require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_60X_REGS)) {
    eval 'sub _H_60X_REGS () {1;}' unless defined(&_H_60X_REGS);
    eval 'sub GS_ATTACH601BUS {
        my($vm_handle, $offset) = @_;
	    eval q( &vm_att(($vm_handle), ($offset)));
    }' unless defined(&GS_ATTACH601BUS);
    eval 'sub GS_DETACH601BUS {
        my($address) = @_;
	    eval q( &vm_det($address));
    }' unless defined(&GS_DETACH601BUS);
    eval 'sub BUS_60X_START_VPD_FEATURE_ROM () {0xffa00000;}' unless defined(&BUS_60X_START_VPD_FEATURE_ROM);
    eval 'sub BUS_60X_END_VPD_FEATURE_ROM () {0xffbfffff;}' unless defined(&BUS_60X_END_VPD_FEATURE_ROM);
    eval 'sub BUS_60X_START_CFG_REGS () {0xff200000;}' unless defined(&BUS_60X_START_CFG_REGS);
    eval 'sub BUS_60X_END_CFG_REGS () {0xff201fff;}' unless defined(&BUS_60X_END_CFG_REGS);
    eval 'sub BUS_60X_DEV_CHAR_REG () {0xff200000;}' unless defined(&BUS_60X_DEV_CHAR_REG);
    eval 'sub BUS_60X_DEV_CHAR_DEV_TYPE_SHIFT () {28;}' unless defined(&BUS_60X_DEV_CHAR_DEV_TYPE_SHIFT);
    eval 'sub BUS_60X_DEV_CHAR_DEV_TYPE_MASK () {(0xf <<  &BUS_60X_DEV_CHAR_DEV_TYPE_SHIFT);}' unless defined(&BUS_60X_DEV_CHAR_DEV_TYPE_MASK);
    eval 'sub BUS_60X_DEV_CHAR_BUID_SHIFT () {26;}' unless defined(&BUS_60X_DEV_CHAR_BUID_SHIFT);
    eval 'sub BUS_60X_DEV_CHAR_BUID_MASK () {(0x3 <<  &BUS_60X_DEV_CHAR_BUID_SHIFT);}' unless defined(&BUS_60X_DEV_CHAR_BUID_MASK);
    eval 'sub BUS_60X_DEV_CHAR_MEM_ALLOC_CNTL_SPACE_SHIFT () {20;}' unless defined(&BUS_60X_DEV_CHAR_MEM_ALLOC_CNTL_SPACE_SHIFT);
    eval 'sub BUS_60X_DEV_CHAR_MEM_ALLOC_CNTL_SPACE_MASK () {(0xf <<  &BUS_60X_DEV_CHAR_MEM_ALLOC_CNTL_SPACE_SHIFT);}' unless defined(&BUS_60X_DEV_CHAR_MEM_ALLOC_CNTL_SPACE_MASK);
    eval 'sub BUS_60X_DEV_CHAR_MEM_ALLOC_DATA_SPACE_SHIFT () {16;}' unless defined(&BUS_60X_DEV_CHAR_MEM_ALLOC_DATA_SPACE_SHIFT);
    eval 'sub BUS_60X_DEV_CHAR_MEM_ALLOC_DATA_SPACE_MASK () {(0xf <<  &BUS_60X_DEV_CHAR_MEM_ALLOC_DATA_SPACE_SHIFT);}' unless defined(&BUS_60X_DEV_CHAR_MEM_ALLOC_DATA_SPACE_MASK);
    eval 'sub BUS_60X_DEV_CHAR_VPD_ROM_SIZE_SHIFT () {5;}' unless defined(&BUS_60X_DEV_CHAR_VPD_ROM_SIZE_SHIFT);
    eval 'sub BUS_60X_DEV_CHAR_VPD_ROM_SIZE_MASK () {(0x3 <<  &BUS_60X_DEV_CHAR_VPD_ROM_SIZE_SHIFT);}' unless defined(&BUS_60X_DEV_CHAR_VPD_ROM_SIZE_MASK);
    eval 'sub BUS_60X_DEV_CHAR_WORD_ADDR_INCREMENT_SHIFT () {2;}' unless defined(&BUS_60X_DEV_CHAR_WORD_ADDR_INCREMENT_SHIFT);
    eval 'sub BUS_60X_DEV_CHAR_WORD_ADDR_INCREMENT_MASK () {(0x7 <<  &BUS_60X_DEV_CHAR_WORD_ADDR_INCREMENT_SHIFT);}' unless defined(&BUS_60X_DEV_CHAR_WORD_ADDR_INCREMENT_MASK);
    eval 'sub BUS_60X_DEV_ID_REG () {0xff200004;}' unless defined(&BUS_60X_DEV_ID_REG);
    eval 'sub BUS_60X_DEV_ID_SHIFT () {0;}' unless defined(&BUS_60X_DEV_ID_SHIFT);
    eval 'sub BUS_60X_DEV_ID_MASK () {(0xffffff <<  &BUS_60X_DEV_ID_SHIFT);}' unless defined(&BUS_60X_DEV_ID_MASK);
    eval 'sub BUS_60X_BUID_REG_1 () {0xff200008;}' unless defined(&BUS_60X_BUID_REG_1);
    eval 'sub BUS_60X_BUID_REG_2 () {0xff20000c;}' unless defined(&BUS_60X_BUID_REG_2);
    eval 'sub BUS_60X_BUID_REG_3 () {0xff200010;}' unless defined(&BUS_60X_BUID_REG_3);
    eval 'sub BUS_60X_BUID_REG_4 () {0xff200014;}' unless defined(&BUS_60X_BUID_REG_4);
    eval 'sub BUS_60X_BUID_ADDR_SHIFT () {16;}' unless defined(&BUS_60X_BUID_ADDR_SHIFT);
    eval 'sub BUS_60X_BUID_ADDR_MASK () {(0x1ff <<  &BUS_60X_BUID_ADDR_SHIFT);}' unless defined(&BUS_60X_BUID_ADDR_MASK);
    eval 'sub BUS_60X_DEV_BASE_REAL_ADDR_REG () {0xff200018;}' unless defined(&BUS_60X_DEV_BASE_REAL_ADDR_REG);
    eval 'sub BUS_60X_DEV_BASE_REAL_ADDR_SHIFT () {28;}' unless defined(&BUS_60X_DEV_BASE_REAL_ADDR_SHIFT);
    eval 'sub BUS_60X_DEV_BASE_REAL_ADDR_MASK () {(0xf <<  &BUS_60X_DEV_BASE_REAL_ADDR_SHIFT);}' unless defined(&BUS_60X_DEV_BASE_REAL_ADDR_MASK);
    eval 'sub BUS_60X_ROM_DEV_ID_REG () {0xffa00000;}' unless defined(&BUS_60X_ROM_DEV_ID_REG);
    eval 'sub BUS_60X_ROM_CHAR_REG () {0xffa00004;}' unless defined(&BUS_60X_ROM_CHAR_REG);
    eval 'sub BUS_60X_ROM_CRC_REG () {0xffa00008;}' unless defined(&BUS_60X_ROM_CRC_REG);
    eval 'sub BUS_60X_VPD_TYPE_REG () {0xffa0000c;}' unless defined(&BUS_60X_VPD_TYPE_REG);
    eval 'sub BUS_60X_VPD_ADDR_REG () {0xffa00010;}' unless defined(&BUS_60X_VPD_ADDR_REG);
    eval 'sub BUS_60X_VPD_LEN_REG () {0xffa00014;}' unless defined(&BUS_60X_VPD_LEN_REG);
    eval 'sub BUS_60X_FEATURE_ROM_TYPE_REG () {0xffa00018;}' unless defined(&BUS_60X_FEATURE_ROM_TYPE_REG);
    eval 'sub BUS_60X_FEATURE_ROM_ADDR_REG () {0xffa0001c;}' unless defined(&BUS_60X_FEATURE_ROM_ADDR_REG);
    eval 'sub BUS_60X_FEATURE_ROM_LEN_REG () {0xffa00020;}' unless defined(&BUS_60X_FEATURE_ROM_LEN_REG);
    eval 'sub BUS_60X_DFA_TABLE_ROM_TYPE_REG () {0xffa00024;}' unless defined(&BUS_60X_DFA_TABLE_ROM_TYPE_REG);
    eval 'sub BUS_60X_DFA_TABLE_ROM_ADDR_REG () {0xffa00028;}' unless defined(&BUS_60X_DFA_TABLE_ROM_ADDR_REG);
    eval 'sub BUS_60X_DFA_TABLE_ROM_LEN_REG () {0xffa0002c;}' unless defined(&BUS_60X_DFA_TABLE_ROM_LEN_REG);
    eval 'sub BUS_60X_BID_PROB_STATE () {0xc0000000;}' unless defined(&BUS_60X_BID_PROB_STATE);
    eval 'sub BUS_60X_BID_SUPER_STATE () {0x80000000;}' unless defined(&BUS_60X_BID_SUPER_STATE);
    eval 'sub BUS_60X_BID_SDSS_ACCESS () {0x7f00000;}' unless defined(&BUS_60X_BID_SDSS_ACCESS);
    eval 'sub BUS_60X_SEG_EXT_BITS_FOR_CFG_SPACE () {0xf;}' unless defined(&BUS_60X_SEG_EXT_BITS_FOR_CFG_SPACE);
    eval 'sub BUS_60X_SLOT_SELECT_CONFIG_REG () {0xf00000c;}' unless defined(&BUS_60X_SLOT_SELECT_CONFIG_REG);
    eval 'sub BUS_60X_SLOT_RESET_REG () {0xf000010;}' unless defined(&BUS_60X_SLOT_RESET_REG);
    eval 'sub BUS_60X_GRAPHICS_SLOT_RESET_INACTIVE () {0x8000000;}' unless defined(&BUS_60X_GRAPHICS_SLOT_RESET_INACTIVE);
    eval 'sub BUS_60X_GRAPHICS_SLOT_CONFIG_ENABLE () {0x80000004;}' unless defined(&BUS_60X_GRAPHICS_SLOT_CONFIG_ENABLE);
    eval 'sub BUS_60X_GRAPHICS_SLOT_CONFIG_DISABLE () {0x;}' unless defined(&BUS_60X_GRAPHICS_SLOT_CONFIG_DISABLE);
    eval 'sub BUS_60X_NO_DEVICE_PRESENT () {0xf0000000;}' unless defined(&BUS_60X_NO_DEVICE_PRESENT);
    eval 'sub BUS_60X_32BIT_SET_T_BIT () {0x80000000;}' unless defined(&BUS_60X_32BIT_SET_T_BIT);
    eval 'sub BUS_60X_MOD250_BUID () {0x7f00000;}' unless defined(&BUS_60X_MOD250_BUID);
    eval 'sub ADDR_IS_60x_CFG_SPACE {
        my( $segment , $address ) = @_;
	    eval q(( ((($segment) &  &BUS_60X_32BIT_SET_T_BIT ) ==  &BUS_60X_32BIT_SET_T_BIT )  && ((($segment) &  &BUS_60X_MOD250_BUID ) ==  &BUS_60X_MOD250_BUID )  && ( ( ($address) >=  &BUS_60X_START_CFG_REGS )  && ( ($address) <=  &BUS_60X_END_CFG_REGS ) ) ));
    }' unless defined(&ADDR_IS_60x_CFG_SPACE);
    eval 'sub ADDR_IS_60x_VPD_FRS_SPACE {
        my( $segment , $address ) = @_;
	    eval q(( ((($segment) &  &BUS_60X_32BIT_SET_T_BIT ) ==  &BUS_60X_32BIT_SET_T_BIT )  && ((($segment) &  &BUS_60X_MOD250_BUID ) ==  &BUS_60X_MOD250_BUID )  && ( ( ($address) >=  &BUS_60X_START_VPD_FEATURE_ROM )  && ( ($address) <=  &BUS_60X_END_VPD_FEATURE_ROM ) ) ));
    }' unless defined(&ADDR_IS_60x_VPD_FRS_SPACE);
}
1;
