require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_FSIO)) {
    eval 'sub _H_FSIO () {1;}' unless defined(&_H_FSIO);
    unless(defined(&NADDR)) {
	require 'sys/inode.ph';
    }
    eval 'sub mi_rmaj () { ($mi_ovly->{mi_odev[0]});}' unless defined(&mi_rmaj);
    eval 'sub mi_rmin () { ($mi_ovly->{mi_odev[1]});}' unless defined(&mi_rmin);
    eval 'sub mi_dadd () { ($mi_ovly->{mi_oadd});}' unless defined(&mi_dadd);
    eval 'sub FS_FMAX () {8;}' unless defined(&FS_FMAX);
    unless(defined(&ITIMES)) {
	eval 'sub ITIMES () { &IMOUNT;}' unless defined(&ITIMES);
    }
    unless(defined(&IRONLY)) {
	eval 'sub IRONLY () { &ITEXT;}' unless defined(&IRONLY);
    }
    eval 'sub FSM_sblk () { ($FSM_u->{FSMustr});}' unless defined(&FSM_sblk);
    eval 'sub FM_FDIRTY () {1;}' unless defined(&FM_FDIRTY);
    eval 'sub FM_FRONLY () {2;}' unless defined(&FM_FRONLY);
    eval 'sub FB_FDIRTY () {1;}' unless defined(&FB_FDIRTY);
    eval 'sub FS_BMAX () {4;}' unless defined(&FS_BMAX);
    eval 'sub _FSbput {
        my($bhp) = @_;
	    eval q((($bhp)-> &FSB_flag |=  &FB_FDIRTY));
    }' unless defined(&_FSbput);
    eval 'sub FSC_NOFR () {1;}' unless defined(&FSC_NOFR);
    eval 'sub FSC_TRNC () {2;}' unless defined(&FSC_TRNC);
    eval 'sub FSC_DELT () {4;}' unless defined(&FSC_DELT);
    eval 'sub FS_CSAVE () {0;}' unless defined(&FS_CSAVE);
    eval 'sub FS_CNOFR () { &FSC_NOFR;}' unless defined(&FS_CNOFR);
    eval 'sub FS_CTRNC () { &FSC_TRNC;}' unless defined(&FS_CTRNC);
    eval 'sub FS_CDELT () { &FSC_TRNC+ &FSC_DELT;}' unless defined(&FS_CDELT);
    eval 'sub FS_BREAD () {0;}' unless defined(&FS_BREAD);
    eval 'sub FS_BWRIT () {1;}' unless defined(&FS_BWRIT);
    eval 'sub FS_SUPDT () {1;}' unless defined(&FS_SUPDT);
    eval 'sub FS_SREFR () {2;}' unless defined(&FS_SREFR);
    eval 'sub IORG () {(( &daddr_t)2);}' unless defined(&IORG);
    if(defined(&_s_NEWF)) {
	eval 'sub SBtype {
	    my($sbp) = @_;
    	    eval q(($sbp)-> &s_type);
	}' unless defined(&SBtype);
	eval 'sub SBbsize {
	    my($sbp) = @_;
    	    eval q(($sbp)-> &s_bsize);
	}' unless defined(&SBbsize);
	eval 'sub SBcpu {
	    my($sbp) = @_;
    	    eval q(($sbp)-> &s_cpu);
	}' unless defined(&SBcpu);
	eval 'sub SBibase {
	    my($sbp) = @_;
    	    eval q(($sbp)-> &s_ibase);
	}' unless defined(&SBibase);
	eval 'sub NICfree {
	    my($sbp) = @_;
    	    eval q(($sbp)-> &s_nicfree);
	}' unless defined(&NICfree);
	eval 'sub NICinod {
	    my($sbp) = @_;
    	    eval q(($sbp)-> &s_nicino);
	}' unless defined(&NICinod);
    } else {
	if((defined(&BSIZE) ? &BSIZE : 0) == 512) {
	    eval 'sub SBtype {
	        my($sbp) = @_;
    		eval q( &Fs1b);
	    }' unless defined(&SBtype);
	}
	if((defined(&BSIZE) ? &BSIZE : 0) == 1024) {
	    eval 'sub SBtype {
	        my($sbp) = @_;
    		eval q( &Fs2b);
	    }' unless defined(&SBtype);
	}
	if((defined(&BSIZE) ? &BSIZE : 0) == 2048) {
	    eval 'sub SBtype {
	        my($sbp) = @_;
    		eval q( &Fs4b);
	    }' unless defined(&SBtype);
	}
	if((defined(&BSIZE) ? &BSIZE : 0) == 4096) {
	    eval 'sub SBtype {
	        my($sbp) = @_;
    		eval q( &Fs8b);
	    }' unless defined(&SBtype);
	}
	eval 'sub SBbsize {
	    my($sbp) = @_;
    	    eval q( &BSIZE);
	}' unless defined(&SBbsize);
	eval 'sub SBcpu {
	    my($sbp) = @_;
    	    eval q(0);
	}' unless defined(&SBcpu);
	eval 'sub SBibase {
	    my($sbp) = @_;
    	    eval q((( &daddr_t)0));
	}' unless defined(&SBibase);
	eval 'sub NICfree {
	    my($sbp) = @_;
    	    eval q( &NICFREE);
	}' unless defined(&NICfree);
	eval 'sub NICinod {
	    my($sbp) = @_;
    	    eval q( &NICINOD);
	}' unless defined(&NICinod);
	eval 'sub FREEblk {
	    my($sbp,$n) = @_;
    	    eval q(($sbp)-> $s_free[$n]);
	}' unless defined(&FREEblk);
	eval 'sub FREEino {
	    my($sbp,$n) = @_;
    	    eval q(($sbp)-> $s_inode[$n]);
	}' unless defined(&FREEino);
	eval 'sub s_cyl () { &s_n;}' unless defined(&s_cyl);
	eval 'sub s_skip () { &s_m;}' unless defined(&s_skip);
    }
    unless(defined(&_s_ALGN)) {
	eval 'sub FSbio {
	    my($mtp,$op,$buf,$blk) = @_;
    	    eval q((*(($mtp)-> &FSM_biop))($mtp,$op,$buf,$blk));
	}' unless defined(&FSbio);
    }
    if(defined(&_s_XCPU)) {
	eval 'sub swapS {
	    my($x,$sbp) = @_;
    	    eval q( &_XXshort($x,($sbp)-> &s_cpu));
	}' unless defined(&swapS);
	eval 'sub swapL {
	    my($x,$sbp) = @_;
    	    eval q( &_XXlong($x,($sbp)-> &s_cpu));
	}' unless defined(&swapL);
    } else {
	eval 'sub FSxdblk {
	    my($buf,$sbp,$flag) = @_;
    	    eval q();
	}' unless defined(&FSxdblk);
	eval 'sub FSxfblk {
	    my($buf,$sbp,$flag) = @_;
    	    eval q();
	}' unless defined(&FSxfblk);
	eval 'sub FSxiblk {
	    my($buf,$sbp,$flag) = @_;
    	    eval q();
	}' unless defined(&FSxiblk);
	eval 'sub FSxnode {
	    my($buf,$sbp,$flag) = @_;
    	    eval q();
	}' unless defined(&FSxnode);
	eval 'sub FSxgblk {
	    my($buf,$sbp,$flag) = @_;
    	    eval q();
	}' unless defined(&FSxgblk);
	eval 'sub FSl3tol {
	    my($lp,$cp,$n,$cpu) = @_;
    	    eval q( &l3tol($lp,$cp,$n));
	}' unless defined(&FSl3tol);
	eval 'sub FSltol3 {
	    my($cp,$lp,$n,$cpu) = @_;
    	    eval q( &ltol3($cp,$lp,$n));
	}' unless defined(&FSltol3);
	eval 'sub swapS {
	    my($x,$sbp) = @_;
    	    eval q((($x)));
	}' unless defined(&swapS);
	eval 'sub swapL {
	    my($x,$sbp) = @_;
    	    eval q((($x)));
	}' unless defined(&swapL);
    }
    if(defined(&_s_FRAG)) {
	eval 'sub FS_NPCTS () {3;}' unless defined(&FS_NPCTS);
    } else {
	eval 'sub FS_NPCTS () {2;}' unless defined(&FS_NPCTS);
    }
}
1;
