require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_PCDEFS)) {
    eval 'sub _H_PCDEFS () {1;}' unless defined(&_H_PCDEFS);
    eval 'sub PCchar {
        my($X) = @_;
	    eval q(($X));
    }' unless defined(&PCchar);
    eval 'sub PCshort {
        my($X) = @_;
	    eval q(((($X>>8)&0xff)|(($X<<8)&0xff00)));
    }' unless defined(&PCshort);
    eval 'sub PCushort {
        my($X) = @_;
	    eval q( &PCshort($X));
    }' unless defined(&PCushort);
    eval 'sub PCino {
        my($X) = @_;
	    eval q( &PCushort($X));
    }' unless defined(&PCino);
    eval 'sub PCdaddrin {
        my($X) = @_;
	    eval q( &PClongin($X));
    }' unless defined(&PCdaddrin);
    eval 'sub PCdaddrout {
        my($X) = @_;
	    eval q( &PClongout($X));
    }' unless defined(&PCdaddrout);
    eval 'sub PCtimein {
        my($X) = @_;
	    eval q( &PClongin($X));
    }' unless defined(&PCtimein);
    eval 'sub PCtimeout {
        my($X) = @_;
	    eval q( &PClongout($X));
    }' unless defined(&PCtimeout);
    eval 'sub PCoffin {
        my($X) = @_;
	    eval q( &PClongin($X));
    }' unless defined(&PCoffin);
    eval 'sub PCoffout {
        my($X) = @_;
	    eval q( &PClongout($X));
    }' unless defined(&PCoffout);
    eval 'sub PCNICFREE () {50;}' unless defined(&PCNICFREE);
    eval 'sub PCNICINOD () {100;}' unless defined(&PCNICINOD);
    eval 'sub PCBSIZE () {512;}' unless defined(&PCBSIZE);
    eval 'sub PCISIZE () {64;}' unless defined(&PCISIZE);
    eval 'sub PCBSHIFT () {9;}' unless defined(&PCBSHIFT);
    eval 'sub PCBNSHIFT () {7;}' unless defined(&PCBNSHIFT);
    eval 'sub PCINOPB () {8;}' unless defined(&PCINOPB);
    eval 'sub PCINOSHIFT () {3;}' unless defined(&PCINOSHIFT);
    eval 'sub PCitod {
        my($x) = @_;
	    eval q(( &daddr_t)((($x)+(2* &PCINOPB-1))>> &PCINOSHIFT));
    }' unless defined(&PCitod);
    eval 'sub PCitoo {
        my($x) = @_;
	    eval q(((($x)+(2* &PCINOPB-1))( &PCINOPB-1)));
    }' unless defined(&PCitoo);
    eval 'sub pc_m () { $pc_dinfo[0];}' unless defined(&pc_m);
    eval 'sub pc_n () { $pc_dinfo[1];}' unless defined(&pc_n);
    eval 'sub pc_bsize () { $pc_dinfo[2];}' unless defined(&pc_bsize);
    eval 'sub PCFsMAGIC () {0xfd187e20;}' unless defined(&PCFsMAGIC);
}
1;
