require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_NLCTYPE)) {
    eval 'sub _H_NLCTYPE () {1;}' unless defined(&_H_NLCTYPE);
    require 'NLchar.ph';
    require 'ctype.ph';
    require 'jctype.ph';
    eval 'sub _U () {01;}' unless defined(&_U);
    eval 'sub _L () {02;}' unless defined(&_L);
    eval 'sub _N () {04;}' unless defined(&_N);
    eval 'sub _S () {010;}' unless defined(&_S);
    eval 'sub _P () {020;}' unless defined(&_P);
    eval 'sub _C () {040;}' unless defined(&_C);
    eval 'sub _B () {0100;}' unless defined(&_B);
    eval 'sub _X () {0200;}' unless defined(&_X);
    eval 'sub _A () {0400;}' unless defined(&_A);
    eval 'sub _G () {01000;}' unless defined(&_G);
    eval 'sub _NCtoupper {
        my($a) = @_;
	    eval q((( &__OBJ_DATA( &__lc_charmap)-> &cm_mb_cur_min  &&  &__OBJ_DATA( &__lc_charmap)-> &cm_mb_cur_max) ?  &__OBJ_DATA( &__lc_ctype)-> $upper[$a] : $a));
    }' unless defined(&_NCtoupper);
    eval 'sub _NCtolower {
        my($a) = @_;
	    eval q((( &__OBJ_DATA( &__lc_charmap)-> &cm_mb_cur_min  &&  &__OBJ_DATA( &__lc_charmap)-> &cm_mb_cur_max) ?  &__OBJ_DATA( &__lc_ctype)-> $lower[$a] : $a));
    }' unless defined(&_NCtolower);
    eval 'sub _atojis {
        my($c) = @_;
	    eval q(( $_atojistab[($c) - 0x20]));
    }' unless defined(&_atojis);
    eval 'sub _jistoa {
        my($c) = @_;
	    eval q(( $_jistoatab[(($c)>>8) - 0x81][(($c)&0xff) - 0x40]));
    }' unless defined(&_jistoa);
    eval 'sub NCflatchr {
        my($c) = @_;
	    eval q((( < 0x80) ? : (($c) - 0x80 <  &_NLflattsize) ?  $_NLflattab[$c - 0x80] : ord(\'?\')));
    }' unless defined(&NCflatchr);
    eval 'sub NLESCMAX () {7;}' unless defined(&NLESCMAX);
    eval 'sub MINESCVAL () {0xa1;}' unless defined(&MINESCVAL);
    eval 'sub MAXESCVAL () {0xdf;}' unless defined(&MAXESCVAL);
    eval 'sub hextoa {
        my($c) = @_;
	    eval q(((($c) < 10) ? (ord(\'0\' + (c)) : (\'a\') + (($c) - 10))));
    }' unless defined(&hextoa);
    eval 'sub atohex {
        my($c) = @_;
	    eval q(((($c) <= ord(\'9\') ? ((c) - \'0\') : (((c) - \'a\')) + 10)));
    }' unless defined(&atohex);
    eval 'sub NCeschex {
        my($nlc, $c) = @_;
	    eval q((($c)[0] = ord(\'\\\\\\\\\', 			    (c)[1] = \'<\',			     (c)[2] = hextoa ((*(nlc) >> 12) & 0xf),			     (c)[3] = hextoa ((*(nlc) >> 8) & 0xf),			     (c)[4] = hextoa ((*(nlc) >> 4) & 0xf),			     (c)[5] = hextoa (*(nlc) & 0xf), 			    (c)[6] = \'>\')));
    }' unless defined(&NCeschex);
    eval 'sub NCuneschex {
        my($c, $nlc) = @_;
	    eval q((($nlc)[0] = ((( &atohex(($c)[2])) & 0xf) << 12) | ((( &atohex(($c)[3])) & 0xf) << 8) | ((( &atohex(($c)[4])) & 0xf) << 4) | (( &atohex(($c)[5])) & 0xf)));
    }' unless defined(&NCuneschex);
    eval 'sub ishexesc {
        my($c) = @_;
	    eval q(((((($c)[0] >= ord(\'a\' && (c)[0] <= \'f\') || 					((c)[0] >= \'0\' && (c)[0] <= \'9\')) && 				(((c)[1] >= \'a\' && (c)[1] <= \'f\') || 					((c)[1] >= \'0\' && (c)[1] <= \'9\')) && 				(((c)[2] >= \'a\' && (c)[2] <= \'f\') || 					((c)[2] >= \'0\' && (c)[2] <= \'9\')) && 				(((c)[3] >= \'a\' && (c)[3] <= \'f\') || 					((c)[3] >= \'0\' && (c)[3] <= \'9\')))) ? 1: -1));
    }' unless defined(&ishexesc);
}
1;
