require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_AIXPROTO_H)) {
    eval 'sub _AIXPROTO_H () {1;}' unless defined(&_AIXPROTO_H);
    require 'Xmd.ph';
    eval 'sub sz_xQueryCrossHairReq () {4;}' unless defined(&sz_xQueryCrossHairReq);
    eval 'sub sz_xQueryCrossHairReply () {32;}' unless defined(&sz_xQueryCrossHairReply);
    eval 'sub sz_xCreateCrossHairReq () {24;}' unless defined(&sz_xCreateCrossHairReq);
    eval 'sub sz_xCreateMultiColorCurReq () {20;}' unless defined(&sz_xCreateMultiColorCurReq);
    eval 'sub sz_xRecolorMultiColorCurReq () {8;}' unless defined(&sz_xRecolorMultiColorCurReq);
    eval 'sub sz_xCursorQueryVersionReq () {8;}' unless defined(&sz_xCursorQueryVersionReq);
    eval 'sub sz_xCursorQueryVersionReply () {32;}' unless defined(&sz_xCursorQueryVersionReply);
    eval 'sub sz_xGetCrossHairCursorInfoReq () {8;}' unless defined(&sz_xGetCrossHairCursorInfoReq);
    eval 'sub sz_xGetCrossHairCursorInfoReply () {32;}' unless defined(&sz_xGetCrossHairCursorInfoReply);
    eval 'sub sz_xRecolorCrossHairCursorReq () {20;}' unless defined(&sz_xRecolorCrossHairCursorReq);
    eval 'sub sz_xGetMultiColorCursorInfoReq () {8;}' unless defined(&sz_xGetMultiColorCursorInfoReq);
    eval 'sub sz_xGetMultiColorCursorInfoReply () {32;}' unless defined(&sz_xGetMultiColorCursorInfoReply);
    eval 'sub sz_xExtBlinkReq () {24;}' unless defined(&sz_xExtBlinkReq);
    eval 'sub sz_xGenExtReq () {4;}' unless defined(&sz_xGenExtReq);
    eval 'sub sz_xGetDPYInfoReq () { &sz_xGenExtReq;}' unless defined(&sz_xGetDPYInfoReq);
    eval 'sub sz_xExtChangeModeReq () {8;}' unless defined(&sz_xExtChangeModeReq);
    eval 'sub sz_xExtQueryModeReq () {8;}' unless defined(&sz_xExtQueryModeReq);
    eval 'sub sz_xManageOverlayReq () {12;}' unless defined(&sz_xManageOverlayReq);
    eval 'sub sz_xQueryMemoryUsageReq () {8;}' unless defined(&sz_xQueryMemoryUsageReq);
    eval 'sub sz_xDirectAdapterAccessReq () {16;}' unless defined(&sz_xDirectAdapterAccessReq);
    eval 'sub sz_xDirectWindowAccessReq () {12;}' unless defined(&sz_xDirectWindowAccessReq);
    eval 'sub sz_xDirectFontAccessReq () {12;}' unless defined(&sz_xDirectFontAccessReq);
    if(defined(&GL_X_PERF)) {
	eval 'sub sz_xDirectInputAccessReq () {8;}' unless defined(&sz_xDirectInputAccessReq);
    }
    eval 'sub sz_xFastResUpdateReq () {12;}' unless defined(&sz_xFastResUpdateReq);
    eval 'sub sz_xFastResUpdateReply () {32;}' unless defined(&sz_xFastResUpdateReply);
    eval 'sub sz_xHardwareSyncReq () {16;}' unless defined(&sz_xHardwareSyncReq);
    eval 'sub sz_xDirectAccessQueryVersionReq () {8;}' unless defined(&sz_xDirectAccessQueryVersionReq);
    eval 'sub sz_xDirectAccessQueryVersionReply () {32;}' unless defined(&sz_xDirectAccessQueryVersionReply);
    eval 'sub sz_xDAEQueryCapabilitiesReq () {8;}' unless defined(&sz_xDAEQueryCapabilitiesReq);
    eval 'sub sz_xDAEQueryCapabilitiesRep () {32;}' unless defined(&sz_xDAEQueryCapabilitiesRep);
    eval 'sub sz_xDAEWriteToBothBuffersReq () {12;}' unless defined(&sz_xDAEWriteToBothBuffersReq);
    eval 'sub sz_xDrawPolyMarkerReq () {16;}' unless defined(&sz_xDrawPolyMarkerReq);
    eval 'sub sz_xSetPolyMarkerReq () {16;}' unless defined(&sz_xSetPolyMarkerReq);
    eval 'sub sz_xDrawPolyMarkersReq () {16;}' unless defined(&sz_xDrawPolyMarkersReq);
    eval 'sub sz_xFullScreenReq () {12;}' unless defined(&sz_xFullScreenReq);
    eval 'sub sz_xNewXFontReq () {20;}' unless defined(&sz_xNewXFontReq);
    eval 'sub Window () { &CARD32;}' unless defined(&Window);
    eval 'sub Drawable () { &CARD32;}' unless defined(&Drawable);
    eval 'sub Font () { &CARD32;}' unless defined(&Font);
    eval 'sub Pixmap () { &CARD32;}' unless defined(&Pixmap);
    eval 'sub Cursor () { &CARD32;}' unless defined(&Cursor);
    eval 'sub Colormap () { &CARD32;}' unless defined(&Colormap);
    eval 'sub GContext () { &CARD32;}' unless defined(&GContext);
    if(defined(&GL_X_PERF)) {
    }
    eval 'sub sz_xDirectBufferAccessReq () {12;}' unless defined(&sz_xDirectBufferAccessReq);
    eval 'sub sz_xDirectBufferAccessReply () {72;}' unless defined(&sz_xDirectBufferAccessReply);
    eval 'sub sz_xDAEChangeDisplayResolutionReq () {16;}' unless defined(&sz_xDAEChangeDisplayResolutionReq);
    undef(&Window) if defined(&Window);
    undef(&Drawable) if defined(&Drawable);
    undef(&Font) if defined(&Font);
    undef(&Pixmap) if defined(&Pixmap);
    undef(&Cursor) if defined(&Cursor);
    undef(&Colormap) if defined(&Colormap);
    undef(&GContext) if defined(&GContext);
}
1;
