require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XtIntrinsic_h)) {
    eval 'sub _XtIntrinsic_h () {1;}' unless defined(&_XtIntrinsic_h);
    require 'X11/Xlib.ph';
    require 'X11/Xutil.ph';
    require 'X11/Xresource.ph';
    require 'X11/Xfuncproto.ph';
    if(defined(&XT_BC)) {
	require 'X11/Xos.ph';
    } else {
	require 'X11/Xosdefs.ph';
	unless(defined(&X_NOT_STDC_ENV)) {
	    require 'string.ph';
	} else {
	    if(defined(&SYSV)) {
		require 'string.ph';
	    } else {
		require 'strings.ph';
	    }
	}
    }
    eval 'sub XtSpecificationRelease () {6;}' unless defined(&XtSpecificationRelease);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	eval 'sub _XtString () {\'char\'*;}' unless defined(&_XtString);
	if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    eval 'sub _XtBoolean () {\'int\';}' unless defined(&_XtBoolean);
	    eval 'sub _XtDimension () {\'unsigned int\';}' unless defined(&_XtDimension);
	    eval 'sub _XtKeyCode () {\'unsigned int\';}' unless defined(&_XtKeyCode);
	    eval 'sub _XtPosition () {\'int\';}' unless defined(&_XtPosition);
	    eval 'sub _XtXtEnum () {\'unsigned int\';}' unless defined(&_XtXtEnum);
	} else {
	    eval 'sub _XtBoolean () { &Boolean;}' unless defined(&_XtBoolean);
	    eval 'sub _XtDimension () { &Dimension;}' unless defined(&_XtDimension);
	    eval 'sub _XtKeyCode () { &KeyCode;}' unless defined(&_XtKeyCode);
	    eval 'sub _XtPosition () { &Position;}' unless defined(&_XtPosition);
	    eval 'sub _XtXtEnum () { &XtEnum;}' unless defined(&_XtXtEnum);
	}
    }
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    if(defined(&VMS)) {
	eval 'sub externalref () { &globalref;}' unless defined(&externalref);
	eval 'sub externaldef {
	    my($psect) = @_;
    	    eval q( &globaldef {\\"psect\\"}  &noshare);
	}' unless defined(&externaldef);
    } else {
	eval 'sub externalref () { &extern;}' unless defined(&externalref);
	eval 'sub externaldef {
	    my($psect) = @_;
    	    eval q();
	}' unless defined(&externaldef);
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
    }
    eval 'sub XtNumber {
        my($arr) = @_;
	    eval q((( &Cardinal) ($sizeof{$arr} / $sizeof{$arr->[0]})));
    }' unless defined(&XtNumber);
    eval 'sub XtCacheNone () {0x1;}' unless defined(&XtCacheNone);
    eval 'sub XtCacheAll () {0x2;}' unless defined(&XtCacheAll);
    eval 'sub XtCacheByDisplay () {0x3;}' unless defined(&XtCacheByDisplay);
    eval 'sub XtCacheRefCount () {0x100;}' unless defined(&XtCacheRefCount);
    if(defined(&CRAY)) {
    } else {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    } else {
    }
    require 'X11/Core.ph';
    require 'X11/Composite.ph';
    require 'X11/Constraint.ph';
    require 'X11/Object.ph';
    require 'X11/RectObj.ph';
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval("sub XtAddress () { 0; }") unless defined(&XtAddress);
    eval("sub XtBaseOffset () { 1; }") unless defined(&XtBaseOffset);
    eval("sub XtImmediate () { 2; }") unless defined(&XtImmediate);
    eval("sub XtResourceString () { 3; }") unless defined(&XtResourceString);
    eval("sub XtResourceQuark () { 4; }") unless defined(&XtResourceQuark);
    eval("sub XtWidgetBaseOffset () { 5; }") unless defined(&XtWidgetBaseOffset);
    eval("sub XtProcedureArg () { 6; }") unless defined(&XtProcedureArg);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtCWQueryOnly () {(1<< 7);}' unless defined(&XtCWQueryOnly);
    eval 'sub XtSMDontChange () {5;}' unless defined(&XtSMDontChange);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval("sub XtListHead () { 0; }") unless defined(&XtListHead);
    eval("sub XtListTail () { 1; }") unless defined(&XtListTail);
    eval 'sub XtInputNoneMask () {0;}' unless defined(&XtInputNoneMask);
    eval 'sub XtInputReadMask () {(1<<0);}' unless defined(&XtInputReadMask);
    eval 'sub XtInputWriteMask () {(1<<1);}' unless defined(&XtInputWriteMask);
    eval 'sub XtInputExceptMask () {(1<<2);}' unless defined(&XtInputExceptMask);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval("sub XtCallbackNoList () { 0; }") unless defined(&XtCallbackNoList);
    eval("sub XtCallbackHasNone () { 1; }") unless defined(&XtCallbackHasNone);
    eval("sub XtCallbackHasSome () { 2; }") unless defined(&XtCallbackHasSome);
    eval("sub XtGeometryYes () { 0; }") unless defined(&XtGeometryYes);
    eval("sub XtGeometryNo () { 1; }") unless defined(&XtGeometryNo);
    eval("sub XtGeometryAlmost () { 2; }") unless defined(&XtGeometryAlmost);
    eval("sub XtGeometryDone () { 3; }") unless defined(&XtGeometryDone);
    eval("sub XtGrabNone () { 0; }") unless defined(&XtGrabNone);
    eval("sub XtGrabNonexclusive () { 1; }") unless defined(&XtGrabNonexclusive);
    eval("sub XtGrabExclusive () { 2; }") unless defined(&XtGrabExclusive);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if(defined(&__STDC__)) {
    } else {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtAllEvents () {(( &EventMask) -1);}' unless defined(&XtAllEvents);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtIMXEvent () {1;}' unless defined(&XtIMXEvent);
    eval 'sub XtIMTimer () {2;}' unless defined(&XtIMTimer);
    eval 'sub XtIMAlternateInput () {4;}' unless defined(&XtIMAlternateInput);
    eval 'sub XtIMSignal () {8;}' unless defined(&XtIMSignal);
    eval 'sub XtIMAll () {( &XtIMXEvent |  &XtIMTimer |  &XtIMAlternateInput |  &XtIMSignal);}' unless defined(&XtIMAll);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtIsRectObj {
        my($object) = @_;
	    eval q(( &_XtCheckSubclassFlag($object, ( &XtEnum)0x2)));
    }' unless defined(&XtIsRectObj);
    eval 'sub XtIsWidget {
        my($object) = @_;
	    eval q(( &_XtCheckSubclassFlag($object, ( &XtEnum)0x4)));
    }' unless defined(&XtIsWidget);
    eval 'sub XtIsComposite {
        my($widget) = @_;
	    eval q(( &_XtCheckSubclassFlag($widget, ( &XtEnum)0x8)));
    }' unless defined(&XtIsComposite);
    eval 'sub XtIsConstraint {
        my($widget) = @_;
	    eval q(( &_XtCheckSubclassFlag($widget, ( &XtEnum)0x10)));
    }' unless defined(&XtIsConstraint);
    eval 'sub XtIsShell {
        my($widget) = @_;
	    eval q(( &_XtCheckSubclassFlag($widget, ( &XtEnum)0x20)));
    }' unless defined(&XtIsShell);
    eval 'sub XtIsOverrideShell {
        my($widget) = @_;
	    eval q(( &_XtIsSubclassOf($widget, ( &WidgetClass) &overrideShellWidgetClass, ( &WidgetClass) &shellWidgetClass, ( &XtEnum)0x20)));
    }' unless defined(&XtIsOverrideShell);
    eval 'sub XtIsWMShell {
        my($widget) = @_;
	    eval q(( &_XtCheckSubclassFlag($widget, ( &XtEnum)0x40)));
    }' unless defined(&XtIsWMShell);
    eval 'sub XtIsVendorShell {
        my($widget) = @_;
	    eval q(( &_XtIsSubclassOf($widget, ( &WidgetClass) &vendorShellWidgetClass, ( &WidgetClass) &wmShellWidgetClass, ( &XtEnum)0x40)));
    }' unless defined(&XtIsVendorShell);
    eval 'sub XtIsTransientShell {
        my($widget) = @_;
	    eval q(( &_XtIsSubclassOf($widget, ( &WidgetClass) &transientShellWidgetClass, ( &WidgetClass) &wmShellWidgetClass, ( &XtEnum)0x40)));
    }' unless defined(&XtIsTransientShell);
    eval 'sub XtIsTopLevelShell {
        my($widget) = @_;
	    eval q(( &_XtCheckSubclassFlag($widget, ( &XtEnum)0x80)));
    }' unless defined(&XtIsTopLevelShell);
    eval 'sub XtIsApplicationShell {
        my($widget) = @_;
	    eval q(( &_XtIsSubclassOf($widget, ( &WidgetClass) &applicationShellWidgetClass, ( &WidgetClass) &topLevelShellWidgetClass, ( &XtEnum)0x80)));
    }' unless defined(&XtIsApplicationShell);
    eval 'sub XtIsSessionShell {
        my($widget) = @_;
	    eval q(( &_XtIsSubclassOf($widget, ( &WidgetClass) &sessionShellWidgetClass, ( &WidgetClass) &topLevelShellWidgetClass, ( &XtEnum)0x80)));
    }' unless defined(&XtIsSessionShell);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtSetArg {
        my($arg, $n, $d) = @_;
	    eval q((( &void)( ($arg). &name = ($n), ($arg). &value = ( &XtArgVal)($d) )));
    }' unless defined(&XtSetArg);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtVaNestedList () {"XtVaNestedList";}' unless defined(&XtVaNestedList);
    eval 'sub XtVaTypedArg () {"XtVaTypedArg";}' unless defined(&XtVaTypedArg);
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    unless(defined(&_XtIntrinsicP_h)) {
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
    }
    eval 'sub XtMapWidget {
        my($widget) = @_;
	    eval q( &XMapWindow( &XtDisplay($widget),  &XtWindow($widget)));
    }' unless defined(&XtMapWidget);
    eval 'sub XtUnmapWidget {
        my($widget) = @_;
	    eval q( &XUnmapWindow( &XtDisplay($widget),  &XtWindow($widget)));
    }' unless defined(&XtUnmapWidget);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedVarargsPrototypes) ? &NeedVarargsPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtUnspecifiedPixmap () {(( &Pixmap)2);}' unless defined(&XtUnspecifiedPixmap);
    eval 'sub XtUnspecifiedShellInt () {(-1);}' unless defined(&XtUnspecifiedShellInt);
    eval 'sub XtUnspecifiedWindow () {(( &Window)2);}' unless defined(&XtUnspecifiedWindow);
    eval 'sub XtUnspecifiedWindowGroup () {(( &Window)3);}' unless defined(&XtUnspecifiedWindowGroup);
    eval 'sub XtCurrentDirectory () {"XtCurrentDirectory";}' unless defined(&XtCurrentDirectory);
    eval 'sub XtDefaultForeground () {"XtDefaultForeground";}' unless defined(&XtDefaultForeground);
    eval 'sub XtDefaultBackground () {"XtDefaultBackground";}' unless defined(&XtDefaultBackground);
    eval 'sub XtDefaultFont () {"XtDefaultFont";}' unless defined(&XtDefaultFont);
    eval 'sub XtDefaultFontSet () {"XtDefaultFontSet";}' unless defined(&XtDefaultFontSet);
    if(defined( &CRAY) || defined( &__arm)) {
	if((defined(&__STDC__) ? &__STDC__ : 0)) {
	    eval 'sub XtOffset {
	        my($p_type,$field) = @_;
    		eval q( &_Offsetof($p_type,$field));
	    }' unless defined(&XtOffset);
	} else {
	    if(defined(&CRAY2)) {
		eval 'sub XtOffset {
		    my($p_type,$field) = @_;
    		    eval q(($sizeof{\'int\'}*(((($p_type) &NULL)->$field))));
		}' unless defined(&XtOffset);
	    } else {
		eval 'sub XtOffset {
		    my($p_type,$field) = @_;
    		    eval q((((($p_type) &NULL)->$field)));
		}' unless defined(&XtOffset);
	    }
	}
    } else {
	eval 'sub XtOffset {
	    my($p_type,$field) = @_;
    	    eval q((( &Cardinal) (( (((($p_type) &NULL)->$field))) - (  &NULL))));
	}' unless defined(&XtOffset);
    }
    if(defined(&offsetof)) {
	eval 'sub XtOffsetOf {
	    my($s_type,$field) = @_;
    	    eval q( &offsetof($s_type,$field));
	}' unless defined(&XtOffsetOf);
    } else {
	eval 'sub XtOffsetOf {
	    my($s_type,$field) = @_;
    	    eval q( &XtOffset($s_type*,$field));
	}' unless defined(&XtOffsetOf);
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if(defined(&XTTRACEMEMORY)) {
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	eval 'sub XtMalloc {
	    my($size) = @_;
    	    eval q( &_XtMalloc($size,  &__FILE__,  &__LINE__));
	}' unless defined(&XtMalloc);
	eval 'sub XtRealloc {
	    my($ptr,$size) = @_;
    	    eval q( &_XtRealloc($ptr, $size,  &__FILE__,  &__LINE__));
	}' unless defined(&XtRealloc);
	eval 'sub XtCalloc {
	    my($num,$size) = @_;
    	    eval q( &_XtCalloc($num, $size,  &__FILE__,  &__LINE__));
	}' unless defined(&XtCalloc);
	eval 'sub XtFree {
	    my($ptr) = @_;
    	    eval q( &_XtFree($ptr));
	}' unless defined(&XtFree);
    }
    eval 'sub XtNew {
        my($type) = @_;
	    eval q((($type *)  &XtMalloc( $sizeof{$type})));
    }' unless defined(&XtNew);
    eval 'sub XtNewString {
        my($str) = @_;
	    eval q(( !=  &NULL ? ( &strcpy( &XtMalloc( &strlen($str) + 1), $str)) :  &NULL));
    }' unless defined(&XtNewString);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XT_CONVERT_FAIL () {( &Atom)0x80000001;}' unless defined(&XT_CONVERT_FAIL);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtCvtStringToPosition () { &XtCvtStringToShort;}' unless defined(&XtCvtStringToPosition);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtCvtIntToDimension () { &XtCvtIntToShort;}' unless defined(&XtCvtIntToDimension);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtCvtIntToPosition () { &XtCvtIntToShort;}' unless defined(&XtCvtIntToPosition);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub XtCvtPixelToColor () { &XtCvtIntToColor;}' unless defined(&XtCvtPixelToColor);
}
1;
