require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&HAS_WCTYPE_H)) {
    require 'wctype.ph';
    require 'widec.ph';
    eval 'sub wcslen {
        my($c) = @_;
	    eval q( &wslen($c));
    }' unless defined(&wcslen);
    eval 'sub wcscpy {
        my($d,$s) = @_;
	    eval q( &wscpy($d,$s));
    }' unless defined(&wcscpy);
    eval 'sub wcsncpy {
        my($d,$s,$l) = @_;
	    eval q( &wsncpy($d,$s,$l));
    }' unless defined(&wcsncpy);
}
if(defined(&HAS_WCHAR_H)) {
    require 'wchar.ph';
}
if(defined(&AIXV3)) {
    require 'ctype.ph';
}
if(defined(&NCR)) {
    eval 'sub iswspace {
        my($c) = @_;
	    eval q( &_Xaw_iswspace($c));
    }' unless defined(&iswspace);
}
if(defined(&sony)) {
    unless(defined(&SVR4)) {
	require 'jctype.ph';
	eval 'sub iswspace {
	    my($c) = @_;
    	    eval q( &jisspace($c));
	}' unless defined(&iswspace);
    }
}
if(defined(&USE_XWCHAR_STRING)) {
    eval 'sub wcslen {
        my($c) = @_;
	    eval q( &_Xwcslen($c));
    }' unless defined(&wcslen);
    eval 'sub wcscpy {
        my($d,$s) = @_;
	    eval q( &_Xwcscpy($d,$s));
    }' unless defined(&wcscpy);
    eval 'sub wcsncpy {
        my($d,$s,$l) = @_;
	    eval q( &_Xwcsncpy($d,$s,$l));
    }' unless defined(&wcsncpy);
    if(defined(&USE_XMBTOWC)) {
	eval 'sub mbtowc {
	    my($wc,$s,$l) = @_;
    	    eval q( &_Xmbtowc($wc,$s,$l));
	}' unless defined(&mbtowc);
    }
}
if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
}
unless(defined(&HAS_ISW_FUNCS)) {
    require 'ctype.ph';
    unless(defined(&iswspace)) {
	eval 'sub iswspace {
	    my($c) = @_;
    	    eval q(( &isascii($c)  &&  &isspace( &toascii($c))));
	}' unless defined(&iswspace);
    }
}
1;
