require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XPOLL_H_)) {
    eval 'sub _XPOLL_H_ () {1;}' unless defined(&_XPOLL_H_);
    unless(defined(&WIN32)) {
	unless(defined(&USE_POLL)) {
	    require 'X11/Xos.ph';
	    require 'sys/select.ph';
	    if(defined(&luna)) {
		require 'sysent.ph';
	    }
	    require 'X11/Xmd.ph';
	    if(defined(&CSRG_BASED)) {
		require 'sys/param.ph';
		if((defined(&BSD) ? &BSD : 0) < 199103) {
		}
	    }
	    eval 'sub XFD_SETSIZE () {256;}' unless defined(&XFD_SETSIZE);
	    unless(defined(&FD_SETSIZE)) {
		eval 'sub FD_SETSIZE () { &XFD_SETSIZE;}' unless defined(&FD_SETSIZE);
	    }
	    unless(defined(&NBBY)) {
		eval 'sub NBBY () {8;}' unless defined(&NBBY);
	    }
	    if(defined(&_AIXR6)) {
		eval 'sub NFDBITS () { &__NFDBITS;}' unless defined(&NFDBITS);
	    }
	    unless(defined(&NFDBITS)) {
		eval 'sub NFDBITS () {($sizeof{ &fd_mask} *  &NBBY);}' unless defined(&NFDBITS);
	    }
	    unless(defined(&howmany)) {
		eval 'sub howmany {
		    my($x,$y) = @_;
    		    eval q(((($x)+(($y)-1))/($y)));
		}' unless defined(&howmany);
	    }
	    if(defined(&BSD)) {
		if((defined(&BSD) ? &BSD : 0) < 198911) {
		    unless(defined(&luna)) {
		    }
		}
	    }
	    if(defined(&hpux)) {
		eval 'sub Select {
		    my($n,$r,$w,$e,$t) = @_;
    		    eval q( &select($n,$r,$w,$e,$t));
		}' unless defined(&Select);
	    } else {
		eval 'sub Select {
		    my($n,$r,$w,$e,$t) = @_;
    		    eval q( &select($n,( &fd_set*)$r,( &fd_set*)$w,( &fd_set*)$e,$t));
		}' unless defined(&Select);
	    }
	    unless(defined(&FD_SET)) {
		eval 'sub FD_SET {
		    my($n, $p) = @_;
    		    eval q((($p)-> $fds_bits[($n)/ &NFDBITS] |= (1<< (($n) %  &NFDBITS))));
		}' unless defined(&FD_SET);
	    }
	    unless(defined(&FD_CLR)) {
		eval 'sub FD_CLR {
		    my($n, $p) = @_;
    		    eval q((($p)-> $fds_bits[($n)/ &NFDBITS] &= ~(1<< (($n) %  &NFDBITS))));
		}' unless defined(&FD_CLR);
	    }
	    unless(defined(&FD_ISSET)) {
		eval 'sub FD_ISSET {
		    my($n, $p) = @_;
    		    eval q((($p)-> $fds_bits[($n)/ &NFDBITS] & (1<< (($n) %  &NFDBITS))));
		}' unless defined(&FD_ISSET);
	    }
	    unless(defined(&FD_ZERO)) {
		eval 'sub FD_ZERO {
		    my($p) = @_;
    		    eval q( &bzero(($p), $sizeof{($p)}));
		}' unless defined(&FD_ZERO);
	    }
	    eval 'sub XFD_ANYSET {
	        my($p) = @_;
    		eval q((($p)-> $fds_bits[0] || ($p)-> $fds_bits[1] || ($p)-> $fds_bits[2] || ($p)-> $fds_bits[3] || ($p)-> $fds_bits[4] || ($p)-> $fds_bits[5] || ($p)-> $fds_bits[6] || ($p)-> $fds_bits[7]));
	    }' unless defined(&XFD_ANYSET);
	    eval 'sub XFD_COPYSET {
	        my($src,$dst) = @_;
    		eval q(($dst)-> $fds_bits[0] = ($src)-> $fds_bits[0]; ($dst)-> $fds_bits[1] = ($src)-> $fds_bits[1]; ($dst)-> $fds_bits[2] = ($src)-> $fds_bits[2]; ($dst)-> $fds_bits[3] = ($src)-> $fds_bits[3]; ($dst)-> $fds_bits[4] = ($src)-> $fds_bits[4]; ($dst)-> $fds_bits[5] = ($src)-> $fds_bits[5]; ($dst)-> $fds_bits[6] = ($src)-> $fds_bits[6]; ($dst)-> $fds_bits[7] = ($src)-> $fds_bits[7];);
	    }' unless defined(&XFD_COPYSET);
	    eval 'sub XFD_ANDSET {
	        my($dst,$b1,$b2) = @_;
    		eval q(($dst)-> $fds_bits[0] = (($b1)-> $fds_bits[0] & ($b2)-> $fds_bits[0]); ($dst)-> $fds_bits[1] = (($b1)-> $fds_bits[1] & ($b2)-> $fds_bits[1]); ($dst)-> $fds_bits[2] = (($b1)-> $fds_bits[2] & ($b2)-> $fds_bits[2]); ($dst)-> $fds_bits[3] = (($b1)-> $fds_bits[3] & ($b2)-> $fds_bits[3]); ($dst)-> $fds_bits[4] = (($b1)-> $fds_bits[4] & ($b2)-> $fds_bits[4]); ($dst)-> $fds_bits[5] = (($b1)-> $fds_bits[5] & ($b2)-> $fds_bits[5]); ($dst)-> $fds_bits[6] = (($b1)-> $fds_bits[6] & ($b2)-> $fds_bits[6]); ($dst)-> $fds_bits[7] = (($b1)-> $fds_bits[7] & ($b2)-> $fds_bits[7]););
	    }' unless defined(&XFD_ANDSET);
	    eval 'sub XFD_ORSET {
	        my($dst,$b1,$b2) = @_;
    		eval q(($dst)-> $fds_bits[0] = (($b1)-> $fds_bits[0] | ($b2)-> $fds_bits[0]); ($dst)-> $fds_bits[1] = (($b1)-> $fds_bits[1] | ($b2)-> $fds_bits[1]); ($dst)-> $fds_bits[2] = (($b1)-> $fds_bits[2] | ($b2)-> $fds_bits[2]); ($dst)-> $fds_bits[3] = (($b1)-> $fds_bits[3] | ($b2)-> $fds_bits[3]); ($dst)-> $fds_bits[4] = (($b1)-> $fds_bits[4] | ($b2)-> $fds_bits[4]); ($dst)-> $fds_bits[5] = (($b1)-> $fds_bits[5] | ($b2)-> $fds_bits[5]); ($dst)-> $fds_bits[6] = (($b1)-> $fds_bits[6] | ($b2)-> $fds_bits[6]); ($dst)-> $fds_bits[7] = (($b1)-> $fds_bits[7] | ($b2)-> $fds_bits[7]););
	    }' unless defined(&XFD_ORSET);
	    eval 'sub XFD_UNSET {
	        my($dst,$b1) = @_;
    		eval q(($dst)-> $fds_bits[0] &= ~(($b1)-> $fds_bits[0]); ($dst)-> $fds_bits[1] &= ~(($b1)-> $fds_bits[1]); ($dst)-> $fds_bits[2] &= ~(($b1)-> $fds_bits[2]); ($dst)-> $fds_bits[3] &= ~(($b1)-> $fds_bits[3]); ($dst)-> $fds_bits[4] &= ~(($b1)-> $fds_bits[4]); ($dst)-> $fds_bits[5] &= ~(($b1)-> $fds_bits[5]); ($dst)-> $fds_bits[6] &= ~(($b1)-> $fds_bits[6]); ($dst)-> $fds_bits[7] &= ~(($b1)-> $fds_bits[7]););
	    }' unless defined(&XFD_UNSET);
	} else {
	    require 'sys/poll.ph';
	}
    } else {
	unless(defined(&FD_SETSIZE)) {
	    eval 'sub FD_SETSIZE () {256;}' unless defined(&FD_SETSIZE);
	}
	eval 'sub BOOL () { &wBOOL;}' unless defined(&BOOL);
	undef(&Status) if defined(&Status);
	eval 'sub Status () { &wStatus;}' unless defined(&Status);
	require 'winsock.ph';
	undef(&Status) if defined(&Status);
	eval 'sub Status () {\'int\';}' unless defined(&Status);
	undef(&BOOL) if defined(&BOOL);
	eval 'sub Select {
	    my($n,$r,$w,$e,$t) = @_;
    	    eval q( &select(0,( &fd_set*)$r,( &fd_set*)$w,( &fd_set*)$e,$t));
	}' unless defined(&Select);
	eval 'sub XFD_ANYSET {
	    my($p) = @_;
    	    eval q(1);
	}' unless defined(&XFD_ANYSET);
	eval 'sub XFD_COPYSET {
	    my($src,$dst) = @_;
    	    eval q();
	}' unless defined(&XFD_COPYSET);
	eval 'sub XFD_ANDSET {
	    my($dst,$b1,$b2) = @_;
    	    eval q();
	}' unless defined(&XFD_ANDSET);
	eval 'sub XFD_ORSET {
	    my($dst,$b1,$b2) = @_;
    	    eval q();
	}' unless defined(&XFD_ORSET);
	eval 'sub XFD_UNSET {
	    my($dst,$b1) = @_;
    	    eval q();
	}' unless defined(&XFD_UNSET);
    }
}
1;
