require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__H_CCM_MACROS)) {
    eval 'sub __H_CCM_MACROS () {1;}' unless defined(&__H_CCM_MACROS);
    eval 'sub CCM_DDS_bus_mem_start {
        my( $dds,$i ) = @_;
	    eval q(( ($dds) ->  $io_bus_mem_start[( &i)] ));
    }' unless defined(&CCM_DDS_bus_mem_start);
    eval 'sub CCM_DDS_bus_mem_length {
        my( $dds,$i ) = @_;
	    eval q(( ($dds) ->  $io_bus_mem_length[( &i)] ));
    }' unless defined(&CCM_DDS_bus_mem_length);
    eval 'sub CCM_DDS_RISC_rom_addr {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &RISC_rom_addr ));
    }' unless defined(&CCM_DDS_RISC_rom_addr);
    eval 'sub CCM_DDS_bus_slot {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &slot_number ));
    }' unless defined(&CCM_DDS_bus_slot);
    eval 'sub CCM_DDS_bus_int_level {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &int_level ));
    }' unless defined(&CCM_DDS_bus_int_level);
    eval 'sub CCM_DDS_bus_int_priority {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &int_priority ));
    }' unless defined(&CCM_DDS_bus_int_priority);
    eval 'sub CCM_DDS_bus_dma_arb_level {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &dma_arb_level ));
    }' unless defined(&CCM_DDS_bus_dma_arb_level);
    eval 'sub CCM_DDS_bus_id {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &bus_id ));
    }' unless defined(&CCM_DDS_bus_id);
    eval 'sub CCM_DDS_bus_type {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &bus_type ));
    }' unless defined(&CCM_DDS_bus_type);
    eval 'sub CCM_DDS_device_num {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &device_num ));
    }' unless defined(&CCM_DDS_device_num);
    eval 'sub CCM_DDS_bus_type_is_microchannel {
        my( $dds ) = @_;
	    eval q((  &CCM_DDS_bus_type($dds) ==  &CCM_BUS_TYPE_MICROCHANNEL ));
    }' unless defined(&CCM_DDS_bus_type_is_microchannel);
    eval 'sub CCM_DDS_bus_type_is_220_BUID40 {
        my( $dds ) = @_;
	    eval q((  &CCM_DDS_bust_type($dds) ==  &CCM_BUS_TYPE_220_BUID40 ));
    }' unless defined(&CCM_DDS_bus_type_is_220_BUID40);
    eval 'sub CCM_DDS_screen_width_pel {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &screen_width_pel ));
    }' unless defined(&CCM_DDS_screen_width_pel);
    eval 'sub CCM_DDS_screen_height_pel {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &screen_height_pel ));
    }' unless defined(&CCM_DDS_screen_height_pel);
    eval 'sub CCM_DDS_screen_width_mm {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &screen_width_mm ));
    }' unless defined(&CCM_DDS_screen_width_mm);
    eval 'sub CCM_DDS_screen_height_mm {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &screen_height_mm ));
    }' unless defined(&CCM_DDS_screen_height_mm);
    eval 'sub CCM_DDS_config_display_id {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &display_id ));
    }' unless defined(&CCM_DDS_config_display_id);
    eval 'sub CCM_DDS_ksr_color_table {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &ksr_color_table ));
    }' unless defined(&CCM_DDS_ksr_color_table);
    eval 'sub CCM_DDS_ucode_fd {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &microcode_fd ));
    }' unless defined(&CCM_DDS_ucode_fd);
    eval 'sub CCM_DDS_component {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &component ));
    }' unless defined(&CCM_DDS_component);
    eval 'sub CCM_DDS_ucode_filename {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &ucode_name ));
    }' unless defined(&CCM_DDS_ucode_filename);
    eval 'sub CCM_DDS_ccmdd_kmid {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &dd_kmid ));
    }' unless defined(&CCM_DDS_ccmdd_kmid);
    eval 'sub CCM_DDS_ccmdd_pin_kmid {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &dd_pin_kmid ));
    }' unless defined(&CCM_DDS_ccmdd_pin_kmid);
    eval 'sub CCM_DDS_cdd_kmid {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &cdd_kmid ));
    }' unless defined(&CCM_DDS_cdd_kmid);
    eval 'sub CCM_DDS_cdd_pin_kmid {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &cdd_pin_kmid ));
    }' unless defined(&CCM_DDS_cdd_pin_kmid);
    eval 'sub CCM_DDS_cdd_ext_kmid {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &cdd_ext_kmid ));
    }' unless defined(&CCM_DDS_cdd_ext_kmid);
    eval 'sub CCM_DDS_cdd_ext_pin_kmid {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &cdd_ext_pin_kmid ));
    }' unless defined(&CCM_DDS_cdd_ext_pin_kmid);
    eval 'sub CCM_DDS_global_dd_data {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &p_ccm_dd_data ));
    }' unless defined(&CCM_DDS_global_dd_data);
    eval 'sub CCM_DDS_x_min {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &x_min ));
    }' unless defined(&CCM_DDS_x_min);
    eval 'sub CCM_DDS_y_min {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &y_min ));
    }' unless defined(&CCM_DDS_y_min);
    eval 'sub CCM_DDS_x_max {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &x_max ));
    }' unless defined(&CCM_DDS_x_max);
    eval 'sub CCM_DDS_y_max {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &y_max ));
    }' unless defined(&CCM_DDS_y_max);
    eval 'sub CCM_DDS_60x_architecture {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &architecture ));
    }' unless defined(&CCM_DDS_60x_architecture);
    eval 'sub CCM_DDS_60x_implementation {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &implementation ));
    }' unless defined(&CCM_DDS_60x_implementation);
    eval 'sub CCM_DDS_60x_int_server {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &int_server ));
    }' unless defined(&CCM_DDS_60x_int_server);
    eval 'sub CCM_DDS_60x_segment {
        my( $dds ) = @_;
	    eval q(( ($dds) ->  &segment_60x ));
    }' unless defined(&CCM_DDS_60x_segment);
    eval 'sub CCM_DDS_60x_buid {
        my( $dds, $i ) = @_;
	    eval q(( ($dds) ->  $buid_60x[ ( &i) ] ));
    }' unless defined(&CCM_DDS_60x_buid);
    eval 'sub GS_IO_MAP_INIT {
        my($iomap, $bid_parm, $busaddr_parm) = @_;
	    eval q({ ($iomap)-> &key =  &IO_MEM_MAP; ($iomap)-> &flags = 0; ($iomap)-> &size =  &SEGSIZE; ($iomap)-> &bid = ($bid_parm); ($iomap)-> &busaddr = ($busaddr_parm) ; });
    }' unless defined(&GS_IO_MAP_INIT);
    eval 'sub CCM_BUS_PUT_60x {
        my($p,$v,$iolen) = @_;
	    eval q({ \'struct io_map\'  &io_map ; \'ulong base_io_addr\' ; \'ulong actual_io_addr\' ;  &GS_IO_MAP_INIT (&,  &REALMEM_BID, & 0xf0000000) ;  &base_io_addr =  &GS_ATTACHGRAPHICSBUS ;  &actual_io_addr =  &base_io_addr + (($p) &  &CCM_60x_UPPER_NIBBLE_MASK); *($iolen  &volatile *)( &actual_io_addr) = ($iolen)($v) ;  &GS_DETACHGRAPHICSBUS( &base_io_addr); });
    }' unless defined(&CCM_BUS_PUT_60x);
    eval 'sub CCM_BUS_PUTL_60x {
        my($p,$v) = @_;
	    eval q( &CCM_BUS_PUT_60x($p,$v,\'ulong\'));
    }' unless defined(&CCM_BUS_PUTL_60x);
    eval 'sub CCM_BUS_PUTS_60x {
        my($p,$v) = @_;
	    eval q( &CCM_BUS_PUT_60x($p,$v,\'ushort\'));
    }' unless defined(&CCM_BUS_PUTS_60x);
    eval 'sub CCM_BUS_PUTC_60x {
        my($p,$v) = @_;
	    eval q( &CCM_BUS_PUT_60x($p,$v,\'uchar\'));
    }' unless defined(&CCM_BUS_PUTC_60x);
    eval 'sub CCM_BUS_GET_60x {
        my($p,$p_val,$iolen) = @_;
	    eval q({ \'struct io_map\'  &io_map ; \'ulong base_io_addr\' ; \'ulong actual_io_addr\' ;  &GS_IO_MAP_INIT ( &io_map,  &REALMEM_BID, & 0xf0000000) ;  &base_io_addr =  &GS_ATTACHGRAPHICSBUS ;  &actual_io_addr =  &base_io_addr + (($p) &  &CCM_60x_UPPER_NIBBLE_MASK); *($p_val) = (*(($iolen  &volatile *)( &actual_io_addr)));  &GS_DETACHGRAPHICSBUS( &base_io_addr); });
    }' unless defined(&CCM_BUS_GET_60x);
    eval 'sub CCM_BUS_GETL_60x {
        my($p,$p_val) = @_;
	    eval q( &CCM_BUS_GET_60x($p,$p_val,\'ulong\'));
    }' unless defined(&CCM_BUS_GETL_60x);
    eval 'sub CCM_BUS_GETS_60x {
        my($p,$p_val) = @_;
	    eval q( &CCM_BUS_GET_60x($p,$p_val,\'ushort\'));
    }' unless defined(&CCM_BUS_GETS_60x);
    eval 'sub CCM_BUS_GETC_60x {
        my($p,$p_val) = @_;
	    eval q( &CCM_BUS_GET_60x($p,$p_val,\'uchar\'));
    }' unless defined(&CCM_BUS_GETC_60x);
    eval 'sub CCMDD_GLOBAL_DATA_DEFINED_HERE () { &ccm_dd_data_t *  &_CCMDD =  &NULL;;}' unless defined(&CCMDD_GLOBAL_DATA_DEFINED_HERE);
    eval 'sub CCMDD_GLOBAL_DATA_DEFINED_EXTERN () { &extern  &ccm_dd_data_t *  &_CCMDD;;}' unless defined(&CCMDD_GLOBAL_DATA_DEFINED_EXTERN);
    eval 'sub CCMDD_GLOBAL_DATA_PTR_INIT {
        my( $ptr ) = @_;
	    eval q({  &_CCMDD = ( &ccm_dd_data_t *) ($ptr); });
    }' unless defined(&CCMDD_GLOBAL_DATA_PTR_INIT);
    eval 'sub CCMDD_GLOBAL_DATA_PTR () {( &_CCMDD);}' unless defined(&CCMDD_GLOBAL_DATA_PTR);
    eval 'sub CCMDD_INTR_GLOBAL_DATA_DEFINED_HERE () { &ccm_dd_intr_data_t *  &_CCMDD_INTR;;}' unless defined(&CCMDD_INTR_GLOBAL_DATA_DEFINED_HERE);
    eval 'sub CCMDD_INTR_GLOBAL_DATA_DEFINED_EXTERN () { &extern  &ccm_dd_intr_data_t *  &_CCMDD_INTR;;}' unless defined(&CCMDD_INTR_GLOBAL_DATA_DEFINED_EXTERN);
    eval 'sub CCMDD_INTR_GLOBAL_DATA_PTR_INIT {
        my( $ptr ) = @_;
	    eval q({  &_CCMDD_INTR = ( &ccm_dd_intr_data_t *) ($ptr); });
    }' unless defined(&CCMDD_INTR_GLOBAL_DATA_PTR_INIT);
    eval 'sub CCMDD_INTR_GLOBAL_DATA_PTR () {( &_CCMDD_INTR);}' unless defined(&CCMDD_INTR_GLOBAL_DATA_PTR);
    eval 'sub CCM_cdd_head {
        my($ptr) = @_;
	    eval q(($ptr ->  &p_cdd_header));
    }' unless defined(&CCM_cdd_head);
    eval 'sub CCM_cdd_svcs {
        my($ptr) = @_;
	    eval q(($ptr ->  &p_cdd_svcs));
    }' unless defined(&CCM_cdd_svcs);
    eval 'sub CCM_cdd_proc {
        my($ptr) = @_;
	    eval q(($ptr ->  &p_cdd_procs));
    }' unless defined(&CCM_cdd_proc);
    eval 'sub CCM_cdd_device {
        my($ptr) = @_;
	    eval q(($ptr ->  &p_cdd_device_attrs));
    }' unless defined(&CCM_cdd_device);
    eval 'sub CCM_cdd_command {
        my($ptr) = @_;
	    eval q(($ptr ->  &p_cdd_command_attrs));
    }' unless defined(&CCM_cdd_command);
    eval 'sub CCM_path {
        my($ptr) = @_;
	    eval q(($ptr ->  &p_ccm_paths));
    }' unless defined(&CCM_path);
    eval 'sub CCM_dds {
        my($ptr) = @_;
	    eval q(($ptr ->  &p_ccm_dds));
    }' unless defined(&CCM_dds);
    eval 'sub CCMDD_cdd () {( &_CCMDD ->  &p_cdd_header );}' unless defined(&CCMDD_cdd);
    eval 'sub CCMDD_cdd_svcs () {( &_CCMDD ->  &p_cdd_svcs );}' unless defined(&CCMDD_cdd_svcs);
    eval 'sub CCMDD_cdd_procs () {( &_CCMDD ->  &p_cdd_procs );}' unless defined(&CCMDD_cdd_procs);
    eval 'sub CCMDD_cdd_dev_attrs () {( &_CCMDD ->  &p_cdd_device_attrs );}' unless defined(&CCMDD_cdd_dev_attrs);
    eval 'sub CCMDD_cdd_dev () { &CCMDD_cdd_dev_attrs;}' unless defined(&CCMDD_cdd_dev);
    eval 'sub CCMDD_cdd_cmd_attrs () {( &_CCMDD ->  &p_cdd_command_attrs );}' unless defined(&CCMDD_cdd_cmd_attrs);
    eval 'sub CCMDD_cdd_cmd () { &CCMDD_cdd_cmd_attrs;}' unless defined(&CCMDD_cdd_cmd);
    eval 'sub CCMDD_dds () {( &_CCMDD ->  &p_ccm_dds );}' unless defined(&CCMDD_dds);
    eval 'sub CCMDD_pathnames () {( &_CCMDD ->  &p_ccm_paths );}' unless defined(&CCMDD_pathnames);
    eval 'sub CCMDD_has_intr_kmod () {( &_CCMDD ->  &has_intr_kmod );}' unless defined(&CCMDD_has_intr_kmod);
    eval 'sub CCMDD_kmid_entry () {( &_CCMDD ->  &kmid_entry );}' unless defined(&CCMDD_kmid_entry);
    eval 'sub CCMDD_kmid_interrupt () {( &_CCMDD ->  &kmid_interrupt );}' unless defined(&CCMDD_kmid_interrupt);
    eval 'sub CCMDD_kmid_ccmdd_pin () {( &_CCMDD ->  &kmid_ccmdd_pin );}' unless defined(&CCMDD_kmid_ccmdd_pin);
    eval 'sub CCMDD_ksr () {( &_CCMDD ->  &p_ccm_ksr_data );}' unless defined(&CCMDD_ksr);
    eval 'sub CCMDD_fast_io () {( &_CCMDD ->  &vtt_fast_io );}' unless defined(&CCMDD_fast_io);
    eval 'sub CCMDD_busmem_att () {( &_CCMDD ->  &vtt_busmem_att );}' unless defined(&CCMDD_busmem_att);
    eval 'sub CCMDD_iocc_att () {( &_CCMDD ->  &vtt_iocc_att );}' unless defined(&CCMDD_iocc_att);
    undef(&X_MIN) if defined(&X_MIN);
    eval 'sub X_MIN () { &CCM_DDS_x_min(  &CCMDD_dds );}' unless defined(&X_MIN);
    undef(&X_MAX) if defined(&X_MAX);
    eval 'sub X_MAX () { &CCM_DDS_x_max(  &CCMDD_dds );}' unless defined(&X_MAX);
    undef(&Y_MIN) if defined(&Y_MIN);
    eval 'sub Y_MIN () { &CCM_DDS_y_min(  &CCMDD_dds );}' unless defined(&Y_MIN);
    undef(&Y_MAX) if defined(&Y_MAX);
    eval 'sub Y_MAX () { &CCM_DDS_y_max(  &CCMDD_dds );}' unless defined(&Y_MAX);
    eval 'sub CCM_PATHNAME_ucode_file {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &ucode_file_ptr ));
    }' unless defined(&CCM_PATHNAME_ucode_file);
    eval 'sub CCM_PATHNAME_dev_ucode {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &dev_ucodename ));
    }' unless defined(&CCM_PATHNAME_dev_ucode);
    eval 'sub CCM_PATHNAME_ccm_ucode {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &ccm_ucodename ));
    }' unless defined(&CCM_PATHNAME_ccm_ucode);
    eval 'sub CCM_PATHNAME_dev_dd {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &device_driver ));
    }' unless defined(&CCM_PATHNAME_dev_dd);
    eval 'sub CCM_PATHNAME_dev_dd_pin {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &device_pinned ));
    }' unless defined(&CCM_PATHNAME_dev_dd_pin);
    eval 'sub CCM_PATHNAME_ccm_dd {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &ccm_dd_name ));
    }' unless defined(&CCM_PATHNAME_ccm_dd);
    eval 'sub CCM_PATHNAME_ccm_dd_pin {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &ccm_dd_pinned ));
    }' unless defined(&CCM_PATHNAME_ccm_dd_pin);
    eval 'sub CCM_PATHNAME_cdd_kmod {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &cdd_kmod_name ));
    }' unless defined(&CCM_PATHNAME_cdd_kmod);
    eval 'sub CCM_PATHNAME_cdd_kmod_entry {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &cdd_kmod_entry ));
    }' unless defined(&CCM_PATHNAME_cdd_kmod_entry);
    eval 'sub CCM_PATHNAME_cdd_kmod_interrupt {
        my( $pp ) = @_;
	    eval q(( ($pp) ->  &cdd_kmod_interrupt ));
    }' unless defined(&CCM_PATHNAME_cdd_kmod_interrupt);
    eval 'sub CCM_IOCC_VALID {
        my( $segment ) = @_;
	    eval q(( ((($segment) &  &CDD_SEG_T_BIT ) ==  &CDD_SEG_T_BIT )  && ((($segment) &  &CDD_IOCC_SELECT ) ==  &CDD_IOCC_SELECT )  && ((($segment) &  &CDD_BUSx ) ==  &CDD_BUSx )  && ((($segment) &  &CDD_ADDR_INCR ) ==  &CDD_ADDR_INCR )  && ((($segment) &  &CDD_ADDR_CHK ) ==  &CDD_ADDR_CHK ) ));
    }' unless defined(&CCM_IOCC_VALID);
    eval 'sub CCM_INTR_dev {
        my( $pdata ) = @_;
	    eval q(( ($pdata)-> &p_cdd_intr_dev_attrs ));
    }' unless defined(&CCM_INTR_dev);
    eval 'sub CCM_INTR_svcs {
        my( $pdata ) = @_;
	    eval q(( ($pdata)-> &p_cdd_intr_svcs ));
    }' unless defined(&CCM_INTR_svcs);
    eval 'sub CCM_INTR_head {
        my( $pdata ) = @_;
	    eval q(( ($pdata)-> &p_cdd_intr_head ));
    }' unless defined(&CCM_INTR_head);
    eval 'sub CCM_INTR_entry {
        my( $pdata ) = @_;
	    eval q(( ($pdata)-> &ccmdd_interrupt ));
    }' unless defined(&CCM_INTR_entry);
    eval 'sub CCM_INTR_cdd_entry {
        my( $pdata ) = @_;
	    eval q(( ($pdata)-> &cdd_interrupt ));
    }' unless defined(&CCM_INTR_cdd_entry);
    eval 'sub CCM_KSR_max_w {
        my( $pk ) = @_;
	    eval q(( ($pk) ->  &cdd_max_width ));
    }' unless defined(&CCM_KSR_max_w);
    eval 'sub CCM_KSR_max_h {
        my( $pk ) = @_;
	    eval q(( ($pk) ->  &cdd_max_height ));
    }' unless defined(&CCM_KSR_max_h);
    eval 'sub CCM_KSR_max_a {
        my( $pk ) = @_;
	    eval q(( ($pk) ->  &cdd_max_area ));
    }' unless defined(&CCM_KSR_max_a);
    eval 'sub CCM_KSR_origin_type {
        my( $pk ) = @_;
	    eval q(( ($pk) ->  &cdd_origin_type ));
    }' unless defined(&CCM_KSR_origin_type);
}
1;
