require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SYS_CORE)) {
    eval 'sub _H_SYS_CORE () {1;}' unless defined(&_H_SYS_CORE);
    require 'sys/user.ph';
    require 'procinfo.ph';
    unless(defined(&__64BIT__)) {
	eval 'sub NSIG41 () {64;}' unless defined(&NSIG41);
	eval 'sub NSEGS41 () {16;}' unless defined(&NSEGS41);
	eval 'sub MAXCOMLEN41 () {32;}' unless defined(&MAXCOMLEN41);
	eval 'sub RLIM_NLIMITS41 () {6;}' unless defined(&RLIM_NLIMITS41);
	eval 'sub NTIMERS41 () {9;}' unless defined(&NTIMERS41);
	eval 'sub OPEN_MAX41 () {2000;}' unless defined(&OPEN_MAX41);
	unless(defined(&__ia64)) {
	}
    }
    unless(defined(&__ia64)) {
	eval 'sub CHDRSIZE () {($sizeof{\'struct core_dump\'});}' unless defined(&CHDRSIZE);
	eval 'sub CTABSIZE () {($sizeof{\'struct __ld_info32\'} +  &MAXPATHLEN +  &MAXNAMLEN);}' unless defined(&CTABSIZE);
    }
    eval 'sub CDATA_ADDR {
        my($x) = @_;
	    eval q(( &PRIVORG));
    }' unless defined(&CDATA_ADDR);
    eval 'sub CSTACK_ADDR {
        my($x) = @_;
	    eval q(( &USRSTACK - $x));
    }' unless defined(&CSTACK_ADDR);
    eval 'sub COREFILE () {"core";}' unless defined(&COREFILE);
    eval 'sub FULL_CORE () {0x1;}' unless defined(&FULL_CORE);
    eval 'sub CORE_VERSION_1 () {0x2;}' unless defined(&CORE_VERSION_1);
    eval 'sub MSTS_VALID () {0x4;}' unless defined(&MSTS_VALID);
    eval 'sub CORE_BIGDATA () {0x8;}' unless defined(&CORE_BIGDATA);
    eval 'sub UBLOCK_VALID () {0x10;}' unless defined(&UBLOCK_VALID);
    eval 'sub USTACK_VALID () {0x20;}' unless defined(&USTACK_VALID);
    eval 'sub LE_VALID () {0x40;}' unless defined(&LE_VALID);
    eval 'sub CORE_TRUNC () {0x80;}' unless defined(&CORE_TRUNC);
    if(defined(&__ia64)) {
    } else {
    }
    if(defined(&__ia64)) {
    } else {
    }
    if(defined(&__ia64)) {
	eval 'sub CO_MAINEXEC () {0x80000000;}' unless defined(&CO_MAINEXEC);
	eval 'sub CO_READ () {0x4;}' unless defined(&CO_READ);
	eval 'sub CO_WRITE () {0x2;}' unless defined(&CO_WRITE);
	eval 'sub CO_EXEC () {0x1;}' unless defined(&CO_EXEC);
	eval 'sub CO_SHARED () {0x8;}' unless defined(&CO_SHARED);
	eval 'sub CO_BREAK () {0x10;}' unless defined(&CO_BREAK);
	eval 'sub CO_STACK () {0x20;}' unless defined(&CO_STACK);
    }
}
1;
