require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_FP)) {
    eval 'sub _H_FP () {1;}' unless defined(&_H_FP);
    require 'fpxcp.ph';
    require 'sys/FP.ph';
    eval 'sub DBL {
        my($val,$hi,$lo) = @_;
	    eval q({  &VALH($val) = $hi; &VALL($val) = $lo; });
    }' unless defined(&DBL);
    eval 'sub FINITE {
        my($x) = @_;
	    eval q(( (  &VALH($x) & 0x7ff00000 ) != 0x7ff00000 ));
    }' unless defined(&FINITE);
    eval 'sub IS_INF {
        my($x) = @_;
	    eval q(( ( (  &VALH($x) & 0x7fffffff ) == 0x7ff00000 )  && (  &VALL($x) == 0) ));
    }' unless defined(&IS_INF);
    eval 'sub IS_QNAN {
        my($x) = @_;
	    eval q(( (  &VALH($x) & 0x7ff80000 ) == 0x7ff80000 ));
    }' unless defined(&IS_QNAN);
    eval 'sub IS_NAN {
        my($x) = @_;
	    eval q(( ( (  &VALH($x) & 0x7ff00000 ) == 0x7ff00000 )  && ( (  &VALH($x) & 0xfffff) |  &VALL($x) ) ));
    }' unless defined(&IS_NAN);
    eval 'sub IS_ZERO {
        my($x) = @_;
	    eval q(( !( (  &VALH($x) & 0x7fffffff ) |  &VALL($x) ) ));
    }' unless defined(&IS_ZERO);
    eval 'sub IS_DENORM {
        my($x) = @_;
	    eval q(( !(  &VALH($x) & 0xfff00000 )  && ( (  &VALH($x) & 0xfffff ) |  &VALL($x) ) ));
    }' unless defined(&IS_DENORM);
}
1;
