require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_im_h)) {
    eval 'sub _im_h () {1;}' unless defined(&_im_h);
    require 'sys/types.ph';
    require 'imerrno.ph';
    unless(defined(&True)) {
	eval 'sub True () {1;}' unless defined(&True);
    }
    unless(defined(&False)) {
	eval 'sub False () {0;}' unless defined(&False);
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    eval 'sub IMDIRECTORY () {"/usr/lib/nls/loc";}' unless defined(&IMDIRECTORY);
    eval 'sub IMPOSTFIX () {".im";}' unless defined(&IMPOSTFIX);
    eval 'sub IMKMPOSTFIX () {".imkeymap";}' unless defined(&IMKMPOSTFIX);
    eval 'sub IMMODULENAME () {"inputmethod";}' unless defined(&IMMODULENAME);
    eval 'sub IMKEYMAPNAME () {"imkeymap";}' unless defined(&IMKEYMAPNAME);
    eval 'sub IMDEFAULTLANG () {"ibmsbcs";}' unless defined(&IMDEFAULTLANG);
    eval 'sub IMAttNone () {0;}' unless defined(&IMAttNone);
    eval 'sub IMAttHighlight () {(1<< 0);}' unless defined(&IMAttHighlight);
    eval 'sub IMAttAttention () {(1<< 1);}' unless defined(&IMAttAttention);
    eval 'sub IMVersionNumber () {((1<< 16) | 1);}' unless defined(&IMVersionNumber);
    eval 'sub IMSuppressedMode () {0;}' unless defined(&IMSuppressedMode);
    eval 'sub IMNormalMode () {( &IMSuppressedMode + 1);}' unless defined(&IMNormalMode);
    eval 'sub IM_NONE () {0;}' unless defined(&IM_NONE);
    eval 'sub IM_OK () {(1<< 0);}' unless defined(&IM_OK);
    eval 'sub IM_YES () {(1<< 1);}' unless defined(&IM_YES);
    eval 'sub IM_NO () {(1<< 2);}' unless defined(&IM_NO);
    eval 'sub IM_ENTER () {(1<< 3);}' unless defined(&IM_ENTER);
    eval 'sub IM_ABORT () {(1<< 4);}' unless defined(&IM_ABORT);
    eval 'sub IM_RETRY () {(1<< 5);}' unless defined(&IM_RETRY);
    eval 'sub IM_IGNORE () {(1<< 6);}' unless defined(&IM_IGNORE);
    eval 'sub IM_CANCEL () {(1<< 7);}' unless defined(&IM_CANCEL);
    eval 'sub IM_HELP () {(1<< 8);}' unless defined(&IM_HELP);
    eval 'sub IM_SELECTED () {(1<< 9);}' unless defined(&IM_SELECTED);
    eval 'sub IM_ERROR () {(1<< 10);}' unless defined(&IM_ERROR);
    eval 'sub IM_NEXT () {(1<< 11);}' unless defined(&IM_NEXT);
    eval 'sub IM_PREV () {(1<< 12);}' unless defined(&IM_PREV);
    eval 'sub IM_OKCANCEL () {( &IM_OK |  &IM_CANCEL);}' unless defined(&IM_OKCANCEL);
    eval 'sub IM_ENTERCANCEL () {( &IM_ENTER |  &IM_CANCEL);}' unless defined(&IM_ENTERCANCEL);
    eval 'sub IM_RETRYCANCEL () {( &IM_RETRY |  &IM_CANCEL);}' unless defined(&IM_RETRYCANCEL);
    eval 'sub IM_ABORTRETRYIGNORE () {( &IM_ABORT |  &IM_RETRY |  &IM_IGNORE);}' unless defined(&IM_ABORTRETRYIGNORE);
    eval 'sub IM_YESNO () {( &IM_YES |  &IM_NO);}' unless defined(&IM_YESNO);
    eval 'sub IM_YESNOCANCEL () {( &IM_YES |  &IM_NO |  &IM_CANCEL);}' unless defined(&IM_YESNOCANCEL);
    eval 'sub IM_AtTheEvent () {0;}' unless defined(&IM_AtTheEvent);
    eval 'sub IM_UpperLeft () {( &IM_AtTheEvent + 1);}' unless defined(&IM_UpperLeft);
    eval 'sub IM_UpperRight () {( &IM_UpperLeft + 1);}' unless defined(&IM_UpperRight);
    eval 'sub IM_LowerLeft () {( &IM_UpperRight + 1);}' unless defined(&IM_LowerLeft);
    eval 'sub IM_LowerRight () {( &IM_LowerLeft + 1);}' unless defined(&IM_LowerRight);
    eval 'sub IMAuxShowing () {0;}' unless defined(&IMAuxShowing);
    eval 'sub IMAuxUpdated () {( &IMAuxShowing + 1);}' unless defined(&IMAuxUpdated);
    eval 'sub IMAuxShown () {( &IMAuxUpdated + 1);}' unless defined(&IMAuxShown);
    eval 'sub IMAuxHiding () {( &IMAuxShown + 1);}' unless defined(&IMAuxHiding);
    eval 'sub IMAuxHidden () {( &IMAuxHiding + 1);}' unless defined(&IMAuxHidden);
    eval 'sub IMHalfWidth () {0;}' unless defined(&IMHalfWidth);
    eval 'sub IMFullWidth () {( &IMHalfWidth + 1);}' unless defined(&IMFullWidth);
    eval 'sub IMInsertMode () { &True;}' unless defined(&IMInsertMode);
    eval 'sub IMReplaceMode () { &False;}' unless defined(&IMReplaceMode);
    eval 'sub IMShortForm () {0;}' unless defined(&IMShortForm);
    eval 'sub IMLongForm () {( &IMShortForm + 1);}' unless defined(&IMLongForm);
    eval 'sub IMInputNotUsed () { &False;}' unless defined(&IMInputNotUsed);
    eval 'sub IMInputUsed () { &True;}' unless defined(&IMInputUsed);
    eval 'sub IMReturnNothing () {0;}' unless defined(&IMReturnNothing);
    eval 'sub IMReturnString () {1;}' unless defined(&IMReturnString);
    eval 'sub IMNoError () {0;}' unless defined(&IMNoError);
    eval 'sub IMError () {-1;}' unless defined(&IMError);
    eval 'sub IMTextAndAuxiliaryOff () {0;}' unless defined(&IMTextAndAuxiliaryOff);
    eval 'sub IMTextOn () {( &IMTextAndAuxiliaryOff + 1);}' unless defined(&IMTextOn);
    eval 'sub IMAuxiliaryOn () {( &IMTextOn + 1);}' unless defined(&IMAuxiliaryOn);
    eval 'sub IMTextAndAuxiliaryOn () {( &IMAuxiliaryOn + 1);}' unless defined(&IMTextAndAuxiliaryOn);
    eval 'sub IM_Refresh () {0;}' unless defined(&IM_Refresh);
    eval 'sub IM_GetString () {( &IM_Refresh + 1);}' unless defined(&IM_GetString);
    eval 'sub IM_Clear () {( &IM_GetString + 1);}' unless defined(&IM_Clear);
    eval 'sub IM_Reset () {( &IM_Clear + 1);}' unless defined(&IM_Reset);
    eval 'sub IM_ChangeLength () {( &IM_Reset + 1);}' unless defined(&IM_ChangeLength);
    eval 'sub IM_QueryState () {( &IM_ChangeLength + 1);}' unless defined(&IM_QueryState);
    eval 'sub IM_QueryText () {( &IM_QueryState + 1);}' unless defined(&IM_QueryText);
    eval 'sub IM_QueryAuxiliary () {( &IM_QueryText + 1);}' unless defined(&IM_QueryAuxiliary);
    eval 'sub IM_QueryIndicator () {( &IM_QueryAuxiliary + 1);}' unless defined(&IM_QueryIndicator);
    eval 'sub IM_QueryIndicatorString () {( &IM_QueryIndicator + 1);}' unless defined(&IM_QueryIndicatorString);
    eval 'sub IM_ChangeMode () {( &IM_QueryIndicatorString + 1);}' unless defined(&IM_ChangeMode);
    eval 'sub IM_GetKeymap () {( &IM_ChangeMode + 1);}' unless defined(&IM_GetKeymap);
    eval 'sub IM_SupportSelection () {( &IM_GetKeymap + 1);}' unless defined(&IM_SupportSelection);
    eval 'sub IM_QueryKeyboard () {( &IM_SupportSelection + 1);}' unless defined(&IM_QueryKeyboard);
    eval 'sub SIMIOC () {(ord(\'S\') << 16);}' unless defined(&SIMIOC);
    eval 'sub JIMIOC () {(ord(\'J\') << 16);}' unless defined(&JIMIOC);
    eval 'sub HIMIOC () {(ord(\'H\') << 16);}' unless defined(&HIMIOC);
    eval 'sub KIMIOC () {(ord(\'K\') << 16);}' unless defined(&KIMIOC);
    eval 'sub IM_CursorUp () {0;}' unless defined(&IM_CursorUp);
    eval 'sub IM_CursorDown () {1;}' unless defined(&IM_CursorDown);
    eval 'sub imfree {
        my($p) = @_;
	    eval q( &free($p));
    }' unless defined(&imfree);
    eval 'sub immalloc {
        my($s) = @_;
	    eval q( &malloc($s));
    }' unless defined(&immalloc);
    eval 'sub imcalloc {
        my($n, $e) = @_;
	    eval q( &calloc($n, $e));
    }' unless defined(&imcalloc);
    eval 'sub imrealloc {
        my($s, $n) = @_;
	    eval q( &realloc($s, $n));
    }' unless defined(&imrealloc);
}
1;
