require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ISOADDRS_)) {
    eval 'sub _ISOADDRS_ () {1;}' unless defined(&_ISOADDRS_);
    unless(defined(&_MANIFEST_)) {
	require 'isode/manifest.ph';
    }
    unless(defined(&_GENERAL_)) {
	require 'isode/general.ph';
    }
    if(defined(&NULLPE)) {
	eval 'sub AEI_NULL () {0x;}' unless defined(&AEI_NULL);
	eval 'sub AEI_AP_ID () {0x1;}' unless defined(&AEI_AP_ID);
	eval 'sub AEI_AE_ID () {0x2;}' unless defined(&AEI_AE_ID);
	eval 'sub NULLAEI () {(( &AEI) 0);}' unless defined(&NULLAEI);
	eval 'sub AEIFREE {
	    my($aei) = @_;
    	    eval q({  &if (($aei) ->  &aei_ap_title)  &pe_free (($aei) ->  &aei_ap_title), ($aei) ->  &aei_ap_title =  &NULLPE;  &if (($aei) ->  &aei_ae_qualifier)  &pe_free (($aei) ->  &aei_ae_qualifier), ($aei) ->  &aei_ae_qualifier =  &NULLPE; });
	}' unless defined(&AEIFREE);
	eval 'sub str2aei {
	    my($d,$q) = @_;
    	    eval q( &_str2aei (($d), ($q),  &NULLCP, 0,  &NULLCP,  &NULLCP));
	}' unless defined(&str2aei);
	eval 'sub str2aeinfo {
	    my($string,$context,$interactive,$userdn,$passwd) = @_;
    	    eval q( &_str2aei (($string),  &NULLCP, ($context), ($interactive), ($userdn), ($passwd)));
	}' unless defined(&str2aeinfo);
    }
    eval 'sub NA_NSAP () {0;}' unless defined(&NA_NSAP);
    eval 'sub NA_TCP () {1;}' unless defined(&NA_TCP);
    eval 'sub NA_X25 () {2;}' unless defined(&NA_X25);
    eval 'sub NA_BRG () {3;}' unless defined(&NA_BRG);
    eval 'sub SUBNET_REALNS () {(-1);}' unless defined(&SUBNET_REALNS);
    eval 'sub SUBNET_INT_X25 () {1;}' unless defined(&SUBNET_INT_X25);
    eval 'sub SUBNET_INTERNET () {3;}' unless defined(&SUBNET_INTERNET);
    eval 'sub SUBNET_DYNAMIC () {100;}' unless defined(&SUBNET_DYNAMIC);
    eval 'sub NASIZE () {64;}' unless defined(&NASIZE);
    eval 'sub NSAP_DOMAINLEN () {63;}' unless defined(&NSAP_DOMAINLEN);
    eval 'sub NA_TSET_TCP () {0x1;}' unless defined(&NA_TSET_TCP);
    eval 'sub NA_TSET_UDP () {0x2;}' unless defined(&NA_TSET_UDP);
    eval 'sub NSAP_DTELEN () {36;}' unless defined(&NSAP_DTELEN);
    eval 'sub NPSIZE () {4;}' unless defined(&NPSIZE);
    eval 'sub CUDFSIZE () {16;}' unless defined(&CUDFSIZE);
    eval 'sub FACSIZE () {6;}' unless defined(&FACSIZE);
    eval 'sub na_address () { ($na_un->{un_na_nsap}->{na_nsap_address});}' unless defined(&na_address);
    eval 'sub na_addrlen () { ($na_un->{un_na_nsap}->{na_nsap_addrlen});}' unless defined(&na_addrlen);
    eval 'sub na_domain () { ($na_un->{un_na_tcp}->{na_tcp_domain});}' unless defined(&na_domain);
    eval 'sub na_port () { ($na_un->{un_na_tcp}->{na_tcp_port});}' unless defined(&na_port);
    eval 'sub na_tset () { ($na_un->{un_na_tcp}->{na_tcp_tset});}' unless defined(&na_tset);
    eval 'sub na_dte () { ($na_un->{un_na_x25}->{na_x25_dte});}' unless defined(&na_dte);
    eval 'sub na_dtelen () { ($na_un->{un_na_x25}->{na_x25_dtelen});}' unless defined(&na_dtelen);
    eval 'sub na_pid () { ($na_un->{un_na_x25}->{na_x25_pid});}' unless defined(&na_pid);
    eval 'sub na_pidlen () { ($na_un->{un_na_x25}->{na_x25_pidlen});}' unless defined(&na_pidlen);
    eval 'sub na_cudf () { ($na_un->{un_na_x25}->{na_x25_cudf});}' unless defined(&na_cudf);
    eval 'sub na_cudflen () { ($na_un->{un_na_x25}->{na_x25_cudflen});}' unless defined(&na_cudflen);
    eval 'sub na_fac () { ($na_un->{un_na_x25}->{na_x25_fac});}' unless defined(&na_fac);
    eval 'sub na_faclen () { ($na_un->{un_na_x25}->{na_x25_faclen});}' unless defined(&na_faclen);
    eval 'sub na_type () { &na_stack;}' unless defined(&na_type);
    eval 'sub na_subnet () { &na_community;}' unless defined(&na_subnet);
    eval 'sub NULLNA () {( 0);}' unless defined(&NULLNA);
    eval 'sub NTADDR () {8;}' unless defined(&NTADDR);
    eval 'sub TSSIZE () {64;}' unless defined(&TSSIZE);
    eval 'sub ta_selector () { ($un_ta->{ta_un_selector});}' unless defined(&ta_selector);
    eval 'sub ta_port () { ($un_ta->{ta_un_port});}' unless defined(&ta_port);
    eval 'sub NULLTA () {( 0);}' unless defined(&NULLTA);
    eval 'sub SSSIZE () {64;}' unless defined(&SSSIZE);
    eval 'sub sa_selector () { ($un_sa->{sa_un_selector});}' unless defined(&sa_selector);
    eval 'sub sa_port () { ($un_sa->{sa_un_port});}' unless defined(&sa_port);
    eval 'sub NULLSA () {( 0);}' unless defined(&NULLSA);
    eval 'sub PSSIZE () {64;}' unless defined(&PSSIZE);
    eval 'sub pa_selector () { ($un_pa->{pa_un_selector});}' unless defined(&pa_selector);
    eval 'sub pa_port () { ($un_pa->{pa_un_port});}' unless defined(&pa_port);
    eval 'sub NULLPA () {( 0);}' unless defined(&NULLPA);
    if(defined(&NULLPE)) {
    }
    if(defined(&NULLOID)) {
    }
    eval 'sub paddr2str {
        my($pa,$na) = @_;
	    eval q( &_paddr2str (($pa), ($na), 0));
    }' unless defined(&paddr2str);
    eval 'sub HIGH_QUALITY () {0;}' unless defined(&HIGH_QUALITY);
    eval 'sub LOW_QUALITY () {1;}' unless defined(&LOW_QUALITY);
    eval 'sub NULLQOS () {( 0);}' unless defined(&NULLQOS);
}
1;
