require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LOGGER_)) {
    eval 'sub _LOGGER_ () {1;}' unless defined(&_LOGGER_);
    require 'isode/manifest.ph';
    eval 'sub LLOG_NONE () {0;}' unless defined(&LLOG_NONE);
    eval 'sub LLOG_FATAL () {0x1;}' unless defined(&LLOG_FATAL);
    eval 'sub LLOG_EXCEPTIONS () {0x2;}' unless defined(&LLOG_EXCEPTIONS);
    eval 'sub LLOG_NOTICE () {0x4;}' unless defined(&LLOG_NOTICE);
    eval 'sub LLOG_PDUS () {0x8;}' unless defined(&LLOG_PDUS);
    eval 'sub LLOG_TRACE () {0x10;}' unless defined(&LLOG_TRACE);
    eval 'sub LLOG_DEBUG () {0x20;}' unless defined(&LLOG_DEBUG);
    eval 'sub LLOG_ALL () {0xff;}' unless defined(&LLOG_ALL);
    eval 'sub LLOG_MASK () {"\\020\\01FATAL\\02EXCEPTIONS\\03NOTICE\\04PDUS\\05TRACE\\06DEBUG";}' unless defined(&LLOG_MASK);
    eval 'sub LLOGNIL () {0x;}' unless defined(&LLOGNIL);
    eval 'sub LLOGCLS () {0x1;}' unless defined(&LLOGCLS);
    eval 'sub LLOGCRT () {0x2;}' unless defined(&LLOGCRT);
    eval 'sub LLOGZER () {0x4;}' unless defined(&LLOGZER);
    eval 'sub LLOGERR () {0x8;}' unless defined(&LLOGERR);
    eval 'sub LLOGTTY () {0x10;}' unless defined(&LLOGTTY);
    eval 'sub LLOGHDR () {0x20;}' unless defined(&LLOGHDR);
    eval 'sub LLOGDHR () {0x40;}' unless defined(&LLOGDHR);
    eval 'sub SLOG {
        my($lp,$event,$what,$args) = @_;
	    eval q( &if ($lp ->  &ll_events & ($event)) { ( &void)  &ll_log ($lp, $event, $what, \\"%s\\",  &ll_preset $args); }  &else);
    }' unless defined(&SLOG);
    unless(defined(&LLOG)) {
	eval 'sub LLOG {
	    my($lp,$event,$args) = @_;
    	    eval q( &SLOG ($lp, $event,  &NULLCP, $args));
	}' unless defined(&LLOG);
    }
    if(defined(&DEBUG)) {
	eval 'sub DLOG {
	    my($lp,$event,$args) = @_;
    	    eval q( &SLOG ($lp, $event,  &NULLCP, $args));
	}' unless defined(&DLOG);
    } else {
	eval 'sub DLOG {
	    my($lp,$event,$args) = @_;
    	    eval q();
	}' unless defined(&DLOG);
    }
    if(defined(&DEBUG)) {
	if(defined(&PEPSY_VERSION)) {
	    if(defined( &_AIX)) {
		eval 'sub PLOGP {
		    my($lp,$args,$pe,$text,$rw) = @_;
    		    eval q( &if (($lp) ->  &ll_events &  &LLOG_PDUS) {  &pvpdu ($lp,  &print_$args &_P, $pe, $text, $rw); }  &else);
		}' unless defined(&PLOGP);
		eval 'sub PLOG {
		    my($lp,$fnx,$pe,$text,$rw) = @_;
    		    eval q( &if (($lp) ->  &ll_events &  &LLOG_PDUS) {  &pvpdu ($lp, $fnx &_P, $pe, $text, $rw); }  &else);
		}' unless defined(&PLOG);
	    } else {
		eval 'sub PLOGP {
		    my($lp,$args,$pe,$text,$rw) = @_;
    		    eval q( &if (($lp) ->  &ll_events &  &LLOG_PDUS) {  &pvpdu ($lp,  &print_ $args  &_P, $pe, $text, $rw); }  &else);
		}' unless defined(&PLOGP);
		eval 'sub PLOG {
		    my($lp,$fnx,$pe,$text,$rw) = @_;
    		    eval q( &if (($lp) ->  &ll_events &  &LLOG_PDUS) {  &pvpdu ($lp, $fnx  &_P, $pe, $text, $rw); }  &else);
		}' unless defined(&PLOG);
	    }
	} else {
	    eval 'sub PLOG {
	        my($lp,$fnx,$pe,$text,$rw) = @_;
    		eval q( &if (($lp) ->  &ll_events &  &LLOG_PDUS) {  &vpdu ($lp, $fnx, $pe, $text, $rw); }  &else);
	    }' unless defined(&PLOG);
	}
	if(defined(&lint)) {
	    undef(&PLOGP) if defined(&PLOGP);
	    eval 'sub PLOGP {
	        my($lp,$args,$pe,$text,$rw) = @_;
    		eval q( &if (($lp) ->  &ll_events &  &LLOG_PDUS) {  &_pvpdu ($lp, $pe, $text, $rw); }  &else);
	    }' unless defined(&PLOGP);
	    eval 'sub pvpdu {
	        my($lp,$cookie,$pe,$text,$rw) = @_;
    		eval q( &_pvpdu($lp, $pe, $text, $rw));
	    }' unless defined(&pvpdu);
	}
    } else {
	eval 'sub PLOG {
	    my($lp,$fnx,$pe,$text,$rw) = @_;
    	    eval q();
	}' unless defined(&PLOG);
	eval 'sub PLOGP {
	    my($lp,$args,$pe,$text,$rw) = @_;
    	    eval q();
	}' unless defined(&PLOGP);
    }
}
1;
