require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_module_SMI_defined_)) {
    eval 'sub _module_SMI_defined_ () {1;}' unless defined(&_module_SMI_defined_);
    unless(defined(&PEPSY_VERSION)) {
	eval 'sub PEPSY_VERSION () {2;}' unless defined(&PEPSY_VERSION);
    }
    require 'isode/psap.ph';
    require 'isode/pepsy.ph';
    require 'isode/pepsy/UNIV-types.ph';
    require 'isode/pepsy/SMI_defs.ph';
    eval 'sub type_SMI_ObjectName () { &OIDentifier;}' unless defined(&type_SMI_ObjectName);
    eval 'sub free_SMI_ObjectName () { &oid_free;}' unless defined(&free_SMI_ObjectName);
    eval 'sub type_SMI_NetworkAddress () { &type_SMI_IpAddress;}' unless defined(&type_SMI_NetworkAddress);
    eval 'sub free_SMI_NetworkAddress () { &free_SMI_IpAddress;}' unless defined(&free_SMI_NetworkAddress);
    eval 'sub type_SMI_IpAddress () { &qbuf;}' unless defined(&type_SMI_IpAddress);
    eval 'sub free_SMI_IpAddress () { &qb_free;}' unless defined(&free_SMI_IpAddress);
    eval 'sub type_SMI_Opaque () { &qbuf;}' unless defined(&type_SMI_Opaque);
    eval 'sub free_SMI_Opaque () { &qb_free;}' unless defined(&free_SMI_Opaque);
    eval 'sub type_SMI_DisplayString () { &qbuf;}' unless defined(&type_SMI_DisplayString);
    eval 'sub free_SMI_DisplayString () { &qb_free;}' unless defined(&free_SMI_DisplayString);
    eval 'sub type_SMI_ObjectSyntax_number () {1;}' unless defined(&type_SMI_ObjectSyntax_number);
    eval 'sub type_SMI_ObjectSyntax_string () {2;}' unless defined(&type_SMI_ObjectSyntax_string);
    eval 'sub type_SMI_ObjectSyntax_object () {3;}' unless defined(&type_SMI_ObjectSyntax_object);
    eval 'sub type_SMI_ObjectSyntax_empty () {4;}' unless defined(&type_SMI_ObjectSyntax_empty);
    eval 'sub type_SMI_ObjectSyntax_internet () {5;}' unless defined(&type_SMI_ObjectSyntax_internet);
    eval 'sub type_SMI_ObjectSyntax_counter () {6;}' unless defined(&type_SMI_ObjectSyntax_counter);
    eval 'sub type_SMI_ObjectSyntax_gauge () {7;}' unless defined(&type_SMI_ObjectSyntax_gauge);
    eval 'sub type_SMI_ObjectSyntax_ticks () {8;}' unless defined(&type_SMI_ObjectSyntax_ticks);
    eval 'sub type_SMI_ObjectSyntax_arbitrary () {9;}' unless defined(&type_SMI_ObjectSyntax_arbitrary);
    eval 'sub free_SMI_ObjectSyntax {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMI_mod->{md_dtab[&_ZObjectSyntaxSMI]}), & &_ZSMI_mod, 1));
    }' unless defined(&free_SMI_ObjectSyntax);
    eval 'sub type_SMI_SimpleSyntax_number () {1;}' unless defined(&type_SMI_SimpleSyntax_number);
    eval 'sub type_SMI_SimpleSyntax_string () {2;}' unless defined(&type_SMI_SimpleSyntax_string);
    eval 'sub type_SMI_SimpleSyntax_object () {3;}' unless defined(&type_SMI_SimpleSyntax_object);
    eval 'sub type_SMI_SimpleSyntax_empty () {4;}' unless defined(&type_SMI_SimpleSyntax_empty);
    eval 'sub free_SMI_SimpleSyntax {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMI_mod->{md_dtab[&_ZSimpleSyntaxSMI]}), & &_ZSMI_mod, 1));
    }' unless defined(&free_SMI_SimpleSyntax);
    eval 'sub type_SMI_ApplicationSyntax_internet () {1;}' unless defined(&type_SMI_ApplicationSyntax_internet);
    eval 'sub type_SMI_ApplicationSyntax_counter () {2;}' unless defined(&type_SMI_ApplicationSyntax_counter);
    eval 'sub type_SMI_ApplicationSyntax_gauge () {3;}' unless defined(&type_SMI_ApplicationSyntax_gauge);
    eval 'sub type_SMI_ApplicationSyntax_ticks () {4;}' unless defined(&type_SMI_ApplicationSyntax_ticks);
    eval 'sub type_SMI_ApplicationSyntax_arbitrary () {5;}' unless defined(&type_SMI_ApplicationSyntax_arbitrary);
    eval 'sub free_SMI_ApplicationSyntax {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMI_mod->{md_dtab[&_ZApplicationSyntaxSMI]}), & &_ZSMI_mod, 1));
    }' unless defined(&free_SMI_ApplicationSyntax);
    eval 'sub free_SMI_Counter {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMI_mod->{md_dtab[&_ZCounterSMI]}), & &_ZSMI_mod, 1));
    }' unless defined(&free_SMI_Counter);
    eval 'sub free_SMI_Gauge {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMI_mod->{md_dtab[&_ZGaugeSMI]}), & &_ZSMI_mod, 1));
    }' unless defined(&free_SMI_Gauge);
    eval 'sub free_SMI_TimeTicks {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMI_mod->{md_dtab[&_ZTimeTicksSMI]}), & &_ZSMI_mod, 1));
    }' unless defined(&free_SMI_TimeTicks);
}
1;
