require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SMI_defs_)) {
    eval 'sub _SMI_defs_ () {1;}' unless defined(&_SMI_defs_);
    require 'isode/pepsy/SMI_pre_defs.ph';
    unless(defined(&lint)) {
	eval 'sub encode_SMI_ObjectName {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZObjectNameSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_ObjectName);
	eval 'sub decode_SMI_ObjectName {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZObjectNameSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_ObjectName);
	eval 'sub print_SMI_ObjectName {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZObjectNameSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_ObjectName);
	eval 'sub print_SMI_ObjectName_P () { &_ZObjectNameSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_ObjectName_P);
	eval 'sub encode_SMI_ObjectSyntax {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZObjectSyntaxSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_ObjectSyntax);
	eval 'sub decode_SMI_ObjectSyntax {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZObjectSyntaxSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_ObjectSyntax);
	eval 'sub print_SMI_ObjectSyntax {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZObjectSyntaxSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_ObjectSyntax);
	eval 'sub print_SMI_ObjectSyntax_P () { &_ZObjectSyntaxSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_ObjectSyntax_P);
	eval 'sub encode_SMI_SimpleSyntax {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZSimpleSyntaxSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_SimpleSyntax);
	eval 'sub decode_SMI_SimpleSyntax {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZSimpleSyntaxSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_SimpleSyntax);
	eval 'sub print_SMI_SimpleSyntax {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZSimpleSyntaxSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_SimpleSyntax);
	eval 'sub print_SMI_SimpleSyntax_P () { &_ZSimpleSyntaxSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_SimpleSyntax_P);
	eval 'sub encode_SMI_ApplicationSyntax {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZApplicationSyntaxSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_ApplicationSyntax);
	eval 'sub decode_SMI_ApplicationSyntax {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZApplicationSyntaxSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_ApplicationSyntax);
	eval 'sub print_SMI_ApplicationSyntax {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZApplicationSyntaxSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_ApplicationSyntax);
	eval 'sub print_SMI_ApplicationSyntax_P () { &_ZApplicationSyntaxSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_ApplicationSyntax_P);
	eval 'sub encode_SMI_NetworkAddress {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZNetworkAddressSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_NetworkAddress);
	eval 'sub decode_SMI_NetworkAddress {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZNetworkAddressSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_NetworkAddress);
	eval 'sub print_SMI_NetworkAddress {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZNetworkAddressSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_NetworkAddress);
	eval 'sub print_SMI_NetworkAddress_P () { &_ZNetworkAddressSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_NetworkAddress_P);
	eval 'sub encode_SMI_IpAddress {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZIpAddressSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_IpAddress);
	eval 'sub decode_SMI_IpAddress {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZIpAddressSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_IpAddress);
	eval 'sub print_SMI_IpAddress {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZIpAddressSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_IpAddress);
	eval 'sub print_SMI_IpAddress_P () { &_ZIpAddressSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_IpAddress_P);
	eval 'sub encode_SMI_Counter {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZCounterSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_Counter);
	eval 'sub decode_SMI_Counter {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZCounterSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_Counter);
	eval 'sub print_SMI_Counter {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZCounterSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_Counter);
	eval 'sub print_SMI_Counter_P () { &_ZCounterSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_Counter_P);
	eval 'sub encode_SMI_Gauge {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZGaugeSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_Gauge);
	eval 'sub decode_SMI_Gauge {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZGaugeSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_Gauge);
	eval 'sub print_SMI_Gauge {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZGaugeSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_Gauge);
	eval 'sub print_SMI_Gauge_P () { &_ZGaugeSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_Gauge_P);
	eval 'sub encode_SMI_TimeTicks {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZTimeTicksSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_TimeTicks);
	eval 'sub decode_SMI_TimeTicks {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZTimeTicksSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_TimeTicks);
	eval 'sub print_SMI_TimeTicks {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZTimeTicksSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_TimeTicks);
	eval 'sub print_SMI_TimeTicks_P () { &_ZTimeTicksSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_TimeTicks_P);
	eval 'sub encode_SMI_Opaque {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZOpaqueSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_Opaque);
	eval 'sub decode_SMI_Opaque {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZOpaqueSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_Opaque);
	eval 'sub print_SMI_Opaque {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZOpaqueSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_Opaque);
	eval 'sub print_SMI_Opaque_P () { &_ZOpaqueSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_Opaque_P);
	eval 'sub encode_SMI_DisplayString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZDisplayStringSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SMI_DisplayString);
	eval 'sub decode_SMI_DisplayString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZDisplayStringSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SMI_DisplayString);
	eval 'sub print_SMI_DisplayString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZDisplayStringSMI, & &_ZSMI_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SMI_DisplayString);
	eval 'sub print_SMI_DisplayString_P () { &_ZDisplayStringSMI, & &_ZSMI_mod;}' unless defined(&print_SMI_DisplayString_P);
    }
}
1;
