require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_module_SMUX_defined_)) {
    eval 'sub _module_SMUX_defined_ () {1;}' unless defined(&_module_SMUX_defined_);
    unless(defined(&PEPSY_VERSION)) {
	eval 'sub PEPSY_VERSION () {2;}' unless defined(&PEPSY_VERSION);
    }
    require 'isode/psap.ph';
    require 'isode/pepsy.ph';
    require 'isode/pepsy/UNIV-types.ph';
    require 'isode/pepsy/SMUX_defs.ph';
    require 'isode/pepsy/SNMP-types.ph';
    require 'isode/pepsy/SMI-types.ph';
    eval 'sub type_SMUX_OpenPDU () { &type_SMUX_SimpleOpen;}' unless defined(&type_SMUX_OpenPDU);
    eval 'sub free_SMUX_OpenPDU () { &free_SMUX_SimpleOpen;}' unless defined(&free_SMUX_OpenPDU);
    eval 'sub type_SMUX_PDUs_simple () {1;}' unless defined(&type_SMUX_PDUs_simple);
    eval 'sub type_SMUX_PDUs_close () {2;}' unless defined(&type_SMUX_PDUs_close);
    eval 'sub type_SMUX_PDUs_registerRequest () {3;}' unless defined(&type_SMUX_PDUs_registerRequest);
    eval 'sub type_SMUX_PDUs_registerResponse () {4;}' unless defined(&type_SMUX_PDUs_registerResponse);
    eval 'sub type_SMUX_PDUs_get__request () {5;}' unless defined(&type_SMUX_PDUs_get__request);
    eval 'sub type_SMUX_PDUs_get__next__request () {6;}' unless defined(&type_SMUX_PDUs_get__next__request);
    eval 'sub type_SMUX_PDUs_get__response () {7;}' unless defined(&type_SMUX_PDUs_get__response);
    eval 'sub type_SMUX_PDUs_set__request () {8;}' unless defined(&type_SMUX_PDUs_set__request);
    eval 'sub type_SMUX_PDUs_trap () {9;}' unless defined(&type_SMUX_PDUs_trap);
    eval 'sub type_SMUX_PDUs_commitOrRollback () {10;}' unless defined(&type_SMUX_PDUs_commitOrRollback);
    eval 'sub free_SMUX_PDUs {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMUX_mod->{md_dtab[&_ZPDUsSMUX]}), & &_ZSMUX_mod, 1));
    }' unless defined(&free_SMUX_PDUs);
    eval 'sub int_SMUX_version_version__1 () {0;}' unless defined(&int_SMUX_version_version__1);
    eval 'sub free_SMUX_SimpleOpen {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMUX_mod->{md_dtab[&_ZSimpleOpenSMUX]}), & &_ZSMUX_mod, 1));
    }' unless defined(&free_SMUX_SimpleOpen);
    eval 'sub int_SMUX_ClosePDU_goingDown () {0;}' unless defined(&int_SMUX_ClosePDU_goingDown);
    eval 'sub int_SMUX_ClosePDU_unsupportedVersion () {1;}' unless defined(&int_SMUX_ClosePDU_unsupportedVersion);
    eval 'sub int_SMUX_ClosePDU_packetFormat () {2;}' unless defined(&int_SMUX_ClosePDU_packetFormat);
    eval 'sub int_SMUX_ClosePDU_protocolError () {3;}' unless defined(&int_SMUX_ClosePDU_protocolError);
    eval 'sub int_SMUX_ClosePDU_internalError () {4;}' unless defined(&int_SMUX_ClosePDU_internalError);
    eval 'sub int_SMUX_ClosePDU_authenticationFailure () {5;}' unless defined(&int_SMUX_ClosePDU_authenticationFailure);
    eval 'sub free_SMUX_ClosePDU {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMUX_mod->{md_dtab[&_ZClosePDUSMUX]}), & &_ZSMUX_mod, 1));
    }' unless defined(&free_SMUX_ClosePDU);
    eval 'sub int_SMUX_operation_delete () {0;}' unless defined(&int_SMUX_operation_delete);
    eval 'sub int_SMUX_operation_readOnly () {1;}' unless defined(&int_SMUX_operation_readOnly);
    eval 'sub int_SMUX_operation_readWrite () {2;}' unless defined(&int_SMUX_operation_readWrite);
    eval 'sub free_SMUX_RReqPDU {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMUX_mod->{md_dtab[&_ZRReqPDUSMUX]}), & &_ZSMUX_mod, 1));
    }' unless defined(&free_SMUX_RReqPDU);
    eval 'sub int_SMUX_RRspPDU_failure () {-1;}' unless defined(&int_SMUX_RRspPDU_failure);
    eval 'sub free_SMUX_RRspPDU {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMUX_mod->{md_dtab[&_ZRRspPDUSMUX]}), & &_ZSMUX_mod, 1));
    }' unless defined(&free_SMUX_RRspPDU);
    eval 'sub int_SMUX_SOutPDU_commit () {0;}' unless defined(&int_SMUX_SOutPDU_commit);
    eval 'sub int_SMUX_SOutPDU_rollback () {1;}' unless defined(&int_SMUX_SOutPDU_rollback);
    eval 'sub free_SMUX_SOutPDU {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSMUX_mod->{md_dtab[&_ZSOutPDUSMUX]}), & &_ZSMUX_mod, 1));
    }' unless defined(&free_SMUX_SOutPDU);
}
1;
