require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_module_SNMP_defined_)) {
    eval 'sub _module_SNMP_defined_ () {1;}' unless defined(&_module_SNMP_defined_);
    unless(defined(&PEPSY_VERSION)) {
	eval 'sub PEPSY_VERSION () {2;}' unless defined(&PEPSY_VERSION);
    }
    require 'isode/psap.ph';
    require 'isode/pepsy.ph';
    require 'isode/pepsy/UNIV-types.ph';
    require 'isode/pepsy/SNMP_defs.ph';
    require 'isode/pepsy/SMI-types.ph';
    eval 'sub type_SNMP_GetRequest__PDU () { &type_SNMP_PDU;}' unless defined(&type_SNMP_GetRequest__PDU);
    eval 'sub free_SNMP_GetRequest__PDU () { &free_SNMP_PDU;}' unless defined(&free_SNMP_GetRequest__PDU);
    eval 'sub type_SNMP_GetNextRequest__PDU () { &type_SNMP_PDU;}' unless defined(&type_SNMP_GetNextRequest__PDU);
    eval 'sub free_SNMP_GetNextRequest__PDU () { &free_SNMP_PDU;}' unless defined(&free_SNMP_GetNextRequest__PDU);
    eval 'sub type_SNMP_GetResponse__PDU () { &type_SNMP_PDU;}' unless defined(&type_SNMP_GetResponse__PDU);
    eval 'sub free_SNMP_GetResponse__PDU () { &free_SNMP_PDU;}' unless defined(&free_SNMP_GetResponse__PDU);
    eval 'sub type_SNMP_SetRequest__PDU () { &type_SNMP_PDU;}' unless defined(&type_SNMP_SetRequest__PDU);
    eval 'sub free_SNMP_SetRequest__PDU () { &free_SNMP_PDU;}' unless defined(&free_SNMP_SetRequest__PDU);
    eval 'sub int_SNMP_version_version__1 () {0;}' unless defined(&int_SNMP_version_version__1);
    eval 'sub free_SNMP_Message {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSNMP_mod->{md_dtab[&_ZMessageSNMP]}), & &_ZSNMP_mod, 1));
    }' unless defined(&free_SNMP_Message);
    eval 'sub type_SNMP_PDUs_get__request () {1;}' unless defined(&type_SNMP_PDUs_get__request);
    eval 'sub type_SNMP_PDUs_get__next__request () {2;}' unless defined(&type_SNMP_PDUs_get__next__request);
    eval 'sub type_SNMP_PDUs_get__response () {3;}' unless defined(&type_SNMP_PDUs_get__response);
    eval 'sub type_SNMP_PDUs_set__request () {4;}' unless defined(&type_SNMP_PDUs_set__request);
    eval 'sub type_SNMP_PDUs_trap () {5;}' unless defined(&type_SNMP_PDUs_trap);
    eval 'sub free_SNMP_PDUs {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSNMP_mod->{md_dtab[&_ZPDUsSNMP]}), & &_ZSNMP_mod, 1));
    }' unless defined(&free_SNMP_PDUs);
    eval 'sub int_SNMP_error__status_noError () {0;}' unless defined(&int_SNMP_error__status_noError);
    eval 'sub int_SNMP_error__status_tooBig () {1;}' unless defined(&int_SNMP_error__status_tooBig);
    eval 'sub int_SNMP_error__status_noSuchName () {2;}' unless defined(&int_SNMP_error__status_noSuchName);
    eval 'sub int_SNMP_error__status_badValue () {3;}' unless defined(&int_SNMP_error__status_badValue);
    eval 'sub int_SNMP_error__status_readOnly () {4;}' unless defined(&int_SNMP_error__status_readOnly);
    eval 'sub int_SNMP_error__status_genErr () {5;}' unless defined(&int_SNMP_error__status_genErr);
    eval 'sub free_SNMP_PDU {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSNMP_mod->{md_dtab[&_ZPDUSNMP]}), & &_ZSNMP_mod, 1));
    }' unless defined(&free_SNMP_PDU);
    eval 'sub int_SNMP_generic__trap_coldStart () {0;}' unless defined(&int_SNMP_generic__trap_coldStart);
    eval 'sub int_SNMP_generic__trap_warmStart () {1;}' unless defined(&int_SNMP_generic__trap_warmStart);
    eval 'sub int_SNMP_generic__trap_linkDown () {2;}' unless defined(&int_SNMP_generic__trap_linkDown);
    eval 'sub int_SNMP_generic__trap_linkUp () {3;}' unless defined(&int_SNMP_generic__trap_linkUp);
    eval 'sub int_SNMP_generic__trap_authenticationFailure () {4;}' unless defined(&int_SNMP_generic__trap_authenticationFailure);
    eval 'sub int_SNMP_generic__trap_egpNeighborLoss () {5;}' unless defined(&int_SNMP_generic__trap_egpNeighborLoss);
    eval 'sub int_SNMP_generic__trap_enterpriseSpecific () {6;}' unless defined(&int_SNMP_generic__trap_enterpriseSpecific);
    eval 'sub free_SNMP_Trap__PDU {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSNMP_mod->{md_dtab[&_ZTrap_PDUSNMP]}), & &_ZSNMP_mod, 1));
    }' unless defined(&free_SNMP_Trap__PDU);
    eval 'sub free_SNMP_VarBind {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSNMP_mod->{md_dtab[&_ZVarBindSNMP]}), & &_ZSNMP_mod, 1));
    }' unless defined(&free_SNMP_VarBind);
    eval 'sub free_SNMP_VarBindList {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZSNMP_mod->{md_dtab[&_ZVarBindListSNMP]}), & &_ZSNMP_mod, 1));
    }' unless defined(&free_SNMP_VarBindList);
}
1;
