require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_UNIV_defs_)) {
    eval 'sub _UNIV_defs_ () {1;}' unless defined(&_UNIV_defs_);
    require 'isode/pepsy/UNIV_pre_defs.ph';
    unless(defined(&lint)) {
	eval 'sub encode_UNIV_IA5String {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZIA5StringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_IA5String);
	eval 'sub decode_UNIV_IA5String {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZIA5StringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_IA5String);
	eval 'sub print_UNIV_IA5String {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZIA5StringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_IA5String);
	eval 'sub print_UNIV_IA5String_P () { &_ZIA5StringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_IA5String_P);
	eval 'sub encode_UNIV_NumericString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZNumericStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_NumericString);
	eval 'sub decode_UNIV_NumericString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZNumericStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_NumericString);
	eval 'sub print_UNIV_NumericString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZNumericStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_NumericString);
	eval 'sub print_UNIV_NumericString_P () { &_ZNumericStringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_NumericString_P);
	eval 'sub encode_UNIV_PrintableString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZPrintableStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_PrintableString);
	eval 'sub decode_UNIV_PrintableString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZPrintableStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_PrintableString);
	eval 'sub print_UNIV_PrintableString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZPrintableStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_PrintableString);
	eval 'sub print_UNIV_PrintableString_P () { &_ZPrintableStringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_PrintableString_P);
	eval 'sub encode_UNIV_T61String {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZT61StringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_T61String);
	eval 'sub decode_UNIV_T61String {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZT61StringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_T61String);
	eval 'sub print_UNIV_T61String {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZT61StringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_T61String);
	eval 'sub print_UNIV_T61String_P () { &_ZT61StringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_T61String_P);
	eval 'sub encode_UNIV_TeletexString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZTeletexStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_TeletexString);
	eval 'sub decode_UNIV_TeletexString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZTeletexStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_TeletexString);
	eval 'sub print_UNIV_TeletexString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZTeletexStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_TeletexString);
	eval 'sub print_UNIV_TeletexString_P () { &_ZTeletexStringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_TeletexString_P);
	eval 'sub encode_UNIV_VideotexString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZVideotexStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_VideotexString);
	eval 'sub decode_UNIV_VideotexString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZVideotexStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_VideotexString);
	eval 'sub print_UNIV_VideotexString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZVideotexStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_VideotexString);
	eval 'sub print_UNIV_VideotexString_P () { &_ZVideotexStringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_VideotexString_P);
	eval 'sub encode_UNIV_GeneralizedTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZGeneralizedTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_GeneralizedTime);
	eval 'sub decode_UNIV_GeneralizedTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZGeneralizedTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_GeneralizedTime);
	eval 'sub print_UNIV_GeneralizedTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZGeneralizedTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_GeneralizedTime);
	eval 'sub print_UNIV_GeneralizedTime_P () { &_ZGeneralizedTimeUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_GeneralizedTime_P);
	eval 'sub encode_UNIV_GeneralisedTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZGeneralisedTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_GeneralisedTime);
	eval 'sub decode_UNIV_GeneralisedTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZGeneralisedTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_GeneralisedTime);
	eval 'sub print_UNIV_GeneralisedTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZGeneralisedTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_GeneralisedTime);
	eval 'sub print_UNIV_GeneralisedTime_P () { &_ZGeneralisedTimeUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_GeneralisedTime_P);
	eval 'sub encode_UNIV_UTCTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZUTCTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_UTCTime);
	eval 'sub decode_UNIV_UTCTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZUTCTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_UTCTime);
	eval 'sub print_UNIV_UTCTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZUTCTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_UTCTime);
	eval 'sub print_UNIV_UTCTime_P () { &_ZUTCTimeUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_UTCTime_P);
	eval 'sub encode_UNIV_UniversalTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZUniversalTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_UniversalTime);
	eval 'sub decode_UNIV_UniversalTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZUniversalTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_UniversalTime);
	eval 'sub print_UNIV_UniversalTime {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZUniversalTimeUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_UniversalTime);
	eval 'sub print_UNIV_UniversalTime_P () { &_ZUniversalTimeUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_UniversalTime_P);
	eval 'sub encode_UNIV_GraphicString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZGraphicStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_GraphicString);
	eval 'sub decode_UNIV_GraphicString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZGraphicStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_GraphicString);
	eval 'sub print_UNIV_GraphicString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZGraphicStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_GraphicString);
	eval 'sub print_UNIV_GraphicString_P () { &_ZGraphicStringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_GraphicString_P);
	eval 'sub encode_UNIV_VisibleString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZVisibleStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_VisibleString);
	eval 'sub decode_UNIV_VisibleString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZVisibleStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_VisibleString);
	eval 'sub print_UNIV_VisibleString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZVisibleStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_VisibleString);
	eval 'sub print_UNIV_VisibleString_P () { &_ZVisibleStringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_VisibleString_P);
	eval 'sub encode_UNIV_ISO646String {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZISO646StringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_ISO646String);
	eval 'sub decode_UNIV_ISO646String {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZISO646StringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_ISO646String);
	eval 'sub print_UNIV_ISO646String {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZISO646StringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_ISO646String);
	eval 'sub print_UNIV_ISO646String_P () { &_ZISO646StringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_ISO646String_P);
	eval 'sub encode_UNIV_GeneralString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZGeneralStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_GeneralString);
	eval 'sub decode_UNIV_GeneralString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZGeneralStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_GeneralString);
	eval 'sub print_UNIV_GeneralString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZGeneralStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_GeneralString);
	eval 'sub print_UNIV_GeneralString_P () { &_ZGeneralStringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_GeneralString_P);
	eval 'sub encode_UNIV_CharacterString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZCharacterStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_CharacterString);
	eval 'sub decode_UNIV_CharacterString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZCharacterStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_CharacterString);
	eval 'sub print_UNIV_CharacterString {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZCharacterStringUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_CharacterString);
	eval 'sub print_UNIV_CharacterString_P () { &_ZCharacterStringUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_CharacterString_P);
	eval 'sub encode_UNIV_EXTERNAL {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZEXTERNALUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_EXTERNAL);
	eval 'sub decode_UNIV_EXTERNAL {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZEXTERNALUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_EXTERNAL);
	eval 'sub print_UNIV_EXTERNAL {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZEXTERNALUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_EXTERNAL);
	eval 'sub print_UNIV_EXTERNAL_P () { &_ZEXTERNALUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_EXTERNAL_P);
	eval 'sub encode_UNIV_ObjectDescriptor {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZObjectDescriptorUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_UNIV_ObjectDescriptor);
	eval 'sub decode_UNIV_ObjectDescriptor {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZObjectDescriptorUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_UNIV_ObjectDescriptor);
	eval 'sub print_UNIV_ObjectDescriptor {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZObjectDescriptorUNIV, & &_ZUNIV_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_UNIV_ObjectDescriptor);
	eval 'sub print_UNIV_ObjectDescriptor_P () { &_ZObjectDescriptorUNIV, & &_ZUNIV_mod;}' unless defined(&print_UNIV_ObjectDescriptor_P);
    }
}
1;
