require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PSAP_)) {
    eval 'sub _PSAP_ () {1;}' unless defined(&_PSAP_);
    unless(defined(&_MANIFEST_)) {
	require 'isode/manifest.ph';
    }
    unless(defined(&_GENERAL_)) {
	require 'isode/general.ph';
    }
    unless(defined(&OSX)) {
	unless(defined(&BSD42)) {
	    require 'time.ph';
	} else {
	    unless(defined(&timerisset)) {
		require 'sys/time.ph';
	    }
	}
    }
    require 'math.ph';
    eval 'sub NULLOID () {(( &OID) 0);}' unless defined(&NULLOID);
    eval 'sub oid2ode {
        my($i) = @_;
	    eval q( &oid2ode_aux (($i), 1));
    }' unless defined(&oid2ode);
    eval 'sub PE_ID_BITS () {14;}' unless defined(&PE_ID_BITS);
    eval 'sub PE_ID {
        my($class,$code) = @_;
	    eval q(( (((($code) & 0x3fff) << 2) | (($class) & 0x3))));
    }' unless defined(&PE_ID);
    eval 'sub NULLPED () {(( &PElementData) 0);}' unless defined(&NULLPED);
    eval 'sub PEDalloc {
        my($s) = @_;
	    eval q((( &PElementData)  &malloc ( ($s))));
    }' unless defined(&PEDalloc);
    eval 'sub PEDrealloc {
        my($p, $s) = @_;
	    eval q((( &PElementData)  &realloc ( , ($s))));
    }' unless defined(&PEDrealloc);
    eval 'sub PEDfree {
        my($p) = @_;
	    eval q( &free ( ($p)));
    }' unless defined(&PEDfree);
    eval 'sub PEDcmp {
        my($b1, $b2, $length) = @_;
	    eval q( &bcmp ( , , ($length)));
    }' unless defined(&PEDcmp);
    eval 'sub PEDcpy {
        my($b1, $b2, $length) = @_;
	    eval q( &bcopy ( , , ($length)));
    }' unless defined(&PEDcpy);
    eval 'sub PE_ERR_NONE () {0;}' unless defined(&PE_ERR_NONE);
    eval 'sub PE_ERR_OVER () {1;}' unless defined(&PE_ERR_OVER);
    eval 'sub PE_ERR_NMEM () {2;}' unless defined(&PE_ERR_NMEM);
    eval 'sub PE_ERR_BIT () {3;}' unless defined(&PE_ERR_BIT);
    eval 'sub PE_ERR_UTCT () {4;}' unless defined(&PE_ERR_UTCT);
    eval 'sub PE_ERR_GENT () {5;}' unless defined(&PE_ERR_GENT);
    eval 'sub PE_ERR_MBER () {6;}' unless defined(&PE_ERR_MBER);
    eval 'sub PE_ERR_PRIM () {7;}' unless defined(&PE_ERR_PRIM);
    eval 'sub PE_ERR_CONS () {8;}' unless defined(&PE_ERR_CONS);
    eval 'sub PE_ERR_TYPE () {9;}' unless defined(&PE_ERR_TYPE);
    eval 'sub PE_ERR_OID () {10;}' unless defined(&PE_ERR_OID);
    eval 'sub PE_ERR_BITS () {11;}' unless defined(&PE_ERR_BITS);
    eval 'sub PE_ERR_NOSUPP () {12;}' unless defined(&PE_ERR_NOSUPP);
    eval 'sub PE_ERR_SIGNED () {13;}' unless defined(&PE_ERR_SIGNED);
    eval 'sub PE_DFLT_CTX () {0;}' unless defined(&PE_DFLT_CTX);
    eval 'sub PE_ID_XTND () {0x1f;}' unless defined(&PE_ID_XTND);
    eval 'sub PE_ID_MORE () {0x80;}' unless defined(&PE_ID_MORE);
    eval 'sub PE_ID_MASK () {0x7f;}' unless defined(&PE_ID_MASK);
    eval 'sub PE_ID_SHIFT () {7;}' unless defined(&PE_ID_SHIFT);
    eval 'sub PE_CLASS_MASK () {0xc0;}' unless defined(&PE_CLASS_MASK);
    eval 'sub PE_CLASS_SHIFT () {6;}' unless defined(&PE_CLASS_SHIFT);
    eval 'sub PE_FORM_MASK () {0x20;}' unless defined(&PE_FORM_MASK);
    eval 'sub PE_FORM_SHIFT () {5;}' unless defined(&PE_FORM_SHIFT);
    eval 'sub PE_CODE_MASK () {0x1f;}' unless defined(&PE_CODE_MASK);
    eval 'sub PE_CODE_SHIFT () {0;}' unless defined(&PE_CODE_SHIFT);
    eval 'sub PE_CLASS_UNIV () {0x;}' unless defined(&PE_CLASS_UNIV);
    eval 'sub PE_CLASS_APPL () {0x1;}' unless defined(&PE_CLASS_APPL);
    eval 'sub PE_CLASS_CONT () {0x2;}' unless defined(&PE_CLASS_CONT);
    eval 'sub PE_CLASS_PRIV () {0x3;}' unless defined(&PE_CLASS_PRIV);
    eval 'sub PE_FORM_PRIM () {0x;}' unless defined(&PE_FORM_PRIM);
    eval 'sub PE_FORM_CONS () {0x1;}' unless defined(&PE_FORM_CONS);
    eval 'sub PE_FORM_ICONS () {0x2;}' unless defined(&PE_FORM_ICONS);
    eval 'sub PE_UNIV_EOC () {0x;}' unless defined(&PE_UNIV_EOC);
    eval 'sub PE_PRIM_BOOL () {0x1;}' unless defined(&PE_PRIM_BOOL);
    eval 'sub PE_PRIM_INT () {0x2;}' unless defined(&PE_PRIM_INT);
    eval 'sub PE_PRIM_BITS () {0x3;}' unless defined(&PE_PRIM_BITS);
    eval 'sub PE_PRIM_OCTS () {0x4;}' unless defined(&PE_PRIM_OCTS);
    eval 'sub PE_PRIM_NULL () {0x5;}' unless defined(&PE_PRIM_NULL);
    eval 'sub PE_PRIM_OID () {0x6;}' unless defined(&PE_PRIM_OID);
    eval 'sub PE_PRIM_ODE () {0x7;}' unless defined(&PE_PRIM_ODE);
    eval 'sub PE_CONS_EXTN () {0x8;}' unless defined(&PE_CONS_EXTN);
    eval 'sub PE_PRIM_REAL () {0x9;}' unless defined(&PE_PRIM_REAL);
    eval 'sub PE_PRIM_ENUM () {0xa;}' unless defined(&PE_PRIM_ENUM);
    eval 'sub PE_PRIM_ENCR () {0xb;}' unless defined(&PE_PRIM_ENCR);
    eval 'sub PE_CONS_SEQ () {0x10;}' unless defined(&PE_CONS_SEQ);
    eval 'sub PE_CONS_SET () {0x11;}' unless defined(&PE_CONS_SET);
    eval 'sub PE_DEFN_NUMS () {0x12;}' unless defined(&PE_DEFN_NUMS);
    eval 'sub PE_DEFN_PRTS () {0x13;}' unless defined(&PE_DEFN_PRTS);
    eval 'sub PE_DEFN_T61S () {0x14;}' unless defined(&PE_DEFN_T61S);
    eval 'sub PE_DEFN_VTXS () {0x15;}' unless defined(&PE_DEFN_VTXS);
    eval 'sub PE_DEFN_IA5S () {0x16;}' unless defined(&PE_DEFN_IA5S);
    eval 'sub PE_DEFN_UTCT () {0x17;}' unless defined(&PE_DEFN_UTCT);
    eval 'sub PE_DEFN_GENT () {0x18;}' unless defined(&PE_DEFN_GENT);
    eval 'sub PE_DEFN_GFXS () {0x19;}' unless defined(&PE_DEFN_GFXS);
    eval 'sub PE_DEFN_VISS () {0x1a;}' unless defined(&PE_DEFN_VISS);
    eval 'sub PE_DEFN_GENS () {0x1b;}' unless defined(&PE_DEFN_GENS);
    eval 'sub PE_DEFN_CHRS () {0x1c;}' unless defined(&PE_DEFN_CHRS);
    eval 'sub PE_LEN_XTND () {0x80;}' unless defined(&PE_LEN_XTND);
    eval 'sub PE_LEN_SMAX () {127;}' unless defined(&PE_LEN_SMAX);
    eval 'sub PE_LEN_MASK () {0x7f;}' unless defined(&PE_LEN_MASK);
    eval 'sub PE_LEN_INDF () {(-1);}' unless defined(&PE_LEN_INDF);
    eval 'sub pe_prim () { ($pe_un1->{un_pe_prim});}' unless defined(&pe_prim);
    eval 'sub pe_cons () { ($pe_un1->{un_pe_cons});}' unless defined(&pe_cons);
    eval 'sub pe_cardinal () { ($pe_un2->{un_pe_cardinal});}' unless defined(&pe_cardinal);
    eval 'sub pe_nbits () { ($pe_un2->{un_pe_nbits});}' unless defined(&pe_nbits);
    if(defined(&DEBUG)) {
    }
    eval 'sub NULLPE () {(( &PE) 0);}' unless defined(&NULLPE);
    eval 'sub NULLPEP () {(( &PE *) 0);}' unless defined(&NULLPEP);
    eval 'sub pe_seterr {
        my($pe, $e, $v) = @_;
	    eval q((($pe) ->  &pe_errno = ($e), ($v)));
    }' unless defined(&pe_seterr);
    if(defined(&DEBUG)) {
    }
    eval 'sub UT_NULL () {0x;}' unless defined(&UT_NULL);
    eval 'sub UT_ZONE () {0x1;}' unless defined(&UT_ZONE);
    eval 'sub UT_SEC () {0x2;}' unless defined(&UT_SEC);
    eval 'sub UT_USEC () {0x4;}' unless defined(&UT_USEC);
    eval 'sub NULLUTC () {(( &UTC) 0);}' unless defined(&NULLUTC);
    eval 'sub bool2prim {
        my($b) = @_;
	    eval q( &flag2prim (($b),  &PE_CLASS_UNIV,  &PE_PRIM_BOOL));
    }' unless defined(&bool2prim);
    eval 'sub int2prim {
        my($i) = @_;
	    eval q( &num2prim (( &integer) ($i),  &PE_CLASS_UNIV,  &PE_PRIM_INT));
    }' unless defined(&int2prim);
    eval 'sub prim2enum {
        my($i) = @_;
	    eval q( &prim2num(($i)));
    }' unless defined(&prim2enum);
    eval 'sub enum2prim {
        my($a,$b,$c) = @_;
	    eval q( &num2prim(($a), ($b), ($c)));
    }' unless defined(&enum2prim);
    eval 'sub enumint2prim {
        my($i) = @_;
	    eval q( &enum2prim (($i),  &PE_CLASS_UNIV,  &PE_PRIM_ENUM));
    }' unless defined(&enumint2prim);
    eval 'sub PE_REAL_FLAGS () {0300;}' unless defined(&PE_REAL_FLAGS);
    eval 'sub PE_REAL_BINENC () {0200;}' unless defined(&PE_REAL_BINENC);
    eval 'sub PE_REAL_DECENC () {0000;}' unless defined(&PE_REAL_DECENC);
    eval 'sub PE_REAL_SPECENC () {0100;}' unless defined(&PE_REAL_SPECENC);
    eval 'sub PE_REAL_B_S () {0100;}' unless defined(&PE_REAL_B_S);
    eval 'sub PE_REAL_B_BASE () {0060;}' unless defined(&PE_REAL_B_BASE);
    eval 'sub PE_REAL_B_B2 () {0000;}' unless defined(&PE_REAL_B_B2);
    eval 'sub PE_REAL_B_B8 () {0020;}' unless defined(&PE_REAL_B_B8);
    eval 'sub PE_REAL_B_B16 () {0040;}' unless defined(&PE_REAL_B_B16);
    eval 'sub PE_REAL_B_F () {0014;}' unless defined(&PE_REAL_B_F);
    eval 'sub PE_REAL_B_EXP () {0003;}' unless defined(&PE_REAL_B_EXP);
    eval 'sub PE_REAL_B_EF1 () {0000;}' unless defined(&PE_REAL_B_EF1);
    eval 'sub PE_REAL_B_EF2 () {0001;}' unless defined(&PE_REAL_B_EF2);
    eval 'sub PE_REAL_B_EF3 () {0002;}' unless defined(&PE_REAL_B_EF3);
    eval 'sub PE_REAL_B_EF4 () {0003;}' unless defined(&PE_REAL_B_EF4);
    eval 'sub PE_REAL_PLUSINF () {0200;}' unless defined(&PE_REAL_PLUSINF);
    eval 'sub PE_REAL_MINUSINF () {0201;}' unless defined(&PE_REAL_MINUSINF);
    unless(defined(&HUGE)) {
	if(defined(&MAXFLOAT)) {
	    eval 'sub PE_REAL_INFINITY () { &MAXFLOAT;}' unless defined(&PE_REAL_INFINITY);
	} else {
	    eval 'sub PE_REAL_INFINITY () {99. &e99;}' unless defined(&PE_REAL_INFINITY);
	}
    } else {
	eval 'sub PE_REAL_INFINITY () { &HUGE;}' unless defined(&PE_REAL_INFINITY);
    }
    eval 'sub double2prim {
        my($i) = @_;
	    eval q( &real2prim (($i),  &PE_CLASS_UNIV,  &PE_PRIM_REAL));
    }' unless defined(&double2prim);
    eval 'sub qb2prim {
        my($q,$c,$i) = @_;
	    eval q( &qb2prim_aux (($q), ($c), ($i), 0));
    }' unless defined(&qb2prim);
    eval 'sub oct2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_PRIM_OCTS));
    }' unless defined(&oct2prim);
    eval 'sub ia5s2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_DEFN_IA5S));
    }' unless defined(&ia5s2prim);
    eval 'sub nums2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_DEFN_NUMS));
    }' unless defined(&nums2prim);
    eval 'sub prts2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_DEFN_PRTS));
    }' unless defined(&prts2prim);
    eval 'sub t61s2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_DEFN_T61S));
    }' unless defined(&t61s2prim);
    eval 'sub vtxs2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_DEFN_VTXS));
    }' unless defined(&vtxs2prim);
    eval 'sub gfxs2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_DEFN_GFXS));
    }' unless defined(&gfxs2prim);
    eval 'sub viss2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_DEFN_VISS));
    }' unless defined(&viss2prim);
    eval 'sub gens2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_DEFN_GENS));
    }' unless defined(&gens2prim);
    eval 'sub chrs2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_DEFN_CHRS));
    }' unless defined(&chrs2prim);
    eval 'sub ode2prim {
        my($s,$len) = @_;
	    eval q( &str2prim (($s), ($len),  &PE_CLASS_UNIV,  &PE_PRIM_ODE));
    }' unless defined(&ode2prim);
    eval 'sub oid2prim {
        my($o) = @_;
	    eval q( &obj2prim (($o),  &PE_CLASS_UNIV,  &PE_PRIM_OID));
    }' unless defined(&oid2prim);
    eval 'sub prim2utct {
        my($pe) = @_;
	    eval q( &prim2time (($pe), 0));
    }' unless defined(&prim2utct);
    eval 'sub prim2gent {
        my($pe) = @_;
	    eval q( &prim2time (($pe), 1));
    }' unless defined(&prim2gent);
    eval 'sub utct2prim {
        my($u) = @_;
	    eval q( &time2prim (($u), 0,  &PE_CLASS_UNIV,  &PE_DEFN_UTCT));
    }' unless defined(&utct2prim);
    eval 'sub gent2prim {
        my($u) = @_;
	    eval q( &time2prim (($u), 1,  &PE_CLASS_UNIV,  &PE_DEFN_GENT));
    }' unless defined(&gent2prim);
    eval 'sub utct2str {
        my($u) = @_;
	    eval q( &time2str (($u), 0));
    }' unless defined(&utct2str);
    eval 'sub gent2str {
        my($u) = @_;
	    eval q( &time2str (($u), 1));
    }' unless defined(&gent2str);
    eval 'sub set2prim {
        my($pe) = @_;
	    eval q(($pe));
    }' unless defined(&set2prim);
    eval 'sub first_member {
        my($pe) = @_;
	    eval q((($pe) ->  &pe_cons));
    }' unless defined(&first_member);
    eval 'sub next_member {
        my($pe,$p) = @_;
	    eval q((($p) ->  &pe_next));
    }' unless defined(&next_member);
    eval 'sub prim2seq {
        my($pe) = @_;
	    eval q(( &prim2set ($pe)));
    }' unless defined(&prim2seq);
    eval 'sub seq2prim {
        my($pe) = @_;
	    eval q(($pe));
    }' unless defined(&seq2prim);
    eval 'sub PS_ERR_NONE () {0;}' unless defined(&PS_ERR_NONE);
    eval 'sub PS_ERR_OVERID () {1;}' unless defined(&PS_ERR_OVERID);
    eval 'sub PS_ERR_OVERLEN () {2;}' unless defined(&PS_ERR_OVERLEN);
    eval 'sub PS_ERR_NMEM () {3;}' unless defined(&PS_ERR_NMEM);
    eval 'sub PS_ERR_EOF () {4;}' unless defined(&PS_ERR_EOF);
    eval 'sub PS_ERR_EOFID () {5;}' unless defined(&PS_ERR_EOFID);
    eval 'sub PS_ERR_EOFLEN () {6;}' unless defined(&PS_ERR_EOFLEN);
    eval 'sub PS_ERR_LEN () {7;}' unless defined(&PS_ERR_LEN);
    eval 'sub PS_ERR_TRNC () {8;}' unless defined(&PS_ERR_TRNC);
    eval 'sub PS_ERR_INDF () {9;}' unless defined(&PS_ERR_INDF);
    eval 'sub PS_ERR_IO () {10;}' unless defined(&PS_ERR_IO);
    eval 'sub PS_ERR_EXTRA () {11;}' unless defined(&PS_ERR_EXTRA);
    eval 'sub PS_ERR_XXX () {12;}' unless defined(&PS_ERR_XXX);
    eval 'sub ps_addr () { ($ps_un->{un_ps_addr});}' unless defined(&ps_addr);
    eval 'sub ps_base () { ($ps_un->{un_ps_st}->{st_ps_base});}' unless defined(&ps_base);
    eval 'sub ps_cnt () { ($ps_un->{un_ps_st}->{st_ps_cnt});}' unless defined(&ps_cnt);
    eval 'sub ps_ptr () { ($ps_un->{un_ps_st}->{st_ps_ptr});}' unless defined(&ps_ptr);
    eval 'sub ps_bufsiz () { ($ps_un->{un_ps_st}->{st_ps_bufsiz});}' unless defined(&ps_bufsiz);
    eval 'sub ps_head () { ($ps_un->{un_ps_uv}->{uv_ps_head});}' unless defined(&ps_head);
    eval 'sub ps_cur () { ($ps_un->{un_ps_uv}->{uv_ps_cur});}' unless defined(&ps_cur);
    eval 'sub ps_end () { ($ps_un->{un_ps_uv}->{uv_ps_end});}' unless defined(&ps_end);
    eval 'sub ps_elems () { ($ps_un->{un_ps_uv}->{uv_ps_elems});}' unless defined(&ps_elems);
    eval 'sub ps_slop () { ($ps_un->{un_ps_uv}->{uv_ps_slop});}' unless defined(&ps_slop);
    eval 'sub ps_cc () { ($ps_un->{un_ps_uv}->{uv_ps_cc});}' unless defined(&ps_cc);
    eval 'sub NULLPS () {(( &PS) 0);}' unless defined(&NULLPS);
    eval 'sub ps_seterr {
        my($ps, $e, $v) = @_;
	    eval q((($ps) ->  &ps_errno = ($e), ($v)));
    }' unless defined(&ps_seterr);
    eval 'sub ps_read {
        my($ps, $data, $cc) = @_;
	    eval q( &ps_io (($ps), ($ps) ->  &ps_readP, ($data), ($cc), 0));
    }' unless defined(&ps_read);
    eval 'sub ps_write {
        my($ps, $data, $cc) = @_;
	    eval q( &ps_write_aux (($ps), ($data), ($cc), 0));
    }' unless defined(&ps_write);
    eval 'sub ps_write_aux {
        my($ps, $data, $cc, $in_line) = @_;
	    eval q( &ps_io (($ps), ($ps) ->  &ps_writeP, ($data), ($cc), ($in_line)));
    }' unless defined(&ps_write_aux);
    eval 'sub std_setup {
        my($ps, $fp) = @_;
	    eval q(( ->  &ps_addr = ($fp),  &OK));
    }' unless defined(&std_setup);
    eval 'sub qbuf_setup {
        my($ps, $qb) = @_;
	    eval q(( ->  &ps_addr = ($qb),  &OK));
    }' unless defined(&qbuf_setup);
    eval 'sub ts_open () { &dg_open;}' unless defined(&ts_open);
    eval 'sub ts_setup {
        my($p,$f,$s) = @_;
	    eval q( &dg_setup (($p), ($f), ($s),  &ts_read,  &ts_write));
    }' unless defined(&ts_setup);
    eval 'sub ps2pe {
        my($ps) = @_;
	    eval q( &ps2pe_aux (($ps), 1, 1));
    }' unless defined(&ps2pe);
    eval 'sub pe2ps {
        my($ps, $pe) = @_;
	    eval q( &pe2ps_aux (($ps), ($pe), 1));
    }' unless defined(&pe2ps);
    eval 'sub PS_LEN_SPAG () {0;}' unless defined(&PS_LEN_SPAG);
    eval 'sub PS_LEN_INDF () {1;}' unless defined(&PS_LEN_INDF);
    eval 'sub PS_LEN_LONG () {2;}' unless defined(&PS_LEN_LONG);
    eval 'sub qbuf2pe {
        my($qb, $len, $result) = @_;
	    eval q(( &Byteno = 0,  &Hqb = $qb,  &Fqb = ( &Qb = ($qb) ->  &qb_forw),  &qbuf2pe_f ($result)));
    }' unless defined(&qbuf2pe);
    if(defined(&PEPSY_VERSION)) {
	eval 'sub vunknown_P () {0, (( &modtyp *) 0);}' unless defined(&vunknown_P);
	if(defined( &_AIX)) {
	    eval 'sub vpdu {
	        my($lp,$fnx,$pe,$text,$rw) = @_;
    		eval q({  &pvpdu (($lp), $fnx &_P, ($pe), ($text), ($rw)); });
	    }' unless defined(&vpdu);
	} else {
	    eval 'sub vpdu {
	        my($lp,$fnx,$pe,$text,$rw) = @_;
    		eval q({  &pvpdu (($lp), $fnx  &_P, ($pe), ($text), ($rw)); });
	    }' unless defined(&vpdu);
	}
    } else {
	eval 'sub vpdu {
	    my($lp,$fnx,$pe,$text,$rw) = @_;
    	    eval q({ \'int\' $fnx ();  &_vpdu (($lp), $fnx, ($pe), ($text), ($rw)); });
	}' unless defined(&vpdu);
    }
    eval 'sub PEPY_ERR_BAD () {( $pepy_strings[0]);}' unless defined(&PEPY_ERR_BAD);
    eval 'sub PEPY_ERR_BAD_BITS () {( $pepy_strings[1]);}' unless defined(&PEPY_ERR_BAD_BITS);
    eval 'sub PEPY_ERR_BAD_BOOLEAN () {( $pepy_strings[2]);}' unless defined(&PEPY_ERR_BAD_BOOLEAN);
    eval 'sub PEPY_ERR_BAD_CLASS () {( $pepy_strings[3]);}' unless defined(&PEPY_ERR_BAD_CLASS);
    eval 'sub PEPY_ERR_BAD_CLASS_FORM_ID () {( $pepy_strings[4]);}' unless defined(&PEPY_ERR_BAD_CLASS_FORM_ID);
    eval 'sub PEPY_ERR_BAD_FORM () {( $pepy_strings[5]);}' unless defined(&PEPY_ERR_BAD_FORM);
    eval 'sub PEPY_ERR_BAD_INTEGER () {( $pepy_strings[6]);}' unless defined(&PEPY_ERR_BAD_INTEGER);
    eval 'sub PEPY_ERR_BAD_OID () {( $pepy_strings[7]);}' unless defined(&PEPY_ERR_BAD_OID);
    eval 'sub PEPY_ERR_BAD_OCTET () {( $pepy_strings[8]);}' unless defined(&PEPY_ERR_BAD_OCTET);
    eval 'sub PEPY_ERR_BAD_REAL () {( $pepy_strings[9]);}' unless defined(&PEPY_ERR_BAD_REAL);
    eval 'sub PEPY_ERR_BAD_SEQ () {( $pepy_strings[10]);}' unless defined(&PEPY_ERR_BAD_SEQ);
    eval 'sub PEPY_ERR_BAD_SET () {( $pepy_strings[11]);}' unless defined(&PEPY_ERR_BAD_SET);
    eval 'sub PEPY_ERR_TOO_MANY_BITS () {( $pepy_strings[12]);}' unless defined(&PEPY_ERR_TOO_MANY_BITS);
    eval 'sub PEPY_ERR_TOO_MANY_ELEMENTS () {( $pepy_strings[13]);}' unless defined(&PEPY_ERR_TOO_MANY_ELEMENTS);
    eval 'sub PEPY_ERR_UNKNOWN_CHOICE () {( $pepy_strings[14]);}' unless defined(&PEPY_ERR_UNKNOWN_CHOICE);
    eval 'sub PEPY_ERR_UNK_COMP () {( $pepy_strings[15]);}' unless defined(&PEPY_ERR_UNK_COMP);
    eval 'sub PEPY_ERR_INIT_FAILED () {( $pepy_strings[16]);}' unless defined(&PEPY_ERR_INIT_FAILED);
    eval 'sub PEPY_ERR_INVALID_CHOICE () {( $pepy_strings[17]);}' unless defined(&PEPY_ERR_INVALID_CHOICE);
    eval 'sub PEPY_ERR_MISSING () {( $pepy_strings[18]);}' unless defined(&PEPY_ERR_MISSING);
    eval 'sub PEPY_ERR_NOMEM () {( $pepy_strings[19]);}' unless defined(&PEPY_ERR_NOMEM);
    eval 'sub PEPY_ERR_TOO_MANY_TAGGED () {( $pepy_strings[20]);}' unless defined(&PEPY_ERR_TOO_MANY_TAGGED);
    eval 'sub PEPY_ERR_EXTRA_MEMBERS () {( $pepy_strings[21]);}' unless defined(&PEPY_ERR_EXTRA_MEMBERS);
}
1;
