require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RoPKT_)) {
    eval 'sub _RoPKT_ () {1;}' unless defined(&_RoPKT_);
    unless(defined(&_RoSAP_)) {
	require 'isode/rosap.ph';
    }
    require 'isode/acpkt.ph';
    unless(defined(&_RtSAP_)) {
	require 'isode/rtsap.ph';
    }
    unless(defined(&_PSAP2_)) {
	require 'isode/psap2.ph';
    }
    unless(defined(&_SSAP_)) {
	require 'isode/ssap.ph';
    }
    eval 'sub rosapPsig {
        my($acb, $sd) = @_;
	    eval q({  &if (($acb =  &findacblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_PARAMETER,  &NULLCP, \\"invalid association descriptor\\"); }  &if (!($acb ->  &acb_flags &  &ACB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"association descriptor not connected\\"); }  &if ($acb ->  &acb_flags &  &ACB_CLOSING) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_WAITING,  &NULLCP,  &NULLCP); }  &if ($acb ->  &acb_flags &  &ACB_FINN) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"association descriptor finishing\\"); }  &if ($acb ->  &acb_putosdu ==  &NULLIFP) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"association descriptor not bound\\"); } });
    }' unless defined(&rosapPsig);
    eval 'sub rosapXsig {
        my($acb, $sd) = @_;
	    eval q({  &if (($acb =  &findacblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_PARAMETER,  &NULLCP, \\"invalid association descriptor\\"); }  &if (!($acb ->  &acb_flags &  &ACB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"association descriptor not connected\\"); }  &if ($acb ->  &acb_flags &  &ACB_FINN) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"association descriptor finishing\\"); }  &if ($acb ->  &acb_putosdu ==  &NULLIFP) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"association descriptor not bound\\"); } });
    }' unless defined(&rosapXsig);
    eval 'sub rosapFsig {
        my($acb, $sd) = @_;
	    eval q({  &if (($acb =  &findacblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_PARAMETER,  &NULLCP, \\"invalid association descriptor\\"); }  &if (!($acb ->  &acb_flags &  &ACB_ROS)) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"not an association descriptor for ROS\\"); }  &if (!($acb ->  &acb_flags &  &ACB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"association descriptor not connected\\"); }  &if (!($acb ->  &acb_flags &  &ACB_FINN)) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"association descriptor not finishing\\"); }  &if ($acb ->  &acb_putosdu ==  &NULLIFP) { ( &void)  &sigiomask ( &smask);  &return  &rosaplose ( &roi,  &ROS_OPERATION,  &NULLCP, \\"association descriptor not bound\\"); } });
    }' unless defined(&rosapFsig);
    eval 'sub missingP {
        my($p) = @_;
	    eval q({  &if ($p ==  &NULL)  &return  &rosaplose ( &roi,  &ROS_PARAMETER,  &NULLCP, \\"mandatory parameter \\\\\\"%s\\\\\\" missing\\", \\"p\\"); });
    }' unless defined(&missingP);
    unless(defined(&lint)) {
	if(!defined( &_AIX)) {
	    eval 'sub copyRoSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d  &_cc =  &min ( &i,  &sizeof $d -> $d  &_data)) > 0)  &bcopy ($base, $d -> $d  &_data, $d -> $d  &_cc); });
	    }' unless defined(&copyRoSAPdata);
	} else {
	    eval 'sub copyRoSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d &_cc =  &min ( &i,  &sizeof $d -> $d &_data)) > 0)  &bcopy ($base, $d -> $d &_data, $d -> $d &_cc); });
	    }' unless defined(&copyRoSAPdata);
	}
    } else {
	eval 'sub copyRoSAPdata {
	    my($base,$len,$d) = @_;
    	    eval q( &bcopy ($base, $d, $len));
	}' unless defined(&copyRoSAPdata);
    }
    eval 'sub pylose () {
        eval q( &ropktlose ( &acb,  &roi,  &ROS_PROTOCOL,  &NULLCP, \\"%s\\",  &PY_pepy));
    }' unless defined(&pylose);
    eval 'sub APDU_INVOKE () {1;}' unless defined(&APDU_INVOKE);
    eval 'sub APDU_RESULT () {2;}' unless defined(&APDU_RESULT);
    eval 'sub APDU_ERROR () {3;}' unless defined(&APDU_ERROR);
    eval 'sub APDU_REJECT () {4;}' unless defined(&APDU_REJECT);
    eval 'sub APDU_UNKNOWN () {(-1);}' unless defined(&APDU_UNKNOWN);
    eval 'sub REJECT_GENERAL () {0;}' unless defined(&REJECT_GENERAL);
    eval 'sub REJECT_GENERAL_BASE () { &ROS_GP_UNRECOG;}' unless defined(&REJECT_GENERAL_BASE);
    eval 'sub REJECT_INVOKE () {1;}' unless defined(&REJECT_INVOKE);
    eval 'sub REJECT_INVOKE_BASE () { &ROS_IP_DUP;}' unless defined(&REJECT_INVOKE_BASE);
    eval 'sub REJECT_RESULT () {2;}' unless defined(&REJECT_RESULT);
    eval 'sub REJECT_RESULT_BASE () { &ROS_RRP_UNRECOG;}' unless defined(&REJECT_RESULT_BASE);
    eval 'sub REJECT_ERROR () {3;}' unless defined(&REJECT_ERROR);
    eval 'sub REJECT_ERROR_BASE () { &ROS_REP_UNRECOG;}' unless defined(&REJECT_ERROR_BASE);
    eval 'sub REJECT_COMPLETE () {4;}' unless defined(&REJECT_COMPLETE);
}
1;
