require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RtPKT_)) {
    eval 'sub _RtPKT_ () {1;}' unless defined(&_RtPKT_);
    unless(defined(&_RtSAP_)) {
	require 'isode/rtsap.ph';
    }
    require 'isode/acpkt.ph';
    unless(defined(&_SSAP_)) {
	require 'isode/ssap.ph';
    }
    eval 'sub rtsapPsig {
        my($acb, $sd) = @_;
	    eval q({  &if (($acb =  &findacblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &rtsaplose ( &rti,  &RTS_PARAMETER,  &NULLCP, \\"invalid association descriptor\\"); }  &if (!($acb ->  &acb_flags &  &ACB_RTS)) { ( &void)  &sigiomask ( &smask);  &return  &rtsaplose ( &rti,  &RTS_OPERATION,  &NULLCP, \\"not an association descriptor for RTS\\"); }  &if (!($acb ->  &acb_flags &  &ACB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &rtsaplose ( &rti,  &RTS_OPERATION,  &NULLCP, \\"association descriptor not connected\\"); }  &if ($acb ->  &acb_flags &  &ACB_FINN) { ( &void)  &sigiomask ( &smask);  &return  &rtsaplose ( &rti,  &RTS_OPERATION,  &NULLCP, \\"association descriptor finishing\\"); } });
    }' unless defined(&rtsapPsig);
    eval 'sub rtsapFsig {
        my($acb, $sd) = @_;
	    eval q({  &if (($acb =  &findacblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &rtsaplose ( &rti,  &RTS_PARAMETER,  &NULLCP, \\"invalid association descriptor\\"); }  &if (!($acb ->  &acb_flags &  &ACB_RTS)) { ( &void)  &sigiomask ( &smask);  &return  &rtsaplose ( &rti,  &RTS_OPERATION,  &NULLCP, \\"not an association descriptor for RTS\\"); }  &if (!($acb ->  &acb_flags &  &ACB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &rtsaplose ( &rti,  &RTS_OPERATION,  &NULLCP, \\"association descriptor not connected\\"); }  &if (!($acb ->  &acb_flags &  &ACB_FINN)) { ( &void)  &sigiomask ( &smask);  &return  &rtsaplose ( &rti,  &RTS_OPERATION,  &NULLCP, \\"association descriptor not finishing\\"); } });
    }' unless defined(&rtsapFsig);
    eval 'sub missingP {
        my($p) = @_;
	    eval q({  &if ($p ==  &NULL)  &return  &rtsaplose ( &rti,  &RTS_PARAMETER,  &NULLCP, \\"mandatory parameter \\\\\\"%s\\\\\\" missing\\", \\"p\\"); });
    }' unless defined(&missingP);
    unless(defined(&lint)) {
	if(!defined( &_AIX)) {
	    eval 'sub copyRtSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d  &_cc =  &min ( &i,  &sizeof $d -> $d  &_data)) > 0)  &bcopy ($base, $d -> $d  &_data, $d -> $d  &_cc); });
	    }' unless defined(&copyRtSAPdata);
	} else {
	    eval 'sub copyRtSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d &_cc =  &min ( &i,  &sizeof $d -> $d &_data)) > 0)  &bcopy ($base, $d -> $d &_data, $d -> $d &_cc); });
	    }' unless defined(&copyRtSAPdata);
	}
    } else {
	eval 'sub copyRtSAPdata {
	    my($base,$len,$d) = @_;
    	    eval q( &bcopy ($base, $d, $len));
	}' unless defined(&copyRtSAPdata);
    }
    eval 'sub pylose () {
        eval q( &rtpktlose ( &acb,  &rti,  &RTS_PROTOCOL,  &NULLCP, \\"%s\\",  &PY_pepy));
    }' unless defined(&pylose);
    eval 'sub DEFAULT_CKPOINT () {(65518>> 10);}' unless defined(&DEFAULT_CKPOINT);
    eval 'sub DEFAULT_WINDOW () { &PCONN_WD_DFLT;}' unless defined(&DEFAULT_WINDOW);
    eval 'sub RTS_MYREQUIRE () {( &SR_EXCEPTIONS |  &SR_ACTIVITY |  &SR_HALFDUPLEX |  &SR_MINORSYNC);}' unless defined(&RTS_MYREQUIRE);
    eval 'sub RT_ASN () {"rtse pci version 1";}' unless defined(&RT_ASN);
    eval 'sub SetPS2RtService {
        my($acb) = @_;
	    eval q({ ($acb) ->  &acb_pturnrequest =  &rt2pspturn; ($acb) ->  &acb_gturnrequest =  &rt2psgturn; ($acb) ->  &acb_transferequest =  &rt2pstrans; ($acb) ->  &acb_rtwaitrequest =  &rt2pswait; ($acb) ->  &acb_rtsetindications =  &rt2psasync; ($acb) ->  &acb_rtselectmask =  &rt2psmask; ($acb) ->  &acb_rtpktlose =  &rt2pslose; });
    }' unless defined(&SetPS2RtService);
    eval 'sub SetSS2RtService {
        my($acb) = @_;
	    eval q({ ($acb) ->  &acb_pturnrequest =  &rt2sspturn; ($acb) ->  &acb_gturnrequest =  &rt2ssgturn; ($acb) ->  &acb_transferequest =  &rt2sstrans; ($acb) ->  &acb_rtwaitrequest =  &rt2sswait; ($acb) ->  &acb_rtsetindications =  &rt2ssasync; ($acb) ->  &acb_rtselectmask =  &rt2ssmask; ($acb) ->  &acb_rtpktlose =  &rt2sslose; });
    }' unless defined(&SetSS2RtService);
    eval 'sub RTORQ_CKPOINT () {0;}' unless defined(&RTORQ_CKPOINT);
    eval 'sub RTORQ_CK_DFLT () {0;}' unless defined(&RTORQ_CK_DFLT);
    eval 'sub RTORQ_WINDOW () {1;}' unless defined(&RTORQ_WINDOW);
    eval 'sub RTORQ_WD_DFLT () {3;}' unless defined(&RTORQ_WD_DFLT);
    eval 'sub RTORQ_DIALOGUE () {2;}' unless defined(&RTORQ_DIALOGUE);
    eval 'sub RTORQ_DM_MONO () {0;}' unless defined(&RTORQ_DM_MONO);
    eval 'sub RTORQ_DM_TWA () {1;}' unless defined(&RTORQ_DM_TWA);
    eval 'sub RTORQ_DM_DFLT () { &RTORQ_DM_MONO;}' unless defined(&RTORQ_DM_DFLT);
    eval 'sub RTORQ_CONNDATA () {3;}' unless defined(&RTORQ_CONNDATA);
    eval 'sub RTORQ_CD_OPEN () {0;}' unless defined(&RTORQ_CD_OPEN);
    eval 'sub RTORQ_CD_RCVR () {1;}' unless defined(&RTORQ_CD_RCVR);
    eval 'sub RTOAC_CKPOINT () {0;}' unless defined(&RTOAC_CKPOINT);
    eval 'sub RTOAC_CK_DFLT () {0;}' unless defined(&RTOAC_CK_DFLT);
    eval 'sub RTOAC_WINDOW () {1;}' unless defined(&RTOAC_WINDOW);
    eval 'sub RTOAC_WD_DFLT () {3;}' unless defined(&RTOAC_WD_DFLT);
    eval 'sub RTOAC_CONNDATA () {2;}' unless defined(&RTOAC_CONNDATA);
    eval 'sub RTOAC_CD_OPEN () {0;}' unless defined(&RTOAC_CD_OPEN);
    eval 'sub RTOAC_CD_RCVR () {1;}' unless defined(&RTOAC_CD_RCVR);
    eval 'sub RTORJ_REFUSE () {0;}' unless defined(&RTORJ_REFUSE);
    eval 'sub RTORJ_USERDATA () {1;}' unless defined(&RTORJ_USERDATA);
    eval 'sub RTAB_REASON () {0;}' unless defined(&RTAB_REASON);
    eval 'sub RTAB_REFLECT () {1;}' unless defined(&RTAB_REFLECT);
    eval 'sub RTAB_USERDATA () {2;}' unless defined(&RTAB_USERDATA);
}
1;
