require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RtSAP_)) {
    eval 'sub _RtSAP_ () {1;}' unless defined(&_RtSAP_);
    unless(defined(&_MANIFEST_)) {
	require 'isode/manifest.ph';
    }
    unless(defined(&_GENERAL_)) {
	require 'isode/general.ph';
    }
    unless(defined(&_AcSAP_)) {
	require 'isode/acsap.ph';
    }
    eval 'sub NULLRtA () {( 0);}' unless defined(&NULLRtA);
    eval 'sub RTS_MONOLOGUE () {0;}' unless defined(&RTS_MONOLOGUE);
    eval 'sub RTS_TWA () {1;}' unless defined(&RTS_TWA);
    eval 'sub RTS_INITIATOR () {0;}' unless defined(&RTS_INITIATOR);
    eval 'sub RTS_RESPONDER () {1;}' unless defined(&RTS_RESPONDER);
    eval 'sub RTSFREE {
        my($rts) = @_;
	    eval q({  &if (($rts) ->  &rts_data)  &pe_free (($rts) ->  &rts_data), ($rts) ->  &rts_data =  &NULLPE;  &ACSFREE ((($rts) ->  &rts_start)); });
    }' unless defined(&RTSFREE);
    eval 'sub RTS_ACCEPT () {(-1);}' unless defined(&RTS_ACCEPT);
    eval 'sub RTS_BUSY () {0;}' unless defined(&RTS_BUSY);
    eval 'sub RTS_RECOVER () {1;}' unless defined(&RTS_RECOVER);
    eval 'sub RTS_VALIDATE () {2;}' unless defined(&RTS_VALIDATE);
    eval 'sub RTS_MODE () {3;}' unless defined(&RTS_MODE);
    eval 'sub RTS_REJECT () {4;}' unless defined(&RTS_REJECT);
    eval 'sub RTCFREE {
        my($rtc) = @_;
	    eval q({  &if (($rtc) ->  &rtc_data)  &pe_free (($rtc) ->  &rtc_data), ($rtc) ->  &rtc_data =  &NULLPE;  &ACCFREE ((($rtc) ->  &rtc_connect)); });
    }' unless defined(&RTCFREE);
    eval 'sub RTTFREE {
        my($rtt) = @_;
	    eval q({  &if (($rtt) ->  &rtt_data)  &pe_free (($rtt) ->  &rtt_data), ($rtt) ->  &rtt_data =  &NULLPE; });
    }' unless defined(&RTTFREE);
    eval 'sub RTS_ADDRESS () {5;}' unless defined(&RTS_ADDRESS);
    eval 'sub RTS_REFUSED () {6;}' unless defined(&RTS_REFUSED);
    eval 'sub RTS_SESSION () {7;}' unless defined(&RTS_SESSION);
    eval 'sub RTS_PROTOCOL () {8;}' unless defined(&RTS_PROTOCOL);
    eval 'sub RTS_CONGEST () {9;}' unless defined(&RTS_CONGEST);
    eval 'sub RTS_REMOTE () {10;}' unless defined(&RTS_REMOTE);
    eval 'sub RTS_PRESENTATION () {11;}' unless defined(&RTS_PRESENTATION);
    eval 'sub RTS_ACS () {12;}' unless defined(&RTS_ACS);
    eval 'sub RTS_ABORTED () {13;}' unless defined(&RTS_ABORTED);
    eval 'sub RTS_PARAMETER () {14;}' unless defined(&RTS_PARAMETER);
    eval 'sub RTS_OPERATION () {15;}' unless defined(&RTS_OPERATION);
    eval 'sub RTS_TIMER () {16;}' unless defined(&RTS_TIMER);
    eval 'sub RTS_WAITING () {17;}' unless defined(&RTS_WAITING);
    eval 'sub RTS_TRANSFER () {18;}' unless defined(&RTS_TRANSFER);
    eval 'sub RTS_FATAL {
        my($r) = @_;
	    eval q((($r) <  &RTS_PARAMETER));
    }' unless defined(&RTS_FATAL);
    eval 'sub RTS_OFFICIAL {
        my($r) = @_;
	    eval q((($r) <  &RTS_ADDRESS));
    }' unless defined(&RTS_OFFICIAL);
    eval 'sub RTA_SIZE () {512;}' unless defined(&RTA_SIZE);
    eval 'sub RTAFREE {
        my($rta) = @_;
	    eval q({  &if (($rta) ->  &rta_udata)  &pe_free (($rta) ->  &rta_udata), ($rta) ->  &rta_udata =  &NULLPE; });
    }' unless defined(&RTAFREE);
    eval 'sub RTI_TURN () {0x;}' unless defined(&RTI_TURN);
    eval 'sub RTI_TRANSFER () {0x1;}' unless defined(&RTI_TRANSFER);
    eval 'sub RTI_ABORT () {0x2;}' unless defined(&RTI_ABORT);
    eval 'sub RTI_CLOSE () {0x3;}' unless defined(&RTI_CLOSE);
    eval 'sub RTI_FINISH () {0x4;}' unless defined(&RTI_FINISH);
    eval 'sub rti_turn () { ($rti_un->{rti_un_turn});}' unless defined(&rti_turn);
    eval 'sub rti_transfer () { ($rti_un->{rti_un_transfer});}' unless defined(&rti_transfer);
    eval 'sub rti_abort () { ($rti_un->{rti_un_abort});}' unless defined(&rti_abort);
    eval 'sub rti_close () { ($rti_un->{rti_un_close});}' unless defined(&rti_close);
    eval 'sub rti_finish () { ($rti_un->{rti_un_finish});}' unless defined(&rti_finish);
    eval 'sub RtInit {
        my($vecp,$vec,$rts,$rti) = @_;
	    eval q( &RtInit_Aux(($vecp),($vec),($rts),($rti), &NULLOID));
    }' unless defined(&RtInit);
    eval 'sub RtOpenRequest {
        my($mode,$turn,$ctx,$ct1,$ct2,$ca1,$ca2,$ctxl,$defc,$data,$qos,$rtc,$rti) = @_;
	    eval q( &RtOpenRequest2(($mode),($turn),($ctx),($ct1),($ct2),($ca1),($ca2), ($ctxl),($defc),($data),($qos), &NULLOID,($rtc),($rti)));
    }' unless defined(&RtOpenRequest);
    eval 'sub RtBeginRequest {
        my($called, $mode, $turn, $data, $rtc, $rti) = @_;
	    eval q( &RtBeginRequest2(($called),  &NULLRtA, ($mode), ($turn), ($data), ($rtc), ($rti)));
    }' unless defined(&RtBeginRequest);
}
1;
