require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_TP4_)) {
    eval 'sub _TP4_ () {1;}' unless defined(&_TP4_);
    if(defined(&BSD_TP4)) {
	unless(defined(&SOCK_STREAM)) {
	    require 'sys/socket.ph';
	}
	require 'netiso/iso.ph';
	require 'netiso/iso_errno.ph';
	require 'netiso/tp_user.ph';
	eval 'sub CLTS () {1;}' unless defined(&CLTS);
	unless(defined(&_DGRAM_)) {
	    require 'isode/dgram.ph';
	}
	eval 'sub start_clts_client () { &start_clts_server;}' unless defined(&start_clts_client);
	eval 'sub join_clts_server {
	    my($fd,$sock) = @_;
    	    eval q( &join_dgram_aux (($fd),  ($sock), 0));
	}' unless defined(&join_clts_server);
	eval 'sub join_clts_client {
	    my($fd,$sock) = @_;
    	    eval q( &join_dgram_aux (($fd),  ($sock), 1));
	}' unless defined(&join_clts_client);
	eval 'sub read_clts_socket () { &read_dgram_socket;}' unless defined(&read_clts_socket);
	eval 'sub write_clts_socket () { &write_dgram_socket;}' unless defined(&write_clts_socket);
	eval 'sub close_clts_socket () { &close_dgram_socket;}' unless defined(&close_clts_socket);
	eval 'sub select_clts_socket () { &select_dgram_socket;}' unless defined(&select_clts_socket);
	eval 'sub check_clts_socket () { &check_dgram_socket;}' unless defined(&check_clts_socket);
    }
    if(defined(&SUN_TP4)) {
	if(defined( &SUNLINK_6_0)  && !defined( &SUNLINK_5_2)) {
	    eval 'sub SUNLINK_5_2 () {1;}' unless defined(&SUNLINK_5_2);
	}
	unless(defined(&SUNLINK_6_0)) {
	    require 'sys/ieee802.ph';
	} else {
	    require 'net/if_ieee802.ph';
	}
	unless(defined(&SOCK_STREAM)) {
	    require 'sys/socket.ph';
	}
	require 'netosi/osi.ph';
	if(defined(&SUNLINK_5_2)) {
	    require 'netosi/osi_profile.ph';
	}
	require 'netosi/osi_addr.ph';
	require 'netosi/osi_error.ph';
	require 'netosi/tp_event.ph';
	eval 'sub MSG_OOB () {0x1;}' unless defined(&MSG_OOB);
	eval 'sub tp4_event () { ($tp_un->{tp_msg}->{tp_event});}' unless defined(&tp4_event);
	eval 'sub tp4_called () { ($tp_un->{tp_connect}->{dst_address});}' unless defined(&tp4_called);
	eval 'sub tp4_calling () { ($tp_un->{tp_connect}->{src_address});}' unless defined(&tp4_calling);
	eval 'sub tp4_expedited () { ($tp_un->{tp_connect}->{expedited_selected});}' unless defined(&tp4_expedited);
	eval 'sub tp4_qos () { ($tp_un->{tp_connect}->{tp_qos});}' unless defined(&tp4_qos);
	eval 'sub tp4_eot () { ($tp_un->{tp_data}->{eot});}' unless defined(&tp4_eot);
	eval 'sub tp4_reason () { ($tp_un->{tp_disconnect}->{reason});}' unless defined(&tp4_reason);
	eval 'sub freetp4pkt {
	    my($tp) = @_;
    	    eval q( &cfree ( ($tp)));
	}' unless defined(&freetp4pkt);
    }
    if(defined(&BSD_TP4)) {
	eval 'sub close_tp4_socket () { &close;}' unless defined(&close_tp4_socket);
	eval 'sub select_tp4_socket () { &selsocket;}' unless defined(&select_tp4_socket);
    }
    if(defined(&SUN_TP4)) {
	eval 'sub close_tp4_socket () { &close;}' unless defined(&close_tp4_socket);
	eval 'sub select_tp4_socket () { &selsocket;}' unless defined(&select_tp4_socket);
    }
}
1;
