require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_TPKT_)) {
    eval 'sub _TPKT_ () {1;}' unless defined(&_TPKT_);
    require 'isode/tsap.ph';
    eval 'sub tsapPsig {
        my($tb, $sd) = @_;
	    eval q({  &if (($tb =  &findtblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &tsaplose ( &td,  &DR_PARAMETER,  &NULLCP, \\"invalid transport descriptor\\"); }  &if (!($tb ->  &tb_flags &  &TB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &tsaplose ( &td,  &DR_OPERATION,  &NULLCP, \\"transport descriptor not connected\\"); } });
    }' unless defined(&tsapPsig);
    eval 'sub missingP {
        my($p) = @_;
	    eval q({  &if ($p ==  &NULL)  &return  &tsaplose ( &td,  &DR_PARAMETER,  &NULLCP, \\"mandatory parameter \\\\\\"%s\\\\\\" missing\\", \\"p\\"); });
    }' unless defined(&missingP);
    eval 'sub toomuchP {
        my($b,$n,$m,$p) = @_;
	    eval q({  &if ($b ==  &NULL) $n = 0;  &else  &if ($n > $m)  &return  &tsaplose ( &td,  &DR_PARAMETER,  &NULLCP, \\"too much %s user data, %d octets\\", $p, $n); });
    }' unless defined(&toomuchP);
    eval 'sub copyTPKTdata {
        my($t,$base,$len) = @_;
	    eval q({  &register \'struct udvec\' * &uv = $t ->  &t_udvec;  &if ($len > 0)  &uv ->  &uv_base = $base,  &uv ->  &uv_len = $len,  &uv++;  &uv ->  &uv_base =  &NULL; });
    }' unless defined(&copyTPKTdata);
    unless(defined(&lint)) {
	if(!defined( &_AIX)) {
	    eval 'sub copyTSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d  &_cc =  &min ( &i,  &sizeof $d -> $d  &_data)) > 0)  &bcopy ($base, $d -> $d  &_data, $d -> $d  &_cc); });
	    }' unless defined(&copyTSAPdata);
	} else {
	    eval 'sub copyTSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d &_cc =  &min ( &i,  &sizeof $d -> $d &_data)) > 0)  &bcopy ($base, $d -> $d &_data, $d -> $d &_cc); });
	    }' unless defined(&copyTSAPdata);
	}
    } else {
	eval 'sub copyTSAPdata {
	    my($base,$len,$d) = @_;
    	    eval q( &bcopy ($base, $d, $len));
	}' unless defined(&copyTSAPdata);
    }
    eval 'sub NT_TCP () {ord(\'T\');}' unless defined(&NT_TCP);
    eval 'sub NT_X25 () {ord(\'X\');}' unless defined(&NT_X25);
    eval 'sub NT_BRG () {ord(\'G\');}' unless defined(&NT_BRG);
    eval 'sub NT_BSD () {ord(\'Z\');}' unless defined(&NT_BSD);
    eval 'sub NT_SUN () {ord(\'S\');}' unless defined(&NT_SUN);
    eval 'sub TB_NULL () {0x;}' unless defined(&TB_NULL);
    eval 'sub TB_CONN () {0x1;}' unless defined(&TB_CONN);
    eval 'sub TB_ASYN () {0x2;}' unless defined(&TB_ASYN);
    eval 'sub TB_EXPD () {0x4;}' unless defined(&TB_EXPD);
    eval 'sub TB_TCP () {0x8;}' unless defined(&TB_TCP);
    eval 'sub TB_X25 () {0x10;}' unless defined(&TB_X25);
    eval 'sub TB_BRG () {0x20;}' unless defined(&TB_BRG);
    eval 'sub TB_TP0 () {( &TB_TCP |  &TB_X25 |  &TB_BRG);}' unless defined(&TB_TP0);
    eval 'sub TB_TP4 () {0x40;}' unless defined(&TB_TP4);
    eval 'sub TB_QWRITES () {0x80;}' unless defined(&TB_QWRITES);
    if(defined(&MGMT)) {
    }
    eval 'sub NULLBP () {( 0);}' unless defined(&NULLBP);
    eval 'sub TPKT_VRSN () {3;}' unless defined(&TPKT_VRSN);
    eval 'sub TPKT_MAXLEN () {0xffff;}' unless defined(&TPKT_MAXLEN);
    eval 'sub t_vrsn () { ($t_pkthdr->{pk_vrsn});}' unless defined(&t_vrsn);
    eval 'sub t_rsrvd () { ($t_pkthdr->{pk_rsrvd});}' unless defined(&t_rsrvd);
    eval 'sub t_length () { ($t_pkthdr->{pk_length});}' unless defined(&t_length);
    eval 'sub TPKT_HDRLEN {
        my($t) = @_;
	    eval q(($sizeof{($t) ->  &t_pkthdr} + $sizeof{($t) ->  &t_li} + $sizeof{($t) ->  &t_code}));
    }' unless defined(&TPKT_HDRLEN);
    unless(defined(&lint)) {
	if(!defined( &_AIX)) {
	    eval 'sub TPDU_MINLEN {
	        my($t,$c) = @_;
    		eval q(($c  &_SIZE($t) + $sizeof{($t) ->  &t_code}));
	    }' unless defined(&TPDU_MINLEN);
	} else {
	    eval 'sub TPDU_MINLEN {
	        my($t,$c) = @_;
    		eval q(($c &_SIZE($t) + $sizeof{($t) ->  &t_code}));
	    }' unless defined(&TPDU_MINLEN);
	}
    } else {
	eval 'sub TPDU_MINLEN {
	    my($t,$c) = @_;
    	    eval q(($sizeof{($t) ->  &t_code}));
	}' unless defined(&TPDU_MINLEN);
    }
    eval 'sub TPDU_MAXLEN {
        my($t) = @_;
	    eval q(( &min (0xfe, ($t) ->  &t_length - $sizeof{($t) ->  &t_pkthdr} - $sizeof{($t) ->  &t_li})));
    }' unless defined(&TPDU_MAXLEN);
    eval 'sub TPDU_USRLEN {
        my($t) = @_;
	    eval q((($t) ->  &t_length - $sizeof{($t) ->  &t_pkthdr} - $sizeof{($t) ->  &t_li} - ($t) ->  &t_li));
    }' unless defined(&TPDU_USRLEN);
    eval 'sub TPDU_CODE {
        my($t) = @_;
	    eval q((($t) ->  &t_code & 0xf0));
    }' unless defined(&TPDU_CODE);
    eval 'sub TPDU_CR () {0xe0;}' unless defined(&TPDU_CR);
    eval 'sub TPDU_CC () {0xd0;}' unless defined(&TPDU_CC);
    eval 'sub TPDU_DR () {0x80;}' unless defined(&TPDU_DR);
    eval 'sub TPDU_DC () {0xc0;}' unless defined(&TPDU_DC);
    eval 'sub TPDU_DT () {0xf0;}' unless defined(&TPDU_DT);
    eval 'sub TPDU_ED () {0x10;}' unless defined(&TPDU_ED);
    eval 'sub TPDU_AK () {0x60;}' unless defined(&TPDU_AK);
    eval 'sub TPDU_EA () {0x20;}' unless defined(&TPDU_EA);
    eval 'sub TPDU_RJ () {0x50;}' unless defined(&TPDU_RJ);
    eval 'sub TPDU_ER () {0x70;}' unless defined(&TPDU_ER);
    eval 'sub CR_CLASS {
        my($t) = @_;
	    eval q((($t) ->  ($t_cr->{cr_class}) & 0xf0));
    }' unless defined(&CR_CLASS);
    eval 'sub CR_CLASS_TP0 () {0x;}' unless defined(&CR_CLASS_TP0);
    eval 'sub CR_CLASS_TP1 () {0x10;}' unless defined(&CR_CLASS_TP1);
    eval 'sub CR_CLASS_TP2 () {0x20;}' unless defined(&CR_CLASS_TP2);
    eval 'sub CR_CLASS_TP3 () {0x30;}' unless defined(&CR_CLASS_TP3);
    eval 'sub CR_CLASS_TP4 () {0x40;}' unless defined(&CR_CLASS_TP4);
    eval 'sub CR_OPT_EXTD () {0x2;}' unless defined(&CR_OPT_EXTD);
    eval 'sub CR_OPT_EXPL () {0x1;}' unless defined(&CR_OPT_EXPL);
    eval 'sub cr_dstref () { &un_cr_dstref;}' unless defined(&cr_dstref);
    eval 'sub cr_srcref () { &un_cr_srcref;}' unless defined(&cr_srcref);
    eval 'sub cr_class () { &un_cr_class;}' unless defined(&cr_class);
    eval 'sub cr_tpdusize () { &un_cr_tpdusize;}' unless defined(&cr_tpdusize);
    eval 'sub cr_options () { &un_cr_options;}' unless defined(&cr_options);
    eval 'sub cr_alternate () { &un_cr_alternate;}' unless defined(&cr_alternate);
    eval 'sub CR_SIZE {
        my($t) = @_;
	    eval q(5);
    }' unless defined(&CR_SIZE);
    eval 'sub un_cc () { &un_cr;}' unless defined(&un_cc);
    eval 'sub cc_dstref () { &un_cr_dstref;}' unless defined(&cc_dstref);
    eval 'sub cc_srcref () { &un_cr_srcref;}' unless defined(&cc_srcref);
    eval 'sub cc_class () { &un_cr_class;}' unless defined(&cc_class);
    eval 'sub cc_tpdusize () { &un_cr_tpdusize;}' unless defined(&cc_tpdusize);
    eval 'sub cc_options () { &un_cr_options;}' unless defined(&cc_options);
    eval 'sub CC_SIZE {
        my($t) = @_;
	    eval q(5);
    }' unless defined(&CC_SIZE);
    eval 'sub dr_dstref () { &un_dr_dstref;}' unless defined(&dr_dstref);
    eval 'sub dr_srcref () { &un_dr_srcref;}' unless defined(&dr_srcref);
    eval 'sub dr_reason () { &un_dr_reason;}' unless defined(&dr_reason);
    eval 'sub DR_SIZE {
        my($t) = @_;
	    eval q(5);
    }' unless defined(&DR_SIZE);
    eval 'sub DT_EOT () {0x80;}' unless defined(&DT_EOT);
    eval 'sub dt_nr () { &un_dt_nr;}' unless defined(&dt_nr);
    eval 'sub DT_SIZE {
        my($t) = @_;
	    eval q(1);
    }' unless defined(&DT_SIZE);
    eval 'sub DT_MAGIC () {(2+ 1);}' unless defined(&DT_MAGIC);
    eval 'sub un_ed () { &un_dt;}' unless defined(&un_ed);
    eval 'sub ed_nr () { &un_dt_nr;}' unless defined(&ed_nr);
    eval 'sub ED_SIZE {
        my($t) = @_;
	    eval q(1);
    }' unless defined(&ED_SIZE);
    eval 'sub ER_REJ_NOTSPECIFIED () {0x;}' unless defined(&ER_REJ_NOTSPECIFIED);
    eval 'sub ER_REJ_CODE () {0x1;}' unless defined(&ER_REJ_CODE);
    eval 'sub ER_REJ_TPDU () {0x2;}' unless defined(&ER_REJ_TPDU);
    eval 'sub ER_REJ_VALUE () {0x3;}' unless defined(&ER_REJ_VALUE);
    eval 'sub er_dstref () { &un_er_dstref;}' unless defined(&er_dstref);
    eval 'sub er_reject () { &un_er_reject;}' unless defined(&er_reject);
    eval 'sub ER_SIZE {
        my($t) = @_;
	    eval q(3);
    }' unless defined(&ER_SIZE);
    eval 'sub tp_cr () { ($tp_un->{un_cr});}' unless defined(&tp_cr);
    eval 'sub tp_cc () { ($tp_un->{un_cc});}' unless defined(&tp_cc);
    eval 'sub tp_dr () { ($tp_un->{un_dr});}' unless defined(&tp_dr);
    eval 'sub tp_dt () { ($tp_un->{un_dt});}' unless defined(&tp_dt);
    eval 'sub tp_ed () { ($tp_un->{un_ed});}' unless defined(&tp_ed);
    eval 'sub tp_er () { ($tp_un->{un_er});}' unless defined(&tp_er);
    eval 'sub NTPUV () {12;}' unless defined(&NTPUV);
    eval 'sub t_li () { ($t_tpdu->{tp_li});}' unless defined(&t_li);
    eval 'sub t_code () { ($t_tpdu->{tp_code});}' unless defined(&t_code);
    eval 'sub t_cr () { ($t_tpdu->{tp_un}->{un_cr});}' unless defined(&t_cr);
    eval 'sub t_called () { ($t_tpdu->{tp_un}->{un_cr}->{un_cr_called});}' unless defined(&t_called);
    eval 'sub t_calledlen () { ($t_tpdu->{tp_un}->{un_cr}->{un_cr_calledlen});}' unless defined(&t_calledlen);
    eval 'sub t_calling () { ($t_tpdu->{tp_un}->{un_cr}->{un_cr_calling});}' unless defined(&t_calling);
    eval 'sub t_callinglen () { ($t_tpdu->{tp_un}->{un_cr}->{un_cr_callinglen});}' unless defined(&t_callinglen);
    eval 'sub t_tpdusize () { ($t_tpdu->{tp_un}->{un_cr}->{un_cr_tpdusize});}' unless defined(&t_tpdusize);
    eval 'sub t_options () { ($t_tpdu->{tp_un}->{un_cr}->{un_cr_options});}' unless defined(&t_options);
    eval 'sub t_alternate () { ($t_tpdu->{tp_un}->{un_cr}->{un_cr_alternate});}' unless defined(&t_alternate);
    eval 'sub t_cc () { ($t_tpdu->{tp_un}->{un_cc});}' unless defined(&t_cc);
    eval 'sub t_dr () { ($t_tpdu->{tp_un}->{un_dr});}' unless defined(&t_dr);
    eval 'sub t_dt () { ($t_tpdu->{tp_un}->{un_dt});}' unless defined(&t_dt);
    eval 'sub t_ed () { ($t_tpdu->{tp_un}->{un_ed});}' unless defined(&t_ed);
    eval 'sub t_er () { ($t_tpdu->{tp_un}->{un_er});}' unless defined(&t_er);
    eval 'sub t_vdata () { ($t_tpdu->{tp_vbase});}' unless defined(&t_vdata);
    eval 'sub t_vlen () { ($t_tpdu->{tp_vlen});}' unless defined(&t_vlen);
    eval 'sub t_qbuf () { ($t_tpdu->{tp_qbuf});}' unless defined(&t_qbuf);
    eval 'sub t_udvec () { ($t_tpdu->{tp_udvec});}' unless defined(&t_udvec);
    eval 'sub NULLPKT () {( 0);}' unless defined(&NULLPKT);
    eval 'sub VDAT_TSAP_SRV () {0xc2;}' unless defined(&VDAT_TSAP_SRV);
    eval 'sub VDAT_TSAP_CLI () {0xc1;}' unless defined(&VDAT_TSAP_CLI);
    eval 'sub VDAT_SIZE () {0xc0;}' unless defined(&VDAT_SIZE);
    eval 'sub SIZE_8K () {0xd;}' unless defined(&SIZE_8K);
    eval 'sub SIZE_4K () {0xc;}' unless defined(&SIZE_4K);
    eval 'sub SIZE_2K () {0xb;}' unless defined(&SIZE_2K);
    eval 'sub SIZE_1K () {0xa;}' unless defined(&SIZE_1K);
    eval 'sub SIZE_512 () {0x9;}' unless defined(&SIZE_512);
    eval 'sub SIZE_256 () {0x8;}' unless defined(&SIZE_256);
    eval 'sub SIZE_128 () {0x7;}' unless defined(&SIZE_128);
    eval 'sub SIZE_DFLT () { &SIZE_128;}' unless defined(&SIZE_DFLT);
    eval 'sub SIZE_MAXTP0 () { &SIZE_2K;}' unless defined(&SIZE_MAXTP0);
    eval 'sub VDAT_VRSN () {0xc4;}' unless defined(&VDAT_VRSN);
    eval 'sub VDAT_SECURITY () {0xc5;}' unless defined(&VDAT_SECURITY);
    eval 'sub VDAT_CHECKSUM () {0xc3;}' unless defined(&VDAT_CHECKSUM);
    eval 'sub VDAT_OPTIONS () {0xc6;}' unless defined(&VDAT_OPTIONS);
    eval 'sub OPT_NEXPEDITE () {0x8;}' unless defined(&OPT_NEXPEDITE);
    eval 'sub OPT_CONFIRM () {0x4;}' unless defined(&OPT_CONFIRM);
    eval 'sub OPT_CHECKSUM () {0x2;}' unless defined(&OPT_CHECKSUM);
    eval 'sub OPT_TEXPEDITE () {0x1;}' unless defined(&OPT_TEXPEDITE);
    eval 'sub VDAT_ALTERNATE () {0xc7;}' unless defined(&VDAT_ALTERNATE);
    eval 'sub ALT_TP0 () {0x1;}' unless defined(&ALT_TP0);
    eval 'sub ALT_TP1 () {0x2;}' unless defined(&ALT_TP1);
    eval 'sub ALT_TP2 () {0x4;}' unless defined(&ALT_TP2);
    eval 'sub ALT_TP3 () {0x8;}' unless defined(&ALT_TP3);
    eval 'sub ALT_TP4 () {0x10;}' unless defined(&ALT_TP4);
    eval 'sub VDAT_ACKTIME () {0x85;}' unless defined(&VDAT_ACKTIME);
    eval 'sub VDAT_THROUGHPUT () {0x89;}' unless defined(&VDAT_THROUGHPUT);
    eval 'sub VDAT_ERRORATE () {0x86;}' unless defined(&VDAT_ERRORATE);
    eval 'sub VDAT_PRIORITY () {0x87;}' unless defined(&VDAT_PRIORITY);
    eval 'sub VDAT_DELAY () {0x88;}' unless defined(&VDAT_DELAY);
    eval 'sub VDAT_TTR () {0x8b;}' unless defined(&VDAT_TTR);
    eval 'sub VDAT_ADDITIONAL () {0xe0;}' unless defined(&VDAT_ADDITIONAL);
    eval 'sub VDAT_SUBSEQ () {0x8c;}' unless defined(&VDAT_SUBSEQ);
    eval 'sub VDAT_FLOWCTL () {0x8b;}' unless defined(&VDAT_FLOWCTL);
    eval 'sub VDAT_INVALID () {0xc1;}' unless defined(&VDAT_INVALID);
}
1;
