require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_J2_BUFMGR)) {
    eval 'sub _H_J2_BUFMGR () {1;}' unless defined(&_H_J2_BUFMGR);
    require 'sys/buf.ph';
    require 'sys/lock_def.ph';
    require 'j2/j2_lock.ph';
    eval 'sub PB_SYNCPT () {0x8000;}' unless defined(&PB_SYNCPT);
    eval 'sub PB_XSYNCPT () {0x4000;}' unless defined(&PB_XSYNCPT);
    eval 'sub PB_BUFFER () {0x8;}' unless defined(&PB_BUFFER);
    eval 'sub PB_TYPE () {0x7;}' unless defined(&PB_TYPE);
    eval 'sub PB_PAGE () {0x4;}' unless defined(&PB_PAGE);
    eval 'sub PB_BLOCK () {0x2;}' unless defined(&PB_BLOCK);
    eval 'sub PB_RAW () {0x1;}' unless defined(&PB_RAW);
    eval 'sub PB_METADATA () {0x1;}' unless defined(&PB_METADATA);
    eval 'sub PB_INUSE () {0x2;}' unless defined(&PB_INUSE);
    eval 'sub PB_PAGELOCK () { &PB_INUSE;}' unless defined(&PB_PAGELOCK);
    eval 'sub PB_PAGEIN () {0x4;}' unless defined(&PB_PAGEIN);
    eval 'sub PB_PAGEOUT () {0x8;}' unless defined(&PB_PAGEOUT);
    eval 'sub PB_IODONE () {0x10;}' unless defined(&PB_IODONE);
    eval 'sub PB_IOERROR () {0x20;}' unless defined(&PB_IOERROR);
    eval 'sub PB_NEW () {0x40;}' unless defined(&PB_NEW);
    eval 'sub PB_MODIFIED () {0x80;}' unless defined(&PB_MODIFIED);
    eval 'sub PB_LRU () {0x100;}' unless defined(&PB_LRU);
    eval 'sub PB_DISCARD () {0x200;}' unless defined(&PB_DISCARD);
    eval 'sub PB_FREE () {0x400;}' unless defined(&PB_FREE);
    eval 'sub PB_RDAHEAD () {0x800;}' unless defined(&PB_RDAHEAD);
    eval 'sub PB_HOLE () {0x1000;}' unless defined(&PB_HOLE);
    eval 'sub PB_ABNR () {0x2000;}' unless defined(&PB_ABNR);
    eval 'sub PB_READONLY () {0x4000;}' unless defined(&PB_READONLY);
    eval 'sub PB_READWRITE () {0x8000;}' unless defined(&PB_READWRITE);
    eval 'sub PB_PROBATIONARY () {0x10000;}' unless defined(&PB_PROBATIONARY);
    eval 'sub PB_HIT () {0x20000;}' unless defined(&PB_HIT);
    eval 'sub PB_SYNCPAGEOUT () {0x40000;}' unless defined(&PB_SYNCPAGEOUT);
    eval 'sub PB_LOCK () {0x80000;}' unless defined(&PB_LOCK);
    eval 'sub PB_PROXY () {0x100000;}' unless defined(&PB_PROXY);
    eval 'sub PB_DELEGATE () {0x200000;}' unless defined(&PB_DELEGATE);
    eval 'sub PB_SURROGATE () {0x400000;}' unless defined(&PB_SURROGATE);
    eval 'sub PB_MULTIOBJECT () {0x800000;}' unless defined(&PB_MULTIOBJECT);
    eval 'sub PB_SEGMENT () {0x1000000;}' unless defined(&PB_SEGMENT);
    eval 'sub PB_MDERROR () {0x2000000;}' unless defined(&PB_MDERROR);
    eval 'sub pb_cacheList () { ($_pb_u1->{_cacheList});}' unless defined(&pb_cacheList);
    eval 'sub pb_ioListNext () { ($_pb_u1->{_ioListNext});}' unless defined(&pb_ioListNext);
    eval 'sub pb_freeNext () { ($_pb_u1->{_freeNext});}' unless defined(&pb_freeNext);
    eval 'sub bmREAD_TYPE () { &PB_TYPE;}' unless defined(&bmREAD_TYPE);
    eval 'sub bmREAD_PAGE () { &PB_PAGE;}' unless defined(&bmREAD_PAGE);
    eval 'sub bmREAD_BLOCK () { &PB_BLOCK;}' unless defined(&bmREAD_BLOCK);
    eval 'sub bmREAD_RAW () { &PB_RAW;}' unless defined(&bmREAD_RAW);
    eval 'sub bmREAD_LOCK () {0x80000000;}' unless defined(&bmREAD_LOCK);
    eval 'sub bmASSIGN_READ () {0x10000000;}' unless defined(&bmASSIGN_READ);
    eval 'sub bmWRITE_FORCE () {0x1;}' unless defined(&bmWRITE_FORCE);
    eval 'sub bmWRITE_FLUSH () {0x2;}' unless defined(&bmWRITE_FLUSH);
    eval 'sub bmRECYCLE_WAIT () {0x1;}' unless defined(&bmRECYCLE_WAIT);
    eval 'sub IOQUEUE_READ {
        my($pbp) = @_;
	    eval q({  ($pbp->{pb_flags}) |=  &PB_PAGEIN;  ($pbp->{pb_flags}) &= ~ &PB_IODONE;});
    }' unless defined(&IOQUEUE_READ);
    eval 'sub IOQUEUE_WRITE {
        my($pbp) = @_;
	    eval q({  ($pbp->{pb_flags}) |=  &PB_PAGEOUT;  ($pbp->{pb_flags}) &= ~ &PB_IODONE;});
    }' unless defined(&IOQUEUE_WRITE);
    eval 'sub BM_WRITE () {0x1;}' unless defined(&BM_WRITE);
    eval 'sub BM_READ () {0x2;}' unless defined(&BM_READ);
    eval 'sub BM_LRU () {0x4;}' unless defined(&BM_LRU);
    eval 'sub LVMTRACK () {128*1024;}' unless defined(&LVMTRACK);
    if(defined(&_KERNEL)) {
    }
}
1;
