require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_J2_FILSYS)) {
    eval 'sub _H_J2_FILSYS () {1;}' unless defined(&_H_J2_FILSYS);
    require 'j2/j2_types.ph';
    eval 'sub MINJ2 () {0x1000000;}' unless defined(&MINJ2);
    unless(defined(&PSIZE)) {
	eval 'sub PSIZE () {4096;}' unless defined(&PSIZE);
	eval 'sub L2PSIZE () {12;}' unless defined(&L2PSIZE);
	eval 'sub POFFSET () {4095;}' unless defined(&POFFSET);
    }
    eval 'sub jBPSIZE () {4096;}' unless defined(&jBPSIZE);
    eval 'sub BPSIZE () { &jBPSIZE;}' unless defined(&BPSIZE);
    eval 'sub L2jBPSIZE () {12;}' unless defined(&L2jBPSIZE);
    eval 'sub L2BPSIZE () { &L2jBPSIZE;}' unless defined(&L2BPSIZE);
    eval 'sub BPOFFSET () {4095;}' unless defined(&BPOFFSET);
    unless(defined(&DBSIZE)) {
	eval 'sub DBSIZE () {512;}' unless defined(&DBSIZE);
	eval 'sub L2DBSIZE () {9;}' unless defined(&L2DBSIZE);
    }
    eval 'sub MIN_FS_BLKSIZE () { &DBSIZE;}' unless defined(&MIN_FS_BLKSIZE);
    eval 'sub MAX_FS_BLKSIZE () { &PSIZE;}' unless defined(&MAX_FS_BLKSIZE);
    eval 'sub MAX_FILESIZE () {(1099511623680);}' unless defined(&MAX_FILESIZE);
    eval 'sub MAX_DATAPAGE_NUM () {(( &MAX_FILESIZE >>  &L2PSIZE) - 1);}' unless defined(&MAX_DATAPAGE_NUM);
    eval 'sub jDISIZE () {512;}' unless defined(&jDISIZE);
    eval 'sub L2jDISIZE () {9;}' unless defined(&L2jDISIZE);
    eval 'sub IDATASIZE () {256;}' unless defined(&IDATASIZE);
    eval 'sub IEASIZE () {128;}' unless defined(&IEASIZE);
    eval 'sub J2_NAME_MAX () {255;}' unless defined(&J2_NAME_MAX);
    eval 'sub J2_PATH_MAX () { &jBPSIZE;}' unless defined(&J2_PATH_MAX);
    eval 'sub SUPERBLK_SIZE () { &jBPSIZE;}' unless defined(&SUPERBLK_SIZE);
    eval 'sub IAG_SIZE () {4096;}' unless defined(&IAG_SIZE);
    eval 'sub INODE_MAP_PAGE_SIZE () { &IAG_SIZE;}' unless defined(&INODE_MAP_PAGE_SIZE);
    eval 'sub IAG_EXTENT_SIZE () { &IAG_SIZE;}' unless defined(&IAG_EXTENT_SIZE);
    eval 'sub INOSPERIAG () {4096;}' unless defined(&INOSPERIAG);
    eval 'sub L2INOSPERIAG () {12;}' unless defined(&L2INOSPERIAG);
    eval 'sub INOSPEREXT () {32;}' unless defined(&INOSPEREXT);
    eval 'sub L2INOSPEREXT () {5;}' unless defined(&L2INOSPEREXT);
    eval 'sub INODE_EXTENT_SIZE () {( &jDISIZE *  &INOSPEREXT);}' unless defined(&INODE_EXTENT_SIZE);
    eval 'sub INOSPERPAGE () {8;}' unless defined(&INOSPERPAGE);
    eval 'sub L2INOSPERPAGE () {3;}' unless defined(&L2INOSPERPAGE);
    eval 'sub IPL_B () {0;}' unless defined(&IPL_B);
    eval 'sub AGGR_RSVD_BYTES () {0x8000;}' unless defined(&AGGR_RSVD_BYTES);
    eval 'sub SUPER1_OFF () { &AGGR_RSVD_BYTES;}' unless defined(&SUPER1_OFF);
    eval 'sub AIMAP_OFF () {( &SUPER1_OFF +  &SUPERBLK_SIZE);}' unless defined(&AIMAP_OFF);
    eval 'sub AITBL_OFF () {( &AIMAP_OFF + ( &IAG_SIZE << 1));}' unless defined(&AITBL_OFF);
    eval 'sub AGGR_INODE_TABLE_START () { &AITBL_OFF;}' unless defined(&AGGR_INODE_TABLE_START);
    eval 'sub SUPER2_OFF () {( &AITBL_OFF +  &INODE_EXTENT_SIZE);}' unless defined(&SUPER2_OFF);
    eval 'sub BMAP_OFF () {( &SUPER2_OFF +  &SUPERBLK_SIZE);}' unless defined(&BMAP_OFF);
    eval 'sub AGGR_RESERVED_I () {0;}' unless defined(&AGGR_RESERVED_I);
    eval 'sub AGGREGATE_I () {1;}' unless defined(&AGGREGATE_I);
    eval 'sub BMAP_I () {2;}' unless defined(&BMAP_I);
    eval 'sub LOG_I () {3;}' unless defined(&LOG_I);
    eval 'sub BADBLOCK_I () {4;}' unless defined(&BADBLOCK_I);
    eval 'sub FILESYSTEM_I () {16;}' unless defined(&FILESYSTEM_I);
    eval 'sub AGGR_RESERVED_I2 () { &AGGR_RESERVED_I +  &INOSPEREXT;}' unless defined(&AGGR_RESERVED_I2);
    eval 'sub AGGREGATE_I2 () { &AGGREGATE_I +  &INOSPEREXT;}' unless defined(&AGGREGATE_I2);
    eval 'sub BMAP_I2 () { &BMAP_I +  &INOSPEREXT;}' unless defined(&BMAP_I2);
    eval 'sub LOG_I2 () { &LOG_I +  &INOSPEREXT;}' unless defined(&LOG_I2);
    eval 'sub BADBLOCK_I2 () { &BADBLOCK_I +  &INOSPEREXT;}' unless defined(&BADBLOCK_I2);
    eval 'sub FILESYSTEM_I2 () { &FILESYSTEM_I +  &INOSPEREXT;}' unless defined(&FILESYSTEM_I2);
    eval 'sub FILESET_RSVD_I () {0;}' unless defined(&FILESET_RSVD_I);
    eval 'sub FILESET_EXT_I () {1;}' unless defined(&FILESET_EXT_I);
    eval 'sub ROOT_I () {(( &ino64_t)2);}' unless defined(&ROOT_I);
    eval 'sub FILESET_OBJECT_I () {3;}' unless defined(&FILESET_OBJECT_I);
    eval 'sub FIRST_FILESET_INO () {16;}' unless defined(&FIRST_FILESET_INO);
    eval 'sub MNT_JFS2 () {0;}' unless defined(&MNT_JFS2);
    eval 'sub J2_AIX () {0x80000000;}' unless defined(&J2_AIX);
    eval 'sub J2_OS2 () {0x40000000;}' unless defined(&J2_OS2);
    eval 'sub J2_DFS () {0x20000000;}' unless defined(&J2_DFS);
    eval 'sub J2_SPARSE () {0x20000;}' unless defined(&J2_SPARSE);
    eval 'sub J2_UNICODE () {0x1;}' unless defined(&J2_UNICODE);
    eval 'sub J2_COMMIT () {0x300;}' unless defined(&J2_COMMIT);
    eval 'sub J2_GROUPCOMMIT () {0x100;}' unless defined(&J2_GROUPCOMMIT);
    eval 'sub J2_LAZYCOMMIT () {0x200;}' unless defined(&J2_LAZYCOMMIT);
    eval 'sub J2_TMPFS () {0x400;}' unless defined(&J2_TMPFS);
    eval 'sub J2_BAD_SAIT () {0x10000;}' unless defined(&J2_BAD_SAIT);
    eval 'sub J2_INLINELOG () {0x800;}' unless defined(&J2_INLINELOG);
    eval 'sub FM_CLEAN () {0x;}' unless defined(&FM_CLEAN);
    eval 'sub FM_MOUNT () {0x1;}' unless defined(&FM_MOUNT);
    eval 'sub FM_DIRTY () {0x2;}' unless defined(&FM_DIRTY);
    eval 'sub FM_LOGREDO () {0x4;}' unless defined(&FM_LOGREDO);
    eval 'sub FM_EXTENDFS () {0x8;}' unless defined(&FM_EXTENDFS);
    eval 'sub FM_MOVEINLINELOG () {0x10;}' unless defined(&FM_MOVEINLINELOG);
    eval 'sub LBSIZE {
        my($ipmnt) = @_;
	    eval q((($ipmnt)-> &i_bsize));
    }' unless defined(&LBSIZE);
    eval 'sub L2LBSIZE {
        my($ipmnt) = @_;
	    eval q((($ipmnt)-> &i_l2bsize));
    }' unless defined(&L2LBSIZE);
    eval 'sub LBOFFSET {
        my($ipmnt, $x) = @_;
	    eval q((($x) & (($ipmnt)-> &i_bsize - 1)));
    }' unless defined(&LBOFFSET);
    eval 'sub LBNUMBER {
        my($ipmnt, $x) = @_;
	    eval q((($x) >> ($ipmnt)-> &i_l2bsize));
    }' unless defined(&LBNUMBER);
    eval 'sub LBLK2PBLK {
        my($ipmnt, $b) = @_;
	    eval q((($b) << ($ipmnt)-> &i_l2bfactor));
    }' unless defined(&LBLK2PBLK);
    eval 'sub PBLK2LBLK {
        my($ipmnt, $b) = @_;
	    eval q((($b) >> ($ipmnt)-> &i_l2bfactor));
    }' unless defined(&PBLK2LBLK);
    eval 'sub SIZE2PN {
        my($size) = @_;
	    eval q(( (( &int64)(($size) - 1)) >> ( &L2PSIZE) ));
    }' unless defined(&SIZE2PN);
    eval 'sub SIZE2BN {
        my($size, $l2bsize) = @_;
	    eval q(( (( &int64)(($size) - 1)) >> ($l2bsize) ));
    }' unless defined(&SIZE2BN);
    eval 'sub J2_CNTL () {0x101;}' unless defined(&J2_CNTL);
    eval 'sub J2_MOUNT () {0x102;}' unless defined(&J2_MOUNT);
    eval 'sub J2_ROOT () {0x103;}' unless defined(&J2_ROOT);
    eval 'sub J2_SETLABEL () {0x106;}' unless defined(&J2_SETLABEL);
    eval 'sub J2_STATFS () {0x104;}' unless defined(&J2_STATFS);
    eval 'sub J2_SYNC () {0x105;}' unless defined(&J2_SYNC);
    eval 'sub J2_SYSINFO () {0x106;}' unless defined(&J2_SYSINFO);
    eval 'sub J2_UNMOUNT () {0x107;}' unless defined(&J2_UNMOUNT);
    eval 'sub J2_VGET () {0x108;}' unless defined(&J2_VGET);
    eval 'sub J2_ACCESS () {0x1;}' unless defined(&J2_ACCESS);
    eval 'sub J2_CLOSE () {0x2;}' unless defined(&J2_CLOSE);
    eval 'sub J2_CREATE () {0x3;}' unless defined(&J2_CREATE);
    eval 'sub J2_FID () {0x4;}' unless defined(&J2_FID);
    eval 'sub J2_FINDDIR () {0x5;}' unless defined(&J2_FINDDIR);
    eval 'sub J2_FSYNC () {0x6;}' unless defined(&J2_FSYNC);
    eval 'sub J2_FTRUNC () {0x7;}' unless defined(&J2_FTRUNC);
    eval 'sub J2_GETACL () {0x8;}' unless defined(&J2_GETACL);
    eval 'sub J2_GETATTR () {0x9;}' unless defined(&J2_GETATTR);
    eval 'sub J2_GETEXTATTR () {0xa;}' unless defined(&J2_GETEXTATTR);
    eval 'sub J2_GROW () {0xb;}' unless defined(&J2_GROW);
    eval 'sub J2_HOLD () {0xc;}' unless defined(&J2_HOLD);
    eval 'sub J2_LINK () {0xd;}' unless defined(&J2_LINK);
    eval 'sub J2_LOCKCTL () {0xe;}' unless defined(&J2_LOCKCTL);
    eval 'sub J2_LOOKUP () {0xf;}' unless defined(&J2_LOOKUP);
    eval 'sub J2_MKDIR () {0x10;}' unless defined(&J2_MKDIR);
    eval 'sub J2_OPEN () {0x20;}' unless defined(&J2_OPEN);
    eval 'sub J2_RDWR () {0x30;}' unless defined(&J2_RDWR);
    eval 'sub J2_READDIR () {0x40;}' unless defined(&J2_READDIR);
    eval 'sub J2_READLINK () {0x50;}' unless defined(&J2_READLINK);
    eval 'sub J2_RELE () {0x60;}' unless defined(&J2_RELE);
    eval 'sub J2_REMOVE () {0x70;}' unless defined(&J2_REMOVE);
    eval 'sub J2_RENAME () {0x80;}' unless defined(&J2_RENAME);
    eval 'sub J2_RMDIR () {0x90;}' unless defined(&J2_RMDIR);
    eval 'sub J2_SETACL () {0xa0;}' unless defined(&J2_SETACL);
    eval 'sub J2_SETATTR () {0xb0;}' unless defined(&J2_SETATTR);
    eval 'sub J2_SETEXTATTR () {0xc0;}' unless defined(&J2_SETEXTATTR);
    eval 'sub J2_SYMLINK () {0xd0;}' unless defined(&J2_SYMLINK);
    if(defined(&_KERNEL)) {
	eval 'sub J2_UNCONFIGURED () {0;}' unless defined(&J2_UNCONFIGURED);
	eval 'sub J2_INITIALIZING () {1;}' unless defined(&J2_INITIALIZING);
	eval 'sub J2_TERMINATING () {2;}' unless defined(&J2_TERMINATING);
	eval 'sub J2_CONFIGURED () {3;}' unless defined(&J2_CONFIGURED);
    }
}
1;
