require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_J2_IMAP)) {
    eval 'sub _H_J2_IMAP () {1;}' unless defined(&_H_J2_IMAP);
    require 'j2/j2_txnmgr.ph';
    eval 'sub EXTSPERIAG () {128;}' unless defined(&EXTSPERIAG);
    eval 'sub IMAPBLKNO () {0;}' unless defined(&IMAPBLKNO);
    eval 'sub SMAPSZ () {4;}' unless defined(&SMAPSZ);
    eval 'sub EXTSPERSUM () {32;}' unless defined(&EXTSPERSUM);
    eval 'sub L2EXTSPERSUM () {5;}' unless defined(&L2EXTSPERSUM);
    eval 'sub PGSPERIEXT () {4;}' unless defined(&PGSPERIEXT);
    eval 'sub MAXIAGS () {((1<<20)-1);}' unless defined(&MAXIAGS);
    eval 'sub MAXAG () {128;}' unless defined(&MAXAG);
    eval 'sub AMAPSIZE () {512;}' unless defined(&AMAPSIZE);
    eval 'sub SMAPSIZE () {16;}' unless defined(&SMAPSIZE);
    eval 'sub INOTOIAG {
        my($ino) = @_;
	    eval q((($ino) >>  &L2INOSPERIAG));
    }' unless defined(&INOTOIAG);
    eval 'sub IAGTOLBLK {
        my($iagno,$l2nbperpg) = @_;
	    eval q(((($iagno) + 1) << ($l2nbperpg)));
    }' unless defined(&IAGTOLBLK);
    eval 'sub INOPBLK {
        my($pxd,$ino,$l2nbperpg) = @_;
	    eval q(( &addressPXD(($pxd)) + (((($ino) & ( &INOSPEREXT-1)) >>  &L2INOSPERPAGE) << ($l2nbperpg))));
    }' unless defined(&INOPBLK);
    if(defined(&_KERNEL)) {
	eval 'sub im_freeiag () { ($im_imap->{in_freeiag});}' unless defined(&im_freeiag);
	eval 'sub im_nextiag () { ($im_imap->{in_nextiag});}' unless defined(&im_nextiag);
	eval 'sub im_numinos () { ($im_imap->{in_numinos});}' unless defined(&im_numinos);
	eval 'sub im_numfree () { ($im_imap->{in_numfree});}' unless defined(&im_numfree);
	eval 'sub im_agctl () { ($im_imap->{in_agctl});}' unless defined(&im_agctl);
	eval 'sub im_nbperiext () { ($im_imap->{in_nbperiext});}' unless defined(&im_nbperiext);
	eval 'sub im_l2nbperiext () { ($im_imap->{in_l2nbperiext});}' unless defined(&im_l2nbperiext);
	eval 'sub im_diskblock () { ($im_imap->{in_diskblock});}' unless defined(&im_diskblock);
	eval 'sub im_maxag () { ($im_imap->{in_maxag});}' unless defined(&im_maxag);
    }
}
1;
