require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_JFS_INO)) {
    eval 'sub _H_JFS_INO () {1;}' unless defined(&_H_JFS_INO);
    require 'sys/types.ph';
    require 'sys/time.ph';
    require 'jfs/fsdefs.ph';
    require 'jfs/filsys.ph';
    require 'jfs/jfsmount.ph';
    require 'sys/priv.ph';
    require 'sys/acl.ph';
    require 'sys/lock_def.ph';
    eval 'sub di_acct () { &di_pel;}' unless defined(&di_acct);
    eval 'sub di_size () { &di_size_lo;}' unless defined(&di_size);
    unless(defined(&__64BIT_KERNEL)) {
    } else {
    }
    unless(defined(&__64BIT_KERNEL)) {
    } else {
    }
    unless(defined(&__64BIT_KERNEL)) {
    } else {
    }
    eval 'sub di_mtime () { ($di_mtime_ts->{tv_sec});}' unless defined(&di_mtime);
    eval 'sub di_atime () { ($di_atime_ts->{tv_sec});}' unless defined(&di_atime);
    eval 'sub di_ctime () { ($di_ctime_ts->{tv_sec});}' unless defined(&di_ctime);
    eval 'sub di_sec () { &di_attr;}' unless defined(&di_sec);
    eval 'sub D_PRIVATE () {48;}' unless defined(&D_PRIVATE);
    eval 'sub PCL_ENABLED () {(1<<31);}' unless defined(&PCL_ENABLED);
    eval 'sub PCL_EXTENDED () {(1<<30);}' unless defined(&PCL_EXTENDED);
    eval 'sub PCL_FLAGS () {( &PCL_ENABLED| &PCL_EXTENDED);}' unless defined(&PCL_FLAGS);
    eval 'sub di_rdaddr () { ($_di_info->{_di_file}->{_di_rdaddr});}' unless defined(&di_rdaddr);
    eval 'sub di_vindirect () { ($_di_info->{_di_file}->{_di_indblk}->{id_vaddr});}' unless defined(&di_vindirect);
    eval 'sub di_rindirect () { ($_di_info->{_di_file}->{_di_indblk}->{id_raddr});}' unless defined(&di_rindirect);
    eval 'sub di_privinfo () { ($_di_info->{_di_file}->{_di_sec}->{_di_privinfo});}' unless defined(&di_privinfo);
    eval 'sub di_privoffset () { ($di_privinfo->{_di_offset});}' unless defined(&di_privoffset);
    eval 'sub di_privflags () { ($di_privinfo->{_di_flags});}' unless defined(&di_privflags);
    eval 'sub di_priv () { ($_di_info->{_di_file}->{_di_sec}->{_di_priv});}' unless defined(&di_priv);
    eval 'sub di_aclf () { ($_di_info->{_di_file}->{_di_sec}->{_di_aclinfo}->{_di_aclf});}' unless defined(&di_aclf);
    eval 'sub di_acld () { ($_di_info->{_di_file}->{_di_sec}->{_di_aclinfo}->{_di_acld});}' unless defined(&di_acld);
    eval 'sub di_rdev () { ($_di_info->{_di_dev}->{_di_rdev});}' unless defined(&di_rdev);
    eval 'sub di_symlink () { ($_di_info->{_di_sym}->{_s_private});}' unless defined(&di_symlink);
    eval 'sub di_iplog () { &_iplog;}' unless defined(&di_iplog);
    eval 'sub di_ipinode () { &_ipinode;}' unless defined(&di_ipinode);
    eval 'sub di_ipind () { &_ipind;}' unless defined(&di_ipind);
    eval 'sub di_ipinomap () { &_ipinomap;}' unless defined(&di_ipinomap);
    eval 'sub di_ipdmap () { &_ipdmap;}' unless defined(&di_ipdmap);
    eval 'sub di_ipsuper () { &_ipsuper;}' unless defined(&di_ipsuper);
    eval 'sub di_ipinodex () { &_ipinodex;}' unless defined(&di_ipinodex);
    eval 'sub di_jmpmnt () { &_jmpmnt;}' unless defined(&di_jmpmnt);
    eval 'sub di_agsize () { ($_jfs_info->{agsize});}' unless defined(&di_agsize);
    eval 'sub di_iagsize () { ($_jfs_info->{iagsize});}' unless defined(&di_iagsize);
    eval 'sub di_logsidx () { ($_jfs_info->{logsidx});}' unless defined(&di_logsidx);
    eval 'sub di_fperpage () { ($_jfs_info->{jv_fperpage});}' unless defined(&di_fperpage);
    eval 'sub di_fsbigexp () { ($_jfs_info->{jv_bigexp});}' unless defined(&di_fsbigexp);
    eval 'sub di_fscompress () { ($_jfs_info->{jv_comptype});}' unless defined(&di_fscompress);
    eval 'sub di_jfsmnt () { &_jfsmnt;}' unless defined(&di_jfsmnt);
    eval 'sub di_diodone () { ($_jfsmnt->{_diodone});}' unless defined(&di_diodone);
    eval 'sub di_diofail () { ($_jfsmnt->{_diofail});}' unless defined(&di_diofail);
    eval 'sub di_mntflag () { ($_jfsmnt->{_mntflag});}' unless defined(&di_mntflag);
    eval 'sub di_sbinfo () { ($_jfsmnt->{_sbinfo});}' unless defined(&di_sbinfo);
    eval 'sub di_mount_ts () { ($_jfsmnt->{_mount_ts});}' unless defined(&di_mount_ts);
    eval 'sub di_dirty_ts () { ($_jfsmnt->{_dirty_ts});}' unless defined(&di_dirty_ts);
    eval 'sub di_pdtx () { &_pdtx;}' unless defined(&di_pdtx);
    eval 'sub di_kdmfset () { &_kdm_fset;}' unless defined(&di_kdmfset);
    eval 'sub di_indfree () { &_indfree;}' unless defined(&di_indfree);
    eval 'sub di_logptr () { &_logptr;}' unless defined(&di_logptr);
    eval 'sub di_logsize () { &_logsize;}' unless defined(&di_logsize);
    eval 'sub di_logend () { &_logend;}' unless defined(&di_logend);
    eval 'sub di_logsync () { &_logsync;}' unless defined(&di_logsync);
    eval 'sub di_nextsync () { &_nextsync;}' unless defined(&di_nextsync);
    eval 'sub di_logdgp () { &_logdgp;}' unless defined(&di_logdgp);
    eval 'sub di_loglock () { &_loglock;}' unless defined(&di_loglock);
    eval 'sub di_logxor () { &_logxor;}' unless defined(&di_logxor);
    eval 'sub di_llogeor () { &_llogeor;}' unless defined(&di_llogeor);
    eval 'sub di_llogxor () { &_llogxor;}' unless defined(&di_llogxor);
    eval 'sub di_logx () { &_logx;}' unless defined(&di_logx);
    eval 'sub di_logpdtx () { &_logpdtx;}' unless defined(&di_logpdtx);
    eval 'sub di_logwaitcount () { &_logwaitcount;}' unless defined(&di_logwaitcount);
    eval 'sub di_logwaittime () { &_logwaittime;}' unless defined(&di_logwaittime);
    eval 'sub di_logilistlock () { &_lilistlock;}' unless defined(&di_logilistlock);
    eval 'sub di_logilistanchor () { &_lforw;}' unless defined(&di_logilistanchor);
    if(defined(&_KERNEL)) {
	eval 'sub FIRSTIND () {65;}' unless defined(&FIRSTIND);
	eval 'sub NEWBIT () {0x80000000;}' unless defined(&NEWBIT);
	eval 'sub CDADDR () {0xfffffff;}' unless defined(&CDADDR);
	eval 'sub NOIND {
	    my($size) = @_;
    	    eval q(( (($size) <=  &NDADDR* &PAGESIZE ) ? 1: 0));
	}' unless defined(&NOIND);
	eval 'sub SGLIND {
	    my($size) = @_;
    	    eval q(( (($size) <= ( &PAGESIZE/4)* &PAGESIZE) ? 1: 0));
	}' unless defined(&SGLIND);
	eval 'sub DBLIND {
	    my($size) = @_;
    	    eval q(( (($size) > ( &PAGESIZE/4)* &PAGESIZE) ? 1: 0));
	}' unless defined(&DBLIND);
	eval 'sub DABLK () {1024;}' unless defined(&DABLK);
	eval 'sub L2DABLK () {10;}' unless defined(&L2DABLK);
	eval 'sub SGLOFF {
	    my($pno, $bigexp) = @_;
    	    eval q(( (($pno) -  &DABLK >> ($bigexp)) &  &DABLK - 1));
	}' unless defined(&SGLOFF);
	eval 'sub DBLOFF {
	    my($pno, $bigexp) = @_;
    	    eval q(( (($pno) -  &DABLK >> ($bigexp) +  &L2DABLK) + 1));
	}' unless defined(&DBLOFF);
	eval 'sub PGTOXPT {
	    my($pno, $exp) = @_;
    	    eval q(( ($pno) <  &DABLK ? ($pno) : ((($pno) -  &DABLK >> ($exp)) +  &DABLK) ));
	}' unless defined(&PGTOXPT);
	eval 'sub BTOFR {
	    my($b,$f) = @_;
    	    eval q((( >  &NDADDR *  &PAGESIZE) ? : (((($b) - 1) & ( &PAGESIZE - 1)) + ( &PAGESIZE/($f))) / ( &PAGESIZE/($f))));
	}' unless defined(&BTOFR);
    }
}
1;
