require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_MON)) {
    eval 'sub _H_MON () {1;}' unless defined(&_H_MON);
    if(defined(&__cplusplus)) {
    }
    eval 'sub _PROF_TYPE_IS_P () {-1;}' unless defined(&_PROF_TYPE_IS_P);
    eval 'sub _PROF_TYPE_IS_PG () {1;}' unless defined(&_PROF_TYPE_IS_PG);
    eval 'sub _PROF_TYPE_IS_NONE () {0;}' unless defined(&_PROF_TYPE_IS_NONE);
    eval 'sub MON_OUT () {"mon.out";}' unless defined(&MON_OUT);
    eval 'sub GMON_OUT () {"gmon.out";}' unless defined(&GMON_OUT);
    eval 'sub ROUNDDOWN {
        my($x,$y) = @_;
	    eval q(((($x)/($y))*($y)));
    }' unless defined(&ROUNDDOWN);
    eval 'sub ROUNDUP {
        my($x,$y) = @_;
	    eval q((((($x)+($y)-1)/($y))*($y)));
    }' unless defined(&ROUNDUP);
    eval 'sub _MONFromChainEnd () {0;}' unless defined(&_MONFromChainEnd);
    eval 'sub HIST_CNT_MAX () {((1<<( &CHAR_BIT*$sizeof{ &HISTCOUNTER}))-1);}' unless defined(&HIST_CNT_MAX);
    eval 'sub HIST_COUNTER_SIZE () {$sizeof{  &HISTCOUNTER };}' unless defined(&HIST_COUNTER_SIZE);
    eval 'sub INST_PER_CNT () {1;}' unless defined(&INST_PER_CNT);
    if(defined(&__ia64)) {
	eval 'sub MIN_SUBR_SPAN () {16;}' unless defined(&MIN_SUBR_SPAN);
	eval 'sub INST_MIN_LENGTH () {8;}' unless defined(&INST_MIN_LENGTH);
    } else {
	if(defined(&_POWER)) {
	    eval 'sub MIN_SUBR_SPAN () {4;}' unless defined(&MIN_SUBR_SPAN);
	    eval 'sub INST_MIN_LENGTH () {4;}' unless defined(&INST_MIN_LENGTH);
	} else {
	    if(defined(&_IBMRT)) {
		eval 'sub MIN_SUBR_SPAN () {2;}' unless defined(&MIN_SUBR_SPAN);
		eval 'sub INST_MIN_LENGTH () {2;}' unless defined(&INST_MIN_LENGTH);
	    } else {
		if(defined(&_IBMPS)) {
		    eval 'sub MIN_SUBR_SPAN () {2;}' unless defined(&MIN_SUBR_SPAN);
		    eval 'sub INST_MIN_LENGTH () {1;}' unless defined(&INST_MIN_LENGTH);
		} else {
		    eval 'sub MIN_SUBR_SPAN () {2;}' unless defined(&MIN_SUBR_SPAN);
		    eval 'sub INST_MIN_LENGTH () {1;}' unless defined(&INST_MIN_LENGTH);
		}
	    }
	}
    }
    eval 'sub INST_CNT_SIZE () {(  &INST_MIN_LENGTH *  &INST_PER_CNT );}' unless defined(&INST_CNT_SIZE);
    eval 'sub HIST_NUM_COUNTERS {
        my($range) = @_;
	    eval q(( ($range +  &INST_CNT_SIZE -1) /  &INST_CNT_SIZE));
    }' unless defined(&HIST_NUM_COUNTERS);
    eval 'sub HIST_STG_SIZE {
        my($range) = @_;
	    eval q((  &ROUNDUP( ( &HIST_NUM_COUNTERS($range) *  &HIST_COUNTER_SIZE ), &HIST_COUNTER_SIZE ) ));
    }' unless defined(&HIST_STG_SIZE);
    eval 'sub HIST_SCALE_1_TO_1 () {((0x10000*( &HIST_COUNTER_SIZE))/(( &INST_MIN_LENGTH) *( &INST_PER_CNT)));}' unless defined(&HIST_SCALE_1_TO_1);
    eval 'sub HASH_LINK_SIZE () {$sizeof{  &HASH_LINK };}' unless defined(&HASH_LINK_SIZE);
    eval 'sub NUM_HASH_LINKS {
        my($range) = @_;
	    eval q(( ( ($range)+(( &MIN_SUBR_SPAN)-(1)) ) / ( &MIN_SUBR_SPAN) ));
    }' unless defined(&NUM_HASH_LINKS);
    eval 'sub FROM_STG_SIZE {
        my($range) = @_;
	    eval q(( &NUM_HASH_LINKS($range) * ( &HASH_LINK_SIZE)));
    }' unless defined(&FROM_STG_SIZE);
    eval 'sub ARCDENSITY () {2;}' unless defined(&ARCDENSITY);
    eval 'sub WHATSIT () {100;}' unless defined(&WHATSIT);
    eval 'sub MINARCS () {50;}' unless defined(&MINARCS);
    eval 'sub MAXARCS () {600;}' unless defined(&MAXARCS);
    eval 'sub TO_NUM_ELEMENTS {
        my($range) = @_;
	    eval q(( (($range)*( &ARCDENSITY))/( &WHATSIT) ));
    }' unless defined(&TO_NUM_ELEMENTS);
    eval 'sub FROM_OFFSET {
        my($frompc,$lopc) = @_;
	    eval q(( ( (($frompc)-($lopc)) * ( &HASH_LINK_SIZE) ) / ( &MIN_SUBR_SPAN) ));
    }' unless defined(&FROM_OFFSET);
    eval 'sub FROM_INDEX {
        my($frompc,$lopc) = @_;
	    eval q(((($frompc)-($lopc)) / ( &MIN_SUBR_SPAN)));
    }' unless defined(&FROM_INDEX);
    eval 'sub TO_MAX () {( ( 1<< ( ( &CHAR_BIT) * ($sizeof{  &HASH_LINK }) ) )-1);}' unless defined(&TO_MAX);
    unless(defined(&_NO_PROTO)) {
    } else {
    }
    unless(defined(&_NO_PROTO)) {
    } else {
    }
    unless(defined(&_NO_PROTO)) {
    } else {
    }
    unless(defined(&_NO_PROTO)) {
    } else {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
