require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_IF_ARP)) {
    eval 'sub _H_IF_ARP () {1;}' unless defined(&_H_IF_ARP);
    require 'netinet/in.ph';
    eval 'sub ARPHRD_ETHER () {1;}' unless defined(&ARPHRD_ETHER);
    eval 'sub ARPHRD_802_5 () {6;}' unless defined(&ARPHRD_802_5);
    eval 'sub ARPHRD_802_3 () {6;}' unless defined(&ARPHRD_802_3);
    eval 'sub ARPHRD_FDDI () {1;}' unless defined(&ARPHRD_FDDI);
    eval 'sub ARPOP_REQUEST () {1;}' unless defined(&ARPOP_REQUEST);
    eval 'sub ARPOP_REPLY () {2;}' unless defined(&ARPOP_REPLY);
    eval 'sub ATF_INUSE () {0x1;}' unless defined(&ATF_INUSE);
    eval 'sub ATF_COM () {0x2;}' unless defined(&ATF_COM);
    eval 'sub ATF_PERM () {0x4;}' unless defined(&ATF_PERM);
    eval 'sub ATF_PUBL () {0x8;}' unless defined(&ATF_PUBL);
    eval 'sub ATF_USETRAILERS () {0x10;}' unless defined(&ATF_USETRAILERS);
    eval 'sub ATF_ASK () {0x20;}' unless defined(&ATF_ASK);
    if(defined(&ARPQ)) {
    }
    eval 'sub MAX_HWADDR () {20;}' unless defined(&MAX_HWADDR);
    if(defined(&ARPQ)) {
    }
    eval 'sub at_enaddr () { &hwaddr;}' unless defined(&at_enaddr);
    eval 'sub at_traddr () { &hwaddr;}' unless defined(&at_traddr);
    eval 'sub at_ie3addr () { &hwaddr;}' unless defined(&at_ie3addr);
    eval 'sub at_x25addr () { &hwaddr;}' unless defined(&at_x25addr);
    eval 'sub at_fdaddr () { &hwaddr;}' unless defined(&at_fdaddr);
    eval 'sub at_rcf () { ($if_dependent->{token}->{u_rcf});}' unless defined(&at_rcf);
    eval 'sub at_seg () { ($if_dependent->{token}->{u_seg});}' unless defined(&at_seg);
    eval 'sub at_session_id () { ($if_dependent->{x25}->{u_session_id});}' unless defined(&at_session_id);
    eval 'sub at_x25unit () { ($if_dependent->{x25}->{u_unit});}' unless defined(&at_x25unit);
    eval 'sub at_fddi_rcf () { ($if_dependent->{fddi}->{u_rcf});}' unless defined(&at_fddi_rcf);
    eval 'sub at_fddi_seg () { ($if_dependent->{fddi}->{u_seg});}' unless defined(&at_fddi_seg);
    if(defined(&ARPQ)) {
	eval 'sub at_last () { ($if_dependent->{_at_last}->{u_at_last});}' unless defined(&at_last);
    }
    eval 'sub MAX_ARP_RETRIES_PER_MINUTE () {60;}' unless defined(&MAX_ARP_RETRIES_PER_MINUTE);
    eval 'sub arp_rcf () { ($ifd->{token}->{u_rcf});}' unless defined(&arp_rcf);
    eval 'sub arp_seg () { ($ifd->{token}->{u_seg});}' unless defined(&arp_seg);
    eval 'sub arp_session_id () { ($ifd->{x25}->{u_session_id});}' unless defined(&arp_session_id);
    eval 'sub arp_x25unit () { ($ifd->{x25}->{u_unit});}' unless defined(&arp_x25unit);
    eval 'sub arp_fddi_rcf () { ($ifd->{fddi}->{u_rcf});}' unless defined(&arp_fddi_rcf);
    eval 'sub arp_fddi_seg () { ($ifd->{fddi}->{u_seg});}' unless defined(&arp_fddi_seg);
    eval 'sub IN_USE () {0x1;}' unless defined(&IN_USE);
    if(defined(&IP_MULTICAST)) {
	if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	}
    }
    eval 'sub ac_enaddr () { &ac_hwaddr;}' unless defined(&ac_enaddr);
    eval 'sub ac_traddr () { &ac_hwaddr;}' unless defined(&ac_traddr);
    eval 'sub ac_fdaddr () { &ac_hwaddr;}' unless defined(&ac_fdaddr);
    if(defined(&GATEWAY)) {
	eval 'sub ARPTAB_BSIZ () {7;}' unless defined(&ARPTAB_BSIZ);
	eval 'sub ARPTAB_NB () {25;}' unless defined(&ARPTAB_NB);
    } else {
	eval 'sub ARPTAB_BSIZ () {5;}' unless defined(&ARPTAB_BSIZ);
	eval 'sub ARPTAB_NB () {20;}' unless defined(&ARPTAB_NB);
    }
    if(defined(&_KERNEL)) {
	if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	    require 'sys/lock_alloc.ph';
	    eval 'sub ARPTAB_LOCKINIT {
	        my($lockp) = @_;
    		eval q({  &lock_alloc(($lockp),  &LOCK_ALLOC_PIN,  &ARPTAB_LOCK_FAMILY, -1);  &simple_lock_init(($lockp)); });
	    }' unless defined(&ARPTAB_LOCKINIT);
	    eval 'sub ARPTAB_LOCK {
	        my($lockp) = @_;
    		eval q( &s =  &disable_lock( &PL_IMP, ($lockp)););
	    }' unless defined(&ARPTAB_LOCK);
	    eval 'sub ARPTAB_UNLOCK {
	        my($lockp) = @_;
    		eval q( &unlock_enable( &s, ($lockp)););
	    }' unless defined(&ARPTAB_UNLOCK);
	} else {
	    eval 'sub ARPTAB_LOCKINIT {
	        my($lockp) = @_;
    		eval q();
	    }' unless defined(&ARPTAB_LOCKINIT);
	    eval 'sub ARPTAB_LOCK {
	        my($lockp) = @_;
    		eval q( &NETSPL( &s, &imp));
	    }' unless defined(&ARPTAB_LOCK);
	    eval 'sub ARPTAB_UNLOCK {
	        my($lockp) = @_;
    		eval q( &NETSPLX( &s));
	    }' unless defined(&ARPTAB_UNLOCK);
	}
	if(defined(&ARPQ)) {
	}
	eval 'sub ARPTAB_HASH {
	    my($a) = @_;
    	    eval q((($a) %  &arptabnb));
	}' unless defined(&ARPTAB_HASH);
	eval 'sub ARPTAB_LOOK {
	    my($at, $addr) = @_;
    	    eval q({  &register \'int\'  &n; $at =  $arptabp[ &ARPTAB_HASH($addr) *  &arptabbsiz];  &for ( &n = 0;  &n <  &arptabbsiz ;  &n++, $at++)  &if ( ($at->{at_iaddr}->{s_addr}) == $addr)  &break;  &if ( &n >=  &arptabbsiz) $at = 0; });
	}' unless defined(&ARPTAB_LOOK);
    }
    eval 'sub ARPT_AGE () {(60* 1);}' unless defined(&ARPT_AGE);
    eval 'sub ARPT_KILLC () {20;}' unless defined(&ARPT_KILLC);
    eval 'sub ARPT_KILLI () {3;}' unless defined(&ARPT_KILLI);
    eval 'sub MAX_NASTIES () {69;}' unless defined(&MAX_NASTIES);
    if(defined(&IP_MULTICAST)) {
	if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	    eval 'sub ACMULTI_LOCK_DECL () {
	        eval q(\'int\'  &_acml;);
	    }' unless defined(&ACMULTI_LOCK_DECL);
	    eval 'sub ACMULTI_LOCK {
	        my($acp) = @_;
    		eval q( &_acml =  &disable_lock( &PL_IMP, (($acp)-> &ac_multi_lock)));
	    }' unless defined(&ACMULTI_LOCK);
	    eval 'sub ACMULTI_UNLOCK {
	        my($acp) = @_;
    		eval q( &unlock_enable( &_acml, (($acp)-> &ac_multi_lock)));
	    }' unless defined(&ACMULTI_UNLOCK);
	    eval 'sub ACMULTI_LOCKINIT {
	        my($acp) = @_;
    		eval q({  &lock_alloc((($acp)-> &ac_multi_lock),  &LOCK_ALLOC_PIN,  &ACMULTI_LOCK_FAMILY, ( &short32uint64_t)$acp);  &simple_lock_init((($acp)-> &ac_multi_lock)); });
	    }' unless defined(&ACMULTI_LOCKINIT);
	} else {
	    eval 'sub ACMULTI_LOCK {
	        my($acp) = @_;
    		eval q( &NETSPL( &s,  &net));
	    }' unless defined(&ACMULTI_LOCK);
	    eval 'sub ACMULTI_UNLOCK {
	        my($acp) = @_;
    		eval q( &NETSPLX( &s));
	    }' unless defined(&ACMULTI_UNLOCK);
	    eval 'sub ACMULTI_LOCKINIT {
	        my($acp) = @_;
    		eval q();
	    }' unless defined(&ACMULTI_LOCKINIT);
	}
    }
    eval 'sub en_if () { ($en_ac->{ac_if});}' unless defined(&en_if);
    eval 'sub en_addr () { ($en_ac->{ac_enaddr});}' unless defined(&en_addr);
}
1;
