require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_IF_SLVAR)) {
    eval 'sub _H_IF_SLVAR () {1;}' unless defined(&_H_IF_SLVAR);
    if(defined(&_KERNEL)) {
	eval 'sub SLIP_LOCK_DECL () {
	    eval q(\'int\'  &_slsc;);
	}' unless defined(&SLIP_LOCK_DECL);
	eval 'sub SLIP_LOCK {
	    my($sc) = @_;
    	    eval q( &_slsc =  &disable_lock( &PL_IMP, (($sc)-> &sc_lock)));
	}' unless defined(&SLIP_LOCK);
	eval 'sub SLIP_UNLOCK {
	    my($sc) = @_;
    	    eval q( &unlock_enable( &_slsc, ($sc)-> &sc_lock));
	}' unless defined(&SLIP_UNLOCK);
	eval 'sub SLIP_LOCK_INIT {
	    my($sc) = @_;
    	    eval q( &simple_lock_init(($sc)-> &sc_lock));
	}' unless defined(&SLIP_LOCK_INIT);
    }
    eval 'sub BUFOFFSET () {128;}' unless defined(&BUFOFFSET);
    eval 'sub SLMAX () {( &MCLBYTES -  &BUFOFFSET);}' unless defined(&SLMAX);
    eval 'sub SLBUFSIZE () {( &SLMAX +  &BUFOFFSET);}' unless defined(&SLBUFSIZE);
    eval 'sub SLMTU () {296;}' unless defined(&SLMTU);
    eval 'sub SLIP_MODID () {518;}' unless defined(&SLIP_MODID);
    eval 'sub SLIP_IFQMAXLEN () {50;}' unless defined(&SLIP_IFQMAXLEN);
    eval 'sub SLIP_HIWAT () {1024;}' unless defined(&SLIP_HIWAT);
    eval 'sub SLIP_LOWAT () {1024;}' unless defined(&SLIP_LOWAT);
    eval 'sub SLIFNAME () {"sl";}' unless defined(&SLIFNAME);
    eval 'sub SC_COMPRESS () {0x2;}' unless defined(&SC_COMPRESS);
    eval 'sub SC_NOICMP () {0x4;}' unless defined(&SC_NOICMP);
    eval 'sub SC_AUTOCOMP () {0x8;}' unless defined(&SC_AUTOCOMP);
    eval 'sub SC_CANSET () {( &SC_COMPRESS| &SC_NOICMP| &SC_AUTOCOMP);}' unless defined(&SC_CANSET);
    if(defined(&_KERNEL)) {
	eval 'sub SC_INUSE () {0x40000;}' unless defined(&SC_INUSE);
	eval 'sub SC_ATTACHED () {0x80000;}' unless defined(&SC_ATTACHED);
	eval 'sub SC_MASK () {0xf0000;}' unless defined(&SC_MASK);
	eval 'sub SC_ERROR () {-1;}' unless defined(&SC_ERROR);
	eval 'sub SC_FOUND () {0;}' unless defined(&SC_FOUND);
	eval 'sub SC_BUSY () {1;}' unless defined(&SC_BUSY);
    }
    eval 'sub FRAME_END () {0xc0;}' unless defined(&FRAME_END);
    eval 'sub FRAME_ESCAPE () {0xdb;}' unless defined(&FRAME_ESCAPE);
    eval 'sub TRANS_FRAME_END () {0xdc;}' unless defined(&TRANS_FRAME_END);
    eval 'sub TRANS_FRAME_ESCAPE () {0xdd;}' unless defined(&TRANS_FRAME_ESCAPE);
    eval 'sub microtime {
        my($tv) = @_;
	    eval q({ \'struct timestruc_t\'  &ct;  &curtime( &ct); -> &tv_sec =  ($ct->{tv_sec}); -> &tv_usec =  ($ct->{tv_nsec}) / 1000; });
    }' unless defined(&microtime);
}
1;
