require '_h2ph_pre.ph';

no warnings 'redefine';

require 'sys/cdli.ph';
unless(defined(&_NET_ND_LAN_H)) {
    eval 'sub _NET_ND_LAN_H () {1;}' unless defined(&_NET_ND_LAN_H);
    unless(defined(&_802_2_LLC)) {
	eval 'sub _802_2_LLC () {1;}' unless defined(&_802_2_LLC);
    }
    eval 'sub DSAP_SNAP () {0xaa;}' unless defined(&DSAP_SNAP);
    eval 'sub SSAP_SNAP () {0xaa;}' unless defined(&SSAP_SNAP);
    eval 'sub DSAP_INET () { &DSAP_SNAP;}' unless defined(&DSAP_INET);
    eval 'sub SSAP_INET () { &SSAP_SNAP;}' unless defined(&SSAP_INET);
    eval 'sub DSAP_APPLETALK () {0xe0;}' unless defined(&DSAP_APPLETALK);
    eval 'sub SSAP_APPLETALK () {0xe0;}' unless defined(&SSAP_APPLETALK);
    eval 'sub DSAP_ISO () {0xfe;}' unless defined(&DSAP_ISO);
    eval 'sub SSAP_ISO () {0xfe;}' unless defined(&SSAP_ISO);
    eval 'sub DSAP_XNS () {0xfa;}' unless defined(&DSAP_XNS);
    eval 'sub SSAP_XNS () {0xfa;}' unless defined(&SSAP_XNS);
    eval 'sub DSAP_NETWARE () {0xff;}' unless defined(&DSAP_NETWARE);
    eval 'sub SSAP_NETWARE () {0xff;}' unless defined(&SSAP_NETWARE);
    eval 'sub DSAP_NETBIOS () {0xf0;}' unless defined(&DSAP_NETBIOS);
    eval 'sub SSAP_NETBIOS () {0xf0;}' unless defined(&SSAP_NETBIOS);
    eval 'sub CTRL_UI () {0x3;}' unless defined(&CTRL_UI);
    eval 'sub CTRL_XID () {0xaf;}' unless defined(&CTRL_XID);
    eval 'sub CTRL_TEST () {0xe3;}' unless defined(&CTRL_TEST);
    eval 'sub SSAP_RESP () {0x1;}' unless defined(&SSAP_RESP);
    eval 'sub NS_MAX_SAPS () {256;}' unless defined(&NS_MAX_SAPS);
    eval 'sub SNAP_TYPE_AP () {0x809b;}' unless defined(&SNAP_TYPE_AP);
    eval 'sub SNAP_TYPE_ARP () {0x806;}' unless defined(&SNAP_TYPE_ARP);
    eval 'sub SNAP_TYPE_IP () {0x800;}' unless defined(&SNAP_TYPE_IP);
    eval 'sub VLAN_TAG_TYPE () {0x8100;}' unless defined(&VLAN_TAG_TYPE);
    eval 'sub DMX_8022_GET_USER {
        my($retfup, $sap, $etype, $org, $nsdemux) = @_;
	    eval q({ \'struct ns_8022_user\' * &fup; \'struct ns_8022_user\' * &filter_head;  &filter_head =  (($nsdemux)-> $dsap_heads[$sap]);  &fup =  ($filter_head->{next});  &if ( ($fup->{filter}->{filtertype}) !=  &NS_8022_LLC_DSAP) {  &for ( ;  &fup !=  &filter_head;  &fup =  ($fup->{next})) {  &if ( ( ($fup->{filter}->{ethertype}) == $etype)  && (! &memcmp( ($fup->{filter}->{orgcode}), $org, $sizeof{$org})) )  &break; } }  &if ( &fup ==  &filter_head) $retfup =  &NULL;  &else $retfup =  &fup; });
    }' unless defined(&DMX_8022_GET_USER);
    eval 'sub IFSTUFF_AND_DELIVER {
        my($nsuser, $nddp, $m, $macp, $extp) = @_;
	    eval q({  &IFQ_LOCK_DECL()  &LOCK_ASSERTL_DECL  &if ( ($nsuser->{user}->{ifp})) {  &if (( ($nsuser->{user}->{ifp}->{if_flags}) &  &IFF_UP) == 0) {  &m_freem($m);  ($nsuser->{user}->{ifp}->{if_iqdrops})++;  &goto  &out; }  &else {  ($nsuser->{user}->{ifp}->{if_ipackets})++;  ($nsuser->{user}->{ifp}->{if_ibytes}) +=  ($m->{m_pkthdr}->{len});  ($m->{m_pkthdr}->{rcvif}) =  ($nsuser->{user}->{ifp}); } }  &if ( ($nsuser->{user}->{protoq}) ==  &NULL) { (*( ($nsuser->{user}->{isr})))($nddp, $m, $macp, ($extp)); }  &else {  &IFQ_LOCK( ($nsuser->{user}->{protoq}));  &if ( &IF_QFULL( ($nsuser->{user}->{protoq}))) {  &IF_DROP( ($nsuser->{user}->{protoq}));  ($nddp->{ndd_demuxer}->{nd_dmxstats}->{nd_nobufs})++;  &m_freem($m); }  &else {  &IF_ENQUEUE_NOLOCK( ($nsuser->{user}->{protoq}), $m); }  &IFQ_UNLOCK( ($nsuser->{user}->{protoq}));  &schednetisr( ($nsuser->{user}->{netisr})); }  &out: ; });
    }' unless defined(&IFSTUFF_AND_DELIVER);
    eval 'sub DELIVER_PACKET {
        my($nsuser, $nddp, $m, $macp, $extp) = @_;
	    eval q({  &IFQ_LOCK_DECL()  &LOCK_ASSERTL_DECL  &if ( ($nsuser->{protoq}) ==  &NULL) { (*( ($nsuser->{isr})))($nddp, $m, $macp, ($extp)); }  &else {  &IFQ_LOCK( ($nsuser->{protoq}));  &if ( &IF_QFULL( ($nsuser->{protoq}))) {  &IF_DROP( ($nsuser->{protoq}));  ($nddp->{ndd_demuxer}->{nd_dmxstats}->{nd_nobufs})++;  &m_freem($m); }  &else {  &IF_ENQUEUE_NOLOCK( ($nsuser->{protoq}), $m); }  &IFQ_UNLOCK( ($nsuser->{protoq}));  &schednetisr( ($nsuser->{netisr})); } });
    }' unless defined(&DELIVER_PACKET);
    eval 'sub DEMUXER_LOCK_DECL () {
        eval q(\'int\'  &_dmx_s;);
    }' unless defined(&DEMUXER_LOCK_DECL);
    if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	eval 'sub DEMUXER_LOCKINIT {
	    my($lockp) = @_;
    	    eval q({  &lock_alloc($lockp,  &LOCK_ALLOC_PIN,  &DEMUXER_LOCK_FAMILY, $lockp);  &simple_lock_init(($lockp)); });
	}' unless defined(&DEMUXER_LOCKINIT);
	eval 'sub DEMUXER_LOCK {
	    my($lockp) = @_;
    	    eval q( &_dmx_s =  &disable_lock( &PL_IMP, ($lockp)));
	}' unless defined(&DEMUXER_LOCK);
	eval 'sub DEMUXER_UNLOCK {
	    my($lockp) = @_;
    	    eval q( &unlock_enable( &_dmx_s, ($lockp)));
	}' unless defined(&DEMUXER_UNLOCK);
    } else {
	eval 'sub DEMUXER_LOCKINIT {
	    my($lockp) = @_;
    	    eval q();
	}' unless defined(&DEMUXER_LOCKINIT);
	eval 'sub DEMUXER_LOCK {
	    my($lockp) = @_;
    	    eval q( &NETSPL( &_dmx_s,  &imp));
	}' unless defined(&DEMUXER_LOCK);
	eval 'sub DEMUXER_UNLOCK {
	    my($lockp) = @_;
    	    eval q( &NETSPLX( &_dmx_s));
	}' unless defined(&DEMUXER_UNLOCK);
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub ie2_llc {
        my($llc, $snap_type) = @_;
	    eval q((($llc))-> &dsap =  &DSAP_INET; (($llc))-> &ssap =  &SSAP_INET; (($llc))-> &ctrl =  &CTRL_UI; (($llc))-> $prot_id[0] = 0; (($llc))-> $prot_id[1] = 0; (($llc))-> $prot_id[2] = 0; (($llc))-> &type = ($snap_type););
    }' unless defined(&ie2_llc);
}
1;
