require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ROUTE_H)) {
    eval 'sub ROUTE_H () {1;}' unless defined(&ROUTE_H);
    eval 'sub PMTU_ISR_TIMEOUT () {0;}' unless defined(&PMTU_ISR_TIMEOUT);
    eval 'sub PMTU_ISR_TCP_UPDATE () {1;}' unless defined(&PMTU_ISR_TCP_UPDATE);
    eval 'sub PMTU_ISR_UDP_UPDATE () {2;}' unless defined(&PMTU_ISR_UDP_UPDATE);
    if(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub RTM_RTTUNIT () {1000000;}' unless defined(&RTM_RTTUNIT);
    eval 'sub RTTTOPRHZ {
        my($r) = @_;
	    eval q((($r) / ( &RTM_RTTUNIT /  &PR_SLOWHZ)));
    }' unless defined(&RTTTOPRHZ);
    require 'sys/limits.ph';
    if(defined(&__ia64)) {
    }
    if(defined(&__ia64)) {
    }
    unless(defined(&RNF_NORMAL)) {
	require 'net/radix.ph';
    }
    eval 'sub rt_key {
        my($r) = @_;
	    eval q(((($r)-> ($rt_nodes->{rn_key}))));
    }' unless defined(&rt_key);
    eval 'sub rt_mask {
        my($r) = @_;
	    eval q(((($r)-> ($rt_nodes->{rn_mask}))));
    }' unless defined(&rt_mask);
    eval 'sub RTENTRY_REF {
        my($rt) = @_;
	    eval q( &fetch_and_add_h(($rt)-> &rt_refcnt, 1););
    }' unless defined(&RTENTRY_REF);
    eval 'sub RTENTRY_UNREF {
        my($rt) = @_;
	    eval q( &fetch_and_add_h(($rt)-> &rt_refcnt, -1););
    }' unless defined(&RTENTRY_UNREF);
    if(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_AIX)) {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub rt_cost () { ($rt_rmx->{rmx_hopcount});}' unless defined(&rt_cost);
    eval 'sub IS_DUP {
        my($rt) = @_;
	    eval q(((($rt))-> &rn_flags &  &RNF_DUP));
    }' unless defined(&IS_DUP);
    eval 'sub MAX_RT_COST () { &INT_MAX;}' unless defined(&MAX_RT_COST);
    eval 'sub rt_use () { ($rt_rmx->{rmx_pksent});}' unless defined(&rt_use);
    eval 'sub RTF_UP () {0x1;}' unless defined(&RTF_UP);
    eval 'sub RTF_GATEWAY () {0x2;}' unless defined(&RTF_GATEWAY);
    eval 'sub RTF_HOST () {0x4;}' unless defined(&RTF_HOST);
    eval 'sub RTF_REJECT () {0x8;}' unless defined(&RTF_REJECT);
    eval 'sub RTF_DYNAMIC () {0x10;}' unless defined(&RTF_DYNAMIC);
    eval 'sub RTF_MODIFIED () {0x20;}' unless defined(&RTF_MODIFIED);
    eval 'sub RTF_DONE () {0x40;}' unless defined(&RTF_DONE);
    eval 'sub RTF_MASK () {0x80;}' unless defined(&RTF_MASK);
    eval 'sub RTF_CLONING () {0x100;}' unless defined(&RTF_CLONING);
    eval 'sub RTF_XRESOLVE () {0x200;}' unless defined(&RTF_XRESOLVE);
    eval 'sub RTF_LLINFO () {0x400;}' unless defined(&RTF_LLINFO);
    eval 'sub RTF_STATIC () {0x800;}' unless defined(&RTF_STATIC);
    eval 'sub RTF_BLACKHOLE () {0x1000;}' unless defined(&RTF_BLACKHOLE);
    eval 'sub RTF_BUL () {0x2000;}' unless defined(&RTF_BUL);
    eval 'sub RTF_PROTO2 () {0x4000;}' unless defined(&RTF_PROTO2);
    eval 'sub RTF_PROTO1 () {0x8000;}' unless defined(&RTF_PROTO1);
    eval 'sub RTF_CLONE () {0x10000;}' unless defined(&RTF_CLONE);
    eval 'sub RTF_CLONED () {0x20000;}' unless defined(&RTF_CLONED);
    eval 'sub RTF_PROTO3 () {0x40000;}' unless defined(&RTF_PROTO3);
    eval 'sub RTF_BCE () {0x80000;}' unless defined(&RTF_BCE);
    eval 'sub RTF_PINNED () {0x100000;}' unless defined(&RTF_PINNED);
    eval 'sub RTF_LOCAL () {0x200000;}' unless defined(&RTF_LOCAL);
    eval 'sub RTF_BROADCAST () {0x400000;}' unless defined(&RTF_BROADCAST);
    eval 'sub RTF_MULTICAST () {0x800000;}' unless defined(&RTF_MULTICAST);
    eval 'sub RTF_ACTIVE_DGD () {0x1000000;}' unless defined(&RTF_ACTIVE_DGD);
    eval 'sub RTF_STOPSRCH () {0x2000000;}' unless defined(&RTF_STOPSRCH);
    eval 'sub RTF_SMALLMTU () {0x40000;}' unless defined(&RTF_SMALLMTU);
    eval 'sub MFC_PACKET_Q_SIZE () {5;}' unless defined(&MFC_PACKET_Q_SIZE);
    eval 'sub MAX_PACKET_Q_SIZE () {7;}' unless defined(&MAX_PACKET_Q_SIZE);
    if(defined(&MFC_IMPL)) {
	eval 'sub mfc_key {
	    my($r) = @_;
    	    eval q(((($r)-> ($rt_nodes->{rn_key}))));
	}' unless defined(&mfc_key);
    }
    if(defined( &_KERNEL)  && (defined(&LOCK_NETSTATS) ? &LOCK_NETSTATS : 0)) {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_KERNEL)) {
	eval 'sub w_rtm () { ($w_m->{m_rtm});}' unless defined(&w_rtm);
    }
    eval 'sub K_GIDLIST () {0x10000;}' unless defined(&K_GIDLIST);
    eval 'sub RTM_VERSION () {2;}' unless defined(&RTM_VERSION);
    eval 'sub RTM_VERSION_GR_COMPAT () {3;}' unless defined(&RTM_VERSION_GR_COMPAT);
    eval 'sub RTM_VERSION_GR () {4;}' unless defined(&RTM_VERSION_GR);
    eval 'sub RTM_ADD () {0x1;}' unless defined(&RTM_ADD);
    eval 'sub RTM_DELETE () {0x2;}' unless defined(&RTM_DELETE);
    eval 'sub RTM_CHANGE () {0x3;}' unless defined(&RTM_CHANGE);
    eval 'sub RTM_GET () {0x4;}' unless defined(&RTM_GET);
    eval 'sub RTM_LOSING () {0x5;}' unless defined(&RTM_LOSING);
    eval 'sub RTM_REDIRECT () {0x6;}' unless defined(&RTM_REDIRECT);
    eval 'sub RTM_MISS () {0x7;}' unless defined(&RTM_MISS);
    eval 'sub RTM_LOCK () {0x8;}' unless defined(&RTM_LOCK);
    eval 'sub RTM_OLDADD () {0x9;}' unless defined(&RTM_OLDADD);
    eval 'sub RTM_OLDDEL () {0xa;}' unless defined(&RTM_OLDDEL);
    eval 'sub RTM_RESOLVE () {0xb;}' unless defined(&RTM_RESOLVE);
    eval 'sub RTM_NEWADDR () {0xc;}' unless defined(&RTM_NEWADDR);
    eval 'sub RTM_DELADDR () {0xd;}' unless defined(&RTM_DELADDR);
    eval 'sub RTM_IFINFO () {0xe;}' unless defined(&RTM_IFINFO);
    eval 'sub RTM_EXPIRE () {0xf;}' unless defined(&RTM_EXPIRE);
    eval 'sub RTM_RTLOST () {0x10;}' unless defined(&RTM_RTLOST);
    eval 'sub RTM_GETNEXT () {0x11;}' unless defined(&RTM_GETNEXT);
    eval 'sub RTV_MTU () {0x1;}' unless defined(&RTV_MTU);
    eval 'sub RTV_HOPCOUNT () {0x2;}' unless defined(&RTV_HOPCOUNT);
    eval 'sub RTV_EXPIRE () {0x4;}' unless defined(&RTV_EXPIRE);
    eval 'sub RTV_RPIPE () {0x8;}' unless defined(&RTV_RPIPE);
    eval 'sub RTV_SPIPE () {0x10;}' unless defined(&RTV_SPIPE);
    eval 'sub RTV_SSTHRESH () {0x20;}' unless defined(&RTV_SSTHRESH);
    eval 'sub RTV_RTT () {0x40;}' unless defined(&RTV_RTT);
    eval 'sub RTV_RTTVAR () {0x80;}' unless defined(&RTV_RTTVAR);
    eval 'sub RTA_DST () {0x1;}' unless defined(&RTA_DST);
    eval 'sub RTA_GATEWAY () {0x2;}' unless defined(&RTA_GATEWAY);
    eval 'sub RTA_NETMASK () {0x4;}' unless defined(&RTA_NETMASK);
    eval 'sub RTA_GENMASK () {0x8;}' unless defined(&RTA_GENMASK);
    eval 'sub RTA_IFP () {0x10;}' unless defined(&RTA_IFP);
    eval 'sub RTA_IFA () {0x20;}' unless defined(&RTA_IFA);
    eval 'sub RTA_AUTHOR () {0x40;}' unless defined(&RTA_AUTHOR);
    eval 'sub RTA_BRD () {0x80;}' unless defined(&RTA_BRD);
    eval 'sub RTA_DOWNSTREAM () {0x100;}' unless defined(&RTA_DOWNSTREAM);
    eval 'sub RT_ROUNDUP {
        my($sa) = @_;
	    eval q((($sa)-> &sa_len > 0? (1+ ((($sa)-> &sa_len-1) | ($sizeof{\'int\'}-1))) : $sizeof{\'int\'}));
    }' unless defined(&RT_ROUNDUP);
    eval 'sub RTAX_DST () {0;}' unless defined(&RTAX_DST);
    eval 'sub RTAX_GATEWAY () {1;}' unless defined(&RTAX_GATEWAY);
    eval 'sub RTAX_NETMASK () {2;}' unless defined(&RTAX_NETMASK);
    eval 'sub RTAX_GENMASK () {3;}' unless defined(&RTAX_GENMASK);
    eval 'sub RTAX_IFP () {4;}' unless defined(&RTAX_IFP);
    eval 'sub RTAX_IFA () {5;}' unless defined(&RTAX_IFA);
    eval 'sub RTAX_AUTHOR () {6;}' unless defined(&RTAX_AUTHOR);
    eval 'sub RTAX_BRD () {7;}' unless defined(&RTAX_BRD);
    if(defined(&MFC_IMPL)) {
	eval 'sub RTAX_DOWNSTREAM () {8;}' unless defined(&RTAX_DOWNSTREAM);
	eval 'sub RTAX_MAX () {9;}' unless defined(&RTAX_MAX);
    } else {
	eval 'sub RTAX_MAX () {8;}' unless defined(&RTAX_MAX);
    }
    if(defined(&_KERNEL)) {
	if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	    eval 'sub ROUTE_READ_LOCK_DECL () {
	        eval q(\'int\'  &_rrl;);
	    }' unless defined(&ROUTE_READ_LOCK_DECL);
	    eval 'sub ROUTE_LOCK_DECL () {
	        eval q();
	    }' unless defined(&ROUTE_LOCK_DECL);
	    eval 'sub ROUTE_ISLOCKED () {
	        eval q(1);
	    }' unless defined(&ROUTE_ISLOCKED);
	    eval 'sub ROUTE_LOCKINIT () {
	        eval q( &RW_LOCKINIT( &route_lock, 128,  &M_LOCKF,  &M_WAITOK,  &LOCK_ALLOC_PIN,  &ROUTE_LOCK_FAMILY, -1));
	    }' unless defined(&ROUTE_LOCKINIT);
	    eval 'sub ROUTE_WRITE_LOCK () {
	        eval q( &RW_WRITE_LOCK( &route_lock,  &_rtl,  &PL_IMP));
	    }' unless defined(&ROUTE_WRITE_LOCK);
	    eval 'sub ROUTE_WRITE_UNLOCK () {
	        eval q( &RW_WRITE_UNLOCK( &route_lock,  &_rtl));
	    }' unless defined(&ROUTE_WRITE_UNLOCK);
	    eval 'sub ROUTE_READ_LOCK () {
	        eval q( &RW_READ_LOCK( &route_lock,  &_rtl,  &PL_IMP,  &_rrl));
	    }' unless defined(&ROUTE_READ_LOCK);
	    eval 'sub ROUTE_READ_UNLOCK () {
	        eval q( &RW_READ_UNLOCK( &route_lock,  &_rrl));
	    }' unless defined(&ROUTE_READ_UNLOCK);
	    eval 'sub ROUTE_READ_UNLOCK_TEMP () {
	        eval q( &RW_READ_UNLOCK_TEMP( &route_lock));
	    }' unless defined(&ROUTE_READ_UNLOCK_TEMP);
	    eval 'sub ROUTE_IS_READ_LOCKED () {
	        eval q( ($route_lock->{read_cnt}));
	    }' unless defined(&ROUTE_IS_READ_LOCKED);
	    eval 'sub RTFREE {
	        my($rt) = @_;
    		eval q( &rtfree($rt));
	    }' unless defined(&RTFREE);
	    eval 'sub RTENTRY_LOCKINIT {
	        my($rt) = @_;
    		eval q({  &lock_alloc( ($rt->{rt_lock}),  &LOCK_ALLOC_PIN,  &RTENTRY_LOCK_FAMILY, -1);  &simple_lock_init( ($rt->{rt_lock})); });
	    }' unless defined(&RTENTRY_LOCKINIT);
	    eval 'sub RTENTRY_LOCK {
	        my($rt) = @_;
    		eval q( ($rt->{rt_intr}) =  &disable_lock( &PL_IMP,  ($rt->{rt_lock})););
	    }' unless defined(&RTENTRY_LOCK);
	    eval 'sub RTENTRY_UNLOCK {
	        my($rt) = @_;
    		eval q( &unlock_enable( ($rt->{rt_intr}),  ($rt->{rt_lock})););
	    }' unless defined(&RTENTRY_UNLOCK);
	    eval 'sub IPFORWARD_RT_LOCKINIT () {
	        eval q({  &lock_alloc( &ipforward_rt_lock,  &LOCK_ALLOC_PIN,  &ROUTE_LOCK_FAMILY, -1);  &simple_lock_init( &ipforward_rt_lock); });
	    }' unless defined(&IPFORWARD_RT_LOCKINIT);
	    eval 'sub IPFORWARD_RT_LOCK () {
	        eval q( &_ipfrl =  &disable_lock( &PL_IMP,  &ipforward_rt_lock););
	    }' unless defined(&IPFORWARD_RT_LOCK);
	    eval 'sub IPFORWARD_RT_UNLOCK () {
	        eval q( &unlock_enable( &_ipfrl,  &ipforward_rt_lock););
	    }' unless defined(&IPFORWARD_RT_UNLOCK);
	} else {
	    eval 'sub ROUTE_LOCKINIT () {
	        eval q();
	    }' unless defined(&ROUTE_LOCKINIT);
	    eval 'sub ROUTE_LOCK_DECL () {
	        eval q( &NETSPL_DECL( &_rs));
	    }' unless defined(&ROUTE_LOCK_DECL);
	    eval 'sub ROUTE_READ_LOCK_DECL () {
	        eval q( &NETSPL_DECL( &_rs));
	    }' unless defined(&ROUTE_READ_LOCK_DECL);
	    eval 'sub ROUTE_READ_LOCK () {
	        eval q( &NETSPL( &_rs, &net));
	    }' unless defined(&ROUTE_READ_LOCK);
	    eval 'sub ROUTE_READ_UNLOCK () {
	        eval q( &NETSPLX( &_rs));
	    }' unless defined(&ROUTE_READ_UNLOCK);
	    eval 'sub ROUTE_READ_UNLOCK_TEMP () {
	        eval q( &NETSPLX( &_rs));
	    }' unless defined(&ROUTE_READ_UNLOCK_TEMP);
	    eval 'sub ROUTE_WRITE_LOCK () {
	        eval q( &NETSPL( &_rs, &net));
	    }' unless defined(&ROUTE_WRITE_LOCK);
	    eval 'sub ROUTE_WRITE_UNLOCK () {
	        eval q( &NETSPLX( &_rs));
	    }' unless defined(&ROUTE_WRITE_UNLOCK);
	    eval 'sub ROUTE_ISLOCKED () {
	        eval q(1);
	    }' unless defined(&ROUTE_ISLOCKED);
	    eval 'sub ROUTE_IS_READ_LOCKED () {
	        eval q();
	    }' unless defined(&ROUTE_IS_READ_LOCKED);
	    eval 'sub RTFREE {
	        my($rt) = @_;
    		eval q( &if (($rt)-> &rt_refcnt <= 1)  &rtfree($rt);  &else  &RTENTRY_UNREF(($rt)));
	    }' unless defined(&RTFREE);
	    eval 'sub RTENTRY_LOCKINIT {
	        my($rt) = @_;
    		eval q();
	    }' unless defined(&RTENTRY_LOCKINIT);
	    eval 'sub RTENTRY_LOCK {
	        my($rt) = @_;
    		eval q( &NETSPL( &_rs, &net));
	    }' unless defined(&RTENTRY_LOCK);
	    eval 'sub RTENTRY_UNLOCK {
	        my($rt) = @_;
    		eval q( &NETSPLX( &_rs));
	    }' unless defined(&RTENTRY_UNLOCK);
	    eval 'sub IPFORWARD_RT_LOCKINIT () {
	        eval q();
	    }' unless defined(&IPFORWARD_RT_LOCKINIT);
	    eval 'sub IPFORWARD_RT_LOCK () {
	        eval q( &NETSPL( &_rs, &net));
	    }' unless defined(&IPFORWARD_RT_LOCK);
	    eval 'sub IPFORWARD_RT_UNLOCK () {
	        eval q( &NETSPLX( &_rs));
	    }' unless defined(&IPFORWARD_RT_UNLOCK);
	}
	if(defined(&MFC_IMPL)) {
	}
	eval 'sub ALL_CLONING () {0;}' unless defined(&ALL_CLONING);
	eval 'sub ONNET_CLONING () {1;}' unless defined(&ONNET_CLONING);
	eval 'sub NO_CLONING () {2;}' unless defined(&NO_CLONING);
    }
}
1;
