require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IF_NDP6_H_)) {
    eval 'sub _NETINET_IF_NDP6_H_ () {1;}' unless defined(&_NETINET_IF_NDP6_H_);
    eval 'sub IFND6_TYPE () {0xff000000;}' unless defined(&IFND6_TYPE);
    eval 'sub IFND6_FLAGS () {0xff0000;}' unless defined(&IFND6_FLAGS);
    eval 'sub IFND6_LLOFF () {0xff00;}' unless defined(&IFND6_LLOFF);
    eval 'sub IFND6_L2OFF () {0xff;}' unless defined(&IFND6_L2OFF);
    eval 'sub IFND6_UNKNOWN () {0x;}' unless defined(&IFND6_UNKNOWN);
    eval 'sub IFND6_LOOP () {0x1000000;}' unless defined(&IFND6_LOOP);
    eval 'sub IFND6_IEEE () {0x2000000;}' unless defined(&IFND6_IEEE);
    eval 'sub IFND6_SIT () {0x3000000;}' unless defined(&IFND6_SIT);
    eval 'sub IFND6_TUG () {0x4000000;}' unless defined(&IFND6_TUG);
    eval 'sub IFND6_TUN () {0x5000000;}' unless defined(&IFND6_TUN);
    eval 'sub IFND6_PPP () {0x6000000;}' unless defined(&IFND6_PPP);
    eval 'sub IFND6_ATM () {0x7000000;}' unless defined(&IFND6_ATM);
    eval 'sub IFND6_VIPA () {0x8000000;}' unless defined(&IFND6_VIPA);
    eval 'sub IFND6_LLINK () {0xff000000;}' unless defined(&IFND6_LLINK);
    eval 'sub IFND6_IS_LLINK {
        my($ifp) = @_;
	    eval q(((($ifp)-> &if_ndtype &  &IFND6_TYPE) ==  &IFND6_LLINK));
    }' unless defined(&IFND6_IS_LLINK);
    eval 'sub IFND6_INLL () {0x10000;}' unless defined(&IFND6_INLL);
    eval 'sub IFND6_ADDRES () {0x20000;}' unless defined(&IFND6_ADDRES);
    eval 'sub IFND6_MTU () {0x40000;}' unless defined(&IFND6_MTU);
    eval 'sub IFND6_LLSET () {0x100000;}' unless defined(&IFND6_LLSET);
    eval 'sub GETLLADDR {
        my($ifp) = @_;
	    eval q((($ifp) + $sizeof{\'struct ifnet\'} + ((($ifp)-> &if_ndtype >> 8) & 0xff)));
    }' unless defined(&GETLLADDR);
    eval 'sub GETL2ADDR {
        my($ifp) = @_;
	    eval q((($ifp) + $sizeof{\'struct ifnet\'} + (($ifp)-> &if_ndtype & 0xff)));
    }' unless defined(&GETL2ADDR);
    if(defined(&_KERNEL)) {
	eval 'sub ln_timer () { ($ln_rt->{rt_rmx}->{rmx_expire});}' unless defined(&ln_timer);
	eval 'sub LLNDP6_PHASEDOUT () {0;}' unless defined(&LLNDP6_PHASEDOUT);
	eval 'sub LLNDP6_INCOMPLETE () {1;}' unless defined(&LLNDP6_INCOMPLETE);
	eval 'sub LLNDP6_PROBING () {2;}' unless defined(&LLNDP6_PROBING);
	eval 'sub LLNDP6_REACHABLE () {3;}' unless defined(&LLNDP6_REACHABLE);
	eval 'sub LLNDP6_BUILTIN () {4;}' unless defined(&LLNDP6_BUILTIN);
	eval 'sub M_NOPROBE () { &M_BCAST;}' unless defined(&M_NOPROBE);
	eval 'sub IFA_BOOTING () { &RTF_XRESOLVE;}' unless defined(&IFA_BOOTING);
    }
}
1;
