require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&IGMP_MINLEN)) {
    sub IGMP_MINLEN () {	8;}
}
unless(defined(&IGMP_HOST_MEMBERSHIP_QUERY)) {
    sub IGMP_HOST_MEMBERSHIP_QUERY () {	0x11;}
}
unless(defined(&IGMP_HOST_MEMBERSHIP_REPORT)) {
    sub IGMP_HOST_MEMBERSHIP_REPORT () {	0x12;}
}
unless(defined(&IGMP_DVMRP)) {
    sub IGMP_DVMRP () {	0x13;}
}
unless(defined(&IGMP_HOST_NEW_MEMBERSHIP_REPORT)) {
    sub IGMP_HOST_NEW_MEMBERSHIP_REPORT () {	0x16;}
}
unless(defined(&IGMP_HOST_LEAVE_MESSAGE)) {
    sub IGMP_HOST_LEAVE_MESSAGE () {	0x17;}
}
unless(defined(&IGMP_MTRACE)) {
    sub IGMP_MTRACE () {	0x1f;}
}
unless(defined(&IGMP_MTRACE_RESP)) {
    sub IGMP_MTRACE_RESP () {	0x1e;}
}
unless(defined(&IGMP_MAX_HOST_REPORT_DELAY)) {
    sub IGMP_MAX_HOST_REPORT_DELAY () {	10;}
}
unless(defined(&IGMP_TIMER_SCALE)) {
    sub IGMP_TIMER_SCALE () {	10;}
}
unless(defined(&IGMP_DELAYING_MEMBER)) {
    sub IGMP_DELAYING_MEMBER () {	1;}
}
unless(defined(&IGMP_IDLE_MEMBER)) {
    sub IGMP_IDLE_MEMBER () {	2;}
}
unless(defined(&IGMP_LAZY_MEMBER)) {
    sub IGMP_LAZY_MEMBER () {	3;}
}
unless(defined(&IGMP_SLEEPING_MEMBER)) {
    sub IGMP_SLEEPING_MEMBER () {	4;}
}
unless(defined(&IGMP_AWAKENING_MEMBER)) {
    sub IGMP_AWAKENING_MEMBER () {	5;}
}
unless(defined(&IGMP_OLD_ROUTER)) {
    sub IGMP_OLD_ROUTER () {	0;}
}
unless(defined(&IGMP_NEW_ROUTER)) {
    sub IGMP_NEW_ROUTER () {	1;}
}
unless(defined(&IGMP_AGE_THRESHOLD)) {
    sub IGMP_AGE_THRESHOLD () {	540;}
}
if(defined(&IGMP_STATES)) {
}
if(defined(&_KERNEL)) {
    if(defined(&IP_MULTICAST)) {
    }
    if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	eval 'sub RTI_LOCKINIT () {
	    eval q({  &lock_alloc( &rti_lock,  &LOCK_ALLOC_PIN,  &RTI_LOCK_FAMILY, -1);  &simple_lock_init( &rti_lock); });
	}' unless defined(&RTI_LOCKINIT);
	eval 'sub RTI_LOCK_DECL () {
	    eval q(\'int\'  &_rtil;);
	}' unless defined(&RTI_LOCK_DECL);
	eval 'sub RTI_LOCK () {
	    eval q( &_rtil =  &disable_lock( &PL_IMP,  &rti_lock));
	}' unless defined(&RTI_LOCK);
	eval 'sub RTI_UNLOCK () {
	    eval q( &unlock_enable( &_rtil,  &rti_lock));
	}' unless defined(&RTI_UNLOCK);
    } else {
	eval 'sub RTI_LOCKINIT () {
	    eval q();
	}' unless defined(&RTI_LOCKINIT);
	eval 'sub RTI_LOCK () {
	    eval q();
	}' unless defined(&RTI_LOCK);
	eval 'sub RTI_UNLOCK () {
	    eval q();
	}' unless defined(&RTI_UNLOCK);
    }
}
1;
