require '_h2ph_pre.ph';

no warnings 'redefine';

require 'sys/types.ph';
require 'netinet/in.ph';
require 'netinet/in_systm.ph';
unless(defined(&_NETINET_IP_H)) {
    eval 'sub _NETINET_IP_H () {1;}' unless defined(&_NETINET_IP_H);
    eval 'sub IPVERSION () {4;}' unless defined(&IPVERSION);
    if(defined( &_NO_BITFIELDS)) {
	eval 'sub ip_fwin () { &ip_flen;}' unless defined(&ip_fwin);
    } else {
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	}
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&LITTLE_ENDIAN) ? &LITTLE_ENDIAN : 0) || (defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&PDP_ENDIAN) ? &PDP_ENDIAN : 0)) {
	}
	eval 'sub ip_fv () { ($ip_vhltl->{ip_x}->{ip_xv});}' unless defined(&ip_fv);
	eval 'sub ip_fhl () { ($ip_vhltl->{ip_x}->{ip_xhl});}' unless defined(&ip_fhl);
	eval 'sub ip_ftos () { ($ip_vhltl->{ip_x}->{ip_xtos});}' unless defined(&ip_ftos);
	eval 'sub ip_flen () { ($ip_vhltl->{ip_x}->{ip_xlen});}' unless defined(&ip_flen);
	eval 'sub ip_fwin () { &ip_flen;}' unless defined(&ip_fwin);
    }
    eval 'sub ip_v () { ($ip_ff->{ip_fv});}' unless defined(&ip_v);
    eval 'sub ip_hl () { ($ip_ff->{ip_fhl});}' unless defined(&ip_hl);
    eval 'sub ip_vhl () { ($ip_ff->{ip_fvhl});}' unless defined(&ip_vhl);
    eval 'sub ip_tos () { ($ip_ff->{ip_ftos});}' unless defined(&ip_tos);
    eval 'sub ip_len () { ($ip_ff->{ip_flen});}' unless defined(&ip_len);
    eval 'sub IP_DF () {0x4000;}' unless defined(&IP_DF);
    eval 'sub IP_MF () {0x2000;}' unless defined(&IP_MF);
    eval 'sub IP_MAXPACKET () {65535;}' unless defined(&IP_MAXPACKET);
    eval 'sub IPTOS_LOWDELAY () {0x10;}' unless defined(&IPTOS_LOWDELAY);
    eval 'sub IPTOS_THROUGHPUT () {0x8;}' unless defined(&IPTOS_THROUGHPUT);
    eval 'sub IPTOS_RELIABILITY () {0x4;}' unless defined(&IPTOS_RELIABILITY);
    eval 'sub IPTOS_ECT () {0x2;}' unless defined(&IPTOS_ECT);
    eval 'sub IPTOS_CE () {0x1;}' unless defined(&IPTOS_CE);
    eval 'sub IPTOS_PREC_NETCONTROL () {0xe0;}' unless defined(&IPTOS_PREC_NETCONTROL);
    eval 'sub IPTOS_PREC_INTERNETCONTROL () {0xc0;}' unless defined(&IPTOS_PREC_INTERNETCONTROL);
    eval 'sub IPTOS_PREC_CRITIC_ECP () {0xa0;}' unless defined(&IPTOS_PREC_CRITIC_ECP);
    eval 'sub IPTOS_PREC_FLASHOVERRIDE () {0x80;}' unless defined(&IPTOS_PREC_FLASHOVERRIDE);
    eval 'sub IPTOS_PREC_FLASH () {0x60;}' unless defined(&IPTOS_PREC_FLASH);
    eval 'sub IPTOS_PREC_IMMEDIATE () {0x40;}' unless defined(&IPTOS_PREC_IMMEDIATE);
    eval 'sub IPTOS_PREC_PRIORITY () {0x20;}' unless defined(&IPTOS_PREC_PRIORITY);
    eval 'sub IPTOS_PREC_ROUTINE () {0x10;}' unless defined(&IPTOS_PREC_ROUTINE);
    eval 'sub IPOPT_COPIED {
        my($o) = @_;
	    eval q((($o)&0x80));
    }' unless defined(&IPOPT_COPIED);
    eval 'sub IPOPT_CLASS {
        my($o) = @_;
	    eval q((($o)&0x60));
    }' unless defined(&IPOPT_CLASS);
    eval 'sub IPOPT_NUMBER {
        my($o) = @_;
	    eval q((($o)&0x1f));
    }' unless defined(&IPOPT_NUMBER);
    eval 'sub IPOPT_CONTROL () {0x;}' unless defined(&IPOPT_CONTROL);
    eval 'sub IPOPT_RESERVED1 () {0x20;}' unless defined(&IPOPT_RESERVED1);
    eval 'sub IPOPT_DEBMEAS () {0x40;}' unless defined(&IPOPT_DEBMEAS);
    eval 'sub IPOPT_RESERVED2 () {0x60;}' unless defined(&IPOPT_RESERVED2);
    eval 'sub IPOPT_EOL () {0;}' unless defined(&IPOPT_EOL);
    eval 'sub IPOPT_NOP () {1;}' unless defined(&IPOPT_NOP);
    eval 'sub IPOPT_RR () {7;}' unless defined(&IPOPT_RR);
    eval 'sub IPOPT_TS () {68;}' unless defined(&IPOPT_TS);
    eval 'sub IPOPT_SECURITY () {130;}' unless defined(&IPOPT_SECURITY);
    eval 'sub IPOPT_LSRR () {131;}' unless defined(&IPOPT_LSRR);
    eval 'sub IPOPT_SATID () {136;}' unless defined(&IPOPT_SATID);
    eval 'sub IPOPT_SSRR () {137;}' unless defined(&IPOPT_SSRR);
    eval 'sub IPOPT_OPTVAL () {0;}' unless defined(&IPOPT_OPTVAL);
    eval 'sub IPOPT_OLEN () {1;}' unless defined(&IPOPT_OLEN);
    eval 'sub IPOPT_OFFSET () {2;}' unless defined(&IPOPT_OFFSET);
    eval 'sub IPOPT_MINOFF () {4;}' unless defined(&IPOPT_MINOFF);
    eval 'sub rt_pmtu {
        my($x) = @_;
	    eval q(((($x)-> &rt_proto)));
    }' unless defined(&rt_pmtu);
    eval 'sub IPP_UNEST () {0x;}' unless defined(&IPP_UNEST);
    eval 'sub IPP_INVALID () {0x1;}' unless defined(&IPP_INVALID);
    eval 'sub IPP_DISCOVER () {0x2;}' unless defined(&IPP_DISCOVER);
    eval 'sub IPP_COMPLETE () {0x3;}' unless defined(&IPP_COMPLETE);
    eval 'sub IPP_NORESP () {0x4;}' unless defined(&IPP_NORESP);
    eval 'sub IPP_DUPEDROUTE () {0x5;}' unless defined(&IPP_DUPEDROUTE);
    eval 'sub PMTU_FULLDISC () {0x1;}' unless defined(&PMTU_FULLDISC);
    eval 'sub PMTU_CURVAL () {0x2;}' unless defined(&PMTU_CURVAL);
    eval 'sub PMTU_CUREST () {0x3;}' unless defined(&PMTU_CUREST);
    eval 'sub PMTU_NEXTMTU () {0x4;}' unless defined(&PMTU_NEXTMTU);
    eval 'sub PMTU_TIMEOUT () {0x5;}' unless defined(&PMTU_TIMEOUT);
    eval 'sub PMTU_ICMPID () {0x;}' unless defined(&PMTU_ICMPID);
    eval 'sub MIN_MTU () {68;}' unless defined(&MIN_MTU);
    eval 'sub PMTU_RESPTIMEOUT () {1;}' unless defined(&PMTU_RESPTIMEOUT);
    eval 'sub PMTU_MAXTRIES () {3;}' unless defined(&PMTU_MAXTRIES);
    eval 'sub DGD_ICMPID () {0x1;}' unless defined(&DGD_ICMPID);
    eval 'sub ECH_ICMPID () {0x2;}' unless defined(&ECH_ICMPID);
    if(defined( &_KERNEL) || defined( &_NO_BITFIELDS)) {
    } else {
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	}
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&LITTLE_ENDIAN) ? &LITTLE_ENDIAN : 0) || (defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&PDP_ENDIAN) ? &PDP_ENDIAN : 0)) {
	}
	eval 'sub ipt_code () { ($ipt_clpof->{ip_x}->{ipt_xcode});}' unless defined(&ipt_code);
	eval 'sub ipt_len () { ($ipt_clpof->{ip_x}->{ipt_xlen});}' unless defined(&ipt_len);
	eval 'sub ipt_ptr () { ($ipt_clpof->{ip_x}->{ipt_xptr});}' unless defined(&ipt_ptr);
	eval 'sub ipt_oflw () { ($ipt_clpof->{ip_x}->{ipt_xoflw});}' unless defined(&ipt_oflw);
	eval 'sub ipt_flg () { ($ipt_clpof->{ip_x}->{ipt_xflg});}' unless defined(&ipt_flg);
    }
    eval 'sub IPOPT_TS_TSONLY () {0;}' unless defined(&IPOPT_TS_TSONLY);
    eval 'sub IPOPT_TS_TSANDADDR () {1;}' unless defined(&IPOPT_TS_TSANDADDR);
    eval 'sub IPOPT_TS_PRESPEC () {3;}' unless defined(&IPOPT_TS_PRESPEC);
    eval 'sub IPOPT_SECUR_UNCLASS () {0x;}' unless defined(&IPOPT_SECUR_UNCLASS);
    eval 'sub IPOPT_SECUR_CONFID () {0xf135;}' unless defined(&IPOPT_SECUR_CONFID);
    eval 'sub IPOPT_SECUR_EFTO () {0x789a;}' unless defined(&IPOPT_SECUR_EFTO);
    eval 'sub IPOPT_SECUR_MMMM () {0xbc4d;}' unless defined(&IPOPT_SECUR_MMMM);
    eval 'sub IPOPT_SECUR_PROG () {0x5e26;}' unless defined(&IPOPT_SECUR_PROG);
    eval 'sub IPOPT_SECUR_RESTR () {0xaf13;}' unless defined(&IPOPT_SECUR_RESTR);
    eval 'sub IPOPT_SECUR_SECRET () {0xd788;}' unless defined(&IPOPT_SECUR_SECRET);
    eval 'sub IPOPT_SECUR_TOPSECRET () {0x6bc5;}' unless defined(&IPOPT_SECUR_TOPSECRET);
    eval 'sub MAXTTL () {255;}' unless defined(&MAXTTL);
    eval 'sub IPDEFTTL () {64;}' unless defined(&IPDEFTTL);
    eval 'sub IPFRAGTTL () {60;}' unless defined(&IPFRAGTTL);
    eval 'sub IPTTLDEC () {1;}' unless defined(&IPTTLDEC);
    eval 'sub IP_MSS () {576;}' unless defined(&IP_MSS);
}
1;
