require '_h2ph_pre.ph';

no warnings 'redefine';

require 'net/route.ph';
unless(defined(&_IP_MROUTE_)) {
    eval 'sub _IP_MROUTE_ () {1;}' unless defined(&_IP_MROUTE_);
    eval 'sub MRT_INIT () {100;}' unless defined(&MRT_INIT);
    eval 'sub MRT_DONE () {101;}' unless defined(&MRT_DONE);
    eval 'sub MRT_ADD_VIF () {102;}' unless defined(&MRT_ADD_VIF);
    eval 'sub MRT_DEL_VIF () {103;}' unless defined(&MRT_DEL_VIF);
    eval 'sub MRT_ADD_MFC () {104;}' unless defined(&MRT_ADD_MFC);
    eval 'sub MRT_DEL_MFC () {105;}' unless defined(&MRT_DEL_MFC);
    eval 'sub MRT_VERSION () {106;}' unless defined(&MRT_VERSION);
    eval 'sub MRT_ASSERT () {107;}' unless defined(&MRT_ASSERT);
    eval 'sub KP_VERSION () {0x305;}' unless defined(&KP_VERSION);
    eval 'sub microtime {
        my($tv) = @_;
	    eval q({ \'struct timestruc_t\'  &ct;  &curtime( &ct); -> &tv_sec =  ($ct->{tv_sec}); -> &tv_usec =  ($ct->{tv_nsec}) / 1000; });
    }' unless defined(&microtime);
    eval 'sub GET_TIME {
        my($t) = @_;
	    eval q( &microtime($t));
    }' unless defined(&GET_TIME);
    eval 'sub MAXVIFS () {32;}' unless defined(&MAXVIFS);
    eval 'sub ALL_VIFS () {( &vifi_t)-1;}' unless defined(&ALL_VIFS);
    eval 'sub VIFM_SET {
        my($n, $m) = @_;
	    eval q((($m) |= (1<< ($n))));
    }' unless defined(&VIFM_SET);
    eval 'sub VIFM_CLR {
        my($n, $m) = @_;
	    eval q((($m) &= ~(1<< ($n))));
    }' unless defined(&VIFM_CLR);
    eval 'sub VIFM_ISSET {
        my($n, $m) = @_;
	    eval q((($m) & (1<< ($n))));
    }' unless defined(&VIFM_ISSET);
    eval 'sub VIFM_CLRALL {
        my($m) = @_;
	    eval q((($m) = 0x));
    }' unless defined(&VIFM_CLRALL);
    eval 'sub VIFM_COPY {
        my($mfrom, $mto) = @_;
	    eval q((($mto) = ($mfrom)));
    }' unless defined(&VIFM_COPY);
    eval 'sub VIFM_SAME {
        my($m1, $m2) = @_;
	    eval q((($m1) == ($m2)));
    }' unless defined(&VIFM_SAME);
    eval 'sub VIFF_TUNNEL () {0x1;}' unless defined(&VIFF_TUNNEL);
    eval 'sub VIFF_SRCRT () {0x2;}' unless defined(&VIFF_SRCRT);
    if(defined(&RSVP_ISI)) {
    }
    eval 'sub IGMPMSG_NOCACHE () {1;}' unless defined(&IGMPMSG_NOCACHE);
    eval 'sub IGMPMSG_WRONGVIF () {2;}' unless defined(&IGMPMSG_WRONGVIF);
    if(defined(&UPCALL_TIMING)) {
    }
    eval 'sub MFCTBLSIZ () {256;}' unless defined(&MFCTBLSIZ);
    if(((defined(&MFCTBLSIZ) ? &MFCTBLSIZ : 0) & ((defined(&MFCTBLSIZ) ? &MFCTBLSIZ : 0) - 1)) == 0) {
	eval 'sub MFCHASHMOD {
	    my($h) = @_;
    	    eval q((($h) & ( &MFCTBLSIZ - 1)));
	}' unless defined(&MFCHASHMOD);
    } else {
	eval 'sub MFCHASHMOD {
	    my($h) = @_;
    	    eval q((($h) %  &MFCTBLSIZ));
	}' unless defined(&MFCHASHMOD);
    }
    eval 'sub MAX_UPQ () {4;}' unless defined(&MAX_UPQ);
    eval 'sub MAX_BKT_SIZE () {10000;}' unless defined(&MAX_BKT_SIZE);
    eval 'sub MAXQSIZE () {10;}' unless defined(&MAXQSIZE);
    if(defined(&_KERNEL)) {
	if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	    eval 'sub IP_MROUTE_LOCKINIT () {
	        eval q({  &lock_alloc( &ip_mrouter_lock,  &LOCK_ALLOC_PIN,  &IP_MROUTE_LOCK_FAM, -1);  &simple_lock_init( &ip_mrouter_lock); });
	    }' unless defined(&IP_MROUTE_LOCKINIT);
	    eval 'sub IP_MROUTE_LOCK_DECL () {
	        eval q(\'int\'  &_ipmrl_spl;);
	    }' unless defined(&IP_MROUTE_LOCK_DECL);
	    eval 'sub IP_MROUTE_LOCK () {
	        eval q( &_ipmrl_spl =  &disable_lock( &PL_IMP,  &ip_mrouter_lock));
	    }' unless defined(&IP_MROUTE_LOCK);
	    eval 'sub IP_MROUTE_UNLOCK () {
	        eval q( &unlock_enable( &_ipmrl_spl,  &ip_mrouter_lock));
	    }' unless defined(&IP_MROUTE_UNLOCK);
	} else {
	    eval 'sub IP_MROUTE_LOCKINIT () {
	        eval q();
	    }' unless defined(&IP_MROUTE_LOCKINIT);
	    eval 'sub IP_MROUTE_LOCK () {
	        eval q();
	    }' unless defined(&IP_MROUTE_LOCK);
	    eval 'sub IP_MROUTE_UNLOCK () {
	        eval q();
	    }' unless defined(&IP_MROUTE_UNLOCK);
	}
    }
}
1;
