require '_h2ph_pre.ph';

no warnings 'redefine';

require 'netinet/ip.ph';
unless(defined(&_NETINET_TCP_H)) {
    eval 'sub _NETINET_TCP_H () {1;}' unless defined(&_NETINET_TCP_H);
    eval 'sub th_off () { &ip_v;}' unless defined(&th_off);
    eval 'sub th_x2 () { &ip_hl;}' unless defined(&th_x2);
    eval 'sub th_xoff () { &ip_vhl;}' unless defined(&th_xoff);
    eval 'sub th_flags () { &ip_tos;}' unless defined(&th_flags);
    eval 'sub th_win () { ($ip_ff->{ip_fwin});}' unless defined(&th_win);
    eval 'sub TH_FIN () {0x1;}' unless defined(&TH_FIN);
    eval 'sub TH_SYN () {0x2;}' unless defined(&TH_SYN);
    eval 'sub TH_RST () {0x4;}' unless defined(&TH_RST);
    eval 'sub TH_PUSH () {0x8;}' unless defined(&TH_PUSH);
    eval 'sub TH_ACK () {0x10;}' unless defined(&TH_ACK);
    eval 'sub TH_URG () {0x20;}' unless defined(&TH_URG);
    eval 'sub TH_ECN_ECHO () {0x40;}' unless defined(&TH_ECN_ECHO);
    eval 'sub TH_CWR () {0x80;}' unless defined(&TH_CWR);
    eval 'sub TCPOPT_EOL () {0;}' unless defined(&TCPOPT_EOL);
    eval 'sub TCPOPT_NOP () {1;}' unless defined(&TCPOPT_NOP);
    eval 'sub TCPOPT_MAXSEG () {2;}' unless defined(&TCPOPT_MAXSEG);
    eval 'sub TCPOPT_WINDOWSCALE () {3;}' unless defined(&TCPOPT_WINDOWSCALE);
    eval 'sub TCPOPT_SACK_PERMITTED () {4;}' unless defined(&TCPOPT_SACK_PERMITTED);
    eval 'sub TCPOPT_SACK () {5;}' unless defined(&TCPOPT_SACK);
    eval 'sub TCPOPT_TIMESTAMP () {8;}' unless defined(&TCPOPT_TIMESTAMP);
    eval 'sub TCPOPT_AH () {194;}' unless defined(&TCPOPT_AH);
    eval 'sub TCP_MAXWINDOWSCALE () {14;}' unless defined(&TCP_MAXWINDOWSCALE);
    eval 'sub TCP_FASTNAME () {0x101080a;}' unless defined(&TCP_FASTNAME);
    eval 'sub TCP_TIMESTAMP_OPTLEN () {12;}' unless defined(&TCP_TIMESTAMP_OPTLEN);
    eval 'sub TCP_24DAYS_WORTH_OF_SLOWTICKS () {(24* 24* 60* 60*  &PR_SLOWHZ);}' unless defined(&TCP_24DAYS_WORTH_OF_SLOWTICKS);
    eval 'sub TCPOLEN_SACK_PERMITTED () {2;}' unless defined(&TCPOLEN_SACK_PERMITTED);
    eval 'sub TCPOPT_SACK_PERMIT_HDR () {( &TCPOPT_NOP<<24| &TCPOPT_NOP<<16| &TCPOPT_SACK_PERMITTED<<8| &TCPOLEN_SACK_PERMITTED);}' unless defined(&TCPOPT_SACK_PERMIT_HDR);
    eval 'sub TCPOPT_SACK_HDR () {( &TCPOPT_NOP<<24| &TCPOPT_NOP<<16| &TCPOPT_SACK<<8);}' unless defined(&TCPOPT_SACK_HDR);
    eval 'sub TCPOLEN_SACK () {8;}' unless defined(&TCPOLEN_SACK);
    eval 'sub TCP_MAX_SACK () {4;}' unless defined(&TCP_MAX_SACK);
    eval 'sub TCP_MSS () {512;}' unless defined(&TCP_MSS);
    eval 'sub TCP_MAXWIN () {65535;}' unless defined(&TCP_MAXWIN);
    eval 'sub TCP_NODELAY () {0x1;}' unless defined(&TCP_NODELAY);
    eval 'sub TCP_MAXSEG () {0x2;}' unless defined(&TCP_MAXSEG);
    eval 'sub TCP_RFC1323 () {0x4;}' unless defined(&TCP_RFC1323);
    eval 'sub TCP_STDURG () {0x10;}' unless defined(&TCP_STDURG);
    eval 'sub TCP_LUID () {0x20;}' unless defined(&TCP_LUID);
    eval 'sub TCP_ACLFLUSH () {0x21;}' unless defined(&TCP_ACLFLUSH);
    eval 'sub TCP_ACLCLEAR () {0x22;}' unless defined(&TCP_ACLCLEAR);
    eval 'sub TCP_ACLADD () {0x23;}' unless defined(&TCP_ACLADD);
    eval 'sub TCP_ACLDEL () {0x24;}' unless defined(&TCP_ACLDEL);
    eval 'sub TCP_ACLLS () {0x25;}' unless defined(&TCP_ACLLS);
    eval 'sub TCP_ACLBIND () {0x26;}' unless defined(&TCP_ACLBIND);
    eval 'sub TCP_SETPRIV () {0x27;}' unless defined(&TCP_SETPRIV);
    eval 'sub TCP_UNSETPRIV () {0x28;}' unless defined(&TCP_UNSETPRIV);
    eval 'sub TCP_LSPRIV () {0x29;}' unless defined(&TCP_LSPRIV);
    eval 'sub TCP_ACLGID () {0x1;}' unless defined(&TCP_ACLGID);
    eval 'sub TCP_ACLUID () {0x2;}' unless defined(&TCP_ACLUID);
    eval 'sub TCP_ACLSUBNET () {0x4;}' unless defined(&TCP_ACLSUBNET);
    eval 'sub TCP_ACLDENY () {0x8;}' unless defined(&TCP_ACLDENY);
    eval 'sub TCP_DELAY_ACK_SYN () {0x1;}' unless defined(&TCP_DELAY_ACK_SYN);
    eval 'sub TCP_DELAY_ACK_FIN () {0x2;}' unless defined(&TCP_DELAY_ACK_FIN);
    eval 'sub TCP_MAXBURST () {8;}' unless defined(&TCP_MAXBURST);
}
1;
