require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_TCP_TIMER_H_)) {
    eval 'sub _TCP_TIMER_H_ () {1;}' unless defined(&_TCP_TIMER_H_);
    eval 'sub TCPT_NTIMERS () {4;}' unless defined(&TCPT_NTIMERS);
    eval 'sub TCPT_REXMT () {0;}' unless defined(&TCPT_REXMT);
    eval 'sub TCPT_PERSIST () {1;}' unless defined(&TCPT_PERSIST);
    eval 'sub TCPT_KEEP () {2;}' unless defined(&TCPT_KEEP);
    eval 'sub TCPT_2MSL () {3;}' unless defined(&TCPT_2MSL);
    eval 'sub TCP_TTL () {60;}' unless defined(&TCP_TTL);
    eval 'sub TCPTV_MSL () {( 30* &PR_SLOWHZ);}' unless defined(&TCPTV_MSL);
    eval 'sub TCPTV_SRTTBASE () {0;}' unless defined(&TCPTV_SRTTBASE);
    eval 'sub TCPTV_SRTTDFLT () {( 3* &PR_SLOWHZ);}' unless defined(&TCPTV_SRTTDFLT);
    eval 'sub TCPTV_PERSMIN () {( 5* &PR_SLOWHZ);}' unless defined(&TCPTV_PERSMIN);
    eval 'sub TCPTV_PERSMAX () {( 60* &PR_SLOWHZ);}' unless defined(&TCPTV_PERSMAX);
    eval 'sub TCPTV_KEEP_INIT () {( 75* &PR_SLOWHZ);}' unless defined(&TCPTV_KEEP_INIT);
    eval 'sub TCPTV_KEEP_IDLE () {(120*60* &PR_SLOWHZ);}' unless defined(&TCPTV_KEEP_IDLE);
    eval 'sub TCPTV_KEEPINTVL () {( 75* &PR_SLOWHZ);}' unless defined(&TCPTV_KEEPINTVL);
    eval 'sub TCPTV_KEEPCNT () {8;}' unless defined(&TCPTV_KEEPCNT);
    eval 'sub TCPTV_MIN () {( 1* &PR_SLOWHZ);}' unless defined(&TCPTV_MIN);
    eval 'sub TCPTV_REXMTMAX () {( 64* &PR_SLOWHZ);}' unless defined(&TCPTV_REXMTMAX);
    eval 'sub TCP_LINGERTIME () {120;}' unless defined(&TCP_LINGERTIME);
    eval 'sub TCPTV_TIME_WAIT () {15;}' unless defined(&TCPTV_TIME_WAIT);
    eval 'sub TCPTV_AOOT () {1;}' unless defined(&TCPTV_AOOT);
    unless(defined(&CONST)) {
	eval 'sub CONST () {1;}' unless defined(&CONST);
    }
    if(defined(&TCPTIMERS)) {
    }
    eval 'sub TCPT_RANGESET {
        my($tv, $value, $tvmin, $tvmax) = @_;
	    eval q({ ($tv) = ($value);  &if (($tv) < ($tvmin)) ($tv) = ($tvmin);  &else  &if (($tv) > ($tvmax)) ($tv) = ($tvmax); });
    }' unless defined(&TCPT_RANGESET);
    if(defined(&_KERNEL)) {
	eval 'sub TCP_BACKOFF {
	    my($x) = @_;
    	    eval q(( ((($x)+1) >= ( &tcp_rtolimit)) ? ( &tcp_rtohigh) : ( &tcp_rtolow) << ((( &tcp_rtoshift)*($x))/( &tcp_rtolimit)) ));
	}' unless defined(&TCP_BACKOFF);
    }
}
1;
