require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_TCPIP_H_)) {
    eval 'sub _TCPIP_H_ () {1;}' unless defined(&_TCPIP_H_);
    require 'netinet/ip6.ph';
    require 'netinet/ip6_var.ph';
    require 'netinet/tcp.ph';
    if(defined(&__64BIT_KERNEL)) {
    }
    unless(defined(&__64BIT__)) {
	eval 'sub ti_next () { ($ti_i->{ih_next});}' unless defined(&ti_next);
	eval 'sub ti_prev () { ($ti_i->{ih_prev});}' unless defined(&ti_prev);
    }
    eval 'sub ti_x1 () { ($ti_i->{ih_x1});}' unless defined(&ti_x1);
    eval 'sub ti_pr () { ($ti_i->{ih_pr});}' unless defined(&ti_pr);
    eval 'sub ti_len () { ($ti_i->{ih_len});}' unless defined(&ti_len);
    eval 'sub ti_src () { ($ti_i->{ih_src});}' unless defined(&ti_src);
    eval 'sub ti_dst () { ($ti_i->{ih_dst});}' unless defined(&ti_dst);
    eval 'sub ti_sport () { ($ti_t->{th_sport});}' unless defined(&ti_sport);
    eval 'sub ti_dport () { ($ti_t->{th_dport});}' unless defined(&ti_dport);
    eval 'sub ti_seq () { ($ti_t->{th_seq});}' unless defined(&ti_seq);
    eval 'sub ti_ack () { ($ti_t->{th_ack});}' unless defined(&ti_ack);
    eval 'sub ti_x2 () { ($ti_t->{th_x2});}' unless defined(&ti_x2);
    eval 'sub ti_off () { ($ti_t->{th_off});}' unless defined(&ti_off);
    eval 'sub ti_xoff () { ($ti_t->{th_xoff});}' unless defined(&ti_xoff);
    eval 'sub ti_flags () { ($ti_t->{th_flags});}' unless defined(&ti_flags);
    eval 'sub ti_win () { ($ti_t->{th_win});}' unless defined(&ti_win);
    eval 'sub ti_sum () { ($ti_t->{th_sum});}' unless defined(&ti_sum);
    eval 'sub ti_urp () { ($ti_t->{th_urp});}' unless defined(&ti_urp);
    eval 'sub ti6_head () { ($ti6_i->{ip6_head});}' unless defined(&ti6_head);
    eval 'sub ti6_len () { ($ti6_i->{ip6_len});}' unless defined(&ti6_len);
    eval 'sub ti6_nh () { ($ti6_i->{ip6_nh});}' unless defined(&ti6_nh);
    eval 'sub ti6_hlim () { ($ti6_i->{ip6_hlim});}' unless defined(&ti6_hlim);
    eval 'sub ti6_src () { ($ti6_i->{ip6_src});}' unless defined(&ti6_src);
    eval 'sub ti6_dst () { ($ti6_i->{ip6_dst});}' unless defined(&ti6_dst);
    eval 'sub ti6_sport () { ($ti6_t->{th_sport});}' unless defined(&ti6_sport);
    eval 'sub ti6_dport () { ($ti6_t->{th_dport});}' unless defined(&ti6_dport);
    eval 'sub ti6_seq () { ($ti6_t->{th_seq});}' unless defined(&ti6_seq);
    eval 'sub ti6_ack () { ($ti6_t->{th_ack});}' unless defined(&ti6_ack);
    eval 'sub ti6_x2 () { ($ti6_t->{th_x2});}' unless defined(&ti6_x2);
    eval 'sub ti6_x1 () { ($ti6_t->{th_x1});}' unless defined(&ti6_x1);
    eval 'sub ti6_off () { ($ti6_t->{th_off});}' unless defined(&ti6_off);
    eval 'sub ti6_xoff () { ($ti6_t->{th_xoff});}' unless defined(&ti6_xoff);
    eval 'sub ti6_flags () { ($ti6_t->{th_flags});}' unless defined(&ti6_flags);
    eval 'sub ti6_win () { ($ti6_t->{th_win});}' unless defined(&ti6_win);
    eval 'sub ti6_sum () { ($ti6_t->{th_sum});}' unless defined(&ti6_sum);
    eval 'sub ti6_urp () { ($ti6_t->{th_urp});}' unless defined(&ti6_urp);
    eval 'sub tr_i6 () { ($tr_ti6->{ti6_i});}' unless defined(&tr_i6);
    eval 'sub tr_head () { ($tr_ti6->{ti6_head});}' unless defined(&tr_head);
    eval 'sub tr_len () { ($tr_ti6->{ti6_len});}' unless defined(&tr_len);
    eval 'sub tr_nh () { ($tr_ti6->{ti6_nh});}' unless defined(&tr_nh);
    eval 'sub tr_hlim () { ($tr_ti6->{ti6_hlim});}' unless defined(&tr_hlim);
    eval 'sub tr_src () { ($tr_ti6->{ti6_src});}' unless defined(&tr_src);
    eval 'sub tr_dst () { ($tr_ti6->{ti6_dst});}' unless defined(&tr_dst);
    eval 'sub tr_t () { ($tr_ti6->{ti6_t});}' unless defined(&tr_t);
    eval 'sub tr_sport () { ($tr_ti6->{ti6_sport});}' unless defined(&tr_sport);
    eval 'sub tr_dport () { ($tr_ti6->{ti6_dport});}' unless defined(&tr_dport);
    eval 'sub tr_seq () { ($tr_ti6->{ti6_seq});}' unless defined(&tr_seq);
    eval 'sub tr_ack () { ($tr_ti6->{ti6_ack});}' unless defined(&tr_ack);
    eval 'sub tr_x2 () { ($tr_ti6->{ti6_x2});}' unless defined(&tr_x2);
    eval 'sub tr_off () { ($tr_ti6->{ti6_off});}' unless defined(&tr_off);
    eval 'sub tr_xoff () { ($tr_ti6->{ti6_xoff});}' unless defined(&tr_xoff);
    eval 'sub tr_flags () { ($tr_ti6->{ti6_flags});}' unless defined(&tr_flags);
    eval 'sub tr_win () { ($tr_ti6->{ti6_win});}' unless defined(&tr_win);
    eval 'sub tr_sum () { ($tr_ti6->{ti6_sum});}' unless defined(&tr_sum);
    eval 'sub tr_urp () { ($tr_ti6->{ti6_urp});}' unless defined(&tr_urp);
    eval 'sub tt_pr () { ($tt_i->{ih_pr});}' unless defined(&tt_pr);
    eval 'sub tt_len () { ($tt_i->{ih_len});}' unless defined(&tt_len);
    eval 'sub tt_src () { ($tt_i->{ih_src});}' unless defined(&tt_src);
    eval 'sub tt_dst () { ($tt_i->{ih_dst});}' unless defined(&tt_dst);
    eval 'sub tt_sport () { ($tt_t->{th_sport});}' unless defined(&tt_sport);
    eval 'sub tt_dport () { ($tt_t->{th_dport});}' unless defined(&tt_dport);
    eval 'sub tt_off () { ($tt_t->{th_off});}' unless defined(&tt_off);
    eval 'sub tt_xoff () { ($tt_t->{th_xoff});}' unless defined(&tt_xoff);
    eval 'sub tt_pr6 () { ($tt_i6->{ih6_pr});}' unless defined(&tt_pr6);
    eval 'sub tt_len6 () { ($tt_i6->{ih6_len});}' unless defined(&tt_len6);
}
1;
