require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ISO__)) {
    eval 'sub __ISO__ () {1;}' unless defined(&__ISO__);
    eval 'sub ISOPROTO_TP_CONS () {24;}' unless defined(&ISOPROTO_TP_CONS);
    eval 'sub ISOPROTO_TP0 () {25;}' unless defined(&ISOPROTO_TP0);
    eval 'sub ISOPROTO_TP1 () {26;}' unless defined(&ISOPROTO_TP1);
    eval 'sub ISOPROTO_TP2 () {27;}' unless defined(&ISOPROTO_TP2);
    eval 'sub ISOPROTO_TP3 () {28;}' unless defined(&ISOPROTO_TP3);
    eval 'sub ISOPROTO_TP4 () {29;}' unless defined(&ISOPROTO_TP4);
    eval 'sub ISOPROTO_TP () { &ISOPROTO_TP4;}' unless defined(&ISOPROTO_TP);
    eval 'sub ISOPROTO_CLTP () {30;}' unless defined(&ISOPROTO_CLTP);
    eval 'sub ISOPROTO_CLNP () {31;}' unless defined(&ISOPROTO_CLNP);
    eval 'sub ISOPROTO_X25 () {32;}' unless defined(&ISOPROTO_X25);
    eval 'sub ISOPROTO_INACT_NL () {33;}' unless defined(&ISOPROTO_INACT_NL);
    eval 'sub ISOPROTO_ESIS () {34;}' unless defined(&ISOPROTO_ESIS);
    eval 'sub ISOPROTO_INTRAISIS () {35;}' unless defined(&ISOPROTO_INTRAISIS);
    eval 'sub ISOPROTO_RAW () {255;}' unless defined(&ISOPROTO_RAW);
    eval 'sub ISOPROTO_MAX () {256;}' unless defined(&ISOPROTO_MAX);
    eval 'sub ISO_PORT_RESERVED () {1024;}' unless defined(&ISO_PORT_RESERVED);
    eval 'sub ISO_PORT_USERRESERVED () {5000;}' unless defined(&ISO_PORT_USERRESERVED);
    eval 'sub ISO_PORT_MAINT () {501;}' unless defined(&ISO_PORT_MAINT);
    eval 'sub ISO_PORT_ECHO () {507;}' unless defined(&ISO_PORT_ECHO);
    eval 'sub ISO_PORT_DISCARD () {509;}' unless defined(&ISO_PORT_DISCARD);
    eval 'sub ISO_PORT_SYSTAT () {511;}' unless defined(&ISO_PORT_SYSTAT);
    eval 'sub ISO_PORT_NETSTAT () {515;}' unless defined(&ISO_PORT_NETSTAT);
    eval 'sub ISO_PORT_LOGIN () {513;}' unless defined(&ISO_PORT_LOGIN);
    eval 'sub ISO_PORT_PUBLIC () {1024;}' unless defined(&ISO_PORT_PUBLIC);
    eval 'sub ISO8473_CLNP () {0x81;}' unless defined(&ISO8473_CLNP);
    eval 'sub ISO9542_ESIS () {0x82;}' unless defined(&ISO9542_ESIS);
    eval 'sub ISO9542X25_ESIS () {0x8a;}' unless defined(&ISO9542X25_ESIS);
    eval 'sub ISO10589_ISIS () {0x83;}' unless defined(&ISO10589_ISIS);
    unless(defined(&IN_CLASSA_NET)) {
	require 'netinet/in.ph';
    }
    eval 'sub siso_nlen () { ($siso_addr->{isoa_len});}' unless defined(&siso_nlen);
    eval 'sub siso_data () { ($siso_addr->{isoa_genaddr});}' unless defined(&siso_data);
    eval 'sub TSEL {
        my($s) = @_;
	    eval q(((($s)-> &siso_data + ($s)-> &siso_nlen)));
    }' unless defined(&TSEL);
    eval 'sub TSEL_SHORT {
        my($s) = @_;
	    eval q(( *(( &TSEL($s))) ));
    }' unless defined(&TSEL_SHORT);
    eval 'sub SAME_ISOADDR {
        my($a, $b) = @_;
	    eval q(( &bcmp(-> &siso_data, -> &siso_data, ($a)-> &siso_nlen)==0));
    }' unless defined(&SAME_ISOADDR);
    eval 'sub AFI_37 () {0x37;}' unless defined(&AFI_37);
    eval 'sub AFI_OSINET () {0x47;}' unless defined(&AFI_OSINET);
    eval 'sub AFI_RFC986 () {0x47;}' unless defined(&AFI_RFC986);
    eval 'sub AFI_SNA () {0x;}' unless defined(&AFI_SNA);
    eval 'sub ADDR37_IDI_LEN () {7;}' unless defined(&ADDR37_IDI_LEN);
    eval 'sub ADDR37_DSP_LEN () {0;}' unless defined(&ADDR37_DSP_LEN);
    eval 'sub IDI_RFC986 () {6;}' unless defined(&IDI_RFC986);
    eval 'sub ADDRRFC986_IDI_LEN () {2;}' unless defined(&ADDRRFC986_IDI_LEN);
    eval 'sub IDI_OSINET () {4;}' unless defined(&IDI_OSINET);
    eval 'sub ADDROSINET_IDI_LEN () {2;}' unless defined(&ADDROSINET_IDI_LEN);
    eval 'sub OVLOSINET_ORGID_LEN () {2;}' unless defined(&OVLOSINET_ORGID_LEN);
    eval 'sub OVLOSINET_SNETID_LEN () {2;}' unless defined(&OVLOSINET_SNETID_LEN);
    eval 'sub MAX_SNPALEN () {8;}' unless defined(&MAX_SNPALEN);
    eval 'sub DLSAP_LEN () {1;}' unless defined(&DLSAP_LEN);
    eval 'sub NSEL_LEN () {1;}' unless defined(&NSEL_LEN);
    eval 'sub MAX_DTE_DIGITS () {14;}' unless defined(&MAX_DTE_DIGITS);
    eval 'sub SOCKADDR_OSI_NSAP_LEN {
        my($so) = @_;
	    eval q((($so)-> &siso_nlen));
    }' unless defined(&SOCKADDR_OSI_NSAP_LEN);
    eval 'sub SOCKADDR_OSI_AFI {
        my($so) = @_;
	    eval q((( (($so)-> &siso_data))-> &isoa_afi));
    }' unless defined(&SOCKADDR_OSI_AFI);
    eval 'sub SOCKADDR_TO_X121 {
        my($so) = @_;
	    eval q((( (($so)-> &siso_data))-> ($u->{addr_37}->{x121})));
    }' unless defined(&SOCKADDR_TO_X121);
    eval 'sub CONS_LOADED () {( ($cons_fn->{cons_output}));}' unless defined(&CONS_LOADED);
    if(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub _offsetof {
        my($t, $m) = @_;
	    eval q((((($t *)0)->$m)));
    }' unless defined(&_offsetof);
}
1;
