require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ia_ifp)) {
    sub ia_ifp () {	 ($ia_ifa->{ifa_ifp});}
}
unless(defined(&ia_flags)) {
    sub ia_flags () {	 ($ia_ifa->{ifa_flags});}
}
unless(defined(&ia_broadaddr)) {
    sub ia_broadaddr () {	 &ia_dstaddr;}
}
unless(defined(&IA_SIS)) {
    sub IA_SIS {
	my($ia) = @_;
	eval q(((($ia)-> &ia_addr)));
    }
}
unless(defined(&SIOCDIFADDR_ISO)) {
    sub SIOCDIFADDR_ISO () {	 &_IOW(ord('i'),25, 'struct iso_ifreq');}
}
unless(defined(&SIOCAIFADDR_ISO)) {
    sub SIOCAIFADDR_ISO () {	 &_IOW(ord('i'),26, 'struct iso_aliasreq');}
}
unless(defined(&SIOCGIFADDR_ISO)) {
    sub SIOCGIFADDR_ISO () {	 &_IOWR(ord('i'),33, 'struct iso_ifreq');}
}
unless(defined(&SIOCGIFDSTADDR_ISO)) {
    sub SIOCGIFDSTADDR_ISO () {	 &_IOWR(ord('i'),34, 'struct iso_ifreq');}
}
unless(defined(&SIOCGIFNETMASK_ISO)) {
    sub SIOCGIFNETMASK_ISO () {	 &_IOWR(ord('i'),37, 'struct iso_ifreq');}
}
unless(defined(&SIOCSSYSTYPE_ISO)) {
    sub SIOCSSYSTYPE_ISO () {	 &_IOW(ord('i'),102,'int');}
}
if(defined(&_KERNEL)) {
}
1;
