require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__TP_SEQ__)) {
    eval 'sub __TP_SEQ__ () {1;}' unless defined(&__TP_SEQ__);
    eval 'sub SEQ {
        my($tpcb,$x) = @_;
	    eval q((($x) & ($tpcb)-> &tp_seqmask));
    }' unless defined(&SEQ);
    eval 'sub SEQ_GT {
        my($tpcb, $seq, $operand ) = @_;
	    eval q(( ((-) > 0)? ((-) < -> &tp_seqhalf): !(-(-) < ($tpcb)-> &tp_seqhalf)));
    }' unless defined(&SEQ_GT);
    eval 'sub SEQ_GEQ {
        my($tpcb, $seq, $operand ) = @_;
	    eval q(( ((-) >= 0)? ((-) < -> &tp_seqhalf): !((-(-)) < ($tpcb)-> &tp_seqhalf)));
    }' unless defined(&SEQ_GEQ);
    eval 'sub SEQ_LEQ {
        my($tpcb, $seq, $operand ) = @_;
	    eval q(( ((-) <= 0)? ((-(-)) < -> &tp_seqhalf): !((-) < ($tpcb)-> &tp_seqhalf)));
    }' unless defined(&SEQ_LEQ);
    eval 'sub SEQ_LT {
        my($tpcb, $seq, $operand ) = @_;
	    eval q(( ((-) < 0)? ((-(-)) < -> &tp_seqhalf): !((-) < ($tpcb)-> &tp_seqhalf)));
    }' unless defined(&SEQ_LT);
    eval 'sub SEQ_MIN {
        my($tpcb, $a, $b) = @_;
	    eval q((  &SEQ_GT($tpcb, $a, $b) ? $b : $a));
    }' unless defined(&SEQ_MIN);
    eval 'sub SEQ_MAX {
        my($tpcb, $a, $b) = @_;
	    eval q((  &SEQ_GT($tpcb, $a, $b) ? $a : $b));
    }' unless defined(&SEQ_MAX);
    eval 'sub SEQ_INC {
        my($tpcb, $Seq) = @_;
	    eval q(((++$Seq), (($Seq) &= ($tpcb)-> &tp_seqmask)));
    }' unless defined(&SEQ_INC);
    eval 'sub SEQ_DEC {
        my($tpcb, $Seq) = @_;
	    eval q(( = ((+(($tpcb)-> &tp_seqbit - 1))($tpcb)-> &tp_seqmask)));
    }' unless defined(&SEQ_DEC);
    eval 'sub SEQ_SUB {
        my($tpcb, $Seq, $amt) = @_;
	    eval q((( + (($tpcb)-> &tp_seqbit - $amt)) & ($tpcb)-> &tp_seqmask));
    }' unless defined(&SEQ_SUB);
    eval 'sub SEQ_ADD {
        my($tpcb, $Seq, $amt) = @_;
	    eval q((( + $amt) & ($tpcb)-> &tp_seqmask));
    }' unless defined(&SEQ_ADD);
    eval 'sub IN_RWINDOW {
        my($tpcb, $seq, $lwe, $uwe) = @_;
	    eval q((  &SEQ_GEQ($tpcb, $seq, $lwe)  &&  &SEQ_LT($tpcb, $seq, $uwe) ));
    }' unless defined(&IN_RWINDOW);
    eval 'sub IN_SWINDOW {
        my($tpcb, $seq, $lwe, $uwe) = @_;
	    eval q((  &SEQ_GT($tpcb, $seq, $lwe)  &&  &SEQ_LEQ($tpcb, $seq, $uwe) ));
    }' unless defined(&IN_SWINDOW);
}
1;
