require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MTLIB_H)) {
    eval 'sub _MTLIB_H () {1;}' unless defined(&_MTLIB_H);
    if(defined(&_REENTRANT)) {
	eval 'sub mutex_lock {
	    my($m) = @_;
    	    eval q( &_mutex_lock($m));
	}' unless defined(&mutex_lock);
	eval 'sub mutex_trylock {
	    my($m) = @_;
    	    eval q( &_mutex_trylock($m));
	}' unless defined(&mutex_trylock);
	eval 'sub mutex_unlock {
	    my($m) = @_;
    	    eval q( &_mutex_unlock($m));
	}' unless defined(&mutex_unlock);
	eval 'sub mutex_init {
	    my($m, $n, $p) = @_;
    	    eval q( &_mutex_init($m, $n, $p));
	}' unless defined(&mutex_init);
	eval 'sub rw_wrlock {
	    my($x) = @_;
    	    eval q( &_rw_wrlock($x));
	}' unless defined(&rw_wrlock);
	eval 'sub rw_rdlock {
	    my($x) = @_;
    	    eval q( &_rw_rdlock($x));
	}' unless defined(&rw_rdlock);
	eval 'sub rw_unlock {
	    my($x) = @_;
    	    eval q( &_rw_unlock($x));
	}' unless defined(&rw_unlock);
	eval 'sub thr_self {
	    my($void) = @_;
    	    eval q( &_thr_self($void));
	}' unless defined(&thr_self);
	eval 'sub thr_exit {
	    my($x) = @_;
    	    eval q( &_thr_exit($x));
	}' unless defined(&thr_exit);
	eval 'sub SIGMASK_MUTEX_LOCK {
	    my($lk, $m, $oldmask) = @_;
    	    eval q({  &sigset_t  &newmask;  &sigfillset( &newmask);  &_thr_sigsetmask( &SIG_SETMASK,  &newmask, ($oldmask));  &FLOCKFILE($lk, $m); });
	}' unless defined(&SIGMASK_MUTEX_LOCK);
	eval 'sub SIGMASK_MUTEX_UNLOCK {
	    my($lk, $m, $oldmask) = @_;
    	    eval q({  &sigset_t  &tmpmask;  &FUNLOCKFILE($lk);  &_thr_sigsetmask( &SIG_SETMASK, ($oldmask),  &tmpmask); });
	}' unless defined(&SIGMASK_MUTEX_UNLOCK);
	eval 'sub _FWRITE () { &_fwrite_unlocked;}' unless defined(&_FWRITE);
	eval 'sub REWIND {
	    my($s) = @_;
    	    eval q( &_rewind_unlocked($s));
	}' unless defined(&REWIND);
	eval 'sub FILENO {
	    my($s) = @_;
    	    eval q( &_fileno_unlocked($s));
	}' unless defined(&FILENO);
	eval 'sub FEOF {
	    my($s) = @_;
    	    eval q( &_feof_unlocked($s));
	}' unless defined(&FEOF);
	eval 'sub FERROR {
	    my($s) = @_;
    	    eval q( &_ferror_unlocked($s));
	}' unless defined(&FERROR);
	eval 'sub CLEARERR {
	    my($s) = @_;
    	    eval q( &_clearerr_unlocked($s));
	}' unless defined(&CLEARERR);
	eval 'sub GETC {
	    my($s) = @_;
    	    eval q( &_getc_unlocked($s));
	}' unless defined(&GETC);
	eval 'sub UNGETC {
	    my($c, $s) = @_;
    	    eval q( &_ungetc_unlocked($c, $s));
	}' unless defined(&UNGETC);
	eval 'sub PUTC {
	    my($c, $s) = @_;
    	    eval q( &_putc_unlocked($c, $s));
	}' unless defined(&PUTC);
	eval 'sub GETWC {
	    my($s) = @_;
    	    eval q( &getwc($s));
	}' unless defined(&GETWC);
	eval 'sub PUTWC {
	    my($c, $s) = @_;
    	    eval q( &putwc($c, $s));
	}' unless defined(&PUTWC);
	eval 'sub FLOCKFILE {
	    my($lk, $iop) = @_;
    	    eval q(($lk =  &_flockget($iop)));
	}' unless defined(&FLOCKFILE);
	eval 'sub FUNLOCKFILE {
	    my($lk) = @_;
    	    eval q(( &_flockrel($lk)));
	}' unless defined(&FUNLOCKFILE);
	eval 'sub FLOCKRETURN {
	    my($iop, $ret) = @_;
    	    eval q({ \'int\'  &r;  &rmutex_t * &lk;  &FLOCKFILE( &lk, $iop);  &r = ($ret);  &FUNLOCKFILE( &lk);  &return ( &r); });
	}' unless defined(&FLOCKRETURN);
    } else {
	eval 'sub rw_wrlock {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&rw_wrlock);
	eval 'sub rw_rdlock {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&rw_rdlock);
	eval 'sub rw_unlock {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&rw_unlock);
	eval 'sub _rw_wrlock {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&_rw_wrlock);
	eval 'sub _rw_rdlock {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&_rw_rdlock);
	eval 'sub _rw_unlock {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&_rw_unlock);
	eval 'sub mutex_lock {
	    my($m) = @_;
    	    eval q();
	}' unless defined(&mutex_lock);
	eval 'sub mutex_unlock {
	    my($m) = @_;
    	    eval q();
	}' unless defined(&mutex_unlock);
	eval 'sub mutex_init {
	    my($m) = @_;
    	    eval q();
	}' unless defined(&mutex_init);
	eval 'sub _mutex_lock {
	    my($m) = @_;
    	    eval q();
	}' unless defined(&_mutex_lock);
	eval 'sub _mutex_unlock {
	    my($m) = @_;
    	    eval q();
	}' unless defined(&_mutex_unlock);
	eval 'sub _mutex_init {
	    my($m) = @_;
    	    eval q();
	}' unless defined(&_mutex_init);
	eval 'sub thr_self {
	    my($void) = @_;
    	    eval q();
	}' unless defined(&thr_self);
	eval 'sub _thr_self {
	    my($void) = @_;
    	    eval q();
	}' unless defined(&_thr_self);
	eval 'sub thr_exit {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&thr_exit);
	eval 'sub _thr_exit {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&_thr_exit);
	eval 'sub SIGMASK_MUTEX_LOCK {
	    my($m, $old) = @_;
    	    eval q();
	}' unless defined(&SIGMASK_MUTEX_LOCK);
	eval 'sub SIGMASK_MUTEX_UNLOCK {
	    my($m, $old) = @_;
    	    eval q();
	}' unless defined(&SIGMASK_MUTEX_UNLOCK);
	eval 'sub FLOCKFILE {
	    my($iop) = @_;
    	    eval q();
	}' unless defined(&FLOCKFILE);
	eval 'sub FUNLOCKFILE {
	    my($iop) = @_;
    	    eval q();
	}' unless defined(&FUNLOCKFILE);
	eval 'sub FLOCKRETURN {
	    my($iop, $ret) = @_;
    	    eval q( &return ($ret));
	}' unless defined(&FLOCKRETURN);
	eval 'sub _FWRITE () { &fwrite;}' unless defined(&_FWRITE);
	eval 'sub REWIND () { &rewind;}' unless defined(&REWIND);
	eval 'sub FILENO {
	    my($s) = @_;
    	    eval q( &fileno($s));
	}' unless defined(&FILENO);
	eval 'sub FEOF {
	    my($s) = @_;
    	    eval q( &feof($s));
	}' unless defined(&FEOF);
	eval 'sub FERROR {
	    my($s) = @_;
    	    eval q( &ferror($s));
	}' unless defined(&FERROR);
	eval 'sub CLEARERR {
	    my($s) = @_;
    	    eval q( &clearerr($s));
	}' unless defined(&CLEARERR);
	eval 'sub GETC {
	    my($s) = @_;
    	    eval q( &getc($s));
	}' unless defined(&GETC);
	eval 'sub UNGETC {
	    my($c, $s) = @_;
    	    eval q( &ungetc($c, $s));
	}' unless defined(&UNGETC);
	eval 'sub PUTC {
	    my($c, $s) = @_;
    	    eval q( &putc($c, $s));
	}' unless defined(&PUTC);
	eval 'sub GETWC {
	    my($s) = @_;
    	    eval q( &getwc($s));
	}' unless defined(&GETWC);
	eval 'sub PUTWC {
	    my($c, $s) = @_;
    	    eval q( &putwc($c, $s));
	}' unless defined(&PUTWC);
    }
    eval 'sub MT_ASSERT_HELD {
        my($x) = @_;
	    eval q();
    }' unless defined(&MT_ASSERT_HELD);
}
1;
