require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NIS_LOCAL_H)) {
    eval 'sub _NIS_LOCAL_H () {1;}' unless defined(&_NIS_LOCAL_H);
    require 'nsl/rpc_mt.ph';
    require 'poll.ph';
    require 'rpc/rpc.ph';
    require 'rpcsvc/nis.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&DEBUG)) {
	eval 'sub ASSERT {
	    my($cond) = @_;
    	    eval q({  &if (!($cond)) {  &printf(\\"ASSERT ERROR:(%s),file %s,line %d\\\\n\\", $cond,  &__FILE__,  &__LINE__);  &abort(); } });
	}' unless defined(&ASSERT);
    } else {
	eval 'sub ASSERT {
	    my($cond) = @_;
    	    eval q();
	}' unless defined(&ASSERT);
    }
    eval 'sub MAX_LINKS () {16;}' unless defined(&MAX_LINKS);
    eval 'sub NIS_MAXLINKS () {16;}' unless defined(&NIS_MAXLINKS);
    eval 'sub NIS_MAXSRCHLEN () {2048;}' unless defined(&NIS_MAXSRCHLEN);
    eval 'sub NIS_MAXPATHDEPTH () {128;}' unless defined(&NIS_MAXPATHDEPTH);
    eval 'sub NIS_MAXPATHLEN () {8192;}' unless defined(&NIS_MAXPATHLEN);
    unless(defined(&NIS_MAXREPLICAS)) {
	eval 'sub NIS_MAXREPLICAS () {128;}' unless defined(&NIS_MAXREPLICAS);
    }
    eval 'sub MAXCLOCKS () {16;}' unless defined(&MAXCLOCKS);
    eval 'sub CLOCK_SERVER () {0;}' unless defined(&CLOCK_SERVER);
    eval 'sub CLOCK_DB () {1;}' unless defined(&CLOCK_DB);
    eval 'sub CLOCK_CLIENT () {2;}' unless defined(&CLOCK_CLIENT);
    eval 'sub CLOCK_CACHE () {3;}' unless defined(&CLOCK_CACHE);
    eval 'sub CLOCK_CACHE_SEARCH () {4;}' unless defined(&CLOCK_CACHE_SEARCH);
    eval 'sub CLOCK_CACHE_FINDDIR () {5;}' unless defined(&CLOCK_CACHE_FINDDIR);
    eval 'sub CLOCK_SCRATCH () {6;}' unless defined(&CLOCK_SCRATCH);
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    eval 'sub UPD_TICKS {
        my($t, $r) = @_;
	    eval q({ ($t->{a$ticks}) +=  ($r->{a$ticks});  ($t->{d$ticks}) +=  ($r->{d$ticks});  ($t->{z$ticks}) +=  ($r->{z$ticks});  ($t->{c$ticks}) +=  ($r->{c$ticks}); });
    }' unless defined(&UPD_TICKS);
    eval 'sub CLR_TICKS {
        my($t) = @_;
	    eval q({ ($t->{a$ticks}) = 0;  ($t->{d$ticks}) = 0;  ($t->{z$ticks}) = 0;  ($t->{c$ticks}) = 0; });
    }' unless defined(&CLR_TICKS);
    eval 'sub RET_TICKS {
        my($t, $r) = @_;
	    eval q({ ($r->{a$ticks}) =  ($t->{a$ticks});  ($r->{d$ticks}) =  ($t->{d$ticks});  ($r->{z$ticks}) =  ($t->{z$ticks});  ($r->{c$ticks}) =  ($t->{c$ticks}); });
    }' unless defined(&RET_TICKS);
    eval 'sub NIS_PING_TIMEOUT () {5;}' unless defined(&NIS_PING_TIMEOUT);
    eval 'sub NIS_DUMP_TIMEOUT () {12;}' unless defined(&NIS_DUMP_TIMEOUT);
    eval 'sub NIS_FINDDIR_TIMEOUT () {15;}' unless defined(&NIS_FINDDIR_TIMEOUT);
    eval 'sub NIS_TAG_TIMEOUT () {30;}' unless defined(&NIS_TAG_TIMEOUT);
    eval 'sub NIS_GEN_TIMEOUT () {15;}' unless defined(&NIS_GEN_TIMEOUT);
    eval 'sub NIS_READ_TIMEOUT () {5;}' unless defined(&NIS_READ_TIMEOUT);
    eval 'sub NIS_HARDSLEEP () {5;}' unless defined(&NIS_HARDSLEEP);
    eval 'sub NIS_CBACK_TIMEOUT () {18;}' unless defined(&NIS_CBACK_TIMEOUT);
    eval 'sub SRV_IS_FREE () {0;}' unless defined(&SRV_IS_FREE);
    eval 'sub SRV_TO_BE_FREED () {1;}' unless defined(&SRV_TO_BE_FREED);
    eval 'sub SRV_IN_USE () {2;}' unless defined(&SRV_IN_USE);
    eval 'sub SRV_INVALID () {3;}' unless defined(&SRV_INVALID);
    eval 'sub SRV_AUTH_INVALID () {4;}' unless defined(&SRV_AUTH_INVALID);
    eval 'sub BAD_SERVER () {1;}' unless defined(&BAD_SERVER);
    eval 'sub GOOD_SERVER () {0;}' unless defined(&GOOD_SERVER);
    eval 'sub NIS_SEND_SIZE () {2048;}' unless defined(&NIS_SEND_SIZE);
    eval 'sub NIS_RECV_SIZE () {2048;}' unless defined(&NIS_RECV_SIZE);
    eval 'sub NIS_TCP_TIMEOUT () {3600;}' unless defined(&NIS_TCP_TIMEOUT);
    eval 'sub NIS_UDP_TIMEOUT () {120;}' unless defined(&NIS_UDP_TIMEOUT);
    if(defined(&__cplusplus)) {
    }
}
1;
