require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NSS_DBDEFS_H)) {
    eval 'sub _NSS_DBDEFS_H () {1;}' unless defined(&_NSS_DBDEFS_H);
    eval 'sub MAXALIASES () {35;}' unless defined(&MAXALIASES);
    eval 'sub MAXADDRS () {35;}' unless defined(&MAXADDRS);
    require 'errno.ph';
    require 'netdb.ph';
    require 'limits.ph';
    require 'nsl/nss_common.ph';
    require 'nsl/rpc_mt.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&NSS_INCLUDE_UNSAFE)) {
	eval 'sub NSS_INCLUDE_UNSAFE () {1;}' unless defined(&NSS_INCLUDE_UNSAFE);
    }
    eval 'sub NSS_DBNAM_ALIASES () {"aliases";}' unless defined(&NSS_DBNAM_ALIASES);
    eval 'sub NSS_DBNAM_AUTOMOUNT () {"automount";}' unless defined(&NSS_DBNAM_AUTOMOUNT);
    eval 'sub NSS_DBNAM_BOOTPARAMS () {"bootparams";}' unless defined(&NSS_DBNAM_BOOTPARAMS);
    eval 'sub NSS_DBNAM_ETHERS () {"ethers";}' unless defined(&NSS_DBNAM_ETHERS);
    eval 'sub NSS_DBNAM_GROUP () {"group";}' unless defined(&NSS_DBNAM_GROUP);
    eval 'sub NSS_DBNAM_HOSTS () {"hosts";}' unless defined(&NSS_DBNAM_HOSTS);
    eval 'sub NSS_DBNAM_NETGROUP () {"netgroup";}' unless defined(&NSS_DBNAM_NETGROUP);
    eval 'sub NSS_DBNAM_NETMASKS () {"netmasks";}' unless defined(&NSS_DBNAM_NETMASKS);
    eval 'sub NSS_DBNAM_NETWORKS () {"networks";}' unless defined(&NSS_DBNAM_NETWORKS);
    eval 'sub NSS_DBNAM_PASSWD () {"passwd";}' unless defined(&NSS_DBNAM_PASSWD);
    eval 'sub NSS_DBNAM_PROTOCOLS () {"protocols";}' unless defined(&NSS_DBNAM_PROTOCOLS);
    eval 'sub NSS_DBNAM_PUBLICKEY () {"publickey";}' unless defined(&NSS_DBNAM_PUBLICKEY);
    eval 'sub NSS_DBNAM_RPC () {"rpc";}' unless defined(&NSS_DBNAM_RPC);
    eval 'sub NSS_DBNAM_SERVICES () {"services";}' unless defined(&NSS_DBNAM_SERVICES);
    eval 'sub NSS_DBNAM_SHADOW () {"shadow";}' unless defined(&NSS_DBNAM_SHADOW);
    eval 'sub NSS_DBNAM_PASSWD_COMPAT () {"passwd_compat";}' unless defined(&NSS_DBNAM_PASSWD_COMPAT);
    eval 'sub NSS_DBNAM_GROUP_COMPAT () {"group_compat";}' unless defined(&NSS_DBNAM_GROUP_COMPAT);
    eval 'sub NSS_FILES_NS () {"files nis";}' unless defined(&NSS_FILES_NS);
    eval 'sub NSS_NS_FALLBACK () {"nis [NOTFOUND=return] files";}' unless defined(&NSS_NS_FALLBACK);
    eval 'sub NSS_NS_ONLY () {"nis";}' unless defined(&NSS_NS_ONLY);
    eval 'sub NSS_DEFCONF_ALIASES () { &NSS_FILES_NS;}' unless defined(&NSS_DEFCONF_ALIASES);
    eval 'sub NSS_DEFCONF_AUTOMOUNT () { &NSS_FILES_NS;}' unless defined(&NSS_DEFCONF_AUTOMOUNT);
    eval 'sub NSS_DEFCONF_BOOTPARAMS () { &NSS_NS_FALLBACK;}' unless defined(&NSS_DEFCONF_BOOTPARAMS);
    eval 'sub NSS_DEFCONF_ETHERS () { &NSS_NS_FALLBACK;}' unless defined(&NSS_DEFCONF_ETHERS);
    eval 'sub NSS_DEFCONF_GROUP () { &NSS_FILES_NS;}' unless defined(&NSS_DEFCONF_GROUP);
    eval 'sub NSS_DEFCONF_HOSTS () { &NSS_NS_FALLBACK;}' unless defined(&NSS_DEFCONF_HOSTS);
    eval 'sub NSS_DEFCONF_NETGROUP () { &NSS_NS_ONLY;}' unless defined(&NSS_DEFCONF_NETGROUP);
    eval 'sub NSS_DEFCONF_NETMASKS () { &NSS_NS_FALLBACK;}' unless defined(&NSS_DEFCONF_NETMASKS);
    eval 'sub NSS_DEFCONF_NETWORKS () { &NSS_NS_FALLBACK;}' unless defined(&NSS_DEFCONF_NETWORKS);
    eval 'sub NSS_DEFCONF_PASSWD () { &NSS_FILES_NS;}' unless defined(&NSS_DEFCONF_PASSWD);
    eval 'sub NSS_DEFCONF_PROTOCOLS () { &NSS_NS_FALLBACK;}' unless defined(&NSS_DEFCONF_PROTOCOLS);
    eval 'sub NSS_DEFCONF_PUBLICKEY () { &NSS_NS_FALLBACK;}' unless defined(&NSS_DEFCONF_PUBLICKEY);
    eval 'sub NSS_DEFCONF_RPC () { &NSS_NS_FALLBACK;}' unless defined(&NSS_DEFCONF_RPC);
    eval 'sub NSS_DEFCONF_SERVICES () { &NSS_FILES_NS;}' unless defined(&NSS_DEFCONF_SERVICES);
    eval 'sub NSS_DEFCONF_GROUP_COMPAT () { &NSS_NS_ONLY;}' unless defined(&NSS_DEFCONF_GROUP_COMPAT);
    eval 'sub NSS_DEFCONF_PASSWD_COMPAT () { &NSS_NS_ONLY;}' unless defined(&NSS_DEFCONF_PASSWD_COMPAT);
    eval 'sub NSS_BUFSIZ () {1024;}' unless defined(&NSS_BUFSIZ);
    eval 'sub NSS_LINELEN_GROUP () {(( &NSS_BUFSIZ) * 4);}' unless defined(&NSS_LINELEN_GROUP);
    eval 'sub NSS_LINELEN_HOSTS () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_HOSTS);
    eval 'sub NSS_LINELEN_NETMASKS () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_NETMASKS);
    eval 'sub NSS_LINELEN_NETWORKS () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_NETWORKS);
    eval 'sub NSS_LINELEN_PASSWD () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_PASSWD);
    eval 'sub NSS_LINELEN_PROTOCOLS () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_PROTOCOLS);
    eval 'sub NSS_LINELEN_RPC () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_RPC);
    eval 'sub NSS_LINELEN_SERVICES () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_SERVICES);
    eval 'sub NSS_LINELEN_SHADOW () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_SHADOW);
    eval 'sub NSS_LINELEN_ETHERS () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_ETHERS);
    eval 'sub NSS_LINELEN_BOOTPARAMS () { &NSS_BUFSIZ;}' unless defined(&NSS_LINELEN_BOOTPARAMS);
    eval 'sub NSS_BUFLEN_GROUP () {( &NSS_LINELEN_GROUP + 800* $sizeof{\'char\' });}' unless defined(&NSS_BUFLEN_GROUP);
    eval 'sub NSS_BUFLEN_HOSTS () {( &NSS_LINELEN_HOSTS + ( &MAXALIASES +  &MAXADDRS + 2) * $sizeof{\'char\' });}' unless defined(&NSS_BUFLEN_HOSTS);
    eval 'sub NSS_BUFLEN_NETGROUP () {( &MAXHOSTNAMELEN * 2+  &LOGNAME_MAX + 3);}' unless defined(&NSS_BUFLEN_NETGROUP);
    eval 'sub NSS_BUFLEN_NETWORKS () { &NSS_LINELEN_NETWORKS;}' unless defined(&NSS_BUFLEN_NETWORKS);
    eval 'sub NSS_BUFLEN_PASSWD () { &NSS_LINELEN_PASSWD;}' unless defined(&NSS_BUFLEN_PASSWD);
    eval 'sub NSS_BUFLEN_PROTOCOLS () { &NSS_LINELEN_PROTOCOLS;}' unless defined(&NSS_BUFLEN_PROTOCOLS);
    eval 'sub NSS_BUFLEN_RPC () { &NSS_LINELEN_RPC;}' unless defined(&NSS_BUFLEN_RPC);
    eval 'sub NSS_BUFLEN_SERVICES () { &NSS_LINELEN_SERVICES;}' unless defined(&NSS_BUFLEN_SERVICES);
    eval 'sub NSS_BUFLEN_SHADOW () { &NSS_LINELEN_SHADOW;}' unless defined(&NSS_BUFLEN_SHADOW);
    eval 'sub NSS_BUFLEN_ETHERS () { &NSS_LINELEN_ETHERS;}' unless defined(&NSS_BUFLEN_ETHERS);
    eval 'sub NSS_BUFLEN_BOOTPARAMS () { &NSS_LINELEN_BOOTPARAMS;}' unless defined(&NSS_BUFLEN_BOOTPARAMS);
    if(defined( &__STDC__)) {
    } else {
    }
    eval("sub NSS_NETGR_MACHINE () { 0; }") unless defined(&NSS_NETGR_MACHINE);
    eval("sub NSS_NETGR_USER () { 1; }") unless defined(&NSS_NETGR_USER);
    eval("sub NSS_NETGR_DOMAIN () { 2; }") unless defined(&NSS_NETGR_DOMAIN);
    eval("sub NSS_NETGR_N () { 3; }") unless defined(&NSS_NETGR_N);
    eval("sub NSS_NETGR_FOUND () { 0; }") unless defined(&NSS_NETGR_FOUND);
    eval("sub NSS_NETGR_NO () { 1; }") unless defined(&NSS_NETGR_NO);
    eval("sub NSS_NETGR_NOMEM () { 2; }") unless defined(&NSS_NETGR_NOMEM);
    if(defined( &__STDC__)) {
    } else {
    }
    eval 'sub NSS_XbyY_ALLOC {
        my($bufpp, $str_size, $buf_size) = @_;
	    eval q(( (*$bufpp) == 0? (*$bufpp) =  &_nss_XbyY_buf_alloc($str_size, $buf_size) : (*$bufpp)));
    }' unless defined(&NSS_XbyY_ALLOC);
    eval 'sub NSS_XbyY_FREE {
        my($bufpp) = @_;
	    eval q(( &_nss_XbyY_buf_free(*$bufpp), (*$bufpp) = 0));
    }' unless defined(&NSS_XbyY_FREE);
    if(defined( &__STDC__)) {
    } else {
    }
    eval 'sub NSS_STR_PARSE_SUCCESS () {0;}' unless defined(&NSS_STR_PARSE_SUCCESS);
    eval 'sub NSS_STR_PARSE_PARSE () {1;}' unless defined(&NSS_STR_PARSE_PARSE);
    eval 'sub NSS_STR_PARSE_ERANGE () {2;}' unless defined(&NSS_STR_PARSE_ERANGE);
    eval 'sub NSS_XbyY_INIT {
        my($str, $res, $bufp, $len, $func) = @_;
	    eval q(( ($str)-> ($buf->{result}) = ($res), ($str)-> ($buf->{buffer}) = ($bufp), ($str)-> ($buf->{buflen}) = ($len), ($str)-> &stayopen = 0, ($str)-> &str2ent = ($func), ($str)-> &returnval = 0, ($str)-> &erange = 0));
    }' unless defined(&NSS_XbyY_INIT);
    eval 'sub NSS_XbyY_FINI {
        my($str) = @_;
	    eval q(( ($str)-> &returnval == 0 && ($str)-> &erange  && ( &errno =  &ERANGE), ($str)-> &returnval));
    }' unless defined(&NSS_XbyY_FINI);
    if(defined( &__STDC__)) {
    } else {
    }
    eval 'sub NSS_DBOP_GROUP_BYNAME () {( &NSS_DBOP_next_iter);}' unless defined(&NSS_DBOP_GROUP_BYNAME);
    eval 'sub NSS_DBOP_GROUP_BYGID () {( &NSS_DBOP_GROUP_BYNAME + 1);}' unless defined(&NSS_DBOP_GROUP_BYGID);
    eval 'sub NSS_DBOP_GROUP_BYMEMBER () {( &NSS_DBOP_GROUP_BYGID + 1);}' unless defined(&NSS_DBOP_GROUP_BYMEMBER);
    eval 'sub NSS_DBOP_PASSWD_BYNAME () {( &NSS_DBOP_next_iter);}' unless defined(&NSS_DBOP_PASSWD_BYNAME);
    eval 'sub NSS_DBOP_PASSWD_BYUID () {( &NSS_DBOP_PASSWD_BYNAME + 1);}' unless defined(&NSS_DBOP_PASSWD_BYUID);
    eval 'sub NSS_DBOP_SHADOW_BYNAME () {( &NSS_DBOP_PASSWD_BYNAME);}' unless defined(&NSS_DBOP_SHADOW_BYNAME);
    eval 'sub NSS_DBOP_HOSTS_BYNAME () {( &NSS_DBOP_next_iter);}' unless defined(&NSS_DBOP_HOSTS_BYNAME);
    eval 'sub NSS_DBOP_HOSTS_BYADDR () {( &NSS_DBOP_HOSTS_BYNAME + 1);}' unless defined(&NSS_DBOP_HOSTS_BYADDR);
    eval 'sub NSS_DBOP_RPC_BYNAME () {( &NSS_DBOP_next_iter);}' unless defined(&NSS_DBOP_RPC_BYNAME);
    eval 'sub NSS_DBOP_RPC_BYNUMBER () {( &NSS_DBOP_RPC_BYNAME + 1);}' unless defined(&NSS_DBOP_RPC_BYNUMBER);
    eval 'sub NSS_DBOP_NETWORKS_BYNAME () {( &NSS_DBOP_next_iter);}' unless defined(&NSS_DBOP_NETWORKS_BYNAME);
    eval 'sub NSS_DBOP_NETWORKS_BYADDR () {( &NSS_DBOP_NETWORKS_BYNAME + 1);}' unless defined(&NSS_DBOP_NETWORKS_BYADDR);
    eval 'sub NSS_DBOP_SERVICES_BYNAME () {( &NSS_DBOP_next_iter);}' unless defined(&NSS_DBOP_SERVICES_BYNAME);
    eval 'sub NSS_DBOP_SERVICES_BYPORT () {( &NSS_DBOP_SERVICES_BYNAME + 1);}' unless defined(&NSS_DBOP_SERVICES_BYPORT);
    eval 'sub NSS_DBOP_PROTOCOLS_BYNAME () {( &NSS_DBOP_next_iter);}' unless defined(&NSS_DBOP_PROTOCOLS_BYNAME);
    eval 'sub NSS_DBOP_PROTOCOLS_BYNUMBER () {( &NSS_DBOP_PROTOCOLS_BYNAME + 1);}' unless defined(&NSS_DBOP_PROTOCOLS_BYNUMBER);
    eval 'sub NSS_DBOP_ETHERS_HOSTTON () {( &NSS_DBOP_next_noiter);}' unless defined(&NSS_DBOP_ETHERS_HOSTTON);
    eval 'sub NSS_DBOP_ETHERS_NTOHOST () {( &NSS_DBOP_ETHERS_HOSTTON + 1);}' unless defined(&NSS_DBOP_ETHERS_NTOHOST);
    eval 'sub NSS_DBOP_BOOTPARAMS_BYNAME () {( &NSS_DBOP_next_noiter);}' unless defined(&NSS_DBOP_BOOTPARAMS_BYNAME);
    eval 'sub NSS_DBOP_NETMASKS_BYNET () {( &NSS_DBOP_next_noiter);}' unless defined(&NSS_DBOP_NETMASKS_BYNET);
    eval 'sub NSS_DBOP_NETGROUP_IN () {( &NSS_DBOP_next_iter);}' unless defined(&NSS_DBOP_NETGROUP_IN);
    eval 'sub NSS_DBOP_NETGROUP_SET () {( &NSS_DBOP_NETGROUP_IN + 1);}' unless defined(&NSS_DBOP_NETGROUP_SET);
    eval 'sub ROUND_DOWN {
        my($n, $align) = @_;
	    eval q((($n) & ~(($align) - 1)));
    }' unless defined(&ROUND_DOWN);
    eval 'sub ROUND_UP {
        my($n, $align) = @_;
	    eval q( &ROUND_DOWN(($n) + ($align) - 1, ($align)));
    }' unless defined(&ROUND_UP);
    if(defined(&__cplusplus)) {
    }
}
1;
