require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&H_RAPI_INTSERV)) {
    eval 'sub H_RAPI_INTSERV () {1;}' unless defined(&H_RAPI_INTSERV);
    unless(defined(&OS2)) {
	require 'sys/types.ph';
    } else {
	require 'types.ph';
    }
    unless(defined(&FLOAT32)) {
	eval 'sub FLOAT32 () {1;}' unless defined(&FLOAT32);
    }
    eval 'sub wordsof {
        my($x) = @_;
	    eval q(((($x)+3)/4));
    }' unless defined(&wordsof);
    eval 'sub GENERAL_INFO () {1;}' unless defined(&GENERAL_INFO);
    eval 'sub GUARANTEED_SERV () {2;}' unless defined(&GUARANTEED_SERV);
    eval 'sub CONTROLLED_LOAD_SERV () {5;}' unless defined(&CONTROLLED_LOAD_SERV);
    eval("sub IS_WKP_HOP_CNT () { 4; }") unless defined(&IS_WKP_HOP_CNT);
    eval("sub IS_WKP_PATH_BW () { 6; }") unless defined(&IS_WKP_PATH_BW);
    eval("sub IS_WKP_MIN_LATENCY () { 8; }") unless defined(&IS_WKP_MIN_LATENCY);
    eval("sub IS_WKP_COMPOSED_MTU () { 10; }") unless defined(&IS_WKP_COMPOSED_MTU);
    eval("sub IS_WKP_TB_TSPEC () { 127; }") unless defined(&IS_WKP_TB_TSPEC);
    eval 'sub INTSERV_VERS_MASK () {0xf0;}' unless defined(&INTSERV_VERS_MASK);
    eval 'sub INTSERV_VERSION0 () {0;}' unless defined(&INTSERV_VERSION0);
    eval 'sub Intserv_Version {
        my($x) = @_;
	    eval q(((($x) &ismh_version &INTSERV_VERS_MASK)>>4));
    }' unless defined(&Intserv_Version);
    eval 'sub Intserv_Version_OK {
        my($x) = @_;
	    eval q(((($x)-> &ismh_version &INTSERV_VERS_MASK)==  &INTSERV_VERSION0));
    }' unless defined(&Intserv_Version_OK);
    eval 'sub ISSH_BREAK_BIT () {0x80;}' unless defined(&ISSH_BREAK_BIT);
    eval 'sub ISPH_FLG_INV () {0x80;}' unless defined(&ISPH_FLG_INV);
    eval 'sub Set_Main_Hdr {
        my($p, $len) = @_;
	    eval q({($p)-> &ismh_version =  &INTSERV_VERSION0; ($p)-> &ismh_unused = 0; ($p)-> &ismh_len32b =  &wordsof($len);});
    }' unless defined(&Set_Main_Hdr);
    eval 'sub Set_Serv_Hdr {
        my($p, $s, $len) = @_;
	    eval q({($p)-> &issh_service = ($s); ($p)-> &issh_flags = 0; ($p)-> &issh_len32b =  &wordsof($len);});
    }' unless defined(&Set_Serv_Hdr);
    eval 'sub Set_Param_Hdr {
        my($p, $id, $len) = @_;
	    eval q({($p)-> &isph_parm_num = ($id); ($p)-> &isph_flags = 0; ($p)-> &isph_len32b =  &wordsof($len);});
    }' unless defined(&Set_Param_Hdr);
    eval 'sub Set_Break_Bit {
        my($p) = @_;
	    eval q((( &IS_serv_hdr_t *)$p)-> &issh_flags |=  &ISSH_BREAK_BIT);
    }' unless defined(&Set_Break_Bit);
    eval 'sub Next_Main_Hdr {
        my($p) = @_;
	    eval q(( &IS_main_hdr_t *)(( &u_int32_t *)($p)+1+($p)-> &ismh_len32b));
    }' unless defined(&Next_Main_Hdr);
    eval 'sub Next_Serv_Hdr {
        my($p) = @_;
	    eval q(( &IS_serv_hdr_t *)(( &u_int32_t *)($p)+1+($p)-> &issh_len32b));
    }' unless defined(&Next_Serv_Hdr);
    eval 'sub Next_Parm_Hdr {
        my($p) = @_;
	    eval q(( &IS_parm_hdr_t *)(( &u_int32_t *)($p)+1+($p)-> &isph_len32b));
    }' unless defined(&Next_Parm_Hdr);
    eval 'sub Non_Is_Hop () {(( &IS_serv_hdr_t *) &p)-> &issh_flags &ISSH_BREAK_BIT;}' unless defined(&Non_Is_Hop);
    eval 'sub TB_MAX_RATE () {40 &e12;}' unless defined(&TB_MAX_RATE);
    eval 'sub TB_MIN_RATE () {1;}' unless defined(&TB_MIN_RATE);
    eval 'sub TB_MAX_DEPTH () {250 &e9;}' unless defined(&TB_MAX_DEPTH);
    eval 'sub TB_MIN_DEPTH () {1;}' unless defined(&TB_MIN_DEPTH);
    eval 'sub TB_MAX_PEAK () {0x7f800000;}' unless defined(&TB_MAX_PEAK);
    eval 'sub gtspec_r () { ($gen_Tspec_parms->{TB_Tspec_r});}' unless defined(&gtspec_r);
    eval 'sub gtspec_b () { ($gen_Tspec_parms->{TB_Tspec_b});}' unless defined(&gtspec_b);
    eval 'sub gtspec_p () { ($gen_Tspec_parms->{TB_Tspec_p});}' unless defined(&gtspec_p);
    eval 'sub gtspec_m () { ($gen_Tspec_parms->{TB_Tspec_m});}' unless defined(&gtspec_m);
    eval 'sub gtspec_M () { ($gen_Tspec_parms->{TB_Tspec_M});}' unless defined(&gtspec_M);
    eval 'sub gtspec_parmno () { ($gen_Tspec_parm_hdr->{isph_parm_num});}' unless defined(&gtspec_parmno);
    eval 'sub gtspec_flags () { ($gen_Tspec_parm_hdr->{isph_flags});}' unless defined(&gtspec_flags);
    eval 'sub gtspec_len32b () { ($gen_Tspec_parm_hdr->{isph_len32b});}' unless defined(&gtspec_len32b);
    eval 'sub gtspec_len () {($sizeof{ &gen_Tspec_t}-$sizeof{ &IS_serv_hdr_t});}' unless defined(&gtspec_len);
    eval 'sub CLspec_r () { ($CL_spec_parms->{TB_Tspec_r});}' unless defined(&CLspec_r);
    eval 'sub CLspec_b () { ($CL_spec_parms->{TB_Tspec_b});}' unless defined(&CLspec_b);
    eval 'sub CLspec_p () { ($CL_spec_parms->{TB_Tspec_p});}' unless defined(&CLspec_p);
    eval 'sub CLspec_m () { ($CL_spec_parms->{TB_Tspec_m});}' unless defined(&CLspec_m);
    eval 'sub CLspec_M () { ($CL_spec_parms->{TB_Tspec_M});}' unless defined(&CLspec_M);
    eval 'sub CLspec_parmno () { ($CL_spec_parm_hdr->{isph_parm_num});}' unless defined(&CLspec_parmno);
    eval 'sub CLspec_flags () { ($CL_spec_parm_hdr->{isph_flags});}' unless defined(&CLspec_flags);
    eval 'sub CLspec_len32b () { ($CL_spec_parm_hdr->{isph_len32b});}' unless defined(&CLspec_len32b);
    eval 'sub CLspec_len () {($sizeof{ &CL_flowspec_t}-$sizeof{ &IS_serv_hdr_t});}' unless defined(&CLspec_len);
    eval("sub IS_GUAR_RSPEC () { 130; }") unless defined(&IS_GUAR_RSPEC);
    eval("sub GUAR_ADSPARM_C () { 131; }") unless defined(&GUAR_ADSPARM_C);
    eval("sub GUAR_ADSPARM_D () { 132; }") unless defined(&GUAR_ADSPARM_D);
    eval("sub GUAR_ADSPARM_Ctot () { 133; }") unless defined(&GUAR_ADSPARM_Ctot);
    eval("sub GUAR_ADSPARM_Dtot () { 134; }") unless defined(&GUAR_ADSPARM_Dtot);
    eval("sub GUAR_ADSPARM_Csum () { 135; }") unless defined(&GUAR_ADSPARM_Csum);
    eval("sub GUAR_ADSPARM_Dsum () { 136; }") unless defined(&GUAR_ADSPARM_Dsum);
    eval 'sub Gspec_r () { ($Guar_Tspec_parms->{TB_Tspec_r});}' unless defined(&Gspec_r);
    eval 'sub Gspec_b () { ($Guar_Tspec_parms->{TB_Tspec_b});}' unless defined(&Gspec_b);
    eval 'sub Gspec_p () { ($Guar_Tspec_parms->{TB_Tspec_p});}' unless defined(&Gspec_p);
    eval 'sub Gspec_m () { ($Guar_Tspec_parms->{TB_Tspec_m});}' unless defined(&Gspec_m);
    eval 'sub Gspec_M () { ($Guar_Tspec_parms->{TB_Tspec_M});}' unless defined(&Gspec_M);
    eval 'sub Gspec_R () { ($Guar_Rspec->{Guar_R});}' unless defined(&Gspec_R);
    eval 'sub Gspec_S () { ($Guar_Rspec->{Guar_S});}' unless defined(&Gspec_S);
    eval 'sub Gspec_T_parmno () { ($Guar_Tspec_hdr->{isph_parm_num});}' unless defined(&Gspec_T_parmno);
    eval 'sub Gspec_T_flags () { ($Guar_Tspec_hdr->{isph_flags});}' unless defined(&Gspec_T_flags);
    eval 'sub Gspec_T_len32b () { ($Guar_Tspec_hdr->{isph_len32b});}' unless defined(&Gspec_T_len32b);
    eval 'sub Gspec_R_parmno () { ($Guar_Rspec_hdr->{isph_parm_num});}' unless defined(&Gspec_R_parmno);
    eval 'sub Gspec_R_flags () { ($Guar_Rspec_hdr->{isph_flags});}' unless defined(&Gspec_R_flags);
    eval 'sub Gspec_R_len32b () { ($Guar_Rspec_hdr->{isph_len32b});}' unless defined(&Gspec_R_len32b);
    eval 'sub Gspec_len () {($sizeof{ &Guar_flowspec_t}-$sizeof{ &IS_serv_hdr_t});}' unless defined(&Gspec_len);
    eval 'sub ISmh_len32b () { ($spec_mh->{ismh_len32b});}' unless defined(&ISmh_len32b);
    eval 'sub ISmh_version () { ($spec_mh->{ismh_version});}' unless defined(&ISmh_version);
    eval 'sub ISmh_unused () { ($spec_mh->{ismh_unused});}' unless defined(&ISmh_unused);
    eval 'sub IStmh_len32b () { ($st_mh->{ismh_len32b});}' unless defined(&IStmh_len32b);
    eval 'sub IStmh_version () { ($st_mh->{ismh_version});}' unless defined(&IStmh_version);
    eval 'sub IStmh_unused () { ($st_mh->{ismh_unused});}' unless defined(&IStmh_unused);
    eval 'sub MAX_OPT_ADSPEC_SIZE () {$sizeof{ &Gads_parms_t}+$sizeof{ &Min_adspec_t}+2*$sizeof{ &genparm_parms_t};}' unless defined(&MAX_OPT_ADSPEC_SIZE);
}
1;
