require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_RELOC)) {
    eval 'sub _H_RELOC () {1;}' unless defined(&_H_RELOC);
    require 'xcoff32_64.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&__XCOFF_HYBRID__)) {
	if(defined(&__XCOFF32__)) {
	    eval 'sub RELSZ () {(10);}' unless defined(&RELSZ);
	}
	if(defined(&__XCOFF64__)) {
	    if(defined(&__XCOFF_32_64__)) {
		eval 'sub RELSZ_64 () {(14);}' unless defined(&RELSZ_64);
	    } else {
		eval 'sub RELSZ () {(14);}' unless defined(&RELSZ);
	    }
	}
	eval 'sub r_type () { ($_r->{_r_type});}' unless defined(&r_type);
	eval 'sub r_rsize () { ($_r->{_r_r}->{_r_rsize});}' unless defined(&r_rsize);
	eval 'sub r_rtype () { ($_r->{_r_r}->{_r_rtype});}' unless defined(&r_rtype);
    } else {
	eval 'sub RELSZ_32 () {(10);}' unless defined(&RELSZ_32);
	eval 'sub RELSZ_64 () {(14);}' unless defined(&RELSZ_64);
	eval 'sub r_vaddr32 () { ($_u->{_s32}->{_vaddr32});}' unless defined(&r_vaddr32);
	eval 'sub r_symndx32 () { ($_u->{_s32}->{_symndx32});}' unless defined(&r_symndx32);
	eval 'sub r_type32 () { ($_r->{_r_type});}' unless defined(&r_type32);
	eval 'sub r_rsize32 () { ($_r->{_r_r}->{_r_rsize});}' unless defined(&r_rsize32);
	eval 'sub r_rtype32 () { ($_r->{_r_r}->{_r_rtype});}' unless defined(&r_rtype32);
	eval 'sub r_vaddr64 () { ($_u->{_vaddr64});}' unless defined(&r_vaddr64);
	eval 'sub r_symndx64 () { ($_r->{_symndx64});}' unless defined(&r_symndx64);
	eval 'sub r_type64 () { ($_r64->{_r_type});}' unless defined(&r_type64);
	eval 'sub r_rsize64 () { ($_r64->{_r_r}->{_r_rsize});}' unless defined(&r_rsize64);
	eval 'sub r_rtype64 () { ($_r64->{_r_r}->{_r_rtype});}' unless defined(&r_rtype64);
    }
    eval 'sub R_LEN () {0x3f;}' unless defined(&R_LEN);
    eval 'sub R_SIGN () {0x80;}' unless defined(&R_SIGN);
    eval 'sub R_FIXUP () {0x40;}' unless defined(&R_FIXUP);
    eval 'sub RELOC_RLEN {
        my($x) = @_;
	    eval q((($x). ($_r->{_r_r}->{_r_rsize}) &  &R_LEN));
    }' unless defined(&RELOC_RLEN);
    eval 'sub RELOC_RSIGN {
        my($x) = @_;
	    eval q((($x). ($_r->{_r_r}->{_r_rsize}) &  &R_SIGN));
    }' unless defined(&RELOC_RSIGN);
    eval 'sub RELOC_RFIXUP {
        my($x) = @_;
	    eval q((($x). ($_r->{_r_r}->{_r_rsize}) &  &R_FIXUP));
    }' unless defined(&RELOC_RFIXUP);
    eval 'sub RELOC_RTYPE {
        my($x) = @_;
	    eval q((($x). ($_r->{_r_r}->{_r_rtype})));
    }' unless defined(&RELOC_RTYPE);
    eval 'sub R_POS () {0x;}' unless defined(&R_POS);
    eval 'sub R_NEG () {0x1;}' unless defined(&R_NEG);
    eval 'sub R_REL () {0x2;}' unless defined(&R_REL);
    eval 'sub R_TOC () {0x3;}' unless defined(&R_TOC);
    eval 'sub R_TRL () {0x12;}' unless defined(&R_TRL);
    eval 'sub R_TRLA () {0x13;}' unless defined(&R_TRLA);
    eval 'sub R_GL () {0x5;}' unless defined(&R_GL);
    eval 'sub R_TCL () {0x6;}' unless defined(&R_TCL);
    eval 'sub R_RL () {0xc;}' unless defined(&R_RL);
    eval 'sub R_RLA () {0xd;}' unless defined(&R_RLA);
    eval 'sub R_REF () {0xf;}' unless defined(&R_REF);
    eval 'sub R_BA () {0x8;}' unless defined(&R_BA);
    eval 'sub R_RBA () {0x18;}' unless defined(&R_RBA);
    eval 'sub R_BR () {0xa;}' unless defined(&R_BR);
    eval 'sub R_RBR () {0x1a;}' unless defined(&R_RBR);
    eval 'sub R_RBAC () {0x19;}' unless defined(&R_RBAC);
    eval 'sub R_RBRC () {0x1b;}' unless defined(&R_RBRC);
    eval 'sub R_RTB () {0x4;}' unless defined(&R_RTB);
    eval 'sub R_RRTBI () {0x14;}' unless defined(&R_RRTBI);
    eval 'sub R_RRTBA () {0x15;}' unless defined(&R_RRTBA);
    eval 'sub R_ABS () {0;}' unless defined(&R_ABS);
    eval 'sub R_OFF8 () {07;}' unless defined(&R_OFF8);
    eval 'sub R_OFF16 () {010;}' unless defined(&R_OFF16);
    eval 'sub R_SEG12 () {011;}' unless defined(&R_SEG12);
    eval 'sub R_AUX () {013;}' unless defined(&R_AUX);
    eval 'sub R_DIR16 () {01;}' unless defined(&R_DIR16);
    eval 'sub R_REL16 () {02;}' unless defined(&R_REL16);
    eval 'sub R_IND16 () {03;}' unless defined(&R_IND16);
    eval 'sub R_DIR24 () {04;}' unless defined(&R_DIR24);
    eval 'sub R_REL24 () {05;}' unless defined(&R_REL24);
    eval 'sub R_OPT16 () {014;}' unless defined(&R_OPT16);
    eval 'sub R_IND24 () {015;}' unless defined(&R_IND24);
    eval 'sub R_IND32 () {016;}' unless defined(&R_IND32);
    eval 'sub R_DIR10 () {025;}' unless defined(&R_DIR10);
    eval 'sub R_REL10 () {026;}' unless defined(&R_REL10);
    eval 'sub R_REL32 () {027;}' unless defined(&R_REL32);
    eval 'sub R_DIR32S () {012;}' unless defined(&R_DIR32S);
    eval 'sub R_RELBYTE () {017;}' unless defined(&R_RELBYTE);
    eval 'sub R_RELWORD () {020;}' unless defined(&R_RELWORD);
    eval 'sub R_RELLONG () {021;}' unless defined(&R_RELLONG);
    eval 'sub R_PCRBYTE () {022;}' unless defined(&R_PCRBYTE);
    eval 'sub R_PCRWORD () {023;}' unless defined(&R_PCRWORD);
    eval 'sub R_PCRLONG () {024;}' unless defined(&R_PCRLONG);
    if(defined(&__cplusplus)) {
    }
}
1;
