require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&_AIX_TIRPC)) {
    require 'tirpc/rpc/pmap_prot.ph';
} else {
    unless(defined(&_RPC_PMAP_PROT_H)) {
	eval 'sub _RPC_PMAP_PROT_H () {1;}' unless defined(&_RPC_PMAP_PROT_H);
	require 'rpc/xdr.ph';
	eval 'sub PMAPPORT () {(111);}' unless defined(&PMAPPORT);
	eval 'sub PMAPPROG () {(( &rpcprog_t)100000);}' unless defined(&PMAPPROG);
	eval 'sub PMAPVERS () {(( &rpcvers_t)2);}' unless defined(&PMAPVERS);
	eval 'sub PMAPVERS_PROTO () {(( &rpcvers_t)2);}' unless defined(&PMAPVERS_PROTO);
	eval 'sub PMAPVERS_ORIG () {(( &rpcvers_t)1);}' unless defined(&PMAPVERS_ORIG);
	eval 'sub PMAPPROC_NULL () {(( &rpcproc_t)0);}' unless defined(&PMAPPROC_NULL);
	eval 'sub PMAPPROC_SET () {(( &rpcproc_t)1);}' unless defined(&PMAPPROC_SET);
	eval 'sub PMAPPROC_UNSET () {(( &rpcproc_t)2);}' unless defined(&PMAPPROC_UNSET);
	eval 'sub PMAPPROC_GETPORT () {(( &rpcproc_t)3);}' unless defined(&PMAPPROC_GETPORT);
	eval 'sub PMAPPROC_DUMP () {(( &rpcproc_t)4);}' unless defined(&PMAPPROC_DUMP);
	eval 'sub PMAPPROC_CALLIT () {(( &rpcproc_t)5);}' unless defined(&PMAPPROC_CALLIT);
	unless(defined(&_KERNEL)) {
	}
    }
}
1;
