require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_CT_CU)) {
    eval 'sub _H_CT_CU () {1;}' unless defined(&_H_CT_CU);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'rsct/ct.ph';
    require 'stdarg.ph';
    require 'unistd.ph';
    if(defined(&__linux__)) {
	eval 'sub __need_timespec () {1;}' unless defined(&__need_timespec);
	require 'time.ph';
    }
    require 'iconv.ph';
    require 'locale.ph';
    require 'nl_types.ph';
    require 'langinfo.ph';
    unless(defined(&CU_VERSION)) {
	eval 'sub CU_VERSION () {1;}' unless defined(&CU_VERSION);
    }
    eval 'sub CU_EFAILURE () {1;}' unless defined(&CU_EFAILURE);
    eval 'sub CU_EINVALIDNAME () {2;}' unless defined(&CU_EINVALIDNAME);
    eval 'sub CU_ENOMEM () {3;}' unless defined(&CU_ENOMEM);
    eval 'sub CU_EINVAL () {4;}' unless defined(&CU_EINVAL);
    eval 'sub CU_EDIVIDEZERO () {5;}' unless defined(&CU_EDIVIDEZERO);
    eval 'sub CU_EINVALIDSDINDEX () {6;}' unless defined(&CU_EINVALIDSDINDEX);
    eval 'sub CU_EINVALIDINDEX () {7;}' unless defined(&CU_EINVALIDINDEX);
    eval 'sub CU_EINVALIDELEMENTID () {8;}' unless defined(&CU_EINVALIDELEMENTID);
    eval 'sub CU_EINVALIDOPTION () {9;}' unless defined(&CU_EINVALIDOPTION);
    eval 'sub CU_EMISSINGFUNC () {10;}' unless defined(&CU_EMISSINGFUNC);
    eval 'sub CU_ENOEXPR () {11;}' unless defined(&CU_ENOEXPR);
    eval 'sub CU_ETOOFEWVALUES () {12;}' unless defined(&CU_ETOOFEWVALUES);
    eval 'sub CU_EINVALIDRANGE () {13;}' unless defined(&CU_EINVALIDRANGE);
    eval 'sub CU_EINVALIDFORMAT () {14;}' unless defined(&CU_EINVALIDFORMAT);
    eval 'sub CU_ECONVNOMEM () {15;}' unless defined(&CU_ECONVNOMEM);
    eval 'sub CU_ECONVAGAIN () {16;}' unless defined(&CU_ECONVAGAIN);
    eval 'sub CU_ECONVINVALID () {17;}' unless defined(&CU_ECONVINVALID);
    eval 'sub CU_ECONVNOSUPPORT () {18;}' unless defined(&CU_ECONVNOSUPPORT);
    eval 'sub CU_ECONVBADINPUT () {19;}' unless defined(&CU_ECONVBADINPUT);
    eval 'sub CU_ECONVBUFFERSIZE () {20;}' unless defined(&CU_ECONVBUFFERSIZE);
    eval 'sub CU_ECONVESCAPESEQ () {24;}' unless defined(&CU_ECONVESCAPESEQ);
    eval 'sub CU_ELOCALENOMEM () {21;}' unless defined(&CU_ELOCALENOMEM);
    eval 'sub CU_ELOCALEAGAIN () {22;}' unless defined(&CU_ELOCALEAGAIN);
    eval 'sub CU_ELOCALEFAILURE () {23;}' unless defined(&CU_ELOCALEFAILURE);
    require 'rsct/ct_cu_proc.ph';
    eval 'sub cu_rsrc_is_fixed () { &CU_ROUTINE_VERSION( &cu_rsrc_is_fixed,  &CU_VERSION);}' unless defined(&cu_rsrc_is_fixed);
    eval 'sub cu_get_resource_location () { &CU_ROUTINE_VERSION( &cu_get_resource_location,  &CU_VERSION);}' unless defined(&cu_get_resource_location);
    eval 'sub cu_set_resource_location () { &CU_ROUTINE_VERSION( &cu_set_resource_location,  &CU_VERSION);}' unless defined(&cu_set_resource_location);
    eval 'sub cu_get_resource_id () { &CU_ROUTINE_VERSION( &cu_get_resource_id,  &CU_VERSION);}' unless defined(&cu_get_resource_id);
    eval 'sub cu_get_resource_id_ext () { &CU_ROUTINE_VERSION( &cu_get_resource_id_ext,  &CU_VERSION);}' unless defined(&cu_get_resource_id_ext);
    eval 'sub cu_get_resource_class_id () { &CU_ROUTINE_VERSION( &cu_get_resource_class_id,  &CU_VERSION);}' unless defined(&cu_get_resource_class_id);
    eval 'sub cu_gen_resource_handle () { &CU_ROUTINE_VERSION( &cu_gen_resource_handle,  &CU_VERSION);}' unless defined(&cu_gen_resource_handle);
    eval 'sub cu_gen_resource_handle_ext () { &CU_ROUTINE_VERSION( &cu_gen_resource_handle_ext,  &CU_VERSION);}' unless defined(&cu_gen_resource_handle_ext);
    eval 'sub cu_rsrcs_are_same () { &CU_ROUTINE_VERSION( &cu_rsrcs_are_same,  &CU_VERSION);}' unless defined(&cu_rsrcs_are_same);
    eval 'sub cu_rsrc_hndl_cmp () { &CU_ROUTINE_VERSION( &cu_rsrc_hndl_cmp,  &CU_VERSION);}' unless defined(&cu_rsrc_hndl_cmp);
    eval 'sub cu_get_canon_hndl () { &CU_ROUTINE_VERSION( &cu_get_canon_hndl,  &CU_VERSION);}' unless defined(&cu_get_canon_hndl);
    eval 'sub cu_set_no_error () { &CU_ROUTINE_VERSION( &cu_set_no_error,  &CU_VERSION);}' unless defined(&cu_set_no_error);
    eval 'sub cu_set_error () { &CU_ROUTINE_VERSION( &cu_set_error,  &CU_VERSION);}' unless defined(&cu_set_error);
    eval 'sub cu_vset_error () { &CU_ROUTINE_VERSION( &cu_vset_error,  &CU_VERSION);}' unless defined(&cu_vset_error);
    eval 'sub cu_pset_error () { &CU_ROUTINE_VERSION( &cu_pset_error,  &CU_VERSION);}' unless defined(&cu_pset_error);
    eval 'sub cu_get_error () { &CU_ROUTINE_VERSION( &cu_get_error,  &CU_VERSION);}' unless defined(&cu_get_error);
    eval 'sub cu_pkg_no_error () { &CU_ROUTINE_VERSION( &cu_pkg_no_error,  &CU_VERSION);}' unless defined(&cu_pkg_no_error);
    eval 'sub cu_pkg_error () { &CU_ROUTINE_VERSION( &cu_pkg_error,  &CU_VERSION);}' unless defined(&cu_pkg_error);
    eval 'sub cu_vpkg_error () { &CU_ROUTINE_VERSION( &cu_vpkg_error,  &CU_VERSION);}' unless defined(&cu_vpkg_error);
    eval 'sub cu_apkg_error () { &CU_ROUTINE_VERSION( &cu_apkg_error,  &CU_VERSION);}' unless defined(&cu_apkg_error);
    eval 'sub cu_dup_error () { &CU_ROUTINE_VERSION( &cu_dup_error,  &CU_VERSION);}' unless defined(&cu_dup_error);
    eval 'sub cu_rel_error () { &CU_ROUTINE_VERSION( &cu_rel_error,  &CU_VERSION);}' unless defined(&cu_rel_error);
    eval 'sub cu_get_errmsg () { &CU_ROUTINE_VERSION( &cu_get_errmsg,  &CU_VERSION);}' unless defined(&cu_get_errmsg);
    eval 'sub cu_fmt_errmsg () { &CU_ROUTINE_VERSION( &cu_fmt_errmsg,  &CU_VERSION);}' unless defined(&cu_fmt_errmsg);
    eval 'sub cu_fmt_msg () { &CU_ROUTINE_VERSION( &cu_fmt_msg,  &CU_VERSION);}' unless defined(&cu_fmt_msg);
    eval 'sub cu_rel_errmsg () { &CU_ROUTINE_VERSION( &cu_rel_errmsg,  &CU_VERSION);}' unless defined(&cu_rel_errmsg);
    eval 'sub cu_set_error_args () { &CU_ROUTINE_VERSION( &cu_set_error_args,  &CU_VERSION);}' unless defined(&cu_set_error_args);
    eval 'sub cu_rel_error_args () { &CU_ROUTINE_VERSION( &cu_rel_error_args,  &CU_VERSION);}' unless defined(&cu_rel_error_args);
    eval 'sub cu_get_cluster_info () { &CU_ROUTINE_VERSION( &cu_get_cluster_info,  &CU_VERSION);}' unless defined(&cu_get_cluster_info);
    eval 'sub cu_get_registry_server_list () { &CU_ROUTINE_VERSION( &cu_get_registry_server_list,  &CU_VERSION);}' unless defined(&cu_get_registry_server_list);
    eval 'sub cu_free_registry_server_list () { &CU_ROUTINE_VERSION( &cu_free_registry_server_list,  &CU_VERSION);}' unless defined(&cu_free_registry_server_list);
    eval 'sub cu_get_cluster_ID () { &CU_ROUTINE_VERSION( &cu_get_cluster_ID,  &CU_VERSION);}' unless defined(&cu_get_cluster_ID);
    eval 'sub cu_gen_rsrc_ids_init () { &CU_ROUTINE_VERSION( &cu_gen_rsrc_ids_init,  &CU_VERSION);}' unless defined(&cu_gen_rsrc_ids_init);
    eval 'sub cu_gen_rsrc_ids () { &CU_ROUTINE_VERSION( &cu_gen_rsrc_ids,  &CU_VERSION);}' unless defined(&cu_gen_rsrc_ids);
    eval 'sub cu_rsrc_id_to_string () { &CU_ROUTINE_VERSION( &cu_rsrc_id_to_string,  &CU_VERSION);}' unless defined(&cu_rsrc_id_to_string);
    eval 'sub cu_rsrc_id_from_string () { &CU_ROUTINE_VERSION( &cu_rsrc_id_from_string,  &CU_VERSION);}' unless defined(&cu_rsrc_id_from_string);
    eval 'sub cu_get_hwid () { &CU_ROUTINE_VERSION( &cu_get_hwid,  &CU_VERSION);}' unless defined(&cu_get_hwid);
    eval 'sub cu_get_procspeed () { &CU_ROUTINE_VERSION( &cu_get_procspeed,  &CU_VERSION);}' unless defined(&cu_get_procspeed);
    eval 'sub cu_get_ctr () { &CU_ROUTINE_VERSION( &cu_get_ctr,  &CU_VERSION);}' unless defined(&cu_get_ctr);
    eval 'sub cu_cvt_time () { &CU_ROUTINE_VERSION( &cu_cvt_time,  &CU_VERSION);}' unless defined(&cu_cvt_time);
    eval 'sub cu_iconv_open () { &CU_ROUTINE_VERSION( &cu_iconv_open,  &CU_VERSION);}' unless defined(&cu_iconv_open);
    eval 'sub cu_iconv_dup () { &CU_ROUTINE_VERSION( &cu_iconv_dup,  &CU_VERSION);}' unless defined(&cu_iconv_dup);
    eval 'sub cu_iconv_close () { &CU_ROUTINE_VERSION( &cu_iconv_close,  &CU_VERSION);}' unless defined(&cu_iconv_close);
    eval 'sub cu_iconv_str () { &CU_ROUTINE_VERSION( &cu_iconv_str,  &CU_VERSION);}' unless defined(&cu_iconv_str);
    eval 'sub cu_iconv_buf () { &CU_ROUTINE_VERSION( &cu_iconv_buf,  &CU_VERSION);}' unless defined(&cu_iconv_buf);
    eval 'sub cu_get_locale_info () { &CU_ROUTINE_VERSION( &cu_get_locale_info,  &CU_VERSION);}' unless defined(&cu_get_locale_info);
    eval 'sub cu_rel_locale_info () { &CU_ROUTINE_VERSION( &cu_rel_locale_info,  &CU_VERSION);}' unless defined(&cu_rel_locale_info);
    eval 'sub cu_get_utf8_locale () { &CU_ROUTINE_VERSION( &cu_get_utf8_locale,  &CU_VERSION);}' unless defined(&cu_get_utf8_locale);
    eval 'sub cu_rel_utf8_locale () { &CU_ROUTINE_VERSION( &cu_rel_utf8_locale,  &CU_VERSION);}' unless defined(&cu_rel_utf8_locale);
    eval 'sub cu_assume_utf8 () { &CU_ROUTINE_VERSION( &cu_assume_utf8,  &CU_VERSION);}' unless defined(&cu_assume_utf8);
    eval 'sub cu_utf8_is_assumed () { &CU_ROUTINE_VERSION( &cu_utf8_is_assumed,  &CU_VERSION);}' unless defined(&cu_utf8_is_assumed);
    eval 'sub cu_prepare_locale () { &CU_ROUTINE_VERSION( &cu_prepare_locale,  &CU_VERSION);}' unless defined(&cu_prepare_locale);
    eval 'sub cu_catopen () { &CU_ROUTINE_VERSION( &cu_catopen,  &CU_VERSION);}' unless defined(&cu_catopen);
    eval 'sub cu_dtc_table () { &CU_ROUTINE_VERSION( &cu_dtc_table,  &CU_VERSION);}' unless defined(&cu_dtc_table);
    eval 'sub cu_dtc_base_types () { &CU_ROUTINE_VERSION( &cu_dtc_base_types,  &CU_VERSION);}' unless defined(&cu_dtc_base_types);
    eval 'sub CU_ROUTINE_VERSION {
        my($routine, $version) = @_;
	    eval q( &CU_ROUTINE_VERSION_GLUE($routine, $version));
    }' unless defined(&CU_ROUTINE_VERSION);
    eval 'sub CU_ROUTINE_VERSION_GLUE {
        my($routine, $version) = @_;
	    eval q($routine   &_  $version);
    }' unless defined(&CU_ROUTINE_VERSION_GLUE);
    eval 'sub CU_DTCB_REG () {0x1;}' unless defined(&CU_DTCB_REG);
    eval 'sub CU_DTCB_RMC () {0x2;}' unless defined(&CU_DTCB_RMC);
    eval 'sub CU_DTCB_PTR () {0x4;}' unless defined(&CU_DTCB_PTR);
    eval 'sub CU_DTCB_CMPCT () {0x8;}' unless defined(&CU_DTCB_CMPCT);
    eval 'sub CU_DTCB_ARRAY () {0x10;}' unless defined(&CU_DTCB_ARRAY);
    eval 'sub CU_DTCB_NUM () {0x20;}' unless defined(&CU_DTCB_NUM);
    if(((defined(&CU_VERSION) ? &CU_VERSION : 0) == 1)) {
	eval 'sub CU_DT_IS_VALID {
	    my($t) = @_;
    	    eval q(($t  && $t <=  &CT_SD_PTR_ARRAY));
	}' unless defined(&CU_DT_IS_VALID);
	eval 'sub CU_DT_IS_REGISTRY {
	    my($t) = @_;
    	    eval q(($t <=  &CT_SD_PTR_ARRAY  &&  $cu_dtc_table[$t] &  &CU_DTCB_REG));
	}' unless defined(&CU_DT_IS_REGISTRY);
	eval 'sub CU_DT_IS_RMC {
	    my($t) = @_;
    	    eval q(($t <=  &CT_SD_PTR_ARRAY  &&  $cu_dtc_table[$t] &  &CU_DTCB_RMC));
	}' unless defined(&CU_DT_IS_RMC);
	eval 'sub CU_DT_IS_REG_RMC {
	    my($t) = @_;
    	    eval q(($t <=  &CT_SD_PTR_ARRAY  &&  $cu_dtc_table[$t] &  &CU_DTCB_REG  &&  $cu_dtc_table[$t] &  &CU_DTCB_RMC));
	}' unless defined(&CU_DT_IS_REG_RMC);
	eval 'sub CU_DT_IS_POINTER {
	    my($t) = @_;
    	    eval q(($t <=  &CT_SD_PTR_ARRAY  &&  $cu_dtc_table[$t] &  &CU_DTCB_PTR));
	}' unless defined(&CU_DT_IS_POINTER);
	eval 'sub CU_DT_IS_COMPACT {
	    my($t) = @_;
    	    eval q(($t <=  &CT_SD_PTR_ARRAY  &&  $cu_dtc_table[$t] &  &CU_DTCB_CMPCT));
	}' unless defined(&CU_DT_IS_COMPACT);
	eval 'sub CU_DT_IS_ARRAY {
	    my($t) = @_;
    	    eval q(($t <=  &CT_SD_PTR_ARRAY  &&  $cu_dtc_table[$t] &  &CU_DTCB_ARRAY));
	}' unless defined(&CU_DT_IS_ARRAY);
	eval 'sub CU_DT_IS_NUMERIC {
	    my($t) = @_;
    	    eval q(($t <=  &CT_SD_PTR_ARRAY  &&  $cu_dtc_table[$t] &  &CU_DTCB_NUM));
	}' unless defined(&CU_DT_IS_NUMERIC);
	eval 'sub CU_DT_BASE_TYPE {
	    my($t) = @_;
    	    eval q(( ($t <=  &CT_SD_PTR_ARRAY) ?  $cu_dtc_base_types[$t] :  &CT_UNKNOWN ));
	}' unless defined(&CU_DT_BASE_TYPE);
    }
    if(((defined(&CU_VERSION) ? &CU_VERSION : 0) == 1) || defined( &CU_ALL_VERSIONS)) {
	eval 'sub CU_PTR_EMPTY_CHAR () { &cu_ptr_empty_char_1;}' unless defined(&CU_PTR_EMPTY_CHAR);
	eval 'sub CU_PTR_EMPTY_BINARY () { &cu_ptr_empty_binary_1;}' unless defined(&CU_PTR_EMPTY_BINARY);
	eval 'sub CU_PTR_EMPTY_SBS () { &cu_ptr_empty_sbs_1;}' unless defined(&CU_PTR_EMPTY_SBS);
	eval 'sub CU_PTR_EMPTY_SD () { &cu_ptr_empty_sd_1;}' unless defined(&CU_PTR_EMPTY_SD);
	eval 'sub CU_PTR_EMPTY_ARRAY () { &cu_ptr_empty_array_1;}' unless defined(&CU_PTR_EMPTY_ARRAY);
	eval 'sub CU_PTR_INVLD_RSRC_HNDL () { &cu_ptr_invld_rsrc_hndl_1;}' unless defined(&CU_PTR_INVLD_RSRC_HNDL);
    }
    eval 'sub CU_ID_LEN () {64;}' unless defined(&CU_ID_LEN);
    eval 'sub CU_IP_ADDR_LEN () {64;}' unless defined(&CU_IP_ADDR_LEN);
    eval 'sub CU_MAX_NAME_LEN () {64;}' unless defined(&CU_MAX_NAME_LEN);
    eval("sub CU_ERROR_ARG_INT () { 0; }") unless defined(&CU_ERROR_ARG_INT);
    eval("sub CU_ERROR_ARG_LONG () { 1; }") unless defined(&CU_ERROR_ARG_LONG);
    eval("sub CU_ERROR_ARG_LONG_LONG () { 2; }") unless defined(&CU_ERROR_ARG_LONG_LONG);
    eval("sub CU_ERROR_ARG_DOUBLE () { 3; }") unless defined(&CU_ERROR_ARG_DOUBLE);
    eval("sub CU_ERROR_ARG_RESERVED () { 4; }") unless defined(&CU_ERROR_ARG_RESERVED);
    eval("sub CU_ERROR_ARG_CHAR_STR () { 5; }") unless defined(&CU_ERROR_ARG_CHAR_STR);
    eval("sub CU_ERROR_ARG_VOID_PTR () { 6; }") unless defined(&CU_ERROR_ARG_VOID_PTR);
    eval 'sub cu_iconv_multipliers {
        my($cui_p, $nm_p, $mm_p) = @_;
	    eval q({ *($nm_p) = ($cui_p)-> &cui_nominal_multiplier; *($mm_p) = ($cui_p)-> &cui_maximum_multiplier; });
    }' unless defined(&cu_iconv_multipliers);
    if((defined(&_AIX) ? &_AIX : 0)) {
	eval 'sub CU_UTF8_CODESET () {"UTF-8";}' unless defined(&CU_UTF8_CODESET);
    }
    if((defined(&__linux__) ? &__linux__ : 0)) {
	eval 'sub CU_UTF8_CODESET () {"UTF-8";}' unless defined(&CU_UTF8_CODESET);
    }
    eval 'sub CU_ICONV_FLAG_TO_CLIENT_CODESET () {0x1;}' unless defined(&CU_ICONV_FLAG_TO_CLIENT_CODESET);
    eval 'sub CU_ICONV_FLAG_NO_SERIALIZATION () {0x2;}' unless defined(&CU_ICONV_FLAG_NO_SERIALIZATION);
    eval 'sub CU_ICONV_FLAG_NO_ESCAPE_SEQUENCE () {0x4;}' unless defined(&CU_ICONV_FLAG_NO_ESCAPE_SEQUENCE);
    eval 'sub CU_NUM_LOCALE_CATEGORIES () {6;}' unless defined(&CU_NUM_LOCALE_CATEGORIES);
    eval 'sub CU_NUM_LANGINFO_ITEMS () {1;}' unless defined(&CU_NUM_LANGINFO_ITEMS);
    eval 'sub CU_CATOPEN_INCLUDE_C_LOCALE () {0x1;}' unless defined(&CU_CATOPEN_INCLUDE_C_LOCALE);
    if(((defined(&CU_VERSION) ? &CU_VERSION : 0) == 1) || defined( &CU_ALL_VERSIONS)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
