require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_CT_CU_EXPR)) {
    eval 'sub _H_CT_CU_EXPR () {1;}' unless defined(&_H_CT_CU_EXPR);
    require 'rsct/ct_cu.ph';
    require 'rsct/ct_pmsg.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub cu_comp_expr () { &CU_ROUTINE_VERSION( &cu_comp_expr,  &CU_VERSION);}' unless defined(&cu_comp_expr);
    eval 'sub cu_free_expr () { &CU_ROUTINE_VERSION( &cu_free_expr,  &CU_VERSION);}' unless defined(&cu_free_expr);
    eval 'sub cu_exec_expr () { &CU_ROUTINE_VERSION( &cu_exec_expr,  &CU_VERSION);}' unless defined(&cu_exec_expr);
    eval 'sub cu_probe_expr () { &CU_ROUTINE_VERSION( &cu_probe_expr,  &CU_VERSION);}' unless defined(&cu_probe_expr);
    eval 'sub cu_get_expr_props () { &CU_ROUTINE_VERSION( &cu_get_expr_props,  &CU_VERSION);}' unless defined(&cu_get_expr_props);
    eval 'sub cu_same_expr () { &CU_ROUTINE_VERSION( &cu_same_expr,  &CU_VERSION);}' unless defined(&cu_same_expr);
    eval 'sub CU_EXPR_NO_OPTIONS () {0;}' unless defined(&CU_EXPR_NO_OPTIONS);
    eval 'sub CU_EXPR_MEM_FUNCS () {1;}' unless defined(&CU_EXPR_MEM_FUNCS);
    eval 'sub CU_EXPR_ALLOW_AT () {2;}' unless defined(&CU_EXPR_ALLOW_AT);
    eval 'sub CU_EXPR_ALLOW_SUBST () {4;}' unless defined(&CU_EXPR_ALLOW_SUBST);
    eval 'sub CU_EXPR_API_FORMAT () {8;}' unless defined(&CU_EXPR_API_FORMAT);
    eval 'sub CU_EXPR_BASE_ADDR () {16;}' unless defined(&CU_EXPR_BASE_ADDR);
    eval 'sub CU_EXPR_MAP_VAR () {32;}' unless defined(&CU_EXPR_MAP_VAR);
    eval 'sub CU_COMP_ALL_OPTS () {( &CU_EXPR_MEM_FUNCS |  &CU_EXPR_API_FORMAT |  &CU_EXPR_ALLOW_AT |  &CU_EXPR_ALLOW_SUBST);}' unless defined(&CU_COMP_ALL_OPTS);
    eval 'sub CU_EXEC_ALL_OPTS () {( &CU_EXPR_MEM_FUNCS |  &CU_EXPR_API_FORMAT |  &CU_EXPR_BASE_ADDR |  &CU_EXPR_MAP_VAR);}' unless defined(&CU_EXEC_ALL_OPTS);
    eval 'sub CU_FREE_ALL_OPTS () {( &CU_EXPR_MEM_FUNCS);}' unless defined(&CU_FREE_ALL_OPTS);
    eval 'sub CU_PROBE_ALL_OPTS () {( &CU_EXPR_MEM_FUNCS |  &CU_EXPR_API_FORMAT);}' unless defined(&CU_PROBE_ALL_OPTS);
    eval 'sub CU_EXPR_NO_PARENT () {0xffffffff;}' unless defined(&CU_EXPR_NO_PARENT);
    eval("sub INCLUSION_LIST () { 0; }") unless defined(&INCLUSION_LIST);
    eval("sub EXCLUSION_LIST () { 1; }") unless defined(&EXCLUSION_LIST);
    if(((defined(&CU_VERSION) ? &CU_VERSION : 0) == 1) || defined( &CU_ALL_VERSIONS)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
