require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_FFDC)) {
    eval 'sub _H_FFDC () {1;}' unless defined(&_H_FFDC);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    if(defined(&_AIX)) {
	require 'sys/err_rec.ph';
    }
    require 'nl_types.ph';
    unless(defined(&ERR_REC_MAX)) {
	eval 'sub ERR_REC_MAX () {230;}' unless defined(&ERR_REC_MAX);
    }
    unless(defined(&FC_VERSION)) {
	eval 'sub FC_VERSION () {1;}' unless defined(&FC_VERSION);
    }
    eval 'sub FC_EID_LEN () {42;}' unless defined(&FC_EID_LEN);
    eval("sub FC_ERROR_DETAIL_HEX () { 0; }") unless defined(&FC_ERROR_DETAIL_HEX);
    eval("sub FC_ERROR_DETAIL_DEC () { 1; }") unless defined(&FC_ERROR_DETAIL_DEC);
    eval("sub FC_ERROR_DETAIL_ALPHA () { 2; }") unless defined(&FC_ERROR_DETAIL_ALPHA);
    eval 'sub FFDC_EMERG () {0;}' unless defined(&FFDC_EMERG);
    eval 'sub FFDC_ERROR () {1;}' unless defined(&FFDC_ERROR);
    eval 'sub FFDC_STATE () {2;}' unless defined(&FFDC_STATE);
    eval 'sub FFDC_PERF () {3;}' unless defined(&FFDC_PERF);
    eval 'sub FFDC_TRACE () {4;}' unless defined(&FFDC_TRACE);
    eval 'sub FFDC_RECOV () {5;}' unless defined(&FFDC_RECOV);
    eval 'sub FFDC_DEBUG () {6;}' unless defined(&FFDC_DEBUG);
    eval 'sub FC_LOG () {0x;}' unless defined(&FC_LOG);
    eval 'sub FC_STACK_CREAT () {0x1;}' unless defined(&FC_STACK_CREAT);
    eval 'sub FC_STACK_INHERIT () {0x2;}' unless defined(&FC_STACK_INHERIT);
    eval 'sub FC_SUCCESS () { 0;}' unless defined(&FC_SUCCESS);
    eval 'sub FC_INHERIT_SUCCESS () { 1;}' unless defined(&FC_INHERIT_SUCCESS);
    eval 'sub FC_HELP_SUCCESS () { 2;}' unless defined(&FC_HELP_SUCCESS);
    eval 'sub FC_OPTION_MISSING () { 10;}' unless defined(&FC_OPTION_MISSING);
    eval 'sub FC_NOT_SUPPORTED () { 11;}' unless defined(&FC_NOT_SUPPORTED);
    eval 'sub FC_UNKNOWN_OPTION () { 12;}' unless defined(&FC_UNKNOWN_OPTION);
    eval 'sub FC_INHERIT_INV () { 13;}' unless defined(&FC_INHERIT_INV);
    eval 'sub FC_ENV_EXIST () { 14;}' unless defined(&FC_ENV_EXIST);
    eval 'sub FC_NO_FC_ENVIR () { 15;}' unless defined(&FC_NO_FC_ENVIR);
    eval 'sub FC_ENV_FAILED () { 16;}' unless defined(&FC_ENV_FAILED);
    eval 'sub FC_ENV_CORRUPT () { 17;}' unless defined(&FC_ENV_CORRUPT);
    eval 'sub FC_NO_MEMORY () { 18;}' unless defined(&FC_NO_MEMORY);
    eval 'sub FC_STACK_DIRECTORY () { 19;}' unless defined(&FC_STACK_DIRECTORY);
    eval 'sub FC_STACK_ACCESS () { 20;}' unless defined(&FC_STACK_ACCESS);
    eval 'sub FC_STACK_RESERVE () { 21;}' unless defined(&FC_STACK_RESERVE);
    eval 'sub FC_STACK_LOCK () { 22;}' unless defined(&FC_STACK_LOCK);
    eval 'sub FC_STACK_UNLOCK () { 23;}' unless defined(&FC_STACK_UNLOCK);
    eval 'sub FC_STACK_CORRUPT () { 24;}' unless defined(&FC_STACK_CORRUPT);
    eval 'sub FC_STACK_INV () { 25;}' unless defined(&FC_STACK_INV);
    eval 'sub FC_COMBINED_OPTION () { 26;}' unless defined(&FC_COMBINED_OPTION);
    eval 'sub FC_EID_INV () { 27;}' unless defined(&FC_EID_INV);
    eval 'sub FC_RESOURCE_INV () { 28;}' unless defined(&FC_RESOURCE_INV);
    eval 'sub FC_DETECTFILE_INV () { 29;}' unless defined(&FC_DETECTFILE_INV);
    eval 'sub FC_DEFAULTDESC_INV () { 30;}' unless defined(&FC_DEFAULTDESC_INV);
    eval 'sub FC_DESC_INV () { 31;}' unless defined(&FC_DESC_INV);
    eval 'sub FC_COPY_FAILED () { 32;}' unless defined(&FC_COPY_FAILED);
    eval 'sub FC_LOGEVENT_INV () { 33;}' unless defined(&FC_LOGEVENT_INV);
    eval 'sub FC_LOGMSG_INV () { 34;}' unless defined(&FC_LOGMSG_INV);
    eval 'sub FC_DETAILDATA_INV () { 35;}' unless defined(&FC_DETAILDATA_INV);
    eval 'sub FC_DETAILLEN_INV () { 36;}' unless defined(&FC_DETAILLEN_INV);
    eval 'sub FC_EID_FAILED () { 37;}' unless defined(&FC_EID_FAILED);
    eval 'sub FC_SYSLOG_FAILED () { 38;}' unless defined(&FC_SYSLOG_FAILED);
    eval 'sub FC_NOT_SOURCED () { 39;}' unless defined(&FC_NOT_SOURCED);
    eval 'sub FC_FILESYS_SPACE () { 40;}' unless defined(&FC_FILESYS_SPACE);
    eval 'sub FC_IO_FAILED () { 41;}' unless defined(&FC_IO_FAILED);
    eval 'sub FC_STACK_DISABLED () { 42;}' unless defined(&FC_STACK_DISABLED);
    eval 'sub FC_EID_REMOTE () { 43;}' unless defined(&FC_EID_REMOTE);
    eval 'sub FC_DATA_TRUNC () { 44;}' unless defined(&FC_DATA_TRUNC);
    eval 'sub FC_INTERNAL () { 99;}' unless defined(&FC_INTERNAL);
    eval 'sub FC_STACK_MAX () {1024;}' unless defined(&FC_STACK_MAX);
    eval 'sub FC_SYSLOG_MAX () {992;}' unless defined(&FC_SYSLOG_MAX);
    eval 'sub FC_FILEINFO_LEN () {46;}' unless defined(&FC_FILEINFO_LEN);
    eval 'sub FC_SYSLOG_MSG_MAX () {( &FC_SYSLOG_MAX -  &FC_FILEINFO_LEN);}' unless defined(&FC_SYSLOG_MSG_MAX);
    eval 'sub FC_ERRLOG_STDINFO_LEN () {( &FC_FILEINFO_LEN + (2*  &FC_EID_LEN));}' unless defined(&FC_ERRLOG_STDINFO_LEN);
    eval 'sub FC_ERRLOG_DETAIL_DATA_MAX () {( &ERR_REC_MAX -  &FC_ERRLOG_STDINFO_LEN);}' unless defined(&FC_ERRLOG_DETAIL_DATA_MAX);
    eval 'sub fc_init () { &FC_ROUTINE_VERSION( &fc_init,  &FC_VERSION);}' unless defined(&fc_init);
    eval 'sub fc_eid_init () { &FC_ROUTINE_VERSION( &fc_eid_init,  &FC_VERSION);}' unless defined(&fc_eid_init);
    eval 'sub fc_eid_is_set () { &FC_ROUTINE_VERSION( &fc_eid_is_set,  &FC_VERSION);}' unless defined(&fc_eid_is_set);
    eval 'sub fc_test_stack () { &FC_ROUTINE_VERSION( &fc_test_stack,  &FC_VERSION);}' unless defined(&fc_test_stack);
    eval 'sub fc_log_error () { &FC_ROUTINE_VERSION( &fc_log_error,  &FC_VERSION);}' unless defined(&fc_log_error);
    eval 'sub fc_push_stack () { &FC_ROUTINE_VERSION( &fc_push_stack,  &FC_VERSION);}' unless defined(&fc_push_stack);
    eval 'sub fc_display_fid () { &FC_ROUTINE_VERSION( &fc_display_fid,  &FC_VERSION);}' unless defined(&fc_display_fid);
    eval 'sub fc_mk_syslog_msg () { &FC_ROUTINE_VERSION( &fc_mk_syslog_msg,  &FC_VERSION);}' unless defined(&fc_mk_syslog_msg);
    eval 'sub FC_ROUTINE_VERSION {
        my($routinename, $versionnumber) = @_;
	    eval q( &FC_ROUTINE_VERSION_GLUE($routinename, $versionnumber));
    }' unless defined(&FC_ROUTINE_VERSION);
    eval 'sub FC_ROUTINE_VERSION_GLUE {
        my($routinename, $versionnumber) = @_;
	    eval q($routinename   &_  $versionnumber);
    }' unless defined(&FC_ROUTINE_VERSION_GLUE);
    if(((defined(&FC_VERSION) ? &FC_VERSION : 0) == 1) || defined( &FC_ALL_VERSIONS)) {
	eval 'sub fc_eid_init_1 {
	    my($ffdcid) = @_;
    	    eval q( &memset(( &void *) , 0, $sizeof{ &fc_eid_t}));
	}' unless defined(&fc_eid_init_1);
	eval 'sub fc_eid_is_set_1 {
	    my($ffdcid) = @_;
    	    eval q((0==  &strcmp(($ffdcid), \\"\\") ? 1: 0));
	}' unless defined(&fc_eid_is_set_1);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
