require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SCNHDR)) {
    eval 'sub _H_SCNHDR () {1;}' unless defined(&_H_SCNHDR);
    require 'xcoff32_64.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&__XCOFF_HYBRID__)) {
	if(defined(&__XCOFF32__)) {
	    eval 'sub SCNHSZ () {$sizeof{ &SCNHDR};}' unless defined(&SCNHSZ);
	    eval 'sub _OVERFLOW_MARKER () {(65535);}' unless defined(&_OVERFLOW_MARKER);
	}
	if(defined(&__XCOFF64__)) {
	    if(defined(&__XCOFF_32_64__)) {
		eval 'sub SCNHSZ_64 () {$sizeof{ &SCNHDR_64};}' unless defined(&SCNHSZ_64);
		eval 'sub _OVERFLOW_MARKER_64 () {(4294967295);}' unless defined(&_OVERFLOW_MARKER_64);
	    } else {
		eval 'sub SCNHSZ () {$sizeof{ &SCNHDR};}' unless defined(&SCNHSZ);
		eval 'sub _OVERFLOW_MARKER () {(4294967295);}' unless defined(&_OVERFLOW_MARKER);
	    }
	}
    } else {
	eval 'sub s_paddr32 () { ($_u->{_s32}->{_paddr});}' unless defined(&s_paddr32);
	eval 'sub s_vaddr32 () { ($_u->{_s32}->{_vaddr});}' unless defined(&s_vaddr32);
	eval 'sub s_size32 () { ($_u->{_s32}->{_size});}' unless defined(&s_size32);
	eval 'sub s_scnptr32 () { ($_u->{_s32}->{_scnptr});}' unless defined(&s_scnptr32);
	eval 'sub s_relptr32 () { ($_u->{_s32}->{_relptr});}' unless defined(&s_relptr32);
	eval 'sub s_lnnoptr32 () { ($_u->{_s32}->{_lnnoptr});}' unless defined(&s_lnnoptr32);
	eval 'sub s_nreloc32 () { ($_u->{_s32}->{_nreloc});}' unless defined(&s_nreloc32);
	eval 'sub s_nlnno32 () { ($_u->{_s32}->{_nlnno});}' unless defined(&s_nlnno32);
	eval 'sub s_flags32 () { ($_u->{_s32}->{_flags});}' unless defined(&s_flags32);
	eval 'sub SCNHSZ_32 () {(40);}' unless defined(&SCNHSZ_32);
	eval 'sub _OVERFLOW_MARKER_32 () {(65535);}' unless defined(&_OVERFLOW_MARKER_32);
	eval 'sub s_paddr64 () { ($_u->{_s64}->{_paddr});}' unless defined(&s_paddr64);
	eval 'sub s_vaddr64 () { ($_u->{_s64}->{_vaddr});}' unless defined(&s_vaddr64);
	eval 'sub s_size64 () { ($_u->{_s64}->{_size});}' unless defined(&s_size64);
	eval 'sub s_scnptr64 () { ($_u->{_s64}->{_scnptr});}' unless defined(&s_scnptr64);
	eval 'sub s_relptr64 () { ($_u->{_s64}->{_relptr});}' unless defined(&s_relptr64);
	eval 'sub s_lnnoptr64 () { ($_u->{_s64}->{_lnnoptr});}' unless defined(&s_lnnoptr64);
	eval 'sub s_nreloc64 () { ($_u->{_s64}->{_nreloc});}' unless defined(&s_nreloc64);
	eval 'sub s_nlnno64 () { ($_u->{_s64}->{_nlnno});}' unless defined(&s_nlnno64);
	eval 'sub s_flags64 () { ($_u->{_s64}->{_flags});}' unless defined(&s_flags64);
	eval 'sub SCNHSZ_64 () {$sizeof{ &SCNHDR};}' unless defined(&SCNHSZ_64);
	eval 'sub _OVERFLOW_MARKER_64 () {(4294967295);}' unless defined(&_OVERFLOW_MARKER_64);
    }
    eval 'sub _TEXT () {".text";}' unless defined(&_TEXT);
    eval 'sub _DATA () {".data";}' unless defined(&_DATA);
    eval 'sub _BSS () {".bss";}' unless defined(&_BSS);
    eval 'sub _PAD () {".pad";}' unless defined(&_PAD);
    eval 'sub _INFO () {".info";}' unless defined(&_INFO);
    eval 'sub _LOADER () {".loader";}' unless defined(&_LOADER);
    eval 'sub _TYPCHK () {".typchk";}' unless defined(&_TYPCHK);
    eval 'sub _DEBUG () {".debug";}' unless defined(&_DEBUG);
    eval 'sub _EXCEPT () {".except";}' unless defined(&_EXCEPT);
    eval 'sub _OVRFLO () {".ovrflo";}' unless defined(&_OVRFLO);
    eval 'sub STYP_REG () {0x;}' unless defined(&STYP_REG);
    eval 'sub STYP_PAD () {0x8;}' unless defined(&STYP_PAD);
    eval 'sub STYP_TEXT () {0x20;}' unless defined(&STYP_TEXT);
    eval 'sub STYP_DATA () {0x40;}' unless defined(&STYP_DATA);
    eval 'sub STYP_BSS () {0x80;}' unless defined(&STYP_BSS);
    eval 'sub STYP_EXCEPT () {0x100;}' unless defined(&STYP_EXCEPT);
    eval 'sub STYP_INFO () {0x200;}' unless defined(&STYP_INFO);
    eval 'sub STYP_LOADER () {0x1000;}' unless defined(&STYP_LOADER);
    eval 'sub STYP_DEBUG () {0x2000;}' unless defined(&STYP_DEBUG);
    eval 'sub STYP_TYPCHK () {0x4000;}' unless defined(&STYP_TYPCHK);
    eval 'sub STYP_OVRFLO () {0x8000;}' unless defined(&STYP_OVRFLO);
    if(defined(&__cplusplus)) {
    }
}
1;
