require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&snmp_dpiH)) {
    eval 'sub snmp_dpiH () {1;}' unless defined(&snmp_dpiH);
    if(defined(&DPI_VERY_MINIMAL_SUBAGENT)) {
	unless(defined(&DPI_MINIMAL_SUBAGENT)) {
	    eval 'sub DPI_MINIMAL_SUBAGENT () {1;}' unless defined(&DPI_MINIMAL_SUBAGENT);
	}
    }
    if(defined(&DPI_MINIMAL_SUBAGENT)) {
	unless(defined(&EXCLUDE_DPI_V1_SUPPORT)) {
	    eval 'sub EXCLUDE_DPI_V1_SUPPORT () {1;}' unless defined(&EXCLUDE_DPI_V1_SUPPORT);
	}
	if(defined(&INCLUDE_UDP_DOMAIN_FOR_DPI)) {
	    undef(&INCLUDE_UDP_DOMAIN_FOR_DPI) if defined(&INCLUDE_UDP_DOMAIN_FOR_DPI);
	}
	if(defined(&INCLUDE_UNIX_DOMAIN_FOR_DPI)) {
	    undef(&INCLUDE_UNIX_DOMAIN_FOR_DPI) if defined(&INCLUDE_UNIX_DOMAIN_FOR_DPI);
	}
	if(defined(&INCLUDE_NMQ_DOMAIN_FOR_DPI)) {
	    undef(&INCLUDE_NMQ_DOMAIN_FOR_DPI) if defined(&INCLUDE_NMQ_DOMAIN_FOR_DPI);
	}
	unless(defined(&SNMP_DPI_BUFSIZE)) {
	    eval 'sub SNMP_DPI_BUFSIZE () {1024;}' unless defined(&SNMP_DPI_BUFSIZE);
	}
    }
    if(defined( &OS2) | defined( &__OS2__) ) {
    }
    unless(defined(&LINKAGE)) {
	if(defined( &OS2) | defined( &__OS2__) ) {
	    eval 'sub LINKAGE () { &_System;}' unless defined(&LINKAGE);
	} else {
	    eval 'sub LINKAGE () {1;}' unless defined(&LINKAGE);
	}
    }
    if(defined(&CONST)) {
	unless(defined(&CONST_ALREADY_DEFINED)) {
	    undef(&CONST) if defined(&CONST);
	    eval 'sub CONST () { &const;}' unless defined(&CONST);
	    eval 'sub CONST_ALREADY_DEFINED () {1;}' unless defined(&CONST_ALREADY_DEFINED);
	}
    } else {
	eval 'sub CONST () {1;}' unless defined(&CONST);
	eval 'sub CONST_ALREADY_DEFINED () {1;}' unless defined(&CONST_ALREADY_DEFINED);
    }
    unless(defined(&SNMP_DPI_BUFSIZE)) {
	eval 'sub SNMP_DPI_BUFSIZE () {4096;}' unless defined(&SNMP_DPI_BUFSIZE);
    }
    eval 'sub SNMP_DPI_GET () {1;}' unless defined(&SNMP_DPI_GET);
    eval 'sub SNMP_DPI_GETNEXT () {2;}' unless defined(&SNMP_DPI_GETNEXT);
    eval 'sub SNMP_DPI_SET () {3;}' unless defined(&SNMP_DPI_SET);
    eval 'sub SNMP_DPI_TRAP () {4;}' unless defined(&SNMP_DPI_TRAP);
    eval 'sub SNMP_DPI_TRAPV1 () {4;}' unless defined(&SNMP_DPI_TRAPV1);
    eval 'sub SNMP_DPI_RESPONSE () {5;}' unless defined(&SNMP_DPI_RESPONSE);
    eval 'sub SNMP_DPI_REGISTER () {6;}' unless defined(&SNMP_DPI_REGISTER);
    eval 'sub SNMP_DPI_UNREGISTER () {7;}' unless defined(&SNMP_DPI_UNREGISTER);
    eval 'sub SNMP_DPI_OPEN () {8;}' unless defined(&SNMP_DPI_OPEN);
    eval 'sub SNMP_DPI_CLOSE () {9;}' unless defined(&SNMP_DPI_CLOSE);
    eval 'sub SNMP_DPI_COMMIT () {10;}' unless defined(&SNMP_DPI_COMMIT);
    eval 'sub SNMP_DPI_UNDO () {11;}' unless defined(&SNMP_DPI_UNDO);
    eval 'sub SNMP_DPI_GETBULK () {12;}' unless defined(&SNMP_DPI_GETBULK);
    eval 'sub SNMP_DPI_TRAPV2 () {13;}' unless defined(&SNMP_DPI_TRAPV2);
    eval 'sub SNMP_DPI_INFORM () {14;}' unless defined(&SNMP_DPI_INFORM);
    eval 'sub SNMP_DPI_ARE_YOU_THERE () {15;}' unless defined(&SNMP_DPI_ARE_YOU_THERE);
    eval 'sub SNMP_DPI_PROTOCOL () {2;}' unless defined(&SNMP_DPI_PROTOCOL);
    unless(defined(&SNMP_DPI_VERSION)) {
	eval 'sub SNMP_DPI_VERSION () {2;}' unless defined(&SNMP_DPI_VERSION);
    }
    unless(defined(&SNMP_DPI_RELEASE)) {
	eval 'sub SNMP_DPI_RELEASE () {0;}' unless defined(&SNMP_DPI_RELEASE);
    }
    if(((defined(&SNMP_DPI_VERSION) ? &SNMP_DPI_VERSION : 0) == 1) ) {
	unless(defined(&DPI_MINIMAL_SUBAGENT)) {
	    require 'snmp_dp1.ph';
	}
    } else {
	unless(defined(&DPI_MINIMAL_SUBAGENT)) {
	    eval 'sub mkDPIAreYouThere () { &mkDPIayt;}' unless defined(&mkDPIAreYouThere);
	}
	eval 'sub mkDPIregister {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &mkDPIreg(($a),($b),($c),($d),0));
	}' unless defined(&mkDPIregister);
	eval 'sub mkDPIunregister {
	    my($a,$b) = @_;
    	    eval q( &mkDPIureg(($a),($b)));
	}' unless defined(&mkDPIunregister);
	eval 'sub mkDPIresponse {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &mkDPIresp(($a),($b),($c),($d)));
	}' unless defined(&mkDPIresponse);
	eval 'sub mkDPItrap {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &mkDPItrape(($a),($b),($c),($d)));
	}' unless defined(&mkDPItrap);
	unless(defined(&DPI_MINIMAL_SUBAGENT)) {
	    eval 'sub mkDPIget {
	        my($a,$b,$c) = @_;
    		eval q( &mkDPIget_packet(($a),($b),($c)));
	    }' unless defined(&mkDPIget);
	    eval 'sub mkDPInext {
	        my($a,$b,$c) = @_;
    		eval q( &mkDPInext_packet(($a),($b),($c)));
	    }' unless defined(&mkDPInext);
	}
	eval 'sub mkDPIset {
	    my($a,$b,$c,$d,$e,$f) = @_;
    	    eval q( &mkDPIset_packet(($a),($b),($c),($d),($e),($f)));
	}' unless defined(&mkDPIset);
	eval 'sub fDPIset {
	    my($a) = @_;
    	    eval q( &fDPIset_packet(($a)));
	}' unless defined(&fDPIset);
	unless(defined(&DPI_MINIMAL_SUBAGENT)) {
	    eval 'sub query_DPI_port {
	        my($a,$b,$c) = @_;
    		eval q( &qDPIport(($a),($b),($c)));
	    }' unless defined(&query_DPI_port);
	}
	eval 'sub DPI_PACKET_LEN {
	    my($packet) = @_;
    	    eval q(((($packet) == ( &void *)0) ? 0: (*() * 256+ *((($packet))+1)) + 2));
	}' unless defined(&DPI_PACKET_LEN);
    }
    if(defined(&DPI_INCLUDE_SNMP_CONFIG)) {
	require 'snmp_config.ph';
    }
    eval 'sub SNMP_TYPE_MASK () {0x7f;}' unless defined(&SNMP_TYPE_MASK);
    eval 'sub SNMP_TYPE_Integer32 () {(128|1);}' unless defined(&SNMP_TYPE_Integer32);
    eval 'sub SNMP_TYPE_OCTET_STRING () {2;}' unless defined(&SNMP_TYPE_OCTET_STRING);
    eval 'sub SNMP_TYPE_OBJECT_IDENTIFIER () {3;}' unless defined(&SNMP_TYPE_OBJECT_IDENTIFIER);
    eval 'sub SNMP_TYPE_NULL () {4;}' unless defined(&SNMP_TYPE_NULL);
    eval 'sub SNMP_TYPE_IpAddress () {5;}' unless defined(&SNMP_TYPE_IpAddress);
    eval 'sub SNMP_TYPE_Counter32 () {(128|6);}' unless defined(&SNMP_TYPE_Counter32);
    eval 'sub SNMP_TYPE_Gauge32 () {(128|7);}' unless defined(&SNMP_TYPE_Gauge32);
    eval 'sub SNMP_TYPE_Unsigned32 () {(128|7);}' unless defined(&SNMP_TYPE_Unsigned32);
    eval 'sub SNMP_TYPE_TimeTicks () {(128|8);}' unless defined(&SNMP_TYPE_TimeTicks);
    eval 'sub SNMP_TYPE_DisplayString () {9;}' unless defined(&SNMP_TYPE_DisplayString);
    if(defined(&INCLUDE_RFC1442)) {
	eval 'sub SNMP_TYPE_BIT_STRING () {10;}' unless defined(&SNMP_TYPE_BIT_STRING);
	eval 'sub SNMP_TYPE_NsapAddress () {11;}' unless defined(&SNMP_TYPE_NsapAddress);
	eval 'sub SNMP_TYPE_UInteger32 () {(128|12);}' unless defined(&SNMP_TYPE_UInteger32);
    }
    eval 'sub SNMP_TYPE_Counter64 () {13;}' unless defined(&SNMP_TYPE_Counter64);
    eval 'sub SNMP_TYPE_Opaque () {14;}' unless defined(&SNMP_TYPE_Opaque);
    eval 'sub SNMP_TYPE_noSuchObject () {15;}' unless defined(&SNMP_TYPE_noSuchObject);
    eval 'sub SNMP_TYPE_noSuchInstance () {16;}' unless defined(&SNMP_TYPE_noSuchInstance);
    eval 'sub SNMP_TYPE_endOfMibView () {17;}' unless defined(&SNMP_TYPE_endOfMibView);
    unless(defined(&snmp_baseH)) {
	eval 'sub SNMP_ERROR_noError () {0;}' unless defined(&SNMP_ERROR_noError);
	eval 'sub SNMP_ERROR_tooBig () {1;}' unless defined(&SNMP_ERROR_tooBig);
	eval 'sub SNMP_ERROR_noSuchName () {2;}' unless defined(&SNMP_ERROR_noSuchName);
	eval 'sub SNMP_ERROR_badValue () {3;}' unless defined(&SNMP_ERROR_badValue);
	eval 'sub SNMP_ERROR_readOnly () {4;}' unless defined(&SNMP_ERROR_readOnly);
	eval 'sub SNMP_ERROR_genErr () {5;}' unless defined(&SNMP_ERROR_genErr);
	eval 'sub SNMP_ERROR_noAccess () {6;}' unless defined(&SNMP_ERROR_noAccess);
	eval 'sub SNMP_ERROR_wrongType () {7;}' unless defined(&SNMP_ERROR_wrongType);
	eval 'sub SNMP_ERROR_wrongLength () {8;}' unless defined(&SNMP_ERROR_wrongLength);
	eval 'sub SNMP_ERROR_wrongEncoding () {9;}' unless defined(&SNMP_ERROR_wrongEncoding);
	eval 'sub SNMP_ERROR_wrongValue () {10;}' unless defined(&SNMP_ERROR_wrongValue);
	eval 'sub SNMP_ERROR_noCreation () {11;}' unless defined(&SNMP_ERROR_noCreation);
	eval 'sub SNMP_ERROR_inconsistentValue () {12;}' unless defined(&SNMP_ERROR_inconsistentValue);
	eval 'sub SNMP_ERROR_resourceUnavailable () {13;}' unless defined(&SNMP_ERROR_resourceUnavailable);
	eval 'sub SNMP_ERROR_commitFailed () {14;}' unless defined(&SNMP_ERROR_commitFailed);
	eval 'sub SNMP_ERROR_undoFailed () {15;}' unless defined(&SNMP_ERROR_undoFailed);
	eval 'sub SNMP_ERROR_authorizationError () {16;}' unless defined(&SNMP_ERROR_authorizationError);
	eval 'sub SNMP_ERROR_notWritable () {17;}' unless defined(&SNMP_ERROR_notWritable);
	eval 'sub SNMP_ERROR_inconsistentName () {18;}' unless defined(&SNMP_ERROR_inconsistentName);
    }
    eval 'sub SNMP_ERROR_DPI_noError () {0;}' unless defined(&SNMP_ERROR_DPI_noError);
    eval 'sub SNMP_ERROR_DPI_otherError () {101;}' unless defined(&SNMP_ERROR_DPI_otherError);
    eval 'sub SNMP_ERROR_DPI_notFound () {102;}' unless defined(&SNMP_ERROR_DPI_notFound);
    eval 'sub SNMP_ERROR_DPI_alreadyRegistered () {103;}' unless defined(&SNMP_ERROR_DPI_alreadyRegistered);
    eval 'sub SNMP_ERROR_DPI_higherPriorityRegistered () {104;}' unless defined(&SNMP_ERROR_DPI_higherPriorityRegistered);
    eval 'sub SNMP_ERROR_DPI_mustOpenFirst () {105;}' unless defined(&SNMP_ERROR_DPI_mustOpenFirst);
    eval 'sub SNMP_ERROR_DPI_notAuthorized () {106;}' unless defined(&SNMP_ERROR_DPI_notAuthorized);
    eval 'sub SNMP_ERROR_DPI_viewSelectionNotSupported () {107;}' unless defined(&SNMP_ERROR_DPI_viewSelectionNotSupported);
    eval 'sub SNMP_ERROR_DPI_getBulkSelectionNotSupported () {108;}' unless defined(&SNMP_ERROR_DPI_getBulkSelectionNotSupported);
    eval 'sub SNMP_ERROR_DPI_duplicateSubAgentIdentifier () {109;}' unless defined(&SNMP_ERROR_DPI_duplicateSubAgentIdentifier);
    eval 'sub SNMP_ERROR_DPI_invalidDisplayString () {110;}' unless defined(&SNMP_ERROR_DPI_invalidDisplayString);
    eval 'sub SNMP_ERROR_DPI_characterSetSelectionNotSupported () {111;}' unless defined(&SNMP_ERROR_DPI_characterSetSelectionNotSupported);
    eval 'sub SNMP_UNREGISTER_otherReason () {1;}' unless defined(&SNMP_UNREGISTER_otherReason);
    eval 'sub SNMP_UNREGISTER_goingDown () {2;}' unless defined(&SNMP_UNREGISTER_goingDown);
    eval 'sub SNMP_UNREGISTER_justUnregister () {3;}' unless defined(&SNMP_UNREGISTER_justUnregister);
    eval 'sub SNMP_UNREGISTER_newRegistration () {4;}' unless defined(&SNMP_UNREGISTER_newRegistration);
    eval 'sub SNMP_UNREGISTER_higherPriorityRegistered () {5;}' unless defined(&SNMP_UNREGISTER_higherPriorityRegistered);
    eval 'sub SNMP_UNREGISTER_byManager () {6;}' unless defined(&SNMP_UNREGISTER_byManager);
    eval 'sub SNMP_UNREGISTER_timeout () {7;}' unless defined(&SNMP_UNREGISTER_timeout);
    eval 'sub SNMP_CLOSE_otherReason () {1;}' unless defined(&SNMP_CLOSE_otherReason);
    eval 'sub SNMP_CLOSE_goingDown () {2;}' unless defined(&SNMP_CLOSE_goingDown);
    eval 'sub SNMP_CLOSE_unsupportedVersion () {3;}' unless defined(&SNMP_CLOSE_unsupportedVersion);
    eval 'sub SNMP_CLOSE_protocolError () {4;}' unless defined(&SNMP_CLOSE_protocolError);
    eval 'sub SNMP_CLOSE_authenticationFailure () {5;}' unless defined(&SNMP_CLOSE_authenticationFailure);
    eval 'sub SNMP_CLOSE_byManager () {6;}' unless defined(&SNMP_CLOSE_byManager);
    eval 'sub SNMP_CLOSE_timeout () {7;}' unless defined(&SNMP_CLOSE_timeout);
    eval 'sub SNMP_CLOSE_openError () {8;}' unless defined(&SNMP_CLOSE_openError);
    eval 'sub resp_priority () { &error_index;}' unless defined(&resp_priority);
    eval 'sub snmp_dpi_hdr_NULL_p () {(( &snmp_dpi_hdr *)0);}' unless defined(&snmp_dpi_hdr_NULL_p);
    eval 'sub snmp_dpi_open_packet_NULL_p () {(( &snmp_dpi_open_packet *)0);}' unless defined(&snmp_dpi_open_packet_NULL_p);
    eval 'sub snmp_dpi_close_packet_NULL_p () {(( &snmp_dpi_close_packet *)0);}' unless defined(&snmp_dpi_close_packet_NULL_p);
    eval 'sub snmp_dpi_get_packet_NULL_p () {(( &snmp_dpi_get_packet *)0);}' unless defined(&snmp_dpi_get_packet_NULL_p);
    eval 'sub snmp_dpi_next_packet_NULL_p () {(( &snmp_dpi_next_packet *)0);}' unless defined(&snmp_dpi_next_packet_NULL_p);
    eval 'sub snmp_dpi_bulk_packet_NULL_p () {(( &snmp_dpi_bulk_packet *)0);}' unless defined(&snmp_dpi_bulk_packet_NULL_p);
    eval 'sub snmp_dpi_set_packet_NULL_p () {(( &snmp_dpi_set_packet *)0);}' unless defined(&snmp_dpi_set_packet_NULL_p);
    eval 'sub snmp_dpi_resp_packet_NULL_p () {(( &snmp_dpi_resp_packet *)0);}' unless defined(&snmp_dpi_resp_packet_NULL_p);
    eval 'sub snmp_dpi_trap_packet_NULL_p () {(( &snmp_dpi_trap_packet *)0);}' unless defined(&snmp_dpi_trap_packet_NULL_p);
    eval 'sub snmp_dpi_reg_packet_NULL_p () {(( &snmp_dpi_reg_packet *)0);}' unless defined(&snmp_dpi_reg_packet_NULL_p);
    eval 'sub snmp_dpi_ureg_packet_NULL_p () {(( &snmp_dpi_ureg_packet *)0);}' unless defined(&snmp_dpi_ureg_packet_NULL_p);
    eval 'sub proto_minor () { &proto_version;}' unless defined(&proto_minor);
    if(defined( &__cplusplus) ) {
	unless(defined(&DPI_NO_EXTERN_C)) {
	}
    }
    if(!defined( &DPI_VERY_MINIMAL_SUBAGENT)  && !defined( &SNMP_VERY_MINIMAL_AGENT)) {
    }
    eval 'sub DPI_MIN_CSET () {0;}' unless defined(&DPI_MIN_CSET);
    eval 'sub DPI_NATIVE_CSET () {0;}' unless defined(&DPI_NATIVE_CSET);
    eval 'sub DPI_ASCII_CSET () {1;}' unless defined(&DPI_ASCII_CSET);
    eval 'sub DPI_MAX_CSET () {1;}' unless defined(&DPI_MAX_CSET);
    eval 'sub DPI_BULK_NO () {0;}' unless defined(&DPI_BULK_NO);
    eval 'sub DPI_BULK_YES () {1;}' unless defined(&DPI_BULK_YES);
    eval 'sub DPI_VIEW_NO () {0;}' unless defined(&DPI_VIEW_NO);
    eval 'sub DPI_VIEW_YES () {1;}' unless defined(&DPI_VIEW_YES);
    unless(defined(&DPI_MINIMAL_SUBAGENT)) {
    }
    eval 'sub mkDPIhdr {
        my($a) = @_;
	    eval q( &mkDPIhdr_version(($a), &SNMP_DPI_VERSION,  &SNMP_DPI_RELEASE));
    }' unless defined(&mkDPIhdr);
    unless(defined(&DPI_MINIMAL_SUBAGENT)) {
    }
    unless(defined(&DPI_MINIMAL_SUBAGENT)) {
    }
    eval 'sub dpiPortForTCP () {1;}' unless defined(&dpiPortForTCP);
    eval 'sub dpiPortForUDP () {2;}' unless defined(&dpiPortForUDP);
    eval 'sub dpiPathForUnixSocket () {3;}' unless defined(&dpiPathForUnixSocket);
    eval 'sub DPIconnect () { &DPIconnectTCP;}' unless defined(&DPIconnect);
    eval 'sub DPI_RC_OK () {0;}' unless defined(&DPI_RC_OK);
    eval 'sub DPI_RC_NOK () {-1;}' unless defined(&DPI_RC_NOK);
    eval 'sub DPI_RC_NO_PORT () {-2;}' unless defined(&DPI_RC_NO_PORT);
    eval 'sub DPI_RC_NO_CONNECTION () {-3;}' unless defined(&DPI_RC_NO_CONNECTION);
    eval 'sub DPI_RC_EOF () {-4;}' unless defined(&DPI_RC_EOF);
    eval 'sub DPI_RC_IO_ERROR () {-5;}' unless defined(&DPI_RC_IO_ERROR);
    eval 'sub DPI_RC_INVALID_HANDLE () {-6;}' unless defined(&DPI_RC_INVALID_HANDLE);
    eval 'sub DPI_RC_TIMEOUT () {-7;}' unless defined(&DPI_RC_TIMEOUT);
    eval 'sub DPI_RC_PACKET_TOO_LARGE () {-8;}' unless defined(&DPI_RC_PACKET_TOO_LARGE);
    eval 'sub DPI_RC_UNSUPPORTED_DOMAIN () {-9;}' unless defined(&DPI_RC_UNSUPPORTED_DOMAIN);
    eval 'sub DPI_RC_INVALID_ARGUMENT () {-10;}' unless defined(&DPI_RC_INVALID_ARGUMENT);
    unless(defined(&DPI_MINIMAL_SUBAGENT)) {
    }
    unless(defined(&DPI_MINIMAL_SUBAGENT)) {
    }
    unless(defined(&SNMP_VERY_MINIMAL_AGENT)) {
    }
    if(defined( &__cplusplus) ) {
	unless(defined(&DPI_NO_EXTERN_C)) {
	}
    }
    if(defined( &OS2) | defined( &__OS2__) ) {
    }
}
1;
