require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SYMS)) {
    eval 'sub _H_SYMS () {1;}' unless defined(&_H_SYMS);
    require 'xcoff32_64.ph';
    if(defined(&__cplusplus)) {
    }
    require 'storclass.ph';
    eval 'sub SYMNMLEN () {8;}' unless defined(&SYMNMLEN);
    eval 'sub FILNMLEN () {14;}' unless defined(&FILNMLEN);
    if(defined(&__XCOFF32__)) {
	eval 'sub DIMNUM () {4;}' unless defined(&DIMNUM);
    }
    unless(defined(&__XCOFF_HYBRID__)) {
	if(defined(&__XCOFF32__)) {
	    unless(defined(&__64BIT__)) {
	    } else {
	    }
	    unless(defined(&n_name)) {
		eval 'sub n_name () { ($_n->{_n_name});}' unless defined(&n_name);
	    }
	    eval 'sub n_zeroes () { ($_n->{_n_n}->{_n_zeroes});}' unless defined(&n_zeroes);
	    unless(defined(&__XCOFF64__)) {
		eval 'sub n_nptr () { ($_n->{_n_nptr[1]});}' unless defined(&n_nptr);
	    }
	}
	if(defined(&__XCOFF64__)) {
	    unless(defined(&__64BIT__)) {
	    }
	    if(defined(&__XCOFF_32_64__)) {
		eval 'sub SYMESZ_64 () {(18);}' unless defined(&SYMESZ_64);
	    }
	    unless(defined(&__XCOFF32__)) {
		eval 'sub n_nptr () { ($_n->{_n_nptr});}' unless defined(&n_nptr);
	    }
	}
	eval 'sub n_offset () { ($_n->{_n_n}->{_n_offset});}' unless defined(&n_offset);
    } else {
	unless(defined(&__64BIT__)) {
	} else {
	}
	eval 'sub n_name32 () { ($_n->{_name32});}' unless defined(&n_name32);
	eval 'sub n_nptr32 () { ($_n->{_nptr32[1]});}' unless defined(&n_nptr32);
	eval 'sub n_zeroes32 () { ($_n->{_n_n}->{_zeroes32});}' unless defined(&n_zeroes32);
	eval 'sub n_value64 () { ($_n->{_value64});}' unless defined(&n_value64);
	eval 'sub n_offset32 () { ($_n->{_n_n}->{_offset32});}' unless defined(&n_offset32);
	unless(defined(&__64BIT__)) {
	    eval 'sub n_nptr64 () { ($_u2->{_offset64});}' unless defined(&n_nptr64);
	}
	eval 'sub n_value32 () { ($_u2->{_value32});}' unless defined(&n_value32);
	eval 'sub n_offset64 () { ($_u2->{_offset64});}' unless defined(&n_offset64);
    }
    unless(defined(&n_type)) {
	eval 'sub n_type () { ($_n_tylc->{_n_type});}' unless defined(&n_type);
    }
    eval 'sub n_cputype () { ($_n_tylc->{_n_lc}->{_n_cpu});}' unless defined(&n_cputype);
    eval 'sub n_lang () { ($_n_tylc->{_n_lc}->{_n_lang});}' unless defined(&n_lang);
    eval 'sub SYMESZ () {(18);}' unless defined(&SYMESZ);
    if(defined(&__XCOFF_HYBRID__)) {
	eval 'sub SYMESZ_32 () {(18);}' unless defined(&SYMESZ_32);
	eval 'sub SYMESZ_64 () {(18);}' unless defined(&SYMESZ_64);
    }
    eval 'sub N_UNDEF () {0;}' unless defined(&N_UNDEF);
    eval 'sub N_ABS () {-1;}' unless defined(&N_ABS);
    eval 'sub N_DEBUG () {-2;}' unless defined(&N_DEBUG);
    if(defined(&__XCOFF32__)) {
	eval 'sub T_NULL () {0;}' unless defined(&T_NULL);
	eval 'sub T_ARG () {1;}' unless defined(&T_ARG);
	eval 'sub T_CHAR () {2;}' unless defined(&T_CHAR);
	eval 'sub T_SHORT () {3;}' unless defined(&T_SHORT);
	eval 'sub T_INT () {4;}' unless defined(&T_INT);
	eval 'sub T_LONG () {5;}' unless defined(&T_LONG);
	eval 'sub T_FLOAT () {6;}' unless defined(&T_FLOAT);
	eval 'sub T_DOUBLE () {7;}' unless defined(&T_DOUBLE);
	eval 'sub T_STRUCT () {8;}' unless defined(&T_STRUCT);
	eval 'sub T_UNION () {9;}' unless defined(&T_UNION);
	eval 'sub T_ENUM () {10;}' unless defined(&T_ENUM);
	eval 'sub T_MOE () {11;}' unless defined(&T_MOE);
	eval 'sub T_UCHAR () {12;}' unless defined(&T_UCHAR);
	eval 'sub T_USHORT () {13;}' unless defined(&T_USHORT);
	eval 'sub T_UINT () {14;}' unless defined(&T_UINT);
	eval 'sub T_ULONG () {15;}' unless defined(&T_ULONG);
	eval 'sub DT_NON () {0;}' unless defined(&DT_NON);
	eval 'sub DT_PTR () {1;}' unless defined(&DT_PTR);
	eval 'sub DT_FCN () {2;}' unless defined(&DT_FCN);
	eval 'sub DT_ARY () {3;}' unless defined(&DT_ARY);
	eval 'sub N_BTMASK () {017;}' unless defined(&N_BTMASK);
	eval 'sub N_TMASK () {060;}' unless defined(&N_TMASK);
	eval 'sub N_TMASK1 () {0300;}' unless defined(&N_TMASK1);
	eval 'sub N_TMASK2 () {0360;}' unless defined(&N_TMASK2);
	eval 'sub N_BTSHFT () {4;}' unless defined(&N_BTSHFT);
	eval 'sub N_TSHIFT () {2;}' unless defined(&N_TSHIFT);
	unless(defined(&_COMPILER)) {
	    eval 'sub BTYPE {
	        my($x) = @_;
    		eval q((($x) &  &N_BTMASK));
	    }' unless defined(&BTYPE);
	    eval 'sub ISPTR {
	        my($x) = @_;
    		eval q(((($x) &  &N_TMASK) == ( &DT_PTR <<  &N_BTSHFT)));
	    }' unless defined(&ISPTR);
	    eval 'sub ISFCN {
	        my($x) = @_;
    		eval q(((($x) &  &N_TMASK) == ( &DT_FCN <<  &N_BTSHFT)));
	    }' unless defined(&ISFCN);
	    eval 'sub ISARY {
	        my($x) = @_;
    		eval q(((($x) &  &N_TMASK) == ( &DT_ARY <<  &N_BTSHFT)));
	    }' unless defined(&ISARY);
	    eval 'sub ISTAG {
	        my($x) = @_;
    		eval q((($x)== &C_STRTAG || ($x)== &C_UNTAG || ($x)== &C_ENTAG));
	    }' unless defined(&ISTAG);
	    eval 'sub INCREF {
	        my($x) = @_;
    		eval q((((($x)&~ &N_BTMASK)<< &N_TSHIFT)|( &DT_PTR<< &N_BTSHFT)|($x &N_BTMASK)));
	    }' unless defined(&INCREF);
	    eval 'sub DECREF {
	        my($x) = @_;
    		eval q((((($x)>> &N_TSHIFT)&~ &N_BTMASK)|(($x) &N_BTMASK)));
	    }' unless defined(&DECREF);
	}
    }
    if(defined(&__XCOFF_32_64__)) {
	eval 'sub ISFCN_64 {
	    my($x) = @_;
    	    eval q((($x) & 0x20));
	}' unless defined(&ISFCN_64);
    }
    if(defined(&__XCOFF_64__)) {
	eval 'sub ISFCN {
	    my($x) = @_;
    	    eval q((($x) & 0x20));
	}' unless defined(&ISFCN);
    }
    eval 'sub AUXESZ () {(18);}' unless defined(&AUXESZ);
    if(defined(&__XCOFF_HYBRID__)) {
	eval 'sub AUXESZ_32 () {(18);}' unless defined(&AUXESZ_32);
	eval 'sub AUXESZ_64 () {(18);}' unless defined(&AUXESZ_64);
    }
    if(defined(&__XCOFF_HYBRID__)) {
	eval 'sub _S32_ {
	    my($name) = @_;
    	    eval q($name  32);
	}' unless defined(&_S32_);
    } else {
	eval 'sub _S32_ {
	    my($name) = @_;
    	    eval q($name);
	}' unless defined(&_S32_);
    }
    if(defined(&__XCOFF32__)) {
	eval 'sub x_exptr () { &x_tagndx;}' unless defined(&x_exptr);
	if(defined(&__XCOFF_HYBRID__)) {
	}
	if(defined(&__XCOFF_HYBRID__)) {
	    eval 'sub x_auxtype64 () { ($_x->{_xt}->{_auxtype});}' unless defined(&x_auxtype64);
	}
	if(defined(&__XCOFF_HYBRID__)) {
	} else {
	}
	if(defined(&__XCOFF_HYBRID__)) {
	} else {
	}
	if(defined(&__XCOFF_HYBRID__)) {
	    eval 'sub x_snstab32 () { ($_x->{_snstab});}' unless defined(&x_snstab32);
	    eval 'sub x_scnlen32 () { ($_u->{_scnlen32});}' unless defined(&x_scnlen32);
	    eval 'sub x_scnlen_lo64 () { ($_u->{_scnlen_lo64});}' unless defined(&x_scnlen_lo64);
	    eval 'sub x_scnlen_hi64 () { &x_stab32;}' unless defined(&x_scnlen_hi64);
	}
	if(defined(&__XCOFF_HYBRID__)) {
	}
    }
    if(defined( &__XCOFF64__)  && ! defined( &__XCOFF_HYBRID__)) {
	if(defined(&__XCOFF32__)) {
	    eval 'sub AUXESZ_64 () {(18);}' unless defined(&AUXESZ_64);
	}
    }
    if(defined(&__XCOFF64__)) {
	eval 'sub _AUX_EXCEPT () {255;}' unless defined(&_AUX_EXCEPT);
	eval 'sub _AUX_FCN () {254;}' unless defined(&_AUX_FCN);
	eval 'sub _AUX_SYM () {253;}' unless defined(&_AUX_SYM);
	eval 'sub _AUX_FILE () {252;}' unless defined(&_AUX_FILE);
	eval 'sub _AUX_CSECT () {251;}' unless defined(&_AUX_CSECT);
    }
    eval 'sub XFT_FN () {0;}' unless defined(&XFT_FN);
    eval 'sub XFT_CT () {1;}' unless defined(&XFT_CT);
    eval 'sub XFT_CV () {2;}' unless defined(&XFT_CV);
    eval 'sub XFT_CD () {128;}' unless defined(&XFT_CD);
    eval 'sub XTY_ER () {0;}' unless defined(&XTY_ER);
    eval 'sub XTY_SD () {1;}' unless defined(&XTY_SD);
    eval 'sub XTY_LD () {2;}' unless defined(&XTY_LD);
    eval 'sub XTY_CM () {3;}' unless defined(&XTY_CM);
    if(defined(&__XCOFF_32__)) {
	eval 'sub XTY_HL () {6;}' unless defined(&XTY_HL);
	eval 'sub XTY_US () {5;}' unless defined(&XTY_US);
	eval 'sub XTY_EM () {4;}' unless defined(&XTY_EM);
    }
    eval 'sub XMC_PR () {0;}' unless defined(&XMC_PR);
    eval 'sub XMC_RO () {1;}' unless defined(&XMC_RO);
    eval 'sub XMC_DB () {2;}' unless defined(&XMC_DB);
    eval 'sub XMC_GL () {6;}' unless defined(&XMC_GL);
    eval 'sub XMC_XO () {7;}' unless defined(&XMC_XO);
    eval 'sub XMC_SV () {8;}' unless defined(&XMC_SV);
    eval 'sub XMC_SV64 () {17;}' unless defined(&XMC_SV64);
    eval 'sub XMC_SV3264 () {18;}' unless defined(&XMC_SV3264);
    eval 'sub XMC_TI () {12;}' unless defined(&XMC_TI);
    eval 'sub XMC_TB () {13;}' unless defined(&XMC_TB);
    eval 'sub XMC_RW () {5;}' unless defined(&XMC_RW);
    eval 'sub XMC_TC0 () {15;}' unless defined(&XMC_TC0);
    eval 'sub XMC_TC () {3;}' unless defined(&XMC_TC);
    eval 'sub XMC_TD () {16;}' unless defined(&XMC_TD);
    eval 'sub XMC_DS () {10;}' unless defined(&XMC_DS);
    eval 'sub XMC_UA () {4;}' unless defined(&XMC_UA);
    eval 'sub XMC_BS () {9;}' unless defined(&XMC_BS);
    eval 'sub XMC_UC () {11;}' unless defined(&XMC_UC);
    eval 'sub _ETEXT () {"etext";}' unless defined(&_ETEXT);
    eval 'sub _EDATA () {"edata";}' unless defined(&_EDATA);
    eval 'sub _END () {"end";}' unless defined(&_END);
    eval 'sub _EF () {".ef";}' unless defined(&_EF);
    eval 'sub _START () {"__start";}' unless defined(&_START);
    if(defined(&__cplusplus)) {
    }
}
1;
