require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_AIO)) {
    eval 'sub _H_AIO () {1;}' unless defined(&_H_AIO);
    require 'sys/errno.ph';
    require 'sys/file.ph';
    require 'sys/signal.ph';
    require 'sys/time.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_ALL_SOURCE)) {
	eval 'sub EINPROG () { &EINPROGRESS;}' unless defined(&EINPROG);
	if(defined(&_LARGE_FILES)) {
	    eval 'sub aiocb () { &aiocb64;}' unless defined(&aiocb);
	    eval 'sub liocb () { &liocb64;}' unless defined(&liocb);
	    eval 'sub aio_read () { &aio_read64;}' unless defined(&aio_read);
	    eval 'sub aio_write () { &aio_write64;}' unless defined(&aio_write);
	    eval 'sub aio_suspend () { &aio_suspend64;}' unless defined(&aio_suspend);
	    eval 'sub aio_cancel () { &aio_cancel64;}' unless defined(&aio_cancel);
	    eval 'sub lio_listio () { &lio_listio64;}' unless defined(&lio_listio);
	}
	unless(defined(&_LARGE_FILES)) {
	    if(defined(&_KERNEL)) {
	    } else {
	    }
	}
	if(defined( &_LARGE_FILES) || defined( &_LARGE_FILE_API)) {
	    if(defined(&_LARGE_FILES)) {
	    } else {
	    }
	}
	eval 'sub AIO_EVENT () {0x1;}' unless defined(&AIO_EVENT);
	eval 'sub AIO_SIGNAL () {0x2;}' unless defined(&AIO_SIGNAL);
	eval 'sub AIO_CANCELED () {0;}' unless defined(&AIO_CANCELED);
	eval 'sub AIO_NOTCANCELED () {1;}' unless defined(&AIO_NOTCANCELED);
	eval 'sub AIO_ALLDONE () {2;}' unless defined(&AIO_ALLDONE);
	eval 'sub LIO_NOWAIT () {0;}' unless defined(&LIO_NOWAIT);
	eval 'sub LIO_WAIT () {1;}' unless defined(&LIO_WAIT);
	eval 'sub LIO_ASYNC () {2;}' unless defined(&LIO_ASYNC);
	eval 'sub LIO_ASIG () {3;}' unless defined(&LIO_ASIG);
	eval 'sub LIO_NOWAIT_AIOWAIT () {4;}' unless defined(&LIO_NOWAIT_AIOWAIT);
	eval 'sub LIO_NOP () {0;}' unless defined(&LIO_NOP);
	eval 'sub LIO_READ () {1;}' unless defined(&LIO_READ);
	eval 'sub LIO_WRITE () {2;}' unless defined(&LIO_WRITE);
	eval 'sub aio_return {
	    my($h) = @_;
    	    eval q((($h)-> &aio_return));
	}' unless defined(&aio_return);
	eval 'sub aio_error {
	    my($h) = @_;
    	    eval q((($h)-> &aio_errno));
	}' unless defined(&aio_error);
	if(defined(&_LARGE_FILE_API)) {
	    eval 'sub aio_return64 {
	        my($h) = @_;
    		eval q((($h)-> &aio_return));
	    }' unless defined(&aio_return64);
	    eval 'sub aio_error64 {
	        my($h) = @_;
    		eval q((($h)-> &aio_errno));
	    }' unless defined(&aio_error64);
	}
	if(defined(&_NO_PROTO)) {
	} else {
	    if(defined(&_LARGE_FILE_API)) {
	    }
	}
    } else {
	if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0)==500) {
	    eval 'sub AIO_CANCELED () {999;}' unless defined(&AIO_CANCELED);
	    eval 'sub AIO_NOTCANCELED () {999;}' unless defined(&AIO_NOTCANCELED);
	    eval 'sub AIO_ALLDONE () {999;}' unless defined(&AIO_ALLDONE);
	    eval 'sub LIO_WAIT () {999;}' unless defined(&LIO_WAIT);
	    eval 'sub LIO_NOWAIT () {999;}' unless defined(&LIO_NOWAIT);
	    eval 'sub LIO_READ () {999;}' unless defined(&LIO_READ);
	    eval 'sub LIO_WRITE () {999;}' unless defined(&LIO_WRITE);
	    eval 'sub LIO_NOP () {999;}' unless defined(&LIO_NOP);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
