require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_GSC)) {
    eval 'sub _H_GSC () {1;}' unless defined(&_H_GSC);
    require 'sys/rcm_win.ph';
    unless(defined(&__64BIT_KERNEL)) {
    }
    eval 'sub GSCIO () {(ord(\'G\')<<8);}' unless defined(&GSCIO);
    eval 'sub MAX_PRIORITY () {100;}' unless defined(&MAX_PRIORITY);
    eval 'sub DEFAULT_PRIORITY () {1;}' unless defined(&DEFAULT_PRIORITY);
    eval 'sub GSC_FAST_SYSCALL_ERROR_BASE () {(1 << 10);}' unless defined(&GSC_FAST_SYSCALL_ERROR_BASE);
    eval 'sub MAKE_GP () {( &GSCIO | 1);}' unless defined(&MAKE_GP);
    eval 'sub SHARE_ACCESS () {0;}' unless defined(&SHARE_ACCESS);
    eval 'sub EXCLUSIVE_ACCESS () {1;}' unless defined(&EXCLUSIVE_ACCESS);
    eval 'sub ADDR_ARRAY_VERSION () {(1 << 1);}' unless defined(&ADDR_ARRAY_VERSION);
    eval 'sub ALL_ADDR_RANGES () {(1 << 2);}' unless defined(&ALL_ADDR_RANGES);
    eval 'sub SP_THREAD () {(1 << 3);}' unless defined(&SP_THREAD);
    eval 'sub MP_MODEL_2 () {(1 << 4);}' unless defined(&MP_MODEL_2);
    if(defined(&__64BIT_KERNEL)) {
    }
    eval 'sub UNMAKE_GP () {( &GSCIO | 2);}' unless defined(&UNMAKE_GP);
    eval 'sub SET_GP_PRIORITY () {( &GSCIO | 3);}' unless defined(&SET_GP_PRIORITY);
    eval 'sub SET_GP_CONTEXT_PRIORITY () {( &GSCIO | 0x83);}' unless defined(&SET_GP_CONTEXT_PRIORITY);
    if(defined(&__64BIT_KERNEL)) {
    }
    eval 'sub CREATE_RCX () {( &GSCIO | 4);}' unless defined(&CREATE_RCX);
    if(defined(&__64BIT_KERNEL)) {
    }
    eval 'sub DELETE_RCX () {( &GSCIO | 5);}' unless defined(&DELETE_RCX);
    eval 'sub CREATE_WIN_GEOM () {( &GSCIO | 6);}' unless defined(&CREATE_WIN_GEOM);
    if(defined(&__64BIT_KERNEL)) {
    }
    eval 'sub DELETE_WIN_GEOM () {( &GSCIO | 7);}' unless defined(&DELETE_WIN_GEOM);
    eval 'sub UPDATE_WIN_GEOM () {( &GSCIO | 8);}' unless defined(&UPDATE_WIN_GEOM);
    if(defined(&__64BIT_KERNEL)) {
    }
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub CREATE_WIN_ATTR () {( &GSCIO | 9);}' unless defined(&CREATE_WIN_ATTR);
	eval 'sub DELETE_WIN_ATTR () {( &GSCIO | 10);}' unless defined(&DELETE_WIN_ATTR);
	eval 'sub UPDATE_WIN_ATTR () {( &GSCIO | 11);}' unless defined(&UPDATE_WIN_ATTR);
    }
    eval 'sub BIND_WINDOW () {( &GSCIO | 12);}' unless defined(&BIND_WINDOW);
    unless(defined(&__64BIT_KERNEL)) {
    }
    eval 'sub BIND_DRAW_READ_WINDOWS () {( &GSCIO | 92);}' unless defined(&BIND_DRAW_READ_WINDOWS);
    eval 'sub SET_RCX () {( &GSCIO | 13);}' unless defined(&SET_RCX);
    eval 'sub LOCK_HW () {( &GSCIO | 14);}' unless defined(&LOCK_HW);
    eval 'sub UNLOCK_HW () {( &GSCIO | 15);}' unless defined(&UNLOCK_HW);
    eval 'sub LOCK_DOMAIN () {( &GSCIO | 16);}' unless defined(&LOCK_DOMAIN);
    eval 'sub UNLOCK_DOMAIN () {( &GSCIO | 17);}' unless defined(&UNLOCK_DOMAIN);
    eval 'sub GIVE_UP_TIMESLICE () {( &GSCIO | 22);}' unless defined(&GIVE_UP_TIMESLICE);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub CREATE_RCXP () {( &GSCIO | 18);}' unless defined(&CREATE_RCXP);
	eval 'sub RCXP_RELOCATABLE () {0x1;}' unless defined(&RCXP_RELOCATABLE);
	eval 'sub RCXP_INDIRECT () {0x2;}' unless defined(&RCXP_INDIRECT);
	eval 'sub DELETE_RCXP () {( &GSCIO | 19);}' unless defined(&DELETE_RCXP);
	eval 'sub ASSOCIATE_RCXP () {( &GSCIO | 20);}' unless defined(&ASSOCIATE_RCXP);
	eval 'sub DISASSOCIATE_RCXP () {( &GSCIO | 21);}' unless defined(&DISASSOCIATE_RCXP);
    }
    eval 'sub COMMAND_LIST () {( &GSCIO | 29);}' unless defined(&COMMAND_LIST);
    eval 'sub MAX_CMDS () {5;}' unless defined(&MAX_CMDS);
    if(defined(&__64BIT_KERNEL)) {
    }
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub DMA_SERVICE () {( &GSCIO | 30);}' unless defined(&DMA_SERVICE);
	eval 'sub MAX_SUBAREAS () {0x4;}' unless defined(&MAX_SUBAREAS);
	eval 'sub DMA_INCOMPLETE () {0x1;}' unless defined(&DMA_INCOMPLETE);
	eval 'sub DMA_WAIT () {0x1;}' unless defined(&DMA_WAIT);
	eval 'sub DMA_POLL () {0x2;}' unless defined(&DMA_POLL);
	eval 'sub DMA_READ () {0x80;}' unless defined(&DMA_READ);
	eval 'sub DMA_WRITE () {0x40;}' unless defined(&DMA_WRITE);
	eval 'sub DMA_RDWR () {0x20;}' unless defined(&DMA_RDWR);
	eval 'sub DMA_FREE () {0x100;}' unless defined(&DMA_FREE);
	eval 'sub DMA_START_FLAG () {0x200;}' unless defined(&DMA_START_FLAG);
	eval 'sub DMA_DIAGNOSTICS () {0x8000;}' unless defined(&DMA_DIAGNOSTICS);
	eval 'sub DMA_PINNED () {0x4;}' unless defined(&DMA_PINNED);
	eval 'sub LEAVE_PINNED () {0x8;}' unless defined(&LEAVE_PINNED);
	eval 'sub DMA_INVALIDATE () {0x10;}' unless defined(&DMA_INVALIDATE);
	eval 'sub DMA_START_SW () {0x20;}' unless defined(&DMA_START_SW);
    }
    eval 'sub DEV_DEP_FUN () {( &GSCIO | 50);}' unless defined(&DEV_DEP_FUN);
    if(defined(&__64BIT_KERNEL)) {
    }
    eval 'sub GSC_RCM_REQ () {( &GSCIO | 51);}' unless defined(&GSC_RCM_REQ);
    eval 'sub gsc_SHM_INIT () {1;}' unless defined(&gsc_SHM_INIT);
    eval 'sub gsc_SHM_EXTEND () {2;}' unless defined(&gsc_SHM_EXTEND);
    eval 'sub gsc_SHM_DELETE () {3;}' unless defined(&gsc_SHM_DELETE);
    eval 'sub gsc_SHM_Unused () {0;}' unless defined(&gsc_SHM_Unused);
    eval 'sub gsc_SHM_CurrDispBuff () {1;}' unless defined(&gsc_SHM_CurrDispBuff);
    eval 'sub gsc_SHM_MBX () {2;}' unless defined(&gsc_SHM_MBX);
    eval 'sub gsc_SHM_hwSync () {3;}' unless defined(&gsc_SHM_hwSync);
    eval 'sub gsc_SHM_Spare4 () {4;}' unless defined(&gsc_SHM_Spare4);
    eval 'sub gsc_SHM_Spare5 () {5;}' unless defined(&gsc_SHM_Spare5);
    eval 'sub gsc_SHM_Spare6 () {6;}' unless defined(&gsc_SHM_Spare6);
    eval 'sub gsc_SHM_Spare7 () {7;}' unless defined(&gsc_SHM_Spare7);
    eval 'sub GSC_DEVICE_REQ () {( &GSCIO | 52);}' unless defined(&GSC_DEVICE_REQ);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub BAD_ARRAY_SIZE () {99;}' unless defined(&BAD_ARRAY_SIZE);
	eval 'sub ASYNC_EVENT () {( &GSCIO | 69);}' unless defined(&ASYNC_EVENT);
	eval 'sub GET_EVENTS () {( &GSCIO | 70);}' unless defined(&GET_EVENTS);
	eval 'sub EVENT_BUFFER () {( &GSCIO | 71);}' unless defined(&EVENT_BUFFER);
	eval 'sub WAIT_EVENT () {( &GSCIO | 72);}' unless defined(&WAIT_EVENT);
	eval 'sub ENABLE_EVENT () {( &GSCIO | 73);}' unless defined(&ENABLE_EVENT);
	eval 'sub CREATE_COLORMAP () {( &GSCIO | 74);}' unless defined(&CREATE_COLORMAP);
	eval 'sub DELETE_COLORMAP () {( &GSCIO | 75);}' unless defined(&DELETE_COLORMAP);
	eval 'sub UPDATE_COLORMAP () {( &GSCIO | 76);}' unless defined(&UPDATE_COLORMAP);
    }
    eval 'sub DISP_PM () {( &GSCIO | 77);}' unless defined(&DISP_PM);
    eval 'sub CHANGE_POWER_STATE () {1;}' unless defined(&CHANGE_POWER_STATE);
    eval 'sub LCD_ON () {5;}' unless defined(&LCD_ON);
    eval 'sub LCD_OFF () {6;}' unless defined(&LCD_OFF);
    eval 'sub CRT_ON () {7;}' unless defined(&CRT_ON);
    eval 'sub CRT_OFF () {8;}' unless defined(&CRT_OFF);
    eval 'sub PTID_ENTRY () {0;}' unless defined(&PTID_ENTRY);
    eval 'sub PTID_EXIT () {1;}' unless defined(&PTID_EXIT);
}
1;
