require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&_KERNEL)) {
    require 'net/net_globals.ph';
}
unless(defined(&_SYS_CDLI_H)) {
    eval 'sub _SYS_CDLI_H () {1;}' unless defined(&_SYS_CDLI_H);
    require 'sys/types.ph';
    require 'sys/socket.ph';
    require 'sys/time.ph';
    require 'net/if.ph';
    eval 'sub NS_PROTO () {0x1;}' unless defined(&NS_PROTO);
    eval 'sub NS_PROTO_SNAP () {0x2;}' unless defined(&NS_PROTO_SNAP);
    eval 'sub NS_INCLUDE_LLC () {0x4;}' unless defined(&NS_INCLUDE_LLC);
    eval 'sub NS_INCLUDE_MAC () {0x8;}' unless defined(&NS_INCLUDE_MAC);
    eval 'sub NS_HANDLE_NON_UI () {0x100;}' unless defined(&NS_HANDLE_NON_UI);
    eval 'sub NS_HANDLE_HEADERS () {0x200;}' unless defined(&NS_HANDLE_HEADERS);
    eval 'sub NS_8022_LLC_DSAP () {(0x1);}' unless defined(&NS_8022_LLC_DSAP);
    eval 'sub NS_8022_LLC_DSAP_SNAP () {(0x2);}' unless defined(&NS_8022_LLC_DSAP_SNAP);
    eval 'sub NS_TAP () {(0x3);}' unless defined(&NS_TAP);
    eval 'sub NS_ETHERTYPE () {(0x4);}' unless defined(&NS_ETHERTYPE);
    eval 'sub NS_VLAN () {(0x5);}' unless defined(&NS_VLAN);
    eval 'sub NS_LAST_FILTER () {(0x10);}' unless defined(&NS_LAST_FILTER);
    eval 'sub NS_STATUS_MASK () {(0x1);}' unless defined(&NS_STATUS_MASK);
    eval 'sub ND_CONFIG_VERSION_1 () {0x1;}' unless defined(&ND_CONFIG_VERSION_1);
    if(defined(&_KERNEL)) {
	unless(defined(&_H_IOCTL)) {
	    require 'sys/ioctl.ph';
	}
	eval 'sub IFIOCTL_ADD_FILTER () { &_IO(ord(\'I\'), 1);}' unless defined(&IFIOCTL_ADD_FILTER);
	eval 'sub IFIOCTL_DEL_FILTER () { &_IO(ord(\'I\'), 2);}' unless defined(&IFIOCTL_DEL_FILTER);
    }
}
1;
