require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_CDLI_ENTUSER)) {
    eval 'sub _H_CDLI_ENTUSER () {1;}' unless defined(&_H_CDLI_ENTUSER);
    require 'sys/ndd.ph';
    eval 'sub ENT_NADR_LENGTH () {(6);}' unless defined(&ENT_NADR_LENGTH);
    eval 'sub ENT_MAX_MTU () {(1514);}' unless defined(&ENT_MAX_MTU);
    eval 'sub ENT_MIN_MTU () {(60);}' unless defined(&ENT_MIN_MTU);
    eval 'sub ENT_RCV_BAD_FRAME () {( &NDD_SPECFLAGS);}' unless defined(&ENT_RCV_BAD_FRAME);
    eval 'sub ENT_DATA_RATE () {(2* &NDD_SPECFLAGS);}' unless defined(&ENT_DATA_RATE);
    eval 'sub ENT_DATA_RATE_10_HALF () {(10);}' unless defined(&ENT_DATA_RATE_10_HALF);
    eval 'sub ENT_DATA_RATE_10_FULL () {(20);}' unless defined(&ENT_DATA_RATE_10_FULL);
    eval 'sub ENT_DATA_RATE_100_HALF () {(100);}' unless defined(&ENT_DATA_RATE_100_HALF);
    eval 'sub ENT_DATA_RATE_100_FULL () {(200);}' unless defined(&ENT_DATA_RATE_100_FULL);
    eval 'sub ENT_DATA_RATE_1000_HALF () {(1000);}' unless defined(&ENT_DATA_RATE_1000_HALF);
    eval 'sub ENT_DATA_RATE_1000_FULL () {(2000);}' unless defined(&ENT_DATA_RATE_1000_FULL);
    eval 'sub NDD_ENT_LARGE_SEND () {(4* &NDD_SPECFLAGS);}' unless defined(&NDD_ENT_LARGE_SEND);
    eval 'sub ENT_3COM () {0x1;}' unless defined(&ENT_3COM);
    eval 'sub ENT_IENT () {0x2;}' unless defined(&ENT_IENT);
    eval 'sub ENT_IEN_ISA () {0x3;}' unless defined(&ENT_IEN_ISA);
    eval 'sub ENT_LCE () {0x4;}' unless defined(&ENT_LCE);
    eval 'sub ENT_KEN_PCI () {0x5;}' unless defined(&ENT_KEN_PCI);
    eval 'sub ENT_LSA () {0x6;}' unless defined(&ENT_LSA);
    eval 'sub ENT_IEN_PCMCIA () {0x7;}' unless defined(&ENT_IEN_PCMCIA);
    eval 'sub AUI_BASET () {0;}' unless defined(&AUI_BASET);
    eval 'sub BASE2_ONLY () {1;}' unless defined(&BASE2_ONLY);
    eval 'sub AUI () {0;}' unless defined(&AUI);
    eval 'sub BASET () {1;}' unless defined(&BASET);
    eval 'sub BASE2 () {2;}' unless defined(&BASE2);
    eval 'sub AUTO () {3;}' unless defined(&AUTO);
    eval 'sub ENT_RCV_CRC_ERR () { &NDD_REASON_CODE + 1;}' unless defined(&ENT_RCV_CRC_ERR);
    eval 'sub ENT_RCV_OVRUN_ERR () { &NDD_REASON_CODE + 2;}' unless defined(&ENT_RCV_OVRUN_ERR);
    eval 'sub ENT_RCV_ALIGN_ERR () { &NDD_REASON_CODE + 3;}' unless defined(&ENT_RCV_ALIGN_ERR);
    eval 'sub ENT_RCV_RSC_ERR () { &NDD_REASON_CODE + 4;}' unless defined(&ENT_RCV_RSC_ERR);
    eval 'sub ENT_RCV_SHORT_ERR () { &NDD_REASON_CODE + 5;}' unless defined(&ENT_RCV_SHORT_ERR);
    eval 'sub ENT_RCV_LONG_ERR () { &NDD_REASON_CODE + 6;}' unless defined(&ENT_RCV_LONG_ERR);
    eval 'sub ENT_RCV_COLL () { &NDD_REASON_CODE + 7;}' unless defined(&ENT_RCV_COLL);
    eval 'sub ENT_NOBUFS () { &NDD_REASON_CODE + 8;}' unless defined(&ENT_NOBUFS);
    eval 'sub ENT_DMA_FAIL () { &NDD_REASON_CODE + 9;}' unless defined(&ENT_DMA_FAIL);
    eval 'sub ENT_PARITY_ERR () { &NDD_REASON_CODE + 10;}' unless defined(&ENT_PARITY_ERR);
    eval 'sub HKWD_EN3COM_XMIT () {0x351;}' unless defined(&HKWD_EN3COM_XMIT);
    eval 'sub HKWD_EN3COM_RECV () {0x352;}' unless defined(&HKWD_EN3COM_RECV);
    eval 'sub HKWD_EN3COM_OTHER () {0x353;}' unless defined(&HKWD_EN3COM_OTHER);
    eval 'sub HKWD_EN3COM_ERR () {0x354;}' unless defined(&HKWD_EN3COM_ERR);
    eval 'sub HKWD_IENT_XMIT () {0x320;}' unless defined(&HKWD_IENT_XMIT);
    eval 'sub HKWD_IENT_RECV () {0x321;}' unless defined(&HKWD_IENT_RECV);
    eval 'sub HKWD_IENT_OTHER () {0x322;}' unless defined(&HKWD_IENT_OTHER);
    eval 'sub HKWD_IENT_ERR () {0x323;}' unless defined(&HKWD_IENT_ERR);
    eval 'sub HKWD_CDLI_LCE_RECV () {0x327;}' unless defined(&HKWD_CDLI_LCE_RECV);
    eval 'sub HKWD_CDLI_LCE_OTHER () {0x328;}' unless defined(&HKWD_CDLI_LCE_OTHER);
    eval 'sub HKWD_CDLI_LCE_XMIT () {0x27d;}' unless defined(&HKWD_CDLI_LCE_XMIT);
    eval 'sub HKWD_CDLI_LCE_ERR () {0x27e;}' unless defined(&HKWD_CDLI_LCE_ERR);
    eval 'sub HKWD_IEN_ISA_XMIT () {0x330;}' unless defined(&HKWD_IEN_ISA_XMIT);
    eval 'sub HKWD_IEN_ISA_RECV () {0x331;}' unless defined(&HKWD_IEN_ISA_RECV);
    eval 'sub HKWD_IEN_ISA_OTHER () {0x332;}' unless defined(&HKWD_IEN_ISA_OTHER);
    eval 'sub HKWD_IEN_ISA_ERR () {0x333;}' unless defined(&HKWD_IEN_ISA_ERR);
    eval 'sub HKWD_KEN_PCI_XMIT () {0x2a4;}' unless defined(&HKWD_KEN_PCI_XMIT);
    eval 'sub HKWD_KEN_PCI_RECV () {0x2a5;}' unless defined(&HKWD_KEN_PCI_RECV);
    eval 'sub HKWD_KEN_PCI_OTHER () {0x2a6;}' unless defined(&HKWD_KEN_PCI_OTHER);
    eval 'sub HKWD_LENT_XMIT () {0x324;}' unless defined(&HKWD_LENT_XMIT);
    eval 'sub HKWD_LENT_RECV () {0x325;}' unless defined(&HKWD_LENT_RECV);
    eval 'sub HKWD_LENT_OTHER () {0x326;}' unless defined(&HKWD_LENT_OTHER);
    eval 'sub HKWD_LENT_ERR () {0x329;}' unless defined(&HKWD_LENT_ERR);
}
1;
