require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_DEVINFO)) {
    eval 'sub _H_DEVINFO () {1;}' unless defined(&_H_DEVINFO);
    unless(defined(&IFNAMSIZ)) {
	eval 'sub IFNAMSIZ () {16;}' unless defined(&IFNAMSIZ);
    }
    unless(defined(&IFF_UP)) {
	eval 'sub IFF_UP () {0x1;}' unless defined(&IFF_UP);
    }
    unless(defined(&IFF_RUNNING)) {
	eval 'sub IFF_RUNNING () {0x40;}' unless defined(&IFF_RUNNING);
    }
    unless(defined(&IFF_PRIMARY)) {
	eval 'sub IFF_PRIMARY () {0x80;}' unless defined(&IFF_PRIMARY);
    }
    unless(defined(&MAXIFS)) {
	eval 'sub MAXIFS () {8;}' unless defined(&MAXIFS);
    }
    require 'sys/types.ph';
    require 'sys/inttypes.ph';
    eval 'sub DD_TMSCSI () {ord(\'T\');}' unless defined(&DD_TMSCSI);
    eval 'sub DD_LP () {ord(\'P\');}' unless defined(&DD_LP);
    eval 'sub DD_TAPE () {ord(\'M\');}' unless defined(&DD_TAPE);
    eval 'sub DD_SCTAPE () {ord(\'m\');}' unless defined(&DD_SCTAPE);
    eval 'sub DD_TTY () {ord(\'T\');}' unless defined(&DD_TTY);
    eval 'sub DD_DISK () {ord(\'R\');}' unless defined(&DD_DISK);
    eval 'sub DD_CDROM () {ord(\'C\');}' unless defined(&DD_CDROM);
    eval 'sub DD_DLC () {ord(\'D\');}' unless defined(&DD_DLC);
    eval 'sub DD_SCDISK () {ord(\'r\');}' unless defined(&DD_SCDISK);
    eval 'sub DD_RTC () {ord(\'c\');}' unless defined(&DD_RTC);
    eval 'sub DD_PSEU () {ord(\'Z\');}' unless defined(&DD_PSEU);
    eval 'sub DD_NET () {ord(\'N\');}' unless defined(&DD_NET);
    eval 'sub DD_EN () {ord(\'E\');}' unless defined(&DD_EN);
    eval 'sub DD_EM78 () {ord(\'e\');}' unless defined(&DD_EM78);
    eval 'sub DD_TR () {ord(\'t\');}' unless defined(&DD_TR);
    eval 'sub DD_BIO () {ord(\'B\');}' unless defined(&DD_BIO);
    eval 'sub DD_X25 () {ord(\'x\');}' unless defined(&DD_X25);
    eval 'sub DD_IEEE_3 () {ord(\'3\');}' unless defined(&DD_IEEE_3);
    eval 'sub DD_SL () {ord(\'S\');}' unless defined(&DD_SL);
    eval 'sub DD_LO () {ord(\'L\');}' unless defined(&DD_LO);
    eval 'sub DD_DUMP () {ord(\'d\');}' unless defined(&DD_DUMP);
    eval 'sub DD_SCCD () {ord(\'C\');}' unless defined(&DD_SCCD);
    eval 'sub DD_CIO () {ord(\'n\');}' unless defined(&DD_CIO);
    eval 'sub DD_BUS () {ord(\'b\');}' unless defined(&DD_BUS);
    eval 'sub DD_HFT () {ord(\'H\');}' unless defined(&DD_HFT);
    eval 'sub DD_INPUT () {ord(\'I\');}' unless defined(&DD_INPUT);
    eval 'sub DD_CON () {ord(\'Q\');}' unless defined(&DD_CON);
    eval 'sub DD_NET_DH () {ord(\'h\');}' unless defined(&DD_NET_DH);
    eval 'sub DD_DISK_C () {ord(\'s\');}' unless defined(&DD_DISK_C);
    eval 'sub DD_SOL () {ord(\'o\');}' unless defined(&DD_SOL);
    eval 'sub DD_CAT () {ord(\'K\');}' unless defined(&DD_CAT);
    eval 'sub DD_FDDI () {ord(\'F\');}' unless defined(&DD_FDDI);
    eval 'sub DD_SCRWOPT () {ord(\'w\');}' unless defined(&DD_SCRWOPT);
    eval 'sub DD_SES () {ord(\'a\');}' unless defined(&DD_SES);
    eval 'sub DD_AUDIT () {ord(\'A\');}' unless defined(&DD_AUDIT);
    eval 'sub DS_DLCETHER () {ord(\'e\');}' unless defined(&DS_DLCETHER);
    eval 'sub DS_DLC8023 () {ord(\'i\');}' unless defined(&DS_DLC8023);
    eval 'sub DS_DLCTOKEN () {ord(\'t\');}' unless defined(&DS_DLCTOKEN);
    eval 'sub DS_DLCSDLC () {ord(\'d\');}' unless defined(&DS_DLCSDLC);
    eval 'sub DS_DLCQLLC () {ord(\'q\');}' unless defined(&DS_DLCQLLC);
    eval 'sub DS_DLCFDDI () {ord(\'f\');}' unless defined(&DS_DLCFDDI);
    eval 'sub DS_LV () {ord(\'l\');}' unless defined(&DS_LV);
    eval 'sub DS_PV () {ord(\'p\');}' unless defined(&DS_PV);
    eval 'sub DS_SCSI () {ord(\'S\');}' unless defined(&DS_SCSI);
    eval 'sub DS_IDE () {ord(\'I\');}' unless defined(&DS_IDE);
    eval 'sub DS_PP () {ord(\'p\');}' unless defined(&DS_PP);
    eval 'sub DS_SP () {ord(\'s\');}' unless defined(&DS_SP);
    eval 'sub DS_TM () {ord(\'T\');}' unless defined(&DS_TM);
    eval 'sub DS_SDA () {ord(\'h\');}' unless defined(&DS_SDA);
    eval 'sub DS_SDC () {ord(\'c\');}' unless defined(&DS_SDC);
    eval 'sub DS_NFS () {ord(\'N\');}' unless defined(&DS_NFS);
    eval 'sub DS_CAT () {ord(\'k\');}' unless defined(&DS_CAT);
    eval 'sub DS_FCP () {ord(\'F\');}' unless defined(&DS_FCP);
    eval 'sub DS_VM () {ord(\'V\');}' unless defined(&DS_VM);
    eval 'sub DS_QIO () {ord(\'q\');}' unless defined(&DS_QIO);
    unless(defined(&DS_VSD)) {
	eval 'sub DS_VSD () {ord(\'v\');}' unless defined(&DS_VSD);
    }
    eval 'sub DT_STREAM () {1;}' unless defined(&DT_STREAM);
    eval 'sub DT_STRTSTP () {2;}' unless defined(&DT_STRTSTP);
    eval 'sub DF_FIXED () {01;}' unless defined(&DF_FIXED);
    eval 'sub DF_RAND () {02;}' unless defined(&DF_RAND);
    eval 'sub DF_FAST () {04;}' unless defined(&DF_FAST);
    eval 'sub DF_CONC () {0x8;}' unless defined(&DF_CONC);
    eval 'sub DF_LGDSK () {0x10;}' unless defined(&DF_LGDSK);
}
1;
