require '_h2ph_pre.ph';

no warnings 'redefine';

require 'sys/intr.ph';
require 'sys/dma.ph';
require 'sys/timer.ph';
require 'sys/watchdog.ph';
require 'sys/lock_def.ph';
unless(defined(&DGX_OK)) {
    sub DGX_OK () {	0;}
}
unless(defined(&DGX_INVALID_HANDLE)) {
    sub DGX_INVALID_HANDLE () {	0x80000000;}
}
unless(defined(&DGX_DEVBUSY_FAIL)) {
    sub DGX_DEVBUSY_FAIL () {	0x80000001;}
}
unless(defined(&DGX_DINIT_FAIL)) {
    sub DGX_DINIT_FAIL () {	0x80000002;}
}
unless(defined(&DGX_DCLEAR_FAIL)) {
    sub DGX_DCLEAR_FAIL () {	0x80000003;}
}
unless(defined(&DGX_IINIT_FAIL)) {
    sub DGX_IINIT_FAIL () {	0x80000004;}
}
unless(defined(&DGX_ICLEAR_FAIL)) {
    sub DGX_ICLEAR_FAIL () {	0x80000005;}
}
unless(defined(&DGX_COPYDDS_FAIL)) {
    sub DGX_COPYDDS_FAIL () {	0x80000006;}
}
unless(defined(&DGX_COPY_FAIL)) {
    sub DGX_COPY_FAIL () {	0x80000007;}
}
unless(defined(&DGX_KMOD_FAIL)) {
    sub DGX_KMOD_FAIL () {	0x80000008;}
}
unless(defined(&DGX_PIN_FAIL)) {
    sub DGX_PIN_FAIL () {	0x80000009;}
}
unless(defined(&DGX_PINU_FAIL)) {
    sub DGX_PINU_FAIL () {	0x8000000a;}
}
unless(defined(&DGX_PINCODE_FAIL)) {
    sub DGX_PINCODE_FAIL () {	0x8000000b;}
}
unless(defined(&DGX_UNPIN_FAIL)) {
    sub DGX_UNPIN_FAIL () {	0x8000000c;}
}
unless(defined(&DGX_UNPINU_FAIL)) {
    sub DGX_UNPINU_FAIL () {	0x8000000d;}
}
unless(defined(&DGX_UNPINCODE_FAIL)) {
    sub DGX_UNPINCODE_FAIL () {	0x8000000e;}
}
unless(defined(&DGX_XMALLOC_FAIL)) {
    sub DGX_XMALLOC_FAIL () {	0x8000000f;}
}
unless(defined(&DGX_XMFREE_FAIL)) {
    sub DGX_XMFREE_FAIL () {	0x80000010;}
}
unless(defined(&DGX_XMATTACH_FAIL)) {
    sub DGX_XMATTACH_FAIL () {	0x80000011;}
}
unless(defined(&DGX_XMDETACH_FAIL)) {
    sub DGX_XMDETACH_FAIL () {	0x80000012;}
}
unless(defined(&DGX_BOUND_FAIL)) {
    sub DGX_BOUND_FAIL () {	0x80000013;}
}
unless(defined(&DGX_DCOMPLETE_FAIL)) {
    sub DGX_DCOMPLETE_FAIL () {	0x80000014;}
}
unless(defined(&DGX_OUTSTANDINGDMA_FAIL)) {
    sub DGX_OUTSTANDINGDMA_FAIL () {	0x80000015;}
}
unless(defined(&DGX_NO_INTRPT_FAIL)) {
    sub DGX_NO_INTRPT_FAIL () {	0x80000016;}
}
unless(defined(&DGX_BADVAL_FAIL)) {
    sub DGX_BADVAL_FAIL () {	0x80000018;}
}
unless(defined(&DGX_UKCOPY_FAIL)) {
    sub DGX_UKCOPY_FAIL () {	0x80000019;}
}
unless(defined(&DGX_ENABLE_FAIL)) {
    sub DGX_ENABLE_FAIL () {	0x8000001a;}
}
unless(defined(&DGX_DISABLE_FAIL)) {
    sub DGX_DISABLE_FAIL () {	0x8000001b;}
}
unless(defined(&DGX_UMAP_SLAVE_FAIL)) {
    sub DGX_UMAP_SLAVE_FAIL () {	0x8000001c;}
}
unless(defined(&DGX_MAP_SLAVE_FAIL)) {
    sub DGX_MAP_SLAVE_FAIL () {	0x8000001d;}
}
unless(defined(&DGX_RMFREE_FAIL)) {
    sub DGX_RMFREE_FAIL () {	0x8000001e;}
}
unless(defined(&DGX_RMALLOC_FAIL)) {
    sub DGX_RMALLOC_FAIL () {	0x8000001f;}
}
unless(defined(&DGX_EVENT_SIG)) {
    sub DGX_EVENT_SIG () {	0x80000020;}
}
unless(defined(&DGX_DEVICE_DUP)) {
    sub DGX_DEVICE_DUP () {	0x80000021;}
}
unless(defined(&DGX_FAIL)) {
    sub DGX_FAIL () {	0xffffffff;}
}
unless(defined(&DGX_LISTFAIL)) {
    sub DGX_LISTFAIL () {	0xdeadcafe;}
}
unless(defined(&DGX_INTERNAL_FAIL)) {
    sub DGX_INTERNAL_FAIL () {	0xdeadbaba;}
}
unless(defined(&IOCHAR)) {
    sub IOCHAR () {	1;}
}
unless(defined(&IOSHORT)) {
    sub IOSHORT () {	2;}
}
unless(defined(&IOLONG)) {
    sub IOLONG () {	4;}
}
unless(defined(&PROCLEV)) {
    sub PROCLEV () {	1;}
}
unless(defined(&INTRKMEM)) {
    sub INTRKMEM () {	2;}
}
unless(defined(&INTRPMEM)) {
    sub INTRPMEM () {	3;}
}
unless(defined(&DGX_SING_LOC_ACC)) {
    sub DGX_SING_LOC_ACC () {	123;}
}
unless(defined(&DGX_SING_LOC_HW)) {
    sub DGX_SING_LOC_HW () {	124;}
}
unless(defined(&DGX_SING_LOC_BUF)) {
    sub DGX_SING_LOC_BUF () {	125;}
}
unless(defined(&DGX_MULT_LOC_ACC)) {
    sub DGX_MULT_LOC_ACC () {	126;}
}
unless(defined(&wait4intr)) {
    sub wait4intr {
	my($a,$b) = @_;
	eval q( &watch4intr(($a),($b),0););
    }
}
1;
