require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_ECPIO)) {
    eval 'sub _H_ECPIO () {1;}' unless defined(&_H_ECPIO);
    require 'sys/types.ph';
    require 'sys/trchkid.ph';
    require 'sys/limits.ph';
    require 'sys/lpio.ph';
    eval 'sub LPAD_ECP () {(0x401);}' unless defined(&LPAD_ECP);
    eval 'sub ECP_DEVSTR_LEN () {( &USHRT_MAX - 2);}' unless defined(&ECP_DEVSTR_LEN);
    eval 'sub ECP_DFIFO_DEPTH () {(16);}' unless defined(&ECP_DFIFO_DEPTH);
    if(defined(&__cplusplus)) {
    }
    eval 'sub ECP_MFGL () {"MANUFACTURER";}' unless defined(&ECP_MFGL);
    eval 'sub ECP_MFG () {"MFG";}' unless defined(&ECP_MFG);
    eval 'sub ECP_MDLL () {"MODEL";}' unless defined(&ECP_MDLL);
    eval 'sub ECP_MDL () {"MDL";}' unless defined(&ECP_MDL);
    eval 'sub ECP_DEVID_LEN () {(24);}' unless defined(&ECP_DEVID_LEN);
    eval("sub CapNone () { 0; }") unless defined(&CapNone);
    eval("sub CapSPP () { 0x01; }") unless defined(&CapSPP);
    eval("sub CapNibble () { 0x02; }") unless defined(&CapNibble);
    eval("sub CapByte () { 0x04; }") unless defined(&CapByte);
    eval("sub CapEPP () { 0x08; }") unless defined(&CapEPP);
    eval("sub CapECP () { 0x10; }") unless defined(&CapECP);
    eval("sub CapMax () { 0x80; }") unless defined(&CapMax);
    eval("sub ECP () { (LPR+40); }") unless defined(&ECP);
    eval("sub ECPDEVSTR () { 1; }") unless defined(&ECPDEVSTR);
    eval("sub ECPTERMINATE () { 2; }") unless defined(&ECPTERMINATE);
    eval("sub ECPMODECAP () { 3; }") unless defined(&ECPMODECAP);
    eval("sub ECPMODE () { 4; }") unless defined(&ECPMODE);
    eval("sub ECPWFLUSH () { 5; }") unless defined(&ECPWFLUSH);
    eval("sub ECPWATOMIC () { 6; }") unless defined(&ECPWATOMIC);
    eval("sub ECPS1284_D1 () { 7; }") unless defined(&ECPS1284_D1);
    eval("sub ECPSLU () { 8; }") unless defined(&ECPSLU);
    eval("sub ECPCTLEND () { 9; }") unless defined(&ECPCTLEND);
    eval("sub ECPGET () { LPRGET; }") unless defined(&ECPGET);
    eval("sub ECPSET () { LPRSET; }") unless defined(&ECPSET);
    eval("sub ECPGETA () { LPRGETA; }") unless defined(&ECPGETA);
    eval("sub ECPSETA () { LPRSETA; }") unless defined(&ECPSETA);
    eval("sub ECPGTOV () { LPRGTOV; }") unless defined(&ECPGTOV);
    eval("sub ECPSTOV () { LPRSTOV; }") unless defined(&ECPSTOV);
    eval("sub ECPQUERY () { LPQUERY; }") unless defined(&ECPQUERY);
    eval("sub ECPDIAG () { LPDIAG; }") unless defined(&ECPDIAG);
    eval("sub ECPMODG () { LPRMODG; }") unless defined(&ECPMODG);
    eval("sub ECPMODS () { LPRMODS; }") unless defined(&ECPMODS);
    eval("sub ECP_R_TFIFO () { 0x10; }") unless defined(&ECP_R_TFIFO);
    eval("sub ECP_W_TFIFO () { 1; }") unless defined(&ECP_W_TFIFO);
    eval("sub ECP_R_ECR () { 2; }") unless defined(&ECP_R_ECR);
    eval("sub ECP_W_ECR () { 3; }") unless defined(&ECP_W_ECR);
    eval("sub ECP_WR_DMA () { 4; }") unless defined(&ECP_WR_DMA);
    eval 'sub ECP_SUCC () {(0);}' unless defined(&ECP_SUCC);
    eval 'sub ECP_DIAG_ERR () {(-1);}' unless defined(&ECP_DIAG_ERR);
    eval("sub IF_Standard () { 0; }") unless defined(&IF_Standard);
    eval("sub IF_Converged () { 1; }") unless defined(&IF_Converged);
    eval("sub IF_IEEE1284 () { 2; }") unless defined(&IF_IEEE1284);
    eval("sub IF_None () { 0xff; }") unless defined(&IF_None);
    if(defined(&__cplusplus)) {
    }
}
1;
