require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_ETHCHAN)) {
    eval 'sub _H_ETHCHAN () {1;}' unless defined(&_H_ETHCHAN);
    require 'sys/types.ph';
    require 'sys/err_rec.ph';
    require 'sys/cdli_entuser.ph';
    require 'sys/cdli_entuser.gxent.ph';
    require 'sys/cdli_entuser.ethchan.ph';
    require 'sys/ethernet_mibs.ph';
    require 'sys/watchdog.ph';
    require 'netinet/ip.ph';
    require 'netinet/ip6.ph';
    require 'netinet/ip_icmp.ph';
    require 'netinet/ip6_icmp.ph';
    eval 'sub MAXIFPERCHAN () {4;}' unless defined(&MAXIFPERCHAN);
    eval 'sub ETHCHAN_TRACE_SIZE () {(1000*4);}' unless defined(&ETHCHAN_TRACE_SIZE);
    eval 'sub ETHCHAN_OPLEVEL () {( &PL_IMP);}' unless defined(&ETHCHAN_OPLEVEL);
    eval 'sub ECH_ROUND_ROBIN_MODE () {(1);}' unless defined(&ECH_ROUND_ROBIN_MODE);
    eval 'sub ECH_NETIF_BACKUP_MODE () {(2);}' unless defined(&ECH_NETIF_BACKUP_MODE);
    eval 'sub ETHCHAN_XMIT () {(( &HKWD_ETHCHAN_XMIT << 20) |  &HKTY_GT | 4);}' unless defined(&ETHCHAN_XMIT);
    eval 'sub ETHCHAN_OTHER () {(( &HKWD_ETHCHAN_OTHER << 20) |  &HKTY_GT | 4);}' unless defined(&ETHCHAN_OTHER);
    eval 'sub ETHCHAN_ETRACE {
        my($a1, $a2, $a3, $a4) = @_;
	    eval q({  &ethchan_trace($a1, $a2, $a3, $a4);  &TRCHKGT( &ETHCHAN_OTHER, *, , , ($a4), 0); });
    }' unless defined(&ETHCHAN_ETRACE);
    if(defined(&ETHCHAN_DEBUG)) {
	eval 'sub ETHCHAN_TRACE {
	    my($a1,$a2,$a3,$a4) = @_;
    	    eval q({  &ethchan_trace($a1,$a2,$a3,$a4);  &TRCHKGT( &ETHCHAN_OTHER, *, , , ($a4), 0); });
	}' unless defined(&ETHCHAN_TRACE);
    } else {
	eval 'sub ETHCHAN_TRACE {
	    my($a1,$a2,$a3,$a4) = @_;
    	    eval q({  &TRCHKGT( &ETHCHAN_OTHER, *, , , ($a4), 0); });
	}' unless defined(&ETHCHAN_TRACE);
    }
    if(defined(&ETHCHAN_DEBUG)) {
	eval 'sub ETHCHAN_TTRACE {
	    my($a1,$a2,$a3,$a4) = @_;
    	    eval q({  &ethchan_trace($a1,$a2,$a3,$a4);  &TRCHKGT( &ETHCHAN_XMIT, *, , , ($a4), 0); });
	}' unless defined(&ETHCHAN_TTRACE);
    } else {
	eval 'sub ETHCHAN_TTRACE {
	    my($a1,$a2,$a3,$a4) = @_;
    	    eval q({  &TRCHKGT( &ETHCHAN_XMIT, *, , , ($a4), 0); });
	}' unless defined(&ETHCHAN_TTRACE);
    }
    eval 'sub NDDSTATS () {( ($p_ccs->{ndd}->{ndd_genstats}));}' unless defined(&NDDSTATS);
    eval 'sub ENTSTATS () {( ($p_ccs->{ls}->{ent_gen_stats}));}' unless defined(&ENTSTATS);
    eval 'sub MIBS () {( ($p_ccs->{mibs}));}' unless defined(&MIBS);
    eval 'sub MIBSGEN () {( ($p_ccs->{mibs}->{Generic_mib}));}' unless defined(&MIBSGEN);
    eval 'sub MIBSETHSTATS () {( ($p_ccs->{mibs}->{Ethernet_mib}->{Dot3StatsEntry}));}' unless defined(&MIBSETHSTATS);
    eval 'sub MIBSETHCOLL () {( ($p_ccs->{mibs}->{Ethernet_mib}->{Dot3CollEntry}));}' unless defined(&MIBSETHCOLL);
}
1;
