require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_FLOCK)) {
    eval 'sub _H_FLOCK () {1;}' unless defined(&_H_FLOCK);
    require 'standards.ph';
    require 'sys/types.ph';
    if(defined(&_POSIX_SOURCE)) {
	unless(defined(&_KERNEL)) {
	    unless(defined(&_LARGE_FILES)) {
		unless(defined(&__64BIT__)) {
		}
	    }
	    if(defined(&_NONSTD_TYPES)) {
	    } else {
	    }
	    if(defined( &_LARGE_FILES) || defined( &__64BIT__)) {
	    }
	}
	eval 'sub F_RDLCK () {01;}' unless defined(&F_RDLCK);
	eval 'sub F_WRLCK () {02;}' unless defined(&F_WRLCK);
	eval 'sub F_UNLCK () {03;}' unless defined(&F_UNLCK);
	if(defined(&_LARGE_FILE_API)) {
	}
    }
    if(defined(&_ALL_SOURCE)) {
	if(defined(&_KERNEL)) {
	    eval 'sub INOFLCK () {1;}' unless defined(&INOFLCK);
	    eval 'sub SETFLCK () {2;}' unless defined(&SETFLCK);
	    eval 'sub SLPFLCK () {4;}' unless defined(&SLPFLCK);
	    eval 'sub LCK_UNBLOCK () {0;}' unless defined(&LCK_UNBLOCK);
	    eval 'sub LCK_BLOCKER () {1;}' unless defined(&LCK_BLOCKER);
	    eval 'sub LCK_BLOCKED () {2;}' unless defined(&LCK_BLOCKED);
	    eval 'sub LCK_WASBLOCK () {4;}' unless defined(&LCK_WASBLOCK);
	    eval 'sub l_end () { &l_len;}' unless defined(&l_end);
	    eval 'sub MAXEND () { &LONGLONG_MAX;}' unless defined(&MAXEND);
	    eval 'sub fl_prev () { ($_flp->{fl_prev});}' unless defined(&fl_prev);
	    eval 'sub fl_qmnext () { ($_flp->{fl_qmnext});}' unless defined(&fl_qmnext);
	    eval 'sub RMTLOCK () {1;}' unless defined(&RMTLOCK);
	    eval 'sub ENF_LOCK {
	        my($mode) = @_;
    		eval q(((($mode) & ( &ISGID |  &IEXEC | ( &IEXEC >> 3) | ( &IEXEC >> 6))) ==  &ISGID));
	    }' unless defined(&ENF_LOCK);
	    unless(defined(&__64BIT_KERNEL)) {
	    }
	}
    }
}
1;
