require '_h2ph_pre.ph';

no warnings 'redefine';

if(!defined( &_H_HIGH_AVAIL)) {
    eval 'sub _H_HIGH_AVAIL () {1;}' unless defined(&_H_HIGH_AVAIL);
    require 'sys/processor.ph';
    require 'sys/err_rec.ph';
    eval 'sub HA_FREE () {0x46524545;}' unless defined(&HA_FREE);
    eval 'sub HA_CPU_FAIL () {0x43505546;}' unless defined(&HA_CPU_FAIL);
    eval 'sub HA_MEM_FAIL () {0x4d454d46;}' unless defined(&HA_MEM_FAIL);
    eval 'sub HA_INITIAL () {0;}' unless defined(&HA_INITIAL);
    eval 'sub HA_NONE () {-1;}' unless defined(&HA_NONE);
    if(defined( &_KERNSYS)) {
	eval 'sub HA_STARTED () {1;}' unless defined(&HA_STARTED);
	eval 'sub HA_UNBIND () {0x10;}' unless defined(&HA_UNBIND);
	eval 'sub HA_UNBIND_W () {0x18;}' unless defined(&HA_UNBIND_W);
	eval 'sub HA_UNBIND_DONE () {0x1e;}' unless defined(&HA_UNBIND_DONE);
	eval 'sub HA_HAEH () {0x20;}' unless defined(&HA_HAEH);
	eval 'sub HA_HAEH_DONE () {0x2e;}' unless defined(&HA_HAEH_DONE);
	eval 'sub HA_PHASE_I1 () {0x30;}' unless defined(&HA_PHASE_I1);
	eval 'sub HA_PHASE_I1_D () {0x3e;}' unless defined(&HA_PHASE_I1_D);
	eval 'sub HA_MK_STOP () {0x40;}' unless defined(&HA_MK_STOP);
	eval 'sub HA_MK_STOP_W () {0x48;}' unless defined(&HA_MK_STOP_W);
	eval 'sub HA_MK_STOP_D () {0x4e;}' unless defined(&HA_MK_STOP_D);
	eval 'sub HA_STOPP () {0x50;}' unless defined(&HA_STOPP);
	eval 'sub HA_STOPP_RQ () {0x55;}' unless defined(&HA_STOPP_RQ);
	eval 'sub HA_STOPP_DONE () {0x5e;}' unless defined(&HA_STOPP_DONE);
	eval 'sub HA_PHASE_I2 () {0x80;}' unless defined(&HA_PHASE_I2);
	eval 'sub HA_PHASE_I2_D () {0x8e;}' unless defined(&HA_PHASE_I2_D);
	eval 'sub HA_SWAP () {0x90;}' unless defined(&HA_SWAP);
	eval 'sub HA_SWAP_DONE () {0x9e;}' unless defined(&HA_SWAP_DONE);
	eval 'sub HA_TRB () {0xb0;}' unless defined(&HA_TRB);
	eval 'sub HA_TRB_DONE () {0xbe;}' unless defined(&HA_TRB_DONE);
	eval 'sub HA_WD () {0xc0;}' unless defined(&HA_WD);
	eval 'sub HA_WD_DONE () {0xce;}' unless defined(&HA_WD_DONE);
	eval 'sub HA_PRE_ABORTED () {0xff;}' unless defined(&HA_PRE_ABORTED);
    }
    eval 'sub HA_SUCCESS () {0x100;}' unless defined(&HA_SUCCESS);
    eval 'sub HA_ABORTED () {0x200;}' unless defined(&HA_ABORTED);
    if(!defined( &__64BIT__)) {
    }
    eval 'sub HA_RPDP () {1;}' unless defined(&HA_RPDP);
    eval 'sub HA_RPDM () {2;}' unless defined(&HA_RPDM);
    eval 'sub HA_DONE () {0;}' unless defined(&HA_DONE);
    eval 'sub HA_NO_PAL () {1;}' unless defined(&HA_NO_PAL);
    eval 'sub HA_TH_MIGR () {2;}' unless defined(&HA_TH_MIGR);
    eval 'sub HA_HAEH_MIGR () {3;}' unless defined(&HA_HAEH_MIGR);
    eval 'sub HA_FEW_CPU () {4;}' unless defined(&HA_FEW_CPU);
    eval 'sub HA_IT_ERR () {5;}' unless defined(&HA_IT_ERR);
    eval 'sub HA_SYNC_ERR () {6;}' unless defined(&HA_SYNC_ERR);
    eval 'sub HA_OTHER_ERR () {100;}' unless defined(&HA_OTHER_ERR);
    eval 'sub HA_CPUGUARD_OFF () {200;}' unless defined(&HA_CPUGUARD_OFF);
    eval 'sub HA_ACCEPTED () {0;}' unless defined(&HA_ACCEPTED);
    eval 'sub HA_REFUSED () {-1;}' unless defined(&HA_REFUSED);
    if(defined( &_KERNSYS)) {
	eval 'sub NOBODY () {-1;}' unless defined(&NOBODY);
	eval 'sub NO_THREAD () {( &pid_t) 0;}' unless defined(&NO_THREAD);
	eval 'sub SIGNALED () {( &pid_t) -1;}' unless defined(&SIGNALED);
	eval 'sub OTHER_ERR () {( &pid_t) -3;}' unless defined(&OTHER_ERR);
    }
}
1;
