require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_INTR)) {
    eval 'sub _H_INTR () {1;}' unless defined(&_H_INTR);
    unless(defined(&_H_TYPES)) {
	require 'sys/types.ph';
    }
    unless(defined(&_H_M_INTR)) {
	require 'sys/m_intr.ph';
    }
    eval 'sub INTMAX () {0;}' unless defined(&INTMAX);
    eval 'sub INTEPOW () { &INTMAX;}' unless defined(&INTEPOW);
    eval 'sub INTCLASS0 () {1;}' unless defined(&INTCLASS0);
    eval 'sub INTCLIST () { &INTCLASS0;}' unless defined(&INTCLIST);
    eval 'sub INTCLASS1 () {2;}' unless defined(&INTCLASS1);
    eval 'sub INTCLASS2 () {3;}' unless defined(&INTCLASS2);
    eval 'sub INTCLASS3 () {4;}' unless defined(&INTCLASS3);
    eval 'sub INTTIMER () {5;}' unless defined(&INTTIMER);
    eval 'sub INTOFFL0 () {6;}' unless defined(&INTOFFL0);
    eval 'sub INTOFFL1 () {7;}' unless defined(&INTOFFL1);
    eval 'sub INTOFFL2 () {8;}' unless defined(&INTOFFL2);
    eval 'sub INTOFFL3 () {9;}' unless defined(&INTOFFL3);
    eval 'sub INTOFFLVL () { &INTIODONE;}' unless defined(&INTOFFLVL);
    eval 'sub INTIODONE () {10;}' unless defined(&INTIODONE);
    eval 'sub INTPAGER () { &INTIODONE;}' unless defined(&INTPAGER);
    eval 'sub INTBASE () {11;}' unless defined(&INTBASE);
    eval 'sub NUM_INTR_PRIORITY () {( &INTBASE+1);}' unless defined(&NUM_INTR_PRIORITY);
    eval 'sub BUS_NONE () {0;}' unless defined(&BUS_NONE);
    eval 'sub BUS_MICRO_CHANNEL () {1;}' unless defined(&BUS_MICRO_CHANNEL);
    eval 'sub BUS_PLANAR () {2;}' unless defined(&BUS_PLANAR);
    eval 'sub BUS_60X () {3;}' unless defined(&BUS_60X);
    eval 'sub BUS_BID () {4;}' unless defined(&BUS_BID);
    eval 'sub BUS_MAXTYPE () { &BUS_BID;}' unless defined(&BUS_MAXTYPE);
    eval 'sub INTR_NOT_SHARED () {0x1;}' unless defined(&INTR_NOT_SHARED);
    eval 'sub EPOW_SUSPEND () {0x2;}' unless defined(&EPOW_SUSPEND);
    eval 'sub EPOW_RESUME () {0x4;}' unless defined(&EPOW_RESUME);
    eval 'sub EPOW_BATTERY () {0x8;}' unless defined(&EPOW_BATTERY);
    eval 'sub INTR_MPSAFE () {0x10;}' unless defined(&INTR_MPSAFE);
    eval 'sub INTR_EDGE () {0x20;}' unless defined(&INTR_EDGE);
    eval 'sub INTR_LEVEL () {0x40;}' unless defined(&INTR_LEVEL);
    eval 'sub INTR_RES1 () {0x80;}' unless defined(&INTR_RES1);
    eval 'sub I_SCHED () {0x8000;}' unless defined(&I_SCHED);
    eval 'sub INTR_POLARITY () {0x;}' unless defined(&INTR_POLARITY);
    if(defined(&_KERNSYS)) {
	eval 'sub INTR_FLAG_MSK () {( &INTR_NOT_SHARED |  &INTR_MPSAFE |  &INTR_EDGE |  &INTR_LEVEL |  &INTR_RES1);}' unless defined(&INTR_FLAG_MSK);
    }
    eval 'sub INIT_EPOW {
        my( $ptr, $routine, $dev_bid ) = @_;
	    eval q({ ($ptr)-> &next =  &NULL; ($ptr)-> &handler = ($routine); ($ptr)-> &bus_type =  &BUS_NONE; ($ptr)-> &flags = 0; ($ptr)-> &priority =  &INTEPOW; ($ptr)-> &level = 0; ($ptr)-> &bid = ($dev_bid); });
    }' unless defined(&INIT_EPOW);
    eval 'sub INIT_OFFL0 {
        my( $ptr, $routine, $dev_bid ) = @_;
	    eval q({ ($ptr)-> &next =  &NULL; ($ptr)-> &handler = ($routine); ($ptr)-> &bus_type =  &BUS_NONE; ($ptr)-> &flags = 0; ($ptr)-> &level =  &INT_OFFLVL; ($ptr)-> &priority =  &INTOFFL0; ($ptr)-> &bid = ($dev_bid); });
    }' unless defined(&INIT_OFFL0);
    eval 'sub INIT_OFFL1 {
        my( $ptr, $routine, $dev_bid ) = @_;
	    eval q({ ($ptr)-> &next =  &NULL; ($ptr)-> &handler = ($routine); ($ptr)-> &bus_type =  &BUS_NONE; ($ptr)-> &flags = 0; ($ptr)-> &level =  &INT_OFFLVL; ($ptr)-> &priority =  &INTOFFL1; ($ptr)-> &bid = ($dev_bid); });
    }' unless defined(&INIT_OFFL1);
    eval 'sub INIT_OFFL2 {
        my( $ptr, $routine, $dev_bid ) = @_;
	    eval q({ ($ptr)-> &next =  &NULL; ($ptr)-> &handler = ($routine); ($ptr)-> &bus_type =  &BUS_NONE; ($ptr)-> &flags = 0; ($ptr)-> &level =  &INT_OFFLVL; ($ptr)-> &priority =  &INTOFFL2; ($ptr)-> &bid = ($dev_bid); });
    }' unless defined(&INIT_OFFL2);
    eval 'sub INIT_OFFL3 {
        my( $ptr, $routine, $dev_bid ) = @_;
	    eval q({ ($ptr)-> &next =  &NULL; ($ptr)-> &handler = ($routine); ($ptr)-> &bus_type =  &BUS_NONE; ($ptr)-> &flags = 0; ($ptr)-> &level =  &INT_OFFLVL; ($ptr)-> &priority =  &INTOFFL3; ($ptr)-> &bid = ($dev_bid); });
    }' unless defined(&INIT_OFFL3);
    eval 'sub INTR_SUCC () {0;}' unless defined(&INTR_SUCC);
    eval 'sub INTR_FAIL () {-1;}' unless defined(&INTR_FAIL);
    eval 'sub NO_EPOW_HANDLER () {-1;}' unless defined(&NO_EPOW_HANDLER);
    eval 'sub INTR_UNFUNNEL () {0;}' unless defined(&INTR_UNFUNNEL);
    eval 'sub INTR_FUNNEL () {1;}' unless defined(&INTR_FUNNEL);
    eval 'sub INTR_PRI_CHG () {2;}' unless defined(&INTR_PRI_CHG);
    unless(defined(&_KERNSYS)) {
	eval 'sub i_reset {
	    my( $x ) = @_;
    	    eval q();
	}' unless defined(&i_reset);
    }
    unless(defined(&_NO_PROTO)) {
	if(defined(&_KERNSYS)) {
	}
    } else {
	if(defined(&_KERNSYS)) {
	}
	if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
	}
    }
    if(defined( &__64BIT_KERNEL)  && defined( &_KERNSYS)) {
	eval 'sub disable_ints () {
	    eval q( &i_disable( &INTMAX));
	}' unless defined(&disable_ints);
	eval 'sub enable_ints {
	    my($_p) = @_;
    	    eval q( &i_enable($_p));
	}' unless defined(&enable_ints);
    }
}
1;
