require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_IO3270)) {
    eval 'sub _H_IO3270 () {1;}' unless defined(&_H_IO3270);
    eval 'sub DEVICE_BASE_NAME () {"/dev/3270c";}' unless defined(&DEVICE_BASE_NAME);
    eval 'sub EMMISC () {(ord(\'j\')<<8);}' unless defined(&EMMISC);
    eval 'sub EMWAIT () {( &EMMISC | 1);}' unless defined(&EMWAIT);
    eval 'sub EMNWAIT () {( &EMMISC | 2);}' unless defined(&EMNWAIT);
    eval 'sub EMXPOR () {( &EMMISC | 3);}' unless defined(&EMXPOR);
    eval 'sub EMIMASK () {( &EMMISC | 4);}' unless defined(&EMIMASK);
    eval 'sub EMCPOS () {( &EMMISC | 5);}' unless defined(&EMCPOS);
    eval 'sub EMVISND () {( &EMMISC | 6);}' unless defined(&EMVISND);
    eval 'sub EMSEEK () {( &EMMISC | 7);}' unless defined(&EMSEEK);
    eval 'sub EMKEY () {(ord(\'k\')<<8);}' unless defined(&EMKEY);
    eval 'sub C327M () {(ord(\'m\')<<8);}' unless defined(&C327M);
    eval 'sub C327DIAG_TCA_SIZE () {( &C327M | 1);}' unless defined(&C327DIAG_TCA_SIZE);
    eval 'sub C327DIAG_TCA_READ () {( &C327M | 2);}' unless defined(&C327DIAG_TCA_READ);
    eval 'sub C327DIAG_TCA_TEST () {( &C327M | 3);}' unless defined(&C327DIAG_TCA_TEST);
    eval 'sub C327DIAG_REG_READ () {( &C327M | 5);}' unless defined(&C327DIAG_REG_READ);
    eval 'sub C327DIAG_REG_TEST () {( &C327M | 6);}' unless defined(&C327DIAG_REG_TEST);
    eval 'sub C327DIAG_SIM_RD_CMD () {( &C327M | 7);}' unless defined(&C327DIAG_SIM_RD_CMD);
    eval 'sub C327DIAG_SIM_WR_CMD () {( &C327M | 8);}' unless defined(&C327DIAG_SIM_WR_CMD);
    eval 'sub C327DIAG_GET_RCV_CMD () {( &C327M | 9);}' unless defined(&C327DIAG_GET_RCV_CMD);
    eval 'sub C327DIAG_I_STAT_RESET () {( &C327M | 10);}' unless defined(&C327DIAG_I_STAT_RESET);
    eval 'sub C327DIAG_I_STAT_READ () {( &C327M | 11);}' unless defined(&C327DIAG_I_STAT_READ);
    eval 'sub C327DIAG_SIM_RESET () {( &C327M | 12);}' unless defined(&C327DIAG_SIM_RESET);
    eval 'sub C327DIAG_DISCONNECT () {( &C327M | 13);}' unless defined(&C327DIAG_DISCONNECT);
    eval 'sub C327DIAG_CONN_TEST () {( &C327M | 14);}' unless defined(&C327DIAG_CONN_TEST);
    eval 'sub adapter_intr_stat_reg () {0x;}' unless defined(&adapter_intr_stat_reg);
    eval 'sub adapter_vis_snd_reg () {0x1;}' unless defined(&adapter_vis_snd_reg);
    eval 'sub adapter_lsb_cur_reg () {0x2;}' unless defined(&adapter_lsb_cur_reg);
    eval 'sub adapter_msb_cur_reg () {0x3;}' unless defined(&adapter_msb_cur_reg);
    eval 'sub adapter_conn_ctrl_reg () {0x4;}' unless defined(&adapter_conn_ctrl_reg);
    eval 'sub adapter_scan_code_reg () {0x5;}' unless defined(&adapter_scan_code_reg);
    eval 'sub adapter_term_id_reg () {0x6;}' unless defined(&adapter_term_id_reg);
    eval 'sub adapter_old_segment_reg () {0x7;}' unless defined(&adapter_old_segment_reg);
    eval 'sub adapter_87e_stat_reg () {0xa;}' unless defined(&adapter_87e_stat_reg);
    eval 'sub adapter_io_ctrl_reg () {0xf;}' unless defined(&adapter_io_ctrl_reg);
    eval 'sub CONN_CTRL_ENABLE_COAX () {0x1;}' unless defined(&CONN_CTRL_ENABLE_COAX);
    eval 'sub CONN_CTRL_DFT_MODE () {0x2;}' unless defined(&CONN_CTRL_DFT_MODE);
    eval 'sub CONN_CTRL_87E_MODE () {0x4;}' unless defined(&CONN_CTRL_87E_MODE);
    eval 'sub CONN_CTRL_KEY_AVAIL () {0x8;}' unless defined(&CONN_CTRL_KEY_AVAIL);
    eval 'sub CONN_CTRL_POLL_REQ () {0x10;}' unless defined(&CONN_CTRL_POLL_REQ);
    eval 'sub CONN_CTRL_TEST () {0x20;}' unless defined(&CONN_CTRL_TEST);
    eval 'sub CONN_CTRL_RST_CUR () {0x40;}' unless defined(&CONN_CTRL_RST_CUR);
    eval 'sub CONN_CTRL_CON_INT_INH () {0x40;}' unless defined(&CONN_CTRL_CON_INT_INH);
    eval 'sub CONN_CTRL_INT_INH () {0x80;}' unless defined(&CONN_CTRL_INT_INH);
    eval 'sub WDC () {(ord(\'w\') << 8);}' unless defined(&WDC);
    eval 'sub WDC_INQ () {( &WDC | 1);}' unless defined(&WDC_INQ);
    eval 'sub WDC_SSTAT () {( &WDC | 2);}' unless defined(&WDC_SSTAT);
    eval 'sub WDC_POR () {( &WDC | 3);}' unless defined(&WDC_POR);
    eval 'sub WDC_AUTO () {( &WDC | 4);}' unless defined(&WDC_AUTO);
    eval 'sub WDC_WAITCLEAR () {( &WDC | 5);}' unless defined(&WDC_WAITCLEAR);
    eval 'sub WDI_DAVAIL () {0x2;}' unless defined(&WDI_DAVAIL);
    eval 'sub WDI_CCHAIN () {0x4;}' unless defined(&WDI_CCHAIN);
    eval 'sub WDI_LOCKED () {0x8;}' unless defined(&WDI_LOCKED);
    eval 'sub WDI_FATAL () {0x10;}' unless defined(&WDI_FATAL);
    eval 'sub WDI_COMM () {0x20;}' unless defined(&WDI_COMM);
    eval 'sub WDI_PROG () {0x40;}' unless defined(&WDI_PROG);
    eval 'sub WDI_MACH () {0x80;}' unless defined(&WDI_MACH);
    eval 'sub WDI_CU () {0x100;}' unless defined(&WDI_CU);
    eval 'sub WDI_WCUS_30 () {0x200;}' unless defined(&WDI_WCUS_30);
    eval 'sub WDI_WCUS_31 () {0x400;}' unless defined(&WDI_WCUS_31);
    eval 'sub WDI_RUSIZE () {0x800;}' unless defined(&WDI_RUSIZE);
    eval 'sub WDI_ALL_CHECK () {( &WDI_FATAL |  &WDI_COMM |  &WDI_PROG |  &WDI_MACH |  &WDI_CU |  &WDI_WCUS_30 |  &WDI_WCUS_31);}' unless defined(&WDI_ALL_CHECK);
    eval 'sub WDI_TRANSP_MODE () {0x1;}' unless defined(&WDI_TRANSP_MODE);
    eval 'sub WEC_501 () {501;}' unless defined(&WEC_501);
    eval 'sub WEC_503 () {503;}' unless defined(&WEC_503);
    eval 'sub WEC_505 () {505;}' unless defined(&WEC_505);
    eval 'sub WEC_513 () {513;}' unless defined(&WEC_513);
    eval 'sub WEC_551 () {551;}' unless defined(&WEC_551);
    eval 'sub WEC_583 () {583;}' unless defined(&WEC_583);
    eval 'sub WEC_584 () {584;}' unless defined(&WEC_584);
    eval 'sub WEC_585 () {585;}' unless defined(&WEC_585);
    eval 'sub WEM_TIMEOUT () {670;}' unless defined(&WEM_TIMEOUT);
    eval 'sub WEM_BAD_INIT () {671;}' unless defined(&WEM_BAD_INIT);
    eval 'sub WEM_HARDWARE () {674;}' unless defined(&WEM_HARDWARE);
    eval 'sub WEP_BAD_NET () {672;}' unless defined(&WEP_BAD_NET);
    eval 'sub WEP_CMD_OUT () {673;}' unless defined(&WEP_CMD_OUT);
    eval 'sub WEP_INV_Q () {675;}' unless defined(&WEP_INV_Q);
    eval 'sub WEP_INV_CMD () {676;}' unless defined(&WEP_INV_CMD);
    eval 'sub WEP_LA_ENB () {677;}' unless defined(&WEP_LA_ENB);
    eval 'sub WEP_LA_AENB () {678;}' unless defined(&WEP_LA_AENB);
    eval 'sub WEP_UNDER_SLIH () {679;}' unless defined(&WEP_UNDER_SLIH);
    eval 'sub WEP_BUFF_DEPL () {680;}' unless defined(&WEP_BUFF_DEPL);
    eval 'sub WEP_OVER_DEV () {681;}' unless defined(&WEP_OVER_DEV);
    eval 'sub WEP_SSLA_BAD () {682;}' unless defined(&WEP_SSLA_BAD);
    eval 'sub WEP_SEL_RESET () {683;}' unless defined(&WEP_SEL_RESET);
    eval 'sub WEP_POWER_ON_RST () {684;}' unless defined(&WEP_POWER_ON_RST);
    eval 'sub WEP_5088_CMD_REJECT () {685;}' unless defined(&WEP_5088_CMD_REJECT);
    eval 'sub WEP_5088_OP_CHK () {686;}' unless defined(&WEP_5088_OP_CHK);
    eval 'sub WEP_HIA_DOWN () {687;}' unless defined(&WEP_HIA_DOWN);
    eval 'sub WEP_DUP_NET () {688;}' unless defined(&WEP_DUP_NET);
    eval 'sub WEP_INV_PARMS () {689;}' unless defined(&WEP_INV_PARMS);
    eval 'sub WEP_FULL_NET () {690;}' unless defined(&WEP_FULL_NET);
    eval 'sub WEP_CARD_DOWN () { &WEP_HIA_DOWN;}' unless defined(&WEP_CARD_DOWN);
    eval 'sub WEB_610 () {610;}' unless defined(&WEB_610);
    eval 'sub WEB_603 () {610;}' unless defined(&WEB_603);
    eval 'sub STAT_ACK () {0;}' unless defined(&STAT_ACK);
    eval 'sub STAT_READ () {1;}' unless defined(&STAT_READ);
    eval 'sub STAT_SEL () {107;}' unless defined(&STAT_SEL);
    eval 'sub STAT_BERR () {109;}' unless defined(&STAT_BERR);
    eval 'sub STAT_BADC () {110;}' unless defined(&STAT_BADC);
    eval 'sub STAT_UNSUP () {111;}' unless defined(&STAT_UNSUP);
    eval 'sub STAT_RESET () {2;}' unless defined(&STAT_RESET);
    eval 'sub STAT_REST () { &STAT_RESET;}' unless defined(&STAT_REST);
    eval 'sub STAT_PRTCMP () {3;}' unless defined(&STAT_PRTCMP);
    eval 'sub ACK_ON () {0x1;}' unless defined(&ACK_ON);
    eval 'sub ACK_OFF () {0x;}' unless defined(&ACK_OFF);
    eval 'sub TRANSP_MODE () {0x1;}' unless defined(&TRANSP_MODE);
}
1;
