require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_IOCC)) {
    eval 'sub _H_IOCC () {1;}' unless defined(&_H_IOCC);
    unless(defined(&_H_TYPES)) {
	require 'sys/types.ph';
    }
    if(defined(&_POWER_MP)) {
	require 'sys/lock_def.ph';
    }
    eval 'sub IRR_MISC () {0x80000000;}' unless defined(&IRR_MISC);
    eval 'sub IRR_KBD () {0x40000000;}' unless defined(&IRR_KBD);
    eval 'sub IRR_SERIAL () {0x20000000;}' unless defined(&IRR_SERIAL);
    eval 'sub IRR_CHECK_F1 () {0x800000;}' unless defined(&IRR_CHECK_F1);
    eval 'sub IRR_PARALLEL () {0x40000;}' unless defined(&IRR_PARALLEL);
    eval 'sub IMI_CHANCK () {0x80000000;}' unless defined(&IMI_CHANCK);
    eval 'sub IMI_TIMEOUT () {0x40000000;}' unless defined(&IMI_TIMEOUT);
    eval 'sub IMI_KBDEXT () {0x20000000;}' unless defined(&IMI_KBDEXT);
    eval 'sub IMI_BUMP () {0x20000000;}' unless defined(&IMI_BUMP);
    eval 'sub IOCC0_BID () {0x820c00e0;}' unless defined(&IOCC0_BID);
    eval 'sub IOCC1_BID () {0x821c00e0;}' unless defined(&IOCC1_BID);
    eval 'sub IOCC2_BID () {0x821c00e0;}' unless defined(&IOCC2_BID);
    eval 'sub IOCC3_BID () {0x821c00e0;}' unless defined(&IOCC3_BID);
    eval 'sub IOCC_BID () { &IOCC0_BID;}' unless defined(&IOCC_BID);
    eval 'sub IO_IOCC () {0x400000;}' unless defined(&IO_IOCC);
    eval 'sub ICF_ENABLE () {0x80000000;}' unless defined(&ICF_ENABLE);
    eval 'sub ICF_BURST16 () {0x10000000;}' unless defined(&ICF_BURST16);
    eval 'sub ICF_BURST32 () {0x20000000;}' unless defined(&ICF_BURST32);
    eval 'sub ICF_BURST64 () {0x30000000;}' unless defined(&ICF_BURST64);
    eval 'sub ICF_DISCK () {0x8000000;}' unless defined(&ICF_DISCK);
    eval 'sub ICF_DISSD () {0x4000000;}' unless defined(&ICF_DISSD);
    eval 'sub ICF_REFR60 () {0x1000000;}' unless defined(&ICF_REFR60);
    eval 'sub ICF_REFR30 () {0x2000000;}' unless defined(&ICF_REFR30);
    eval 'sub ICF_REFR15 () {0x3000000;}' unless defined(&ICF_REFR15);
    eval 'sub ICF_RAM256K () {0x100000;}' unless defined(&ICF_RAM256K);
    eval 'sub ICF_RAM512K () {0x200000;}' unless defined(&ICF_RAM512K);
    eval 'sub ICF_RAM1M () {0x300000;}' unless defined(&ICF_RAM1M);
    eval 'sub ICF_RAM2M () {0x400000;}' unless defined(&ICF_RAM2M);
    eval 'sub ICF_RAM4M () {0x500000;}' unless defined(&ICF_RAM4M);
    eval 'sub ICF_RAM8M () {0x600000;}' unless defined(&ICF_RAM8M);
    eval 'sub ICF_RAM16M () {0x700000;}' unless defined(&ICF_RAM16M);
    eval 'sub ICF_RAM_MASK () {0x700000;}' unless defined(&ICF_RAM_MASK);
    eval 'sub ICF_RAM_SHIFT () {20;}' unless defined(&ICF_RAM_SHIFT);
    eval 'sub ICF_ARB200 () {0x10000;}' unless defined(&ICF_ARB200);
    eval 'sub ICF_ARB300 () {0x20000;}' unless defined(&ICF_ARB300);
    eval 'sub ICF_ARB1600 () {0xf0000;}' unless defined(&ICF_ARB1600);
    eval 'sub ICF_DUAL_BUF () {0x80;}' unless defined(&ICF_DUAL_BUF);
    eval 'sub ICF_SLAVE_TCW () {0x40;}' unless defined(&ICF_SLAVE_TCW);
    eval 'sub ICF_BUF_MSK () {0x30;}' unless defined(&ICF_BUF_MSK);
    eval 'sub ICF_SLVCHN_MSK () {0xf;}' unless defined(&ICF_SLVCHN_MSK);
    eval 'sub ICF_TCWS {
        my($c) = @_;
	    eval q(( (($c) &  &ICF_SLAVE_TCW) ? ((0x8000 << ((($c) &  &ICF_RAM_MASK) >>  &ICF_RAM_SHIFT)) >> 2) : (((0x20000 << ((($c) &  &ICF_RAM_MASK) >>  &ICF_RAM_SHIFT)) >> 2) - 0x2000)));
    }' unless defined(&ICF_TCWS);
    eval 'sub ICF_SLV_TCWS {
        my($c) = @_;
	    eval q(((($c) &  &ICF_SLAVE_TCW) ? (256* &ICF_NUM_SLVCHN($c)) : 0));
    }' unless defined(&ICF_SLV_TCWS);
    eval 'sub ICF_NUM_TCWS {
        my($c) = @_;
	    eval q(( &ICF_TCWS($c) -  &ICF_SLV_TCWS($c)));
    }' unless defined(&ICF_NUM_TCWS);
    eval 'sub ICF_BUFFERED {
        my($c) = @_;
	    eval q(((($c) &  &ICF_BUF_MSK) != 0x10));
    }' unless defined(&ICF_BUFFERED);
    eval 'sub ICF_NUM_SLVCHN {
        my($c) = @_;
	    eval q((((($c) &  &ICF_SLVCHN_MSK) == 0) ? 0xf : ($c) &  &ICF_SLVCHN_MSK));
    }' unless defined(&ICF_NUM_SLVCHN);
    eval 'sub IOCC_DELAY () {0xe0;}' unless defined(&IOCC_DELAY);
    eval 'sub IO_CONFIG () {0x400000;}' unless defined(&IO_CONFIG);
    eval 'sub IO_CONFIG_SLOT () {0xf0000;}' unless defined(&IO_CONFIG_SLOT);
    eval 'sub F1_CONFIG () {0x470000;}' unless defined(&F1_CONFIG);
    eval 'sub f1_modes () { &dev1;}' unless defined(&f1_modes);
    eval 'sub F1_DIAG () {0x2;}' unless defined(&F1_DIAG);
    eval 'sub F1_ENABLE () {0x1;}' unless defined(&F1_ENABLE);
    eval 'sub f1_dmamask () { &dev2;}' unless defined(&f1_dmamask);
    eval 'sub f1_dmafair () { &dev3;}' unless defined(&f1_dmafair);
    eval 'sub f1_eoi () { &dev4;}' unless defined(&f1_eoi);
    eval 'sub F1_CCK () {0x80;}' unless defined(&F1_CCK);
    eval 'sub f1_intmaskH () { &subaddr2;}' unless defined(&f1_intmaskH);
    eval 'sub f1_intmaskL () { &subaddr1;}' unless defined(&f1_intmaskL);
    eval 'sub EPOW_MASK () {0xf0000000;}' unless defined(&EPOW_MASK);
    eval 'sub PSR_ADDRESS () {0x4000e4;}' unless defined(&PSR_ADDRESS);
    eval 'sub PCRR_ADDRESS () {0x4000e8;}' unless defined(&PCRR_ADDRESS);
    eval 'sub NORMAL_STATE () {0x;}' unless defined(&NORMAL_STATE);
    eval 'sub BATTERY () {0x10000000;}' unless defined(&BATTERY);
    eval 'sub LOPP () {0x80000000;}' unless defined(&LOPP);
    eval 'sub THERMAL_WARNING () {0x50000000;}' unless defined(&THERMAL_WARNING);
    eval 'sub PWR_OVERLOAD () {0x70000000;}' unless defined(&PWR_OVERLOAD);
    eval 'sub PWR_FAN_FAULT () {0x90000000;}' unless defined(&PWR_FAN_FAULT);
    eval 'sub KEY_POS_MASK () {0x3;}' unless defined(&KEY_POS_MASK);
    eval 'sub KEY_POS_NORMAL () {0x3;}' unless defined(&KEY_POS_NORMAL);
    eval 'sub KEY_POS_SECURE () {0x1;}' unless defined(&KEY_POS_SECURE);
    eval 'sub KEY_POS_SERVICE () {0x2;}' unless defined(&KEY_POS_SERVICE);
    eval 'sub BEHAVIOR_SHIFT () {18;}' unless defined(&BEHAVIOR_SHIFT);
    eval 'sub BEHAVIOR_MASK () {0xf;}' unless defined(&BEHAVIOR_MASK);
    eval 'sub USE_EPOW_BITS () {0x;}' unless defined(&USE_EPOW_BITS);
    unless(defined(&WARN_COOLING)) {
	eval 'sub WARN_COOLING () {0x1;}' unless defined(&WARN_COOLING);
    }
    unless(defined(&WARN_POWER)) {
	eval 'sub WARN_POWER () {0x2;}' unless defined(&WARN_POWER);
    }
    eval 'sub SLOW_SHUTDOWN () {0x3;}' unless defined(&SLOW_SHUTDOWN);
    eval 'sub FAST_SHUTDOWN () {0x4;}' unless defined(&FAST_SHUTDOWN);
    eval 'sub IMMED_SHUTDOWN () {0x5;}' unless defined(&IMMED_SHUTDOWN);
    eval 'sub IMMEDX_SHUTDOWN () {0x6;}' unless defined(&IMMEDX_SHUTDOWN);
    if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
    }
    eval 'sub IOCC_COMMAND_START () {0x400000;}' unless defined(&IOCC_COMMAND_START);
    eval 'sub IOCC_COMMAND_END () {0x4fffff;}' unless defined(&IOCC_COMMAND_END);
    eval 'sub IOCCSR_KEY () {0x40000000;}' unless defined(&IOCCSR_KEY);
    eval 'sub IOCCSR_SELECT () {0x80;}' unless defined(&IOCCSR_SELECT);
    eval 'sub IOCC_SEGREG () {0x80000000;}' unless defined(&IOCC_SEGREG);
    eval 'sub IO_IOCC_PPC () {0x10000;}' unless defined(&IO_IOCC_PPC);
    eval 'sub IOCC_CFG_REG () {0x80;}' unless defined(&IOCC_CFG_REG);
    eval 'sub IOCC_TCE_ADDR () {0x9c;}' unless defined(&IOCC_TCE_ADDR);
    eval 'sub MAX_NUM_IOCCS () {2;}' unless defined(&MAX_NUM_IOCCS);
    eval 'sub IOCC_601_BOX () {0x300000;}' unless defined(&IOCC_601_BOX);
    eval 'sub BUID_SEGREG_MASK () {0x1ff00000;}' unless defined(&BUID_SEGREG_MASK);
    eval 'sub BUID_TO_IOCC {
        my( $Buid ) = @_;
	    eval q((  &IOCC_SEGREG | ($Buid << 20)));
    }' unless defined(&BUID_TO_IOCC);
    eval 'sub NUM_TCES_PPC {
        my($c) = @_;
	    eval q(( 0x2000 << (($c) & 0x7)));
    }' unless defined(&NUM_TCES_PPC);
    eval 'sub NUM_SLVCHN_PPC {
        my($c) = @_;
	    eval q((($c) & 0xf));
    }' unless defined(&NUM_SLVCHN_PPC);
    eval 'sub SLV_TCES_PPC {
        my($c) = @_;
	    eval q((256*  &NUM_SLVCHN_PPC($c)));
    }' unless defined(&SLV_TCES_PPC);
    unless(defined(&_POWER_MP)) {
    } else {
    }
    eval 'sub ICF_ENABLE () {0x80000000;}' unless defined(&ICF_ENABLE);
    eval 'sub ICF_64_bit () {0x80;}' unless defined(&ICF_64_bit);
    eval 'sub ICF_MAXTCE_MSK () {0x70;}' unless defined(&ICF_MAXTCE_MSK);
}
1;
