require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ki_op)) {
    sub ki_op {
	my($x) = @_;
	eval q((($x)&0xffff));
    }
}
unless(defined(&ki_type)) {
    sub ki_type {
	my($x) = @_;
	eval q((($x)&0xff00));
    }
}
unless(defined(&KINFO_PROC)) {
    sub KINFO_PROC () {	(0<<8);}
}
unless(defined(&KINFO_PROC_ALL)) {
    sub KINFO_PROC_ALL () {	( &KINFO_PROC|0);}
}
unless(defined(&KINFO_PROC_PID)) {
    sub KINFO_PROC_PID () {	( &KINFO_PROC|1);}
}
unless(defined(&KINFO_PROC_PGRP)) {
    sub KINFO_PROC_PGRP () {	( &KINFO_PROC|2);}
}
unless(defined(&KINFO_PROC_SESSION)) {
    sub KINFO_PROC_SESSION () {	( &KINFO_PROC|3);}
}
unless(defined(&KINFO_PROC_TTY)) {
    sub KINFO_PROC_TTY () {	( &KINFO_PROC|4);}
}
unless(defined(&KINFO_PROC_UID)) {
    sub KINFO_PROC_UID () {	( &KINFO_PROC|5);}
}
unless(defined(&KINFO_PROC_RUID)) {
    sub KINFO_PROC_RUID () {	( &KINFO_PROC|6);}
}
unless(defined(&ki_af)) {
    sub ki_af {
	my($x) = @_;
	eval q(((($x)&0xff0000) >> 16));
    }
}
unless(defined(&KINFO_RT)) {
    sub KINFO_RT () {	(1<<8);}
}
unless(defined(&KINFO_RT_DUMP)) {
    sub KINFO_RT_DUMP () {	( &KINFO_RT|1);}
}
unless(defined(&KINFO_RT_FLAGS)) {
    sub KINFO_RT_FLAGS () {	( &KINFO_RT|2);}
}
unless(defined(&KINFO_RT_IFLIST)) {
    sub KINFO_RT_IFLIST () {	( &KINFO_RT|3);}
}
unless(defined(&KINFO_VNODE)) {
    sub KINFO_VNODE () {	(2<<8);}
}
unless(defined(&KINFO_NDD)) {
    sub KINFO_NDD () {	(4<<8);}
}
unless(defined(&KINFO_READ)) {
    sub KINFO_READ () {	(8<<8);}
}
unless(defined(&KINFO_WRITE)) {
    sub KINFO_WRITE () {	(10<<8);}
}
unless(defined(&KINFO_READ64)) {
    sub KINFO_READ64 () {	(20<<8);}
}
unless(defined(&KINFO_WRITE64)) {
    sub KINFO_WRITE64 () {	(40<<8);}
}
unless(defined(&KINFO_ZSTATS)) {
    sub KINFO_ZSTATS () {	(80<<8);}
}
unless(defined(&KINFO_SET_IF_STATS)) {
    sub KINFO_SET_IF_STATS () {	(100<<8);}
}
unless(defined(&KINFO_SET_DMX_STATS)) {
    sub KINFO_SET_DMX_STATS () {	(200<<8);}
}
if(defined(&KERNEL)) {
}
1;
