require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_LPIO)) {
    eval 'sub _H_LPIO () {1;}' unless defined(&_H_LPIO);
    require 'sys/termio.ph';
    require 'sys/ioctl.ph';
    require 'sys/stropts.ph';
    eval 'sub LPDIAGMOD () {1;}' unless defined(&LPDIAGMOD);
    eval 'sub LPR () {(ord(\'l\')<<8);}' unless defined(&LPR);
    eval 'sub LPRGET () {( &LPR|01);}' unless defined(&LPRGET);
    eval 'sub LPRSET () {( &LPR|02);}' unless defined(&LPRSET);
    eval 'sub LPRGETA () {( &LPR|17);}' unless defined(&LPRGETA);
    eval 'sub LPRSETA () {( &LPR|18);}' unless defined(&LPRSETA);
    eval 'sub LPRGTOV () {( &LPR|19);}' unless defined(&LPRGTOV);
    eval 'sub LPRSTOV () {( &LPR|20);}' unless defined(&LPRSTOV);
    eval 'sub LPQUERY () {( &LPR|23);}' unless defined(&LPQUERY);
    eval 'sub LPDIAG () {( &LPR|26);}' unless defined(&LPDIAG);
    eval 'sub LPRMODG () {( &LPR|27);}' unless defined(&LPRMODG);
    eval 'sub LPRMODS () {( &LPR|28);}' unless defined(&LPRMODS);
    eval 'sub LPWRITE_REQ () {( &LPR|30);}' unless defined(&LPWRITE_REQ);
    eval 'sub PLOT () {0x1;}' unless defined(&PLOT);
    eval 'sub NOFF () {0x2;}' unless defined(&NOFF);
    eval 'sub NONL () {0x4;}' unless defined(&NONL);
    eval 'sub NOCL () {0x8;}' unless defined(&NOCL);
    eval 'sub NOTB () {0x10;}' unless defined(&NOTB);
    eval 'sub NOBS () {0x20;}' unless defined(&NOBS);
    eval 'sub NOCR () {0x40;}' unless defined(&NOCR);
    eval 'sub CAPS () {0x80;}' unless defined(&CAPS);
    eval 'sub WRAP () {0x100;}' unless defined(&WRAP);
    eval 'sub FONTINIT () {0x200;}' unless defined(&FONTINIT);
    eval 'sub RPTERR () {0x400;}' unless defined(&RPTERR);
    eval 'sub IGNOREPE () {0x800;}' unless defined(&IGNOREPE);
    eval 'sub DOALLWRITES () {01000000;}' unless defined(&DOALLWRITES);
    eval 'sub LPST_POUT () {0x1;}' unless defined(&LPST_POUT);
    eval 'sub LPST_TOUT () {0x2;}' unless defined(&LPST_TOUT);
    eval 'sub LPST_ERROR () {0x4;}' unless defined(&LPST_ERROR);
    eval 'sub LPST_BUSY () {0x8;}' unless defined(&LPST_BUSY);
    eval 'sub LPST_NOSLCT () {0x20;}' unless defined(&LPST_NOSLCT);
    eval 'sub LPST_SOFT () {0x40;}' unless defined(&LPST_SOFT);
    eval 'sub LPST_OFF () {0x80;}' unless defined(&LPST_OFF);
    eval 'sub LPAD_R1 () {1;}' unless defined(&LPAD_R1);
    eval 'sub LPAD_SA () {2;}' unless defined(&LPAD_SA);
    eval 'sub LPAD_NIO () {3;}' unless defined(&LPAD_NIO);
    eval 'sub LPAD_IOD () {4;}' unless defined(&LPAD_IOD);
    eval 'sub LP_R_STAT () {0x1;}' unless defined(&LP_R_STAT);
    eval 'sub LP_R_CNTL () {0x2;}' unless defined(&LP_R_CNTL);
    eval 'sub LP_W_CNTL () {0x3;}' unless defined(&LP_W_CNTL);
    eval 'sub LP_R_DATA () {0x4;}' unless defined(&LP_R_DATA);
    eval 'sub LP_W_DATA () {0x5;}' unless defined(&LP_W_DATA);
    eval 'sub LP_WATCHINT () {0x6;}' unless defined(&LP_WATCHINT);
    eval 'sub LP_DIDINTOCC () {0x7;}' unless defined(&LP_DIDINTOCC);
    eval 'sub LP_INTDIDOCC () {0x1;}' unless defined(&LP_INTDIDOCC);
    eval 'sub LP_INTNOTOCC () {0x2;}' unless defined(&LP_INTNOTOCC);
    eval 'sub SP_WRITE_DECL () {\'struct strioctl\'  &lpwrite_str ;;}' unless defined(&SP_WRITE_DECL);
    eval 'sub SP_WRITE_INIT () { ($lpwrite_str->{ic_cmd})	=  &LPWRITE_REQ;  ($lpwrite_str->{ic_timout})	= -1;  ($lpwrite_str->{ic_len})	= 0;  ($lpwrite_str->{ic_dp})	=  &NULL;;}' unless defined(&SP_WRITE_INIT);
    eval 'sub SP_WRITE {
        my($fd, $buf, $len) = @_;
	    eval q(( ! &isastream($fd) ?  &write($fd, $buf, $len) : (  &write($fd, $buf, $len) < 0? -1: (  &ioctl($fd,  &I_STR,  &lpwrite_str) == 0? $len : -1) ) ));
    }' unless defined(&SP_WRITE);
}
1;
