require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MBUF_H_)) {
    eval 'sub _SYS_MBUF_H_ () {1;}' unless defined(&_SYS_MBUF_H_);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_AIX)) {
	if(defined(&__64BIT_KERNEL)) {
	    eval 'sub MSIZE () {512;}' unless defined(&MSIZE);
	} else {
	    eval 'sub MSIZE () {256;}' unless defined(&MSIZE);
	}
	eval 'sub MCLBYTES () { &CLBYTES;}' unless defined(&MCLBYTES);
	require 'sys/xmem.ph';
	require 'sys/trchkid.ph';
    }
    if(defined( &_KERNEL)  && !defined( &_NET_GLOBALS_H_)) {
	require 'net/net_globals.ph';
    }
    unless(defined(&NET_MALLOC)) {
	require 'net/net_malloc.ph';
    }
    require 'sys/adspace.ph';
    eval 'sub MLEN () {( &MSIZE - $sizeof{\'struct m_hdr\'});}' unless defined(&MLEN);
    eval 'sub MHLEN () {( &MLEN - $sizeof{\'struct pkthdr\'});}' unless defined(&MHLEN);
    eval 'sub MQOSLEN () {( &MHLEN - $sizeof{\'struct qoshdr\'} - $sizeof{\'struct __m_ext\'} - $sizeof{\'struct suminfo\'});}' unless defined(&MQOSLEN);
    eval 'sub MSUMLEN () {( &MHLEN - $sizeof{\'struct suminfo\'});}' unless defined(&MSUMLEN);
    eval 'sub MINCLSIZE () {( &MHLEN + 3* &MLEN);}' unless defined(&MINCLSIZE);
    eval 'sub M_MAXCOMPRESS () {( &MHLEN / 2);}' unless defined(&M_MAXCOMPRESS);
    eval 'sub mtod {
        my($m,$t) = @_;
	    eval q((($t)(($m)-> &m_data)));
    }' unless defined(&mtod);
    eval 'sub dtom {
        my($x) = @_;
	    eval q(((($x) & ~( &MSIZE-1))));
    }' unless defined(&dtom);
    if(defined(&_AIX)) {
	eval 'sub mtocl {
	    my($m) = @_;
    	    eval q((($m)-> ($m_ext->{ext_buf})));
	}' unless defined(&mtocl);
	eval 'sub MTOD {
	    my($m,$t) = @_;
    	    eval q( &mtod($m,$t));
	}' unless defined(&MTOD);
	eval 'sub DTOM {
	    my($x) = @_;
    	    eval q( &dtom($x));
	}' unless defined(&DTOM);
	eval 'sub MTOCL {
	    my($x) = @_;
    	    eval q( &mtocl($x));
	}' unless defined(&MTOCL);
	eval 'sub CLTOM {
	    my($x) = @_;
    	    eval q( &cltom($x));
	}' unless defined(&CLTOM);
    }
    if(defined(&__64BIT_KERNEL)) {
    } else {
    }
    if(defined(&__64BIT_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_AIX)) {
	if(defined(&__64BIT_KERNEL)) {
	}
    }
    eval 'sub m_next () { ($m_hdr->{mh_next});}' unless defined(&m_next);
    eval 'sub m_len () { ($m_hdr->{mh_len});}' unless defined(&m_len);
    eval 'sub m_data () { ($m_hdr->{mh_data});}' unless defined(&m_data);
    eval 'sub m_type () { ($m_hdr->{mh_type});}' unless defined(&m_type);
    eval 'sub m_flags () { ($m_hdr->{mh_flags});}' unless defined(&m_flags);
    eval 'sub m_nextpkt () { ($m_hdr->{mh_nextpkt});}' unless defined(&m_nextpkt);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub m_options () { ($m_hdr->{mh_options});}' unless defined(&m_options);
    }
    eval 'sub m_act () { &m_nextpkt;}' unless defined(&m_act);
    eval 'sub m_pkthdr () { ($M_dat->{MH}->{MH_pkthdr});}' unless defined(&m_pkthdr);
    eval 'sub m_ext () { ($M_dat->{MH}->{MH_dat}->{MH_ext});}' unless defined(&m_ext);
    eval 'sub m_pktdat () { ($M_dat->{MH}->{MH_dat}->{MH_databuf});}' unless defined(&m_pktdat);
    eval 'sub m_qosdat () { ($M_dat->{MH}->{MH_dat}->{MH_qos}->{MH_qosdatabuf});}' unless defined(&m_qosdat);
    eval 'sub m_qoshdr () { ($M_dat->{MH}->{MH_dat}->{MH_qos}->{MH_qoshdr});}' unless defined(&m_qoshdr);
    eval 'sub m_sumdat () { ($M_dat->{MH}->{MH_dat}->{MH_sum}->{MH_sumdat});}' unless defined(&m_sumdat);
    eval 'sub m_suminfo () { ($M_dat->{MH}->{MH_dat}->{MH_sum}->{MH_suminfo});}' unless defined(&m_suminfo);
    eval 'sub m_qossuminfo () { ($M_dat->{MH}->{MH_dat}->{MH_qos}->{MH_suminfo});}' unless defined(&m_qossuminfo);
    eval 'sub m_dat () { ($M_dat->{M_databuf});}' unless defined(&m_dat);
    eval 'sub M_EXT () {0x1;}' unless defined(&M_EXT);
    eval 'sub M_PKTHDR () {0x2;}' unless defined(&M_PKTHDR);
    eval 'sub M_EOR () {0x4;}' unless defined(&M_EOR);
    eval 'sub M_MPEG () {0x10;}' unless defined(&M_MPEG);
    eval 'sub M_QOS () {0x20;}' unless defined(&M_QOS);
    eval 'sub M_EXT2 () {0x40;}' unless defined(&M_EXT2);
    eval 'sub M_IPV6 () {0x80;}' unless defined(&M_IPV6);
    eval 'sub M_BCAST () {0x100;}' unless defined(&M_BCAST);
    eval 'sub M_MCAST () {0x200;}' unless defined(&M_MCAST);
    eval 'sub M_WCARD () {0x400;}' unless defined(&M_WCARD);
    eval 'sub M_MLOOP () {0x800;}' unless defined(&M_MLOOP);
    eval 'sub M_CHECKSUM_TX () {0x1000;}' unless defined(&M_CHECKSUM_TX);
    eval 'sub M_CHECKSUM_RX () {0x2000;}' unless defined(&M_CHECKSUM_RX);
    eval 'sub M_CHECKSUM () {( &M_CHECKSUM_TX| &M_CHECKSUM_RX);}' unless defined(&M_CHECKSUM);
    eval 'sub M_PSEG () {0x8;}' unless defined(&M_PSEG);
    eval 'sub M_MAPPED () {0x4000;}' unless defined(&M_MAPPED);
    eval 'sub M_LARGESEND () {0x8000;}' unless defined(&M_LARGESEND);
    eval 'sub m_broadcast {
        my($m) = @_;
	    eval q((($m)-> &m_flags & ( &M_BCAST| &M_MCAST| &M_WCARD)));
    }' unless defined(&m_broadcast);
    eval 'sub M_COPYFLAGS () {(~( &M_EXT| &M_EXT2| &M_PSEG| &M_MAPPED));}' unless defined(&M_COPYFLAGS);
    eval 'sub MT_FREE () {0;}' unless defined(&MT_FREE);
    eval 'sub MT_DATA () {1;}' unless defined(&MT_DATA);
    eval 'sub MT_HEADER () {2;}' unless defined(&MT_HEADER);
    eval 'sub MT_SOCKET () {3;}' unless defined(&MT_SOCKET);
    eval 'sub MT_PCB () {4;}' unless defined(&MT_PCB);
    eval 'sub MT_RTABLE () {5;}' unless defined(&MT_RTABLE);
    eval 'sub MT_HTABLE () {6;}' unless defined(&MT_HTABLE);
    eval 'sub MT_ATABLE () {7;}' unless defined(&MT_ATABLE);
    eval 'sub MT_SONAME () {8;}' unless defined(&MT_SONAME);
    eval 'sub MT_SOOPTS () {10;}' unless defined(&MT_SOOPTS);
    eval 'sub MT_FTABLE () {11;}' unless defined(&MT_FTABLE);
    eval 'sub MT_RIGHTS () {12;}' unless defined(&MT_RIGHTS);
    eval 'sub MT_IFADDR () {13;}' unless defined(&MT_IFADDR);
    eval 'sub MT_CONTROL () {14;}' unless defined(&MT_CONTROL);
    eval 'sub MT_OOBDATA () {15;}' unless defined(&MT_OOBDATA);
    eval 'sub MT_MAX () {32;}' unless defined(&MT_MAX);
    if(defined(&IP_MULTICAST)) {
	eval 'sub MT_IPMOPTS () {16;}' unless defined(&MT_IPMOPTS);
	eval 'sub MT_IPMADDR () {17;}' unless defined(&MT_IPMADDR);
	eval 'sub MT_IFMADDR () {18;}' unless defined(&MT_IFMADDR);
	eval 'sub MT_MRTABLE () {19;}' unless defined(&MT_MRTABLE);
    }
    eval 'sub MT_IEEE1284 () {20;}' unless defined(&MT_IEEE1284);
    eval 'sub MT_IPSEC () {21;}' unless defined(&MT_IPSEC);
    eval 'sub M_DONTWAIT () {0;}' unless defined(&M_DONTWAIT);
    eval 'sub M_WAIT () {1;}' unless defined(&M_WAIT);
    eval 'sub MGET {
        my($m, $how, $type) = @_;
	    eval q({  &TRCHKL5T( &HKWD_MBUF |  &hkwd_m_get_in, $how, $type,  &getcaller(),  &getcaller2(),  &getpid());  &MALLOC(($m), \'struct mbuf\' *,  &MSIZE,  &M_MBUF, (!$how));  &if ($m) {  &MBSTAT2( ($mbstat->{m_mtypes[$type]}), 1);  &MBSTAT2( ($mbstat->{m_mbufs}), 1); ($m)-> &m_next = ($m)-> &m_nextpkt = 0; ($m)-> &m_type = ($type); ($m)-> &m_data = ($m)-> &m_dat; ($m)-> &m_flags = 0; }  &else {  &MBSTAT( ($mbstat->{m_drops}), 1); }  &TRCHKL2T( &HKWD_MBUF |  &hkwd_m_get_out, $m,  &mtod($m, \'caddr_t\')); });
    }' unless defined(&MGET);
    eval 'sub MGET_SRAD {
        my($m, $how, $type, $srad) = @_;
	    eval q({  &TRCHKL5T( &HKWD_MBUF |  &hkwd_m_get_in, $how, $type,  &getcaller(),  &getcaller2(),  &getpid());  &MALLOC_SRAD(($m), \'struct mbuf\' *,  &MSIZE,  &M_MBUF, (!$how), $srad);  &if ($m) {  &MBSTAT2( ($mbstat->{m_mtypes[$type]}), 1);  &MBSTAT2( ($mbstat->{m_mbufs}), 1); ($m)-> &m_next = ($m)-> &m_nextpkt = 0; ($m)-> &m_type = ($type); ($m)-> &m_data = ($m)-> &m_dat; ($m)-> &m_flags = 0; }  &else {  &MBSTAT( ($mbstat->{m_drops}), 1); }  &TRCHKL2T( &HKWD_MBUF |  &hkwd_m_get_out, $m,  &mtod($m, \'caddr_t\')); });
    }' unless defined(&MGET_SRAD);
    eval 'sub MGETHDR {
        my($m, $how, $type) = @_;
	    eval q({  &TRCHKL5T( &HKWD_MBUF |  &hkwd_m_get_in, $how, $type,  &getcaller(),  &getcaller2(),  &getpid());  &MALLOC(($m), \'struct mbuf\' *,  &MSIZE,  &M_MBUF, (!$how));  &if ($m) {  &MBSTAT2( ($mbstat->{m_mtypes[$type]}), 1);  &MBSTAT2( ($mbstat->{m_mbufs}), 1); ($m)-> &m_next = ($m)-> &m_nextpkt = 0; ($m)-> &m_type = ($type); ($m)-> &m_data = ($m)-> &m_pktdat; ($m)-> &m_flags =  &M_PKTHDR; }  &else {  &MBSTAT( ($mbstat->{m_drops}), 1); }  &TRCHKL2T( &HKWD_MBUF |  &hkwd_m_get_out, $m,  &mtod($m, \'caddr_t\')); });
    }' unless defined(&MGETHDR);
    eval 'sub MGETHDR_SRAD {
        my($m, $how, $type, $srad) = @_;
	    eval q({  &TRCHKL5T( &HKWD_MBUF |  &hkwd_m_get_in, $how, $type,  &getcaller(),  &getcaller2(),  &getpid());  &MALLOC_SRAD(($m), \'struct mbuf\' *,  &MSIZE,  &M_MBUF, (!$how), $srad);  &if ($m) {  &MBSTAT2( ($mbstat->{m_mtypes[$type]}), 1);  &MBSTAT2( ($mbstat->{m_mbufs}), 1); ($m)-> &m_next = ($m)-> &m_nextpkt = 0; ($m)-> &m_type = ($type); ($m)-> &m_data = ($m)-> &m_pktdat; ($m)-> &m_flags =  &M_PKTHDR; }  &else {  &MBSTAT( ($mbstat->{m_drops}), 1); }  &TRCHKL2T( &HKWD_MBUF |  &hkwd_m_get_out, $m,  &mtod($m, \'caddr_t\')); });
    }' unless defined(&MGETHDR_SRAD);
    eval 'sub MCLALLOC {
        my($p, $how) = @_;
	    eval q(($p =  &m_clalloc(0,  &MCLBYTES, ($how))));
    }' unless defined(&MCLALLOC);
    eval 'sub MCLALLOC_SRAD {
        my($p, $how, $srad) = @_;
	    eval q(($p =  &m_clalloc_srad(0,  &MCLBYTES, ($how), $srad)));
    }' unless defined(&MCLALLOC_SRAD);
    eval 'sub MCLFREE {
        my($p) = @_;
	    eval q({  &MBSTAT2( ($mbstat->{m_clusters}), -1);  &FREE(($p),  &M_CLUSTER); });
    }' unless defined(&MCLFREE);
    eval 'sub MCLGET {
        my($m, $how) = @_;
	    eval q(( &void)  &m_clalloc(($m),  &MCLBYTES, ($how)));
    }' unless defined(&MCLGET);
    eval 'sub MCLGET_SRAD {
        my($m, $how, $srad) = @_;
	    eval q(( &void)  &m_clalloc_srad(($m),  &MCLBYTES, ($how), $srad));
    }' unless defined(&MCLGET_SRAD);
    eval 'sub MCLREFERENCED {
        my($m) = @_;
	    eval q((($m)-> ($m_ext->{ext_ref}->{forw}) != (($m)-> ($m_ext->{ext_ref}))));
    }' unless defined(&MCLREFERENCED);
    eval 'sub MFREE {
        my($m, $n) = @_;
	    eval q({  &MBUF_LOCK_DECL() \'struct mbuf\' * &mnext = -> &m_next;  &void (* &extfree)() =  ($m->{m_ext}->{ext_free});  &__mh_flags_t  &mflags =  ($m->{m_flags});  &TRCHKL5T( &HKWD_MBUF |  &hkwd_m_free_in, $m,  &mtod($m, \'caddr_t\'),  &getcaller(),  &getcaller2(),  &getpid());  &if ( ($m->{m_flags}) &  &M_EXT) {  &if (-> &m_hasxm  && !(-> &m_flags &  &M_MAPPED))  &MBUF_LOCK(-> ($m_ext->{ext_size}));  &else  &MBUF_LOCK(-> ($m_ext->{ext_buf}));  &if {  &remque( ($m->{m_ext}->{ext_ref}));  &mflags &= ~ &M_EXT2;  &if (-> &m_hasxm  && !(-> &m_flags &  &M_MAPPED))  &MBUF_UNLOCK(-> ($m_ext->{ext_size}));  &else  &MBUF_UNLOCK(-> ($m_ext->{ext_buf})); }  &else  &if ( ($m->{m_ext}->{ext_free}) ==  &NULL) {  &if (-> &m_hasxm  && !(-> &m_flags &  &M_MAPPED))  &MBUF_UNLOCK(-> ($m_ext->{ext_size}));  &else  &MBUF_UNLOCK(-> ($m_ext->{ext_buf}));  &MBSTAT2( ($mbstat->{m_clusters}), -1);  &FREE( ($m->{m_ext}->{ext_buf}),  &M_CLUSTER); }  &else  &if ( ($m->{m_flags}) &  &M_EXT2) {  &if (-> &m_hasxm  && !(-> &m_flags &  &M_MAPPED))  &MBUF_UNLOCK(-> ($m_ext->{ext_size}));  &else  &MBUF_UNLOCK(-> ($m_ext->{ext_buf})); (*( ($m->{m_ext}->{ext_free})))($m,  ($m->{m_ext}->{ext_size}),  ($m->{m_ext}->{ext_arg})); }  &else {  &if (($m)-> &m_hasxm  && !(($m)-> &m_flags &  &M_MAPPED))  &MBUF_UNLOCK(($m)-> ($m_ext->{ext_size}));  &else  &MBUF_UNLOCK(($m)-> ($m_ext->{ext_buf})); (*( ($m->{m_ext}->{ext_free})))( ($m->{m_ext}->{ext_buf}),  ($m->{m_ext}->{ext_size}),  ($m->{m_ext}->{ext_arg}));  ($m->{m_flags}) &= ~ &M_EXT; } } ($n) =  &mnext;  &if (!(( &mflags &  &M_EXT2)  &&  &extfree)) {  &MBSTAT2( ($mbstat->{m_mbufs}), -1);  &MBSTAT2( ($mbstat->{m_mtypes[$m}->{m_type]}), -1);  &FREE($m,  &M_MBUF); }  &TRCHKL1T( &HKWD_MBUF |  &hkwd_m_free_out, $m); });
    }' unless defined(&MFREE);
    eval 'sub m_extfree () { ($m_ext->{ext_free});}' unless defined(&m_extfree);
    eval 'sub m_extarg () { ($m_ext->{ext_arg});}' unless defined(&m_extarg);
    eval 'sub m_forw () { ($m_ext->{ext_ref}->{forw});}' unless defined(&m_forw);
    eval 'sub m_back () { ($m_ext->{ext_ref}->{back});}' unless defined(&m_back);
    eval 'sub m_hasxm () { ($m_ext->{ext_hasxm});}' unless defined(&m_hasxm);
    eval 'sub m_xmemd () { ($m_ext->{ext_xmemd});}' unless defined(&m_xmemd);
    eval 'sub m_getclust {
        my($h, $t) = @_;
	    eval q( &m_getclustm($h, $t,  &MCLBYTES));
    }' unless defined(&m_getclust);
    eval 'sub M_HASCL {
        my($m) = @_;
	    eval q((($m)-> &m_flags &  &M_EXT));
    }' unless defined(&M_HASCL);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub M_XMEMD {
	    my($m) = @_;
    	    eval q(( &M_HASCL($m) ? (($m)-> &m_hasxm ? (($m)-> &m_xmemd) :  &BTOSRAD(($m)-> &m_data)-> &kmemxmemd) :  &BTOSRAD($m)-> &kmemxmemd));
	}' unless defined(&M_XMEMD);
    } else {
	eval 'sub M_XMEMD {
	    my($m) = @_;
    	    eval q(( &M_HASCL($m) ? (($m)-> &m_hasxm ? (($m)-> &m_xmemd) :  &mclxmemd) :  &mclxmemd));
	}' unless defined(&M_XMEMD);
    }
    eval 'sub MCLREFERENCE {
        my($m, $n) = @_;
	    eval q( &m_clreference(($m), ($n)));
    }' unless defined(&MCLREFERENCE);
    eval 'sub MCLUNREFERENCE {
        my($m) = @_;
	    eval q( &m_clunreference(($m)));
    }' unless defined(&MCLUNREFERENCE);
    eval 'sub M_SUMINFOP {
        my($m) = @_;
	    eval q((($m)-> &m_flags & ( &M_CHECKSUM_RX| &M_CHECKSUM_TX) ? (($m)-> &m_flags & ( &M_QOS| &M_EXT) ? ($m)-> &m_qossuminfo : ($m)-> &m_suminfo) : 0));
    }' unless defined(&M_SUMINFOP);
    eval 'sub M_COPY_PKTHDR {
        my($to, $from) = @_;
	    eval q({ ($to)-> &m_pkthdr = ($from)-> &m_pkthdr;  &if (($from)-> &m_flags &  &M_QOS) { ($to)-> &m_qoshdr = ($from)-> &m_qoshdr; ($to)-> &m_data = ($to)-> &m_qosdat; }  &else  &if (($from)-> &m_flags & ( &M_CHECKSUM_TX| &M_CHECKSUM_RX)) ($to)-> &m_data = ($to)-> &m_sumdat;  &else ($to)-> &m_data = ($to)-> &m_pktdat;  &if ( &M_SUMINFOP($from))  &if (($from)-> &m_flags &  &M_QOS) ($to)-> &m_qossuminfo = * &M_SUMINFOP($from);  &else ($to)-> &m_suminfo = * &M_SUMINFOP($from); ($to)-> &m_flags = ($from)-> &m_flags &  &M_COPYFLAGS; });
    }' unless defined(&M_COPY_PKTHDR);
    eval 'sub M_ALIGN {
        my($m, $len) = @_;
	    eval q({ ($m)-> &m_data += ( &MLEN - ($len)) &~ ($sizeof{\'long\'} - 1); });
    }' unless defined(&M_ALIGN);
    eval 'sub MH_ALIGN {
        my($m, $len) = @_;
	    eval q({ \'int\'  &bufferlength;  &if (($m)-> &m_flags &  &M_QOS) {  &bufferlength =  &MQOSLEN; }  &else  &if (($m)-> &m_flags & ( &M_CHECKSUM_TX| &M_CHECKSUM_RX)) {  &bufferlength =  &MSUMLEN; }  &else {  &bufferlength =  &MHLEN; } ($m)-> &m_data += ( &bufferlength - ($len)) & ~($sizeof{\'long\'} - 1); });
    }' unless defined(&MH_ALIGN);
    eval 'sub MQOS_ALIGN {
        my($m, $len) = @_;
	    eval q({ ($m)-> &m_data += ( &MQOSLEN - ($len)) &~ ($sizeof{\'long\'} - 1); });
    }' unless defined(&MQOS_ALIGN);
    eval 'sub M_LEADINGSPACE {
        my($m) = @_;
	    eval q((($m)-> &m_flags &  &M_EXT ? (  &MCLREFERENCED(($m)) ? 0: ($m)-> &m_data - ($m)-> ($m_ext->{ext_buf}) ) : ($m)-> &m_flags &  &M_PKTHDR ? (($m)-> &m_flags &  &M_QOS ? ($m)-> &m_data - ($m)-> &m_qosdat : (($m)-> &m_flags & ( &M_CHECKSUM_TX| &M_CHECKSUM_RX) ? ($m)-> &m_data - ($m)-> &m_sumdat : ($m)-> &m_data - ($m)-> &m_pktdat)) : ($m)-> &m_data - ($m)-> &m_dat));
    }' unless defined(&M_LEADINGSPACE);
    eval 'sub M_TRAILINGSPACE {
        my($m) = @_;
	    eval q((($m)-> &m_flags &  &M_EXT ? (  &MCLREFERENCED(($m)) ? 0: ($m)-> ($m_ext->{ext_buf}) + ($m)-> ($m_ext->{ext_size}) - (($m)-> &m_data + ($m)-> &m_len) ) : ($m)-> $m_dat[ &MLEN] - (($m)-> &m_data + ($m)-> &m_len)));
    }' unless defined(&M_TRAILINGSPACE);
    eval 'sub M_PREPEND {
        my($m, $plen, $how) = @_;
	    eval q({  &if ( &M_LEADINGSPACE($m) >= ($plen)) { ($m)-> &m_data -= ($plen); ($m)-> &m_len += ($plen); }  &else ($m) =  &m_prepend(($m), ($plen), ($how));  &if (($m)  && ($m)-> &m_flags &  &M_PKTHDR) ($m)-> ($m_pkthdr->{len}) += ($plen); });
    }' unless defined(&M_PREPEND);
    eval 'sub MCHTYPE {
        my($m, $t) = @_;
	    eval q({  &MBSTAT2( ($mbstat->{m_mtypes[&(m)}->{m_type]}), -1);  &MBSTAT2( ($mbstat->{m_mtypes[$t]}), 1); ($m)-> &m_type = $t;});
    }' unless defined(&MCHTYPE);
    eval 'sub M_COPYALL () {1000000000;}' unless defined(&M_COPYALL);
    eval 'sub m_copy {
        my($m, $o, $l) = @_;
	    eval q( &m_copym(($m), ($o), ($l),  &M_DONTWAIT));
    }' unless defined(&m_copy);
    if(defined(&_AIX)) {
	eval 'sub m_clget {
	    my($m) = @_;
    	    eval q( &m_clgetm(($m),  &M_DONTWAIT,  &MCLBYTES));
	}' unless defined(&m_clget);
	eval 'sub m_getclust {
	    my($h, $t) = @_;
    	    eval q( &m_getclustm($h, $t,  &MCLBYTES));
	}' unless defined(&m_getclust);
    }
    if(defined(&_KERNEL)) {
	if(defined(&_POWER_MP)) {
	}
	if(defined(&_POWER_MP)) {
	    eval 'sub MBLOCK_HASHSZ () {29;}' unless defined(&MBLOCK_HASHSZ);
	    eval 'sub MBUF_LOCK_HASH {
	        my($claddr) = @_;
    		eval q((( &SEGOFFSET($claddr)) %  &MBLOCK_HASHSZ));
	    }' unless defined(&MBUF_LOCK_HASH);
	    eval 'sub MBUF_LOCK_DECL () {
	        eval q(\'int\'  &_mbufs,  &_mbcell;);
	    }' unless defined(&MBUF_LOCK_DECL);
	    eval 'sub MBUF_LOCK {
	        my($claddr) = @_;
    		eval q( &_mbufs =  &disable_lock( &PL_IMP,  ($mbuf_slock[(_mbcell = MBUF_LOCK_HASH($claddr))]->{lock})));
	    }' unless defined(&MBUF_LOCK);
	    eval 'sub MBUF_UNLOCK {
	        my($claddr) = @_;
    		eval q( &unlock_enable( &_mbufs,  ($mbuf_slock[&_mbcell]->{lock})));
	    }' unless defined(&MBUF_UNLOCK);
	    eval 'sub MBUF_LOCKINIT () {
	        eval q({ \'int\'  &i;  &for ( &i =  &MBLOCK_HASHSZ - 1;  &i >= 0;  &i--) {  &lock_alloc( ($mbuf_slock[&i]->{lock}),  &LOCK_ALLOC_PIN,  &MBUF_LOCK_FAMILY,  &i);  &simple_lock_init( ($mbuf_slock[&i]->{lock})); } });
	    }' unless defined(&MBUF_LOCKINIT);
	} else {
	    eval 'sub MBLOCK_HASHSZ () {1;}' unless defined(&MBLOCK_HASHSZ);
	    eval 'sub MBUF_LOCK_DECL () {
	        eval q(\'int\'  &_mbufs;);
	    }' unless defined(&MBUF_LOCK_DECL);
	    eval 'sub MBUF_LOCK {
	        my($claddr) = @_;
    		eval q( &_mbufs =  &disable_ints());
	    }' unless defined(&MBUF_LOCK);
	    eval 'sub MBUF_UNLOCK {
	        my($claddr) = @_;
    		eval q( &enable_ints( &_mbufs));
	    }' unless defined(&MBUF_UNLOCK);
	    eval 'sub MBUF_LOCKINIT () {
	        eval q();
	    }' unless defined(&MBUF_LOCKINIT);
	}
	eval 'sub MBSTAT {
	    my($x, $i) = @_;
    	    eval q(($x) += ($i));
	}' unless defined(&MBSTAT);
	eval 'sub MBSTAT2 {
	    my($x, $i) = @_;
    	    eval q();
	}' unless defined(&MBSTAT2);
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub M_NEED_PSEG_MAP {
        my($a) = @_;
	    eval q(( &M_HASCL($a)  && ($a)-> &m_hasxm  && ($a)-> ($m_xmemd->{aspace_id}) !=  &XMEM_GLOBAL  && !(($a)-> &m_flags &  &M_MAPPED)));
    }' unless defined(&M_NEED_PSEG_MAP);
    eval 'sub M_NEED_PSEG_UNMAP {
        my($a) = @_;
	    eval q(( &M_HASCL($a)  && ($a)-> &m_hasxm  && ($a)-> ($m_xmemd->{aspace_id}) !=  &XMEM_GLOBAL  && (($a)-> &m_flags &  &M_MAPPED)));
    }' unless defined(&M_NEED_PSEG_UNMAP);
    eval 'sub M_PSEG_MAP {
        my($a) = @_;
	    eval q({ \'long off\'; \'int\'  &__rv;  &off =  ($a->{m_data}) -  ($a->{m_ext}->{ext_buf});  &__rv =  &xm_mapin(( ($a->{m_xmemd})),  ($a->{m_ext}->{ext_buf}),  ($a->{m_ext}->{ext_size}), ( ($a->{m_ext}->{ext_buf})));  ($a->{m_flags}) |=  &M_MAPPED;  ($a->{m_data}) =  ($a->{m_ext}->{ext_buf}) +  &off; });
    }' unless defined(&M_PSEG_MAP);
    eval 'sub M_PSEG_UNMAP {
        my($a) = @_;
	    eval q({  &xm_det( ($a->{m_ext}->{ext_buf}), ( ($a->{m_xmemd})));  ($a->{m_flags}) &= ~ &M_MAPPED; });
    }' unless defined(&M_PSEG_UNMAP);
    eval 'sub M_DO_PSEG_MAP {
        my($a) = @_;
	    eval q({  &if (($a)-> &m_flags &  &M_PSEG) { \'struct mbuf\' * &nextp;  &nextp = $a;  &do {  &if ( &M_NEED_PSEG_MAP( &nextp)) {  &M_PSEG_MAP( &nextp); }  &nextp =  ($nextp->{m_next}); }  &while ( &nextp); } });
    }' unless defined(&M_DO_PSEG_MAP);
    eval 'sub M_DO_PSEG_UNMAP {
        my($a) = @_;
	    eval q({  &if (($a)-> &m_flags &  &M_PSEG) { \'struct mbuf\' * &nextp;  &nextp = $a;  &do {  &if ( &M_NEED_PSEG_UNMAP( &nextp)) {  &M_PSEG_UNMAP( &nextp); }  &nextp =  ($nextp->{m_next}); }  &while ( &nextp); } });
    }' unless defined(&M_DO_PSEG_UNMAP);
}
1;
