require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_NDD)) {
    eval 'sub _H_NDD () {1;}' unless defined(&_H_NDD);
    require 'sys/types.ph';
    require 'sys/lockl.ph';
    eval 'sub NDD_MAXNAMELEN () {(16);}' unless defined(&NDD_MAXNAMELEN);
    eval 'sub NDD_LOCK {
        my($nddp) = @_;
	    eval q( &lock_write(($nddp)-> &ndd_lock));
    }' unless defined(&NDD_LOCK);
    eval 'sub NDD_UNLOCK {
        my($nddp) = @_;
	    eval q( &lock_done(($nddp)-> &ndd_lock));
    }' unless defined(&NDD_UNLOCK);
    eval 'sub NDD_UP () {(0x1);}' unless defined(&NDD_UP);
    eval 'sub NDD_BROADCAST () {(0x2);}' unless defined(&NDD_BROADCAST);
    eval 'sub NDD_DEBUG () {(0x4);}' unless defined(&NDD_DEBUG);
    eval 'sub NDD_RUNNING () {(0x8);}' unless defined(&NDD_RUNNING);
    eval 'sub NDD_SIMPLEX () {(0x10);}' unless defined(&NDD_SIMPLEX);
    eval 'sub NDD_DEAD () {(0x20);}' unless defined(&NDD_DEAD);
    eval 'sub NDD_LIMBO () {(0x40);}' unless defined(&NDD_LIMBO);
    eval 'sub NDD_PROMISC () {(0x80);}' unless defined(&NDD_PROMISC);
    eval 'sub NDD_ALTADDRS () {(0x100);}' unless defined(&NDD_ALTADDRS);
    eval 'sub NDD_MULTICAST () {(0x200);}' unless defined(&NDD_MULTICAST);
    eval 'sub NDD_DETACHED () {(0x400);}' unless defined(&NDD_DETACHED);
    eval 'sub NDD_64BIT () {(0x800);}' unless defined(&NDD_64BIT);
    eval 'sub NDD_HIGHFUNC_QOS () {(0x1000);}' unless defined(&NDD_HIGHFUNC_QOS);
    eval 'sub NDD_MEDFUNC_QOS () {(0x2000);}' unless defined(&NDD_MEDFUNC_QOS);
    eval 'sub NDD_MINFUNC_QOS () {(0x4000);}' unless defined(&NDD_MINFUNC_QOS);
    eval 'sub NDD_QOS () {( &NDD_HIGHFUNC_QOS| &NDD_MEDFUNC_QOS| &NDD_MINFUNC_QOS);}' unless defined(&NDD_QOS);
    eval 'sub NDD_CHECKSUM_TCP () {(0x8000);}' unless defined(&NDD_CHECKSUM_TCP);
    eval 'sub NDD_CHECKSUM_OFFLOAD () {(0x10000);}' unless defined(&NDD_CHECKSUM_OFFLOAD);
    eval 'sub NDD_PSEG () {(0x20000);}' unless defined(&NDD_PSEG);
    eval 'sub NDD_ETHERCHANNEL () {(0x40000);}' unless defined(&NDD_ETHERCHANNEL);
    eval 'sub NDD_VLAN () {(0x80000);}' unless defined(&NDD_VLAN);
    eval 'sub NDD_SPECFLAGS () {(0x100000);}' unless defined(&NDD_SPECFLAGS);
    eval 'sub NDD_OTHER () {0x1;}' unless defined(&NDD_OTHER);
    eval 'sub NDD_1822 () {0x2;}' unless defined(&NDD_1822);
    eval 'sub NDD_HDH1822 () {0x3;}' unless defined(&NDD_HDH1822);
    eval 'sub NDD_X25DDN () {0x4;}' unless defined(&NDD_X25DDN);
    eval 'sub NDD_X25 () {0x5;}' unless defined(&NDD_X25);
    eval 'sub NDD_ETHER () {0x6;}' unless defined(&NDD_ETHER);
    eval 'sub NDD_ISO88023 () {0x7;}' unless defined(&NDD_ISO88023);
    eval 'sub NDD_ISO88024 () {0x8;}' unless defined(&NDD_ISO88024);
    eval 'sub NDD_ISO88025 () {0x9;}' unless defined(&NDD_ISO88025);
    eval 'sub NDD_ISO88026 () {0xa;}' unless defined(&NDD_ISO88026);
    eval 'sub NDD_STARLAN () {0xb;}' unless defined(&NDD_STARLAN);
    eval 'sub NDD_P10 () {0xc;}' unless defined(&NDD_P10);
    eval 'sub NDD_P80 () {0xd;}' unless defined(&NDD_P80);
    eval 'sub NDD_HY () {0xe;}' unless defined(&NDD_HY);
    eval 'sub NDD_FDDI () {0xf;}' unless defined(&NDD_FDDI);
    eval 'sub NDD_LAPB () {0x10;}' unless defined(&NDD_LAPB);
    eval 'sub NDD_SDLC () {0x11;}' unless defined(&NDD_SDLC);
    eval 'sub NDD_T1 () {0x12;}' unless defined(&NDD_T1);
    eval 'sub NDD_CEPT () {0x13;}' unless defined(&NDD_CEPT);
    eval 'sub NDD_ISDNBASIC () {0x14;}' unless defined(&NDD_ISDNBASIC);
    eval 'sub NDD_ISDNPRIMARY () {0x15;}' unless defined(&NDD_ISDNPRIMARY);
    eval 'sub NDD_PTPSERIAL () {0x16;}' unless defined(&NDD_PTPSERIAL);
    eval 'sub NDD_LOOP () {0x18;}' unless defined(&NDD_LOOP);
    eval 'sub NDD_EON () {0x19;}' unless defined(&NDD_EON);
    eval 'sub NDD_XETHER () {0x1a;}' unless defined(&NDD_XETHER);
    eval 'sub NDD_NSIP () {0x1b;}' unless defined(&NDD_NSIP);
    eval 'sub NDD_SLIP () {0x1c;}' unless defined(&NDD_SLIP);
    eval 'sub NDD_ATM () {0x20;}' unless defined(&NDD_ATM);
    eval 'sub NDD_HDLC () {0x21;}' unless defined(&NDD_HDLC);
    eval 'sub NDD_SCB () {0x127;}' unless defined(&NDD_SCB);
    eval 'sub NDD_FCS () {0x128;}' unless defined(&NDD_FCS);
    eval 'sub NDD_SCSI () {0x129;}' unless defined(&NDD_SCSI);
    eval 'sub NDD_HIPPI () {0x12a;}' unless defined(&NDD_HIPPI);
    eval 'sub NDD_GET_STATS () {(0x1);}' unless defined(&NDD_GET_STATS);
    eval 'sub NDD_ENABLE_MULTICAST () {(0x2);}' unless defined(&NDD_ENABLE_MULTICAST);
    eval 'sub NDD_DISABLE_MULTICAST () {(0x3);}' unless defined(&NDD_DISABLE_MULTICAST);
    eval 'sub NDD_PROMISCUOUS_ON () {(0x4);}' unless defined(&NDD_PROMISCUOUS_ON);
    eval 'sub NDD_PROMISCUOUS_OFF () {(0x5);}' unless defined(&NDD_PROMISCUOUS_OFF);
    eval 'sub NDD_ADD_FILTER () {(0x6);}' unless defined(&NDD_ADD_FILTER);
    eval 'sub NDD_DEL_FILTER () {(0x7);}' unless defined(&NDD_DEL_FILTER);
    eval 'sub NDD_MIB_QUERY () {(0x8);}' unless defined(&NDD_MIB_QUERY);
    eval 'sub NDD_MIB_GET () {(0x9);}' unless defined(&NDD_MIB_GET);
    eval 'sub NDD_MIB_SET () {(0xa);}' unless defined(&NDD_MIB_SET);
    eval 'sub NDD_ADD_STATUS () {(0xb);}' unless defined(&NDD_ADD_STATUS);
    eval 'sub NDD_DEL_STATUS () {(0xc);}' unless defined(&NDD_DEL_STATUS);
    eval 'sub NDD_ENABLE_ADDRESS () {(0xd);}' unless defined(&NDD_ENABLE_ADDRESS);
    eval 'sub NDD_DISABLE_ADDRESS () {(0xe);}' unless defined(&NDD_DISABLE_ADDRESS);
    eval 'sub NDD_MIB_ADDR () {(0xf);}' unless defined(&NDD_MIB_ADDR);
    eval 'sub NDD_CLEAR_STATS () {(0x10);}' unless defined(&NDD_CLEAR_STATS);
    eval 'sub NDD_DUMP_ADDR () {(0x100);}' unless defined(&NDD_DUMP_ADDR);
    eval 'sub NDD_PRIORITY_ADDR () {(0x101);}' unless defined(&NDD_PRIORITY_ADDR);
    eval 'sub NDD_GET_ALL_STATS () {(0x102);}' unless defined(&NDD_GET_ALL_STATS);
    eval 'sub NDD_DEBUG_TRACE () {(0x103);}' unless defined(&NDD_DEBUG_TRACE);
    eval 'sub NDD_SET_LINK_STATUS () {(0x104);}' unless defined(&NDD_SET_LINK_STATUS);
    eval 'sub NDD_ENABLE_ADAPTER () {(0x105);}' unless defined(&NDD_ENABLE_ADAPTER);
    eval 'sub NDD_DISABLE_ADAPTER () {(0x106);}' unless defined(&NDD_DISABLE_ADAPTER);
    eval 'sub NDD_QUERY_IPSEC_OFFLOAD () {(0x107);}' unless defined(&NDD_QUERY_IPSEC_OFFLOAD);
    eval 'sub NDD_ADD_SA_CACHE () {(0x108);}' unless defined(&NDD_ADD_SA_CACHE);
    eval 'sub NDD_DELETE_SA_CACHE () {(0x109);}' unless defined(&NDD_DELETE_SA_CACHE);
    eval 'sub NDD_MODIFY_SA_CACHE () {(0x10a);}' unless defined(&NDD_MODIFY_SA_CACHE);
    eval 'sub NDD_CLEAR_ALL_SA_CACHE () {(0x10b);}' unless defined(&NDD_CLEAR_ALL_SA_CACHE);
    eval 'sub NDD_IPSEC_REGISTER () {(0x10c);}' unless defined(&NDD_IPSEC_REGISTER);
    eval 'sub NDD_IPSEC_UNREGISTER () {(0x10d);}' unless defined(&NDD_IPSEC_UNREGISTER);
    eval 'sub NDD_NOTIFY_UNCONFIGURE () {1;}' unless defined(&NDD_NOTIFY_UNCONFIGURE);
    eval 'sub NDD_STOP_TRACE () {(0x10e);}' unless defined(&NDD_STOP_TRACE);
    eval 'sub NDD_DEVICE_SPECIFIC () {(0x10000);}' unless defined(&NDD_DEVICE_SPECIFIC);
    eval 'sub NDD_LS_DOWN () {(0);}' unless defined(&NDD_LS_DOWN);
    eval 'sub NDD_LS_UP () {(1);}' unless defined(&NDD_LS_UP);
    eval 'sub NDD_LS_ENABLING () {(2);}' unless defined(&NDD_LS_ENABLING);
    eval 'sub MIB_NOT_SUPPORTED () {(0x);}' unless defined(&MIB_NOT_SUPPORTED);
    eval 'sub MIB_READ_ONLY () {(0x1);}' unless defined(&MIB_READ_ONLY);
    eval 'sub MIB_READ_WRITE () {(0x2);}' unless defined(&MIB_READ_WRITE);
    eval 'sub MIB_WRITE_ONLY () {(0x3);}' unless defined(&MIB_WRITE_ONLY);
    eval 'sub MIB_OK () {0;}' unless defined(&MIB_OK);
    eval 'sub MIB_NOT_SETTABLE () {1;}' unless defined(&MIB_NOT_SETTABLE);
    eval 'sub MIB_WRONG_STATE () {2;}' unless defined(&MIB_WRONG_STATE);
    eval 'sub MIB_FAILED () {3;}' unless defined(&MIB_FAILED);
    eval 'sub MIB_BAD_VALUE () {4;}' unless defined(&MIB_BAD_VALUE);
    eval 'sub NDD_MIB_OTHER () {1;}' unless defined(&NDD_MIB_OTHER);
    eval 'sub NDD_MIB_INVALID () {2;}' unless defined(&NDD_MIB_INVALID);
    eval 'sub NDD_MIB_VOLATILE () {3;}' unless defined(&NDD_MIB_VOLATILE);
    eval 'sub NDD_MIB_NONVOLATILE () {4;}' unless defined(&NDD_MIB_NONVOLATILE);
    eval 'sub NDD_HARD_FAIL () {(0x1);}' unless defined(&NDD_HARD_FAIL);
    eval 'sub NDD_LIMBO_ENTER () {(0x2);}' unless defined(&NDD_LIMBO_ENTER);
    eval 'sub NDD_LIMBO_EXIT () {(0x4);}' unless defined(&NDD_LIMBO_EXIT);
    eval 'sub NDD_CONNECTED () {(0x8);}' unless defined(&NDD_CONNECTED);
    eval 'sub NDD_STATUS () {(0x10);}' unless defined(&NDD_STATUS);
    eval 'sub NDD_BAD_PKTS () {(0x20);}' unless defined(&NDD_BAD_PKTS);
    eval 'sub NDD_STAT_BLOCK () {(0x100000);}' unless defined(&NDD_STAT_BLOCK);
    eval 'sub NDD_ADAP_CHECK () {(0x1);}' unless defined(&NDD_ADAP_CHECK);
    eval 'sub NDD_BUS_ERROR () {(0x2);}' unless defined(&NDD_BUS_ERROR);
    eval 'sub NDD_CMD_FAIL () {(0x3);}' unless defined(&NDD_CMD_FAIL);
    eval 'sub NDD_PIO_FAIL () {(0x4);}' unless defined(&NDD_PIO_FAIL);
    eval 'sub NDD_UCODE_FAIL () {(0x5);}' unless defined(&NDD_UCODE_FAIL);
    eval 'sub NDD_TX_ERROR () {(0x6);}' unless defined(&NDD_TX_ERROR);
    eval 'sub NDD_TX_TIMEOUT () {(0x7);}' unless defined(&NDD_TX_TIMEOUT);
    eval 'sub NDD_RCV_ERROR () {(0x8);}' unless defined(&NDD_RCV_ERROR);
    eval 'sub NDD_AUTO_RMV () {(0x9);}' unless defined(&NDD_AUTO_RMV);
    eval 'sub NDD_REASON_CODE () {(0x100);}' unless defined(&NDD_REASON_CODE);
    if(defined(&__64BIT_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub ndd_spec_ks () { $ndd_reserved[0];}' unless defined(&ndd_spec_ks);
    eval 'sub ndd_spec_conf () { $ndd_reserved[1];}' unless defined(&ndd_spec_conf);
}
1;
