require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PFIOCSETF)) {
    sub PFIOCSETF () {	((ord('P')) << 8| 1);}
}
unless(defined(&MAXFILTERS)) {
    sub MAXFILTERS () {	255;}
}
unless(defined(&PF_CMD)) {
    sub PF_CMD {
	my($x) = @_;
	eval q(($x & 0x7000));
    }
}
unless(defined(&PF_OP)) {
    sub PF_OP {
	my($x) = @_;
	eval q(($x & 0xf00));
    }
}
unless(defined(&PF_ARG)) {
    sub PF_ARG {
	my($x) = @_;
	eval q(($x & 0xff));
    }
}
unless(defined(&PF_NOPUSH)) {
    sub PF_NOPUSH () {	0x;}
}
unless(defined(&PF_PUSHLIT)) {
    sub PF_PUSHLIT () {	0x1000;}
}
unless(defined(&PF_PUSHZERO)) {
    sub PF_PUSHZERO () {	0x2000;}
}
unless(defined(&PF_PUSHONE)) {
    sub PF_PUSHONE () {	0x3000;}
}
unless(defined(&PF_PUSHFFFF)) {
    sub PF_PUSHFFFF () {	0x4000;}
}
unless(defined(&PF_PUSHFF00)) {
    sub PF_PUSHFF00 () {	0x5000;}
}
unless(defined(&PF_PUSH00FF)) {
    sub PF_PUSH00FF () {	0x6000;}
}
unless(defined(&PF_PUSHWORD)) {
    sub PF_PUSHWORD () {	0x7000;}
}
unless(defined(&PF_NOP)) {
    sub PF_NOP () {	0x;}
}
unless(defined(&PF_EQ)) {
    sub PF_EQ () {	0x100;}
}
unless(defined(&PF_NEQ)) {
    sub PF_NEQ () {	0x200;}
}
unless(defined(&PF_LT)) {
    sub PF_LT () {	0x300;}
}
unless(defined(&PF_LE)) {
    sub PF_LE () {	0x400;}
}
unless(defined(&PF_GT)) {
    sub PF_GT () {	0x500;}
}
unless(defined(&PF_GE)) {
    sub PF_GE () {	0x600;}
}
unless(defined(&PF_AND)) {
    sub PF_AND () {	0x700;}
}
unless(defined(&PF_OR)) {
    sub PF_OR () {	0x800;}
}
unless(defined(&PF_XOR)) {
    sub PF_XOR () {	0x900;}
}
unless(defined(&PF_COR)) {
    sub PF_COR () {	0xa00;}
}
unless(defined(&PF_CNOR)) {
    sub PF_CNOR () {	0xb00;}
}
unless(defined(&PF_CAND)) {
    sub PF_CAND () {	0xc00;}
}
unless(defined(&PF_CNAND)) {
    sub PF_CNAND () {	0xd00;}
}
if(defined(&_SUN)) {
    eval 'sub ENMAXFILTERS () { &MAXFILTERS;}' unless defined(&ENMAXFILTERS);
    eval 'sub ENF_NOPUSH () { &PF_NOPUSH;}' unless defined(&ENF_NOPUSH);
    eval 'sub ENF_PUSHLIT () { &PF_PUSHLIT;}' unless defined(&ENF_PUSHLIT);
    eval 'sub ENF_PUSHZERO () { &PF_PUSHZERO;}' unless defined(&ENF_PUSHZERO);
    eval 'sub ENF_PUSHONE () { &PF_PUSHONE;}' unless defined(&ENF_PUSHONE);
    eval 'sub ENF_PUSHFFFF () { &PF_PUSHFFFF;}' unless defined(&ENF_PUSHFFFF);
    eval 'sub ENF_PUSHFF00 () { &PF_PUSHFF00;}' unless defined(&ENF_PUSHFF00);
    eval 'sub ENF_PUSH00FF () { &PF_PUSH00FF;}' unless defined(&ENF_PUSH00FF);
    eval 'sub ENF_PUSHWORD () { &PF_PUSHWORD;}' unless defined(&ENF_PUSHWORD);
    eval 'sub ENF_NOP () { &PF_NOP;}' unless defined(&ENF_NOP);
    eval 'sub ENF_EQ () { &PF_EQ;}' unless defined(&ENF_EQ);
    eval 'sub ENF_NEQ () { &PF_NEQ;}' unless defined(&ENF_NEQ);
    eval 'sub ENF_LT () { &PF_LT;}' unless defined(&ENF_LT);
    eval 'sub ENF_LE () { &PF_LE;}' unless defined(&ENF_LE);
    eval 'sub ENF_GT () { &PF_GT;}' unless defined(&ENF_GT);
    eval 'sub ENF_GE () { &PF_GE;}' unless defined(&ENF_GE);
    eval 'sub ENF_AND () { &PF_AND;}' unless defined(&ENF_AND);
    eval 'sub ENF_OR () { &PF_OR;}' unless defined(&ENF_OR);
    eval 'sub ENF_XOR () { &PF_XOR;}' unless defined(&ENF_XOR);
    eval 'sub ENF_COR () { &PF_COR;}' unless defined(&ENF_COR);
    eval 'sub ENF_CNOR () { &PF_CNOR;}' unless defined(&ENF_CNOR);
    eval 'sub ENF_CAND () { &PF_CAND;}' unless defined(&ENF_CAND);
    eval 'sub ENF_CNAND () { &PF_CNAND;}' unless defined(&ENF_CNAND);
}
1;
