require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_INC_PMDEV)) {
    eval 'sub _INC_PMDEV () {1;}' unless defined(&_INC_PMDEV);
    eval 'sub PM_SUCCESS () {0;}' unless defined(&PM_SUCCESS);
    eval 'sub PM_ERROR () {-1;}' unless defined(&PM_ERROR);
    require 'sys/time.ph';
    eval 'sub PM_ACTIVITY_NOT_SET () {-1;}' unless defined(&PM_ACTIVITY_NOT_SET);
    eval 'sub PM_NO_ACTIVITY () {0;}' unless defined(&PM_NO_ACTIVITY);
    eval 'sub PM_ACTIVITY_OCCURRED () {1;}' unless defined(&PM_ACTIVITY_OCCURRED);
    eval 'sub PM_PHASE1_SUPPORT_ONLY () {0x;}' unless defined(&PM_PHASE1_SUPPORT_ONLY);
    eval 'sub PM_PHASE2_SUPPORT () {0x100;}' unless defined(&PM_PHASE2_SUPPORT);
    eval 'sub PM_DEVICE_FULL_ON () {0x;}' unless defined(&PM_DEVICE_FULL_ON);
    eval 'sub PM_DEVICE_ENABLE () {0x100;}' unless defined(&PM_DEVICE_ENABLE);
    eval 'sub PM_DEVICE_DPMS_STANDBY () {0x201;}' unless defined(&PM_DEVICE_DPMS_STANDBY);
    eval 'sub PM_DEVICE_DPMS_SUSPEND () {0x202;}' unless defined(&PM_DEVICE_DPMS_SUSPEND);
    eval 'sub PM_DEVICE_DPMS_OFF () {0x200;}' unless defined(&PM_DEVICE_DPMS_OFF);
    eval 'sub PM_DEVICE_IDLE () {0x200;}' unless defined(&PM_DEVICE_IDLE);
    eval 'sub PM_DEVICE_SUSPEND () {0x400;}' unless defined(&PM_DEVICE_SUSPEND);
    eval 'sub PM_DEVICE_HIBERNATION () {0x800;}' unless defined(&PM_DEVICE_HIBERNATION);
    eval 'sub PM_DEVICE_RESUME () {0x80000000;}' unless defined(&PM_DEVICE_RESUME);
    eval 'sub PM_PAGE_FREEZE_NOTICE () {0x1000;}' unless defined(&PM_PAGE_FREEZE_NOTICE);
    eval 'sub PM_PAGE_UNFREEZE_NOTICE () {0x2000;}' unless defined(&PM_PAGE_UNFREEZE_NOTICE);
    eval 'sub PM_RING_RESUME_ENABLE_NOTICE () {0x4000;}' unless defined(&PM_RING_RESUME_ENABLE_NOTICE);
    eval 'sub PM_GRAPHICAL_INPUT () {0x10000;}' unless defined(&PM_GRAPHICAL_INPUT);
    eval 'sub PM_GRAPHICAL_OUTPUT () {0x20000;}' unless defined(&PM_GRAPHICAL_OUTPUT);
    eval 'sub PM_OTHER_DEVICE () {0x40000;}' unless defined(&PM_OTHER_DEVICE);
    eval 'sub PM_AUDIO_INPUT () {0x80000;}' unless defined(&PM_AUDIO_INPUT);
    eval 'sub PM_AUDIO_OUTPUT () {0x100000;}' unless defined(&PM_AUDIO_OUTPUT);
    eval 'sub PM_RING_RESUME_SUPPORT () {0x200000;}' unless defined(&PM_RING_RESUME_SUPPORT);
    eval 'sub PM_REMOTE_TERMINAL () {0x400000;}' unless defined(&PM_REMOTE_TERMINAL);
    eval 'sub PM_REGISTER () {1;}' unless defined(&PM_REGISTER);
    eval 'sub PM_UNREGISTER () {2;}' unless defined(&PM_UNREGISTER);
    eval 'sub PM_PLANAR_QUERY () {0x10000;}' unless defined(&PM_PLANAR_QUERY);
    eval 'sub PM_PLANAR_ON () {0x20000;}' unless defined(&PM_PLANAR_ON);
    eval 'sub PM_PLANAR_OFF () {0x40000;}' unless defined(&PM_PLANAR_OFF);
    eval 'sub PM_PLANAR_LOWPOWER1 () {0x80000;}' unless defined(&PM_PLANAR_LOWPOWER1);
    eval 'sub PM_PLANAR_LOWPOWER2 () {0x100000;}' unless defined(&PM_PLANAR_LOWPOWER2);
    eval 'sub PM_PLANAR_CURRENT_LEVEL () {0x80000000;}' unless defined(&PM_PLANAR_CURRENT_LEVEL);
    unless(defined(&__ia64)) {
    }
    eval 'sub PM_DUMP () {0x1000;}' unless defined(&PM_DUMP);
    eval 'sub PMDEV_MAJOR_NUMBER () {0x80000000;}' unless defined(&PMDEV_MAJOR_NUMBER);
    eval 'sub PMDEV_MAJOR_MASK () {0x7fff0000;}' unless defined(&PMDEV_MAJOR_MASK);
    eval 'sub PMDEV_MINOR_MASK () {0xffff;}' unless defined(&PMDEV_MINOR_MASK);
    eval 'sub PMDEV_LCD () {0x10000;}' unless defined(&PMDEV_LCD);
    eval 'sub PMDEV_CRT () {0x10100;}' unless defined(&PMDEV_CRT);
    eval 'sub PMDEV_GCC () {0x20000;}' unless defined(&PMDEV_GCC);
    eval 'sub PMDEV_DAC () {0x20100;}' unless defined(&PMDEV_DAC);
    eval 'sub PMDEV_VRAM () {0x20200;}' unless defined(&PMDEV_VRAM);
    eval 'sub PMDEV_VCAP () {0x30000;}' unless defined(&PMDEV_VCAP);
    eval 'sub PMDEV_VPLAY () {0x30100;}' unless defined(&PMDEV_VPLAY);
    eval 'sub PMDEV_CAMERA () {0x30200;}' unless defined(&PMDEV_CAMERA);
    eval 'sub PMDEV_AUDIO () {0x30300;}' unless defined(&PMDEV_AUDIO);
    eval 'sub PMDEV_AUDIO_EXT_MUTE () {0x30310;}' unless defined(&PMDEV_AUDIO_EXT_MUTE);
    eval 'sub PMDEV_INTKBD () {0x40000;}' unless defined(&PMDEV_INTKBD);
    eval 'sub PMDEV_EXTKBD () {0x40100;}' unless defined(&PMDEV_EXTKBD);
    eval 'sub PMDEV_INTMOUSE () {0x40200;}' unless defined(&PMDEV_INTMOUSE);
    eval 'sub PMDEV_EXTMOUSE () {0x40300;}' unless defined(&PMDEV_EXTMOUSE);
    eval 'sub PMDEV_TABLET () {0x40400;}' unless defined(&PMDEV_TABLET);
    eval 'sub PMDEV_SERIAL1 () {0x50001;}' unless defined(&PMDEV_SERIAL1);
    eval 'sub PMDEV_SERIAL2 () {0x50002;}' unless defined(&PMDEV_SERIAL2);
    eval 'sub PMDEV_SERIAL3 () {0x50003;}' unless defined(&PMDEV_SERIAL3);
    eval 'sub PMDEV_SERIAL4 () {0x50004;}' unless defined(&PMDEV_SERIAL4);
    eval 'sub PMDEV_PARALLEL () {0x50100;}' unless defined(&PMDEV_PARALLEL);
    eval 'sub PMDEV_FDC () {0x60000;}' unless defined(&PMDEV_FDC);
    eval 'sub PMDEV_CPU () {0x90000;}' unless defined(&PMDEV_CPU);
    eval 'sub PMDEV_L2 () {0x90100;}' unless defined(&PMDEV_L2);
    eval 'sub PMDEV_LOCAL2 () {0x90200;}' unless defined(&PMDEV_LOCAL2);
    eval 'sub PMDEV_PSUSUS () {0xb0000;}' unless defined(&PMDEV_PSUSUS);
    eval 'sub PMDEV_PSUMAIN () {0xb0100;}' unless defined(&PMDEV_PSUMAIN);
    eval 'sub PMDEV_PCMCIA00 () {0xc0000;}' unless defined(&PMDEV_PCMCIA00);
    eval 'sub PMDEV_PCI0000 () {0xd0000;}' unless defined(&PMDEV_PCI0000);
    eval 'sub PMDEV_ISA_base () {0xe0000;}' unless defined(&PMDEV_ISA_base);
    eval 'sub PMDEV_ISA00 () {0xe0000;}' unless defined(&PMDEV_ISA00);
    eval 'sub PMDEV_CDROM () {0xf0100;}' unless defined(&PMDEV_CDROM);
    eval 'sub PMDEV_UNKNOWN_SCSI () {0x100000;}' unless defined(&PMDEV_UNKNOWN_SCSI);
    eval 'sub PMDEV_UNKNOWN_IDE () {0x110000;}' unless defined(&PMDEV_UNKNOWN_IDE);
    eval 'sub PMDEV_UNKNOWN_OTHER () {0x120000;}' unless defined(&PMDEV_UNKNOWN_OTHER);
    eval 'sub PMDEV_INTERNAL_SCSI () {0x180000;}' unless defined(&PMDEV_INTERNAL_SCSI);
    eval 'sub PMDEV_INTERNAL_IDE () {0x190000;}' unless defined(&PMDEV_INTERNAL_IDE);
    eval 'sub PMDEV_INTERNAL_OTHER () {0x1a0000;}' unless defined(&PMDEV_INTERNAL_OTHER);
}
1;
