require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_PTRACE)) {
    eval 'sub _H_PTRACE () {1;}' unless defined(&_H_PTRACE);
    require 'sys/thread.ph';
    eval 'sub PT_TRACE_ME () {0;}' unless defined(&PT_TRACE_ME);
    eval 'sub PT_READ_I () {1;}' unless defined(&PT_READ_I);
    eval 'sub PT_READ_D () {2;}' unless defined(&PT_READ_D);
    eval 'sub PT_WRITE_I () {4;}' unless defined(&PT_WRITE_I);
    eval 'sub PT_WRITE_D () {5;}' unless defined(&PT_WRITE_D);
    eval 'sub PT_CONTINUE () {7;}' unless defined(&PT_CONTINUE);
    eval 'sub PT_KILL () {8;}' unless defined(&PT_KILL);
    eval 'sub PT_STEP () {9;}' unless defined(&PT_STEP);
    eval 'sub PT_READ_GPR () {11;}' unless defined(&PT_READ_GPR);
    eval 'sub PT_READ_FPR () {12;}' unless defined(&PT_READ_FPR);
    eval 'sub PT_WRITE_GPR () {14;}' unless defined(&PT_WRITE_GPR);
    eval 'sub PT_WRITE_FPR () {15;}' unless defined(&PT_WRITE_FPR);
    eval 'sub PT_READ_BLOCK () {17;}' unless defined(&PT_READ_BLOCK);
    eval 'sub PT_WRITE_BLOCK () {19;}' unless defined(&PT_WRITE_BLOCK);
    eval 'sub PT_ATTACH () {30;}' unless defined(&PT_ATTACH);
    eval 'sub PT_DETACH () {31;}' unless defined(&PT_DETACH);
    eval 'sub PT_REGSET () {32;}' unless defined(&PT_REGSET);
    eval 'sub PT_REATT () {33;}' unless defined(&PT_REATT);
    eval 'sub PT_LDINFO () {34;}' unless defined(&PT_LDINFO);
    eval 'sub PT_MULTI () {35;}' unless defined(&PT_MULTI);
    eval 'sub PT_NEXT () {36;}' unless defined(&PT_NEXT);
    eval 'sub PT_SET () {37;}' unless defined(&PT_SET);
    eval 'sub PT_CLEAR () {38;}' unless defined(&PT_CLEAR);
    eval 'sub PT_QUERY () {40;}' unless defined(&PT_QUERY);
    eval 'sub PT_WATCH () {41;}' unless defined(&PT_WATCH);
    eval 'sub PTT_CONTINUE () {50;}' unless defined(&PTT_CONTINUE);
    eval 'sub PTT_STEP () {51;}' unless defined(&PTT_STEP);
    eval 'sub PTT_READ_SPRS () {52;}' unless defined(&PTT_READ_SPRS);
    eval 'sub PTT_WRITE_SPRS () {53;}' unless defined(&PTT_WRITE_SPRS);
    eval 'sub PTT_READ_GPRS () {54;}' unless defined(&PTT_READ_GPRS);
    eval 'sub PTT_WRITE_GPRS () {55;}' unless defined(&PTT_WRITE_GPRS);
    eval 'sub PTT_READ_FPRS () {56;}' unless defined(&PTT_READ_FPRS);
    eval 'sub PTT_WRITE_FPRS () {57;}' unless defined(&PTT_WRITE_FPRS);
    eval 'sub IPCDATA () {1024;}' unless defined(&IPCDATA);
    eval 'sub PTFLAG_FAST_TRAP () {0x1;}' unless defined(&PTFLAG_FAST_TRAP);
    eval 'sub _FASTTRAP_OP () {0xddf8000;}' unless defined(&_FASTTRAP_OP);
    eval 'sub _FASTTRAP_OP_MASK () {0xffff8000;}' unless defined(&_FASTTRAP_OP_MASK);
    eval 'sub _FASTTRAP_NUM () {0x7fff;}' unless defined(&_FASTTRAP_NUM);
    if(defined(&_NO_PROTO)) {
    } else {
	if(defined(&__64BIT__)) {
	} else {
	}
    }
    unless(defined(&__64BIT__)) {
    }
    eval 'sub _WP_STYLE_ANY () {1;}' unless defined(&_WP_STYLE_ANY);
    eval 'sub _WP_STYLE_HARDWARE () {2;}' unless defined(&_WP_STYLE_HARDWARE);
    eval 'sub _WP_STYLE_HARDWARE1 () {3;}' unless defined(&_WP_STYLE_HARDWARE1);
    eval 'sub _WP_STYLE_HARDWARE_LAST () {127;}' unless defined(&_WP_STYLE_HARDWARE_LAST);
    eval 'sub _WP_STYLE_SOFTWARE () {128;}' unless defined(&_WP_STYLE_SOFTWARE);
    eval 'sub _WP_STYLE_SOFTWARE1 () {129;}' unless defined(&_WP_STYLE_SOFTWARE1);
    eval 'sub _WP_STYLE_SOFTWARE_LAST () {255;}' unless defined(&_WP_STYLE_SOFTWARE_LAST);
    if(defined(&_KERNEL)) {
	eval 'sub OLD_MAXTHREADS () {512;}' unless defined(&OLD_MAXTHREADS);
	eval 'sub OLD_PTTHREADS_SIZE () {($sizeof{ &tid32_t}* &OLD_MAXTHREADS);}' unless defined(&OLD_PTTHREADS_SIZE);
	eval 'sub IPCBSZ () {($sizeof{\'double\'});}' unless defined(&IPCBSZ);
	eval 'sub LARGEBLKSIZE () {($sizeof{\'struct ptthreads\'}+2*$sizeof{ &tid_t});}' unless defined(&LARGEBLKSIZE);
	eval 'sub SMALLBLKSIZE () {(( &OLD_MAXTHREADS+2)*$sizeof{ &tid_t});}' unless defined(&SMALLBLKSIZE);
	eval 'sub MAXLDINFO () {(128*1024);}' unless defined(&MAXLDINFO);
	unless(defined(&__64BIT_KERNEL)) {
	}
	eval 'sub IPCBUSY () {0x1;}' unless defined(&IPCBUSY);
	eval 'sub IPCWANTED () {0x2;}' unless defined(&IPCWANTED);
	eval 'sub IPCPTRACE () {0x4;}' unless defined(&IPCPTRACE);
	eval 'sub IPCBLKDATA () {0x8;}' unless defined(&IPCBLKDATA);
	eval 'sub IPCBLKLARGE () {0x10;}' unless defined(&IPCBLKLARGE);
    }
    eval("sub PTRACE_TRACEME () { 0; }") unless defined(&PTRACE_TRACEME);
    eval("sub PTRACE_PEEKTEXT () { 1; }") unless defined(&PTRACE_PEEKTEXT);
    eval("sub PTRACE_PEEKDATA () { 2; }") unless defined(&PTRACE_PEEKDATA);
    eval("sub PTRACE_PEEKUSER () { 3; }") unless defined(&PTRACE_PEEKUSER);
    eval("sub PTRACE_POKETEXT () { 4; }") unless defined(&PTRACE_POKETEXT);
    eval("sub PTRACE_POKEDATA () { 5; }") unless defined(&PTRACE_POKEDATA);
    eval("sub PTRACE_POKEUSER () { 6; }") unless defined(&PTRACE_POKEUSER);
    eval("sub PTRACE_CONT () { 7; }") unless defined(&PTRACE_CONT);
    eval("sub PTRACE_KILL () { 8; }") unless defined(&PTRACE_KILL);
    eval("sub PTRACE_SINGLESTEP () { 9; }") unless defined(&PTRACE_SINGLESTEP);
    eval("sub PTRACE_GETREGS () { 10; }") unless defined(&PTRACE_GETREGS);
    eval("sub PTRACE_SETREGS () { 11; }") unless defined(&PTRACE_SETREGS);
    eval("sub PTRACE_GETFPREGS () { 12; }") unless defined(&PTRACE_GETFPREGS);
    eval("sub PTRACE_SETFPREGS () { 13; }") unless defined(&PTRACE_SETFPREGS);
    eval("sub PTRACE_ATTACH () { 14; }") unless defined(&PTRACE_ATTACH);
    eval("sub PTRACE_DETACH () { 15; }") unless defined(&PTRACE_DETACH);
    eval("sub PTRACE_SYSCALL () { 16; }") unless defined(&PTRACE_SYSCALL);
    if(defined(&_LINUX_SOURCE_COMPAT)) {
	undef(&PT_TRACE_ME) if defined(&PT_TRACE_ME);
	eval 'sub PT_TRACE_ME () { &PTRACE_TRACEME;}' unless defined(&PT_TRACE_ME);
	undef(&PT_READ_I) if defined(&PT_READ_I);
	eval 'sub PT_READ_I () { &PTRACE_PEEKTEXT;}' unless defined(&PT_READ_I);
	undef(&PT_READ_D) if defined(&PT_READ_D);
	eval 'sub PT_READ_D () { &PTRACE_PEEKDATA;}' unless defined(&PT_READ_D);
	eval 'sub PT_READ_U () { &PTRACE_PEEKUSER;}' unless defined(&PT_READ_U);
	undef(&PT_WRITE_I) if defined(&PT_WRITE_I);
	eval 'sub PT_WRITE_I () { &PTRACE_POKETEXT;}' unless defined(&PT_WRITE_I);
	undef(&PT_WRITE_D) if defined(&PT_WRITE_D);
	eval 'sub PT_WRITE_D () { &PTRACE_POKEDATA;}' unless defined(&PT_WRITE_D);
	eval 'sub PT_WRITE_U () { &PTRACE_POKEUSER;}' unless defined(&PT_WRITE_U);
	undef(&PT_CONTINUE) if defined(&PT_CONTINUE);
	eval 'sub PT_CONTINUE () { &PTRACE_CONT;}' unless defined(&PT_CONTINUE);
	undef(&PT_KILL) if defined(&PT_KILL);
	eval 'sub PT_KILL () { &PTRACE_KILL;}' unless defined(&PT_KILL);
	undef(&PT_STEP) if defined(&PT_STEP);
	eval 'sub PT_STEP () { &PTRACE_SINGLESTEP;}' unless defined(&PT_STEP);
	eval 'sub PT_GETREGS () { &PTRACE_GETREGS;}' unless defined(&PT_GETREGS);
	eval 'sub PT_SETREGS () { &PTRACE_SETREGS;}' unless defined(&PT_SETREGS);
	eval 'sub PT_GETFPREGS () { &PTRACE_GETFPREGS;}' unless defined(&PT_GETFPREGS);
	eval 'sub PT_SETFPREGS () { &PTRACE_SETFPREGS;}' unless defined(&PT_SETFPREGS);
	undef(&PT_ATTACH) if defined(&PT_ATTACH);
	eval 'sub PT_ATTACH () { &PTRACE_ATTACH;}' unless defined(&PT_ATTACH);
	undef(&PT_DETACH) if defined(&PT_DETACH);
	eval 'sub PT_DETACH () { &PTRACE_DETACH;}' unless defined(&PT_DETACH);
	eval 'sub ptrace {
	    my($a, $b, $c, $d) = @_;
    	    eval q( &__linux_ptrace(($a), ($b), ($c), ($d)));
	}' unless defined(&ptrace);
    }
}
1;
