require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_REG)) {
    eval 'sub _H_REG () {1;}' unless defined(&_H_REG);
    eval 'sub GPR0 () {0;}' unless defined(&GPR0);
    eval 'sub GPR1 () {1;}' unless defined(&GPR1);
    eval 'sub GPR2 () {2;}' unless defined(&GPR2);
    eval 'sub GPR3 () {3;}' unless defined(&GPR3);
    eval 'sub GPR4 () {4;}' unless defined(&GPR4);
    eval 'sub GPR5 () {5;}' unless defined(&GPR5);
    eval 'sub GPR6 () {6;}' unless defined(&GPR6);
    eval 'sub GPR7 () {7;}' unless defined(&GPR7);
    eval 'sub GPR8 () {8;}' unless defined(&GPR8);
    eval 'sub GPR9 () {9;}' unless defined(&GPR9);
    eval 'sub GPR10 () {10;}' unless defined(&GPR10);
    eval 'sub GPR11 () {11;}' unless defined(&GPR11);
    eval 'sub GPR12 () {12;}' unless defined(&GPR12);
    eval 'sub GPR13 () {13;}' unless defined(&GPR13);
    eval 'sub GPR14 () {14;}' unless defined(&GPR14);
    eval 'sub GPR15 () {15;}' unless defined(&GPR15);
    eval 'sub GPR16 () {16;}' unless defined(&GPR16);
    eval 'sub GPR17 () {17;}' unless defined(&GPR17);
    eval 'sub GPR18 () {18;}' unless defined(&GPR18);
    eval 'sub GPR19 () {19;}' unless defined(&GPR19);
    eval 'sub GPR20 () {20;}' unless defined(&GPR20);
    eval 'sub GPR21 () {21;}' unless defined(&GPR21);
    eval 'sub GPR22 () {22;}' unless defined(&GPR22);
    eval 'sub GPR23 () {23;}' unless defined(&GPR23);
    eval 'sub GPR24 () {24;}' unless defined(&GPR24);
    eval 'sub GPR25 () {25;}' unless defined(&GPR25);
    eval 'sub GPR26 () {26;}' unless defined(&GPR26);
    eval 'sub GPR27 () {27;}' unless defined(&GPR27);
    eval 'sub GPR28 () {28;}' unless defined(&GPR28);
    eval 'sub GPR29 () {29;}' unless defined(&GPR29);
    eval 'sub GPR30 () {30;}' unless defined(&GPR30);
    eval 'sub GPR31 () {31;}' unless defined(&GPR31);
    eval 'sub IAR () {128;}' unless defined(&IAR);
    eval 'sub MSR () {129;}' unless defined(&MSR);
    eval 'sub CR () {130;}' unless defined(&CR);
    eval 'sub LR () {131;}' unless defined(&LR);
    eval 'sub CTR () {132;}' unless defined(&CTR);
    eval 'sub XER () {133;}' unless defined(&XER);
    eval 'sub MQ () {134;}' unless defined(&MQ);
    eval 'sub TID () {135;}' unless defined(&TID);
    eval 'sub FPSCR () {136;}' unless defined(&FPSCR);
    eval 'sub FPINFO () {138;}' unless defined(&FPINFO);
    eval 'sub FPSCRX () {148;}' unless defined(&FPSCRX);
    eval 'sub FPR0 () {256;}' unless defined(&FPR0);
    eval 'sub FPR1 () {257;}' unless defined(&FPR1);
    eval 'sub FPR2 () {258;}' unless defined(&FPR2);
    eval 'sub FPR3 () {259;}' unless defined(&FPR3);
    eval 'sub FPR4 () {260;}' unless defined(&FPR4);
    eval 'sub FPR5 () {261;}' unless defined(&FPR5);
    eval 'sub FPR6 () {262;}' unless defined(&FPR6);
    eval 'sub FPR7 () {263;}' unless defined(&FPR7);
    eval 'sub FPR8 () {264;}' unless defined(&FPR8);
    eval 'sub FPR9 () {265;}' unless defined(&FPR9);
    eval 'sub FPR10 () {266;}' unless defined(&FPR10);
    eval 'sub FPR11 () {267;}' unless defined(&FPR11);
    eval 'sub FPR12 () {268;}' unless defined(&FPR12);
    eval 'sub FPR13 () {269;}' unless defined(&FPR13);
    eval 'sub FPR14 () {270;}' unless defined(&FPR14);
    eval 'sub FPR15 () {271;}' unless defined(&FPR15);
    eval 'sub FPR16 () {272;}' unless defined(&FPR16);
    eval 'sub FPR17 () {273;}' unless defined(&FPR17);
    eval 'sub FPR18 () {274;}' unless defined(&FPR18);
    eval 'sub FPR19 () {275;}' unless defined(&FPR19);
    eval 'sub FPR20 () {276;}' unless defined(&FPR20);
    eval 'sub FPR21 () {277;}' unless defined(&FPR21);
    eval 'sub FPR22 () {278;}' unless defined(&FPR22);
    eval 'sub FPR23 () {279;}' unless defined(&FPR23);
    eval 'sub FPR24 () {280;}' unless defined(&FPR24);
    eval 'sub FPR25 () {281;}' unless defined(&FPR25);
    eval 'sub FPR26 () {282;}' unless defined(&FPR26);
    eval 'sub FPR27 () {283;}' unless defined(&FPR27);
    eval 'sub FPR28 () {284;}' unless defined(&FPR28);
    eval 'sub FPR29 () {285;}' unless defined(&FPR29);
    eval 'sub FPR30 () {286;}' unless defined(&FPR30);
    eval 'sub FPR31 () {287;}' unless defined(&FPR31);
    eval 'sub STKP () { &GPR1;}' unless defined(&STKP);
    eval 'sub PCP () { &GPR1;}' unless defined(&PCP);
    eval 'sub TOC () { &GPR2;}' unless defined(&TOC);
    eval 'sub ARG1 () { &GPR3;}' unless defined(&ARG1);
    eval 'sub ARG2 () { &GPR4;}' unless defined(&ARG2);
    eval 'sub ARG3 () { &GPR5;}' unless defined(&ARG3);
    eval 'sub ARG4 () { &GPR6;}' unless defined(&ARG4);
    eval 'sub STACK_FLOOR () {256;}' unless defined(&STACK_FLOOR);
    if(defined(&_KERNEL)) {
	eval 'sub VALID_GPR {
	    my($x) = @_;
    	    eval q((($x) >=  &GPR0  && ($x) <=  &GPR31));
	}' unless defined(&VALID_GPR);
	eval 'sub VALID_SPR {
	    my($x) = @_;
    	    eval q((($x) >=  &IAR  && ($x) <=  &FPSCR));
	}' unless defined(&VALID_SPR);
	eval 'sub VALID_FPR {
	    my($x) = @_;
    	    eval q((($x) >=  &FPR0  && ($x) <=  &FPR31));
	}' unless defined(&VALID_FPR);
	eval 'sub GPR_loc {
	    my($mp, $x) = @_;
    	    eval q((( ($mp->{gpr[(x) }- GPR0]))));
	}' unless defined(&GPR_loc);
	eval 'sub SPR_loc {
	    my($mp, $x) = @_;
    	    eval q((( ($mp->{iar})) + ($x) -  &IAR));
	}' unless defined(&SPR_loc);
	eval 'sub FPR_loc {
	    my($mp, $x) = @_;
    	    eval q((( ($mp->{fpr[(x) }- FPR0]))));
	}' unless defined(&FPR_loc);
	eval 'sub GPR_size () {($sizeof{ ($uthr0->{ut_save}->{gpr[0]})});}' unless defined(&GPR_size);
	eval 'sub SPR_size {
	    my($x) = @_;
    	    eval q(($sizeof{ ($uthr0->{ut_save}->{iar})}));
	}' unless defined(&SPR_size);
	eval 'sub FPR_size () {($sizeof{ ($uthr0->{ut_fpr[0]})});}' unless defined(&FPR_size);
	eval 'sub ISWALIGN {
	    my($x) = @_;
    	    eval q((($x) & ($sizeof{\'int\'} - 1) ? 0: 1));
	}' unless defined(&ISWALIGN);
	eval 'sub ISDWALIGN {
	    my($x) = @_;
    	    eval q((($x) & ($sizeof{\'long long\'} - 1) ? 0: 1));
	}' unless defined(&ISDWALIGN);
	eval 'sub VALID_ADDR {
	    my($x) = @_;
    	    eval q((( (( >>  &SEGSHIFT) ==  &PRIVSEG_LO  &&  &SEGOFFSET >=  &U_REGION_SIZE) || (($x) >>  &SEGSHIFT) ==  &KERNEXSEG ) ? 0: 1));
	}' unless defined(&VALID_ADDR);
	eval 'sub ISWRITEREG {
	    my($x) = @_;
    	    eval q(( &VALID_GPR((($x)-(0)-> $gpr[0])) ||  &VALID_SPR((($x)-(0)-> &iar)) ));
	}' unless defined(&ISWRITEREG);
    }
    if(defined(&_KERNSYS)) {
	eval 'sub SANITIZE_MSR {
	    my($x) = @_;
    	    eval q(($x) = ( &MSR_EE| &MSR_ME| &MSR_IR| &MSR_DR| &MSR_PR| &MSR_RI) | (($x) & ( &MSR_AL)) | (($x) & (( &pmihrv?-1:0) & ( &MSR_PM| &MSR_BE| &MSR_SE))));
	}' unless defined(&SANITIZE_MSR);
	eval 'sub MASK_FP {
	    my($x) = @_;
    	    eval q((((($x) >>  &FP_SYNC_IMP_S) & ( &FP_IMP_INT |  &FP_SYNC_TASK))));
	}' unless defined(&MASK_FP);
	eval 'sub UPDATE_FPINFO {
	    my($x) = @_;
    	    eval q(( &__power_pc() ?  &MASK_FP :  &MASK_FP &  &FP_SYNC_TASK ?  &FP_SYNC_TASK : ( (  &MASK_FP($x) &  &FP_IMP_INT )  && (  &__power_rs2()) )));
	}' unless defined(&UPDATE_FPINFO);
    }
}
1;
