require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SELECT)) {
    eval 'sub _H_SELECT () {1;}' unless defined(&_H_SELECT);
    unless(defined(&_H_STANDARDS)) {
	require 'standards.ph';
    }
    unless(defined(&_H_SYS_TIME)) {
	require 'sys/time.ph';
    }
    if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0)==1) {
    }
    if(defined(&_ALL_SOURCE)) {
	unless(defined(&NO_TIMEOUT)) {
	    eval 'sub NO_TIMEOUT () {0;}' unless defined(&NO_TIMEOUT);
	}
	unless(defined(&INF_TIMEOUT)) {
	    eval 'sub INF_TIMEOUT () {-1;}' unless defined(&INF_TIMEOUT);
	}
	eval 'sub NFDS {
	    my($x) = @_;
    	    eval q((($x) & 0xffff));
	}' unless defined(&NFDS);
	eval 'sub LOW_HALF {
	    my($x) = @_;
    	    eval q( &NFDS($x));
	}' unless defined(&LOW_HALF);
	eval 'sub NMSGS {
	    my($x) = @_;
    	    eval q(((($x) >> 16) & 0xffff));
	}' unless defined(&NMSGS);
	eval 'sub HIGH_HALF {
	    my($x) = @_;
    	    eval q( &NMSGS($x));
	}' unless defined(&HIGH_HALF);
	eval 'sub SELLIST {
	    my($F,$M) = @_;
    	    eval q(\'struct struct\' { \'ulong fdsmask\'[$F]; \'int\'  $msgids[$M]; });
	}' unless defined(&SELLIST);
	eval 'sub NFDBITS () { &__NFDBITS;}' unless defined(&NFDBITS);
	unless(defined(&howmany)) {
	    eval 'sub howmany {
	        my($x, $y) = @_;
    		eval q(((($x)+(($y)-1))/($y)));
	    }' unless defined(&howmany);
	}
    }
}
1;
