require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SERDASD)) {
    eval 'sub _H_SERDASD () {1;}' unless defined(&_H_SERDASD);
    require 'sys/scsi.ph';
    require 'sys/scdisk.ph';
    require 'sys/ddconc.ph';
    eval 'sub SD_NO_RESERVE () { &SC_NO_RESERVE;}' unless defined(&SD_NO_RESERVE);
    eval 'sub SD_DAEMON () { &SC_RESV_05;}' unless defined(&SD_DAEMON);
    eval 'sub SD_SCSICMD () { &DKIOCMD;}' unless defined(&SD_SCSICMD);
    eval 'sub SD_RESET () {0x71;}' unless defined(&SD_RESET);
    eval 'sub SD_ADAP_DOWNLOAD () {0x72;}' unless defined(&SD_ADAP_DOWNLOAD);
    eval 'sub SD_ADAP_TRACE_SNAPSHOT () {0x73;}' unless defined(&SD_ADAP_TRACE_SNAPSHOT);
    eval 'sub SD_ADAP_QUERY_TRACE () {0x74;}' unless defined(&SD_ADAP_QUERY_TRACE);
    eval 'sub SD_ADAP_INQUIRY () {0x75;}' unless defined(&SD_ADAP_INQUIRY);
    eval 'sub SD_SET_ADAP_PARMS () {0x76;}' unless defined(&SD_SET_ADAP_PARMS);
    eval 'sub SD_QUERY_DEVICE () {0x77;}' unless defined(&SD_QUERY_DEVICE);
    eval 'sub SD_READ_ADAP_ID () {0x78;}' unless defined(&SD_READ_ADAP_ID);
    eval 'sub SD_GET_EVENT () {0x79;}' unless defined(&SD_GET_EVENT);
    eval 'sub SD_DAEMON_ERROR () {0x7a;}' unless defined(&SD_DAEMON_ERROR);
    eval 'sub SD_MBOX () {0x7b;}' unless defined(&SD_MBOX);
    eval 'sub SD_SET_FENCE () {0x7c;}' unless defined(&SD_SET_FENCE);
    eval 'sub SD_CLEAR_FENCE () {0x7d;}' unless defined(&SD_CLEAR_FENCE);
    eval 'sub SD_WRITE_SAME () {0x41;}' unless defined(&SD_WRITE_SAME);
    eval 'sub SD_FENCE_OP_CODE () {0xd0;}' unless defined(&SD_FENCE_OP_CODE);
    eval 'sub SD_FENCE_MASK_SWAP () {0x1;}' unless defined(&SD_FENCE_MASK_SWAP);
    eval 'sub SD_FENCE_COMPARE_SWAP () {0x2;}' unless defined(&SD_FENCE_COMPARE_SWAP);
    eval 'sub SD_WRITE_VPD () {0x80;}' unless defined(&SD_WRITE_VPD);
    eval 'sub SD_RESET_DASD () {0x81;}' unless defined(&SD_RESET_DASD);
    eval 'sub SD_SET_TRACE_SNAPSHOT () {0x82;}' unless defined(&SD_SET_TRACE_SNAPSHOT);
    eval 'sub SD_PREPARE_TRACE_STATUS () {0x83;}' unless defined(&SD_PREPARE_TRACE_STATUS);
    eval 'sub SD_PREPARE_TRACE_DUMP () {0x84;}' unless defined(&SD_PREPARE_TRACE_DUMP);
    eval 'sub SD_SELF_TEST_BIT () {0x4;}' unless defined(&SD_SELF_TEST_BIT);
    eval 'sub SD_ADAP_ID () {0x788f;}' unless defined(&SD_ADAP_ID);
    eval 'sub SD_ADAPTER () {0x;}' unless defined(&SD_ADAPTER);
    eval 'sub SD_CONTROLLER () {0x1;}' unless defined(&SD_CONTROLLER);
    eval 'sub SD_DASD () {0x2;}' unless defined(&SD_DASD);
    eval 'sub SD_ADAP_VPD_SIZE () {255;}' unless defined(&SD_ADAP_VPD_SIZE);
    eval 'sub SD_ADAP_DUMP_LENGTH () {0x1200;}' unless defined(&SD_ADAP_DUMP_LENGTH);
    eval 'sub SD_SCSI_STATUS () {0x;}' unless defined(&SD_SCSI_STATUS);
    eval 'sub SD_CTRL_STATUS () {0x1;}' unless defined(&SD_CTRL_STATUS);
    eval 'sub SD_CMD_TO_ACTIVE_TAG () {0x2;}' unless defined(&SD_CMD_TO_ACTIVE_TAG);
    eval 'sub SD_DNLD_ADAP_BUSY () {0x3;}' unless defined(&SD_DNLD_ADAP_BUSY);
    eval 'sub SD_ILLEGAL_ADAP_CMD () {0x4;}' unless defined(&SD_ILLEGAL_ADAP_CMD);
    eval 'sub SD_CTRL_NOT_RESPONDING () {0x5;}' unless defined(&SD_CTRL_NOT_RESPONDING);
    eval 'sub SD_UNIT_POWERED_ON () {0x6;}' unless defined(&SD_UNIT_POWERED_ON);
    eval 'sub SD_TIME_OUT () {0x7;}' unless defined(&SD_TIME_OUT);
    eval 'sub SD_OPEN_LINK () {0x8;}' unless defined(&SD_OPEN_LINK);
    eval 'sub SD_RESET_PURGE_TAG () {0x9;}' unless defined(&SD_RESET_PURGE_TAG);
    eval 'sub SD_UNEXP_SCSI_STATUS () {0xa;}' unless defined(&SD_UNEXP_SCSI_STATUS);
    eval 'sub SD_UNEXP_CTRL_STATUS () {0xb;}' unless defined(&SD_UNEXP_CTRL_STATUS);
    eval 'sub SD_DATA_DMA_FAIL () {0xc;}' unless defined(&SD_DATA_DMA_FAIL);
    eval 'sub SD_MB_DMA_FAIL () {0xd;}' unless defined(&SD_MB_DMA_FAIL);
    eval 'sub SD_INVALID_MB_PTR () {0xe;}' unless defined(&SD_INVALID_MB_PTR);
    eval 'sub SD_DMA_COUNT_ERROR () {0xf;}' unless defined(&SD_DMA_COUNT_ERROR);
    eval 'sub SD_BAD_CTRL_ADDRESS () {0x10;}' unless defined(&SD_BAD_CTRL_ADDRESS);
    eval 'sub SD_QUIESCE_TIME_OUT () {0x11;}' unless defined(&SD_QUIESCE_TIME_OUT);
    eval 'sub SD_RECOV_LINK_ERROR () {0x12;}' unless defined(&SD_RECOV_LINK_ERROR);
    eval 'sub SD_DNLD_MC_CHKSUM_FAIL () {0x13;}' unless defined(&SD_DNLD_MC_CHKSUM_FAIL);
    eval 'sub SD_MSG_TO_INACTIVE_TAG () {0x14;}' unless defined(&SD_MSG_TO_INACTIVE_TAG);
    eval 'sub SD_MSG_WRONG_LINK () {0x15;}' unless defined(&SD_MSG_WRONG_LINK);
    eval 'sub SD_INVALID_LINK_MSG () {0x16;}' unless defined(&SD_INVALID_LINK_MSG);
    eval 'sub SD_LINK_ERROR () {0x17;}' unless defined(&SD_LINK_ERROR);
    eval 'sub SD_INVALID_ADAP_PARMS () {0x18;}' unless defined(&SD_INVALID_ADAP_PARMS);
    eval 'sub SD_INVALID_TAG () {0x19;}' unless defined(&SD_INVALID_TAG);
    eval 'sub SD_DMA_DISABLED () {0x1d;}' unless defined(&SD_DMA_DISABLED);
    eval 'sub SD_ASYNCHRONOUS_EVENT () {0x1f;}' unless defined(&SD_ASYNCHRONOUS_EVENT);
    eval 'sub SD_WBUFF_STARTED () {0x20;}' unless defined(&SD_WBUFF_STARTED);
    eval 'sub SD_MB_TERM_INTERN_RST () {0x21;}' unless defined(&SD_MB_TERM_INTERN_RST);
    eval 'sub SD_ADAP_HDW_ERROR () {0x22;}' unless defined(&SD_ADAP_HDW_ERROR);
    eval 'sub SD_TRACE_DATA_DMA_ERR () {0x24;}' unless defined(&SD_TRACE_DATA_DMA_ERR);
    eval 'sub SD_SYSTEM_DMA_HUNG () {0x25;}' unless defined(&SD_SYSTEM_DMA_HUNG);
    eval 'sub SD_TRACE_SUPERCEDED () {0x26;}' unless defined(&SD_TRACE_SUPERCEDED);
    eval 'sub SD_PREV_TRC_DUMP_BUSY () {0x27;}' unless defined(&SD_PREV_TRC_DUMP_BUSY);
    eval 'sub SD_DD_PURGED_TAG () {0x1;}' unless defined(&SD_DD_PURGED_TAG);
    eval 'sub SD_ABORTED_CMD () {0x81;}' unless defined(&SD_ABORTED_CMD);
    eval 'sub SD_INVALID_QC () {0x82;}' unless defined(&SD_INVALID_QC);
    eval 'sub SD_PURG_OS () {0x83;}' unless defined(&SD_PURG_OS);
    eval 'sub SD_PURG_EPOW () {0x84;}' unless defined(&SD_PURG_EPOW);
    eval 'sub SD_WBUFF_INPROG () {0x87;}' unless defined(&SD_WBUFF_INPROG);
    eval 'sub SD_INVALID_MSG () {0x88;}' unless defined(&SD_INVALID_MSG);
    eval 'sub SD_INVALID_MB () {0x89;}' unless defined(&SD_INVALID_MB);
    eval 'sub SD_NO_VALID_DELAY () {0x8a;}' unless defined(&SD_NO_VALID_DELAY);
    eval 'sub SD_GOOD () { &SC_GOOD_STATUS;}' unless defined(&SD_GOOD);
    eval 'sub SD_CHECK () { &SC_CHECK_CONDITION;}' unless defined(&SD_CHECK);
    eval 'sub SD_RES_CONFLICT () { &SC_RESERVATION_CONFLICT;}' unless defined(&SD_RES_CONFLICT);
    eval 'sub SD_QUEUE_FULL () {0x28;}' unless defined(&SD_QUEUE_FULL);
    eval 'sub SD_FENCED_OUT () {0x3e;}' unless defined(&SD_FENCED_OUT);
    eval 'sub SD_POS5_VALID () {0x1;}' unless defined(&SD_POS5_VALID);
    eval 'sub SD_ALERT_VALID () {0x2;}' unless defined(&SD_ALERT_VALID);
    eval 'sub SD_DMA_RC_VALID () {0x4;}' unless defined(&SD_DMA_RC_VALID);
    eval 'sub SD_CHANNEL_STATUS_VALID () {0x8;}' unless defined(&SD_CHANNEL_STATUS_VALID);
    eval 'sub SD_RESET_OP () {0x;}' unless defined(&SD_RESET_OP);
    eval 'sub SD_QUIESCE_OP () {0x1;}' unless defined(&SD_QUIESCE_OP);
    eval 'sub SD_DASD_RESET () {0x2;}' unless defined(&SD_DASD_RESET);
    eval 'sub SD_NO_STATUS () {0x;}' unless defined(&SD_NO_STATUS);
    eval 'sub SD_VALID_ADAP_STATUS () {0x1;}' unless defined(&SD_VALID_ADAP_STATUS);
    eval 'sub SD_VALID_CTRL_STATUS () {0x2;}' unless defined(&SD_VALID_CTRL_STATUS);
    eval 'sub SD_DRIVER_STATUS () {0x4;}' unless defined(&SD_DRIVER_STATUS);
    if(defined(&_KERNEL)) {
    }
    eval 'sub SD_VALID_ALERTREG () {0x4;}' unless defined(&SD_VALID_ALERTREG);
    eval 'sub SD_Q_NONE () {0x;}' unless defined(&SD_Q_NONE);
    eval 'sub SD_Q_INVALID () {0x40;}' unless defined(&SD_Q_INVALID);
    eval 'sub SD_Q_ORDERED () {0x80;}' unless defined(&SD_Q_ORDERED);
    eval 'sub SD_Q_UNORDERED () {0xc0;}' unless defined(&SD_Q_UNORDERED);
    eval 'sub SD_NO_EXT () {0x;}' unless defined(&SD_NO_EXT);
    eval 'sub SD_SPLIT_WRITE () {0x20;}' unless defined(&SD_SPLIT_WRITE);
    eval 'sub SD_SPLIT_READ () {0x10;}' unless defined(&SD_SPLIT_READ);
    if(defined(&_KERNEL)) {
    }
}
1;
