require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SLEEP)) {
    eval 'sub _H_SLEEP () {1;}' unless defined(&_H_SLEEP);
    require 'sys/types.ph';
    require 'sys/lock_def.ph';
    eval 'sub EVENT_NULL () {(-1);}' unless defined(&EVENT_NULL);
    eval 'sub EVENT_NDELAY () {(0);}' unless defined(&EVENT_NDELAY);
    eval 'sub EVENT_KIPC () {(0x1);}' unless defined(&EVENT_KIPC);
    eval 'sub EVENT_THRPGIO () {(0x2);}' unless defined(&EVENT_THRPGIO);
    eval 'sub EVENT_SHARED () {(0x4);}' unless defined(&EVENT_SHARED);
    eval 'sub EVENT_QUEUE () {(0x8);}' unless defined(&EVENT_QUEUE);
    eval 'sub EVENT_SYNC () {(0x10);}' unless defined(&EVENT_SYNC);
    eval 'sub EVENT_CHILD () {(0x20);}' unless defined(&EVENT_CHILD);
    eval 'sub EVENT_THREAD () {(0x40);}' unless defined(&EVENT_THREAD);
    eval 'sub EVENT_RESTART () {(0x80);}' unless defined(&EVENT_RESTART);
    eval 'sub EVENT_KERNEL () {(0xff);}' unless defined(&EVENT_KERNEL);
    eval 'sub EVENT_SHORT () {(0);}' unless defined(&EVENT_SHORT);
    eval 'sub EVENT_SIGWAKE () {(2);}' unless defined(&EVENT_SIGWAKE);
    eval 'sub EVENT_SIGRET () {(4);}' unless defined(&EVENT_SIGRET);
    eval 'sub EVENT_SUCC () {(1);}' unless defined(&EVENT_SUCC);
    eval 'sub EVENT_SIG () {(0);}' unless defined(&EVENT_SIG);
    eval 'sub E_WKX_NO_PREEMPT () {(0);}' unless defined(&E_WKX_NO_PREEMPT);
    eval 'sub E_WKX_PREEMPT () {(1);}' unless defined(&E_WKX_PREEMPT);
    eval 'sub INTERRUPTIBLE () {(1);}' unless defined(&INTERRUPTIBLE);
    eval 'sub LOCK_HANDLER () {(2);}' unless defined(&LOCK_HANDLER);
    eval 'sub LOCK_READ () {(4);}' unless defined(&LOCK_READ);
    eval 'sub LOCK_SIMPLE () {(8);}' unless defined(&LOCK_SIMPLE);
    eval 'sub LOCK_WRITE () {(16);}' unless defined(&LOCK_WRITE);
    eval 'sub WAKEUP_LOCK_SIMPLE () {(1);}' unless defined(&WAKEUP_LOCK_SIMPLE);
    eval 'sub WAKEUP_LOCK_ALL () {(2);}' unless defined(&WAKEUP_LOCK_ALL);
    eval 'sub WAKEUP_LOCK_WRITER_OR_READERS () {(3);}' unless defined(&WAKEUP_LOCK_WRITER_OR_READERS);
    eval 'sub WAKEUP_LOCK_READERS () {(4);}' unless defined(&WAKEUP_LOCK_READERS);
    eval 'sub WAKEUP_LOCK_UPGRADER () {(5);}' unless defined(&WAKEUP_LOCK_UPGRADER);
    eval 'sub THREAD_AWAKENED () {(1);}' unless defined(&THREAD_AWAKENED);
    eval 'sub THREAD_TIMED_OUT () {(2);}' unless defined(&THREAD_TIMED_OUT);
    eval 'sub THREAD_INTERRUPTED () {(4);}' unless defined(&THREAD_INTERRUPTED);
    eval 'sub THREAD_OTHER () {(4096);}' unless defined(&THREAD_OTHER);
    if(defined(&_KERNEL)) {
	if(defined(&_AIXV3_POSTWAIT)) {
	    eval 'sub e_wait {
	        my($x,$y,$z) = @_;
    		eval q( &et_wait(($x),($y),($z)));
	    }' unless defined(&e_wait);
	    eval 'sub e_post {
	        my($x,$y) = @_;
    		eval q( &et_post(($x), &getptid($y)));
	    }' unless defined(&e_post);
	}
    }
    unless(defined(&__FULL_PROTO)) {
    } else {
    }
}
1;
