require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SOCKETVAR_H_)) {
    eval 'sub _SYS_SOCKETVAR_H_ () {1;}' unless defined(&_SYS_SOCKETVAR_H_);
    if(defined(&__cplusplus)) {
    }
    if(defined( &_KERNEL)  && !defined( &_NET_GLOBALS_H_)) {
	require 'net/net_globals.ph';
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    require 'sys/time.ph';
    if((defined(&MACH) ? &MACH : 0)) {
	require 'sys/secdefines.ph';
	if((defined(&SEC_ARCH) ? &SEC_ARCH : 0)) {
	    require 'sys/security.ph';
	}
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub sb_sel () { ($sb_select->{sb_selproc});}' unless defined(&sb_sel);
    eval 'sub sb_selq () { ($sb_select->{sb_selque});}' unless defined(&sb_selq);
    eval 'sub SB_MAX () {(1024*1024);}' unless defined(&SB_MAX);
    eval 'sub SB_LOCK () {0x1;}' unless defined(&SB_LOCK);
    eval 'sub SB_WANT () {0x2;}' unless defined(&SB_WANT);
    eval 'sub SB_WAIT () {0x4;}' unless defined(&SB_WAIT);
    eval 'sub SB_SEL () {0x8;}' unless defined(&SB_SEL);
    eval 'sub SB_ASYNC () {0x10;}' unless defined(&SB_ASYNC);
    eval 'sub SB_COLL () {0x20;}' unless defined(&SB_COLL);
    eval 'sub SB_NOINTR () {0x40;}' unless defined(&SB_NOINTR);
    eval 'sub SB_WAKEONE () {0x80;}' unless defined(&SB_WAKEONE);
    eval 'sub SB_WAITING () {0x100;}' unless defined(&SB_WAITING);
    eval 'sub SB_INHERIT () {( &SB_NOINTR| &SB_WAKEONE);}' unless defined(&SB_INHERIT);
    if(defined(&_AIX)) {
	eval 'sub SB_PSEG () {0x200;}' unless defined(&SB_PSEG);
	eval 'sub SB_KIODONE () {0x400;}' unless defined(&SB_KIODONE);
	eval 'sub SB_NOTIFY () {( &SB_WAIT| &SB_SEL| &SB_ASYNC| &SB_WAKEONE| &SB_KIODONE);}' unless defined(&SB_NOTIFY);
    } else {
	eval 'sub SB_NOTIFY () {( &SB_WAIT| &SB_SEL| &SB_ASYNC| &SB_WAKEONE);}' unless defined(&SB_NOTIFY);
    }
    eval 'sub SB_NOSELECT () {0x800;}' unless defined(&SB_NOSELECT);
    eval 'sub SO_NOISNO_TCP_SENDSPACE () {0x1;}' unless defined(&SO_NOISNO_TCP_SENDSPACE);
    eval 'sub SO_NOISNO_TCP_RECVSPACE () {0x2;}' unless defined(&SO_NOISNO_TCP_RECVSPACE);
    eval 'sub SO_NOISNO_TCP_NODELAY () {0x4;}' unless defined(&SO_NOISNO_TCP_NODELAY);
    eval 'sub SO_NOISNO_RFC1323 () {0x8;}' unless defined(&SO_NOISNO_RFC1323);
    eval 'sub soorfield () { &SOORFIELD;}' unless defined(&soorfield);
    eval 'sub SOORFIELD {
        my($so, $field, $value) = @_;
	    eval q({  ($so->{field}) |= $value;  &if ( ($so->{so_special}) &  &SP_GROUP  &&  ($so->{so_q0})) { \'int\'  &z2; \'struct socket\' * &sg2;  &for ( &z2 = 1;  &z2 <  ($so->{so_q0len});  &z2++) {  &sg2 = ( ($so->{so_q0}))[ &z2];  ($sg2->{field}) |= $value; } } });
    }' unless defined(&SOORFIELD);
    eval 'sub soandfield () { &SOANDFIELD;}' unless defined(&soandfield);
    eval 'sub SOANDFIELD {
        my($so, $field, $value) = @_;
	    eval q({  ($so->{field}) &= $value;  &if ( ($so->{so_special}) &  &SP_GROUP  &&  ($so->{so_q0})) { \'int\'  &z2; \'struct socket\' * &sg2;  &for ( &z2 = 1;  &z2 <  ($so->{so_q0len});  &z2++) {  &sg2 = ( ($so->{so_q0}))[ &z2];  ($sg2->{field}) &= $value; } } });
    }' unless defined(&SOANDFIELD);
    eval 'sub sosetrcvwakearg () { &SOSETRCVWAKEARG;}' unless defined(&sosetrcvwakearg);
    eval 'sub SOSETRCVWAKEARG {
        my($so) = @_;
	    eval q({  ($so->{so_rcv}->{sb_wakearg}) = $so;  &if ( ($so->{so_special}) &  &SP_GROUP  &&  ($so->{so_q0})) { \'int\'  &z2; \'struct socket\' * &sg2;  &for ( &z2 = 1;  &z2 <  ($so->{so_q0len});  &z2++) {  &sg2 = ( ($so->{so_q0}))[ &z2];  ($sg2->{so_rcv}->{sb_wakearg}) =  &sg2; } } });
    }' unless defined(&SOSETRCVWAKEARG);
    eval 'sub SOMAXBUFSIZE () {(65536);}' unless defined(&SOMAXBUFSIZE);
    eval 'sub SAIOQ_LOCK () { &disable_lock( &PL_IMP,  &saioq_lock);}' unless defined(&SAIOQ_LOCK);
    eval 'sub SAIOQ_UNLOCK {
        my($x) = @_;
	    eval q( &unlock_enable($x,  &saioq_lock));
    }' unless defined(&SAIOQ_UNLOCK);
    eval 'sub SS_NOFDREF () {0x1;}' unless defined(&SS_NOFDREF);
    eval 'sub SS_ISCONNECTED () {0x2;}' unless defined(&SS_ISCONNECTED);
    eval 'sub SS_ISCONNECTING () {0x4;}' unless defined(&SS_ISCONNECTING);
    eval 'sub SS_ISDISCONNECTING () {0x8;}' unless defined(&SS_ISDISCONNECTING);
    eval 'sub SS_CANTSENDMORE () {0x10;}' unless defined(&SS_CANTSENDMORE);
    eval 'sub SS_CANTRCVMORE () {0x20;}' unless defined(&SS_CANTRCVMORE);
    eval 'sub SS_RCVATMARK () {0x40;}' unless defined(&SS_RCVATMARK);
    eval 'sub SS_PRIV () {0x80;}' unless defined(&SS_PRIV);
    eval 'sub SS_NBIO () {0x100;}' unless defined(&SS_NBIO);
    eval 'sub SS_ASYNC () {0x200;}' unless defined(&SS_ASYNC);
    eval 'sub SS_ISCONFIRMING () {0x400;}' unless defined(&SS_ISCONFIRMING);
    eval 'sub SS_QUEUE () {0x800;}' unless defined(&SS_QUEUE);
    eval 'sub SS_SPLICED () {0x1000;}' unless defined(&SS_SPLICED);
    eval 'sub SP_PIPE () {0x1;}' unless defined(&SP_PIPE);
    eval 'sub SP_WATOMIC () {0x2;}' unless defined(&SP_WATOMIC);
    eval 'sub SP_NOUAREA () {0x4;}' unless defined(&SP_NOUAREA);
    eval 'sub SP_LOCKABLE () {0x8;}' unless defined(&SP_LOCKABLE);
    eval 'sub SP_CLOSING () {0x10;}' unless defined(&SP_CLOSING);
    eval 'sub SP_RWAKEUP () {0x20;}' unless defined(&SP_RWAKEUP);
    eval 'sub SP_WWAKEUP () {0x40;}' unless defined(&SP_WWAKEUP);
    eval 'sub SP_EXTPRIV () {0x80;}' unless defined(&SP_EXTPRIV);
    eval 'sub SP_XPG1170 () {0x100;}' unless defined(&SP_XPG1170);
    if(defined(&MEMSAVE)) {
	eval 'sub SP_MEMCOMPRESS () {0x200;}' unless defined(&SP_MEMCOMPRESS);
    }
    eval 'sub SP_ACCEPT () {0x400;}' unless defined(&SP_ACCEPT);
    eval 'sub SP_DISABLE () {0x800;}' unless defined(&SP_DISABLE);
    eval 'sub SP_GROUP () {0x1000;}' unless defined(&SP_GROUP);
    eval 'sub SP_QCONN_CLOSING () {0x2000;}' unless defined(&SP_QCONN_CLOSING);
    eval 'sub SP_ONFREELIST () {0x4000;}' unless defined(&SP_ONFREELIST);
    eval 'sub SP_FREEABLE () {0x8000;}' unless defined(&SP_FREEABLE);
    eval 'sub SP_INHERIT () {( &SP_PIPE| &SP_WATOMIC| &SP_NOUAREA| &SP_LOCKABLE|  &SP_DISABLE| &SP_XPG1170);}' unless defined(&SP_INHERIT);
    eval 'sub SP2_PROC () {0x1;}' unless defined(&SP2_PROC);
    eval 'sub SP2_INHERIT () {( &SP2_PROC);}' unless defined(&SP2_INHERIT);
    eval 'sub SP2_MSGWAITALL () {0x2;}' unless defined(&SP2_MSGWAITALL);
    eval 'sub SP2_FRCA_BACKDOOR_BUSY () {0x1000;}' unless defined(&SP2_FRCA_BACKDOOR_BUSY);
    eval 'sub SP2_FRCA_BACKDOOR () {0x2000;}' unless defined(&SP2_FRCA_BACKDOOR);
    eval 'sub SP2_FRCA_BUCKET () {0x4000;}' unless defined(&SP2_FRCA_BUCKET);
    eval 'sub SP2_FRCA_BACKDOOR_DONE () {0x8000;}' unless defined(&SP2_FRCA_BACKDOOR_DONE);
    if(defined(&_KERNEL)) {
	eval 'sub SOCKET_LOCKINIT {
	    my($so, $lp) = @_;
    	    eval q({ -> &so_lock = ; -> ($so_snd->{sb_lock}) = (-> &snd_lock); -> ($so_rcv->{sb_lock}) = (-> &rcv_lock); -> &refcnt = 0; -> &sp_wake = 0; ->$so = $so; -> &freelist = 0;  &lock_alloc((-> &sock_lock),  &LOCK_ALLOC_PIN,  &SOCKET_LOCK_FAMILY, $so);  &simple_lock_init((($lp)-> &sock_lock)); });
	}' unless defined(&SOCKET_LOCKINIT);
	eval 'sub SOCKET_ISLOCKED {
	    my($so) = @_;
    	    eval q(1);
	}' unless defined(&SOCKET_ISLOCKED);
	eval 'sub SOCKET_LOCK2 {
	    my($so1, $so2) = @_;
    	    eval q({  &if (($so1) < ($so2)) {  &SOCKET_LOCK($so1);  &if (($so1)-> &so_lock != ($so2)-> &so_lock)  &SOCKET_LOCK($so2); }  &else {  &SOCKET_LOCK($so2);  &if (($so1)-> &so_lock != ($so2)-> &so_lock)  &SOCKET_LOCK($so1); } });
	}' unless defined(&SOCKET_LOCK2);
	eval 'sub SOCKET_UNLOCK2 {
	    my($so1, $so2) = @_;
    	    eval q({  &if (($so1) < ($so2)) {  &if (($so1)-> &so_lock != ($so2)-> &so_lock)  &SOCKET_UNLOCK($so2);  &SOCKET_UNLOCK($so1); }  &else {  &if (($so1)-> &so_lock != ($so2)-> &so_lock)  &SOCKET_UNLOCK($so1);  &SOCKET_UNLOCK($so2); } });
	}' unless defined(&SOCKET_UNLOCK2);
	if(defined(&__64BIT__)) {
	    eval 'sub SOCKET_LOCK {
	        my($so) = @_;
    		eval q({  &if (($so)-> &so_special &  &SP_DISABLE) ($so)-> ($so_lock->{spl}) =  &disable_lock( &PL_IMP,(($so)-> ($so_lock->{sock_lock})));  &else {  &simple_lock_data_t * &lw = (($so)-> ($so_lock->{sock_lock}));  &simple_lock( &lw);  &while ( &lw != (($so)-> ($so_lock->{sock_lock}))) {  &simple_unlock( &lw);  &lw = (($so)-> ($so_lock->{sock_lock}));  &simple_lock( &lw); } } });
	    }' unless defined(&SOCKET_LOCK);
	} else {
	    eval 'sub SOCKET_LOCK {
	        my($so) = @_;
    		eval q({  &if (($so)-> &so_special &  &SP_DISABLE)  &so_pin_more_stack($so);  &else {  &simple_lock_data_t * &lw = (($so)-> ($so_lock->{sock_lock}));  &simple_lock( &lw);  &while ( &lw != (($so)-> ($so_lock->{sock_lock}))) {  &simple_unlock( &lw);  &lw = (($so)-> ($so_lock->{sock_lock}));  &simple_lock( &lw); } } });
	    }' unless defined(&SOCKET_LOCK);
	}
	eval 'sub SOCKET_UNLOCK {
	    my($so) = @_;
    	    eval q(( &void) &sounlock($so));
	}' unless defined(&SOCKET_UNLOCK);
	eval 'sub sosetfield () { &SOSETFIELD;}' unless defined(&sosetfield);
	eval 'sub SOSETFIELD {
	    my($so, $field, $value) = @_;
    	    eval q({  ($so->{field}) = $value;  &if ( ($so->{so_special}) &  &SP_GROUP  &&  ($so->{so_q0})) { \'int\'  &z2; \'struct socket\' * &sg2;  &for ( &z2 = 1;  &z2 <  ($so->{so_q0len});  &z2++) {  &sg2 = ( ($so->{so_q0}))[ &z2];  &SOCKET_LOCK( &sg2);  ($sg2->{field}) = $value;  &SOCKET_UNLOCK( &sg2); } } });
	}' unless defined(&SOSETFIELD);
	eval 'sub SOCKBUF_LOCKTEST () {0;}' unless defined(&SOCKBUF_LOCKTEST);
	eval 'sub SOCKBUF_LOCK {
	    my($sb) = @_;
    	    eval q();
	}' unless defined(&SOCKBUF_LOCK);
	eval 'sub SOCKBUF_UNLOCK {
	    my($sb) = @_;
    	    eval q();
	}' unless defined(&SOCKBUF_UNLOCK);
	eval 'sub SOCKBUF_ISLOCKED {
	    my($sb) = @_;
    	    eval q(1);
	}' unless defined(&SOCKBUF_ISLOCKED);
	eval 'sub SE_ERROR () {0x1;}' unless defined(&SE_ERROR);
	eval 'sub SE_HAVEDATA () {0x2;}' unless defined(&SE_HAVEDATA);
	eval 'sub SE_HAVEOOB () {0x4;}' unless defined(&SE_HAVEOOB);
	eval 'sub SE_DATAFULL () {0x8;}' unless defined(&SE_DATAFULL);
	eval 'sub SE_CONNOUT () {0x10;}' unless defined(&SE_CONNOUT);
	eval 'sub SE_CONNIN () {0x20;}' unless defined(&SE_CONNIN);
	eval 'sub SE_SENDCONN () {0x40;}' unless defined(&SE_SENDCONN);
	eval 'sub SE_RECVCONN () {0x80;}' unless defined(&SE_RECVCONN);
	eval 'sub SE_POLL () {0x4000;}' unless defined(&SE_POLL);
	eval 'sub SE_STATUS () {0x8000;}' unless defined(&SE_STATUS);
	eval 'sub SOHASUAREA {
	    my($so) = @_;
    	    eval q((!(($so)-> &so_special &  &SP_NOUAREA)));
	}' unless defined(&SOHASUAREA);
	eval 'sub sodomain {
	    my($so) = @_;
    	    eval q((($so)-> ($so_proto->{pr_domain})));
	}' unless defined(&sodomain);
	if(defined(&_AIX_FULLOSF)) {
	    eval 'sub sbspace {
	        my($sb) = @_;
    		eval q((  &imin((-> &sb_hiwat - -> &sb_cc), (($sb)-> &sb_mbmax - ($sb)-> &sb_mbcnt))));
	    }' unless defined(&sbspace);
	} else {
	    eval 'sub sbspace {
	        my($sb) = @_;
    		eval q(( &MIN((-> &sb_hiwat - -> &sb_cc), (($sb)-> &sb_mbmax - ($sb)-> &sb_mbcnt))));
	    }' unless defined(&sbspace);
	}
	eval 'sub sosendallatonce {
	    my($so) = @_;
    	    eval q((($so)-> ($so_proto->{pr_flags}) &  &PR_ATOMIC));
	}' unless defined(&sosendallatonce);
	eval 'sub sowatomic {
	    my($so, $len) = @_;
    	    eval q(((($so)-> &so_special &  &SP_WATOMIC)  && (($len) <=  &PIPE_BUF)));
	}' unless defined(&sowatomic);
	eval 'sub soreadable {
	    my($so) = @_;
    	    eval q((($so)-> ($so_rcv->{sb_cc}) >= ($so)-> ($so_rcv->{sb_lowat}) || (($so)-> &so_state &  &SS_CANTRCVMORE) || ($so)-> &so_qlen || ($so)-> &so_error));
	}' unless defined(&soreadable);
	eval 'sub sowriteable {
	    my($so) = @_;
    	    eval q(( &sbspace(($so)-> &so_snd) >= ($so)-> ($so_snd->{sb_lowat})  && ((($so)-> &so_state &SS_ISCONNECTED) || (($so)-> ($so_proto->{pr_flags})& &PR_CONNREQUIRED)==0) || (($so)-> &so_state &  &SS_CANTSENDMORE) || ($so)-> &so_error));
	}' unless defined(&sowriteable);
	eval 'sub sballoc {
	    my($sb, $m) = @_;
    	    eval q({ ($sb)-> &sb_cc += ($m)-> &m_len; ($sb)-> &sb_mbcnt +=  &MSIZE;  &if (($m)-> &m_flags &  &M_EXT) ($sb)-> &sb_mbcnt += ($m)-> ($m_ext->{ext_size}); });
	}' unless defined(&sballoc);
	eval 'sub sbfree {
	    my($sb, $m) = @_;
    	    eval q({ ($sb)-> &sb_cc -= ($m)-> &m_len; ($sb)-> &sb_mbcnt -=  &MSIZE;  &if (($m)-> &m_flags &  &M_EXT) ($sb)-> &sb_mbcnt -= ($m)-> ($m_ext->{ext_size}); });
	}' unless defined(&sbfree);
	eval 'sub sorwakeup {
	    my($so) = @_;
    	    eval q( &sowakeup(($so), ($so)-> &so_rcv));
	}' unless defined(&sorwakeup);
	eval 'sub sowwakeup {
	    my($so) = @_;
    	    eval q( &sowakeup(($so), ($so)-> &so_snd));
	}' unless defined(&sowwakeup);
	eval 'sub sonewconn {
	    my($head, $connstatus) = @_;
    	    eval q( &sonewsock(($head), ($connstatus)));
	}' unless defined(&sonewconn);
	eval 'sub QOS_IS_LOADED () {( ($qos_fns->{qos_alloc}) !=  &NULL);}' unless defined(&QOS_IS_LOADED);
	if(defined(&MEMSAVE)) {
	    eval 'sub so2gidstruct {
	        my($so) = @_;
    		eval q( (($so) + 1));
	    }' unless defined(&so2gidstruct);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
