require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SNODE)) {
    eval 'sub _H_SNODE () {1;}' unless defined(&_H_SNODE);
    require 'sys/acl.ph';
    require 'sys/time.ph';
    require 'sys/types.ph';
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub PIPE_MAXDSEGS () {64;}' unless defined(&PIPE_MAXDSEGS);
	eval 'sub PIPE_DSEG {
	    my($x) = @_;
    	    eval q(($x >> 13));
	}' unless defined(&PIPE_DSEG);
	eval 'sub PIPE_DOFFSET {
	    my($x) = @_;
    	    eval q((($x & 0x1fff) << 15));
	}' unless defined(&PIPE_DOFFSET);
    } else {
	eval 'sub PIPE_SIZE () {( &PAGESIZE * 8);}' unless defined(&PIPE_SIZE);
    }
    eval 'sub sn_dev () { ($sn_gnode->{gn_rdev});}' unless defined(&sn_dev);
    eval 'sub sn_chan () { ($sn_gnode->{gn_chan});}' unless defined(&sn_chan);
    eval 'sub sn_vnode () { ($sn_gnode->{gn_vnode});}' unless defined(&sn_vnode);
    eval 'sub sn_ops () { ($sn_gnode->{gn_ops});}' unless defined(&sn_ops);
    eval 'sub sn_type () { ($sn_gnode->{gn_type});}' unless defined(&sn_type);
    eval 'sub sn_devnode () { ($sn_data->{_sn_dnode});}' unless defined(&sn_devnode);
    eval 'sub sn_fifonode () { ($sn_data->{_sn_fnode});}' unless defined(&sn_fifonode);
    eval 'sub sn_mode () { ($sn_attr->{ica_mode});}' unless defined(&sn_mode);
    eval 'sub sn_uid () { ($sn_attr->{ica_uid});}' unless defined(&sn_uid);
    eval 'sub sn_gid () { ($sn_attr->{ica_gid});}' unless defined(&sn_gid);
    eval 'sub sn_atime () { ($sn_attr->{ica_atime});}' unless defined(&sn_atime);
    eval 'sub sn_mtime () { ($sn_attr->{ica_mtime});}' unless defined(&sn_mtime);
    eval 'sub sn_ctime () { ($sn_attr->{ica_ctime});}' unless defined(&sn_ctime);
    eval 'sub sn_acl () { ($sn_attr->{ica_acl});}' unless defined(&sn_acl);
    eval 'sub dv_chan () { ($dv_gnode->{gn_chan});}' unless defined(&dv_chan);
    eval 'sub dv_rdcnt () { ($dv_gnode->{gn_rdcnt});}' unless defined(&dv_rdcnt);
    eval 'sub dv_wrcnt () { ($dv_gnode->{gn_wrcnt});}' unless defined(&dv_wrcnt);
    eval 'sub dv_rshcnt () { ($dv_gnode->{gn_rshcnt});}' unless defined(&dv_rshcnt);
    eval 'sub dv_mntcnt () { ($dv_gnode->{gn_mntcnt});}' unless defined(&dv_mntcnt);
    eval 'sub sn_lastr () { ($sn_devnode->{dv_lastr});}' unless defined(&sn_lastr);
    eval 'sub DV_CLOSING () {0x1;}' unless defined(&DV_CLOSING);
    eval 'sub DV_OPENPENDING () {0x2;}' unless defined(&DV_OPENPENDING);
    eval 'sub DV_REVOKING () {0x4;}' unless defined(&DV_REVOKING);
    eval 'sub DV_CLOSEPENDING () {0x8;}' unless defined(&DV_CLOSEPENDING);
    unless(defined(&__64BIT_KERNEL)) {
    } else {
    }
    eval 'sub FIFO_RBLK () {0x1;}' unless defined(&FIFO_RBLK);
    eval 'sub FIFO_WBLK () {0x2;}' unless defined(&FIFO_WBLK);
    eval 'sub FIFO_WWRT () {0x4;}' unless defined(&FIFO_WWRT);
    eval 'sub sn_size () { ($sn_fifonode->{ff_size});}' unless defined(&sn_size);
    eval 'sub sn_wptr () { ($sn_fifonode->{ff_wptr});}' unless defined(&sn_wptr);
    eval 'sub sn_rptr () { ($sn_fifonode->{ff_rptr});}' unless defined(&sn_rptr);
    eval 'sub sn_poll () { ($sn_fifonode->{ff_poll});}' unless defined(&sn_poll);
    eval 'sub sn_rcnt () { ($sn_fifonode->{ff_rcnt});}' unless defined(&sn_rcnt);
    eval 'sub sn_wcnt () { ($sn_fifonode->{ff_wcnt});}' unless defined(&sn_wcnt);
    eval 'sub sn_revent () { ($sn_fifonode->{ff_revent});}' unless defined(&sn_revent);
    eval 'sub sn_wevent () { ($sn_fifonode->{ff_wevent});}' unless defined(&sn_wevent);
    eval 'sub sn_flag () { ($sn_fifonode->{ff_flag});}' unless defined(&sn_flag);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub sn_dbuf () { ($sn_fifonode->{ff_dbuf});}' unless defined(&sn_dbuf);
    } else {
	eval 'sub sn_dseg () { ($sn_fifonode->{ff_dseg});}' unless defined(&sn_dseg);
	eval 'sub sn_doff () { ($sn_fifonode->{ff_doff});}' unless defined(&sn_doff);
    }
    eval 'sub SGTOSP {
        my($x) = @_;
	    eval q(((($x)-> &gn_data)));
    }' unless defined(&SGTOSP);
    eval 'sub STOSGP {
        my($x) = @_;
	    eval q(((($x)-> &sn_gnode)));
    }' unless defined(&STOSGP);
    eval 'sub STODP {
        my($x) = @_;
	    eval q((($x)-> &sn_devnode));
    }' unless defined(&STODP);
    eval 'sub STOFP {
        my($x) = @_;
	    eval q((($x)-> &sn_fifonode));
    }' unless defined(&STOFP);
    eval 'sub FTOSP {
        my($x) = @_;
	    eval q((($x)-> &ff_specnode));
    }' unless defined(&FTOSP);
    eval 'sub DTODGP {
        my($x) = @_;
	    eval q(((($x)-> &dv_gnode)));
    }' unless defined(&DTODGP);
    eval 'sub DGTODP {
        my($x) = @_;
	    eval q(((($x)-> &gn_data)));
    }' unless defined(&DGTODP);
    eval 'sub STODGP {
        my($x) = @_;
	    eval q(( &DTODGP( &STODP($x))));
    }' unless defined(&STODGP);
    eval 'sub VTOSP {
        my($x) = @_;
	    eval q(( &SGTOSP( &VTOGP($x))));
    }' unless defined(&VTOSP);
    eval 'sub VTODP {
        my($x) = @_;
	    eval q(( &STODP( &VTOSP($x))));
    }' unless defined(&VTODP);
    eval 'sub VTODGP {
        my($x) = @_;
	    eval q(( &STODGP( &VTOSP($x))));
    }' unless defined(&VTODGP);
    eval 'sub SGTODGP {
        my($x) = @_;
	    eval q(( &STODGP( &SGTOSP($x))));
    }' unless defined(&SGTODGP);
    eval 'sub BASE_MPX () {(( &chan_t)(-1));}' unless defined(&BASE_MPX);
    eval 'sub MPX_CHANNEL {
        my($gp) = @_;
	    eval q((($gp)-> &gn_type ==  &VMPC  && ($gp)-> &gn_chan !=  &BASE_MPX));
    }' unless defined(&MPX_CHANNEL);
    eval 'sub MPX_BASE {
        my($gp) = @_;
	    eval q((($gp)-> &gn_type ==  &VMPC  && ($gp)-> &gn_chan ==  &BASE_MPX));
    }' unless defined(&MPX_BASE);
    eval 'sub NHNODE () {256;}' unless defined(&NHNODE);
    eval 'sub DEVHASH {
        my($x, $y) = @_;
	    eval q(( $hnodetable[(( &major << 4) ^ $x ^ ($y)) & ( &NHNODE-1)]));
    }' unless defined(&DEVHASH);
    eval 'sub FIFOHASH {
        my($x) = @_;
	    eval q(( $hnodetable[(( >> 16) ^ ($x)) & ( &NHNODE-1)]));
    }' unless defined(&FIFOHASH);
    eval 'sub FATTACH_NODE {
        my($vp) = @_;
	    eval q(( &VTOGP($vp)-> &gn_type ==  &VCHR  && ($vp)-> &v_flag &  &V_ROOT));
    }' unless defined(&FATTACH_NODE);
    eval 'sub hdv_forw () { ($hn_forw->{_hdv_forw});}' unless defined(&hdv_forw);
    eval 'sub hff_forw () { ($hn_forw->{_hff_forw});}' unless defined(&hff_forw);
    eval 'sub hdv_back () { ($hn_back->{_hdv_back});}' unless defined(&hdv_back);
    eval 'sub hff_back () { ($hn_back->{_hff_back});}' unless defined(&hff_back);
}
1;
