require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_STREAM_H)) {
    eval 'sub _SYS_STREAM_H () {1;}' unless defined(&_SYS_STREAM_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/param.ph';
    require 'sys/errno.ph';
    require 'sys/cred.ph';
    require 'sys/types.ph';
    if(defined(&_KERNEL)) {
	require 'sys/malloc.ph';
	require 'sys/conf.ph';
	require 'stdarg.ph';
	undef(&queue) if defined(&queue);
	eval 'sub queue () { &pse_queue;}' unless defined(&queue);
	undef(&queue_t) if defined(&queue_t);
	eval 'sub queue_t () { &pse_queue_t;}' unless defined(&queue_t);
    }
    unless(defined(&MSG_KERNEL_FIELDS)) {
	eval 'sub MSG_KERNEL_FIELDS () {1;}' unless defined(&MSG_KERNEL_FIELDS);
    }
    eval 'sub b_emul () { &b_pad1;}' unless defined(&b_emul);
    eval 'sub MSGMARK () {0x1;}' unless defined(&MSGMARK);
    eval 'sub MSGNOLOOP () {0x2;}' unless defined(&MSGNOLOOP);
    eval 'sub MSGDELIM () {0x4;}' unless defined(&MSGDELIM);
    eval 'sub MSGCOMPRESS () {0x100;}' unless defined(&MSGCOMPRESS);
    eval 'sub MSGNOTIFY () {0x200;}' unless defined(&MSGNOTIFY);
    eval 'sub MSGPKT () {0x400;}' unless defined(&MSGPKT);
    eval 'sub MSG64BIT () {0x800;}' unless defined(&MSG64BIT);
    eval 'sub MSGIA32BIN () {0x1000;}' unless defined(&MSGIA32BIN);
    eval 'sub MSGATTR () {0x8000;}' unless defined(&MSGATTR);
    eval 'sub db_freep () { ($db_f->{freep});}' unless defined(&db_freep);
    eval 'sub db_frtnp () { ($db_f->{frtnp});}' unless defined(&db_frtnp);
    unless(defined(&QUEUE_KERNEL_FIELDS)) {
	eval 'sub QUEUE_KERNEL_FIELDS () {1;}' unless defined(&QUEUE_KERNEL_FIELDS);
    }
    eval 'sub QREADR () {0x1;}' unless defined(&QREADR);
    eval 'sub QNOENB () {0x2;}' unless defined(&QNOENB);
    eval 'sub QFULL () {0x4;}' unless defined(&QFULL);
    eval 'sub QWANTR () {0x8;}' unless defined(&QWANTR);
    eval 'sub QWANTW () {0x10;}' unless defined(&QWANTW);
    eval 'sub QUSE () {0x20;}' unless defined(&QUSE);
    eval 'sub QENAB () {0x40;}' unless defined(&QENAB);
    eval 'sub QBACK () {0x80;}' unless defined(&QBACK);
    eval 'sub QOLD () {0x100;}' unless defined(&QOLD);
    eval 'sub QHLIST () {0x200;}' unless defined(&QHLIST);
    eval 'sub QFUN () {0x400;}' unless defined(&QFUN);
    eval 'sub QSAFE () {0x2000;}' unless defined(&QSAFE);
    eval 'sub QWELDED () {0x4000;}' unless defined(&QWELDED);
    eval 'sub QNOTTOSPEC () {0x8000;}' unless defined(&QNOTTOSPEC);
    eval 'sub NODEV () {( &dev_t)(-1);}' unless defined(&NODEV);
    eval 'sub QB_FULL () {0x1;}' unless defined(&QB_FULL);
    eval 'sub QB_WANTW () {0x2;}' unless defined(&QB_WANTW);
    eval 'sub QB_BACK () {0x4;}' unless defined(&QB_BACK);
    eval 'sub ioc_count () { ($ioc_cnt->{ul});}' unless defined(&ioc_count);
    eval 'sub ioc_uid () { ($ioc_cr->{cr_uid});}' unless defined(&ioc_uid);
    eval 'sub ioc_gid () { ($ioc_cr->{cr_gid});}' unless defined(&ioc_gid);
    eval 'sub cq_addr () { ($cq_ad->{cp});}' unless defined(&cq_addr);
    eval 'sub cq_uid () { ($cq_cr->{cr_uid});}' unless defined(&cq_uid);
    eval 'sub cq_gid () { ($cq_cr->{cr_gid});}' unless defined(&cq_gid);
    if(defined(&_KERNEL)) {
    }
    eval 'sub cp_rval () { ($cp_rv->{l});}' unless defined(&cp_rval);
    eval 'sub cp_uid () { ($cp_cr->{cr_uid});}' unless defined(&cp_uid);
    eval 'sub cp_gid () { ($cp_cr->{cr_gid});}' unless defined(&cp_gid);
    eval 'sub TRANSPARENT () {(-32768);}' unless defined(&TRANSPARENT);
    eval 'sub QNORM () {0;}' unless defined(&QNORM);
    eval 'sub M_DATA () {0x;}' unless defined(&M_DATA);
    eval 'sub M_PROTO () {0x1;}' unless defined(&M_PROTO);
    eval 'sub M_BREAK () {0x8;}' unless defined(&M_BREAK);
    eval 'sub M_PASSFP () {0x9;}' unless defined(&M_PASSFP);
    eval 'sub M_SIG () {0xb;}' unless defined(&M_SIG);
    eval 'sub M_DELAY () {0xc;}' unless defined(&M_DELAY);
    eval 'sub M_CTL () {0xd;}' unless defined(&M_CTL);
    eval 'sub M_IOCTL () {0xe;}' unless defined(&M_IOCTL);
    eval 'sub M_SETOPTS () {0x10;}' unless defined(&M_SETOPTS);
    eval 'sub M_RSE () {0x11;}' unless defined(&M_RSE);
    eval 'sub M_TTY () {0x12;}' unless defined(&M_TTY);
    eval 'sub QPCTL () {0x80;}' unless defined(&QPCTL);
    eval 'sub M_IOCACK () {0x81;}' unless defined(&M_IOCACK);
    eval 'sub M_IOCNAK () {0x82;}' unless defined(&M_IOCNAK);
    eval 'sub M_PCPROTO () {0x83;}' unless defined(&M_PCPROTO);
    eval 'sub M_PCSIG () {0x84;}' unless defined(&M_PCSIG);
    eval 'sub M_READ () {0x85;}' unless defined(&M_READ);
    eval 'sub M_FLUSH () {0x86;}' unless defined(&M_FLUSH);
    eval 'sub M_STOP () {0x87;}' unless defined(&M_STOP);
    eval 'sub M_START () {0x88;}' unless defined(&M_START);
    eval 'sub M_HANGUP () {0x89;}' unless defined(&M_HANGUP);
    eval 'sub M_ERROR () {0x8a;}' unless defined(&M_ERROR);
    eval 'sub M_COPYIN () {0x8b;}' unless defined(&M_COPYIN);
    eval 'sub M_COPYOUT () {0x8c;}' unless defined(&M_COPYOUT);
    eval 'sub M_IOCDATA () {0x8d;}' unless defined(&M_IOCDATA);
    eval 'sub M_PCRSE () {0x8e;}' unless defined(&M_PCRSE);
    eval 'sub M_STOPI () {0x8f;}' unless defined(&M_STOPI);
    eval 'sub M_STARTI () {0x90;}' unless defined(&M_STARTI);
    eval 'sub M_HPDATA () {0x93;}' unless defined(&M_HPDATA);
    eval 'sub M_NOTIFY () {0x94;}' unless defined(&M_NOTIFY);
    eval 'sub M_LETSPLAY () {0x95;}' unless defined(&M_LETSPLAY);
    eval 'sub M_DONTPLAY () {0x96;}' unless defined(&M_DONTPLAY);
    eval 'sub M_BACKWASH () {0x97;}' unless defined(&M_BACKWASH);
    eval 'sub M_BACKDONE () {0x98;}' unless defined(&M_BACKDONE);
    eval 'sub M_PCTTY () {0x99;}' unless defined(&M_PCTTY);
    eval 'sub M_COPYIN64 () {0x9a;}' unless defined(&M_COPYIN64);
    eval 'sub M_COPYOUT64 () {0x9b;}' unless defined(&M_COPYOUT64);
    eval 'sub FLUSHALL () {0x1;}' unless defined(&FLUSHALL);
    eval 'sub FLUSHDATA () {0x;}' unless defined(&FLUSHDATA);
    eval 'sub NOERROR () {-1;}' unless defined(&NOERROR);
    eval 'sub SO_ALL () {(~0);}' unless defined(&SO_ALL);
    eval 'sub SO_READOPT () {0x1;}' unless defined(&SO_READOPT);
    eval 'sub SO_WROFF () {0x2;}' unless defined(&SO_WROFF);
    eval 'sub SO_MINPSZ () {0x4;}' unless defined(&SO_MINPSZ);
    eval 'sub SO_MAXPSZ () {0x8;}' unless defined(&SO_MAXPSZ);
    eval 'sub SO_HIWAT () {0x10;}' unless defined(&SO_HIWAT);
    eval 'sub SO_LOWAT () {0x20;}' unless defined(&SO_LOWAT);
    eval 'sub SO_MREADON () {0x40;}' unless defined(&SO_MREADON);
    eval 'sub SO_MREADOFF () {0x80;}' unless defined(&SO_MREADOFF);
    eval 'sub SO_ISTTY () {0x100;}' unless defined(&SO_ISTTY);
    eval 'sub SO_ISNTTY () {0x200;}' unless defined(&SO_ISNTTY);
    eval 'sub SO_NDELON () {0x400;}' unless defined(&SO_NDELON);
    eval 'sub SO_NDELOFF () {0x800;}' unless defined(&SO_NDELOFF);
    eval 'sub SO_TOSTOP () {0x1000;}' unless defined(&SO_TOSTOP);
    eval 'sub SO_TONSTOP () {0x2000;}' unless defined(&SO_TONSTOP);
    eval 'sub SO_BAND () {0x4000;}' unless defined(&SO_BAND);
    eval 'sub SO_MSGATTR () {0x8000;}' unless defined(&SO_MSGATTR);
    eval 'sub SO_PTY () {0x10000;}' unless defined(&SO_PTY);
    eval 'sub BPRI_LO () {1;}' unless defined(&BPRI_LO);
    eval 'sub BPRI_MED () {2;}' unless defined(&BPRI_MED);
    eval 'sub BPRI_HI () {3;}' unless defined(&BPRI_HI);
    eval 'sub BPRI_WAITOK () {255;}' unless defined(&BPRI_WAITOK);
    eval 'sub datamsg {
        my($type) = @_;
	    eval q((($type) ==  &M_DATA || ($type) ==  &M_PROTO || ($type) ==  &M_PCPROTO || ($type) ==  &M_DELAY));
    }' unless defined(&datamsg);
    eval 'sub OTHERQ {
        my($q) = @_;
	    eval q((($q)-> &q_other));
    }' unless defined(&OTHERQ);
    eval 'sub RD {
        my($q) = @_;
	    eval q( &OTHERQ($q));
    }' unless defined(&RD);
    eval 'sub WR {
        my($q) = @_;
	    eval q( &OTHERQ($q));
    }' unless defined(&WR);
    eval 'sub OPENFAIL () {(-1);}' unless defined(&OPENFAIL);
    eval 'sub CLONEOPEN () {0x2;}' unless defined(&CLONEOPEN);
    eval 'sub MODOPEN () {0x1;}' unless defined(&MODOPEN);
    eval 'sub NSTRPUSH () {9;}' unless defined(&NSTRPUSH);
    eval 'sub STRMSGSZ () {0;}' unless defined(&STRMSGSZ);
    eval 'sub STRCTLSZ () {1024;}' unless defined(&STRCTLSZ);
    eval 'sub STRLOFRAC () {80;}' unless defined(&STRLOFRAC);
    eval 'sub STRMEDFRAC () {90;}' unless defined(&STRMEDFRAC);
    eval 'sub STRTHRESH () {0;}' unless defined(&STRTHRESH);
    eval 'sub NSTREVENT () {20;}' unless defined(&NSTREVENT);
    eval 'sub STRTURNCNT () {15;}' unless defined(&STRTURNCNT);
    unless(defined(&__ia64)) {
	unless(defined(&__64BIT_KERNEL)) {
	    eval 'sub PSEINTRSTACK () {12288;}' unless defined(&PSEINTRSTACK);
	} else {
	    eval 'sub PSEINTRSTACK () {24576;}' unless defined(&PSEINTRSTACK);
	}
    } else {
	eval 'sub PSEINTRSTACK () {32768;}' unless defined(&PSEINTRSTACK);
    }
    eval 'sub PSETHRESH () {85;}' unless defined(&PSETHRESH);
    eval 'sub STRLOWTHRESH () {90;}' unless defined(&STRLOWTHRESH);
    eval 'sub STRMEDTHRESH () {95;}' unless defined(&STRMEDTHRESH);
    eval 'sub INFPSZ () {(-1);}' unless defined(&INFPSZ);
    eval 'sub FMNAMESZ () {8;}' unless defined(&FMNAMESZ);
    eval("sub QHIWAT () { 0; }") unless defined(&QHIWAT);
    eval("sub QLOWAT () { 1; }") unless defined(&QLOWAT);
    eval("sub QMAXPSZ () { 2; }") unless defined(&QMAXPSZ);
    eval("sub QMINPSZ () { 3; }") unless defined(&QMINPSZ);
    eval("sub QCOUNT () { 4; }") unless defined(&QCOUNT);
    eval("sub QFIRST () { 5; }") unless defined(&QFIRST);
    eval("sub QLAST () { 6; }") unless defined(&QLAST);
    eval("sub QFLAG () { 7; }") unless defined(&QFLAG);
    eval("sub QBAD () { 8; }") unless defined(&QBAD);
    eval 'sub W_SIGIO () {0x1;}' unless defined(&W_SIGIO);
    eval 'sub W_LOCKME () {0x2;}' unless defined(&W_LOCKME);
    eval 'sub MTTY_VERSION () {0x1;}' unless defined(&MTTY_VERSION);
    eval 'sub S_READGONE () {0x1;}' unless defined(&S_READGONE);
    eval 'sub S_IOCTLGONE () {0x2;}' unless defined(&S_IOCTLGONE);
    eval 'sub S_LETSPLAY () {0x3;}' unless defined(&S_LETSPLAY);
    eval 'sub S_DONTPLAY () {0x4;}' unless defined(&S_DONTPLAY);
    eval 'sub S_BACKWASH () {0x5;}' unless defined(&S_BACKWASH);
    eval 'sub S_BACKDONE () {0x6;}' unless defined(&S_BACKDONE);
    eval 'sub S_DRAINO () {0x7;}' unless defined(&S_DRAINO);
    eval 'sub S_DRAIN_ACK () {0x8;}' unless defined(&S_DRAIN_ACK);
    unless(defined(&max)) {
	eval 'sub max {
	    my($x1,$x2) = @_;
    	    eval q((($x1) >= ($x2) ? ($x1) : ($x2)));
	}' unless defined(&max);
    }
    unless(defined(&min)) {
	eval 'sub min {
	    my($x1,$x2) = @_;
    	    eval q((($x1) <= ($x2) ? ($x1) : ($x2)));
	}' unless defined(&min);
    }
    if(defined(&_KERNEL)) {
	eval 'sub getmajor () { &major_num;}' unless defined(&getmajor);
	eval 'sub getminor () { &minor_num;}' unless defined(&getminor);
	eval 'sub getemajor () { &major_num;}' unless defined(&getemajor);
	eval 'sub geteminor () { &minor_num;}' unless defined(&geteminor);
	eval 'sub makedevice () { &makedevno;}' unless defined(&makedevice);
	undef(&bufcall) if defined(&bufcall);
	eval 'sub bufcall {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &pse_bufcall(($a), ($b), ( &bufcall_fcn_t)($c), ( &bufcall_arg_t)($d)));
	}' unless defined(&bufcall);
	undef(&timeout) if defined(&timeout);
	eval 'sub timeout {
	    my($a,$b,$c) = @_;
    	    eval q( &pse_timeout(( &timeout_fcn_t)($a),( &timeout_arg_t)($b),$c));
	}' unless defined(&timeout);
	undef(&untimeout) if defined(&untimeout);
	eval 'sub untimeout () { &pse_untimeout;}' unless defined(&untimeout);
	undef(&timeoutcf) if defined(&timeoutcf);
	eval 'sub timeoutcf () { &pse_timeout_cf;}' unless defined(&timeoutcf);
	undef(&sleepx) if defined(&sleepx);
	eval 'sub sleepx {
	    my($a, $b, $c) = @_;
    	    eval q( &pse_sleepx(($a),($b),($c)));
	}' unless defined(&sleepx);
	undef(&e_sleep) if defined(&e_sleep);
	eval 'sub e_sleep {
	    my($a, $b) = @_;
    	    eval q( &pse_sleep(($a),($b)));
	}' unless defined(&e_sleep);
	undef(&e_sleepl) if defined(&e_sleepl);
	eval 'sub e_sleepl {
	    my($a, $b, $c) = @_;
    	    eval q( &pse_sleepl(($a),($b),($c)));
	}' unless defined(&e_sleepl);
	undef(&e_sleep_thread) if defined(&e_sleep_thread);
	eval 'sub e_sleep_thread {
	    my($a, $b, $c) = @_;
    	    eval q( &pse_sleep_thread(($a),($b),($c)));
	}' unless defined(&e_sleep_thread);
	undef(&e_block_thread) if defined(&e_block_thread);
	eval 'sub e_block_thread () {
	    eval q( &pse_block_thread());
	}' unless defined(&e_block_thread);
	if(defined(&__64BIT_KERNEL)) {
	    eval 'sub fdinsert_q64p {
	        my($mp, $offset) = @_;
    		eval q(*( &queue_t **)( ($mp->{b_rptr}) + $offset));
	    }' unless defined(&fdinsert_q64p);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
