require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SYSCONFIG)) {
    eval 'sub _H_SYSCONFIG () {1;}' unless defined(&_H_SYSCONFIG);
    require 'sys/types.ph';
    require 'sys/lock_def.ph';
    eval 'sub CONF_SUCC () {0;}' unless defined(&CONF_SUCC);
    eval 'sub CONF_FAIL () {-1;}' unless defined(&CONF_FAIL);
    eval 'sub SYS_KLOAD () {0x1;}' unless defined(&SYS_KLOAD);
    eval 'sub SYS_SINGLELOAD () {0x2;}' unless defined(&SYS_SINGLELOAD);
    eval 'sub SYS_QUERYLOAD () {0x3;}' unless defined(&SYS_QUERYLOAD);
    eval 'sub SYS_KULOAD () {0x4;}' unless defined(&SYS_KULOAD);
    eval 'sub SYS_CFGKMOD () {0x5;}' unless defined(&SYS_CFGKMOD);
    eval 'sub SYS_CFGDD () {0x6;}' unless defined(&SYS_CFGDD);
    eval 'sub SYS_QDVSW () {0x7;}' unless defined(&SYS_QDVSW);
    eval 'sub SYS_GETPARMS () {0x8;}' unless defined(&SYS_GETPARMS);
    eval 'sub SYS_SETPARMS () {0x9;}' unless defined(&SYS_SETPARMS);
    eval 'sub SYS_SEC_MODE () {0xa;}' unless defined(&SYS_SEC_MODE);
    eval 'sub SET_SECURE_NLSPATH () {0xb;}' unless defined(&SET_SECURE_NLSPATH);
    eval 'sub GET_SECURE_NLSPATH () {0xc;}' unless defined(&GET_SECURE_NLSPATH);
    eval 'sub SYS_GETLPAR_INFO () {0xd;}' unless defined(&SYS_GETLPAR_INFO);
    eval 'sub SET_COREPATH () {0xe;}' unless defined(&SET_COREPATH);
    eval 'sub GET_COREPATH () {0xf;}' unless defined(&GET_COREPATH);
    eval 'sub NLSPATH_MAX () {1024;}' unless defined(&NLSPATH_MAX);
    eval 'sub SYS_64BIT () {0x80000000;}' unless defined(&SYS_64BIT);
    eval 'sub SYS_64L () {0x40000000;}' unless defined(&SYS_64L);
    eval 'sub LPAR_ENABLED () {0x1;}' unless defined(&LPAR_ENABLED);
    eval 'sub LPAR_CAPABLE () {0x2;}' unless defined(&LPAR_CAPABLE);
    eval 'sub CFGV_PREPARE () {0x1;}' unless defined(&CFGV_PREPARE);
    eval 'sub CFGV_COMMIT () {0x2;}' unless defined(&CFGV_COMMIT);
    unless(defined(&_NO_PROTO)) {
    } else {
    }
    if(defined(&_KERNEL)) {
	if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
	}
    }
    eval 'sub OFFSET_VLOCK () {((0)-> &v_lock);}' unless defined(&OFFSET_VLOCK);
    eval 'sub OFFSET_VFILE () {((0)-> &v_file);}' unless defined(&OFFSET_VFILE);
    eval 'sub OFFSET_VPROC () {((0)-> &v_proc);}' unless defined(&OFFSET_VPROC);
    eval 'sub OFFSET_VCLIST () {((0)-> &v_clist);}' unless defined(&OFFSET_VCLIST);
    eval 'sub OFFSET_VTHREAD () {((0)-> &v_thread);}' unless defined(&OFFSET_VTHREAD);
    eval 'sub OFFSET_VNCPUS () {((0)-> &v_ncpus);}' unless defined(&OFFSET_VNCPUS);
    eval 'sub OFFSET_VNCPUSCFG () {((0)-> &v_ncpus_cfg);}' unless defined(&OFFSET_VNCPUSCFG);
    eval 'sub OFFSET_VELOCK () {((0)-> &ve_lock);}' unless defined(&OFFSET_VELOCK);
    eval 'sub OFFSET_VEFILE () {((0)-> &ve_file);}' unless defined(&OFFSET_VEFILE);
    eval 'sub OFFSET_VEPROC () {((0)-> &ve_proc);}' unless defined(&OFFSET_VEPROC);
    eval 'sub OFFSET_VETHREAD () {((0)-> &ve_thread);}' unless defined(&OFFSET_VETHREAD);
    eval 'sub OFFSET_VBPROC () {((0)-> &vb_proc);}' unless defined(&OFFSET_VBPROC);
    eval 'sub OFFSET_VBTHREAD () {((0)-> &vb_thread);}' unless defined(&OFFSET_VBTHREAD);
    eval 'sub NUM_VARS () {13;}' unless defined(&NUM_VARS);
}
1;
