require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_TERMIO)) {
    eval 'sub _H_TERMIO () {1;}' unless defined(&_H_TERMIO);
    require 'standards.ph';
    require 'sys/ioctl.ph';
    require 'sys/ttmap.ph';
    require 'termios.ph';
    eval 'sub CBELL () {ord(\'\\007\');}' unless defined(&CBELL);
    eval 'sub CDEL () {ord(\'\\177\');}' unless defined(&CDEL);
    eval 'sub CEOF () {ord(\'\\004\');}' unless defined(&CEOF);
    eval 'sub CERASE () {ord(\'\\010\');}' unless defined(&CERASE);
    eval 'sub CESC () {ord(\'\\\\\');}' unless defined(&CESC);
    eval 'sub CFORM () {ord(\'\\014\');}' unless defined(&CFORM);
    eval 'sub CINTR () {ord(\'\\003\');}' unless defined(&CINTR);
    eval 'sub CKILL () {ord(\'\\025\');}' unless defined(&CKILL);
    eval 'sub CNUL () {ord(\'\\0\');}' unless defined(&CNUL);
    eval 'sub CQUIT () {ord(\'\\034\');}' unless defined(&CQUIT);
    eval 'sub CSTART () {ord(\'\\021\');}' unless defined(&CSTART);
    eval 'sub CSTOP () {ord(\'\\023\');}' unless defined(&CSTOP);
    eval 'sub CVT () {ord(\'\\013\');}' unless defined(&CVT);
    eval 'sub NCC () {8;}' unless defined(&NCC);
    eval 'sub PAGE_SETL () {04;}' unless defined(&PAGE_SETL);
    eval 'sub PAGE_MSK () {03;}' unless defined(&PAGE_MSK);
    eval 'sub PAGE_ON () {01;}' unless defined(&PAGE_ON);
    eval 'sub PAGE_OFF () {02;}' unless defined(&PAGE_OFF);
    unless(defined(&PAGE_ENB)) {
	eval 'sub PAGE_ENB () { &PAGE_ON;}' unless defined(&PAGE_ENB);
    }
    eval 'sub TIOC () {(ord(\'T\')<<8);}' unless defined(&TIOC);
    eval 'sub TCGETS () {( &TIOC|1);}' unless defined(&TCGETS);
    eval 'sub TCSETS () {( &TIOC|2);}' unless defined(&TCSETS);
    eval 'sub TCSETSW () {( &TIOC|3);}' unless defined(&TCSETSW);
    eval 'sub TCSETSF () {( &TIOC|4);}' unless defined(&TCSETSF);
    eval 'sub TCGETA () {( &TIOC|5);}' unless defined(&TCGETA);
    eval 'sub TCSETA () {( &TIOC|6);}' unless defined(&TCSETA);
    eval 'sub TCSETAW () {( &TIOC|7);}' unless defined(&TCSETAW);
    eval 'sub TCSETAF () {( &TIOC|8);}' unless defined(&TCSETAF);
    eval 'sub TCSBRK () {( &TIOC|9);}' unless defined(&TCSBRK);
    eval 'sub TCSBREAK () {( &TIOC|10);}' unless defined(&TCSBREAK);
    eval 'sub TCXONC () {( &TIOC|11);}' unless defined(&TCXONC);
    eval 'sub TCFLSH () {( &TIOC|12);}' unless defined(&TCFLSH);
    eval 'sub TCGLEN () {( &TIOC|13);}' unless defined(&TCGLEN);
    eval 'sub TCSLEN () {( &TIOC|14);}' unless defined(&TCSLEN);
    eval 'sub TCSAK () {( &TIOC|15);}' unless defined(&TCSAK);
    eval 'sub TCQSAK () {( &TIOC|16);}' unless defined(&TCQSAK);
    eval 'sub TCTRUST () {( &TIOC|17);}' unless defined(&TCTRUST);
    eval 'sub TCQTRUST () {( &TIOC|18);}' unless defined(&TCQTRUST);
    eval 'sub TCSMAP () {( &TIOC|19);}' unless defined(&TCSMAP);
    eval 'sub TCGMAP () {( &TIOC|20);}' unless defined(&TCGMAP);
    eval 'sub TCKEP () {( &TIOC|21);}' unless defined(&TCKEP);
    eval 'sub TCGSAK () {( &TIOC|22);}' unless defined(&TCGSAK);
    eval 'sub TCLOOP () {( &TIOC|23);}' unless defined(&TCLOOP);
    eval 'sub TCVPD () {( &TIOC|24);}' unless defined(&TCVPD);
    eval 'sub TCREG () {( &TIOC|25);}' unless defined(&TCREG);
    eval 'sub TCGSTATUS () {( &TIOC|26);}' unless defined(&TCGSTATUS);
    eval 'sub TCSCONTROL () {( &TIOC|27);}' unless defined(&TCSCONTROL);
    eval 'sub TCSCSMAP () {( &TIOC|28);}' unless defined(&TCSCSMAP);
    eval 'sub TCGCSMAP () {( &TIOC|29);}' unless defined(&TCGCSMAP);
    eval 'sub TCMGR () { &TCSAK;}' unless defined(&TCMGR);
    eval 'sub TCQMGR () { &TCQSAK;}' unless defined(&TCQMGR);
    eval 'sub TIONREAD () { &FIONREAD;}' unless defined(&TIONREAD);
    eval 'sub TCSAKOFF () {0;}' unless defined(&TCSAKOFF);
    eval 'sub TCSAKON () {1;}' unless defined(&TCSAKON);
    eval 'sub TCUNTRUSTED () {0;}' unless defined(&TCUNTRUSTED);
    eval 'sub TCTRUSTED () {1;}' unless defined(&TCTRUSTED);
}
1;
