require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SYS_TIME)) {
    eval 'sub _H_SYS_TIME () {1;}' unless defined(&_H_SYS_TIME);
    unless(defined(&_H_STANDARDS)) {
	require 'standards.ph';
    }
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0)==1) {
	eval 'sub ITIMER_REAL () {0;}' unless defined(&ITIMER_REAL);
	eval 'sub ITIMER_VIRTUAL () {1;}' unless defined(&ITIMER_VIRTUAL);
	eval 'sub ITIMER_PROF () {2;}' unless defined(&ITIMER_PROF);
	eval 'sub ITIMER_VIRT () {3;}' unless defined(&ITIMER_VIRT);
	eval 'sub ITIMER_REAL1 () {20;}' unless defined(&ITIMER_REAL1);
	if(defined( &__64BIT__) || ((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) == 500)) {
	} else {
	}
	if(defined(&_ALL_SOURCE)) {
	    eval 'sub CP_TIMEVAL {
	        my($__tsrc, $__tdest) = @_;
    		eval q(($__tdest). &tv_sec = ($__tsrc). &tv_sec; ($__tdest). &tv_usec = ($__tsrc). &tv_usec);
	    }' unless defined(&CP_TIMEVAL);
	    if(defined(&_LONG_LONG)) {
		if(defined( &__ia64)  && !defined( &__64BIT__)) {
		}
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	unless(defined(&FD_SETSIZE)) {
	    eval 'sub FD_SETSIZE () {32767;}' unless defined(&FD_SETSIZE);
	}
	eval 'sub __NFDBITS () {($sizeof{\'long\'} * 8);}' unless defined(&__NFDBITS);
	eval 'sub __NUM_ENTRIES () {( &FD_SETSIZE/ &__NFDBITS+1);}' unless defined(&__NUM_ENTRIES);
	if(defined(&_ALL_SOURCE)) {
	}
	if(defined(&_NO_PROTO)) {
	} else {
	    unless(defined(&_KERNEL)) {
	    } else {
	    }
	}
	if(defined( &__cplusplus)  && !defined( &_H_STRING)) {
	    if(defined(&_NO_PROTO)) {
	    } else {
	    }
	}
	unless(defined(&_ALL_SOURCE)) {
	    if(defined(&_NO_PROTO)) {
	    } else {
	    }
	    eval 'sub FD_ZERO {
	        my($p) = @_;
    		eval q({  &fd_set * &__q=$p;  &memset(( &__q), 0, $sizeof{( &__q)}); });
	    }' unless defined(&FD_ZERO);
	} else {
	    eval 'sub FD_SET {
	        my($n, $p) = @_;
    		eval q((-> $fds_bits[/ &__NFDBITS] |= (1<< (($n) %  &__NFDBITS))));
	    }' unless defined(&FD_SET);
	    eval 'sub FD_CLR {
	        my($n, $p) = @_;
    		eval q((-> $fds_bits[/ &__NFDBITS] &= ~(1<< (($n) %  &__NFDBITS))));
	    }' unless defined(&FD_CLR);
	    eval 'sub FD_ISSET {
	        my($n, $p) = @_;
    		eval q(((-> $fds_bits[/ &__NFDBITS] & (1<< (($n) %  &__NFDBITS)))?1:0));
	    }' unless defined(&FD_ISSET);
	    eval 'sub FD_ZERO {
	        my($p) = @_;
    		eval q( &memset(($p), 0, $sizeof{($p)}));
	    }' unless defined(&FD_ZERO);
	}
    }
    if(defined(&_ALL_SOURCE)) {
	eval 'sub TIMEOFDAY () {9;}' unless defined(&TIMEOFDAY);
	eval 'sub TIMERID_ALRM () {( &ITIMER_REAL);}' unless defined(&TIMERID_ALRM);
	eval 'sub TIMERID_REAL () {( &ITIMER_REAL);}' unless defined(&TIMERID_REAL);
	eval 'sub TIMERID_VIRTUAL () {( &ITIMER_VIRTUAL);}' unless defined(&TIMERID_VIRTUAL);
	eval 'sub TIMERID_PROF () {( &ITIMER_PROF);}' unless defined(&TIMERID_PROF);
	eval 'sub TIMERID_VIRT () {( &ITIMER_VIRT);}' unless defined(&TIMERID_VIRT);
	eval 'sub TIMERID_TOD () {( &TIMERID_VIRT+1);}' unless defined(&TIMERID_TOD);
	eval 'sub TIMERID_REAL1 () {( &ITIMER_REAL1);}' unless defined(&TIMERID_REAL1);
	eval 'sub NALRM () {1;}' unless defined(&NALRM);
	eval 'sub NPROF () {1;}' unless defined(&NPROF);
	eval 'sub NVIRTUAL () {2;}' unless defined(&NVIRTUAL);
	eval 'sub NTIMEOFDAY () {5;}' unless defined(&NTIMEOFDAY);
	eval 'sub NTIMERS () {( &NALRM +  &NPROF +  &NVIRTUAL +  &NTIMEOFDAY);}' unless defined(&NTIMERS);
	eval 'sub NALRM_THREAD () {1;}' unless defined(&NALRM_THREAD);
	eval 'sub NTIMERS_THREAD () {( &NALRM_THREAD);}' unless defined(&NTIMERS_THREAD);
	eval 'sub MIN_SECS_SINCE_EPOCH () {0;}' unless defined(&MIN_SECS_SINCE_EPOCH);
	eval 'sub NS_PER_TICK () {( &NS_PER_SEC/ &HZ);}' unless defined(&NS_PER_TICK);
	eval 'sub uS_PER_SECOND () {(1000000);}' unless defined(&uS_PER_SECOND);
	eval 'sub NS_PER_uS () {(1000);}' unless defined(&NS_PER_uS);
	eval 'sub MAX_SECS_TO_uS () {4000;}' unless defined(&MAX_SECS_TO_uS);
	eval 'sub MAX_NS_TO_uS () {294967296;}' unless defined(&MAX_NS_TO_uS);
	eval 'sub NS_PER_SEC () {1000000000;}' unless defined(&NS_PER_SEC);
	eval 'sub uS_PER_SEC () {( &NS_PER_SEC / 1000);}' unless defined(&uS_PER_SEC);
	eval 'sub NS_PER_MSEC () {( &NS_PER_SEC / 1000);}' unless defined(&NS_PER_MSEC);
	eval 'sub MAX_DEC_SECS () {2;}' unless defined(&MAX_DEC_SECS);
	eval 'sub MAX_DEC_NS () {147483647;}' unless defined(&MAX_DEC_NS);
	if(defined(&_ALL_SOURCE)) {
	    if(defined( &_ALL_SOURCE)  && (defined( &__64BIT__) || defined( &_LONG_LONG))) {
	    }
	    eval 'sub CP_TIMESTRUCT {
	        my($__tsrc, $__tdest) = @_;
    		eval q(($__tdest). &tv_sec = ($__tsrc). &tv_sec; ($__tdest). &tv_nsec = ($__tsrc). &tv_nsec);
	    }' unless defined(&CP_TIMESTRUCT);
	}
	if(defined(&_ALL_SOURCE)) {
	    if(defined( &_ALL_SOURCE)  && (defined( &__64BIT__) || defined( &_LONG_LONG))) {
	    }
	    eval 'sub CP_ITIMERSTRUCT {
	        my($__tsrc, $__tdest) = @_;
    		eval q(($__tdest). ($it_interval->{tv_sec})  = ($__tsrc). ($it_interval->{tv_sec}); ($__tdest). ($it_interval->{tv_nsec}) = ($__tsrc). ($it_interval->{tv_nsec}); ($__tdest). ($it_value->{tv_sec})  = ($__tsrc). ($it_value->{tv_sec}); ($__tdest). ($it_value->{tv_nsec})  = ($__tsrc). ($it_value->{tv_nsec}));
	    }' unless defined(&CP_ITIMERSTRUCT);
	}
	eval 'sub TIMEBASE_SZ () {($sizeof{\'struct timebasestruct\'});}' unless defined(&TIMEBASE_SZ);
	if(defined(&_KERNEL)) {
	}
	eval 'sub ntimerisset {
	    my($tvp) = @_;
    	    eval q((($tvp)-> &tv_sec || ($tvp)-> &tv_nsec));
	}' unless defined(&ntimerisset);
	eval 'sub ntimerclear {
	    my($tvp) = @_;
    	    eval q(($tvp)-> &tv_sec = ($tvp)-> &tv_nsec = 0);
	}' unless defined(&ntimerclear);
	eval 'sub ntimercmp {
	    my($tvp, $fvp, $cmp) = @_;
    	    eval q((($tvp). &tv_sec $cmp ($fvp). &tv_sec || ($tvp). &tv_sec == ($fvp). &tv_sec  && ($tvp). &tv_nsec $cmp ($fvp). &tv_nsec));
	}' unless defined(&ntimercmp);
	eval 'sub ntimeradd {
	    my($tvp, $svp, $rvp) = @_;
    	    eval q({ ($rvp). &tv_sec = ($tvp). &tv_sec + ($svp). &tv_sec; ($rvp). &tv_nsec = ($tvp). &tv_nsec + ($svp). &tv_nsec;  &if(($rvp). &tv_nsec > ( &NS_PER_SEC - 1)) { ($rvp). &tv_nsec -=  &NS_PER_SEC; ($rvp). &tv_sec++; }  &assert(($rvp). &tv_nsec <  &NS_PER_SEC); });
	}' unless defined(&ntimeradd);
	eval 'sub ntimersub {
	    my($tvp, $svp, $rvp) = @_;
    	    eval q({  &assert(. &tv_nsec <=  &NS_PER_SEC);  &assert(. &tv_nsec <=  &NS_PER_SEC);  &assert(!(. &tv_sec == 0 && (. &tv_nsec > . &tv_nsec)));  &if(. &tv_sec == . &tv_sec) {  &assert(. &tv_nsec >= . &tv_nsec); }  &else {  &assert(. &tv_sec > . &tv_sec); }  &if(. &tv_nsec > . &tv_nsec) {  &assert(. &tv_sec > . &tv_sec); . &tv_sec = (. &tv_sec - 1) - . &tv_sec; . &tv_nsec = ((((. &tv_nsec) +  &NS_PER_SEC) - (($svp). &tv_nsec))); }  &else { ($rvp). &tv_sec = ($tvp). &tv_sec - ($svp). &tv_sec; ($rvp). &tv_nsec = ($tvp). &tv_nsec - ($svp). &tv_nsec; }  &assert(($tvp). &tv_nsec <=  &NS_PER_SEC);  &assert(($svp). &tv_nsec <=  &NS_PER_SEC);  &assert(($rvp). &tv_nsec <=  &NS_PER_SEC); });
	}' unless defined(&ntimersub);
	eval 'sub timerisset {
	    my($tvp) = @_;
    	    eval q((($tvp)-> &tv_sec || ($tvp)-> &tv_usec));
	}' unless defined(&timerisset);
	eval 'sub timerclear {
	    my($tvp) = @_;
    	    eval q(($tvp)-> &tv_sec = ($tvp)-> &tv_usec = 0);
	}' unless defined(&timerclear);
	eval 'sub timercmp {
	    my($tvp, $fvp, $cmp) = @_;
    	    eval q((($tvp)-> &tv_sec $cmp ($fvp)-> &tv_sec || ($tvp)-> &tv_sec == ($fvp)-> &tv_sec  && ($tvp)-> &tv_usec $cmp ($fvp)-> &tv_usec));
	}' unless defined(&timercmp);
	eval 'sub ADD_TO_NS {
	    my($tvp, $delta) = @_;
    	    eval q({ ($tvp). &tv_nsec += $delta;  &if(($tvp). &tv_nsec >=  &NS_PER_SEC) { ($tvp). &tv_sec++; ($tvp). &tv_nsec -=  &NS_PER_SEC; } });
	}' unless defined(&ADD_TO_NS);
	eval 'sub ADD_NS_TO_TIMEVAL {
	    my($tvp, $delta) = @_;
    	    eval q({ ($tvp). &tv_usec += $delta;  &if(($tvp). &tv_usec >=  &NS_PER_SEC) { ($tvp). &tv_sec++; ($tvp). &tv_usec -=  &NS_PER_SEC; } });
	}' unless defined(&ADD_NS_TO_TIMEVAL);
	eval 'sub DST_NONE () {0;}' unless defined(&DST_NONE);
	eval 'sub DST_USA () {1;}' unless defined(&DST_USA);
	eval 'sub DST_AUST () {2;}' unless defined(&DST_AUST);
	eval 'sub DST_WET () {3;}' unless defined(&DST_WET);
	eval 'sub DST_MET () {4;}' unless defined(&DST_MET);
	eval 'sub DST_EET () {5;}' unless defined(&DST_EET);
	eval 'sub DST_CAN () {6;}' unless defined(&DST_CAN);
	if(defined( &_BSD_INCLUDES) || defined( &_LINUX_SOURCE_COMPAT)) {
	    require 'time.ph';
	}
    }
    if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
