require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_TIMER)) {
    eval 'sub _H_TIMER () {1;}' unless defined(&_H_TIMER);
    require 'sys/time.ph';
    require 'sys/types.ph';
    require 'sys/processor.ph';
    eval 'sub T_TIMEOUT () {0xabababab;}' unless defined(&T_TIMEOUT);
    eval 'sub T_PENDING () {0x1;}' unless defined(&T_PENDING);
    eval 'sub T_ACTIVE () {0x2;}' unless defined(&T_ACTIVE);
    eval 'sub T_ABSOLUTE () {0x4;}' unless defined(&T_ABSOLUTE);
    eval 'sub T_INCINTERVAL () {0x10;}' unless defined(&T_INCINTERVAL);
    eval 'sub T_COMPLETE () {0x20;}' unless defined(&T_COMPLETE);
    eval 'sub T_MPSAFE () {0x40;}' unless defined(&T_MPSAFE);
    eval 'sub T_LOWRES () {0x80;}' unless defined(&T_LOWRES);
    unless(defined(&_LINUX_SOURCE_COMPAT)) {
	eval 'sub func_data () { ($t_union->{data});}' unless defined(&func_data);
    }
    eval 'sub t_func_data () { ($t_union->{data});}' unless defined(&t_func_data);
    eval 'sub t_func_sdata () { ($t_union->{sdata});}' unless defined(&t_func_sdata);
    eval 'sub t_func_addr () { ($t_union->{addr});}' unless defined(&t_func_addr);
    eval 'sub TIMERID_ISBSD {
        my($timerid) = @_;
	    eval q(((($timerid) ==  &ITIMER_VIRTUAL) || (($timerid) ==  &ITIMER_VIRT) || (($timerid) ==  &ITIMER_PROF)));
    }' unless defined(&TIMERID_ISBSD);
    if(defined(&_KERNEL)) {
	eval 'sub TIMERID_PROC {
	    my($timerid) = @_;
    	    eval q((( >= 0)  && (($timerid) <  &NTIMERS)  && ( ($U->{U_timer[$timerid]}) !=  &NULL)));
	}' unless defined(&TIMERID_PROC);
	eval 'sub TIMERID_THREAD {
	    my($timerid) = @_;
    	    eval q((( >=  &TIMERID_REAL1)  && (($timerid) <  &TIMERID_REAL1 +  &NTIMERS_THREAD)  && ( ($u->{u_th_timer[$timerid }- TIMERID_REAL1]) !=  &NULL)));
	}' unless defined(&TIMERID_THREAD);
	eval 'sub TIMERID_NOTVALID {
	    my($timerid) = @_;
    	    eval q((!( &TIMERID_PROC(($timerid)) ||  &TIMERID_THREAD(($timerid)))));
	}' unless defined(&TIMERID_NOTVALID);
	if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
	} else {
	}
    }
}
1;
