require '_h2ph_pre.ph';

no warnings 'redefine';

require 'stdio.ph';
require 'string.ph';
require 'sys/types.ph';
unless(defined(&_TIUSER_H)) {
    eval 'sub _TIUSER_H () {1;}' unless defined(&_TIUSER_H);
    if(defined( &_THREAD_SAFE) || defined( &_THREAD_SAFE_ERRNO)) {
	eval 'sub t_errno () {(* &_terrno());}' unless defined(&t_errno);
    }
    unless(defined(&_T_SCALAR_DEF)) {
	if(defined(&__64BIT__)) {
	} else {
	}
	eval 'sub _T_SCALAR_DEF () {1;}' unless defined(&_T_SCALAR_DEF);
    }
    eval 'sub TBADADDR () {1;}' unless defined(&TBADADDR);
    eval 'sub TBADOPT () {2;}' unless defined(&TBADOPT);
    eval 'sub TACCES () {3;}' unless defined(&TACCES);
    eval 'sub TBADF () {4;}' unless defined(&TBADF);
    eval 'sub TNOADDR () {5;}' unless defined(&TNOADDR);
    eval 'sub TOUTSTATE () {6;}' unless defined(&TOUTSTATE);
    eval 'sub TBADSEQ () {7;}' unless defined(&TBADSEQ);
    eval 'sub TSYSERR () {8;}' unless defined(&TSYSERR);
    eval 'sub TLOOK () {9;}' unless defined(&TLOOK);
    eval 'sub TBADDATA () {10;}' unless defined(&TBADDATA);
    eval 'sub TBUFOVFLW () {11;}' unless defined(&TBUFOVFLW);
    eval 'sub TFLOW () {12;}' unless defined(&TFLOW);
    eval 'sub TNODATA () {13;}' unless defined(&TNODATA);
    eval 'sub TNODIS () {14;}' unless defined(&TNODIS);
    eval 'sub TNOUDERR () {15;}' unless defined(&TNOUDERR);
    eval 'sub TBADFLAG () {16;}' unless defined(&TBADFLAG);
    eval 'sub TNOREL () {17;}' unless defined(&TNOREL);
    eval 'sub TNOTSUPPORT () {18;}' unless defined(&TNOTSUPPORT);
    eval 'sub TSTATECHNG () {19;}' unless defined(&TSTATECHNG);
    eval 'sub TNOSTRUCTYPE () {20;}' unless defined(&TNOSTRUCTYPE);
    eval 'sub TBADNAME () {21;}' unless defined(&TBADNAME);
    eval 'sub TBADQLEN () {22;}' unless defined(&TBADQLEN);
    eval 'sub TADDRBUSY () {23;}' unless defined(&TADDRBUSY);
    eval 'sub T_BIND () {1;}' unless defined(&T_BIND);
    eval 'sub T_OPTMGMT () {2;}' unless defined(&T_OPTMGMT);
    eval 'sub T_CALL () {3;}' unless defined(&T_CALL);
    eval 'sub T_DIS () {4;}' unless defined(&T_DIS);
    eval 'sub T_UNITDATA () {5;}' unless defined(&T_UNITDATA);
    eval 'sub T_UDERROR () {6;}' unless defined(&T_UDERROR);
    eval 'sub T_INFO () {7;}' unless defined(&T_INFO);
    eval 'sub T_ADDR () {0x1;}' unless defined(&T_ADDR);
    eval 'sub T_OPT () {0x2;}' unless defined(&T_OPT);
    eval 'sub T_UDATA () {0x4;}' unless defined(&T_UDATA);
    eval 'sub T_ALL () {0x7;}' unless defined(&T_ALL);
    eval 'sub T_LISTEN () {0x1;}' unless defined(&T_LISTEN);
    eval 'sub T_CONNECT () {0x2;}' unless defined(&T_CONNECT);
    eval 'sub T_DATA () {0x4;}' unless defined(&T_DATA);
    eval 'sub T_EXDATA () {0x8;}' unless defined(&T_EXDATA);
    eval 'sub T_DISCONNECT () {0x10;}' unless defined(&T_DISCONNECT);
    eval 'sub T_UDERR () {0x40;}' unless defined(&T_UDERR);
    eval 'sub T_ORDREL () {0x80;}' unless defined(&T_ORDREL);
    eval 'sub T_ERROR () {0x800;}' unless defined(&T_ERROR);
    eval 'sub T_MORE () {0x1;}' unless defined(&T_MORE);
    eval 'sub T_EXPEDITED () {0x2;}' unless defined(&T_EXPEDITED);
    eval 'sub T_NEGOTIATE () {0x4;}' unless defined(&T_NEGOTIATE);
    eval 'sub T_CHECK () {0x8;}' unless defined(&T_CHECK);
    eval 'sub T_DEFAULT () {0x10;}' unless defined(&T_DEFAULT);
    eval 'sub T_SUCCESS () {0x20;}' unless defined(&T_SUCCESS);
    eval 'sub T_FAILURE () {0x40;}' unless defined(&T_FAILURE);
    eval 'sub T_CURRENT () {0x80;}' unless defined(&T_CURRENT);
    eval 'sub T_PARTSUCCESS () {0x100;}' unless defined(&T_PARTSUCCESS);
    eval 'sub T_READONLY () {0x200;}' unless defined(&T_READONLY);
    eval 'sub T_NOTSUPPORT () {0x400;}' unless defined(&T_NOTSUPPORT);
    eval 'sub T_COTS () {1;}' unless defined(&T_COTS);
    eval 'sub T_COTS_ORD () {2;}' unless defined(&T_COTS_ORD);
    eval 'sub T_CLTS () {3;}' unless defined(&T_CLTS);
    eval 'sub T_UNBND () {1;}' unless defined(&T_UNBND);
    eval 'sub T_IDLE () {2;}' unless defined(&T_IDLE);
    eval 'sub T_OUTCON () {3;}' unless defined(&T_OUTCON);
    eval 'sub T_INCON () {4;}' unless defined(&T_INCON);
    eval 'sub T_DATAXFER () {5;}' unless defined(&T_DATAXFER);
    eval 'sub T_OUTREL () {6;}' unless defined(&T_OUTREL);
    eval 'sub T_INREL () {7;}' unless defined(&T_INREL);
    eval 'sub T_SENDZERO () {0x1;}' unless defined(&T_SENDZERO);
    eval 'sub T_YES () {1;}' unless defined(&T_YES);
    eval 'sub T_NO () {0;}' unless defined(&T_NO);
    eval 'sub T_NULL () {0;}' unless defined(&T_NULL);
    eval 'sub T_UNSPEC () {(~0- 2);}' unless defined(&T_UNSPEC);
    eval 'sub T_ALLOPT () {0;}' unless defined(&T_ALLOPT);
    eval 'sub T_ALIGN {
        my($p) = @_;
	    eval q(((( &t_uscalar_t) ($p) + ($sizeof{ &t_scalar_t} - 1)) & ~($sizeof{ &t_scalar_t} - 1)));
    }' unless defined(&T_ALIGN);
    eval 'sub OPT_NEXTHDR {
        my($pbuf,$buflen,$popt) = @_;
	    eval q((( +  &T_ALIGN(-> &len) < ($pbuf) + $buflen) ? (($popt) +  &T_ALIGN(($popt)-> &len)) : 0));
    }' unless defined(&OPT_NEXTHDR);
    eval 'sub XTI_GENERIC () {0xffff;}' unless defined(&XTI_GENERIC);
    eval 'sub XTI_DEBUG () {0x1;}' unless defined(&XTI_DEBUG);
    eval 'sub XTI_LINGER () {0x80;}' unless defined(&XTI_LINGER);
    eval 'sub XTI_RCVBUF () {0x1002;}' unless defined(&XTI_RCVBUF);
    eval 'sub XTI_RCVLOWAT () {0x1004;}' unless defined(&XTI_RCVLOWAT);
    eval 'sub XTI_SNDBUF () {0x1001;}' unless defined(&XTI_SNDBUF);
    eval 'sub XTI_SNDLOWAT () {0x1003;}' unless defined(&XTI_SNDLOWAT);
    eval 'sub XTI_ERROR () {0x1007;}' unless defined(&XTI_ERROR);
    eval 'sub INET_TCP () {0x6;}' unless defined(&INET_TCP);
    eval 'sub TCP_NODELAY () {0x1;}' unless defined(&TCP_NODELAY);
    eval 'sub TCP_MAXSEG () {0x2;}' unless defined(&TCP_MAXSEG);
    eval 'sub TCP_KEEPALIVE () {0x8;}' unless defined(&TCP_KEEPALIVE);
    eval 'sub INET_UDP () {0x11;}' unless defined(&INET_UDP);
    eval 'sub UDP_CHECKSUM () {0x600;}' unless defined(&UDP_CHECKSUM);
    eval 'sub INET_IP () {0x;}' unless defined(&INET_IP);
    eval 'sub IP_OPTIONS () {1;}' unless defined(&IP_OPTIONS);
    eval 'sub IP_TOS () {3;}' unless defined(&IP_TOS);
    eval 'sub IP_TTL () {4;}' unless defined(&IP_TTL);
    eval 'sub IP_REUSEADDR () {0x8;}' unless defined(&IP_REUSEADDR);
    eval 'sub IP_DONTROUTE () {0x10;}' unless defined(&IP_DONTROUTE);
    eval 'sub IP_BROADCAST () {0x20;}' unless defined(&IP_BROADCAST);
    eval 'sub IP_REUSEPORT () {0x40;}' unless defined(&IP_REUSEPORT);
    eval 'sub T_ROUTINE () {0;}' unless defined(&T_ROUTINE);
    eval 'sub T_PRIORITY () {1;}' unless defined(&T_PRIORITY);
    eval 'sub T_IMMEDIATE () {2;}' unless defined(&T_IMMEDIATE);
    eval 'sub T_FLASH () {3;}' unless defined(&T_FLASH);
    eval 'sub T_OVERRIDEFLASH () {4;}' unless defined(&T_OVERRIDEFLASH);
    eval 'sub T_CRITIC_ECP () {5;}' unless defined(&T_CRITIC_ECP);
    eval 'sub T_INETCONTROL () {6;}' unless defined(&T_INETCONTROL);
    eval 'sub T_NETCONTROL () {7;}' unless defined(&T_NETCONTROL);
    eval 'sub T_NOTOS () {0;}' unless defined(&T_NOTOS);
    eval 'sub T_LDELAY () {(1<<4);}' unless defined(&T_LDELAY);
    eval 'sub T_HITHRPT () {(1<<3);}' unless defined(&T_HITHRPT);
    eval 'sub T_HIREL () {(1<<2);}' unless defined(&T_HIREL);
    eval 'sub SET_TOS {
        my($prec,$tos) = @_;
	    eval q(((0x7 & ($prec)) << 5| (0x1c & ($tos))));
    }' unless defined(&SET_TOS);
    unless(defined(&_KERNEL)) {
	if(defined(&_NO_PROTO)) {
	} else {
	}
    }
}
1;
