require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_TokenRing_MIBS)) {
    eval 'sub _H_TokenRing_MIBS () {1;}' unless defined(&_H_TokenRing_MIBS);
    require 'sys/machine.ph';
    require 'sys/generic_mibs.ph';
    eval 'sub TOKEN_COMMANDS () {30;}' unless defined(&TOKEN_COMMANDS);
    eval 'sub TR_MIB_NO_OP () {1;}' unless defined(&TR_MIB_NO_OP);
    eval 'sub TR_MIB_OPEN () {2;}' unless defined(&TR_MIB_OPEN);
    eval 'sub TR_MIB_RESET () {3;}' unless defined(&TR_MIB_RESET);
    eval 'sub TR_MIB_CLOSE () {4;}' unless defined(&TR_MIB_CLOSE);
    eval 'sub TOKEN_RING_STATUS () {31;}' unless defined(&TOKEN_RING_STATUS);
    eval 'sub TR_MIB_NOPROBLEM () {0;}' unless defined(&TR_MIB_NOPROBLEM);
    eval 'sub TR_MIB_RINGRECOVERY () {32;}' unless defined(&TR_MIB_RINGRECOVERY);
    eval 'sub TR_MIB_SINGLESTATION () {64;}' unless defined(&TR_MIB_SINGLESTATION);
    eval 'sub TR_MIB_REMOVE_RX () {256;}' unless defined(&TR_MIB_REMOVE_RX);
    eval 'sub TR_MIB_RESERVED () {512;}' unless defined(&TR_MIB_RESERVED);
    eval 'sub TR_MIB_AUTOREMOVAL_ERR () {1024;}' unless defined(&TR_MIB_AUTOREMOVAL_ERR);
    eval 'sub TR_MIB_LOBEWIREFAULT () {2048;}' unless defined(&TR_MIB_LOBEWIREFAULT);
    eval 'sub TR_MIB_TX_BEACON () {4096;}' unless defined(&TR_MIB_TX_BEACON);
    eval 'sub TR_MIB_SOFT_ERR () {8192;}' unless defined(&TR_MIB_SOFT_ERR);
    eval 'sub TR_MIB_HARD_ERROR () {16384;}' unless defined(&TR_MIB_HARD_ERROR);
    eval 'sub TR_MIB_SIGNAL_LOSS () {32768;}' unless defined(&TR_MIB_SIGNAL_LOSS);
    eval 'sub TR_MIB_NO_STATUS () {131072;}' unless defined(&TR_MIB_NO_STATUS);
    eval 'sub TOKEN_RING_STATE () {32;}' unless defined(&TOKEN_RING_STATE);
    eval 'sub TR_MIB_OPENED () {1;}' unless defined(&TR_MIB_OPENED);
    eval 'sub TR_MIB_CLOSED () {2;}' unless defined(&TR_MIB_CLOSED);
    eval 'sub TR_MIB_OPENING () {3;}' unless defined(&TR_MIB_OPENING);
    eval 'sub TR_MIB_CLOSING () {4;}' unless defined(&TR_MIB_CLOSING);
    eval 'sub TR_MIB_OPENFAILURE () {5;}' unless defined(&TR_MIB_OPENFAILURE);
    eval 'sub TR_MIB_RINGFAILURE () {6;}' unless defined(&TR_MIB_RINGFAILURE);
    eval 'sub TOKEN_RING_OSTATUS () {33;}' unless defined(&TOKEN_RING_OSTATUS);
    eval 'sub TR_MIB_NOOPEN () {1;}' unless defined(&TR_MIB_NOOPEN);
    eval 'sub TR_MIB_BADPARAM () {2;}' unless defined(&TR_MIB_BADPARAM);
    eval 'sub TR_MIB_LOBEFAILED () {3;}' unless defined(&TR_MIB_LOBEFAILED);
    eval 'sub TR_MIB_SIGNALLOSS () {4;}' unless defined(&TR_MIB_SIGNALLOSS);
    eval 'sub TR_MIB_INSERTIONTIMEOUT () {5;}' unless defined(&TR_MIB_INSERTIONTIMEOUT);
    eval 'sub TR_MIB_RINGFAILED () {6;}' unless defined(&TR_MIB_RINGFAILED);
    eval 'sub TR_MIB_BEACONING () {7;}' unless defined(&TR_MIB_BEACONING);
    eval 'sub TR_MIB_DUPLICATEMAC () {8;}' unless defined(&TR_MIB_DUPLICATEMAC);
    eval 'sub TR_MIB_REQUESTFAILED () {9;}' unless defined(&TR_MIB_REQUESTFAILED);
    eval 'sub TR_MIB_REMOVERECEIVED () {10;}' unless defined(&TR_MIB_REMOVERECEIVED);
    eval 'sub TR_MIB_LASTOPEN () {11;}' unless defined(&TR_MIB_LASTOPEN);
    eval 'sub TOKEN_RING_SPEED () {34;}' unless defined(&TOKEN_RING_SPEED);
    eval 'sub TR_MIB_UNKNOWN () {1;}' unless defined(&TR_MIB_UNKNOWN);
    eval 'sub TR_MIB_ONEMEGABIT () {2;}' unless defined(&TR_MIB_ONEMEGABIT);
    eval 'sub TR_MIB_FOURMEGABIT () {3;}' unless defined(&TR_MIB_FOURMEGABIT);
    eval 'sub TR_MIB_SIXTEENMEGABIT () {4;}' unless defined(&TR_MIB_SIXTEENMEGABIT);
    eval 'sub TR_MIB_HUNDREDMEGABIT () {5;}' unless defined(&TR_MIB_HUNDREDMEGABIT);
    eval 'sub TOKEN_UPSTREAM () {35;}' unless defined(&TOKEN_UPSTREAM);
    eval 'sub TR_MIB_TRUE () {1;}' unless defined(&TR_MIB_TRUE);
    eval 'sub TR_MIB_FALSE () {2;}' unless defined(&TR_MIB_FALSE);
    eval 'sub TOKEN_FUNCTIONAL () {36;}' unless defined(&TOKEN_FUNCTIONAL);
    eval 'sub TOKEN_LINE_ERRS () {40;}' unless defined(&TOKEN_LINE_ERRS);
    eval 'sub TOKEN_BURST_ERRS () {41;}' unless defined(&TOKEN_BURST_ERRS);
    eval 'sub TOKEN_AC_ERRS () {42;}' unless defined(&TOKEN_AC_ERRS);
    eval 'sub TOKEN_ABORT_ERRS () {43;}' unless defined(&TOKEN_ABORT_ERRS);
    eval 'sub TOKEN_INT_ERRS () {44;}' unless defined(&TOKEN_INT_ERRS);
    eval 'sub TOKEN_LOSTFRAMES () {45;}' unless defined(&TOKEN_LOSTFRAMES);
    eval 'sub TOKEN_RX_CONGESTION () {46;}' unless defined(&TOKEN_RX_CONGESTION);
    eval 'sub TOKEN_FRAMECOPIES () {47;}' unless defined(&TOKEN_FRAMECOPIES);
    eval 'sub TOKEN_TOKEN_ERRS () {48;}' unless defined(&TOKEN_TOKEN_ERRS);
    eval 'sub TOKEN_SOFT_ERRS () {49;}' unless defined(&TOKEN_SOFT_ERRS);
    eval 'sub TOKEN_HARD_ERRS () {50;}' unless defined(&TOKEN_HARD_ERRS);
    eval 'sub TOKEN_SIGNAL_LOSS () {51;}' unless defined(&TOKEN_SIGNAL_LOSS);
    eval 'sub TOKEN_TX_BEACONS () {52;}' unless defined(&TOKEN_TX_BEACONS);
    eval 'sub TOKEN_RECOVERYS () {53;}' unless defined(&TOKEN_RECOVERYS);
    eval 'sub TOKEN_LOBEWIRES () {54;}' unless defined(&TOKEN_LOBEWIRES);
    eval 'sub TOKEN_REMOVES () {55;}' unless defined(&TOKEN_REMOVES);
    eval 'sub TOKEN_SINGLES () {56;}' unless defined(&TOKEN_SINGLES);
    eval 'sub TOKEN_FREQ_ERRS () {57;}' unless defined(&TOKEN_FREQ_ERRS);
    eval 'sub TOKEN_RETURN_REPEAT () {60;}' unless defined(&TOKEN_RETURN_REPEAT);
    eval 'sub TOKEN_HOLDING () {61;}' unless defined(&TOKEN_HOLDING);
    eval 'sub TOKEN_QUEUE_PDU () {62;}' unless defined(&TOKEN_QUEUE_PDU);
    eval 'sub TOKEN_VALID_TX () {63;}' unless defined(&TOKEN_VALID_TX);
    eval 'sub TOKEN_NO_TOKEN () {64;}' unless defined(&TOKEN_NO_TOKEN);
    eval 'sub TOKEN_ACTIVE_MON () {65;}' unless defined(&TOKEN_ACTIVE_MON);
    eval 'sub TOKEN_STANDBY_MON () {66;}' unless defined(&TOKEN_STANDBY_MON);
    eval 'sub TOKEN_ERR_REPORT () {67;}' unless defined(&TOKEN_ERR_REPORT);
    eval 'sub TOKEN_BEACON_TX () {68;}' unless defined(&TOKEN_BEACON_TX);
    eval 'sub TOKEN_BEACON_RX () {69;}' unless defined(&TOKEN_BEACON_RX);
    eval 'sub TR_MIB_testInsertFunc () {1;}' unless defined(&TR_MIB_testInsertFunc);
    if((defined(&BYTEORDER) ? &BYTEORDER : 0)==(defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	eval 'sub TR_MIB_IBM16 () {"\\000\\000\\000\\012\\000\\000\\000\\001\\000\\000\\000\\003\\000\\000\\000\\006\\000\\000\\000\\001\\000\\000\\000\\002\\000\\000\\000\\001\\000\\000\\000\\012\\000\\000\\000\\011\\000\\000\\000\\004\\000\\000\\000\\001\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000";}' unless defined(&TR_MIB_IBM16);
    } else {
	eval 'sub TR_MIB_IBM16 () {"\\012\\000\\000\\000\\001\\000\\000\\000\\003\\000\\000\\000\\006\\000\\000\\000\\001\\000\\000\\000\\002\\000\\000\\000\\001\\000\\000\\000\\012\\000\\000\\000\\011\\000\\000\\000\\004\\000\\000\\000\\001\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000";}' unless defined(&TR_MIB_IBM16);
    }
    if((defined(&BYTEORDER) ? &BYTEORDER : 0)==(defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	eval 'sub TR_MIB_TITMS380 () {"\\000\\000\\000\\012\\000\\000\\000\\001\\000\\000\\000\\003\\000\\000\\000\\006\\000\\000\\000\\001\\000\\000\\000\\002\\000\\000\\000\\001\\000\\000\\000\\012\\000\\000\\000\\011\\000\\000\\000\\004\\000\\000\\000\\002\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000";}' unless defined(&TR_MIB_TITMS380);
    } else {
	eval 'sub TR_MIB_TITMS380 () {"\\012\\000\\000\\000\\001\\000\\000\\000\\003\\000\\000\\000\\006\\000\\000\\000\\001\\000\\000\\000\\002\\000\\000\\000\\001\\000\\000\\000\\012\\000\\000\\000\\011\\000\\000\\000\\004\\000\\000\\000\\002\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000";}' unless defined(&TR_MIB_TITMS380);
    }
    if((defined(&BYTEORDER) ? &BYTEORDER : 0)==(defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	eval 'sub TR_MIB_TITMS380C16 () {"\\000\\000\\000\\012\\000\\000\\000\\001\\000\\000\\000\\003\\000\\000\\000\\006\\000\\000\\000\\001\\000\\000\\000\\002\\000\\000\\000\\001\\000\\000\\000\\012\\000\\000\\000\\011\\000\\000\\000\\004\\000\\000\\000\\003\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000";}' unless defined(&TR_MIB_TITMS380C16);
    } else {
	eval 'sub TR_MIB_TITMS380C16 () {"\\012\\000\\000\\000\\001\\000\\000\\000\\003\\000\\000\\000\\006\\000\\000\\000\\001\\000\\000\\000\\002\\000\\000\\000\\001\\000\\000\\000\\012\\000\\000\\000\\011\\000\\000\\000\\004\\000\\000\\000\\003\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000";}' unless defined(&TR_MIB_TITMS380C16);
    }
}
1;
