require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_TRCHDR)) {
    eval 'sub _H_TRCHDR () {1;}' unless defined(&_H_TRCHDR);
    require 'sys/lock_def.ph';
    unless(defined(&TRC_NCHANNELS)) {
	eval 'sub TRC_NCHANNELS () {8;}' unless defined(&TRC_NCHANNELS);
    }
    eval 'sub TRC_OVB () {272;}' unless defined(&TRC_OVB);
    eval 'sub GENBUFSIZE () {4096;}' unless defined(&GENBUFSIZE);
    eval 'sub GENBUFSIZE64_32 () {( &GENBUFSIZE+4+8);}' unless defined(&GENBUFSIZE64_32);
    if(defined( &_KERNSYS) || defined ( &_TRACE_KEXT)) {
	unless(defined(&__64BIT_KERNEL)) {
	}
	eval 'sub TRC_STACKWORDS () {1024;}' unless defined(&TRC_STACKWORDS);
	eval 'sub TRC_SAVEWORDS () {16;}' unless defined(&TRC_SAVEWORDS);
	if(defined(&__64BIT_KERNEL)) {
	} else {
	}
	unless(defined(&__64BIT_KERNEL)) {
	    eval 'sub tbuf_sreg () { ($tbuf_currq->{q_sreg});}' unless defined(&tbuf_sreg);
	    eval 'sub tbuf_sid () { ($tbuf_currq->{q_sid});}' unless defined(&tbuf_sid);
	}
	eval 'sub tbuf_start () { ($tbuf_currq->{q_start});}' unless defined(&tbuf_start);
	eval 'sub tbuf_end () { ($tbuf_currq->{q_end});}' unless defined(&tbuf_end);
	eval 'sub tbuf_inptr () { ($tbuf_currq->{q_inptr});}' unless defined(&tbuf_inptr);
	eval 'sub tbuf_size () { ($tbuf_currq->{q_size});}' unless defined(&tbuf_size);
	unless(defined(&__64BIT_KERNEL)) {
	    eval 'sub tbuf_sregA () { ($tbuf_Aq->{q_sreg});}' unless defined(&tbuf_sregA);
	    eval 'sub tbuf_sidA () { ($tbuf_Aq->{q_sid});}' unless defined(&tbuf_sidA);
	}
	eval 'sub tbuf_startA () { ($tbuf_Aq->{q_start});}' unless defined(&tbuf_startA);
	eval 'sub tbuf_endA () { ($tbuf_Aq->{q_end});}' unless defined(&tbuf_endA);
	eval 'sub tbuf_inptrA () { ($tbuf_Aq->{q_inptr});}' unless defined(&tbuf_inptrA);
	eval 'sub tbuf_sizeA () { ($tbuf_Aq->{q_size});}' unless defined(&tbuf_sizeA);
	unless(defined(&__64BIT_KERNEL)) {
	    eval 'sub tbuf_sregB () { ($tbuf_Bq->{q_sreg});}' unless defined(&tbuf_sregB);
	    eval 'sub tbuf_sidB () { ($tbuf_Bq->{q_sid});}' unless defined(&tbuf_sidB);
	}
	eval 'sub tbuf_startB () { ($tbuf_Bq->{q_start});}' unless defined(&tbuf_startB);
	eval 'sub tbuf_endB () { ($tbuf_Bq->{q_end});}' unless defined(&tbuf_endB);
	eval 'sub tbuf_inptrB () { ($tbuf_Bq->{q_inptr});}' unless defined(&tbuf_inptrB);
	eval 'sub tbuf_sizeB () { ($tbuf_Bq->{q_size});}' unless defined(&tbuf_sizeB);
	eval 'sub EVENT_TRACE () {0x80000000;}' unless defined(&EVENT_TRACE);
	eval 'sub EVENT_TRCUNLOCK () {0x80000000;}' unless defined(&EVENT_TRCUNLOCK);
	eval 'sub EVENT_TRCPROC () {0x40000000;}' unless defined(&EVENT_TRCPROC);
	eval 'sub FSM_A_B () {1;}' unless defined(&FSM_A_B);
	eval 'sub FSM_A_BLOCK () {2;}' unless defined(&FSM_A_BLOCK);
	eval 'sub FSM_B_A () {3;}' unless defined(&FSM_B_A);
	eval 'sub FSM_B_BLOCK () {4;}' unless defined(&FSM_B_BLOCK);
	eval 'sub FSM_SPILL_MASK () {0x8000;}' unless defined(&FSM_SPILL_MASK);
	eval 'sub FSM_SPILL_A () {0x8001;}' unless defined(&FSM_SPILL_A);
	eval 'sub FSM_SPILL_A_OFF () {0x8002;}' unless defined(&FSM_SPILL_A_OFF);
	eval 'sub FSM_SPILL_A_OFF2 () {0x8003;}' unless defined(&FSM_SPILL_A_OFF2);
	eval 'sub FSM_SPILL_B () {0x8004;}' unless defined(&FSM_SPILL_B);
	eval 'sub FSM_SPILL_B_OFF () {0x8005;}' unless defined(&FSM_SPILL_B_OFF);
	eval 'sub FSM_SPILL_B_OFF2 () {0x8006;}' unless defined(&FSM_SPILL_B_OFF2);
	eval 'sub FSM_SPILL_BLOCK () {0x8007;}' unless defined(&FSM_SPILL_BLOCK);
	eval 'sub FSM_SPILL_EOF () {0x8008;}' unless defined(&FSM_SPILL_EOF);
	eval 'sub CTL_MPSER () {0x1;}' unless defined(&CTL_MPSER);
	eval 'sub CTL_UPSER () {0x2;}' unless defined(&CTL_UPSER);
	eval 'sub ST_ISOPEN () {0x1;}' unless defined(&ST_ISOPEN);
	eval 'sub ST_TRCON () {0x2;}' unless defined(&ST_TRCON);
	eval 'sub ST_WRAP () {0x4;}' unless defined(&ST_WRAP);
	eval 'sub ST_TRCSTOP () {0x10;}' unless defined(&ST_TRCSTOP);
	eval 'sub ST_COND () {0x20;}' unless defined(&ST_COND);
	eval 'sub ST_BUS () {0x40;}' unless defined(&ST_BUS);
	eval 'sub ST_TSYNC () {0x80;}' unless defined(&ST_TSYNC);
	eval 'sub ST_IACTIVE () {0x100;}' unless defined(&ST_IACTIVE);
	eval 'sub ST_SEPSEG () {0x200;}' unless defined(&ST_SEPSEG);
	eval 'sub MD_OFF () {0;}' unless defined(&MD_OFF);
	eval 'sub MD_CIRCULAR () {1;}' unless defined(&MD_CIRCULAR);
	eval 'sub MD_CIRCULAR_COND () {2;}' unless defined(&MD_CIRCULAR_COND);
	eval 'sub MD_ALTERNATE () {3;}' unless defined(&MD_ALTERNATE);
	eval 'sub MD_ALTERNATE_COND () {4;}' unless defined(&MD_ALTERNATE_COND);
	eval 'sub MD_SINGLE () {5;}' unless defined(&MD_SINGLE);
	eval 'sub MD_SINGLE_COND () {6;}' unless defined(&MD_SINGLE_COND);
	eval 'sub MD_BUS () {7;}' unless defined(&MD_BUS);
	eval 'sub MD_BUS_COND () {8;}' unless defined(&MD_BUS_COND);
	eval 'sub FF_STOPONWRAP () {0x1;}' unless defined(&FF_STOPONWRAP);
	eval 'sub FF_SEPCPU () {0x2;}' unless defined(&FF_SEPCPU);
	eval 'sub HKTOEVENT {
	    my($hookword) = @_;
    	    eval q(((($hookword) >> 20) & 0xfff));
	}' unless defined(&HKTOEVENT);
	eval 'sub ISEVENT {
	    my($tp,$n) = @_;
    	    eval q(( ($tp->{trc_events[HKTOEVENT($n)/8]}) & (1<<  &HKTOEVENT($n)%8)));
	}' unless defined(&ISEVENT);
	if(defined(&_IBMRT)) {
	    eval 'sub INT_OFF () {
	        eval q( &j_disable());
	    }' unless defined(&INT_OFF);
	    eval 'sub INT_ON () {
	        eval q( &j_enable(0));
	    }' unless defined(&INT_ON);
	    eval 'sub INT_ONX {
	        my($s) = @_;
    		eval q( &j_enable($s));
	    }' unless defined(&INT_ONX);
	} else {
	    eval 'sub INT_OFF () {
	        eval q( &i_disable( &INTMAX));
	    }' unless defined(&INT_OFF);
	    eval 'sub INT_ON () {
	        eval q( &i_enable( &INTBASE));
	    }' unless defined(&INT_ON);
	    eval 'sub INT_ONX {
	        my($s) = @_;
    		eval q( &i_enable($s));
	    }' unless defined(&INT_ONX);
	}
	if(defined(&DEBUG)) {
	    eval 'sub trc_debug () {( &jsnapflg == 0) ? 0:  &jsnap;}' unless defined(&trc_debug);
	    eval 'sub trc_debug2 () {( &jsnapflg < 2) ? 0:  &jsnap;}' unless defined(&trc_debug2);
	} else {
	    eval 'sub trc_debug () {1;}' unless defined(&trc_debug);
	    eval 'sub trc_debug2 () {1;}' unless defined(&trc_debug2);
	}
	eval 'sub TIMESTAMP () { &trc_timestamp();}' unless defined(&TIMESTAMP);
    }
    eval 'sub l_magic () { ($l_h->{lh_magic});}' unless defined(&l_magic);
    eval 'sub l_nentries () { ($l_h->{lh_nentries});}' unless defined(&l_nentries);
    eval 'sub l_currentry () { ($l_h->{lh_currentry});}' unless defined(&l_currentry);
    eval 'sub l_mode () { ($l_h->{lh_mode});}' unless defined(&l_mode);
    eval 'sub l_wrapcount () { ($l_h->{lh_wrapcount});}' unless defined(&l_wrapcount);
    eval 'sub l_fd () { ($l_h->{lh_fd});}' unless defined(&l_fd);
    eval 'sub l_fp () { ($l_h->{lh_fp});}' unless defined(&l_fp);
    eval 'sub l_ic () { ($l_h->{lh_ic});}' unless defined(&l_ic);
    eval 'sub MDL_NOWRAP () {0x1;}' unless defined(&MDL_NOWRAP);
    eval 'sub MDL_STOPONWRAP () {0x2;}' unless defined(&MDL_STOPONWRAP);
    eval 'sub MDL_MULTICPU () {0x4;}' unless defined(&MDL_MULTICPU);
    eval 'sub MDL_CPUFILE () {0x8;}' unless defined(&MDL_CPUFILE);
    eval 'sub TRC_LMAGIC () {0xefdf1111;}' unless defined(&TRC_LMAGIC);
    eval 'sub TRC_NEW_LMAGIC () {0xefdf1112;}' unless defined(&TRC_NEW_LMAGIC);
    eval 'sub TRC_64_LMAGIC () {0xefdf1113;}' unless defined(&TRC_64_LMAGIC);
    eval 'sub TRC_64_LSTREAM () {0xefdf1114;}' unless defined(&TRC_64_LSTREAM);
    eval 'sub VALID_TRCMAGIC {
        my($m) = @_;
	    eval q(((($m) ==  &TRC_LMAGIC) || (($m) ==  &TRC_NEW_LMAGIC) || (($m) ==  &TRC_64_LMAGIC) || (($m) ==  &TRC_64_LSTREAM)));
    }' unless defined(&VALID_TRCMAGIC);
    if(defined(&__64BIT__)) {
	eval 'sub TRC_LHSIZE () {$sizeof{\'struct trc_log_hdr_64\'};}' unless defined(&TRC_LHSIZE);
	eval 'sub TRC_LESIZE () {$sizeof{\'struct trc_log_entry_64\'};}' unless defined(&TRC_LESIZE);
    } else {
	eval 'sub TRC_LHSIZE () {$sizeof{\'struct trc_log_hdr\'};}' unless defined(&TRC_LHSIZE);
	eval 'sub TRC_LESIZE () {$sizeof{\'struct trc_log_entry\'};}' unless defined(&TRC_LESIZE);
    }
    eval 'sub TRC_LSIZE {
        my($hp) = @_;
	    eval q((  &TRC_LHSIZE + ($hp)-> &lh_nentries *  &TRC_LESIZE ));
    }' unless defined(&TRC_LSIZE);
    eval 'sub TRCT_A () {1;}' unless defined(&TRCT_A);
    eval 'sub TRCT_B () {2;}' unless defined(&TRCT_B);
    eval 'sub TRCT_A64 () {3;}' unless defined(&TRCT_A64);
    eval 'sub TRCT_B64 () {4;}' unless defined(&TRCT_B64);
}
1;
