require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_VMOUNT)) {
    eval 'sub _H_VMOUNT () {1;}' unless defined(&_H_VMOUNT);
    eval 'sub MNT_AIX () {0;}' unless defined(&MNT_AIX);
    eval 'sub MNT_J2 () {0;}' unless defined(&MNT_J2);
    eval 'sub MNT_NAMEFS () {1;}' unless defined(&MNT_NAMEFS);
    eval 'sub MNT_NFS () {2;}' unless defined(&MNT_NFS);
    eval 'sub MNT_JFS () {3;}' unless defined(&MNT_JFS);
    eval 'sub MNT_CDROM () {5;}' unless defined(&MNT_CDROM);
    eval 'sub MNT_PROCFS () {6;}' unless defined(&MNT_PROCFS);
    eval 'sub MNT_USRVFS () {8;}' unless defined(&MNT_USRVFS);
    eval 'sub MNT_SFS () {16;}' unless defined(&MNT_SFS);
    eval 'sub MNT_CACHEFS () {17;}' unless defined(&MNT_CACHEFS);
    eval 'sub MNT_NFS3 () {18;}' unless defined(&MNT_NFS3);
    eval 'sub MNT_AUTOFS () {19;}' unless defined(&MNT_AUTOFS);
    eval 'sub MNT_USRLAST () {31;}' unless defined(&MNT_USRLAST);
    eval 'sub MNT_VXFS () {32;}' unless defined(&MNT_VXFS);
    eval 'sub MNT_VXODM () {33;}' unless defined(&MNT_VXODM);
    eval 'sub MNT_AIXLAST () {39;}' unless defined(&MNT_AIXLAST);
    eval 'sub MNT_BADVFS () {-1;}' unless defined(&MNT_BADVFS);
    eval 'sub MNT_READONLY () {0x1;}' unless defined(&MNT_READONLY);
    eval 'sub MNT_REMOVABLE () {0x2;}' unless defined(&MNT_REMOVABLE);
    eval 'sub MNT_DEVICE () {0x4;}' unless defined(&MNT_DEVICE);
    eval 'sub MNT_REMOTE () {0x8;}' unless defined(&MNT_REMOTE);
    eval 'sub MNT_SYSV_MOUNT () {0x10;}' unless defined(&MNT_SYSV_MOUNT);
    eval 'sub MNT_UNMOUNTING () {0x20;}' unless defined(&MNT_UNMOUNTING);
    eval 'sub MNT_NOSUID () {0x40;}' unless defined(&MNT_NOSUID);
    eval 'sub MNT_NODEV () {0x80;}' unless defined(&MNT_NODEV);
    eval 'sub MNT_NOINTEG () {0x100;}' unless defined(&MNT_NOINTEG);
    eval 'sub MNT_NOMANAGER () {0x200;}' unless defined(&MNT_NOMANAGER);
    eval 'sub MNT_NOCASE () {0x400;}' unless defined(&MNT_NOCASE);
    eval 'sub MNT_UPCASE () {0x800;}' unless defined(&MNT_UPCASE);
    eval 'sub MNT_MIND () {0x2000;}' unless defined(&MNT_MIND);
    eval 'sub MNT_RBR () {0x4000;}' unless defined(&MNT_RBR);
    eval 'sub MNT_RBW () {0x8000;}' unless defined(&MNT_RBW);
    eval 'sub MNT_DIO () {0x80000000;}' unless defined(&MNT_DIO);
    eval 'sub VMOUNT_MASK () {( &MNT_READONLY |  &MNT_REMOVABLE |  &MNT_SYSV_MOUNT |  &MNT_NOSUID |  &MNT_NODEV |  &MNT_NOINTEG |  &MNT_NOMANAGER |  &MNT_NOCASE |  &MNT_UPCASE |  &MNT_DIO |  &MNT_MIND |  &MNT_RBR |  &MNT_RBW);}' unless defined(&VMOUNT_MASK);
    eval 'sub VMT_OBJECT () {0;}' unless defined(&VMT_OBJECT);
    eval 'sub VMT_STUB () {1;}' unless defined(&VMT_STUB);
    eval 'sub VMT_HOST () {2;}' unless defined(&VMT_HOST);
    eval 'sub VMT_HOSTNAME () {3;}' unless defined(&VMT_HOSTNAME);
    eval 'sub VMT_INFO () {4;}' unless defined(&VMT_INFO);
    eval 'sub VMT_ARGS () {5;}' unless defined(&VMT_ARGS);
    eval 'sub VMT_LASTINDEX () {5;}' unless defined(&VMT_LASTINDEX);
    if(!defined( &_KERNEL)  && defined( &__64BIT__)) {
    } else {
    }
    eval 'sub VMT_REVISION () {1;}' unless defined(&VMT_REVISION);
    eval 'sub vmt2dataptr {
        my($vmt, $idx) = @_;
	    eval q((((($vmt)) + (($vmt)-> ($vmt_data[&(idx)]->{vmt_off})))));
    }' unless defined(&vmt2dataptr);
    eval 'sub vmt2datasize {
        my($vmt, $idx) = @_;
	    eval q((($vmt)-> ($vmt_data[&(idx)]->{vmt_size})));
    }' unless defined(&vmt2datasize);
    eval 'sub MCTL_QUERY () {2;}' unless defined(&MCTL_QUERY);
    eval 'sub UVMNT_FORCE () {0x1;}' unless defined(&UVMNT_FORCE);
}
1;
