require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_VMUSER)) {
    eval 'sub _H_VMUSER () {1;}' unless defined(&_H_VMUSER);
    require 'sys/rset.ph';
    require 'sys/buf.ph';
    eval 'sub V_WORKING () {0x1;}' unless defined(&V_WORKING);
    eval 'sub V_CLIENT () {0x2;}' unless defined(&V_CLIENT);
    eval 'sub V_PERSISTENT () {0x4;}' unless defined(&V_PERSISTENT);
    eval 'sub V_JOURNAL () {0x8;}' unless defined(&V_JOURNAL);
    eval 'sub V_DEFER () {0x10;}' unless defined(&V_DEFER);
    eval 'sub V_SYSTEM () {0x20;}' unless defined(&V_SYSTEM);
    eval 'sub V_LOGSEG () {0x40;}' unless defined(&V_LOGSEG);
    eval 'sub V_UREAD () {0x80;}' unless defined(&V_UREAD);
    eval 'sub V_PTASEG () {0x100;}' unless defined(&V_PTASEG);
    eval 'sub V_PRIVSEG () {0x200;}' unless defined(&V_PRIVSEG);
    eval 'sub V_INTRSEG () {0x400;}' unless defined(&V_INTRSEG);
    eval 'sub V_MAPPING () {0x800;}' unless defined(&V_MAPPING);
    eval 'sub V_PSEARLYALLOC () {0x1000;}' unless defined(&V_PSEARLYALLOC);
    eval 'sub V_SHRLIB () {0x2000;}' unless defined(&V_SHRLIB);
    eval 'sub V_SPARSE () {0x4000;}' unless defined(&V_SPARSE);
    eval 'sub V_LARGE () {0x8000;}' unless defined(&V_LARGE);
    eval 'sub V_LRGEXT () {0x10000;}' unless defined(&V_LRGEXT);
    eval 'sub V_RMMAP () {0x20000;}' unless defined(&V_RMMAP);
    eval 'sub V_ASYNC () {0x40000;}' unless defined(&V_ASYNC);
    eval 'sub V_STACKSEG () {0x80000;}' unless defined(&V_STACKSEG);
    eval 'sub V_FREEZE () {0x100000;}' unless defined(&V_FREEZE);
    eval 'sub V_RMMAPIO () {0x200000;}' unless defined(&V_RMMAPIO);
    eval 'sub V_PERMFREEZE () {0x400000;}' unless defined(&V_PERMFREEZE);
    eval 'sub V_ACCT () {0x800000;}' unless defined(&V_ACCT);
    eval 'sub V_ATTACH () {0x1000000;}' unless defined(&V_ATTACH);
    eval 'sub V_TEXTCOPY () {0x2000000;}' unless defined(&V_TEXTCOPY);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub V_USERACC () {0x4000000;}' unless defined(&V_USERACC);
    }
    eval 'sub V_PIN () {0x8000000;}' unless defined(&V_PIN);
    eval 'sub V_LGPAGE () {0x10000000;}' unless defined(&V_LGPAGE);
    eval 'sub V_SHMSEG () {0x20000000;}' unless defined(&V_SHMSEG);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub V_RSVD_VSID () {0x40000000;}' unless defined(&V_RSVD_VSID);
    }
    eval 'sub V_NOFORCE () {0x;}' unless defined(&V_NOFORCE);
    eval 'sub V_FORCE () {0x1;}' unless defined(&V_FORCE);
    eval 'sub V_FORCE_SYNC () {0x2;}' unless defined(&V_FORCE_SYNC);
    eval 'sub V_ASYNC_FLAG () {0x4;}' unless defined(&V_ASYNC_FLAG);
    eval 'sub V_COMMIT () {0x8;}' unless defined(&V_COMMIT);
    eval 'sub V_IOWAIT () {0x1;}' unless defined(&V_IOWAIT);
    eval 'sub V_ALLDONE () {0x2;}' unless defined(&V_ALLDONE);
    eval 'sub V_NOKEEP () {0;}' unless defined(&V_NOKEEP);
    eval 'sub V_KEEP () {1;}' unless defined(&V_KEEP);
    eval 'sub V_CHECKXPT () {2;}' unless defined(&V_CHECKXPT);
    eval 'sub V_CHECKPIN () {4;}' unless defined(&V_CHECKPIN);
    eval 'sub V_TOUCH () {1;}' unless defined(&V_TOUCH);
    eval 'sub V_NOTOUCH () {0;}' unless defined(&V_NOTOUCH);
    eval 'sub KERKEY () {0;}' unless defined(&KERKEY);
    eval 'sub UBLKKEY () {0;}' unless defined(&UBLKKEY);
    eval 'sub FILEKEY () {1;}' unless defined(&FILEKEY);
    eval 'sub UTXTKEY () {1;}' unless defined(&UTXTKEY);
    eval 'sub UDATAKEY () {2;}' unless defined(&UDATAKEY);
    eval 'sub RDONLY () {3;}' unless defined(&RDONLY);
    eval 'sub VM_IOACCESSP_MAKE () {0x1;}' unless defined(&VM_IOACCESSP_MAKE);
    eval 'sub VM_IOACCESSP_FLUSH () {0x2;}' unless defined(&VM_IOACCESSP_FLUSH);
    eval 'sub VM_IOACCESSP_PGINWAIT () {0x4;}' unless defined(&VM_IOACCESSP_PGINWAIT);
    eval 'sub VM_IOACCESSP_PGOUTWAIT () {0x8;}' unless defined(&VM_IOACCESSP_PGOUTWAIT);
    eval 'sub VM_IOACCESSP_WAITONLY () {0x10;}' unless defined(&VM_IOACCESSP_WAITONLY);
    eval 'sub VM_MVC_ZERO () {1;}' unless defined(&VM_MVC_ZERO);
    eval 'sub VM_MVC_READ () {2;}' unless defined(&VM_MVC_READ);
    eval 'sub VM_MVC_WRITE () {3;}' unless defined(&VM_MVC_WRITE);
    eval 'sub V_WAITERR () {0;}' unless defined(&V_WAITERR);
    eval 'sub V_WAITALL () {1;}' unless defined(&V_WAITALL);
    eval 'sub V_IOERROR () {2;}' unless defined(&V_IOERROR);
    eval 'sub D_PAGING () {1;}' unless defined(&D_PAGING);
    eval 'sub D_FILESYSTEM () {2;}' unless defined(&D_FILESYSTEM);
    eval 'sub D_REMOTE () {4;}' unless defined(&D_REMOTE);
    eval 'sub D_LOGDEV () {8;}' unless defined(&D_LOGDEV);
    eval 'sub D_SERVER () {16;}' unless defined(&D_SERVER);
    eval 'sub D_XPAGER () {32;}' unless defined(&D_XPAGER);
    eval 'sub D_FLAGMASK () {0xffff0000;}' unless defined(&D_FLAGMASK);
    eval 'sub DEVTYPE {
        my($x) = @_;
	    eval q(($x & ~( &D_FLAGMASK)));
    }' unless defined(&DEVTYPE);
    eval 'sub DEVFLAGS {
        my($x) = @_;
	    eval q(($x &  &D_FLAGMASK));
    }' unless defined(&DEVFLAGS);
    eval 'sub D_PREXLATE () {0x80000000;}' unless defined(&D_PREXLATE);
    eval 'sub D_THRPGIO () {0x40000000;}' unless defined(&D_THRPGIO);
    eval 'sub D_ENHANCEDIO () {0x20000000;}' unless defined(&D_ENHANCEDIO);
    eval 'sub D_RB_READ () {0x10000000;}' unless defined(&D_RB_READ);
    eval 'sub D_RB_WRITE () {0x8000000;}' unless defined(&D_RB_WRITE);
    if(defined(&_LONG_LONG)) {
	eval 'sub MAX_BFSIZE () {(1 << 36);}' unless defined(&MAX_BFSIZE);
	eval 'sub MAX_CBFSIZE () {(1 << 40);}' unless defined(&MAX_CBFSIZE);
    }
    eval 'sub MAXFSIZE () {((1<< 31));}' unless defined(&MAXFSIZE);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub VU_INPLACE () {0x1;}' unless defined(&VU_INPLACE);
	eval 'sub VU_ANYWHERE () {0x2;}' unless defined(&VU_ANYWHERE);
    }
    eval 'sub VM_OK () {0;}' unless defined(&VM_OK);
    eval 'sub VM_WAIT () {-1;}' unless defined(&VM_WAIT);
    eval 'sub VM_ECC () {-2;}' unless defined(&VM_ECC);
    eval 'sub VM_XMEMCNT () {-3;}' unless defined(&VM_XMEMCNT);
    eval 'sub VM_EXTMEM () {-4;}' unless defined(&VM_EXTMEM);
    eval 'sub VM_NOTIN () {-5;}' unless defined(&VM_NOTIN);
    eval 'sub VM_NOPFAULT () {-6;}' unless defined(&VM_NOPFAULT);
    eval 'sub VM_UNHIDE () {-7;}' unless defined(&VM_UNHIDE);
    eval 'sub VM_NOTMINE () {-8;}' unless defined(&VM_NOTMINE);
    eval 'sub VM_NOWAIT () {-9;}' unless defined(&VM_NOWAIT);
    eval 'sub VM_NOSPACE () {-10;}' unless defined(&VM_NOSPACE);
    eval 'sub VM_SPARSE () {-11;}' unless defined(&VM_SPARSE);
    eval 'sub VM_NOXPT () {-12;}' unless defined(&VM_NOXPT);
    eval 'sub VM_XMDBG () {-13;}' unless defined(&VM_XMDBG);
    eval 'sub VM_CMDIRTY () {-14;}' unless defined(&VM_CMDIRTY);
    eval 'sub VM_KPROC () {-15;}' unless defined(&VM_KPROC);
    eval 'sub ASYNC_CLIENT_MAGIC () {0x41434c49;}' unless defined(&ASYNC_CLIENT_MAGIC);
    eval 'sub MAX_XFER_4K () {0;}' unless defined(&MAX_XFER_4K);
    eval 'sub MAX_XFER_8K () {1;}' unless defined(&MAX_XFER_8K);
    eval 'sub MAX_XFER_16K () {2;}' unless defined(&MAX_XFER_16K);
    eval 'sub MAX_XFER_32K () {3;}' unless defined(&MAX_XFER_32K);
    eval 'sub MAX_XFER_64K () {4;}' unless defined(&MAX_XFER_64K);
    eval 'sub MAX_XFER_128K () {5;}' unless defined(&MAX_XFER_128K);
    eval 'sub MAX_XFER_256K () {6;}' unless defined(&MAX_XFER_256K);
    eval 'sub MAX_XFER_512K () {7;}' unless defined(&MAX_XFER_512K);
    eval 'sub MAX_XFERTB {
        my($max_xfer) = @_;
	    eval q((1<< (($max_xfer) + 12)));
    }' unless defined(&MAX_XFERTB);
    eval 'sub MAX_XFERTP {
        my($max_xfer) = @_;
	    eval q((1<< ($max_xfer)));
    }' unless defined(&MAX_XFERTP);
    if(defined(&_KERNEL)) {
	eval 'sub UT_PGIO_SAVE_COUNT () {3;}' unless defined(&UT_PGIO_SAVE_COUNT);
	eval 'sub UT_THRPGIOTAIL_INIT () {(-2);}' unless defined(&UT_THRPGIOTAIL_INIT);
	eval 'sub UT_THRPGIOTAIL_PFGET () {(-3);}' unless defined(&UT_THRPGIOTAIL_PFGET);
	eval 'sub UT_THRPGIOTAIL_PFPROT () {(-4);}' unless defined(&UT_THRPGIOTAIL_PFPROT);
	eval 'sub UT_THRPGIOTAIL_READP () {(-5);}' unless defined(&UT_THRPGIOTAIL_READP);
	eval 'sub UT_THRPGIOTAIL_WRITEP () {(-6);}' unless defined(&UT_THRPGIOTAIL_WRITEP);
	eval 'sub UT_THRPGIOTAIL_FLUSHP () {(-7);}' unless defined(&UT_THRPGIOTAIL_FLUSHP);
	eval 'sub UT_THRPGIOTAIL_IOACCESSP () {(-8);}' unless defined(&UT_THRPGIOTAIL_IOACCESSP);
	eval 'sub UT_THRPGIOTAIL_WORKER () {(-9);}' unless defined(&UT_THRPGIOTAIL_WORKER);
	eval 'sub VM_THRPGIO_USERMODE () {0x1;}' unless defined(&VM_THRPGIO_USERMODE);
    }
    if(defined( (defined(&__64BIT_KERNEL) ? &__64BIT_KERNEL : 0)) || defined( &__FULL_PROTO)) {
	eval 'sub STARTOFPAGE {
	    my($x) = @_;
    	    eval q((($x & ~( &PAGESIZE-1))));
	}' unless defined(&STARTOFPAGE);
	eval 'sub NEXTPAGE {
	    my($x) = @_;
    	    eval q(((($x+( &PAGESIZE-1)) & (~( &PAGESIZE-1)))));
	}' unless defined(&NEXTPAGE);
	eval 'sub USER_PROTECT {
	    my($x,$y,$a) = @_;
    	    eval q( &if ( &STARTOFPAGE($y) >  &NEXTPAGE($x))  &vm_map( &NEXTPAGE($x), (($a)+ &NEXTPAGE($x)),  &STARTOFPAGE($y)- &NEXTPAGE($x)));
	}' unless defined(&USER_PROTECT);
    } else {
	eval 'sub STARTOFPAGE {
	    my($x) = @_;
    	    eval q(($x & ~( &PAGESIZE-1)));
	}' unless defined(&STARTOFPAGE);
	eval 'sub NEXTPAGE {
	    my($x) = @_;
    	    eval q((($x+( &PAGESIZE-1)) & (~( &PAGESIZE-1))));
	}' unless defined(&NEXTPAGE);
	eval 'sub USER_PROTECT {
	    my($x,$y,$a) = @_;
    	    eval q( &if ( &STARTOFPAGE >  &NEXTPAGE)  &vm_map( &NEXTPAGE, (($a)+ &NEXTPAGE($x)),  &STARTOFPAGE($y)- &NEXTPAGE($x)));
	}' unless defined(&USER_PROTECT);
    }
    eval 'sub STORE_PROTECT {
        my($x,$y) = @_;
	    eval q( &if ( &STARTOFPAGE($y) >  &NEXTPAGE($x))  &vm_protect( &NEXTPAGE($x), &STARTOFPAGE($y)- &NEXTPAGE($x), &RDONLY));
    }' unless defined(&STORE_PROTECT);
    eval 'sub UN_PROTECT {
        my($x,$y) = @_;
	    eval q( &if ( &STARTOFPAGE($y) >  &NEXTPAGE($x))  &vm_protect( &NEXTPAGE($x), &STARTOFPAGE($y)- &NEXTPAGE($x), &KERKEY));
    }' unless defined(&UN_PROTECT);
    if(defined(&_KERNEL)) {
	if(defined( (defined(&__64BIT_KERNEL) ? &__64BIT_KERNEL : 0)) || defined( &__FULL_PROTO)) {
	}
	if(defined(&__64BIT_KERNEL)) {
	}
    }
}
1;
