require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_VNODE)) {
    eval 'sub _H_VNODE () {1;}' unless defined(&_H_VNODE);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'sys/stat.ph';
    require 'sys/lockl.ph';
    require 'sys/uio.ph';
    require 'sys/rset.ph';
    eval 'sub v_socket () { ($_v_data->{_v_socket});}' unless defined(&v_socket);
    eval 'sub v_pfsvnode () { ($_v_data->{_v_pfsvnode});}' unless defined(&v_pfsvnode);
    eval 'sub V_ROOT () {0x1;}' unless defined(&V_ROOT);
    unless(defined(&VROOT)) {
	eval 'sub VROOT () { &V_ROOT;}' unless defined(&VROOT);
    }
    eval 'sub V_INTRANSIT () {0x4;}' unless defined(&V_INTRANSIT);
    eval 'sub V_DMA () {0x8;}' unless defined(&V_DMA);
    eval 'sub V_TEXT () {0x10;}' unless defined(&V_TEXT);
    eval 'sub V_RMDC () {0x20;}' unless defined(&V_RMDC);
    eval 'sub V_RENAME () {0x40;}' unless defined(&V_RENAME);
    eval 'sub V_LOCK () {0x80;}' unless defined(&V_LOCK);
    eval 'sub V_SPEC () {0x100;}' unless defined(&V_SPEC);
    eval 'sub V_ACCESS () {0x200;}' unless defined(&V_ACCESS);
    eval 'sub V_UPDATE () {0x400;}' unless defined(&V_UPDATE);
    eval 'sub V_LAZYTS () {0x800;}' unless defined(&V_LAZYTS);
    eval("sub VNON () { 0; }") unless defined(&VNON);
    eval("sub VREG () { 1; }") unless defined(&VREG);
    eval("sub VDIR () { 2; }") unless defined(&VDIR);
    eval("sub VBLK () { 3; }") unless defined(&VBLK);
    eval("sub VCHR () { 4; }") unless defined(&VCHR);
    eval("sub VLNK () { 5; }") unless defined(&VLNK);
    eval("sub VSOCK () { 6; }") unless defined(&VSOCK);
    eval("sub VBAD () { 7; }") unless defined(&VBAD);
    eval("sub VFIFO () { 8; }") unless defined(&VFIFO);
    eval("sub VMPC () { 9; }") unless defined(&VMPC);
    eval 'sub VUNDEF () { &VNON;}' unless defined(&VUNDEF);
    eval 'sub GNF_TCB () {0x1;}' unless defined(&GNF_TCB);
    eval 'sub GNF_WMAP () {0x2;}' unless defined(&GNF_WMAP);
    eval 'sub GNF_NSHARE () {0x4;}' unless defined(&GNF_NSHARE);
    eval 'sub GNF_NWRITEMOUNT () {0x8;}' unless defined(&GNF_NWRITEMOUNT);
    eval 'sub GNF_ATTACH () {0x100;}' unless defined(&GNF_ATTACH);
    eval 'sub GNF_NORDAWRB () {0x4000;}' unless defined(&GNF_NORDAWRB);
    eval 'sub GNF_XPAGER () {0x8000;}' unless defined(&GNF_XPAGER);
    eval 'sub gn_segcnt () { &gn_mwrcnt;}' unless defined(&gn_segcnt);
    eval 'sub v_type () { ($v_gnode->{gn_type});}' unless defined(&v_type);
    eval 'sub v_vntype () { ($v_gnode->{gn_type});}' unless defined(&v_vntype);
    eval 'sub v_rdev () { ($v_gnode->{gn_rdev});}' unless defined(&v_rdev);
    eval 'sub v_data () { ($v_gnode->{gn_data});}' unless defined(&v_data);
    eval 'sub gn_mntcnt () { &gn_excnt;}' unless defined(&gn_mntcnt);
    if(defined(&_KERNEL)) {
	eval 'sub VNOP_ACCESS {
	    my($vp, $mode, $who, $ucred) = @_;
    	    eval q( &vnop_access($vp, $mode, $who, $ucred));
	}' unless defined(&VNOP_ACCESS);
	eval 'sub VNOP_CLOSE {
	    my($vp, $flags, $vinfo, $ucred) = @_;
    	    eval q( &vnop_close($vp, $flags, $vinfo, $ucred));
	}' unless defined(&VNOP_CLOSE);
	eval 'sub VNOP_CREATE {
	    my($dp, $vpp, $flags, $name, $mode, $vinfo, $ucred) = @_;
    	    eval q( &vnop_create($dp, $vpp, $flags, $name, $mode, $vinfo, $ucred));
	}' unless defined(&VNOP_CREATE);
	eval 'sub VNOP_FCLEAR {
	    my($vp, $flags, $offset, $length, $vinfo, $ucred) = @_;
    	    eval q( &vnop_fclear($vp, $flags, $offset, $length, $vinfo, $ucred));
	}' unless defined(&VNOP_FCLEAR);
	eval 'sub VNOP_FID {
	    my($vp, $fid, $ucred) = @_;
    	    eval q( &vnop_fid($vp, $fid, $ucred));
	}' unless defined(&VNOP_FID);
	eval 'sub VNOP_FSYNC {
	    my($vp, $flags, $vinfo, $ucred) = @_;
    	    eval q( &vnop_fsync($vp, $flags, $vinfo, $ucred));
	}' unless defined(&VNOP_FSYNC);
	eval 'sub VNOP_FTRUNC {
	    my($vp, $flags, $length, $vinfo, $ucred) = @_;
    	    eval q( &vnop_ftrunc($vp, $flags, $length, $vinfo, $ucred));
	}' unless defined(&VNOP_FTRUNC);
	eval 'sub VNOP_GETACL {
	    my($vp, $uiop, $ucred) = @_;
    	    eval q( &vnop_getacl($vp, $uiop, $ucred));
	}' unless defined(&VNOP_GETACL);
	eval 'sub VNOP_GETATTR {
	    my($vp, $vattrp, $ucred) = @_;
    	    eval q( &vnop_getattr($vp, $vattrp, $ucred));
	}' unless defined(&VNOP_GETATTR);
	eval 'sub VNOP_GETPCL {
	    my($vp, $uiop, $ucred) = @_;
    	    eval q( &vnop_getpcl($vp, $uiop, $ucred));
	}' unless defined(&VNOP_GETPCL);
	eval 'sub VNOP_HOLD {
	    my($vp) = @_;
    	    eval q( &vnop_hold($vp));
	}' unless defined(&VNOP_HOLD);
	eval 'sub VNOP_IOCTL {
	    my($vp, $cmd, $arg, $flags, $ext, $ucred) = @_;
    	    eval q( &vnop_ioctl($vp, $cmd, $arg, $flags, $ext, $ucred));
	}' unless defined(&VNOP_IOCTL);
	eval 'sub VNOP_LINK {
	    my($vp, $dp, $target, $ucred) = @_;
    	    eval q( &vnop_link($vp, $dp, $target, $ucred));
	}' unless defined(&VNOP_LINK);
	eval 'sub VNOP_LOCKCTL {
	    my($vp, $offset, $lckdat, $cmd, $retry_fcn, $retry_id, $ucred) = @_;
    	    eval q( &vnop_lockctl($vp, $offset, $lckdat, $cmd, $retry_fcn, $retry_id, $ucred));
	}' unless defined(&VNOP_LOCKCTL);
	eval 'sub VNOP_LOOKUP {
	    my($dp, $vpp, $nam, $flags, $vattrp, $ucred) = @_;
    	    eval q( &vnop_lookup($dp, $vpp, $nam, $flags, $vattrp, $ucred));
	}' unless defined(&VNOP_LOOKUP);
	eval 'sub VNOP_MAP {
	    my($vp, $addr, $length, $offset, $flags, $ucred) = @_;
    	    eval q( &vnop_map($vp, $addr, $length, $offset, $flags, $ucred));
	}' unless defined(&VNOP_MAP);
	eval 'sub VNOP_MKDIR {
	    my($vp, $name, $mode, $ucred) = @_;
    	    eval q( &vnop_mkdir($vp, $name, $mode, $ucred));
	}' unless defined(&VNOP_MKDIR);
	eval 'sub VNOP_MKNOD {
	    my($vp, $name, $mode, $dev, $ucred) = @_;
    	    eval q( &vnop_mknod($vp, $name, $mode, $dev, $ucred));
	}' unless defined(&VNOP_MKNOD);
	eval 'sub VNOP_OPEN {
	    my($vp, $flags, $ext, $vinfop, $ucred) = @_;
    	    eval q( &vnop_open($vp, $flags, $ext, $vinfop, $ucred));
	}' unless defined(&VNOP_OPEN);
	eval 'sub VNOP_SELECT {
	    my($vp, $correl, $reqevents, $rtnevents, $notify, $vinfo, $ucred) = @_;
    	    eval q( &vnop_select($vp, $correl, $reqevents, $rtnevents, $notify, $vinfo, $ucred));
	}' unless defined(&VNOP_SELECT);
	eval 'sub VNOP_RDWR {
	    my($vp, $op, $flags, $uiop, $ext, $vinfo, $vattrp, $ucred) = @_;
    	    eval q( &vnop_rdwr($vp, $op, $flags, $uiop, $ext, $vinfo, $vattrp, $ucred));
	}' unless defined(&VNOP_RDWR);
	eval 'sub VNOP_READDIR {
	    my($vp, $uiop, $ucred) = @_;
    	    eval q( &vnop_readdir($vp, $uiop, $ucred));
	}' unless defined(&VNOP_READDIR);
	eval 'sub VNOP_READLINK {
	    my($vp, $uiop, $ucred) = @_;
    	    eval q( &vnop_readlink($vp, $uiop, $ucred));
	}' unless defined(&VNOP_READLINK);
	eval 'sub VNOP_RELE {
	    my($vp) = @_;
    	    eval q( &vnop_rele($vp));
	}' unless defined(&VNOP_RELE);
	eval 'sub VNOP_REMOVE {
	    my($dp, $vp, $name, $ucred) = @_;
    	    eval q( &vnop_remove($dp, $vp, $name, $ucred));
	}' unless defined(&VNOP_REMOVE);
	eval 'sub VNOP_RENAME {
	    my($vp, $dp, $name, $tvp, $tdp, $tname, $ucred) = @_;
    	    eval q( &vnop_rename($vp, $dp, $name, $tvp, $tdp, $tname, $ucred));
	}' unless defined(&VNOP_RENAME);
	eval 'sub VNOP_REVOKE {
	    my($vp, $cmd, $flags, $vattrp, $ucred) = @_;
    	    eval q( &vnop_revoke($vp, $cmd, $flags, $vattrp, $ucred));
	}' unless defined(&VNOP_REVOKE);
	eval 'sub VNOP_RMDIR {
	    my($vp, $dp, $name, $ucred) = @_;
    	    eval q( &vnop_rmdir($vp, $dp, $name, $ucred));
	}' unless defined(&VNOP_RMDIR);
	eval 'sub VNOP_SETACL {
	    my($vp, $uiop, $ucred) = @_;
    	    eval q( &vnop_setacl($vp, $uiop, $ucred));
	}' unless defined(&VNOP_SETACL);
	eval 'sub VNOP_SETATTR {
	    my($vp, $op, $arg1, $arg2, $arg3, $ucred) = @_;
    	    eval q( &vnop_setattr($vp, $op, $arg1, $arg2, $arg3, $ucred));
	}' unless defined(&VNOP_SETATTR);
	eval 'sub VNOP_SETPCL {
	    my($vp, $uiop, $ucred) = @_;
    	    eval q( &vnop_setpcl($vp, $uiop, $ucred));
	}' unless defined(&VNOP_SETPCL);
	eval 'sub VNOP_STRATEGY {
	    my($vp, $bp, $ucred) = @_;
    	    eval q( &vnop_strategy($vp, $bp, $ucred));
	}' unless defined(&VNOP_STRATEGY);
	eval 'sub VNOP_SYMLINK {
	    my($vp, $name, $target, $ucred) = @_;
    	    eval q( &vnop_symlink($vp, $name, $target, $ucred));
	}' unless defined(&VNOP_SYMLINK);
	eval 'sub VNOP_UNMAP {
	    my($vp, $addr, $ucred) = @_;
    	    eval q( &vnop_unmap($vp, $addr, $ucred));
	}' unless defined(&VNOP_UNMAP);
	eval 'sub VNOP_SEEK {
	    my($vp, $off, $ucred) = @_;
    	    eval q( &vnop_seek($vp, $off, $ucred));
	}' unless defined(&VNOP_SEEK);
	eval 'sub VNOP_FSYNC_RANGE {
	    my($vp, $flags, $vinfo, $off, $len, $ucred) = @_;
    	    eval q( &vnop_fsync_range($vp, $flags, $vinfo, $off, $len, $ucred));
	}' unless defined(&VNOP_FSYNC_RANGE);
	eval 'sub VNOP_CREATE_ATTR {
	    my($dp, $vpp, $flags, $name, $vap, $vcf, $vinfo, $ucred) = @_;
    	    eval q( &vnop_create_attr($dp, $vpp, $flags, $name, $vap, $vcf, $vinfo, $ucred));
	}' unless defined(&VNOP_CREATE_ATTR);
	eval 'sub VNOP_FINFO {
	    my($vp, $cmd, $p, $len, $ucred) = @_;
    	    eval q( &vnop_finfo($vp, $cmd, $p, $len, $ucred));
	}' unless defined(&VNOP_FINFO);
	eval 'sub VNOP_MAP_LLOFF {
	    my($vp, $a, $len, $off, $mf, $ff, $ucred) = @_;
    	    eval q( &vnop_map_lloff($vp, $a, $len, $off, $mf, $ff, $ucred));
	}' unless defined(&VNOP_MAP_LLOFF);
	eval 'sub VNOP_READDIR_EOFP {
	    my($vp, $uiop, $eofp, $ucred) = @_;
    	    eval q( &vnop_readdir_eofp($vp, $uiop, $eofp, $ucred));
	}' unless defined(&VNOP_READDIR_EOFP);
	eval 'sub VNOP_RDWR_ATTR {
	    my($vp, $rw, $ff, $uio, $x, $vi, $pre, $post, $ucred) = @_;
    	    eval q( &vnop_rdwr_attr($vp, $rw, $ff, $uio, $x, $vi, $pre, $post, $ucred));
	}' unless defined(&VNOP_RDWR_ATTR);
	eval 'sub VNOP_MEMCNTL {
	    my($vp,$cmd,$arg,$ucred) = @_;
    	    eval q( &vnop_memcntl($vp,$cmd,$arg,$ucred));
	}' unless defined(&VNOP_MEMCNTL);
	eval 'sub gn_rdawrb {
	    my($gp) = @_;
    	    eval q((! (($gp)-> &gn_flags &  &GNF_NORDAWRB)));
	}' unless defined(&gn_rdawrb);
	eval 'sub PagerCallOut {
	    my($gp) = @_;
    	    eval q((($gp)-> &gn_flags &  &GNF_XPAGER));
	}' unless defined(&PagerCallOut);
	eval 'sub XPAGER_RA_TRIGGER () {0x1;}' unless defined(&XPAGER_RA_TRIGGER);
	eval 'sub XPAGER_OVERWRITE () {0x1;}' unless defined(&XPAGER_OVERWRITE);
	eval 'sub XPAGER_HOLE () {0x2;}' unless defined(&XPAGER_HOLE);
	eval 'sub XPAGER_EXTEND () {0x4;}' unless defined(&XPAGER_EXTEND);
	eval 'sub XPAGER_APPEND () {0x8;}' unless defined(&XPAGER_APPEND);
	eval 'sub XPAGER_MAPPED () {0x10;}' unless defined(&XPAGER_MAPPED);
	eval 'sub XPAGER_MMAPPED () {0x20;}' unless defined(&XPAGER_MMAPPED);
	eval 'sub XPAGER_MAKEPAGE () {0x100;}' unless defined(&XPAGER_MAKEPAGE);
	eval 'sub XPAGER_ZEROFILL () {0x200;}' unless defined(&XPAGER_ZEROFILL);
	eval 'sub XPAGER_COPY_SUCCESS () {0x;}' unless defined(&XPAGER_COPY_SUCCESS);
	eval 'sub XPAGER_COPY_FAILURE () {0x10000;}' unless defined(&XPAGER_COPY_FAILURE);
	eval 'sub XPAGER_MMAP () {0x10;}' unless defined(&XPAGER_MMAP);
	eval 'sub XPAGER_STORE () {0x20;}' unless defined(&XPAGER_STORE);
	eval 'sub XPAGER_PROTECT () {0x40;}' unless defined(&XPAGER_PROTECT);
	eval 'sub XPAGER_READ () {0x1;}' unless defined(&XPAGER_READ);
	eval 'sub XPAGER_WRITE () {0x2;}' unless defined(&XPAGER_WRITE);
	eval 'sub XPAGER_RELEASE () {0x4;}' unless defined(&XPAGER_RELEASE);
	eval 'sub PagerBackRange {
	    my($gp, $offset, $dest, $nBytesOfRange, $nBytesBacked, $flags) = @_;
    	    eval q((*($gp)-> ($gn_ops->{pagerBackRange}))($gp, ( &offset_t)$offset, $dest, $nBytesOfRange, $nBytesBacked, $flags));
	}' unless defined(&PagerBackRange);
	eval 'sub PagerEndCopy {
	    my($gp, $offset, $nBytesMoved, $nBytesBacked, $flags) = @_;
    	    eval q((*($gp)-> ($gn_ops->{pagerEndCopy}))($gp, ( &offset_t)$offset,$nBytesMoved,$nBytesBacked,$flags));
	}' unless defined(&PagerEndCopy);
	eval 'sub PagerGetFileSize {
	    my($gp) = @_;
    	    eval q((*($gp)-> ($gn_ops->{pagerGetFileSize}))($gp));
	}' unless defined(&PagerGetFileSize);
	eval 'sub PagerReadAhead {
	    my($gp, $pFault, $pFirst, $nPage, $pTripWire, $tripWire) = @_;
    	    eval q((*($gp)-> ($gn_ops->{pagerReadAhead}))($gp, ( &vpn_t)$pFault, ( &vpn_t *)$pFirst, ( &vpn_t *)$nPage, ( &vpn_t *)$pTripWire, ( &boolean_t)$tripWire));
	}' unless defined(&PagerReadAhead);
	eval 'sub PagerReadWriteBehind {
	    my($gp, $offset, $length, $flags) = @_;
    	    eval q((*($gp)-> ($gn_ops->{pagerReadWriteBehind}))($gp, ( &int64_t)$offset, ( &int64_t)$length, $flags));
	}' unless defined(&PagerReadWriteBehind);
	eval 'sub F_ATTACH () {1;}' unless defined(&F_ATTACH);
	eval 'sub F_DETACH () {2;}' unless defined(&F_DETACH);
	eval 'sub F_ATTINFO () {3;}' unless defined(&F_ATTINFO);
    }
    if(defined(&_SUN)) {
	require 'sys/vattr.ph';
	eval("sub NONEXCL () { 0; }") unless defined(&NONEXCL);
	eval("sub EXCL () { 1; }") unless defined(&EXCL);
    }
    eval 'sub IFTOVT {
        my($M) = @_;
	    eval q(( $iftovt_tab[(($M) &  &S_IFMT) >> 12]));
    }' unless defined(&IFTOVT);
    eval 'sub VTTOIF {
        my($T) = @_;
	    eval q(( $vttoif_tab[($T)]));
    }' unless defined(&VTTOIF);
    eval 'sub MAKEIMODE {
        my($T, $M) = @_;
	    eval q(( &VTTOIF($T) | ($M)));
    }' unless defined(&MAKEIMODE);
    eval 'sub VTOGP {
        my($x) = @_;
	    eval q(((($x)-> &v_gnode)));
    }' unless defined(&VTOGP);
    eval 'sub VC_DEFAULT () {0;}' unless defined(&VC_DEFAULT);
    eval 'sub VC_LOOKUP () {1;}' unless defined(&VC_LOOKUP);
    eval 'sub VC_OPEN () {2;}' unless defined(&VC_OPEN);
    if(defined(&__cplusplus)) {
    }
}
1;
