require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_WLM)) {
    eval 'sub _H_WLM () {1;}' unless defined(&_H_WLM);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'sys/param.ph';
    require 'sys/lock_def.ph';
    require 'sys/rset.ph';
    eval 'sub WLM_VERSION_FIELD () {0xf0000000;}' unless defined(&WLM_VERSION_FIELD);
    eval 'sub WLM_VERSION () {0x10000000;}' unless defined(&WLM_VERSION);
    eval 'sub WLM_MUTE () {0x1000000;}' unless defined(&WLM_MUTE);
    eval 'sub WLM_OFF () {0x;}' unless defined(&WLM_OFF);
    eval 'sub WLM_ACTIVE () {0x1;}' unless defined(&WLM_ACTIVE);
    eval 'sub WLM_PASSIVE () {0x2;}' unless defined(&WLM_PASSIVE);
    eval 'sub WLM_BIND_RSETS () {0x4;}' unless defined(&WLM_BIND_RSETS);
    eval 'sub WLM_CPUONLY () {0x8;}' unless defined(&WLM_CPUONLY);
    eval 'sub WLM_TEST_ON () {0x200;}' unless defined(&WLM_TEST_ON);
    eval 'sub WLM_MAX_CLASSES () {27;}' unless defined(&WLM_MAX_CLASSES);
    eval 'sub WLM_MAX_SUBCLASSES () {10;}' unless defined(&WLM_MAX_SUBCLASSES);
    eval 'sub WLM_TIER_MIN () {0;}' unless defined(&WLM_TIER_MIN);
    eval 'sub WLM_TIER_MAX () {9;}' unless defined(&WLM_TIER_MAX);
    eval 'sub WLM_SHARES_UNDEF () {(-1);}' unless defined(&WLM_SHARES_UNDEF);
    eval 'sub WLM_NYC_NAME () {"Unclassified";}' unless defined(&WLM_NYC_NAME);
    eval 'sub WLM_UNMANAGED_NAME () {"Unmanaged";}' unless defined(&WLM_UNMANAGED_NAME);
    eval 'sub WLM_DEFAULT_NAME () {"Default";}' unless defined(&WLM_DEFAULT_NAME);
    eval 'sub WLM_SHARED_NAME () {"Shared";}' unless defined(&WLM_SHARED_NAME);
    eval 'sub WLM_SYSTEM_NAME () {"System";}' unless defined(&WLM_SYSTEM_NAME);
    eval 'sub SWLMTAGINHERITFORK () {0x4000;}' unless defined(&SWLMTAGINHERITFORK);
    eval 'sub SWLMTAGINHERITEXEC () {0x8000;}' unless defined(&SWLMTAGINHERITEXEC);
    eval 'sub WLM_TYP_FIXPRI () {1;}' unless defined(&WLM_TYP_FIXPRI);
    eval 'sub WLM_TYP_PLOCK () {2;}' unless defined(&WLM_TYP_PLOCK);
    eval 'sub WLM_TYP_64BITS () {4;}' unless defined(&WLM_TYP_64BITS);
    eval 'sub WLM_CLASSNAME_LENGTH () {16;}' unless defined(&WLM_CLASSNAME_LENGTH);
    eval 'sub WLM_RULE_LEN () {4096;}' unless defined(&WLM_RULE_LEN);
    eval 'sub WLM_SEPARATOR () {ord(\'.\');}' unless defined(&WLM_SEPARATOR);
    eval 'sub WLM_RES_CPU () {0;}' unless defined(&WLM_RES_CPU);
    eval 'sub WLM_RES_MEM () {1;}' unless defined(&WLM_RES_MEM);
    eval 'sub WLM_RES_BIO () {2;}' unless defined(&WLM_RES_BIO);
    eval 'sub WLM_RES_NB () {3;}' unless defined(&WLM_RES_NB);
    eval 'sub WLM_NOGUID () {-1;}' unless defined(&WLM_NOGUID);
    eval 'sub WLM_SUB_ONLY () {0x1;}' unless defined(&WLM_SUB_ONLY);
    eval 'sub WLM_SUPER_ONLY () {0x2;}' unless defined(&WLM_SUPER_ONLY);
    eval 'sub WLM_VERBOSE_MODE () {0x4;}' unless defined(&WLM_VERBOSE_MODE);
    eval 'sub WLM_BIO_CLASS_INFO () {0x8;}' unless defined(&WLM_BIO_CLASS_INFO);
    eval 'sub WLM_BIO_DEV_INFO () {0x10;}' unless defined(&WLM_BIO_DEV_INFO);
    eval 'sub WLM_BIO_ALL_DEV () {0x20;}' unless defined(&WLM_BIO_ALL_DEV);
    eval 'sub WLM_BIO_ALL_MINOR () {0x40;}' unless defined(&WLM_BIO_ALL_MINOR);
    eval 'sub WLM_NOSTAT () {0x80;}' unless defined(&WLM_NOSTAT);
    eval 'sub wlm_update_stat_regul {
        my($r,$current) = @_;
	    eval q(($r)-> &cumpct += ($r)-> &consum;  &if (($r)-> &cumpct < 0) ($r)-> &cumpct = 0;  &if ($current > ($r)-> &hwm) ($r)-> &hwm = $current;);
    }' unless defined(&wlm_update_stat_regul);
    eval 'sub wbc_dev () { ($wbc_dev_u->{dev});}' unless defined(&wbc_dev);
    eval 'sub WBS_RTHRPUT () {0;}' unless defined(&WBS_RTHRPUT);
    eval 'sub WBS_WTHRPUT () {1;}' unless defined(&WBS_WTHRPUT);
    eval 'sub WBS_REQUESTS () {2;}' unless defined(&WBS_REQUESTS);
    eval 'sub WBS_QUEUED () {3;}' unless defined(&WBS_QUEUED);
    eval 'sub WBS_STARVED () {4;}' unless defined(&WBS_STARVED);
    eval 'sub WBS_ACTIVITY () {5;}' unless defined(&WBS_ACTIVITY);
    eval 'sub WBS_MAX () {6;}' unless defined(&WBS_MAX);
    eval 'sub wbd_dev () { ($wbd_dev_u->{dev});}' unless defined(&wbd_dev);
    eval 'sub WLM_ASSIGN_SUPER () {1;}' unless defined(&WLM_ASSIGN_SUPER);
    eval 'sub WLM_ASSIGN_SUB () {2;}' unless defined(&WLM_ASSIGN_SUB);
    eval 'sub WLM_ASSIGN_BOTH () {( &WLM_ASSIGN_SUPER| &WLM_ASSIGN_SUB);}' unless defined(&WLM_ASSIGN_BOTH);
    eval 'sub WLM_UNASSIGN_SUPER () {4;}' unless defined(&WLM_UNASSIGN_SUPER);
    eval 'sub WLM_UNASSIGN_SUB () {8;}' unless defined(&WLM_UNASSIGN_SUB);
    eval 'sub WLM_UNASSIGN_BOTH () {( &WLM_UNASSIGN_SUPER| &WLM_UNASSIGN_SUB);}' unless defined(&WLM_UNASSIGN_BOTH);
    eval 'sub wa_pids () { ($wa_pid_u->{_pids});}' unless defined(&wa_pids);
    eval 'sub wa_pgids () { ($wa_pgid_u->{_pids});}' unless defined(&wa_pgids);
    eval 'sub WLM_BADVERS () {501;}' unless defined(&WLM_BADVERS);
    eval 'sub WLM_NOTINITED () {502;}' unless defined(&WLM_NOTINITED);
    eval 'sub WLM_ALREADYINIT () {503;}' unless defined(&WLM_ALREADYINIT);
    eval 'sub WLM_UNSUPP () {504;}' unless defined(&WLM_UNSUPP);
    eval 'sub WLM_OPENERR () {505;}' unless defined(&WLM_OPENERR);
    eval 'sub WLM_CREATERR () {506;}' unless defined(&WLM_CREATERR);
    eval 'sub WLM_MKDIRERR () {507;}' unless defined(&WLM_MKDIRERR);
    eval 'sub WLM_WRITERR () {508;}' unless defined(&WLM_WRITERR);
    eval 'sub WLM_REMERR () {509;}' unless defined(&WLM_REMERR);
    eval 'sub WLM_RENAMERR () {510;}' unless defined(&WLM_RENAMERR);
    eval 'sub WLM_SYMLERR () {511;}' unless defined(&WLM_SYMLERR);
    eval 'sub WLM_NOMEM () {512;}' unless defined(&WLM_NOMEM);
    eval 'sub WLM_NOCLASS () {513;}' unless defined(&WLM_NOCLASS);
    eval 'sub WLM_RNOCLASS () {514;}' unless defined(&WLM_RNOCLASS);
    eval 'sub WLM_EXISTS () {515;}' unless defined(&WLM_EXISTS);
    eval 'sub WLM_MAXCLASSES () {516;}' unless defined(&WLM_MAXCLASSES);
    eval 'sub WLM_RMPREDEF () {517;}' unless defined(&WLM_RMPREDEF);
    eval 'sub WLM_NOSUBS () {518;}' unless defined(&WLM_NOSUBS);
    eval 'sub WLM_HASSUBS () {519;}' unless defined(&WLM_HASSUBS);
    eval 'sub WLM_SHAREDSUB () {520;}' unless defined(&WLM_SHAREDSUB);
    eval 'sub WLM_SHAREDLIM () {521;}' unless defined(&WLM_SHAREDLIM);
    eval 'sub WLM_BADDEFSHR () {522;}' unless defined(&WLM_BADDEFSHR);
    eval 'sub WLM_BADDEFLIM () {523;}' unless defined(&WLM_BADDEFLIM);
    eval 'sub WLM_BADLIMFMT () {524;}' unless defined(&WLM_BADLIMFMT);
    eval 'sub WLM_BADSHRFMT () {525;}' unless defined(&WLM_BADSHRFMT);
    eval 'sub WLM_BADTIER () {526;}' unless defined(&WLM_BADTIER);
    eval 'sub WLM_BADSHARES () {527;}' unless defined(&WLM_BADSHARES);
    eval 'sub WLM_BADMIN () {528;}' unless defined(&WLM_BADMIN);
    eval 'sub WLM_BADSMAX () {529;}' unless defined(&WLM_BADSMAX);
    eval 'sub WLM_BADHMAX () {530;}' unless defined(&WLM_BADHMAX);
    eval 'sub WLM_BADCNAME () {531;}' unless defined(&WLM_BADCNAME);
    eval 'sub WLM_TOOLONG () {532;}' unless defined(&WLM_TOOLONG);
    eval 'sub WLM_MINSMAX () {533;}' unless defined(&WLM_MINSMAX);
    eval 'sub WLM_SMAXHMAX () {534;}' unless defined(&WLM_SMAXHMAX);
    eval 'sub WLM_SUMMINS () {535;}' unless defined(&WLM_SUMMINS);
    eval 'sub WLM_BADINHER () {536;}' unless defined(&WLM_BADINHER);
    eval 'sub WLM_LOADERR () {537;}' unless defined(&WLM_LOADERR);
    eval 'sub WLM_RULESERR () {538;}' unless defined(&WLM_RULESERR);
    eval 'sub WLM_SETERR () {539;}' unless defined(&WLM_SETERR);
    eval 'sub WLM_QUERYERR () {540;}' unless defined(&WLM_QUERYERR);
    eval 'sub WLM_MANYRULES () {541;}' unless defined(&WLM_MANYRULES);
    eval 'sub WLM_MANYITEMS () {542;}' unless defined(&WLM_MANYITEMS);
    eval 'sub WLM_RULERR () {543;}' unless defined(&WLM_RULERR);
    eval 'sub WLM_BADLIST () {544;}' unless defined(&WLM_BADLIST);
    eval 'sub WLM_BADUSR () {545;}' unless defined(&WLM_BADUSR);
    eval 'sub WLM_BADRUSR () {546;}' unless defined(&WLM_BADRUSR);
    eval 'sub WLM_BADUID () {547;}' unless defined(&WLM_BADUID);
    eval 'sub WLM_BADGRP () {548;}' unless defined(&WLM_BADGRP);
    eval 'sub WLM_BADRGRP () {549;}' unless defined(&WLM_BADRGRP);
    eval 'sub WLM_BADGID () {550;}' unless defined(&WLM_BADGID);
    eval 'sub WLM_BADTAG () {551;}' unless defined(&WLM_BADTAG);
    eval 'sub WLM_BADTYP () {552;}' unless defined(&WLM_BADTYP);
    eval 'sub WLM_NOSHRRULE () {553;}' unless defined(&WLM_NOSHRRULE);
    eval 'sub WLM_NOWILDCRD () {554;}' unless defined(&WLM_NOWILDCRD);
    eval 'sub WLM_STATERR () {555;}' unless defined(&WLM_STATERR);
    eval 'sub WLM_EMPTYRULE () {556;}' unless defined(&WLM_EMPTYRULE);
    eval 'sub WLM_RUNERR () {557;}' unless defined(&WLM_RUNERR);
    eval 'sub WLM_BADCONFIG () {558;}' unless defined(&WLM_BADCONFIG);
    eval 'sub WLM_CLASSMIS () {559;}' unless defined(&WLM_CLASSMIS);
    eval 'sub WLM_EMPTYATTR () {560;}' unless defined(&WLM_EMPTYATTR);
    eval 'sub WLM_MULTATTR () {561;}' unless defined(&WLM_MULTATTR);
    eval 'sub WLM_EXCLATTR () {562;}' unless defined(&WLM_EXCLATTR);
    eval 'sub WLM_ATTERR () {563;}' unless defined(&WLM_ATTERR);
    eval 'sub WLM_BADATTUSR () {564;}' unless defined(&WLM_BADATTUSR);
    eval 'sub WLM_BADATTGRP () {565;}' unless defined(&WLM_BADATTGRP);
    eval 'sub WLM_BADATTAPP () {566;}' unless defined(&WLM_BADATTAPP);
    eval 'sub WLM_BADATTTAG () {567;}' unless defined(&WLM_BADATTTAG);
    eval 'sub WLM_BADATTTYP () {568;}' unless defined(&WLM_BADATTTYP);
    eval 'sub WLM_TOOMANYATT () {569;}' unless defined(&WLM_TOOMANYATT);
    eval 'sub WLM_WILDCRDATT () {570;}' unless defined(&WLM_WILDCRDATT);
    eval 'sub WLM_RUNERRATT () {571;}' unless defined(&WLM_RUNERRATT);
    eval 'sub WLM_BADLISATT () {572;}' unless defined(&WLM_BADLISATT);
    eval 'sub WLM_TOOLONGATT () {573;}' unless defined(&WLM_TOOLONGATT);
    eval 'sub WLM_EFAULT () {574;}' unless defined(&WLM_EFAULT);
    eval 'sub WLM_NOTCOMPLETE () {575;}' unless defined(&WLM_NOTCOMPLETE);
    eval 'sub WLM_NOTRUNNING () {576;}' unless defined(&WLM_NOTRUNNING);
    eval 'sub WLM_ESRCH () {577;}' unless defined(&WLM_ESRCH);
    eval 'sub WLM_TOOMANYPID () {578;}' unless defined(&WLM_TOOMANYPID);
    eval 'sub WLM_EPERM () {579;}' unless defined(&WLM_EPERM);
    eval 'sub WLM_CANTASSIGN () {580;}' unless defined(&WLM_CANTASSIGN);
    eval 'sub WLM_TAGTOOLONG () {581;}' unless defined(&WLM_TAGTOOLONG);
    eval 'sub WLM_BADFLAGS () {582;}' unless defined(&WLM_BADFLAGS);
    eval 'sub WLM_CANTSETTAG () {583;}' unless defined(&WLM_CANTSETTAG);
    eval 'sub WLM_CANTCHECK () {584;}' unless defined(&WLM_CANTCHECK);
    eval 'sub WLM_TOOSMALL () {585;}' unless defined(&WLM_TOOSMALL);
    eval 'sub WLM_BADRSET () {586;}' unless defined(&WLM_BADRSET);
    eval 'sub WLM_CHOWNERR () {587;}' unless defined(&WLM_CHOWNERR);
    eval 'sub WLM_LOCKERR () {588;}' unless defined(&WLM_LOCKERR);
    eval 'sub WLM_ERRNO () {589;}' unless defined(&WLM_ERRNO);
    eval 'sub WLM_BADCLNAME () {590;}' unless defined(&WLM_BADCLNAME);
    eval 'sub WLM_BADSUPER () {591;}' unless defined(&WLM_BADSUPER);
    eval 'sub WLM_NOTASSGND () {592;}' unless defined(&WLM_NOTASSGND);
    eval 'sub WLM_RULTOOLNG () {593;}' unless defined(&WLM_RULTOOLNG);
    eval 'sub WLM_NOADMINSUB () {594;}' unless defined(&WLM_NOADMINSUB);
    eval 'sub WLM_UNLOADERR () {595;}' unless defined(&WLM_UNLOADERR);
    eval 'sub WLM_NOSYSMAX () {596;}' unless defined(&WLM_NOSYSMAX);
    eval 'sub WLM_DUPKEY () {597;}' unless defined(&WLM_DUPKEY);
    eval 'sub WLM_READERR () {598;}' unless defined(&WLM_READERR);
    eval 'sub WLM_BADLOCALSHM () {599;}' unless defined(&WLM_BADLOCALSHM);
    eval 'sub WLM_IGNRULE () {600;}' unless defined(&WLM_IGNRULE);
    eval 'sub WLM_REFRULE () {601;}' unless defined(&WLM_REFRULE);
    eval 'sub WLM_RSVDNAME () {602;}' unless defined(&WLM_RSVDNAME);
    if(defined(&__cplusplus)) {
    }
}
1;
