require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XDPSproto_h)) {
    eval 'sub _XDPSproto_h () {1;}' unless defined(&_XDPSproto_h);
    require 'X11/Xmd.ph';
    eval 'sub Window () { &CARD32;}' unless defined(&Window);
    eval 'sub Drawable () { &CARD32;}' unless defined(&Drawable);
    eval 'sub Font () { &CARD32;}' unless defined(&Font);
    eval 'sub Pixmap () { &CARD32;}' unless defined(&Pixmap);
    eval 'sub Cursor () { &CARD32;}' unless defined(&Cursor);
    eval 'sub Colormap () { &CARD32;}' unless defined(&Colormap);
    eval 'sub GContext () { &CARD32;}' unless defined(&GContext);
    eval 'sub Atom () { &CARD32;}' unless defined(&Atom);
    eval 'sub VisualID () { &CARD32;}' unless defined(&VisualID);
    eval 'sub Time () { &CARD32;}' unless defined(&Time);
    eval 'sub KeyCode () { &CARD8;}' unless defined(&KeyCode);
    eval 'sub KeySym () { &CARD32;}' unless defined(&KeySym);
    eval 'sub DPSNAME () {"Adobe-DPS-Extension";}' unless defined(&DPSNAME);
    eval 'sub DECDPSNAME () {"DPSExtension";}' unless defined(&DECDPSNAME);
    eval 'sub DPSPROTO_V09 () {9;}' unless defined(&DPSPROTO_V09);
    eval 'sub DPSPROTO_V08 () {8;}' unless defined(&DPSPROTO_V08);
    eval 'sub DPSPROTO_OLDEST () { &DPSPROTO_V08;}' unless defined(&DPSPROTO_OLDEST);
    unless(defined(&DPSPROTOCOLVERSION)) {
	eval 'sub DPSPROTOCOLVERSION () { &DPSPROTO_V09;}' unless defined(&DPSPROTOCOLVERSION);
    }
    eval 'sub CONTEXTXID () { &CARD32;}' unless defined(&CONTEXTXID);
    eval 'sub SPACEXID () { &CARD32;}' unless defined(&SPACEXID);
    unless(defined(&BYTESPEROUTPUTEVENT)) {
	eval 'sub BYTESPEROUTPUTEVENT () {24;}' unless defined(&BYTESPEROUTPUTEVENT);
    }
    eval 'sub X_PSInit () {1;}' unless defined(&X_PSInit);
    eval 'sub X_PSCreateContext () {2;}' unless defined(&X_PSCreateContext);
    eval 'sub X_PSCreateSpace () {3;}' unless defined(&X_PSCreateSpace);
    eval 'sub X_PSGiveInput () {4;}' unless defined(&X_PSGiveInput);
    eval 'sub X_PSGetStatus () {5;}' unless defined(&X_PSGetStatus);
    eval 'sub X_PSDestroySpace () {6;}' unless defined(&X_PSDestroySpace);
    eval 'sub X_PSReset () {7;}' unless defined(&X_PSReset);
    eval 'sub X_PSNotifyContext () {8;}' unless defined(&X_PSNotifyContext);
    eval 'sub X_PSCreateContextFromID () {9;}' unless defined(&X_PSCreateContextFromID);
    eval 'sub X_PSXIDFromContext () {10;}' unless defined(&X_PSXIDFromContext);
    eval 'sub X_PSContextFromXID () {11;}' unless defined(&X_PSContextFromXID);
    eval 'sub X_PSSetStatusMask () {12;}' unless defined(&X_PSSetStatusMask);
    eval 'sub X_PSCreateSecureContext () {13;}' unless defined(&X_PSCreateSecureContext);
    eval 'sub X_PSNotifyWhenReady () {14;}' unless defined(&X_PSNotifyWhenReady);
    eval 'sub PSLASTREQUEST () { &X_PSNotifyWhenReady;}' unless defined(&PSLASTREQUEST);
    eval 'sub PSLASTREQUEST_P8 () { &X_PSSetStatusMask;}' unless defined(&PSLASTREQUEST_P8);
    eval 'sub sz_xPSInitReq () {8;}' unless defined(&sz_xPSInitReq);
    eval 'sub sz_xPSCreateContextReq () {76;}' unless defined(&sz_xPSCreateContextReq);
    eval 'sub sz_xPSCreateSpaceReq () {8;}' unless defined(&sz_xPSCreateSpaceReq);
    eval 'sub sz_xPSGiveInputReq () {12;}' unless defined(&sz_xPSGiveInputReq);
    eval 'sub sz_xPSGetStatusReq () {12;}' unless defined(&sz_xPSGetStatusReq);
    eval 'sub sz_xPSDestroySpaceReq () {8;}' unless defined(&sz_xPSDestroySpaceReq);
    eval 'sub sz_xPSResetReq () {8;}' unless defined(&sz_xPSResetReq);
    eval 'sub sz_xPSNotifyContextReq () {12;}' unless defined(&sz_xPSNotifyContextReq);
    eval 'sub sz_xPSCreateContextFromIDReq () {12;}' unless defined(&sz_xPSCreateContextFromIDReq);
    eval 'sub sz_xPSXIDFromContextReq () {8;}' unless defined(&sz_xPSXIDFromContextReq);
    eval 'sub sz_xPSContextFromXIDReq () {8;}' unless defined(&sz_xPSContextFromXIDReq);
    eval 'sub sz_xPSSetStatusMaskReq () {20;}' unless defined(&sz_xPSSetStatusMaskReq);
    eval 'sub sz_xPSCreateSecureContextReq () { &sz_xPSCreateContextReq;}' unless defined(&sz_xPSCreateSecureContextReq);
    eval 'sub sz_xPSNotifyWhenReadyReq () {24;}' unless defined(&sz_xPSNotifyWhenReadyReq);
    undef(&Window) if defined(&Window);
    undef(&Drawable) if defined(&Drawable);
    undef(&Font) if defined(&Font);
    undef(&Pixmap) if defined(&Pixmap);
    undef(&Cursor) if defined(&Cursor);
    undef(&Colormap) if defined(&Colormap);
    undef(&GContext) if defined(&GContext);
    undef(&Atom) if defined(&Atom);
    undef(&VisualID) if defined(&VisualID);
    undef(&Time) if defined(&Time);
    undef(&KeyCode) if defined(&KeyCode);
    undef(&KeySym) if defined(&KeySym);
}
1;
