require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__gl_h_)) {
    eval 'sub __gl_h_ () {1;}' unless defined(&__gl_h_);
    if(defined( &USE_MGL_NAMESPACE)) {
	require 'gl_mangle.ph';
    }
    if(defined( &__BEOS__)) {
	require 'stdlib.ph';
    }
    if(!defined( &OPENSTEP)  && (defined( &NeXT) || defined( &NeXT_PDO))) {
	eval 'sub OPENSTEP () {1;}' unless defined(&OPENSTEP);
    }
    if(defined( &_WIN32)  && !defined( &__WIN32__)  && !defined( &__CYGWIN__)) {
	eval 'sub __WIN32__ () {1;}' unless defined(&__WIN32__);
    }
    if(!defined( &OPENSTEP)  && (defined( &__WIN32__)  && !defined( &__CYGWIN__))) {
	if(defined( &_MSC_VER)  && defined( &BUILD_GL32) ) {
	    eval 'sub GLAPI () { &__declspec( &dllexport);}' unless defined(&GLAPI);
	}
 elsif(defined( &_MSC_VER)  && defined( &_DLL) ) {
	    eval 'sub GLAPI () { &__declspec( &dllimport);}' unless defined(&GLAPI);
	} else {
	    eval 'sub GLAPI () { &extern;}' unless defined(&GLAPI);
	}
	eval 'sub GLAPIENTRY () { &__stdcall;}' unless defined(&GLAPIENTRY);
    } else {
	eval 'sub GLAPI () { &extern;}' unless defined(&GLAPI);
	eval 'sub GLAPIENTRY () {1;}' unless defined(&GLAPIENTRY);
    }
    if((defined( &__BEOS__)  && defined( &__POWERPC__)) || defined( &__QUICKDRAW__)) {
	eval 'sub PRAGMA_EXPORT_SUPPORTED () {1;}' unless defined(&PRAGMA_EXPORT_SUPPORTED);
    }
    if(defined( &_WIN32)  && !defined( &_WINGDI_)  && !defined( &_GNU_H_WINDOWS32_DEFINES)  && !defined( &OPENSTEP)  && !defined( &__CYGWIN__)) {
	require 'gl/mesa_wgl.ph';
    }
    if(defined( &macintosh)  && (defined(&PRAGMA_IMPORT_SUPPORTED) ? &PRAGMA_IMPORT_SUPPORTED : 0)) {
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub GL_VERSION_1_1 () {1;}' unless defined(&GL_VERSION_1_1);
    eval 'sub GL_VERSION_1_2 () {1;}' unless defined(&GL_VERSION_1_2);
    eval 'sub GL_VERSION_1_3 () {1;}' unless defined(&GL_VERSION_1_3);
    eval 'sub GL_ARB_imaging () {1;}' unless defined(&GL_ARB_imaging);
    if(defined(&CENTERLINE_CLPP)) {
	eval 'sub signed () {1;}' unless defined(&signed);
    }
    eval 'sub GL_FALSE () {0x;}' unless defined(&GL_FALSE);
    eval 'sub GL_TRUE () {0x1;}' unless defined(&GL_TRUE);
    eval 'sub GL_BYTE () {0x1400;}' unless defined(&GL_BYTE);
    eval 'sub GL_UNSIGNED_BYTE () {0x1401;}' unless defined(&GL_UNSIGNED_BYTE);
    eval 'sub GL_SHORT () {0x1402;}' unless defined(&GL_SHORT);
    eval 'sub GL_UNSIGNED_SHORT () {0x1403;}' unless defined(&GL_UNSIGNED_SHORT);
    eval 'sub GL_INT () {0x1404;}' unless defined(&GL_INT);
    eval 'sub GL_UNSIGNED_INT () {0x1405;}' unless defined(&GL_UNSIGNED_INT);
    eval 'sub GL_FLOAT () {0x1406;}' unless defined(&GL_FLOAT);
    eval 'sub GL_DOUBLE () {0x140a;}' unless defined(&GL_DOUBLE);
    eval 'sub GL_2_BYTES () {0x1407;}' unless defined(&GL_2_BYTES);
    eval 'sub GL_3_BYTES () {0x1408;}' unless defined(&GL_3_BYTES);
    eval 'sub GL_4_BYTES () {0x1409;}' unless defined(&GL_4_BYTES);
    eval 'sub GL_POINTS () {0x;}' unless defined(&GL_POINTS);
    eval 'sub GL_LINES () {0x1;}' unless defined(&GL_LINES);
    eval 'sub GL_LINE_LOOP () {0x2;}' unless defined(&GL_LINE_LOOP);
    eval 'sub GL_LINE_STRIP () {0x3;}' unless defined(&GL_LINE_STRIP);
    eval 'sub GL_TRIANGLES () {0x4;}' unless defined(&GL_TRIANGLES);
    eval 'sub GL_TRIANGLE_STRIP () {0x5;}' unless defined(&GL_TRIANGLE_STRIP);
    eval 'sub GL_TRIANGLE_FAN () {0x6;}' unless defined(&GL_TRIANGLE_FAN);
    eval 'sub GL_QUADS () {0x7;}' unless defined(&GL_QUADS);
    eval 'sub GL_QUAD_STRIP () {0x8;}' unless defined(&GL_QUAD_STRIP);
    eval 'sub GL_POLYGON () {0x9;}' unless defined(&GL_POLYGON);
    eval 'sub GL_VERTEX_ARRAY () {0x8074;}' unless defined(&GL_VERTEX_ARRAY);
    eval 'sub GL_NORMAL_ARRAY () {0x8075;}' unless defined(&GL_NORMAL_ARRAY);
    eval 'sub GL_COLOR_ARRAY () {0x8076;}' unless defined(&GL_COLOR_ARRAY);
    eval 'sub GL_INDEX_ARRAY () {0x8077;}' unless defined(&GL_INDEX_ARRAY);
    eval 'sub GL_TEXTURE_COORD_ARRAY () {0x8078;}' unless defined(&GL_TEXTURE_COORD_ARRAY);
    eval 'sub GL_EDGE_FLAG_ARRAY () {0x8079;}' unless defined(&GL_EDGE_FLAG_ARRAY);
    eval 'sub GL_VERTEX_ARRAY_SIZE () {0x807a;}' unless defined(&GL_VERTEX_ARRAY_SIZE);
    eval 'sub GL_VERTEX_ARRAY_TYPE () {0x807b;}' unless defined(&GL_VERTEX_ARRAY_TYPE);
    eval 'sub GL_VERTEX_ARRAY_STRIDE () {0x807c;}' unless defined(&GL_VERTEX_ARRAY_STRIDE);
    eval 'sub GL_NORMAL_ARRAY_TYPE () {0x807e;}' unless defined(&GL_NORMAL_ARRAY_TYPE);
    eval 'sub GL_NORMAL_ARRAY_STRIDE () {0x807f;}' unless defined(&GL_NORMAL_ARRAY_STRIDE);
    eval 'sub GL_COLOR_ARRAY_SIZE () {0x8081;}' unless defined(&GL_COLOR_ARRAY_SIZE);
    eval 'sub GL_COLOR_ARRAY_TYPE () {0x8082;}' unless defined(&GL_COLOR_ARRAY_TYPE);
    eval 'sub GL_COLOR_ARRAY_STRIDE () {0x8083;}' unless defined(&GL_COLOR_ARRAY_STRIDE);
    eval 'sub GL_INDEX_ARRAY_TYPE () {0x8085;}' unless defined(&GL_INDEX_ARRAY_TYPE);
    eval 'sub GL_INDEX_ARRAY_STRIDE () {0x8086;}' unless defined(&GL_INDEX_ARRAY_STRIDE);
    eval 'sub GL_TEXTURE_COORD_ARRAY_SIZE () {0x8088;}' unless defined(&GL_TEXTURE_COORD_ARRAY_SIZE);
    eval 'sub GL_TEXTURE_COORD_ARRAY_TYPE () {0x8089;}' unless defined(&GL_TEXTURE_COORD_ARRAY_TYPE);
    eval 'sub GL_TEXTURE_COORD_ARRAY_STRIDE () {0x808a;}' unless defined(&GL_TEXTURE_COORD_ARRAY_STRIDE);
    eval 'sub GL_EDGE_FLAG_ARRAY_STRIDE () {0x808c;}' unless defined(&GL_EDGE_FLAG_ARRAY_STRIDE);
    eval 'sub GL_VERTEX_ARRAY_POINTER () {0x808e;}' unless defined(&GL_VERTEX_ARRAY_POINTER);
    eval 'sub GL_NORMAL_ARRAY_POINTER () {0x808f;}' unless defined(&GL_NORMAL_ARRAY_POINTER);
    eval 'sub GL_COLOR_ARRAY_POINTER () {0x8090;}' unless defined(&GL_COLOR_ARRAY_POINTER);
    eval 'sub GL_INDEX_ARRAY_POINTER () {0x8091;}' unless defined(&GL_INDEX_ARRAY_POINTER);
    eval 'sub GL_TEXTURE_COORD_ARRAY_POINTER () {0x8092;}' unless defined(&GL_TEXTURE_COORD_ARRAY_POINTER);
    eval 'sub GL_EDGE_FLAG_ARRAY_POINTER () {0x8093;}' unless defined(&GL_EDGE_FLAG_ARRAY_POINTER);
    eval 'sub GL_V2F () {0x2a20;}' unless defined(&GL_V2F);
    eval 'sub GL_V3F () {0x2a21;}' unless defined(&GL_V3F);
    eval 'sub GL_C4UB_V2F () {0x2a22;}' unless defined(&GL_C4UB_V2F);
    eval 'sub GL_C4UB_V3F () {0x2a23;}' unless defined(&GL_C4UB_V3F);
    eval 'sub GL_C3F_V3F () {0x2a24;}' unless defined(&GL_C3F_V3F);
    eval 'sub GL_N3F_V3F () {0x2a25;}' unless defined(&GL_N3F_V3F);
    eval 'sub GL_C4F_N3F_V3F () {0x2a26;}' unless defined(&GL_C4F_N3F_V3F);
    eval 'sub GL_T2F_V3F () {0x2a27;}' unless defined(&GL_T2F_V3F);
    eval 'sub GL_T4F_V4F () {0x2a28;}' unless defined(&GL_T4F_V4F);
    eval 'sub GL_T2F_C4UB_V3F () {0x2a29;}' unless defined(&GL_T2F_C4UB_V3F);
    eval 'sub GL_T2F_C3F_V3F () {0x2a2a;}' unless defined(&GL_T2F_C3F_V3F);
    eval 'sub GL_T2F_N3F_V3F () {0x2a2b;}' unless defined(&GL_T2F_N3F_V3F);
    eval 'sub GL_T2F_C4F_N3F_V3F () {0x2a2c;}' unless defined(&GL_T2F_C4F_N3F_V3F);
    eval 'sub GL_T4F_C4F_N3F_V4F () {0x2a2d;}' unless defined(&GL_T4F_C4F_N3F_V4F);
    eval 'sub GL_MATRIX_MODE () {0xba0;}' unless defined(&GL_MATRIX_MODE);
    eval 'sub GL_MODELVIEW () {0x1700;}' unless defined(&GL_MODELVIEW);
    eval 'sub GL_PROJECTION () {0x1701;}' unless defined(&GL_PROJECTION);
    eval 'sub GL_TEXTURE () {0x1702;}' unless defined(&GL_TEXTURE);
    eval 'sub GL_POINT_SMOOTH () {0xb10;}' unless defined(&GL_POINT_SMOOTH);
    eval 'sub GL_POINT_SIZE () {0xb11;}' unless defined(&GL_POINT_SIZE);
    eval 'sub GL_POINT_SIZE_GRANULARITY () {0xb13;}' unless defined(&GL_POINT_SIZE_GRANULARITY);
    eval 'sub GL_POINT_SIZE_RANGE () {0xb12;}' unless defined(&GL_POINT_SIZE_RANGE);
    eval 'sub GL_LINE_SMOOTH () {0xb20;}' unless defined(&GL_LINE_SMOOTH);
    eval 'sub GL_LINE_STIPPLE () {0xb24;}' unless defined(&GL_LINE_STIPPLE);
    eval 'sub GL_LINE_STIPPLE_PATTERN () {0xb25;}' unless defined(&GL_LINE_STIPPLE_PATTERN);
    eval 'sub GL_LINE_STIPPLE_REPEAT () {0xb26;}' unless defined(&GL_LINE_STIPPLE_REPEAT);
    eval 'sub GL_LINE_WIDTH () {0xb21;}' unless defined(&GL_LINE_WIDTH);
    eval 'sub GL_LINE_WIDTH_GRANULARITY () {0xb23;}' unless defined(&GL_LINE_WIDTH_GRANULARITY);
    eval 'sub GL_LINE_WIDTH_RANGE () {0xb22;}' unless defined(&GL_LINE_WIDTH_RANGE);
    eval 'sub GL_POINT () {0x1b00;}' unless defined(&GL_POINT);
    eval 'sub GL_LINE () {0x1b01;}' unless defined(&GL_LINE);
    eval 'sub GL_FILL () {0x1b02;}' unless defined(&GL_FILL);
    eval 'sub GL_CW () {0x900;}' unless defined(&GL_CW);
    eval 'sub GL_CCW () {0x901;}' unless defined(&GL_CCW);
    eval 'sub GL_FRONT () {0x404;}' unless defined(&GL_FRONT);
    eval 'sub GL_BACK () {0x405;}' unless defined(&GL_BACK);
    eval 'sub GL_POLYGON_MODE () {0xb40;}' unless defined(&GL_POLYGON_MODE);
    eval 'sub GL_POLYGON_SMOOTH () {0xb41;}' unless defined(&GL_POLYGON_SMOOTH);
    eval 'sub GL_POLYGON_STIPPLE () {0xb42;}' unless defined(&GL_POLYGON_STIPPLE);
    eval 'sub GL_EDGE_FLAG () {0xb43;}' unless defined(&GL_EDGE_FLAG);
    eval 'sub GL_CULL_FACE () {0xb44;}' unless defined(&GL_CULL_FACE);
    eval 'sub GL_CULL_FACE_MODE () {0xb45;}' unless defined(&GL_CULL_FACE_MODE);
    eval 'sub GL_FRONT_FACE () {0xb46;}' unless defined(&GL_FRONT_FACE);
    eval 'sub GL_POLYGON_OFFSET_FACTOR () {0x8038;}' unless defined(&GL_POLYGON_OFFSET_FACTOR);
    eval 'sub GL_POLYGON_OFFSET_UNITS () {0x2a00;}' unless defined(&GL_POLYGON_OFFSET_UNITS);
    eval 'sub GL_POLYGON_OFFSET_POINT () {0x2a01;}' unless defined(&GL_POLYGON_OFFSET_POINT);
    eval 'sub GL_POLYGON_OFFSET_LINE () {0x2a02;}' unless defined(&GL_POLYGON_OFFSET_LINE);
    eval 'sub GL_POLYGON_OFFSET_FILL () {0x8037;}' unless defined(&GL_POLYGON_OFFSET_FILL);
    eval 'sub GL_COMPILE () {0x1300;}' unless defined(&GL_COMPILE);
    eval 'sub GL_COMPILE_AND_EXECUTE () {0x1301;}' unless defined(&GL_COMPILE_AND_EXECUTE);
    eval 'sub GL_LIST_BASE () {0xb32;}' unless defined(&GL_LIST_BASE);
    eval 'sub GL_LIST_INDEX () {0xb33;}' unless defined(&GL_LIST_INDEX);
    eval 'sub GL_LIST_MODE () {0xb30;}' unless defined(&GL_LIST_MODE);
    eval 'sub GL_NEVER () {0x200;}' unless defined(&GL_NEVER);
    eval 'sub GL_LESS () {0x201;}' unless defined(&GL_LESS);
    eval 'sub GL_EQUAL () {0x202;}' unless defined(&GL_EQUAL);
    eval 'sub GL_LEQUAL () {0x203;}' unless defined(&GL_LEQUAL);
    eval 'sub GL_GREATER () {0x204;}' unless defined(&GL_GREATER);
    eval 'sub GL_NOTEQUAL () {0x205;}' unless defined(&GL_NOTEQUAL);
    eval 'sub GL_GEQUAL () {0x206;}' unless defined(&GL_GEQUAL);
    eval 'sub GL_ALWAYS () {0x207;}' unless defined(&GL_ALWAYS);
    eval 'sub GL_DEPTH_TEST () {0xb71;}' unless defined(&GL_DEPTH_TEST);
    eval 'sub GL_DEPTH_BITS () {0xd56;}' unless defined(&GL_DEPTH_BITS);
    eval 'sub GL_DEPTH_CLEAR_VALUE () {0xb73;}' unless defined(&GL_DEPTH_CLEAR_VALUE);
    eval 'sub GL_DEPTH_FUNC () {0xb74;}' unless defined(&GL_DEPTH_FUNC);
    eval 'sub GL_DEPTH_RANGE () {0xb70;}' unless defined(&GL_DEPTH_RANGE);
    eval 'sub GL_DEPTH_WRITEMASK () {0xb72;}' unless defined(&GL_DEPTH_WRITEMASK);
    eval 'sub GL_DEPTH_COMPONENT () {0x1902;}' unless defined(&GL_DEPTH_COMPONENT);
    eval 'sub GL_LIGHTING () {0xb50;}' unless defined(&GL_LIGHTING);
    eval 'sub GL_LIGHT0 () {0x4000;}' unless defined(&GL_LIGHT0);
    eval 'sub GL_LIGHT1 () {0x4001;}' unless defined(&GL_LIGHT1);
    eval 'sub GL_LIGHT2 () {0x4002;}' unless defined(&GL_LIGHT2);
    eval 'sub GL_LIGHT3 () {0x4003;}' unless defined(&GL_LIGHT3);
    eval 'sub GL_LIGHT4 () {0x4004;}' unless defined(&GL_LIGHT4);
    eval 'sub GL_LIGHT5 () {0x4005;}' unless defined(&GL_LIGHT5);
    eval 'sub GL_LIGHT6 () {0x4006;}' unless defined(&GL_LIGHT6);
    eval 'sub GL_LIGHT7 () {0x4007;}' unless defined(&GL_LIGHT7);
    eval 'sub GL_SPOT_EXPONENT () {0x1205;}' unless defined(&GL_SPOT_EXPONENT);
    eval 'sub GL_SPOT_CUTOFF () {0x1206;}' unless defined(&GL_SPOT_CUTOFF);
    eval 'sub GL_CONSTANT_ATTENUATION () {0x1207;}' unless defined(&GL_CONSTANT_ATTENUATION);
    eval 'sub GL_LINEAR_ATTENUATION () {0x1208;}' unless defined(&GL_LINEAR_ATTENUATION);
    eval 'sub GL_QUADRATIC_ATTENUATION () {0x1209;}' unless defined(&GL_QUADRATIC_ATTENUATION);
    eval 'sub GL_AMBIENT () {0x1200;}' unless defined(&GL_AMBIENT);
    eval 'sub GL_DIFFUSE () {0x1201;}' unless defined(&GL_DIFFUSE);
    eval 'sub GL_SPECULAR () {0x1202;}' unless defined(&GL_SPECULAR);
    eval 'sub GL_SHININESS () {0x1601;}' unless defined(&GL_SHININESS);
    eval 'sub GL_EMISSION () {0x1600;}' unless defined(&GL_EMISSION);
    eval 'sub GL_POSITION () {0x1203;}' unless defined(&GL_POSITION);
    eval 'sub GL_SPOT_DIRECTION () {0x1204;}' unless defined(&GL_SPOT_DIRECTION);
    eval 'sub GL_AMBIENT_AND_DIFFUSE () {0x1602;}' unless defined(&GL_AMBIENT_AND_DIFFUSE);
    eval 'sub GL_COLOR_INDEXES () {0x1603;}' unless defined(&GL_COLOR_INDEXES);
    eval 'sub GL_LIGHT_MODEL_TWO_SIDE () {0xb52;}' unless defined(&GL_LIGHT_MODEL_TWO_SIDE);
    eval 'sub GL_LIGHT_MODEL_LOCAL_VIEWER () {0xb51;}' unless defined(&GL_LIGHT_MODEL_LOCAL_VIEWER);
    eval 'sub GL_LIGHT_MODEL_AMBIENT () {0xb53;}' unless defined(&GL_LIGHT_MODEL_AMBIENT);
    eval 'sub GL_FRONT_AND_BACK () {0x408;}' unless defined(&GL_FRONT_AND_BACK);
    eval 'sub GL_SHADE_MODEL () {0xb54;}' unless defined(&GL_SHADE_MODEL);
    eval 'sub GL_FLAT () {0x1d00;}' unless defined(&GL_FLAT);
    eval 'sub GL_SMOOTH () {0x1d01;}' unless defined(&GL_SMOOTH);
    eval 'sub GL_COLOR_MATERIAL () {0xb57;}' unless defined(&GL_COLOR_MATERIAL);
    eval 'sub GL_COLOR_MATERIAL_FACE () {0xb55;}' unless defined(&GL_COLOR_MATERIAL_FACE);
    eval 'sub GL_COLOR_MATERIAL_PARAMETER () {0xb56;}' unless defined(&GL_COLOR_MATERIAL_PARAMETER);
    eval 'sub GL_NORMALIZE () {0xba1;}' unless defined(&GL_NORMALIZE);
    eval 'sub GL_CLIP_PLANE0 () {0x3000;}' unless defined(&GL_CLIP_PLANE0);
    eval 'sub GL_CLIP_PLANE1 () {0x3001;}' unless defined(&GL_CLIP_PLANE1);
    eval 'sub GL_CLIP_PLANE2 () {0x3002;}' unless defined(&GL_CLIP_PLANE2);
    eval 'sub GL_CLIP_PLANE3 () {0x3003;}' unless defined(&GL_CLIP_PLANE3);
    eval 'sub GL_CLIP_PLANE4 () {0x3004;}' unless defined(&GL_CLIP_PLANE4);
    eval 'sub GL_CLIP_PLANE5 () {0x3005;}' unless defined(&GL_CLIP_PLANE5);
    eval 'sub GL_ACCUM_RED_BITS () {0xd58;}' unless defined(&GL_ACCUM_RED_BITS);
    eval 'sub GL_ACCUM_GREEN_BITS () {0xd59;}' unless defined(&GL_ACCUM_GREEN_BITS);
    eval 'sub GL_ACCUM_BLUE_BITS () {0xd5a;}' unless defined(&GL_ACCUM_BLUE_BITS);
    eval 'sub GL_ACCUM_ALPHA_BITS () {0xd5b;}' unless defined(&GL_ACCUM_ALPHA_BITS);
    eval 'sub GL_ACCUM_CLEAR_VALUE () {0xb80;}' unless defined(&GL_ACCUM_CLEAR_VALUE);
    eval 'sub GL_ACCUM () {0x100;}' unless defined(&GL_ACCUM);
    eval 'sub GL_ADD () {0x104;}' unless defined(&GL_ADD);
    eval 'sub GL_LOAD () {0x101;}' unless defined(&GL_LOAD);
    eval 'sub GL_MULT () {0x103;}' unless defined(&GL_MULT);
    eval 'sub GL_RETURN () {0x102;}' unless defined(&GL_RETURN);
    eval 'sub GL_ALPHA_TEST () {0xbc0;}' unless defined(&GL_ALPHA_TEST);
    eval 'sub GL_ALPHA_TEST_REF () {0xbc2;}' unless defined(&GL_ALPHA_TEST_REF);
    eval 'sub GL_ALPHA_TEST_FUNC () {0xbc1;}' unless defined(&GL_ALPHA_TEST_FUNC);
    eval 'sub GL_BLEND () {0xbe2;}' unless defined(&GL_BLEND);
    eval 'sub GL_BLEND_SRC () {0xbe1;}' unless defined(&GL_BLEND_SRC);
    eval 'sub GL_BLEND_DST () {0xbe0;}' unless defined(&GL_BLEND_DST);
    eval 'sub GL_ZERO () {0x;}' unless defined(&GL_ZERO);
    eval 'sub GL_ONE () {0x1;}' unless defined(&GL_ONE);
    eval 'sub GL_SRC_COLOR () {0x300;}' unless defined(&GL_SRC_COLOR);
    eval 'sub GL_ONE_MINUS_SRC_COLOR () {0x301;}' unless defined(&GL_ONE_MINUS_SRC_COLOR);
    eval 'sub GL_SRC_ALPHA () {0x302;}' unless defined(&GL_SRC_ALPHA);
    eval 'sub GL_ONE_MINUS_SRC_ALPHA () {0x303;}' unless defined(&GL_ONE_MINUS_SRC_ALPHA);
    eval 'sub GL_DST_ALPHA () {0x304;}' unless defined(&GL_DST_ALPHA);
    eval 'sub GL_ONE_MINUS_DST_ALPHA () {0x305;}' unless defined(&GL_ONE_MINUS_DST_ALPHA);
    eval 'sub GL_DST_COLOR () {0x306;}' unless defined(&GL_DST_COLOR);
    eval 'sub GL_ONE_MINUS_DST_COLOR () {0x307;}' unless defined(&GL_ONE_MINUS_DST_COLOR);
    eval 'sub GL_SRC_ALPHA_SATURATE () {0x308;}' unless defined(&GL_SRC_ALPHA_SATURATE);
    eval 'sub GL_CONSTANT_COLOR () {0x8001;}' unless defined(&GL_CONSTANT_COLOR);
    eval 'sub GL_ONE_MINUS_CONSTANT_COLOR () {0x8002;}' unless defined(&GL_ONE_MINUS_CONSTANT_COLOR);
    eval 'sub GL_CONSTANT_ALPHA () {0x8003;}' unless defined(&GL_CONSTANT_ALPHA);
    eval 'sub GL_ONE_MINUS_CONSTANT_ALPHA () {0x8004;}' unless defined(&GL_ONE_MINUS_CONSTANT_ALPHA);
    eval 'sub GL_FEEDBACK () {0x1c01;}' unless defined(&GL_FEEDBACK);
    eval 'sub GL_RENDER () {0x1c00;}' unless defined(&GL_RENDER);
    eval 'sub GL_SELECT () {0x1c02;}' unless defined(&GL_SELECT);
    eval 'sub GL_2D () {0x600;}' unless defined(&GL_2D);
    eval 'sub GL_3D () {0x601;}' unless defined(&GL_3D);
    eval 'sub GL_3D_COLOR () {0x602;}' unless defined(&GL_3D_COLOR);
    eval 'sub GL_3D_COLOR_TEXTURE () {0x603;}' unless defined(&GL_3D_COLOR_TEXTURE);
    eval 'sub GL_4D_COLOR_TEXTURE () {0x604;}' unless defined(&GL_4D_COLOR_TEXTURE);
    eval 'sub GL_POINT_TOKEN () {0x701;}' unless defined(&GL_POINT_TOKEN);
    eval 'sub GL_LINE_TOKEN () {0x702;}' unless defined(&GL_LINE_TOKEN);
    eval 'sub GL_LINE_RESET_TOKEN () {0x707;}' unless defined(&GL_LINE_RESET_TOKEN);
    eval 'sub GL_POLYGON_TOKEN () {0x703;}' unless defined(&GL_POLYGON_TOKEN);
    eval 'sub GL_BITMAP_TOKEN () {0x704;}' unless defined(&GL_BITMAP_TOKEN);
    eval 'sub GL_DRAW_PIXEL_TOKEN () {0x705;}' unless defined(&GL_DRAW_PIXEL_TOKEN);
    eval 'sub GL_COPY_PIXEL_TOKEN () {0x706;}' unless defined(&GL_COPY_PIXEL_TOKEN);
    eval 'sub GL_PASS_THROUGH_TOKEN () {0x700;}' unless defined(&GL_PASS_THROUGH_TOKEN);
    eval 'sub GL_FEEDBACK_BUFFER_POINTER () {0xdf0;}' unless defined(&GL_FEEDBACK_BUFFER_POINTER);
    eval 'sub GL_FEEDBACK_BUFFER_SIZE () {0xdf1;}' unless defined(&GL_FEEDBACK_BUFFER_SIZE);
    eval 'sub GL_FEEDBACK_BUFFER_TYPE () {0xdf2;}' unless defined(&GL_FEEDBACK_BUFFER_TYPE);
    eval 'sub GL_SELECTION_BUFFER_POINTER () {0xdf3;}' unless defined(&GL_SELECTION_BUFFER_POINTER);
    eval 'sub GL_SELECTION_BUFFER_SIZE () {0xdf4;}' unless defined(&GL_SELECTION_BUFFER_SIZE);
    eval 'sub GL_FOG () {0xb60;}' unless defined(&GL_FOG);
    eval 'sub GL_FOG_MODE () {0xb65;}' unless defined(&GL_FOG_MODE);
    eval 'sub GL_FOG_DENSITY () {0xb62;}' unless defined(&GL_FOG_DENSITY);
    eval 'sub GL_FOG_COLOR () {0xb66;}' unless defined(&GL_FOG_COLOR);
    eval 'sub GL_FOG_INDEX () {0xb61;}' unless defined(&GL_FOG_INDEX);
    eval 'sub GL_FOG_START () {0xb63;}' unless defined(&GL_FOG_START);
    eval 'sub GL_FOG_END () {0xb64;}' unless defined(&GL_FOG_END);
    eval 'sub GL_LINEAR () {0x2601;}' unless defined(&GL_LINEAR);
    eval 'sub GL_EXP () {0x800;}' unless defined(&GL_EXP);
    eval 'sub GL_EXP2 () {0x801;}' unless defined(&GL_EXP2);
    eval 'sub GL_LOGIC_OP () {0xbf1;}' unless defined(&GL_LOGIC_OP);
    eval 'sub GL_INDEX_LOGIC_OP () {0xbf1;}' unless defined(&GL_INDEX_LOGIC_OP);
    eval 'sub GL_COLOR_LOGIC_OP () {0xbf2;}' unless defined(&GL_COLOR_LOGIC_OP);
    eval 'sub GL_LOGIC_OP_MODE () {0xbf0;}' unless defined(&GL_LOGIC_OP_MODE);
    eval 'sub GL_CLEAR () {0x1500;}' unless defined(&GL_CLEAR);
    eval 'sub GL_SET () {0x150f;}' unless defined(&GL_SET);
    eval 'sub GL_COPY () {0x1503;}' unless defined(&GL_COPY);
    eval 'sub GL_COPY_INVERTED () {0x150c;}' unless defined(&GL_COPY_INVERTED);
    eval 'sub GL_NOOP () {0x1505;}' unless defined(&GL_NOOP);
    eval 'sub GL_INVERT () {0x150a;}' unless defined(&GL_INVERT);
    eval 'sub GL_AND () {0x1501;}' unless defined(&GL_AND);
    eval 'sub GL_NAND () {0x150e;}' unless defined(&GL_NAND);
    eval 'sub GL_OR () {0x1507;}' unless defined(&GL_OR);
    eval 'sub GL_NOR () {0x1508;}' unless defined(&GL_NOR);
    eval 'sub GL_XOR () {0x1506;}' unless defined(&GL_XOR);
    eval 'sub GL_EQUIV () {0x1509;}' unless defined(&GL_EQUIV);
    eval 'sub GL_AND_REVERSE () {0x1502;}' unless defined(&GL_AND_REVERSE);
    eval 'sub GL_AND_INVERTED () {0x1504;}' unless defined(&GL_AND_INVERTED);
    eval 'sub GL_OR_REVERSE () {0x150b;}' unless defined(&GL_OR_REVERSE);
    eval 'sub GL_OR_INVERTED () {0x150d;}' unless defined(&GL_OR_INVERTED);
    eval 'sub GL_STENCIL_TEST () {0xb90;}' unless defined(&GL_STENCIL_TEST);
    eval 'sub GL_STENCIL_WRITEMASK () {0xb98;}' unless defined(&GL_STENCIL_WRITEMASK);
    eval 'sub GL_STENCIL_BITS () {0xd57;}' unless defined(&GL_STENCIL_BITS);
    eval 'sub GL_STENCIL_FUNC () {0xb92;}' unless defined(&GL_STENCIL_FUNC);
    eval 'sub GL_STENCIL_VALUE_MASK () {0xb93;}' unless defined(&GL_STENCIL_VALUE_MASK);
    eval 'sub GL_STENCIL_REF () {0xb97;}' unless defined(&GL_STENCIL_REF);
    eval 'sub GL_STENCIL_FAIL () {0xb94;}' unless defined(&GL_STENCIL_FAIL);
    eval 'sub GL_STENCIL_PASS_DEPTH_PASS () {0xb96;}' unless defined(&GL_STENCIL_PASS_DEPTH_PASS);
    eval 'sub GL_STENCIL_PASS_DEPTH_FAIL () {0xb95;}' unless defined(&GL_STENCIL_PASS_DEPTH_FAIL);
    eval 'sub GL_STENCIL_CLEAR_VALUE () {0xb91;}' unless defined(&GL_STENCIL_CLEAR_VALUE);
    eval 'sub GL_STENCIL_INDEX () {0x1901;}' unless defined(&GL_STENCIL_INDEX);
    eval 'sub GL_KEEP () {0x1e00;}' unless defined(&GL_KEEP);
    eval 'sub GL_REPLACE () {0x1e01;}' unless defined(&GL_REPLACE);
    eval 'sub GL_INCR () {0x1e02;}' unless defined(&GL_INCR);
    eval 'sub GL_DECR () {0x1e03;}' unless defined(&GL_DECR);
    eval 'sub GL_NONE () {0x;}' unless defined(&GL_NONE);
    eval 'sub GL_LEFT () {0x406;}' unless defined(&GL_LEFT);
    eval 'sub GL_RIGHT () {0x407;}' unless defined(&GL_RIGHT);
    eval 'sub GL_FRONT_LEFT () {0x400;}' unless defined(&GL_FRONT_LEFT);
    eval 'sub GL_FRONT_RIGHT () {0x401;}' unless defined(&GL_FRONT_RIGHT);
    eval 'sub GL_BACK_LEFT () {0x402;}' unless defined(&GL_BACK_LEFT);
    eval 'sub GL_BACK_RIGHT () {0x403;}' unless defined(&GL_BACK_RIGHT);
    eval 'sub GL_AUX0 () {0x409;}' unless defined(&GL_AUX0);
    eval 'sub GL_AUX1 () {0x40a;}' unless defined(&GL_AUX1);
    eval 'sub GL_AUX2 () {0x40b;}' unless defined(&GL_AUX2);
    eval 'sub GL_AUX3 () {0x40c;}' unless defined(&GL_AUX3);
    eval 'sub GL_COLOR_INDEX () {0x1900;}' unless defined(&GL_COLOR_INDEX);
    eval 'sub GL_RED () {0x1903;}' unless defined(&GL_RED);
    eval 'sub GL_GREEN () {0x1904;}' unless defined(&GL_GREEN);
    eval 'sub GL_BLUE () {0x1905;}' unless defined(&GL_BLUE);
    eval 'sub GL_ALPHA () {0x1906;}' unless defined(&GL_ALPHA);
    eval 'sub GL_LUMINANCE () {0x1909;}' unless defined(&GL_LUMINANCE);
    eval 'sub GL_LUMINANCE_ALPHA () {0x190a;}' unless defined(&GL_LUMINANCE_ALPHA);
    eval 'sub GL_ALPHA_BITS () {0xd55;}' unless defined(&GL_ALPHA_BITS);
    eval 'sub GL_RED_BITS () {0xd52;}' unless defined(&GL_RED_BITS);
    eval 'sub GL_GREEN_BITS () {0xd53;}' unless defined(&GL_GREEN_BITS);
    eval 'sub GL_BLUE_BITS () {0xd54;}' unless defined(&GL_BLUE_BITS);
    eval 'sub GL_INDEX_BITS () {0xd51;}' unless defined(&GL_INDEX_BITS);
    eval 'sub GL_SUBPIXEL_BITS () {0xd50;}' unless defined(&GL_SUBPIXEL_BITS);
    eval 'sub GL_AUX_BUFFERS () {0xc00;}' unless defined(&GL_AUX_BUFFERS);
    eval 'sub GL_READ_BUFFER () {0xc02;}' unless defined(&GL_READ_BUFFER);
    eval 'sub GL_DRAW_BUFFER () {0xc01;}' unless defined(&GL_DRAW_BUFFER);
    eval 'sub GL_DOUBLEBUFFER () {0xc32;}' unless defined(&GL_DOUBLEBUFFER);
    eval 'sub GL_STEREO () {0xc33;}' unless defined(&GL_STEREO);
    eval 'sub GL_BITMAP () {0x1a00;}' unless defined(&GL_BITMAP);
    eval 'sub GL_COLOR () {0x1800;}' unless defined(&GL_COLOR);
    eval 'sub GL_DEPTH () {0x1801;}' unless defined(&GL_DEPTH);
    eval 'sub GL_STENCIL () {0x1802;}' unless defined(&GL_STENCIL);
    eval 'sub GL_DITHER () {0xbd0;}' unless defined(&GL_DITHER);
    eval 'sub GL_RGB () {0x1907;}' unless defined(&GL_RGB);
    eval 'sub GL_RGBA () {0x1908;}' unless defined(&GL_RGBA);
    eval 'sub GL_MAX_LIST_NESTING () {0xb31;}' unless defined(&GL_MAX_LIST_NESTING);
    eval 'sub GL_MAX_ATTRIB_STACK_DEPTH () {0xd35;}' unless defined(&GL_MAX_ATTRIB_STACK_DEPTH);
    eval 'sub GL_MAX_MODELVIEW_STACK_DEPTH () {0xd36;}' unless defined(&GL_MAX_MODELVIEW_STACK_DEPTH);
    eval 'sub GL_MAX_NAME_STACK_DEPTH () {0xd37;}' unless defined(&GL_MAX_NAME_STACK_DEPTH);
    eval 'sub GL_MAX_PROJECTION_STACK_DEPTH () {0xd38;}' unless defined(&GL_MAX_PROJECTION_STACK_DEPTH);
    eval 'sub GL_MAX_TEXTURE_STACK_DEPTH () {0xd39;}' unless defined(&GL_MAX_TEXTURE_STACK_DEPTH);
    eval 'sub GL_MAX_EVAL_ORDER () {0xd30;}' unless defined(&GL_MAX_EVAL_ORDER);
    eval 'sub GL_MAX_LIGHTS () {0xd31;}' unless defined(&GL_MAX_LIGHTS);
    eval 'sub GL_MAX_CLIP_PLANES () {0xd32;}' unless defined(&GL_MAX_CLIP_PLANES);
    eval 'sub GL_MAX_TEXTURE_SIZE () {0xd33;}' unless defined(&GL_MAX_TEXTURE_SIZE);
    eval 'sub GL_MAX_PIXEL_MAP_TABLE () {0xd34;}' unless defined(&GL_MAX_PIXEL_MAP_TABLE);
    eval 'sub GL_MAX_VIEWPORT_DIMS () {0xd3a;}' unless defined(&GL_MAX_VIEWPORT_DIMS);
    eval 'sub GL_MAX_CLIENT_ATTRIB_STACK_DEPTH () {0xd3b;}' unless defined(&GL_MAX_CLIENT_ATTRIB_STACK_DEPTH);
    eval 'sub GL_ATTRIB_STACK_DEPTH () {0xbb0;}' unless defined(&GL_ATTRIB_STACK_DEPTH);
    eval 'sub GL_CLIENT_ATTRIB_STACK_DEPTH () {0xbb1;}' unless defined(&GL_CLIENT_ATTRIB_STACK_DEPTH);
    eval 'sub GL_COLOR_CLEAR_VALUE () {0xc22;}' unless defined(&GL_COLOR_CLEAR_VALUE);
    eval 'sub GL_COLOR_WRITEMASK () {0xc23;}' unless defined(&GL_COLOR_WRITEMASK);
    eval 'sub GL_CURRENT_INDEX () {0xb01;}' unless defined(&GL_CURRENT_INDEX);
    eval 'sub GL_CURRENT_COLOR () {0xb00;}' unless defined(&GL_CURRENT_COLOR);
    eval 'sub GL_CURRENT_NORMAL () {0xb02;}' unless defined(&GL_CURRENT_NORMAL);
    eval 'sub GL_CURRENT_RASTER_COLOR () {0xb04;}' unless defined(&GL_CURRENT_RASTER_COLOR);
    eval 'sub GL_CURRENT_RASTER_DISTANCE () {0xb09;}' unless defined(&GL_CURRENT_RASTER_DISTANCE);
    eval 'sub GL_CURRENT_RASTER_INDEX () {0xb05;}' unless defined(&GL_CURRENT_RASTER_INDEX);
    eval 'sub GL_CURRENT_RASTER_POSITION () {0xb07;}' unless defined(&GL_CURRENT_RASTER_POSITION);
    eval 'sub GL_CURRENT_RASTER_TEXTURE_COORDS () {0xb06;}' unless defined(&GL_CURRENT_RASTER_TEXTURE_COORDS);
    eval 'sub GL_CURRENT_RASTER_POSITION_VALID () {0xb08;}' unless defined(&GL_CURRENT_RASTER_POSITION_VALID);
    eval 'sub GL_CURRENT_TEXTURE_COORDS () {0xb03;}' unless defined(&GL_CURRENT_TEXTURE_COORDS);
    eval 'sub GL_INDEX_CLEAR_VALUE () {0xc20;}' unless defined(&GL_INDEX_CLEAR_VALUE);
    eval 'sub GL_INDEX_MODE () {0xc30;}' unless defined(&GL_INDEX_MODE);
    eval 'sub GL_INDEX_WRITEMASK () {0xc21;}' unless defined(&GL_INDEX_WRITEMASK);
    eval 'sub GL_MODELVIEW_MATRIX () {0xba6;}' unless defined(&GL_MODELVIEW_MATRIX);
    eval 'sub GL_MODELVIEW_STACK_DEPTH () {0xba3;}' unless defined(&GL_MODELVIEW_STACK_DEPTH);
    eval 'sub GL_NAME_STACK_DEPTH () {0xd70;}' unless defined(&GL_NAME_STACK_DEPTH);
    eval 'sub GL_PROJECTION_MATRIX () {0xba7;}' unless defined(&GL_PROJECTION_MATRIX);
    eval 'sub GL_PROJECTION_STACK_DEPTH () {0xba4;}' unless defined(&GL_PROJECTION_STACK_DEPTH);
    eval 'sub GL_RENDER_MODE () {0xc40;}' unless defined(&GL_RENDER_MODE);
    eval 'sub GL_RGBA_MODE () {0xc31;}' unless defined(&GL_RGBA_MODE);
    eval 'sub GL_TEXTURE_MATRIX () {0xba8;}' unless defined(&GL_TEXTURE_MATRIX);
    eval 'sub GL_TEXTURE_STACK_DEPTH () {0xba5;}' unless defined(&GL_TEXTURE_STACK_DEPTH);
    eval 'sub GL_VIEWPORT () {0xba2;}' unless defined(&GL_VIEWPORT);
    eval 'sub GL_AUTO_NORMAL () {0xd80;}' unless defined(&GL_AUTO_NORMAL);
    eval 'sub GL_MAP1_COLOR_4 () {0xd90;}' unless defined(&GL_MAP1_COLOR_4);
    eval 'sub GL_MAP1_GRID_DOMAIN () {0xdd0;}' unless defined(&GL_MAP1_GRID_DOMAIN);
    eval 'sub GL_MAP1_GRID_SEGMENTS () {0xdd1;}' unless defined(&GL_MAP1_GRID_SEGMENTS);
    eval 'sub GL_MAP1_INDEX () {0xd91;}' unless defined(&GL_MAP1_INDEX);
    eval 'sub GL_MAP1_NORMAL () {0xd92;}' unless defined(&GL_MAP1_NORMAL);
    eval 'sub GL_MAP1_TEXTURE_COORD_1 () {0xd93;}' unless defined(&GL_MAP1_TEXTURE_COORD_1);
    eval 'sub GL_MAP1_TEXTURE_COORD_2 () {0xd94;}' unless defined(&GL_MAP1_TEXTURE_COORD_2);
    eval 'sub GL_MAP1_TEXTURE_COORD_3 () {0xd95;}' unless defined(&GL_MAP1_TEXTURE_COORD_3);
    eval 'sub GL_MAP1_TEXTURE_COORD_4 () {0xd96;}' unless defined(&GL_MAP1_TEXTURE_COORD_4);
    eval 'sub GL_MAP1_VERTEX_3 () {0xd97;}' unless defined(&GL_MAP1_VERTEX_3);
    eval 'sub GL_MAP1_VERTEX_4 () {0xd98;}' unless defined(&GL_MAP1_VERTEX_4);
    eval 'sub GL_MAP2_COLOR_4 () {0xdb0;}' unless defined(&GL_MAP2_COLOR_4);
    eval 'sub GL_MAP2_GRID_DOMAIN () {0xdd2;}' unless defined(&GL_MAP2_GRID_DOMAIN);
    eval 'sub GL_MAP2_GRID_SEGMENTS () {0xdd3;}' unless defined(&GL_MAP2_GRID_SEGMENTS);
    eval 'sub GL_MAP2_INDEX () {0xdb1;}' unless defined(&GL_MAP2_INDEX);
    eval 'sub GL_MAP2_NORMAL () {0xdb2;}' unless defined(&GL_MAP2_NORMAL);
    eval 'sub GL_MAP2_TEXTURE_COORD_1 () {0xdb3;}' unless defined(&GL_MAP2_TEXTURE_COORD_1);
    eval 'sub GL_MAP2_TEXTURE_COORD_2 () {0xdb4;}' unless defined(&GL_MAP2_TEXTURE_COORD_2);
    eval 'sub GL_MAP2_TEXTURE_COORD_3 () {0xdb5;}' unless defined(&GL_MAP2_TEXTURE_COORD_3);
    eval 'sub GL_MAP2_TEXTURE_COORD_4 () {0xdb6;}' unless defined(&GL_MAP2_TEXTURE_COORD_4);
    eval 'sub GL_MAP2_VERTEX_3 () {0xdb7;}' unless defined(&GL_MAP2_VERTEX_3);
    eval 'sub GL_MAP2_VERTEX_4 () {0xdb8;}' unless defined(&GL_MAP2_VERTEX_4);
    eval 'sub GL_COEFF () {0xa00;}' unless defined(&GL_COEFF);
    eval 'sub GL_DOMAIN () {0xa02;}' unless defined(&GL_DOMAIN);
    eval 'sub GL_ORDER () {0xa01;}' unless defined(&GL_ORDER);
    eval 'sub GL_FOG_HINT () {0xc54;}' unless defined(&GL_FOG_HINT);
    eval 'sub GL_LINE_SMOOTH_HINT () {0xc52;}' unless defined(&GL_LINE_SMOOTH_HINT);
    eval 'sub GL_PERSPECTIVE_CORRECTION_HINT () {0xc50;}' unless defined(&GL_PERSPECTIVE_CORRECTION_HINT);
    eval 'sub GL_POINT_SMOOTH_HINT () {0xc51;}' unless defined(&GL_POINT_SMOOTH_HINT);
    eval 'sub GL_POLYGON_SMOOTH_HINT () {0xc53;}' unless defined(&GL_POLYGON_SMOOTH_HINT);
    eval 'sub GL_DONT_CARE () {0x1100;}' unless defined(&GL_DONT_CARE);
    eval 'sub GL_FASTEST () {0x1101;}' unless defined(&GL_FASTEST);
    eval 'sub GL_NICEST () {0x1102;}' unless defined(&GL_NICEST);
    eval 'sub GL_SCISSOR_TEST () {0xc11;}' unless defined(&GL_SCISSOR_TEST);
    eval 'sub GL_SCISSOR_BOX () {0xc10;}' unless defined(&GL_SCISSOR_BOX);
    eval 'sub GL_MAP_COLOR () {0xd10;}' unless defined(&GL_MAP_COLOR);
    eval 'sub GL_MAP_STENCIL () {0xd11;}' unless defined(&GL_MAP_STENCIL);
    eval 'sub GL_INDEX_SHIFT () {0xd12;}' unless defined(&GL_INDEX_SHIFT);
    eval 'sub GL_INDEX_OFFSET () {0xd13;}' unless defined(&GL_INDEX_OFFSET);
    eval 'sub GL_RED_SCALE () {0xd14;}' unless defined(&GL_RED_SCALE);
    eval 'sub GL_RED_BIAS () {0xd15;}' unless defined(&GL_RED_BIAS);
    eval 'sub GL_GREEN_SCALE () {0xd18;}' unless defined(&GL_GREEN_SCALE);
    eval 'sub GL_GREEN_BIAS () {0xd19;}' unless defined(&GL_GREEN_BIAS);
    eval 'sub GL_BLUE_SCALE () {0xd1a;}' unless defined(&GL_BLUE_SCALE);
    eval 'sub GL_BLUE_BIAS () {0xd1b;}' unless defined(&GL_BLUE_BIAS);
    eval 'sub GL_ALPHA_SCALE () {0xd1c;}' unless defined(&GL_ALPHA_SCALE);
    eval 'sub GL_ALPHA_BIAS () {0xd1d;}' unless defined(&GL_ALPHA_BIAS);
    eval 'sub GL_DEPTH_SCALE () {0xd1e;}' unless defined(&GL_DEPTH_SCALE);
    eval 'sub GL_DEPTH_BIAS () {0xd1f;}' unless defined(&GL_DEPTH_BIAS);
    eval 'sub GL_PIXEL_MAP_S_TO_S_SIZE () {0xcb1;}' unless defined(&GL_PIXEL_MAP_S_TO_S_SIZE);
    eval 'sub GL_PIXEL_MAP_I_TO_I_SIZE () {0xcb0;}' unless defined(&GL_PIXEL_MAP_I_TO_I_SIZE);
    eval 'sub GL_PIXEL_MAP_I_TO_R_SIZE () {0xcb2;}' unless defined(&GL_PIXEL_MAP_I_TO_R_SIZE);
    eval 'sub GL_PIXEL_MAP_I_TO_G_SIZE () {0xcb3;}' unless defined(&GL_PIXEL_MAP_I_TO_G_SIZE);
    eval 'sub GL_PIXEL_MAP_I_TO_B_SIZE () {0xcb4;}' unless defined(&GL_PIXEL_MAP_I_TO_B_SIZE);
    eval 'sub GL_PIXEL_MAP_I_TO_A_SIZE () {0xcb5;}' unless defined(&GL_PIXEL_MAP_I_TO_A_SIZE);
    eval 'sub GL_PIXEL_MAP_R_TO_R_SIZE () {0xcb6;}' unless defined(&GL_PIXEL_MAP_R_TO_R_SIZE);
    eval 'sub GL_PIXEL_MAP_G_TO_G_SIZE () {0xcb7;}' unless defined(&GL_PIXEL_MAP_G_TO_G_SIZE);
    eval 'sub GL_PIXEL_MAP_B_TO_B_SIZE () {0xcb8;}' unless defined(&GL_PIXEL_MAP_B_TO_B_SIZE);
    eval 'sub GL_PIXEL_MAP_A_TO_A_SIZE () {0xcb9;}' unless defined(&GL_PIXEL_MAP_A_TO_A_SIZE);
    eval 'sub GL_PIXEL_MAP_S_TO_S () {0xc71;}' unless defined(&GL_PIXEL_MAP_S_TO_S);
    eval 'sub GL_PIXEL_MAP_I_TO_I () {0xc70;}' unless defined(&GL_PIXEL_MAP_I_TO_I);
    eval 'sub GL_PIXEL_MAP_I_TO_R () {0xc72;}' unless defined(&GL_PIXEL_MAP_I_TO_R);
    eval 'sub GL_PIXEL_MAP_I_TO_G () {0xc73;}' unless defined(&GL_PIXEL_MAP_I_TO_G);
    eval 'sub GL_PIXEL_MAP_I_TO_B () {0xc74;}' unless defined(&GL_PIXEL_MAP_I_TO_B);
    eval 'sub GL_PIXEL_MAP_I_TO_A () {0xc75;}' unless defined(&GL_PIXEL_MAP_I_TO_A);
    eval 'sub GL_PIXEL_MAP_R_TO_R () {0xc76;}' unless defined(&GL_PIXEL_MAP_R_TO_R);
    eval 'sub GL_PIXEL_MAP_G_TO_G () {0xc77;}' unless defined(&GL_PIXEL_MAP_G_TO_G);
    eval 'sub GL_PIXEL_MAP_B_TO_B () {0xc78;}' unless defined(&GL_PIXEL_MAP_B_TO_B);
    eval 'sub GL_PIXEL_MAP_A_TO_A () {0xc79;}' unless defined(&GL_PIXEL_MAP_A_TO_A);
    eval 'sub GL_PACK_ALIGNMENT () {0xd05;}' unless defined(&GL_PACK_ALIGNMENT);
    eval 'sub GL_PACK_LSB_FIRST () {0xd01;}' unless defined(&GL_PACK_LSB_FIRST);
    eval 'sub GL_PACK_ROW_LENGTH () {0xd02;}' unless defined(&GL_PACK_ROW_LENGTH);
    eval 'sub GL_PACK_SKIP_PIXELS () {0xd04;}' unless defined(&GL_PACK_SKIP_PIXELS);
    eval 'sub GL_PACK_SKIP_ROWS () {0xd03;}' unless defined(&GL_PACK_SKIP_ROWS);
    eval 'sub GL_PACK_SWAP_BYTES () {0xd00;}' unless defined(&GL_PACK_SWAP_BYTES);
    eval 'sub GL_UNPACK_ALIGNMENT () {0xcf5;}' unless defined(&GL_UNPACK_ALIGNMENT);
    eval 'sub GL_UNPACK_LSB_FIRST () {0xcf1;}' unless defined(&GL_UNPACK_LSB_FIRST);
    eval 'sub GL_UNPACK_ROW_LENGTH () {0xcf2;}' unless defined(&GL_UNPACK_ROW_LENGTH);
    eval 'sub GL_UNPACK_SKIP_PIXELS () {0xcf4;}' unless defined(&GL_UNPACK_SKIP_PIXELS);
    eval 'sub GL_UNPACK_SKIP_ROWS () {0xcf3;}' unless defined(&GL_UNPACK_SKIP_ROWS);
    eval 'sub GL_UNPACK_SWAP_BYTES () {0xcf0;}' unless defined(&GL_UNPACK_SWAP_BYTES);
    eval 'sub GL_ZOOM_X () {0xd16;}' unless defined(&GL_ZOOM_X);
    eval 'sub GL_ZOOM_Y () {0xd17;}' unless defined(&GL_ZOOM_Y);
    eval 'sub GL_TEXTURE_ENV () {0x2300;}' unless defined(&GL_TEXTURE_ENV);
    eval 'sub GL_TEXTURE_ENV_MODE () {0x2200;}' unless defined(&GL_TEXTURE_ENV_MODE);
    eval 'sub GL_TEXTURE_1D () {0xde0;}' unless defined(&GL_TEXTURE_1D);
    eval 'sub GL_TEXTURE_2D () {0xde1;}' unless defined(&GL_TEXTURE_2D);
    eval 'sub GL_TEXTURE_WRAP_S () {0x2802;}' unless defined(&GL_TEXTURE_WRAP_S);
    eval 'sub GL_TEXTURE_WRAP_T () {0x2803;}' unless defined(&GL_TEXTURE_WRAP_T);
    eval 'sub GL_TEXTURE_MAG_FILTER () {0x2800;}' unless defined(&GL_TEXTURE_MAG_FILTER);
    eval 'sub GL_TEXTURE_MIN_FILTER () {0x2801;}' unless defined(&GL_TEXTURE_MIN_FILTER);
    eval 'sub GL_TEXTURE_ENV_COLOR () {0x2201;}' unless defined(&GL_TEXTURE_ENV_COLOR);
    eval 'sub GL_TEXTURE_GEN_S () {0xc60;}' unless defined(&GL_TEXTURE_GEN_S);
    eval 'sub GL_TEXTURE_GEN_T () {0xc61;}' unless defined(&GL_TEXTURE_GEN_T);
    eval 'sub GL_TEXTURE_GEN_MODE () {0x2500;}' unless defined(&GL_TEXTURE_GEN_MODE);
    eval 'sub GL_TEXTURE_BORDER_COLOR () {0x1004;}' unless defined(&GL_TEXTURE_BORDER_COLOR);
    eval 'sub GL_TEXTURE_WIDTH () {0x1000;}' unless defined(&GL_TEXTURE_WIDTH);
    eval 'sub GL_TEXTURE_HEIGHT () {0x1001;}' unless defined(&GL_TEXTURE_HEIGHT);
    eval 'sub GL_TEXTURE_BORDER () {0x1005;}' unless defined(&GL_TEXTURE_BORDER);
    eval 'sub GL_TEXTURE_COMPONENTS () {0x1003;}' unless defined(&GL_TEXTURE_COMPONENTS);
    eval 'sub GL_TEXTURE_RED_SIZE () {0x805c;}' unless defined(&GL_TEXTURE_RED_SIZE);
    eval 'sub GL_TEXTURE_GREEN_SIZE () {0x805d;}' unless defined(&GL_TEXTURE_GREEN_SIZE);
    eval 'sub GL_TEXTURE_BLUE_SIZE () {0x805e;}' unless defined(&GL_TEXTURE_BLUE_SIZE);
    eval 'sub GL_TEXTURE_ALPHA_SIZE () {0x805f;}' unless defined(&GL_TEXTURE_ALPHA_SIZE);
    eval 'sub GL_TEXTURE_LUMINANCE_SIZE () {0x8060;}' unless defined(&GL_TEXTURE_LUMINANCE_SIZE);
    eval 'sub GL_TEXTURE_INTENSITY_SIZE () {0x8061;}' unless defined(&GL_TEXTURE_INTENSITY_SIZE);
    eval 'sub GL_NEAREST_MIPMAP_NEAREST () {0x2700;}' unless defined(&GL_NEAREST_MIPMAP_NEAREST);
    eval 'sub GL_NEAREST_MIPMAP_LINEAR () {0x2702;}' unless defined(&GL_NEAREST_MIPMAP_LINEAR);
    eval 'sub GL_LINEAR_MIPMAP_NEAREST () {0x2701;}' unless defined(&GL_LINEAR_MIPMAP_NEAREST);
    eval 'sub GL_LINEAR_MIPMAP_LINEAR () {0x2703;}' unless defined(&GL_LINEAR_MIPMAP_LINEAR);
    eval 'sub GL_OBJECT_LINEAR () {0x2401;}' unless defined(&GL_OBJECT_LINEAR);
    eval 'sub GL_OBJECT_PLANE () {0x2501;}' unless defined(&GL_OBJECT_PLANE);
    eval 'sub GL_EYE_LINEAR () {0x2400;}' unless defined(&GL_EYE_LINEAR);
    eval 'sub GL_EYE_PLANE () {0x2502;}' unless defined(&GL_EYE_PLANE);
    eval 'sub GL_SPHERE_MAP () {0x2402;}' unless defined(&GL_SPHERE_MAP);
    eval 'sub GL_DECAL () {0x2101;}' unless defined(&GL_DECAL);
    eval 'sub GL_MODULATE () {0x2100;}' unless defined(&GL_MODULATE);
    eval 'sub GL_NEAREST () {0x2600;}' unless defined(&GL_NEAREST);
    eval 'sub GL_REPEAT () {0x2901;}' unless defined(&GL_REPEAT);
    eval 'sub GL_CLAMP () {0x2900;}' unless defined(&GL_CLAMP);
    eval 'sub GL_S () {0x2000;}' unless defined(&GL_S);
    eval 'sub GL_T () {0x2001;}' unless defined(&GL_T);
    eval 'sub GL_R () {0x2002;}' unless defined(&GL_R);
    eval 'sub GL_Q () {0x2003;}' unless defined(&GL_Q);
    eval 'sub GL_TEXTURE_GEN_R () {0xc62;}' unless defined(&GL_TEXTURE_GEN_R);
    eval 'sub GL_TEXTURE_GEN_Q () {0xc63;}' unless defined(&GL_TEXTURE_GEN_Q);
    eval 'sub GL_VENDOR () {0x1f00;}' unless defined(&GL_VENDOR);
    eval 'sub GL_RENDERER () {0x1f01;}' unless defined(&GL_RENDERER);
    eval 'sub GL_VERSION () {0x1f02;}' unless defined(&GL_VERSION);
    eval 'sub GL_EXTENSIONS () {0x1f03;}' unless defined(&GL_EXTENSIONS);
    eval 'sub GL_NO_ERROR () {0x;}' unless defined(&GL_NO_ERROR);
    eval 'sub GL_INVALID_VALUE () {0x501;}' unless defined(&GL_INVALID_VALUE);
    eval 'sub GL_INVALID_ENUM () {0x500;}' unless defined(&GL_INVALID_ENUM);
    eval 'sub GL_INVALID_OPERATION () {0x502;}' unless defined(&GL_INVALID_OPERATION);
    eval 'sub GL_STACK_OVERFLOW () {0x503;}' unless defined(&GL_STACK_OVERFLOW);
    eval 'sub GL_STACK_UNDERFLOW () {0x504;}' unless defined(&GL_STACK_UNDERFLOW);
    eval 'sub GL_OUT_OF_MEMORY () {0x505;}' unless defined(&GL_OUT_OF_MEMORY);
    eval 'sub GL_CURRENT_BIT () {0x1;}' unless defined(&GL_CURRENT_BIT);
    eval 'sub GL_POINT_BIT () {0x2;}' unless defined(&GL_POINT_BIT);
    eval 'sub GL_LINE_BIT () {0x4;}' unless defined(&GL_LINE_BIT);
    eval 'sub GL_POLYGON_BIT () {0x8;}' unless defined(&GL_POLYGON_BIT);
    eval 'sub GL_POLYGON_STIPPLE_BIT () {0x10;}' unless defined(&GL_POLYGON_STIPPLE_BIT);
    eval 'sub GL_PIXEL_MODE_BIT () {0x20;}' unless defined(&GL_PIXEL_MODE_BIT);
    eval 'sub GL_LIGHTING_BIT () {0x40;}' unless defined(&GL_LIGHTING_BIT);
    eval 'sub GL_FOG_BIT () {0x80;}' unless defined(&GL_FOG_BIT);
    eval 'sub GL_DEPTH_BUFFER_BIT () {0x100;}' unless defined(&GL_DEPTH_BUFFER_BIT);
    eval 'sub GL_ACCUM_BUFFER_BIT () {0x200;}' unless defined(&GL_ACCUM_BUFFER_BIT);
    eval 'sub GL_STENCIL_BUFFER_BIT () {0x400;}' unless defined(&GL_STENCIL_BUFFER_BIT);
    eval 'sub GL_VIEWPORT_BIT () {0x800;}' unless defined(&GL_VIEWPORT_BIT);
    eval 'sub GL_TRANSFORM_BIT () {0x1000;}' unless defined(&GL_TRANSFORM_BIT);
    eval 'sub GL_ENABLE_BIT () {0x2000;}' unless defined(&GL_ENABLE_BIT);
    eval 'sub GL_COLOR_BUFFER_BIT () {0x4000;}' unless defined(&GL_COLOR_BUFFER_BIT);
    eval 'sub GL_HINT_BIT () {0x8000;}' unless defined(&GL_HINT_BIT);
    eval 'sub GL_EVAL_BIT () {0x10000;}' unless defined(&GL_EVAL_BIT);
    eval 'sub GL_LIST_BIT () {0x20000;}' unless defined(&GL_LIST_BIT);
    eval 'sub GL_TEXTURE_BIT () {0x40000;}' unless defined(&GL_TEXTURE_BIT);
    eval 'sub GL_SCISSOR_BIT () {0x80000;}' unless defined(&GL_SCISSOR_BIT);
    eval 'sub GL_ALL_ATTRIB_BITS () {0xfffff;}' unless defined(&GL_ALL_ATTRIB_BITS);
    eval 'sub GL_PROXY_TEXTURE_1D () {0x8063;}' unless defined(&GL_PROXY_TEXTURE_1D);
    eval 'sub GL_PROXY_TEXTURE_2D () {0x8064;}' unless defined(&GL_PROXY_TEXTURE_2D);
    eval 'sub GL_TEXTURE_PRIORITY () {0x8066;}' unless defined(&GL_TEXTURE_PRIORITY);
    eval 'sub GL_TEXTURE_RESIDENT () {0x8067;}' unless defined(&GL_TEXTURE_RESIDENT);
    eval 'sub GL_TEXTURE_BINDING_1D () {0x8068;}' unless defined(&GL_TEXTURE_BINDING_1D);
    eval 'sub GL_TEXTURE_BINDING_2D () {0x8069;}' unless defined(&GL_TEXTURE_BINDING_2D);
    eval 'sub GL_TEXTURE_INTERNAL_FORMAT () {0x1003;}' unless defined(&GL_TEXTURE_INTERNAL_FORMAT);
    eval 'sub GL_ALPHA4 () {0x803b;}' unless defined(&GL_ALPHA4);
    eval 'sub GL_ALPHA8 () {0x803c;}' unless defined(&GL_ALPHA8);
    eval 'sub GL_ALPHA12 () {0x803d;}' unless defined(&GL_ALPHA12);
    eval 'sub GL_ALPHA16 () {0x803e;}' unless defined(&GL_ALPHA16);
    eval 'sub GL_LUMINANCE4 () {0x803f;}' unless defined(&GL_LUMINANCE4);
    eval 'sub GL_LUMINANCE8 () {0x8040;}' unless defined(&GL_LUMINANCE8);
    eval 'sub GL_LUMINANCE12 () {0x8041;}' unless defined(&GL_LUMINANCE12);
    eval 'sub GL_LUMINANCE16 () {0x8042;}' unless defined(&GL_LUMINANCE16);
    eval 'sub GL_LUMINANCE4_ALPHA4 () {0x8043;}' unless defined(&GL_LUMINANCE4_ALPHA4);
    eval 'sub GL_LUMINANCE6_ALPHA2 () {0x8044;}' unless defined(&GL_LUMINANCE6_ALPHA2);
    eval 'sub GL_LUMINANCE8_ALPHA8 () {0x8045;}' unless defined(&GL_LUMINANCE8_ALPHA8);
    eval 'sub GL_LUMINANCE12_ALPHA4 () {0x8046;}' unless defined(&GL_LUMINANCE12_ALPHA4);
    eval 'sub GL_LUMINANCE12_ALPHA12 () {0x8047;}' unless defined(&GL_LUMINANCE12_ALPHA12);
    eval 'sub GL_LUMINANCE16_ALPHA16 () {0x8048;}' unless defined(&GL_LUMINANCE16_ALPHA16);
    eval 'sub GL_INTENSITY () {0x8049;}' unless defined(&GL_INTENSITY);
    eval 'sub GL_INTENSITY4 () {0x804a;}' unless defined(&GL_INTENSITY4);
    eval 'sub GL_INTENSITY8 () {0x804b;}' unless defined(&GL_INTENSITY8);
    eval 'sub GL_INTENSITY12 () {0x804c;}' unless defined(&GL_INTENSITY12);
    eval 'sub GL_INTENSITY16 () {0x804d;}' unless defined(&GL_INTENSITY16);
    eval 'sub GL_R3_G3_B2 () {0x2a10;}' unless defined(&GL_R3_G3_B2);
    eval 'sub GL_RGB4 () {0x804f;}' unless defined(&GL_RGB4);
    eval 'sub GL_RGB5 () {0x8050;}' unless defined(&GL_RGB5);
    eval 'sub GL_RGB8 () {0x8051;}' unless defined(&GL_RGB8);
    eval 'sub GL_RGB10 () {0x8052;}' unless defined(&GL_RGB10);
    eval 'sub GL_RGB12 () {0x8053;}' unless defined(&GL_RGB12);
    eval 'sub GL_RGB16 () {0x8054;}' unless defined(&GL_RGB16);
    eval 'sub GL_RGBA2 () {0x8055;}' unless defined(&GL_RGBA2);
    eval 'sub GL_RGBA4 () {0x8056;}' unless defined(&GL_RGBA4);
    eval 'sub GL_RGB5_A1 () {0x8057;}' unless defined(&GL_RGB5_A1);
    eval 'sub GL_RGBA8 () {0x8058;}' unless defined(&GL_RGBA8);
    eval 'sub GL_RGB10_A2 () {0x8059;}' unless defined(&GL_RGB10_A2);
    eval 'sub GL_RGBA12 () {0x805a;}' unless defined(&GL_RGBA12);
    eval 'sub GL_RGBA16 () {0x805b;}' unless defined(&GL_RGBA16);
    eval 'sub GL_CLIENT_PIXEL_STORE_BIT () {0x1;}' unless defined(&GL_CLIENT_PIXEL_STORE_BIT);
    eval 'sub GL_CLIENT_VERTEX_ARRAY_BIT () {0x2;}' unless defined(&GL_CLIENT_VERTEX_ARRAY_BIT);
    eval 'sub GL_ALL_CLIENT_ATTRIB_BITS () {0xffffffff;}' unless defined(&GL_ALL_CLIENT_ATTRIB_BITS);
    eval 'sub GL_CLIENT_ALL_ATTRIB_BITS () {0xffffffff;}' unless defined(&GL_CLIENT_ALL_ATTRIB_BITS);
    eval 'sub GL_RESCALE_NORMAL () {0x803a;}' unless defined(&GL_RESCALE_NORMAL);
    eval 'sub GL_CLAMP_TO_EDGE () {0x812f;}' unless defined(&GL_CLAMP_TO_EDGE);
    eval 'sub GL_MAX_ELEMENTS_VERTICES () {0x80e8;}' unless defined(&GL_MAX_ELEMENTS_VERTICES);
    eval 'sub GL_MAX_ELEMENTS_INDICES () {0x80e9;}' unless defined(&GL_MAX_ELEMENTS_INDICES);
    eval 'sub GL_BGR () {0x80e0;}' unless defined(&GL_BGR);
    eval 'sub GL_BGRA () {0x80e1;}' unless defined(&GL_BGRA);
    eval 'sub GL_UNSIGNED_BYTE_3_3_2 () {0x8032;}' unless defined(&GL_UNSIGNED_BYTE_3_3_2);
    eval 'sub GL_UNSIGNED_BYTE_2_3_3_REV () {0x8362;}' unless defined(&GL_UNSIGNED_BYTE_2_3_3_REV);
    eval 'sub GL_UNSIGNED_SHORT_5_6_5 () {0x8363;}' unless defined(&GL_UNSIGNED_SHORT_5_6_5);
    eval 'sub GL_UNSIGNED_SHORT_5_6_5_REV () {0x8364;}' unless defined(&GL_UNSIGNED_SHORT_5_6_5_REV);
    eval 'sub GL_UNSIGNED_SHORT_4_4_4_4 () {0x8033;}' unless defined(&GL_UNSIGNED_SHORT_4_4_4_4);
    eval 'sub GL_UNSIGNED_SHORT_4_4_4_4_REV () {0x8365;}' unless defined(&GL_UNSIGNED_SHORT_4_4_4_4_REV);
    eval 'sub GL_UNSIGNED_SHORT_5_5_5_1 () {0x8034;}' unless defined(&GL_UNSIGNED_SHORT_5_5_5_1);
    eval 'sub GL_UNSIGNED_SHORT_1_5_5_5_REV () {0x8366;}' unless defined(&GL_UNSIGNED_SHORT_1_5_5_5_REV);
    eval 'sub GL_UNSIGNED_INT_8_8_8_8 () {0x8035;}' unless defined(&GL_UNSIGNED_INT_8_8_8_8);
    eval 'sub GL_UNSIGNED_INT_8_8_8_8_REV () {0x8367;}' unless defined(&GL_UNSIGNED_INT_8_8_8_8_REV);
    eval 'sub GL_UNSIGNED_INT_10_10_10_2 () {0x8036;}' unless defined(&GL_UNSIGNED_INT_10_10_10_2);
    eval 'sub GL_UNSIGNED_INT_2_10_10_10_REV () {0x8368;}' unless defined(&GL_UNSIGNED_INT_2_10_10_10_REV);
    eval 'sub GL_LIGHT_MODEL_COLOR_CONTROL () {0x81f8;}' unless defined(&GL_LIGHT_MODEL_COLOR_CONTROL);
    eval 'sub GL_SINGLE_COLOR () {0x81f9;}' unless defined(&GL_SINGLE_COLOR);
    eval 'sub GL_SEPARATE_SPECULAR_COLOR () {0x81fa;}' unless defined(&GL_SEPARATE_SPECULAR_COLOR);
    eval 'sub GL_TEXTURE_MIN_LOD () {0x813a;}' unless defined(&GL_TEXTURE_MIN_LOD);
    eval 'sub GL_TEXTURE_MAX_LOD () {0x813b;}' unless defined(&GL_TEXTURE_MAX_LOD);
    eval 'sub GL_TEXTURE_BASE_LEVEL () {0x813c;}' unless defined(&GL_TEXTURE_BASE_LEVEL);
    eval 'sub GL_TEXTURE_MAX_LEVEL () {0x813d;}' unless defined(&GL_TEXTURE_MAX_LEVEL);
    eval 'sub GL_SMOOTH_POINT_SIZE_RANGE () {0xb12;}' unless defined(&GL_SMOOTH_POINT_SIZE_RANGE);
    eval 'sub GL_SMOOTH_POINT_SIZE_GRANULARITY () {0xb13;}' unless defined(&GL_SMOOTH_POINT_SIZE_GRANULARITY);
    eval 'sub GL_SMOOTH_LINE_WIDTH_RANGE () {0xb22;}' unless defined(&GL_SMOOTH_LINE_WIDTH_RANGE);
    eval 'sub GL_SMOOTH_LINE_WIDTH_GRANULARITY () {0xb23;}' unless defined(&GL_SMOOTH_LINE_WIDTH_GRANULARITY);
    eval 'sub GL_ALIASED_POINT_SIZE_RANGE () {0x846d;}' unless defined(&GL_ALIASED_POINT_SIZE_RANGE);
    eval 'sub GL_ALIASED_LINE_WIDTH_RANGE () {0x846e;}' unless defined(&GL_ALIASED_LINE_WIDTH_RANGE);
    eval 'sub GL_PACK_SKIP_IMAGES () {0x806b;}' unless defined(&GL_PACK_SKIP_IMAGES);
    eval 'sub GL_PACK_IMAGE_HEIGHT () {0x806c;}' unless defined(&GL_PACK_IMAGE_HEIGHT);
    eval 'sub GL_UNPACK_SKIP_IMAGES () {0x806d;}' unless defined(&GL_UNPACK_SKIP_IMAGES);
    eval 'sub GL_UNPACK_IMAGE_HEIGHT () {0x806e;}' unless defined(&GL_UNPACK_IMAGE_HEIGHT);
    eval 'sub GL_TEXTURE_3D () {0x806f;}' unless defined(&GL_TEXTURE_3D);
    eval 'sub GL_PROXY_TEXTURE_3D () {0x8070;}' unless defined(&GL_PROXY_TEXTURE_3D);
    eval 'sub GL_TEXTURE_DEPTH () {0x8071;}' unless defined(&GL_TEXTURE_DEPTH);
    eval 'sub GL_TEXTURE_WRAP_R () {0x8072;}' unless defined(&GL_TEXTURE_WRAP_R);
    eval 'sub GL_MAX_3D_TEXTURE_SIZE () {0x8073;}' unless defined(&GL_MAX_3D_TEXTURE_SIZE);
    eval 'sub GL_TEXTURE_BINDING_3D () {0x806a;}' unless defined(&GL_TEXTURE_BINDING_3D);
    eval 'sub GL_COLOR_TABLE () {0x80d0;}' unless defined(&GL_COLOR_TABLE);
    eval 'sub GL_POST_CONVOLUTION_COLOR_TABLE () {0x80d1;}' unless defined(&GL_POST_CONVOLUTION_COLOR_TABLE);
    eval 'sub GL_POST_COLOR_MATRIX_COLOR_TABLE () {0x80d2;}' unless defined(&GL_POST_COLOR_MATRIX_COLOR_TABLE);
    eval 'sub GL_PROXY_COLOR_TABLE () {0x80d3;}' unless defined(&GL_PROXY_COLOR_TABLE);
    eval 'sub GL_PROXY_POST_CONVOLUTION_COLOR_TABLE () {0x80d4;}' unless defined(&GL_PROXY_POST_CONVOLUTION_COLOR_TABLE);
    eval 'sub GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE () {0x80d5;}' unless defined(&GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE);
    eval 'sub GL_COLOR_TABLE_SCALE () {0x80d6;}' unless defined(&GL_COLOR_TABLE_SCALE);
    eval 'sub GL_COLOR_TABLE_BIAS () {0x80d7;}' unless defined(&GL_COLOR_TABLE_BIAS);
    eval 'sub GL_COLOR_TABLE_FORMAT () {0x80d8;}' unless defined(&GL_COLOR_TABLE_FORMAT);
    eval 'sub GL_COLOR_TABLE_WIDTH () {0x80d9;}' unless defined(&GL_COLOR_TABLE_WIDTH);
    eval 'sub GL_COLOR_TABLE_RED_SIZE () {0x80da;}' unless defined(&GL_COLOR_TABLE_RED_SIZE);
    eval 'sub GL_COLOR_TABLE_GREEN_SIZE () {0x80db;}' unless defined(&GL_COLOR_TABLE_GREEN_SIZE);
    eval 'sub GL_COLOR_TABLE_BLUE_SIZE () {0x80dc;}' unless defined(&GL_COLOR_TABLE_BLUE_SIZE);
    eval 'sub GL_COLOR_TABLE_ALPHA_SIZE () {0x80dd;}' unless defined(&GL_COLOR_TABLE_ALPHA_SIZE);
    eval 'sub GL_COLOR_TABLE_LUMINANCE_SIZE () {0x80de;}' unless defined(&GL_COLOR_TABLE_LUMINANCE_SIZE);
    eval 'sub GL_COLOR_TABLE_INTENSITY_SIZE () {0x80df;}' unless defined(&GL_COLOR_TABLE_INTENSITY_SIZE);
    eval 'sub GL_CONVOLUTION_1D () {0x8010;}' unless defined(&GL_CONVOLUTION_1D);
    eval 'sub GL_CONVOLUTION_2D () {0x8011;}' unless defined(&GL_CONVOLUTION_2D);
    eval 'sub GL_SEPARABLE_2D () {0x8012;}' unless defined(&GL_SEPARABLE_2D);
    eval 'sub GL_CONVOLUTION_BORDER_MODE () {0x8013;}' unless defined(&GL_CONVOLUTION_BORDER_MODE);
    eval 'sub GL_CONVOLUTION_FILTER_SCALE () {0x8014;}' unless defined(&GL_CONVOLUTION_FILTER_SCALE);
    eval 'sub GL_CONVOLUTION_FILTER_BIAS () {0x8015;}' unless defined(&GL_CONVOLUTION_FILTER_BIAS);
    eval 'sub GL_REDUCE () {0x8016;}' unless defined(&GL_REDUCE);
    eval 'sub GL_CONVOLUTION_FORMAT () {0x8017;}' unless defined(&GL_CONVOLUTION_FORMAT);
    eval 'sub GL_CONVOLUTION_WIDTH () {0x8018;}' unless defined(&GL_CONVOLUTION_WIDTH);
    eval 'sub GL_CONVOLUTION_HEIGHT () {0x8019;}' unless defined(&GL_CONVOLUTION_HEIGHT);
    eval 'sub GL_MAX_CONVOLUTION_WIDTH () {0x801a;}' unless defined(&GL_MAX_CONVOLUTION_WIDTH);
    eval 'sub GL_MAX_CONVOLUTION_HEIGHT () {0x801b;}' unless defined(&GL_MAX_CONVOLUTION_HEIGHT);
    eval 'sub GL_POST_CONVOLUTION_RED_SCALE () {0x801c;}' unless defined(&GL_POST_CONVOLUTION_RED_SCALE);
    eval 'sub GL_POST_CONVOLUTION_GREEN_SCALE () {0x801d;}' unless defined(&GL_POST_CONVOLUTION_GREEN_SCALE);
    eval 'sub GL_POST_CONVOLUTION_BLUE_SCALE () {0x801e;}' unless defined(&GL_POST_CONVOLUTION_BLUE_SCALE);
    eval 'sub GL_POST_CONVOLUTION_ALPHA_SCALE () {0x801f;}' unless defined(&GL_POST_CONVOLUTION_ALPHA_SCALE);
    eval 'sub GL_POST_CONVOLUTION_RED_BIAS () {0x8020;}' unless defined(&GL_POST_CONVOLUTION_RED_BIAS);
    eval 'sub GL_POST_CONVOLUTION_GREEN_BIAS () {0x8021;}' unless defined(&GL_POST_CONVOLUTION_GREEN_BIAS);
    eval 'sub GL_POST_CONVOLUTION_BLUE_BIAS () {0x8022;}' unless defined(&GL_POST_CONVOLUTION_BLUE_BIAS);
    eval 'sub GL_POST_CONVOLUTION_ALPHA_BIAS () {0x8023;}' unless defined(&GL_POST_CONVOLUTION_ALPHA_BIAS);
    eval 'sub GL_CONSTANT_BORDER () {0x8151;}' unless defined(&GL_CONSTANT_BORDER);
    eval 'sub GL_REPLICATE_BORDER () {0x8153;}' unless defined(&GL_REPLICATE_BORDER);
    eval 'sub GL_CONVOLUTION_BORDER_COLOR () {0x8154;}' unless defined(&GL_CONVOLUTION_BORDER_COLOR);
    eval 'sub GL_COLOR_MATRIX () {0x80b1;}' unless defined(&GL_COLOR_MATRIX);
    eval 'sub GL_COLOR_MATRIX_STACK_DEPTH () {0x80b2;}' unless defined(&GL_COLOR_MATRIX_STACK_DEPTH);
    eval 'sub GL_MAX_COLOR_MATRIX_STACK_DEPTH () {0x80b3;}' unless defined(&GL_MAX_COLOR_MATRIX_STACK_DEPTH);
    eval 'sub GL_POST_COLOR_MATRIX_RED_SCALE () {0x80b4;}' unless defined(&GL_POST_COLOR_MATRIX_RED_SCALE);
    eval 'sub GL_POST_COLOR_MATRIX_GREEN_SCALE () {0x80b5;}' unless defined(&GL_POST_COLOR_MATRIX_GREEN_SCALE);
    eval 'sub GL_POST_COLOR_MATRIX_BLUE_SCALE () {0x80b6;}' unless defined(&GL_POST_COLOR_MATRIX_BLUE_SCALE);
    eval 'sub GL_POST_COLOR_MATRIX_ALPHA_SCALE () {0x80b7;}' unless defined(&GL_POST_COLOR_MATRIX_ALPHA_SCALE);
    eval 'sub GL_POST_COLOR_MATRIX_RED_BIAS () {0x80b8;}' unless defined(&GL_POST_COLOR_MATRIX_RED_BIAS);
    eval 'sub GL_POST_COLOR_MATRIX_GREEN_BIAS () {0x80b9;}' unless defined(&GL_POST_COLOR_MATRIX_GREEN_BIAS);
    eval 'sub GL_POST_COLOR_MATRIX_BLUE_BIAS () {0x80ba;}' unless defined(&GL_POST_COLOR_MATRIX_BLUE_BIAS);
    eval 'sub GL_POST_COLOR_MATRIX_ALPHA_BIAS () {0x80bb;}' unless defined(&GL_POST_COLOR_MATRIX_ALPHA_BIAS);
    eval 'sub GL_HISTOGRAM () {0x8024;}' unless defined(&GL_HISTOGRAM);
    eval 'sub GL_PROXY_HISTOGRAM () {0x8025;}' unless defined(&GL_PROXY_HISTOGRAM);
    eval 'sub GL_HISTOGRAM_WIDTH () {0x8026;}' unless defined(&GL_HISTOGRAM_WIDTH);
    eval 'sub GL_HISTOGRAM_FORMAT () {0x8027;}' unless defined(&GL_HISTOGRAM_FORMAT);
    eval 'sub GL_HISTOGRAM_RED_SIZE () {0x8028;}' unless defined(&GL_HISTOGRAM_RED_SIZE);
    eval 'sub GL_HISTOGRAM_GREEN_SIZE () {0x8029;}' unless defined(&GL_HISTOGRAM_GREEN_SIZE);
    eval 'sub GL_HISTOGRAM_BLUE_SIZE () {0x802a;}' unless defined(&GL_HISTOGRAM_BLUE_SIZE);
    eval 'sub GL_HISTOGRAM_ALPHA_SIZE () {0x802b;}' unless defined(&GL_HISTOGRAM_ALPHA_SIZE);
    eval 'sub GL_HISTOGRAM_LUMINANCE_SIZE () {0x802c;}' unless defined(&GL_HISTOGRAM_LUMINANCE_SIZE);
    eval 'sub GL_HISTOGRAM_SINK () {0x802d;}' unless defined(&GL_HISTOGRAM_SINK);
    eval 'sub GL_MINMAX () {0x802e;}' unless defined(&GL_MINMAX);
    eval 'sub GL_MINMAX_FORMAT () {0x802f;}' unless defined(&GL_MINMAX_FORMAT);
    eval 'sub GL_MINMAX_SINK () {0x8030;}' unless defined(&GL_MINMAX_SINK);
    eval 'sub GL_TABLE_TOO_LARGE () {0x8031;}' unless defined(&GL_TABLE_TOO_LARGE);
    eval 'sub GL_BLEND_EQUATION () {0x8009;}' unless defined(&GL_BLEND_EQUATION);
    eval 'sub GL_MIN () {0x8007;}' unless defined(&GL_MIN);
    eval 'sub GL_MAX () {0x8008;}' unless defined(&GL_MAX);
    eval 'sub GL_FUNC_ADD () {0x8006;}' unless defined(&GL_FUNC_ADD);
    eval 'sub GL_FUNC_SUBTRACT () {0x800a;}' unless defined(&GL_FUNC_SUBTRACT);
    eval 'sub GL_FUNC_REVERSE_SUBTRACT () {0x800b;}' unless defined(&GL_FUNC_REVERSE_SUBTRACT);
    eval 'sub GL_BLEND_COLOR () {0x8005;}' unless defined(&GL_BLEND_COLOR);
    eval 'sub GL_TEXTURE0 () {0x84c0;}' unless defined(&GL_TEXTURE0);
    eval 'sub GL_TEXTURE1 () {0x84c1;}' unless defined(&GL_TEXTURE1);
    eval 'sub GL_TEXTURE2 () {0x84c2;}' unless defined(&GL_TEXTURE2);
    eval 'sub GL_TEXTURE3 () {0x84c3;}' unless defined(&GL_TEXTURE3);
    eval 'sub GL_TEXTURE4 () {0x84c4;}' unless defined(&GL_TEXTURE4);
    eval 'sub GL_TEXTURE5 () {0x84c5;}' unless defined(&GL_TEXTURE5);
    eval 'sub GL_TEXTURE6 () {0x84c6;}' unless defined(&GL_TEXTURE6);
    eval 'sub GL_TEXTURE7 () {0x84c7;}' unless defined(&GL_TEXTURE7);
    eval 'sub GL_TEXTURE8 () {0x84c8;}' unless defined(&GL_TEXTURE8);
    eval 'sub GL_TEXTURE9 () {0x84c9;}' unless defined(&GL_TEXTURE9);
    eval 'sub GL_TEXTURE10 () {0x84ca;}' unless defined(&GL_TEXTURE10);
    eval 'sub GL_TEXTURE11 () {0x84cb;}' unless defined(&GL_TEXTURE11);
    eval 'sub GL_TEXTURE12 () {0x84cc;}' unless defined(&GL_TEXTURE12);
    eval 'sub GL_TEXTURE13 () {0x84cd;}' unless defined(&GL_TEXTURE13);
    eval 'sub GL_TEXTURE14 () {0x84ce;}' unless defined(&GL_TEXTURE14);
    eval 'sub GL_TEXTURE15 () {0x84cf;}' unless defined(&GL_TEXTURE15);
    eval 'sub GL_TEXTURE16 () {0x84d0;}' unless defined(&GL_TEXTURE16);
    eval 'sub GL_TEXTURE17 () {0x84d1;}' unless defined(&GL_TEXTURE17);
    eval 'sub GL_TEXTURE18 () {0x84d2;}' unless defined(&GL_TEXTURE18);
    eval 'sub GL_TEXTURE19 () {0x84d3;}' unless defined(&GL_TEXTURE19);
    eval 'sub GL_TEXTURE20 () {0x84d4;}' unless defined(&GL_TEXTURE20);
    eval 'sub GL_TEXTURE21 () {0x84d5;}' unless defined(&GL_TEXTURE21);
    eval 'sub GL_TEXTURE22 () {0x84d6;}' unless defined(&GL_TEXTURE22);
    eval 'sub GL_TEXTURE23 () {0x84d7;}' unless defined(&GL_TEXTURE23);
    eval 'sub GL_TEXTURE24 () {0x84d8;}' unless defined(&GL_TEXTURE24);
    eval 'sub GL_TEXTURE25 () {0x84d9;}' unless defined(&GL_TEXTURE25);
    eval 'sub GL_TEXTURE26 () {0x84da;}' unless defined(&GL_TEXTURE26);
    eval 'sub GL_TEXTURE27 () {0x84db;}' unless defined(&GL_TEXTURE27);
    eval 'sub GL_TEXTURE28 () {0x84dc;}' unless defined(&GL_TEXTURE28);
    eval 'sub GL_TEXTURE29 () {0x84dd;}' unless defined(&GL_TEXTURE29);
    eval 'sub GL_TEXTURE30 () {0x84de;}' unless defined(&GL_TEXTURE30);
    eval 'sub GL_TEXTURE31 () {0x84df;}' unless defined(&GL_TEXTURE31);
    eval 'sub GL_ACTIVE_TEXTURE () {0x84e0;}' unless defined(&GL_ACTIVE_TEXTURE);
    eval 'sub GL_CLIENT_ACTIVE_TEXTURE () {0x84e1;}' unless defined(&GL_CLIENT_ACTIVE_TEXTURE);
    eval 'sub GL_MAX_TEXTURE_UNITS () {0x84e2;}' unless defined(&GL_MAX_TEXTURE_UNITS);
    eval 'sub GL_NORMAL_MAP () {0x8511;}' unless defined(&GL_NORMAL_MAP);
    eval 'sub GL_REFLECTION_MAP () {0x8512;}' unless defined(&GL_REFLECTION_MAP);
    eval 'sub GL_TEXTURE_CUBE_MAP () {0x8513;}' unless defined(&GL_TEXTURE_CUBE_MAP);
    eval 'sub GL_TEXTURE_BINDING_CUBE_MAP () {0x8514;}' unless defined(&GL_TEXTURE_BINDING_CUBE_MAP);
    eval 'sub GL_TEXTURE_CUBE_MAP_POSITIVE_X () {0x8515;}' unless defined(&GL_TEXTURE_CUBE_MAP_POSITIVE_X);
    eval 'sub GL_TEXTURE_CUBE_MAP_NEGATIVE_X () {0x8516;}' unless defined(&GL_TEXTURE_CUBE_MAP_NEGATIVE_X);
    eval 'sub GL_TEXTURE_CUBE_MAP_POSITIVE_Y () {0x8517;}' unless defined(&GL_TEXTURE_CUBE_MAP_POSITIVE_Y);
    eval 'sub GL_TEXTURE_CUBE_MAP_NEGATIVE_Y () {0x8518;}' unless defined(&GL_TEXTURE_CUBE_MAP_NEGATIVE_Y);
    eval 'sub GL_TEXTURE_CUBE_MAP_POSITIVE_Z () {0x8519;}' unless defined(&GL_TEXTURE_CUBE_MAP_POSITIVE_Z);
    eval 'sub GL_TEXTURE_CUBE_MAP_NEGATIVE_Z () {0x851a;}' unless defined(&GL_TEXTURE_CUBE_MAP_NEGATIVE_Z);
    eval 'sub GL_PROXY_TEXTURE_CUBE_MAP () {0x851b;}' unless defined(&GL_PROXY_TEXTURE_CUBE_MAP);
    eval 'sub GL_MAX_CUBE_MAP_TEXTURE_SIZE () {0x851c;}' unless defined(&GL_MAX_CUBE_MAP_TEXTURE_SIZE);
    eval 'sub GL_COMPRESSED_ALPHA () {0x84e9;}' unless defined(&GL_COMPRESSED_ALPHA);
    eval 'sub GL_COMPRESSED_LUMINANCE () {0x84ea;}' unless defined(&GL_COMPRESSED_LUMINANCE);
    eval 'sub GL_COMPRESSED_LUMINANCE_ALPHA () {0x84eb;}' unless defined(&GL_COMPRESSED_LUMINANCE_ALPHA);
    eval 'sub GL_COMPRESSED_INTENSITY () {0x84ec;}' unless defined(&GL_COMPRESSED_INTENSITY);
    eval 'sub GL_COMPRESSED_RGB () {0x84ed;}' unless defined(&GL_COMPRESSED_RGB);
    eval 'sub GL_COMPRESSED_RGBA () {0x84ee;}' unless defined(&GL_COMPRESSED_RGBA);
    eval 'sub GL_TEXTURE_COMPRESSION_HINT () {0x84ef;}' unless defined(&GL_TEXTURE_COMPRESSION_HINT);
    eval 'sub GL_TEXTURE_COMPRESSED_IMAGE_SIZE () {0x86a0;}' unless defined(&GL_TEXTURE_COMPRESSED_IMAGE_SIZE);
    eval 'sub GL_TEXTURE_COMPRESSED () {0x86a1;}' unless defined(&GL_TEXTURE_COMPRESSED);
    eval 'sub GL_NUM_COMPRESSED_TEXTURE_FORMATS () {0x86a2;}' unless defined(&GL_NUM_COMPRESSED_TEXTURE_FORMATS);
    eval 'sub GL_COMPRESSED_TEXTURE_FORMATS () {0x86a3;}' unless defined(&GL_COMPRESSED_TEXTURE_FORMATS);
    eval 'sub GL_MULTISAMPLE () {0x809d;}' unless defined(&GL_MULTISAMPLE);
    eval 'sub GL_SAMPLE_ALPHA_TO_COVERAGE () {0x809e;}' unless defined(&GL_SAMPLE_ALPHA_TO_COVERAGE);
    eval 'sub GL_SAMPLE_ALPHA_TO_ONE () {0x809f;}' unless defined(&GL_SAMPLE_ALPHA_TO_ONE);
    eval 'sub GL_SAMPLE_COVERAGE () {0x80a0;}' unless defined(&GL_SAMPLE_COVERAGE);
    eval 'sub GL_SAMPLE_BUFFERS () {0x80a8;}' unless defined(&GL_SAMPLE_BUFFERS);
    eval 'sub GL_SAMPLES () {0x80a9;}' unless defined(&GL_SAMPLES);
    eval 'sub GL_SAMPLE_COVERAGE_VALUE () {0x80aa;}' unless defined(&GL_SAMPLE_COVERAGE_VALUE);
    eval 'sub GL_SAMPLE_COVERAGE_INVERT () {0x80ab;}' unless defined(&GL_SAMPLE_COVERAGE_INVERT);
    eval 'sub GL_MULTISAMPLE_BIT () {0x20000000;}' unless defined(&GL_MULTISAMPLE_BIT);
    eval 'sub GL_TRANSPOSE_MODELVIEW_MATRIX () {0x84e3;}' unless defined(&GL_TRANSPOSE_MODELVIEW_MATRIX);
    eval 'sub GL_TRANSPOSE_PROJECTION_MATRIX () {0x84e4;}' unless defined(&GL_TRANSPOSE_PROJECTION_MATRIX);
    eval 'sub GL_TRANSPOSE_TEXTURE_MATRIX () {0x84e5;}' unless defined(&GL_TRANSPOSE_TEXTURE_MATRIX);
    eval 'sub GL_TRANSPOSE_COLOR_MATRIX () {0x84e6;}' unless defined(&GL_TRANSPOSE_COLOR_MATRIX);
    eval 'sub GL_COMBINE () {0x8570;}' unless defined(&GL_COMBINE);
    eval 'sub GL_COMBINE_RGB () {0x8571;}' unless defined(&GL_COMBINE_RGB);
    eval 'sub GL_COMBINE_ALPHA () {0x8572;}' unless defined(&GL_COMBINE_ALPHA);
    eval 'sub GL_SOURCE0_RGB () {0x8580;}' unless defined(&GL_SOURCE0_RGB);
    eval 'sub GL_SOURCE1_RGB () {0x8581;}' unless defined(&GL_SOURCE1_RGB);
    eval 'sub GL_SOURCE2_RGB () {0x8582;}' unless defined(&GL_SOURCE2_RGB);
    eval 'sub GL_SOURCE0_ALPHA () {0x8588;}' unless defined(&GL_SOURCE0_ALPHA);
    eval 'sub GL_SOURCE1_ALPHA () {0x8589;}' unless defined(&GL_SOURCE1_ALPHA);
    eval 'sub GL_SOURCE2_ALPHA () {0x858a;}' unless defined(&GL_SOURCE2_ALPHA);
    eval 'sub GL_OPERAND0_RGB () {0x8590;}' unless defined(&GL_OPERAND0_RGB);
    eval 'sub GL_OPERAND1_RGB () {0x8591;}' unless defined(&GL_OPERAND1_RGB);
    eval 'sub GL_OPERAND2_RGB () {0x8592;}' unless defined(&GL_OPERAND2_RGB);
    eval 'sub GL_OPERAND0_ALPHA () {0x8598;}' unless defined(&GL_OPERAND0_ALPHA);
    eval 'sub GL_OPERAND1_ALPHA () {0x8599;}' unless defined(&GL_OPERAND1_ALPHA);
    eval 'sub GL_OPERAND2_ALPHA () {0x859a;}' unless defined(&GL_OPERAND2_ALPHA);
    eval 'sub GL_RGB_SCALE () {0x8573;}' unless defined(&GL_RGB_SCALE);
    eval 'sub GL_ADD_SIGNED () {0x8574;}' unless defined(&GL_ADD_SIGNED);
    eval 'sub GL_INTERPOLATE () {0x8575;}' unless defined(&GL_INTERPOLATE);
    eval 'sub GL_SUBTRACT () {0x84e7;}' unless defined(&GL_SUBTRACT);
    eval 'sub GL_CONSTANT () {0x8576;}' unless defined(&GL_CONSTANT);
    eval 'sub GL_PRIMARY_COLOR () {0x8577;}' unless defined(&GL_PRIMARY_COLOR);
    eval 'sub GL_PREVIOUS () {0x8578;}' unless defined(&GL_PREVIOUS);
    eval 'sub GL_DOT3_RGB () {0x86ae;}' unless defined(&GL_DOT3_RGB);
    eval 'sub GL_DOT3_RGBA () {0x86af;}' unless defined(&GL_DOT3_RGBA);
    eval 'sub GL_CLAMP_TO_BORDER () {0x812d;}' unless defined(&GL_CLAMP_TO_BORDER);
    if(defined( &__BEOS__) || defined( &__QUICKDRAW__)) {
    }
    unless(defined(&GL_ARB_multitexture)) {
	eval 'sub GL_ARB_multitexture () {1;}' unless defined(&GL_ARB_multitexture);
	eval 'sub GL_TEXTURE0_ARB () {0x84c0;}' unless defined(&GL_TEXTURE0_ARB);
	eval 'sub GL_TEXTURE1_ARB () {0x84c1;}' unless defined(&GL_TEXTURE1_ARB);
	eval 'sub GL_TEXTURE2_ARB () {0x84c2;}' unless defined(&GL_TEXTURE2_ARB);
	eval 'sub GL_TEXTURE3_ARB () {0x84c3;}' unless defined(&GL_TEXTURE3_ARB);
	eval 'sub GL_TEXTURE4_ARB () {0x84c4;}' unless defined(&GL_TEXTURE4_ARB);
	eval 'sub GL_TEXTURE5_ARB () {0x84c5;}' unless defined(&GL_TEXTURE5_ARB);
	eval 'sub GL_TEXTURE6_ARB () {0x84c6;}' unless defined(&GL_TEXTURE6_ARB);
	eval 'sub GL_TEXTURE7_ARB () {0x84c7;}' unless defined(&GL_TEXTURE7_ARB);
	eval 'sub GL_TEXTURE8_ARB () {0x84c8;}' unless defined(&GL_TEXTURE8_ARB);
	eval 'sub GL_TEXTURE9_ARB () {0x84c9;}' unless defined(&GL_TEXTURE9_ARB);
	eval 'sub GL_TEXTURE10_ARB () {0x84ca;}' unless defined(&GL_TEXTURE10_ARB);
	eval 'sub GL_TEXTURE11_ARB () {0x84cb;}' unless defined(&GL_TEXTURE11_ARB);
	eval 'sub GL_TEXTURE12_ARB () {0x84cc;}' unless defined(&GL_TEXTURE12_ARB);
	eval 'sub GL_TEXTURE13_ARB () {0x84cd;}' unless defined(&GL_TEXTURE13_ARB);
	eval 'sub GL_TEXTURE14_ARB () {0x84ce;}' unless defined(&GL_TEXTURE14_ARB);
	eval 'sub GL_TEXTURE15_ARB () {0x84cf;}' unless defined(&GL_TEXTURE15_ARB);
	eval 'sub GL_TEXTURE16_ARB () {0x84d0;}' unless defined(&GL_TEXTURE16_ARB);
	eval 'sub GL_TEXTURE17_ARB () {0x84d1;}' unless defined(&GL_TEXTURE17_ARB);
	eval 'sub GL_TEXTURE18_ARB () {0x84d2;}' unless defined(&GL_TEXTURE18_ARB);
	eval 'sub GL_TEXTURE19_ARB () {0x84d3;}' unless defined(&GL_TEXTURE19_ARB);
	eval 'sub GL_TEXTURE20_ARB () {0x84d4;}' unless defined(&GL_TEXTURE20_ARB);
	eval 'sub GL_TEXTURE21_ARB () {0x84d5;}' unless defined(&GL_TEXTURE21_ARB);
	eval 'sub GL_TEXTURE22_ARB () {0x84d6;}' unless defined(&GL_TEXTURE22_ARB);
	eval 'sub GL_TEXTURE23_ARB () {0x84d7;}' unless defined(&GL_TEXTURE23_ARB);
	eval 'sub GL_TEXTURE24_ARB () {0x84d8;}' unless defined(&GL_TEXTURE24_ARB);
	eval 'sub GL_TEXTURE25_ARB () {0x84d9;}' unless defined(&GL_TEXTURE25_ARB);
	eval 'sub GL_TEXTURE26_ARB () {0x84da;}' unless defined(&GL_TEXTURE26_ARB);
	eval 'sub GL_TEXTURE27_ARB () {0x84db;}' unless defined(&GL_TEXTURE27_ARB);
	eval 'sub GL_TEXTURE28_ARB () {0x84dc;}' unless defined(&GL_TEXTURE28_ARB);
	eval 'sub GL_TEXTURE29_ARB () {0x84dd;}' unless defined(&GL_TEXTURE29_ARB);
	eval 'sub GL_TEXTURE30_ARB () {0x84de;}' unless defined(&GL_TEXTURE30_ARB);
	eval 'sub GL_TEXTURE31_ARB () {0x84df;}' unless defined(&GL_TEXTURE31_ARB);
	eval 'sub GL_ACTIVE_TEXTURE_ARB () {0x84e0;}' unless defined(&GL_ACTIVE_TEXTURE_ARB);
	eval 'sub GL_CLIENT_ACTIVE_TEXTURE_ARB () {0x84e1;}' unless defined(&GL_CLIENT_ACTIVE_TEXTURE_ARB);
	eval 'sub GL_MAX_TEXTURE_UNITS_ARB () {0x84e2;}' unless defined(&GL_MAX_TEXTURE_UNITS_ARB);
    }
    if(defined( &GL_GLEXT_LEGACY)) {
	unless(defined(&GL_EXT_abgr)) {
	    eval 'sub GL_EXT_abgr () {1;}' unless defined(&GL_EXT_abgr);
	    eval 'sub GL_ABGR_EXT () {0x8000;}' unless defined(&GL_ABGR_EXT);
	}
	unless(defined(&GL_EXT_blend_color)) {
	    eval 'sub GL_EXT_blend_color () {1;}' unless defined(&GL_EXT_blend_color);
	    eval 'sub GL_CONSTANT_COLOR_EXT () {0x8001;}' unless defined(&GL_CONSTANT_COLOR_EXT);
	    eval 'sub GL_ONE_MINUS_CONSTANT_COLOR_EXT () {0x8002;}' unless defined(&GL_ONE_MINUS_CONSTANT_COLOR_EXT);
	    eval 'sub GL_CONSTANT_ALPHA_EXT () {0x8003;}' unless defined(&GL_CONSTANT_ALPHA_EXT);
	    eval 'sub GL_ONE_MINUS_CONSTANT_ALPHA_EXT () {0x8004;}' unless defined(&GL_ONE_MINUS_CONSTANT_ALPHA_EXT);
	    eval 'sub GL_BLEND_COLOR_EXT () {0x8005;}' unless defined(&GL_BLEND_COLOR_EXT);
	}
	unless(defined(&GL_EXT_polygon_offset)) {
	    eval 'sub GL_EXT_polygon_offset () {1;}' unless defined(&GL_EXT_polygon_offset);
	    eval 'sub GL_POLYGON_OFFSET_EXT () {0x8037;}' unless defined(&GL_POLYGON_OFFSET_EXT);
	    eval 'sub GL_POLYGON_OFFSET_FACTOR_EXT () {0x8038;}' unless defined(&GL_POLYGON_OFFSET_FACTOR_EXT);
	    eval 'sub GL_POLYGON_OFFSET_BIAS_EXT () {0x8039;}' unless defined(&GL_POLYGON_OFFSET_BIAS_EXT);
	}
	unless(defined(&GL_EXT_texture3D)) {
	    eval 'sub GL_EXT_texture3D () {1;}' unless defined(&GL_EXT_texture3D);
	    eval 'sub GL_PACK_SKIP_IMAGES_EXT () {0x806b;}' unless defined(&GL_PACK_SKIP_IMAGES_EXT);
	    eval 'sub GL_PACK_IMAGE_HEIGHT_EXT () {0x806c;}' unless defined(&GL_PACK_IMAGE_HEIGHT_EXT);
	    eval 'sub GL_UNPACK_SKIP_IMAGES_EXT () {0x806d;}' unless defined(&GL_UNPACK_SKIP_IMAGES_EXT);
	    eval 'sub GL_UNPACK_IMAGE_HEIGHT_EXT () {0x806e;}' unless defined(&GL_UNPACK_IMAGE_HEIGHT_EXT);
	    eval 'sub GL_TEXTURE_3D_EXT () {0x806f;}' unless defined(&GL_TEXTURE_3D_EXT);
	    eval 'sub GL_PROXY_TEXTURE_3D_EXT () {0x8070;}' unless defined(&GL_PROXY_TEXTURE_3D_EXT);
	    eval 'sub GL_TEXTURE_DEPTH_EXT () {0x8071;}' unless defined(&GL_TEXTURE_DEPTH_EXT);
	    eval 'sub GL_TEXTURE_WRAP_R_EXT () {0x8072;}' unless defined(&GL_TEXTURE_WRAP_R_EXT);
	    eval 'sub GL_MAX_3D_TEXTURE_SIZE_EXT () {0x8073;}' unless defined(&GL_MAX_3D_TEXTURE_SIZE_EXT);
	    eval 'sub GL_TEXTURE_3D_BINDING_EXT () {0x806a;}' unless defined(&GL_TEXTURE_3D_BINDING_EXT);
	}
	unless(defined(&GL_EXT_texture_object)) {
	    eval 'sub GL_EXT_texture_object () {1;}' unless defined(&GL_EXT_texture_object);
	    eval 'sub GL_TEXTURE_PRIORITY_EXT () {0x8066;}' unless defined(&GL_TEXTURE_PRIORITY_EXT);
	    eval 'sub GL_TEXTURE_RESIDENT_EXT () {0x8067;}' unless defined(&GL_TEXTURE_RESIDENT_EXT);
	    eval 'sub GL_TEXTURE_1D_BINDING_EXT () {0x8068;}' unless defined(&GL_TEXTURE_1D_BINDING_EXT);
	    eval 'sub GL_TEXTURE_2D_BINDING_EXT () {0x8069;}' unless defined(&GL_TEXTURE_2D_BINDING_EXT);
	}
	unless(defined(&GL_EXT_rescale_normal)) {
	    eval 'sub GL_EXT_rescale_normal () {1;}' unless defined(&GL_EXT_rescale_normal);
	    eval 'sub GL_RESCALE_NORMAL_EXT () {0x803a;}' unless defined(&GL_RESCALE_NORMAL_EXT);
	}
	unless(defined(&GL_EXT_vertex_array)) {
	    eval 'sub GL_EXT_vertex_array () {1;}' unless defined(&GL_EXT_vertex_array);
	    eval 'sub GL_VERTEX_ARRAY_EXT () {0x8074;}' unless defined(&GL_VERTEX_ARRAY_EXT);
	    eval 'sub GL_NORMAL_ARRAY_EXT () {0x8075;}' unless defined(&GL_NORMAL_ARRAY_EXT);
	    eval 'sub GL_COLOR_ARRAY_EXT () {0x8076;}' unless defined(&GL_COLOR_ARRAY_EXT);
	    eval 'sub GL_INDEX_ARRAY_EXT () {0x8077;}' unless defined(&GL_INDEX_ARRAY_EXT);
	    eval 'sub GL_TEXTURE_COORD_ARRAY_EXT () {0x8078;}' unless defined(&GL_TEXTURE_COORD_ARRAY_EXT);
	    eval 'sub GL_EDGE_FLAG_ARRAY_EXT () {0x8079;}' unless defined(&GL_EDGE_FLAG_ARRAY_EXT);
	    eval 'sub GL_VERTEX_ARRAY_SIZE_EXT () {0x807a;}' unless defined(&GL_VERTEX_ARRAY_SIZE_EXT);
	    eval 'sub GL_VERTEX_ARRAY_TYPE_EXT () {0x807b;}' unless defined(&GL_VERTEX_ARRAY_TYPE_EXT);
	    eval 'sub GL_VERTEX_ARRAY_STRIDE_EXT () {0x807c;}' unless defined(&GL_VERTEX_ARRAY_STRIDE_EXT);
	    eval 'sub GL_VERTEX_ARRAY_COUNT_EXT () {0x807d;}' unless defined(&GL_VERTEX_ARRAY_COUNT_EXT);
	    eval 'sub GL_NORMAL_ARRAY_TYPE_EXT () {0x807e;}' unless defined(&GL_NORMAL_ARRAY_TYPE_EXT);
	    eval 'sub GL_NORMAL_ARRAY_STRIDE_EXT () {0x807f;}' unless defined(&GL_NORMAL_ARRAY_STRIDE_EXT);
	    eval 'sub GL_NORMAL_ARRAY_COUNT_EXT () {0x8080;}' unless defined(&GL_NORMAL_ARRAY_COUNT_EXT);
	    eval 'sub GL_COLOR_ARRAY_SIZE_EXT () {0x8081;}' unless defined(&GL_COLOR_ARRAY_SIZE_EXT);
	    eval 'sub GL_COLOR_ARRAY_TYPE_EXT () {0x8082;}' unless defined(&GL_COLOR_ARRAY_TYPE_EXT);
	    eval 'sub GL_COLOR_ARRAY_STRIDE_EXT () {0x8083;}' unless defined(&GL_COLOR_ARRAY_STRIDE_EXT);
	    eval 'sub GL_COLOR_ARRAY_COUNT_EXT () {0x8084;}' unless defined(&GL_COLOR_ARRAY_COUNT_EXT);
	    eval 'sub GL_INDEX_ARRAY_TYPE_EXT () {0x8085;}' unless defined(&GL_INDEX_ARRAY_TYPE_EXT);
	    eval 'sub GL_INDEX_ARRAY_STRIDE_EXT () {0x8086;}' unless defined(&GL_INDEX_ARRAY_STRIDE_EXT);
	    eval 'sub GL_INDEX_ARRAY_COUNT_EXT () {0x8087;}' unless defined(&GL_INDEX_ARRAY_COUNT_EXT);
	    eval 'sub GL_TEXTURE_COORD_ARRAY_SIZE_EXT () {0x8088;}' unless defined(&GL_TEXTURE_COORD_ARRAY_SIZE_EXT);
	    eval 'sub GL_TEXTURE_COORD_ARRAY_TYPE_EXT () {0x8089;}' unless defined(&GL_TEXTURE_COORD_ARRAY_TYPE_EXT);
	    eval 'sub GL_TEXTURE_COORD_ARRAY_STRIDE_EXT () {0x808a;}' unless defined(&GL_TEXTURE_COORD_ARRAY_STRIDE_EXT);
	    eval 'sub GL_TEXTURE_COORD_ARRAY_COUNT_EXT () {0x808b;}' unless defined(&GL_TEXTURE_COORD_ARRAY_COUNT_EXT);
	    eval 'sub GL_EDGE_FLAG_ARRAY_STRIDE_EXT () {0x808c;}' unless defined(&GL_EDGE_FLAG_ARRAY_STRIDE_EXT);
	    eval 'sub GL_EDGE_FLAG_ARRAY_COUNT_EXT () {0x808d;}' unless defined(&GL_EDGE_FLAG_ARRAY_COUNT_EXT);
	    eval 'sub GL_VERTEX_ARRAY_POINTER_EXT () {0x808e;}' unless defined(&GL_VERTEX_ARRAY_POINTER_EXT);
	    eval 'sub GL_NORMAL_ARRAY_POINTER_EXT () {0x808f;}' unless defined(&GL_NORMAL_ARRAY_POINTER_EXT);
	    eval 'sub GL_COLOR_ARRAY_POINTER_EXT () {0x8090;}' unless defined(&GL_COLOR_ARRAY_POINTER_EXT);
	    eval 'sub GL_INDEX_ARRAY_POINTER_EXT () {0x8091;}' unless defined(&GL_INDEX_ARRAY_POINTER_EXT);
	    eval 'sub GL_TEXTURE_COORD_ARRAY_POINTER_EXT () {0x8092;}' unless defined(&GL_TEXTURE_COORD_ARRAY_POINTER_EXT);
	    eval 'sub GL_EDGE_FLAG_ARRAY_POINTER_EXT () {0x8093;}' unless defined(&GL_EDGE_FLAG_ARRAY_POINTER_EXT);
	}
	unless(defined(&GL_SGIS_texture_edge_clamp)) {
	    eval 'sub GL_SGIS_texture_edge_clamp () {1;}' unless defined(&GL_SGIS_texture_edge_clamp);
	    eval 'sub GL_CLAMP_TO_EDGE_SGIS () {0x812f;}' unless defined(&GL_CLAMP_TO_EDGE_SGIS);
	}
	unless(defined(&GL_EXT_blend_minmax)) {
	    eval 'sub GL_EXT_blend_minmax () {1;}' unless defined(&GL_EXT_blend_minmax);
	    eval 'sub GL_FUNC_ADD_EXT () {0x8006;}' unless defined(&GL_FUNC_ADD_EXT);
	    eval 'sub GL_MIN_EXT () {0x8007;}' unless defined(&GL_MIN_EXT);
	    eval 'sub GL_MAX_EXT () {0x8008;}' unless defined(&GL_MAX_EXT);
	    eval 'sub GL_BLEND_EQUATION_EXT () {0x8009;}' unless defined(&GL_BLEND_EQUATION_EXT);
	}
	unless(defined(&GL_EXT_blend_subtract)) {
	    eval 'sub GL_EXT_blend_subtract () {1;}' unless defined(&GL_EXT_blend_subtract);
	    eval 'sub GL_FUNC_SUBTRACT_EXT () {0x800a;}' unless defined(&GL_FUNC_SUBTRACT_EXT);
	    eval 'sub GL_FUNC_REVERSE_SUBTRACT_EXT () {0x800b;}' unless defined(&GL_FUNC_REVERSE_SUBTRACT_EXT);
	}
	unless(defined(&GL_EXT_blend_logic_op)) {
	    eval 'sub GL_EXT_blend_logic_op () {1;}' unless defined(&GL_EXT_blend_logic_op);
	}
	unless(defined(&GL_EXT_point_parameters)) {
	    eval 'sub GL_EXT_point_parameters () {1;}' unless defined(&GL_EXT_point_parameters);
	    eval 'sub GL_POINT_SIZE_MIN_EXT () {0x8126;}' unless defined(&GL_POINT_SIZE_MIN_EXT);
	    eval 'sub GL_POINT_SIZE_MAX_EXT () {0x8127;}' unless defined(&GL_POINT_SIZE_MAX_EXT);
	    eval 'sub GL_POINT_FADE_THRESHOLD_SIZE_EXT () {0x8128;}' unless defined(&GL_POINT_FADE_THRESHOLD_SIZE_EXT);
	    eval 'sub GL_DISTANCE_ATTENUATION_EXT () {0x8129;}' unless defined(&GL_DISTANCE_ATTENUATION_EXT);
	}
	unless(defined(&GL_EXT_paletted_texture)) {
	    eval 'sub GL_EXT_paletted_texture () {1;}' unless defined(&GL_EXT_paletted_texture);
	    eval 'sub GL_TABLE_TOO_LARGE_EXT () {0x8031;}' unless defined(&GL_TABLE_TOO_LARGE_EXT);
	    eval 'sub GL_COLOR_TABLE_FORMAT_EXT () {0x80d8;}' unless defined(&GL_COLOR_TABLE_FORMAT_EXT);
	    eval 'sub GL_COLOR_TABLE_WIDTH_EXT () {0x80d9;}' unless defined(&GL_COLOR_TABLE_WIDTH_EXT);
	    eval 'sub GL_COLOR_TABLE_RED_SIZE_EXT () {0x80da;}' unless defined(&GL_COLOR_TABLE_RED_SIZE_EXT);
	    eval 'sub GL_COLOR_TABLE_GREEN_SIZE_EXT () {0x80db;}' unless defined(&GL_COLOR_TABLE_GREEN_SIZE_EXT);
	    eval 'sub GL_COLOR_TABLE_BLUE_SIZE_EXT () {0x80dc;}' unless defined(&GL_COLOR_TABLE_BLUE_SIZE_EXT);
	    eval 'sub GL_COLOR_TABLE_ALPHA_SIZE_EXT () {0x80dd;}' unless defined(&GL_COLOR_TABLE_ALPHA_SIZE_EXT);
	    eval 'sub GL_COLOR_TABLE_LUMINANCE_SIZE_EXT () {0x80de;}' unless defined(&GL_COLOR_TABLE_LUMINANCE_SIZE_EXT);
	    eval 'sub GL_COLOR_TABLE_INTENSITY_SIZE_EXT () {0x80df;}' unless defined(&GL_COLOR_TABLE_INTENSITY_SIZE_EXT);
	    eval 'sub GL_TEXTURE_INDEX_SIZE_EXT () {0x80ed;}' unless defined(&GL_TEXTURE_INDEX_SIZE_EXT);
	    eval 'sub GL_COLOR_INDEX1_EXT () {0x80e2;}' unless defined(&GL_COLOR_INDEX1_EXT);
	    eval 'sub GL_COLOR_INDEX2_EXT () {0x80e3;}' unless defined(&GL_COLOR_INDEX2_EXT);
	    eval 'sub GL_COLOR_INDEX4_EXT () {0x80e4;}' unless defined(&GL_COLOR_INDEX4_EXT);
	    eval 'sub GL_COLOR_INDEX8_EXT () {0x80e5;}' unless defined(&GL_COLOR_INDEX8_EXT);
	    eval 'sub GL_COLOR_INDEX12_EXT () {0x80e6;}' unless defined(&GL_COLOR_INDEX12_EXT);
	    eval 'sub GL_COLOR_INDEX16_EXT () {0x80e7;}' unless defined(&GL_COLOR_INDEX16_EXT);
	}
	unless(defined(&GL_EXT_clip_volume_hint)) {
	    eval 'sub GL_EXT_clip_volume_hint () {1;}' unless defined(&GL_EXT_clip_volume_hint);
	    eval 'sub GL_CLIP_VOLUME_CLIPPING_HINT_EXT () {0x80f0;}' unless defined(&GL_CLIP_VOLUME_CLIPPING_HINT_EXT);
	}
	unless(defined(&GL_EXT_compiled_vertex_array)) {
	    eval 'sub GL_EXT_compiled_vertex_array () {1;}' unless defined(&GL_EXT_compiled_vertex_array);
	    eval 'sub GL_ARRAY_ELEMENT_LOCK_FIRST_EXT () {0x81a8;}' unless defined(&GL_ARRAY_ELEMENT_LOCK_FIRST_EXT);
	    eval 'sub GL_ARRAY_ELEMENT_LOCK_COUNT_EXT () {0x81a9;}' unless defined(&GL_ARRAY_ELEMENT_LOCK_COUNT_EXT);
	}
	unless(defined(&GL_HP_occlusion_test)) {
	    eval 'sub GL_HP_occlusion_test () {1;}' unless defined(&GL_HP_occlusion_test);
	    eval 'sub GL_OCCLUSION_TEST_HP () {0x8165;}' unless defined(&GL_OCCLUSION_TEST_HP);
	    eval 'sub GL_OCCLUSION_TEST_RESULT_HP () {0x8166;}' unless defined(&GL_OCCLUSION_TEST_RESULT_HP);
	}
	unless(defined(&GL_EXT_shared_texture_palette)) {
	    eval 'sub GL_EXT_shared_texture_palette () {1;}' unless defined(&GL_EXT_shared_texture_palette);
	    eval 'sub GL_SHARED_TEXTURE_PALETTE_EXT () {0x81fb;}' unless defined(&GL_SHARED_TEXTURE_PALETTE_EXT);
	}
	unless(defined(&GL_EXT_stencil_wrap)) {
	    eval 'sub GL_EXT_stencil_wrap () {1;}' unless defined(&GL_EXT_stencil_wrap);
	    eval 'sub GL_INCR_WRAP_EXT () {0x8507;}' unless defined(&GL_INCR_WRAP_EXT);
	    eval 'sub GL_DECR_WRAP_EXT () {0x8508;}' unless defined(&GL_DECR_WRAP_EXT);
	}
	unless(defined(&GL_NV_texgen_reflection)) {
	    eval 'sub GL_NV_texgen_reflection () {1;}' unless defined(&GL_NV_texgen_reflection);
	    eval 'sub GL_NORMAL_MAP_NV () {0x8511;}' unless defined(&GL_NORMAL_MAP_NV);
	    eval 'sub GL_REFLECTION_MAP_NV () {0x8512;}' unless defined(&GL_REFLECTION_MAP_NV);
	}
	unless(defined(&GL_EXT_texture_env_add)) {
	    eval 'sub GL_EXT_texture_env_add () {1;}' unless defined(&GL_EXT_texture_env_add);
	}
	unless(defined(&GL_MESA_window_pos)) {
	    eval 'sub GL_MESA_window_pos () {1;}' unless defined(&GL_MESA_window_pos);
	}
	unless(defined(&GL_MESA_resize_bufffers)) {
	    eval 'sub GL_MESA_resize_buffers () {1;}' unless defined(&GL_MESA_resize_buffers);
	}
	unless(defined(&GL_EXT_texture_env_dot3)) {
	    eval 'sub GL_EXT_texture_env_dot3 () {1;}' unless defined(&GL_EXT_texture_env_dot3);
	    eval 'sub GL_DOT3_RGB_EXT () {0x8740;}' unless defined(&GL_DOT3_RGB_EXT);
	    eval 'sub GL_DOT3_RGBA_EXT () {0x8741;}' unless defined(&GL_DOT3_RGBA_EXT);
	}
    } else {
	require 'GL/glext.ph';
    }
    unless(defined(&GL_MESA_trace)) {
	eval 'sub GL_MESA_trace () {1;}' unless defined(&GL_MESA_trace);
	eval 'sub GL_TRACE_ALL_BITS_MESA () {0xffff;}' unless defined(&GL_TRACE_ALL_BITS_MESA);
	eval 'sub GL_TRACE_OPERATIONS_BIT_MESA () {0x1;}' unless defined(&GL_TRACE_OPERATIONS_BIT_MESA);
	eval 'sub GL_TRACE_PRIMITIVES_BIT_MESA () {0x2;}' unless defined(&GL_TRACE_PRIMITIVES_BIT_MESA);
	eval 'sub GL_TRACE_ARRAYS_BIT_MESA () {0x4;}' unless defined(&GL_TRACE_ARRAYS_BIT_MESA);
	eval 'sub GL_TRACE_TEXTURES_BIT_MESA () {0x8;}' unless defined(&GL_TRACE_TEXTURES_BIT_MESA);
	eval 'sub GL_TRACE_PIXELS_BIT_MESA () {0x10;}' unless defined(&GL_TRACE_PIXELS_BIT_MESA);
	eval 'sub GL_TRACE_ERRORS_BIT_MESA () {0x20;}' unless defined(&GL_TRACE_ERRORS_BIT_MESA);
	eval 'sub GL_TRACE_MASK_MESA () {0x8755;}' unless defined(&GL_TRACE_MASK_MESA);
	eval 'sub GL_TRACE_NAME_MESA () {0x8756;}' unless defined(&GL_TRACE_NAME_MESA);
    }
    unless(defined(&GL_MESA_packed_depth_stencil)) {
	eval 'sub GL_MESA_packed_depth_stencil () {1;}' unless defined(&GL_MESA_packed_depth_stencil);
	eval 'sub GL_DEPTH_STENCIL_MESA () {0x8750;}' unless defined(&GL_DEPTH_STENCIL_MESA);
	eval 'sub GL_UNSIGNED_INT_24_8_MESA () {0x8751;}' unless defined(&GL_UNSIGNED_INT_24_8_MESA);
	eval 'sub GL_UNSIGNED_INT_8_24_REV_MESA () {0x8752;}' unless defined(&GL_UNSIGNED_INT_8_24_REV_MESA);
	eval 'sub GL_UNSIGNED_SHORT_15_1_MESA () {0x8753;}' unless defined(&GL_UNSIGNED_SHORT_15_1_MESA);
	eval 'sub GL_UNSIGNED_SHORT_1_15_REV_MESA () {0x8754;}' unless defined(&GL_UNSIGNED_SHORT_1_15_REV_MESA);
    }
    unless(defined(&GL_MESA_ycbcr_texture)) {
	eval 'sub GL_MESA_ycbcr_texture () {1;}' unless defined(&GL_MESA_ycbcr_texture);
	eval 'sub GL_YCBCR_MESA () {0x8757;}' unless defined(&GL_YCBCR_MESA);
	eval 'sub GL_UNSIGNED_SHORT_8_8_MESA () {0x85ba;}' unless defined(&GL_UNSIGNED_SHORT_8_8_MESA);
	eval 'sub GL_UNSIGNED_SHORT_8_8_REV_MESA () {0x85bb;}' unless defined(&GL_UNSIGNED_SHORT_8_8_REV_MESA);
    }
    unless(defined(&GL_MESA_pack_invert)) {
	eval 'sub GL_MESA_pack_invert () {1;}' unless defined(&GL_MESA_pack_invert);
	eval 'sub GL_PACK_INVERT_MESA () {0x8758;}' unless defined(&GL_PACK_INVERT_MESA);
    }
    unless(defined(&GL_APPLE_client_storage)) {
	eval 'sub GL_APPLE_client_storage () {1;}' unless defined(&GL_APPLE_client_storage);
	eval 'sub GL_UNPACK_CLIENT_STORAGE_APPLE () {0x85b2;}' unless defined(&GL_UNPACK_CLIENT_STORAGE_APPLE);
    }
    unless(defined(&GL_APPLE_ycbcr_422)) {
	eval 'sub GL_APPLE_ycbcr_422 () {1;}' unless defined(&GL_APPLE_ycbcr_422);
	eval 'sub GL_YCBCR_422_APPLE () {0x85b9;}' unless defined(&GL_YCBCR_422_APPLE);
	eval 'sub GL_UNSIGNED_SHORT_8_8_APPLE () {0x85ba;}' unless defined(&GL_UNSIGNED_SHORT_8_8_APPLE);
	eval 'sub GL_UNSIGNED_SHORT_8_8_REV_APPLE () {0x85bb;}' unless defined(&GL_UNSIGNED_SHORT_8_8_REV_APPLE);
    }
    if(defined( &PRAGMA_EXPORT_SUPPORTED)) {
    }
    if(defined( &macintosh)  && (defined(&PRAGMA_IMPORT_SUPPORTED) ? &PRAGMA_IMPORT_SUPPORTED : 0)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
