require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XARCH_H_)) {
    eval 'sub _XARCH_H_ () {1;}' unless defined(&_XARCH_H_);
    if(defined(&X_BYTE_ORDER)) {
	eval 'sub X_BIG_ENDIAN () {4321;}' unless defined(&X_BIG_ENDIAN);
	eval 'sub X_LITTLE_ENDIAN () {1234;}' unless defined(&X_LITTLE_ENDIAN);
    } else {
	if(defined( &SVR4)  && !defined( &linux)) {
	    if(defined( &NCR) || defined( &Mips)) {
		require 'sys/endian.ph';
	    } else {
		if(!defined( &sun)  && !defined( &__sgi)) {
		    require 'sys/byteorder.ph';
		}
	    }
	}
 elsif(defined( &CSRG_BASED)) {
	    if(defined( &__NetBSD__) || defined( &__OpenBSD__)) {
		require 'sys/types.ph';
	    }
	    require 'machine/endian.ph';
	}
 elsif(defined( &linux)) {
	    if(defined (defined(&__STRICT_ANSI__) ? &__STRICT_ANSI__ : 0)) {
		undef(&__STRICT_ANSI__) if defined(&__STRICT_ANSI__);
		require 'endian.ph';
		eval 'sub __STRICT_ANSI__ () {1;}' unless defined(&__STRICT_ANSI__);
	    } else {
		require 'endian.ph';
	    }
	    if(!defined( &LITTLE_ENDIAN)  && defined( &__LITTLE_ENDIAN)) {
		eval 'sub LITTLE_ENDIAN () { &__LITTLE_ENDIAN;}' unless defined(&LITTLE_ENDIAN);
	    }
	    if(!defined( &BIG_ENDIAN)  && defined( &__BIG_ENDIAN)) {
		eval 'sub BIG_ENDIAN () { &__BIG_ENDIAN;}' unless defined(&BIG_ENDIAN);
	    }
	    if(!defined( &PDP_ENDIAN)  && defined( &__PDP_ENDIAN)) {
		eval 'sub PDP_ENDIAN () { &__PDP_ENDIAN;}' unless defined(&PDP_ENDIAN);
	    }
	    if(!defined( &BYTE_ORDER)  && defined( &__BYTE_ORDER)) {
		eval 'sub BYTE_ORDER () { &__BYTE_ORDER;}' unless defined(&BYTE_ORDER);
	    }
	}
 elsif(defined( &Lynx)) {
	    if(0) {
		require 'bsd/in.ph';
		require 'bsd/in_systm.ph';
		require 'bsd/ip.ph';
	    }
	}
	unless(defined(&BYTE_ORDER)) {
	    eval 'sub LITTLE_ENDIAN () {1234;}' unless defined(&LITTLE_ENDIAN);
	    eval 'sub BIG_ENDIAN () {4321;}' unless defined(&BIG_ENDIAN);
	    if(defined( &__QNX__)  && !defined( &__QNXNTO__)) {
		eval 'sub BYTE_ORDER () { &LITTLE_ENDIAN;}' unless defined(&BYTE_ORDER);
	    }
	    if(defined( &__QNXNTO__)) {
		if(defined( &i386) || defined( &__i386__) || defined( &__x86__)) {
		    eval 'sub BYTE_ORDER () { &LITTLE_ENDIAN;}' unless defined(&BYTE_ORDER);
		} else {
		    eval 'sub BYTE_ORDER () { &BIG_ENDIAN;}' unless defined(&BYTE_ORDER);
		}
	    }
	    if(defined(&Lynx)) {
		if(defined( &i386) || defined( &__i386__) || defined( &__x86__)) {
		    eval 'sub BYTE_ORDER () { &LITTLE_ENDIAN;}' unless defined(&BYTE_ORDER);
		} else {
		    eval 'sub BYTE_ORDER () { &BIG_ENDIAN;}' unless defined(&BYTE_ORDER);
		}
	    }
	    if((defined( &sun)  && defined( &SVR4))  && !defined( &Lynx)) {
		require 'sys/isa_defs.ph';
		if(defined(&_LITTLE_ENDIAN)) {
		    eval 'sub BYTE_ORDER () { &LITTLE_ENDIAN;}' unless defined(&BYTE_ORDER);
		}
		if(defined(&_BIG_ENDIAN)) {
		    eval 'sub BYTE_ORDER () { &BIG_ENDIAN;}' unless defined(&BYTE_ORDER);
		}
	    }
	}
	eval 'sub X_BYTE_ORDER () { &BYTE_ORDER;}' unless defined(&X_BYTE_ORDER);
	eval 'sub X_BIG_ENDIAN () { &BIG_ENDIAN;}' unless defined(&X_BIG_ENDIAN);
	eval 'sub X_LITTLE_ENDIAN () { &LITTLE_ENDIAN;}' unless defined(&X_LITTLE_ENDIAN);
    }
}
1;
