require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XFT_H_)) {
    eval 'sub _XFT_H_ () {1;}' unless defined(&_XFT_H_);
    eval 'sub XFT_MAJOR () {2;}' unless defined(&XFT_MAJOR);
    eval 'sub XFT_MINOR () {1;}' unless defined(&XFT_MINOR);
    eval 'sub XFT_REVISION () {2;}' unless defined(&XFT_REVISION);
    eval 'sub XFT_VERSION () {(( &XFT_MAJOR * 10000) + ( &XFT_MINOR * 100) + ( &XFT_REVISION));}' unless defined(&XFT_VERSION);
    eval 'sub XftVersion () { &XFT_VERSION;}' unless defined(&XftVersion);
    require 'stdarg.ph';
    require 'ft2build.ph';
    require 'fontconfig/fontconfig.ph';
    require 'X11/extensions/Xrender.ph';
    require 'X11/Xfuncproto.ph';
    unless(defined(&_XFT_NO_COMPAT_)) {
	require 'X11/Xft/XftCompat.ph';
    }
    eval 'sub XFT_CORE () {"core";}' unless defined(&XFT_CORE);
    eval 'sub XFT_RENDER () {"render";}' unless defined(&XFT_RENDER);
    eval 'sub XFT_XLFD () {"xlfd";}' unless defined(&XFT_XLFD);
    eval 'sub XFT_MAX_GLYPH_MEMORY () {"maxglyphmemory";}' unless defined(&XFT_MAX_GLYPH_MEMORY);
    eval 'sub XFT_MAX_UNREF_FONTS () {"maxunreffonts";}' unless defined(&XFT_MAX_UNREF_FONTS);
    eval 'sub XFT_NMISSING () {256;}' unless defined(&XFT_NMISSING);
}
1;
