require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XOS_R_H_)) {
    eval 'sub _XOS_R_H_ () {1;}' unless defined(&_XOS_R_H_);
    require 'X11/Xos.ph';
    require 'X11/Xfuncs.ph';
    unless(defined(&X_NOT_POSIX)) {
	if(defined(&_POSIX_SOURCE)) {
	    require 'limits.ph';
	} else {
	    eval 'sub _POSIX_SOURCE () {1;}' unless defined(&_POSIX_SOURCE);
	    require 'limits.ph';
	    undef(&_POSIX_SOURCE) if defined(&_POSIX_SOURCE);
	}
	unless(defined(&LINE_MAX)) {
	    eval 'sub X_LINE_MAX () {2048;}' unless defined(&X_LINE_MAX);
	} else {
	    eval 'sub X_LINE_MAX () { &LINE_MAX;}' unless defined(&X_LINE_MAX);
	}
    }
}
unless(defined(&WIN32)) {
    if(defined(&__cplusplus)) {
    }
    if(defined( &XOS_USE_XLIB_LOCKING)) {
	unless(defined(&XAllocIDs)) {
	}
	unless(defined(&_Xos_isThreadInitialized)) {
	    eval 'sub _Xos_isThreadInitialized () {( &_Xglobal_lock);}' unless defined(&_Xos_isThreadInitialized);
	}
	if(defined( &XTHREADS_WARN) || defined( &XTHREADS_FILE_LINE)) {
	    unless(defined(&XAllocIDs)) {
		require 'X11/Xfuncproto.ph';
		if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
		}
		if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
		}
	    }
	    unless(defined(&_Xos_processLock)) {
		eval 'sub _Xos_processLock () {( &_XLockMutex_fn ? (* &_XLockMutex_fn)( &_Xglobal_lock, &__FILE__, &__LINE__) : 0);}' unless defined(&_Xos_processLock);
	    }
	    unless(defined(&_Xos_processUnlock)) {
		eval 'sub _Xos_processUnlock () {( &_XUnlockMutex_fn ? (* &_XUnlockMutex_fn)( &_Xglobal_lock, &__FILE__, &__LINE__) : 0);}' unless defined(&_Xos_processUnlock);
	    }
	} else {
	    unless(defined(&XAllocIDs)) {
		require 'X11/Xfuncproto.ph';
		if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
		}
		if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
		}
	    }
	    unless(defined(&_Xos_processLock)) {
		eval 'sub _Xos_processLock () {( &_XLockMutex_fn ? ((* &_XLockMutex_fn)( &_Xglobal_lock), 0) : 0);}' unless defined(&_Xos_processLock);
	    }
	    unless(defined(&_Xos_processUnlock)) {
		eval 'sub _Xos_processUnlock () {( &_XUnlockMutex_fn ? ((* &_XUnlockMutex_fn)( &_Xglobal_lock), 0) : 0);}' unless defined(&_Xos_processUnlock);
	    }
	}
    }
 elsif(defined( &XOS_USE_XT_LOCKING)) {
	unless(defined(&_XtThreadsI_h)) {
	}
	unless(defined(&_XtintrinsicP_h)) {
	    require 'X11/Xfuncproto.ph';
	    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	    }
	    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	    }
	}
	unless(defined(&_Xos_isThreadInitialized)) {
	    eval 'sub _Xos_isThreadInitialized () { &_XtProcessLock;}' unless defined(&_Xos_isThreadInitialized);
	}
	unless(defined(&_Xos_processLock)) {
	    eval 'sub _Xos_processLock () { &XtProcessLock();}' unless defined(&_Xos_processLock);
	}
	unless(defined(&_Xos_processUnlock)) {
	    eval 'sub _Xos_processUnlock () { &XtProcessUnlock();}' unless defined(&_Xos_processUnlock);
	}
    }
 elsif(defined( &XOS_USE_NO_LOCKING)) {
	unless(defined(&_Xos_isThreadInitialized)) {
	    eval 'sub _Xos_isThreadInitialized () {0;}' unless defined(&_Xos_isThreadInitialized);
	}
	unless(defined(&_Xos_processLock)) {
	    eval 'sub _Xos_processLock () {0;}' unless defined(&_Xos_processLock);
	}
	unless(defined(&_Xos_processUnlock)) {
	    eval 'sub _Xos_processUnlock () {0;}' unless defined(&_Xos_processUnlock);
	}
    }
}
if(defined( &sun)  && defined( &_POSIX_THREAD_SAFE_FUNCTIONS)) {
    undef(&_POSIX_THREAD_SAFE_FUNCTIONS) if defined(&_POSIX_THREAD_SAFE_FUNCTIONS);
}
if(defined( &Lynx)  && defined( &_POSIX_THREAD_SAFE_FUNCTIONS)) {
    undef(&_POSIX_THREAD_SAFE_FUNCTIONS) if defined(&_POSIX_THREAD_SAFE_FUNCTIONS);
}
if(defined( &X_INCLUDE_PWD_H)  && !defined( &_XOS_INCLUDED_PWD_H)) {
    require 'pwd.ph';
    if(defined( &XUSE_MTSAFE_API) || defined( &XUSE_MTSAFE_PWDAPI)) {
	eval 'sub XOS_USE_MTSAFE_PWDAPI () {1;}' unless defined(&XOS_USE_MTSAFE_PWDAPI);
    }
}
undef(&X_NEEDS_PWPARAMS) if defined(&X_NEEDS_PWPARAMS);
if(!defined( &X_INCLUDE_PWD_H) || defined( &_XOS_INCLUDED_PWD_H)) {
}
 elsif(!defined( &XTHREADS)  && !defined( &X_FORCE_USE_MTSAFE_API)) {
    if(defined( &X_NOT_POSIX)  && !defined( &i386)  && !defined( &SYSV)) {
    }
    eval 'sub _XGetpwuid {
        my($u,$p) = @_;
	    eval q( &getpwuid(($u)));
    }' unless defined(&_XGetpwuid);
    eval 'sub _XGetpwnam {
        my($u,$p) = @_;
	    eval q( &getpwnam(($u)));
    }' unless defined(&_XGetpwnam);
}
 elsif(!defined( &XOS_USE_MTSAFE_PWDAPI) || defined( &XNO_MTSAFE_PWDAPI)) {
    eval 'sub X_NEEDS_PWPARAMS () {1;}' unless defined(&X_NEEDS_PWPARAMS);
    if(defined( &__NetBSD__) || defined( &__FreeBSD__) || defined( &__OpenBSD__) || defined( &__APPLE__)) {
	eval 'sub _Xpw_copyPasswd {
	    my($p) = @_;
    	    eval q({  &memcpy(($p). &pws, ($p). &pwp, $sizeof{\'struct passwd\'}); ($p). ($pws->{pw_name}) = ($p). &pwbuf; ($p). &len =  &strlen(($p). ($pwp->{pw_name}));  &strcpy(($p). ($pws->{pw_name}), ($p). ($pwp->{pw_name})); ($p). ($pws->{pw_passwd}) = ($p). ($pws->{pw_name}) + ($p). &len + 1; ($p). &len =  &strlen(($p). ($pwp->{pw_passwd}));  &strcpy(($p). ($pws->{pw_passwd}),($p). ($pwp->{pw_passwd})); ($p). ($pws->{pw_class}) = ($p). ($pws->{pw_passwd}) + ($p). &len + 1; ($p). &len =  &strlen(($p). ($pwp->{pw_class}));  &strcpy(($p). ($pws->{pw_class}), ($p). ($pwp->{pw_class})); ($p). ($pws->{pw_gecos}) = ($p). ($pws->{pw_class}) + ($p). &len + 1; ($p). &len =  &strlen(($p). ($pwp->{pw_gecos}));  &strcpy(($p). ($pws->{pw_gecos}), ($p). ($pwp->{pw_gecos})); ($p). ($pws->{pw_dir}) = ($p). ($pws->{pw_gecos}) + ($p). &len + 1; ($p). &len =  &strlen(($p). ($pwp->{pw_dir}));  &strcpy(($p). ($pws->{pw_dir}), ($p). ($pwp->{pw_dir})); ($p). ($pws->{pw_shell}) = ($p). ($pws->{pw_dir}) + ($p). &len + 1; ($p). &len =  &strlen(($p). ($pwp->{pw_shell}));  &strcpy(($p). ($pws->{pw_shell}), ($p). ($pwp->{pw_shell})); ($p). &pwp = ($p). &pws; });
	}' unless defined(&_Xpw_copyPasswd);
    } else {
	eval 'sub _Xpw_copyPasswd {
	    my($p) = @_;
    	    eval q(( &memcpy(($p). &pws, ($p). &pwp, $sizeof{\'struct passwd\'}), (($p). ($pws->{pw_name}) = ($p). &pwbuf), (($p). &len =  &strlen(($p). ($pwp->{pw_name}))),  &strcpy(($p). ($pws->{pw_name}), ($p). ($pwp->{pw_name})), (($p). ($pws->{pw_passwd}) = ($p). ($pws->{pw_name}) + ($p). &len + 1), (($p). &len =  &strlen(($p). ($pwp->{pw_passwd}))),  &strcpy(($p). ($pws->{pw_passwd}),($p). ($pwp->{pw_passwd})), (($p). ($pws->{pw_age}) = ($p). ($pws->{pw_passwd}) + ($p). &len + 1), (($p). &len =  &strlen(($p). ($pwp->{pw_age}))),  &strcpy(($p). ($pws->{pw_age}), ($p). ($pwp->{pw_age})), (($p). ($pws->{pw_comment}) = ($p). ($pws->{pw_age}) + ($p). &len + 1), (($p). &len =  &strlen(($p). ($pwp->{pw_comment}))),  &strcpy(($p). ($pws->{pw_comment}), ($p). ($pwp->{pw_comment})), (($p). ($pws->{pw_gecos}) = ($p). ($pws->{pw_comment}) + ($p). &len + 1), (($p). &len =  &strlen(($p). ($pwp->{pw_gecos}))),  &strcpy(($p). ($pws->{pw_gecos}), ($p). ($pwp->{pw_gecos})), (($p). ($pws->{pw_dir}) = ($p). ($pws->{pw_comment}) + ($p). &len + 1), (($p). &len =  &strlen(($p). ($pwp->{pw_dir}))),  &strcpy(($p). ($pws->{pw_dir}), ($p). ($pwp->{pw_dir})), (($p). ($pws->{pw_shell}) = ($p). ($pws->{pw_dir}) + ($p). &len + 1), (($p). &len =  &strlen(($p). ($pwp->{pw_shell}))),  &strcpy(($p). ($pws->{pw_shell}), ($p). ($pwp->{pw_shell})), (($p). &pwp = ($p). &pws), 0));
	}' unless defined(&_Xpw_copyPasswd);
    }
    eval 'sub _XGetpwuid {
        my($u,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &pwp =  &getpwuid(($u))) ?  &_Xpw_copyPasswd($p), 0: 0), ( &_Xos_processUnlock), ($p). &pwp ));
    }' unless defined(&_XGetpwuid);
    eval 'sub _XGetpwnam {
        my($u,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &pwp =  &getpwnam(($u))) ?  &_Xpw_copyPasswd($p), 0: 0), ( &_Xos_processUnlock), ($p). &pwp ));
    }' unless defined(&_XGetpwnam);
}
 elsif(!defined( &_POSIX_THREAD_SAFE_FUNCTIONS)  && !defined( &__APPLE__)) {
    eval 'sub X_NEEDS_PWPARAMS () {1;}' unless defined(&X_NEEDS_PWPARAMS);
    if(defined( &_POSIX_REENTRANT_FUNCTIONS) || !defined( &SVR4) || defined( &Lynx)) {
	unless(defined(&Lynx)) {
	    eval 'sub _XGetpwuid {
	        my($u,$p) = @_;
    		eval q((( &getpwuid_r(($u),($p). &pws,($p). &pwbuf,$sizeof{($p). &pwbuf}) == -1) ?  &NULL : ($p). &pws));
	    }' unless defined(&_XGetpwuid);
	    eval 'sub _XGetpwnam {
	        my($u,$p) = @_;
    		eval q((( &getpwnam_r(($u),($p). &pws,($p). &pwbuf,$sizeof{($p). &pwbuf}) == -1) ?  &NULL : ($p). &pws));
	    }' unless defined(&_XGetpwnam);
	} else {
	    eval 'sub _XGetpwuid {
	        my($u,$p) = @_;
    		eval q((( &getpwuid_r(($p). &pws,($u),($p). &pwbuf,$sizeof{($p). &pwbuf}) == -1) ?  &NULL : ($p). &pws));
	    }' unless defined(&_XGetpwuid);
	    eval 'sub _XGetpwnam {
	        my($u,$p) = @_;
    		eval q((( &getpwnam_r(($p). &pws,($u),($p). &pwbuf,$sizeof{($p). &pwbuf}) == -1) ?  &NULL : ($p). &pws));
	    }' unless defined(&_XGetpwnam);
	}
    } else {
	eval 'sub _XGetpwuid {
	    my($u,$p) = @_;
    	    eval q((( &getpwuid_r(($u),($p). &pws,($p). &pwbuf,$sizeof{($p). &pwbuf}) ==  &NULL) ?  &NULL : ($p). &pws));
	}' unless defined(&_XGetpwuid);
	eval 'sub _XGetpwnam {
	    my($u,$p) = @_;
    	    eval q((( &getpwnam_r(($u),($p). &pws,($p). &pwbuf,$sizeof{($p). &pwbuf}) ==  &NULL) ?  &NULL : ($p). &pws));
	}' unless defined(&_XGetpwnam);
    }
} else {
    if(defined( &__osf__)) {
    }
    eval 'sub X_NEEDS_PWPARAMS () {1;}' unless defined(&X_NEEDS_PWPARAMS);
    eval 'sub _XGetpwuid {
        my($u,$p) = @_;
	    eval q((( &getpwuid_r(($u),($p). &pws,($p). &pwbuf,$sizeof{($p). &pwbuf},($p). &pwp) == -1) ?  &NULL : ($p). &pwp));
    }' unless defined(&_XGetpwuid);
    eval 'sub _XGetpwnam {
        my($u,$p) = @_;
	    eval q((( &getpwnam_r(($u),($p). &pws,($p). &pwbuf,$sizeof{($p). &pwbuf},($p). &pwp) == -1) ?  &NULL : ($p). &pwp));
    }' unless defined(&_XGetpwnam);
}
if(defined( &X_INCLUDE_PWD_H)  && !defined( &_XOS_INCLUDED_PWD_H)) {
    eval 'sub _XOS_INCLUDED_PWD_H () {1;}' unless defined(&_XOS_INCLUDED_PWD_H);
}
undef(&XTHREADS_NEEDS_BYNAMEPARAMS) if defined(&XTHREADS_NEEDS_BYNAMEPARAMS);
if(defined( &X_INCLUDE_NETDB_H)  && !defined( &_XOS_INCLUDED_NETDB_H)  && !defined( &WIN32)) {
    require 'netdb.ph';
    if(defined( &XUSE_MTSAFE_API) || defined( &XUSE_MTSAFE_NETDBAPI)) {
	eval 'sub XOS_USE_MTSAFE_NETDBAPI () {1;}' unless defined(&XOS_USE_MTSAFE_NETDBAPI);
    }
}
if(!defined( &X_INCLUDE_NETDB_H) || defined( &_XOS_INCLUDED_NETDB_H)) {
}
 elsif(!defined( &XTHREADS)  && !defined( &X_FORCE_USE_MTSAFE_API)) {
    eval 'sub _XGethostbyname {
        my($h,$hp) = @_;
	    eval q( &gethostbyname(($h)));
    }' unless defined(&_XGethostbyname);
    eval 'sub _XGethostbyaddr {
        my($a,$al,$t,$hp) = @_;
	    eval q( &gethostbyaddr(($a),($al),($t)));
    }' unless defined(&_XGethostbyaddr);
    eval 'sub _XGetservbyname {
        my($s,$p,$sp) = @_;
	    eval q( &getservbyname(($s),($p)));
    }' unless defined(&_XGetservbyname);
}
 elsif(!defined( &XOS_USE_MTSAFE_NETDBAPI) || defined( &XNO_MTSAFE_NETDBAPI)) {
    if(defined( &__NetBSD__) || defined( &__FreeBSD__)) {
	require 'sys/param.ph';
    }
    eval 'sub XTHREADS_NEEDS_BYNAMEPARAMS () {1;}' unless defined(&XTHREADS_NEEDS_BYNAMEPARAMS);
    eval 'sub _Xg_copyHostent {
        my($hp) = @_;
	    eval q(( &memcpy(($hp). &hent, ($hp). &hptr, $sizeof{\'struct hostent\'}),  &strcpy(($hp). &h_name, ($hp). ($hptr->{h_name})), (($hp). ($hent->{h_name}) = ($hp). &h_name), (($hp). &hptr = ($hp). &hent), 0));
    }' unless defined(&_Xg_copyHostent);
    eval 'sub _Xg_copyServent {
        my($sp) = @_;
	    eval q(( &memcpy(($sp). &sent, ($sp). &sptr, $sizeof{\'struct servent\'}),  &strcpy(($sp). &s_name, ($sp). ($sptr->{s_name})), (($sp). ($sent->{s_name}) = ($sp). &s_name),  &strcpy(($sp). &s_proto, ($sp). ($sptr->{s_proto})), (($sp). ($sent->{s_proto}) = ($sp). &s_proto), (($sp). &sptr = ($sp). &sent), 0));
    }' unless defined(&_Xg_copyServent);
    eval 'sub _XGethostbyname {
        my($h,$hp) = @_;
	    eval q((( &_Xos_processLock), ((($hp). &hptr =  &gethostbyname(($h))) ?  &_Xg_copyHostent($hp) : 0), ( &_Xos_processUnlock), ($hp). &hptr ));
    }' unless defined(&_XGethostbyname);
    eval 'sub _XGethostbyaddr {
        my($a,$al,$t,$hp) = @_;
	    eval q((( &_Xos_processLock), ((($hp). &hptr =  &gethostbyaddr(($a),($al),($t))) ?  &_Xg_copyHostent($hp) : 0), ( &_Xos_processUnlock), ($hp). &hptr ));
    }' unless defined(&_XGethostbyaddr);
    eval 'sub _XGetservbyname {
        my($s,$p,$sp) = @_;
	    eval q((( &_Xos_processLock), ((($sp). &sptr =  &getservbyname(($s),($p))) ?  &_Xg_copyServent($sp) : 0), ( &_Xos_processUnlock), ($sp). &sptr ));
    }' unless defined(&_XGetservbyname);
}
 elsif(defined( &XUSE_NETDB_R_API)) {
    if(defined(&_POSIX_REENTRANT_FUNCTIONS)) {
	unless(defined(&_POSIX_THREAD_SAFE_FUNCTIONS)) {
	    if(defined( &AIXV3) || defined( &AIXV4) || defined( &__osf__)) {
		eval 'sub X_POSIX_THREAD_SAFE_FUNCTIONS () {1;}' unless defined(&X_POSIX_THREAD_SAFE_FUNCTIONS);
	    }
	}
    }
    if(defined(&_POSIX_THREAD_SAFE_FUNCTIONS)) {
	eval 'sub X_POSIX_THREAD_SAFE_FUNCTIONS () {1;}' unless defined(&X_POSIX_THREAD_SAFE_FUNCTIONS);
    }
    eval 'sub XTHREADS_NEEDS_BYNAMEPARAMS () {1;}' unless defined(&XTHREADS_NEEDS_BYNAMEPARAMS);
    unless(defined(&X_POSIX_THREAD_SAFE_FUNCTIONS)) {
	eval 'sub _XGethostbyname {
	    my($h,$hp) = @_;
    	    eval q( &gethostbyname_r(($h),($hp). &hent,($hp). &hbuf,$sizeof{($hp). &hbuf},($hp). &herr));
	}' unless defined(&_XGethostbyname);
	eval 'sub _XGethostbyaddr {
	    my($a,$al,$t,$hp) = @_;
    	    eval q( &gethostbyaddr_r(($a),($al),($t),($hp). &hent,($hp). &hbuf,$sizeof{($hp). &hbuf},($hp). &herr));
	}' unless defined(&_XGethostbyaddr);
	eval 'sub _XGetservbyname {
	    my($s,$p,$sp) = @_;
    	    eval q( &getservbyname_r(($s),($p),($sp). &sent,($sp). &sbuf,$sizeof{($sp). &sbuf}));
	}' unless defined(&_XGetservbyname);
    } else {
	eval 'sub _XGethostbyname {
	    my($h,$hp) = @_;
    	    eval q(( &bzero(($hp). &hdata,$sizeof{($hp). &hdata}), (( &gethostbyname_r(($h),($hp). &hent,($hp). &hdata) == -1) ?  &NULL : ($hp). &hent)));
	}' unless defined(&_XGethostbyname);
	eval 'sub _XGethostbyaddr {
	    my($a,$al,$t,$hp) = @_;
    	    eval q(( &bzero(($hp). &hdata,$sizeof{($hp). &hdata}), (( &gethostbyaddr_r(($a),($al),($t),($hp). &hent,($hp). &hdata) == -1) ?  &NULL : ($hp). &hent)));
	}' unless defined(&_XGethostbyaddr);
	eval 'sub _XGetservbyname {
	    my($s,$p,$sp) = @_;
    	    eval q(( &bzero(($sp). &sdata,$sizeof{($sp). &sdata}), (( &getservbyname_r(($s),($p),($sp). &sent,($sp). &sdata) == -1) ?  &NULL : ($sp). &sent) ));
	}' unless defined(&_XGetservbyname);
    }
    if(defined(&X_POSIX_THREAD_SAFE_FUNCTIONS)) {
	undef(&X_POSIX_THREAD_SAFE_FUNCTIONS) if defined(&X_POSIX_THREAD_SAFE_FUNCTIONS);
    }
} else {
    eval 'sub _XGethostbyname {
        my($h,$hp) = @_;
	    eval q( &gethostbyname(($h)));
    }' unless defined(&_XGethostbyname);
    eval 'sub _XGethostbyaddr {
        my($a,$al,$t,$hp) = @_;
	    eval q( &gethostbyaddr(($a),($al),($t)));
    }' unless defined(&_XGethostbyaddr);
    eval 'sub _XGetservbyname {
        my($s,$p,$sp) = @_;
	    eval q( &getservbyname(($s),($p)));
    }' unless defined(&_XGetservbyname);
}
if(defined( &X_INCLUDE_NETDB_H)  && !defined( &_XOS_INCLUDED_NETDB_H)) {
    eval 'sub _XOS_INCLUDED_NETDB_H () {1;}' unless defined(&_XOS_INCLUDED_NETDB_H);
}
if(defined( &X_INCLUDE_DIRENT_H)  && !defined( &_XOS_INCLUDED_DIRENT_H)) {
    require 'sys/types.ph';
    if(!defined( &X_NOT_POSIX) || defined( &SYSV) || defined( &USG)) {
	require 'dirent.ph';
    } else {
	require 'sys/dir.ph';
	unless(defined(&dirent)) {
	    eval 'sub dirent () { &direct;}' unless defined(&dirent);
	}
    }
    if(defined( &XUSE_MTSAFE_API) || defined( &XUSE_MTSAFE_DIRENTAPI)) {
	eval 'sub XOS_USE_MTSAFE_DIRENTAPI () {1;}' unless defined(&XOS_USE_MTSAFE_DIRENTAPI);
    }
}
if(!defined( &X_INCLUDE_DIRENT_H) || defined( &_XOS_INCLUDED_DIRENT_H)) {
}
 elsif(!defined( &XTHREADS)  && !defined( &X_FORCE_USE_MTSAFE_API)) {
    eval 'sub _XReaddir {
        my($d,$p) = @_;
	    eval q( &readdir($d));
    }' unless defined(&_XReaddir);
}
 elsif(!defined( &XOS_USE_MTSAFE_DIRENTAPI) || defined( &XNO_MTSAFE_DIRENTAPI)) {
    if(defined(&_POSIX_PATH_MAX)) {
    }
 elsif(defined( &NAME_MAX)) {
    } else {
    }
    eval 'sub _XReaddir {
        my($d,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &result =  &readdir(($d))) ? ( &memcpy((($p). &dir_entry), ($p). &result, ($p). ($result->{d_reclen})), (($p). &result = ($p). &dir_entry), 0) : 0), ( &_Xos_processUnlock), ($p). &result ));
    }' unless defined(&_XReaddir);
} else {
    if(defined(&_POSIX_PATH_MAX)) {
    }
 elsif(defined( &NAME_MAX)) {
    } else {
    }
    if(defined( &_POSIX_THREAD_SAFE_FUNCTIONS) || defined( &AIXV3) || defined( &AIXV4) || defined( &__APPLE__)) {
	if(defined( &__osf__)) {
	}
	eval 'sub _XReaddir {
	    my($d,$p) = @_;
    	    eval q(( &readdir_r(($d), (($p). &dir_entry), (($p). &result)) ?  &NULL : ($p). &result));
	}' unless defined(&_XReaddir);
    }
 elsif(defined( &_POSIX_REENTRANT_FUNCTIONS)  && defined( &__osf__)) {
	eval 'sub _XReaddir {
	    my($d,$p) = @_;
    	    eval q(( ( &_Xos_isThreadInitialized) ? ( &readdir_r(($d), (($p). &dir_entry)) ?  &NULL : (($p). &dir_entry)) : (( &_Xos_processLock), ((($p). &result =  &readdir(($d))) ? ( &memcpy((($p). &dir_entry), ($p). &result, ($p). ($result->{d_reclen})), (($p). &result = ($p). &dir_entry), 0) : 0), ( &_Xos_processUnlock), ($p). &result) ));
	}' unless defined(&_XReaddir);
    }
 elsif(defined( &_POSIX_REENTRANT_FUNCTIONS)) {
	eval 'sub _XReaddir {
	    my($d,$p) = @_;
    	    eval q(( &readdir_r(($d),(($p). &dir_entry)) ?  &NULL : (($p). &dir_entry)));
	}' unless defined(&_XReaddir);
    }
 elsif(defined( &SVR4)) {
	eval 'sub _XReaddir {
	    my($d,$p) = @_;
    	    eval q(( &readdir_r(($d), ($p). &dir_entry)));
	}' unless defined(&_XReaddir);
    } else {
	eval 'sub _XReaddir {
	    my($d,$p) = @_;
    	    eval q(( ( &_Xos_processLock), ((($p). &result =  &readdir(($d))) ? ( &memcpy((($p). &dir_entry), ($p). &result, ($p). ($result->{d_reclen})), (($p). &result = ($p). &dir_entry), 0) : 0), ( &_Xos_processUnlock), ($p). &result ));
	}' unless defined(&_XReaddir);
    }
}
if(defined( &X_INCLUDE_DIRENT_H)  && !defined( &_XOS_INCLUDED_DIRENT_H)) {
    eval 'sub _XOS_INCLUDED_DIRENT_H () {1;}' unless defined(&_XOS_INCLUDED_DIRENT_H);
}
if(defined( &X_INCLUDE_UNISTD_H)  && !defined( &_XOS_INCLUDED_UNISTD_H)) {
    if(defined( &XUSE_MTSAFE_API) || defined( &XUSE_MTSAFE_UNISTDAPI)) {
	eval 'sub XOS_USE_MTSAFE_UNISTDAPI () {1;}' unless defined(&XOS_USE_MTSAFE_UNISTDAPI);
    }
}
if(!defined( &X_INCLUDE_UNISTD_H) || defined( &_XOS_INCLUDED_UNISTD_H)) {
}
 elsif(!defined( &XTHREADS)  && !defined( &X_FORCE_USE_MTSAFE_API)) {
    eval 'sub _XGetlogin {
        my($p) = @_;
	    eval q( &getlogin());
    }' unless defined(&_XGetlogin);
    eval 'sub _XTtyname {
        my($f) = @_;
	    eval q( &ttyname(($f)));
    }' unless defined(&_XTtyname);
}
 elsif(!defined( &XOS_USE_MTSAFE_UNISTDAPI) || defined( &XNO_MTSAFE_UNISTDAPI)) {
    if(defined( &MAXLOGNAME)) {
    }
 elsif(defined( &LOGIN_NAME_MAX)) {
    } else {
    }
    if(defined(&TTY_NAME_MAX)) {
    }
 elsif(defined( &_POSIX_TTY_NAME_MAX)) {
    }
 elsif(defined( &_POSIX_PATH_MAX)) {
    } else {
    }
    eval 'sub _XGetlogin {
        my($p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &result =  &getlogin()) ? ( &strncpy(($p). &buf, ($p). &result, $sizeof{($p). &buf}), (($p). $buf[$sizeof{($p). &buf}-1] = ord(\'\\\\0\')), (($p). &result = ($p). &buf), 0) : 0), ( &_Xos_processUnlock), ($p). &result ));
    }' unless defined(&_XGetlogin);
    eval 'sub _XTtyname {
        my($f,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &result =  &ttyname($f)) ? ( &strncpy(($p). &buf, ($p). &result, $sizeof{($p). &buf}), (($p). $buf[$sizeof{($p). &buf}-1] = ord(\'\\\\0\')), (($p). &result = ($p). &buf), 0) : 0), ( &_Xos_processUnlock), ($p). &result ));
    }' unless defined(&_XTtyname);
}
 elsif(defined( &_POSIX_THREAD_SAFE_FUNCTIONS) || defined( &_POSIX_REENTRANT_FUNCTIONS)) {
    if(defined( &MAXLOGNAME)) {
    }
 elsif(defined( &LOGIN_NAME_MAX)) {
    } else {
    }
    if(defined(&TTY_NAME_MAX)) {
    }
 elsif(defined( &_POSIX_TTY_NAME_MAX)) {
    }
 elsif(defined( &_POSIX_PATH_MAX)) {
    } else {
    }
    eval 'sub _XGetlogin {
        my($p) = @_;
	    eval q(( &getlogin_r(($p). &buf, $sizeof{($p). &buf}) ?  &NULL : ($p). &buf));
    }' unless defined(&_XGetlogin);
    eval 'sub _XTtyname {
        my($f,$p) = @_;
	    eval q(( &ttyname_r(($f), ($p). &buf, $sizeof{($p). &buf}) ?  &NULL : ($p). &buf));
    }' unless defined(&_XTtyname);
} else {
    if(defined( &MAXLOGNAME)) {
    }
 elsif(defined( &LOGIN_NAME_MAX)) {
    } else {
    }
    if(defined(&TTY_NAME_MAX)) {
    }
 elsif(defined( &_POSIX_TTY_NAME_MAX)) {
    }
 elsif(defined( &_POSIX_PATH_MAX)) {
    } else {
    }
    eval 'sub _XGetlogin {
        my($p) = @_;
	    eval q( &getlogin_r(($p). &buf, $sizeof{($p). &buf}));
    }' unless defined(&_XGetlogin);
    eval 'sub _XTtyname {
        my($f,$p) = @_;
	    eval q( &ttyname_r(($f), ($p). &buf, $sizeof{($p). &buf}));
    }' unless defined(&_XTtyname);
}
if(defined( &X_INCLUDE_UNISTD_H)  && !defined( &_XOS_INCLUDED_UNISTD_H)) {
    eval 'sub _XOS_INCLUDED_UNISTD_H () {1;}' unless defined(&_XOS_INCLUDED_UNISTD_H);
}
if(defined( &X_INCLUDE_STRING_H)  && !defined( &_XOS_INCLUDED_STRING_H)) {
    if(defined( &XUSE_MTSAFE_API) || defined( &XUSE_MTSAFE_STRINGAPI)) {
	eval 'sub XOS_USE_MTSAFE_STRINGAPI () {1;}' unless defined(&XOS_USE_MTSAFE_STRINGAPI);
    }
}
if(!defined( &X_INCLUDE_STRING_H) || defined( &_XOS_INCLUDED_STRING_H)) {
}
 elsif(!defined( &XTHREADS)  && !defined( &X_FORCE_USE_MTSAFE_API)) {
    eval 'sub _XStrtok {
        my($s1,$s2,$p) = @_;
	    eval q(( ( &void)($p),  &strtok(($s1),($s2)) ));
    }' unless defined(&_XStrtok);
}
 elsif(!defined( &XOS_USE_MTSAFE_STRINGAPI) || defined( &XNO_MTSAFE_STRINGAPI)) {
    eval 'sub _XStrtok {
        my($s1,$s2,$p) = @_;
	    eval q(( ( &_Xos_processLock), (($p) =  &strtok(($s1),($s2))), ( &_Xos_processUnlock), ($p) ));
    }' unless defined(&_XStrtok);
} else {
    eval 'sub _XStrtok {
        my($s1,$s2,$p) = @_;
	    eval q( &strtok_r(($s1),($s2),($p)));
    }' unless defined(&_XStrtok);
}
if(defined( &X_INCLUDE_TIME_H)  && !defined( &_XOS_INCLUDED_TIME_H)) {
    require 'time.ph';
    if(defined( &XUSE_MTSAFE_API) || defined( &XUSE_MTSAFE_TIMEAPI)) {
	eval 'sub XOS_USE_MTSAFE_TIMEAPI () {1;}' unless defined(&XOS_USE_MTSAFE_TIMEAPI);
    }
}
if(!defined( &X_INCLUDE_TIME_H) || defined( &_XOS_INCLUDED_TIME_H)) {
}
 elsif(!defined( &XTHREADS)  && !defined( &X_FORCE_USE_MTSAFE_API)) {
    eval 'sub _XAsctime {
        my($t,$p) = @_;
	    eval q( &asctime(($t)));
    }' unless defined(&_XAsctime);
    eval 'sub _XCtime {
        my($t,$p) = @_;
	    eval q( &ctime(($t)));
    }' unless defined(&_XCtime);
    eval 'sub _XGmtime {
        my($t,$p) = @_;
	    eval q( &gmtime(($t)));
    }' unless defined(&_XGmtime);
    eval 'sub _XLocaltime {
        my($t,$p) = @_;
	    eval q( &localtime(($t)));
    }' unless defined(&_XLocaltime);
}
 elsif(!defined( &XOS_USE_MTSAFE_TIMEAPI) || defined( &XNO_MTSAFE_TIMEAPI)) {
    if(defined(&TIMELEN)) {
    } else {
    }
    eval 'sub _XAsctime {
        my($t,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &result =  &asctime(($t))) ? ( &strncpy(($p). &buf, ($p). &result, $sizeof{($p). &buf}), ($p). &result = ($p). &buf) : 0), ( &_Xos_processUnlock), ($p). &result ));
    }' unless defined(&_XAsctime);
    eval 'sub _XCtime {
        my($t,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &result =  &ctime(($t))) ? ( &strncpy(($p). &buf, ($p). &result, $sizeof{($p). &buf}), ($p). &result = ($p). &buf) : 0), ( &_Xos_processUnlock), ($p). &result ));
    }' unless defined(&_XCtime);
    eval 'sub _XGmtime {
        my($t,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &result =  &gmtime($t)) ? ( &memcpy(($p). &buf, ($p). &result, $sizeof{($p). &buf}), ($p). &result = ($p). &buf) : 0), ( &_Xos_processUnlock), ($p). &result ));
    }' unless defined(&_XGmtime);
    eval 'sub _XLocaltime {
        my($t,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &result =  &localtime($t)) ? ( &memcpy(($p). &buf, ($p). &result, $sizeof{($p). &buf}), ($p). &result = ($p). &buf) : 0), ( &_Xos_processUnlock), ($p). &result ));
    }' unless defined(&_XLocaltime);
}
 elsif(!defined( &_POSIX_THREAD_SAFE_FUNCTIONS)  && (defined( &__osf__) || defined( &hpV4))) {
    if(defined(&TIMELEN)) {
    } else {
    }
    eval 'sub _XAsctime {
        my($t,$p) = @_;
	    eval q(( &asctime_r(($t),($p),$sizeof{($p)}) ?  &NULL : ($p)));
    }' unless defined(&_XAsctime);
    eval 'sub _XCtime {
        my($t,$p) = @_;
	    eval q(( &ctime_r(($t),($p),$sizeof{($p)}) ?  &NULL : ($p)));
    }' unless defined(&_XCtime);
    eval 'sub _XGmtime {
        my($t,$p) = @_;
	    eval q(( &gmtime_r(($t),($p)) ?  &NULL : ($p)));
    }' unless defined(&_XGmtime);
    eval 'sub _XLocaltime {
        my($t,$p) = @_;
	    eval q(( &localtime_r(($t),($p)) ?  &NULL : ($p)));
    }' unless defined(&_XLocaltime);
}
 elsif(!defined( &_POSIX_THREAD_SAFE_FUNCTIONS)  && defined( &sun)) {
    if(defined(&TIMELEN)) {
    } else {
    }
    eval 'sub _XAsctime {
        my($t,$p) = @_;
	    eval q( &asctime_r(($t),($p),$sizeof{($p)}));
    }' unless defined(&_XAsctime);
    eval 'sub _XCtime {
        my($t,$p) = @_;
	    eval q( &ctime_r(($t),($p),$sizeof{($p)}));
    }' unless defined(&_XCtime);
    eval 'sub _XGmtime {
        my($t,$p) = @_;
	    eval q( &gmtime_r(($t),($p)));
    }' unless defined(&_XGmtime);
    eval 'sub _XLocaltime {
        my($t,$p) = @_;
	    eval q( &localtime_r(($t),($p)));
    }' unless defined(&_XLocaltime);
} else {
    if(defined( &__osf__)) {
    }
    if(defined(&TIMELEN)) {
    } else {
    }
    eval 'sub _XAsctime {
        my($t,$p) = @_;
	    eval q( &asctime_r(($t),($p)));
    }' unless defined(&_XAsctime);
    eval 'sub _XCtime {
        my($t,$p) = @_;
	    eval q( &ctime_r(($t),($p)));
    }' unless defined(&_XCtime);
    eval 'sub _XGmtime {
        my($t,$p) = @_;
	    eval q( &gmtime_r(($t),($p)));
    }' unless defined(&_XGmtime);
    eval 'sub _XLocaltime {
        my($t,$p) = @_;
	    eval q( &localtime_r(($t),($p)));
    }' unless defined(&_XLocaltime);
}
if(defined( &X_INCLUDE_TIME_H)  && !defined( &_XOS_INCLUDED_TIME_H)) {
    eval 'sub _XOS_INCLUDED_TIME_H () {1;}' unless defined(&_XOS_INCLUDED_TIME_H);
}
if(defined( &X_INCLUDE_GRP_H)  && !defined( &_XOS_INCLUDED_GRP_H)) {
    require 'grp.ph';
    if(defined( &XUSE_MTSAFE_API) || defined( &XUSE_MTSAFE_GRPAPI)) {
	eval 'sub XOS_USE_MTSAFE_GRPAPI () {1;}' unless defined(&XOS_USE_MTSAFE_GRPAPI);
    }
}
if(!defined( &X_INCLUDE_GRP_H) || defined( &_XOS_INCLUDED_GRP_H)) {
}
 elsif(!defined( &XTHREADS)  && !defined( &X_FORCE_USE_MTSAFE_API)) {
    eval 'sub _XGetgrgid {
        my($g,$p) = @_;
	    eval q( &getgrgid(($g)));
    }' unless defined(&_XGetgrgid);
    eval 'sub _XGetgrnam {
        my($n,$p) = @_;
	    eval q( &getgrnam(($n)));
    }' unless defined(&_XGetgrnam);
}
 elsif(!defined( &XOS_USE_MTSAFE_GRPAPI) || defined( &XNO_MTSAFE_GRPAPI)) {
    if(defined(&SVR4)) {
	eval 'sub _Xgrp_copyGroup {
	    my($p) = @_;
    	    eval q((  &memcpy(($p). &grp, ($p). &pgrp, $sizeof{\'struct group\'}), (($p). ($grp->{gr_name}) = ($p). &buf), (($p). &len =  &strlen(($p). ($pgrp->{gr_name}))),  &strcpy(($p). ($grp->{gr_name}), ($p). ($pgrp->{gr_name})), (($p). ($grp->{gr_passwd}) = ($p). ($grp->{gr_name}) + ($p). &len + 1), (($p). &pgrp = ($p). &grp), 0));
	}' unless defined(&_Xgrp_copyGroup);
    } else {
	eval 'sub _Xgrp_copyGroup {
	    my($p) = @_;
    	    eval q((  &memcpy(($p). &grp, ($p). &pgrp, $sizeof{\'struct group\'}), (($p). ($grp->{gr_name}) = ($p). &buf),  &strcpy(($p). ($grp->{gr_name}), ($p). ($pgrp->{gr_name})), (($p). &pgrp = ($p). &grp), 0));
	}' unless defined(&_Xgrp_copyGroup);
    }
    eval 'sub _XGetgrgid {
        my($g,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &pgrp =  &getgrgid(($g))) ?  &_Xgrp_copyGroup($p) : 0), ( &_Xos_processUnlock), ($p). &pgrp ));
    }' unless defined(&_XGetgrgid);
    eval 'sub _XGetgrnam {
        my($n,$p) = @_;
	    eval q(( ( &_Xos_processLock), ((($p). &pgrp =  &getgrnam(($n))) ?  &_Xgrp_copyGroup($p) : 0), ( &_Xos_processUnlock), ($p). &pgrp ));
    }' unless defined(&_XGetgrnam);
}
 elsif(!defined( &_POSIX_THREAD_SAFE_FUNCTIONS)  && (defined( &sun) || defined( &__osf__))) {
    eval 'sub _XGetgrgid {
        my($g,$p) = @_;
	    eval q( &getgrgid_r(($g), ($p). &grp, ($p). &buf, $sizeof{($p). &buf}));
    }' unless defined(&_XGetgrgid);
    eval 'sub _XGetgrnam {
        my($n,$p) = @_;
	    eval q( &getgrnam_r(($n), ($p). &grp, ($p). &buf, $sizeof{($p). &buf}));
    }' unless defined(&_XGetgrnam);
}
 elsif(!defined( &_POSIX_THREAD_SAFE_FUNCTIONS)) {
    eval 'sub _XGetgrgid {
        my($g,$p) = @_;
	    eval q((( &getgrgid_r(($g), ($p). &grp, ($p). &buf, $sizeof{($p). &buf}) ?  &NULL : ($p). &grp)));
    }' unless defined(&_XGetgrgid);
    eval 'sub _XGetgrnam {
        my($n,$p) = @_;
	    eval q((( &getgrnam_r(($n), ($p). &grp, ($p). &buf, $sizeof{($p). &buf}) ?  &NULL : ($p). &grp)));
    }' unless defined(&_XGetgrnam);
} else {
    if(defined( &__osf__)) {
    }
    eval 'sub _XGetgrgid {
        my($g,$p) = @_;
	    eval q((( &getgrgid_r(($g), ($p). &grp, ($p). &buf, $sizeof{($p). &buf}, ($p). &result) ?  &NULL : ($p). &result)));
    }' unless defined(&_XGetgrgid);
    eval 'sub _XGetgrnam {
        my($n,$p) = @_;
	    eval q((( &getgrnam_r(($n), ($p). &grp, ($p). &buf, $sizeof{($p). &buf}, ($p). &result) ?  &NULL : ($p). &result)));
    }' unless defined(&_XGetgrnam);
}
if(defined( &X_INCLUDE_GRP_H)  && !defined( &_XOS_INCLUDED_GRP_H)) {
    eval 'sub _XOS_INCLUDED_GRP_H () {1;}' unless defined(&_XOS_INCLUDED_GRP_H);
}
if(defined(&__cplusplus)) {
}
1;
