require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XINPUT_H_)) {
    eval 'sub _XINPUT_H_ () {1;}' unless defined(&_XINPUT_H_);
    require 'X11/Xlib.ph';
    require 'X11/extensions/XI.ph';
    eval 'sub _deviceKeyPress () {0;}' unless defined(&_deviceKeyPress);
    eval 'sub _deviceKeyRelease () {1;}' unless defined(&_deviceKeyRelease);
    eval 'sub _deviceButtonPress () {0;}' unless defined(&_deviceButtonPress);
    eval 'sub _deviceButtonRelease () {1;}' unless defined(&_deviceButtonRelease);
    eval 'sub _deviceMotionNotify () {0;}' unless defined(&_deviceMotionNotify);
    eval 'sub _deviceFocusIn () {0;}' unless defined(&_deviceFocusIn);
    eval 'sub _deviceFocusOut () {1;}' unless defined(&_deviceFocusOut);
    eval 'sub _proximityIn () {0;}' unless defined(&_proximityIn);
    eval 'sub _proximityOut () {1;}' unless defined(&_proximityOut);
    eval 'sub _deviceStateNotify () {0;}' unless defined(&_deviceStateNotify);
    eval 'sub _deviceMappingNotify () {1;}' unless defined(&_deviceMappingNotify);
    eval 'sub _changeDeviceNotify () {2;}' unless defined(&_changeDeviceNotify);
    eval 'sub FindTypeAndClass {
        my($d,$type,$_class,$classid,$offset) = @_;
	    eval q({ \'int\'  &_i;  &XInputClassInfo * &_ip; $type = 0; $_class = 0;  &for ( &_i=0,  &_ip= (( &XDevice *) $d)-> &classes;  &_i< (( &XDevice *) $d)-> &num_classes;  &_i++,  &_ip++)  &if ( ($_ip->{input_class}) == $classid) {$type =  ($_ip->{event_type_base}) + $offset; $_class = (( &XDevice *) $d)-> &device_id << 8| $type;}});
    }' unless defined(&FindTypeAndClass);
    eval 'sub DeviceKeyPress {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &KeyClass,  &_deviceKeyPress));
    }' unless defined(&DeviceKeyPress);
    eval 'sub DeviceKeyRelease {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &KeyClass,  &_deviceKeyRelease));
    }' unless defined(&DeviceKeyRelease);
    eval 'sub DeviceButtonPress {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &ButtonClass,  &_deviceButtonPress));
    }' unless defined(&DeviceButtonPress);
    eval 'sub DeviceButtonRelease {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &ButtonClass,  &_deviceButtonRelease));
    }' unless defined(&DeviceButtonRelease);
    eval 'sub DeviceMotionNotify {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &ValuatorClass,  &_deviceMotionNotify));
    }' unless defined(&DeviceMotionNotify);
    eval 'sub DeviceFocusIn {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &FocusClass,  &_deviceFocusIn));
    }' unless defined(&DeviceFocusIn);
    eval 'sub DeviceFocusOut {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &FocusClass,  &_deviceFocusOut));
    }' unless defined(&DeviceFocusOut);
    eval 'sub ProximityIn {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &ProximityClass,  &_proximityIn));
    }' unless defined(&ProximityIn);
    eval 'sub ProximityOut {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &ProximityClass,  &_proximityOut));
    }' unless defined(&ProximityOut);
    eval 'sub DeviceStateNotify {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &OtherClass,  &_deviceStateNotify));
    }' unless defined(&DeviceStateNotify);
    eval 'sub DeviceMappingNotify {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &OtherClass,  &_deviceMappingNotify));
    }' unless defined(&DeviceMappingNotify);
    eval 'sub ChangeDeviceNotify {
        my($d,$type,$_class) = @_;
	    eval q( &FindTypeAndClass($d, $type, $_class,  &OtherClass,  &_changeDeviceNotify));
    }' unless defined(&ChangeDeviceNotify);
    eval 'sub DevicePointerMotionHint {
        my($d,$type,$_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_devicePointerMotionHint;});
    }' unless defined(&DevicePointerMotionHint);
    eval 'sub DeviceButton1Motion {
        my($d,$type,$_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_deviceButton1Motion;});
    }' unless defined(&DeviceButton1Motion);
    eval 'sub DeviceButton2Motion {
        my($d,$type,$_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_deviceButton2Motion;});
    }' unless defined(&DeviceButton2Motion);
    eval 'sub DeviceButton3Motion {
        my($d,$type,$_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_deviceButton3Motion;});
    }' unless defined(&DeviceButton3Motion);
    eval 'sub DeviceButton4Motion {
        my($d,$type, $_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_deviceButton4Motion;});
    }' unless defined(&DeviceButton4Motion);
    eval 'sub DeviceButton5Motion {
        my($d,$type,$_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_deviceButton5Motion;});
    }' unless defined(&DeviceButton5Motion);
    eval 'sub DeviceButtonMotion {
        my($d,$type, $_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_deviceButtonMotion;});
    }' unless defined(&DeviceButtonMotion);
    eval 'sub DeviceOwnerGrabButton {
        my($d,$type,$_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_deviceOwnerGrabButton;});
    }' unless defined(&DeviceOwnerGrabButton);
    eval 'sub DeviceButtonPressGrab {
        my($d,$type,$_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_deviceButtonGrab;});
    }' unless defined(&DeviceButtonPressGrab);
    eval 'sub NoExtensionEvent {
        my($d,$type,$_class) = @_;
	    eval q({ $_class = (( &XDevice *) $d)-> &device_id << 8|  &_noExtensionEvent;});
    }' unless defined(&NoExtensionEvent);
    eval 'sub BadDevice {
        my($dpy,$error) = @_;
	    eval q( &_xibaddevice($dpy, $error));
    }' unless defined(&BadDevice);
    eval 'sub BadClass {
        my($dpy,$error) = @_;
	    eval q( &_xibadclass($dpy, $error));
    }' unless defined(&BadClass);
    eval 'sub BadEvent {
        my($dpy,$error) = @_;
	    eval q( &_xibadevent($dpy, $error));
    }' unless defined(&BadEvent);
    eval 'sub BadMode {
        my($dpy,$error) = @_;
	    eval q( &_xibadmode($dpy, $error));
    }' unless defined(&BadMode);
    eval 'sub DeviceBusy {
        my($dpy,$error) = @_;
	    eval q( &_xidevicebusy($dpy, $error));
    }' unless defined(&DeviceBusy);
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	} else {
	}
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
}
1;
