require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MULTIBUFST_H_)) {
    eval 'sub _MULTIBUFST_H_ () {1;}' unless defined(&_MULTIBUFST_H_);
    require 'multibuf.ph';
    if(defined(&_MULTIBUF_SERVER_)) {
	require 'inputstr.ph';
    }
    if(!defined( &UNIXCPP) || defined( &ANSICPP)) {
	eval 'sub MbufGetReq {
	    my($name,$req,$info) = @_;
    	    eval q( &GetReq ($name, $req);  ($req->{reqType}) =  ($info->{codes}->{major_opcode});  ($req->{mbufReqType}) =  &X_$name;);
	}' unless defined(&MbufGetReq);
    } else {
	eval 'sub MbufGetReq {
	    my($name,$req,$info) = @_;
    	    eval q( &GetReq ($name, $req);  ($req->{reqType}) =  ($info->{codes}->{major_opcode});  ($req->{mbufReqType}) =  &X_ $name;);
	}' unless defined(&MbufGetReq);
    }
    eval 'sub Window () { &CARD32;}' unless defined(&Window);
    eval 'sub Drawable () { &CARD32;}' unless defined(&Drawable);
    eval 'sub VisualID () { &CARD32;}' unless defined(&VisualID);
    eval 'sub Multibuffer () { &CARD32;}' unless defined(&Multibuffer);
    eval 'sub sz_xMbufBufferInfo () {8;}' unless defined(&sz_xMbufBufferInfo);
    eval 'sub sz_xMbufGetBufferVersionReq () {4;}' unless defined(&sz_xMbufGetBufferVersionReq);
    eval 'sub sz_xMbufGetBufferVersionReply () {32;}' unless defined(&sz_xMbufGetBufferVersionReply);
    eval 'sub sz_xMbufCreateImageBuffersReq () {12;}' unless defined(&sz_xMbufCreateImageBuffersReq);
    eval 'sub sz_xMbufCreateImageBuffersReply () {32;}' unless defined(&sz_xMbufCreateImageBuffersReply);
    eval 'sub sz_xMbufDestroyImageBuffersReq () {8;}' unless defined(&sz_xMbufDestroyImageBuffersReq);
    eval 'sub sz_xMbufDisplayImageBuffersReq () {8;}' unless defined(&sz_xMbufDisplayImageBuffersReq);
    eval 'sub sz_xMbufSetMBufferAttributesReq () {12;}' unless defined(&sz_xMbufSetMBufferAttributesReq);
    eval 'sub sz_xMbufGetMBufferAttributesReq () {8;}' unless defined(&sz_xMbufGetMBufferAttributesReq);
    eval 'sub sz_xMbufGetMBufferAttributesReply () {32;}' unless defined(&sz_xMbufGetMBufferAttributesReply);
    eval 'sub sz_xMbufSetBufferAttributesReq () {12;}' unless defined(&sz_xMbufSetBufferAttributesReq);
    eval 'sub sz_xMbufGetBufferAttributesReq () {8;}' unless defined(&sz_xMbufGetBufferAttributesReq);
    eval 'sub sz_xMbufGetBufferAttributesReply () {32;}' unless defined(&sz_xMbufGetBufferAttributesReply);
    eval 'sub sz_xMbufGetBufferInfoReq () {8;}' unless defined(&sz_xMbufGetBufferInfoReq);
    eval 'sub sz_xMbufGetBufferInfoReply () {32;}' unless defined(&sz_xMbufGetBufferInfoReply);
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    eval 'sub sz_xMbufCreateStereoWindowReq () {44;}' unless defined(&sz_xMbufCreateStereoWindowReq);
    eval 'sub sz_xMbufClearImageBufferAreaReq () {20;}' unless defined(&sz_xMbufClearImageBufferAreaReq);
    undef(&Window) if defined(&Window);
    undef(&Drawable) if defined(&Drawable);
    undef(&VisualID) if defined(&VisualID);
    undef(&Multibuffer) if defined(&Multibuffer);
    if(defined(&_MULTIBUF_SERVER_)) {
	eval 'sub SWAP_FUNC_VECTOR {
	    my($pSTRUCT1,$pSTRUCT2,$DATA_TYPE,$FUNC_NAME) = @_;
    	    eval q({ $DATA_TYPE (*  &tmpFn)();  &tmpFn =  ($pSTRUCT1->{FUNC_NAME});  ($pSTRUCT1->{FUNC_NAME}) =  ($pSTRUCT2->{FUNC_NAME});  ($pSTRUCT2->{FUNC_NAME}) =  &tmpFn; });
	}' unless defined(&SWAP_FUNC_VECTOR);
	if(!defined( &UNIXCPP) || defined( &ANSICPP)) {
	    eval 'sub WRAP_SCREEN_FUNC {
	        my($pSCREEN,$pPRIV,$FUNC_NAME, $PRIV_FUNC_NAME) = @_;
    		eval q({  &if (( ($pPRIV->{funcsWrapped}) & $FUNC_NAME &Mask) == 0) {  ($pPRIV->{FUNC_NAME})  =  ($pSCREEN->{FUNC_NAME});  ($pSCREEN->{FUNC_NAME}) = $PRIV_FUNC_NAME;  ($pPRIV->{funcsWrapped}) |= $FUNC_NAME &Mask; } });
	    }' unless defined(&WRAP_SCREEN_FUNC);
	    eval 'sub UNWRAP_SCREEN_FUNC {
	        my($pSCREEN,$pPRIV,$DATA_TYPE,$FUNC_NAME) = @_;
    		eval q({  &SWAP_FUNC_VECTOR($pSCREEN,$pPRIV,$DATA_TYPE,$FUNC_NAME);  ($pPRIV->{funcsWrapped}) &= ~($FUNC_NAME &Mask); });
	    }' unless defined(&UNWRAP_SCREEN_FUNC);
	    eval 'sub REWRAP_SCREEN_FUNC {
	        my($pSCREEN,$pPRIV,$DATA_TYPE,$FUNC_NAME) = @_;
    		eval q({  &if ( &MB_SCREEN_PRIV($pSCREEN)-> &mbufWindowCount) {  &SWAP_FUNC_VECTOR($pSCREEN,$pPRIV,$DATA_TYPE,$FUNC_NAME);  ($pPRIV->{funcsWrapped}) |= $FUNC_NAME &Mask; } });
	    }' unless defined(&REWRAP_SCREEN_FUNC);
	} else {
	    eval 'sub WRAP_SCREEN_FUNC {
	        my($pSCREEN,$pPRIV,$FUNC_NAME, $PRIV_FUNC_NAME) = @_;
    		eval q({  &if (( ($pPRIV->{funcsWrapped}) & $FUNC_NAME  &Mask) == 0) {  ($pPRIV->{FUNC_NAME})  =  ($pSCREEN->{FUNC_NAME});  ($pSCREEN->{FUNC_NAME}) = $PRIV_FUNC_NAME;  ($pPRIV->{funcsWrapped}) |= $FUNC_NAME  &Mask; } });
	    }' unless defined(&WRAP_SCREEN_FUNC);
	    eval 'sub UNWRAP_SCREEN_FUNC {
	        my($pSCREEN,$pPRIV,$DATA_TYPE,$FUNC_NAME) = @_;
    		eval q({  &SWAP_FUNC_VECTOR($pSCREEN,$pPRIV,$DATA_TYPE,$FUNC_NAME);  ($pPRIV->{funcsWrapped}) &= ~($FUNC_NAME  &Mask); });
	    }' unless defined(&UNWRAP_SCREEN_FUNC);
	    eval 'sub REWRAP_SCREEN_FUNC {
	        my($pSCREEN,$pPRIV,$DATA_TYPE,$FUNC_NAME) = @_;
    		eval q({  &if ( &MB_SCREEN_PRIV($pSCREEN)-> &mbufWindowCount) {  &SWAP_FUNC_VECTOR($pSCREEN,$pPRIV,$DATA_TYPE,$FUNC_NAME);  ($pPRIV->{funcsWrapped}) |= $FUNC_NAME  &Mask; } });
	    }' unless defined(&REWRAP_SCREEN_FUNC);
	}
	eval 'sub DestroyWindowMask () {(1<<0);}' unless defined(&DestroyWindowMask);
	eval 'sub PositionWindowMask () {(1<<1);}' unless defined(&PositionWindowMask);
	eval 'sub PostValidateTreeMask () {(1<<2);}' unless defined(&PostValidateTreeMask);
	eval 'sub ClipNotifyMask () {(1<<3);}' unless defined(&ClipNotifyMask);
	eval 'sub WindowExposuresMask () {(1<<4);}' unless defined(&WindowExposuresMask);
	eval 'sub CopyWindowMask () {(1<<5);}' unless defined(&CopyWindowMask);
	eval 'sub ClearToBackgroundMask () {(1<<6);}' unless defined(&ClearToBackgroundMask);
	eval 'sub ChangeWindowAttributesMask () {(1<<7);}' unless defined(&ChangeWindowAttributesMask);
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	eval 'sub MB_DISPLAYED_BUFFER {
	    my($pMBWindow) = @_;
    	    eval q((($pMBWindow)-> &buffers + ($pMBWindow)-> &displayedMultibuffer));
	}' unless defined(&MB_DISPLAYED_BUFFER);
	eval 'sub MB_WINDOW_PRIV {
	    my($pWin) = @_;
    	    eval q((( &mbufWindowPtr)(($pWin)-> ($devPrivates[&MultibufferWindowIndex]->{ptr}))));
	}' unless defined(&MB_WINDOW_PRIV);
	eval 'sub MB_SCREEN_PRIV {
	    my($pScreen) = @_;
    	    eval q((( &mbufScreenPtr)(($pScreen)-> ($devPrivates[&MultibufferScreenIndex]->{ptr}))));
	}' unless defined(&MB_SCREEN_PRIV);
	if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
	}
	if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
	}
	if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
	}
	if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
	}
	if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
	}
	if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
	}
	if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
	}
	if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
	}
	if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
	}
	if(defined(&_MULTIBUF_PIXMAP_)) {
	    eval 'sub MB_SCREEN_PRIV_PIXMAP {
	        my($pScreen) = @_;
    		eval q((( &mbufPixmapPrivPtr)  &MB_SCREEN_PRIV(($pScreen))-> ($devPrivate->{ptr})));
	    }' unless defined(&MB_SCREEN_PRIV_PIXMAP);
	}
	if(defined(&_MULTIBUF_BUFFER_)) {
	    eval 'sub MB_SCREEN_PRIV_BUFFER {
	        my($pScreen) = @_;
    		eval q((( &mbufBufferPrivPtr)  &MB_SCREEN_PRIV(($pScreen))-> ($devPrivate->{ptr})));
	    }' unless defined(&MB_SCREEN_PRIV_BUFFER);
	}
    }
}
1;
