require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RECORDSTR_H_)) {
    eval 'sub _RECORDSTR_H_ () {1;}' unless defined(&_RECORDSTR_H_);
    require 'X11/extensions/record.ph';
    eval 'sub RECORD_NAME () {"RECORD";}' unless defined(&RECORD_NAME);
    eval 'sub RECORD_MAJOR_VERSION () {1;}' unless defined(&RECORD_MAJOR_VERSION);
    eval 'sub RECORD_MINOR_VERSION () {13;}' unless defined(&RECORD_MINOR_VERSION);
    eval 'sub RECORD_LOWEST_MAJOR_VERSION () {1;}' unless defined(&RECORD_LOWEST_MAJOR_VERSION);
    eval 'sub RECORD_LOWEST_MINOR_VERSION () {12;}' unless defined(&RECORD_LOWEST_MINOR_VERSION);
    eval 'sub X_RecordQueryVersion () {0;}' unless defined(&X_RecordQueryVersion);
    eval 'sub X_RecordCreateContext () {1;}' unless defined(&X_RecordCreateContext);
    eval 'sub X_RecordRegisterClients () {2;}' unless defined(&X_RecordRegisterClients);
    eval 'sub X_RecordUnregisterClients () {3;}' unless defined(&X_RecordUnregisterClients);
    eval 'sub X_RecordGetContext () {4;}' unless defined(&X_RecordGetContext);
    eval 'sub X_RecordEnableContext () {5;}' unless defined(&X_RecordEnableContext);
    eval 'sub X_RecordDisableContext () {6;}' unless defined(&X_RecordDisableContext);
    eval 'sub X_RecordFreeContext () {7;}' unless defined(&X_RecordFreeContext);
    eval 'sub RecordNumErrors () {( &XRecordBadContext + 1);}' unless defined(&RecordNumErrors);
    eval 'sub RecordNumEvents () {0;}' unless defined(&RecordNumEvents);
    eval 'sub sz_XRecordRange () {32;}' unless defined(&sz_XRecordRange);
    eval 'sub sz_XRecordClientInfo () {12;}' unless defined(&sz_XRecordClientInfo);
    eval 'sub sz_XRecordState () {16;}' unless defined(&sz_XRecordState);
    eval 'sub sz_XRecordDatum () {32;}' unless defined(&sz_XRecordDatum);
    eval 'sub XRecordGlobaldef () {1;}' unless defined(&XRecordGlobaldef);
    eval 'sub XRecordGlobalref () { &extern;}' unless defined(&XRecordGlobalref);
    eval 'sub RecordMaxEvent () {(128-1);}' unless defined(&RecordMaxEvent);
    eval 'sub RecordMinDeviceEvent () {(2);}' unless defined(&RecordMinDeviceEvent);
    eval 'sub RecordMaxDeviceEvent () {(6);}' unless defined(&RecordMaxDeviceEvent);
    eval 'sub RecordMaxError () {(256-1);}' unless defined(&RecordMaxError);
    eval 'sub RecordMaxCoreRequest () {(128-1);}' unless defined(&RecordMaxCoreRequest);
    eval 'sub RecordMaxExtRequest () {(256-1);}' unless defined(&RecordMaxExtRequest);
    eval 'sub RecordMinExtRequest () {(129-1);}' unless defined(&RecordMinExtRequest);
    eval 'sub RECORD_RC () { &CARD32;}' unless defined(&RECORD_RC);
    eval 'sub RECORD_XIDBASE () { &CARD32;}' unless defined(&RECORD_XIDBASE);
    eval 'sub RECORD_CLIENTSPEC () { &CARD32;}' unless defined(&RECORD_CLIENTSPEC);
    eval 'sub RECORD_ELEMENT_HEADER () { &CARD8;}' unless defined(&RECORD_ELEMENT_HEADER);
    eval 'sub sz_RECORDRANGE () {24;}' unless defined(&sz_RECORDRANGE);
    eval 'sub sz_xRecordRange () {24;}' unless defined(&sz_xRecordRange);
    eval 'sub sz_xRecordQueryVersionReq () {8;}' unless defined(&sz_xRecordQueryVersionReq);
    eval 'sub sz_xRecordQueryVersionReply () {32;}' unless defined(&sz_xRecordQueryVersionReply);
    eval 'sub sz_xRecordCreateContextReq () {20;}' unless defined(&sz_xRecordCreateContextReq);
    eval 'sub sz_xRecordRegisterClientsReq () {20;}' unless defined(&sz_xRecordRegisterClientsReq);
    eval 'sub sz_xRecordUnregisterClientsReq () {12;}' unless defined(&sz_xRecordUnregisterClientsReq);
    eval 'sub sz_xRecordGetContextReq () {8;}' unless defined(&sz_xRecordGetContextReq);
    eval 'sub sz_xRecordGetContextReply () {32;}' unless defined(&sz_xRecordGetContextReply);
    eval 'sub sz_xRecordEnableContextReq () {8;}' unless defined(&sz_xRecordEnableContextReq);
    eval 'sub sz_xRecordEnableContextReply () {32;}' unless defined(&sz_xRecordEnableContextReply);
    eval 'sub sz_xRecordDisableContextReq () {8;}' unless defined(&sz_xRecordDisableContextReq);
    eval 'sub sz_xRecordFreeContextReq () {8;}' unless defined(&sz_xRecordFreeContextReq);
    undef(&RECORD_RC) if defined(&RECORD_RC);
    undef(&RECORD_XIDBASE) if defined(&RECORD_XIDBASE);
    undef(&RECORD_ELEMENT_HEADER) if defined(&RECORD_ELEMENT_HEADER);
    undef(&RECORD_CLIENTSPEC) if defined(&RECORD_CLIENTSPEC);
}
1;
