require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XF86VIDMODE_H_)) {
    eval 'sub _XF86VIDMODE_H_ () {1;}' unless defined(&_XF86VIDMODE_H_);
    require 'X11/Xfuncproto.ph';
    require 'X11/Xmd.ph';
    eval 'sub X_XF86VidModeQueryVersion () {0;}' unless defined(&X_XF86VidModeQueryVersion);
    eval 'sub X_XF86VidModeGetModeLine () {1;}' unless defined(&X_XF86VidModeGetModeLine);
    eval 'sub X_XF86VidModeModModeLine () {2;}' unless defined(&X_XF86VidModeModModeLine);
    eval 'sub X_XF86VidModeSwitchMode () {3;}' unless defined(&X_XF86VidModeSwitchMode);
    eval 'sub X_XF86VidModeGetMonitor () {4;}' unless defined(&X_XF86VidModeGetMonitor);
    eval 'sub X_XF86VidModeLockModeSwitch () {5;}' unless defined(&X_XF86VidModeLockModeSwitch);
    eval 'sub X_XF86VidModeGetAllModeLines () {6;}' unless defined(&X_XF86VidModeGetAllModeLines);
    eval 'sub X_XF86VidModeAddModeLine () {7;}' unless defined(&X_XF86VidModeAddModeLine);
    eval 'sub X_XF86VidModeDeleteModeLine () {8;}' unless defined(&X_XF86VidModeDeleteModeLine);
    eval 'sub X_XF86VidModeValidateModeLine () {9;}' unless defined(&X_XF86VidModeValidateModeLine);
    eval 'sub X_XF86VidModeSwitchToMode () {10;}' unless defined(&X_XF86VidModeSwitchToMode);
    eval 'sub X_XF86VidModeGetViewPort () {11;}' unless defined(&X_XF86VidModeGetViewPort);
    eval 'sub X_XF86VidModeSetViewPort () {12;}' unless defined(&X_XF86VidModeSetViewPort);
    eval 'sub X_XF86VidModeGetDotClocks () {13;}' unless defined(&X_XF86VidModeGetDotClocks);
    eval 'sub X_XF86VidModeSetClientVersion () {14;}' unless defined(&X_XF86VidModeSetClientVersion);
    eval 'sub X_XF86VidModeSetGamma () {15;}' unless defined(&X_XF86VidModeSetGamma);
    eval 'sub X_XF86VidModeGetGamma () {16;}' unless defined(&X_XF86VidModeGetGamma);
    eval 'sub X_XF86VidModeGetGammaRamp () {17;}' unless defined(&X_XF86VidModeGetGammaRamp);
    eval 'sub X_XF86VidModeSetGammaRamp () {18;}' unless defined(&X_XF86VidModeSetGammaRamp);
    eval 'sub X_XF86VidModeGetGammaRampSize () {19;}' unless defined(&X_XF86VidModeGetGammaRampSize);
    eval 'sub X_XF86VidModeGetPermissions () {20;}' unless defined(&X_XF86VidModeGetPermissions);
    eval 'sub CLKFLAG_PROGRAMABLE () {1;}' unless defined(&CLKFLAG_PROGRAMABLE);
    if(defined(&XF86VIDMODE_EVENTS)) {
	eval 'sub XF86VidModeNotify () {0;}' unless defined(&XF86VidModeNotify);
	eval 'sub XF86VidModeNumberEvents () {( &XF86VidModeNotify + 1);}' unless defined(&XF86VidModeNumberEvents);
	eval 'sub XF86VidModeNotifyMask () {0x1;}' unless defined(&XF86VidModeNotifyMask);
	eval 'sub XF86VidModeNonEvent () {0;}' unless defined(&XF86VidModeNonEvent);
	eval 'sub XF86VidModeModeChange () {1;}' unless defined(&XF86VidModeModeChange);
    } else {
	eval 'sub XF86VidModeNumberEvents () {0;}' unless defined(&XF86VidModeNumberEvents);
    }
    eval 'sub XF86VidModeBadClock () {0;}' unless defined(&XF86VidModeBadClock);
    eval 'sub XF86VidModeBadHTimings () {1;}' unless defined(&XF86VidModeBadHTimings);
    eval 'sub XF86VidModeBadVTimings () {2;}' unless defined(&XF86VidModeBadVTimings);
    eval 'sub XF86VidModeModeUnsuitable () {3;}' unless defined(&XF86VidModeModeUnsuitable);
    eval 'sub XF86VidModeExtensionDisabled () {4;}' unless defined(&XF86VidModeExtensionDisabled);
    eval 'sub XF86VidModeClientNotLocal () {5;}' unless defined(&XF86VidModeClientNotLocal);
    eval 'sub XF86VidModeZoomLocked () {6;}' unless defined(&XF86VidModeZoomLocked);
    eval 'sub XF86VidModeNumberErrors () {( &XF86VidModeZoomLocked + 1);}' unless defined(&XF86VidModeNumberErrors);
    eval 'sub XF86VM_READ_PERMISSION () {1;}' unless defined(&XF86VM_READ_PERMISSION);
    eval 'sub XF86VM_WRITE_PERMISSION () {2;}' unless defined(&XF86VM_WRITE_PERMISSION);
    unless(defined(&_XF86VIDMODE_SERVER_)) {
	if(defined( &__cplusplus) || defined( &c_plusplus)) {
	} else {
	}
	if(defined( &__cplusplus) || defined( &c_plusplus)) {
	} else {
	}
	eval 'sub XF86VidModeSelectNextMode {
	    my($disp, $scr) = @_;
    	    eval q( &XF86VidModeSwitchMode($disp, $scr, 1));
	}' unless defined(&XF86VidModeSelectNextMode);
	eval 'sub XF86VidModeSelectPrevMode {
	    my($disp, $scr) = @_;
    	    eval q( &XF86VidModeSwitchMode($disp, $scr, -1));
	}' unless defined(&XF86VidModeSelectPrevMode);
    }
}
1;
