require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__XTRAPDDMI__)) {
    eval 'sub __XTRAPDDMI__ () {1;}' unless defined(&__XTRAPDDMI__);
    require 'X11/X.ph';
    require 'X11/extensions/xtrapbits.ph';
    require 'dix.ph';
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    my($a,$b) = @_;
    	    eval q((($a) < ($b) ? ($a) : ($b)));
	}' unless defined(&MIN);
    }
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    my($a,$b) = @_;
    	    eval q((($a) > ($b) ? ($a) : ($b)));
	}' unless defined(&MAX);
    }
    eval 'sub XETrapNumEvents () {1;}' unless defined(&XETrapNumEvents);
    eval 'sub XETrapMinRepSize () {32;}' unless defined(&XETrapMinRepSize);
    eval 'sub XETrapSetHeaderEvent {
        my($phdr) = @_;
	    eval q((($phdr)-> &type = 0x1));
    }' unless defined(&XETrapSetHeaderEvent);
    eval 'sub XETrapSetHeaderRequest {
        my($phdr) = @_;
	    eval q((($phdr)-> &type = 0x2));
    }' unless defined(&XETrapSetHeaderRequest);
    eval 'sub XETrapSetHeaderSpecial {
        my($phdr) = @_;
	    eval q((($phdr)-> &type = 0x3));
    }' unless defined(&XETrapSetHeaderSpecial);
    eval 'sub XETrapSetHeaderCursor {
        my($phdr) = @_;
	    eval q((($phdr)-> &type = 0x4));
    }' unless defined(&XETrapSetHeaderCursor);
    eval 'sub XETrapSetHeaderReply {
        my($phdr) = @_;
	    eval q((($phdr)-> &type = 0x5));
    }' unless defined(&XETrapSetHeaderReply);
    unless(defined(&vaxc)) {
	eval 'sub globaldef () {1;}' unless defined(&globaldef);
	eval 'sub globalref () { &extern;}' unless defined(&globalref);
    }
    if(( defined ( &__osf__)  && defined( &__alpha) )) {
	eval 'sub XETrapPlatform () { &PF_DECOSF1;}' unless defined(&XETrapPlatform);
    }
    if(defined(&ultrix)) {
	eval 'sub XETrapPlatform () { &PF_DECUltrix;}' unless defined(&XETrapPlatform);
    }
    if(defined(&vms)) {
	if(defined(&VAXELN)) {
	    eval 'sub XETrapPlatform () { &PF_DECELN;}' unless defined(&XETrapPlatform);
	} else {
	    eval 'sub XETrapPlatform () { &PF_DECVMS;}' unless defined(&XETrapPlatform);
	}
    }
    if(defined(&VT1000)) {
	eval 'sub XETrapPlatform () { &PF_DECVT1000;}' unless defined(&XETrapPlatform);
    }
    if(defined(&VXT)) {
	eval 'sub XETrapPlatform () { &PF_DECXTerm;}' unless defined(&XETrapPlatform);
    }
    if(defined(&PC)) {
	eval 'sub XETrapPlatform () { &PF_IBMAT;}' unless defined(&XETrapPlatform);
    }
    if(defined(&sun)) {
	eval 'sub XETrapPlatform () { &PF_SunSparc;}' unless defined(&XETrapPlatform);
    }
    unless(defined(&XETrapPlatform)) {
	eval 'sub XETrapPlatform () { &PF_Other;}' unless defined(&XETrapPlatform);
    }
}
1;
