require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XTTCCONVP_H_)) {
    eval 'sub _XTTCCONVP_H_ () {1;}' unless defined(&_XTTCCONVP_H_);
    require 'X11/Xdefs.ph';
    eval("sub EPlfmUnicode () { 0; }") unless defined(&EPlfmUnicode);
    eval("sub EPlfmApple () { 1; }") unless defined(&EPlfmApple);
    eval("sub EPlfmISO () { 2; }") unless defined(&EPlfmISO);
    eval("sub EPlfmMS () { 3; }") unless defined(&EPlfmMS);
    eval("sub EPlfmAny () { -1; }") unless defined(&EPlfmAny);
    eval("sub EEncUnicodeAny () { -1; }") unless defined(&EEncUnicodeAny);
    eval("sub EEncAppleRoman () { 0; }") unless defined(&EEncAppleRoman);
    eval("sub EEncAppleJapanese () { 1; }") unless defined(&EEncAppleJapanese);
    eval("sub EEncAppleCenteuro () { 29; }") unless defined(&EEncAppleCenteuro);
    eval("sub EEncAppleCyrillic () { 7; }") unless defined(&EEncAppleCyrillic);
    eval("sub EEncISOASCII () { 0; }") unless defined(&EEncISOASCII);
    eval("sub EEncISO10646 () { 1; }") unless defined(&EEncISO10646);
    eval("sub EEncISO8859_1 () { 2; }") unless defined(&EEncISO8859_1);
    eval("sub EEncMSSymbol () { 0; }") unless defined(&EEncMSSymbol);
    eval("sub EEncMSUnicode () { 1; }") unless defined(&EEncMSUnicode);
    eval("sub EEncMSShiftJIS () { 2; }") unless defined(&EEncMSShiftJIS);
    eval("sub EEncMSBig5WGL4 () { 3; }") unless defined(&EEncMSBig5WGL4);
    eval("sub EEncMSGB2312 () { 4; }") unless defined(&EEncMSGB2312);
    eval("sub EEncMSWansung () { 5; }") unless defined(&EEncMSWansung);
    eval("sub EEncAny () { -1; }") unless defined(&EEncAny);
    eval 'sub CODE_CONV_ONE_OCTET_TO_UCS2 {
        my($funcName, $tableName,				    $begin, $end,				    $altChar) = @_;
	    eval q( &ft_char_code_t $funcName( &ft_char_code_t  &codeSrc){  &ucs2_t  &codeDst;  &if ( &codeSrc>=$begin  &&  &codeSrc<=$end)  &codeDst = $tableName->[ &codeSrc-$begin];  &else  &codeDst = $altChar;  &return  &codeDst;});
    }' unless defined(&CODE_CONV_ONE_OCTET_TO_UCS2);
    eval 'sub CODE_CONV_ONE_OCTET_TO_UCS2_ALL {
        my($funcName, $tableName) = @_;
	    eval q( &ft_char_code_t $funcName( &ft_char_code_t  &codeSrc){  &return $tableName->[ &codeSrc];});
    }' unless defined(&CODE_CONV_ONE_OCTET_TO_UCS2_ALL);
    eval 'sub CODE_CONV_TWO_OCTET_TO_UCS2 {
        my($funcName, $tableName,				    $beginHigh, $endHigh,				    $beginLow, $endLow,				    $altChar) = @_;
	    eval q( &ft_char_code_t $funcName( &ft_char_code_t  &codeSrc){  &ucs2_t  &codeDst; \'int\'  &high =  &codeSrc >> 8; \'int\'  &low =  &codeSrc & 0xff;  &if ( &high>=$beginHigh  &&  &high<=$endHigh  &&  &low>=$beginLow  &&  &low<=$endLow)  &codeDst = $tableName->[( &high-$beginHigh)*($endLow-$beginLow+1)+( &low-$beginLow)];  &else  &codeDst = $altChar;  &return  &codeDst;});
    }' unless defined(&CODE_CONV_TWO_OCTET_TO_UCS2);
    eval 'sub CODE_CONV_ISO8859_TO_UCS2 {
        my($funcName, $tableName, $altChar) = @_;
	    eval q( &ft_char_code_t $funcName( &ft_char_code_t  &codeSrc){  &ucs2_t  &codeDst = 0;  &if ( &codeSrc>=0xa0)  &codeDst = $tableName->[ &codeSrc-0xa0];  &else  &if ( &codeSrc<0x80)  &codeDst =  &codeSrc;  &return  &codeDst;});
    }' unless defined(&CODE_CONV_ISO8859_TO_UCS2);
    eval 'sub CODE_CONV_CP_TO_UCS2 {
        my($funcName, $tableName) = @_;
	    eval q( &ft_char_code_t $funcName( &ft_char_code_t  &codeSrc){  &ucs2_t  &codeDst = 0;  &if ( &codeSrc>=0x80)  &codeDst = $tableName->[ &codeSrc-0x80];  &else  &if ( &codeSrc<0x80)  &codeDst =  &codeSrc;  &return  &codeDst;});
    }' unless defined(&CODE_CONV_CP_TO_UCS2);
    eval 'sub CODECONV_TEMPLATE {
        my($funcName) = @_;
	    eval q( &ft_char_code_t $funcName( &ft_char_code_t  &codeSrc));
    }' unless defined(&CODECONV_TEMPLATE);
    eval 'sub ENTRYFUNC_PROTO_TEMPLATE {
        my($funcName) = @_;
	    eval q( &Bool $funcName( &CharSetSelectionHints  &const * &charSetHints,  &CodeConverterInfo * &refCodeConverterInfo , \'int\' * &refMapID ));
    }' unless defined(&ENTRYFUNC_PROTO_TEMPLATE);
    eval 'sub ENTRYFUNC_TEMPLATE {
        my($funcName) = @_;
	    eval q( &ENTRYFUNC_PROTO_TEMPLATE($funcName);  &CCONV_MODULE_SETUP  &ENTRYFUNC_PROTO_TEMPLATE($funcName));
    }' unless defined(&ENTRYFUNC_TEMPLATE);
    eval 'sub STD_ENTRYFUNC_TEMPLATE {
        my($funcName) = @_;
	    eval q( &ENTRYFUNC_TEMPLATE($funcName) {  &return  &codeconv_search_map_id( &charSetHints,  &charSetRelations,  &mapIDRelations,  &refCodeConverterInfo,  &refMapID);});
    }' unless defined(&STD_ENTRYFUNC_TEMPLATE);
    eval 'sub CODECONV_CALLBACK_TEMPLATE {
        my($funcName) = @_;
	    eval q( &void $funcName( &CharSetSelectionHints  &const * &charSetHints,  &CodeConverterInfo * &refCodeConverterInfo , \'int\' * &refMapID ));
    }' unless defined(&CODECONV_CALLBACK_TEMPLATE);
}
if(defined(&FONTMODULE)) {
    if(0) {
	require 'xf86Module.ph';
    }
    require 'xttversion.ph';
    require 'cconvversion.ph';
} else {
    eval 'sub CCONV_MODULE_SETUP () {1;}' unless defined(&CCONV_MODULE_SETUP);
}
1;
