require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&XK_VoidSymbol)) {
    sub XK_VoidSymbol () {	0xffffff;}
}
if(defined(&XK_MISCELLANY)) {
    eval 'sub XK_BackSpace () {0xff08;}' unless defined(&XK_BackSpace);
    eval 'sub XK_Tab () {0xff09;}' unless defined(&XK_Tab);
    eval 'sub XK_Linefeed () {0xff0a;}' unless defined(&XK_Linefeed);
    eval 'sub XK_Clear () {0xff0b;}' unless defined(&XK_Clear);
    eval 'sub XK_Return () {0xff0d;}' unless defined(&XK_Return);
    eval 'sub XK_Pause () {0xff13;}' unless defined(&XK_Pause);
    eval 'sub XK_Scroll_Lock () {0xff14;}' unless defined(&XK_Scroll_Lock);
    eval 'sub XK_Sys_Req () {0xff15;}' unless defined(&XK_Sys_Req);
    eval 'sub XK_Escape () {0xff1b;}' unless defined(&XK_Escape);
    eval 'sub XK_Delete () {0xffff;}' unless defined(&XK_Delete);
    eval 'sub XK_Multi_key () {0xff20;}' unless defined(&XK_Multi_key);
    eval 'sub XK_Codeinput () {0xff37;}' unless defined(&XK_Codeinput);
    eval 'sub XK_SingleCandidate () {0xff3c;}' unless defined(&XK_SingleCandidate);
    eval 'sub XK_MultipleCandidate () {0xff3d;}' unless defined(&XK_MultipleCandidate);
    eval 'sub XK_PreviousCandidate () {0xff3e;}' unless defined(&XK_PreviousCandidate);
    eval 'sub XK_Kanji () {0xff21;}' unless defined(&XK_Kanji);
    eval 'sub XK_Muhenkan () {0xff22;}' unless defined(&XK_Muhenkan);
    eval 'sub XK_Henkan_Mode () {0xff23;}' unless defined(&XK_Henkan_Mode);
    eval 'sub XK_Henkan () {0xff23;}' unless defined(&XK_Henkan);
    eval 'sub XK_Romaji () {0xff24;}' unless defined(&XK_Romaji);
    eval 'sub XK_Hiragana () {0xff25;}' unless defined(&XK_Hiragana);
    eval 'sub XK_Katakana () {0xff26;}' unless defined(&XK_Katakana);
    eval 'sub XK_Hiragana_Katakana () {0xff27;}' unless defined(&XK_Hiragana_Katakana);
    eval 'sub XK_Zenkaku () {0xff28;}' unless defined(&XK_Zenkaku);
    eval 'sub XK_Hankaku () {0xff29;}' unless defined(&XK_Hankaku);
    eval 'sub XK_Zenkaku_Hankaku () {0xff2a;}' unless defined(&XK_Zenkaku_Hankaku);
    eval 'sub XK_Touroku () {0xff2b;}' unless defined(&XK_Touroku);
    eval 'sub XK_Massyo () {0xff2c;}' unless defined(&XK_Massyo);
    eval 'sub XK_Kana_Lock () {0xff2d;}' unless defined(&XK_Kana_Lock);
    eval 'sub XK_Kana_Shift () {0xff2e;}' unless defined(&XK_Kana_Shift);
    eval 'sub XK_Eisu_Shift () {0xff2f;}' unless defined(&XK_Eisu_Shift);
    eval 'sub XK_Eisu_toggle () {0xff30;}' unless defined(&XK_Eisu_toggle);
    eval 'sub XK_Kanji_Bangou () {0xff37;}' unless defined(&XK_Kanji_Bangou);
    eval 'sub XK_Zen_Koho () {0xff3d;}' unless defined(&XK_Zen_Koho);
    eval 'sub XK_Mae_Koho () {0xff3e;}' unless defined(&XK_Mae_Koho);
    eval 'sub XK_Home () {0xff50;}' unless defined(&XK_Home);
    eval 'sub XK_Left () {0xff51;}' unless defined(&XK_Left);
    eval 'sub XK_Up () {0xff52;}' unless defined(&XK_Up);
    eval 'sub XK_Right () {0xff53;}' unless defined(&XK_Right);
    eval 'sub XK_Down () {0xff54;}' unless defined(&XK_Down);
    eval 'sub XK_Prior () {0xff55;}' unless defined(&XK_Prior);
    eval 'sub XK_Page_Up () {0xff55;}' unless defined(&XK_Page_Up);
    eval 'sub XK_Next () {0xff56;}' unless defined(&XK_Next);
    eval 'sub XK_Page_Down () {0xff56;}' unless defined(&XK_Page_Down);
    eval 'sub XK_End () {0xff57;}' unless defined(&XK_End);
    eval 'sub XK_Begin () {0xff58;}' unless defined(&XK_Begin);
    eval 'sub XK_Select () {0xff60;}' unless defined(&XK_Select);
    eval 'sub XK_Print () {0xff61;}' unless defined(&XK_Print);
    eval 'sub XK_Execute () {0xff62;}' unless defined(&XK_Execute);
    eval 'sub XK_Insert () {0xff63;}' unless defined(&XK_Insert);
    eval 'sub XK_Undo () {0xff65;}' unless defined(&XK_Undo);
    eval 'sub XK_Redo () {0xff66;}' unless defined(&XK_Redo);
    eval 'sub XK_Menu () {0xff67;}' unless defined(&XK_Menu);
    eval 'sub XK_Find () {0xff68;}' unless defined(&XK_Find);
    eval 'sub XK_Cancel () {0xff69;}' unless defined(&XK_Cancel);
    eval 'sub XK_Help () {0xff6a;}' unless defined(&XK_Help);
    eval 'sub XK_Break () {0xff6b;}' unless defined(&XK_Break);
    eval 'sub XK_Mode_switch () {0xff7e;}' unless defined(&XK_Mode_switch);
    eval 'sub XK_script_switch () {0xff7e;}' unless defined(&XK_script_switch);
    eval 'sub XK_Num_Lock () {0xff7f;}' unless defined(&XK_Num_Lock);
    eval 'sub XK_KP_Space () {0xff80;}' unless defined(&XK_KP_Space);
    eval 'sub XK_KP_Tab () {0xff89;}' unless defined(&XK_KP_Tab);
    eval 'sub XK_KP_Enter () {0xff8d;}' unless defined(&XK_KP_Enter);
    eval 'sub XK_KP_F1 () {0xff91;}' unless defined(&XK_KP_F1);
    eval 'sub XK_KP_F2 () {0xff92;}' unless defined(&XK_KP_F2);
    eval 'sub XK_KP_F3 () {0xff93;}' unless defined(&XK_KP_F3);
    eval 'sub XK_KP_F4 () {0xff94;}' unless defined(&XK_KP_F4);
    eval 'sub XK_KP_Home () {0xff95;}' unless defined(&XK_KP_Home);
    eval 'sub XK_KP_Left () {0xff96;}' unless defined(&XK_KP_Left);
    eval 'sub XK_KP_Up () {0xff97;}' unless defined(&XK_KP_Up);
    eval 'sub XK_KP_Right () {0xff98;}' unless defined(&XK_KP_Right);
    eval 'sub XK_KP_Down () {0xff99;}' unless defined(&XK_KP_Down);
    eval 'sub XK_KP_Prior () {0xff9a;}' unless defined(&XK_KP_Prior);
    eval 'sub XK_KP_Page_Up () {0xff9a;}' unless defined(&XK_KP_Page_Up);
    eval 'sub XK_KP_Next () {0xff9b;}' unless defined(&XK_KP_Next);
    eval 'sub XK_KP_Page_Down () {0xff9b;}' unless defined(&XK_KP_Page_Down);
    eval 'sub XK_KP_End () {0xff9c;}' unless defined(&XK_KP_End);
    eval 'sub XK_KP_Begin () {0xff9d;}' unless defined(&XK_KP_Begin);
    eval 'sub XK_KP_Insert () {0xff9e;}' unless defined(&XK_KP_Insert);
    eval 'sub XK_KP_Delete () {0xff9f;}' unless defined(&XK_KP_Delete);
    eval 'sub XK_KP_Equal () {0xffbd;}' unless defined(&XK_KP_Equal);
    eval 'sub XK_KP_Multiply () {0xffaa;}' unless defined(&XK_KP_Multiply);
    eval 'sub XK_KP_Add () {0xffab;}' unless defined(&XK_KP_Add);
    eval 'sub XK_KP_Separator () {0xffac;}' unless defined(&XK_KP_Separator);
    eval 'sub XK_KP_Subtract () {0xffad;}' unless defined(&XK_KP_Subtract);
    eval 'sub XK_KP_Decimal () {0xffae;}' unless defined(&XK_KP_Decimal);
    eval 'sub XK_KP_Divide () {0xffaf;}' unless defined(&XK_KP_Divide);
    eval 'sub XK_KP_0 () {0xffb0;}' unless defined(&XK_KP_0);
    eval 'sub XK_KP_1 () {0xffb1;}' unless defined(&XK_KP_1);
    eval 'sub XK_KP_2 () {0xffb2;}' unless defined(&XK_KP_2);
    eval 'sub XK_KP_3 () {0xffb3;}' unless defined(&XK_KP_3);
    eval 'sub XK_KP_4 () {0xffb4;}' unless defined(&XK_KP_4);
    eval 'sub XK_KP_5 () {0xffb5;}' unless defined(&XK_KP_5);
    eval 'sub XK_KP_6 () {0xffb6;}' unless defined(&XK_KP_6);
    eval 'sub XK_KP_7 () {0xffb7;}' unless defined(&XK_KP_7);
    eval 'sub XK_KP_8 () {0xffb8;}' unless defined(&XK_KP_8);
    eval 'sub XK_KP_9 () {0xffb9;}' unless defined(&XK_KP_9);
    eval 'sub XK_F1 () {0xffbe;}' unless defined(&XK_F1);
    eval 'sub XK_F2 () {0xffbf;}' unless defined(&XK_F2);
    eval 'sub XK_F3 () {0xffc0;}' unless defined(&XK_F3);
    eval 'sub XK_F4 () {0xffc1;}' unless defined(&XK_F4);
    eval 'sub XK_F5 () {0xffc2;}' unless defined(&XK_F5);
    eval 'sub XK_F6 () {0xffc3;}' unless defined(&XK_F6);
    eval 'sub XK_F7 () {0xffc4;}' unless defined(&XK_F7);
    eval 'sub XK_F8 () {0xffc5;}' unless defined(&XK_F8);
    eval 'sub XK_F9 () {0xffc6;}' unless defined(&XK_F9);
    eval 'sub XK_F10 () {0xffc7;}' unless defined(&XK_F10);
    eval 'sub XK_F11 () {0xffc8;}' unless defined(&XK_F11);
    eval 'sub XK_L1 () {0xffc8;}' unless defined(&XK_L1);
    eval 'sub XK_F12 () {0xffc9;}' unless defined(&XK_F12);
    eval 'sub XK_L2 () {0xffc9;}' unless defined(&XK_L2);
    eval 'sub XK_F13 () {0xffca;}' unless defined(&XK_F13);
    eval 'sub XK_L3 () {0xffca;}' unless defined(&XK_L3);
    eval 'sub XK_F14 () {0xffcb;}' unless defined(&XK_F14);
    eval 'sub XK_L4 () {0xffcb;}' unless defined(&XK_L4);
    eval 'sub XK_F15 () {0xffcc;}' unless defined(&XK_F15);
    eval 'sub XK_L5 () {0xffcc;}' unless defined(&XK_L5);
    eval 'sub XK_F16 () {0xffcd;}' unless defined(&XK_F16);
    eval 'sub XK_L6 () {0xffcd;}' unless defined(&XK_L6);
    eval 'sub XK_F17 () {0xffce;}' unless defined(&XK_F17);
    eval 'sub XK_L7 () {0xffce;}' unless defined(&XK_L7);
    eval 'sub XK_F18 () {0xffcf;}' unless defined(&XK_F18);
    eval 'sub XK_L8 () {0xffcf;}' unless defined(&XK_L8);
    eval 'sub XK_F19 () {0xffd0;}' unless defined(&XK_F19);
    eval 'sub XK_L9 () {0xffd0;}' unless defined(&XK_L9);
    eval 'sub XK_F20 () {0xffd1;}' unless defined(&XK_F20);
    eval 'sub XK_L10 () {0xffd1;}' unless defined(&XK_L10);
    eval 'sub XK_F21 () {0xffd2;}' unless defined(&XK_F21);
    eval 'sub XK_R1 () {0xffd2;}' unless defined(&XK_R1);
    eval 'sub XK_F22 () {0xffd3;}' unless defined(&XK_F22);
    eval 'sub XK_R2 () {0xffd3;}' unless defined(&XK_R2);
    eval 'sub XK_F23 () {0xffd4;}' unless defined(&XK_F23);
    eval 'sub XK_R3 () {0xffd4;}' unless defined(&XK_R3);
    eval 'sub XK_F24 () {0xffd5;}' unless defined(&XK_F24);
    eval 'sub XK_R4 () {0xffd5;}' unless defined(&XK_R4);
    eval 'sub XK_F25 () {0xffd6;}' unless defined(&XK_F25);
    eval 'sub XK_R5 () {0xffd6;}' unless defined(&XK_R5);
    eval 'sub XK_F26 () {0xffd7;}' unless defined(&XK_F26);
    eval 'sub XK_R6 () {0xffd7;}' unless defined(&XK_R6);
    eval 'sub XK_F27 () {0xffd8;}' unless defined(&XK_F27);
    eval 'sub XK_R7 () {0xffd8;}' unless defined(&XK_R7);
    eval 'sub XK_F28 () {0xffd9;}' unless defined(&XK_F28);
    eval 'sub XK_R8 () {0xffd9;}' unless defined(&XK_R8);
    eval 'sub XK_F29 () {0xffda;}' unless defined(&XK_F29);
    eval 'sub XK_R9 () {0xffda;}' unless defined(&XK_R9);
    eval 'sub XK_F30 () {0xffdb;}' unless defined(&XK_F30);
    eval 'sub XK_R10 () {0xffdb;}' unless defined(&XK_R10);
    eval 'sub XK_F31 () {0xffdc;}' unless defined(&XK_F31);
    eval 'sub XK_R11 () {0xffdc;}' unless defined(&XK_R11);
    eval 'sub XK_F32 () {0xffdd;}' unless defined(&XK_F32);
    eval 'sub XK_R12 () {0xffdd;}' unless defined(&XK_R12);
    eval 'sub XK_F33 () {0xffde;}' unless defined(&XK_F33);
    eval 'sub XK_R13 () {0xffde;}' unless defined(&XK_R13);
    eval 'sub XK_F34 () {0xffdf;}' unless defined(&XK_F34);
    eval 'sub XK_R14 () {0xffdf;}' unless defined(&XK_R14);
    eval 'sub XK_F35 () {0xffe0;}' unless defined(&XK_F35);
    eval 'sub XK_R15 () {0xffe0;}' unless defined(&XK_R15);
    eval 'sub XK_Shift_L () {0xffe1;}' unless defined(&XK_Shift_L);
    eval 'sub XK_Shift_R () {0xffe2;}' unless defined(&XK_Shift_R);
    eval 'sub XK_Control_L () {0xffe3;}' unless defined(&XK_Control_L);
    eval 'sub XK_Control_R () {0xffe4;}' unless defined(&XK_Control_R);
    eval 'sub XK_Caps_Lock () {0xffe5;}' unless defined(&XK_Caps_Lock);
    eval 'sub XK_Shift_Lock () {0xffe6;}' unless defined(&XK_Shift_Lock);
    eval 'sub XK_Meta_L () {0xffe7;}' unless defined(&XK_Meta_L);
    eval 'sub XK_Meta_R () {0xffe8;}' unless defined(&XK_Meta_R);
    eval 'sub XK_Alt_L () {0xffe9;}' unless defined(&XK_Alt_L);
    eval 'sub XK_Alt_R () {0xffea;}' unless defined(&XK_Alt_R);
    eval 'sub XK_Super_L () {0xffeb;}' unless defined(&XK_Super_L);
    eval 'sub XK_Super_R () {0xffec;}' unless defined(&XK_Super_R);
    eval 'sub XK_Hyper_L () {0xffed;}' unless defined(&XK_Hyper_L);
    eval 'sub XK_Hyper_R () {0xffee;}' unless defined(&XK_Hyper_R);
}
if(defined(&XK_XKB_KEYS)) {
    eval 'sub XK_ISO_Lock () {0xfe01;}' unless defined(&XK_ISO_Lock);
    eval 'sub XK_ISO_Level2_Latch () {0xfe02;}' unless defined(&XK_ISO_Level2_Latch);
    eval 'sub XK_ISO_Level3_Shift () {0xfe03;}' unless defined(&XK_ISO_Level3_Shift);
    eval 'sub XK_ISO_Level3_Latch () {0xfe04;}' unless defined(&XK_ISO_Level3_Latch);
    eval 'sub XK_ISO_Level3_Lock () {0xfe05;}' unless defined(&XK_ISO_Level3_Lock);
    eval 'sub XK_ISO_Group_Shift () {0xff7e;}' unless defined(&XK_ISO_Group_Shift);
    eval 'sub XK_ISO_Group_Latch () {0xfe06;}' unless defined(&XK_ISO_Group_Latch);
    eval 'sub XK_ISO_Group_Lock () {0xfe07;}' unless defined(&XK_ISO_Group_Lock);
    eval 'sub XK_ISO_Next_Group () {0xfe08;}' unless defined(&XK_ISO_Next_Group);
    eval 'sub XK_ISO_Next_Group_Lock () {0xfe09;}' unless defined(&XK_ISO_Next_Group_Lock);
    eval 'sub XK_ISO_Prev_Group () {0xfe0a;}' unless defined(&XK_ISO_Prev_Group);
    eval 'sub XK_ISO_Prev_Group_Lock () {0xfe0b;}' unless defined(&XK_ISO_Prev_Group_Lock);
    eval 'sub XK_ISO_First_Group () {0xfe0c;}' unless defined(&XK_ISO_First_Group);
    eval 'sub XK_ISO_First_Group_Lock () {0xfe0d;}' unless defined(&XK_ISO_First_Group_Lock);
    eval 'sub XK_ISO_Last_Group () {0xfe0e;}' unless defined(&XK_ISO_Last_Group);
    eval 'sub XK_ISO_Last_Group_Lock () {0xfe0f;}' unless defined(&XK_ISO_Last_Group_Lock);
    eval 'sub XK_ISO_Left_Tab () {0xfe20;}' unless defined(&XK_ISO_Left_Tab);
    eval 'sub XK_ISO_Move_Line_Up () {0xfe21;}' unless defined(&XK_ISO_Move_Line_Up);
    eval 'sub XK_ISO_Move_Line_Down () {0xfe22;}' unless defined(&XK_ISO_Move_Line_Down);
    eval 'sub XK_ISO_Partial_Line_Up () {0xfe23;}' unless defined(&XK_ISO_Partial_Line_Up);
    eval 'sub XK_ISO_Partial_Line_Down () {0xfe24;}' unless defined(&XK_ISO_Partial_Line_Down);
    eval 'sub XK_ISO_Partial_Space_Left () {0xfe25;}' unless defined(&XK_ISO_Partial_Space_Left);
    eval 'sub XK_ISO_Partial_Space_Right () {0xfe26;}' unless defined(&XK_ISO_Partial_Space_Right);
    eval 'sub XK_ISO_Set_Margin_Left () {0xfe27;}' unless defined(&XK_ISO_Set_Margin_Left);
    eval 'sub XK_ISO_Set_Margin_Right () {0xfe28;}' unless defined(&XK_ISO_Set_Margin_Right);
    eval 'sub XK_ISO_Release_Margin_Left () {0xfe29;}' unless defined(&XK_ISO_Release_Margin_Left);
    eval 'sub XK_ISO_Release_Margin_Right () {0xfe2a;}' unless defined(&XK_ISO_Release_Margin_Right);
    eval 'sub XK_ISO_Release_Both_Margins () {0xfe2b;}' unless defined(&XK_ISO_Release_Both_Margins);
    eval 'sub XK_ISO_Fast_Cursor_Left () {0xfe2c;}' unless defined(&XK_ISO_Fast_Cursor_Left);
    eval 'sub XK_ISO_Fast_Cursor_Right () {0xfe2d;}' unless defined(&XK_ISO_Fast_Cursor_Right);
    eval 'sub XK_ISO_Fast_Cursor_Up () {0xfe2e;}' unless defined(&XK_ISO_Fast_Cursor_Up);
    eval 'sub XK_ISO_Fast_Cursor_Down () {0xfe2f;}' unless defined(&XK_ISO_Fast_Cursor_Down);
    eval 'sub XK_ISO_Continuous_Underline () {0xfe30;}' unless defined(&XK_ISO_Continuous_Underline);
    eval 'sub XK_ISO_Discontinuous_Underline () {0xfe31;}' unless defined(&XK_ISO_Discontinuous_Underline);
    eval 'sub XK_ISO_Emphasize () {0xfe32;}' unless defined(&XK_ISO_Emphasize);
    eval 'sub XK_ISO_Center_Object () {0xfe33;}' unless defined(&XK_ISO_Center_Object);
    eval 'sub XK_ISO_Enter () {0xfe34;}' unless defined(&XK_ISO_Enter);
    eval 'sub XK_dead_grave () {0xfe50;}' unless defined(&XK_dead_grave);
    eval 'sub XK_dead_acute () {0xfe51;}' unless defined(&XK_dead_acute);
    eval 'sub XK_dead_circumflex () {0xfe52;}' unless defined(&XK_dead_circumflex);
    eval 'sub XK_dead_tilde () {0xfe53;}' unless defined(&XK_dead_tilde);
    eval 'sub XK_dead_macron () {0xfe54;}' unless defined(&XK_dead_macron);
    eval 'sub XK_dead_breve () {0xfe55;}' unless defined(&XK_dead_breve);
    eval 'sub XK_dead_abovedot () {0xfe56;}' unless defined(&XK_dead_abovedot);
    eval 'sub XK_dead_diaeresis () {0xfe57;}' unless defined(&XK_dead_diaeresis);
    eval 'sub XK_dead_abovering () {0xfe58;}' unless defined(&XK_dead_abovering);
    eval 'sub XK_dead_doubleacute () {0xfe59;}' unless defined(&XK_dead_doubleacute);
    eval 'sub XK_dead_caron () {0xfe5a;}' unless defined(&XK_dead_caron);
    eval 'sub XK_dead_cedilla () {0xfe5b;}' unless defined(&XK_dead_cedilla);
    eval 'sub XK_dead_ogonek () {0xfe5c;}' unless defined(&XK_dead_ogonek);
    eval 'sub XK_dead_iota () {0xfe5d;}' unless defined(&XK_dead_iota);
    eval 'sub XK_dead_voiced_sound () {0xfe5e;}' unless defined(&XK_dead_voiced_sound);
    eval 'sub XK_dead_semivoiced_sound () {0xfe5f;}' unless defined(&XK_dead_semivoiced_sound);
    eval 'sub XK_dead_belowdot () {0xfe60;}' unless defined(&XK_dead_belowdot);
    eval 'sub XK_dead_hook () {0xfe61;}' unless defined(&XK_dead_hook);
    eval 'sub XK_dead_horn () {0xfe62;}' unless defined(&XK_dead_horn);
    eval 'sub XK_First_Virtual_Screen () {0xfed0;}' unless defined(&XK_First_Virtual_Screen);
    eval 'sub XK_Prev_Virtual_Screen () {0xfed1;}' unless defined(&XK_Prev_Virtual_Screen);
    eval 'sub XK_Next_Virtual_Screen () {0xfed2;}' unless defined(&XK_Next_Virtual_Screen);
    eval 'sub XK_Last_Virtual_Screen () {0xfed4;}' unless defined(&XK_Last_Virtual_Screen);
    eval 'sub XK_Terminate_Server () {0xfed5;}' unless defined(&XK_Terminate_Server);
    eval 'sub XK_AccessX_Enable () {0xfe70;}' unless defined(&XK_AccessX_Enable);
    eval 'sub XK_AccessX_Feedback_Enable () {0xfe71;}' unless defined(&XK_AccessX_Feedback_Enable);
    eval 'sub XK_RepeatKeys_Enable () {0xfe72;}' unless defined(&XK_RepeatKeys_Enable);
    eval 'sub XK_SlowKeys_Enable () {0xfe73;}' unless defined(&XK_SlowKeys_Enable);
    eval 'sub XK_BounceKeys_Enable () {0xfe74;}' unless defined(&XK_BounceKeys_Enable);
    eval 'sub XK_StickyKeys_Enable () {0xfe75;}' unless defined(&XK_StickyKeys_Enable);
    eval 'sub XK_MouseKeys_Enable () {0xfe76;}' unless defined(&XK_MouseKeys_Enable);
    eval 'sub XK_MouseKeys_Accel_Enable () {0xfe77;}' unless defined(&XK_MouseKeys_Accel_Enable);
    eval 'sub XK_Overlay1_Enable () {0xfe78;}' unless defined(&XK_Overlay1_Enable);
    eval 'sub XK_Overlay2_Enable () {0xfe79;}' unless defined(&XK_Overlay2_Enable);
    eval 'sub XK_AudibleBell_Enable () {0xfe7a;}' unless defined(&XK_AudibleBell_Enable);
    eval 'sub XK_Pointer_Left () {0xfee0;}' unless defined(&XK_Pointer_Left);
    eval 'sub XK_Pointer_Right () {0xfee1;}' unless defined(&XK_Pointer_Right);
    eval 'sub XK_Pointer_Up () {0xfee2;}' unless defined(&XK_Pointer_Up);
    eval 'sub XK_Pointer_Down () {0xfee3;}' unless defined(&XK_Pointer_Down);
    eval 'sub XK_Pointer_UpLeft () {0xfee4;}' unless defined(&XK_Pointer_UpLeft);
    eval 'sub XK_Pointer_UpRight () {0xfee5;}' unless defined(&XK_Pointer_UpRight);
    eval 'sub XK_Pointer_DownLeft () {0xfee6;}' unless defined(&XK_Pointer_DownLeft);
    eval 'sub XK_Pointer_DownRight () {0xfee7;}' unless defined(&XK_Pointer_DownRight);
    eval 'sub XK_Pointer_Button_Dflt () {0xfee8;}' unless defined(&XK_Pointer_Button_Dflt);
    eval 'sub XK_Pointer_Button1 () {0xfee9;}' unless defined(&XK_Pointer_Button1);
    eval 'sub XK_Pointer_Button2 () {0xfeea;}' unless defined(&XK_Pointer_Button2);
    eval 'sub XK_Pointer_Button3 () {0xfeeb;}' unless defined(&XK_Pointer_Button3);
    eval 'sub XK_Pointer_Button4 () {0xfeec;}' unless defined(&XK_Pointer_Button4);
    eval 'sub XK_Pointer_Button5 () {0xfeed;}' unless defined(&XK_Pointer_Button5);
    eval 'sub XK_Pointer_DblClick_Dflt () {0xfeee;}' unless defined(&XK_Pointer_DblClick_Dflt);
    eval 'sub XK_Pointer_DblClick1 () {0xfeef;}' unless defined(&XK_Pointer_DblClick1);
    eval 'sub XK_Pointer_DblClick2 () {0xfef0;}' unless defined(&XK_Pointer_DblClick2);
    eval 'sub XK_Pointer_DblClick3 () {0xfef1;}' unless defined(&XK_Pointer_DblClick3);
    eval 'sub XK_Pointer_DblClick4 () {0xfef2;}' unless defined(&XK_Pointer_DblClick4);
    eval 'sub XK_Pointer_DblClick5 () {0xfef3;}' unless defined(&XK_Pointer_DblClick5);
    eval 'sub XK_Pointer_Drag_Dflt () {0xfef4;}' unless defined(&XK_Pointer_Drag_Dflt);
    eval 'sub XK_Pointer_Drag1 () {0xfef5;}' unless defined(&XK_Pointer_Drag1);
    eval 'sub XK_Pointer_Drag2 () {0xfef6;}' unless defined(&XK_Pointer_Drag2);
    eval 'sub XK_Pointer_Drag3 () {0xfef7;}' unless defined(&XK_Pointer_Drag3);
    eval 'sub XK_Pointer_Drag4 () {0xfef8;}' unless defined(&XK_Pointer_Drag4);
    eval 'sub XK_Pointer_Drag5 () {0xfefd;}' unless defined(&XK_Pointer_Drag5);
    eval 'sub XK_Pointer_EnableKeys () {0xfef9;}' unless defined(&XK_Pointer_EnableKeys);
    eval 'sub XK_Pointer_Accelerate () {0xfefa;}' unless defined(&XK_Pointer_Accelerate);
    eval 'sub XK_Pointer_DfltBtnNext () {0xfefb;}' unless defined(&XK_Pointer_DfltBtnNext);
    eval 'sub XK_Pointer_DfltBtnPrev () {0xfefc;}' unless defined(&XK_Pointer_DfltBtnPrev);
}
if(defined(&XK_3270)) {
    eval 'sub XK_3270_Duplicate () {0xfd01;}' unless defined(&XK_3270_Duplicate);
    eval 'sub XK_3270_FieldMark () {0xfd02;}' unless defined(&XK_3270_FieldMark);
    eval 'sub XK_3270_Right2 () {0xfd03;}' unless defined(&XK_3270_Right2);
    eval 'sub XK_3270_Left2 () {0xfd04;}' unless defined(&XK_3270_Left2);
    eval 'sub XK_3270_BackTab () {0xfd05;}' unless defined(&XK_3270_BackTab);
    eval 'sub XK_3270_EraseEOF () {0xfd06;}' unless defined(&XK_3270_EraseEOF);
    eval 'sub XK_3270_EraseInput () {0xfd07;}' unless defined(&XK_3270_EraseInput);
    eval 'sub XK_3270_Reset () {0xfd08;}' unless defined(&XK_3270_Reset);
    eval 'sub XK_3270_Quit () {0xfd09;}' unless defined(&XK_3270_Quit);
    eval 'sub XK_3270_PA1 () {0xfd0a;}' unless defined(&XK_3270_PA1);
    eval 'sub XK_3270_PA2 () {0xfd0b;}' unless defined(&XK_3270_PA2);
    eval 'sub XK_3270_PA3 () {0xfd0c;}' unless defined(&XK_3270_PA3);
    eval 'sub XK_3270_Test () {0xfd0d;}' unless defined(&XK_3270_Test);
    eval 'sub XK_3270_Attn () {0xfd0e;}' unless defined(&XK_3270_Attn);
    eval 'sub XK_3270_CursorBlink () {0xfd0f;}' unless defined(&XK_3270_CursorBlink);
    eval 'sub XK_3270_AltCursor () {0xfd10;}' unless defined(&XK_3270_AltCursor);
    eval 'sub XK_3270_KeyClick () {0xfd11;}' unless defined(&XK_3270_KeyClick);
    eval 'sub XK_3270_Jump () {0xfd12;}' unless defined(&XK_3270_Jump);
    eval 'sub XK_3270_Ident () {0xfd13;}' unless defined(&XK_3270_Ident);
    eval 'sub XK_3270_Rule () {0xfd14;}' unless defined(&XK_3270_Rule);
    eval 'sub XK_3270_Copy () {0xfd15;}' unless defined(&XK_3270_Copy);
    eval 'sub XK_3270_Play () {0xfd16;}' unless defined(&XK_3270_Play);
    eval 'sub XK_3270_Setup () {0xfd17;}' unless defined(&XK_3270_Setup);
    eval 'sub XK_3270_Record () {0xfd18;}' unless defined(&XK_3270_Record);
    eval 'sub XK_3270_ChangeScreen () {0xfd19;}' unless defined(&XK_3270_ChangeScreen);
    eval 'sub XK_3270_DeleteWord () {0xfd1a;}' unless defined(&XK_3270_DeleteWord);
    eval 'sub XK_3270_ExSelect () {0xfd1b;}' unless defined(&XK_3270_ExSelect);
    eval 'sub XK_3270_CursorSelect () {0xfd1c;}' unless defined(&XK_3270_CursorSelect);
    eval 'sub XK_3270_PrintScreen () {0xfd1d;}' unless defined(&XK_3270_PrintScreen);
    eval 'sub XK_3270_Enter () {0xfd1e;}' unless defined(&XK_3270_Enter);
}
if(defined(&XK_LATIN1)) {
    eval 'sub XK_space () {0x20;}' unless defined(&XK_space);
    eval 'sub XK_exclam () {0x21;}' unless defined(&XK_exclam);
    eval 'sub XK_quotedbl () {0x22;}' unless defined(&XK_quotedbl);
    eval 'sub XK_numbersign () {0x23;}' unless defined(&XK_numbersign);
    eval 'sub XK_dollar () {0x24;}' unless defined(&XK_dollar);
    eval 'sub XK_percent () {0x25;}' unless defined(&XK_percent);
    eval 'sub XK_ampersand () {0x26;}' unless defined(&XK_ampersand);
    eval 'sub XK_apostrophe () {0x27;}' unless defined(&XK_apostrophe);
    eval 'sub XK_quoteright () {0x27;}' unless defined(&XK_quoteright);
    eval 'sub XK_parenleft () {0x28;}' unless defined(&XK_parenleft);
    eval 'sub XK_parenright () {0x29;}' unless defined(&XK_parenright);
    eval 'sub XK_asterisk () {0x2a;}' unless defined(&XK_asterisk);
    eval 'sub XK_plus () {0x2b;}' unless defined(&XK_plus);
    eval 'sub XK_comma () {0x2c;}' unless defined(&XK_comma);
    eval 'sub XK_minus () {0x2d;}' unless defined(&XK_minus);
    eval 'sub XK_period () {0x2e;}' unless defined(&XK_period);
    eval 'sub XK_slash () {0x2f;}' unless defined(&XK_slash);
    eval 'sub XK_0 () {0x30;}' unless defined(&XK_0);
    eval 'sub XK_1 () {0x31;}' unless defined(&XK_1);
    eval 'sub XK_2 () {0x32;}' unless defined(&XK_2);
    eval 'sub XK_3 () {0x33;}' unless defined(&XK_3);
    eval 'sub XK_4 () {0x34;}' unless defined(&XK_4);
    eval 'sub XK_5 () {0x35;}' unless defined(&XK_5);
    eval 'sub XK_6 () {0x36;}' unless defined(&XK_6);
    eval 'sub XK_7 () {0x37;}' unless defined(&XK_7);
    eval 'sub XK_8 () {0x38;}' unless defined(&XK_8);
    eval 'sub XK_9 () {0x39;}' unless defined(&XK_9);
    eval 'sub XK_colon () {0x3a;}' unless defined(&XK_colon);
    eval 'sub XK_semicolon () {0x3b;}' unless defined(&XK_semicolon);
    eval 'sub XK_less () {0x3c;}' unless defined(&XK_less);
    eval 'sub XK_equal () {0x3d;}' unless defined(&XK_equal);
    eval 'sub XK_greater () {0x3e;}' unless defined(&XK_greater);
    eval 'sub XK_question () {0x3f;}' unless defined(&XK_question);
    eval 'sub XK_at () {0x40;}' unless defined(&XK_at);
    eval 'sub XK_A () {0x41;}' unless defined(&XK_A);
    eval 'sub XK_B () {0x42;}' unless defined(&XK_B);
    eval 'sub XK_C () {0x43;}' unless defined(&XK_C);
    eval 'sub XK_D () {0x44;}' unless defined(&XK_D);
    eval 'sub XK_E () {0x45;}' unless defined(&XK_E);
    eval 'sub XK_F () {0x46;}' unless defined(&XK_F);
    eval 'sub XK_G () {0x47;}' unless defined(&XK_G);
    eval 'sub XK_H () {0x48;}' unless defined(&XK_H);
    eval 'sub XK_I () {0x49;}' unless defined(&XK_I);
    eval 'sub XK_J () {0x4a;}' unless defined(&XK_J);
    eval 'sub XK_K () {0x4b;}' unless defined(&XK_K);
    eval 'sub XK_L () {0x4c;}' unless defined(&XK_L);
    eval 'sub XK_M () {0x4d;}' unless defined(&XK_M);
    eval 'sub XK_N () {0x4e;}' unless defined(&XK_N);
    eval 'sub XK_O () {0x4f;}' unless defined(&XK_O);
    eval 'sub XK_P () {0x50;}' unless defined(&XK_P);
    eval 'sub XK_Q () {0x51;}' unless defined(&XK_Q);
    eval 'sub XK_R () {0x52;}' unless defined(&XK_R);
    eval 'sub XK_S () {0x53;}' unless defined(&XK_S);
    eval 'sub XK_T () {0x54;}' unless defined(&XK_T);
    eval 'sub XK_U () {0x55;}' unless defined(&XK_U);
    eval 'sub XK_V () {0x56;}' unless defined(&XK_V);
    eval 'sub XK_W () {0x57;}' unless defined(&XK_W);
    eval 'sub XK_X () {0x58;}' unless defined(&XK_X);
    eval 'sub XK_Y () {0x59;}' unless defined(&XK_Y);
    eval 'sub XK_Z () {0x5a;}' unless defined(&XK_Z);
    eval 'sub XK_bracketleft () {0x5b;}' unless defined(&XK_bracketleft);
    eval 'sub XK_backslash () {0x5c;}' unless defined(&XK_backslash);
    eval 'sub XK_bracketright () {0x5d;}' unless defined(&XK_bracketright);
    eval 'sub XK_asciicircum () {0x5e;}' unless defined(&XK_asciicircum);
    eval 'sub XK_underscore () {0x5f;}' unless defined(&XK_underscore);
    eval 'sub XK_grave () {0x60;}' unless defined(&XK_grave);
    eval 'sub XK_quoteleft () {0x60;}' unless defined(&XK_quoteleft);
    eval 'sub XK_a () {0x61;}' unless defined(&XK_a);
    eval 'sub XK_b () {0x62;}' unless defined(&XK_b);
    eval 'sub XK_c () {0x63;}' unless defined(&XK_c);
    eval 'sub XK_d () {0x64;}' unless defined(&XK_d);
    eval 'sub XK_e () {0x65;}' unless defined(&XK_e);
    eval 'sub XK_f () {0x66;}' unless defined(&XK_f);
    eval 'sub XK_g () {0x67;}' unless defined(&XK_g);
    eval 'sub XK_h () {0x68;}' unless defined(&XK_h);
    eval 'sub XK_i () {0x69;}' unless defined(&XK_i);
    eval 'sub XK_j () {0x6a;}' unless defined(&XK_j);
    eval 'sub XK_k () {0x6b;}' unless defined(&XK_k);
    eval 'sub XK_l () {0x6c;}' unless defined(&XK_l);
    eval 'sub XK_m () {0x6d;}' unless defined(&XK_m);
    eval 'sub XK_n () {0x6e;}' unless defined(&XK_n);
    eval 'sub XK_o () {0x6f;}' unless defined(&XK_o);
    eval 'sub XK_p () {0x70;}' unless defined(&XK_p);
    eval 'sub XK_q () {0x71;}' unless defined(&XK_q);
    eval 'sub XK_r () {0x72;}' unless defined(&XK_r);
    eval 'sub XK_s () {0x73;}' unless defined(&XK_s);
    eval 'sub XK_t () {0x74;}' unless defined(&XK_t);
    eval 'sub XK_u () {0x75;}' unless defined(&XK_u);
    eval 'sub XK_v () {0x76;}' unless defined(&XK_v);
    eval 'sub XK_w () {0x77;}' unless defined(&XK_w);
    eval 'sub XK_x () {0x78;}' unless defined(&XK_x);
    eval 'sub XK_y () {0x79;}' unless defined(&XK_y);
    eval 'sub XK_z () {0x7a;}' unless defined(&XK_z);
    eval 'sub XK_braceleft () {0x7b;}' unless defined(&XK_braceleft);
    eval 'sub XK_bar () {0x7c;}' unless defined(&XK_bar);
    eval 'sub XK_braceright () {0x7d;}' unless defined(&XK_braceright);
    eval 'sub XK_asciitilde () {0x7e;}' unless defined(&XK_asciitilde);
    eval 'sub XK_nobreakspace () {0xa0;}' unless defined(&XK_nobreakspace);
    eval 'sub XK_exclamdown () {0xa1;}' unless defined(&XK_exclamdown);
    eval 'sub XK_cent () {0xa2;}' unless defined(&XK_cent);
    eval 'sub XK_sterling () {0xa3;}' unless defined(&XK_sterling);
    eval 'sub XK_currency () {0xa4;}' unless defined(&XK_currency);
    eval 'sub XK_yen () {0xa5;}' unless defined(&XK_yen);
    eval 'sub XK_brokenbar () {0xa6;}' unless defined(&XK_brokenbar);
    eval 'sub XK_section () {0xa7;}' unless defined(&XK_section);
    eval 'sub XK_diaeresis () {0xa8;}' unless defined(&XK_diaeresis);
    eval 'sub XK_copyright () {0xa9;}' unless defined(&XK_copyright);
    eval 'sub XK_ordfeminine () {0xaa;}' unless defined(&XK_ordfeminine);
    eval 'sub XK_guillemotleft () {0xab;}' unless defined(&XK_guillemotleft);
    eval 'sub XK_notsign () {0xac;}' unless defined(&XK_notsign);
    eval 'sub XK_hyphen () {0xad;}' unless defined(&XK_hyphen);
    eval 'sub XK_registered () {0xae;}' unless defined(&XK_registered);
    eval 'sub XK_macron () {0xaf;}' unless defined(&XK_macron);
    eval 'sub XK_degree () {0xb0;}' unless defined(&XK_degree);
    eval 'sub XK_plusminus () {0xb1;}' unless defined(&XK_plusminus);
    eval 'sub XK_twosuperior () {0xb2;}' unless defined(&XK_twosuperior);
    eval 'sub XK_threesuperior () {0xb3;}' unless defined(&XK_threesuperior);
    eval 'sub XK_acute () {0xb4;}' unless defined(&XK_acute);
    eval 'sub XK_mu () {0xb5;}' unless defined(&XK_mu);
    eval 'sub XK_paragraph () {0xb6;}' unless defined(&XK_paragraph);
    eval 'sub XK_periodcentered () {0xb7;}' unless defined(&XK_periodcentered);
    eval 'sub XK_cedilla () {0xb8;}' unless defined(&XK_cedilla);
    eval 'sub XK_onesuperior () {0xb9;}' unless defined(&XK_onesuperior);
    eval 'sub XK_masculine () {0xba;}' unless defined(&XK_masculine);
    eval 'sub XK_guillemotright () {0xbb;}' unless defined(&XK_guillemotright);
    eval 'sub XK_onequarter () {0xbc;}' unless defined(&XK_onequarter);
    eval 'sub XK_onehalf () {0xbd;}' unless defined(&XK_onehalf);
    eval 'sub XK_threequarters () {0xbe;}' unless defined(&XK_threequarters);
    eval 'sub XK_questiondown () {0xbf;}' unless defined(&XK_questiondown);
    eval 'sub XK_Agrave () {0xc0;}' unless defined(&XK_Agrave);
    eval 'sub XK_Aacute () {0xc1;}' unless defined(&XK_Aacute);
    eval 'sub XK_Acircumflex () {0xc2;}' unless defined(&XK_Acircumflex);
    eval 'sub XK_Atilde () {0xc3;}' unless defined(&XK_Atilde);
    eval 'sub XK_Adiaeresis () {0xc4;}' unless defined(&XK_Adiaeresis);
    eval 'sub XK_Aring () {0xc5;}' unless defined(&XK_Aring);
    eval 'sub XK_AE () {0xc6;}' unless defined(&XK_AE);
    eval 'sub XK_Ccedilla () {0xc7;}' unless defined(&XK_Ccedilla);
    eval 'sub XK_Egrave () {0xc8;}' unless defined(&XK_Egrave);
    eval 'sub XK_Eacute () {0xc9;}' unless defined(&XK_Eacute);
    eval 'sub XK_Ecircumflex () {0xca;}' unless defined(&XK_Ecircumflex);
    eval 'sub XK_Ediaeresis () {0xcb;}' unless defined(&XK_Ediaeresis);
    eval 'sub XK_Igrave () {0xcc;}' unless defined(&XK_Igrave);
    eval 'sub XK_Iacute () {0xcd;}' unless defined(&XK_Iacute);
    eval 'sub XK_Icircumflex () {0xce;}' unless defined(&XK_Icircumflex);
    eval 'sub XK_Idiaeresis () {0xcf;}' unless defined(&XK_Idiaeresis);
    eval 'sub XK_ETH () {0xd0;}' unless defined(&XK_ETH);
    eval 'sub XK_Eth () {0xd0;}' unless defined(&XK_Eth);
    eval 'sub XK_Ntilde () {0xd1;}' unless defined(&XK_Ntilde);
    eval 'sub XK_Ograve () {0xd2;}' unless defined(&XK_Ograve);
    eval 'sub XK_Oacute () {0xd3;}' unless defined(&XK_Oacute);
    eval 'sub XK_Ocircumflex () {0xd4;}' unless defined(&XK_Ocircumflex);
    eval 'sub XK_Otilde () {0xd5;}' unless defined(&XK_Otilde);
    eval 'sub XK_Odiaeresis () {0xd6;}' unless defined(&XK_Odiaeresis);
    eval 'sub XK_multiply () {0xd7;}' unless defined(&XK_multiply);
    eval 'sub XK_Ooblique () {0xd8;}' unless defined(&XK_Ooblique);
    eval 'sub XK_Oslash () { &XK_Ooblique;}' unless defined(&XK_Oslash);
    eval 'sub XK_Ugrave () {0xd9;}' unless defined(&XK_Ugrave);
    eval 'sub XK_Uacute () {0xda;}' unless defined(&XK_Uacute);
    eval 'sub XK_Ucircumflex () {0xdb;}' unless defined(&XK_Ucircumflex);
    eval 'sub XK_Udiaeresis () {0xdc;}' unless defined(&XK_Udiaeresis);
    eval 'sub XK_Yacute () {0xdd;}' unless defined(&XK_Yacute);
    eval 'sub XK_THORN () {0xde;}' unless defined(&XK_THORN);
    eval 'sub XK_Thorn () {0xde;}' unless defined(&XK_Thorn);
    eval 'sub XK_ssharp () {0xdf;}' unless defined(&XK_ssharp);
    eval 'sub XK_agrave () {0xe0;}' unless defined(&XK_agrave);
    eval 'sub XK_aacute () {0xe1;}' unless defined(&XK_aacute);
    eval 'sub XK_acircumflex () {0xe2;}' unless defined(&XK_acircumflex);
    eval 'sub XK_atilde () {0xe3;}' unless defined(&XK_atilde);
    eval 'sub XK_adiaeresis () {0xe4;}' unless defined(&XK_adiaeresis);
    eval 'sub XK_aring () {0xe5;}' unless defined(&XK_aring);
    eval 'sub XK_ae () {0xe6;}' unless defined(&XK_ae);
    eval 'sub XK_ccedilla () {0xe7;}' unless defined(&XK_ccedilla);
    eval 'sub XK_egrave () {0xe8;}' unless defined(&XK_egrave);
    eval 'sub XK_eacute () {0xe9;}' unless defined(&XK_eacute);
    eval 'sub XK_ecircumflex () {0xea;}' unless defined(&XK_ecircumflex);
    eval 'sub XK_ediaeresis () {0xeb;}' unless defined(&XK_ediaeresis);
    eval 'sub XK_igrave () {0xec;}' unless defined(&XK_igrave);
    eval 'sub XK_iacute () {0xed;}' unless defined(&XK_iacute);
    eval 'sub XK_icircumflex () {0xee;}' unless defined(&XK_icircumflex);
    eval 'sub XK_idiaeresis () {0xef;}' unless defined(&XK_idiaeresis);
    eval 'sub XK_eth () {0xf0;}' unless defined(&XK_eth);
    eval 'sub XK_ntilde () {0xf1;}' unless defined(&XK_ntilde);
    eval 'sub XK_ograve () {0xf2;}' unless defined(&XK_ograve);
    eval 'sub XK_oacute () {0xf3;}' unless defined(&XK_oacute);
    eval 'sub XK_ocircumflex () {0xf4;}' unless defined(&XK_ocircumflex);
    eval 'sub XK_otilde () {0xf5;}' unless defined(&XK_otilde);
    eval 'sub XK_odiaeresis () {0xf6;}' unless defined(&XK_odiaeresis);
    eval 'sub XK_division () {0xf7;}' unless defined(&XK_division);
    eval 'sub XK_oslash () {0xf8;}' unless defined(&XK_oslash);
    eval 'sub XK_ooblique () { &XK_oslash;}' unless defined(&XK_ooblique);
    eval 'sub XK_ugrave () {0xf9;}' unless defined(&XK_ugrave);
    eval 'sub XK_uacute () {0xfa;}' unless defined(&XK_uacute);
    eval 'sub XK_ucircumflex () {0xfb;}' unless defined(&XK_ucircumflex);
    eval 'sub XK_udiaeresis () {0xfc;}' unless defined(&XK_udiaeresis);
    eval 'sub XK_yacute () {0xfd;}' unless defined(&XK_yacute);
    eval 'sub XK_thorn () {0xfe;}' unless defined(&XK_thorn);
    eval 'sub XK_ydiaeresis () {0xff;}' unless defined(&XK_ydiaeresis);
}
if(defined(&XK_LATIN2)) {
    eval 'sub XK_Aogonek () {0x1a1;}' unless defined(&XK_Aogonek);
    eval 'sub XK_breve () {0x1a2;}' unless defined(&XK_breve);
    eval 'sub XK_Lstroke () {0x1a3;}' unless defined(&XK_Lstroke);
    eval 'sub XK_Lcaron () {0x1a5;}' unless defined(&XK_Lcaron);
    eval 'sub XK_Sacute () {0x1a6;}' unless defined(&XK_Sacute);
    eval 'sub XK_Scaron () {0x1a9;}' unless defined(&XK_Scaron);
    eval 'sub XK_Scedilla () {0x1aa;}' unless defined(&XK_Scedilla);
    eval 'sub XK_Tcaron () {0x1ab;}' unless defined(&XK_Tcaron);
    eval 'sub XK_Zacute () {0x1ac;}' unless defined(&XK_Zacute);
    eval 'sub XK_Zcaron () {0x1ae;}' unless defined(&XK_Zcaron);
    eval 'sub XK_Zabovedot () {0x1af;}' unless defined(&XK_Zabovedot);
    eval 'sub XK_aogonek () {0x1b1;}' unless defined(&XK_aogonek);
    eval 'sub XK_ogonek () {0x1b2;}' unless defined(&XK_ogonek);
    eval 'sub XK_lstroke () {0x1b3;}' unless defined(&XK_lstroke);
    eval 'sub XK_lcaron () {0x1b5;}' unless defined(&XK_lcaron);
    eval 'sub XK_sacute () {0x1b6;}' unless defined(&XK_sacute);
    eval 'sub XK_caron () {0x1b7;}' unless defined(&XK_caron);
    eval 'sub XK_scaron () {0x1b9;}' unless defined(&XK_scaron);
    eval 'sub XK_scedilla () {0x1ba;}' unless defined(&XK_scedilla);
    eval 'sub XK_tcaron () {0x1bb;}' unless defined(&XK_tcaron);
    eval 'sub XK_zacute () {0x1bc;}' unless defined(&XK_zacute);
    eval 'sub XK_doubleacute () {0x1bd;}' unless defined(&XK_doubleacute);
    eval 'sub XK_zcaron () {0x1be;}' unless defined(&XK_zcaron);
    eval 'sub XK_zabovedot () {0x1bf;}' unless defined(&XK_zabovedot);
    eval 'sub XK_Racute () {0x1c0;}' unless defined(&XK_Racute);
    eval 'sub XK_Abreve () {0x1c3;}' unless defined(&XK_Abreve);
    eval 'sub XK_Lacute () {0x1c5;}' unless defined(&XK_Lacute);
    eval 'sub XK_Cacute () {0x1c6;}' unless defined(&XK_Cacute);
    eval 'sub XK_Ccaron () {0x1c8;}' unless defined(&XK_Ccaron);
    eval 'sub XK_Eogonek () {0x1ca;}' unless defined(&XK_Eogonek);
    eval 'sub XK_Ecaron () {0x1cc;}' unless defined(&XK_Ecaron);
    eval 'sub XK_Dcaron () {0x1cf;}' unless defined(&XK_Dcaron);
    eval 'sub XK_Dstroke () {0x1d0;}' unless defined(&XK_Dstroke);
    eval 'sub XK_Nacute () {0x1d1;}' unless defined(&XK_Nacute);
    eval 'sub XK_Ncaron () {0x1d2;}' unless defined(&XK_Ncaron);
    eval 'sub XK_Odoubleacute () {0x1d5;}' unless defined(&XK_Odoubleacute);
    eval 'sub XK_Rcaron () {0x1d8;}' unless defined(&XK_Rcaron);
    eval 'sub XK_Uring () {0x1d9;}' unless defined(&XK_Uring);
    eval 'sub XK_Udoubleacute () {0x1db;}' unless defined(&XK_Udoubleacute);
    eval 'sub XK_Tcedilla () {0x1de;}' unless defined(&XK_Tcedilla);
    eval 'sub XK_racute () {0x1e0;}' unless defined(&XK_racute);
    eval 'sub XK_abreve () {0x1e3;}' unless defined(&XK_abreve);
    eval 'sub XK_lacute () {0x1e5;}' unless defined(&XK_lacute);
    eval 'sub XK_cacute () {0x1e6;}' unless defined(&XK_cacute);
    eval 'sub XK_ccaron () {0x1e8;}' unless defined(&XK_ccaron);
    eval 'sub XK_eogonek () {0x1ea;}' unless defined(&XK_eogonek);
    eval 'sub XK_ecaron () {0x1ec;}' unless defined(&XK_ecaron);
    eval 'sub XK_dcaron () {0x1ef;}' unless defined(&XK_dcaron);
    eval 'sub XK_dstroke () {0x1f0;}' unless defined(&XK_dstroke);
    eval 'sub XK_nacute () {0x1f1;}' unless defined(&XK_nacute);
    eval 'sub XK_ncaron () {0x1f2;}' unless defined(&XK_ncaron);
    eval 'sub XK_odoubleacute () {0x1f5;}' unless defined(&XK_odoubleacute);
    eval 'sub XK_udoubleacute () {0x1fb;}' unless defined(&XK_udoubleacute);
    eval 'sub XK_rcaron () {0x1f8;}' unless defined(&XK_rcaron);
    eval 'sub XK_uring () {0x1f9;}' unless defined(&XK_uring);
    eval 'sub XK_tcedilla () {0x1fe;}' unless defined(&XK_tcedilla);
    eval 'sub XK_abovedot () {0x1ff;}' unless defined(&XK_abovedot);
}
if(defined(&XK_LATIN3)) {
    eval 'sub XK_Hstroke () {0x2a1;}' unless defined(&XK_Hstroke);
    eval 'sub XK_Hcircumflex () {0x2a6;}' unless defined(&XK_Hcircumflex);
    eval 'sub XK_Iabovedot () {0x2a9;}' unless defined(&XK_Iabovedot);
    eval 'sub XK_Gbreve () {0x2ab;}' unless defined(&XK_Gbreve);
    eval 'sub XK_Jcircumflex () {0x2ac;}' unless defined(&XK_Jcircumflex);
    eval 'sub XK_hstroke () {0x2b1;}' unless defined(&XK_hstroke);
    eval 'sub XK_hcircumflex () {0x2b6;}' unless defined(&XK_hcircumflex);
    eval 'sub XK_idotless () {0x2b9;}' unless defined(&XK_idotless);
    eval 'sub XK_gbreve () {0x2bb;}' unless defined(&XK_gbreve);
    eval 'sub XK_jcircumflex () {0x2bc;}' unless defined(&XK_jcircumflex);
    eval 'sub XK_Cabovedot () {0x2c5;}' unless defined(&XK_Cabovedot);
    eval 'sub XK_Ccircumflex () {0x2c6;}' unless defined(&XK_Ccircumflex);
    eval 'sub XK_Gabovedot () {0x2d5;}' unless defined(&XK_Gabovedot);
    eval 'sub XK_Gcircumflex () {0x2d8;}' unless defined(&XK_Gcircumflex);
    eval 'sub XK_Ubreve () {0x2dd;}' unless defined(&XK_Ubreve);
    eval 'sub XK_Scircumflex () {0x2de;}' unless defined(&XK_Scircumflex);
    eval 'sub XK_cabovedot () {0x2e5;}' unless defined(&XK_cabovedot);
    eval 'sub XK_ccircumflex () {0x2e6;}' unless defined(&XK_ccircumflex);
    eval 'sub XK_gabovedot () {0x2f5;}' unless defined(&XK_gabovedot);
    eval 'sub XK_gcircumflex () {0x2f8;}' unless defined(&XK_gcircumflex);
    eval 'sub XK_ubreve () {0x2fd;}' unless defined(&XK_ubreve);
    eval 'sub XK_scircumflex () {0x2fe;}' unless defined(&XK_scircumflex);
}
if(defined(&XK_LATIN4)) {
    eval 'sub XK_kra () {0x3a2;}' unless defined(&XK_kra);
    eval 'sub XK_kappa () {0x3a2;}' unless defined(&XK_kappa);
    eval 'sub XK_Rcedilla () {0x3a3;}' unless defined(&XK_Rcedilla);
    eval 'sub XK_Itilde () {0x3a5;}' unless defined(&XK_Itilde);
    eval 'sub XK_Lcedilla () {0x3a6;}' unless defined(&XK_Lcedilla);
    eval 'sub XK_Emacron () {0x3aa;}' unless defined(&XK_Emacron);
    eval 'sub XK_Gcedilla () {0x3ab;}' unless defined(&XK_Gcedilla);
    eval 'sub XK_Tslash () {0x3ac;}' unless defined(&XK_Tslash);
    eval 'sub XK_rcedilla () {0x3b3;}' unless defined(&XK_rcedilla);
    eval 'sub XK_itilde () {0x3b5;}' unless defined(&XK_itilde);
    eval 'sub XK_lcedilla () {0x3b6;}' unless defined(&XK_lcedilla);
    eval 'sub XK_emacron () {0x3ba;}' unless defined(&XK_emacron);
    eval 'sub XK_gcedilla () {0x3bb;}' unless defined(&XK_gcedilla);
    eval 'sub XK_tslash () {0x3bc;}' unless defined(&XK_tslash);
    eval 'sub XK_ENG () {0x3bd;}' unless defined(&XK_ENG);
    eval 'sub XK_eng () {0x3bf;}' unless defined(&XK_eng);
    eval 'sub XK_Amacron () {0x3c0;}' unless defined(&XK_Amacron);
    eval 'sub XK_Iogonek () {0x3c7;}' unless defined(&XK_Iogonek);
    eval 'sub XK_Eabovedot () {0x3cc;}' unless defined(&XK_Eabovedot);
    eval 'sub XK_Imacron () {0x3cf;}' unless defined(&XK_Imacron);
    eval 'sub XK_Ncedilla () {0x3d1;}' unless defined(&XK_Ncedilla);
    eval 'sub XK_Omacron () {0x3d2;}' unless defined(&XK_Omacron);
    eval 'sub XK_Kcedilla () {0x3d3;}' unless defined(&XK_Kcedilla);
    eval 'sub XK_Uogonek () {0x3d9;}' unless defined(&XK_Uogonek);
    eval 'sub XK_Utilde () {0x3dd;}' unless defined(&XK_Utilde);
    eval 'sub XK_Umacron () {0x3de;}' unless defined(&XK_Umacron);
    eval 'sub XK_amacron () {0x3e0;}' unless defined(&XK_amacron);
    eval 'sub XK_iogonek () {0x3e7;}' unless defined(&XK_iogonek);
    eval 'sub XK_eabovedot () {0x3ec;}' unless defined(&XK_eabovedot);
    eval 'sub XK_imacron () {0x3ef;}' unless defined(&XK_imacron);
    eval 'sub XK_ncedilla () {0x3f1;}' unless defined(&XK_ncedilla);
    eval 'sub XK_omacron () {0x3f2;}' unless defined(&XK_omacron);
    eval 'sub XK_kcedilla () {0x3f3;}' unless defined(&XK_kcedilla);
    eval 'sub XK_uogonek () {0x3f9;}' unless defined(&XK_uogonek);
    eval 'sub XK_utilde () {0x3fd;}' unless defined(&XK_utilde);
    eval 'sub XK_umacron () {0x3fe;}' unless defined(&XK_umacron);
}
if(defined(&XK_LATIN8)) {
    eval 'sub XK_Babovedot () {0x12a1;}' unless defined(&XK_Babovedot);
    eval 'sub XK_babovedot () {0x12a2;}' unless defined(&XK_babovedot);
    eval 'sub XK_Dabovedot () {0x12a6;}' unless defined(&XK_Dabovedot);
    eval 'sub XK_Wgrave () {0x12a8;}' unless defined(&XK_Wgrave);
    eval 'sub XK_Wacute () {0x12aa;}' unless defined(&XK_Wacute);
    eval 'sub XK_dabovedot () {0x12ab;}' unless defined(&XK_dabovedot);
    eval 'sub XK_Ygrave () {0x12ac;}' unless defined(&XK_Ygrave);
    eval 'sub XK_Fabovedot () {0x12b0;}' unless defined(&XK_Fabovedot);
    eval 'sub XK_fabovedot () {0x12b1;}' unless defined(&XK_fabovedot);
    eval 'sub XK_Mabovedot () {0x12b4;}' unless defined(&XK_Mabovedot);
    eval 'sub XK_mabovedot () {0x12b5;}' unless defined(&XK_mabovedot);
    eval 'sub XK_Pabovedot () {0x12b7;}' unless defined(&XK_Pabovedot);
    eval 'sub XK_wgrave () {0x12b8;}' unless defined(&XK_wgrave);
    eval 'sub XK_pabovedot () {0x12b9;}' unless defined(&XK_pabovedot);
    eval 'sub XK_wacute () {0x12ba;}' unless defined(&XK_wacute);
    eval 'sub XK_Sabovedot () {0x12bb;}' unless defined(&XK_Sabovedot);
    eval 'sub XK_ygrave () {0x12bc;}' unless defined(&XK_ygrave);
    eval 'sub XK_Wdiaeresis () {0x12bd;}' unless defined(&XK_Wdiaeresis);
    eval 'sub XK_wdiaeresis () {0x12be;}' unless defined(&XK_wdiaeresis);
    eval 'sub XK_sabovedot () {0x12bf;}' unless defined(&XK_sabovedot);
    eval 'sub XK_Wcircumflex () {0x12d0;}' unless defined(&XK_Wcircumflex);
    eval 'sub XK_Tabovedot () {0x12d7;}' unless defined(&XK_Tabovedot);
    eval 'sub XK_Ycircumflex () {0x12de;}' unless defined(&XK_Ycircumflex);
    eval 'sub XK_wcircumflex () {0x12f0;}' unless defined(&XK_wcircumflex);
    eval 'sub XK_tabovedot () {0x12f7;}' unless defined(&XK_tabovedot);
    eval 'sub XK_ycircumflex () {0x12fe;}' unless defined(&XK_ycircumflex);
}
if(defined(&XK_LATIN9)) {
    eval 'sub XK_OE () {0x13bc;}' unless defined(&XK_OE);
    eval 'sub XK_oe () {0x13bd;}' unless defined(&XK_oe);
    eval 'sub XK_Ydiaeresis () {0x13be;}' unless defined(&XK_Ydiaeresis);
}
if(defined(&XK_KATAKANA)) {
    eval 'sub XK_overline () {0x47e;}' unless defined(&XK_overline);
    eval 'sub XK_kana_fullstop () {0x4a1;}' unless defined(&XK_kana_fullstop);
    eval 'sub XK_kana_openingbracket () {0x4a2;}' unless defined(&XK_kana_openingbracket);
    eval 'sub XK_kana_closingbracket () {0x4a3;}' unless defined(&XK_kana_closingbracket);
    eval 'sub XK_kana_comma () {0x4a4;}' unless defined(&XK_kana_comma);
    eval 'sub XK_kana_conjunctive () {0x4a5;}' unless defined(&XK_kana_conjunctive);
    eval 'sub XK_kana_middledot () {0x4a5;}' unless defined(&XK_kana_middledot);
    eval 'sub XK_kana_WO () {0x4a6;}' unless defined(&XK_kana_WO);
    eval 'sub XK_kana_a () {0x4a7;}' unless defined(&XK_kana_a);
    eval 'sub XK_kana_i () {0x4a8;}' unless defined(&XK_kana_i);
    eval 'sub XK_kana_u () {0x4a9;}' unless defined(&XK_kana_u);
    eval 'sub XK_kana_e () {0x4aa;}' unless defined(&XK_kana_e);
    eval 'sub XK_kana_o () {0x4ab;}' unless defined(&XK_kana_o);
    eval 'sub XK_kana_ya () {0x4ac;}' unless defined(&XK_kana_ya);
    eval 'sub XK_kana_yu () {0x4ad;}' unless defined(&XK_kana_yu);
    eval 'sub XK_kana_yo () {0x4ae;}' unless defined(&XK_kana_yo);
    eval 'sub XK_kana_tsu () {0x4af;}' unless defined(&XK_kana_tsu);
    eval 'sub XK_kana_tu () {0x4af;}' unless defined(&XK_kana_tu);
    eval 'sub XK_prolongedsound () {0x4b0;}' unless defined(&XK_prolongedsound);
    eval 'sub XK_kana_A () {0x4b1;}' unless defined(&XK_kana_A);
    eval 'sub XK_kana_I () {0x4b2;}' unless defined(&XK_kana_I);
    eval 'sub XK_kana_U () {0x4b3;}' unless defined(&XK_kana_U);
    eval 'sub XK_kana_E () {0x4b4;}' unless defined(&XK_kana_E);
    eval 'sub XK_kana_O () {0x4b5;}' unless defined(&XK_kana_O);
    eval 'sub XK_kana_KA () {0x4b6;}' unless defined(&XK_kana_KA);
    eval 'sub XK_kana_KI () {0x4b7;}' unless defined(&XK_kana_KI);
    eval 'sub XK_kana_KU () {0x4b8;}' unless defined(&XK_kana_KU);
    eval 'sub XK_kana_KE () {0x4b9;}' unless defined(&XK_kana_KE);
    eval 'sub XK_kana_KO () {0x4ba;}' unless defined(&XK_kana_KO);
    eval 'sub XK_kana_SA () {0x4bb;}' unless defined(&XK_kana_SA);
    eval 'sub XK_kana_SHI () {0x4bc;}' unless defined(&XK_kana_SHI);
    eval 'sub XK_kana_SU () {0x4bd;}' unless defined(&XK_kana_SU);
    eval 'sub XK_kana_SE () {0x4be;}' unless defined(&XK_kana_SE);
    eval 'sub XK_kana_SO () {0x4bf;}' unless defined(&XK_kana_SO);
    eval 'sub XK_kana_TA () {0x4c0;}' unless defined(&XK_kana_TA);
    eval 'sub XK_kana_CHI () {0x4c1;}' unless defined(&XK_kana_CHI);
    eval 'sub XK_kana_TI () {0x4c1;}' unless defined(&XK_kana_TI);
    eval 'sub XK_kana_TSU () {0x4c2;}' unless defined(&XK_kana_TSU);
    eval 'sub XK_kana_TU () {0x4c2;}' unless defined(&XK_kana_TU);
    eval 'sub XK_kana_TE () {0x4c3;}' unless defined(&XK_kana_TE);
    eval 'sub XK_kana_TO () {0x4c4;}' unless defined(&XK_kana_TO);
    eval 'sub XK_kana_NA () {0x4c5;}' unless defined(&XK_kana_NA);
    eval 'sub XK_kana_NI () {0x4c6;}' unless defined(&XK_kana_NI);
    eval 'sub XK_kana_NU () {0x4c7;}' unless defined(&XK_kana_NU);
    eval 'sub XK_kana_NE () {0x4c8;}' unless defined(&XK_kana_NE);
    eval 'sub XK_kana_NO () {0x4c9;}' unless defined(&XK_kana_NO);
    eval 'sub XK_kana_HA () {0x4ca;}' unless defined(&XK_kana_HA);
    eval 'sub XK_kana_HI () {0x4cb;}' unless defined(&XK_kana_HI);
    eval 'sub XK_kana_FU () {0x4cc;}' unless defined(&XK_kana_FU);
    eval 'sub XK_kana_HU () {0x4cc;}' unless defined(&XK_kana_HU);
    eval 'sub XK_kana_HE () {0x4cd;}' unless defined(&XK_kana_HE);
    eval 'sub XK_kana_HO () {0x4ce;}' unless defined(&XK_kana_HO);
    eval 'sub XK_kana_MA () {0x4cf;}' unless defined(&XK_kana_MA);
    eval 'sub XK_kana_MI () {0x4d0;}' unless defined(&XK_kana_MI);
    eval 'sub XK_kana_MU () {0x4d1;}' unless defined(&XK_kana_MU);
    eval 'sub XK_kana_ME () {0x4d2;}' unless defined(&XK_kana_ME);
    eval 'sub XK_kana_MO () {0x4d3;}' unless defined(&XK_kana_MO);
    eval 'sub XK_kana_YA () {0x4d4;}' unless defined(&XK_kana_YA);
    eval 'sub XK_kana_YU () {0x4d5;}' unless defined(&XK_kana_YU);
    eval 'sub XK_kana_YO () {0x4d6;}' unless defined(&XK_kana_YO);
    eval 'sub XK_kana_RA () {0x4d7;}' unless defined(&XK_kana_RA);
    eval 'sub XK_kana_RI () {0x4d8;}' unless defined(&XK_kana_RI);
    eval 'sub XK_kana_RU () {0x4d9;}' unless defined(&XK_kana_RU);
    eval 'sub XK_kana_RE () {0x4da;}' unless defined(&XK_kana_RE);
    eval 'sub XK_kana_RO () {0x4db;}' unless defined(&XK_kana_RO);
    eval 'sub XK_kana_WA () {0x4dc;}' unless defined(&XK_kana_WA);
    eval 'sub XK_kana_N () {0x4dd;}' unless defined(&XK_kana_N);
    eval 'sub XK_voicedsound () {0x4de;}' unless defined(&XK_voicedsound);
    eval 'sub XK_semivoicedsound () {0x4df;}' unless defined(&XK_semivoicedsound);
    eval 'sub XK_kana_switch () {0xff7e;}' unless defined(&XK_kana_switch);
}
if(defined(&XK_ARABIC)) {
    eval 'sub XK_Farsi_0 () {0x590;}' unless defined(&XK_Farsi_0);
    eval 'sub XK_Farsi_1 () {0x591;}' unless defined(&XK_Farsi_1);
    eval 'sub XK_Farsi_2 () {0x592;}' unless defined(&XK_Farsi_2);
    eval 'sub XK_Farsi_3 () {0x593;}' unless defined(&XK_Farsi_3);
    eval 'sub XK_Farsi_4 () {0x594;}' unless defined(&XK_Farsi_4);
    eval 'sub XK_Farsi_5 () {0x595;}' unless defined(&XK_Farsi_5);
    eval 'sub XK_Farsi_6 () {0x596;}' unless defined(&XK_Farsi_6);
    eval 'sub XK_Farsi_7 () {0x597;}' unless defined(&XK_Farsi_7);
    eval 'sub XK_Farsi_8 () {0x598;}' unless defined(&XK_Farsi_8);
    eval 'sub XK_Farsi_9 () {0x599;}' unless defined(&XK_Farsi_9);
    eval 'sub XK_Arabic_percent () {0x5a5;}' unless defined(&XK_Arabic_percent);
    eval 'sub XK_Arabic_superscript_alef () {0x5a6;}' unless defined(&XK_Arabic_superscript_alef);
    eval 'sub XK_Arabic_tteh () {0x5a7;}' unless defined(&XK_Arabic_tteh);
    eval 'sub XK_Arabic_peh () {0x5a8;}' unless defined(&XK_Arabic_peh);
    eval 'sub XK_Arabic_tcheh () {0x5a9;}' unless defined(&XK_Arabic_tcheh);
    eval 'sub XK_Arabic_ddal () {0x5aa;}' unless defined(&XK_Arabic_ddal);
    eval 'sub XK_Arabic_rreh () {0x5ab;}' unless defined(&XK_Arabic_rreh);
    eval 'sub XK_Arabic_comma () {0x5ac;}' unless defined(&XK_Arabic_comma);
    eval 'sub XK_Arabic_fullstop () {0x5ae;}' unless defined(&XK_Arabic_fullstop);
    eval 'sub XK_Arabic_0 () {0x5b0;}' unless defined(&XK_Arabic_0);
    eval 'sub XK_Arabic_1 () {0x5b1;}' unless defined(&XK_Arabic_1);
    eval 'sub XK_Arabic_2 () {0x5b2;}' unless defined(&XK_Arabic_2);
    eval 'sub XK_Arabic_3 () {0x5b3;}' unless defined(&XK_Arabic_3);
    eval 'sub XK_Arabic_4 () {0x5b4;}' unless defined(&XK_Arabic_4);
    eval 'sub XK_Arabic_5 () {0x5b5;}' unless defined(&XK_Arabic_5);
    eval 'sub XK_Arabic_6 () {0x5b6;}' unless defined(&XK_Arabic_6);
    eval 'sub XK_Arabic_7 () {0x5b7;}' unless defined(&XK_Arabic_7);
    eval 'sub XK_Arabic_8 () {0x5b8;}' unless defined(&XK_Arabic_8);
    eval 'sub XK_Arabic_9 () {0x5b9;}' unless defined(&XK_Arabic_9);
    eval 'sub XK_Arabic_semicolon () {0x5bb;}' unless defined(&XK_Arabic_semicolon);
    eval 'sub XK_Arabic_question_mark () {0x5bf;}' unless defined(&XK_Arabic_question_mark);
    eval 'sub XK_Arabic_hamza () {0x5c1;}' unless defined(&XK_Arabic_hamza);
    eval 'sub XK_Arabic_maddaonalef () {0x5c2;}' unless defined(&XK_Arabic_maddaonalef);
    eval 'sub XK_Arabic_hamzaonalef () {0x5c3;}' unless defined(&XK_Arabic_hamzaonalef);
    eval 'sub XK_Arabic_hamzaonwaw () {0x5c4;}' unless defined(&XK_Arabic_hamzaonwaw);
    eval 'sub XK_Arabic_hamzaunderalef () {0x5c5;}' unless defined(&XK_Arabic_hamzaunderalef);
    eval 'sub XK_Arabic_hamzaonyeh () {0x5c6;}' unless defined(&XK_Arabic_hamzaonyeh);
    eval 'sub XK_Arabic_alef () {0x5c7;}' unless defined(&XK_Arabic_alef);
    eval 'sub XK_Arabic_beh () {0x5c8;}' unless defined(&XK_Arabic_beh);
    eval 'sub XK_Arabic_tehmarbuta () {0x5c9;}' unless defined(&XK_Arabic_tehmarbuta);
    eval 'sub XK_Arabic_teh () {0x5ca;}' unless defined(&XK_Arabic_teh);
    eval 'sub XK_Arabic_theh () {0x5cb;}' unless defined(&XK_Arabic_theh);
    eval 'sub XK_Arabic_jeem () {0x5cc;}' unless defined(&XK_Arabic_jeem);
    eval 'sub XK_Arabic_hah () {0x5cd;}' unless defined(&XK_Arabic_hah);
    eval 'sub XK_Arabic_khah () {0x5ce;}' unless defined(&XK_Arabic_khah);
    eval 'sub XK_Arabic_dal () {0x5cf;}' unless defined(&XK_Arabic_dal);
    eval 'sub XK_Arabic_thal () {0x5d0;}' unless defined(&XK_Arabic_thal);
    eval 'sub XK_Arabic_ra () {0x5d1;}' unless defined(&XK_Arabic_ra);
    eval 'sub XK_Arabic_zain () {0x5d2;}' unless defined(&XK_Arabic_zain);
    eval 'sub XK_Arabic_seen () {0x5d3;}' unless defined(&XK_Arabic_seen);
    eval 'sub XK_Arabic_sheen () {0x5d4;}' unless defined(&XK_Arabic_sheen);
    eval 'sub XK_Arabic_sad () {0x5d5;}' unless defined(&XK_Arabic_sad);
    eval 'sub XK_Arabic_dad () {0x5d6;}' unless defined(&XK_Arabic_dad);
    eval 'sub XK_Arabic_tah () {0x5d7;}' unless defined(&XK_Arabic_tah);
    eval 'sub XK_Arabic_zah () {0x5d8;}' unless defined(&XK_Arabic_zah);
    eval 'sub XK_Arabic_ain () {0x5d9;}' unless defined(&XK_Arabic_ain);
    eval 'sub XK_Arabic_ghain () {0x5da;}' unless defined(&XK_Arabic_ghain);
    eval 'sub XK_Arabic_tatweel () {0x5e0;}' unless defined(&XK_Arabic_tatweel);
    eval 'sub XK_Arabic_feh () {0x5e1;}' unless defined(&XK_Arabic_feh);
    eval 'sub XK_Arabic_qaf () {0x5e2;}' unless defined(&XK_Arabic_qaf);
    eval 'sub XK_Arabic_kaf () {0x5e3;}' unless defined(&XK_Arabic_kaf);
    eval 'sub XK_Arabic_lam () {0x5e4;}' unless defined(&XK_Arabic_lam);
    eval 'sub XK_Arabic_meem () {0x5e5;}' unless defined(&XK_Arabic_meem);
    eval 'sub XK_Arabic_noon () {0x5e6;}' unless defined(&XK_Arabic_noon);
    eval 'sub XK_Arabic_ha () {0x5e7;}' unless defined(&XK_Arabic_ha);
    eval 'sub XK_Arabic_heh () {0x5e7;}' unless defined(&XK_Arabic_heh);
    eval 'sub XK_Arabic_waw () {0x5e8;}' unless defined(&XK_Arabic_waw);
    eval 'sub XK_Arabic_alefmaksura () {0x5e9;}' unless defined(&XK_Arabic_alefmaksura);
    eval 'sub XK_Arabic_yeh () {0x5ea;}' unless defined(&XK_Arabic_yeh);
    eval 'sub XK_Arabic_fathatan () {0x5eb;}' unless defined(&XK_Arabic_fathatan);
    eval 'sub XK_Arabic_dammatan () {0x5ec;}' unless defined(&XK_Arabic_dammatan);
    eval 'sub XK_Arabic_kasratan () {0x5ed;}' unless defined(&XK_Arabic_kasratan);
    eval 'sub XK_Arabic_fatha () {0x5ee;}' unless defined(&XK_Arabic_fatha);
    eval 'sub XK_Arabic_damma () {0x5ef;}' unless defined(&XK_Arabic_damma);
    eval 'sub XK_Arabic_kasra () {0x5f0;}' unless defined(&XK_Arabic_kasra);
    eval 'sub XK_Arabic_shadda () {0x5f1;}' unless defined(&XK_Arabic_shadda);
    eval 'sub XK_Arabic_sukun () {0x5f2;}' unless defined(&XK_Arabic_sukun);
    eval 'sub XK_Arabic_madda_above () {0x5f3;}' unless defined(&XK_Arabic_madda_above);
    eval 'sub XK_Arabic_hamza_above () {0x5f4;}' unless defined(&XK_Arabic_hamza_above);
    eval 'sub XK_Arabic_hamza_below () {0x5f5;}' unless defined(&XK_Arabic_hamza_below);
    eval 'sub XK_Arabic_jeh () {0x5f6;}' unless defined(&XK_Arabic_jeh);
    eval 'sub XK_Arabic_veh () {0x5f7;}' unless defined(&XK_Arabic_veh);
    eval 'sub XK_Arabic_keheh () {0x5f8;}' unless defined(&XK_Arabic_keheh);
    eval 'sub XK_Arabic_gaf () {0x5f9;}' unless defined(&XK_Arabic_gaf);
    eval 'sub XK_Arabic_noon_ghunna () {0x5fa;}' unless defined(&XK_Arabic_noon_ghunna);
    eval 'sub XK_Arabic_heh_doachashmee () {0x5fb;}' unless defined(&XK_Arabic_heh_doachashmee);
    eval 'sub XK_Farsi_yeh () {0x5fc;}' unless defined(&XK_Farsi_yeh);
    eval 'sub XK_Arabic_farsi_yeh () { &XK_Farsi_yeh;}' unless defined(&XK_Arabic_farsi_yeh);
    eval 'sub XK_Arabic_yeh_baree () {0x5fd;}' unless defined(&XK_Arabic_yeh_baree);
    eval 'sub XK_Arabic_heh_goal () {0x5fe;}' unless defined(&XK_Arabic_heh_goal);
    eval 'sub XK_Arabic_switch () {0xff7e;}' unless defined(&XK_Arabic_switch);
}
if(defined(&XK_CYRILLIC)) {
    eval 'sub XK_Cyrillic_GHE_bar () {0x680;}' unless defined(&XK_Cyrillic_GHE_bar);
    eval 'sub XK_Cyrillic_ghe_bar () {0x690;}' unless defined(&XK_Cyrillic_ghe_bar);
    eval 'sub XK_Cyrillic_ZHE_descender () {0x681;}' unless defined(&XK_Cyrillic_ZHE_descender);
    eval 'sub XK_Cyrillic_zhe_descender () {0x691;}' unless defined(&XK_Cyrillic_zhe_descender);
    eval 'sub XK_Cyrillic_KA_descender () {0x682;}' unless defined(&XK_Cyrillic_KA_descender);
    eval 'sub XK_Cyrillic_ka_descender () {0x692;}' unless defined(&XK_Cyrillic_ka_descender);
    eval 'sub XK_Cyrillic_KA_vertstroke () {0x683;}' unless defined(&XK_Cyrillic_KA_vertstroke);
    eval 'sub XK_Cyrillic_ka_vertstroke () {0x693;}' unless defined(&XK_Cyrillic_ka_vertstroke);
    eval 'sub XK_Cyrillic_EN_descender () {0x684;}' unless defined(&XK_Cyrillic_EN_descender);
    eval 'sub XK_Cyrillic_en_descender () {0x694;}' unless defined(&XK_Cyrillic_en_descender);
    eval 'sub XK_Cyrillic_U_straight () {0x685;}' unless defined(&XK_Cyrillic_U_straight);
    eval 'sub XK_Cyrillic_u_straight () {0x695;}' unless defined(&XK_Cyrillic_u_straight);
    eval 'sub XK_Cyrillic_U_straight_bar () {0x686;}' unless defined(&XK_Cyrillic_U_straight_bar);
    eval 'sub XK_Cyrillic_u_straight_bar () {0x696;}' unless defined(&XK_Cyrillic_u_straight_bar);
    eval 'sub XK_Cyrillic_HA_descender () {0x687;}' unless defined(&XK_Cyrillic_HA_descender);
    eval 'sub XK_Cyrillic_ha_descender () {0x697;}' unless defined(&XK_Cyrillic_ha_descender);
    eval 'sub XK_Cyrillic_CHE_descender () {0x688;}' unless defined(&XK_Cyrillic_CHE_descender);
    eval 'sub XK_Cyrillic_che_descender () {0x698;}' unless defined(&XK_Cyrillic_che_descender);
    eval 'sub XK_Cyrillic_CHE_vertstroke () {0x689;}' unless defined(&XK_Cyrillic_CHE_vertstroke);
    eval 'sub XK_Cyrillic_che_vertstroke () {0x699;}' unless defined(&XK_Cyrillic_che_vertstroke);
    eval 'sub XK_Cyrillic_SHHA () {0x68a;}' unless defined(&XK_Cyrillic_SHHA);
    eval 'sub XK_Cyrillic_shha () {0x69a;}' unless defined(&XK_Cyrillic_shha);
    eval 'sub XK_Cyrillic_SCHWA () {0x68c;}' unless defined(&XK_Cyrillic_SCHWA);
    eval 'sub XK_Cyrillic_schwa () {0x69c;}' unless defined(&XK_Cyrillic_schwa);
    eval 'sub XK_Cyrillic_I_macron () {0x68d;}' unless defined(&XK_Cyrillic_I_macron);
    eval 'sub XK_Cyrillic_i_macron () {0x69d;}' unless defined(&XK_Cyrillic_i_macron);
    eval 'sub XK_Cyrillic_O_bar () {0x68e;}' unless defined(&XK_Cyrillic_O_bar);
    eval 'sub XK_Cyrillic_o_bar () {0x69e;}' unless defined(&XK_Cyrillic_o_bar);
    eval 'sub XK_Cyrillic_U_macron () {0x68f;}' unless defined(&XK_Cyrillic_U_macron);
    eval 'sub XK_Cyrillic_u_macron () {0x69f;}' unless defined(&XK_Cyrillic_u_macron);
    eval 'sub XK_Serbian_dje () {0x6a1;}' unless defined(&XK_Serbian_dje);
    eval 'sub XK_Macedonia_gje () {0x6a2;}' unless defined(&XK_Macedonia_gje);
    eval 'sub XK_Cyrillic_io () {0x6a3;}' unless defined(&XK_Cyrillic_io);
    eval 'sub XK_Ukrainian_ie () {0x6a4;}' unless defined(&XK_Ukrainian_ie);
    eval 'sub XK_Ukranian_je () {0x6a4;}' unless defined(&XK_Ukranian_je);
    eval 'sub XK_Macedonia_dse () {0x6a5;}' unless defined(&XK_Macedonia_dse);
    eval 'sub XK_Ukrainian_i () {0x6a6;}' unless defined(&XK_Ukrainian_i);
    eval 'sub XK_Ukranian_i () {0x6a6;}' unless defined(&XK_Ukranian_i);
    eval 'sub XK_Ukrainian_yi () {0x6a7;}' unless defined(&XK_Ukrainian_yi);
    eval 'sub XK_Ukranian_yi () {0x6a7;}' unless defined(&XK_Ukranian_yi);
    eval 'sub XK_Cyrillic_je () {0x6a8;}' unless defined(&XK_Cyrillic_je);
    eval 'sub XK_Serbian_je () {0x6a8;}' unless defined(&XK_Serbian_je);
    eval 'sub XK_Cyrillic_lje () {0x6a9;}' unless defined(&XK_Cyrillic_lje);
    eval 'sub XK_Serbian_lje () {0x6a9;}' unless defined(&XK_Serbian_lje);
    eval 'sub XK_Cyrillic_nje () {0x6aa;}' unless defined(&XK_Cyrillic_nje);
    eval 'sub XK_Serbian_nje () {0x6aa;}' unless defined(&XK_Serbian_nje);
    eval 'sub XK_Serbian_tshe () {0x6ab;}' unless defined(&XK_Serbian_tshe);
    eval 'sub XK_Macedonia_kje () {0x6ac;}' unless defined(&XK_Macedonia_kje);
    eval 'sub XK_Ukrainian_ghe_with_upturn () {0x6ad;}' unless defined(&XK_Ukrainian_ghe_with_upturn);
    eval 'sub XK_Byelorussian_shortu () {0x6ae;}' unless defined(&XK_Byelorussian_shortu);
    eval 'sub XK_Cyrillic_dzhe () {0x6af;}' unless defined(&XK_Cyrillic_dzhe);
    eval 'sub XK_Serbian_dze () {0x6af;}' unless defined(&XK_Serbian_dze);
    eval 'sub XK_numerosign () {0x6b0;}' unless defined(&XK_numerosign);
    eval 'sub XK_Serbian_DJE () {0x6b1;}' unless defined(&XK_Serbian_DJE);
    eval 'sub XK_Macedonia_GJE () {0x6b2;}' unless defined(&XK_Macedonia_GJE);
    eval 'sub XK_Cyrillic_IO () {0x6b3;}' unless defined(&XK_Cyrillic_IO);
    eval 'sub XK_Ukrainian_IE () {0x6b4;}' unless defined(&XK_Ukrainian_IE);
    eval 'sub XK_Ukranian_JE () {0x6b4;}' unless defined(&XK_Ukranian_JE);
    eval 'sub XK_Macedonia_DSE () {0x6b5;}' unless defined(&XK_Macedonia_DSE);
    eval 'sub XK_Ukrainian_I () {0x6b6;}' unless defined(&XK_Ukrainian_I);
    eval 'sub XK_Ukranian_I () {0x6b6;}' unless defined(&XK_Ukranian_I);
    eval 'sub XK_Ukrainian_YI () {0x6b7;}' unless defined(&XK_Ukrainian_YI);
    eval 'sub XK_Ukranian_YI () {0x6b7;}' unless defined(&XK_Ukranian_YI);
    eval 'sub XK_Cyrillic_JE () {0x6b8;}' unless defined(&XK_Cyrillic_JE);
    eval 'sub XK_Serbian_JE () {0x6b8;}' unless defined(&XK_Serbian_JE);
    eval 'sub XK_Cyrillic_LJE () {0x6b9;}' unless defined(&XK_Cyrillic_LJE);
    eval 'sub XK_Serbian_LJE () {0x6b9;}' unless defined(&XK_Serbian_LJE);
    eval 'sub XK_Cyrillic_NJE () {0x6ba;}' unless defined(&XK_Cyrillic_NJE);
    eval 'sub XK_Serbian_NJE () {0x6ba;}' unless defined(&XK_Serbian_NJE);
    eval 'sub XK_Serbian_TSHE () {0x6bb;}' unless defined(&XK_Serbian_TSHE);
    eval 'sub XK_Macedonia_KJE () {0x6bc;}' unless defined(&XK_Macedonia_KJE);
    eval 'sub XK_Ukrainian_GHE_WITH_UPTURN () {0x6bd;}' unless defined(&XK_Ukrainian_GHE_WITH_UPTURN);
    eval 'sub XK_Byelorussian_SHORTU () {0x6be;}' unless defined(&XK_Byelorussian_SHORTU);
    eval 'sub XK_Cyrillic_DZHE () {0x6bf;}' unless defined(&XK_Cyrillic_DZHE);
    eval 'sub XK_Serbian_DZE () {0x6bf;}' unless defined(&XK_Serbian_DZE);
    eval 'sub XK_Cyrillic_yu () {0x6c0;}' unless defined(&XK_Cyrillic_yu);
    eval 'sub XK_Cyrillic_a () {0x6c1;}' unless defined(&XK_Cyrillic_a);
    eval 'sub XK_Cyrillic_be () {0x6c2;}' unless defined(&XK_Cyrillic_be);
    eval 'sub XK_Cyrillic_tse () {0x6c3;}' unless defined(&XK_Cyrillic_tse);
    eval 'sub XK_Cyrillic_de () {0x6c4;}' unless defined(&XK_Cyrillic_de);
    eval 'sub XK_Cyrillic_ie () {0x6c5;}' unless defined(&XK_Cyrillic_ie);
    eval 'sub XK_Cyrillic_ef () {0x6c6;}' unless defined(&XK_Cyrillic_ef);
    eval 'sub XK_Cyrillic_ghe () {0x6c7;}' unless defined(&XK_Cyrillic_ghe);
    eval 'sub XK_Cyrillic_ha () {0x6c8;}' unless defined(&XK_Cyrillic_ha);
    eval 'sub XK_Cyrillic_i () {0x6c9;}' unless defined(&XK_Cyrillic_i);
    eval 'sub XK_Cyrillic_shorti () {0x6ca;}' unless defined(&XK_Cyrillic_shorti);
    eval 'sub XK_Cyrillic_ka () {0x6cb;}' unless defined(&XK_Cyrillic_ka);
    eval 'sub XK_Cyrillic_el () {0x6cc;}' unless defined(&XK_Cyrillic_el);
    eval 'sub XK_Cyrillic_em () {0x6cd;}' unless defined(&XK_Cyrillic_em);
    eval 'sub XK_Cyrillic_en () {0x6ce;}' unless defined(&XK_Cyrillic_en);
    eval 'sub XK_Cyrillic_o () {0x6cf;}' unless defined(&XK_Cyrillic_o);
    eval 'sub XK_Cyrillic_pe () {0x6d0;}' unless defined(&XK_Cyrillic_pe);
    eval 'sub XK_Cyrillic_ya () {0x6d1;}' unless defined(&XK_Cyrillic_ya);
    eval 'sub XK_Cyrillic_er () {0x6d2;}' unless defined(&XK_Cyrillic_er);
    eval 'sub XK_Cyrillic_es () {0x6d3;}' unless defined(&XK_Cyrillic_es);
    eval 'sub XK_Cyrillic_te () {0x6d4;}' unless defined(&XK_Cyrillic_te);
    eval 'sub XK_Cyrillic_u () {0x6d5;}' unless defined(&XK_Cyrillic_u);
    eval 'sub XK_Cyrillic_zhe () {0x6d6;}' unless defined(&XK_Cyrillic_zhe);
    eval 'sub XK_Cyrillic_ve () {0x6d7;}' unless defined(&XK_Cyrillic_ve);
    eval 'sub XK_Cyrillic_softsign () {0x6d8;}' unless defined(&XK_Cyrillic_softsign);
    eval 'sub XK_Cyrillic_yeru () {0x6d9;}' unless defined(&XK_Cyrillic_yeru);
    eval 'sub XK_Cyrillic_ze () {0x6da;}' unless defined(&XK_Cyrillic_ze);
    eval 'sub XK_Cyrillic_sha () {0x6db;}' unless defined(&XK_Cyrillic_sha);
    eval 'sub XK_Cyrillic_e () {0x6dc;}' unless defined(&XK_Cyrillic_e);
    eval 'sub XK_Cyrillic_shcha () {0x6dd;}' unless defined(&XK_Cyrillic_shcha);
    eval 'sub XK_Cyrillic_che () {0x6de;}' unless defined(&XK_Cyrillic_che);
    eval 'sub XK_Cyrillic_hardsign () {0x6df;}' unless defined(&XK_Cyrillic_hardsign);
    eval 'sub XK_Cyrillic_YU () {0x6e0;}' unless defined(&XK_Cyrillic_YU);
    eval 'sub XK_Cyrillic_A () {0x6e1;}' unless defined(&XK_Cyrillic_A);
    eval 'sub XK_Cyrillic_BE () {0x6e2;}' unless defined(&XK_Cyrillic_BE);
    eval 'sub XK_Cyrillic_TSE () {0x6e3;}' unless defined(&XK_Cyrillic_TSE);
    eval 'sub XK_Cyrillic_DE () {0x6e4;}' unless defined(&XK_Cyrillic_DE);
    eval 'sub XK_Cyrillic_IE () {0x6e5;}' unless defined(&XK_Cyrillic_IE);
    eval 'sub XK_Cyrillic_EF () {0x6e6;}' unless defined(&XK_Cyrillic_EF);
    eval 'sub XK_Cyrillic_GHE () {0x6e7;}' unless defined(&XK_Cyrillic_GHE);
    eval 'sub XK_Cyrillic_HA () {0x6e8;}' unless defined(&XK_Cyrillic_HA);
    eval 'sub XK_Cyrillic_I () {0x6e9;}' unless defined(&XK_Cyrillic_I);
    eval 'sub XK_Cyrillic_SHORTI () {0x6ea;}' unless defined(&XK_Cyrillic_SHORTI);
    eval 'sub XK_Cyrillic_KA () {0x6eb;}' unless defined(&XK_Cyrillic_KA);
    eval 'sub XK_Cyrillic_EL () {0x6ec;}' unless defined(&XK_Cyrillic_EL);
    eval 'sub XK_Cyrillic_EM () {0x6ed;}' unless defined(&XK_Cyrillic_EM);
    eval 'sub XK_Cyrillic_EN () {0x6ee;}' unless defined(&XK_Cyrillic_EN);
    eval 'sub XK_Cyrillic_O () {0x6ef;}' unless defined(&XK_Cyrillic_O);
    eval 'sub XK_Cyrillic_PE () {0x6f0;}' unless defined(&XK_Cyrillic_PE);
    eval 'sub XK_Cyrillic_YA () {0x6f1;}' unless defined(&XK_Cyrillic_YA);
    eval 'sub XK_Cyrillic_ER () {0x6f2;}' unless defined(&XK_Cyrillic_ER);
    eval 'sub XK_Cyrillic_ES () {0x6f3;}' unless defined(&XK_Cyrillic_ES);
    eval 'sub XK_Cyrillic_TE () {0x6f4;}' unless defined(&XK_Cyrillic_TE);
    eval 'sub XK_Cyrillic_U () {0x6f5;}' unless defined(&XK_Cyrillic_U);
    eval 'sub XK_Cyrillic_ZHE () {0x6f6;}' unless defined(&XK_Cyrillic_ZHE);
    eval 'sub XK_Cyrillic_VE () {0x6f7;}' unless defined(&XK_Cyrillic_VE);
    eval 'sub XK_Cyrillic_SOFTSIGN () {0x6f8;}' unless defined(&XK_Cyrillic_SOFTSIGN);
    eval 'sub XK_Cyrillic_YERU () {0x6f9;}' unless defined(&XK_Cyrillic_YERU);
    eval 'sub XK_Cyrillic_ZE () {0x6fa;}' unless defined(&XK_Cyrillic_ZE);
    eval 'sub XK_Cyrillic_SHA () {0x6fb;}' unless defined(&XK_Cyrillic_SHA);
    eval 'sub XK_Cyrillic_E () {0x6fc;}' unless defined(&XK_Cyrillic_E);
    eval 'sub XK_Cyrillic_SHCHA () {0x6fd;}' unless defined(&XK_Cyrillic_SHCHA);
    eval 'sub XK_Cyrillic_CHE () {0x6fe;}' unless defined(&XK_Cyrillic_CHE);
    eval 'sub XK_Cyrillic_HARDSIGN () {0x6ff;}' unless defined(&XK_Cyrillic_HARDSIGN);
}
if(defined(&XK_GREEK)) {
    eval 'sub XK_Greek_ALPHAaccent () {0x7a1;}' unless defined(&XK_Greek_ALPHAaccent);
    eval 'sub XK_Greek_EPSILONaccent () {0x7a2;}' unless defined(&XK_Greek_EPSILONaccent);
    eval 'sub XK_Greek_ETAaccent () {0x7a3;}' unless defined(&XK_Greek_ETAaccent);
    eval 'sub XK_Greek_IOTAaccent () {0x7a4;}' unless defined(&XK_Greek_IOTAaccent);
    eval 'sub XK_Greek_IOTAdieresis () {0x7a5;}' unless defined(&XK_Greek_IOTAdieresis);
    eval 'sub XK_Greek_IOTAdiaeresis () { &XK_Greek_IOTAdieresis;}' unless defined(&XK_Greek_IOTAdiaeresis);
    eval 'sub XK_Greek_OMICRONaccent () {0x7a7;}' unless defined(&XK_Greek_OMICRONaccent);
    eval 'sub XK_Greek_UPSILONaccent () {0x7a8;}' unless defined(&XK_Greek_UPSILONaccent);
    eval 'sub XK_Greek_UPSILONdieresis () {0x7a9;}' unless defined(&XK_Greek_UPSILONdieresis);
    eval 'sub XK_Greek_OMEGAaccent () {0x7ab;}' unless defined(&XK_Greek_OMEGAaccent);
    eval 'sub XK_Greek_accentdieresis () {0x7ae;}' unless defined(&XK_Greek_accentdieresis);
    eval 'sub XK_Greek_horizbar () {0x7af;}' unless defined(&XK_Greek_horizbar);
    eval 'sub XK_Greek_alphaaccent () {0x7b1;}' unless defined(&XK_Greek_alphaaccent);
    eval 'sub XK_Greek_epsilonaccent () {0x7b2;}' unless defined(&XK_Greek_epsilonaccent);
    eval 'sub XK_Greek_etaaccent () {0x7b3;}' unless defined(&XK_Greek_etaaccent);
    eval 'sub XK_Greek_iotaaccent () {0x7b4;}' unless defined(&XK_Greek_iotaaccent);
    eval 'sub XK_Greek_iotadieresis () {0x7b5;}' unless defined(&XK_Greek_iotadieresis);
    eval 'sub XK_Greek_iotaaccentdieresis () {0x7b6;}' unless defined(&XK_Greek_iotaaccentdieresis);
    eval 'sub XK_Greek_omicronaccent () {0x7b7;}' unless defined(&XK_Greek_omicronaccent);
    eval 'sub XK_Greek_upsilonaccent () {0x7b8;}' unless defined(&XK_Greek_upsilonaccent);
    eval 'sub XK_Greek_upsilondieresis () {0x7b9;}' unless defined(&XK_Greek_upsilondieresis);
    eval 'sub XK_Greek_upsilonaccentdieresis () {0x7ba;}' unless defined(&XK_Greek_upsilonaccentdieresis);
    eval 'sub XK_Greek_omegaaccent () {0x7bb;}' unless defined(&XK_Greek_omegaaccent);
    eval 'sub XK_Greek_ALPHA () {0x7c1;}' unless defined(&XK_Greek_ALPHA);
    eval 'sub XK_Greek_BETA () {0x7c2;}' unless defined(&XK_Greek_BETA);
    eval 'sub XK_Greek_GAMMA () {0x7c3;}' unless defined(&XK_Greek_GAMMA);
    eval 'sub XK_Greek_DELTA () {0x7c4;}' unless defined(&XK_Greek_DELTA);
    eval 'sub XK_Greek_EPSILON () {0x7c5;}' unless defined(&XK_Greek_EPSILON);
    eval 'sub XK_Greek_ZETA () {0x7c6;}' unless defined(&XK_Greek_ZETA);
    eval 'sub XK_Greek_ETA () {0x7c7;}' unless defined(&XK_Greek_ETA);
    eval 'sub XK_Greek_THETA () {0x7c8;}' unless defined(&XK_Greek_THETA);
    eval 'sub XK_Greek_IOTA () {0x7c9;}' unless defined(&XK_Greek_IOTA);
    eval 'sub XK_Greek_KAPPA () {0x7ca;}' unless defined(&XK_Greek_KAPPA);
    eval 'sub XK_Greek_LAMDA () {0x7cb;}' unless defined(&XK_Greek_LAMDA);
    eval 'sub XK_Greek_LAMBDA () {0x7cb;}' unless defined(&XK_Greek_LAMBDA);
    eval 'sub XK_Greek_MU () {0x7cc;}' unless defined(&XK_Greek_MU);
    eval 'sub XK_Greek_NU () {0x7cd;}' unless defined(&XK_Greek_NU);
    eval 'sub XK_Greek_XI () {0x7ce;}' unless defined(&XK_Greek_XI);
    eval 'sub XK_Greek_OMICRON () {0x7cf;}' unless defined(&XK_Greek_OMICRON);
    eval 'sub XK_Greek_PI () {0x7d0;}' unless defined(&XK_Greek_PI);
    eval 'sub XK_Greek_RHO () {0x7d1;}' unless defined(&XK_Greek_RHO);
    eval 'sub XK_Greek_SIGMA () {0x7d2;}' unless defined(&XK_Greek_SIGMA);
    eval 'sub XK_Greek_TAU () {0x7d4;}' unless defined(&XK_Greek_TAU);
    eval 'sub XK_Greek_UPSILON () {0x7d5;}' unless defined(&XK_Greek_UPSILON);
    eval 'sub XK_Greek_PHI () {0x7d6;}' unless defined(&XK_Greek_PHI);
    eval 'sub XK_Greek_CHI () {0x7d7;}' unless defined(&XK_Greek_CHI);
    eval 'sub XK_Greek_PSI () {0x7d8;}' unless defined(&XK_Greek_PSI);
    eval 'sub XK_Greek_OMEGA () {0x7d9;}' unless defined(&XK_Greek_OMEGA);
    eval 'sub XK_Greek_alpha () {0x7e1;}' unless defined(&XK_Greek_alpha);
    eval 'sub XK_Greek_beta () {0x7e2;}' unless defined(&XK_Greek_beta);
    eval 'sub XK_Greek_gamma () {0x7e3;}' unless defined(&XK_Greek_gamma);
    eval 'sub XK_Greek_delta () {0x7e4;}' unless defined(&XK_Greek_delta);
    eval 'sub XK_Greek_epsilon () {0x7e5;}' unless defined(&XK_Greek_epsilon);
    eval 'sub XK_Greek_zeta () {0x7e6;}' unless defined(&XK_Greek_zeta);
    eval 'sub XK_Greek_eta () {0x7e7;}' unless defined(&XK_Greek_eta);
    eval 'sub XK_Greek_theta () {0x7e8;}' unless defined(&XK_Greek_theta);
    eval 'sub XK_Greek_iota () {0x7e9;}' unless defined(&XK_Greek_iota);
    eval 'sub XK_Greek_kappa () {0x7ea;}' unless defined(&XK_Greek_kappa);
    eval 'sub XK_Greek_lamda () {0x7eb;}' unless defined(&XK_Greek_lamda);
    eval 'sub XK_Greek_lambda () {0x7eb;}' unless defined(&XK_Greek_lambda);
    eval 'sub XK_Greek_mu () {0x7ec;}' unless defined(&XK_Greek_mu);
    eval 'sub XK_Greek_nu () {0x7ed;}' unless defined(&XK_Greek_nu);
    eval 'sub XK_Greek_xi () {0x7ee;}' unless defined(&XK_Greek_xi);
    eval 'sub XK_Greek_omicron () {0x7ef;}' unless defined(&XK_Greek_omicron);
    eval 'sub XK_Greek_pi () {0x7f0;}' unless defined(&XK_Greek_pi);
    eval 'sub XK_Greek_rho () {0x7f1;}' unless defined(&XK_Greek_rho);
    eval 'sub XK_Greek_sigma () {0x7f2;}' unless defined(&XK_Greek_sigma);
    eval 'sub XK_Greek_finalsmallsigma () {0x7f3;}' unless defined(&XK_Greek_finalsmallsigma);
    eval 'sub XK_Greek_tau () {0x7f4;}' unless defined(&XK_Greek_tau);
    eval 'sub XK_Greek_upsilon () {0x7f5;}' unless defined(&XK_Greek_upsilon);
    eval 'sub XK_Greek_phi () {0x7f6;}' unless defined(&XK_Greek_phi);
    eval 'sub XK_Greek_chi () {0x7f7;}' unless defined(&XK_Greek_chi);
    eval 'sub XK_Greek_psi () {0x7f8;}' unless defined(&XK_Greek_psi);
    eval 'sub XK_Greek_omega () {0x7f9;}' unless defined(&XK_Greek_omega);
    eval 'sub XK_Greek_switch () {0xff7e;}' unless defined(&XK_Greek_switch);
}
if(defined(&XK_TECHNICAL)) {
    eval 'sub XK_leftradical () {0x8a1;}' unless defined(&XK_leftradical);
    eval 'sub XK_topleftradical () {0x8a2;}' unless defined(&XK_topleftradical);
    eval 'sub XK_horizconnector () {0x8a3;}' unless defined(&XK_horizconnector);
    eval 'sub XK_topintegral () {0x8a4;}' unless defined(&XK_topintegral);
    eval 'sub XK_botintegral () {0x8a5;}' unless defined(&XK_botintegral);
    eval 'sub XK_vertconnector () {0x8a6;}' unless defined(&XK_vertconnector);
    eval 'sub XK_topleftsqbracket () {0x8a7;}' unless defined(&XK_topleftsqbracket);
    eval 'sub XK_botleftsqbracket () {0x8a8;}' unless defined(&XK_botleftsqbracket);
    eval 'sub XK_toprightsqbracket () {0x8a9;}' unless defined(&XK_toprightsqbracket);
    eval 'sub XK_botrightsqbracket () {0x8aa;}' unless defined(&XK_botrightsqbracket);
    eval 'sub XK_topleftparens () {0x8ab;}' unless defined(&XK_topleftparens);
    eval 'sub XK_botleftparens () {0x8ac;}' unless defined(&XK_botleftparens);
    eval 'sub XK_toprightparens () {0x8ad;}' unless defined(&XK_toprightparens);
    eval 'sub XK_botrightparens () {0x8ae;}' unless defined(&XK_botrightparens);
    eval 'sub XK_leftmiddlecurlybrace () {0x8af;}' unless defined(&XK_leftmiddlecurlybrace);
    eval 'sub XK_rightmiddlecurlybrace () {0x8b0;}' unless defined(&XK_rightmiddlecurlybrace);
    eval 'sub XK_topleftsummation () {0x8b1;}' unless defined(&XK_topleftsummation);
    eval 'sub XK_botleftsummation () {0x8b2;}' unless defined(&XK_botleftsummation);
    eval 'sub XK_topvertsummationconnector () {0x8b3;}' unless defined(&XK_topvertsummationconnector);
    eval 'sub XK_botvertsummationconnector () {0x8b4;}' unless defined(&XK_botvertsummationconnector);
    eval 'sub XK_toprightsummation () {0x8b5;}' unless defined(&XK_toprightsummation);
    eval 'sub XK_botrightsummation () {0x8b6;}' unless defined(&XK_botrightsummation);
    eval 'sub XK_rightmiddlesummation () {0x8b7;}' unless defined(&XK_rightmiddlesummation);
    eval 'sub XK_lessthanequal () {0x8bc;}' unless defined(&XK_lessthanequal);
    eval 'sub XK_notequal () {0x8bd;}' unless defined(&XK_notequal);
    eval 'sub XK_greaterthanequal () {0x8be;}' unless defined(&XK_greaterthanequal);
    eval 'sub XK_integral () {0x8bf;}' unless defined(&XK_integral);
    eval 'sub XK_therefore () {0x8c0;}' unless defined(&XK_therefore);
    eval 'sub XK_variation () {0x8c1;}' unless defined(&XK_variation);
    eval 'sub XK_infinity () {0x8c2;}' unless defined(&XK_infinity);
    eval 'sub XK_nabla () {0x8c5;}' unless defined(&XK_nabla);
    eval 'sub XK_approximate () {0x8c8;}' unless defined(&XK_approximate);
    eval 'sub XK_similarequal () {0x8c9;}' unless defined(&XK_similarequal);
    eval 'sub XK_ifonlyif () {0x8cd;}' unless defined(&XK_ifonlyif);
    eval 'sub XK_implies () {0x8ce;}' unless defined(&XK_implies);
    eval 'sub XK_identical () {0x8cf;}' unless defined(&XK_identical);
    eval 'sub XK_radical () {0x8d6;}' unless defined(&XK_radical);
    eval 'sub XK_includedin () {0x8da;}' unless defined(&XK_includedin);
    eval 'sub XK_includes () {0x8db;}' unless defined(&XK_includes);
    eval 'sub XK_intersection () {0x8dc;}' unless defined(&XK_intersection);
    eval 'sub XK_union () {0x8dd;}' unless defined(&XK_union);
    eval 'sub XK_logicaland () {0x8de;}' unless defined(&XK_logicaland);
    eval 'sub XK_logicalor () {0x8df;}' unless defined(&XK_logicalor);
    eval 'sub XK_partialderivative () {0x8ef;}' unless defined(&XK_partialderivative);
    eval 'sub XK_function () {0x8f6;}' unless defined(&XK_function);
    eval 'sub XK_leftarrow () {0x8fb;}' unless defined(&XK_leftarrow);
    eval 'sub XK_uparrow () {0x8fc;}' unless defined(&XK_uparrow);
    eval 'sub XK_rightarrow () {0x8fd;}' unless defined(&XK_rightarrow);
    eval 'sub XK_downarrow () {0x8fe;}' unless defined(&XK_downarrow);
}
if(defined(&XK_SPECIAL)) {
    eval 'sub XK_blank () {0x9df;}' unless defined(&XK_blank);
    eval 'sub XK_soliddiamond () {0x9e0;}' unless defined(&XK_soliddiamond);
    eval 'sub XK_checkerboard () {0x9e1;}' unless defined(&XK_checkerboard);
    eval 'sub XK_ht () {0x9e2;}' unless defined(&XK_ht);
    eval 'sub XK_ff () {0x9e3;}' unless defined(&XK_ff);
    eval 'sub XK_cr () {0x9e4;}' unless defined(&XK_cr);
    eval 'sub XK_lf () {0x9e5;}' unless defined(&XK_lf);
    eval 'sub XK_nl () {0x9e8;}' unless defined(&XK_nl);
    eval 'sub XK_vt () {0x9e9;}' unless defined(&XK_vt);
    eval 'sub XK_lowrightcorner () {0x9ea;}' unless defined(&XK_lowrightcorner);
    eval 'sub XK_uprightcorner () {0x9eb;}' unless defined(&XK_uprightcorner);
    eval 'sub XK_upleftcorner () {0x9ec;}' unless defined(&XK_upleftcorner);
    eval 'sub XK_lowleftcorner () {0x9ed;}' unless defined(&XK_lowleftcorner);
    eval 'sub XK_crossinglines () {0x9ee;}' unless defined(&XK_crossinglines);
    eval 'sub XK_horizlinescan1 () {0x9ef;}' unless defined(&XK_horizlinescan1);
    eval 'sub XK_horizlinescan3 () {0x9f0;}' unless defined(&XK_horizlinescan3);
    eval 'sub XK_horizlinescan5 () {0x9f1;}' unless defined(&XK_horizlinescan5);
    eval 'sub XK_horizlinescan7 () {0x9f2;}' unless defined(&XK_horizlinescan7);
    eval 'sub XK_horizlinescan9 () {0x9f3;}' unless defined(&XK_horizlinescan9);
    eval 'sub XK_leftt () {0x9f4;}' unless defined(&XK_leftt);
    eval 'sub XK_rightt () {0x9f5;}' unless defined(&XK_rightt);
    eval 'sub XK_bott () {0x9f6;}' unless defined(&XK_bott);
    eval 'sub XK_topt () {0x9f7;}' unless defined(&XK_topt);
    eval 'sub XK_vertbar () {0x9f8;}' unless defined(&XK_vertbar);
}
if(defined(&XK_PUBLISHING)) {
    eval 'sub XK_emspace () {0xaa1;}' unless defined(&XK_emspace);
    eval 'sub XK_enspace () {0xaa2;}' unless defined(&XK_enspace);
    eval 'sub XK_em3space () {0xaa3;}' unless defined(&XK_em3space);
    eval 'sub XK_em4space () {0xaa4;}' unless defined(&XK_em4space);
    eval 'sub XK_digitspace () {0xaa5;}' unless defined(&XK_digitspace);
    eval 'sub XK_punctspace () {0xaa6;}' unless defined(&XK_punctspace);
    eval 'sub XK_thinspace () {0xaa7;}' unless defined(&XK_thinspace);
    eval 'sub XK_hairspace () {0xaa8;}' unless defined(&XK_hairspace);
    eval 'sub XK_emdash () {0xaa9;}' unless defined(&XK_emdash);
    eval 'sub XK_endash () {0xaaa;}' unless defined(&XK_endash);
    eval 'sub XK_signifblank () {0xaac;}' unless defined(&XK_signifblank);
    eval 'sub XK_ellipsis () {0xaae;}' unless defined(&XK_ellipsis);
    eval 'sub XK_doubbaselinedot () {0xaaf;}' unless defined(&XK_doubbaselinedot);
    eval 'sub XK_onethird () {0xab0;}' unless defined(&XK_onethird);
    eval 'sub XK_twothirds () {0xab1;}' unless defined(&XK_twothirds);
    eval 'sub XK_onefifth () {0xab2;}' unless defined(&XK_onefifth);
    eval 'sub XK_twofifths () {0xab3;}' unless defined(&XK_twofifths);
    eval 'sub XK_threefifths () {0xab4;}' unless defined(&XK_threefifths);
    eval 'sub XK_fourfifths () {0xab5;}' unless defined(&XK_fourfifths);
    eval 'sub XK_onesixth () {0xab6;}' unless defined(&XK_onesixth);
    eval 'sub XK_fivesixths () {0xab7;}' unless defined(&XK_fivesixths);
    eval 'sub XK_careof () {0xab8;}' unless defined(&XK_careof);
    eval 'sub XK_figdash () {0xabb;}' unless defined(&XK_figdash);
    eval 'sub XK_leftanglebracket () {0xabc;}' unless defined(&XK_leftanglebracket);
    eval 'sub XK_decimalpoint () {0xabd;}' unless defined(&XK_decimalpoint);
    eval 'sub XK_rightanglebracket () {0xabe;}' unless defined(&XK_rightanglebracket);
    eval 'sub XK_marker () {0xabf;}' unless defined(&XK_marker);
    eval 'sub XK_oneeighth () {0xac3;}' unless defined(&XK_oneeighth);
    eval 'sub XK_threeeighths () {0xac4;}' unless defined(&XK_threeeighths);
    eval 'sub XK_fiveeighths () {0xac5;}' unless defined(&XK_fiveeighths);
    eval 'sub XK_seveneighths () {0xac6;}' unless defined(&XK_seveneighths);
    eval 'sub XK_trademark () {0xac9;}' unless defined(&XK_trademark);
    eval 'sub XK_signaturemark () {0xaca;}' unless defined(&XK_signaturemark);
    eval 'sub XK_trademarkincircle () {0xacb;}' unless defined(&XK_trademarkincircle);
    eval 'sub XK_leftopentriangle () {0xacc;}' unless defined(&XK_leftopentriangle);
    eval 'sub XK_rightopentriangle () {0xacd;}' unless defined(&XK_rightopentriangle);
    eval 'sub XK_emopencircle () {0xace;}' unless defined(&XK_emopencircle);
    eval 'sub XK_emopenrectangle () {0xacf;}' unless defined(&XK_emopenrectangle);
    eval 'sub XK_leftsinglequotemark () {0xad0;}' unless defined(&XK_leftsinglequotemark);
    eval 'sub XK_rightsinglequotemark () {0xad1;}' unless defined(&XK_rightsinglequotemark);
    eval 'sub XK_leftdoublequotemark () {0xad2;}' unless defined(&XK_leftdoublequotemark);
    eval 'sub XK_rightdoublequotemark () {0xad3;}' unless defined(&XK_rightdoublequotemark);
    eval 'sub XK_prescription () {0xad4;}' unless defined(&XK_prescription);
    eval 'sub XK_minutes () {0xad6;}' unless defined(&XK_minutes);
    eval 'sub XK_seconds () {0xad7;}' unless defined(&XK_seconds);
    eval 'sub XK_latincross () {0xad9;}' unless defined(&XK_latincross);
    eval 'sub XK_hexagram () {0xada;}' unless defined(&XK_hexagram);
    eval 'sub XK_filledrectbullet () {0xadb;}' unless defined(&XK_filledrectbullet);
    eval 'sub XK_filledlefttribullet () {0xadc;}' unless defined(&XK_filledlefttribullet);
    eval 'sub XK_filledrighttribullet () {0xadd;}' unless defined(&XK_filledrighttribullet);
    eval 'sub XK_emfilledcircle () {0xade;}' unless defined(&XK_emfilledcircle);
    eval 'sub XK_emfilledrect () {0xadf;}' unless defined(&XK_emfilledrect);
    eval 'sub XK_enopencircbullet () {0xae0;}' unless defined(&XK_enopencircbullet);
    eval 'sub XK_enopensquarebullet () {0xae1;}' unless defined(&XK_enopensquarebullet);
    eval 'sub XK_openrectbullet () {0xae2;}' unless defined(&XK_openrectbullet);
    eval 'sub XK_opentribulletup () {0xae3;}' unless defined(&XK_opentribulletup);
    eval 'sub XK_opentribulletdown () {0xae4;}' unless defined(&XK_opentribulletdown);
    eval 'sub XK_openstar () {0xae5;}' unless defined(&XK_openstar);
    eval 'sub XK_enfilledcircbullet () {0xae6;}' unless defined(&XK_enfilledcircbullet);
    eval 'sub XK_enfilledsqbullet () {0xae7;}' unless defined(&XK_enfilledsqbullet);
    eval 'sub XK_filledtribulletup () {0xae8;}' unless defined(&XK_filledtribulletup);
    eval 'sub XK_filledtribulletdown () {0xae9;}' unless defined(&XK_filledtribulletdown);
    eval 'sub XK_leftpointer () {0xaea;}' unless defined(&XK_leftpointer);
    eval 'sub XK_rightpointer () {0xaeb;}' unless defined(&XK_rightpointer);
    eval 'sub XK_club () {0xaec;}' unless defined(&XK_club);
    eval 'sub XK_diamond () {0xaed;}' unless defined(&XK_diamond);
    eval 'sub XK_heart () {0xaee;}' unless defined(&XK_heart);
    eval 'sub XK_maltesecross () {0xaf0;}' unless defined(&XK_maltesecross);
    eval 'sub XK_dagger () {0xaf1;}' unless defined(&XK_dagger);
    eval 'sub XK_doubledagger () {0xaf2;}' unless defined(&XK_doubledagger);
    eval 'sub XK_checkmark () {0xaf3;}' unless defined(&XK_checkmark);
    eval 'sub XK_ballotcross () {0xaf4;}' unless defined(&XK_ballotcross);
    eval 'sub XK_musicalsharp () {0xaf5;}' unless defined(&XK_musicalsharp);
    eval 'sub XK_musicalflat () {0xaf6;}' unless defined(&XK_musicalflat);
    eval 'sub XK_malesymbol () {0xaf7;}' unless defined(&XK_malesymbol);
    eval 'sub XK_femalesymbol () {0xaf8;}' unless defined(&XK_femalesymbol);
    eval 'sub XK_telephone () {0xaf9;}' unless defined(&XK_telephone);
    eval 'sub XK_telephonerecorder () {0xafa;}' unless defined(&XK_telephonerecorder);
    eval 'sub XK_phonographcopyright () {0xafb;}' unless defined(&XK_phonographcopyright);
    eval 'sub XK_caret () {0xafc;}' unless defined(&XK_caret);
    eval 'sub XK_singlelowquotemark () {0xafd;}' unless defined(&XK_singlelowquotemark);
    eval 'sub XK_doublelowquotemark () {0xafe;}' unless defined(&XK_doublelowquotemark);
    eval 'sub XK_cursor () {0xaff;}' unless defined(&XK_cursor);
}
if(defined(&XK_APL)) {
    eval 'sub XK_leftcaret () {0xba3;}' unless defined(&XK_leftcaret);
    eval 'sub XK_rightcaret () {0xba6;}' unless defined(&XK_rightcaret);
    eval 'sub XK_downcaret () {0xba8;}' unless defined(&XK_downcaret);
    eval 'sub XK_upcaret () {0xba9;}' unless defined(&XK_upcaret);
    eval 'sub XK_overbar () {0xbc0;}' unless defined(&XK_overbar);
    eval 'sub XK_downtack () {0xbc2;}' unless defined(&XK_downtack);
    eval 'sub XK_upshoe () {0xbc3;}' unless defined(&XK_upshoe);
    eval 'sub XK_downstile () {0xbc4;}' unless defined(&XK_downstile);
    eval 'sub XK_underbar () {0xbc6;}' unless defined(&XK_underbar);
    eval 'sub XK_jot () {0xbca;}' unless defined(&XK_jot);
    eval 'sub XK_quad () {0xbcc;}' unless defined(&XK_quad);
    eval 'sub XK_uptack () {0xbce;}' unless defined(&XK_uptack);
    eval 'sub XK_circle () {0xbcf;}' unless defined(&XK_circle);
    eval 'sub XK_upstile () {0xbd3;}' unless defined(&XK_upstile);
    eval 'sub XK_downshoe () {0xbd6;}' unless defined(&XK_downshoe);
    eval 'sub XK_rightshoe () {0xbd8;}' unless defined(&XK_rightshoe);
    eval 'sub XK_leftshoe () {0xbda;}' unless defined(&XK_leftshoe);
    eval 'sub XK_lefttack () {0xbdc;}' unless defined(&XK_lefttack);
    eval 'sub XK_righttack () {0xbfc;}' unless defined(&XK_righttack);
}
if(defined(&XK_HEBREW)) {
    eval 'sub XK_hebrew_doublelowline () {0xcdf;}' unless defined(&XK_hebrew_doublelowline);
    eval 'sub XK_hebrew_aleph () {0xce0;}' unless defined(&XK_hebrew_aleph);
    eval 'sub XK_hebrew_bet () {0xce1;}' unless defined(&XK_hebrew_bet);
    eval 'sub XK_hebrew_beth () {0xce1;}' unless defined(&XK_hebrew_beth);
    eval 'sub XK_hebrew_gimel () {0xce2;}' unless defined(&XK_hebrew_gimel);
    eval 'sub XK_hebrew_gimmel () {0xce2;}' unless defined(&XK_hebrew_gimmel);
    eval 'sub XK_hebrew_dalet () {0xce3;}' unless defined(&XK_hebrew_dalet);
    eval 'sub XK_hebrew_daleth () {0xce3;}' unless defined(&XK_hebrew_daleth);
    eval 'sub XK_hebrew_he () {0xce4;}' unless defined(&XK_hebrew_he);
    eval 'sub XK_hebrew_waw () {0xce5;}' unless defined(&XK_hebrew_waw);
    eval 'sub XK_hebrew_zain () {0xce6;}' unless defined(&XK_hebrew_zain);
    eval 'sub XK_hebrew_zayin () {0xce6;}' unless defined(&XK_hebrew_zayin);
    eval 'sub XK_hebrew_chet () {0xce7;}' unless defined(&XK_hebrew_chet);
    eval 'sub XK_hebrew_het () {0xce7;}' unless defined(&XK_hebrew_het);
    eval 'sub XK_hebrew_tet () {0xce8;}' unless defined(&XK_hebrew_tet);
    eval 'sub XK_hebrew_teth () {0xce8;}' unless defined(&XK_hebrew_teth);
    eval 'sub XK_hebrew_yod () {0xce9;}' unless defined(&XK_hebrew_yod);
    eval 'sub XK_hebrew_finalkaph () {0xcea;}' unless defined(&XK_hebrew_finalkaph);
    eval 'sub XK_hebrew_kaph () {0xceb;}' unless defined(&XK_hebrew_kaph);
    eval 'sub XK_hebrew_lamed () {0xcec;}' unless defined(&XK_hebrew_lamed);
    eval 'sub XK_hebrew_finalmem () {0xced;}' unless defined(&XK_hebrew_finalmem);
    eval 'sub XK_hebrew_mem () {0xcee;}' unless defined(&XK_hebrew_mem);
    eval 'sub XK_hebrew_finalnun () {0xcef;}' unless defined(&XK_hebrew_finalnun);
    eval 'sub XK_hebrew_nun () {0xcf0;}' unless defined(&XK_hebrew_nun);
    eval 'sub XK_hebrew_samech () {0xcf1;}' unless defined(&XK_hebrew_samech);
    eval 'sub XK_hebrew_samekh () {0xcf1;}' unless defined(&XK_hebrew_samekh);
    eval 'sub XK_hebrew_ayin () {0xcf2;}' unless defined(&XK_hebrew_ayin);
    eval 'sub XK_hebrew_finalpe () {0xcf3;}' unless defined(&XK_hebrew_finalpe);
    eval 'sub XK_hebrew_pe () {0xcf4;}' unless defined(&XK_hebrew_pe);
    eval 'sub XK_hebrew_finalzade () {0xcf5;}' unless defined(&XK_hebrew_finalzade);
    eval 'sub XK_hebrew_finalzadi () {0xcf5;}' unless defined(&XK_hebrew_finalzadi);
    eval 'sub XK_hebrew_zade () {0xcf6;}' unless defined(&XK_hebrew_zade);
    eval 'sub XK_hebrew_zadi () {0xcf6;}' unless defined(&XK_hebrew_zadi);
    eval 'sub XK_hebrew_qoph () {0xcf7;}' unless defined(&XK_hebrew_qoph);
    eval 'sub XK_hebrew_kuf () {0xcf7;}' unless defined(&XK_hebrew_kuf);
    eval 'sub XK_hebrew_resh () {0xcf8;}' unless defined(&XK_hebrew_resh);
    eval 'sub XK_hebrew_shin () {0xcf9;}' unless defined(&XK_hebrew_shin);
    eval 'sub XK_hebrew_taw () {0xcfa;}' unless defined(&XK_hebrew_taw);
    eval 'sub XK_hebrew_taf () {0xcfa;}' unless defined(&XK_hebrew_taf);
    eval 'sub XK_Hebrew_switch () {0xff7e;}' unless defined(&XK_Hebrew_switch);
}
if(defined(&XK_THAI)) {
    eval 'sub XK_Thai_kokai () {0xda1;}' unless defined(&XK_Thai_kokai);
    eval 'sub XK_Thai_khokhai () {0xda2;}' unless defined(&XK_Thai_khokhai);
    eval 'sub XK_Thai_khokhuat () {0xda3;}' unless defined(&XK_Thai_khokhuat);
    eval 'sub XK_Thai_khokhwai () {0xda4;}' unless defined(&XK_Thai_khokhwai);
    eval 'sub XK_Thai_khokhon () {0xda5;}' unless defined(&XK_Thai_khokhon);
    eval 'sub XK_Thai_khorakhang () {0xda6;}' unless defined(&XK_Thai_khorakhang);
    eval 'sub XK_Thai_ngongu () {0xda7;}' unless defined(&XK_Thai_ngongu);
    eval 'sub XK_Thai_chochan () {0xda8;}' unless defined(&XK_Thai_chochan);
    eval 'sub XK_Thai_choching () {0xda9;}' unless defined(&XK_Thai_choching);
    eval 'sub XK_Thai_chochang () {0xdaa;}' unless defined(&XK_Thai_chochang);
    eval 'sub XK_Thai_soso () {0xdab;}' unless defined(&XK_Thai_soso);
    eval 'sub XK_Thai_chochoe () {0xdac;}' unless defined(&XK_Thai_chochoe);
    eval 'sub XK_Thai_yoying () {0xdad;}' unless defined(&XK_Thai_yoying);
    eval 'sub XK_Thai_dochada () {0xdae;}' unless defined(&XK_Thai_dochada);
    eval 'sub XK_Thai_topatak () {0xdaf;}' unless defined(&XK_Thai_topatak);
    eval 'sub XK_Thai_thothan () {0xdb0;}' unless defined(&XK_Thai_thothan);
    eval 'sub XK_Thai_thonangmontho () {0xdb1;}' unless defined(&XK_Thai_thonangmontho);
    eval 'sub XK_Thai_thophuthao () {0xdb2;}' unless defined(&XK_Thai_thophuthao);
    eval 'sub XK_Thai_nonen () {0xdb3;}' unless defined(&XK_Thai_nonen);
    eval 'sub XK_Thai_dodek () {0xdb4;}' unless defined(&XK_Thai_dodek);
    eval 'sub XK_Thai_totao () {0xdb5;}' unless defined(&XK_Thai_totao);
    eval 'sub XK_Thai_thothung () {0xdb6;}' unless defined(&XK_Thai_thothung);
    eval 'sub XK_Thai_thothahan () {0xdb7;}' unless defined(&XK_Thai_thothahan);
    eval 'sub XK_Thai_thothong () {0xdb8;}' unless defined(&XK_Thai_thothong);
    eval 'sub XK_Thai_nonu () {0xdb9;}' unless defined(&XK_Thai_nonu);
    eval 'sub XK_Thai_bobaimai () {0xdba;}' unless defined(&XK_Thai_bobaimai);
    eval 'sub XK_Thai_popla () {0xdbb;}' unless defined(&XK_Thai_popla);
    eval 'sub XK_Thai_phophung () {0xdbc;}' unless defined(&XK_Thai_phophung);
    eval 'sub XK_Thai_fofa () {0xdbd;}' unless defined(&XK_Thai_fofa);
    eval 'sub XK_Thai_phophan () {0xdbe;}' unless defined(&XK_Thai_phophan);
    eval 'sub XK_Thai_fofan () {0xdbf;}' unless defined(&XK_Thai_fofan);
    eval 'sub XK_Thai_phosamphao () {0xdc0;}' unless defined(&XK_Thai_phosamphao);
    eval 'sub XK_Thai_moma () {0xdc1;}' unless defined(&XK_Thai_moma);
    eval 'sub XK_Thai_yoyak () {0xdc2;}' unless defined(&XK_Thai_yoyak);
    eval 'sub XK_Thai_rorua () {0xdc3;}' unless defined(&XK_Thai_rorua);
    eval 'sub XK_Thai_ru () {0xdc4;}' unless defined(&XK_Thai_ru);
    eval 'sub XK_Thai_loling () {0xdc5;}' unless defined(&XK_Thai_loling);
    eval 'sub XK_Thai_lu () {0xdc6;}' unless defined(&XK_Thai_lu);
    eval 'sub XK_Thai_wowaen () {0xdc7;}' unless defined(&XK_Thai_wowaen);
    eval 'sub XK_Thai_sosala () {0xdc8;}' unless defined(&XK_Thai_sosala);
    eval 'sub XK_Thai_sorusi () {0xdc9;}' unless defined(&XK_Thai_sorusi);
    eval 'sub XK_Thai_sosua () {0xdca;}' unless defined(&XK_Thai_sosua);
    eval 'sub XK_Thai_hohip () {0xdcb;}' unless defined(&XK_Thai_hohip);
    eval 'sub XK_Thai_lochula () {0xdcc;}' unless defined(&XK_Thai_lochula);
    eval 'sub XK_Thai_oang () {0xdcd;}' unless defined(&XK_Thai_oang);
    eval 'sub XK_Thai_honokhuk () {0xdce;}' unless defined(&XK_Thai_honokhuk);
    eval 'sub XK_Thai_paiyannoi () {0xdcf;}' unless defined(&XK_Thai_paiyannoi);
    eval 'sub XK_Thai_saraa () {0xdd0;}' unless defined(&XK_Thai_saraa);
    eval 'sub XK_Thai_maihanakat () {0xdd1;}' unless defined(&XK_Thai_maihanakat);
    eval 'sub XK_Thai_saraaa () {0xdd2;}' unless defined(&XK_Thai_saraaa);
    eval 'sub XK_Thai_saraam () {0xdd3;}' unless defined(&XK_Thai_saraam);
    eval 'sub XK_Thai_sarai () {0xdd4;}' unless defined(&XK_Thai_sarai);
    eval 'sub XK_Thai_saraii () {0xdd5;}' unless defined(&XK_Thai_saraii);
    eval 'sub XK_Thai_saraue () {0xdd6;}' unless defined(&XK_Thai_saraue);
    eval 'sub XK_Thai_sarauee () {0xdd7;}' unless defined(&XK_Thai_sarauee);
    eval 'sub XK_Thai_sarau () {0xdd8;}' unless defined(&XK_Thai_sarau);
    eval 'sub XK_Thai_sarauu () {0xdd9;}' unless defined(&XK_Thai_sarauu);
    eval 'sub XK_Thai_phinthu () {0xdda;}' unless defined(&XK_Thai_phinthu);
    eval 'sub XK_Thai_maihanakat_maitho () {0xdde;}' unless defined(&XK_Thai_maihanakat_maitho);
    eval 'sub XK_Thai_baht () {0xddf;}' unless defined(&XK_Thai_baht);
    eval 'sub XK_Thai_sarae () {0xde0;}' unless defined(&XK_Thai_sarae);
    eval 'sub XK_Thai_saraae () {0xde1;}' unless defined(&XK_Thai_saraae);
    eval 'sub XK_Thai_sarao () {0xde2;}' unless defined(&XK_Thai_sarao);
    eval 'sub XK_Thai_saraaimaimuan () {0xde3;}' unless defined(&XK_Thai_saraaimaimuan);
    eval 'sub XK_Thai_saraaimaimalai () {0xde4;}' unless defined(&XK_Thai_saraaimaimalai);
    eval 'sub XK_Thai_lakkhangyao () {0xde5;}' unless defined(&XK_Thai_lakkhangyao);
    eval 'sub XK_Thai_maiyamok () {0xde6;}' unless defined(&XK_Thai_maiyamok);
    eval 'sub XK_Thai_maitaikhu () {0xde7;}' unless defined(&XK_Thai_maitaikhu);
    eval 'sub XK_Thai_maiek () {0xde8;}' unless defined(&XK_Thai_maiek);
    eval 'sub XK_Thai_maitho () {0xde9;}' unless defined(&XK_Thai_maitho);
    eval 'sub XK_Thai_maitri () {0xdea;}' unless defined(&XK_Thai_maitri);
    eval 'sub XK_Thai_maichattawa () {0xdeb;}' unless defined(&XK_Thai_maichattawa);
    eval 'sub XK_Thai_thanthakhat () {0xdec;}' unless defined(&XK_Thai_thanthakhat);
    eval 'sub XK_Thai_nikhahit () {0xded;}' unless defined(&XK_Thai_nikhahit);
    eval 'sub XK_Thai_leksun () {0xdf0;}' unless defined(&XK_Thai_leksun);
    eval 'sub XK_Thai_leknung () {0xdf1;}' unless defined(&XK_Thai_leknung);
    eval 'sub XK_Thai_leksong () {0xdf2;}' unless defined(&XK_Thai_leksong);
    eval 'sub XK_Thai_leksam () {0xdf3;}' unless defined(&XK_Thai_leksam);
    eval 'sub XK_Thai_leksi () {0xdf4;}' unless defined(&XK_Thai_leksi);
    eval 'sub XK_Thai_lekha () {0xdf5;}' unless defined(&XK_Thai_lekha);
    eval 'sub XK_Thai_lekhok () {0xdf6;}' unless defined(&XK_Thai_lekhok);
    eval 'sub XK_Thai_lekchet () {0xdf7;}' unless defined(&XK_Thai_lekchet);
    eval 'sub XK_Thai_lekpaet () {0xdf8;}' unless defined(&XK_Thai_lekpaet);
    eval 'sub XK_Thai_lekkao () {0xdf9;}' unless defined(&XK_Thai_lekkao);
}
if(defined(&XK_KOREAN)) {
    eval 'sub XK_Hangul () {0xff31;}' unless defined(&XK_Hangul);
    eval 'sub XK_Hangul_Start () {0xff32;}' unless defined(&XK_Hangul_Start);
    eval 'sub XK_Hangul_End () {0xff33;}' unless defined(&XK_Hangul_End);
    eval 'sub XK_Hangul_Hanja () {0xff34;}' unless defined(&XK_Hangul_Hanja);
    eval 'sub XK_Hangul_Jamo () {0xff35;}' unless defined(&XK_Hangul_Jamo);
    eval 'sub XK_Hangul_Romaja () {0xff36;}' unless defined(&XK_Hangul_Romaja);
    eval 'sub XK_Hangul_Codeinput () {0xff37;}' unless defined(&XK_Hangul_Codeinput);
    eval 'sub XK_Hangul_Jeonja () {0xff38;}' unless defined(&XK_Hangul_Jeonja);
    eval 'sub XK_Hangul_Banja () {0xff39;}' unless defined(&XK_Hangul_Banja);
    eval 'sub XK_Hangul_PreHanja () {0xff3a;}' unless defined(&XK_Hangul_PreHanja);
    eval 'sub XK_Hangul_PostHanja () {0xff3b;}' unless defined(&XK_Hangul_PostHanja);
    eval 'sub XK_Hangul_SingleCandidate () {0xff3c;}' unless defined(&XK_Hangul_SingleCandidate);
    eval 'sub XK_Hangul_MultipleCandidate () {0xff3d;}' unless defined(&XK_Hangul_MultipleCandidate);
    eval 'sub XK_Hangul_PreviousCandidate () {0xff3e;}' unless defined(&XK_Hangul_PreviousCandidate);
    eval 'sub XK_Hangul_Special () {0xff3f;}' unless defined(&XK_Hangul_Special);
    eval 'sub XK_Hangul_switch () {0xff7e;}' unless defined(&XK_Hangul_switch);
    eval 'sub XK_Hangul_Kiyeog () {0xea1;}' unless defined(&XK_Hangul_Kiyeog);
    eval 'sub XK_Hangul_SsangKiyeog () {0xea2;}' unless defined(&XK_Hangul_SsangKiyeog);
    eval 'sub XK_Hangul_KiyeogSios () {0xea3;}' unless defined(&XK_Hangul_KiyeogSios);
    eval 'sub XK_Hangul_Nieun () {0xea4;}' unless defined(&XK_Hangul_Nieun);
    eval 'sub XK_Hangul_NieunJieuj () {0xea5;}' unless defined(&XK_Hangul_NieunJieuj);
    eval 'sub XK_Hangul_NieunHieuh () {0xea6;}' unless defined(&XK_Hangul_NieunHieuh);
    eval 'sub XK_Hangul_Dikeud () {0xea7;}' unless defined(&XK_Hangul_Dikeud);
    eval 'sub XK_Hangul_SsangDikeud () {0xea8;}' unless defined(&XK_Hangul_SsangDikeud);
    eval 'sub XK_Hangul_Rieul () {0xea9;}' unless defined(&XK_Hangul_Rieul);
    eval 'sub XK_Hangul_RieulKiyeog () {0xeaa;}' unless defined(&XK_Hangul_RieulKiyeog);
    eval 'sub XK_Hangul_RieulMieum () {0xeab;}' unless defined(&XK_Hangul_RieulMieum);
    eval 'sub XK_Hangul_RieulPieub () {0xeac;}' unless defined(&XK_Hangul_RieulPieub);
    eval 'sub XK_Hangul_RieulSios () {0xead;}' unless defined(&XK_Hangul_RieulSios);
    eval 'sub XK_Hangul_RieulTieut () {0xeae;}' unless defined(&XK_Hangul_RieulTieut);
    eval 'sub XK_Hangul_RieulPhieuf () {0xeaf;}' unless defined(&XK_Hangul_RieulPhieuf);
    eval 'sub XK_Hangul_RieulHieuh () {0xeb0;}' unless defined(&XK_Hangul_RieulHieuh);
    eval 'sub XK_Hangul_Mieum () {0xeb1;}' unless defined(&XK_Hangul_Mieum);
    eval 'sub XK_Hangul_Pieub () {0xeb2;}' unless defined(&XK_Hangul_Pieub);
    eval 'sub XK_Hangul_SsangPieub () {0xeb3;}' unless defined(&XK_Hangul_SsangPieub);
    eval 'sub XK_Hangul_PieubSios () {0xeb4;}' unless defined(&XK_Hangul_PieubSios);
    eval 'sub XK_Hangul_Sios () {0xeb5;}' unless defined(&XK_Hangul_Sios);
    eval 'sub XK_Hangul_SsangSios () {0xeb6;}' unless defined(&XK_Hangul_SsangSios);
    eval 'sub XK_Hangul_Ieung () {0xeb7;}' unless defined(&XK_Hangul_Ieung);
    eval 'sub XK_Hangul_Jieuj () {0xeb8;}' unless defined(&XK_Hangul_Jieuj);
    eval 'sub XK_Hangul_SsangJieuj () {0xeb9;}' unless defined(&XK_Hangul_SsangJieuj);
    eval 'sub XK_Hangul_Cieuc () {0xeba;}' unless defined(&XK_Hangul_Cieuc);
    eval 'sub XK_Hangul_Khieuq () {0xebb;}' unless defined(&XK_Hangul_Khieuq);
    eval 'sub XK_Hangul_Tieut () {0xebc;}' unless defined(&XK_Hangul_Tieut);
    eval 'sub XK_Hangul_Phieuf () {0xebd;}' unless defined(&XK_Hangul_Phieuf);
    eval 'sub XK_Hangul_Hieuh () {0xebe;}' unless defined(&XK_Hangul_Hieuh);
    eval 'sub XK_Hangul_A () {0xebf;}' unless defined(&XK_Hangul_A);
    eval 'sub XK_Hangul_AE () {0xec0;}' unless defined(&XK_Hangul_AE);
    eval 'sub XK_Hangul_YA () {0xec1;}' unless defined(&XK_Hangul_YA);
    eval 'sub XK_Hangul_YAE () {0xec2;}' unless defined(&XK_Hangul_YAE);
    eval 'sub XK_Hangul_EO () {0xec3;}' unless defined(&XK_Hangul_EO);
    eval 'sub XK_Hangul_E () {0xec4;}' unless defined(&XK_Hangul_E);
    eval 'sub XK_Hangul_YEO () {0xec5;}' unless defined(&XK_Hangul_YEO);
    eval 'sub XK_Hangul_YE () {0xec6;}' unless defined(&XK_Hangul_YE);
    eval 'sub XK_Hangul_O () {0xec7;}' unless defined(&XK_Hangul_O);
    eval 'sub XK_Hangul_WA () {0xec8;}' unless defined(&XK_Hangul_WA);
    eval 'sub XK_Hangul_WAE () {0xec9;}' unless defined(&XK_Hangul_WAE);
    eval 'sub XK_Hangul_OE () {0xeca;}' unless defined(&XK_Hangul_OE);
    eval 'sub XK_Hangul_YO () {0xecb;}' unless defined(&XK_Hangul_YO);
    eval 'sub XK_Hangul_U () {0xecc;}' unless defined(&XK_Hangul_U);
    eval 'sub XK_Hangul_WEO () {0xecd;}' unless defined(&XK_Hangul_WEO);
    eval 'sub XK_Hangul_WE () {0xece;}' unless defined(&XK_Hangul_WE);
    eval 'sub XK_Hangul_WI () {0xecf;}' unless defined(&XK_Hangul_WI);
    eval 'sub XK_Hangul_YU () {0xed0;}' unless defined(&XK_Hangul_YU);
    eval 'sub XK_Hangul_EU () {0xed1;}' unless defined(&XK_Hangul_EU);
    eval 'sub XK_Hangul_YI () {0xed2;}' unless defined(&XK_Hangul_YI);
    eval 'sub XK_Hangul_I () {0xed3;}' unless defined(&XK_Hangul_I);
    eval 'sub XK_Hangul_J_Kiyeog () {0xed4;}' unless defined(&XK_Hangul_J_Kiyeog);
    eval 'sub XK_Hangul_J_SsangKiyeog () {0xed5;}' unless defined(&XK_Hangul_J_SsangKiyeog);
    eval 'sub XK_Hangul_J_KiyeogSios () {0xed6;}' unless defined(&XK_Hangul_J_KiyeogSios);
    eval 'sub XK_Hangul_J_Nieun () {0xed7;}' unless defined(&XK_Hangul_J_Nieun);
    eval 'sub XK_Hangul_J_NieunJieuj () {0xed8;}' unless defined(&XK_Hangul_J_NieunJieuj);
    eval 'sub XK_Hangul_J_NieunHieuh () {0xed9;}' unless defined(&XK_Hangul_J_NieunHieuh);
    eval 'sub XK_Hangul_J_Dikeud () {0xeda;}' unless defined(&XK_Hangul_J_Dikeud);
    eval 'sub XK_Hangul_J_Rieul () {0xedb;}' unless defined(&XK_Hangul_J_Rieul);
    eval 'sub XK_Hangul_J_RieulKiyeog () {0xedc;}' unless defined(&XK_Hangul_J_RieulKiyeog);
    eval 'sub XK_Hangul_J_RieulMieum () {0xedd;}' unless defined(&XK_Hangul_J_RieulMieum);
    eval 'sub XK_Hangul_J_RieulPieub () {0xede;}' unless defined(&XK_Hangul_J_RieulPieub);
    eval 'sub XK_Hangul_J_RieulSios () {0xedf;}' unless defined(&XK_Hangul_J_RieulSios);
    eval 'sub XK_Hangul_J_RieulTieut () {0xee0;}' unless defined(&XK_Hangul_J_RieulTieut);
    eval 'sub XK_Hangul_J_RieulPhieuf () {0xee1;}' unless defined(&XK_Hangul_J_RieulPhieuf);
    eval 'sub XK_Hangul_J_RieulHieuh () {0xee2;}' unless defined(&XK_Hangul_J_RieulHieuh);
    eval 'sub XK_Hangul_J_Mieum () {0xee3;}' unless defined(&XK_Hangul_J_Mieum);
    eval 'sub XK_Hangul_J_Pieub () {0xee4;}' unless defined(&XK_Hangul_J_Pieub);
    eval 'sub XK_Hangul_J_PieubSios () {0xee5;}' unless defined(&XK_Hangul_J_PieubSios);
    eval 'sub XK_Hangul_J_Sios () {0xee6;}' unless defined(&XK_Hangul_J_Sios);
    eval 'sub XK_Hangul_J_SsangSios () {0xee7;}' unless defined(&XK_Hangul_J_SsangSios);
    eval 'sub XK_Hangul_J_Ieung () {0xee8;}' unless defined(&XK_Hangul_J_Ieung);
    eval 'sub XK_Hangul_J_Jieuj () {0xee9;}' unless defined(&XK_Hangul_J_Jieuj);
    eval 'sub XK_Hangul_J_Cieuc () {0xeea;}' unless defined(&XK_Hangul_J_Cieuc);
    eval 'sub XK_Hangul_J_Khieuq () {0xeeb;}' unless defined(&XK_Hangul_J_Khieuq);
    eval 'sub XK_Hangul_J_Tieut () {0xeec;}' unless defined(&XK_Hangul_J_Tieut);
    eval 'sub XK_Hangul_J_Phieuf () {0xeed;}' unless defined(&XK_Hangul_J_Phieuf);
    eval 'sub XK_Hangul_J_Hieuh () {0xeee;}' unless defined(&XK_Hangul_J_Hieuh);
    eval 'sub XK_Hangul_RieulYeorinHieuh () {0xeef;}' unless defined(&XK_Hangul_RieulYeorinHieuh);
    eval 'sub XK_Hangul_SunkyeongeumMieum () {0xef0;}' unless defined(&XK_Hangul_SunkyeongeumMieum);
    eval 'sub XK_Hangul_SunkyeongeumPieub () {0xef1;}' unless defined(&XK_Hangul_SunkyeongeumPieub);
    eval 'sub XK_Hangul_PanSios () {0xef2;}' unless defined(&XK_Hangul_PanSios);
    eval 'sub XK_Hangul_KkogjiDalrinIeung () {0xef3;}' unless defined(&XK_Hangul_KkogjiDalrinIeung);
    eval 'sub XK_Hangul_SunkyeongeumPhieuf () {0xef4;}' unless defined(&XK_Hangul_SunkyeongeumPhieuf);
    eval 'sub XK_Hangul_YeorinHieuh () {0xef5;}' unless defined(&XK_Hangul_YeorinHieuh);
    eval 'sub XK_Hangul_AraeA () {0xef6;}' unless defined(&XK_Hangul_AraeA);
    eval 'sub XK_Hangul_AraeAE () {0xef7;}' unless defined(&XK_Hangul_AraeAE);
    eval 'sub XK_Hangul_J_PanSios () {0xef8;}' unless defined(&XK_Hangul_J_PanSios);
    eval 'sub XK_Hangul_J_KkogjiDalrinIeung () {0xef9;}' unless defined(&XK_Hangul_J_KkogjiDalrinIeung);
    eval 'sub XK_Hangul_J_YeorinHieuh () {0xefa;}' unless defined(&XK_Hangul_J_YeorinHieuh);
    eval 'sub XK_Korean_Won () {0xeff;}' unless defined(&XK_Korean_Won);
}
if(defined(&XK_ARMENIAN)) {
    eval 'sub XK_Armenian_eternity () {0x14a1;}' unless defined(&XK_Armenian_eternity);
    eval 'sub XK_Armenian_ligature_ew () {0x14a2;}' unless defined(&XK_Armenian_ligature_ew);
    eval 'sub XK_Armenian_full_stop () {0x14a3;}' unless defined(&XK_Armenian_full_stop);
    eval 'sub XK_Armenian_verjaket () {0x14a3;}' unless defined(&XK_Armenian_verjaket);
    eval 'sub XK_Armenian_parenright () {0x14a4;}' unless defined(&XK_Armenian_parenright);
    eval 'sub XK_Armenian_parenleft () {0x14a5;}' unless defined(&XK_Armenian_parenleft);
    eval 'sub XK_Armenian_guillemotright () {0x14a6;}' unless defined(&XK_Armenian_guillemotright);
    eval 'sub XK_Armenian_guillemotleft () {0x14a7;}' unless defined(&XK_Armenian_guillemotleft);
    eval 'sub XK_Armenian_em_dash () {0x14a8;}' unless defined(&XK_Armenian_em_dash);
    eval 'sub XK_Armenian_dot () {0x14a9;}' unless defined(&XK_Armenian_dot);
    eval 'sub XK_Armenian_mijaket () {0x14a9;}' unless defined(&XK_Armenian_mijaket);
    eval 'sub XK_Armenian_separation_mark () {0x14aa;}' unless defined(&XK_Armenian_separation_mark);
    eval 'sub XK_Armenian_but () {0x14aa;}' unless defined(&XK_Armenian_but);
    eval 'sub XK_Armenian_comma () {0x14ab;}' unless defined(&XK_Armenian_comma);
    eval 'sub XK_Armenian_en_dash () {0x14ac;}' unless defined(&XK_Armenian_en_dash);
    eval 'sub XK_Armenian_hyphen () {0x14ad;}' unless defined(&XK_Armenian_hyphen);
    eval 'sub XK_Armenian_yentamna () {0x14ad;}' unless defined(&XK_Armenian_yentamna);
    eval 'sub XK_Armenian_ellipsis () {0x14ae;}' unless defined(&XK_Armenian_ellipsis);
    eval 'sub XK_Armenian_exclam () {0x14af;}' unless defined(&XK_Armenian_exclam);
    eval 'sub XK_Armenian_amanak () {0x14af;}' unless defined(&XK_Armenian_amanak);
    eval 'sub XK_Armenian_accent () {0x14b0;}' unless defined(&XK_Armenian_accent);
    eval 'sub XK_Armenian_shesht () {0x14b0;}' unless defined(&XK_Armenian_shesht);
    eval 'sub XK_Armenian_question () {0x14b1;}' unless defined(&XK_Armenian_question);
    eval 'sub XK_Armenian_paruyk () {0x14b1;}' unless defined(&XK_Armenian_paruyk);
    eval 'sub XK_Armenian_AYB () {0x14b2;}' unless defined(&XK_Armenian_AYB);
    eval 'sub XK_Armenian_ayb () {0x14b3;}' unless defined(&XK_Armenian_ayb);
    eval 'sub XK_Armenian_BEN () {0x14b4;}' unless defined(&XK_Armenian_BEN);
    eval 'sub XK_Armenian_ben () {0x14b5;}' unless defined(&XK_Armenian_ben);
    eval 'sub XK_Armenian_GIM () {0x14b6;}' unless defined(&XK_Armenian_GIM);
    eval 'sub XK_Armenian_gim () {0x14b7;}' unless defined(&XK_Armenian_gim);
    eval 'sub XK_Armenian_DA () {0x14b8;}' unless defined(&XK_Armenian_DA);
    eval 'sub XK_Armenian_da () {0x14b9;}' unless defined(&XK_Armenian_da);
    eval 'sub XK_Armenian_YECH () {0x14ba;}' unless defined(&XK_Armenian_YECH);
    eval 'sub XK_Armenian_yech () {0x14bb;}' unless defined(&XK_Armenian_yech);
    eval 'sub XK_Armenian_ZA () {0x14bc;}' unless defined(&XK_Armenian_ZA);
    eval 'sub XK_Armenian_za () {0x14bd;}' unless defined(&XK_Armenian_za);
    eval 'sub XK_Armenian_E () {0x14be;}' unless defined(&XK_Armenian_E);
    eval 'sub XK_Armenian_e () {0x14bf;}' unless defined(&XK_Armenian_e);
    eval 'sub XK_Armenian_AT () {0x14c0;}' unless defined(&XK_Armenian_AT);
    eval 'sub XK_Armenian_at () {0x14c1;}' unless defined(&XK_Armenian_at);
    eval 'sub XK_Armenian_TO () {0x14c2;}' unless defined(&XK_Armenian_TO);
    eval 'sub XK_Armenian_to () {0x14c3;}' unless defined(&XK_Armenian_to);
    eval 'sub XK_Armenian_ZHE () {0x14c4;}' unless defined(&XK_Armenian_ZHE);
    eval 'sub XK_Armenian_zhe () {0x14c5;}' unless defined(&XK_Armenian_zhe);
    eval 'sub XK_Armenian_INI () {0x14c6;}' unless defined(&XK_Armenian_INI);
    eval 'sub XK_Armenian_ini () {0x14c7;}' unless defined(&XK_Armenian_ini);
    eval 'sub XK_Armenian_LYUN () {0x14c8;}' unless defined(&XK_Armenian_LYUN);
    eval 'sub XK_Armenian_lyun () {0x14c9;}' unless defined(&XK_Armenian_lyun);
    eval 'sub XK_Armenian_KHE () {0x14ca;}' unless defined(&XK_Armenian_KHE);
    eval 'sub XK_Armenian_khe () {0x14cb;}' unless defined(&XK_Armenian_khe);
    eval 'sub XK_Armenian_TSA () {0x14cc;}' unless defined(&XK_Armenian_TSA);
    eval 'sub XK_Armenian_tsa () {0x14cd;}' unless defined(&XK_Armenian_tsa);
    eval 'sub XK_Armenian_KEN () {0x14ce;}' unless defined(&XK_Armenian_KEN);
    eval 'sub XK_Armenian_ken () {0x14cf;}' unless defined(&XK_Armenian_ken);
    eval 'sub XK_Armenian_HO () {0x14d0;}' unless defined(&XK_Armenian_HO);
    eval 'sub XK_Armenian_ho () {0x14d1;}' unless defined(&XK_Armenian_ho);
    eval 'sub XK_Armenian_DZA () {0x14d2;}' unless defined(&XK_Armenian_DZA);
    eval 'sub XK_Armenian_dza () {0x14d3;}' unless defined(&XK_Armenian_dza);
    eval 'sub XK_Armenian_GHAT () {0x14d4;}' unless defined(&XK_Armenian_GHAT);
    eval 'sub XK_Armenian_ghat () {0x14d5;}' unless defined(&XK_Armenian_ghat);
    eval 'sub XK_Armenian_TCHE () {0x14d6;}' unless defined(&XK_Armenian_TCHE);
    eval 'sub XK_Armenian_tche () {0x14d7;}' unless defined(&XK_Armenian_tche);
    eval 'sub XK_Armenian_MEN () {0x14d8;}' unless defined(&XK_Armenian_MEN);
    eval 'sub XK_Armenian_men () {0x14d9;}' unless defined(&XK_Armenian_men);
    eval 'sub XK_Armenian_HI () {0x14da;}' unless defined(&XK_Armenian_HI);
    eval 'sub XK_Armenian_hi () {0x14db;}' unless defined(&XK_Armenian_hi);
    eval 'sub XK_Armenian_NU () {0x14dc;}' unless defined(&XK_Armenian_NU);
    eval 'sub XK_Armenian_nu () {0x14dd;}' unless defined(&XK_Armenian_nu);
    eval 'sub XK_Armenian_SHA () {0x14de;}' unless defined(&XK_Armenian_SHA);
    eval 'sub XK_Armenian_sha () {0x14df;}' unless defined(&XK_Armenian_sha);
    eval 'sub XK_Armenian_VO () {0x14e0;}' unless defined(&XK_Armenian_VO);
    eval 'sub XK_Armenian_vo () {0x14e1;}' unless defined(&XK_Armenian_vo);
    eval 'sub XK_Armenian_CHA () {0x14e2;}' unless defined(&XK_Armenian_CHA);
    eval 'sub XK_Armenian_cha () {0x14e3;}' unless defined(&XK_Armenian_cha);
    eval 'sub XK_Armenian_PE () {0x14e4;}' unless defined(&XK_Armenian_PE);
    eval 'sub XK_Armenian_pe () {0x14e5;}' unless defined(&XK_Armenian_pe);
    eval 'sub XK_Armenian_JE () {0x14e6;}' unless defined(&XK_Armenian_JE);
    eval 'sub XK_Armenian_je () {0x14e7;}' unless defined(&XK_Armenian_je);
    eval 'sub XK_Armenian_RA () {0x14e8;}' unless defined(&XK_Armenian_RA);
    eval 'sub XK_Armenian_ra () {0x14e9;}' unless defined(&XK_Armenian_ra);
    eval 'sub XK_Armenian_SE () {0x14ea;}' unless defined(&XK_Armenian_SE);
    eval 'sub XK_Armenian_se () {0x14eb;}' unless defined(&XK_Armenian_se);
    eval 'sub XK_Armenian_VEV () {0x14ec;}' unless defined(&XK_Armenian_VEV);
    eval 'sub XK_Armenian_vev () {0x14ed;}' unless defined(&XK_Armenian_vev);
    eval 'sub XK_Armenian_TYUN () {0x14ee;}' unless defined(&XK_Armenian_TYUN);
    eval 'sub XK_Armenian_tyun () {0x14ef;}' unless defined(&XK_Armenian_tyun);
    eval 'sub XK_Armenian_RE () {0x14f0;}' unless defined(&XK_Armenian_RE);
    eval 'sub XK_Armenian_re () {0x14f1;}' unless defined(&XK_Armenian_re);
    eval 'sub XK_Armenian_TSO () {0x14f2;}' unless defined(&XK_Armenian_TSO);
    eval 'sub XK_Armenian_tso () {0x14f3;}' unless defined(&XK_Armenian_tso);
    eval 'sub XK_Armenian_VYUN () {0x14f4;}' unless defined(&XK_Armenian_VYUN);
    eval 'sub XK_Armenian_vyun () {0x14f5;}' unless defined(&XK_Armenian_vyun);
    eval 'sub XK_Armenian_PYUR () {0x14f6;}' unless defined(&XK_Armenian_PYUR);
    eval 'sub XK_Armenian_pyur () {0x14f7;}' unless defined(&XK_Armenian_pyur);
    eval 'sub XK_Armenian_KE () {0x14f8;}' unless defined(&XK_Armenian_KE);
    eval 'sub XK_Armenian_ke () {0x14f9;}' unless defined(&XK_Armenian_ke);
    eval 'sub XK_Armenian_O () {0x14fa;}' unless defined(&XK_Armenian_O);
    eval 'sub XK_Armenian_o () {0x14fb;}' unless defined(&XK_Armenian_o);
    eval 'sub XK_Armenian_FE () {0x14fc;}' unless defined(&XK_Armenian_FE);
    eval 'sub XK_Armenian_fe () {0x14fd;}' unless defined(&XK_Armenian_fe);
    eval 'sub XK_Armenian_apostrophe () {0x14fe;}' unless defined(&XK_Armenian_apostrophe);
    eval 'sub XK_Armenian_section_sign () {0x14ff;}' unless defined(&XK_Armenian_section_sign);
}
if(defined(&XK_GEORGIAN)) {
    eval 'sub XK_Georgian_an () {0x15d0;}' unless defined(&XK_Georgian_an);
    eval 'sub XK_Georgian_ban () {0x15d1;}' unless defined(&XK_Georgian_ban);
    eval 'sub XK_Georgian_gan () {0x15d2;}' unless defined(&XK_Georgian_gan);
    eval 'sub XK_Georgian_don () {0x15d3;}' unless defined(&XK_Georgian_don);
    eval 'sub XK_Georgian_en () {0x15d4;}' unless defined(&XK_Georgian_en);
    eval 'sub XK_Georgian_vin () {0x15d5;}' unless defined(&XK_Georgian_vin);
    eval 'sub XK_Georgian_zen () {0x15d6;}' unless defined(&XK_Georgian_zen);
    eval 'sub XK_Georgian_tan () {0x15d7;}' unless defined(&XK_Georgian_tan);
    eval 'sub XK_Georgian_in () {0x15d8;}' unless defined(&XK_Georgian_in);
    eval 'sub XK_Georgian_kan () {0x15d9;}' unless defined(&XK_Georgian_kan);
    eval 'sub XK_Georgian_las () {0x15da;}' unless defined(&XK_Georgian_las);
    eval 'sub XK_Georgian_man () {0x15db;}' unless defined(&XK_Georgian_man);
    eval 'sub XK_Georgian_nar () {0x15dc;}' unless defined(&XK_Georgian_nar);
    eval 'sub XK_Georgian_on () {0x15dd;}' unless defined(&XK_Georgian_on);
    eval 'sub XK_Georgian_par () {0x15de;}' unless defined(&XK_Georgian_par);
    eval 'sub XK_Georgian_zhar () {0x15df;}' unless defined(&XK_Georgian_zhar);
    eval 'sub XK_Georgian_rae () {0x15e0;}' unless defined(&XK_Georgian_rae);
    eval 'sub XK_Georgian_san () {0x15e1;}' unless defined(&XK_Georgian_san);
    eval 'sub XK_Georgian_tar () {0x15e2;}' unless defined(&XK_Georgian_tar);
    eval 'sub XK_Georgian_un () {0x15e3;}' unless defined(&XK_Georgian_un);
    eval 'sub XK_Georgian_phar () {0x15e4;}' unless defined(&XK_Georgian_phar);
    eval 'sub XK_Georgian_khar () {0x15e5;}' unless defined(&XK_Georgian_khar);
    eval 'sub XK_Georgian_ghan () {0x15e6;}' unless defined(&XK_Georgian_ghan);
    eval 'sub XK_Georgian_qar () {0x15e7;}' unless defined(&XK_Georgian_qar);
    eval 'sub XK_Georgian_shin () {0x15e8;}' unless defined(&XK_Georgian_shin);
    eval 'sub XK_Georgian_chin () {0x15e9;}' unless defined(&XK_Georgian_chin);
    eval 'sub XK_Georgian_can () {0x15ea;}' unless defined(&XK_Georgian_can);
    eval 'sub XK_Georgian_jil () {0x15eb;}' unless defined(&XK_Georgian_jil);
    eval 'sub XK_Georgian_cil () {0x15ec;}' unless defined(&XK_Georgian_cil);
    eval 'sub XK_Georgian_char () {0x15ed;}' unless defined(&XK_Georgian_char);
    eval 'sub XK_Georgian_xan () {0x15ee;}' unless defined(&XK_Georgian_xan);
    eval 'sub XK_Georgian_jhan () {0x15ef;}' unless defined(&XK_Georgian_jhan);
    eval 'sub XK_Georgian_hae () {0x15f0;}' unless defined(&XK_Georgian_hae);
    eval 'sub XK_Georgian_he () {0x15f1;}' unless defined(&XK_Georgian_he);
    eval 'sub XK_Georgian_hie () {0x15f2;}' unless defined(&XK_Georgian_hie);
    eval 'sub XK_Georgian_we () {0x15f3;}' unless defined(&XK_Georgian_we);
    eval 'sub XK_Georgian_har () {0x15f4;}' unless defined(&XK_Georgian_har);
    eval 'sub XK_Georgian_hoe () {0x15f5;}' unless defined(&XK_Georgian_hoe);
    eval 'sub XK_Georgian_fi () {0x15f6;}' unless defined(&XK_Georgian_fi);
}
if(defined(&XK_CAUCASUS)) {
    eval 'sub XK_Ccedillaabovedot () {0x16a2;}' unless defined(&XK_Ccedillaabovedot);
    eval 'sub XK_Xabovedot () {0x16a3;}' unless defined(&XK_Xabovedot);
    eval 'sub XK_Qabovedot () {0x16a5;}' unless defined(&XK_Qabovedot);
    eval 'sub XK_Ibreve () {0x16a6;}' unless defined(&XK_Ibreve);
    eval 'sub XK_IE () {0x16a7;}' unless defined(&XK_IE);
    eval 'sub XK_UO () {0x16a8;}' unless defined(&XK_UO);
    eval 'sub XK_Zstroke () {0x16a9;}' unless defined(&XK_Zstroke);
    eval 'sub XK_Gcaron () {0x16aa;}' unless defined(&XK_Gcaron);
    eval 'sub XK_Obarred () {0x16af;}' unless defined(&XK_Obarred);
    eval 'sub XK_ccedillaabovedot () {0x16b2;}' unless defined(&XK_ccedillaabovedot);
    eval 'sub XK_xabovedot () {0x16b3;}' unless defined(&XK_xabovedot);
    eval 'sub XK_Ocaron () {0x16b4;}' unless defined(&XK_Ocaron);
    eval 'sub XK_qabovedot () {0x16b5;}' unless defined(&XK_qabovedot);
    eval 'sub XK_ibreve () {0x16b6;}' unless defined(&XK_ibreve);
    eval 'sub XK_ie () {0x16b7;}' unless defined(&XK_ie);
    eval 'sub XK_uo () {0x16b8;}' unless defined(&XK_uo);
    eval 'sub XK_zstroke () {0x16b9;}' unless defined(&XK_zstroke);
    eval 'sub XK_gcaron () {0x16ba;}' unless defined(&XK_gcaron);
    eval 'sub XK_ocaron () {0x16bd;}' unless defined(&XK_ocaron);
    eval 'sub XK_obarred () {0x16bf;}' unless defined(&XK_obarred);
    eval 'sub XK_SCHWA () {0x16c6;}' unless defined(&XK_SCHWA);
    eval 'sub XK_schwa () {0x16f6;}' unless defined(&XK_schwa);
    eval 'sub XK_Lbelowdot () {0x16d1;}' unless defined(&XK_Lbelowdot);
    eval 'sub XK_Lstrokebelowdot () {0x16d2;}' unless defined(&XK_Lstrokebelowdot);
    eval 'sub XK_lbelowdot () {0x16e1;}' unless defined(&XK_lbelowdot);
    eval 'sub XK_lstrokebelowdot () {0x16e2;}' unless defined(&XK_lstrokebelowdot);
    eval 'sub XK_Gtilde () {0x16d3;}' unless defined(&XK_Gtilde);
    eval 'sub XK_gtilde () {0x16e3;}' unless defined(&XK_gtilde);
}
if(defined(&XK_VIETNAMESE)) {
    eval 'sub XK_Abelowdot () {0x1ea0;}' unless defined(&XK_Abelowdot);
    eval 'sub XK_abelowdot () {0x1ea1;}' unless defined(&XK_abelowdot);
    eval 'sub XK_Ahook () {0x1ea2;}' unless defined(&XK_Ahook);
    eval 'sub XK_ahook () {0x1ea3;}' unless defined(&XK_ahook);
    eval 'sub XK_Acircumflexacute () {0x1ea4;}' unless defined(&XK_Acircumflexacute);
    eval 'sub XK_acircumflexacute () {0x1ea5;}' unless defined(&XK_acircumflexacute);
    eval 'sub XK_Acircumflexgrave () {0x1ea6;}' unless defined(&XK_Acircumflexgrave);
    eval 'sub XK_acircumflexgrave () {0x1ea7;}' unless defined(&XK_acircumflexgrave);
    eval 'sub XK_Acircumflexhook () {0x1ea8;}' unless defined(&XK_Acircumflexhook);
    eval 'sub XK_acircumflexhook () {0x1ea9;}' unless defined(&XK_acircumflexhook);
    eval 'sub XK_Acircumflextilde () {0x1eaa;}' unless defined(&XK_Acircumflextilde);
    eval 'sub XK_acircumflextilde () {0x1eab;}' unless defined(&XK_acircumflextilde);
    eval 'sub XK_Acircumflexbelowdot () {0x1eac;}' unless defined(&XK_Acircumflexbelowdot);
    eval 'sub XK_acircumflexbelowdot () {0x1ead;}' unless defined(&XK_acircumflexbelowdot);
    eval 'sub XK_Abreveacute () {0x1eae;}' unless defined(&XK_Abreveacute);
    eval 'sub XK_abreveacute () {0x1eaf;}' unless defined(&XK_abreveacute);
    eval 'sub XK_Abrevegrave () {0x1eb0;}' unless defined(&XK_Abrevegrave);
    eval 'sub XK_abrevegrave () {0x1eb1;}' unless defined(&XK_abrevegrave);
    eval 'sub XK_Abrevehook () {0x1eb2;}' unless defined(&XK_Abrevehook);
    eval 'sub XK_abrevehook () {0x1eb3;}' unless defined(&XK_abrevehook);
    eval 'sub XK_Abrevetilde () {0x1eb4;}' unless defined(&XK_Abrevetilde);
    eval 'sub XK_abrevetilde () {0x1eb5;}' unless defined(&XK_abrevetilde);
    eval 'sub XK_Abrevebelowdot () {0x1eb6;}' unless defined(&XK_Abrevebelowdot);
    eval 'sub XK_abrevebelowdot () {0x1eb7;}' unless defined(&XK_abrevebelowdot);
    eval 'sub XK_Ebelowdot () {0x1eb8;}' unless defined(&XK_Ebelowdot);
    eval 'sub XK_ebelowdot () {0x1eb9;}' unless defined(&XK_ebelowdot);
    eval 'sub XK_Ehook () {0x1eba;}' unless defined(&XK_Ehook);
    eval 'sub XK_ehook () {0x1ebb;}' unless defined(&XK_ehook);
    eval 'sub XK_Etilde () {0x1ebc;}' unless defined(&XK_Etilde);
    eval 'sub XK_etilde () {0x1ebd;}' unless defined(&XK_etilde);
    eval 'sub XK_Ecircumflexacute () {0x1ebe;}' unless defined(&XK_Ecircumflexacute);
    eval 'sub XK_ecircumflexacute () {0x1ebf;}' unless defined(&XK_ecircumflexacute);
    eval 'sub XK_Ecircumflexgrave () {0x1ec0;}' unless defined(&XK_Ecircumflexgrave);
    eval 'sub XK_ecircumflexgrave () {0x1ec1;}' unless defined(&XK_ecircumflexgrave);
    eval 'sub XK_Ecircumflexhook () {0x1ec2;}' unless defined(&XK_Ecircumflexhook);
    eval 'sub XK_ecircumflexhook () {0x1ec3;}' unless defined(&XK_ecircumflexhook);
    eval 'sub XK_Ecircumflextilde () {0x1ec4;}' unless defined(&XK_Ecircumflextilde);
    eval 'sub XK_ecircumflextilde () {0x1ec5;}' unless defined(&XK_ecircumflextilde);
    eval 'sub XK_Ecircumflexbelowdot () {0x1ec6;}' unless defined(&XK_Ecircumflexbelowdot);
    eval 'sub XK_ecircumflexbelowdot () {0x1ec7;}' unless defined(&XK_ecircumflexbelowdot);
    eval 'sub XK_Ihook () {0x1ec8;}' unless defined(&XK_Ihook);
    eval 'sub XK_ihook () {0x1ec9;}' unless defined(&XK_ihook);
    eval 'sub XK_Ibelowdot () {0x1eca;}' unless defined(&XK_Ibelowdot);
    eval 'sub XK_ibelowdot () {0x1ecb;}' unless defined(&XK_ibelowdot);
    eval 'sub XK_Obelowdot () {0x1ecc;}' unless defined(&XK_Obelowdot);
    eval 'sub XK_obelowdot () {0x1ecd;}' unless defined(&XK_obelowdot);
    eval 'sub XK_Ohook () {0x1ece;}' unless defined(&XK_Ohook);
    eval 'sub XK_ohook () {0x1ecf;}' unless defined(&XK_ohook);
    eval 'sub XK_Ocircumflexacute () {0x1ed0;}' unless defined(&XK_Ocircumflexacute);
    eval 'sub XK_ocircumflexacute () {0x1ed1;}' unless defined(&XK_ocircumflexacute);
    eval 'sub XK_Ocircumflexgrave () {0x1ed2;}' unless defined(&XK_Ocircumflexgrave);
    eval 'sub XK_ocircumflexgrave () {0x1ed3;}' unless defined(&XK_ocircumflexgrave);
    eval 'sub XK_Ocircumflexhook () {0x1ed4;}' unless defined(&XK_Ocircumflexhook);
    eval 'sub XK_ocircumflexhook () {0x1ed5;}' unless defined(&XK_ocircumflexhook);
    eval 'sub XK_Ocircumflextilde () {0x1ed6;}' unless defined(&XK_Ocircumflextilde);
    eval 'sub XK_ocircumflextilde () {0x1ed7;}' unless defined(&XK_ocircumflextilde);
    eval 'sub XK_Ocircumflexbelowdot () {0x1ed8;}' unless defined(&XK_Ocircumflexbelowdot);
    eval 'sub XK_ocircumflexbelowdot () {0x1ed9;}' unless defined(&XK_ocircumflexbelowdot);
    eval 'sub XK_Ohornacute () {0x1eda;}' unless defined(&XK_Ohornacute);
    eval 'sub XK_ohornacute () {0x1edb;}' unless defined(&XK_ohornacute);
    eval 'sub XK_Ohorngrave () {0x1edc;}' unless defined(&XK_Ohorngrave);
    eval 'sub XK_ohorngrave () {0x1edd;}' unless defined(&XK_ohorngrave);
    eval 'sub XK_Ohornhook () {0x1ede;}' unless defined(&XK_Ohornhook);
    eval 'sub XK_ohornhook () {0x1edf;}' unless defined(&XK_ohornhook);
    eval 'sub XK_Ohorntilde () {0x1ee0;}' unless defined(&XK_Ohorntilde);
    eval 'sub XK_ohorntilde () {0x1ee1;}' unless defined(&XK_ohorntilde);
    eval 'sub XK_Ohornbelowdot () {0x1ee2;}' unless defined(&XK_Ohornbelowdot);
    eval 'sub XK_ohornbelowdot () {0x1ee3;}' unless defined(&XK_ohornbelowdot);
    eval 'sub XK_Ubelowdot () {0x1ee4;}' unless defined(&XK_Ubelowdot);
    eval 'sub XK_ubelowdot () {0x1ee5;}' unless defined(&XK_ubelowdot);
    eval 'sub XK_Uhook () {0x1ee6;}' unless defined(&XK_Uhook);
    eval 'sub XK_uhook () {0x1ee7;}' unless defined(&XK_uhook);
    eval 'sub XK_Uhornacute () {0x1ee8;}' unless defined(&XK_Uhornacute);
    eval 'sub XK_uhornacute () {0x1ee9;}' unless defined(&XK_uhornacute);
    eval 'sub XK_Uhorngrave () {0x1eea;}' unless defined(&XK_Uhorngrave);
    eval 'sub XK_uhorngrave () {0x1eeb;}' unless defined(&XK_uhorngrave);
    eval 'sub XK_Uhornhook () {0x1eec;}' unless defined(&XK_Uhornhook);
    eval 'sub XK_uhornhook () {0x1eed;}' unless defined(&XK_uhornhook);
    eval 'sub XK_Uhorntilde () {0x1eee;}' unless defined(&XK_Uhorntilde);
    eval 'sub XK_uhorntilde () {0x1eef;}' unless defined(&XK_uhorntilde);
    eval 'sub XK_Uhornbelowdot () {0x1ef0;}' unless defined(&XK_Uhornbelowdot);
    eval 'sub XK_uhornbelowdot () {0x1ef1;}' unless defined(&XK_uhornbelowdot);
    eval 'sub XK_Ybelowdot () {0x1ef4;}' unless defined(&XK_Ybelowdot);
    eval 'sub XK_ybelowdot () {0x1ef5;}' unless defined(&XK_ybelowdot);
    eval 'sub XK_Yhook () {0x1ef6;}' unless defined(&XK_Yhook);
    eval 'sub XK_yhook () {0x1ef7;}' unless defined(&XK_yhook);
    eval 'sub XK_Ytilde () {0x1ef8;}' unless defined(&XK_Ytilde);
    eval 'sub XK_ytilde () {0x1ef9;}' unless defined(&XK_ytilde);
    eval 'sub XK_Ohorn () {0x1efa;}' unless defined(&XK_Ohorn);
    eval 'sub XK_ohorn () {0x1efb;}' unless defined(&XK_ohorn);
    eval 'sub XK_Uhorn () {0x1efc;}' unless defined(&XK_Uhorn);
    eval 'sub XK_uhorn () {0x1efd;}' unless defined(&XK_uhorn);
    eval 'sub XK_combining_tilde () {0x1e9f;}' unless defined(&XK_combining_tilde);
    eval 'sub XK_combining_grave () {0x1ef2;}' unless defined(&XK_combining_grave);
    eval 'sub XK_combining_acute () {0x1ef3;}' unless defined(&XK_combining_acute);
    eval 'sub XK_combining_hook () {0x1efe;}' unless defined(&XK_combining_hook);
    eval 'sub XK_combining_belowdot () {0x1eff;}' unless defined(&XK_combining_belowdot);
}
if(defined(&XK_CURRENCY)) {
    eval 'sub XK_EcuSign () {0x20a0;}' unless defined(&XK_EcuSign);
    eval 'sub XK_ColonSign () {0x20a1;}' unless defined(&XK_ColonSign);
    eval 'sub XK_CruzeiroSign () {0x20a2;}' unless defined(&XK_CruzeiroSign);
    eval 'sub XK_FFrancSign () {0x20a3;}' unless defined(&XK_FFrancSign);
    eval 'sub XK_LiraSign () {0x20a4;}' unless defined(&XK_LiraSign);
    eval 'sub XK_MillSign () {0x20a5;}' unless defined(&XK_MillSign);
    eval 'sub XK_NairaSign () {0x20a6;}' unless defined(&XK_NairaSign);
    eval 'sub XK_PesetaSign () {0x20a7;}' unless defined(&XK_PesetaSign);
    eval 'sub XK_RupeeSign () {0x20a8;}' unless defined(&XK_RupeeSign);
    eval 'sub XK_WonSign () {0x20a9;}' unless defined(&XK_WonSign);
    eval 'sub XK_NewSheqelSign () {0x20aa;}' unless defined(&XK_NewSheqelSign);
    eval 'sub XK_DongSign () {0x20ab;}' unless defined(&XK_DongSign);
    eval 'sub XK_EuroSign () {0x20ac;}' unless defined(&XK_EuroSign);
}
1;
