require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&AUDIOFILE_H)) {
    eval 'sub AUDIOFILE_H () {1;}' unless defined(&AUDIOFILE_H);
    require 'sys/types.ph';
    require 'aupvlist.ph';
    eval 'sub LIBAUDIOFILE_MAJOR_VERSION () {0;}' unless defined(&LIBAUDIOFILE_MAJOR_VERSION);
    eval 'sub LIBAUDIOFILE_MINOR_VERSION () {2;}' unless defined(&LIBAUDIOFILE_MINOR_VERSION);
    if(defined(&__cplusplus)) {
    }
    eval 'sub AF_NULL_FILESETUP () {( 0);}' unless defined(&AF_NULL_FILESETUP);
    eval 'sub AF_NULL_FILEHANDLE () {( 0);}' unless defined(&AF_NULL_FILEHANDLE);
    eval 'sub AF_ERR_BASE () {3000;}' unless defined(&AF_ERR_BASE);
    eval("sub AF_DEFAULT_TRACK () { 1001; }") unless defined(&AF_DEFAULT_TRACK);
    eval("sub AF_DEFAULT_INST () { 2001; }") unless defined(&AF_DEFAULT_INST);
    eval("sub AF_NUM_UNLIMITED () { 99999; }") unless defined(&AF_NUM_UNLIMITED);
    eval("sub AF_BYTEORDER_BIGENDIAN () { 501; }") unless defined(&AF_BYTEORDER_BIGENDIAN);
    eval("sub AF_BYTEORDER_LITTLEENDIAN () { 502; }") unless defined(&AF_BYTEORDER_LITTLEENDIAN);
    eval("sub AF_FILE_UNKNOWN () { -1; }") unless defined(&AF_FILE_UNKNOWN);
    eval("sub AF_FILE_RAWDATA () { 0; }") unless defined(&AF_FILE_RAWDATA);
    eval("sub AF_FILE_AIFFC () { 1; }") unless defined(&AF_FILE_AIFFC);
    eval("sub AF_FILE_AIFF () { 2; }") unless defined(&AF_FILE_AIFF);
    eval("sub AF_FILE_NEXTSND () { 3; }") unless defined(&AF_FILE_NEXTSND);
    eval("sub AF_FILE_WAVE () { 4; }") unless defined(&AF_FILE_WAVE);
    eval("sub AF_FILE_BICSF () { 5; }") unless defined(&AF_FILE_BICSF);
    eval("sub AF_FILE_IRCAM () { AF_FILE_BICSF; }") unless defined(&AF_FILE_IRCAM);
    eval("sub AF_LOOP_MODE_NOLOOP () { 0; }") unless defined(&AF_LOOP_MODE_NOLOOP);
    eval("sub AF_LOOP_MODE_FORW () { 1; }") unless defined(&AF_LOOP_MODE_FORW);
    eval("sub AF_LOOP_MODE_FORWBAKW () { 2; }") unless defined(&AF_LOOP_MODE_FORWBAKW);
    eval("sub AF_SAMPFMT_TWOSCOMP () { 401; }") unless defined(&AF_SAMPFMT_TWOSCOMP);
    eval("sub AF_SAMPFMT_UNSIGNED () { 402; }") unless defined(&AF_SAMPFMT_UNSIGNED);
    eval("sub AF_SAMPFMT_FLOAT () { 403; }") unless defined(&AF_SAMPFMT_FLOAT);
    eval("sub AF_SAMPFMT_DOUBLE () { 404; }") unless defined(&AF_SAMPFMT_DOUBLE);
    eval("sub AF_INST_LOOP_OFF () { 0; }") unless defined(&AF_INST_LOOP_OFF);
    eval("sub AF_INST_LOOP_CONTINUOUS () { 1; }") unless defined(&AF_INST_LOOP_CONTINUOUS);
    eval("sub AF_INST_LOOP_SUSTAIN () { 3; }") unless defined(&AF_INST_LOOP_SUSTAIN);
    eval("sub AF_INST_MIDI_BASENOTE () { 301; }") unless defined(&AF_INST_MIDI_BASENOTE);
    eval("sub AF_INST_NUMCENTS_DETUNE () { 302; }") unless defined(&AF_INST_NUMCENTS_DETUNE);
    eval("sub AF_INST_MIDI_LONOTE () { 303; }") unless defined(&AF_INST_MIDI_LONOTE);
    eval("sub AF_INST_MIDI_HINOTE () { 304; }") unless defined(&AF_INST_MIDI_HINOTE);
    eval("sub AF_INST_MIDI_LOVELOCITY () { 305; }") unless defined(&AF_INST_MIDI_LOVELOCITY);
    eval("sub AF_INST_MIDI_HIVELOCITY () { 306; }") unless defined(&AF_INST_MIDI_HIVELOCITY);
    eval("sub AF_INST_NUMDBS_GAIN () { 307; }") unless defined(&AF_INST_NUMDBS_GAIN);
    eval("sub AF_INST_SUSLOOPID () { 308; }") unless defined(&AF_INST_SUSLOOPID);
    eval("sub AF_INST_RELLOOPID () { 309; }") unless defined(&AF_INST_RELLOOPID);
    eval("sub AF_INST_SAMP_STARTFRAME () { 310; }") unless defined(&AF_INST_SAMP_STARTFRAME);
    eval("sub AF_INST_SAMP_ENDFRAME () { 311; }") unless defined(&AF_INST_SAMP_ENDFRAME);
    eval("sub AF_INST_SAMP_MODE () { 312; }") unless defined(&AF_INST_SAMP_MODE);
    eval("sub AF_INST_TRACKID () { 313; }") unless defined(&AF_INST_TRACKID);
    eval("sub AF_INST_NAME () { 314; }") unless defined(&AF_INST_NAME);
    eval("sub AF_INST_SAMP_RATE () { 315; }") unless defined(&AF_INST_SAMP_RATE);
    eval("sub AF_INST_PRESETID () { 316; }") unless defined(&AF_INST_PRESETID);
    eval("sub AF_INST_PRESET_NAME () { 317; }") unless defined(&AF_INST_PRESET_NAME);
    eval("sub AF_MISC_UNRECOGNIZED () { 0; }") unless defined(&AF_MISC_UNRECOGNIZED);
    eval("sub AF_MISC_COPY () { 201; }") unless defined(&AF_MISC_COPY);
    eval("sub AF_MISC_AUTH () { 202; }") unless defined(&AF_MISC_AUTH);
    eval("sub AF_MISC_NAME () { 203; }") unless defined(&AF_MISC_NAME);
    eval("sub AF_MISC_ANNO () { 204; }") unless defined(&AF_MISC_ANNO);
    eval("sub AF_MISC_APPL () { 205; }") unless defined(&AF_MISC_APPL);
    eval("sub AF_MISC_MIDI () { 206; }") unless defined(&AF_MISC_MIDI);
    eval("sub AF_MISC_PCMMAP () { 207; }") unless defined(&AF_MISC_PCMMAP);
    eval("sub AF_MISC_NeXT () { 208; }") unless defined(&AF_MISC_NeXT);
    eval("sub AF_MISC_IRCAM_PEAKAMP () { 209; }") unless defined(&AF_MISC_IRCAM_PEAKAMP);
    eval("sub AF_MISC_IRCAM_COMMENT () { 210; }") unless defined(&AF_MISC_IRCAM_COMMENT);
    eval("sub AF_MISC_COMMENT () { 210; }") unless defined(&AF_MISC_COMMENT);
    eval("sub AF_MISC_ICMT () { AF_MISC_COMMENT; }") unless defined(&AF_MISC_ICMT);
    eval("sub AF_MISC_ICRD () { 211; }") unless defined(&AF_MISC_ICRD);
    eval("sub AF_MISC_ISFT () { 212; }") unless defined(&AF_MISC_ISFT);
    eval("sub AF_COMPRESSION_UNKNOWN () { -1; }") unless defined(&AF_COMPRESSION_UNKNOWN);
    eval("sub AF_COMPRESSION_NONE () { 0; }") unless defined(&AF_COMPRESSION_NONE);
    eval("sub AF_COMPRESSION_G722 () { 501; }") unless defined(&AF_COMPRESSION_G722);
    eval("sub AF_COMPRESSION_G711_ULAW () { 502; }") unless defined(&AF_COMPRESSION_G711_ULAW);
    eval("sub AF_COMPRESSION_G711_ALAW () { 503; }") unless defined(&AF_COMPRESSION_G711_ALAW);
    eval("sub AF_COMPRESSION_APPLE_ACE2 () { 504; }") unless defined(&AF_COMPRESSION_APPLE_ACE2);
    eval("sub AF_COMPRESSION_APPLE_ACE8 () { 505; }") unless defined(&AF_COMPRESSION_APPLE_ACE8);
    eval("sub AF_COMPRESSION_APPLE_MAC3 () { 506; }") unless defined(&AF_COMPRESSION_APPLE_MAC3);
    eval("sub AF_COMPRESSION_APPLE_MAC6 () { 507; }") unless defined(&AF_COMPRESSION_APPLE_MAC6);
    eval("sub AF_COMPRESSION_G726 () { 517; }") unless defined(&AF_COMPRESSION_G726);
    eval("sub AF_COMPRESSION_G728 () { 518; }") unless defined(&AF_COMPRESSION_G728);
    eval("sub AF_COMPRESSION_DVI_AUDIO () { 519; }") unless defined(&AF_COMPRESSION_DVI_AUDIO);
    eval("sub AF_COMPRESSION_IMA () { AF_COMPRESSION_DVI_AUDIO; }") unless defined(&AF_COMPRESSION_IMA);
    eval("sub AF_COMPRESSION_GSM () { 520; }") unless defined(&AF_COMPRESSION_GSM);
    eval("sub AF_COMPRESSION_FS1016 () { 521; }") unless defined(&AF_COMPRESSION_FS1016);
    eval("sub AF_COMPRESSION_DV () { 522; }") unless defined(&AF_COMPRESSION_DV);
    eval("sub AF_COMPRESSION_MS_ADPCM () { 523; }") unless defined(&AF_COMPRESSION_MS_ADPCM);
    eval("sub AF_QUERYTYPE_INSTPARAM () { 500; }") unless defined(&AF_QUERYTYPE_INSTPARAM);
    eval("sub AF_QUERYTYPE_FILEFMT () { 501; }") unless defined(&AF_QUERYTYPE_FILEFMT);
    eval("sub AF_QUERYTYPE_COMPRESSION () { 502; }") unless defined(&AF_QUERYTYPE_COMPRESSION);
    eval("sub AF_QUERYTYPE_COMPRESSIONPARAM () { 503; }") unless defined(&AF_QUERYTYPE_COMPRESSIONPARAM);
    eval("sub AF_QUERYTYPE_MISC () { 504; }") unless defined(&AF_QUERYTYPE_MISC);
    eval("sub AF_QUERYTYPE_INST () { 505; }") unless defined(&AF_QUERYTYPE_INST);
    eval("sub AF_QUERYTYPE_MARK () { 506; }") unless defined(&AF_QUERYTYPE_MARK);
    eval("sub AF_QUERYTYPE_LOOP () { 507; }") unless defined(&AF_QUERYTYPE_LOOP);
    eval("sub AF_QUERY_NAME () { 600; }") unless defined(&AF_QUERY_NAME);
    eval("sub AF_QUERY_DESC () { 601; }") unless defined(&AF_QUERY_DESC);
    eval("sub AF_QUERY_LABEL () { 602; }") unless defined(&AF_QUERY_LABEL);
    eval("sub AF_QUERY_TYPE () { 603; }") unless defined(&AF_QUERY_TYPE);
    eval("sub AF_QUERY_DEFAULT () { 604; }") unless defined(&AF_QUERY_DEFAULT);
    eval("sub AF_QUERY_ID_COUNT () { 605; }") unless defined(&AF_QUERY_ID_COUNT);
    eval("sub AF_QUERY_IDS () { 606; }") unless defined(&AF_QUERY_IDS);
    eval("sub AF_QUERY_IMPLEMENTED () { 613; }") unless defined(&AF_QUERY_IMPLEMENTED);
    eval("sub AF_QUERY_TYPE_COUNT () { 607; }") unless defined(&AF_QUERY_TYPE_COUNT);
    eval("sub AF_QUERY_TYPES () { 608; }") unless defined(&AF_QUERY_TYPES);
    eval("sub AF_QUERY_NATIVE_SAMPFMT () { 609; }") unless defined(&AF_QUERY_NATIVE_SAMPFMT);
    eval("sub AF_QUERY_NATIVE_SAMPWIDTH () { 610; }") unless defined(&AF_QUERY_NATIVE_SAMPWIDTH);
    eval("sub AF_QUERY_SQUISHFAC () { 611; }") unless defined(&AF_QUERY_SQUISHFAC);
    eval("sub AF_QUERY_MAX_NUMBER () { 612; }") unless defined(&AF_QUERY_MAX_NUMBER);
    eval("sub AF_QUERY_SUPPORTED () { 613; }") unless defined(&AF_QUERY_SUPPORTED);
    eval("sub AF_QUERY_TRACKS () { 620; }") unless defined(&AF_QUERY_TRACKS);
    eval("sub AF_QUERY_CHANNELS () { 621; }") unless defined(&AF_QUERY_CHANNELS);
    eval("sub AF_QUERY_SAMPLE_SIZES () { 622; }") unless defined(&AF_QUERY_SAMPLE_SIZES);
    eval("sub AF_QUERY_SAMPLE_FORMATS () { 623; }") unless defined(&AF_QUERY_SAMPLE_FORMATS);
    eval("sub AF_QUERY_COMPRESSION_TYPES () { 624; }") unless defined(&AF_QUERY_COMPRESSION_TYPES);
    eval("sub AF_QUERY_VALUE_COUNT () { 650; }") unless defined(&AF_QUERY_VALUE_COUNT);
    eval("sub AF_QUERY_VALUES () { 651; }") unless defined(&AF_QUERY_VALUES);
    eval("sub AF_BAD_NOT_IMPLEMENTED () { 0; }") unless defined(&AF_BAD_NOT_IMPLEMENTED);
    eval("sub AF_BAD_FILEHANDLE () { 1; }") unless defined(&AF_BAD_FILEHANDLE);
    eval("sub AF_BAD_OPEN () { 3; }") unless defined(&AF_BAD_OPEN);
    eval("sub AF_BAD_CLOSE () { 4; }") unless defined(&AF_BAD_CLOSE);
    eval("sub AF_BAD_READ () { 5; }") unless defined(&AF_BAD_READ);
    eval("sub AF_BAD_WRITE () { 6; }") unless defined(&AF_BAD_WRITE);
    eval("sub AF_BAD_LSEEK () { 7; }") unless defined(&AF_BAD_LSEEK);
    eval("sub AF_BAD_NO_FILEHANDLE () { 8; }") unless defined(&AF_BAD_NO_FILEHANDLE);
    eval("sub AF_BAD_ACCMODE () { 10; }") unless defined(&AF_BAD_ACCMODE);
    eval("sub AF_BAD_NOWRITEACC () { 11; }") unless defined(&AF_BAD_NOWRITEACC);
    eval("sub AF_BAD_NOREADACC () { 12; }") unless defined(&AF_BAD_NOREADACC);
    eval("sub AF_BAD_FILEFMT () { 13; }") unless defined(&AF_BAD_FILEFMT);
    eval("sub AF_BAD_RATE () { 14; }") unless defined(&AF_BAD_RATE);
    eval("sub AF_BAD_CHANNELS () { 15; }") unless defined(&AF_BAD_CHANNELS);
    eval("sub AF_BAD_SAMPCNT () { 16; }") unless defined(&AF_BAD_SAMPCNT);
    eval("sub AF_BAD_WIDTH () { 17; }") unless defined(&AF_BAD_WIDTH);
    eval("sub AF_BAD_SEEKMODE () { 18; }") unless defined(&AF_BAD_SEEKMODE);
    eval("sub AF_BAD_NO_LOOPDATA () { 19; }") unless defined(&AF_BAD_NO_LOOPDATA);
    eval("sub AF_BAD_MALLOC () { 20; }") unless defined(&AF_BAD_MALLOC);
    eval("sub AF_BAD_LOOPID () { 21; }") unless defined(&AF_BAD_LOOPID);
    eval("sub AF_BAD_SAMPFMT () { 22; }") unless defined(&AF_BAD_SAMPFMT);
    eval("sub AF_BAD_FILESETUP () { 23; }") unless defined(&AF_BAD_FILESETUP);
    eval("sub AF_BAD_TRACKID () { 24; }") unless defined(&AF_BAD_TRACKID);
    eval("sub AF_BAD_NUMTRACKS () { 25; }") unless defined(&AF_BAD_NUMTRACKS);
    eval("sub AF_BAD_NO_FILESETUP () { 26; }") unless defined(&AF_BAD_NO_FILESETUP);
    eval("sub AF_BAD_LOOPMODE () { 27; }") unless defined(&AF_BAD_LOOPMODE);
    eval("sub AF_BAD_INSTID () { 28; }") unless defined(&AF_BAD_INSTID);
    eval("sub AF_BAD_NUMLOOPS () { 29; }") unless defined(&AF_BAD_NUMLOOPS);
    eval("sub AF_BAD_NUMMARKS () { 30; }") unless defined(&AF_BAD_NUMMARKS);
    eval("sub AF_BAD_MARKID () { 31; }") unless defined(&AF_BAD_MARKID);
    eval("sub AF_BAD_MARKPOS () { 32; }") unless defined(&AF_BAD_MARKPOS);
    eval("sub AF_BAD_NUMINSTS () { 33; }") unless defined(&AF_BAD_NUMINSTS);
    eval("sub AF_BAD_NOAESDATA () { 34; }") unless defined(&AF_BAD_NOAESDATA);
    eval("sub AF_BAD_MISCID () { 35; }") unless defined(&AF_BAD_MISCID);
    eval("sub AF_BAD_NUMMISC () { 36; }") unless defined(&AF_BAD_NUMMISC);
    eval("sub AF_BAD_MISCSIZE () { 37; }") unless defined(&AF_BAD_MISCSIZE);
    eval("sub AF_BAD_MISCTYPE () { 38; }") unless defined(&AF_BAD_MISCTYPE);
    eval("sub AF_BAD_MISCSEEK () { 39; }") unless defined(&AF_BAD_MISCSEEK);
    eval("sub AF_BAD_STRLEN () { 40; }") unless defined(&AF_BAD_STRLEN);
    eval("sub AF_BAD_RATECONV () { 45; }") unless defined(&AF_BAD_RATECONV);
    eval("sub AF_BAD_SYNCFILE () { 46; }") unless defined(&AF_BAD_SYNCFILE);
    eval("sub AF_BAD_CODEC_CONFIG () { 47; }") unless defined(&AF_BAD_CODEC_CONFIG);
    eval("sub AF_BAD_CODEC_STATE () { 48; }") unless defined(&AF_BAD_CODEC_STATE);
    eval("sub AF_BAD_CODEC_LICENSE () { 49; }") unless defined(&AF_BAD_CODEC_LICENSE);
    eval("sub AF_BAD_CODEC_TYPE () { 50; }") unless defined(&AF_BAD_CODEC_TYPE);
    eval("sub AF_BAD_COMPRESSION () { AF_BAD_CODEC_CONFIG; }") unless defined(&AF_BAD_COMPRESSION);
    eval("sub AF_BAD_COMPTYPE () { AF_BAD_CODEC_TYPE; }") unless defined(&AF_BAD_COMPTYPE);
    eval("sub AF_BAD_INSTPTYPE () { 51; }") unless defined(&AF_BAD_INSTPTYPE);
    eval("sub AF_BAD_INSTPID () { 52; }") unless defined(&AF_BAD_INSTPID);
    eval("sub AF_BAD_BYTEORDER () { 53; }") unless defined(&AF_BAD_BYTEORDER);
    eval("sub AF_BAD_FILEFMT_PARAM () { 54; }") unless defined(&AF_BAD_FILEFMT_PARAM);
    eval("sub AF_BAD_COMP_PARAM () { 55; }") unless defined(&AF_BAD_COMP_PARAM);
    eval("sub AF_BAD_DATAOFFSET () { 56; }") unless defined(&AF_BAD_DATAOFFSET);
    eval("sub AF_BAD_FRAMECNT () { 57; }") unless defined(&AF_BAD_FRAMECNT);
    eval("sub AF_BAD_QUERYTYPE () { 58; }") unless defined(&AF_BAD_QUERYTYPE);
    eval("sub AF_BAD_QUERY () { 59; }") unless defined(&AF_BAD_QUERY);
    eval("sub AF_WARNING_CODEC_RATE () { 60; }") unless defined(&AF_WARNING_CODEC_RATE);
    eval("sub AF_WARNING_RATECVT () { 61; }") unless defined(&AF_WARNING_RATECVT);
    eval("sub AF_BAD_HEADER () { 62; }") unless defined(&AF_BAD_HEADER);
    eval("sub AF_BAD_FRAME () { 63; }") unless defined(&AF_BAD_FRAME);
    eval("sub AF_BAD_LOOPCOUNT () { 64; }") unless defined(&AF_BAD_LOOPCOUNT);
    eval("sub AF_BAD_DMEDIA_CALL () { 65; }") unless defined(&AF_BAD_DMEDIA_CALL);
    eval("sub AF_BAD_AIFF_HEADER () { 108; }") unless defined(&AF_BAD_AIFF_HEADER);
    eval("sub AF_BAD_AIFF_FORM () { 109; }") unless defined(&AF_BAD_AIFF_FORM);
    eval("sub AF_BAD_AIFF_SSND () { 110; }") unless defined(&AF_BAD_AIFF_SSND);
    eval("sub AF_BAD_AIFF_CHUNKID () { 111; }") unless defined(&AF_BAD_AIFF_CHUNKID);
    eval("sub AF_BAD_AIFF_COMM () { 112; }") unless defined(&AF_BAD_AIFF_COMM);
    eval("sub AF_BAD_AIFF_INST () { 113; }") unless defined(&AF_BAD_AIFF_INST);
    eval("sub AF_BAD_AIFF_MARK () { 114; }") unless defined(&AF_BAD_AIFF_MARK);
    eval("sub AF_BAD_AIFF_SKIP () { 115; }") unless defined(&AF_BAD_AIFF_SKIP);
    eval("sub AF_BAD_AIFF_LOOPMODE () { 116; }") unless defined(&AF_BAD_AIFF_LOOPMODE);
    eval("sub AF_ERR_NOT_IMPLEMENTED () { 0+AF_ERR_BASE; }") unless defined(&AF_ERR_NOT_IMPLEMENTED);
    eval("sub AF_ERR_BAD_FILEHANDLE () { 1+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_FILEHANDLE);
    eval("sub AF_ERR_BAD_READ () { 5+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_READ);
    eval("sub AF_ERR_BAD_WRITE () { 6+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_WRITE);
    eval("sub AF_ERR_BAD_LSEEK () { 7+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_LSEEK);
    eval("sub AF_ERR_BAD_ACCMODE () { 10+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_ACCMODE);
    eval("sub AF_ERR_NO_WRITEACC () { 11+AF_ERR_BASE; }") unless defined(&AF_ERR_NO_WRITEACC);
    eval("sub AF_ERR_NO_READACC () { 12+AF_ERR_BASE; }") unless defined(&AF_ERR_NO_READACC);
    eval("sub AF_ERR_BAD_FILEFMT () { 13+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_FILEFMT);
    eval("sub AF_ERR_BAD_RATE () { 14+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_RATE);
    eval("sub AF_ERR_BAD_CHANNELS () { 15+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_CHANNELS);
    eval("sub AF_ERR_BAD_SAMPCNT () { 16+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_SAMPCNT);
    eval("sub AF_ERR_BAD_WIDTH () { 17+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_WIDTH);
    eval("sub AF_ERR_BAD_SEEKMODE () { 18+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_SEEKMODE);
    eval("sub AF_ERR_BAD_LOOPID () { 21+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_LOOPID);
    eval("sub AF_ERR_BAD_SAMPFMT () { 22+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_SAMPFMT);
    eval("sub AF_ERR_BAD_FILESETUP () { 23+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_FILESETUP);
    eval("sub AF_ERR_BAD_TRACKID () { 24+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_TRACKID);
    eval("sub AF_ERR_BAD_NUMTRACKS () { 25+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_NUMTRACKS);
    eval("sub AF_ERR_BAD_LOOPMODE () { 27+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_LOOPMODE);
    eval("sub AF_ERR_BAD_INSTID () { 28+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_INSTID);
    eval("sub AF_ERR_BAD_NUMLOOPS () { 29+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_NUMLOOPS);
    eval("sub AF_ERR_BAD_NUMMARKS () { 30+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_NUMMARKS);
    eval("sub AF_ERR_BAD_MARKID () { 31+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_MARKID);
    eval("sub AF_ERR_BAD_MARKPOS () { 32+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_MARKPOS);
    eval("sub AF_ERR_BAD_NUMINSTS () { 33+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_NUMINSTS);
    eval("sub AF_ERR_BAD_NOAESDATA () { 34+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_NOAESDATA);
    eval("sub AF_ERR_BAD_MISCID () { 35+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_MISCID);
    eval("sub AF_ERR_BAD_NUMMISC () { 36+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_NUMMISC);
    eval("sub AF_ERR_BAD_MISCSIZE () { 37+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_MISCSIZE);
    eval("sub AF_ERR_BAD_MISCTYPE () { 38+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_MISCTYPE);
    eval("sub AF_ERR_BAD_MISCSEEK () { 39+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_MISCSEEK);
    eval("sub AF_ERR_BAD_STRLEN () { 40+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_STRLEN);
    eval("sub AF_ERR_BAD_RATECONV () { 45+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_RATECONV);
    eval("sub AF_ERR_BAD_SYNCFILE () { 46+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_SYNCFILE);
    eval("sub AF_ERR_BAD_CODEC_CONFIG () { 47+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_CODEC_CONFIG);
    eval("sub AF_ERR_BAD_CODEC_TYPE () { 50+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_CODEC_TYPE);
    eval("sub AF_ERR_BAD_INSTPTYPE () { 51+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_INSTPTYPE);
    eval("sub AF_ERR_BAD_INSTPID () { 52+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_INSTPID);
    eval("sub AF_ERR_BAD_BYTEORDER () { 53+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_BYTEORDER);
    eval("sub AF_ERR_BAD_FILEFMT_PARAM () { 54+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_FILEFMT_PARAM);
    eval("sub AF_ERR_BAD_COMP_PARAM () { 55+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_COMP_PARAM);
    eval("sub AF_ERR_BAD_DATAOFFSET () { 56+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_DATAOFFSET);
    eval("sub AF_ERR_BAD_FRAMECNT () { 57+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_FRAMECNT);
    eval("sub AF_ERR_BAD_QUERYTYPE () { 58+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_QUERYTYPE);
    eval("sub AF_ERR_BAD_QUERY () { 59+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_QUERY);
    eval("sub AF_ERR_BAD_HEADER () { 62+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_HEADER);
    eval("sub AF_ERR_BAD_FRAME () { 63+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_FRAME);
    eval("sub AF_ERR_BAD_LOOPCOUNT () { 64+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_LOOPCOUNT);
    eval("sub AF_ERR_BAD_AIFF_HEADER () { 66+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_AIFF_HEADER);
    eval("sub AF_ERR_BAD_AIFF_FORM () { 67+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_AIFF_FORM);
    eval("sub AF_ERR_BAD_AIFF_SSND () { 68+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_AIFF_SSND);
    eval("sub AF_ERR_BAD_AIFF_CHUNKID () { 69+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_AIFF_CHUNKID);
    eval("sub AF_ERR_BAD_AIFF_COMM () { 70+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_AIFF_COMM);
    eval("sub AF_ERR_BAD_AIFF_INST () { 71+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_AIFF_INST);
    eval("sub AF_ERR_BAD_AIFF_MARK () { 72+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_AIFF_MARK);
    eval("sub AF_ERR_BAD_AIFF_SKIP () { 73+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_AIFF_SKIP);
    eval("sub AF_ERR_BAD_AIFF_LOOPMODE () { 74+AF_ERR_BASE; }") unless defined(&AF_ERR_BAD_AIFF_LOOPMODE);
    if(0) {
    }
    if(0) {
    }
    if(0) {
    }
    if(0) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
