require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_BAUDBOY_H_)) {
    eval 'sub _BAUDBOY_H_ () {1;}' unless defined(&_BAUDBOY_H_);
    require 'stdio.ph';
    require 'stdlib.ph';
    require 'string.ph';
    require 'signal.ph';
    require 'sys/wait.ph';
    require 'sys/types.ph';
    require 'errno.ph';
    require 'unistd.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub LOCKDEV_PATH () {"/usr/sbin/lockdev";}' unless defined(&LOCKDEV_PATH);
    eval 'sub _doit {
        eval q({  &pid_t  &child; \'int\'  &status;  &void (* &osig) =  &signal( &SIGCHLD,  &SIG_DFL); \'int\'  &rc;  &if (!( &child =  &fork())) { \'int\'  &fd;  &if (( &fd =  &open(\\"/dev/null\\", 2)) < 0)  &exit(-1);  &dup2( &fd, 0);  &dup2( &fd, 1);  &dup2( &fd, 2);  &close;  &setregid( &getegid(),  &getgid());  &execv( $argv[0], (\'char\' * &const *) &argv);  &exit(-1); }  &rc =  &waitpid( &child,  &status, 0);  &signal( &SIGCHLD,  &osig);  &if ( &rc ==  &child  &&  &WIFEXITED( &status)) {  &rc =  &WEXITSTATUS( &status);  &switch( &rc) {  &case 0:  &rc = 0;  &break;  &default:  &case 1:  &rc = - &EPERM;  &break;  &case 2:  &rc = - &EACCES;  &break;  &case 3:  &rc = - &EROFS;  &break;  &case 4:  &rc = - &EFAULT;  &break;  &case 5:  &rc = - &EINVAL;  &break;  &case 6:  &rc = - &ENAMETOOLONG;  &break;  &case 7:  &rc = - &ENOENT;  &break;  &case 8:  &rc = - &ENOTDIR;  &break;  &case 9:  &rc = - &ENOMEM;  &break;  &case 10:  &rc = - &ELOOP;  &break;  &case 11:  &rc = - &EIO;  &break; } }  &else  &if ( &rc == -1)  &rc = - &errno;  &else  &rc = - &ECHILD;  &rc; });
    }' unless defined(&_doit);
    eval 'sub ttylock {
        my($devname) = @_;
	    eval q({  &const \'char\' *  $argv[] = {  &LOCKDEV_PATH, \\"-l\\",  &NULL,  &NULL};  $argv[2] = $devname;  &_doit( &argv); });
    }' unless defined(&ttylock);
    eval 'sub ttyunlock {
        my($devname) = @_;
	    eval q({  &const \'char\' *  $argv[] = {  &LOCKDEV_PATH, \\"-u\\",  &NULL,  &NULL};  $argv[2] = $devname;  &_doit( &argv); });
    }' unless defined(&ttyunlock);
    eval 'sub ttylocked {
        my($devname) = @_;
	    eval q({  &const \'char\' *  $argv[] = {  &LOCKDEV_PATH,  &NULL,  &NULL};  $argv[1] = $devname;  &_doit( &argv); });
    }' unless defined(&ttylocked);
    eval 'sub ttywait {
        my($devname) = @_;
	    eval q({ \'int\'  &rc;  &while(( &rc =  &ttylocked($devname)) == 0)  &sleep(1);  &rc; });
    }' unless defined(&ttywait);
    if(defined(&__cplusplus)) {
    }
}
1;
