require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_GLIBCPP_OS_DEFINES)) {
    eval 'sub _GLIBCPP_OS_DEFINES () {1;}' unless defined(&_GLIBCPP_OS_DEFINES);
    eval 'sub __NO_CTYPE () {1;}' unless defined(&__NO_CTYPE);
    require 'features.ph';
    if(!defined ( &__GLIBC__) || ((defined(&__GLIBC__) ? &__GLIBC__ : 0) == 2 && (defined(&__GLIBC_MINOR__) ? &__GLIBC_MINOR__ : 0)+ 0== 0)) {
	require 'gnu/types.ph';
	undef(&__THROW) if defined(&__THROW);
	eval 'sub __THROW () {1;}' unless defined(&__THROW);
	eval 'sub __NO_MATH_INLINES () {1;}' unless defined(&__NO_MATH_INLINES);
    }
    if(defined (defined(&__GLIBC__) ? &__GLIBC__ : 0)  && (defined(&__GLIBC__) ? &__GLIBC__ : 0) >= 2) {
	eval 'sub __NO_STRING_INLINES () {1;}' unless defined(&__NO_STRING_INLINES);
    }
    if((defined( &__hppa__)  && defined( &__LP64__)) || defined( &__powerpc64__) || defined( &__s390x__) || (defined( &__sparc__)  && defined( &__arch64__))) {
	eval 'sub __glibcpp_long_bits () {64;}' unless defined(&__glibcpp_long_bits);
    }
    if(defined( &__hppa__) || (defined( &__sparc__)  && !defined( &__arch64__))) {
	eval 'sub __glibcpp_long_double_bits () {64;}' unless defined(&__glibcpp_long_double_bits);
    }
    if(defined( &__GNUC__)  && !defined( &__INTEL_COMPILER)  && !defined( &__IBMCPP__)  && (defined( &__i386__) || defined( &__x86_64__) || defined( &__ia64__) || defined( &__s390__) || defined( &__s390x__) || defined( &__powerpc__) || defined( &__powerpc64__))) {
	eval 'sub __glibcpp_float_has_quiet_NaN () { &true;}' unless defined(&__glibcpp_float_has_quiet_NaN);
	eval 'sub __glibcpp_float_has_signaling_NaN () { &true;}' unless defined(&__glibcpp_float_has_signaling_NaN);
	eval 'sub __glibcpp_float_has_denorm () { &denorm_present;}' unless defined(&__glibcpp_float_has_denorm);
	eval 'sub __glibcpp_float_has_infinity () { &true;}' unless defined(&__glibcpp_float_has_infinity);
	eval 'sub __glibcpp_float_round_style () { &round_to_nearest;}' unless defined(&__glibcpp_float_round_style);
	eval 'sub __glibcpp_float_is_iec559 () { &true;}' unless defined(&__glibcpp_float_is_iec559);
	eval 'sub __glibcpp_double_has_quiet_NaN () { &true;}' unless defined(&__glibcpp_double_has_quiet_NaN);
	eval 'sub __glibcpp_double_has_signaling_NaN () { &true;}' unless defined(&__glibcpp_double_has_signaling_NaN);
	eval 'sub __glibcpp_double_has_denorm () { &denorm_present;}' unless defined(&__glibcpp_double_has_denorm);
	eval 'sub __glibcpp_double_has_infinity () { &true;}' unless defined(&__glibcpp_double_has_infinity);
	eval 'sub __glibcpp_double_round_style () { &round_to_nearest;}' unless defined(&__glibcpp_double_round_style);
	eval 'sub __glibcpp_double_is_iec559 () { &true;}' unless defined(&__glibcpp_double_is_iec559);
	eval 'sub __glibcpp_long_double_has_quiet_NaN () { &true;}' unless defined(&__glibcpp_long_double_has_quiet_NaN);
	eval 'sub __glibcpp_long_double_has_signaling_NaN () { &true;}' unless defined(&__glibcpp_long_double_has_signaling_NaN);
	eval 'sub __glibcpp_long_double_has_denorm () { &denorm_present;}' unless defined(&__glibcpp_long_double_has_denorm);
	eval 'sub __glibcpp_long_double_has_infinity () { &true;}' unless defined(&__glibcpp_long_double_has_infinity);
	eval 'sub __glibcpp_long_double_round_style () { &round_to_nearest;}' unless defined(&__glibcpp_long_double_round_style);
	eval 'sub __glibcpp_long_double_is_iec559 () { &true;}' unless defined(&__glibcpp_long_double_is_iec559);
	eval 'sub __glibcpp_f32_round_error () {0.5 &F;}' unless defined(&__glibcpp_f32_round_error);
	eval 'sub __glibcpp_f64_round_error () {0.5;}' unless defined(&__glibcpp_f64_round_error);
	eval 'sub __glibcpp_f80_round_error () {0.5;}' unless defined(&__glibcpp_f80_round_error);
	eval 'sub __glibcpp_f96_round_error () {0.5;}' unless defined(&__glibcpp_f96_round_error);
	eval 'sub __glibcpp_f128_round_error () {0.5;}' unless defined(&__glibcpp_f128_round_error);
	eval 'sub __glibcpp_float_infinity () {1.0e+40;}' unless defined(&__glibcpp_float_infinity);
	eval 'sub __glibcpp_double_infinity () {1.0e+320;}' unless defined(&__glibcpp_double_infinity);
	eval 'sub __glibcpp_long_double_infinity () {1.0e+5000;}' unless defined(&__glibcpp_long_double_infinity);
	eval 'sub __glibcpp_float_denorm_min () {1.40129846e-45;}' unless defined(&__glibcpp_float_denorm_min);
	eval 'sub __glibcpp_double_denorm_min () {4.9406564584124654e-324;}' unless defined(&__glibcpp_double_denorm_min);
	eval 'sub __glibcpp_float_quiet_NaN () {( &__extension__ ((\'union union\' { \'unsigned int __l\'; \'float\'  &__d; }) {  &__l: 0x7fc00000 }). &__d);}' unless defined(&__glibcpp_float_quiet_NaN);
	eval 'sub __glibcpp_double_quiet_NaN () {( &__extension__ ((\'union union\' { \'unsigned long long __l\'; \'double\'  &__d; }) {  &__l: 9.22112023704109e+18 }). &__d);}' unless defined(&__glibcpp_double_quiet_NaN);
	eval 'sub __glibcpp_float_signaling_NaN () {( &__extension__ ({ \'union union\' { \'unsigned int __l\'; \'float\'  &__d; }  &__u;  ($__u->{__l}) = 0x7fa00000;  &__asm ("" : : "r" (& &__u) : "memory");  ($__u->{__d}); }));}' unless defined(&__glibcpp_float_signaling_NaN);
	eval 'sub __glibcpp_double_signaling_NaN () {( &__extension__ ({ \'union union\' { \'unsigned long long __l\'; \'double\'  &__d; }  &__u;  ($__u->{__l}) = 9.21999433713425e+18;  &__asm ("" : : "r" (& &__u) : "memory");  ($__u->{__d}); }));}' unless defined(&__glibcpp_double_signaling_NaN);
	if('__glibcpp_long_double_bits' == 80) {
	    eval 'sub __glibcpp_long_double_denorm_min () {3.64519953188247460253e-4951;}' unless defined(&__glibcpp_long_double_denorm_min);
	    eval 'sub __glibcpp_long_double_quiet_NaN () {( &__extension__ ({ \'union union\' { \'unsigned long long __l\'[2]; \'long double __d\'; }  &__u;  ($__u->{__l[0]}) = 0xc << 60;  ($__u->{__l[1]}) = 0x7fff;  ($__u->{__d}); }));}' unless defined(&__glibcpp_long_double_quiet_NaN);
	    eval 'sub __glibcpp_long_double_signaling_NaN () {( &__extension__ ({ \'union union\' { \'unsigned long long __l\'[2]; \'long double __d\'; }  &__u;  ($__u->{__l[0]}) = 0xa << 60;  ($__u->{__l[1]}) = 0x7fff;  &__asm ("" : : "r" (& &__u) : "memory");  ($__u->{__d}); }));}' unless defined(&__glibcpp_long_double_signaling_NaN);
	} else {
	    eval 'sub __glibcpp_long_double_denorm_min () {4.9406564584124654e-324;}' unless defined(&__glibcpp_long_double_denorm_min);
	    eval 'sub __glibcpp_long_double_quiet_NaN () {( &__extension__ ((\'union union\' { \'unsigned long long __l\'; \'long double __d\'; }) {  &__l: 9.22112023704109e+18 }). &__d);}' unless defined(&__glibcpp_long_double_quiet_NaN);
	    eval 'sub __glibcpp_long_double_signaling_NaN () {( &__extension__ ({ \'union union\' { \'unsigned long long __l\'; \'long double __d\'; }  &__u;  ($__u->{__l}) = 9.21999433713425e+18;  &__asm ("" : : "r" (& &__u) : "memory");  ($__u->{__d}); }));}' unless defined(&__glibcpp_long_double_signaling_NaN);
	}
    }
}
1;
