require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__FT_HEADER_H__)) {
    eval 'sub __FT_HEADER_H__ () {1;}' unless defined(&__FT_HEADER_H__);
    if(defined(&__cplusplus)) {
	eval 'sub FT_BEGIN_HEADER () { &extern "C" {;}' unless defined(&FT_BEGIN_HEADER);
    } else {
	eval 'sub FT_BEGIN_HEADER () {1;}' unless defined(&FT_BEGIN_HEADER);
    }
    if(defined(&__cplusplus)) {
	eval 'sub FT_END_HEADER () {};}' unless defined(&FT_END_HEADER);
    } else {
	eval 'sub FT_END_HEADER () {1;}' unless defined(&FT_END_HEADER);
    }
    unless(defined(&FT_CONFIG_CONFIG_H)) {
	eval 'sub FT_CONFIG_CONFIG_H () {< &freetype/ &config/ ($ftconfig->{h})>;}' unless defined(&FT_CONFIG_CONFIG_H);
    }
    unless(defined(&FT_CONFIG_STANDARD_LIBRARY_H)) {
	eval 'sub FT_CONFIG_STANDARD_LIBRARY_H () {< &freetype/ &config/ ($ftstdlib->{h})>;}' unless defined(&FT_CONFIG_STANDARD_LIBRARY_H);
    }
    unless(defined(&FT_CONFIG_OPTIONS_H)) {
	eval 'sub FT_CONFIG_OPTIONS_H () {< &freetype/ &config/ ($ftoption->{h})>;}' unless defined(&FT_CONFIG_OPTIONS_H);
    }
    unless(defined(&FT_CONFIG_MODULES_H)) {
	eval 'sub FT_CONFIG_MODULES_H () {< &freetype/ &config/ ($ftmodule->{h})>;}' unless defined(&FT_CONFIG_MODULES_H);
    }
    eval 'sub FT_FREETYPE_H () {< &freetype/ ($freetype->{h})>;}' unless defined(&FT_FREETYPE_H);
    eval 'sub FT_ERRORS_H () {< &freetype/ ($fterrors->{h})>;}' unless defined(&FT_ERRORS_H);
    eval 'sub FT_MODULE_ERRORS_H () {< &freetype/ ($ftmoderr->{h})>;}' unless defined(&FT_MODULE_ERRORS_H);
    eval 'sub FT_SYSTEM_H () {< &freetype/ ($ftsystem->{h})>;}' unless defined(&FT_SYSTEM_H);
    eval 'sub FT_IMAGE_H () {< &freetype/ ($ftimage->{h})>;}' unless defined(&FT_IMAGE_H);
    eval 'sub FT_TYPES_H () {< &freetype/ ($fttypes->{h})>;}' unless defined(&FT_TYPES_H);
    eval 'sub FT_LIST_H () {< &freetype/ ($ftlist->{h})>;}' unless defined(&FT_LIST_H);
    eval 'sub FT_OUTLINE_H () {< &freetype/ ($ftoutln->{h})>;}' unless defined(&FT_OUTLINE_H);
    eval 'sub FT_SIZES_H () {< &freetype/ ($ftsizes->{h})>;}' unless defined(&FT_SIZES_H);
    eval 'sub FT_MODULE_H () {< &freetype/ ($ftmodule->{h})>;}' unless defined(&FT_MODULE_H);
    eval 'sub FT_RENDER_H () {< &freetype/ ($ftrender->{h})>;}' unless defined(&FT_RENDER_H);
    eval 'sub FT_TYPE1_TABLES_H () {< &freetype/ ($t1tables->{h})>;}' unless defined(&FT_TYPE1_TABLES_H);
    eval 'sub FT_TRUETYPE_IDS_H () {< &freetype/ ($ttnameid->{h})>;}' unless defined(&FT_TRUETYPE_IDS_H);
    eval 'sub FT_TRUETYPE_TABLES_H () {< &freetype/ ($tttables->{h})>;}' unless defined(&FT_TRUETYPE_TABLES_H);
    eval 'sub FT_TRUETYPE_TAGS_H () {< &freetype/ ($tttags->{h})>;}' unless defined(&FT_TRUETYPE_TAGS_H);
    eval 'sub FT_BDF_H () {< &freetype/ ($ftbdf->{h})>;}' unless defined(&FT_BDF_H);
    eval 'sub FT_GZIP_H () {< &freetype/ ($ftgzip->{h})>;}' unless defined(&FT_GZIP_H);
    eval 'sub FT_WINFONTS_H () {< &freetype/ ($ftwinfnt->{h})>;}' unless defined(&FT_WINFONTS_H);
    eval 'sub FT_GLYPH_H () {< &freetype/ ($ftglyph->{h})>;}' unless defined(&FT_GLYPH_H);
    eval 'sub FT_BBOX_H () {< &freetype/ ($ftbbox->{h})>;}' unless defined(&FT_BBOX_H);
    eval 'sub FT_CACHE_H () {< &freetype/ ($ftcache->{h})>;}' unless defined(&FT_CACHE_H);
    eval 'sub FT_CACHE_IMAGE_H () {< &freetype/ &cache/ ($ftcimage->{h})>;}' unless defined(&FT_CACHE_IMAGE_H);
    eval 'sub FT_CACHE_SMALL_BITMAPS_H () {< &freetype/ &cache/ ($ftcsbits->{h})>;}' unless defined(&FT_CACHE_SMALL_BITMAPS_H);
    eval 'sub FT_CACHE_CHARMAP_H () {< &freetype/ &cache/ ($ftccmap->{h})>;}' unless defined(&FT_CACHE_CHARMAP_H);
    eval 'sub FT_MAC_H () {< &freetype/ ($ftmac->{h})>;}' unless defined(&FT_MAC_H);
    eval 'sub FT_MULTIPLE_MASTERS_H () {< &freetype/ ($ftmm->{h})>;}' unless defined(&FT_MULTIPLE_MASTERS_H);
    eval 'sub FT_SFNT_NAMES_H () {< &freetype/ ($ftsnames->{h})>;}' unless defined(&FT_SFNT_NAMES_H);
    eval 'sub FT_TRIGONOMETRY_H () {< &freetype/ ($fttrigon->{h})>;}' unless defined(&FT_TRIGONOMETRY_H);
    eval 'sub FT_STROKER_H () {< &freetype/ ($ftstroker->{h})>;}' unless defined(&FT_STROKER_H);
    eval 'sub FT_SYNTHESIS_H () {< &freetype/ ($ftsynth->{h})>;}' unless defined(&FT_SYNTHESIS_H);
    eval 'sub FT_ERROR_DEFINITIONS_H () {< &freetype/ ($fterrdef->{h})>;}' unless defined(&FT_ERROR_DEFINITIONS_H);
    eval 'sub FT_CACHE_MANAGER_H () {< &freetype/ &cache/ ($ftcmanag->{h})>;}' unless defined(&FT_CACHE_MANAGER_H);
    eval 'sub FT_CACHE_INTERNAL_LRU_H () {< &freetype/ &cache/ ($ftlru->{h})>;}' unless defined(&FT_CACHE_INTERNAL_LRU_H);
    eval 'sub FT_CACHE_INTERNAL_GLYPH_H () {< &freetype/ &cache/ ($ftcglyph->{h})>;}' unless defined(&FT_CACHE_INTERNAL_GLYPH_H);
    eval 'sub FT_CACHE_INTERNAL_CACHE_H () {< &freetype/ &cache/ ($ftccache->{h})>;}' unless defined(&FT_CACHE_INTERNAL_CACHE_H);
    eval 'sub FT_XFREE86_H () {< &freetype/ ($ftxf86->{h})>;}' unless defined(&FT_XFREE86_H);
    eval 'sub FT_INCREMENTAL_H () {< &freetype/ ($ftincrem->{h})>;}' unless defined(&FT_INCREMENTAL_H);
    eval 'sub FT_INTERNAL_INTERNAL_H () {< &freetype/ &internal/ ($internal->{h})>;}' unless defined(&FT_INTERNAL_INTERNAL_H);
}
1;
