require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__FTERRORS_H__)) {
    eval 'sub __FTERRORS_H__ () {1;}' unless defined(&__FTERRORS_H__);
    undef(&FT_NEED_EXTERN_C) if defined(&FT_NEED_EXTERN_C);
    undef(&FT_ERR_XCAT) if defined(&FT_ERR_XCAT);
    undef(&FT_ERR_CAT) if defined(&FT_ERR_CAT);
    eval 'sub FT_ERR_XCAT {
        my( $x, $y ) = @_;
	    eval q( &x   &y);
    }' unless defined(&FT_ERR_XCAT);
    eval 'sub FT_ERR_CAT {
        my( $x, $y ) = @_;
	    eval q( &FT_ERR_XCAT(  &x,  &y ));
    }' unless defined(&FT_ERR_CAT);
    unless(defined(&FT_ERR_PREFIX)) {
	eval 'sub FT_ERR_PREFIX () { &FT_Err_;}' unless defined(&FT_ERR_PREFIX);
    }
    if(defined(&FT_CONFIG_OPTION_USE_MODULE_ERRORS)) {
	unless(defined(&FT_ERR_BASE)) {
	    eval 'sub FT_ERR_BASE () { &FT_Mod_Err_Base;}' unless defined(&FT_ERR_BASE);
	}
    } else {
	undef(&FT_ERR_BASE) if defined(&FT_ERR_BASE);
	eval 'sub FT_ERR_BASE () {0;}' unless defined(&FT_ERR_BASE);
    }
    unless(defined(&FT_ERRORDEF)) {
	eval 'sub FT_ERRORDEF {
	    my( $e, $v, $s ) = @_;
    	    eval q( &e = $v,);
	}' unless defined(&FT_ERRORDEF);
	eval 'sub FT_ERROR_START_LIST () { &enum {;}' unless defined(&FT_ERROR_START_LIST);
	eval 'sub FT_ERROR_END_LIST () { &FT_ERR_CAT(  &FT_ERR_PREFIX,  &Max ) };;}' unless defined(&FT_ERROR_END_LIST);
	if(defined(&__cplusplus)) {
	    eval 'sub FT_NEED_EXTERN_C () {1;}' unless defined(&FT_NEED_EXTERN_C);
	}
    }
    eval 'sub FT_ERRORDEF_ {
        my( $e, $v, $s ) = @_;
	    eval q( &FT_ERRORDEF(  &FT_ERR_CAT(  &FT_ERR_PREFIX,  &e ), $v +  &FT_ERR_BASE,  &s ));
    }' unless defined(&FT_ERRORDEF_);
    eval 'sub FT_NOERRORDEF_ {
        my( $e, $v, $s ) = @_;
	    eval q( &FT_ERRORDEF(  &FT_ERR_CAT(  &FT_ERR_PREFIX,  &e ), $v,  &s ));
    }' unless defined(&FT_NOERRORDEF_);
    if(defined(&FT_ERROR_START_LIST)) {
    }
    if(defined(&FT_ERROR_END_LIST)) {
    }
    if(defined(&FT_NEED_EXTERN_C)) {
    }
    undef(&FT_ERROR_START_LIST) if defined(&FT_ERROR_START_LIST);
    undef(&FT_ERROR_END_LIST) if defined(&FT_ERROR_END_LIST);
    undef(&FT_ERRORDEF) if defined(&FT_ERRORDEF);
    undef(&FT_ERRORDEF_) if defined(&FT_ERRORDEF_);
    undef(&FT_NOERRORDEF_) if defined(&FT_NOERRORDEF_);
    undef(&FT_NEED_EXTERN_C) if defined(&FT_NEED_EXTERN_C);
    undef(&FT_ERR_PREFIX) if defined(&FT_ERR_PREFIX);
    undef(&FT_ERR_BASE) if defined(&FT_ERR_BASE);
    undef(&FT_ERR_CONCAT) if defined(&FT_ERR_CONCAT);
}
1;
