require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__FTOBJS_H__)) {
    eval 'sub __FTOBJS_H__ () {1;}' unless defined(&__FTOBJS_H__);
    require 'ft2build.ph';
    if(defined(&FT_CONFIG_OPTION_INCREMENTAL)) {
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    unless(defined(&NULL)) {
	eval 'sub NULL () {( &void*)0;}' unless defined(&NULL);
    }
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    my( $a, $b ) = @_;
    	    eval q(( ( &a) < ( &b) ? ( &a) : ( &b) ));
	}' unless defined(&MIN);
    }
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    my( $a, $b ) = @_;
    	    eval q(( ( &a) > ( &b) ? ( &a) : ( &b) ));
	}' unless defined(&MAX);
    }
    unless(defined(&ABS)) {
	eval 'sub ABS {
	    my( $a ) = @_;
    	    eval q(( ( &a) < 0? -( &a) : ( &a) ));
	}' unless defined(&ABS);
    }
    eval("sub FT_VALIDATE_DEFAULT () { 0; }") unless defined(&FT_VALIDATE_DEFAULT);
    eval("sub FT_VALIDATE_TIGHT () { 1; }") unless defined(&FT_VALIDATE_TIGHT);
    eval("sub FT_VALIDATE_PARANOID () { 2; }") unless defined(&FT_VALIDATE_PARANOID);
    eval 'sub FT_VALIDATOR {
        my( $x ) = @_;
	    eval q((( &FT_Validator)(  &x )));
    }' unless defined(&FT_VALIDATOR);
    eval 'sub FT_INVALID {
        my( $_error ) = @_;
	    eval q( &ft_validator_error(  &valid, $_error ));
    }' unless defined(&FT_INVALID);
    eval 'sub FT_INVALID_TOO_SHORT () { &FT_INVALID(  &FT_Err_Invalid_Table );}' unless defined(&FT_INVALID_TOO_SHORT);
    eval 'sub FT_INVALID_OFFSET () { &FT_INVALID(  &FT_Err_Invalid_Offset );}' unless defined(&FT_INVALID_OFFSET);
    eval 'sub FT_INVALID_FORMAT () { &FT_INVALID(  &FT_Err_Invalid_Table );}' unless defined(&FT_INVALID_FORMAT);
    eval 'sub FT_INVALID_GLYPH_ID () { &FT_INVALID(  &FT_Err_Invalid_Glyph_Index );}' unless defined(&FT_INVALID_GLYPH_ID);
    eval 'sub FT_INVALID_DATA () { &FT_INVALID(  &FT_Err_Invalid_Table );}' unless defined(&FT_INVALID_DATA);
    eval 'sub FT_CMAP {
        my( $x ) = @_;
	    eval q((( &FT_CMap)(  &x )));
    }' unless defined(&FT_CMAP);
    eval 'sub FT_CMAP_PLATFORM_ID {
        my( $x ) = @_;
	    eval q( &FT_CMAP(  &x )-> ($charmap->{platform_id}));
    }' unless defined(&FT_CMAP_PLATFORM_ID);
    eval 'sub FT_CMAP_ENCODING_ID {
        my( $x ) = @_;
	    eval q( &FT_CMAP(  &x )-> ($charmap->{encoding_id}));
    }' unless defined(&FT_CMAP_ENCODING_ID);
    eval 'sub FT_CMAP_ENCODING {
        my( $x ) = @_;
	    eval q( &FT_CMAP(  &x )-> ($charmap->{encoding}));
    }' unless defined(&FT_CMAP_ENCODING);
    eval 'sub FT_CMAP_FACE {
        my( $x ) = @_;
	    eval q( &FT_CMAP(  &x )-> ($charmap->{face}));
    }' unless defined(&FT_CMAP_FACE);
    if(defined(&FT_CONFIG_OPTION_INCREMENTAL)) {
    }
    eval 'sub FT_MODULE {
        my( $x ) = @_;
	    eval q((( &FT_Module)(  &x )));
    }' unless defined(&FT_MODULE);
    eval 'sub FT_MODULE_CLASS {
        my( $x ) = @_;
	    eval q( &FT_MODULE(  &x )-> &clazz);
    }' unless defined(&FT_MODULE_CLASS);
    eval 'sub FT_MODULE_LIBRARY {
        my( $x ) = @_;
	    eval q( &FT_MODULE(  &x )-> &library);
    }' unless defined(&FT_MODULE_LIBRARY);
    eval 'sub FT_MODULE_MEMORY {
        my( $x ) = @_;
	    eval q( &FT_MODULE(  &x )-> &memory);
    }' unless defined(&FT_MODULE_MEMORY);
    eval 'sub FT_MODULE_IS_DRIVER {
        my( $x ) = @_;
	    eval q((  &FT_MODULE_CLASS(  &x )-> &module_flags &  &ft_module_font_driver ));
    }' unless defined(&FT_MODULE_IS_DRIVER);
    eval 'sub FT_MODULE_IS_RENDERER {
        my( $x ) = @_;
	    eval q((  &FT_MODULE_CLASS(  &x )-> &module_flags &  &ft_module_renderer ));
    }' unless defined(&FT_MODULE_IS_RENDERER);
    eval 'sub FT_MODULE_IS_HINTER {
        my( $x ) = @_;
	    eval q((  &FT_MODULE_CLASS(  &x )-> &module_flags &  &ft_module_hinter ));
    }' unless defined(&FT_MODULE_IS_HINTER);
    eval 'sub FT_MODULE_IS_STYLER {
        my( $x ) = @_;
	    eval q((  &FT_MODULE_CLASS(  &x )-> &module_flags &  &ft_module_styler ));
    }' unless defined(&FT_MODULE_IS_STYLER);
    eval 'sub FT_DRIVER_IS_SCALABLE {
        my( $x ) = @_;
	    eval q((  &FT_MODULE_CLASS(  &x )-> &module_flags &  &ft_module_driver_scalable ));
    }' unless defined(&FT_DRIVER_IS_SCALABLE);
    eval 'sub FT_DRIVER_USES_OUTLINES {
        my( $x ) = @_;
	    eval q(!(  &FT_MODULE_CLASS(  &x )-> &module_flags &  &ft_module_driver_no_outlines ));
    }' unless defined(&FT_DRIVER_USES_OUTLINES);
    eval 'sub FT_DRIVER_HAS_HINTER {
        my( $x ) = @_;
	    eval q((  &FT_MODULE_CLASS(  &x )-> &module_flags &  &ft_module_driver_has_hinter ));
    }' unless defined(&FT_DRIVER_HAS_HINTER);
    eval 'sub FT_FACE {
        my( $x ) = @_;
	    eval q((( &FT_Face)( &x)));
    }' unless defined(&FT_FACE);
    eval 'sub FT_SIZE {
        my( $x ) = @_;
	    eval q((( &FT_Size)( &x)));
    }' unless defined(&FT_SIZE);
    eval 'sub FT_SLOT {
        my( $x ) = @_;
	    eval q((( &FT_GlyphSlot)( &x)));
    }' unless defined(&FT_SLOT);
    eval 'sub FT_FACE_DRIVER {
        my( $x ) = @_;
	    eval q( &FT_FACE(  &x )-> &driver);
    }' unless defined(&FT_FACE_DRIVER);
    eval 'sub FT_FACE_LIBRARY {
        my( $x ) = @_;
	    eval q( &FT_FACE_DRIVER(  &x )-> ($root->{library}));
    }' unless defined(&FT_FACE_LIBRARY);
    eval 'sub FT_FACE_MEMORY {
        my( $x ) = @_;
	    eval q( &FT_FACE(  &x )-> &memory);
    }' unless defined(&FT_FACE_MEMORY);
    eval 'sub FT_FACE_STREAM {
        my( $x ) = @_;
	    eval q( &FT_FACE(  &x )-> &stream);
    }' unless defined(&FT_FACE_STREAM);
    eval 'sub FT_SIZE_FACE {
        my( $x ) = @_;
	    eval q( &FT_SIZE(  &x )-> &face);
    }' unless defined(&FT_SIZE_FACE);
    eval 'sub FT_SLOT_FACE {
        my( $x ) = @_;
	    eval q( &FT_SLOT(  &x )-> &face);
    }' unless defined(&FT_SLOT_FACE);
    eval 'sub FT_FACE_SLOT {
        my( $x ) = @_;
	    eval q( &FT_FACE(  &x )-> &glyph);
    }' unless defined(&FT_FACE_SLOT);
    eval 'sub FT_FACE_SIZE {
        my( $x ) = @_;
	    eval q( &FT_FACE(  &x )-> &size);
    }' unless defined(&FT_FACE_SIZE);
    eval 'sub FT_RENDERER {
        my( $x ) = @_;
	    eval q((( &FT_Renderer)(  &x )));
    }' unless defined(&FT_RENDERER);
    eval 'sub FT_GLYPH {
        my( $x ) = @_;
	    eval q((( &FT_Glyph)(  &x )));
    }' unless defined(&FT_GLYPH);
    eval 'sub FT_BITMAP_GLYPH {
        my( $x ) = @_;
	    eval q((( &FT_BitmapGlyph)(  &x )));
    }' unless defined(&FT_BITMAP_GLYPH);
    eval 'sub FT_OUTLINE_GLYPH {
        my( $x ) = @_;
	    eval q((( &FT_OutlineGlyph)(  &x )));
    }' unless defined(&FT_OUTLINE_GLYPH);
    eval 'sub FT_DRIVER {
        my( $x ) = @_;
	    eval q((( &FT_Driver)( &x)));
    }' unless defined(&FT_DRIVER);
    eval 'sub FT_DRIVER_CLASS {
        my( $x ) = @_;
	    eval q( &FT_DRIVER(  &x )-> &clazz);
    }' unless defined(&FT_DRIVER_CLASS);
    eval 'sub FT_DEBUG_HOOK_TRUETYPE () {0;}' unless defined(&FT_DEBUG_HOOK_TRUETYPE);
    eval 'sub FT_DEBUG_HOOK_TYPE1 () {1;}' unless defined(&FT_DEBUG_HOOK_TYPE1);
    unless(defined(&FT_CONFIG_OPTION_NO_DEFAULT_SYSTEM)) {
    }
    unless(defined(&FT_NO_DEFAULT_RASTER)) {
    }
}
1;
