require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__FTSTREAM_H__)) {
    eval 'sub __FTSTREAM_H__ () {1;}' unless defined(&__FTSTREAM_H__);
    require 'ft2build.ph';
    eval 'sub FT_FRAME_OP_SHIFT () {2;}' unless defined(&FT_FRAME_OP_SHIFT);
    eval 'sub FT_FRAME_OP_SIGNED () {1;}' unless defined(&FT_FRAME_OP_SIGNED);
    eval 'sub FT_FRAME_OP_LITTLE () {2;}' unless defined(&FT_FRAME_OP_LITTLE);
    eval 'sub FT_FRAME_OP_COMMAND {
        my( $x ) = @_;
	    eval q((  &x >>  &FT_FRAME_OP_SHIFT ));
    }' unless defined(&FT_FRAME_OP_COMMAND);
    eval 'sub FT_MAKE_FRAME_OP {
        my( $command, $little, $sign ) = @_;
	    eval q(( ( $command <<  &FT_FRAME_OP_SHIFT ) | ( $little << 1) | $sign ));
    }' unless defined(&FT_MAKE_FRAME_OP);
    eval 'sub FT_FRAME_OP_END () {0;}' unless defined(&FT_FRAME_OP_END);
    eval 'sub FT_FRAME_OP_START () {1;}' unless defined(&FT_FRAME_OP_START);
    eval 'sub FT_FRAME_OP_BYTE () {2;}' unless defined(&FT_FRAME_OP_BYTE);
    eval 'sub FT_FRAME_OP_SHORT () {3;}' unless defined(&FT_FRAME_OP_SHORT);
    eval 'sub FT_FRAME_OP_LONG () {4;}' unless defined(&FT_FRAME_OP_LONG);
    eval 'sub FT_FRAME_OP_OFF3 () {5;}' unless defined(&FT_FRAME_OP_OFF3);
    eval 'sub FT_FRAME_OP_BYTES () {6;}' unless defined(&FT_FRAME_OP_BYTES);
    eval("sub ft_frame_end () { 0; }") unless defined(&ft_frame_end);
    eval("sub ft_frame_start () { FT_MAKE_FRAME_OP(FT_FRAME_OP_START; }") unless defined(&ft_frame_start);
    eval("sub ft_frame_byte () { FT_MAKE_FRAME_OP(FT_FRAME_OP_BYTE; }") unless defined(&ft_frame_byte);
    eval("sub ft_frame_schar () { FT_MAKE_FRAME_OP(FT_FRAME_OP_BYTE; }") unless defined(&ft_frame_schar);
    eval("sub ft_frame_ushort_be () { FT_MAKE_FRAME_OP(FT_FRAME_OP_SHORT; }") unless defined(&ft_frame_ushort_be);
    eval("sub ft_frame_short_be () { FT_MAKE_FRAME_OP(FT_FRAME_OP_SHORT; }") unless defined(&ft_frame_short_be);
    eval("sub ft_frame_ushort_le () { FT_MAKE_FRAME_OP(FT_FRAME_OP_SHORT; }") unless defined(&ft_frame_ushort_le);
    eval("sub ft_frame_short_le () { FT_MAKE_FRAME_OP(FT_FRAME_OP_SHORT; }") unless defined(&ft_frame_short_le);
    eval("sub ft_frame_ulong_be () { FT_MAKE_FRAME_OP(FT_FRAME_OP_LONG; }") unless defined(&ft_frame_ulong_be);
    eval("sub ft_frame_long_be () { FT_MAKE_FRAME_OP(FT_FRAME_OP_LONG; }") unless defined(&ft_frame_long_be);
    eval("sub ft_frame_ulong_le () { FT_MAKE_FRAME_OP(FT_FRAME_OP_LONG; }") unless defined(&ft_frame_ulong_le);
    eval("sub ft_frame_long_le () { FT_MAKE_FRAME_OP(FT_FRAME_OP_LONG; }") unless defined(&ft_frame_long_le);
    eval("sub ft_frame_uoff3_be () { FT_MAKE_FRAME_OP(FT_FRAME_OP_OFF3; }") unless defined(&ft_frame_uoff3_be);
    eval("sub ft_frame_off3_be () { FT_MAKE_FRAME_OP(FT_FRAME_OP_OFF3; }") unless defined(&ft_frame_off3_be);
    eval("sub ft_frame_uoff3_le () { FT_MAKE_FRAME_OP(FT_FRAME_OP_OFF3; }") unless defined(&ft_frame_uoff3_le);
    eval("sub ft_frame_off3_le () { FT_MAKE_FRAME_OP(FT_FRAME_OP_OFF3; }") unless defined(&ft_frame_off3_le);
    eval("sub ft_frame_bytes () { FT_MAKE_FRAME_OP(FT_FRAME_OP_BYTES; }") unless defined(&ft_frame_bytes);
    eval("sub ft_frame_skip () { FT_MAKE_FRAME_OP(FT_FRAME_OP_BYTES; }") unless defined(&ft_frame_skip);
    eval 'sub FT_FIELD_SIZE {
        my( $f ) = @_;
	    eval q(( &FT_Byte)$sizeof{ (( &FT_STRUCTURE)0)-> &f });
    }' unless defined(&FT_FIELD_SIZE);
    eval 'sub FT_FIELD_SIZE_DELTA {
        my( $f ) = @_;
	    eval q(( &FT_Byte)$sizeof{ (( &FT_STRUCTURE)0)-> $f[0] });
    }' unless defined(&FT_FIELD_SIZE_DELTA);
    eval 'sub FT_FIELD_OFFSET {
        my( $f ) = @_;
	    eval q(( &FT_UShort)(  &offsetof(  &FT_STRUCTURE,  &f ) ));
    }' unless defined(&FT_FIELD_OFFSET);
    eval 'sub FT_FRAME_FIELD {
        my( $frame_op, $field ) = @_;
	    eval q({ $frame_op,  &FT_FIELD_SIZE( $field ),  &FT_FIELD_OFFSET( $field ) });
    }' unless defined(&FT_FRAME_FIELD);
    eval 'sub FT_MAKE_EMPTY_FIELD {
        my( $frame_op ) = @_;
	    eval q({ $frame_op, 0, 0});
    }' unless defined(&FT_MAKE_EMPTY_FIELD);
    eval 'sub FT_FRAME_START {
        my( $size ) = @_;
	    eval q({  &ft_frame_start, 0, $size });
    }' unless defined(&FT_FRAME_START);
    eval 'sub FT_FRAME_END () {{  &ft_frame_end, 0, 0};}' unless defined(&FT_FRAME_END);
    eval 'sub FT_FRAME_LONG {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD( \'ft_frame_long_be\',  &f ));
    }' unless defined(&FT_FRAME_LONG);
    eval 'sub FT_FRAME_ULONG {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD( \'ft_frame_ulong_be\',  &f ));
    }' unless defined(&FT_FRAME_ULONG);
    eval 'sub FT_FRAME_SHORT {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_short_be,  &f ));
    }' unless defined(&FT_FRAME_SHORT);
    eval 'sub FT_FRAME_USHORT {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_ushort_be,  &f ));
    }' unless defined(&FT_FRAME_USHORT);
    eval 'sub FT_FRAME_OFF3 {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_off3_be,  &f ));
    }' unless defined(&FT_FRAME_OFF3);
    eval 'sub FT_FRAME_UOFF3 {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_uoff3_be,  &f ));
    }' unless defined(&FT_FRAME_UOFF3);
    eval 'sub FT_FRAME_BYTE {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_byte,  &f ));
    }' unless defined(&FT_FRAME_BYTE);
    eval 'sub FT_FRAME_CHAR {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_schar,  &f ));
    }' unless defined(&FT_FRAME_CHAR);
    eval 'sub FT_FRAME_LONG_LE {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD( \'ft_frame_long_le\',  &f ));
    }' unless defined(&FT_FRAME_LONG_LE);
    eval 'sub FT_FRAME_ULONG_LE {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD( \'ft_frame_ulong_le\',  &f ));
    }' unless defined(&FT_FRAME_ULONG_LE);
    eval 'sub FT_FRAME_SHORT_LE {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_short_le,  &f ));
    }' unless defined(&FT_FRAME_SHORT_LE);
    eval 'sub FT_FRAME_USHORT_LE {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_ushort_le,  &f ));
    }' unless defined(&FT_FRAME_USHORT_LE);
    eval 'sub FT_FRAME_OFF3_LE {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_off3_le,  &f ));
    }' unless defined(&FT_FRAME_OFF3_LE);
    eval 'sub FT_FRAME_UOFF3_LE {
        my( $f ) = @_;
	    eval q( &FT_FRAME_FIELD(  &ft_frame_uoff3_le,  &f ));
    }' unless defined(&FT_FRAME_UOFF3_LE);
    eval 'sub FT_FRAME_SKIP_LONG () {{ \'ft_frame_long_be\', 0, 0};}' unless defined(&FT_FRAME_SKIP_LONG);
    eval 'sub FT_FRAME_SKIP_SHORT () {{  &ft_frame_short_be, 0, 0};}' unless defined(&FT_FRAME_SKIP_SHORT);
    eval 'sub FT_FRAME_SKIP_BYTE () {{  &ft_frame_byte, 0, 0};}' unless defined(&FT_FRAME_SKIP_BYTE);
    eval 'sub FT_FRAME_BYTES {
        my( $field, $count ) = @_;
	    eval q({  &ft_frame_bytes, $count,  &FT_FIELD_OFFSET( $field ) });
    }' unless defined(&FT_FRAME_BYTES);
    eval 'sub FT_FRAME_SKIP_BYTES {
        my( $count ) = @_;
	    eval q({  &ft_frame_skip, $count, 0});
    }' unless defined(&FT_FRAME_SKIP_BYTES);
    eval 'sub FT_BYTE_ {
        my( $p, $i ) = @_;
	    eval q(( (( &const  &FT_Byte*)( &p))[( &i)] ));
    }' unless defined(&FT_BYTE_);
    eval 'sub FT_INT8_ {
        my( $p, $i ) = @_;
	    eval q(( (( &const  &FT_Char*)( &p))[( &i)] ));
    }' unless defined(&FT_INT8_);
    eval 'sub FT_INT16 {
        my( $x ) = @_;
	    eval q(( ( &FT_Int16)( &x) ));
    }' unless defined(&FT_INT16);
    eval 'sub FT_UINT16 {
        my( $x ) = @_;
	    eval q(( ( &FT_UInt16)( &x) ));
    }' unless defined(&FT_UINT16);
    eval 'sub FT_INT32 {
        my( $x ) = @_;
	    eval q(( ( &FT_Int32)( &x) ));
    }' unless defined(&FT_INT32);
    eval 'sub FT_UINT32 {
        my( $x ) = @_;
	    eval q(( ( &FT_UInt32)( &x) ));
    }' unless defined(&FT_UINT32);
    eval 'sub FT_BYTE_I16 {
        my( $p, $i, $s ) = @_;
	    eval q((  &FT_INT16(  &FT_BYTE_(  &p, $i ) ) << ( &s) ));
    }' unless defined(&FT_BYTE_I16);
    eval 'sub FT_BYTE_U16 {
        my( $p, $i, $s ) = @_;
	    eval q((  &FT_UINT16(  &FT_BYTE_(  &p, $i ) ) << ( &s) ));
    }' unless defined(&FT_BYTE_U16);
    eval 'sub FT_BYTE_I32 {
        my( $p, $i, $s ) = @_;
	    eval q((  &FT_INT32(  &FT_BYTE_(  &p, $i ) ) << ( &s) ));
    }' unless defined(&FT_BYTE_I32);
    eval 'sub FT_BYTE_U32 {
        my( $p, $i, $s ) = @_;
	    eval q((  &FT_UINT32(  &FT_BYTE_(  &p, $i ) ) << ( &s) ));
    }' unless defined(&FT_BYTE_U32);
    eval 'sub FT_INT8_I16 {
        my( $p, $i, $s ) = @_;
	    eval q((  &FT_INT16(  &FT_INT8_(  &p, $i ) ) << ( &s) ));
    }' unless defined(&FT_INT8_I16);
    eval 'sub FT_INT8_U16 {
        my( $p, $i, $s ) = @_;
	    eval q((  &FT_UINT16(  &FT_INT8_(  &p, $i ) ) << ( &s) ));
    }' unless defined(&FT_INT8_U16);
    eval 'sub FT_INT8_I32 {
        my( $p, $i, $s ) = @_;
	    eval q((  &FT_INT32(  &FT_INT8_(  &p, $i ) ) << ( &s) ));
    }' unless defined(&FT_INT8_I32);
    eval 'sub FT_INT8_U32 {
        my( $p, $i, $s ) = @_;
	    eval q((  &FT_UINT32(  &FT_INT8_(  &p, $i ) ) << ( &s) ));
    }' unless defined(&FT_INT8_U32);
    eval 'sub FT_PEEK_SHORT {
        my( $p ) = @_;
	    eval q( &FT_INT16(  &FT_INT8_I16(  &p, 0, 8) |  &FT_BYTE_I16(  &p, 1, 0) ));
    }' unless defined(&FT_PEEK_SHORT);
    eval 'sub FT_PEEK_USHORT {
        my( $p ) = @_;
	    eval q( &FT_UINT16(  &FT_BYTE_U16(  &p, 0, 8) |  &FT_BYTE_U16(  &p, 1, 0) ));
    }' unless defined(&FT_PEEK_USHORT);
    eval 'sub FT_PEEK_LONG {
        my( $p ) = @_;
	    eval q( &FT_INT32(  &FT_INT8_I32(  &p, 0, 24) |  &FT_BYTE_I32(  &p, 1, 16) |  &FT_BYTE_I32(  &p, 2, 8) |  &FT_BYTE_I32(  &p, 3, 0) ));
    }' unless defined(&FT_PEEK_LONG);
    eval 'sub FT_PEEK_ULONG {
        my( $p ) = @_;
	    eval q( &FT_UINT32(  &FT_BYTE_U32(  &p, 0, 24) |  &FT_BYTE_U32(  &p, 1, 16) |  &FT_BYTE_U32(  &p, 2, 8) |  &FT_BYTE_U32(  &p, 3, 0) ));
    }' unless defined(&FT_PEEK_ULONG);
    eval 'sub FT_PEEK_OFF3 {
        my( $p ) = @_;
	    eval q( &FT_INT32(  &FT_INT8_I32(  &p, 0, 16) |  &FT_BYTE_I32(  &p, 1, 8) |  &FT_BYTE_I32(  &p, 2, 0) ));
    }' unless defined(&FT_PEEK_OFF3);
    eval 'sub FT_PEEK_UOFF3 {
        my( $p ) = @_;
	    eval q( &FT_UINT32(  &FT_BYTE_U32(  &p, 0, 16) |  &FT_BYTE_U32(  &p, 1, 8) |  &FT_BYTE_U32(  &p, 2, 0) ));
    }' unless defined(&FT_PEEK_UOFF3);
    eval 'sub FT_PEEK_SHORT_LE {
        my( $p ) = @_;
	    eval q( &FT_INT16(  &FT_INT8_I16(  &p, 1, 8) |  &FT_BYTE_I16(  &p, 0, 0) ));
    }' unless defined(&FT_PEEK_SHORT_LE);
    eval 'sub FT_PEEK_USHORT_LE {
        my( $p ) = @_;
	    eval q( &FT_UINT16(  &FT_BYTE_U16(  &p, 1, 8) |  &FT_BYTE_U16(  &p, 0, 0) ));
    }' unless defined(&FT_PEEK_USHORT_LE);
    eval 'sub FT_PEEK_LONG_LE {
        my( $p ) = @_;
	    eval q( &FT_INT32(  &FT_INT8_I32(  &p, 3, 24) |  &FT_BYTE_I32(  &p, 2, 16) |  &FT_BYTE_I32(  &p, 1, 8) |  &FT_BYTE_I32(  &p, 0, 0) ));
    }' unless defined(&FT_PEEK_LONG_LE);
    eval 'sub FT_PEEK_ULONG_LE {
        my( $p ) = @_;
	    eval q( &FT_UINT32(  &FT_BYTE_U32(  &p, 3, 24) |  &FT_BYTE_U32(  &p, 2, 16) |  &FT_BYTE_U32(  &p, 1, 8) |  &FT_BYTE_U32(  &p, 0, 0) ));
    }' unless defined(&FT_PEEK_ULONG_LE);
    eval 'sub FT_PEEK_OFF3_LE {
        my( $p ) = @_;
	    eval q( &FT_INT32(  &FT_INT8_I32(  &p, 2, 16) |  &FT_BYTE_I32(  &p, 1, 8) |  &FT_BYTE_I32(  &p, 0, 0) ));
    }' unless defined(&FT_PEEK_OFF3_LE);
    eval 'sub FT_PEEK_UOFF3_LE {
        my( $p ) = @_;
	    eval q( &FT_UINT32(  &FT_BYTE_U32(  &p, 2, 16) |  &FT_BYTE_U32(  &p, 1, 8) |  &FT_BYTE_U32(  &p, 0, 0) ));
    }' unless defined(&FT_PEEK_UOFF3_LE);
    eval 'sub FT_NEXT_CHAR {
        my( $buffer ) = @_;
	    eval q(( *$buffer++ ));
    }' unless defined(&FT_NEXT_CHAR);
    eval 'sub FT_NEXT_BYTE {
        my( $buffer ) = @_;
	    eval q(( *$buffer++ ));
    }' unless defined(&FT_NEXT_BYTE);
    eval 'sub FT_NEXT_SHORT {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 2,  &FT_PEEK_SHORT( $buffer - 2) ) ));
    }' unless defined(&FT_NEXT_SHORT);
    eval 'sub FT_NEXT_USHORT {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 2,  &FT_PEEK_USHORT( $buffer - 2) ) ));
    }' unless defined(&FT_NEXT_USHORT);
    eval 'sub FT_NEXT_OFF3 {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 3,  &FT_PEEK_OFF3( $buffer - 3) ) ));
    }' unless defined(&FT_NEXT_OFF3);
    eval 'sub FT_NEXT_UOFF3 {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 3,  &FT_PEEK_UOFF3( $buffer - 3) ) ));
    }' unless defined(&FT_NEXT_UOFF3);
    eval 'sub FT_NEXT_LONG {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 4,  &FT_PEEK_LONG( $buffer - 4) ) ));
    }' unless defined(&FT_NEXT_LONG);
    eval 'sub FT_NEXT_ULONG {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 4,  &FT_PEEK_ULONG( $buffer - 4) ) ));
    }' unless defined(&FT_NEXT_ULONG);
    eval 'sub FT_NEXT_SHORT_LE {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 2,  &FT_PEEK_SHORT_LE( $buffer - 2) ) ));
    }' unless defined(&FT_NEXT_SHORT_LE);
    eval 'sub FT_NEXT_USHORT_LE {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 2,  &FT_PEEK_USHORT_LE( $buffer - 2) ) ));
    }' unless defined(&FT_NEXT_USHORT_LE);
    eval 'sub FT_NEXT_OFF3_LE {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 3,  &FT_PEEK_OFF3_LE( $buffer - 3) ) ));
    }' unless defined(&FT_NEXT_OFF3_LE);
    eval 'sub FT_NEXT_UOFF3_LE {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 3,  &FT_PEEK_UOFF3_LE( $buffer - 3) ) ));
    }' unless defined(&FT_NEXT_UOFF3_LE);
    eval 'sub FT_NEXT_LONG_LE {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 4,  &FT_PEEK_LONG_LE( $buffer - 4) ) ));
    }' unless defined(&FT_NEXT_LONG_LE);
    eval 'sub FT_NEXT_ULONG_LE {
        my( $buffer ) = @_;
	    eval q(( ( $buffer += 4,  &FT_PEEK_ULONG_LE( $buffer - 4) ) ));
    }' unless defined(&FT_NEXT_ULONG_LE);
    eval 'sub FT_GET_MACRO {
        my( $func, $type ) = @_;
	    eval q(( ($type)$func(  &stream ) ));
    }' unless defined(&FT_GET_MACRO);
    eval 'sub FT_GET_CHAR () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetChar,  &FT_Char ));
    }' unless defined(&FT_GET_CHAR);
    eval 'sub FT_GET_BYTE () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetChar,  &FT_Byte ));
    }' unless defined(&FT_GET_BYTE);
    eval 'sub FT_GET_SHORT () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetShort,  &FT_Short ));
    }' unless defined(&FT_GET_SHORT);
    eval 'sub FT_GET_USHORT () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetShort,  &FT_UShort ));
    }' unless defined(&FT_GET_USHORT);
    eval 'sub FT_GET_OFF3 () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetOffset,  &FT_Long ));
    }' unless defined(&FT_GET_OFF3);
    eval 'sub FT_GET_UOFF3 () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetOffset,  &FT_ULong ));
    }' unless defined(&FT_GET_UOFF3);
    eval 'sub FT_GET_LONG () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetLong,  &FT_Long ));
    }' unless defined(&FT_GET_LONG);
    eval 'sub FT_GET_ULONG () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetLong,  &FT_ULong ));
    }' unless defined(&FT_GET_ULONG);
    eval 'sub FT_GET_TAG4 () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetLong,  &FT_ULong ));
    }' unless defined(&FT_GET_TAG4);
    eval 'sub FT_GET_SHORT_LE () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetShortLE,  &FT_Short ));
    }' unless defined(&FT_GET_SHORT_LE);
    eval 'sub FT_GET_USHORT_LE () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetShortLE,  &FT_UShort ));
    }' unless defined(&FT_GET_USHORT_LE);
    eval 'sub FT_GET_LONG_LE () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetLongLE,  &FT_Long ));
    }' unless defined(&FT_GET_LONG_LE);
    eval 'sub FT_GET_ULONG_LE () {
        eval q( &FT_GET_MACRO(  &FT_Stream_GetLongLE,  &FT_ULong ));
    }' unless defined(&FT_GET_ULONG_LE);
    eval 'sub FT_READ_MACRO {
        my( $func, $type, $var ) = @_;
	    eval q(( $var = ($type)$func(  &stream,  &error ),  &error !=  &FT_Err_Ok ));
    }' unless defined(&FT_READ_MACRO);
    eval 'sub FT_READ_BYTE {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadChar,  &FT_Byte, $var ));
    }' unless defined(&FT_READ_BYTE);
    eval 'sub FT_READ_CHAR {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadChar,  &FT_Char, $var ));
    }' unless defined(&FT_READ_CHAR);
    eval 'sub FT_READ_SHORT {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadShort,  &FT_Short, $var ));
    }' unless defined(&FT_READ_SHORT);
    eval 'sub FT_READ_USHORT {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadShort,  &FT_UShort, $var ));
    }' unless defined(&FT_READ_USHORT);
    eval 'sub FT_READ_OFF3 {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadOffset,  &FT_Long, $var ));
    }' unless defined(&FT_READ_OFF3);
    eval 'sub FT_READ_UOFF3 {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadOffset,  &FT_ULong, $var ));
    }' unless defined(&FT_READ_UOFF3);
    eval 'sub FT_READ_LONG {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadLong,  &FT_Long, $var ));
    }' unless defined(&FT_READ_LONG);
    eval 'sub FT_READ_ULONG {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadLong,  &FT_ULong, $var ));
    }' unless defined(&FT_READ_ULONG);
    eval 'sub FT_READ_SHORT_LE {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadShortLE,  &FT_Short, $var ));
    }' unless defined(&FT_READ_SHORT_LE);
    eval 'sub FT_READ_USHORT_LE {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadShortLE,  &FT_UShort, $var ));
    }' unless defined(&FT_READ_USHORT_LE);
    eval 'sub FT_READ_LONG_LE {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadLongLE,  &FT_Long, $var ));
    }' unless defined(&FT_READ_LONG_LE);
    eval 'sub FT_READ_ULONG_LE {
        my( $var ) = @_;
	    eval q( &FT_READ_MACRO(  &FT_Stream_ReadLongLE,  &FT_ULong, $var ));
    }' unless defined(&FT_READ_ULONG_LE);
    unless(defined(&FT_CONFIG_OPTION_NO_DEFAULT_SYSTEM)) {
    }
    eval 'sub FT_STREAM_POS () {
        eval q( &FT_Stream_Pos(  &stream ));
    }' unless defined(&FT_STREAM_POS);
    eval 'sub FT_STREAM_SEEK {
        my( $position ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_Stream_Seek(  &stream, $position ) ));
    }' unless defined(&FT_STREAM_SEEK);
    eval 'sub FT_STREAM_SKIP {
        my( $distance ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_Stream_Skip(  &stream, $distance ) ));
    }' unless defined(&FT_STREAM_SKIP);
    eval 'sub FT_STREAM_READ {
        my( $buffer, $count ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_Stream_Read(  &stream, ( &FT_Byte*)$buffer, $count ) ));
    }' unless defined(&FT_STREAM_READ);
    eval 'sub FT_STREAM_READ_AT {
        my( $position, $buffer, $count ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_Stream_ReadAt(  &stream, $position, ( &FT_Byte*)$buffer, $count ) ));
    }' unless defined(&FT_STREAM_READ_AT);
    eval 'sub FT_STREAM_READ_FIELDS {
        my( $fields, $object ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_Stream_ReadFields(  &stream, $fields, $object ) ));
    }' unless defined(&FT_STREAM_READ_FIELDS);
    eval 'sub FT_FRAME_ENTER {
        my( $size ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_Stream_EnterFrame(  &stream, $size ) ));
    }' unless defined(&FT_FRAME_ENTER);
    eval 'sub FT_FRAME_EXIT () {
        eval q( &FT_Stream_ExitFrame(  &stream ));
    }' unless defined(&FT_FRAME_EXIT);
    eval 'sub FT_FRAME_EXTRACT {
        my( $size, $bytes ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_Stream_ExtractFrame(  &stream, $size, ( &FT_Byte**)($bytes) ) ));
    }' unless defined(&FT_FRAME_EXTRACT);
    eval 'sub FT_FRAME_RELEASE {
        my( $bytes ) = @_;
	    eval q( &FT_Stream_ReleaseFrame(  &stream, ( &FT_Byte**)($bytes) ));
    }' unless defined(&FT_FRAME_RELEASE);
}
1;
