require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__PSAUX_H__)) {
    eval 'sub __PSAUX_H__ () {1;}' unless defined(&__PSAUX_H__);
    require 'ft2build.ph';
    eval("sub T1_TOKEN_TYPE_NONE () { 0; }") unless defined(&T1_TOKEN_TYPE_NONE);
    eval("sub T1_TOKEN_TYPE_ANY () { 1; }") unless defined(&T1_TOKEN_TYPE_ANY);
    eval("sub T1_TOKEN_TYPE_STRING () { 2; }") unless defined(&T1_TOKEN_TYPE_STRING);
    eval("sub T1_TOKEN_TYPE_ARRAY () { 3; }") unless defined(&T1_TOKEN_TYPE_ARRAY);
    eval("sub T1_TOKEN_TYPE_MAX () { 4; }") unless defined(&T1_TOKEN_TYPE_MAX);
    eval("sub T1_FIELD_TYPE_NONE () { 0; }") unless defined(&T1_FIELD_TYPE_NONE);
    eval("sub T1_FIELD_TYPE_BOOL () { 1; }") unless defined(&T1_FIELD_TYPE_BOOL);
    eval("sub T1_FIELD_TYPE_INTEGER () { 2; }") unless defined(&T1_FIELD_TYPE_INTEGER);
    eval("sub T1_FIELD_TYPE_FIXED () { 3; }") unless defined(&T1_FIELD_TYPE_FIXED);
    eval("sub T1_FIELD_TYPE_STRING () { 4; }") unless defined(&T1_FIELD_TYPE_STRING);
    eval("sub T1_FIELD_TYPE_BBOX () { 5; }") unless defined(&T1_FIELD_TYPE_BBOX);
    eval("sub T1_FIELD_TYPE_INTEGER_ARRAY () { 6; }") unless defined(&T1_FIELD_TYPE_INTEGER_ARRAY);
    eval("sub T1_FIELD_TYPE_FIXED_ARRAY () { 7; }") unless defined(&T1_FIELD_TYPE_FIXED_ARRAY);
    eval("sub T1_FIELD_TYPE_CALLBACK () { 8; }") unless defined(&T1_FIELD_TYPE_CALLBACK);
    eval("sub T1_FIELD_TYPE_MAX () { 9; }") unless defined(&T1_FIELD_TYPE_MAX);
    eval("sub T1_FIELD_LOCATION_CID_INFO () { 0; }") unless defined(&T1_FIELD_LOCATION_CID_INFO);
    eval("sub T1_FIELD_LOCATION_FONT_DICT () { 1; }") unless defined(&T1_FIELD_LOCATION_FONT_DICT);
    eval("sub T1_FIELD_LOCATION_FONT_INFO () { 2; }") unless defined(&T1_FIELD_LOCATION_FONT_INFO);
    eval("sub T1_FIELD_LOCATION_PRIVATE () { 3; }") unless defined(&T1_FIELD_LOCATION_PRIVATE);
    eval("sub T1_FIELD_LOCATION_BBOX () { 4; }") unless defined(&T1_FIELD_LOCATION_BBOX);
    eval("sub T1_FIELD_LOCATION_MAX () { 5; }") unless defined(&T1_FIELD_LOCATION_MAX);
    eval 'sub T1_NEW_SIMPLE_FIELD {
        my( $_ident, $_type, $_fname ) = @_;
	    eval q({ $_ident,  &T1CODE, $_type, 0,  &FT_FIELD_OFFSET( $_fname ),  &FT_FIELD_SIZE( $_fname ), 0, 0},);
    }' unless defined(&T1_NEW_SIMPLE_FIELD);
    eval 'sub T1_NEW_CALLBACK_FIELD {
        my( $_ident, $_reader ) = @_;
	    eval q({ $_ident,  &T1CODE,  &T1_FIELD_TYPE_CALLBACK, ( &T1_Field_ParseFunc)$_reader, 0, 0, 0, 0},);
    }' unless defined(&T1_NEW_CALLBACK_FIELD);
    eval 'sub T1_NEW_TABLE_FIELD {
        my( $_ident, $_type, $_fname, $_max ) = @_;
	    eval q({ $_ident,  &T1CODE, $_type, 0,  &FT_FIELD_OFFSET( $_fname ),  &FT_FIELD_SIZE_DELTA( $_fname ), $_max,  &FT_FIELD_OFFSET(  &num_  $_fname ) },);
    }' unless defined(&T1_NEW_TABLE_FIELD);
    eval 'sub T1_NEW_TABLE_FIELD2 {
        my( $_ident, $_type, $_fname, $_max ) = @_;
	    eval q({ $_ident,  &T1CODE, $_type, 0,  &FT_FIELD_OFFSET( $_fname ),  &FT_FIELD_SIZE_DELTA( $_fname ), $_max, 0},);
    }' unless defined(&T1_NEW_TABLE_FIELD2);
    eval 'sub T1_FIELD_TYPE_BOOL {
        my( $_ident, $_fname ) = @_;
	    eval q( &T1_NEW_SIMPLE_FIELD( $_ident,  &T1_FIELD_TYPE_BOOL, $_fname ));
    }' unless defined(&T1_FIELD_TYPE_BOOL);
    eval 'sub T1_FIELD_NUM {
        my( $_ident, $_fname ) = @_;
	    eval q( &T1_NEW_SIMPLE_FIELD( $_ident,  &T1_FIELD_TYPE_INTEGER, $_fname ));
    }' unless defined(&T1_FIELD_NUM);
    eval 'sub T1_FIELD_FIXED {
        my( $_ident, $_fname ) = @_;
	    eval q( &T1_NEW_SIMPLE_FIELD( $_ident,  &T1_FIELD_TYPE_FIXED, $_fname ));
    }' unless defined(&T1_FIELD_FIXED);
    eval 'sub T1_FIELD_STRING {
        my( $_ident, $_fname ) = @_;
	    eval q( &T1_NEW_SIMPLE_FIELD( $_ident,  &T1_FIELD_TYPE_STRING, $_fname ));
    }' unless defined(&T1_FIELD_STRING);
    eval 'sub T1_FIELD_BBOX {
        my( $_ident, $_fname ) = @_;
	    eval q( &T1_NEW_SIMPLE_FIELD( $_ident,  &T1_FIELD_TYPE_BBOX, $_fname ));
    }' unless defined(&T1_FIELD_BBOX);
    eval 'sub T1_FIELD_NUM_TABLE {
        my( $_ident, $_fname, $_fmax ) = @_;
	    eval q( &T1_NEW_TABLE_FIELD( $_ident,  &T1_FIELD_TYPE_INTEGER_ARRAY, $_fname, $_fmax ));
    }' unless defined(&T1_FIELD_NUM_TABLE);
    eval 'sub T1_FIELD_FIXED_TABLE {
        my( $_ident, $_fname, $_fmax ) = @_;
	    eval q( &T1_NEW_TABLE_FIELD( $_ident,  &T1_FIELD_TYPE_FIXED_ARRAY, $_fname, $_fmax ));
    }' unless defined(&T1_FIELD_FIXED_TABLE);
    eval 'sub T1_FIELD_NUM_TABLE2 {
        my( $_ident, $_fname, $_fmax ) = @_;
	    eval q( &T1_NEW_TABLE_FIELD2( $_ident,  &T1_FIELD_TYPE_INTEGER_ARRAY, $_fname, $_fmax ));
    }' unless defined(&T1_FIELD_NUM_TABLE2);
    eval 'sub T1_FIELD_FIXED_TABLE2 {
        my( $_ident, $_fname, $_fmax ) = @_;
	    eval q( &T1_NEW_TABLE_FIELD2( $_ident,  &T1_FIELD_TYPE_FIXED_ARRAY, $_fname, $_fmax ));
    }' unless defined(&T1_FIELD_FIXED_TABLE2);
    eval 'sub T1_FIELD_CALLBACK {
        my( $_ident, $_name ) = @_;
	    eval q( &T1_NEW_CALLBACK_FIELD( $_ident, $_name ));
    }' unless defined(&T1_FIELD_CALLBACK);
    if(0) {
	eval 'sub T1_MAX_SUBRS_CALLS () {8;}' unless defined(&T1_MAX_SUBRS_CALLS);
	eval 'sub T1_MAX_CHARSTRINGS_OPERANDS () {32;}' unless defined(&T1_MAX_CHARSTRINGS_OPERANDS);
    }
}
1;
