require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XmHTMLP_h_)) {
    eval 'sub _XmHTMLP_h_ () {1;}' unless defined(&_XmHTMLP_h_);
    require 'X11/Xatom.ph';
    if(defined(&WITH_MOTIF)) {
	require 'XmHTML/toolkit.ph';
	require 'XmHTML/XmHTML.ph';
    } else {
	require 'gtk-xmhtml/toolkit.ph';
	require 'gtk-xmhtml/XmHTML.ph';
    }
    if(defined(&GNOME_LIB)) {
	unless(defined(&VERSION)) {
	    eval 'sub VERSION () {1;}' unless defined(&VERSION);
	}
    }
    if(defined(&VERSION)) {
	unless(defined(&_LIBRARY)) {
	    eval 'sub _LIBRARY () {1;}' unless defined(&_LIBRARY);
	}
    }
    if(defined(&_LIBRARY)) {
	if(defined(&WITH_MOTIF)) {
	    require 'XCC.ph';
	} else {
	}
	if(defined(&_ZCONF_H)) {
	    unless(defined(&BYTE_ALREADY_TYPEDEFED)) {
		eval 'sub BYTE_ALREADY_TYPEDEFED () {1;}' unless defined(&BYTE_ALREADY_TYPEDEFED);
	    }
	}
    } else {
    }
    unless(defined(&BYTE_ALREADY_TYPEDEFED)) {
	eval 'sub BYTE_ALREADY_TYPEDEFED () {1;}' unless defined(&BYTE_ALREADY_TYPEDEFED);
    }
    eval 'sub LINE_SOLID () {(1<<1);}' unless defined(&LINE_SOLID);
    eval 'sub LINE_DASHED () {(1<<2);}' unless defined(&LINE_DASHED);
    eval 'sub LINE_SINGLE () {(1<<3);}' unless defined(&LINE_SINGLE);
    eval 'sub LINE_DOUBLE () {(1<<4);}' unless defined(&LINE_DOUBLE);
    eval 'sub LINE_STRIKE () {(1<<5);}' unless defined(&LINE_STRIKE);
    eval 'sub LINE_UNDER () {(1<<6);}' unless defined(&LINE_UNDER);
    eval 'sub NO_LINE () {0;}' unless defined(&NO_LINE);
    eval 'sub TEXT_SPACE_NONE () {(1<<0);}' unless defined(&TEXT_SPACE_NONE);
    eval 'sub TEXT_SPACE_LEAD () {(1<<1);}' unless defined(&TEXT_SPACE_LEAD);
    eval 'sub TEXT_SPACE_TRAIL () {(1<<2);}' unless defined(&TEXT_SPACE_TRAIL);
    eval 'sub TEXT_ANCHOR () {(1<<3);}' unless defined(&TEXT_ANCHOR);
    eval 'sub TEXT_ANCHOR_INTERN () {(1<<4);}' unless defined(&TEXT_ANCHOR_INTERN);
    eval 'sub TEXT_IMAGE () {(1<<5);}' unless defined(&TEXT_IMAGE);
    eval 'sub TEXT_FORM () {(1<<6);}' unless defined(&TEXT_FORM);
    eval 'sub TEXT_BREAK () {(1<<7);}' unless defined(&TEXT_BREAK);
    eval 'sub TEXT_SPACE_LEAD_ZEROWIDTH () {(1<<8);}' unless defined(&TEXT_SPACE_LEAD_ZEROWIDTH);
    eval 'sub TEXT_SPACE_TRAIL_ZEROWIDTH () {(1<<9);}' unless defined(&TEXT_SPACE_TRAIL_ZEROWIDTH);
    eval("sub XmMARKER_NONE () { 0; }") unless defined(&XmMARKER_NONE);
    eval("sub XmMARKER_ARABIC () { 10; }") unless defined(&XmMARKER_ARABIC);
    eval("sub XmMARKER_ALPHA_LOWER () { 11; }") unless defined(&XmMARKER_ALPHA_LOWER);
    eval("sub XmMARKER_ALPHA_UPPER () { 12; }") unless defined(&XmMARKER_ALPHA_UPPER);
    eval("sub XmMARKER_ROMAN_LOWER () { 13; }") unless defined(&XmMARKER_ROMAN_LOWER);
    eval("sub XmMARKER_ROMAN_UPPER () { 14; }") unless defined(&XmMARKER_ROMAN_UPPER);
    eval("sub XmMARKER_DISC () { 15; }") unless defined(&XmMARKER_DISC);
    eval("sub XmMARKER_SQUARE () { 16; }") unless defined(&XmMARKER_SQUARE);
    eval("sub XmMARKER_CIRCLE () { 17; }") unless defined(&XmMARKER_CIRCLE);
    eval("sub XmHALIGN_NONE () { 0; }") unless defined(&XmHALIGN_NONE);
    eval("sub XmHALIGN_LEFT () { 1; }") unless defined(&XmHALIGN_LEFT);
    eval("sub XmHALIGN_CENTER () { 2; }") unless defined(&XmHALIGN_CENTER);
    eval("sub XmHALIGN_RIGHT () { 3; }") unless defined(&XmHALIGN_RIGHT);
    eval("sub XmHALIGN_JUSTIFY () { 4; }") unless defined(&XmHALIGN_JUSTIFY);
    eval("sub XmVALIGN_NONE () { 8; }") unless defined(&XmVALIGN_NONE);
    eval("sub XmVALIGN_TOP () { 9; }") unless defined(&XmVALIGN_TOP);
    eval("sub XmVALIGN_MIDDLE () { 10; }") unless defined(&XmVALIGN_MIDDLE);
    eval("sub XmVALIGN_BOTTOM () { 11; }") unless defined(&XmVALIGN_BOTTOM);
    eval("sub XmVALIGN_BASELINE () { 12; }") unless defined(&XmVALIGN_BASELINE);
    eval("sub OBJ_NONE () { 0; }") unless defined(&OBJ_NONE);
    eval("sub OBJ_TEXT () { 1; }") unless defined(&OBJ_TEXT);
    eval("sub OBJ_PRE_TEXT () { 2; }") unless defined(&OBJ_PRE_TEXT);
    eval("sub OBJ_BULLET () { 3; }") unless defined(&OBJ_BULLET);
    eval("sub OBJ_HRULE () { 4; }") unless defined(&OBJ_HRULE);
    eval("sub OBJ_TABLE () { 5; }") unless defined(&OBJ_TABLE);
    eval("sub OBJ_TABLE_FRAME () { 6; }") unless defined(&OBJ_TABLE_FRAME);
    eval("sub OBJ_IMG () { 7; }") unless defined(&OBJ_IMG);
    eval("sub OBJ_FORM () { 8; }") unless defined(&OBJ_FORM);
    eval("sub OBJ_APPLET () { 9; }") unless defined(&OBJ_APPLET);
    eval("sub OBJ_BLOCK () { 10; }") unless defined(&OBJ_BLOCK);
    eval 'sub CLEAR_NONE () {-1;}' unless defined(&CLEAR_NONE);
    eval 'sub CLEAR_SOFT () {0;}' unless defined(&CLEAR_SOFT);
    eval 'sub CLEAR_HARD () {1;}' unless defined(&CLEAR_HARD);
    eval 'sub CLEAR_ALL () {2;}' unless defined(&CLEAR_ALL);
    eval("sub XmMAP_NONE () { 1; }") unless defined(&XmMAP_NONE);
    eval("sub XmMAP_SERVER () { 2; }") unless defined(&XmMAP_SERVER);
    eval("sub XmMAP_CLIENT () { 3; }") unless defined(&XmMAP_CLIENT);
    eval 'sub IMG_ISBACKGROUND () {(1<<1);}' unless defined(&IMG_ISBACKGROUND);
    eval 'sub IMG_ISINTERNAL () {(1<<2);}' unless defined(&IMG_ISINTERNAL);
    eval 'sub IMG_ISCOPY () {(1<<3);}' unless defined(&IMG_ISCOPY);
    eval 'sub IMG_ISANIM () {(1<<4);}' unless defined(&IMG_ISANIM);
    eval 'sub IMG_FRAMEREFRESH () {(1<<5);}' unless defined(&IMG_FRAMEREFRESH);
    eval 'sub IMG_HASDIMENSIONS () {(1<<6);}' unless defined(&IMG_HASDIMENSIONS);
    eval 'sub IMG_HASSTATE () {(1<<7);}' unless defined(&IMG_HASSTATE);
    eval 'sub IMG_INFOFREED () {(1<<8);}' unless defined(&IMG_INFOFREED);
    eval 'sub IMG_DELAYED_CREATION () {(1<<9);}' unless defined(&IMG_DELAYED_CREATION);
    eval 'sub IMG_ORPHANED () {(1<<10);}' unless defined(&IMG_ORPHANED);
    eval 'sub IMG_PROGRESSIVE () {(1<<11);}' unless defined(&IMG_PROGRESSIVE);
    eval 'sub COLOR_CLASS_GRAYSCALE () {0;}' unless defined(&COLOR_CLASS_GRAYSCALE);
    eval 'sub COLOR_CLASS_INDEXED () {1;}' unless defined(&COLOR_CLASS_INDEXED);
    eval 'sub COLOR_CLASS_RGB () {2;}' unless defined(&COLOR_CLASS_RGB);
    eval("sub FRAME_SCROLL_NONE () { 1; }") unless defined(&FRAME_SCROLL_NONE);
    eval("sub FRAME_SCROLL_AUTO () { 2; }") unless defined(&FRAME_SCROLL_AUTO);
    eval("sub FRAME_SCROLL_YES () { 3; }") unless defined(&FRAME_SCROLL_YES);
    eval("sub FRAME_SIZE_FIXED () { 1; }") unless defined(&FRAME_SIZE_FIXED);
    eval("sub FRAME_SIZE_RELATIVE () { 2; }") unless defined(&FRAME_SIZE_RELATIVE);
    eval("sub FRAME_SIZE_OPTIONAL () { 3; }") unless defined(&FRAME_SIZE_OPTIONAL);
    eval 'sub ANCHOR_UNSELECTED () {( &Byte)0;}' unless defined(&ANCHOR_UNSELECTED);
    eval 'sub ANCHOR_INSELECT () {( &Byte)1;}' unless defined(&ANCHOR_INSELECT);
    eval 'sub ANCHOR_SELECTED () {( &Byte)2;}' unless defined(&ANCHOR_SELECTED);
    eval 'sub FONT_BOLD () {(1<<1);}' unless defined(&FONT_BOLD);
    eval 'sub FONT_MEDIUM () {(1<<2);}' unless defined(&FONT_MEDIUM);
    eval 'sub FONT_ITALIC () {(1<<3);}' unless defined(&FONT_ITALIC);
    eval 'sub FONT_REGULAR () {(1<<4);}' unless defined(&FONT_REGULAR);
    eval 'sub FONT_FIXED () {(1<<5);}' unless defined(&FONT_FIXED);
    eval 'sub FONT_SCALABLE () {(1<<6);}' unless defined(&FONT_SCALABLE);
    eval("sub TFRAME_VOID () { 0; }") unless defined(&TFRAME_VOID);
    eval("sub TFRAME_ABOVE () { 1; }") unless defined(&TFRAME_ABOVE);
    eval("sub TFRAME_BELOW () { 2; }") unless defined(&TFRAME_BELOW);
    eval("sub TFRAME_LEFT () { 3; }") unless defined(&TFRAME_LEFT);
    eval("sub TFRAME_RIGHT () { 4; }") unless defined(&TFRAME_RIGHT);
    eval("sub TFRAME_HSIDES () { 5; }") unless defined(&TFRAME_HSIDES);
    eval("sub TFRAME_VSIDES () { 6; }") unless defined(&TFRAME_VSIDES);
    eval("sub TFRAME_BOX () { 7; }") unless defined(&TFRAME_BOX);
    eval("sub TFRAME_BORDER () { 8; }") unless defined(&TFRAME_BORDER);
    eval("sub TRULE_NONE () { 0; }") unless defined(&TRULE_NONE);
    eval("sub TRULE_GROUPS () { 1; }") unless defined(&TRULE_GROUPS);
    eval("sub TRULE_ROWS () { 2; }") unless defined(&TRULE_ROWS);
    eval("sub TRULE_COLS () { 3; }") unless defined(&TRULE_COLS);
    eval("sub TRULE_ALL () { 4; }") unless defined(&TRULE_ALL);
    if(defined(&WITH_MOTIF)) {
	eval 'sub XmHTMLIndex () {( &XmManagerIndex+1);}' unless defined(&XmHTMLIndex);
    }
    if(defined(&_LIBRARY)) {
	require 'XmHTMLI.ph';
    }
    unless(defined(&WITH_MOTIF)) {
	require 'gtk-xmhtml-p.ph';
    }
}
1;
