require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GNOME_I18N_H__)) {
    eval 'sub __GNOME_I18N_H__ () {1;}' unless defined(&__GNOME_I18N_H__);
    if(defined(&__GNOME_I18NP_H__)) {
	warn("\"You\ should\ use\ either\ gnome\-i18n\.h\ OR\ gnome\-i18nP\.h\"");
    }
    if(defined(&ENABLE_NLS)) {
	require 'libintl.ph';
	if(defined(&GNOME_EXPLICIT_TRANSLATION_DOMAIN)) {
	    undef(&_) if defined(&_);
	    eval 'sub _ {
	        my($String) = @_;
    		eval q( &dgettext ( &GNOME_EXPLICIT_TRANSLATION_DOMAIN, $String));
	    }' unless defined(&_);
	} else {
	    eval 'sub _ {
	        my($String) = @_;
    		eval q( &gettext ($String));
	    }' unless defined(&_);
	}
	if(defined(&gettext_noop)) {
	    eval 'sub N_ {
	        my($String) = @_;
    		eval q( &gettext_noop ($String));
	    }' unless defined(&N_);
	} else {
	    eval 'sub N_ {
	        my($String) = @_;
    		eval q(($String));
	    }' unless defined(&N_);
	}
    } else {
	eval 'sub textdomain {
	    my($String) = @_;
    	    eval q(($String));
	}' unless defined(&textdomain);
	eval 'sub gettext {
	    my($String) = @_;
    	    eval q(($String));
	}' unless defined(&gettext);
	eval 'sub dgettext {
	    my($Domain,$Message) = @_;
    	    eval q(($Message));
	}' unless defined(&dgettext);
	eval 'sub dcgettext {
	    my($Domain,$Message,$Type) = @_;
    	    eval q(($Message));
	}' unless defined(&dcgettext);
	eval 'sub bindtextdomain {
	    my($Domain,$Directory) = @_;
    	    eval q(($Domain));
	}' unless defined(&bindtextdomain);
	eval 'sub _ {
	    my($String) = @_;
    	    eval q(($String));
	}' unless defined(&_);
	eval 'sub N_ {
	    my($String) = @_;
    	    eval q(($String));
	}' unless defined(&N_);
    }
}
1;
