require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ATT_GRAPH_H)) {
    eval 'sub ATT_GRAPH_H () {1;}' unless defined(&ATT_GRAPH_H);
    require 'cdt.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {(0);}' unless defined(&FALSE);
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {(! &FALSE);}' unless defined(&TRUE);
    }
    unless(defined(&NOT)) {
	eval 'sub NOT {
	    my($x) = @_;
    	    eval q((!($x)));
	}' unless defined(&NOT);
    }
    unless(defined(&NIL)) {
	eval 'sub NIL {
	    my($type) = @_;
    	    eval q((($type)0));
	}' unless defined(&NIL);
    }
    eval 'sub NILgraph () { &NIL( &Agraph_t*);}' unless defined(&NILgraph);
    eval 'sub NILnode () { &NIL( &Agnode_t*);}' unless defined(&NILnode);
    eval 'sub NILedge () { &NIL( &Agedge_t*);}' unless defined(&NILedge);
    eval 'sub NILsym () { &NIL( &Agsym_t*);}' unless defined(&NILsym);
    eval 'sub AGRAPH () {0;}' unless defined(&AGRAPH);
    eval 'sub AGNODE () {1;}' unless defined(&AGNODE);
    eval 'sub AGOUTEDGE () {2;}' unless defined(&AGOUTEDGE);
    eval 'sub AGINEDGE () {3;}' unless defined(&AGINEDGE);
    eval 'sub AGEDGE () { &AGOUTEDGE;}' unless defined(&AGEDGE);
    eval 'sub AGTAG {
        my($obj) = @_;
	    eval q(((( &Agobj_t*)($obj))-> &tag));
    }' unless defined(&AGTAG);
    eval 'sub AGTYPE {
        my($obj) = @_;
	    eval q(( &AGTAG($obj). &objtype));
    }' unless defined(&AGTYPE);
    eval 'sub AGID {
        my($obj) = @_;
	    eval q(( &AGTAG($obj). &id));
    }' unless defined(&AGID);
    eval 'sub AGSEQ {
        my($obj) = @_;
	    eval q(( &AGTAG($obj). &seq));
    }' unless defined(&AGSEQ);
    eval 'sub AGATTRWF {
        my($obj) = @_;
	    eval q(( &AGTAG($obj). &attrwf));
    }' unless defined(&AGATTRWF);
    eval 'sub AGDATA {
        my($obj) = @_;
	    eval q(((( &Agobj_t*)($obj))-> &data));
    }' unless defined(&AGDATA);
    if((defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
	if(defined( &_BLD_agraph)  && defined( &__EXPORT__)) {
	    eval 'sub extern () { &__EXPORT__;}' unless defined(&extern);
	}
	if(!defined( &_BLD_agraph)  && defined( &__IMPORT__)) {
	    eval 'sub extern () { &__IMPORT__;}' unless defined(&extern);
	}
    }
    eval 'sub agnew {
        my($g,$t) = @_;
	    eval q((($t*) &agalloc($g,$sizeof{$t})));
    }' unless defined(&agnew);
    eval 'sub agnnew {
        my($g,$n,$t) = @_;
	    eval q((($t*) &agalloc($g,($n)*$sizeof{$t})));
    }' unless defined(&agnnew);
    eval 'sub AGERROR_SYNTAX () {1;}' unless defined(&AGERROR_SYNTAX);
    eval 'sub AGERROR_MEMORY () {2;}' unless defined(&AGERROR_MEMORY);
    eval 'sub AGERROR_UNIMPL () {3;}' unless defined(&AGERROR_UNIMPL);
    eval 'sub AGERROR_MTFLOCK () {4;}' unless defined(&AGERROR_MTFLOCK);
    eval 'sub AGERROR_CMPND () {5;}' unless defined(&AGERROR_CMPND);
    eval 'sub AGERROR_BADOBJ () {6;}' unless defined(&AGERROR_BADOBJ);
    eval 'sub AGERROR_IDOVFL () {7;}' unless defined(&AGERROR_IDOVFL);
    eval 'sub AGERROR_FLAT () {8;}' unless defined(&AGERROR_FLAT);
    eval 'sub AGERROR_WRONGGRAPH () {9;}' unless defined(&AGERROR_WRONGGRAPH);
    eval 'sub AGFIRSTNODE {
        my($g) = @_;
	    eval q((( &Agnode_t*) &dtfirst(($g)-> &n_seq)));
    }' unless defined(&AGFIRSTNODE);
    eval 'sub AGPREVNODE {
        my($n) = @_;
	    eval q((( &Agnode_t*)(($n)-> ($base->{seq_link}->{hl}->{_left}))));
    }' unless defined(&AGPREVNODE);
    eval 'sub AGNEXTNODE {
        my($n) = @_;
	    eval q((( &Agnode_t*)(($n)-> ($base->{seq_link}->{right}))));
    }' unless defined(&AGNEXTNODE);
    eval 'sub AGFSTOUT {
        my($n) = @_;
	    eval q((( &Agedge_t*)(($n)-> &out)));
    }' unless defined(&AGFSTOUT);
    eval 'sub AGFSTIN {
        my($n) = @_;
	    eval q((( &Agedge_t*)(($n)-> &in)));
    }' unless defined(&AGFSTIN);
    eval 'sub AGPREV {
        my($e) = @_;
	    eval q((( &Agedge_t*)(($e)-> ($base->{s$eq_link}->{hl}->{_left}))));
    }' unless defined(&AGPREV);
    eval 'sub AGNXTE {
        my($e) = @_;
	    eval q((( &Agedge_t*)(($e)-> ($base->{s$eq_link}->{right}))));
    }' unless defined(&AGNXTE);
    eval 'sub AGIN2OUT {
        my($e) = @_;
	    eval q((($e)-1));
    }' unless defined(&AGIN2OUT);
    eval 'sub AGOUT2IN {
        my($e) = @_;
	    eval q((($e)+1));
    }' unless defined(&AGOUT2IN);
    eval 'sub AGOPP {
        my($e) = @_;
	    eval q((( &AGTYPE($e)== &AGINEDGE)? &AGIN2OUT($e): &AGOUT2IN($e)));
    }' unless defined(&AGOPP);
    eval 'sub AGMKOUT {
        my($e) = @_;
	    eval q(( &AGTYPE($e) ==  &AGOUTEDGE? ($e):  &AGIN2OUT($e)));
    }' unless defined(&AGMKOUT);
    eval 'sub AGMKIN {
        my($e) = @_;
	    eval q(( &AGTYPE($e) ==  &AGINEDGE? ($e):  &AGOUT2IN($e)));
    }' unless defined(&AGMKIN);
    eval 'sub AGTAIL {
        my($e) = @_;
	    eval q(( &AGMKIN($e)-> &node));
    }' unless defined(&AGTAIL);
    eval 'sub AGHEAD {
        my($e) = @_;
	    eval q(( &AGMKOUT($e)-> &node));
    }' unless defined(&AGHEAD);
    eval 'sub agtail {
        my($e) = @_;
	    eval q( &AGTAIL($e));
    }' unless defined(&agtail);
    eval 'sub aghead {
        my($e) = @_;
	    eval q( &AGHEAD($e));
    }' unless defined(&aghead);
    eval 'sub agopp {
        my($e) = @_;
	    eval q( &AGOPP($e));
    }' unless defined(&agopp);
    if((defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
	if(!defined( &_BLD_agraph)  && defined( &__IMPORT__)) {
	    eval 'sub extern () { &__IMPORT__;}' unless defined(&extern);
	}
    }
    undef(&extern) if defined(&extern);
    if((defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
