require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&GV_ARITH_H)) {
    eval 'sub GV_ARITH_H () {1;}' unless defined(&GV_ARITH_H);
    unless(defined(&_GNU_SOURCE)) {
	eval 'sub _GNU_SOURCE () {1;}' unless defined(&_GNU_SOURCE);
    }
    if(defined(&HAVE_LIMITS_H)) {
	require 'limits.ph';
    } else {
	if(defined(&HAVE_VALUES_H)) {
	    require 'values.ph';
	}
    }
    require 'math.ph';
    require 'logic.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&MIN)) {
	undef(&MIN) if defined(&MIN);
    }
    eval 'sub MIN {
        my($a,$b) = @_;
	    eval q((($a)<($b)?($a):($b)));
    }' unless defined(&MIN);
    if(defined(&MAX)) {
	undef(&MAX) if defined(&MAX);
    }
    eval 'sub MAX {
        my($a,$b) = @_;
	    eval q((($a)>($b)?($a):($b)));
    }' unless defined(&MAX);
    if(defined(&ABS)) {
	undef(&ABS) if defined(&ABS);
    }
    eval 'sub ABS {
        my($a) = @_;
	    eval q((($a) >= 0? ($a) : -($a)));
    }' unless defined(&ABS);
    unless(defined(&INT_MAX)) {
	eval 'sub INT_MAX () {((~0>> 1));}' unless defined(&INT_MAX);
    }
    unless(defined(&INT_MIN)) {
	eval 'sub INT_MIN () {(- &INT_MAX - 1);}' unless defined(&INT_MIN);
    }
    unless(defined(&MAXSHORT)) {
	eval 'sub MAXSHORT () {(0x7fff);}' unless defined(&MAXSHORT);
    }
    unless(defined(&MAXDOUBLE)) {
	eval 'sub MAXDOUBLE () {1.7976931348623157e+308;}' unless defined(&MAXDOUBLE);
    }
    unless(defined(&MAXFLOAT)) {
	eval 'sub MAXFLOAT () {(3.40282347e+38);}' unless defined(&MAXFLOAT);
    }
    if(defined(&BETWEEN)) {
	undef(&BETWEEN) if defined(&BETWEEN);
    }
    eval 'sub BETWEEN {
        my($a,$b,$c) = @_;
	    eval q(((($a) <= ($b))  && (($b) <= ($c))));
    }' unless defined(&BETWEEN);
    unless(defined(&M_PI)) {
	eval 'sub M_PI () {3.14159265358979323846;}' unless defined(&M_PI);
    }
    unless(defined(&PI)) {
	eval 'sub PI () { &M_PI;}' unless defined(&PI);
    }
    eval 'sub ROUND {
        my($f) = @_;
	    eval q((($f>=0)?($f + .5):($f - .5)));
    }' unless defined(&ROUND);
    eval 'sub RADIANS {
        my($deg) = @_;
	    eval q((($deg)/180.0*  &PI));
    }' unless defined(&RADIANS);
    eval 'sub DEGREES {
        my($rad) = @_;
	    eval q((($rad)/ &M_PI * 180.0));
    }' unless defined(&DEGREES);
    eval 'sub SQR {
        my($a) = @_;
	    eval q((($a) * ($a)));
    }' unless defined(&SQR);
    if(defined(&HAVE_SINCOS)) {
    } else {
	eval 'sub sincos {
	    my($x,$s,$c) = @_;
    	    eval q(*$s =  &sin($x); *$c =  &cos($x));
	}' unless defined(&sincos);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
