require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_AST_COMMON_H)) {
    eval 'sub _AST_COMMON_H () {1;}' unless defined(&_AST_COMMON_H);
    if(defined(&HAVE_CONFIG_H)) {
	require 'config.ph';
    }
    if(defined(&HAVE_SYS_TYPES_H)) {
	eval 'sub _sys_types () {1;}' unless defined(&_sys_types);
    }
    if(defined(&HAVE_LIMITS_H)) {
	eval 'sub _hdr_limits () {1;}' unless defined(&_hdr_limits);
    }
    if(defined(&HAVE_FLOAT_H)) {
	eval 'sub _hdr_float () {1;}' unless defined(&_hdr_float);
    }
    if(defined(&HAVE_VALUES_H)) {
	eval 'sub _hdr_values () {1;}' unless defined(&_hdr_values);
    }
    if(defined(&HAVE_SYS_TYPES_H)) {
	eval 'sub _sys_types () {1;}' unless defined(&_sys_types);
    }
    if(defined(&HAVE_PTHREAD_H)) {
	eval 'sub _hdr_pthread () {1;}' unless defined(&_hdr_pthread);
    }
    if(defined(&HAVE_STDDEF_H)) {
	eval 'sub hdr_stddef () {1;}' unless defined(&hdr_stddef);
    }
    if(defined(&HAVE_TIME_H)) {
	eval 'sub _hdr_time () {1;}' unless defined(&_hdr_time);
    }
    if(defined(&HAVE_SYS_TIME_H)) {
	eval 'sub _sys_time () {1;}' unless defined(&_sys_time);
    }
    if(defined(&HAVE_SYS_TIMES_H)) {
	eval 'sub _sys_times () {1;}' unless defined(&_sys_times);
    }
    if(defined(&HAVE_STDLIB_H)) {
	eval 'sub _hdr_stdlib () {1;}' unless defined(&_hdr_stdlib);
    }
    if(defined(&HAVE_SYS_SOCKET_H)) {
	eval 'sub _sys_socket () {1;}' unless defined(&_sys_socket);
    }
    if(defined(&HAVE_SYS_STAT_H)) {
	eval 'sub _sys_stat () {1;}' unless defined(&_sys_stat);
    }
    if(defined(&HAVE_STDARG_H)) {
	eval 'sub _hdr_stdarg () {1;}' unless defined(&_hdr_stdarg);
    }
    if(defined(&HAVE_VARARGS_H)) {
	eval 'sub _hdr_varargs () {1;}' unless defined(&_hdr_varargs);
    }
    eval 'sub _typ_size_t () {1;}' unless defined(&_typ_size_t);
    eval 'sub _typ_ssize_t () {1;}' unless defined(&_typ_ssize_t);
    eval 'sub _typ_long_double () {1;}' unless defined(&_typ_long_double);
    eval 'sub _proto_stdc () {1;}' unless defined(&_proto_stdc);
    if(!defined( &__STD_C)  && (defined(&__STDC__) ? &__STDC__ : 0)) {
	eval 'sub __STD_C () {1;}' unless defined(&__STD_C);
    }
    if(!defined( &__STD_C)  && ((defined(&__cplusplus) ? &__cplusplus : 0) || (defined(&c_plusplus) ? &c_plusplus : 0))) {
	eval 'sub __STD_C () {1;}' unless defined(&__STD_C);
    }
    if(!defined( &__STD_C)  && (defined(&_proto_stdc) ? &_proto_stdc : 0)) {
	eval 'sub __STD_C () {1;}' unless defined(&__STD_C);
    }
    if(!defined( &__STD_C)) {
	eval 'sub __STD_C () {0;}' unless defined(&__STD_C);
    }
    unless(defined(&_BEGIN_EXTERNS_)) {
	if((defined(&__cplusplus) ? &__cplusplus : 0) || (defined(&c_plusplus) ? &c_plusplus : 0)) {
	    eval 'sub _BEGIN_EXTERNS_ () { &extern "C" {;}' unless defined(&_BEGIN_EXTERNS_);
	    eval 'sub _END_EXTERNS_ () {};}' unless defined(&_END_EXTERNS_);
	} else {
	    eval 'sub _BEGIN_EXTERNS_ () {1;}' unless defined(&_BEGIN_EXTERNS_);
	    eval 'sub _END_EXTERNS_ () {1;}' unless defined(&_END_EXTERNS_);
	}
    }
    unless(defined(&_ARG_)) {
	if((defined(&__STD_C) ? &__STD_C : 0)) {
	    eval 'sub _ARG_ {
	        my($x) = @_;
    		eval q($x);
	    }' unless defined(&_ARG_);
	} else {
	    eval 'sub _ARG_ {
	        my($x) = @_;
    		eval q(());
	    }' unless defined(&_ARG_);
	}
    }
    if(!defined( &__INLINE__)  && defined( &__cplusplus)) {
	eval 'sub __INLINE__ () { &inline;}' unless defined(&__INLINE__);
    }
    if(!defined( &__INLINE__)  && defined( &_WIN32)  && !defined( &__GNUC__)) {
	eval 'sub __INLINE__ () { &__inline;}' unless defined(&__INLINE__);
    }
    unless(defined(&Void_t)) {
	if((defined(&__STD_C) ? &__STD_C : 0)) {
	    eval 'sub Void_t () { &void;}' unless defined(&Void_t);
	} else {
	    eval 'sub Void_t () {\'char\';}' unless defined(&Void_t);
	}
    }
    undef(&extern) if defined(&extern);
    if((defined(&_dll_import) ? &_dll_import : 0)  && !defined( &__EXPORT__)  && (defined(&_DLL_BLD) ? &_DLL_BLD : 0)) {
	eval 'sub __EXPORT__ () { &__declspec( &dllexport);}' unless defined(&__EXPORT__);
    }
    if((defined(&_dll_import) ? &_dll_import : 0)  && !defined( &__IMPORT__)) {
	eval 'sub __IMPORT__ () { &__declspec( &dllimport);}' unless defined(&__IMPORT__);
    }
    if(!defined( &_astimport)) {
	if(defined( &__IMPORT__)  && (defined(&_DLL_BLD) ? &_DLL_BLD : 0)) {
	    eval 'sub _astimport () { &__IMPORT__;}' unless defined(&_astimport);
	} else {
	    eval 'sub _astimport () { &extern;}' unless defined(&_astimport);
	}
    }
    if(!(defined(&_DLL_BLD) ? &_DLL_BLD : 0)  && (defined(&_dll_import) ? &_dll_import : 0)) {
	eval 'sub __EXTERN__ {
	    my($T,$obj) = @_;
    	    eval q( &extern $T $obj; $T*  &_imp__  $obj = $obj);
	}' unless defined(&__EXTERN__);
	eval 'sub __DEFINE__ {
	    my($T,$obj,$val) = @_;
    	    eval q($T $obj = $val; $T*  &_imp__  $obj = $obj);
	}' unless defined(&__DEFINE__);
    } else {
	eval 'sub __EXTERN__ {
	    my($T,$obj) = @_;
    	    eval q( &extern $T $obj);
	}' unless defined(&__EXTERN__);
	eval 'sub __DEFINE__ {
	    my($T,$obj,$val) = @_;
    	    eval q($T $obj = $val);
	}' unless defined(&__DEFINE__);
    }
    unless(defined(&_AST_STD_H)) {
	if((defined(&_hdr_stddef) ? &_hdr_stddef : 0)) {
	    require 'stddef.ph';
	}
	if((defined(&_hdr_stdarg) ? &_hdr_stdarg : 0)) {
	    require 'stdarg.ph';
	}
	if((defined(&_hdr_varargs) ? &_hdr_varargs : 0)) {
	    require 'varargs.ph';
	}
	if((defined(&_sys_types) ? &_sys_types : 0)) {
	    require 'sys/types.ph';
	}
    }
    if(!(defined(&_typ_size_t) ? &_typ_size_t : 0)) {
	eval 'sub _typ_size_t () {1;}' unless defined(&_typ_size_t);
    }
    if(!(defined(&_typ_ssize_t) ? &_typ_ssize_t : 0)) {
	eval 'sub _typ_ssize_t () {1;}' unless defined(&_typ_ssize_t);
    }
    eval 'sub _ast_int1_t () {\'char\';}' unless defined(&_ast_int1_t);
    eval 'sub _ast_int2_t () {\'short\';}' unless defined(&_ast_int2_t);
    eval 'sub _ast_int4_t () {\'int\';}' unless defined(&_ast_int4_t);
    eval 'sub _ast_int8_t () {\'long long\';}' unless defined(&_ast_int8_t);
    eval 'sub _ast_intmax_t () { &_ast_int8_t;}' unless defined(&_ast_intmax_t);
    eval 'sub _ast_intswap () {7;}' unless defined(&_ast_intswap);
    eval 'sub _ast_flt4_t () {\'float\';}' unless defined(&_ast_flt4_t);
    eval 'sub _ast_flt8_t () {\'double\';}' unless defined(&_ast_flt8_t);
    eval 'sub _ast_flt12_t () {\'long double\';}' unless defined(&_ast_flt12_t);
    eval 'sub _ast_fltmax_t () { &_ast_flt12_t;}' unless defined(&_ast_fltmax_t);
    unless(defined(&va_listref)) {
	eval 'sub va_listref {
	    my($p) = @_;
    	    eval q(($p));
	}' unless defined(&va_listref);
	eval 'sub va_listval {
	    my($p) = @_;
    	    eval q(($p));
	}' unless defined(&va_listval);
	eval 'sub va_listarg () { &va_list;}' unless defined(&va_listarg);
	unless(defined(&va_copy)) {
	    eval 'sub va_copy {
	        my($to,$fr) = @_;
    		eval q((($to)=($fr)));
	    }' unless defined(&va_copy);
	}
	undef(&_ast_va_list) if defined(&_ast_va_list);
	if(defined(&va_start)) {
	    eval 'sub _ast_va_list () { &va_list;}' unless defined(&_ast_va_list);
	} else {
	    eval 'sub _ast_va_list () { &void*;}' unless defined(&_ast_va_list);
	}
    }
    if(defined(&HAVE_LIMITS_H)) {
	require 'limits.ph';
    } else {
	if(defined(&HAVE_VALUES_H)) {
	    require 'values.ph';
	}
    }
    unless(defined(&MAXINT)) {
	eval 'sub MAXINT () { &INT_MAX;}' unless defined(&MAXINT);
    }
    unless(defined(&R_OK)) {
	eval 'sub R_OK () {4;}' unless defined(&R_OK);
    }
}
1;
