require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__cplusplus)) {
}
unless(defined(&_DTHDR_H)) {
    eval 'sub _DTHDR_H () {1;}' unless defined(&_DTHDR_H);
    unless(defined(&_BLD_cdt)) {
	eval 'sub _BLD_cdt () {1;}' unless defined(&_BLD_cdt);
    }
    if((defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
	require 'ast.ph';
    }
    require 'cdt.ph';
    eval 'sub NIL {
        my($t) = @_;
	    eval q((($t)0));
    }' unless defined(&NIL);
    eval 'sub reg () { &register;}' unless defined(&reg);
    eval 'sub uint () {\'unsigned int\';}' unless defined(&uint);
    eval 'sub left () { ($hl->{_left});}' unless defined(&left);
    eval 'sub hash () { ($hl->{_hash});}' unless defined(&hash);
    eval 'sub htab () { ($hh->{_htab});}' unless defined(&htab);
    eval 'sub head () { ($hh->{_head});}' unless defined(&head);
    eval 'sub DT_FLATTEN () {010000;}' unless defined(&DT_FLATTEN);
    eval 'sub DT_WALK () {020000;}' unless defined(&DT_WALK);
    eval 'sub HSLOT () {(32);}' unless defined(&HSLOT);
    eval 'sub HRESIZE {
        my($n) = @_;
	    eval q((($n) << 1));
    }' unless defined(&HRESIZE);
    eval 'sub HLOAD {
        my($s) = @_;
	    eval q((($s) << 1));
    }' unless defined(&HLOAD);
    eval 'sub HINDEX {
        my($n,$h) = @_;
	    eval q((($h)(($n)-1)));
    }' unless defined(&HINDEX);
    eval 'sub UNFLATTEN {
        my($dt) = @_;
	    eval q((( ($dt->{data}->{type})& &DT_FLATTEN) ?  &dtrestore($dt, &NIL( &Dtlink_t*)) : 0));
    }' unless defined(&UNFLATTEN);
    eval 'sub INITDISC {
        my($dt,$d,$ky,$sz,$lk,$cmpf) = @_;
	    eval q(($d =  ($dt->{disc}), $ky =  ($d->{key}), $sz =  ($d->{size}), $lk =  ($d->{link}), $cmpf =  ($d->{comparf})));
    }' unless defined(&INITDISC);
    eval 'sub ELT {
        my($o,$lk) = @_;
	    eval q((( &Dtlink_t*)(($o) + $lk) ));
    }' unless defined(&ELT);
    eval 'sub OBJ {
        my($e,$lk) = @_;
	    eval q(($lk < 0? (( &Dthold_t*)($e))-> &obj : ( &Void_t*)(($e) - $lk) ));
    }' unless defined(&OBJ);
    eval 'sub KEY {
        my($o,$ky,$sz) = @_;
	    eval q((( &Void_t*)($sz < 0? *(( + $ky)) : (($o) + $ky) ) ));
    }' unless defined(&KEY);
    eval 'sub CMP {
        my($dt,$k1,$k2,$d,$cmpf,$sz) = @_;
	    eval q(($cmpf ? (*$cmpf)($dt,$k1,$k2,$d) : $sz <= 0?  &strcmp($k1,$k2) :  &memcmp($k1,$k2,$sz) ));
    }' unless defined(&CMP);
    eval 'sub HASH {
        my($dt,$k,$d,$sz) = @_;
	    eval q(( ($d->{hashf}) ? (* ($d->{hashf}))($dt,$k,$d) :  &dtstrhash(0,$k,$sz) ));
    }' unless defined(&HASH);
    eval 'sub RROTATE {
        my($x,$y) = @_;
	    eval q((($x)-> &left = ($y)-> &right, ($y)-> &right = ($x), ($x) = ($y)));
    }' unless defined(&RROTATE);
    eval 'sub LROTATE {
        my($x,$y) = @_;
	    eval q((($x)-> &right = ($y)-> &left, ($y)-> &left = ($x), ($x) = ($y)));
    }' unless defined(&LROTATE);
    eval 'sub RLINK {
        my($r,$x) = @_;
	    eval q((($r) = ($r)-> &left = ($x) ));
    }' unless defined(&RLINK);
    eval 'sub LLINK {
        my($l,$x) = @_;
	    eval q((($l) = ($l)-> &right = ($x) ));
    }' unless defined(&LLINK);
    if(!(defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
    }
}
if(defined(&__cplusplus)) {
}
1;
