require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GTK_FEATURES_H__)) {
    eval 'sub __GTK_FEATURES_H__ () {1;}' unless defined(&__GTK_FEATURES_H__);
    if(defined(&__cplusplus)) {
    }
    eval 'sub GTK_MAJOR_VERSION () {(1);}' unless defined(&GTK_MAJOR_VERSION);
    eval 'sub GTK_MINOR_VERSION () {(2);}' unless defined(&GTK_MINOR_VERSION);
    eval 'sub GTK_MICRO_VERSION () {(10);}' unless defined(&GTK_MICRO_VERSION);
    eval 'sub GTK_BINARY_AGE () {(10);}' unless defined(&GTK_BINARY_AGE);
    eval 'sub GTK_INTERFACE_AGE () {(1);}' unless defined(&GTK_INTERFACE_AGE);
    eval 'sub GTK_CHECK_VERSION {
        my($major,$minor,$micro) = @_;
	    eval q(( &GTK_MAJOR_VERSION > ($major) || ( &GTK_MAJOR_VERSION == ($major)  &&  &GTK_MINOR_VERSION > ($minor)) || ( &GTK_MAJOR_VERSION == ($major)  &&  &GTK_MINOR_VERSION == ($minor)  &&  &GTK_MICRO_VERSION >= ($micro))));
    }' unless defined(&GTK_CHECK_VERSION);
    eval 'sub GTK_HAVE_CONTAINER_FOCUS_ADJUSTMENTS () {1-0-1;}' unless defined(&GTK_HAVE_CONTAINER_FOCUS_ADJUSTMENTS);
    eval 'sub GTK_HAVE_SIGNAL_INIT () {1-0-2;}' unless defined(&GTK_HAVE_SIGNAL_INIT);
    eval 'sub GTK_HAVE_FEATURES_1_1_0 () {1-1-0;}' unless defined(&GTK_HAVE_FEATURES_1_1_0);
    eval 'sub GTK_HAVE_FEATURES_1_1_2 () {1-1-2;}' unless defined(&GTK_HAVE_FEATURES_1_1_2);
    eval 'sub GTK_HAVE_FEATURES_1_1_4 () {1-1-4;}' unless defined(&GTK_HAVE_FEATURES_1_1_4);
    eval 'sub GTK_HAVE_FEATURES_1_1_5 () {1-1-5;}' unless defined(&GTK_HAVE_FEATURES_1_1_5);
    eval 'sub GTK_HAVE_FEATURES_1_1_6 () {1-1-6;}' unless defined(&GTK_HAVE_FEATURES_1_1_6);
    eval 'sub GTK_HAVE_FEATURES_1_1_7 () {1-1-7;}' unless defined(&GTK_HAVE_FEATURES_1_1_7);
    eval 'sub GTK_HAVE_FEATURES_1_1_8 () {1-1-8;}' unless defined(&GTK_HAVE_FEATURES_1_1_8);
    eval 'sub GTK_HAVE_FEATURES_1_1_9 () {1-1-9;}' unless defined(&GTK_HAVE_FEATURES_1_1_9);
    eval 'sub GTK_HAVE_FEATURES_1_1_10 () {1-1-10;}' unless defined(&GTK_HAVE_FEATURES_1_1_10);
    eval 'sub GTK_HAVE_FEATURES_1_1_11 () {1-1-11;}' unless defined(&GTK_HAVE_FEATURES_1_1_11);
    eval 'sub GTK_HAVE_FEATURES_1_1_12 () {1-1-12;}' unless defined(&GTK_HAVE_FEATURES_1_1_12);
    eval 'sub GTK_HAVE_FEATURES_1_1_13 () {1-1-13;}' unless defined(&GTK_HAVE_FEATURES_1_1_13);
    eval 'sub GTK_HAVE_FEATURES_1_1_14 () {1-1-14;}' unless defined(&GTK_HAVE_FEATURES_1_1_14);
    if(defined(&__cplusplus)) {
    }
}
1;
