require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GTK_TREE_H__)) {
    eval 'sub __GTK_TREE_H__ () {1;}' unless defined(&__GTK_TREE_H__);
    require 'gdk/gdk.ph';
    require 'gtk/gtkcontainer.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub GTK_TYPE_TREE () {( &gtk_tree_get_type ());}' unless defined(&GTK_TYPE_TREE);
    eval 'sub GTK_TREE {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_CAST (($obj),  &GTK_TYPE_TREE,  &GtkTree)));
    }' unless defined(&GTK_TREE);
    eval 'sub GTK_TREE_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_CAST (($klass),  &GTK_TYPE_TREE,  &GtkTreeClass)));
    }' unless defined(&GTK_TREE_CLASS);
    eval 'sub GTK_IS_TREE {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_TYPE (($obj),  &GTK_TYPE_TREE)));
    }' unless defined(&GTK_IS_TREE);
    eval 'sub GTK_IS_TREE_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_TYPE (($klass),  &GTK_TYPE_TREE)));
    }' unless defined(&GTK_IS_TREE_CLASS);
    eval 'sub GTK_IS_ROOT_TREE {
        my($obj) = @_;
	    eval q((( &GtkObject*)  &GTK_TREE($obj)-> &root_tree == ( &GtkObject*)$obj));
    }' unless defined(&GTK_IS_ROOT_TREE);
    eval 'sub GTK_TREE_ROOT_TREE {
        my($obj) = @_;
	    eval q(( &GTK_TREE($obj)-> &root_tree ?  &GTK_TREE($obj)-> &root_tree :  &GTK_TREE($obj)));
    }' unless defined(&GTK_TREE_ROOT_TREE);
    eval 'sub GTK_TREE_SELECTION {
        my($obj) = @_;
	    eval q(( &GTK_TREE_ROOT_TREE($obj)-> &selection));
    }' unless defined(&GTK_TREE_SELECTION);
    eval("sub GTK_TREE_VIEW_LINE () { 0; }") unless defined(&GTK_TREE_VIEW_LINE);
    eval("sub GTK_TREE_VIEW_ITEM () { 1; }") unless defined(&GTK_TREE_VIEW_ITEM);
    if(defined(&__cplusplus)) {
    }
}
1;
