require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GTK_TYPE_UTILS_H__)) {
    eval 'sub __GTK_TYPE_UTILS_H__ () {1;}' unless defined(&__GTK_TYPE_UTILS_H__);
    require 'glib.ph';
    if(defined(&__cplusplus)) {
    }
    eval("sub GTK_TYPE_INVALID () { 0; }") unless defined(&GTK_TYPE_INVALID);
    eval("sub GTK_TYPE_NONE () { 1; }") unless defined(&GTK_TYPE_NONE);
    eval("sub GTK_TYPE_CHAR () { 2; }") unless defined(&GTK_TYPE_CHAR);
    eval("sub GTK_TYPE_UCHAR () { 3; }") unless defined(&GTK_TYPE_UCHAR);
    eval("sub GTK_TYPE_BOOL () { 4; }") unless defined(&GTK_TYPE_BOOL);
    eval("sub GTK_TYPE_INT () { 5; }") unless defined(&GTK_TYPE_INT);
    eval("sub GTK_TYPE_UINT () { 6; }") unless defined(&GTK_TYPE_UINT);
    eval("sub GTK_TYPE_LONG () { 7; }") unless defined(&GTK_TYPE_LONG);
    eval("sub GTK_TYPE_ULONG () { 8; }") unless defined(&GTK_TYPE_ULONG);
    eval("sub GTK_TYPE_FLOAT () { 9; }") unless defined(&GTK_TYPE_FLOAT);
    eval("sub GTK_TYPE_DOUBLE () { 10; }") unless defined(&GTK_TYPE_DOUBLE);
    eval("sub GTK_TYPE_STRING () { 11; }") unless defined(&GTK_TYPE_STRING);
    eval("sub GTK_TYPE_ENUM () { 12; }") unless defined(&GTK_TYPE_ENUM);
    eval("sub GTK_TYPE_FLAGS () { 13; }") unless defined(&GTK_TYPE_FLAGS);
    eval("sub GTK_TYPE_BOXED () { 14; }") unless defined(&GTK_TYPE_BOXED);
    eval("sub GTK_TYPE_POINTER () { 15; }") unless defined(&GTK_TYPE_POINTER);
    eval("sub GTK_TYPE_SIGNAL () { 16; }") unless defined(&GTK_TYPE_SIGNAL);
    eval("sub GTK_TYPE_ARGS () { 17; }") unless defined(&GTK_TYPE_ARGS);
    eval("sub GTK_TYPE_CALLBACK () { 18; }") unless defined(&GTK_TYPE_CALLBACK);
    eval("sub GTK_TYPE_C_CALLBACK () { 19; }") unless defined(&GTK_TYPE_C_CALLBACK);
    eval("sub GTK_TYPE_FOREIGN () { 20; }") unless defined(&GTK_TYPE_FOREIGN);
    eval("sub GTK_TYPE_OBJECT () { 21; }") unless defined(&GTK_TYPE_OBJECT);
    eval 'sub GTK_TYPE_FLAT_FIRST () { &GTK_TYPE_CHAR;}' unless defined(&GTK_TYPE_FLAT_FIRST);
    eval 'sub GTK_TYPE_FLAT_LAST () { &GTK_TYPE_POINTER;}' unless defined(&GTK_TYPE_FLAT_LAST);
    eval 'sub GTK_TYPE_STRUCTURED_FIRST () { &GTK_TYPE_SIGNAL;}' unless defined(&GTK_TYPE_STRUCTURED_FIRST);
    eval 'sub GTK_TYPE_STRUCTURED_LAST () { &GTK_TYPE_FOREIGN;}' unless defined(&GTK_TYPE_STRUCTURED_LAST);
    eval 'sub GTK_TYPE_FUNDAMENTAL_LAST () { &GTK_TYPE_OBJECT;}' unless defined(&GTK_TYPE_FUNDAMENTAL_LAST);
    eval 'sub GTK_TYPE_FUNDAMENTAL_MAX () {(32);}' unless defined(&GTK_TYPE_FUNDAMENTAL_MAX);
    if(defined(&offsetof)) {
	eval 'sub GTK_STRUCT_OFFSET {
	    my($struct, $field) = @_;
    	    eval q((( &gint)  &offsetof (\'struct struct\', $field)));
	}' unless defined(&GTK_STRUCT_OFFSET);
    } else {
	eval 'sub GTK_STRUCT_OFFSET {
	    my($struct, $field) = @_;
    	    eval q((( &gint) ( ( 0)->$field)));
	}' unless defined(&GTK_STRUCT_OFFSET);
    }
    if(defined(&GTK_NO_CHECK_CASTS)) {
	eval 'sub GTK_CHECK_CAST {
	    my($tobj, $cast_type, $cast) = @_;
    	    eval q((($cast*) ($tobj)));
	}' unless defined(&GTK_CHECK_CAST);
	eval 'sub GTK_CHECK_CLASS_CAST {
	    my($tclass,$cast_type,$cast) = @_;
    	    eval q((($cast*) ($tclass)));
	}' unless defined(&GTK_CHECK_CLASS_CAST);
    } else {
	eval 'sub GTK_CHECK_CAST {
	    my($tobj, $cast_type, $cast) = @_;
    	    eval q((($cast*)  &gtk_type_check_object_cast (( &GtkTypeObject*) ($tobj), ($cast_type))));
	}' unless defined(&GTK_CHECK_CAST);
	eval 'sub GTK_CHECK_CLASS_CAST {
	    my($tclass,$cast_type,$cast) = @_;
    	    eval q((($cast*)  &gtk_type_check_class_cast (( &GtkTypeClass*) ($tclass), ($cast_type))));
	}' unless defined(&GTK_CHECK_CLASS_CAST);
    }
    eval 'sub GTK_CHECK_TYPE {
        my($type_object, $otype) = @_;
	    eval q(( (( &GtkTypeObject*) ($type_object)) !=  &NULL  &&  &GTK_CHECK_CLASS_TYPE ((( &GtkTypeObject*) ($type_object))-> &klass, ($otype)) ));
    }' unless defined(&GTK_CHECK_TYPE);
    eval 'sub GTK_CHECK_CLASS_TYPE {
        my($type_class, $otype) = @_;
	    eval q(( (( &GtkTypeClass*) ($type_class)) !=  &NULL  &&  &gtk_type_is_a ((( &GtkTypeClass*) ($type_class))-> &type, ($otype)) ));
    }' unless defined(&GTK_CHECK_CLASS_TYPE);
    if(defined(&__cplusplus)) {
    }
    require 'gtk/gtktypebuiltins.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub GTK_TYPE_IDENTIFIER () {( &gtk_identifier_get_type ());}' unless defined(&GTK_TYPE_IDENTIFIER);
    eval 'sub GTK_TYPE_MAKE {
        my($parent_t, $seqno) = @_;
	    eval q(((($seqno) << 8) |  &GTK_FUNDAMENTAL_TYPE ($parent_t)));
    }' unless defined(&GTK_TYPE_MAKE);
    eval 'sub GTK_FUNDAMENTAL_TYPE {
        my($type) = @_;
	    eval q((( &GtkFundamentalType) (($type) & 0xff)));
    }' unless defined(&GTK_FUNDAMENTAL_TYPE);
    eval 'sub GTK_TYPE_SEQNO {
        my($type) = @_;
	    eval q((($type) > 0xff ? ($type) >> 8: ($type)));
    }' unless defined(&GTK_TYPE_SEQNO);
    eval 'sub GTK_SIGNAL_FUNC {
        my($f) = @_;
	    eval q((( &GtkSignalFunc) $f));
    }' unless defined(&GTK_SIGNAL_FUNC);
    if(defined(&__GNUC__)) {
    }
    if(defined(&__GNUC__)) {
    }
    eval 'sub GTK_VALUE_CHAR {
        my($a) = @_;
	    eval q((($a). ($d->{char_data})));
    }' unless defined(&GTK_VALUE_CHAR);
    eval 'sub GTK_VALUE_UCHAR {
        my($a) = @_;
	    eval q((($a). ($d->{uchar_data})));
    }' unless defined(&GTK_VALUE_UCHAR);
    eval 'sub GTK_VALUE_BOOL {
        my($a) = @_;
	    eval q((($a). ($d->{bool_data})));
    }' unless defined(&GTK_VALUE_BOOL);
    eval 'sub GTK_VALUE_INT {
        my($a) = @_;
	    eval q((($a). ($d->{int_data})));
    }' unless defined(&GTK_VALUE_INT);
    eval 'sub GTK_VALUE_UINT {
        my($a) = @_;
	    eval q((($a). ($d->{uint_data})));
    }' unless defined(&GTK_VALUE_UINT);
    eval 'sub GTK_VALUE_LONG {
        my($a) = @_;
	    eval q((($a). ($d->{long_data})));
    }' unless defined(&GTK_VALUE_LONG);
    eval 'sub GTK_VALUE_ULONG {
        my($a) = @_;
	    eval q((($a). ($d->{ulong_data})));
    }' unless defined(&GTK_VALUE_ULONG);
    eval 'sub GTK_VALUE_FLOAT {
        my($a) = @_;
	    eval q((($a). ($d->{float_data})));
    }' unless defined(&GTK_VALUE_FLOAT);
    eval 'sub GTK_VALUE_DOUBLE {
        my($a) = @_;
	    eval q((($a). ($d->{double_data})));
    }' unless defined(&GTK_VALUE_DOUBLE);
    eval 'sub GTK_VALUE_STRING {
        my($a) = @_;
	    eval q((($a). ($d->{string_data})));
    }' unless defined(&GTK_VALUE_STRING);
    eval 'sub GTK_VALUE_ENUM {
        my($a) = @_;
	    eval q((($a). ($d->{int_data})));
    }' unless defined(&GTK_VALUE_ENUM);
    eval 'sub GTK_VALUE_FLAGS {
        my($a) = @_;
	    eval q((($a). ($d->{uint_data})));
    }' unless defined(&GTK_VALUE_FLAGS);
    eval 'sub GTK_VALUE_BOXED {
        my($a) = @_;
	    eval q((($a). ($d->{pointer_data})));
    }' unless defined(&GTK_VALUE_BOXED);
    eval 'sub GTK_VALUE_POINTER {
        my($a) = @_;
	    eval q((($a). ($d->{pointer_data})));
    }' unless defined(&GTK_VALUE_POINTER);
    eval 'sub GTK_VALUE_OBJECT {
        my($a) = @_;
	    eval q((($a). ($d->{object_data})));
    }' unless defined(&GTK_VALUE_OBJECT);
    eval 'sub GTK_VALUE_SIGNAL {
        my($a) = @_;
	    eval q((($a). ($d->{signal_data})));
    }' unless defined(&GTK_VALUE_SIGNAL);
    eval 'sub GTK_VALUE_ARGS {
        my($a) = @_;
	    eval q((($a). ($d->{args_data})));
    }' unless defined(&GTK_VALUE_ARGS);
    eval 'sub GTK_VALUE_CALLBACK {
        my($a) = @_;
	    eval q((($a). ($d->{c$allback_data})));
    }' unless defined(&GTK_VALUE_CALLBACK);
    eval 'sub GTK_VALUE_C_CALLBACK {
        my($a) = @_;
	    eval q((($a). ($d->{c_callback_data})));
    }' unless defined(&GTK_VALUE_C_CALLBACK);
    eval 'sub GTK_VALUE_FOREIGN {
        my($a) = @_;
	    eval q((($a). ($d->{foreign_data})));
    }' unless defined(&GTK_VALUE_FOREIGN);
    eval 'sub GTK_RETLOC_CHAR {
        my($a) = @_;
	    eval q((( &gchar*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_CHAR);
    eval 'sub GTK_RETLOC_UCHAR {
        my($a) = @_;
	    eval q((( &guchar*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_UCHAR);
    eval 'sub GTK_RETLOC_BOOL {
        my($a) = @_;
	    eval q((( &gboolean*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_BOOL);
    eval 'sub GTK_RETLOC_INT {
        my($a) = @_;
	    eval q((( &gint*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_INT);
    eval 'sub GTK_RETLOC_UINT {
        my($a) = @_;
	    eval q((( &guint*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_UINT);
    eval 'sub GTK_RETLOC_LONG {
        my($a) = @_;
	    eval q(( ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_LONG);
    eval 'sub GTK_RETLOC_ULONG {
        my($a) = @_;
	    eval q(( ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_ULONG);
    eval 'sub GTK_RETLOC_FLOAT {
        my($a) = @_;
	    eval q((( &gfloat*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_FLOAT);
    eval 'sub GTK_RETLOC_DOUBLE {
        my($a) = @_;
	    eval q((( &gdouble*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_DOUBLE);
    eval 'sub GTK_RETLOC_STRING {
        my($a) = @_;
	    eval q((( &gchar**) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_STRING);
    eval 'sub GTK_RETLOC_ENUM {
        my($a) = @_;
	    eval q((( &gint*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_ENUM);
    eval 'sub GTK_RETLOC_FLAGS {
        my($a) = @_;
	    eval q((( &guint*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_FLAGS);
    eval 'sub GTK_RETLOC_BOXED {
        my($a) = @_;
	    eval q((( &gpointer*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_BOXED);
    eval 'sub GTK_RETLOC_POINTER {
        my($a) = @_;
	    eval q((( &gpointer*) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_POINTER);
    eval 'sub GTK_RETLOC_OBJECT {
        my($a) = @_;
	    eval q((( &GtkObject**) ($a). ($d->{pointer_data})));
    }' unless defined(&GTK_RETLOC_OBJECT);
    if(defined(&__cplusplus)) {
    }
}
1;
