require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&IWLIB_H)) {
    eval 'sub IWLIB_H () {1;}' unless defined(&IWLIB_H);
    require 'sys/types.ph';
    require 'sys/ioctl.ph';
    require 'stdio.ph';
    require 'math.ph';
    require 'errno.ph';
    require 'fcntl.ph';
    require 'ctype.ph';
    require 'stdlib.ph';
    require 'string.ph';
    require 'unistd.ph';
    require 'netdb.ph';
    require 'net/ethernet.ph';
    require 'sys/time.ph';
    require 'unistd.ph';
    unless(defined(&LINUX_VERSION_CODE)) {
	require 'linux/version.ph';
    }
    if(defined( &__GLIBC__)  && (defined(&__GLIBC__) ? &__GLIBC__ : 0) == 2 && (defined(&__GLIBC_MINOR__) ? &__GLIBC_MINOR__ : 0) >= 2 && (defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,2,0)) {
	eval 'sub GENERIC_HEADERS () {1;}' unless defined(&GENERIC_HEADERS);
    }
 elsif(defined( &__GLIBC__)  && (defined(&__GLIBC__) ? &__GLIBC__ : 0) == 2 && (defined(&__GLIBC_MINOR__) ? &__GLIBC_MINOR__ : 0) == 1 && (defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,2,0)) {
	eval 'sub GENERIC_HEADERS () {1;}' unless defined(&GENERIC_HEADERS);
    }
 elsif(defined( &__GLIBC__)  && (defined(&__GLIBC__) ? &__GLIBC__ : 0) == 2 && (defined(&__GLIBC_MINOR__) ? &__GLIBC_MINOR__ : 0) == 0 && (defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,0,0)  && (defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,0)) {
	eval 'sub GLIBC_HEADERS () {1;}' unless defined(&GLIBC_HEADERS);
	eval 'sub KLUDGE_HEADERS () {1;}' unless defined(&KLUDGE_HEADERS);
    }
 elsif(defined( &__GLIBC__)  && (defined(&__GLIBC__) ? &__GLIBC__ : 0) == 2 && (defined(&__GLIBC_MINOR__) ? &__GLIBC_MINOR__ : 0) == 0 && (defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,0)  && (defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,0,0)) {
	eval 'sub GLIBC_HEADERS () {1;}' unless defined(&GLIBC_HEADERS);
    }
 elsif(defined( &_LINUX_C_LIB_VERSION_MAJOR)  && (defined(&_LINUX_C_LIB_VERSION_MAJOR) ? &_LINUX_C_LIB_VERSION_MAJOR : 0) == 5 && (defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,0,0)  && (defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,0)) {
	eval 'sub LIBC5_HEADERS () {1;}' unless defined(&LIBC5_HEADERS);
    } else {
	die("Your kernel/libc combination is not supported");
    }
    if(defined(&GENERIC_HEADERS)) {
	require 'net/if_arp.ph';
	require 'sys/socket.ph';
	require 'netinet/in.ph';
	require 'netinet/if_ether.ph';
    }
    if(defined(&GLIBC22_HEADERS)) {
	require 'linux/if_arp.ph';
	require 'linux/socket.ph';
	require 'sys/socket.ph';
    }
    if(defined(&KLUDGE_HEADERS)) {
	require 'socketbits.ph';
    }
    if(defined(&GLIBC_HEADERS)) {
	require 'linux/if_arp.ph';
	require 'linux/socket.ph';
	require 'linux/in.ph';
    }
    if(defined(&LIBC5_HEADERS)) {
	require 'sys/socket.ph';
	require 'linux/if_arp.ph';
	require 'linux/in.ph';
    }
    require 'linux/types.ph';
    require 'linux/socket.ph';
    require 'linux/if.ph';
    if(defined(&WEXT_HEADER)) {
    } else {
	require 'linux/wireless.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub PROC_NET_WIRELESS () {"/proc/net/wireless";}' unless defined(&PROC_NET_WIRELESS);
    eval 'sub PROC_NET_DEV () {"/proc/net/dev";}' unless defined(&PROC_NET_DEV);
    eval 'sub KILO () {1 &e3;}' unless defined(&KILO);
    eval 'sub MEGA () {1 &e6;}' unless defined(&MEGA);
    eval 'sub GIGA () {1 &e9;}' unless defined(&GIGA);
    eval 'sub LOG10_MAGIC () {1.25892541179;}' unless defined(&LOG10_MAGIC);
    unless(defined(&IW_POWER_MODIFIER)) {
	eval 'sub IW_POWER_MODIFIER () {0xf;}' unless defined(&IW_POWER_MODIFIER);
	eval 'sub IW_POWER_MIN () {0x1;}' unless defined(&IW_POWER_MIN);
	eval 'sub IW_POWER_MAX () {0x2;}' unless defined(&IW_POWER_MAX);
	eval 'sub IW_POWER_RELATIVE () {0x4;}' unless defined(&IW_POWER_RELATIVE);
    }
    unless(defined(&IW_ENCODE_NOKEY)) {
	eval 'sub IW_ENCODE_NOKEY () {0x800;}' unless defined(&IW_ENCODE_NOKEY);
	eval 'sub IW_ENCODE_MODE () {0xf000;}' unless defined(&IW_ENCODE_MODE);
    }
    unless(defined(&IW_ENCODE_TEMP)) {
	eval 'sub IW_ENCODE_TEMP () {0x400;}' unless defined(&IW_ENCODE_TEMP);
    }
    unless(defined(&SIOCSIWCOMMIT)) {
	eval 'sub SIOCSIWCOMMIT () { &SIOCSIWNAME;}' unless defined(&SIOCSIWCOMMIT);
    }
    if((defined(&WIRELESS_EXT) ? &WIRELESS_EXT : 0) > 10) {
    }
    if(0) {
    }
    if((defined(&WIRELESS_EXT) ? &WIRELESS_EXT : 0) > 13) {
    }
    eval 'sub IW_NUM_OPER_MODE () {7;}' unless defined(&IW_NUM_OPER_MODE);
    if(defined(&__cplusplus)) {
    }
}
1;
