require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&libuser_error_h)) {
    eval 'sub libuser_error_h () {1;}' unless defined(&libuser_error_h);
    require 'sys/types.ph';
    require 'errno.ph';
    require 'glib.ph';
    eval("sub lu_success () { 0; }") unless defined(&lu_success);
    eval("sub lu_warning_config_disabled () { 1; }") unless defined(&lu_warning_config_disabled);
    eval("sub lu_error_generic () { 2; }") unless defined(&lu_error_generic);
    eval("sub lu_error_privilege () { 3; }") unless defined(&lu_error_privilege);
    eval("sub lu_error_access_denied () { 4; }") unless defined(&lu_error_access_denied);
    eval("sub lu_error_name_bad () { 5; }") unless defined(&lu_error_name_bad);
    eval("sub lu_error_id_bad () { 6; }") unless defined(&lu_error_id_bad);
    eval("sub lu_error_name_used () { 7; }") unless defined(&lu_error_name_used);
    eval("sub lu_error_id_used () { 8; }") unless defined(&lu_error_id_used);
    eval("sub lu_error_terminal () { 9; }") unless defined(&lu_error_terminal);
    eval("sub lu_error_open () { 10; }") unless defined(&lu_error_open);
    eval("sub lu_error_lock () { 11; }") unless defined(&lu_error_lock);
    eval("sub lu_error_stat () { 12; }") unless defined(&lu_error_stat);
    eval("sub lu_error_read () { 13; }") unless defined(&lu_error_read);
    eval("sub lu_error_write () { 14; }") unless defined(&lu_error_write);
    eval("sub lu_error_search () { 15; }") unless defined(&lu_error_search);
    eval("sub lu_error_init () { 16; }") unless defined(&lu_error_init);
    eval("sub lu_error_module_load () { 17; }") unless defined(&lu_error_module_load);
    eval("sub lu_error_module_sym () { 18; }") unless defined(&lu_error_module_sym);
    eval("sub lu_error_module_version () { 19; }") unless defined(&lu_error_module_version);
    eval 'sub LU_ERROR_CHECK {
        my($err_p_p) = @_;
	    eval q( &do { \'struct lu_error\' ** &__err = ($err_p_p);  &if (( &__err ==  &NULL) || (* &__err !=  &NULL)) {  &if( &__err ==  &NULL) {  &fprintf( &stderr, \\"libuser fatal error: %s() called with NULL \\" $err_p_p \\"\\\\n\\",  &__FUNCTION__); }  &else  &if(* &__err !=  &NULL) {  &fprintf( &stderr, \\"libuser fatal error: %s() called with non-NULL *\\" $err_p_p,  &__FUNCTION__); }  &abort(); } }  &while(0));
    }' unless defined(&LU_ERROR_CHECK);
}
1;
