require '_h2ph_pre.ph';

no warnings 'redefine';

require 'libxml/parser.ph';
unless(defined(&__XML_ERROR_H__)) {
    eval 'sub __XML_ERROR_H__ () {1;}' unless defined(&__XML_ERROR_H__);
    if(defined(&__cplusplus)) {
    }
    eval("sub XML_ERR_OK () { 0; }") unless defined(&XML_ERR_OK);
    eval("sub XML_ERR_INTERNAL_ERROR () { 1; }") unless defined(&XML_ERR_INTERNAL_ERROR);
    eval("sub XML_ERR_NO_MEMORY () { 2; }") unless defined(&XML_ERR_NO_MEMORY);
    eval("sub XML_ERR_DOCUMENT_START () { 3; }") unless defined(&XML_ERR_DOCUMENT_START);
    eval("sub XML_ERR_DOCUMENT_EMPTY () { 4; }") unless defined(&XML_ERR_DOCUMENT_EMPTY);
    eval("sub XML_ERR_DOCUMENT_END () { 5; }") unless defined(&XML_ERR_DOCUMENT_END);
    eval("sub XML_ERR_INVALID_HEX_CHARREF () { 6; }") unless defined(&XML_ERR_INVALID_HEX_CHARREF);
    eval("sub XML_ERR_INVALID_DEC_CHARREF () { 7; }") unless defined(&XML_ERR_INVALID_DEC_CHARREF);
    eval("sub XML_ERR_INVALID_CHARREF () { 8; }") unless defined(&XML_ERR_INVALID_CHARREF);
    eval("sub XML_ERR_INVALID_CHAR () { 9; }") unless defined(&XML_ERR_INVALID_CHAR);
    eval("sub XML_ERR_CHARREF_AT_EOF () { 10; }") unless defined(&XML_ERR_CHARREF_AT_EOF);
    eval("sub XML_ERR_CHARREF_IN_PROLOG () { 11; }") unless defined(&XML_ERR_CHARREF_IN_PROLOG);
    eval("sub XML_ERR_CHARREF_IN_EPILOG () { 12; }") unless defined(&XML_ERR_CHARREF_IN_EPILOG);
    eval("sub XML_ERR_CHARREF_IN_DTD () { 13; }") unless defined(&XML_ERR_CHARREF_IN_DTD);
    eval("sub XML_ERR_ENTITYREF_AT_EOF () { 14; }") unless defined(&XML_ERR_ENTITYREF_AT_EOF);
    eval("sub XML_ERR_ENTITYREF_IN_PROLOG () { 15; }") unless defined(&XML_ERR_ENTITYREF_IN_PROLOG);
    eval("sub XML_ERR_ENTITYREF_IN_EPILOG () { 16; }") unless defined(&XML_ERR_ENTITYREF_IN_EPILOG);
    eval("sub XML_ERR_ENTITYREF_IN_DTD () { 17; }") unless defined(&XML_ERR_ENTITYREF_IN_DTD);
    eval("sub XML_ERR_PEREF_AT_EOF () { 18; }") unless defined(&XML_ERR_PEREF_AT_EOF);
    eval("sub XML_ERR_PEREF_IN_PROLOG () { 19; }") unless defined(&XML_ERR_PEREF_IN_PROLOG);
    eval("sub XML_ERR_PEREF_IN_EPILOG () { 20; }") unless defined(&XML_ERR_PEREF_IN_EPILOG);
    eval("sub XML_ERR_PEREF_IN_INT_SUBSET () { 21; }") unless defined(&XML_ERR_PEREF_IN_INT_SUBSET);
    eval("sub XML_ERR_ENTITYREF_NO_NAME () { 22; }") unless defined(&XML_ERR_ENTITYREF_NO_NAME);
    eval("sub XML_ERR_ENTITYREF_SEMICOL_MISSING () { 23; }") unless defined(&XML_ERR_ENTITYREF_SEMICOL_MISSING);
    eval("sub XML_ERR_PEREF_NO_NAME () { 24; }") unless defined(&XML_ERR_PEREF_NO_NAME);
    eval("sub XML_ERR_PEREF_SEMICOL_MISSING () { 25; }") unless defined(&XML_ERR_PEREF_SEMICOL_MISSING);
    eval("sub XML_ERR_UNDECLARED_ENTITY () { 26; }") unless defined(&XML_ERR_UNDECLARED_ENTITY);
    eval("sub XML_WAR_UNDECLARED_ENTITY () { 27; }") unless defined(&XML_WAR_UNDECLARED_ENTITY);
    eval("sub XML_ERR_UNPARSED_ENTITY () { 28; }") unless defined(&XML_ERR_UNPARSED_ENTITY);
    eval("sub XML_ERR_ENTITY_IS_EXTERNAL () { 29; }") unless defined(&XML_ERR_ENTITY_IS_EXTERNAL);
    eval("sub XML_ERR_ENTITY_IS_PARAMETER () { 30; }") unless defined(&XML_ERR_ENTITY_IS_PARAMETER);
    eval("sub XML_ERR_UNKNOWN_ENCODING () { 31; }") unless defined(&XML_ERR_UNKNOWN_ENCODING);
    eval("sub XML_ERR_UNSUPPORTED_ENCODING () { 32; }") unless defined(&XML_ERR_UNSUPPORTED_ENCODING);
    eval("sub XML_ERR_STRING_NOT_STARTED () { 33; }") unless defined(&XML_ERR_STRING_NOT_STARTED);
    eval("sub XML_ERR_STRING_NOT_CLOSED () { 34; }") unless defined(&XML_ERR_STRING_NOT_CLOSED);
    eval("sub XML_ERR_NS_DECL_ERROR () { 35; }") unless defined(&XML_ERR_NS_DECL_ERROR);
    eval("sub XML_ERR_ENTITY_NOT_STARTED () { 36; }") unless defined(&XML_ERR_ENTITY_NOT_STARTED);
    eval("sub XML_ERR_ENTITY_NOT_FINISHED () { 37; }") unless defined(&XML_ERR_ENTITY_NOT_FINISHED);
    eval("sub XML_ERR_LT_IN_ATTRIBUTE () { 38; }") unless defined(&XML_ERR_LT_IN_ATTRIBUTE);
    eval("sub XML_ERR_ATTRIBUTE_NOT_STARTED () { 39; }") unless defined(&XML_ERR_ATTRIBUTE_NOT_STARTED);
    eval("sub XML_ERR_ATTRIBUTE_NOT_FINISHED () { 40; }") unless defined(&XML_ERR_ATTRIBUTE_NOT_FINISHED);
    eval("sub XML_ERR_ATTRIBUTE_WITHOUT_VALUE () { 41; }") unless defined(&XML_ERR_ATTRIBUTE_WITHOUT_VALUE);
    eval("sub XML_ERR_ATTRIBUTE_REDEFINED () { 42; }") unless defined(&XML_ERR_ATTRIBUTE_REDEFINED);
    eval("sub XML_ERR_LITERAL_NOT_STARTED () { 43; }") unless defined(&XML_ERR_LITERAL_NOT_STARTED);
    eval("sub XML_ERR_LITERAL_NOT_FINISHED () { 44; }") unless defined(&XML_ERR_LITERAL_NOT_FINISHED);
    eval("sub XML_ERR_COMMENT_NOT_FINISHED () { 45; }") unless defined(&XML_ERR_COMMENT_NOT_FINISHED);
    eval("sub XML_ERR_PI_NOT_STARTED () { 46; }") unless defined(&XML_ERR_PI_NOT_STARTED);
    eval("sub XML_ERR_PI_NOT_FINISHED () { 47; }") unless defined(&XML_ERR_PI_NOT_FINISHED);
    eval("sub XML_ERR_NOTATION_NOT_STARTED () { 48; }") unless defined(&XML_ERR_NOTATION_NOT_STARTED);
    eval("sub XML_ERR_NOTATION_NOT_FINISHED () { 49; }") unless defined(&XML_ERR_NOTATION_NOT_FINISHED);
    eval("sub XML_ERR_ATTLIST_NOT_STARTED () { 50; }") unless defined(&XML_ERR_ATTLIST_NOT_STARTED);
    eval("sub XML_ERR_ATTLIST_NOT_FINISHED () { 51; }") unless defined(&XML_ERR_ATTLIST_NOT_FINISHED);
    eval("sub XML_ERR_MIXED_NOT_STARTED () { 52; }") unless defined(&XML_ERR_MIXED_NOT_STARTED);
    eval("sub XML_ERR_MIXED_NOT_FINISHED () { 53; }") unless defined(&XML_ERR_MIXED_NOT_FINISHED);
    eval("sub XML_ERR_ELEMCONTENT_NOT_STARTED () { 54; }") unless defined(&XML_ERR_ELEMCONTENT_NOT_STARTED);
    eval("sub XML_ERR_ELEMCONTENT_NOT_FINISHED () { 55; }") unless defined(&XML_ERR_ELEMCONTENT_NOT_FINISHED);
    eval("sub XML_ERR_XMLDECL_NOT_STARTED () { 56; }") unless defined(&XML_ERR_XMLDECL_NOT_STARTED);
    eval("sub XML_ERR_XMLDECL_NOT_FINISHED () { 57; }") unless defined(&XML_ERR_XMLDECL_NOT_FINISHED);
    eval("sub XML_ERR_CONDSEC_NOT_STARTED () { 58; }") unless defined(&XML_ERR_CONDSEC_NOT_STARTED);
    eval("sub XML_ERR_CONDSEC_NOT_FINISHED () { 59; }") unless defined(&XML_ERR_CONDSEC_NOT_FINISHED);
    eval("sub XML_ERR_EXT_SUBSET_NOT_FINISHED () { 60; }") unless defined(&XML_ERR_EXT_SUBSET_NOT_FINISHED);
    eval("sub XML_ERR_DOCTYPE_NOT_FINISHED () { 61; }") unless defined(&XML_ERR_DOCTYPE_NOT_FINISHED);
    eval("sub XML_ERR_MISPLACED_CDATA_END () { 62; }") unless defined(&XML_ERR_MISPLACED_CDATA_END);
    eval("sub XML_ERR_CDATA_NOT_FINISHED () { 63; }") unless defined(&XML_ERR_CDATA_NOT_FINISHED);
    eval("sub XML_ERR_RESERVED_XML_NAME () { 64; }") unless defined(&XML_ERR_RESERVED_XML_NAME);
    eval("sub XML_ERR_SPACE_REQUIRED () { 65; }") unless defined(&XML_ERR_SPACE_REQUIRED);
    eval("sub XML_ERR_SEPARATOR_REQUIRED () { 66; }") unless defined(&XML_ERR_SEPARATOR_REQUIRED);
    eval("sub XML_ERR_NMTOKEN_REQUIRED () { 67; }") unless defined(&XML_ERR_NMTOKEN_REQUIRED);
    eval("sub XML_ERR_NAME_REQUIRED () { 68; }") unless defined(&XML_ERR_NAME_REQUIRED);
    eval("sub XML_ERR_PCDATA_REQUIRED () { 69; }") unless defined(&XML_ERR_PCDATA_REQUIRED);
    eval("sub XML_ERR_URI_REQUIRED () { 70; }") unless defined(&XML_ERR_URI_REQUIRED);
    eval("sub XML_ERR_PUBID_REQUIRED () { 71; }") unless defined(&XML_ERR_PUBID_REQUIRED);
    eval("sub XML_ERR_LT_REQUIRED () { 72; }") unless defined(&XML_ERR_LT_REQUIRED);
    eval("sub XML_ERR_GT_REQUIRED () { 73; }") unless defined(&XML_ERR_GT_REQUIRED);
    eval("sub XML_ERR_LTSLASH_REQUIRED () { 74; }") unless defined(&XML_ERR_LTSLASH_REQUIRED);
    eval("sub XML_ERR_EQUAL_REQUIRED () { 75; }") unless defined(&XML_ERR_EQUAL_REQUIRED);
    eval("sub XML_ERR_TAG_NAME_MISMATCH () { 76; }") unless defined(&XML_ERR_TAG_NAME_MISMATCH);
    eval("sub XML_ERR_TAG_NOT_FINISHED () { 77; }") unless defined(&XML_ERR_TAG_NOT_FINISHED);
    eval("sub XML_ERR_STANDALONE_VALUE () { 78; }") unless defined(&XML_ERR_STANDALONE_VALUE);
    eval("sub XML_ERR_ENCODING_NAME () { 79; }") unless defined(&XML_ERR_ENCODING_NAME);
    eval("sub XML_ERR_HYPHEN_IN_COMMENT () { 80; }") unless defined(&XML_ERR_HYPHEN_IN_COMMENT);
    eval("sub XML_ERR_INVALID_ENCODING () { 81; }") unless defined(&XML_ERR_INVALID_ENCODING);
    eval("sub XML_ERR_EXT_ENTITY_STANDALONE () { 82; }") unless defined(&XML_ERR_EXT_ENTITY_STANDALONE);
    eval("sub XML_ERR_CONDSEC_INVALID () { 83; }") unless defined(&XML_ERR_CONDSEC_INVALID);
    eval("sub XML_ERR_VALUE_REQUIRED () { 84; }") unless defined(&XML_ERR_VALUE_REQUIRED);
    eval("sub XML_ERR_NOT_WELL_BALANCED () { 85; }") unless defined(&XML_ERR_NOT_WELL_BALANCED);
    eval("sub XML_ERR_EXTRA_CONTENT () { 86; }") unless defined(&XML_ERR_EXTRA_CONTENT);
    eval("sub XML_ERR_ENTITY_CHAR_ERROR () { 87; }") unless defined(&XML_ERR_ENTITY_CHAR_ERROR);
    eval("sub XML_ERR_ENTITY_PE_INTERNAL () { 88; }") unless defined(&XML_ERR_ENTITY_PE_INTERNAL);
    eval("sub XML_ERR_ENTITY_LOOP () { 89; }") unless defined(&XML_ERR_ENTITY_LOOP);
    eval("sub XML_ERR_ENTITY_BOUNDARY () { 90; }") unless defined(&XML_ERR_ENTITY_BOUNDARY);
    eval("sub XML_ERR_INVALID_URI () { 91; }") unless defined(&XML_ERR_INVALID_URI);
    eval("sub XML_ERR_URI_FRAGMENT () { 92; }") unless defined(&XML_ERR_URI_FRAGMENT);
    eval("sub XML_WAR_CATALOG_PI () { 93; }") unless defined(&XML_WAR_CATALOG_PI);
    eval("sub XML_ERR_NO_DTD () { 94; }") unless defined(&XML_ERR_NO_DTD);
    if(defined(&__cplusplus)) {
    }
}
1;
