require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&META_UTIL_H)) {
    eval 'sub META_UTIL_H () {1;}' unless defined(&META_UTIL_H);
    require 'glib.ph';
    eval("sub META_DEBUG_FOCUS () { 1<<0; }") unless defined(&META_DEBUG_FOCUS);
    eval("sub META_DEBUG_WORKAREA () { 1<<1; }") unless defined(&META_DEBUG_WORKAREA);
    eval("sub META_DEBUG_STACK () { 1<<2; }") unless defined(&META_DEBUG_STACK);
    eval("sub META_DEBUG_THEMES () { 1<<3; }") unless defined(&META_DEBUG_THEMES);
    eval("sub META_DEBUG_SM () { 1<<4; }") unless defined(&META_DEBUG_SM);
    eval("sub META_DEBUG_EVENTS () { 1<<5; }") unless defined(&META_DEBUG_EVENTS);
    eval("sub META_DEBUG_WINDOW_STATE () { 1<<6; }") unless defined(&META_DEBUG_WINDOW_STATE);
    eval("sub META_DEBUG_WINDOW_OPS () { 1<<7; }") unless defined(&META_DEBUG_WINDOW_OPS);
    eval("sub META_DEBUG_GEOMETRY () { 1<<8; }") unless defined(&META_DEBUG_GEOMETRY);
    eval("sub META_DEBUG_PLACEMENT () { 1<<9; }") unless defined(&META_DEBUG_PLACEMENT);
    eval("sub META_DEBUG_PING () { 1<<10; }") unless defined(&META_DEBUG_PING);
    eval("sub META_DEBUG_XINERAMA () { 1<<11; }") unless defined(&META_DEBUG_XINERAMA);
    eval("sub META_DEBUG_KEYBINDINGS () { 1<<12; }") unless defined(&META_DEBUG_KEYBINDINGS);
    eval("sub META_DEBUG_SYNC () { 1<<13; }") unless defined(&META_DEBUG_SYNC);
    eval("sub META_DEBUG_ERRORS () { 1<<14; }") unless defined(&META_DEBUG_ERRORS);
    eval("sub META_DEBUG_STARTUP () { 1<<15; }") unless defined(&META_DEBUG_STARTUP);
    eval("sub META_DEBUG_PREFS () { 1<<16; }") unless defined(&META_DEBUG_PREFS);
    eval("sub META_DEBUG_GROUPS () { 1<<17; }") unless defined(&META_DEBUG_GROUPS);
    eval("sub META_DEBUG_RESIZING () { 1<<18; }") unless defined(&META_DEBUG_RESIZING);
    eval("sub META_DEBUG_SHAPES () { 1<<19; }") unless defined(&META_DEBUG_SHAPES);
    require 'libintl.ph';
    eval 'sub _ {
        my($x) = @_;
	    eval q( &dgettext ( &GETTEXT_PACKAGE, $x));
    }' unless defined(&_);
    eval 'sub N_ {
        my($x) = @_;
	    eval q($x);
    }' unless defined(&N_);
    if(defined(&WITH_VERBOSE_MODE)) {
	eval 'sub meta_debug_spew () { &meta_debug_spew_real;}' unless defined(&meta_debug_spew);
	eval 'sub meta_verbose () { &meta_verbose_real;}' unless defined(&meta_verbose);
	eval 'sub meta_topic () { &meta_topic_real;}' unless defined(&meta_topic);
    } else {
	if(defined(&G_HAVE_ISO_VARARGS)) {
	    eval 'sub meta_debug_spew () {(...);}' unless defined(&meta_debug_spew);
	    eval 'sub meta_verbose () {(...);}' unless defined(&meta_verbose);
	    eval 'sub meta_topic () {(...);}' unless defined(&meta_topic);
	}
 elsif(defined( &G_HAVE_GNUC_VARARGS)) {
	    eval 'sub meta_debug_spew () {( &format...);}' unless defined(&meta_debug_spew);
	    eval 'sub meta_verbose () {( &format...);}' unless defined(&meta_verbose);
	    eval 'sub meta_topic () {( &format...);}' unless defined(&meta_topic);
	} else {
	    die("This compiler does not support varargs macros and thus verbose mode can't be disabled meaningfully");
	}
    }
}
1;
