require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_dbug_h)) {
    eval 'sub _dbug_h () {1;}' unless defined(&_dbug_h);
    if(defined(&__cplusplus)) {
    }
    if(!defined( &DBUG_OFF)  && !defined( &_lint)) {
	eval 'sub DBUG_ENTER {
	    my($a) = @_;
    	    eval q( &const \'char\' * &_db_func_, * &_db_file_; \'uint\'  &_db_level_; \'char\' ** &_db_framep_;  &_db_enter_ ($a, &__FILE__, &__LINE__,& &_db_func_,& &_db_file_,& &_db_level_, & &_db_framep_));
	}' unless defined(&DBUG_ENTER);
	eval 'sub DBUG_LEAVE () {( &_db_return_ ( &__LINE__, & &_db_func_, & &_db_file_, & &_db_level_));}' unless defined(&DBUG_LEAVE);
	eval 'sub DBUG_RETURN {
	    my($a1) = @_;
    	    eval q({ &DBUG_LEAVE;  &return($a1);});
	}' unless defined(&DBUG_RETURN);
	eval 'sub DBUG_VOID_RETURN () {{ &DBUG_LEAVE;  &return;};}' unless defined(&DBUG_VOID_RETURN);
	eval 'sub DBUG_EXECUTE {
	    my($keyword,$a1) = @_;
    	    eval q({ &if ( &_db_on_) { &if ( &_db_keyword_ ($keyword)) { $a1 }}});
	}' unless defined(&DBUG_EXECUTE);
	eval 'sub DBUG_PRINT {
	    my($keyword,$arglist) = @_;
    	    eval q({ &if ( &_db_on_) { &_db_pargs_( &__LINE__,$keyword);  &_db_doprnt_ $arglist;}});
	}' unless defined(&DBUG_PRINT);
	eval 'sub DBUG_PUSH {
	    my($a1) = @_;
    	    eval q( &_db_push_ ($a1));
	}' unless defined(&DBUG_PUSH);
	eval 'sub DBUG_POP () {
	    eval q( &_db_pop_ ());
	}' unless defined(&DBUG_POP);
	eval 'sub DBUG_PROCESS {
	    my($a1) = @_;
    	    eval q(( &_db_process_ = $a1));
	}' unless defined(&DBUG_PROCESS);
	eval 'sub DBUG_FILE () {( &_db_fp_);}' unless defined(&DBUG_FILE);
	eval 'sub DBUG_SETJMP {
	    my($a1) = @_;
    	    eval q(( &_db_setjmp_ (),  &setjmp ($a1)));
	}' unless defined(&DBUG_SETJMP);
	eval 'sub DBUG_LONGJMP {
	    my($a1,$a2) = @_;
    	    eval q(( &_db_longjmp_ (),  &longjmp ($a1, $a2)));
	}' unless defined(&DBUG_LONGJMP);
	eval 'sub DBUG_DUMP {
	    my($keyword,$a1,$a2) = @_;
    	    eval q({ &if ( &_db_on_) { &_db_dump_( &__LINE__,$keyword,$a1,$a2);}});
	}' unless defined(&DBUG_DUMP);
	eval 'sub DBUG_IN_USE () {( &_db_fp_  &&  &_db_fp_ !=  &stderr);}' unless defined(&DBUG_IN_USE);
	eval 'sub DEBUGGER_OFF () { &_no_db_=1; &_db_on_=0;;}' unless defined(&DEBUGGER_OFF);
	eval 'sub DEBUGGER_ON () { &_no_db_=0;}' unless defined(&DEBUGGER_ON);
	eval 'sub DBUG_LOCK_FILE () {{  &_db_lock_file(); };}' unless defined(&DBUG_LOCK_FILE);
	eval 'sub DBUG_UNLOCK_FILE () {{  &_db_unlock_file(); };}' unless defined(&DBUG_UNLOCK_FILE);
	eval 'sub DBUG_ASSERT {
	    my($A) = @_;
    	    eval q( &assert($A));
	}' unless defined(&DBUG_ASSERT);
    } else {
	eval 'sub DBUG_ENTER {
	    my($a1) = @_;
    	    eval q();
	}' unless defined(&DBUG_ENTER);
	eval 'sub DBUG_RETURN {
	    my($a1) = @_;
    	    eval q( &return($a1));
	}' unless defined(&DBUG_RETURN);
	eval 'sub DBUG_VOID_RETURN () { &return;}' unless defined(&DBUG_VOID_RETURN);
	eval 'sub DBUG_EXECUTE {
	    my($keyword,$a1) = @_;
    	    eval q({});
	}' unless defined(&DBUG_EXECUTE);
	eval 'sub DBUG_PRINT {
	    my($keyword,$arglist) = @_;
    	    eval q({});
	}' unless defined(&DBUG_PRINT);
	eval 'sub DBUG_PUSH {
	    my($a1) = @_;
    	    eval q({});
	}' unless defined(&DBUG_PUSH);
	eval 'sub DBUG_POP () {
	    eval q({});
	}' unless defined(&DBUG_POP);
	eval 'sub DBUG_PROCESS {
	    my($a1) = @_;
    	    eval q({});
	}' unless defined(&DBUG_PROCESS);
	eval 'sub DBUG_FILE () {( &stderr);}' unless defined(&DBUG_FILE);
	eval 'sub DBUG_SETJMP () { &setjmp;}' unless defined(&DBUG_SETJMP);
	eval 'sub DBUG_LONGJMP () {\'longjmp\';}' unless defined(&DBUG_LONGJMP);
	eval 'sub DBUG_DUMP {
	    my($keyword,$a1,$a2) = @_;
    	    eval q({});
	}' unless defined(&DBUG_DUMP);
	eval 'sub DBUG_IN_USE () {0;}' unless defined(&DBUG_IN_USE);
	eval 'sub DEBUGGER_OFF () {1;}' unless defined(&DEBUGGER_OFF);
	eval 'sub DEBUGGER_ON () {1;}' unless defined(&DEBUGGER_ON);
	eval 'sub DBUG_LOCK_FILE () {1;}' unless defined(&DBUG_LOCK_FILE);
	eval 'sub DBUG_UNLOCK_FILE () {1;}' unless defined(&DBUG_UNLOCK_FILE);
	eval 'sub DBUG_ASSERT {
	    my($A) = @_;
    	    eval q({});
	}' unless defined(&DBUG_ASSERT);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
