require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_m_ctype_h)) {
    eval 'sub _m_ctype_h () {1;}' unless defined(&_m_ctype_h);
    if(defined(&__cplusplus)) {
    }
    eval 'sub CHARSET_DIR () {"charsets/";}' unless defined(&CHARSET_DIR);
    eval 'sub MY_CHARSET_UNDEFINED () {0;}' unless defined(&MY_CHARSET_UNDEFINED);
    eval 'sub MY_CHARSET_CURRENT () {( ($default_charset_info->{number}));}' unless defined(&MY_CHARSET_CURRENT);
    if(defined(&__WIN__)) {
	require 'ctype.ph';
    }
    eval 'sub _CTYPE_H () {1;}' unless defined(&_CTYPE_H);
    eval 'sub _CTYPE_H_ () {1;}' unless defined(&_CTYPE_H_);
    eval 'sub _CTYPE_INCLUDED () {1;}' unless defined(&_CTYPE_INCLUDED);
    eval 'sub __CTYPE_INCLUDED () {1;}' unless defined(&__CTYPE_INCLUDED);
    eval 'sub _CTYPE_USING () {1;}' unless defined(&_CTYPE_USING);
    eval 'sub _U () {01;}' unless defined(&_U);
    eval 'sub _L () {02;}' unless defined(&_L);
    eval 'sub _N () {04;}' unless defined(&_N);
    eval 'sub _S () {010;}' unless defined(&_S);
    eval 'sub _P () {020;}' unless defined(&_P);
    eval 'sub _C () {040;}' unless defined(&_C);
    eval 'sub _B () {0100;}' unless defined(&_B);
    eval 'sub _X () {0200;}' unless defined(&_X);
    eval 'sub my_ctype () {( ($default_charset_info->{ctype}));}' unless defined(&my_ctype);
    eval 'sub my_to_upper () {( ($default_charset_info->{to_upper}));}' unless defined(&my_to_upper);
    eval 'sub my_to_lower () {( ($default_charset_info->{to_lower}));}' unless defined(&my_to_lower);
    eval 'sub my_sort_order () {( ($default_charset_info->{sort_order}));}' unless defined(&my_sort_order);
    unless(defined(&__WIN__)) {
	eval 'sub _toupper {
	    my($c) = @_;
    	    eval q(  $my_to_upper[ ($c)]);
	}' unless defined(&_toupper);
	eval 'sub _tolower {
	    my($c) = @_;
    	    eval q(  $my_to_lower[ ($c)]);
	}' unless defined(&_tolower);
	eval 'sub toupper {
	    my($c) = @_;
    	    eval q(  $my_to_upper[ ($c)]);
	}' unless defined(&toupper);
	eval 'sub tolower {
	    my($c) = @_;
    	    eval q(  $my_to_lower[ ($c)]);
	}' unless defined(&tolower);
	eval 'sub isalpha {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] & ( &_U |  &_L)));
	}' unless defined(&isalpha);
	eval 'sub isupper {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] &  &_U));
	}' unless defined(&isupper);
	eval 'sub islower {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] &  &_L));
	}' unless defined(&islower);
	eval 'sub isdigit {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] &  &_N));
	}' unless defined(&isdigit);
	eval 'sub isxdigit {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] &  &_X));
	}' unless defined(&isxdigit);
	eval 'sub isalnum {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] & ( &_U |  &_L |  &_N)));
	}' unless defined(&isalnum);
	eval 'sub isspace {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] &  &_S));
	}' unless defined(&isspace);
	eval 'sub ispunct {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] &  &_P));
	}' unless defined(&ispunct);
	eval 'sub isprint {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] & ( &_P |  &_U |  &_L |  &_N |  &_B)));
	}' unless defined(&isprint);
	eval 'sub isgraph {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] & ( &_P |  &_U |  &_L |  &_N)));
	}' unless defined(&isgraph);
	eval 'sub iscntrl {
	    my($c) = @_;
    	    eval q((( &my_ctype+1)[ ($c)] &  &_C));
	}' unless defined(&iscntrl);
	eval 'sub isascii {
	    my($c) = @_;
    	    eval q((!(($c) & ~0177)));
	}' unless defined(&isascii);
	eval 'sub toascii {
	    my($c) = @_;
    	    eval q((($c) & 0177));
	}' unless defined(&toascii);
	if(defined(&ctype)) {
	    undef(&ctype) if defined(&ctype);
	}
    }
    eval 'sub my_isalpha {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] & ( &_U |  &_L)));
    }' unless defined(&my_isalpha);
    eval 'sub my_isupper {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] &  &_U));
    }' unless defined(&my_isupper);
    eval 'sub my_islower {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] &  &_L));
    }' unless defined(&my_islower);
    eval 'sub my_isdigit {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] &  &_N));
    }' unless defined(&my_isdigit);
    eval 'sub my_isxdigit {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] &  &_X));
    }' unless defined(&my_isxdigit);
    eval 'sub my_isalnum {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] & ( &_U |  &_L |  &_N)));
    }' unless defined(&my_isalnum);
    eval 'sub my_isspace {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] &  &_S));
    }' unless defined(&my_isspace);
    eval 'sub my_ispunct {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] &  &_P));
    }' unless defined(&my_ispunct);
    eval 'sub my_isprint {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] & ( &_P |  &_U |  &_L |  &_N |  &_B)));
    }' unless defined(&my_isprint);
    eval 'sub my_isgraph {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] & ( &_P |  &_U |  &_L |  &_N)));
    }' unless defined(&my_isgraph);
    eval 'sub my_iscntrl {
        my($s, $c) = @_;
	    eval q(((-> &ctype+1)[ ($c)] &  &_C));
    }' unless defined(&my_iscntrl);
    eval 'sub use_strcoll {
        my($s) = @_;
	    eval q((($s)-> &strcoll !=  &NULL));
    }' unless defined(&use_strcoll);
    eval 'sub MY_STRXFRM_MULTIPLY () {( ($default_charset_info->{strxfrm_multiply}));}' unless defined(&MY_STRXFRM_MULTIPLY);
    eval 'sub my_strnxfrm {
        my($s, $a, $b, $c, $d) = @_;
	    eval q((($s)-> &strnxfrm(($a), ($b), ($c), ($d))));
    }' unless defined(&my_strnxfrm);
    eval 'sub my_strnncoll {
        my($s, $a, $b, $c, $d) = @_;
	    eval q((($s)-> &strnncoll(($a), ($b), ($c), ($d))));
    }' unless defined(&my_strnncoll);
    eval 'sub my_strxfrm {
        my($s, $a, $b, $c, $d) = @_;
	    eval q((($s)-> &strnxfrm(($a), ($b), ($c))));
    }' unless defined(&my_strxfrm);
    eval 'sub my_strcoll {
        my($s, $a, $b) = @_;
	    eval q((($s)-> &strcoll(($a), ($b))));
    }' unless defined(&my_strcoll);
    eval 'sub my_like_range {
        my($s, $a, $b, $c, $d, $e, $f, $g, $h) = @_;
	    eval q((($s)-> &like_range(($a), ($b), ($c), ($d), ($e), ($f), ($g), ($h))));
    }' unless defined(&my_like_range);
    eval 'sub use_mb {
        my($s) = @_;
	    eval q((($s)-> &ismbchar !=  &NULL));
    }' unless defined(&use_mb);
    eval 'sub MBMAXLEN () {( ($default_charset_info->{mbmaxlen}));}' unless defined(&MBMAXLEN);
    eval 'sub my_ismbchar {
        my($s, $a, $b) = @_;
	    eval q((($s)-> &ismbchar(($a), ($b))));
    }' unless defined(&my_ismbchar);
    eval 'sub my_ismbhead {
        my($s, $a) = @_;
	    eval q((($s)-> &ismbhead(($a))));
    }' unless defined(&my_ismbhead);
    eval 'sub my_mbcharlen {
        my($s, $a) = @_;
	    eval q((($s)-> &mbcharlen(($a))));
    }' unless defined(&my_mbcharlen);
    eval 'sub isvar {
        my($c) = @_;
	    eval q(( &isalnum($c) || ($c) == ord(\'_\')));
    }' unless defined(&isvar);
    eval 'sub isvar_start {
        my($c) = @_;
	    eval q(( &isalpha($c) || ($c) == ord(\'_\')));
    }' unless defined(&isvar_start);
    eval 'sub tocntrl {
        my($c) = @_;
	    eval q((($c) & 31));
    }' unless defined(&tocntrl);
    eval 'sub toprint {
        my($c) = @_;
	    eval q((($c) | 64));
    }' unless defined(&toprint);
    if(defined(&MY_CHARSET_TIS620)) {
	die("The\ TIS620\ charset\ is\ broken\ at\ the\ moment\.\ \ Tell\ tim\ to\ fix\ it\.");
	eval 'sub USE_TIS620 () {1;}' unless defined(&USE_TIS620);
	require 't_ctype.ph';
    }
    if(defined(&__cplusplus)) {
    }
}
1;
