require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_global_h)) {
    eval 'sub _global_h () {1;}' unless defined(&_global_h);
    if(defined( (defined(&__EMX__) ? &__EMX__ : 0))  && !defined( (defined(&MYSQL_SERVER) ? &MYSQL_SERVER : 0))) {
	eval 'sub INCL_BASE () {1;}' unless defined(&INCL_BASE);
	eval 'sub INCL_NOPMAPI () {1;}' unless defined(&INCL_NOPMAPI);
	require 'os2.ph';
    }
    if(defined(&__CYGWIN__)) {
	undef(&WIN) if defined(&WIN);
	undef(&WIN32) if defined(&WIN32);
	undef(&_WIN) if defined(&_WIN);
	undef(&_WIN32) if defined(&_WIN32);
	undef(&_WIN64) if defined(&_WIN64);
	undef(&__WIN__) if defined(&__WIN__);
	undef(&__WIN32__) if defined(&__WIN32__);
	eval 'sub HAVE_ERRNO_AS_DEFINE () {1;}' unless defined(&HAVE_ERRNO_AS_DEFINE);
    }
    if(defined( &_WIN32) || defined( &_WIN64) || defined( &__WIN32__) || defined( &WIN32)) {
	require 'config-win.ph';
    }
 elsif(defined( &OS2)) {
	require 'config-os2.ph';
    } else {
	require 'my_config.ph';
	if(defined( &__cplusplus)  && defined( &inline)) {
	    undef(&inline) if defined(&inline);
	}
    }
    if(defined( &HAVE_LINUXTHREADS)) {
	undef(&_GNU_SOURCE) if defined(&_GNU_SOURCE);
	eval 'sub _GNU_SOURCE () {1;}' unless defined(&_GNU_SOURCE);
    }
    if(defined( &UNDEF_THREADS_HACK)) {
	undef(&THREAD) if defined(&THREAD);
	undef(&HAVE_mit_thread) if defined(&HAVE_mit_thread);
	undef(&HAVE_LINUXTHREADS) if defined(&HAVE_LINUXTHREADS);
	undef(&HAVE_UNIXWARE7_THREADS) if defined(&HAVE_UNIXWARE7_THREADS);
    }
    if(defined(&HAVE_THREADS_WITHOUT_SOCKETS)) {
	undef(&HAVE_SYS_UN_H) if defined(&HAVE_SYS_UN_H);
    }
    eval 'sub __EXTENSIONS__ () {1;}' unless defined(&__EXTENSIONS__);
    unless(defined(&__STDC_EXT__)) {
	eval 'sub __STDC_EXT__ () {1;}' unless defined(&__STDC_EXT__);
    }
    if(defined( &THREAD)  && !defined( &__WIN__)  && !defined( &OS2)) {
	unless(defined(&_POSIX_PTHREAD_SEMANTICS)) {
	    eval 'sub _POSIX_PTHREAD_SEMANTICS () {1;}' unless defined(&_POSIX_PTHREAD_SEMANTICS);
	}
	if(!defined( &SCO)) {
	    eval 'sub _REENTRANT () {1;}' unless defined(&_REENTRANT);
	}
	if(!defined( &_THREAD_SAFE)  && !defined( &_AIX)) {
	    eval 'sub _THREAD_SAFE () {1;}' unless defined(&_THREAD_SAFE);
	}
	unless(defined(&HAVE_mit_thread)) {
	    if(defined(&HAVE_UNIXWARE7_THREADS)) {
		require 'thread.ph';
	    } else {
		require 'pthread.ph';
	    }
	}
	if(!defined( &SCO)  && !defined( &_REENTRANT)) {
	    eval 'sub _REENTRANT () {1;}' unless defined(&_REENTRANT);
	}
    }
    if(defined(&_AIX)) {
	eval 'sub _H_STRINGS () {1;}' unless defined(&_H_STRINGS);
	eval 'sub _SYS_STREAM_H () {1;}' unless defined(&_SYS_STREAM_H);
	eval 'sub _AIX32_CURSES () {1;}' unless defined(&_AIX32_CURSES);
	eval 'sub ulonglong2double {
	    my($A) = @_;
    	    eval q( &my_ulonglong2double($A));
	}' unless defined(&ulonglong2double);
	eval 'sub my_off_t2double {
	    my($A) = @_;
    	    eval q( &my_ulonglong2double($A));
	}' unless defined(&my_off_t2double);
	if(defined(&__cplusplus)) {
	}
	if(defined(&__cplusplus)) {
	}
    }
    if(defined(&HAVE_BROKEN_SNPRINTF)) {
	undef(&HAVE_SNPRINTF) if defined(&HAVE_SNPRINTF);
    }
    if(defined(&HAVE_BROKEN_PREAD)) {
	undef(&HAVE_PREAD) if defined(&HAVE_PREAD);
	undef(&HAVE_PWRITE) if defined(&HAVE_PWRITE);
    }
    if(defined( &HAVE_BROKEN_INLINE)  && !defined( &__cplusplus)) {
	undef(&inline) if defined(&inline);
	eval 'sub inline () {1;}' unless defined(&inline);
    }
    if(defined(&UNDEF_HAVE_GETHOSTBYNAME_R)) {
	undef(&HAVE_GETHOSTBYNAME_R) if defined(&HAVE_GETHOSTBYNAME_R);
    }
    if(defined(&UNDEF_HAVE_INITGROUPS)) {
	undef(&HAVE_INITGROUPS) if defined(&HAVE_INITGROUPS);
    }
    if((defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) == 4 && defined( &__LONG_MAX__)) {
	undef(&__LONG_MAX__) if defined(&__LONG_MAX__);
	eval 'sub __LONG_MAX__ () {2147483647;}' unless defined(&__LONG_MAX__);
    }
    if(defined(&DEFINE_CXA_PURE_VIRTUAL)) {
	eval 'sub FIX_GCC_LINKING_PROBLEM () { &extern "C" { \'int\'  &__cxa_pure_virtual() { &return 0;} };}' unless defined(&FIX_GCC_LINKING_PROBLEM);
    } else {
	eval 'sub FIX_GCC_LINKING_PROBLEM () {1;}' unless defined(&FIX_GCC_LINKING_PROBLEM);
    }
    if(defined( &__GNUC__)  && defined( &__alpha__)  && ! ((defined(&__GNUC__) ? &__GNUC__ : 0) > 2|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 95))) {
	eval 'sub BAD_MEMCPY () {1;}' unless defined(&BAD_MEMCPY);
    }
    if(defined( &HAVE_LINUXTHREADS)  && defined( &__GNUC__)  && defined( &__alpha__)  && ((defined(&__GNUC__) ? &__GNUC__ : 0) > 2|| ( (defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 95))  && !defined( &HAVE_ATOMIC_ADD)) {
	eval 'sub HAVE_ATOMIC_ADD () {1;}' unless defined(&HAVE_ATOMIC_ADD);
	eval 'sub HAVE_ATOMIC_SUB () {1;}' unless defined(&HAVE_ATOMIC_SUB);
    }
    if((defined( &HAVE_LINUXTHREADS)  && defined( &__GNUC__)  && (defined( &__ia64__) || defined( &__powerpc64__))) || !defined( &THREAD)) {
	undef(&HAVE_ATOMIC_ADD) if defined(&HAVE_ATOMIC_ADD);
	undef(&HAVE_ATOMIC_SUB) if defined(&HAVE_ATOMIC_SUB);
    }
    if(defined( &_lint)  && !defined( &lint)) {
	eval 'sub lint () {1;}' unless defined(&lint);
    }
    if((defined(&SIZEOF_LONG_LONG) ? &SIZEOF_LONG_LONG : 0) > 4 && !defined( &_LONG_LONG)) {
	eval 'sub _LONG_LONG () {1;}' unless defined(&_LONG_LONG);
    }
    unless(defined(&stdin)) {
	require 'stdio.ph';
    }
    if(defined(&HAVE_STDLIB_H)) {
	require 'stdlib.ph';
    }
    if(defined(&HAVE_STDDEF_H)) {
	require 'stddef.ph';
    }
    require 'math.ph';
    if(defined(&HAVE_LIMITS_H)) {
	require 'limits.ph';
    }
    if(defined(&HAVE_FLOAT_H)) {
	require 'float.ph';
    }
    if(defined(&HAVE_SYS_TYPES_H)) {
	require 'sys/types.ph';
    }
    if(defined(&HAVE_FCNTL_H)) {
	require 'fcntl.ph';
    }
    if(defined(&HAVE_SYS_TIMEB_H)) {
	require 'sys/timeb.ph';
    }
    if((defined(&TIME_WITH_SYS_TIME) ? &TIME_WITH_SYS_TIME : 0)) {
	require 'sys/time.ph';
	require 'time.ph';
    } else {
	if((defined(&HAVE_SYS_TIME_H) ? &HAVE_SYS_TIME_H : 0)) {
	    require 'sys/time.ph';
	} else {
	    require 'time.ph';
	}
    }
    if(defined(&HAVE_UNISTD_H)) {
	require 'unistd.ph';
    }
    if(defined( &__cplusplus)  && defined( &NO_CPLUSPLUS_ALLOCA)) {
	undef(&HAVE_ALLOCA) if defined(&HAVE_ALLOCA);
	undef(&HAVE_ALLOCA_H) if defined(&HAVE_ALLOCA_H);
    }
    if(defined(&HAVE_ALLOCA_H)) {
	require 'alloca.ph';
    }
    if(defined(&HAVE_ATOMIC_ADD)) {
	eval 'sub __SMP__ () {1;}' unless defined(&__SMP__);
	eval 'sub CONFIG_SMP () {1;}' unless defined(&CONFIG_SMP);
	require 'asm/atomic.ph';
    }
    require 'errno.ph';
    if(defined( &_HPUX_SOURCE)  && defined( &HAVE_SYS_STREAM_H)) {
	require 'sys/stream.ph';
	eval 'sub HAVE_ULONG () {1;}' unless defined(&HAVE_ULONG);
    }
    if(defined(&DONT_USE_FINITE)) {
	undef(&HAVE_FINITE) if defined(&HAVE_FINITE);
    }
    if(defined( &HPUX)  && defined( &_LARGEFILE64_SOURCE)  && defined( &THREAD)) {
	undef(&setrlimit) if defined(&setrlimit);
	eval 'sub setrlimit () { &cma_setrlimit64;}' unless defined(&setrlimit);
    }
    eval 'sub USE_MYFUNC () {1;}' unless defined(&USE_MYFUNC);
    eval 'sub MASTER () {1;}' unless defined(&MASTER);
    eval 'sub ENGLISH () {1;}' unless defined(&ENGLISH);
    eval 'sub POSIX_MISTAKE () {1;}' unless defined(&POSIX_MISTAKE);
    eval 'sub USE_REGEX () {1;}' unless defined(&USE_REGEX);
    unless(defined(&OS2)) {
	eval 'sub USE_BMOVE512 () {1;}' unless defined(&USE_BMOVE512);
    }
    if(defined(&I_AM_PARANOID)) {
	eval 'sub DONT_ALLOW_USER_CHANGE () {1;}' unless defined(&DONT_ALLOW_USER_CHANGE);
	eval 'sub DONT_USE_MYSQL_PWD () {1;}' unless defined(&DONT_USE_MYSQL_PWD);
    }
    unless(defined(&HAVE_BSD_SIGNALS)) {
	eval 'sub DONT_REMEMBER_SIGNAL () {1;}' unless defined(&DONT_REMEMBER_SIGNAL);
    }
    unless(defined(&DONT_DEFINE_VOID)) {
	if(defined(&_lint)) {
	    eval 'sub VOID {
	        my($X) = @_;
    		eval q(( &__void__ = ($X)));
	    }' unless defined(&VOID);
	} else {
	    undef(&VOID) if defined(&VOID);
	    eval 'sub VOID {
	        my($X) = @_;
    		eval q(($X));
	    }' unless defined(&VOID);
	}
    }
    if(defined( &_lint) || defined( &FORCE_INIT_OF_VARS)) {
	eval 'sub LINT_INIT {
	    my($var) = @_;
    	    eval q($var=0);
	}' unless defined(&LINT_INIT);
    } else {
	eval 'sub LINT_INIT {
	    my($var) = @_;
    	    eval q();
	}' unless defined(&LINT_INIT);
    }
    if(defined( &__cplusplus)  && defined( &__GNUC__)) {
	eval 'sub max {
	    my($a, $b) = @_;
    	    eval q((($a) >? ($b)));
	}' unless defined(&max);
	eval 'sub min {
	    my($a, $b) = @_;
    	    eval q((($a) <? ($b)));
	}' unless defined(&min);
    }
 elsif(!defined( &max)) {
	eval 'sub max {
	    my($a, $b) = @_;
    	    eval q((($a) > ($b) ? ($a) : ($b)));
	}' unless defined(&max);
	eval 'sub min {
	    my($a, $b) = @_;
    	    eval q((($a) < ($b) ? ($a) : ($b)));
	}' unless defined(&min);
    }
    if(defined( &__EMX__) || !defined( &HAVE_UINT)) {
    }
    eval 'sub sgn {
        my($a) = @_;
	    eval q(((($a) < 0) ? -1: (($a) > 0) ? 1: 0));
    }' unless defined(&sgn);
    eval 'sub swap {
        my($t,$a,$b) = @_;
	    eval q({  &register $t  &dummy;  &dummy = $a; $a = $b; $b =  &dummy; });
    }' unless defined(&swap);
    eval 'sub test {
        my($a) = @_;
	    eval q((($a) ? 1: 0));
    }' unless defined(&test);
    eval 'sub set_if_bigger {
        my($a,$b) = @_;
	    eval q({  &if (($a) < ($b)) ($a)=($b); });
    }' unless defined(&set_if_bigger);
    eval 'sub set_if_smaller {
        my($a,$b) = @_;
	    eval q({  &if (($a) > ($b)) ($a)=($b); });
    }' unless defined(&set_if_smaller);
    eval 'sub test_all_bits {
        my($a,$b) = @_;
	    eval q(((($a) & ($b)) == ($b)));
    }' unless defined(&test_all_bits);
    eval 'sub set_bits {
        my($type, $bit_count) = @_;
	    eval q(($sizeof{$type}*8<= ($bit_count) ? ~($type) 0: (((($type) 1) << ($bit_count)) - ($type) 1)));
    }' unless defined(&set_bits);
    eval 'sub array_elements {
        my($A) = @_;
	    eval q(( ($sizeof{$A}/$sizeof{$A->[0]})));
    }' unless defined(&array_elements);
    unless(defined(&HAVE_RINT)) {
	eval 'sub rint {
	    my($A) = @_;
    	    eval q( &floor(($A)+0.5));
	}' unless defined(&rint);
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {(1);}' unless defined(&TRUE);
	eval 'sub FALSE () {(0);}' unless defined(&FALSE);
    }
    if(defined( &__GNUC__)) {
	eval 'sub function_volatile () { &volatile;}' unless defined(&function_volatile);
	eval 'sub my_reinterpret_cast {
	    my($A) = @_;
    	    eval q( &reinterpret_cast<$A>);
	}' unless defined(&my_reinterpret_cast);
	eval 'sub my_const_cast {
	    my($A) = @_;
    	    eval q( &const_cast<$A>);
	}' unless defined(&my_const_cast);
    }
 elsif(!defined( &my_reinterpret_cast)) {
	eval 'sub my_reinterpret_cast {
	    my($A) = @_;
    	    eval q(($A));
	}' unless defined(&my_reinterpret_cast);
	eval 'sub my_const_cast {
	    my($A) = @_;
    	    eval q(($A));
	}' unless defined(&my_const_cast);
    }
    if(!defined( &__attribute__)  && (defined( &__cplusplus) || !defined( &__GNUC__) || (defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 8)) {
	eval 'sub __attribute__ {
	    my($A) = @_;
    	    eval q();
	}' unless defined(&__attribute__);
    }
    eval 'sub _VARARGS {
        my($X) = @_;
	    eval q($X);
    }' unless defined(&_VARARGS);
    eval 'sub _STATIC_VARARGS {
        my($X) = @_;
	    eval q($X);
    }' unless defined(&_STATIC_VARARGS);
    eval 'sub _PC {
        my($X) = @_;
	    eval q($X);
    }' unless defined(&_PC);
    if(defined( &DBUG_ON)  && defined( &DBUG_OFF)) {
	undef(&DBUG_OFF) if defined(&DBUG_OFF);
    }
    if(defined( &_lint)  && !defined( &DBUG_OFF)) {
	eval 'sub DBUG_OFF () {1;}' unless defined(&DBUG_OFF);
    }
    require 'dbug.ph';
    unless(defined(&DBUG_OFF)) {
	eval 'sub dbug_assert {
	    my($A) = @_;
    	    eval q( &assert($A));
	}' unless defined(&dbug_assert);
    } else {
	eval 'sub dbug_assert {
	    my($A) = @_;
    	    eval q();
	}' unless defined(&dbug_assert);
    }
    eval 'sub MIN_ARRAY_SIZE () {0;}' unless defined(&MIN_ARRAY_SIZE);
    eval 'sub ASCII_BITS_USED () {8;}' unless defined(&ASCII_BITS_USED);
    eval 'sub NEAR_F () {1;}' unless defined(&NEAR_F);
    unless(defined(&Socket_defined)) {
	eval 'sub INVALID_SOCKET () {-1;}' unless defined(&INVALID_SOCKET);
    }
    eval 'sub sig_handler () { &RETSIGTYPE;}' unless defined(&sig_handler);
    if(defined( &__GNUC__)  && !defined( &_lint)) {
    } else {
    }
    if(defined(&HAVE_mit_thread)) {
	eval 'sub qsort_t () { &void;}' unless defined(&qsort_t);
	undef(&QSORT_TYPE_IS_VOID) if defined(&QSORT_TYPE_IS_VOID);
	eval 'sub QSORT_TYPE_IS_VOID () {1;}' unless defined(&QSORT_TYPE_IS_VOID);
    } else {
	eval 'sub qsort_t () { &RETQSORTTYPE;}' unless defined(&qsort_t);
    }
    if(defined(&HAVE_mit_thread)) {
	eval 'sub size_socket () { &socklen_t;}' unless defined(&size_socket);
    } else {
	if(defined(&HAVE_SYS_SOCKET_H)) {
	    require 'sys/socket.ph';
	}
    }
    unless(defined(&SOCKOPT_OPTLEN_TYPE)) {
	eval 'sub SOCKOPT_OPTLEN_TYPE () { &size_socket;}' unless defined(&SOCKOPT_OPTLEN_TYPE);
    }
    unless(defined(&O_SHARE)) {
	eval 'sub O_SHARE () {0;}' unless defined(&O_SHARE);
	unless(defined(&O_BINARY)) {
	    eval 'sub O_BINARY () {0;}' unless defined(&O_BINARY);
	}
	eval 'sub FILE_BINARY () {0;}' unless defined(&FILE_BINARY);
	if(defined(&HAVE_FCNTL)) {
	    eval 'sub HAVE_FCNTL_LOCK () {1;}' unless defined(&HAVE_FCNTL_LOCK);
	    eval 'sub F_TO_EOF () {0;}' unless defined(&F_TO_EOF);
	}
    }
    unless(defined(&O_TEMPORARY)) {
	eval 'sub O_TEMPORARY () {0;}' unless defined(&O_TEMPORARY);
    }
    unless(defined(&O_SHORT_LIVED)) {
	eval 'sub O_SHORT_LIVED () {0;}' unless defined(&O_SHORT_LIVED);
    }
    unless(defined(&O_NOFOLLOW)) {
	eval 'sub O_NOFOLLOW () {0;}' unless defined(&O_NOFOLLOW);
    }
    eval 'sub UNSINT8 () {1;}' unless defined(&UNSINT8);
    eval 'sub UNSINT16 () {1;}' unless defined(&UNSINT16);
    eval 'sub UNSINT32 () {1;}' unless defined(&UNSINT32);
    eval 'sub SC_MAXWIDTH () {256;}' unless defined(&SC_MAXWIDTH);
    eval 'sub FN_LEN () {256;}' unless defined(&FN_LEN);
    eval 'sub FN_HEADLEN () {253;}' unless defined(&FN_HEADLEN);
    eval 'sub FN_EXTLEN () {20;}' unless defined(&FN_EXTLEN);
    eval 'sub FN_REFLEN () {512;}' unless defined(&FN_REFLEN);
    eval 'sub FN_EXTCHAR () {ord(\'.\');}' unless defined(&FN_EXTCHAR);
    eval 'sub FN_HOMELIB () {ord(\'~\');}' unless defined(&FN_HOMELIB);
    eval 'sub FN_CURLIB () {ord(\'.\');}' unless defined(&FN_CURLIB);
    eval 'sub FN_PARENTDIR () {"..";}' unless defined(&FN_PARENTDIR);
    eval 'sub FN_DEVCHAR () {ord(\':\');}' unless defined(&FN_DEVCHAR);
    unless(defined(&FN_LIBCHAR)) {
	if(defined(&__EMX__)) {
	    eval 'sub FN_LIBCHAR () {ord(\'\\\\\');}' unless defined(&FN_LIBCHAR);
	    eval 'sub FN_ROOTDIR () {"\\\\";}' unless defined(&FN_ROOTDIR);
	} else {
	    eval 'sub FN_LIBCHAR () {ord(\'/\');}' unless defined(&FN_LIBCHAR);
	    eval 'sub FN_ROOTDIR () {"/";}' unless defined(&FN_ROOTDIR);
	}
	eval 'sub MY_NFILE () {1024;}' unless defined(&MY_NFILE);
    }
    eval 'sub IO_SIZE () {4096;}' unless defined(&IO_SIZE);
    if(defined(&SAFEMALLOC)) {
	eval 'sub MALLOC_OVERHEAD () {(8+24+4);}' unless defined(&MALLOC_OVERHEAD);
    } else {
	eval 'sub MALLOC_OVERHEAD () {8;}' unless defined(&MALLOC_OVERHEAD);
    }
    eval 'sub ONCE_ALLOC_INIT () { (4096- &MALLOC_OVERHEAD);}' unless defined(&ONCE_ALLOC_INIT);
    eval 'sub RECORD_CACHE_SIZE () { (64*1024- &MALLOC_OVERHEAD);}' unless defined(&RECORD_CACHE_SIZE);
    eval 'sub KEY_CACHE_SIZE () { (8*1024*1024- &MALLOC_OVERHEAD);}' unless defined(&KEY_CACHE_SIZE);
    eval 'sub ONLY_OWN_DATABASES () {1;}' unless defined(&ONLY_OWN_DATABASES);
    eval 'sub NO_PISAM () {1;}' unless defined(&NO_PISAM);
    eval 'sub NO_MISAM () {1;}' unless defined(&NO_MISAM);
    eval 'sub NO_HASH () {1;}' unless defined(&NO_HASH);
    if(defined(&__WIN__)) {
	eval 'sub NO_DIR_LIBRARY () {1;}' unless defined(&NO_DIR_LIBRARY);
	eval 'sub USE_MY_STAT_STRUCT () {1;}' unless defined(&USE_MY_STAT_STRUCT);
    }
    unless(defined(&HAVE_ITOA)) {
	eval 'sub USE_MY_ITOA () {1;}' unless defined(&USE_MY_ITOA);
    }
    unless(defined(&HAVE_ATOD)) {
	eval 'sub atod () { &atof;}' unless defined(&atod);
    }
    if(defined(&USE_MY_ATOF)) {
	eval 'sub atof () { &my_atof;}' unless defined(&atof);
    }
    undef(&remove) if defined(&remove);
    unless(defined(&__WIN__)) {
	if(defined(&OS2)) {
	    eval 'sub closesocket {
	        my($A) = @_;
    		eval q( &soclose($A));
	    }' unless defined(&closesocket);
	} else {
	    eval 'sub closesocket {
	        my($A) = @_;
    		eval q( &close($A));
	    }' unless defined(&closesocket);
	}
	unless(defined(&ulonglong2double)) {
	    eval 'sub ulonglong2double {
	        my($A) = @_;
    		eval q(( ($A)));
	    }' unless defined(&ulonglong2double);
	    eval 'sub my_off_t2double {
	        my($A) = @_;
    		eval q(( ($A)));
	    }' unless defined(&my_off_t2double);
	}
    }
    unless(defined(&offsetof)) {
	eval 'sub offsetof {
	    my($TYPE, $MEMBER) = @_;
    	    eval q(( (($TYPE *)0)->$MEMBER));
	}' unless defined(&offsetof);
    }
    eval 'sub ulong_to_double {
        my($X) = @_;
	    eval q(( ($X)));
    }' unless defined(&ulong_to_double);
    eval 'sub SET_STACK_SIZE {
        my($X) = @_;
	    eval q();
    }' unless defined(&SET_STACK_SIZE);
    if(!defined( &HAVE_mit_thread)  && !defined( &HAVE_STRTOK_R)) {
	eval 'sub strtok_r {
	    my($A,$B,$C) = @_;
    	    eval q( &strtok(($A),($B)));
	}' unless defined(&strtok_r);
    }
    if(defined(&HAVE_LINUXTHREADS)) {
    }
    if(defined( &HAVE_mit_thread)  && defined( &THREAD)) {
	undef(&HAVE_PREAD) if defined(&HAVE_PREAD);
	undef(&HAVE_REALPATH) if defined(&HAVE_REALPATH);
	undef(&HAVE_MLOCK) if defined(&HAVE_MLOCK);
	undef(&HAVE_TEMPNAM) if defined(&HAVE_TEMPNAM);
	undef(&HAVE_PTHREAD_SETPRIO) if defined(&HAVE_PTHREAD_SETPRIO);
	undef(&HAVE_FTRUNCATE) if defined(&HAVE_FTRUNCATE);
	undef(&HAVE_READLINK) if defined(&HAVE_READLINK);
    }
    if((defined(&SIZEOF_LONG_LONG) ? &SIZEOF_LONG_LONG : 0) > 4) {
	eval 'sub HAVE_LONG_LONG () {1;}' unless defined(&HAVE_LONG_LONG);
    }
    if(defined( &HAVE_LONG_LONG)  && !defined( &LONGLONG_MIN)) {
	eval 'sub LONGLONG_MIN () {( 9.22337203685478e+18);}' unless defined(&LONGLONG_MIN);
	eval 'sub LONGLONG_MAX () {( 9.22337203685478e+18);}' unless defined(&LONGLONG_MAX);
    }
    if((defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) == 4) {
	eval 'sub INT_MIN32 () { 0x80000000;}' unless defined(&INT_MIN32);
	eval 'sub INT_MAX32 () { 0x7fffffff;}' unless defined(&INT_MAX32);
	eval 'sub INT_MIN24 () {( 0xff800000);}' unless defined(&INT_MIN24);
	eval 'sub INT_MAX24 () {0x7fffff;}' unless defined(&INT_MAX24);
	eval 'sub INT_MIN16 () {( 0x8000);}' unless defined(&INT_MIN16);
	eval 'sub INT_MAX16 () {0x7fff;}' unless defined(&INT_MAX16);
	eval 'sub INT_MIN8 () {( 0x80);}' unless defined(&INT_MIN8);
	eval 'sub INT_MAX8 () {( 0x7f);}' unless defined(&INT_MAX8);
    } else {
	eval 'sub INT_MIN32 () {( 0x80000000);}' unless defined(&INT_MIN32);
	eval 'sub INT_MAX32 () {( 0x7fffffff);}' unless defined(&INT_MAX32);
	eval 'sub INT_MIN24 () {( 0xff800000);}' unless defined(&INT_MIN24);
	eval 'sub INT_MAX24 () {( 0x7fffff);}' unless defined(&INT_MAX24);
	eval 'sub INT_MIN16 () {( 0xffff8000);}' unless defined(&INT_MIN16);
	eval 'sub INT_MAX16 () {( 0x7fff);}' unless defined(&INT_MAX16);
    }
    unless(defined(&DBL_MIN)) {
	eval 'sub DBL_MIN () {4.94065645841246544e-324;}' unless defined(&DBL_MIN);
	eval 'sub FLT_MIN () {(1.40129846432481707e-45);}' unless defined(&FLT_MIN);
    }
    unless(defined(&DBL_MAX)) {
	eval 'sub DBL_MAX () {1.79769313486231470e+308;}' unless defined(&DBL_MAX);
	eval 'sub FLT_MAX () {(3.40282346638528860e+38);}' unless defined(&FLT_MAX);
    }
    eval 'sub MY_ALIGN {
        my($A,$L) = @_;
	    eval q(((($A) + ($L) - 1) & ~(($L) - 1)));
    }' unless defined(&MY_ALIGN);
    eval 'sub ALIGN_SIZE {
        my($A) = @_;
	    eval q( &MY_ALIGN(($A),$sizeof{\'double\'}));
    }' unless defined(&ALIGN_SIZE);
    eval 'sub ALIGN_PTR {
        my($A, $t) = @_;
	    eval q((($t*)  &MY_ALIGN(($A),$sizeof{$t})));
    }' unless defined(&ALIGN_PTR);
    eval 'sub OFFSET {
        my($t, $f) = @_;
	    eval q(((($t *)0)->$f));
    }' unless defined(&OFFSET);
    eval 'sub ADD_TO_PTR {
        my($ptr,$size,$type) = @_;
	    eval q(($type) (( &byte*) ($ptr)+$size));
    }' unless defined(&ADD_TO_PTR);
    eval 'sub PTR_BYTE_DIFF {
        my($A,$B) = @_;
	    eval q(( &my_ptrdiff_t) (( &byte*) ($A) - ( &byte*) ($B)));
    }' unless defined(&PTR_BYTE_DIFF);
    eval 'sub NullS () { 0;}' unless defined(&NullS);
    unless(defined(&NEAR)) {
	eval 'sub NEAR () {1;}' unless defined(&NEAR);
	eval 'sub FAR () {1;}' unless defined(&FAR);
	unless(defined(&HUGE_PTR)) {
	    eval 'sub HUGE_PTR () {1;}' unless defined(&HUGE_PTR);
	}
    }
    if(defined( &__IBMC__) || defined( &__IBMCPP__)) {
	eval 'sub STDCALL () { &_System  &_Export;}' unless defined(&STDCALL);
    }
 elsif(!defined( (defined(&STDCALL) ? &STDCALL : 0))) {
	eval 'sub STDCALL () {1;}' unless defined(&STDCALL);
    }
    if(defined( &VOIDTYPE)) {
    } else {
    }
    unless(defined(&HAVE_INT_8_16_32)) {
    }
    unless(defined(&HAVE_UCHAR)) {
    }
    if((defined(&SIZEOF_INT) ? &SIZEOF_INT : 0) == 4) {
	unless(defined(&HAVE_INT_8_16_32)) {
	}
    }
 elsif((defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) == 4) {
	unless(defined(&HAVE_INT_8_16_32)) {
	}
    } else {
    }
    if(!defined( &HAVE_ULONG)  && !defined( &HAVE_LINUXTHREADS)  && !defined( &__USE_MISC)) {
    }
    unless(defined(&longlong_defined)) {
	if(defined( &HAVE_LONG_LONG)  && (defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) != 8) {
	} else {
	}
    }
    if(defined(&USE_RAID)) {
	if((defined(&SIZEOF_OFF_T) ? &SIZEOF_OFF_T : 0) == 4) {
	    eval 'sub SYSTEM_SIZEOF_OFF_T () {4;}' unless defined(&SYSTEM_SIZEOF_OFF_T);
	} else {
	    eval 'sub SYSTEM_SIZEOF_OFF_T () {8;}' unless defined(&SYSTEM_SIZEOF_OFF_T);
	}
	undef(&SIZEOF_OFF_T) if defined(&SIZEOF_OFF_T);
	eval 'sub SIZEOF_OFF_T () {8;}' unless defined(&SIZEOF_OFF_T);
    } else {
	eval 'sub SYSTEM_SIZEOF_OFF_T () { &SIZEOF_OFF_T;}' unless defined(&SYSTEM_SIZEOF_OFF_T);
    }
    if((defined(&SIZEOF_OFF_T) ? &SIZEOF_OFF_T : 0) > 4) {
    } else {
    }
    eval 'sub MY_FILEPOS_ERROR () {(~( &my_off_t) 0);}' unless defined(&MY_FILEPOS_ERROR);
    if(!defined( &__WIN__)  && !defined( &OS2)) {
    }
    if(defined( &__WIN__)) {
	eval 'sub socket_errno () { &WSAGetLastError();}' unless defined(&socket_errno);
	eval 'sub SOCKET_EINTR () { &WSAEINTR;}' unless defined(&SOCKET_EINTR);
	eval 'sub SOCKET_EAGAIN () { &WSAEINPROGRESS;}' unless defined(&SOCKET_EAGAIN);
	eval 'sub SOCKET_ENFILE () { &ENFILE;}' unless defined(&SOCKET_ENFILE);
	eval 'sub SOCKET_EMFILE () { &EMFILE;}' unless defined(&SOCKET_EMFILE);
    }
 elsif(defined( &OS2)) {
	eval 'sub socket_errno () { &sock_errno();}' unless defined(&socket_errno);
	eval 'sub SOCKET_EINTR () { &SOCEINTR;}' unless defined(&SOCKET_EINTR);
	eval 'sub SOCKET_EAGAIN () { &SOCEINPROGRESS;}' unless defined(&SOCKET_EAGAIN);
	eval 'sub SOCKET_EWOULDBLOCK () { &SOCEWOULDBLOCK;}' unless defined(&SOCKET_EWOULDBLOCK);
	eval 'sub SOCKET_ENFILE () { &SOCENFILE;}' unless defined(&SOCKET_ENFILE);
	eval 'sub SOCKET_EMFILE () { &SOCEMFILE;}' unless defined(&SOCKET_EMFILE);
	eval 'sub closesocket {
	    my($A) = @_;
    	    eval q( &soclose($A));
	}' unless defined(&closesocket);
    } else {
	eval 'sub socket_errno () { &errno;}' unless defined(&socket_errno);
	eval 'sub closesocket {
	    my($A) = @_;
    	    eval q( &close($A));
	}' unless defined(&closesocket);
	eval 'sub SOCKET_EINTR () { &EINTR;}' unless defined(&SOCKET_EINTR);
	eval 'sub SOCKET_EAGAIN () { &EAGAIN;}' unless defined(&SOCKET_EAGAIN);
	eval 'sub SOCKET_EWOULDBLOCK () { &EWOULDBLOCK;}' unless defined(&SOCKET_EWOULDBLOCK);
	eval 'sub SOCKET_ENFILE () { &ENFILE;}' unless defined(&SOCKET_ENFILE);
	eval 'sub SOCKET_EMFILE () { &EMFILE;}' unless defined(&SOCKET_EMFILE);
    }
    unless(defined(&byte_defined)) {
    }
    if(!defined( &bool)  && !defined( &bool_defined)  && (!defined( &HAVE_BOOL) || !defined( &__cplusplus))) {
    }
    eval 'sub INT8 {
        my($v) = @_;
	    eval q(( &int8) ($v));
    }' unless defined(&INT8);
    eval 'sub INT16 {
        my($v) = @_;
	    eval q(( &int16) ($v));
    }' unless defined(&INT16);
    eval 'sub INT32 {
        my($v) = @_;
	    eval q(( &int32) ($v));
    }' unless defined(&INT32);
    eval 'sub MYF {
        my($v) = @_;
	    eval q(( &myf) ($v));
    }' unless defined(&MYF);
    unless(defined(&USING_X)) {
	eval 'sub reg1 () { &register;}' unless defined(&reg1);
	eval 'sub reg2 () { &register;}' unless defined(&reg2);
	eval 'sub reg3 () { &register;}' unless defined(&reg3);
	eval 'sub reg4 () { &register;}' unless defined(&reg4);
	eval 'sub reg5 () { &register;}' unless defined(&reg5);
	eval 'sub reg6 () { &register;}' unless defined(&reg6);
	eval 'sub reg7 () { &register;}' unless defined(&reg7);
	eval 'sub reg8 () { &register;}' unless defined(&reg8);
	eval 'sub reg9 () { &register;}' unless defined(&reg9);
	eval 'sub reg10 () { &register;}' unless defined(&reg10);
	eval 'sub reg11 () { &register;}' unless defined(&reg11);
	eval 'sub reg12 () { &register;}' unless defined(&reg12);
	eval 'sub reg13 () { &register;}' unless defined(&reg13);
	eval 'sub reg14 () { &register;}' unless defined(&reg14);
	eval 'sub reg15 () { &register;}' unless defined(&reg15);
	eval 'sub reg16 () { &register;}' unless defined(&reg16);
    }
    eval 'sub SCALE_SEC () {100;}' unless defined(&SCALE_SEC);
    eval 'sub SCALE_USEC () {10000;}' unless defined(&SCALE_USEC);
    eval 'sub MY_HOW_OFTEN_TO_ALARM () {2;}' unless defined(&MY_HOW_OFTEN_TO_ALARM);
    eval 'sub MY_HOW_OFTEN_TO_WRITE () {1000;}' unless defined(&MY_HOW_OFTEN_TO_WRITE);
    if(defined(&__i386__)) {
	eval 'sub sint2korr {
	    my($A) = @_;
    	    eval q((*(( &int16 *) ($A))));
	}' unless defined(&sint2korr);
	eval 'sub sint3korr {
	    my($A) = @_;
    	    eval q((( &int32) ((( ($A)[2]) & 128) ? ((( &uint32) 255 << 24) | ((( &uint32) ($A)[2]) << 16) | ((( &uint32) ($A)[1]) << 8) | (( &uint32) ($A)[0])) : ((( &uint32) ($A)[2]) << 16) | ((( &uint32) ($A)[1]) << 8) | (( &uint32) ($A)[0]))));
	}' unless defined(&sint3korr);
	eval 'sub sint4korr {
	    my($A) = @_;
    	    eval q((*( ($A))));
	}' unless defined(&sint4korr);
	eval 'sub uint2korr {
	    my($A) = @_;
    	    eval q((*(( &uint16 *) ($A))));
	}' unless defined(&uint2korr);
	eval 'sub uint3korr {
	    my($A) = @_;
    	    eval q( (*( ($A)) & 0xffffff));
	}' unless defined(&uint3korr);
	eval 'sub uint4korr {
	    my($A) = @_;
    	    eval q((*( ($A))));
	}' unless defined(&uint4korr);
	eval 'sub uint5korr {
	    my($A) = @_;
    	    eval q((((( &uint32) ( ($A)[0])) + ((( &uint32) ( ($A)[1])) << 8) + ((( &uint32) ( ($A)[2])) << 16) + ((( &uint32) ( [3])) << 24)) + (( ( ($A)[4])) << 32)));
	}' unless defined(&uint5korr);
	eval 'sub uint8korr {
	    my($A) = @_;
    	    eval q((*( ($A))));
	}' unless defined(&uint8korr);
	eval 'sub sint8korr {
	    my($A) = @_;
    	    eval q((*( ($A))));
	}' unless defined(&sint8korr);
	eval 'sub int2store {
	    my($T,$A) = @_;
    	    eval q(*(( &uint16*) ($T))= ( &uint16) ($A));
	}' unless defined(&int2store);
	eval 'sub int3store {
	    my($T,$A) = @_;
    	    eval q({ *= (); *($T+1)= (( >> 8)); *($T+2)= ((($A) >> 16)); });
	}' unless defined(&int3store);
	eval 'sub int4store {
	    my($T,$A) = @_;
    	    eval q(*= ($A));
	}' unless defined(&int4store);
	eval 'sub int5store {
	    my($T,$A) = @_;
    	    eval q({ *= (); *(+1)= (( >> 8)); *(+2)= (( >> 16)); *(+3)= (( >> 24)); *(+4)= ((($A) >> 32)); });
	}' unless defined(&int5store);
	eval 'sub int8store {
	    my($T,$A) = @_;
    	    eval q(*= ($A));
	}' unless defined(&int8store);
	eval 'sub doubleget {
	    my($V,$M) = @_;
    	    eval q({  &doubleget_union  &_tmp;  ($_tmp->{m[0]}) = *();  ($_tmp->{m[1]}) = *(( ($M))+1); ($V) =  ($_tmp->{v}); });
	}' unless defined(&doubleget);
	eval 'sub doublestore {
	    my($T,$V) = @_;
    	    eval q({ * = ($V)-> $m[0]; *(( $T)+1) = (( &doubleget_union *)$V)-> $m[1]; });
	}' unless defined(&doublestore);
	eval 'sub float4get {
	    my($V,$M) = @_;
    	    eval q({ *( ) = *( ($M)); });
	}' unless defined(&float4get);
	eval 'sub float8get {
	    my($V,$M) = @_;
    	    eval q( &doubleget(($V),($M)));
	}' unless defined(&float8get);
	eval 'sub float4store {
	    my($V,$M) = @_;
    	    eval q( &memcpy(( &byte*) $V,( &byte*) ($M),$sizeof{\'float\'}));
	}' unless defined(&float4store);
	eval 'sub float8store {
	    my($V,$M) = @_;
    	    eval q( &doublestore(($V),($M)));
	}' unless defined(&float8store);
    }
    unless(defined(&sint2korr)) {
	eval 'sub sint2korr {
	    my($A) = @_;
    	    eval q(( &int16) ((( &int16) ( ($A)[0])) + (( &int16) (( &int16) ($A)[1]) << 8)));
	}' unless defined(&sint2korr);
	eval 'sub sint3korr {
	    my($A) = @_;
    	    eval q((( &int32) ((( ($A)[2]) & 128) ? ((( &uint32) 255 << 24) | ((( &uint32) ($A)[2]) << 16) | ((( &uint32) ($A)[1]) << 8) | (( &uint32) ($A)[0])) : ((( &uint32) ($A)[2]) << 16) | ((( &uint32) ($A)[1]) << 8) | (( &uint32) ($A)[0]))));
	}' unless defined(&sint3korr);
	eval 'sub sint4korr {
	    my($A) = @_;
    	    eval q(( &int32) ((( &int32) ( ($A)[0])) + ((( &int32) ( ($A)[1]) << 8)) + ((( &int32) ( ($A)[2]) << 16)) + ((( &int32) (( &int16) ($A)[3]) << 24))));
	}' unless defined(&sint4korr);
	eval 'sub sint8korr {
	    my($A) = @_;
    	    eval q(  &uint8korr($A));
	}' unless defined(&sint8korr);
	eval 'sub uint2korr {
	    my($A) = @_;
    	    eval q(( &uint16) ((( &uint16) ( ($A)[0])) + (( &uint16) ( ($A)[1]) << 8)));
	}' unless defined(&uint2korr);
	eval 'sub uint3korr {
	    my($A) = @_;
    	    eval q(( &uint32) ((( &uint32) ( ($A)[0])) + ((( &uint32) ( ($A)[1])) << 8) + ((( &uint32) ( ($A)[2])) << 16)));
	}' unless defined(&uint3korr);
	eval 'sub uint4korr {
	    my($A) = @_;
    	    eval q(( &uint32) ((( &uint32) ( ($A)[0])) + ((( &uint32) ( ($A)[1])) << 8) + ((( &uint32) ( ($A)[2])) << 16) + ((( &uint32) ( ($A)[3])) << 24)));
	}' unless defined(&uint4korr);
	eval 'sub uint5korr {
	    my($A) = @_;
    	    eval q((((( &uint32) ( ($A)[0])) + ((( &uint32) ( ($A)[1])) << 8) + ((( &uint32) ( ($A)[2])) << 16) + ((( &uint32) ( [3])) << 24)) + (( ( ($A)[4])) << 32)));
	}' unless defined(&uint5korr);
	eval 'sub uint8korr {
	    my($A) = @_;
    	    eval q((((( &uint32) ( ($A)[0])) + ((( &uint32) ( ($A)[1])) << 8) + ((( &uint32) ( ($A)[2])) << 16) + ((( &uint32) ( [3])) << 24)) + (( ((( &uint32) ( ($A)[4])) + ((( &uint32) ( ($A)[5])) << 8) + ((( &uint32) ( ($A)[6])) << 16) + ((( &uint32) ( ($A)[7])) << 24))) << 32)));
	}' unless defined(&uint8korr);
	eval 'sub int2store {
	    my($T,$A) = @_;
    	    eval q({ \'uint\'  &def_temp= ; *= ; *( ($T+1))=(( &def_temp >> 8)); });
	}' unless defined(&int2store);
	eval 'sub int3store {
	    my($T,$A) = @_;
    	    eval q({ *()= (); *(+1)= (( >> 8)); *(+2)= ((($A) >> 16)); });
	}' unless defined(&int3store);
	eval 'sub int4store {
	    my($T,$A) = @_;
    	    eval q({ *= (); *(+1)= (( >> 8)); *(+2)= (( >> 16)); *(+3)= ((($A) >> 24)); });
	}' unless defined(&int4store);
	eval 'sub int5store {
	    my($T,$A) = @_;
    	    eval q({ *($T)=(($A)); *(($T)+1)=((($A) >> 8)); *(($T)+2)=((($A) >> 16)); *(($T)+3)=((($A) >> 24)); *(($T)+4)=((($A) >> 32)); });
	}' unless defined(&int5store);
	eval 'sub int8store {
	    my($T,$A) = @_;
    	    eval q({ \'uint\'  &def_temp= ,  &def_temp2= (($A) >> 32);  &int4store(($T), &def_temp);  &int4store(($T+4), &def_temp2); });
	}' unless defined(&int8store);
	if(defined(&WORDS_BIGENDIAN)) {
	    eval 'sub float4store {
	        my($T,$A) = @_;
    		eval q({ *= ( $A)[3]; *(+1)= ( $A)[2]; *(+2)= ( $A)[1]; *(+3)= (( &byte *) $A)[0]; });
	    }' unless defined(&float4store);
	    eval 'sub float4get {
	        my($V,$M) = @_;
    		eval q({ \'float\'  &def_temp; (( &byte*)  &def_temp)[0]=($M)[3]; (( &byte*)  &def_temp)[1]=($M)[2]; (( &byte*)  &def_temp)[2]=($M)[1]; (( &byte*)  &def_temp)[3]=($M)[0]; ($V)= &def_temp; });
	    }' unless defined(&float4get);
	    eval 'sub float8store {
	        my($T,$V) = @_;
    		eval q({ *= ( $V)[7]; *(+1)= ( $V)[6]; *(+2)= ( $V)[5]; *(+3)= ( $V)[4]; *(+4)= ( $V)[3]; *(+5)= ( $V)[2]; *(+6)= ( $V)[1]; *(+7)= (( &byte *) $V)[0]; });
	    }' unless defined(&float8store);
	    eval 'sub float8get {
	        my($V,$M) = @_;
    		eval q({ \'double\'  &def_temp; (( &byte*)  &def_temp)[0]=($M)[7]; (( &byte*)  &def_temp)[1]=($M)[6]; (( &byte*)  &def_temp)[2]=($M)[5]; (( &byte*)  &def_temp)[3]=($M)[4]; (( &byte*)  &def_temp)[4]=($M)[3]; (( &byte*)  &def_temp)[5]=($M)[2]; (( &byte*)  &def_temp)[6]=($M)[1]; (( &byte*)  &def_temp)[7]=($M)[0]; ($V) =  &def_temp; });
	    }' unless defined(&float8get);
	} else {
	    eval 'sub float4get {
	        my($V,$M) = @_;
    		eval q( &memcpy_fixed(( &byte*) $V,( &byte*) ($M),$sizeof{\'float\'}));
	    }' unless defined(&float4get);
	    eval 'sub float4store {
	        my($V,$M) = @_;
    		eval q( &memcpy_fixed(( &byte*) $V,( &byte*) ($M),$sizeof{\'float\'}));
	    }' unless defined(&float4store);
	    if(defined( &__FLOAT_WORD_ORDER)  && ((defined(&__FLOAT_WORD_ORDER) ? &__FLOAT_WORD_ORDER : 0) == (defined(&__BIG_ENDIAN) ? &__BIG_ENDIAN : 0))) {
		eval 'sub doublestore {
		    my($T,$V) = @_;
    		    eval q({ *= ( $V)[4]; *(+1)= ( $V)[5]; *(+2)= ( $V)[6]; *(+3)= ( $V)[7]; *(+4)= ( $V)[0]; *(+5)= ( $V)[1]; *(+6)= ( $V)[2]; *(+7)= (( &byte *) $V)[3]; });
		}' unless defined(&doublestore);
		eval 'sub doubleget {
		    my($V,$M) = @_;
    		    eval q({ \'double\'  &def_temp; (( &byte*)  &def_temp)[0]=($M)[4]; (( &byte*)  &def_temp)[1]=($M)[5]; (( &byte*)  &def_temp)[2]=($M)[6]; (( &byte*)  &def_temp)[3]=($M)[7]; (( &byte*)  &def_temp)[4]=($M)[0]; (( &byte*)  &def_temp)[5]=($M)[1]; (( &byte*)  &def_temp)[6]=($M)[2]; (( &byte*)  &def_temp)[7]=($M)[3]; ($V) =  &def_temp; });
		}' unless defined(&doubleget);
	    }
	    eval 'sub float8get {
	        my($V,$M) = @_;
    		eval q( &doubleget(($V),($M)));
	    }' unless defined(&float8get);
	    eval 'sub float8store {
	        my($V,$M) = @_;
    		eval q( &doublestore(($V),($M)));
	    }' unless defined(&float8store);
	}
    }
    if(defined(&WORDS_BIGENDIAN)) {
	eval 'sub ushortget {
	    my($V,$M) = @_;
    	    eval q({ $V = ( &uint16) ((( &uint16) ( ($M)[1]))+ (( &uint16) (( &uint16) ($M)[0]) << 8)); });
	}' unless defined(&ushortget);
	eval 'sub shortget {
	    my($V,$M) = @_;
    	    eval q({ $V = (( ( [1]))+ ( ( ($M)[0]) << 8)); });
	}' unless defined(&shortget);
	eval 'sub longget {
	    my($V,$M) = @_;
    	    eval q({  &int32  &def_temp; (( &byte*)  &def_temp)[0]=($M)[0]; (( &byte*)  &def_temp)[1]=($M)[1]; (( &byte*)  &def_temp)[2]=($M)[2]; (( &byte*)  &def_temp)[3]=($M)[3]; ($V)= &def_temp; });
	}' unless defined(&longget);
	eval 'sub ulongget {
	    my($V,$M) = @_;
    	    eval q({  &uint32  &def_temp; (( &byte*)  &def_temp)[0]=($M)[0]; (( &byte*)  &def_temp)[1]=($M)[1]; (( &byte*)  &def_temp)[2]=($M)[2]; (( &byte*)  &def_temp)[3]=($M)[3]; ($V)= &def_temp; });
	}' unless defined(&ulongget);
	eval 'sub shortstore {
	    my($T,$A) = @_;
    	    eval q({ \'uint\'  &def_temp= ; *($T+1)=; *($T+0)=( &def_temp >> 8); });
	}' unless defined(&shortstore);
	eval 'sub longstore {
	    my($T,$A) = @_;
    	    eval q({ *(($T)+3)=(($A)); *(($T)+2)=((($A) >> 8)); *(($T)+1)=((($A) >> 16)); *(($T)+0)=((($A) >> 24)); });
	}' unless defined(&longstore);
	eval 'sub doubleget {
	    my($V,$M) = @_;
    	    eval q( &memcpy(( &byte*) $V,( &byte*) ($M),$sizeof{\'double\'}));
	}' unless defined(&doubleget);
	eval 'sub doublestore {
	    my($T,$V) = @_;
    	    eval q( &memcpy(( &byte*) ($T),( &byte*) $V,$sizeof{\'double\'}));
	}' unless defined(&doublestore);
	eval 'sub longlongget {
	    my($V,$M) = @_;
    	    eval q( &memcpy(( &byte*) $V,( &byte*) ($M),$sizeof{\'ulonglong\'}));
	}' unless defined(&longlongget);
	eval 'sub longlongstore {
	    my($T,$V) = @_;
    	    eval q( &memcpy(( &byte*) ($T),( &byte*) $V,$sizeof{\'ulonglong\'}));
	}' unless defined(&longlongstore);
    } else {
	eval 'sub ushortget {
	    my($V,$M) = @_;
    	    eval q({ $V =  &uint2korr($M); });
	}' unless defined(&ushortget);
	eval 'sub shortget {
	    my($V,$M) = @_;
    	    eval q({ $V =  &sint2korr($M); });
	}' unless defined(&shortget);
	eval 'sub longget {
	    my($V,$M) = @_;
    	    eval q({ $V =  &sint4korr($M); });
	}' unless defined(&longget);
	eval 'sub ulongget {
	    my($V,$M) = @_;
    	    eval q({ $V =  &uint4korr($M); });
	}' unless defined(&ulongget);
	eval 'sub shortstore {
	    my($T,$V) = @_;
    	    eval q( &int2store($T,$V));
	}' unless defined(&shortstore);
	eval 'sub longstore {
	    my($T,$V) = @_;
    	    eval q( &int4store($T,$V));
	}' unless defined(&longstore);
	unless(defined(&doubleget)) {
	    eval 'sub doubleget {
	        my($V,$M) = @_;
    		eval q( &memcpy_fixed(( &byte*) $V,( &byte*) ($M),$sizeof{\'double\'}));
	    }' unless defined(&doubleget);
	    eval 'sub doublestore {
	        my($T,$V) = @_;
    		eval q( &memcpy_fixed(( &byte*) ($T),( &byte*) $V,$sizeof{\'double\'}));
	    }' unless defined(&doublestore);
	}
	eval 'sub longlongget {
	    my($V,$M) = @_;
    	    eval q( &memcpy_fixed(( &byte*) $V,( &byte*) ($M),$sizeof{\'ulonglong\'}));
	}' unless defined(&longlongget);
	eval 'sub longlongstore {
	    my($T,$V) = @_;
    	    eval q( &memcpy_fixed(( &byte*) ($T),( &byte*) $V,$sizeof{\'ulonglong\'}));
	}' unless defined(&longlongstore);
    }
    if(defined(&SPRINTF_RETURNS_INT)) {
	eval 'sub my_sprintf {
	    my($buff,$args) = @_;
    	    eval q( &sprintf $args);
	}' unless defined(&my_sprintf);
    } else {
	if(defined(&SPRINTF_RETURNS_PTR)) {
	    eval 'sub my_sprintf {
	        my($buff,$args) = @_;
    		eval q((( &sprintf $args - $buff)));
	    }' unless defined(&my_sprintf);
	} else {
	    eval 'sub my_sprintf {
	        my($buff,$args) = @_;
    		eval q( &sprintf $args, &strlen($buff));
	    }' unless defined(&my_sprintf);
	}
    }
    unless(defined(&THREAD)) {
	eval 'sub thread_safe_increment {
	    my($V,$L) = @_;
    	    eval q(($V)++);
	}' unless defined(&thread_safe_increment);
	eval 'sub thread_safe_add {
	    my($V,$C,$L) = @_;
    	    eval q(($V)+=($C));
	}' unless defined(&thread_safe_add);
	eval 'sub thread_safe_sub {
	    my($V,$C,$L) = @_;
    	    eval q(($V)-=($C));
	}' unless defined(&thread_safe_sub);
	eval 'sub statistic_increment {
	    my($V,$L) = @_;
    	    eval q(($V)++);
	}' unless defined(&statistic_increment);
	eval 'sub statistic_add {
	    my($V,$C,$L) = @_;
    	    eval q(($V)+=($C));
	}' unless defined(&statistic_add);
    }
}
1;
