require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_my_pthread_h)) {
    eval 'sub _my_pthread_h () {1;}' unless defined(&_my_pthread_h);
    require 'errno.ph';
    unless(defined(&ETIME)) {
	eval 'sub ETIME () { &ETIMEDOUT;}' unless defined(&ETIME);
    }
    if(defined(&__cplusplus)) {
    }
    if(defined( &__WIN__) || defined( &OS2)) {
	if(defined(&OS2)) {
	}
	if(defined(&OS2)) {
	} else {
	}
	if(defined(&OS2)) {
	} else {
	}
	unless(defined(&OS2)) {
	}
	eval 'sub win_pthread_self () { ($my_thread_var->{pthread_self});}' unless defined(&win_pthread_self);
	if(defined(&OS2)) {
	    eval 'sub pthread_handler_decl {
	        my($A,$B) = @_;
    		eval q( &void *  &_Optlink $A( &void *$B));
	    }' unless defined(&pthread_handler_decl);
	} else {
	    eval 'sub pthread_handler_decl {
	        my($A,$B) = @_;
    		eval q( &void *  &__cdecl $A( &void *$B));
	    }' unless defined(&pthread_handler_decl);
	}
	unless(defined(&OS2)) {
	    eval 'sub ETIMEDOUT () {145;}' unless defined(&ETIMEDOUT);
	    eval 'sub getpid () {
	        eval q( &GetCurrentThreadId());
	    }' unless defined(&getpid);
	}
	eval 'sub pthread_self () {
	    eval q( &win_pthread_self);
	}' unless defined(&pthread_self);
	eval 'sub HAVE_LOCALTIME_R () {1;}' unless defined(&HAVE_LOCALTIME_R);
	eval 'sub _REENTRANT () {1;}' unless defined(&_REENTRANT);
	eval 'sub HAVE_PTHREAD_ATTR_SETSTACKSIZE () {1;}' unless defined(&HAVE_PTHREAD_ATTR_SETSTACKSIZE);
	if(defined(&USE_TLS)) {
	    undef(&SAFE_MUTEX) if defined(&SAFE_MUTEX);
	    eval 'sub pthread_key {
	        my($T,$V) = @_;
    		eval q( &DWORD $V);
	    }' unless defined(&pthread_key);
	    eval 'sub pthread_key_create {
	        my($A,$B) = @_;
    		eval q(((*$A= &TlsAlloc())==0xffffffff));
	    }' unless defined(&pthread_key_create);
	    eval 'sub pthread_getspecific {
	        my($A) = @_;
    		eval q(( &TlsGetValue($A)));
	    }' unless defined(&pthread_getspecific);
	    eval 'sub my_pthread_getspecific {
	        my($T,$A) = @_;
    		eval q((($T)  &TlsGetValue($A)));
	    }' unless defined(&my_pthread_getspecific);
	    eval 'sub my_pthread_getspecific_ptr {
	        my($T,$V) = @_;
    		eval q((($T)  &TlsGetValue($V)));
	    }' unless defined(&my_pthread_getspecific_ptr);
	    eval 'sub my_pthread_setspecific_ptr {
	        my($T,$V) = @_;
    		eval q((! &TlsSetValue(($T),($V))));
	    }' unless defined(&my_pthread_setspecific_ptr);
	    eval 'sub pthread_setspecific {
	        my($A,$B) = @_;
    		eval q((! &TlsSetValue(($A),($B))));
	    }' unless defined(&pthread_setspecific);
	} else {
	    eval 'sub pthread_key {
	        my($T,$V) = @_;
    		eval q( &__declspec( &thread) $T $V);
	    }' unless defined(&pthread_key);
	    eval 'sub pthread_key_create {
	        my($A,$B) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_key_create);
	    eval 'sub pthread_getspecific {
	        my($A) = @_;
    		eval q((($A)));
	    }' unless defined(&pthread_getspecific);
	    eval 'sub my_pthread_getspecific {
	        my($T,$A) = @_;
    		eval q((($A)));
	    }' unless defined(&my_pthread_getspecific);
	    eval 'sub my_pthread_getspecific_ptr {
	        my($T,$V) = @_;
    		eval q(($V));
	    }' unless defined(&my_pthread_getspecific_ptr);
	    eval 'sub my_pthread_setspecific_ptr {
	        my($T,$V) = @_;
    		eval q((($T)=($V),0));
	    }' unless defined(&my_pthread_setspecific_ptr);
	    eval 'sub pthread_setspecific {
	        my($A,$B) = @_;
    		eval q( &win_pthread_setspecific(($A),($B),$sizeof{$A}));
	    }' unless defined(&pthread_setspecific);
	}
	eval 'sub pthread_equal {
	    my($A,$B) = @_;
    	    eval q((($A) == ($B)));
	}' unless defined(&pthread_equal);
	if(defined(&OS2)) {
	    eval 'sub my_pthread_setprio {
	        my($A,$B) = @_;
    		eval q( &DosSetPriority( &PRTYS_THREAD, &PRTYC_NOCHANGE, $B, $A));
	    }' unless defined(&my_pthread_setprio);
	    eval 'sub pthread_kill {
	        my($A,$B) = @_;
    		eval q( &raise($B));
	    }' unless defined(&pthread_kill);
	    eval 'sub pthread_exit {
	        my($A) = @_;
    		eval q( &pthread_dummy());
	    }' unless defined(&pthread_exit);
	} else {
	    eval 'sub pthread_mutex_init {
	        my($A,$B) = @_;
    		eval q( &InitializeCriticalSection($A));
	    }' unless defined(&pthread_mutex_init);
	    eval 'sub pthread_mutex_lock {
	        my($A) = @_;
    		eval q(( &EnterCriticalSection($A),0));
	    }' unless defined(&pthread_mutex_lock);
	    eval 'sub pthread_mutex_trylock {
	        my($A) = @_;
    		eval q(( &WaitForSingleObject(($A), 0) ==  &WAIT_TIMEOUT));
	    }' unless defined(&pthread_mutex_trylock);
	    eval 'sub pthread_mutex_unlock {
	        my($A) = @_;
    		eval q( &LeaveCriticalSection($A));
	    }' unless defined(&pthread_mutex_unlock);
	    eval 'sub pthread_mutex_destroy {
	        my($A) = @_;
    		eval q( &DeleteCriticalSection($A));
	    }' unless defined(&pthread_mutex_destroy);
	    eval 'sub my_pthread_setprio {
	        my($A,$B) = @_;
    		eval q( &SetThreadPriority( &GetCurrentThread(), ($B)));
	    }' unless defined(&my_pthread_setprio);
	    eval 'sub pthread_kill {
	        my($A,$B) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_kill);
	}
	eval 'sub pthread_attr_setdetachstate {
	    my($A,$B) = @_;
    	    eval q( &pthread_dummy(0));
	}' unless defined(&pthread_attr_setdetachstate);
	eval 'sub my_pthread_attr_setprio {
	    my($A,$B) = @_;
    	    eval q( &pthread_attr_setprio($A,$B));
	}' unless defined(&my_pthread_attr_setprio);
	eval 'sub pthread_attr_setscope {
	    my($A,$B) = @_;
    	    eval q();
	}' unless defined(&pthread_attr_setscope);
	eval 'sub pthread_detach_this_thread () {
	    eval q();
	}' unless defined(&pthread_detach_this_thread);
	eval 'sub pthread_condattr_init {
	    my($A) = @_;
    	    eval q();
	}' unless defined(&pthread_condattr_init);
	eval 'sub pthread_condattr_destroy {
	    my($A) = @_;
    	    eval q();
	}' unless defined(&pthread_condattr_destroy);
	eval 'sub my_pthread_getprio {
	    my($thread_id) = @_;
    	    eval q( &pthread_dummy(0));
	}' unless defined(&my_pthread_getprio);
    }
 elsif(defined( &HAVE_UNIXWARE7_THREADS)) {
	require 'thread.ph';
	require 'synch.ph';
	unless(defined(&_REENTRANT)) {
	    eval 'sub _REENTRANT () {1;}' unless defined(&_REENTRANT);
	}
	eval 'sub HAVE_NONPOSIX_SIGWAIT () {1;}' unless defined(&HAVE_NONPOSIX_SIGWAIT);
	eval 'sub pthread_t () { &thread_t;}' unless defined(&pthread_t);
	eval 'sub pthread_cond_t () { &cond_t;}' unless defined(&pthread_cond_t);
	eval 'sub pthread_mutex_t () { &mutex_t;}' unless defined(&pthread_mutex_t);
	eval 'sub pthread_key_t () { &thread_key_t;}' unless defined(&pthread_key_t);
	eval 'sub pthread_key_create {
	    my($A,$B) = @_;
    	    eval q( &thr_keycreate(($A),($B)));
	}' unless defined(&pthread_key_create);
	eval 'sub pthread_handler_decl {
	    my($A,$B) = @_;
    	    eval q( &void *$A( &void *$B));
	}' unless defined(&pthread_handler_decl);
	eval 'sub pthread_key {
	    my($T,$V) = @_;
    	    eval q( &pthread_key_t $V);
	}' unless defined(&pthread_key);
	eval 'sub my_pthread_getspecific {
	    my($A,$B) = @_;
    	    eval q((($A)  &my_pthread_getspecific_imp($B)));
	}' unless defined(&my_pthread_getspecific);
	eval 'sub my_pthread_getspecific_ptr {
	    my($T,$V) = @_;
    	    eval q( &my_pthread_getspecific($T,$V));
	}' unless defined(&my_pthread_getspecific_ptr);
	eval 'sub pthread_setspecific {
	    my($A,$B) = @_;
    	    eval q( &thr_setspecific($A,$B));
	}' unless defined(&pthread_setspecific);
	eval 'sub my_pthread_setspecific_ptr {
	    my($T,$V) = @_;
    	    eval q( &pthread_setspecific($T,$V));
	}' unless defined(&my_pthread_setspecific_ptr);
	eval 'sub pthread_create {
	    my($A,$B,$C,$D) = @_;
    	    eval q( &thr_create( &NULL,65536,($C),($D), &THR_DETACHED,($A)));
	}' unless defined(&pthread_create);
	eval 'sub pthread_cond_init {
	    my($a,$b) = @_;
    	    eval q( &cond_init(($a), &USYNC_THREAD, &NULL));
	}' unless defined(&pthread_cond_init);
	eval 'sub pthread_cond_destroy {
	    my($a) = @_;
    	    eval q( &cond_destroy($a));
	}' unless defined(&pthread_cond_destroy);
	eval 'sub pthread_cond_signal {
	    my($a) = @_;
    	    eval q( &cond_signal($a));
	}' unless defined(&pthread_cond_signal);
	eval 'sub pthread_cond_wait {
	    my($a,$b) = @_;
    	    eval q( &cond_wait(($a),($b)));
	}' unless defined(&pthread_cond_wait);
	eval 'sub pthread_cond_timedwait {
	    my($a,$b,$c) = @_;
    	    eval q( &cond_timedwait(($a),($b),($c)));
	}' unless defined(&pthread_cond_timedwait);
	eval 'sub pthread_cond_broadcast {
	    my($a) = @_;
    	    eval q( &cond_broadcast($a));
	}' unless defined(&pthread_cond_broadcast);
	eval 'sub pthread_mutex_init {
	    my($a,$b) = @_;
    	    eval q( &mutex_init(($a), &USYNC_THREAD, &NULL));
	}' unless defined(&pthread_mutex_init);
	eval 'sub pthread_mutex_lock {
	    my($a) = @_;
    	    eval q( &mutex_lock($a));
	}' unless defined(&pthread_mutex_lock);
	eval 'sub pthread_mutex_unlock {
	    my($a) = @_;
    	    eval q( &mutex_unlock($a));
	}' unless defined(&pthread_mutex_unlock);
	eval 'sub pthread_mutex_destroy {
	    my($a) = @_;
    	    eval q( &mutex_destroy($a));
	}' unless defined(&pthread_mutex_destroy);
	eval 'sub pthread_self () {
	    eval q( &thr_self());
	}' unless defined(&pthread_self);
	eval 'sub pthread_exit {
	    my($A) = @_;
    	    eval q( &thr_exit($A));
	}' unless defined(&pthread_exit);
	eval 'sub pthread_equal {
	    my($A,$B) = @_;
    	    eval q(((($A) == ($B)) ? 1: 0));
	}' unless defined(&pthread_equal);
	eval 'sub pthread_kill {
	    my($A,$B) = @_;
    	    eval q( &thr_kill(($A),($B)));
	}' unless defined(&pthread_kill);
	eval 'sub HAVE_PTHREAD_KILL () {1;}' unless defined(&HAVE_PTHREAD_KILL);
	eval 'sub pthread_sigmask {
	    my($A,$B,$C) = @_;
    	    eval q( &thr_sigsetmask(($A),($B),($C)));
	}' unless defined(&pthread_sigmask);
	eval 'sub pthread_detach_this_thread () {
	    eval q( &pthread_dummy(0));
	}' unless defined(&pthread_detach_this_thread);
	eval 'sub pthread_attr_init {
	    my($A) = @_;
    	    eval q( &pthread_dummy(0));
	}' unless defined(&pthread_attr_init);
	eval 'sub pthread_attr_destroy {
	    my($A) = @_;
    	    eval q( &pthread_dummy(0));
	}' unless defined(&pthread_attr_destroy);
	eval 'sub pthread_attr_setscope {
	    my($A,$B) = @_;
    	    eval q( &pthread_dummy(0));
	}' unless defined(&pthread_attr_setscope);
	eval 'sub pthread_attr_setdetachstate {
	    my($A,$B) = @_;
    	    eval q( &pthread_dummy(0));
	}' unless defined(&pthread_attr_setdetachstate);
	eval 'sub my_pthread_setprio {
	    my($A,$B) = @_;
    	    eval q( &pthread_dummy (0));
	}' unless defined(&my_pthread_setprio);
	eval 'sub my_pthread_getprio {
	    my($A) = @_;
    	    eval q( &pthread_dummy (0));
	}' unless defined(&my_pthread_getprio);
	eval 'sub my_pthread_attr_setprio {
	    my($A,$B) = @_;
    	    eval q( &pthread_dummy(0));
	}' unless defined(&my_pthread_attr_setprio);
    } else {
	if(defined(&HAVE_rts_threads)) {
	    eval 'sub sigwait () { &org_sigwait;}' unless defined(&sigwait);
	    require 'signal.ph';
	    undef(&sigwait) if defined(&sigwait);
	}
	undef(&_REENTRANT) if defined(&_REENTRANT);
	require 'pthread.ph';
	unless(defined(&_REENTRANT)) {
	    eval 'sub _REENTRANT () {1;}' unless defined(&_REENTRANT);
	}
	if(defined(&HAVE_THR_SETCONCURRENCY)) {
	    require 'thread.ph';
	}
	if(defined(&HAVE_SCHED_H)) {
	    require 'sched.ph';
	}
	if(defined(&HAVE_SYNCH_H)) {
	    require 'synch.ph';
	}
	if(defined( &__EMX__)  && (!defined( &EMX_PTHREAD_REV) || ((defined(&EMX_PTHREAD_REV) ? &EMX_PTHREAD_REV : 0) < 2))) {
	    die("Requires\ at\ least\ rev\ 2\ of\ EMX\ pthreads\ library\.");
	}
	eval 'sub pthread_key {
	    my($T,$V) = @_;
    	    eval q( &pthread_key_t $V);
	}' unless defined(&pthread_key);
	eval 'sub my_pthread_getspecific_ptr {
	    my($T,$V) = @_;
    	    eval q( &my_pthread_getspecific($T,($V)));
	}' unless defined(&my_pthread_getspecific_ptr);
	eval 'sub my_pthread_setspecific_ptr {
	    my($T,$V) = @_;
    	    eval q( &pthread_setspecific($T,( &void*) ($V)));
	}' unless defined(&my_pthread_setspecific_ptr);
	eval 'sub pthread_detach_this_thread () {
	    eval q();
	}' unless defined(&pthread_detach_this_thread);
	eval 'sub pthread_handler_decl {
	    my($A,$B) = @_;
    	    eval q( &void *$A( &void *$B));
	}' unless defined(&pthread_handler_decl);
	if(defined( &PTHREAD_SCOPE_GLOBAL)  && !defined( &PTHREAD_SCOPE_SYSTEM)) {
	    eval 'sub HAVE_rts_threads () {1;}' unless defined(&HAVE_rts_threads);
	    eval 'sub pthread_sigmask {
	        my($A,$B,$C) = @_;
    		eval q( &sigprocmask(($A),($B),($C)));
	    }' unless defined(&pthread_sigmask);
	    eval 'sub PTHREAD_CREATE_DETACHED () { &my_pthread_create_detached;}' unless defined(&PTHREAD_CREATE_DETACHED);
	    eval 'sub PTHREAD_SCOPE_SYSTEM () { &PTHREAD_SCOPE_GLOBAL;}' unless defined(&PTHREAD_SCOPE_SYSTEM);
	    eval 'sub PTHREAD_SCOPE_PROCESS () { &PTHREAD_SCOPE_LOCAL;}' unless defined(&PTHREAD_SCOPE_PROCESS);
	    eval 'sub USE_ALARM_THREAD () {1;}' unless defined(&USE_ALARM_THREAD);
	}
 elsif(defined( &HAVE_mit_thread)) {
	    eval 'sub USE_ALARM_THREAD () {1;}' unless defined(&USE_ALARM_THREAD);
	    undef(&HAVE_LOCALTIME_R) if defined(&HAVE_LOCALTIME_R);
	    eval 'sub HAVE_LOCALTIME_R () {1;}' unless defined(&HAVE_LOCALTIME_R);
	    undef(&HAVE_PTHREAD_ATTR_SETSCOPE) if defined(&HAVE_PTHREAD_ATTR_SETSCOPE);
	    eval 'sub HAVE_PTHREAD_ATTR_SETSCOPE () {1;}' unless defined(&HAVE_PTHREAD_ATTR_SETSCOPE);
	    undef(&HAVE_GETHOSTBYNAME_R_GLIBC2_STYLE) if defined(&HAVE_GETHOSTBYNAME_R_GLIBC2_STYLE);
	    undef(&HAVE_RWLOCK_T) if defined(&HAVE_RWLOCK_T);
	    undef(&HAVE_RWLOCK_INIT) if defined(&HAVE_RWLOCK_INIT);
	    undef(&HAVE_PTHREAD_RWLOCK_RDLOCK) if defined(&HAVE_PTHREAD_RWLOCK_RDLOCK);
	    undef(&HAVE_SNPRINTF) if defined(&HAVE_SNPRINTF);
	    eval 'sub sigset {
	        my($A,$B) = @_;
    		eval q( &pthread_signal(($A),( &void (*)) ($B)));
	    }' unless defined(&sigset);
	    eval 'sub signal {
	        my($A,$B) = @_;
    		eval q( &pthread_signal(($A),( &void (*)) ($B)));
	    }' unless defined(&signal);
	    eval 'sub my_pthread_attr_setprio {
	        my($A,$B) = @_;
    		eval q();
	    }' unless defined(&my_pthread_attr_setprio);
	}
	if(defined( &_BSDI_VERSION)  && (defined(&_BSDI_VERSION) ? &_BSDI_VERSION : 0) < 199910) {
	}
	if(defined( &HAVE_UNIXWARE7_POSIX)) {
	    undef(&HAVE_NONPOSIX_SIGWAIT) if defined(&HAVE_NONPOSIX_SIGWAIT);
	    eval 'sub HAVE_NONPOSIX_SIGWAIT () {1;}' unless defined(&HAVE_NONPOSIX_SIGWAIT);
	}
	unless(defined(&HAVE_NONPOSIX_SIGWAIT)) {
	    eval 'sub my_sigwait {
	        my($A,$B) = @_;
    		eval q( &sigwait(($A),($B)));
	    }' unless defined(&my_sigwait);
	} else {
	}
	if(defined(&HAVE_NONPOSIX_PTHREAD_MUTEX_INIT)) {
	    unless(defined(&SAFE_MUTEX)) {
		eval 'sub pthread_mutex_init {
		    my($a,$b) = @_;
    		    eval q( &my_pthread_mutex_init(($a),($b)));
		}' unless defined(&pthread_mutex_init);
	    }
	    eval 'sub pthread_cond_init {
	        my($a,$b) = @_;
    		eval q( &my_pthread_cond_init(($a),($b)));
	    }' unless defined(&pthread_cond_init);
	}
	if(defined( &HAVE_SIGTHREADMASK)  && !defined( &HAVE_PTHREAD_SIGMASK)) {
	    eval 'sub pthread_sigmask {
	        my($A,$B,$C) = @_;
    		eval q( &sigthreadmask(($A),($B),($C)));
	    }' unless defined(&pthread_sigmask);
	}
	if(!defined( &HAVE_SIGWAIT)  && !defined( &HAVE_mit_thread)  && !defined( &HAVE_rts_threads)  && !defined( &sigwait)  && !defined( &alpha_linux_port)  && !defined( &HAVE_NONPOSIX_SIGWAIT)  && !defined( &HAVE_DEC_3_2_THREADS)  && !defined( &_AIX)) {
	}
	if(!defined( &HAVE_SIGSET)  && !defined( &HAVE_mit_thread)  && !defined( &sigset)) {
	    eval 'sub sigset {
	        my($A,$B) = @_;
    		eval q( &do { \'struct sigaction\'  &s;  &sigset_t  &set;  &sigemptyset( &set);  ($s->{sa_handler}) = ($B);  ($s->{sa_mask})  =  &set;  ($s->{sa_flags})  = 0;  &sigaction(($A),  &s,   &NULL); }  &while (0));
	    }' unless defined(&sigset);
	}
	unless(defined(&my_pthread_setprio)) {
	    if(defined( &HAVE_PTHREAD_SETPRIO_NP) ) {
		eval 'sub my_pthread_setprio {
		    my($A,$B) = @_;
    		    eval q( &pthread_setprio_np(($A),($B)));
		}' unless defined(&my_pthread_setprio);
	    }
 elsif(defined( &HAVE_PTHREAD_SETPRIO)) {
		eval 'sub my_pthread_setprio {
		    my($A,$B) = @_;
    		    eval q( &pthread_setprio(($A),($B)));
		}' unless defined(&my_pthread_setprio);
	    } else {
	    }
	}
	unless(defined(&my_pthread_attr_setprio)) {
	    if(defined(&HAVE_PTHREAD_ATTR_SETPRIO)) {
		eval 'sub my_pthread_attr_setprio {
		    my($A,$B) = @_;
    		    eval q( &pthread_attr_setprio(($A),($B)));
		}' unless defined(&my_pthread_attr_setprio);
	    } else {
	    }
	}
	if(!defined( &HAVE_PTHREAD_ATTR_SETSCOPE) || defined( &HAVE_DEC_3_2_THREADS)) {
	    eval 'sub pthread_attr_setscope {
	        my($A,$B) = @_;
    		eval q();
	    }' unless defined(&pthread_attr_setscope);
	    undef(&HAVE_GETHOSTBYADDR_R) if defined(&HAVE_GETHOSTBYADDR_R);
	}
	if(defined( &HAVE_BROKEN_PTHREAD_COND_TIMEDWAIT)  && !defined( &SAFE_MUTEX)) {
	    eval 'sub pthread_cond_timedwait {
	        my($A,$B,$C) = @_;
    		eval q( &my_pthread_cond_timedwait(($A),($B),($C)));
	    }' unless defined(&pthread_cond_timedwait);
	}
	if(defined( &OS2)) {
	    eval 'sub my_pthread_getspecific {
	        my($T,$A) = @_;
    		eval q((($T) ($A)));
	    }' unless defined(&my_pthread_getspecific);
	    eval 'sub pthread_setspecific {
	        my($A,$B) = @_;
    		eval q( &win_pthread_setspecific(($A),($B),$sizeof{$A}));
	    }' unless defined(&pthread_setspecific);
	}
 elsif(!defined( (defined(&HAVE_NONPOSIX_PTHREAD_GETSPECIFIC) ? &HAVE_NONPOSIX_PTHREAD_GETSPECIFIC : 0))) {
	    eval 'sub my_pthread_getspecific {
	        my($A,$B) = @_;
    		eval q((($A)  &pthread_getspecific($B)));
	    }' unless defined(&my_pthread_getspecific);
	} else {
	    eval 'sub my_pthread_getspecific {
	        my($A,$B) = @_;
    		eval q((($A)  &my_pthread_getspecific_imp($B)));
	    }' unless defined(&my_pthread_getspecific);
	}
	unless(defined(&HAVE_LOCALTIME_R)) {
	}
	if(defined(&HAVE_PTHREAD_CONDATTR_CREATE)) {
	    eval 'sub pthread_condattr_init () { &pthread_condattr_create;}' unless defined(&pthread_condattr_init);
	    eval 'sub pthread_condattr_destroy () { &pthread_condattr_delete;}' unless defined(&pthread_condattr_destroy);
	}
	if(defined(&HAVE_CTHREADS_WRAPPER)) {
	    eval 'sub pthread_cond_destroy {
	        my($A) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_cond_destroy);
	    eval 'sub pthread_mutex_destroy {
	        my($A) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_mutex_destroy);
	    eval 'sub pthread_attr_delete {
	        my($A) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_attr_delete);
	    eval 'sub pthread_condattr_delete {
	        my($A) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_condattr_delete);
	    eval 'sub pthread_attr_setstacksize {
	        my($A,$B) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_attr_setstacksize);
	    eval 'sub pthread_equal {
	        my($A,$B) = @_;
    		eval q((($A) == ($B)));
	    }' unless defined(&pthread_equal);
	    eval 'sub pthread_cond_timedwait {
	        my($a,$b,$c) = @_;
    		eval q( &pthread_cond_wait(($a),($b)));
	    }' unless defined(&pthread_cond_timedwait);
	    eval 'sub pthread_attr_init {
	        my($A) = @_;
    		eval q( &pthread_attr_create($A));
	    }' unless defined(&pthread_attr_init);
	    eval 'sub pthread_attr_destroy {
	        my($A) = @_;
    		eval q( &pthread_attr_delete($A));
	    }' unless defined(&pthread_attr_destroy);
	    eval 'sub pthread_attr_setdetachstate {
	        my($A,$B) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_attr_setdetachstate);
	    eval 'sub pthread_create {
	        my($A,$B,$C,$D) = @_;
    		eval q( &pthread_create(($A),*($B),($C),($D)));
	    }' unless defined(&pthread_create);
	    eval 'sub pthread_sigmask {
	        my($A,$B,$C) = @_;
    		eval q( &sigprocmask(($A),($B),($C)));
	    }' unless defined(&pthread_sigmask);
	    eval 'sub pthread_kill {
	        my($A,$B) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_kill);
	    undef(&pthread_detach_this_thread) if defined(&pthread_detach_this_thread);
	    eval 'sub pthread_detach_this_thread () {
	        eval q({  &pthread_t  &tmp= &pthread_self() ;  &pthread_detach( &tmp); });
	    }' unless defined(&pthread_detach_this_thread);
	}
	if(defined(&HAVE_DARWIN_THREADS)) {
	    eval 'sub pthread_sigmask {
	        my($A,$B,$C) = @_;
    		eval q( &sigprocmask(($A),($B),($C)));
	    }' unless defined(&pthread_sigmask);
	    eval 'sub pthread_kill {
	        my($A,$B) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_kill);
	    eval 'sub pthread_condattr_init {
	        my($A) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_condattr_init);
	    eval 'sub pthread_condattr_destroy {
	        my($A) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_condattr_destroy);
	    eval 'sub pthread_signal {
	        my($A,$B) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_signal);
	    undef(&pthread_detach_this_thread) if defined(&pthread_detach_this_thread);
	    eval 'sub pthread_detach_this_thread () {
	        eval q({  &pthread_t  &tmp= &pthread_self() ;  &pthread_detach( &tmp); });
	    }' unless defined(&pthread_detach_this_thread);
	    undef(&sigset) if defined(&sigset);
	    eval 'sub sigset {
	        my($A,$B) = @_;
    		eval q( &pthread_signal(($A),( &void (*)) ($B)));
	    }' unless defined(&sigset);
	}
	if(((defined( &HAVE_PTHREAD_ATTR_CREATE)  && !defined( &HAVE_SIGWAIT)) || defined( &HAVE_DEC_3_2_THREADS))  && !defined( &HAVE_CTHREADS_WRAPPER)) {
	    eval 'sub pthread_key_create {
	        my($A,$B) = @_;
    		eval q( &pthread_keycreate($A,($B) ? ( &pthread_destructor_t) ($B) : ( &pthread_destructor_t)  &pthread_dummy));
	    }' unless defined(&pthread_key_create);
	    eval 'sub pthread_attr_init {
	        my($A) = @_;
    		eval q( &pthread_attr_create($A));
	    }' unless defined(&pthread_attr_init);
	    eval 'sub pthread_attr_destroy {
	        my($A) = @_;
    		eval q( &pthread_attr_delete($A));
	    }' unless defined(&pthread_attr_destroy);
	    eval 'sub pthread_attr_setdetachstate {
	        my($A,$B) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_attr_setdetachstate);
	    eval 'sub pthread_create {
	        my($A,$B,$C,$D) = @_;
    		eval q( &pthread_create(($A),*($B),($C),($D)));
	    }' unless defined(&pthread_create);
	    unless(defined(&pthread_sigmask)) {
		eval 'sub pthread_sigmask {
		    my($A,$B,$C) = @_;
    		    eval q( &sigprocmask(($A),($B),($C)));
		}' unless defined(&pthread_sigmask);
	    }
	    eval 'sub pthread_kill {
	        my($A,$B) = @_;
    		eval q( &pthread_dummy(0));
	    }' unless defined(&pthread_kill);
	    undef(&pthread_detach_this_thread) if defined(&pthread_detach_this_thread);
	    eval 'sub pthread_detach_this_thread () {
	        eval q({  &pthread_t  &tmp= &pthread_self() ;  &pthread_detach( &tmp); });
	    }' unless defined(&pthread_detach_this_thread);
	} else {
	    eval 'sub HAVE_PTHREAD_KILL () {1;}' unless defined(&HAVE_PTHREAD_KILL);
	}
    }
    if(defined( &HPUX)  && !defined( &DONT_REMAP_PTHREAD_FUNCTIONS)) {
	undef(&pthread_cond_timedwait) if defined(&pthread_cond_timedwait);
	eval 'sub pthread_cond_timedwait {
	    my($a,$b,$c) = @_;
    	    eval q( &my_pthread_cond_timedwait(($a),($b),($c)));
	}' unless defined(&pthread_cond_timedwait);
    }
    if(defined( &HAVE_POSIX1003_4a_MUTEX)  && !defined( &DONT_REMAP_PTHREAD_FUNCTIONS)) {
	undef(&pthread_mutex_trylock) if defined(&pthread_mutex_trylock);
	eval 'sub pthread_mutex_trylock {
	    my($a) = @_;
    	    eval q( &my_pthread_mutex_trylock(($a)));
	}' unless defined(&pthread_mutex_trylock);
    }
    if(defined(&SAFE_MUTEX)) {
	undef(&pthread_mutex_init) if defined(&pthread_mutex_init);
	undef(&pthread_mutex_lock) if defined(&pthread_mutex_lock);
	undef(&pthread_mutex_unlock) if defined(&pthread_mutex_unlock);
	undef(&pthread_mutex_destroy) if defined(&pthread_mutex_destroy);
	undef(&pthread_mutex_wait) if defined(&pthread_mutex_wait);
	undef(&pthread_mutex_timedwait) if defined(&pthread_mutex_timedwait);
	undef(&pthread_mutex_t) if defined(&pthread_mutex_t);
	undef(&pthread_cond_wait) if defined(&pthread_cond_wait);
	undef(&pthread_cond_timedwait) if defined(&pthread_cond_timedwait);
	undef(&pthread_mutex_trylock) if defined(&pthread_mutex_trylock);
	eval 'sub pthread_mutex_init {
	    my($A,$B) = @_;
    	    eval q( &safe_mutex_init(($A),($B)));
	}' unless defined(&pthread_mutex_init);
	eval 'sub pthread_mutex_lock {
	    my($A) = @_;
    	    eval q( &safe_mutex_lock(($A), &__FILE__, &__LINE__));
	}' unless defined(&pthread_mutex_lock);
	eval 'sub pthread_mutex_unlock {
	    my($A) = @_;
    	    eval q( &safe_mutex_unlock(($A), &__FILE__, &__LINE__));
	}' unless defined(&pthread_mutex_unlock);
	eval 'sub pthread_mutex_destroy {
	    my($A) = @_;
    	    eval q( &safe_mutex_destroy(($A), &__FILE__, &__LINE__));
	}' unless defined(&pthread_mutex_destroy);
	eval 'sub pthread_cond_wait {
	    my($A,$B) = @_;
    	    eval q( &safe_cond_wait(($A),($B), &__FILE__, &__LINE__));
	}' unless defined(&pthread_cond_wait);
	eval 'sub pthread_cond_timedwait {
	    my($A,$B,$C) = @_;
    	    eval q( &safe_cond_timedwait(($A),($B),($C), &__FILE__, &__LINE__));
	}' unless defined(&pthread_cond_timedwait);
	eval 'sub pthread_mutex_trylock {
	    my($A) = @_;
    	    eval q( &pthread_mutex_lock($A));
	}' unless defined(&pthread_mutex_trylock);
	eval 'sub pthread_mutex_t () { &safe_mutex_t;}' unless defined(&pthread_mutex_t);
	eval 'sub safe_mutex_assert_owner {
	    my($mp) = @_;
    	    eval q( &DBUG_ASSERT(($mp)-> &count > 0 &&  &pthread_equal( &pthread_self(),($mp)-> &thread)));
	}' unless defined(&safe_mutex_assert_owner);
    } else {
	eval 'sub safe_mutex_assert_owner {
	    my($mp) = @_;
    	    eval q();
	}' unless defined(&safe_mutex_assert_owner);
    }
    if(defined( &USE_MUTEX_INSTEAD_OF_RW_LOCKS)) {
	eval 'sub rw_lock_t () { &pthread_mutex_t;}' unless defined(&rw_lock_t);
	eval 'sub my_rwlock_init {
	    my($A,$B) = @_;
    	    eval q( &pthread_mutex_init(($A),($B)));
	}' unless defined(&my_rwlock_init);
	eval 'sub rw_rdlock {
	    my($A) = @_;
    	    eval q( &pthread_mutex_lock(($A)));
	}' unless defined(&rw_rdlock);
	eval 'sub rw_wrlock {
	    my($A) = @_;
    	    eval q( &pthread_mutex_lock(($A)));
	}' unless defined(&rw_wrlock);
	eval 'sub rw_tryrdlock {
	    my($A) = @_;
    	    eval q( &pthread_mutex_trylock(($A)));
	}' unless defined(&rw_tryrdlock);
	eval 'sub rw_trywrlock {
	    my($A) = @_;
    	    eval q( &pthread_mutex_trylock(($A)));
	}' unless defined(&rw_trywrlock);
	eval 'sub rw_unlock {
	    my($A) = @_;
    	    eval q( &pthread_mutex_unlock(($A)));
	}' unless defined(&rw_unlock);
	eval 'sub rwlock_destroy {
	    my($A) = @_;
    	    eval q( &pthread_mutex_destroy(($A)));
	}' unless defined(&rwlock_destroy);
    }
 elsif(defined( &HAVE_PTHREAD_RWLOCK_RDLOCK)) {
	eval 'sub rw_lock_t () { &pthread_rwlock_t;}' unless defined(&rw_lock_t);
	eval 'sub my_rwlock_init {
	    my($A,$B) = @_;
    	    eval q( &pthread_rwlock_init(($A),($B)));
	}' unless defined(&my_rwlock_init);
	eval 'sub rw_rdlock {
	    my($A) = @_;
    	    eval q( &pthread_rwlock_rdlock($A));
	}' unless defined(&rw_rdlock);
	eval 'sub rw_wrlock {
	    my($A) = @_;
    	    eval q( &pthread_rwlock_wrlock($A));
	}' unless defined(&rw_wrlock);
	eval 'sub rw_tryrdlock {
	    my($A) = @_;
    	    eval q( &pthread_rwlock_tryrdlock(($A)));
	}' unless defined(&rw_tryrdlock);
	eval 'sub rw_trywrlock {
	    my($A) = @_;
    	    eval q( &pthread_rwlock_trywrlock(($A)));
	}' unless defined(&rw_trywrlock);
	eval 'sub rw_unlock {
	    my($A) = @_;
    	    eval q( &pthread_rwlock_unlock($A));
	}' unless defined(&rw_unlock);
	eval 'sub rwlock_destroy {
	    my($A) = @_;
    	    eval q( &pthread_rwlock_destroy($A));
	}' unless defined(&rwlock_destroy);
    }
 elsif(defined( &HAVE_RWLOCK_INIT)) {
	if(defined(&HAVE_RWLOCK_T)) {
	    eval 'sub rw_lock_t () { &rwlock_t;}' unless defined(&rw_lock_t);
	}
	eval 'sub my_rwlock_init {
	    my($A,$B) = @_;
    	    eval q( &rwlock_init(($A), &USYNC_THREAD,0));
	}' unless defined(&my_rwlock_init);
    } else {
	eval 'sub rw_lock_t () { &my_rw_lock_t;}' unless defined(&rw_lock_t);
	eval 'sub rw_rdlock {
	    my($A) = @_;
    	    eval q( &my_rw_rdlock(($A)));
	}' unless defined(&rw_rdlock);
	eval 'sub rw_wrlock {
	    my($A) = @_;
    	    eval q( &my_rw_wrlock(($A)));
	}' unless defined(&rw_wrlock);
	eval 'sub rw_tryrdlock {
	    my($A) = @_;
    	    eval q( &my_rw_tryrdlock(($A)));
	}' unless defined(&rw_tryrdlock);
	eval 'sub rw_trywrlock {
	    my($A) = @_;
    	    eval q( &my_rw_trywrlock(($A)));
	}' unless defined(&rw_trywrlock);
	eval 'sub rw_unlock {
	    my($A) = @_;
    	    eval q( &my_rw_unlock(($A)));
	}' unless defined(&rw_unlock);
	eval 'sub rwlock_destroy {
	    my($A) = @_;
    	    eval q( &my_rwlock_destroy(($A)));
	}' unless defined(&rwlock_destroy);
    }
    eval 'sub GETHOSTBYADDR_BUFF_SIZE () {2048;}' unless defined(&GETHOSTBYADDR_BUFF_SIZE);
    unless(defined(&HAVE_THR_SETCONCURRENCY)) {
	eval 'sub thr_setconcurrency {
	    my($A) = @_;
    	    eval q( &pthread_dummy(0));
	}' unless defined(&thr_setconcurrency);
    }
    if(!defined( &HAVE_PTHREAD_ATTR_SETSTACKSIZE)  && ! defined( &pthread_attr_setstacksize)) {
	eval 'sub pthread_attr_setstacksize {
	    my($A,$B) = @_;
    	    eval q( &pthread_dummy(0));
	}' unless defined(&pthread_attr_setstacksize);
    }
    eval 'sub MY_MUTEX_INIT_SLOW () { &NULL;}' unless defined(&MY_MUTEX_INIT_SLOW);
    eval 'sub MY_MUTEX_INIT_FAST () { &NULL;}' unless defined(&MY_MUTEX_INIT_FAST);
    eval 'sub MY_MUTEX_INIT_ERRCHK () { &NULL;}' unless defined(&MY_MUTEX_INIT_ERRCHK);
    if(defined(&PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP)) {
	undef(&MY_MUTEX_INIT_FAST) if defined(&MY_MUTEX_INIT_FAST);
	eval 'sub MY_MUTEX_INIT_FAST () { &my_fast_mutexattr;}' unless defined(&MY_MUTEX_INIT_FAST);
    }
    if(defined(&PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP)) {
	undef(&MY_INIT_MUTEX_ERRCHK) if defined(&MY_INIT_MUTEX_ERRCHK);
	eval 'sub MY_INIT_MUTEX_ERRCHK () { &my_errchk_mutexattr;}' unless defined(&MY_INIT_MUTEX_ERRCHK);
    }
    eval 'sub THREAD_NAME_SIZE () {10;}' unless defined(&THREAD_NAME_SIZE);
    if(defined( &__ia64__)) {
	eval 'sub DEFAULT_THREAD_STACK () {(128*1024);}' unless defined(&DEFAULT_THREAD_STACK);
    } else {
	eval 'sub DEFAULT_THREAD_STACK () {(64*1024);}' unless defined(&DEFAULT_THREAD_STACK);
    }
    unless(defined(&DBUG_OFF)) {
    }
    eval 'sub my_thread_var () {( &_my_thread_var());}' unless defined(&my_thread_var);
    eval 'sub my_errno () { ($my_thread_var->{thr_errno});}' unless defined(&my_errno);
    unless(defined(&thread_safe_increment)) {
	if(defined(&HAVE_ATOMIC_ADD)) {
	    eval 'sub thread_safe_increment {
	        my($V,$L) = @_;
    		eval q( &atomic_add(1,( &atomic_t*) $V););
	    }' unless defined(&thread_safe_increment);
	    eval 'sub thread_safe_add {
	        my($V,$C,$L) = @_;
    		eval q( &atomic_add(($C),( &atomic_t*) $V););
	    }' unless defined(&thread_safe_add);
	    eval 'sub thread_safe_sub {
	        my($V,$C,$L) = @_;
    		eval q( &atomic_sub(($C),( &atomic_t*) $V););
	    }' unless defined(&thread_safe_sub);
	    eval 'sub statistic_increment {
	        my($V,$L) = @_;
    		eval q( &thread_safe_increment(($V),($L)));
	    }' unless defined(&statistic_increment);
	    eval 'sub statistic_add {
	        my($V,$C,$L) = @_;
    		eval q( &thread_safe_add(($V),($C),($L)));
	    }' unless defined(&statistic_add);
	} else {
	    eval 'sub thread_safe_increment {
	        my($V,$L) = @_;
    		eval q( &pthread_mutex_lock(($L)); ($V)++;  &pthread_mutex_unlock(($L)););
	    }' unless defined(&thread_safe_increment);
	    eval 'sub thread_safe_add {
	        my($V,$C,$L) = @_;
    		eval q( &pthread_mutex_lock(($L)); ($V)+=($C);  &pthread_mutex_unlock(($L)););
	    }' unless defined(&thread_safe_add);
	    eval 'sub thread_safe_sub {
	        my($V,$C,$L) = @_;
    		eval q( &pthread_mutex_lock(($L)); ($V)-=($C);  &pthread_mutex_unlock(($L)););
	    }' unless defined(&thread_safe_sub);
	    if(defined(&SAFE_STATISTICS)) {
		eval 'sub statistic_increment {
		    my($V,$L) = @_;
    		    eval q( &thread_safe_increment(($V),($L)));
		}' unless defined(&statistic_increment);
		eval 'sub statistic_add {
		    my($V,$C,$L) = @_;
    		    eval q( &thread_safe_add(($V),($C),($L)));
		}' unless defined(&statistic_add);
	    } else {
		eval 'sub statistic_increment {
		    my($V,$L) = @_;
    		    eval q(($V)++);
		}' unless defined(&statistic_increment);
		eval 'sub statistic_add {
		    my($V,$C,$L) = @_;
    		    eval q(($V)+=($C));
		}' unless defined(&statistic_add);
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
