require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_my_sys_h)) {
    eval 'sub _my_sys_h () {1;}' unless defined(&_my_sys_h);
    if(defined(&__cplusplus)) {
    }
    if(defined(&HAVE_AIOWAIT)) {
	require 'sys/asynch.ph';
    }
    unless(defined(&THREAD)) {
    } else {
	require 'my_pthread.ph';
    }
    unless(defined(&_m_ctype_h)) {
	require 'm_ctype.ph';
    }
    require 'stdarg.ph';
    eval 'sub MYSYS_PROGRAM_USES_CURSES () {
        eval q({  &error_handler_hook =  &my_message_curses;  &mysys_uses_curses=1; });
    }' unless defined(&MYSYS_PROGRAM_USES_CURSES);
    eval 'sub MYSYS_PROGRAM_DONT_USE_CURSES () {
        eval q({  &error_handler_hook =  &my_message_no_curses;  &mysys_uses_curses=0;});
    }' unless defined(&MYSYS_PROGRAM_DONT_USE_CURSES);
    eval 'sub MY_INIT {
        my($name) = @_;
	    eval q(; {  &my_progname= $name;  &my_init(); });
    }' unless defined(&MY_INIT);
    eval 'sub MAXMAPS () {(4);}' unless defined(&MAXMAPS);
    eval 'sub ERRMOD () {(1000);}' unless defined(&ERRMOD);
    eval 'sub ERRMSGSIZE () {( &SC_MAXWIDTH);}' unless defined(&ERRMSGSIZE);
    eval 'sub NRERRBUFFS () {(2);}' unless defined(&NRERRBUFFS);
    eval 'sub MY_FILE_ERROR () {( ~0);}' unless defined(&MY_FILE_ERROR);
    eval 'sub MY_FFNF () {1;}' unless defined(&MY_FFNF);
    eval 'sub MY_FNABP () {2;}' unless defined(&MY_FNABP);
    eval 'sub MY_NABP () {4;}' unless defined(&MY_NABP);
    eval 'sub MY_FAE () {8;}' unless defined(&MY_FAE);
    eval 'sub MY_WME () {16;}' unless defined(&MY_WME);
    eval 'sub MY_WAIT_IF_FULL () {32;}' unless defined(&MY_WAIT_IF_FULL);
    eval 'sub MY_RAID () {64;}' unless defined(&MY_RAID);
    eval 'sub MY_DONT_CHECK_FILESIZE () {128;}' unless defined(&MY_DONT_CHECK_FILESIZE);
    eval 'sub MY_LINK_WARNING () {32;}' unless defined(&MY_LINK_WARNING);
    eval 'sub MY_COPYTIME () {64;}' unless defined(&MY_COPYTIME);
    eval 'sub MY_DELETE_OLD () {256;}' unless defined(&MY_DELETE_OLD);
    eval 'sub MY_RESOLVE_LINK () {128;}' unless defined(&MY_RESOLVE_LINK);
    eval 'sub MY_HOLD_ORIGINAL_MODES () {128;}' unless defined(&MY_HOLD_ORIGINAL_MODES);
    eval 'sub MY_REDEL_MAKE_BACKUP () {256;}' unless defined(&MY_REDEL_MAKE_BACKUP);
    eval 'sub MY_SEEK_NOT_DONE () {32;}' unless defined(&MY_SEEK_NOT_DONE);
    eval 'sub MY_DONT_WAIT () {64;}' unless defined(&MY_DONT_WAIT);
    eval 'sub MY_ZEROFILL () {32;}' unless defined(&MY_ZEROFILL);
    eval 'sub MY_ALLOW_ZERO_PTR () {64;}' unless defined(&MY_ALLOW_ZERO_PTR);
    eval 'sub MY_FREE_ON_ERROR () {128;}' unless defined(&MY_FREE_ON_ERROR);
    eval 'sub MY_HOLD_ON_ERROR () {256;}' unless defined(&MY_HOLD_ON_ERROR);
    eval 'sub MY_THREADSAFE () {128;}' unless defined(&MY_THREADSAFE);
    eval 'sub MY_DONT_OVERWRITE_FILE () {1024;}' unless defined(&MY_DONT_OVERWRITE_FILE);
    eval 'sub MY_CHECK_ERROR () {1;}' unless defined(&MY_CHECK_ERROR);
    eval 'sub MY_GIVE_INFO () {2;}' unless defined(&MY_GIVE_INFO);
    eval 'sub ME_HIGHBYTE () {8;}' unless defined(&ME_HIGHBYTE);
    eval 'sub ME_NOCUR () {1;}' unless defined(&ME_NOCUR);
    eval 'sub ME_OLDWIN () {2;}' unless defined(&ME_OLDWIN);
    eval 'sub ME_BELL () {4;}' unless defined(&ME_BELL);
    eval 'sub ME_HOLDTANG () {8;}' unless defined(&ME_HOLDTANG);
    eval 'sub ME_WAITTOT () {16;}' unless defined(&ME_WAITTOT);
    eval 'sub ME_WAITTANG () {32;}' unless defined(&ME_WAITTANG);
    eval 'sub ME_NOREFRESH () {64;}' unless defined(&ME_NOREFRESH);
    eval 'sub ME_NOINPUT () {128;}' unless defined(&ME_NOINPUT);
    eval 'sub ME_COLOUR1 () {((1<<  &ME_HIGHBYTE));}' unless defined(&ME_COLOUR1);
    eval 'sub ME_COLOUR2 () {((2<<  &ME_HIGHBYTE));}' unless defined(&ME_COLOUR2);
    eval 'sub ME_COLOUR3 () {((3<<  &ME_HIGHBYTE));}' unless defined(&ME_COLOUR3);
    eval 'sub MY_SEEK_SET () {0;}' unless defined(&MY_SEEK_SET);
    eval 'sub MY_SEEK_CUR () {1;}' unless defined(&MY_SEEK_CUR);
    eval 'sub MY_SEEK_END () {2;}' unless defined(&MY_SEEK_END);
    eval 'sub MY_NO_SETS () {0;}' unless defined(&MY_NO_SETS);
    eval 'sub MY_COMPILED_SETS () {1;}' unless defined(&MY_COMPILED_SETS);
    eval 'sub MY_CONFIG_SETS () {2;}' unless defined(&MY_CONFIG_SETS);
    eval 'sub MY_INDEX_SETS () {4;}' unless defined(&MY_INDEX_SETS);
    eval 'sub MY_LOADED_SETS () {8;}' unless defined(&MY_LOADED_SETS);
    eval 'sub MY_WAIT_FOR_USER_TO_FIX_PANIC () {60;}' unless defined(&MY_WAIT_FOR_USER_TO_FIX_PANIC);
    eval 'sub MY_WAIT_GIVE_USER_A_MESSAGE () {10;}' unless defined(&MY_WAIT_GIVE_USER_A_MESSAGE);
    eval 'sub MIN_COMPRESS_LENGTH () {50;}' unless defined(&MIN_COMPRESS_LENGTH);
    eval 'sub KEYCACHE_BLOCK_SIZE () {1024;}' unless defined(&KEYCACHE_BLOCK_SIZE);
    eval 'sub MY_KEEP_PREALLOC () {1;}' unless defined(&MY_KEEP_PREALLOC);
    if(defined(&SAFEMALLOC)) {
	eval 'sub my_malloc {
	    my($SZ,$FLAG) = @_;
    	    eval q( &_mymalloc( $SZ,  &__FILE__,  &__LINE__, $FLAG ));
	}' unless defined(&my_malloc);
	eval 'sub my_malloc_ci {
	    my($SZ,$FLAG) = @_;
    	    eval q( &_mymalloc( $SZ,  &sFile,  &uLine, $FLAG ));
	}' unless defined(&my_malloc_ci);
	eval 'sub my_realloc {
	    my($PTR,$SZ,$FLAG) = @_;
    	    eval q( &_myrealloc( $PTR, $SZ,  &__FILE__,  &__LINE__, $FLAG ));
	}' unless defined(&my_realloc);
	eval 'sub my_checkmalloc () {
	    eval q( &_sanity(  &__FILE__,  &__LINE__ ));
	}' unless defined(&my_checkmalloc);
	eval 'sub my_free {
	    my($PTR,$FLAG) = @_;
    	    eval q( &_myfree( $PTR,  &__FILE__,  &__LINE__,$FLAG));
	}' unless defined(&my_free);
	eval 'sub my_memdup {
	    my($A,$B,$C) = @_;
    	    eval q( &_my_memdup($A,$B, &__FILE__, &__LINE__,$C));
	}' unless defined(&my_memdup);
	eval 'sub my_strdup {
	    my($A,$C) = @_;
    	    eval q( &_my_strdup($A, &__FILE__, &__LINE__,$C));
	}' unless defined(&my_strdup);
	eval 'sub QUICK_SAFEMALLOC () { &sf_malloc_quick=1;}' unless defined(&QUICK_SAFEMALLOC);
	eval 'sub NORMAL_SAFEMALLOC () { &sf_malloc_quick=0;}' unless defined(&NORMAL_SAFEMALLOC);
	eval 'sub CALLER_INFO_PROTO () {,  &const \'char\' * &sFile, \'uint\'  &uLine;}' unless defined(&CALLER_INFO_PROTO);
	eval 'sub CALLER_INFO () {,  &__FILE__,  &__LINE__;}' unless defined(&CALLER_INFO);
	eval 'sub ORIG_CALLER_INFO () {,  &sFile,  &uLine;}' unless defined(&ORIG_CALLER_INFO);
    } else {
	eval 'sub my_checkmalloc () {
	    eval q((0));
	}' unless defined(&my_checkmalloc);
	undef(&TERMINATE) if defined(&TERMINATE);
	eval 'sub TERMINATE {
	    my($A) = @_;
    	    eval q({});
	}' unless defined(&TERMINATE);
	eval 'sub QUICK_SAFEMALLOC () {1;}' unless defined(&QUICK_SAFEMALLOC);
	eval 'sub NORMAL_SAFEMALLOC () {1;}' unless defined(&NORMAL_SAFEMALLOC);
	eval 'sub my_malloc_ci {
	    my($SZ,$FLAG) = @_;
    	    eval q( &my_malloc( $SZ, $FLAG ));
	}' unless defined(&my_malloc_ci);
	eval 'sub my_free {
	    my($PTR,$FG) = @_;
    	    eval q( &my_no_flags_free($PTR));
	}' unless defined(&my_free);
	eval 'sub CALLER_INFO_PROTO () {1;}' unless defined(&CALLER_INFO_PROTO);
	eval 'sub CALLER_INFO () {1;}' unless defined(&CALLER_INFO);
	eval 'sub ORIG_CALLER_INFO () {1;}' unless defined(&ORIG_CALLER_INFO);
    }
    if(defined(&HAVE_ALLOCA)) {
	if(defined( &_AIX)  && !defined( &__GNUC__)) {
	}
	if(defined( &__GNUC__)  && !defined( &HAVE_ALLOCA_H)) {
	    eval 'sub alloca () { &__builtin_alloca;}' unless defined(&alloca);
	}
	eval 'sub my_alloca {
	    my($SZ) = @_;
    	    eval q( &alloca( ($SZ)));
	}' unless defined(&my_alloca);
	eval 'sub my_afree {
	    my($PTR) = @_;
    	    eval q({});
	}' unless defined(&my_afree);
    } else {
	eval 'sub my_alloca {
	    my($SZ) = @_;
    	    eval q( &my_malloc($SZ, &MYF(0)));
	}' unless defined(&my_alloca);
	eval 'sub my_afree {
	    my($PTR) = @_;
    	    eval q( &my_free($PTR, &MYF( &MY_WME)));
	}' unless defined(&my_afree);
    }
    if(defined(&MSDOS)) {
	if(defined(&__ZTC__)) {
	}
	if(defined( &USE_HALLOC)) {
	    if(defined( &_VCM_) || defined( &M_IC80386)) {
		undef(&USE_HALLOC) if defined(&USE_HALLOC);
	    }
	}
	if(defined(&USE_HALLOC)) {
	    eval 'sub malloc {
	        my($a) = @_;
    		eval q( &halloc( ($a),1));
	    }' unless defined(&malloc);
	    eval 'sub free {
	        my($a) = @_;
    		eval q( &hfree($a));
	    }' unless defined(&free);
	}
    }
    if(defined(&HAVE_ERRNO_AS_DEFINE)) {
	require 'errno.ph';
    } else {
    }
    eval("sub READ_CACHE () { 0; }") unless defined(&READ_CACHE);
    eval("sub WRITE_CACHE () { 1; }") unless defined(&WRITE_CACHE);
    eval("sub READ_FIFO () { 2; }") unless defined(&READ_FIFO);
    eval("sub READ_NET () { 3; }") unless defined(&READ_NET);
    eval("sub WRITE_NET () { 4; }") unless defined(&WRITE_NET);
    eval("sub FLUSH_KEEP () { 0; }") unless defined(&FLUSH_KEEP);
    eval("sub FLUSH_RELEASE () { 1; }") unless defined(&FLUSH_RELEASE);
    eval("sub FLUSH_IGNORE_CHANGED () { 2; }") unless defined(&FLUSH_IGNORE_CHANGED);
    eval("sub FLUSH_FORCE_WRITE () { 3; }") unless defined(&FLUSH_FORCE_WRITE);
    if(defined(&HAVE_AIOWAIT)) {
    }
    eval("sub UNOPEN () { 0; }") unless defined(&UNOPEN);
    eval("sub FILE_BY_OPEN () { 1; }") unless defined(&FILE_BY_OPEN);
    eval("sub FILE_BY_CREATE () { 2; }") unless defined(&FILE_BY_CREATE);
    eval("sub STREAM_BY_FOPEN () { 3; }") unless defined(&STREAM_BY_FOPEN);
    eval("sub STREAM_BY_FDOPEN () { 4; }") unless defined(&STREAM_BY_FDOPEN);
    eval("sub FILE_BY_MKSTEMP () { 5; }") unless defined(&FILE_BY_MKSTEMP);
    if(defined( &THREAD)  && !defined( &HAVE_PREAD) ) {
    }
    if(defined(&HAVE_AIOWAIT)) {
    }
    eval 'sub my_b_clear {
        my($info) = @_;
	    eval q(($info)-> &buffer=0);
    }' unless defined(&my_b_clear);
    eval 'sub my_b_inited {
        my($info) = @_;
	    eval q(($info)-> &buffer);
    }' unless defined(&my_b_inited);
    eval 'sub my_b_EOF () { &INT_MIN;}' unless defined(&my_b_EOF);
    eval 'sub my_b_read {
        my($info,$Buffer,$Count) = @_;
	    eval q((-> &rc_pos + <= -> &rc_end ? ( &memcpy($Buffer,-> &rc_pos, ($Count)), (($info)-> &rc_pos+=($Count)),0) : (*($info)-> &read_function)(($info),$Buffer,$Count)));
    }' unless defined(&my_b_read);
    eval 'sub my_b_get {
        my($info) = @_;
	    eval q((-> &rc_pos != -> &rc_end ? (-> &rc_pos++, ($info)-> $rc_pos[-1]) :  &_my_b_get($info)));
    }' unless defined(&my_b_get);
    eval 'sub my_b_write {
        my($info,$Buffer,$Count) = @_;
	    eval q((-> &rc_pos + <= -> &rc_end ? ( &memcpy(-> &rc_pos,$Buffer, ($Count)), (($info)-> &rc_pos+=($Count)),0) :  &_my_b_write($info,$Buffer,$Count)));
    }' unless defined(&my_b_write);
    eval 'sub my_b_write_byte {
        my($info,$chr) = @_;
	    eval q(((($info)-> &rc_pos < ($info)-> &rc_end) ? ((*($info)-> &rc_pos++)=($chr)) : ( &_my_b_write($info,0,0) , ((*($info)-> &rc_pos++)=($chr)))));
    }' unless defined(&my_b_write_byte);
    eval 'sub my_b_fill_cache {
        my($info) = @_;
	    eval q(((($info)-> &rc_end=($info)-> &rc_pos),(*($info)-> &read_function)($info,0,0)));
    }' unless defined(&my_b_fill_cache);
    eval 'sub my_b_tell {
        my($info) = @_;
	    eval q((($info)-> &pos_in_file + (($info)-> &rc_pos - ($info)-> &rc_request_pos)));
    }' unless defined(&my_b_tell);
    eval 'sub my_b_bytes_in_cache {
        my($info) = @_;
	    eval q(( (($info)-> &rc_end - ($info)-> &rc_pos)));
    }' unless defined(&my_b_bytes_in_cache);
    unless(defined(&ST_USED_MEM_DEFINED)) {
	eval 'sub ST_USED_MEM_DEFINED () {1;}' unless defined(&ST_USED_MEM_DEFINED);
    }
    unless(defined(&TERMINATE)) {
    }
    unless(defined(&THREAD)) {
    } else {
	eval 'sub dont_break () {
	    eval q();
	}' unless defined(&dont_break);
	eval 'sub allow_break () {
	    eval q();
	}' unless defined(&allow_break);
    }
    eval 'sub base_name {
        my($A) = @_;
	    eval q(($A+ &dirname_length($A)));
    }' unless defined(&base_name);
    eval 'sub my_init_dynamic_array {
        my($A,$B,$C,$D) = @_;
	    eval q( &init_dynamic_array($A,$B,$C,$D  &CALLER_INFO));
    }' unless defined(&my_init_dynamic_array);
    eval 'sub my_init_dynamic_array_ci {
        my($A,$B,$C,$D) = @_;
	    eval q( &init_dynamic_array($A,$B,$C,$D  &ORIG_CALLER_INFO));
    }' unless defined(&my_init_dynamic_array_ci);
    eval 'sub dynamic_array_ptr {
        my($array,$array_index) = @_;
	    eval q((($array)-> &buffer+($array_index)*($array)-> &size_of_element));
    }' unless defined(&dynamic_array_ptr);
    eval 'sub dynamic_element {
        my($array,$array_index,$type) = @_;
	    eval q((($type)(($array)-> &buffer) +($array_index)));
    }' unless defined(&dynamic_element);
    eval 'sub push_dynamic {
        my($A,$B) = @_;
	    eval q( &insert_dynamic($A,$B));
    }' unless defined(&push_dynamic);
    if(defined(&HAVE_MLOCK)) {
    } else {
	eval 'sub my_malloc_lock {
	    my($A,$B) = @_;
    	    eval q( &my_malloc(($A),($B)));
	}' unless defined(&my_malloc_lock);
	eval 'sub my_free_lock {
	    my($A,$B) = @_;
    	    eval q( &my_free(($A),($B)));
	}' unless defined(&my_free_lock);
    }
    eval 'sub alloc_root_inited {
        my($A) = @_;
	    eval q((($A)-> &min_malloc != 0));
    }' unless defined(&alloc_root_inited);
    if(defined( &_MSC_VER)  && !defined( &__WIN__)) {
    }
    if(defined(&__WIN__)) {
    }
    if(defined(&__cplusplus)) {
    }
    require 'raid.ph';
}
1;
