require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&NET_SNMP_CMU_COMPAT_H)) {
    eval 'sub NET_SNMP_CMU_COMPAT_H () {1;}' unless defined(&NET_SNMP_CMU_COMPAT_H);
    if(defined(&__cplusplus)) {
    }
    require 'net-snmp/definitions.ph';
    eval 'sub ACCESS_READONLY () { &MIB_ACCESS_READONLY;}' unless defined(&ACCESS_READONLY);
    eval 'sub ACCESS_READWRITE () { &MIB_ACCESS_READWRITE;}' unless defined(&ACCESS_READWRITE);
    eval 'sub ACCESS_WRITEONLY () { &MIB_ACCESS_WRITEONLY;}' unless defined(&ACCESS_WRITEONLY);
    eval 'sub ACCESS_NOACCESS () { &MIB_ACCESS_NOACCESS;}' unless defined(&ACCESS_NOACCESS);
    eval 'sub ACCESS_NOTIFY () { &MIB_ACCESS_NOTIFY;}' unless defined(&ACCESS_NOTIFY);
    eval 'sub ACCESS_CREATE () { &MIB_ACCESS_CREATE;}' unless defined(&ACCESS_CREATE);
    eval 'sub STATUS_MANDATORY () { &MIB_STATUS_MANDATORY;}' unless defined(&STATUS_MANDATORY);
    eval 'sub STATUS_OPTIONAL () { &MIB_STATUS_OPTIONAL;}' unless defined(&STATUS_OPTIONAL);
    eval 'sub STATUS_OBSOLETE () { &MIB_STATUS_OBSOLETE;}' unless defined(&STATUS_OBSOLETE);
    eval 'sub STATUS_DEPRECATED () { &MIB_STATUS_DEPRECATED;}' unless defined(&STATUS_DEPRECATED);
    eval 'sub STATUS_CURRENT () { &MIB_STATUS_CURRENT;}' unless defined(&STATUS_CURRENT);
    eval 'sub INTEGER () { &ASN_INTEGER;}' unless defined(&INTEGER);
    eval 'sub STRING () { &ASN_OCTET_STR;}' unless defined(&STRING);
    eval 'sub OBJID () { &ASN_OBJECT_ID;}' unless defined(&OBJID);
    eval 'sub NULLOBJ () { &ASN_NULL;}' unless defined(&NULLOBJ);
    eval 'sub BITSTRING () { &ASN_BIT_STR;}' unless defined(&BITSTRING);
    eval 'sub IPADDRESS () { &ASN_IPADDRESS;}' unless defined(&IPADDRESS);
    eval 'sub COUNTER () { &ASN_COUNTER;}' unless defined(&COUNTER);
    eval 'sub GAUGE () { &ASN_GAUGE;}' unless defined(&GAUGE);
    eval 'sub UNSIGNED () { &ASN_UNSIGNED;}' unless defined(&UNSIGNED);
    eval 'sub TIMETICKS () { &ASN_TIMETICKS;}' unless defined(&TIMETICKS);
    eval 'sub ASNT_OPAQUE () { &ASN_OPAQUE;}' unless defined(&ASNT_OPAQUE);
    eval 'sub NSAP () { &ASN_NSAP;}' unless defined(&NSAP);
    eval 'sub COUNTER64 () { &ASN_COUNTER64;}' unless defined(&COUNTER64);
    eval 'sub UINTEGER () { &ASN_UINTEGER;}' unless defined(&UINTEGER);
    eval 'sub GET_REQ_MSG () { &SNMP_MSG_GET;}' unless defined(&GET_REQ_MSG);
    eval 'sub GETNEXT_REQ_MSG () { &SNMP_MSG_GETNEXT;}' unless defined(&GETNEXT_REQ_MSG);
    eval 'sub GET_RSP_MSG () { &SNMP_MSG_RESPONSE;}' unless defined(&GET_RSP_MSG);
    eval 'sub SET_REQ_MSG () { &SNMP_MSG_SET;}' unless defined(&SET_REQ_MSG);
    eval 'sub TRP_REQ_MSG () { &SNMP_MSG_TRAP;}' unless defined(&TRP_REQ_MSG);
    eval 'sub BULK_REQ_MSG () { &SNMP_MSG_GETBULK;}' unless defined(&BULK_REQ_MSG);
    eval 'sub INFORM_REQ_MSG () { &SNMP_MSG_INFORM;}' unless defined(&INFORM_REQ_MSG);
    eval 'sub TRP2_REQ_MSG () { &SNMP_MSG_TRAP2;}' unless defined(&TRP2_REQ_MSG);
    eval 'sub REPORT_RSP_MSG () { &SNMP_MSG_REPORT;}' unless defined(&REPORT_RSP_MSG);
    eval 'sub SNMP_PDU_GET () { &SNMP_MSG_GET;}' unless defined(&SNMP_PDU_GET);
    eval 'sub SNMP_PDU_GETNEXT () { &SNMP_MSG_GETNEXT;}' unless defined(&SNMP_PDU_GETNEXT);
    eval 'sub SNMP_PDU_RESPONSE () { &SNMP_MSG_RESPONSE;}' unless defined(&SNMP_PDU_RESPONSE);
    eval 'sub SNMP_PDU_SET () { &SNMP_MSG_SET;}' unless defined(&SNMP_PDU_SET);
    eval 'sub SNMP_PDU_GETBULK () { &SNMP_MSG_GETBULK;}' unless defined(&SNMP_PDU_GETBULK);
    eval 'sub SNMP_PDU_INFORM () { &SNMP_MSG_INFORM;}' unless defined(&SNMP_PDU_INFORM);
    eval 'sub SNMP_PDU_V2TRAP () { &SNMP_MSG_TRAP2;}' unless defined(&SNMP_PDU_V2TRAP);
    eval 'sub SNMP_PDU_REPORT () { &SNMP_MSG_REPORT;}' unless defined(&SNMP_PDU_REPORT);
    eval 'sub SNMP_TRAP_AUTHENTICATIONFAILURE () { &SNMP_TRAP_AUTHFAIL;}' unless defined(&SNMP_TRAP_AUTHENTICATIONFAILURE);
    eval 'sub SMI_INTEGER () { &ASN_INTEGER;}' unless defined(&SMI_INTEGER);
    eval 'sub SMI_STRING () { &ASN_OCTET_STR;}' unless defined(&SMI_STRING);
    eval 'sub SMI_OBJID () { &ASN_OBJECT_ID;}' unless defined(&SMI_OBJID);
    eval 'sub SMI_NULLOBJ () { &ASN_NULL;}' unless defined(&SMI_NULLOBJ);
    eval 'sub SMI_IPADDRESS () { &ASN_IPADDRESS;}' unless defined(&SMI_IPADDRESS);
    eval 'sub SMI_COUNTER32 () { &ASN_COUNTER;}' unless defined(&SMI_COUNTER32);
    eval 'sub SMI_GAUGE32 () { &ASN_GAUGE;}' unless defined(&SMI_GAUGE32);
    eval 'sub SMI_UNSIGNED32 () { &SMI_GAUGE32;}' unless defined(&SMI_UNSIGNED32);
    eval 'sub SMI_TIMETICKS () { &ASN_TIMETICKS;}' unless defined(&SMI_TIMETICKS);
    eval 'sub SMI_OPAQUE () { &ASN_OPAQUE;}' unless defined(&SMI_OPAQUE);
    eval 'sub SMI_COUNTER64 () { &ASN_COUNTER64;}' unless defined(&SMI_COUNTER64);
    require 'net-snmp/types.ph';
    if(defined(&__cplusplus)) {
    }
}
1;
