require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SNMP_API_H)) {
    eval 'sub SNMP_API_H () {1;}' unless defined(&SNMP_API_H);
    unless(defined(&DONT_SHARE_ERROR_WITH_OTHER_THREADS)) {
	eval 'sub SET_SNMP_ERROR {
	    my($x) = @_;
    	    eval q( &snmp_errno=($x));
	}' unless defined(&SET_SNMP_ERROR);
    } else {
	eval 'sub SET_SNMP_ERROR {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&SET_SNMP_ERROR);
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub USM_AUTH_KU_LEN () {32;}' unless defined(&USM_AUTH_KU_LEN);
    eval 'sub USM_PRIV_KU_LEN () {32;}' unless defined(&USM_PRIV_KU_LEN);
    if(defined(&SNMP_NEED_REQUEST_LIST)) {
    }
    eval 'sub SNMP_DEFAULT_COMMUNITY_LEN () {0;}' unless defined(&SNMP_DEFAULT_COMMUNITY_LEN);
    eval 'sub SNMP_DEFAULT_RETRIES () {-1;}' unless defined(&SNMP_DEFAULT_RETRIES);
    eval 'sub SNMP_DEFAULT_TIMEOUT () {-1;}' unless defined(&SNMP_DEFAULT_TIMEOUT);
    eval 'sub SNMP_DEFAULT_REMPORT () {0;}' unless defined(&SNMP_DEFAULT_REMPORT);
    eval 'sub SNMP_DEFAULT_REQID () {-1;}' unless defined(&SNMP_DEFAULT_REQID);
    eval 'sub SNMP_DEFAULT_MSGID () {-1;}' unless defined(&SNMP_DEFAULT_MSGID);
    eval 'sub SNMP_DEFAULT_ERRSTAT () {-1;}' unless defined(&SNMP_DEFAULT_ERRSTAT);
    eval 'sub SNMP_DEFAULT_ERRINDEX () {-1;}' unless defined(&SNMP_DEFAULT_ERRINDEX);
    eval 'sub SNMP_DEFAULT_ADDRESS () {0;}' unless defined(&SNMP_DEFAULT_ADDRESS);
    eval 'sub SNMP_DEFAULT_PEERNAME () { &NULL;}' unless defined(&SNMP_DEFAULT_PEERNAME);
    eval 'sub SNMP_DEFAULT_ENTERPRISE_LENGTH () {0;}' unless defined(&SNMP_DEFAULT_ENTERPRISE_LENGTH);
    eval 'sub SNMP_DEFAULT_TIME () {0;}' unless defined(&SNMP_DEFAULT_TIME);
    eval 'sub SNMP_DEFAULT_VERSION () {-1;}' unless defined(&SNMP_DEFAULT_VERSION);
    eval 'sub SNMP_DEFAULT_SECMODEL () {-1;}' unless defined(&SNMP_DEFAULT_SECMODEL);
    eval 'sub SNMP_DEFAULT_CONTEXT () {"";}' unless defined(&SNMP_DEFAULT_CONTEXT);
    eval 'sub SNMP_DEFAULT_AUTH_PROTO () { &usmHMACMD5AuthProtocol;}' unless defined(&SNMP_DEFAULT_AUTH_PROTO);
    eval 'sub SNMP_DEFAULT_AUTH_PROTOLEN () { &USM_LENGTH_OID_TRANSFORM;}' unless defined(&SNMP_DEFAULT_AUTH_PROTOLEN);
    eval 'sub SNMP_DEFAULT_PRIV_PROTO () { &usmDESPrivProtocol;}' unless defined(&SNMP_DEFAULT_PRIV_PROTO);
    eval 'sub SNMP_DEFAULT_PRIV_PROTOLEN () { &USM_LENGTH_OID_TRANSFORM;}' unless defined(&SNMP_DEFAULT_PRIV_PROTOLEN);
    eval 'sub SNMP_MAX_MSG_SIZE () {1472;}' unless defined(&SNMP_MAX_MSG_SIZE);
    eval 'sub SNMP_MAX_MSG_V3_HDRS () {(4+3+4+7+7+3+7+16);}' unless defined(&SNMP_MAX_MSG_V3_HDRS);
    eval 'sub SNMP_MAX_ENG_SIZE () {32;}' unless defined(&SNMP_MAX_ENG_SIZE);
    eval 'sub SNMP_MAX_SEC_NAME_SIZE () {256;}' unless defined(&SNMP_MAX_SEC_NAME_SIZE);
    eval 'sub SNMP_MAX_CONTEXT_SIZE () {256;}' unless defined(&SNMP_MAX_CONTEXT_SIZE);
    eval 'sub SNMP_SEC_PARAM_BUF_SIZE () {256;}' unless defined(&SNMP_SEC_PARAM_BUF_SIZE);
    eval 'sub SNMPV3_IGNORE_UNAUTH_REPORTS () {0;}' unless defined(&SNMPV3_IGNORE_UNAUTH_REPORTS);
    eval 'sub SNMP_SESS_NONAUTHORITATIVE () {0;}' unless defined(&SNMP_SESS_NONAUTHORITATIVE);
    eval 'sub SNMP_SESS_AUTHORITATIVE () {1;}' unless defined(&SNMP_SESS_AUTHORITATIVE);
    eval 'sub SNMP_SESS_UNKNOWNAUTH () {2;}' unless defined(&SNMP_SESS_UNKNOWNAUTH);
    eval 'sub REPORT_STATS_LEN () {9;}' unless defined(&REPORT_STATS_LEN);
    eval 'sub REPORT_snmpUnknownSecurityModels_NUM () {1;}' unless defined(&REPORT_snmpUnknownSecurityModels_NUM);
    eval 'sub REPORT_snmpInvalidMsgs_NUM () {2;}' unless defined(&REPORT_snmpInvalidMsgs_NUM);
    eval 'sub REPORT_usmStatsUnsupportedSecLevels_NUM () {1;}' unless defined(&REPORT_usmStatsUnsupportedSecLevels_NUM);
    eval 'sub REPORT_usmStatsNotInTimeWindows_NUM () {2;}' unless defined(&REPORT_usmStatsNotInTimeWindows_NUM);
    eval 'sub REPORT_usmStatsUnknownUserNames_NUM () {3;}' unless defined(&REPORT_usmStatsUnknownUserNames_NUM);
    eval 'sub REPORT_usmStatsUnknownEngineIDs_NUM () {4;}' unless defined(&REPORT_usmStatsUnknownEngineIDs_NUM);
    eval 'sub REPORT_usmStatsWrongDigests_NUM () {5;}' unless defined(&REPORT_usmStatsWrongDigests_NUM);
    eval 'sub REPORT_usmStatsDecryptionErrors_NUM () {6;}' unless defined(&REPORT_usmStatsDecryptionErrors_NUM);
    eval 'sub SNMP_DETAIL_SIZE () {512;}' unless defined(&SNMP_DETAIL_SIZE);
    eval 'sub SNMP_FLAGS_DONT_PROBE () {0x100;}' unless defined(&SNMP_FLAGS_DONT_PROBE);
    eval 'sub SNMP_FLAGS_STREAM_SOCKET () {0x80;}' unless defined(&SNMP_FLAGS_STREAM_SOCKET);
    eval 'sub SNMP_FLAGS_LISTENING () {0x40;}' unless defined(&SNMP_FLAGS_LISTENING);
    eval 'sub SNMP_FLAGS_SUBSESSION () {0x20;}' unless defined(&SNMP_FLAGS_SUBSESSION);
    eval 'sub SNMP_FLAGS_STRIKE2 () {0x2;}' unless defined(&SNMP_FLAGS_STRIKE2);
    eval 'sub SNMP_FLAGS_STRIKE1 () {0x1;}' unless defined(&SNMP_FLAGS_STRIKE1);
    eval 'sub CLEAR_SNMP_STRIKE_FLAGS {
        my($x) = @_;
	    eval q($x &= ~( &SNMP_FLAGS_STRIKE2| &SNMP_FLAGS_STRIKE1));
    }' unless defined(&CLEAR_SNMP_STRIKE_FLAGS);
    eval 'sub SET_SNMP_STRIKE_FLAGS {
        my($x) = @_;
	    eval q((( $x &  &SNMP_FLAGS_STRIKE2 ) ? 1: ((( $x &  &SNMP_FLAGS_STRIKE1 ) ? ( $x |=  &SNMP_FLAGS_STRIKE2 ) : ( $x |=  &SNMP_FLAGS_STRIKE1 )), 0)));
    }' unless defined(&SET_SNMP_STRIKE_FLAGS);
    eval 'sub SNMPERR_SUCCESS () {(0);}' unless defined(&SNMPERR_SUCCESS);
    eval 'sub SNMPERR_GENERR () {(-1);}' unless defined(&SNMPERR_GENERR);
    eval 'sub SNMPERR_BAD_LOCPORT () {(-2);}' unless defined(&SNMPERR_BAD_LOCPORT);
    eval 'sub SNMPERR_BAD_ADDRESS () {(-3);}' unless defined(&SNMPERR_BAD_ADDRESS);
    eval 'sub SNMPERR_BAD_SESSION () {(-4);}' unless defined(&SNMPERR_BAD_SESSION);
    eval 'sub SNMPERR_TOO_LONG () {(-5);}' unless defined(&SNMPERR_TOO_LONG);
    eval 'sub SNMPERR_NO_SOCKET () {(-6);}' unless defined(&SNMPERR_NO_SOCKET);
    eval 'sub SNMPERR_V2_IN_V1 () {(-7);}' unless defined(&SNMPERR_V2_IN_V1);
    eval 'sub SNMPERR_V1_IN_V2 () {(-8);}' unless defined(&SNMPERR_V1_IN_V2);
    eval 'sub SNMPERR_BAD_REPEATERS () {(-9);}' unless defined(&SNMPERR_BAD_REPEATERS);
    eval 'sub SNMPERR_BAD_REPETITIONS () {(-10);}' unless defined(&SNMPERR_BAD_REPETITIONS);
    eval 'sub SNMPERR_BAD_ASN1_BUILD () {(-11);}' unless defined(&SNMPERR_BAD_ASN1_BUILD);
    eval 'sub SNMPERR_BAD_SENDTO () {(-12);}' unless defined(&SNMPERR_BAD_SENDTO);
    eval 'sub SNMPERR_BAD_PARSE () {(-13);}' unless defined(&SNMPERR_BAD_PARSE);
    eval 'sub SNMPERR_BAD_VERSION () {(-14);}' unless defined(&SNMPERR_BAD_VERSION);
    eval 'sub SNMPERR_BAD_SRC_PARTY () {(-15);}' unless defined(&SNMPERR_BAD_SRC_PARTY);
    eval 'sub SNMPERR_BAD_DST_PARTY () {(-16);}' unless defined(&SNMPERR_BAD_DST_PARTY);
    eval 'sub SNMPERR_BAD_CONTEXT () {(-17);}' unless defined(&SNMPERR_BAD_CONTEXT);
    eval 'sub SNMPERR_BAD_COMMUNITY () {(-18);}' unless defined(&SNMPERR_BAD_COMMUNITY);
    eval 'sub SNMPERR_NOAUTH_DESPRIV () {(-19);}' unless defined(&SNMPERR_NOAUTH_DESPRIV);
    eval 'sub SNMPERR_BAD_ACL () {(-20);}' unless defined(&SNMPERR_BAD_ACL);
    eval 'sub SNMPERR_BAD_PARTY () {(-21);}' unless defined(&SNMPERR_BAD_PARTY);
    eval 'sub SNMPERR_ABORT () {(-22);}' unless defined(&SNMPERR_ABORT);
    eval 'sub SNMPERR_UNKNOWN_PDU () {(-23);}' unless defined(&SNMPERR_UNKNOWN_PDU);
    eval 'sub SNMPERR_TIMEOUT () {(-24);}' unless defined(&SNMPERR_TIMEOUT);
    eval 'sub SNMPERR_BAD_RECVFROM () {(-25);}' unless defined(&SNMPERR_BAD_RECVFROM);
    eval 'sub SNMPERR_BAD_ENG_ID () {(-26);}' unless defined(&SNMPERR_BAD_ENG_ID);
    eval 'sub SNMPERR_BAD_SEC_NAME () {(-27);}' unless defined(&SNMPERR_BAD_SEC_NAME);
    eval 'sub SNMPERR_BAD_SEC_LEVEL () {(-28);}' unless defined(&SNMPERR_BAD_SEC_LEVEL);
    eval 'sub SNMPERR_ASN_PARSE_ERR () {(-29);}' unless defined(&SNMPERR_ASN_PARSE_ERR);
    eval 'sub SNMPERR_UNKNOWN_SEC_MODEL () {(-30);}' unless defined(&SNMPERR_UNKNOWN_SEC_MODEL);
    eval 'sub SNMPERR_INVALID_MSG () {(-31);}' unless defined(&SNMPERR_INVALID_MSG);
    eval 'sub SNMPERR_UNKNOWN_ENG_ID () {(-32);}' unless defined(&SNMPERR_UNKNOWN_ENG_ID);
    eval 'sub SNMPERR_UNKNOWN_USER_NAME () {(-33);}' unless defined(&SNMPERR_UNKNOWN_USER_NAME);
    eval 'sub SNMPERR_UNSUPPORTED_SEC_LEVEL () {(-34);}' unless defined(&SNMPERR_UNSUPPORTED_SEC_LEVEL);
    eval 'sub SNMPERR_AUTHENTICATION_FAILURE () {(-35);}' unless defined(&SNMPERR_AUTHENTICATION_FAILURE);
    eval 'sub SNMPERR_NOT_IN_TIME_WINDOW () {(-36);}' unless defined(&SNMPERR_NOT_IN_TIME_WINDOW);
    eval 'sub SNMPERR_DECRYPTION_ERR () {(-37);}' unless defined(&SNMPERR_DECRYPTION_ERR);
    eval 'sub SNMPERR_SC_GENERAL_FAILURE () {(-38);}' unless defined(&SNMPERR_SC_GENERAL_FAILURE);
    eval 'sub SNMPERR_SC_NOT_CONFIGURED () {(-39);}' unless defined(&SNMPERR_SC_NOT_CONFIGURED);
    eval 'sub SNMPERR_KT_NOT_AVAILABLE () {(-40);}' unless defined(&SNMPERR_KT_NOT_AVAILABLE);
    eval 'sub SNMPERR_UNKNOWN_REPORT () {(-41);}' unless defined(&SNMPERR_UNKNOWN_REPORT);
    eval 'sub SNMPERR_USM_GENERICERROR () {(-42);}' unless defined(&SNMPERR_USM_GENERICERROR);
    eval 'sub SNMPERR_USM_UNKNOWNSECURITYNAME () {(-43);}' unless defined(&SNMPERR_USM_UNKNOWNSECURITYNAME);
    eval 'sub SNMPERR_USM_UNSUPPORTEDSECURITYLEVEL () {(-44);}' unless defined(&SNMPERR_USM_UNSUPPORTEDSECURITYLEVEL);
    eval 'sub SNMPERR_USM_ENCRYPTIONERROR () {(-45);}' unless defined(&SNMPERR_USM_ENCRYPTIONERROR);
    eval 'sub SNMPERR_USM_AUTHENTICATIONFAILURE () {(-46);}' unless defined(&SNMPERR_USM_AUTHENTICATIONFAILURE);
    eval 'sub SNMPERR_USM_PARSEERROR () {(-47);}' unless defined(&SNMPERR_USM_PARSEERROR);
    eval 'sub SNMPERR_USM_UNKNOWNENGINEID () {(-48);}' unless defined(&SNMPERR_USM_UNKNOWNENGINEID);
    eval 'sub SNMPERR_USM_NOTINTIMEWINDOW () {(-49);}' unless defined(&SNMPERR_USM_NOTINTIMEWINDOW);
    eval 'sub SNMPERR_USM_DECRYPTIONERROR () {(-50);}' unless defined(&SNMPERR_USM_DECRYPTIONERROR);
    eval 'sub SNMPERR_NOMIB () {(-51);}' unless defined(&SNMPERR_NOMIB);
    eval 'sub SNMPERR_RANGE () {(-52);}' unless defined(&SNMPERR_RANGE);
    eval 'sub SNMPERR_MAX_SUBID () {(-53);}' unless defined(&SNMPERR_MAX_SUBID);
    eval 'sub SNMPERR_BAD_SUBID () {(-54);}' unless defined(&SNMPERR_BAD_SUBID);
    eval 'sub SNMPERR_LONG_OID () {(-55);}' unless defined(&SNMPERR_LONG_OID);
    eval 'sub SNMPERR_BAD_NAME () {(-56);}' unless defined(&SNMPERR_BAD_NAME);
    eval 'sub SNMPERR_VALUE () {(-57);}' unless defined(&SNMPERR_VALUE);
    eval 'sub SNMPERR_UNKNOWN_OBJID () {(-58);}' unless defined(&SNMPERR_UNKNOWN_OBJID);
    eval 'sub SNMPERR_NULL_PDU () {(-59);}' unless defined(&SNMPERR_NULL_PDU);
    eval 'sub SNMPERR_NO_VARS () {(-60);}' unless defined(&SNMPERR_NO_VARS);
    eval 'sub SNMPERR_VAR_TYPE () {(-61);}' unless defined(&SNMPERR_VAR_TYPE);
    eval 'sub SNMPERR_MALLOC () {(-62);}' unless defined(&SNMPERR_MALLOC);
    eval 'sub SNMPERR_KRB5 () {(-63);}' unless defined(&SNMPERR_KRB5);
    eval 'sub SNMPERR_MAX () {(-63);}' unless defined(&SNMPERR_MAX);
    eval 'sub non_repeaters () { &errstat;}' unless defined(&non_repeaters);
    eval 'sub max_repetitions () { &errindex;}' unless defined(&max_repetitions);
    if(defined(&OPAQUE_SPECIAL_TYPES)) {
    }
    eval 'sub NETSNMP_CALLBACK_OP_RECEIVED_MESSAGE () {1;}' unless defined(&NETSNMP_CALLBACK_OP_RECEIVED_MESSAGE);
    eval 'sub NETSNMP_CALLBACK_OP_TIMED_OUT () {2;}' unless defined(&NETSNMP_CALLBACK_OP_TIMED_OUT);
    eval 'sub NETSNMP_CALLBACK_OP_SEND_FAILED () {3;}' unless defined(&NETSNMP_CALLBACK_OP_SEND_FAILED);
    eval 'sub NETSNMP_CALLBACK_OP_CONNECT () {4;}' unless defined(&NETSNMP_CALLBACK_OP_CONNECT);
    eval 'sub NETSNMP_CALLBACK_OP_DISCONNECT () {5;}' unless defined(&NETSNMP_CALLBACK_OP_DISCONNECT);
    if(defined(&USE_REVERSE_ASNENCODING)) {
    }
    if(defined(&USE_REVERSE_ASNENCODING)) {
    }
    eval 'sub STAT_SNMPUNKNOWNSECURITYMODELS () {0;}' unless defined(&STAT_SNMPUNKNOWNSECURITYMODELS);
    eval 'sub STAT_SNMPINVALIDMSGS () {1;}' unless defined(&STAT_SNMPINVALIDMSGS);
    eval 'sub STAT_SNMPUNKNOWNPDUHANDLERS () {2;}' unless defined(&STAT_SNMPUNKNOWNPDUHANDLERS);
    eval 'sub STAT_MPD_STATS_START () { &STAT_SNMPUNKNOWNSECURITYMODELS;}' unless defined(&STAT_MPD_STATS_START);
    eval 'sub STAT_MPD_STATS_END () { &STAT_SNMPUNKNOWNPDUHANDLERS;}' unless defined(&STAT_MPD_STATS_END);
    eval 'sub STAT_USMSTATSUNSUPPORTEDSECLEVELS () {3;}' unless defined(&STAT_USMSTATSUNSUPPORTEDSECLEVELS);
    eval 'sub STAT_USMSTATSNOTINTIMEWINDOWS () {4;}' unless defined(&STAT_USMSTATSNOTINTIMEWINDOWS);
    eval 'sub STAT_USMSTATSUNKNOWNUSERNAMES () {5;}' unless defined(&STAT_USMSTATSUNKNOWNUSERNAMES);
    eval 'sub STAT_USMSTATSUNKNOWNENGINEIDS () {6;}' unless defined(&STAT_USMSTATSUNKNOWNENGINEIDS);
    eval 'sub STAT_USMSTATSWRONGDIGESTS () {7;}' unless defined(&STAT_USMSTATSWRONGDIGESTS);
    eval 'sub STAT_USMSTATSDECRYPTIONERRORS () {8;}' unless defined(&STAT_USMSTATSDECRYPTIONERRORS);
    eval 'sub STAT_USM_STATS_START () { &STAT_USMSTATSUNSUPPORTEDSECLEVELS;}' unless defined(&STAT_USM_STATS_START);
    eval 'sub STAT_USM_STATS_END () { &STAT_USMSTATSDECRYPTIONERRORS;}' unless defined(&STAT_USM_STATS_END);
    eval 'sub STAT_SNMPINPKTS () {9;}' unless defined(&STAT_SNMPINPKTS);
    eval 'sub STAT_SNMPOUTPKTS () {10;}' unless defined(&STAT_SNMPOUTPKTS);
    eval 'sub STAT_SNMPINBADVERSIONS () {11;}' unless defined(&STAT_SNMPINBADVERSIONS);
    eval 'sub STAT_SNMPINBADCOMMUNITYNAMES () {12;}' unless defined(&STAT_SNMPINBADCOMMUNITYNAMES);
    eval 'sub STAT_SNMPINBADCOMMUNITYUSES () {13;}' unless defined(&STAT_SNMPINBADCOMMUNITYUSES);
    eval 'sub STAT_SNMPINASNPARSEERRS () {14;}' unless defined(&STAT_SNMPINASNPARSEERRS);
    eval 'sub STAT_SNMPINTOOBIGS () {16;}' unless defined(&STAT_SNMPINTOOBIGS);
    eval 'sub STAT_SNMPINNOSUCHNAMES () {17;}' unless defined(&STAT_SNMPINNOSUCHNAMES);
    eval 'sub STAT_SNMPINBADVALUES () {18;}' unless defined(&STAT_SNMPINBADVALUES);
    eval 'sub STAT_SNMPINREADONLYS () {19;}' unless defined(&STAT_SNMPINREADONLYS);
    eval 'sub STAT_SNMPINGENERRS () {20;}' unless defined(&STAT_SNMPINGENERRS);
    eval 'sub STAT_SNMPINTOTALREQVARS () {21;}' unless defined(&STAT_SNMPINTOTALREQVARS);
    eval 'sub STAT_SNMPINTOTALSETVARS () {22;}' unless defined(&STAT_SNMPINTOTALSETVARS);
    eval 'sub STAT_SNMPINGETREQUESTS () {23;}' unless defined(&STAT_SNMPINGETREQUESTS);
    eval 'sub STAT_SNMPINGETNEXTS () {24;}' unless defined(&STAT_SNMPINGETNEXTS);
    eval 'sub STAT_SNMPINSETREQUESTS () {25;}' unless defined(&STAT_SNMPINSETREQUESTS);
    eval 'sub STAT_SNMPINGETRESPONSES () {26;}' unless defined(&STAT_SNMPINGETRESPONSES);
    eval 'sub STAT_SNMPINTRAPS () {27;}' unless defined(&STAT_SNMPINTRAPS);
    eval 'sub STAT_SNMPOUTTOOBIGS () {28;}' unless defined(&STAT_SNMPOUTTOOBIGS);
    eval 'sub STAT_SNMPOUTNOSUCHNAMES () {29;}' unless defined(&STAT_SNMPOUTNOSUCHNAMES);
    eval 'sub STAT_SNMPOUTBADVALUES () {30;}' unless defined(&STAT_SNMPOUTBADVALUES);
    eval 'sub STAT_SNMPOUTGENERRS () {32;}' unless defined(&STAT_SNMPOUTGENERRS);
    eval 'sub STAT_SNMPOUTGETREQUESTS () {33;}' unless defined(&STAT_SNMPOUTGETREQUESTS);
    eval 'sub STAT_SNMPOUTGETNEXTS () {34;}' unless defined(&STAT_SNMPOUTGETNEXTS);
    eval 'sub STAT_SNMPOUTSETREQUESTS () {35;}' unless defined(&STAT_SNMPOUTSETREQUESTS);
    eval 'sub STAT_SNMPOUTGETRESPONSES () {36;}' unless defined(&STAT_SNMPOUTGETRESPONSES);
    eval 'sub STAT_SNMPOUTTRAPS () {37;}' unless defined(&STAT_SNMPOUTTRAPS);
    eval 'sub STAT_SNMPSILENTDROPS () {39;}' unless defined(&STAT_SNMPSILENTDROPS);
    eval 'sub STAT_SNMPPROXYDROPS () {40;}' unless defined(&STAT_SNMPPROXYDROPS);
    eval 'sub STAT_SNMP_STATS_START () { &STAT_SNMPINPKTS;}' unless defined(&STAT_SNMP_STATS_START);
    eval 'sub STAT_SNMP_STATS_END () { &STAT_SNMPPROXYDROPS;}' unless defined(&STAT_SNMP_STATS_END);
    eval 'sub STAT_SNMPUNAVAILABLECONTEXTS () {41;}' unless defined(&STAT_SNMPUNAVAILABLECONTEXTS);
    eval 'sub STAT_SNMPUNKNOWNCONTEXTS () {42;}' unless defined(&STAT_SNMPUNKNOWNCONTEXTS);
    eval 'sub STAT_TARGET_STATS_START () { &STAT_SNMPUNAVAILABLECONTEXTS;}' unless defined(&STAT_TARGET_STATS_START);
    eval 'sub STAT_TARGET_STATS_END () { &STAT_SNMPUNKNOWNCONTEXTS;}' unless defined(&STAT_TARGET_STATS_END);
    eval 'sub MAX_STATS () {43;}' unless defined(&MAX_STATS);
    if(defined(&__cplusplus)) {
    }
}
1;
