require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SNMP_ASSERT_H)) {
    eval 'sub SNMP_ASSERT_H () {1;}' unless defined(&SNMP_ASSERT_H);
    if(defined(&NETSNMP_USE_ASSERT)) {
	require 'assert.ph';
    } else {
	require 'net-snmp/library/snmp_logging.ph';
    }
    if(defined(&DEBUG)) {
	if(defined(&NETSNMP_USE_ASSERT)) {
	    eval 'sub netsnmp_assert {
	        my($x) = @_;
    		eval q( &assert( $x ));
	    }' unless defined(&netsnmp_assert);
	} else {
	    if(defined(&HAVE_CPP_UNDERBAR_FUNCTION_DEFINED)) {
		eval 'sub netsnmp_assert {
		    my($x) = @_;
    		    eval q( &do {  &if ( $x ) ;  &else  &snmp_log( &LOG_ERR,\\"netsnmp_assert %s failed %s:%d %s()\\\\n\\",  &__STRING($x), &__FILE__, &__LINE__, &__FUNCTION__); } &while(0));
		}' unless defined(&netsnmp_assert);
	    } else {
		eval 'sub netsnmp_assert {
		    my($x) = @_;
    		    eval q( &do {  &if( $x ) ;  &else  &snmp_log( &LOG_ERR,\\"netsnmp_assert %s failed %s:%d\\\\n\\",  &__STRING($x), &__FILE__, &__LINE__); } &while(0));
		}' unless defined(&netsnmp_assert);
	    }
	}
    } else {
	eval 'sub netsnmp_assert {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&netsnmp_assert);
    }
}
1;
