require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SNMP_IMPL_H)) {
    eval 'sub SNMP_IMPL_H () {1;}' unless defined(&SNMP_IMPL_H);
    if(defined(&__cplusplus)) {
    }
    require 'stdio.ph';
    require 'net-snmp/types.ph';
    eval 'sub COMMUNITY_MAX_LEN () {256;}' unless defined(&COMMUNITY_MAX_LEN);
    eval 'sub SPRINT_MAX_LEN () {2560;}' unless defined(&SPRINT_MAX_LEN);
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    eval 'sub READ () {1;}' unless defined(&READ);
    eval 'sub WRITE () {0;}' unless defined(&WRITE);
    eval 'sub RESERVE1 () {0;}' unless defined(&RESERVE1);
    eval 'sub RESERVE2 () {1;}' unless defined(&RESERVE2);
    eval 'sub ACTION () {2;}' unless defined(&ACTION);
    eval 'sub COMMIT () {3;}' unless defined(&COMMIT);
    eval 'sub FREE () {4;}' unless defined(&FREE);
    eval 'sub UNDO () {5;}' unless defined(&UNDO);
    eval 'sub FINISHED_SUCCESS () {9;}' unless defined(&FINISHED_SUCCESS);
    eval 'sub FINISHED_FAILURE () {10;}' unless defined(&FINISHED_FAILURE);
    eval 'sub RONLY () {0x1;}' unless defined(&RONLY);
    eval 'sub RWRITE () {0x2;}' unless defined(&RWRITE);
    eval 'sub NOACCESS () {0x;}' unless defined(&NOACCESS);
    eval 'sub ASN_IPADDRESS () {( &ASN_APPLICATION | 0);}' unless defined(&ASN_IPADDRESS);
    eval 'sub ASN_COUNTER () {( &ASN_APPLICATION | 1);}' unless defined(&ASN_COUNTER);
    eval 'sub ASN_GAUGE () {( &ASN_APPLICATION | 2);}' unless defined(&ASN_GAUGE);
    eval 'sub ASN_UNSIGNED () {( &ASN_APPLICATION | 2);}' unless defined(&ASN_UNSIGNED);
    eval 'sub ASN_TIMETICKS () {( &ASN_APPLICATION | 3);}' unless defined(&ASN_TIMETICKS);
    eval 'sub ASN_OPAQUE () {( &ASN_APPLICATION | 4);}' unless defined(&ASN_OPAQUE);
    eval 'sub ASN_NSAP () {( &ASN_APPLICATION | 5);}' unless defined(&ASN_NSAP);
    eval 'sub ASN_COUNTER64 () {( &ASN_APPLICATION | 6);}' unless defined(&ASN_COUNTER64);
    eval 'sub ASN_UINTEGER () {( &ASN_APPLICATION | 7);}' unless defined(&ASN_UINTEGER);
    if(defined(&OPAQUE_SPECIAL_TYPES)) {
	eval 'sub ASN_FLOAT () {( &ASN_APPLICATION | 8);}' unless defined(&ASN_FLOAT);
	eval 'sub ASN_DOUBLE () {( &ASN_APPLICATION | 9);}' unless defined(&ASN_DOUBLE);
	eval 'sub ASN_INTEGER64 () {( &ASN_APPLICATION | 10);}' unless defined(&ASN_INTEGER64);
	eval 'sub ASN_UNSIGNED64 () {( &ASN_APPLICATION | 11);}' unless defined(&ASN_UNSIGNED64);
    }
    unless(defined(&ERROR_MSG)) {
	eval 'sub ERROR_MSG {
	    my($string) = @_;
    	    eval q( &snmp_set_detail($string));
	}' unless defined(&ERROR_MSG);
    }
    eval 'sub FIRST_PASS () {1;}' unless defined(&FIRST_PASS);
    eval 'sub LAST_PASS () {2;}' unless defined(&LAST_PASS);
    if(defined(&__cplusplus)) {
    }
}
1;
