require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&NET_SNMP_CONFIG_H)) {
    eval 'sub NET_SNMP_CONFIG_H () {1;}' unless defined(&NET_SNMP_CONFIG_H);
    eval 'sub DEFAULT_SNMP_VERSION () {3;}' unless defined(&DEFAULT_SNMP_VERSION);
    eval 'sub SNMPV1 () {0xaaaa;}' unless defined(&SNMPV1);
    eval 'sub SNMPV2ANY () {0xa000;}' unless defined(&SNMPV2ANY);
    eval 'sub SNMPV2AUTH () {0x8000;}' unless defined(&SNMPV2AUTH);
    eval 'sub DEFAULT_MIBS () {"IP-MIB:IF-MIB:TCP-MIB:UDP-MIB:SNMPv2-MIB:RFC1213-MIB:NOTIFICATION-LOG-MIB:UCD-SNMP-MIB:UCD-DEMO-MIB:SNMP-TARGET-MIB:NET-SNMP-AGENT-MIB:HOST-RESOURCES-MIB:HOST-RESOURCES-TYPES:IPV6-ICMP-MIB:IPV6-MIB:IPV6-TCP-MIB:IPV6-UDP-MIB:SNMP-VIEW-BASED-ACM-MIB:SNMP-COMMUNITY-MIB:UCD-DLMOD-MIB:SNMP-FRAMEWORK-MIB:SNMP-MPD-MIB:SNMP-USER-BASED-SM-MIB:SNMP-NOTIFICATION-MIB:SNMPv2-TM";}' unless defined(&DEFAULT_MIBS);
    eval 'sub DEFAULT_MIBDIRS () {"$HOME/.snmp/mibs:/usr/share/snmp/mibs";}' unless defined(&DEFAULT_MIBDIRS);
    eval 'sub OPAQUE_SPECIAL_TYPES () {1;}' unless defined(&OPAQUE_SPECIAL_TYPES);
    eval 'sub UCD_SNMP_LIBRARY () {1;}' unless defined(&UCD_SNMP_LIBRARY);
    eval 'sub SCAPI_AUTHPRIV () {1;}' unless defined(&SCAPI_AUTHPRIV);
    eval 'sub SNMP_ALWAYS_DEBUG () {0;}' unless defined(&SNMP_ALWAYS_DEBUG);
    eval 'sub USE_REVERSE_ASNENCODING () {1;}' unless defined(&USE_REVERSE_ASNENCODING);
    eval 'sub DEFAULT_ASNENCODING_DIRECTION () {1;}' unless defined(&DEFAULT_ASNENCODING_DIRECTION);
    eval 'sub PERSISTENT_DIRECTORY () {"/var/net-snmp";}' unless defined(&PERSISTENT_DIRECTORY);
    eval 'sub PERSISTENT_MASK () {077;}' unless defined(&PERSISTENT_MASK);
    eval 'sub AGENT_DIRECTORY_MODE () {0700;}' unless defined(&AGENT_DIRECTORY_MODE);
    eval 'sub MAX_PERSISTENT_BACKUPS () {10;}' unless defined(&MAX_PERSISTENT_BACKUPS);
    unless(defined(&_ALL_SOURCE)) {
    }
    eval 'sub HAVE_ALLOCA () {1;}' unless defined(&HAVE_ALLOCA);
    eval 'sub HAVE_ALLOCA_H () {1;}' unless defined(&HAVE_ALLOCA_H);
    eval 'sub HAVE_GETMNTENT () {1;}' unless defined(&HAVE_GETMNTENT);
    eval 'sub HAVE_SYS_WAIT_H () {1;}' unless defined(&HAVE_SYS_WAIT_H);
    eval 'sub RETSIGTYPE () { &void;}' unless defined(&RETSIGTYPE);
    eval 'sub STDC_HEADERS () {1;}' unless defined(&STDC_HEADERS);
    eval 'sub TIME_WITH_SYS_TIME () {1;}' unless defined(&TIME_WITH_SYS_TIME);
    eval 'sub SYSTEM_INCLUDE_FILE () {"net-snmp/system/linux.h";}' unless defined(&SYSTEM_INCLUDE_FILE);
    eval 'sub MACHINE_INCLUDE_FILE () {"net-snmp/machine/generic.h";}' unless defined(&MACHINE_INCLUDE_FILE);
    eval 'sub SNMPLIBPATH () {"/usr/lib/snmp";}' unless defined(&SNMPLIBPATH);
    eval 'sub SNMPSHAREPATH () {"/usr/share/snmp";}' unless defined(&SNMPSHAREPATH);
    eval 'sub SNMPCONFPATH () {"/etc/snmp";}' unless defined(&SNMPCONFPATH);
    eval 'sub SNMPDLMODPATH () {"/usr/lib/snmp/dlmod";}' unless defined(&SNMPDLMODPATH);
    eval 'sub LOGFILE () {"/var/log/snmpd.log";}' unless defined(&LOGFILE);
    eval 'sub SYS_CONTACT () {"root@localhost";}' unless defined(&SYS_CONTACT);
    eval 'sub SYS_LOC () {"Unknown";}' unless defined(&SYS_LOC);
    eval 'sub USE_LIBWRAP () {1;}' unless defined(&USE_LIBWRAP);
    eval 'sub KERNEL_LOC () {"unknown";}' unless defined(&KERNEL_LOC);
    eval 'sub ETC_MNTTAB () {"/etc/mtab";}' unless defined(&ETC_MNTTAB);
    eval 'sub PSCMD () {"/bin/ps -e";}' unless defined(&PSCMD);
    eval 'sub UNAMEPROG () {"/bin/uname";}' unless defined(&UNAMEPROG);
    eval 'sub NO_DUMMY_VALUES () {1;}' unless defined(&NO_DUMMY_VALUES);
    eval 'sub HAVE_AES_CFB128_ENCRYPT () {1;}' unless defined(&HAVE_AES_CFB128_ENCRYPT);
    eval 'sub HAVE_BCOPY () {1;}' unless defined(&HAVE_BCOPY);
    eval 'sub HAVE_DLOPEN () {1;}' unless defined(&HAVE_DLOPEN);
    eval 'sub HAVE_EXECV () {1;}' unless defined(&HAVE_EXECV);
    eval 'sub HAVE_FORK () {1;}' unless defined(&HAVE_FORK);
    eval 'sub HAVE_GETADDRINFO () {1;}' unless defined(&HAVE_GETADDRINFO);
    eval 'sub HAVE_GETDTABLESIZE () {1;}' unless defined(&HAVE_GETDTABLESIZE);
    eval 'sub HAVE_GETGRNAM () {1;}' unless defined(&HAVE_GETGRNAM);
    eval 'sub HAVE_GETHOSTNAME () {1;}' unless defined(&HAVE_GETHOSTNAME);
    eval 'sub HAVE_GETLOADAVG () {1;}' unless defined(&HAVE_GETLOADAVG);
    eval 'sub HAVE_GETPAGESIZE () {1;}' unless defined(&HAVE_GETPAGESIZE);
    eval 'sub HAVE_GETPID () {1;}' unless defined(&HAVE_GETPID);
    eval 'sub HAVE_GETPWNAM () {1;}' unless defined(&HAVE_GETPWNAM);
    eval 'sub HAVE_GETTIMEOFDAY () {1;}' unless defined(&HAVE_GETTIMEOFDAY);
    eval 'sub HAVE_IF_FREENAMEINDEX () {1;}' unless defined(&HAVE_IF_FREENAMEINDEX);
    eval 'sub HAVE_IF_NAMEINDEX () {1;}' unless defined(&HAVE_IF_NAMEINDEX);
    eval 'sub HAVE_INDEX () {1;}' unless defined(&HAVE_INDEX);
    eval 'sub HAVE_LRAND48 () {1;}' unless defined(&HAVE_LRAND48);
    eval 'sub HAVE_MEMCPY () {1;}' unless defined(&HAVE_MEMCPY);
    eval 'sub HAVE_MEMMOVE () {1;}' unless defined(&HAVE_MEMMOVE);
    eval 'sub HAVE_MKSTEMP () {1;}' unless defined(&HAVE_MKSTEMP);
    eval 'sub HAVE_NLIST () {1;}' unless defined(&HAVE_NLIST);
    eval 'sub HAVE_RAND () {1;}' unless defined(&HAVE_RAND);
    eval 'sub HAVE_RANDOM () {1;}' unless defined(&HAVE_RANDOM);
    eval 'sub HAVE_REGCOMP () {1;}' unless defined(&HAVE_REGCOMP);
    eval 'sub HAVE_RPMGETPATH () {1;}' unless defined(&HAVE_RPMGETPATH);
    eval 'sub HAVE_SELECT () {1;}' unless defined(&HAVE_SELECT);
    eval 'sub HAVE_SETENV () {1;}' unless defined(&HAVE_SETENV);
    eval 'sub HAVE_SETGID () {1;}' unless defined(&HAVE_SETGID);
    eval 'sub HAVE_SETGROUPS () {1;}' unless defined(&HAVE_SETGROUPS);
    eval 'sub HAVE_SETITIMER () {1;}' unless defined(&HAVE_SETITIMER);
    eval 'sub HAVE_SETLOCALE () {1;}' unless defined(&HAVE_SETLOCALE);
    eval 'sub HAVE_SETMNTENT () {1;}' unless defined(&HAVE_SETMNTENT);
    eval 'sub HAVE_SETSID () {1;}' unless defined(&HAVE_SETSID);
    eval 'sub HAVE_SETUID () {1;}' unless defined(&HAVE_SETUID);
    eval 'sub HAVE_SIGACTION () {1;}' unless defined(&HAVE_SIGACTION);
    eval 'sub HAVE_SIGBLOCK () {1;}' unless defined(&HAVE_SIGBLOCK);
    eval 'sub HAVE_SIGHOLD () {1;}' unless defined(&HAVE_SIGHOLD);
    eval 'sub HAVE_SIGNAL () {1;}' unless defined(&HAVE_SIGNAL);
    eval 'sub HAVE_SIGSET () {1;}' unless defined(&HAVE_SIGSET);
    eval 'sub HAVE_SNPRINTF () {1;}' unless defined(&HAVE_SNPRINTF);
    eval 'sub HAVE_SOCKET () {1;}' unless defined(&HAVE_SOCKET);
    eval 'sub HAVE_STATFS () {1;}' unless defined(&HAVE_STATFS);
    eval 'sub HAVE_STATVFS () {1;}' unless defined(&HAVE_STATVFS);
    eval 'sub HAVE_STRCASESTR () {1;}' unless defined(&HAVE_STRCASESTR);
    eval 'sub HAVE_STRCHR () {1;}' unless defined(&HAVE_STRCHR);
    eval 'sub HAVE_STRDUP () {1;}' unless defined(&HAVE_STRDUP);
    eval 'sub HAVE_STRERROR () {1;}' unless defined(&HAVE_STRERROR);
    eval 'sub HAVE_STRNCASECMP () {1;}' unless defined(&HAVE_STRNCASECMP);
    eval 'sub HAVE_STRTOL () {1;}' unless defined(&HAVE_STRTOL);
    eval 'sub HAVE_STRTOUL () {1;}' unless defined(&HAVE_STRTOUL);
    eval 'sub HAVE_SYSTEM () {1;}' unless defined(&HAVE_SYSTEM);
    eval 'sub HAVE_TCGETATTR () {1;}' unless defined(&HAVE_TCGETATTR);
    eval 'sub HAVE_UNAME () {1;}' unless defined(&HAVE_UNAME);
    eval 'sub HAVE_USLEEP () {1;}' unless defined(&HAVE_USLEEP);
    eval 'sub HAVE_VSNPRINTF () {1;}' unless defined(&HAVE_VSNPRINTF);
    eval 'sub HAVE_ARPA_INET_H () {1;}' unless defined(&HAVE_ARPA_INET_H);
    eval 'sub HAVE_ASM_PAGE_H () {1;}' unless defined(&HAVE_ASM_PAGE_H);
    eval 'sub HAVE_DIRENT_H () {1;}' unless defined(&HAVE_DIRENT_H);
    eval 'sub HAVE_DLFCN_H () {1;}' unless defined(&HAVE_DLFCN_H);
    eval 'sub HAVE_ERR_H () {1;}' unless defined(&HAVE_ERR_H);
    eval 'sub HAVE_FCNTL_H () {1;}' unless defined(&HAVE_FCNTL_H);
    eval 'sub HAVE_FSTAB_H () {1;}' unless defined(&HAVE_FSTAB_H);
    eval 'sub HAVE_GETOPT_H () {1;}' unless defined(&HAVE_GETOPT_H);
    eval 'sub HAVE_GRP_H () {1;}' unless defined(&HAVE_GRP_H);
    eval 'sub HAVE_LIMITS_H () {1;}' unless defined(&HAVE_LIMITS_H);
    eval 'sub HAVE_LINUX_HDREG_H () {1;}' unless defined(&HAVE_LINUX_HDREG_H);
    eval 'sub HAVE_LOCALE_H () {1;}' unless defined(&HAVE_LOCALE_H);
    eval 'sub HAVE_MALLOC_H () {1;}' unless defined(&HAVE_MALLOC_H);
    eval 'sub HAVE_MNTENT_H () {1;}' unless defined(&HAVE_MNTENT_H);
    eval 'sub HAVE_NET_IF_H () {1;}' unless defined(&HAVE_NET_IF_H);
    eval 'sub HAVE_NET_ROUTE_H () {1;}' unless defined(&HAVE_NET_ROUTE_H);
    eval 'sub HAVE_NETDB_H () {1;}' unless defined(&HAVE_NETDB_H);
    eval 'sub HAVE_NETINET_IF_ETHER_H () {1;}' unless defined(&HAVE_NETINET_IF_ETHER_H);
    eval 'sub HAVE_NETINET_IN_H () {1;}' unless defined(&HAVE_NETINET_IN_H);
    eval 'sub HAVE_NETINET_IN_SYSTM_H () {1;}' unless defined(&HAVE_NETINET_IN_SYSTM_H);
    eval 'sub HAVE_NETINET_IP_H () {1;}' unless defined(&HAVE_NETINET_IP_H);
    eval 'sub HAVE_NETINET_IP6_H () {1;}' unless defined(&HAVE_NETINET_IP6_H);
    eval 'sub HAVE_NETINET_IP_ICMP_H () {1;}' unless defined(&HAVE_NETINET_IP_ICMP_H);
    eval 'sub HAVE_NETINET_TCP_H () {1;}' unless defined(&HAVE_NETINET_TCP_H);
    eval 'sub HAVE_NETINET_UDP_H () {1;}' unless defined(&HAVE_NETINET_UDP_H);
    eval 'sub HAVE_NETIPX_IPX_H () {1;}' unless defined(&HAVE_NETIPX_IPX_H);
    eval 'sub HAVE_NLIST_H () {1;}' unless defined(&HAVE_NLIST_H);
    eval 'sub HAVE_OPENSSL_AES_H () {1;}' unless defined(&HAVE_OPENSSL_AES_H);
    eval 'sub HAVE_OPENSSL_DES_H () {1;}' unless defined(&HAVE_OPENSSL_DES_H);
    eval 'sub HAVE_OPENSSL_EVP_H () {1;}' unless defined(&HAVE_OPENSSL_EVP_H);
    eval 'sub HAVE_OPENSSL_HMAC_H () {1;}' unless defined(&HAVE_OPENSSL_HMAC_H);
    eval 'sub HAVE_PTHREAD_H () {1;}' unless defined(&HAVE_PTHREAD_H);
    eval 'sub HAVE_PWD_H () {1;}' unless defined(&HAVE_PWD_H);
    eval 'sub HAVE_REGEX_H () {1;}' unless defined(&HAVE_REGEX_H);
    eval 'sub HAVE_SEARCH_H () {1;}' unless defined(&HAVE_SEARCH_H);
    eval 'sub HAVE_SGTTY_H () {1;}' unless defined(&HAVE_SGTTY_H);
    eval 'sub HAVE_STDARG_H () {1;}' unless defined(&HAVE_STDARG_H);
    eval 'sub HAVE_STDLIB_H () {1;}' unless defined(&HAVE_STDLIB_H);
    eval 'sub HAVE_STRING_H () {1;}' unless defined(&HAVE_STRING_H);
    eval 'sub HAVE_SYS_CDEFS_H () {1;}' unless defined(&HAVE_SYS_CDEFS_H);
    eval 'sub HAVE_SYS_FILE_H () {1;}' unless defined(&HAVE_SYS_FILE_H);
    eval 'sub HAVE_SYS_IOCTL_H () {1;}' unless defined(&HAVE_SYS_IOCTL_H);
    eval 'sub HAVE_SYS_MOUNT_H () {1;}' unless defined(&HAVE_SYS_MOUNT_H);
    eval 'sub HAVE_SYS_PARAM_H () {1;}' unless defined(&HAVE_SYS_PARAM_H);
    eval 'sub HAVE_SYS_QUEUE_H () {1;}' unless defined(&HAVE_SYS_QUEUE_H);
    eval 'sub HAVE_SYS_SELECT_H () {1;}' unless defined(&HAVE_SYS_SELECT_H);
    eval 'sub HAVE_SYS_SOCKET_H () {1;}' unless defined(&HAVE_SYS_SOCKET_H);
    eval 'sub HAVE_SYS_SOCKETVAR_H () {1;}' unless defined(&HAVE_SYS_SOCKETVAR_H);
    eval 'sub HAVE_SYS_STAT_H () {1;}' unless defined(&HAVE_SYS_STAT_H);
    eval 'sub HAVE_SYS_STATFS_H () {1;}' unless defined(&HAVE_SYS_STATFS_H);
    eval 'sub HAVE_SYS_STATVFS_H () {1;}' unless defined(&HAVE_SYS_STATVFS_H);
    eval 'sub HAVE_SYS_SWAP_H () {1;}' unless defined(&HAVE_SYS_SWAP_H);
    eval 'sub HAVE_SYS_SYSCTL_H () {1;}' unless defined(&HAVE_SYS_SYSCTL_H);
    eval 'sub HAVE_SYS_TIME_H () {1;}' unless defined(&HAVE_SYS_TIME_H);
    eval 'sub HAVE_SYS_UN_H () {1;}' unless defined(&HAVE_SYS_UN_H);
    eval 'sub HAVE_SYS_USER_H () {1;}' unless defined(&HAVE_SYS_USER_H);
    eval 'sub HAVE_SYS_UTSNAME_H () {1;}' unless defined(&HAVE_SYS_UTSNAME_H);
    eval 'sub HAVE_SYS_VFS_H () {1;}' unless defined(&HAVE_SYS_VFS_H);
    eval 'sub HAVE_SYSLOG_H () {1;}' unless defined(&HAVE_SYSLOG_H);
    eval 'sub HAVE_UNISTD_H () {1;}' unless defined(&HAVE_UNISTD_H);
    eval 'sub HAVE_UTMPX_H () {1;}' unless defined(&HAVE_UTMPX_H);
    eval 'sub HAVE_LIBCRYPTO () {1;}' unless defined(&HAVE_LIBCRYPTO);
    eval 'sub HAVE_LIBDL () {1;}' unless defined(&HAVE_LIBDL);
    eval 'sub HAVE_LIBELF () {1;}' unless defined(&HAVE_LIBELF);
    eval 'sub HAVE_LIBM () {1;}' unless defined(&HAVE_LIBM);
    eval 'sub HAVE_LIBZ () {1;}' unless defined(&HAVE_LIBZ);
    eval 'sub RTENTRY () {\'struct rtentry\';}' unless defined(&RTENTRY);
    eval 'sub STRUCT_SIGACTION_HAS_SA_SIGACTION () {1;}' unless defined(&STRUCT_SIGACTION_HAS_SA_SIGACTION);
    eval 'sub STRUCT_RTENTRY_HAS_RT_DST () {1;}' unless defined(&STRUCT_RTENTRY_HAS_RT_DST);
    eval 'sub STRUCT_IFNET_HAS_IF_SPEED () {1;}' unless defined(&STRUCT_IFNET_HAS_IF_SPEED);
    eval 'sub STRUCT_IFNET_HAS_IF_TYPE () {1;}' unless defined(&STRUCT_IFNET_HAS_IF_TYPE);
    eval 'sub STRUCT_IFNET_HAS_IF_IQDROPS () {1;}' unless defined(&STRUCT_IFNET_HAS_IF_IQDROPS);
    eval 'sub STRUCT_IFNET_HAS_IF_OBYTES () {1;}' unless defined(&STRUCT_IFNET_HAS_IF_OBYTES);
    eval 'sub STRUCT_IFNET_HAS_IF_IBYTES () {1;}' unless defined(&STRUCT_IFNET_HAS_IF_IBYTES);
    eval 'sub STRUCT_IFADDR_HAS_IFA_NEXT () {1;}' unless defined(&STRUCT_IFADDR_HAS_IFA_NEXT);
    eval 'sub STRUCT_NLIST_HAS_N_VALUE () {1;}' unless defined(&STRUCT_NLIST_HAS_N_VALUE);
    eval 'sub STRUCT_STATVFS_HAS_F_FRSIZE () {1;}' unless defined(&STRUCT_STATVFS_HAS_F_FRSIZE);
    eval 'sub STRUCT_STATVFS_HAS_F_FILES () {1;}' unless defined(&STRUCT_STATVFS_HAS_F_FILES);
    eval 'sub STRUCT_STATFS_HAS_F_FILES () {1;}' unless defined(&STRUCT_STATFS_HAS_F_FILES);
    eval 'sub STRUCT_STATFS_HAS_F_FFREE () {1;}' unless defined(&STRUCT_STATFS_HAS_F_FFREE);
    eval 'sub SYS_IOCTL_H_HAS_SIOCGIFADDR () {1;}' unless defined(&SYS_IOCTL_H_HAS_SIOCGIFADDR);
    eval 'sub HAVE_CPP_UNDERBAR_FUNCTION_DEFINED () {1;}' unless defined(&HAVE_CPP_UNDERBAR_FUNCTION_DEFINED);
    eval 'sub VERS_DESC () {"unknown";}' unless defined(&VERS_DESC);
    eval 'sub SYS_NAME () {"unknown";}' unless defined(&SYS_NAME);
    eval 'sub PROCMIBNUM () {2;}' unless defined(&PROCMIBNUM);
    eval 'sub SHELLMIBNUM () {8;}' unless defined(&SHELLMIBNUM);
    eval 'sub MEMMIBNUM () {4;}' unless defined(&MEMMIBNUM);
    eval 'sub DISKMIBNUM () {9;}' unless defined(&DISKMIBNUM);
    eval 'sub LOADAVEMIBNUM () {10;}' unless defined(&LOADAVEMIBNUM);
    eval 'sub VERSIONMIBNUM () {100;}' unless defined(&VERSIONMIBNUM);
    eval 'sub ERRORMIBNUM () {101;}' unless defined(&ERRORMIBNUM);
    eval 'sub AGENTID () {250;}' unless defined(&AGENTID);
    eval 'sub HPUX9ID () {1;}' unless defined(&HPUX9ID);
    eval 'sub SUNOS4ID () {2;}' unless defined(&SUNOS4ID);
    eval 'sub SOLARISID () {3;}' unless defined(&SOLARISID);
    eval 'sub OSFID () {4;}' unless defined(&OSFID);
    eval 'sub ULTRIXID () {5;}' unless defined(&ULTRIXID);
    eval 'sub HPUX10ID () {6;}' unless defined(&HPUX10ID);
    eval 'sub NETBSD1ID () {7;}' unless defined(&NETBSD1ID);
    eval 'sub FREEBSDID () {8;}' unless defined(&FREEBSDID);
    eval 'sub IRIXID () {9;}' unless defined(&IRIXID);
    eval 'sub LINUXID () {10;}' unless defined(&LINUXID);
    eval 'sub BSDIID () {11;}' unless defined(&BSDIID);
    eval 'sub OPENBSDID () {12;}' unless defined(&OPENBSDID);
    eval 'sub WIN32ID () {13;}' unless defined(&WIN32ID);
    eval 'sub HPUX11ID () {14;}' unless defined(&HPUX11ID);
    eval 'sub UNKNOWNID () {255;}' unless defined(&UNKNOWNID);
    if(defined(&hpux9)) {
	eval 'sub OSTYPE () { &HPUX9ID;}' unless defined(&OSTYPE);
    }
    if(defined(&hpux10)) {
	eval 'sub OSTYPE () { &HPUX10ID;}' unless defined(&OSTYPE);
    }
    if(defined(&hpux11)) {
	eval 'sub OSTYPE () { &HPUX11ID;}' unless defined(&OSTYPE);
    }
    if(defined(&sunos4)) {
	eval 'sub OSTYPE () { &SUNOS4ID;}' unless defined(&OSTYPE);
    }
    if(defined(&solaris2)) {
	eval 'sub OSTYPE () { &SOLARISID;}' unless defined(&OSTYPE);
    }
    if(defined( &osf3) || defined( &osf4)) {
	eval 'sub OSTYPE () { &OSFID;}' unless defined(&OSTYPE);
    }
    if(defined(&ultrix4)) {
	eval 'sub OSTYPE () { &ULTRIXID;}' unless defined(&OSTYPE);
    }
    if(defined(&netbsd1)) {
	eval 'sub OSTYPE () { &NETBSD1ID;}' unless defined(&OSTYPE);
    }
    if(defined(&freebsd2)) {
	eval 'sub OSTYPE () { &FREEBSDID;}' unless defined(&OSTYPE);
    }
    if(defined( &irix6) || defined( &irix5)) {
	eval 'sub OSTYPE () { &IRIXID;}' unless defined(&OSTYPE);
    }
    if(defined(&linux)) {
	eval 'sub OSTYPE () { &LINUXID;}' unless defined(&OSTYPE);
    }
    if(defined( &bsdi2) || defined( &bsdi3) || defined( &bsdi4)) {
	eval 'sub OSTYPE () { &BSDIID;}' unless defined(&OSTYPE);
    }
    if(defined(&openbsd2)) {
	eval 'sub OSTYPE () { &OPENBSDID;}' unless defined(&OSTYPE);
    }
    unless(defined(&OSTYPE)) {
	eval 'sub OSTYPE () { &UNKNOWNID;}' unless defined(&OSTYPE);
    }
    eval 'sub ENTERPRISE_OID () {8072;}' unless defined(&ENTERPRISE_OID);
    eval 'sub ENTERPRISE_MIB () {1,3,6,1,4,1,8072;}' unless defined(&ENTERPRISE_MIB);
    eval 'sub ENTERPRISE_DOT_MIB () {1.3.6.1.4.1.8072;}' unless defined(&ENTERPRISE_DOT_MIB);
    eval 'sub ENTERPRISE_DOT_MIB_LENGTH () {7;}' unless defined(&ENTERPRISE_DOT_MIB_LENGTH);
    eval 'sub SYSTEM_MIB () {1,3,6,1,4,1,8072,3,2, &OSTYPE;}' unless defined(&SYSTEM_MIB);
    eval 'sub SYSTEM_DOT_MIB () {1.3.6.1.4.1.8072.3.2. &OSTYPE;}' unless defined(&SYSTEM_DOT_MIB);
    eval 'sub SYSTEM_DOT_MIB_LENGTH () {10;}' unless defined(&SYSTEM_DOT_MIB_LENGTH);
    eval 'sub NOTIFICATION_MIB () {1,3,6,1,4,1,8072,4;}' unless defined(&NOTIFICATION_MIB);
    eval 'sub NOTIFICATION_DOT_MIB () {1.3.6.1.4.1.8072.4;}' unless defined(&NOTIFICATION_DOT_MIB);
    eval 'sub NOTIFICATION_DOT_MIB_LENGTH () {8;}' unless defined(&NOTIFICATION_DOT_MIB_LENGTH);
    eval 'sub UCDAVIS_OID () {2021;}' unless defined(&UCDAVIS_OID);
    eval 'sub UCDAVIS_MIB () {1,3,6,1,4,1,2021;}' unless defined(&UCDAVIS_MIB);
    eval 'sub UCDAVIS_DOT_MIB () {1.3.6.1.4.1.2021;}' unless defined(&UCDAVIS_DOT_MIB);
    eval 'sub UCDAVIS_DOT_MIB_LENGTH () {7;}' unless defined(&UCDAVIS_DOT_MIB_LENGTH);
    eval 'sub ERRORTIMELENGTH () {600;}' unless defined(&ERRORTIMELENGTH);
    eval 'sub EXCACHETIME () {30;}' unless defined(&EXCACHETIME);
    eval 'sub CACHEFILE () {".snmp-exec-cache";}' unless defined(&CACHEFILE);
    eval 'sub MAXCACHESIZE () {(200*80);}' unless defined(&MAXCACHESIZE);
    eval 'sub MAXDISKS () {50;}' unless defined(&MAXDISKS);
    eval 'sub DEFDISKMINIMUMSPACE () {100000;}' unless defined(&DEFDISKMINIMUMSPACE);
    eval 'sub DEFMAXLOADAVE () {12.0;}' unless defined(&DEFMAXLOADAVE);
    eval 'sub MAXREADCOUNT () {100;}' unless defined(&MAXREADCOUNT);
    eval 'sub SNMPBLOCK () {1;}' unless defined(&SNMPBLOCK);
    eval 'sub RESTARTSLEEP () {5;}' unless defined(&RESTARTSLEEP);
    eval 'sub NUM_COMMUNITIES () {5;}' unless defined(&NUM_COMMUNITIES);
    eval 'sub LASTFIELD () {-1;}' unless defined(&LASTFIELD);
    eval 'sub CONFIGURE_OPTIONS () {"\\" --host=i386-redhat-linux --build=i386-redhat-linux --target=i386-redhat-linux-gnu --program-prefix= --prefix=/usr --exec-prefix=/usr --bindir=/usr/bin --sbindir=/usr/sbin --sysconfdir=/etc --datadir=/usr/share --includedir=/usr/include/net-snmp --libdir=/usr/lib --libexecdir=/usr/libexec --localstatedir=/var --sharedstatedir=/usr/com --mandir=/usr/share/man --infodir=/usr/share/info --enable-static --enable-shared --enable-dmalloc \'--with-cflags=-O2 -g -pipe -march=i386 -mcpu=i686 -g -lcrypto\' --with-sys-location=Unknown --with-logfile=/var/log/snmpd.log --with-persistent-directory=/var/net-snmp \'--with-mib-modules=host agentx smux\' --with-libwrap=/usr/lib --sysconfdir=/etc --enable-ipv6 --enable-ucd-snmp-compatibility --with-sys-contact=root@localhost\\"";}' unless defined(&CONFIGURE_OPTIONS);
    eval 'sub HAVE_SOCKLEN_T () {1;}' unless defined(&HAVE_SOCKLEN_T);
    eval 'sub HAVE_IN_ADDR_T () {1;}' unless defined(&HAVE_IN_ADDR_T);
    unless(defined(&HAVE_STRCHR)) {
	if(defined(&HAVE_INDEX)) {
	    eval 'sub strchr () { &index;}' unless defined(&strchr);
	    eval 'sub strrchr () { &rindex;}' unless defined(&strrchr);
	}
    }
    unless(defined(&HAVE_INDEX)) {
	if(defined(&HAVE_STRCHR)) {
	    eval 'sub index () { &strchr;}' unless defined(&index);
	    eval 'sub rindex () { &strrchr;}' unless defined(&rindex);
	}
    }
    unless(defined(&HAVE_MEMCPY)) {
	if(defined(&HAVE_BCOPY)) {
	    eval 'sub memcpy {
	        my($d, $s, $n) = @_;
    		eval q( &bcopy (($s), ($d), ($n)));
	    }' unless defined(&memcpy);
	    eval 'sub memmove {
	        my($d, $s, $n) = @_;
    		eval q( &bcopy (($s), ($d), ($n)));
	    }' unless defined(&memmove);
	    eval 'sub memcmp () { &bcmp;}' unless defined(&memcmp);
	}
    }
    unless(defined(&HAVE_MEMMOVE)) {
	if(defined(&HAVE_MEMCPY)) {
	    eval 'sub memmove () { &memcpy;}' unless defined(&memmove);
	}
    }
    unless(defined(&HAVE_BCOPY)) {
	if(defined(&HAVE_MEMCPY)) {
	    eval 'sub bcopy {
	        my($s, $d, $n) = @_;
    		eval q( &memcpy (($d), ($s), ($n)));
	    }' unless defined(&bcopy);
	    eval 'sub bzero {
	        my($p,$n) = @_;
    		eval q( &memset(($p),(0),($n)));
	    }' unless defined(&bzero);
	    eval 'sub bcmp () { &memcmp;}' unless defined(&bcmp);
	}
    }
    eval 'sub USE_OPENSSL () {1;}' unless defined(&USE_OPENSSL);
    if(defined( &USE_OPENSSL)  && defined( &HAVE_OPENSSL_AES_H)  && defined( &HAVE_AES_CFB128_ENCRYPT)) {
	eval 'sub HAVE_AES () {1;}' unless defined(&HAVE_AES);
    }
    unless(defined(&HAVE_RANDOM)) {
	if(defined(&HAVE_LRAND48)) {
	    eval 'sub random () { &lrand48;}' unless defined(&random);
	    eval 'sub srandom {
	        my($s) = @_;
    		eval q( &srand48($s));
	    }' unless defined(&srandom);
	} else {
	    if(defined(&HAVE_RAND)) {
		eval 'sub random () { &rand;}' unless defined(&random);
		eval 'sub srandom {
		    my($s) = @_;
    		    eval q( &srand($s));
		}' unless defined(&srandom);
	    }
	}
    }
    unless(defined(&HAVE_SIGNAL)) {
	if(defined(&HAVE_SIGSET)) {
	    eval 'sub signal {
	        my($a,$b) = @_;
    		eval q( &sigset($a,$b));
	    }' unless defined(&signal);
	}
    }
    eval 'sub HAVE_LIBRPM () {1;}' unless defined(&HAVE_LIBRPM);
    eval 'sub HAVE_GETHOSTBYNAME () {1;}' unless defined(&HAVE_GETHOSTBYNAME);
    eval 'sub HAVE_GETSERVBYNAME () {1;}' unless defined(&HAVE_GETSERVBYNAME);
    eval 'sub HAVE_LPSTAT () {1;}' unless defined(&HAVE_LPSTAT);
    eval 'sub LPSTAT_PATH () {"/usr/bin/lpstat";}' unless defined(&LPSTAT_PATH);
    eval 'sub HAVE_PRINTCAP () {1;}' unless defined(&HAVE_PRINTCAP);
    eval 'sub SNMP_TRANSPORT_UDP_DOMAIN () {1;}' unless defined(&SNMP_TRANSPORT_UDP_DOMAIN);
    eval 'sub SNMP_TRANSPORT_TCP_DOMAIN () {1;}' unless defined(&SNMP_TRANSPORT_TCP_DOMAIN);
    eval 'sub SNMP_TRANSPORT_UNIX_DOMAIN () {1;}' unless defined(&SNMP_TRANSPORT_UNIX_DOMAIN);
    eval 'sub SNMP_TRANSPORT_UDPIPV6_DOMAIN () {1;}' unless defined(&SNMP_TRANSPORT_UDPIPV6_DOMAIN);
    eval 'sub SNMP_TRANSPORT_TCPIPV6_DOMAIN () {1;}' unless defined(&SNMP_TRANSPORT_TCPIPV6_DOMAIN);
    eval 'sub SNMP_SECMOD_USM () {1;}' unless defined(&SNMP_SECMOD_USM);
    eval 'sub config_require {
        my($x) = @_;
	    eval q();
    }' unless defined(&config_require);
    eval 'sub config_arch_require {
        my($x,$y) = @_;
	    eval q();
    }' unless defined(&config_arch_require);
    eval 'sub config_parse_dot_conf {
        my($w,$x,$y,$z) = @_;
	    eval q();
    }' unless defined(&config_parse_dot_conf);
    eval 'sub config_add_mib {
        my($x) = @_;
	    eval q();
    }' unless defined(&config_add_mib);
    if(defined(&WIN32)) {
	eval 'sub ENV_SEPARATOR () {";";}' unless defined(&ENV_SEPARATOR);
	eval 'sub ENV_SEPARATOR_CHAR () {ord(\';\');}' unless defined(&ENV_SEPARATOR_CHAR);
    } else {
	eval 'sub ENV_SEPARATOR () {":";}' unless defined(&ENV_SEPARATOR);
	eval 'sub ENV_SEPARATOR_CHAR () {ord(\':\');}' unless defined(&ENV_SEPARATOR_CHAR);
    }
    if(defined( &HAVE_NLIST)  && defined( &STRUCT_NLIST_HAS_N_VALUE)  && !defined( &DONT_USE_NLIST)  && !defined( &NO_KMEM_USAGE)) {
	eval 'sub CAN_USE_NLIST () {1;}' unless defined(&CAN_USE_NLIST);
    }
    if((defined(&HAVE_DMALLOC_H) ? &HAVE_DMALLOC_H : 0)) {
	eval 'sub DMALLOC_FUNC_CHECK () {1;}' unless defined(&DMALLOC_FUNC_CHECK);
    }
    eval 'sub INET6 () {1;}' unless defined(&INET6);
    unless(defined(&NETSNMP_INLINE)) {
	eval 'sub NETSNMP_NO_INLINE () {1;}' unless defined(&NETSNMP_NO_INLINE);
	eval 'sub NETSNMP_INLINE () {1;}' unless defined(&NETSNMP_INLINE);
    }
}
1;
