require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&NET_SNMP_INCLUDES_H)) {
    eval 'sub NET_SNMP_INCLUDES_H () {1;}' unless defined(&NET_SNMP_INCLUDES_H);
    require 'stdio.ph';
    require 'sys/types.ph';
    if((defined(&HAVE_STRING_H) ? &HAVE_STRING_H : 0)) {
	require 'string.ph';
    } else {
	require 'strings.ph';
    }
    if((defined(&HAVE_STDLIB_H) ? &HAVE_STDLIB_H : 0)) {
	require 'stdlib.ph';
    }
    if((defined(&HAVE_NETINET_IN_H) ? &HAVE_NETINET_IN_H : 0)) {
	require 'netinet/in.ph';
    }
    if((defined(&TIME_WITH_SYS_TIME) ? &TIME_WITH_SYS_TIME : 0)) {
	if(defined(&WIN32)) {
	    require 'sys/timeb.ph';
	} else {
	    require 'sys/time.ph';
	}
	require 'time.ph';
    } else {
	if((defined(&HAVE_SYS_TIME_H) ? &HAVE_SYS_TIME_H : 0)) {
	    require 'sys/time.ph';
	} else {
	    require 'time.ph';
	}
    }
    if((defined(&HAVE_DMALLOC_H) ? &HAVE_DMALLOC_H : 0)) {
	require 'dmalloc.ph';
    }
    require 'net-snmp/definitions.ph';
    require 'net-snmp/types.ph';
    require 'net-snmp/utilities.ph';
    require 'net-snmp/session_api.ph';
    require 'net-snmp/pdu_api.ph';
    require 'net-snmp/mib_api.ph';
    require 'net-snmp/varbind_api.ph';
    require 'net-snmp/config_api.ph';
    require 'net-snmp/output_api.ph';
    require 'net-snmp/utilities.ph';
    require 'net-snmp/snmpv3_api.ph';
    if(defined(&CMU_COMPATIBLE)) {
	require 'net-snmp/library/cmu_compat.ph';
    }
}
1;
