require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&NET_SNMP_SESSION_API_H)) {
    eval 'sub NET_SNMP_SESSION_API_H () {1;}' unless defined(&NET_SNMP_SESSION_API_H);
    require 'net-snmp/types.ph';
    require 'net-snmp/library/snmp_api.ph';
    require 'net-snmp/library/snmp_client.ph';
    require 'net-snmp/library/asn1.ph';
    require 'net-snmp/library/callback.ph';
    require 'net-snmp/library/snmp_transport.ph';
    require 'net-snmp/library/snmpCallbackDomain.ph';
    if(defined(&SNMP_TRANSPORT_UNIX_DOMAIN)) {
	require 'net-snmp/library/snmpUnixDomain.ph';
    }
    if(defined(&SNMP_TRANSPORT_UDP_DOMAIN)) {
	require 'net-snmp/library/snmpUDPDomain.ph';
    }
    if(defined(&SNMP_TRANSPORT_TCP_DOMAIN)) {
	require 'net-snmp/library/snmpTCPDomain.ph';
    }
    if(defined(&SNMP_TRANSPORT_UDPIPV6_DOMAIN)) {
	require 'net-snmp/library/snmpUDPIPv6Domain.ph';
    }
    if(defined(&SNMP_TRANSPORT_TCPIPV6_DOMAIN)) {
	require 'net-snmp/library/snmpTCPIPv6Domain.ph';
    }
    if(defined(&SNMP_TRANSPORT_IPX_DOMAIN)) {
	require 'net-snmp/library/snmpIPXDomain.ph';
    }
    if(defined(&SNMP_TRANSPORT_AAL5PVC_DOMAIN)) {
	require 'net-snmp/library/snmpAAL5PVCDomain.ph';
    }
    require 'net-snmp/library/ucd_compat.ph';
}
1;
