require '_h2ph_pre.ph';

no warnings 'redefine';

require 'generic.ph';
unless(defined(&SYSV)) {
    sub SYSV () {	1;}
}
unless(defined(&dynix)) {
    sub dynix () {	1;}
}
undef(&TOTAL_MEMORY_SYMBOL) if defined(&TOTAL_MEMORY_SYMBOL);
undef(&MBSTAT_SYMBOL) if defined(&MBSTAT_SYMBOL);
if(defined(&NPROC_SYMBOL)) {
    undef(&NPROC_SYMBOL) if defined(&NPROC_SYMBOL);
}
if(defined(&PROC_SYMBOL)) {
    undef(&PROC_SYMBOL) if defined(&PROC_SYMBOL);
}
unless(defined(&TCPTV_MIN)) {
    eval 'sub TCPTV_MIN () {(1* &PR_SLOWHZ);}' unless defined(&TCPTV_MIN);
}
unless(defined(&TCPTV_REXMTMAX)) {
    eval 'sub TCPTV_REXMTMAX () {(64* &PR_SLOWHZ);}' unless defined(&TCPTV_REXMTMAX);
}
unless(defined(&__NO_ASM_MACRO)) {
    sub __NO_ASM_MACRO () {	1;}
}
unless(defined(&L_SET)) {
    eval 'sub L_SET () { &SEEK_SET;}' unless defined(&L_SET);
}
unless(defined(&HAVE_GETHOSTNAME)) {
    sub HAVE_GETHOSTNAME () {	1;}
}
unless(defined(&HAVE_NET_IF_DL_H)) {
    sub HAVE_NET_IF_DL_H () {	1;}
}
unless(defined(&HAVE_LIBNSL)) {
    sub HAVE_LIBNSL () {	1;}
}
unless(defined(&HAVE_GETHOSTBYNAME)) {
    sub HAVE_GETHOSTBYNAME () {	1;}
}
unless(defined(&HAVE_GETSERVBYNAME)) {
    sub HAVE_GETSERVBYNAME () {	1;}
}
if((defined(&HAVE_SYS_SELECT_H) ? &HAVE_SYS_SELECT_H : 0)) {
    require 'sys/select.ph';
}
1;
