require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&bsdlike)) {
    sub bsdlike () {	1;}
}
unless(defined(&IPSTAT_SYMBOL)) {
    sub IPSTAT_SYMBOL () {	"ipstat";}
}
unless(defined(&IP_FORWARDING_SYMBOL)) {
    sub IP_FORWARDING_SYMBOL () {	"ipforwarding";}
}
unless(defined(&TCP_TTL_SYMBOL)) {
    sub TCP_TTL_SYMBOL () {	"tcpDefaultTTL";}
}
unless(defined(&IFNET_SYMBOL)) {
    sub IFNET_SYMBOL () {	"ifnet";}
}
unless(defined(&IFADDR_SYMBOL)) {
    sub IFADDR_SYMBOL () {	"in_ifaddr";}
}
unless(defined(&ARPTAB_SYMBOL)) {
    sub ARPTAB_SYMBOL () {	"arptab";}
}
unless(defined(&ARPTAB_SIZE_SYMBOL)) {
    sub ARPTAB_SIZE_SYMBOL () {	"arptab_size";}
}
unless(defined(&LOADAVE_SYMBOL)) {
    sub LOADAVE_SYMBOL () {	"avenrun";}
}
unless(defined(&PHYSMEM_SYMBOL)) {
    sub PHYSMEM_SYMBOL () {	"physmem";}
}
unless(defined(&TOTAL_MEMORY_SYMBOL)) {
    sub TOTAL_MEMORY_SYMBOL () {	"total";}
}
unless(defined(&MBSTAT_SYMBOL)) {
    sub MBSTAT_SYMBOL () {	"mbstat";}
}
unless(defined(&SWDEVT_SYMBOL)) {
    sub SWDEVT_SYMBOL () {	"swdevt";}
}
unless(defined(&FSWDEVT_SYMBOL)) {
    sub FSWDEVT_SYMBOL () {	"fswdevt";}
}
unless(defined(&NSWAPFS_SYMBOL)) {
    sub NSWAPFS_SYMBOL () {	"nswapfs";}
}
unless(defined(&NSWAPDEV_SYMBOL)) {
    sub NSWAPDEV_SYMBOL () {	"nswapdev";}
}
unless(defined(&NPROC_SYMBOL)) {
    sub NPROC_SYMBOL () {	"nproc";}
}
unless(defined(&PROC_SYMBOL)) {
    sub PROC_SYMBOL () {	"proc";}
}
unless(defined(&ICMPSTAT_SYMBOL)) {
    sub ICMPSTAT_SYMBOL () {	"icmpstat";}
}
unless(defined(&TCPSTAT_SYMBOL)) {
    sub TCPSTAT_SYMBOL () {	"tcpstat";}
}
unless(defined(&TCP_SYMBOL)) {
    sub TCP_SYMBOL () {	"tcb";}
}
unless(defined(&UDPSTAT_SYMBOL)) {
    sub UDPSTAT_SYMBOL () {	"udpstat";}
}
unless(defined(&UDB_SYMBOL)) {
    sub UDB_SYMBOL () {	"udb";}
}
unless(defined(&RTTABLES_SYMBOL)) {
    sub RTTABLES_SYMBOL () {	"rt_table";}
}
unless(defined(&RTHASHSIZE_SYMBOL)) {
    sub RTHASHSIZE_SYMBOL () {	"rthashsize";}
}
unless(defined(&RTHOST_SYMBOL)) {
    sub RTHOST_SYMBOL () {	"rthost";}
}
unless(defined(&RTNET_SYMBOL)) {
    sub RTNET_SYMBOL () {	"rtnet";}
}
unless(defined(&INP_NEXT_SYMBOL)) {
    sub INP_NEXT_SYMBOL () {	 &inp_next;}
}
unless(defined(&INP_PREV_SYMBOL)) {
    sub INP_PREV_SYMBOL () {	 &inp_prev;}
}
1;
