require '_h2ph_pre.ph';

no warnings 'redefine';

require 'bsd.ph';
unless(defined(&PCB_TABLE)) {
    sub PCB_TABLE () {	1;}
}
undef(&TCP_SYMBOL) if defined(&TCP_SYMBOL);
unless(defined(&TCP_SYMBOL)) {
    sub TCP_SYMBOL () {	"tcbtable";}
}
undef(&TCP_TTL_SYMBOL) if defined(&TCP_TTL_SYMBOL);
unless(defined(&TCP_TTL_SYMBOL)) {
    sub TCP_TTL_SYMBOL () {	"ip_defttl";}
}
undef(&UDB_SYMBOL) if defined(&UDB_SYMBOL);
unless(defined(&UDB_SYMBOL)) {
    sub UDB_SYMBOL () {	"udbtable";}
}
undef(&NPROC_SYMBOL) if defined(&NPROC_SYMBOL);
undef(&PROC_SYMBOL) if defined(&PROC_SYMBOL);
unless(defined(&MBPOOL_SYMBOL)) {
    sub MBPOOL_SYMBOL () {	"mbpool";}
}
unless(defined(&MCLPOOL_SYMBOL)) {
    sub MCLPOOL_SYMBOL () {	"mclpool";}
}
undef(&INP_NEXT_SYMBOL) if defined(&INP_NEXT_SYMBOL);
unless(defined(&INP_NEXT_SYMBOL)) {
    sub INP_NEXT_SYMBOL () {	 ($inp_queue->{cqe_next});}
}
undef(&INP_PREV_SYMBOL) if defined(&INP_PREV_SYMBOL);
unless(defined(&INP_PREV_SYMBOL)) {
    sub INP_PREV_SYMBOL () {	 ($inp_queue->{cqe_prev});}
}
unless(defined(&HAVE_INPCBTABLE)) {
    sub HAVE_INPCBTABLE () {	1;}
}
unless(defined(&UTMP_FILE)) {
    sub UTMP_FILE () {	 &_PATH_UTMP;}
}
unless(defined(&netbsd1)) {
    eval 'sub netbsd1 () {1;}' unless defined(&netbsd1);
}
undef(&STRUCT_IFNET_HAS_IF_BAUDRATE) if defined(&STRUCT_IFNET_HAS_IF_BAUDRATE);
unless(defined(&STRUCT_IFNET_HAS_IF_BAUDRATE)) {
    sub STRUCT_IFNET_HAS_IF_BAUDRATE () {	1;}
}
undef(&STRUCT_IFNET_HAS_IF_TYPE) if defined(&STRUCT_IFNET_HAS_IF_TYPE);
unless(defined(&STRUCT_IFNET_HAS_IF_TYPE)) {
    sub STRUCT_IFNET_HAS_IF_TYPE () {	1;}
}
undef(&STRUCT_IFNET_HAS_IF_IMCASTS) if defined(&STRUCT_IFNET_HAS_IF_IMCASTS);
unless(defined(&STRUCT_IFNET_HAS_IF_IMCASTS)) {
    sub STRUCT_IFNET_HAS_IF_IMCASTS () {	1;}
}
undef(&STRUCT_IFNET_HAS_IF_IQDROPS) if defined(&STRUCT_IFNET_HAS_IF_IQDROPS);
unless(defined(&STRUCT_IFNET_HAS_IF_IQDROPS)) {
    sub STRUCT_IFNET_HAS_IF_IQDROPS () {	1;}
}
undef(&STRUCT_IFNET_HAS_IF_NOPROTO) if defined(&STRUCT_IFNET_HAS_IF_NOPROTO);
unless(defined(&STRUCT_IFNET_HAS_IF_NOPROTO)) {
    sub STRUCT_IFNET_HAS_IF_NOPROTO () {	1;}
}
undef(&STRUCT_IFNET_HAS_IF_OMCASTS) if defined(&STRUCT_IFNET_HAS_IF_OMCASTS);
unless(defined(&STRUCT_IFNET_HAS_IF_OMCASTS)) {
    sub STRUCT_IFNET_HAS_IF_OMCASTS () {	1;}
}
undef(&STRUCT_IFNET_HAS_IF_IBYTES) if defined(&STRUCT_IFNET_HAS_IF_IBYTES);
unless(defined(&STRUCT_IFNET_HAS_IF_IBYTES)) {
    sub STRUCT_IFNET_HAS_IF_IBYTES () {	1;}
}
undef(&STRUCT_IFNET_HAS_IF_OBYTES) if defined(&STRUCT_IFNET_HAS_IF_OBYTES);
unless(defined(&STRUCT_IFNET_HAS_IF_OBYTES)) {
    sub STRUCT_IFNET_HAS_IF_OBYTES () {	1;}
}
1;
