require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&NET_SNMP_TYPES_H)) {
    eval 'sub NET_SNMP_TYPES_H () {1;}' unless defined(&NET_SNMP_TYPES_H);
    require 'stdio.ph';
    unless(defined(&NET_SNMP_CONFIG_H)) {
	die("Please include <net-snmp/net-snmp-config.h> before this file");
    }
    if((defined(&TIME_WITH_SYS_TIME) ? &TIME_WITH_SYS_TIME : 0)) {
	if(defined(&WIN32)) {
	    require 'sys/timeb.ph';
	} else {
	    require 'sys/time.ph';
	}
	require 'time.ph';
    } else {
	if((defined(&HAVE_SYS_TIME_H) ? &HAVE_SYS_TIME_H : 0)) {
	    require 'sys/time.ph';
	} else {
	    require 'time.ph';
	}
    }
    require 'sys/types.ph';
    if(defined(&HAVE_WINSOCK_H)) {
	require 'winsock.ph';
    }
    if((defined(&HAVE_NETINET_IN_H) ? &HAVE_NETINET_IN_H : 0)) {
	require 'netinet/in.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&MAX_SUBID)) {
	unless(defined(&EIGHTBIT_SUBIDS)) {
	    eval 'sub MAX_SUBID () {0xffffffff;}' unless defined(&MAX_SUBID);
	} else {
	    eval 'sub MAX_SUBID () {0xff;}' unless defined(&MAX_SUBID);
	}
    }
    unless(defined(&HAVE_SOCKLEN_T)) {
    }
    unless(defined(&HAVE_IN_ADDR_T)) {
    }
    require 'net-snmp/definitions.ph';
    require 'net-snmp/library/snmp_api.ph';
    if(defined(&__cplusplus)) {
    }
}
1;
