require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&THREAD_SAFETY_H)) {
    eval 'sub THREAD_SAFETY_H () {1;}' unless defined(&THREAD_SAFETY_H);
    if(defined(&NOT_REENTRANT)) {
	require 'pthread.ph';
	eval 'sub DEFINE_LOCK {
	    my($x) = @_;
    	    eval q( &pthread_mutex_t $x &_lock =  &PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP);
	}' unless defined(&DEFINE_LOCK);
	eval 'sub INIT_LOCK {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&INIT_LOCK);
	eval 'sub GET_LOCK {
	    my($x) = @_;
    	    eval q( &pthread_mutex_lock($x &_lock));
	}' unless defined(&GET_LOCK);
	eval 'sub RELEASE_LOCK {
	    my($x) = @_;
    	    eval q( &pthread_mutex_unlock($x &_lock));
	}' unless defined(&RELEASE_LOCK);
	eval 'sub PARAM_LOCK {
	    my($x) = @_;
    	    eval q( &pthread_mutex_t $x &_lock);
	}' unless defined(&PARAM_LOCK);
	eval 'sub LOCK_NAME {
	    my($x) = @_;
    	    eval q($x &_lock);
	}' unless defined(&LOCK_NAME);
	eval 'sub EXTERN_LOCK {
	    my($x) = @_;
    	    eval q( &extern  &pthread_mutex_t $x &_lock);
	}' unless defined(&EXTERN_LOCK);
	eval 'sub GET_THREAD_DATA () {
	    eval q( &pthread_getspecific( &thread_data));
	}' unless defined(&GET_THREAD_DATA);
	eval 'sub SET_THREAD_DATA {
	    my($x) = @_;
    	    eval q( &pthread_setspecific( &thread_data, ($x)));
	}' unless defined(&SET_THREAD_DATA);
    } else {
	eval 'sub DEFINE_LOCK {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&DEFINE_LOCK);
	eval 'sub INIT_LOCK {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&INIT_LOCK);
	eval 'sub GET_LOCK {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&GET_LOCK);
	eval 'sub RELEASE_LOCK {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&RELEASE_LOCK);
	eval 'sub PARAM_LOCK {
	    my($x) = @_;
    	    eval q( &gpointer $x &_lock);
	}' unless defined(&PARAM_LOCK);
	eval 'sub LOCK_NAME {
	    my($x) = @_;
    	    eval q( &NULL);
	}' unless defined(&LOCK_NAME);
	eval 'sub EXTERN_LOCK {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&EXTERN_LOCK);
	eval 'sub GET_THREAD_DATA () {
	    eval q( &prog_data);
	}' unless defined(&GET_THREAD_DATA);
	eval 'sub SET_THREAD_DATA {
	    my($x) = @_;
    	    eval q(( &prog_data = ($x)));
	}' unless defined(&SET_THREAD_DATA);
    }
}
1;
