require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ORBIT_CORBA_TYPECODE_H_)) {
    eval 'sub _ORBIT_CORBA_TYPECODE_H_ () {1;}' unless defined(&_ORBIT_CORBA_TYPECODE_H_);
    eval("sub CORBA_tk_null () { 0; }") unless defined(&CORBA_tk_null);
    eval("sub CORBA_tk_void () { 1; }") unless defined(&CORBA_tk_void);
    eval("sub CORBA_tk_short () { 2; }") unless defined(&CORBA_tk_short);
    eval("sub CORBA_tk_long () { 3; }") unless defined(&CORBA_tk_long);
    eval("sub CORBA_tk_ushort () { 4; }") unless defined(&CORBA_tk_ushort);
    eval("sub CORBA_tk_ulong () { 5; }") unless defined(&CORBA_tk_ulong);
    eval("sub CORBA_tk_float () { 6; }") unless defined(&CORBA_tk_float);
    eval("sub CORBA_tk_double () { 7; }") unless defined(&CORBA_tk_double);
    eval("sub CORBA_tk_boolean () { 8; }") unless defined(&CORBA_tk_boolean);
    eval("sub CORBA_tk_char () { 9; }") unless defined(&CORBA_tk_char);
    eval("sub CORBA_tk_octet () { 10; }") unless defined(&CORBA_tk_octet);
    eval("sub CORBA_tk_any () { 11; }") unless defined(&CORBA_tk_any);
    eval("sub CORBA_tk_TypeCode () { 12; }") unless defined(&CORBA_tk_TypeCode);
    eval("sub CORBA_tk_Principal () { 13; }") unless defined(&CORBA_tk_Principal);
    eval("sub CORBA_tk_objref () { 14; }") unless defined(&CORBA_tk_objref);
    eval("sub CORBA_tk_struct () { 15; }") unless defined(&CORBA_tk_struct);
    eval("sub CORBA_tk_union () { 16; }") unless defined(&CORBA_tk_union);
    eval("sub CORBA_tk_enum () { 17; }") unless defined(&CORBA_tk_enum);
    eval("sub CORBA_tk_string () { 18; }") unless defined(&CORBA_tk_string);
    eval("sub CORBA_tk_sequence () { 19; }") unless defined(&CORBA_tk_sequence);
    eval("sub CORBA_tk_array () { 20; }") unless defined(&CORBA_tk_array);
    eval("sub CORBA_tk_alias () { 21; }") unless defined(&CORBA_tk_alias);
    eval("sub CORBA_tk_except () { 22; }") unless defined(&CORBA_tk_except);
    eval("sub CORBA_tk_longlong () { 23; }") unless defined(&CORBA_tk_longlong);
    eval("sub CORBA_tk_ulonglong () { 24; }") unless defined(&CORBA_tk_ulonglong);
    eval("sub CORBA_tk_longdouble () { 25; }") unless defined(&CORBA_tk_longdouble);
    eval("sub CORBA_tk_wchar () { 26; }") unless defined(&CORBA_tk_wchar);
    eval("sub CORBA_tk_wstring () { 27; }") unless defined(&CORBA_tk_wstring);
    eval("sub CORBA_tk_fixed () { 28; }") unless defined(&CORBA_tk_fixed);
    eval("sub CORBA_tk_recursive () { 0xffffffff; }") unless defined(&CORBA_tk_recursive);
    eval("sub CORBA_tk_last () { 29; }") unless defined(&CORBA_tk_last);
    eval 'sub TC_CORBA_short () {\'TC_short\';}' unless defined(&TC_CORBA_short);
    eval 'sub TC_CORBA_long () {\'TC_long\';}' unless defined(&TC_CORBA_long);
    eval 'sub TC_CORBA_longlong () {\'TC_longlong\';}' unless defined(&TC_CORBA_longlong);
    eval 'sub TC_CORBA_long_long () {\'TC_longlong\';}' unless defined(&TC_CORBA_long_long);
    eval 'sub TC_CORBA_ushort () {\'TC_ushort\';}' unless defined(&TC_CORBA_ushort);
    eval 'sub TC_CORBA_unsigned_short () {\'TC_ushort\';}' unless defined(&TC_CORBA_unsigned_short);
    eval 'sub TC_CORBA_ulong () {\'TC_ulong\';}' unless defined(&TC_CORBA_ulong);
    eval 'sub TC_CORBA_unsigned_long () {\'TC_ulong\';}' unless defined(&TC_CORBA_unsigned_long);
    eval 'sub TC_CORBA_ulonglong () {\'TC_ulonglong\';}' unless defined(&TC_CORBA_ulonglong);
    eval 'sub TC_CORBA_unsigned_long_long () {\'TC_ulonglong\';}' unless defined(&TC_CORBA_unsigned_long_long);
    eval 'sub TC_CORBA_float () { &TC_float;}' unless defined(&TC_CORBA_float);
    eval 'sub TC_CORBA_double () { &TC_double;}' unless defined(&TC_CORBA_double);
    eval 'sub TC_CORBA_longdouble () {\'TC_longdouble\';}' unless defined(&TC_CORBA_longdouble);
    eval 'sub TC_CORBA_long_double () {\'TC_longdouble\';}' unless defined(&TC_CORBA_long_double);
    eval 'sub TC_CORBA_boolean () { &TC_boolean;}' unless defined(&TC_CORBA_boolean);
    eval 'sub TC_CORBA_char () { &TC_char;}' unless defined(&TC_CORBA_char);
    eval 'sub TC_CORBA_wchar () { &TC_wchar;}' unless defined(&TC_CORBA_wchar);
    eval 'sub TC_CORBA_octet () { &TC_octet;}' unless defined(&TC_CORBA_octet);
    eval 'sub TC_CORBA_any () { &TC_any;}' unless defined(&TC_CORBA_any);
    eval 'sub TC_CORBA_TypeCode () { &TC_TypeCode;}' unless defined(&TC_CORBA_TypeCode);
    eval 'sub TC_CORBA_Principal () { &TC_Principal;}' unless defined(&TC_CORBA_Principal);
    eval 'sub TC_CORBA_Object () { &TC_Object;}' unless defined(&TC_CORBA_Object);
    eval 'sub TC_CORBA_string () { &TC_string;}' unless defined(&TC_CORBA_string);
    eval 'sub TC_CORBA_wstring () { &TC_wstring;}' unless defined(&TC_CORBA_wstring);
    eval 'sub TC_null () {(( &CORBA_TypeCode) &TC_null_struct);}' unless defined(&TC_null);
    eval 'sub TC_void () {(( &CORBA_TypeCode) &TC_void_struct);}' unless defined(&TC_void);
    eval 'sub TC_short () {(( &CORBA_TypeCode) &TC_short_struct);}' unless defined(&TC_short);
    eval 'sub TC_long () {(( &CORBA_TypeCode)\'TC_long_struct\');}' unless defined(&TC_long);
    eval 'sub TC_longlong () {(( &CORBA_TypeCode)\'TC_longlong_struct\');}' unless defined(&TC_longlong);
    eval 'sub TC_ushort () {(( &CORBA_TypeCode) &TC_ushort_struct);}' unless defined(&TC_ushort);
    eval 'sub TC_ulong () {(( &CORBA_TypeCode)\'TC_ulong_struct\');}' unless defined(&TC_ulong);
    eval 'sub TC_ulonglong () {(( &CORBA_TypeCode)\'TC_ulonglong_struct\');}' unless defined(&TC_ulonglong);
    eval 'sub TC_float () {(( &CORBA_TypeCode) &TC_float_struct);}' unless defined(&TC_float);
    eval 'sub TC_double () {(( &CORBA_TypeCode) &TC_double_struct);}' unless defined(&TC_double);
    eval 'sub TC_longdouble () {(( &CORBA_TypeCode)\'TC_longdouble_struct\');}' unless defined(&TC_longdouble);
    eval 'sub TC_boolean () {(( &CORBA_TypeCode) &TC_boolean_struct);}' unless defined(&TC_boolean);
    eval 'sub TC_char () {(( &CORBA_TypeCode) &TC_char_struct);}' unless defined(&TC_char);
    eval 'sub TC_wchar () {(( &CORBA_TypeCode) &TC_wchar_struct);}' unless defined(&TC_wchar);
    eval 'sub TC_octet () {(( &CORBA_TypeCode) &TC_octet_struct);}' unless defined(&TC_octet);
    eval 'sub TC_any () {(( &CORBA_TypeCode) &TC_any_struct);}' unless defined(&TC_any);
    eval 'sub TC_TypeCode () {(( &CORBA_TypeCode) &TC_TypeCode_struct);}' unless defined(&TC_TypeCode);
    eval 'sub TC_Principal () {(( &CORBA_TypeCode) &TC_Principal_struct);}' unless defined(&TC_Principal);
    eval 'sub TC_Object () {(( &CORBA_TypeCode) &TC_Object_struct);}' unless defined(&TC_Object);
    eval 'sub TC_string () {(( &CORBA_TypeCode) &TC_string_struct);}' unless defined(&TC_string);
    eval 'sub TC_wstring () {(( &CORBA_TypeCode) &TC_wstring_struct);}' unless defined(&TC_wstring);
    eval 'sub TC_CORBA_NamedValue () {(( &CORBA_TypeCode) &TC_CORBA_NamedValue_struct);}' unless defined(&TC_CORBA_NamedValue);
    eval 'sub TC_CORBA_short_struct () { &TC_short_struct;}' unless defined(&TC_CORBA_short_struct);
    eval 'sub TC_CORBA_long_struct () {\'TC_long_struct\';}' unless defined(&TC_CORBA_long_struct);
    eval 'sub TC_CORBA_longlong_struct () {\'TC_longlong_struct\';}' unless defined(&TC_CORBA_longlong_struct);
    eval 'sub TC_CORBA_long_long_struct () {\'TC_longlong_struct\';}' unless defined(&TC_CORBA_long_long_struct);
    eval 'sub TC_CORBA_ushort_struct () { &TC_ushort_struct;}' unless defined(&TC_CORBA_ushort_struct);
    eval 'sub TC_CORBA_unsigned_short_struct () { &TC_ushort_struct;}' unless defined(&TC_CORBA_unsigned_short_struct);
    eval 'sub TC_CORBA_ulong_struct () {\'TC_ulong_struct\';}' unless defined(&TC_CORBA_ulong_struct);
    eval 'sub TC_CORBA_unsigned_long_struct () {\'TC_ulong_struct\';}' unless defined(&TC_CORBA_unsigned_long_struct);
    eval 'sub TC_CORBA_ulonglong_struct () {\'TC_ulonglong_struct\';}' unless defined(&TC_CORBA_ulonglong_struct);
    eval 'sub TC_CORBA_unsigned_long_long_struct () {\'TC_ulonglong_struct\';}' unless defined(&TC_CORBA_unsigned_long_long_struct);
    eval 'sub TC_CORBA_float_struct () { &TC_float_struct;}' unless defined(&TC_CORBA_float_struct);
    eval 'sub TC_CORBA_double_struct () { &TC_double_struct;}' unless defined(&TC_CORBA_double_struct);
    eval 'sub TC_CORBA_longdouble_struct () {\'TC_longdouble_struct\';}' unless defined(&TC_CORBA_longdouble_struct);
    eval 'sub TC_CORBA_long_double_struct () {\'TC_longdouble_struct\';}' unless defined(&TC_CORBA_long_double_struct);
    eval 'sub TC_CORBA_boolean_struct () { &TC_boolean_struct;}' unless defined(&TC_CORBA_boolean_struct);
    eval 'sub TC_CORBA_char_struct () { &TC_char_struct;}' unless defined(&TC_CORBA_char_struct);
    eval 'sub TC_CORBA_wchar_struct () { &TC_wchar_struct;}' unless defined(&TC_CORBA_wchar_struct);
    eval 'sub TC_CORBA_octet_struct () { &TC_octet_struct;}' unless defined(&TC_CORBA_octet_struct);
    eval 'sub TC_CORBA_any_struct () { &TC_any_struct;}' unless defined(&TC_CORBA_any_struct);
    eval 'sub TC_CORBA_TypeCode_struct () { &TC_TypeCode_struct;}' unless defined(&TC_CORBA_TypeCode_struct);
    eval 'sub TC_CORBA_Principal_struct () { &TC_Principal_struct;}' unless defined(&TC_CORBA_Principal_struct);
    eval 'sub TC_CORBA_Object_struct () { &TC_Object_struct;}' unless defined(&TC_CORBA_Object_struct);
    eval 'sub TC_CORBA_string_struct () { &TC_string_struct;}' unless defined(&TC_CORBA_string_struct);
    eval 'sub TC_CORBA_wstring_struct () { &TC_wstring_struct;}' unless defined(&TC_CORBA_wstring_struct);
}
1;
