require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ORBIT_DYNANY_H_)) {
    eval 'sub _ORBIT_DYNANY_H_ () {1;}' unless defined(&_ORBIT_DYNANY_H_);
    require 'orbit_types.ph';
    require 'orbit_object.ph';
    require 'corba_any.ph';
    eval 'sub ex_DynamicAny_DynAny_Invalid () {"IDL:CORBA/DynAny/Invalid:1.0";}' unless defined(&ex_DynamicAny_DynAny_Invalid);
    eval 'sub ex_DynamicAny_DynAny_InvalidValue () {"IDL:CORBA/DynAny/InvalidValue:1.0";}' unless defined(&ex_DynamicAny_DynAny_InvalidValue);
    eval 'sub ex_DynamicAny_DynAny_TypeMismatch () {"IDL:CORBA/DynAny/TypeMismatch:1.0";}' unless defined(&ex_DynamicAny_DynAny_TypeMismatch);
    eval 'sub ex_DynamicAny_DynAny_InvalidSeq () {"IDL:CORBA/DynAny/InvalidSeq:1.0";}' unless defined(&ex_DynamicAny_DynAny_InvalidSeq);
    if(defined(&HAVE_CORBA_LONG_LONG)) {
    }
    if(defined(&HAVE_CORBA_LONG_LONG)) {
    }
    eval 'sub TC_CORBA_sequence_DynamicAny_DynAny_AnySeq () {(( &CORBA_TypeCode) &TC_CORBA_sequence_DynamicAny_DynAny_AnySeq_struct);}' unless defined(&TC_CORBA_sequence_DynamicAny_DynAny_AnySeq);
    eval 'sub TC_CORBA_sequence_DynamicAny_DynAny_DynAnySeq () {(( &CORBA_TypeCode) &TC_CORBA_sequence_DynamicAny_DynAny_DynAnySeq_struct);}' unless defined(&TC_CORBA_sequence_DynamicAny_DynAny_DynAnySeq);
    eval 'sub DynamicAny_DynFixed_type () { &DynamicAny_DynAny_type;}' unless defined(&DynamicAny_DynFixed_type);
    eval 'sub DynamicAny_DynFixed_assign () { &DynamicAny_DynAny_assign;}' unless defined(&DynamicAny_DynFixed_assign);
    eval 'sub DynamicAny_DynFixed_from_any () { &DynamicAny_DynAny_from_any;}' unless defined(&DynamicAny_DynFixed_from_any);
    eval 'sub DynamicAny_DynFixed_to_any () { &DynamicAny_DynAny_to_any;}' unless defined(&DynamicAny_DynFixed_to_any);
    eval 'sub DynamicAny_DynFixed_destroy () { &DynamicAny_DynAny_destroy;}' unless defined(&DynamicAny_DynFixed_destroy);
    eval 'sub DynamicAny_DynFixed_equal () { &DynamicAny_DynAny_equal;}' unless defined(&DynamicAny_DynFixed_equal);
    eval 'sub DynamicAny_DynFixed_copy () { &DynamicAny_DynAny_copy;}' unless defined(&DynamicAny_DynFixed_copy);
    eval 'sub DynamicAny_DynFixed_insert_boolean () { &DynamicAny_DynAny_insert_boolean;}' unless defined(&DynamicAny_DynFixed_insert_boolean);
    eval 'sub DynamicAny_DynFixed_insert_octet () { &DynamicAny_DynAny_insert_octet;}' unless defined(&DynamicAny_DynFixed_insert_octet);
    eval 'sub DynamicAny_DynFixed_insert_char () { &DynamicAny_DynAny_insert_char;}' unless defined(&DynamicAny_DynFixed_insert_char);
    eval 'sub DynamicAny_DynFixed_insert_short () {\'DynamicAny_DynAny_insert_short\';}' unless defined(&DynamicAny_DynFixed_insert_short);
    eval 'sub DynamicAny_DynFixed_insert_ushort () {\'DynamicAny_DynAny_insert_ushort\';}' unless defined(&DynamicAny_DynFixed_insert_ushort);
    eval 'sub DynamicAny_DynFixed_insert_long () {\'DynamicAny_DynAny_insert_long\';}' unless defined(&DynamicAny_DynFixed_insert_long);
    eval 'sub DynamicAny_DynFixed_insert_ulong () {\'DynamicAny_DynAny_insert_ulong\';}' unless defined(&DynamicAny_DynFixed_insert_ulong);
    eval 'sub DynamicAny_DynFixed_insert_float () { &DynamicAny_DynAny_insert_float;}' unless defined(&DynamicAny_DynFixed_insert_float);
    eval 'sub DynamicAny_DynFixed_insert_double () { &DynamicAny_DynAny_insert_double;}' unless defined(&DynamicAny_DynFixed_insert_double);
    eval 'sub DynamicAny_DynFixed_insert_string () { &DynamicAny_DynAny_insert_string;}' unless defined(&DynamicAny_DynFixed_insert_string);
    eval 'sub DynamicAny_DynFixed_insert_reference () { &DynamicAny_DynAny_insert_reference;}' unless defined(&DynamicAny_DynFixed_insert_reference);
    eval 'sub DynamicAny_DynFixed_insert_typecode () { &DynamicAny_DynAny_insert_typecode;}' unless defined(&DynamicAny_DynFixed_insert_typecode);
    eval 'sub DynamicAny_DynFixed_insert_longlong () {\'DynamicAny_DynAny_insert_longlong\';}' unless defined(&DynamicAny_DynFixed_insert_longlong);
    eval 'sub DynamicAny_DynFixed_insert_ulonglong () {\'DynamicAny_DynAny_insert_ulonglong\';}' unless defined(&DynamicAny_DynFixed_insert_ulonglong);
    eval 'sub DynamicAny_DynFixed_insert_longdouble () {\'DynamicAny_DynAny_insert_longdouble\';}' unless defined(&DynamicAny_DynFixed_insert_longdouble);
    eval 'sub DynamicAny_DynFixed_insert_wchar () { &DynamicAny_DynAny_insert_wchar;}' unless defined(&DynamicAny_DynFixed_insert_wchar);
    eval 'sub DynamicAny_DynFixed_insert_wstring () { &DynamicAny_DynAny_insert_wstring;}' unless defined(&DynamicAny_DynFixed_insert_wstring);
    eval 'sub DynamicAny_DynFixed_insert_any () { &DynamicAny_DynAny_insert_any;}' unless defined(&DynamicAny_DynFixed_insert_any);
    eval 'sub DynamicAny_DynFixed_get_boolean () { &DynamicAny_DynAny_get_boolean;}' unless defined(&DynamicAny_DynFixed_get_boolean);
    eval 'sub DynamicAny_DynFixed_get_octet () { &DynamicAny_DynAny_get_octet;}' unless defined(&DynamicAny_DynFixed_get_octet);
    eval 'sub DynamicAny_DynFixed_get_char () { &DynamicAny_DynAny_get_char;}' unless defined(&DynamicAny_DynFixed_get_char);
    eval 'sub DynamicAny_DynFixed_get_short () {\'DynamicAny_DynAny_get_short\';}' unless defined(&DynamicAny_DynFixed_get_short);
    eval 'sub DynamicAny_DynFixed_get_ushort () {\'DynamicAny_DynAny_get_ushort\';}' unless defined(&DynamicAny_DynFixed_get_ushort);
    eval 'sub DynamicAny_DynFixed_get_long () {\'DynamicAny_DynAny_get_long\';}' unless defined(&DynamicAny_DynFixed_get_long);
    eval 'sub DynamicAny_DynFixed_get_ulong () {\'DynamicAny_DynAny_get_ulong\';}' unless defined(&DynamicAny_DynFixed_get_ulong);
    eval 'sub DynamicAny_DynFixed_get_float () { &DynamicAny_DynAny_get_float;}' unless defined(&DynamicAny_DynFixed_get_float);
    eval 'sub DynamicAny_DynFixed_get_double () { &DynamicAny_DynAny_get_double;}' unless defined(&DynamicAny_DynFixed_get_double);
    eval 'sub DynamicAny_DynFixed_get_string () { &DynamicAny_DynAny_get_string;}' unless defined(&DynamicAny_DynFixed_get_string);
    eval 'sub DynamicAny_DynFixed_get_reference () { &DynamicAny_DynAny_get_reference;}' unless defined(&DynamicAny_DynFixed_get_reference);
    eval 'sub DynamicAny_DynFixed_get_typecode () { &DynamicAny_DynAny_get_typecode;}' unless defined(&DynamicAny_DynFixed_get_typecode);
    eval 'sub DynamicAny_DynFixed_get_longlong () {\'DynamicAny_DynAny_get_longlong\';}' unless defined(&DynamicAny_DynFixed_get_longlong);
    eval 'sub DynamicAny_DynFixed_get_ulonglong () {\'DynamicAny_DynAny_get_ulonglong\';}' unless defined(&DynamicAny_DynFixed_get_ulonglong);
    eval 'sub DynamicAny_DynFixed_get_longdouble () {\'DynamicAny_DynAny_get_longdouble\';}' unless defined(&DynamicAny_DynFixed_get_longdouble);
    eval 'sub DynamicAny_DynFixed_get_wchar () { &DynamicAny_DynAny_get_wchar;}' unless defined(&DynamicAny_DynFixed_get_wchar);
    eval 'sub DynamicAny_DynFixed_get_wstring () { &DynamicAny_DynAny_get_wstring;}' unless defined(&DynamicAny_DynFixed_get_wstring);
    eval 'sub DynamicAny_DynFixed_get_any () { &DynamicAny_DynAny_get_any;}' unless defined(&DynamicAny_DynFixed_get_any);
    eval 'sub DynamicAny_DynFixed_component_count () { &DynamicAny_DynAny_component_count;}' unless defined(&DynamicAny_DynFixed_component_count);
    eval 'sub DynamicAny_DynFixed_current_component () { &DynamicAny_DynAny_current_component;}' unless defined(&DynamicAny_DynFixed_current_component);
    eval 'sub DynamicAny_DynFixed_next () { &DynamicAny_DynAny_next;}' unless defined(&DynamicAny_DynFixed_next);
    eval 'sub DynamicAny_DynFixed_seek () { &DynamicAny_DynAny_seek;}' unless defined(&DynamicAny_DynFixed_seek);
    eval 'sub DynamicAny_DynFixed_rewind () { &DynamicAny_DynAny_rewind;}' unless defined(&DynamicAny_DynFixed_rewind);
    eval 'sub DynamicAny_DynEnum_type () { &DynamicAny_DynAny_type;}' unless defined(&DynamicAny_DynEnum_type);
    eval 'sub DynamicAny_DynEnum_assign () { &DynamicAny_DynAny_assign;}' unless defined(&DynamicAny_DynEnum_assign);
    eval 'sub DynamicAny_DynEnum_from_any () { &DynamicAny_DynAny_from_any;}' unless defined(&DynamicAny_DynEnum_from_any);
    eval 'sub DynamicAny_DynEnum_to_any () { &DynamicAny_DynAny_to_any;}' unless defined(&DynamicAny_DynEnum_to_any);
    eval 'sub DynamicAny_DynEnum_destroy () { &DynamicAny_DynAny_destroy;}' unless defined(&DynamicAny_DynEnum_destroy);
    eval 'sub DynamicAny_DynEnum_equal () { &DynamicAny_DynAny_equal;}' unless defined(&DynamicAny_DynEnum_equal);
    eval 'sub DynamicAny_DynEnum_copy () { &DynamicAny_DynAny_copy;}' unless defined(&DynamicAny_DynEnum_copy);
    eval 'sub DynamicAny_DynEnum_insert_boolean () { &DynamicAny_DynAny_insert_boolean;}' unless defined(&DynamicAny_DynEnum_insert_boolean);
    eval 'sub DynamicAny_DynEnum_insert_octet () { &DynamicAny_DynAny_insert_octet;}' unless defined(&DynamicAny_DynEnum_insert_octet);
    eval 'sub DynamicAny_DynEnum_insert_char () { &DynamicAny_DynAny_insert_char;}' unless defined(&DynamicAny_DynEnum_insert_char);
    eval 'sub DynamicAny_DynEnum_insert_short () {\'DynamicAny_DynAny_insert_short\';}' unless defined(&DynamicAny_DynEnum_insert_short);
    eval 'sub DynamicAny_DynEnum_insert_ushort () {\'DynamicAny_DynAny_insert_ushort\';}' unless defined(&DynamicAny_DynEnum_insert_ushort);
    eval 'sub DynamicAny_DynEnum_insert_long () {\'DynamicAny_DynAny_insert_long\';}' unless defined(&DynamicAny_DynEnum_insert_long);
    eval 'sub DynamicAny_DynEnum_insert_ulong () {\'DynamicAny_DynAny_insert_ulong\';}' unless defined(&DynamicAny_DynEnum_insert_ulong);
    eval 'sub DynamicAny_DynEnum_insert_float () { &DynamicAny_DynAny_insert_float;}' unless defined(&DynamicAny_DynEnum_insert_float);
    eval 'sub DynamicAny_DynEnum_insert_double () { &DynamicAny_DynAny_insert_double;}' unless defined(&DynamicAny_DynEnum_insert_double);
    eval 'sub DynamicAny_DynEnum_insert_string () { &DynamicAny_DynAny_insert_string;}' unless defined(&DynamicAny_DynEnum_insert_string);
    eval 'sub DynamicAny_DynEnum_insert_reference () { &DynamicAny_DynAny_insert_reference;}' unless defined(&DynamicAny_DynEnum_insert_reference);
    eval 'sub DynamicAny_DynEnum_insert_typecode () { &DynamicAny_DynAny_insert_typecode;}' unless defined(&DynamicAny_DynEnum_insert_typecode);
    eval 'sub DynamicAny_DynEnum_insert_longlong () {\'DynamicAny_DynAny_insert_longlong\';}' unless defined(&DynamicAny_DynEnum_insert_longlong);
    eval 'sub DynamicAny_DynEnum_insert_ulonglong () {\'DynamicAny_DynAny_insert_ulonglong\';}' unless defined(&DynamicAny_DynEnum_insert_ulonglong);
    eval 'sub DynamicAny_DynEnum_insert_longdouble () {\'DynamicAny_DynAny_insert_longdouble\';}' unless defined(&DynamicAny_DynEnum_insert_longdouble);
    eval 'sub DynamicAny_DynEnum_insert_wchar () { &DynamicAny_DynAny_insert_wchar;}' unless defined(&DynamicAny_DynEnum_insert_wchar);
    eval 'sub DynamicAny_DynEnum_insert_wstring () { &DynamicAny_DynAny_insert_wstring;}' unless defined(&DynamicAny_DynEnum_insert_wstring);
    eval 'sub DynamicAny_DynEnum_insert_any () { &DynamicAny_DynAny_insert_any;}' unless defined(&DynamicAny_DynEnum_insert_any);
    eval 'sub DynamicAny_DynEnum_get_boolean () { &DynamicAny_DynAny_get_boolean;}' unless defined(&DynamicAny_DynEnum_get_boolean);
    eval 'sub DynamicAny_DynEnum_get_octet () { &DynamicAny_DynAny_get_octet;}' unless defined(&DynamicAny_DynEnum_get_octet);
    eval 'sub DynamicAny_DynEnum_get_char () { &DynamicAny_DynAny_get_char;}' unless defined(&DynamicAny_DynEnum_get_char);
    eval 'sub DynamicAny_DynEnum_get_short () {\'DynamicAny_DynAny_get_short\';}' unless defined(&DynamicAny_DynEnum_get_short);
    eval 'sub DynamicAny_DynEnum_get_ushort () {\'DynamicAny_DynAny_get_ushort\';}' unless defined(&DynamicAny_DynEnum_get_ushort);
    eval 'sub DynamicAny_DynEnum_get_long () {\'DynamicAny_DynAny_get_long\';}' unless defined(&DynamicAny_DynEnum_get_long);
    eval 'sub DynamicAny_DynEnum_get_ulong () {\'DynamicAny_DynAny_get_ulong\';}' unless defined(&DynamicAny_DynEnum_get_ulong);
    eval 'sub DynamicAny_DynEnum_get_float () { &DynamicAny_DynAny_get_float;}' unless defined(&DynamicAny_DynEnum_get_float);
    eval 'sub DynamicAny_DynEnum_get_double () { &DynamicAny_DynAny_get_double;}' unless defined(&DynamicAny_DynEnum_get_double);
    eval 'sub DynamicAny_DynEnum_get_string () { &DynamicAny_DynAny_get_string;}' unless defined(&DynamicAny_DynEnum_get_string);
    eval 'sub DynamicAny_DynEnum_get_reference () { &DynamicAny_DynAny_get_reference;}' unless defined(&DynamicAny_DynEnum_get_reference);
    eval 'sub DynamicAny_DynEnum_get_typecode () { &DynamicAny_DynAny_get_typecode;}' unless defined(&DynamicAny_DynEnum_get_typecode);
    eval 'sub DynamicAny_DynEnum_get_longlong () {\'DynamicAny_DynAny_get_longlong\';}' unless defined(&DynamicAny_DynEnum_get_longlong);
    eval 'sub DynamicAny_DynEnum_get_ulonglong () {\'DynamicAny_DynAny_get_ulonglong\';}' unless defined(&DynamicAny_DynEnum_get_ulonglong);
    eval 'sub DynamicAny_DynEnum_get_longdouble () {\'DynamicAny_DynAny_get_longdouble\';}' unless defined(&DynamicAny_DynEnum_get_longdouble);
    eval 'sub DynamicAny_DynEnum_get_wchar () { &DynamicAny_DynAny_get_wchar;}' unless defined(&DynamicAny_DynEnum_get_wchar);
    eval 'sub DynamicAny_DynEnum_get_wstring () { &DynamicAny_DynAny_get_wstring;}' unless defined(&DynamicAny_DynEnum_get_wstring);
    eval 'sub DynamicAny_DynEnum_get_any () { &DynamicAny_DynAny_get_any;}' unless defined(&DynamicAny_DynEnum_get_any);
    eval 'sub DynamicAny_DynEnum_component_count () { &DynamicAny_DynAny_component_count;}' unless defined(&DynamicAny_DynEnum_component_count);
    eval 'sub DynamicAny_DynEnum_current_component () { &DynamicAny_DynAny_current_component;}' unless defined(&DynamicAny_DynEnum_current_component);
    eval 'sub DynamicAny_DynEnum_next () { &DynamicAny_DynAny_next;}' unless defined(&DynamicAny_DynEnum_next);
    eval 'sub DynamicAny_DynEnum_seek () { &DynamicAny_DynAny_seek;}' unless defined(&DynamicAny_DynEnum_seek);
    eval 'sub DynamicAny_DynEnum_rewind () { &DynamicAny_DynAny_rewind;}' unless defined(&DynamicAny_DynEnum_rewind);
    eval 'sub DynamicAny_DynStruct_type () { &DynamicAny_DynAny_type;}' unless defined(&DynamicAny_DynStruct_type);
    eval 'sub DynamicAny_DynStruct_assign () { &DynamicAny_DynAny_assign;}' unless defined(&DynamicAny_DynStruct_assign);
    eval 'sub DynamicAny_DynStruct_from_any () { &DynamicAny_DynAny_from_any;}' unless defined(&DynamicAny_DynStruct_from_any);
    eval 'sub DynamicAny_DynStruct_to_any () { &DynamicAny_DynAny_to_any;}' unless defined(&DynamicAny_DynStruct_to_any);
    eval 'sub DynamicAny_DynStruct_destroy () { &DynamicAny_DynAny_destroy;}' unless defined(&DynamicAny_DynStruct_destroy);
    eval 'sub DynamicAny_DynStruct_equal () { &DynamicAny_DynAny_equal;}' unless defined(&DynamicAny_DynStruct_equal);
    eval 'sub DynamicAny_DynStruct_copy () { &DynamicAny_DynAny_copy;}' unless defined(&DynamicAny_DynStruct_copy);
    eval 'sub DynamicAny_DynStruct_insert_boolean () { &DynamicAny_DynAny_insert_boolean;}' unless defined(&DynamicAny_DynStruct_insert_boolean);
    eval 'sub DynamicAny_DynStruct_insert_octet () { &DynamicAny_DynAny_insert_octet;}' unless defined(&DynamicAny_DynStruct_insert_octet);
    eval 'sub DynamicAny_DynStruct_insert_char () { &DynamicAny_DynAny_insert_char;}' unless defined(&DynamicAny_DynStruct_insert_char);
    eval 'sub DynamicAny_DynStruct_insert_short () {\'DynamicAny_DynAny_insert_short\';}' unless defined(&DynamicAny_DynStruct_insert_short);
    eval 'sub DynamicAny_DynStruct_insert_ushort () {\'DynamicAny_DynAny_insert_ushort\';}' unless defined(&DynamicAny_DynStruct_insert_ushort);
    eval 'sub DynamicAny_DynStruct_insert_long () {\'DynamicAny_DynAny_insert_long\';}' unless defined(&DynamicAny_DynStruct_insert_long);
    eval 'sub DynamicAny_DynStruct_insert_ulong () {\'DynamicAny_DynAny_insert_ulong\';}' unless defined(&DynamicAny_DynStruct_insert_ulong);
    eval 'sub DynamicAny_DynStruct_insert_float () { &DynamicAny_DynAny_insert_float;}' unless defined(&DynamicAny_DynStruct_insert_float);
    eval 'sub DynamicAny_DynStruct_insert_double () { &DynamicAny_DynAny_insert_double;}' unless defined(&DynamicAny_DynStruct_insert_double);
    eval 'sub DynamicAny_DynStruct_insert_string () { &DynamicAny_DynAny_insert_string;}' unless defined(&DynamicAny_DynStruct_insert_string);
    eval 'sub DynamicAny_DynStruct_insert_reference () { &DynamicAny_DynAny_insert_reference;}' unless defined(&DynamicAny_DynStruct_insert_reference);
    eval 'sub DynamicAny_DynStruct_insert_typecode () { &DynamicAny_DynAny_insert_typecode;}' unless defined(&DynamicAny_DynStruct_insert_typecode);
    eval 'sub DynamicAny_DynStruct_insert_longlong () {\'DynamicAny_DynAny_insert_longlong\';}' unless defined(&DynamicAny_DynStruct_insert_longlong);
    eval 'sub DynamicAny_DynStruct_insert_ulonglong () {\'DynamicAny_DynAny_insert_ulonglong\';}' unless defined(&DynamicAny_DynStruct_insert_ulonglong);
    eval 'sub DynamicAny_DynStruct_insert_longdouble () {\'DynamicAny_DynAny_insert_longdouble\';}' unless defined(&DynamicAny_DynStruct_insert_longdouble);
    eval 'sub DynamicAny_DynStruct_insert_wchar () { &DynamicAny_DynAny_insert_wchar;}' unless defined(&DynamicAny_DynStruct_insert_wchar);
    eval 'sub DynamicAny_DynStruct_insert_wstring () { &DynamicAny_DynAny_insert_wstring;}' unless defined(&DynamicAny_DynStruct_insert_wstring);
    eval 'sub DynamicAny_DynStruct_insert_any () { &DynamicAny_DynAny_insert_any;}' unless defined(&DynamicAny_DynStruct_insert_any);
    eval 'sub DynamicAny_DynStruct_get_boolean () { &DynamicAny_DynAny_get_boolean;}' unless defined(&DynamicAny_DynStruct_get_boolean);
    eval 'sub DynamicAny_DynStruct_get_octet () { &DynamicAny_DynAny_get_octet;}' unless defined(&DynamicAny_DynStruct_get_octet);
    eval 'sub DynamicAny_DynStruct_get_char () { &DynamicAny_DynAny_get_char;}' unless defined(&DynamicAny_DynStruct_get_char);
    eval 'sub DynamicAny_DynStruct_get_short () {\'DynamicAny_DynAny_get_short\';}' unless defined(&DynamicAny_DynStruct_get_short);
    eval 'sub DynamicAny_DynStruct_get_ushort () {\'DynamicAny_DynAny_get_ushort\';}' unless defined(&DynamicAny_DynStruct_get_ushort);
    eval 'sub DynamicAny_DynStruct_get_long () {\'DynamicAny_DynAny_get_long\';}' unless defined(&DynamicAny_DynStruct_get_long);
    eval 'sub DynamicAny_DynStruct_get_ulong () {\'DynamicAny_DynAny_get_ulong\';}' unless defined(&DynamicAny_DynStruct_get_ulong);
    eval 'sub DynamicAny_DynStruct_get_float () { &DynamicAny_DynAny_get_float;}' unless defined(&DynamicAny_DynStruct_get_float);
    eval 'sub DynamicAny_DynStruct_get_double () { &DynamicAny_DynAny_get_double;}' unless defined(&DynamicAny_DynStruct_get_double);
    eval 'sub DynamicAny_DynStruct_get_string () { &DynamicAny_DynAny_get_string;}' unless defined(&DynamicAny_DynStruct_get_string);
    eval 'sub DynamicAny_DynStruct_get_reference () { &DynamicAny_DynAny_get_reference;}' unless defined(&DynamicAny_DynStruct_get_reference);
    eval 'sub DynamicAny_DynStruct_get_typecode () { &DynamicAny_DynAny_get_typecode;}' unless defined(&DynamicAny_DynStruct_get_typecode);
    eval 'sub DynamicAny_DynStruct_get_longlong () {\'DynamicAny_DynAny_get_longlong\';}' unless defined(&DynamicAny_DynStruct_get_longlong);
    eval 'sub DynamicAny_DynStruct_get_ulonglong () {\'DynamicAny_DynAny_get_ulonglong\';}' unless defined(&DynamicAny_DynStruct_get_ulonglong);
    eval 'sub DynamicAny_DynStruct_get_longdouble () {\'DynamicAny_DynAny_get_longdouble\';}' unless defined(&DynamicAny_DynStruct_get_longdouble);
    eval 'sub DynamicAny_DynStruct_get_wchar () { &DynamicAny_DynAny_get_wchar;}' unless defined(&DynamicAny_DynStruct_get_wchar);
    eval 'sub DynamicAny_DynStruct_get_wstring () { &DynamicAny_DynAny_get_wstring;}' unless defined(&DynamicAny_DynStruct_get_wstring);
    eval 'sub DynamicAny_DynStruct_get_any () { &DynamicAny_DynAny_get_any;}' unless defined(&DynamicAny_DynStruct_get_any);
    eval 'sub DynamicAny_DynStruct_component_count () { &DynamicAny_DynAny_component_count;}' unless defined(&DynamicAny_DynStruct_component_count);
    eval 'sub DynamicAny_DynStruct_current_component () { &DynamicAny_DynAny_current_component;}' unless defined(&DynamicAny_DynStruct_current_component);
    eval 'sub DynamicAny_DynStruct_next () { &DynamicAny_DynAny_next;}' unless defined(&DynamicAny_DynStruct_next);
    eval 'sub DynamicAny_DynStruct_seek () { &DynamicAny_DynAny_seek;}' unless defined(&DynamicAny_DynStruct_seek);
    eval 'sub DynamicAny_DynStruct_rewind () { &DynamicAny_DynAny_rewind;}' unless defined(&DynamicAny_DynStruct_rewind);
    eval 'sub DynamicAny_DynUnion_type () { &DynamicAny_DynAny_type;}' unless defined(&DynamicAny_DynUnion_type);
    eval 'sub DynamicAny_DynUnion_assign () { &DynamicAny_DynAny_assign;}' unless defined(&DynamicAny_DynUnion_assign);
    eval 'sub DynamicAny_DynUnion_from_any () { &DynamicAny_DynAny_from_any;}' unless defined(&DynamicAny_DynUnion_from_any);
    eval 'sub DynamicAny_DynUnion_to_any () { &DynamicAny_DynAny_to_any;}' unless defined(&DynamicAny_DynUnion_to_any);
    eval 'sub DynamicAny_DynUnion_destroy () { &DynamicAny_DynAny_destroy;}' unless defined(&DynamicAny_DynUnion_destroy);
    eval 'sub DynamicAny_DynUnion_equal () { &DynamicAny_DynAny_equal;}' unless defined(&DynamicAny_DynUnion_equal);
    eval 'sub DynamicAny_DynUnion_copy () { &DynamicAny_DynAny_copy;}' unless defined(&DynamicAny_DynUnion_copy);
    eval 'sub DynamicAny_DynUnion_insert_boolean () { &DynamicAny_DynAny_insert_boolean;}' unless defined(&DynamicAny_DynUnion_insert_boolean);
    eval 'sub DynamicAny_DynUnion_insert_octet () { &DynamicAny_DynAny_insert_octet;}' unless defined(&DynamicAny_DynUnion_insert_octet);
    eval 'sub DynamicAny_DynUnion_insert_char () { &DynamicAny_DynAny_insert_char;}' unless defined(&DynamicAny_DynUnion_insert_char);
    eval 'sub DynamicAny_DynUnion_insert_short () {\'DynamicAny_DynAny_insert_short\';}' unless defined(&DynamicAny_DynUnion_insert_short);
    eval 'sub DynamicAny_DynUnion_insert_ushort () {\'DynamicAny_DynAny_insert_ushort\';}' unless defined(&DynamicAny_DynUnion_insert_ushort);
    eval 'sub DynamicAny_DynUnion_insert_long () {\'DynamicAny_DynAny_insert_long\';}' unless defined(&DynamicAny_DynUnion_insert_long);
    eval 'sub DynamicAny_DynUnion_insert_ulong () {\'DynamicAny_DynAny_insert_ulong\';}' unless defined(&DynamicAny_DynUnion_insert_ulong);
    eval 'sub DynamicAny_DynUnion_insert_float () { &DynamicAny_DynAny_insert_float;}' unless defined(&DynamicAny_DynUnion_insert_float);
    eval 'sub DynamicAny_DynUnion_insert_double () { &DynamicAny_DynAny_insert_double;}' unless defined(&DynamicAny_DynUnion_insert_double);
    eval 'sub DynamicAny_DynUnion_insert_string () { &DynamicAny_DynAny_insert_string;}' unless defined(&DynamicAny_DynUnion_insert_string);
    eval 'sub DynamicAny_DynUnion_insert_reference () { &DynamicAny_DynAny_insert_reference;}' unless defined(&DynamicAny_DynUnion_insert_reference);
    eval 'sub DynamicAny_DynUnion_insert_typecode () { &DynamicAny_DynAny_insert_typecode;}' unless defined(&DynamicAny_DynUnion_insert_typecode);
    eval 'sub DynamicAny_DynUnion_insert_longlong () {\'DynamicAny_DynAny_insert_longlong\';}' unless defined(&DynamicAny_DynUnion_insert_longlong);
    eval 'sub DynamicAny_DynUnion_insert_ulonglong () {\'DynamicAny_DynAny_insert_ulonglong\';}' unless defined(&DynamicAny_DynUnion_insert_ulonglong);
    eval 'sub DynamicAny_DynUnion_insert_longdouble () {\'DynamicAny_DynAny_insert_longdouble\';}' unless defined(&DynamicAny_DynUnion_insert_longdouble);
    eval 'sub DynamicAny_DynUnion_insert_wchar () { &DynamicAny_DynAny_insert_wchar;}' unless defined(&DynamicAny_DynUnion_insert_wchar);
    eval 'sub DynamicAny_DynUnion_insert_wstring () { &DynamicAny_DynAny_insert_wstring;}' unless defined(&DynamicAny_DynUnion_insert_wstring);
    eval 'sub DynamicAny_DynUnion_insert_any () { &DynamicAny_DynAny_insert_any;}' unless defined(&DynamicAny_DynUnion_insert_any);
    eval 'sub DynamicAny_DynUnion_get_boolean () { &DynamicAny_DynAny_get_boolean;}' unless defined(&DynamicAny_DynUnion_get_boolean);
    eval 'sub DynamicAny_DynUnion_get_octet () { &DynamicAny_DynAny_get_octet;}' unless defined(&DynamicAny_DynUnion_get_octet);
    eval 'sub DynamicAny_DynUnion_get_char () { &DynamicAny_DynAny_get_char;}' unless defined(&DynamicAny_DynUnion_get_char);
    eval 'sub DynamicAny_DynUnion_get_short () {\'DynamicAny_DynAny_get_short\';}' unless defined(&DynamicAny_DynUnion_get_short);
    eval 'sub DynamicAny_DynUnion_get_ushort () {\'DynamicAny_DynAny_get_ushort\';}' unless defined(&DynamicAny_DynUnion_get_ushort);
    eval 'sub DynamicAny_DynUnion_get_long () {\'DynamicAny_DynAny_get_long\';}' unless defined(&DynamicAny_DynUnion_get_long);
    eval 'sub DynamicAny_DynUnion_get_ulong () {\'DynamicAny_DynAny_get_ulong\';}' unless defined(&DynamicAny_DynUnion_get_ulong);
    eval 'sub DynamicAny_DynUnion_get_float () { &DynamicAny_DynAny_get_float;}' unless defined(&DynamicAny_DynUnion_get_float);
    eval 'sub DynamicAny_DynUnion_get_double () { &DynamicAny_DynAny_get_double;}' unless defined(&DynamicAny_DynUnion_get_double);
    eval 'sub DynamicAny_DynUnion_get_string () { &DynamicAny_DynAny_get_string;}' unless defined(&DynamicAny_DynUnion_get_string);
    eval 'sub DynamicAny_DynUnion_get_reference () { &DynamicAny_DynAny_get_reference;}' unless defined(&DynamicAny_DynUnion_get_reference);
    eval 'sub DynamicAny_DynUnion_get_typecode () { &DynamicAny_DynAny_get_typecode;}' unless defined(&DynamicAny_DynUnion_get_typecode);
    eval 'sub DynamicAny_DynUnion_get_longlong () {\'DynamicAny_DynAny_get_longlong\';}' unless defined(&DynamicAny_DynUnion_get_longlong);
    eval 'sub DynamicAny_DynUnion_get_ulonglong () {\'DynamicAny_DynAny_get_ulonglong\';}' unless defined(&DynamicAny_DynUnion_get_ulonglong);
    eval 'sub DynamicAny_DynUnion_get_longdouble () {\'DynamicAny_DynAny_get_longdouble\';}' unless defined(&DynamicAny_DynUnion_get_longdouble);
    eval 'sub DynamicAny_DynUnion_get_wchar () { &DynamicAny_DynAny_get_wchar;}' unless defined(&DynamicAny_DynUnion_get_wchar);
    eval 'sub DynamicAny_DynUnion_get_wstring () { &DynamicAny_DynAny_get_wstring;}' unless defined(&DynamicAny_DynUnion_get_wstring);
    eval 'sub DynamicAny_DynUnion_get_any () { &DynamicAny_DynAny_get_any;}' unless defined(&DynamicAny_DynUnion_get_any);
    eval 'sub DynamicAny_DynUnion_component_count () { &DynamicAny_DynAny_component_count;}' unless defined(&DynamicAny_DynUnion_component_count);
    eval 'sub DynamicAny_DynUnion_current_component () { &DynamicAny_DynAny_current_component;}' unless defined(&DynamicAny_DynUnion_current_component);
    eval 'sub DynamicAny_DynUnion_next () { &DynamicAny_DynAny_next;}' unless defined(&DynamicAny_DynUnion_next);
    eval 'sub DynamicAny_DynUnion_seek () { &DynamicAny_DynAny_seek;}' unless defined(&DynamicAny_DynUnion_seek);
    eval 'sub DynamicAny_DynUnion_rewind () { &DynamicAny_DynAny_rewind;}' unless defined(&DynamicAny_DynUnion_rewind);
    eval 'sub DynamicAny_DynSequence_type () { &DynamicAny_DynAny_type;}' unless defined(&DynamicAny_DynSequence_type);
    eval 'sub DynamicAny_DynSequence_assign () { &DynamicAny_DynAny_assign;}' unless defined(&DynamicAny_DynSequence_assign);
    eval 'sub DynamicAny_DynSequence_from_any () { &DynamicAny_DynAny_from_any;}' unless defined(&DynamicAny_DynSequence_from_any);
    eval 'sub DynamicAny_DynSequence_to_any () { &DynamicAny_DynAny_to_any;}' unless defined(&DynamicAny_DynSequence_to_any);
    eval 'sub DynamicAny_DynSequence_destroy () { &DynamicAny_DynAny_destroy;}' unless defined(&DynamicAny_DynSequence_destroy);
    eval 'sub DynamicAny_DynSequence_equal () { &DynamicAny_DynAny_equal;}' unless defined(&DynamicAny_DynSequence_equal);
    eval 'sub DynamicAny_DynSequence_copy () { &DynamicAny_DynAny_copy;}' unless defined(&DynamicAny_DynSequence_copy);
    eval 'sub DynamicAny_DynSequence_insert_boolean () { &DynamicAny_DynAny_insert_boolean;}' unless defined(&DynamicAny_DynSequence_insert_boolean);
    eval 'sub DynamicAny_DynSequence_insert_octet () { &DynamicAny_DynAny_insert_octet;}' unless defined(&DynamicAny_DynSequence_insert_octet);
    eval 'sub DynamicAny_DynSequence_insert_char () { &DynamicAny_DynAny_insert_char;}' unless defined(&DynamicAny_DynSequence_insert_char);
    eval 'sub DynamicAny_DynSequence_insert_short () {\'DynamicAny_DynAny_insert_short\';}' unless defined(&DynamicAny_DynSequence_insert_short);
    eval 'sub DynamicAny_DynSequence_insert_ushort () {\'DynamicAny_DynAny_insert_ushort\';}' unless defined(&DynamicAny_DynSequence_insert_ushort);
    eval 'sub DynamicAny_DynSequence_insert_long () {\'DynamicAny_DynAny_insert_long\';}' unless defined(&DynamicAny_DynSequence_insert_long);
    eval 'sub DynamicAny_DynSequence_insert_ulong () {\'DynamicAny_DynAny_insert_ulong\';}' unless defined(&DynamicAny_DynSequence_insert_ulong);
    eval 'sub DynamicAny_DynSequence_insert_float () { &DynamicAny_DynAny_insert_float;}' unless defined(&DynamicAny_DynSequence_insert_float);
    eval 'sub DynamicAny_DynSequence_insert_double () { &DynamicAny_DynAny_insert_double;}' unless defined(&DynamicAny_DynSequence_insert_double);
    eval 'sub DynamicAny_DynSequence_insert_string () { &DynamicAny_DynAny_insert_string;}' unless defined(&DynamicAny_DynSequence_insert_string);
    eval 'sub DynamicAny_DynSequence_insert_reference () { &DynamicAny_DynAny_insert_reference;}' unless defined(&DynamicAny_DynSequence_insert_reference);
    eval 'sub DynamicAny_DynSequence_insert_typecode () { &DynamicAny_DynAny_insert_typecode;}' unless defined(&DynamicAny_DynSequence_insert_typecode);
    eval 'sub DynamicAny_DynSequence_insert_longlong () {\'DynamicAny_DynAny_insert_longlong\';}' unless defined(&DynamicAny_DynSequence_insert_longlong);
    eval 'sub DynamicAny_DynSequence_insert_ulonglong () {\'DynamicAny_DynAny_insert_ulonglong\';}' unless defined(&DynamicAny_DynSequence_insert_ulonglong);
    eval 'sub DynamicAny_DynSequence_insert_longdouble () {\'DynamicAny_DynAny_insert_longdouble\';}' unless defined(&DynamicAny_DynSequence_insert_longdouble);
    eval 'sub DynamicAny_DynSequence_insert_wchar () { &DynamicAny_DynAny_insert_wchar;}' unless defined(&DynamicAny_DynSequence_insert_wchar);
    eval 'sub DynamicAny_DynSequence_insert_wstring () { &DynamicAny_DynAny_insert_wstring;}' unless defined(&DynamicAny_DynSequence_insert_wstring);
    eval 'sub DynamicAny_DynSequence_insert_any () { &DynamicAny_DynAny_insert_any;}' unless defined(&DynamicAny_DynSequence_insert_any);
    eval 'sub DynamicAny_DynSequence_get_boolean () { &DynamicAny_DynAny_get_boolean;}' unless defined(&DynamicAny_DynSequence_get_boolean);
    eval 'sub DynamicAny_DynSequence_get_octet () { &DynamicAny_DynAny_get_octet;}' unless defined(&DynamicAny_DynSequence_get_octet);
    eval 'sub DynamicAny_DynSequence_get_char () { &DynamicAny_DynAny_get_char;}' unless defined(&DynamicAny_DynSequence_get_char);
    eval 'sub DynamicAny_DynSequence_get_short () {\'DynamicAny_DynAny_get_short\';}' unless defined(&DynamicAny_DynSequence_get_short);
    eval 'sub DynamicAny_DynSequence_get_ushort () {\'DynamicAny_DynAny_get_ushort\';}' unless defined(&DynamicAny_DynSequence_get_ushort);
    eval 'sub DynamicAny_DynSequence_get_long () {\'DynamicAny_DynAny_get_long\';}' unless defined(&DynamicAny_DynSequence_get_long);
    eval 'sub DynamicAny_DynSequence_get_ulong () {\'DynamicAny_DynAny_get_ulong\';}' unless defined(&DynamicAny_DynSequence_get_ulong);
    eval 'sub DynamicAny_DynSequence_get_float () { &DynamicAny_DynAny_get_float;}' unless defined(&DynamicAny_DynSequence_get_float);
    eval 'sub DynamicAny_DynSequence_get_double () { &DynamicAny_DynAny_get_double;}' unless defined(&DynamicAny_DynSequence_get_double);
    eval 'sub DynamicAny_DynSequence_get_string () { &DynamicAny_DynAny_get_string;}' unless defined(&DynamicAny_DynSequence_get_string);
    eval 'sub DynamicAny_DynSequence_get_reference () { &DynamicAny_DynAny_get_reference;}' unless defined(&DynamicAny_DynSequence_get_reference);
    eval 'sub DynamicAny_DynSequence_get_typecode () { &DynamicAny_DynAny_get_typecode;}' unless defined(&DynamicAny_DynSequence_get_typecode);
    eval 'sub DynamicAny_DynSequence_get_longlong () {\'DynamicAny_DynAny_get_longlong\';}' unless defined(&DynamicAny_DynSequence_get_longlong);
    eval 'sub DynamicAny_DynSequence_get_ulonglong () {\'DynamicAny_DynAny_get_ulonglong\';}' unless defined(&DynamicAny_DynSequence_get_ulonglong);
    eval 'sub DynamicAny_DynSequence_get_longdouble () {\'DynamicAny_DynAny_get_longdouble\';}' unless defined(&DynamicAny_DynSequence_get_longdouble);
    eval 'sub DynamicAny_DynSequence_get_wchar () { &DynamicAny_DynAny_get_wchar;}' unless defined(&DynamicAny_DynSequence_get_wchar);
    eval 'sub DynamicAny_DynSequence_get_wstring () { &DynamicAny_DynAny_get_wstring;}' unless defined(&DynamicAny_DynSequence_get_wstring);
    eval 'sub DynamicAny_DynSequence_get_any () { &DynamicAny_DynAny_get_any;}' unless defined(&DynamicAny_DynSequence_get_any);
    eval 'sub DynamicAny_DynSequence_component_count () { &DynamicAny_DynAny_component_count;}' unless defined(&DynamicAny_DynSequence_component_count);
    eval 'sub DynamicAny_DynSequence_current_component () { &DynamicAny_DynAny_current_component;}' unless defined(&DynamicAny_DynSequence_current_component);
    eval 'sub DynamicAny_DynSequence_next () { &DynamicAny_DynAny_next;}' unless defined(&DynamicAny_DynSequence_next);
    eval 'sub DynamicAny_DynSequence_seek () { &DynamicAny_DynAny_seek;}' unless defined(&DynamicAny_DynSequence_seek);
    eval 'sub DynamicAny_DynSequence_rewind () { &DynamicAny_DynAny_rewind;}' unless defined(&DynamicAny_DynSequence_rewind);
    eval 'sub DynamicAny_DynArray_type () { &DynamicAny_DynAny_type;}' unless defined(&DynamicAny_DynArray_type);
    eval 'sub DynamicAny_DynArray_assign () { &DynamicAny_DynAny_assign;}' unless defined(&DynamicAny_DynArray_assign);
    eval 'sub DynamicAny_DynArray_from_any () { &DynamicAny_DynAny_from_any;}' unless defined(&DynamicAny_DynArray_from_any);
    eval 'sub DynamicAny_DynArray_to_any () { &DynamicAny_DynAny_to_any;}' unless defined(&DynamicAny_DynArray_to_any);
    eval 'sub DynamicAny_DynArray_destroy () { &DynamicAny_DynAny_destroy;}' unless defined(&DynamicAny_DynArray_destroy);
    eval 'sub DynamicAny_DynArray_equal () { &DynamicAny_DynAny_equal;}' unless defined(&DynamicAny_DynArray_equal);
    eval 'sub DynamicAny_DynArray_copy () { &DynamicAny_DynAny_copy;}' unless defined(&DynamicAny_DynArray_copy);
    eval 'sub DynamicAny_DynArray_insert_boolean () { &DynamicAny_DynAny_insert_boolean;}' unless defined(&DynamicAny_DynArray_insert_boolean);
    eval 'sub DynamicAny_DynArray_insert_octet () { &DynamicAny_DynAny_insert_octet;}' unless defined(&DynamicAny_DynArray_insert_octet);
    eval 'sub DynamicAny_DynArray_insert_char () { &DynamicAny_DynAny_insert_char;}' unless defined(&DynamicAny_DynArray_insert_char);
    eval 'sub DynamicAny_DynArray_insert_short () {\'DynamicAny_DynAny_insert_short\';}' unless defined(&DynamicAny_DynArray_insert_short);
    eval 'sub DynamicAny_DynArray_insert_ushort () {\'DynamicAny_DynAny_insert_ushort\';}' unless defined(&DynamicAny_DynArray_insert_ushort);
    eval 'sub DynamicAny_DynArray_insert_long () {\'DynamicAny_DynAny_insert_long\';}' unless defined(&DynamicAny_DynArray_insert_long);
    eval 'sub DynamicAny_DynArray_insert_ulong () {\'DynamicAny_DynAny_insert_ulong\';}' unless defined(&DynamicAny_DynArray_insert_ulong);
    eval 'sub DynamicAny_DynArray_insert_float () { &DynamicAny_DynAny_insert_float;}' unless defined(&DynamicAny_DynArray_insert_float);
    eval 'sub DynamicAny_DynArray_insert_double () { &DynamicAny_DynAny_insert_double;}' unless defined(&DynamicAny_DynArray_insert_double);
    eval 'sub DynamicAny_DynArray_insert_string () { &DynamicAny_DynAny_insert_string;}' unless defined(&DynamicAny_DynArray_insert_string);
    eval 'sub DynamicAny_DynArray_insert_reference () { &DynamicAny_DynAny_insert_reference;}' unless defined(&DynamicAny_DynArray_insert_reference);
    eval 'sub DynamicAny_DynArray_insert_typecode () { &DynamicAny_DynAny_insert_typecode;}' unless defined(&DynamicAny_DynArray_insert_typecode);
    eval 'sub DynamicAny_DynArray_insert_longlong () {\'DynamicAny_DynAny_insert_longlong\';}' unless defined(&DynamicAny_DynArray_insert_longlong);
    eval 'sub DynamicAny_DynArray_insert_ulonglong () {\'DynamicAny_DynAny_insert_ulonglong\';}' unless defined(&DynamicAny_DynArray_insert_ulonglong);
    eval 'sub DynamicAny_DynArray_insert_longdouble () {\'DynamicAny_DynAny_insert_longdouble\';}' unless defined(&DynamicAny_DynArray_insert_longdouble);
    eval 'sub DynamicAny_DynArray_insert_wchar () { &DynamicAny_DynAny_insert_wchar;}' unless defined(&DynamicAny_DynArray_insert_wchar);
    eval 'sub DynamicAny_DynArray_insert_wstring () { &DynamicAny_DynAny_insert_wstring;}' unless defined(&DynamicAny_DynArray_insert_wstring);
    eval 'sub DynamicAny_DynArray_insert_any () { &DynamicAny_DynAny_insert_any;}' unless defined(&DynamicAny_DynArray_insert_any);
    eval 'sub DynamicAny_DynArray_get_boolean () { &DynamicAny_DynAny_get_boolean;}' unless defined(&DynamicAny_DynArray_get_boolean);
    eval 'sub DynamicAny_DynArray_get_octet () { &DynamicAny_DynAny_get_octet;}' unless defined(&DynamicAny_DynArray_get_octet);
    eval 'sub DynamicAny_DynArray_get_char () { &DynamicAny_DynAny_get_char;}' unless defined(&DynamicAny_DynArray_get_char);
    eval 'sub DynamicAny_DynArray_get_short () {\'DynamicAny_DynAny_get_short\';}' unless defined(&DynamicAny_DynArray_get_short);
    eval 'sub DynamicAny_DynArray_get_ushort () {\'DynamicAny_DynAny_get_ushort\';}' unless defined(&DynamicAny_DynArray_get_ushort);
    eval 'sub DynamicAny_DynArray_get_long () {\'DynamicAny_DynAny_get_long\';}' unless defined(&DynamicAny_DynArray_get_long);
    eval 'sub DynamicAny_DynArray_get_ulong () {\'DynamicAny_DynAny_get_ulong\';}' unless defined(&DynamicAny_DynArray_get_ulong);
    eval 'sub DynamicAny_DynArray_get_float () { &DynamicAny_DynAny_get_float;}' unless defined(&DynamicAny_DynArray_get_float);
    eval 'sub DynamicAny_DynArray_get_double () { &DynamicAny_DynAny_get_double;}' unless defined(&DynamicAny_DynArray_get_double);
    eval 'sub DynamicAny_DynArray_get_string () { &DynamicAny_DynAny_get_string;}' unless defined(&DynamicAny_DynArray_get_string);
    eval 'sub DynamicAny_DynArray_get_reference () { &DynamicAny_DynAny_get_reference;}' unless defined(&DynamicAny_DynArray_get_reference);
    eval 'sub DynamicAny_DynArray_get_typecode () { &DynamicAny_DynAny_get_typecode;}' unless defined(&DynamicAny_DynArray_get_typecode);
    eval 'sub DynamicAny_DynArray_get_longlong () {\'DynamicAny_DynAny_get_longlong\';}' unless defined(&DynamicAny_DynArray_get_longlong);
    eval 'sub DynamicAny_DynArray_get_ulonglong () {\'DynamicAny_DynAny_get_ulonglong\';}' unless defined(&DynamicAny_DynArray_get_ulonglong);
    eval 'sub DynamicAny_DynArray_get_longdouble () {\'DynamicAny_DynAny_get_longdouble\';}' unless defined(&DynamicAny_DynArray_get_longdouble);
    eval 'sub DynamicAny_DynArray_get_wchar () { &DynamicAny_DynAny_get_wchar;}' unless defined(&DynamicAny_DynArray_get_wchar);
    eval 'sub DynamicAny_DynArray_get_wstring () { &DynamicAny_DynAny_get_wstring;}' unless defined(&DynamicAny_DynArray_get_wstring);
    eval 'sub DynamicAny_DynArray_get_any () { &DynamicAny_DynAny_get_any;}' unless defined(&DynamicAny_DynArray_get_any);
    eval 'sub DynamicAny_DynArray_component_count () { &DynamicAny_DynAny_component_count;}' unless defined(&DynamicAny_DynArray_component_count);
    eval 'sub DynamicAny_DynArray_current_component () { &DynamicAny_DynAny_current_component;}' unless defined(&DynamicAny_DynArray_current_component);
    eval 'sub DynamicAny_DynArray_next () { &DynamicAny_DynAny_next;}' unless defined(&DynamicAny_DynArray_next);
    eval 'sub DynamicAny_DynArray_seek () { &DynamicAny_DynAny_seek;}' unless defined(&DynamicAny_DynArray_seek);
    eval 'sub DynamicAny_DynArray_rewind () { &DynamicAny_DynAny_rewind;}' unless defined(&DynamicAny_DynArray_rewind);
}
1;
