require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ORBIT_SERIAL)) {
    eval 'sub ORBIT_SERIAL () {9;}' unless defined(&ORBIT_SERIAL);
}
if(defined(&ORBIT_IDL_SERIAL)) {
    if((defined(&ORBIT_IDL_SERIAL) ? &ORBIT_IDL_SERIAL : 0) < 9) {
	die("You need to rerun 'orbit-idl' on the .idl file whose stubs you are using. These stubs were generated with an older version of ORBit, and need to be regenerated.");
    }
}
unless(defined(&_ORBIT_H_)) {
    eval 'sub _ORBIT_H_ () {1;}' unless defined(&_ORBIT_H_);
    if(defined(&__cplusplus)) {
    }
    require 'glib.ph';
    eval 'sub BACKWARDS_COMPAT_0_4 () {1;}' unless defined(&BACKWARDS_COMPAT_0_4);
    undef(&NOT_BACKWARDS_COMPAT_0_4) if defined(&NOT_BACKWARDS_COMPAT_0_4);
    require 'sys/types.ph';
    require 'sys/uio.ph';
    require 'IIOP/IIOP.ph';
    require 'ORBitutil/util.ph';
    require 'orb/orbit_config.ph';
    require 'orb/orbit_types.ph';
    require 'orb/allocators.ph';
    require 'orb/cdr.ph';
    require 'orb/dii.ph';
    require 'orb/dynany.ph';
    require 'orb/env.ph';
    require 'orb/iop.ph';
    require 'orb/ir.ph';
    require 'orb/options.ph';
    require 'orb/orb.ph';
    require 'orb/poa.ph';
    require 'orb/sequences.ph';
    require 'orb/orbit_typecode.ph';
    require 'orb/typecode.ph';
    unless(defined(&ORBIT_MAJOR_VERSION)) {
	eval 'sub ORBIT_MAJOR_VERSION () {(0);}' unless defined(&ORBIT_MAJOR_VERSION);
	eval 'sub ORBIT_MINOR_VERSION () {(5);}' unless defined(&ORBIT_MINOR_VERSION);
	eval 'sub ORBIT_MICRO_VERSION () {(17);}' unless defined(&ORBIT_MICRO_VERSION);
    }
    eval 'sub CORBA_any__alloc () { &CORBA_any_alloc;}' unless defined(&CORBA_any__alloc);
    eval 'sub CORBA_wstring_free () { &CORBA_string_free;}' unless defined(&CORBA_wstring_free);
    eval("sub ORBIT_MESSAGE_BAD () { 0; }") unless defined(&ORBIT_MESSAGE_BAD);
    eval("sub ORBIT_MESSAGE_ALLOW () { 1; }") unless defined(&ORBIT_MESSAGE_ALLOW);
    eval("sub ORBIT_MESSAGE_ALLOW_ALL () { 2; }") unless defined(&ORBIT_MESSAGE_ALLOW_ALL);
    if(defined(&__cplusplus)) {
    }
}
1;
