require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&LIBPQ_INT_H)) {
    eval 'sub LIBPQ_INT_H () {1;}' unless defined(&LIBPQ_INT_H);
    require 'time.ph';
    require 'sys/types.ph';
    unless(defined(&WIN32)) {
	require 'sys/time.ph';
    }
    if(defined( &WIN32)  && (!defined( &ssize_t))) {
    }
    require 'postgres_fe.ph';
    require 'libpq/pqcomm.ph';
    require 'lib/dllist.ph';
    require 'pqexpbuffer.ph';
    if(defined(&USE_SSL)) {
	require 'openssl/ssl.ph';
	require 'openssl/err.ph';
    }
    eval 'sub PG_PROTOCOL_LIBPQ () { &PG_PROTOCOL(2,0);}' unless defined(&PG_PROTOCOL_LIBPQ);
    eval 'sub PQERRORMSG_LENGTH () {1024;}' unless defined(&PQERRORMSG_LENGTH);
    eval 'sub CMDSTATUS_LEN () {40;}' unless defined(&CMDSTATUS_LEN);
    eval 'sub NULL_LEN () {(-1);}' unless defined(&NULL_LEN);
    eval("sub PGASYNC_IDLE () { 0; }") unless defined(&PGASYNC_IDLE);
    eval("sub PGASYNC_BUSY () { 1; }") unless defined(&PGASYNC_BUSY);
    eval("sub PGASYNC_READY () { 2; }") unless defined(&PGASYNC_READY);
    eval("sub PGASYNC_COPY_IN () { 3; }") unless defined(&PGASYNC_COPY_IN);
    eval("sub PGASYNC_COPY_OUT () { 4; }") unless defined(&PGASYNC_COPY_OUT);
    eval("sub SETENV_STATE_OPTION_SEND () { 0; }") unless defined(&SETENV_STATE_OPTION_SEND);
    eval("sub SETENV_STATE_OPTION_WAIT () { 1; }") unless defined(&SETENV_STATE_OPTION_WAIT);
    eval("sub SETENV_STATE_ENCODINGS_SEND () { 2; }") unless defined(&SETENV_STATE_ENCODINGS_SEND);
    eval("sub SETENV_STATE_ENCODINGS_WAIT () { 3; }") unless defined(&SETENV_STATE_ENCODINGS_WAIT);
    eval("sub SETENV_STATE_IDLE () { 4; }") unless defined(&SETENV_STATE_IDLE);
    if(defined(&USE_SSL)) {
    }
    eval 'sub BYTELEN () {8;}' unless defined(&BYTELEN);
    eval 'sub DefaultHost () {"localhost";}' unless defined(&DefaultHost);
    eval 'sub DefaultTty () {"";}' unless defined(&DefaultTty);
    eval 'sub DefaultOption () {"";}' unless defined(&DefaultOption);
    eval 'sub DefaultAuthtype () {"";}' unless defined(&DefaultAuthtype);
    eval 'sub DefaultPassword () {"";}' unless defined(&DefaultPassword);
    eval 'sub pqIsnonblocking {
        my($conn) = @_;
	    eval q((($conn)-> &nonblocking));
    }' unless defined(&pqIsnonblocking);
    if(defined(&ENABLE_NLS)) {
    } else {
	eval 'sub libpq_gettext {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&libpq_gettext);
    }
    if(defined(&WIN32)) {
	eval 'sub SOCK_ERRNO () {( &WSAGetLastError());}' unless defined(&SOCK_ERRNO);
	eval 'sub SOCK_STRERROR () { &winsock_strerror;}' unless defined(&SOCK_STRERROR);
    } else {
	eval 'sub SOCK_ERRNO () { &errno;}' unless defined(&SOCK_ERRNO);
	eval 'sub SOCK_STRERROR () { &strerror;}' unless defined(&SOCK_STRERROR);
    }
}
1;
