require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&GIST_H)) {
    eval 'sub GIST_H () {1;}' unless defined(&GIST_H);
    require 'access/itup.ph';
    require 'access/relscan.ph';
    require 'access/sdir.ph';
    require 'access/xlog.ph';
    eval 'sub GISTNStrategies () {100;}' unless defined(&GISTNStrategies);
    eval 'sub GIST_CONSISTENT_PROC () {1;}' unless defined(&GIST_CONSISTENT_PROC);
    eval 'sub GIST_UNION_PROC () {2;}' unless defined(&GIST_UNION_PROC);
    eval 'sub GIST_COMPRESS_PROC () {3;}' unless defined(&GIST_COMPRESS_PROC);
    eval 'sub GIST_DECOMPRESS_PROC () {4;}' unless defined(&GIST_DECOMPRESS_PROC);
    eval 'sub GIST_PENALTY_PROC () {5;}' unless defined(&GIST_PENALTY_PROC);
    eval 'sub GIST_PICKSPLIT_PROC () {6;}' unless defined(&GIST_PICKSPLIT_PROC);
    eval 'sub GIST_EQUAL_PROC () {7;}' unless defined(&GIST_EQUAL_PROC);
    eval 'sub GISTNProcs () {7;}' unless defined(&GISTNProcs);
    eval 'sub F_LEAF () {(1<< 0);}' unless defined(&F_LEAF);
    eval 'sub GIST_LEAF {
        my($entry) = @_;
	    eval q(((( &GISTPageOpaque)  &PageGetSpecialPointer(($entry)-> &page))-> &flags &  &F_LEAF));
    }' unless defined(&GIST_LEAF);
    eval 'sub isAttByVal {
        my( $gs, $anum ) = @_;
	    eval q(($gs)-> ($tupdesc->{attrs[$anum]}->{attbyval}));
    }' unless defined(&isAttByVal);
    eval 'sub GS_CURBEFORE () {(( &uint16) (1<< 0));}' unless defined(&GS_CURBEFORE);
    eval 'sub GS_MRKBEFORE () {(( &uint16) (1<< 1));}' unless defined(&GS_MRKBEFORE);
    eval 'sub GISTP_ROOT () {0;}' unless defined(&GISTP_ROOT);
    eval 'sub GISTOP_DEL () {0;}' unless defined(&GISTOP_DEL);
    eval 'sub GISTOP_SPLIT () {1;}' unless defined(&GISTOP_SPLIT);
    eval 'sub gistentryinit {
        my($e, $k, $r, $pg, $o, $b, $l) = @_;
	    eval q( &do { ($e). &key = ($k); ($e). &rel = ($r); ($e). &page = ($pg); ($e). &offset = ($o); ($e). &bytes = ($b); ($e). &leafkey = ($l); }  &while (0));
    }' unless defined(&gistentryinit);
}
1;
