require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ISTRAT_H)) {
    eval 'sub ISTRAT_H () {1;}' unless defined(&ISTRAT_H);
    require 'utils/rel.ph';
    eval 'sub StrategyNumberIsValid {
        my($strategyNumber) = @_;
	    eval q((( &bool) (($strategyNumber) !=  &InvalidStrategy)));
    }' unless defined(&StrategyNumberIsValid);
    eval 'sub StrategyNumberIsInBounds {
        my($strategyNumber, $maxStrategyNumber) = @_;
	    eval q((( &bool)( &InvalidStrategy < ($strategyNumber)  && ($strategyNumber) <= ($maxStrategyNumber))));
    }' unless defined(&StrategyNumberIsInBounds);
    eval 'sub StrategyMapIsValid {
        my($map) = @_;
	    eval q( &PointerIsValid($map));
    }' unless defined(&StrategyMapIsValid);
    eval 'sub IndexStrategyIsValid {
        my($s) = @_;
	    eval q( &PointerIsValid($s));
    }' unless defined(&IndexStrategyIsValid);
}
1;
