require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ITUP_H)) {
    eval 'sub ITUP_H () {1;}' unless defined(&ITUP_H);
    require 'access/ibit.ph';
    require 'access/tupdesc.ph';
    require 'access/tupmacs.ph';
    require 'storage/itemptr.ph';
    eval 'sub INDEX_SIZE_MASK () {0x1fff;}' unless defined(&INDEX_SIZE_MASK);
    eval 'sub INDEX_NULL_MASK () {0x8000;}' unless defined(&INDEX_NULL_MASK);
    eval 'sub INDEX_VAR_MASK () {0x4000;}' unless defined(&INDEX_VAR_MASK);
    eval 'sub IndexTupleSize {
        my($itup) = @_;
	    eval q((( &Size) ((( &IndexTuple) ($itup))-> &t_info &  &INDEX_SIZE_MASK)));
    }' unless defined(&IndexTupleSize);
    eval 'sub IndexTupleDSize {
        my($itup) = @_;
	    eval q((( &Size) (($itup). &t_info &  &INDEX_SIZE_MASK)));
    }' unless defined(&IndexTupleDSize);
    eval 'sub IndexTupleHasNulls {
        my($itup) = @_;
	    eval q((((( &IndexTuple) ($itup))-> &t_info &  &INDEX_NULL_MASK)));
    }' unless defined(&IndexTupleHasNulls);
    eval 'sub IndexTupleHasVarwidths {
        my($itup) = @_;
	    eval q((((( &IndexTuple) ($itup))-> &t_info &  &INDEX_VAR_MASK)));
    }' unless defined(&IndexTupleHasVarwidths);
    eval 'sub IndexTupleHasMinHeader {
        my($itup) = @_;
	    eval q((! &IndexTupleHasNulls($itup)));
    }' unless defined(&IndexTupleHasMinHeader);
    eval 'sub IndexInfoFindDataOffset {
        my($t_info) = @_;
	    eval q(( (!(($t_info) &  &INDEX_NULL_MASK)) ? ( ( &Size)$sizeof{ &IndexTupleData} ) : ( ( &Size) &MAXALIGN($sizeof{ &IndexTupleData} + $sizeof{ &IndexAttributeBitMapData}) ) ));
    }' unless defined(&IndexInfoFindDataOffset);
    eval 'sub index_getattr {
        my($tup, $attnum, $tupleDesc, $isnull) = @_;
	    eval q((  &AssertMacro( &PointerIsValid  && > 0), * =  &false, ! &IndexTupleHasNulls ? ( -> ($attrs[-1]->{attcacheoff}) >= 0? (  &fetchatt(-> $attrs[-1], + (  &IndexTupleHasMinHeader ? $sizeof{} :  &IndexInfoFindDataOffset(-> &t_info) ) + -> ($attrs[-1]->{attcacheoff})) ) :  &nocache_index_getattr(, , , ) ) : ( ( &att_isnull(-1, ($tup) + $sizeof{($tup)})) ? ( *($isnull) =  &true, ( &Datum) &NULL ) : (  &nocache_index_getattr(($tup), ($attnum), ($tupleDesc), ($isnull)) ) ) ));
    }' unless defined(&index_getattr);
}
1;
