require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&RTREE_H)) {
    eval 'sub RTREE_H () {1;}' unless defined(&RTREE_H);
    require 'access/itup.ph';
    require 'access/sdir.ph';
    require 'access/skey.ph';
    require 'access/xlog.ph';
    require 'utils/rel.ph';
    eval 'sub RTNStrategies () {8;}' unless defined(&RTNStrategies);
    eval 'sub RTLeftStrategyNumber () {1;}' unless defined(&RTLeftStrategyNumber);
    eval 'sub RTOverLeftStrategyNumber () {2;}' unless defined(&RTOverLeftStrategyNumber);
    eval 'sub RTOverlapStrategyNumber () {3;}' unless defined(&RTOverlapStrategyNumber);
    eval 'sub RTOverRightStrategyNumber () {4;}' unless defined(&RTOverRightStrategyNumber);
    eval 'sub RTRightStrategyNumber () {5;}' unless defined(&RTRightStrategyNumber);
    eval 'sub RTSameStrategyNumber () {6;}' unless defined(&RTSameStrategyNumber);
    eval 'sub RTContainsStrategyNumber () {7;}' unless defined(&RTContainsStrategyNumber);
    eval 'sub RTContainedByStrategyNumber () {8;}' unless defined(&RTContainedByStrategyNumber);
    eval 'sub RTNProcs () {3;}' unless defined(&RTNProcs);
    eval 'sub RT_UNION_PROC () {1;}' unless defined(&RT_UNION_PROC);
    eval 'sub RT_INTER_PROC () {2;}' unless defined(&RT_INTER_PROC);
    eval 'sub RT_SIZE_PROC () {3;}' unless defined(&RT_SIZE_PROC);
    eval 'sub F_LEAF () {(1<< 0);}' unless defined(&F_LEAF);
    eval 'sub RTS_CURBEFORE () {(( &uint16) (1<< 0));}' unless defined(&RTS_CURBEFORE);
    eval 'sub RTS_MRKBEFORE () {(( &uint16) (1<< 1));}' unless defined(&RTS_MRKBEFORE);
    eval 'sub P_ROOT () {0;}' unless defined(&P_ROOT);
    eval 'sub RTOP_DEL () {0;}' unless defined(&RTOP_DEL);
    eval 'sub RTOP_SPLIT () {1;}' unless defined(&RTOP_SPLIT);
}
1;
