require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&TRANSAM_H)) {
    eval 'sub TRANSAM_H () {1;}' unless defined(&TRANSAM_H);
    eval 'sub InvalidTransactionId () {(( &TransactionId) 0);}' unless defined(&InvalidTransactionId);
    eval 'sub BootstrapTransactionId () {(( &TransactionId) 1);}' unless defined(&BootstrapTransactionId);
    eval 'sub FrozenTransactionId () {(( &TransactionId) 2);}' unless defined(&FrozenTransactionId);
    eval 'sub FirstNormalTransactionId () {(( &TransactionId) 3);}' unless defined(&FirstNormalTransactionId);
    eval 'sub MaxTransactionId () {(( &TransactionId) 0xffffffff);}' unless defined(&MaxTransactionId);
    eval 'sub TransactionIdIsValid {
        my($xid) = @_;
	    eval q((($xid) !=  &InvalidTransactionId));
    }' unless defined(&TransactionIdIsValid);
    eval 'sub TransactionIdIsNormal {
        my($xid) = @_;
	    eval q((($xid) >=  &FirstNormalTransactionId));
    }' unless defined(&TransactionIdIsNormal);
    eval 'sub TransactionIdEquals {
        my($id1, $id2) = @_;
	    eval q((($id1) == ($id2)));
    }' unless defined(&TransactionIdEquals);
    eval 'sub TransactionIdStore {
        my($xid, $dest) = @_;
	    eval q((*($dest) = ($xid)));
    }' unless defined(&TransactionIdStore);
    eval 'sub StoreInvalidTransactionId {
        my($dest) = @_;
	    eval q((*($dest) =  &InvalidTransactionId));
    }' unless defined(&StoreInvalidTransactionId);
    eval 'sub TransactionIdAdvance {
        my($dest) = @_;
	    eval q( &do { ($dest)++;  &if (($dest) <  &FirstNormalTransactionId) ($dest) =  &FirstNormalTransactionId; }  &while(0));
    }' unless defined(&TransactionIdAdvance);
    eval 'sub FirstGenBKIObjectId () {10000;}' unless defined(&FirstGenBKIObjectId);
    eval 'sub BootstrapObjectIdData () {16384;}' unless defined(&BootstrapObjectIdData);
}
1;
