require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&TUPMACS_H)) {
    eval 'sub TUPMACS_H () {1;}' unless defined(&TUPMACS_H);
    require 'utils/memutils.ph';
    eval 'sub att_isnull {
        my($ATT, $BITS) = @_;
	    eval q((!(($BITS)[($ATT) >> 3] & (1<< (($ATT) & 0x7)))));
    }' unless defined(&att_isnull);
    eval 'sub fetchatt {
        my($A,$T) = @_;
	    eval q( &fetch_att($T, ($A)-> &attbyval, ($A)-> &attlen));
    }' unless defined(&fetchatt);
    if((defined(&SIZEOF_DATUM) ? &SIZEOF_DATUM : 0) == 8) {
	eval 'sub fetch_att {
	    my($T,$attbyval,$attlen) = @_;
    	    eval q(( ? ( == $sizeof{ &Datum} ? *(( &Datum *)) : ( == $sizeof{ &int32} ?  &Int32GetDatum(*(( &int32 *))) : ( == $sizeof{ &int16} ?  &Int16GetDatum(*(( &int16 *))) : (  &AssertMacro( == 1),  &CharGetDatum(*()) ) ) ) ) :  &PointerGetDatum( ($T)) ));
	}' unless defined(&fetch_att);
    } else {
	eval 'sub fetch_att {
	    my($T,$attbyval,$attlen) = @_;
    	    eval q(( ? ( == $sizeof{ &int32} ?  &Int32GetDatum(*(( &int32 *))) : ( == $sizeof{ &int16} ?  &Int16GetDatum(*(( &int16 *))) : (  &AssertMacro( == 1),  &CharGetDatum(*()) ) ) ) :  &PointerGetDatum( ($T)) ));
	}' unless defined(&fetch_att);
    }
    eval 'sub att_align {
        my($cur_offset, $attalign) = @_;
	    eval q(( ( == ord(\'i\') ? INTALIGN : 	 (( == \'c\') ? ((cur_offset)) : 	  (((attalign) == \'d\') ? DOUBLEALIGN(cur_offset) : 		( 			AssertMacro((attalign) == \'s\')),  &SHORTALIGN($cur_offset) ))) ));
    }' unless defined(&att_align);
    eval 'sub att_addlength {
        my($cur_offset, $attlen, $attval) = @_;
	    eval q(( (($attlen) > 0) ? ( ($cur_offset) + ($attlen) ) : ((($attlen) == -1) ? ( ($cur_offset) +  &VARATT_SIZE( &DatumGetPointer($attval)) ) : (  &AssertMacro(($attlen) == -2), ($cur_offset) + ( &strlen( &DatumGetCString($attval)) + 1) )) ));
    }' unless defined(&att_addlength);
    if((defined(&SIZEOF_DATUM) ? &SIZEOF_DATUM : 0) == 8) {
	eval 'sub store_att_byval {
	    my($T,$newdatum,$attlen) = @_;
    	    eval q( &do {  &switch {  &case  &sizeof: * ($T) =  &DatumGetChar($newdatum);  &break;  &case $sizeof{ &int16}: *( &int16 *) ($T) =  &DatumGetInt16($newdatum);  &break;  &case $sizeof{ &int32}: *( &int32 *) ($T) =  &DatumGetInt32($newdatum);  &break;  &case $sizeof{ &Datum}: *( &Datum *) = ;  &break;  &default:  &elog( &ERROR, \\"store_att_byval: unsupported byval length %d\\", ($attlen));  &break; } }  &while (0));
	}' unless defined(&store_att_byval);
    } else {
	eval 'sub store_att_byval {
	    my($T,$newdatum,$attlen) = @_;
    	    eval q( &do {  &switch {  &case  &sizeof: * ($T) =  &DatumGetChar($newdatum);  &break;  &case $sizeof{ &int16}: *( &int16 *) ($T) =  &DatumGetInt16($newdatum);  &break;  &case $sizeof{ &int32}: *( &int32 *) =  &DatumGetInt32;  &break;  &default:  &elog( &ERROR, \\"store_att_byval: unsupported byval length %d\\", ($attlen));  &break; } }  &while (0));
	}' unless defined(&store_att_byval);
    }
}
1;
