require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&XLOG_H)) {
    eval 'sub XLOG_H () {1;}' unless defined(&XLOG_H);
    require 'access/rmgr.ph';
    require 'access/transam.ph';
    require 'access/xlogdefs.ph';
    require 'storage/bufmgr.ph';
    require 'utils/pg_crc.ph';
    eval 'sub SizeOfXLogRecord () { &MAXALIGN($sizeof{ &XLogRecord});}' unless defined(&SizeOfXLogRecord);
    eval 'sub MAXLOGRECSZ () {65535;}' unless defined(&MAXLOGRECSZ);
    eval 'sub XLogRecGetData {
        my($record) = @_;
	    eval q(( ($record) +  &SizeOfXLogRecord));
    }' unless defined(&XLogRecGetData);
    eval 'sub XLR_INFO_MASK () {0xf;}' unless defined(&XLR_INFO_MASK);
    eval 'sub XLR_BKP_BLOCK_MASK () {0xc;}' unless defined(&XLR_BKP_BLOCK_MASK);
    eval 'sub XLR_MAX_BKP_BLOCKS () {2;}' unless defined(&XLR_MAX_BKP_BLOCKS);
    eval 'sub XLR_SET_BKP_BLOCK {
        my($iblk) = @_;
	    eval q((0x8 >> ($iblk)));
    }' unless defined(&XLR_SET_BKP_BLOCK);
    eval 'sub XLR_BKP_BLOCK_1 () { &XLR_SET_BKP_BLOCK(0);}' unless defined(&XLR_BKP_BLOCK_1);
    eval 'sub XLR_BKP_BLOCK_2 () { &XLR_SET_BKP_BLOCK(1);}' unless defined(&XLR_BKP_BLOCK_2);
    eval 'sub XLOG_NO_TRAN () { &XLR_INFO_MASK;}' unless defined(&XLOG_NO_TRAN);
    eval 'sub SizeOfXLogContRecord () { &MAXALIGN($sizeof{ &XLogContRecord});}' unless defined(&SizeOfXLogContRecord);
    eval 'sub XLOG_PAGE_MAGIC () {0xd05a;}' unless defined(&XLOG_PAGE_MAGIC);
    eval 'sub SizeOfXLogPHD () { &MAXALIGN($sizeof{ &XLogPageHeaderData});}' unless defined(&SizeOfXLogPHD);
    eval 'sub XLP_FIRST_IS_CONTRECORD () {0x1;}' unless defined(&XLP_FIRST_IS_CONTRECORD);
    eval 'sub XLP_ALL_FLAGS () {0x1;}' unless defined(&XLP_ALL_FLAGS);
    eval 'sub XLogSegSize () {(( &uint32) (16*1024*1024));}' unless defined(&XLogSegSize);
    eval 'sub XLogSegsPerFile () {((( &uint32) 0xffffffff) /  &XLogSegSize);}' unless defined(&XLogSegsPerFile);
    eval 'sub XLogFileSize () {( &XLogSegsPerFile *  &XLogSegSize);}' unless defined(&XLogFileSize);
}
1;
