require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&TRIGGER_H)) {
    eval 'sub TRIGGER_H () {1;}' unless defined(&TRIGGER_H);
    require 'nodes/execnodes.ph';
    require 'nodes/parsenodes.ph';
    eval 'sub CALLED_AS_TRIGGER {
        my($fcinfo) = @_;
	    eval q((($fcinfo)-> &context !=  &NULL  &&  &IsA(($fcinfo)-> &context,  &TriggerData)));
    }' unless defined(&CALLED_AS_TRIGGER);
    eval 'sub TRIGGER_EVENT_INSERT () {0x;}' unless defined(&TRIGGER_EVENT_INSERT);
    eval 'sub TRIGGER_EVENT_DELETE () {0x1;}' unless defined(&TRIGGER_EVENT_DELETE);
    eval 'sub TRIGGER_EVENT_UPDATE () {0x2;}' unless defined(&TRIGGER_EVENT_UPDATE);
    eval 'sub TRIGGER_EVENT_OPMASK () {0x3;}' unless defined(&TRIGGER_EVENT_OPMASK);
    eval 'sub TRIGGER_EVENT_ROW () {0x4;}' unless defined(&TRIGGER_EVENT_ROW);
    eval 'sub TRIGGER_EVENT_BEFORE () {0x8;}' unless defined(&TRIGGER_EVENT_BEFORE);
    eval 'sub TRIGGER_DEFERRED_DONE () {0x10;}' unless defined(&TRIGGER_DEFERRED_DONE);
    eval 'sub TRIGGER_DEFERRED_CANCELED () {0x20;}' unless defined(&TRIGGER_DEFERRED_CANCELED);
    eval 'sub TRIGGER_DEFERRED_DEFERRABLE () {0x40;}' unless defined(&TRIGGER_DEFERRED_DEFERRABLE);
    eval 'sub TRIGGER_DEFERRED_INITDEFERRED () {0x80;}' unless defined(&TRIGGER_DEFERRED_INITDEFERRED);
    eval 'sub TRIGGER_DEFERRED_HAS_BEFORE () {0x100;}' unless defined(&TRIGGER_DEFERRED_HAS_BEFORE);
    eval 'sub TRIGGER_FIRED_BY_INSERT {
        my($event) = @_;
	    eval q(((( &TriggerEvent) ($event) &  &TRIGGER_EVENT_OPMASK) ==  &TRIGGER_EVENT_INSERT));
    }' unless defined(&TRIGGER_FIRED_BY_INSERT);
    eval 'sub TRIGGER_FIRED_BY_DELETE {
        my($event) = @_;
	    eval q(((( &TriggerEvent) ($event) &  &TRIGGER_EVENT_OPMASK) ==  &TRIGGER_EVENT_DELETE));
    }' unless defined(&TRIGGER_FIRED_BY_DELETE);
    eval 'sub TRIGGER_FIRED_BY_UPDATE {
        my($event) = @_;
	    eval q(((( &TriggerEvent) ($event) &  &TRIGGER_EVENT_OPMASK) ==  &TRIGGER_EVENT_UPDATE));
    }' unless defined(&TRIGGER_FIRED_BY_UPDATE);
    eval 'sub TRIGGER_FIRED_FOR_ROW {
        my($event) = @_;
	    eval q((( &TriggerEvent) ($event) &  &TRIGGER_EVENT_ROW));
    }' unless defined(&TRIGGER_FIRED_FOR_ROW);
    eval 'sub TRIGGER_FIRED_FOR_STATEMENT {
        my($event) = @_;
	    eval q((! &TRIGGER_FIRED_FOR_ROW ($event)));
    }' unless defined(&TRIGGER_FIRED_FOR_STATEMENT);
    eval 'sub TRIGGER_FIRED_BEFORE {
        my($event) = @_;
	    eval q((( &TriggerEvent) ($event) &  &TRIGGER_EVENT_BEFORE));
    }' unless defined(&TRIGGER_FIRED_BEFORE);
    eval 'sub TRIGGER_FIRED_AFTER {
        my($event) = @_;
	    eval q((! &TRIGGER_FIRED_BEFORE ($event)));
    }' unless defined(&TRIGGER_FIRED_AFTER);
    eval 'sub RI_CONSTRAINT_NAME_ARGNO () {0;}' unless defined(&RI_CONSTRAINT_NAME_ARGNO);
    eval 'sub RI_FK_RELNAME_ARGNO () {1;}' unless defined(&RI_FK_RELNAME_ARGNO);
    eval 'sub RI_PK_RELNAME_ARGNO () {2;}' unless defined(&RI_PK_RELNAME_ARGNO);
    eval 'sub RI_MATCH_TYPE_ARGNO () {3;}' unless defined(&RI_MATCH_TYPE_ARGNO);
    eval 'sub RI_FIRST_ATTNAME_ARGNO () {4;}' unless defined(&RI_FIRST_ATTNAME_ARGNO);
    eval 'sub RI_KEYPAIR_FK_IDX () {0;}' unless defined(&RI_KEYPAIR_FK_IDX);
    eval 'sub RI_KEYPAIR_PK_IDX () {1;}' unless defined(&RI_KEYPAIR_PK_IDX);
    eval 'sub RI_MAX_NUMKEYS () { &INDEX_MAX_KEYS;}' unless defined(&RI_MAX_NUMKEYS);
    eval 'sub RI_MAX_ARGUMENTS () {( &RI_FIRST_ATTNAME_ARGNO + ( &RI_MAX_NUMKEYS * 2));}' unless defined(&RI_MAX_ARGUMENTS);
}
1;
