require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SPI_H)) {
    eval 'sub SPI_H () {1;}' unless defined(&SPI_H);
    require 'postgres.ph';
    require 'nodes/primnodes.ph';
    require 'nodes/relation.ph';
    require 'nodes/execnodes.ph';
    require 'nodes/plannodes.ph';
    require 'catalog/pg_proc.ph';
    require 'catalog/pg_type.ph';
    require 'tcop/pquery.ph';
    require 'tcop/tcopprot.ph';
    require 'tcop/utility.ph';
    require 'tcop/dest.ph';
    require 'nodes/params.ph';
    require 'utils/fcache.ph';
    require 'utils/datum.ph';
    require 'utils/syscache.ph';
    require 'utils/builtins.ph';
    require 'catalog/pg_language.ph';
    require 'access/heapam.ph';
    require 'access/xact.ph';
    require 'executor/executor.ph';
    require 'executor/execdefs.ph';
    eval 'sub SPI_ERROR_CONNECT () {(-1);}' unless defined(&SPI_ERROR_CONNECT);
    eval 'sub SPI_ERROR_COPY () {(-2);}' unless defined(&SPI_ERROR_COPY);
    eval 'sub SPI_ERROR_OPUNKNOWN () {(-3);}' unless defined(&SPI_ERROR_OPUNKNOWN);
    eval 'sub SPI_ERROR_UNCONNECTED () {(-4);}' unless defined(&SPI_ERROR_UNCONNECTED);
    eval 'sub SPI_ERROR_CURSOR () {(-5);}' unless defined(&SPI_ERROR_CURSOR);
    eval 'sub SPI_ERROR_ARGUMENT () {(-6);}' unless defined(&SPI_ERROR_ARGUMENT);
    eval 'sub SPI_ERROR_PARAM () {(-7);}' unless defined(&SPI_ERROR_PARAM);
    eval 'sub SPI_ERROR_TRANSACTION () {(-8);}' unless defined(&SPI_ERROR_TRANSACTION);
    eval 'sub SPI_ERROR_NOATTRIBUTE () {(-9);}' unless defined(&SPI_ERROR_NOATTRIBUTE);
    eval 'sub SPI_ERROR_NOOUTFUNC () {(-10);}' unless defined(&SPI_ERROR_NOOUTFUNC);
    eval 'sub SPI_ERROR_TYPUNKNOWN () {(-11);}' unless defined(&SPI_ERROR_TYPUNKNOWN);
    eval 'sub SPI_OK_CONNECT () {1;}' unless defined(&SPI_OK_CONNECT);
    eval 'sub SPI_OK_FINISH () {2;}' unless defined(&SPI_OK_FINISH);
    eval 'sub SPI_OK_FETCH () {3;}' unless defined(&SPI_OK_FETCH);
    eval 'sub SPI_OK_UTILITY () {4;}' unless defined(&SPI_OK_UTILITY);
    eval 'sub SPI_OK_SELECT () {5;}' unless defined(&SPI_OK_SELECT);
    eval 'sub SPI_OK_SELINTO () {6;}' unless defined(&SPI_OK_SELINTO);
    eval 'sub SPI_OK_INSERT () {7;}' unless defined(&SPI_OK_INSERT);
    eval 'sub SPI_OK_DELETE () {8;}' unless defined(&SPI_OK_DELETE);
    eval 'sub SPI_OK_UPDATE () {9;}' unless defined(&SPI_OK_UPDATE);
    eval 'sub SPI_OK_CURSOR () {10;}' unless defined(&SPI_OK_CURSOR);
}
1;
