require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&FUNCAPI_H)) {
    eval 'sub FUNCAPI_H () {1;}' unless defined(&FUNCAPI_H);
    require 'fmgr.ph';
    require 'access/tupdesc.ph';
    require 'executor/executor.ph';
    require 'executor/tuptable.ph';
    eval 'sub TupleGetDatum {
        my($_slot, $_tuple) = @_;
	    eval q( &PointerGetDatum( &ExecStoreTuple($_tuple, $_slot,  &InvalidBuffer,  &false)));
    }' unless defined(&TupleGetDatum);
    eval 'sub SRF_IS_FIRSTCALL () {
        eval q(( ($fcinfo->{flinfo}->{fn_extra}) ==  &NULL));
    }' unless defined(&SRF_IS_FIRSTCALL);
    eval 'sub SRF_FIRSTCALL_INIT () {
        eval q( &init_MultiFuncCall( &fcinfo));
    }' unless defined(&SRF_FIRSTCALL_INIT);
    eval 'sub SRF_PERCALL_SETUP () {
        eval q( &per_MultiFuncCall( &fcinfo));
    }' unless defined(&SRF_PERCALL_SETUP);
    eval 'sub SRF_RETURN_NEXT {
        my($_funcctx, $_result) = @_;
	    eval q( &do {  &ReturnSetInfo * &rsi; ($_funcctx)-> &call_cntr++;  &rsi = ( &ReturnSetInfo *)  ($fcinfo->{resultinfo});  ($rsi->{isDone}) =  &ExprMultipleResult;  &PG_RETURN_DATUM($_result); }  &while (0));
    }' unless defined(&SRF_RETURN_NEXT);
    eval 'sub SRF_RETURN_DONE {
        my($_funcctx) = @_;
	    eval q( &do {  &ReturnSetInfo * &rsi;  &end_MultiFuncCall( &fcinfo, $_funcctx);  &rsi = ( &ReturnSetInfo *)  ($fcinfo->{resultinfo});  ($rsi->{isDone}) =  &ExprEndResult;  &PG_RETURN_NULL(); }  &while (0));
    }' unless defined(&SRF_RETURN_DONE);
}
1;
