require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PG_LIST_H)) {
    eval 'sub PG_LIST_H () {1;}' unless defined(&PG_LIST_H);
    require 'nodes/nodes.ph';
    eval 'sub intVal {
        my($v) = @_;
	    eval q(((( &Value *)($v))-> ($val->{i$val})));
    }' unless defined(&intVal);
    eval 'sub floatVal {
        my($v) = @_;
	    eval q( &atof((( &Value *)($v))-> ($val->{str})));
    }' unless defined(&floatVal);
    eval 'sub strVal {
        my($v) = @_;
	    eval q(((( &Value *)($v))-> ($val->{str})));
    }' unless defined(&strVal);
    eval 'sub NIL () {(( &List *)  &NULL);}' unless defined(&NIL);
    eval 'sub lfirst {
        my($l) = @_;
	    eval q((($l)-> ($e$lem->{ptr_value})));
    }' unless defined(&lfirst);
    eval 'sub lnext {
        my($l) = @_;
	    eval q((($l)-> &next));
    }' unless defined(&lnext);
    eval 'sub lsecond {
        my($l) = @_;
	    eval q( &lfirst( &lnext($l)));
    }' unless defined(&lsecond);
    eval 'sub lfirsti {
        my($l) = @_;
	    eval q((($l)-> ($e$lem->{int_value})));
    }' unless defined(&lfirsti);
    eval 'sub foreach {
        my($_elt_,$_list_) = @_;
	    eval q( &for($_elt_=($_list_); $_elt_!= &NIL; $_elt_= &lnext($_elt_)));
    }' unless defined(&foreach);
    eval 'sub makeList1 {
        my($x1) = @_;
	    eval q( &lcons($x1,  &NIL));
    }' unless defined(&makeList1);
    eval 'sub makeList2 {
        my($x1,$x2) = @_;
	    eval q( &lcons($x1,  &makeList1($x2)));
    }' unless defined(&makeList2);
    eval 'sub makeList3 {
        my($x1,$x2,$x3) = @_;
	    eval q( &lcons($x1,  &makeList2($x2,$x3)));
    }' unless defined(&makeList3);
    eval 'sub makeList4 {
        my($x1,$x2,$x3,$x4) = @_;
	    eval q( &lcons($x1,  &makeList3($x2,$x3,$x4)));
    }' unless defined(&makeList4);
    eval 'sub makeListi1 {
        my($x1) = @_;
	    eval q( &lconsi($x1,  &NIL));
    }' unless defined(&makeListi1);
    eval 'sub makeListi2 {
        my($x1,$x2) = @_;
	    eval q( &lconsi($x1,  &makeListi1($x2)));
    }' unless defined(&makeListi2);
    eval 'sub makeListi3 {
        my($x1,$x2,$x3) = @_;
	    eval q( &lconsi($x1,  &makeListi2($x2,$x3)));
    }' unless defined(&makeListi3);
    eval 'sub makeListi4 {
        my($x1,$x2,$x3,$x4) = @_;
	    eval q( &lconsi($x1,  &makeListi3($x2,$x3,$x4)));
    }' unless defined(&makeListi4);
}
1;
