require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PGSTAT_H)) {
    eval 'sub PGSTAT_H () {1;}' unless defined(&PGSTAT_H);
    eval 'sub PGSTAT_STAT_FILENAME () {"%s/global/pgstat.stat";}' unless defined(&PGSTAT_STAT_FILENAME);
    eval 'sub PGSTAT_STAT_TMPFILE () {"%s/global/pgstat.tmp.%d";}' unless defined(&PGSTAT_STAT_TMPFILE);
    eval 'sub PGSTAT_STAT_INTERVAL () {500;}' unless defined(&PGSTAT_STAT_INTERVAL);
    eval 'sub PGSTAT_DESTROY_DELAY () {10000;}' unless defined(&PGSTAT_DESTROY_DELAY);
    eval 'sub PGSTAT_DESTROY_COUNT () {( &PGSTAT_DESTROY_DELAY /  &PGSTAT_STAT_INTERVAL);}' unless defined(&PGSTAT_DESTROY_COUNT);
    eval 'sub PGSTAT_ACTIVITY_SIZE () {256;}' unless defined(&PGSTAT_ACTIVITY_SIZE);
    eval 'sub PGSTAT_MTYPE_DUMMY () {0;}' unless defined(&PGSTAT_MTYPE_DUMMY);
    eval 'sub PGSTAT_MTYPE_BESTART () {1;}' unless defined(&PGSTAT_MTYPE_BESTART);
    eval 'sub PGSTAT_MTYPE_BETERM () {2;}' unless defined(&PGSTAT_MTYPE_BETERM);
    eval 'sub PGSTAT_MTYPE_ACTIVITY () {3;}' unless defined(&PGSTAT_MTYPE_ACTIVITY);
    eval 'sub PGSTAT_MTYPE_TABSTAT () {4;}' unless defined(&PGSTAT_MTYPE_TABSTAT);
    eval 'sub PGSTAT_MTYPE_TABPURGE () {5;}' unless defined(&PGSTAT_MTYPE_TABPURGE);
    eval 'sub PGSTAT_MTYPE_DROPDB () {6;}' unless defined(&PGSTAT_MTYPE_DROPDB);
    eval 'sub PGSTAT_MTYPE_RESETCOUNTER () {7;}' unless defined(&PGSTAT_MTYPE_RESETCOUNTER);
    eval 'sub PGSTAT_RECVBUFFERSZ () {( (1024* $sizeof{ &PgStat_Msg}));}' unless defined(&PGSTAT_RECVBUFFERSZ);
    eval 'sub PGSTAT_DB_HASH_SIZE () {16;}' unless defined(&PGSTAT_DB_HASH_SIZE);
    eval 'sub PGSTAT_BE_HASH_SIZE () {512;}' unless defined(&PGSTAT_BE_HASH_SIZE);
    eval 'sub PGSTAT_TAB_HASH_SIZE () {512;}' unless defined(&PGSTAT_TAB_HASH_SIZE);
    eval 'sub PGSTAT_NUM_TABENTRIES () {((1000- $sizeof{ &PgStat_MsgHdr}) / $sizeof{ &PgStat_TableEntry});}' unless defined(&PGSTAT_NUM_TABENTRIES);
    eval 'sub PGSTAT_NUM_TABPURGE () {((1000- $sizeof{ &PgStat_MsgHdr}) / $sizeof{ &PgStat_TableEntry});}' unless defined(&PGSTAT_NUM_TABPURGE);
    eval 'sub pgstat_reset_heap_scan {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL) ($s)-> &heap_scan_counted =  &FALSE; }  &while (0));
    }' unless defined(&pgstat_reset_heap_scan);
    eval 'sub pgstat_count_heap_scan {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL  && !($s)-> &heap_scan_counted) { (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_numscans++; ($s)-> &heap_scan_counted =  &TRUE; } }  &while (0));
    }' unless defined(&pgstat_count_heap_scan);
    eval 'sub pgstat_count_heap_getnext {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_tuples_returned++; }  &while (0));
    }' unless defined(&pgstat_count_heap_getnext);
    eval 'sub pgstat_count_heap_fetch {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_tuples_fetched++; }  &while (0));
    }' unless defined(&pgstat_count_heap_fetch);
    eval 'sub pgstat_count_heap_insert {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_tuples_inserted++; }  &while (0));
    }' unless defined(&pgstat_count_heap_insert);
    eval 'sub pgstat_count_heap_update {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_tuples_updated++; }  &while (0));
    }' unless defined(&pgstat_count_heap_update);
    eval 'sub pgstat_count_heap_delete {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_tuples_deleted++; }  &while (0));
    }' unless defined(&pgstat_count_heap_delete);
    eval 'sub pgstat_reset_index_scan {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL) ($s)-> &index_scan_counted =  &FALSE; }  &while (0));
    }' unless defined(&pgstat_reset_index_scan);
    eval 'sub pgstat_count_index_scan {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL  && !($s)-> &index_scan_counted) { (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_numscans++; ($s)-> &index_scan_counted =  &TRUE; } }  &while (0));
    }' unless defined(&pgstat_count_index_scan);
    eval 'sub pgstat_count_index_getnext {
        my($s) = @_;
	    eval q( &do {  &if ( &pgstat_collect_tuplelevel  && ($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_tuples_returned++; }  &while (0));
    }' unless defined(&pgstat_count_index_getnext);
    eval 'sub pgstat_count_buffer_read {
        my($s,$r) = @_;
	    eval q( &do {  &if ( &pgstat_collect_blocklevel  && ($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_blocks_fetched++;  &else {  &if ( &pgstat_collect_blocklevel  && !($s)-> &no_stats) {  &pgstat_initstats(($s), ($r));  &if (($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_blocks_fetched++; } } }  &while (0));
    }' unless defined(&pgstat_count_buffer_read);
    eval 'sub pgstat_count_buffer_hit {
        my($s,$r) = @_;
	    eval q( &do {  &if ( &pgstat_collect_blocklevel  && ($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_blocks_hit++;  &else {  &if ( &pgstat_collect_blocklevel  && !($s)-> &no_stats) {  &pgstat_initstats(($s), ($r));  &if (($s)-> &tabentry !=  &NULL) (( &PgStat_TableEntry *)(($s)-> &tabentry))-> &t_blocks_hit++; } } }  &while (0));
    }' unless defined(&pgstat_count_buffer_hit);
}
1;
