require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&HAS_TEST_AND_SET)) {
    sub HAS_TEST_AND_SET () {	1;}
}
if(defined( &__i386)  && !defined( &__i386__)) {
    eval 'sub __i386__ () {1;}' unless defined(&__i386__);
}
if(defined( &__sparc)  && !defined( &__sparc__)) {
    eval 'sub __sparc__ () {1;}' unless defined(&__sparc__);
}
if(defined( &__i386__)) {
    require 'sys/isa_defs.ph';
}
unless(defined(&BIG_ENDIAN)) {
    eval 'sub BIG_ENDIAN () {4321;}' unless defined(&BIG_ENDIAN);
}
unless(defined(&LITTLE_ENDIAN)) {
    eval 'sub LITTLE_ENDIAN () {1234;}' unless defined(&LITTLE_ENDIAN);
}
unless(defined(&PDP_ENDIAN)) {
    eval 'sub PDP_ENDIAN () {3412;}' unless defined(&PDP_ENDIAN);
}
unless(defined(&BYTE_ORDER)) {
    if(defined(&__sparc__)) {
	eval 'sub BYTE_ORDER () { &BIG_ENDIAN;}' unless defined(&BYTE_ORDER);
    }
    if(defined(&__i386__)) {
	eval 'sub BYTE_ORDER () { &LITTLE_ENDIAN;}' unless defined(&BYTE_ORDER);
    }
}
unless(defined(&NAN)) {
    if(defined( &__GNUC__)  && defined( &__i386__)) {
	unless(defined(&__nan_bytes)) {
	    eval 'sub __nan_bytes () {{ 0, 0, 0, 0, 0, 0, 0xf8, 0x7f };}' unless defined(&__nan_bytes);
	}
	eval 'sub NAN () {( &__extension__ ((\'union union\' { \'unsigned char __c\'[8]; \'double\'  &__d; }) {  &__nan_bytes }). &__d);}' unless defined(&NAN);
    } else {
	eval 'sub NAN () {(0.0/0.0);}' unless defined(&NAN);
    }
}
1;
