require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&POSTGRES_H)) {
    eval 'sub POSTGRES_H () {1;}' unless defined(&POSTGRES_H);
    require 'c.ph';
    require 'utils/elog.ph';
    require 'utils/palloc.ph';
    eval 'sub TUPLE_TOASTER_ACTIVE () {1;}' unless defined(&TUPLE_TOASTER_ACTIVE);
    eval 'sub VARATT_FLAG_EXTERNAL () {0x80000000;}' unless defined(&VARATT_FLAG_EXTERNAL);
    eval 'sub VARATT_FLAG_COMPRESSED () {0x40000000;}' unless defined(&VARATT_FLAG_COMPRESSED);
    eval 'sub VARATT_MASK_FLAGS () {0xc0000000;}' unless defined(&VARATT_MASK_FLAGS);
    eval 'sub VARATT_MASK_SIZE () {0x3fffffff;}' unless defined(&VARATT_MASK_SIZE);
    eval 'sub VARATT_SIZEP {
        my($_PTR) = @_;
	    eval q(((( &varattrib *)($_PTR))-> &va_header));
    }' unless defined(&VARATT_SIZEP);
    eval 'sub VARATT_SIZE {
        my($PTR) = @_;
	    eval q(( &VARATT_SIZEP($PTR) &  &VARATT_MASK_SIZE));
    }' unless defined(&VARATT_SIZE);
    eval 'sub VARATT_DATA {
        my($PTR) = @_;
	    eval q(((( &varattrib *)($PTR))-> ($va_content->{va_data})));
    }' unless defined(&VARATT_DATA);
    eval 'sub VARATT_CDATA {
        my($PTR) = @_;
	    eval q(((( &varattrib *)($PTR))-> ($va_content->{va_compressed}->{va_data})));
    }' unless defined(&VARATT_CDATA);
    eval 'sub VARSIZE {
        my($__PTR) = @_;
	    eval q( &VARATT_SIZE($__PTR));
    }' unless defined(&VARSIZE);
    eval 'sub VARDATA {
        my($__PTR) = @_;
	    eval q( &VARATT_DATA($__PTR));
    }' unless defined(&VARDATA);
    eval 'sub VARATT_IS_EXTENDED {
        my($PTR) = @_;
	    eval q((( &VARATT_SIZEP($PTR) &  &VARATT_MASK_FLAGS) != 0));
    }' unless defined(&VARATT_IS_EXTENDED);
    eval 'sub VARATT_IS_EXTERNAL {
        my($PTR) = @_;
	    eval q((( &VARATT_SIZEP($PTR) &  &VARATT_FLAG_EXTERNAL) != 0));
    }' unless defined(&VARATT_IS_EXTERNAL);
    eval 'sub VARATT_IS_COMPRESSED {
        my($PTR) = @_;
	    eval q((( &VARATT_SIZEP($PTR) &  &VARATT_FLAG_COMPRESSED) != 0));
    }' unless defined(&VARATT_IS_COMPRESSED);
    eval 'sub GET_1_BYTE {
        my($datum) = @_;
	    eval q(((( &Datum) ($datum)) & 0xff));
    }' unless defined(&GET_1_BYTE);
    eval 'sub GET_2_BYTES {
        my($datum) = @_;
	    eval q(((( &Datum) ($datum)) & 0xffff));
    }' unless defined(&GET_2_BYTES);
    eval 'sub GET_4_BYTES {
        my($datum) = @_;
	    eval q(((( &Datum) ($datum)) & 0xffffffff));
    }' unless defined(&GET_4_BYTES);
    eval 'sub SET_1_BYTE {
        my($value) = @_;
	    eval q(((( &Datum) ($value)) & 0xff));
    }' unless defined(&SET_1_BYTE);
    eval 'sub SET_2_BYTES {
        my($value) = @_;
	    eval q(((( &Datum) ($value)) & 0xffff));
    }' unless defined(&SET_2_BYTES);
    eval 'sub SET_4_BYTES {
        my($value) = @_;
	    eval q(((( &Datum) ($value)) & 0xffffffff));
    }' unless defined(&SET_4_BYTES);
    eval 'sub DatumGetBool {
        my($X) = @_;
	    eval q((( &bool) ((( &Datum) ($X)) != 0)));
    }' unless defined(&DatumGetBool);
    eval 'sub BoolGetDatum {
        my($X) = @_;
	    eval q((( &Datum) (($X) ? 1: 0)));
    }' unless defined(&BoolGetDatum);
    eval 'sub DatumGetChar {
        my($X) = @_;
	    eval q((  &GET_1_BYTE($X)));
    }' unless defined(&DatumGetChar);
    eval 'sub CharGetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_1_BYTE($X)));
    }' unless defined(&CharGetDatum);
    eval 'sub Int8GetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_1_BYTE($X)));
    }' unless defined(&Int8GetDatum);
    eval 'sub DatumGetUInt8 {
        my($X) = @_;
	    eval q((( &uint8)  &GET_1_BYTE($X)));
    }' unless defined(&DatumGetUInt8);
    eval 'sub UInt8GetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_1_BYTE($X)));
    }' unless defined(&UInt8GetDatum);
    eval 'sub DatumGetInt16 {
        my($X) = @_;
	    eval q((( &int16)  &GET_2_BYTES($X)));
    }' unless defined(&DatumGetInt16);
    eval 'sub Int16GetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_2_BYTES($X)));
    }' unless defined(&Int16GetDatum);
    eval 'sub DatumGetUInt16 {
        my($X) = @_;
	    eval q((( &uint16)  &GET_2_BYTES($X)));
    }' unless defined(&DatumGetUInt16);
    eval 'sub UInt16GetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_2_BYTES($X)));
    }' unless defined(&UInt16GetDatum);
    eval 'sub DatumGetInt32 {
        my($X) = @_;
	    eval q((( &int32)  &GET_4_BYTES($X)));
    }' unless defined(&DatumGetInt32);
    eval 'sub Int32GetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_4_BYTES($X)));
    }' unless defined(&Int32GetDatum);
    eval 'sub DatumGetUInt32 {
        my($X) = @_;
	    eval q((( &uint32)  &GET_4_BYTES($X)));
    }' unless defined(&DatumGetUInt32);
    eval 'sub UInt32GetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_4_BYTES($X)));
    }' unless defined(&UInt32GetDatum);
    eval 'sub DatumGetObjectId {
        my($X) = @_;
	    eval q((( &Oid)  &GET_4_BYTES($X)));
    }' unless defined(&DatumGetObjectId);
    eval 'sub ObjectIdGetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_4_BYTES($X)));
    }' unless defined(&ObjectIdGetDatum);
    eval 'sub DatumGetTransactionId {
        my($X) = @_;
	    eval q((( &TransactionId)  &GET_4_BYTES($X)));
    }' unless defined(&DatumGetTransactionId);
    eval 'sub TransactionIdGetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_4_BYTES(($X))));
    }' unless defined(&TransactionIdGetDatum);
    eval 'sub DatumGetCommandId {
        my($X) = @_;
	    eval q((( &CommandId)  &GET_4_BYTES($X)));
    }' unless defined(&DatumGetCommandId);
    eval 'sub CommandIdGetDatum {
        my($X) = @_;
	    eval q((( &Datum)  &SET_4_BYTES($X)));
    }' unless defined(&CommandIdGetDatum);
    eval 'sub DatumGetPointer {
        my($X) = @_;
	    eval q((( &Pointer) ($X)));
    }' unless defined(&DatumGetPointer);
    eval 'sub PointerGetDatum {
        my($X) = @_;
	    eval q((( &Datum) ($X)));
    }' unless defined(&PointerGetDatum);
    eval 'sub DatumGetCString {
        my($X) = @_;
	    eval q((  &DatumGetPointer($X)));
    }' unless defined(&DatumGetCString);
    eval 'sub CStringGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&CStringGetDatum);
    eval 'sub DatumGetName {
        my($X) = @_;
	    eval q((( &Name)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetName);
    eval 'sub NameGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&NameGetDatum);
    eval 'sub DatumGetInt64 {
        my($X) = @_;
	    eval q((* (( &int64 *)  &DatumGetPointer($X))));
    }' unless defined(&DatumGetInt64);
    eval 'sub DatumGetFloat4 {
        my($X) = @_;
	    eval q((* (( &float4 *)  &DatumGetPointer($X))));
    }' unless defined(&DatumGetFloat4);
    eval 'sub DatumGetFloat8 {
        my($X) = @_;
	    eval q((* (( &float8 *)  &DatumGetPointer($X))));
    }' unless defined(&DatumGetFloat8);
    eval 'sub DatumGetFloat32 {
        my($X) = @_;
	    eval q((( &float32)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetFloat32);
    eval 'sub Float32GetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&Float32GetDatum);
    eval 'sub DatumGetFloat64 {
        my($X) = @_;
	    eval q((( &float64)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetFloat64);
    eval 'sub Float64GetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&Float64GetDatum);
    eval 'sub Int64GetDatumFast {
        my($X) = @_;
	    eval q( &PointerGetDatum(($X)));
    }' unless defined(&Int64GetDatumFast);
    eval 'sub Float4GetDatumFast {
        my($X) = @_;
	    eval q( &PointerGetDatum(($X)));
    }' unless defined(&Float4GetDatumFast);
    eval 'sub Float8GetDatumFast {
        my($X) = @_;
	    eval q( &PointerGetDatum(($X)));
    }' unless defined(&Float8GetDatumFast);
    eval 'sub Trap {
        my($condition, $errorType) = @_;
	    eval q( &do {  &if (( &assert_enabled)  && ($condition))  &ExceptionalCondition( &CppAsString($condition), ($errorType),  &__FILE__,  &__LINE__); }  &while (0));
    }' unless defined(&Trap);
    eval 'sub TrapMacro {
        my($condition, $errorType) = @_;
	    eval q((( &bool) ((!  &assert_enabled) || ! ($condition) || ( &ExceptionalCondition( &CppAsString($condition), ($errorType),  &__FILE__,  &__LINE__)))));
    }' unless defined(&TrapMacro);
    unless(defined(&USE_ASSERT_CHECKING)) {
	eval 'sub Assert {
	    my($condition) = @_;
    	    eval q();
	}' unless defined(&Assert);
	eval 'sub AssertMacro {
	    my($condition) = @_;
    	    eval q((( &void) &true));
	}' unless defined(&AssertMacro);
	eval 'sub AssertArg {
	    my($condition) = @_;
    	    eval q();
	}' unless defined(&AssertArg);
	eval 'sub AssertState {
	    my($condition) = @_;
    	    eval q();
	}' unless defined(&AssertState);
	eval 'sub assert_enabled () {0;}' unless defined(&assert_enabled);
    } else {
	eval 'sub Assert {
	    my($condition) = @_;
    	    eval q( &Trap(!($condition), \\"FailedAssertion\\"));
	}' unless defined(&Assert);
	eval 'sub AssertMacro {
	    my($condition) = @_;
    	    eval q((( &void)  &TrapMacro(!($condition), \\"FailedAssertion\\")));
	}' unless defined(&AssertMacro);
	eval 'sub AssertArg {
	    my($condition) = @_;
    	    eval q( &Trap(!($condition), \\"BadArgument\\"));
	}' unless defined(&AssertArg);
	eval 'sub AssertState {
	    my($condition) = @_;
    	    eval q( &Trap(!($condition), \\"BadState\\"));
	}' unless defined(&AssertState);
    }
    eval 'sub CATALOG {
        my($x) = @_;
	    eval q( &typedef  &struct CppConcat( &FormData_,$x));
    }' unless defined(&CATALOG);
    eval 'sub BOOTSTRAP () {1;}' unless defined(&BOOTSTRAP);
    eval 'sub BKI_SHARED_RELATION () {1;}' unless defined(&BKI_SHARED_RELATION);
    eval 'sub BKI_WITHOUT_OIDS () {1;}' unless defined(&BKI_WITHOUT_OIDS);
    eval 'sub DATA {
        my($x) = @_;
	    eval q( &extern \'int\'  &no_such_variable);
    }' unless defined(&DATA);
    eval 'sub DESCR {
        my($x) = @_;
	    eval q( &extern \'int\'  &no_such_variable);
    }' unless defined(&DESCR);
    eval 'sub BKI_BEGIN () {1;}' unless defined(&BKI_BEGIN);
    eval 'sub BKI_END () {1;}' unless defined(&BKI_END);
}
1;
