require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&OFF_H)) {
    eval 'sub OFF_H () {1;}' unless defined(&OFF_H);
    require 'storage/itemid.ph';
    eval 'sub InvalidOffsetNumber () {(( &OffsetNumber) 0);}' unless defined(&InvalidOffsetNumber);
    eval 'sub FirstOffsetNumber () {(( &OffsetNumber) 1);}' unless defined(&FirstOffsetNumber);
    eval 'sub MaxOffsetNumber () {(( &OffsetNumber) ( &BLCKSZ / $sizeof{ &ItemIdData}));}' unless defined(&MaxOffsetNumber);
    eval 'sub OffsetNumberMask () {(0xffff);}' unless defined(&OffsetNumberMask);
    eval 'sub OffsetNumberIsValid {
        my($offsetNumber) = @_;
	    eval q((( &bool) (($offsetNumber !=  &InvalidOffsetNumber)  && ($offsetNumber <=  &MaxOffsetNumber))));
    }' unless defined(&OffsetNumberIsValid);
    eval 'sub OffsetNumberNext {
        my($offsetNumber) = @_;
	    eval q((( &OffsetNumber) (1+ ($offsetNumber))));
    }' unless defined(&OffsetNumberNext);
    eval 'sub OffsetNumberPrev {
        my($offsetNumber) = @_;
	    eval q((( &OffsetNumber) (-1+ ($offsetNumber))));
    }' unless defined(&OffsetNumberPrev);
}
1;
