require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&S_LOCK_H)) {
    eval 'sub S_LOCK_H () {1;}' unless defined(&S_LOCK_H);
    require 'storage/pg_sema.ph';
    if(defined( &HAS_TEST_AND_SET)) {
	if(defined( &__GNUC__) || defined( &__ICC)) {
	    if(defined( &__i386__) || defined( &__x86_64__) ) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    }
	    if(defined( &__ia64__) || defined( &__ia64)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    }
	    if(defined( &__arm__) || defined( &__arm)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    }
	    if(defined( &__s390__)  && !defined( &__s390x__)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    }
	    if(defined( &__s390x__)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    }
	    if(defined( &__sparc__)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    }
	    if(defined( &__ppc__) || defined( &__powerpc__) || defined( &__powerpc64__)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
	    }
	    if(defined( &__mc68000__)  && defined( &__linux__)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    }
	    if(defined( &__ppc__) || defined( &__powerpc__) || defined( &__powerpc64__)) {
		eval 'sub S_UNLOCK {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&S_UNLOCK);
	    }
	    if(defined( &NEED_VAX_TAS_ASM)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    }
	    if(defined( &NEED_NS32K_TAS_ASM)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    }
	} else {
	    if(defined( &NEED_I386_TAS_ASM)  && defined( &USE_UNIVEL_CC)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
	    }
	}
	if(defined( &__alpha)) {
	    if(defined( &__GNUC__)) {
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q( &tas($lock));
		}' unless defined(&TAS);
		eval 'sub S_UNLOCK {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&S_UNLOCK);
		eval 'sub tas {
		    my($lock) = @_;
    		    eval q(\\"(assembly code)\\");
		}' unless defined(&tas);
	    } else {
		require 'alpha/builtins.ph';
		eval 'sub S_INIT_LOCK {
		    my($lock) = @_;
    		    eval q((*($lock) = 0));
		}' unless defined(&S_INIT_LOCK);
		eval 'sub TAS {
		    my($lock) = @_;
    		    eval q(( &__LOCK_LONG_RETRY(($lock), 1) == 0));
		}' unless defined(&TAS);
		eval 'sub S_UNLOCK {
		    my($lock) = @_;
    		    eval q( &__UNLOCK_LONG($lock));
		}' unless defined(&S_UNLOCK);
	    }
	}
	if(defined( &__hpux)) {
	    eval 'sub S_UNLOCK {
	        my($lock) = @_;
    		eval q( &do {  &volatile  &slock_t * &lock_ = ( &volatile  &slock_t *) ($lock);  ($lock_->{sema[0]}) = -1;  ($lock_->{sema[1]}) = -1;  ($lock_->{sema[2]}) = -1;  ($lock_->{sema[3]}) = -1; }  &while (0));
	    }' unless defined(&S_UNLOCK);
	    eval 'sub S_LOCK_FREE {
	        my($lock) = @_;
    		eval q(( * (( ($lock) + 15) & ~15) != 0));
	    }' unless defined(&S_LOCK_FREE);
	}
	if(defined( &__QNX__)  && defined( &__WATCOMC__)) {
	    eval 'sub TAS {
	        my($lock) = @_;
    		eval q( &wc_tas($lock));
	    }' unless defined(&TAS);
	}
	if(defined( &__sgi)) {
	    require 'mutex.ph';
	    eval 'sub TAS {
	        my($lock) = @_;
    		eval q(( &test_and_set($lock,1)));
	    }' unless defined(&TAS);
	    eval 'sub S_UNLOCK {
	        my($lock) = @_;
    		eval q(( &test_then_and($lock,0)));
	    }' unless defined(&S_UNLOCK);
	    eval 'sub S_INIT_LOCK {
	        my($lock) = @_;
    		eval q(( &test_then_and($lock,0)));
	    }' unless defined(&S_INIT_LOCK);
	    eval 'sub S_LOCK_FREE {
	        my($lock) = @_;
    		eval q(( &test_then_add($lock,0) == 0));
	    }' unless defined(&S_LOCK_FREE);
	}
	if(defined( &sinix)) {
	    eval 'sub TAS {
	        my($lock) = @_;
    		eval q((! &acquire_lock($lock)));
	    }' unless defined(&TAS);
	    eval 'sub S_UNLOCK {
	        my($lock) = @_;
    		eval q( &release_lock($lock));
	    }' unless defined(&S_UNLOCK);
	    eval 'sub S_INIT_LOCK {
	        my($lock) = @_;
    		eval q( &init_lock($lock));
	    }' unless defined(&S_INIT_LOCK);
	    eval 'sub S_LOCK_FREE {
	        my($lock) = @_;
    		eval q(( &stat_lock($lock) ==  &UNLOCKED));
	    }' unless defined(&S_LOCK_FREE);
	}
	if(defined( &_AIX)) {
	    eval 'sub TAS {
	        my($lock) = @_;
    		eval q( &_check_lock($lock, 0, 1));
	    }' unless defined(&TAS);
	    eval 'sub S_UNLOCK {
	        my($lock) = @_;
    		eval q( &_clear_lock($lock, 0));
	    }' unless defined(&S_UNLOCK);
	}
	if(defined ( &nextstep)) {
	    eval 'sub S_LOCK {
	        my($lock) = @_;
    		eval q( &mutex_lock($lock));
	    }' unless defined(&S_LOCK);
	    eval 'sub S_UNLOCK {
	        my($lock) = @_;
    		eval q( &mutex_unlock($lock));
	    }' unless defined(&S_UNLOCK);
	    eval 'sub S_INIT_LOCK {
	        my($lock) = @_;
    		eval q( &mutex_init($lock));
	    }' unless defined(&S_INIT_LOCK);
	    eval 'sub S_LOCK_FREE {
	        my($alock) = @_;
    		eval q((($alock)-> &lock == 0));
	    }' unless defined(&S_LOCK_FREE);
	}
    } else {
	eval 'sub S_LOCK_FREE {
	    my($lock) = @_;
    	    eval q( &s_lock_free_sema($lock));
	}' unless defined(&S_LOCK_FREE);
	eval 'sub S_UNLOCK {
	    my($lock) = @_;
    	    eval q( &s_unlock_sema($lock));
	}' unless defined(&S_UNLOCK);
	eval 'sub S_INIT_LOCK {
	    my($lock) = @_;
    	    eval q( &s_init_lock_sema($lock));
	}' unless defined(&S_INIT_LOCK);
	eval 'sub TAS {
	    my($lock) = @_;
    	    eval q( &tas_sema($lock));
	}' unless defined(&TAS);
    }
    if(!defined( &S_LOCK)) {
	eval 'sub S_LOCK {
	    my($lock) = @_;
    	    eval q( &do {  &if ( &TAS($lock))  &s_lock(($lock),  &__FILE__,  &__LINE__); }  &while (0));
	}' unless defined(&S_LOCK);
    }
    if(!defined( &S_LOCK_FREE)) {
	eval 'sub S_LOCK_FREE {
	    my($lock) = @_;
    	    eval q((*($lock) == 0));
	}' unless defined(&S_LOCK_FREE);
    }
    if(!defined( &S_UNLOCK)) {
	eval 'sub S_UNLOCK {
	    my($lock) = @_;
    	    eval q((*(( &volatile  &slock_t *) ($lock)) = 0));
	}' unless defined(&S_UNLOCK);
    }
    if(!defined( &S_INIT_LOCK)) {
	eval 'sub S_INIT_LOCK {
	    my($lock) = @_;
    	    eval q( &S_UNLOCK($lock));
	}' unless defined(&S_INIT_LOCK);
    }
    if(!defined( &TAS)) {
	eval 'sub TAS {
	    my($lock) = @_;
    	    eval q( &tas($lock));
	}' unless defined(&TAS);
    }
}
1;
