require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ACL_H)) {
    eval 'sub ACL_H () {1;}' unless defined(&ACL_H);
    require 'nodes/parsenodes.ph';
    require 'utils/array.ph';
    eval 'sub ACL_ID_WORLD () {0;}' unless defined(&ACL_ID_WORLD);
    eval 'sub ACL_IDTYPE_WORLD () {0x;}' unless defined(&ACL_IDTYPE_WORLD);
    eval 'sub ACL_IDTYPE_UID () {0x1;}' unless defined(&ACL_IDTYPE_UID);
    eval 'sub ACL_IDTYPE_GID () {0x2;}' unless defined(&ACL_IDTYPE_GID);
    eval 'sub ACLITEM_GET_PRIVS {
        my($item) = @_;
	    eval q((($item). &ai_privs & 0x3fffffff));
    }' unless defined(&ACLITEM_GET_PRIVS);
    eval 'sub ACLITEM_GET_IDTYPE {
        my($item) = @_;
	    eval q((($item). &ai_privs >> 30));
    }' unless defined(&ACLITEM_GET_IDTYPE);
    eval 'sub ACLITEM_SET_PRIVS_IDTYPE {
        my($item,$privs,$idtype) = @_;
	    eval q((($item). &ai_privs = (($privs) & 0x3fffffff) | (($idtype) << 30)));
    }' unless defined(&ACLITEM_SET_PRIVS_IDTYPE);
    eval 'sub ACL_NUM {
        my($ACL) = @_;
	    eval q(( &ARR_DIMS($ACL)[0]));
    }' unless defined(&ACL_NUM);
    eval 'sub ACL_DAT {
        my($ACL) = @_;
	    eval q((( &AclItem *)  &ARR_DATA_PTR($ACL)));
    }' unless defined(&ACL_DAT);
    eval 'sub ACL_N_SIZE {
        my($N) = @_;
	    eval q(( &ARR_OVERHEAD(1) + (($N) * $sizeof{ &AclItem})));
    }' unless defined(&ACL_N_SIZE);
    eval 'sub ACL_SIZE {
        my($ACL) = @_;
	    eval q( &ARR_SIZE($ACL));
    }' unless defined(&ACL_SIZE);
    eval 'sub IDLIST_NUM {
        my($IDL) = @_;
	    eval q(( &ARR_DIMS($IDL)[0]));
    }' unless defined(&IDLIST_NUM);
    eval 'sub IDLIST_DAT {
        my($IDL) = @_;
	    eval q((( &AclId *)  &ARR_DATA_PTR($IDL)));
    }' unless defined(&IDLIST_DAT);
    eval 'sub IDLIST_N_SIZE {
        my($N) = @_;
	    eval q(( &ARR_OVERHEAD(1) + (($N) * $sizeof{ &AclId})));
    }' unless defined(&IDLIST_N_SIZE);
    eval 'sub IDLIST_SIZE {
        my($IDL) = @_;
	    eval q( &ARR_SIZE($IDL));
    }' unless defined(&IDLIST_SIZE);
    eval 'sub DatumGetAclItemP {
        my($X) = @_;
	    eval q((( &AclItem *)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetAclItemP);
    eval 'sub PG_GETARG_ACLITEM_P {
        my($n) = @_;
	    eval q( &DatumGetAclItemP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_ACLITEM_P);
    eval 'sub PG_RETURN_ACLITEM_P {
        my($x) = @_;
	    eval q( &PG_RETURN_POINTER($x));
    }' unless defined(&PG_RETURN_ACLITEM_P);
    eval 'sub DatumGetAclP {
        my($X) = @_;
	    eval q((( &Acl *)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetAclP);
    eval 'sub DatumGetAclPCopy {
        my($X) = @_;
	    eval q((( &Acl *)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetAclPCopy);
    eval 'sub PG_GETARG_ACL_P {
        my($n) = @_;
	    eval q( &DatumGetAclP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_ACL_P);
    eval 'sub PG_GETARG_ACL_P_COPY {
        my($n) = @_;
	    eval q( &DatumGetAclPCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_ACL_P_COPY);
    eval 'sub PG_RETURN_ACL_P {
        my($x) = @_;
	    eval q( &PG_RETURN_POINTER($x));
    }' unless defined(&PG_RETURN_ACL_P);
    eval 'sub DatumGetIdListP {
        my($X) = @_;
	    eval q((( &IdList *)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetIdListP);
    eval 'sub DatumGetIdListPCopy {
        my($X) = @_;
	    eval q((( &IdList *)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetIdListPCopy);
    eval 'sub PG_GETARG_IDLIST_P {
        my($n) = @_;
	    eval q( &DatumGetIdListP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_IDLIST_P);
    eval 'sub PG_GETARG_IDLIST_P_COPY {
        my($n) = @_;
	    eval q( &DatumGetIdListPCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_IDLIST_P_COPY);
    eval 'sub PG_RETURN_IDLIST_P {
        my($x) = @_;
	    eval q( &PG_RETURN_POINTER($x));
    }' unless defined(&PG_RETURN_IDLIST_P);
    eval 'sub ACL_MODECHG_ADD () {1;}' unless defined(&ACL_MODECHG_ADD);
    eval 'sub ACL_MODECHG_DEL () {2;}' unless defined(&ACL_MODECHG_DEL);
    eval 'sub ACL_MODECHG_EQL () {3;}' unless defined(&ACL_MODECHG_EQL);
    eval 'sub ACL_MODECHG_ADD_CHR () {ord(\'+\');}' unless defined(&ACL_MODECHG_ADD_CHR);
    eval 'sub ACL_MODECHG_DEL_CHR () {ord(\'-\');}' unless defined(&ACL_MODECHG_DEL_CHR);
    eval 'sub ACL_MODECHG_EQL_CHR () {ord(\'=\');}' unless defined(&ACL_MODECHG_EQL_CHR);
    eval 'sub ACL_INSERT_CHR () {ord(\'a\');}' unless defined(&ACL_INSERT_CHR);
    eval 'sub ACL_SELECT_CHR () {ord(\'r\');}' unless defined(&ACL_SELECT_CHR);
    eval 'sub ACL_UPDATE_CHR () {ord(\'w\');}' unless defined(&ACL_UPDATE_CHR);
    eval 'sub ACL_DELETE_CHR () {ord(\'d\');}' unless defined(&ACL_DELETE_CHR);
    eval 'sub ACL_RULE_CHR () {ord(\'R\');}' unless defined(&ACL_RULE_CHR);
    eval 'sub ACL_REFERENCES_CHR () {ord(\'x\');}' unless defined(&ACL_REFERENCES_CHR);
    eval 'sub ACL_TRIGGER_CHR () {ord(\'t\');}' unless defined(&ACL_TRIGGER_CHR);
    eval 'sub ACL_EXECUTE_CHR () {ord(\'X\');}' unless defined(&ACL_EXECUTE_CHR);
    eval 'sub ACL_USAGE_CHR () {ord(\'U\');}' unless defined(&ACL_USAGE_CHR);
    eval 'sub ACL_CREATE_CHR () {ord(\'C\');}' unless defined(&ACL_CREATE_CHR);
    eval 'sub ACL_CREATE_TEMP_CHR () {ord(\'T\');}' unless defined(&ACL_CREATE_TEMP_CHR);
    eval 'sub ACL_ALL_RIGHTS_STR () {"arwdRxtXUCT";}' unless defined(&ACL_ALL_RIGHTS_STR);
    eval 'sub ACL_ALL_RIGHTS_RELATION () {( &ACL_INSERT| &ACL_SELECT| &ACL_UPDATE| &ACL_DELETE| &ACL_RULE| &ACL_REFERENCES| &ACL_TRIGGER);}' unless defined(&ACL_ALL_RIGHTS_RELATION);
    eval 'sub ACL_ALL_RIGHTS_DATABASE () {( &ACL_CREATE| &ACL_CREATE_TEMP);}' unless defined(&ACL_ALL_RIGHTS_DATABASE);
    eval 'sub ACL_ALL_RIGHTS_FUNCTION () {( &ACL_EXECUTE);}' unless defined(&ACL_ALL_RIGHTS_FUNCTION);
    eval 'sub ACL_ALL_RIGHTS_LANGUAGE () {( &ACL_USAGE);}' unless defined(&ACL_ALL_RIGHTS_LANGUAGE);
    eval 'sub ACL_ALL_RIGHTS_NAMESPACE () {( &ACL_USAGE| &ACL_CREATE);}' unless defined(&ACL_ALL_RIGHTS_NAMESPACE);
    eval("sub ACLCHECK_OK () { 0; }") unless defined(&ACLCHECK_OK);
    eval("sub ACLCHECK_NO_PRIV () { 1; }") unless defined(&ACLCHECK_NO_PRIV);
    eval("sub ACLCHECK_NOT_OWNER () { 2; }") unless defined(&ACLCHECK_NOT_OWNER);
}
1;
