require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PG_CRC_H)) {
    eval 'sub PG_CRC_H () {1;}' unless defined(&PG_CRC_H);
    if(defined(&INT64_IS_BUSTED)) {
	eval 'sub INIT_CRC64 {
	    my($crc) = @_;
    	    eval q((($crc). &crc0 = 0xffffffff, ($crc). &crc1 = 0xffffffff));
	}' unless defined(&INIT_CRC64);
	eval 'sub FIN_CRC64 {
	    my($crc) = @_;
    	    eval q((($crc). &crc0 ^= 0xffffffff, ($crc). &crc1 ^= 0xffffffff));
	}' unless defined(&FIN_CRC64);
	eval 'sub COMP_CRC64 {
	    my($crc, $data, $len) = @_;
    	    eval q( &do {  &uint32  &__crc0 = . &crc0;  &uint32  &__crc1 = . &crc1; \'unsigned char\' * &__data = ;  &uint32  &__len = ;  &while ( &__len-- > 0) { \'int\'  &__tab_index = ( ( &__crc1 >> 24) ^ * &__data++) & 0xff;  &__crc1 =  $crc_table1[ &__tab_index] ^ (( &__crc1 << 8) | ( &__crc0 >> 24));  &__crc0 =  $crc_table0[ &__tab_index] ^ ( &__crc0 << 8); } ($crc). &crc0 =  &__crc0; ($crc). &crc1 =  &__crc1; }  &while (0));
	}' unless defined(&COMP_CRC64);
	eval 'sub EQ_CRC64 {
	    my($c1,$c2) = @_;
    	    eval q((($c1). &crc0 == ($c2). &crc0  && ($c1). &crc1 == ($c2). &crc1));
	}' unless defined(&EQ_CRC64);
    } else {
	eval 'sub INIT_CRC64 {
	    my($crc) = @_;
    	    eval q((($crc). &crc0 =  &UINT64CONST(1.84467440737096e+19)));
	}' unless defined(&INIT_CRC64);
	eval 'sub FIN_CRC64 {
	    my($crc) = @_;
    	    eval q((($crc). &crc0 ^=  &UINT64CONST(1.84467440737096e+19)));
	}' unless defined(&FIN_CRC64);
	eval 'sub COMP_CRC64 {
	    my($crc, $data, $len) = @_;
    	    eval q( &do {  &uint64  &__crc0 = . &crc0; \'unsigned char\' * &__data = ;  &uint32  &__len = ;  &while ( &__len-- > 0) { \'int\'  &__tab_index = ( ( &__crc0 >> 56) ^ * &__data++) & 0xff;  &__crc0 =  $crc_table[ &__tab_index] ^ ( &__crc0 << 8); } ($crc). &crc0 =  &__crc0; }  &while (0));
	}' unless defined(&COMP_CRC64);
	eval 'sub EQ_CRC64 {
	    my($c1,$c2) = @_;
    	    eval q((($c1). &crc0 == ($c2). &crc0));
	}' unless defined(&EQ_CRC64);
    }
}
1;
