require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SASL_H)) {
    eval 'sub SASL_H () {1;}' unless defined(&SASL_H);
    eval 'sub SASL_VERSION_MAJOR () {1;}' unless defined(&SASL_VERSION_MAJOR);
    eval 'sub SASL_VERSION_MINOR () {5;}' unless defined(&SASL_VERSION_MINOR);
    eval 'sub SASL_VERSION_STEP () {28;}' unless defined(&SASL_VERSION_STEP);
    if(defined(&WIN32)) {
	if(defined(&LIBSASL_EXPORTS)) {
	    eval 'sub LIBSASL_API () { &__declspec( &dllexport);}' unless defined(&LIBSASL_API);
	} else {
	    eval 'sub LIBSASL_API () { &__declspec( &dllimport);}' unless defined(&LIBSASL_API);
	}
    } else {
	eval 'sub LIBSASL_API () { &extern;}' unless defined(&LIBSASL_API);
    }
    eval 'sub SASL_CONTINUE () {(1);}' unless defined(&SASL_CONTINUE);
    eval 'sub SASL_OK () {(0);}' unless defined(&SASL_OK);
    eval 'sub SASL_FAIL () {(-1);}' unless defined(&SASL_FAIL);
    eval 'sub SASL_NOMEM () {(-2);}' unless defined(&SASL_NOMEM);
    eval 'sub SASL_BUFOVER () {(-3);}' unless defined(&SASL_BUFOVER);
    eval 'sub SASL_NOMECH () {(-4);}' unless defined(&SASL_NOMECH);
    eval 'sub SASL_BADPROT () {(-5);}' unless defined(&SASL_BADPROT);
    eval 'sub SASL_NOTDONE () {(-6);}' unless defined(&SASL_NOTDONE);
    eval 'sub SASL_BADPARAM () {(-7);}' unless defined(&SASL_BADPARAM);
    eval 'sub SASL_TRYAGAIN () {(-8);}' unless defined(&SASL_TRYAGAIN);
    eval 'sub SASL_BADMAC () {(-9);}' unless defined(&SASL_BADMAC);
    eval 'sub SASL_INTERACT () {(2);}' unless defined(&SASL_INTERACT);
    eval 'sub SASL_BADSERV () {(-10);}' unless defined(&SASL_BADSERV);
    eval 'sub SASL_WRONGMECH () {(-11);}' unless defined(&SASL_WRONGMECH);
    eval 'sub SASL_NEWSECRET () {(-12);}' unless defined(&SASL_NEWSECRET);
    eval 'sub SASL_BADAUTH () {(-13);}' unless defined(&SASL_BADAUTH);
    eval 'sub SASL_NOAUTHZ () {(-14);}' unless defined(&SASL_NOAUTHZ);
    eval 'sub SASL_TOOWEAK () {(-15);}' unless defined(&SASL_TOOWEAK);
    eval 'sub SASL_ENCRYPT () {(-16);}' unless defined(&SASL_ENCRYPT);
    eval 'sub SASL_TRANS () {(-17);}' unless defined(&SASL_TRANS);
    eval 'sub SASL_EXPIRED () {(-18);}' unless defined(&SASL_EXPIRED);
    eval 'sub SASL_DISABLED () {(-19);}' unless defined(&SASL_DISABLED);
    eval 'sub SASL_NOUSER () {(-20);}' unless defined(&SASL_NOUSER);
    eval 'sub SASL_PWLOCK () {(-21);}' unless defined(&SASL_PWLOCK);
    eval 'sub SASL_NOCHANGE () {(-22);}' unless defined(&SASL_NOCHANGE);
    eval 'sub SASL_BADVERS () {(-23);}' unless defined(&SASL_BADVERS);
    eval 'sub SASL_NOPATH () {(-25);}' unless defined(&SASL_NOPATH);
    eval 'sub SASL_MECHNAMEMAX () {20;}' unless defined(&SASL_MECHNAMEMAX);
    eval 'sub SASL_SECURITY_LAYER () {(0x1);}' unless defined(&SASL_SECURITY_LAYER);
    eval 'sub SASL_SEC_NOPLAINTEXT () {(0x1);}' unless defined(&SASL_SEC_NOPLAINTEXT);
    eval 'sub SASL_SEC_NOACTIVE () {(0x2);}' unless defined(&SASL_SEC_NOACTIVE);
    eval 'sub SASL_SEC_NODICTIONARY () {(0x4);}' unless defined(&SASL_SEC_NODICTIONARY);
    eval 'sub SASL_SEC_FORWARD_SECRECY () {(0x8);}' unless defined(&SASL_SEC_FORWARD_SECRECY);
    eval 'sub SASL_SEC_NOANONYMOUS () {(0x10);}' unless defined(&SASL_SEC_NOANONYMOUS);
    eval 'sub SASL_SEC_PASS_CREDENTIALS () {(0x200);}' unless defined(&SASL_SEC_PASS_CREDENTIALS);
    eval 'sub SASL_CB_LIST_END () {(0);}' unless defined(&SASL_CB_LIST_END);
    eval 'sub SASL_CB_GETOPT () {(1);}' unless defined(&SASL_CB_GETOPT);
    eval 'sub SASL_LOG_ERR () {(1);}' unless defined(&SASL_LOG_ERR);
    eval 'sub SASL_LOG_WARNING () {(2);}' unless defined(&SASL_LOG_WARNING);
    eval 'sub SASL_LOG_INFO () {(3);}' unless defined(&SASL_LOG_INFO);
    eval 'sub SASL_CB_LOG () {(2);}' unless defined(&SASL_CB_LOG);
    eval 'sub SASL_CB_GETPATH () {(3);}' unless defined(&SASL_CB_GETPATH);
    eval 'sub SASL_CB_VERIFYFILE () {(4);}' unless defined(&SASL_CB_VERIFYFILE);
    eval 'sub SASL_VRFY_PLUGIN () {(1);}' unless defined(&SASL_VRFY_PLUGIN);
    eval 'sub SASL_VRFY_CONF () {(2);}' unless defined(&SASL_VRFY_CONF);
    eval 'sub SASL_VRFY_PASSWD () {(3);}' unless defined(&SASL_VRFY_PASSWD);
    eval 'sub SASL_VRFY_OTHER () {(4);}' unless defined(&SASL_VRFY_OTHER);
    eval 'sub SASL_CB_USER () {(0x4001);}' unless defined(&SASL_CB_USER);
    eval 'sub SASL_CB_AUTHNAME () {(0x4002);}' unless defined(&SASL_CB_AUTHNAME);
    eval 'sub SASL_CB_LANGUAGE () {(0x4003);}' unless defined(&SASL_CB_LANGUAGE);
    eval 'sub SASL_CB_PASS () {(0x4004);}' unless defined(&SASL_CB_PASS);
    eval 'sub SASL_CB_ECHOPROMPT () {(0x4005);}' unless defined(&SASL_CB_ECHOPROMPT);
    eval 'sub SASL_CB_NOECHOPROMPT () {(0x4006);}' unless defined(&SASL_CB_NOECHOPROMPT);
    eval 'sub SASL_CB_GETREALM () {(0x4007);}' unless defined(&SASL_CB_GETREALM);
    eval 'sub SASL_CB_PROXY_POLICY () {(0x8001);}' unless defined(&SASL_CB_PROXY_POLICY);
    eval 'sub SASL_CB_SERVER_GETSECRET () {(0x8002);}' unless defined(&SASL_CB_SERVER_GETSECRET);
    eval 'sub SASL_CB_SERVER_PUTSECRET () {(0x8003);}' unless defined(&SASL_CB_SERVER_PUTSECRET);
    eval 'sub SASL_USERNAME () {0;}' unless defined(&SASL_USERNAME);
    eval 'sub SASL_SSF () {1;}' unless defined(&SASL_SSF);
    eval 'sub SASL_MAXOUTBUF () {2;}' unless defined(&SASL_MAXOUTBUF);
    eval 'sub SASL_REALM () {3;}' unless defined(&SASL_REALM);
    eval 'sub SASL_GETOPTCTX () {4;}' unless defined(&SASL_GETOPTCTX);
    eval 'sub SASL_IP_LOCAL () {5;}' unless defined(&SASL_IP_LOCAL);
    eval 'sub SASL_IP_REMOTE () {6;}' unless defined(&SASL_IP_REMOTE);
    eval 'sub SASL_SSF_EXTERNAL () {100;}' unless defined(&SASL_SSF_EXTERNAL);
    eval 'sub SASL_SEC_PROPS () {101;}' unless defined(&SASL_SEC_PROPS);
    eval 'sub SASL_SET_CREATE () {0x1;}' unless defined(&SASL_SET_CREATE);
    eval 'sub SASL_SET_DISABLE () {0x2;}' unless defined(&SASL_SET_DISABLE);
}
1;
