require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&macros_INCLUDED)) {
    eval 'sub macros_INCLUDED () {1;}' unless defined(&macros_INCLUDED);
    unless(defined(&__GNUG__)) {
	eval 'sub __attribute__ {
	    my($args) = @_;
    	    eval q();
	}' unless defined(&__attribute__);
    }
    if(defined(&NDEBUG)) {
	require 'stdlib.ph';
	eval 'sub ASSERT {
	    my($expr) = @_;
    	    eval q((( &void)0));
	}' unless defined(&ASSERT);
	eval 'sub CANNOT_HAPPEN () {
	    eval q((( &void) &abort()));
	}' unless defined(&CANNOT_HAPPEN);
    } else {
	if(defined(&SP_NAMESPACE)) {
	}
	if(defined(&SP_NAMESPACE)) {
	}
	eval 'sub ASSERT {
	    my($expr) = @_;
    	    eval q((( &void)(($expr) || (:: &SP_NAMESPACE_SCOPE  &assertionFailed( $expr,  &__FILE__,  &__LINE__), 0))));
	}' unless defined(&ASSERT);
	eval 'sub CANNOT_HAPPEN () {
	    eval q( &ASSERT(0));
	}' unless defined(&CANNOT_HAPPEN);
    }
    eval 'sub SIZEOF {
        my($v) = @_;
	    eval q(($sizeof{$v}/$sizeof{$v->[0]}));
    }' unless defined(&SIZEOF);
}
1;
