require '_h2ph_pre.ph';

no warnings 'redefine';

require 'Allocator.ph';
require 'ArcEngine.ph';
require 'Attribute.ph';
require 'Attributed.ph';
require 'Boolean.ph';
require 'CharMap.ph';
require 'CharsetDecl.ph';
require 'CharsetInfo.ph';
require 'CmdLineApp.ph';
require 'CodingSystem.ph';
require 'CodingSystemKit.ph';
require 'ConsoleOutput.ph';
require 'ContentState.ph';
require 'ContentToken.ph';
require 'CopyOwner.ph';
require 'DescriptorManager.ph';
require 'Dtd.ph';
require 'ElementType.ph';
require 'Entity.ph';
require 'EntityApp.ph';
require 'EntityCatalog.ph';
require 'EntityDecl.ph';
require 'EntityManager.ph';
require 'ErrnoMessageArg.ph';
require 'ErrorCountEventHandler.ph';
require 'Event.ph';
require 'EventsWanted.ph';
require 'ExtendEntityManager.ph';
require 'ExternalId.ph';
require 'GenericEventHandler.ph';
require 'Hash.ph';
require 'HashTable.ph';
require 'HashTableItemBase.ph';
require 'IList.ph';
require 'IListBase.ph';
require 'IListIter.ph';
require 'IListIterBase.ph';
require 'IQueue.ph';
require 'ISet.ph';
require 'ISetIter.ph';
require 'IdentityCodingSystem.ph';
require 'InputSource.ph';
require 'Link.ph';
require 'LinkProcess.ph';
require 'List.ph';
require 'ListIter.ph';
require 'LiteralStorage.ph';
require 'Location.ph';
require 'Lpd.ph';
require 'Markup.ph';
require 'Message.ph';
require 'MessageArg.ph';
require 'MessageBuilder.ph';
require 'MessageEventHandler.ph';
require 'MessageFormatter.ph';
require 'MessageReporter.ph';
require 'Mode.ph';
require 'NCVector.ph';
require 'Named.ph';
require 'NamedResource.ph';
require 'NamedResourceTable.ph';
require 'NamedTable.ph';
require 'Notation.ph';
require 'NotationStorage.ph';
require 'OpenElement.ph';
require 'Options.ph';
require 'OutputByteStream.ph';
require 'OutputCharStream.ph';
require 'Owner.ph';
require 'OwnerTable.ph';
require 'ParserApp.ph';
require 'ParserOptions.ph';
require 'PointerTable.ph';
require 'PosixStorage.ph';
require 'Ptr.ph';
require 'RangeMap.ph';
require 'Resource.ph';
require 'RewindStorageObject.ph';
require 'SOEntityCatalog.ph';
require 'Sd.ph';
require 'SdText.ph';
require 'SearchResultMessageArg.ph';
require 'SgmlParser.ph';
require 'ShortReferenceMap.ph';
require 'StdioStorage.ph';
require 'StorageManager.ph';
require 'StringC.ph';
require 'StringOf.ph';
require 'StringResource.ph';
require 'SubstTable.ph';
require 'Syntax.ph';
require 'Text.ph';
require 'TypeId.ph';
require 'URLStorage.ph';
require 'UnivCharsetDesc.ph';
require 'Vector.ph';
require 'XcharMap.ph';
require 'config.ph';
require 'constant.ph';
require 'macros.ph';
require 'rtti.ph';
require 'sptchar.ph';
require 'types.ph';
require 'xnew.ph';
if(defined(&SP_MULTI_BYTE)) {
    require 'EUCJPCodingSystem.ph';
    require 'Fixed2CodingSystem.ph';
    require 'SJISCodingSystem.ph';
    require 'UnicodeCodingSystem.ph';
    require 'UTF8CodingSystem.ph';
    if(defined(&WIN32)) {
	require 'Win32CodingSystem.ph';
    }
}
require 'EventGenerator.ph';
require 'ParserEventGeneratorKit.ph';
require 'SGMLApplication.ph';
require 'ArcProcessor.ph';
require 'CatalogEntry.ph';
require 'CharsetRegistry.ph';
require 'EquivClass.ph';
require 'EventQueue.ph';
require 'Group.ph';
require 'Id.ph';
require 'InternalInputSource.ph';
require 'LpdEntityRef.ph';
require 'MarkupScan.ph';
require 'ModeInfo.ph';
require 'NameToken.ph';
require 'NumericCharRefOrigin.ph';
require 'OutputState.ph';
require 'Param.ph';
require 'Parser.ph';
require 'ParserMessages.ph';
require 'ParserState.ph';
require 'Partition.ph';
require 'Priority.ph';
require 'Recognizer.ph';
require 'SdFormalError.ph';
require 'SrInfo.ph';
require 'StorageObjectPosition.ph';
require 'StringVectorMessageArg.ph';
require 'TokenMessageArg.ph';
require 'Trie.ph';
require 'TrieBuilder.ph';
require 'Undo.ph';
require 'token.ph';
1;
