require '_h2ph_pre.ph';

no warnings 'redefine';

require 'stdlib.ph';
require 'stdio.ph';
require 'string.ph';
unless(defined(&SWIG_MAJOR_VERSION)) {
    sub SWIG_MAJOR_VERSION () {	1;}
}
unless(defined(&SWIG_MINOR_VERSION)) {
    sub SWIG_MINOR_VERSION () {	1;}
}
unless(defined(&SWIG_SPIN)) {
    sub SWIG_SPIN () {	"(Patch 5)";}
}
if(defined(&MACSWIG)) {
    eval 'sub Status () { &Swig_Status;}' unless defined(&Status);
    undef(&stderr) if defined(&stderr);
    eval 'sub stderr () { &swig_log;}' unless defined(&stderr);
}
unless(defined(&FatalError)) {
    sub FatalError () {
	eval q( &if (( &error_count++) > 20) {  &fprintf( &stderr,\"Confused by earlier errors. Bailing out\\n\");  &SWIG_exit(1); });
    }
}
unless(defined(&STAT_READONLY)) {
    sub STAT_READONLY () {	1;}
}
unless(defined(&MAXSCOPE)) {
    sub MAXSCOPE () {	16;}
}
unless(defined(&tab2)) {
    sub tab2 () {	"  ";}
}
unless(defined(&tab4)) {
    sub tab4 () {	"    ";}
}
unless(defined(&tab8)) {
    sub tab8 () {	"	";}
}
unless(defined(&br)) {
    sub br () {	"\n";}
}
unless(defined(&endl)) {
    sub endl () {	"\n";}
}
unless(defined(&quote)) {
    sub quote () {	"\"";}
}
unless(defined(&T_INT)) {
    sub T_INT () {	1;}
}
unless(defined(&T_SHORT)) {
    sub T_SHORT () {	2;}
}
unless(defined(&T_LONG)) {
    sub T_LONG () {	3;}
}
unless(defined(&T_UINT)) {
    sub T_UINT () {	4;}
}
unless(defined(&T_USHORT)) {
    sub T_USHORT () {	5;}
}
unless(defined(&T_ULONG)) {
    sub T_ULONG () {	6;}
}
unless(defined(&T_UCHAR)) {
    sub T_UCHAR () {	7;}
}
unless(defined(&T_SCHAR)) {
    sub T_SCHAR () {	8;}
}
unless(defined(&T_BOOL)) {
    sub T_BOOL () {	9;}
}
unless(defined(&T_DOUBLE)) {
    sub T_DOUBLE () {	10;}
}
unless(defined(&T_FLOAT)) {
    sub T_FLOAT () {	11;}
}
unless(defined(&T_CHAR)) {
    sub T_CHAR () {	12;}
}
unless(defined(&T_USER)) {
    sub T_USER () {	13;}
}
unless(defined(&T_VOID)) {
    sub T_VOID () {	14;}
}
unless(defined(&T_SYMBOL)) {
    sub T_SYMBOL () {	98;}
}
unless(defined(&T_ERROR)) {
    sub T_ERROR () {	99;}
}
unless(defined(&T_SINT)) {
    sub T_SINT () {	90;}
}
unless(defined(&T_SSHORT)) {
    sub T_SSHORT () {	91;}
}
unless(defined(&T_SLONG)) {
    sub T_SLONG () {	92;}
}
unless(defined(&MAX_NAME)) {
    sub MAX_NAME () {	96;}
}
unless(defined(&STAT_REPLACETYPE)) {
    sub STAT_REPLACETYPE () {	2;}
}
unless(defined(&CALL_VALUE)) {
    sub CALL_VALUE () {	0x1;}
}
unless(defined(&CALL_REFERENCE)) {
    sub CALL_REFERENCE () {	0x2;}
}
unless(defined(&CALL_OUTPUT)) {
    sub CALL_OUTPUT () {	0x4;}
}
unless(defined(&MAXPARMS)) {
    sub MAXPARMS () {	16;}
}
unless(defined(&INHERIT_FUNC)) {
    sub INHERIT_FUNC () {	0x1;}
}
unless(defined(&INHERIT_VAR)) {
    sub INHERIT_VAR () {	0x2;}
}
unless(defined(&INHERIT_CONST)) {
    sub INHERIT_CONST () {	0x4;}
}
unless(defined(&INHERIT_ALL)) {
    sub INHERIT_ALL () {	( &INHERIT_FUNC |  &INHERIT_VAR |  &INHERIT_CONST);}
}
unless(defined(&SWIGDEFAULT_SORT)) {
    sub SWIGDEFAULT_SORT () {	0;}
}
unless(defined(&SWIGDEFAULT_FORMAT)) {
    sub SWIGDEFAULT_FORMAT () {	1;}
}
unless(defined(&SWIGDEFAULT_INFO)) {
    sub SWIGDEFAULT_INFO () {	1;}
}
unless(defined(&AS_IS)) {
    sub AS_IS () {	1;}
}
1;
