require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_TK)) {
    eval 'sub _TK () {1;}' unless defined(&_TK);
    if(defined(&__cplusplus)) {
    }
    eval 'sub TK_MAJOR_VERSION () {8;}' unless defined(&TK_MAJOR_VERSION);
    eval 'sub TK_MINOR_VERSION () {3;}' unless defined(&TK_MINOR_VERSION);
    eval 'sub TK_RELEASE_LEVEL () { &TCL_FINAL_RELEASE;}' unless defined(&TK_RELEASE_LEVEL);
    eval 'sub TK_RELEASE_SERIAL () {5;}' unless defined(&TK_RELEASE_SERIAL);
    eval 'sub TK_VERSION () {"8.3";}' unless defined(&TK_VERSION);
    eval 'sub TK_PATCH_LEVEL () {"8.3.5";}' unless defined(&TK_PATCH_LEVEL);
    if(defined(&MAC_TCL)) {
	unless(defined(&REDO_KEYSYM_LOOKUP)) {
	    eval 'sub REDO_KEYSYM_LOOKUP () {1;}' unless defined(&REDO_KEYSYM_LOOKUP);
	}
    }
    unless(defined(&_TCL)) {
	require 'tcl.ph';
    }
    unless(defined(&RESOURCE_INCLUDED)) {
	unless(defined(&_XLIB_H)) {
	    if(defined(&MAC_TCL)) {
		require 'Xlib.ph';
		require 'X.ph';
	    } else {
		require 'X11/Xlib.ph';
	    }
	}
	if(defined(&__STDC__)) {
	    require 'stddef.ph';
	}
	if(defined(&BUILD_tk)) {
	    undef(&TCL_STORAGE_CLASS) if defined(&TCL_STORAGE_CLASS);
	    eval 'sub TCL_STORAGE_CLASS () { &DLLEXPORT;}' unless defined(&TCL_STORAGE_CLASS);
	}
	if(defined(&XNQueryInputStyle)) {
	    eval 'sub TK_USE_INPUT_METHODS () {1;}' unless defined(&TK_USE_INPUT_METHODS);
	}
	eval("sub TK_OPTION_BOOLEAN () { 0; }") unless defined(&TK_OPTION_BOOLEAN);
	eval("sub TK_OPTION_INT () { 1; }") unless defined(&TK_OPTION_INT);
	eval("sub TK_OPTION_DOUBLE () { 2; }") unless defined(&TK_OPTION_DOUBLE);
	eval("sub TK_OPTION_STRING () { 3; }") unless defined(&TK_OPTION_STRING);
	eval("sub TK_OPTION_STRING_TABLE () { 4; }") unless defined(&TK_OPTION_STRING_TABLE);
	eval("sub TK_OPTION_COLOR () { 5; }") unless defined(&TK_OPTION_COLOR);
	eval("sub TK_OPTION_FONT () { 6; }") unless defined(&TK_OPTION_FONT);
	eval("sub TK_OPTION_BITMAP () { 7; }") unless defined(&TK_OPTION_BITMAP);
	eval("sub TK_OPTION_BORDER () { 8; }") unless defined(&TK_OPTION_BORDER);
	eval("sub TK_OPTION_RELIEF () { 9; }") unless defined(&TK_OPTION_RELIEF);
	eval("sub TK_OPTION_CURSOR () { 10; }") unless defined(&TK_OPTION_CURSOR);
	eval("sub TK_OPTION_JUSTIFY () { 11; }") unless defined(&TK_OPTION_JUSTIFY);
	eval("sub TK_OPTION_ANCHOR () { 12; }") unless defined(&TK_OPTION_ANCHOR);
	eval("sub TK_OPTION_SYNONYM () { 13; }") unless defined(&TK_OPTION_SYNONYM);
	eval("sub TK_OPTION_PIXELS () { 14; }") unless defined(&TK_OPTION_PIXELS);
	eval("sub TK_OPTION_WINDOW () { 15; }") unless defined(&TK_OPTION_WINDOW);
	eval("sub TK_OPTION_END () { 16; }") unless defined(&TK_OPTION_END);
	eval 'sub TK_OPTION_NULL_OK () {1;}' unless defined(&TK_OPTION_NULL_OK);
	eval 'sub TK_OPTION_DONT_SET_DEFAULT () {8;}' unless defined(&TK_OPTION_DONT_SET_DEFAULT);
	if(defined(&offsetof)) {
	    eval 'sub Tk_Offset {
	        my($type, $field) = @_;
    		eval q((  &offsetof($type, $field)));
	    }' unless defined(&Tk_Offset);
	} else {
	    eval 'sub Tk_Offset {
	        my($type, $field) = @_;
    		eval q(( ( (($type *) 0)->$field)));
	    }' unless defined(&Tk_Offset);
	}
	if(defined(&TCL_MEM_DEBUG)) {
	    eval 'sub TK_NUM_SAVED_OPTIONS () {2;}' unless defined(&TK_NUM_SAVED_OPTIONS);
	} else {
	    eval 'sub TK_NUM_SAVED_OPTIONS () {20;}' unless defined(&TK_NUM_SAVED_OPTIONS);
	}
	unless(defined(&__NO_OLD_CONFIG)) {
	    eval("sub TK_CONFIG_BOOLEAN () { 0; }") unless defined(&TK_CONFIG_BOOLEAN);
	    eval("sub TK_CONFIG_INT () { 1; }") unless defined(&TK_CONFIG_INT);
	    eval("sub TK_CONFIG_DOUBLE () { 2; }") unless defined(&TK_CONFIG_DOUBLE);
	    eval("sub TK_CONFIG_STRING () { 3; }") unless defined(&TK_CONFIG_STRING);
	    eval("sub TK_CONFIG_UID () { 4; }") unless defined(&TK_CONFIG_UID);
	    eval("sub TK_CONFIG_COLOR () { 5; }") unless defined(&TK_CONFIG_COLOR);
	    eval("sub TK_CONFIG_FONT () { 6; }") unless defined(&TK_CONFIG_FONT);
	    eval("sub TK_CONFIG_BITMAP () { 7; }") unless defined(&TK_CONFIG_BITMAP);
	    eval("sub TK_CONFIG_BORDER () { 8; }") unless defined(&TK_CONFIG_BORDER);
	    eval("sub TK_CONFIG_RELIEF () { 9; }") unless defined(&TK_CONFIG_RELIEF);
	    eval("sub TK_CONFIG_CURSOR () { 10; }") unless defined(&TK_CONFIG_CURSOR);
	    eval("sub TK_CONFIG_ACTIVE_CURSOR () { 11; }") unless defined(&TK_CONFIG_ACTIVE_CURSOR);
	    eval("sub TK_CONFIG_JUSTIFY () { 12; }") unless defined(&TK_CONFIG_JUSTIFY);
	    eval("sub TK_CONFIG_ANCHOR () { 13; }") unless defined(&TK_CONFIG_ANCHOR);
	    eval("sub TK_CONFIG_SYNONYM () { 14; }") unless defined(&TK_CONFIG_SYNONYM);
	    eval("sub TK_CONFIG_CAP_STYLE () { 15; }") unless defined(&TK_CONFIG_CAP_STYLE);
	    eval("sub TK_CONFIG_JOIN_STYLE () { 16; }") unless defined(&TK_CONFIG_JOIN_STYLE);
	    eval("sub TK_CONFIG_PIXELS () { 17; }") unless defined(&TK_CONFIG_PIXELS);
	    eval("sub TK_CONFIG_MM () { 18; }") unless defined(&TK_CONFIG_MM);
	    eval("sub TK_CONFIG_WINDOW () { 19; }") unless defined(&TK_CONFIG_WINDOW);
	    eval("sub TK_CONFIG_CUSTOM () { 20; }") unless defined(&TK_CONFIG_CUSTOM);
	    eval("sub TK_CONFIG_END () { 21; }") unless defined(&TK_CONFIG_END);
	    eval 'sub TK_CONFIG_ARGV_ONLY () {1;}' unless defined(&TK_CONFIG_ARGV_ONLY);
	    eval 'sub TK_CONFIG_OBJS () {0x80;}' unless defined(&TK_CONFIG_OBJS);
	    eval 'sub TK_CONFIG_NULL_OK () {1;}' unless defined(&TK_CONFIG_NULL_OK);
	    eval 'sub TK_CONFIG_COLOR_ONLY () {2;}' unless defined(&TK_CONFIG_COLOR_ONLY);
	    eval 'sub TK_CONFIG_MONO_ONLY () {4;}' unless defined(&TK_CONFIG_MONO_ONLY);
	    eval 'sub TK_CONFIG_DONT_SET_DEFAULT () {8;}' unless defined(&TK_CONFIG_DONT_SET_DEFAULT);
	    eval 'sub TK_CONFIG_OPTION_SPECIFIED () {0x10;}' unless defined(&TK_CONFIG_OPTION_SPECIFIED);
	    eval 'sub TK_CONFIG_USER_BIT () {0x100;}' unless defined(&TK_CONFIG_USER_BIT);
	}
	eval 'sub TK_ARGV_CONSTANT () {15;}' unless defined(&TK_ARGV_CONSTANT);
	eval 'sub TK_ARGV_INT () {16;}' unless defined(&TK_ARGV_INT);
	eval 'sub TK_ARGV_STRING () {17;}' unless defined(&TK_ARGV_STRING);
	eval 'sub TK_ARGV_UID () {18;}' unless defined(&TK_ARGV_UID);
	eval 'sub TK_ARGV_REST () {19;}' unless defined(&TK_ARGV_REST);
	eval 'sub TK_ARGV_FLOAT () {20;}' unless defined(&TK_ARGV_FLOAT);
	eval 'sub TK_ARGV_FUNC () {21;}' unless defined(&TK_ARGV_FUNC);
	eval 'sub TK_ARGV_GENFUNC () {22;}' unless defined(&TK_ARGV_GENFUNC);
	eval 'sub TK_ARGV_HELP () {23;}' unless defined(&TK_ARGV_HELP);
	eval 'sub TK_ARGV_CONST_OPTION () {24;}' unless defined(&TK_ARGV_CONST_OPTION);
	eval 'sub TK_ARGV_OPTION_VALUE () {25;}' unless defined(&TK_ARGV_OPTION_VALUE);
	eval 'sub TK_ARGV_OPTION_NAME_VALUE () {26;}' unless defined(&TK_ARGV_OPTION_NAME_VALUE);
	eval 'sub TK_ARGV_END () {27;}' unless defined(&TK_ARGV_END);
	eval 'sub TK_ARGV_NO_DEFAULTS () {0x1;}' unless defined(&TK_ARGV_NO_DEFAULTS);
	eval 'sub TK_ARGV_NO_LEFTOVERS () {0x2;}' unless defined(&TK_ARGV_NO_LEFTOVERS);
	eval 'sub TK_ARGV_NO_ABBREV () {0x4;}' unless defined(&TK_ARGV_NO_ABBREV);
	eval 'sub TK_ARGV_DONT_SKIP_FIRST_ARG () {0x8;}' unless defined(&TK_ARGV_DONT_SKIP_FIRST_ARG);
	eval("sub TK_DEFER_EVENT () { 0; }") unless defined(&TK_DEFER_EVENT);
	eval("sub TK_PROCESS_EVENT () { 1; }") unless defined(&TK_PROCESS_EVENT);
	eval("sub TK_DISCARD_EVENT () { 2; }") unless defined(&TK_DISCARD_EVENT);
	eval 'sub TK_WIDGET_DEFAULT_PRIO () {20;}' unless defined(&TK_WIDGET_DEFAULT_PRIO);
	eval 'sub TK_STARTUP_FILE_PRIO () {40;}' unless defined(&TK_STARTUP_FILE_PRIO);
	eval 'sub TK_USER_DEFAULT_PRIO () {60;}' unless defined(&TK_USER_DEFAULT_PRIO);
	eval 'sub TK_INTERACTIVE_PRIO () {80;}' unless defined(&TK_INTERACTIVE_PRIO);
	eval 'sub TK_MAX_PRIO () {100;}' unless defined(&TK_MAX_PRIO);
	eval 'sub TK_RELIEF_FLAT () {0;}' unless defined(&TK_RELIEF_FLAT);
	eval 'sub TK_RELIEF_GROOVE () {1;}' unless defined(&TK_RELIEF_GROOVE);
	eval 'sub TK_RELIEF_RAISED () {2;}' unless defined(&TK_RELIEF_RAISED);
	eval 'sub TK_RELIEF_RIDGE () {3;}' unless defined(&TK_RELIEF_RIDGE);
	eval 'sub TK_RELIEF_SOLID () {4;}' unless defined(&TK_RELIEF_SOLID);
	eval 'sub TK_RELIEF_SUNKEN () {5;}' unless defined(&TK_RELIEF_SUNKEN);
	eval 'sub TK_3D_FLAT_GC () {1;}' unless defined(&TK_3D_FLAT_GC);
	eval 'sub TK_3D_LIGHT_GC () {2;}' unless defined(&TK_3D_LIGHT_GC);
	eval 'sub TK_3D_DARK_GC () {3;}' unless defined(&TK_3D_DARK_GC);
	eval 'sub TK_NOTIFY_SHARE () {20;}' unless defined(&TK_NOTIFY_SHARE);
	eval("sub TK_ANCHOR_N () { 0; }") unless defined(&TK_ANCHOR_N);
	eval("sub TK_ANCHOR_NE () { 1; }") unless defined(&TK_ANCHOR_NE);
	eval("sub TK_ANCHOR_E () { 2; }") unless defined(&TK_ANCHOR_E);
	eval("sub TK_ANCHOR_SE () { 3; }") unless defined(&TK_ANCHOR_SE);
	eval("sub TK_ANCHOR_S () { 4; }") unless defined(&TK_ANCHOR_S);
	eval("sub TK_ANCHOR_SW () { 5; }") unless defined(&TK_ANCHOR_SW);
	eval("sub TK_ANCHOR_W () { 6; }") unless defined(&TK_ANCHOR_W);
	eval("sub TK_ANCHOR_NW () { 7; }") unless defined(&TK_ANCHOR_NW);
	eval("sub TK_ANCHOR_CENTER () { 8; }") unless defined(&TK_ANCHOR_CENTER);
	eval("sub TK_JUSTIFY_LEFT () { 0; }") unless defined(&TK_JUSTIFY_LEFT);
	eval("sub TK_JUSTIFY_RIGHT () { 1; }") unless defined(&TK_JUSTIFY_RIGHT);
	eval("sub TK_JUSTIFY_CENTER () { 2; }") unless defined(&TK_JUSTIFY_CENTER);
	eval 'sub TK_WHOLE_WORDS () {1;}' unless defined(&TK_WHOLE_WORDS);
	eval 'sub TK_AT_LEAST_ONE () {2;}' unless defined(&TK_AT_LEAST_ONE);
	eval 'sub TK_PARTIAL_OK () {4;}' unless defined(&TK_PARTIAL_OK);
	eval 'sub TK_IGNORE_TABS () {8;}' unless defined(&TK_IGNORE_TABS);
	eval 'sub TK_IGNORE_NEWLINES () {16;}' unless defined(&TK_IGNORE_NEWLINES);
	eval 'sub TK_SCROLL_MOVETO () {1;}' unless defined(&TK_SCROLL_MOVETO);
	eval 'sub TK_SCROLL_PAGES () {2;}' unless defined(&TK_SCROLL_PAGES);
	eval 'sub TK_SCROLL_UNITS () {3;}' unless defined(&TK_SCROLL_UNITS);
	eval 'sub TK_SCROLL_ERROR () {4;}' unless defined(&TK_SCROLL_ERROR);
	eval 'sub VirtualEvent () {( &LASTEvent);}' unless defined(&VirtualEvent);
	eval 'sub ActivateNotify () {( &LASTEvent + 1);}' unless defined(&ActivateNotify);
	eval 'sub DeactivateNotify () {( &LASTEvent + 2);}' unless defined(&DeactivateNotify);
	eval 'sub MouseWheelEvent () {( &LASTEvent + 3);}' unless defined(&MouseWheelEvent);
	eval 'sub TK_LASTEVENT () {( &LASTEvent + 4);}' unless defined(&TK_LASTEVENT);
	eval 'sub MouseWheelMask () {(1 << 28);}' unless defined(&MouseWheelMask);
	eval 'sub ActivateMask () {(1 << 29);}' unless defined(&ActivateMask);
	eval 'sub VirtualEventMask () {(1 << 30);}' unless defined(&VirtualEventMask);
	eval 'sub TK_LASTEVENT () {( &LASTEvent + 4);}' unless defined(&TK_LASTEVENT);
	eval 'sub Tk_Display {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &display));
	}' unless defined(&Tk_Display);
	eval 'sub Tk_ScreenNumber {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &screenNum));
	}' unless defined(&Tk_ScreenNumber);
	eval 'sub Tk_Screen {
	    my($tkwin) = @_;
    	    eval q(( &ScreenOfDisplay( &Tk_Display($tkwin),  &Tk_ScreenNumber($tkwin))));
	}' unless defined(&Tk_Screen);
	eval 'sub Tk_Depth {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &depth));
	}' unless defined(&Tk_Depth);
	eval 'sub Tk_Visual {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &visual));
	}' unless defined(&Tk_Visual);
	eval 'sub Tk_WindowId {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &window));
	}' unless defined(&Tk_WindowId);
	eval 'sub Tk_PathName {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &pathName));
	}' unless defined(&Tk_PathName);
	eval 'sub Tk_Name {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &nameUid));
	}' unless defined(&Tk_Name);
	eval 'sub Tk_Class {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &classUid));
	}' unless defined(&Tk_Class);
	eval 'sub Tk_X {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> ($changes->{x})));
	}' unless defined(&Tk_X);
	eval 'sub Tk_Y {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> ($changes->{y})));
	}' unless defined(&Tk_Y);
	eval 'sub Tk_Width {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> ($changes->{width})));
	}' unless defined(&Tk_Width);
	eval 'sub Tk_Height {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> ($changes->{height})));
	}' unless defined(&Tk_Height);
	eval 'sub Tk_Changes {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &changes));
	}' unless defined(&Tk_Changes);
	eval 'sub Tk_Attributes {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &atts));
	}' unless defined(&Tk_Attributes);
	eval 'sub Tk_IsEmbedded {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &flags &  &TK_EMBEDDED));
	}' unless defined(&Tk_IsEmbedded);
	eval 'sub Tk_IsContainer {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &flags &  &TK_CONTAINER));
	}' unless defined(&Tk_IsContainer);
	eval 'sub Tk_IsMapped {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &flags &  &TK_MAPPED));
	}' unless defined(&Tk_IsMapped);
	eval 'sub Tk_IsTopLevel {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &flags &  &TK_TOP_LEVEL));
	}' unless defined(&Tk_IsTopLevel);
	eval 'sub Tk_ReqWidth {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &reqWidth));
	}' unless defined(&Tk_ReqWidth);
	eval 'sub Tk_ReqHeight {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &reqHeight));
	}' unless defined(&Tk_ReqHeight);
	eval 'sub Tk_InternalBorderWidth {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &internalBorderWidth));
	}' unless defined(&Tk_InternalBorderWidth);
	eval 'sub Tk_Parent {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> &parentPtr));
	}' unless defined(&Tk_Parent);
	eval 'sub Tk_Colormap {
	    my($tkwin) = @_;
    	    eval q(((( &Tk_FakeWin *) ($tkwin))-> ($atts->{colormap})));
	}' unless defined(&Tk_Colormap);
	if(defined(&TK_USE_INPUT_METHODS)) {
	}
	eval 'sub TK_MAPPED () {1;}' unless defined(&TK_MAPPED);
	eval 'sub TK_TOP_LEVEL () {2;}' unless defined(&TK_TOP_LEVEL);
	eval 'sub TK_ALREADY_DEAD () {4;}' unless defined(&TK_ALREADY_DEAD);
	eval 'sub TK_NEED_CONFIG_NOTIFY () {8;}' unless defined(&TK_NEED_CONFIG_NOTIFY);
	eval 'sub TK_GRAB_FLAG () {0x10;}' unless defined(&TK_GRAB_FLAG);
	eval 'sub TK_CHECKED_IC () {0x20;}' unless defined(&TK_CHECKED_IC);
	eval 'sub TK_DONT_DESTROY_WINDOW () {0x40;}' unless defined(&TK_DONT_DESTROY_WINDOW);
	eval 'sub TK_WM_COLORMAP_WINDOW () {0x80;}' unless defined(&TK_WM_COLORMAP_WINDOW);
	eval 'sub TK_EMBEDDED () {0x100;}' unless defined(&TK_EMBEDDED);
	eval 'sub TK_CONTAINER () {0x200;}' unless defined(&TK_CONTAINER);
	eval 'sub TK_BOTH_HALVES () {0x400;}' unless defined(&TK_BOTH_HALVES);
	eval 'sub TK_DEFER_MODAL () {0x800;}' unless defined(&TK_DEFER_MODAL);
	eval 'sub TK_WRAPPER () {0x1000;}' unless defined(&TK_WRAPPER);
	eval 'sub TK_REPARENTED () {0x2000;}' unless defined(&TK_REPARENTED);
	eval("sub TK_STATE_NULL () { -1; }") unless defined(&TK_STATE_NULL);
	eval("sub TK_STATE_ACTIVE () { 0; }") unless defined(&TK_STATE_ACTIVE);
	eval("sub TK_STATE_DISABLED () { 1; }") unless defined(&TK_STATE_DISABLED);
	eval("sub TK_STATE_NORMAL () { 2; }") unless defined(&TK_STATE_NORMAL);
	eval("sub TK_STATE_HIDDEN () { 3; }") unless defined(&TK_STATE_HIDDEN);
	eval 'sub TK_TAG_SPACE () {3;}' unless defined(&TK_TAG_SPACE);
	eval 'sub TK_ITEM_STATE_DEPENDANT () {1;}' unless defined(&TK_ITEM_STATE_DEPENDANT);
	eval 'sub TK_ITEM_DONT_REDRAW () {2;}' unless defined(&TK_ITEM_DONT_REDRAW);
	if(defined(&USE_OLD_CANVAS)) {
	} else {
	}
	unless(defined(&__NO_OLD_CONFIG)) {
	}
	eval 'sub TK_OFFSET_INDEX () {1;}' unless defined(&TK_OFFSET_INDEX);
	eval 'sub TK_OFFSET_RELATIVE () {2;}' unless defined(&TK_OFFSET_RELATIVE);
	eval 'sub TK_OFFSET_LEFT () {4;}' unless defined(&TK_OFFSET_LEFT);
	eval 'sub TK_OFFSET_CENTER () {8;}' unless defined(&TK_OFFSET_CENTER);
	eval 'sub TK_OFFSET_RIGHT () {16;}' unless defined(&TK_OFFSET_RIGHT);
	eval 'sub TK_OFFSET_TOP () {32;}' unless defined(&TK_OFFSET_TOP);
	eval 'sub TK_OFFSET_MIDDLE () {64;}' unless defined(&TK_OFFSET_MIDDLE);
	eval 'sub TK_OFFSET_BOTTOM () {128;}' unless defined(&TK_OFFSET_BOTTOM);
	if(defined(&USE_OLD_IMAGE)) {
	} else {
	}
	if(defined(&USE_OLD_IMAGE)) {
	} else {
	}
	if(!defined( &USE_TK_STUBS)  && defined( &USE_OLD_IMAGE)) {
	    eval 'sub Tk_CreateImageType () { &Tk_CreateOldImageType;}' unless defined(&Tk_CreateImageType);
	    eval 'sub Tk_CreatePhotoImageFormat () { &Tk_CreateOldPhotoImageFormat;}' unless defined(&Tk_CreatePhotoImageFormat);
	}
	eval 'sub TK_READABLE () { &TCL_READABLE;}' unless defined(&TK_READABLE);
	eval 'sub TK_WRITABLE () { &TCL_WRITABLE;}' unless defined(&TK_WRITABLE);
	eval 'sub TK_EXCEPTION () { &TCL_EXCEPTION;}' unless defined(&TK_EXCEPTION);
	eval 'sub TK_DONT_WAIT () { &TCL_DONT_WAIT;}' unless defined(&TK_DONT_WAIT);
	eval 'sub TK_X_EVENTS () { &TCL_WINDOW_EVENTS;}' unless defined(&TK_X_EVENTS);
	eval 'sub TK_WINDOW_EVENTS () { &TCL_WINDOW_EVENTS;}' unless defined(&TK_WINDOW_EVENTS);
	eval 'sub TK_FILE_EVENTS () { &TCL_FILE_EVENTS;}' unless defined(&TK_FILE_EVENTS);
	eval 'sub TK_TIMER_EVENTS () { &TCL_TIMER_EVENTS;}' unless defined(&TK_TIMER_EVENTS);
	eval 'sub TK_IDLE_EVENTS () { &TCL_IDLE_EVENTS;}' unless defined(&TK_IDLE_EVENTS);
	eval 'sub TK_ALL_EVENTS () { &TCL_ALL_EVENTS;}' unless defined(&TK_ALL_EVENTS);
	eval 'sub Tk_IdleProc () { &Tcl_IdleProc;}' unless defined(&Tk_IdleProc);
	eval 'sub Tk_FileProc () { &Tcl_FileProc;}' unless defined(&Tk_FileProc);
	eval 'sub Tk_TimerProc () { &Tcl_TimerProc;}' unless defined(&Tk_TimerProc);
	eval 'sub Tk_TimerToken () { &Tcl_TimerToken;}' unless defined(&Tk_TimerToken);
	eval 'sub Tk_BackgroundError () { &Tcl_BackgroundError;}' unless defined(&Tk_BackgroundError);
	eval 'sub Tk_CancelIdleCall () { &Tcl_CancelIdleCall;}' unless defined(&Tk_CancelIdleCall);
	eval 'sub Tk_CreateFileHandler () { &Tcl_CreateFileHandler;}' unless defined(&Tk_CreateFileHandler);
	eval 'sub Tk_CreateTimerHandler () { &Tcl_CreateTimerHandler;}' unless defined(&Tk_CreateTimerHandler);
	eval 'sub Tk_DeleteFileHandler () { &Tcl_DeleteFileHandler;}' unless defined(&Tk_DeleteFileHandler);
	eval 'sub Tk_DeleteTimerHandler () { &Tcl_DeleteTimerHandler;}' unless defined(&Tk_DeleteTimerHandler);
	eval 'sub Tk_DoOneEvent () { &Tcl_DoOneEvent;}' unless defined(&Tk_DoOneEvent);
	eval 'sub Tk_DoWhenIdle () { &Tcl_DoWhenIdle;}' unless defined(&Tk_DoWhenIdle);
	eval 'sub Tk_Sleep () { &Tcl_Sleep;}' unless defined(&Tk_Sleep);
	eval 'sub Tk_AfterCmd () { &Tcl_AfterCmd;}' unless defined(&Tk_AfterCmd);
	eval 'sub Tk_EventuallyFree () { &Tcl_EventuallyFree;}' unless defined(&Tk_EventuallyFree);
	eval 'sub Tk_FreeProc () { &Tcl_FreeProc;}' unless defined(&Tk_FreeProc);
	eval 'sub Tk_Preserve () { &Tcl_Preserve;}' unless defined(&Tk_Preserve);
	eval 'sub Tk_Release () { &Tcl_Release;}' unless defined(&Tk_Release);
	eval 'sub Tk_Main {
	    my($argc, $argv, $proc) = @_;
    	    eval q( &Tk_MainEx($argc, $argv, $proc,  &Tcl_CreateInterp()));
	}' unless defined(&Tk_Main);
	unless(defined(&USE_TK_STUBS)) {
	    eval 'sub Tk_InitStubs {
	        my($interp, $version, $exact) = @_;
    		eval q( &Tcl_PkgRequire($interp, \\"Tk\\", $version, $exact));
	    }' unless defined(&Tk_InitStubs);
	}
	if(!defined( &USE_TK_STUBS) || !defined( &USE_OLD_IMAGE)) {
	    eval 'sub Tk_InitImageArgs {
	        my($interp, $argc, $argv) = @_;
    		eval q();
	    }' unless defined(&Tk_InitImageArgs);
	}
	require 'tkDecls.ph';
    }
    undef(&TCL_STORAGE_CLASS) if defined(&TCL_STORAGE_CLASS);
    eval 'sub TCL_STORAGE_CLASS () { &DLLIMPORT;}' unless defined(&TCL_STORAGE_CLASS);
    if(defined(&__cplusplus)) {
    }
}
1;
