require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NET_TUX_U_H)) {
    eval 'sub _NET_TUX_U_H () {1;}' unless defined(&_NET_TUX_U_H);
    require 'stdint.ph';
    eval 'sub TUX_MAJOR_VERSION () {3;}' unless defined(&TUX_MAJOR_VERSION);
    eval 'sub TUX_MINOR_VERSION () {0;}' unless defined(&TUX_MINOR_VERSION);
    eval 'sub TUX_PATCHLEVEL_VERSION () {0;}' unless defined(&TUX_PATCHLEVEL_VERSION);
    eval 'sub __KERNEL_SYSCALLS__ () {1;}' unless defined(&__KERNEL_SYSCALLS__);
    eval("sub HTTP_1_0 () { 0; }") unless defined(&HTTP_1_0);
    eval("sub HTTP_1_1 () { 1; }") unless defined(&HTTP_1_1);
    eval("sub METHOD_NONE () { 0; }") unless defined(&METHOD_NONE);
    eval("sub METHOD_GET () { 1; }") unless defined(&METHOD_GET);
    eval("sub METHOD_HEAD () { 2; }") unless defined(&METHOD_HEAD);
    eval("sub METHOD_POST () { 3; }") unless defined(&METHOD_POST);
    eval("sub METHOD_PUT () { 4; }") unless defined(&METHOD_PUT);
    eval("sub NR_METHODS () { 5; }") unless defined(&NR_METHODS);
    eval("sub TUX_ACTION_STARTUP () { 1; }") unless defined(&TUX_ACTION_STARTUP);
    eval("sub TUX_ACTION_SHUTDOWN () { 2; }") unless defined(&TUX_ACTION_SHUTDOWN);
    eval("sub TUX_ACTION_STARTTHREAD () { 3; }") unless defined(&TUX_ACTION_STARTTHREAD);
    eval("sub TUX_ACTION_STOPTHREAD () { 4; }") unless defined(&TUX_ACTION_STOPTHREAD);
    eval("sub TUX_ACTION_EVENTLOOP () { 5; }") unless defined(&TUX_ACTION_EVENTLOOP);
    eval("sub TUX_ACTION_GET_OBJECT () { 6; }") unless defined(&TUX_ACTION_GET_OBJECT);
    eval("sub TUX_ACTION_SEND_OBJECT () { 7; }") unless defined(&TUX_ACTION_SEND_OBJECT);
    eval("sub TUX_ACTION_READ_OBJECT () { 8; }") unless defined(&TUX_ACTION_READ_OBJECT);
    eval("sub TUX_ACTION_FINISH_REQ () { 9; }") unless defined(&TUX_ACTION_FINISH_REQ);
    eval("sub TUX_ACTION_FINISH_CLOSE_REQ () { 10; }") unless defined(&TUX_ACTION_FINISH_CLOSE_REQ);
    eval("sub TUX_ACTION_REGISTER_MODULE () { 11; }") unless defined(&TUX_ACTION_REGISTER_MODULE);
    eval("sub TUX_ACTION_UNREGISTER_MODULE () { 12; }") unless defined(&TUX_ACTION_UNREGISTER_MODULE);
    eval("sub TUX_ACTION_CURRENT_DATE () { 13; }") unless defined(&TUX_ACTION_CURRENT_DATE);
    eval("sub TUX_ACTION_REGISTER_MIMETYPE () { 14; }") unless defined(&TUX_ACTION_REGISTER_MIMETYPE);
    eval("sub TUX_ACTION_READ_HEADERS () { 15; }") unless defined(&TUX_ACTION_READ_HEADERS);
    eval("sub TUX_ACTION_POSTPONE_REQ () { 16; }") unless defined(&TUX_ACTION_POSTPONE_REQ);
    eval("sub TUX_ACTION_CONTINUE_REQ () { 17; }") unless defined(&TUX_ACTION_CONTINUE_REQ);
    eval("sub TUX_ACTION_REDIRECT_REQ () { 18; }") unless defined(&TUX_ACTION_REDIRECT_REQ);
    eval("sub TUX_ACTION_READ_POST_DATA () { 19; }") unless defined(&TUX_ACTION_READ_POST_DATA);
    eval("sub TUX_ACTION_SEND_BUFFER () { 20; }") unless defined(&TUX_ACTION_SEND_BUFFER);
    eval("sub TUX_ACTION_WATCH_PROXY_SOCKET () { 21; }") unless defined(&TUX_ACTION_WATCH_PROXY_SOCKET);
    eval("sub TUX_ACTION_WAIT_PROXY_SOCKET () { 22; }") unless defined(&TUX_ACTION_WAIT_PROXY_SOCKET);
    eval("sub TUX_ACTION_QUERY_VERSION () { 23; }") unless defined(&TUX_ACTION_QUERY_VERSION);
    eval("sub MAX_TUX_ACTION () { 24; }") unless defined(&MAX_TUX_ACTION);
    eval("sub TUX_ERROR () { -1; }") unless defined(&TUX_ERROR);
    eval("sub TUX_RETURN_USERSPACE_REQUEST () { 0; }") unless defined(&TUX_RETURN_USERSPACE_REQUEST);
    eval("sub TUX_RETURN_EXIT () { 1; }") unless defined(&TUX_RETURN_EXIT);
    eval("sub TUX_RETURN_SIGNAL () { 2; }") unless defined(&TUX_RETURN_SIGNAL);
    eval("sub TUX_CONTINUE_EVENTLOOP () { 3; }") unless defined(&TUX_CONTINUE_EVENTLOOP);
    eval 'sub MAX_URI_LEN () {256;}' unless defined(&MAX_URI_LEN);
    eval 'sub MAX_COOKIE_LEN () {128;}' unless defined(&MAX_COOKIE_LEN);
    eval 'sub MAX_FIELD_LEN () {64;}' unless defined(&MAX_FIELD_LEN);
    eval 'sub DATE_LEN () {32;}' unless defined(&DATE_LEN);
    eval 'sub TUXAPI_declare () {\'int\'  &TUXAPI_protocol_version = 3;}' unless defined(&TUXAPI_declare);
}
1;
