require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_TUX_MODULE_H)) {
    eval 'sub _TUX_MODULE_H () {1;}' unless defined(&_TUX_MODULE_H);
    require 'stdio.ph';
    require 'unistd.ph';
    require 'sys/types.ph';
    require 'sys/wait.ph';
    require 'sys/mman.ph';
    require 'sys/socket.ph';
    require 'sys/time.ph';
    require 'unistd.ph';
    require 'netinet/in.ph';
    require 'netdb.ph';
    require 'errno.ph';
    require 'malloc.ph';
    require 'fcntl.ph';
    require 'time.ph';
    require 'ctype.ph';
    require 'stdlib.ph';
    require 'string.ph';
    require 'netinet/tcp.ph';
    require 'tux.ph';
    eval 'sub CGI_SERVER_NAME {
        my($req) = @_;
	    eval q( &TUXAPI_servername);
    }' unless defined(&CGI_SERVER_NAME);
    eval 'sub CGI_SERVER_NAME_LEN {
        my($req) = @_;
	    eval q( &TUXAPI_servername_len);
    }' unless defined(&CGI_SERVER_NAME_LEN);
    eval 'sub CGI_GATEWAY_INTERFACE {
        my($req) = @_;
	    eval q(\\"CGI/1.1\\");
    }' unless defined(&CGI_GATEWAY_INTERFACE);
    eval 'sub CGI_SERVER_PROTOCOL {
        my($req) = @_;
	    eval q(((($req)-> &http_version ==  &HTTP_1_1) ? \\"HTTP/1.1\\" : \\"HTTP/1.0\\"));
    }' unless defined(&CGI_SERVER_PROTOCOL);
    eval 'sub CGI_SERVER_PORT {
        my($req) = @_;
	    eval q(80);
    }' unless defined(&CGI_SERVER_PORT);
    eval 'sub CGI_REQUEST_METHOD {
        my($req) = @_;
	    eval q(({ \'char\' * &__res;  &switch (($req)-> &http_method) {  &case  &METHOD_GET:  &__res = \\"GET\\";  &break;  &case  &METHOD_POST:  &__res = \\"POST\\";  &break;  &case  &METHOD_HEAD:  &__res = \\"HEAD\\";  &break;  &case  &METHOD_PUT:  &__res = \\"PUT\\";  &break;  &default:  &__res = \\"NONE\\";  &break; }  &__res; }));
    }' unless defined(&CGI_REQUEST_METHOD);
    eval 'sub CGI_HTTP_ACCEPT {
        my($req) = @_;
	    eval q((($req)-> &accept));
    }' unless defined(&CGI_HTTP_ACCEPT);
    eval 'sub CGI_HTTP_USER_AGENT {
        my($req) = @_;
	    eval q((($req)-> &user_agent));
    }' unless defined(&CGI_HTTP_USER_AGENT);
    eval 'sub CGI_HTTP_REFERER {
        my($req) = @_;
	    eval q((($req)-> &referer));
    }' unless defined(&CGI_HTTP_REFERER);
    eval 'sub CGI_PATH_TRANSLATED {
        my($req) = @_;
	    eval q(( &TUXAPI_docroot));
    }' unless defined(&CGI_PATH_TRANSLATED);
    eval 'sub CGI_DOCUMENT_ROOT {
        my($req) = @_;
	    eval q(( &TUXAPI_docroot));
    }' unless defined(&CGI_DOCUMENT_ROOT);
    eval 'sub CGI_PATH_INFO {
        my($req) = @_;
	    eval q((($req)-> &query));
    }' unless defined(&CGI_PATH_INFO);
    eval 'sub CGI_SCRIPT_NAME {
        my($req) = @_;
	    eval q(( $TUXAPI_modulename_array[($req)-> &module_index]));
    }' unless defined(&CGI_SCRIPT_NAME);
    eval 'sub CGI_QUERY_STRING {
        my($req) = @_;
	    eval q((($req)-> &query));
    }' unless defined(&CGI_QUERY_STRING);
    eval 'sub CGI_REMOTE_USER {
        my($req) = @_;
	    eval q(\\"\\");
    }' unless defined(&CGI_REMOTE_USER);
    eval 'sub CGI_REMOTE_AUTH_TYPE {
        my($req) = @_;
	    eval q(\\"\\");
    }' unless defined(&CGI_REMOTE_AUTH_TYPE);
    eval 'sub CGI_ANNOTATION_SERVER {
        my($req) = @_;
	    eval q(\\"\\");
    }' unless defined(&CGI_ANNOTATION_SERVER);
    eval 'sub CGI_CONTENT_TYPE {
        my($req) = @_;
	    eval q((($req)-> &content_type));
    }' unless defined(&CGI_CONTENT_TYPE);
    if(0) {
    }
    eval 'sub BUG () {
        eval q( &do {  &printf(\\"TUX BUG at %d:%s!\\\\n\\",  &__LINE__,  &__FILE__);  &tux( &TUX_ACTION_STOPTHREAD,  &NULL);  &tux( &TUX_ACTION_SHUTDOWN,  &NULL); *0=0;  &exit(-1); }  &while (0));
    }' unless defined(&BUG);
    if(defined( &__i386__) || defined( &__x86_64__)) {
	eval 'sub LOCK_PREFIX () {"lock ; ";}' unless defined(&LOCK_PREFIX);
	eval 'sub barrier () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&barrier);
	eval 'sub ADDR () {(*( &volatile \'struct __dummy\' *)  &addr);}' unless defined(&ADDR);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&test_and_set_bit);
	eval 'sub TUXAPI_down {
	    my($sem) = @_;
    	    eval q({  &while ( &test_and_set_bit(0, $sem))  &barrier(); });
	}' unless defined(&TUXAPI_down);
	eval 'sub TUXAPI_up {
	    my($sem) = @_;
    	    eval q({ *(( &volatile \'int\' *)$sem) = 0; });
	}' unless defined(&TUXAPI_up);
    }
 elsif(defined( &__powerpc__)) {
	eval 'sub TUXAPI_down {
	    my($sem) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&TUXAPI_down);
	eval 'sub TUXAPI_up {
	    my($sem) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&TUXAPI_up);
    }
 elsif(defined( &__ia64)) {
	require 'ia64intrin.ph';
	eval 'sub TUXAPI_down {
	    my($sem) = @_;
    	    eval q({  &while (! &__sync_bool_compare_and_swap($sem, 0, 1)) {  &while (*( &volatile \'int\' *)$sem)  &asm  &volatile (\\"hint @pause\\"); } });
	}' unless defined(&TUXAPI_down);
	eval 'sub TUXAPI_up {
	    my($sem) = @_;
    	    eval q({ *(( &volatile \'int\' *)$sem) = 0; });
	}' unless defined(&TUXAPI_up);
    } else {
	warn("Using\ generic\ TUXAPI\ locks\ \-\ not\ SMP\ safe");
	eval 'sub barrier () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&barrier);
	eval 'sub test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &oldbit;  &volatile my $long * &foo;  &foo = $addr;  &oldbit = (* &foo >> $nr) & 1; * &foo = * &foo | (1<<$nr);  &oldbit; });
	}' unless defined(&test_and_set_bit);
	eval 'sub TUXAPI_down {
	    my($sem) = @_;
    	    eval q({  &while ( &test_and_set_bit(0, $sem))  &barrier(); });
	}' unless defined(&TUXAPI_down);
	eval 'sub TUXAPI_up {
	    my($sem) = @_;
    	    eval q({ *(( &volatile \'int\' *)$sem) = 0; });
	}' unless defined(&TUXAPI_up);
    }
    eval 'sub TUX_DEBUG () {0;}' unless defined(&TUX_DEBUG);
    if((defined(&TUX_DEBUG) ? &TUX_DEBUG : 0)) {
	eval 'sub Dprintk () {( &x...)  &do {  &printf( &x);  &fflush( &stdout); }  &while (0);}' unless defined(&Dprintk);
    } else {
	eval 'sub Dprintk () {( &x...)  &do { }  &while (0);}' unless defined(&Dprintk);
    }
    eval 'sub HTTP_TRACE {
        my($req,$info) = @_;
	    eval q( &Dprintk(\\"HTTP trace at %s:%d, request %p, info %d, event %d (meth:%d, query:%s, cookies:%s).\\\\n\\",  &__FILE__,  &__LINE__, ($req)-> &id, $info, ($req)-> &event, ($req)-> &http_method, ($req)-> &query, ($req)-> &cookies_len ? ($req)-> &cookies : \\"<no cookies>\\"));
    }' unless defined(&HTTP_TRACE);
}
1;
