require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&XKM_H)) {
    eval 'sub XKM_H () {1;}' unless defined(&XKM_H);
    eval 'sub XkmFileVersion () {15;}' unless defined(&XkmFileVersion);
    eval 'sub XkmIllegalFile () {-1;}' unless defined(&XkmIllegalFile);
    eval 'sub XkmSemanticsFile () {20;}' unless defined(&XkmSemanticsFile);
    eval 'sub XkmLayoutFile () {21;}' unless defined(&XkmLayoutFile);
    eval 'sub XkmKeymapFile () {22;}' unless defined(&XkmKeymapFile);
    eval 'sub XkmGeometryFile () {23;}' unless defined(&XkmGeometryFile);
    eval 'sub XkmTypesIndex () {0;}' unless defined(&XkmTypesIndex);
    eval 'sub XkmCompatMapIndex () {1;}' unless defined(&XkmCompatMapIndex);
    eval 'sub XkmSymbolsIndex () {2;}' unless defined(&XkmSymbolsIndex);
    eval 'sub XkmIndicatorsIndex () {3;}' unless defined(&XkmIndicatorsIndex);
    eval 'sub XkmKeyNamesIndex () {4;}' unless defined(&XkmKeyNamesIndex);
    eval 'sub XkmGeometryIndex () {5;}' unless defined(&XkmGeometryIndex);
    eval 'sub XkmVirtualModsIndex () {6;}' unless defined(&XkmVirtualModsIndex);
    eval 'sub XkmLastIndex () { &XkmVirtualModsIndex;}' unless defined(&XkmLastIndex);
    eval 'sub XkmTypesMask () {(1<<0);}' unless defined(&XkmTypesMask);
    eval 'sub XkmCompatMapMask () {(1<<1);}' unless defined(&XkmCompatMapMask);
    eval 'sub XkmSymbolsMask () {(1<<2);}' unless defined(&XkmSymbolsMask);
    eval 'sub XkmIndicatorsMask () {(1<<3);}' unless defined(&XkmIndicatorsMask);
    eval 'sub XkmKeyNamesMask () {(1<<4);}' unless defined(&XkmKeyNamesMask);
    eval 'sub XkmGeometryMask () {(1<<5);}' unless defined(&XkmGeometryMask);
    eval 'sub XkmVirtualModsMask () {(1<<6);}' unless defined(&XkmVirtualModsMask);
    eval 'sub XkmLegalIndexMask () {(0x7f);}' unless defined(&XkmLegalIndexMask);
    eval 'sub XkmAllIndicesMask () {(0x7f);}' unless defined(&XkmAllIndicesMask);
    eval 'sub XkmSemanticsRequired () {( &XkmCompatMapMask);}' unless defined(&XkmSemanticsRequired);
    eval 'sub XkmSemanticsOptional () {( &XkmTypesMask| &XkmVirtualModsMask| &XkmIndicatorsMask);}' unless defined(&XkmSemanticsOptional);
    eval 'sub XkmSemanticsLegal () {( &XkmSemanticsRequired| &XkmSemanticsOptional);}' unless defined(&XkmSemanticsLegal);
    eval 'sub XkmLayoutRequired () {( &XkmKeyNamesMask| &XkmSymbolsMask| &XkmTypesMask);}' unless defined(&XkmLayoutRequired);
    eval 'sub XkmLayoutOptional () {( &XkmVirtualModsMask| &XkmGeometryMask);}' unless defined(&XkmLayoutOptional);
    eval 'sub XkmLayoutLegal () {( &XkmLayoutRequired| &XkmLayoutOptional);}' unless defined(&XkmLayoutLegal);
    eval 'sub XkmKeymapRequired () {( &XkmSemanticsRequired| &XkmLayoutRequired);}' unless defined(&XkmKeymapRequired);
    eval 'sub XkmKeymapOptional () {(( &XkmSemanticsOptional| &XkmLayoutOptional)(~ &XkmKeymapRequired));}' unless defined(&XkmKeymapOptional);
    eval 'sub XkmKeymapLegal () {( &XkmKeymapRequired| &XkmKeymapOptional);}' unless defined(&XkmKeymapLegal);
    eval 'sub XkmLegalSection {
        my($m) = @_;
	    eval q(((($m)(~ &XkmKeymapLegal))==0));
    }' unless defined(&XkmLegalSection);
    eval 'sub XkmSingleSection {
        my($m) = @_;
	    eval q(( &XkmLegalSection($m) &&((($m)(~($m)+1))==($m))));
    }' unless defined(&XkmSingleSection);
}
1;
