require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&MAX_ENTITY_SIZE)) {
    sub MAX_ENTITY_SIZE () {	17;}
}
unless(defined(&MAX_NODE)) {
    sub MAX_NODE () {	4096;}
}
unless(defined(&NODE)) {
    sub NODE () {	0;}
}
unless(defined(&LINE)) {
    sub LINE () {	1;}
}
unless(defined(&LOGGING)) {
    sub LOGGING () {	2;}
}
unless(defined(&CIRCUIT)) {
    sub CIRCUIT () {	3;}
}
unless(defined(&MODULE)) {
    sub MODULE () {	4;}
}
unless(defined(&AREA)) {
    sub AREA () {	5;}
}
unless(defined(&EXEC)) {
    sub EXEC () {	6;}
}
unless(defined(&LINK)) {
    sub LINK () {	7;}
}
unless(defined(&NM_STATE_ON)) {
    sub NM_STATE_ON () {	0;}
}
unless(defined(&NM_STATE_OFF)) {
    sub NM_STATE_OFF () {	1;}
}
unless(defined(&NM_STATE_SHUT)) {
    sub NM_STATE_SHUT () {	2;}
}
unless(defined(&NM_STATE_RESTRICTED)) {
    sub NM_STATE_RESTRICTED () {	3;}
}
unless(defined(&NM_STATE_REACHABLE)) {
    sub NM_STATE_REACHABLE () {	4;}
}
unless(defined(&NM_STATE_UNREACHABLE)) {
    sub NM_STATE_UNREACHABLE () {	5;}
}
unless(defined(&NM_ROUTING_III)) {
    sub NM_ROUTING_III () {	0;}
}
unless(defined(&NM_NONROUTING_III)) {
    sub NM_NONROUTING_III () {	1;}
}
unless(defined(&NM_AREA)) {
    sub NM_AREA () {	3;}
}
unless(defined(&NM_ROUTING_IV)) {
    sub NM_ROUTING_IV () {	4;}
}
unless(defined(&NM_NONROUTING_IV)) {
    sub NM_NONROUTING_IV () {	5;}
}
unless(defined(&NM_DDCMP_POINT)) {
    sub NM_DDCMP_POINT () {	0;}
}
unless(defined(&NM_ETHERNET_CIRCUIT)) {
    sub NM_ETHERNET_CIRCUIT () {	6;}
}
unless(defined(&NM_NSP_VER_LEN)) {
    sub NM_NSP_VER_LEN () {	0x6;}
}
unless(defined(&NM_NSP_FLD_LEN)) {
    sub NM_NSP_FLD_LEN () {	0x1;}
}
unless(defined(&NM_NSP_VER)) {
    sub NM_NSP_VER () {	0x4;}
}
unless(defined(&NM_NSP_ECO)) {
    sub NM_NSP_ECO () {	0x;}
}
unless(defined(&NM_NSP_USER_ECO)) {
    sub NM_NSP_USER_ECO () {	0x;}
}
unless(defined(&NM_SUCCESS)) {
    sub NM_SUCCESS () {	0x1;}
}
unless(defined(&NM_VERSION_GOOD)) {
    sub NM_VERSION_GOOD () {	 &NM_SUCCESS;}
}
unless(defined(&NM_UNREC_FUNC_OP)) {
    sub NM_UNREC_FUNC_OP () {	0xff;}
}
unless(defined(&NM_INVAL_MSG_FMT)) {
    sub NM_INVAL_MSG_FMT () {	0xfe;}
}
unless(defined(&NM_PRIV_VIOL)) {
    sub NM_PRIV_VIOL () {	0xfd;}
}
unless(defined(&NM_OVRSZD_MGMT_CMD)) {
    sub NM_OVRSZD_MGMT_CMD () {	0xfc;}
}
unless(defined(&NM_MGMT_PGM_ERR)) {
    sub NM_MGMT_PGM_ERR () {	0xfb;}
}
unless(defined(&NM_LOGIC_ERROR)) {
    sub NM_LOGIC_ERROR () {	 &NM_MGMT_PGM_ERR;}
}
unless(defined(&NM_UNREC_PARM_TYPE)) {
    sub NM_UNREC_PARM_TYPE () {	0xfa;}
}
unless(defined(&NM_INCOMP_MGMT_VER)) {
    sub NM_INCOMP_MGMT_VER () {	0xf9;}
}
unless(defined(&NM_VERSION_SKEW)) {
    sub NM_VERSION_SKEW () {	 &NM_INCOMP_MGMT_VER;}
}
unless(defined(&NM_UNRECOG_COMP)) {
    sub NM_UNRECOG_COMP () {	0xf8;}
}
unless(defined(&NM_RECORD_NOT_FOUND)) {
    sub NM_RECORD_NOT_FOUND () {	 &NM_UNRECOG_COMP;}
}
unless(defined(&NM_INVAL_ID)) {
    sub NM_INVAL_ID () {	0xf7;}
}
unless(defined(&NM_LINE_COMM_ERR)) {
    sub NM_LINE_COMM_ERR () {	0xf6;}
}
unless(defined(&NM_COMP_IN_WRNG_ST)) {
    sub NM_COMP_IN_WRNG_ST () {	0xf5;}
}
unless(defined(&NM_FILE_OPEN_ERROR)) {
    sub NM_FILE_OPEN_ERROR () {	0xf3;}
}
unless(defined(&NM_INVAL_FILE_CONT)) {
    sub NM_INVAL_FILE_CONT () {	0xf2;}
}
unless(defined(&NM_RESOURCE_ERROR)) {
    sub NM_RESOURCE_ERROR () {	0xf1;}
}
unless(defined(&NM_INVAL_PARM_VALUE)) {
    sub NM_INVAL_PARM_VALUE () {	0xf0;}
}
unless(defined(&NM_DUPLICATE_RECORD)) {
    sub NM_DUPLICATE_RECORD () {	 &NM_INVAL_PARM_VALUE;}
}
unless(defined(&NM_DUP_NODE_NUM)) {
    sub NM_DUP_NODE_NUM () {	 &NM_INVAL_PARM_VALUE;}
}
unless(defined(&NM_DUP_NODE_NAME)) {
    sub NM_DUP_NODE_NAME () {	 &NM_INVAL_PARM_VALUE;}
}
unless(defined(&NM_LINE_PROT_ERROR)) {
    sub NM_LINE_PROT_ERROR () {	0xef;}
}
unless(defined(&NM_FILE_IO_ERROR)) {
    sub NM_FILE_IO_ERROR () {	0xee;}
}
unless(defined(&NM_REC_RD_FAILED)) {
    sub NM_REC_RD_FAILED () {	 &NM_FILE_IO_ERROR;}
}
unless(defined(&NM_REC_WR_FAILED)) {
    sub NM_REC_WR_FAILED () {	 &NM_FILE_IO_ERROR;}
}
unless(defined(&NM_VER_WRITE_FAILED)) {
    sub NM_VER_WRITE_FAILED () {	 &NM_FILE_IO_ERROR;}
}
unless(defined(&NM_VER_READ_FAILED)) {
    sub NM_VER_READ_FAILED () {	 &NM_FILE_IO_ERROR;}
}
unless(defined(&NM_FSEEK_ERROR)) {
    sub NM_FSEEK_ERROR () {	 &NM_FILE_IO_ERROR;}
}
unless(defined(&NM_CLOSE_ERR)) {
    sub NM_CLOSE_ERR () {	 &NM_FILE_IO_ERROR;}
}
unless(defined(&NM_IOCTL_ERROR)) {
    sub NM_IOCTL_ERROR () {	 &NM_FILE_IO_ERROR;}
}
unless(defined(&NM_MIRROR_LINK_DIS)) {
    sub NM_MIRROR_LINK_DIS () {	0xed;}
}
unless(defined(&NM_OUT_OF_SPACE)) {
    sub NM_OUT_OF_SPACE () {	0xec;}
}
unless(defined(&NM_ALLOC_FAIL)) {
    sub NM_ALLOC_FAIL () {	 &NM_OUT_OF_SPACE;}
}
unless(defined(&NM_MIRROR_CONN_FAIL)) {
    sub NM_MIRROR_CONN_FAIL () {	0xeb;}
}
unless(defined(&NM_PARM_NOT_APPLIC)) {
    sub NM_PARM_NOT_APPLIC () {	0xea;}
}
unless(defined(&NM_PARM_VAL_LONG)) {
    sub NM_PARM_VAL_LONG () {	0xe9;}
}
unless(defined(&NM_HARDWARE_FAILURE)) {
    sub NM_HARDWARE_FAILURE () {	0xe8;}
}
unless(defined(&NM_SYS_SPEC_FUNC_NS)) {
    sub NM_SYS_SPEC_FUNC_NS () {	0xe6;}
}
unless(defined(&NM_INV_PARM_GRPING)) {
    sub NM_INV_PARM_GRPING () {	0xe5;}
}
unless(defined(&NM_BAD_LOOP_RESP)) {
    sub NM_BAD_LOOP_RESP () {	0xe4;}
}
unless(defined(&NM_PARM_MISSING)) {
    sub NM_PARM_MISSING () {	0xe3;}
}
unless(defined(&NM_DONE)) {
    sub NM_DONE () {	0x80;}
}
unless(defined(&MAX_CIRCUITS)) {
    sub MAX_CIRCUITS () {	1;}
}
unless(defined(&MAX_LINES)) {
    sub MAX_LINES () {	1;}
}
unless(defined(&NMARS_DNI_SET_ADDRESS)) {
    sub NMARS_DNI_SET_ADDRESS () {	 &_IOW("M", 101, 'int');}
}
unless(defined(&NMARS_READ_SNT)) {
    sub NMARS_READ_SNT () {	 &_IOWR("M", 102,  &M_Snt);}
}
unless(defined(&NMARS_READ_NLN)) {
    sub NMARS_READ_NLN () {	 &_IOWR("M", 103,  &M_Nln);}
}
unless(defined(&NMARS_READ_NRN)) {
    sub NMARS_READ_NRN () {	 &_IOWR("M", 104,  &M_Nrn);}
}
unless(defined(&NMARS_READ_DRB)) {
    sub NMARS_READ_DRB () {	 &_IOWR("M", 105,  &M_Drb);}
}
unless(defined(&NMARS_READ_CST)) {
    sub NMARS_READ_CST () {	 &_IOWR("M", 106,  &M_Cst);}
}
unless(defined(&NMARS_WRITE_SNT)) {
    sub NMARS_WRITE_SNT () {	 &_IOWR("M", 107,  &M_Snt);}
}
unless(defined(&NMARS_WRITE_NLN)) {
    sub NMARS_WRITE_NLN () {	 &_IOWR("M", 108,  &M_Nln);}
}
unless(defined(&NMARS_WRITE_NRN)) {
    sub NMARS_WRITE_NRN () {	 &_IOWR("M", 109,  &M_Nrn);}
}
unless(defined(&NMARS_WRITE_DRB)) {
    sub NMARS_WRITE_DRB () {	 &_IOWR("M", 110,  &M_Drb);}
}
unless(defined(&NMARS_WRITE_CST)) {
    sub NMARS_WRITE_CST () {	 &_IOWR("M", 111,  &M_Cst);}
}
unless(defined(&NMARS_SNT_CREATE)) {
    sub NMARS_SNT_CREATE () {	 &_IOWR("M", 112,  &M_Com);}
}
unless(defined(&NMARS_SNT_DELETE)) {
    sub NMARS_SNT_DELETE () {	 &_IOWR("M", 113,  &M_Com);}
}
unless(defined(&NMARS_CLEAR_SNT)) {
    sub NMARS_CLEAR_SNT () {	 &_IOWR("M", 114,  &M_Com);}
}
unless(defined(&NMARS_CLEAR_NRN)) {
    sub NMARS_CLEAR_NRN () {	 &_IOWR("M", 115,  &M_Com);}
}
unless(defined(&NMARS_READ_VER)) {
    sub NMARS_READ_VER () {	 &_IOWR("M", 116,  &M_Com);}
}
unless(defined(&NMARS_READ_SNT_NRN)) {
    sub NMARS_READ_SNT_NRN () {	 &_IOWR("M", 117,  &M_Snt_Nrn);}
}
unless(defined(&NMARS_READ_LN_SNT)) {
    sub NMARS_READ_LN_SNT () {	 &_IOWR("M", 118,  &M_LN_Snt);}
}
unless(defined(&NMARS_DNI_ON)) {
    sub NMARS_DNI_ON () {	 &_IOWR("M", 119,  &M_Com);}
}
unless(defined(&NMARS_DNI_OFF)) {
    sub NMARS_DNI_OFF () {	 &_IOWR("M", 120,  &M_Com);}
}
unless(defined(&NMARS_CHECK_INIT)) {
    sub NMARS_CHECK_INIT () {	 &_IOWR("M", 121, 'short');}
}
unless(defined(&NMARS_READ_NODE)) {
    sub NMARS_READ_NODE () {	 &_IOWR("M", 122,  &M_Node);}
}
unless(defined(&NMARS_WRITE_NODE)) {
    sub NMARS_WRITE_NODE () {	 &_IOWR("M", 123,  &M_Node);}
}
unless(defined(&NMARS_READ_LINE)) {
    sub NMARS_READ_LINE () {	 &_IOWR("M", 124,  &M_Line);}
}
unless(defined(&NMARS_WRITE_LINE)) {
    sub NMARS_WRITE_LINE () {	 &_IOWR("M", 125,  &M_Line);}
}
unless(defined(&NMARS_READ_CIRCUIT)) {
    sub NMARS_READ_CIRCUIT () {	 &_IOWR("M", 126,  &M_Circuit);}
}
unless(defined(&NMARS_WRITE_CIRCUIT)) {
    sub NMARS_WRITE_CIRCUIT () {	 &_IOWR("M", 127,  &M_Circuit);}
}
1;
