require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XmCascadeBGP_h)) {
    eval 'sub _XmCascadeBGP_h () {1;}' unless defined(&_XmCascadeBGP_h);
    unless(defined(&MOTIF12_HEADERS)) {
	require 'Xm/CascadeBG.ph';
	require 'Xm/LabelGP.ph';
	if(defined(&__cplusplus)) {
	}
	eval 'sub CBG_Submenu {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{submenu})));
	}' unless defined(&CBG_Submenu);
	eval 'sub CBG_ActivateCall {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{activate_callback})));
	}' unless defined(&CBG_ActivateCall);
	eval 'sub CBG_CascadeCall {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_callback})));
	}' unless defined(&CBG_CascadeCall);
	eval 'sub CBG_Armed {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{armed})));
	}' unless defined(&CBG_Armed);
	eval 'sub CBG_CascadeRect {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect})));
	}' unless defined(&CBG_CascadeRect);
	eval 'sub CBG_Timer {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{timer})));
	}' unless defined(&CBG_Timer);
	eval 'sub CBG_Cascade_x {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect}->{x})));
	}' unless defined(&CBG_Cascade_x);
	eval 'sub CBG_Cascade_y {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect}->{y})));
	}' unless defined(&CBG_Cascade_y);
	eval 'sub CBG_Cascade_width {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect}->{width})));
	}' unless defined(&CBG_Cascade_width);
	eval 'sub CBG_Cascade_height {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect}->{height})));
	}' unless defined(&CBG_Cascade_height);
	eval 'sub CBG_HasCascade {
	    my($cb) = @_;
    	    eval q(((( &LabG_MenuType($cb) ==  &XmMENU_PULLDOWN) || ( &LabG_MenuType($cb) ==  &XmMENU_POPUP) || ( &LabG_MenuType($cb) ==  &XmMENU_OPTION))  && ( &CBG_Submenu($cb))));
	}' unless defined(&CBG_HasCascade);
	eval 'sub XmCBG_ARMED_BIT () {(1<< 0);}' unless defined(&XmCBG_ARMED_BIT);
	eval 'sub XmCBG_TRAVERSE_BIT () {(1<< 1);}' unless defined(&XmCBG_TRAVERSE_BIT);
	eval 'sub XmCBG_WAS_POSTED_BIT () {(1<< 2);}' unless defined(&XmCBG_WAS_POSTED_BIT);
	eval 'sub CBG_IsArmed {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget)($cb))-> ($cascade_button->{armed})  &  &XmCBG_ARMED_BIT));
	}' unless defined(&CBG_IsArmed);
	eval 'sub CBG_Traversing {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) ($cb))-> ($cascade_button->{armed}) &  &XmCBG_TRAVERSE_BIT));
	}' unless defined(&CBG_Traversing);
	eval 'sub CBG_WasPosted {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) ($cb))-> ($cascade_button->{armed}) &  &XmCBG_WAS_POSTED_BIT));
	}' unless defined(&CBG_WasPosted);
	eval 'sub CBG_SetBit {
	    my($byte,$bit,$v) = @_;
    	    eval q($byte = ($byte & (~$bit)) | ($v ? $bit : 0));
	}' unless defined(&CBG_SetBit);
	eval 'sub CBG_SetArmed {
	    my($cb,$v) = @_;
    	    eval q( &CBG_SetBit ((( &XmCascadeButtonGadget) ($cb))-> ($cascade_button->{armed}),  &XmCBG_ARMED_BIT, $v));
	}' unless defined(&CBG_SetArmed);
	eval 'sub CBG_SetTraverse {
	    my($cb,$v) = @_;
    	    eval q( &CBG_SetBit ((( &XmCascadeButtonGadget) ($cb))-> ($cascade_button->{armed}),  &XmCBG_TRAVERSE_BIT, $v));
	}' unless defined(&CBG_SetTraverse);
	eval 'sub CBG_SetWasPosted {
	    my($cb,$v) = @_;
    	    eval q( &CBG_SetBit ((( &XmCascadeButtonGadget) ($cb))-> ($cascade_button->{armed}),  &XmCBG_WAS_POSTED_BIT, $v));
	}' unless defined(&CBG_SetWasPosted);
	eval 'sub CBG_CascadePixmap {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cache}->{cascade_pixmap})));
	}' unless defined(&CBG_CascadePixmap);
	eval 'sub CBG_MapDelay {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cache}->{map_delay})));
	}' unless defined(&CBG_MapDelay);
	eval 'sub CBG_ArmedPixmap {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cache}->{armed_pixmap})));
	}' unless defined(&CBG_ArmedPixmap);
	eval 'sub CBG_ArmGC {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cache}->{arm_gc})));
	}' unless defined(&CBG_ArmGC);
	eval 'sub CBG_BackgroundGC {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cache}->{background_gc})));
	}' unless defined(&CBG_BackgroundGC);
	eval 'sub CBG_Cache {
	    my($w) = @_;
    	    eval q(((( &XmCascadeButtonGadget)($w))->  ($cascade_button->{cache})));
	}' unless defined(&CBG_Cache);
	eval 'sub CBG_ClassCachePart {
	    my($w) = @_;
    	    eval q(((( &XmCascadeButtonGadgetClass) &xmCascadeButtonGadgetClass)-> ($gadget_class->{cache_part})));
	}' unless defined(&CBG_ClassCachePart);
	if(defined(&__cplusplus)) {
	}
    } else {
	require 'Xm/CascadeBG.ph';
	require 'Xm/LabelGP.ph';
	if(defined(&__cplusplus)) {
	}
	eval 'sub CBG_Submenu {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{submenu})));
	}' unless defined(&CBG_Submenu);
	eval 'sub CBG_ActivateCall {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{activate_callback})));
	}' unless defined(&CBG_ActivateCall);
	eval 'sub CBG_CascadeCall {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_callback})));
	}' unless defined(&CBG_CascadeCall);
	eval 'sub CBG_Armed {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{armed})));
	}' unless defined(&CBG_Armed);
	eval 'sub CBG_CascadeRect {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect})));
	}' unless defined(&CBG_CascadeRect);
	eval 'sub CBG_Timer {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{timer})));
	}' unless defined(&CBG_Timer);
	eval 'sub CBG_Cascade_x {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect}->{x})));
	}' unless defined(&CBG_Cascade_x);
	eval 'sub CBG_Cascade_y {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect}->{y})));
	}' unless defined(&CBG_Cascade_y);
	eval 'sub CBG_Cascade_width {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect}->{width})));
	}' unless defined(&CBG_Cascade_width);
	eval 'sub CBG_Cascade_height {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cascade_rect}->{height})));
	}' unless defined(&CBG_Cascade_height);
	eval 'sub CBG_HasCascade {
	    my($cb) = @_;
    	    eval q(((( &LabG_MenuType($cb) ==  &XmMENU_PULLDOWN) || ( &LabG_MenuType($cb) ==  &XmMENU_POPUP) || ( &LabG_MenuType($cb) ==  &XmMENU_OPTION))  && ( &CBG_Submenu($cb))));
	}' unless defined(&CBG_HasCascade);
	eval 'sub XmCBG_ARMED_BIT () {(1<< 0);}' unless defined(&XmCBG_ARMED_BIT);
	eval 'sub XmCBG_TRAVERSE_BIT () {(1<< 1);}' unless defined(&XmCBG_TRAVERSE_BIT);
	eval 'sub CBG_IsArmed {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget)($cb))-> ($cascade_button->{armed})  &  &XmCB_ARMED_BIT));
	}' unless defined(&CBG_IsArmed);
	eval 'sub CBG_Traversing {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) ($cb))-> ($cascade_button->{armed}) &  &XmCBG_TRAVERSE_BIT));
	}' unless defined(&CBG_Traversing);
	eval 'sub CBG_SetBit {
	    my($byte,$bit,$v) = @_;
    	    eval q($byte = ($byte & (~$bit)) | ($v ? $bit : 0));
	}' unless defined(&CBG_SetBit);
	eval 'sub CBG_SetArmed {
	    my($cb,$v) = @_;
    	    eval q( &CBG_SetBit ((( &XmCascadeButtonGadget) ($cb))-> ($cascade_button->{armed}),  &XmCBG_ARMED_BIT, $v));
	}' unless defined(&CBG_SetArmed);
	eval 'sub CBG_SetTraverse {
	    my($cb,$v) = @_;
    	    eval q( &CBG_SetBit ((( &XmCascadeButtonGadget) ($cb))-> ($cascade_button->{armed}),  &XmCBG_TRAVERSE_BIT, $v));
	}' unless defined(&CBG_SetTraverse);
	eval 'sub CBG_CascadePixmap {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cache}->{cascade_pixmap})));
	}' unless defined(&CBG_CascadePixmap);
	eval 'sub CBG_MapDelay {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cache}->{map_delay})));
	}' unless defined(&CBG_MapDelay);
	eval 'sub CBG_ArmedPixmap {
	    my($cb) = @_;
    	    eval q(((( &XmCascadeButtonGadget) $cb)-> ($cascade_button->{cache}->{armed_pixmap})));
	}' unless defined(&CBG_ArmedPixmap);
	eval 'sub CBG_Cache {
	    my($w) = @_;
    	    eval q(((( &XmCascadeButtonGadget)($w))->  ($cascade_button->{cache})));
	}' unless defined(&CBG_Cache);
	eval 'sub CBG_ClassCachePart {
	    my($w) = @_;
    	    eval q(((( &XmCascadeButtonGadgetClass) &xmCascadeButtonGadgetClass)-> ($gadget_class->{cache_part})));
	}' unless defined(&CBG_ClassCachePart);
	if(defined(&_NO_PROTO)) {
	} else {
	}
	if(defined(&__cplusplus)) {
	}
    }
}
1;
