require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ColorObj_h)) {
    eval 'sub _ColorObj_h () {1;}' unless defined(&_ColorObj_h);
    unless(defined(&MOTIF12_HEADERS)) {
	require 'Xm/Xm.ph';
	require 'Xm/ColorObjP.ph';
	eval 'sub PixelSet () { &XmPixelSet;}' unless defined(&PixelSet);
	eval 'sub _ColorObjClassRec () { &_XmColorObjClassRec;}' unless defined(&_ColorObjClassRec);
	eval 'sub _ColorObjRec () { &_XmColorObjRec;}' unless defined(&_ColorObjRec);
	eval 'sub _xmColorObjClass () { &xmColorObjClass;}' unless defined(&_xmColorObjClass);
	if(defined( &__cplusplus) || defined( &c_plusplus)) {
	}
	eval 'sub DitherTopShadow {
	    my($display, $screen, $pixelSet) = @_;
    	    eval q((($pixelSet)-> &bs ==  &BlackPixel(($display), ($screen))));
	}' unless defined(&DitherTopShadow);
	eval 'sub DitherBottomShadow {
	    my($display, $screen, $pixelSet) = @_;
    	    eval q((($pixelSet)-> &ts ==  &WhitePixel(($display), ($screen))));
	}' unless defined(&DitherBottomShadow);
	eval 'sub DITHER () { &XmCO_DITHER;}' unless defined(&DITHER);
	eval 'sub NO_DITHER () { &XmCO_NO_DITHER;}' unless defined(&NO_DITHER);
	eval 'sub B_W () {0;}' unless defined(&B_W);
	eval 'sub LOW_COLOR () {1;}' unless defined(&LOW_COLOR);
	eval 'sub MEDIUM_COLOR () {2;}' unless defined(&MEDIUM_COLOR);
	eval 'sub HIGH_COLOR () {3;}' unless defined(&HIGH_COLOR);
	eval 'sub COLOR_SRV_NAME () {"ColorServer";}' unless defined(&COLOR_SRV_NAME);
	eval 'sub VALUE_THRESHOLD () {225;}' unless defined(&VALUE_THRESHOLD);
	eval 'sub PIXEL_SET () {"Pixel Sets";}' unless defined(&PIXEL_SET);
	if(defined(&SUN_SDT_COLOR_OBJECT_CACHE)) {
	    eval 'sub _SUN_SDT_COLOR_OBJECT_CACHE () {"SDT Pixel Set";}' unless defined(&_SUN_SDT_COLOR_OBJECT_CACHE);
	    eval 'sub SUN_SDT_COLOR_OBJECT_VERSION () {ord(\'1\');}' unless defined(&SUN_SDT_COLOR_OBJECT_VERSION);
	}
	eval 'sub PALETTE_NAME () {"DefaultPalette Name";}' unless defined(&PALETTE_NAME);
	eval 'sub TYPE_OF_MONITOR () {"Type Of Monitor";}' unless defined(&TYPE_OF_MONITOR);
	eval 'sub UPDATE_FILE () {"Update Default File";}' unless defined(&UPDATE_FILE);
	eval 'sub CUST_DATA () {"Customize Data:";}' unless defined(&CUST_DATA);
	eval 'sub MAX_NUM_COLORS () { &XmCO_MAX_NUM_COLORS;}' unless defined(&MAX_NUM_COLORS);
	eval 'sub NUM_COLORS () { &XmCO_NUM_COLORS;}' unless defined(&NUM_COLORS);
	if(defined( &__cplusplus) || defined( &c_plusplus)) {
	}
    } else {
	require 'Xm/Xm.ph';
	if(defined( &__cplusplus) || defined( &c_plusplus)) {
	}
	eval 'sub XmNprimaryColorSetId () {"primaryColorSetId";}' unless defined(&XmNprimaryColorSetId);
	eval 'sub XmCPrimaryColorSetId () {"PrimaryColorSetId";}' unless defined(&XmCPrimaryColorSetId);
	eval 'sub XmNsecondaryColorSetId () {"secondaryColorSetId";}' unless defined(&XmNsecondaryColorSetId);
	eval 'sub XmCSecondaryColorSetId () {"SecondaryColorSetId";}' unless defined(&XmCSecondaryColorSetId);
	eval 'sub XmNactiveColorSetId () {"activeColorSetId";}' unless defined(&XmNactiveColorSetId);
	eval 'sub XmCActiveColorSetId () {"ActiveColorSetId";}' unless defined(&XmCActiveColorSetId);
	eval 'sub XmNinactiveColorSetId () {"inactiveColorSetId";}' unless defined(&XmNinactiveColorSetId);
	eval 'sub XmCInactiveColorSetId () {"InactiveColorSetId";}' unless defined(&XmCInactiveColorSetId);
	eval 'sub XmNuseColorObj () {"useColorObj";}' unless defined(&XmNuseColorObj);
	eval 'sub XmCUseColorObj () {"UseColorObj";}' unless defined(&XmCUseColorObj);
	eval 'sub XmNtextColorSetId () {"textColorSetId";}' unless defined(&XmNtextColorSetId);
	eval 'sub XmCTextColorSetId () {"TextColorSetId";}' unless defined(&XmCTextColorSetId);
	eval 'sub XmNuseTextColor () {"useTextColor";}' unless defined(&XmNuseTextColor);
	eval 'sub XmCUseTextColor () {"UseTextColor";}' unless defined(&XmCUseTextColor);
	eval 'sub XmNuseTextColorForList () {"useTextColorForList";}' unless defined(&XmNuseTextColorForList);
	eval 'sub XmCUseTextColorForList () {"UseTextColorForList";}' unless defined(&XmCUseTextColorForList);
	eval 'sub XmNuseMask () {"useMask";}' unless defined(&XmNuseMask);
	eval 'sub XmCUseMask () {"UseMask";}' unless defined(&XmCUseMask);
	eval 'sub XmNuseMultiColorIcons () {"useMultiColorIcons";}' unless defined(&XmNuseMultiColorIcons);
	eval 'sub XmCUseMultiColorIcons () {"UseMultiColorIcons";}' unless defined(&XmCUseMultiColorIcons);
	eval 'sub DitherTopShadow {
	    my($display, $screen, $pixelSet) = @_;
    	    eval q((($pixelSet)-> &bs ==  &BlackPixel(($display), ($screen))));
	}' unless defined(&DitherTopShadow);
	eval 'sub DitherBottomShadow {
	    my($display, $screen, $pixelSet) = @_;
    	    eval q((($pixelSet)-> &ts ==  &WhitePixel(($display), ($screen))));
	}' unless defined(&DitherBottomShadow);
	eval 'sub DITHER () {"50_foreground";}' unless defined(&DITHER);
	eval 'sub NO_DITHER () {"unspecified_pixmap";}' unless defined(&NO_DITHER);
	eval 'sub B_W () {0;}' unless defined(&B_W);
	eval 'sub LOW_COLOR () {1;}' unless defined(&LOW_COLOR);
	eval 'sub MEDIUM_COLOR () {2;}' unless defined(&MEDIUM_COLOR);
	eval 'sub HIGH_COLOR () {3;}' unless defined(&HIGH_COLOR);
	eval 'sub COLOR_SRV_NAME () {"ColorServer";}' unless defined(&COLOR_SRV_NAME);
	eval 'sub VALUE_THRESHOLD () {225;}' unless defined(&VALUE_THRESHOLD);
	eval 'sub PIXEL_SET () {"Pixel Sets";}' unless defined(&PIXEL_SET);
	if(defined(&SUN_SDT_COLOR_OBJECT_CACHE)) {
	    eval 'sub _SUN_SDT_COLOR_OBJECT_CACHE () {"SDT Pixel Set";}' unless defined(&_SUN_SDT_COLOR_OBJECT_CACHE);
	    eval 'sub SUN_SDT_COLOR_OBJECT_VERSION () {ord(\'1\');}' unless defined(&SUN_SDT_COLOR_OBJECT_VERSION);
	}
	eval 'sub PALETTE_NAME () {"DefaultPalette Name";}' unless defined(&PALETTE_NAME);
	eval 'sub TYPE_OF_MONITOR () {"Type Of Monitor";}' unless defined(&TYPE_OF_MONITOR);
	eval 'sub UPDATE_FILE () {"Update Default File";}' unless defined(&UPDATE_FILE);
	eval 'sub CUST_DATA () {"Customize Data:";}' unless defined(&CUST_DATA);
	eval 'sub MAX_NUM_COLORS () {8;}' unless defined(&MAX_NUM_COLORS);
	eval 'sub NUM_COLORS () { &MAX_NUM_COLORS;}' unless defined(&NUM_COLORS);
	if(defined( &__cplusplus) || defined( &c_plusplus)) {
	}
    }
}
1;
