require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XpmI_h)) {
    eval 'sub _XpmI_h () {1;}' unless defined(&_XpmI_h);
    eval 'sub xpmParseData () { &_Xmxpm21ParseData;}' unless defined(&xpmParseData);
    eval 'sub xpmParseDataAndCreate () { &_XmxpmParseDataAndCreate;}' unless defined(&xpmParseDataAndCreate);
    eval 'sub xpmFreeColorTable () { &_Xmxpm21FreeColorTable;}' unless defined(&xpmFreeColorTable);
    eval 'sub xpmInitAttributes () { &_XmxpmInitAttributes;}' unless defined(&xpmInitAttributes);
    eval 'sub xpmInitXpmImage () { &_XmxpmInitXpmImage;}' unless defined(&xpmInitXpmImage);
    eval 'sub xpmInitXpmInfo () { &_XmxpmInitXpmInfo;}' unless defined(&xpmInitXpmInfo);
    eval 'sub xpmSetInfoMask () { &_XmxpmSetInfoMask;}' unless defined(&xpmSetInfoMask);
    eval 'sub xpmSetInfo () { &_XmxpmSetInfo;}' unless defined(&xpmSetInfo);
    eval 'sub xpmSetAttributes () { &_Xmxpm21SetAttributes;}' unless defined(&xpmSetAttributes);
    eval 'sub xpmCreatePixmapFromImage () { &_XmxpmCreatePixmapFromImage;}' unless defined(&xpmCreatePixmapFromImage);
    eval 'sub xpmCreateImageFromPixmap () { &_XmxpmCreateImageFromPixmap;}' unless defined(&xpmCreateImageFromPixmap);
    eval 'sub xpmHashTableInit () { &_XmxpmHashTableInit;}' unless defined(&xpmHashTableInit);
    eval 'sub xpmHashTableFree () { &_XmxpmHashTableFree;}' unless defined(&xpmHashTableFree);
    eval 'sub xpmHashSlot () { &_XmxpmHashSlot;}' unless defined(&xpmHashSlot);
    eval 'sub xpmHashIntern () { &_XmxpmHashIntern;}' unless defined(&xpmHashIntern);
    eval 'sub xpmNextString () { &_Xmxpm21NextString;}' unless defined(&xpmNextString);
    eval 'sub xpmNextUI () { &_Xmxpm21NextUI;}' unless defined(&xpmNextUI);
    eval 'sub xpmGetString () { &_Xmxpm21GetString;}' unless defined(&xpmGetString);
    eval 'sub xpmNextWord () { &_Xmxpm21NextWord;}' unless defined(&xpmNextWord);
    eval 'sub xpmGetCmt () { &_Xmxpm21GetCmt;}' unless defined(&xpmGetCmt);
    eval 'sub xpmParseHeader () { &_XmxpmParseHeader;}' unless defined(&xpmParseHeader);
    eval 'sub xpmParseValues () { &_XmxpmParseValues;}' unless defined(&xpmParseValues);
    eval 'sub xpmParseColors () { &_XmxpmParseColors;}' unless defined(&xpmParseColors);
    eval 'sub xpmParseExtensions () { &_XmxpmParseExtensions;}' unless defined(&xpmParseExtensions);
    eval 'sub xpmReadRgbNames () { &_XmxpmReadRgbNames;}' unless defined(&xpmReadRgbNames);
    eval 'sub xpmGetRgbName () { &_XmxpmGetRgbName;}' unless defined(&xpmGetRgbName);
    eval 'sub xpmFreeRgbNames () { &_XmxpmFreeRgbNames;}' unless defined(&xpmFreeRgbNames);
    eval 'sub xpmGetRGBfromName () { &_XmxpmGetRGBfromName;}' unless defined(&xpmGetRGBfromName);
    eval 'sub xpm_xynormalizeimagebits () { &_Xmxpm_xynormalizeimagebits;}' unless defined(&xpm_xynormalizeimagebits);
    eval 'sub xpm_znormalizeimagebits () { &_Xmxpm_znormalizeimagebits;}' unless defined(&xpm_znormalizeimagebits);
    eval 'sub xpmstrdup () { &_Xmxpmstrdup;}' unless defined(&xpmstrdup);
    eval 'sub xpmstrcasecmp () { &_Xmxpmstrcasecmp;}' unless defined(&xpmstrcasecmp);
    eval 'sub xpmatoui () { &_Xmxpmatoui;}' unless defined(&xpmatoui);
    eval 'sub xpmDataTypes () { &_XmxpmDataTypes;}' unless defined(&xpmDataTypes);
    eval 'sub xpmColorKeys () { &_Xmxpm21ColorKeys;}' unless defined(&xpmColorKeys);
    unless(defined(&XPMI_h)) {
	eval 'sub XPMI_h () {1;}' unless defined(&XPMI_h);
	require 'XpmP.ph';
	require 'stdio.ph';
	require 'stdlib.ph';
	if(defined(&sequent)) {
	}
	if(defined( &SYSV) || defined( &SVR4) || defined( &VMS) || defined( &WIN32)) {
	    require 'string.ph';
	    unless(defined(&index)) {
		eval 'sub index () { &strchr;}' unless defined(&index);
	    }
	    unless(defined(&rindex)) {
		eval 'sub rindex () { &strrchr;}' unless defined(&rindex);
	    }
	} else {
	    require 'strings.ph';
	}
	if(defined( &SYSV) || defined( &SVR4) || defined( &VMS) || defined( &WIN32)) {
	    unless(defined(&bcopy)) {
		eval 'sub bcopy {
		    my($source, $dest, $count) = @_;
    		    eval q( &memcpy($dest, $source, $count));
		}' unless defined(&bcopy);
	    }
	    unless(defined(&bzero)) {
		eval 'sub bzero {
		    my($b, $len) = @_;
    		    eval q( &memset($b, 0, $len));
		}' unless defined(&bzero);
	    }
	}
	if(defined( &__alpha) || defined( &__sparcv9) ) {
	    unless(defined(&LONG64)) {
		eval 'sub LONG64 () {1;}' unless defined(&LONG64);
	    }
	}
	if(defined(&VMS)) {
	    require 'unixio.ph';
	    require 'file.ph';
	}
	unless(defined(&NO_XPMFREE_MACRO)) {
	    if(defined(&XpmFree)) {
		undef(&XpmFree) if defined(&XpmFree);
	    }
	    eval 'sub XpmFree {
	        my($ptr) = @_;
    		eval q( &free($ptr));
	    }' unless defined(&XpmFree);
	}
	unless(defined(&FOR_MSW)) {
	    eval 'sub XpmMalloc {
	        my($size) = @_;
    		eval q( &malloc(($size)));
	    }' unless defined(&XpmMalloc);
	    eval 'sub XpmRealloc {
	        my($ptr, $size) = @_;
    		eval q( &realloc(($ptr), ($size)));
	    }' unless defined(&XpmRealloc);
	    eval 'sub XpmCalloc {
	        my($nelem, $elsize) = @_;
    		eval q( &calloc(($nelem), ($elsize)));
	    }' unless defined(&XpmCalloc);
	} else {
	    eval 'sub XpmMalloc {
	        my($size) = @_;
    		eval q( &boundCheckingMalloc(($size)));
	    }' unless defined(&XpmMalloc);
	    eval 'sub XpmRealloc {
	        my($ptr, $size) = @_;
    		eval q( &boundCheckingRealloc(,($size)));
	    }' unless defined(&XpmRealloc);
	    eval 'sub XpmCalloc {
	        my($nelem, $elsize) = @_;
    		eval q( &boundCheckingCalloc(, ($elsize)));
	    }' unless defined(&XpmCalloc);
	}
	eval 'sub XPMMAXCMTLEN () { &BUFSIZ;}' unless defined(&XPMMAXCMTLEN);
	eval 'sub XPMARRAY () {0;}' unless defined(&XPMARRAY);
	eval 'sub XPMFILE () {1;}' unless defined(&XPMFILE);
	eval 'sub XPMPIPE () {2;}' unless defined(&XPMPIPE);
	eval 'sub XPMBUFFER () {3;}' unless defined(&XPMBUFFER);
	eval 'sub EOL () {ord(\'\\n\');}' unless defined(&EOL);
	eval 'sub TAB () {ord(\'\\t\');}' unless defined(&TAB);
	eval 'sub SPC () {ord(\' \');}' unless defined(&SPC);
	eval 'sub MAX_RGBNAMES () {1024;}' unless defined(&MAX_RGBNAMES);
	eval 'sub TRANSPARENT_COLOR () {"None";}' unless defined(&TRANSPARENT_COLOR);
	eval 'sub NKEYS () {5;}' unless defined(&NKEYS);
	eval 'sub UNDEF_PIXEL () {0x80000000;}' unless defined(&UNDEF_PIXEL);
	eval 'sub HashAtomData {
	    my($i) = @_;
    	    eval q((( &void *)$i));
	}' unless defined(&HashAtomData);
	eval 'sub HashColorIndex {
	    my($slot) = @_;
    	    eval q((((*$slot)-> &data)));
	}' unless defined(&HashColorIndex);
	eval 'sub USE_HASHTABLE () {( &cpp > 2 &&  &ncolors > 4);}' unless defined(&USE_HASHTABLE);
	eval 'sub _XmxpmGetC {
	    my($mdata) = @_;
    	    eval q(((! ($mdata->{type}) ||  ($mdata->{type}) ==  &XPMBUFFER) ? (* ($mdata->{cptr})++) : ( &getc( ($mdata->{stream}->{file})))));
	}' unless defined(&_XmxpmGetC);
	if(defined(&NEED_STRDUP)) {
	} else {
	    undef(&xpmstrdup) if defined(&xpmstrdup);
	    eval 'sub xpmstrdup () { &strdup;}' unless defined(&xpmstrdup);
	}
	if(defined(&FOR_MSW)) {
	}
	if(defined(&NEED_STRDUP)) {
	} else {
	    undef(&xpmstrdup) if defined(&xpmstrdup);
	    eval 'sub xpmstrdup () { &strdup;}' unless defined(&xpmstrdup);
	}
	if(defined(&NEED_STRCASECMP)) {
	} else {
	    undef(&xpmstrcasecmp) if defined(&xpmstrcasecmp);
	    eval 'sub xpmstrcasecmp () { &strcasecmp;}' unless defined(&xpmstrcasecmp);
	}
	eval 'sub XYNORMALIZE {
	    my($bp, $img) = @_;
    	    eval q( &if (( ($img->{byte_order}) ==  &MSBFirst) || ( ($img->{bitmap_bit_order}) ==  &MSBFirst))  &xpm_xynormalizeimagebits(($bp), $img));
	}' unless defined(&XYNORMALIZE);
	eval 'sub ZNORMALIZE {
	    my($bp, $img) = @_;
    	    eval q( &if ( ($img->{byte_order}) ==  &MSBFirst)  &xpm_znormalizeimagebits(($bp), $img));
	}' unless defined(&ZNORMALIZE);
	eval 'sub XYINDEX {
	    my($x, $y, $img) = @_;
    	    eval q((($y) *  ($img->{b$ytes_per_line})) + ((($x) +  ($img->{xoffset})) /  ($img->{bitmap_unit})) * ( ($img->{bitmap_unit}) >> 3));
	}' unless defined(&XYINDEX);
	eval 'sub ZINDEX {
	    my($x, $y, $img) = @_;
    	    eval q((($y) *  ($img->{b$ytes_per_line})) + ((($x) *  ($img->{bits_per_pixel})) >> 3));
	}' unless defined(&ZINDEX);
	eval 'sub ZINDEX32 {
	    my($x, $y, $img) = @_;
    	    eval q((($y) *  ($img->{b$ytes_per_line})) + (($x) << 2));
	}' unless defined(&ZINDEX32);
	eval 'sub ZINDEX16 {
	    my($x, $y, $img) = @_;
    	    eval q((($y) *  ($img->{b$ytes_per_line})) + (($x) << 1));
	}' unless defined(&ZINDEX16);
	eval 'sub ZINDEX8 {
	    my($x, $y, $img) = @_;
    	    eval q((($y) *  ($img->{b$ytes_per_line})) + ($x));
	}' unless defined(&ZINDEX8);
	eval 'sub ZINDEX1 {
	    my($x, $y, $img) = @_;
    	    eval q((($y) *  ($img->{b$ytes_per_line})) + (($x) >> 3));
	}' unless defined(&ZINDEX1);
	if(defined(&__STDC__)) {
	    eval 'sub Const () { &const;}' unless defined(&Const);
	} else {
	    eval 'sub Const () {1;}' unless defined(&Const);
	}
    }
}
1;
