require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_AIO_H)) {
    eval 'sub _AIO_H () {1;}' unless defined(&_AIO_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    require 'sys/fcntl.ph';
    require 'sys/siginfo.ph';
    require 'sys/aiocb.ph';
    require 'time.ph';
    if(defined(&__cplusplus)) {
    }
    if(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) - 0> 0)  && ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) - 0<= 2)) {
	die("POSIX Asynchronous I/O is not supported in POSIX.1-1990");
    }
    if(!defined( &_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	} else {
	    eval 'sub aio_read () { &aio_read64;}' unless defined(&aio_read);
	    eval 'sub aio_write () { &aio_write64;}' unless defined(&aio_write);
	    eval 'sub lio_listio () { &lio_listio64;}' unless defined(&lio_listio);
	    eval 'sub aio_error () { &aio_error64;}' unless defined(&aio_error);
	    eval 'sub aio_return () { &aio_return64;}' unless defined(&aio_return);
	    eval 'sub aio_cancel () { &aio_cancel64;}' unless defined(&aio_cancel);
	    eval 'sub aio_suspend () { &aio_suspend64;}' unless defined(&aio_suspend);
	    eval 'sub aio_fsync () { &aio_fsync64;}' unless defined(&aio_fsync);
	}
    }
    if(defined( &__STDC__)) {
	if(defined( &_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)  && !defined( &__PRAGMA_REDEFINE_EXTNAME))) {
	}
    } else {
	if(defined( &_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)  && !defined( &__PRAGMA_REDEFINE_EXTNAME))) {
	}
    }
    if(defined( &_LP64)  && defined( &_LARGEFILE64_SOURCE)) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	} else {
	    eval 'sub aio_read64 () { &aio_read;}' unless defined(&aio_read64);
	    eval 'sub aio_write64 () { &aio_write;}' unless defined(&aio_write64);
	    eval 'sub lio_listio64 () { &lio_listio;}' unless defined(&lio_listio64);
	    eval 'sub aio_error64 () { &aio_error;}' unless defined(&aio_error64);
	    eval 'sub aio_return64 () { &aio_return;}' unless defined(&aio_return64);
	    eval 'sub aio_cancel64 () { &aio_cancel;}' unless defined(&aio_cancel64);
	    eval 'sub aio_suspend64 () { &aio_suspend;}' unless defined(&aio_suspend64);
	    eval 'sub aio_fsync64 () { &aio_fsync;}' unless defined(&aio_fsync64);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
