require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_CURSES_H)) {
    eval 'sub _CURSES_H () {1;}' unless defined(&_CURSES_H);
    require 'widec.ph';
    require 'stdio.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub CSMAX () {4;}' unless defined(&CSMAX);
    if(defined(&L_ctermid)) {
	if(defined(&SYSV)) {
	    undef(&SYSV) if defined(&SYSV);
	}
	eval 'sub SYSV () {1;}' unless defined(&SYSV);
    }
    if(defined(&BSD)) {
	undef(&SYSV) if defined(&SYSV);
    }
    if(defined(&SYSV)) {
	unless(defined(&VINTR)) {
	    require 'termio.ph';
	}
    } else {
	unless(defined(&_SGTTYB_)) {
	    require 'sgtty.ph';
	}
	eval 'sub memcpy {
	    my($dst, $src, $len) = @_;
    	    eval q( &bcopy(($src), ($dst), ($len)));
	}' unless defined(&memcpy);
	eval 'sub strchr () { &index;}' unless defined(&strchr);
	eval 'sub strrchr () { &rindex;}' unless defined(&strrchr);
    }
    if(!(defined( &__cplusplus)  && defined( &_BOOL))) {
    }
    eval 'sub _VR3_COMPAT_CODE () {1;}' unless defined(&_VR3_COMPAT_CODE);
    if(defined(&CHTYPE)) {
    } else {
	if(defined(&_LP64)) {
	} else {
	}
    }
    if(defined(&_VR3_COMPAT_CODE)) {
    }
    if(!defined( &TRUE) || (((defined(&TRUE) ? &TRUE : 0)) != 1)) {
	eval 'sub TRUE () {(1);}' unless defined(&TRUE);
    }
    if(!defined( &FALSE) || (((defined(&FALSE) ? &FALSE : 0)) != 0)) {
	eval 'sub FALSE () {(0);}' unless defined(&FALSE);
    }
    if(!defined( &ERR) || (((defined(&ERR) ? &ERR : 0)) != -1)) {
	eval 'sub ERR () {(-1);}' unless defined(&ERR);
    }
    if(!defined( &OK) || (((defined(&OK) ? &OK : 0)) != 0)) {
	eval 'sub OK () {(0);}' unless defined(&OK);
    }
    if(defined(&_VR3_COMPAT_CODE)) {
    }
    eval 'sub _NOCHANGE () {-1;}' unless defined(&_NOCHANGE);
    eval 'sub _INFINITY () {16000;}' unless defined(&_INFINITY);
    eval 'sub _ISPAD () {001;}' unless defined(&_ISPAD);
    eval 'sub _WINCHANGED () {002;}' unless defined(&_WINCHANGED);
    eval 'sub _WINMOVED () {004;}' unless defined(&_WINMOVED);
    eval 'sub _WINSDEL () {010;}' unless defined(&_WINSDEL);
    eval 'sub _CANT_BE_IMMED () {020;}' unless defined(&_CANT_BE_IMMED);
    eval 'sub _WIN_ADD_ONE () {040;}' unless defined(&_WIN_ADD_ONE);
    eval 'sub _WIN_INS_ONE () {100;}' unless defined(&_WIN_INS_ONE);
    eval 'sub CURS_STUPID () {0;}' unless defined(&CURS_STUPID);
    eval 'sub CURS_UNKNOWN () {1;}' unless defined(&CURS_UNKNOWN);
    eval 'sub CURS_BAD_MALLOC () {2;}' unless defined(&CURS_BAD_MALLOC);
    if(defined( &lint)  && !defined( &CURSES) ) {
    }
    if(defined(&_VR3_COMPAT_CODE)) {
	eval 'sub initscr () { &initscr32;}' unless defined(&initscr);
	eval 'sub newterm () { &newterm32;}' unless defined(&newterm);
	eval 'sub waddch () { &w32addch;}' unless defined(&waddch);
	eval 'sub wechochar () { &w32echochar;}' unless defined(&wechochar);
	eval 'sub pechochar () { &p32echochar;}' unless defined(&pechochar);
	eval 'sub winsch () { &w32insch;}' unless defined(&winsch);
	eval 'sub vidputs () { &vid32puts;}' unless defined(&vidputs);
	eval 'sub vidattr () { &vid32attr;}' unless defined(&vidattr);
	eval 'sub wattroff () { &w32attroff;}' unless defined(&wattroff);
	eval 'sub wattron () { &w32attron;}' unless defined(&wattron);
	eval 'sub wattrset () { &w32attrset;}' unless defined(&wattrset);
	eval 'sub acs_map () { &acs32map;}' unless defined(&acs_map);
	eval 'sub box () { &box32;}' unless defined(&box);
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
    } else {
    }
    if(defined(&__STDC__)) {
    } else {
    }
    eval 'sub getsyx {
        my($y, $x) = @_;
	    eval q( &_getsyx(($y), ($x)));
    }' unless defined(&getsyx);
    eval 'sub getyx {
        my($win, $y, $x) = @_;
	    eval q((($y) =  &getcury($win), ($x) =  &getcurx($win)));
    }' unless defined(&getyx);
    eval 'sub getbegyx {
        my($win, $y, $x) = @_;
	    eval q((($y) =  &getbegy($win), ($x) =  &getbegx($win)));
    }' unless defined(&getbegyx);
    eval 'sub getmaxyx {
        my($win, $y, $x) = @_;
	    eval q((($y) =  &getmaxy($win), ($x) =  &getmaxx($win)));
    }' unless defined(&getmaxyx);
    eval 'sub getparyx {
        my($win, $y, $x) = @_;
	    eval q((($y) =  &getpary($win), ($x) =  &getparx($win)));
    }' unless defined(&getparyx);
    if(defined( &CURS_PERFORMANCE)  && !defined( &lint)) {
	eval 'sub getcury {
	    my($win) = @_;
    	    eval q((($win)-> &_cury));
	}' unless defined(&getcury);
	eval 'sub getcurx {
	    my($win) = @_;
    	    eval q((($win)-> &_curx));
	}' unless defined(&getcurx);
	eval 'sub getbegy {
	    my($win) = @_;
    	    eval q((($win)-> &_begy));
	}' unless defined(&getbegy);
	eval 'sub getbegx {
	    my($win) = @_;
    	    eval q((($win)-> &_begx));
	}' unless defined(&getbegx);
	eval 'sub getmaxy {
	    my($win) = @_;
    	    eval q((($win)-> &_maxy));
	}' unless defined(&getmaxy);
	eval 'sub getmaxx {
	    my($win) = @_;
    	    eval q((($win)-> &_maxx));
	}' unless defined(&getmaxx);
	eval 'sub getpary {
	    my($win) = @_;
    	    eval q((($win)-> &_pary));
	}' unless defined(&getpary);
	eval 'sub getparx {
	    my($win) = @_;
    	    eval q((($win)-> &_parx));
	}' unless defined(&getparx);
	eval 'sub getbkgd {
	    my($win) = @_;
    	    eval q((($win)-> &_bkgd));
	}' unless defined(&getbkgd);
	eval 'sub getattrs {
	    my($win) = @_;
    	    eval q((($win)-> &_attrs));
	}' unless defined(&getattrs);
    } else {
	if(defined(&__STDC__)) {
	} else {
	}
    }
    if(defined( &NOMACROS) || defined( &lint)) {
	if(defined(&__STDC__)) {
	} else {
	}
    } else {
	require 'unctrl.ph';
	eval 'sub addch {
	    my($ch) = @_;
    	    eval q( &waddch( &stdscr, $ch));
	}' unless defined(&addch);
	eval 'sub addnstr {
	    my($s, $n) = @_;
    	    eval q( &waddnstr( &stdscr, $s, $n));
	}' unless defined(&addnstr);
	eval 'sub addstr {
	    my($str) = @_;
    	    eval q( &waddstr( &stdscr, $str));
	}' unless defined(&addstr);
	eval 'sub attroff {
	    my($at) = @_;
    	    eval q( &wattroff( &stdscr, $at));
	}' unless defined(&attroff);
	eval 'sub attron {
	    my($at) = @_;
    	    eval q( &wattron( &stdscr, $at));
	}' unless defined(&attron);
	eval 'sub attrset {
	    my($at) = @_;
    	    eval q( &wattrset( &stdscr, $at));
	}' unless defined(&attrset);
	eval 'sub bkgd {
	    my($c) = @_;
    	    eval q( &wbkgd( &stdscr, $c));
	}' unless defined(&bkgd);
	eval 'sub border {
	    my($ls, $rs, $ts, $bs, $tl, $tr, $bl, $br) = @_;
    	    eval q( &wborder( &stdscr, $ls, $rs, $ts, $bs, $tl, $tr, $bl, $br));
	}' unless defined(&border);
	eval 'sub clear () {
	    eval q( &wclear( &stdscr));
	}' unless defined(&clear);
	eval 'sub clrtobot () {
	    eval q( &wclrtobot( &stdscr));
	}' unless defined(&clrtobot);
	eval 'sub clrtoeol () {
	    eval q( &wclrtoeol( &stdscr));
	}' unless defined(&clrtoeol);
	eval 'sub delch () {
	    eval q( &wdelch( &stdscr));
	}' unless defined(&delch);
	eval 'sub deleteln () {
	    eval q( &wdeleteln( &stdscr));
	}' unless defined(&deleteln);
	eval 'sub echochar {
	    my($ch) = @_;
    	    eval q( &wechochar( &stdscr, $ch));
	}' unless defined(&echochar);
	eval 'sub erase () {
	    eval q( &werase( &stdscr));
	}' unless defined(&erase);
	eval 'sub getch () {
	    eval q( &wgetch( &stdscr));
	}' unless defined(&getch);
	eval 'sub getstr {
	    my($str) = @_;
    	    eval q( &wgetstr( &stdscr, $str));
	}' unless defined(&getstr);
	eval 'sub inch () {
	    eval q( &winch( &stdscr));
	}' unless defined(&inch);
	eval 'sub insch {
	    my($c) = @_;
    	    eval q( &winsch( &stdscr, $c));
	}' unless defined(&insch);
	eval 'sub insdelln {
	    my($id) = @_;
    	    eval q( &winsdelln( &stdscr, $id));
	}' unless defined(&insdelln);
	eval 'sub insertln () {
	    eval q( &winsertln( &stdscr));
	}' unless defined(&insertln);
	eval 'sub insnstr {
	    my($s, $n) = @_;
    	    eval q( &winsnstr( &stdscr, $s, $n));
	}' unless defined(&insnstr);
	eval 'sub insstr {
	    my($s) = @_;
    	    eval q( &winsstr( &stdscr, $s));
	}' unless defined(&insstr);
	eval 'sub move {
	    my($y, $x) = @_;
    	    eval q( &wmove( &stdscr, $y, $x));
	}' unless defined(&move);
	eval 'sub refresh () {
	    eval q( &wrefresh( &stdscr));
	}' unless defined(&refresh);
	eval 'sub scrl {
	    my($n) = @_;
    	    eval q( &wscrl( &stdscr, $n));
	}' unless defined(&scrl);
	eval 'sub setscrreg {
	    my($t, $b) = @_;
    	    eval q( &wsetscrreg( &stdscr, $t, $b));
	}' unless defined(&setscrreg);
	eval 'sub standend () {
	    eval q( &wstandend( &stdscr));
	}' unless defined(&standend);
	eval 'sub standout () {
	    eval q( &wstandout( &stdscr));
	}' unless defined(&standout);
	eval 'sub timeout {
	    my($tm) = @_;
    	    eval q( &wtimeout( &stdscr, $tm));
	}' unless defined(&timeout);
	eval 'sub hline {
	    my($c, $num) = @_;
    	    eval q( &whline( &stdscr, $c, $num));
	}' unless defined(&hline);
	eval 'sub vline {
	    my($c, $num) = @_;
    	    eval q( &wvline( &stdscr, $c, $num));
	}' unless defined(&vline);
	eval 'sub addchstr {
	    my($str) = @_;
    	    eval q( &waddchstr( &stdscr, $str));
	}' unless defined(&addchstr);
	eval 'sub addchnstr {
	    my($str, $n) = @_;
    	    eval q( &waddchnstr( &stdscr, $str, $n));
	}' unless defined(&addchnstr);
	eval 'sub instr {
	    my($str) = @_;
    	    eval q( &winstr( &stdscr, ($str)));
	}' unless defined(&instr);
	eval 'sub innstr {
	    my($str, $n) = @_;
    	    eval q( &winnstr( &stdscr, ($str), ($n)));
	}' unless defined(&innstr);
	eval 'sub inchstr {
	    my($str) = @_;
    	    eval q( &winchstr( &stdscr, $str));
	}' unless defined(&inchstr);
	eval 'sub inchnstr {
	    my($str, $n) = @_;
    	    eval q( &winchnstr( &stdscr, $str, $n));
	}' unless defined(&inchnstr);
	eval 'sub bkgdset {
	    my($c) = @_;
    	    eval q( &wbkgdset( &stdscr, $c));
	}' unless defined(&bkgdset);
	eval 'sub addnwstr {
	    my($ws, $n) = @_;
    	    eval q( &waddnwstr( &stdscr, $ws, $n));
	}' unless defined(&addnwstr);
	eval 'sub addwch {
	    my($ch) = @_;
    	    eval q( &waddwch( &stdscr, $ch));
	}' unless defined(&addwch);
	eval 'sub addwchnstr {
	    my($str, $n) = @_;
    	    eval q( &waddwchnstr( &stdscr, $str, $n));
	}' unless defined(&addwchnstr);
	eval 'sub addwchstr {
	    my($str) = @_;
    	    eval q( &waddwchstr( &stdscr, $str));
	}' unless defined(&addwchstr);
	eval 'sub addwstr {
	    my($ws) = @_;
    	    eval q( &waddwstr( &stdscr, $ws));
	}' unless defined(&addwstr);
	eval 'sub echowchar {
	    my($ch) = @_;
    	    eval q( &wechowchar( &stdscr, $ch));
	}' unless defined(&echowchar);
	eval 'sub getnwstr {
	    my($ws, $n) = @_;
    	    eval q( &wgetnwstr( &stdscr, $ws, $n));
	}' unless defined(&getnwstr);
	eval 'sub getwch () {
	    eval q( &wgetwch( &stdscr));
	}' unless defined(&getwch);
	eval 'sub getwstr {
	    my($ws) = @_;
    	    eval q( &wgetwstr( &stdscr, $ws));
	}' unless defined(&getwstr);
	eval 'sub innwstr {
	    my($ws, $n) = @_;
    	    eval q( &winnwstr( &stdscr, $ws, $n));
	}' unless defined(&innwstr);
	eval 'sub insnwstr {
	    my($ws, $n) = @_;
    	    eval q( &winsnwstr( &stdscr, $ws, $n));
	}' unless defined(&insnwstr);
	eval 'sub inswch {
	    my($c) = @_;
    	    eval q( &winswch( &stdscr, $c));
	}' unless defined(&inswch);
	eval 'sub inswstr {
	    my($ws) = @_;
    	    eval q( &winswstr( &stdscr, $ws));
	}' unless defined(&inswstr);
	eval 'sub inwch () {
	    eval q( &winwch( &stdscr));
	}' unless defined(&inwch);
	eval 'sub inwchnstr {
	    my($str, $n) = @_;
    	    eval q( &winwchnstr( &stdscr, $str, $n));
	}' unless defined(&inwchnstr);
	eval 'sub inwchstr {
	    my($str) = @_;
    	    eval q( &winwchstr( &stdscr, $str));
	}' unless defined(&inwchstr);
	eval 'sub inwstr {
	    my($ws) = @_;
    	    eval q( &winwstr( &stdscr, $ws));
	}' unless defined(&inwstr);
	eval 'sub adjcurspos () {
	    eval q( &wadjcurspos( &stdscr));
	}' unless defined(&adjcurspos);
	eval 'sub movenextch () {
	    eval q( &wmovenextch( &stdscr));
	}' unless defined(&movenextch);
	eval 'sub moveprevch () {
	    eval q( &wmoveprevch( &stdscr));
	}' unless defined(&moveprevch);
	if(defined(&CURS_PERFORMANCE)) {
	    eval 'sub wbkgdset {
	        my($win, $c) = @_;
    		eval q(((($win)-> &_attrs = ((($win)-> &_attrs & ~(($win)-> &_bkgd &  &A_ATTRIBUTES)) | ($c &  &A_ATTRIBUTES))), (($win)-> &_bkgd = ($c))));
	    }' unless defined(&wbkgdset);
	    eval 'sub syncok {
	        my($win, $bf) = @_;
    		eval q((($win)-> &_parent ? ($win)-> &_sync = ($bf) :  &ERR));
	    }' unless defined(&syncok);
	    eval 'sub notimeout {
	        my($win, $bf) = @_;
    		eval q(((($win)-> &_notimeout = (($bf) ?  &TRUE :  &FALSE)),  &OK));
	    }' unless defined(&notimeout);
	    eval 'sub clearok {
	        my($win, $bf) = @_;
    		eval q(((($win)-> &_clear = ($bf)),  &OK));
	    }' unless defined(&clearok);
	    eval 'sub leaveok {
	        my($win, $bf) = @_;
    		eval q(((($win)-> &_leave = ($bf)),  &OK));
	    }' unless defined(&leaveok);
	    eval 'sub scrollok {
	        my($win, $bf) = @_;
    		eval q(((($win)-> &_scroll = (($bf) ?  &TRUE :  &FALSE)),  &OK));
	    }' unless defined(&scrollok);
	    eval 'sub idcok {
	        my($win, $bf) = @_;
    		eval q((($win)-> &_use_idc = (($bf) ?  &TRUE :  &FALSE)));
	    }' unless defined(&idcok);
	    eval 'sub nodelay {
	        my($win, $bf) = @_;
    		eval q(((($win)-> &_delay = ($bf) ? 0: -1),  &OK));
	    }' unless defined(&nodelay);
	    eval 'sub is_wintouched {
	        my($win) = @_;
    		eval q((($win)-> &_flags &  &_WINCHANGED));
	    }' unless defined(&is_wintouched);
	    eval 'sub is_linetouched {
	        my($win, $line) = @_;
    		eval q((((($line) >= ($win)-> &_maxy) || (($line) < 0)) ?  &ERR : ((($win)-> $_firstch[($line)] ==  &_INFINITY) ?  &FALSE :  &TRUE)));
	    }' unless defined(&is_linetouched);
	    eval 'sub subwin {
	        my($win, $nl, $nc, $by, $bx) = @_;
    		eval q( &derwin(($win), ($nl), ($nc), ($by- ($win->{_begy})), ($bx- ($win->{_begx}))));
	    }' unless defined(&subwin);
	    eval 'sub touchwin {
	        my($win) = @_;
    		eval q( &wtouchln(($win), 0, ($win)-> &_maxy,  &TRUE));
	    }' unless defined(&touchwin);
	    eval 'sub redrawwin {
	        my($win) = @_;
    		eval q( &wredrawln(($win), 0, ($win)-> &_maxy));
	    }' unless defined(&redrawwin);
	    eval 'sub winchstr {
	        my($win, $str) = @_;
    		eval q( &winchnstr(($win), $str, (($win)-> &_maxx - ($win)-> &_curx)));
	    }' unless defined(&winchstr);
	    eval 'sub winstr {
	        my($win, $str) = @_;
    		eval q( &winnstr(($win), $str, (($win)-> &_maxx - ($win)-> &_curx)));
	    }' unless defined(&winstr);
	    eval 'sub untouchwin {
	        my($win) = @_;
    		eval q( &wtouchln(($win), 0, (($win)-> &_maxy),  &FALSE));
	    }' unless defined(&untouchwin);
	    eval 'sub winch {
	        my($win) = @_;
    		eval q((($win)-> $_y[($win)-> &_cury][($win)-> &_curx]));
	    }' unless defined(&winch);
	    eval 'sub wtimeout {
	        my($win, $tm) = @_;
    		eval q((($win)-> &_delay = ($tm)));
	    }' unless defined(&wtimeout);
	    eval 'sub use_env {
	        my($bf) = @_;
    		eval q(( &_use_env = ($bf)));
	    }' unless defined(&use_env);
	} else {
	    if(defined(&__STDC__)) {
	    } else {
	    }
	}
	eval 'sub mvaddch {
	    my($y, $x, $ch) = @_;
    	    eval q( &mvwaddch( &stdscr, $y, $x, $ch));
	}' unless defined(&mvaddch);
	eval 'sub mvaddnstr {
	    my($y, $x, $s, $n) = @_;
    	    eval q( &mvwaddnstr( &stdscr, $y, $x, $s, $n));
	}' unless defined(&mvaddnstr);
	eval 'sub mvaddstr {
	    my($y, $x, $str) = @_;
    	    eval q( &mvwaddstr( &stdscr, $y, $x, $str));
	}' unless defined(&mvaddstr);
	eval 'sub mvdelch {
	    my($y, $x) = @_;
    	    eval q( &mvwdelch( &stdscr, $y, $x));
	}' unless defined(&mvdelch);
	eval 'sub mvgetch {
	    my($y, $x) = @_;
    	    eval q( &mvwgetch( &stdscr, $y, $x));
	}' unless defined(&mvgetch);
	eval 'sub mvgetstr {
	    my($y, $x, $str) = @_;
    	    eval q( &mvwgetstr( &stdscr, $y, $x, $str));
	}' unless defined(&mvgetstr);
	eval 'sub mvinch {
	    my($y, $x) = @_;
    	    eval q( &mvwinch( &stdscr, $y, $x));
	}' unless defined(&mvinch);
	eval 'sub mvinsch {
	    my($y, $x, $c) = @_;
    	    eval q( &mvwinsch( &stdscr, $y, $x, $c));
	}' unless defined(&mvinsch);
	eval 'sub mvinsnstr {
	    my($y, $x, $s, $n) = @_;
    	    eval q( &mvwinsnstr( &stdscr, $y, $x, $s, $n));
	}' unless defined(&mvinsnstr);
	eval 'sub mvinsstr {
	    my($y, $x, $s) = @_;
    	    eval q( &mvwinsstr( &stdscr, $y, $x, $s));
	}' unless defined(&mvinsstr);
	eval 'sub mvaddchstr {
	    my($y, $x, $str) = @_;
    	    eval q( &mvwaddchstr( &stdscr, $y, $x, $str));
	}' unless defined(&mvaddchstr);
	eval 'sub mvaddchnstr {
	    my($y, $x, $str, $n) = @_;
    	    eval q( &mvwaddchnstr( &stdscr, $y, $x, $str, $n));
	}' unless defined(&mvaddchnstr);
	eval 'sub mvinstr {
	    my($y, $x, $str) = @_;
    	    eval q( &mvwinstr( &stdscr, $y, $x, ($str)));
	}' unless defined(&mvinstr);
	eval 'sub mvinnstr {
	    my($y, $x, $str, $n) = @_;
    	    eval q( &mvwinnstr( &stdscr, $y, $x, ($str), ($n)));
	}' unless defined(&mvinnstr);
	eval 'sub mvinchstr {
	    my($y, $x, $str) = @_;
    	    eval q( &mvwinchstr( &stdscr, $y, $x, $str));
	}' unless defined(&mvinchstr);
	eval 'sub mvinchnstr {
	    my($y, $x, $str, $n) = @_;
    	    eval q( &mvwinchnstr( &stdscr, $y, $x, $str, $n));
	}' unless defined(&mvinchnstr);
	eval 'sub mvhline {
	    my($y, $x, $c, $num) = @_;
    	    eval q( &mvwhline( &stdscr, $y, $x, $c, $num));
	}' unless defined(&mvhline);
	eval 'sub mvvline {
	    my($y, $x, $c, $num) = @_;
    	    eval q( &mvwvline( &stdscr, $y, $x, $c, $num));
	}' unless defined(&mvvline);
	eval 'sub mvaddnwstr {
	    my($y, $x, $ws, $n) = @_;
    	    eval q( &mvwaddnwstr( &stdscr, $y, $x, $ws, $n));
	}' unless defined(&mvaddnwstr);
	eval 'sub mvaddwch {
	    my($y, $x, $ch) = @_;
    	    eval q( &mvwaddwch( &stdscr, $y, $x, $ch));
	}' unless defined(&mvaddwch);
	eval 'sub mvaddwchnstr {
	    my($y, $x, $str, $n) = @_;
    	    eval q( &mvwaddwchnstr( &stdscr, $y, $x, $str, $n));
	}' unless defined(&mvaddwchnstr);
	eval 'sub mvaddwchstr {
	    my($y, $x, $str) = @_;
    	    eval q( &mvwaddwchstr( &stdscr, $y, $x, $str));
	}' unless defined(&mvaddwchstr);
	eval 'sub mvaddwstr {
	    my($y, $x, $ws) = @_;
    	    eval q( &mvwaddwstr( &stdscr, $y, $x, $ws));
	}' unless defined(&mvaddwstr);
	eval 'sub mvgetnwstr {
	    my($y, $x, $ws, $n) = @_;
    	    eval q( &mvwgetnwstr( &stdscr, $y, $x, $ws, $n));
	}' unless defined(&mvgetnwstr);
	eval 'sub mvgetwch {
	    my($y, $x) = @_;
    	    eval q( &mvwgetwch( &stdscr, $y, $x));
	}' unless defined(&mvgetwch);
	eval 'sub mvgetwstr {
	    my($y, $x, $ws) = @_;
    	    eval q( &mvwgetwstr( &stdscr, $y, $x, $ws));
	}' unless defined(&mvgetwstr);
	eval 'sub mvinnwstr {
	    my($y, $x, $ws, $n) = @_;
    	    eval q( &mvwinnwstr( &stdscr, $y, $x, $ws, $n));
	}' unless defined(&mvinnwstr);
	eval 'sub mvinsnwstr {
	    my($y, $x, $ws, $n) = @_;
    	    eval q( &mvwinsnwstr( &stdscr, $y, $x, $ws, $n));
	}' unless defined(&mvinsnwstr);
	eval 'sub mvinswch {
	    my($y, $x, $c) = @_;
    	    eval q( &mvwinswch( &stdscr, $y, $x, $c));
	}' unless defined(&mvinswch);
	eval 'sub mvinswstr {
	    my($y, $x, $ws) = @_;
    	    eval q( &mvwinswstr( &stdscr, $y, $x, $ws));
	}' unless defined(&mvinswstr);
	eval 'sub mvinwch {
	    my($y, $x) = @_;
    	    eval q( &mvwinwch( &stdscr, $y, $x));
	}' unless defined(&mvinwch);
	eval 'sub mvinwchnstr {
	    my($y, $x, $str, $n) = @_;
    	    eval q( &mvwinwchnstr( &stdscr, $y, $x, $str, $n));
	}' unless defined(&mvinwchnstr);
	eval 'sub mvinwchstr {
	    my($y, $x, $str) = @_;
    	    eval q( &mvwinwchstr( &stdscr, $y, $x, $str));
	}' unless defined(&mvinwchstr);
	eval 'sub mvinwstr {
	    my($y, $x, $ws) = @_;
    	    eval q( &mvwinwstr( &stdscr, $y, $x, $ws));
	}' unless defined(&mvinwstr);
	eval 'sub mvwaddch {
	    my($win, $y, $x, $ch) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddch($win, $ch)));
	}' unless defined(&mvwaddch);
	eval 'sub mvwaddnstr {
	    my($win, $y, $x, $s, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddnstr($win, $s, $n)));
	}' unless defined(&mvwaddnstr);
	eval 'sub mvwaddstr {
	    my($win, $y, $x, $str) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddstr($win, $str)));
	}' unless defined(&mvwaddstr);
	eval 'sub mvwdelch {
	    my($win, $y, $x) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wdelch($win)));
	}' unless defined(&mvwdelch);
	eval 'sub mvwgetch {
	    my($win, $y, $x) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetch($win)));
	}' unless defined(&mvwgetch);
	eval 'sub mvwgetstr {
	    my($win, $y, $x, $str) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetstr($win, $str)));
	}' unless defined(&mvwgetstr);
	eval 'sub mvwinch {
	    my($win, $y, $x) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ? ( &chtype) &ERR :  &winch($win)));
	}' unless defined(&mvwinch);
	eval 'sub mvwinsch {
	    my($win, $y, $x, $c) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winsch($win, $c)));
	}' unless defined(&mvwinsch);
	eval 'sub mvwinsnstr {
	    my($win, $y, $x, $s, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winsnstr($win, $s, $n)));
	}' unless defined(&mvwinsnstr);
	eval 'sub mvwinsstr {
	    my($win, $y, $x, $s) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winsstr($win, $s)));
	}' unless defined(&mvwinsstr);
	eval 'sub mvwhline {
	    my($win, $y, $x, $c, $num) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &whline($win, $c, $num)));
	}' unless defined(&mvwhline);
	eval 'sub mvwvline {
	    my($win, $y, $x, $c, $num) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wvline($win, $c, $num)));
	}' unless defined(&mvwvline);
	eval 'sub mvwaddchstr {
	    my($win, $y, $x, $str) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddchstr($win, $str)));
	}' unless defined(&mvwaddchstr);
	eval 'sub mvwaddchnstr {
	    my($win, $y, $x, $str, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddchnstr($win, $str, $n)));
	}' unless defined(&mvwaddchnstr);
	eval 'sub mvwinstr {
	    my($win, $y, $x, $str) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winstr($win, $str)));
	}' unless defined(&mvwinstr);
	eval 'sub mvwinnstr {
	    my($win, $y, $x, $str, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winnstr($win, $str, $n)));
	}' unless defined(&mvwinnstr);
	eval 'sub mvwinchstr {
	    my($win, $y, $x, $str) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winchstr($win, $str)));
	}' unless defined(&mvwinchstr);
	eval 'sub mvwinchnstr {
	    my($win, $y, $x, $str, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winchnstr($win, $str, $n)));
	}' unless defined(&mvwinchnstr);
	eval 'sub mvwaddnwstr {
	    my($win, $y, $x, $ws, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddnwstr($win, $ws, $n)));
	}' unless defined(&mvwaddnwstr);
	eval 'sub mvwaddwch {
	    my($win, $y, $x, $ch) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddwch($win, $ch)));
	}' unless defined(&mvwaddwch);
	eval 'sub mvwaddwchnstr {
	    my($win, $y, $x, $str, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddwchnstr($win, $str, $n)));
	}' unless defined(&mvwaddwchnstr);
	eval 'sub mvwaddwchstr {
	    my($win, $y, $x, $str) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddwchstr($win, $str)));
	}' unless defined(&mvwaddwchstr);
	eval 'sub mvwaddwstr {
	    my($win, $y, $x, $ws) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddwstr($win, $ws)));
	}' unless defined(&mvwaddwstr);
	eval 'sub mvwgetnwstr {
	    my($win, $y, $x, $ws, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetnwstr($win, $ws, $n)));
	}' unless defined(&mvwgetnwstr);
	eval 'sub mvwgetwch {
	    my($win, $y, $x) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetwch($win)));
	}' unless defined(&mvwgetwch);
	eval 'sub mvwgetwstr {
	    my($win, $y, $x, $ws) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetwstr($win, $ws)));
	}' unless defined(&mvwgetwstr);
	eval 'sub mvwinnwstr {
	    my($win, $y, $x, $ws, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winnwstr($win, $ws, $n)));
	}' unless defined(&mvwinnwstr);
	eval 'sub mvwinsnwstr {
	    my($win, $y, $x, $ws, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winsnwstr($win, $ws, $n)));
	}' unless defined(&mvwinsnwstr);
	eval 'sub mvwinswch {
	    my($win, $y, $x, $c) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winswch($win, $c)));
	}' unless defined(&mvwinswch);
	eval 'sub mvwinswstr {
	    my($win, $y, $x, $ws) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winswstr($win, $ws)));
	}' unless defined(&mvwinswstr);
	eval 'sub mvwinwch {
	    my($win, $y, $x) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?( &chtype)  &ERR :  &winwch($win)));
	}' unless defined(&mvwinwch);
	eval 'sub mvwinwchnstr {
	    my($win, $y, $x, $str, $n) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winwchnstr($win, $str, $n)));
	}' unless defined(&mvwinwchnstr);
	eval 'sub mvwinwchstr {
	    my($win, $y, $x, $str) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winwchstr($win, $str)));
	}' unless defined(&mvwinwchstr);
	eval 'sub mvwinwstr {
	    my($win, $y, $x, $ws) = @_;
    	    eval q(( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winwstr($win, $ws)));
	}' unless defined(&mvwinwstr);
	eval 'sub waddwchstr {
	    my($win, $str) = @_;
    	    eval q( &waddwchnstr($win, $str, -1));
	}' unless defined(&waddwchstr);
	eval 'sub winwchstr {
	    my($win, $str) = @_;
    	    eval q( &winwchnstr($win, $str, -1));
	}' unless defined(&winwchstr);
	eval 'sub waddwstr {
	    my($win, $ws) = @_;
    	    eval q( &waddnwstr($win, $ws, -1));
	}' unless defined(&waddwstr);
	eval 'sub winswstr {
	    my($win, $ws) = @_;
    	    eval q( &winsnwstr($win, $ws, -1));
	}' unless defined(&winswstr);
	if(defined(&CURS_MACROS)) {
	    eval 'sub overlay {
	        my($src, $dst) = @_;
    		eval q( &_overlap(($src), ($dst),  &TRUE));
	    }' unless defined(&overlay);
	    eval 'sub overwrite {
	        my($src, $dst) = @_;
    		eval q( &_overlap(($src), ($dst),  &FALSE));
	    }' unless defined(&overwrite);
	    eval 'sub wdeleteln {
	        my($win) = @_;
    		eval q( &winsdelln(($win), -1));
	    }' unless defined(&wdeleteln);
	    eval 'sub winsertln {
	        my($win) = @_;
    		eval q( &winsdelln(($win), 1));
	    }' unless defined(&winsertln);
	    eval 'sub wstandend {
	        my($win) = @_;
    		eval q( &wattrset(($win),  &A_NORMAL));
	    }' unless defined(&wstandend);
	    eval 'sub wstandout {
	        my($win) = @_;
    		eval q( &wattron(($win),  &A_STANDOUT));
	    }' unless defined(&wstandout);
	    eval 'sub beep () {
	        eval q( &_ring( &TRUE));
	    }' unless defined(&beep);
	    eval 'sub flash () {
	        eval q( &_ring( &FALSE));
	    }' unless defined(&flash);
	    eval 'sub scroll {
	        my($win) = @_;
    		eval q( &wscrl(($win), 1));
	    }' unless defined(&scroll);
	    eval 'sub slk_init {
	        my($f) = @_;
    		eval q( &slk_start((($f == 0) ? 3: 2),  &NULL));
	    }' unless defined(&slk_init);
	    eval 'sub scr_init {
	        my($file) = @_;
    		eval q( &_scr_all($file, 0));
	    }' unless defined(&scr_init);
	    eval 'sub scr_restore {
	        my($file) = @_;
    		eval q( &_scr_all($file, 1));
	    }' unless defined(&scr_restore);
	    eval 'sub scr_set {
	        my($file) = @_;
    		eval q( &_scr_all($file, 2));
	    }' unless defined(&scr_set);
	    eval 'sub subpad {
	        my($win, $nl, $nc, $by, $bx) = @_;
    		eval q( &derwin(($win), ($nl), ($nc), ($by), ($bx)));
	    }' unless defined(&subpad);
	    eval 'sub box {
	        my($win, $v, $h) = @_;
    		eval q( &wborder(($win), ($v), ($v), ($h), ($h), 0, 0, 0, 0));
	    }' unless defined(&box);
	    eval 'sub newterm {
	        my($type, $fout, $fin) = @_;
    		eval q( &newscreen(($type), 0, 0, 0, ($fout), ($fin)));
	    }' unless defined(&newterm);
	    eval 'sub touchline {
	        my($win, $y, $n) = @_;
    		eval q( &wtouchln(($win), ($y), ($n),  &TRUE));
	    }' unless defined(&touchline);
	    eval 'sub waddstr {
	        my($win, $str) = @_;
    		eval q( &waddnstr(($win), ($str), -1));
	    }' unless defined(&waddstr);
	    eval 'sub werase {
	        my($win) = @_;
    		eval q(( &wmove(($win), 0, 0),  &wclrtobot($win)));
	    }' unless defined(&werase);
	    eval 'sub wclear {
	        my($win) = @_;
    		eval q(( &clearok(($win),  &TRUE),  &werase($win)));
	    }' unless defined(&wclear);
	    eval 'sub intrflush {
	        my($win, $flag) = @_;
    		eval q( &_setqiflush($flag));
	    }' unless defined(&intrflush);
	    eval 'sub meta {
	        my($win, $flag) = @_;
    		eval q( &_meta($flag));
	    }' unless defined(&meta);
	    eval 'sub setterm {
	        my($name) = @_;
    		eval q( &setupterm(, 1,  &NULL));
	    }' unless defined(&setterm);
	    eval 'sub gettmode () {
	        eval q(( &OK));
	    }' unless defined(&gettmode);
	    eval 'sub halfdelay {
	        my($tens) = @_;
    		eval q( &ttimeout(($tens)*100));
	    }' unless defined(&halfdelay);
	    eval 'sub echo () {
	        eval q( &_setecho( &TRUE));
	    }' unless defined(&echo);
	    eval 'sub noecho () {
	        eval q( &_setecho( &FALSE));
	    }' unless defined(&noecho);
	    eval 'sub nl () {
	        eval q( &_setnonl( &FALSE));
	    }' unless defined(&nl);
	    eval 'sub nonl () {
	        eval q( &_setnonl( &TRUE));
	    }' unless defined(&nonl);
	} else {
	    if(defined(&__STDC__)) {
	    } else {
	    }
	}
	eval 'sub garbagedlines () { &wredrawln;}' unless defined(&garbagedlines);
	eval 'sub garbagedwin () { &redrawwin;}' unless defined(&garbagedwin);
	eval 'sub crmode () { &cbreak;}' unless defined(&crmode);
	eval 'sub nocrmode () { &nocbreak;}' unless defined(&nocrmode);
	eval 'sub saveterm () { &def_prog_mode;}' unless defined(&saveterm);
	eval 'sub fixterm () { &reset_prog_mode;}' unless defined(&fixterm);
	eval 'sub resetterm () { &reset_shell_mode;}' unless defined(&resetterm);
	eval 'sub waddchstr {
	    my($win, $str) = @_;
    	    eval q( &waddchnstr(($win), ($str), -1));
	}' unless defined(&waddchstr);
	eval 'sub winsstr {
	    my($win, $str) = @_;
    	    eval q( &winsnstr(($win), ($str), -1));
	}' unless defined(&winsstr);
	eval 'sub qiflush () {
	    eval q( &_setqiflush( &TRUE));
	}' unless defined(&qiflush);
	eval 'sub noqiflush () {
	    eval q( &_setqiflush( &FALSE));
	}' unless defined(&noqiflush);
	eval 'sub set_term () { &setcurscreen;}' unless defined(&set_term);
    }
    eval 'sub ACS_BSSB () {( $acs_map[ord(\'l\')]);}' unless defined(&ACS_BSSB);
    eval 'sub ACS_SSBB () {( $acs_map[ord(\'m\')]);}' unless defined(&ACS_SSBB);
    eval 'sub ACS_BBSS () {( $acs_map[ord(\'k\')]);}' unless defined(&ACS_BBSS);
    eval 'sub ACS_SBBS () {( $acs_map[ord(\'j\')]);}' unless defined(&ACS_SBBS);
    eval 'sub ACS_SBSS () {( $acs_map[ord(\'u\')]);}' unless defined(&ACS_SBSS);
    eval 'sub ACS_SSSB () {( $acs_map[ord(\'t\')]);}' unless defined(&ACS_SSSB);
    eval 'sub ACS_SSBS () {( $acs_map[ord(\'v\')]);}' unless defined(&ACS_SSBS);
    eval 'sub ACS_BSSS () {( $acs_map[ord(\'w\')]);}' unless defined(&ACS_BSSS);
    eval 'sub ACS_BSBS () {( $acs_map[ord(\'q\')]);}' unless defined(&ACS_BSBS);
    eval 'sub ACS_SBSB () {( $acs_map[ord(\'x\')]);}' unless defined(&ACS_SBSB);
    eval 'sub ACS_SSSS () {( $acs_map[ord(\'n\')]);}' unless defined(&ACS_SSSS);
    eval 'sub ACS_ULCORNER () { &ACS_BSSB;}' unless defined(&ACS_ULCORNER);
    eval 'sub ACS_LLCORNER () { &ACS_SSBB;}' unless defined(&ACS_LLCORNER);
    eval 'sub ACS_URCORNER () { &ACS_BBSS;}' unless defined(&ACS_URCORNER);
    eval 'sub ACS_LRCORNER () { &ACS_SBBS;}' unless defined(&ACS_LRCORNER);
    eval 'sub ACS_RTEE () { &ACS_SBSS;}' unless defined(&ACS_RTEE);
    eval 'sub ACS_LTEE () { &ACS_SSSB;}' unless defined(&ACS_LTEE);
    eval 'sub ACS_BTEE () { &ACS_SSBS;}' unless defined(&ACS_BTEE);
    eval 'sub ACS_TTEE () { &ACS_BSSS;}' unless defined(&ACS_TTEE);
    eval 'sub ACS_HLINE () { &ACS_BSBS;}' unless defined(&ACS_HLINE);
    eval 'sub ACS_VLINE () { &ACS_SBSB;}' unless defined(&ACS_VLINE);
    eval 'sub ACS_PLUS () { &ACS_SSSS;}' unless defined(&ACS_PLUS);
    eval 'sub ACS_S1 () {( $acs_map[ord(\'o\')]);}' unless defined(&ACS_S1);
    eval 'sub ACS_S9 () {( $acs_map[ord(\'s\')]);}' unless defined(&ACS_S9);
    eval 'sub ACS_DIAMOND () {( $acs_map[ord(\'`\')]);}' unless defined(&ACS_DIAMOND);
    eval 'sub ACS_CKBOARD () {( $acs_map[ord(\'a\')]);}' unless defined(&ACS_CKBOARD);
    eval 'sub ACS_DEGREE () {( $acs_map[ord(\'f\')]);}' unless defined(&ACS_DEGREE);
    eval 'sub ACS_PLMINUS () {( $acs_map[ord(\'g\')]);}' unless defined(&ACS_PLMINUS);
    eval 'sub ACS_BULLET () {( $acs_map[ord(\'~\')]);}' unless defined(&ACS_BULLET);
    eval 'sub ACS_LARROW () {( $acs_map[ord(\',\')]);}' unless defined(&ACS_LARROW);
    eval 'sub ACS_RARROW () {( $acs_map[ord(\'+\')]);}' unless defined(&ACS_RARROW);
    eval 'sub ACS_DARROW () {( $acs_map[ord(\'.\')]);}' unless defined(&ACS_DARROW);
    eval 'sub ACS_UARROW () {( $acs_map[ord(\'-\')]);}' unless defined(&ACS_UARROW);
    eval 'sub ACS_BOARD () {( $acs_map[ord(\'h\')]);}' unless defined(&ACS_BOARD);
    eval 'sub ACS_LANTERN () {( $acs_map[ord(\'i\')]);}' unless defined(&ACS_LANTERN);
    eval 'sub ACS_BLOCK () {( $acs_map[ord(\'0\')]);}' unless defined(&ACS_BLOCK);
    eval 'sub KEY_MIN () {0401;}' unless defined(&KEY_MIN);
    eval 'sub KEY_BREAK () {0401;}' unless defined(&KEY_BREAK);
    eval 'sub KEY_DOWN () {0402;}' unless defined(&KEY_DOWN);
    eval 'sub KEY_UP () {0403;}' unless defined(&KEY_UP);
    eval 'sub KEY_LEFT () {0404;}' unless defined(&KEY_LEFT);
    eval 'sub KEY_RIGHT () {0405;}' unless defined(&KEY_RIGHT);
    eval 'sub KEY_HOME () {0406;}' unless defined(&KEY_HOME);
    eval 'sub KEY_BACKSPACE () {0407;}' unless defined(&KEY_BACKSPACE);
    eval 'sub KEY_F0 () {0410;}' unless defined(&KEY_F0);
    eval 'sub KEY_F {
        my($n) = @_;
	    eval q(( &KEY_F0+($n)));
    }' unless defined(&KEY_F);
    eval 'sub KEY_DL () {0510;}' unless defined(&KEY_DL);
    eval 'sub KEY_IL () {0511;}' unless defined(&KEY_IL);
    eval 'sub KEY_DC () {0512;}' unless defined(&KEY_DC);
    eval 'sub KEY_IC () {0513;}' unless defined(&KEY_IC);
    eval 'sub KEY_EIC () {0514;}' unless defined(&KEY_EIC);
    eval 'sub KEY_CLEAR () {0515;}' unless defined(&KEY_CLEAR);
    eval 'sub KEY_EOS () {0516;}' unless defined(&KEY_EOS);
    eval 'sub KEY_EOL () {0517;}' unless defined(&KEY_EOL);
    eval 'sub KEY_SF () {0520;}' unless defined(&KEY_SF);
    eval 'sub KEY_SR () {0521;}' unless defined(&KEY_SR);
    eval 'sub KEY_NPAGE () {0522;}' unless defined(&KEY_NPAGE);
    eval 'sub KEY_PPAGE () {0523;}' unless defined(&KEY_PPAGE);
    eval 'sub KEY_STAB () {0524;}' unless defined(&KEY_STAB);
    eval 'sub KEY_CTAB () {0525;}' unless defined(&KEY_CTAB);
    eval 'sub KEY_CATAB () {0526;}' unless defined(&KEY_CATAB);
    eval 'sub KEY_ENTER () {0527;}' unless defined(&KEY_ENTER);
    eval 'sub KEY_SRESET () {0530;}' unless defined(&KEY_SRESET);
    eval 'sub KEY_RESET () {0531;}' unless defined(&KEY_RESET);
    eval 'sub KEY_PRINT () {0532;}' unless defined(&KEY_PRINT);
    eval 'sub KEY_LL () {0533;}' unless defined(&KEY_LL);
    eval 'sub KEY_A1 () {0534;}' unless defined(&KEY_A1);
    eval 'sub KEY_A3 () {0535;}' unless defined(&KEY_A3);
    eval 'sub KEY_B2 () {0536;}' unless defined(&KEY_B2);
    eval 'sub KEY_C1 () {0537;}' unless defined(&KEY_C1);
    eval 'sub KEY_C3 () {0540;}' unless defined(&KEY_C3);
    eval 'sub KEY_BTAB () {0541;}' unless defined(&KEY_BTAB);
    eval 'sub KEY_BEG () {0542;}' unless defined(&KEY_BEG);
    eval 'sub KEY_CANCEL () {0543;}' unless defined(&KEY_CANCEL);
    eval 'sub KEY_CLOSE () {0544;}' unless defined(&KEY_CLOSE);
    eval 'sub KEY_COMMAND () {0545;}' unless defined(&KEY_COMMAND);
    eval 'sub KEY_COPY () {0546;}' unless defined(&KEY_COPY);
    eval 'sub KEY_CREATE () {0547;}' unless defined(&KEY_CREATE);
    eval 'sub KEY_END () {0550;}' unless defined(&KEY_END);
    eval 'sub KEY_EXIT () {0551;}' unless defined(&KEY_EXIT);
    eval 'sub KEY_FIND () {0552;}' unless defined(&KEY_FIND);
    eval 'sub KEY_HELP () {0553;}' unless defined(&KEY_HELP);
    eval 'sub KEY_MARK () {0554;}' unless defined(&KEY_MARK);
    eval 'sub KEY_MESSAGE () {0555;}' unless defined(&KEY_MESSAGE);
    eval 'sub KEY_MOVE () {0556;}' unless defined(&KEY_MOVE);
    eval 'sub KEY_NEXT () {0557;}' unless defined(&KEY_NEXT);
    eval 'sub KEY_OPEN () {0560;}' unless defined(&KEY_OPEN);
    eval 'sub KEY_OPTIONS () {0561;}' unless defined(&KEY_OPTIONS);
    eval 'sub KEY_PREVIOUS () {0562;}' unless defined(&KEY_PREVIOUS);
    eval 'sub KEY_REDO () {0563;}' unless defined(&KEY_REDO);
    eval 'sub KEY_REFERENCE () {0564;}' unless defined(&KEY_REFERENCE);
    eval 'sub KEY_REFRESH () {0565;}' unless defined(&KEY_REFRESH);
    eval 'sub KEY_REPLACE () {0566;}' unless defined(&KEY_REPLACE);
    eval 'sub KEY_RESTART () {0567;}' unless defined(&KEY_RESTART);
    eval 'sub KEY_RESUME () {0570;}' unless defined(&KEY_RESUME);
    eval 'sub KEY_SAVE () {0571;}' unless defined(&KEY_SAVE);
    eval 'sub KEY_SBEG () {0572;}' unless defined(&KEY_SBEG);
    eval 'sub KEY_SCANCEL () {0573;}' unless defined(&KEY_SCANCEL);
    eval 'sub KEY_SCOMMAND () {0574;}' unless defined(&KEY_SCOMMAND);
    eval 'sub KEY_SCOPY () {0575;}' unless defined(&KEY_SCOPY);
    eval 'sub KEY_SCREATE () {0576;}' unless defined(&KEY_SCREATE);
    eval 'sub KEY_SDC () {0577;}' unless defined(&KEY_SDC);
    eval 'sub KEY_SDL () {0600;}' unless defined(&KEY_SDL);
    eval 'sub KEY_SELECT () {0601;}' unless defined(&KEY_SELECT);
    eval 'sub KEY_SEND () {0602;}' unless defined(&KEY_SEND);
    eval 'sub KEY_SEOL () {0603;}' unless defined(&KEY_SEOL);
    eval 'sub KEY_SEXIT () {0604;}' unless defined(&KEY_SEXIT);
    eval 'sub KEY_SFIND () {0605;}' unless defined(&KEY_SFIND);
    eval 'sub KEY_SHELP () {0606;}' unless defined(&KEY_SHELP);
    eval 'sub KEY_SHOME () {0607;}' unless defined(&KEY_SHOME);
    eval 'sub KEY_SIC () {0610;}' unless defined(&KEY_SIC);
    eval 'sub KEY_SLEFT () {0611;}' unless defined(&KEY_SLEFT);
    eval 'sub KEY_SMESSAGE () {0612;}' unless defined(&KEY_SMESSAGE);
    eval 'sub KEY_SMOVE () {0613;}' unless defined(&KEY_SMOVE);
    eval 'sub KEY_SNEXT () {0614;}' unless defined(&KEY_SNEXT);
    eval 'sub KEY_SOPTIONS () {0615;}' unless defined(&KEY_SOPTIONS);
    eval 'sub KEY_SPREVIOUS () {0616;}' unless defined(&KEY_SPREVIOUS);
    eval 'sub KEY_SPRINT () {0617;}' unless defined(&KEY_SPRINT);
    eval 'sub KEY_SREDO () {0620;}' unless defined(&KEY_SREDO);
    eval 'sub KEY_SREPLACE () {0621;}' unless defined(&KEY_SREPLACE);
    eval 'sub KEY_SRIGHT () {0622;}' unless defined(&KEY_SRIGHT);
    eval 'sub KEY_SRSUME () {0623;}' unless defined(&KEY_SRSUME);
    eval 'sub KEY_SSAVE () {0624;}' unless defined(&KEY_SSAVE);
    eval 'sub KEY_SSUSPEND () {0625;}' unless defined(&KEY_SSUSPEND);
    eval 'sub KEY_SUNDO () {0626;}' unless defined(&KEY_SUNDO);
    eval 'sub KEY_SUSPEND () {0627;}' unless defined(&KEY_SUSPEND);
    eval 'sub KEY_UNDO () {0630;}' unless defined(&KEY_UNDO);
    eval 'sub KEY_MOUSE () {0631;}' unless defined(&KEY_MOUSE);
    eval 'sub KEY_MAX () {0777;}' unless defined(&KEY_MAX);
    eval 'sub reg () { &register;}' unless defined(&reg);
    eval 'sub A_STANDOUT () {000010000000;}' unless defined(&A_STANDOUT);
    eval 'sub _STANDOUT () { &A_STANDOUT;}' unless defined(&_STANDOUT);
    eval 'sub A_UNDERLINE () {000020000000;}' unless defined(&A_UNDERLINE);
    eval 'sub A_REVERSE () {000040000000;}' unless defined(&A_REVERSE);
    eval 'sub A_BLINK () {000100000000;}' unless defined(&A_BLINK);
    eval 'sub A_DIM () {000200000000;}' unless defined(&A_DIM);
    eval 'sub A_BOLD () {000400000000;}' unless defined(&A_BOLD);
    eval 'sub A_ALTCHARSET () {001000000000;}' unless defined(&A_ALTCHARSET);
    eval 'sub A_INVIS () {010000000000;}' unless defined(&A_INVIS);
    eval 'sub A_PROTECT () {020000000000;}' unless defined(&A_PROTECT);
    eval 'sub A_NORMAL () {000000000000;}' unless defined(&A_NORMAL);
    eval 'sub A_ATTRIBUTES () {031777700000;}' unless defined(&A_ATTRIBUTES);
    eval 'sub A_CHARTEXT () {006000077777;}' unless defined(&A_CHARTEXT);
    eval 'sub A_COLOR () {000007700000;}' unless defined(&A_COLOR);
    eval 'sub A_WATTRIBUTES () {031770000000;}' unless defined(&A_WATTRIBUTES);
    eval 'sub A_WCHARTEXT () {006007777777;}' unless defined(&A_WCHARTEXT);
    eval 'sub COLOR_PAIR {
        my($n) = @_;
	    eval q((($n) << 15));
    }' unless defined(&COLOR_PAIR);
    eval 'sub PAIR_NUMBER {
        my($n) = @_;
	    eval q(((($n) &  &A_COLOR) >> 15));
    }' unless defined(&PAIR_NUMBER);
    eval 'sub COLOR_BLACK () {0;}' unless defined(&COLOR_BLACK);
    eval 'sub COLOR_RED () {1;}' unless defined(&COLOR_RED);
    eval 'sub COLOR_GREEN () {2;}' unless defined(&COLOR_GREEN);
    eval 'sub COLOR_YELLOW () {3;}' unless defined(&COLOR_YELLOW);
    eval 'sub COLOR_BLUE () {4;}' unless defined(&COLOR_BLUE);
    eval 'sub COLOR_MAGENTA () {5;}' unless defined(&COLOR_MAGENTA);
    eval 'sub COLOR_CYAN () {6;}' unless defined(&COLOR_CYAN);
    eval 'sub COLOR_WHITE () {7;}' unless defined(&COLOR_WHITE);
    eval 'sub BUTTON_RELEASED () {0;}' unless defined(&BUTTON_RELEASED);
    eval 'sub BUTTON_PRESSED () {1;}' unless defined(&BUTTON_PRESSED);
    eval 'sub BUTTON_CLICKED () {2;}' unless defined(&BUTTON_CLICKED);
    eval 'sub BUTTON_DOUBLE_CLICKED () {3;}' unless defined(&BUTTON_DOUBLE_CLICKED);
    eval 'sub BUTTON_TRIPLE_CLICKED () {4;}' unless defined(&BUTTON_TRIPLE_CLICKED);
    eval 'sub MOUSE_X_POS () {( ($Mouse_status->{x}));}' unless defined(&MOUSE_X_POS);
    eval 'sub MOUSE_Y_POS () {( ($Mouse_status->{y}));}' unless defined(&MOUSE_Y_POS);
    eval 'sub A_BUTTON_CHANGED () {( ($Mouse_status->{changes}) & 7);}' unless defined(&A_BUTTON_CHANGED);
    eval 'sub MOUSE_MOVED () {( ($Mouse_status->{changes}) & 8);}' unless defined(&MOUSE_MOVED);
    eval 'sub MOUSE_POS_REPORT () {( ($Mouse_status->{changes}) & 16);}' unless defined(&MOUSE_POS_REPORT);
    eval 'sub BUTTON_CHANGED {
        my($x) = @_;
	    eval q(( ($Mouse_status->{changes}) & (1<< (($x) - 1))));
    }' unless defined(&BUTTON_CHANGED);
    eval 'sub BUTTON_STATUS {
        my($x) = @_;
	    eval q(( ($Mouse_status->{button[(x)}-1])));
    }' unless defined(&BUTTON_STATUS);
    eval 'sub BUTTON1_RELEASED () {000000000001;}' unless defined(&BUTTON1_RELEASED);
    eval 'sub BUTTON1_PRESSED () {000000000002;}' unless defined(&BUTTON1_PRESSED);
    eval 'sub BUTTON1_CLICKED () {000000000004;}' unless defined(&BUTTON1_CLICKED);
    eval 'sub BUTTON1_DOUBLE_CLICKED () {000000000010;}' unless defined(&BUTTON1_DOUBLE_CLICKED);
    eval 'sub BUTTON1_TRIPLE_CLICKED () {000000000020;}' unless defined(&BUTTON1_TRIPLE_CLICKED);
    eval 'sub BUTTON2_RELEASED () {000000000040;}' unless defined(&BUTTON2_RELEASED);
    eval 'sub BUTTON2_PRESSED () {000000000100;}' unless defined(&BUTTON2_PRESSED);
    eval 'sub BUTTON2_CLICKED () {000000000200;}' unless defined(&BUTTON2_CLICKED);
    eval 'sub BUTTON2_DOUBLE_CLICKED () {000000000400;}' unless defined(&BUTTON2_DOUBLE_CLICKED);
    eval 'sub BUTTON2_TRIPLE_CLICKED () {000000001000;}' unless defined(&BUTTON2_TRIPLE_CLICKED);
    eval 'sub BUTTON3_RELEASED () {000000002000;}' unless defined(&BUTTON3_RELEASED);
    eval 'sub BUTTON3_PRESSED () {000000004000;}' unless defined(&BUTTON3_PRESSED);
    eval 'sub BUTTON3_CLICKED () {000000010000;}' unless defined(&BUTTON3_CLICKED);
    eval 'sub BUTTON3_DOUBLE_CLICKED () {000000020000;}' unless defined(&BUTTON3_DOUBLE_CLICKED);
    eval 'sub BUTTON3_TRIPLE_CLICKED () {000000040000;}' unless defined(&BUTTON3_TRIPLE_CLICKED);
    eval 'sub ALL_MOUSE_EVENTS () {000000077777;}' unless defined(&ALL_MOUSE_EVENTS);
    eval 'sub REPORT_MOUSE_POSITION () {000000100000;}' unless defined(&REPORT_MOUSE_POSITION);
    if(defined(&__cplusplus)) {
    }
}
1;
