require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_DHCP_SVC_PUBLIC_H)) {
    eval 'sub _DHCP_SVC_PUBLIC_H () {1;}' unless defined(&_DHCP_SVC_PUBLIC_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'netinet/in.ph';
    require 'netinet/dhcp.ph';
    eval 'sub DSVC_PUBLIC_VERSION () {1;}' unless defined(&DSVC_PUBLIC_VERSION);
    eval 'sub DSVC_SUCCESS () {0;}' unless defined(&DSVC_SUCCESS);
    eval 'sub DSVC_EXISTS () {1;}' unless defined(&DSVC_EXISTS);
    eval 'sub DSVC_ACCESS () {2;}' unless defined(&DSVC_ACCESS);
    eval 'sub DSVC_NO_CRED () {3;}' unless defined(&DSVC_NO_CRED);
    eval 'sub DSVC_NOENT () {4;}' unless defined(&DSVC_NOENT);
    eval 'sub DSVC_BUSY () {5;}' unless defined(&DSVC_BUSY);
    eval 'sub DSVC_INVAL () {6;}' unless defined(&DSVC_INVAL);
    eval 'sub DSVC_INTERNAL () {7;}' unless defined(&DSVC_INTERNAL);
    eval 'sub DSVC_UNAVAILABLE () {8;}' unless defined(&DSVC_UNAVAILABLE);
    eval 'sub DSVC_COLLISION () {9;}' unless defined(&DSVC_COLLISION);
    eval 'sub DSVC_UNSUPPORTED () {10;}' unless defined(&DSVC_UNSUPPORTED);
    eval 'sub DSVC_NO_MEMORY () {11;}' unless defined(&DSVC_NO_MEMORY);
    eval 'sub DSVC_NO_RESOURCES () {12;}' unless defined(&DSVC_NO_RESOURCES);
    eval 'sub DSVC_BAD_RESOURCE () {13;}' unless defined(&DSVC_BAD_RESOURCE);
    eval 'sub DSVC_BAD_PATH () {14;}' unless defined(&DSVC_BAD_PATH);
    eval 'sub DSVC_MODULE_VERSION () {15;}' unless defined(&DSVC_MODULE_VERSION);
    eval 'sub DSVC_MODULE_ERR () {16;}' unless defined(&DSVC_MODULE_ERR);
    eval 'sub DSVC_MODULE_LOAD_ERR () {17;}' unless defined(&DSVC_MODULE_LOAD_ERR);
    eval 'sub DSVC_MODULE_UNLOAD_ERR () {18;}' unless defined(&DSVC_MODULE_UNLOAD_ERR);
    eval 'sub DSVC_MODULE_CFG_ERR () {19;}' unless defined(&DSVC_MODULE_CFG_ERR);
    eval 'sub DSVC_SYNCH_ERR () {20;}' unless defined(&DSVC_SYNCH_ERR);
    eval 'sub DSVC_NO_LOCKMGR () {21;}' unless defined(&DSVC_NO_LOCKMGR);
    eval 'sub DSVC_NO_LOCATION () {22;}' unless defined(&DSVC_NO_LOCATION);
    eval 'sub DSVC_BAD_CONVER () {23;}' unless defined(&DSVC_BAD_CONVER);
    eval 'sub DSVC_NO_TABLE () {24;}' unless defined(&DSVC_NO_TABLE);
    eval 'sub DSVC_TABLE_EXISTS () {25;}' unless defined(&DSVC_TABLE_EXISTS);
    eval 'sub DSVC_NERR () {( &DSVC_TABLE_EXISTS + 1);}' unless defined(&DSVC_NERR);
    eval 'sub DSVC_CREATE () {0x1;}' unless defined(&DSVC_CREATE);
    eval 'sub DSVC_READ () {0x2;}' unless defined(&DSVC_READ);
    eval 'sub DSVC_WRITE () {0x4;}' unless defined(&DSVC_WRITE);
    eval 'sub DSVC_NONBLOCK () {0x8;}' unless defined(&DSVC_NONBLOCK);
    eval 'sub DSVC_QINIT {
        my($q) = @_;
	    eval q((($q) = 0));
    }' unless defined(&DSVC_QINIT);
    eval 'sub DSVC_QEQ {
        my($q, $v) = @_;
	    eval q((($q) = (($q) | ($v) | (($v) << 16))));
    }' unless defined(&DSVC_QEQ);
    eval 'sub DSVC_QNEQ {
        my($q, $v) = @_;
	    eval q((($q) = ((~(($v) << 16)) & ($q)) | ($v)));
    }' unless defined(&DSVC_QNEQ);
    eval 'sub DSVC_QISEQ {
        my($q, $v) = @_;
	    eval q(((($q) & ($v))  && (($q) & (($v) << 16))));
    }' unless defined(&DSVC_QISEQ);
    eval 'sub DSVC_QISNEQ {
        my($q, $v) = @_;
	    eval q(((($q) & ($v))  && (!(($q) & (($v) << 16)))));
    }' unless defined(&DSVC_QISNEQ);
    eval 'sub DSVC_MAX_MACSYM_LEN () {128;}' unless defined(&DSVC_MAX_MACSYM_LEN);
    eval 'sub DT_DHCPTAB () {"dhcptab";}' unless defined(&DT_DHCPTAB);
    eval 'sub DT_SYMBOL () {ord(\'s\');}' unless defined(&DT_SYMBOL);
    eval 'sub DT_MACRO () {ord(\'m\');}' unless defined(&DT_MACRO);
    eval 'sub DT_QKEY () {0x1;}' unless defined(&DT_QKEY);
    eval 'sub DT_QTYPE () {0x2;}' unless defined(&DT_QTYPE);
    eval 'sub DT_QALL () {( &DT_QKEY| &DT_QTYPE);}' unless defined(&DT_QALL);
    eval 'sub DN_MAX_CID_LEN () {( &DSVC_MAX_MACSYM_LEN / 2);}' unless defined(&DN_MAX_CID_LEN);
    eval 'sub DN_MAX_COMMENT_LEN () {48;}' unless defined(&DN_MAX_COMMENT_LEN);
    eval 'sub DN_QCID () {0x1;}' unless defined(&DN_QCID);
    eval 'sub DN_QCIP () {0x2;}' unless defined(&DN_QCIP);
    eval 'sub DN_QSIP () {0x4;}' unless defined(&DN_QSIP);
    eval 'sub DN_QLEASE () {0x8;}' unless defined(&DN_QLEASE);
    eval 'sub DN_QMACRO () {0x10;}' unless defined(&DN_QMACRO);
    eval 'sub DN_QFDYNAMIC () {0x20;}' unless defined(&DN_QFDYNAMIC);
    eval 'sub DN_QFAUTOMATIC () {0x40;}' unless defined(&DN_QFAUTOMATIC);
    eval 'sub DN_QFMANUAL () {0x80;}' unless defined(&DN_QFMANUAL);
    eval 'sub DN_QFUNUSABLE () {0x100;}' unless defined(&DN_QFUNUSABLE);
    eval 'sub DN_QFBOOTP_ONLY () {0x200;}' unless defined(&DN_QFBOOTP_ONLY);
    eval 'sub DN_QALL () {( &DN_QCID |  &DN_QCIP |  &DN_QSIP |  &DN_QLEASE |  &DN_QMACRO |  &DN_QFDYNAMIC |  &DN_QFAUTOMATIC |  &DN_QFMANUAL |  &DN_QFUNUSABLE |  &DN_QFBOOTP_ONLY);}' unless defined(&DN_QALL);
    eval 'sub DN_FDYNAMIC () {0x;}' unless defined(&DN_FDYNAMIC);
    eval 'sub DN_FAUTOMATIC () {0x1;}' unless defined(&DN_FAUTOMATIC);
    eval 'sub DN_FMANUAL () {0x2;}' unless defined(&DN_FMANUAL);
    eval 'sub DN_FUNUSABLE () {0x4;}' unless defined(&DN_FUNUSABLE);
    eval 'sub DN_FBOOTP_ONLY () {0x8;}' unless defined(&DN_FBOOTP_ONLY);
    eval 'sub DN_FALL () {( &DN_FDYNAMIC |  &DN_FAUTOMATIC |  &DN_FMANUAL |  &DN_FUNUSABLE |  &DN_FBOOTP_ONLY);}' unless defined(&DN_FALL);
    eval 'sub DSVC_SYNCH_NONE () {0;}' unless defined(&DSVC_SYNCH_NONE);
    eval 'sub DSVC_SYNCH_DSVCD () {1;}' unless defined(&DSVC_SYNCH_DSVCD);
    unless(defined(&_DHCPSVC_IMPL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
