require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_FTW_H)) {
    eval 'sub _FTW_H () {1;}' unless defined(&_FTW_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    require 'sys/stat.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub FTW_F () {0;}' unless defined(&FTW_F);
    eval 'sub FTW_D () {1;}' unless defined(&FTW_D);
    eval 'sub FTW_DNR () {2;}' unless defined(&FTW_DNR);
    eval 'sub FTW_NS () {3;}' unless defined(&FTW_NS);
    eval 'sub FTW_SL () {4;}' unless defined(&FTW_SL);
    eval 'sub FTW_DP () {6;}' unless defined(&FTW_DP);
    eval 'sub FTW_SLN () {7;}' unless defined(&FTW_SLN);
    eval 'sub FTW_PHYS () {01;}' unless defined(&FTW_PHYS);
    eval 'sub FTW_MOUNT () {02;}' unless defined(&FTW_MOUNT);
    eval 'sub FTW_CHDIR () {04;}' unless defined(&FTW_CHDIR);
    eval 'sub FTW_DEPTH () {010;}' unless defined(&FTW_DEPTH);
    if(defined( &__EXTENSIONS__) || !defined( &_XOPEN_SOURCE) || defined( &_XPG4_2)) {
	if(defined( &_XPG4_2)) {
	} else {
	}
    }
    eval 'sub FTW_SKD () {1;}' unless defined(&FTW_SKD);
    eval 'sub FTW_FOLLOW () {2;}' unless defined(&FTW_FOLLOW);
    eval 'sub FTW_PRUNE () {4;}' unless defined(&FTW_PRUNE);
    if(!defined( &_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    if(!defined( &_XOPEN_SOURCE) || defined( &_XPG5)) {
	    }
	} else {
	    eval 'sub _xftw () { &_xftw64;}' unless defined(&_xftw);
	    eval 'sub _ftw () { &_ftw64;}' unless defined(&_ftw);
	    if(!defined( &_XOPEN_SOURCE) || defined( &_XPG5)) {
		eval 'sub nftw () { &nftw64;}' unless defined(&nftw);
	    }
	}
    }
    if(defined( &_LP64)  && defined( &_LARGEFILE64_SOURCE)) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    if(!defined( &_XOPEN_SOURCE) || defined( &_XPG5)) {
	    }
	} else {
	    eval 'sub _xftw64 () { &_xftw;}' unless defined(&_xftw64);
	    eval 'sub _ftw64 () { &_ftw;}' unless defined(&_ftw64);
	    if(!defined( &_XOPEN_SOURCE) || defined( &_XPG5)) {
		eval 'sub nftw64 () { &nftw;}' unless defined(&nftw64);
	    }
	}
    }
    if(defined( &__STDC__)) {
	if(defined( &__EXTENSIONS__) || !defined( &_XOPEN_SOURCE) || defined( &_XPG4_2)) {
	}
	if(defined( &_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)  && !defined( &__PRAGMA_REDEFINE_EXTNAME))) {
	    if(!defined( &_XOPEN_SOURCE)) {
	    }
	}
    } else {
	if(defined( &__EXTENSIONS__) || !defined( &_XOPEN_SOURCE) || defined( &_XPG4_2)) {
	}
	if(defined( &_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)  && !defined( &__PRAGMA_REDEFINE_EXTNAME))) {
	    if(!defined( &_XOPEN_SOURCE)) {
	    }
	}
    }
    eval 'sub _XFTWVER () {2;}' unless defined(&_XFTWVER);
    eval 'sub ftw {
        my($path, $fn, $depth) = @_;
	    eval q(( &_xftw( &_XFTWVER, $path, $fn, $depth)));
    }' unless defined(&ftw);
    if(defined( &_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)  && !defined( &__PRAGMA_REDEFINE_EXTNAME))) {
	eval 'sub ftw64 {
	    my($path, $fn, $depth) = @_;
    	    eval q(( &_xftw64( &_XFTWVER, $path, $fn, $depth)));
	}' unless defined(&ftw64);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
