require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_INET_COMMON_H)) {
    eval 'sub _INET_COMMON_H () {1;}' unless defined(&_INET_COMMON_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/inttypes.ph';
    eval 'sub A_CNT {
        my($arr) = @_;
	    eval q(($sizeof{$arr}/$sizeof{$arr->[0]}));
    }' unless defined(&A_CNT);
    eval 'sub A_END {
        my($arr) = @_;
	    eval q(($arr->[ &A_CNT($arr)]));
    }' unless defined(&A_END);
    eval 'sub A_LAST {
        my($arr) = @_;
	    eval q(($arr->[ &A_CNT($arr)-1]));
    }' unless defined(&A_LAST);
    eval 'sub fallthru () {1;}' unless defined(&fallthru);
    eval 'sub getarg {
        my($ac, $av) = @_;
	    eval q(( &optind < $ac ? $av->[ &optind++] :  &nilp));
    }' unless defined(&getarg);
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    my($x1, $x2) = @_;
    	    eval q((($x1) >= ($x2) ? ($x1) : ($x2)));
	}' unless defined(&MAX);
    }
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    my($x1, $x2) = @_;
    	    eval q((($x1) <= ($x2) ? ($x1) : ($x2)));
	}' unless defined(&MIN);
    }
    eval 'sub MAX_INT () {(( &MAX_UINT >> 1));}' unless defined(&MAX_INT);
    eval 'sub MAX_LONG () {(( &MAX_ULONG >> 1));}' unless defined(&MAX_LONG);
    eval 'sub MAX_SHORT () {(( &MAX_USHORT >> 1));}' unless defined(&MAX_SHORT);
    eval 'sub MAX_UINT () {(~0);}' unless defined(&MAX_UINT);
    eval 'sub MAX_ULONG () {(~0);}' unless defined(&MAX_ULONG);
    eval 'sub MAX_USHORT () {(~0);}' unless defined(&MAX_USHORT);
    eval 'sub MIN_INT () {(~ &MAX_INT);}' unless defined(&MIN_INT);
    eval 'sub MIN_LONG () {(~ &MAX_LONG);}' unless defined(&MIN_LONG);
    eval 'sub MIN_SHORT () {(~ &MAX_SHORT);}' unless defined(&MIN_SHORT);
    eval 'sub newa {
        my($t, $cnt) = @_;
	    eval q((($t *) &calloc($cnt, $sizeof{$t})));
    }' unless defined(&newa);
    eval 'sub nilp {
        my($t) = @_;
	    eval q((($t *)0));
    }' unless defined(&nilp);
    eval 'sub nil {
        my($t) = @_;
	    eval q((($t)0));
    }' unless defined(&nil);
    eval 'sub noop () {1;}' unless defined(&noop);
    eval 'sub BE32_EQL {
        my($a, $b) = @_;
	    eval q(((( &uint8_t *)$a)[0] == (( &uint8_t *)$b)[0]  && (( &uint8_t *)$a)[1] == (( &uint8_t *)$b)[1]  && (( &uint8_t *)$a)[2] == (( &uint8_t *)$b)[2]  && (( &uint8_t *)$a)[3] == (( &uint8_t *)$b)[3]));
    }' unless defined(&BE32_EQL);
    eval 'sub BE16_EQL {
        my($a, $b) = @_;
	    eval q(((( &uint8_t *)$a)[0] == (( &uint8_t *)$b)[0]  && (( &uint8_t *)$a)[1] == (( &uint8_t *)$b)[1]));
    }' unless defined(&BE16_EQL);
    eval 'sub BE16_TO_U16 {
        my($a) = @_;
	    eval q((((( &uint16_t)(( &uint8_t *)$a)[0] << ( &uint16_t)8) | (( &uint16_t)(( &uint8_t *)$a)[1] & 0xff)) & ( &uint16_t)0xffff));
    }' unless defined(&BE16_TO_U16);
    eval 'sub BE32_TO_U32 {
        my($a) = @_;
	    eval q((((( &uint32_t)(( &uint8_t *)$a)[0] & 0xff) << ( &uint32_t)24) | ((( &uint32_t)(( &uint8_t *)$a)[1] & 0xff) << ( &uint32_t)16) | ((( &uint32_t)(( &uint8_t *)$a)[2] & 0xff) << ( &uint32_t)8) | (( &uint32_t)(( &uint8_t *)$a)[3] & 0xff)));
    }' unless defined(&BE32_TO_U32);
    eval 'sub U16_TO_BE16 {
        my($u, $a) = @_;
	    eval q((((( &uint8_t *)$a)[0] = ( &uint8_t)(($u) >> 8)), ((( &uint8_t *)$a)[1] = ( &uint8_t)($u))));
    }' unless defined(&U16_TO_BE16);
    eval 'sub U32_TO_BE32 {
        my($u, $a) = @_;
	    eval q((((( &uint8_t *)$a)[0] = ( &uint8_t)(($u) >> 24)), ((( &uint8_t *)$a)[1] = ( &uint8_t)(($u) >> 16)), ((( &uint8_t *)$a)[2] = ( &uint8_t)(($u) >> 8)), ((( &uint8_t *)$a)[3] = ( &uint8_t)($u))));
    }' unless defined(&U32_TO_BE32);
    require 'inet/led.ph';
    require 'sys/isa_defs.ph';
    if(defined(&_BIG_ENDIAN)) {
	unless(defined(&ABE32_TO_U32)) {
	    eval 'sub ABE32_TO_U32 {
	        my($p) = @_;
    		eval q((*(( &uint32_t *)$p)));
	    }' unless defined(&ABE32_TO_U32);
	}
	unless(defined(&ABE16_TO_U16)) {
	    eval 'sub ABE16_TO_U16 {
	        my($p) = @_;
    		eval q((*(( &uint16_t *)$p)));
	    }' unless defined(&ABE16_TO_U16);
	}
	unless(defined(&U16_TO_ABE16)) {
	    eval 'sub U16_TO_ABE16 {
	        my($u, $p) = @_;
    		eval q((*(( &uint16_t *)$p) = ($u)));
	    }' unless defined(&U16_TO_ABE16);
	}
	unless(defined(&U32_TO_ABE16)) {
	    eval 'sub U32_TO_ABE16 {
	        my($u, $p) = @_;
    		eval q( &U16_TO_ABE16($u, $p));
	    }' unless defined(&U32_TO_ABE16);
	}
	unless(defined(&UA32_TO_U32)) {
	    eval 'sub UA32_TO_U32 {
	        my($p, $u) = @_;
    		eval q((($u) = ((( &uint32_t)(( &uint8_t *)$p)[0] << 24) | (( &uint32_t)(( &uint8_t *)$p)[1] << 16) | (( &uint32_t)(( &uint8_t *)$p)[2] << 8) | ( &uint32_t)(( &uint8_t *)$p)[3])));
	    }' unless defined(&UA32_TO_U32);
	}
	unless(defined(&U32_TO_ABE32)) {
	    eval 'sub U32_TO_ABE32 {
	        my($u, $p) = @_;
    		eval q((*(( &uint32_t *)$p) = ($u)));
	    }' unless defined(&U32_TO_ABE32);
	}
    } else {
	unless(defined(&ABE16_TO_U16)) {
	    eval 'sub ABE16_TO_U16 {
	        my($p) = @_;
    		eval q( &BE16_TO_U16($p));
	    }' unless defined(&ABE16_TO_U16);
	}
	unless(defined(&ABE32_TO_U32)) {
	    eval 'sub ABE32_TO_U32 {
	        my($p) = @_;
    		eval q( &BE32_TO_U32($p));
	    }' unless defined(&ABE32_TO_U32);
	}
	unless(defined(&U16_TO_ABE16)) {
	    eval 'sub U16_TO_ABE16 {
	        my($u, $p) = @_;
    		eval q( &U16_TO_BE16($u, $p));
	    }' unless defined(&U16_TO_ABE16);
	}
	unless(defined(&U32_TO_ABE16)) {
	    eval 'sub U32_TO_ABE16 {
	        my($u, $p) = @_;
    		eval q( &U16_TO_ABE16($u, $p));
	    }' unless defined(&U32_TO_ABE16);
	}
	unless(defined(&U32_TO_ABE32)) {
	    eval 'sub U32_TO_ABE32 {
	        my($u, $p) = @_;
    		eval q( &U32_TO_BE32($u, $p));
	    }' unless defined(&U32_TO_ABE32);
	}
	unless(defined(&UA32_TO_U32)) {
	    eval 'sub UA32_TO_U32 {
	        my($p, $u) = @_;
    		eval q((($u) = ((( &uint32_t)(( &uint8_t *)$p)[3] << 24) | (( &uint32_t)(( &uint8_t *)$p)[2] << 16) | (( &uint32_t)(( &uint8_t *)$p)[1] << 8) | ( &uint32_t)(( &uint8_t *)$p)[0])));
	    }' unless defined(&UA32_TO_U32);
	}
    }
    if(defined(&_KERNEL)) {
	eval 'sub M_MI () {64;}' unless defined(&M_MI);
	eval 'sub M_MI_READ_RESET () {1;}' unless defined(&M_MI_READ_RESET);
	eval 'sub M_MI_READ_SEEK () {2;}' unless defined(&M_MI_READ_SEEK);
	eval 'sub M_MI_READ_END () {4;}' unless defined(&M_MI_READ_END);
	unless(defined(&EINVAL)) {
	    require 'errno.ph';
	}
	if(defined(&MPS)) {
	    eval 'sub mi_adjmsg () { &adjmsg;}' unless defined(&mi_adjmsg);
	}
	unless(defined(&CANPUTNEXT)) {
	    eval 'sub CANPUTNEXT {
	        my($q) = @_;
    		eval q( &canput(($q)-> &q_next));
	    }' unless defined(&CANPUTNEXT);
	}
    }
    unless(defined(&UNIX5_3)) {
	eval 'sub EBASE () {127;}' unless defined(&EBASE);
	unless(defined(&EBADMSG)) {
	    eval 'sub EBADMSG () {( &EBASE-0);}' unless defined(&EBADMSG);
	}
	unless(defined(&ETIME)) {
	    eval 'sub ETIME () {( &EBASE-1);}' unless defined(&ETIME);
	}
	unless(defined(&EPROTO)) {
	    eval 'sub EPROTO () {( &EBASE-2);}' unless defined(&EPROTO);
	}
    }
    unless(defined(&GOOD_EXIT_STATUS)) {
	eval 'sub GOOD_EXIT_STATUS () {0;}' unless defined(&GOOD_EXIT_STATUS);
    }
    unless(defined(&BAD_EXIT_STATUS)) {
	eval 'sub BAD_EXIT_STATUS () {1;}' unless defined(&BAD_EXIT_STATUS);
    }
    unless(defined(&is_ok_exit_status)) {
	eval 'sub is_ok_exit_status {
	    my($status) = @_;
    	    eval q(($status ==  &GOOD_EXIT_STATUS));
	}' unless defined(&is_ok_exit_status);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
