require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_INET_OPTCOM_H)) {
    eval 'sub _INET_OPTCOM_H () {1;}' unless defined(&_INET_OPTCOM_H);
    if(defined(&__cplusplus)) {
    }
    if(defined( &_KERNEL)  && defined( &__STDC__)) {
	eval 'sub OPDES_DEFSZ_MAX () {64;}' unless defined(&OPDES_DEFSZ_MAX);
	eval 'sub opdes_default () { ($opdes_def->{opdes_def_int64});}' unless defined(&opdes_default);
	eval 'sub opdes_defbuf () { ($opdes_def->{opdes_def_charbuf});}' unless defined(&opdes_defbuf);
	eval 'sub OA_R () {0x1;}' unless defined(&OA_R);
	eval 'sub OA_W () {0x2;}' unless defined(&OA_W);
	eval 'sub OA_X () {0x4;}' unless defined(&OA_X);
	eval 'sub OA_RW () {( &OA_R| &OA_W);}' unless defined(&OA_RW);
	eval 'sub OA_WX () {( &OA_W| &OA_X);}' unless defined(&OA_WX);
	eval 'sub OA_RX () {( &OA_R| &OA_X);}' unless defined(&OA_RX);
	eval 'sub OA_RWX () {( &OA_R| &OA_W| &OA_X);}' unless defined(&OA_RWX);
	eval 'sub OA_ANY_ACCESS {
	    my($x) = @_;
    	    eval q((($x)-> &opdes_access_nopriv|($x)-> &opdes_access_priv));
	}' unless defined(&OA_ANY_ACCESS);
	eval 'sub OA_R_NOPRIV {
	    my($x) = @_;
    	    eval q((($x)-> &opdes_access_nopriv &  &OA_R));
	}' unless defined(&OA_R_NOPRIV);
	eval 'sub OA_R_ANYPRIV {
	    my($x) = @_;
    	    eval q(( &OA_ANY_ACCESS($x) &  &OA_R));
	}' unless defined(&OA_R_ANYPRIV);
	eval 'sub OA_W_NOPRIV {
	    my($x) = @_;
    	    eval q((($x)-> &opdes_access_nopriv &  &OA_W));
	}' unless defined(&OA_W_NOPRIV);
	eval 'sub OA_X_ANYPRIV {
	    my($x) = @_;
    	    eval q(( &OA_ANY_ACCESS($x) &  &OA_X));
	}' unless defined(&OA_X_ANYPRIV);
	eval 'sub OA_X_NOPRIV {
	    my($x) = @_;
    	    eval q((($x)-> &opdes_access_nopriv &  &OA_X));
	}' unless defined(&OA_X_NOPRIV);
	eval 'sub OA_W_ANYPRIV {
	    my($x) = @_;
    	    eval q(( &OA_ANY_ACCESS($x) &  &OA_W));
	}' unless defined(&OA_W_ANYPRIV);
	eval 'sub OA_WX_NOPRIV {
	    my($x) = @_;
    	    eval q((($x)-> &opdes_access_nopriv &  &OA_WX));
	}' unless defined(&OA_WX_NOPRIV);
	eval 'sub OA_WX_ANYPRIV {
	    my($x) = @_;
    	    eval q(( &OA_ANY_ACCESS($x) &  &OA_WX));
	}' unless defined(&OA_WX_ANYPRIV);
	eval 'sub OA_RWX_ANYPRIV {
	    my($x) = @_;
    	    eval q(( &OA_ANY_ACCESS($x) &  &OA_RWX));
	}' unless defined(&OA_RWX_ANYPRIV);
	eval 'sub OA_RONLY_NOPRIV {
	    my($x) = @_;
    	    eval q(((($x)-> &opdes_access_nopriv &  &OA_RWX) ==  &OA_R));
	}' unless defined(&OA_RONLY_NOPRIV);
	eval 'sub OA_RONLY_ANYPRIV {
	    my($x) = @_;
    	    eval q((( &OA_ANY_ACCESS($x) &  &OA_RWX) ==  &OA_R));
	}' unless defined(&OA_RONLY_ANYPRIV);
	eval 'sub OA_READ_PERMISSION {
	    my($x, $p) = @_;
    	    eval q(((!($p)  &&  &OA_R_NOPRIV($x)) || (($p)  &&  &OA_R_ANYPRIV($x))));
	}' unless defined(&OA_READ_PERMISSION);
	eval 'sub OA_WRITE_OR_EXECUTE {
	    my($x, $p) = @_;
    	    eval q(((!($p)  &&  &OA_WX_NOPRIV($x)) || (($p)  &&  &OA_WX_ANYPRIV($x))));
	}' unless defined(&OA_WRITE_OR_EXECUTE);
	eval 'sub OA_READONLY_PERMISSION {
	    my($x, $p) = @_;
    	    eval q(((!($p)  &&  &OA_RONLY_NOPRIV($x)) || (($p)  &&  &OA_RONLY_ANYPRIV($x))));
	}' unless defined(&OA_READONLY_PERMISSION);
	eval 'sub OA_WRITE_PERMISSION {
	    my($x, $p) = @_;
    	    eval q(((!($p)  &&  &OA_W_NOPRIV($x)) || ($p  &&  &OA_W_ANYPRIV($x))));
	}' unless defined(&OA_WRITE_PERMISSION);
	eval 'sub OA_EXECUTE_PERMISSION {
	    my($x, $p) = @_;
    	    eval q(((!($p)  &&  &OA_X_NOPRIV($x)) || (($p)  &&  &OA_X_ANYPRIV($x))));
	}' unless defined(&OA_EXECUTE_PERMISSION);
	eval 'sub OA_NO_PERMISSION {
	    my($x, $p) = @_;
    	    eval q(((!($p)  && ($x)-> &opdes_access_nopriv == 0) || (($p)  && ($x)-> &opdes_access_priv == 0)));
	}' unless defined(&OA_NO_PERMISSION);
	eval 'sub OP_PASSNEXT () {0x1;}' unless defined(&OP_PASSNEXT);
	eval 'sub OP_VARLEN () {0x2;}' unless defined(&OP_VARLEN);
	eval 'sub OP_NOT_ABSREQ () {0x4;}' unless defined(&OP_NOT_ABSREQ);
	eval 'sub OP_NODEFAULT () {0x8;}' unless defined(&OP_NODEFAULT);
	eval 'sub OP_DEF_FN () {0x10;}' unless defined(&OP_DEF_FN);
	eval 'sub SETFN_OPTCOM_CHECKONLY () {1;}' unless defined(&SETFN_OPTCOM_CHECKONLY);
	eval 'sub SETFN_OPTCOM_NEGOTIATE () {2;}' unless defined(&SETFN_OPTCOM_NEGOTIATE);
	eval 'sub SETFN_UD_NEGOTIATE () {3;}' unless defined(&SETFN_UD_NEGOTIATE);
	eval 'sub SETFN_CONN_NEGOTIATE () {4;}' unless defined(&SETFN_CONN_NEGOTIATE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
