require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_INET_TCP_H)) {
    eval 'sub _INET_TCP_H () {1;}' unless defined(&_INET_TCP_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/inttypes.ph';
    require 'netinet/ip6.ph';
    require 'netinet/tcp.ph';
    require 'inet/tcp_sack.ph';
    require 'sys/socket.ph';
    eval 'sub TCP_IOC_DEFAULT_Q () {((ord(\'T\') << 8) + 51);}' unless defined(&TCP_IOC_DEFAULT_Q);
    eval 'sub TCPS_CLOSED () {-6;}' unless defined(&TCPS_CLOSED);
    eval 'sub TCPS_IDLE () {-5;}' unless defined(&TCPS_IDLE);
    eval 'sub TCPS_BOUND () {-4;}' unless defined(&TCPS_BOUND);
    eval 'sub TCPS_LISTEN () {-3;}' unless defined(&TCPS_LISTEN);
    eval 'sub TCPS_SYN_SENT () {-2;}' unless defined(&TCPS_SYN_SENT);
    eval 'sub TCPS_SYN_RCVD () {-1;}' unless defined(&TCPS_SYN_RCVD);
    eval 'sub TCPS_ESTABLISHED () {0;}' unless defined(&TCPS_ESTABLISHED);
    eval 'sub TCPS_CLOSE_WAIT () {1;}' unless defined(&TCPS_CLOSE_WAIT);
    eval 'sub TCPS_FIN_WAIT_1 () {2;}' unless defined(&TCPS_FIN_WAIT_1);
    eval 'sub TCPS_CLOSING () {3;}' unless defined(&TCPS_CLOSING);
    eval 'sub TCPS_LAST_ACK () {4;}' unless defined(&TCPS_LAST_ACK);
    eval 'sub TCPS_FIN_WAIT_2 () {5;}' unless defined(&TCPS_FIN_WAIT_2);
    eval 'sub TCPS_TIME_WAIT () {6;}' unless defined(&TCPS_TIME_WAIT);
    eval 'sub TH_FIN () {0x1;}' unless defined(&TH_FIN);
    eval 'sub TH_SYN () {0x2;}' unless defined(&TH_SYN);
    eval 'sub TH_RST () {0x4;}' unless defined(&TH_RST);
    eval 'sub TH_PSH () {0x8;}' unless defined(&TH_PSH);
    eval 'sub TH_ACK () {0x10;}' unless defined(&TH_ACK);
    eval 'sub TH_URG () {0x20;}' unless defined(&TH_URG);
    eval 'sub TH_ACK_ACCEPTABLE () {0x400;}' unless defined(&TH_ACK_ACCEPTABLE);
    eval 'sub TH_XMIT_NEEDED () {0x800;}' unless defined(&TH_XMIT_NEEDED);
    eval 'sub TH_REXMIT_NEEDED () {0x1000;}' unless defined(&TH_REXMIT_NEEDED);
    eval 'sub TH_ACK_NEEDED () {0x2000;}' unless defined(&TH_ACK_NEEDED);
    eval 'sub TH_NEED_SACK_REXMIT () {0x4000;}' unless defined(&TH_NEED_SACK_REXMIT);
    eval 'sub TH_TIMER_NEEDED () {0x8000;}' unless defined(&TH_TIMER_NEEDED);
    eval 'sub TH_ORDREL_NEEDED () {0x10000;}' unless defined(&TH_ORDREL_NEEDED);
    eval 'sub TH_MARKNEXT_NEEDED () {0x20000;}' unless defined(&TH_MARKNEXT_NEEDED);
    eval 'sub TH_SEND_URP_MARK () {0x40000;}' unless defined(&TH_SEND_URP_MARK);
    eval 'sub SEQ_LT {
        my($a, $b) = @_;
	    eval q((( &int32_t)(($a)-($b)) < 0));
    }' unless defined(&SEQ_LT);
    eval 'sub SEQ_LEQ {
        my($a, $b) = @_;
	    eval q((( &int32_t)(($a)-($b)) <= 0));
    }' unless defined(&SEQ_LEQ);
    eval 'sub SEQ_GT {
        my($a, $b) = @_;
	    eval q((( &int32_t)(($a)-($b)) > 0));
    }' unless defined(&SEQ_GT);
    eval 'sub SEQ_GEQ {
        my($a, $b) = @_;
	    eval q((( &int32_t)(($a)-($b)) >= 0));
    }' unless defined(&SEQ_GEQ);
    eval 'sub TCP_HDR_LENGTH {
        my($tcph) = @_;
	    eval q(((($tcph)-> $th_offset_and_rsrvd[0] >>2) (0xf << 2)));
    }' unless defined(&TCP_HDR_LENGTH);
    eval 'sub TCP_MAX_COMBINED_HEADER_LENGTH () {(60+ 60);}' unless defined(&TCP_MAX_COMBINED_HEADER_LENGTH);
    eval 'sub TCP_MAX_IP_OPTIONS_LENGTH () {(60-  &IP_SIMPLE_HDR_LENGTH);}' unless defined(&TCP_MAX_IP_OPTIONS_LENGTH);
    eval 'sub TCP_MAX_HDR_LENGTH () {60;}' unless defined(&TCP_MAX_HDR_LENGTH);
    eval 'sub TCP_MAX_TCP_OPTIONS_LENGTH () {(60- $sizeof{ &tcph_t});}' unless defined(&TCP_MAX_TCP_OPTIONS_LENGTH);
    eval 'sub TCP_MIN_HEADER_LENGTH () {20;}' unless defined(&TCP_MIN_HEADER_LENGTH);
    eval 'sub TCP_MAXWIN () {65535;}' unless defined(&TCP_MAXWIN);
    eval 'sub TCP_PORT_LEN () {$sizeof{ &in_port_t};}' unless defined(&TCP_PORT_LEN);
    eval 'sub TCP_MAX_WINSHIFT () {14;}' unless defined(&TCP_MAX_WINSHIFT);
    eval 'sub TCP_MAX_LARGEWIN () {( &TCP_MAXWIN <<  &TCP_MAX_WINSHIFT);}' unless defined(&TCP_MAX_LARGEWIN);
    eval 'sub TCPIP_HDR_LENGTH {
        my($mp, $n) = @_;
	    eval q(($n) =  &IPH_HDR_LENGTH(($mp)-> &b_rptr), ($n) +=  &TCP_HDR_LENGTH(( &tcph_t *)($mp)-> $b_rptr[($n)]));
    }' unless defined(&TCPIP_HDR_LENGTH);
    if((defined( &_KERNEL) || defined( &_KMEMUSER))) {
	eval 'sub TCP_ISS_VALID () {0x1;}' unless defined(&TCP_ISS_VALID);
	eval 'sub TCP_FSS_VALID () {0x2;}' unless defined(&TCP_FSS_VALID);
	eval 'sub TCP_URG_VALID () {0x4;}' unless defined(&TCP_URG_VALID);
	eval 'sub TCP_OFO_FIN_VALID () {0x8;}' unless defined(&TCP_OFO_FIN_VALID);
	eval 'sub tcp_dontdrop () { &tcp_syn_defense;}' unless defined(&tcp_dontdrop);
	eval 'sub tcp_pipe () { ($tcp_sack_info->{tcp_pipe});}' unless defined(&tcp_pipe);
	eval 'sub tcp_fack () { ($tcp_sack_info->{tcp_fack});}' unless defined(&tcp_fack);
	eval 'sub tcp_sack_snxt () { ($tcp_sack_info->{tcp_sack_snxt});}' unless defined(&tcp_sack_snxt);
	eval 'sub tcp_max_sack_blk () { ($tcp_sack_info->{tcp_max_sack_blk});}' unless defined(&tcp_max_sack_blk);
	eval 'sub tcp_num_sack_blk () { ($tcp_sack_info->{tcp_num_sack_blk});}' unless defined(&tcp_num_sack_blk);
	eval 'sub tcp_sack_list () { ($tcp_sack_info->{tcp_sack_list});}' unless defined(&tcp_sack_list);
	eval 'sub tcp_num_notsack_blk () { ($tcp_sack_info->{tcp_num_notsack_blk});}' unless defined(&tcp_num_notsack_blk);
	eval 'sub tcp_cnt_notsack_list () { ($tcp_sack_info->{tcp_cnt_notsack_list});}' unless defined(&tcp_cnt_notsack_list);
	eval 'sub tcp_notsack_list () { ($tcp_sack_info->{tcp_notsack_list});}' unless defined(&tcp_notsack_list);
	eval 'sub tcp_ip_addr_cache () { &tcp_reass_tail;}' unless defined(&tcp_ip_addr_cache);
	eval 'sub TCP_IPV6_RECVPKTINFO () {0x1;}' unless defined(&TCP_IPV6_RECVPKTINFO);
	eval 'sub TCP_IPV6_RECVHOPLIMIT () {0x2;}' unless defined(&TCP_IPV6_RECVHOPLIMIT);
	eval 'sub TCP_IPV6_RECVHOPOPTS () {0x4;}' unless defined(&TCP_IPV6_RECVHOPOPTS);
	eval 'sub TCP_IPV6_RECVDSTOPTS () {0x8;}' unless defined(&TCP_IPV6_RECVDSTOPTS);
	eval 'sub TCP_IPV6_RECVRTHDR () {0x10;}' unless defined(&TCP_IPV6_RECVRTHDR);
	eval 'sub TCP_IPV6_RECVRTDSTOPTS () {0x20;}' unless defined(&TCP_IPV6_RECVRTDSTOPTS);
	eval 'sub tcp_ipp_fields () { ($tcp_sticky_ipp->{tcp_ipp_fields});}' unless defined(&tcp_ipp_fields);
	eval 'sub tcp_ipp_ifindex () { ($tcp_sticky_ipp->{tcp_ipp_ifindex});}' unless defined(&tcp_ipp_ifindex);
	eval 'sub tcp_ipp_addr () { ($tcp_sticky_ipp->{tcp_ipp_addr});}' unless defined(&tcp_ipp_addr);
	eval 'sub tcp_ipp_hoplimit () { ($tcp_sticky_ipp->{tcp_ipp_hoplimit});}' unless defined(&tcp_ipp_hoplimit);
	eval 'sub tcp_ipp_hopoptslen () { ($tcp_sticky_ipp->{tcp_ipp_hopoptslen});}' unless defined(&tcp_ipp_hopoptslen);
	eval 'sub tcp_ipp_rtdstoptslen () { ($tcp_sticky_ipp->{tcp_ipp_rtdstoptslen});}' unless defined(&tcp_ipp_rtdstoptslen);
	eval 'sub tcp_ipp_rthdrlen () { ($tcp_sticky_ipp->{tcp_ipp_rthdrlen});}' unless defined(&tcp_ipp_rthdrlen);
	eval 'sub tcp_ipp_dstoptslen () { ($tcp_sticky_ipp->{tcp_ipp_dstoptslen});}' unless defined(&tcp_ipp_dstoptslen);
	eval 'sub tcp_ipp_hopopts () { ($tcp_sticky_ipp->{tcp_ipp_hopopts});}' unless defined(&tcp_ipp_hopopts);
	eval 'sub tcp_ipp_rtdstopts () { ($tcp_sticky_ipp->{tcp_ipp_rtdstopts});}' unless defined(&tcp_ipp_rtdstopts);
	eval 'sub tcp_ipp_rthdr () { ($tcp_sticky_ipp->{tcp_ipp_rthdr});}' unless defined(&tcp_ipp_rthdr);
	eval 'sub tcp_ipp_dstopts () { ($tcp_sticky_ipp->{tcp_ipp_dstopts});}' unless defined(&tcp_ipp_dstopts);
	eval 'sub tcp_ipp_nexthop () { ($tcp_sticky_ipp->{tcp_ipp_nexthop});}' unless defined(&tcp_ipp_nexthop);
	eval 'sub tcpb_ttl () { ($tcpb_hdr_info->{v4_hdr_info}->{v4_ttl});}' unless defined(&tcpb_ttl);
	eval 'sub tcpb_tos () { ($tcpb_hdr_info->{v4_hdr_info}->{v4_tos});}' unless defined(&tcpb_tos);
	eval 'sub tcpb_ip6_vcf () { ($tcpb_hdr_info->{v6_hdr_info}->{v6_vcf});}' unless defined(&tcpb_ip6_vcf);
	eval 'sub tcpb_ip6_hops () { ($tcpb_hdr_info->{v6_hdr_info}->{v6_hops});}' unless defined(&tcpb_ip6_hops);
	if(defined(&_KERNEL)) {
	    eval 'sub tcpb_remote () { &V4_PART_OF_V6( &tcpb_remote_v6);}' unless defined(&tcpb_remote);
	    eval 'sub tcpb_bound_source () { &V4_PART_OF_V6( &tcpb_bound_source_v6);}' unless defined(&tcpb_bound_source);
	    eval 'sub tcpb_ip_src () { &V4_PART_OF_V6( &tcpb_ip_src_v6);}' unless defined(&tcpb_ip_src);
	}
	eval 'sub tcpb_fport () { ($tcpb_tcpu->{tcpu_ports1}->{tcpu_fport});}' unless defined(&tcpb_fport);
	eval 'sub tcpb_lport () { ($tcpb_tcpu->{tcpu_ports1}->{tcpu_lport});}' unless defined(&tcpb_lport);
	eval 'sub tcpb_ports () { ($tcpb_tcpu->{tcpu_ports2});}' unless defined(&tcpb_ports);
	eval 'sub tcp_bind_hash () { ($tcp_base->{tcpb_bind_hash});}' unless defined(&tcp_bind_hash);
	eval 'sub tcp_ptpbhn () { ($tcp_base->{tcpb_ptpbhn});}' unless defined(&tcp_ptpbhn);
	eval 'sub tcp_conn_hash () { ($tcp_base->{tcpb_conn_hash});}' unless defined(&tcp_conn_hash);
	eval 'sub tcp_ptpchn () { ($tcp_base->{tcpb_ptpchn});}' unless defined(&tcp_ptpchn);
	eval 'sub tcp_time_wait_next () { ($tcp_base->{tcpb_time_wait_next});}' unless defined(&tcp_time_wait_next);
	eval 'sub tcp_time_wait_prev () { ($tcp_base->{tcpb_time_wait_prev});}' unless defined(&tcp_time_wait_prev);
	eval 'sub tcp_time_wait_expire () { ($tcp_base->{tcpb_time_wait_expire});}' unless defined(&tcp_time_wait_expire);
	eval 'sub tcp_last_rcv_lbolt () { ($tcp_base->{tcpb_last_rcv_lbolt});}' unless defined(&tcp_last_rcv_lbolt);
	eval 'sub tcp_state () { ($tcp_base->{tcpb_state});}' unless defined(&tcp_state);
	eval 'sub tcp_rcv_ws () { ($tcp_base->{tcpb_rcv_ws});}' unless defined(&tcp_rcv_ws);
	eval 'sub tcp_snd_ws () { ($tcp_base->{tcpb_snd_ws});}' unless defined(&tcp_snd_ws);
	eval 'sub tcp_ts_recent () { ($tcp_base->{tcpb_ts_recent});}' unless defined(&tcp_ts_recent);
	eval 'sub tcp_rto () { ($tcp_base->{tcpb_rto});}' unless defined(&tcp_rto);
	eval 'sub tcp_snd_ts_ok () { ($tcp_base->{tcpb_snd_ts_ok});}' unless defined(&tcp_snd_ts_ok);
	eval 'sub tcp_snd_ws_ok () { ($tcp_base->{tcpb_snd_ws_ok});}' unless defined(&tcp_snd_ws_ok);
	eval 'sub tcp_is_secure () { ($tcp_base->{tcpb_is_secure});}' unless defined(&tcp_is_secure);
	eval 'sub tcp_snxt () { ($tcp_base->{tcpb_snxt});}' unless defined(&tcp_snxt);
	eval 'sub tcp_swnd () { ($tcp_base->{tcpb_swnd});}' unless defined(&tcp_swnd);
	eval 'sub tcp_mss () { ($tcp_base->{tcpb_mss});}' unless defined(&tcp_mss);
	eval 'sub tcp_iss () { ($tcp_base->{tcpb_iss});}' unless defined(&tcp_iss);
	eval 'sub tcp_rnxt () { ($tcp_base->{tcpb_rnxt});}' unless defined(&tcp_rnxt);
	eval 'sub tcp_rwnd () { ($tcp_base->{tcpb_rwnd});}' unless defined(&tcp_rwnd);
	eval 'sub tcp_reflock () { ($tcp_base->{tcpb_reflock});}' unless defined(&tcp_reflock);
	eval 'sub tcp_refcnt () { ($tcp_base->{tcpb_refcnt});}' unless defined(&tcp_refcnt);
	eval 'sub tcp_remote_v6 () { ($tcp_base->{tcpb_remote_v6});}' unless defined(&tcp_remote_v6);
	eval 'sub tcp_remote () { ($tcp_base->{tcpb_remote});}' unless defined(&tcp_remote);
	eval 'sub tcp_bound_source_v6 () { ($tcp_base->{tcpb_bound_source_v6});}' unless defined(&tcp_bound_source_v6);
	eval 'sub tcp_bound_source () { ($tcp_base->{tcpb_bound_source});}' unless defined(&tcp_bound_source);
	eval 'sub tcp_lport () { ($tcp_base->{tcpb_tcpu}->{tcpu_ports1}->{tcpu_lport});}' unless defined(&tcp_lport);
	eval 'sub tcp_fport () { ($tcp_base->{tcpb_tcpu}->{tcpu_ports1}->{tcpu_fport});}' unless defined(&tcp_fport);
	eval 'sub tcp_ports () { ($tcp_base->{tcpb_tcpu}->{tcpu_ports2});}' unless defined(&tcp_ports);
	eval 'sub tcp_ipsec_out () { ($tcp_base->{tcpb_ipsec_out});}' unless defined(&tcp_ipsec_out);
	eval 'sub tcp_ipsec_req_in () { ($tcp_base->{tcpb_ipsec_req_in});}' unless defined(&tcp_ipsec_req_in);
	eval 'sub tcp_ipversion () { ($tcp_base->{tcpb_ipversion});}' unless defined(&tcp_ipversion);
	eval 'sub tcp_bound_if () { ($tcp_base->{tcpb_bound_if});}' unless defined(&tcp_bound_if);
	eval 'sub tcp_reuseaddr () { ($tcp_base->{tcpb_reuseaddr});}' unless defined(&tcp_reuseaddr);
	eval 'sub tcp_exclbind () { ($tcp_base->{tcpb_exclbind});}' unless defined(&tcp_exclbind);
	eval 'sub tcp_ownerid () { ($tcp_base->{tcpb_ownerid});}' unless defined(&tcp_ownerid);
    }
    eval 'sub CL_TCPI_V1 () {1;}' unless defined(&CL_TCPI_V1);
    if(defined(&_KERNEL)) {
	eval 'sub cl_tcpi_laddr () { &V4_PART_OF_V6( &cl_tcpi_laddr_v6);}' unless defined(&cl_tcpi_laddr);
	eval 'sub cl_tcpi_faddr () { &V4_PART_OF_V6( &cl_tcpi_faddr_v6);}' unless defined(&cl_tcpi_faddr);
    }
    eval 'sub TCP_IOC_ABORT_CONN () {((ord(\'T\') << 8) + 91);}' unless defined(&TCP_IOC_ABORT_CONN);
    if(defined(&__cplusplus)) {
    }
}
1;
