require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ISO_STDARG_ISO_H)) {
    eval 'sub _ISO_STDARG_ISO_H () {1;}' unless defined(&_ISO_STDARG_ISO_H);
    require 'sys/va_list.ph';
    if(defined(&__cplusplus)) {
    }
    if((defined(&__cplusplus) ? &__cplusplus : 0) >= 199711) {
    }
    if(!defined( &_VA_LIST) || (defined(&__cplusplus) ? &__cplusplus : 0) >= 199711) {
	eval 'sub _VA_LIST () {1;}' unless defined(&_VA_LIST);
    }
    if((defined(&__cplusplus) ? &__cplusplus : 0) >= 199711) {
    }
    if((defined( &__BUILTIN_VA_ARG_INCR) || defined( &__sparc) || defined( &__i386))  && !defined( &__lint)) {
	eval 'sub va_start {
	    my($list, $name) = @_;
    	    eval q(( &void) ($list = ( &__va_list) & &__builtin_va_alist));
	}' unless defined(&va_start);
	eval 'sub va_arg {
	    my($list, $mode) = @_;
    	    eval q((($mode *) &__builtin_va_arg_incr(($mode *)$list))[0]);
	}' unless defined(&va_arg);
    }
 elsif(defined( &__ia64)) {
	eval 'sub VA_ALIGN () {8;}' unless defined(&VA_ALIGN);
	eval 'sub _ARGSIZEOF {
	    my($t) = @_;
    	    eval q((($sizeof{$t} +  &VA_ALIGN - 1) & ~( &VA_ALIGN - 1)));
	}' unless defined(&_ARGSIZEOF);
	if(defined( &__epcg__)) {
	    eval 'sub va_start {
	        my($list, $name) = @_;
    		eval q(( &__va_start($list)));
	    }' unless defined(&va_start);
	} else {
	    eval 'sub va_start {
	        my($list, $name) = @_;
    		eval q(($list = ( &__va_list)$name +  &_ARGSIZEOF($name)));
	    }' unless defined(&va_start);
	}
	eval 'sub va_arg {
	    my($list, $t) = @_;
    	    eval q((*($t *)(($list +=  &_ARGSIZEOF($t)) -  &_ARGSIZEOF($t))));
	}' unless defined(&va_arg);
	eval 'sub va_end {
	    my($list) = @_;
    	    eval q(($list = ( &__va_list)0));
	}' unless defined(&va_end);
    } else {
	if((defined(&__STDC__) ? &__STDC__ : 0) != 0) {
	    eval 'sub va_start {
	        my($list, $name) = @_;
    		eval q(( &void) ($list = ( &void *)($name + (($sizeof{$name} + ($sizeof{\'int\'} - 1)) & ~($sizeof{\'int\'} - 1)))));
	    }' unless defined(&va_start);
	} else {
	    eval 'sub va_start {
	        my($list, $name) = @_;
    		eval q(( &void) ($list = ( &void *)(&...)));
	    }' unless defined(&va_start);
	}
	eval 'sub va_arg {
	    my($list, $mode) = @_;
    	    eval q((($mode *)($list = ( &void *)($list + $sizeof{$mode})))[-1]);
	}' unless defined(&va_arg);
    }
    if(!defined( &__ia64)) {
	eval 'sub va_end {
	    my($list) = @_;
    	    eval q(( &void)0);
	}' unless defined(&va_end);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
