require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__Kcs__)) {
    require 'kcs.ph';
}
unless(defined(&__KcsTypes__)) {
    eval 'sub __KcsTypes__ () {1;}' unless defined(&__KcsTypes__);
    if(defined(&KCS_ON_WINDOWS)) {
	eval 'sub KcsForceAlign () {0x7fff;}' unless defined(&KcsForceAlign);
    } else {
	eval 'sub KcsForceAlign () {0x7fffffff;}' unless defined(&KcsForceAlign);
    }
    if(defined(&_LP64)) {
    } else {
    }
    eval 'sub KP_USE_KBOOL () {1;}' unless defined(&KP_USE_KBOOL);
    require 'icc.ph';
    require 'kcsstats.ph';
    require 'time.ph';
    if(defined(&KCS_ON_SOLARIS)) {
	require 'X11/X.ph';
	require 'X11/Xlib.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub KCS_DEFAULT_ATTRIB_COUNT {
        my($data_type) = @_;
	    eval q((($sizeof{ &KcsAttributeValue} - $sizeof{ &KcsAttributeBase}) / $sizeof{$data_type}));
    }' unless defined(&KCS_DEFAULT_ATTRIB_COUNT);
    eval 'sub KcsCurrentVersion () {(0x332e3031);}' unless defined(&KcsCurrentVersion);
    eval 'sub KcsExtendableArray () {4;}' unless defined(&KcsExtendableArray);
    eval 'sub KcsExtendablePixelLayout () {4;}' unless defined(&KcsExtendablePixelLayout);
    eval 'sub KcsExtendableMeasSet () {4;}' unless defined(&KcsExtendableMeasSet);
    eval 'sub KcsAttrStrLength () {256;}' unless defined(&KcsAttrStrLength);
    eval 'sub KcsKodakColorSenseCMM () {(0x4b434d53);}' unless defined(&KcsKodakColorSenseCMM);
    if(defined(&KCS_ON_MAC)) {
    } else {
    }
    eval 'sub KcsEvalFunc () {(1<<0);}' unless defined(&KcsEvalFunc);
    eval 'sub KcsFreeFunc () {(1<<1);}' unless defined(&KcsFreeFunc);
    eval 'sub KcsGetAttrFunc () {(1<<2);}' unless defined(&KcsGetAttrFunc);
    eval 'sub KcsLoadFunc () {(1<<3);}' unless defined(&KcsLoadFunc);
    eval 'sub KcsConnectFunc () {(1<<4);}' unless defined(&KcsConnectFunc);
    eval 'sub KcsOptFunc () {(1<<5);}' unless defined(&KcsOptFunc);
    eval 'sub KcsModLoadHintsFunc () {(1<<6);}' unless defined(&KcsModLoadHintsFunc);
    eval 'sub KcsSaveFunc () {(1<<7);}' unless defined(&KcsSaveFunc);
    eval 'sub KcsSetAttrFunc () {(1<<8);}' unless defined(&KcsSetAttrFunc);
    eval 'sub KcsUpdateFunc () {(1<<9);}' unless defined(&KcsUpdateFunc);
    eval 'sub KcsCreateFunc () {(1<<10);}' unless defined(&KcsCreateFunc);
    eval 'sub KcsAllFunc () {(0xffffffff);}' unless defined(&KcsAllFunc);
    eval 'sub KcsNumbOfFuncs () {(13);}' unless defined(&KcsNumbOfFuncs);
    eval 'sub KcsRGB_R () {0;}' unless defined(&KcsRGB_R);
    eval 'sub KcsRGB_G () {1;}' unless defined(&KcsRGB_G);
    eval 'sub KcsRGB_B () {2;}' unless defined(&KcsRGB_B);
    eval 'sub KcsCMYK_C () {0;}' unless defined(&KcsCMYK_C);
    eval 'sub KcsCMYK_M () {1;}' unless defined(&KcsCMYK_M);
    eval 'sub KcsCMYK_Y () {2;}' unless defined(&KcsCMYK_Y);
    eval 'sub KcsCMYK_K () {3;}' unless defined(&KcsCMYK_K);
    eval 'sub KcsYCbC_Y () {0;}' unless defined(&KcsYCbC_Y);
    eval 'sub KcsYCbC_Cb () {1;}' unless defined(&KcsYCbC_Cb);
    eval 'sub KcsYCbC_Cy () {2;}' unless defined(&KcsYCbC_Cy);
    eval 'sub KcsCIEXYZ_X () {0;}' unless defined(&KcsCIEXYZ_X);
    eval 'sub KcsCIEXYZ_Y () {1;}' unless defined(&KcsCIEXYZ_Y);
    eval 'sub KcsCIEXYZ_Z () {2;}' unless defined(&KcsCIEXYZ_Z);
    eval 'sub KcsCIExyY_x () {1;}' unless defined(&KcsCIExyY_x);
    eval 'sub KcsCIExyY_y () {2;}' unless defined(&KcsCIExyY_y);
    eval 'sub KcsCIExyY_Y () {0;}' unless defined(&KcsCIExyY_Y);
    eval 'sub KcsCIEuvL_u () {1;}' unless defined(&KcsCIEuvL_u);
    eval 'sub KcsCIEuvL_v () {2;}' unless defined(&KcsCIEuvL_v);
    eval 'sub KcsCIEuvL_L () {0;}' unless defined(&KcsCIEuvL_L);
    eval 'sub KcsCIELuv_L () {0;}' unless defined(&KcsCIELuv_L);
    eval 'sub KcsCIELuv_u () {1;}' unless defined(&KcsCIELuv_u);
    eval 'sub KcsCIELuv_v () {2;}' unless defined(&KcsCIELuv_v);
    eval 'sub KcsCIELab_L () {0;}' unless defined(&KcsCIELab_L);
    eval 'sub KcsCIELab_a () {1;}' unless defined(&KcsCIELab_a);
    eval 'sub KcsCIELab_b () {2;}' unless defined(&KcsCIELab_b);
    eval 'sub KcsHSV_H () {0;}' unless defined(&KcsHSV_H);
    eval 'sub KcsHSV_S () {1;}' unless defined(&KcsHSV_S);
    eval 'sub KcsHSV_V () {2;}' unless defined(&KcsHSV_V);
    eval 'sub KcsHLS_H () {0;}' unless defined(&KcsHLS_H);
    eval 'sub KcsHLS_L () {1;}' unless defined(&KcsHLS_L);
    eval 'sub KcsHLS_S () {2;}' unless defined(&KcsHLS_S);
    eval 'sub KcsGRAY_K () {0;}' unless defined(&KcsGRAY_K);
    eval 'sub KcsMaxSamples () {4;}' unless defined(&KcsMaxSamples);
    eval 'sub KcsMaxPatches () {8;}' unless defined(&KcsMaxPatches);
    eval("sub KcsSpaceUnknown () { 0; }") unless defined(&KcsSpaceUnknown);
    eval("sub KcsRGB () { 1; }") unless defined(&KcsRGB);
    eval("sub KcsPhotoCDYcc () { 2; }") unless defined(&KcsPhotoCDYcc);
    eval("sub KcsUVLStar () { 3; }") unless defined(&KcsUVLStar);
    eval("sub KcsCMY () { 4; }") unless defined(&KcsCMY);
    eval("sub KcsCMYK () { 5; }") unless defined(&KcsCMYK);
    eval("sub KcsRCS () { 6; }") unless defined(&KcsRCS);
    eval("sub KcsCIEXYZ () { 7; }") unless defined(&KcsCIEXYZ);
    eval("sub KcsCIELAB () { 8; }") unless defined(&KcsCIELAB);
    eval("sub KcsCIELUV () { 9; }") unless defined(&KcsCIELUV);
    eval("sub KcsLogExp () { 10; }") unless defined(&KcsLogExp);
    eval("sub KcsGray () { 11; }") unless defined(&KcsGray);
    eval("sub Kcs2color () { 12; }") unless defined(&Kcs2color);
    eval("sub Kcs3color () { 13; }") unless defined(&Kcs3color);
    eval("sub Kcs4color () { 14; }") unless defined(&Kcs4color);
    eval("sub Kcs5color () { 15; }") unless defined(&Kcs5color);
    eval("sub Kcs6color () { 16; }") unless defined(&Kcs6color);
    eval("sub Kcs7color () { 17; }") unless defined(&Kcs7color);
    eval("sub Kcs8color () { 18; }") unless defined(&Kcs8color);
    eval("sub Kcs9color () { 19; }") unless defined(&Kcs9color);
    eval("sub Kcs10color () { 20; }") unless defined(&Kcs10color);
    eval("sub Kcs11color () { 21; }") unless defined(&Kcs11color);
    eval("sub Kcs12color () { 22; }") unless defined(&Kcs12color);
    eval("sub Kcs13color () { 23; }") unless defined(&Kcs13color);
    eval("sub Kcs14color () { 24; }") unless defined(&Kcs14color);
    eval("sub Kcs15color () { 25; }") unless defined(&Kcs15color);
    eval("sub KcsAttrEnd () { 26; }") unless defined(&KcsAttrEnd);
    eval("sub KcsAttrSpaceMax () { KcsForceAlign; }") unless defined(&KcsAttrSpaceMax);
    eval("sub KcsBlack () { 0; }") unless defined(&KcsBlack);
    eval("sub KcsWhite () { 1; }") unless defined(&KcsWhite);
    eval("sub KcsNeutral () { 2; }") unless defined(&KcsNeutral);
    eval("sub KcsFluorescent () { 3; }") unless defined(&KcsFluorescent);
    eval("sub KcsChromatic () { 4; }") unless defined(&KcsChromatic);
    eval("sub KcsSampleTypeEnd () { KcsForceAlign; }") unless defined(&KcsSampleTypeEnd);
    eval 'sub KcsCompFixed () {1;}' unless defined(&KcsCompFixed);
    eval 'sub KcsCompUFixed () {2;}' unless defined(&KcsCompUFixed);
    eval 'sub KcsCompFloat () {3;}' unless defined(&KcsCompFloat);
    eval 'sub KcsCompName () {4;}' unless defined(&KcsCompName);
    eval 'sub KcsOptNone () {(0);}' unless defined(&KcsOptNone);
    eval 'sub KcsOptAccuracy () {(1<<0);}' unless defined(&KcsOptAccuracy);
    eval 'sub KcsOptSpeed () {(1<<1);}' unless defined(&KcsOptSpeed);
    eval 'sub KcsOptSize () {(1<<2);}' unless defined(&KcsOptSize);
    eval 'sub icSigSInt8ArrayType () {(0x73693038);}' unless defined(&icSigSInt8ArrayType);
    eval 'sub icSigSInt16ArrayType () {(0x73693136);}' unless defined(&icSigSInt16ArrayType);
    eval 'sub icSigSInt32ArrayType () {(0x73693332);}' unless defined(&icSigSInt32ArrayType);
    eval 'sub icSigSFlt64ArrayType () {(0x73663634);}' unless defined(&icSigSFlt64ArrayType);
    eval 'sub icSigPixelLayoutSType () {(0x706c6179);}' unless defined(&icSigPixelLayoutSType);
    eval 'sub icSigAliasType () {(0x6c696173);}' unless defined(&icSigAliasType);
    eval 'sub icSigHeaderType () {(0x69636865);}' unless defined(&icSigHeaderType);
    eval 'sub icSigHeaderTag () {(0x69636864);}' unless defined(&icSigHeaderTag);
    eval 'sub icSigNumTag () {(0x6e746167);}' unless defined(&icSigNumTag);
    eval 'sub icSigListTag () {(0x6c746167);}' unless defined(&icSigListTag);
    eval("sub KcsString () { 2; }") unless defined(&KcsString);
    eval("sub KcsDateTimeStamp () { 9; }") unless defined(&KcsDateTimeStamp);
    eval("sub KcsUByte () { icSigUInt8ArrayType; }") unless defined(&KcsUByte);
    eval("sub KcsUShort () { icSigUInt16ArrayType; }") unless defined(&KcsUShort);
    eval("sub KcsULong () { icSigUInt32ArrayType; }") unless defined(&KcsULong);
    eval("sub KcsByte () { icSigSInt8ArrayType; }") unless defined(&KcsByte);
    eval("sub KcsShort () { icSigSInt16ArrayType; }") unless defined(&KcsShort);
    eval("sub KcsLong () { icSigSInt32ArrayType; }") unless defined(&KcsLong);
    eval("sub KcsDouble () { icSigSFlt64ArrayType; }") unless defined(&KcsDouble);
    eval("sub KcsPixelLayoutSupported () { icSigPixelLayoutSType; }") unless defined(&KcsPixelLayoutSupported);
    eval("sub KcsAlias () { icSigAliasType; }") unless defined(&KcsAlias);
    eval("sub KcsLong_PreIC () { 0; }") unless defined(&KcsLong_PreIC);
    eval("sub KcsDouble_PreIC () { 1; }") unless defined(&KcsDouble_PreIC);
    eval("sub KcsByte_PreIC () { 10; }") unless defined(&KcsByte_PreIC);
    eval("sub KcsUByte_PreIC () { 11; }") unless defined(&KcsUByte_PreIC);
    eval("sub KcsShort_PreIC () { 12; }") unless defined(&KcsShort_PreIC);
    eval("sub KcsUShort_PreIC () { 13; }") unless defined(&KcsUShort_PreIC);
    eval("sub KcsULong_PreIC () { 14; }") unless defined(&KcsULong_PreIC);
    eval("sub KcsPixelLayoutSupported_PreIC () { 15; }") unless defined(&KcsPixelLayoutSupported_PreIC);
    eval("sub KcsMeasurements_PreIC () { 16; }") unless defined(&KcsMeasurements_PreIC);
    eval("sub KcsAlias_PreIC () { 17; }") unless defined(&KcsAlias_PreIC);
    eval("sub KcsLastAttrType_PreIC () { 18; }") unless defined(&KcsLastAttrType_PreIC);
    eval("sub KcsAttrTypeEnd_PreIC () { 19; }") unless defined(&KcsAttrTypeEnd_PreIC);
    eval("sub KcsAttrTypeMax () { KcsForceAlign; }") unless defined(&KcsAttrTypeMax);
    eval 'sub KcsOpForward () {(0x1);}' unless defined(&KcsOpForward);
    eval 'sub KcsOpReverse () {(0x2);}' unless defined(&KcsOpReverse);
    eval 'sub KcsOpSimulate () {(0x4);}' unless defined(&KcsOpSimulate);
    eval 'sub KcsOpGamutTest () {(0x8);}' unless defined(&KcsOpGamutTest);
    eval 'sub KcsOpAll () {(0x3ff);}' unless defined(&KcsOpAll);
    eval 'sub KcsContUnknown () {(0x);}' unless defined(&KcsContUnknown);
    eval 'sub KcsContGraphics () {(0x10000);}' unless defined(&KcsContGraphics);
    eval 'sub KcsContImage () {(0x20000);}' unless defined(&KcsContImage);
    eval 'sub KcsContColorimetric () {(0x40000);}' unless defined(&KcsContColorimetric);
    eval 'sub KcsContAll () {(0xff0000);}' unless defined(&KcsContAll);
    eval 'sub KcsMaskOp () {( &KcsOpAll);}' unless defined(&KcsMaskOp);
    eval 'sub KcsMaskCont () {( &KcsContAll);}' unless defined(&KcsMaskCont);
    eval 'sub KcsMaskAttr () {(0x800);}' unless defined(&KcsMaskAttr);
    eval 'sub KcsMaskLogical () {(0x80000000);}' unless defined(&KcsMaskLogical);
    eval 'sub KcsMaskLoadWhen () {(0x7f000000);}' unless defined(&KcsMaskLoadWhen);
    eval 'sub KcsMaskUnloadWhen () {(0xf000);}' unless defined(&KcsMaskUnloadWhen);
    eval 'sub KcsMaskLoadWhere () {(0x400);}' unless defined(&KcsMaskLoadWhere);
    eval 'sub KcsMaskEffect () {(0x200);}' unless defined(&KcsMaskEffect);
    eval 'sub KcsMaskWhat () {( &KcsMaskOp+ &KcsMaskCont+ &KcsMaskAttr);}' unless defined(&KcsMaskWhat);
    eval 'sub KcsHeapApp () {(0);}' unless defined(&KcsHeapApp);
    eval 'sub KcsHeapSys () {(0x400);}' unless defined(&KcsHeapSys);
    eval 'sub KcsNothing () {(0x);}' unless defined(&KcsNothing);
    eval 'sub KcsAttributes () {(0x800);}' unless defined(&KcsAttributes);
    eval 'sub KcsEffect () {(0x200);}' unless defined(&KcsEffect);
    eval 'sub KcsAll () {( &KcsMaskWhat);}' unless defined(&KcsAll);
    eval 'sub KcsLoadNever () {(0x);}' unless defined(&KcsLoadNever);
    eval 'sub KcsLoadNow () {(0x1000000);}' unless defined(&KcsLoadNow);
    eval 'sub KcsLoadWhenNeeded () {(0x2000000);}' unless defined(&KcsLoadWhenNeeded);
    eval 'sub KcsLoadWhenIdle () {(0x4000000);}' unless defined(&KcsLoadWhenIdle);
    eval 'sub KcsUnloadNow () {(0x1000);}' unless defined(&KcsUnloadNow);
    eval 'sub KcsUnloadWhenFreed () {(0x2000);}' unless defined(&KcsUnloadWhenFreed);
    eval 'sub KcsUnloadWhenNeeded () {(0x4000);}' unless defined(&KcsUnloadWhenNeeded);
    eval 'sub KcsUnloadAfterUse () {(0x8000);}' unless defined(&KcsUnloadAfterUse);
    eval 'sub KcsStartOverWithThis () {(0x10000000);}' unless defined(&KcsStartOverWithThis);
    eval 'sub KcsAddToCurrentHints () {(0x);}' unless defined(&KcsAddToCurrentHints);
    eval 'sub KcsLoadAllNow () {( &KcsAll| &KcsLoadNow| &KcsUnloadWhenFreed | &KcsStartOverWithThis);}' unless defined(&KcsLoadAllNow);
    eval 'sub KcsLoadAllWhenNeeded () {( &KcsAll| &KcsLoadWhenNeeded| &KcsUnloadWhenFreed | &KcsStartOverWithThis);}' unless defined(&KcsLoadAllWhenNeeded);
    eval 'sub KcsLoadAttributesNow () {( &KcsAttributes| &KcsLoadNow| &KcsUnloadWhenFreed | &KcsStartOverWithThis);}' unless defined(&KcsLoadAttributesNow);
    eval 'sub KcsLoadMinimalMemory () {( &KcsAll| &KcsLoadWhenNeeded| &KcsUnloadAfterUse | &KcsStartOverWithThis);}' unless defined(&KcsLoadMinimalMemory);
    eval 'sub KcsPurgeMemoryNow () {( &KcsAll| &KcsLoadWhenNeeded| &KcsUnloadNow | &KcsStartOverWithThis);}' unless defined(&KcsPurgeMemoryNow);
    eval("sub KcsFileProfile () { 0x46696C65; }") unless defined(&KcsFileProfile);
    eval("sub KcsMemoryProfile () { 0x4D426C00; }") unless defined(&KcsMemoryProfile);
    eval("sub KcsProfileTypeEnd () { 0x7FFFFFFF; }") unless defined(&KcsProfileTypeEnd);
    eval("sub KcsProfileTypeMax () { KcsForceAlign; }") unless defined(&KcsProfileTypeMax);
    if(defined(&KCS_ON_SOLARIS)) {
    }
    eval("sub KcsIdentifierSpec () { 0x49640000; }") unless defined(&KcsIdentifierSpec);
    eval("sub KcsCreationTypeEnd () { 0xFFFFFFFFL; }") unless defined(&KcsCreationTypeEnd);
    eval("sub KcsCreationTypeMax () { KcsForceAlign; }") unless defined(&KcsCreationTypeMax);
    if(defined(&__cplusplus)) {
    }
}
1;
