require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LIMITS_H)) {
    eval 'sub _LIMITS_H () {1;}' unless defined(&_LIMITS_H);
    require 'sys/feature_tests.ph';
    require 'sys/isa_defs.ph';
    require 'iso/limits_iso.ph';
    if(defined( &__EXTENSIONS__) || (defined(&__STDC__) ? &__STDC__ : 0) - 0== 0|| defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE)) {
	require 'sys/int_limits.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined( &__EXTENSIONS__) || (defined(&__STDC__) ? &__STDC__ : 0) - 0== 0|| defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE)) {
	eval 'sub SIZE_MAX () { &ULONG_MAX;}' unless defined(&SIZE_MAX);
	eval 'sub SSIZE_MAX () { &LONG_MAX;}' unless defined(&SSIZE_MAX);
	eval 'sub _ARG_MAX32 () {1048320;}' unless defined(&_ARG_MAX32);
	eval 'sub _ARG_MAX64 () {2096640;}' unless defined(&_ARG_MAX64);
	if(defined(&_LP64)) {
	    eval 'sub ARG_MAX () { &_ARG_MAX64;}' unless defined(&ARG_MAX);
	} else {
	    eval 'sub ARG_MAX () { &_ARG_MAX32;}' unless defined(&ARG_MAX);
	}
	eval 'sub LINK_MAX () {32767;}' unless defined(&LINK_MAX);
	unless(defined(&MAX_CANON)) {
	    eval 'sub MAX_CANON () {256;}' unless defined(&MAX_CANON);
	}
	unless(defined(&MAX_INPUT)) {
	    eval 'sub MAX_INPUT () {512;}' unless defined(&MAX_INPUT);
	}
	eval 'sub NGROUPS_MAX () {16;}' unless defined(&NGROUPS_MAX);
	unless(defined(&PATH_MAX)) {
	    eval 'sub PATH_MAX () {1024;}' unless defined(&PATH_MAX);
	}
	eval 'sub PIPE_BUF () {5120;}' unless defined(&PIPE_BUF);
	unless(defined(&TMP_MAX)) {
	    eval 'sub TMP_MAX () {17576;}' unless defined(&TMP_MAX);
	}
	eval 'sub _POSIX_AIO_LISTIO_MAX () {2;}' unless defined(&_POSIX_AIO_LISTIO_MAX);
	eval 'sub _POSIX_AIO_MAX () {1;}' unless defined(&_POSIX_AIO_MAX);
	eval 'sub _POSIX_ARG_MAX () {4096;}' unless defined(&_POSIX_ARG_MAX);
	eval 'sub _POSIX_CHILD_MAX () {6;}' unless defined(&_POSIX_CHILD_MAX);
	eval 'sub _POSIX_CLOCKRES_MIN () {20000000;}' unless defined(&_POSIX_CLOCKRES_MIN);
	eval 'sub _POSIX_DELAYTIMER_MAX () {32;}' unless defined(&_POSIX_DELAYTIMER_MAX);
	eval 'sub _POSIX_LINK_MAX () {8;}' unless defined(&_POSIX_LINK_MAX);
	eval 'sub _POSIX_MAX_CANON () {255;}' unless defined(&_POSIX_MAX_CANON);
	eval 'sub _POSIX_MAX_INPUT () {255;}' unless defined(&_POSIX_MAX_INPUT);
	eval 'sub _POSIX_MQ_OPEN_MAX () {8;}' unless defined(&_POSIX_MQ_OPEN_MAX);
	eval 'sub _POSIX_MQ_PRIO_MAX () {32;}' unless defined(&_POSIX_MQ_PRIO_MAX);
	eval 'sub _POSIX_NAME_MAX () {14;}' unless defined(&_POSIX_NAME_MAX);
	eval 'sub _POSIX_NGROUPS_MAX () {0;}' unless defined(&_POSIX_NGROUPS_MAX);
	eval 'sub _POSIX_OPEN_MAX () {16;}' unless defined(&_POSIX_OPEN_MAX);
	eval 'sub _POSIX_PATH_MAX () {255;}' unless defined(&_POSIX_PATH_MAX);
	eval 'sub _POSIX_PIPE_BUF () {512;}' unless defined(&_POSIX_PIPE_BUF);
	eval 'sub _POSIX_RTSIG_MAX () {8;}' unless defined(&_POSIX_RTSIG_MAX);
	eval 'sub _POSIX_SEM_NSEMS_MAX () {256;}' unless defined(&_POSIX_SEM_NSEMS_MAX);
	eval 'sub _POSIX_SEM_VALUE_MAX () {32767;}' unless defined(&_POSIX_SEM_VALUE_MAX);
	eval 'sub _POSIX_SIGQUEUE_MAX () {32;}' unless defined(&_POSIX_SIGQUEUE_MAX);
	eval 'sub _POSIX_SSIZE_MAX () {32767;}' unless defined(&_POSIX_SSIZE_MAX);
	eval 'sub _POSIX_STREAM_MAX () {8;}' unless defined(&_POSIX_STREAM_MAX);
	eval 'sub _POSIX_TIMER_MAX () {32;}' unless defined(&_POSIX_TIMER_MAX);
	eval 'sub _POSIX_TZNAME_MAX () {3;}' unless defined(&_POSIX_TZNAME_MAX);
	eval 'sub _POSIX_LOGIN_NAME_MAX () {9;}' unless defined(&_POSIX_LOGIN_NAME_MAX);
	eval 'sub _POSIX_THREAD_DESTRUCTOR_ITERATIONS () {4;}' unless defined(&_POSIX_THREAD_DESTRUCTOR_ITERATIONS);
	eval 'sub _POSIX_THREAD_KEYS_MAX () {128;}' unless defined(&_POSIX_THREAD_KEYS_MAX);
	eval 'sub _POSIX_THREAD_THREADS_MAX () {64;}' unless defined(&_POSIX_THREAD_THREADS_MAX);
	eval 'sub _POSIX_TTY_NAME_MAX () {9;}' unless defined(&_POSIX_TTY_NAME_MAX);
	eval 'sub _POSIX2_BC_BASE_MAX () {99;}' unless defined(&_POSIX2_BC_BASE_MAX);
	eval 'sub _POSIX2_BC_DIM_MAX () {2048;}' unless defined(&_POSIX2_BC_DIM_MAX);
	eval 'sub _POSIX2_BC_SCALE_MAX () {99;}' unless defined(&_POSIX2_BC_SCALE_MAX);
	eval 'sub _POSIX2_BC_STRING_MAX () {1000;}' unless defined(&_POSIX2_BC_STRING_MAX);
	eval 'sub _POSIX2_COLL_WEIGHTS_MAX () {10;}' unless defined(&_POSIX2_COLL_WEIGHTS_MAX);
	eval 'sub _POSIX2_EXPR_NEST_MAX () {32;}' unless defined(&_POSIX2_EXPR_NEST_MAX);
	eval 'sub _POSIX2_LINE_MAX () {2048;}' unless defined(&_POSIX2_LINE_MAX);
	eval 'sub _POSIX2_RE_DUP_MAX () {255;}' unless defined(&_POSIX2_RE_DUP_MAX);
	eval 'sub BC_BASE_MAX () { &_POSIX2_BC_BASE_MAX;}' unless defined(&BC_BASE_MAX);
	eval 'sub BC_DIM_MAX () { &_POSIX2_BC_DIM_MAX;}' unless defined(&BC_DIM_MAX);
	eval 'sub BC_SCALE_MAX () { &_POSIX2_BC_SCALE_MAX;}' unless defined(&BC_SCALE_MAX);
	eval 'sub BC_STRING_MAX () { &_POSIX2_BC_STRING_MAX;}' unless defined(&BC_STRING_MAX);
	eval 'sub COLL_WEIGHTS_MAX () { &_POSIX2_COLL_WEIGHTS_MAX;}' unless defined(&COLL_WEIGHTS_MAX);
	eval 'sub EXPR_NEST_MAX () { &_POSIX2_EXPR_NEST_MAX;}' unless defined(&EXPR_NEST_MAX);
	eval 'sub LINE_MAX () { &_POSIX2_LINE_MAX;}' unless defined(&LINE_MAX);
	eval 'sub RE_DUP_MAX () { &_POSIX2_RE_DUP_MAX;}' unless defined(&RE_DUP_MAX);
    }
    if(defined( &__EXTENSIONS__) || ((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_POSIX_C_SOURCE)) || defined( &_XOPEN_SOURCE)) {
	eval 'sub PASS_MAX () {8;}' unless defined(&PASS_MAX);
	eval 'sub CHARCLASS_NAME_MAX () {14;}' unless defined(&CHARCLASS_NAME_MAX);
	eval 'sub NL_ARGMAX () {9;}' unless defined(&NL_ARGMAX);
	eval 'sub NL_LANGMAX () {14;}' unless defined(&NL_LANGMAX);
	eval 'sub NL_MSGMAX () {32767;}' unless defined(&NL_MSGMAX);
	eval 'sub NL_NMAX () {1;}' unless defined(&NL_NMAX);
	eval 'sub NL_SETMAX () {255;}' unless defined(&NL_SETMAX);
	eval 'sub NL_TEXTMAX () {2048;}' unless defined(&NL_TEXTMAX);
	eval 'sub NZERO () {20;}' unless defined(&NZERO);
	eval 'sub WORD_BIT () {32;}' unless defined(&WORD_BIT);
	if(defined( &_LP64)) {
	    eval 'sub LONG_BIT () {64;}' unless defined(&LONG_BIT);
	} else {
	    eval 'sub LONG_BIT () {32;}' unless defined(&LONG_BIT);
	}
	eval 'sub DBL_DIG () {15;}' unless defined(&DBL_DIG);
	eval 'sub DBL_MAX () {1.7976931348623157E+308;}' unless defined(&DBL_MAX);
	eval 'sub DBL_MIN () {2.2250738585072014E-308;}' unless defined(&DBL_MIN);
	eval 'sub FLT_DIG () {6;}' unless defined(&FLT_DIG);
	eval 'sub FLT_MAX () {3.402823466E+38;}' unless defined(&FLT_MAX);
	eval 'sub FLT_MIN () {1.175494351E-38;}' unless defined(&FLT_MIN);
    }
    eval 'sub ATEXIT_MAX () {32;}' unless defined(&ATEXIT_MAX);
    eval 'sub _XOPEN_IOV_MAX () {16;}' unless defined(&_XOPEN_IOV_MAX);
    eval 'sub IOV_MAX () { &_XOPEN_IOV_MAX;}' unless defined(&IOV_MAX);
    if(defined( &__EXTENSIONS__) || ((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE))) {
	eval 'sub FCHR_MAX () {1048576;}' unless defined(&FCHR_MAX);
	eval 'sub PID_MAX () {999999;}' unless defined(&PID_MAX);
	eval 'sub CHILD_MAX () {25;}' unless defined(&CHILD_MAX);
	unless(defined(&OPEN_MAX)) {
	    eval 'sub OPEN_MAX () {256;}' unless defined(&OPEN_MAX);
	}
	eval 'sub PIPE_MAX () {5120;}' unless defined(&PIPE_MAX);
	eval 'sub STD_BLK () {1024;}' unless defined(&STD_BLK);
	eval 'sub UID_MAX () {2147483647;}' unless defined(&UID_MAX);
	eval 'sub USI_MAX () {4294967295;}' unless defined(&USI_MAX);
	eval 'sub SYSPID_MAX () {1;}' unless defined(&SYSPID_MAX);
	unless(defined(&SYS_NMLN)) {
	    eval 'sub SYS_NMLN () {257;}' unless defined(&SYS_NMLN);
	}
	unless(defined(&CLK_TCK)) {
	    unless(defined(&_CLOCK_T)) {
		eval 'sub _CLOCK_T () {1;}' unless defined(&_CLOCK_T);
	    }
	    eval 'sub CLK_TCK () {(( &clock_t) &_sysconf(3));}' unless defined(&CLK_TCK);
	}
	eval 'sub LOGNAME_MAX () {8;}' unless defined(&LOGNAME_MAX);
	eval 'sub TTYNAME_MAX () {128;}' unless defined(&TTYNAME_MAX);
	eval 'sub LLONG_MIN () {(-9223372036854775807-1);}' unless defined(&LLONG_MIN);
	eval 'sub LLONG_MAX () {9223372036854775807;}' unless defined(&LLONG_MAX);
	eval 'sub ULLONG_MAX () {18446744073709551615;}' unless defined(&ULLONG_MAX);
    }
    if(defined( &__EXTENSIONS__) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) >= 199506)) {
	require 'sys/unistd.ph';
	unless(defined(&_SIZE_T)) {
	    eval 'sub _SIZE_T () {1;}' unless defined(&_SIZE_T);
	    if(defined( &_LP64) || defined( &_I32LPx)) {
	    } else {
	    }
	}
	eval 'sub PTHREAD_STACK_MIN () {( &_sysconf( &_SC_THREAD_STACK_MIN));}' unless defined(&PTHREAD_STACK_MIN);
	eval 'sub PTHREAD_DESTRUCTOR_ITERATIONS () { &_POSIX_THREAD_DESTRUCTOR_ITERATIONS;}' unless defined(&PTHREAD_DESTRUCTOR_ITERATIONS);
	eval 'sub PTHREAD_KEYS_MAX () { &_POSIX_THREAD_KEYS_MAX;}' unless defined(&PTHREAD_KEYS_MAX);
	eval 'sub PTHREAD_THREADS_MAX () { &_POSIX_THREAD_THREADS_MAX;}' unless defined(&PTHREAD_THREADS_MAX);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
