require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MATH_H)) {
    eval 'sub _MATH_H () {1;}' unless defined(&_MATH_H);
    require 'iso/math_iso.ph';
    if((defined(&__cplusplus) ? &__cplusplus : 0) >= 199711) {
    }
    if(defined(&__cplusplus)) {
    }
    if(defined( &_POSIX_SOURCE)  && !defined( &_POSIX_C_SOURCE)) {
	eval 'sub _POSIX_C_SOURCE () {1;}' unless defined(&_POSIX_C_SOURCE);
    }
    if(defined(&__STDC__)) {
	eval 'sub __P {
	    my($p) = @_;
    	    eval q($p);
	}' unless defined(&__P);
    } else {
	eval 'sub __P {
	    my($p) = @_;
    	    eval q(());
	}' unless defined(&__P);
    }
    if(defined( &__EXTENSIONS__) || (defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE)) {
	eval 'sub M_E () {2.7182818284590452354;}' unless defined(&M_E);
	eval 'sub M_LOG2E () {1.4426950408889634074;}' unless defined(&M_LOG2E);
	eval 'sub M_LOG10E () {0.43429448190325182765;}' unless defined(&M_LOG10E);
	eval 'sub M_LN2 () {0.69314718055994530942;}' unless defined(&M_LN2);
	eval 'sub M_LN10 () {2.30258509299404568402;}' unless defined(&M_LN10);
	eval 'sub M_PI () {3.14159265358979323846;}' unless defined(&M_PI);
	eval 'sub M_PI_2 () {1.57079632679489661923;}' unless defined(&M_PI_2);
	eval 'sub M_PI_4 () {0.78539816339744830962;}' unless defined(&M_PI_4);
	eval 'sub M_1_PI () {0.31830988618379067154;}' unless defined(&M_1_PI);
	eval 'sub M_2_PI () {0.63661977236758134308;}' unless defined(&M_2_PI);
	eval 'sub M_2_SQRTPI () {1.12837916709551257390;}' unless defined(&M_2_SQRTPI);
	eval 'sub M_SQRT2 () {1.41421356237309504880;}' unless defined(&M_SQRT2);
	eval 'sub M_SQRT1_2 () {0.70710678118654752440;}' unless defined(&M_SQRT1_2);
	eval 'sub MAXFLOAT () {(3.40282346638528860e+38);}' unless defined(&MAXFLOAT);
	if(defined( &__EXTENSIONS__) || !defined( &_XOPEN_SOURCE)) {
	    eval("sub libm_ieee () { -1; }") unless defined(&libm_ieee);
	    eval("sub c_issue_4 () { 0; }") unless defined(&c_issue_4);
	    eval("sub ansi_1 () { 1; }") unless defined(&ansi_1);
	    eval("sub strict_ansi () { 2; }") unless defined(&strict_ansi);
	    if(defined(&__STDC__)) {
	    } else {
	    }
	    eval 'sub HUGE () { &MAXFLOAT;}' unless defined(&HUGE);
	    eval 'sub _ABS {
	        my($x) = @_;
    		eval q((($x) < 0? -($x) : ($x)));
	    }' unless defined(&_ABS);
	    eval 'sub _REDUCE {
	        my($TYPE, $X, $XN, $C1, $C2) = @_;
    		eval q({ \'double\'  &x1 = ($TYPE)$X,  &x2 = $X -  &x1; $X =  &x1 - ($XN) * ($C1); $X +=  &x2; $X -= ($XN) * ($C2); });
	    }' unless defined(&_REDUCE);
	    eval 'sub DOMAIN () {1;}' unless defined(&DOMAIN);
	    eval 'sub SING () {2;}' unless defined(&SING);
	    eval 'sub OVERFLOW () {3;}' unless defined(&OVERFLOW);
	    eval 'sub UNDERFLOW () {4;}' unless defined(&UNDERFLOW);
	    eval 'sub TLOSS () {5;}' unless defined(&TLOSS);
	    eval 'sub PLOSS () {6;}' unless defined(&PLOSS);
	    eval 'sub _POLY1 {
	        my($x, $c) = @_;
    		eval q((($c)[0] * ($x) + ($c)[1]));
	    }' unless defined(&_POLY1);
	    eval 'sub _POLY2 {
	        my($x, $c) = @_;
    		eval q(( &_POLY1(($x), ($c)) * ($x) + ($c)[2]));
	    }' unless defined(&_POLY2);
	    eval 'sub _POLY3 {
	        my($x, $c) = @_;
    		eval q(( &_POLY2(($x), ($c)) * ($x) + ($c)[3]));
	    }' unless defined(&_POLY3);
	    eval 'sub _POLY4 {
	        my($x, $c) = @_;
    		eval q(( &_POLY3(($x), ($c)) * ($x) + ($c)[4]));
	    }' unless defined(&_POLY4);
	    eval 'sub _POLY5 {
	        my($x, $c) = @_;
    		eval q(( &_POLY4(($x), ($c)) * ($x) + ($c)[5]));
	    }' unless defined(&_POLY5);
	    eval 'sub _POLY6 {
	        my($x, $c) = @_;
    		eval q(( &_POLY5(($x), ($c)) * ($x) + ($c)[6]));
	    }' unless defined(&_POLY6);
	    eval 'sub _POLY7 {
	        my($x, $c) = @_;
    		eval q(( &_POLY6(($x), ($c)) * ($x) + ($c)[7]));
	    }' unless defined(&_POLY7);
	    eval 'sub _POLY8 {
	        my($x, $c) = @_;
    		eval q(( &_POLY7(($x), ($c)) * ($x) + ($c)[8]));
	    }' unless defined(&_POLY8);
	    eval 'sub _POLY9 {
	        my($x, $c) = @_;
    		eval q(( &_POLY8(($x), ($c)) * ($x) + ($c)[9]));
	    }' unless defined(&_POLY9);
	}
    }
    if(defined( &__EXTENSIONS__) || (defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE)) {
	if(defined( &__MATHERR_ERRNO_DONTCARE)) {
	}
	if(defined( &__EXTENSIONS__) || !defined( &_XOPEN_SOURCE) || (defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) - 0== 500|| defined( &_XOPEN_SOURCE)  && (defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0) - 0== 1) {
	    if(defined( &__MATHERR_ERRNO_DONTCARE)) {
	    }
	    if(defined( &__MATHERR_ERRNO_DONTCARE)) {
	    }
	}
	if(defined( &__EXTENSIONS__) || !defined( &_XOPEN_SOURCE)) {
	    if(defined( &__MATHERR_ERRNO_DONTCARE)) {
	    }
	    if(defined(&_REENTRANT)) {
		if(defined( &__MATHERR_ERRNO_DONTCARE)) {
		}
	    }
	    if(defined( &__MATHERR_ERRNO_DONTCARE)) {
	    }
	    if(defined( &__EXTENSIONS__) || !defined( &__cplusplus)) {
		require 'floatingpoint.ph';
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
