require '_h2ph_pre.ph';

no warnings 'redefine';

# "@(#)ci.h 1.7 93/05/19 SMI"
unless(defined(&_MLE_CI_H)) {
    eval 'sub _MLE_CI_H () {1;}' unless defined(&_MLE_CI_H);
    require 'sys/types.ph';
    require 'mle/cs.ph';
    eval 'sub CI_OK () {0x;}' unless defined(&CI_OK);
    eval 'sub CI_ERR_EXIST () {0x1;}' unless defined(&CI_ERR_EXIST);
    eval 'sub CI_ERR_CONNECT () {0x2;}' unless defined(&CI_ERR_CONNECT);
    eval 'sub CI_ERR_DISCONNECT () {0x3;}' unless defined(&CI_ERR_DISCONNECT);
    eval 'sub CI_ERR_LIMIT () {0x4;}' unless defined(&CI_ERR_LIMIT);
    eval 'sub CI_ERR_NOMEM () {0x5;}' unless defined(&CI_ERR_NOMEM);
    eval 'sub CI_ERR_INACTIVE () {0xf;}' unless defined(&CI_ERR_INACTIVE);
    eval 'sub CI_ERR_UNDEFINED () {0x10;}' unless defined(&CI_ERR_UNDEFINED);
    eval 'sub CI_ERR_NOSUPPORT () {0x11;}' unless defined(&CI_ERR_NOSUPPORT);
    eval 'sub CI_ERR_PARAM () {0x12;}' unless defined(&CI_ERR_PARAM);
    eval 'sub CI_ERR_FORMAT () {0x13;}' unless defined(&CI_ERR_FORMAT);
    eval 'sub CI_ERR_MISSING () {0x20;}' unless defined(&CI_ERR_MISSING);
    eval 'sub CI_ERR_NODICT () {0x21;}' unless defined(&CI_ERR_NODICT);
    eval 'sub CI_ERR_ACCESS () {0x22;}' unless defined(&CI_ERR_ACCESS);
    eval 'sub CI_ERR_PERMIT () {0x23;}' unless defined(&CI_ERR_PERMIT);
    eval 'sub CI_ERR_ILLGAL () {0x24;}' unless defined(&CI_ERR_ILLGAL);
    eval 'sub CI_ERR_STATUS () {0x25;}' unless defined(&CI_ERR_STATUS);
    eval 'sub CI_ERR_ENCODING () {0x26;}' unless defined(&CI_ERR_ENCODING);
    eval 'sub CI_ERR_UNKNOWN () {0x7fff;}' unless defined(&CI_ERR_UNKNOWN);
    eval 'sub CI_CSLIST_GET () {0x100;}' unless defined(&CI_CSLIST_GET);
    eval 'sub CI_KEYBIND_GET () {0x110;}' unless defined(&CI_KEYBIND_GET);
    eval 'sub CI_KEYBIND_SET () {0x111;}' unless defined(&CI_KEYBIND_SET);
    eval 'sub CI_KCAT_SHIFTMASK () {(1<<0);}' unless defined(&CI_KCAT_SHIFTMASK);
    eval 'sub CI_KCAT_LOCKMASK () {(1<<1);}' unless defined(&CI_KCAT_LOCKMASK);
    eval 'sub CI_KCAT_CTRLMASK () {(1<<2);}' unless defined(&CI_KCAT_CTRLMASK);
    eval 'sub CI_KCAT_MOD1MASK () {(1<<3);}' unless defined(&CI_KCAT_MOD1MASK);
    eval 'sub CI_KCAT_MOD2MASK () {(1<<4);}' unless defined(&CI_KCAT_MOD2MASK);
    eval 'sub CI_KCAT_MOD3MASK () {(1<<5);}' unless defined(&CI_KCAT_MOD3MASK);
    eval 'sub CI_KCAT_MOD4MASK () {(1<<6);}' unless defined(&CI_KCAT_MOD4MASK);
    eval 'sub CI_KCAT_MOD5MASK () {(1<<7);}' unless defined(&CI_KCAT_MOD5MASK);
    eval 'sub CI_SESSION_MAX () {64;}' unless defined(&CI_SESSION_MAX);
    eval 'sub CIO_CIS_FAILED () {0x100;}' unless defined(&CIO_CIS_FAILED);
    eval 'sub CIO_CIS_ESTABLISHED () {0x101;}' unless defined(&CIO_CIS_ESTABLISHED);
    eval 'sub CI_REGION_UNKNOWN () { &CS_REGION_UNKNOWN;}' unless defined(&CI_REGION_UNKNOWN);
    eval 'sub CI_REGION_INTERM () { &CS_REGION_INTERM;}' unless defined(&CI_REGION_INTERM);
    eval 'sub CI_REGION_MODE () { &CS_REGION_MODE;}' unless defined(&CI_REGION_MODE);
    eval 'sub CI_REGION_SELECT () { &CS_REGION_SELECT;}' unless defined(&CI_REGION_SELECT);
    eval 'sub CI_REGION_MISC () { &CS_REGION_MISC;}' unless defined(&CI_REGION_MISC);
    eval 'sub CI_FIELD_UNUSED () { &CS_FIELD_UNUSED;}' unless defined(&CI_FIELD_UNUSED);
    eval 'sub CI_FIELD_INTERM () { &CS_FIELD_INTERM;}' unless defined(&CI_FIELD_INTERM);
    eval 'sub CI_FIELD_DISPLAY () { &CS_FIELD_DISPLAY;}' unless defined(&CI_FIELD_DISPLAY);
    eval 'sub CI_FIELD_SELECT () { &CS_FIELD_SELECT;}' unless defined(&CI_FIELD_SELECT);
    eval 'sub CI_REQ_CONTROL () {0x200;}' unless defined(&CI_REQ_CONTROL);
    eval 'sub CI_REQ_COMMAND () {0x201;}' unless defined(&CI_REQ_COMMAND);
    eval 'sub CIO_RES_CONTROL () {0x1200;}' unless defined(&CIO_RES_CONTROL);
    eval 'sub CIO_RES_COMMAND () {0x1201;}' unless defined(&CIO_RES_COMMAND);
}
1;
