require '_h2ph_pre.ph';

no warnings 'redefine';

# "@(#)cm.h 1.17 97/10/31 SMI"
require 'sys/types.ph';
unless(defined(&MAX_INTERM_TEXT)) {
    sub MAX_INTERM_TEXT () {	1024;}
}
unless(defined(&INVALID_TEXT_INDEX)) {
    sub INVALID_TEXT_INDEX () {	 &MAX_INTERM_TEXT + 2;}
}
unless(defined(&ep_size)) {
    sub ep_size () {	 ($ep_string->{e_size});}
}
unless(defined(&ep_keyptr)) {
    sub ep_keyptr () {	 ($ep_string->{e_keyptr});}
}
unless(defined(&ec_key)) {
    sub ec_key () {	 ($ec_parameter->{ep_key});}
}
unless(defined(&ec_keyptr)) {
    sub ec_keyptr () {	 ($ec_parameter->{ep_keyptr});}
}
unless(defined(&ec_size)) {
    sub ec_size () {	 ($ec_parameter->{ep_size});}
}
unless(defined(&ec_select)) {
    sub ec_select () {	 ($ec_parameter->{ep_select});}
}
unless(defined(&ec_select_invalid)) {
    sub ec_select_invalid () {	 ($ec_parameter->{ep_select_invalid});}
}
unless(defined(&CM_RESET)) {
    sub CM_RESET () {	1;}
}
unless(defined(&CM_SIMPLE_EVENT)) {
    sub CM_SIMPLE_EVENT () {	2;}
}
unless(defined(&CM_STRING_EVENT)) {
    sub CM_STRING_EVENT () {	3;}
}
unless(defined(&CM_SET_CURRENT_REGION)) {
    sub CM_SET_CURRENT_REGION () {	5;}
}
unless(defined(&CM_SET_CONVLEVEL)) {
    sub CM_SET_CONVLEVEL () {	6;}
}
unless(defined(&CM_GET_CONVLEVEL)) {
    sub CM_GET_CONVLEVEL () {	7;}
}
unless(defined(&CM_GET_CONVID)) {
    sub CM_GET_CONVID () {	8;}
}
unless(defined(&CM_GET_KEYBINDING)) {
    sub CM_GET_KEYBINDING () {	9;}
}
unless(defined(&CM_CMON)) {
    sub CM_CMON () {	10;}
}
unless(defined(&CM_NEXT_CANDIDATE)) {
    sub CM_NEXT_CANDIDATE () {	30;}
}
unless(defined(&CM_PREV_CANDIDATE)) {
    sub CM_PREV_CANDIDATE () {	31;}
}
unless(defined(&CM_SELECT)) {
    sub CM_SELECT () {	32;}
}
unless(defined(&CM_ABORT_SELECTION)) {
    sub CM_ABORT_SELECTION () {	33;}
}
unless(defined(&CM_SELECT_INVALID)) {
    sub CM_SELECT_INVALID () {	34;}
}
unless(defined(&INVALID)) {
    sub INVALID () {	0x;}
}
unless(defined(&COMMITT)) {
    sub COMMITT () {	0x1;}
}
unless(defined(&COMMITT_NOTC)) {
    sub COMMITT_NOTC () {	0x2;}
}
unless(defined(&AMB_C)) {
    sub AMB_C () {	0x3;}
}
unless(defined(&AMB)) {
    sub AMB () {	0x4;}
}
unless(defined(&CONV_ON)) {
    sub CONV_ON () {	1;}
}
unless(defined(&CM_IMSERVER_NEGOTIATION)) {
    sub CM_IMSERVER_NEGOTIATION () {	35;}
}
unless(defined(&IM_CM_LUC_NEGOTIATED)) {
    sub IM_CM_LUC_NEGOTIATED () {	(1<<0);}
}
unless(defined(&LUC_LABEL_NONE)) {
    sub LUC_LABEL_NONE () {	0;}
}
unless(defined(&LUC_LABEL_NUMERIC)) {
    sub LUC_LABEL_NUMERIC () {	1;}
}
unless(defined(&LUC_LABEL_ALPHABETIC)) {
    sub LUC_LABEL_ALPHABETIC () {	2;}
}
unless(defined(&LUC_LABEL_ALPHA_UPPER)) {
    sub LUC_LABEL_ALPHA_UPPER () {	3;}
}
1;
