require '_h2ph_pre.ph';

no warnings 'redefine';

# "@(#)cs.h 1.11 93/05/19 SMI"
unless(defined(&_MLE_CS_H)) {
    eval 'sub _MLE_CS_H () {1;}' unless defined(&_MLE_CS_H);
    require 'sys/types.ph';
    eval 'sub CS_REGION_INTERM () {1;}' unless defined(&CS_REGION_INTERM);
    eval 'sub CS_REGION_MODE () {2;}' unless defined(&CS_REGION_MODE);
    eval 'sub CS_REGION_SELECT () {3;}' unless defined(&CS_REGION_SELECT);
    eval 'sub CS_REGION_MISC () {4;}' unless defined(&CS_REGION_MISC);
    eval 'sub CS_REGION_UNKNOWN () {0;}' unless defined(&CS_REGION_UNKNOWN);
    eval 'sub CS_RESULT_CALLME () {0;}' unless defined(&CS_RESULT_CALLME);
    eval 'sub CS_RESULT_INTERM () { &CS_REGION_INTERM;}' unless defined(&CS_RESULT_INTERM);
    eval 'sub CS_RESULT_MODE () { &CS_REGION_MODE;}' unless defined(&CS_RESULT_MODE);
    eval 'sub CS_RESULT_SELECT () { &CS_REGION_SELECT;}' unless defined(&CS_RESULT_SELECT);
    eval 'sub CS_RESULT_MISC () { &CS_REGION_MISC;}' unless defined(&CS_RESULT_MISC);
    eval 'sub CS_RESULT_TEXT () {(-1);}' unless defined(&CS_RESULT_TEXT);
    eval 'sub CS_RESULT_KEYINFO () {(-2);}' unless defined(&CS_RESULT_KEYINFO);
    eval 'sub CS_RESULT_RESET () {(-3);}' unless defined(&CS_RESULT_RESET);
    eval 'sub CS_RESULT_OFF () {33;}' unless defined(&CS_RESULT_OFF);
    eval 'sub CS_RESULT_REJECT () {48;}' unless defined(&CS_RESULT_REJECT);
    eval 'sub CS_STATE_UNUSED () {0x;}' unless defined(&CS_STATE_UNUSED);
    eval 'sub CS_STATE_INIT () {0x81;}' unless defined(&CS_STATE_INIT);
    eval 'sub CS_STATE_EDIT () {0x82;}' unless defined(&CS_STATE_EDIT);
    eval 'sub CS_STATE_CONV () {0x83;}' unless defined(&CS_STATE_CONV);
    eval 'sub CS_STATE_CHOICE () {0x83;}' unless defined(&CS_STATE_CHOICE);
    eval 'sub CS_STATE_KAKUTEI () {0x84;}' unless defined(&CS_STATE_KAKUTEI);
    eval 'sub CS_STATE_BUSY () {0x80;}' unless defined(&CS_STATE_BUSY);
    eval 'sub CS_SEL_INIT () {0;}' unless defined(&CS_SEL_INIT);
    eval 'sub CS_SEL_UPDATE () {1;}' unless defined(&CS_SEL_UPDATE);
    eval 'sub CS_SEL_UNFOCUS () {2;}' unless defined(&CS_SEL_UNFOCUS);
    eval 'sub CS_SEL_FOCUS () {3;}' unless defined(&CS_SEL_FOCUS);
    eval 'sub CS_SEL_END () {4;}' unless defined(&CS_SEL_END);
    eval 'sub CS_SI_DIMENSION () {0xf;}' unless defined(&CS_SI_DIMENSION);
    eval 'sub CS_SI_DIRECTION () {0xf0;}' unless defined(&CS_SI_DIRECTION);
    eval 'sub CS_SI_LABEL () {0xf00;}' unless defined(&CS_SI_LABEL);
    eval 'sub CS_SI_IWIDTH () {0xf000;}' unless defined(&CS_SI_IWIDTH);
    eval 'sub CS_SI_CURSOR () {0xf0000;}' unless defined(&CS_SI_CURSOR);
    eval 'sub CS_SI_TRANSFER () {0x1000000;}' unless defined(&CS_SI_TRANSFER);
    eval 'sub CS_SI_INPUT () {0x2000000;}' unless defined(&CS_SI_INPUT);
    eval 'sub CS_SI_FOCUS () {0x4000000;}' unless defined(&CS_SI_FOCUS);
    eval 'sub CS_MISC_INIT () {0;}' unless defined(&CS_MISC_INIT);
    eval 'sub CS_MISC_UPDATE () {1;}' unless defined(&CS_MISC_UPDATE);
    eval 'sub CS_MISC_END () {2;}' unless defined(&CS_MISC_END);
    eval 'sub CS_FIELD_UNUSED () {0;}' unless defined(&CS_FIELD_UNUSED);
    eval 'sub CS_FIELD_INTERM () {1;}' unless defined(&CS_FIELD_INTERM);
    eval 'sub CS_FIELD_DISPLAY () {2;}' unless defined(&CS_FIELD_DISPLAY);
    eval 'sub CS_FIELD_SELECT () {3;}' unless defined(&CS_FIELD_SELECT);
    eval 'sub CS_RESET () {0x1;}' unless defined(&CS_RESET);
    eval 'sub CS_ACTIVE () {0xf;}' unless defined(&CS_ACTIVE);
    eval 'sub CS_MODE_LIST () {0x10;}' unless defined(&CS_MODE_LIST);
    eval 'sub CS_MODE_SET () {0x11;}' unless defined(&CS_MODE_SET);
    eval 'sub CS_MODE_GET () {0x12;}' unless defined(&CS_MODE_GET);
    eval 'sub CS_CIOINFO_SET () {0x13;}' unless defined(&CS_CIOINFO_SET);
    eval 'sub CS_STATUS_GET () {0x20;}' unless defined(&CS_STATUS_GET);
    eval 'sub CS_MBYTE_ENCODING () {0;}' unless defined(&CS_MBYTE_ENCODING);
    eval 'sub CS_WCHAR_ENCODING () {1;}' unless defined(&CS_WCHAR_ENCODING);
    eval 'sub CS_MODESTRSZ () {32;}' unless defined(&CS_MODESTRSZ);
    eval 'sub CS_MAXMBCHSZ () {3;}' unless defined(&CS_MAXMBCHSZ);
    eval 'sub CS_HOSTNAMESZ () {32;}' unless defined(&CS_HOSTNAMESZ);
    eval 'sub CS_USE_RPC () {1;}' unless defined(&CS_USE_RPC);
    eval 'sub CS_USE_IPC () {2;}' unless defined(&CS_USE_IPC);
    eval 'sub CS_PROTO_TCP () {1;}' unless defined(&CS_PROTO_TCP);
    eval 'sub CS_PROTO_UDP () {2;}' unless defined(&CS_PROTO_UDP);
    eval 'sub CS_USRNAMESZ () {8;}' unless defined(&CS_USRNAMESZ);
    eval 'sub CS_GRPNAMESZ () {8;}' unless defined(&CS_GRPNAMESZ);
    eval 'sub CS_CSNAMESZ () {8;}' unless defined(&CS_CSNAMESZ);
    eval 'sub CS_MODNAMESZ () {8;}' unless defined(&CS_MODNAMESZ);
    eval 'sub CS_MAXMDINFO () {64;}' unless defined(&CS_MAXMDINFO);
    eval 'sub CS_STRINGSZ () {128;}' unless defined(&CS_STRINGSZ);
    eval 'sub CS_CIOIS_WIN () {0x1;}' unless defined(&CS_CIOIS_WIN);
    eval 'sub CS_CIOIS_COLOR () {0x2;}' unless defined(&CS_CIOIS_COLOR);
    eval 'sub CS_CIOIS_MDATT () {0x4;}' unless defined(&CS_CIOIS_MDATT);
    eval 'sub CS_KCAT_SHIFTMASK () {(1<<0);}' unless defined(&CS_KCAT_SHIFTMASK);
    eval 'sub CS_KCAT_LOCKMASK () {(1<<1);}' unless defined(&CS_KCAT_LOCKMASK);
    eval 'sub CS_KCAT_CTRLMASK () {(1<<2);}' unless defined(&CS_KCAT_CTRLMASK);
    eval 'sub CS_KCAT_MOD1MASK () {(1<<3);}' unless defined(&CS_KCAT_MOD1MASK);
    eval 'sub CS_KCAT_MOD2MASK () {(1<<4);}' unless defined(&CS_KCAT_MOD2MASK);
    eval 'sub CS_KCAT_MOD3MASK () {(1<<5);}' unless defined(&CS_KCAT_MOD3MASK);
    eval 'sub CS_KCAT_MOD4MASK () {(1<<6);}' unless defined(&CS_KCAT_MOD4MASK);
    eval 'sub CS_KCAT_MOD5MASK () {(1<<7);}' unless defined(&CS_KCAT_MOD5MASK);
    eval 'sub CS_CALLME_USECMD () {0x1;}' unless defined(&CS_CALLME_USECMD);
    eval 'sub CS_CALLME_BYCI () {0x80;}' unless defined(&CS_CALLME_BYCI);
    eval 'sub CS_MODTYPE_NUMBER () {1;}' unless defined(&CS_MODTYPE_NUMBER);
    eval 'sub CS_MODTYPE_STRING () {2;}' unless defined(&CS_MODTYPE_STRING);
    eval 'sub modestr_mb () { ($modeatt->{_mb});}' unless defined(&modestr_mb);
    eval 'sub modestr_wc () { ($modeatt->{_wc});}' unless defined(&modestr_wc);
    eval 'sub CS_OK () {0x;}' unless defined(&CS_OK);
    eval 'sub CS_ERR_EXIST () {0x1;}' unless defined(&CS_ERR_EXIST);
    eval 'sub CS_ERR_CONNECT () {0x2;}' unless defined(&CS_ERR_CONNECT);
    eval 'sub CS_ERR_DISCONNECT () {0x3;}' unless defined(&CS_ERR_DISCONNECT);
    eval 'sub CS_ERR_LIMIT () {0x4;}' unless defined(&CS_ERR_LIMIT);
    eval 'sub CS_ERR_NOMEM () {0x5;}' unless defined(&CS_ERR_NOMEM);
    eval 'sub CS_ERR_INACTIVE () {0xf;}' unless defined(&CS_ERR_INACTIVE);
    eval 'sub CS_ERR_UNDEFINED () {0x10;}' unless defined(&CS_ERR_UNDEFINED);
    eval 'sub CS_ERR_NOSUPPORT () {0x11;}' unless defined(&CS_ERR_NOSUPPORT);
    eval 'sub CS_ERR_PARAM () {0x12;}' unless defined(&CS_ERR_PARAM);
    eval 'sub CS_ERR_FORMAT () {0x13;}' unless defined(&CS_ERR_FORMAT);
    eval 'sub CS_ERR_MISSING () {0x20;}' unless defined(&CS_ERR_MISSING);
    eval 'sub CS_ERR_NODICT () {0x21;}' unless defined(&CS_ERR_NODICT);
    eval 'sub CS_ERR_ACCSES () {0x22;}' unless defined(&CS_ERR_ACCSES);
    eval 'sub CS_ERR_PERMIT () {0x23;}' unless defined(&CS_ERR_PERMIT);
    eval 'sub CS_ERR_ILLGAL () {0x24;}' unless defined(&CS_ERR_ILLGAL);
    eval 'sub CS_ERR_STATUS () {0x25;}' unless defined(&CS_ERR_STATUS);
    eval 'sub CS_ERR_ENCODING () {0x26;}' unless defined(&CS_ERR_ENCODING);
    eval 'sub CS_ERR_UNKNOWN () {0x7fff;}' unless defined(&CS_ERR_UNKNOWN);
}
1;
