require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NET_IF_H)) {
    eval 'sub _NET_IF_H () {1;}' unless defined(&_NET_IF_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub IFF_UP () {0x1;}' unless defined(&IFF_UP);
    eval 'sub IFF_BROADCAST () {0x2;}' unless defined(&IFF_BROADCAST);
    eval 'sub IFF_DEBUG () {0x4;}' unless defined(&IFF_DEBUG);
    eval 'sub IFF_LOOPBACK () {0x8;}' unless defined(&IFF_LOOPBACK);
    eval 'sub IFF_POINTOPOINT () {0x10;}' unless defined(&IFF_POINTOPOINT);
    eval 'sub IFF_NOTRAILERS () {0x20;}' unless defined(&IFF_NOTRAILERS);
    eval 'sub IFF_RUNNING () {0x40;}' unless defined(&IFF_RUNNING);
    eval 'sub IFF_NOARP () {0x80;}' unless defined(&IFF_NOARP);
    eval 'sub IFF_PROMISC () {0x100;}' unless defined(&IFF_PROMISC);
    eval 'sub IFF_ALLMULTI () {0x200;}' unless defined(&IFF_ALLMULTI);
    eval 'sub IFF_INTELLIGENT () {0x400;}' unless defined(&IFF_INTELLIGENT);
    eval 'sub IFF_MULTICAST () {0x800;}' unless defined(&IFF_MULTICAST);
    eval 'sub IFF_MULTI_BCAST () {0x1000;}' unless defined(&IFF_MULTI_BCAST);
    eval 'sub IFF_UNNUMBERED () {0x2000;}' unless defined(&IFF_UNNUMBERED);
    eval 'sub IFF_DHCPRUNNING () {0x4000;}' unless defined(&IFF_DHCPRUNNING);
    eval 'sub IFF_PRIVATE () {0x8000;}' unless defined(&IFF_PRIVATE);
    eval 'sub IFF_NOXMIT () {0x10000;}' unless defined(&IFF_NOXMIT);
    eval 'sub IFF_NOLOCAL () {0x20000;}' unless defined(&IFF_NOLOCAL);
    eval 'sub IFF_DEPRECATED () {0x40000;}' unless defined(&IFF_DEPRECATED);
    eval 'sub IFF_ADDRCONF () {0x80000;}' unless defined(&IFF_ADDRCONF);
    eval 'sub IFF_ROUTER () {0x100000;}' unless defined(&IFF_ROUTER);
    eval 'sub IFF_NONUD () {0x200000;}' unless defined(&IFF_NONUD);
    eval 'sub IFF_ANYCAST () {0x400000;}' unless defined(&IFF_ANYCAST);
    eval 'sub IFF_NORTEXCH () {0x800000;}' unless defined(&IFF_NORTEXCH);
    eval 'sub IFF_IPV4 () {0x1000000;}' unless defined(&IFF_IPV4);
    eval 'sub IFF_IPV6 () {0x2000000;}' unless defined(&IFF_IPV6);
    eval 'sub IFF_MIPRUNNING () {0x4000000;}' unless defined(&IFF_MIPRUNNING);
    eval 'sub IFF_NOFAILOVER () {0x8000000;}' unless defined(&IFF_NOFAILOVER);
    eval 'sub IFF_FAILED () {0x10000000;}' unless defined(&IFF_FAILED);
    eval 'sub IFF_STANDBY () {0x20000000;}' unless defined(&IFF_STANDBY);
    eval 'sub IFF_INACTIVE () {0x40000000;}' unless defined(&IFF_INACTIVE);
    eval 'sub IFF_OFFLINE () {0x80000000;}' unless defined(&IFF_OFFLINE);
    eval 'sub IFF_CANTCHANGE () {( &IFF_BROADCAST |  &IFF_POINTOPOINT |  &IFF_RUNNING |  &IFF_PROMISC |  &IFF_MULTICAST |  &IFF_MULTI_BCAST |  &IFF_UNNUMBERED |  &IFF_IPV4 |  &IFF_IPV6| &IFF_INACTIVE);}' unless defined(&IFF_CANTCHANGE);
    eval 'sub IF_QFULL {
        my($ifq) = @_;
	    eval q((($ifq)-> &ifq_len >= ($ifq)-> &ifq_maxlen));
    }' unless defined(&IF_QFULL);
    eval 'sub IF_DROP {
        my($ifq) = @_;
	    eval q((($ifq)-> &ifq_drops++));
    }' unless defined(&IF_DROP);
    eval 'sub IF_ENQUEUE {
        my($ifq, $m) = @_;
	    eval q({ ($m)-> &m_act = 0;  &if (($ifq)-> &ifq_tail == 0) ($ifq)-> &ifq_head = $m;  &else ($ifq)-> ($ifq_tail->{m_act}) = $m; ($ifq)-> &ifq_tail = $m; ($ifq)-> &ifq_len++; });
    }' unless defined(&IF_ENQUEUE);
    eval 'sub IF_PREPEND {
        my($ifq, $m) = @_;
	    eval q({ ($m)-> &m_act = ($ifq)-> &ifq_head;  &if (($ifq)-> &ifq_tail == 0) ($ifq)-> &ifq_tail = ($m); ($ifq)-> &ifq_head = ($m); ($ifq)-> &ifq_len++; });
    }' unless defined(&IF_PREPEND);
    eval 'sub IF_ADJ {
        my($m) = @_;
	    eval q({ ($m)-> &m_off += $sizeof{\'struct ifnet\' }; ($m)-> &m_len -= $sizeof{\'struct ifnet\' };  &if (($m)-> &m_len == 0) { \'struct mbuf\' * &n;  &MFREE(($m),  &n); ($m) =  &n; } });
    }' unless defined(&IF_ADJ);
    eval 'sub IF_DEQUEUEIF {
        my($ifq, $m, $ifp) = @_;
	    eval q({ ($m) = ($ifq)-> &ifq_head;  &if ($m) {  &if ((($ifq)-> &ifq_head = ($m)-> &m_act) == 0) ($ifq)-> &ifq_tail = 0; ($m)-> &m_act = 0; ($ifq)-> &ifq_len--; ($ifp) = *( &mtod(($m), \'struct ifnet\' **));  &IF_ADJ($m); } });
    }' unless defined(&IF_DEQUEUEIF);
    eval 'sub IF_DEQUEUE {
        my($ifq, $m) = @_;
	    eval q({ ($m) = ($ifq)-> &ifq_head;  &if ($m) {  &if ((($ifq)-> &ifq_head = ($m)-> &m_act) == 0) ($ifq)-> &ifq_tail = 0; ($m)-> &m_act = 0; ($ifq)-> &ifq_len--; } });
    }' unless defined(&IF_DEQUEUE);
    eval 'sub IFQ_MAXLEN () {50;}' unless defined(&IFQ_MAXLEN);
    eval 'sub IFNET_SLOWHZ () {1;}' unless defined(&IFNET_SLOWHZ);
    eval 'sub ifa_broadaddr () { ($ifa_ifu->{ifu_broadaddr});}' unless defined(&ifa_broadaddr);
    eval 'sub ifa_dstaddr () { ($ifa_ifu->{ifu_dstaddr});}' unless defined(&ifa_dstaddr);
    eval 'sub ND_MAX_HDW_LEN () {64;}' unless defined(&ND_MAX_HDW_LEN);
    eval 'sub ND_UNCHANGED () {0;}' unless defined(&ND_UNCHANGED);
    eval 'sub ND_INCOMPLETE () {1;}' unless defined(&ND_INCOMPLETE);
    eval 'sub ND_REACHABLE () {2;}' unless defined(&ND_REACHABLE);
    eval 'sub ND_STALE () {3;}' unless defined(&ND_STALE);
    eval 'sub ND_DELAY () {4;}' unless defined(&ND_DELAY);
    eval 'sub ND_PROBE () {5;}' unless defined(&ND_PROBE);
    eval 'sub ND_UNREACHABLE () {6;}' unless defined(&ND_UNREACHABLE);
    eval 'sub ND_STATE_VALID_MIN () {0;}' unless defined(&ND_STATE_VALID_MIN);
    eval 'sub ND_STATE_VALID_MAX () {6;}' unless defined(&ND_STATE_VALID_MAX);
    eval 'sub NDF_ISROUTER_ON () {0x1;}' unless defined(&NDF_ISROUTER_ON);
    eval 'sub NDF_ISROUTER_OFF () {0x2;}' unless defined(&NDF_ISROUTER_OFF);
    eval 'sub NDF_ANYCAST_ON () {0x4;}' unless defined(&NDF_ANYCAST_ON);
    eval 'sub NDF_ANYCAST_OFF () {0x8;}' unless defined(&NDF_ANYCAST_OFF);
    eval 'sub NDF_PROXY_ON () {0x10;}' unless defined(&NDF_PROXY_ON);
    eval 'sub NDF_PROXY_OFF () {0x20;}' unless defined(&NDF_PROXY_OFF);
    eval 'sub LIFNAMSIZ () {32;}' unless defined(&LIFNAMSIZ);
    if(defined( &_LP64) || ((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_NO_LONGLONG))) {
	eval 'sub lifr_addrlen () { ($lifr_lifru1->{lifru_addrlen});}' unless defined(&lifr_addrlen);
	eval 'sub lifr_ppa () { ($lifr_lifru1->{lifru_ppa});}' unless defined(&lifr_ppa);
	eval 'sub lifr_addr () { ($lifr_lifru->{lifru_addr});}' unless defined(&lifr_addr);
	eval 'sub lifr_dstaddr () { ($lifr_lifru->{lifru_dstaddr});}' unless defined(&lifr_dstaddr);
	eval 'sub lifr_broadaddr () { ($lifr_lifru->{lifru_broadaddr});}' unless defined(&lifr_broadaddr);
	eval 'sub lifr_token () { ($lifr_lifru->{lifru_token});}' unless defined(&lifr_token);
	eval 'sub lifr_subnet () { ($lifr_lifru->{lifru_subnet});}' unless defined(&lifr_subnet);
	eval 'sub lifr_index () { ($lifr_lifru->{lifru_index});}' unless defined(&lifr_index);
	eval 'sub lifr_flags () { ($lifr_lifru->{lifru_flags});}' unless defined(&lifr_flags);
	eval 'sub lifr_metric () { ($lifr_lifru->{lifru_metric});}' unless defined(&lifr_metric);
	eval 'sub lifr_mtu () { ($lifr_lifru->{lifru_mtu});}' unless defined(&lifr_mtu);
	eval 'sub lifr_data () { ($lifr_lifru->{lifru_data});}' unless defined(&lifr_data);
	eval 'sub lifr_enaddr () { ($lifr_lifru->{lifru_enaddr});}' unless defined(&lifr_enaddr);
	eval 'sub lifr_index () { ($lifr_lifru->{lifru_index});}' unless defined(&lifr_index);
	eval 'sub lifr_ip_muxid () { ($lifr_lifru->{lif_muxid[0]});}' unless defined(&lifr_ip_muxid);
	eval 'sub lifr_arp_muxid () { ($lifr_lifru->{lif_muxid[1]});}' unless defined(&lifr_arp_muxid);
	eval 'sub lifr_nd () { ($lifr_lifru->{lifru_nd_req});}' unless defined(&lifr_nd);
	eval 'sub lifr_ifinfo () { ($lifr_lifru->{lifru_ifinfo_req});}' unless defined(&lifr_ifinfo);
	eval 'sub lifr_groupname () { ($lifr_lifru->{lifru_groupname});}' unless defined(&lifr_groupname);
	eval 'sub lifr_delay () { ($lifr_lifru->{lifru_delay});}' unless defined(&lifr_delay);
    }
    eval 'sub IFNAMSIZ () {16;}' unless defined(&IFNAMSIZ);
    eval 'sub ifr_addr () { ($ifr_ifru->{ifru_addr});}' unless defined(&ifr_addr);
    eval 'sub ifr_dstaddr () { ($ifr_ifru->{ifru_dstaddr});}' unless defined(&ifr_dstaddr);
    eval 'sub ifr_oname () { ($ifr_ifru->{ifru_oname});}' unless defined(&ifr_oname);
    eval 'sub ifr_broadaddr () { ($ifr_ifru->{ifru_broadaddr});}' unless defined(&ifr_broadaddr);
    eval 'sub ifr_flags () { ($ifr_ifru->{ifru_flags});}' unless defined(&ifr_flags);
    eval 'sub ifr_metric () { ($ifr_ifru->{ifru_metric});}' unless defined(&ifr_metric);
    eval 'sub ifr_data () { ($ifr_ifru->{ifru_data});}' unless defined(&ifr_data);
    eval 'sub ifr_enaddr () { ($ifr_ifru->{ifru_enaddr});}' unless defined(&ifr_enaddr);
    eval 'sub ifr_index () { ($ifr_ifru->{ifru_index});}' unless defined(&ifr_index);
    eval 'sub ifr_ppa () { ($ifr_ifru->{ifru_ppaflags}->{ifrup_ppa});}' unless defined(&ifr_ppa);
    eval 'sub ifr_dnld_req () { ($ifr_ifru->{ifru_dnld_req});}' unless defined(&ifr_dnld_req);
    eval 'sub ifr_fddi_stat () { ($ifr_ifru->{ifru_fddi_stat});}' unless defined(&ifr_fddi_stat);
    eval 'sub ifr_fddi_netmap () { ($ifr_ifru->{ifru_netmapent});}' unless defined(&ifr_fddi_netmap);
    eval 'sub ifr_fddi_gstruct () { ($ifr_ifru->{ifru_fddi_gstruct});}' unless defined(&ifr_fddi_gstruct);
    eval 'sub ifr_ip_muxid () { ($ifr_ifru->{if_muxid[0]});}' unless defined(&ifr_ip_muxid);
    eval 'sub ifr_arp_muxid () { ($ifr_ifru->{if_muxid[1]});}' unless defined(&ifr_arp_muxid);
    eval 'sub lifc_buf () { ($lifc_lifcu->{lifcu_buf});}' unless defined(&lifc_buf);
    eval 'sub lifc_req () { ($lifc_lifcu->{lifcu_req});}' unless defined(&lifc_req);
    eval 'sub LIFC_NOXMIT () {0x1;}' unless defined(&LIFC_NOXMIT);
    eval 'sub LIFC_EXTERNAL_SOURCE () {0x2;}' unless defined(&LIFC_EXTERNAL_SOURCE);
    if(defined( &_SYSCALL32)) {
    }
    eval 'sub ifc_buf () { ($ifc_ifcu->{ifcu_buf});}' unless defined(&ifc_buf);
    eval 'sub ifc_req () { ($ifc_ifcu->{ifcu_req});}' unless defined(&ifc_req);
    if(defined( &_SYSCALL32)) {
    }
    eval("sub IFTAP_INVALID () { 0; }") unless defined(&IFTAP_INVALID);
    eval("sub IFTAP_IPV4 () { 1; }") unless defined(&IFTAP_IPV4);
    eval("sub IFTAP_IPV6 () { 2; }") unless defined(&IFTAP_IPV6);
    eval 'sub IFTUN_SECINFOLEN () {8;}' unless defined(&IFTUN_SECINFOLEN);
    eval 'sub IFTUN_VERSION () {1;}' unless defined(&IFTUN_VERSION);
    eval 'sub IFTUN_SRC () {0x1;}' unless defined(&IFTUN_SRC);
    eval 'sub IFTUN_DST () {0x2;}' unless defined(&IFTUN_DST);
    eval 'sub IFTUN_SECURITY () {0x4;}' unless defined(&IFTUN_SECURITY);
    eval 'sub IF_NAMESIZE () { &LIFNAMSIZ;}' unless defined(&IF_NAMESIZE);
    if(defined(&__cplusplus)) {
    }
}
1;
