require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NET_PPP_COMP_H)) {
    eval 'sub _NET_PPP_COMP_H () {1;}' unless defined(&_NET_PPP_COMP_H);
    if(defined(&__cplusplus)) {
    }
    unless(defined(&DO_BSD_COMPRESS)) {
	eval 'sub DO_BSD_COMPRESS () {1;}' unless defined(&DO_BSD_COMPRESS);
    }
    unless(defined(&DO_DEFLATE)) {
	eval 'sub DO_DEFLATE () {1;}' unless defined(&DO_DEFLATE);
    }
    eval 'sub DO_PREDICTOR_1 () {0;}' unless defined(&DO_PREDICTOR_1);
    eval 'sub DO_PREDICTOR_2 () {0;}' unless defined(&DO_PREDICTOR_2);
    if(defined(&PACKETPTR)) {
    }
    eval 'sub DECOMP_OK () {0;}' unless defined(&DECOMP_OK);
    eval 'sub DECOMP_ERROR () {1;}' unless defined(&DECOMP_ERROR);
    eval 'sub DECOMP_FATALERROR () {2;}' unless defined(&DECOMP_FATALERROR);
    eval 'sub CCP_CONFREQ () {1;}' unless defined(&CCP_CONFREQ);
    eval 'sub CCP_CONFACK () {2;}' unless defined(&CCP_CONFACK);
    eval 'sub CCP_TERMREQ () {5;}' unless defined(&CCP_TERMREQ);
    eval 'sub CCP_TERMACK () {6;}' unless defined(&CCP_TERMACK);
    eval 'sub CCP_RESETREQ () {14;}' unless defined(&CCP_RESETREQ);
    eval 'sub CCP_RESETACK () {15;}' unless defined(&CCP_RESETACK);
    eval 'sub CCP_MAX_OPTION_LENGTH () {32;}' unless defined(&CCP_MAX_OPTION_LENGTH);
    eval 'sub CCP_CODE {
        my($dp) = @_;
	    eval q((($dp)[0]));
    }' unless defined(&CCP_CODE);
    eval 'sub CCP_ID {
        my($dp) = @_;
	    eval q((($dp)[1]));
    }' unless defined(&CCP_ID);
    eval 'sub CCP_LENGTH {
        my($dp) = @_;
	    eval q(((($dp)[2] << 8) + ($dp)[3]));
    }' unless defined(&CCP_LENGTH);
    eval 'sub CCP_HDRLEN () {4;}' unless defined(&CCP_HDRLEN);
    eval 'sub CCP_OPT_CODE {
        my($dp) = @_;
	    eval q((($dp)[0]));
    }' unless defined(&CCP_OPT_CODE);
    eval 'sub CCP_OPT_LENGTH {
        my($dp) = @_;
	    eval q((($dp)[1]));
    }' unless defined(&CCP_OPT_LENGTH);
    eval 'sub CCP_OPT_MINLEN () {2;}' unless defined(&CCP_OPT_MINLEN);
    eval 'sub CI_BSD_COMPRESS () {21;}' unless defined(&CI_BSD_COMPRESS);
    eval 'sub CILEN_BSD_COMPRESS () {3;}' unless defined(&CILEN_BSD_COMPRESS);
    eval 'sub BSD_NBITS {
        my($x) = @_;
	    eval q((($x) & 0x1f));
    }' unless defined(&BSD_NBITS);
    eval 'sub BSD_VERSION {
        my($x) = @_;
	    eval q((($x) >> 5));
    }' unless defined(&BSD_VERSION);
    eval 'sub BSD_CURRENT_VERSION () {1;}' unless defined(&BSD_CURRENT_VERSION);
    eval 'sub BSD_MAKE_OPT {
        my($v, $n) = @_;
	    eval q(((($v) << 5) | ($n)));
    }' unless defined(&BSD_MAKE_OPT);
    eval 'sub BSD_MIN_BITS () {9;}' unless defined(&BSD_MIN_BITS);
    eval 'sub BSD_MAX_BITS () {15;}' unless defined(&BSD_MAX_BITS);
    eval 'sub CI_DEFLATE () {26;}' unless defined(&CI_DEFLATE);
    eval 'sub CI_DEFLATE_DRAFT () {24;}' unless defined(&CI_DEFLATE_DRAFT);
    eval 'sub CILEN_DEFLATE () {4;}' unless defined(&CILEN_DEFLATE);
    eval 'sub DEFLATE_MIN_SIZE () {8;}' unless defined(&DEFLATE_MIN_SIZE);
    eval 'sub DEFLATE_MAX_SIZE () {15;}' unless defined(&DEFLATE_MAX_SIZE);
    eval 'sub DEFLATE_METHOD_VAL () {8;}' unless defined(&DEFLATE_METHOD_VAL);
    eval 'sub DEFLATE_SIZE {
        my($x) = @_;
	    eval q(((($x) >> 4) +  &DEFLATE_MIN_SIZE));
    }' unless defined(&DEFLATE_SIZE);
    eval 'sub DEFLATE_METHOD {
        my($x) = @_;
	    eval q((($x) & 0xf));
    }' unless defined(&DEFLATE_METHOD);
    eval 'sub DEFLATE_MAKE_OPT {
        my($w) = @_;
	    eval q((((($w) -  &DEFLATE_MIN_SIZE) << 4) +  &DEFLATE_METHOD_VAL));
    }' unless defined(&DEFLATE_MAKE_OPT);
    eval 'sub DEFLATE_CHK_SEQUENCE () {0;}' unless defined(&DEFLATE_CHK_SEQUENCE);
    eval 'sub CI_PREDICTOR_1 () {1;}' unless defined(&CI_PREDICTOR_1);
    eval 'sub CILEN_PREDICTOR_1 () {2;}' unless defined(&CILEN_PREDICTOR_1);
    eval 'sub CI_PREDICTOR_2 () {2;}' unless defined(&CI_PREDICTOR_2);
    eval 'sub CILEN_PREDICTOR_2 () {2;}' unless defined(&CILEN_PREDICTOR_2);
    eval 'sub CI_STAC () {17;}' unless defined(&CI_STAC);
    eval 'sub CILEN_STAC () {5;}' unless defined(&CILEN_STAC);
    eval 'sub STAC_CHK_NONE () {0;}' unless defined(&STAC_CHK_NONE);
    eval 'sub STAC_CHK_LCB () {1;}' unless defined(&STAC_CHK_LCB);
    eval 'sub STAC_CHK_CRC () {2;}' unless defined(&STAC_CHK_CRC);
    eval 'sub STAC_CHK_SEQ () {3;}' unless defined(&STAC_CHK_SEQ);
    eval 'sub STAC_CHK_EXTENDED () {4;}' unless defined(&STAC_CHK_EXTENDED);
    eval 'sub CI_MPPC () {18;}' unless defined(&CI_MPPC);
    eval 'sub CILEN_MPPC () {6;}' unless defined(&CILEN_MPPC);
    eval 'sub MPPC_COMP () {0x1;}' unless defined(&MPPC_COMP);
    eval 'sub MPPC_40LANM () {0x10;}' unless defined(&MPPC_40LANM);
    eval 'sub MPPC_40NT () {0x20;}' unless defined(&MPPC_40NT);
    eval 'sub MPPC_128NT () {0x40;}' unless defined(&MPPC_128NT);
    eval 'sub MPPC_56NT () {0x80;}' unless defined(&MPPC_56NT);
    eval 'sub MPPC_PBP () {0x1000000;}' unless defined(&MPPC_PBP);
    eval 'sub MPPC_MPPE () {0xf0;}' unless defined(&MPPC_MPPE);
    if(defined(&__cplusplus)) {
    }
}
1;
