require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_ICMP6_H)) {
    eval 'sub _NETINET_ICMP6_H () {1;}' unless defined(&_NETINET_ICMP6_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    eval 'sub ICMP6_INFOMSG_MASK () {0x80;}' unless defined(&ICMP6_INFOMSG_MASK);
    eval 'sub ICMP6_MINLEN () {8;}' unless defined(&ICMP6_MINLEN);
    eval 'sub icmp6_data32 () { ($icmp6_dataun->{icmp6_un_data32});}' unless defined(&icmp6_data32);
    eval 'sub icmp6_data16 () { ($icmp6_dataun->{icmp6_un_data16});}' unless defined(&icmp6_data16);
    eval 'sub icmp6_data8 () { ($icmp6_dataun->{icmp6_un_data8});}' unless defined(&icmp6_data8);
    eval 'sub icmp6_pptr () { $icmp6_data32[0];}' unless defined(&icmp6_pptr);
    eval 'sub icmp6_mtu () { $icmp6_data32[0];}' unless defined(&icmp6_mtu);
    eval 'sub icmp6_id () { $icmp6_data16[0];}' unless defined(&icmp6_id);
    eval 'sub icmp6_seq () { $icmp6_data16[1];}' unless defined(&icmp6_seq);
    eval 'sub icmp6_maxdelay () { $icmp6_data16[0];}' unless defined(&icmp6_maxdelay);
    eval 'sub mld_type () { ($icmp6m_hdr->{icmp6_type});}' unless defined(&mld_type);
    eval 'sub mld_code () { ($icmp6m_hdr->{icmp6_code});}' unless defined(&mld_code);
    eval 'sub mld_cksum () { ($icmp6m_hdr->{icmp6_cksum});}' unless defined(&mld_cksum);
    eval 'sub mld_maxdelay () { ($icmp6m_hdr->{icmp6_data16[0]});}' unless defined(&mld_maxdelay);
    eval 'sub mld_reserved () { ($icmp6m_hdr->{icmp6_data16[1]});}' unless defined(&mld_reserved);
    eval 'sub mld_group_addr () { &icmp6m_group;}' unless defined(&mld_group_addr);
    eval 'sub ICMP6_DST_UNREACH () {1;}' unless defined(&ICMP6_DST_UNREACH);
    eval 'sub ICMP6_PACKET_TOO_BIG () {2;}' unless defined(&ICMP6_PACKET_TOO_BIG);
    eval 'sub ICMP6_TIME_EXCEEDED () {3;}' unless defined(&ICMP6_TIME_EXCEEDED);
    eval 'sub ICMP6_PARAM_PROB () {4;}' unless defined(&ICMP6_PARAM_PROB);
    eval 'sub ICMP6_ECHO_REQUEST () {128;}' unless defined(&ICMP6_ECHO_REQUEST);
    eval 'sub ICMP6_ECHO_REPLY () {129;}' unless defined(&ICMP6_ECHO_REPLY);
    eval 'sub ICMP6_MEMBERSHIP_QUERY () {130;}' unless defined(&ICMP6_MEMBERSHIP_QUERY);
    eval 'sub ICMP6_MEMBERSHIP_REPORT () {131;}' unless defined(&ICMP6_MEMBERSHIP_REPORT);
    eval 'sub ICMP6_MEMBERSHIP_REDUCTION () {132;}' unless defined(&ICMP6_MEMBERSHIP_REDUCTION);
    eval 'sub ND_ROUTER_SOLICIT () {133;}' unless defined(&ND_ROUTER_SOLICIT);
    eval 'sub ND_ROUTER_ADVERT () {134;}' unless defined(&ND_ROUTER_ADVERT);
    eval 'sub ND_NEIGHBOR_SOLICIT () {135;}' unless defined(&ND_NEIGHBOR_SOLICIT);
    eval 'sub ND_NEIGHBOR_ADVERT () {136;}' unless defined(&ND_NEIGHBOR_ADVERT);
    eval 'sub ND_REDIRECT () {137;}' unless defined(&ND_REDIRECT);
    eval 'sub ICMP6_MAX_INFO_TYPE () {137;}' unless defined(&ICMP6_MAX_INFO_TYPE);
    eval 'sub ICMP6_IS_ERROR {
        my($x) = @_;
	    eval q((($x) < 128));
    }' unless defined(&ICMP6_IS_ERROR);
    eval 'sub ICMP6_DST_UNREACH_NOROUTE () {0;}' unless defined(&ICMP6_DST_UNREACH_NOROUTE);
    eval 'sub ICMP6_DST_UNREACH_ADMIN () {1;}' unless defined(&ICMP6_DST_UNREACH_ADMIN);
    eval 'sub ICMP6_DST_UNREACH_NOTNEIGHBOR () {2;}' unless defined(&ICMP6_DST_UNREACH_NOTNEIGHBOR);
    eval 'sub ICMP6_DST_UNREACH_ADDR () {3;}' unless defined(&ICMP6_DST_UNREACH_ADDR);
    eval 'sub ICMP6_DST_UNREACH_NOPORT () {4;}' unless defined(&ICMP6_DST_UNREACH_NOPORT);
    eval 'sub ICMP6_TIME_EXCEED_TRANSIT () {0;}' unless defined(&ICMP6_TIME_EXCEED_TRANSIT);
    eval 'sub ICMP6_TIME_EXCEED_REASSEMBLY () {1;}' unless defined(&ICMP6_TIME_EXCEED_REASSEMBLY);
    eval 'sub ICMP6_PARAMPROB_HEADER () {0;}' unless defined(&ICMP6_PARAMPROB_HEADER);
    eval 'sub ICMP6_PARAMPROB_NEXTHEADER () {1;}' unless defined(&ICMP6_PARAMPROB_NEXTHEADER);
    eval 'sub ICMP6_PARAMPROB_OPTION () {2;}' unless defined(&ICMP6_PARAMPROB_OPTION);
    eval 'sub ICMP6_MAX_HOST_REPORT_DELAY () {10;}' unless defined(&ICMP6_MAX_HOST_REPORT_DELAY);
    eval 'sub nd_rs_type () { ($nd_rs_hdr->{icmp6_type});}' unless defined(&nd_rs_type);
    eval 'sub nd_rs_code () { ($nd_rs_hdr->{icmp6_code});}' unless defined(&nd_rs_code);
    eval 'sub nd_rs_cksum () { ($nd_rs_hdr->{icmp6_cksum});}' unless defined(&nd_rs_cksum);
    eval 'sub nd_rs_reserved () { ($nd_rs_hdr->{icmp6_data32[0]});}' unless defined(&nd_rs_reserved);
    eval 'sub nd_ra_type () { ($nd_ra_hdr->{icmp6_type});}' unless defined(&nd_ra_type);
    eval 'sub nd_ra_code () { ($nd_ra_hdr->{icmp6_code});}' unless defined(&nd_ra_code);
    eval 'sub nd_ra_cksum () { ($nd_ra_hdr->{icmp6_cksum});}' unless defined(&nd_ra_cksum);
    eval 'sub nd_ra_curhoplimit () { ($nd_ra_hdr->{icmp6_data8[0]});}' unless defined(&nd_ra_curhoplimit);
    eval 'sub nd_ra_flags_reserved () { ($nd_ra_hdr->{icmp6_data8[1]});}' unless defined(&nd_ra_flags_reserved);
    eval 'sub ND_RA_FLAG_OTHER () {0x40;}' unless defined(&ND_RA_FLAG_OTHER);
    eval 'sub ND_RA_FLAG_MANAGED () {0x80;}' unless defined(&ND_RA_FLAG_MANAGED);
    eval 'sub nd_ra_router_lifetime () { ($nd_ra_hdr->{icmp6_data16[1]});}' unless defined(&nd_ra_router_lifetime);
    eval 'sub nd_ns_type () { ($nd_ns_hdr->{icmp6_type});}' unless defined(&nd_ns_type);
    eval 'sub nd_ns_code () { ($nd_ns_hdr->{icmp6_code});}' unless defined(&nd_ns_code);
    eval 'sub nd_ns_cksum () { ($nd_ns_hdr->{icmp6_cksum});}' unless defined(&nd_ns_cksum);
    eval 'sub nd_ns_reserved () { ($nd_ns_hdr->{icmp6_data32[0]});}' unless defined(&nd_ns_reserved);
    eval 'sub nd_na_type () { ($nd_na_hdr->{icmp6_type});}' unless defined(&nd_na_type);
    eval 'sub nd_na_code () { ($nd_na_hdr->{icmp6_code});}' unless defined(&nd_na_code);
    eval 'sub nd_na_cksum () { ($nd_na_hdr->{icmp6_cksum});}' unless defined(&nd_na_cksum);
    eval 'sub nd_na_flags_reserved () { ($nd_na_hdr->{icmp6_data32[0]});}' unless defined(&nd_na_flags_reserved);
    if(defined(&_BIG_ENDIAN)) {
	eval 'sub ND_NA_FLAG_ROUTER () {0x80000000;}' unless defined(&ND_NA_FLAG_ROUTER);
	eval 'sub ND_NA_FLAG_SOLICITED () {0x40000000;}' unless defined(&ND_NA_FLAG_SOLICITED);
	eval 'sub ND_NA_FLAG_OVERRIDE () {0x20000000;}' unless defined(&ND_NA_FLAG_OVERRIDE);
    } else {
	eval 'sub ND_NA_FLAG_ROUTER () {0x80;}' unless defined(&ND_NA_FLAG_ROUTER);
	eval 'sub ND_NA_FLAG_SOLICITED () {0x40;}' unless defined(&ND_NA_FLAG_SOLICITED);
	eval 'sub ND_NA_FLAG_OVERRIDE () {0x20;}' unless defined(&ND_NA_FLAG_OVERRIDE);
    }
    eval 'sub nd_rd_type () { ($nd_rd_hdr->{icmp6_type});}' unless defined(&nd_rd_type);
    eval 'sub nd_rd_code () { ($nd_rd_hdr->{icmp6_code});}' unless defined(&nd_rd_code);
    eval 'sub nd_rd_cksum () { ($nd_rd_hdr->{icmp6_cksum});}' unless defined(&nd_rd_cksum);
    eval 'sub nd_rd_reserved () { ($nd_rd_hdr->{icmp6_data32[0]});}' unless defined(&nd_rd_reserved);
    eval 'sub ND_OPT_SOURCE_LINKADDR () {1;}' unless defined(&ND_OPT_SOURCE_LINKADDR);
    eval 'sub ND_OPT_TARGET_LINKADDR () {2;}' unless defined(&ND_OPT_TARGET_LINKADDR);
    eval 'sub ND_OPT_PREFIX_INFORMATION () {3;}' unless defined(&ND_OPT_PREFIX_INFORMATION);
    eval 'sub ND_OPT_REDIRECTED_HEADER () {4;}' unless defined(&ND_OPT_REDIRECTED_HEADER);
    eval 'sub ND_OPT_MTU () {5;}' unless defined(&ND_OPT_MTU);
    eval 'sub ND_OPT_PI_FLAG_AUTO () {0x40;}' unless defined(&ND_OPT_PI_FLAG_AUTO);
    eval 'sub ND_OPT_PI_FLAG_ONLINK () {0x80;}' unless defined(&ND_OPT_PI_FLAG_ONLINK);
    unless(defined(&ND_MAX_HDW_LEN)) {
	eval 'sub ND_MAX_HDW_LEN () {64;}' unless defined(&ND_MAX_HDW_LEN);
    }
    eval 'sub ND_MAX_INITIAL_RTR_ADVERT_INTERVAL () {16000;}' unless defined(&ND_MAX_INITIAL_RTR_ADVERT_INTERVAL);
    eval 'sub ND_MAX_INITIAL_RTR_ADVERTISEMENTS () {3;}' unless defined(&ND_MAX_INITIAL_RTR_ADVERTISEMENTS);
    eval 'sub ND_MAX_FINAL_RTR_ADVERTISEMENTS () {3;}' unless defined(&ND_MAX_FINAL_RTR_ADVERTISEMENTS);
    eval 'sub ND_MIN_DELAY_BETWEEN_RAS () {3000;}' unless defined(&ND_MIN_DELAY_BETWEEN_RAS);
    eval 'sub ND_MAX_RA_DELAY_TIME () {500;}' unless defined(&ND_MAX_RA_DELAY_TIME);
    eval 'sub ND_MAX_RTR_SOLICITATION_DELAY () {1000;}' unless defined(&ND_MAX_RTR_SOLICITATION_DELAY);
    eval 'sub ND_RTR_SOLICITATION_INTERVAL () {4000;}' unless defined(&ND_RTR_SOLICITATION_INTERVAL);
    eval 'sub ND_MAX_RTR_SOLICITATIONS () {3;}' unless defined(&ND_MAX_RTR_SOLICITATIONS);
    eval 'sub ND_MAX_MULTICAST_SOLICIT () {3;}' unless defined(&ND_MAX_MULTICAST_SOLICIT);
    eval 'sub ND_MAX_UNICAST_SOLICIT () {3;}' unless defined(&ND_MAX_UNICAST_SOLICIT);
    eval 'sub ND_MAX_ANYCAST_DELAY_TIME () {1000;}' unless defined(&ND_MAX_ANYCAST_DELAY_TIME);
    eval 'sub ND_MAX_NEIGHBOR_ADVERTISEMENT () {3;}' unless defined(&ND_MAX_NEIGHBOR_ADVERTISEMENT);
    eval 'sub ND_REACHABLE_TIME () {30000;}' unless defined(&ND_REACHABLE_TIME);
    eval 'sub ND_RETRANS_TIMER () {1000;}' unless defined(&ND_RETRANS_TIMER);
    eval 'sub ND_DELAY_FIRST_PROBE_TIME () {5000;}' unless defined(&ND_DELAY_FIRST_PROBE_TIME);
    eval 'sub ND_MIN_RANDOM_FACTOR () {.5;}' unless defined(&ND_MIN_RANDOM_FACTOR);
    eval 'sub ND_MAX_RANDOM_FACTOR () {1.5;}' unless defined(&ND_MAX_RANDOM_FACTOR);
    eval 'sub ND_MAX_REACHTIME () {3600000;}' unless defined(&ND_MAX_REACHTIME);
    eval 'sub ND_MAX_REACHRETRANSTIME () {100000;}' unless defined(&ND_MAX_REACHRETRANSTIME);
    eval 'sub ICMP6_FILTER () {0x1;}' unless defined(&ICMP6_FILTER);
    eval 'sub ICMP6_FILTER_SETPASSALL {
        my($filterp) = @_;
	    eval q(( (($filterp)-> $__icmp6_filt[0] = 0xffffffff), (($filterp)-> $__icmp6_filt[1] = 0xffffffff), (($filterp)-> $__icmp6_filt[2] = 0xffffffff), (($filterp)-> $__icmp6_filt[3] = 0xffffffff), (($filterp)-> $__icmp6_filt[4] = 0xffffffff), (($filterp)-> $__icmp6_filt[5] = 0xffffffff), (($filterp)-> $__icmp6_filt[6] = 0xffffffff), (($filterp)-> $__icmp6_filt[7] = 0xffffffff)));
    }' unless defined(&ICMP6_FILTER_SETPASSALL);
    eval 'sub ICMP6_FILTER_SETBLOCKALL {
        my($filterp) = @_;
	    eval q(( (($filterp)-> $__icmp6_filt[0] = 0x), (($filterp)-> $__icmp6_filt[1] = 0x), (($filterp)-> $__icmp6_filt[2] = 0x), (($filterp)-> $__icmp6_filt[3] = 0x), (($filterp)-> $__icmp6_filt[4] = 0x), (($filterp)-> $__icmp6_filt[5] = 0x), (($filterp)-> $__icmp6_filt[6] = 0x), (($filterp)-> $__icmp6_filt[7] = 0x)));
    }' unless defined(&ICMP6_FILTER_SETBLOCKALL);
    eval 'sub ICMP6_FILTER_SETPASS {
        my($type, $filterp) = @_;
	    eval q((((($filterp)-> $__icmp6_filt[($type) >> 5]) |= (1<< (($type) & 31)))));
    }' unless defined(&ICMP6_FILTER_SETPASS);
    eval 'sub ICMP6_FILTER_SETBLOCK {
        my($type, $filterp) = @_;
	    eval q((((($filterp)-> $__icmp6_filt[($type) >> 5]) &= ~(1<< (($type) & 31)))));
    }' unless defined(&ICMP6_FILTER_SETBLOCK);
    eval 'sub ICMP6_FILTER_WILLPASS {
        my($type, $filterp) = @_;
	    eval q((((($filterp)-> $__icmp6_filt[($type) >> 5]) & (1<< (($type) & 31))) != 0));
    }' unless defined(&ICMP6_FILTER_WILLPASS);
    eval 'sub ICMP6_FILTER_WILLBLOCK {
        my($type, $filterp) = @_;
	    eval q((((($filterp)-> $__icmp6_filt[($type) >> 5]) & (1<< (($type) & 31))) == 0));
    }' unless defined(&ICMP6_FILTER_WILLBLOCK);
    if(defined(&__cplusplus)) {
    }
}
1;
