require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IF_ETHER_H)) {
    eval 'sub _NETINET_IF_ETHER_H () {1;}' unless defined(&_NETINET_IF_ETHER_H);
    require 'net/if_arp.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub ETHERTYPE_PUP () {0x200;}' unless defined(&ETHERTYPE_PUP);
    eval 'sub ETHERTYPE_IP () {0x800;}' unless defined(&ETHERTYPE_IP);
    eval 'sub ETHERTYPE_ARP () {0x806;}' unless defined(&ETHERTYPE_ARP);
    eval 'sub ETHERTYPE_REVARP () {0x8035;}' unless defined(&ETHERTYPE_REVARP);
    eval 'sub ETHERTYPE_IPV6 () {0x86dd;}' unless defined(&ETHERTYPE_IPV6);
    eval 'sub ETHERTYPE_PPPOED () {0x8863;}' unless defined(&ETHERTYPE_PPPOED);
    eval 'sub ETHERTYPE_PPPOES () {0x8864;}' unless defined(&ETHERTYPE_PPPOES);
    eval 'sub ETHERTYPE_TRAIL () {0x1000;}' unless defined(&ETHERTYPE_TRAIL);
    eval 'sub ETHERTYPE_NTRAILER () {16;}' unless defined(&ETHERTYPE_NTRAILER);
    eval 'sub ETHERMTU () {1500;}' unless defined(&ETHERMTU);
    eval 'sub ETHERMIN () {(60-14);}' unless defined(&ETHERMIN);
    eval 'sub arp_hrd () { ($ea_hdr->{ar_hrd});}' unless defined(&arp_hrd);
    eval 'sub arp_pro () { ($ea_hdr->{ar_pro});}' unless defined(&arp_pro);
    eval 'sub arp_hln () { ($ea_hdr->{ar_hln});}' unless defined(&arp_hln);
    eval 'sub arp_pln () { ($ea_hdr->{ar_pln});}' unless defined(&arp_pln);
    eval 'sub arp_op () { ($ea_hdr->{ar_op});}' unless defined(&arp_op);
    eval 'sub MCADDRMAX () {64;}' unless defined(&MCADDRMAX);
    eval 'sub MCCOUNTMAX () {4096;}' unless defined(&MCCOUNTMAX);
    eval 'sub at_enaddr () { ($at_union->{atu_enaddr});}' unless defined(&at_enaddr);
    eval 'sub at_tvsec () { ($at_union->{atu_tvsec});}' unless defined(&at_tvsec);
    if(defined( &sparc) || defined( &__sparc)) {
	eval 'sub ether_cmp {
	    my($a, $b) = @_;
    	    eval q(([2] != [2] || [1] != [1] || [0] != ($a)[0]));
	}' unless defined(&ether_cmp);
    } else {
	eval 'sub ether_cmp {
	    my($a, $b) = @_;
    	    eval q(( &bcmp($a, $b, 6)));
	}' unless defined(&ether_cmp);
    }
    if(defined( &sparc) || defined( &__sparc)) {
	eval 'sub ether_copy {
	    my($a, $b) = @_;
    	    eval q({ [0] = [0]; [1] = [1]; [2] = ($a)[2]; });
	}' unless defined(&ether_copy);
    } else {
	eval 'sub ether_copy {
	    my($a, $b) = @_;
    	    eval q(( &bcopy($a, $b, 6)));
	}' unless defined(&ether_copy);
    }
    if(defined( &sparc) || defined( &__sparc)) {
	eval 'sub ip_copy {
	    my($a, $b) = @_;
    	    eval q({ [0] = [0]; [1] = ($a)[1]; });
	}' unless defined(&ip_copy);
    } else {
	eval 'sub ip_copy {
	    my($a, $b) = @_;
    	    eval q(( &bcopy($a, $b, 4)));
	}' unless defined(&ip_copy);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
