require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IGMP_VAR_H)) {
    eval 'sub _NETINET_IGMP_VAR_H () {1;}' unless defined(&_NETINET_IGMP_VAR_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub IGMP_TIMEOUT_FREQUENCY () {10;}' unless defined(&IGMP_TIMEOUT_FREQUENCY);
	eval 'sub IGMP_TIMEOUT_INTERVAL () {(1000/ &IGMP_TIMEOUT_FREQUENCY);}' unless defined(&IGMP_TIMEOUT_INTERVAL);
	eval 'sub MLD_TIMEOUT_INTERVAL () {1;}' unless defined(&MLD_TIMEOUT_INTERVAL);
	eval 'sub IGMP_RANDOM_DELAY {
	    my($multiaddr, $ipif, $maxticks) = @_;
    	    eval q((( &TICK_TO_MSEC( &lbolt) + (($ipif !=  &NULL) ? ( ($ipif->{ipif_lcl_addr})) : 0) +  &ntohl($multiaddr)) % ($maxticks) + 1));
	}' unless defined(&IGMP_RANDOM_DELAY);
	eval 'sub MLD_RANDOM_DELAY {
	    my($multiaddr, $ipif, $maxticks) = @_;
    	    eval q((((($ipif !=  &NULL) ? ( ($ipif->{ipif_v6lcl_addr}->{s6_addr32[3]})) : 0) +  &ntohl( ($multiaddr->{s6_addr32[3]}))) % ($maxticks) + 1));
	}' unless defined(&MLD_RANDOM_DELAY);
	eval 'sub IGMP_OTHERMEMBER () {0;}' unless defined(&IGMP_OTHERMEMBER);
	eval 'sub IGMP_IREPORTEDLAST () {1;}' unless defined(&IGMP_IREPORTEDLAST);
	eval 'sub IGMP_V1_ROUTER () {0;}' unless defined(&IGMP_V1_ROUTER);
	eval 'sub IGMP_V2_ROUTER () {1;}' unless defined(&IGMP_V2_ROUTER);
	eval 'sub IGMP_AGE_THRESHOLD () {270;}' unless defined(&IGMP_AGE_THRESHOLD);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
