require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IP6_H)) {
    eval 'sub _NETINET_IP6_H () {1;}' unless defined(&_NETINET_IP6_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'netinet/in.ph';
    eval 'sub ip6_vfc () { ($ip6_ctlun->{ip6_un2_vfc});}' unless defined(&ip6_vfc);
    eval 'sub ip6_flow () { ($ip6_ctlun->{ip6_un1}->{ip6_un1_flow});}' unless defined(&ip6_flow);
    eval 'sub ip6_vcf () { &ip6_flow;}' unless defined(&ip6_vcf);
    eval 'sub ip6_plen () { ($ip6_ctlun->{ip6_un1}->{ip6_un1_plen});}' unless defined(&ip6_plen);
    eval 'sub ip6_nxt () { ($ip6_ctlun->{ip6_un1}->{ip6_un1_nxt});}' unless defined(&ip6_nxt);
    eval 'sub ip6_hlim () { ($ip6_ctlun->{ip6_un1}->{ip6_un1_hlim});}' unless defined(&ip6_hlim);
    eval 'sub ip6_hops () { ($ip6_ctlun->{ip6_un1}->{ip6_un1_hlim});}' unless defined(&ip6_hops);
    if(defined(&_BIG_ENDIAN)) {
	eval 'sub IP6F_OFF_MASK () {0xfff8;}' unless defined(&IP6F_OFF_MASK);
	eval 'sub IP6F_RESERVED_MASK () {0x6;}' unless defined(&IP6F_RESERVED_MASK);
	eval 'sub IP6F_MORE_FRAG () {0x1;}' unless defined(&IP6F_MORE_FRAG);
    } else {
	eval 'sub IP6F_OFF_MASK () {0xf8ff;}' unless defined(&IP6F_OFF_MASK);
	eval 'sub IP6F_RESERVED_MASK () {0x600;}' unless defined(&IP6F_RESERVED_MASK);
	eval 'sub IP6F_MORE_FRAG () {0x100;}' unless defined(&IP6F_MORE_FRAG);
    }
    eval 'sub IP6OPT_TYPE {
        my($o) = @_;
	    eval q((($o) & 0xc0));
    }' unless defined(&IP6OPT_TYPE);
    eval 'sub IP6OPT_TYPE_SKIP () {0x;}' unless defined(&IP6OPT_TYPE_SKIP);
    eval 'sub IP6OPT_TYPE_DISCARD () {0x40;}' unless defined(&IP6OPT_TYPE_DISCARD);
    eval 'sub IP6OPT_TYPE_FORCEICMP () {0x80;}' unless defined(&IP6OPT_TYPE_FORCEICMP);
    eval 'sub IP6OPT_TYPE_ICMP () {0xc0;}' unless defined(&IP6OPT_TYPE_ICMP);
    eval 'sub IP6OPT_MUTABLE () {0x20;}' unless defined(&IP6OPT_MUTABLE);
    eval 'sub IP6OPT_PAD1 () {0x;}' unless defined(&IP6OPT_PAD1);
    eval 'sub IP6OPT_PADN () {0x1;}' unless defined(&IP6OPT_PADN);
    eval 'sub IP6OPT_JUMBO () {0xc2;}' unless defined(&IP6OPT_JUMBO);
    eval 'sub IP6OPT_NSAP_ADDR () {0xc3;}' unless defined(&IP6OPT_NSAP_ADDR);
    eval 'sub IP6OPT_TUNNEL_LIMIT () {0x4;}' unless defined(&IP6OPT_TUNNEL_LIMIT);
    eval 'sub IP6OPT_ROUTER_ALERT () {0x5;}' unless defined(&IP6OPT_ROUTER_ALERT);
    eval 'sub IP6OPT_BINDING_UPDATE () {0xc6;}' unless defined(&IP6OPT_BINDING_UPDATE);
    eval 'sub IP6OPT_BINDING_ACK () {0x7;}' unless defined(&IP6OPT_BINDING_ACK);
    eval 'sub IP6OPT_BINDING_REQ () {0x8;}' unless defined(&IP6OPT_BINDING_REQ);
    eval 'sub IP6OPT_HOME_ADDRESS () {0xc9;}' unless defined(&IP6OPT_HOME_ADDRESS);
    eval 'sub IP6OPT_EID () {0x8a;}' unless defined(&IP6OPT_EID);
    eval 'sub IP6OPT_JUMBO_LEN () {6;}' unless defined(&IP6OPT_JUMBO_LEN);
    if(defined(&_BIG_ENDIAN)) {
	eval 'sub IP6_ALERT_MLD () {0x;}' unless defined(&IP6_ALERT_MLD);
	eval 'sub IP6_ALERT_RSVP () {0x1;}' unless defined(&IP6_ALERT_RSVP);
	eval 'sub IP6_ALERT_AN () {0x2;}' unless defined(&IP6_ALERT_AN);
    } else {
	eval 'sub IP6_ALERT_MLD () {0x;}' unless defined(&IP6_ALERT_MLD);
	eval 'sub IP6_ALERT_RSVP () {0x100;}' unless defined(&IP6_ALERT_RSVP);
	eval 'sub IP6_ALERT_AN () {0x200;}' unless defined(&IP6_ALERT_AN);
    }
    eval 'sub IP6_BUF_ACK () {0x80;}' unless defined(&IP6_BUF_ACK);
    eval 'sub IP6_BUF_HOME () {0x40;}' unless defined(&IP6_BUF_HOME);
    eval 'sub IP6_BUF_COA () {0x20;}' unless defined(&IP6_BUF_COA);
    eval 'sub IP6_BUF_ROUTER () {0x10;}' unless defined(&IP6_BUF_ROUTER);
    if(defined(&__cplusplus)) {
    }
}
1;
