require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IP_MROUTE_H)) {
    eval 'sub _NETINET_IP_MROUTE_H () {1;}' unless defined(&_NETINET_IP_MROUTE_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&UPCALL_TIMING)) {
	eval 'sub UPCALL_MAX_TIME () {51;}' unless defined(&UPCALL_MAX_TIME);
    }
    eval 'sub MRT_INIT () {100;}' unless defined(&MRT_INIT);
    eval 'sub MRT_DONE () {101;}' unless defined(&MRT_DONE);
    eval 'sub MRT_ADD_VIF () {102;}' unless defined(&MRT_ADD_VIF);
    eval 'sub MRT_DEL_VIF () {103;}' unless defined(&MRT_DEL_VIF);
    eval 'sub MRT_ADD_MFC () {104;}' unless defined(&MRT_ADD_MFC);
    eval 'sub MRT_DEL_MFC () {105;}' unless defined(&MRT_DEL_MFC);
    eval 'sub MRT_VERSION () {106;}' unless defined(&MRT_VERSION);
    eval 'sub MRT_ASSERT () {107;}' unless defined(&MRT_ASSERT);
    eval 'sub MAXVIFS () {32;}' unless defined(&MAXVIFS);
    eval 'sub ALL_VIFS () {( &vifi_t)-1;}' unless defined(&ALL_VIFS);
    eval 'sub VIFM_SET {
        my($n, $m) = @_;
	    eval q((($m) |= (1<< ($n))));
    }' unless defined(&VIFM_SET);
    eval 'sub VIFM_CLR {
        my($n, $m) = @_;
	    eval q((($m) &= ~(1<< ($n))));
    }' unless defined(&VIFM_CLR);
    eval 'sub VIFM_ISSET {
        my($n, $m) = @_;
	    eval q((($m) & (1<< ($n))));
    }' unless defined(&VIFM_ISSET);
    eval 'sub VIFM_CLRALL {
        my($m) = @_;
	    eval q((($m) = 0x));
    }' unless defined(&VIFM_CLRALL);
    eval 'sub VIFM_COPY {
        my($mfrom, $mto) = @_;
	    eval q((($mto) = ($mfrom)));
    }' unless defined(&VIFM_COPY);
    eval 'sub VIFM_SAME {
        my($m1, $m2) = @_;
	    eval q((($m1) == ($m2)));
    }' unless defined(&VIFM_SAME);
    eval 'sub VIFF_TUNNEL () {0x1;}' unless defined(&VIFF_TUNNEL);
    eval 'sub VIFF_SRCRT () {0x2;}' unless defined(&VIFF_SRCRT);
    eval 'sub VIFF_REGISTER () {0x4;}' unless defined(&VIFF_REGISTER);
    if(defined(&UPCALL_TIMING)) {
    }
    if(defined(&_KERNEL)) {
	if(defined(&UPCALL_TIMING)) {
	}
    }
    eval 'sub IGMPMSG_NOCACHE () {1;}' unless defined(&IGMPMSG_NOCACHE);
    eval 'sub IGMPMSG_WRONGVIF () {2;}' unless defined(&IGMPMSG_WRONGVIF);
    eval 'sub IGMPMSG_WHOLEPKT () {3;}' unless defined(&IGMPMSG_WHOLEPKT);
    if(defined(&_KERNEL)) {
	eval 'sub MFCTBLSIZ () {256;}' unless defined(&MFCTBLSIZ);
	if(((defined(&MFCTBLSIZ) ? &MFCTBLSIZ : 0) & ((defined(&MFCTBLSIZ) ? &MFCTBLSIZ : 0) - 1)) == 0) {
	    eval 'sub MFCHASHMOD {
	        my($h) = @_;
    		eval q((($h) & ( &MFCTBLSIZ - 1)));
	    }' unless defined(&MFCHASHMOD);
	} else {
	    eval 'sub MFCHASHMOD {
	        my($h) = @_;
    		eval q((($h) %  &MFCTBLSIZ));
	    }' unless defined(&MFCHASHMOD);
	}
	eval 'sub MAX_UPQ () {4;}' unless defined(&MAX_UPQ);
	eval 'sub MAX_BKT_SIZE () {10000;}' unless defined(&MAX_BKT_SIZE);
	eval 'sub MAXQSIZE () {10;}' unless defined(&MAXQSIZE);
	eval 'sub TOKEN_SIZE () {8;}' unless defined(&TOKEN_SIZE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
