require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NFS_LM_H)) {
    eval 'sub _NFS_LM_H () {1;}' unless defined(&_NFS_LM_H);
    require 'nfs/lm_nlm.ph';
    require 'sys/mutex.ph';
    require 'sys/thread.ph';
    require 'sys/note.ph';
    require 'nfs/nfs.ph';
    require 'nfs/nfssys.ph';
    require 'nfs/nfs_clnt.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&LM_DEBUG_COTS)) {
    }
    unless(defined(&lint)) {
    }
    unless(defined(&lint)) {
    }
    eval 'sub LM_SYSID () {(( &sysid_t)0x1);}' unless defined(&LM_SYSID);
    eval 'sub LM_SYSID_MAX () {(( &sysid_t)0x3fff);}' unless defined(&LM_SYSID_MAX);
    eval 'sub LM_SYSID_CLIENT () {(( &sysid_t)0x4000);}' unless defined(&LM_SYSID_CLIENT);
    eval 'sub LM_STATD_DELAY () {10;}' unless defined(&LM_STATD_DELAY);
    eval 'sub LM_NO_TIMOUT () {0;}' unless defined(&LM_NO_TIMOUT);
    eval 'sub LM_GR_TIMOUT () {20;}' unless defined(&LM_GR_TIMOUT);
    eval 'sub LM_SM_TIMOUT () {5;}' unless defined(&LM_SM_TIMOUT);
    eval 'sub LM_CR_TIMOUT () {20;}' unless defined(&LM_CR_TIMOUT);
    eval 'sub LM_RLOCK_SLP () {20;}' unless defined(&LM_RLOCK_SLP);
    eval 'sub LM_ERROR_SLP () {30;}' unless defined(&LM_ERROR_SLP);
    eval 'sub LM_GRACE_SLP () {10;}' unless defined(&LM_GRACE_SLP);
    eval 'sub LM_BLOCK_SLP () {60;}' unless defined(&LM_BLOCK_SLP);
    eval 'sub LM_RETRY () {5;}' unless defined(&LM_RETRY);
    eval 'sub LM_RECLAIM_RETRY () {100;}' unless defined(&LM_RECLAIM_RETRY);
    eval 'sub LM_ASYN_RETRY () {3;}' unless defined(&LM_ASYN_RETRY);
    eval 'sub LM_PMAP_TIMEOUT () {15;}' unless defined(&LM_PMAP_TIMEOUT);
    eval 'sub LM_GR_RETRY () {1;}' unless defined(&LM_GR_RETRY);
    eval 'sub LM_OH_SYS_LEN () {($sizeof{ &lm_owner_handle_sys});}' unless defined(&LM_OH_SYS_LEN);
    eval 'sub LM_OH_LEN () {($sizeof{ &pid_t} +  &LM_OH_SYS_LEN);}' unless defined(&LM_OH_LEN);
    unless(defined(&lint)) {
    }
    unless(defined(&lint)) {
    }
    unless(defined(&lint)) {
    }
    if(defined(&_KERNEL)) {
	if(defined(&DEBUG)) {
	}
	eval 'sub lm_zalloc {
	    my($s) = @_;
    	    eval q( &kmem_zalloc($sizeof{$s},  &KM_SLEEP));
	}' unless defined(&lm_zalloc);
    } else {
	if(defined(&__STDC__)) {
	} else {
	}
    }
    eval 'sub LM_DEBUG_SUPPORT () {1;}' unless defined(&LM_DEBUG_SUPPORT);
    if(defined(&LM_DEBUG_SUPPORT)) {
	eval 'sub LM_DEBUG {
	    my($a) = @_;
    	    eval q( &lm_debug $a);
	}' unless defined(&LM_DEBUG);
    } else {
	eval 'sub LM_DEBUG {
	    my($a) = @_;
    	    eval q();
	}' unless defined(&LM_DEBUG);
	eval 'sub lm_alock {
	    my($a, $b, $c) = @_;
    	    eval q();
	}' unless defined(&lm_alock);
	eval 'sub lm_d_nsa {
	    my($a, $b, $c) = @_;
    	    eval q();
	}' unless defined(&lm_d_nsa);
	eval 'sub lm_n_buf {
	    my($a, $b, $c, $d) = @_;
    	    eval q();
	}' unless defined(&lm_n_buf);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
