require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NFS_LOG_H)) {
    eval 'sub _NFS_LOG_H () {1;}' unless defined(&_NFS_LOG_H);
    if(defined(&__cplusplus)) {
    }
    require 'nfs/nfs.ph';
    require 'nfs/export.ph';
    require 'rpc/rpc.ph';
    eval 'sub LOG_MODE () {0600;}' unless defined(&LOG_MODE);
    eval 'sub LOG_INPROG_STRING () {"_log_in_process";}' unless defined(&LOG_INPROG_STRING);
    eval 'sub NFSLOG_PROGRAM () {(( &rpcprog_t)42);}' unless defined(&NFSLOG_PROGRAM);
    eval 'sub NFSLOG_VERSION () {(( &rpcvers_t)1);}' unless defined(&NFSLOG_VERSION);
    eval 'sub NFSLOG_VERSMIN () {(( &rpcvers_t)1);}' unless defined(&NFSLOG_VERSMIN);
    eval 'sub NFSLOG_VERSMAX () {(( &rpcvers_t)1);}' unless defined(&NFSLOG_VERSMAX);
    eval 'sub NFSLOG_NULL () {(( &rpcproc_t)0);}' unless defined(&NFSLOG_NULL);
    eval 'sub NFSLOG_SHARE () {(( &rpcproc_t)1);}' unless defined(&NFSLOG_SHARE);
    eval 'sub NFSLOG_UNSHARE () {(( &rpcproc_t)2);}' unless defined(&NFSLOG_UNSHARE);
    eval 'sub NFSLOG_LOOKUP () {(( &rpcproc_t)3);}' unless defined(&NFSLOG_LOOKUP);
    eval 'sub NFSLOG_GETFH () {(( &rpcproc_t)4);}' unless defined(&NFSLOG_GETFH);
    eval 'sub NFSLOG_BUF_VERSION () {1;}' unless defined(&NFSLOG_BUF_VERSION);
    unless(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_KERNEL)) {
	eval 'sub NFSLOG_ALL_BUFFERS () {1;}' unless defined(&NFSLOG_ALL_BUFFERS);
	eval 'sub NFSLOG_ONE_BUFFER () {2;}' unless defined(&NFSLOG_ONE_BUFFER);
	eval 'sub NFSLOG_SMALL_RECORD_SIZE () {512;}' unless defined(&NFSLOG_SMALL_RECORD_SIZE);
	eval 'sub NFSLOG_SMALL_REC_NAME () {"nfslog_small_rec";}' unless defined(&NFSLOG_SMALL_REC_NAME);
	eval 'sub NFSLOG_MEDIUM_RECORD_SIZE () {8192;}' unless defined(&NFSLOG_MEDIUM_RECORD_SIZE);
	eval 'sub NFSLOG_MEDIUM_REC_NAME () {"nfslog_medium_rec";}' unless defined(&NFSLOG_MEDIUM_REC_NAME);
	eval 'sub NFSLOG_LARGE_RECORD_SIZE () {32768;}' unless defined(&NFSLOG_LARGE_RECORD_SIZE);
	eval 'sub NFSLOG_LARGE_REC_NAME () {"nfslog_large_rec";}' unless defined(&NFSLOG_LARGE_REC_NAME);
	unless(defined(&DEBUG)) {
	    eval 'sub LOGGING_DPRINT {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&LOGGING_DPRINT);
	} else {
	    eval 'sub LOGGING_DPRINT {
	        my($x) = @_;
    		eval q( &nfslog_dprint $x);
	    }' unless defined(&LOGGING_DPRINT);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
