require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RPC_SVC_H)) {
    eval 'sub _RPC_SVC_H () {1;}' unless defined(&_RPC_SVC_H);
    require 'rpc/rpc_com.ph';
    require 'rpc/rpc_msg.ph';
    require 'sys/tihdr.ph';
    require 'sys/poll.ph';
    if(defined(&_KERNEL)) {
	require 'rpc/svc_auth.ph';
	require 'sys/callb.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    unless(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub DUP_NEW () {0x;}' unless defined(&DUP_NEW);
	eval 'sub DUP_INPROGRESS () {0x1;}' unless defined(&DUP_INPROGRESS);
	eval 'sub DUP_DONE () {0x2;}' unless defined(&DUP_DONE);
	eval 'sub DUP_DROP () {0x3;}' unless defined(&DUP_DROP);
	eval 'sub DUP_ERROR () {0x4;}' unless defined(&DUP_ERROR);
    } else {
	eval 'sub SVCGET_VERSQUIET () {1;}' unless defined(&SVCGET_VERSQUIET);
	eval 'sub SVCSET_VERSQUIET () {2;}' unless defined(&SVCSET_VERSQUIET);
	eval 'sub SVCGET_XID () {4;}' unless defined(&SVCGET_XID);
	eval 'sub SVCSET_KEEPALIVE () {5;}' unless defined(&SVCSET_KEEPALIVE);
	eval 'sub SVCSET_CONNMAXREC () {6;}' unless defined(&SVCSET_CONNMAXREC);
	eval 'sub SVCGET_CONNMAXREC () {7;}' unless defined(&SVCGET_CONNMAXREC);
	eval 'sub SVCGET_RECVERRHANDLER () {8;}' unless defined(&SVCGET_RECVERRHANDLER);
	eval 'sub SVCSET_RECVERRHANDLER () {9;}' unless defined(&SVCSET_RECVERRHANDLER);
	eval("sub XPRT_DIED () { 0; }") unless defined(&XPRT_DIED);
	eval("sub XPRT_MOREREQS () { 1; }") unless defined(&XPRT_MOREREQS);
	eval("sub XPRT_IDLE () { 2; }") unless defined(&XPRT_IDLE);
	if(defined(&__STDC__)) {
	} else {
	}
    }
    if(defined(&_KERNEL)) {
	eval 'sub xp_fp () { ($xp_xpc->{xpc_fp});}' unless defined(&xp_fp);
	eval 'sub xp_ops () { ($xp_xpc->{xpc_ops});}' unless defined(&xp_ops);
	eval 'sub xp_wq () { ($xp_xpc->{xpc_wq});}' unless defined(&xp_wq);
	eval 'sub xp_cred () { ($xp_xpc->{xpc_cred});}' unless defined(&xp_cred);
	eval 'sub xp_type () { ($xp_xpc->{xpc_type});}' unless defined(&xp_type);
	eval 'sub xp_msg_size () { ($xp_xpc->{xpc_msg_size});}' unless defined(&xp_msg_size);
	eval 'sub xp_rtaddr () { ($xp_xpc->{xpc_rtaddr});}' unless defined(&xp_rtaddr);
	eval 'sub xp_sct () { ($xp_xpc->{xpc_sct});}' unless defined(&xp_sct);
	eval 'sub SVC_P2LEN () {32;}' unless defined(&SVC_P2LEN);
    } else {
	eval 'sub xp_sock () { &xp_fd;}' unless defined(&xp_sock);
    }
    eval 'sub svc_getrpccaller {
        my($x) = @_;
	    eval q((($x)-> &xp_rtaddr));
    }' unless defined(&svc_getrpccaller);
    if(defined(&_KERNEL)) {
	eval 'sub svc_getcaller {
	    my($x) = @_;
    	    eval q((($x)-> ($xp_rtaddr->{buf})));
	}' unless defined(&svc_getcaller);
	eval 'sub svc_getaddrmask {
	    my($x) = @_;
    	    eval q((($x)-> ($xp_master->{xp_addrmask})));
	}' unless defined(&svc_getaddrmask);
	eval 'sub svc_getnetid {
	    my($x) = @_;
    	    eval q((($x)-> ($xp_master->{xp_netid})));
	}' unless defined(&svc_getnetid);
    }
    if(defined(&_KERNEL)) {
	eval 'sub SVC_RECV {
	    my($clone_xprt, $mp, $msg) = @_;
    	    eval q((*($clone_xprt)-> ($xp_ops->{xp_recv}))(($clone_xprt), ($mp), ($msg)));
	}' unless defined(&SVC_RECV);
	eval 'sub SVC_GETARGS {
	    my($clone_xprt, $xargs, $argsp) = @_;
    	    eval q((*($clone_xprt)-> ($xp_ops->{xp_getargs}))(($clone_xprt), ($xargs), ($argsp)));
	}' unless defined(&SVC_GETARGS);
	eval 'sub SVC_REPLY {
	    my($clone_xprt, $msg) = @_;
    	    eval q((*($clone_xprt)-> ($xp_ops->{xp_reply})) (($clone_xprt), ($msg)));
	}' unless defined(&SVC_REPLY);
	eval 'sub SVC_FREEARGS {
	    my($clone_xprt, $xargs, $argsp) = @_;
    	    eval q((*($clone_xprt)-> ($xp_ops->{xp_freeargs}))(($clone_xprt), ($xargs), ($argsp)));
	}' unless defined(&SVC_FREEARGS);
	eval 'sub SVC_GETRES {
	    my($clone_xprt, $size) = @_;
    	    eval q((*($clone_xprt)-> ($xp_ops->{xp_getres}))(($clone_xprt), ($size)));
	}' unless defined(&SVC_GETRES);
	eval 'sub SVC_FREERES {
	    my($clone_xprt) = @_;
    	    eval q((*($clone_xprt)-> ($xp_ops->{xp_freeres}))($clone_xprt));
	}' unless defined(&SVC_FREERES);
	eval 'sub SVC_DESTROY {
	    my($xprt) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_destroy}))($xprt));
	}' unless defined(&SVC_DESTROY);
	eval 'sub SVC_DUP {
	    my($clone_xprt, $req, $res, $size, $drpp) = @_;
    	    eval q((*($clone_xprt)-> ($xp_ops->{xp_dup}))($req, $res, $size, $drpp));
	}' unless defined(&SVC_DUP);
	eval 'sub SVC_DUPDONE {
	    my($clone_xprt, $dr, $res, $size, $status) = @_;
    	    eval q((*($clone_xprt)-> ($xp_ops->{xp_dupdone}))($dr, $res, $size, $status));
	}' unless defined(&SVC_DUPDONE);
	eval 'sub SVC_CLONE_DESTROY {
	    my($clone_xprt) = @_;
    	    eval q((*($clone_xprt)-> ($xp_ops->{xp_clone_destroy}))($clone_xprt));
	}' unless defined(&SVC_CLONE_DESTROY);
	eval 'sub SVC_START {
	    my($xprt) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_start}))($xprt));
	}' unless defined(&SVC_START);
    } else {
	eval 'sub SVC_RECV {
	    my($xprt, $msg) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_recv}))(($xprt), ($msg)));
	}' unless defined(&SVC_RECV);
	eval 'sub svc_recv {
	    my($xprt, $msg) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_recv}))(($xprt), ($msg)));
	}' unless defined(&svc_recv);
	eval 'sub SVC_STAT {
	    my($xprt) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_stat}))($xprt));
	}' unless defined(&SVC_STAT);
	eval 'sub svc_stat {
	    my($xprt) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_stat}))($xprt));
	}' unless defined(&svc_stat);
	eval 'sub SVC_GETARGS {
	    my($xprt, $xargs, $argsp) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_getargs}))(($xprt), ($xargs), ($argsp)));
	}' unless defined(&SVC_GETARGS);
	eval 'sub svc_getargs {
	    my($xprt, $xargs, $argsp) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_getargs}))(($xprt), ($xargs), ($argsp)));
	}' unless defined(&svc_getargs);
	eval 'sub SVC_REPLY {
	    my($xprt, $msg) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_reply})) (($xprt), ($msg)));
	}' unless defined(&SVC_REPLY);
	eval 'sub svc_reply {
	    my($xprt, $msg) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_reply})) (($xprt), ($msg)));
	}' unless defined(&svc_reply);
	eval 'sub SVC_FREEARGS {
	    my($xprt, $xargs, $argsp) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_freeargs}))(($xprt), ($xargs), ($argsp)));
	}' unless defined(&SVC_FREEARGS);
	eval 'sub svc_freeargs {
	    my($xprt, $xargs, $argsp) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_freeargs}))(($xprt), ($xargs), ($argsp)));
	}' unless defined(&svc_freeargs);
	eval 'sub SVC_GETRES {
	    my($xprt, $size) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_getres}))(($xprt), ($size)));
	}' unless defined(&SVC_GETRES);
	eval 'sub svc_getres {
	    my($xprt, $size) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_getres}))(($xprt), ($size)));
	}' unless defined(&svc_getres);
	eval 'sub SVC_FREERES {
	    my($xprt) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_freeres}))($xprt));
	}' unless defined(&SVC_FREERES);
	eval 'sub svc_freeres {
	    my($xprt) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_freeres}))($xprt));
	}' unless defined(&svc_freeres);
	eval 'sub SVC_DESTROY {
	    my($xprt) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_destroy}))($xprt));
	}' unless defined(&SVC_DESTROY);
	eval 'sub svc_destroy {
	    my($xprt) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_destroy}))($xprt));
	}' unless defined(&svc_destroy);
	eval 'sub SVC_CONTROL {
	    my($xprt, $rq, $in) = @_;
    	    eval q((*($xprt)-> ($xp_ops->{xp_control}))(($xprt), ($rq), ($in)));
	}' unless defined(&SVC_CONTROL);
    }
    eval 'sub NFS_SVCPOOL_ID () {0x1;}' unless defined(&NFS_SVCPOOL_ID);
    eval 'sub NLM_SVCPOOL_ID () {0x2;}' unless defined(&NLM_SVCPOOL_ID);
    if(defined(&_KERNEL)) {
    } else {
	if(defined(&__STDC__)) {
	} else {
	}
    }
    if(defined(&__STDC__)) {
    } else {
    }
    if(defined(&_KERNEL)) {
    } else {
	if(!defined( &_LP64)  && (defined(&FD_SETSIZE) ? &FD_SETSIZE : 0) > 1024) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub svc_fdset () { &_new_svc_fdset;}' unless defined(&svc_fdset);
	    }
	}
	eval 'sub svc_fds () { ($svc_fdset->{fds_bits[0]});}' unless defined(&svc_fds);
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&PORTMAP)) {
	    require 'rpc/svc_soc.ph';
	}
	eval 'sub RPC_SVC_MT_NONE () {0;}' unless defined(&RPC_SVC_MT_NONE);
	eval 'sub RPC_SVC_MT_AUTO () {1;}' unless defined(&RPC_SVC_MT_AUTO);
	eval 'sub RPC_SVC_MT_USER () {2;}' unless defined(&RPC_SVC_MT_USER);
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	eval 'sub DUPCACHE_FIXEDTIME () {0;}' unless defined(&DUPCACHE_FIXEDTIME);
	eval 'sub DUP_NEW () {0x;}' unless defined(&DUP_NEW);
	eval 'sub DUP_INPROGRESS () {0x1;}' unless defined(&DUP_INPROGRESS);
	eval 'sub DUP_DONE () {0x2;}' unless defined(&DUP_DONE);
	eval 'sub DUP_DROP () {0x3;}' unless defined(&DUP_DROP);
	eval 'sub DUP_ERROR () {0x4;}' unless defined(&DUP_ERROR);
	if(defined(&__STDC__)) {
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
