require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RPC_XDR_H)) {
    eval 'sub _RPC_XDR_H () {1;}' unless defined(&_RPC_XDR_H);
    require 'sys/byteorder.ph';
    require 'rpc/types.ph';
    unless(defined(&_KERNEL)) {
	require 'stdio.ph';
    }
    if(defined(&_KERNEL)) {
	require 'sys/stream.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval("sub XDR_ENCODE () { 0; }") unless defined(&XDR_ENCODE);
    eval("sub XDR_DECODE () { 1; }") unless defined(&XDR_DECODE);
    eval("sub XDR_FREE () { 2; }") unless defined(&XDR_FREE);
    eval 'sub BYTES_PER_XDR_UNIT () {(4);}' unless defined(&BYTES_PER_XDR_UNIT);
    eval 'sub RNDUP {
        my($x) = @_;
	    eval q((((($x) +  &BYTES_PER_XDR_UNIT - 1) /  &BYTES_PER_XDR_UNIT) *  &BYTES_PER_XDR_UNIT));
    }' unless defined(&RNDUP);
    if(defined(&__STDC__)) {
	if(!defined( &_KERNEL)) {
	}
	if(defined( &_LP64) || defined( &_KERNEL)) {
	}
    } else {
	if(!defined( &_KERNEL)) {
	}
	if(defined( &_LP64) || defined( &_KERNEL)) {
	}
    }
    if(!defined( &_KERNEL)) {
	eval 'sub XDR_GETLONG {
	    my($xdrs, $longp) = @_;
    	    eval q((*($xdrs)-> ($x_ops->{x_getlong}))($xdrs, $longp));
	}' unless defined(&XDR_GETLONG);
	eval 'sub xdr_getlong {
	    my($xdrs, $longp) = @_;
    	    eval q((*($xdrs)-> ($x_ops->{x_getlong}))($xdrs, $longp));
	}' unless defined(&xdr_getlong);
	eval 'sub XDR_PUTLONG {
	    my($xdrs, $longp) = @_;
    	    eval q((*($xdrs)-> ($x_ops->{x_putlong}))($xdrs, $longp));
	}' unless defined(&XDR_PUTLONG);
	eval 'sub xdr_putlong {
	    my($xdrs, $longp) = @_;
    	    eval q((*($xdrs)-> ($x_ops->{x_putlong}))($xdrs, $longp));
	}' unless defined(&xdr_putlong);
    }
    if(!defined( &_LP64)  && !defined( &_KERNEL)) {
	eval 'sub XDR_GETINT32 {
	    my($xdrs, $int32p) = @_;
    	    eval q((*-> ($x_ops->{x_getlong}))($xdrs, $int32p));
	}' unless defined(&XDR_GETINT32);
	eval 'sub xdr_getint32 {
	    my($xdrs, $int32p) = @_;
    	    eval q((*-> ($x_ops->{x_getlong}))($xdrs, $int32p));
	}' unless defined(&xdr_getint32);
	eval 'sub XDR_PUTINT32 {
	    my($xdrs, $int32p) = @_;
    	    eval q((*-> ($x_ops->{x_putlong}))($xdrs, $int32p));
	}' unless defined(&XDR_PUTINT32);
	eval 'sub xdr_putint32 {
	    my($xdrs, $int32p) = @_;
    	    eval q((*-> ($x_ops->{x_putlong}))($xdrs, $int32p));
	}' unless defined(&xdr_putint32);
    } else {
	eval 'sub XDR_GETINT32 {
	    my($xdrs, $int32p) = @_;
    	    eval q((*($xdrs)-> ($x_ops->{x_getint32}))($xdrs, $int32p));
	}' unless defined(&XDR_GETINT32);
	eval 'sub xdr_getint32 {
	    my($xdrs, $int32p) = @_;
    	    eval q((*($xdrs)-> ($x_ops->{x_getint32}))($xdrs, $int32p));
	}' unless defined(&xdr_getint32);
	eval 'sub XDR_PUTINT32 {
	    my($xdrs, $int32p) = @_;
    	    eval q((*($xdrs)-> ($x_ops->{x_putint32}))($xdrs, $int32p));
	}' unless defined(&XDR_PUTINT32);
	eval 'sub xdr_putint32 {
	    my($xdrs, $int32p) = @_;
    	    eval q((*($xdrs)-> ($x_ops->{x_putint32}))($xdrs, $int32p));
	}' unless defined(&xdr_putint32);
    }
    eval 'sub XDR_GETBYTES {
        my($xdrs, $addr, $len) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_getbytes}))($xdrs, $addr, $len));
    }' unless defined(&XDR_GETBYTES);
    eval 'sub xdr_getbytes {
        my($xdrs, $addr, $len) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_getbytes}))($xdrs, $addr, $len));
    }' unless defined(&xdr_getbytes);
    eval 'sub XDR_PUTBYTES {
        my($xdrs, $addr, $len) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_putbytes}))($xdrs, $addr, $len));
    }' unless defined(&XDR_PUTBYTES);
    eval 'sub xdr_putbytes {
        my($xdrs, $addr, $len) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_putbytes}))($xdrs, $addr, $len));
    }' unless defined(&xdr_putbytes);
    eval 'sub XDR_GETPOS {
        my($xdrs) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_getpostn}))($xdrs));
    }' unless defined(&XDR_GETPOS);
    eval 'sub xdr_getpos {
        my($xdrs) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_getpostn}))($xdrs));
    }' unless defined(&xdr_getpos);
    eval 'sub XDR_SETPOS {
        my($xdrs, $pos) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_setpostn}))($xdrs, $pos));
    }' unless defined(&XDR_SETPOS);
    eval 'sub xdr_setpos {
        my($xdrs, $pos) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_setpostn}))($xdrs, $pos));
    }' unless defined(&xdr_setpos);
    eval 'sub XDR_INLINE {
        my($xdrs, $len) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_inline}))($xdrs, $len));
    }' unless defined(&XDR_INLINE);
    eval 'sub xdr_inline {
        my($xdrs, $len) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_inline}))($xdrs, $len));
    }' unless defined(&xdr_inline);
    eval 'sub XDR_DESTROY {
        my($xdrs) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_destroy}))($xdrs));
    }' unless defined(&XDR_DESTROY);
    eval 'sub xdr_destroy {
        my($xdrs) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_destroy}))($xdrs));
    }' unless defined(&xdr_destroy);
    eval 'sub XDR_CONTROL {
        my($xdrs, $req, $op) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_control}))($xdrs, $req, $op));
    }' unless defined(&XDR_CONTROL);
    eval 'sub xdr_control {
        my($xdrs, $req, $op) = @_;
	    eval q((*($xdrs)-> ($x_ops->{x_control}))($xdrs, $req, $op));
    }' unless defined(&xdr_control);
    if(defined(&__cplusplus)) {
    } else {
	if(defined(&__STDC__)) {
	} else {
	}
    }
    eval 'sub NULL_xdrproc_t () {(( &xdrproc_t)0);}' unless defined(&NULL_xdrproc_t);
    if(defined( &_LP64) || defined( &_I32LPx)) {
	eval 'sub xdr_rpcvers {
	    my($xdrs, $versp) = @_;
    	    eval q( &xdr_u_int($xdrs, $versp));
	}' unless defined(&xdr_rpcvers);
	eval 'sub xdr_rpcprog {
	    my($xdrs, $progp) = @_;
    	    eval q( &xdr_u_int($xdrs, $progp));
	}' unless defined(&xdr_rpcprog);
	eval 'sub xdr_rpcproc {
	    my($xdrs, $procp) = @_;
    	    eval q( &xdr_u_int($xdrs, $procp));
	}' unless defined(&xdr_rpcproc);
	eval 'sub xdr_rpcprot {
	    my($xdrs, $protp) = @_;
    	    eval q( &xdr_u_int($xdrs, $protp));
	}' unless defined(&xdr_rpcprot);
	eval 'sub xdr_rpcport {
	    my($xdrs, $portp) = @_;
    	    eval q( &xdr_u_int($xdrs, $portp));
	}' unless defined(&xdr_rpcport);
    } else {
	eval 'sub xdr_rpcvers {
	    my($xdrs, $versp) = @_;
    	    eval q( &xdr_u_long($xdrs, $versp));
	}' unless defined(&xdr_rpcvers);
	eval 'sub xdr_rpcprog {
	    my($xdrs, $progp) = @_;
    	    eval q( &xdr_u_long($xdrs, $progp));
	}' unless defined(&xdr_rpcprog);
	eval 'sub xdr_rpcproc {
	    my($xdrs, $procp) = @_;
    	    eval q( &xdr_u_long($xdrs, $procp));
	}' unless defined(&xdr_rpcproc);
	eval 'sub xdr_rpcprot {
	    my($xdrs, $protp) = @_;
    	    eval q( &xdr_u_long($xdrs, $protp));
	}' unless defined(&xdr_rpcprot);
	eval 'sub xdr_rpcport {
	    my($xdrs, $portp) = @_;
    	    eval q( &xdr_u_long($xdrs, $portp));
	}' unless defined(&xdr_rpcport);
    }
    eval 'sub IXDR_GET_INT32 {
        my($buf) = @_;
	    eval q((( &int32_t) &ntohl(( &uint32_t)*($buf)++)));
    }' unless defined(&IXDR_GET_INT32);
    eval 'sub IXDR_PUT_INT32 {
        my($buf, $v) = @_;
	    eval q((*($buf)++ = ( &int32_t) &htonl(( &uint32_t)$v)));
    }' unless defined(&IXDR_PUT_INT32);
    eval 'sub IXDR_GET_U_INT32 {
        my($buf) = @_;
	    eval q((( &uint32_t) &IXDR_GET_INT32($buf)));
    }' unless defined(&IXDR_GET_U_INT32);
    eval 'sub IXDR_PUT_U_INT32 {
        my($buf, $v) = @_;
	    eval q( &IXDR_PUT_INT32(($buf), (( &int32_t)($v))));
    }' unless defined(&IXDR_PUT_U_INT32);
    if(!defined( &_KERNEL)  && !defined( &_LP64)) {
	eval 'sub IXDR_GET_LONG {
	    my($buf) = @_;
    	    eval q(( &ntohl(*($buf)++)));
	}' unless defined(&IXDR_GET_LONG);
	eval 'sub IXDR_PUT_LONG {
	    my($buf, $v) = @_;
    	    eval q((*++ =  &htonl($v)));
	}' unless defined(&IXDR_PUT_LONG);
	eval 'sub IXDR_GET_U_LONG {
	    my($buf) = @_;
    	    eval q(( &IXDR_GET_LONG($buf)));
	}' unless defined(&IXDR_GET_U_LONG);
	eval 'sub IXDR_PUT_U_LONG {
	    my($buf, $v) = @_;
    	    eval q( &IXDR_PUT_LONG(, (($v))));
	}' unless defined(&IXDR_PUT_U_LONG);
	eval 'sub IXDR_GET_BOOL {
	    my($buf) = @_;
    	    eval q((( &bool_t) &IXDR_GET_LONG($buf)));
	}' unless defined(&IXDR_GET_BOOL);
	eval 'sub IXDR_GET_ENUM {
	    my($buf, $t) = @_;
    	    eval q((($t) &IXDR_GET_LONG($buf)));
	}' unless defined(&IXDR_GET_ENUM);
	eval 'sub IXDR_GET_SHORT {
	    my($buf) = @_;
    	    eval q(( &IXDR_GET_LONG($buf)));
	}' unless defined(&IXDR_GET_SHORT);
	eval 'sub IXDR_GET_U_SHORT {
	    my($buf) = @_;
    	    eval q((( &ushort_t) &IXDR_GET_LONG($buf)));
	}' unless defined(&IXDR_GET_U_SHORT);
	eval 'sub IXDR_PUT_BOOL {
	    my($buf, $v) = @_;
    	    eval q( &IXDR_PUT_LONG(, (($v))));
	}' unless defined(&IXDR_PUT_BOOL);
	eval 'sub IXDR_PUT_ENUM {
	    my($buf, $v) = @_;
    	    eval q( &IXDR_PUT_LONG(, (($v))));
	}' unless defined(&IXDR_PUT_ENUM);
	eval 'sub IXDR_PUT_SHORT {
	    my($buf, $v) = @_;
    	    eval q( &IXDR_PUT_LONG(, (($v))));
	}' unless defined(&IXDR_PUT_SHORT);
	eval 'sub IXDR_PUT_U_SHORT {
	    my($buf, $v) = @_;
    	    eval q( &IXDR_PUT_LONG(, (($v))));
	}' unless defined(&IXDR_PUT_U_SHORT);
    } else {
	eval 'sub IXDR_GET_BOOL {
	    my($buf) = @_;
    	    eval q((( &bool_t) &IXDR_GET_INT32($buf)));
	}' unless defined(&IXDR_GET_BOOL);
	eval 'sub IXDR_GET_ENUM {
	    my($buf, $t) = @_;
    	    eval q((($t) &IXDR_GET_INT32($buf)));
	}' unless defined(&IXDR_GET_ENUM);
	eval 'sub IXDR_GET_SHORT {
	    my($buf) = @_;
    	    eval q(( &IXDR_GET_INT32($buf)));
	}' unless defined(&IXDR_GET_SHORT);
	eval 'sub IXDR_GET_U_SHORT {
	    my($buf) = @_;
    	    eval q((( &ushort_t) &IXDR_GET_INT32($buf)));
	}' unless defined(&IXDR_GET_U_SHORT);
	eval 'sub IXDR_PUT_BOOL {
	    my($buf, $v) = @_;
    	    eval q( &IXDR_PUT_INT32(, (($v))));
	}' unless defined(&IXDR_PUT_BOOL);
	eval 'sub IXDR_PUT_ENUM {
	    my($buf, $v) = @_;
    	    eval q( &IXDR_PUT_INT32(, (($v))));
	}' unless defined(&IXDR_PUT_ENUM);
	eval 'sub IXDR_PUT_SHORT {
	    my($buf, $v) = @_;
    	    eval q( &IXDR_PUT_INT32(, (($v))));
	}' unless defined(&IXDR_PUT_SHORT);
	eval 'sub IXDR_PUT_U_SHORT {
	    my($buf, $v) = @_;
    	    eval q( &IXDR_PUT_INT32(, (($v))));
	}' unless defined(&IXDR_PUT_U_SHORT);
    }
    unless(defined(&_LITTLE_ENDIAN)) {
	eval 'sub IXDR_GET_HYPER {
	    my($buf, $v) = @_;
    	    eval q({ *(( &int32_t *)($v)) =  &ntohl(*( &uint32_t *)$buf++); *(( &int32_t *)(($v) +  &BYTES_PER_XDR_UNIT)) =  &ntohl(*( &uint32_t *)$buf++); });
	}' unless defined(&IXDR_GET_HYPER);
	eval 'sub IXDR_PUT_HYPER {
	    my($buf, $v) = @_;
    	    eval q({ *($buf)++ = ( &int32_t) &htonl(*( &uint32_t *) ($v)); *($buf)++ = ( &int32_t) &htonl(*( &uint32_t *)(($v) +  &BYTES_PER_XDR_UNIT)); });
	}' unless defined(&IXDR_PUT_HYPER);
    } else {
	eval 'sub IXDR_GET_HYPER {
	    my($buf, $v) = @_;
    	    eval q({ *(( &int32_t *)(($v) +  &BYTES_PER_XDR_UNIT)) =  &ntohl(*( &uint32_t *)$buf++); *(( &int32_t *)($v)) =  &ntohl(*( &uint32_t *)$buf++); });
	}' unless defined(&IXDR_GET_HYPER);
	eval 'sub IXDR_PUT_HYPER {
	    my($buf, $v) = @_;
    	    eval q({ *($buf)++ = ( &int32_t) &htonl(*( &uint32_t *)(($v) +  &BYTES_PER_XDR_UNIT)); *($buf)++ = ( &int32_t) &htonl(*( &uint32_t *)($v)); });
	}' unless defined(&IXDR_PUT_HYPER);
    }
    eval 'sub IXDR_GET_U_HYPER {
        my($buf, $v) = @_;
	    eval q( &IXDR_GET_HYPER($buf, $v));
    }' unless defined(&IXDR_GET_U_HYPER);
    eval 'sub IXDR_PUT_U_HYPER {
        my($buf, $v) = @_;
	    eval q( &IXDR_PUT_HYPER($buf, $v));
    }' unless defined(&IXDR_PUT_U_HYPER);
    if(defined(&__STDC__)) {
	if(defined( &_LP64) || ((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_NO_LONGLONG))) {
	}
	unless(defined(&_KERNEL)) {
	}
    } else {
	if(defined( &_LP64)) {
	}
	unless(defined(&_KERNEL)) {
	}
    }
    eval 'sub MAX_NETOBJ_SZ () {1024;}' unless defined(&MAX_NETOBJ_SZ);
    if(defined(&__STDC__)) {
    } else {
    }
    eval 'sub XDR_GET_BYTES_AVAIL () {1;}' unless defined(&XDR_GET_BYTES_AVAIL);
    if(defined(&_KERNEL)) {
	eval 'sub XDR_PEEK () {2;}' unless defined(&XDR_PEEK);
	eval 'sub XDR_SKIPBYTES () {3;}' unless defined(&XDR_SKIPBYTES);
    }
    unless(defined(&_KERNEL)) {
	if(defined(&__STDC__)) {
	} else {
	}
    } else {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
