require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYNCH_H)) {
    eval 'sub _SYNCH_H () {1;}' unless defined(&_SYNCH_H);
    unless(defined(&_ASM)) {
	require 'sys/machlock.ph';
	require 'sys/time_impl.ph';
	require 'sys/synch.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	if(defined(&__STDC__)) {
	} else {
	}
    }
    eval 'sub MUTEX_MAGIC () {0x4d58;}' unless defined(&MUTEX_MAGIC);
    eval 'sub SEMA_MAGIC () {0x534d;}' unless defined(&SEMA_MAGIC);
    eval 'sub COND_MAGIC () {0x4356;}' unless defined(&COND_MAGIC);
    eval 'sub RWL_MAGIC () {0x5257;}' unless defined(&RWL_MAGIC);
    eval 'sub DEFAULTMUTEX () {{{0, 0, 0, { &USYNC_THREAD},  &MUTEX_MAGIC}, {{{0, 0, 0, 0, 0, 0, 0, 0}}}, 0};}' unless defined(&DEFAULTMUTEX);
    eval 'sub SHAREDMUTEX () {{{0, 0, 0, { &USYNC_PROCESS},  &MUTEX_MAGIC}, {{{0, 0, 0, 0, 0, 0, 0, 0}}}, 0};}' unless defined(&SHAREDMUTEX);
    eval 'sub DEFAULTCV () {{{{0, 0, 0, 0},  &USYNC_THREAD,  &COND_MAGIC}, 0};}' unless defined(&DEFAULTCV);
    eval 'sub SHAREDCV () {{{{0, 0, 0, 0},  &USYNC_PROCESS,  &COND_MAGIC}, 0};}' unless defined(&SHAREDCV);
    eval 'sub DEFAULTSEMA () {{0,  &USYNC_THREAD,  &SEMA_MAGIC, {0, 0, 0}, {0, 0}};}' unless defined(&DEFAULTSEMA);
    eval 'sub SHAREDSEMA () {{0,  &USYNC_PROCESS,  &SEMA_MAGIC, {0, 0, 0}, {0, 0}};}' unless defined(&SHAREDSEMA);
    eval 'sub DEFAULTRWLOCK () {{0,  &USYNC_THREAD,  &RWL_MAGIC, {0, 0,  &USYNC_THREAD,  &MUTEX_MAGIC}, { 0, 0}, {0, 0,  &USYNC_THREAD,  &COND_MAGIC}, 0, {0, 0,  &USYNC_THREAD,  &COND_MAGIC}, 0};}' unless defined(&DEFAULTRWLOCK);
    eval 'sub SHAREDRWLOCK () {{0,  &USYNC_PROCESS,  &RWL_MAGIC, {0, 0,  &USYNC_PROCESS,  &MUTEX_MAGIC}, { 0, 0}, {0, 0,  &USYNC_PROCESS,  &COND_MAGIC}, 0, {0, 0,  &USYNC_PROCESS,  &COND_MAGIC}, 0};}' unless defined(&SHAREDRWLOCK);
    eval 'sub SEMA_HELD {
        my($x) = @_;
	    eval q( &_sema_held($x));
    }' unless defined(&SEMA_HELD);
    eval 'sub RW_READ_HELD {
        my($x) = @_;
	    eval q( &_rw_read_held($x));
    }' unless defined(&RW_READ_HELD);
    eval 'sub RW_WRITE_HELD {
        my($x) = @_;
	    eval q( &_rw_write_held($x));
    }' unless defined(&RW_WRITE_HELD);
    eval 'sub RW_LOCK_HELD {
        my($x) = @_;
	    eval q(( &RW_READ_HELD($x) ||  &RW_WRITE_HELD($x)));
    }' unless defined(&RW_LOCK_HELD);
    eval 'sub MUTEX_HELD {
        my($x) = @_;
	    eval q( &_mutex_held($x));
    }' unless defined(&MUTEX_HELD);
    unless(defined(&NO_LOCKS_HELD)) {
	eval 'sub NO_LOCKS_HELD () {1;}' unless defined(&NO_LOCKS_HELD);
    }
    unless(defined(&NO_COMPETING_THREADS)) {
	eval 'sub NO_COMPETING_THREADS () {1;}' unless defined(&NO_COMPETING_THREADS);
    }
    unless(defined(&_ASM)) {
	if(defined(&__STDC__)) {
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
