require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_AC97_H)) {
    eval 'sub _SYS_AC97_H () {1;}' unless defined(&_SYS_AC97_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub AC97_RESET_REGISTER () {0x;}' unless defined(&AC97_RESET_REGISTER);
	eval 'sub RR_DEDICATED_MIC () {0x1;}' unless defined(&RR_DEDICATED_MIC);
	eval 'sub RR_RESERVED () {0x2;}' unless defined(&RR_RESERVED);
	eval 'sub RR_BASS_TREBLE () {0x4;}' unless defined(&RR_BASS_TREBLE);
	eval 'sub RR_PSEUDO_STEREO () {0x8;}' unless defined(&RR_PSEUDO_STEREO);
	eval 'sub RR_HEADPHONE_SUPPORT () {0x10;}' unless defined(&RR_HEADPHONE_SUPPORT);
	eval 'sub RR_LOUDNESS_SUPPORT () {0x20;}' unless defined(&RR_LOUDNESS_SUPPORT);
	eval 'sub RR_18_BIT_DAC () {0x40;}' unless defined(&RR_18_BIT_DAC);
	eval 'sub RR_20_BIT_DAC () {0x80;}' unless defined(&RR_20_BIT_DAC);
	eval 'sub RR_18_BIT_ADC () {0x100;}' unless defined(&RR_18_BIT_ADC);
	eval 'sub RR_20_BIT_ADC () {0x200;}' unless defined(&RR_20_BIT_ADC);
	eval 'sub RR_3D_STEREO_ENHANCE_MASK () {0x7c00;}' unless defined(&RR_3D_STEREO_ENHANCE_MASK);
	eval 'sub AC97_MASTER_VOLUME_REGISTER () {0x2;}' unless defined(&AC97_MASTER_VOLUME_REGISTER);
	eval 'sub MVR_RIGHT_MASK () {0x1f;}' unless defined(&MVR_RIGHT_MASK);
	eval 'sub MVR_RIGHT_0dB_ATTEN () {0x;}' unless defined(&MVR_RIGHT_0dB_ATTEN);
	eval 'sub MVR_RIGHT_OPTIONAL_MASK () {0x3f;}' unless defined(&MVR_RIGHT_OPTIONAL_MASK);
	eval 'sub MVR_LEFT_MASK () {0x1f00;}' unless defined(&MVR_LEFT_MASK);
	eval 'sub MVR_LEFT_0dB_ATTEN () {0x;}' unless defined(&MVR_LEFT_0dB_ATTEN);
	eval 'sub MVR_LEFT_OPTIONAL_MASK () {0x3f00;}' unless defined(&MVR_LEFT_OPTIONAL_MASK);
	eval 'sub MVR_MUTE () {0x8000;}' unless defined(&MVR_MUTE);
	eval 'sub AC97_HEADPHONE_VOLUME_REGISTER () {0x4;}' unless defined(&AC97_HEADPHONE_VOLUME_REGISTER);
	eval 'sub HPVR_RIGHT_MASK () {0x1f;}' unless defined(&HPVR_RIGHT_MASK);
	eval 'sub HPVR_RIGHT_0dB_ATTEN () {0x;}' unless defined(&HPVR_RIGHT_0dB_ATTEN);
	eval 'sub HPVR_RIGHT_OPTIONAL_MASK () {0x3f;}' unless defined(&HPVR_RIGHT_OPTIONAL_MASK);
	eval 'sub HPVR_LEFT_MASK () {0x1f00;}' unless defined(&HPVR_LEFT_MASK);
	eval 'sub HPVR_LEFT_0dB_ATTEN () {0x;}' unless defined(&HPVR_LEFT_0dB_ATTEN);
	eval 'sub HPVR_LEFT_OPTIONAL_MASK () {0x3f00;}' unless defined(&HPVR_LEFT_OPTIONAL_MASK);
	eval 'sub HPVR_MUTE () {0x8000;}' unless defined(&HPVR_MUTE);
	eval 'sub AC97_MONO_MASTER_VOLUME_REGSITER () {0x6;}' unless defined(&AC97_MONO_MASTER_VOLUME_REGSITER);
	eval 'sub MMVR_MASK () {0x1f;}' unless defined(&MMVR_MASK);
	eval 'sub MMVR_0dB_ATTEN () {0x;}' unless defined(&MMVR_0dB_ATTEN);
	eval 'sub MMVR_OPTIONAL_MASK () {0x3f;}' unless defined(&MMVR_OPTIONAL_MASK);
	eval 'sub MMVR_MUTE () {0x8000;}' unless defined(&MMVR_MUTE);
	eval 'sub AC97_MASTER_TONE_CONTROL_REGISTER () {0x8;}' unless defined(&AC97_MASTER_TONE_CONTROL_REGISTER);
	eval 'sub MTCR_TREBLE_MASK () {0xe;}' unless defined(&MTCR_TREBLE_MASK);
	eval 'sub MTCR_TREBLE_OPTIONAL_MASK () {0xf;}' unless defined(&MTCR_TREBLE_OPTIONAL_MASK);
	eval 'sub MTCR_TREBLE_BYPASS () {0xf;}' unless defined(&MTCR_TREBLE_BYPASS);
	eval 'sub MTCR_BASS_MASK () {0xe00;}' unless defined(&MTCR_BASS_MASK);
	eval 'sub MTCR_BASS_OPTIONAL_MASK () {0xf00;}' unless defined(&MTCR_BASS_OPTIONAL_MASK);
	eval 'sub MTCR_BASS_BYPASS () {0xf00;}' unless defined(&MTCR_BASS_BYPASS);
	eval 'sub AC97_PC_BEEP_REGISTER () {0xa;}' unless defined(&AC97_PC_BEEP_REGISTER);
	eval 'sub PCBR_VOLUME_MASK () {0x1e;}' unless defined(&PCBR_VOLUME_MASK);
	eval 'sub PCBR_0dB_ATTEN () {0x;}' unless defined(&PCBR_0dB_ATTEN);
	eval 'sub PCBR_MUTE () {0x8000;}' unless defined(&PCBR_MUTE);
	eval 'sub AC97_PHONE_VOLUME_REGISTER () {0xc;}' unless defined(&AC97_PHONE_VOLUME_REGISTER);
	eval 'sub PVR_GAIN_MASK () {0x1f;}' unless defined(&PVR_GAIN_MASK);
	eval 'sub PVR_0dB_GAIN () {0x10;}' unless defined(&PVR_0dB_GAIN);
	eval 'sub PVR_MAX_ATTEN () {0x1f;}' unless defined(&PVR_MAX_ATTEN);
	eval 'sub PVR_MUTE () {0x8000;}' unless defined(&PVR_MUTE);
	eval 'sub AC97_MIC_VOLUME_REGISTER () {0xe;}' unless defined(&AC97_MIC_VOLUME_REGISTER);
	eval 'sub MICVR_GAIN_MASK () {0x1f;}' unless defined(&MICVR_GAIN_MASK);
	eval 'sub MICVR_0dB_GAIN () {0x8;}' unless defined(&MICVR_0dB_GAIN);
	eval 'sub MICVR_MAX_ATTEN () {0x1f;}' unless defined(&MICVR_MAX_ATTEN);
	eval 'sub MICVR_20dB_BOOST () {0x40;}' unless defined(&MICVR_20dB_BOOST);
	eval 'sub MICVR_20dB_NOBOOST () {0x;}' unless defined(&MICVR_20dB_NOBOOST);
	eval 'sub MICVR_MUTE () {0x8000;}' unless defined(&MICVR_MUTE);
	eval 'sub AC97_LINE_IN_VOLUME_REGISTER () {0x10;}' unless defined(&AC97_LINE_IN_VOLUME_REGISTER);
	eval 'sub LIVR_RIGHT_GAIN_MASK () {0x1f;}' unless defined(&LIVR_RIGHT_GAIN_MASK);
	eval 'sub LIVR_RIGHT_0dB_GAIN () {0x10;}' unless defined(&LIVR_RIGHT_0dB_GAIN);
	eval 'sub LIVR_RIGHT_MAX_ATTEN () {0x1f;}' unless defined(&LIVR_RIGHT_MAX_ATTEN);
	eval 'sub LIVR_LEFT_GAIN_MASK () {0x1f00;}' unless defined(&LIVR_LEFT_GAIN_MASK);
	eval 'sub LIVR_LEFT_0dB_GAIN () {0x1000;}' unless defined(&LIVR_LEFT_0dB_GAIN);
	eval 'sub LIVR_LEFT_MAX_ATTEN () {0x1f00;}' unless defined(&LIVR_LEFT_MAX_ATTEN);
	eval 'sub LIVR_MUTE () {0x8000;}' unless defined(&LIVR_MUTE);
	eval 'sub AC97_CD_VOLUME_REGISTER () {0x12;}' unless defined(&AC97_CD_VOLUME_REGISTER);
	eval 'sub CDVR_RIGHT_GAIN_MASK () {0x1f;}' unless defined(&CDVR_RIGHT_GAIN_MASK);
	eval 'sub CDVR_RIGHT_0dB_GAIN () {0x10;}' unless defined(&CDVR_RIGHT_0dB_GAIN);
	eval 'sub CDVR_RIGHT_MAX_ATTEN () {0x1f;}' unless defined(&CDVR_RIGHT_MAX_ATTEN);
	eval 'sub CDVR_LEFT_GAIN_MASK () {0x1f00;}' unless defined(&CDVR_LEFT_GAIN_MASK);
	eval 'sub CDVR_LEFT_0dB_GAIN () {0x1000;}' unless defined(&CDVR_LEFT_0dB_GAIN);
	eval 'sub CDVR_LEFT_MAX_ATTEN () {0x1f00;}' unless defined(&CDVR_LEFT_MAX_ATTEN);
	eval 'sub CDVR_MUTE () {0x8000;}' unless defined(&CDVR_MUTE);
	eval 'sub AC97_VIDEO_VOLUME_REGISTER () {0x14;}' unless defined(&AC97_VIDEO_VOLUME_REGISTER);
	eval 'sub VIDVR_RIGHT_GAIN_MASK () {0x1f;}' unless defined(&VIDVR_RIGHT_GAIN_MASK);
	eval 'sub VIDVR_RIGHT_0dB_GAIN () {0x10;}' unless defined(&VIDVR_RIGHT_0dB_GAIN);
	eval 'sub VIDVR_RIGHT_MAX_ATTEN () {0x1f;}' unless defined(&VIDVR_RIGHT_MAX_ATTEN);
	eval 'sub VIDVR_LEFT_GAIN_MASK () {0x1f00;}' unless defined(&VIDVR_LEFT_GAIN_MASK);
	eval 'sub VIDVR_LEFT_0dB_GAIN () {0x1000;}' unless defined(&VIDVR_LEFT_0dB_GAIN);
	eval 'sub VIDVR_LEFT_MAX_ATTEN () {0x1f00;}' unless defined(&VIDVR_LEFT_MAX_ATTEN);
	eval 'sub VIDVR_MUTE () {0x8000;}' unless defined(&VIDVR_MUTE);
	eval 'sub AC97_AUX_VOLUME_REGISTER () {0x16;}' unless defined(&AC97_AUX_VOLUME_REGISTER);
	eval 'sub AUXVR_RIGHT_GAIN_MASK () {0x1f;}' unless defined(&AUXVR_RIGHT_GAIN_MASK);
	eval 'sub AUXVR_RIGHT_0dB_GAIN () {0x10;}' unless defined(&AUXVR_RIGHT_0dB_GAIN);
	eval 'sub AUXVR_RIGHT_MAX_ATTEN () {0x1f;}' unless defined(&AUXVR_RIGHT_MAX_ATTEN);
	eval 'sub AUXVR_LEFT_GAIN_MASK () {0x1f00;}' unless defined(&AUXVR_LEFT_GAIN_MASK);
	eval 'sub AUXVR_LEFT_0dB_GAIN () {0x1000;}' unless defined(&AUXVR_LEFT_0dB_GAIN);
	eval 'sub AUXVR_LEFT_MAX_ATTEN () {0x1f00;}' unless defined(&AUXVR_LEFT_MAX_ATTEN);
	eval 'sub AUXVR_MUTE () {0x8000;}' unless defined(&AUXVR_MUTE);
	eval 'sub AC97_PCM_OUT_VOLUME_REGISTER () {0x18;}' unless defined(&AC97_PCM_OUT_VOLUME_REGISTER);
	eval 'sub PCMOVR_RIGHT_GAIN_MASK () {0x1f;}' unless defined(&PCMOVR_RIGHT_GAIN_MASK);
	eval 'sub PCMOVR_RIGHT_0dB_GAIN () {0x10;}' unless defined(&PCMOVR_RIGHT_0dB_GAIN);
	eval 'sub PCMOVR_RIGHT_MAX_ATTEN () {0x1f;}' unless defined(&PCMOVR_RIGHT_MAX_ATTEN);
	eval 'sub PCMOVR_LEFT_GAIN_MASK () {0x1f00;}' unless defined(&PCMOVR_LEFT_GAIN_MASK);
	eval 'sub PCMOVR_LEFT_0dB_GAIN () {0x1000;}' unless defined(&PCMOVR_LEFT_0dB_GAIN);
	eval 'sub PCMOVR_LEFT_MAX_ATTEN () {0x1f00;}' unless defined(&PCMOVR_LEFT_MAX_ATTEN);
	eval 'sub PCMOVR_MUTE () {0x8000;}' unless defined(&PCMOVR_MUTE);
	eval 'sub AC97_RECORD_SELECT_CTRL_REGISTER () {0x1a;}' unless defined(&AC97_RECORD_SELECT_CTRL_REGISTER);
	eval 'sub RSCR_R_MIC () {0x;}' unless defined(&RSCR_R_MIC);
	eval 'sub RSCR_R_CD () {0x1;}' unless defined(&RSCR_R_CD);
	eval 'sub RSCR_R_VIDEO () {0x2;}' unless defined(&RSCR_R_VIDEO);
	eval 'sub RSCR_R_AUX () {0x3;}' unless defined(&RSCR_R_AUX);
	eval 'sub RSCR_R_LINE_IN () {0x4;}' unless defined(&RSCR_R_LINE_IN);
	eval 'sub RSCR_R_STEREO_MIX () {0x5;}' unless defined(&RSCR_R_STEREO_MIX);
	eval 'sub RSCR_R_MONO_MIX () {0x6;}' unless defined(&RSCR_R_MONO_MIX);
	eval 'sub RSCR_R_PHONE () {0x7;}' unless defined(&RSCR_R_PHONE);
	eval 'sub RSCR_L_MIC () {0x;}' unless defined(&RSCR_L_MIC);
	eval 'sub RSCR_L_CD () {0x100;}' unless defined(&RSCR_L_CD);
	eval 'sub RSCR_L_VIDEO () {0x200;}' unless defined(&RSCR_L_VIDEO);
	eval 'sub RSCR_L_AUX () {0x300;}' unless defined(&RSCR_L_AUX);
	eval 'sub RSCR_L_LINE_IN () {0x400;}' unless defined(&RSCR_L_LINE_IN);
	eval 'sub RSCR_L_STEREO_MIX () {0x500;}' unless defined(&RSCR_L_STEREO_MIX);
	eval 'sub RSCR_L_MONO_MIX () {0x600;}' unless defined(&RSCR_L_MONO_MIX);
	eval 'sub RSCR_L_PHONE () {0x700;}' unless defined(&RSCR_L_PHONE);
	eval 'sub AC97_RECORD_GAIN_REGISTER () {0x1c;}' unless defined(&AC97_RECORD_GAIN_REGISTER);
	eval 'sub RGR_RIGHT_MASK () {0xf;}' unless defined(&RGR_RIGHT_MASK);
	eval 'sub RGR_RIGHT_0db_GAIN () {0x;}' unless defined(&RGR_RIGHT_0db_GAIN);
	eval 'sub RGR_RIGHT_MAX_GAIN () {0xf;}' unless defined(&RGR_RIGHT_MAX_GAIN);
	eval 'sub RGR_LEFT_MASK () {0xf00;}' unless defined(&RGR_LEFT_MASK);
	eval 'sub RGR_LEFT_0db_GAIN () {0x;}' unless defined(&RGR_LEFT_0db_GAIN);
	eval 'sub RGR_LEFT_MAX_GAIN () {0xf00;}' unless defined(&RGR_LEFT_MAX_GAIN);
	eval 'sub RGR_MUTE () {0x8000;}' unless defined(&RGR_MUTE);
	eval 'sub AC97_RECORD_GAIN_MIC_REGISTER () {0x1e;}' unless defined(&AC97_RECORD_GAIN_MIC_REGISTER);
	eval 'sub RGMR_MASK () {0xf;}' unless defined(&RGMR_MASK);
	eval 'sub RGMR_MUTE () {0x8000;}' unless defined(&RGMR_MUTE);
	eval 'sub RGMR_MASK () {0xf;}' unless defined(&RGMR_MASK);
	eval 'sub RGMR_0db_GAIN () {0x;}' unless defined(&RGMR_0db_GAIN);
	eval 'sub RGMR_MAX_GAIN () {0xf;}' unless defined(&RGMR_MAX_GAIN);
	eval 'sub AC97_GENERAL_PURPOSE_REGISTER () {0x20;}' unless defined(&AC97_GENERAL_PURPOSE_REGISTER);
	eval 'sub GPR_LPBK () {0x80;}' unless defined(&GPR_LPBK);
	eval 'sub GPR_MS_MIC1 () {0x;}' unless defined(&GPR_MS_MIC1);
	eval 'sub GPR_MS_MIC2 () {0x100;}' unless defined(&GPR_MS_MIC2);
	eval 'sub GPR_MONO_MIX_IN () {0x;}' unless defined(&GPR_MONO_MIX_IN);
	eval 'sub GPR_MONO_MIC_IN () {0x200;}' unless defined(&GPR_MONO_MIC_IN);
	eval 'sub GPR_BASS_BOOST () {0x1000;}' unless defined(&GPR_BASS_BOOST);
	eval 'sub GPR_3D_STEREO_ENHANCE () {0x2000;}' unless defined(&GPR_3D_STEREO_ENHANCE);
	eval 'sub GPR_ST () {0x4000;}' unless defined(&GPR_ST);
	eval 'sub GPR_POP_PRE_3D () {0x;}' unless defined(&GPR_POP_PRE_3D);
	eval 'sub GPR_POP_POST_3D () {0x8000;}' unless defined(&GPR_POP_POST_3D);
	eval 'sub AC97_THREE_D_CONTROL_REGISTER () {0x22;}' unless defined(&AC97_THREE_D_CONTROL_REGISTER);
	eval 'sub TDCR_DEPTH_MASK () {0xf;}' unless defined(&TDCR_DEPTH_MASK);
	eval 'sub TDCR_CENTER_MASK () {0xf00;}' unless defined(&TDCR_CENTER_MASK);
	eval 'sub TDCR_NULL () {0x;}' unless defined(&TDCR_NULL);
	eval 'sub AC97_POWERDOWN_CTRL_STAT_REGISTER () {0x26;}' unless defined(&AC97_POWERDOWN_CTRL_STAT_REGISTER);
	eval 'sub PCSR_ADC () {0x1;}' unless defined(&PCSR_ADC);
	eval 'sub PCSR_DAC () {0x2;}' unless defined(&PCSR_DAC);
	eval 'sub PCSR_ANL () {0x4;}' unless defined(&PCSR_ANL);
	eval 'sub PCSR_REF () {0x8;}' unless defined(&PCSR_REF);
	eval 'sub PCSR_POWERD_UP () {( &PCSR_ADC| &PCSR_DAC|  &PCSR_ANL| &PCSR_REF);}' unless defined(&PCSR_POWERD_UP);
	eval 'sub PCSR_PR0 () {0x100;}' unless defined(&PCSR_PR0);
	eval 'sub PCSR_PR1 () {0x200;}' unless defined(&PCSR_PR1);
	eval 'sub PCSR_PR2 () {0x400;}' unless defined(&PCSR_PR2);
	eval 'sub PCSR_PR3 () {0x800;}' unless defined(&PCSR_PR3);
	eval 'sub PCSR_PR4 () {0x1000;}' unless defined(&PCSR_PR4);
	eval 'sub PCSR_PR5 () {0x2000;}' unless defined(&PCSR_PR5);
	eval 'sub PCSR_PR6 () {0x4000;}' unless defined(&PCSR_PR6);
	eval 'sub PCSR_EAPD () {0x8000;}' unless defined(&PCSR_EAPD);
	eval 'sub AC97_EXTENDED_AUDIO_REGISTER () {0x28;}' unless defined(&AC97_EXTENDED_AUDIO_REGISTER);
	eval 'sub EAR_VRA () {0x1;}' unless defined(&EAR_VRA);
	eval 'sub EAR_DRA () {0x2;}' unless defined(&EAR_DRA);
	eval 'sub EAR_VRM () {0x8;}' unless defined(&EAR_VRM);
	eval 'sub EAR_CDAC () {0x40;}' unless defined(&EAR_CDAC);
	eval 'sub EAR_SDAC () {0x80;}' unless defined(&EAR_SDAC);
	eval 'sub EAR_LDAC () {0x100;}' unless defined(&EAR_LDAC);
	eval 'sub EAR_AMAP () {0x200;}' unless defined(&EAR_AMAP);
	eval 'sub EAR_PRIMARY_CODEC () {0x;}' unless defined(&EAR_PRIMARY_CODEC);
	eval 'sub EAR_SECONDARY_01_CODEC () {0x4000;}' unless defined(&EAR_SECONDARY_01_CODEC);
	eval 'sub EAR_SECONDARY_10_CODEC () {0x8000;}' unless defined(&EAR_SECONDARY_10_CODEC);
	eval 'sub EAR_SECONDARY_11_CODEC () {0xc000;}' unless defined(&EAR_SECONDARY_11_CODEC);
	eval 'sub AC97_EXTENDED_AUDIO_STAT_CTRL_REGISTER () {0x2a;}' unless defined(&AC97_EXTENDED_AUDIO_STAT_CTRL_REGISTER);
	eval 'sub EASCR_VRA () {0x1;}' unless defined(&EASCR_VRA);
	eval 'sub EASCR_DRA () {0x2;}' unless defined(&EASCR_DRA);
	eval 'sub EASCR_VRM () {0x8;}' unless defined(&EASCR_VRM);
	eval 'sub EASCR_CDAC () {0x40;}' unless defined(&EASCR_CDAC);
	eval 'sub EASCR_SDAC () {0x80;}' unless defined(&EASCR_SDAC);
	eval 'sub EASCR_LDAC () {0x100;}' unless defined(&EASCR_LDAC);
	eval 'sub EASCR_MADC () {0x200;}' unless defined(&EASCR_MADC);
	eval 'sub EASCR_PRI () {0x800;}' unless defined(&EASCR_PRI);
	eval 'sub EASCR_PRJ () {0x1000;}' unless defined(&EASCR_PRJ);
	eval 'sub EASCR_PRK () {0x2000;}' unless defined(&EASCR_PRK);
	eval 'sub EASCR_PRL () {0x4000;}' unless defined(&EASCR_PRL);
	eval 'sub AC97_EXTENDED_FRONT_DAC_RATE_REGISTER () {0x2c;}' unless defined(&AC97_EXTENDED_FRONT_DAC_RATE_REGISTER);
	eval 'sub AC97_SAMPLE_RATE_48000 () {0xbb80;}' unless defined(&AC97_SAMPLE_RATE_48000);
	eval 'sub AC97_EXTENDED_SURROUND_DAC_RATE_REGISTER () {0x2e;}' unless defined(&AC97_EXTENDED_SURROUND_DAC_RATE_REGISTER);
	eval 'sub AC97_EXTENDED_LFE_DAC_RATE_REGISTER () {0x30;}' unless defined(&AC97_EXTENDED_LFE_DAC_RATE_REGISTER);
	eval 'sub AC97_EXTENDED_LR_DAC_RATE_REGISTER () {0x32;}' unless defined(&AC97_EXTENDED_LR_DAC_RATE_REGISTER);
	eval 'sub AC97_EXTENDED_MIC_ADC_RATE_REGISTER () {0x34;}' unless defined(&AC97_EXTENDED_MIC_ADC_RATE_REGISTER);
	eval 'sub AC97_EXTENDED_C_LFE_VOLUME_REGISTER () {0x36;}' unless defined(&AC97_EXTENDED_C_LFE_VOLUME_REGISTER);
	eval 'sub EXLFEVR_CENTER_MASK () {0x1f;}' unless defined(&EXLFEVR_CENTER_MASK);
	eval 'sub EXLFEVR_CENTER_OPTIONAL_MASK () {0x3f;}' unless defined(&EXLFEVR_CENTER_OPTIONAL_MASK);
	eval 'sub EXLFEVR_CENTER_MTUE () {0x80;}' unless defined(&EXLFEVR_CENTER_MTUE);
	eval 'sub EXLFEVR_LFE_MASK () {0x1f00;}' unless defined(&EXLFEVR_LFE_MASK);
	eval 'sub EXLFEVR_LFE_OPTIONAL_MASK () {0x3f00;}' unless defined(&EXLFEVR_LFE_OPTIONAL_MASK);
	eval 'sub EXLFEVR_LFE_MUTE () {0x8000;}' unless defined(&EXLFEVR_LFE_MUTE);
	eval 'sub AC97_EXTENDED_LRS_VOLUME_REGISTER () {0x38;}' unless defined(&AC97_EXTENDED_LRS_VOLUME_REGISTER);
	eval 'sub EXLFEVR_RIGHT_MASK () {0x1f;}' unless defined(&EXLFEVR_RIGHT_MASK);
	eval 'sub EXLFEVR_RIGHT_OPTIONAL_MASK () {0x3f;}' unless defined(&EXLFEVR_RIGHT_OPTIONAL_MASK);
	eval 'sub EXLFEVR_RIGHT_MTUE () {0x80;}' unless defined(&EXLFEVR_RIGHT_MTUE);
	eval 'sub EXLFEVR_LEFT_MASK () {0x1f00;}' unless defined(&EXLFEVR_LEFT_MASK);
	eval 'sub EXLFEVR_LEFT_OPTIONAL_MASK () {0x3f00;}' unless defined(&EXLFEVR_LEFT_OPTIONAL_MASK);
	eval 'sub EXLFEVR_LEFT_MUTE () {0x8000;}' unless defined(&EXLFEVR_LEFT_MUTE);
	eval 'sub AC97_EXTENDED_MODEM_ID_REGISTER () {0x3c;}' unless defined(&AC97_EXTENDED_MODEM_ID_REGISTER);
	eval 'sub EMIDR_LINE1 () {0x1;}' unless defined(&EMIDR_LINE1);
	eval 'sub EMIDR_LINE2 () {0x2;}' unless defined(&EMIDR_LINE2);
	eval 'sub EMIDR_HSET () {0x4;}' unless defined(&EMIDR_HSET);
	eval 'sub EMIDR_CID1 () {0x8;}' unless defined(&EMIDR_CID1);
	eval 'sub EMIDR_CID2 () {0x10;}' unless defined(&EMIDR_CID2);
	eval 'sub EMIDR_PRIMARY_CODEC () {0x;}' unless defined(&EMIDR_PRIMARY_CODEC);
	eval 'sub EMIDR_SECONDARY_01_CODEC () {0x4000;}' unless defined(&EMIDR_SECONDARY_01_CODEC);
	eval 'sub EMIDR_SECONDARY_10_CODEC () {0x8000;}' unless defined(&EMIDR_SECONDARY_10_CODEC);
	eval 'sub EMIDR_SECONDARY_11_CODEC () {0xc000;}' unless defined(&EMIDR_SECONDARY_11_CODEC);
	eval 'sub AC97_EXTENDED_MODE_STAT_CTRL_REGISTER () {0x3e;}' unless defined(&AC97_EXTENDED_MODE_STAT_CTRL_REGISTER);
	eval 'sub EMSCR_BPIO () {0x1;}' unless defined(&EMSCR_BPIO);
	eval 'sub EMSCR_MREF () {0x2;}' unless defined(&EMSCR_MREF);
	eval 'sub EMSCR_ADC1 () {0x4;}' unless defined(&EMSCR_ADC1);
	eval 'sub EMSCR_DAC1 () {0x8;}' unless defined(&EMSCR_DAC1);
	eval 'sub EMSCR_ADC2 () {0x10;}' unless defined(&EMSCR_ADC2);
	eval 'sub EMSCR_DAC2 () {0x20;}' unless defined(&EMSCR_DAC2);
	eval 'sub EMSCR_HADC () {0x40;}' unless defined(&EMSCR_HADC);
	eval 'sub EMSCR_HDAC () {0x80;}' unless defined(&EMSCR_HDAC);
	eval 'sub EMSCR_PRA () {0x100;}' unless defined(&EMSCR_PRA);
	eval 'sub EMSCR_PRB () {0x200;}' unless defined(&EMSCR_PRB);
	eval 'sub EMSCR_PRC () {0x400;}' unless defined(&EMSCR_PRC);
	eval 'sub EMSCR_PRD () {0x800;}' unless defined(&EMSCR_PRD);
	eval 'sub EMSCR_PRE () {0x1000;}' unless defined(&EMSCR_PRE);
	eval 'sub EMSCR_PRF () {0x2000;}' unless defined(&EMSCR_PRF);
	eval 'sub EMSCR_PRG () {0x4000;}' unless defined(&EMSCR_PRG);
	eval 'sub EMSCR_PRH () {0x8000;}' unless defined(&EMSCR_PRH);
	eval 'sub AC97_EXTENDED_MODEM_LINE1_RATE_REGISTER () {0x40;}' unless defined(&AC97_EXTENDED_MODEM_LINE1_RATE_REGISTER);
	eval 'sub AC97_EXTENDED_MODEM_LINE2_RATE_REGISTER () {0x42;}' unless defined(&AC97_EXTENDED_MODEM_LINE2_RATE_REGISTER);
	eval 'sub AC97_EXTENDED_MODEM_HANDSET_RATE_REGISTER () {0x44;}' unless defined(&AC97_EXTENDED_MODEM_HANDSET_RATE_REGISTER);
	eval 'sub AC97_EXTENDED_MODEM_LINE1_LEVEL_REGISTER () {0x46;}' unless defined(&AC97_EXTENDED_MODEM_LINE1_LEVEL_REGISTER);
	eval 'sub EML1LR_ADC_LEVEL_MASK () {0xf;}' unless defined(&EML1LR_ADC_LEVEL_MASK);
	eval 'sub EML1LR_ADC_LEVEL_MUTE () {0x80;}' unless defined(&EML1LR_ADC_LEVEL_MUTE);
	eval 'sub EML1LR_DAC_LEVEL_MASK () {0xf00;}' unless defined(&EML1LR_DAC_LEVEL_MASK);
	eval 'sub EML1LR_DAC_LEVEL_MUTE () {0x8000;}' unless defined(&EML1LR_DAC_LEVEL_MUTE);
	eval 'sub AC97_EXTENDED_MODEM_LINE2_LEVEL_REGISTER () {0x48;}' unless defined(&AC97_EXTENDED_MODEM_LINE2_LEVEL_REGISTER);
	eval 'sub EML2LR_ADC_LEVEL_MASK () {0xf;}' unless defined(&EML2LR_ADC_LEVEL_MASK);
	eval 'sub EML2LR_ADC_LEVEL_MUTE () {0x80;}' unless defined(&EML2LR_ADC_LEVEL_MUTE);
	eval 'sub EML2LR_DAC_LEVEL_MASK () {0xf00;}' unless defined(&EML2LR_DAC_LEVEL_MASK);
	eval 'sub EML2LR_DAC_LEVEL_MUTE () {0x8000;}' unless defined(&EML2LR_DAC_LEVEL_MUTE);
	eval 'sub AC97_EXTENDED_MODEM_HANDSET_LEVEL_REGISTER () {0x4a;}' unless defined(&AC97_EXTENDED_MODEM_HANDSET_LEVEL_REGISTER);
	eval 'sub EMHLR_ADC_LEVEL_MASK () {0xf;}' unless defined(&EMHLR_ADC_LEVEL_MASK);
	eval 'sub EMHLR_ADC_LEVEL_MUTE () {0x80;}' unless defined(&EMHLR_ADC_LEVEL_MUTE);
	eval 'sub EMHLR_DAC_LEVEL_MASK () {0xf00;}' unless defined(&EMHLR_DAC_LEVEL_MASK);
	eval 'sub EMHLR_DAC_LEVEL_MUTE () {0x8000;}' unless defined(&EMHLR_DAC_LEVEL_MUTE);
	eval 'sub AC97_EXTENDED_MODEM_GPIO_PIN_REGISTER () {0x4c;}' unless defined(&AC97_EXTENDED_MODEM_GPIO_PIN_REGISTER);
	eval 'sub AC97_EXTENDED_MODEM_GPIO_POLARITY_REGISTER () {0x4e;}' unless defined(&AC97_EXTENDED_MODEM_GPIO_POLARITY_REGISTER);
	eval 'sub AC97_EXTENDED_MODEM_GPIO_STICKY_REGISTER () {0x50;}' unless defined(&AC97_EXTENDED_MODEM_GPIO_STICKY_REGISTER);
	eval 'sub AC97_EXTENDED_MODEM_GPIO_WAKEUP_REGISTER () {0x52;}' unless defined(&AC97_EXTENDED_MODEM_GPIO_WAKEUP_REGISTER);
	eval 'sub AC97_EXTENDED_MODEM_GPIO_STATUS_REGISTER () {0x54;}' unless defined(&AC97_EXTENDED_MODEM_GPIO_STATUS_REGISTER);
	eval 'sub AC97_EXTENDED_MODEM_AFE_STAT_CTRL_REGISTER () {0x56;}' unless defined(&AC97_EXTENDED_MODEM_AFE_STAT_CTRL_REGISTER);
	eval 'sub EMAFESCR_L1B0 () {0x1;}' unless defined(&EMAFESCR_L1B0);
	eval 'sub EMAFESCR_L1B1 () {0x2;}' unless defined(&EMAFESCR_L1B1);
	eval 'sub EMAFESCR_L1B2 () {0x4;}' unless defined(&EMAFESCR_L1B2);
	eval 'sub EMAFESCR_L2B0 () {0x10;}' unless defined(&EMAFESCR_L2B0);
	eval 'sub EMAFESCR_L2B1 () {0x20;}' unless defined(&EMAFESCR_L2B1);
	eval 'sub EMAFESCR_L2B2 () {0x40;}' unless defined(&EMAFESCR_L2B2);
	eval 'sub EMAFESCR_HSB0 () {0x100;}' unless defined(&EMAFESCR_HSB0);
	eval 'sub EMAFESCR_HSB1 () {0x200;}' unless defined(&EMAFESCR_HSB1);
	eval 'sub EMAFESCR_HSB2 () {0x400;}' unless defined(&EMAFESCR_HSB2);
	eval 'sub EMAFESCR_MLINK_ON () {0x;}' unless defined(&EMAFESCR_MLINK_ON);
	eval 'sub EMAFESCR_MLINK_OFF () {0x1000;}' unless defined(&EMAFESCR_MLINK_OFF);
	eval 'sub EMAFESCR_CIDR () {0x2000;}' unless defined(&EMAFESCR_CIDR);
	eval 'sub EMAFESCR_CID1 () {0x4000;}' unless defined(&EMAFESCR_CID1);
	eval 'sub EMAFESCR_CID2 () {0x8000;}' unless defined(&EMAFESCR_CID2);
	eval 'sub AC97_VENDOR_REGISTER_01 () {0x5a;}' unless defined(&AC97_VENDOR_REGISTER_01);
	eval 'sub AC97_VENDOR_REGISTER_02 () {0x5c;}' unless defined(&AC97_VENDOR_REGISTER_02);
	eval 'sub AC97_VENDOR_REGISTER_03 () {0x5e;}' unless defined(&AC97_VENDOR_REGISTER_03);
	eval 'sub AC97_VENDOR_REGISTER_04 () {0x60;}' unless defined(&AC97_VENDOR_REGISTER_04);
	eval 'sub AC97_VENDOR_REGISTER_05 () {0x62;}' unless defined(&AC97_VENDOR_REGISTER_05);
	eval 'sub AC97_VENDOR_REGISTER_06 () {0x64;}' unless defined(&AC97_VENDOR_REGISTER_06);
	eval 'sub AC97_VENDOR_REGISTER_07 () {0x66;}' unless defined(&AC97_VENDOR_REGISTER_07);
	eval 'sub AC97_VENDOR_REGISTER_08 () {0x68;}' unless defined(&AC97_VENDOR_REGISTER_08);
	eval 'sub AC97_VENDOR_REGISTER_09 () {0x6a;}' unless defined(&AC97_VENDOR_REGISTER_09);
	eval 'sub AC97_VENDOR_REGISTER_10 () {0x6c;}' unless defined(&AC97_VENDOR_REGISTER_10);
	eval 'sub AC97_VENDOR_REGISTER_11 () {0x6e;}' unless defined(&AC97_VENDOR_REGISTER_11);
	eval 'sub AC97_VENDOR_REGISTER_12 () {0x70;}' unless defined(&AC97_VENDOR_REGISTER_12);
	eval 'sub AC97_VENDOR_REGISTER_13 () {0x72;}' unless defined(&AC97_VENDOR_REGISTER_13);
	eval 'sub AC97_VENDOR_REGISTER_14 () {0x74;}' unless defined(&AC97_VENDOR_REGISTER_14);
	eval 'sub AC97_VENDOR_REGISTER_15 () {0x76;}' unless defined(&AC97_VENDOR_REGISTER_15);
	eval 'sub AC97_VENDOR_REGISTER_16 () {0x78;}' unless defined(&AC97_VENDOR_REGISTER_16);
	eval 'sub AC97_VENDOR_REGISTER_17 () {0x7a;}' unless defined(&AC97_VENDOR_REGISTER_17);
	eval 'sub AC97_VENDOR_ID1_REGISTER () {0x7c;}' unless defined(&AC97_VENDOR_ID1_REGISTER);
	eval 'sub VID1R_CHAR2_MASK () {0xff;}' unless defined(&VID1R_CHAR2_MASK);
	eval 'sub VID1R_CHAR1_MASK () {0xff00;}' unless defined(&VID1R_CHAR1_MASK);
	eval 'sub AC97_VENDOR_ID2_REGISTER () {0x7e;}' unless defined(&AC97_VENDOR_ID2_REGISTER);
	eval 'sub VID2R_REVISION_MASK () {0xff;}' unless defined(&VID2R_REVISION_MASK);
	eval 'sub VID2R_CHAR3_MASK () {0xff00;}' unless defined(&VID2R_CHAR3_MASK);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
