require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_AUDIO4231_DMA_H)) {
    eval 'sub _SYS_AUDIO4231_DMA_H () {1;}' unless defined(&_SYS_AUDIO4231_DMA_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub APC_HANDLE () { ($state->{cs_handles}->{cs_codec_hndl});}' unless defined(&APC_HANDLE);
	eval 'sub APC_DMACSR () { ($state->{cs_regs}->{apc}->{dmacsr});}' unless defined(&APC_DMACSR);
	eval 'sub APC_DMACVA () { ($state->{cs_regs}->{apc}->{dmacva});}' unless defined(&APC_DMACVA);
	eval 'sub APC_DMACC () { ($state->{cs_regs}->{apc}->{dmacc});}' unless defined(&APC_DMACC);
	eval 'sub APC_DMACNVA () { ($state->{cs_regs}->{apc}->{dmacnva});}' unless defined(&APC_DMACNVA);
	eval 'sub APC_DMACNC () { ($state->{cs_regs}->{apc}->{dmacnc});}' unless defined(&APC_DMACNC);
	eval 'sub APC_DMAPVA () { ($state->{cs_regs}->{apc}->{dmapva});}' unless defined(&APC_DMAPVA);
	eval 'sub APC_DMAPC () { ($state->{cs_regs}->{apc}->{dmapc});}' unless defined(&APC_DMAPC);
	eval 'sub APC_DMAPNVA () { ($state->{cs_regs}->{apc}->{dmapnva});}' unless defined(&APC_DMAPNVA);
	eval 'sub APC_DMAPNC () { ($state->{cs_regs}->{apc}->{dmapnc});}' unless defined(&APC_DMAPNC);
	eval 'sub APC_RESET () {0x1;}' unless defined(&APC_RESET);
	eval 'sub APC_CDMA_GO () {0x4;}' unless defined(&APC_CDMA_GO);
	eval 'sub APC_PDMA_GO () {0x8;}' unless defined(&APC_PDMA_GO);
	eval 'sub APC_LOOP_BACK () {0x10;}' unless defined(&APC_LOOP_BACK);
	eval 'sub APC_COD_PDWN () {0x20;}' unless defined(&APC_COD_PDWN);
	eval 'sub APC_C_ABORT () {0x40;}' unless defined(&APC_C_ABORT);
	eval 'sub APC_P_ABORT () {0x80;}' unless defined(&APC_P_ABORT);
	eval 'sub APC_CXI_EN () {0x100;}' unless defined(&APC_CXI_EN);
	eval 'sub APC_CXI () {0x200;}' unless defined(&APC_CXI);
	eval 'sub APC_CD () {0x400;}' unless defined(&APC_CD);
	eval 'sub APC_CX () {0x800;}' unless defined(&APC_CX);
	eval 'sub APC_PMI_EN () {0x1000;}' unless defined(&APC_PMI_EN);
	eval 'sub APC_PD () {0x2000;}' unless defined(&APC_PD);
	eval 'sub APC_PM () {0x4000;}' unless defined(&APC_PM);
	eval 'sub APC_PMI () {0x8000;}' unless defined(&APC_PMI);
	eval 'sub APC_EIE () {0x10000;}' unless defined(&APC_EIE);
	eval 'sub APC_CIE () {0x20000;}' unless defined(&APC_CIE);
	eval 'sub APC_PIE () {0x40000;}' unless defined(&APC_PIE);
	eval 'sub APC_IE () {0x80000;}' unless defined(&APC_IE);
	eval 'sub APC_EI () {0x100000;}' unless defined(&APC_EI);
	eval 'sub APC_CI () {0x200000;}' unless defined(&APC_CI);
	eval 'sub APC_PI () {0x400000;}' unless defined(&APC_PI);
	eval 'sub APC_IP () {0x800000;}' unless defined(&APC_IP);
	eval 'sub APC_ID () {0xff000000;}' unless defined(&APC_ID);
	eval 'sub APC_ID_VALUE () {0x7e000000;}' unless defined(&APC_ID_VALUE);
	eval 'sub APC_CLEAR_RESET_VALUE () {0x;}' unless defined(&APC_CLEAR_RESET_VALUE);
	eval 'sub APC_PINTR_MASK () {( &APC_PI| &APC_PMI);}' unless defined(&APC_PINTR_MASK);
	eval 'sub APC_CINTR_MASK () {( &APC_CI| &APC_CXI);}' unless defined(&APC_CINTR_MASK);
	eval 'sub APC_COMMON_MASK () {( &APC_IP| &APC_EI);}' unless defined(&APC_COMMON_MASK);
	eval 'sub APC_PINTR_ENABLE () {( &APC_PIE| &APC_PMI_EN);}' unless defined(&APC_PINTR_ENABLE);
	eval 'sub APC_CINTR_ENABLE () {( &APC_CIE| &APC_CXI_EN);}' unless defined(&APC_CINTR_ENABLE);
	eval 'sub APC_COMMON_ENABLE () {( &APC_IE| &APC_EIE);}' unless defined(&APC_COMMON_ENABLE);
	eval 'sub APC_PLAY_ENABLE () {( &APC_PINTR_MASK| &APC_COMMON_MASK|  &APC_PINTR_ENABLE| &APC_COMMON_ENABLE| &APC_PDMA_GO);}' unless defined(&APC_PLAY_ENABLE);
	eval 'sub APC_PLAY_DISABLE () {( &APC_PINTR_MASK| &APC_PINTR_ENABLE| &APC_PDMA_GO);}' unless defined(&APC_PLAY_DISABLE);
	eval 'sub APC_CAP_ENABLE () {( &APC_CINTR_MASK| &APC_COMMON_MASK|  &APC_CINTR_ENABLE| &APC_COMMON_ENABLE| &APC_CDMA_GO);}' unless defined(&APC_CAP_ENABLE);
	eval 'sub APC_CAP_DISABLE () {( &APC_CINTR_MASK| &APC_CINTR_ENABLE| &APC_CDMA_GO);}' unless defined(&APC_CAP_DISABLE);
	eval 'sub EB2_CODEC_HNDL () { ($state->{cs_handles}->{cs_codec_hndl});}' unless defined(&EB2_CODEC_HNDL);
	eval 'sub EB2_PLAY_HNDL () { ($state->{cs_handles}->{cs_eb2_play_hndl});}' unless defined(&EB2_PLAY_HNDL);
	eval 'sub EB2_REC_HNDL () { ($state->{cs_handles}->{cs_eb2_rec_hndl});}' unless defined(&EB2_REC_HNDL);
	eval 'sub EB2_AUXIO_HNDL () { ($state->{cs_handles}->{cs_eb2_auxio_hndl});}' unless defined(&EB2_AUXIO_HNDL);
	eval 'sub EB2_PLAY_CSR () { ($state->{cs_eb2_regs}->{play}->{eb2csr});}' unless defined(&EB2_PLAY_CSR);
	eval 'sub EB2_PLAY_ACR () { ($state->{cs_eb2_regs}->{play}->{eb2acr});}' unless defined(&EB2_PLAY_ACR);
	eval 'sub EB2_PLAY_BCR () { ($state->{cs_eb2_regs}->{play}->{eb2bcr});}' unless defined(&EB2_PLAY_BCR);
	eval 'sub EB2_REC_CSR () { ($state->{cs_eb2_regs}->{record}->{eb2csr});}' unless defined(&EB2_REC_CSR);
	eval 'sub EB2_REC_ACR () { ($state->{cs_eb2_regs}->{record}->{eb2acr});}' unless defined(&EB2_REC_ACR);
	eval 'sub EB2_REC_BCR () { ($state->{cs_eb2_regs}->{record}->{eb2bcr});}' unless defined(&EB2_REC_BCR);
	eval 'sub EB2_AUXIO_REG () { ($state->{cs_eb2_regs}->{auxio});}' unless defined(&EB2_AUXIO_REG);
	eval 'sub EB2_AUXIO_COD_PDWN () {0x1;}' unless defined(&EB2_AUXIO_COD_PDWN);
	eval 'sub EB2_INT_PEND () {0x1;}' unless defined(&EB2_INT_PEND);
	eval 'sub EB2_ERR_PEND () {0x2;}' unless defined(&EB2_ERR_PEND);
	eval 'sub EB2_DRAIN () {0x4;}' unless defined(&EB2_DRAIN);
	eval 'sub EB2_INT_EN () {0x10;}' unless defined(&EB2_INT_EN);
	eval 'sub EB2_RESET () {0x80;}' unless defined(&EB2_RESET);
	eval 'sub EB2_WRITE () {0x100;}' unless defined(&EB2_WRITE);
	eval 'sub EB2_READ () {0x;}' unless defined(&EB2_READ);
	eval 'sub EB2_EN_DMA () {0x200;}' unless defined(&EB2_EN_DMA);
	eval 'sub EB2_CYC_PENDING () {0x400;}' unless defined(&EB2_CYC_PENDING);
	eval 'sub EB2_DIAG_RD_DONE () {0x800;}' unless defined(&EB2_DIAG_RD_DONE);
	eval 'sub EB2_DIAG_WR_DONE () {0x1000;}' unless defined(&EB2_DIAG_WR_DONE);
	eval 'sub EB2_EN_CNT () {0x2000;}' unless defined(&EB2_EN_CNT);
	eval 'sub EB2_TC () {0x4000;}' unless defined(&EB2_TC);
	eval 'sub EB2_DIS_CSR_DRN () {0x10000;}' unless defined(&EB2_DIS_CSR_DRN);
	eval 'sub EB2_16 () {0x;}' unless defined(&EB2_16);
	eval 'sub EB2_32 () {0x40000;}' unless defined(&EB2_32);
	eval 'sub EB2_4 () {0x80000;}' unless defined(&EB2_4);
	eval 'sub EB2_64 () {0xc0000;}' unless defined(&EB2_64);
	eval 'sub EB2_DIAG_EN () {0x100000;}' unless defined(&EB2_DIAG_EN);
	eval 'sub EB2_DIS_ERR_PEND () {0x400000;}' unless defined(&EB2_DIS_ERR_PEND);
	eval 'sub EB2_TCI_DIS () {0x800000;}' unless defined(&EB2_TCI_DIS);
	eval 'sub EB2_EN_NEXT () {0x1000000;}' unless defined(&EB2_EN_NEXT);
	eval 'sub EB2_DMA_ON () {0x2000000;}' unless defined(&EB2_DMA_ON);
	eval 'sub EB2_A_LOADED () {0x4000000;}' unless defined(&EB2_A_LOADED);
	eval 'sub EB2_NA_LOADED () {0x8000000;}' unless defined(&EB2_NA_LOADED);
	eval 'sub EB2_DEV_ID () {0xf0000000;}' unless defined(&EB2_DEV_ID);
	eval 'sub EB2_ID_VALUE () {0xc0000000;}' unless defined(&EB2_ID_VALUE);
	eval 'sub EB2_PCLEAR_RESET_VALUE () {( &EB2_READ| &EB2_EN_NEXT);}' unless defined(&EB2_PCLEAR_RESET_VALUE);
	eval 'sub EB2_RCLEAR_RESET_VALUE () {( &EB2_WRITE| &EB2_EN_NEXT);}' unless defined(&EB2_RCLEAR_RESET_VALUE);
	eval 'sub EB2_PINTR_MASK () {( &EB2_INT_EN);}' unless defined(&EB2_PINTR_MASK);
	eval 'sub EB2_RINTR_MASK () {( &EB2_INT_EN);}' unless defined(&EB2_RINTR_MASK);
	eval 'sub EB2_PLAY_ENABLE () {( &EB2_PINTR_MASK| &EB2_EN_DMA| &EB2_EN_CNT| &EB2_64|  &EB2_PCLEAR_RESET_VALUE);}' unless defined(&EB2_PLAY_ENABLE);
	eval 'sub EB2_REC_ENABLE () {( &EB2_RINTR_MASK| &EB2_EN_DMA| &EB2_EN_CNT| &EB2_64|  &EB2_RCLEAR_RESET_VALUE);}' unless defined(&EB2_REC_ENABLE);
	eval 'sub EB2_FIFO_DRAIN () {( &EB2_DRAIN| &EB2_CYC_PENDING);}' unless defined(&EB2_FIFO_DRAIN);
	eval 'sub CS4231_IDNUM () {(0x6175);}' unless defined(&CS4231_IDNUM);
	eval 'sub CS4231_MINPACKET () {(0);}' unless defined(&CS4231_MINPACKET);
	eval 'sub CS4231_MAXPACKET () {(4*1024);}' unless defined(&CS4231_MAXPACKET);
	eval 'sub CS4231_HIWATER () {( &AM_MAX_QUEUED_MSGS_SIZE);}' unless defined(&CS4231_HIWATER);
	eval 'sub CS4231_LOWATER () {( &AM_MIN_QUEUED_MSGS_SIZE);}' unless defined(&CS4231_LOWATER);
	eval 'sub CS4231_MAX_CHANNELS () {(200);}' unless defined(&CS4231_MAX_CHANNELS);
	eval 'sub CS4231_REGS () {(32);}' unless defined(&CS4231_REGS);
	eval 'sub CS4231_NCOMPONENTS () {(1);}' unless defined(&CS4231_NCOMPONENTS);
	eval 'sub CS4231_COMPONENT () {(0);}' unless defined(&CS4231_COMPONENT);
	eval 'sub CS4231_PWR_OFF () {(0);}' unless defined(&CS4231_PWR_OFF);
	eval 'sub CS4231_PWR_ON () {(1);}' unless defined(&CS4231_PWR_ON);
	eval 'sub CS4231_TIMEOUT () {(100000);}' unless defined(&CS4231_TIMEOUT);
	eval 'sub CS4231_NOT_SUSPENDED () {(0);}' unless defined(&CS4231_NOT_SUSPENDED);
	eval 'sub CS4231_SUSPENDED () {(~ &CS4231_NOT_SUSPENDED);}' unless defined(&CS4231_SUSPENDED);
	eval 'sub CS4231_BSIZE () {(8*1024);}' unless defined(&CS4231_BSIZE);
	eval("sub APC_DMA () { 0; }") unless defined(&APC_DMA);
	eval("sub EB2_DMA () { 1; }") unless defined(&EB2_DMA);
	eval 'sub CS4231_IAR () { ($state->{cs_regs}->{codec}->{iar});}' unless defined(&CS4231_IAR);
	eval 'sub CS4231_IDR () { ($state->{cs_regs}->{codec}->{idr});}' unless defined(&CS4231_IDR);
	eval 'sub CS4231_STATUS () { ($state->{cs_regs}->{codec}->{statr});}' unless defined(&CS4231_STATUS);
	eval 'sub CS4231_PIODR () { ($state->{cs_regs}->{codec}->{piodr});}' unless defined(&CS4231_PIODR);
	eval("sub NO_INTERNAL_CD () { 0; }") unless defined(&NO_INTERNAL_CD);
	eval("sub INTERNAL_CD_ON_AUX1 () { 1; }") unless defined(&INTERNAL_CD_ON_AUX1);
	eval("sub INTERNAL_CD_ON_AUX2 () { 2; }") unless defined(&INTERNAL_CD_ON_AUX2);
	eval 'sub PDMA_ENGINE_INITIALIZED () {0x1;}' unless defined(&PDMA_ENGINE_INITIALIZED);
	eval 'sub REC_INTR_PENDING () {0x2;}' unless defined(&REC_INTR_PENDING);
	eval 'sub APC_P_STOPPED () {0x4;}' unless defined(&APC_P_STOPPED);
	eval 'sub PLAY_DMA_HANDLE () { ($state->{cs_ph[&state}->{cs_pbuf_toggle]});}' unless defined(&PLAY_DMA_HANDLE);
	eval 'sub PLAY_DMA_COOKIE () { ($state->{cs_pc[&state}->{cs_pbuf_toggle]});}' unless defined(&PLAY_DMA_COOKIE);
	eval 'sub PLAY_DMA_BUF () { ($state->{cs_pb[&state}->{cs_pbuf_toggle]});}' unless defined(&PLAY_DMA_BUF);
	eval 'sub PLAY_DMA_MEM_HANDLE () { ($state->{cs_pmh[&state}->{cs_pbuf_toggle]});}' unless defined(&PLAY_DMA_MEM_HANDLE);
	eval 'sub PLAY_DMA_MEM_LENGTH () { ($state->{cs_pml[&state}->{cs_pbuf_toggle]});}' unless defined(&PLAY_DMA_MEM_LENGTH);
	eval 'sub PLAY_COUNT () { ($state->{cs_pcnt[&state}->{cs_pbuf_toggle]});}' unless defined(&PLAY_COUNT);
	eval 'sub CAP_DMA_HANDLE () { ($state->{cs_ch[&state}->{cs_cbuf_toggle]});}' unless defined(&CAP_DMA_HANDLE);
	eval 'sub CAP_DMA_COOKIE () { ($state->{cs_cc[&state}->{cs_cbuf_toggle]});}' unless defined(&CAP_DMA_COOKIE);
	eval 'sub CAP_DMA_BUF () { ($state->{cs_cb[&state}->{cs_cbuf_toggle]});}' unless defined(&CAP_DMA_BUF);
	eval 'sub CAP_DMA_MEM_HANDLE () { ($state->{cs_cmh[&state}->{cs_cbuf_toggle]});}' unless defined(&CAP_DMA_MEM_HANDLE);
	eval 'sub CAP_DMA_MEM_LENGTH () { ($state->{cs_cml[&state}->{cs_cbuf_toggle]});}' unless defined(&CAP_DMA_MEM_LENGTH);
	eval 'sub CAP_COUNT () { ($state->{cs_ccnt[&state}->{cs_cbuf_toggle]});}' unless defined(&CAP_COUNT);
	eval 'sub KIOP {
	    my($X) = @_;
    	    eval q((( &kstat_intr_t *)( ($X->{cs_ksp}->{ks_data}))));
	}' unless defined(&KIOP);
	eval 'sub CS4231_DMA_MAP_REGS {
	    my($DIP, $S, $P, $C) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_map_regs}))($DIP, $S, $P, $C));
	}' unless defined(&CS4231_DMA_MAP_REGS);
	eval 'sub CS4231_DMA_UNMAP_REGS {
	    my($S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_unmap_regs}))($S));
	}' unless defined(&CS4231_DMA_UNMAP_REGS);
	eval 'sub CS4231_DMA_RESET {
	    my($S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_reset}))($S));
	}' unless defined(&CS4231_DMA_RESET);
	eval 'sub CS4231_DMA_ADD_INTR {
	    my($S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_add_intr}))($S));
	}' unless defined(&CS4231_DMA_ADD_INTR);
	eval 'sub CS4231_DMA_REM_INTR {
	    my($DIP, $S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_rem_intr}))($DIP));
	}' unless defined(&CS4231_DMA_REM_INTR);
	eval 'sub CS4231_DMA_START_PLAY {
	    my($S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_p_start}))($S));
	}' unless defined(&CS4231_DMA_START_PLAY);
	eval 'sub CS4231_DMA_PAUSE_PLAY {
	    my($S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_p_pause}))($S));
	}' unless defined(&CS4231_DMA_PAUSE_PLAY);
	eval 'sub CS4231_DMA_RESTART_PLAY {
	    my($S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_p_restart}))($S));
	}' unless defined(&CS4231_DMA_RESTART_PLAY);
	eval 'sub CS4231_DMA_STOP_PLAY {
	    my($S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_p_stop}))($S));
	}' unless defined(&CS4231_DMA_STOP_PLAY);
	eval 'sub CS4231_DMA_START_RECORD {
	    my($S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_r_start}))($S));
	}' unless defined(&CS4231_DMA_START_RECORD);
	eval 'sub CS4231_DMA_STOP_RECORD {
	    my($S) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_r_stop}))($S));
	}' unless defined(&CS4231_DMA_STOP_RECORD);
	eval 'sub CS4231_DMA_POWER {
	    my($S, $L) = @_;
    	    eval q((($S)-> ($cs_dma_ops->{cs_dma_power}))($S, $L));
	}' unless defined(&CS4231_DMA_POWER);
	eval 'sub CS4231_RETRIES () {10;}' unless defined(&CS4231_RETRIES);
	eval 'sub OR_SET_BYTE {
	    my($handle, $addr, $val) = @_;
    	    eval q( &cs4231_put8(( ($state->{cs_ahandle})), ($handle), ( &uint8_t *)($addr), ( &ddi_get8(($handle), ( &uint8_t *)($addr)) | ( &uint8_t)($val)), ( &__LINE__), ( &thisfile)););
	}' unless defined(&OR_SET_BYTE);
	eval 'sub OR_SET_WORD {
	    my($handle, $addr, $val) = @_;
    	    eval q( &ddi_put32(($handle), ( &uint_t *)($addr), ( &ddi_get32(($handle), ( &uint_t *)($addr)) | ( &uint_t)($val))););
	}' unless defined(&OR_SET_WORD);
	eval 'sub AND_SET_BYTE {
	    my($handle, $addr, $val) = @_;
    	    eval q( &cs4231_put8(( ($state->{cs_ahandle})), ($handle), ( &uint8_t *)($addr), ( &ddi_get8(($handle), ( &uint8_t *)($addr)) & ( &uint8_t)($val)), ( &__LINE__), ( &thisfile)););
	}' unless defined(&AND_SET_BYTE);
	eval 'sub AND_SET_WORD {
	    my($handle, $addr, $val) = @_;
    	    eval q( &ddi_put32(($handle), ( &uint_t *)($addr), ( &ddi_get32(($handle), ( &uint_t *)($addr)) & ( &uint_t)($val))););
	}' unless defined(&AND_SET_WORD);
	eval 'sub IAR_ADDRESS_MASK () {0x1f;}' unless defined(&IAR_ADDRESS_MASK);
	eval 'sub IAR_TRD () {0x20;}' unless defined(&IAR_TRD);
	eval 'sub IAR_MCE () {0x40;}' unless defined(&IAR_MCE);
	eval 'sub IAR_INIT () {0x80;}' unless defined(&IAR_INIT);
	eval 'sub STATUS_INT () {0x1;}' unless defined(&STATUS_INT);
	eval 'sub STATUS_PRDY () {0x2;}' unless defined(&STATUS_PRDY);
	eval 'sub STATUS_PLR () {0x4;}' unless defined(&STATUS_PLR);
	eval 'sub STATUS_PUL () {0x8;}' unless defined(&STATUS_PUL);
	eval 'sub STATUS_SER () {0x10;}' unless defined(&STATUS_SER);
	eval 'sub STATUS_CRDY () {0x20;}' unless defined(&STATUS_CRDY);
	eval 'sub STATUS_CLR () {0x40;}' unless defined(&STATUS_CLR);
	eval 'sub STATUS_CUL () {0x80;}' unless defined(&STATUS_CUL);
	eval 'sub STATUS_RESET () {0x;}' unless defined(&STATUS_RESET);
	eval 'sub LADCI_REG () {0x;}' unless defined(&LADCI_REG);
	eval 'sub LADCI_GAIN_MASK () {0xf;}' unless defined(&LADCI_GAIN_MASK);
	eval 'sub LADCI_LMGE () {0x20;}' unless defined(&LADCI_LMGE);
	eval 'sub LADCI_LLINE () {0x;}' unless defined(&LADCI_LLINE);
	eval 'sub LADCI_LAUX1 () {0x40;}' unless defined(&LADCI_LAUX1);
	eval 'sub LADCI_LMIC () {0x80;}' unless defined(&LADCI_LMIC);
	eval 'sub LADCI_LLOOP () {0xc0;}' unless defined(&LADCI_LLOOP);
	eval 'sub LADCI_IN_MASK () {0xc0;}' unless defined(&LADCI_IN_MASK);
	eval 'sub RADCI_REG () {0x1;}' unless defined(&RADCI_REG);
	eval 'sub RADCI_GAIN_MASK () {0xf;}' unless defined(&RADCI_GAIN_MASK);
	eval 'sub RADCI_RMGE () {0x20;}' unless defined(&RADCI_RMGE);
	eval 'sub RADCI_RLINE () {0x;}' unless defined(&RADCI_RLINE);
	eval 'sub RADCI_RAUX1 () {0x40;}' unless defined(&RADCI_RAUX1);
	eval 'sub RADCI_RMIC () {0x80;}' unless defined(&RADCI_RMIC);
	eval 'sub RADCI_RLOOP () {0xc0;}' unless defined(&RADCI_RLOOP);
	eval 'sub RADCI_IN_MASK () {0xc0;}' unless defined(&RADCI_IN_MASK);
	eval 'sub LAUX1_REG () {0x2;}' unless defined(&LAUX1_REG);
	eval 'sub LAUX1_GAIN_MASK () {0x1f;}' unless defined(&LAUX1_GAIN_MASK);
	eval 'sub LAUX1_LX1M () {0x80;}' unless defined(&LAUX1_LX1M);
	eval 'sub LAUX1_UNITY_GAIN () {0x8;}' unless defined(&LAUX1_UNITY_GAIN);
	eval 'sub RAUX1_REG () {0x3;}' unless defined(&RAUX1_REG);
	eval 'sub RAUX1_GAIN_MASK () {0x1f;}' unless defined(&RAUX1_GAIN_MASK);
	eval 'sub RAUX1_RX1M () {0x80;}' unless defined(&RAUX1_RX1M);
	eval 'sub RAUX1_UNITY_GAIN () {0x8;}' unless defined(&RAUX1_UNITY_GAIN);
	eval 'sub LAUX2_REG () {0x4;}' unless defined(&LAUX2_REG);
	eval 'sub LAUX2_GAIN_MASK () {0x1f;}' unless defined(&LAUX2_GAIN_MASK);
	eval 'sub LAUX2_LX2M () {0x80;}' unless defined(&LAUX2_LX2M);
	eval 'sub LAUX2_UNITY_GAIN () {0x8;}' unless defined(&LAUX2_UNITY_GAIN);
	eval 'sub RAUX2_REG () {0x5;}' unless defined(&RAUX2_REG);
	eval 'sub RAUX2_GAIN_MASK () {0x1f;}' unless defined(&RAUX2_GAIN_MASK);
	eval 'sub RAUX2_RX2M () {0x80;}' unless defined(&RAUX2_RX2M);
	eval 'sub RAUX2_UNITY_GAIN () {0x8;}' unless defined(&RAUX2_UNITY_GAIN);
	eval 'sub LDACO_REG () {0x6;}' unless defined(&LDACO_REG);
	eval 'sub LDACO_ATTEN_MASK () {0x3f;}' unless defined(&LDACO_ATTEN_MASK);
	eval 'sub LDACO_LDM () {0x80;}' unless defined(&LDACO_LDM);
	eval 'sub LDACO_MID_GAIN () {0x11;}' unless defined(&LDACO_MID_GAIN);
	eval 'sub RDACO_REG () {0x7;}' unless defined(&RDACO_REG);
	eval 'sub RDACO_ATTEN_MASK () {0x3f;}' unless defined(&RDACO_ATTEN_MASK);
	eval 'sub RDACO_RDM () {0x80;}' unless defined(&RDACO_RDM);
	eval 'sub RDACO_MID_GAIN () {0x11;}' unless defined(&RDACO_MID_GAIN);
	eval 'sub FSDF_REG () {0x8;}' unless defined(&FSDF_REG);
	eval 'sub FS_5510 () {0x1;}' unless defined(&FS_5510);
	eval 'sub FS_6620 () {0xf;}' unless defined(&FS_6620);
	eval 'sub FS_8000 () {0x;}' unless defined(&FS_8000);
	eval 'sub FS_9600 () {0xe;}' unless defined(&FS_9600);
	eval 'sub FS_11025 () {0x3;}' unless defined(&FS_11025);
	eval 'sub FS_16000 () {0x2;}' unless defined(&FS_16000);
	eval 'sub FS_18900 () {0x5;}' unless defined(&FS_18900);
	eval 'sub FS_22050 () {0x7;}' unless defined(&FS_22050);
	eval 'sub FS_27420 () {0x4;}' unless defined(&FS_27420);
	eval 'sub FS_32000 () {0x6;}' unless defined(&FS_32000);
	eval 'sub FS_33075 () {0xd;}' unless defined(&FS_33075);
	eval 'sub FS_37800 () {0x9;}' unless defined(&FS_37800);
	eval 'sub FS_44100 () {0xb;}' unless defined(&FS_44100);
	eval 'sub FS_48000 () {0xc;}' unless defined(&FS_48000);
	eval 'sub PDF_STEREO () {0x10;}' unless defined(&PDF_STEREO);
	eval 'sub PDF_MONO () {0x;}' unless defined(&PDF_MONO);
	eval 'sub PDF_LINEAR8 () {0x;}' unless defined(&PDF_LINEAR8);
	eval 'sub PDF_ULAW8 () {0x20;}' unless defined(&PDF_ULAW8);
	eval 'sub PDF_LINEAR16LE () {0x40;}' unless defined(&PDF_LINEAR16LE);
	eval 'sub PDF_ALAW8 () {0x60;}' unless defined(&PDF_ALAW8);
	eval 'sub PDF_ADPCM4 () {0xa0;}' unless defined(&PDF_ADPCM4);
	eval 'sub PDB_LINEAR16BE () {0xc0;}' unless defined(&PDB_LINEAR16BE);
	eval 'sub INTC_REG () {0x9;}' unless defined(&INTC_REG);
	eval 'sub INTC_PEN () {0x1;}' unless defined(&INTC_PEN);
	eval 'sub INTC_CEN () {0x2;}' unless defined(&INTC_CEN);
	eval 'sub INTC_SDC () {0x4;}' unless defined(&INTC_SDC);
	eval 'sub INTC_DDC () {0x;}' unless defined(&INTC_DDC);
	eval 'sub INTC_ACAL () {0x8;}' unless defined(&INTC_ACAL);
	eval 'sub INTC_PPIO () {0x40;}' unless defined(&INTC_PPIO);
	eval 'sub INTC_PDMA () {0x;}' unless defined(&INTC_PDMA);
	eval 'sub INTC_CPIO () {0x80;}' unless defined(&INTC_CPIO);
	eval 'sub INTC_CDMA () {0x;}' unless defined(&INTC_CDMA);
	eval 'sub PC_REG () {0xa;}' unless defined(&PC_REG);
	eval 'sub PC_IEN () {0x2;}' unless defined(&PC_IEN);
	eval 'sub PC_DEN () {0x4;}' unless defined(&PC_DEN);
	eval 'sub PC_XCTL0 () {0x40;}' unless defined(&PC_XCTL0);
	eval 'sub LINE_OUT_MUTE () {0x40;}' unless defined(&LINE_OUT_MUTE);
	eval 'sub PC_XCTL1 () {0x80;}' unless defined(&PC_XCTL1);
	eval 'sub HEADPHONE_MUTE () {0x80;}' unless defined(&HEADPHONE_MUTE);
	eval 'sub ESI_REG () {0xb;}' unless defined(&ESI_REG);
	eval 'sub ESI_ORL_MASK () {0x3;}' unless defined(&ESI_ORL_MASK);
	eval 'sub ESI_ORR_MASK () {0xc;}' unless defined(&ESI_ORR_MASK);
	eval 'sub ESI_DRS () {0x10;}' unless defined(&ESI_DRS);
	eval 'sub ESI_ACI () {0x20;}' unless defined(&ESI_ACI);
	eval 'sub ESI_PUR () {0x40;}' unless defined(&ESI_PUR);
	eval 'sub ESI_COR () {0x80;}' unless defined(&ESI_COR);
	eval 'sub MID_REG () {0xc;}' unless defined(&MID_REG);
	eval 'sub MID_ID_MASK () {0xf;}' unless defined(&MID_ID_MASK);
	eval 'sub MID_MODE2 () {0x40;}' unless defined(&MID_MODE2);
	eval 'sub LC_REG () {0xd;}' unless defined(&LC_REG);
	eval 'sub LC_LBE () {0x1;}' unless defined(&LC_LBE);
	eval 'sub LC_ATTEN_MASK () {0xfc;}' unless defined(&LC_ATTEN_MASK);
	eval 'sub LC_OFF () {0x;}' unless defined(&LC_OFF);
	eval 'sub PUB_REG () {0xe;}' unless defined(&PUB_REG);
	eval 'sub PLB_REG () {0xf;}' unless defined(&PLB_REG);
	eval 'sub AFE1_REG () {0x10;}' unless defined(&AFE1_REG);
	eval 'sub AFE1_DACZ () {0x1;}' unless defined(&AFE1_DACZ);
	eval 'sub AFE1_TE () {0x40;}' unless defined(&AFE1_TE);
	eval 'sub AFE1_OLB () {0x80;}' unless defined(&AFE1_OLB);
	eval 'sub AFE2_REG () {0x11;}' unless defined(&AFE2_REG);
	eval 'sub AFE2_HPF () {0x1;}' unless defined(&AFE2_HPF);
	eval 'sub LLIC_REG () {0x12;}' unless defined(&LLIC_REG);
	eval 'sub LLIC_MIX_GAIN_MASK () {0x1f;}' unless defined(&LLIC_MIX_GAIN_MASK);
	eval 'sub LLIC_LLM () {0x80;}' unless defined(&LLIC_LLM);
	eval 'sub LLIC_UNITY_GAIN () {0x8;}' unless defined(&LLIC_UNITY_GAIN);
	eval 'sub RLIC_REG () {0x13;}' unless defined(&RLIC_REG);
	eval 'sub RLIC_MIX_GAIN_MASK () {0x1f;}' unless defined(&RLIC_MIX_GAIN_MASK);
	eval 'sub RLIC_RLM () {0x80;}' unless defined(&RLIC_RLM);
	eval 'sub RLIC_UNITY_GAIN () {0x8;}' unless defined(&RLIC_UNITY_GAIN);
	eval 'sub TLB_REG () {0x14;}' unless defined(&TLB_REG);
	eval 'sub TUB_REG () {0x15;}' unless defined(&TUB_REG);
	eval 'sub AFS_REG () {0x18;}' unless defined(&AFS_REG);
	eval 'sub AFS_PU () {0x1;}' unless defined(&AFS_PU);
	eval 'sub AFS_PO () {0x2;}' unless defined(&AFS_PO);
	eval 'sub AFS_CO () {0x4;}' unless defined(&AFS_CO);
	eval 'sub AFS_CU () {0x8;}' unless defined(&AFS_CU);
	eval 'sub AFS_PI () {0x10;}' unless defined(&AFS_PI);
	eval 'sub AFS_CI () {0x20;}' unless defined(&AFS_CI);
	eval 'sub AFS_TI () {0x40;}' unless defined(&AFS_TI);
	eval 'sub AFS_RESET_STATUS () {0x;}' unless defined(&AFS_RESET_STATUS);
	eval 'sub VID_REG () {0x19;}' unless defined(&VID_REG);
	eval 'sub VID_CID_MASK () {0x7;}' unless defined(&VID_CID_MASK);
	eval 'sub VID_VERSION_MASK () {0xe0;}' unless defined(&VID_VERSION_MASK);
	eval 'sub VID_A () {0x20;}' unless defined(&VID_A);
	eval 'sub VID_CDE () {0x80;}' unless defined(&VID_CDE);
	eval 'sub MIOC_REG () {0x1a;}' unless defined(&MIOC_REG);
	eval 'sub MIOC_MI_ATTEN_MASK () {0xf;}' unless defined(&MIOC_MI_ATTEN_MASK);
	eval 'sub MIOC_MOM () {0x40;}' unless defined(&MIOC_MOM);
	eval 'sub MONO_SPKR_MUTE () {0x40;}' unless defined(&MONO_SPKR_MUTE);
	eval 'sub MIOC_MIM () {0x80;}' unless defined(&MIOC_MIM);
	eval 'sub CDF_REG () {0x1c;}' unless defined(&CDF_REG);
	eval 'sub CDF_STEREO () {0x10;}' unless defined(&CDF_STEREO);
	eval 'sub CDF_MONO () {0x;}' unless defined(&CDF_MONO);
	eval 'sub CDF_LINEAR8 () {0x;}' unless defined(&CDF_LINEAR8);
	eval 'sub CDF_ULAW8 () {0x20;}' unless defined(&CDF_ULAW8);
	eval 'sub CDF_LINEAR16LE () {0x40;}' unless defined(&CDF_LINEAR16LE);
	eval 'sub CDF_ALAW8 () {0x60;}' unless defined(&CDF_ALAW8);
	eval 'sub CDF_ADPCM4 () {0xa0;}' unless defined(&CDF_ADPCM4);
	eval 'sub CDB_LINEAR16BE () {0xc0;}' unless defined(&CDB_LINEAR16BE);
	eval 'sub CUB_REG () {0x1e;}' unless defined(&CUB_REG);
	eval 'sub CLB_REG () {0x1f;}' unless defined(&CLB_REG);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
