require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_AUDIO_79C30_H)) {
    eval 'sub _SYS_AUDIO_79C30_H () {1;}' unless defined(&_SYS_AUDIO_79C30_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub AUD_79C30_PRECISION () {(8);}' unless defined(&AUD_79C30_PRECISION);
	eval 'sub AUD_79C30_CHANNELS () {(1);}' unless defined(&AUD_79C30_CHANNELS);
	eval 'sub AUD_79C30_SAMPLERATE () {(8000);}' unless defined(&AUD_79C30_SAMPLERATE);
	eval 'sub AUD_79C30_DEFAULT_BSIZE () {(256);}' unless defined(&AUD_79C30_DEFAULT_BSIZE);
	eval 'sub AUD_79C30_MAX_BSIZE () {(65536);}' unless defined(&AUD_79C30_MAX_BSIZE);
	eval 'sub AUD_79C30_HIWATER () {(8192* 3);}' unless defined(&AUD_79C30_HIWATER);
	eval 'sub AUD_79C30_LOWATER () {(8192* 2);}' unless defined(&AUD_79C30_LOWATER);
	eval 'sub AUD_79C30_CMDPOOL () {(7);}' unless defined(&AUD_79C30_CMDPOOL);
	eval 'sub AUD_79C30_RECBUFS () {(4);}' unless defined(&AUD_79C30_RECBUFS);
	eval 'sub AUD_79C30_PLAYBUFS () {( &AUD_79C30_CMDPOOL -  &AUD_79C30_RECBUFS);}' unless defined(&AUD_79C30_PLAYBUFS);
	eval 'sub AUD_79C30_MAXPACKET () {(2048);}' unless defined(&AUD_79C30_MAXPACKET);
	eval 'sub AUD_79C30_DEFAULT_PLAYGAIN () {(75);}' unless defined(&AUD_79C30_DEFAULT_PLAYGAIN);
	eval 'sub AUD_79C30_DEFAULT_RECGAIN () {(128);}' unless defined(&AUD_79C30_DEFAULT_RECGAIN);
	eval 'sub AMD_DEV_NAME () {"SUNW,am79c30";}' unless defined(&AMD_DEV_NAME);
	eval 'sub AMD_DEV_VERSION () {"a";}' unless defined(&AMD_DEV_VERSION);
	eval 'sub AMD_DEV_CONFIG_ONBRD1 () {"onboard1";}' unless defined(&AMD_DEV_CONFIG_ONBRD1);
	eval 'sub AMD_UNITMASK () {(0xf);}' unless defined(&AMD_UNITMASK);
	eval 'sub AMD_UNIT {
	    my($dev) = @_;
    	    eval q((( &geteminor($dev)) &  &AMD_UNITMASK));
	}' unless defined(&AMD_UNIT);
	eval 'sub AMD_ISCTL {
	    my($dev) = @_;
    	    eval q(((( &geteminor($dev)) &  &AMD_MINOR_CTL) != 0));
	}' unless defined(&AMD_ISCTL);
	eval 'sub AMD_MINOR_RW () {(0x20);}' unless defined(&AMD_MINOR_RW);
	eval 'sub AMD_MINOR_RO () {(0x40);}' unless defined(&AMD_MINOR_RO);
	eval 'sub AMD_MINOR_CTL () {(0x80);}' unless defined(&AMD_MINOR_CTL);
	eval 'sub AMD_CLONE_BIT () {(0x10);}' unless defined(&AMD_CLONE_BIT);
	eval 'sub AMD_SUSPENDED () {1;}' unless defined(&AMD_SUSPENDED);
	eval 'sub AMD_RESUMED () {2;}' unless defined(&AMD_RESUMED);
	eval 'sub ir () { &cr;}' unless defined(&ir);
	eval 'sub bbrb () { &bbtb;}' unless defined(&bbrb);
	eval 'sub bcrb () { &bctb;}' unless defined(&bcrb);
	eval 'sub UNITP {
	    my($as) = @_;
    	    eval q((( &amd_unit_t *)(($as)-> ($distate->{ddstate}))));
	}' unless defined(&UNITP);
	eval 'sub CSR {
	    my($as) = @_;
    	    eval q(( &UNITP($as)-> &chip));
	}' unless defined(&CSR);
    }
    eval 'sub AUDIO_PACK {
        my($reg, $length) = @_;
	    eval q(((($reg) << 8) | ($length)));
    }' unless defined(&AUDIO_PACK);
    eval 'sub AUDIO_UNPACK_REG {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xff));
    }' unless defined(&AUDIO_UNPACK_REG);
    eval 'sub AUDIO_UNPACK_LENGTH {
        my($x) = @_;
	    eval q((($x) & 0xff));
    }' unless defined(&AUDIO_UNPACK_LENGTH);
    eval 'sub AUDIO_INIT () {0x20;}' unless defined(&AUDIO_INIT);
    eval 'sub AUDIO_INIT_INIT () { &AUDIO_PACK(( &AUDIO_INIT | 0x1), 1);}' unless defined(&AUDIO_INIT_INIT);
    eval 'sub AUDIO_MUX () {0x40;}' unless defined(&AUDIO_MUX);
    eval 'sub AUDIO_MUX_MCR1 () { &AUDIO_PACK( &AUDIO_MUX | 0x1, 1);}' unless defined(&AUDIO_MUX_MCR1);
    eval 'sub AUDIO_MUX_MCR2 () { &AUDIO_PACK( &AUDIO_MUX | 0x2, 1);}' unless defined(&AUDIO_MUX_MCR2);
    eval 'sub AUDIO_MUX_MCR3 () { &AUDIO_PACK( &AUDIO_MUX | 0x3, 1);}' unless defined(&AUDIO_MUX_MCR3);
    eval 'sub AUDIO_MUX_MCR4 () { &AUDIO_PACK( &AUDIO_MUX | 0x4, 1);}' unless defined(&AUDIO_MUX_MCR4);
    eval 'sub AUDIO_MAP () {0x60;}' unless defined(&AUDIO_MAP);
    eval 'sub AUDIO_MAP_X () { &AUDIO_PACK( &AUDIO_MAP | 0x1, 16);}' unless defined(&AUDIO_MAP_X);
    eval 'sub AUDIO_MAP_R () { &AUDIO_PACK( &AUDIO_MAP | 0x2, 16);}' unless defined(&AUDIO_MAP_R);
    eval 'sub AUDIO_MAP_GX () { &AUDIO_PACK( &AUDIO_MAP | 0x3, 2);}' unless defined(&AUDIO_MAP_GX);
    eval 'sub AUDIO_MAP_GR () { &AUDIO_PACK( &AUDIO_MAP | 0x4, 2);}' unless defined(&AUDIO_MAP_GR);
    eval 'sub AUDIO_MAP_GER () { &AUDIO_PACK( &AUDIO_MAP | 0x5, 2);}' unless defined(&AUDIO_MAP_GER);
    eval 'sub AUDIO_MAP_STG () { &AUDIO_PACK( &AUDIO_MAP | 0x6, 2);}' unless defined(&AUDIO_MAP_STG);
    eval 'sub AUDIO_MAP_FTGR () { &AUDIO_PACK( &AUDIO_MAP | 0x7, 2);}' unless defined(&AUDIO_MAP_FTGR);
    eval 'sub AUDIO_MAP_ATGR () { &AUDIO_PACK( &AUDIO_MAP | 0x8, 2);}' unless defined(&AUDIO_MAP_ATGR);
    eval 'sub AUDIO_MAP_MMR1 () { &AUDIO_PACK( &AUDIO_MAP | 0x9, 1);}' unless defined(&AUDIO_MAP_MMR1);
    eval 'sub AUDIO_MAP_MMR2 () { &AUDIO_PACK( &AUDIO_MAP | 0xa, 1);}' unless defined(&AUDIO_MAP_MMR2);
    eval 'sub AUDIO_MAP_ALL () { &AUDIO_PACK( &AUDIO_MAP | 0xb, 46);}' unless defined(&AUDIO_MAP_ALL);
    eval 'sub AUDIO_MAP_GX_MIN () {0;}' unless defined(&AUDIO_MAP_GX_MIN);
    eval 'sub AUDIO_MAP_GX_MAX () {12;}' unless defined(&AUDIO_MAP_GX_MAX);
    eval 'sub AUDIO_MAP_GR_MIN () {-12;}' unless defined(&AUDIO_MAP_GR_MIN);
    eval 'sub AUDIO_MAP_GR_MAX () {0;}' unless defined(&AUDIO_MAP_GR_MAX);
    eval 'sub AUDIO_MAP_GER_MIN () {-10;}' unless defined(&AUDIO_MAP_GER_MIN);
    eval 'sub AUDIO_MAP_GER_MAX () {18;}' unless defined(&AUDIO_MAP_GER_MAX);
    eval 'sub AUDIO_MAP_STG_MIN () {-18;}' unless defined(&AUDIO_MAP_STG_MIN);
    eval 'sub AUDIO_MAP_STG_MAX () {0;}' unless defined(&AUDIO_MAP_STG_MAX);
    eval 'sub AUDIO_MAP_FTGR_MIN () {16;}' unless defined(&AUDIO_MAP_FTGR_MIN);
    eval 'sub AUDIO_MAP_FTGR_MAX () {3999;}' unless defined(&AUDIO_MAP_FTGR_MAX);
    eval 'sub AUDIO_MAP_ATGR_MIN () {-18;}' unless defined(&AUDIO_MAP_ATGR_MIN);
    eval 'sub AUDIO_MAP_ATGR_MAX () {0;}' unless defined(&AUDIO_MAP_ATGR_MAX);
    eval 'sub AUDIO_INIT_BITS_IDLE () {0x;}' unless defined(&AUDIO_INIT_BITS_IDLE);
    eval 'sub AUDIO_INIT_BITS_ACTIVE () {0x1;}' unless defined(&AUDIO_INIT_BITS_ACTIVE);
    eval 'sub AUDIO_INIT_BITS_NOMAP () {0x20;}' unless defined(&AUDIO_INIT_BITS_NOMAP);
    eval 'sub AUDIO_INIT_BITS_INT_ENABLED () {0x;}' unless defined(&AUDIO_INIT_BITS_INT_ENABLED);
    eval 'sub AUDIO_INIT_BITS_INT_DISABLED () {0x4;}' unless defined(&AUDIO_INIT_BITS_INT_DISABLED);
    eval 'sub AUDIO_INIT_BITS_CLOCK_DIVIDE_2 () {0x;}' unless defined(&AUDIO_INIT_BITS_CLOCK_DIVIDE_2);
    eval 'sub AUDIO_INIT_BITS_CLOCK_DIVIDE_1 () {0x8;}' unless defined(&AUDIO_INIT_BITS_CLOCK_DIVIDE_1);
    eval 'sub AUDIO_INIT_BITS_CLOCK_DIVIDE_4 () {0x10;}' unless defined(&AUDIO_INIT_BITS_CLOCK_DIVIDE_4);
    eval 'sub AUDIO_INIT_BITS_CLOCK_DIVIDE_3 () {0x20;}' unless defined(&AUDIO_INIT_BITS_CLOCK_DIVIDE_3);
    eval 'sub AUDIO_INIT_BITS_RECEIVE_ABORT () {0x40;}' unless defined(&AUDIO_INIT_BITS_RECEIVE_ABORT);
    eval 'sub AUDIO_INIT_BITS_TRANSMIT_ABORT () {0x80;}' unless defined(&AUDIO_INIT_BITS_TRANSMIT_ABORT);
    eval 'sub AUDIO_MUX_PORT_NONE () {0x;}' unless defined(&AUDIO_MUX_PORT_NONE);
    eval 'sub AUDIO_MUX_PORT_B1 () {0x1;}' unless defined(&AUDIO_MUX_PORT_B1);
    eval 'sub AUDIO_MUX_PORT_B2 () {0x2;}' unless defined(&AUDIO_MUX_PORT_B2);
    eval 'sub AUDIO_MUX_PORT_BA () {0x3;}' unless defined(&AUDIO_MUX_PORT_BA);
    eval 'sub AUDIO_MUX_PORT_BB () {0x4;}' unless defined(&AUDIO_MUX_PORT_BB);
    eval 'sub AUDIO_MUX_PORT_BC () {0x5;}' unless defined(&AUDIO_MUX_PORT_BC);
    eval 'sub AUDIO_MUX_PORT_BD () {0x6;}' unless defined(&AUDIO_MUX_PORT_BD);
    eval 'sub AUDIO_MUX_PORT_BE () {0x7;}' unless defined(&AUDIO_MUX_PORT_BE);
    eval 'sub AUDIO_MUX_PORT_BF () {0x8;}' unless defined(&AUDIO_MUX_PORT_BF);
    eval 'sub AUDIO_MUX_MCR4_BITS_INT_ENABLE () {0x8;}' unless defined(&AUDIO_MUX_MCR4_BITS_INT_ENABLE);
    eval 'sub AUDIO_MUX_MCR4_BITS_INT_DISABLE () {0x;}' unless defined(&AUDIO_MUX_MCR4_BITS_INT_DISABLE);
    eval 'sub AUDIO_MUX_MCR4_BITS_REVERSE_BB () {0x10;}' unless defined(&AUDIO_MUX_MCR4_BITS_REVERSE_BB);
    eval 'sub AUDIO_MUX_MCR4_BITS_REVERSE_BC () {0x20;}' unless defined(&AUDIO_MUX_MCR4_BITS_REVERSE_BC);
    eval 'sub AUDIO_MMR1_BITS_A_LAW () {0x1;}' unless defined(&AUDIO_MMR1_BITS_A_LAW);
    eval 'sub AUDIO_MMR1_BITS_u_LAW () {0x;}' unless defined(&AUDIO_MMR1_BITS_u_LAW);
    eval 'sub AUDIO_MMR1_BITS_LOAD_GX () {0x2;}' unless defined(&AUDIO_MMR1_BITS_LOAD_GX);
    eval 'sub AUDIO_MMR1_BITS_LOAD_GR () {0x4;}' unless defined(&AUDIO_MMR1_BITS_LOAD_GR);
    eval 'sub AUDIO_MMR1_BITS_LOAD_GER () {0x8;}' unless defined(&AUDIO_MMR1_BITS_LOAD_GER);
    eval 'sub AUDIO_MMR1_BITS_LOAD_X () {0x10;}' unless defined(&AUDIO_MMR1_BITS_LOAD_X);
    eval 'sub AUDIO_MMR1_BITS_LOAD_R () {0x20;}' unless defined(&AUDIO_MMR1_BITS_LOAD_R);
    eval 'sub AUDIO_MMR1_BITS_LOAD_STG () {0x40;}' unless defined(&AUDIO_MMR1_BITS_LOAD_STG);
    eval 'sub AUDIO_MMR1_BITS_LOAD_DLB () {0x80;}' unless defined(&AUDIO_MMR1_BITS_LOAD_DLB);
    eval 'sub AUDIO_MMR2_BITS_AINA () {0x;}' unless defined(&AUDIO_MMR2_BITS_AINA);
    eval 'sub AUDIO_MMR2_BITS_AINB () {0x1;}' unless defined(&AUDIO_MMR2_BITS_AINB);
    eval 'sub AUDIO_MMR2_BITS_EAR () {0x;}' unless defined(&AUDIO_MMR2_BITS_EAR);
    eval 'sub AUDIO_MMR2_BITS_LS () {0x2;}' unless defined(&AUDIO_MMR2_BITS_LS);
    eval 'sub AUDIO_MMR2_BITS_DTMF () {0x4;}' unless defined(&AUDIO_MMR2_BITS_DTMF);
    eval 'sub AUDIO_MMR2_BITS_TONE () {0x8;}' unless defined(&AUDIO_MMR2_BITS_TONE);
    eval 'sub AUDIO_MMR2_BITS_RINGER () {0x10;}' unless defined(&AUDIO_MMR2_BITS_RINGER);
    eval 'sub AUDIO_MMR2_BITS_HIGH_PASS () {0x20;}' unless defined(&AUDIO_MMR2_BITS_HIGH_PASS);
    eval 'sub AUDIO_MMR2_BITS_AUTOZERO () {0x40;}' unless defined(&AUDIO_MMR2_BITS_AUTOZERO);
    if(defined(&__cplusplus)) {
    }
}
1;
