require '_h2ph_pre.ph';

no warnings 'redefine';

# "@(#)bdio.h	6.1 of 29 Feb 1996 SMI"
unless(defined(&_SYS_BDIO_H)) {
    eval 'sub _SYS_BDIO_H () {1;}' unless defined(&_SYS_BDIO_H);
    require 'sys/ioccom.ph';
    eval 'sub DIAL_DEVID () {0x7b;}' unless defined(&DIAL_DEVID);
    eval 'sub NDIALS () {8;}' unless defined(&NDIALS);
    eval 'sub DIAL_DELTA {
        my($dialnum) = @_;
	    eval q(( &vuid_first( &DIAL_DEVID) + ($dialnum)));
    }' unless defined(&DIAL_DELTA);
    eval 'sub DIAL_NUMBER {
        my($event_code) = @_;
	    eval q(($event_code & 0xff));
    }' unless defined(&DIAL_NUMBER);
    eval 'sub event_is_dial {
        my($event) = @_;
	    eval q(( &vuid_in_range( &DIAL_DEVID,  ($event->{ie_code}))));
    }' unless defined(&event_is_dial);
    eval 'sub DIAL_UNITS_PER_DEGREE () {64;}' unless defined(&DIAL_UNITS_PER_DEGREE);
    eval 'sub DIAL_UNITS_PER_CYCLE () {(360*  &DIAL_UNITS_PER_DEGREE);}' unless defined(&DIAL_UNITS_PER_CYCLE);
    eval 'sub DIAL_TO_DEGREES {
        my($n) = @_;
	    eval q((($n) /  &DIAL_UNITS_PER_DEGREE));
    }' unless defined(&DIAL_TO_DEGREES);
    eval 'sub DIAL_TO_RADIANS {
        my($n) = @_;
	    eval q((( * 2.0*  &M_PI) /  &DIAL_UNITS_PER_CYCLE));
    }' unless defined(&DIAL_TO_RADIANS);
    eval 'sub BUTTON_DEVID () {0x7a;}' unless defined(&BUTTON_DEVID);
    eval 'sub NBUTTON () {32;}' unless defined(&NBUTTON);
    eval 'sub BDIOC () {(ord(\'B\')<<8);}' unless defined(&BDIOC);
    eval 'sub BDIOBUTLITE () {( &BDIOC|1);}' unless defined(&BDIOBUTLITE);
    eval 'sub event_is_32_button {
        my($event) = @_;
	    eval q(( &vuid_in_range( &BUTTON_DEVID,  ($event->{ie_code}))));
    }' unless defined(&event_is_32_button);
    eval 'sub BUTTON_MAP {
        my($butnum) = @_;
	    eval q(($butnum));
    }' unless defined(&BUTTON_MAP);
    eval 'sub LED_MAP {
        my($butnum) = @_;
	    eval q((1<< ($butnum - 1)));
    }' unless defined(&LED_MAP);
    undef(&VUIOC) if defined(&VUIOC);
    undef(&VUIDSFORMAT) if defined(&VUIDSFORMAT);
    undef(&VUIDGFORMAT) if defined(&VUIDGFORMAT);
    eval 'sub VUIOC () {(ord(\'v\')<<8);}' unless defined(&VUIOC);
    eval 'sub VUIDSFORMAT () {( &VUIOC|1);}' unless defined(&VUIDSFORMAT);
    eval 'sub VUIDGFORMAT () {( &VUIOC|2);}' unless defined(&VUIDGFORMAT);
}
1;
