require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_BITMAP_H)) {
    eval 'sub _SYS_BITMAP_H () {1;}' unless defined(&_SYS_BITMAP_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_LP64)) {
	eval 'sub BT_ULSHIFT () {6;}' unless defined(&BT_ULSHIFT);
    } else {
	eval 'sub BT_ULSHIFT () {5;}' unless defined(&BT_ULSHIFT);
    }
    eval 'sub BT_NBIPUL () {(1<<  &BT_ULSHIFT);}' unless defined(&BT_NBIPUL);
    eval 'sub BT_ULMASK () {( &BT_NBIPUL - 1);}' unless defined(&BT_ULMASK);
    if(defined(&_LP64)) {
	eval 'sub BT_ULMAXMASK () {1.84467440737096e+19;}' unless defined(&BT_ULMAXMASK);
    } else {
	eval 'sub BT_ULMAXMASK () {0xffffffff;}' unless defined(&BT_ULMAXMASK);
    }
    eval 'sub BT_WIM {
        my($bitmap, $bitindex) = @_;
	    eval q((($bitmap)[($bitindex) >>  &BT_ULSHIFT]));
    }' unless defined(&BT_WIM);
    eval 'sub BT_BIW {
        my($bitindex) = @_;
	    eval q((1 << (($bitindex) &  &BT_ULMASK)));
    }' unless defined(&BT_BIW);
    eval 'sub BT_BITOUL {
        my($nbits) = @_;
	    eval q(((($nbits) +  &BT_NBIPUL - 1) /  &BT_NBIPUL));
    }' unless defined(&BT_BITOUL);
    eval 'sub BT_TEST {
        my($bitmap, $bitindex) = @_;
	    eval q((( &BT_WIM(($bitmap), ($bitindex)) &  &BT_BIW($bitindex)) ? 1: 0));
    }' unless defined(&BT_TEST);
    eval 'sub BT_SET {
        my($bitmap, $bitindex) = @_;
	    eval q({  &BT_WIM(($bitmap), ($bitindex)) |=  &BT_BIW($bitindex); });
    }' unless defined(&BT_SET);
    eval 'sub BT_CLEAR {
        my($bitmap, $bitindex) = @_;
	    eval q({  &BT_WIM(($bitmap), ($bitindex)) &= ~ &BT_BIW($bitindex); });
    }' unless defined(&BT_CLEAR);
    if(defined( &_KERNEL)  && !defined( &_ASM)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
