require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_BPP_REG_H)) {
    eval 'sub _SYS_BPP_REG_H () {1;}' unless defined(&_SYS_BPP_REG_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub BPP_INT_PEND () {0x1;}' unless defined(&BPP_INT_PEND);
    eval 'sub BPP_ERR_PEND () {0x2;}' unless defined(&BPP_ERR_PEND);
    eval 'sub BPP_DRAINING () {0xc;}' unless defined(&BPP_DRAINING);
    eval 'sub BPP_INT_EN () {0x10;}' unless defined(&BPP_INT_EN);
    eval 'sub BPP_FLUSH () {0x20;}' unless defined(&BPP_FLUSH);
    eval 'sub BPP_SLAVE_ERR () {0x40;}' unless defined(&BPP_SLAVE_ERR);
    eval 'sub BPP_RESET_BPP () {0x80;}' unless defined(&BPP_RESET_BPP);
    eval 'sub BPP_READ () {0x100;}' unless defined(&BPP_READ);
    eval 'sub BPP_ENABLE_DMA () {0x200;}' unless defined(&BPP_ENABLE_DMA);
    eval 'sub BPP_ENABLE_BCNT () {0x2000;}' unless defined(&BPP_ENABLE_BCNT);
    eval 'sub BPP_TERMINAL_CNT () {0x4000;}' unless defined(&BPP_TERMINAL_CNT);
    eval 'sub BPP_BURST_SIZES_MASK () {0xc0000;}' unless defined(&BPP_BURST_SIZES_MASK);
    eval 'sub BPP_TC_INTR_DISABLE () {0x800000;}' unless defined(&BPP_TC_INTR_DISABLE);
    eval 'sub BPP_EN_CHAIN_DMA () {0x1000000;}' unless defined(&BPP_EN_CHAIN_DMA);
    eval 'sub BPP_DMA_ON () {0x2000000;}' unless defined(&BPP_DMA_ON);
    eval 'sub BPP_ADDR_VALID () {0x4000000;}' unless defined(&BPP_ADDR_VALID);
    eval 'sub BPP_NEXT_VALID () {0x8000000;}' unless defined(&BPP_NEXT_VALID);
    eval 'sub BPP_DEVICE_ID_MASK () {0xf0000000;}' unless defined(&BPP_DEVICE_ID_MASK);
    eval 'sub BPP_BURST_4WORD () {0x;}' unless defined(&BPP_BURST_4WORD);
    eval 'sub BPP_BURST_16BYTE () { &BPP_BURST_4WORD;}' unless defined(&BPP_BURST_16BYTE);
    eval 'sub BPP_BURST_DEFAULT () { &BPP_BURST_4WORD;}' unless defined(&BPP_BURST_DEFAULT);
    eval 'sub BPP_BURST_8WORD () {0x40000;}' unless defined(&BPP_BURST_8WORD);
    eval 'sub BPP_BURST_32BYTE () { &BPP_BURST_8WORD;}' unless defined(&BPP_BURST_32BYTE);
    eval 'sub BPP_BURST_1WORD () {0x80000;}' unless defined(&BPP_BURST_1WORD);
    eval 'sub BPP_BURST_4BYTE () { &BPP_BURST_1WORD;}' unless defined(&BPP_BURST_4BYTE);
    eval 'sub BPP_BURST_NOBURST () { &BPP_BURST_1WORD;}' unless defined(&BPP_BURST_NOBURST);
    eval 'sub BPP_HIOD_DEVID () {0x40000000;}' unless defined(&BPP_HIOD_DEVID);
    eval 'sub BPP_DMA2P_DEVID () {0xa0000000;}' unless defined(&BPP_DMA2P_DEVID);
    eval 'sub BPP_MAX_DMA () {0x1000000;}' unless defined(&BPP_MAX_DMA);
    eval 'sub BPP_DSS_MASK () {0x7f;}' unless defined(&BPP_DSS_MASK);
    eval 'sub BPP_DSS_SIZE () {0x7f;}' unless defined(&BPP_DSS_SIZE);
    eval 'sub BPP_DSW_MASK () {0x7f00;}' unless defined(&BPP_DSW_MASK);
    eval 'sub BPP_DSW_SIZE () {0x7f;}' unless defined(&BPP_DSW_SIZE);
    eval 'sub BPP_CNTR_TEST () {0x8000;}' unless defined(&BPP_CNTR_TEST);
    eval 'sub BPP_SEVEN_BITS () {0x7f;}' unless defined(&BPP_SEVEN_BITS);
    eval 'sub BPP_EN_VERSATEC () {0x1;}' unless defined(&BPP_EN_VERSATEC);
    eval 'sub BPP_VERSATEC_INTERLOCK () {0x2;}' unless defined(&BPP_VERSATEC_INTERLOCK);
    eval 'sub BPP_IDLE () {0x8;}' unless defined(&BPP_IDLE);
    eval 'sub BPP_SRST () {0x80;}' unless defined(&BPP_SRST);
    eval 'sub BPP_ACK_OP () {0x100;}' unless defined(&BPP_ACK_OP);
    eval 'sub BPP_BUSY_OP () {0x200;}' unless defined(&BPP_BUSY_OP);
    eval 'sub BPP_EN_DIAG () {0x400;}' unless defined(&BPP_EN_DIAG);
    eval 'sub BPP_ACK_BIDIR () {0x800;}' unless defined(&BPP_ACK_BIDIR);
    eval 'sub BPP_BUSY_BIDIR () {0x1000;}' unless defined(&BPP_BUSY_BIDIR);
    eval 'sub BPP_DS_BIDIR () {0x2000;}' unless defined(&BPP_DS_BIDIR);
    eval 'sub BPP_DMA_DATA () {0x4000;}' unless defined(&BPP_DMA_DATA);
    eval 'sub BPP_EN_MEM_CLR () {0x8000;}' unless defined(&BPP_EN_MEM_CLR);
    eval 'sub BPP_DS_PIN () {0x1;}' unless defined(&BPP_DS_PIN);
    eval 'sub BPP_ACK_PIN () {0x2;}' unless defined(&BPP_ACK_PIN);
    eval 'sub BPP_BUSY_PIN () {0x4;}' unless defined(&BPP_BUSY_PIN);
    eval 'sub BPP_DIRECTION () {0x8;}' unless defined(&BPP_DIRECTION);
    eval 'sub BPP_ERR_IRQ_EN () {0x1;}' unless defined(&BPP_ERR_IRQ_EN);
    eval 'sub BPP_ERR_IRP () {0x2;}' unless defined(&BPP_ERR_IRP);
    eval 'sub BPP_SLCT_IRQ_EN () {0x4;}' unless defined(&BPP_SLCT_IRQ_EN);
    eval 'sub BPP_SLCT_IRP () {0x8;}' unless defined(&BPP_SLCT_IRP);
    eval 'sub BPP_PE_IRQ_EN () {0x10;}' unless defined(&BPP_PE_IRQ_EN);
    eval 'sub BPP_PE_IRP () {0x20;}' unless defined(&BPP_PE_IRP);
    eval 'sub BPP_BUSY_IRQ_EN () {0x40;}' unless defined(&BPP_BUSY_IRQ_EN);
    eval 'sub BPP_BUSY_IRP () {0x80;}' unless defined(&BPP_BUSY_IRP);
    eval 'sub BPP_ACK_IRQ_EN () {0x100;}' unless defined(&BPP_ACK_IRQ_EN);
    eval 'sub BPP_DS_IRQ_EN () {0x200;}' unless defined(&BPP_DS_IRQ_EN);
    eval 'sub BPP_ERR_IRQ () {0x400;}' unless defined(&BPP_ERR_IRQ);
    eval 'sub BPP_SLCT_IRQ () {0x800;}' unless defined(&BPP_SLCT_IRQ);
    eval 'sub BPP_PE_IRQ () {0x1000;}' unless defined(&BPP_PE_IRQ);
    eval 'sub BPP_BUSY_IRQ () {0x2000;}' unless defined(&BPP_BUSY_IRQ);
    eval 'sub BPP_ACK_IRQ () {0x4000;}' unless defined(&BPP_ACK_IRQ);
    eval 'sub BPP_DS_IRQ () {0x8000;}' unless defined(&BPP_DS_IRQ);
    eval 'sub BPP_ALL_IRQS () {( &BPP_ERR_IRQ |  &BPP_SLCT_IRQ |  &BPP_PE_IRQ |  &BPP_BUSY_IRQ |  &BPP_ACK_IRQ |  &BPP_DS_IRQ);}' unless defined(&BPP_ALL_IRQS);
    if(defined(&__cplusplus)) {
    }
}
1;
