require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CG6REG_H)) {
    eval 'sub _SYS_CG6REG_H () {1;}' unless defined(&_SYS_CG6REG_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub CG6_P4BASE () {0xfb000000;}' unless defined(&CG6_P4BASE);
    eval 'sub CG6_ADDR_ROM_SBUS () {0;}' unless defined(&CG6_ADDR_ROM_SBUS);
    eval 'sub CG6_ADDR_ROM_P4 () {0x380000;}' unless defined(&CG6_ADDR_ROM_P4);
    eval 'sub CG6_ADDR_CMAP () {0x200000;}' unless defined(&CG6_ADDR_CMAP);
    eval 'sub CG6_ADDR_DHC () {0x240000;}' unless defined(&CG6_ADDR_DHC);
    eval 'sub CG6_ADDR_ALT () {0x280000;}' unless defined(&CG6_ADDR_ALT);
    eval 'sub CG6_ADDR_FBC () {0x700000;}' unless defined(&CG6_ADDR_FBC);
    eval 'sub CG6_ADDR_TEC () {0x701000;}' unless defined(&CG6_ADDR_TEC);
    eval 'sub CG6_ADDR_P4REG () {0x300000;}' unless defined(&CG6_ADDR_P4REG);
    eval 'sub CG6_ADDR_OVERLAY () {0x400000;}' unless defined(&CG6_ADDR_OVERLAY);
    eval 'sub CG6_ADDR_FHC () {0x300000;}' unless defined(&CG6_ADDR_FHC);
    eval 'sub CG6_ADDR_THC () {0x301000;}' unless defined(&CG6_ADDR_THC);
    eval 'sub CG6_ADDR_ENABLE () {0x600000;}' unless defined(&CG6_ADDR_ENABLE);
    eval 'sub CG6_ADDR_COLOR () {0x800000;}' unless defined(&CG6_ADDR_COLOR);
    eval 'sub CG6_ADDR_FBCTEC () { &CG6_ADDR_FBC;}' unless defined(&CG6_ADDR_FBCTEC);
    eval 'sub CG6_ADDR_FHCTHC () { &CG6_ADDR_FHC;}' unless defined(&CG6_ADDR_FHCTHC);
    eval 'sub CG6_CMAP_SZ () {8192;}' unless defined(&CG6_CMAP_SZ);
    eval 'sub CG6_FBCTEC_SZ () {8192;}' unless defined(&CG6_FBCTEC_SZ);
    eval 'sub CG6_FHCTHC_SZ () {8192;}' unless defined(&CG6_FHCTHC_SZ);
    eval 'sub CG6_ROM_SZ () {(64*1024);}' unless defined(&CG6_ROM_SZ);
    eval 'sub CG6_FB_SZ () {(1024*1024);}' unless defined(&CG6_FB_SZ);
    eval 'sub CG6_DHC_SZ () {8192;}' unless defined(&CG6_DHC_SZ);
    eval 'sub CG6_ALT_SZ () {8192;}' unless defined(&CG6_ALT_SZ);
    eval 'sub CG6_TEC_POFF () {0x1000;}' unless defined(&CG6_TEC_POFF);
    eval 'sub CG6_THC_POFF () {0x1000;}' unless defined(&CG6_THC_POFF);
    eval 'sub CG6_VBASE () {0x70000000;}' unless defined(&CG6_VBASE);
    eval 'sub CG6_VADDR {
        my($x) = @_;
	    eval q(( &CG6_VBASE + ($x) * 8192));
    }' unless defined(&CG6_VADDR);
    eval 'sub CG6_VADDR_FBC () { &CG6_VADDR(0);}' unless defined(&CG6_VADDR_FBC);
    eval 'sub CG6_VADDR_TEC () {( &CG6_VADDR_FBC +  &CG6_TEC_POFF);}' unless defined(&CG6_VADDR_TEC);
    eval 'sub CG6_VADDR_CMAP () { &CG6_VADDR(1);}' unless defined(&CG6_VADDR_CMAP);
    eval 'sub CG6_VADDR_FHC () { &CG6_VADDR(2);}' unless defined(&CG6_VADDR_FHC);
    eval 'sub CG6_VADDR_THC () {( &CG6_VADDR_FHC +  &CG6_THC_POFF);}' unless defined(&CG6_VADDR_THC);
    eval 'sub CG6_VADDR_ROM () { &CG6_VADDR(3);}' unless defined(&CG6_VADDR_ROM);
    eval 'sub CG6_VADDR_COLOR () {( &CG6_VADDR_ROM +  &CG6_ROM_SZ);}' unless defined(&CG6_VADDR_COLOR);
    eval 'sub CG6_VADDR_DHC () { &CG6_VADDR(16384);}' unless defined(&CG6_VADDR_DHC);
    eval 'sub CG6_VADDR_ALT () { &CG6_VADDR(16385);}' unless defined(&CG6_VADDR_ALT);
    eval 'sub CG6_VADDR_UART () { &CG6_VADDR(16386);}' unless defined(&CG6_VADDR_UART);
    eval 'sub CG6_VADDR_VRT () { &CG6_VADDR(16387);}' unless defined(&CG6_VADDR_VRT);
    eval 'sub CG6_VADDR_FBCTEC () { &CG6_VADDR_FBC;}' unless defined(&CG6_VADDR_FBCTEC);
    eval 'sub CG6_VADDR_FHCTHC () { &CG6_VADDR_FHC;}' unless defined(&CG6_VADDR_FHCTHC);
    eval 'sub MMAPSIZE {
        my($dfbsize) = @_;
	    eval q(( &CG6_VADDR_COLOR- &CG6_VBASE+$dfbsize));
    }' unless defined(&MMAPSIZE);
    eval 'sub CG6VA_TO_FBC {
        my($base) = @_;
	    eval q(((($base)+( &CG6_VADDR_FBC- &CG6_VBASE))));
    }' unless defined(&CG6VA_TO_FBC);
    eval 'sub CG6VA_TO_TEC {
        my($base) = @_;
	    eval q(((($base)+( &CG6_VADDR_TEC- &CG6_VBASE))));
    }' unless defined(&CG6VA_TO_TEC);
    eval 'sub CG6VA_TO_FHC {
        my($base) = @_;
	    eval q((( &uint_t *)(($base)+( &CG6_VADDR_FHC- &CG6_VBASE))));
    }' unless defined(&CG6VA_TO_FHC);
    eval 'sub CG6VA_TO_THC {
        my($base) = @_;
	    eval q(((($base)+( &CG6_VADDR_THC- &CG6_VBASE))));
    }' unless defined(&CG6VA_TO_THC);
    eval 'sub CG6VA_TO_DFB {
        my($base) = @_;
	    eval q(((($base)+( &CG6_VADDR_COLOR- &CG6_VBASE))));
    }' unless defined(&CG6VA_TO_DFB);
    eval 'sub CG6VA_TO_ROM {
        my($base) = @_;
	    eval q((( &uint_t *)(($base)+( &CG6_VADDR_ROM- &CG6_VBASE))));
    }' unless defined(&CG6VA_TO_ROM);
    eval 'sub CG6VA_TO_CMAP {
        my($base) = @_;
	    eval q(((($base)+( &CG6_VADDR_CMAP- &CG6_VBASE))));
    }' unless defined(&CG6VA_TO_CMAP);
    eval 'sub CG6_CMAP_ENTRIES () {256;}' unless defined(&CG6_CMAP_ENTRIES);
    if(defined(&__cplusplus)) {
    }
}
1;
