require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CG6VAR_H)) {
    eval 'sub _SYS_CG6VAR_H () {1;}' unless defined(&_SYS_CG6VAR_H);
    if(defined(&__cplusplus)) {
    }
    unless(defined(&FBC_REV0)) {
	eval 'sub FBC_REV0 () {1;}' unless defined(&FBC_REV0);
    }
    require 'sys/cg6fbc.ph';
    require 'sys/cg6tec.ph';
    require 'sys/cg6thc.ph';
    eval 'sub CG6_DEPTH () {8;}' unless defined(&CG6_DEPTH);
    require 'sys/memvar.ph';
    require 'sys/pr_impl_util.ph';
    eval 'sub FB_ATTR_CG6_SETOWNER_CMD () {0;}' unless defined(&FB_ATTR_CG6_SETOWNER_CMD);
    eval 'sub FB_ATTR_CG6_SETOWNER_PID () {1;}' unless defined(&FB_ATTR_CG6_SETOWNER_PID);
    unless(defined(&_KERNEL)) {
	eval 'sub cg6_d {
	    my($pr) = @_;
    	    eval q((($pr)-> &pr_data));
	}' unless defined(&cg6_d);
	eval 'sub cg6_waitidle {
	    my($fbc) = @_;
    	    eval q( &do {; }  &while (($fbc)-> &l_fbc_status &  &L_FBC_BUSY));
	}' unless defined(&cg6_waitidle);
	eval 'sub cg6_setfontxy {
	    my($fbc, $x0, $x1, $y) = @_;
    	    eval q((($fbc)-> &l_fbc_x0 = ($x0), ($fbc)-> &l_fbc_x1 = ($x1), ($fbc)-> &l_fbc_y0 = ($y)));
	}' unless defined(&cg6_setfontxy);
	eval 'sub cg6_setinx {
	    my($fbc, $x, $y) = @_;
    	    eval q((($fbc)-> &l_fbc_autoincx = ($x), ($fbc)-> &l_fbc_autoincy = ($y)));
	}' unless defined(&cg6_setinx);
	eval 'sub cg6_draw_done {
	    my($fbc, $r) = @_;
    	    eval q( &do = -> &l_fbc_drawstatus;  &while (($r) < 0 && ($r &  &L_FBC_FULL)));
	}' unless defined(&cg6_draw_done);
	eval 'sub cg6_clip {
	    my($fbc, $x_min, $y_min, $x_max, $y_max) = @_;
    	    eval q((($fbc)-> &l_fbc_clipminx = ($x_min), ($fbc)-> &l_fbc_clipminy = ($y_min), ($fbc)-> &l_fbc_clipmaxx = ($x_max), ($fbc)-> &l_fbc_clipmaxy = ($y_max)));
	}' unless defined(&cg6_clip);
	eval 'sub cg6_color_mode {
	    my($fbc, $mode) = @_;
    	    eval q((* (( &uint32_t *)($fbc)-> &l_fbc_misc) = ( &uint32_t) &L_FBC_MISC_BLIT_NOSRC << 20| (( &uint32_t)($mode) & 3) << 17| ( &uint32_t) &L_FBC_MISC_DRAW_RENDER << 15));
	}' unless defined(&cg6_color_mode);
	eval 'sub cg6_setregs {
	    my($fbc, $x, $y, $rop, $planemask, $fcolor, $patt, $polyg) = @_;
    	    eval q( &_STMT( ($fbc)-> &l_fbc_rasteroffx = ($x); ($fbc)-> &l_fbc_rasteroffy = ($y); ($fbc)-> &l_fbc_fcolor = ($fcolor);  &cg6_waitidle($fbc); ($fbc)-> &l_fbc_status = 0; * (( &uint32_t *)($fbc)-> &l_fbc_rasterop) = (( &uint32_t)($patt) & 3) << 26| (( &uint32_t)($polyg) & 3) << 24| ( &uint32_t) &L_FBC_RASTEROP_ATTR_SUPP << 22| ( &uint32_t) &L_FBC_RASTEROP_RAST_BOOL << 17| ( &uint32_t) $cg6_rop_table[($rop)]; ($fbc)-> &l_fbc_planemask = ($planemask); ($fbc)-> &l_fbc_clipcheck = 0; ));
	}' unless defined(&cg6_setregs);
	if((defined(&FBC_REV0) ? &FBC_REV0 : 0)) {
	    eval 'sub fbc_rev0 {
	        my($fbc) = @_;
    		eval q((((($fbc))[1] & 0xf0) == 0));
	    }' unless defined(&fbc_rev0);
	    eval 'sub cg6_draw_done0 {
	        my($fbc, $x0, $x1, $r) = @_;
    		eval q( &if ((($fbc)-> &l_fbc_status &  &L_FBC_DRAW_INTERSECT)  && (($x0) < 0|| ($x1) < 0)) ($r) =  &L_FBC_DRAW_EXCEPTION;  &else  &cg6_draw_done(($fbc), ($r)));
	    }' unless defined(&cg6_draw_done0);
	} else {
	    eval 'sub fbc_rev0 {
	        my($fbc) = @_;
    		eval q((0));
	    }' unless defined(&fbc_rev0);
	    eval 'sub cg6_draw_done0 {
	        my($fbc, $x0, $x1, $r) = @_;
    		eval q( &cg6_draw_done(($fbc), ($r)));
	    }' unless defined(&cg6_draw_done0);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
