require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_CIS_H)) {
    eval 'sub _CIS_H () {1;}' unless defined(&_CIS_H);
    if(defined(&__cplusplus)) {
    }
    if(defined( &DEBUG)) {
	eval 'sub CIS_DEBUG () {1;}' unless defined(&CIS_DEBUG);
    }
    eval 'sub CISP_CIS_SETUP () {0x1;}' unless defined(&CISP_CIS_SETUP);
    eval 'sub CISP_CIS_LIST_CREATE () {0x2;}' unless defined(&CISP_CIS_LIST_CREATE);
    eval 'sub CISP_CIS_LIST_DESTROY () {0x3;}' unless defined(&CISP_CIS_LIST_DESTROY);
    eval 'sub CISP_CIS_GET_LTUPLE () {0x4;}' unless defined(&CISP_CIS_GET_LTUPLE);
    eval 'sub CISP_CIS_PARSE_TUPLE () {0x5;}' unless defined(&CISP_CIS_PARSE_TUPLE);
    eval 'sub CISP_CIS_CONV_DEVSPEED () {0x6;}' unless defined(&CISP_CIS_CONV_DEVSPEED);
    eval 'sub CISP_CIS_CONV_DEVSIZE () {0x7;}' unless defined(&CISP_CIS_CONV_DEVSIZE);
    eval 'sub CIS_CARD_SERVICES () {(* &cis_card_services);}' unless defined(&CIS_CARD_SERVICES);
    eval 'sub CISTPL_NULL () {0x;}' unless defined(&CISTPL_NULL);
    eval 'sub CISTPL_DEVICE () {0x1;}' unless defined(&CISTPL_DEVICE);
    eval 'sub CISTPL_LONGLINK_CB () {0x2;}' unless defined(&CISTPL_LONGLINK_CB);
    eval 'sub CISTPL_CONFIG_CB () {0x4;}' unless defined(&CISTPL_CONFIG_CB);
    eval 'sub CISTPL_CFTABLE_ENTRY_CB () {0x5;}' unless defined(&CISTPL_CFTABLE_ENTRY_CB);
    eval 'sub CISTPL_LONGLINK_MFC () {0x6;}' unless defined(&CISTPL_LONGLINK_MFC);
    eval 'sub CISTPL_BAR () {0x7;}' unless defined(&CISTPL_BAR);
    eval 'sub CISTPL_CHECKSUM () {0x10;}' unless defined(&CISTPL_CHECKSUM);
    eval 'sub CISTPL_LONGLINK_A () {0x11;}' unless defined(&CISTPL_LONGLINK_A);
    eval 'sub CISTPL_LONGLINK_C () {0x12;}' unless defined(&CISTPL_LONGLINK_C);
    eval 'sub CISTPL_LINKTARGET () {0x13;}' unless defined(&CISTPL_LINKTARGET);
    eval 'sub CISTPL_NO_LINK () {0x14;}' unless defined(&CISTPL_NO_LINK);
    eval 'sub CISTPL_VERS_1 () {0x15;}' unless defined(&CISTPL_VERS_1);
    eval 'sub CISTPL_ALTSTR () {0x16;}' unless defined(&CISTPL_ALTSTR);
    eval 'sub CISTPL_DEVICE_A () {0x17;}' unless defined(&CISTPL_DEVICE_A);
    eval 'sub CISTPL_JEDEC_C () {0x18;}' unless defined(&CISTPL_JEDEC_C);
    eval 'sub CISTPL_JEDEC_A () {0x19;}' unless defined(&CISTPL_JEDEC_A);
    eval 'sub CISTPL_CONFIG () {0x1a;}' unless defined(&CISTPL_CONFIG);
    eval 'sub CISTPL_CFTABLE_ENTRY () {0x1b;}' unless defined(&CISTPL_CFTABLE_ENTRY);
    eval 'sub CISTPL_DEVICE_OC () {0x1c;}' unless defined(&CISTPL_DEVICE_OC);
    eval 'sub CISTPL_DEVICE_OA () {0x1d;}' unless defined(&CISTPL_DEVICE_OA);
    eval 'sub CISTPL_DEVICEGEO () {0x1e;}' unless defined(&CISTPL_DEVICEGEO);
    eval 'sub CISTPL_DEVICEGEO_A () {0x1f;}' unless defined(&CISTPL_DEVICEGEO_A);
    eval 'sub CISTPL_MANFID () {0x20;}' unless defined(&CISTPL_MANFID);
    eval 'sub CISTPL_FUNCID () {0x21;}' unless defined(&CISTPL_FUNCID);
    eval 'sub CISTPL_FUNCE () {0x22;}' unless defined(&CISTPL_FUNCE);
    eval 'sub CISTPL_SWIL () {0x23;}' unless defined(&CISTPL_SWIL);
    eval 'sub CISTPL_VERS_2 () {0x40;}' unless defined(&CISTPL_VERS_2);
    eval 'sub CISTPL_FORMAT () {0x41;}' unless defined(&CISTPL_FORMAT);
    eval 'sub CISTPL_GEOMETRY () {0x42;}' unless defined(&CISTPL_GEOMETRY);
    eval 'sub CISTPL_BYTEORDER () {0x43;}' unless defined(&CISTPL_BYTEORDER);
    eval 'sub CISTPL_DATE () {0x44;}' unless defined(&CISTPL_DATE);
    eval 'sub CISTPL_BATTERY () {0x45;}' unless defined(&CISTPL_BATTERY);
    eval 'sub CISTPL_FORMAT_A () {0x47;}' unless defined(&CISTPL_FORMAT_A);
    eval 'sub CISTPL_ORG () {0x46;}' unless defined(&CISTPL_ORG);
    eval 'sub CISTPL_VEND_SPEC_80 () {0x80;}' unless defined(&CISTPL_VEND_SPEC_80);
    eval 'sub CISTPL_VEND_SPEC_81 () {0x81;}' unless defined(&CISTPL_VEND_SPEC_81);
    eval 'sub CISTPL_VEND_SPEC_82 () {0x82;}' unless defined(&CISTPL_VEND_SPEC_82);
    eval 'sub CISTPL_VEND_SPEC_83 () {0x83;}' unless defined(&CISTPL_VEND_SPEC_83);
    eval 'sub CISTPL_VEND_SPEC_84 () {0x84;}' unless defined(&CISTPL_VEND_SPEC_84);
    eval 'sub CISTPL_VEND_SPEC_85 () {0x85;}' unless defined(&CISTPL_VEND_SPEC_85);
    eval 'sub CISTPL_VEND_SPEC_86 () {0x86;}' unless defined(&CISTPL_VEND_SPEC_86);
    eval 'sub CISTPL_VEND_SPEC_87 () {0x87;}' unless defined(&CISTPL_VEND_SPEC_87);
    eval 'sub CISTPL_VEND_SPEC_88 () {0x88;}' unless defined(&CISTPL_VEND_SPEC_88);
    eval 'sub CISTPL_VEND_SPEC_89 () {0x89;}' unless defined(&CISTPL_VEND_SPEC_89);
    eval 'sub CISTPL_VEND_SPEC_8a () {0x8a;}' unless defined(&CISTPL_VEND_SPEC_8a);
    eval 'sub CISTPL_VEND_SPEC_8b () {0x8b;}' unless defined(&CISTPL_VEND_SPEC_8b);
    eval 'sub CISTPL_VEND_SPEC_8c () {0x8c;}' unless defined(&CISTPL_VEND_SPEC_8c);
    eval 'sub CISTPL_VEND_SPEC_8d () {0x8d;}' unless defined(&CISTPL_VEND_SPEC_8d);
    eval 'sub CISTPL_VEND_SPEC_8e () {0x8e;}' unless defined(&CISTPL_VEND_SPEC_8e);
    eval 'sub CISTPL_VEND_SPEC_8f () {0x8f;}' unless defined(&CISTPL_VEND_SPEC_8f);
    eval 'sub CISTPL_SPCL () {0x90;}' unless defined(&CISTPL_SPCL);
    eval 'sub CISTPL_END () {0xff;}' unless defined(&CISTPL_END);
    eval 'sub CISTPL_VENDSPEC_START () { &CISTPL_VEND_SPEC_80;}' unless defined(&CISTPL_VENDSPEC_START);
    eval 'sub CISTPL_VENDSPEC_END () { &CISTPL_VEND_SPEC_8f;}' unless defined(&CISTPL_VENDSPEC_END);
    eval 'sub CISTPL_IS_VENDOR_SPECIFIC {
        my($td) = @_;
	    eval q(((($td) >=  &CISTPL_VENDSPEC_START)  && (($td) <=  &CISTPL_VENDSPEC_END)));
    }' unless defined(&CISTPL_IS_VENDOR_SPECIFIC);
    eval 'sub RETURN_FIRST_TUPLE () {0xff;}' unless defined(&RETURN_FIRST_TUPLE);
    eval 'sub RETURN_NEXT_TUPLE () {0xff;}' unless defined(&RETURN_NEXT_TUPLE);
    eval 'sub CIS_MAX_TUPLE_DATA_LEN () {254;}' unless defined(&CIS_MAX_TUPLE_DATA_LEN);
    eval 'sub CIS_MAX_TUPLE_NAME_LEN () {40;}' unless defined(&CIS_MAX_TUPLE_NAME_LEN);
    eval 'sub CIS_MAX_FUNCTIONS () {8;}' unless defined(&CIS_MAX_FUNCTIONS);
    eval 'sub NEXT_CIS_ADDR {
        my($ptr) = @_;
	    eval q(((( ($ptr->{flags})& &CISTPLF_AM_SPACE)?( ($ptr->{offset}) += 2): ( ($ptr->{offset})++)), (( ($ptr->{offset}) >  ($ptr->{size}))?( &NULL): ($ptr->{offset}))));
    }' unless defined(&NEXT_CIS_ADDR);
    eval 'sub GET_CIS_DATA {
        my($ptr) = @_;
	    eval q( &csx_Get8( ($ptr->{handle}),  ($ptr->{offset})));
    }' unless defined(&GET_CIS_DATA);
    eval 'sub GET_CIS_ADDR {
        my($tp) = @_;
	    eval q((( &cisdata_t *)($tp)-> &offset));
    }' unless defined(&GET_CIS_ADDR);
    eval 'sub BAD_CIS_ADDR () {0x80000000;}' unless defined(&BAD_CIS_ADDR);
    if(!defined( &_KERNEL)) {
	if(defined(&CISMALLOC_DEBUG)) {
	    eval 'sub CIS_MEM_ALLOC {
	        my($len) = @_;
    		eval q( &cis_malloc(( &uint32_t)$len));
	    }' unless defined(&CIS_MEM_ALLOC);
	    eval 'sub CIS_MEM_FREE {
	        my($ptr) = @_;
    		eval q( &cis_free($ptr));
	    }' unless defined(&CIS_MEM_FREE);
	} else {
	    eval 'sub CIS_MEM_ALLOC {
	        my($len) = @_;
    		eval q( &malloc(( &uint32_t)$len));
	    }' unless defined(&CIS_MEM_ALLOC);
	    eval 'sub CIS_MEM_FREE {
	        my($ptr) = @_;
    		eval q( &free($ptr));
	    }' unless defined(&CIS_MEM_FREE);
	}
    } else {
	eval 'sub CIS_MEM_ALLOC {
	    my($len) = @_;
    	    eval q( &cis_malloc(( &uint32_t)$len));
	}' unless defined(&CIS_MEM_ALLOC);
	eval 'sub CIS_MEM_FREE {
	    my($ptr) = @_;
    	    eval q( &cis_free($ptr));
	}' unless defined(&CIS_MEM_FREE);
    }
    eval 'sub CISTPLF_NOERROR () {0x;}' unless defined(&CISTPLF_NOERROR);
    eval 'sub CISTPLF_UNKNOWN () {0x1;}' unless defined(&CISTPLF_UNKNOWN);
    eval 'sub CISTPLF_REGS () {0x2;}' unless defined(&CISTPLF_REGS);
    eval 'sub CISTPLF_COPYOK () {0x4;}' unless defined(&CISTPLF_COPYOK);
    eval 'sub CISTPLF_VALID () {0x8;}' unless defined(&CISTPLF_VALID);
    eval 'sub CISTPLF_GLOBAL_CIS () {0x10;}' unless defined(&CISTPLF_GLOBAL_CIS);
    eval 'sub CISTPLF_MF_CIS () {0x20;}' unless defined(&CISTPLF_MF_CIS);
    eval 'sub CISTPLF_FROM_AM () {0x40;}' unless defined(&CISTPLF_FROM_AM);
    eval 'sub CISTPLF_FROM_CM () {0x80;}' unless defined(&CISTPLF_FROM_CM);
    eval 'sub CISTPLF_IGNORE_TUPLE () {0x100;}' unless defined(&CISTPLF_IGNORE_TUPLE);
    eval 'sub CISTPLF_VENDOR_SPECIFIC () {0x200;}' unless defined(&CISTPLF_VENDOR_SPECIFIC);
    eval 'sub CISTPLF_LINK_INVALID () {0x1000000;}' unless defined(&CISTPLF_LINK_INVALID);
    eval 'sub CISTPLF_PARAMS_INVALID () {0x2000000;}' unless defined(&CISTPLF_PARAMS_INVALID);
    eval 'sub CISTPLF_AM_SPACE () {0x10000000;}' unless defined(&CISTPLF_AM_SPACE);
    eval 'sub CISTPLF_CM_SPACE () {0x20000000;}' unless defined(&CISTPLF_CM_SPACE);
    eval 'sub CISTPLF_LM_SPACE () {0x40000000;}' unless defined(&CISTPLF_LM_SPACE);
    eval 'sub CISTPLF_MEM_ERR () {0x80000000;}' unless defined(&CISTPLF_MEM_ERR);
    eval 'sub CISTPLF_SPACE_MASK () {( &CISTPLF_AM_SPACE |  &CISTPLF_CM_SPACE |  &CISTPLF_LM_SPACE);}' unless defined(&CISTPLF_SPACE_MASK);
    eval 'sub CISTPLF_FROM_MASK () {( &CISTPLF_FROM_AM |  &CISTPLF_FROM_CM);}' unless defined(&CISTPLF_FROM_MASK);
    eval 'sub GET_FIRST_LTUPLEF () {0x1;}' unless defined(&GET_FIRST_LTUPLEF);
    eval 'sub GET_LAST_LTUPLEF () {0x2;}' unless defined(&GET_LAST_LTUPLEF);
    eval 'sub FIND_LTUPLE_FWDF () {0x3;}' unless defined(&FIND_LTUPLE_FWDF);
    eval 'sub FIND_LTUPLE_BACKF () {0x4;}' unless defined(&FIND_LTUPLE_BACKF);
    eval 'sub FIND_NEXT_LTUPLEF () {0x5;}' unless defined(&FIND_NEXT_LTUPLEF);
    eval 'sub FIND_PREV_LTUPLEF () {0x6;}' unless defined(&FIND_PREV_LTUPLEF);
    eval 'sub GET_NEXT_LTUPLEF () {0x7;}' unless defined(&GET_NEXT_LTUPLEF);
    eval 'sub GET_PREV_LTUPLEF () {0x8;}' unless defined(&GET_PREV_LTUPLEF);
    eval 'sub CIS_GET_LTUPLE_OPMASK () {0xffff;}' unless defined(&CIS_GET_LTUPLE_OPMASK);
    eval 'sub CIS_GET_LTUPLE_IGNORE () {0x10000;}' unless defined(&CIS_GET_LTUPLE_IGNORE);
    eval 'sub GET_CM_BYTE {
        my($tp) = @_;
	    eval q(((-> &len >= (-> ($read->{byte}) - ($tp)-> &data)) ? *($tp)-> ($read->{byte})++ : ( ($tp->{flags}) |=  &CISTPLF_MEM_ERR)));
    }' unless defined(&GET_CM_BYTE);
    eval 'sub GET_CM_SHORT {
        my($tp) = @_;
	    eval q(((-> &len >= ((-> ($read->{byte}) - ($tp)-> &data) + 1)) ? (*($tp)-> ($read->{byte})++ | (*($tp)-> ($read->{byte})++ << 8)) : ( ($tp->{flags}) |=  &CISTPLF_MEM_ERR)));
    }' unless defined(&GET_CM_SHORT);
    eval 'sub GET_CM_BE_SHORT {
        my($tp) = @_;
	    eval q(((-> &len >= ((-> ($read->{byte}) - ($tp)-> &data) + 1)) ? ((*($tp)-> ($read->{byte})++ << 8) | *($tp)-> ($read->{byte})++) : ( ($tp->{flags}) |=  &CISTPLF_MEM_ERR)));
    }' unless defined(&GET_CM_BE_SHORT);
    eval 'sub GET_CM_INT24 {
        my($tp) = @_;
	    eval q(( &GET_CM_SHORT($tp) | ( &GET_CM_BYTE($tp)<<16)));
    }' unless defined(&GET_CM_INT24);
    eval 'sub GET_CM_LONG {
        my($tp) = @_;
	    eval q(( &GET_CM_SHORT($tp) | ( &GET_CM_SHORT($tp) << 16)));
    }' unless defined(&GET_CM_LONG);
    eval 'sub GET_CM_LEN {
        my($tp) = @_;
	    eval q(( ($tp->{len}) - (-> ($read->{byte}) - ($tp)-> &data)));
    }' unless defined(&GET_CM_LEN);
    eval 'sub GET_AM_BYTE {
        my($tp) = @_;
	    eval q(((-> &len >= ((-> ($read->{byte}) - ($tp)-> &data))>>1) ? *( &cisdata_t *)($tp)-> ($read->{sword})++ : ( ($tp->{flags}) |=  &CISTPLF_MEM_ERR)));
    }' unless defined(&GET_AM_BYTE);
    eval 'sub GET_AM_SHORT {
        my($tp) = @_;
	    eval q(( &GET_AM_BYTE($tp) | ( &GET_AM_BYTE($tp) << 8)));
    }' unless defined(&GET_AM_SHORT);
    eval 'sub GET_AM_BE_SHORT {
        my($tp) = @_;
	    eval q((( &GET_AM_BYTE($tp) << 8) |  &GET_AM_BYTE($tp)));
    }' unless defined(&GET_AM_BE_SHORT);
    eval 'sub GET_AM_INT24 {
        my($tp) = @_;
	    eval q(( &GET_AM_SHORT($tp) | ( &GET_AM_BYTE($tp)<<16)));
    }' unless defined(&GET_AM_INT24);
    eval 'sub GET_AM_LONG {
        my($tp) = @_;
	    eval q(( &GET_AM_SHORT($tp) | ( &GET_AM_SHORT($tp) << 16)));
    }' unless defined(&GET_AM_LONG);
    eval 'sub GET_AM_LEN {
        my($tp) = @_;
	    eval q(( ($tp->{len}) - ((-> ($read->{byte}) - ($tp)-> &data) >> 1)));
    }' unless defined(&GET_AM_LEN);
    eval 'sub RESET_TP {
        my($tp) = @_;
	    eval q(($tp)-> ($read->{byte}) = ($tp)-> &data);
    }' unless defined(&RESET_TP);
    eval 'sub LOOK_BYTE {
        my($tp) = @_;
	    eval q(*($tp)-> ($read->{byte}));
    }' unless defined(&LOOK_BYTE);
    eval 'sub GET_BYTE_ADDR {
        my($tp) = @_;
	    eval q(($tp)-> ($read->{byte}));
    }' unless defined(&GET_BYTE_ADDR);
    eval 'sub GET_BYTE {
        my($tp) = @_;
	    eval q(((($tp)-> &flags &  &CISTPLF_AM_SPACE) ?  &GET_AM_BYTE($tp) :  &GET_CM_BYTE($tp)));
    }' unless defined(&GET_BYTE);
    eval 'sub GET_SHORT {
        my($tp) = @_;
	    eval q(((($tp)-> &flags &  &CISTPLF_AM_SPACE) ?  &GET_AM_SHORT($tp) :  &GET_CM_SHORT($tp)));
    }' unless defined(&GET_SHORT);
    eval 'sub GET_BE_SHORT {
        my($tp) = @_;
	    eval q(((($tp)-> &flags &  &CISTPLF_AM_SPACE) ?  &GET_AM_BE_SHORT($tp) :  &GET_CM_BE_SHORT($tp)));
    }' unless defined(&GET_BE_SHORT);
    eval 'sub GET_INT24 {
        my($tp) = @_;
	    eval q(((($tp)-> &flags &  &CISTPLF_AM_SPACE) ?  &GET_AM_INT24($tp) :  &GET_CM_INT24($tp)));
    }' unless defined(&GET_INT24);
    eval 'sub GET_LONG {
        my($tp) = @_;
	    eval q(((($tp)-> &flags &  &CISTPLF_AM_SPACE) ?  &GET_AM_LONG($tp) :  &GET_CM_LONG($tp)));
    }' unless defined(&GET_LONG);
    eval 'sub GET_LEN {
        my($tp) = @_;
	    eval q(((($tp)-> &flags &  &CISTPLF_AM_SPACE) ?  &GET_AM_LEN($tp) :  &GET_CM_LEN($tp)));
    }' unless defined(&GET_LEN);
    if(defined(&__cplusplus)) {
    }
}
1;
