require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CPR_H)) {
    eval 'sub _SYS_CPR_H () {1;}' unless defined(&_SYS_CPR_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/obpdefs.ph';
    require 'sys/param.ph';
    require 'sys/mutex.ph';
    require 'sys/uadmin.ph';
    require 'sys/compress.ph';
    eval 'sub CPR_VERSION () {5;}' unless defined(&CPR_VERSION);
    eval 'sub CPR_CONFIG () {"/etc/.cpr_config";}' unless defined(&CPR_CONFIG);
    eval 'sub CPR_CONFIG_MAGIC () {0x436e4667;}' unless defined(&CPR_CONFIG_MAGIC);
    eval 'sub CPR_DEFAULT_MAGIC () {0x44664c74;}' unless defined(&CPR_DEFAULT_MAGIC);
    eval 'sub PROP_BOOL_LEN () {6;}' unless defined(&PROP_BOOL_LEN);
    eval 'sub PROP_MOD () {ord(\'Y\');}' unless defined(&PROP_MOD);
    eval 'sub PROP_NOMOD () {ord(\'N\');}' unless defined(&PROP_NOMOD);
    eval 'sub CPR_MAXPLEN () {15;}' unless defined(&CPR_MAXPLEN);
    eval 'sub CPR_MAXPROP () {5;}' unless defined(&CPR_MAXPROP);
    eval 'sub CFT_UFS () {1;}' unless defined(&CFT_UFS);
    eval 'sub CFT_SPEC () {2;}' unless defined(&CFT_SPEC);
    if(defined(&_KERNEL)) {
	require 'sys/promif.ph';
	require 'sys/sunddi.ph';
	require 'sys/sysmacros.ph';
	require 'sys/vnode.ph';
	require 'sys/cpr_impl.ph';
	eval 'sub errp () { &prom_printf;}' unless defined(&errp);
	eval 'sub DPRINT () {1;}' unless defined(&DPRINT);
	eval 'sub LEVEL1 () {0x1;}' unless defined(&LEVEL1);
	eval 'sub LEVEL2 () {0x2;}' unless defined(&LEVEL2);
	eval 'sub LEVEL3 () {0x4;}' unless defined(&LEVEL3);
	eval 'sub LEVEL4 () {0x8;}' unless defined(&LEVEL4);
	eval 'sub LEVEL5 () {0x10;}' unless defined(&LEVEL5);
	eval 'sub LEVEL6 () {0x20;}' unless defined(&LEVEL6);
	eval 'sub LEVEL7 () {0x40;}' unless defined(&LEVEL7);
	eval 'sub LEVEL8 () {0x80;}' unless defined(&LEVEL8);
	eval 'sub DEBUG1 {
	    my($p) = @_;
    	    eval q({ &if ( &cpr_debug &  &LEVEL1) $p; });
	}' unless defined(&DEBUG1);
	eval 'sub DEBUG2 {
	    my($p) = @_;
    	    eval q({ &if ( &cpr_debug &  &LEVEL2) $p; });
	}' unless defined(&DEBUG2);
	eval 'sub DEBUG3 {
	    my($p) = @_;
    	    eval q({ &if ( &cpr_debug &  &LEVEL3) $p; });
	}' unless defined(&DEBUG3);
	eval 'sub DEBUG4 {
	    my($p) = @_;
    	    eval q({ &if ( &cpr_debug &  &LEVEL4) $p; });
	}' unless defined(&DEBUG4);
	eval 'sub DEBUG5 {
	    my($p) = @_;
    	    eval q({ &if ( &cpr_debug &  &LEVEL5) $p; });
	}' unless defined(&DEBUG5);
	eval 'sub DEBUG7 {
	    my($p) = @_;
    	    eval q({ &if ( &cpr_debug &  &LEVEL7) $p; });
	}' unless defined(&DEBUG7);
	eval 'sub DEBUG8 {
	    my($p) = @_;
    	    eval q({ &if ( &cpr_debug &  &LEVEL8) $p; });
	}' unless defined(&DEBUG8);
	eval 'sub DEBUG9 {
	    my($p) = @_;
    	    eval q({ &if ( &cpr_debug &  &LEVEL6) $p; });
	}' unless defined(&DEBUG9);
	eval 'sub CPR_DEBUG_BIT {
	    my($dval) = @_;
    	    eval q((1<< ($dval -  &AD_CPR_DEBUG0 - 1)));
	}' unless defined(&CPR_DEBUG_BIT);
	eval 'sub CPR_DUMP_MAGIC () {0x44754d70;}' unless defined(&CPR_DUMP_MAGIC);
	eval 'sub CPR_BITMAP_MAGIC () {0x42744d70;}' unless defined(&CPR_BITMAP_MAGIC);
	eval 'sub CPR_PAGE_MAGIC () {0x50614765;}' unless defined(&CPR_PAGE_MAGIC);
	eval 'sub CPR_MACHDEP_MAGIC () {0x4d614470;}' unless defined(&CPR_MACHDEP_MAGIC);
	eval 'sub CPR_TERM_MAGIC () {0x5465526d;}' unless defined(&CPR_TERM_MAGIC);
	if(defined(&DEBUG)) {
	}
	eval 'sub CPD_COMPRESS () {0x1;}' unless defined(&CPD_COMPRESS);
	eval 'sub CPD_CSUM () {0x2;}' unless defined(&CPD_CSUM);
	eval 'sub CPD_USUM () {0x4;}' unless defined(&CPD_USUM);
	eval 'sub REGULAR_BITMAP () { ($CPR->{c_bitmap_desc}->{cbd_reg_bitmap});}' unless defined(&REGULAR_BITMAP);
	eval 'sub VOLATILE_BITMAP () { ($CPR->{c_bitmap_desc}->{cbd_vlt_bitmap});}' unless defined(&VOLATILE_BITMAP);
	eval 'sub WRITE_TO_STATEFILE () {0;}' unless defined(&WRITE_TO_STATEFILE);
	eval 'sub SAVE_TO_STORAGE () {1;}' unless defined(&SAVE_TO_STORAGE);
	eval 'sub STORAGE_DESC_ALLOC () {2;}' unless defined(&STORAGE_DESC_ALLOC);
	eval 'sub PROM_MAX_READ () {0x8000;}' unless defined(&PROM_MAX_READ);
	eval 'sub CPR_MAX_BLOCK () {0x8000;}' unless defined(&CPR_MAX_BLOCK);
	eval 'sub CPR_MAXCONTIG () {( &CPR_MAX_BLOCK /  &MMU_PAGESIZE);}' unless defined(&CPR_MAXCONTIG);
	eval 'sub PAGE_ROUNDUP {
	    my($val) = @_;
    	    eval q(((($val) +  &MMU_PAGEOFFSET) &  &MMU_PAGEMASK));
	}' unless defined(&PAGE_ROUNDUP);
	eval 'sub AD_CPR_COMPRESS () { &AD_COMPRESS;}' unless defined(&AD_CPR_COMPRESS);
	eval 'sub AD_CPR_FORCE () { &AD_FORCE;}' unless defined(&AD_CPR_FORCE);
	eval 'sub AD_CPR_CHECK () { &AD_CHECK;}' unless defined(&AD_CPR_CHECK);
	eval 'sub AD_CPR_REUSEINIT () { &AD_REUSEINIT;}' unless defined(&AD_CPR_REUSEINIT);
	eval 'sub AD_CPR_REUSABLE () { &AD_REUSABLE;}' unless defined(&AD_CPR_REUSABLE);
	eval 'sub AD_CPR_REUSEFINI () { &AD_REUSEFINI;}' unless defined(&AD_CPR_REUSEFINI);
	eval 'sub AD_CPR_TESTHALT () {6;}' unless defined(&AD_CPR_TESTHALT);
	eval 'sub AD_CPR_TESTNOZ () {7;}' unless defined(&AD_CPR_TESTNOZ);
	eval 'sub AD_CPR_TESTZ () {8;}' unless defined(&AD_CPR_TESTZ);
	eval 'sub AD_CPR_PRINT () {9;}' unless defined(&AD_CPR_PRINT);
	eval 'sub AD_CPR_NOCOMPRESS () {10;}' unless defined(&AD_CPR_NOCOMPRESS);
	eval 'sub AD_CPR_DEBUG0 () {100;}' unless defined(&AD_CPR_DEBUG0);
	eval 'sub AD_CPR_DEBUG1 () {101;}' unless defined(&AD_CPR_DEBUG1);
	eval 'sub AD_CPR_DEBUG2 () {102;}' unless defined(&AD_CPR_DEBUG2);
	eval 'sub AD_CPR_DEBUG3 () {103;}' unless defined(&AD_CPR_DEBUG3);
	eval 'sub AD_CPR_DEBUG4 () {104;}' unless defined(&AD_CPR_DEBUG4);
	eval 'sub AD_CPR_DEBUG5 () {105;}' unless defined(&AD_CPR_DEBUG5);
	eval 'sub AD_CPR_DEBUG7 () {107;}' unless defined(&AD_CPR_DEBUG7);
	eval 'sub AD_CPR_DEBUG8 () {108;}' unless defined(&AD_CPR_DEBUG8);
	eval 'sub AD_CPR_DEBUG9 () {109;}' unless defined(&AD_CPR_DEBUG9);
	eval 'sub CPR_DEFAULT () {"/.cpr_default";}' unless defined(&CPR_DEFAULT);
	eval 'sub CPR_STATE_FILE () {"/.CPR";}' unless defined(&CPR_STATE_FILE);
	eval 'sub CPR_E_NAMELEN () {64;}' unless defined(&CPR_E_NAMELEN);
	eval 'sub CPR_E_MAX_EVENTNUM () {64;}' unless defined(&CPR_E_MAX_EVENTNUM);
	eval 'sub CPR_STAT_EVENT_START {
	    my($s) = @_;
    	    eval q( &cpr_stat_event_start($s, 0));
	}' unless defined(&CPR_STAT_EVENT_START);
	eval 'sub CPR_STAT_EVENT_END {
	    my($s) = @_;
    	    eval q( &cpr_stat_event_end($s, 0));
	}' unless defined(&CPR_STAT_EVENT_END);
	eval 'sub CPR_STAT_EVENT_START_TMZ {
	    my($s, $t) = @_;
    	    eval q( &cpr_stat_event_start($s, $t));
	}' unless defined(&CPR_STAT_EVENT_START_TMZ);
	eval 'sub CPR_STAT_EVENT_END_TMZ {
	    my($s, $t) = @_;
    	    eval q( &cpr_stat_event_end($s, $t));
	}' unless defined(&CPR_STAT_EVENT_END_TMZ);
	eval 'sub CPR_STAT_EVENT_PRINT () { &cpr_stat_event_print;}' unless defined(&CPR_STAT_EVENT_PRINT);
	eval 'sub C_SUSPENDING () {0x1;}' unless defined(&C_SUSPENDING);
	eval 'sub C_RESUMING () {0x2;}' unless defined(&C_RESUMING);
	eval 'sub C_COMPRESSING () {0x4;}' unless defined(&C_COMPRESSING);
	eval 'sub C_REUSABLE () {0x8;}' unless defined(&C_REUSABLE);
	eval 'sub C_ERROR () {0x10;}' unless defined(&C_ERROR);
	eval 'sub CPR () {( &cpr_state);}' unless defined(&CPR);
	eval 'sub STAT () {( ($cpr_state->{c_stat}));}' unless defined(&STAT);
	eval 'sub C_ST_USER_THREADS () {0;}' unless defined(&C_ST_USER_THREADS);
	eval 'sub C_ST_STATEF_ALLOC () {1;}' unless defined(&C_ST_STATEF_ALLOC);
	eval 'sub C_ST_STATEF_ALLOC_RETRY () {2;}' unless defined(&C_ST_STATEF_ALLOC_RETRY);
	eval 'sub C_ST_DDI () {3;}' unless defined(&C_ST_DDI);
	eval 'sub C_ST_DRIVERS () {4;}' unless defined(&C_ST_DRIVERS);
	eval 'sub C_ST_DUMP () {5;}' unless defined(&C_ST_DUMP);
	eval 'sub C_ST_KERNEL_THREADS () {6;}' unless defined(&C_ST_KERNEL_THREADS);
	eval 'sub C_ST_REUSABLE () {7;}' unless defined(&C_ST_REUSABLE);
	eval 'sub cpr_set_substate {
	    my($a) = @_;
    	    eval q(( ($CPR->{c_substate}) = ($a)));
	}' unless defined(&cpr_set_substate);
	eval 'sub C_VP () {( ($CPR->{c_vp}));}' unless defined(&C_VP);
	eval 'sub C_MAX_ALLOC_RETRY () {4;}' unless defined(&C_MAX_ALLOC_RETRY);
	eval 'sub CPR_PROM_SAVE () {0;}' unless defined(&CPR_PROM_SAVE);
	eval 'sub CPR_PROM_RESTORE () {1;}' unless defined(&CPR_PROM_RESTORE);
	eval 'sub CPR_PROM_FREE () {2;}' unless defined(&CPR_PROM_FREE);
	eval 'sub CPRBUFS () {256;}' unless defined(&CPRBUFS);
	eval 'sub CPRBUFSZ () {( &CPRBUFS *  &DEV_BSIZE);}' unless defined(&CPRBUFSZ);
	eval 'sub CPR_SPEC_OFFSET () {16384;}' unless defined(&CPR_SPEC_OFFSET);
	unless(defined(&_ASM)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
