require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_CS_H)) {
    eval 'sub _CS_H () {1;}' unless defined(&_CS_H);
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_VERSION)) {
	eval 'sub _VERSION {
	    my($major, $minor) = @_;
    	    eval q((($major)<<16|($minor)));
	}' unless defined(&_VERSION);
    }
    eval 'sub CS_VERSION () { &_VERSION(5, 2);}' unless defined(&CS_VERSION);
    eval 'sub CS_INTERNAL_REVISION_LEVEL () { &_VERSION(2, 0);}' unless defined(&CS_INTERNAL_REVISION_LEVEL);
    eval 'sub CS_GET_CARDSERVICES_INFO_VENDOR_STRING () {"Solaris UNIX Card Services\\n" "Copyright (c) 1996 by Sun Microsystems, Inc.\\n" "All rights reserved\\n" "@(#)cs.h	1.65 00/03/10 SMI\\n" "Based on the PC Card Standard, February 1995\\n";}' unless defined(&CS_GET_CARDSERVICES_INFO_VENDOR_STRING);
    eval 'sub CS_SUN_VENDOR_DESCRIPTION () {"Sun Microsystems, Inc. (c) 1996";}' unless defined(&CS_SUN_VENDOR_DESCRIPTION);
    eval 'sub CS_SUCCESS () {0x;}' unless defined(&CS_SUCCESS);
    eval 'sub CS_BAD_ADAPTER () {0x1;}' unless defined(&CS_BAD_ADAPTER);
    eval 'sub CS_BAD_ATTRIBUTE () {0x2;}' unless defined(&CS_BAD_ATTRIBUTE);
    eval 'sub CS_BAD_BASE () {0x3;}' unless defined(&CS_BAD_BASE);
    eval 'sub CS_BAD_EDC () {0x4;}' unless defined(&CS_BAD_EDC);
    eval 'sub CS_BAD_IRQ () {0x6;}' unless defined(&CS_BAD_IRQ);
    eval 'sub CS_BAD_OFFSET () {0x7;}' unless defined(&CS_BAD_OFFSET);
    eval 'sub CS_BAD_PAGE () {0x8;}' unless defined(&CS_BAD_PAGE);
    eval 'sub CS_READ_FAILURE () {0x9;}' unless defined(&CS_READ_FAILURE);
    eval 'sub CS_BAD_SIZE () {0xa;}' unless defined(&CS_BAD_SIZE);
    eval 'sub CS_BAD_SOCKET () {0xb;}' unless defined(&CS_BAD_SOCKET);
    eval 'sub CS_BAD_TYPE () {0xd;}' unless defined(&CS_BAD_TYPE);
    eval 'sub CS_BAD_VCC () {0xe;}' unless defined(&CS_BAD_VCC);
    eval 'sub CS_BAD_VPP () {0xf;}' unless defined(&CS_BAD_VPP);
    eval 'sub CS_BAD_WINDOW () {0x11;}' unless defined(&CS_BAD_WINDOW);
    eval 'sub CS_WRITE_FAILURE () {0x12;}' unless defined(&CS_WRITE_FAILURE);
    eval 'sub CS_NO_CARD () {0x14;}' unless defined(&CS_NO_CARD);
    eval 'sub CS_UNSUPPORTED_FUNCTION () {0x15;}' unless defined(&CS_UNSUPPORTED_FUNCTION);
    eval 'sub CS_UNSUPPORTED_MODE () {0x16;}' unless defined(&CS_UNSUPPORTED_MODE);
    eval 'sub CS_BAD_SPEED () {0x17;}' unless defined(&CS_BAD_SPEED);
    eval 'sub CS_BUSY () {0x18;}' unless defined(&CS_BUSY);
    eval 'sub CS_GENERAL_FAILURE () {0x19;}' unless defined(&CS_GENERAL_FAILURE);
    eval 'sub CS_WRITE_PROTECTED () {0x1a;}' unless defined(&CS_WRITE_PROTECTED);
    eval 'sub CS_BAD_ARG_LENGTH () {0x1b;}' unless defined(&CS_BAD_ARG_LENGTH);
    eval 'sub CS_BAD_ARGS () {0x1c;}' unless defined(&CS_BAD_ARGS);
    eval 'sub CS_CONFIGURATION_LOCKED () {0x1d;}' unless defined(&CS_CONFIGURATION_LOCKED);
    eval 'sub CS_IN_USE () {0x1e;}' unless defined(&CS_IN_USE);
    eval 'sub CS_NO_MORE_ITEMS () {0x1f;}' unless defined(&CS_NO_MORE_ITEMS);
    eval 'sub CS_OUT_OF_RESOURCE () {0x20;}' unless defined(&CS_OUT_OF_RESOURCE);
    eval 'sub CS_BAD_HANDLE () {0x21;}' unless defined(&CS_BAD_HANDLE);
    eval 'sub CS_NO_CIS () {0x80;}' unless defined(&CS_NO_CIS);
    eval 'sub CS_BAD_CIS () {0x81;}' unless defined(&CS_BAD_CIS);
    eval 'sub CS_UNKNOWN_TUPLE () {0x82;}' unless defined(&CS_UNKNOWN_TUPLE);
    eval 'sub CS_BAD_VERSION () {0x83;}' unless defined(&CS_BAD_VERSION);
    eval 'sub CS_UNSUPPORTED_EVENT () {0x84;}' unless defined(&CS_UNSUPPORTED_EVENT);
    eval 'sub CS_CSI_ERROR () {0x85;}' unless defined(&CS_CSI_ERROR);
    eval 'sub CS_CSI_NOT_INIT () {0x86;}' unless defined(&CS_CSI_NOT_INIT);
    eval 'sub CS_NO_TUPLE_PARSER () {0x87;}' unless defined(&CS_NO_TUPLE_PARSER);
    eval 'sub CS_ERRORLIST_END () {0x8000;}' unless defined(&CS_ERRORLIST_END);
    eval 'sub CS_EVENT_REGISTRATION_COMPLETE () {0x1;}' unless defined(&CS_EVENT_REGISTRATION_COMPLETE);
    eval 'sub CS_EVENT_PM_RESUME () {0x2;}' unless defined(&CS_EVENT_PM_RESUME);
    eval 'sub CS_EVENT_CARD_INSERTION () {0x4;}' unless defined(&CS_EVENT_CARD_INSERTION);
    eval 'sub CS_EVENT_CARD_READY () {0x8;}' unless defined(&CS_EVENT_CARD_READY);
    eval 'sub CS_EVENT_BATTERY_LOW () {0x10;}' unless defined(&CS_EVENT_BATTERY_LOW);
    eval 'sub CS_EVENT_BATTERY_DEAD () {0x20;}' unless defined(&CS_EVENT_BATTERY_DEAD);
    eval 'sub CS_EVENT_CARD_LOCK () {0x40;}' unless defined(&CS_EVENT_CARD_LOCK);
    eval 'sub CS_EVENT_PM_SUSPEND () {0x80;}' unless defined(&CS_EVENT_PM_SUSPEND);
    eval 'sub CS_EVENT_CARD_RESET () {0x100;}' unless defined(&CS_EVENT_CARD_RESET);
    eval 'sub CS_EVENT_CARD_UNLOCK () {0x200;}' unless defined(&CS_EVENT_CARD_UNLOCK);
    eval 'sub CS_EVENT_EJECTION_COMPLETE () {0x400;}' unless defined(&CS_EVENT_EJECTION_COMPLETE);
    eval 'sub CS_EVENT_EJECTION_REQUEST () {0x800;}' unless defined(&CS_EVENT_EJECTION_REQUEST);
    eval 'sub CS_EVENT_ERASE_COMPLETE () {0x1000;}' unless defined(&CS_EVENT_ERASE_COMPLETE);
    eval 'sub CS_EVENT_EXCLUSIVE_COMPLETE () {0x2000;}' unless defined(&CS_EVENT_EXCLUSIVE_COMPLETE);
    eval 'sub CS_EVENT_EXCLUSIVE_REQUEST () {0x4000;}' unless defined(&CS_EVENT_EXCLUSIVE_REQUEST);
    eval 'sub CS_EVENT_INSERTION_COMPLETE () {0x8000;}' unless defined(&CS_EVENT_INSERTION_COMPLETE);
    eval 'sub CS_EVENT_INSERTION_REQUEST () {0x10000;}' unless defined(&CS_EVENT_INSERTION_REQUEST);
    eval 'sub CS_EVENT_RESET_COMPLETE () {0x20000;}' unless defined(&CS_EVENT_RESET_COMPLETE);
    eval 'sub CS_EVENT_RESET_PHYSICAL () {0x40000;}' unless defined(&CS_EVENT_RESET_PHYSICAL);
    eval 'sub CS_EVENT_RESET_REQUEST () {0x80000;}' unless defined(&CS_EVENT_RESET_REQUEST);
    eval 'sub CS_EVENT_MTD_REQUEST () {0x100000;}' unless defined(&CS_EVENT_MTD_REQUEST);
    eval 'sub CS_EVENT_CLIENT_INFO () {0x200000;}' unless defined(&CS_EVENT_CLIENT_INFO);
    eval 'sub CS_EVENT_TIMER_EXPIRED () {0x400000;}' unless defined(&CS_EVENT_TIMER_EXPIRED);
    eval 'sub CS_EVENT_WRITE_PROTECT () {0x1000000;}' unless defined(&CS_EVENT_WRITE_PROTECT);
    eval 'sub CS_EVENT_SS_UPDATED () {0x800000;}' unless defined(&CS_EVENT_SS_UPDATED);
    eval 'sub CS_EVENT_STATUS_CHANGE () {0x2000000;}' unless defined(&CS_EVENT_STATUS_CHANGE);
    eval 'sub CS_EVENT_CARD_REMOVAL () {0x10000000;}' unless defined(&CS_EVENT_CARD_REMOVAL);
    eval 'sub CS_EVENT_CARD_REMOVAL_LOWP () {0x20000000;}' unless defined(&CS_EVENT_CARD_REMOVAL_LOWP);
    eval 'sub CS_EVENT_ALL_CLIENTS () {0x40000000;}' unless defined(&CS_EVENT_ALL_CLIENTS);
    eval 'sub CS_EVENT_READY_TIMEOUT () {0x80000000;}' unless defined(&CS_EVENT_READY_TIMEOUT);
    eval 'sub CS_EVENT_CLIENT_EVENTS_MASK () {~( &CS_EVENT_SS_UPDATED |  &CS_EVENT_ALL_CLIENTS |  &CS_EVENT_CARD_REMOVAL_LOWP);}' unless defined(&CS_EVENT_CLIENT_EVENTS_MASK);
    eval 'sub CS_CLIENT_INFO_MAX_NAME_LEN () {80;}' unless defined(&CS_CLIENT_INFO_MAX_NAME_LEN);
    eval 'sub CS_CLIENT_INFO_SOCKET_SERVICES () { &INFO_SOCKET_SERVICES;}' unless defined(&CS_CLIENT_INFO_SOCKET_SERVICES);
    eval 'sub CS_CLIENT_INFO_IO_CLIENT () { &INFO_IO_CLIENT;}' unless defined(&CS_CLIENT_INFO_IO_CLIENT);
    eval 'sub CS_CLIENT_INFO_MTD_CLIENT () { &INFO_MTD_CLIENT;}' unless defined(&CS_CLIENT_INFO_MTD_CLIENT);
    eval 'sub CS_CLIENT_INFO_MEM_CLIENT () { &INFO_MEM_CLIENT;}' unless defined(&CS_CLIENT_INFO_MEM_CLIENT);
    eval 'sub CS_CLIENT_INFO_CSI_CLIENT () { &INFO_CSI_CLIENT;}' unless defined(&CS_CLIENT_INFO_CSI_CLIENT);
    eval 'sub CS_CLIENT_INFO_CARD_SHARE () { &INFO_CARD_SHARE;}' unless defined(&CS_CLIENT_INFO_CARD_SHARE);
    eval 'sub CS_CLIENT_INFO_CARD_EXCL () { &INFO_CARD_EXCL;}' unless defined(&CS_CLIENT_INFO_CARD_EXCL);
    eval 'sub CS_CLIENT_INFO_CLIENT_MASK () {0xff;}' unless defined(&CS_CLIENT_INFO_CLIENT_MASK);
    eval 'sub CS_CLIENT_INFO_VALID () {0x10000;}' unless defined(&CS_CLIENT_INFO_VALID);
    eval 'sub CS_CLIENT_INFO_CLIENT_ACTIVE () {0x20000;}' unless defined(&CS_CLIENT_INFO_CLIENT_ACTIVE);
    eval 'sub CS_CLIENT_INFO_FLAGS_MASK () {0xffff0000;}' unless defined(&CS_CLIENT_INFO_FLAGS_MASK);
    eval 'sub CS_CLIENT_INFO_SUBSVC_CS () {0x;}' unless defined(&CS_CLIENT_INFO_SUBSVC_CS);
    eval 'sub CS_CLIENT_INFO_SUBSVC_MASK () {0xff00;}' unless defined(&CS_CLIENT_INFO_SUBSVC_MASK);
    eval 'sub GET_CLIENT_INFO_SUBSVC {
        my($s) = @_;
	    eval q(((($s) &  &CS_CLIENT_INFO_SUBSVC_MASK)>>8));
    }' unless defined(&GET_CLIENT_INFO_SUBSVC);
    eval 'sub SET_CLIENT_INFO_SUBSVC {
        my($s) = @_;
	    eval q(((($s)<<8) &  &CS_CLIENT_INFO_SUBSVC_MASK));
    }' unless defined(&SET_CLIENT_INFO_SUBSVC);
    eval 'sub CS_CLIENT_INFO_MAKE_DATE {
        my($d, $m, $y) = @_;
	    eval q(((($d) & 0x1f) | ((($m) & 0xf) << 5) | ((($y) & 0x7f) << 9)));
    }' unless defined(&CS_CLIENT_INFO_MAKE_DATE);
    eval 'sub CS_CLIENT_INFO_GET_DAY {
        my($d) = @_;
	    eval q((($d) & 0x1f));
    }' unless defined(&CS_CLIENT_INFO_GET_DAY);
    eval 'sub CS_CLIENT_INFO_GET_MONTH {
        my($m) = @_;
	    eval q(((($m) >> 5) & 0xf));
    }' unless defined(&CS_CLIENT_INFO_GET_MONTH);
    eval 'sub CS_CLIENT_INFO_GET_YEAR {
        my($y) = @_;
	    eval q((((($y) >> 9) & 0x7f) + 1980));
    }' unless defined(&CS_CLIENT_INFO_GET_YEAR);
    eval 'sub CS_CLIENT_INFO_GET_YEAR_OFFSET {
        my($y) = @_;
	    eval q(((($y) >> 9) & 0x7f));
    }' unless defined(&CS_CLIENT_INFO_GET_YEAR_OFFSET);
    eval 'sub CS_GET_FIRSTNEXT_CLIENT_ALL_CLIENTS () {0x1;}' unless defined(&CS_GET_FIRSTNEXT_CLIENT_ALL_CLIENTS);
    eval 'sub CS_GET_FIRSTNEXT_CLIENT_SOCKET_ONLY () {0x2;}' unless defined(&CS_GET_FIRSTNEXT_CLIENT_SOCKET_ONLY);
    eval 'sub CS_EVENT_PRI_LOW () {0x1;}' unless defined(&CS_EVENT_PRI_LOW);
    eval 'sub CS_EVENT_PRI_HIGH () {0x2;}' unless defined(&CS_EVENT_PRI_HIGH);
    eval 'sub CS_EVENT_PRI_NONE () {0x4;}' unless defined(&CS_EVENT_PRI_NONE);
    eval 'sub CS_EVENT_WRITE_PROTECT_WPOFF () {0x;}' unless defined(&CS_EVENT_WRITE_PROTECT_WPOFF);
    eval 'sub CS_EVENT_WRITE_PROTECT_WPON () {0xffff;}' unless defined(&CS_EVENT_WRITE_PROTECT_WPON);
    eval 'sub WIN_ACC_ENDIAN_MASK () {0x300000;}' unless defined(&WIN_ACC_ENDIAN_MASK);
    eval 'sub WIN_ACC_NEVER_SWAP () {0x;}' unless defined(&WIN_ACC_NEVER_SWAP);
    eval 'sub WIN_ACC_BIG_ENDIAN () {0x100000;}' unless defined(&WIN_ACC_BIG_ENDIAN);
    eval 'sub WIN_ACC_LITTLE_ENDIAN () {0x200000;}' unless defined(&WIN_ACC_LITTLE_ENDIAN);
    eval 'sub WIN_ACC_ORDER_MASK () {0x700000;}' unless defined(&WIN_ACC_ORDER_MASK);
    eval 'sub WIN_ACC_STRICT_ORDER () {0x;}' unless defined(&WIN_ACC_STRICT_ORDER);
    eval 'sub WIN_ACC_UNORDERED_OK () {0x100000;}' unless defined(&WIN_ACC_UNORDERED_OK);
    eval 'sub WIN_ACC_MERGING_OK () {0x200000;}' unless defined(&WIN_ACC_MERGING_OK);
    eval 'sub WIN_ACC_LOADCACHING_OK () {0x300000;}' unless defined(&WIN_ACC_LOADCACHING_OK);
    eval 'sub WIN_ACC_STORECACHING_OK () {0x400000;}' unless defined(&WIN_ACC_STORECACHING_OK);
    eval 'sub IO_DATA_WIDTH_MASK () {0x1;}' unless defined(&IO_DATA_WIDTH_MASK);
    eval 'sub IO_DATA_WIDTH_8 () {0x;}' unless defined(&IO_DATA_WIDTH_8);
    eval 'sub IO_DATA_WIDTH_16 () {0x1;}' unless defined(&IO_DATA_WIDTH_16);
    eval 'sub IO_SHARED () {0x10000;}' unless defined(&IO_SHARED);
    eval 'sub IO_FIRST_SHARED () {0x20000;}' unless defined(&IO_FIRST_SHARED);
    eval 'sub IO_FORCE_ALIAS_ACCESS () {0x40000;}' unless defined(&IO_FORCE_ALIAS_ACCESS);
    eval 'sub IO_DEALLOCATE_WINDOW () {0x10000000;}' unless defined(&IO_DEALLOCATE_WINDOW);
    eval 'sub IO_DISABLE_WINDOW () {0x20000000;}' unless defined(&IO_DISABLE_WINDOW);
    eval 'sub WIN_MEMORY_TYPE_MASK () {0x21;}' unless defined(&WIN_MEMORY_TYPE_MASK);
    eval 'sub WIN_MEMORY_TYPE_CM () {0x;}' unless defined(&WIN_MEMORY_TYPE_CM);
    eval 'sub WIN_MEMORY_TYPE_AM () {0x1;}' unless defined(&WIN_MEMORY_TYPE_AM);
    eval 'sub WIN_MEMORY_TYPE_IO () {0x20;}' unless defined(&WIN_MEMORY_TYPE_IO);
    eval 'sub WIN_DATA_WIDTH_MASK () {0x42;}' unless defined(&WIN_DATA_WIDTH_MASK);
    eval 'sub WIN_DATA_WIDTH_8 () {0x;}' unless defined(&WIN_DATA_WIDTH_8);
    eval 'sub WIN_DATA_WIDTH_16 () {0x2;}' unless defined(&WIN_DATA_WIDTH_16);
    eval 'sub WIN_DATA_WIDTH_32 () {0x40;}' unless defined(&WIN_DATA_WIDTH_32);
    eval 'sub WIN_ENABLE () {0x4;}' unless defined(&WIN_ENABLE);
    eval 'sub WIN_OFFSET_SIZE () {0x8;}' unless defined(&WIN_OFFSET_SIZE);
    eval 'sub WIN_ACCESS_SPEED_VALID () {0x10;}' unless defined(&WIN_ACCESS_SPEED_VALID);
    eval 'sub WIN_PREFETCH_CACHE_MASK () {0x300;}' unless defined(&WIN_PREFETCH_CACHE_MASK);
    eval 'sub WIN_PREFETCH () {0x100;}' unless defined(&WIN_PREFETCH);
    eval 'sub WIN_PREFETCH_CACHE () {0x200;}' unless defined(&WIN_PREFETCH_CACHE);
    eval 'sub WIN_BAR_MASK () {0x7000;}' unless defined(&WIN_BAR_MASK);
    eval 'sub WIN_BAR_1 () {0x1000;}' unless defined(&WIN_BAR_1);
    eval 'sub WIN_BAR_2 () {0x2000;}' unless defined(&WIN_BAR_2);
    eval 'sub WIN_BAR_3 () {0x3000;}' unless defined(&WIN_BAR_3);
    eval 'sub WIN_BAR_4 () {0x4000;}' unless defined(&WIN_BAR_4);
    eval 'sub WIN_BAR_5 () {0x5000;}' unless defined(&WIN_BAR_5);
    eval 'sub WIN_BAR_6 () {0x6000;}' unless defined(&WIN_BAR_6);
    eval 'sub WIN_BAR_7 () {0x7000;}' unless defined(&WIN_BAR_7);
    eval 'sub WIN_DATA_WIDTH_VALID () {0x8000;}' unless defined(&WIN_DATA_WIDTH_VALID);
    eval 'sub WIN_PAGED () {0x10000;}' unless defined(&WIN_PAGED);
    eval 'sub WIN_SHARED () {0x20000;}' unless defined(&WIN_SHARED);
    eval 'sub WIN_FIRST_SHARED () {0x40000;}' unless defined(&WIN_FIRST_SHARED);
    eval 'sub WIN_BINDING_SPECIFIC () {0x80000;}' unless defined(&WIN_BINDING_SPECIFIC);
    eval 'sub WIN_USE_WAIT () {0x80;}' unless defined(&WIN_USE_WAIT);
    eval 'sub INFO_SOCKET_SERVICES () {0x1;}' unless defined(&INFO_SOCKET_SERVICES);
    eval 'sub INFO_IO_CLIENT () {0x2;}' unless defined(&INFO_IO_CLIENT);
    eval 'sub INFO_MTD_CLIENT () {0x4;}' unless defined(&INFO_MTD_CLIENT);
    eval 'sub INFO_MEM_CLIENT () {0x8;}' unless defined(&INFO_MEM_CLIENT);
    eval 'sub INFO_CSI_CLIENT () {0x10;}' unless defined(&INFO_CSI_CLIENT);
    eval 'sub INFO_CLIENT_TYPE_MASK () {( &INFO_SOCKET_SERVICES |  &INFO_IO_CLIENT |  &INFO_MTD_CLIENT |  &INFO_MEM_CLIENT |  &INFO_CSI_CLIENT);}' unless defined(&INFO_CLIENT_TYPE_MASK);
    eval 'sub MAX_CLIENT_TYPES () {3;}' unless defined(&MAX_CLIENT_TYPES);
    eval 'sub INFO_CARD_SHARE () {0x20;}' unless defined(&INFO_CARD_SHARE);
    eval 'sub INFO_CARD_EXCL () {0x40;}' unless defined(&INFO_CARD_EXCL);
    eval 'sub INFO_CARD_FLAGS_MASK () {( &INFO_CARD_SHARE |  &INFO_CARD_EXCL);}' unless defined(&INFO_CARD_FLAGS_MASK);
    eval 'sub TUPLE_RETURN_LINK () {0x2;}' unless defined(&TUPLE_RETURN_LINK);
    eval 'sub TUPLE_RETURN_IGNORED_TUPLES () {0x10000;}' unless defined(&TUPLE_RETURN_IGNORED_TUPLES);
    eval 'sub TUPLE_RETURN_NAME () {0x20000;}' unless defined(&TUPLE_RETURN_NAME);
    eval 'sub CONF_EVENT_MASK_GLOBAL () {0x;}' unless defined(&CONF_EVENT_MASK_GLOBAL);
    eval 'sub CONF_EVENT_MASK_CLIENT () {0x1;}' unless defined(&CONF_EVENT_MASK_CLIENT);
    eval 'sub CONF_EVENT_MASK_VALID () {0x1;}' unless defined(&CONF_EVENT_MASK_VALID);
    eval 'sub CONVERT_NS_TO_DEVSPEED () {0x1;}' unless defined(&CONVERT_NS_TO_DEVSPEED);
    eval 'sub CONVERT_DEVSPEED_TO_NS () {0x2;}' unless defined(&CONVERT_DEVSPEED_TO_NS);
    eval 'sub CONVERT_BYTES_TO_DEVSIZE () {0x1;}' unless defined(&CONVERT_BYTES_TO_DEVSIZE);
    eval 'sub CONVERT_DEVSIZE_TO_BYTES () {0x2;}' unless defined(&CONVERT_DEVSIZE_TO_BYTES);
    eval 'sub MAX_CS_EVENT_BUFSIZE () {64;}' unless defined(&MAX_CS_EVENT_BUFSIZE);
    eval 'sub MAX_MULTI_EVENT_BUFSIZE () {512;}' unless defined(&MAX_MULTI_EVENT_BUFSIZE);
    eval 'sub CS_EVENT_MAX_BUFSIZE () { &MAX_MULTI_EVENT_BUFSIZE;}' unless defined(&CS_EVENT_MAX_BUFSIZE);
    eval 'sub CS_ERROR_MAX_BUFSIZE () { &MAX_CS_EVENT_BUFSIZE;}' unless defined(&CS_ERROR_MAX_BUFSIZE);
    eval 'sub CS_STATUS_WRITE_PROTECTED () { &CS_EVENT_WRITE_PROTECT;}' unless defined(&CS_STATUS_WRITE_PROTECTED);
    eval 'sub CS_STATUS_CARD_LOCKED () { &CS_EVENT_CARD_LOCK;}' unless defined(&CS_STATUS_CARD_LOCKED);
    eval 'sub CS_STATUS_EJECTION_REQUEST () { &CS_EVENT_EJECTION_REQUEST;}' unless defined(&CS_STATUS_EJECTION_REQUEST);
    eval 'sub CS_STATUS_INSERTION_REQUEST () { &CS_EVENT_INSERTION_REQUEST;}' unless defined(&CS_STATUS_INSERTION_REQUEST);
    eval 'sub CS_STATUS_BATTERY_DEAD () { &CS_EVENT_BATTERY_DEAD;}' unless defined(&CS_STATUS_BATTERY_DEAD);
    eval 'sub CS_STATUS_BATTERY_LOW () { &CS_EVENT_BATTERY_LOW;}' unless defined(&CS_STATUS_BATTERY_LOW);
    eval 'sub CS_STATUS_CARD_READY () { &CS_EVENT_CARD_READY;}' unless defined(&CS_STATUS_CARD_READY);
    eval 'sub CS_STATUS_CARD_INSERTED () { &CS_EVENT_CARD_INSERTION;}' unless defined(&CS_STATUS_CARD_INSERTED);
    eval 'sub CS_STATUS_RES_EVT1 () {0x100000;}' unless defined(&CS_STATUS_RES_EVT1);
    eval 'sub CS_STATUS_RES_EVT2 () {0x200000;}' unless defined(&CS_STATUS_RES_EVT2);
    eval 'sub CS_STATUS_RES_EVT3 () {0x400000;}' unless defined(&CS_STATUS_RES_EVT3);
    eval 'sub CS_STATUS_VCC_50 () {0x10000000;}' unless defined(&CS_STATUS_VCC_50);
    eval 'sub CS_STATUS_VCC_33 () {0x20000000;}' unless defined(&CS_STATUS_VCC_33);
    eval 'sub CS_STATUS_VCC_XX () {0x40000000;}' unless defined(&CS_STATUS_VCC_XX);
    eval 'sub CS_STATUS_REQ_ATTN () {0x80000000;}' unless defined(&CS_STATUS_REQ_ATTN);
    eval 'sub CS_SOCK_STATUS_WRITE_PROTECT_CHANGE () { &CS_EVENT_WRITE_PROTECT;}' unless defined(&CS_SOCK_STATUS_WRITE_PROTECT_CHANGE);
    eval 'sub CS_SOCK_STATUS_CARD_LOCK_CHNAGE () { &CS_EVENT_CARD_LOCK;}' unless defined(&CS_SOCK_STATUS_CARD_LOCK_CHNAGE);
    eval 'sub CS_SOCK_STATUS_EJECTION_PENDING () { &CS_EVENT_EJECTION_REQUEST;}' unless defined(&CS_SOCK_STATUS_EJECTION_PENDING);
    eval 'sub CS_SOCK_STATUS_INSERTION_PENDING () { &CS_EVENT_INSERTION_REQUEST;}' unless defined(&CS_SOCK_STATUS_INSERTION_PENDING);
    eval 'sub CS_SOCK_STATUS_BATTERY_DEAD_CHNAGE () { &CS_EVENT_BATTERY_DEAD;}' unless defined(&CS_SOCK_STATUS_BATTERY_DEAD_CHNAGE);
    eval 'sub CS_SOCK_STATUS_BATTERY_LOW_CHNAGE () { &CS_EVENT_BATTERY_LOW;}' unless defined(&CS_SOCK_STATUS_BATTERY_LOW_CHNAGE);
    eval 'sub CS_SOCK_STATUS_CARD_READY_CHANGE () { &CS_EVENT_CARD_READY;}' unless defined(&CS_SOCK_STATUS_CARD_READY_CHANGE);
    eval 'sub CS_SOCK_STATUS_CARD_DETECT_CHNAGE () { &CS_EVENT_CARD_INSERTION;}' unless defined(&CS_SOCK_STATUS_CARD_DETECT_CHNAGE);
    eval 'sub IRQ_TYPE_EXCLUSIVE () {0x2;}' unless defined(&IRQ_TYPE_EXCLUSIVE);
    eval 'sub IRQ_FORCED_PULSE () {0x10000;}' unless defined(&IRQ_FORCED_PULSE);
    eval 'sub IRQ_TYPE_TIME () {0x20000;}' unless defined(&IRQ_TYPE_TIME);
    eval 'sub IRQ_TYPE_DYNAMIC_SHARING () {0x40000;}' unless defined(&IRQ_TYPE_DYNAMIC_SHARING);
    eval 'sub IRQ_FIRST_SHARED () {0x80000;}' unless defined(&IRQ_FIRST_SHARED);
    eval 'sub IRQ_PULSE_ALLOCATED () {0x100000;}' unless defined(&IRQ_PULSE_ALLOCATED);
    eval 'sub CONF_ENABLE_IRQ_STEERING () {0x10000;}' unless defined(&CONF_ENABLE_IRQ_STEERING);
    eval 'sub SOCKET_INTERFACE_MEMORY () {0x1;}' unless defined(&SOCKET_INTERFACE_MEMORY);
    eval 'sub SOCKET_INTERFACE_MEMORY_AND_IO () {0x2;}' unless defined(&SOCKET_INTERFACE_MEMORY_AND_IO);
    eval 'sub CONFIG_OPTION_REG_PRESENT () {0x1;}' unless defined(&CONFIG_OPTION_REG_PRESENT);
    eval 'sub CONFIG_STATUS_REG_PRESENT () {0x2;}' unless defined(&CONFIG_STATUS_REG_PRESENT);
    eval 'sub CONFIG_PINREPL_REG_PRESENT () {0x4;}' unless defined(&CONFIG_PINREPL_REG_PRESENT);
    eval 'sub CONFIG_COPY_REG_PRESENT () {0x8;}' unless defined(&CONFIG_COPY_REG_PRESENT);
    eval 'sub CONFIG_EXSTAT_REG_PRESENT () {0x10;}' unless defined(&CONFIG_EXSTAT_REG_PRESENT);
    eval 'sub CONFIG_IOBASE0_REG_PRESENT () {0x20;}' unless defined(&CONFIG_IOBASE0_REG_PRESENT);
    eval 'sub CONFIG_IOBASE1_REG_PRESENT () {0x40;}' unless defined(&CONFIG_IOBASE1_REG_PRESENT);
    eval 'sub CONFIG_IOBASE2_REG_PRESENT () {0x80;}' unless defined(&CONFIG_IOBASE2_REG_PRESENT);
    eval 'sub CONFIG_IOBASE3_REG_PRESENT () {0x100;}' unless defined(&CONFIG_IOBASE3_REG_PRESENT);
    eval 'sub CONFIG_IOLIMIT_REG_PRESENT () {0x200;}' unless defined(&CONFIG_IOLIMIT_REG_PRESENT);
    eval 'sub CONFIG_IOBASE_REG_MASK () {0x1e0;}' unless defined(&CONFIG_IOBASE_REG_MASK);
    eval 'sub CONFIG_IOBASE_REG_SHIFT () {5;}' unless defined(&CONFIG_IOBASE_REG_SHIFT);
    eval 'sub PRR_WP_STATUS () {0x1;}' unless defined(&PRR_WP_STATUS);
    eval 'sub PRR_READY_STATUS () {0x2;}' unless defined(&PRR_READY_STATUS);
    eval 'sub PRR_BVD2_STATUS () {0x4;}' unless defined(&PRR_BVD2_STATUS);
    eval 'sub PRR_BVD1_STATUS () {0x8;}' unless defined(&PRR_BVD1_STATUS);
    eval 'sub PRR_WP_EVENT () {0x10;}' unless defined(&PRR_WP_EVENT);
    eval 'sub PRR_READY_EVENT () {0x20;}' unless defined(&PRR_READY_EVENT);
    eval 'sub PRR_BVD2_EVENT () {0x40;}' unless defined(&PRR_BVD2_EVENT);
    eval 'sub PRR_BVD1_EVENT () {0x80;}' unless defined(&PRR_BVD1_EVENT);
    eval 'sub COR_ENABLE_FUNCTION () {0x1;}' unless defined(&COR_ENABLE_FUNCTION);
    eval 'sub COR_ENABLE_BASE_LIMIT () {0x2;}' unless defined(&COR_ENABLE_BASE_LIMIT);
    eval 'sub COR_ENABLE_IREQ_ROUTING () {0x4;}' unless defined(&COR_ENABLE_IREQ_ROUTING);
    eval 'sub COR_STATUS_CHANGE_MODE () {0x8;}' unless defined(&COR_STATUS_CHANGE_MODE);
    eval 'sub COR_LEVEL_IRQ () {0x40;}' unless defined(&COR_LEVEL_IRQ);
    eval 'sub COR_SOFT_RESET () {0x80;}' unless defined(&COR_SOFT_RESET);
    eval 'sub CCSR_INTR_ACK () {0x1;}' unless defined(&CCSR_INTR_ACK);
    eval 'sub CCSR_INTR () {0x2;}' unless defined(&CCSR_INTR);
    eval 'sub CCSR_POWER_DOWN () {0x4;}' unless defined(&CCSR_POWER_DOWN);
    eval 'sub CCSR_AUDIO () {0x8;}' unless defined(&CCSR_AUDIO);
    eval 'sub CCSR_IO_IS_8 () {0x20;}' unless defined(&CCSR_IO_IS_8);
    eval 'sub CCSR_SIG_CHG () {0x40;}' unless defined(&CCSR_SIG_CHG);
    eval 'sub CCSR_CHANGED () {0x80;}' unless defined(&CCSR_CHANGED);
    eval 'sub SCR_GET_SOCKET {
        my($r) = @_;
	    eval q((($r)&0xf));
    }' unless defined(&SCR_GET_SOCKET);
    eval 'sub SCR_GET_COPY {
        my($r) = @_;
	    eval q(((($r)>>4)&7));
    }' unless defined(&SCR_GET_COPY);
    eval 'sub SCR_SET_SOCKET {
        my($s) = @_;
	    eval q((($s)&0xf));
    }' unless defined(&SCR_SET_SOCKET);
    eval 'sub SCR_SET_COPY {
        my($c) = @_;
	    eval q(((($c)&7)<<4));
    }' unless defined(&SCR_SET_COPY);
    eval 'sub SCR_SET_SOCKET_COPY {
        my($s, $c) = @_;
	    eval q(((($s)&0xf) | ((($c)&7)<<4)));
    }' unless defined(&SCR_SET_SOCKET_COPY);
    eval 'sub CONF_VPP1_CHANGE_VALID () {0x2;}' unless defined(&CONF_VPP1_CHANGE_VALID);
    eval 'sub CONF_VPP2_CHANGE_VALID () {0x4;}' unless defined(&CONF_VPP2_CHANGE_VALID);
    eval 'sub CONF_IRQ_CHANGE_VALID () {0x8;}' unless defined(&CONF_IRQ_CHANGE_VALID);
    eval 'sub CONFIG_REG_READ () {0x1;}' unless defined(&CONFIG_REG_READ);
    eval 'sub CONFIG_REG_WRITE () {0x2;}' unless defined(&CONFIG_REG_WRITE);
    eval 'sub CONFIG_OPTION_REG_OFFSET () {0x;}' unless defined(&CONFIG_OPTION_REG_OFFSET);
    eval 'sub CONFIG_STATUS_REG_OFFSET () {0x2;}' unless defined(&CONFIG_STATUS_REG_OFFSET);
    eval 'sub CONFIG_PINREPL_REG_OFFSET () {0x4;}' unless defined(&CONFIG_PINREPL_REG_OFFSET);
    eval 'sub CONFIG_COPY_REG_OFFSET () {0x6;}' unless defined(&CONFIG_COPY_REG_OFFSET);
    eval 'sub CONFIG_EXSTAT_REG_OFFSET () {0x8;}' unless defined(&CONFIG_EXSTAT_REG_OFFSET);
    eval 'sub CONFIG_IOBASE0_REG_OFFSET () {0xa;}' unless defined(&CONFIG_IOBASE0_REG_OFFSET);
    eval 'sub CONFIG_IOBASE1_REG_OFFSET () {0xc;}' unless defined(&CONFIG_IOBASE1_REG_OFFSET);
    eval 'sub CONFIG_IOBASE2_REG_OFFSET () {0xe;}' unless defined(&CONFIG_IOBASE2_REG_OFFSET);
    eval 'sub CONFIG_IOBASE3_REG_OFFSET () {0x10;}' unless defined(&CONFIG_IOBASE3_REG_OFFSET);
    eval 'sub CONFIG_IOLIMIT_REG_OFFSET () {0x12;}' unless defined(&CONFIG_IOLIMIT_REG_OFFSET);
    eval 'sub CS_GET_CARDSERVICES_INFO_MAX_VS_LEN () {512;}' unless defined(&CS_GET_CARDSERVICES_INFO_MAX_VS_LEN);
    eval 'sub CREATE_DEVICE_NODE () {0x1;}' unless defined(&CREATE_DEVICE_NODE);
    eval 'sub REMOVE_DEVICE_NODE () {0x2;}' unless defined(&REMOVE_DEVICE_NODE);
    eval 'sub REMOVE_ALL_DEVICE_NODES () {0x3;}' unless defined(&REMOVE_ALL_DEVICE_NODES);
    eval 'sub CS_SYS_CTL_SEND_EVENT () {0x1;}' unless defined(&CS_SYS_CTL_SEND_EVENT);
    eval 'sub CS_SYS_CTL_WAIT_SYNC () {0x1;}' unless defined(&CS_SYS_CTL_WAIT_SYNC);
    eval 'sub CS_SYS_CTL_EVENT_SOCKET () {0x2;}' unless defined(&CS_SYS_CTL_EVENT_SOCKET);
    eval 'sub CS_SYS_CTL_EVENT_CLIENT () {0x4;}' unless defined(&CS_SYS_CTL_EVENT_CLIENT);
    eval 'sub CS_DEV_AUTOINCR () { &DDI_DEV_AUTOINCR;}' unless defined(&CS_DEV_AUTOINCR);
    eval 'sub CS_DEV_NO_AUTOINCR () { &DDI_DEV_NO_AUTOINCR;}' unless defined(&CS_DEV_NO_AUTOINCR);
    eval 'sub WIN_DATA_WIDTH () {0x2;}' unless defined(&WIN_DATA_WIDTH);
    eval 'sub IO_DATA_PATH_WIDTH () {0x1;}' unless defined(&IO_DATA_PATH_WIDTH);
    eval 'sub IO_DATA_PATH_WIDTH_8 () {0x;}' unless defined(&IO_DATA_PATH_WIDTH_8);
    eval 'sub IO_DATA_PATH_WIDTH_16 () {0x1;}' unless defined(&IO_DATA_PATH_WIDTH_16);
    eval 'sub REMOVAL_ALL_DEVICE_NODES () {0x3;}' unless defined(&REMOVAL_ALL_DEVICE_NODES);
    if(defined(&__cplusplus)) {
    }
}
1;
