require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_CS_STUBS_H)) {
    eval 'sub _CS_STUBS_H () {1;}' unless defined(&_CS_STUBS_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub CS_STUBS_MAGIC () {0x19960300;}' unless defined(&CS_STUBS_MAGIC);
    eval 'sub GetCardServicesInfo () {0xb;}' unless defined(&GetCardServicesInfo);
    eval 'sub RegisterClient () {0x10;}' unless defined(&RegisterClient);
    eval 'sub DeregisterClient () {0x2;}' unless defined(&DeregisterClient);
    eval 'sub GetStatus () {0xc;}' unless defined(&GetStatus);
    eval 'sub ResetFunction () {0x11;}' unless defined(&ResetFunction);
    eval 'sub SetEventMask () {0x31;}' unless defined(&SetEventMask);
    eval 'sub GetEventMask () {0x2e;}' unless defined(&GetEventMask);
    eval 'sub RequestIO () {0x1f;}' unless defined(&RequestIO);
    eval 'sub ReleaseIO () {0x1b;}' unless defined(&ReleaseIO);
    eval 'sub RequestIRQ () {0x20;}' unless defined(&RequestIRQ);
    eval 'sub ReleaseIRQ () {0x1c;}' unless defined(&ReleaseIRQ);
    eval 'sub RequestWindow () {0x21;}' unless defined(&RequestWindow);
    eval 'sub ReleaseWindow () {0x1d;}' unless defined(&ReleaseWindow);
    eval 'sub ModifyWindow () {0x17;}' unless defined(&ModifyWindow);
    eval 'sub MapMemPage () {0x14;}' unless defined(&MapMemPage);
    eval 'sub RequestSocketMask () {0x22;}' unless defined(&RequestSocketMask);
    eval 'sub ReleaseSocketMask () {0x2f;}' unless defined(&ReleaseSocketMask);
    eval 'sub RequestConfiguration () {0x30;}' unless defined(&RequestConfiguration);
    eval 'sub GetConfigurationInfo () {0x4;}' unless defined(&GetConfigurationInfo);
    eval 'sub ModifyConfiguration () {0x27;}' unless defined(&ModifyConfiguration);
    eval 'sub ReleaseConfiguration () {0x1e;}' unless defined(&ReleaseConfiguration);
    eval 'sub AccessConfigurationRegister () {0x36;}' unless defined(&AccessConfigurationRegister);
    eval 'sub OpenMemory () {0x18;}' unless defined(&OpenMemory);
    eval 'sub ReadMemory () {0x19;}' unless defined(&ReadMemory);
    eval 'sub WriteMemory () {0x24;}' unless defined(&WriteMemory);
    eval 'sub CopyMemory () {0x1;}' unless defined(&CopyMemory);
    eval 'sub RegisterEraseQueue () {0xf;}' unless defined(&RegisterEraseQueue);
    eval 'sub CheckEraseQueue () {0x26;}' unless defined(&CheckEraseQueue);
    eval 'sub DeregisterEraseQueue () {0x25;}' unless defined(&DeregisterEraseQueue);
    eval 'sub CloseMemory () {0x;}' unless defined(&CloseMemory);
    eval 'sub GetFirstTuple () {0x7;}' unless defined(&GetFirstTuple);
    eval 'sub GetNextTuple () {0xa;}' unless defined(&GetNextTuple);
    eval 'sub GetTupleData () {0xd;}' unless defined(&GetTupleData);
    eval 'sub GetFirstRegion () {0x6;}' unless defined(&GetFirstRegion);
    eval 'sub GetNextRegion () {0x9;}' unless defined(&GetNextRegion);
    eval 'sub GetFirstPartition () {0x5;}' unless defined(&GetFirstPartition);
    eval 'sub GetNextPartition () {0x8;}' unless defined(&GetNextPartition);
    eval 'sub ReturnSSEntry () {0x23;}' unless defined(&ReturnSSEntry);
    eval 'sub MapLogSocket () {0x12;}' unless defined(&MapLogSocket);
    eval 'sub MapPhySocket () {0x15;}' unless defined(&MapPhySocket);
    eval 'sub MapLogWindow () {0x13;}' unless defined(&MapLogWindow);
    eval 'sub MapPhyWindow () {0x16;}' unless defined(&MapPhyWindow);
    eval 'sub RegisterMTD () {0x1a;}' unless defined(&RegisterMTD);
    eval 'sub RegisterTimer () {0x28;}' unless defined(&RegisterTimer);
    eval 'sub SetRegion () {0x29;}' unless defined(&SetRegion);
    eval 'sub ValidateCIS () {0x2b;}' unless defined(&ValidateCIS);
    eval 'sub RequestExclusive () {0x2c;}' unless defined(&RequestExclusive);
    eval 'sub ReleaseExclusive () {0x2d;}' unless defined(&ReleaseExclusive);
    eval 'sub GetFirstClient () {0xe;}' unless defined(&GetFirstClient);
    eval 'sub GetNextClient () {0x2a;}' unless defined(&GetNextClient);
    eval 'sub GetClientInfo () {0x3;}' unless defined(&GetClientInfo);
    eval 'sub AddSocketServices () {0x32;}' unless defined(&AddSocketServices);
    eval 'sub ReplaceSocketServices () {0x33;}' unless defined(&ReplaceSocketServices);
    eval 'sub VendorSpecific () {0x34;}' unless defined(&VendorSpecific);
    eval 'sub AdjustResourceInfo () {0x35;}' unless defined(&AdjustResourceInfo);
    eval 'sub CISRegister () {0x1000;}' unless defined(&CISRegister);
    eval 'sub CISUnregister () {0x1001;}' unless defined(&CISUnregister);
    eval 'sub InitCISWindow () {0x1002;}' unless defined(&InitCISWindow);
    eval 'sub ParseTuple () {0x2000;}' unless defined(&ParseTuple);
    eval 'sub MakeDeviceNode () {0x2001;}' unless defined(&MakeDeviceNode);
    eval 'sub ConvertSpeed () {0x2002;}' unless defined(&ConvertSpeed);
    eval 'sub ConvertSize () {0x2003;}' unless defined(&ConvertSize);
    eval 'sub Event2Text () {0x2004;}' unless defined(&Event2Text);
    eval 'sub Error2Text () {0x2005;}' unless defined(&Error2Text);
    eval 'sub CS_DDI_Info () {0x2006;}' unless defined(&CS_DDI_Info);
    eval 'sub CS_Sys_Ctl () {0x2007;}' unless defined(&CS_Sys_Ctl);
    eval 'sub RemoveDeviceNode () {0x2008;}' unless defined(&RemoveDeviceNode);
    eval 'sub GetPhysicalAdapterInfo () {0x2009;}' unless defined(&GetPhysicalAdapterInfo);
    eval 'sub CSFuncListEnd () {0x8000;}' unless defined(&CSFuncListEnd);
    eval 'sub CS_ENTRY_REGISTER () {0x1;}' unless defined(&CS_ENTRY_REGISTER);
    eval 'sub CS_ENTRY_DEREGISTER () {0x2;}' unless defined(&CS_ENTRY_DEREGISTER);
    eval 'sub CS_ENTRY_INQUIRE () {0x3;}' unless defined(&CS_ENTRY_INQUIRE);
    if(defined(&__cplusplus)) {
    }
}
1;
