require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CYCLIC_IMPL_H)) {
    eval 'sub _SYS_CYCLIC_IMPL_H () {1;}' unless defined(&_SYS_CYCLIC_IMPL_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/cyclic.ph';
    if(defined(&DEBUG)) {
	eval 'sub CYCLIC_TRACE () {1;}' unless defined(&CYCLIC_TRACE);
    }
    eval("sub CYS_ONLINE () { 0; }") unless defined(&CYS_ONLINE);
    eval("sub CYS_OFFLINE () { 1; }") unless defined(&CYS_OFFLINE);
    eval("sub CYS_EXPANDING () { 2; }") unless defined(&CYS_EXPANDING);
    eval("sub CYS_REMOVING () { 3; }") unless defined(&CYS_REMOVING);
    eval("sub CYS_SUSPENDED () { 4; }") unless defined(&CYS_SUSPENDED);
    eval 'sub CYF_FREE () {0x1;}' unless defined(&CYF_FREE);
    eval 'sub CYF_CPU_BOUND () {0x2;}' unless defined(&CYF_CPU_BOUND);
    eval 'sub CYF_PART_BOUND () {0x4;}' unless defined(&CYF_PART_BOUND);
    if(defined(&CYCLIC_TRACE)) {
	eval 'sub CY_NTRACEREC () {512;}' unless defined(&CY_NTRACEREC);
	eval 'sub CY_NCOVERAGE () {127;}' unless defined(&CY_NCOVERAGE);
    }
    if(defined(&CYCLIC_TRACE)) {
    }
    eval 'sub CY_DEFAULT_PERCPU () {1;}' unless defined(&CY_DEFAULT_PERCPU);
    eval 'sub CY_PASSIVE_LEVEL () {-1;}' unless defined(&CY_PASSIVE_LEVEL);
    eval 'sub CY_WAIT () {0;}' unless defined(&CY_WAIT);
    eval 'sub CY_NOWAIT () {1;}' unless defined(&CY_NOWAIT);
    eval 'sub CYC_HEAP_PARENT {
        my($ndx) = @_;
	    eval q(((($ndx) - 1) >> 1));
    }' unless defined(&CYC_HEAP_PARENT);
    eval 'sub CYC_HEAP_RIGHT {
        my($ndx) = @_;
	    eval q(((($ndx) + 1) << 1));
    }' unless defined(&CYC_HEAP_RIGHT);
    eval 'sub CYC_HEAP_LEFT {
        my($ndx) = @_;
	    eval q((((($ndx) + 1) << 1) - 1));
    }' unless defined(&CYC_HEAP_LEFT);
    if(defined(&__cplusplus)) {
    }
}
1;
