require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DBRIREG_H)) {
    eval 'sub _SYS_DBRIREG_H () {1;}' unless defined(&_SYS_DBRIREG_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub DBRI_NPIPES () {(32);}' unless defined(&DBRI_NPIPES);
    eval 'sub DBRI_STS_PIPEOFFSET () {16;}' unless defined(&DBRI_STS_PIPEOFFSET);
    eval 'sub DBRI_STS_P () {(1<< 15);}' unless defined(&DBRI_STS_P);
    eval 'sub DBRI_STS_S () {(1<< 13);}' unless defined(&DBRI_STS_S);
    eval 'sub DBRI_STS_E () {(1<< 12);}' unless defined(&DBRI_STS_E);
    eval 'sub DBRI_STS_G () {(1<< 14);}' unless defined(&DBRI_STS_G);
    eval 'sub DBRI_STS_X () {(1<< 7);}' unless defined(&DBRI_STS_X);
    eval 'sub DBRI_STS_T () {(1<< 6);}' unless defined(&DBRI_STS_T);
    eval 'sub DBRI_STS_N () {(1<< 5);}' unless defined(&DBRI_STS_N);
    eval 'sub DBRI_STS_C () {(1<< 4);}' unless defined(&DBRI_STS_C);
    eval 'sub DBRI_STS_F () {(1<< 3);}' unless defined(&DBRI_STS_F);
    eval 'sub DBRI_STS_D () {(1<< 2);}' unless defined(&DBRI_STS_D);
    eval 'sub DBRI_STS_H () {(1<< 1);}' unless defined(&DBRI_STS_H);
    eval 'sub DBRI_STS_R () {(1);}' unless defined(&DBRI_STS_R);
    eval 'sub DBRI_INTR_LIT_ENDIAN () {(1<< 8);}' unless defined(&DBRI_INTR_LIT_ENDIAN);
    eval 'sub DBRI_INTR_MRR_ERR () {(1<< 4);}' unless defined(&DBRI_INTR_MRR_ERR);
    eval 'sub DBRI_INTR_LATE_ERR () {(1<< 3);}' unless defined(&DBRI_INTR_LATE_ERR);
    eval 'sub DBRI_INTR_BUS_GRANT_ERR () {(1<< 2);}' unless defined(&DBRI_INTR_BUS_GRANT_ERR);
    eval 'sub DBRI_INTR_BURST_ERR () {(1<< 1);}' unless defined(&DBRI_INTR_BURST_ERR);
    eval 'sub DBRI_INTR_REQ () {(1);}' unless defined(&DBRI_INTR_REQ);
    eval 'sub DBRI_PIO_0 () {(1);}' unless defined(&DBRI_PIO_0);
    eval 'sub DBRI_PIO_1 () {(1<< 1);}' unless defined(&DBRI_PIO_1);
    eval 'sub DBRI_PIO_2 () {(1<< 2);}' unless defined(&DBRI_PIO_2);
    eval 'sub DBRI_PIO_3 () {(1<< 3);}' unless defined(&DBRI_PIO_3);
    eval 'sub DBRI_PIO0_EN () {(1<< 4);}' unless defined(&DBRI_PIO0_EN);
    eval 'sub DBRI_PIO1_EN () {(1<< 5);}' unless defined(&DBRI_PIO1_EN);
    eval 'sub DBRI_PIO2_EN () {(1<< 6);}' unless defined(&DBRI_PIO2_EN);
    eval 'sub DBRI_PIO3_EN () {(1<< 7);}' unless defined(&DBRI_PIO3_EN);
    eval 'sub DBRI_TST_MODE_SPEED () {(1<< 2);}' unless defined(&DBRI_TST_MODE_SPEED);
    eval 'sub DBRI_TST_MODE_PIO () {(1<< 3);}' unless defined(&DBRI_TST_MODE_PIO);
    eval 'sub DBRI_OPSHIFT () {(28);}' unless defined(&DBRI_OPSHIFT);
    eval 'sub DBRI_OPMASK () {(0xf0000000);}' unless defined(&DBRI_OPMASK);
    eval 'sub DBRI_OP {
        my($x) = @_;
	    eval q((((( &uint_t)$x &  &DBRI_OPMASK)) >>  &DBRI_OPSHIFT));
    }' unless defined(&DBRI_OP);
    eval 'sub DBRI_OPCODE {
        my($x) = @_;
	    eval q((((( &uint_t)$x) <<  &DBRI_OPSHIFT) &  &DBRI_OPMASK));
    }' unless defined(&DBRI_OPCODE);
    eval 'sub DBRI_CMD_WAIT () { &DBRI_OPCODE(0x);}' unless defined(&DBRI_CMD_WAIT);
    eval 'sub DBRI_CMD_PAUSE () { &DBRI_OPCODE(0x1);}' unless defined(&DBRI_CMD_PAUSE);
    eval 'sub DBRI_CMD_JMP () { &DBRI_OPCODE(0x2);}' unless defined(&DBRI_CMD_JMP);
    eval 'sub DBRI_CMD_JMP_LEN () {(2);}' unless defined(&DBRI_CMD_JMP_LEN);
    eval 'sub DBRI_CMD_IIQ () { &DBRI_OPCODE(0x3);}' unless defined(&DBRI_CMD_IIQ);
    eval 'sub DBRI_CMD_REX () { &DBRI_OPCODE(0x4);}' unless defined(&DBRI_CMD_REX);
    eval 'sub DBRI_OPCODE_REX () {(0x4);}' unless defined(&DBRI_OPCODE_REX);
    eval 'sub DBRI_CMD_SDP () { &DBRI_OPCODE(0x5);}' unless defined(&DBRI_CMD_SDP);
    eval 'sub DBRI_CMD_CDP () { &DBRI_OPCODE(0x6);}' unless defined(&DBRI_CMD_CDP);
    eval 'sub DBRI_CMD_DTS () { &DBRI_OPCODE(0x7);}' unless defined(&DBRI_CMD_DTS);
    eval 'sub DBRI_OPCODE_DTS () {(0x7);}' unless defined(&DBRI_OPCODE_DTS);
    eval 'sub DBRI_CMD_SSP () { &DBRI_OPCODE(0x8);}' unless defined(&DBRI_CMD_SSP);
    eval 'sub DBRI_CMD_CHI () { &DBRI_OPCODE(0x9);}' unless defined(&DBRI_CMD_CHI);
    eval 'sub DBRI_CMD_NT () { &DBRI_OPCODE(0xa);}' unless defined(&DBRI_CMD_NT);
    eval 'sub DBRI_CMD_TE () { &DBRI_OPCODE(0xb);}' unless defined(&DBRI_CMD_TE);
    eval 'sub DBRI_CMD_CDEC () { &DBRI_OPCODE(0xc);}' unless defined(&DBRI_CMD_CDEC);
    eval 'sub DBRI_CMD_TEST () { &DBRI_OPCODE(0xd);}' unless defined(&DBRI_CMD_TEST);
    eval 'sub DBRI_CMD_CDM () { &DBRI_OPCODE(0xe);}' unless defined(&DBRI_CMD_CDM);
    eval 'sub DBRI_CMDI () {(1<< 27);}' unless defined(&DBRI_CMDI);
    eval 'sub DBRI_CMD_VALUE {
        my($a) = @_;
	    eval q(($a & 0x7ff));
    }' unless defined(&DBRI_CMD_VALUE);
    eval 'sub DBRI_CMD_MASK () {(0xf <<  &DBRI_OPSHIFT);}' unless defined(&DBRI_CMD_MASK);
    eval 'sub DBRI_SDP_COLL () {(1<< 19);}' unless defined(&DBRI_SDP_COLL);
    eval 'sub DBRI_SDP_IRM () {(0);}' unless defined(&DBRI_SDP_IRM);
    eval 'sub DBRI_SDP_PIPE {
        my($a) = @_;
	    eval q(($a & 0x1f));
    }' unless defined(&DBRI_SDP_PIPE);
    eval 'sub DBRI_SDP_TWOSAME () {(1<< 18);}' unless defined(&DBRI_SDP_TWOSAME);
    eval 'sub DBRI_SDP_CHNG () {(2<< 18);}' unless defined(&DBRI_SDP_CHNG);
    eval 'sub DBRI_SDP_ALLVAL () {(3<< 18);}' unless defined(&DBRI_SDP_ALLVAL);
    eval 'sub DBRI_SDP_EOL () {(1<< 17);}' unless defined(&DBRI_SDP_EOL);
    eval 'sub DBRI_SDP_IBEG () {(1<< 16);}' unless defined(&DBRI_SDP_IBEG);
    eval 'sub DBRI_SDP_TRANSPARENT () {(0<< 13);}' unless defined(&DBRI_SDP_TRANSPARENT);
    eval 'sub DBRI_SDP_HDLC () {(2<< 13);}' unless defined(&DBRI_SDP_HDLC);
    eval 'sub DBRI_SDP_TE_DCHAN () {(3<< 13);}' unless defined(&DBRI_SDP_TE_DCHAN);
    eval 'sub DBRI_SDP_SERIAL () {(4<< 13);}' unless defined(&DBRI_SDP_SERIAL);
    eval 'sub DBRI_SDP_FIXED () {(6<< 13);}' unless defined(&DBRI_SDP_FIXED);
    eval 'sub DBRI_SDP_MODEMASK () {(7<< 13);}' unless defined(&DBRI_SDP_MODEMASK);
    eval 'sub DBRI_SDP_D () {(1<< 12);}' unless defined(&DBRI_SDP_D);
    eval 'sub DBRI_SDP_B () {(1<< 11);}' unless defined(&DBRI_SDP_B);
    eval 'sub DBRI_SDP_PTR () {(1<< 10);}' unless defined(&DBRI_SDP_PTR);
    eval 'sub DBRI_SDP_IDL () {(1<< 9);}' unless defined(&DBRI_SDP_IDL);
    eval 'sub DBRI_SDP_ABT () {(1<< 8);}' unless defined(&DBRI_SDP_ABT);
    eval 'sub DBRI_SDP_CLR () {(1<< 7);}' unless defined(&DBRI_SDP_CLR);
    eval 'sub DBRI_SDP_CMDMASK () {(0xf << 7);}' unless defined(&DBRI_SDP_CMDMASK);
    eval 'sub DBRI_CDP_PIPE {
        my($a) = @_;
	    eval q(($a & 0x1f));
    }' unless defined(&DBRI_CDP_PIPE);
    eval 'sub DBRI_DTS_VI () {1;}' unless defined(&DBRI_DTS_VI);
    eval 'sub DBRI_DTS_VO () {1;}' unless defined(&DBRI_DTS_VO);
    eval 'sub DBRI_DTS_ID () {1;}' unless defined(&DBRI_DTS_ID);
    eval 'sub DBRI_DTS_DI () {1;}' unless defined(&DBRI_DTS_DI);
    eval 'sub DBRI_DTS_SINGLE () {0;}' unless defined(&DBRI_DTS_SINGLE);
    eval 'sub DBRI_DTS_MONITOR () {2;}' unless defined(&DBRI_DTS_MONITOR);
    eval 'sub DBRI_DTS_INDIRECT () {3;}' unless defined(&DBRI_DTS_INDIRECT);
    eval 'sub DBRI_DTS_ALTERNATE () {7;}' unless defined(&DBRI_DTS_ALTERNATE);
    eval 'sub DBRI_SSP_PIPE {
        my($a) = @_;
	    eval q((($a) & 0x1f));
    }' unless defined(&DBRI_SSP_PIPE);
    eval 'sub DBRI_CHI_CHICM {
        my($a) = @_;
	    eval q(((($a) & 0xff) << 16));
    }' unless defined(&DBRI_CHI_CHICM);
    eval 'sub DBRI_CHI_INT () {(1<< 15);}' unless defined(&DBRI_CHI_INT);
    eval 'sub DBRI_CHI_CHIL () {(1<< 14);}' unless defined(&DBRI_CHI_CHIL);
    eval 'sub DBRI_CHI_OD () {(1<< 13);}' unless defined(&DBRI_CHI_OD);
    eval 'sub DBRI_CHI_FE () {(1<< 12);}' unless defined(&DBRI_CHI_FE);
    eval 'sub DBRI_CHI_FD () {(1<< 11);}' unless defined(&DBRI_CHI_FD);
    eval 'sub DBRI_CHI_BPF {
        my($a) = @_;
	    eval q((($a) & 0x7ff));
    }' unless defined(&DBRI_CHI_BPF);
    eval 'sub DBRI_NTE_F () {(1<< 17);}' unless defined(&DBRI_NTE_F);
    eval 'sub DBRI_NTE_NBF () {(1<< 16);}' unless defined(&DBRI_NTE_NBF);
    eval 'sub DBRI_NTE_IRM_STATUS () {(1<< 15);}' unless defined(&DBRI_NTE_IRM_STATUS);
    eval 'sub DBRI_NTE_IRM_SBRI () {(1<< 14);}' unless defined(&DBRI_NTE_IRM_SBRI);
    eval 'sub DBRI_NTE_ISNT () {(1<< 13);}' unless defined(&DBRI_NTE_ISNT);
    eval 'sub DBRI_NT_FT () {(1<< 12);}' unless defined(&DBRI_NT_FT);
    eval 'sub DBRI_NTE_EZ () {(1<< 11);}' unless defined(&DBRI_NTE_EZ);
    eval 'sub DBRI_NTE_IFA () {(1<< 10);}' unless defined(&DBRI_NTE_IFA);
    eval 'sub DBRI_NTE_ACT () {(1<< 9);}' unless defined(&DBRI_NTE_ACT);
    eval 'sub DBRI_NT_MFE () {(1<< 8);}' unless defined(&DBRI_NT_MFE);
    eval 'sub DBRI_TE_QE () {(1<< 8);}' unless defined(&DBRI_TE_QE);
    eval 'sub DBRI_NTE_RLB_D () {(1<< 7);}' unless defined(&DBRI_NTE_RLB_D);
    eval 'sub DBRI_NTE_RLB_B1 () {(1<< 6);}' unless defined(&DBRI_NTE_RLB_B1);
    eval 'sub DBRI_NTE_RLB_B2 () {(1<< 5);}' unless defined(&DBRI_NTE_RLB_B2);
    eval 'sub DBRI_NTE_LLB_D () {(1<< 4);}' unless defined(&DBRI_NTE_LLB_D);
    eval 'sub DBRI_NTE_LLB_B1 () {(1<< 3);}' unless defined(&DBRI_NTE_LLB_B1);
    eval 'sub DBRI_NTE_LLB_B2 () {(1<< 2);}' unless defined(&DBRI_NTE_LLB_B2);
    eval 'sub DBRI_NTE_FACT () {(1<< 1);}' unless defined(&DBRI_NTE_FACT);
    eval 'sub DBRI_NTE_ABV () {(1);}' unless defined(&DBRI_NTE_ABV);
    eval 'sub DBRI_CDEC_DISABL_CLK () {(0<< 24);}' unless defined(&DBRI_CDEC_DISABL_CLK);
    eval 'sub DBRI_CDEC_2MHZ () {(1<< 24);}' unless defined(&DBRI_CDEC_2MHZ);
    eval 'sub DBRI_CDEC_1_5MHZ () {(2<< 24);}' unless defined(&DBRI_CDEC_1_5MHZ);
    eval 'sub DBRI_CDEC_FE_FSCOD {
        my($a) = @_;
	    eval q(((($a) & 0x7ff) << 12));
    }' unless defined(&DBRI_CDEC_FE_FSCOD);
    eval 'sub DBRI_CDEC_RE_FSCOD {
        my($a) = @_;
	    eval q((($a) & 0x7ff));
    }' unless defined(&DBRI_CDEC_RE_FSCOD);
    eval 'sub DBRI_TST_TYPE {
        my($a) = @_;
	    eval q((($a) & 0x7ff));
    }' unless defined(&DBRI_TST_TYPE);
    eval 'sub DBRI_TST_RAMPTR {
        my($a) = @_;
	    eval q(((($a) & 0x3ff) << 16));
    }' unless defined(&DBRI_TST_RAMPTR);
    eval 'sub DBRI_TST_SIZE {
        my($a) = @_;
	    eval q(((($a) & 0x1f) << 11));
    }' unless defined(&DBRI_TST_SIZE);
    eval 'sub DBRI_TST_ROMMON () {0x5;}' unless defined(&DBRI_TST_ROMMON);
    eval 'sub DBRI_TST_SBUS () {0x6;}' unless defined(&DBRI_TST_SBUS);
    eval 'sub DBRI_TST_SERIAL () {0x7;}' unless defined(&DBRI_TST_SERIAL);
    eval 'sub DBRI_TST_RAM_RD () {0x8;}' unless defined(&DBRI_TST_RAM_RD);
    eval 'sub DBRI_TST_RAM_WT () {0x9;}' unless defined(&DBRI_TST_RAM_WT);
    eval 'sub DBRI_TST_RAM_BIST () {0xa;}' unless defined(&DBRI_TST_RAM_BIST);
    eval 'sub DBRI_TST_UCTL_BIST () {0xb;}' unless defined(&DBRI_TST_UCTL_BIST);
    eval 'sub DBRI_TST_ROM_DUMP () {0xc;}' unless defined(&DBRI_TST_ROM_DUMP);
    eval 'sub DBRI_CDM_THI () {(1<< 8);}' unless defined(&DBRI_CDM_THI);
    eval 'sub DBRI_CDM_RHI () {(1<< 7);}' unless defined(&DBRI_CDM_RHI);
    eval 'sub DBRI_CDM_RCE () {(1<< 6);}' unless defined(&DBRI_CDM_RCE);
    eval 'sub DBRI_CDM_CMSR () {(1<< 5);}' unless defined(&DBRI_CDM_CMSR);
    eval 'sub DBRI_CDM_ODD () {(1<< 4);}' unless defined(&DBRI_CDM_ODD);
    eval 'sub DBRI_CDM_CMSX () {(1<< 3);}' unless defined(&DBRI_CDM_CMSX);
    eval 'sub DBRI_CDM_XCE () {(1<< 2);}' unless defined(&DBRI_CDM_XCE);
    eval 'sub DBRI_CDM_XEN () {(1<< 1);}' unless defined(&DBRI_CDM_XEN);
    eval 'sub DBRI_CDM_REN () {(1);}' unless defined(&DBRI_CDM_REN);
    eval 'sub DBRI_MAX_QWORDS () {63;}' unless defined(&DBRI_MAX_QWORDS);
    eval 'sub DBRI_INT_IBITS () {0x2;}' unless defined(&DBRI_INT_IBITS);
    eval 'sub DBRI_INT_MAX_CHAN () {(32);}' unless defined(&DBRI_INT_MAX_CHAN);
    eval 'sub DBRI_INT_TE_CHAN () {(32);}' unless defined(&DBRI_INT_TE_CHAN);
    eval 'sub DBRI_INT_NT_CHAN () {(34);}' unless defined(&DBRI_INT_NT_CHAN);
    eval 'sub DBRI_INT_CHI_CHAN () {(36);}' unless defined(&DBRI_INT_CHI_CHAN);
    eval 'sub DBRI_INT_REPORT_CHAN () {(38);}' unless defined(&DBRI_INT_REPORT_CHAN);
    eval 'sub DBRI_INT_OTHER_CHAN () {(40);}' unless defined(&DBRI_INT_OTHER_CHAN);
    eval 'sub DBRI_INT_BRDY () {0x1;}' unless defined(&DBRI_INT_BRDY);
    eval 'sub DBRI_INT_MINT () {0x2;}' unless defined(&DBRI_INT_MINT);
    eval 'sub DBRI_INT_IBEG () {0x3;}' unless defined(&DBRI_INT_IBEG);
    eval 'sub DBRI_INT_IEND () {0x4;}' unless defined(&DBRI_INT_IEND);
    eval 'sub DBRI_INT_EOL () {0x5;}' unless defined(&DBRI_INT_EOL);
    eval 'sub DBRI_INT_CMDI () {0x6;}' unless defined(&DBRI_INT_CMDI);
    eval 'sub DBRI_INT_XCMP () {0x8;}' unless defined(&DBRI_INT_XCMP);
    eval 'sub DBRI_INT_SBRI () {0x9;}' unless defined(&DBRI_INT_SBRI);
    eval 'sub DBRI_INT_FXDT () {0xa;}' unless defined(&DBRI_INT_FXDT);
    eval 'sub DBRI_INT_CHIL () {0xb;}' unless defined(&DBRI_INT_CHIL);
    eval 'sub DBRI_INT_COLL () {0xb;}' unless defined(&DBRI_INT_COLL);
    eval 'sub DBRI_INT_DBYT () {0xc;}' unless defined(&DBRI_INT_DBYT);
    eval 'sub DBRI_INT_RBYT () {0xd;}' unless defined(&DBRI_INT_RBYT);
    eval 'sub DBRI_INT_LINT () {0xe;}' unless defined(&DBRI_INT_LINT);
    eval 'sub DBRI_INT_UNDR () {0xf;}' unless defined(&DBRI_INT_UNDR);
    eval 'sub DBRI_NTINFO0_G1 () {0x;}' unless defined(&DBRI_NTINFO0_G1);
    eval 'sub DBRI_NTINFO2_G2 () {0x6;}' unless defined(&DBRI_NTINFO2_G2);
    eval 'sub DBRI_NTINFO4_G3 () {0x7;}' unless defined(&DBRI_NTINFO4_G3);
    eval 'sub DBRI_NTINFO0_G4 () {0x1;}' unless defined(&DBRI_NTINFO0_G4);
    eval 'sub DBRI_TEINFO0_F1 () {0x;}' unless defined(&DBRI_TEINFO0_F1);
    eval 'sub DBRI_TEINFO0_F8 () {0x2;}' unless defined(&DBRI_TEINFO0_F8);
    eval 'sub DBRI_TEINFO0_F3 () {0x3;}' unless defined(&DBRI_TEINFO0_F3);
    eval 'sub DBRI_TEINFO1_F4 () {0x4;}' unless defined(&DBRI_TEINFO1_F4);
    eval 'sub DBRI_TEINFO0_F5 () {0x5;}' unless defined(&DBRI_TEINFO0_F5);
    eval 'sub DBRI_TEINFO3_F6 () {0x6;}' unless defined(&DBRI_TEINFO3_F6);
    eval 'sub DBRI_TEINFO3_F7 () {0x7;}' unless defined(&DBRI_TEINFO3_F7);
    eval 'sub DBRI_D_CLASS_1 () {0;}' unless defined(&DBRI_D_CLASS_1);
    eval 'sub DBRI_D_CLASS_2 () {1;}' unless defined(&DBRI_D_CLASS_2);
    eval 'sub DBRI_TMD_UNR () {(1<< 3);}' unless defined(&DBRI_TMD_UNR);
    eval 'sub DBRI_TMD_ABT () {(1<< 2);}' unless defined(&DBRI_TMD_ABT);
    eval 'sub DBRI_TMD_TFC () {(1<< 1);}' unless defined(&DBRI_TMD_TFC);
    eval 'sub DBRI_TMD_TBC () {(1);}' unless defined(&DBRI_TMD_TBC);
    eval 'sub DBRI_MAX_DMASIZE () {(8191);}' unless defined(&DBRI_MAX_DMASIZE);
    eval 'sub DBRI_RMD_CRC () {(1<< 7);}' unless defined(&DBRI_RMD_CRC);
    eval 'sub DBRI_RMD_BBC () {(1<< 6);}' unless defined(&DBRI_RMD_BBC);
    eval 'sub DBRI_RMD_ABT () {(1<< 5);}' unless defined(&DBRI_RMD_ABT);
    eval 'sub DBRI_RMD_OVRN () {(1<< 3);}' unless defined(&DBRI_RMD_OVRN);
    if(defined(&__cplusplus)) {
    }
}
1;
