require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_DC_KI_H)) {
    eval 'sub _DC_KI_H () {1;}' unless defined(&_DC_KI_H);
    require 'sys/types.ph';
    require 'sys/sunddi.ph';
    require 'sys/modctl.ph';
    if(defined(&__cplusplus)) {
    }
    eval("sub DEV_INVALID () { 0; }") unless defined(&DEV_INVALID);
    eval("sub DEV_GLOBAL () { GLOBAL_DEV; }") unless defined(&DEV_GLOBAL);
    eval("sub DEV_NODEBOUND () { NODEBOUND_DEV; }") unless defined(&DEV_NODEBOUND);
    eval("sub DEV_NODESPECIFIC () { NODESPECIFIC_DEV; }") unless defined(&DEV_NODESPECIFIC);
    eval("sub DEV_ENUMERATED () { ENUMERATED_DEV; }") unless defined(&DEV_ENUMERATED);
    eval("sub DEV_CLONE () { CLONE_DEV; }") unless defined(&DEV_CLONE);
    eval 'sub EMINOR_UNKNOWN () {(( &minor_t)(-1));}' unless defined(&EMINOR_UNKNOWN);
    eval 'sub CLUSTER_DEVICE_BASE () {"/node@";}' unless defined(&CLUSTER_DEVICE_BASE);
    eval 'sub CLUSTER_DEVICE_BASE_LEN () {($sizeof{ &CLUSTER_DEVICE_BASE} - 1);}' unless defined(&CLUSTER_DEVICE_BASE_LEN);
    eval 'sub DC_CLSLEEP () {0;}' unless defined(&DC_CLSLEEP);
    eval 'sub DC_CLNOSLEEP () {1;}' unless defined(&DC_CLNOSLEEP);
    eval 'sub DCOPS_VERSION () {1;}' unless defined(&DCOPS_VERSION);
    eval 'sub DC_GET_MAJOR {
        my($mopsp, $major, $driver_name) = @_;
	    eval q(((($mopsp)-> &dc_get_major)($major, $driver_name)));
    }' unless defined(&DC_GET_MAJOR);
    eval 'sub DC_FREE_MAJOR {
        my($mopsp, $major, $driver) = @_;
	    eval q(((($mopsp)-> &dc_free_major)($major, $driver)));
    }' unless defined(&DC_FREE_MAJOR);
    eval 'sub DC_MAJOR_NAME {
        my($mopsp, $major, $driver_name) = @_;
	    eval q(((($mopsp)-> &dc_major_name)($major, $driver_name)));
    }' unless defined(&DC_MAJOR_NAME);
    eval 'sub DC_SYNC_INSTANCES {
        my($mopsp) = @_;
	    eval q(((($mopsp)-> &dc_sync_instances)()));
    }' unless defined(&DC_SYNC_INSTANCES);
    eval 'sub DC_INSTANCE_PATH {
        my($mopsp, $major, $path, $inst_number) = @_;
	    eval q(((($mopsp)-> &dc_instance_path)($major, $path, $inst_number)));
    }' unless defined(&DC_INSTANCE_PATH);
    eval 'sub DC_GET_INSTANCE {
        my($mopsp, $maj, $path, $inst_number) = @_;
	    eval q(((($mopsp)-> &dc_get_instance)($maj, $path, $inst_number)));
    }' unless defined(&DC_GET_INSTANCE);
    eval 'sub DC_FREE_INSTANCE {
        my($mopsp, $major, $path, $inst) = @_;
	    eval q(((($mopsp)-> &dc_free_instance)($major, $path, $inst)));
    }' unless defined(&DC_FREE_INSTANCE);
    eval 'sub DC_MAP_MINOR {
        my($mopsp, $major, $lminor, $gminor, $dev_type) = @_;
	    eval q(((($mopsp)-> &dc_map_minor)($major, $lminor, $gminor, $dev_type)));
    }' unless defined(&DC_MAP_MINOR);
    eval 'sub DC_UNMAP_MINOR {
        my($mopsp, $major, $lminor, $gminor, $dev_type) = @_;
	    eval q(((($mopsp)-> &dc_unmap_minor)($major, $lminor, $gminor, $dev_type)));
    }' unless defined(&DC_UNMAP_MINOR);
    eval 'sub DC_RESOLVE_MINOR {
        my($mopsp, $major, $gminor, $lminor, $dev_type) = @_;
	    eval q(((($mopsp)-> &dc_resolve_minor)($major, $gminor, $lminor, $dev_type)));
    }' unless defined(&DC_RESOLVE_MINOR);
    eval 'sub DC_DEVCONFIG_LOCK {
        my($mopsp, $sleep) = @_;
	    eval q(((($mopsp)-> &dc_devconfig_lock)($sleep)));
    }' unless defined(&DC_DEVCONFIG_LOCK);
    eval 'sub DC_DEVCONFIG_UNLOCK {
        my($mopsp) = @_;
	    eval q(((($mopsp)-> &dc_devconfig_unlock)()));
    }' unless defined(&DC_DEVCONFIG_UNLOCK);
    eval 'sub DC_SERVICE_CONFIG {
        my($mopsp, $cmd, $service_args_ptr, $mode) = @_;
	    eval q(((($mopsp)-> &dc_service_config)($cmd, $service_args_ptr, $mode)));
    }' unless defined(&DC_SERVICE_CONFIG);
    eval("sub DC_READONLY () { 0; }") unless defined(&DC_READONLY);
    eval("sub DC_INSTALLING () { 1; }") unless defined(&DC_INSTALLING);
    eval("sub DC_READY () { 2; }") unless defined(&DC_READY);
    if(defined(&__cplusplus)) {
    }
}
1;
