require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DDI_IMPLDEFS_H)) {
    eval 'sub _SYS_DDI_IMPLDEFS_H () {1;}' unless defined(&_SYS_DDI_IMPLDEFS_H);
    require 'sys/types.ph';
    require 'sys/param.ph';
    require 'sys/t_lock.ph';
    require 'sys/ddipropdefs.ph';
    require 'sys/devops.ph';
    require 'sys/autoconf.ph';
    require 'sys/mutex.ph';
    require 'vm/page.ph';
    require 'sys/dacf_impl.ph';
    if(defined(&__cplusplus)) {
    }
    eval("sub DDI_NC_PROM () { 0; }") unless defined(&DDI_NC_PROM);
    eval("sub DDI_NC_PSEUDO () { 1; }") unless defined(&DDI_NC_PSEUDO);
    eval 'sub DEVI {
        my($dev_info_type) = @_;
	    eval q((($dev_info_type)));
    }' unless defined(&DEVI);
    eval 'sub devi_name () { &devi_binding_name;}' unless defined(&devi_name);
    eval 'sub DDI_CF1 {
        my($devi) = @_;
	    eval q(( &DEVI($devi)-> &devi_addr !=  &NULL));
    }' unless defined(&DDI_CF1);
    eval 'sub DDI_CF2 {
        my($devi) = @_;
	    eval q(( &DEVI($devi)-> &devi_ops !=  &NULL));
    }' unless defined(&DDI_CF2);
    eval 'sub DDI_DRV_UNLOADED {
        my($devi) = @_;
	    eval q(( &DEVI($devi)-> &devi_ops ==  &mod_nodev_ops));
    }' unless defined(&DDI_DRV_UNLOADED);
    eval 'sub DEVI_DEVICE_OFFLINE () {0x1;}' unless defined(&DEVI_DEVICE_OFFLINE);
    eval 'sub DEVI_DEVICE_DOWN () {0x2;}' unless defined(&DEVI_DEVICE_DOWN);
    eval 'sub DEVI_DEVICE_DEGRADED () {0x4;}' unless defined(&DEVI_DEVICE_DEGRADED);
    eval 'sub DEVI_BUS_QUIESCED () {0x100;}' unless defined(&DEVI_BUS_QUIESCED);
    eval 'sub DEVI_BUS_DOWN () {0x200;}' unless defined(&DEVI_BUS_DOWN);
    eval 'sub DEVI_NDI_CONFIG () {0x400;}' unless defined(&DEVI_NDI_CONFIG);
    eval 'sub DEVI_S_ATTACHING () {0x10000;}' unless defined(&DEVI_S_ATTACHING);
    eval 'sub DEVI_S_DETACHING () {0x20000;}' unless defined(&DEVI_S_DETACHING);
    eval 'sub DEVI_S_ONLINING () {0x40000;}' unless defined(&DEVI_S_ONLINING);
    eval 'sub DEVI_S_OFFLINING () {0x80000;}' unless defined(&DEVI_S_OFFLINING);
    eval 'sub DEVI_S_INVOKING_DACF () {0x100000;}' unless defined(&DEVI_S_INVOKING_DACF);
    eval 'sub DEVI_S_UNBOUND () {0x200000;}' unless defined(&DEVI_S_UNBOUND);
    eval 'sub DEVI_S_MD_UPDATE () {0x400000;}' unless defined(&DEVI_S_MD_UPDATE);
    eval 'sub DEVI_S_REPORT () {0x8000000;}' unless defined(&DEVI_S_REPORT);
    eval 'sub DEVI_IS_DEVICE_OFFLINE {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_DEVICE_OFFLINE) ==  &DEVI_DEVICE_OFFLINE));
    }' unless defined(&DEVI_IS_DEVICE_OFFLINE);
    eval 'sub DEVI_SET_DEVICE_ONLINE {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state &= ~( &DEVI_DEVICE_OFFLINE |  &DEVI_DEVICE_DEGRADED |  &DEVI_DEVICE_DOWN)));
    }' unless defined(&DEVI_SET_DEVICE_ONLINE);
    eval 'sub DEVI_SET_DEVICE_OFFLINE {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state |=  &DEVI_DEVICE_OFFLINE));
    }' unless defined(&DEVI_SET_DEVICE_OFFLINE);
    eval 'sub DEVI_IS_DEVICE_DOWN {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_DEVICE_DOWN) ==  &DEVI_DEVICE_DOWN));
    }' unless defined(&DEVI_IS_DEVICE_DOWN);
    eval 'sub DEVI_SET_DEVICE_DOWN {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state |=  &DEVI_DEVICE_DOWN));
    }' unless defined(&DEVI_SET_DEVICE_DOWN);
    eval 'sub DEVI_IS_DEVICE_DEGRADED {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state & ( &DEVI_DEVICE_DEGRADED| &DEVI_DEVICE_DOWN)) ==  &DEVI_DEVICE_DEGRADED));
    }' unless defined(&DEVI_IS_DEVICE_DEGRADED);
    eval 'sub DEVI_SET_DEVICE_DEGRADED {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state |=  &DEVI_DEVICE_DEGRADED));
    }' unless defined(&DEVI_SET_DEVICE_DEGRADED);
    eval 'sub DEVI_SET_DEVICE_UP {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state &= ~( &DEVI_DEVICE_DEGRADED| &DEVI_DEVICE_DOWN)));
    }' unless defined(&DEVI_SET_DEVICE_UP);
    eval 'sub DEVI_IS_BUS_QUIESCED {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_BUS_QUIESCED) ==  &DEVI_BUS_QUIESCED));
    }' unless defined(&DEVI_IS_BUS_QUIESCED);
    eval 'sub DEVI_SET_BUS_ACTIVE {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state &= ~ &DEVI_BUS_QUIESCED));
    }' unless defined(&DEVI_SET_BUS_ACTIVE);
    eval 'sub DEVI_SET_BUS_QUIESCE {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state |=  &DEVI_BUS_QUIESCED));
    }' unless defined(&DEVI_SET_BUS_QUIESCE);
    eval 'sub DEVI_IS_BUS_DOWN {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_BUS_DOWN) ==  &DEVI_BUS_DOWN));
    }' unless defined(&DEVI_IS_BUS_DOWN);
    eval 'sub DEVI_SET_BUS_UP {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state &= ~ &DEVI_BUS_DOWN));
    }' unless defined(&DEVI_SET_BUS_UP);
    eval 'sub DEVI_SET_BUS_DOWN {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state |=  &DEVI_BUS_DOWN));
    }' unless defined(&DEVI_SET_BUS_DOWN);
    eval 'sub DEVI_NEEDS_BINDING {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_S_UNBOUND) != 0));
    }' unless defined(&DEVI_NEEDS_BINDING);
    eval 'sub DEVI_SET_BOUND {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_REPORT); ( &DEVI(($dip))-> &devi_state &= ~ &DEVI_S_UNBOUND));
    }' unless defined(&DEVI_SET_BOUND);
    eval 'sub DEVI_NEED_REPORT {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_S_REPORT) ==  &DEVI_S_REPORT));
    }' unless defined(&DEVI_NEED_REPORT);
    eval 'sub DEVI_REPORT_DONE {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state &= ~ &DEVI_S_REPORT));
    }' unless defined(&DEVI_REPORT_DONE);
    eval 'sub DEVI_NEED_NDI_CONFIG {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_NDI_CONFIG) ==  &DEVI_NDI_CONFIG));
    }' unless defined(&DEVI_NEED_NDI_CONFIG);
    eval 'sub DEVI_SET_NDI_CONFIG {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_NDI_CONFIG));
    }' unless defined(&DEVI_SET_NDI_CONFIG);
    eval 'sub DEVI_CLR_NDI_CONFIG {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state &= ~ &DEVI_NDI_CONFIG));
    }' unless defined(&DEVI_CLR_NDI_CONFIG);
    eval 'sub DEVI_SET_ATTACHING {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_ATTACHING));
    }' unless defined(&DEVI_SET_ATTACHING);
    eval 'sub DEVI_CLR_ATTACHING {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state &= ~ &DEVI_S_ATTACHING));
    }' unless defined(&DEVI_CLR_ATTACHING);
    eval 'sub DEVI_IS_ATTACHING {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_S_ATTACHING) ==  &DEVI_S_ATTACHING));
    }' unless defined(&DEVI_IS_ATTACHING);
    eval 'sub DEVI_SET_DETACHING {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_DETACHING));
    }' unless defined(&DEVI_SET_DETACHING);
    eval 'sub DEVI_CLR_DETACHING {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state &= ~ &DEVI_S_DETACHING));
    }' unless defined(&DEVI_CLR_DETACHING);
    eval 'sub DEVI_IS_DETACHING {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_S_DETACHING) ==  &DEVI_S_DETACHING));
    }' unless defined(&DEVI_IS_DETACHING);
    eval 'sub DEVI_SET_ONLINING {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_ONLINING));
    }' unless defined(&DEVI_SET_ONLINING);
    eval 'sub DEVI_CLR_ONLINING {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state &= ~ &DEVI_S_ONLINING));
    }' unless defined(&DEVI_CLR_ONLINING);
    eval 'sub DEVI_IS_ONLINING {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_S_ONLINING) ==  &DEVI_S_ONLINING));
    }' unless defined(&DEVI_IS_ONLINING);
    eval 'sub DEVI_SET_OFFLINING {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_OFFLINING));
    }' unless defined(&DEVI_SET_OFFLINING);
    eval 'sub DEVI_CLR_OFFLINING {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state &= ~ &DEVI_S_OFFLINING));
    }' unless defined(&DEVI_CLR_OFFLINING);
    eval 'sub DEVI_IS_OFFLINING {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_S_OFFLINING) ==  &DEVI_S_OFFLINING));
    }' unless defined(&DEVI_IS_OFFLINING);
    eval 'sub DEVI_IS_IN_RECONFIG {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state & ( &DEVI_S_OFFLINING |  &DEVI_S_ONLINING)));
    }' unless defined(&DEVI_IS_IN_RECONFIG);
    eval 'sub DEVI_IS_INVOKING_DACF {
        my($dip) = @_;
	    eval q((( &DEVI(($dip))-> &devi_state &  &DEVI_S_INVOKING_DACF) ==  &DEVI_S_INVOKING_DACF));
    }' unless defined(&DEVI_IS_INVOKING_DACF);
    eval 'sub DEVI_SET_INVOKING_DACF {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state |=  &DEVI_S_INVOKING_DACF));
    }' unless defined(&DEVI_SET_INVOKING_DACF);
    eval 'sub DEVI_CLR_INVOKING_DACF {
        my($dip) = @_;
	    eval q(( &DEVI(($dip))-> &devi_state &= ~ &DEVI_S_INVOKING_DACF));
    }' unless defined(&DEVI_CLR_INVOKING_DACF);
    eval 'sub EVC_BUCKETS () {128;}' unless defined(&EVC_BUCKETS);
    eval 'sub EVC_HASH {
        my($num) = @_;
	    eval q(((($num) & ( &EVC_BUCKETS - 1))));
    }' unless defined(&EVC_HASH);
    if(defined(&_KERNEL)) {
	eval("sub DDI_PRE () { 0; }") unless defined(&DDI_PRE);
	eval("sub DDI_POST () { 1; }") unless defined(&DDI_POST);
    }
    eval("sub DDM_MINOR () { 0; }") unless defined(&DDM_MINOR);
    eval("sub DDM_ALIAS () { 1; }") unless defined(&DDM_ALIAS);
    eval("sub DDM_DEFAULT () { 2; }") unless defined(&DDM_DEFAULT);
    eval("sub DDM_INTERNAL_PATH () { 3; }") unless defined(&DDM_INTERNAL_PATH);
    eval 'sub DDI_PERSISTENT () {0x1;}' unless defined(&DDI_PERSISTENT);
    eval 'sub DDI_AUTO_ASSIGNED_NODEID () {0x2;}' unless defined(&DDI_AUTO_ASSIGNED_NODEID);
    if(defined(&_KERNEL)) {
    }
    eval 'sub ddm_name () { ($mu->{d_minor}->{name});}' unless defined(&ddm_name);
    eval 'sub ddm_aname () { ($mu->{d_alias}->{dmp}->{mu}->{d_minor}->{name});}' unless defined(&ddm_aname);
    eval 'sub ddm_dev () { ($mu->{d_minor}->{dev});}' unless defined(&ddm_dev);
    eval 'sub ddm_eminor () { ($mu->{d_minor}->{eminor});}' unless defined(&ddm_eminor);
    eval 'sub ddm_class () { ($mu->{d_minor}->{mdclass});}' unless defined(&ddm_class);
    eval 'sub ddm_adev () { ($mu->{d_alias}->{dmp}->{mu}->{d_minor}->{dev});}' unless defined(&ddm_adev);
    eval 'sub ddm_spec_type () { ($mu->{d_minor}->{spec_type});}' unless defined(&ddm_spec_type);
    eval 'sub ddm_aspec_type () { ($mu->{d_alias}->{dmp}->{mu}->{d_minor}->{spec_type});}' unless defined(&ddm_aspec_type);
    eval 'sub ddm_node_type () { ($mu->{d_minor}->{node_type});}' unless defined(&ddm_node_type);
    eval 'sub ddm_anode_type () { ($mu->{d_alias}->{dmp}->{mu}->{d_minor}->{node_type});}' unless defined(&ddm_anode_type);
    eval 'sub ddm_admp () { ($mu->{d_alias}->{dmp});}' unless defined(&ddm_admp);
    eval 'sub ddm_atype () { ($mu->{d_alias}->{dmp}->{type});}' unless defined(&ddm_atype);
    eval 'sub ddm_adip () { ($mu->{d_alias}->{dmp}->{dip});}' unless defined(&ddm_adip);
    eval 'sub DEVI_PD {
        my($d) = @_;
	    eval q(( &DEVI(($d))-> &devi_parent_data));
    }' unless defined(&DEVI_PD);
    eval 'sub sparc_pd_getnreg {
        my($dev) = @_;
	    eval q(( &DEVI_PD($dev)-> &par_nreg));
    }' unless defined(&sparc_pd_getnreg);
    eval 'sub sparc_pd_getnintr {
        my($dev) = @_;
	    eval q(( &DEVI_PD($dev)-> &par_nintr));
    }' unless defined(&sparc_pd_getnintr);
    eval 'sub sparc_pd_getnrng {
        my($dev) = @_;
	    eval q(( &DEVI_PD($dev)-> &par_nrng));
    }' unless defined(&sparc_pd_getnrng);
    eval 'sub sparc_pd_getreg {
        my($dev, $n) = @_;
	    eval q(( &DEVI_PD($dev)-> $par_reg[($n)]));
    }' unless defined(&sparc_pd_getreg);
    eval 'sub sparc_pd_getintr {
        my($dev, $n) = @_;
	    eval q(( &DEVI_PD($dev)-> $par_intr[($n)]));
    }' unless defined(&sparc_pd_getintr);
    eval 'sub sparc_pd_getrng {
        my($dev, $n) = @_;
	    eval q(( &DEVI_PD($dev)-> $par_rng[($n)]));
    }' unless defined(&sparc_pd_getrng);
    if(defined( &_KERNEL)  && defined( &__STDC__)) {
    }
    if(defined( &sparc) || defined( &__sparc)) {
    } else {
	eval 'sub DMAMI_KVADR () {0x5;}' unless defined(&DMAMI_KVADR);
	eval 'sub DMAMI_UVADR () {0x9;}' unless defined(&DMAMI_UVADR);
	eval 'sub DMAMI_PAGES () {0xb;}' unless defined(&DMAMI_PAGES);
	eval 'sub DMAI_SOMEMORE_COOKIES () {4;}' unless defined(&DMAI_SOMEMORE_COOKIES);
	if(defined( &i386) || defined( &__ia64)) {
	}
    }
    eval 'sub _DMCM1 () { &DDI_DMA_RDWR| &DDI_DMA_REDZONE| &DDI_DMA_PARTIAL;}' unless defined(&_DMCM1);
    eval 'sub _DMCM2 () { &DDI_DMA_CONSISTENT| &DMP_VMEREQ;}' unless defined(&_DMCM2);
    eval 'sub DMP_DDIFLAGS () {( &_DMCM1| &_DMCM2);}' unless defined(&DMP_DDIFLAGS);
    eval 'sub DMP_SHADOW () {0x20;}' unless defined(&DMP_SHADOW);
    eval 'sub DMP_LKIOPB () {0x40;}' unless defined(&DMP_LKIOPB);
    eval 'sub DMP_LKSYSV () {0x80;}' unless defined(&DMP_LKSYSV);
    eval 'sub DMP_IOCACHE () {0x100;}' unless defined(&DMP_IOCACHE);
    eval 'sub DMP_USEHAT () {0x200;}' unless defined(&DMP_USEHAT);
    eval 'sub DMP_PHYSADDR () {0x400;}' unless defined(&DMP_PHYSADDR);
    eval 'sub DMP_INVALID () {0x800;}' unless defined(&DMP_INVALID);
    eval 'sub DMP_NOLIMIT () {0x1000;}' unless defined(&DMP_NOLIMIT);
    eval 'sub DMP_VMEREQ () {0x10000000;}' unless defined(&DMP_VMEREQ);
    eval 'sub DMP_BYPASSNEXUS () {0x20000000;}' unless defined(&DMP_BYPASSNEXUS);
    eval 'sub DMP_NODEVSYNC () {0x40000000;}' unless defined(&DMP_NODEVSYNC);
    eval 'sub DMP_NOCPUSYNC () {0x80000000;}' unless defined(&DMP_NOCPUSYNC);
    eval 'sub DMP_NOSYNC () {( &DMP_NODEVSYNC| &DMP_NOCPUSYNC);}' unless defined(&DMP_NOSYNC);
    if(defined( &i386) || defined( &__ia64)) {
    }
    eval 'sub DMAIS_NEEDINTBUF () {0x100;}' unless defined(&DMAIS_NEEDINTBUF);
    eval 'sub DMAIS_COMPLEMENT () {0x200;}' unless defined(&DMAIS_COMPLEMENT);
    eval 'sub DMAIS_NOMERGE () { &DMAIS_NEEDINTBUF |  &DMAIS_COMPLEMENT;}' unless defined(&DMAIS_NOMERGE);
    eval 'sub DMAIS_MAPPAGE () {0x400;}' unless defined(&DMAIS_MAPPAGE);
    eval 'sub DMAIS_PAGEPTR () {0x800;}' unless defined(&DMAIS_PAGEPTR);
    eval 'sub DMAIS_WINSTRT () {0x1000;}' unless defined(&DMAIS_WINSTRT);
    eval 'sub DMAIS_WINUIB () {0x2000;}' unless defined(&DMAIS_WINUIB);
    eval 'sub DMAIS_WINEND () {0x8000;}' unless defined(&DMAIS_WINEND);
    eval 'sub IDDI_INTR_TYPE_NORMAL () {1;}' unless defined(&IDDI_INTR_TYPE_NORMAL);
    eval 'sub IDDI_INTR_TYPE_FAST () {2;}' unless defined(&IDDI_INTR_TYPE_FAST);
    eval 'sub IDDI_INTR_TYPE_SOFT () {3;}' unless defined(&IDDI_INTR_TYPE_SOFT);
    eval 'sub MAXCALLBACK () {20;}' unless defined(&MAXCALLBACK);
    eval 'sub DEVID_MAGIC_MSB () {0x69;}' unless defined(&DEVID_MAGIC_MSB);
    eval 'sub DEVID_MAGIC_LSB () {0x64;}' unless defined(&DEVID_MAGIC_LSB);
    eval 'sub DEVID_REV_MSB () {0x;}' unless defined(&DEVID_REV_MSB);
    eval 'sub DEVID_REV_LSB () {0x1;}' unless defined(&DEVID_REV_LSB);
    eval 'sub DEVID_HINT_SIZE () {4;}' unless defined(&DEVID_HINT_SIZE);
    eval 'sub DEVID_GETTYPE {
        my($devid) = @_;
	    eval q((( &ushort_t) ((($devid)-> &did_type_hi <<  &NBBY) + ($devid)-> &did_type_lo)));
    }' unless defined(&DEVID_GETTYPE);
    eval 'sub DEVID_FORMTYPE {
        my($devid, $type) = @_;
	    eval q(($devid)-> &did_type_hi =  &hibyte(($type)); ($devid)-> &did_type_lo =  &lobyte(($type)););
    }' unless defined(&DEVID_FORMTYPE);
    eval 'sub DEVID_GETLEN {
        my($devid) = @_;
	    eval q((( &ushort_t) ((($devid)-> &did_len_hi <<  &NBBY) + ($devid)-> &did_len_lo)));
    }' unless defined(&DEVID_GETLEN);
    eval 'sub DEVID_FORMLEN {
        my($devid, $len) = @_;
	    eval q(($devid)-> &did_len_hi =  &hibyte(($len)); ($devid)-> &did_len_lo =  &lobyte(($len)););
    }' unless defined(&DEVID_FORMLEN);
    eval 'sub SAVED_CONFIG_REGS () {"pci-config-regs";}' unless defined(&SAVED_CONFIG_REGS);
    if(defined(&__cplusplus)) {
    }
}
1;
