require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DDIDMAREQ_H)) {
    eval 'sub _SYS_DDIDMAREQ_H () {1;}' unless defined(&_SYS_DDIDMAREQ_H);
    if(defined(&__cplusplus)) {
    }
    eval("sub DMA_OTYP_VADDR () { 0; }") unless defined(&DMA_OTYP_VADDR);
    eval("sub DMA_OTYP_PAGES () { 1; }") unless defined(&DMA_OTYP_PAGES);
    eval("sub DMA_OTYP_PADDR () { 2; }") unless defined(&DMA_OTYP_PADDR);
    if(defined( &sparc) || defined( &__sparc)) {
    } else {
	eval 'sub DMA_UNIT_8 () {1;}' unless defined(&DMA_UNIT_8);
	eval 'sub DMA_UNIT_16 () {2;}' unless defined(&DMA_UNIT_16);
	eval 'sub DMA_UNIT_32 () {4;}' unless defined(&DMA_UNIT_32);
	eval 'sub DMALIM_VER0 () {((0x86000000) + 0);}' unless defined(&DMALIM_VER0);
    }
    eval 'sub DDI_DMA_FORCE_PHYSICAL () {0x100;}' unless defined(&DDI_DMA_FORCE_PHYSICAL);
    eval 'sub DMA_ATTR_V0 () {0;}' unless defined(&DMA_ATTR_V0);
    eval 'sub DMA_ATTR_VERSION () { &DMA_ATTR_V0;}' unless defined(&DMA_ATTR_VERSION);
    eval 'sub maxbit {
        my($val, $mybit) = @_;
	    eval q((($val) & ~(($mybit)-1)) | (((($val) & ~(($mybit)-1)) == 0) ? ($mybit) : 0));
    }' unless defined(&maxbit);
    eval 'sub minbit {
        my($val, $mybit) = @_;
	    eval q(((($val)(($mybit)|(($mybit)-1))) | (((($val) & (($mybit)-1)) == 0) ? ($mybit) : 0)));
    }' unless defined(&minbit);
    if(defined(&__STDC__)) {
	eval 'sub DDI_DMA_DONTWAIT () {(0);}' unless defined(&DDI_DMA_DONTWAIT);
	eval 'sub DDI_DMA_SLEEP () {(1);}' unless defined(&DDI_DMA_SLEEP);
    } else {
	eval 'sub DDI_DMA_DONTWAIT () {(0);}' unless defined(&DDI_DMA_DONTWAIT);
	eval 'sub DDI_DMA_SLEEP () {(1);}' unless defined(&DDI_DMA_SLEEP);
    }
    eval 'sub DDI_DMA_CALLBACK_RUNOUT () {0;}' unless defined(&DDI_DMA_CALLBACK_RUNOUT);
    eval 'sub DDI_DMA_CALLBACK_DONE () {1;}' unless defined(&DDI_DMA_CALLBACK_DONE);
    eval 'sub DDI_DMA_WRITE () {0x1;}' unless defined(&DDI_DMA_WRITE);
    eval 'sub DDI_DMA_READ () {0x2;}' unless defined(&DDI_DMA_READ);
    eval 'sub DDI_DMA_RDWR () {( &DDI_DMA_READ |  &DDI_DMA_WRITE);}' unless defined(&DDI_DMA_RDWR);
    eval 'sub DDI_DMA_REDZONE () {0x4;}' unless defined(&DDI_DMA_REDZONE);
    eval 'sub DDI_DMA_PARTIAL () {0x8;}' unless defined(&DDI_DMA_PARTIAL);
    eval 'sub DDI_DMA_CONSISTENT () {0x10;}' unless defined(&DDI_DMA_CONSISTENT);
    eval 'sub DDI_DMA_EXCLUSIVE () {0x20;}' unless defined(&DDI_DMA_EXCLUSIVE);
    eval 'sub DDI_DMA_STREAMING () {0x40;}' unless defined(&DDI_DMA_STREAMING);
    eval 'sub DDI_DMA_SBUS_64BIT () {0x2000;}' unless defined(&DDI_DMA_SBUS_64BIT);
    eval 'sub DDI_DMA_MAPPED () {0;}' unless defined(&DDI_DMA_MAPPED);
    eval 'sub DDI_DMA_MAPOK () {0;}' unless defined(&DDI_DMA_MAPOK);
    eval 'sub DDI_DMA_PARTIAL_MAP () {1;}' unless defined(&DDI_DMA_PARTIAL_MAP);
    eval 'sub DDI_DMA_DONE () {2;}' unless defined(&DDI_DMA_DONE);
    eval 'sub DDI_DMA_NORESOURCES () {-1;}' unless defined(&DDI_DMA_NORESOURCES);
    eval 'sub DDI_DMA_NOMAPPING () {-2;}' unless defined(&DDI_DMA_NOMAPPING);
    eval 'sub DDI_DMA_TOOBIG () {-3;}' unless defined(&DDI_DMA_TOOBIG);
    eval 'sub DDI_DMA_TOOSMALL () {-4;}' unless defined(&DDI_DMA_TOOSMALL);
    eval 'sub DDI_DMA_LOCKED () {-5;}' unless defined(&DDI_DMA_LOCKED);
    eval 'sub DDI_DMA_BADLIMITS () {-6;}' unless defined(&DDI_DMA_BADLIMITS);
    eval 'sub DDI_DMA_STALE () {-7;}' unless defined(&DDI_DMA_STALE);
    eval 'sub DDI_DMA_BADATTR () {-8;}' unless defined(&DDI_DMA_BADATTR);
    eval 'sub DDI_DMA_INUSE () {-9;}' unless defined(&DDI_DMA_INUSE);
    eval 'sub DDI_DMA_SYNC_FORDEV () {0x;}' unless defined(&DDI_DMA_SYNC_FORDEV);
    eval 'sub DDI_DMA_SYNC_FORCPU () {0x1;}' unless defined(&DDI_DMA_SYNC_FORCPU);
    eval 'sub DDI_DMA_SYNC_FORKERNEL () {0x2;}' unless defined(&DDI_DMA_SYNC_FORKERNEL);
    eval("sub DDI_DMA_FREE () { 0; }") unless defined(&DDI_DMA_FREE);
    eval("sub DDI_DMA_SYNC () { 1; }") unless defined(&DDI_DMA_SYNC);
    eval("sub DDI_DMA_HTOC () { 2; }") unless defined(&DDI_DMA_HTOC);
    eval("sub DDI_DMA_KVADDR () { 3; }") unless defined(&DDI_DMA_KVADDR);
    eval("sub DDI_DMA_MOVWIN () { 4; }") unless defined(&DDI_DMA_MOVWIN);
    eval("sub DDI_DMA_REPWIN () { 5; }") unless defined(&DDI_DMA_REPWIN);
    eval("sub DDI_DMA_GETERR () { 6; }") unless defined(&DDI_DMA_GETERR);
    eval("sub DDI_DMA_COFF () { 7; }") unless defined(&DDI_DMA_COFF);
    eval("sub DDI_DMA_NEXTWIN () { 8; }") unless defined(&DDI_DMA_NEXTWIN);
    eval("sub DDI_DMA_NEXTSEG () { 9; }") unless defined(&DDI_DMA_NEXTSEG);
    eval("sub DDI_DMA_SEGTOC () { 10; }") unless defined(&DDI_DMA_SEGTOC);
    eval("sub DDI_DMA_RESERVE () { 11; }") unless defined(&DDI_DMA_RESERVE);
    eval("sub DDI_DMA_RELEASE () { 12; }") unless defined(&DDI_DMA_RELEASE);
    eval("sub DDI_DMA_RESETH () { 13; }") unless defined(&DDI_DMA_RESETH);
    eval("sub DDI_DMA_CKSYNC () { 14; }") unless defined(&DDI_DMA_CKSYNC);
    eval("sub DDI_DMA_IOPB_ALLOC () { 15; }") unless defined(&DDI_DMA_IOPB_ALLOC);
    eval("sub DDI_DMA_IOPB_FREE () { 16; }") unless defined(&DDI_DMA_IOPB_FREE);
    eval("sub DDI_DMA_SMEM_ALLOC () { 17; }") unless defined(&DDI_DMA_SMEM_ALLOC);
    eval("sub DDI_DMA_SMEM_FREE () { 18; }") unless defined(&DDI_DMA_SMEM_FREE);
    eval("sub DDI_DMA_SET_SBUS64 () { 19; }") unless defined(&DDI_DMA_SET_SBUS64);
    eval("sub DDI_DMA_E_ACQUIRE () { 20; }") unless defined(&DDI_DMA_E_ACQUIRE);
    eval("sub DDI_DMA_E_FREE () { 21; }") unless defined(&DDI_DMA_E_FREE);
    eval("sub DDI_DMA_E_1STPTY () { 22; }") unless defined(&DDI_DMA_E_1STPTY);
    eval("sub DDI_DMA_E_GETCB () { 23; }") unless defined(&DDI_DMA_E_GETCB);
    eval("sub DDI_DMA_E_FREECB () { 24; }") unless defined(&DDI_DMA_E_FREECB);
    eval("sub DDI_DMA_E_PROG () { 25; }") unless defined(&DDI_DMA_E_PROG);
    eval("sub DDI_DMA_E_SWSETUP () { 26; }") unless defined(&DDI_DMA_E_SWSETUP);
    eval("sub DDI_DMA_E_SWSTART () { 27; }") unless defined(&DDI_DMA_E_SWSTART);
    eval("sub DDI_DMA_E_ENABLE () { 28; }") unless defined(&DDI_DMA_E_ENABLE);
    eval("sub DDI_DMA_E_STOP () { 29; }") unless defined(&DDI_DMA_E_STOP);
    eval("sub DDI_DMA_E_DISABLE () { 30; }") unless defined(&DDI_DMA_E_DISABLE);
    eval("sub DDI_DMA_E_GETCNT () { 31; }") unless defined(&DDI_DMA_E_GETCNT);
    eval("sub DDI_DMA_E_GETLIM () { 32; }") unless defined(&DDI_DMA_E_GETLIM);
    eval("sub DDI_DMA_E_GETATTR () { 33; }") unless defined(&DDI_DMA_E_GETATTR);
    if(defined(&__cplusplus)) {
    }
}
1;
