require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DEBUG_H)) {
    eval 'sub _SYS_DEBUG_H () {1;}' unless defined(&_SYS_DEBUG_H);
    require 'sys/isa_defs.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &__STDC__)) {
	if((defined(&DEBUG) ? &DEBUG : 0)) {
	    eval 'sub ASSERT {
	        my($EX) = @_;
    		eval q((( &void)(($EX) ||  &assfail($EX,  &__FILE__,  &__LINE__))));
	    }' unless defined(&ASSERT);
	} else {
	    eval 'sub ASSERT {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&ASSERT);
	}
    } else {
	if((defined(&DEBUG) ? &DEBUG : 0)) {
	    eval 'sub ASSERT {
	        my($EX) = @_;
    		eval q((( &void)(($EX) ||  &assfail(\\"EX\\",  &__FILE__,  &__LINE__))));
	    }' unless defined(&ASSERT);
	} else {
	    eval 'sub ASSERT {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&ASSERT);
	}
    }
    if(defined( &_LP64)) {
	eval 'sub ASSERT64 {
	    my($x) = @_;
    	    eval q( &ASSERT($x));
	}' unless defined(&ASSERT64);
	eval 'sub ASSERT32 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&ASSERT32);
    } else {
	eval 'sub ASSERT64 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&ASSERT64);
	eval 'sub ASSERT32 {
	    my($x) = @_;
    	    eval q( &ASSERT($x));
	}' unless defined(&ASSERT32);
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&MONITOR)) {
	eval 'sub MONITOR {
	    my($id, $w1, $w2, $w3, $w4) = @_;
    	    eval q( &monitor($id, $w1, $w2, $w3, $w4));
	}' unless defined(&MONITOR);
    } else {
	eval 'sub MONITOR {
	    my($id, $w1, $w2, $w3, $w4) = @_;
    	    eval q();
	}' unless defined(&MONITOR);
    }
    if(defined( &DEBUG)  && !defined( &sun)) {
	eval 'sub STATIC () {1;}' unless defined(&STATIC);
    } else {
	eval 'sub STATIC () { &static;}' unless defined(&STATIC);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
