require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DKMPIO_H)) {
    eval 'sub _SYS_DKMPIO_H () {1;}' unless defined(&_SYS_DKMPIO_H);
    if(defined(&__cplusplus)) {
    }
    eval("sub DKS_INITIAL () { 0; }") unless defined(&DKS_INITIAL);
    eval("sub DKS_OFFLINE () { 1; }") unless defined(&DKS_OFFLINE);
    eval("sub DKS_ONLINE () { 2; }") unless defined(&DKS_ONLINE);
    eval("sub DKS_FREEZE () { 3; }") unless defined(&DKS_FREEZE);
    eval("sub DKT_IPI () { 0; }") unless defined(&DKT_IPI);
    eval("sub DKT_SCSI () { 1; }") unless defined(&DKT_SCSI);
    eval("sub DKT_UNKNOWN () { 2; }") unless defined(&DKT_UNKNOWN);
    eval 'sub DKF_DRV_RESERVED () {0x1;}' unless defined(&DKF_DRV_RESERVED);
    eval 'sub DKF_DRV_DUAL_ENABLED () {0x2;}' unless defined(&DKF_DRV_DUAL_ENABLED);
    eval 'sub DKF_DRV_RESET () {0x4;}' unless defined(&DKF_DRV_RESET);
    eval 'sub DKF_DRV_WRTPROT () {0x8;}' unless defined(&DKF_DRV_WRTPROT);
    eval 'sub DKF_DRV_BUSY () {0x10;}' unless defined(&DKF_DRV_BUSY);
    eval 'sub DKF_DRV_TIMEOUT () {0x20;}' unless defined(&DKF_DRV_TIMEOUT);
    eval 'sub DKF_DRV_DUALPORTED () {0x40;}' unless defined(&DKF_DRV_DUALPORTED);
    eval 'sub DKF_DRV_ALTRSVD () {0x80;}' unless defined(&DKF_DRV_ALTRSVD);
    eval 'sub DKF_ADAPT_RESERVED () {0x100;}' unless defined(&DKF_ADAPT_RESERVED);
    eval 'sub DKF_ADAPT_RESET () {0x400;}' unless defined(&DKF_ADAPT_RESET);
    eval 'sub DKF_ADAPT_BUSY () {0x1000;}' unless defined(&DKF_ADAPT_BUSY);
    eval 'sub DKF_ADAPT_TIMEOUT () {0x2000;}' unless defined(&DKF_ADAPT_TIMEOUT);
    eval 'sub DKF_CTLR_RESERVED () {0x10000;}' unless defined(&DKF_CTLR_RESERVED);
    eval 'sub DKF_CTLR_RESET () {0x40000;}' unless defined(&DKF_CTLR_RESET);
    eval 'sub DKF_CTLR_BUSY () {0x100000;}' unless defined(&DKF_CTLR_BUSY);
    eval 'sub DKF_CTLR_TIMEOUT () {0x2000000;}' unless defined(&DKF_CTLR_TIMEOUT);
    eval 'sub DKF_DRV_RSV_LOST () {0x1;}' unless defined(&DKF_DRV_RSV_LOST);
    eval 'sub DKF_CTLR_RSV_LOST () {0x2;}' unless defined(&DKF_CTLR_RSV_LOST);
    eval 'sub DKF_DRV_DIAGNOSED () {0x4;}' unless defined(&DKF_DRV_DIAGNOSED);
    eval 'sub DKF_CTLR_DIAGNOSED () {0x8;}' unless defined(&DKF_CTLR_DIAGNOSED);
    eval 'sub DKF_ADAPT_DIAGNOSED () {0x10;}' unless defined(&DKF_ADAPT_DIAGNOSED);
    eval 'sub DKF_DRV_FAILED () {0x1000;}' unless defined(&DKF_DRV_FAILED);
    eval 'sub DKF_CTLR_FAILED () {0x100000;}' unless defined(&DKF_CTLR_FAILED);
    eval 'sub DKF_ADAPT_FAILED () {0x10000000;}' unless defined(&DKF_ADAPT_FAILED);
    eval 'sub DKF_DRV_NOEXIST () {0x1;}' unless defined(&DKF_DRV_NOEXIST);
    eval 'sub DKF_CTLR_NOEXIST () {0x2;}' unless defined(&DKF_CTLR_NOEXIST);
    eval 'sub DKF_ADAPT_NOEXIST () {0x4;}' unless defined(&DKF_ADAPT_NOEXIST);
    eval 'sub DKF_ORDERED () {0x1;}' unless defined(&DKF_ORDERED);
    eval 'sub DKF_PANIC_ABORT () {0x2;}' unless defined(&DKF_PANIC_ABORT);
    eval 'sub DKF_RERUN_UNR_CMDS () {0x4;}' unless defined(&DKF_RERUN_UNR_CMDS);
    eval 'sub DKF_RERUN_RSV_CMDS () {0x8;}' unless defined(&DKF_RERUN_RSV_CMDS);
    eval 'sub DKF_AUTOFAIL () {0x10;}' unless defined(&DKF_AUTOFAIL);
    eval 'sub DKF_RESERVE () {0x1;}' unless defined(&DKF_RESERVE);
    eval 'sub DKF_RELEASE () {0x2;}' unless defined(&DKF_RELEASE);
    eval 'sub DKF_RESET () {0x4;}' unless defined(&DKF_RESET);
    eval 'sub DKF_ABORT () {0x8;}' unless defined(&DKF_ABORT);
    eval 'sub DKF_PROBE () {0x10;}' unless defined(&DKF_PROBE);
    eval 'sub DKF_REINIT () {0x20;}' unless defined(&DKF_REINIT);
    eval 'sub DKF_DIAGNOSE () {0x1;}' unless defined(&DKF_DIAGNOSE);
    eval 'sub DKF_ISOLATE () {0x2;}' unless defined(&DKF_ISOLATE);
    eval 'sub DKF_READ () {0x4;}' unless defined(&DKF_READ);
    eval 'sub DKF_WRITE () {0x8;}' unless defined(&DKF_WRITE);
    eval 'sub DKF_DESTRUCTIVE () {0x10;}' unless defined(&DKF_DESTRUCTIVE);
    eval 'sub DKIOCGMPINFO () {( &DIOC | 90);}' unless defined(&DKIOCGMPINFO);
    eval 'sub DKIOCGMPSTATE () {( &DIOC | 91);}' unless defined(&DKIOCGMPSTATE);
    eval 'sub DKIOCSMPSTATE () {( &DIOC | 92);}' unless defined(&DKIOCSMPSTATE);
    eval 'sub DKIOCGSTATUS () {( &DIOC | 93);}' unless defined(&DKIOCGSTATUS);
    eval 'sub DKIOCGMPFLAGS () {( &DIOC | 94);}' unless defined(&DKIOCGMPFLAGS);
    eval 'sub DKIOCSMPFLAGS () {( &DIOC | 95);}' unless defined(&DKIOCSMPFLAGS);
    eval 'sub DKIOCSMPCMD () {( &DIOC | 96);}' unless defined(&DKIOCSMPCMD);
    if(defined(&__cplusplus)) {
    }
}
1;
