require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DMAGA_H)) {
    eval 'sub _SYS_DMAGA_H () {1;}' unless defined(&_SYS_DMAGA_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub SET_DMAESC_COUNT {
        my($dmar, $val) = @_;
	    eval q(($dmar)-> &dmaga_count = $val);
    }' unless defined(&SET_DMAESC_COUNT);
    eval 'sub DMAGA_INTPEND () {0x1;}' unless defined(&DMAGA_INTPEND);
    eval 'sub DMAGA_ERRPEND () {0x2;}' unless defined(&DMAGA_ERRPEND);
    eval 'sub DMAGA_PACKCNT () {0xc;}' unless defined(&DMAGA_PACKCNT);
    eval 'sub DMAGA_NPACKED {
        my($x) = @_;
	    eval q(((($x)-> &dmaga_csr &  &DMAGA_PACKCNT) >> 2));
    }' unless defined(&DMAGA_NPACKED);
    eval 'sub DMAGA_DRAINING () {0xc;}' unless defined(&DMAGA_DRAINING);
    eval 'sub DMAGA_INTEN () {0x10;}' unless defined(&DMAGA_INTEN);
    eval 'sub DMAGA_FLUSH () {0x20;}' unless defined(&DMAGA_FLUSH);
    eval 'sub DMAGA_DRAIN () {0x40;}' unless defined(&DMAGA_DRAIN);
    eval 'sub DMAGA_SLVERR () {0x40;}' unless defined(&DMAGA_SLVERR);
    eval 'sub DMAGA_RESET () {0x80;}' unless defined(&DMAGA_RESET);
    eval 'sub DMAGA_WRITE () {0x100;}' unless defined(&DMAGA_WRITE);
    eval 'sub DMAGA_ENDVMA () {0x200;}' unless defined(&DMAGA_ENDVMA);
    eval 'sub DMAGA_REQPEND () {0x400;}' unless defined(&DMAGA_REQPEND);
    eval 'sub DMAESC_BSIZE () {0x800;}' unless defined(&DMAESC_BSIZE);
    eval 'sub DMAESC_SETBURST16 {
        my($d) = @_;
	    eval q(($d)-> &dmaga_csr |=  &DMAESC_BSIZE);
    }' unless defined(&DMAESC_SETBURST16);
    eval 'sub DMAESC_SETBURST32 {
        my($d) = @_;
	    eval q(($d)-> &dmaga_csr &= ~ &DMAESC_BSIZE);
    }' unless defined(&DMAESC_SETBURST32);
    eval 'sub DMAESC_TCZERO () {0x1000;}' unless defined(&DMAESC_TCZERO);
    eval 'sub DMAESC_EN_TCI () {0x2000;}' unless defined(&DMAESC_EN_TCI);
    eval 'sub DMAESC_INTPEND () {0x4000;}' unless defined(&DMAESC_INTPEND);
    eval 'sub DMAESC_PEN () {0x8000;}' unless defined(&DMAESC_PEN);
    eval 'sub DMAESC_PERR () {0x10000;}' unless defined(&DMAESC_PERR);
    eval 'sub DMAESC_DRAIN () {0x20000;}' unless defined(&DMAESC_DRAIN);
    eval 'sub DMAESC_EN_ADD () {0x40000;}' unless defined(&DMAESC_EN_ADD);
    eval 'sub DMAGA_BYTEADR () {0x1800;}' unless defined(&DMAGA_BYTEADR);
    eval 'sub DMAGA_NEXTBYTE {
        my($x) = @_;
	    eval q(((($x)-> &dmaga_csr &  &DMAGA_BYTEADR) >> 11));
    }' unless defined(&DMAGA_NEXTBYTE);
    eval 'sub DMAGA_ENATC () {0x2000;}' unless defined(&DMAGA_ENATC);
    eval 'sub DMAGA_TC () {0x4000;}' unless defined(&DMAGA_TC);
    eval 'sub DMAGA_ILACC () {0x8000;}' unless defined(&DMAGA_ILACC);
    eval 'sub DMAGA_BURSTMASK () {0xc0000;}' unless defined(&DMAGA_BURSTMASK);
    eval 'sub DMAGA_BURST16 () {0x;}' unless defined(&DMAGA_BURST16);
    eval 'sub DMAGA_NOBURST () {0x80000;}' unless defined(&DMAGA_NOBURST);
    eval 'sub DMAGA_BURST32 () {0x40000;}' unless defined(&DMAGA_BURST32);
    eval 'sub DMA2_SETNOBURST {
        my($d) = @_;
	    eval q(($d)-> &dmaga_csr &= ~ &DMAGA_BURSTMASK, ($d)-> &dmaga_csr |=  &DMAGA_NOBURST);
    }' unless defined(&DMA2_SETNOBURST);
    eval 'sub DMA2_SETBURST16 {
        my($d) = @_;
	    eval q(($d)-> &dmaga_csr &= ~ &DMAGA_BURSTMASK);
    }' unless defined(&DMA2_SETBURST16);
    eval 'sub DMA2_SETBURST32 {
        my($d) = @_;
	    eval q(($d)-> &dmaga_csr &= ~ &DMAGA_BURSTMASK, ($d)-> &dmaga_csr |=  &DMAGA_BURST32);
    }' unless defined(&DMA2_SETBURST32);
    eval 'sub DMAGA_ALE () {0x100000;}' unless defined(&DMAGA_ALE);
    eval 'sub DMAGA_LERR () {0x200000;}' unless defined(&DMAGA_LERR);
    eval 'sub DMAGA_TURBO () {0x400000;}' unless defined(&DMAGA_TURBO);
    eval 'sub DMAGA_NOTCINT () {0x800000;}' unless defined(&DMAGA_NOTCINT);
    eval 'sub DMAGA_TWO_CYCLE () {0x200000;}' unless defined(&DMAGA_TWO_CYCLE);
    eval 'sub DMAGA_ENANXT () {0x1000000;}' unless defined(&DMAGA_ENANXT);
    eval 'sub DMAGA_DMAON () {0x2000000;}' unless defined(&DMAGA_DMAON);
    eval 'sub DMAGA_ALOAD () {0x4000000;}' unless defined(&DMAGA_ALOAD);
    eval 'sub DMAGA_NALOAD () {0x8000000;}' unless defined(&DMAGA_NALOAD);
    eval 'sub BURST1 () {0x1;}' unless defined(&BURST1);
    eval 'sub BURST2 () {0x2;}' unless defined(&BURST2);
    eval 'sub BURST4 () {0x4;}' unless defined(&BURST4);
    eval 'sub BURST8 () {0x8;}' unless defined(&BURST8);
    eval 'sub BURST16 () {0x10;}' unless defined(&BURST16);
    eval 'sub BURST32 () {0x20;}' unless defined(&BURST32);
    eval 'sub BURST64 () {0x40;}' unless defined(&BURST64);
    eval 'sub BURSTSIZE_MASK () {0x7f;}' unless defined(&BURSTSIZE_MASK);
    eval 'sub DEFAULT_BURSTSIZE () { &BURST16| &BURST8| &BURST4| &BURST2| &BURST1;}' unless defined(&DEFAULT_BURSTSIZE);
    eval 'sub DMAGA_DEVID () {0xf0000000;}' unless defined(&DMAGA_DEVID);
    eval 'sub DMAGA_REV {
        my($x) = @_;
	    eval q(((($x)-> &dmaga_csr &  &DMAGA_DEVID) >> 28));
    }' unless defined(&DMAGA_REV);
    eval 'sub DMA_REV1 () {0x8;}' unless defined(&DMA_REV1);
    eval 'sub DMA_REV2 () {0x9;}' unless defined(&DMA_REV2);
    eval 'sub ESC1_REV1 () {0x4;}' unless defined(&ESC1_REV1);
    eval 'sub DMA_REV3 () {0xa;}' unless defined(&DMA_REV3);
    eval 'sub DMAGA_CHK_MASK () {( &DMAGA_INTPEND |  &DMAGA_ERRPEND |  &DMAGA_REQPEND);}' unless defined(&DMAGA_CHK_MASK);
    eval 'sub DMAGA_INT_MASK () {( &DMAGA_INTPEND |  &DMAGA_ERRPEND);}' unless defined(&DMAGA_INT_MASK);
    eval 'sub DMAGA_BITS () {"\\20\\20ILACC\\17TC\\13RQPND\\12EN\\11IN\\10RST\\7DRAIN\\6FLSH\\5INTEN\\2ERRPEND\\1INTPND";}' unless defined(&DMAGA_BITS);
    if(defined(&_KERNEL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
