require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DOOR_H)) {
    eval 'sub _SYS_DOOR_H () {1;}' unless defined(&_SYS_DOOR_H);
    if(defined(&__cplusplus)) {
    }
    if(!defined( &_ASM)) {
	require 'sys/types.ph';
	if(defined( &_KERNEL)) {
	    require 'sys/mutex.ph';
	    require 'sys/vnode.ph';
	}
	if(defined(&_KERNEL)) {
	}
	eval 'sub DOOR_INVAL () {-1;}' unless defined(&DOOR_INVAL);
	eval 'sub DOOR_UNREF_DATA () {(( &void *)1);}' unless defined(&DOOR_UNREF_DATA);
	eval 'sub DOOR_QUERY () {-2;}' unless defined(&DOOR_QUERY);
	eval 'sub DOOR_UNREF () {0x1;}' unless defined(&DOOR_UNREF);
	eval 'sub DOOR_PRIVATE () {0x2;}' unless defined(&DOOR_PRIVATE);
	eval 'sub DOOR_UNREF_MULTI () {0x10;}' unless defined(&DOOR_UNREF_MULTI);
	eval 'sub DOOR_LOCAL () {0x4;}' unless defined(&DOOR_LOCAL);
	eval 'sub DOOR_REVOKED () {0x8;}' unless defined(&DOOR_REVOKED);
	eval 'sub DOOR_IS_UNREF () {0x20;}' unless defined(&DOOR_IS_UNREF);
	eval 'sub DOOR_ATTR_MASK () {( &DOOR_UNREF |  &DOOR_PRIVATE |  &DOOR_UNREF_MULTI |  &DOOR_LOCAL |  &DOOR_REVOKED |  &DOOR_IS_UNREF);}' unless defined(&DOOR_ATTR_MASK);
	eval 'sub DOOR_DESCRIPTOR () {0x10000;}' unless defined(&DOOR_DESCRIPTOR);
	if(defined(&_KERNEL)) {
	    eval 'sub DOOR_HANDLE () {0x20000;}' unless defined(&DOOR_HANDLE);
	}
	eval 'sub DOOR_RELEASE () {0x40000;}' unless defined(&DOOR_RELEASE);
	eval 'sub DOOR_DELAY () {0x80000;}' unless defined(&DOOR_DELAY);
	eval 'sub DOOR_UNREF_ACTIVE () {0x100000;}' unless defined(&DOOR_UNREF_ACTIVE);
	if(defined(&_KERNEL)) {
	}
	if(defined( &_SYSCALL32)) {
	}
	if(defined( &_KERNEL)) {
	    eval 'sub DOOR_WAIT () {-1;}' unless defined(&DOOR_WAIT);
	    eval 'sub DOOR_EXIT () {-2;}' unless defined(&DOOR_EXIT);
	    eval 'sub VTOD {
	        my($v) = @_;
    		eval q((($v)));
	    }' unless defined(&VTOD);
	    eval 'sub DTOV {
	        my($d) = @_;
    		eval q((($d)));
	    }' unless defined(&DTOV);
	    eval 'sub DOOR_INVALID {
	        my($dp) = @_;
    		eval q((($dp)-> &door_flags &  &DOOR_REVOKED));
	    }' unless defined(&DOOR_INVALID);
	    if(defined( &_SYSCALL32_IMPL)) {
	    }
	}
    }
    eval 'sub DOOR_CREATE () {0;}' unless defined(&DOOR_CREATE);
    eval 'sub DOOR_REVOKE () {1;}' unless defined(&DOOR_REVOKE);
    eval 'sub DOOR_INFO () {2;}' unless defined(&DOOR_INFO);
    eval 'sub DOOR_CALL () {3;}' unless defined(&DOOR_CALL);
    eval 'sub DOOR_RETURN () {4;}' unless defined(&DOOR_RETURN);
    eval 'sub DOOR_CRED () {5;}' unless defined(&DOOR_CRED);
    eval 'sub DOOR_BIND () {6;}' unless defined(&DOOR_BIND);
    eval 'sub DOOR_UNBIND () {7;}' unless defined(&DOOR_UNBIND);
    if(defined(&__cplusplus)) {
    }
}
1;
