require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_ECPPVAR_H)) {
    eval 'sub _SYS_ECPPVAR_H () {1;}' unless defined(&_SYS_ECPPVAR_H);
    require 'sys/note.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub ECPP_MAP_REGS {
        my($pp) = @_;
	    eval q(($pp)-> ($hw->{map_regs})($pp));
    }' unless defined(&ECPP_MAP_REGS);
    eval 'sub ECPP_UNMAP_REGS {
        my($pp) = @_;
	    eval q(($pp)-> ($hw->{unmap_regs})($pp));
    }' unless defined(&ECPP_UNMAP_REGS);
    eval 'sub ECPP_CONFIG_CHIP {
        my($pp) = @_;
	    eval q(($pp)-> ($hw->{config_chip})($pp));
    }' unless defined(&ECPP_CONFIG_CHIP);
    eval 'sub ECPP_CONFIG_MODE {
        my($pp) = @_;
	    eval q(($pp)-> ($hw->{config_mode})($pp));
    }' unless defined(&ECPP_CONFIG_MODE);
    eval 'sub ECPP_MASK_INTR {
        my($pp) = @_;
	    eval q(($pp)-> ($hw->{mask_intr})($pp));
    }' unless defined(&ECPP_MASK_INTR);
    eval 'sub ECPP_UNMASK_INTR {
        my($pp) = @_;
	    eval q(($pp)-> ($hw->{unmask_intr})($pp));
    }' unless defined(&ECPP_UNMASK_INTR);
    eval 'sub ECPP_DMA_START {
        my($pp) = @_;
	    eval q(($pp)-> ($hw->{dma_start})($pp));
    }' unless defined(&ECPP_DMA_START);
    eval 'sub ECPP_DMA_STOP {
        my($pp, $cnt) = @_;
	    eval q(($pp)-> ($hw->{dma_stop})($pp, $cnt));
    }' unless defined(&ECPP_DMA_STOP);
    eval 'sub ECPP_DMA_GETCNT {
        my($pp) = @_;
	    eval q(($pp)-> ($hw->{dma_getcnt})($pp));
    }' unless defined(&ECPP_DMA_GETCNT);
    eval 'sub ECPP_PHASE_INIT () {0x;}' unless defined(&ECPP_PHASE_INIT);
    eval 'sub ECPP_PHASE_NEGO () {0x1;}' unless defined(&ECPP_PHASE_NEGO);
    eval 'sub ECPP_PHASE_TERM () {0x2;}' unless defined(&ECPP_PHASE_TERM);
    eval 'sub ECPP_PHASE_PO () {0x3;}' unless defined(&ECPP_PHASE_PO);
    eval 'sub ECPP_PHASE_C_FWD_DMA () {0x10;}' unless defined(&ECPP_PHASE_C_FWD_DMA);
    eval 'sub ECPP_PHASE_C_FWD_PIO () {0x11;}' unless defined(&ECPP_PHASE_C_FWD_PIO);
    eval 'sub ECPP_PHASE_C_IDLE () {0x12;}' unless defined(&ECPP_PHASE_C_IDLE);
    eval 'sub ECPP_PHASE_NIBT_REVDATA () {0x20;}' unless defined(&ECPP_PHASE_NIBT_REVDATA);
    eval 'sub ECPP_PHASE_NIBT_AVAIL () {0x21;}' unless defined(&ECPP_PHASE_NIBT_AVAIL);
    eval 'sub ECPP_PHASE_NIBT_NAVAIL () {0x22;}' unless defined(&ECPP_PHASE_NIBT_NAVAIL);
    eval 'sub ECPP_PHASE_NIBT_REVIDLE () {0x22;}' unless defined(&ECPP_PHASE_NIBT_REVIDLE);
    eval 'sub ECPP_PHASE_NIBT_REVINTR () {0x23;}' unless defined(&ECPP_PHASE_NIBT_REVINTR);
    eval 'sub ECPP_PHASE_ECP_SETUP () {0x30;}' unless defined(&ECPP_PHASE_ECP_SETUP);
    eval 'sub ECPP_PHASE_ECP_FWD_XFER () {0x31;}' unless defined(&ECPP_PHASE_ECP_FWD_XFER);
    eval 'sub ECPP_PHASE_ECP_FWD_IDLE () {0x32;}' unless defined(&ECPP_PHASE_ECP_FWD_IDLE);
    eval 'sub ECPP_PHASE_ECP_FWD_REV () {0x33;}' unless defined(&ECPP_PHASE_ECP_FWD_REV);
    eval 'sub ECPP_PHASE_ECP_REV_XFER () {0x34;}' unless defined(&ECPP_PHASE_ECP_REV_XFER);
    eval 'sub ECPP_PHASE_ECP_REV_IDLE () {0x35;}' unless defined(&ECPP_PHASE_ECP_REV_IDLE);
    eval 'sub ECPP_PHASE_ECP_REV_FWD () {0x36;}' unless defined(&ECPP_PHASE_ECP_REV_FWD);
    eval 'sub ECPP_PHASE_EPP_INIT_IDLE () {0x40;}' unless defined(&ECPP_PHASE_EPP_INIT_IDLE);
    eval 'sub ECPP_PHASE_EPP_IDLE () {0x41;}' unless defined(&ECPP_PHASE_EPP_IDLE);
    eval 'sub FAILURE_PHASE () {0x80;}' unless defined(&FAILURE_PHASE);
    eval 'sub UNDEFINED_PHASE () {0x81;}' unless defined(&UNDEFINED_PHASE);
    eval 'sub SUCCESS () {1;}' unless defined(&SUCCESS);
    eval 'sub FAILURE () {2;}' unless defined(&FAILURE);
    eval 'sub ECPP_IDLE () {1;}' unless defined(&ECPP_IDLE);
    eval 'sub ECPP_BUSY () {2;}' unless defined(&ECPP_BUSY);
    eval 'sub ECPP_DATA () {3;}' unless defined(&ECPP_DATA);
    eval 'sub ECPP_ERR () {4;}' unless defined(&ECPP_ERR);
    eval 'sub ECPP_FLUSH () {5;}' unless defined(&ECPP_FLUSH);
    eval 'sub TRUE () {1;}' unless defined(&TRUE);
    eval 'sub FALSE () {0;}' unless defined(&FALSE);
    eval 'sub ECPP_BACKCHANNEL () {0x45;}' unless defined(&ECPP_BACKCHANNEL);
    eval 'sub ECPP_NO_1284_ERR () {0x;}' unless defined(&ECPP_NO_1284_ERR);
    eval 'sub ECPP_1284_ERR () {0x1;}' unless defined(&ECPP_1284_ERR);
    eval 'sub ECPP_DMA () {0x1;}' unless defined(&ECPP_DMA);
    eval 'sub ECPP_PIO () {0x2;}' unless defined(&ECPP_PIO);
    eval 'sub CENTRONICS_RETRY () {750;}' unless defined(&CENTRONICS_RETRY);
    eval 'sub WAIT_FOR_BUSY () {1000;}' unless defined(&WAIT_FOR_BUSY);
    eval 'sub SUSPEND_TOUT () {10;}' unless defined(&SUSPEND_TOUT);
    eval 'sub DATA_SETUP_TIME () {2;}' unless defined(&DATA_SETUP_TIME);
    eval 'sub STROBE_PULSE_WIDTH () {2;}' unless defined(&STROBE_PULSE_WIDTH);
    eval 'sub ECPP_XREQ_NIBBLE () {0x;}' unless defined(&ECPP_XREQ_NIBBLE);
    eval 'sub ECPP_XREQ_BYTE () {0x1;}' unless defined(&ECPP_XREQ_BYTE);
    eval 'sub ECPP_XREQ_ID () {0x4;}' unless defined(&ECPP_XREQ_ID);
    eval 'sub ECPP_XREQ_ECP () {0x10;}' unless defined(&ECPP_XREQ_ECP);
    eval 'sub ECPP_XREQ_ECPRLE () {0x30;}' unless defined(&ECPP_XREQ_ECPRLE);
    eval 'sub ECPP_XREQ_EPP () {0x40;}' unless defined(&ECPP_XREQ_EPP);
    eval 'sub ECPP_XREQ_XLINK () {0x80;}' unless defined(&ECPP_XREQ_XLINK);
    eval 'sub ECPP_SOFTINTR_PIONEXT () {0x1;}' unless defined(&ECPP_SOFTINTR_PIONEXT);
    eval 'sub IO_BLOCK_SZ () {1024* 128;}' unless defined(&IO_BLOCK_SZ);
    eval 'sub ECPPHIWAT () {32* 1024* 6;}' unless defined(&ECPPHIWAT);
    eval 'sub ECPPLOWAT () {32* 1024* 4;}' unless defined(&ECPPLOWAT);
    eval 'sub ECPP_REG_WRITE_MAX_LOOP () {100;}' unless defined(&ECPP_REG_WRITE_MAX_LOOP);
    eval 'sub ECPP_ISR_MAX_DELAY () {30;}' unless defined(&ECPP_ISR_MAX_DELAY);
    eval 'sub ECPP_FIFO_SZ () {16;}' unless defined(&ECPP_FIFO_SZ);
    eval 'sub FIFO_DRAIN_PERIOD () {250000;}' unless defined(&FIFO_DRAIN_PERIOD);
    eval 'sub NIBBLE_REV_BLKSZ () {1024;}' unless defined(&NIBBLE_REV_BLKSZ);
    eval 'sub ECP_REV_BLKSZ () {1024;}' unless defined(&ECP_REV_BLKSZ);
    eval 'sub ECP_REV_BLKSZ_MAX () {(32* 1024);}' unless defined(&ECP_REV_BLKSZ_MAX);
    eval 'sub ECP_REV_SPEED () {(1* 1024* 1024);}' unless defined(&ECP_REV_SPEED);
    eval 'sub ECP_REV_MINTOUT () {5;}' unless defined(&ECP_REV_MINTOUT);
    eval 'sub REV_WATCHDOG () {100;}' unless defined(&REV_WATCHDOG);
    eval 'sub SPUR_CRITICAL () {100;}' unless defined(&SPUR_CRITICAL);
    eval 'sub SPUR_PERIOD () {1000000000;}' unless defined(&SPUR_PERIOD);
    eval 'sub ECPP_STRUCTIN () {0;}' unless defined(&ECPP_STRUCTIN);
    eval 'sub ECPP_STRUCTOUT () {1;}' unless defined(&ECPP_STRUCTOUT);
    eval 'sub ECPP_ADDRIN () {2;}' unless defined(&ECPP_ADDRIN);
    eval 'sub ECPP_ADDROUT () {3;}' unless defined(&ECPP_ADDROUT);
    eval 'sub PP_PUTB {
        my($x, $y, $z) = @_;
	    eval q( &ddi_put8($x, $y, $z));
    }' unless defined(&PP_PUTB);
    eval 'sub PP_GETB {
        my($x, $y) = @_;
	    eval q( &ddi_get8($x, $y));
    }' unless defined(&PP_GETB);
    eval 'sub DSR_READ {
        my($pp) = @_;
	    eval q( &PP_GETB(($pp)-> &i_handle, ($pp)-> ($i_reg->{dsr})));
    }' unless defined(&DSR_READ);
    eval 'sub DCR_READ {
        my($pp) = @_;
	    eval q( &PP_GETB(($pp)-> &i_handle, ($pp)-> ($i_reg->{dcr})));
    }' unless defined(&DCR_READ);
    eval 'sub ECR_READ {
        my($pp) = @_;
	    eval q( &PP_GETB(($pp)-> &f_handle, ($pp)-> ($f_reg->{ecr})));
    }' unless defined(&ECR_READ);
    eval 'sub DATAR_READ {
        my($pp) = @_;
	    eval q( &PP_GETB(($pp)-> &i_handle, ($pp)-> ($i_reg->{ir}->{datar})));
    }' unless defined(&DATAR_READ);
    eval 'sub DFIFO_READ {
        my($pp) = @_;
	    eval q( &PP_GETB(($pp)-> &f_handle, ($pp)-> ($f_reg->{fr}->{dfifo})));
    }' unless defined(&DFIFO_READ);
    eval 'sub TFIFO_READ {
        my($pp) = @_;
	    eval q( &PP_GETB(($pp)-> &f_handle, ($pp)-> ($f_reg->{fr}->{tfifo})));
    }' unless defined(&TFIFO_READ);
    eval 'sub DCR_WRITE {
        my($pp, $val) = @_;
	    eval q( &PP_PUTB(($pp)-> &i_handle, ($pp)-> ($i_reg->{dcr}), $val));
    }' unless defined(&DCR_WRITE);
    eval 'sub ECR_WRITE {
        my($pp, $val) = @_;
	    eval q( &PP_PUTB(($pp)-> &f_handle, ($pp)-> ($f_reg->{ecr}), $val));
    }' unless defined(&ECR_WRITE);
    eval 'sub DATAR_WRITE {
        my($pp, $val) = @_;
	    eval q( &PP_PUTB(($pp)-> &i_handle, ($pp)-> ($i_reg->{ir}->{datar}), $val));
    }' unless defined(&DATAR_WRITE);
    eval 'sub DFIFO_WRITE {
        my($pp, $val) = @_;
	    eval q( &PP_PUTB(($pp)-> &f_handle, ($pp)-> ($f_reg->{fr}->{dfifo}), $val));
    }' unless defined(&DFIFO_WRITE);
    eval 'sub TFIFO_WRITE {
        my($pp, $val) = @_;
	    eval q( &PP_PUTB(($pp)-> &f_handle, ($pp)-> ($f_reg->{fr}->{tfifo}), $val));
    }' unless defined(&TFIFO_WRITE);
    eval 'sub OR_SET_BYTE_R {
        my($handle, $addr, $val) = @_;
	    eval q({  &uint8_t  &tmpval;  &tmpval =  &ddi_get8($handle, ( &uint8_t *)$addr);  &tmpval |= $val;  &ddi_put8($handle, ( &uint8_t *)$addr,  &tmpval); });
    }' unless defined(&OR_SET_BYTE_R);
    eval 'sub OR_SET_LONG_R {
        my($handle, $addr, $val) = @_;
	    eval q({  &uint32_t  &tmpval;  &tmpval =  &ddi_get32($handle, ( &uint32_t *)$addr);  &tmpval |= $val;  &ddi_put32($handle, ( &uint32_t *)$addr,  &tmpval); });
    }' unless defined(&OR_SET_LONG_R);
    eval 'sub AND_SET_BYTE_R {
        my($handle, $addr, $val) = @_;
	    eval q({  &uint8_t  &tmpval;  &tmpval =  &ddi_get8($handle, ( &uint8_t *)$addr);  &tmpval &= $val;  &ddi_put8($handle, ( &uint8_t *)$addr,  &tmpval); });
    }' unless defined(&AND_SET_BYTE_R);
    eval 'sub AND_SET_LONG_R {
        my($handle, $addr, $val) = @_;
	    eval q({  &uint32_t  &tmpval;  &tmpval =  &ddi_get32($handle, ( &uint32_t *)$addr);  &tmpval &= $val;  &ddi_put32($handle, ( &uint32_t *)$addr,  &tmpval); });
    }' unless defined(&AND_SET_LONG_R);
    eval 'sub NOR_SET_LONG_R {
        my($handle, $addr, $val, $mask) = @_;
	    eval q({  &uint32_t  &tmpval;  &tmpval =  &ddi_get32($handle, ( &uint32_t *)$addr);  &tmpval &= ~($mask);  &tmpval |= $val;  &ddi_put32($handle, ( &uint32_t *)$addr,  &tmpval); });
    }' unless defined(&NOR_SET_LONG_R);
    eval 'sub SET_DMAC_CSR {
        my($pp, $val) = @_;
	    eval q( &ddi_put32( ($pp->{uh}->{ebus}->{d_handle}), (( &uint32_t *) ($pp->{uh}->{ebus}->{dmac}->{csr})), (( &uint32_t)$val)));
    }' unless defined(&SET_DMAC_CSR);
    eval 'sub GET_DMAC_CSR {
        my($pp) = @_;
	    eval q( &ddi_get32( ($pp->{uh}->{ebus}->{d_handle}), ( &uint32_t *)( ($pp->{uh}->{ebus}->{dmac}->{csr}))));
    }' unless defined(&GET_DMAC_CSR);
    eval 'sub SET_DMAC_ACR {
        my($pp, $val) = @_;
	    eval q( &ddi_put32( ($pp->{uh}->{ebus}->{d_handle}), (( &uint32_t *) ($pp->{uh}->{ebus}->{dmac}->{acr})), (( &uint32_t)$val)));
    }' unless defined(&SET_DMAC_ACR);
    eval 'sub GET_DMAC_ACR {
        my($pp) = @_;
	    eval q( &ddi_get32( ($pp->{uh}->{ebus}->{d_handle}), ( &uint32_t *) ($pp->{uh}->{ebus}->{dmac}->{acr})));
    }' unless defined(&GET_DMAC_ACR);
    eval 'sub SET_DMAC_BCR {
        my($pp, $val) = @_;
	    eval q( &ddi_put32( ($pp->{uh}->{ebus}->{d_handle}), (( &uint32_t *) ($pp->{uh}->{ebus}->{dmac}->{bcr})), (( &uint32_t)$val)));
    }' unless defined(&SET_DMAC_BCR);
    eval 'sub GET_DMAC_BCR {
        my($pp) = @_;
	    eval q( &ddi_get32( ($pp->{uh}->{ebus}->{d_handle}), (( &uint32_t *) ($pp->{uh}->{ebus}->{dmac}->{bcr}))));
    }' unless defined(&GET_DMAC_BCR);
    eval 'sub DMAC_RESET_TIMEOUT () {10000;}' unless defined(&DMAC_RESET_TIMEOUT);
    eval 'sub COMPAT_PIO {
        my($pp) = @_;
	    eval q(((($pp)-> &io_mode ==  &ECPP_PIO)  && (($pp)-> &current_mode ==  &ECPP_CENTRONICS || ($pp)-> &current_mode ==  &ECPP_COMPAT_MODE)));
    }' unless defined(&COMPAT_PIO);
    eval 'sub COMPAT_DMA {
        my($pp) = @_;
	    eval q(((($pp)-> &io_mode ==  &ECPP_DMA)  && (($pp)-> &current_mode ==  &ECPP_CENTRONICS || ($pp)-> &current_mode ==  &ECPP_COMPAT_MODE)));
    }' unless defined(&COMPAT_DMA);
    eval 'sub NELEM {
        my($a) = @_;
	    eval q(($sizeof{$a} / $sizeof{($a)}));
    }' unless defined(&NELEM);
    if(defined(&__cplusplus)) {
    }
}
1;
