require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_ELF_IA64_H)) {
    eval 'sub _SYS_ELF_IA64_H () {1;}' unless defined(&_SYS_ELF_IA64_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub EF_IA_64_MASKOS () {0xf;}' unless defined(&EF_IA_64_MASKOS);
    eval 'sub EF_IA_64_ABI64 () {0x10;}' unless defined(&EF_IA_64_ABI64);
    eval 'sub EF_IA_64_ARCH () {0xff000000;}' unless defined(&EF_IA_64_ARCH);
    eval 'sub PT_IA_64_ARCHEXT () {0x70000000;}' unless defined(&PT_IA_64_ARCHEXT);
    eval 'sub PT_IA_64_UNWIND () {0x70000001;}' unless defined(&PT_IA_64_UNWIND);
    eval 'sub PF_IA_64_NORECOV () {0x80000000;}' unless defined(&PF_IA_64_NORECOV);
    eval 'sub R_IA_64_NONE () {0;}' unless defined(&R_IA_64_NONE);
    eval 'sub R_IA_64_IMM14 () {0x21;}' unless defined(&R_IA_64_IMM14);
    eval 'sub R_IA_64_IMM22 () {0x22;}' unless defined(&R_IA_64_IMM22);
    eval 'sub R_IA_64_IMM64 () {0x23;}' unless defined(&R_IA_64_IMM64);
    eval 'sub R_IA_64_DIR32MSB () {0x24;}' unless defined(&R_IA_64_DIR32MSB);
    eval 'sub R_IA_64_DIR32LSB () {0x25;}' unless defined(&R_IA_64_DIR32LSB);
    eval 'sub R_IA_64_DIR64MSB () {0x26;}' unless defined(&R_IA_64_DIR64MSB);
    eval 'sub R_IA_64_DIR64LSB () {0x27;}' unless defined(&R_IA_64_DIR64LSB);
    eval 'sub R_IA_64_GPREL22 () {0x2a;}' unless defined(&R_IA_64_GPREL22);
    eval 'sub R_IA_64_GPREL64I () {0x2b;}' unless defined(&R_IA_64_GPREL64I);
    eval 'sub R_IA_64_GPREL64MSB () {0x2e;}' unless defined(&R_IA_64_GPREL64MSB);
    eval 'sub R_IA_64_GPREL64LSB () {0x2f;}' unless defined(&R_IA_64_GPREL64LSB);
    eval 'sub R_IA_64_LTOFF22 () {0x32;}' unless defined(&R_IA_64_LTOFF22);
    eval 'sub R_IA_64_LTOFF64I () {0x33;}' unless defined(&R_IA_64_LTOFF64I);
    eval 'sub R_IA_64_PLTOFF22 () {0x3a;}' unless defined(&R_IA_64_PLTOFF22);
    eval 'sub R_IA_64_PLTOFF64I () {0x3b;}' unless defined(&R_IA_64_PLTOFF64I);
    eval 'sub R_IA_64_PLTOFF64MSB () {0x3e;}' unless defined(&R_IA_64_PLTOFF64MSB);
    eval 'sub R_IA_64_PLTOFF64LSB () {0x3f;}' unless defined(&R_IA_64_PLTOFF64LSB);
    eval 'sub R_IA_64_FPTR64I () {0x43;}' unless defined(&R_IA_64_FPTR64I);
    eval 'sub R_IA_64_FPTR32MSB () {0x44;}' unless defined(&R_IA_64_FPTR32MSB);
    eval 'sub R_IA_64_FPTR32LSB () {0x45;}' unless defined(&R_IA_64_FPTR32LSB);
    eval 'sub R_IA_64_FPTR64MSB () {0x46;}' unless defined(&R_IA_64_FPTR64MSB);
    eval 'sub R_IA_64_FPTR64LSB () {0x47;}' unless defined(&R_IA_64_FPTR64LSB);
    eval 'sub R_IA_64_PCREL21B () {0x49;}' unless defined(&R_IA_64_PCREL21B);
    eval 'sub R_IA_64_PCREL21M () {0x4a;}' unless defined(&R_IA_64_PCREL21M);
    eval 'sub R_IA_64_PCREL21F () {0x4b;}' unless defined(&R_IA_64_PCREL21F);
    eval 'sub R_IA_64_PCREL32MSB () {0x4c;}' unless defined(&R_IA_64_PCREL32MSB);
    eval 'sub R_IA_64_PCREL32LSB () {0x4d;}' unless defined(&R_IA_64_PCREL32LSB);
    eval 'sub R_IA_64_PCREL64MSB () {0x4e;}' unless defined(&R_IA_64_PCREL64MSB);
    eval 'sub R_IA_64_PCREL64LSB () {0x4f;}' unless defined(&R_IA_64_PCREL64LSB);
    eval 'sub R_IA_64_LTOFF_FPTR22 () {0x52;}' unless defined(&R_IA_64_LTOFF_FPTR22);
    eval 'sub R_IA_64_LTOFF_FPTR64I () {0x53;}' unless defined(&R_IA_64_LTOFF_FPTR64I);
    eval 'sub R_IA_64_SEGREL32MSB () {0x5c;}' unless defined(&R_IA_64_SEGREL32MSB);
    eval 'sub R_IA_64_SEGREL32LSB () {0x5d;}' unless defined(&R_IA_64_SEGREL32LSB);
    eval 'sub R_IA_64_SEGREL64MSB () {0x5e;}' unless defined(&R_IA_64_SEGREL64MSB);
    eval 'sub R_IA_64_SEGREL64LSB () {0x5f;}' unless defined(&R_IA_64_SEGREL64LSB);
    eval 'sub R_IA_64_SECREL32MSB () {0x64;}' unless defined(&R_IA_64_SECREL32MSB);
    eval 'sub R_IA_64_SECREL32LSB () {0x65;}' unless defined(&R_IA_64_SECREL32LSB);
    eval 'sub R_IA_64_SECREL64MSB () {0x66;}' unless defined(&R_IA_64_SECREL64MSB);
    eval 'sub R_IA_64_SECREL64LSB () {0x67;}' unless defined(&R_IA_64_SECREL64LSB);
    eval 'sub R_IA_64_REL32MSB () {0x6c;}' unless defined(&R_IA_64_REL32MSB);
    eval 'sub R_IA_64_REL32LSB () {0x6d;}' unless defined(&R_IA_64_REL32LSB);
    eval 'sub R_IA_64_REL64MSB () {0x6e;}' unless defined(&R_IA_64_REL64MSB);
    eval 'sub R_IA_64_REL64LSB () {0x6f;}' unless defined(&R_IA_64_REL64LSB);
    eval 'sub R_IA_64_LTV32MSB () {0x70;}' unless defined(&R_IA_64_LTV32MSB);
    eval 'sub R_IA_64_LTV32LSB () {0x71;}' unless defined(&R_IA_64_LTV32LSB);
    eval 'sub R_IA_64_LTV64MSB () {0x72;}' unless defined(&R_IA_64_LTV64MSB);
    eval 'sub R_IA_64_LTV64LSB () {0x73;}' unless defined(&R_IA_64_LTV64LSB);
    eval 'sub R_IA_64_IPLTMSB () {0x80;}' unless defined(&R_IA_64_IPLTMSB);
    eval 'sub R_IA_64_IPLTLSB () {0x81;}' unless defined(&R_IA_64_IPLTLSB);
    eval 'sub R_IA_64_NUM () {0x82;}' unless defined(&R_IA_64_NUM);
    eval 'sub ELF_IA_64_MAXPGSZ () {0x100000;}' unless defined(&ELF_IA_64_MAXPGSZ);
    eval 'sub SHF_ORDERED () {0x40000000;}' unless defined(&SHF_ORDERED);
    eval 'sub SHF_EXCLUDE () {0x80000000;}' unless defined(&SHF_EXCLUDE);
    eval 'sub SHN_BEFORE () {0xff00;}' unless defined(&SHN_BEFORE);
    eval 'sub SHN_AFTER () {0xff01;}' unless defined(&SHN_AFTER);
    eval 'sub SHT_IA_64_EXT () {0x70000000;}' unless defined(&SHT_IA_64_EXT);
    eval 'sub SHT_IA_64_UNWIND () {0x70000001;}' unless defined(&SHT_IA_64_UNWIND);
    eval 'sub SHF_IA_64_SHORT () {0x10000000;}' unless defined(&SHF_IA_64_SHORT);
    eval 'sub SHF_IA_64_NORECOV () {0x20000000;}' unless defined(&SHF_IA_64_NORECOV);
    eval 'sub DT_IA_64_PLT_RESERVE () {0x70000000;}' unless defined(&DT_IA_64_PLT_RESERVE);
    if(defined(&__cplusplus)) {
    }
}
1;
