require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_ERI_COMMON_H)) {
    eval 'sub _SYS_ERI_COMMON_H () {1;}' unless defined(&_SYS_ERI_COMMON_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval("sub ERI_NO_MSG () { 0; }") unless defined(&ERI_NO_MSG);
	eval("sub ERI_CON_MSG () { 1; }") unless defined(&ERI_CON_MSG);
	eval("sub ERI_BUF_MSG () { 2; }") unless defined(&ERI_BUF_MSG);
	eval("sub ERI_VERB_MSG () { 3; }") unless defined(&ERI_VERB_MSG);
	eval("sub ERI_LOG_MSG () { 4; }") unless defined(&ERI_LOG_MSG);
	if(defined(&DEBUG)) {
	}
	if(defined(&LATER)) {
	}
	eval 'sub SEVERITY_UNKNOWN () {0;}' unless defined(&SEVERITY_UNKNOWN);
	eval 'sub SEVERITY_NONE () {0;}' unless defined(&SEVERITY_NONE);
	eval 'sub SEVERITY_LOW () {0;}' unless defined(&SEVERITY_LOW);
	eval 'sub SEVERITY_MID () {1;}' unless defined(&SEVERITY_MID);
	eval 'sub SEVERITY_HIGH () {2;}' unless defined(&SEVERITY_HIGH);
	eval 'sub ERI_FAULT_MSG1 {
	    my($p, $t, $f, $a) = @_;
    	    eval q( &eri_fault_msg( &__FILE__,  &__LINE__, ($p), ($t), ($f), ($a)););
	}' unless defined(&ERI_FAULT_MSG1);
	eval 'sub ERI_FAULT_MSG2 {
	    my($p, $t, $f, $a, $b) = @_;
    	    eval q( &eri_fault_msg( &__FILE__,  &__LINE__, ($p), ($t), ($f), ($a), ($b)););
	}' unless defined(&ERI_FAULT_MSG2);
	eval 'sub ERI_FAULT_MSG3 {
	    my($p, $t, $f, $a, $b, $c) = @_;
    	    eval q( &eri_fault_msg( &__FILE__,  &__LINE__, ($p), ($t), ($f), ($a), ($b), ($c)););
	}' unless defined(&ERI_FAULT_MSG3);
	eval 'sub ERI_FAULT_MSG4 {
	    my($p, $t, $f, $a, $b, $c, $d) = @_;
    	    eval q( &eri_fault_msg( &__FILE__,  &__LINE__, ($p), ($t), ($f), ($a), ($b), ($c), ($d)););
	}' unless defined(&ERI_FAULT_MSG4);
	if(defined(&DEBUG)) {
	    eval("sub NO_MSG () { 0; }") unless defined(&NO_MSG);
	    eval("sub AUTOCONFIG_MSG () { 1; }") unless defined(&AUTOCONFIG_MSG);
	    eval("sub STREAMS_MSG () { 2; }") unless defined(&STREAMS_MSG);
	    eval("sub IOCTL_MSG () { 3; }") unless defined(&IOCTL_MSG);
	    eval("sub PROTO_MSG () { 4; }") unless defined(&PROTO_MSG);
	    eval("sub INIT_MSG () { 5; }") unless defined(&INIT_MSG);
	    eval("sub TX_MSG () { 6; }") unless defined(&TX_MSG);
	    eval("sub RX_MSG () { 7; }") unless defined(&RX_MSG);
	    eval("sub INTR_MSG () { 8; }") unless defined(&INTR_MSG);
	    eval("sub UNINIT_MSG () { 9; }") unless defined(&UNINIT_MSG);
	    eval("sub CONFIG_MSG () { 10; }") unless defined(&CONFIG_MSG);
	    eval("sub PROP_MSG () { 11; }") unless defined(&PROP_MSG);
	    eval("sub ENTER_MSG () { 12; }") unless defined(&ENTER_MSG);
	    eval("sub RESUME_MSG () { 13; }") unless defined(&RESUME_MSG);
	    eval("sub AUTONEG_MSG () { 14; }") unless defined(&AUTONEG_MSG);
	    eval("sub NAUTONEG_MSG () { 15; }") unless defined(&NAUTONEG_MSG);
	    eval("sub FATAL_ERR_MSG () { 16; }") unless defined(&FATAL_ERR_MSG);
	    eval("sub NONFATAL_MSG () { 17; }") unless defined(&NONFATAL_MSG);
	    eval("sub NDD_MSG () { 18; }") unless defined(&NDD_MSG);
	    eval("sub PHY_MSG () { 19; }") unless defined(&PHY_MSG);
	    eval("sub XCVR_MSG () { 20; }") unless defined(&XCVR_MSG);
	    eval("sub NSUPPORT_MSG () { 21; }") unless defined(&NSUPPORT_MSG);
	    eval("sub ERX_MSG () { 22; }") unless defined(&ERX_MSG);
	    eval("sub FREE_MSG () { 23; }") unless defined(&FREE_MSG);
	    eval("sub IPG_MSG () { 24; }") unless defined(&IPG_MSG);
	    eval("sub DDI_MSG () { 25; }") unless defined(&DDI_MSG);
	    eval("sub DEFAULT_MSG () { 26; }") unless defined(&DEFAULT_MSG);
	    eval("sub DISPLAY_MSG () { 27; }") unless defined(&DISPLAY_MSG);
	    eval("sub DIAG_MSG () { 28; }") unless defined(&DIAG_MSG);
	    eval("sub END_TRACE1_MSG () { 29; }") unless defined(&END_TRACE1_MSG);
	    eval("sub END_TRACE2_MSG () { 30; }") unless defined(&END_TRACE2_MSG);
	    eval("sub ASSERT_MSG () { 31; }") unless defined(&ASSERT_MSG);
	    eval("sub FRM_MSG () { 32; }") unless defined(&FRM_MSG);
	    eval("sub MIF_MSG () { 33; }") unless defined(&MIF_MSG);
	    eval("sub LINK_MSG () { 34; }") unless defined(&LINK_MSG);
	    eval("sub RESOURCE_MSG () { 35; }") unless defined(&RESOURCE_MSG);
	    eval("sub LOOPBACK_MSG () { 36; }") unless defined(&LOOPBACK_MSG);
	    eval("sub VERBOSE_MSG () { 37; }") unless defined(&VERBOSE_MSG);
	    eval("sub MODCTL_MSG () { 38; }") unless defined(&MODCTL_MSG);
	    eval("sub HWCSUM_MSG () { 39; }") unless defined(&HWCSUM_MSG);
	    eval("sub CORRUPTION_MSG () { 40; }") unless defined(&CORRUPTION_MSG);
	    eval("sub EXIT_MSG () { 41; }") unless defined(&EXIT_MSG);
	    eval 'sub ERI_DEBUG_MSG1 {
	        my($t, $f, $a) = @_;
    		eval q( &eri_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a)););
	    }' unless defined(&ERI_DEBUG_MSG1);
	    eval 'sub ERI_DEBUG_MSG2 {
	        my($t, $f, $a, $b) = @_;
    		eval q( &eri_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b)););
	    }' unless defined(&ERI_DEBUG_MSG2);
	    eval 'sub ERI_DEBUG_MSG3 {
	        my($t, $f, $a, $b, $c) = @_;
    		eval q( &eri_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b), ($c)););
	    }' unless defined(&ERI_DEBUG_MSG3);
	    eval 'sub ERI_DEBUG_MSG4 {
	        my($t, $f, $a, $b, $c, $d) = @_;
    		eval q( &eri_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b), ($c), ($d)););
	    }' unless defined(&ERI_DEBUG_MSG4);
	    eval 'sub ERI_DEBUG_MSG5 {
	        my($t, $f, $a, $b, $c, $d, $e) = @_;
    		eval q( &eri_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b), ($c), ($d), ($e)););
	    }' unless defined(&ERI_DEBUG_MSG5);
	} else {
	    eval 'sub ERI_DEBUG_MSG1 {
	        my($t, $f, $a) = @_;
    		eval q();
	    }' unless defined(&ERI_DEBUG_MSG1);
	    eval 'sub ERI_DEBUG_MSG2 {
	        my($t, $f, $a, $b) = @_;
    		eval q();
	    }' unless defined(&ERI_DEBUG_MSG2);
	    eval 'sub ERI_DEBUG_MSG3 {
	        my($t, $f, $a, $b, $c) = @_;
    		eval q();
	    }' unless defined(&ERI_DEBUG_MSG3);
	    eval 'sub ERI_DEBUG_MSG4 {
	        my($t, $f, $a, $b, $c, $d) = @_;
    		eval q();
	    }' unless defined(&ERI_DEBUG_MSG4);
	    eval 'sub ERI_DEBUG_MSG5 {
	        my($t, $f, $a, $b, $c, $d, $e) = @_;
    		eval q();
	    }' unless defined(&ERI_DEBUG_MSG5);
	    eval 'sub ERI_DEBUG_MSG6 {
	        my($t, $f, $a, $b, $c, $d, $e, $g, $h) = @_;
    		eval q();
	    }' unless defined(&ERI_DEBUG_MSG6);
	}
	eval 'sub ERI_HWCSUM () {1;}' unless defined(&ERI_HWCSUM);
	if(defined(&ERI_ERI_REV_1_0)) {
	    eval 'sub RCV_OVRFLOW_CORRUPTION_BUG () {1;}' unless defined(&RCV_OVRFLOW_CORRUPTION_BUG);
	}
	eval 'sub ERI_HDX_BUG_WORKAROUND () {1;}' unless defined(&ERI_HDX_BUG_WORKAROUND);
	eval 'sub ERI_TX_HUNG () {1;}' unless defined(&ERI_TX_HUNG);
	eval 'sub ERI_10_10_FORCE_SPEED_WORKAROUND () {1;}' unless defined(&ERI_10_10_FORCE_SPEED_WORKAROUND);
	eval 'sub ERI_MIF_POLL_STATUS_WORKAROUND () {1;}' unless defined(&ERI_MIF_POLL_STATUS_WORKAROUND);
	eval 'sub ERI_STRETCH_RCV_BUFFER () {1;}' unless defined(&ERI_STRETCH_RCV_BUFFER);
	if(defined(&ERI_STRETCH_RCV_BUFFER)) {
	    undef(&ERIBUFSIZE) if defined(&ERIBUFSIZE);
	    eval 'sub ERIBUFSIZE () {3904;}' unless defined(&ERIBUFSIZE);
	}
	if(defined(&notdef)) {
	    eval 'sub ERI_DONT_STRIP_CRC () {1;}' unless defined(&ERI_DONT_STRIP_CRC);
	}
	if(defined(&ERI_HWCSUM)) {
	    require 'sys/strick.ph';
	    eval 'sub ERI_RCV_CKSUM () {1;}' unless defined(&ERI_RCV_CKSUM);
	    eval 'sub IP_PACKET_IS_TCP {
	        my($ipp) = @_;
    		eval q(( ($ipp->{ip_p}) & 0x6));
	    }' unless defined(&IP_PACKET_IS_TCP);
	}
	if(defined(&notdef)) {
	    eval 'sub ERI_SERVICE_ROUTINE () {1;}' unless defined(&ERI_SERVICE_ROUTINE);
	}
	eval 'sub ERIHIWAT () {(128* 1024);}' unless defined(&ERIHIWAT);
	eval 'sub ERIRINDEX {
	    my($i) = @_;
    	    eval q(($i &  ($erip->{erirpending_mask})));
	}' unless defined(&ERIRINDEX);
	eval 'sub DONT_FLUSH () {-1;}' unless defined(&DONT_FLUSH);
	eval 'sub ERI_SYNCIOPB {
	    my($erip, $a, $size, $who) = @_;
    	    eval q(( &void)  &ddi_dma_sync(($erip)-> &md_h, (( &uintptr_t)($a) - ($erip)-> &iopbkbase), ($size), ($who)));
	}' unless defined(&ERI_SYNCIOPB);
	eval 'sub ND_BASE () {(ord(\'N\') << 8);}' unless defined(&ND_BASE);
	eval 'sub ND_GET () {( &ND_BASE + 0);}' unless defined(&ND_GET);
	eval 'sub ND_SET () {( &ND_BASE + 1);}' unless defined(&ND_SET);
	eval 'sub ERI_ND_GET () { &ND_GET;}' unless defined(&ERI_ND_GET);
	eval 'sub ERI_ND_SET () { &ND_SET;}' unless defined(&ERI_ND_SET);
	eval 'sub ERI_NOTUSR () {0xf000000;}' unless defined(&ERI_NOTUSR);
	eval 'sub ERI_MASK_1BIT () {0x1;}' unless defined(&ERI_MASK_1BIT);
	eval 'sub ERI_MASK_2BIT () {0x3;}' unless defined(&ERI_MASK_2BIT);
	eval 'sub ERI_MASK_8BIT () {0xff;}' unless defined(&ERI_MASK_8BIT);
	eval 'sub param_transceiver () {( ($erip->{param_arr[0]}->{param_val}));}' unless defined(&param_transceiver);
	eval 'sub param_linkup () {( ($erip->{param_arr[1]}->{param_val}));}' unless defined(&param_linkup);
	eval 'sub param_speed () {( ($erip->{param_arr[2]}->{param_val}));}' unless defined(&param_speed);
	eval 'sub param_mode () {( ($erip->{param_arr[3]}->{param_val}));}' unless defined(&param_mode);
	eval 'sub param_ipg1 () {( ($erip->{param_arr[4]}->{param_val}));}' unless defined(&param_ipg1);
	eval 'sub param_ipg2 () {( ($erip->{param_arr[5]}->{param_val}));}' unless defined(&param_ipg2);
	eval 'sub param_use_intphy () {( ($erip->{param_arr[6]}->{param_val}));}' unless defined(&param_use_intphy);
	eval 'sub param_pace_count () {( ($erip->{param_arr[7]}->{param_val}));}' unless defined(&param_pace_count);
	eval 'sub param_autoneg () {( ($erip->{param_arr[8]}->{param_val}));}' unless defined(&param_autoneg);
	eval 'sub param_anar_100T4 () {( ($erip->{param_arr[9]}->{param_val}));}' unless defined(&param_anar_100T4);
	eval 'sub param_anar_100fdx () {( ($erip->{param_arr[10]}->{param_val}));}' unless defined(&param_anar_100fdx);
	eval 'sub param_anar_100hdx () {( ($erip->{param_arr[11]}->{param_val}));}' unless defined(&param_anar_100hdx);
	eval 'sub param_anar_10fdx () {( ($erip->{param_arr[12]}->{param_val}));}' unless defined(&param_anar_10fdx);
	eval 'sub param_anar_10hdx () {( ($erip->{param_arr[13]}->{param_val}));}' unless defined(&param_anar_10hdx);
	eval 'sub param_bmsr_ancap () {( ($erip->{param_arr[14]}->{param_val}));}' unless defined(&param_bmsr_ancap);
	eval 'sub param_bmsr_100T4 () {( ($erip->{param_arr[15]}->{param_val}));}' unless defined(&param_bmsr_100T4);
	eval 'sub param_bmsr_100fdx () {( ($erip->{param_arr[16]}->{param_val}));}' unless defined(&param_bmsr_100fdx);
	eval 'sub param_bmsr_100hdx () {( ($erip->{param_arr[17]}->{param_val}));}' unless defined(&param_bmsr_100hdx);
	eval 'sub param_bmsr_10fdx () {( ($erip->{param_arr[18]}->{param_val}));}' unless defined(&param_bmsr_10fdx);
	eval 'sub param_bmsr_10hdx () {( ($erip->{param_arr[19]}->{param_val}));}' unless defined(&param_bmsr_10hdx);
	eval 'sub param_aner_lpancap () {( ($erip->{param_arr[20]}->{param_val}));}' unless defined(&param_aner_lpancap);
	eval 'sub param_anlpar_100T4 () {( ($erip->{param_arr[21]}->{param_val}));}' unless defined(&param_anlpar_100T4);
	eval 'sub param_anlpar_100fdx () {( ($erip->{param_arr[22]}->{param_val}));}' unless defined(&param_anlpar_100fdx);
	eval 'sub param_anlpar_100hdx () {( ($erip->{param_arr[23]}->{param_val}));}' unless defined(&param_anlpar_100hdx);
	eval 'sub param_anlpar_10fdx () {( ($erip->{param_arr[24]}->{param_val}));}' unless defined(&param_anlpar_10fdx);
	eval 'sub param_anlpar_10hdx () {( ($erip->{param_arr[25]}->{param_val}));}' unless defined(&param_anlpar_10hdx);
	eval 'sub param_device () {( ($erip->{param_arr[26]}->{param_val}));}' unless defined(&param_device);
	eval 'sub param_lance_mode () {( ($erip->{param_arr[27]}->{param_val}));}' unless defined(&param_lance_mode);
	eval 'sub param_ipg0 () {( ($erip->{param_arr[28]}->{param_val}));}' unless defined(&param_ipg0);
	eval 'sub param_intr_blank_time () {( ($erip->{param_arr[29]}->{param_val}));}' unless defined(&param_intr_blank_time);
	eval 'sub param_intr_blank_packets () {( ($erip->{param_arr[30]}->{param_val}));}' unless defined(&param_intr_blank_packets);
	eval 'sub param_serial_link () {( ($erip->{param_arr[31]}->{param_val}));}' unless defined(&param_serial_link);
	eval 'sub param_non_serial_link () {( ($erip->{param_arr[32]}->{param_val}));}' unless defined(&param_non_serial_link);
	eval 'sub param_select_link () {( ($erip->{param_arr[33]}->{param_val}));}' unless defined(&param_select_link);
	eval 'sub param_default_link () {( ($erip->{param_arr[34]}->{param_val}));}' unless defined(&param_default_link);
	eval 'sub param_link_in_use () {( ($erip->{param_arr[35]}->{param_val}));}' unless defined(&param_link_in_use);
	eval 'sub param_unknown0 () {( ($erip->{param_arr[36]}->{param_val}));}' unless defined(&param_unknown0);
	eval 'sub param_unknown1 () {( ($erip->{param_arr[37]}->{param_val}));}' unless defined(&param_unknown1);
	eval 'sub param_unknown2 () {( ($erip->{param_arr[38]}->{param_val}));}' unless defined(&param_unknown2);
	eval 'sub param_anar_asm_dir () {( ($erip->{param_arr[39]}->{param_val}));}' unless defined(&param_anar_asm_dir);
	eval 'sub param_anar_pause () {( ($erip->{param_arr[40]}->{param_val}));}' unless defined(&param_anar_pause);
	eval 'sub param_unknown3 () {( ($erip->{param_arr[41]}->{param_val}));}' unless defined(&param_unknown3);
	eval 'sub param_unknown4 () {( ($erip->{param_arr[42]}->{param_val}));}' unless defined(&param_unknown4);
	eval 'sub param_unknown5 () {( ($erip->{param_arr[43]}->{param_val}));}' unless defined(&param_unknown5);
	eval 'sub param_bmsr_asm_dir () {( ($erip->{param_arr[44]}->{param_val}));}' unless defined(&param_bmsr_asm_dir);
	eval 'sub param_bmsr_pause () {( ($erip->{param_arr[45]}->{param_val}));}' unless defined(&param_bmsr_pause);
	eval 'sub param_anlpar_autoneg () {( ($erip->{param_arr[46]}->{param_val}));}' unless defined(&param_anlpar_autoneg);
	eval 'sub param_unknown6 () {( ($erip->{param_arr[47]}->{param_val}));}' unless defined(&param_unknown6);
	eval 'sub param_unknown7 () {( ($erip->{param_arr[48]}->{param_val}));}' unless defined(&param_unknown7);
	eval 'sub param_anlpar_pauseTX () {( ($erip->{param_arr[49]}->{param_val}));}' unless defined(&param_anlpar_pauseTX);
	eval 'sub param_anlpar_pauseRX () {( ($erip->{param_arr[50]}->{param_val}));}' unless defined(&param_anlpar_pauseRX);
	eval 'sub GET_PCSREG {
	    my($reg) = @_;
    	    eval q( &ddi_get32( ($erip->{pcsregh}), ( &uint32_t *) ($erip->{pcsregp}->{reg})));
	}' unless defined(&GET_PCSREG);
	eval 'sub PUT_PCSREG {
	    my($reg, $value) = @_;
    	    eval q( &ddi_put32( ($erip->{pcsregh}), ( &uint32_t *) ($erip->{pcsregp}->{reg}), $value));
	}' unless defined(&PUT_PCSREG);
	eval 'sub GET_MIFREG {
	    my($reg) = @_;
    	    eval q( &ddi_get32( ($erip->{mifregh}), ( &uint32_t *) ($erip->{mifregp}->{reg})));
	}' unless defined(&GET_MIFREG);
	eval 'sub PUT_MIFREG {
	    my($reg, $value) = @_;
    	    eval q( &ddi_put32( ($erip->{mifregh}), ( &uint32_t *) ($erip->{mifregp}->{reg}), $value));
	}' unless defined(&PUT_MIFREG);
	eval 'sub GET_ETXREG {
	    my($reg) = @_;
    	    eval q( &ddi_get32( ($erip->{etxregh}), ( &uint32_t *) ($erip->{etxregp}->{reg})));
	}' unless defined(&GET_ETXREG);
	eval 'sub PUT_ETXREG {
	    my($reg, $value) = @_;
    	    eval q( &ddi_put32( ($erip->{etxregh}), ( &uint32_t *) ($erip->{etxregp}->{reg}), $value));
	}' unless defined(&PUT_ETXREG);
	eval 'sub GET_ERXREG {
	    my($reg) = @_;
    	    eval q( &ddi_get32( ($erip->{erxregh}), ( &uint32_t *) ($erip->{erxregp}->{reg})));
	}' unless defined(&GET_ERXREG);
	eval 'sub PUT_ERXREG {
	    my($reg, $value) = @_;
    	    eval q( &ddi_put32( ($erip->{erxregh}), ( &uint32_t *) ($erip->{erxregp}->{reg}), $value));
	}' unless defined(&PUT_ERXREG);
	eval 'sub GET_MACREG {
	    my($reg) = @_;
    	    eval q( &ddi_get32( ($erip->{bmacregh}), ( &uint32_t *) ($erip->{bmacregp}->{reg})));
	}' unless defined(&GET_MACREG);
	eval 'sub PUT_MACREG {
	    my($reg, $value) = @_;
    	    eval q( &ddi_put32( ($erip->{bmacregh}), ( &uint32_t *) ($erip->{bmacregp}->{reg}), $value));
	}' unless defined(&PUT_MACREG);
	eval 'sub GET_GLOBREG {
	    my($reg) = @_;
    	    eval q( &ddi_get32( ($erip->{globregh}), ( &uint32_t *) ($erip->{globregp}->{reg})));
	}' unless defined(&GET_GLOBREG);
	eval 'sub PUT_GLOBREG {
	    my($reg, $value) = @_;
    	    eval q( &ddi_put32( ($erip->{globregh}), ( &uint32_t *) ($erip->{globregp}->{reg}), $value));
	}' unless defined(&PUT_GLOBREG);
	eval 'sub GET_SWRSTREG {
	    my($reg) = @_;
    	    eval q( &ddi_get32( ($erip->{sw_reset_regh}), ( &uint32_t *) ($erip->{sw_reset_reg})));
	}' unless defined(&GET_SWRSTREG);
	eval 'sub PUT_SWRSTREG {
	    my($reg, $value) = @_;
    	    eval q( &ddi_put32( ($erip->{sw_reset_regh}), ( &uint32_t *) ($erip->{sw_reset_reg}), $value));
	}' unless defined(&PUT_SWRSTREG);
	eval 'sub PUT_TMD {
	    my($ptr, $cookie, $len, $flags) = @_;
    	    eval q( &ddi_put64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{tmd_addr}),  ($cookie->{dmac_laddress}));  &ddi_put64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{tmd_flags}), $len | $flags));
	}' unless defined(&PUT_TMD);
	eval 'sub PUT_TMD_FAST {
	    my($ptr, $cookie, $len, $flags) = @_;
    	    eval q( &ddi_put64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{tmd_addr}),  ($cookie->{dmac_address}));  &ddi_put64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{tmd_flags}), $len | $flags));
	}' unless defined(&PUT_TMD_FAST);
	eval 'sub GET_TMD_FLAGS {
	    my($ptr) = @_;
    	    eval q( &ddi_get64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{tmd_flags})));
	}' unless defined(&GET_TMD_FLAGS);
	eval 'sub PUT_RMD {
	    my($ptr, $cookie) = @_;
    	    eval q( &ddi_put64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{rmd_addr}),  ($cookie->{dmac_laddress}));  &ddi_put64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{rmd_flags}), ( &uint64_t)( &ERI_BUFSIZE <<  &ERI_RMD_BUFSIZE_SHIFT) |  &ERI_RMD_OWN));
	}' unless defined(&PUT_RMD);
	eval 'sub UPDATE_RMD {
	    my($ptr) = @_;
    	    eval q( &ddi_put64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{rmd_flags}), ( &uint64_t)( &ERI_BUFSIZE <<  &ERI_RMD_BUFSIZE_SHIFT) |  &ERI_RMD_OWN));
	}' unless defined(&UPDATE_RMD);
	eval 'sub PUT_RMD_FAST {
	    my($ptr, $cookie) = @_;
    	    eval q( &ddi_put64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{rmd_addr}),  ($cookie->{dmac_address}));  &ddi_put64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{rmd_flags}), ( &uint64_t)( &ERI_BUFSIZE <<  &ERI_RMD_BUFSIZE_SHIFT) |  &ERI_RMD_OWN));
	}' unless defined(&PUT_RMD_FAST);
	eval 'sub GET_RMD_FLAGS {
	    my($ptr) = @_;
    	    eval q( &ddi_get64( ($erip->{mdm_h}), ( &uint64_t *) ($ptr->{rmd_flags})));
	}' unless defined(&GET_RMD_FLAGS);
	eval 'sub ENABLE_TXMAC {
	    my($erip) = @_;
    	    eval q( &PUT_MACREG( &txcfg,  &GET_MACREG( &txcfg) |  &BMAC_TXCFG_ENAB));
	}' unless defined(&ENABLE_TXMAC);
	eval 'sub ENABLE_RXMAC {
	    my($erip) = @_;
    	    eval q( &PUT_MACREG( &rxcfg,  &GET_MACREG( &rxcfg) |  &BMAC_RXCFG_ENAB));
	}' unless defined(&ENABLE_RXMAC);
	eval 'sub DISABLE_RXMAC {
	    my($erip) = @_;
    	    eval q( &PUT_MACREG( &rxcfg,  &GET_MACREG( &rxcfg) & ~ &BMAC_RXCFG_ENAB));
	}' unless defined(&DISABLE_RXMAC);
	eval 'sub DISABLE_TXMAC {
	    my($erip) = @_;
    	    eval q( &PUT_MACREG( &txcfg,  &GET_MACREG( &txcfg) & ~ &BMAC_TXCFG_ENAB));
	}' unless defined(&DISABLE_TXMAC);
	eval 'sub ENABLE_MAC {
	    my($erip) = @_;
    	    eval q( &ENABLE_RXMAC($erip);  &ENABLE_TXMAC($erip));
	}' unless defined(&ENABLE_MAC);
	eval 'sub DISABLE_MAC {
	    my($erip) = @_;
    	    eval q( &DISABLE_RXMAC($erip);  &DISABLE_TXMAC($erip));
	}' unless defined(&DISABLE_MAC);
	eval 'sub ENABLE_TXDMA {
	    my($erip) = @_;
    	    eval q( &PUT_ETXREG( &config,  &GET_ETXREG( &config) |  &GET_CONFIG_TXDMA_EN));
	}' unless defined(&ENABLE_TXDMA);
	eval 'sub ENABLE_RXDMA {
	    my($erip) = @_;
    	    eval q( &PUT_ERXREG( &config,  &GET_ERXREG( &config) |  &GET_CONFIG_RXDMA_EN));
	}' unless defined(&ENABLE_RXDMA);
	eval 'sub ether_bcopy {
	    my($a, $b) = @_;
    	    eval q(( &bcopy($a, $b, 6)));
	}' unless defined(&ether_bcopy);
	eval 'sub get_ether_type {
	    my($ptr) = @_;
    	    eval q(( ((( &uint8_t *)(( &eehp)$ptr)-> &ether_type)[0] << 8) | ((( &uint8_t *)(( &eehp)$ptr)-> &ether_type)[1])));
	}' unless defined(&get_ether_type);
	eval 'sub put_ether_type {
	    my($ptr, $value) = @_;
    	    eval q({ (( &uint8_t *)((( &eehp)$ptr)-> &ether_type))[0] = (( &uint16_t)$value & 0xff00) >> 8; (( &uint8_t *)((( &eehp)$ptr)-> &ether_type))[1] = ($value & 0xff); });
	}' unless defined(&put_ether_type);
	if(defined(&ERI_ERI_REV_1_0)) {
	    eval 'sub IP_PACKET_LEN {
	        my($len) = @_;
    		eval q(($len - 14));
	    }' unless defined(&IP_PACKET_LEN);
	    eval 'sub INVALID_IP_PACKET_LENGTH {
	        my($ipp, $len) = @_;
    		eval q((($len > 0x3c)  && ( ($ipp->{ip_len}) != ($len - 14))));
	    }' unless defined(&INVALID_IP_PACKET_LENGTH);
	    eval 'sub IP_PACKET_IS_TCP {
	        my($ipp) = @_;
    		eval q(( ($ipp->{ip_p}) & 0x6));
	    }' unless defined(&IP_PACKET_IS_TCP);
	    eval 'sub ERI_ERX_HANG {
	        my($wp, $rp) = @_;
    		eval q((($rp <= $wp) ? (($wp - $rp) > 1275) : (($rp -$wp) < 4)));
	    }' unless defined(&ERI_ERX_HANG);
	}
	eval 'sub DEVICE_NAME {
	    my($dip) = @_;
    	    eval q((( &strcmp( &ddi_get_name($dip), \\"pci108e,1101\\") == 0) ? \\"SUNW,eri\\" : \\"SUNW,eri:unknown\\"));
	}' unless defined(&DEVICE_NAME);
	eval 'sub GETSTRUCT {
	    my($structure, $number) = @_;
    	    eval q(( &kmem_zalloc(($sizeof{$structure} * ($number)),  &KM_SLEEP)));
	}' unless defined(&GETSTRUCT);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
