require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_ERI_MAC_H)) {
    eval 'sub _SYS_ERI_MAC_H () {1;}' unless defined(&_SYS_ERI_MAC_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub ERI_GMDALIGN () {(2048);}' unless defined(&ERI_GMDALIGN);
    eval 'sub ERI_TMDMAX () {(4096);}' unless defined(&ERI_TMDMAX);
    eval 'sub ERI_RMDMAX () {(4096);}' unless defined(&ERI_RMDMAX);
    eval 'sub ERI_TMD_BUFSIZE () {(0x7fff << 0);}' unless defined(&ERI_TMD_BUFSIZE);
    eval 'sub ERI_TMD_CSSTART () {(0x3f << 15);}' unless defined(&ERI_TMD_CSSTART);
    eval 'sub ERI_TMD_CSSTUFF () {(0xff << 21);}' unless defined(&ERI_TMD_CSSTUFF);
    eval 'sub ERI_TMD_CSENABL () {(1<< 29);}' unless defined(&ERI_TMD_CSENABL);
    eval 'sub ERI_TMD_EOP () {(1<< 30);}' unless defined(&ERI_TMD_EOP);
    eval 'sub ERI_TMD_SOP () {(( &uint64_t)1<< 31);}' unless defined(&ERI_TMD_SOP);
    eval 'sub ERI_TMD_INTME () {(( &uint64_t)1<< 32);}' unless defined(&ERI_TMD_INTME);
    eval 'sub ERI_TMD_NOCRC () {(( &uint64_t)1<< 33);}' unless defined(&ERI_TMD_NOCRC);
    eval 'sub ERI_TMD_CSSTART_SHIFT () {15;}' unless defined(&ERI_TMD_CSSTART_SHIFT);
    eval 'sub ERI_TMD_CSSTUFF_SHIFT () {21;}' unless defined(&ERI_TMD_CSSTUFF_SHIFT);
    eval 'sub ERI_TCPHDR_OFFSET () {34;}' unless defined(&ERI_TCPHDR_OFFSET);
    eval 'sub ERI_IPHDR_OFFSET () {20;}' unless defined(&ERI_IPHDR_OFFSET);
    eval 'sub ERI_TCPCSUM_OFFSET () {50;}' unless defined(&ERI_TCPCSUM_OFFSET);
    eval 'sub ERI_TMDCSUM_CTL () {( &ERI_TMD_CSENABL | ( &ERI_TCPHDR_OFFSET <<  &ERI_TMD_CSSTART_SHIFT) | ( &ERI_TCPCSUM_OFFSET <<  &ERI_TMD_CSSTUFF_SHIFT));}' unless defined(&ERI_TMDCSUM_CTL);
    eval 'sub ERI_RMD_CKSUM () {(0xffff << 0);}' unless defined(&ERI_RMD_CKSUM);
    eval 'sub ERI_RMD_BUFSIZE () {(0x7fff << 16);}' unless defined(&ERI_RMD_BUFSIZE);
    eval 'sub ERI_RMD_OWN () {(( &uint64_t)1<< 31);}' unless defined(&ERI_RMD_OWN);
    eval 'sub ERI_RMD_RESERVED1 () {(( &uint64_t)0xfff << 32);}' unless defined(&ERI_RMD_RESERVED1);
    eval 'sub ERI_RMD_HASHVAL () {(( &uint64_t)0xffff << 44);}' unless defined(&ERI_RMD_HASHVAL);
    eval 'sub ERI_RMD_HASHPASS () {(( &uint64_t)1<< 60);}' unless defined(&ERI_RMD_HASHPASS);
    eval 'sub ERI_RMD_ALTERNATE () {(( &uint64_t)1<< 61);}' unless defined(&ERI_RMD_ALTERNATE);
    eval 'sub ERI_RMD_BAD () {(( &uint64_t)1<< 62);}' unless defined(&ERI_RMD_BAD);
    eval 'sub ERI_RMD_RESERVED2 () {(( &uint64_t)1<< 63);}' unless defined(&ERI_RMD_RESERVED2);
    eval 'sub ERI_RMD_BUFSIZE_SHIFT () {16;}' unless defined(&ERI_RMD_BUFSIZE_SHIFT);
    eval 'sub ERI__RMD_BUFALIGN () {8;}' unless defined(&ERI__RMD_BUFALIGN);
    eval 'sub ERI_SIOCFG_BSIZE32 () {(0x1 << 0);}' unless defined(&ERI_SIOCFG_BSIZE32);
    eval 'sub ERI_SIOCFG_BSIZE64 () {(0x1 << 1);}' unless defined(&ERI_SIOCFG_BSIZE64);
    eval 'sub ERI_SIOCFG_BSIZE128 () {(0x1 << 2);}' unless defined(&ERI_SIOCFG_BSIZE128);
    eval 'sub ERI_SIOCFG_BMODE64 () {(0x1 << 3);}' unless defined(&ERI_SIOCFG_BMODE64);
    eval 'sub ERI_SIOCFG_PARITY () {(0x1 << 9);}' unless defined(&ERI_SIOCFG_PARITY);
    eval 'sub ERI_SEB_ARBSTS () {(0x2 << 0);}' unless defined(&ERI_SEB_ARBSTS);
    eval 'sub ERI_SEB_RXWON () {(1<< 2);}' unless defined(&ERI_SEB_RXWON);
    eval 'sub ERI_G_CONFIG_BURST_SIZE () {(0x1 << 0);}' unless defined(&ERI_G_CONFIG_BURST_SIZE);
    eval 'sub ERI_G_CONFIG_TX_DMA_LIM () {(0x1f << 1);}' unless defined(&ERI_G_CONFIG_TX_DMA_LIM);
    eval 'sub ERI_G_CONFIG_RX_DMA_LIM () {(0x1f << 6);}' unless defined(&ERI_G_CONFIG_RX_DMA_LIM);
    eval 'sub ERI_G_CONFIG_BURST_64 () {0x;}' unless defined(&ERI_G_CONFIG_BURST_64);
    eval 'sub ERI_G_CONFIG_BURST_INF () {0x1;}' unless defined(&ERI_G_CONFIG_BURST_INF);
    eval 'sub ERI_G_CONFIG_TX_DMA_LIM_SHIFT () {1;}' unless defined(&ERI_G_CONFIG_TX_DMA_LIM_SHIFT);
    eval 'sub ERI_G_CONFIG_RX_DMA_LIM_SHIFT () {6;}' unless defined(&ERI_G_CONFIG_RX_DMA_LIM_SHIFT);
    eval 'sub ERI_G_STATUS_TX_INT_ME () {(1<< 0);}' unless defined(&ERI_G_STATUS_TX_INT_ME);
    eval 'sub ERI_G_STATUS_TX_ALL () {(1<< 1);}' unless defined(&ERI_G_STATUS_TX_ALL);
    eval 'sub ERI_G_STATUS_TX_DONE () {(1<< 2);}' unless defined(&ERI_G_STATUS_TX_DONE);
    eval 'sub ERI_G_STATUS_RES1 () {(1<< 3);}' unless defined(&ERI_G_STATUS_RES1);
    eval 'sub ERI_G_STATUS_RX_DONE () {(1<< 4);}' unless defined(&ERI_G_STATUS_RX_DONE);
    eval 'sub ERI_G_STATUS_RX_NO_BUF () {(1<< 5);}' unless defined(&ERI_G_STATUS_RX_NO_BUF);
    eval 'sub ERI_G_STATUS_RX_TAG_ERR () {(1<< 6);}' unless defined(&ERI_G_STATUS_RX_TAG_ERR);
    eval 'sub ERI_G_STATUS_PERR_INT () {(1<< 7);}' unless defined(&ERI_G_STATUS_PERR_INT);
    eval 'sub ERI_G_STATUS_RES2 () {(0x3f << 7);}' unless defined(&ERI_G_STATUS_RES2);
    eval 'sub ERI_G_STATUS_PCS_INT () {(1<< 13);}' unless defined(&ERI_G_STATUS_PCS_INT);
    eval 'sub ERI_G_STATUS_TX_MAC_INT () {(1<< 14);}' unless defined(&ERI_G_STATUS_TX_MAC_INT);
    eval 'sub ERI_G_STATUS_RX_MAC_INT () {(1<< 15);}' unless defined(&ERI_G_STATUS_RX_MAC_INT);
    eval 'sub ERI_G_STATUS_MAC_CTRL_INT () {(1<< 16);}' unless defined(&ERI_G_STATUS_MAC_CTRL_INT);
    eval 'sub ERI_G_STATUS_MIF_INT () {(1<< 17);}' unless defined(&ERI_G_STATUS_MIF_INT);
    eval 'sub ERI_G_STATUS_BUS_ERR_INT () {(1<< 18);}' unless defined(&ERI_G_STATUS_BUS_ERR_INT);
    eval 'sub ERI_G_STATUS_TX_COMPL () {(0xfff80000);}' unless defined(&ERI_G_STATUS_TX_COMPL);
    eval 'sub ERI_G_STATUS_INTR () {(0xffffffff & ~( &ERI_G_STATUS_TX_DONE |  &ERI_G_STATUS_TX_ALL |  &ERI_G_STATUS_MAC_CTRL_INT |  &ERI_G_STATUS_TX_COMPL));}' unless defined(&ERI_G_STATUS_INTR);
    eval 'sub ERI_G_STATUS_TX_INT () {( &ERI_G_STATUS_TX_DONE |  &ERI_G_STATUS_TX_ALL);}' unless defined(&ERI_G_STATUS_TX_INT);
    eval 'sub ERI_G_STATUS_RX_INT () {(~ &ERI_G_STATUS_TX_COMPL & ~ &ERI_G_STATUS_TX_INT);}' unless defined(&ERI_G_STATUS_RX_INT);
    eval 'sub ERI_G_STATUS_FATAL_ERR () {( &ERI_G_STATUS_RX_TAG_ERR |  &ERI_G_STATUS_PERR_INT |  &ERI_G_STATUS_BUS_ERR_INT);}' unless defined(&ERI_G_STATUS_FATAL_ERR);
    eval 'sub ERI_G_STATUS_NONFATAL_ERR () {( &ERI_G_STATUS_TX_MAC_INT |  &ERI_G_STATUS_RX_MAC_INT |  &ERI_G_STATUS_MAC_CTRL_INT);}' unless defined(&ERI_G_STATUS_NONFATAL_ERR);
    eval 'sub ERI_G_STATUS_TX_COMPL_SHIFT () {19;}' unless defined(&ERI_G_STATUS_TX_COMPL_SHIFT);
    eval 'sub ERI_G_STATUS_TX_COMPL_MASK () {0x1fff;}' unless defined(&ERI_G_STATUS_TX_COMPL_MASK);
    eval 'sub ERI_G_MASK_TX_INT_ME () {(1<< 0);}' unless defined(&ERI_G_MASK_TX_INT_ME);
    eval 'sub ERI_G_MASK_TX_ALL () {(1<< 1);}' unless defined(&ERI_G_MASK_TX_ALL);
    eval 'sub ERI_G_MASK_TX_DONE () {(1<< 2);}' unless defined(&ERI_G_MASK_TX_DONE);
    eval 'sub ERI_G_MASK_RES1 () {(1<< 3);}' unless defined(&ERI_G_MASK_RES1);
    eval 'sub ERI_G_MASK_RX_DONE () {(1<< 4);}' unless defined(&ERI_G_MASK_RX_DONE);
    eval 'sub ERI_G_MASK_RX_NO_BUF () {(1<< 5);}' unless defined(&ERI_G_MASK_RX_NO_BUF);
    eval 'sub ERI_G_MASK_RX_TAG_ERR () {(1<< 6);}' unless defined(&ERI_G_MASK_RX_TAG_ERR);
    eval 'sub ERI_G_MASK_RES2 () {(0x3f << 7);}' unless defined(&ERI_G_MASK_RES2);
    eval 'sub ERI_G_MASK_PCS_INT () {(1<< 13);}' unless defined(&ERI_G_MASK_PCS_INT);
    eval 'sub ERI_G_MASK_TX_MAC_INT () {(1<< 14);}' unless defined(&ERI_G_MASK_TX_MAC_INT);
    eval 'sub ERI_G_MASK_RX_MAC_INT () {(1<< 15);}' unless defined(&ERI_G_MASK_RX_MAC_INT);
    eval 'sub ERI_G_MASK_MAC_CTRL_INT () {(1<< 16);}' unless defined(&ERI_G_MASK_MAC_CTRL_INT);
    eval 'sub ERI_G_MASK_MIF_INT () {(1<< 17);}' unless defined(&ERI_G_MASK_MIF_INT);
    eval 'sub ERI_G_MASK_BUS_ERR_INT () {(1<< 18);}' unless defined(&ERI_G_MASK_BUS_ERR_INT);
    eval 'sub ERI_G_MASK_INTR () {(~ &ERI_G_STATUS_INTR |  &ERI_G_MASK_PCS_INT);}' unless defined(&ERI_G_MASK_INTR);
    eval 'sub ERI_G_MASK_ALL () {(0xffffffff);}' unless defined(&ERI_G_MASK_ALL);
    eval 'sub ERI_G_STS_BADACK () {(1<< 0);}' unless defined(&ERI_G_STS_BADACK);
    eval 'sub ERI_G_STS_DTRTO () {(1<< 1);}' unless defined(&ERI_G_STS_DTRTO);
    eval 'sub ERI_G_STS_OTHERS () {(1<< 2);}' unless defined(&ERI_G_STS_OTHERS);
    eval 'sub ERI_G_PCI_ERROR_MASK () {0x;}' unless defined(&ERI_G_PCI_ERROR_MASK);
    eval 'sub ERI_G_BIFCFG_SLOWCLK () {(1<< 0);}' unless defined(&ERI_G_BIFCFG_SLOWCLK);
    eval 'sub ERI_G_BIFCFG_HOST_64 () {(1<< 1);}' unless defined(&ERI_G_BIFCFG_HOST_64);
    eval 'sub ERI_G_BIFCFG_B64D_DIS () {(1<< 2);}' unless defined(&ERI_G_BIFCFG_B64D_DIS);
    eval 'sub ERI_G_BIFCFG_M66EN () {(1<< 3);}' unless defined(&ERI_G_BIFCFG_M66EN);
    eval 'sub ERI_G_RESET_ETX () {(1<< 0);}' unless defined(&ERI_G_RESET_ETX);
    eval 'sub ERI_G_RESET_ERX () {(1<< 1);}' unless defined(&ERI_G_RESET_ERX);
    eval 'sub ERI_G_RESET_RSTOUT () {(1<< 2);}' unless defined(&ERI_G_RESET_RSTOUT);
    eval 'sub ERI_G_CACHE_BIT () {16;}' unless defined(&ERI_G_CACHE_BIT);
    eval 'sub ERI_G_CACHE_LINE_SIZE_16 () {16;}' unless defined(&ERI_G_CACHE_LINE_SIZE_16);
    eval 'sub ERI_G_CACHE_LINE_SIZE_32 () {32;}' unless defined(&ERI_G_CACHE_LINE_SIZE_32);
    eval 'sub ERI_G_CACHE_16 () {( &ERI_G_CACHE_LINE_SIZE_16 <<  &ERI_G_CACHE_BIT);}' unless defined(&ERI_G_CACHE_16);
    eval 'sub ERI_G_CACHE_32 () {( &ERI_G_CACHE_LINE_SIZE_32 <<  &ERI_G_CACHE_BIT);}' unless defined(&ERI_G_CACHE_32);
    eval 'sub ERI_G_RESET_GLOBAL () {( &ERI_G_RESET_ETX |  &ERI_G_RESET_ERX);}' unless defined(&ERI_G_RESET_GLOBAL);
    eval 'sub ETX_COMPLETION_MASK () {0x1fff;}' unless defined(&ETX_COMPLETION_MASK);
    eval 'sub GET_CONFIG_TXDMA_EN () {(1<< 0);}' unless defined(&GET_CONFIG_TXDMA_EN);
    eval 'sub GET_CONFIG_TXRING_SZ () {(0xf << 1);}' unless defined(&GET_CONFIG_TXRING_SZ);
    eval 'sub GET_CONFIG_RESERVED () {(0x1f << 5);}' unless defined(&GET_CONFIG_RESERVED);
    eval 'sub GET_CONFIG_TXFIFOTH () {(0x7ff << 10);}' unless defined(&GET_CONFIG_TXFIFOTH);
    eval 'sub ETX_ERI_THRESHOLD () {0x100;}' unless defined(&ETX_ERI_THRESHOLD);
    eval 'sub ETX_CONFIG_THRESHOLD () {( &ETX_ERI_THRESHOLD << 10);}' unless defined(&ETX_CONFIG_THRESHOLD);
    eval 'sub GET_CONFIG_PACED_MODE () {(1<< 21);}' unless defined(&GET_CONFIG_PACED_MODE);
    eval 'sub GET_CONFIG_THRESHOLD () {(0x400 << 10);}' unless defined(&GET_CONFIG_THRESHOLD);
    eval 'sub GET_CONFIG_RINGSZ () {( &ERI_TMDMAX << 1);}' unless defined(&GET_CONFIG_RINGSZ);
    eval 'sub ERI_TX_RINGSZ_SHIFT () {1;}' unless defined(&ERI_TX_RINGSZ_SHIFT);
    eval 'sub ETX_RINGSZ_32 () {0;}' unless defined(&ETX_RINGSZ_32);
    eval 'sub ETX_RINGSZ_64 () {1;}' unless defined(&ETX_RINGSZ_64);
    eval 'sub ETX_RINGSZ_128 () {2;}' unless defined(&ETX_RINGSZ_128);
    eval 'sub ETX_RINGSZ_256 () {3;}' unless defined(&ETX_RINGSZ_256);
    eval 'sub ETX_RINGSZ_512 () {4;}' unless defined(&ETX_RINGSZ_512);
    eval 'sub ETX_RINGSZ_1024 () {5;}' unless defined(&ETX_RINGSZ_1024);
    eval 'sub ETX_RINGSZ_2048 () {6;}' unless defined(&ETX_RINGSZ_2048);
    eval 'sub ETX_RINGSZ_4096 () {7;}' unless defined(&ETX_RINGSZ_4096);
    eval 'sub ETX_RINGSZ_8192 () {8;}' unless defined(&ETX_RINGSZ_8192);
    eval 'sub GET_CONFIG_RXDMA_EN () {(1<< 0);}' unless defined(&GET_CONFIG_RXDMA_EN);
    eval 'sub ERI_RX_CONFIG_RXRING_SZ () {(0xf << 1);}' unless defined(&ERI_RX_CONFIG_RXRING_SZ);
    eval 'sub ERI_RX_CONFIG_BATDIS () {(1<< 5);}' unless defined(&ERI_RX_CONFIG_BATDIS);
    eval 'sub ERI_RX_CONFIG_RES1 () {(0xf << 6);}' unless defined(&ERI_RX_CONFIG_RES1);
    eval 'sub ERI_RX_CONFIG_FBOFFSET () {(0x7 << 10);}' unless defined(&ERI_RX_CONFIG_FBOFFSET);
    eval 'sub ERI_RX_CONFIG_RX_CSSTART () {(0x7f << 13);}' unless defined(&ERI_RX_CONFIG_RX_CSSTART);
    eval 'sub ERI_RX_CONFIG_RES2 () {(0xf << 20);}' unless defined(&ERI_RX_CONFIG_RES2);
    eval 'sub ERI_RX_CONFIG_RXFIFOTH () {(0x7 << 24);}' unless defined(&ERI_RX_CONFIG_RXFIFOTH);
    eval 'sub ERI_RX_RINGSZ_SHIFT () {1;}' unless defined(&ERI_RX_RINGSZ_SHIFT);
    eval 'sub ERI_RX_CONFIG_FBO_SHIFT () {10;}' unless defined(&ERI_RX_CONFIG_FBO_SHIFT);
    eval 'sub ERI_RX_CONFIG_RX_CSSTART_SHIFT () {13;}' unless defined(&ERI_RX_CONFIG_RX_CSSTART_SHIFT);
    eval 'sub ERI_RX_CONFIG_RXFIFOTH_SHIFT () {24;}' unless defined(&ERI_RX_CONFIG_RXFIFOTH_SHIFT);
    eval 'sub ERX_RINGSZ_32 () {0;}' unless defined(&ERX_RINGSZ_32);
    eval 'sub ERX_RINGSZ_64 () {1;}' unless defined(&ERX_RINGSZ_64);
    eval 'sub ERX_RINGSZ_128 () {2;}' unless defined(&ERX_RINGSZ_128);
    eval 'sub ERX_RINGSZ_256 () {3;}' unless defined(&ERX_RINGSZ_256);
    eval 'sub ERX_RINGSZ_512 () {4;}' unless defined(&ERX_RINGSZ_512);
    eval 'sub ERX_RINGSZ_1024 () {5;}' unless defined(&ERX_RINGSZ_1024);
    eval 'sub ERX_RINGSZ_2048 () {6;}' unless defined(&ERX_RINGSZ_2048);
    eval 'sub ERX_RINGSZ_4096 () {7;}' unless defined(&ERX_RINGSZ_4096);
    eval 'sub ERX_RINGSZ_8192 () {8;}' unless defined(&ERX_RINGSZ_8192);
    eval 'sub ERI_RX_FIFOTH_64 () {0;}' unless defined(&ERI_RX_FIFOTH_64);
    eval 'sub ERI_RX_FIFOTH_128 () {1;}' unless defined(&ERI_RX_FIFOTH_128);
    eval 'sub ERI_RX_FIFOTH_256 () {2;}' unless defined(&ERI_RX_FIFOTH_256);
    eval 'sub ERI_RX_FIFOTH_512 () {3;}' unless defined(&ERI_RX_FIFOTH_512);
    eval 'sub ERI_RX_FIFOTH_1024 () {4;}' unless defined(&ERI_RX_FIFOTH_1024);
    eval 'sub ERI_RX_FIFOTH_2048 () {5;}' unless defined(&ERI_RX_FIFOTH_2048);
    eval 'sub ERI_RX_PTH_OFFTH () {(0x1ff << 0);}' unless defined(&ERI_RX_PTH_OFFTH);
    eval 'sub ERI_RX_PTH_RES () {(0x7 << 9);}' unless defined(&ERI_RX_PTH_RES);
    eval 'sub ERI_RX_PTH_ONTH () {(0x1ff << 12);}' unless defined(&ERI_RX_PTH_ONTH);
    eval 'sub ERI_RX_PTH_ONTH_SHIFT () {12;}' unless defined(&ERI_RX_PTH_ONTH_SHIFT);
    eval 'sub ERI_RX_BLNK_INTR_PACKETS () {(0x1ff << 0);}' unless defined(&ERI_RX_BLNK_INTR_PACKETS);
    eval 'sub ERI_RX_BLNK_RESERVED () {(0x7 << 9);}' unless defined(&ERI_RX_BLNK_RESERVED);
    eval 'sub ERI_RX_BLNK_INTR_TIME () {(0xff << 12);}' unless defined(&ERI_RX_BLNK_INTR_TIME);
    eval 'sub ERI_RX_BLNK_INTR_TIME_SHIFT () {12;}' unless defined(&ERI_RX_BLNK_INTR_TIME_SHIFT);
    eval 'sub BMAC_OVERFLOW_STATE () {0x3800000;}' unless defined(&BMAC_OVERFLOW_STATE);
    eval 'sub BMAC_SEND_PAUSE_CMD () {0x1bf0;}' unless defined(&BMAC_SEND_PAUSE_CMD);
    eval 'sub BMAC_IPG0 () {0x;}' unless defined(&BMAC_IPG0);
    eval 'sub BMAC_IPG1 () {0x8;}' unless defined(&BMAC_IPG1);
    eval 'sub BMAC_IPG2 () {0x4;}' unless defined(&BMAC_IPG2);
    eval 'sub BMAC_SLOT_TIME () {0x40;}' unless defined(&BMAC_SLOT_TIME);
    eval 'sub BMAC_EXT_SLOT_TIME () {0x200;}' unless defined(&BMAC_EXT_SLOT_TIME);
    eval 'sub BMAC_MIN_FRAME_SIZE () {0x40;}' unless defined(&BMAC_MIN_FRAME_SIZE);
    eval 'sub BMAC_MAX_FRAME_SIZE () {( &ETHERMTU + 18);}' unless defined(&BMAC_MAX_FRAME_SIZE);
    if(defined(&ERI_RX_TAG_ERROR_WORKAROUND)) {
	eval 'sub BMAC_MAX_FRAME_SIZE_TAG () {0x7fff;}' unless defined(&BMAC_MAX_FRAME_SIZE_TAG);
    }
    eval 'sub BMAC_MAX_BURST () {(0x2000 << 16);}' unless defined(&BMAC_MAX_BURST);
    eval 'sub BMAC_PREAMBLE_SIZE () {0x7;}' unless defined(&BMAC_PREAMBLE_SIZE);
    eval 'sub BMAC_JAM_SIZE () {0x4;}' unless defined(&BMAC_JAM_SIZE);
    eval 'sub BMAC_ATTEMPT_LIMIT () {0x10;}' unless defined(&BMAC_ATTEMPT_LIMIT);
    eval 'sub BMAC_CONTROL_TYPE () {0x8808;}' unless defined(&BMAC_CONTROL_TYPE);
    eval 'sub BMAC_ADDRESS_3 () {0x;}' unless defined(&BMAC_ADDRESS_3);
    eval 'sub BMAC_ADDRESS_4 () {0x;}' unless defined(&BMAC_ADDRESS_4);
    eval 'sub BMAC_ADDRESS_5 () {0x;}' unless defined(&BMAC_ADDRESS_5);
    eval 'sub BMAC_ADDRESS_6 () {0x1;}' unless defined(&BMAC_ADDRESS_6);
    eval 'sub BMAC_ADDRESS_7 () {0xc200;}' unless defined(&BMAC_ADDRESS_7);
    eval 'sub BMAC_ADDRESS_8 () {0x180;}' unless defined(&BMAC_ADDRESS_8);
    eval 'sub BMAC_AF_0 () {0x;}' unless defined(&BMAC_AF_0);
    eval 'sub BMAC_AF_1 () {0x;}' unless defined(&BMAC_AF_1);
    eval 'sub BMAC_AF_2 () {0x;}' unless defined(&BMAC_AF_2);
    eval 'sub BMAC_AF21_MASK () {0x;}' unless defined(&BMAC_AF21_MASK);
    eval 'sub BMAC_AF0_MASK () {0x;}' unless defined(&BMAC_AF0_MASK);
    eval 'sub BMAC_COUNTER () {0x;}' unless defined(&BMAC_COUNTER);
    eval 'sub BMAC_TX_RESET () {(1<< 0);}' unless defined(&BMAC_TX_RESET);
    eval 'sub BMAC_RX_RESET () {(1<< 0);}' unless defined(&BMAC_RX_RESET);
    eval 'sub ERI_MCTLSP_TIME () {(0xffff << 0);}' unless defined(&ERI_MCTLSP_TIME);
    eval 'sub ERI_MCTLSP_SEND () {(1<< 16);}' unless defined(&ERI_MCTLSP_SEND);
    eval 'sub BMAC_TXSTS_XMIT_DONE () {(1<< 0);}' unless defined(&BMAC_TXSTS_XMIT_DONE);
    eval 'sub BMAC_TXSTS_TX_URUN () {(1<< 1);}' unless defined(&BMAC_TXSTS_TX_URUN);
    eval 'sub BMAC_TXSTS_MAXPKT_ERR () {(1<< 2);}' unless defined(&BMAC_TXSTS_MAXPKT_ERR);
    eval 'sub BMAC_TXSTS_NCC_EXP () {(1<< 3);}' unless defined(&BMAC_TXSTS_NCC_EXP);
    eval 'sub BMAC_TXSTS_ECC_EXP () {(1<< 4);}' unless defined(&BMAC_TXSTS_ECC_EXP);
    eval 'sub BMAC_TXSTS_LCC_EXP () {(1<< 5);}' unless defined(&BMAC_TXSTS_LCC_EXP);
    eval 'sub BMAC_TXSTS_FCC_EXP () {(1<< 6);}' unless defined(&BMAC_TXSTS_FCC_EXP);
    eval 'sub BMAC_TXSTS_DEFER_EXP () {(1<< 7);}' unless defined(&BMAC_TXSTS_DEFER_EXP);
    eval 'sub BMAC_TXSTS_PEAK_EXP () {(1<< 8);}' unless defined(&BMAC_TXSTS_PEAK_EXP);
    eval 'sub BMAC_TXMASK_XMIT_DONE () {(1<< 0);}' unless defined(&BMAC_TXMASK_XMIT_DONE);
    eval 'sub BMAC_TXMASK_TX_URUN () {(1<< 1);}' unless defined(&BMAC_TXMASK_TX_URUN);
    eval 'sub BMAC_TXMASK_MAXPKT_ERR () {(1<< 2);}' unless defined(&BMAC_TXMASK_MAXPKT_ERR);
    eval 'sub BMAC_TXMASK_NCC_EXP () {(1<< 3);}' unless defined(&BMAC_TXMASK_NCC_EXP);
    eval 'sub BMAC_TXMASK_ECC_EXP () {(1<< 4);}' unless defined(&BMAC_TXMASK_ECC_EXP);
    eval 'sub BMAC_TXMASK_LCC_EXP () {(1<< 5);}' unless defined(&BMAC_TXMASK_LCC_EXP);
    eval 'sub BMAC_TXMASK_FCC_EXP () {(1<< 6);}' unless defined(&BMAC_TXMASK_FCC_EXP);
    eval 'sub BMAC_TXMASK_DEFER_EXP () {(1<< 7);}' unless defined(&BMAC_TXMASK_DEFER_EXP);
    eval 'sub BMAC_TXMASK_PEAK_EXP () {(1<< 8);}' unless defined(&BMAC_TXMASK_PEAK_EXP);
    eval 'sub BMAC_TXINTR_MASK () {( &BMAC_TXMASK_XMIT_DONE |  &BMAC_TXMASK_DEFER_EXP);}' unless defined(&BMAC_TXINTR_MASK);
    eval 'sub BMAC_RXSTS_RX_DONE () {(1<< 0);}' unless defined(&BMAC_RXSTS_RX_DONE);
    eval 'sub BMAC_RXSTS_RX_OVF () {(1<< 1);}' unless defined(&BMAC_RXSTS_RX_OVF);
    eval 'sub BMAC_RXSTS_FRMCNT_EXP () {(1<< 2);}' unless defined(&BMAC_RXSTS_FRMCNT_EXP);
    eval 'sub BMAC_RXSTS_ALE_EXP () {(1<< 3);}' unless defined(&BMAC_RXSTS_ALE_EXP);
    eval 'sub BMAC_RXSTS_CRC_EXP () {(1<< 4);}' unless defined(&BMAC_RXSTS_CRC_EXP);
    eval 'sub BMAC_RXSTS_LEN_EXP () {(1<< 5);}' unless defined(&BMAC_RXSTS_LEN_EXP);
    eval 'sub BMAC_RXSTS_CVI_EXP () {(1<< 6);}' unless defined(&BMAC_RXSTS_CVI_EXP);
    eval 'sub BMAC_RXMASK_RX_DONE () {(1<< 0);}' unless defined(&BMAC_RXMASK_RX_DONE);
    eval 'sub BMAC_RXMASK_RX_OVF () {(1<< 1);}' unless defined(&BMAC_RXMASK_RX_OVF);
    eval 'sub BMAC_RXMASK_FRMCNT_EXP () {(1<< 2);}' unless defined(&BMAC_RXMASK_FRMCNT_EXP);
    eval 'sub BMAC_RXMASK_ALE_EXP () {(1<< 3);}' unless defined(&BMAC_RXMASK_ALE_EXP);
    eval 'sub BMAC_RXMASK_CRC_EXP () {(1<< 4);}' unless defined(&BMAC_RXMASK_CRC_EXP);
    eval 'sub BMAC_RXMASK_LEN_EXP () {(1<< 5);}' unless defined(&BMAC_RXMASK_LEN_EXP);
    eval 'sub BMAC_RXMASK_CVI_EXP () {(1<< 6);}' unless defined(&BMAC_RXMASK_CVI_EXP);
    eval 'sub BMAC_RXINTR_MASK () {( &BMAC_RXMASK_RX_DONE |  &BMAC_RXMASK_FRMCNT_EXP);}' unless defined(&BMAC_RXINTR_MASK);
    eval 'sub ERI_MCTLSTS_PAUSE_RCVD () {(1<< 0);}' unless defined(&ERI_MCTLSTS_PAUSE_RCVD);
    eval 'sub ERI_MCTLSTS_PAUSE_STATE () {(1<< 1);}' unless defined(&ERI_MCTLSTS_PAUSE_STATE);
    eval 'sub ERI_MCTLSTS_NONPAUSE () {(1<< 2);}' unless defined(&ERI_MCTLSTS_NONPAUSE);
    eval 'sub ERI_MCTLSTS_RESERVED () {(0x1fff << 3);}' unless defined(&ERI_MCTLSTS_RESERVED);
    eval 'sub ERI_MCTLSTS_PAUSE_TIME () {(0xffff0000);}' unless defined(&ERI_MCTLSTS_PAUSE_TIME);
    eval 'sub ERI_MCTLSTS_PAUSE_TIME_SHIFT () {16;}' unless defined(&ERI_MCTLSTS_PAUSE_TIME_SHIFT);
    eval 'sub ERI_MCTLMASK_PAUSE_RCVD () {(1<< 0);}' unless defined(&ERI_MCTLMASK_PAUSE_RCVD);
    eval 'sub ERI_MCTLMASK_PAUSE_STATE () {(1<< 1);}' unless defined(&ERI_MCTLMASK_PAUSE_STATE);
    eval 'sub ERI_MCTLMASK_NONPAUSE () {(1<< 2);}' unless defined(&ERI_MCTLMASK_NONPAUSE);
    eval 'sub ERI_MCTLMASK_RESERVED () {(0x1fff << 3);}' unless defined(&ERI_MCTLMASK_RESERVED);
    eval 'sub ERI_MCTLMASK_PAUSE_TIME () {(0xffff << 16);}' unless defined(&ERI_MCTLMASK_PAUSE_TIME);
    eval 'sub ERI_MACCTL_INTR_MASK () {0x;}' unless defined(&ERI_MACCTL_INTR_MASK);
    eval 'sub BMAC_XIFC_TX_MII_OE () {(1<< 0);}' unless defined(&BMAC_XIFC_TX_MII_OE);
    eval 'sub BMAC_XIFC_MIILPBK () {(1<< 1);}' unless defined(&BMAC_XIFC_MIILPBK);
    eval 'sub BMAC_XIFC_DIS_ECHO () {(1<< 2);}' unless defined(&BMAC_XIFC_DIS_ECHO);
    eval 'sub BMAC_XIFC_MII_MODE () {(1<< 3);}' unless defined(&BMAC_XIFC_MII_MODE);
    eval 'sub BMAC_XIFC_MIIBUF_OE () {(1<< 4);}' unless defined(&BMAC_XIFC_MIIBUF_OE);
    eval 'sub BMAC_XIFC_LINK_LED () {(1<< 5);}' unless defined(&BMAC_XIFC_LINK_LED);
    eval 'sub BMAC_XIFC_FDPLX_LED () {(1<< 6);}' unless defined(&BMAC_XIFC_FDPLX_LED);
    eval 'sub BMACTXRSTDELAY () {(125);}' unless defined(&BMACTXRSTDELAY);
    eval 'sub BMAC_TXCFG_ENAB () {(1<< 0);}' unless defined(&BMAC_TXCFG_ENAB);
    eval 'sub BMAC_TXCFG_IGNCS () {(1<< 1);}' unless defined(&BMAC_TXCFG_IGNCS);
    eval 'sub BMAC_TXCFG_IGCOLL () {(1<< 2);}' unless defined(&BMAC_TXCFG_IGCOLL);
    eval 'sub BMAC_TXCFG_ENIPG0 () {(1<< 3);}' unless defined(&BMAC_TXCFG_ENIPG0);
    eval 'sub BMAC_TXCFG_NGU () {(1<< 4);}' unless defined(&BMAC_TXCFG_NGU);
    eval 'sub BMAC_TXCFG_NGU_LIMIT () {(1<< 5);}' unless defined(&BMAC_TXCFG_NGU_LIMIT);
    eval 'sub BMAC_TXCFG_NBKOFF () {(1<< 6);}' unless defined(&BMAC_TXCFG_NBKOFF);
    eval 'sub BMAC_TXCFG_SLOWDOWN () {(1<< 7);}' unless defined(&BMAC_TXCFG_SLOWDOWN);
    eval 'sub BMAC_TXCFG_NFCS () {(1<< 8);}' unless defined(&BMAC_TXCFG_NFCS);
    eval 'sub BMAC_TXCFG_CARR_EXT () {(1<< 9);}' unless defined(&BMAC_TXCFG_CARR_EXT);
    eval 'sub BMAC_TXCFG_FDX () {( &BMAC_TXCFG_IGNCS |  &BMAC_TXCFG_IGCOLL);}' unless defined(&BMAC_TXCFG_FDX);
    eval 'sub BMACRXRSTDELAY () {(3200);}' unless defined(&BMACRXRSTDELAY);
    eval 'sub BMAC_RXCFG_ENAB () {(1<< 0);}' unless defined(&BMAC_RXCFG_ENAB);
    eval 'sub BMAC_RXCFG_STRIP_PAD () {(1<< 1);}' unless defined(&BMAC_RXCFG_STRIP_PAD);
    eval 'sub BMAC_RXCFG_STRIP_CRC () {(1<< 2);}' unless defined(&BMAC_RXCFG_STRIP_CRC);
    eval 'sub BMAC_RXCFG_PROMIS () {(1<< 3);}' unless defined(&BMAC_RXCFG_PROMIS);
    eval 'sub BMAC_RXCFG_GRPROM () {(1<< 4);}' unless defined(&BMAC_RXCFG_GRPROM);
    eval 'sub BMAC_RXCFG_HASH () {(1<< 5);}' unless defined(&BMAC_RXCFG_HASH);
    eval 'sub BMAC_RXCFG_ADDR () {(1<< 6);}' unless defined(&BMAC_RXCFG_ADDR);
    eval 'sub BMAC_RXCFG_ERR () {(1<< 7);}' unless defined(&BMAC_RXCFG_ERR);
    eval 'sub BMAC_RXCFG_CARR_EXT () {(1<< 8);}' unless defined(&BMAC_RXCFG_CARR_EXT);
    eval 'sub ERI_MCTLCFG_TXPAUSE () {(1<< 0);}' unless defined(&ERI_MCTLCFG_TXPAUSE);
    eval 'sub ERI_MCTLCFG_RXPAUSE () {(1<< 1);}' unless defined(&ERI_MCTLCFG_RXPAUSE);
    eval 'sub ERI_MCTLCFG_PASSPAUSE () {(1<< 2);}' unless defined(&ERI_MCTLCFG_PASSPAUSE);
    eval 'sub ERI_MIF_BBCLK () {(1<< 0);;}' unless defined(&ERI_MIF_BBCLK);
    eval 'sub ERI_BBCLK_LOW () {0;}' unless defined(&ERI_BBCLK_LOW);
    eval 'sub ERI_BBCLK_HIGH () {1;}' unless defined(&ERI_BBCLK_HIGH);
    eval 'sub ERI_MIF_BBDATA () {(1<< 0);;}' unless defined(&ERI_MIF_BBDATA);
    eval 'sub ERI_MIF_BBOPENB () {(1<< 0);;}' unless defined(&ERI_MIF_BBOPENB);
    eval 'sub ERI_MIF_FRDATA () {(0xffff << 0);}' unless defined(&ERI_MIF_FRDATA);
    eval 'sub ERI_MIF_FRTA0 () {(0x1 << 16);}' unless defined(&ERI_MIF_FRTA0);
    eval 'sub ERI_MIF_FRTA1 () {(0x1 << 17);}' unless defined(&ERI_MIF_FRTA1);
    eval 'sub ERI_MIF_FRREGAD () {(0x1f << 18);}' unless defined(&ERI_MIF_FRREGAD);
    eval 'sub ERI_MIF_FRPHYAD () {(0x1f << 23);}' unless defined(&ERI_MIF_FRPHYAD);
    eval 'sub ERI_MIF_FROP () {(0x3 << 28);}' unless defined(&ERI_MIF_FROP);
    eval 'sub ERI_MIF_FRST () {(0xc0000000);}' unless defined(&ERI_MIF_FRST);
    eval 'sub ERI_MIF_FRREGAD_SHIFT () {18;}' unless defined(&ERI_MIF_FRREGAD_SHIFT);
    eval 'sub ERI_MIF_FRPHYAD_SHIFT () {23;}' unless defined(&ERI_MIF_FRPHYAD_SHIFT);
    eval 'sub ERI_MIF_FRREAD () {0x60020000;}' unless defined(&ERI_MIF_FRREAD);
    eval 'sub ERI_MIF_FRWRITE () {0x50020000;}' unless defined(&ERI_MIF_FRWRITE);
    eval 'sub ERI_MAX_MIF_DELAY () {(100);}' unless defined(&ERI_MAX_MIF_DELAY);
    eval 'sub ERI_PHYRST_MAXDELAY () {(500);}' unless defined(&ERI_PHYRST_MAXDELAY);
    eval 'sub ERI_PCS_PHYRST_MAXDELAY () {(500);}' unless defined(&ERI_PCS_PHYRST_MAXDELAY);
    eval 'sub ERI_MIF_CFGPS () {(1<< 0);}' unless defined(&ERI_MIF_CFGPS);
    eval 'sub ERI_MIF_CFGPE () {(1<< 1);}' unless defined(&ERI_MIF_CFGPE);
    eval 'sub ERI_MIF_CFGBB () {(1<< 2);}' unless defined(&ERI_MIF_CFGBB);
    eval 'sub ERI_MIF_CFGPR () {(0x1f << 3);}' unless defined(&ERI_MIF_CFGPR);
    eval 'sub ERI_MIF_CFGM0 () {(1<< 8);}' unless defined(&ERI_MIF_CFGM0);
    eval 'sub ERI_MIF_CFGM1 () {(1<< 9);}' unless defined(&ERI_MIF_CFGM1);
    eval 'sub ERI_MIF_CFGPD () {(0x1f << 10);}' unless defined(&ERI_MIF_CFGPD);
    eval 'sub ERI_MIF_CFGPR_SHIFT () {3;}' unless defined(&ERI_MIF_CFGPR_SHIFT);
    eval 'sub ERI_MIF_CFGPD_SHIFT () {10;}' unless defined(&ERI_MIF_CFGPD_SHIFT);
    eval 'sub ERI_MIF_POLL_DELAY () {200;}' unless defined(&ERI_MIF_POLL_DELAY);
    eval 'sub ERI_INTERNAL_PHYAD () {1;}' unless defined(&ERI_INTERNAL_PHYAD);
    eval 'sub ERI_EXTERNAL_PHYAD () {0;}' unless defined(&ERI_EXTERNAL_PHYAD);
    eval 'sub ERI_NOXCVR_PHYAD () {99;}' unless defined(&ERI_NOXCVR_PHYAD);
    eval 'sub ERI_MIF_INTMASK () {(0xffff << 0);}' unless defined(&ERI_MIF_INTMASK);
    eval 'sub ERI_MIF_STATUS () {(0xffff << 0);}' unless defined(&ERI_MIF_STATUS);
    eval 'sub ERI_MIF_BASIC () {(0xffff << 16);}' unless defined(&ERI_MIF_BASIC);
    eval 'sub ERI_MIF_FSM () {(0x3ff << 0);}' unless defined(&ERI_MIF_FSM);
    eval 'sub PCS_BMCR_RESET () {(1<< 15);}' unless defined(&PCS_BMCR_RESET);
    eval 'sub PCS_BMCR_LPBK () {(1<< 14);}' unless defined(&PCS_BMCR_LPBK);
    eval 'sub PCS_BMCR_1000M () {(1<< 13);}' unless defined(&PCS_BMCR_1000M);
    eval 'sub PCS_BMCR_ANE () {(1<< 12);}' unless defined(&PCS_BMCR_ANE);
    eval 'sub PCS_BMCR_PWRDN () {(1<< 11);}' unless defined(&PCS_BMCR_PWRDN);
    eval 'sub PCS_BMCR_ISOLATE () {(1<< 10);}' unless defined(&PCS_BMCR_ISOLATE);
    eval 'sub PCS_BMCR_RAN () {(1<< 9);}' unless defined(&PCS_BMCR_RAN);
    eval 'sub PCS_BMCR_FDX () {(1<< 8);}' unless defined(&PCS_BMCR_FDX);
    eval 'sub PCS_BMCR_COLTST () {(1<< 7);}' unless defined(&PCS_BMCR_COLTST);
    eval 'sub PCS_BMCR_RES1 () {(0x7f << 0);}' unless defined(&PCS_BMCR_RES1);
    eval 'sub PCS_AUTONEG_DISABLE () {0;}' unless defined(&PCS_AUTONEG_DISABLE);
    eval 'sub PCS_BMSR_RES2 () {(0x1f << 11);}' unless defined(&PCS_BMSR_RES2);
    eval 'sub PCS_BMSR_GBFDX () {(1<< 10);}' unless defined(&PCS_BMSR_GBFDX);
    eval 'sub PCS_BMSR_GBHDX () {(1<< 9);}' unless defined(&PCS_BMSR_GBHDX);
    eval 'sub PCS_BMSR_RES1 () {(0x7 << 6);}' unless defined(&PCS_BMSR_RES1);
    eval 'sub PCS_BMSR_ANC () {(1<< 5);}' unless defined(&PCS_BMSR_ANC);
    eval 'sub PCS_BMSR_REMFLT () {(1<< 4);}' unless defined(&PCS_BMSR_REMFLT);
    eval 'sub PCS_BMSR_ACFG () {(1<< 3);}' unless defined(&PCS_BMSR_ACFG);
    eval 'sub PCS_BMSR_LNKSTS () {(1<< 2);}' unless defined(&PCS_BMSR_LNKSTS);
    eval 'sub PCS_BMSR_JABDET () {(1<< 1);}' unless defined(&PCS_BMSR_JABDET);
    eval 'sub PCS_BMSR_EXTCAP () {(1<< 0);}' unless defined(&PCS_BMSR_EXTCAP);
    eval 'sub PCS_CAPABILITY_MASK () {( &PCS_BMSR_GBFDX |  &PCS_BMSR_GBHDX);}' unless defined(&PCS_CAPABILITY_MASK);
    eval 'sub PCS_ANAR_NP () {(1<< 15);}' unless defined(&PCS_ANAR_NP);
    eval 'sub PCS_ANAR_ACK () {(1<< 14);}' unless defined(&PCS_ANAR_ACK);
    eval 'sub PCS_ANAR_RF () {(0x2 << 12);}' unless defined(&PCS_ANAR_RF);
    eval 'sub PCS_ANAR_RES1 () {(0x7 << 9);}' unless defined(&PCS_ANAR_RES1);
    eval 'sub PCS_ANAR_PTX () {(1<< 8);}' unless defined(&PCS_ANAR_PTX);
    eval 'sub PCS_ANAR_PRX () {(1<< 7);}' unless defined(&PCS_ANAR_PRX);
    eval 'sub PCS_ANAR_PAUSE () {(1<< 7);}' unless defined(&PCS_ANAR_PAUSE);
    eval 'sub PCS_ANAR_ASM_DIR () {(1<< 8);}' unless defined(&PCS_ANAR_ASM_DIR);
    eval 'sub PCS_ANAR_GBFDX () {(1<< 5);}' unless defined(&PCS_ANAR_GBFDX);
    eval 'sub PCS_ANAR_GBHDX () {(1<< 6);}' unless defined(&PCS_ANAR_GBHDX);
    eval 'sub PCS_ANAR_RES () {(0x1f << 0);}' unless defined(&PCS_ANAR_RES);
    eval 'sub PCS_ANLPAR_NP () {(1<< 15);}' unless defined(&PCS_ANLPAR_NP);
    eval 'sub PCS_ANLPAR_ACK () {(1<< 14);}' unless defined(&PCS_ANLPAR_ACK);
    eval 'sub PCS_ANLPAR_RF () {(0x2 << 12);}' unless defined(&PCS_ANLPAR_RF);
    eval 'sub PCS_ANLPAR_RES1 () {(0x7 << 9);}' unless defined(&PCS_ANLPAR_RES1);
    eval 'sub PCS_ANLPAR_PTX () {(1<< 8);}' unless defined(&PCS_ANLPAR_PTX);
    eval 'sub PCS_ANLPAR_PRX () {(1<< 7);}' unless defined(&PCS_ANLPAR_PRX);
    eval 'sub PCS_ANLPAR_GBFDX () {(1<< 5);}' unless defined(&PCS_ANLPAR_GBFDX);
    eval 'sub PCS_ANLPAR_GBHDX () {(1<< 6);}' unless defined(&PCS_ANLPAR_GBHDX);
    eval 'sub PCS_ANLPAR_RES () {(0x1f << 0);}' unless defined(&PCS_ANLPAR_RES);
    eval 'sub PCS_CFG_RES () {(0xfff << 4);}' unless defined(&PCS_CFG_RES);
    eval 'sub PCS_CFG_TIMER () {(0x7 << 1);}' unless defined(&PCS_CFG_TIMER);
    eval 'sub PCS_CFG_ENABLE () {(1<< 0);}' unless defined(&PCS_CFG_ENABLE);
    eval 'sub PCS_STS_LNKSTS () {2;}' unless defined(&PCS_STS_LNKSTS);
    eval 'sub ERI_PCS_MII () {(1<< 2);}' unless defined(&ERI_PCS_MII);
    eval 'sub ERI_PCS_GMIIOUTEN () {(1<< 3);}' unless defined(&ERI_PCS_GMIIOUTEN);
    eval 'sub ERI_SLC_LOOPBACK () {(1<< 0);}' unless defined(&ERI_SLC_LOOPBACK);
    eval 'sub ERI_SLC_ENSYNCDT () {(1<< 1);}' unless defined(&ERI_SLC_ENSYNCDT);
    eval 'sub ERI_SLC_LOCKREF () {(1<< 2);}' unless defined(&ERI_SLC_LOCKREF);
    eval 'sub ERI_SLC_EMP () {(0x2 << 3);}' unless defined(&ERI_SLC_EMP);
    eval 'sub ERI_SLC_RES () {(1<< 5);}' unless defined(&ERI_SLC_RES);
    eval 'sub ERI_SLC_SELFTEST () {(0x7 << 6);}' unless defined(&ERI_SLC_SELFTEST);
    eval 'sub ERI_SLC_SW_PDOWN () {(1<< 9);}' unless defined(&ERI_SLC_SW_PDOWN);
    eval 'sub ERI_SLS_STATE () {(0x2 << 0);}' unless defined(&ERI_SLS_STATE);
    eval 'sub ERI_MAX_RST_DELAY () {(200);}' unless defined(&ERI_MAX_RST_DELAY);
    eval 'sub ERI_PERIOD () {(20);}' unless defined(&ERI_PERIOD);
    eval 'sub ERI_WAITPERIOD () { &ERI_PERIOD;}' unless defined(&ERI_WAITPERIOD);
    eval 'sub ERI_DELAY {
        my($c, $n) = @_;
	    eval q({  &register \'int\'  &N = $n /  &ERI_WAITPERIOD;  &while (-- &N > 0) {  &if ($c)  &break;  &drv_usecwait( &ERI_WAITPERIOD); } });
    }' unless defined(&ERI_DELAY);
    eval 'sub MIF_ERIDELAY {
        my($n, $phyad, $regad) = @_;
	    eval q({  &register \'int\'  &N = $n /  &ERI_WAITPERIOD;  &PUT_MIFREG( &mif_frame, ( &ERI_MIF_FRREAD | ($phyad <<  &ERI_MIF_FRPHYAD_SHIFT) | ($regad <<  &ERI_MIF_FRREGAD_SHIFT)));  &while (-- &N > 0) {  &if ( &GET_MIFREG( &mif_frame) &  &ERI_MIF_FRTA0)  &break;  &drv_usecwait( &ERI_WAITPERIOD); } });
    }' unless defined(&MIF_ERIDELAY);
    if(defined(&__cplusplus)) {
    }
}
1;
