require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_ERI_PHY_H)) {
    eval 'sub _SYS_ERI_PHY_H () {1;}' unless defined(&_SYS_ERI_PHY_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub ERI_PHY_BMCR () {00;}' unless defined(&ERI_PHY_BMCR);
    eval 'sub ERI_PHY_BMSR () {01;}' unless defined(&ERI_PHY_BMSR);
    eval 'sub ERI_PHY_IDR1 () {02;}' unless defined(&ERI_PHY_IDR1);
    eval 'sub ERI_PHY_IDR2 () {03;}' unless defined(&ERI_PHY_IDR2);
    eval 'sub ERI_PHY_ANAR () {04;}' unless defined(&ERI_PHY_ANAR);
    eval 'sub ERI_PHY_ANLPAR () {05;}' unless defined(&ERI_PHY_ANLPAR);
    eval 'sub ERI_PHY_ANER () {06;}' unless defined(&ERI_PHY_ANER);
    eval 'sub ERI_PHY_DIS () {18;}' unless defined(&ERI_PHY_DIS);
    eval 'sub ERI_PHY_FCSC () {19;}' unless defined(&ERI_PHY_FCSC);
    eval 'sub ERI_PHY_NWAYTR () {20;}' unless defined(&ERI_PHY_NWAYTR);
    eval 'sub ERI_PHY_REC () {21;}' unless defined(&ERI_PHY_REC);
    eval 'sub ERI_PHY_SRR () {22;}' unless defined(&ERI_PHY_SRR);
    eval 'sub ERI_PHY_CSC () {23;}' unless defined(&ERI_PHY_CSC);
    eval 'sub ERI_PHY_LBREMR () {24;}' unless defined(&ERI_PHY_LBREMR);
    eval 'sub ERI_PHY_AR () {25;}' unless defined(&ERI_PHY_AR);
    eval 'sub ERI_PHY_VRES1 () {26;}' unless defined(&ERI_PHY_VRES1);
    eval 'sub ERI_PHY_TPISR () {27;}' unless defined(&ERI_PHY_TPISR);
    eval 'sub ERI_PHY_NICR () {28;}' unless defined(&ERI_PHY_NICR);
    eval 'sub PHY_BMCR_RESET () {(1<< 15);}' unless defined(&PHY_BMCR_RESET);
    eval 'sub PHY_BMCR_LPBK () {(1<< 14);}' unless defined(&PHY_BMCR_LPBK);
    eval 'sub PHY_BMCR_100M () {(1<< 13);}' unless defined(&PHY_BMCR_100M);
    eval 'sub PHY_BMCR_ANE () {(1<< 12);}' unless defined(&PHY_BMCR_ANE);
    eval 'sub PHY_BMCR_PWRDN () {(1<< 11);}' unless defined(&PHY_BMCR_PWRDN);
    eval 'sub PHY_BMCR_ISOLATE () {(1<< 10);}' unless defined(&PHY_BMCR_ISOLATE);
    eval 'sub PHY_BMCR_RAN () {(1<< 9);}' unless defined(&PHY_BMCR_RAN);
    eval 'sub PHY_BMCR_FDX () {(1<< 8);}' unless defined(&PHY_BMCR_FDX);
    eval 'sub PHY_BMCR_COLTST () {(1<< 7);}' unless defined(&PHY_BMCR_COLTST);
    eval 'sub PHY_BMCR_RES1 () {(0x7f << 0);}' unless defined(&PHY_BMCR_RES1);
    eval 'sub PHY_BMSR_100T4 () {(1<< 15);}' unless defined(&PHY_BMSR_100T4);
    eval 'sub PHY_BMSR_100FDX () {(1<< 14);}' unless defined(&PHY_BMSR_100FDX);
    eval 'sub PHY_BMSR_100HDX () {(1<< 13);}' unless defined(&PHY_BMSR_100HDX);
    eval 'sub PHY_BMSR_10FDX () {(1<< 12);}' unless defined(&PHY_BMSR_10FDX);
    eval 'sub PHY_BMSR_10HDX () {(1<< 11);}' unless defined(&PHY_BMSR_10HDX);
    eval 'sub PHY_BMSR_RES1 () {(0x1f << 6);}' unless defined(&PHY_BMSR_RES1);
    eval 'sub PHY_BMSR_ANC () {(1<< 5);}' unless defined(&PHY_BMSR_ANC);
    eval 'sub PHY_BMSR_REMFLT () {(1<< 4);}' unless defined(&PHY_BMSR_REMFLT);
    eval 'sub PHY_BMSR_ACFG () {(1<< 3);}' unless defined(&PHY_BMSR_ACFG);
    eval 'sub PHY_BMSR_LNKSTS () {(1<< 2);}' unless defined(&PHY_BMSR_LNKSTS);
    eval 'sub PHY_BMSR_JABDET () {(1<< 1);}' unless defined(&PHY_BMSR_JABDET);
    eval 'sub PHY_BMSR_EXTCAP () {(1<< 0);}' unless defined(&PHY_BMSR_EXTCAP);
    eval 'sub PHY_CAPABILITY_MASK () {( &PHY_BMSR_100FDX |  &PHY_BMSR_100HDX |  &PHY_BMSR_10FDX |  &PHY_BMSR_10HDX);}' unless defined(&PHY_CAPABILITY_MASK);
    eval 'sub PHY_IDR2_OUILSB () {(0x3f << 10);}' unless defined(&PHY_IDR2_OUILSB);
    eval 'sub PHY_IDR2_VNDMDL () {(0x3f << 4);}' unless defined(&PHY_IDR2_VNDMDL);
    eval 'sub PHY_IDR2_MDLREV () {(0xf << 0);}' unless defined(&PHY_IDR2_MDLREV);
    eval 'sub PHY_ANAR_NP () {(1<< 15);}' unless defined(&PHY_ANAR_NP);
    eval 'sub PHY_ANAR_ACK () {(1<< 14);}' unless defined(&PHY_ANAR_ACK);
    eval 'sub PHY_ANAR_RF () {(1<< 13);}' unless defined(&PHY_ANAR_RF);
    eval 'sub PHY_ANAR_RES1 () {(0x7 << 10);}' unless defined(&PHY_ANAR_RES1);
    eval 'sub PHY_ANAR_T4 () {(1<< 9);}' unless defined(&PHY_ANAR_T4);
    eval 'sub PHY_ANAR_TXFDX () {(1<< 8);}' unless defined(&PHY_ANAR_TXFDX);
    eval 'sub PHY_ANAR_TX () {(1<< 7);}' unless defined(&PHY_ANAR_TX);
    eval 'sub PHY_ANAR_10FDX () {(1<< 6);}' unless defined(&PHY_ANAR_10FDX);
    eval 'sub PHY_ANAR_10 () {(1<< 5);}' unless defined(&PHY_ANAR_10);
    eval 'sub PHY_ANAR_SELECT () {(0x1f << 0);}' unless defined(&PHY_ANAR_SELECT);
    eval 'sub PHY_SELECTOR () {1;}' unless defined(&PHY_SELECTOR);
    eval 'sub PHY_ANLPAR_NP () {(1<< 15);}' unless defined(&PHY_ANLPAR_NP);
    eval 'sub PHY_ANLPAR_ACK () {(1<< 14);}' unless defined(&PHY_ANLPAR_ACK);
    eval 'sub PHY_ANLPAR_RF () {(1<< 13);}' unless defined(&PHY_ANLPAR_RF);
    eval 'sub PHY_ANLPAR_RES1 () {(0x7 << 10);}' unless defined(&PHY_ANLPAR_RES1);
    eval 'sub PHY_ANLPAR_T4 () {(1<< 9);}' unless defined(&PHY_ANLPAR_T4);
    eval 'sub PHY_ANLPAR_TXFDX () {(1<< 8);}' unless defined(&PHY_ANLPAR_TXFDX);
    eval 'sub PHY_ANLPAR_TX () {(1<< 7);}' unless defined(&PHY_ANLPAR_TX);
    eval 'sub PHY_ANLPAR_10FDX () {(1<< 6);}' unless defined(&PHY_ANLPAR_10FDX);
    eval 'sub PHY_ANLPAR_10 () {(1<< 5);}' unless defined(&PHY_ANLPAR_10);
    eval 'sub PHY_ANLPAR_SELECT () {(0x1f << 0);}' unless defined(&PHY_ANLPAR_SELECT);
    eval 'sub PHY_ANER_RES1 () {(0x7ff << 5);}' unless defined(&PHY_ANER_RES1);
    eval 'sub PHY_ANER_MLF () {(1<< 4);}' unless defined(&PHY_ANER_MLF);
    eval 'sub PHY_ANER_LPNP () {(1<< 3);}' unless defined(&PHY_ANER_LPNP);
    eval 'sub PHY_ANER_NPABLE () {(1<< 2);}' unless defined(&PHY_ANER_NPABLE);
    eval 'sub PHY_ANER_PAGERX () {(1<< 1);}' unless defined(&PHY_ANER_PAGERX);
    eval 'sub PHY_ANER_LPNW () {(1<< 0);}' unless defined(&PHY_ANER_LPNW);
    eval 'sub PHY_NWAYTR_RES1 () {(0xff << 8);}' unless defined(&PHY_NWAYTR_RES1);
    eval 'sub PHY_NWAYTR_LPBK () {(1<< 7);}' unless defined(&PHY_NWAYTR_LPBK);
    eval 'sub PHY_NWAYTR_RES2 () {(0x7f << 0);}' unless defined(&PHY_NWAYTR_RES2);
    eval 'sub PHY_CSCR_NRZIDIS () {(1<< 15);}' unless defined(&PHY_CSCR_NRZIDIS);
    eval 'sub PHY_CSCR_RES1 () {(1<< 14);}' unless defined(&PHY_CSCR_RES1);
    eval 'sub PHY_CSCR_TOCDIS () {(1<< 13);}' unless defined(&PHY_CSCR_TOCDIS);
    eval 'sub PHY_CSCR_REPTR () {(1<< 12);}' unless defined(&PHY_CSCR_REPTR);
    eval 'sub PHY_CSCR_ENCSEL () {(1<< 11);}' unless defined(&PHY_CSCR_ENCSEL);
    eval 'sub PHY_CSCR_RES2 () {(0x7 << 8);}' unless defined(&PHY_CSCR_RES2);
    eval 'sub PHY_CSCR_CLK25M () {(1<< 7);}' unless defined(&PHY_CSCR_CLK25M);
    eval 'sub PHY_CSCR_FLN100 () {(1<< 6);}' unless defined(&PHY_CSCR_FLN100);
    eval 'sub PHY_CSCR_FCONN () {(1<< 5);}' unless defined(&PHY_CSCR_FCONN);
    eval 'sub PHY_CSCR_TXOFF () {(1<< 4);}' unless defined(&PHY_CSCR_TXOFF);
    eval 'sub PHY_CSCR_RES3 () {(1<< 3);}' unless defined(&PHY_CSCR_RES3);
    eval 'sub PHY_CSCR_CSTSEN () {(1<< 2);}' unless defined(&PHY_CSCR_CSTSEN);
    eval 'sub PHY_CSCR_10FDXE () {(1<< 1);}' unless defined(&PHY_CSCR_10FDXE);
    eval 'sub PHY_CSCR_RES4 () {(1<< 0);}' unless defined(&PHY_CSCR_RES4);
    eval 'sub PHY_LBREMR_BPEB () {(1<< 15);}' unless defined(&PHY_LBREMR_BPEB);
    eval 'sub PHY_LBREMR_BP4B5B () {(1<< 14);}' unless defined(&PHY_LBREMR_BP4B5B);
    eval 'sub PHY_LBREMR_BPSCR () {(1<< 13);}' unless defined(&PHY_LBREMR_BPSCR);
    eval 'sub PHY_LBREMR_BPALIGN () {(1<< 12);}' unless defined(&PHY_LBREMR_BPALIGN);
    eval 'sub PHY_LBREMR_EWRAP () {(1<< 11);}' unless defined(&PHY_LBREMR_EWRAP);
    eval 'sub PHY_LBREMR_XWRAP () {(1<< 10);}' unless defined(&PHY_LBREMR_XWRAP);
    eval 'sub PHY_LBREMR_LB () {(0x3 << 8);}' unless defined(&PHY_LBREMR_LB);
    eval 'sub PHY_LBREMR_RES1 () {(0x7 << 5);}' unless defined(&PHY_LBREMR_RES1);
    eval 'sub PHY_LBREMR_CODE () {(1<< 4);}' unless defined(&PHY_LBREMR_CODE);
    eval 'sub PHY_LBREMR_PME () {(1<< 3);}' unless defined(&PHY_LBREMR_PME);
    eval 'sub PHY_LBREMR_LINK () {(1<< 2);}' unless defined(&PHY_LBREMR_LINK);
    eval 'sub PHY_LBREMR_PKT () {(1<< 1);}' unless defined(&PHY_LBREMR_PKT);
    eval 'sub PHY_LBREMR_EB () {(1<< 0);}' unless defined(&PHY_LBREMR_EB);
    eval 'sub PHY_AR_RES1 () {(0x1ff << 7);}' unless defined(&PHY_AR_RES1);
    eval 'sub PHY_AR_SPEED10 () {(1<< 6);}' unless defined(&PHY_AR_SPEED10);
    eval 'sub PHY_AR_CONSTS () {(1<< 5);}' unless defined(&PHY_AR_CONSTS);
    eval 'sub PHY_AR_ADDR () {(0x1f << 0);}' unless defined(&PHY_AR_ADDR);
    eval 'sub PHY_TPISR_RES1 () {(0x3f << 10);}' unless defined(&PHY_TPISR_RES1);
    eval 'sub PHY_TPISR_10BTSER () {(1<< 9);}' unless defined(&PHY_TPISR_10BTSER);
    eval 'sub PHY_TPISR_RES2 () {(0x1ff << 0);}' unless defined(&PHY_TPISR_RES2);
    eval 'sub PHY_NICR_RES1 () {(0x3ff << 6);}' unless defined(&PHY_NICR_RES1);
    eval 'sub PHY_NICR_LD () {(1<< 5);}' unless defined(&PHY_NICR_LD);
    eval 'sub PHY_NICR_HBE () {(1<< 4);}' unless defined(&PHY_NICR_HBE);
    eval 'sub PHY_NICR_UTP () {(1<< 3);}' unless defined(&PHY_NICR_UTP);
    eval 'sub PHY_NICR_LSS () {(1<< 2);}' unless defined(&PHY_NICR_LSS);
    eval 'sub PHY_NICR_RES2 () {(1<< 1);}' unless defined(&PHY_NICR_RES2);
    eval 'sub PHY_NICR_JBEN () {(1<< 0);}' unless defined(&PHY_NICR_JBEN);
    if(defined(&__cplusplus)) {
    }
}
1;
