require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_EXACCT_H)) {
    eval 'sub _SYS_EXACCT_H () {1;}' unless defined(&_SYS_EXACCT_H);
    require 'sys/types.ph';
    require 'sys/task.ph';
    require 'sys/proc.ph';
    require 'sys/procset.ph';
    if(defined(&_KERNEL)) {
	require 'sys/acctctl.ph';
	require 'sys/kmem.ph';
	require 'sys/taskq.ph';
	require 'sys/vnode.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub EXACCT_VERSION () {1;}' unless defined(&EXACCT_VERSION);
    eval 'sub EUP_ALLOC () {0x;}' unless defined(&EUP_ALLOC);
    eval 'sub EUP_NOALLOC () {0x1;}' unless defined(&EUP_NOALLOC);
    eval 'sub EUP_ALLOC_MASK () {0x1;}' unless defined(&EUP_ALLOC_MASK);
    eval 'sub EW_PARTIAL () {(0x1);}' unless defined(&EW_PARTIAL);
    eval 'sub EW_INTERVAL () {(0x2);}' unless defined(&EW_INTERVAL);
    eval 'sub EW_FINAL () {(0x4);}' unless defined(&EW_FINAL);
    eval 'sub EP_RAW () {0;}' unless defined(&EP_RAW);
    eval 'sub EP_EXACCT_OBJECT () {1;}' unless defined(&EP_EXACCT_OBJECT);
    eval 'sub EXACCT_MAX_BUFSIZE () {(64* 1024);}' unless defined(&EXACCT_MAX_BUFSIZE);
    unless(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub EA_SET_ERR {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&EA_SET_ERR);
    } else {
	eval 'sub EA_SET_ERR {
	    my($x) = @_;
    	    eval q({  &_ea_errval = ($x); });
	}' unless defined(&EA_SET_ERR);
    }
    eval 'sub EXR_OK () {0;}' unless defined(&EXR_OK);
    eval 'sub EXR_SYSCALL_FAIL () {1;}' unless defined(&EXR_SYSCALL_FAIL);
    eval 'sub EXR_CORRUPT_FILE () {2;}' unless defined(&EXR_CORRUPT_FILE);
    eval 'sub EXR_EOF () {3;}' unless defined(&EXR_EOF);
    eval 'sub EXR_NO_CREATOR () {4;}' unless defined(&EXR_NO_CREATOR);
    eval 'sub EXR_INVALID_BUF () {5;}' unless defined(&EXR_INVALID_BUF);
    eval 'sub EXR_NOTSUPP () {6;}' unless defined(&EXR_NOTSUPP);
    eval 'sub EXR_UNKN_VERSION () {7;}' unless defined(&EXR_UNKN_VERSION);
    eval("sub EO_NONE () { 0; }") unless defined(&EO_NONE);
    eval("sub EO_GROUP () { 1; }") unless defined(&EO_GROUP);
    eval("sub EO_ITEM () { 2; }") unless defined(&EO_ITEM);
    eval 'sub ei_uint8 () { ($ei_u->{ei_u_uint8});}' unless defined(&ei_uint8);
    eval 'sub ei_uint16 () { ($ei_u->{ei_u_uint16});}' unless defined(&ei_uint16);
    eval 'sub ei_uint32 () { ($ei_u->{ei_u_uint32});}' unless defined(&ei_uint32);
    eval 'sub ei_uint64 () { ($ei_u->{ei_u_uint64});}' unless defined(&ei_uint64);
    eval 'sub ei_double () { ($ei_u->{ei_u_double});}' unless defined(&ei_double);
    eval 'sub ei_string () { ($ei_u->{ei_u_string});}' unless defined(&ei_string);
    eval 'sub ei_object () { ($ei_u->{ei_u_object});}' unless defined(&ei_object);
    eval 'sub ei_raw () { ($ei_u->{ei_u_raw});}' unless defined(&ei_raw);
    eval 'sub eo_group () { ($eo_u->{eo_u_group});}' unless defined(&eo_group);
    eval 'sub eo_item () { ($eo_u->{eo_u_item});}' unless defined(&eo_item);
    if(defined(&_KERNEL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
