require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_EXACCT_CATALOG_H)) {
    eval 'sub _SYS_EXACCT_CATALOG_H () {1;}' unless defined(&_SYS_EXACCT_CATALOG_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub EXT_TYPE_MASK () {(( &uint_t)0xf << 28);}' unless defined(&EXT_TYPE_MASK);
    eval 'sub EXT_NONE () {(( &uint_t)0x << 28);}' unless defined(&EXT_NONE);
    eval 'sub EXT_UINT8 () {(( &uint_t)0x1 << 28);}' unless defined(&EXT_UINT8);
    eval 'sub EXT_UINT16 () {(( &uint_t)0x2 << 28);}' unless defined(&EXT_UINT16);
    eval 'sub EXT_UINT32 () {(( &uint_t)0x3 << 28);}' unless defined(&EXT_UINT32);
    eval 'sub EXT_UINT64 () {(( &uint_t)0x4 << 28);}' unless defined(&EXT_UINT64);
    eval 'sub EXT_DOUBLE () {(( &uint_t)0x5 << 28);}' unless defined(&EXT_DOUBLE);
    eval 'sub EXT_STRING () {(( &uint_t)0x6 << 28);}' unless defined(&EXT_STRING);
    eval 'sub EXT_EXACCT_OBJECT () {(( &uint_t)0x7 << 28);}' unless defined(&EXT_EXACCT_OBJECT);
    eval 'sub EXT_RAW () {(( &uint_t)0x8 << 28);}' unless defined(&EXT_RAW);
    eval 'sub EXT_GROUP () {(( &uint_t)0xf << 28);}' unless defined(&EXT_GROUP);
    eval 'sub EXC_CATALOG_MASK () {(( &uint_t)0xf << 24);}' unless defined(&EXC_CATALOG_MASK);
    eval 'sub EXC_NONE () {(0x << 24);}' unless defined(&EXC_NONE);
    eval 'sub EXC_LOCAL () {(0x1 << 24);}' unless defined(&EXC_LOCAL);
    eval 'sub EXC_DEFAULT () { &EXC_NONE;}' unless defined(&EXC_DEFAULT);
    eval 'sub EXD_DATA_MASK () {0xffffff;}' unless defined(&EXD_DATA_MASK);
    eval 'sub EXD_NONE () {0x;}' unless defined(&EXD_NONE);
    eval 'sub EXD_VERSION () {0x1;}' unless defined(&EXD_VERSION);
    eval 'sub EXD_FILETYPE () {0x2;}' unless defined(&EXD_FILETYPE);
    eval 'sub EXD_CREATOR () {0x3;}' unless defined(&EXD_CREATOR);
    eval 'sub EXD_HOSTNAME () {0x4;}' unless defined(&EXD_HOSTNAME);
    eval 'sub EXD_GROUP_HEADER () {0xff;}' unless defined(&EXD_GROUP_HEADER);
    eval 'sub EXD_GROUP_PROC () {0x100;}' unless defined(&EXD_GROUP_PROC);
    eval 'sub EXD_GROUP_TASK () {0x101;}' unless defined(&EXD_GROUP_TASK);
    eval 'sub EXD_GROUP_LWP () {0x102;}' unless defined(&EXD_GROUP_LWP);
    eval 'sub EXD_GROUP_PROC_TAG () {0x103;}' unless defined(&EXD_GROUP_PROC_TAG);
    eval 'sub EXD_GROUP_TASK_TAG () {0x104;}' unless defined(&EXD_GROUP_TASK_TAG);
    eval 'sub EXD_GROUP_LWP_TAG () {0x105;}' unless defined(&EXD_GROUP_LWP_TAG);
    eval 'sub EXD_GROUP_PROC_PARTIAL () {0x106;}' unless defined(&EXD_GROUP_PROC_PARTIAL);
    eval 'sub EXD_GROUP_TASK_PARTIAL () {0x107;}' unless defined(&EXD_GROUP_TASK_PARTIAL);
    eval 'sub EXD_GROUP_TASK_INTERVAL () {0x108;}' unless defined(&EXD_GROUP_TASK_INTERVAL);
    eval 'sub EXD_PROC_PID () {0x1000;}' unless defined(&EXD_PROC_PID);
    eval 'sub EXD_PROC_UID () {0x1001;}' unless defined(&EXD_PROC_UID);
    eval 'sub EXD_PROC_GID () {0x1002;}' unless defined(&EXD_PROC_GID);
    eval 'sub EXD_PROC_TASKID () {0x1003;}' unless defined(&EXD_PROC_TASKID);
    eval 'sub EXD_PROC_PROJID () {0x1004;}' unless defined(&EXD_PROC_PROJID);
    eval 'sub EXD_PROC_HOSTNAME () {0x1005;}' unless defined(&EXD_PROC_HOSTNAME);
    eval 'sub EXD_PROC_COMMAND () {0x1006;}' unless defined(&EXD_PROC_COMMAND);
    eval 'sub EXD_PROC_START_SEC () {0x1007;}' unless defined(&EXD_PROC_START_SEC);
    eval 'sub EXD_PROC_START_NSEC () {0x1008;}' unless defined(&EXD_PROC_START_NSEC);
    eval 'sub EXD_PROC_FINISH_SEC () {0x1009;}' unless defined(&EXD_PROC_FINISH_SEC);
    eval 'sub EXD_PROC_FINISH_NSEC () {0x100a;}' unless defined(&EXD_PROC_FINISH_NSEC);
    eval 'sub EXD_PROC_CPU_USER_SEC () {0x100b;}' unless defined(&EXD_PROC_CPU_USER_SEC);
    eval 'sub EXD_PROC_CPU_USER_NSEC () {0x100c;}' unless defined(&EXD_PROC_CPU_USER_NSEC);
    eval 'sub EXD_PROC_CPU_SYS_SEC () {0x100d;}' unless defined(&EXD_PROC_CPU_SYS_SEC);
    eval 'sub EXD_PROC_CPU_SYS_NSEC () {0x100e;}' unless defined(&EXD_PROC_CPU_SYS_NSEC);
    eval 'sub EXD_PROC_TTY_MAJOR () {0x100f;}' unless defined(&EXD_PROC_TTY_MAJOR);
    eval 'sub EXD_PROC_TTY_MINOR () {0x1010;}' unless defined(&EXD_PROC_TTY_MINOR);
    eval 'sub EXD_PROC_FAULTS_MAJOR () {0x1011;}' unless defined(&EXD_PROC_FAULTS_MAJOR);
    eval 'sub EXD_PROC_FAULTS_MINOR () {0x1012;}' unless defined(&EXD_PROC_FAULTS_MINOR);
    eval 'sub EXD_PROC_MESSAGES_RCV () {0x1013;}' unless defined(&EXD_PROC_MESSAGES_RCV);
    eval 'sub EXD_PROC_MESSAGES_SND () {0x1014;}' unless defined(&EXD_PROC_MESSAGES_SND);
    eval 'sub EXD_PROC_BLOCKS_IN () {0x1015;}' unless defined(&EXD_PROC_BLOCKS_IN);
    eval 'sub EXD_PROC_BLOCKS_OUT () {0x1016;}' unless defined(&EXD_PROC_BLOCKS_OUT);
    eval 'sub EXD_PROC_CHARS_RDWR () {0x1017;}' unless defined(&EXD_PROC_CHARS_RDWR);
    eval 'sub EXD_PROC_CONTEXT_VOL () {0x1018;}' unless defined(&EXD_PROC_CONTEXT_VOL);
    eval 'sub EXD_PROC_CONTEXT_INV () {0x1019;}' unless defined(&EXD_PROC_CONTEXT_INV);
    eval 'sub EXD_PROC_SIGNALS () {0x101a;}' unless defined(&EXD_PROC_SIGNALS);
    eval 'sub EXD_PROC_SWAPS () {0x101b;}' unless defined(&EXD_PROC_SWAPS);
    eval 'sub EXD_PROC_SYSCALLS () {0x101c;}' unless defined(&EXD_PROC_SYSCALLS);
    eval 'sub EXD_PROC_ACCT_FLAGS () {0x101d;}' unless defined(&EXD_PROC_ACCT_FLAGS);
    eval 'sub EXD_PROC_TAG () {0x101e;}' unless defined(&EXD_PROC_TAG);
    eval 'sub EXD_TASK_TASKID () {0x2000;}' unless defined(&EXD_TASK_TASKID);
    eval 'sub EXD_TASK_PROJID () {0x2001;}' unless defined(&EXD_TASK_PROJID);
    eval 'sub EXD_TASK_HOSTNAME () {0x2002;}' unless defined(&EXD_TASK_HOSTNAME);
    eval 'sub EXD_TASK_START_SEC () {0x2003;}' unless defined(&EXD_TASK_START_SEC);
    eval 'sub EXD_TASK_START_NSEC () {0x2004;}' unless defined(&EXD_TASK_START_NSEC);
    eval 'sub EXD_TASK_FINISH_SEC () {0x2005;}' unless defined(&EXD_TASK_FINISH_SEC);
    eval 'sub EXD_TASK_FINISH_NSEC () {0x2006;}' unless defined(&EXD_TASK_FINISH_NSEC);
    eval 'sub EXD_TASK_CPU_USER_SEC () {0x2007;}' unless defined(&EXD_TASK_CPU_USER_SEC);
    eval 'sub EXD_TASK_CPU_USER_NSEC () {0x2008;}' unless defined(&EXD_TASK_CPU_USER_NSEC);
    eval 'sub EXD_TASK_CPU_SYS_SEC () {0x2009;}' unless defined(&EXD_TASK_CPU_SYS_SEC);
    eval 'sub EXD_TASK_CPU_SYS_NSEC () {0x200a;}' unless defined(&EXD_TASK_CPU_SYS_NSEC);
    eval 'sub EXD_TASK_FAULTS_MAJOR () {0x200b;}' unless defined(&EXD_TASK_FAULTS_MAJOR);
    eval 'sub EXD_TASK_FAULTS_MINOR () {0x200c;}' unless defined(&EXD_TASK_FAULTS_MINOR);
    eval 'sub EXD_TASK_MESSAGES_RCV () {0x200d;}' unless defined(&EXD_TASK_MESSAGES_RCV);
    eval 'sub EXD_TASK_MESSAGES_SND () {0x200e;}' unless defined(&EXD_TASK_MESSAGES_SND);
    eval 'sub EXD_TASK_BLOCKS_IN () {0x200f;}' unless defined(&EXD_TASK_BLOCKS_IN);
    eval 'sub EXD_TASK_BLOCKS_OUT () {0x2010;}' unless defined(&EXD_TASK_BLOCKS_OUT);
    eval 'sub EXD_TASK_CHARS_RDWR () {0x2011;}' unless defined(&EXD_TASK_CHARS_RDWR);
    eval 'sub EXD_TASK_CONTEXT_VOL () {0x2012;}' unless defined(&EXD_TASK_CONTEXT_VOL);
    eval 'sub EXD_TASK_CONTEXT_INV () {0x2013;}' unless defined(&EXD_TASK_CONTEXT_INV);
    eval 'sub EXD_TASK_SIGNALS () {0x2014;}' unless defined(&EXD_TASK_SIGNALS);
    eval 'sub EXD_TASK_SWAPS () {0x2015;}' unless defined(&EXD_TASK_SWAPS);
    eval 'sub EXD_TASK_SYSCALLS () {0x2016;}' unless defined(&EXD_TASK_SYSCALLS);
    eval 'sub EXD_TASK_TAG () {0x2017;}' unless defined(&EXD_TASK_TAG);
    if(defined(&__cplusplus)) {
    }
}
1;
