require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FDVAR_H)) {
    eval 'sub _SYS_FDVAR_H () {1;}' unless defined(&_SYS_FDVAR_H);
    if(defined(&__cplusplus)) {
    }
    unless(defined(&OTYPCNT)) {
	eval 'sub OTYPCNT () {5;}' unless defined(&OTYPCNT);
    }
    unless(defined(&NDKMAP)) {
	eval 'sub NDKMAP () {8;}' unless defined(&NDKMAP);
    }
    eval 'sub FDUNITSHIFT () {(3);}' unless defined(&FDUNITSHIFT);
    eval 'sub FDINSTSHIFT () {(2+  &FDUNITSHIFT);}' unless defined(&FDINSTSHIFT);
    eval 'sub FDPARTITION {
        my($x) = @_;
	    eval q(( &getminor($x) & 0x7));
    }' unless defined(&FDPARTITION);
    eval 'sub FDUNIT {
        my($x) = @_;
	    eval q((( &getminor($x) >>  &FDUNITSHIFT) & 0x3));
    }' unless defined(&FDUNIT);
    eval 'sub FDCTLR {
        my($x) = @_;
	    eval q(( &getminor($x) >>  &FDINSTSHIFT));
    }' unless defined(&FDCTLR);
    unless(defined(&_ASM)) {
    }
    eval 'sub CSB_OFIMMEDIATE () {0x1;}' unless defined(&CSB_OFIMMEDIATE);
    eval 'sub CSB_OFSEEKOPS () {0x2;}' unless defined(&CSB_OFSEEKOPS);
    eval 'sub CSB_OFXFEROPS () {0x4;}' unless defined(&CSB_OFXFEROPS);
    eval 'sub CSB_OFRAWIOCTL () {0x10;}' unless defined(&CSB_OFRAWIOCTL);
    eval 'sub CSB_OFNORESULTS () {0x20;}' unless defined(&CSB_OFNORESULTS);
    eval 'sub CSB_OFTIMEIT () {0x40;}' unless defined(&CSB_OFTIMEIT);
    eval 'sub CSB_CMDTO () {0x1;}' unless defined(&CSB_CMDTO);
    eval 'sub CSB_NULL () {0x;}' unless defined(&CSB_NULL);
    eval 'sub CSB_READ () {0x1;}' unless defined(&CSB_READ);
    eval 'sub CSB_WRITE () {0x2;}' unless defined(&CSB_WRITE);
    unless(defined(&_ASM)) {
	unless(defined(&_GENASSYM)) {
	    eval 'sub FDUNIT_DRVCHECKED () {0x1;}' unless defined(&FDUNIT_DRVCHECKED);
	    eval 'sub FDUNIT_DRVPRESENT () {0x2;}' unless defined(&FDUNIT_DRVPRESENT);
	    eval 'sub FDUNIT_CHAROK () {0x4;}' unless defined(&FDUNIT_CHAROK);
	    eval 'sub FDUNIT_UNLABELED () {0x10;}' unless defined(&FDUNIT_UNLABELED);
	    eval 'sub FDUNIT_CHANGED () {0x20;}' unless defined(&FDUNIT_CHANGED);
	    eval 'sub FDUNIT_MEDIUM () {0x40;}' unless defined(&FDUNIT_MEDIUM);
	    eval 'sub FDUNIT_SET_SPEED () {0x80;}' unless defined(&FDUNIT_SET_SPEED);
	}
	eval 'sub FD_STATE_NORMAL () {0x;}' unless defined(&FD_STATE_NORMAL);
	eval 'sub FD_STATE_SUSPENDED () {0x1;}' unless defined(&FD_STATE_SUSPENDED);
	eval 'sub FD_STATE_STOPPED () {0x2;}' unless defined(&FD_STATE_STOPPED);
	eval 'sub PM_LEVEL_ON () {0x1;}' unless defined(&PM_LEVEL_ON);
	eval 'sub PM_LEVEL_OFF () {0x;}' unless defined(&PM_LEVEL_OFF);
    }
    eval 'sub FDCTYPE_82072 () {0x1;}' unless defined(&FDCTYPE_82072);
    eval 'sub FDCTYPE_82077 () {0x2;}' unless defined(&FDCTYPE_82077);
    eval 'sub FDCTYPE_CTRLMASK () {0xf;}' unless defined(&FDCTYPE_CTRLMASK);
    eval 'sub FDCTYPE_MACHIO () {0x10;}' unless defined(&FDCTYPE_MACHIO);
    eval 'sub FDCTYPE_SLAVIO () {0x20;}' unless defined(&FDCTYPE_SLAVIO);
    eval 'sub FDCTYPE_CHEERIO () {0x40;}' unless defined(&FDCTYPE_CHEERIO);
    eval 'sub FDCTYPE_SB () {0x80;}' unless defined(&FDCTYPE_SB);
    eval 'sub FDCTYPE_AUXIOMASK () {0xf0;}' unless defined(&FDCTYPE_AUXIOMASK);
    eval 'sub FDCTYPE_DMA () {0x1000;}' unless defined(&FDCTYPE_DMA);
    eval 'sub FDCTYPE_DMA8237 () { &FDCTYPE_DMA;}' unless defined(&FDCTYPE_DMA8237);
    eval 'sub FDCTYPE_TRNSFER_MASTK () {0xf000;}' unless defined(&FDCTYPE_TRNSFER_MASTK);
    eval 'sub FDCTYPE_TCBUG () {0x100;}' unless defined(&FDCTYPE_TCBUG);
    eval 'sub FDCTYPE_BUGMASK () {0xf00;}' unless defined(&FDCTYPE_BUGMASK);
    eval 'sub FDCFLG_BUSY () {0x1;}' unless defined(&FDCFLG_BUSY);
    eval 'sub FDCFLG_WANT () {0x2;}' unless defined(&FDCFLG_WANT);
    eval 'sub FDCFLG_WAITING () {0x4;}' unless defined(&FDCFLG_WAITING);
    eval 'sub FDCFLG_TIMEDOUT () {0x8;}' unless defined(&FDCFLG_TIMEDOUT);
    unless(defined(&_ASM)) {
	eval 'sub FDREAD () {1;}' unless defined(&FDREAD);
	eval 'sub FDWRITE () {2;}' unless defined(&FDWRITE);
	eval 'sub FD_CRETRY () {1000000;}' unless defined(&FD_CRETRY);
	eval 'sub FD_RRETRY () {1000000;}' unless defined(&FD_RRETRY);
	eval 'sub FDXC_SLEEP () {0x1;}' unless defined(&FDXC_SLEEP);
	eval 'sub FDXC_CHECKCHG () {0x2;}' unless defined(&FDXC_CHECKCHG);
	eval 'sub FD_SB_DMA_ALIGN () {0x10000;}' unless defined(&FD_SB_DMA_ALIGN);
	eval 'sub FDEP_L0 () {0;}' unless defined(&FDEP_L0);
	eval 'sub FDEP_L1 () {1;}' unless defined(&FDEP_L1);
	eval 'sub FDEP_L2 () {2;}' unless defined(&FDEP_L2);
	eval 'sub FDEP_L3 () {3;}' unless defined(&FDEP_L3);
	eval 'sub FDEP_L4 () {4;}' unless defined(&FDEP_L4);
	eval 'sub FDEP_LMAX () {4;}' unless defined(&FDEP_LMAX);
	eval 'sub FDERRPRINT {
	    my($l, $m, $args) = @_;
    	    eval q({  &if ((($l) >=  &fderrlevel)  && (($m) &  &fderrmask))  &cmn_err $args; });
	}' unless defined(&FDERRPRINT);
	eval 'sub FDEM_IDEN () {0x1;}' unless defined(&FDEM_IDEN);
	eval 'sub FDEM_ATTA () {0x1;}' unless defined(&FDEM_ATTA);
	eval 'sub FDEM_SIZE () {0x2;}' unless defined(&FDEM_SIZE);
	eval 'sub FDEM_OPEN () {0x4;}' unless defined(&FDEM_OPEN);
	eval 'sub FDEM_GETL () {0x8;}' unless defined(&FDEM_GETL);
	eval 'sub FDEM_CLOS () {0x10;}' unless defined(&FDEM_CLOS);
	eval 'sub FDEM_STRA () {0x20;}' unless defined(&FDEM_STRA);
	eval 'sub FDEM_STRT () {0x40;}' unless defined(&FDEM_STRT);
	eval 'sub FDEM_RDWR () {0x80;}' unless defined(&FDEM_RDWR);
	eval 'sub FDEM_CMD () {0x100;}' unless defined(&FDEM_CMD);
	eval 'sub FDEM_EXEC () {0x200;}' unless defined(&FDEM_EXEC);
	eval 'sub FDEM_RECO () {0x400;}' unless defined(&FDEM_RECO);
	eval 'sub FDEM_INTR () {0x800;}' unless defined(&FDEM_INTR);
	eval 'sub FDEM_WATC () {0x1000;}' unless defined(&FDEM_WATC);
	eval 'sub FDEM_IOCT () {0x2000;}' unless defined(&FDEM_IOCT);
	eval 'sub FDEM_RAWI () {0x4000;}' unless defined(&FDEM_RAWI);
	eval 'sub FDEM_DUMP () {0x8000;}' unless defined(&FDEM_DUMP);
	eval 'sub FDEM_GETC () {0x10000;}' unless defined(&FDEM_GETC);
	eval 'sub FDEM_RETC () {0x20000;}' unless defined(&FDEM_RETC);
	eval 'sub FDEM_RESE () {0x40000;}' unless defined(&FDEM_RESE);
	eval 'sub FDEM_RECA () {0x80000;}' unless defined(&FDEM_RECA);
	eval 'sub FDEM_FORM () {0x100000;}' unless defined(&FDEM_FORM);
	eval 'sub FDEM_RW () {0x200000;}' unless defined(&FDEM_RW);
	eval 'sub FDEM_CHEK () {0x400000;}' unless defined(&FDEM_CHEK);
	eval 'sub FDEM_DSEL () {0x800000;}' unless defined(&FDEM_DSEL);
	eval 'sub FDEM_EJEC () {0x1000000;}' unless defined(&FDEM_EJEC);
	eval 'sub FDEM_SCHG () {0x2000000;}' unless defined(&FDEM_SCHG);
	eval 'sub FDEM_PACK () {0x4000000;}' unless defined(&FDEM_PACK);
	eval 'sub FDEM_MODS () {0x8000000;}' unless defined(&FDEM_MODS);
	eval 'sub FDEM_MOFF () {0x10000000;}' unless defined(&FDEM_MOFF);
	eval 'sub FDEM_SDMA () {0x20000000;}' unless defined(&FDEM_SDMA);
	eval 'sub FDEM_PWR () {0x40000000;}' unless defined(&FDEM_PWR);
	eval 'sub FDEM_ALL () {0xffffffff;}' unless defined(&FDEM_ALL);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
