require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FIBRE_CHANNEL_FCA_USOCVAR_H)) {
    eval 'sub _SYS_FIBRE_CHANNEL_FCA_USOCVAR_H () {1;}' unless defined(&_SYS_FIBRE_CHANNEL_FCA_USOCVAR_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/fibre-channel/impl/fc_fcaif.ph';
    eval 'sub USOC_DRV_HARDENING () {1;}' unless defined(&USOC_DRV_HARDENING);
    eval 'sub USOC_PORTA_NAME () {"0";}' unless defined(&USOC_PORTA_NAME);
    eval 'sub USOC_PORTB_NAME () {"1";}' unless defined(&USOC_PORTB_NAME);
    eval 'sub USOC_NT_PORT () { &NULL;}' unless defined(&USOC_NT_PORT);
    eval 'sub USOC_INIT_ITEMS () {5;}' unless defined(&USOC_INIT_ITEMS);
    eval 'sub USOC_WWN_SIZE () {($sizeof{ &la_wwn_t});}' unless defined(&USOC_WWN_SIZE);
    eval 'sub USOC_LOG_ONLY () {1;}' unless defined(&USOC_LOG_ONLY);
    eval 'sub USOC_CONSOLE_ONLY () {2;}' unless defined(&USOC_CONSOLE_ONLY);
    eval 'sub USOC_LOG_AND_CONSOLE () {3;}' unless defined(&USOC_LOG_AND_CONSOLE);
    eval 'sub USOC_TIMELIST_SIZE () {(63);}' unless defined(&USOC_TIMELIST_SIZE);
    eval 'sub USOC_TIMELIST_HASH {
        my($x) = @_;
	    eval q((($x) & ( &USOC_TIMELIST_SIZE)));
    }' unless defined(&USOC_TIMELIST_HASH);
    eval 'sub USOC_MAX_CQ_ENTRIES () {256;}' unless defined(&USOC_MAX_CQ_ENTRIES);
    eval 'sub USOC_CQ_SIZE () {($sizeof{ &cqe_t} *  &USOC_MAX_CQ_ENTRIES);}' unless defined(&USOC_CQ_SIZE);
    eval 'sub USOC_SMALL_CQ_ENTRIES () {8;}' unless defined(&USOC_SMALL_CQ_ENTRIES);
    eval 'sub USOC_N_CQS () {4;}' unless defined(&USOC_N_CQS);
    eval 'sub USOC_HW_N_CQS () {4;}' unless defined(&USOC_HW_N_CQS);
    eval 'sub USOC_CQ_ALIGN () {64;}' unless defined(&USOC_CQ_ALIGN);
    eval 'sub USOC_POOL_SIZE () {2112;}' unless defined(&USOC_POOL_SIZE);
    eval 'sub USOC_SVC_LENGTH () {80;}' unless defined(&USOC_SVC_LENGTH);
    eval 'sub FABRIC_FLAG () {1;}' unless defined(&FABRIC_FLAG);
    eval 'sub NPORT_FLAG () {2;}' unless defined(&NPORT_FLAG);
    eval 'sub FCIO_DIAG_LBTFQ () {( &FIOC|203);}' unless defined(&FCIO_DIAG_LBTFQ);
    eval 'sub USOC_DIAG_LBTFQ () {0xa;}' unless defined(&USOC_DIAG_LBTFQ);
    eval 'sub PORT_LBF_PENDING () {0x100000;}' unless defined(&PORT_LBF_PENDING);
    eval 'sub USOC_QFULL () {82565;}' unless defined(&USOC_QFULL);
    eval 'sub USOC_UNAVAIL () {82566;}' unless defined(&USOC_UNAVAIL);
    eval 'sub USOC_INVALID_ID () {(( &uint32_t)0xffffffff);}' unless defined(&USOC_INVALID_ID);
    eval 'sub USOC_MAX_SPURIOUS_INTR () {0x50;}' unless defined(&USOC_MAX_SPURIOUS_INTR);
    eval 'sub USOC_MAX_REC_RESETS () {10;}' unless defined(&USOC_MAX_REC_RESETS);
    eval 'sub USOC_MIN_REC_RESET_TIME () {300;}' unless defined(&USOC_MIN_REC_RESET_TIME);
    eval 'sub USOC_LFD_INTERVAL () {300;}' unless defined(&USOC_LFD_INTERVAL);
    eval 'sub USOC_LFD_MAX_RETRIES () {6;}' unless defined(&USOC_LFD_MAX_RETRIES);
    eval 'sub USOC_LFD_WAIT_COUNT () {20;}' unless defined(&USOC_LFD_WAIT_COUNT);
    eval 'sub USOC_LFD_WAIT_DELAY () {1000000;}' unless defined(&USOC_LFD_WAIT_DELAY);
    eval 'sub USOC_MIN_THROTTLE () {50;}' unless defined(&USOC_MIN_THROTTLE);
    eval 'sub USOC_MAX_THROTTLE () {800;}' unless defined(&USOC_MAX_THROTTLE);
    eval 'sub USOC_THROTTLE_THRESHOLD () {200;}' unless defined(&USOC_THROTTLE_THRESHOLD);
    eval 'sub USOC_STATUS_DIAG_BUSY () {82565;}' unless defined(&USOC_STATUS_DIAG_BUSY);
    eval 'sub USOC_STATUS_DIAG_INVALID () {82566;}' unless defined(&USOC_STATUS_DIAG_INVALID);
    eval 'sub USOC_PRIV_TO_PORTNUM {
        my($p) = @_;
	    eval q((($p)-> ($s$pp_portp->{s$p_port})));
    }' unless defined(&USOC_PRIV_TO_PORTNUM);
    eval 'sub USOC_PORT_ANY () {(-1);}' unless defined(&USOC_PORT_ANY);
    eval 'sub USOC_CORE_ON_ABORT_TIMEOUT () {0x1;}' unless defined(&USOC_CORE_ON_ABORT_TIMEOUT);
    eval 'sub USOC_CORE_ON_BAD_TOKEN () {0x2;}' unless defined(&USOC_CORE_ON_BAD_TOKEN);
    eval 'sub USOC_CORE_ON_BAD_ABORT () {0x4;}' unless defined(&USOC_CORE_ON_BAD_ABORT);
    eval 'sub USOC_CORE_ON_BAD_UNSOL () {0x8;}' unless defined(&USOC_CORE_ON_BAD_UNSOL);
    eval 'sub USOC_CORE_ON_LOW_THROTTLE () {0x10;}' unless defined(&USOC_CORE_ON_LOW_THROTTLE);
    eval 'sub USOC_CORE_ON_SEND_1 () {0x20;}' unless defined(&USOC_CORE_ON_SEND_1);
    eval 'sub USOC_CORE_ON_SEND_2 () {0x40;}' unless defined(&USOC_CORE_ON_SEND_2);
    eval 'sub USOC_FORCE_CORE () {0x8000;}' unless defined(&USOC_FORCE_CORE);
    eval 'sub USOC_SKC_FULL () {1;}' unless defined(&USOC_SKC_FULL);
    eval 'sub USOC_SKC_SLEEP () {2;}' unless defined(&USOC_SKC_SLEEP);
    eval 'sub USOC_POOL_VALID_DMA () {0x1;}' unless defined(&USOC_POOL_VALID_DMA);
    eval 'sub USOC_POOL_VALID_SETUP () {0x2;}' unless defined(&USOC_POOL_VALID_SETUP);
    eval 'sub PORT_FABRIC_PRESENT () {0x1;}' unless defined(&PORT_FABRIC_PRESENT);
    eval 'sub PORT_OFFLINE () {0x2;}' unless defined(&PORT_OFFLINE);
    eval 'sub NPORT_LOGIN_SUCCESS () {0x4;}' unless defined(&NPORT_LOGIN_SUCCESS);
    eval 'sub PORT_LOGIN_ACTIVE () {0x8;}' unless defined(&PORT_LOGIN_ACTIVE);
    eval 'sub PORT_LOGIN_RECOVERY () {0x10;}' unless defined(&PORT_LOGIN_RECOVERY);
    eval 'sub PORT_ONLINE_LOOP () {0x20;}' unless defined(&PORT_ONLINE_LOOP);
    eval 'sub PORT_ONLINE () {0x40;}' unless defined(&PORT_ONLINE);
    eval 'sub PORT_STATUS_FLAG () {0x80;}' unless defined(&PORT_STATUS_FLAG);
    eval 'sub PORT_STATUS_MASK () {0xff;}' unless defined(&PORT_STATUS_MASK);
    eval 'sub PORT_OPEN () {0x100;}' unless defined(&PORT_OPEN);
    eval 'sub PORT_CHILD_INIT () {0x200;}' unless defined(&PORT_CHILD_INIT);
    eval 'sub PORT_BOUND () {0x400;}' unless defined(&PORT_BOUND);
    eval 'sub PORT_EXCL () {0x800;}' unless defined(&PORT_EXCL);
    eval 'sub PORT_LILP_PENDING () {0x1000;}' unless defined(&PORT_LILP_PENDING);
    eval 'sub PORT_LIP_PENDING () {0x2000;}' unless defined(&PORT_LIP_PENDING);
    eval 'sub PORT_ABORT_PENDING () {0x4000;}' unless defined(&PORT_ABORT_PENDING);
    eval 'sub PORT_ELS_PENDING () {0x8000;}' unless defined(&PORT_ELS_PENDING);
    eval 'sub PORT_BYPASS_PENDING () {0x10000;}' unless defined(&PORT_BYPASS_PENDING);
    eval 'sub PORT_OFFLINE_PENDING () {0x20000;}' unless defined(&PORT_OFFLINE_PENDING);
    eval 'sub PORT_ADISC_PENDING () {0x40000;}' unless defined(&PORT_ADISC_PENDING);
    eval 'sub PORT_RLS_PENDING () {0x80000;}' unless defined(&PORT_RLS_PENDING);
    eval 'sub PORT_FLOGI_PENDING () {0x100000;}' unless defined(&PORT_FLOGI_PENDING);
    eval 'sub PORT_NS_PENDING () {0x200000;}' unless defined(&PORT_NS_PENDING);
    eval 'sub PORT_IN_LINK_RESET () {0x400000;}' unless defined(&PORT_IN_LINK_RESET);
    eval 'sub PORT_OUTBOUND_PENDING () {0x800000;}' unless defined(&PORT_OUTBOUND_PENDING);
    eval 'sub PORT_DIAG_PENDING () {0x1000000;}' unless defined(&PORT_DIAG_PENDING);
    eval 'sub USOC_IS_QFULL {
        my($kcq) = @_;
	    eval q(((((($kcq)-> &skc_in + 1) & ($kcq)-> &skc_last_index) == ($kcq)-> &skc_out)));
    }' unless defined(&USOC_IS_QFULL);
    eval 'sub FC_TYPE_IOCTL () {0x100000;}' unless defined(&FC_TYPE_IOCTL);
    eval 'sub USOC_NOINTR_POLL_DELAY_TIME () {1000;}' unless defined(&USOC_NOINTR_POLL_DELAY_TIME);
    eval 'sub USOC_LILP_TIMEOUT () {30;}' unless defined(&USOC_LILP_TIMEOUT);
    eval 'sub USOC_LIP_TIMEOUT () {30;}' unless defined(&USOC_LIP_TIMEOUT);
    eval 'sub USOC_ABORT_TIMEOUT () {20;}' unless defined(&USOC_ABORT_TIMEOUT);
    eval 'sub USOC_BYPASS_TIMEOUT () {5;}' unless defined(&USOC_BYPASS_TIMEOUT);
    eval 'sub USOC_OFFLINE_TIMEOUT () {90;}' unless defined(&USOC_OFFLINE_TIMEOUT);
    eval 'sub USOC_ADISC_TIMEOUT () {15;}' unless defined(&USOC_ADISC_TIMEOUT);
    eval 'sub USOC_RLS_TIMEOUT () {15;}' unless defined(&USOC_RLS_TIMEOUT);
    eval 'sub USOC_DIAG_TIMEOUT () {15;}' unless defined(&USOC_DIAG_TIMEOUT);
    eval 'sub USOC_PKT_TIMEOUT () {10;}' unless defined(&USOC_PKT_TIMEOUT);
    eval 'sub USOC_LBF_TIMEOUT () {15;}' unless defined(&USOC_LBF_TIMEOUT);
    eval 'sub USOC_MIN_PACKETS () {10;}' unless defined(&USOC_MIN_PACKETS);
    eval 'sub USOC_MAX_PACKETS () {1024;}' unless defined(&USOC_MAX_PACKETS);
    eval 'sub USOC_NUM_TIMEOUT_THREADS () {4;}' unless defined(&USOC_NUM_TIMEOUT_THREADS);
    eval 'sub USOC_WATCH_TIMER () {1000000;}' unless defined(&USOC_WATCH_TIMER);
    eval 'sub USOC_INITIAL_ONLINE () {30;}' unless defined(&USOC_INITIAL_ONLINE);
    eval 'sub USOC_MAX_IDS () {2048;}' unless defined(&USOC_MAX_IDS);
    eval 'sub USOC_ID_SHIFT () {11;}' unless defined(&USOC_ID_SHIFT);
    eval 'sub PACKET_DORMANT () {0x1;}' unless defined(&PACKET_DORMANT);
    eval 'sub PACKET_IN_TRANSPORT () {0x2;}' unless defined(&PACKET_IN_TRANSPORT);
    eval 'sub PACKET_IN_ABORT () {0x4;}' unless defined(&PACKET_IN_ABORT);
    eval 'sub PACKET_INTERNAL_ABORT () {0x8;}' unless defined(&PACKET_INTERNAL_ABORT);
    eval 'sub PACKET_CALLBACK_DONE () {0x10000;}' unless defined(&PACKET_CALLBACK_DONE);
    eval 'sub PACKET_IN_TIMEOUT () {0x100000;}' unless defined(&PACKET_IN_TIMEOUT);
    eval 'sub PACKET_IN_INTR () {0x200000;}' unless defined(&PACKET_IN_INTR);
    eval 'sub PACKET_NO_CALLBACK () {0x400000;}' unless defined(&PACKET_NO_CALLBACK);
    eval 'sub PACKET_IN_OVERFLOW_Q () {0x800000;}' unless defined(&PACKET_IN_OVERFLOW_Q);
    eval 'sub PACKET_IN_USOC () {0x1000000;}' unless defined(&PACKET_IN_USOC);
    eval 'sub PACKET_RETURNED () {0x2000000;}' unless defined(&PACKET_RETURNED);
    eval 'sub PACKET_INTERNAL_PACKET () {0x4000000;}' unless defined(&PACKET_INTERNAL_PACKET);
    eval 'sub PACKET_VALID () {0x8000000;}' unless defined(&PACKET_VALID);
    eval 'sub PACKET_IN_PROCESS () {( &PACKET_IN_TRANSPORT |  &PACKET_IN_ABORT);}' unless defined(&PACKET_IN_PROCESS);
    if(defined(&DEBUG)) {
    }
    eval 'sub UB_VALID () {0x80000000;}' unless defined(&UB_VALID);
    eval 'sub UB_IN_FCA () {0x1;}' unless defined(&UB_IN_FCA);
    eval 'sub UB_TEMPORARY () {0x2;}' unless defined(&UB_TEMPORARY);
    eval 'sub USOC_PKT_COMP {
        my($pkt, $priv) = @_;
	    eval q(((($pkt)-> &pkt_comp !=  &NULL)  && ((($priv)-> &spp_flags &  &PACKET_NO_CALLBACK) == 0)));
    }' unless defined(&USOC_PKT_COMP);
    eval 'sub USOC_DDH_NOERR () {0;}' unless defined(&USOC_DDH_NOERR);
    eval 'sub USOC_DDH_RP_INTR_ACCHDL_FAULT () {1;}' unless defined(&USOC_DDH_RP_INTR_ACCHDL_FAULT);
    eval 'sub USOC_DDH_XRP_INITCQ_ACCHDL_FAULT () {2;}' unless defined(&USOC_DDH_XRP_INITCQ_ACCHDL_FAULT);
    eval 'sub USOC_DDH_SPURIOUS_SOL () {3;}' unless defined(&USOC_DDH_SPURIOUS_SOL);
    eval 'sub USOC_DDH_SPURIOUS_UNSOL () {4;}' unless defined(&USOC_DDH_SPURIOUS_UNSOL);
    eval 'sub USOC_DDH_FAIL_ALLOCID () {5;}' unless defined(&USOC_DDH_FAIL_ALLOCID);
    eval 'sub USOC_DDH_FAIL_FREEID () {6;}' unless defined(&USOC_DDH_FAIL_FREEID);
    eval 'sub USOC_DDH_FAIL_LATENT_FAULT () {7;}' unless defined(&USOC_DDH_FAIL_LATENT_FAULT);
    eval 'sub USOC_DDH_FAIL_LATENT_DETACH () {8;}' unless defined(&USOC_DDH_FAIL_LATENT_DETACH);
    eval 'sub USOC_DDH_FAIL_LATENT_SUSPEND () {9;}' unless defined(&USOC_DDH_FAIL_LATENT_SUSPEND);
    eval 'sub USOC_DDH_ENABLE_ACCHDL_FAULT () {10;}' unless defined(&USOC_DDH_ENABLE_ACCHDL_FAULT);
    eval 'sub USOC_DDH_ENQUE1_ACCHDL_FAULT () {11;}' unless defined(&USOC_DDH_ENQUE1_ACCHDL_FAULT);
    eval 'sub USOC_DDH_ENQUE2_ACCHDL_FAULT () {12;}' unless defined(&USOC_DDH_ENQUE2_ACCHDL_FAULT);
    eval 'sub USOC_DDH_SOLINTR_ACCHDL_FAULT () {13;}' unless defined(&USOC_DDH_SOLINTR_ACCHDL_FAULT);
    eval 'sub USOC_DDH_UNSOLINTR_ACCHDL_FAULT () {14;}' unless defined(&USOC_DDH_UNSOLINTR_ACCHDL_FAULT);
    eval 'sub USOC_DDH_PKT_DATA_DMAHDL_FAULT () {15;}' unless defined(&USOC_DDH_PKT_DATA_DMAHDL_FAULT);
    if(defined(&USOC_DRV_HARDENING)) {
	eval 'sub USOC_RD8 {
	    my($acchandle, $addr) = @_;
    	    eval q( &ddi_get8(($acchandle), ( &uint8_t *)($addr)));
	}' unless defined(&USOC_RD8);
	eval 'sub USOC_RD16 {
	    my($acchandle, $addr) = @_;
    	    eval q( &ddi_get16(($acchandle), ( &uint16_t *)($addr)));
	}' unless defined(&USOC_RD16);
	eval 'sub USOC_RD32 {
	    my($acchandle, $addr) = @_;
    	    eval q( &ddi_get32(($acchandle), ( &uint32_t *)($addr)));
	}' unless defined(&USOC_RD32);
	eval 'sub USOC_RD64 {
	    my($acchandle, $addr) = @_;
    	    eval q( &ddi_get64(($acchandle), ( &uint64_t *)($addr)));
	}' unless defined(&USOC_RD64);
	eval 'sub USOC_WR8 {
	    my($acchandle, $addr, $val) = @_;
    	    eval q( &ddi_put8(($acchandle), ( &uint8_t *)($addr), ( &uint8_t)($val)));
	}' unless defined(&USOC_WR8);
	eval 'sub USOC_WR16 {
	    my($acchandle, $addr, $val) = @_;
    	    eval q( &ddi_put16(($acchandle), ( &uint16_t *)($addr), ( &uint16_t)($val)));
	}' unless defined(&USOC_WR16);
	eval 'sub USOC_WR32 {
	    my($acchandle, $addr, $val) = @_;
    	    eval q( &ddi_put32(($acchandle), ( &uint32_t *)($addr), ( &uint32_t)($val)));
	}' unless defined(&USOC_WR32);
	eval 'sub USOC_WR64 {
	    my($acchandle, $addr, $val) = @_;
    	    eval q( &ddi_put64(($acchandle), ( &uint64_t *)($addr), ( &uint64_t)($val)));
	}' unless defined(&USOC_WR64);
	eval 'sub USOC_REP_RD {
	    my($acchandle, $hostaddr, $devaddr, $cnt) = @_;
    	    eval q( &ddi_rep_get8(($acchandle), ( &uint8_t *)($hostaddr), ( &uint8_t *), ($cnt),  &DDI_DEV_AUTOINCR));
	}' unless defined(&USOC_REP_RD);
	eval 'sub USOC_REP_RD32 {
	    my($acchandle, $hostaddr, $devaddr, $cnt) = @_;
    	    eval q( &ddi_rep_get32(($acchandle), ( &uint32_t *)($hostaddr), ( &uint32_t *), (($cnt)) >> 2,  &DDI_DEV_AUTOINCR));
	}' unless defined(&USOC_REP_RD32);
	eval 'sub USOC_REP_WR32 {
	    my($acchandle, $hostaddr, $devaddr, $cnt) = @_;
    	    eval q( &ddi_rep_put32(($acchandle), ( &uint32_t *)($hostaddr), ( &uint32_t *), (($cnt)) >> 2,  &DDI_DEV_AUTOINCR));
	}' unless defined(&USOC_REP_WR32);
	eval 'sub USOC_SYNC_FOR_DEV {
	    my($acchandle, $offset, $length) = @_;
    	    eval q(( &void)  &ddi_dma_sync(($acchandle), ($offset), ($length),  &DDI_DMA_SYNC_FORDEV));
	}' unless defined(&USOC_SYNC_FOR_DEV);
	eval 'sub USOC_SYNC_FOR_KERNEL {
	    my($acchandle, $offset, $length) = @_;
    	    eval q(( &void)  &ddi_dma_sync(($acchandle), ($offset), ($length),  &DDI_DMA_SYNC_FORKERNEL));
	}' unless defined(&USOC_SYNC_FOR_KERNEL);
	eval 'sub USOC_GET_DEVSTATE {
	    my($usocp) = @_;
    	    eval q(( &ddi_get_devstate(($usocp)-> &usoc_dip)));
	}' unless defined(&USOC_GET_DEVSTATE);
	eval 'sub USOC_DEVSTATE_BAD {
	    my($state) = @_;
    	    eval q((($state) == ( &DDI_DEVSTATE_DOWN) || ($state) == ( &DDI_DEVSTATE_OFFLINE)));
	}' unless defined(&USOC_DEVSTATE_BAD);
	eval 'sub USOC_DEVICE_BAD {
	    my($usocp, $state) = @_;
    	    eval q((($state =  &USOC_GET_DEVSTATE($usocp)),  &USOC_DEVSTATE_BAD($state)));
	}' unless defined(&USOC_DEVICE_BAD);
	eval 'sub USOC_DEVICE_STATE {
	    my($devstate) = @_;
    	    eval q(((($devstate) ==  &DDI_DEVSTATE_OFFLINE) ? \\"OFFLINE\\" : ((($devstate) ==  &DDI_DEVSTATE_DOWN) ? \\"DOWN\\" : \\"UNKNOWN\\")));
	}' unless defined(&USOC_DEVICE_STATE);
	eval 'sub USOC_ACC_HANDLE_BAD {
	    my($acc_handle) = @_;
    	    eval q(( &ddi_check_acc_handle(($acc_handle)) !=  &DDI_SUCCESS));
	}' unless defined(&USOC_ACC_HANDLE_BAD);
	eval 'sub USOC_DMA_HANDLE_BAD {
	    my($dma_handle) = @_;
    	    eval q(( &ddi_check_dma_handle(($dma_handle)) !=  &DDI_SUCCESS));
	}' unless defined(&USOC_DMA_HANDLE_BAD);
	if(defined(&DEBUG)) {
	    eval 'sub USOC_DDH_DMA_HANDLE_BAD {
	        my($dma_handle, $val) = @_;
    		eval q((( &usoc_dbg_drv_hdn == $val) || ( &USOC_DMA_HANDLE_BAD($dma_handle))));
	    }' unless defined(&USOC_DDH_DMA_HANDLE_BAD);
	} else {
	    eval 'sub USOC_DDH_DMA_HANDLE_BAD {
	        my($dma_handle, $val) = @_;
    		eval q(( &USOC_DMA_HANDLE_BAD($dma_handle)));
	    }' unless defined(&USOC_DDH_DMA_HANDLE_BAD);
	}
	eval 'sub USOC_REPORT_FAULT {
	    my($usocp) = @_;
    	    eval q( &usoc_report_fault(($usocp)));
	}' unless defined(&USOC_REPORT_FAULT);
	eval 'sub USOC_DDI_REPORT_FAULT {
	    my($a, $b, $c, $d) = @_;
    	    eval q(( &void)  &ddi_dev_report_fault(($a), ($b), ($c), ($d)));
	}' unless defined(&USOC_DDI_REPORT_FAULT);
	eval 'sub USOC_ACCHDL_FAULT {
	    my($usocp, $acchdl) = @_;
    	    eval q(( &USOC_ACC_HANDLE_BAD(($acchdl))  &&  &USOC_REPORT_FAULT($usocp)));
	}' unless defined(&USOC_ACCHDL_FAULT);
	eval 'sub USOC_DMAHDL_FAULT {
	    my($usocp, $acchdl) = @_;
    	    eval q(( &USOC_DMA_HANDLE_BAD(($acchdl))  &&  &USOC_REPORT_FAULT($usocp)));
	}' unless defined(&USOC_DMAHDL_FAULT);
	if(defined(&DEBUG)) {
	    eval 'sub USOC_DDH_ACCHDL_FAULT {
	        my($usocp, $acchdl, $val) = @_;
    		eval q(((( &usoc_dbg_drv_hdn == $val) ||  &USOC_ACC_HANDLE_BAD($acchdl))  &&  &usoc_report_fault(($usocp))));
	    }' unless defined(&USOC_DDH_ACCHDL_FAULT);
	} else {
	    eval 'sub USOC_DDH_ACCHDL_FAULT {
	        my($usocp, $acchdl, $val) = @_;
    		eval q( &USOC_ACCHDL_FAULT($usocp, $acchdl));
	    }' unless defined(&USOC_DDH_ACCHDL_FAULT);
	}
    } else {
	eval 'sub USOC_RD8 {
	    my($acchandle, $addr) = @_;
    	    eval q((*( &uint8_t *)($addr)));
	}' unless defined(&USOC_RD8);
	eval 'sub USOC_RD16 {
	    my($acchandle, $addr) = @_;
    	    eval q((*( &uint16_t *)($addr)));
	}' unless defined(&USOC_RD16);
	eval 'sub USOC_RD32 {
	    my($acchandle, $addr) = @_;
    	    eval q((*( &uint32_t *)($addr)));
	}' unless defined(&USOC_RD32);
	eval 'sub USOC_RD64 {
	    my($acchandle, $addr) = @_;
    	    eval q((*( &uint64_t *)($addr)));
	}' unless defined(&USOC_RD64);
	eval 'sub USOC_WR8 {
	    my($acchandle, $addr, $val) = @_;
    	    eval q((*( &uint8_t *)($addr) = ( &uint8_t)($val)));
	}' unless defined(&USOC_WR8);
	eval 'sub USOC_WR16 {
	    my($acchandle, $addr, $val) = @_;
    	    eval q((*( &uint16_t *)($addr) = ( &uint16_t)($val)));
	}' unless defined(&USOC_WR16);
	eval 'sub USOC_WR32 {
	    my($acchandle, $addr, $val) = @_;
    	    eval q((*( &uint32_t *)($addr) = ( &uint32_t)($val)));
	}' unless defined(&USOC_WR32);
	eval 'sub USOC_WR64 {
	    my($acchandle, $addr, $val) = @_;
    	    eval q((*( &uint64_t *)($addr) = ( &uint64_t)($val)));
	}' unless defined(&USOC_WR64);
	eval 'sub USOC_REP_RD {
	    my($acchandle, $hostaddr, $devaddr, $cnt) = @_;
    	    eval q( &bcopy($devaddr, $hostaddr, $cnt));
	}' unless defined(&USOC_REP_RD);
	eval 'sub USOC_REP_RD32 {
	    my($acchandle, $hostaddr, $devaddr, $cnt) = @_;
    	    eval q( &usoc_wcopy(( &uint_t *)($devaddr), ( &uint_t *)($hostaddr), ($cnt)));
	}' unless defined(&USOC_REP_RD32);
	eval 'sub USOC_REP_WR32 {
	    my($acchandle, $hostaddr, $devaddr, $cnt) = @_;
    	    eval q( &usoc_wcopy(( &uint_t *)($hostaddr), ( &uint_t *)($devaddr), ($cnt)));
	}' unless defined(&USOC_REP_WR32);
	eval 'sub USOC_SYNC_FOR_DEV {
	    my($acchandle, $offset, $length) = @_;
    	    eval q(( &void)  &ddi_dma_sync(($acchandle), ($offset), ($length),  &DDI_DMA_SYNC_FORDEV));
	}' unless defined(&USOC_SYNC_FOR_DEV);
	eval 'sub USOC_SYNC_FOR_KERNEL {
	    my($acchandle, $offset, $length) = @_;
    	    eval q(( &void)  &ddi_dma_sync(($acchandle), ($offset), ($length),  &DDI_DMA_SYNC_FORKERNEL));
	}' unless defined(&USOC_SYNC_FOR_KERNEL);
	eval 'sub USOC_GET_DEVSTATE {
	    my($usocp) = @_;
    	    eval q(( &DDI_DEVSTATE_UP));
	}' unless defined(&USOC_GET_DEVSTATE);
	eval 'sub USOC_DEVICE_BAD {
	    my($usocp, $devstate) = @_;
    	    eval q((0));
	}' unless defined(&USOC_DEVICE_BAD);
	eval 'sub USOC_DEVICE_STATE {
	    my($devstate) = @_;
    	    eval q(((($devstate) ==  &DDI_DEVSTATE_OFFLINE) ? \\"OFFLINE\\" : \\"DOWN\\"));
	}' unless defined(&USOC_DEVICE_STATE);
	eval 'sub USOC_ACC_HANDLE_BAD {
	    my($acc_handle) = @_;
    	    eval q((0));
	}' unless defined(&USOC_ACC_HANDLE_BAD);
	eval 'sub USOC_DMA_HANDLE_BAD {
	    my($dma_handle) = @_;
    	    eval q((0));
	}' unless defined(&USOC_DMA_HANDLE_BAD);
	eval 'sub USOC_DDH_DMA_HANDLE_BAD {
	    my($dma_handle, $val) = @_;
    	    eval q((0));
	}' unless defined(&USOC_DDH_DMA_HANDLE_BAD);
	eval 'sub USOC_REPORT_FAULT {
	    my($usocp) = @_;
    	    eval q((1));
	}' unless defined(&USOC_REPORT_FAULT);
	eval 'sub USOC_DDI_REPORT_FAULT {
	    my($a, $b, $c, $d) = @_;
    	    eval q();
	}' unless defined(&USOC_DDI_REPORT_FAULT);
	eval 'sub USOC_ACCHDL_FAULT {
	    my($usocp, $acchdl) = @_;
    	    eval q((0));
	}' unless defined(&USOC_ACCHDL_FAULT);
	eval 'sub USOC_DMAHDL_FAULT {
	    my($usocp, $acchdl) = @_;
    	    eval q((0));
	}' unless defined(&USOC_DMAHDL_FAULT);
	eval 'sub USOC_DDH_ACCHDL_FAULT {
	    my($usocp, $acchdl, $val) = @_;
    	    eval q((0));
	}' unless defined(&USOC_DDH_ACCHDL_FAULT);
    }
    if(defined(&MICROCODE_TESTING)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
