require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FIBRE_CHANNEL_FCIO_H)) {
    eval 'sub _SYS_FIBRE_CHANNEL_FCIO_H () {1;}' unless defined(&_SYS_FIBRE_CHANNEL_FCIO_H);
    require 'sys/note.ph';
    require 'sys/fibre-channel/fc_types.ph';
    require 'sys/fibre-channel/fc_appif.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub FCTIO () {(ord(\'F\')<< 8);}' unless defined(&FCTIO);
    eval 'sub FCIO_CMD () {( &FCTIO | 1998);}' unless defined(&FCIO_CMD);
    eval 'sub FCIO_SUB_CMD () {(ord(\'Z\') << 8);}' unless defined(&FCIO_SUB_CMD);
    eval 'sub FCIO_GET_NUM_DEVS () {( &FCIO_SUB_CMD + 0x1);}' unless defined(&FCIO_GET_NUM_DEVS);
    eval 'sub FCIO_GET_DEV_LIST () {( &FCIO_SUB_CMD + 0x2);}' unless defined(&FCIO_GET_DEV_LIST);
    eval 'sub FCIO_GET_SYM_PNAME () {( &FCIO_SUB_CMD + 0x3);}' unless defined(&FCIO_GET_SYM_PNAME);
    eval 'sub FCIO_GET_SYM_NNAME () {( &FCIO_SUB_CMD + 0x4);}' unless defined(&FCIO_GET_SYM_NNAME);
    eval 'sub FCIO_SET_SYM_PNAME () {( &FCIO_SUB_CMD + 0x5);}' unless defined(&FCIO_SET_SYM_PNAME);
    eval 'sub FCIO_SET_SYM_NNAME () {( &FCIO_SUB_CMD + 0x6);}' unless defined(&FCIO_SET_SYM_NNAME);
    eval 'sub FCIO_GET_LOGI_PARAMS () {( &FCIO_SUB_CMD + 0x7);}' unless defined(&FCIO_GET_LOGI_PARAMS);
    eval 'sub FCIO_DEV_LOGIN () {( &FCIO_SUB_CMD + 0x8);}' unless defined(&FCIO_DEV_LOGIN);
    eval 'sub FCIO_DEV_LOGOUT () {( &FCIO_SUB_CMD + 0x9);}' unless defined(&FCIO_DEV_LOGOUT);
    eval 'sub FCIO_GET_STATE () {( &FCIO_SUB_CMD + 0xa);}' unless defined(&FCIO_GET_STATE);
    eval 'sub FCIO_DEV_REMOVE () {( &FCIO_SUB_CMD + 0xb);}' unless defined(&FCIO_DEV_REMOVE);
    eval 'sub FCIO_GET_FCODE_REV () {( &FCIO_SUB_CMD + 0xc);}' unless defined(&FCIO_GET_FCODE_REV);
    eval 'sub FCIO_GET_FW_REV () {( &FCIO_SUB_CMD + 0xd);}' unless defined(&FCIO_GET_FW_REV);
    eval 'sub FCIO_GET_DUMP_SIZE () {( &FCIO_SUB_CMD + 0xe);}' unless defined(&FCIO_GET_DUMP_SIZE);
    eval 'sub FCIO_FORCE_DUMP () {( &FCIO_SUB_CMD + 0xf);}' unless defined(&FCIO_FORCE_DUMP);
    eval 'sub FCIO_GET_DUMP () {( &FCIO_SUB_CMD + 0x10);}' unless defined(&FCIO_GET_DUMP);
    eval 'sub FCIO_GET_TOPOLOGY () {( &FCIO_SUB_CMD + 0x11);}' unless defined(&FCIO_GET_TOPOLOGY);
    eval 'sub FCIO_RESET_LINK () {( &FCIO_SUB_CMD + 0x12);}' unless defined(&FCIO_RESET_LINK);
    eval 'sub FCIO_RESET_HARD () {( &FCIO_SUB_CMD + 0x13);}' unless defined(&FCIO_RESET_HARD);
    eval 'sub FCIO_RESET_HARD_CORE () {( &FCIO_SUB_CMD + 0x14);}' unless defined(&FCIO_RESET_HARD_CORE);
    eval 'sub FCIO_DIAG () {( &FCIO_SUB_CMD + 0x15);}' unless defined(&FCIO_DIAG);
    eval 'sub FCIO_NS () {( &FCIO_SUB_CMD + 0x16);}' unless defined(&FCIO_NS);
    eval 'sub FCIO_DOWNLOAD_FW () {( &FCIO_SUB_CMD + 0x17);}' unless defined(&FCIO_DOWNLOAD_FW);
    eval 'sub FCIO_GET_HOST_PARAMS () {( &FCIO_SUB_CMD + 0x18);}' unless defined(&FCIO_GET_HOST_PARAMS);
    eval 'sub FCIO_LINK_STATUS () {( &FCIO_SUB_CMD + 0x19);}' unless defined(&FCIO_LINK_STATUS);
    eval 'sub FCIO_DOWNLOAD_FCODE () {( &FCIO_SUB_CMD + 0x1a);}' unless defined(&FCIO_DOWNLOAD_FCODE);
    eval 'sub FCIO_DIAG_PORT_DISABLE () {( &FCIO_SUB_CMD + 0x80);}' unless defined(&FCIO_DIAG_PORT_DISABLE);
    eval 'sub FCIO_DIAG_PORT_ENABLE () {( &FCIO_SUB_CMD + 0x81);}' unless defined(&FCIO_DIAG_PORT_ENABLE);
    eval 'sub FCIO_CFLAGS_RLS_DEST_NPORT () {0x;}' unless defined(&FCIO_CFLAGS_RLS_DEST_NPORT);
    eval 'sub FCIO_CFLAGS_RLS_DEST_FPORT () {0x1;}' unless defined(&FCIO_CFLAGS_RLS_DEST_FPORT);
    eval 'sub FCIO_XFER_NONE () {0x;}' unless defined(&FCIO_XFER_NONE);
    eval 'sub FCIO_XFER_READ () {0x1;}' unless defined(&FCIO_XFER_READ);
    eval 'sub FCIO_XFER_WRITE () {0x2;}' unless defined(&FCIO_XFER_WRITE);
    eval 'sub FCIO_XFER_RW () {( &FCIO_XFER_READ |  &FCIO_XFER_WRITE);}' unless defined(&FCIO_XFER_RW);
    if(defined( &_SYSCALL32)) {
	if(!defined( &lint)) {
	}
    }
    if(!defined( &lint)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
