require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FIBRE_CHANNEL_ULP_FCIP_H)) {
    eval 'sub _SYS_FIBRE_CHANNEL_ULP_FCIP_H () {1;}' unless defined(&_SYS_FIBRE_CHANNEL_ULP_FCIP_H);
    require 'sys/kstat.ph';
    require 'sys/socket.ph';
    require 'netinet/arp.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub FCIPIDNUM () {(77);}' unless defined(&FCIPIDNUM);
    eval 'sub FCIPNAME () {"fcip";}' unless defined(&FCIPNAME);
    eval 'sub FCIPMINPSZ () {(0);}' unless defined(&FCIPMINPSZ);
    eval 'sub FCIPMAXPSZ () {1514;}' unless defined(&FCIPMAXPSZ);
    eval 'sub FCIPHIWAT () {(32* 1024);}' unless defined(&FCIPHIWAT);
    eval 'sub FCIPLOWAT () {(1);}' unless defined(&FCIPLOWAT);
    eval 'sub FCIPMTU () { &ETHERMTU;}' unless defined(&FCIPMTU);
    eval 'sub FCIPMIN () {( &ETHERMIN + $sizeof{ &llc_snap_hdr_t} + $sizeof{ &fcph_network_hdr_t});}' unless defined(&FCIPMIN);
    eval 'sub NMCHASH () {64;}' unless defined(&NMCHASH);
    eval 'sub INIT_BUCKET_SIZE () {16;}' unless defined(&INIT_BUCKET_SIZE);
    eval 'sub FCIP_MAX_MTU_SIZE () {65280;}' unless defined(&FCIP_MAX_MTU_SIZE);
    eval 'sub FCIP_SLFAST () {0x1;}' unless defined(&FCIP_SLFAST);
    eval 'sub FCIP_SLRAW () {0x2;}' unless defined(&FCIP_SLRAW);
    eval 'sub FCIP_SLALLPHYS () {0x4;}' unless defined(&FCIP_SLALLPHYS);
    eval 'sub FCIP_SLALLMULTI () {0x8;}' unless defined(&FCIP_SLALLMULTI);
    eval 'sub FCIP_SLALLSAP () {0x10;}' unless defined(&FCIP_SLALLSAP);
    eval 'sub FCIPMAXMC () {64;}' unless defined(&FCIPMAXMC);
    eval 'sub FCIPMCALLOC () {( &FCIPMAXMC * $sizeof{ &la_wwn_t});}' unless defined(&FCIPMCALLOC);
    eval 'sub FCIPADDRL () {($sizeof{ &ushort_t} + $sizeof{\'struct ether_addr\'});}' unless defined(&FCIPADDRL);
    eval 'sub FCIP_SUCCESS () {(0);}' unless defined(&FCIP_SUCCESS);
    eval 'sub FCIP_FAILURE () {(1);}' unless defined(&FCIP_FAILURE);
    eval 'sub FCIP_FARP_TIMEOUT () {10;}' unless defined(&FCIP_FARP_TIMEOUT);
    eval 'sub FCIP_WAIT_CMDS () {5;}' unless defined(&FCIP_WAIT_CMDS);
    eval 'sub FCIP_NUM_INSTANCES () {5;}' unless defined(&FCIP_NUM_INSTANCES);
    eval 'sub FCIP_UB_NBUFS () {60;}' unless defined(&FCIP_UB_NBUFS);
    eval 'sub FCIP_UB_SIZE () {2048;}' unless defined(&FCIP_UB_SIZE);
    eval 'sub FCIP_UB_DECREMENT () {4;}' unless defined(&FCIP_UB_DECREMENT);
    eval 'sub FCIP_UB_MINBUFS () {8;}' unless defined(&FCIP_UB_MINBUFS);
    eval 'sub FCIP_INIT_DELAY () {10000000;}' unless defined(&FCIP_INIT_DELAY);
    eval 'sub FCIP_PKT_TTL () {120;}' unless defined(&FCIP_PKT_TTL);
    eval 'sub FCIP_TIMEOUT_INTERVAL () {10;}' unless defined(&FCIP_TIMEOUT_INTERVAL);
    eval 'sub FCIP_OFFLINE_TIMEOUT () {60;}' unless defined(&FCIP_OFFLINE_TIMEOUT);
    eval 'sub FCIP_MAX_PORTS () {127;}' unless defined(&FCIP_MAX_PORTS);
    eval 'sub FCIP_RTE_TIMEOUT () {60;}' unless defined(&FCIP_RTE_TIMEOUT);
    eval 'sub FCIP_PORT_DEVICE_IGNORE () {(-3);}' unless defined(&FCIP_PORT_DEVICE_IGNORE);
    eval 'sub ETHERSTRL () {((2*  &ETHERADDRL) + 1);}' unless defined(&ETHERSTRL);
    eval 'sub FCIP_RT_HASH_ELEMS () {32;}' unless defined(&FCIP_RT_HASH_ELEMS);
    eval 'sub FCIP_DEST_HASH_ELEMS () {16;}' unless defined(&FCIP_DEST_HASH_ELEMS);
    if(defined( &_BIT_FIELDS_LTOH)) {
	eval 'sub FCIP_RT_HASH {
	    my($x) = @_;
    	    eval q((($x->[0] + $x->[1] + $x->[2] + $x->[3] + $x->[4] + $x->[5]) & ( &FCIP_RT_HASH_ELEMS - 1)));
	}' unless defined(&FCIP_RT_HASH);
	eval 'sub FCIP_DEST_HASH {
	    my($x) = @_;
    	    eval q((($x->[0] + $x->[1] + $x->[2] + $x->[3] + $x->[4] + $x->[5]) & ( &FCIP_DEST_HASH_ELEMS - 1)));
	}' unless defined(&FCIP_DEST_HASH);
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
	eval 'sub FCIP_RT_HASH {
	    my($x) = @_;
    	    eval q((($x->[2] + $x->[3] + $x->[4] + $x->[5] + $x->[6] + $x->[7]) & ( &FCIP_RT_HASH_ELEMS - 1)));
	}' unless defined(&FCIP_RT_HASH);
	eval 'sub FCIP_DEST_HASH {
	    my($x) = @_;
    	    eval q((($x->[2] + $x->[3] + $x->[4] + $x->[5] + $x->[6] + $x->[7]) & ( &FCIP_DEST_HASH_ELEMS - 1)));
	}' unless defined(&FCIP_DEST_HASH);
    }
    eval 'sub FCIP_HDR_SIZE () {8;}' unless defined(&FCIP_HDR_SIZE);
    eval 'sub FCIP_RT_INVALID () {(-1);}' unless defined(&FCIP_RT_INVALID);
    eval 'sub FCIP_RT_RETIRED () {(-2);}' unless defined(&FCIP_RT_RETIRED);
    eval 'sub FCIP_RT_SUSPENDED () {(-3);}' unless defined(&FCIP_RT_SUSPENDED);
    eval 'sub FCIP_RTE_UNAVAIL {
        my($state) = @_;
	    eval q(((($state) ==  &FCIP_RT_INVALID) || (($state) ==  &FCIP_RT_RETIRED) || (($state) ==  &FCIP_RT_SUSPENDED)) ? 1: 0);
    }' unless defined(&FCIP_RTE_UNAVAIL);
    eval 'sub FCIP_NUM_THREADS () {4;}' unless defined(&FCIP_NUM_THREADS);
    eval 'sub FCIP_MIN_TASKS () {12;}' unless defined(&FCIP_MIN_TASKS);
    eval 'sub FCIP_MAX_TASKS () {128;}' unless defined(&FCIP_MAX_TASKS);
    if(defined(&INARP_SUPPORT)) {
    }
    eval 'sub FCIP_FACTADDR_PRESENT () {0x1;}' unless defined(&FCIP_FACTADDR_PRESENT);
    eval 'sub FCIP_FACTADDR_USE () {0x2;}' unless defined(&FCIP_FACTADDR_USE);
    eval 'sub FCIP_RUNNING () {0x1;}' unless defined(&FCIP_RUNNING);
    eval 'sub FCIP_INITED () {0x2;}' unless defined(&FCIP_INITED);
    eval 'sub FCIP_PROMISC () {0x4;}' unless defined(&FCIP_PROMISC);
    eval 'sub FCIP_SUSPENDED () {0x8;}' unless defined(&FCIP_SUSPENDED);
    eval 'sub FCIP_NOTIMEOUTS () {0x10;}' unless defined(&FCIP_NOTIMEOUTS);
    eval 'sub FCIP_DETACHING () {0x20;}' unless defined(&FCIP_DETACHING);
    eval 'sub FCIP_DETACHED () {0x40;}' unless defined(&FCIP_DETACHED);
    eval 'sub FCIP_ATTACHING () {0x80;}' unless defined(&FCIP_ATTACHING);
    eval 'sub FCIP_LINK_DOWN () {0x100;}' unless defined(&FCIP_LINK_DOWN);
    eval 'sub FCIP_IN_CALLBACK () {0x200;}' unless defined(&FCIP_IN_CALLBACK);
    eval 'sub FCIP_IN_TIMEOUT () {0x400;}' unless defined(&FCIP_IN_TIMEOUT);
    eval 'sub FCIP_POWER_DOWN () {0x800;}' unless defined(&FCIP_POWER_DOWN);
    eval 'sub FCIP_COMPARE_NWWN () {0x1;}' unless defined(&FCIP_COMPARE_NWWN);
    eval 'sub FCIP_COMPARE_PWWN () {0x10;}' unless defined(&FCIP_COMPARE_PWWN);
    eval 'sub FCIP_COMPARE_BROADCAST () {0x100;}' unless defined(&FCIP_COMPARE_BROADCAST);
    eval 'sub IS_BROADCAST_ADDR {
        my($wwn) = @_;
	    eval q(((($wwn)-> ($w->{wwn_hi}) == 0xffff)  && (($wwn)-> ($w->{wwn_lo}) == 0xffffffff)));
    }' unless defined(&IS_BROADCAST_ADDR);
    eval 'sub FCIP_CMD_DMA_MEM () {0x1;}' unless defined(&FCIP_CMD_DMA_MEM);
    eval 'sub FCIP_CMD_DMA_BOUND () {0x2;}' unless defined(&FCIP_CMD_DMA_BOUND);
    eval 'sub FCIP_RESP_DMA_MEM () {0x4;}' unless defined(&FCIP_RESP_DMA_MEM);
    eval 'sub FCIP_RESP_DMA_BOUND () {0x8;}' unless defined(&FCIP_RESP_DMA_BOUND);
    eval 'sub FCIP_PKT_INTERNAL () {0x1;}' unless defined(&FCIP_PKT_INTERNAL);
    eval 'sub FCIP_PKT_IN_TIMEOUT () {0x2;}' unless defined(&FCIP_PKT_IN_TIMEOUT);
    eval 'sub FCIP_PKT_RETURNED () {0x4;}' unless defined(&FCIP_PKT_RETURNED);
    eval 'sub FCIP_PKT_IN_LIST () {0x8;}' unless defined(&FCIP_PKT_IN_LIST);
    eval 'sub FCIP_PKT_IN_ABORT () {0x10;}' unless defined(&FCIP_PKT_IN_ABORT);
    eval 'sub FCIP_PKT_TO_FC_PKT {
        my($fcip_pkt) = @_;
	    eval q(($fcip_pkt)-> &fcip_pkt_fcpkt);
    }' unless defined(&FCIP_PKT_TO_FC_PKT);
    eval 'sub fcipd_nwwn () { ($fcipd_rtable->{fcipr_nwwn});}' unless defined(&fcipd_nwwn);
    eval 'sub fcipd_pwwn () { ($fcipd_rtable->{fcipr_pwwn});}' unless defined(&fcipd_pwwn);
    eval 'sub fcipd_did () { ($fcipd_rtable->{fcipr_d_id});}' unless defined(&fcipd_did);
    eval 'sub fcipd_pd () { ($fcipd_rtable->{fcipr_pd});}' unless defined(&fcipd_pd);
    eval 'sub fcipd_state () { ($fcipd_rtable->{fcipr_state});}' unless defined(&fcipd_state);
    eval 'sub fcipd_fca_dev () { ($fcipd_rtable->{fcipr_fca_dev});;}' unless defined(&fcipd_fca_dev);
    eval 'sub FCIP_PORT_OFFLINE () {0;}' unless defined(&FCIP_PORT_OFFLINE);
    eval 'sub FCIP_PORT_ONLINE () {1;}' unless defined(&FCIP_PORT_ONLINE);
    eval 'sub FCIP_PORT_NOTLOGGED () {2;}' unless defined(&FCIP_PORT_NOTLOGGED);
    eval 'sub FCIP_INVALID_WWN () {-1;}' unless defined(&FCIP_INVALID_WWN);
    eval 'sub SLFAST () {0x1;}' unless defined(&SLFAST);
    eval 'sub SLRAW () {0x2;}' unless defined(&SLRAW);
    eval 'sub SLALLPHYS () {0x4;}' unless defined(&SLALLPHYS);
    eval 'sub SLALLMULTI () {0x5;}' unless defined(&SLALLMULTI);
    eval 'sub SLALLSAP () {0x10;}' unless defined(&SLALLSAP);
    eval 'sub FC_OFF () {0x;}' unless defined(&FC_OFF);
    eval 'sub DA_OFF () {0x1;}' unless defined(&DA_OFF);
    eval 'sub SA_OFF () {0x7;}' unless defined(&SA_OFF);
    eval 'sub DLSAP_OFF () {0xd;}' unless defined(&DLSAP_OFF);
    eval 'sub SLSAP_OFF () {0xe;}' unless defined(&SLSAP_OFF);
    eval 'sub ORG_OFF () {0xf;}' unless defined(&ORG_OFF);
    eval 'sub TYPE_OFF () {0x13;}' unless defined(&TYPE_OFF);
    eval 'sub FCIP_IPV4_LEN () {0x4;;}' unless defined(&FCIP_IPV4_LEN);
    eval 'sub FCIP_CP_IN {
        my($s, $d, $handle, $len) = @_;
	    eval q(( &ddi_rep_get8(($handle), ( &uint8_t *)($d), ( &uint8_t *)($s), ($len),  &DDI_DEV_AUTOINCR)));
    }' unless defined(&FCIP_CP_IN);
    eval 'sub FCIP_CP_OUT {
        my($s, $d, $handle, $len) = @_;
	    eval q(( &ddi_rep_put8(($handle), ( &uint8_t *)($d), ( &uint8_t *)($s), ($len),  &DDI_DEV_AUTOINCR)));
    }' unless defined(&FCIP_CP_OUT);
    eval 'sub LA_ELS_FARP_REQ () {0x54;}' unless defined(&LA_ELS_FARP_REQ);
    eval 'sub LA_ELS_FARP_REPLY () {0x55;}' unless defined(&LA_ELS_FARP_REPLY);
    eval 'sub FARP_MATCH_RSVD () {0x;}' unless defined(&FARP_MATCH_RSVD);
    eval 'sub FARP_MATCH_WW_PN () {0x1;}' unless defined(&FARP_MATCH_WW_PN);
    eval 'sub FARP_MATCH_WW_NN () {0x2;}' unless defined(&FARP_MATCH_WW_NN);
    eval 'sub FARP_MATCH_WW_PN_NN () {0x3;}' unless defined(&FARP_MATCH_WW_PN_NN);
    eval 'sub FARP_MATCH_IPv4 () {0x4;}' unless defined(&FARP_MATCH_IPv4);
    eval 'sub FARP_MATCH_WW_PN_IPv4 () {0x5;}' unless defined(&FARP_MATCH_WW_PN_IPv4);
    eval 'sub FARP_MATCH_WW_NN_IPv4 () {0x6;}' unless defined(&FARP_MATCH_WW_NN_IPv4);
    eval 'sub FARP_MATCH_WW_PN_NN_IPv4 () {0x7;}' unless defined(&FARP_MATCH_WW_PN_NN_IPv4);
    eval 'sub FARP_INIT_P_LOGI () {0x;}' unless defined(&FARP_INIT_P_LOGI);
    eval 'sub FARP_INIT_REPLY () {0x1;}' unless defined(&FARP_INIT_REPLY);
    if(defined(&lint)) {
	eval 'sub FCIP_TNF_ENABLED () {1;}' unless defined(&FCIP_TNF_ENABLED);
    } else {
	undef(&FCIP_TNF_ENABLED) if defined(&FCIP_TNF_ENABLED);
    }
    if(defined(&FCIP_TNF_ENABLED)) {
	eval 'sub FCIP_TNF_LOAD () {
	    eval q(( &void)  &tnf_mod_load());
	}' unless defined(&FCIP_TNF_LOAD);
	eval 'sub FCIP_TNF_UNLOAD {
	    my($x) = @_;
    	    eval q(( &void)  &tnf_mod_unload($x));
	}' unless defined(&FCIP_TNF_UNLOAD);
	eval 'sub FCIP_TNF_PROBE_0 {
	    my($x) = @_;
    	    eval q( &TNF_PROBE_0 $x);
	}' unless defined(&FCIP_TNF_PROBE_0);
	eval 'sub FCIP_TNF_PROBE_1 {
	    my($x) = @_;
    	    eval q( &TNF_PROBE_1 $x);
	}' unless defined(&FCIP_TNF_PROBE_1);
	eval 'sub FCIP_TNF_PROBE_2 {
	    my($x) = @_;
    	    eval q( &TNF_PROBE_2 $x);
	}' unless defined(&FCIP_TNF_PROBE_2);
	eval 'sub FCIP_TNF_PROBE_3 {
	    my($x) = @_;
    	    eval q( &TNF_PROBE_3 $x);
	}' unless defined(&FCIP_TNF_PROBE_3);
	eval 'sub FCIP_TNF_PROBE_4 {
	    my($x) = @_;
    	    eval q( &TNF_PROBE_4 $x);
	}' unless defined(&FCIP_TNF_PROBE_4);
	eval 'sub FCIP_TNF_PROBE_5 {
	    my($x) = @_;
    	    eval q( &TNF_PROBE_5 $x);
	}' unless defined(&FCIP_TNF_PROBE_5);
    } else {
	eval 'sub FCIP_TNF_LOAD () {
	    eval q();
	}' unless defined(&FCIP_TNF_LOAD);
	eval 'sub FCIP_TNF_UNLOAD {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&FCIP_TNF_UNLOAD);
	eval 'sub FCIP_TNF_PROBE_0 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&FCIP_TNF_PROBE_0);
	eval 'sub FCIP_TNF_PROBE_1 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&FCIP_TNF_PROBE_1);
	eval 'sub FCIP_TNF_PROBE_2 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&FCIP_TNF_PROBE_2);
	eval 'sub FCIP_TNF_PROBE_3 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&FCIP_TNF_PROBE_3);
	eval 'sub FCIP_TNF_PROBE_4 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&FCIP_TNF_PROBE_4);
	eval 'sub FCIP_TNF_PROBE_5 {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&FCIP_TNF_PROBE_5);
    }
    if(defined(&FCIP_TNF_ENABLED)) {
	eval 'sub FCIP_TNF_BYTE_ARRAY {
	    my($name, $keys, $detail, $mesg, $barray_name, $barray, $len) = @_;
    	    eval q({  &TNF_PROBE_1($name, $keys, $detail,  &tnf_string,  &msg, $mesg); { \'int\'  &i = 0; \'char\'  $str[36] = \\"\\"; \'char\' * &strp =  &str;  &while ( &i < 32 &&  &i < $len) { ( &void)  &sprintf( &strp, \\"%02x\\", (($barray))[ &i++] & 0xff);  &strp += 2; }  &TNF_PROBE_1($name, $keys, \\"\\",  &tnf_string, $barray_name,  &str); } });
	}' unless defined(&FCIP_TNF_BYTE_ARRAY);
    } else {
	eval 'sub FCIP_TNF_BYTE_ARRAY {
	    my($name, $keys, $detail, $mesg, $barray_name, $barray, $len) = @_;
    	    eval q();
	}' unless defined(&FCIP_TNF_BYTE_ARRAY);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
