require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FLOCK_H)) {
    eval 'sub _SYS_FLOCK_H () {1;}' unless defined(&_SYS_FLOCK_H);
    require 'sys/types.ph';
    require 'sys/fcntl.ph';
    require 'sys/vnode.ph';
    require 'sys/t_lock.ph';
    require 'sys/callb.ph';
    require 'sys/param.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub F_REMOTELOCK () {(0x1 << 16);}' unless defined(&F_REMOTELOCK);
    eval 'sub F_PXFSLOCK () {(0x2 << 16);}' unless defined(&F_PXFSLOCK);
    eval 'sub INOFLCK () {0x1;}' unless defined(&INOFLCK);
    eval 'sub SETFLCK () {0x2;}' unless defined(&SETFLCK);
    eval 'sub SLPFLCK () {0x4;}' unless defined(&SLPFLCK);
    eval 'sub RCMDLCK () {0x8;}' unless defined(&RCMDLCK);
    eval 'sub PCMDLCK () {0x10;}' unless defined(&PCMDLCK);
    eval 'sub IGN_PID () {(-1);}' unless defined(&IGN_PID);
    eval 'sub l_end () { &l_len;}' unless defined(&l_end);
    eval 'sub MAX_U_OFF_T () {(( &u_off_t)~0);}' unless defined(&MAX_U_OFF_T);
    eval 'sub MAX_U_OFFSET_T () {(( &u_offset_t)~0);}' unless defined(&MAX_U_OFFSET_T);
    eval 'sub MAXEND () { &MAXOFFSET_T;}' unless defined(&MAXEND);
    eval 'sub l_has_rmt {
        my($flockp) = @_;
	    eval q(((( &pad_info_t *)(($flockp)-> &l_pad))-> &pi_has_rmt));
    }' unless defined(&l_has_rmt);
    eval 'sub l_callback {
        my($flockp) = @_;
	    eval q(((( &pad_info_t *)(($flockp)-> &l_pad))-> ($pi_cback->{cb_callback})));
    }' unless defined(&l_callback);
    eval 'sub l_cbp {
        my($flockp) = @_;
	    eval q(((( &pad_info_t *)(($flockp)-> &l_pad))-> ($pi_cback->{cb_cbp})));
    }' unless defined(&l_cbp);
    eval 'sub FLP_DELAYED_FREE () {-1;}' unless defined(&FLP_DELAYED_FREE);
    eval 'sub MAX_GRANT_LOCKS () {52;}' unless defined(&MAX_GRANT_LOCKS);
    eval("sub FLK_NLM_UP () { 0; }") unless defined(&FLK_NLM_UP);
    eval("sub FLK_NLM_SHUTTING_DOWN () { 1; }") unless defined(&FLK_NLM_SHUTTING_DOWN);
    eval("sub FLK_NLM_DOWN () { 2; }") unless defined(&FLK_NLM_DOWN);
    eval("sub FLK_NLM_UNKNOWN () { 3; }") unless defined(&FLK_NLM_UNKNOWN);
    eval("sub FLK_LOCKMGR_UP () { 0; }") unless defined(&FLK_LOCKMGR_UP);
    eval("sub FLK_WAKEUP_SLEEPERS () { 1; }") unless defined(&FLK_WAKEUP_SLEEPERS);
    eval("sub FLK_LOCKMGR_DOWN () { 2; }") unless defined(&FLK_LOCKMGR_DOWN);
    if(defined( &_KERNEL)) {
	eval 'sub FLK_QUERY_ACTIVE () {0x1;}' unless defined(&FLK_QUERY_ACTIVE);
	eval 'sub FLK_QUERY_SLEEPING () {0x2;}' unless defined(&FLK_QUERY_SLEEPING);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
