require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FPU_FPU_SIMULATOR_H)) {
    eval 'sub _SYS_FPU_FPU_SIMULATOR_H () {1;}' unless defined(&_SYS_FPU_FPU_SIMULATOR_H);
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
	require 'sys/ieeefp.ph';
	require 'vm/seg.ph';
	require 'sys/kstat.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub FITOS_INSTR_MASK () {0xc1f83fe0;}' unless defined(&FITOS_INSTR_MASK);
    eval 'sub FITOS_INSTR () {0x81a01880;}' unless defined(&FITOS_INSTR);
    eval 'sub FITOS_RS2_SHIFT () {0;}' unless defined(&FITOS_RS2_SHIFT);
    eval 'sub FITOS_RD_SHIFT () {25;}' unless defined(&FITOS_RD_SHIFT);
    eval 'sub FITOS_REG_MASK () {0x1f;}' unless defined(&FITOS_REG_MASK);
    unless(defined(&_ASM)) {
	eval("sub fcc_equal () { 0; }") unless defined(&fcc_equal);
	eval("sub fcc_less () { 1; }") unless defined(&fcc_less);
	eval("sub fcc_greater () { 2; }") unless defined(&fcc_greater);
	eval("sub fcc_unordered () { 3; }") unless defined(&fcc_unordered);
	eval("sub fcc_0 () { 0; }") unless defined(&fcc_0);
	eval("sub fcc_1 () { 1; }") unless defined(&fcc_1);
	eval("sub fcc_2 () { 2; }") unless defined(&fcc_2);
	eval("sub fcc_3 () { 3; }") unless defined(&fcc_3);
	eval("sub icc () { 4; }") unless defined(&icc);
	eval("sub xcc () { 6; }") unless defined(&xcc);
	eval("sub ftt_none () { 0; }") unless defined(&ftt_none);
	eval("sub ftt_ieee () { 1; }") unless defined(&ftt_ieee);
	eval("sub ftt_unfinished () { 2; }") unless defined(&ftt_unfinished);
	eval("sub ftt_unimplemented () { 3; }") unless defined(&ftt_unimplemented);
	eval("sub ftt_sequence () { 4; }") unless defined(&ftt_sequence);
	eval("sub ftt_alignment () { 5; }") unless defined(&ftt_alignment);
	eval("sub ftt_fault () { 6; }") unless defined(&ftt_fault);
	eval("sub ftt_7 () { 7; }") unless defined(&ftt_7);
	unless(defined(&__sparcv9cpu)) {
	} else {
	    eval 'sub fcc3 () { ($fsr->{fcc3});}' unless defined(&fcc3);
	    eval 'sub fcc2 () { ($fsr->{fcc2});}' unless defined(&fcc2);
	    eval 'sub fcc1 () { ($fsr->{fcc1});}' unless defined(&fcc1);
	    eval 'sub fcc0 () { ($fsr->{fcc});}' unless defined(&fcc0);
	    eval 'sub rnd () { ($fsr->{rnd});}' unless defined(&rnd);
	    eval 'sub rnp () { ($fsr->{rnp});}' unless defined(&rnp);
	    eval 'sub tem () { ($fsr->{tem});}' unless defined(&tem);
	    eval 'sub aexc () { ($fsr->{aexc});}' unless defined(&aexc);
	    eval 'sub cexc () { ($fsr->{cexc});}' unless defined(&cexc);
	}
	eval("sub fp_op_int32 () { 0; }") unless defined(&fp_op_int32);
	eval("sub fp_op_single () { 1; }") unless defined(&fp_op_single);
	eval("sub fp_op_double () { 2; }") unless defined(&fp_op_double);
	eval("sub fp_op_extended () { 3; }") unless defined(&fp_op_extended);
	eval("sub fp_op_int64 () { 4; }") unless defined(&fp_op_int64);
	eval("sub fmovs () { 0x0; }") unless defined(&fmovs);
	eval("sub fnegs () { 0x1; }") unless defined(&fnegs);
	eval("sub fabss () { 0x2; }") unless defined(&fabss);
	eval("sub fp_op_3 () { 3; }") unless defined(&fp_op_3);
	eval("sub fp_op_4 () { 4; }") unless defined(&fp_op_4);
	eval("sub fp_op_5 () { 5; }") unless defined(&fp_op_5);
	eval("sub fp_op_6 () { 6; }") unless defined(&fp_op_6);
	eval("sub fp_op_7 () { 7; }") unless defined(&fp_op_7);
	eval("sub fp_op_8 () { 0x8; }") unless defined(&fp_op_8);
	eval("sub fp_op_9 () { 0x9; }") unless defined(&fp_op_9);
	eval("sub fsqrt () { 0xa; }") unless defined(&fsqrt);
	eval("sub fp_op_b () { 0xb; }") unless defined(&fp_op_b);
	eval("sub fp_op_c () { 0xc; }") unless defined(&fp_op_c);
	eval("sub fp_op_d () { 0xd; }") unless defined(&fp_op_d);
	eval("sub fp_op_e () { 0xe; }") unless defined(&fp_op_e);
	eval("sub fp_op_f () { 0xf; }") unless defined(&fp_op_f);
	eval("sub fadd () { 0x10; }") unless defined(&fadd);
	eval("sub fsub () { 0x11; }") unless defined(&fsub);
	eval("sub fmul () { 0x12; }") unless defined(&fmul);
	eval("sub fdiv () { 0x13; }") unless defined(&fdiv);
	eval("sub fcmp () { 0x14; }") unless defined(&fcmp);
	eval("sub fcmpe () { 0x15; }") unless defined(&fcmpe);
	eval("sub fp_op_16 () { 0x16; }") unless defined(&fp_op_16);
	eval("sub fp_op_17 () { 0x17; }") unless defined(&fp_op_17);
	eval("sub fp_op_18 () { 0x18; }") unless defined(&fp_op_18);
	eval("sub fp_op_19 () { 0x19; }") unless defined(&fp_op_19);
	eval("sub fsmuld () { 0x1a; }") unless defined(&fsmuld);
	eval("sub fdmulx () { 0x1b; }") unless defined(&fdmulx);
	eval("sub ftoll () { 0x20; }") unless defined(&ftoll);
	eval("sub flltos () { 0x21; }") unless defined(&flltos);
	eval("sub flltod () { 0x22; }") unless defined(&flltod);
	eval("sub flltox () { 0x23; }") unless defined(&flltox);
	eval("sub fp_op_24 () { 0x24; }") unless defined(&fp_op_24);
	eval("sub fp_op_25 () { 0x25; }") unless defined(&fp_op_25);
	eval("sub fp_op_26 () { 0x26; }") unless defined(&fp_op_26);
	eval("sub fp_op_27 () { 0x27; }") unless defined(&fp_op_27);
	eval("sub fp_op_28 () { 0x28; }") unless defined(&fp_op_28);
	eval("sub fp_op_29 () { 0x29; }") unless defined(&fp_op_29);
	eval("sub fp_op_2a () { 0x2a; }") unless defined(&fp_op_2a);
	eval("sub fp_op_2b () { 0x2b; }") unless defined(&fp_op_2b);
	eval("sub fp_op_2c () { 0x2c; }") unless defined(&fp_op_2c);
	eval("sub fp_op_2d () { 0x2d; }") unless defined(&fp_op_2d);
	eval("sub fp_op_2e () { 0x2e; }") unless defined(&fp_op_2e);
	eval("sub fp_op_2f () { 0x2f; }") unless defined(&fp_op_2f);
	eval("sub fp_op_30 () { 0x30; }") unless defined(&fp_op_30);
	eval("sub fitos () { 0x31; }") unless defined(&fitos);
	eval("sub fitod () { 0x32; }") unless defined(&fitod);
	eval("sub fitox () { 0x33; }") unless defined(&fitox);
	eval("sub ftoi () { 0x34; }") unless defined(&ftoi);
	eval("sub fp_op_35 () { 0x35; }") unless defined(&fp_op_35);
	eval("sub fp_op_36 () { 0x36; }") unless defined(&fp_op_36);
	eval("sub fp_op_37 () { 0x37; }") unless defined(&fp_op_37);
	eval("sub ft_op_38 () { 0x38; }") unless defined(&ft_op_38);
	eval("sub fp_op_39 () { 0x39; }") unless defined(&fp_op_39);
	eval("sub fp_op_3a () { 0x3a; }") unless defined(&fp_op_3a);
	eval("sub fp_op_3b () { 0x3b; }") unless defined(&fp_op_3b);
	eval("sub fp_op_3c () { 0x3c; }") unless defined(&fp_op_3c);
	eval("sub fp_op_3d () { 0x3d; }") unless defined(&fp_op_3d);
	eval("sub fp_op_3e () { 0x3e; }") unless defined(&fp_op_3e);
	eval("sub fp_op_3f () { 0x3f; }") unless defined(&fp_op_3f);
	if(defined(&__sparcv9cpu)) {
	}
	if(defined(&__STDC__)) {
	    if(defined(&__sparcv9cpu)) {
	    } else {
	    }
	} else {
	    if(defined(&__sparcv9cpu)) {
	    } else {
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
