require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_CACHEFS_DLOG_H)) {
    eval 'sub _SYS_FS_CACHEFS_DLOG_H () {1;}' unless defined(&_SYS_FS_CACHEFS_DLOG_H);
    require 'sys/vfs.ph';
    require 'sys/acl.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub CFS_DLOG_VERSION () {1001;}' unless defined(&CFS_DLOG_VERSION);
    eval("sub CFS_DLOG_CREATE () { 0x100; }") unless defined(&CFS_DLOG_CREATE);
    eval("sub CFS_DLOG_REMOVE () { 1; }") unless defined(&CFS_DLOG_REMOVE);
    eval("sub CFS_DLOG_LINK () { 2; }") unless defined(&CFS_DLOG_LINK);
    eval("sub CFS_DLOG_RENAME () { 3; }") unless defined(&CFS_DLOG_RENAME);
    eval("sub CFS_DLOG_MKDIR () { 4; }") unless defined(&CFS_DLOG_MKDIR);
    eval("sub CFS_DLOG_RMDIR () { 5; }") unless defined(&CFS_DLOG_RMDIR);
    eval("sub CFS_DLOG_SYMLINK () { 6; }") unless defined(&CFS_DLOG_SYMLINK);
    eval("sub CFS_DLOG_SETATTR () { 7; }") unless defined(&CFS_DLOG_SETATTR);
    eval("sub CFS_DLOG_SETSECATTR () { 8; }") unless defined(&CFS_DLOG_SETSECATTR);
    eval("sub CFS_DLOG_MODIFIED () { 9; }") unless defined(&CFS_DLOG_MODIFIED);
    eval("sub CFS_DLOG_MAPFID () { 10; }") unless defined(&CFS_DLOG_MAPFID);
    eval("sub CFS_DLOG_TRAILER () { 11; }") unless defined(&CFS_DLOG_TRAILER);
    eval("sub CFS_DLOG_VAL_CRASH () { 0x200; }") unless defined(&CFS_DLOG_VAL_CRASH);
    eval("sub CFS_DLOG_VAL_COMMITTED () { 1; }") unless defined(&CFS_DLOG_VAL_COMMITTED);
    eval("sub CFS_DLOG_VAL_ERROR () { 2; }") unless defined(&CFS_DLOG_VAL_ERROR);
    eval("sub CFS_DLOG_VAL_PROCESSED () { 3; }") unless defined(&CFS_DLOG_VAL_PROCESSED);
    eval 'sub CFS_DLOG_BUFSIZE () {($sizeof{ &gid_t} * ( &NGROUPS_MAX_DEFAULT - 1));}' unless defined(&CFS_DLOG_BUFSIZE);
    eval 'sub COMMON_RECORD_HDR () {
        eval q(\'int\'  &dl_len;  &cfs_dlog_op_t  &dl_op;  &cfs_dlog_val_t  &dl_valid;  &uint_t  &dl_seq;);
    }' unless defined(&COMMON_RECORD_HDR);
    eval 'sub CFS_DLOG_SECATTR_MAXSIZE () {($sizeof{\'struct cfs_dlog_setsecattr\'} + ($sizeof{ &aclent_t} *  &MAX_ACL_ENTRIES));}' unless defined(&CFS_DLOG_SECATTR_MAXSIZE);
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    my($a, $b) = @_;
    	    eval q(((($a) > ($b)) ? ($a) : ($b)));
	}' unless defined(&MAX);
    }
    eval 'sub CFS_DLOG_ENTRY_MAXSIZE () { &MAX( &offsetof(\'struct cfs_dlog_entry\',  &dl_trailer),  &offsetof(\'struct cfs_dlog_entry\',  ($dl_u->{dl_setsecattr})) +  &CFS_DLOG_SECATTR_MAXSIZE);}' unless defined(&CFS_DLOG_ENTRY_MAXSIZE);
    if(defined( &_KERNEL)  && defined( &__STDC__)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
