require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_CACHEFS_FSCACHE_H)) {
    eval 'sub _SYS_FS_CACHEFS_FSCACHE_H () {1;}' unless defined(&_SYS_FS_CACHEFS_FSCACHE_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub CFS_FS_FGP_BUCKET_SIZE () {64;}' unless defined(&CFS_FS_FGP_BUCKET_SIZE);
    eval 'sub CFS_FS_MAXIDLE () {100;}' unless defined(&CFS_FS_MAXIDLE);
    eval("sub CFS_CD_CONNECTED () { 0x801; }") unless defined(&CFS_CD_CONNECTED);
    eval("sub CFS_CD_DISCONNECTED () { 1; }") unless defined(&CFS_CD_DISCONNECTED);
    eval("sub CFS_CD_RECONNECTING () { 2; }") unless defined(&CFS_CD_RECONNECTING);
    eval 'sub CFS_FS_MOUNTED () {0x1;}' unless defined(&CFS_FS_MOUNTED);
    eval 'sub CFS_FS_READ () {0x2;}' unless defined(&CFS_FS_READ);
    eval 'sub CFS_FS_WRITE () {0x4;}' unless defined(&CFS_FS_WRITE);
    eval 'sub CFS_FS_ROOTFS () {0x8;}' unless defined(&CFS_FS_ROOTFS);
    eval 'sub CFS_FS_DIRTYINFO () {0x10;}' unless defined(&CFS_FS_DIRTYINFO);
    eval 'sub CFS_FS_HASHPRINT () {0x20;}' unless defined(&CFS_FS_HASHPRINT);
    eval 'sub CFS_FS_CONST_STRICT () {11;}' unless defined(&CFS_FS_CONST_STRICT);
    eval 'sub CFS_FS_CONST_NOCONST () {12;}' unless defined(&CFS_FS_CONST_NOCONST);
    eval 'sub CFS_FS_CONST_CODCONST () {13;}' unless defined(&CFS_FS_CONST_CODCONST);
    eval 'sub CFSOP_INIT_COBJECT {
        my($FSCP, $CP, $VAP, $CR) = @_;
	    eval q((*($FSCP)-> ($fs_cfsops->{co_init_cobject}))($FSCP, $CP, $VAP, $CR));
    }' unless defined(&CFSOP_INIT_COBJECT);
    eval 'sub CFSOP_CHECK_COBJECT {
        my($FSCP, $CP, $WHAT, $CR) = @_;
	    eval q((*($FSCP)-> ($fs_cfsops->{co_check_cobject}))($FSCP, $CP, $WHAT, $CR));
    }' unless defined(&CFSOP_CHECK_COBJECT);
    eval 'sub CFSOP_MODIFY_COBJECT {
        my($FSCP, $CP, $CR) = @_;
	    eval q((*($FSCP)-> ($fs_cfsops->{co_modify_cobject}))($FSCP, $CP, $CR));
    }' unless defined(&CFSOP_MODIFY_COBJECT);
    eval 'sub CFSOP_INVALIDATE_COBJECT {
        my($FSCP, $CP, $CR) = @_;
	    eval q((*($FSCP)-> ($fs_cfsops->{co_invalidate_cobject}))($FSCP, $CP, $CR));
    }' unless defined(&CFSOP_INVALIDATE_COBJECT);
    eval 'sub CFSOP_CONVERT_COBJECT {
        my($FSCP, $CP, $CR) = @_;
	    eval q((*($FSCP)-> ($fs_cfsops->{co_convert_cobject}))($FSCP, $CP, $CR));
    }' unless defined(&CFSOP_CONVERT_COBJECT);
    eval 'sub CFS_ISFS_SNR {
        my($FSCP) = @_;
	    eval q((($FSCP)-> ($fs_info->{fi_mntflags}) &  &CFS_DISCONNECTABLE));
    }' unless defined(&CFS_ISFS_SNR);
    eval 'sub CFS_ISFS_SOFT {
        my($FSCP) = @_;
	    eval q((($FSCP)-> ($fs_info->{fi_mntflags}) &  &CFS_SOFT));
    }' unless defined(&CFS_ISFS_SOFT);
    eval 'sub CFS_ISFS_WRITE_AROUND {
        my($FSCP) = @_;
	    eval q((($FSCP)-> ($fs_info->{fi_mntflags}) &  &CFS_WRITE_AROUND));
    }' unless defined(&CFS_ISFS_WRITE_AROUND);
    eval 'sub CFS_ISFS_NONSHARED {
        my($FSCP) = @_;
	    eval q((($FSCP)-> ($fs_info->{fi_mntflags}) &  &CFS_NONSHARED));
    }' unless defined(&CFS_ISFS_NONSHARED);
    eval 'sub CFS_ISFS_STRICT {
        my($FSCP) = @_;
	    eval q(((($FSCP)-> ($fs_info->{fi_mntflags}) &  &CFS_WRITE_AROUND)  && ((($FSCP)-> ($fs_info->{fi_mntflags}) & ( &CFS_NOCONST_MODE |  &CFS_CODCONST_MODE)) == 0)));
    }' unless defined(&CFS_ISFS_STRICT);
    eval 'sub CFS_ISFS_NOCONST {
        my($FSCP) = @_;
	    eval q((($FSCP)-> ($fs_info->{fi_mntflags}) &  &CFS_NOCONST_MODE));
    }' unless defined(&CFS_ISFS_NOCONST);
    eval 'sub CFS_ISFS_CODCONST {
        my($FSCP) = @_;
	    eval q((($FSCP)-> ($fs_info->{fi_mntflags}) &  &CFS_CODCONST_MODE));
    }' unless defined(&CFS_ISFS_CODCONST);
    eval 'sub CFS_ISFS_LLOCK {
        my($FSCP) = @_;
	    eval q((($FSCP)-> ($fs_info->{fi_mntflags}) &  &CFS_LLOCK));
    }' unless defined(&CFS_ISFS_LLOCK);
    if(defined(&__cplusplus)) {
    }
}
1;
