require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_CACHEFS_LOG_H)) {
    eval 'sub _SYS_FS_CACHEFS_LOG_H () {1;}' unless defined(&_SYS_FS_CACHEFS_LOG_H);
    require 'sys/types.ph';
    require 'sys/types32.ph';
    require 'sys/vfs.ph';
    require 'sys/fs/cachefs_fs.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub CACHEFS_LOG_MAGIC () {32321;}' unless defined(&CACHEFS_LOG_MAGIC);
    eval 'sub CACHEFS_LOG_FILE_REV () {2;}' unless defined(&CACHEFS_LOG_FILE_REV);
    eval 'sub CACHEFS_LOG_MOUNT () {1;}' unless defined(&CACHEFS_LOG_MOUNT);
    eval 'sub CACHEFS_LOG_UMOUNT () {2;}' unless defined(&CACHEFS_LOG_UMOUNT);
    eval 'sub CACHEFS_LOG_GETPAGE () {3;}' unless defined(&CACHEFS_LOG_GETPAGE);
    eval 'sub CACHEFS_LOG_READDIR () {4;}' unless defined(&CACHEFS_LOG_READDIR);
    eval 'sub CACHEFS_LOG_READLINK () {5;}' unless defined(&CACHEFS_LOG_READLINK);
    eval 'sub CACHEFS_LOG_REMOVE () {6;}' unless defined(&CACHEFS_LOG_REMOVE);
    eval 'sub CACHEFS_LOG_RMDIR () {7;}' unless defined(&CACHEFS_LOG_RMDIR);
    eval 'sub CACHEFS_LOG_TRUNCATE () {8;}' unless defined(&CACHEFS_LOG_TRUNCATE);
    eval 'sub CACHEFS_LOG_PUTPAGE () {9;}' unless defined(&CACHEFS_LOG_PUTPAGE);
    eval 'sub CACHEFS_LOG_CREATE () {10;}' unless defined(&CACHEFS_LOG_CREATE);
    eval 'sub CACHEFS_LOG_MKDIR () {11;}' unless defined(&CACHEFS_LOG_MKDIR);
    eval 'sub CACHEFS_LOG_RENAME () {12;}' unless defined(&CACHEFS_LOG_RENAME);
    eval 'sub CACHEFS_LOG_SYMLINK () {13;}' unless defined(&CACHEFS_LOG_SYMLINK);
    eval 'sub CACHEFS_LOG_POPULATE () {14;}' unless defined(&CACHEFS_LOG_POPULATE);
    eval 'sub CACHEFS_LOG_CSYMLINK () {15;}' unless defined(&CACHEFS_LOG_CSYMLINK);
    eval 'sub CACHEFS_LOG_FILLDIR () {16;}' unless defined(&CACHEFS_LOG_FILLDIR);
    eval 'sub CACHEFS_LOG_MDCREATE () {17;}' unless defined(&CACHEFS_LOG_MDCREATE);
    eval 'sub CACHEFS_LOG_GPFRONT () {18;}' unless defined(&CACHEFS_LOG_GPFRONT);
    eval 'sub CACHEFS_LOG_RFDIR () {19;}' unless defined(&CACHEFS_LOG_RFDIR);
    eval 'sub CACHEFS_LOG_UALLOC () {20;}' unless defined(&CACHEFS_LOG_UALLOC);
    eval 'sub CACHEFS_LOG_CALLOC () {21;}' unless defined(&CACHEFS_LOG_CALLOC);
    eval 'sub CACHEFS_LOG_NOCACHE () {22;}' unless defined(&CACHEFS_LOG_NOCACHE);
    eval 'sub CACHEFS_LOG_NUMRECS () {22;}' unless defined(&CACHEFS_LOG_NUMRECS);
    eval 'sub CACHEFS_LOG_LOGGING {
        my($cp, $which) = @_;
	    eval q((($cp !=  &NULL)  && ( ($cp->{c_log}) !=  &NULL)  && ( ($cp->{c_log_ctl}->{lc_which[$which / NBBY]}) & (1<< ($which %  &NBBY)))));
    }' unless defined(&CACHEFS_LOG_LOGGING);
    eval 'sub CACHEFS_LOG_SET {
        my($lc, $which) = @_;
	    eval q(( ($lc->{lc_which[$which / NBBY]}) |= (1<< ($which %  &NBBY))));
    }' unless defined(&CACHEFS_LOG_SET);
    eval 'sub CACHEFS_LOG_CLEAR {
        my($lc, $which) = @_;
	    eval q(( ($lc->{lc_which[$which / NBBY]}) &= ~(1<< ($which %  &NBBY))));
    }' unless defined(&CACHEFS_LOG_CLEAR);
    eval 'sub CLPAD {
        my($sname, $field) = @_;
	    eval q(($sizeof{\'struct sname\'} -  &offsetof(\'struct sname\', $field) - $sizeof{(0)->$field}));
    }' unless defined(&CLPAD);
    if((defined( &_SYSCALL32)  && defined( &_LP64))) {
    } else {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
