require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_HSFS_SUSP_H)) {
    eval 'sub _SYS_FS_HSFS_SUSP_H () {1;}' unless defined(&_SYS_FS_HSFS_SUSP_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub DEBUGGING_ALL () {0;}' unless defined(&DEBUGGING_ALL);
    eval 'sub DEBUGGING () {0;}' unless defined(&DEBUGGING);
    eval 'sub DPRINTF () { &if ( &DEBUGGING)  &printf;}' unless defined(&DPRINTF);
    eval 'sub DPRINTF_ALL () { &if ( &DEBUGGING_ALL)  &printf;}' unless defined(&DPRINTF_ALL);
    eval 'sub SUA_NULL_POINTER () {-1;}' unless defined(&SUA_NULL_POINTER);
    eval 'sub END_OF_SUA_PARSING () {-2;}' unless defined(&END_OF_SUA_PARSING);
    eval 'sub END_OF_SUA () {-3;}' unless defined(&END_OF_SUA);
    eval 'sub GET_CONTINUATION () {-4;}' unless defined(&GET_CONTINUATION);
    eval 'sub SUA_ENOMEM () {-5;}' unless defined(&SUA_ENOMEM);
    eval 'sub SUA_EINVAL () {-6;}' unless defined(&SUA_EINVAL);
    eval 'sub RELOC_DIR () {-7;}' unless defined(&RELOC_DIR);
    eval 'sub SET_IMPL_BIT {
        my($fsp, $y) = @_;
	    eval q((( ($fsp->{hsfs_ext_impl})) |= (0x1) << ($y)));
    }' unless defined(&SET_IMPL_BIT);
    eval 'sub UNSET_IMPL_BIT {
        my($fsp, $y) = @_;
	    eval q((( ($fsp->{hsfs_ext_impl})) &= ~((0x1) << ($y))));
    }' unless defined(&UNSET_IMPL_BIT);
    eval 'sub IS_IMPL_BIT_SET {
        my($fsp, $y) = @_;
	    eval q((( ($fsp->{hsfs_ext_impl})) & ((0x1) << ($y))));
    }' unless defined(&IS_IMPL_BIT_SET);
    eval 'sub HAVE_SUSP () {0;}' unless defined(&HAVE_SUSP);
    eval 'sub HAVE_PROHIBITED () {1;}' unless defined(&HAVE_PROHIBITED);
    eval 'sub SET_SUSP_BIT {
        my($fsp) = @_;
	    eval q(( &SET_IMPL_BIT(($fsp),  &HAVE_SUSP)));
    }' unless defined(&SET_SUSP_BIT);
    eval 'sub UNSET_SUSP_BIT {
        my($fsp) = @_;
	    eval q(( &UNSET_IMPL_BIT(($fsp),  &HAVE_SUSP)));
    }' unless defined(&UNSET_SUSP_BIT);
    eval 'sub IS_SUSP_IMPLEMENTED {
        my($fsp) = @_;
	    eval q(( &IS_IMPL_BIT_SET($fsp, 0) ? 1: 0));
    }' unless defined(&IS_SUSP_IMPLEMENTED);
    eval 'sub SUSP_VERSION () {1;}' unless defined(&SUSP_VERSION);
    eval 'sub SUSP_SP () {"SP";}' unless defined(&SUSP_SP);
    eval 'sub SUSP_CE () {"CE";}' unless defined(&SUSP_CE);
    eval 'sub SUSP_PD () {"PD";}' unless defined(&SUSP_PD);
    eval 'sub SUSP_ER () {"ER";}' unless defined(&SUSP_ER);
    eval 'sub SUSP_ST () {"ST";}' unless defined(&SUSP_ST);
    eval 'sub SUF_SIG_LEN () {2;}' unless defined(&SUF_SIG_LEN);
    eval 'sub SUF_MIN_LEN () {4;}' unless defined(&SUF_MIN_LEN);
    eval 'sub SUF_LEN {
        my($x) = @_;
	    eval q(*( &SUF_len($x)));
    }' unless defined(&SUF_LEN);
    eval 'sub SUF_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[2]));
    }' unless defined(&SUF_len);
    eval 'sub SUF_VER {
        my($x) = @_;
	    eval q(*( &SUF_ver($x)));
    }' unless defined(&SUF_VER);
    eval 'sub SUF_ver {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[3]));
    }' unless defined(&SUF_ver);
    eval 'sub ER_ID_LEN {
        my($x) = @_;
	    eval q(*( &ER_id_len($x)));
    }' unless defined(&ER_ID_LEN);
    eval 'sub ER_id_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&ER_id_len);
    eval 'sub ER_DES_LEN {
        my($x) = @_;
	    eval q(*( &ER_des_len($x)));
    }' unless defined(&ER_DES_LEN);
    eval 'sub ER_des_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[5]));
    }' unless defined(&ER_des_len);
    eval 'sub ER_SRC_LEN {
        my($x) = @_;
	    eval q(*( &ER_src_len($x)));
    }' unless defined(&ER_SRC_LEN);
    eval 'sub ER_src_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[6]));
    }' unless defined(&ER_src_len);
    eval 'sub ER_EXT_VER {
        my($x) = @_;
	    eval q(*( &ER_ext_ver($x)));
    }' unless defined(&ER_EXT_VER);
    eval 'sub ER_ext_ver {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[7]));
    }' unless defined(&ER_ext_ver);
    eval 'sub ER_EXT_ID_LOC () {8;}' unless defined(&ER_EXT_ID_LOC);
    eval 'sub ER_ext_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[ &ER_EXT_ID_LOC]));
    }' unless defined(&ER_ext_id);
    eval 'sub ER_ext_des {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[ &ER_EXT_ID_LOC +  &ER_ID_LEN($x)]));
    }' unless defined(&ER_ext_des);
    eval 'sub ER_ext_src {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[ &ER_EXT_ID_LOC +  &ER_ID_LEN($x) +  &ER_DES_LEN($x)]));
    }' unless defined(&ER_ext_src);
    eval 'sub CE_BLK_LOC {
        my($x) = @_;
	    eval q( &BOTH_INT( &CE_blk_loc($x)));
    }' unless defined(&CE_BLK_LOC);
    eval 'sub CE_blk_loc {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&CE_blk_loc);
    eval 'sub CE_OFFSET {
        my($x) = @_;
	    eval q( &BOTH_INT( &CE_offset($x)));
    }' unless defined(&CE_OFFSET);
    eval 'sub CE_offset {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[12]));
    }' unless defined(&CE_offset);
    eval 'sub CE_CONT_LEN {
        my($x) = @_;
	    eval q( &BOTH_INT( &CE_cont_len($x)));
    }' unless defined(&CE_CONT_LEN);
    eval 'sub CE_cont_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[20]));
    }' unless defined(&CE_cont_len);
    eval 'sub SP_CHK_BYTE_1 {
        my($x) = @_;
	    eval q(*( &SP_chk_byte_1($x)));
    }' unless defined(&SP_CHK_BYTE_1);
    eval 'sub SP_chk_byte_1 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&SP_chk_byte_1);
    eval 'sub SP_CHK_BYTE_2 {
        my($x) = @_;
	    eval q(*( &SP_chk_byte_2($x)));
    }' unless defined(&SP_CHK_BYTE_2);
    eval 'sub SP_chk_byte_2 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[5]));
    }' unless defined(&SP_chk_byte_2);
    eval 'sub SUSP_CHECK_BYTE_1 () {( &uchar_t)0xbe;}' unless defined(&SUSP_CHECK_BYTE_1);
    eval 'sub SUSP_CHECK_BYTE_2 () {( &uchar_t)0xef;}' unless defined(&SUSP_CHECK_BYTE_2);
    eval 'sub CHECK_BYTES_OK {
        my($x) = @_;
	    eval q((( &SP_CHK_BYTE_1($x) ==  &SUSP_CHECK_BYTE_1)  && ( &SP_CHK_BYTE_2($x) ==  &SUSP_CHECK_BYTE_2)));
    }' unless defined(&CHECK_BYTES_OK);
    eval 'sub SP_SUA_OFFSET {
        my($x) = @_;
	    eval q(*( &SP_sua_offset($x)));
    }' unless defined(&SP_SUA_OFFSET);
    eval 'sub SP_sua_offset {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[6]));
    }' unless defined(&SP_sua_offset);
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
