require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_PC_DIR_H)) {
    eval 'sub _SYS_FS_PC_DIR_H () {1;}' unless defined(&_SYS_FS_PC_DIR_H);
    require 'sys/dirent.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub PCFNAMESIZE () {8;}' unless defined(&PCFNAMESIZE);
    eval 'sub PCFEXTSIZE () {3;}' unless defined(&PCFEXTSIZE);
    eval 'sub PCMAXPATHLEN () { &MAXPATHLEN;}' unless defined(&PCMAXPATHLEN);
    eval 'sub PCMAXNAMLEN () {255;}' unless defined(&PCMAXNAMLEN);
    eval 'sub PCLFNCHUNKSIZE () {13;}' unless defined(&PCLFNCHUNKSIZE);
    eval 'sub SECSHIFT () {0;}' unless defined(&SECSHIFT);
    eval 'sub SECMASK () {0x1f;}' unless defined(&SECMASK);
    eval 'sub MINSHIFT () {5;}' unless defined(&MINSHIFT);
    eval 'sub MINMASK () {0x3f;}' unless defined(&MINMASK);
    eval 'sub HOURSHIFT () {11;}' unless defined(&HOURSHIFT);
    eval 'sub HOURMASK () {0x1f;}' unless defined(&HOURMASK);
    eval 'sub DAYSHIFT () {0;}' unless defined(&DAYSHIFT);
    eval 'sub DAYMASK () {0x1f;}' unless defined(&DAYMASK);
    eval 'sub MONSHIFT () {5;}' unless defined(&MONSHIFT);
    eval 'sub MONMASK () {0xf;}' unless defined(&MONMASK);
    eval 'sub YEARSHIFT () {9;}' unless defined(&YEARSHIFT);
    eval 'sub YEARMASK () {0x7f;}' unless defined(&YEARMASK);
    if(defined(&__cplusplus)) {
    }
    require 'sys/fs/pc_node.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub PCLF_FIRSTNAMESIZE () {10;}' unless defined(&PCLF_FIRSTNAMESIZE);
    eval 'sub PCLF_SECONDNAMESIZE () {12;}' unless defined(&PCLF_SECONDNAMESIZE);
    eval 'sub PCLF_THIRDNAMESIZE () {4;}' unless defined(&PCLF_THIRDNAMESIZE);
    eval 'sub PCDL_IS_LAST_LFN {
        my($x) = @_;
	    eval q((( ($x->{pcdl_ordinal})) & 0x40));
    }' unless defined(&PCDL_IS_LAST_LFN);
    eval 'sub PCDL_LFN_BITS () {( &PCA_RDONLY |  &PCA_HIDDEN |  &PCA_SYSTEM |  &PCA_LABEL);}' unless defined(&PCDL_LFN_BITS);
    eval 'sub PCDL_IS_LFN {
        my($x) = @_;
	    eval q((\'enable_long_filenames\'  && ((($x)-> &pcd_attr &  &PCDL_LFN_BITS) ==  &PCDL_LFN_BITS)));
    }' unless defined(&PCDL_IS_LFN);
    eval 'sub PCD_UNUSED () {(0x);}' unless defined(&PCD_UNUSED);
    eval 'sub PCD_ERASED () {(0xe5);}' unless defined(&PCD_ERASED);
    eval 'sub PCA_RDONLY () {0x1;}' unless defined(&PCA_RDONLY);
    eval 'sub PCA_HIDDEN () {0x2;}' unless defined(&PCA_HIDDEN);
    eval 'sub PCA_SYSTEM () {0x4;}' unless defined(&PCA_SYSTEM);
    eval 'sub PCA_LABEL () {0x8;}' unless defined(&PCA_LABEL);
    eval 'sub PCA_DIR () {0x10;}' unless defined(&PCA_DIR);
    eval 'sub PCA_ARCH () {0x20;}' unless defined(&PCA_ARCH);
    eval 'sub PCA_IS_HIDDEN {
        my($fsp, $attr) = @_;
	    eval q((((($attr) &  &PCA_LABEL) ==  &PCA_LABEL) || (((($fsp)-> &pcfs_flags &  &PCFS_HIDDEN) == 0)  && (($attr) & ( &PCA_HIDDEN |  &PCA_SYSTEM)))));
    }' unless defined(&PCA_IS_HIDDEN);
    eval 'sub PC_NAME_IS_DOT {
        my($namep) = @_;
	    eval q(((($namep)[0] == ord(\'.\') && ((namep)[1] == \'\\\\0\'))));
    }' unless defined(&PC_NAME_IS_DOT);
    eval 'sub PC_NAME_IS_DOTDOT {
        my($namep) = @_;
	    eval q(((($namep)[0] == ord(\'.\') && ((namep)[1] == \'.\') && ((namep)[2] == \'\\\\0\'))));
    }' unless defined(&PC_NAME_IS_DOTDOT);
    eval 'sub PC_SHORTNAME_IS_DOT {
        my($namep) = @_;
	    eval q(((($namep)[0] == ord(\'.\') && ((namep)[1] == \' \'))));
    }' unless defined(&PC_SHORTNAME_IS_DOT);
    eval 'sub PC_SHORTNAME_IS_DOTDOT {
        my($namep) = @_;
	    eval q(((($namep)[0] == ord(\'.\') && ((namep)[1] == \'.\') && ((namep)[2] == \' \'))));
    }' unless defined(&PC_SHORTNAME_IS_DOTDOT);
    eval("sub SL_NONE () { 0; }") unless defined(&SL_NONE);
    eval("sub SL_FOUND () { 1; }") unless defined(&SL_FOUND);
    eval("sub SL_EXTEND () { 2; }") unless defined(&SL_EXTEND);
    eval 'sub SL_DOT () {1;}' unless defined(&SL_DOT);
    eval 'sub SL_DOTDOT () {2;}' unless defined(&SL_DOTDOT);
    if(defined(&_KERNEL)) {
	eval 'sub toupper {
	    my($C) = @_;
    	    eval q(((($C) >= ord(\'a\' && (C) <= \'z\') ? (C) - \'a\' + \'A\') : ($C)));
	}' unless defined(&toupper);
	eval 'sub tolower {
	    my($C) = @_;
    	    eval q(((($C) >= ord(\'A\' && (C) <= \'Z\') ? (C) - \'A\' + \'a\') : ($C)));
	}' unless defined(&tolower);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
