require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_SNODE_H)) {
    eval 'sub _SYS_FS_SNODE_H () {1;}' unless defined(&_SYS_FS_SNODE_H);
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/cred.ph';
    require 'sys/vnode.ph';
    require 'sys/dditypes.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub SUPD () {0x1;}' unless defined(&SUPD);
    eval 'sub SACC () {0x2;}' unless defined(&SACC);
    eval 'sub SCHG () {0x4;}' unless defined(&SCHG);
    eval 'sub SPRIV () {0x8;}' unless defined(&SPRIV);
    eval 'sub SLOFFSET () {0x10;}' unless defined(&SLOFFSET);
    eval 'sub SLOCKED () {0x20;}' unless defined(&SLOCKED);
    eval 'sub SWANT () {0x40;}' unless defined(&SWANT);
    eval 'sub SCLONE () {0x100;}' unless defined(&SCLONE);
    eval 'sub SNEEDCLOSE () {0x200;}' unless defined(&SNEEDCLOSE);
    if(defined(&_KERNEL)) {
	eval 'sub VTOS {
	    my($vp) = @_;
    	    eval q(((($vp)-> &v_data)));
	}' unless defined(&VTOS);
	eval 'sub STOV {
	    my($sp) = @_;
    	    eval q((($sp)-> &s_vnode));
	}' unless defined(&STOV);
	eval 'sub UNKNOWN_SIZE () {0x7fffffff;}' unless defined(&UNKNOWN_SIZE);
	if(defined( &_NO_LONGLONG)) {
	    eval 'sub SPEC_MAXOFFSET_T () { &MAXOFF_T;}' unless defined(&SPEC_MAXOFFSET_T);
	}
 elsif(defined( &_LP64)) {
	    eval 'sub SPEC_MAXOFFSET_T () { &MAXOFFSET_T;}' unless defined(&SPEC_MAXOFFSET_T);
	} else {
	    eval 'sub SPEC_MAXOFFSET_T () {((1 <<  &NBBY * $sizeof{ &daddr32_t} +  &DEV_BSHIFT - 1) - 1);}' unless defined(&SPEC_MAXOFFSET_T);
	}
	eval 'sub STABLESIZE () {256;}' unless defined(&STABLESIZE);
	eval 'sub STABLEHASH {
	    my($dev) = @_;
    	    eval q((( &getmajor($dev) +  &getminor($dev)) & ( &STABLESIZE - 1)));
	}' unless defined(&STABLEHASH);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
