require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_UDF_INODE_H)) {
    eval 'sub _SYS_FS_UDF_INODE_H () {1;}' unless defined(&_SYS_FS_UDF_INODE_H);
    require 'sys/note.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub SUN_IMPL_ID () {"*SUN SOLARIS UDF";}' unless defined(&SUN_IMPL_ID);
    eval 'sub SUN_IMPL_ID_LEN () {16;}' unless defined(&SUN_IMPL_ID_LEN);
    eval 'sub SUN_OS_CLASS () {4;}' unless defined(&SUN_OS_CLASS);
    eval 'sub SUN_OS_ID () {2;}' unless defined(&SUN_OS_ID);
    eval 'sub CLSTR_SIZE () {8;}' unless defined(&CLSTR_SIZE);
    eval 'sub CLSTR_MASK () {7;}' unless defined(&CLSTR_MASK);
    eval("sub DE_CREATE () { 0; }") unless defined(&DE_CREATE);
    eval("sub DE_MKDIR () { 1; }") unless defined(&DE_MKDIR);
    eval("sub DE_LINK () { 2; }") unless defined(&DE_LINK);
    eval("sub DE_RENAME () { 3; }") unless defined(&DE_RENAME);
    eval("sub DR_REMOVE () { 0; }") unless defined(&DR_REMOVE);
    eval("sub DR_RMDIR () { 1; }") unless defined(&DR_RMDIR);
    eval("sub DR_RENAME () { 2; }") unless defined(&DR_RENAME);
    eval 'sub blkoff {
        my($udfvfsp, $loc) = @_;
	    eval q((($loc) & ($udfvfsp)-> &udf_lbmask));
    }' unless defined(&blkoff);
    eval 'sub lblkno {
        my($udf_vfsp, $loc) = @_;
	    eval q((( &int32_t)(($loc) / ($udf_vfsp)-> &udf_lbsize)));
    }' unless defined(&lblkno);
    eval 'sub fsbtodb {
        my($udf, $blk) = @_;
	    eval q((($blk) <<  ($udf->{udf_l2d_shift})));
    }' unless defined(&fsbtodb);
    eval 'sub MAXNAMLEN () {255;}' unless defined(&MAXNAMLEN);
    eval 'sub UDP_BITMAPS () {0x;}' unless defined(&UDP_BITMAPS);
    eval 'sub UDP_SPACETBLS () {0x1;}' unless defined(&UDP_SPACETBLS);
    eval 'sub UDP_MT_RO () {0x1;}' unless defined(&UDP_MT_RO);
    eval 'sub UDP_MT_WO () {0x2;}' unless defined(&UDP_MT_WO);
    eval 'sub UDP_MT_RW () {0x3;}' unless defined(&UDP_MT_RW);
    eval 'sub UDP_MT_OW () {0x4;}' unless defined(&UDP_MT_OW);
    eval 'sub MAX_SPM () {4;}' unless defined(&MAX_SPM);
    eval 'sub UDM_MAP_NORM () {0x;}' unless defined(&UDM_MAP_NORM);
    eval 'sub UDM_MAP_VPM () {0x1;}' unless defined(&UDM_MAP_VPM);
    eval 'sub UDM_MAP_SPM () {0x2;}' unless defined(&UDM_MAP_SPM);
    unless(defined(&__lint)) {
    }
    eval 'sub UDF_MT_RO () { &UDP_MT_RO;}' unless defined(&UDF_MT_RO);
    eval 'sub UDF_MT_WO () { &UDP_MT_OW;}' unless defined(&UDF_MT_WO);
    eval 'sub UDF_MT_RW () { &UDP_MT_RW;}' unless defined(&UDF_MT_RW);
    eval 'sub UDF_MT_OW () { &UDP_MT_OW;}' unless defined(&UDF_MT_OW);
    eval 'sub UDF_FL_RDONLY () {0x1;}' unless defined(&UDF_FL_RDONLY);
    eval 'sub UDF_FL_RW () {0x2;}' unless defined(&UDF_FL_RW);
    eval 'sub UDF_DIRTY () {0x;}' unless defined(&UDF_DIRTY);
    eval 'sub UDF_CLEAN () {0x1;}' unless defined(&UDF_CLEAN);
    eval 'sub RD_CLUSTSZ {
        my($ip) = @_;
	    eval q((($ip)-> ($i_udf->{udf_rdclustsz})));
    }' unless defined(&RD_CLUSTSZ);
    eval 'sub WR_CLUSTSZ {
        my($ip) = @_;
	    eval q((($ip)-> ($i_udf->{udf_wrclustsz})));
    }' unless defined(&WR_CLUSTSZ);
    if(defined(&UNDEF)) {
	eval 'sub blkroundup {
	    my($fs, $size) = @_;
    	    eval q(((($size) + ($fs)-> &udf_lbsize - 1) & ( &offset_t)($fs)-> &udf_lbmask));
	}' unless defined(&blkroundup);
    }
    eval 'sub blkroundup {
        my($fs, $size) = @_;
	    eval q(((($size) + ($fs)-> &udf_lbmask) & ( &offset_t)(~($fs)-> &udf_lbmask)));
    }' unless defined(&blkroundup);
    eval 'sub blksize {
        my($fs) = @_;
	    eval q(( ($fs->{udf_lbsize})));
    }' unless defined(&blksize);
    eval 'sub VTOI {
        my($VP) = @_;
	    eval q((($VP)-> &v_data));
    }' unless defined(&VTOI);
    eval 'sub ITOV {
        my($IP) = @_;
	    eval q((($IP)-> &i_vnode));
    }' unless defined(&ITOV);
    eval 'sub i_vfs () { ($i_vnode->{v_vfsp});}' unless defined(&i_vfs);
    eval 'sub IB_UN_REC () {0x1;}' unless defined(&IB_UN_REC);
    eval 'sub IB_UN_RE_AL () {0x2;}' unless defined(&IB_UN_RE_AL);
    eval 'sub IB_CON () {0x3;}' unless defined(&IB_CON);
    eval 'sub IB_MASK () {0x3;}' unless defined(&IB_MASK);
    eval 'sub IB_ALLOCATED {
        my($flags) = @_;
	    eval q(((($flags) &  &IB_MASK) !=  &IB_UN_RE_AL));
    }' unless defined(&IB_ALLOCATED);
    eval 'sub EXT_PER_MALLOC () {8;}' unless defined(&EXT_PER_MALLOC);
    unless(defined(&__lint)) {
    }
    eval 'sub IUPD () {0x1;}' unless defined(&IUPD);
    eval 'sub IACC () {0x2;}' unless defined(&IACC);
    eval 'sub IMOD () {0x4;}' unless defined(&IMOD);
    eval 'sub ICHG () {0x8;}' unless defined(&ICHG);
    eval 'sub INOACC () {0x10;}' unless defined(&INOACC);
    eval 'sub IMODTIME () {0x20;}' unless defined(&IMODTIME);
    eval 'sub IREF () {0x40;}' unless defined(&IREF);
    eval 'sub ISYNC () {0x80;}' unless defined(&ISYNC);
    eval 'sub IMODACC () {0x200;}' unless defined(&IMODACC);
    eval 'sub IATTCHG () {0x400;}' unless defined(&IATTCHG);
    eval 'sub IBDWRITE () {0x800;}' unless defined(&IBDWRITE);
    eval 'sub ISUID () { &VSUID;}' unless defined(&ISUID);
    eval 'sub ISGID () { &VSGID;}' unless defined(&ISGID);
    eval 'sub ISVTX () { &VSVTX;}' unless defined(&ISVTX);
    eval 'sub IEXEC () {0x400;}' unless defined(&IEXEC);
    eval 'sub IWRITE () {0x800;}' unless defined(&IWRITE);
    eval 'sub IREAD () {0x1000;}' unless defined(&IREAD);
    eval 'sub IATTR () {0x2000;}' unless defined(&IATTR);
    eval 'sub IDELE () {0x4000;}' unless defined(&IDELE);
    eval 'sub UP_MASK () {0x1ce7;}' unless defined(&UP_MASK);
    eval 'sub VA2UD_PERM {
        my($perm) = @_;
	    eval q(((($perm) & 0x7) | ((($perm) & 0x38) << 2) | ((($perm) & 0x1c0) << 4)));
    }' unless defined(&VA2UD_PERM);
    eval 'sub UD2VA_PERM {
        my($perm) = @_;
	    eval q(((($perm) & 0x7) | ((($perm) & 0xe0) >> 2) | ((($perm) & 0x1c00) >> 4)));
    }' unless defined(&UD2VA_PERM);
    eval 'sub UD_DPERM2UPERM {
        my($dperm) = @_;
	    eval q((((($dperm) >> 4) & 0x1c0) | ((($dperm) >> 2) & 0x38) | (($dperm) & 0x7)));
    }' unless defined(&UD_DPERM2UPERM);
    eval 'sub UD_UPERM2DPERM {
        my($uperm) = @_;
	    eval q((((($uperm) & 0x1c0) << 4) | ((($uperm) & 0x38) << 2) | (($uperm) & 0x7)));
    }' unless defined(&UD_UPERM2DPERM);
    eval 'sub I_SYNC () {1;}' unless defined(&I_SYNC);
    eval 'sub I_DSYNC () {2;}' unless defined(&I_DSYNC);
    eval 'sub I_ASYNC () {0;}' unless defined(&I_ASYNC);
    eval 'sub UD_HASH_SZ () {512;}' unless defined(&UD_HASH_SZ);
    if((((defined(&UD_HASH_SZ) ? &UD_HASH_SZ : 0) & ((defined(&UD_HASH_SZ) ? &UD_HASH_SZ : 0) - 1)) == 0)) {
	eval 'sub UD_INOHASH {
	    my($dev, $bno) = @_;
    	    eval q(( &hash2ints($dev, $bno) &  &UD_HASH_SZ - 1));
	}' unless defined(&UD_INOHASH);
    } else {
	eval 'sub UD_INOHASH {
	    my($dev, $bno) = @_;
    	    eval q(( &hash2ints($dev, $bno) %  &UD_HASH_SZ));
	}' unless defined(&UD_INOHASH);
    }
    eval 'sub IMARK {
        my($ip) = @_;
	    eval q( &ud_imark($ip));
    }' unless defined(&IMARK);
    eval 'sub ITIMES_NOLOCK {
        my($ip) = @_;
	    eval q( &ud_itimes_nolock($ip));
    }' unless defined(&ITIMES_NOLOCK);
    eval 'sub ITIMES {
        my($ip) = @_;
	    eval q({  &mutex_enter(($ip)-> &i_tlock);  &ITIMES_NOLOCK($ip);  &mutex_exit(($ip)-> &i_tlock); });
    }' unless defined(&ITIMES);
    eval 'sub ESAME () {(-1);}' unless defined(&ESAME);
    eval 'sub UDF_HOLE () {( &daddr32_t)-1;}' unless defined(&UDF_HOLE);
    eval 'sub ud_printf {
        my($xyz) = @_;
	    eval q( &if ( &ud_trace) {  &cmn_err( &CE_NOTE, $xyz); });
    }' unless defined(&ud_printf);
    unless(defined(&__lint)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
