require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_UDF_VOLUME_H)) {
    eval 'sub _SYS_FS_UDF_VOLUME_H () {1;}' unless defined(&_SYS_FS_UDF_VOLUME_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub UDF_102 () {0x102;}' unless defined(&UDF_102);
    eval 'sub UDF_150 () {0x150;}' unless defined(&UDF_150);
    eval 'sub UDF_200 () {0x200;}' unless defined(&UDF_200);
    eval 'sub FID_LEN {
        my($fid) = @_;
	    eval q(((($sizeof{\'struct file_id\'} +  &SWAP_16(($fid)-> &fid_iulen) + ($fid)-> &fid_idlen - 2) + 3) & ~3));
    }' unless defined(&FID_LEN);
    eval 'sub F_LEN () {($sizeof{\'struct file_id\'} - 2);}' unless defined(&F_LEN);
    eval 'sub UDF_DOMAIN_NAME () {"*OSTA UDF Compliant\\0\\0\\0\\0";}' unless defined(&UDF_DOMAIN_NAME);
    eval 'sub UDF_LV_INFO () {"*UDF LV Info\\0\\0\\0\\0\\0\\0\\0\\0\\0\\0\\0\\0";}' unless defined(&UDF_LV_INFO);
    eval 'sub UDF_FREEEASPACE () {"*UDF FreeEASpace\\0\\0\\0\\0\\0\\0\\0\\0";}' unless defined(&UDF_FREEEASPACE);
    eval 'sub UDF_FREEAEASPACE () {"*UDF FreeAppEASpace\\0\\0\\0\\0";}' unless defined(&UDF_FREEAEASPACE);
    eval 'sub UDF_CGMS_INFO () {"*UDF DVD CGMS Info\\0\\0\\0\\0";}' unless defined(&UDF_CGMS_INFO);
    eval 'sub UDF_OS2_EA () {"*UDF OS/2 EA\\0\\0\\0\\0\\0\\0\\0\\0\\0\\0\\0";}' unless defined(&UDF_OS2_EA);
    eval 'sub UDF_OS2_EA_LEN () {"*UDF OS/2 EALength\\0\\0\\0\\0\\0\\0";}' unless defined(&UDF_OS2_EA_LEN);
    eval 'sub UDF_MAC_VOLINFO () {"*UDF Mac VolumeInfo\\0\\0\\0\\0";}' unless defined(&UDF_MAC_VOLINFO);
    eval 'sub UDF_MAC_UNIQID () {"*UDF Mac UniqueIDTable\\0";}' unless defined(&UDF_MAC_UNIQID);
    eval 'sub UDF_MAC_RESFRK () {"*UDF Mac ResourceFork\\0\\0";}' unless defined(&UDF_MAC_RESFRK);
    eval 'sub UDF_VIRT_PART () {"*UDF Virtual Partition\\0";}' unless defined(&UDF_VIRT_PART);
    eval 'sub UDF_SPAR_PART () {"*UDF Sparable Partition";}' unless defined(&UDF_SPAR_PART);
    eval 'sub UDF_VAT () {"*UDF Virtual Alloc Tbl\\0";}' unless defined(&UDF_VAT);
    eval 'sub UDF_SPAR_TBL () {"*UDF Sparing Table\\0\\0\\0\\0\\0";}' unless defined(&UDF_SPAR_TBL);
    if(defined( &sparc) || defined( &__sparc)) {
	eval 'sub SWAP_16 {
	    my($a) = @_;
    	    eval q(((( &ushort_t)(($a) & 0xff) << 8) | (( &ushort_t)(($a) & 0xff00) >> 8)));
	}' unless defined(&SWAP_16);
	eval 'sub SWAP_32 {
	    my($a) = @_;
    	    eval q((((($a) & 0xff) << 24) | ((($a) & 0xff00) << 8) | ((($a) & 0xff0000) >> 8) | ((($a) & 0xff000000) >> 24)));
	}' unless defined(&SWAP_32);
	eval 'sub SWAP_64 {
	    my($a) = @_;
    	    eval q((((($a) & 0xff) << 56) | ((($a) & 0xff00) << 40) | ((($a) & 0xff0000) << 24) | ((($a) & 0xff000000) << 8) | ((($a) & 1095216660480) >> 8) | ((($a) & 280375465082880) >> 24) | ((($a) & 7.17761190612173e+16) >> 40) | ((($a) & 1.83746864796716e+19) >> 56)));
	}' unless defined(&SWAP_64);
	eval 'sub GET_32 {
	    my($a) = @_;
    	    eval q((( &uint32_t)(*(( &uint8_t *)$a)) | ((( &uint32_t)(*((( &uint8_t *)$a) + 1))) << 8) | ((( &uint32_t)(*((( &uint8_t *)$a) + 2))) << 16) | ((( &uint32_t)(*((( &uint8_t *)$a) + 3))) << 24)));
	}' unless defined(&GET_32);
    } else {
	eval 'sub SWAP_16 {
	    my($a) = @_;
    	    eval q(($a));
	}' unless defined(&SWAP_16);
	eval 'sub SWAP_32 {
	    my($a) = @_;
    	    eval q(($a));
	}' unless defined(&SWAP_32);
	eval 'sub SWAP_64 {
	    my($a) = @_;
    	    eval q(($a));
	}' unless defined(&SWAP_64);
	eval 'sub GET_32 {
	    my($a) = @_;
    	    eval q((*(( &uint32_t *)$a)));
	}' unless defined(&GET_32);
    }
    eval 'sub BCD2HEX_16 {
        my($a) = @_;
	    eval q(((($a) & 0xf) + ((( &ushort_t)(($a) & 0xf0) >> 4) * 10) + ((( &ushort_t)(($a) & 0xf00) >> 8) * 100) + ((( &ushort_t)(($a) & 0xf000) >> 12) * 1000)));
    }' unless defined(&BCD2HEX_16);
    eval 'sub HEX2BCD_16 {
        my($a) = @_;
	    eval q((((( &ushort_t)$a) % 10) | ((( &ushort_t)(( &ushort_t)($a) / 10) % 10) << 4) | ((( &ushort_t)(( &ushort_t)($a) / 100) % 10) << 8) | ((( &ushort_t)(( &ushort_t)($a) / 1000) % 10) << 12)));
    }' unless defined(&HEX2BCD_16);
    eval 'sub ANCHOR_VOL_DESC_LOC () {(256);}' unless defined(&ANCHOR_VOL_DESC_LOC);
    eval 'sub ANCHOR_VOL_DESC_LEN () {0x200;}' unless defined(&ANCHOR_VOL_DESC_LEN);
    eval 'sub UD_PRI_VOL_DESC () {0x1;}' unless defined(&UD_PRI_VOL_DESC);
    eval 'sub UD_ANCH_VOL_DESC () {0x2;}' unless defined(&UD_ANCH_VOL_DESC);
    eval 'sub UD_VOL_DESC_PTR () {0x3;}' unless defined(&UD_VOL_DESC_PTR);
    eval 'sub UD_IMPL_USE_DESC () {0x4;}' unless defined(&UD_IMPL_USE_DESC);
    eval 'sub UD_PART_DESC () {0x5;}' unless defined(&UD_PART_DESC);
    eval 'sub UD_LOG_VOL_DESC () {0x6;}' unless defined(&UD_LOG_VOL_DESC);
    eval 'sub UD_UNALL_SPA_DESC () {0x7;}' unless defined(&UD_UNALL_SPA_DESC);
    eval 'sub UD_TERM_DESC () {0x8;}' unless defined(&UD_TERM_DESC);
    eval 'sub UD_LOG_VOL_INT () {0x9;}' unless defined(&UD_LOG_VOL_INT);
    eval 'sub UD_FILE_SET_DESC () {0x100;}' unless defined(&UD_FILE_SET_DESC);
    eval 'sub UD_FILE_ID_DESC () {0x101;}' unless defined(&UD_FILE_ID_DESC);
    eval 'sub UD_ALLOC_EXT_DESC () {0x102;}' unless defined(&UD_ALLOC_EXT_DESC);
    eval 'sub UD_INDIRECT_ENT () {0x103;}' unless defined(&UD_INDIRECT_ENT);
    eval 'sub UD_TERMINAL_ENT () {0x104;}' unless defined(&UD_TERMINAL_ENT);
    eval 'sub UD_FILE_ENTRY () {0x105;}' unless defined(&UD_FILE_ENTRY);
    eval 'sub UD_EXT_ATTR_HDR () {0x106;}' unless defined(&UD_EXT_ATTR_HDR);
    eval 'sub UD_UNALL_SPA_ENT () {0x107;}' unless defined(&UD_UNALL_SPA_ENT);
    eval 'sub UD_SPA_BMAP_DESC () {0x108;}' unless defined(&UD_SPA_BMAP_DESC);
    eval 'sub UD_PART_INT_DESC () {0x109;}' unless defined(&UD_PART_INT_DESC);
    eval 'sub UD_EXT_FILE_ENT () {0x10a;}' unless defined(&UD_EXT_FILE_ENT);
    eval 'sub CS_TYPE0 () {0x;}' unless defined(&CS_TYPE0);
    eval 'sub CS_TYPE1 () {0x1;}' unless defined(&CS_TYPE1);
    eval 'sub CS_TYPE2 () {0x2;}' unless defined(&CS_TYPE2);
    eval 'sub CS_TYPE3 () {0x3;}' unless defined(&CS_TYPE3);
    eval 'sub CS_TYPE4 () {0x4;}' unless defined(&CS_TYPE4);
    eval 'sub CS_TYPE5 () {0x5;}' unless defined(&CS_TYPE5);
    eval 'sub CS_TYPE6 () {0x6;}' unless defined(&CS_TYPE6);
    eval 'sub CS_TYPE7 () {0x7;}' unless defined(&CS_TYPE7);
    eval 'sub CS_TYPE8 () {0x8;}' unless defined(&CS_TYPE8);
    eval 'sub EI_FLAG_DIRTY () {0x;}' unless defined(&EI_FLAG_DIRTY);
    eval 'sub EI_FLAG_PROT () {0x1;}' unless defined(&EI_FLAG_PROT);
    eval 'sub lba_number {
        my($x) = @_;
	    eval q(((($x)-> $lba_aaa[0]) | (($x)-> $lba_aaa[1] << 8) | (($x)-> $lba_aaa[2] << 16) | (($x)-> $lba_aaa[3] << 24)));
    }' unless defined(&lba_number);
    eval 'sub lba_prn {
        my($x) = @_;
	    eval q((($x)-> $lba_aaa[4] | (($x)-> $lba_aaa[5] << 8)));
    }' unless defined(&lba_prn);
    eval 'sub TMODE () {0xf000;}' unless defined(&TMODE);
    eval 'sub TSIGN () {0x800;}' unless defined(&TSIGN);
    eval 'sub TOFFSET () {0x7ff;}' unless defined(&TOFFSET);
    eval 'sub TINVALID () {( &TSIGN| &TOFFSET);}' unless defined(&TINVALID);
    eval 'sub STRAT_TYPE1 () {0x1;}' unless defined(&STRAT_TYPE1);
    eval 'sub STRAT_TYPE2 () {0x2;}' unless defined(&STRAT_TYPE2);
    eval 'sub STRAT_TYPE3 () {0x3;}' unless defined(&STRAT_TYPE3);
    eval 'sub STRAT_TYPE4 () {0x4;}' unless defined(&STRAT_TYPE4);
    eval 'sub STRAT_TYPE4096 () {0x1000;}' unless defined(&STRAT_TYPE4096);
    eval 'sub FTYPE_UNALL_SPACE () {0x1;}' unless defined(&FTYPE_UNALL_SPACE);
    eval 'sub FTYPE_PART_INTEG () {0x2;}' unless defined(&FTYPE_PART_INTEG);
    eval 'sub FTYPE_INDIRECT () {0x3;}' unless defined(&FTYPE_INDIRECT);
    eval 'sub FTYPE_DIRECTORY () {0x4;}' unless defined(&FTYPE_DIRECTORY);
    eval 'sub FTYPE_FILE () {0x5;}' unless defined(&FTYPE_FILE);
    eval 'sub FTYPE_BLOCK_DEV () {0x6;}' unless defined(&FTYPE_BLOCK_DEV);
    eval 'sub FTYPE_CHAR_DEV () {0x7;}' unless defined(&FTYPE_CHAR_DEV);
    eval 'sub FTYPE_EAR () {0x8;}' unless defined(&FTYPE_EAR);
    eval 'sub FTYPE_FIFO () {0x9;}' unless defined(&FTYPE_FIFO);
    eval 'sub FTYPE_C_ISSOCK () {0xa;}' unless defined(&FTYPE_C_ISSOCK);
    eval 'sub FTYPE_T_ENTRY () {0xb;}' unless defined(&FTYPE_T_ENTRY);
    eval 'sub FTYPE_SYMLINK () {0xc;}' unless defined(&FTYPE_SYMLINK);
    eval 'sub ICB_FLAG_SHORT_AD () {0x;}' unless defined(&ICB_FLAG_SHORT_AD);
    eval 'sub ICB_FLAG_LONG_AD () {0x1;}' unless defined(&ICB_FLAG_LONG_AD);
    eval 'sub ICB_FLAG_EXT_AD () {0x2;}' unless defined(&ICB_FLAG_EXT_AD);
    eval 'sub ICB_FLAG_ONE_AD () {0x3;}' unless defined(&ICB_FLAG_ONE_AD);
    eval 'sub ICB_FLAG_SORTED () {0x8;}' unless defined(&ICB_FLAG_SORTED);
    eval 'sub ICB_FLAG_NON_RELOC () {0x10;}' unless defined(&ICB_FLAG_NON_RELOC);
    eval 'sub ICB_FLAG_ARCHIVE () {0x20;}' unless defined(&ICB_FLAG_ARCHIVE);
    eval 'sub ICB_FLAG_SETUID () {0x40;}' unless defined(&ICB_FLAG_SETUID);
    eval 'sub ICB_FLAG_SETGID () {0x80;}' unless defined(&ICB_FLAG_SETGID);
    eval 'sub ICB_FLAG_STICKY () {0x100;}' unless defined(&ICB_FLAG_STICKY);
    eval 'sub ICB_FLAG_CONTIG () {0x200;}' unless defined(&ICB_FLAG_CONTIG);
    eval 'sub ICB_FLAG_SYSTEM () {0x400;}' unless defined(&ICB_FLAG_SYSTEM);
    eval 'sub ICB_FLAG_TRNSFRMED () {0x800;}' unless defined(&ICB_FLAG_TRNSFRMED);
    eval 'sub ICB_FLAG_MVERS () {0x1000;}' unless defined(&ICB_FLAG_MVERS);
    eval 'sub PART_ACC_RO () {0x1;}' unless defined(&PART_ACC_RO);
    eval 'sub PART_ACC_WO () {0x2;}' unless defined(&PART_ACC_WO);
    eval 'sub PART_ACC_RW () {0x3;}' unless defined(&PART_ACC_RW);
    eval 'sub PART_ACC_OW () {0x4;}' unless defined(&PART_ACC_OW);
    eval 'sub lvid_uniqid () { ($lvid_lvcu->{lvhd_uniqid});}' unless defined(&lvid_uniqid);
    eval 'sub LOG_VOL_OPEN_INT () {0x;}' unless defined(&LOG_VOL_OPEN_INT);
    eval 'sub LOG_VOL_CLOSE_INT () {0x1;}' unless defined(&LOG_VOL_CLOSE_INT);
    eval 'sub FID_EXIST () {0x1;}' unless defined(&FID_EXIST);
    eval 'sub FID_DIR () {0x2;}' unless defined(&FID_DIR);
    eval 'sub FID_DELETED () {0x4;}' unless defined(&FID_DELETED);
    eval 'sub FID_PARENT () {0x8;}' unless defined(&FID_PARENT);
    eval 'sub PART_OPEN_INT () {0x;}' unless defined(&PART_OPEN_INT);
    eval 'sub PART_CLOSE_INT () {0x1;}' unless defined(&PART_CLOSE_INT);
    eval 'sub PART_STABLE_INT () {0x2;}' unless defined(&PART_STABLE_INT);
    eval 'sub FT_EXIST () {0x;}' unless defined(&FT_EXIST);
    eval 'sub FT_DELETE () {0x2;}' unless defined(&FT_DELETE);
    eval 'sub FT_FEDT () {0x3;}' unless defined(&FT_FEDT);
    eval 'sub FT_BACKUP () {0x5;}' unless defined(&FT_BACKUP);
    eval 'sub COPY_PROTECTED () {0x80;}' unless defined(&COPY_PROTECTED);
    eval 'sub MAP_TYPE1 () {1;}' unless defined(&MAP_TYPE1);
    eval 'sub MAP_TYPE2 () {2;}' unless defined(&MAP_TYPE2);
    eval 'sub MAP_TYPE1_LEN () {6;}' unless defined(&MAP_TYPE1_LEN);
    eval 'sub MAP_TYPE2_LEN () {64;}' unless defined(&MAP_TYPE2_LEN);
    if(defined(&__cplusplus)) {
    }
}
1;
