require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FSSNAP_H)) {
    eval 'sub _SYS_FSSNAP_H () {1;}' unless defined(&_SYS_FSSNAP_H);
    require 'sys/sysmacros.ph';
    require 'sys/devops.ph';
    if(defined(&__cplusplus)) {
    }
    require 'sys/buf.ph';
    require 'sys/taskq.ph';
    require 'sys/fs/ufs_inode.ph';
    if(defined( &_KERNEL)) {
	eval 'sub FSSNAP_TASKQ_THREADS () {(2);}' unless defined(&FSSNAP_TASKQ_THREADS);
	eval 'sub FSSNAP_MAX_MEM_CHUNKS () {(32);}' unless defined(&FSSNAP_MAX_MEM_CHUNKS);
	eval 'sub FSSNAP_TASKQ_MAXTASKS () {( &FSSNAP_MAX_MEM_CHUNKS);}' unless defined(&FSSNAP_TASKQ_MAXTASKS);
	eval 'sub dbtocowchunk {
	    my($cmap, $dblkno) = @_;
    	    eval q((($dblkno) / (($cmap)-> &cmap_chunksz >>  &DEV_BSHIFT)));
	}' unless defined(&dbtocowchunk);
	eval 'sub cowchunktodb {
	    my($cmap, $cowchunk) = @_;
    	    eval q((($cowchunk) * (($cmap)-> &cmap_chunksz >>  &DEV_BSHIFT)));
	}' unless defined(&cowchunktodb);
	eval 'sub SID_DISABLED () {(0x1);}' unless defined(&SID_DISABLED);
	eval 'sub SID_DISABLING () {(0x2);}' unless defined(&SID_DISABLING);
	eval 'sub SID_BLOCK_BUSY () {(0x4);}' unless defined(&SID_BLOCK_BUSY);
	eval 'sub SID_CHAR_BUSY () {(0x8);}' unless defined(&SID_CHAR_BUSY);
	eval 'sub SID_CREATING () {(0x10);}' unless defined(&SID_CREATING);
	eval 'sub SID_DELETE () {(0x20);}' unless defined(&SID_DELETE);
	eval 'sub SID_BUSY {
	    my($sidp) = @_;
    	    eval q(((($sidp)-> &sid_flags &  &SID_BLOCK_BUSY) || (($sidp)-> &sid_flags &  &SID_CHAR_BUSY)));
	}' unless defined(&SID_BUSY);
	eval 'sub SID_INACTIVE {
	    my($sidp) = @_;
    	    eval q(((($sidp)-> &sid_flags &  &SID_DISABLED) || (($sidp)-> &sid_flags &  &SID_DISABLING) || (($sidp)-> &sid_flags &  &SID_CREATING) || (($sidp)-> &sid_flags &  &SID_DELETE) || (($sidp)-> &sid_cowinfo ==  &NULL)));
	}' unless defined(&SID_INACTIVE);
	eval 'sub SID_AVAILABLE {
	    my($sidp) = @_;
    	    eval q((! &SID_BUSY($sidp)  && (($sidp)-> &sid_flags &  &SID_DISABLED)));
	}' unless defined(&SID_AVAILABLE);
	eval 'sub COWSTATE_CREATING () {(0);}' unless defined(&COWSTATE_CREATING);
	eval 'sub COWSTATE_IDLE () {(1);}' unless defined(&COWSTATE_IDLE);
	eval 'sub COWSTATE_ACTIVE () {(2);}' unless defined(&COWSTATE_ACTIVE);
	eval 'sub COWSTATE_DISABLED () {(3);}' unless defined(&COWSTATE_DISABLED);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
