require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FTRACE_H)) {
    eval 'sub _SYS_FTRACE_H () {1;}' unless defined(&_SYS_FTRACE_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub FTRACE_READY () {0x1;}' unless defined(&FTRACE_READY);
    eval 'sub FTRACE_ENABLED () {0x2;}' unless defined(&FTRACE_ENABLED);
    if(!defined( &_ASM)) {
	require 'sys/thread.ph';
	require 'sys/cpuvar.ph';
	require 'sys/types.ph';
	if(defined(&_LP64)) {
	}
	eval 'sub FTRACE_NENT () {1024;}' unless defined(&FTRACE_NENT);
	if(defined(&_KERNEL)) {
	    eval 'sub FTRACE_0 {
	        my($fmt) = @_;
    		eval q({  &if ( ($CPU->{cpu_ftrace}->{ftd_state}) &  &FTRACE_ENABLED)  &ftrace_0($fmt); });
	    }' unless defined(&FTRACE_0);
	    eval 'sub FTRACE_1 {
	        my($fmt, $d1) = @_;
    		eval q({  &if ( ($CPU->{cpu_ftrace}->{ftd_state}) &  &FTRACE_ENABLED)  &ftrace_1($fmt, $d1); });
	    }' unless defined(&FTRACE_1);
	    eval 'sub FTRACE_2 {
	        my($fmt, $d1, $d2) = @_;
    		eval q({  &if ( ($CPU->{cpu_ftrace}->{ftd_state}) &  &FTRACE_ENABLED)  &ftrace_2($fmt, $d1, $d2); });
	    }' unless defined(&FTRACE_2);
	    eval 'sub FTRACE_3 {
	        my($fmt, $d1, $d2, $d3) = @_;
    		eval q({  &if ( ($CPU->{cpu_ftrace}->{ftd_state}) &  &FTRACE_ENABLED)  &ftrace_3($fmt, $d1, $d2, $d3); });
	    }' unless defined(&FTRACE_3);
	    eval 'sub FTRACE_START () {
	        eval q( &ftrace_start());
	    }' unless defined(&FTRACE_START);
	    eval 'sub FTRACE_STOP () {
	        eval q( &ftrace_stop());
	    }' unless defined(&FTRACE_STOP);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
