require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_GLDPRIV_H)) {
    eval 'sub _SYS_GLDPRIV_H () {1;}' unless defined(&_SYS_GLDPRIV_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&DEBUG)) {
	eval 'sub GLD_DEBUG () {1;}' unless defined(&GLD_DEBUG);
    }
    eval 'sub GLD_VERSION_200 () {0x200;}' unless defined(&GLD_VERSION_200);
    eval 'sub GLD_VERSION () { &GLD_VERSION_200;}' unless defined(&GLD_VERSION);
    eval 'sub GLD_VERSION_STRING () {"v2";}' unless defined(&GLD_VERSION_STRING);
    eval 'sub GLD_OPT_NO_IPQ () {0x1;}' unless defined(&GLD_OPT_NO_IPQ);
    eval 'sub GLD_OPT_NO_FASTPATH () {0x2;}' unless defined(&GLD_OPT_NO_FASTPATH);
    eval 'sub GLD_OPT_NO_ETHRXSNAP () {0x8;}' unless defined(&GLD_OPT_NO_ETHRXSNAP);
    eval 'sub GLD_OPT_OLD_PPA_STYLE () {0x10;}' unless defined(&GLD_OPT_OLD_PPA_STYLE);
    eval 'sub GLD_PPA_INIT () {0x1000;}' unless defined(&GLD_PPA_INIT);
    eval 'sub GLD_MAXMIN () {0x3ffff;}' unless defined(&GLD_MAXMIN);
    eval 'sub GLD_USE_STYLE2 () {0;}' unless defined(&GLD_USE_STYLE2);
    eval 'sub GLD_RAW () {0x1;}' unless defined(&GLD_RAW);
    eval 'sub GLD_FAST () {0x2;}' unless defined(&GLD_FAST);
    eval 'sub GLD_PROM_PHYS () {0x4;}' unless defined(&GLD_PROM_PHYS);
    eval 'sub GLD_PROM_SAP () {0x8;}' unless defined(&GLD_PROM_SAP);
    eval 'sub GLD_PROM_MULT () {0x10;}' unless defined(&GLD_PROM_MULT);
    eval 'sub GLD_STR_CLOSING () {0x20;}' unless defined(&GLD_STR_CLOSING);
    eval 'sub IF_HDR_FIXED () {0;}' unless defined(&IF_HDR_FIXED);
    eval 'sub IF_HDR_VAR () {1;}' unless defined(&IF_HDR_VAR);
    eval 'sub GLDE_OK () {(-1);}' unless defined(&GLDE_OK);
    eval 'sub GLDE_RETRY () {0x1002;}' unless defined(&GLDE_RETRY);
    eval 'sub GLD_802_SAP () {1500;}' unless defined(&GLD_802_SAP);
    eval 'sub GLD_MAX_802_SAP () {0xff;}' unless defined(&GLD_MAX_802_SAP);
    eval 'sub GLD_SPECIAL_SAP () {0x10000;}' unless defined(&GLD_SPECIAL_SAP);
    eval 'sub GLD_LOCK () {0;}' unless defined(&GLD_LOCK);
    eval 'sub GLD_TRYLOCK () {1;}' unless defined(&GLD_TRYLOCK);
    eval 'sub GLD_HAVELOCK () {2;}' unless defined(&GLD_HAVELOCK);
    eval 'sub GLD_DONTLOCK () {3;}' unless defined(&GLD_DONTLOCK);
    eval 'sub mac_eq {
        my($a, $b, $l) = @_;
	    eval q(( &bcmp(, ($b), ($l)) == 0));
    }' unless defined(&mac_eq);
    eval 'sub mac_copy {
        my($a, $b, $l) = @_;
	    eval q(( &bcopy(, ($b), ($l))));
    }' unless defined(&mac_copy);
    eval 'sub cmac_copy {
        my($a, $b, $l, $macinfo) = @_;
	    eval q({  &if (-> &gldm_options &  &GLDOPT_CANONICAL_ADDR)  &gld_bitrevcopy(, ($b), ($l));  &else  &mac_copy(($a), ($b), ($l)); });
    }' unless defined(&cmac_copy);
    if(((defined(&_ALIGNMENT_REQUIRED) ? &_ALIGNMENT_REQUIRED : 0) == 0)) {
	eval 'sub REF_HOST_USHORT {
	    my($lvalue) = @_;
    	    eval q(($lvalue));
	}' unless defined(&REF_HOST_USHORT);
	eval 'sub REF_NET_USHORT {
	    my($lvalue) = @_;
    	    eval q(( &ntohs($lvalue)));
	}' unless defined(&REF_NET_USHORT);
	eval 'sub SET_NET_USHORT {
	    my($lvalue, $val) = @_;
    	    eval q((($lvalue) =  &htons($val)));
	}' unless defined(&SET_NET_USHORT);
    } else {
	eval 'sub REF_NET_USHORT {
	    my($lvalue) = @_;
    	    eval q((( &ushort_t)(((( &uchar_t *)(($lvalue)))[0]<<8) | (( &uchar_t *)(($lvalue)))[1])));
	}' unless defined(&REF_NET_USHORT);
	eval 'sub SET_NET_USHORT {
	    my($lvalue, $val) = @_;
    	    eval q({ (( &uchar_t *)(($lvalue)))[0] = ( &uchar_t)(($val)>>8); (( &uchar_t *)(($lvalue)))[1] = ( &uchar_t)($val); });
	}' unless defined(&SET_NET_USHORT);
	if(defined( &_LITTLE_ENDIAN)) {
	    eval 'sub REF_HOST_USHORT {
	        my($lvalue) = @_;
    		eval q((( &ushort_t)(((( &uchar_t *)(($lvalue)))[1]<<8) | (( &uchar_t *)(($lvalue)))[0])));
	    }' unless defined(&REF_HOST_USHORT);
	}
 elsif(defined( &_BIG_ENDIAN)) {
	    eval 'sub REF_HOST_USHORT {
	        my($lvalue) = @_;
    		eval q((( &ushort_t)(((( &uchar_t *)(($lvalue)))[0]<<8) | (( &uchar_t *)(($lvalue)))[1])));
	    }' unless defined(&REF_HOST_USHORT);
	} else {
	    die("what endian is this machine?");
	}
    }
    eval 'sub LSAP_RDE () {0xa6;}' unless defined(&LSAP_RDE);
    eval 'sub RDE_RQC () {0x1;}' unless defined(&RDE_RQC);
    eval 'sub RDE_RQR () {0x2;}' unless defined(&RDE_RQR);
    eval 'sub RDE_RS () {0x3;}' unless defined(&RDE_RS);
    eval 'sub MAX_RDFLDS () {14;}' unless defined(&MAX_RDFLDS);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("which way do bit fields get allocated?");
    }
    eval 'sub RT_SRF () {0x;}' unless defined(&RT_SRF);
    eval 'sub RT_ARE () {0x4;}' unless defined(&RT_ARE);
    eval 'sub RT_STE () {0x6;}' unless defined(&RT_STE);
    eval 'sub RT_MTU_MAX () {0x7;}' unless defined(&RT_MTU_MAX);
    eval 'sub SR_HASH_SIZE () {256;}' unless defined(&SR_HASH_SIZE);
    eval 'sub DLSAP {
        my($p, $offset) = @_;
	    eval q(((($p)+$offset)));
    }' unless defined(&DLSAP);
    eval 'sub LLC_HDR1_LEN () {3;}' unless defined(&LLC_HDR1_LEN);
    eval 'sub LLC_SNAP_HDR_LEN () {8;}' unless defined(&LLC_SNAP_HDR_LEN);
    eval 'sub LSAP_SNAP () {0xaa;}' unless defined(&LSAP_SNAP);
    eval 'sub CNTL_LLC_UI () {0x3;}' unless defined(&CNTL_LLC_UI);
    if(defined(&__cplusplus)) {
    }
}
1;
