require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_HME_MAC_H)) {
    eval 'sub _SYS_HME_MAC_H () {1;}' unless defined(&_SYS_HME_MAC_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub HME_HMDALIGN () {(2048);}' unless defined(&HME_HMDALIGN);
    eval 'sub HME_TMDMAX () {(256);}' unless defined(&HME_TMDMAX);
    eval 'sub HME_RMDMAX () {(256);}' unless defined(&HME_RMDMAX);
    eval 'sub HMETMD_BUFSIZE () {(0x3fff << 0);}' unless defined(&HMETMD_BUFSIZE);
    eval 'sub HMETMD_CSSTART () {(0x3f << 14);}' unless defined(&HMETMD_CSSTART);
    eval 'sub HMETMD_CSSTUFF () {(0xff << 20);}' unless defined(&HMETMD_CSSTUFF);
    eval 'sub HMETMD_CSENABL () {(1<< 28);}' unless defined(&HMETMD_CSENABL);
    eval 'sub HMETMD_EOP () {(1<< 29);}' unless defined(&HMETMD_EOP);
    eval 'sub HMETMD_SOP () {(1<< 30);}' unless defined(&HMETMD_SOP);
    eval 'sub HMETMD_OWN () {(0x80000000);}' unless defined(&HMETMD_OWN);
    eval 'sub HMETMD_CSSTART_SHIFT () {14;}' unless defined(&HMETMD_CSSTART_SHIFT);
    eval 'sub HMETMD_CSSTUFF_SHIFT () {20;}' unless defined(&HMETMD_CSSTUFF_SHIFT);
    eval 'sub HMERMD_CKSUM () {(0xffff << 0);}' unless defined(&HMERMD_CKSUM);
    eval 'sub HMERMD_BUFSIZE () {(0x3fff << 16);}' unless defined(&HMERMD_BUFSIZE);
    eval 'sub HMERMD_OVFLOW () {(1<< 30);}' unless defined(&HMERMD_OVFLOW);
    eval 'sub HMERMD_OWN () {(0x80000000);}' unless defined(&HMERMD_OWN);
    eval 'sub HMERMD_BUFSIZE_SHIFT () {16;}' unless defined(&HMERMD_BUFSIZE_SHIFT);
    eval 'sub HME_RMD_BUFALIGN () {64;}' unless defined(&HME_RMD_BUFALIGN);
    eval 'sub HMEG_RESET_ETX () {(1<< 0);}' unless defined(&HMEG_RESET_ETX);
    eval 'sub HMEG_RESET_ERX () {(1<< 1);}' unless defined(&HMEG_RESET_ERX);
    eval 'sub HMEG_RESET_GLOBAL () { &HMEG_RESET_ETX |  &HMEG_RESET_ERX;}' unless defined(&HMEG_RESET_GLOBAL);
    eval 'sub HMEG_CONFIG_BURSTSZ () {(0x3 << 0);}' unless defined(&HMEG_CONFIG_BURSTSZ);
    eval 'sub HMEG_CONFIG_64BIT_XFER () {(1<< 2);}' unless defined(&HMEG_CONFIG_64BIT_XFER);
    eval 'sub HMEG_CONFIG_PARITY () {(1<< 3);}' unless defined(&HMEG_CONFIG_PARITY);
    eval 'sub HMEG_CONFIG_RES1 () {(1<< 4);}' unless defined(&HMEG_CONFIG_RES1);
    eval 'sub HMEG_CONFIG_BURST16 () {0x;}' unless defined(&HMEG_CONFIG_BURST16);
    eval 'sub HMEG_CONFIG_BURST32 () {0x1;}' unless defined(&HMEG_CONFIG_BURST32);
    eval 'sub HMEG_CONFIG_BURST64 () {0x2;}' unless defined(&HMEG_CONFIG_BURST64);
    eval 'sub HMEG_CONFIG_BURST_RES () {0x3;}' unless defined(&HMEG_CONFIG_BURST_RES);
    eval 'sub HMEG_CONFIG_64BIT_SHIFT () {2;}' unless defined(&HMEG_CONFIG_64BIT_SHIFT);
    eval 'sub HMEG_STATUS_FRAME_RCVD () {(1<< 0);}' unless defined(&HMEG_STATUS_FRAME_RCVD);
    eval 'sub HMEG_STATUS_RXF_CNT_EXP () {(1<< 1);}' unless defined(&HMEG_STATUS_RXF_CNT_EXP);
    eval 'sub HMEG_STATUS_ALN_CNT_EXP () {(1<< 2);}' unless defined(&HMEG_STATUS_ALN_CNT_EXP);
    eval 'sub HMEG_STATUS_CRC_CNT_EXP () {(1<< 3);}' unless defined(&HMEG_STATUS_CRC_CNT_EXP);
    eval 'sub HMEG_STATUS_LEN_CNT_EXP () {(1<< 4);}' unless defined(&HMEG_STATUS_LEN_CNT_EXP);
    eval 'sub HMEG_STATUS_RXFIFO_OVFL () {(1<< 5);}' unless defined(&HMEG_STATUS_RXFIFO_OVFL);
    eval 'sub HMEG_STATUS_RCV_CNT_EXP () {(1<< 6);}' unless defined(&HMEG_STATUS_RCV_CNT_EXP);
    eval 'sub HMEG_STATUS_SQE_TST_ERR () {(1<< 7);}' unless defined(&HMEG_STATUS_SQE_TST_ERR);
    eval 'sub HMEG_STATUS_FRAME_SENT () {(1<< 8);}' unless defined(&HMEG_STATUS_FRAME_SENT);
    eval 'sub HMEG_STATUS_TXFIFO_UNDR () {(1<< 9);}' unless defined(&HMEG_STATUS_TXFIFO_UNDR);
    eval 'sub HMEG_STATUS_MXPKTSZ_ERR () {(1<< 10);}' unless defined(&HMEG_STATUS_MXPKTSZ_ERR);
    eval 'sub HMEG_STATUS_NRMCOLC_EXP () {(1<< 11);}' unless defined(&HMEG_STATUS_NRMCOLC_EXP);
    eval 'sub HMEG_STATUS_EXCOLC_EXP () {(1<< 12);}' unless defined(&HMEG_STATUS_EXCOLC_EXP);
    eval 'sub HMEG_STATUS_LATCOLC_EXP () {(1<< 13);}' unless defined(&HMEG_STATUS_LATCOLC_EXP);
    eval 'sub HMEG_STATUS_FSTCOLC_EXP () {(1<< 14);}' unless defined(&HMEG_STATUS_FSTCOLC_EXP);
    eval 'sub HMEG_STATUS_DEFTIMR_EXP () {(1<< 15);}' unless defined(&HMEG_STATUS_DEFTIMR_EXP);
    eval 'sub HMEG_STATUS_RINT () {(1<< 16);}' unless defined(&HMEG_STATUS_RINT);
    eval 'sub HMEG_STATUS_RX_DROP () {(1<< 17);}' unless defined(&HMEG_STATUS_RX_DROP);
    eval 'sub HMEG_STATUS_RX_ERR_ACK () {(1<< 18);}' unless defined(&HMEG_STATUS_RX_ERR_ACK);
    eval 'sub HMEG_STATUS_RX_LATE_ERR () {(1<< 19);}' unless defined(&HMEG_STATUS_RX_LATE_ERR);
    eval 'sub HMEG_STATUS_RX_PAR_ERR () {(1<< 20);}' unless defined(&HMEG_STATUS_RX_PAR_ERR);
    eval 'sub HMEG_STATUS_RX_TAG_ERR () {(1<< 21);}' unless defined(&HMEG_STATUS_RX_TAG_ERR);
    eval 'sub HMEG_STATUS_EOP_ERR () {(1<< 22);}' unless defined(&HMEG_STATUS_EOP_ERR);
    eval 'sub HMEG_STATUS_MIF_INTR () {(1<< 23);}' unless defined(&HMEG_STATUS_MIF_INTR);
    eval 'sub HMEG_STATUS_TINT () {(1<< 24);}' unless defined(&HMEG_STATUS_TINT);
    eval 'sub HMEG_STATUS_TX_ALL () {(1<< 25);}' unless defined(&HMEG_STATUS_TX_ALL);
    eval 'sub HMEG_STATUS_TX_ERR_ACK () {(1<< 26);}' unless defined(&HMEG_STATUS_TX_ERR_ACK);
    eval 'sub HMEG_STATUS_TX_LATE_ERR () {(1<< 27);}' unless defined(&HMEG_STATUS_TX_LATE_ERR);
    eval 'sub HMEG_STATUS_TX_PAR_ERR () {(1<< 28);}' unless defined(&HMEG_STATUS_TX_PAR_ERR);
    eval 'sub HMEG_STATUS_TX_TAG_ERR () {(1<< 29);}' unless defined(&HMEG_STATUS_TX_TAG_ERR);
    eval 'sub HMEG_STATUS_SLV_ERR_ACK () {(1<< 30);}' unless defined(&HMEG_STATUS_SLV_ERR_ACK);
    eval 'sub HMEG_STATUS_SLV_PAR_ERR () {(0x80000000);}' unless defined(&HMEG_STATUS_SLV_PAR_ERR);
    eval 'sub HMEG_STATUS_FATAL_ERR () {0xfc7c0000;}' unless defined(&HMEG_STATUS_FATAL_ERR);
    eval 'sub HMEG_STATUS_NONFATAL_ERR () {0x2fefc;}' unless defined(&HMEG_STATUS_NONFATAL_ERR);
    eval 'sub HMEG_STATUS_NORMAL_INT () {0x1810000;}' unless defined(&HMEG_STATUS_NORMAL_INT);
    eval 'sub HMEG_STATUS_INTR () {0xfefffefc;}' unless defined(&HMEG_STATUS_INTR);
    eval 'sub HMEG_MASK_FRAME_RCVD () {(1<< 0);}' unless defined(&HMEG_MASK_FRAME_RCVD);
    eval 'sub HMEG_MASK_RXF_CNT_EXP () {(1<< 1);}' unless defined(&HMEG_MASK_RXF_CNT_EXP);
    eval 'sub HMEG_MASK_ALN_CNT_EXP () {(1<< 2);}' unless defined(&HMEG_MASK_ALN_CNT_EXP);
    eval 'sub HMEG_MASK_CRC_CNT_EXP () {(1<< 3);}' unless defined(&HMEG_MASK_CRC_CNT_EXP);
    eval 'sub HMEG_MASK_LEN_CNT_EXP () {(1<< 4);}' unless defined(&HMEG_MASK_LEN_CNT_EXP);
    eval 'sub HMEG_MASK_RXFIFO_OVFL () {(1<< 5);}' unless defined(&HMEG_MASK_RXFIFO_OVFL);
    eval 'sub HMEG_MASK_RCV_CNT_EXP () {(1<< 6);}' unless defined(&HMEG_MASK_RCV_CNT_EXP);
    eval 'sub HMEG_MASK_SQE_TST_ERR () {(1<< 7);}' unless defined(&HMEG_MASK_SQE_TST_ERR);
    eval 'sub HMEG_MASK_FRAME_SENT () {(1<< 8);}' unless defined(&HMEG_MASK_FRAME_SENT);
    eval 'sub HMEG_MASK_TXFIFO_UNDR () {(1<< 9);}' unless defined(&HMEG_MASK_TXFIFO_UNDR);
    eval 'sub HMEG_MASK_MXPKTSZ_ERR () {(1<< 10);}' unless defined(&HMEG_MASK_MXPKTSZ_ERR);
    eval 'sub HMEG_MASK_NRMCOLC_EXP () {(1<< 11);}' unless defined(&HMEG_MASK_NRMCOLC_EXP);
    eval 'sub HMEG_MASK_EXECOLC_EXP () {(1<< 12);}' unless defined(&HMEG_MASK_EXECOLC_EXP);
    eval 'sub HMEG_MASK_LATCOLC_EXP () {(1<< 13);}' unless defined(&HMEG_MASK_LATCOLC_EXP);
    eval 'sub HMEG_MASK_FSTCOLC_EXP () {(1<< 14);}' unless defined(&HMEG_MASK_FSTCOLC_EXP);
    eval 'sub HMEG_MASK_DEFTIMR_EXP () {(1<< 15);}' unless defined(&HMEG_MASK_DEFTIMR_EXP);
    eval 'sub HMEG_MASK_RINT () {(1<< 16);}' unless defined(&HMEG_MASK_RINT);
    eval 'sub HMEG_MASK_RX_DROP () {(1<< 17);}' unless defined(&HMEG_MASK_RX_DROP);
    eval 'sub HMEG_MASK_RX_ERR_ACK () {(1<< 18);}' unless defined(&HMEG_MASK_RX_ERR_ACK);
    eval 'sub HMEG_MASK_RX_LATE_ERR () {(1<< 19);}' unless defined(&HMEG_MASK_RX_LATE_ERR);
    eval 'sub HMEG_MASK_RX_PAR_ERR () {(1<< 20);}' unless defined(&HMEG_MASK_RX_PAR_ERR);
    eval 'sub HMEG_MASK_RX_TAG_ERR () {(1<< 21);}' unless defined(&HMEG_MASK_RX_TAG_ERR);
    eval 'sub HMEG_MASK_EOP_ERR () {(1<< 22);}' unless defined(&HMEG_MASK_EOP_ERR);
    eval 'sub HMEG_MASK_MIF_INTR () {(1<< 23);}' unless defined(&HMEG_MASK_MIF_INTR);
    eval 'sub HMEG_MASK_TINT () {(1<< 24);}' unless defined(&HMEG_MASK_TINT);
    eval 'sub HMEG_MASK_TX_ALL () {(1<< 25);}' unless defined(&HMEG_MASK_TX_ALL);
    eval 'sub HMEG_MASK_TX_ERR_ACK () {(1<< 26);}' unless defined(&HMEG_MASK_TX_ERR_ACK);
    eval 'sub HMEG_MASK_TX_LATE_ERR () {(1<< 27);}' unless defined(&HMEG_MASK_TX_LATE_ERR);
    eval 'sub HMEG_MASK_TX_PAR_ERR () {(1<< 28);}' unless defined(&HMEG_MASK_TX_PAR_ERR);
    eval 'sub HMEG_MASK_TX_TAG_ERR () {(1<< 29);}' unless defined(&HMEG_MASK_TX_TAG_ERR);
    eval 'sub HMEG_MASK_SLV_ERR_ACK () {(1<< 30);}' unless defined(&HMEG_MASK_SLV_ERR_ACK);
    eval 'sub HMEG_MASK_SLV_PAR_ERR () {(0x80000000);}' unless defined(&HMEG_MASK_SLV_PAR_ERR);
    eval 'sub HMEG_MASK_INTR () {(~ &HMEG_STATUS_INTR);}' unless defined(&HMEG_MASK_INTR);
    eval 'sub HMET_TXPEND_TDMD () {(1<< 0);}' unless defined(&HMET_TXPEND_TDMD);
    eval 'sub HMET_CONFIG_TXDMA_EN () {(1<< 0);}' unless defined(&HMET_CONFIG_TXDMA_EN);
    eval 'sub HMET_CONFIG_TXFIFOTH () {(0x1ff << 1);}' unless defined(&HMET_CONFIG_TXFIFOTH);
    eval 'sub HMET_CONFIG_DRAIN_INT () {(1<< 10);}' unless defined(&HMET_CONFIG_DRAIN_INT);
    eval 'sub HMET_RINGSZ_SHIFT () {4;}' unless defined(&HMET_RINGSZ_SHIFT);
    eval 'sub HMER_CONFIG_RXDMA_EN () {(1<< 0);}' unless defined(&HMER_CONFIG_RXDMA_EN);
    eval 'sub HMER_CONFIG_RES1 () {(0x3 << 1);}' unless defined(&HMER_CONFIG_RES1);
    eval 'sub HMER_CONFIG_FBOFFSET () {(0x7 << 3);}' unless defined(&HMER_CONFIG_FBOFFSET);
    eval 'sub HMER_CONFIG_RES2 () {(0x7 << 6);}' unless defined(&HMER_CONFIG_RES2);
    eval 'sub HMER_CONFIG_RXRINGSZ () {(0x3 << 9);}' unless defined(&HMER_CONFIG_RXRINGSZ);
    eval 'sub HMER_CONFIG_RES3 () {(0x1f << 11);}' unless defined(&HMER_CONFIG_RES3);
    eval 'sub HMER_CONFIG_RX_CSSTART () {(0x7f << 16);}' unless defined(&HMER_CONFIG_RX_CSSTART);
    eval 'sub HMER_CONFIG_RXRINGSZ32 () {(0x << 9);}' unless defined(&HMER_CONFIG_RXRINGSZ32);
    eval 'sub HMER_CONFIG_RXRINGSZ64 () {(0x1 << 9);}' unless defined(&HMER_CONFIG_RXRINGSZ64);
    eval 'sub HMER_CONFIG_RXRINGSZ128 () {(0x2 << 9);}' unless defined(&HMER_CONFIG_RXRINGSZ128);
    eval 'sub HMER_CONFIG_RXRINGSZ256 () {(0x3 << 9);}' unless defined(&HMER_CONFIG_RXRINGSZ256);
    eval 'sub HMER_CONFIG_FBO_SHIFT () {3;}' unless defined(&HMER_CONFIG_FBO_SHIFT);
    eval 'sub HMER_RXRINGSZ_SHIFT () {9;}' unless defined(&HMER_RXRINGSZ_SHIFT);
    eval 'sub BMAC_XIFC_ENAB () {(1<< 0);}' unless defined(&BMAC_XIFC_ENAB);
    eval 'sub BMAC_XIFC_XIFLPBK () {(1<< 1);}' unless defined(&BMAC_XIFC_XIFLPBK);
    eval 'sub BMAC_XIFC_MIILPBK () {(1<< 2);}' unless defined(&BMAC_XIFC_MIILPBK);
    eval 'sub BMAC_XIFC_MIIBUFDIS () {(1<< 3);}' unless defined(&BMAC_XIFC_MIIBUFDIS);
    eval 'sub BMAC_XIFC_SQETSTENB () {(1<< 4);}' unless defined(&BMAC_XIFC_SQETSTENB);
    eval 'sub BMAC_XIFC_SQETSTWIN () {(0x1f << 5);}' unless defined(&BMAC_XIFC_SQETSTWIN);
    eval 'sub BMAC_XIFC_LANCE_ENAB () {(1<< 4);}' unless defined(&BMAC_XIFC_LANCE_ENAB);
    eval 'sub BMAC_XIFC_LANCE_IPG0 () {(0x1f << 5);}' unless defined(&BMAC_XIFC_LANCE_IPG0);
    eval 'sub BMAC_XIFC_IPG0_SHIFT () {5;}' unless defined(&BMAC_XIFC_IPG0_SHIFT);
    eval 'sub BMAC_TX_RESET () {(1<< 0);}' unless defined(&BMAC_TX_RESET);
    eval 'sub BMACTXRSTDELAY () {(125);}' unless defined(&BMACTXRSTDELAY);
    eval 'sub BMAC_TXCFG_ENAB () {(1<< 0);}' unless defined(&BMAC_TXCFG_ENAB);
    eval 'sub BMAC_TXCFG_RES1 () {(0xf << 1);}' unless defined(&BMAC_TXCFG_RES1);
    eval 'sub BMAC_TXCFG_SLOW () {(1<< 5);}' unless defined(&BMAC_TXCFG_SLOW);
    eval 'sub BMAC_TXCFG_IGCOLL () {(1<< 6);}' unless defined(&BMAC_TXCFG_IGCOLL);
    eval 'sub BMAC_TXCFG_NFCS () {(1<< 7);}' unless defined(&BMAC_TXCFG_NFCS);
    eval 'sub BMAC_TXCFG_NBKOFF () {(1<< 8);}' unless defined(&BMAC_TXCFG_NBKOFF);
    eval 'sub BMAC_TXCFG_FDX () {(1<< 9);}' unless defined(&BMAC_TXCFG_FDX);
    eval 'sub BMAC_TXCFG_NGU () {(1<< 10);}' unless defined(&BMAC_TXCFG_NGU);
    eval 'sub BMACRXRSTDELAY () {(40);}' unless defined(&BMACRXRSTDELAY);
    eval 'sub BMAC_RXCFG_ENAB () {(1<< 0);}' unless defined(&BMAC_RXCFG_ENAB);
    eval 'sub BMAC_RXCFG_RES1 () {(0xf << 1);}' unless defined(&BMAC_RXCFG_RES1);
    eval 'sub BMAC_RXCFG_STRIP () {(1<< 5);}' unless defined(&BMAC_RXCFG_STRIP);
    eval 'sub BMAC_RXCFG_PROMIS () {(1<< 6);}' unless defined(&BMAC_RXCFG_PROMIS);
    eval 'sub BMAC_RXCFG_ERR () {(1<< 7);}' unless defined(&BMAC_RXCFG_ERR);
    eval 'sub BMAC_RXCFG_CRC () {(1<< 8);}' unless defined(&BMAC_RXCFG_CRC);
    eval 'sub BMAC_RXCFG_MYOWN () {(1<< 9);}' unless defined(&BMAC_RXCFG_MYOWN);
    eval 'sub BMAC_RXCFG_GRPROM () {(1<< 10);}' unless defined(&BMAC_RXCFG_GRPROM);
    eval 'sub BMAC_RXCFG_HASH () {(1<< 11);}' unless defined(&BMAC_RXCFG_HASH);
    eval 'sub BMAC_RXCFG_ADDR () {(1<< 12);}' unless defined(&BMAC_RXCFG_ADDR);
    eval 'sub HME_MIF_BBCLK () {(1<< 0);;}' unless defined(&HME_MIF_BBCLK);
    eval 'sub HME_BBCLK_LOW () {0;}' unless defined(&HME_BBCLK_LOW);
    eval 'sub HME_BBCLK_HIGH () {1;}' unless defined(&HME_BBCLK_HIGH);
    eval 'sub HME_MIF_BBDATA () {(1<< 0);;}' unless defined(&HME_MIF_BBDATA);
    eval 'sub HME_MIF_BBOPENB () {(1<< 0);;}' unless defined(&HME_MIF_BBOPENB);
    eval 'sub HME_MIF_FRDATA () {(0xffff << 0);}' unless defined(&HME_MIF_FRDATA);
    eval 'sub HME_MIF_FRTA0 () {(0x1 << 16);}' unless defined(&HME_MIF_FRTA0);
    eval 'sub HME_MIF_FRTA1 () {(0x1 << 17);}' unless defined(&HME_MIF_FRTA1);
    eval 'sub HME_MIF_FRREGAD () {(0x1f << 18);}' unless defined(&HME_MIF_FRREGAD);
    eval 'sub HME_MIF_FRPHYAD () {(0x1f << 23);}' unless defined(&HME_MIF_FRPHYAD);
    eval 'sub HME_MIF_FROP () {(0x3 << 28);}' unless defined(&HME_MIF_FROP);
    eval 'sub HME_MIF_FRST () {(0xc0000000);}' unless defined(&HME_MIF_FRST);
    eval 'sub HME_MIF_FRREGAD_SHIFT () {18;}' unless defined(&HME_MIF_FRREGAD_SHIFT);
    eval 'sub HME_MIF_FRPHYAD_SHIFT () {23;}' unless defined(&HME_MIF_FRPHYAD_SHIFT);
    eval 'sub HME_MIF_FRREAD () {0x60020000;}' unless defined(&HME_MIF_FRREAD);
    eval 'sub HME_MIF_FRWRITE () {0x50020000;}' unless defined(&HME_MIF_FRWRITE);
    eval 'sub HMEMAXMIFDELAY () {(100);}' unless defined(&HMEMAXMIFDELAY);
    eval 'sub HME_PHYRST_MAXDELAY () {(500);}' unless defined(&HME_PHYRST_MAXDELAY);
    eval 'sub HME_MIF_CFGPS () {(1<< 0);}' unless defined(&HME_MIF_CFGPS);
    eval 'sub HME_MIF_CFGPE () {(1<< 1);}' unless defined(&HME_MIF_CFGPE);
    eval 'sub HME_MIF_CFGBB () {(1<< 2);}' unless defined(&HME_MIF_CFGBB);
    eval 'sub HME_MIF_CFGPR () {(0x1f << 3);}' unless defined(&HME_MIF_CFGPR);
    eval 'sub HME_MIF_CFGM0 () {(1<< 8);}' unless defined(&HME_MIF_CFGM0);
    eval 'sub HME_MIF_CFGM1 () {(1<< 9);}' unless defined(&HME_MIF_CFGM1);
    eval 'sub HME_MIF_CFGPD () {(0x1f << 10);}' unless defined(&HME_MIF_CFGPD);
    eval 'sub HME_MIF_CFGPR_SHIFT () {3;}' unless defined(&HME_MIF_CFGPR_SHIFT);
    eval 'sub HME_MIF_CFGPD_SHIFT () {10;}' unless defined(&HME_MIF_CFGPD_SHIFT);
    eval 'sub HME_MIF_POLL_DELAY () {200;}' unless defined(&HME_MIF_POLL_DELAY);
    eval 'sub HME_INTERNAL_PHYAD () {1;}' unless defined(&HME_INTERNAL_PHYAD);
    eval 'sub HME_EXTERNAL_PHYAD () {0;}' unless defined(&HME_EXTERNAL_PHYAD);
    eval 'sub HME_MIF_INTMASK () {(0xffff << 0);}' unless defined(&HME_MIF_INTMASK);
    eval 'sub HME_MIF_STATUS () {(0xffff << 0);}' unless defined(&HME_MIF_STATUS);
    eval 'sub HME_MIF_BASIC () {(0xffff << 16);}' unless defined(&HME_MIF_BASIC);
    eval 'sub HME_MIF_FSM () {(0x3ff << 0);}' unless defined(&HME_MIF_FSM);
    eval 'sub HMEMAXRSTDELAY () {(200);}' unless defined(&HMEMAXRSTDELAY);
    eval 'sub HMEPERIOD () {(20);}' unless defined(&HMEPERIOD);
    eval 'sub HMEWAITPERIOD () { &HMEPERIOD;}' unless defined(&HMEWAITPERIOD);
    eval 'sub HMEDELAY {
        my($c, $n) = @_;
	    eval q({  &register \'int\'  &N = $n /  &HMEWAITPERIOD;  &while (-- &N > 0) {  &if ($c)  &break;  &drv_usecwait( &HMEWAITPERIOD); } });
    }' unless defined(&HMEDELAY);
    if(defined(&__cplusplus)) {
    }
}
1;
