require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_IPD_SYS_H)) {
    eval 'sub _SYS_IPD_SYS_H () {1;}' unless defined(&_SYS_IPD_SYS_H);
    require 'netinet/in.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub IPDCM () {"ipdcm";}' unless defined(&IPDCM);
    eval 'sub IPD_MTP_NAME () {"ipd";}' unless defined(&IPD_MTP_NAME);
    eval 'sub IPD_PTP_NAME () {"ipdptp";}' unless defined(&IPD_PTP_NAME);
    eval 'sub IPD_SAPL () {0;}' unless defined(&IPD_SAPL);
    unless(defined(&IP_ADDR_LEN)) {
	eval 'sub IP_ADDR_LEN () {4;}' unless defined(&IP_ADDR_LEN);
    }
    eval 'sub IPD_MTP_ADDRL () { &IP_ADDR_LEN;}' unless defined(&IPD_MTP_ADDRL);
    eval 'sub IPD_PTP_ADDRL () {0;}' unless defined(&IPD_PTP_ADDRL);
    eval 'sub IPD_MTU () {(8232);}' unless defined(&IPD_MTU);
    eval 'sub IPD_LINKHDR () {(4);}' unless defined(&IPD_LINKHDR);
    eval 'sub IPD_MAX_PKTS () {(10);}' unless defined(&IPD_MAX_PKTS);
    eval 'sub IPD_IF_STATIC () {(-1);}' unless defined(&IPD_IF_STATIC);
    eval 'sub IPD_MINOR () {(0);}' unless defined(&IPD_MINOR);
    eval 'sub IPD_HOLDING_TIME () {(10);}' unless defined(&IPD_HOLDING_TIME);
    eval 'sub IPD_MAXIFS () {(64);}' unless defined(&IPD_MAXIFS);
    eval 'sub IPD_MAXIPDCMS () {(20);}' unless defined(&IPD_MAXIPDCMS);
    eval 'sub IPD_DLPI () {1;}' unless defined(&IPD_DLPI);
    eval 'sub IPD_FLOWCTRL () {2;}' unless defined(&IPD_FLOWCTRL);
    eval 'sub IPD_DDI () {4;}' unless defined(&IPD_DDI);
    eval 'sub IPD_DATA () {8;}' unless defined(&IPD_DATA);
    if(defined(&IPD_DEBUG_MSGS)) {
	eval 'sub IPD_DLPI2 {
	    my($s, $t, $q) = @_;
    	    eval q( &if ( &ipd_debug &  &IPD_DLPI) {  &printf($s, $t, $q); });
	}' unless defined(&IPD_DLPI2);
	eval 'sub IPD_DLPI3 {
	    my($s, $t, $q, $u) = @_;
    	    eval q( &if ( &ipd_debug &  &IPD_DLPI) {  &printf($s, $t, $q, $u); });
	}' unless defined(&IPD_DLPI3);
	eval 'sub IPD_DDIDEBUG {
	    my($s) = @_;
    	    eval q( &if ( &ipd_debug &  &IPD_DDI) {  &printf($s); });
	}' unless defined(&IPD_DDIDEBUG);
	eval 'sub IPD_DDIDEBUG1 {
	    my($s, $t) = @_;
    	    eval q( &if ( &ipd_debug &  &IPD_DDI) {  &printf($s, $t); });
	}' unless defined(&IPD_DDIDEBUG1);
	eval 'sub IPD_DDIDEBUG2 {
	    my($s, $t, $v) = @_;
    	    eval q( &if ( &ipd_debug &  &IPD_DDI) {  &printf($s, $t, $v); });
	}' unless defined(&IPD_DDIDEBUG2);
	eval 'sub IPD_FLDEBUG1 {
	    my($s, $t) = @_;
    	    eval q( &if ( &ipd_debug &  &IPD_FLOWCTRL) {  &printf($s, $t); });
	}' unless defined(&IPD_FLDEBUG1);
	eval 'sub IPD_DATADBG1 {
	    my($s, $t) = @_;
    	    eval q( &if ( &ipd_debug &  &IPD_DATA) {  &printf($s, $t); });
	}' unless defined(&IPD_DATADBG1);
	eval 'sub IPD_DEBUG {
	    my($s) = @_;
    	    eval q( &if ( &ipd_debug)  &printf($s));
	}' unless defined(&IPD_DEBUG);
	eval 'sub IPD_DEBUG1 {
	    my($s, $t) = @_;
    	    eval q( &if ( &ipd_debug)  &printf($s, $t));
	}' unless defined(&IPD_DEBUG1);
	eval 'sub IPD_DEBUG2 {
	    my($s, $t, $q) = @_;
    	    eval q( &if ( &ipd_debug)  &printf($s, $t, $q));
	}' unless defined(&IPD_DEBUG2);
    } else {
	eval 'sub IPD_DLPI2 {
	    my($s, $t, $q) = @_;
    	    eval q();
	}' unless defined(&IPD_DLPI2);
	eval 'sub IPD_DLPI3 {
	    my($s, $t, $q, $u) = @_;
    	    eval q();
	}' unless defined(&IPD_DLPI3);
	eval 'sub IPD_DDIDEBUG {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&IPD_DDIDEBUG);
	eval 'sub IPD_DDIDEBUG1 {
	    my($s, $t) = @_;
    	    eval q();
	}' unless defined(&IPD_DDIDEBUG1);
	eval 'sub IPD_DDIDEBUG2 {
	    my($s, $t, $v) = @_;
    	    eval q();
	}' unless defined(&IPD_DDIDEBUG2);
	eval 'sub IPD_FLDEBUG1 {
	    my($s, $t) = @_;
    	    eval q();
	}' unless defined(&IPD_FLDEBUG1);
	eval 'sub IPD_DATADBG1 {
	    my($s, $t) = @_;
    	    eval q();
	}' unless defined(&IPD_DATADBG1);
	eval 'sub IPD_DEBUG {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&IPD_DEBUG);
	eval 'sub IPD_DEBUG1 {
	    my($s, $t) = @_;
    	    eval q();
	}' unless defined(&IPD_DEBUG1);
	eval 'sub IPD_DEBUG2 {
	    my($s, $t, $q) = @_;
    	    eval q();
	}' unless defined(&IPD_DEBUG2);
    }
    unless(defined(&DL_MAXPRIM)) {
	eval 'sub DL_MAXPRIM () { &DL_GET_STATISTICS_ACK;}' unless defined(&DL_MAXPRIM);
    }
    eval 'sub MTYPE {
        my($mp) = @_;
	    eval q(( ($mp->{b_datap}->{db_type})));
    }' unless defined(&MTYPE);
    eval 'sub EQUAL {
        my($a1, $a2) = @_;
	    eval q(( &bcmp(($a1), ($a2), ( &IP_ADDR_LEN)) == 0));
    }' unless defined(&EQUAL);
    eval 'sub GETSTRUCT {
        my($structure, $number) = @_;
	    eval q(( &kmem_zalloc($sizeof{$structure} * ($number),  &KM_NOSLEEP)));
    }' unless defined(&GETSTRUCT);
    eval 'sub GETBUF {
        my($structure, $size) = @_;
	    eval q(( &kmem_zalloc($size,  &KM_NOSLEEP)));
    }' unless defined(&GETBUF);
    eval 'sub DRIVER_IS {
        my($dev, $name) = @_;
	    eval q(( &strcmp( &ddi_major_to_name( &getmajor($dev)), $name) == 0));
    }' unless defined(&DRIVER_IS);
    if(defined(&__cplusplus)) {
    }
}
1;
