require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_LE_H)) {
    eval 'sub _SYS_LE_H () {1;}' unless defined(&_SYS_LE_H);
    require 'sys/types.ph';
    require 'sys/kstat.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub LEIDNUM () {(68);}' unless defined(&LEIDNUM);
    eval 'sub LENAME () {"le";}' unless defined(&LENAME);
    eval 'sub LEMINPSZ () {(0);}' unless defined(&LEMINPSZ);
    eval 'sub LEMAXPSZ () {1514;}' unless defined(&LEMAXPSZ);
    eval 'sub LEHIWAT () {(32* 1024);}' unless defined(&LEHIWAT);
    eval 'sub LELOWAT () {(1);}' unless defined(&LELOWAT);
    eval 'sub NMCHASH () {64;}' unless defined(&NMCHASH);
    eval 'sub INIT_BUCKET_SIZE () {16;}' unless defined(&INIT_BUCKET_SIZE);
    eval 'sub MCHASH {
        my($a) = @_;
	    eval q(((*((( &uchar_t *)($a)) + 0) ^ *((( &uchar_t *)($a)) + 1) ^ *((( &uchar_t *)($a)) + 2) ^ *((( &uchar_t *)($a)) + 3) ^ *((( &uchar_t *)($a)) + 4) ^ *((( &uchar_t *)($a)) + 5)) % ( &uint_t) &NMCHASH));
    }' unless defined(&MCHASH);
    eval 'sub SLFAST () {0x1;}' unless defined(&SLFAST);
    eval 'sub SLRAW () {0x2;}' unless defined(&SLRAW);
    eval 'sub SLALLPHYS () {0x4;}' unless defined(&SLALLPHYS);
    eval 'sub SLALLMULTI () {0x8;}' unless defined(&SLALLMULTI);
    eval 'sub SLALLSAP () {0x10;}' unless defined(&SLALLSAP);
    eval 'sub TMD_INUSE () { &TMD_RES;}' unless defined(&TMD_INUSE);
    eval 'sub LEMAXMC () {64;}' unless defined(&LEMAXMC);
    eval 'sub LEMCALLOC () {( &LEMAXMC * $sizeof{\'struct ether_addr\'});}' unless defined(&LEMCALLOC);
    eval 'sub LEADDRL () {($sizeof{ &ushort_t} +  &ETHERADDRL);}' unless defined(&LEADDRL);
    eval 'sub NEXTRMD {
        my($lep, $rmdp) = @_;
	    eval q(((($rmdp) + 1) == ($lep)-> &le_rmdlimp ? ($lep)-> &le_rmdp : (($rmdp) + 1)));
    }' unless defined(&NEXTRMD);
    eval 'sub NEXTTMD {
        my($lep, $tmdp) = @_;
	    eval q(((($tmdp) + 1) == ($lep)-> &le_tmdlimp ? ($lep)-> &le_tmdp : (($tmdp) + 1)));
    }' unless defined(&NEXTTMD);
    eval 'sub PREVTMD {
        my($lep, $tmdp) = @_;
	    eval q((($tmdp) == ($lep)-> &le_tmdp ? (($lep)-> &le_tmdlimp - 1) : (($tmdp) - 1)));
    }' unless defined(&PREVTMD);
    eval 'sub LERUNNING () {0x1;}' unless defined(&LERUNNING);
    eval 'sub LESLAVE () {0x2;}' unless defined(&LESLAVE);
    eval 'sub LEPROMISC () {0x4;}' unless defined(&LEPROMISC);
    eval 'sub LESUSPENDED () {0x10;}' unless defined(&LESUSPENDED);
    eval 'sub LEBURSTSIZE () {(64);}' unless defined(&LEBURSTSIZE);
    eval 'sub LEBURSTMASK () {( &LEBURSTSIZE-1);}' unless defined(&LEBURSTMASK);
    eval 'sub LEDRAINTIME () {(200000);}' unless defined(&LEDRAINTIME);
    eval 'sub LEROUNDUP {
        my($a, $n) = @_;
	    eval q(((($a) + (($n) - 1)) & ~(($n) - 1)));
    }' unless defined(&LEROUNDUP);
    eval 'sub LETOP16MEG () {( &uint32_t)0xff000000;}' unless defined(&LETOP16MEG);
    eval 'sub LEBUFSIZE () {(1728);}' unless defined(&LEBUFSIZE);
    eval 'sub LEBUFPAD () {( &LEBURSTSIZE - $sizeof{\'struct le\' } - $sizeof{ &frtn_t});}' unless defined(&LEBUFPAD);
    eval 'sub LEHEADROOM () {34;}' unless defined(&LEHEADROOM);
    eval 'sub LOSLAVE () {0x1;}' unless defined(&LOSLAVE);
    if(defined(&__cplusplus)) {
    }
}
1;
