require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_LOCKFS_H)) {
    eval 'sub _SYS_LOCKFS_H () {1;}' unless defined(&_SYS_LOCKFS_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_SYSCALL32)) {
    }
    eval 'sub LOCKFS_ULOCK () {0;}' unless defined(&LOCKFS_ULOCK);
    eval 'sub LOCKFS_WLOCK () {1;}' unless defined(&LOCKFS_WLOCK);
    eval 'sub LOCKFS_NLOCK () {2;}' unless defined(&LOCKFS_NLOCK);
    eval 'sub LOCKFS_DLOCK () {3;}' unless defined(&LOCKFS_DLOCK);
    eval 'sub LOCKFS_HLOCK () {4;}' unless defined(&LOCKFS_HLOCK);
    eval 'sub LOCKFS_ELOCK () {5;}' unless defined(&LOCKFS_ELOCK);
    eval 'sub LOCKFS_ROELOCK () {6;}' unless defined(&LOCKFS_ROELOCK);
    eval 'sub LOCKFS_MAXLOCK () {6;}' unless defined(&LOCKFS_MAXLOCK);
    eval 'sub LOCKFS_BUSY () {0x1;}' unless defined(&LOCKFS_BUSY);
    eval 'sub LOCKFS_MOD () {0x2;}' unless defined(&LOCKFS_MOD);
    eval 'sub LOCKFS_MAXCOMMENTLEN () {1024;}' unless defined(&LOCKFS_MAXCOMMENTLEN);
    eval 'sub LOCKFS_IS_BUSY {
        my($LF) = @_;
	    eval q((($LF)-> &lf_flags &  &LOCKFS_BUSY));
    }' unless defined(&LOCKFS_IS_BUSY);
    eval 'sub LOCKFS_IS_MOD {
        my($LF) = @_;
	    eval q((($LF)-> &lf_flags &  &LOCKFS_MOD));
    }' unless defined(&LOCKFS_IS_MOD);
    eval 'sub LOCKFS_CLR_BUSY {
        my($LF) = @_;
	    eval q((($LF)-> &lf_flags &= ~ &LOCKFS_BUSY));
    }' unless defined(&LOCKFS_CLR_BUSY);
    eval 'sub LOCKFS_CLR_MOD {
        my($LF) = @_;
	    eval q((($LF)-> &lf_flags &= ~ &LOCKFS_MOD));
    }' unless defined(&LOCKFS_CLR_MOD);
    eval 'sub LOCKFS_SET_MOD {
        my($LF) = @_;
	    eval q((($LF)-> &lf_flags |=  &LOCKFS_MOD));
    }' unless defined(&LOCKFS_SET_MOD);
    eval 'sub LOCKFS_SET_BUSY {
        my($LF) = @_;
	    eval q((($LF)-> &lf_flags |=  &LOCKFS_BUSY));
    }' unless defined(&LOCKFS_SET_BUSY);
    eval 'sub LOCKFS_IS_WLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &lf_lock ==  &LOCKFS_WLOCK));
    }' unless defined(&LOCKFS_IS_WLOCK);
    eval 'sub LOCKFS_IS_HLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &lf_lock ==  &LOCKFS_HLOCK));
    }' unless defined(&LOCKFS_IS_HLOCK);
    eval 'sub LOCKFS_IS_ROELOCK {
        my($LF) = @_;
	    eval q((($LF)-> &lf_lock ==  &LOCKFS_ROELOCK));
    }' unless defined(&LOCKFS_IS_ROELOCK);
    eval 'sub LOCKFS_IS_ELOCK {
        my($LF) = @_;
	    eval q((($LF)-> &lf_lock ==  &LOCKFS_ELOCK));
    }' unless defined(&LOCKFS_IS_ELOCK);
    eval 'sub LOCKFS_IS_ULOCK {
        my($LF) = @_;
	    eval q((($LF)-> &lf_lock ==  &LOCKFS_ULOCK));
    }' unless defined(&LOCKFS_IS_ULOCK);
    eval 'sub LOCKFS_IS_NLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &lf_lock ==  &LOCKFS_NLOCK));
    }' unless defined(&LOCKFS_IS_NLOCK);
    eval 'sub LOCKFS_IS_DLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &lf_lock ==  &LOCKFS_DLOCK));
    }' unless defined(&LOCKFS_IS_DLOCK);
    if(defined(&__cplusplus)) {
    }
}
1;
