require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_LOCKSTAT_H)) {
    eval 'sub _SYS_LOCKSTAT_H () {1;}' unless defined(&_SYS_LOCKSTAT_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub LS_ADAPTIVE_MUTEX_SPIN () {0;}' unless defined(&LS_ADAPTIVE_MUTEX_SPIN);
    eval 'sub LS_ADAPTIVE_MUTEX_BLOCK () {1;}' unless defined(&LS_ADAPTIVE_MUTEX_BLOCK);
    eval 'sub LS_SPIN_LOCK () {2;}' unless defined(&LS_SPIN_LOCK);
    eval 'sub LS_THREAD_LOCK () {3;}' unless defined(&LS_THREAD_LOCK);
    eval 'sub LS_RW_WRITER_BY_WRITER () {4;}' unless defined(&LS_RW_WRITER_BY_WRITER);
    eval 'sub LS_RW_WRITER_BY_READERS () {5;}' unless defined(&LS_RW_WRITER_BY_READERS);
    eval 'sub LS_RW_READER_BY_WRITER () {6;}' unless defined(&LS_RW_READER_BY_WRITER);
    eval 'sub LS_RW_READER_BY_WRITE_WANTED () {7;}' unless defined(&LS_RW_READER_BY_WRITE_WANTED);
    eval 'sub LS_ADAPTIVE_MUTEX_HOLD () {32;}' unless defined(&LS_ADAPTIVE_MUTEX_HOLD);
    eval 'sub LS_SPIN_LOCK_HOLD () {33;}' unless defined(&LS_SPIN_LOCK_HOLD);
    eval 'sub LS_RW_WRITER_HOLD () {34;}' unless defined(&LS_RW_WRITER_HOLD);
    eval 'sub LS_RW_READER_HOLD () {35;}' unless defined(&LS_RW_READER_HOLD);
    eval 'sub LS_PROFILE_INTR () {56;}' unless defined(&LS_PROFILE_INTR);
    eval 'sub LS_ERROR_BASE () {60;}' unless defined(&LS_ERROR_BASE);
    eval 'sub LS_RECURSION_DETECTED () {60;}' unless defined(&LS_RECURSION_DETECTED);
    eval 'sub LS_ENTER_FAILED () {61;}' unless defined(&LS_ENTER_FAILED);
    eval 'sub LS_EXIT_FAILED () {62;}' unless defined(&LS_EXIT_FAILED);
    eval 'sub LS_RECORD_FAILED () {63;}' unless defined(&LS_RECORD_FAILED);
    eval 'sub LS_MAX_EVENTS () {64;}' unless defined(&LS_MAX_EVENTS);
    eval 'sub LSE_ENTER () {0x1;}' unless defined(&LSE_ENTER);
    eval 'sub LSE_EXIT () {0x2;}' unless defined(&LSE_EXIT);
    eval 'sub LSE_RECORD () {0x4;}' unless defined(&LSE_RECORD);
    eval 'sub LSE_TRACE () {0x8;}' unless defined(&LSE_TRACE);
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
	require 'sys/inttypes.ph';
	require 'sys/systm.ph';
	eval 'sub LS_MAX_STACK_DEPTH () {50;}' unless defined(&LS_MAX_STACK_DEPTH);
	eval 'sub LS_BASIC () { &offsetof( &lsrec_t,  &ls_time);}' unless defined(&LS_BASIC);
	eval 'sub LS_TIME () { &offsetof( &lsrec_t,  $ls_hist[0]);}' unless defined(&LS_TIME);
	eval 'sub LS_HIST () { &offsetof( &lsrec_t,  $ls_stack[0]);}' unless defined(&LS_HIST);
	eval 'sub LS_STACK {
	    my($depth) = @_;
    	    eval q( &offsetof( &lsrec_t,  $ls_stack[$depth]));
	}' unless defined(&LS_STACK);
	eval 'sub LS_MAX_WATCH () {32;}' unless defined(&LS_MAX_WATCH);
	if(defined(&_KERNEL)) {
	    eval 'sub LOCKSTAT_RECORD {
	        my($event, $lp, $time, $refcnt) = @_;
    		eval q( &if ( $lockstat_event[$event] &  &LSE_RECORD)  ($curthread->{t_lockstat})++,  &lockstat_record_op(( &uintptr_t)($lp), ( &uintptr_t) &caller(), ($event), ($refcnt), ($time)),  ($curthread->{t_lockstat})--;);
	    }' unless defined(&LOCKSTAT_RECORD);
	    eval 'sub LOCKSTAT_ENTER {
	        my($event, $lp, $owner) = @_;
    		eval q( &if ( $lockstat_event[$event] &  &LSE_ENTER)  ($curthread->{t_lockstat})++,  &lockstat_enter_op(( &uintptr_t)($lp), ( &uintptr_t) &caller(), ( &uintptr_t)($owner)),  ($curthread->{t_lockstat})--;);
	    }' unless defined(&LOCKSTAT_ENTER);
	    eval 'sub LOCKSTAT_EXIT {
	        my($event, $lp, $owner, $refcnt) = @_;
    		eval q( &if ( $lockstat_event[$event] &  &LSE_EXIT)  ($curthread->{t_lockstat})++,  &lockstat_exit_op(( &uintptr_t)($lp), ( &uintptr_t) &caller(), ($event), ($refcnt), ( &uintptr_t)($owner)),  ($curthread->{t_lockstat})--;);
	    }' unless defined(&LOCKSTAT_EXIT);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
