require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_LOFI_H)) {
    eval 'sub _SYS_LOFI_H () {1;}' unless defined(&_SYS_LOFI_H);
    require 'sys/types.ph';
    require 'sys/time.ph';
    require 'sys/taskq.ph';
    require 'sys/vtoc.ph';
    require 'sys/dkio.ph';
    require 'sys/vnode.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub LOFI_DRIVER_NAME () {"lofi";}' unless defined(&LOFI_DRIVER_NAME);
    eval 'sub LOFI_CTL_NODE () {"ctl";}' unless defined(&LOFI_CTL_NODE);
    eval 'sub LOFI_CTL_NAME () { &LOFI_DRIVER_NAME  &LOFI_CTL_NODE;}' unless defined(&LOFI_CTL_NAME);
    eval 'sub LOFI_BLOCK_NAME () { &LOFI_DRIVER_NAME;}' unless defined(&LOFI_BLOCK_NAME);
    eval 'sub LOFI_CHAR_NAME () {"r"  &LOFI_DRIVER_NAME;}' unless defined(&LOFI_CHAR_NAME);
    eval 'sub LOFI_IOC_BASE () {((ord(\'L\' << 16) | (\'F\') << 8));}' unless defined(&LOFI_IOC_BASE);
    eval 'sub LOFI_MAP_FILE () {( &LOFI_IOC_BASE | 0x1);}' unless defined(&LOFI_MAP_FILE);
    eval 'sub LOFI_MAP_FILE_MINOR () {( &LOFI_IOC_BASE | 0x2);}' unless defined(&LOFI_MAP_FILE_MINOR);
    eval 'sub LOFI_UNMAP_FILE () {( &LOFI_IOC_BASE | 0x3);}' unless defined(&LOFI_UNMAP_FILE);
    eval 'sub LOFI_UNMAP_FILE_MINOR () {( &LOFI_IOC_BASE | 0x4);}' unless defined(&LOFI_UNMAP_FILE_MINOR);
    eval 'sub LOFI_GET_FILENAME () {( &LOFI_IOC_BASE | 0x5);}' unless defined(&LOFI_GET_FILENAME);
    eval 'sub LOFI_GET_MINOR () {( &LOFI_IOC_BASE | 0x6);}' unless defined(&LOFI_GET_MINOR);
    eval 'sub LOFI_GET_MAXMINOR () {( &LOFI_IOC_BASE | 0x7);}' unless defined(&LOFI_GET_MAXMINOR);
    eval 'sub S_ISLOFIABLE {
        my($mode) = @_;
	    eval q(( &S_ISREG($mode) ||  &S_ISBLK($mode) ||  &S_ISCHR($mode)));
    }' unless defined(&S_ISLOFIABLE);
    if(defined( &_KERNEL)) {
	eval 'sub V_ISLOFIABLE {
	    my($vtype) = @_;
    	    eval q((($vtype ==  &VREG) || ($vtype ==  &VBLK) || ($vtype ==  &VCHR)));
	}' unless defined(&V_ISLOFIABLE);
	eval 'sub LOFI_CHR_OPEN () {0x1;}' unless defined(&LOFI_CHR_OPEN);
	eval 'sub LOFI_BLK_OPEN () {0x2;}' unless defined(&LOFI_BLK_OPEN);
	eval 'sub LOFI_LYR_OPEN () {0x4;}' unless defined(&LOFI_LYR_OPEN);
	eval 'sub LOFI_OPEN_FLAGS () {( &LOFI_CHR_OPEN |  &LOFI_BLK_OPEN |  &LOFI_LYR_OPEN);}' unless defined(&LOFI_OPEN_FLAGS);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
