require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MDB_MODAPI_H)) {
    eval 'sub _MDB_MODAPI_H () {1;}' unless defined(&_MDB_MODAPI_H);
    require 'sys/types.ph';
    require 'gelf.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&NULL)) {
	if(defined( &_LP64)  && !defined( &__cplusplus)) {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	} else {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	}
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    my($x, $y) = @_;
    	    eval q((($x) < ($y) ? ($x) : ($y)));
	}' unless defined(&MIN);
    }
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    my($x, $y) = @_;
    	    eval q((($x) > ($y) ? ($x) : ($y)));
	}' unless defined(&MAX);
    }
    eval 'sub MDB_API_VERSION () {1;}' unless defined(&MDB_API_VERSION);
    eval 'sub DCMD_ADDRSPEC () {0x1;}' unless defined(&DCMD_ADDRSPEC);
    eval 'sub DCMD_LOOP () {0x2;}' unless defined(&DCMD_LOOP);
    eval 'sub DCMD_LOOPFIRST () {0x4;}' unless defined(&DCMD_LOOPFIRST);
    eval 'sub DCMD_PIPE () {0x8;}' unless defined(&DCMD_PIPE);
    eval 'sub DCMD_PIPE_OUT () {0x10;}' unless defined(&DCMD_PIPE_OUT);
    eval 'sub DCMD_HDRSPEC {
        my($fl) = @_;
	    eval q(((($fl) &  &DCMD_LOOPFIRST) || !(($fl) &  &DCMD_LOOP)));
    }' unless defined(&DCMD_HDRSPEC);
    eval 'sub DCMD_OK () {0;}' unless defined(&DCMD_OK);
    eval 'sub DCMD_ERR () {1;}' unless defined(&DCMD_ERR);
    eval 'sub DCMD_USAGE () {2;}' unless defined(&DCMD_USAGE);
    eval 'sub DCMD_NEXT () {3;}' unless defined(&DCMD_NEXT);
    eval 'sub DCMD_ABORT () {4;}' unless defined(&DCMD_ABORT);
    eval 'sub OFFSETOF {
        my($s, $m) = @_;
	    eval q((((($s *)0)->$m)));
    }' unless defined(&OFFSETOF);
    eval("sub MDB_TYPE_STRING () { 0; }") unless defined(&MDB_TYPE_STRING);
    eval("sub MDB_TYPE_IMMEDIATE () { 1; }") unless defined(&MDB_TYPE_IMMEDIATE);
    eval("sub MDB_TYPE_CHAR () { 2; }") unless defined(&MDB_TYPE_CHAR);
    eval 'sub WALK_ERR () {-1;}' unless defined(&WALK_ERR);
    eval 'sub WALK_NEXT () {0;}' unless defined(&WALK_NEXT);
    eval 'sub WALK_DONE () {1;}' unless defined(&WALK_DONE);
    eval 'sub MDB_SYM_NAMLEN () {1024;}' unless defined(&MDB_SYM_NAMLEN);
    eval 'sub MDB_SYM_FUZZY () {0;}' unless defined(&MDB_SYM_FUZZY);
    eval 'sub MDB_SYM_EXACT () {1;}' unless defined(&MDB_SYM_EXACT);
    eval 'sub MDB_OBJ_EXEC () {(( &const \'char\' *)0);}' unless defined(&MDB_OBJ_EXEC);
    eval 'sub MDB_OBJ_RTLD () {(( &const \'char\' *)1);}' unless defined(&MDB_OBJ_RTLD);
    eval 'sub MDB_OBJ_EVERY () {(( &const \'char\' *)-1);}' unless defined(&MDB_OBJ_EVERY);
    eval 'sub MDB_OPT_SETBITS () {1;}' unless defined(&MDB_OPT_SETBITS);
    eval 'sub MDB_OPT_CLRBITS () {2;}' unless defined(&MDB_OPT_CLRBITS);
    eval 'sub MDB_OPT_STR () {3;}' unless defined(&MDB_OPT_STR);
    eval 'sub MDB_OPT_UINTPTR () {4;}' unless defined(&MDB_OPT_UINTPTR);
    eval 'sub MDB_OPT_UINT64 () {5;}' unless defined(&MDB_OPT_UINT64);
    eval 'sub UM_NOSLEEP () {0x;}' unless defined(&UM_NOSLEEP);
    eval 'sub UM_SLEEP () {0x1;}' unless defined(&UM_SLEEP);
    eval 'sub UM_GC () {0x2;}' unless defined(&UM_GC);
    if(defined(&__cplusplus)) {
    }
}
1;
