require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MIXER_H)) {
    eval 'sub _SYS_MIXER_H () {1;}' unless defined(&_SYS_MIXER_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/audio.ph';
    eval 'sub MIXER_NAME () {"audio mixer";}' unless defined(&MIXER_NAME);
    eval 'sub MIXER_VERSION () {"Rev 1";}' unless defined(&MIXER_VERSION);
    eval 'sub MIXER_CONFIGURATION () {"Config A";}' unless defined(&MIXER_CONFIGURATION);
    eval 'sub MIXER_MOD_NAME () {"Audio Mixer";}' unless defined(&MIXER_MOD_NAME);
    eval 'sub AM_MIXER_MODE () {0;}' unless defined(&AM_MIXER_MODE);
    eval 'sub AM_COMPAT_MODE () {1;}' unless defined(&AM_COMPAT_MODE);
    eval 'sub AM_DEFAULT_SAMPLERATE () {8000;}' unless defined(&AM_DEFAULT_SAMPLERATE);
    eval 'sub AM_DEFAULT_CHANNELS () { &AUDIO_CHANNELS_MONO;}' unless defined(&AM_DEFAULT_CHANNELS);
    eval 'sub AM_DEFAULT_PRECISION () { &AUDIO_PRECISION_8;}' unless defined(&AM_DEFAULT_PRECISION);
    eval 'sub AM_DEFAULT_ENCODING () { &AUDIO_ENCODING_ULAW;}' unless defined(&AM_DEFAULT_ENCODING);
    eval 'sub AM_DEFAULT_GAIN () { &AUDIO_MID_GAIN;}' unless defined(&AM_DEFAULT_GAIN);
    eval 'sub MIOC () {(ord(\'M\')<<8);}' unless defined(&MIOC);
    eval 'sub AUDIO_MIXER_MULTIPLE_OPEN () {( &MIOC|10);}' unless defined(&AUDIO_MIXER_MULTIPLE_OPEN);
    eval 'sub AUDIO_MIXER_SINGLE_OPEN () {( &MIOC|11);}' unless defined(&AUDIO_MIXER_SINGLE_OPEN);
    eval 'sub AUDIO_MIXER_GET_SAMPLE_RATES () {( &MIOC|12);}' unless defined(&AUDIO_MIXER_GET_SAMPLE_RATES);
    eval 'sub AUDIO_MIXERCTL_GETINFO () {( &MIOC|13);}' unless defined(&AUDIO_MIXERCTL_GETINFO);
    eval 'sub AUDIO_MIXERCTL_SETINFO () {( &MIOC|14);}' unless defined(&AUDIO_MIXERCTL_SETINFO);
    eval 'sub AUDIO_MIXERCTL_GET_CHINFO () {( &MIOC|15);}' unless defined(&AUDIO_MIXERCTL_GET_CHINFO);
    eval 'sub AUDIO_MIXERCTL_SET_CHINFO () {( &MIOC|16);}' unless defined(&AUDIO_MIXERCTL_SET_CHINFO);
    eval 'sub AUDIO_MIXERCTL_GET_MODE () {( &MIOC|17);}' unless defined(&AUDIO_MIXERCTL_GET_MODE);
    eval 'sub AUDIO_MIXERCTL_SET_MODE () {( &MIOC|18);}' unless defined(&AUDIO_MIXERCTL_SET_MODE);
    eval 'sub AUDIO_MIXER_CTL_STRUCT_SIZE {
        my($num_ch) = @_;
	    eval q(($sizeof{ &am_control_t} + (($num_ch - 1) * $sizeof{ &int8_t})));
    }' unless defined(&AUDIO_MIXER_CTL_STRUCT_SIZE);
    eval 'sub AUDIO_MIXER_SAMP_RATES_STRUCT_SIZE {
        my($num_srs) = @_;
	    eval q(($sizeof{ &am_sample_rates_t} + (($num_srs - 1) * $sizeof{ &uint_t})));
    }' unless defined(&AUDIO_MIXER_SAMP_RATES_STRUCT_SIZE);
    eval 'sub AM_MIXER () {0x1;}' unless defined(&AM_MIXER);
    eval 'sub MIXER_SR_LIMITS () {0x1;}' unless defined(&MIXER_SR_LIMITS);
    if(defined(&__cplusplus)) {
    }
}
1;
