require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MODCTL_H)) {
    eval 'sub _SYS_MODCTL_H () {1;}' unless defined(&_SYS_MODCTL_H);
    require 'sys/types.ph';
    require 'sys/ioccom.ph';
    require 'sys/nexusdefs.ph';
    require 'sys/thread.ph';
    require 'sys/t_lock.ph';
    require 'sys/dditypes.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	if(defined(&_SYSCALL32_IMPL)) {
	}
    }
    eval 'sub MODREV_1 () {1;}' unless defined(&MODREV_1);
    if(defined(&_LP64)) {
    } else {
    }
    eval 'sub MODLOAD () {0;}' unless defined(&MODLOAD);
    eval 'sub MODUNLOAD () {1;}' unless defined(&MODUNLOAD);
    eval 'sub MODINFO () {2;}' unless defined(&MODINFO);
    eval 'sub MODRESERVED () {3;}' unless defined(&MODRESERVED);
    eval 'sub MODCONFIG () {4;}' unless defined(&MODCONFIG);
    eval 'sub MODADDMAJBIND () {5;}' unless defined(&MODADDMAJBIND);
    eval 'sub MODGETPATH () {6;}' unless defined(&MODGETPATH);
    eval 'sub MODREADSYSBIND () {7;}' unless defined(&MODREADSYSBIND);
    eval 'sub MODGETMAJBIND () {8;}' unless defined(&MODGETMAJBIND);
    eval 'sub MODGETNAME () {9;}' unless defined(&MODGETNAME);
    eval 'sub MODSIZEOF_DEVID () {10;}' unless defined(&MODSIZEOF_DEVID);
    eval 'sub MODGETDEVID () {11;}' unless defined(&MODGETDEVID);
    eval 'sub MODSIZEOF_MINORNAME () {12;}' unless defined(&MODSIZEOF_MINORNAME);
    eval 'sub MODGETMINORNAME () {13;}' unless defined(&MODGETMINORNAME);
    eval 'sub MODGETPATHLEN () {14;}' unless defined(&MODGETPATHLEN);
    eval 'sub MODEVENTS () {15;}' unless defined(&MODEVENTS);
    eval 'sub MODGETFBNAME () {16;}' unless defined(&MODGETFBNAME);
    eval 'sub MODREREADDACF () {17;}' unless defined(&MODREREADDACF);
    eval 'sub MODREMMAJBIND () {18;}' unless defined(&MODREMMAJBIND);
    eval 'sub MOD_SHARED () {1;}' unless defined(&MOD_SHARED);
    eval 'sub MOD_EXCL () {2;}' unless defined(&MOD_EXCL);
    eval 'sub MODEVENTS_FLUSH () {0;}' unless defined(&MODEVENTS_FLUSH);
    eval 'sub MODEVENTS_FLUSH_DUMP () {1;}' unless defined(&MODEVENTS_FLUSH_DUMP);
    eval 'sub MODEVENTS_SET_DOOR_UPCALL_FILENAME () {2;}' unless defined(&MODEVENTS_SET_DOOR_UPCALL_FILENAME);
    eval 'sub MODEVENTS_GETDATA () {3;}' unless defined(&MODEVENTS_GETDATA);
    eval 'sub MODEVENTS_FREEDATA () {4;}' unless defined(&MODEVENTS_FREEDATA);
    eval 'sub MODEVENTS_POST_EVENT () {5;}' unless defined(&MODEVENTS_POST_EVENT);
    eval 'sub MAXMODCONFNAME () {256;}' unless defined(&MAXMODCONFNAME);
    if(defined( &_SYSCALL32)) {
    }
    eval 'sub MOD_MAXPATH () {256;}' unless defined(&MOD_MAXPATH);
    eval 'sub MOD_DEFPATH () {"/kernel /usr/kernel";}' unless defined(&MOD_DEFPATH);
    eval 'sub MOD_DEFEXT () {"";}' unless defined(&MOD_DEFEXT);
    eval 'sub MODMAXNAMELEN () {32;}' unless defined(&MODMAXNAMELEN);
    eval 'sub MODMAXLINKINFOLEN () {32;}' unless defined(&MODMAXLINKINFOLEN);
    eval 'sub MODMAXLINK () {10;}' unless defined(&MODMAXLINK);
    if(defined( &_SYSCALL32)) {
	eval 'sub MODMAXNAMELEN32 () {32;}' unless defined(&MODMAXNAMELEN32);
	eval 'sub MODMAXLINKINFOLEN32 () {32;}' unless defined(&MODMAXLINKINFOLEN32);
	eval 'sub MODMAXLINK32 () {10;}' unless defined(&MODMAXLINK32);
    }
    eval 'sub MI_INFO_ONE () {1;}' unless defined(&MI_INFO_ONE);
    eval 'sub MI_INFO_ALL () {2;}' unless defined(&MI_INFO_ALL);
    eval 'sub MI_INFO_CNT () {4;}' unless defined(&MI_INFO_CNT);
    if(defined(&_KERNEL)) {
	eval 'sub MI_INFO_LINKAGE () {8;}' unless defined(&MI_INFO_LINKAGE);
    }
    eval 'sub MI_LOADED () {1;}' unless defined(&MI_LOADED);
    eval 'sub MI_INSTALLED () {2;}' unless defined(&MI_INSTALLED);
    eval 'sub MODL_INSTALL {
        my($MODL, $MODLP) = @_;
	    eval q((*($MODL)-> ($misc_modops->{modm_install}))($MODL, $MODLP));
    }' unless defined(&MODL_INSTALL);
    eval 'sub MODL_REMOVE {
        my($MODL, $MODLP) = @_;
	    eval q((*($MODL)-> ($misc_modops->{modm_remove}))($MODL, $MODLP));
    }' unless defined(&MODL_REMOVE);
    eval 'sub MODL_INFO {
        my($MODL, $MODLP, $P0) = @_;
	    eval q((*($MODL)-> ($misc_modops->{modm_info}))($MODL, $MODLP, $P0));
    }' unless defined(&MODL_INFO);
    eval 'sub MODS_WEAK () {0x1;}' unless defined(&MODS_WEAK);
    eval 'sub MODS_NOUNLOAD () {0x2;}' unless defined(&MODS_NOUNLOAD);
    eval 'sub MOD_NOAUTOUNLOAD () {0x1;}' unless defined(&MOD_NOAUTOUNLOAD);
    if(defined(&_KERNEL)) {
	eval 'sub MOD_BIND_HASHSIZE () {64;}' unless defined(&MOD_BIND_HASHSIZE);
	eval 'sub MOD_BIND_HASHMASK () {( &MOD_BIND_HASHSIZE-1);}' unless defined(&MOD_BIND_HASHMASK);
    }
    eval 'sub MODDEBUG_LOADMSG () {0x80000000;}' unless defined(&MODDEBUG_LOADMSG);
    eval 'sub MODDEBUG_ERRMSG () {0x40000000;}' unless defined(&MODDEBUG_ERRMSG);
    eval 'sub MODDEBUG_LOADMSG2 () {0x20000000;}' unless defined(&MODDEBUG_LOADMSG2);
    eval 'sub MODDEBUG_NOAUL_DACF () {0x8000;}' unless defined(&MODDEBUG_NOAUL_DACF);
    eval 'sub MODDEBUG_KEEPTEXT () {0x4000;}' unless defined(&MODDEBUG_KEEPTEXT);
    eval 'sub MODDEBUG_NOPACK () {0x2000;}' unless defined(&MODDEBUG_NOPACK);
    eval 'sub MODDEBUG_NOAUL_DRV () {0x1000;}' unless defined(&MODDEBUG_NOAUL_DRV);
    eval 'sub MODDEBUG_NOAUL_EXEC () {0x800;}' unless defined(&MODDEBUG_NOAUL_EXEC);
    eval 'sub MODDEBUG_NOAUL_FS () {0x400;}' unless defined(&MODDEBUG_NOAUL_FS);
    eval 'sub MODDEBUG_NOAUL_MISC () {0x200;}' unless defined(&MODDEBUG_NOAUL_MISC);
    eval 'sub MODDEBUG_NOAUL_SCHED () {0x100;}' unless defined(&MODDEBUG_NOAUL_SCHED);
    eval 'sub MODDEBUG_NOAUL_STR () {0x80;}' unless defined(&MODDEBUG_NOAUL_STR);
    eval 'sub MODDEBUG_NOAUL_SYS () {0x40;}' unless defined(&MODDEBUG_NOAUL_SYS);
    eval 'sub MODDEBUG_NOSYMS () {0x20;}' unless defined(&MODDEBUG_NOSYMS);
    eval 'sub MODDEBUG_NOAUTOUNLOAD () {0x10;}' unless defined(&MODDEBUG_NOAUTOUNLOAD);
    eval 'sub MODDEBUG_UNLOCKSYMBOLS () {0x8;}' unless defined(&MODDEBUG_UNLOCKSYMBOLS);
    eval 'sub MODDEBUG_LOCKSYMBOLS () {0x4;}' unless defined(&MODDEBUG_LOCKSYMBOLS);
    eval 'sub MODDEBUG_STUBBPT () {0x2;}' unless defined(&MODDEBUG_STUBBPT);
    eval 'sub MODDEBUG_USERDEBUG () {0x1;}' unless defined(&MODDEBUG_USERDEBUG);
    if(defined(&__cplusplus)) {
    }
}
1;
