require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_OBPDEFS_H)) {
    eval 'sub _SYS_OBPDEFS_H () {1;}' unless defined(&_SYS_OBPDEFS_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub OBP_MAGIC () {(( &uint_t)0x10010407);}' unless defined(&OBP_MAGIC);
    eval 'sub SUNMON_ROMVEC_VERSION () {-1;}' unless defined(&SUNMON_ROMVEC_VERSION);
    eval 'sub OBP_V0_ROMVEC_VERSION () {0;}' unless defined(&OBP_V0_ROMVEC_VERSION);
    eval 'sub OBP_V2_ROMVEC_VERSION () {2;}' unless defined(&OBP_V2_ROMVEC_VERSION);
    eval 'sub OBP_V3_ROMVEC_VERSION () {3;}' unless defined(&OBP_V3_ROMVEC_VERSION);
    eval 'sub OBP_PSEUDO_ROMVEC_VERSION () {5555;}' unless defined(&OBP_PSEUDO_ROMVEC_VERSION);
    eval 'sub OBP_PLUGIN_VERSION () {2;}' unless defined(&OBP_PLUGIN_VERSION);
    eval 'sub OBP_NONODE () {(( &dnode_t)0);}' unless defined(&OBP_NONODE);
    eval 'sub OBP_BADNODE () {(( &dnode_t)-1);}' unless defined(&OBP_BADNODE);
    eval 'sub OBP_NAME () {"name";}' unless defined(&OBP_NAME);
    eval 'sub OBP_REG () {"reg";}' unless defined(&OBP_REG);
    eval 'sub OBP_INTR () {"intr";}' unless defined(&OBP_INTR);
    eval 'sub OBP_RANGES () {"ranges";}' unless defined(&OBP_RANGES);
    eval 'sub OBP_INTERRUPTS () {"interrupts";}' unless defined(&OBP_INTERRUPTS);
    eval 'sub OBP_COMPATIBLE () {"compatible";}' unless defined(&OBP_COMPATIBLE);
    eval 'sub OBP_STATUS () {"status";}' unless defined(&OBP_STATUS);
    eval 'sub OBP_BOARDNUM () {"board#";}' unless defined(&OBP_BOARDNUM);
    eval 'sub OBP_MAC_ADDR () {"mac-address";}' unless defined(&OBP_MAC_ADDR);
    eval 'sub OBP_STDINPATH () {"stdin-path";}' unless defined(&OBP_STDINPATH);
    eval 'sub OBP_STDOUTPATH () {"stdout-path";}' unless defined(&OBP_STDOUTPATH);
    eval 'sub OBP_IDPROM () {"idprom";}' unless defined(&OBP_IDPROM);
    eval 'sub OBP_DEVICETYPE () {"device_type";}' unless defined(&OBP_DEVICETYPE);
    eval 'sub OBP_DISPLAY () {"display";}' unless defined(&OBP_DISPLAY);
    eval 'sub OBP_NETWORK () {"network";}' unless defined(&OBP_NETWORK);
    eval 'sub OBP_BYTE () {"byte";}' unless defined(&OBP_BYTE);
    eval 'sub OBP_BLOCK () {"block";}' unless defined(&OBP_BLOCK);
    eval 'sub OBP_SERIAL () {"serial";}' unless defined(&OBP_SERIAL);
    eval 'sub OBP_HIERARCHICAL () {"hierarchical";}' unless defined(&OBP_HIERARCHICAL);
    eval 'sub OBP_IPI () {"ipi3";}' unless defined(&OBP_IPI);
    eval 'sub OBP_CPU () {"cpu";}' unless defined(&OBP_CPU);
    eval 'sub OBP_ADDRESS () {"address";}' unless defined(&OBP_ADDRESS);
    eval 'sub OBP_ST_OKAY () {"okay";}' unless defined(&OBP_ST_OKAY);
    eval 'sub OBP_ST_DISABLED () {"disabled";}' unless defined(&OBP_ST_DISABLED);
    eval 'sub OBP_ST_FAIL () {"fail";}' unless defined(&OBP_ST_FAIL);
    eval 'sub OBP_MAXDRVNAME () {32;}' unless defined(&OBP_MAXDRVNAME);
    eval 'sub OBP_MAXPROPNAME () {32;}' unless defined(&OBP_MAXPROPNAME);
    eval 'sub OBP_MAXPATHLEN () {256;}' unless defined(&OBP_MAXPATHLEN);
    eval 'sub OBP_STACKDEPTH () {( &OBP_MAXPATHLEN/3);}' unless defined(&OBP_STACKDEPTH);
    eval 'sub ROMVEC_BLKSIZE () {512;}' unless defined(&ROMVEC_BLKSIZE);
    eval 'sub OBP_MB_IDLE_LOW () {((0x90));}' unless defined(&OBP_MB_IDLE_LOW);
    eval 'sub OBP_MB_IDLE_HIGH () {((0xef));}' unless defined(&OBP_MB_IDLE_HIGH);
    eval 'sub OBP_MB_IS_IDLE {
        my($s) = @_;
	    eval q(((($s) >=  &OBP_MB_IDLE_LOW)  && (($s) <=  &OBP_MB_IDLE_HIGH)));
    }' unless defined(&OBP_MB_IS_IDLE);
    eval 'sub OBP_MB_ACTIVE () {((0xf0));}' unless defined(&OBP_MB_ACTIVE);
    eval 'sub OBP_MB_EXIT_STOP () {((0xfb));}' unless defined(&OBP_MB_EXIT_STOP);
    eval 'sub OBP_MB_ENTER_IDLE () {((0xfc));}' unless defined(&OBP_MB_ENTER_IDLE);
    eval 'sub OBP_MB_BRKPT_IDLE () {((0xfd));}' unless defined(&OBP_MB_BRKPT_IDLE);
    eval 'sub OBP_MB_WATCHDOG_STOP () {((0xfe));}' unless defined(&OBP_MB_WATCHDOG_STOP);
    eval 'sub INKEYB () {0;}' unless defined(&INKEYB);
    eval 'sub INUARTA () {1;}' unless defined(&INUARTA);
    eval 'sub INUARTB () {2;}' unless defined(&INUARTB);
    eval 'sub INUARTC () {3;}' unless defined(&INUARTC);
    eval 'sub INUARTD () {4;}' unless defined(&INUARTD);
    eval 'sub OUTSCREEN () {0;}' unless defined(&OUTSCREEN);
    eval 'sub OUTUARTA () {1;}' unless defined(&OUTUARTA);
    eval 'sub OUTUARTB () {2;}' unless defined(&OUTUARTB);
    eval 'sub OUTUARTC () {3;}' unless defined(&OUTUARTC);
    eval 'sub OUTUARTD () {4;}' unless defined(&OUTUARTD);
    if(defined(&__cplusplus)) {
    }
}
1;
