require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PANIC_H)) {
    eval 'sub _SYS_PANIC_H () {1;}' unless defined(&_SYS_PANIC_H);
    if(!defined( &_ASM)) {
	require 'sys/types.ph';
	require 'sys/thread.ph';
	require 'sys/cpuvar.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&_LP64)) {
	eval 'sub PANICSTKSIZE () {16384;}' unless defined(&PANICSTKSIZE);
    } else {
	eval 'sub PANICSTKSIZE () {8192;}' unless defined(&PANICSTKSIZE);
    }
    eval 'sub PANICBUFSIZE () {8192;}' unless defined(&PANICBUFSIZE);
    eval 'sub PANICBUFVERS () {1;}' unless defined(&PANICBUFVERS);
    eval 'sub PANICNVNAMELEN () {16;}' unless defined(&PANICNVNAMELEN);
    if(!defined( &_ASM)) {
	if(defined( &_KERNEL)) {
	    eval 'sub PANICNVGET {
	        my($pdp) = @_;
    		eval q((($pdp)-> &pd_nvdata + ((($pdp)-> &pd_msgoff - ($sizeof{ &panic_data_t} - $sizeof{ &panic_nv_t})) / $sizeof{ &panic_nv_t})));
	    }' unless defined(&PANICNVGET);
	    eval 'sub PANICNVADD {
	        my($pnv, $n, $v) = @_;
    		eval q({ ( &void)  &strncpy(($pnv)-> &pnv_name, ($n),  &PANICNVNAMELEN); ($pnv)-> &pnv_value = ( &uint64_t)($v); ($pnv)++; });
	    }' unless defined(&PANICNVADD);
	    eval 'sub PANICNVSET {
	        my($pdp, $pnv) = @_;
    		eval q(($pdp)-> &pd_msgoff = ( &uint32_t)( - ($pdp)););
	    }' unless defined(&PANICNVSET);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
