require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PCMCIA_H)) {
    eval 'sub _PCMCIA_H () {1;}' unless defined(&_PCMCIA_H);
    if(defined(&__cplusplus)) {
    }
    if(defined( &DEBUG)) {
	eval 'sub PCMCIA_DEBUG () {1;}' unless defined(&PCMCIA_DEBUG);
    }
    require 'sys/modctl.ph';
    eval 'sub PCMCIA_MAX_ADAPTERS () {8;}' unless defined(&PCMCIA_MAX_ADAPTERS);
    eval 'sub PCMCIA_MAX_SOCKETS () {64;}' unless defined(&PCMCIA_MAX_SOCKETS);
    eval 'sub PCMCIA_MAX_WIN_ADAPT () {40;}' unless defined(&PCMCIA_MAX_WIN_ADAPT);
    eval 'sub PCMCIA_MAX_WINDOWS () {( &PCMCIA_MAX_ADAPTERS* &PCMCIA_MAX_WIN_ADAPT);}' unless defined(&PCMCIA_MAX_WINDOWS);
    eval 'sub PCMCIA_MAX_POWER () {16;}' unless defined(&PCMCIA_MAX_POWER);
    eval 'sub _VERSION {
        my($major, $minor) = @_;
	    eval q((($major)<<16|($minor)));
    }' unless defined(&_VERSION);
    eval 'sub PCMCIA_NEXUS_NAME () {"pcmcia";}' unless defined(&PCMCIA_NEXUS_NAME);
    eval 'sub PCMCIA_ADAPTER_NODE () {"ddi_pcmcia:adapter";}' unless defined(&PCMCIA_ADAPTER_NODE);
    eval 'sub PCMCIA_SOCKET_NODE () {"ddi_pcmcia:socket";}' unless defined(&PCMCIA_SOCKET_NODE);
    eval 'sub PCMCIA_PCCARD_NODE () {"ddi_pcmcia:pccard";}' unless defined(&PCMCIA_PCCARD_NODE);
    eval 'sub PCIF_MAGIC () {0x50434946;}' unless defined(&PCIF_MAGIC);
    eval 'sub PCIF_VERSION () { &_VERSION(0, 1);}' unless defined(&PCIF_VERSION);
    eval 'sub PCIF_MIN_VERSION () { &_VERSION(0, 1);}' unless defined(&PCIF_MIN_VERSION);
    eval 'sub DEFAULT_CS_NAME () {"cs";}' unless defined(&DEFAULT_CS_NAME);
    eval 'sub PPD_CARD_MULTI () {0x1;}' unless defined(&PPD_CARD_MULTI);
    eval 'sub PPD_CARD_CARDBUS () {0x2;}' unless defined(&PPD_CARD_CARDBUS);
    eval 'sub PPD_CB_BUSMASTER () {0x4;}' unless defined(&PPD_CB_BUSMASTER);
    eval 'sub PPD_SUSPENDED () {0x8;}' unless defined(&PPD_SUSPENDED);
    eval 'sub GET_SOCKET_STATUS {
        my($f, $dip, $sock, $stat) = @_;
	    eval q((*($f)-> &pcif_get_socket_status)($dip, $sock, $stat));
    }' unless defined(&GET_SOCKET_STATUS);
    eval 'sub SET_CALLBACK {
        my($f, $dip, $callback, $sock) = @_;
	    eval q((*($f)-> &pcif_set_callback)($dip, $callback, $sock));
    }' unless defined(&SET_CALLBACK);
    eval 'sub GET_ADAPTER {
        my($f, $dip, $conf) = @_;
	    eval q((*($f)-> &pcif_get_adapter) ($dip, $conf));
    }' unless defined(&GET_ADAPTER);
    eval 'sub GET_SOCKET {
        my($f, $dip, $sock) = @_;
	    eval q((*($f)-> &pcif_get_socket)($dip, $sock));
    }' unless defined(&GET_SOCKET);
    eval 'sub GET_STATUS {
        my($f, $dip, $status) = @_;
	    eval q((*($f)-> &pcif_get_status)($dip, $status));
    }' unless defined(&GET_STATUS);
    eval 'sub GET_WINDOW {
        my($f, $dip, $window) = @_;
	    eval q((*($f)-> &pcif_get_window)($dip, $window));
    }' unless defined(&GET_WINDOW);
    eval 'sub INQUIRE_ADAPTER {
        my($f, $dip, $inquire) = @_;
	    eval q((*($f)-> &pcif_inquire_adapter)($dip, $inquire));
    }' unless defined(&INQUIRE_ADAPTER);
    eval 'sub GET_CONFIG {
        my($f, $dip, $conf) = @_;
	    eval q( &INQUIRE_ADAPTER($f, $dip, $conf));
    }' unless defined(&GET_CONFIG);
    eval 'sub INQUIRE_SOCKET {
        my($f, $dip, $sock) = @_;
	    eval q((*($f)-> &pcif_inquire_socket)($dip, $sock));
    }' unless defined(&INQUIRE_SOCKET);
    eval 'sub GET_PAGE {
        my($f, $dip, $page) = @_;
	    eval q((*($f)-> &pcif_get_page)($dip, $page));
    }' unless defined(&GET_PAGE);
    eval 'sub INQUIRE_WINDOW {
        my($f, $dip, $window) = @_;
	    eval q((*($f)-> &pcif_inquire_window)($dip, $window));
    }' unless defined(&INQUIRE_WINDOW);
    eval 'sub RESET_SOCKET {
        my($f, $dip, $socket, $mode) = @_;
	    eval q((*($f)-> &pcif_reset_socket)($dip, $socket, $mode));
    }' unless defined(&RESET_SOCKET);
    eval 'sub SET_PAGE {
        my($f, $dip, $page) = @_;
	    eval q((*($f)-> &pcif_set_page)($dip, $page));
    }' unless defined(&SET_PAGE);
    eval 'sub SET_WINDOW {
        my($f, $dip, $window) = @_;
	    eval q((*($f)-> &pcif_set_window)($dip, $window));
    }' unless defined(&SET_WINDOW);
    eval 'sub SET_SOCKET {
        my($f, $dip, $socket) = @_;
	    eval q((*($f)-> &pcif_set_socket)($dip, $socket));
    }' unless defined(&SET_SOCKET);
    eval 'sub SET_IRQ {
        my($f, $dip, $handler) = @_;
	    eval q((*($f)-> &pcif_set_interrupt)($dip, $handler));
    }' unless defined(&SET_IRQ);
    eval 'sub CLEAR_IRQ {
        my($f, $dip, $handler) = @_;
	    eval q((*($f)-> &pcif_clr_interrupt)($dip, $handler));
    }' unless defined(&CLEAR_IRQ);
    eval 'sub PCCS_MAGIC () {0x50434353;}' unless defined(&PCCS_MAGIC);
    eval 'sub PCCS_VERSION () { &_VERSION(2, 1);}' unless defined(&PCCS_VERSION);
    eval 'sub ADAPT_PROP () {"adapters";}' unless defined(&ADAPT_PROP);
    eval 'sub CS_PROP () {"card-services";}' unless defined(&CS_PROP);
    eval 'sub DEF_DRV_PROP () {"default-driver";}' unless defined(&DEF_DRV_PROP);
    eval 'sub PCA_RES_NEED_IRQ () {0x1;}' unless defined(&PCA_RES_NEED_IRQ);
    eval 'sub PCA_RES_NEED_IO () {0x2;}' unless defined(&PCA_RES_NEED_IO);
    eval 'sub PCA_RES_NEED_MEM () {0x4;}' unless defined(&PCA_RES_NEED_MEM);
    eval 'sub PCA_RES_CONSTRAINT () {0x8;}' unless defined(&PCA_RES_CONSTRAINT);
    eval 'sub PCA_IRQ_SMI_SHARE () {0x10;}' unless defined(&PCA_IRQ_SMI_SHARE);
    eval 'sub PCA_IRQ_SHAREABLE () {0x20;}' unless defined(&PCA_IRQ_SHAREABLE);
    eval 'sub PCA_IRQ_ISA () {0x40;}' unless defined(&PCA_IRQ_ISA);
    eval 'sub PCA_IO_OPENED () {0x100;}' unless defined(&PCA_IO_OPENED);
    eval 'sub PCMCIA_MAX_FUNCTIONS () {8;}' unless defined(&PCMCIA_MAX_FUNCTIONS);
    eval 'sub PCS_CARD_PRESENT () {0x1;}' unless defined(&PCS_CARD_PRESENT);
    eval 'sub PCS_MULTI_FUNCTION () {0x2;}' unless defined(&PCS_MULTI_FUNCTION);
    eval 'sub PCS_SOCKET_ADDED () {0x4;}' unless defined(&PCS_SOCKET_ADDED);
    eval 'sub PCS_COOKIES_VALID () {0x8;}' unless defined(&PCS_COOKIES_VALID);
    eval 'sub PCS_IRQ_ENABLED () {0x10;}' unless defined(&PCS_IRQ_ENABLED);
    eval 'sub PCS_SUSPENDED () {0x20;}' unless defined(&PCS_SUSPENDED);
    eval 'sub PCS_ENABLED () {0x2;}' unless defined(&PCS_ENABLED);
    eval 'sub EM_EVENTSIZE () {4;}' unless defined(&EM_EVENTSIZE);
    eval 'sub PR_WORDSIZE () {8;}' unless defined(&PR_WORDSIZE);
    eval 'sub PR_MASK () {0x7;}' unless defined(&PR_MASK);
    eval 'sub PR_GET {
        my($map, $bit) = @_;
	    eval q(((( &uchar_t *)($map))[($bit)/ &PR_WORDSIZE] & (1<< (($bit) &  &PR_MASK))));
    }' unless defined(&PR_GET);
    eval 'sub PR_SET {
        my($map, $bit) = @_;
	    eval q(((( &uchar_t *)($map))[($bit)/ &PR_WORDSIZE] |= (1<< (($bit) &  &PR_MASK))));
    }' unless defined(&PR_SET);
    eval 'sub PR_CLEAR {
        my($map, $bit) = @_;
	    eval q(((( &uchar_t *)($map))[($bit)/ &PR_WORDSIZE] &= ~(1<< (($bit) &  &PR_MASK))));
    }' unless defined(&PR_CLEAR);
    eval 'sub PR_ADDR {
        my($map, $bit) = @_;
	    eval q(((( &uchar_t *)($map)) + (($bit)/ &PR_WORDSIZE)));
    }' unless defined(&PR_ADDR);
    eval 'sub PR_ZERO {
        my($map) = @_;
	    eval q( &bzero($map, $sizeof{$map}));
    }' unless defined(&PR_ZERO);
    eval 'sub PR_MAX_IO_LEN () {1024;}' unless defined(&PR_MAX_IO_LEN);
    eval 'sub PR_MAX_IO_RANGES () {4;}' unless defined(&PR_MAX_IO_RANGES);
    eval 'sub PR_MAX_MEM_LEN () {1024;}' unless defined(&PR_MAX_MEM_LEN);
    eval 'sub PR_MAX_MEM_RANGES () {32;}' unless defined(&PR_MAX_MEM_RANGES);
    eval 'sub PR_MAX_IOADDR () {0xffffffff;}' unless defined(&PR_MAX_IOADDR);
    eval 'sub PR_MAX_MEMADDR () {0xffffffff;}' unless defined(&PR_MAX_MEMADDR);
    eval 'sub PR_MAX_INTERRUPTS () {0xff;}' unless defined(&PR_MAX_INTERRUPTS);
    eval 'sub PC_SUCCESS () {1;}' unless defined(&PC_SUCCESS);
    eval 'sub PC_FAILURE () {0;}' unless defined(&PC_FAILURE);
    eval 'sub PC_MEM_AM () {0;}' unless defined(&PC_MEM_AM);
    eval 'sub PC_MEM_CM () {1;}' unless defined(&PC_MEM_CM);
    eval 'sub PCC_MULTI () {0;}' unless defined(&PCC_MULTI);
    eval 'sub PCC_MEMORY () {1;}' unless defined(&PCC_MEMORY);
    eval 'sub PCC_SERIAL () {2;}' unless defined(&PCC_SERIAL);
    eval 'sub PCC_PARALLEL () {3;}' unless defined(&PCC_PARALLEL);
    eval 'sub PCC_FIXED_DISK () {4;}' unless defined(&PCC_FIXED_DISK);
    eval 'sub PCC_VIDEO () {5;}' unless defined(&PCC_VIDEO);
    eval 'sub PCC_LAN () {6;}' unless defined(&PCC_LAN);
    eval 'sub PCM_GET_SOCKET {
        my($socknum) = @_;
	    eval q((($socknum) & 0x1f));
    }' unless defined(&PCM_GET_SOCKET);
    eval 'sub PCM_GET_FUNCTION {
        my($socknum) = @_;
	    eval q(((($socknum) >> 5) & 0x7));
    }' unless defined(&PCM_GET_FUNCTION);
    eval 'sub PCM_DEFAULT_NODEID () {(-1);}' unless defined(&PCM_DEFAULT_NODEID);
    eval 'sub PCM_DEV_MODEL () {"model";}' unless defined(&PCM_DEV_MODEL);
    eval 'sub PCM_DEV_ACTIVE () {"card-active";}' unless defined(&PCM_DEV_ACTIVE);
    eval 'sub PCM_DEV_SOCKET () {"socket";}' unless defined(&PCM_DEV_SOCKET);
    eval 'sub PCM_DEV_R2TYPE () {"16bitcard";}' unless defined(&PCM_DEV_R2TYPE);
    eval 'sub PCM_DEV_CARDBUS () {"cardbus";}' unless defined(&PCM_DEV_CARDBUS);
    eval 'sub PCMD_DEVTYPE () {0x1;}' unless defined(&PCMD_DEVTYPE);
    eval 'sub PCMD_FUNCID () {0x2;}' unless defined(&PCMD_FUNCID);
    eval 'sub PCMD_MANFID () {0x4;}' unless defined(&PCMD_MANFID);
    eval 'sub PCMD_FUNCE () {0x8;}' unless defined(&PCMD_FUNCE);
    eval 'sub PCMD_VERS1 () {0x10;}' unless defined(&PCMD_VERS1);
    eval 'sub PCMD_JEDEC () {0x20;}' unless defined(&PCMD_JEDEC);
    eval 'sub PCM_NAME_1275 () {0x1;}' unless defined(&PCM_NAME_1275);
    eval 'sub PCM_NAME_VERS1 () {0x2;}' unless defined(&PCM_NAME_VERS1);
    eval 'sub PCM_NAME_GENERIC () {0x4;}' unless defined(&PCM_NAME_GENERIC);
    eval 'sub PCM_NO_CONFIG () {0x8;}' unless defined(&PCM_NO_CONFIG);
    eval 'sub PCM_OTHER_NOCIS () {0x100;}' unless defined(&PCM_OTHER_NOCIS);
    eval 'sub PCM_MULTI_FUNCTION () {0x200;}' unless defined(&PCM_MULTI_FUNCTION);
    eval 'sub PCM_MAX_R2_MEM () {0x3ffffff;}' unless defined(&PCM_MAX_R2_MEM);
    eval 'sub PCMDEV_PREFIX () {"PC,";}' unless defined(&PCMDEV_PREFIX);
    eval 'sub PCMDEV_NAMEPREF () {"pccard";}' unless defined(&PCMDEV_NAMEPREF);
    eval 'sub PCM_PROP_DEVICE () {"device";}' unless defined(&PCM_PROP_DEVICE);
    eval 'sub PCM_PROP_FUNCID () {"funcid";}' unless defined(&PCM_PROP_FUNCID);
    eval 'sub PCM_1275_NUMWIN () {"#windows";}' unless defined(&PCM_1275_NUMWIN);
    eval 'sub PCM_1275_NUMSOCK () {"#sockets";}' unless defined(&PCM_1275_NUMSOCK);
    eval 'sub PCM_1275_SCIC () {"status-change-int_caps";}' unless defined(&PCM_1275_SCIC);
    eval 'sub PCM_TYPE_MULTI () {0;}' unless defined(&PCM_TYPE_MULTI);
    eval 'sub PCM_TYPE_MEMORY () {1;}' unless defined(&PCM_TYPE_MEMORY);
    eval 'sub PCM_TYPE_SERIAL () {2;}' unless defined(&PCM_TYPE_SERIAL);
    eval 'sub PCM_TYPE_PARALLEL () {3;}' unless defined(&PCM_TYPE_PARALLEL);
    eval 'sub PCM_TYPE_FIXED () {4;}' unless defined(&PCM_TYPE_FIXED);
    eval 'sub PCM_TYPE_VIDEO () {5;}' unless defined(&PCM_TYPE_VIDEO);
    eval 'sub PCM_TYPE_LAN () {6;}' unless defined(&PCM_TYPE_LAN);
    eval 'sub PCIOC () {(ord(\'P\') << 8);}' unless defined(&PCIOC);
    eval 'sub PC_SS_CMD {
        my($cmd) = @_;
	    eval q(( &PCIOC|($cmd)));
    }' unless defined(&PC_SS_CMD);
    eval 'sub PCM_DEVICETYPE () {"device_type";}' unless defined(&PCM_DEVICETYPE);
    eval 'sub PC_REG_RELOC {
        my($x) = @_;
	    eval q((((( &uint32_t)$x) & 0x1) << 31));
    }' unless defined(&PC_REG_RELOC);
    eval 'sub PC_REG_PREFETCH {
        my($x) = @_;
	    eval q(((($x) & 0x1) << 30));
    }' unless defined(&PC_REG_PREFETCH);
    eval 'sub PC_REG_TYPE {
        my($x) = @_;
	    eval q(((($x) & 0x1) << 29));
    }' unless defined(&PC_REG_TYPE);
    eval 'sub PC_REG_SPACE {
        my($x) = @_;
	    eval q(((($x) & 0x7) << 24));
    }' unless defined(&PC_REG_SPACE);
    eval 'sub PC_REG_SOCKET {
        my($x) = @_;
	    eval q(((($x) & 0x1f) << 11));
    }' unless defined(&PC_REG_SOCKET);
    eval 'sub PC_REG_FUNCTION {
        my($x) = @_;
	    eval q(((($x) & 0x7) << 8));
    }' unless defined(&PC_REG_FUNCTION);
    eval 'sub PC_REG_BASEREG {
        my($x) = @_;
	    eval q((($x) & 0xff));
    }' unless defined(&PC_REG_BASEREG);
    eval 'sub PC_REG_REFCNT {
        my($x) = @_;
	    eval q(((($x) & 0xff) << 16));
    }' unless defined(&PC_REG_REFCNT);
    eval 'sub PC_GET_REG_RELOC {
        my($x) = @_;
	    eval q(((($x) >> 31) & 1));
    }' unless defined(&PC_GET_REG_RELOC);
    eval 'sub PC_GET_REG_PREFETCH {
        my($x) = @_;
	    eval q(((($x) >> 30) & 1));
    }' unless defined(&PC_GET_REG_PREFETCH);
    eval 'sub PC_GET_REG_TYPE {
        my($x) = @_;
	    eval q(((($x) >> 29) & 1));
    }' unless defined(&PC_GET_REG_TYPE);
    eval 'sub PC_GET_REG_SPACE {
        my($x) = @_;
	    eval q(((($x) >> 24) & 7));
    }' unless defined(&PC_GET_REG_SPACE);
    eval 'sub PC_GET_REG_SOCKET {
        my($x) = @_;
	    eval q(((($x) >> 11) & 0x1f));
    }' unless defined(&PC_GET_REG_SOCKET);
    eval 'sub PC_GET_REG_FUNCTION {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0x7));
    }' unless defined(&PC_GET_REG_FUNCTION);
    eval 'sub PC_GET_REG_BASEREG {
        my($x) = @_;
	    eval q((($x) & 0xff));
    }' unless defined(&PC_GET_REG_BASEREG);
    eval 'sub PC_GET_REG_REFCNT {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xff));
    }' unless defined(&PC_GET_REG_REFCNT);
    eval 'sub PC_INCR_REFCNT {
        my($x) = @_;
	    eval q(((($x) & 0xff00ffff) |  &PC_REG_REFCNT( &PC_GET_REG_REFCNT($x) + 1)));
    }' unless defined(&PC_INCR_REFCNT);
    eval 'sub PC_DECR_REFCNT {
        my($x) = @_;
	    eval q(((($x) & 0xff00ffff) |  &PC_REG_REFCNT( &PC_GET_REG_REFCNT($x) - 1)));
    }' unless defined(&PC_DECR_REFCNT);
    eval 'sub PC_REG_PHYS_HI {
        my($n, $p, $t, $c, $s, $f, $r) = @_;
	    eval q(( &uint32_t)(  &PC_REG_RELOC($n) |  &PC_REG_PREFETCH($p) |  &PC_REG_TYPE($t) |  &PC_REG_SPACE($c) |  &PC_REG_SOCKET($s) |  &PC_REG_FUNCTION($f) |  &PC_REG_BASEREG($r)));
    }' unless defined(&PC_REG_PHYS_HI);
    eval 'sub PC_REG_TYPE_CARDBUS () {0;}' unless defined(&PC_REG_TYPE_CARDBUS);
    eval 'sub PC_REG_TYPE_16BIT () {1;}' unless defined(&PC_REG_TYPE_16BIT);
    eval 'sub PC_REG_SPACE_CONFIG () {0x;}' unless defined(&PC_REG_SPACE_CONFIG);
    eval 'sub PC_REG_SPACE_IO () {0x1;}' unless defined(&PC_REG_SPACE_IO);
    eval 'sub PC_REG_SPACE_MEMORY () {0x2;}' unless defined(&PC_REG_SPACE_MEMORY);
    eval 'sub PC_REG_SPACE_ATTRIBUTE () {0x4;}' unless defined(&PC_REG_SPACE_ATTRIBUTE);
    eval 'sub PCMCIA_PROP_UNKNOWN () {0x10000;}' unless defined(&PCMCIA_PROP_UNKNOWN);
    eval 'sub PCMCIA_PROP_CIS () {0x20000;}' unless defined(&PCMCIA_PROP_CIS);
    eval 'sub PCMCIA_PROP_SOCKET () {0;}' unless defined(&PCMCIA_PROP_SOCKET);
    eval 'sub PCMCIA_PROP_COMPAT () {1;}' unless defined(&PCMCIA_PROP_COMPAT);
    eval 'sub PCMCIA_PROP_DEFAULT_PM () {2;}' unless defined(&PCMCIA_PROP_DEFAULT_PM);
    eval 'sub PCMCIA_PROP_ACTIVE () {3;}' unless defined(&PCMCIA_PROP_ACTIVE);
    eval 'sub PCMCIA_PROP_R2TYPE () {4;}' unless defined(&PCMCIA_PROP_R2TYPE);
    eval 'sub PCMCIA_PROP_CARDBUS () {5;}' unless defined(&PCMCIA_PROP_CARDBUS);
    eval 'sub PCMCIA_PROP_OLDCS () {6;}' unless defined(&PCMCIA_PROP_OLDCS);
    eval 'sub PCMCIA_PROP_REG () {7;}' unless defined(&PCMCIA_PROP_REG);
    eval 'sub PCMCIA_PROP_INTR () {8;}' unless defined(&PCMCIA_PROP_INTR);
    if(defined(&__cplusplus)) {
    }
}
1;
