require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PCRAMVAR_H)) {
    eval 'sub _PCRAMVAR_H () {1;}' unless defined(&_PCRAMVAR_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub PCRAM_GETMEDIA () {( &PCRAMIOC|21);}' unless defined(&PCRAM_GETMEDIA);
    eval 'sub PCRAM_PROBESIZE () {( &PCRAMIOC|22);}' unless defined(&PCRAM_PROBESIZE);
    eval 'sub PCMM_TYPE_RAM () {0x1;}' unless defined(&PCMM_TYPE_RAM);
    eval 'sub PCMM_TYPE_FLASH () {0x2;}' unless defined(&PCMM_TYPE_FLASH);
    eval 'sub PCMM_TYPE_EEPROM () {0x4;}' unless defined(&PCMM_TYPE_EEPROM);
    eval 'sub PCMM_TYPE_OTP () {0x8;}' unless defined(&PCMM_TYPE_OTP);
    eval 'sub PCRAM_DEBUG_TRACE () {0x1;}' unless defined(&PCRAM_DEBUG_TRACE);
    eval 'sub PCRAM_DEBUG_SIZE () {0x100;}' unless defined(&PCRAM_DEBUG_SIZE);
    eval 'sub PCRAM_DEBUG_CARD_STATUS () {0x200;}' unless defined(&PCRAM_DEBUG_CARD_STATUS);
    eval 'sub PCRAM_DEBUG_VOLD () {0x400;}' unless defined(&PCRAM_DEBUG_VOLD);
    eval 'sub PCRAM_DEBUG_CIS () {0x800;}' unless defined(&PCRAM_DEBUG_CIS);
    unless(defined(&DKIOCREMOVABLE)) {
	eval 'sub DKIOCREMOVABLE () {( &DKIOC|16);}' unless defined(&DKIOCREMOVABLE);
    }
    eval 'sub PCRAM_CLIENT_DESCRIPTION () {"PCMCIA SRAM memory card driver";}' unless defined(&PCRAM_CLIENT_DESCRIPTION);
    eval 'sub PCRAM_VENDOR_DESCRIPTION () { &CS_SUN_VENDOR_DESCRIPTION;}' unless defined(&PCRAM_VENDOR_DESCRIPTION);
    eval 'sub PCRAM_REV_LEVEL () {0x100;}' unless defined(&PCRAM_REV_LEVEL);
    eval 'sub PCRAM_REV_DAY () {01;}' unless defined(&PCRAM_REV_DAY);
    eval 'sub PCRAM_REV_MONTH () {4;}' unless defined(&PCRAM_REV_MONTH);
    eval 'sub PCRAM_REV_YEAR () {16;}' unless defined(&PCRAM_REV_YEAR);
    eval 'sub PCRAM_REV_DATE () { &CS_CLIENT_INFO_MAKE_DATE(  &PCRAM_REV_DAY,  &PCRAM_REV_MONTH,  &PCRAM_REV_YEAR);}' unless defined(&PCRAM_REV_DATE);
    eval 'sub PCRAM_CARD_PRESENT {
        my($rs) = @_;
	    eval q((($rs)-> &card_event &  &PCRAM_CARD_INSERTED));
    }' unless defined(&PCRAM_CARD_PRESENT);
    eval 'sub PCRAM_CARD_INSERTION_TIMEOUT () { &SEC_TO_TICK(60);}' unless defined(&PCRAM_CARD_INSERTION_TIMEOUT);
    eval 'sub PCRAM_DRIVERID () {"PCMCIA Memory Card Driver V2.0";}' unless defined(&PCRAM_DRIVERID);
    eval 'sub PCRAM_NAME () {"pcram";}' unless defined(&PCRAM_NAME);
    eval 'sub PCRAM_DKC_CNAME () { &PCRAM_NAME;}' unless defined(&PCRAM_DKC_CNAME);
    eval 'sub PCRAM_DKC_DNAME () {"pccard";}' unless defined(&PCRAM_DKC_DNAME);
    eval 'sub PCRAM_SOCKET {
        my($dev) = @_;
	    eval q((( &getminor($dev) >> 10) & 0x3f));
    }' unless defined(&PCRAM_SOCKET);
    eval 'sub PCRAM_PARTTION {
        my($dev) = @_;
	    eval q(( &getminor($dev) & 0x3ff));
    }' unless defined(&PCRAM_PARTTION);
    eval 'sub PCRAM_SETMINOR {
        my($skt, $part) = @_;
	    eval q((($skt<<10) | ($part)));
    }' unless defined(&PCRAM_SETMINOR);
    eval 'sub HOST_BUF_SIZE () {(1*1024);}' unless defined(&HOST_BUF_SIZE);
    eval 'sub PCRAM_SOFTINTROK () {0x1;}' unless defined(&PCRAM_SOFTINTROK);
    eval 'sub PCRAM_REGCLIENT () {0x2;}' unless defined(&PCRAM_REGCLIENT);
    eval 'sub PCRAM_DIDLOCKS () {0x4;}' unless defined(&PCRAM_DIDLOCKS);
    eval 'sub PCRAM_REQSOCKMASK () {0x8;}' unless defined(&PCRAM_REQSOCKMASK);
    eval 'sub PCRAM_ATTACHOK () {0x10;}' unless defined(&PCRAM_ATTACHOK);
    eval 'sub PCRAM_HAS_WINDOW () {0x20;}' unless defined(&PCRAM_HAS_WINDOW);
    eval 'sub PCRAM_CARD_INSERTED () {0x1;}' unless defined(&PCRAM_CARD_INSERTED);
    eval 'sub PCRAM_WRITE_PROTECT () {0x2;}' unless defined(&PCRAM_WRITE_PROTECT);
    eval 'sub PCRAM_FIRST_OPEN () {0x4;}' unless defined(&PCRAM_FIRST_OPEN);
    eval 'sub GET_NCYL {
        my($cs, $hd, $ss, $st) = @_;
	    eval q(($cs/($hd*$ss*$st)));
    }' unless defined(&GET_NCYL);
    eval 'sub GET_CSIZ {
        my($cyl, $hd, $ss, $st) = @_;
	    eval q(($cyl*$hd*$ss*$st));
    }' unless defined(&GET_CSIZ);
    eval 'sub GET_CSIZ_DOS {
        my($tsec, $ss) = @_;
	    eval q(($tsec*$ss));
    }' unless defined(&GET_CSIZ_DOS);
    eval 'sub GET_INFO {
        my($b0, $b1) = @_;
	    eval q(($b0 | $b1 << 8));
    }' unless defined(&GET_INFO);
    eval 'sub SIZE_1KB () {(1024);}' unless defined(&SIZE_1KB);
    eval 'sub HALF_MEG () {(512* 1024);}' unless defined(&HALF_MEG);
    eval 'sub MAX_CARD_SIZE () {(64* 1024* 1024);}' unless defined(&MAX_CARD_SIZE);
    eval 'sub PATTERN_1 () {0x55;}' unless defined(&PATTERN_1);
    eval 'sub PATTERN_2 () {0xaa;}' unless defined(&PATTERN_2);
    eval 'sub UNRECOGNIZED_MEDIA () {-1;}' unless defined(&UNRECOGNIZED_MEDIA);
    eval 'sub DEFAULT_CM_SPEED () {250;}' unless defined(&DEFAULT_CM_SPEED);
    eval 'sub REGION_DEFAULT () {0x1;}' unless defined(&REGION_DEFAULT);
    eval 'sub REGION_READONLY () {0x2;}' unless defined(&REGION_READONLY);
    eval 'sub REGION_DOS_BPBFAT () {0x4;}' unless defined(&REGION_DOS_BPBFAT);
    eval 'sub REGION_SOLARIS () {0x8;}' unless defined(&REGION_SOLARIS);
    eval 'sub REGION_VALID () {0x10;}' unless defined(&REGION_VALID);
    eval 'sub REGION_HOLE () {0x20;}' unless defined(&REGION_HOLE);
    eval 'sub BUILD_AM_LIST () {0x1;}' unless defined(&BUILD_AM_LIST);
    eval 'sub BUILD_CM_LIST () {0x2;}' unless defined(&BUILD_CM_LIST);
    eval 'sub BUILD_DOS_BPBFAT_LIST () {0x4;}' unless defined(&BUILD_DOS_BPBFAT_LIST);
    eval 'sub BUILD_SOLARIS_LIST () {0x8;}' unless defined(&BUILD_SOLARIS_LIST);
    eval 'sub BUILD_DEFAULT_LIST () {0x10;}' unless defined(&BUILD_DEFAULT_LIST);
    eval 'sub DESTROY_AM_LIST () {0x10000;}' unless defined(&DESTROY_AM_LIST);
    eval 'sub DESTROY_CM_LIST () {0x20000;}' unless defined(&DESTROY_CM_LIST);
    if(defined(&__cplusplus)) {
    }
}
1;
