require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PROC_PRDATA_H)) {
    eval 'sub _SYS_PROC_PRDATA_H () {1;}' unless defined(&_SYS_PROC_PRDATA_H);
    require 'sys/isa_defs.ph';
    require 'sys/proc.ph';
    require 'sys/vnode.ph';
    require 'sys/prsystm.ph';
    require 'sys/model.ph';
    require 'sys/poll.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub DSTOPPED {
        my($t) = @_;
	    eval q((($t)-> &t_state ==  &TS_STOPPED  && (($t)-> &t_proc_flag &  &TP_PRSTOP)));
    }' unless defined(&DSTOPPED);
    eval 'sub round4 {
        my($r) = @_;
	    eval q(((($r) + 3) & (~3)));
    }' unless defined(&round4);
    eval 'sub round8 {
        my($r) = @_;
	    eval q(((($r) + 7) & (~7)));
    }' unless defined(&round8);
    eval 'sub round16 {
        my($r) = @_;
	    eval q(((($r) + 15) & (~15)));
    }' unless defined(&round16);
    eval 'sub roundlong {
        my($r) = @_;
	    eval q(((($r) + $sizeof{\'long\'} - 1) & (~($sizeof{\'long\'} - 1))));
    }' unless defined(&roundlong);
    eval 'sub PNSIZ () {10;}' unless defined(&PNSIZ);
    eval 'sub PLNSIZ () {10;}' unless defined(&PLNSIZ);
    eval 'sub PRC_DESTROY () {0x1;}' unless defined(&PRC_DESTROY);
    eval 'sub PRC_LWP () {0x2;}' unless defined(&PRC_LWP);
    eval 'sub PRC_SYS () {0x4;}' unless defined(&PRC_SYS);
    eval 'sub PRC_POLL () {0x8;}' unless defined(&PRC_POLL);
    eval 'sub PRC_EXCL () {0x10;}' unless defined(&PRC_EXCL);
    eval 'sub pmkino {
        my($tslot, $pslot, $nodetype) = @_;
	    eval q(((((($tslot) <<  &nproc_highbit) | ($pslot)) << 6) | ($nodetype) + 2));
    }' unless defined(&pmkino);
    eval 'sub PRBIAS () {64;}' unless defined(&PRBIAS);
    eval 'sub ptoi {
        my($n) = @_;
	    eval q((((($n) +  &PRBIAS))));
    }' unless defined(&ptoi);
    eval("sub PR_PROCDIR () { 0; }") unless defined(&PR_PROCDIR);
    eval("sub PR_PIDDIR () { 1; }") unless defined(&PR_PIDDIR);
    eval("sub PR_AS () { 2; }") unless defined(&PR_AS);
    eval("sub PR_CTL () { 3; }") unless defined(&PR_CTL);
    eval("sub PR_STATUS () { 4; }") unless defined(&PR_STATUS);
    eval("sub PR_LSTATUS () { 5; }") unless defined(&PR_LSTATUS);
    eval("sub PR_PSINFO () { 6; }") unless defined(&PR_PSINFO);
    eval("sub PR_LPSINFO () { 7; }") unless defined(&PR_LPSINFO);
    eval("sub PR_MAP () { 8; }") unless defined(&PR_MAP);
    eval("sub PR_RMAP () { 9; }") unless defined(&PR_RMAP);
    eval("sub PR_XMAP () { 10; }") unless defined(&PR_XMAP);
    eval("sub PR_CRED () { 11; }") unless defined(&PR_CRED);
    eval("sub PR_SIGACT () { 12; }") unless defined(&PR_SIGACT);
    eval("sub PR_AUXV () { 13; }") unless defined(&PR_AUXV);
    eval("sub PR_USAGE () { 14; }") unless defined(&PR_USAGE);
    eval("sub PR_LUSAGE () { 15; }") unless defined(&PR_LUSAGE);
    eval("sub PR_PAGEDATA () { 16; }") unless defined(&PR_PAGEDATA);
    eval("sub PR_WATCH () { 17; }") unless defined(&PR_WATCH);
    eval("sub PR_CURDIR () { 18; }") unless defined(&PR_CURDIR);
    eval("sub PR_ROOTDIR () { 19; }") unless defined(&PR_ROOTDIR);
    eval("sub PR_FDDIR () { 20; }") unless defined(&PR_FDDIR);
    eval("sub PR_FD () { 21; }") unless defined(&PR_FD);
    eval("sub PR_OBJECTDIR () { 22; }") unless defined(&PR_OBJECTDIR);
    eval("sub PR_OBJECT () { 23; }") unless defined(&PR_OBJECT);
    eval("sub PR_LWPDIR () { 24; }") unless defined(&PR_LWPDIR);
    eval("sub PR_LWPIDDIR () { 25; }") unless defined(&PR_LWPIDDIR);
    eval("sub PR_LWPCTL () { 26; }") unless defined(&PR_LWPCTL);
    eval("sub PR_LWPSTATUS () { 27; }") unless defined(&PR_LWPSTATUS);
    eval("sub PR_LWPSINFO () { 28; }") unless defined(&PR_LWPSINFO);
    eval("sub PR_LWPUSAGE () { 29; }") unless defined(&PR_LWPUSAGE);
    eval("sub PR_XREGS () { 30; }") unless defined(&PR_XREGS);
    eval("sub PR_PIDFILE () { 31; }") unless defined(&PR_PIDFILE);
    eval("sub PR_LWPIDFILE () { 32; }") unless defined(&PR_LWPIDFILE);
    eval("sub PR_OPAGEDATA () { 33; }") unless defined(&PR_OPAGEDATA);
    eval("sub PR_NFILES () { 34; }") unless defined(&PR_NFILES);
    eval 'sub PR_INVAL () {0x1;}' unless defined(&PR_INVAL);
    eval 'sub PR_SELF () {0x2;}' unless defined(&PR_SELF);
    eval 'sub VTOP {
        my($vp) = @_;
	    eval q((($vp)-> &v_data));
    }' unless defined(&VTOP);
    eval 'sub PTOV {
        my($pnp) = @_;
	    eval q((($pnp)-> &pr_vnode));
    }' unless defined(&PTOV);
    eval 'sub ZNO () {0;}' unless defined(&ZNO);
    eval 'sub ZYES () {1;}' unless defined(&ZYES);
    eval 'sub prassignset {
        my($ap, $sp) = @_;
	    eval q({  &register \'int\'  &_i_ = $sizeof{($ap)}/$sizeof{ &uint32_t};  &while (-- &_i_ >= 0) (( &uint32_t *)($ap))[ &_i_] = ( &_i_ >= $sizeof{($sp)}/$sizeof{ &uint32_t}) ? 0: (( &uint32_t *)($sp))[ &_i_]; });
    }' unless defined(&prassignset);
    eval 'sub prisempty {
        my($sp) = @_;
	    eval q( &setisempty(( &uint32_t *)($sp), ( &uint_t)($sizeof{($sp)} / $sizeof{ &uint32_t})));
    }' unless defined(&prisempty);
    if(defined( &_KERNEL)) {
	eval 'sub PROCESS_NOT_32BIT {
	    my($p) = @_;
    	    eval q((!(($p)-> &p_flag &  &SSYS)  && ($p)-> &p_as !=  &kas  && ($p)-> &p_model !=  &DATAMODEL_ILP32));
	}' unless defined(&PROCESS_NOT_32BIT);
	if(defined( &_SYSCALL32_IMPL)) {
	}
	if(!defined( &_SYS_OLD_PROCFS_H)) {
	    if(defined( &_SYSCALL32_IMPL)) {
	    }
	}
	if(defined( &_SYSCALL32_IMPL)) {
	}
	if(defined( &i386) || defined( &__i386)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
