require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PROCFS_ISA_H)) {
    eval 'sub _SYS_PROCFS_ISA_H () {1;}' unless defined(&_SYS_PROCFS_ISA_H);
    require 'sys/regset.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub PR_MODEL_UNKNOWN () {0;}' unless defined(&PR_MODEL_UNKNOWN);
    eval 'sub PR_MODEL_ILP32 () {1;}' unless defined(&PR_MODEL_ILP32);
    eval 'sub PR_MODEL_LP64 () {2;}' unless defined(&PR_MODEL_LP64);
    if(defined( &_LP64)) {
	eval 'sub PR_MODEL_NATIVE () { &PR_MODEL_LP64;}' unless defined(&PR_MODEL_NATIVE);
    }
 elsif(defined( &_ILP32)) {
	eval 'sub PR_MODEL_NATIVE () { &PR_MODEL_ILP32;}' unless defined(&PR_MODEL_NATIVE);
    } else {
	die("No DATAMODEL_NATIVE specified");
    }
    eval 'sub NPRGREG () {38;}' unless defined(&NPRGREG);
    if(defined( &_LP64) || defined( &_I32LPx)) {
    } else {
    }
    eval 'sub R_G0 () {0;}' unless defined(&R_G0);
    eval 'sub R_G1 () {1;}' unless defined(&R_G1);
    eval 'sub R_G2 () {2;}' unless defined(&R_G2);
    eval 'sub R_G3 () {3;}' unless defined(&R_G3);
    eval 'sub R_G4 () {4;}' unless defined(&R_G4);
    eval 'sub R_G5 () {5;}' unless defined(&R_G5);
    eval 'sub R_G6 () {6;}' unless defined(&R_G6);
    eval 'sub R_G7 () {7;}' unless defined(&R_G7);
    eval 'sub R_O0 () {8;}' unless defined(&R_O0);
    eval 'sub R_O1 () {9;}' unless defined(&R_O1);
    eval 'sub R_O2 () {10;}' unless defined(&R_O2);
    eval 'sub R_O3 () {11;}' unless defined(&R_O3);
    eval 'sub R_O4 () {12;}' unless defined(&R_O4);
    eval 'sub R_O5 () {13;}' unless defined(&R_O5);
    eval 'sub R_O6 () {14;}' unless defined(&R_O6);
    eval 'sub R_O7 () {15;}' unless defined(&R_O7);
    eval 'sub R_L0 () {16;}' unless defined(&R_L0);
    eval 'sub R_L1 () {17;}' unless defined(&R_L1);
    eval 'sub R_L2 () {18;}' unless defined(&R_L2);
    eval 'sub R_L3 () {19;}' unless defined(&R_L3);
    eval 'sub R_L4 () {20;}' unless defined(&R_L4);
    eval 'sub R_L5 () {21;}' unless defined(&R_L5);
    eval 'sub R_L6 () {22;}' unless defined(&R_L6);
    eval 'sub R_L7 () {23;}' unless defined(&R_L7);
    eval 'sub R_I0 () {24;}' unless defined(&R_I0);
    eval 'sub R_I1 () {25;}' unless defined(&R_I1);
    eval 'sub R_I2 () {26;}' unless defined(&R_I2);
    eval 'sub R_I3 () {27;}' unless defined(&R_I3);
    eval 'sub R_I4 () {28;}' unless defined(&R_I4);
    eval 'sub R_I5 () {29;}' unless defined(&R_I5);
    eval 'sub R_I6 () {30;}' unless defined(&R_I6);
    eval 'sub R_I7 () {31;}' unless defined(&R_I7);
    if(defined(&__sparcv9)) {
	eval 'sub R_CCR () {32;}' unless defined(&R_CCR);
    } else {
	eval 'sub R_PSR () {32;}' unless defined(&R_PSR);
    }
    eval 'sub R_PC () {33;}' unless defined(&R_PC);
    eval 'sub R_nPC () {34;}' unless defined(&R_nPC);
    eval 'sub R_Y () {35;}' unless defined(&R_Y);
    if(defined(&__sparcv9)) {
	eval 'sub R_ASI () {36;}' unless defined(&R_ASI);
	eval 'sub R_FPRS () {37;}' unless defined(&R_FPRS);
    } else {
	eval 'sub R_WIM () {36;}' unless defined(&R_WIM);
	eval 'sub R_TBR () {37;}' unless defined(&R_TBR);
    }
    if(defined(&__sparcv9)) {
	eval 'sub R_PS () { &R_CCR;}' unless defined(&R_PS);
    } else {
	eval 'sub R_PS () { &R_PSR;}' unless defined(&R_PS);
    }
    eval 'sub R_SP () { &R_O6;}' unless defined(&R_SP);
    eval 'sub R_FP () { &R_I6;}' unless defined(&R_FP);
    eval 'sub R_R0 () { &R_O0;}' unless defined(&R_R0);
    eval 'sub R_R1 () { &R_O1;}' unless defined(&R_R1);
    if(defined( &_SYSCALL32)) {
	eval 'sub R_PSR () {32;}' unless defined(&R_PSR);
	eval 'sub R_WIM () {36;}' unless defined(&R_WIM);
	eval 'sub R_TBR () {37;}' unless defined(&R_TBR);
    }
    if(defined(&__sparcv9)) {
    } else {
    }
    if(defined( &_SYSCALL32)) {
    }
    eval 'sub XR_G0 () {0;}' unless defined(&XR_G0);
    eval 'sub XR_G1 () {1;}' unless defined(&XR_G1);
    eval 'sub XR_G2 () {2;}' unless defined(&XR_G2);
    eval 'sub XR_G3 () {3;}' unless defined(&XR_G3);
    eval 'sub XR_G4 () {4;}' unless defined(&XR_G4);
    eval 'sub XR_G5 () {5;}' unless defined(&XR_G5);
    eval 'sub XR_G6 () {6;}' unless defined(&XR_G6);
    eval 'sub XR_G7 () {7;}' unless defined(&XR_G7);
    eval 'sub NPRXGREG () {8;}' unless defined(&NPRXGREG);
    eval 'sub XR_O0 () {0;}' unless defined(&XR_O0);
    eval 'sub XR_O1 () {1;}' unless defined(&XR_O1);
    eval 'sub XR_O2 () {2;}' unless defined(&XR_O2);
    eval 'sub XR_O3 () {3;}' unless defined(&XR_O3);
    eval 'sub XR_O4 () {4;}' unless defined(&XR_O4);
    eval 'sub XR_O5 () {5;}' unless defined(&XR_O5);
    eval 'sub XR_O6 () {6;}' unless defined(&XR_O6);
    eval 'sub XR_O7 () {7;}' unless defined(&XR_O7);
    eval 'sub NPRXOREG () {8;}' unless defined(&NPRXOREG);
    eval 'sub NPRXFILLER () {8;}' unless defined(&NPRXFILLER);
    eval 'sub XR_TYPE_V8P () {1;}' unless defined(&XR_TYPE_V8P);
    unless(defined(&__sparcv9)) {
    }
    eval 'sub PRXREG_GSR {
        my($xrp) = @_;
	    eval q((*( &uint64_t *)(($xrp)-> ($pr_un->{pr_v8p}->{pr_filler}))));
    }' unless defined(&PRXREG_GSR);
    if(defined(&__cplusplus)) {
    }
}
1;
