require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PROMIMPL_H)) {
    eval 'sub _SYS_PROMIMPL_H () {1;}' unless defined(&_SYS_PROMIMPL_H);
    require 'sys/types.ph';
    require 'sys/promif.ph';
    require 'sys/prom_isa.ph';
    require 'sys/prom_plat.ph';
    require 'sys/openprom.ph';
    require 'sys/comvec.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub PROMIF_DMSG_VERBOSE () {2;}' unless defined(&PROMIF_DMSG_VERBOSE);
    eval 'sub PROMIF_DMSG_NORMAL () {1;}' unless defined(&PROMIF_DMSG_NORMAL);
    eval 'sub PROMIF_DEBUG () {1;}' unless defined(&PROMIF_DEBUG);
    eval 'sub PROMIF_DEBUG_P1275 () {1;}' unless defined(&PROMIF_DEBUG_P1275);
    if(defined(&PROMIF_DEBUG)) {
	eval 'sub PROMIF_DPRINTF {
	    my($args) = @_;
    	    eval q( &if ( &promif_debug) {  &if ( &promif_debug ==  &PROMIF_DMSG_VERBOSE)  &prom_printf(\\"file %s line %d: \\",  &__FILE__,  &__LINE__);  &prom_printf $args; });
	}' unless defined(&PROMIF_DPRINTF);
    } else {
	eval 'sub PROMIF_DPRINTF {
	    my($args) = @_;
    	    eval q();
	}' unless defined(&PROMIF_DPRINTF);
    }
    eval 'sub prom_decode_int {
        my($v) = @_;
	    eval q(($v));
    }' unless defined(&prom_decode_int);
    eval 'sub PROMIF_MIN_ALIGN () {1;}' unless defined(&PROMIF_MIN_ALIGN);
    if(defined( &PROM_32BIT_ADDRS)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
