require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PTMS_H)) {
    eval 'sub _SYS_PTMS_H () {1;}' unless defined(&_SYS_PTMS_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub PTLOCK () {0x1;}' unless defined(&PTLOCK);
    eval 'sub PTMOPEN () {0x2;}' unless defined(&PTMOPEN);
    eval 'sub PTSOPEN () {0x4;}' unless defined(&PTSOPEN);
    eval 'sub PTSTTY () {0x8;}' unless defined(&PTSTTY);
    if(defined(&_KERNEL)) {
	eval 'sub PT_ENTER_READ {
	    my($p) = @_;
    	    eval q({  &mutex_enter(($p)-> &pt_lock);  &while (($p)-> &pt_refcnt < 0)  &cv_wait((($p)-> &pt_cv), ($p)-> &pt_lock); ($p)-> &pt_refcnt++;  &mutex_exit(($p)-> &pt_lock); });
	}' unless defined(&PT_ENTER_READ);
	eval 'sub PT_ENTER_WRITE {
	    my($p) = @_;
    	    eval q({  &mutex_enter(($p)-> &pt_lock);  &while (($p)-> &pt_refcnt != 0)  &cv_wait((($p)-> &pt_cv), ($p)-> &pt_lock); ($p)-> &pt_refcnt = -1;  &mutex_exit(($p)-> &pt_lock); });
	}' unless defined(&PT_ENTER_WRITE);
	eval 'sub PT_EXIT_READ {
	    my($p) = @_;
    	    eval q({  &mutex_enter(($p)-> &pt_lock);  &ASSERT(($p)-> &pt_refcnt > 0);  &if ((--(($p)-> &pt_refcnt)) == 0)  &cv_broadcast(($p)-> &pt_cv);  &mutex_exit(($p)-> &pt_lock); });
	}' unless defined(&PT_EXIT_READ);
	eval 'sub PT_EXIT_WRITE {
	    my($p) = @_;
    	    eval q({  &mutex_enter(($p)-> &pt_lock);  &ASSERT(($p)-> &pt_refcnt == -1); ($p)-> &pt_refcnt = 0;  &cv_broadcast(($p)-> &pt_cv);  &mutex_exit(($p)-> &pt_lock); });
	}' unless defined(&PT_EXIT_WRITE);
	if(defined(&DEBUG)) {
	    eval 'sub DDBG {
	        my($a, $b) = @_;
    		eval q( &ptms_log($a, $b));
	    }' unless defined(&DDBG);
	    eval 'sub DDBGP {
	        my($a, $b) = @_;
    		eval q( &ptms_logp($a, $b));
	    }' unless defined(&DDBGP);
	} else {
	    eval 'sub DDBG {
	        my($a, $b) = @_;
    		eval q();
	    }' unless defined(&DDBG);
	    eval 'sub DDBGP {
	        my($a, $b) = @_;
    		eval q();
	    }' unless defined(&DDBGP);
	}
    }
    eval 'sub ISPTM () {((ord(\'P\')<<8)|1);}' unless defined(&ISPTM);
    eval 'sub UNLKPT () {((ord(\'P\')<<8)|2);}' unless defined(&UNLKPT);
    eval 'sub PTSSTTY () {((ord(\'P\')<<8)|3);}' unless defined(&PTSSTTY);
    if(defined(&__cplusplus)) {
    }
}
1;
