require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_QE_H)) {
    eval 'sub _SYS_QE_H () {1;}' unless defined(&_SYS_QE_H);
    require 'sys/kstat.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub QEIDNUM () {(102);}' unless defined(&QEIDNUM);
    eval 'sub QENAME () {"qe";}' unless defined(&QENAME);
    eval 'sub QEMINPSZ () {(0);}' unless defined(&QEMINPSZ);
    eval 'sub QEMAXPSZ () {1514;}' unless defined(&QEMAXPSZ);
    eval 'sub QEHIWAT () {(32* 1024);}' unless defined(&QEHIWAT);
    eval 'sub QELOWAT () {(1);}' unless defined(&QELOWAT);
    eval 'sub NMCHASH () {64;}' unless defined(&NMCHASH);
    eval 'sub INIT_BUCKET_SIZE () {16;}' unless defined(&INIT_BUCKET_SIZE);
    eval 'sub MCHASH {
        my($a) = @_;
	    eval q(((*((( &uchar_t *)($a)) + 0) ^ *((( &uchar_t *)($a)) + 1) ^ *((( &uchar_t *)($a)) + 2) ^ *((( &uchar_t *)($a)) + 3) ^ *((( &uchar_t *)($a)) + 4) ^ *((( &uchar_t *)($a)) + 5)) % ( &uint_t) &NMCHASH));
    }' unless defined(&MCHASH);
    eval 'sub QESFAST () {0x1;}' unless defined(&QESFAST);
    eval 'sub QESRAW () {0x2;}' unless defined(&QESRAW);
    eval 'sub QESALLPHYS () {0x4;}' unless defined(&QESALLPHYS);
    eval 'sub QESALLMULTI () {0x8;}' unless defined(&QESALLMULTI);
    eval 'sub QESALLSAP () {0x10;}' unless defined(&QESALLSAP);
    eval 'sub QEMAXMC () {64;}' unless defined(&QEMAXMC);
    eval 'sub QEMCALLOC () {( &QEMAXMC * $sizeof{\'struct ether_addr\'});}' unless defined(&QEMCALLOC);
    eval 'sub QERPENDING () {64;}' unless defined(&QERPENDING);
    eval 'sub QETPENDING () {64;}' unless defined(&QETPENDING);
    eval 'sub QEADDRL () {($sizeof{ &ushort_t} +  &ETHERADDRL);}' unless defined(&QEADDRL);
    eval 'sub NEXTRMD {
        my($qep, $rmdp) = @_;
	    eval q(((($rmdp) + 1) == ($qep)-> &qe_rmdlimp ? ($qep)-> &qe_rmdp : (($rmdp) + 1)));
    }' unless defined(&NEXTRMD);
    eval 'sub NEXTTMD {
        my($qep, $tmdp) = @_;
	    eval q(((($tmdp) + 1) == ($qep)-> &qe_tmdlimp ? ($qep)-> &qe_tmdp : (($tmdp) + 1)));
    }' unless defined(&NEXTTMD);
    eval 'sub PREVTMD {
        my($qep, $tmdp) = @_;
	    eval q((($tmdp) == ($qep)-> &qe_tmdp ? (($qep)-> &qe_tmdlimp - 1) : (($tmdp) - 1)));
    }' unless defined(&PREVTMD);
    eval 'sub SECOND {
        my($t) = @_;
	    eval q($t*1000);
    }' unless defined(&SECOND);
    eval 'sub QE_SANITY_TIMER () { &SECOND(30);}' unless defined(&QE_SANITY_TIMER);
    eval 'sub QERUNNING () {0x1;}' unless defined(&QERUNNING);
    eval 'sub QEPROMISC () {0x2;}' unless defined(&QEPROMISC);
    eval 'sub QEDMA () {0x8;}' unless defined(&QEDMA);
    eval 'sub QESUSPENDED () {0x10;}' unless defined(&QESUSPENDED);
    eval 'sub QESTOP () {0x20;}' unless defined(&QESTOP);
    eval 'sub QEBCOPYALIGN () {(64);}' unless defined(&QEBCOPYALIGN);
    eval 'sub QEBCOPYMASK () {( &QEBCOPYALIGN-1);}' unless defined(&QEBCOPYMASK);
    eval 'sub QEDRAINTIME () {(400000);}' unless defined(&QEDRAINTIME);
    eval 'sub QELNKTIME () {(500000);}' unless defined(&QELNKTIME);
    eval 'sub QEROUNDUP {
        my($a, $n) = @_;
	    eval q(((($a) + (($n) - 1)) & ~(($n) - 1)));
    }' unless defined(&QEROUNDUP);
    eval 'sub QEROUNDUP2 {
        my($a, $n) = @_;
	    eval q(( &uchar_t *)(((( &uintptr_t)($a)) + (($n) - 1)) & ~(($n) - 1) + 2));
    }' unless defined(&QEROUNDUP2);
    eval 'sub QE_SPEED () {10;}' unless defined(&QE_SPEED);
    eval 'sub QEBURSTSIZE () {(64);}' unless defined(&QEBURSTSIZE);
    eval 'sub QEBURSTMASK () {( &QEBURSTSIZE - 1);}' unless defined(&QEBURSTMASK);
    eval 'sub QEBUFSIZE () {(1728- $sizeof{\'struct qe\' } - $sizeof{ &frtn_t});}' unless defined(&QEBUFSIZE);
    eval 'sub QEHEADROOM () {34;}' unless defined(&QEHEADROOM);
    if(defined(&__cplusplus)) {
    }
}
1;
