require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_HME_H)) {
    eval 'sub _SYS_HME_H () {1;}' unless defined(&_SYS_HME_H);
    if(defined(&__cplusplus)) {
    }
    unless(defined(&D_HOTPLUG)) {
	eval 'sub D_HOTPLUG () {0x;}' unless defined(&D_HOTPLUG);
    }
    unless(defined(&ETHERTYPE_IPV6)) {
	eval 'sub ETHERTYPE_IPV6 () {(0x86dd);}' unless defined(&ETHERTYPE_IPV6);
    }
    eval 'sub HME_IOC () {0x60201ae1;}' unless defined(&HME_IOC);
    eval 'sub HME_IOC_GET_SPEED () {0x100;}' unless defined(&HME_IOC_GET_SPEED);
    eval 'sub HME_IOC_SET_SPEED () {0x110;}' unless defined(&HME_IOC_SET_SPEED);
    if(defined(&QFETRUNK)) {
	eval 'sub HME_IOC_TRUNK () {0x120;}' unless defined(&HME_IOC_TRUNK);
	eval 'sub HME_IOC_TRUNK_SETUP () {0x1;}' unless defined(&HME_IOC_TRUNK_SETUP);
	eval 'sub HME_IOC_TRUNK_RELEASE () {0x2;}' unless defined(&HME_IOC_TRUNK_RELEASE);
	eval 'sub HME_IOC_TRUNK_GETCONF () {0x3;}' unless defined(&HME_IOC_TRUNK_GETCONF);
	eval 'sub HME_IOC_TRUNK_GETSTATS () {0x4;}' unless defined(&HME_IOC_TRUNK_GETSTATS);
    }
    eval("sub SEVERITY_NONE () { 0; }") unless defined(&SEVERITY_NONE);
    eval("sub SEVERITY_LOW () { 1; }") unless defined(&SEVERITY_LOW);
    eval("sub SEVERITY_MID () { 2; }") unless defined(&SEVERITY_MID);
    eval("sub SEVERITY_HIGH () { 3; }") unless defined(&SEVERITY_HIGH);
    eval("sub NO_SEVERITY () { 4; }") unless defined(&NO_SEVERITY);
    eval("sub DONT_WAIT () { 0; }") unless defined(&DONT_WAIT);
    eval("sub DO_WAIT () { 1; }") unless defined(&DO_WAIT);
    eval("sub DVMA () { 0; }") unless defined(&DVMA);
    eval("sub DMA () { 1; }") unless defined(&DMA);
    eval("sub SDMA () { 2; }") unless defined(&SDMA);
    eval("sub MIF_POLL_STOP () { 0; }") unless defined(&MIF_POLL_STOP);
    eval("sub MIF_POLL_START () { 1; }") unless defined(&MIF_POLL_START);
    eval 'sub HME_NO_XCVR () {0;}' unless defined(&HME_NO_XCVR);
    eval 'sub HME_INTERNAL_XCVR () {1;}' unless defined(&HME_INTERNAL_XCVR);
    eval 'sub HME_EXTERNAL_XCVR () {2;}' unless defined(&HME_EXTERNAL_XCVR);
    if(defined(&SHEFFIELD)) {
	eval 'sub qfe_dev_is_usable {
	    my($a, $b) = @_;
    	    eval q( &u4ft_ddi_dev_is_usable($a, ( &u4ft_waitflag_t)$b));
	}' unless defined(&qfe_dev_is_usable);
    } else {
    }
    eval 'sub HME_AUTO_SPEED () {0;}' unless defined(&HME_AUTO_SPEED);
    eval 'sub HME_FORCE_SPEED () {1;}' unless defined(&HME_FORCE_SPEED);
    eval 'sub HME_SPEED_10 () {10;}' unless defined(&HME_SPEED_10);
    eval 'sub HME_SPEED_100 () {100;}' unless defined(&HME_SPEED_100);
    eval 'sub HME_HALF_DUPLEX () {0;}' unless defined(&HME_HALF_DUPLEX);
    eval 'sub HME_FULL_DUPLEX () {1;}' unless defined(&HME_FULL_DUPLEX);
    if(defined (defined(&SOL2_4) ? &SOL2_4 : 0) || defined (defined(&SOL2_5) ? &SOL2_5 : 0) || defined (defined(&SOL2_5_1) ? &SOL2_5_1 : 0)) {
	eval 'sub ND_BASE () {(ord(\'N\') << 8);}' unless defined(&ND_BASE);
	eval 'sub ND_GET () {( &ND_BASE + 0);}' unless defined(&ND_GET);
	eval 'sub ND_SET () {( &ND_BASE + 1);}' unless defined(&ND_SET);
	eval 'sub NDE_ALLOC_COUNT () {4;}' unless defined(&NDE_ALLOC_COUNT);
	eval 'sub NDE_ALLOC_SIZE () {($sizeof{ &NDE} *  &NDE_ALLOC_COUNT);}' unless defined(&NDE_ALLOC_SIZE);
	eval 'sub DDI_UMEM_NOSLEEP () {0x1;}' unless defined(&DDI_UMEM_NOSLEEP);
	eval 'sub ddi_get32 {
	    my($handle, $dev_addr) = @_;
    	    eval q( &ddi_getl($handle, $dev_addr));
	}' unless defined(&ddi_get32);
	eval 'sub ddi_get16 {
	    my($handle, $dev_addr) = @_;
    	    eval q( &ddi_getw($handle, $dev_addr));
	}' unless defined(&ddi_get16);
	eval 'sub ddi_get8 {
	    my($handle, $dev_addr) = @_;
    	    eval q( &ddi_getb($handle, $dev_addr));
	}' unless defined(&ddi_get8);
	eval 'sub ddi_put32 {
	    my($handle, $dev_addr, $value) = @_;
    	    eval q( &ddi_putl($handle, $dev_addr, $value));
	}' unless defined(&ddi_put32);
	eval 'sub ddi_put16 {
	    my($handle, $dev_addr, $value) = @_;
    	    eval q( &ddi_putw($handle, $dev_addr, $value));
	}' unless defined(&ddi_put16);
	eval 'sub ddi_put8 {
	    my($handle, $dev_addr, $value) = @_;
    	    eval q( &ddi_putb($handle, $dev_addr, $value));
	}' unless defined(&ddi_put8);
    }
    if(defined (defined(&SOL2_4) ? &SOL2_4 : 0)) {
	eval 'sub PCI_COMM_MAE () {0x2;}' unless defined(&PCI_COMM_MAE);
	eval 'sub PCI_COMM_ME () {0x4;}' unless defined(&PCI_COMM_ME);
	eval 'sub PCI_COMM_PARITY_DETECT () {0x40;}' unless defined(&PCI_COMM_PARITY_DETECT);
	eval 'sub PCI_COMM_SERR_ENABLE () {0x100;}' unless defined(&PCI_COMM_SERR_ENABLE);
	eval 'sub DDI_DEVICE_ATTR_V0 () {0x1;}' unless defined(&DDI_DEVICE_ATTR_V0);
	eval 'sub DMA_ATTR_V0 () {0x1;}' unless defined(&DMA_ATTR_V0);
	eval 'sub DDI_STRUCTURE_LE_ACC () {0x1;}' unless defined(&DDI_STRUCTURE_LE_ACC);
	eval 'sub DDI_STRUCTURE_BE_ACC () {0x2;}' unless defined(&DDI_STRUCTURE_BE_ACC);
	eval 'sub DDI_STRICTORDER_ACC () {0x;}' unless defined(&DDI_STRICTORDER_ACC);
	eval 'sub DDI_DMA_STREAMING () {0x40;}' unless defined(&DDI_DMA_STREAMING);
    }
    if(defined (defined(&SOL2_4) ? &SOL2_4 : 0) || defined (defined(&SOL2_5) ? &SOL2_5 : 0) || defined (defined(&SOL2_5_1) ? &SOL2_5_1 : 0)) {
	eval 'sub ether_bcopy {
	    my($a, $b) = @_;
    	    eval q(( &bcopy($a, $b, 6)));
	}' unless defined(&ether_bcopy);
    } else {
	eval 'sub ether_bcopy {
	    my($a, $b) = @_;
    	    eval q(( &bcopy($a, $b, 6)));
	}' unless defined(&ether_bcopy);
    }
    if(defined(&QFETRUNK)) {
	eval 'sub HME_TR_POLICY_MAX () {32;}' unless defined(&HME_TR_POLICY_MAX);
	eval 'sub HME_TYPE_HME_SBUS () {1;}' unless defined(&HME_TYPE_HME_SBUS);
	eval 'sub HME_TYPE_HME_PCI () {2;}' unless defined(&HME_TYPE_HME_PCI);
	eval 'sub HME_TYPE_QFE_SBUS () {3;}' unless defined(&HME_TYPE_QFE_SBUS);
	eval 'sub HME_TYPE_QFE_PCI () {4;}' unless defined(&HME_TYPE_QFE_PCI);
	eval 'sub HME_TRUNK_MAXSIZE () {4;}' unless defined(&HME_TRUNK_MAXSIZE);
	eval 'sub NET_TRUNK_MAXSIZE () {16;}' unless defined(&NET_TRUNK_MAXSIZE);
	eval 'sub HME_SM_LINK () {0x1;}' unless defined(&HME_SM_LINK);
	eval 'sub HME_SM_MODE () {0x2;}' unless defined(&HME_SM_MODE);
	eval 'sub HME_SM_SPEED () {0x4;}' unless defined(&HME_SM_SPEED);
	eval 'sub HME_SM_XCVR () {0x8;}' unless defined(&HME_SM_XCVR);
	eval 'sub HME_TRUNK_MAXERR () {320;}' unless defined(&HME_TRUNK_MAXERR);
	if(0) {
	    eval 'sub HME_TRUNK_MAXCONF () {( &HME_TRUNK_MAXERR/($sizeof{ &hme_tr_conf_t}));}' unless defined(&HME_TRUNK_MAXCONF);
	}
	eval 'sub HME_TRUNK_MAXCONF () {32;}' unless defined(&HME_TRUNK_MAXCONF);
    }
    if(defined(&_KERNEL)) {
	if(defined(&QFETRUNK)) {
	    eval 'sub HSTAT {
	        my($hmep, $x) = @_;
    		eval q( ($hmep->{hme_stats}->{x})++;  &if ( ($hmep->{hme_trunkp})) {  ($hmep->{hme_trunkp}->{tr_stats}->{x})++; });
	    }' unless defined(&HSTAT);
	    eval 'sub HSTATN {
	        my($hmep, $x, $n) = @_;
    		eval q( ($hmep->{hme_stats}->{x}) += $n;  &if ( ($hmep->{hme_trunkp})) {  ($hmep->{hme_trunkp}->{tr_stats}->{x}) += $n; });
	    }' unless defined(&HSTATN);
	} else {
	    eval 'sub HSTAT {
	        my($hmep, $x) = @_;
    		eval q( ($hmep->{hme_stats}->{x})++;);
	    }' unless defined(&HSTAT);
	    eval 'sub HSTATN {
	        my($hmep, $x, $n) = @_;
    		eval q( ($hmep->{hme_stats}->{x}) += $n;);
	    }' unless defined(&HSTATN);
	}
	if(defined(&QFETRUNK)) {
	    eval 'sub qt_head {
	        my($hmep) = @_;
    		eval q(( ($hmep->{hme_trunkp})  && ($hmep ==  ($hmep->{hme_trunkp}->{trunk_head}))));
	    }' unless defined(&qt_head);
	    eval 'sub qt_member {
	        my($hmep) = @_;
    		eval q(( ($hmep->{hme_trunkp})  && ($hmep !=  ($hmep->{hme_trunkp}->{trunk_head}))));
	    }' unless defined(&qt_member);
	} else {
	}
	eval 'sub hme_param_transceiver () {( ($hmep->{hme_param_arr[0]}->{hme_param_val}));}' unless defined(&hme_param_transceiver);
	eval 'sub hme_param_linkup () {( ($hmep->{hme_param_arr[1]}->{hme_param_val}));}' unless defined(&hme_param_linkup);
	eval 'sub hme_param_speed () {( ($hmep->{hme_param_arr[2]}->{hme_param_val}));}' unless defined(&hme_param_speed);
	eval 'sub hme_param_mode () {( ($hmep->{hme_param_arr[3]}->{hme_param_val}));}' unless defined(&hme_param_mode);
	eval 'sub hme_param_ipg1 () {( ($hmep->{hme_param_arr[4]}->{hme_param_val}));}' unless defined(&hme_param_ipg1);
	eval 'sub hme_param_ipg2 () {( ($hmep->{hme_param_arr[5]}->{hme_param_val}));}' unless defined(&hme_param_ipg2);
	eval 'sub hme_param_use_intphy () {( ($hmep->{hme_param_arr[6]}->{hme_param_val}));}' unless defined(&hme_param_use_intphy);
	eval 'sub hme_param_pace_count () {( ($hmep->{hme_param_arr[7]}->{hme_param_val}));}' unless defined(&hme_param_pace_count);
	eval 'sub hme_param_autoneg () {( ($hmep->{hme_param_arr[8]}->{hme_param_val}));}' unless defined(&hme_param_autoneg);
	eval 'sub hme_param_anar_100T4 () {( ($hmep->{hme_param_arr[9]}->{hme_param_val}));}' unless defined(&hme_param_anar_100T4);
	eval 'sub hme_param_anar_100fdx () {( ($hmep->{hme_param_arr[10]}->{hme_param_val}));}' unless defined(&hme_param_anar_100fdx);
	eval 'sub hme_param_anar_100hdx () {( ($hmep->{hme_param_arr[11]}->{hme_param_val}));}' unless defined(&hme_param_anar_100hdx);
	eval 'sub hme_param_anar_10fdx () {( ($hmep->{hme_param_arr[12]}->{hme_param_val}));}' unless defined(&hme_param_anar_10fdx);
	eval 'sub hme_param_anar_10hdx () {( ($hmep->{hme_param_arr[13]}->{hme_param_val}));}' unless defined(&hme_param_anar_10hdx);
	eval 'sub hme_param_bmsr_ancap () {( ($hmep->{hme_param_arr[14]}->{hme_param_val}));}' unless defined(&hme_param_bmsr_ancap);
	eval 'sub hme_param_bmsr_100T4 () {( ($hmep->{hme_param_arr[15]}->{hme_param_val}));}' unless defined(&hme_param_bmsr_100T4);
	eval 'sub hme_param_bmsr_100fdx () {( ($hmep->{hme_param_arr[16]}->{hme_param_val}));}' unless defined(&hme_param_bmsr_100fdx);
	eval 'sub hme_param_bmsr_100hdx () {( ($hmep->{hme_param_arr[17]}->{hme_param_val}));}' unless defined(&hme_param_bmsr_100hdx);
	eval 'sub hme_param_bmsr_10fdx () {( ($hmep->{hme_param_arr[18]}->{hme_param_val}));}' unless defined(&hme_param_bmsr_10fdx);
	eval 'sub hme_param_bmsr_10hdx () {( ($hmep->{hme_param_arr[19]}->{hme_param_val}));}' unless defined(&hme_param_bmsr_10hdx);
	eval 'sub hme_param_aner_lpancap () {( ($hmep->{hme_param_arr[20]}->{hme_param_val}));}' unless defined(&hme_param_aner_lpancap);
	eval 'sub hme_param_anlpar_100T4 () {( ($hmep->{hme_param_arr[21]}->{hme_param_val}));}' unless defined(&hme_param_anlpar_100T4);
	eval 'sub hme_param_anlpar_100fdx () {( ($hmep->{hme_param_arr[22]}->{hme_param_val}));}' unless defined(&hme_param_anlpar_100fdx);
	eval 'sub hme_param_anlpar_100hdx () {( ($hmep->{hme_param_arr[23]}->{hme_param_val}));}' unless defined(&hme_param_anlpar_100hdx);
	eval 'sub hme_param_anlpar_10fdx () {( ($hmep->{hme_param_arr[24]}->{hme_param_val}));}' unless defined(&hme_param_anlpar_10fdx);
	eval 'sub hme_param_anlpar_10hdx () {( ($hmep->{hme_param_arr[25]}->{hme_param_val}));}' unless defined(&hme_param_anlpar_10hdx);
	eval 'sub hme_param_device () {( ($hmep->{hme_param_arr[26]}->{hme_param_val}));}' unless defined(&hme_param_device);
	eval 'sub hme_param_lance_mode () {( ($hmep->{hme_param_arr[27]}->{hme_param_val}));}' unless defined(&hme_param_lance_mode);
	eval 'sub hme_param_ipg0 () {( ($hmep->{hme_param_arr[28]}->{hme_param_val}));}' unless defined(&hme_param_ipg0);
	eval 'sub HME_PARAM_CNT () {29;}' unless defined(&HME_PARAM_CNT);
	eval 'sub HME_ND_GET () { &ND_GET;}' unless defined(&HME_ND_GET);
	eval 'sub HME_ND_SET () { &ND_SET;}' unless defined(&HME_ND_SET);
	eval 'sub IPG1 () {8;}' unless defined(&IPG1);
	eval 'sub IPG2 () {4;}' unless defined(&IPG2);
	if(defined (defined(&SOL2_4) ? &SOL2_4 : 0) || defined (defined(&SOL2_5) ? &SOL2_5 : 0) || defined (defined(&SOL2_5_1) ? &SOL2_5_1 : 0)) {
	}
	eval 'sub HMEIDNUM () {(131);}' unless defined(&HMEIDNUM);
	eval 'sub HMENAME () {"qfe";}' unless defined(&HMENAME);
	eval 'sub HMEMINPSZ () {(0);}' unless defined(&HMEMINPSZ);
	eval 'sub HMEMAXPSZ () {1514;}' unless defined(&HMEMAXPSZ);
	eval 'sub HMEHIWAT () {(128* 1024);}' unless defined(&HMEHIWAT);
	eval 'sub HMELOWAT () {(1);}' unless defined(&HMELOWAT);
	eval 'sub NMCHASH () {64;}' unless defined(&NMCHASH);
	eval 'sub INIT_BUCKET_SIZE () {16;}' unless defined(&INIT_BUCKET_SIZE);
	eval 'sub MCHASH {
	    my($a) = @_;
    	    eval q(((*((( &uchar_t *) ($a)) + 0) ^ *((( &uchar_t *) ($a)) + 1) ^ *((( &uchar_t *) ($a)) + 2) ^ *((( &uchar_t *) ($a)) + 3) ^ *((( &uchar_t *) ($a)) + 4) ^ *((( &uchar_t *) ($a)) + 5)) % ( &uint_t)  &NMCHASH));
	}' unless defined(&MCHASH);
	eval 'sub HMESFAST () {0x1;}' unless defined(&HMESFAST);
	eval 'sub HMESRAW () {0x2;}' unless defined(&HMESRAW);
	eval 'sub HMESALLPHYS () {0x4;}' unless defined(&HMESALLPHYS);
	eval 'sub HMESALLMULTI () {0x8;}' unless defined(&HMESALLMULTI);
	eval 'sub HMESALLSAP () {0x10;}' unless defined(&HMESALLSAP);
	eval 'sub HMESCKSUM () {0x20;}' unless defined(&HMESCKSUM);
	eval 'sub HMEMAXMC () {64;}' unless defined(&HMEMAXMC);
	eval 'sub HMEMCALLOC () {( &HMEMAXMC * $sizeof{\'struct ether_addr\'});}' unless defined(&HMEMCALLOC);
	eval 'sub HMERPENDING () {128;}' unless defined(&HMERPENDING);
	eval 'sub HMETPENDING () {64;}' unless defined(&HMETPENDING);
	eval 'sub HMEADDRL () {($sizeof{ &uint16_t} +  &ETHERADDRL);}' unless defined(&HMEADDRL);
	eval 'sub NEXTRMD {
	    my($hmep, $rmdp) = @_;
    	    eval q(((($rmdp) + 1) == ($hmep)-> &hme_rmdlimp ? ($hmep)-> &hme_rmdp : (($rmdp) + 1)));
	}' unless defined(&NEXTRMD);
	eval 'sub NEXTTMD {
	    my($hmep, $tmdp) = @_;
    	    eval q(((($tmdp) + 1) == ($hmep)-> &hme_tmdlimp ? ($hmep)-> &hme_tmdp : (($tmdp) + 1)));
	}' unless defined(&NEXTTMD);
	eval 'sub PREVTMD {
	    my($hmep, $tmdp) = @_;
    	    eval q((($tmdp) == ($hmep)-> &hme_tmdp ? (($hmep)-> &hme_tmdlimp - 1) : (($tmdp) - 1)));
	}' unless defined(&PREVTMD);
	eval 'sub MSECOND {
	    my($t) = @_;
    	    eval q($t);
	}' unless defined(&MSECOND);
	eval 'sub SECOND {
	    my($t) = @_;
    	    eval q($t*1000);
	}' unless defined(&SECOND);
	eval 'sub HME_TICKS () { &MSECOND(100);}' unless defined(&HME_TICKS);
	eval 'sub HME_LINKCHECK_TIMER () { &SECOND(30);}' unless defined(&HME_LINKCHECK_TIMER);
	eval 'sub ALL_MACHINES () {0x;}' unless defined(&ALL_MACHINES);
	eval 'sub SUN4D_MACHINE () {0x1;}' unless defined(&SUN4D_MACHINE);
	eval 'sub HME_ADAPTER () {0x;}' unless defined(&HME_ADAPTER);
	eval 'sub QFE_S_ADAPTER () {0x1;}' unless defined(&QFE_S_ADAPTER);
	eval 'sub QFE_P_ADAPTER () {0x2;}' unless defined(&QFE_P_ADAPTER);
	eval 'sub MAX_LINK_DOWN () {5;}' unless defined(&MAX_LINK_DOWN);
	eval 'sub HME_2P0_REVID () {0xa0;}' unless defined(&HME_2P0_REVID);
	eval 'sub HME_2P1_REVID () {0x20;}' unless defined(&HME_2P1_REVID);
	eval 'sub HME_2P1_REVID_OBP () {0x21;}' unless defined(&HME_2P1_REVID_OBP);
	eval 'sub HME_1C0_REVID () {0xc0;}' unless defined(&HME_1C0_REVID);
	eval 'sub HME_2C0_REVID () {0xc1;}' unless defined(&HME_2C0_REVID);
	eval 'sub HME_NTRIES_LOW () {( &SECOND(5)/ &HME_TICKS);}' unless defined(&HME_NTRIES_LOW);
	eval 'sub HME_NTRIES_HIGH () {( &SECOND(5)/ &HME_TICKS);}' unless defined(&HME_NTRIES_HIGH);
	eval 'sub HME_NTRIES_LOW_10 () {( &SECOND(2)/ &HME_TICKS);}' unless defined(&HME_NTRIES_LOW_10);
	eval 'sub HME_LINKDOWN_TIME () {( &SECOND(2)/ &HME_TICKS);}' unless defined(&HME_LINKDOWN_TIME);
	eval 'sub HME_LINKDOWN_OK () {0;}' unless defined(&HME_LINKDOWN_OK);
	eval 'sub HME_FORCE_LINKDOWN () {1;}' unless defined(&HME_FORCE_LINKDOWN);
	eval 'sub HME_LINKDOWN_STARTED () {2;}' unless defined(&HME_LINKDOWN_STARTED);
	eval 'sub HME_LINKDOWN_DONE () {3;}' unless defined(&HME_LINKDOWN_DONE);
	eval 'sub P1_0 () {0x100;}' unless defined(&P1_0);
	eval 'sub HME_HWAN_TRY () {0;}' unless defined(&HME_HWAN_TRY);
	eval 'sub HME_HWAN_INPROGRESS () {1;}' unless defined(&HME_HWAN_INPROGRESS);
	eval 'sub HME_HWAN_SUCCESFUL () {2;}' unless defined(&HME_HWAN_SUCCESFUL);
	eval 'sub HME_HWAN_FAILED () {3;}' unless defined(&HME_HWAN_FAILED);
	if(defined(&QFETRUNK)) {
	}
	if(defined(&RX_DRAIN_QUEUE)) {
	}
	if(defined(&QFETRUNK)) {
	}
	if(defined(&POLL_QFE)) {
	}
	eval 'sub HMERUNNING () {0x1;}' unless defined(&HMERUNNING);
	eval 'sub HMEPROMISC () {0x2;}' unless defined(&HMEPROMISC);
	eval 'sub HMESUN4C () {0x4;}' unless defined(&HMESUN4C);
	eval 'sub HMESUSPENDED () {0x8;}' unless defined(&HMESUSPENDED);
	eval 'sub HMEINITIALIZED () {0x10;}' unless defined(&HMEINITIALIZED);
	eval 'sub HMENOTIMEOUTS () {0x20;}' unless defined(&HMENOTIMEOUTS);
	eval 'sub HMEDLPILINKUP () {0x40;}' unless defined(&HMEDLPILINKUP);
	eval 'sub HMETHREADRUN () {0x80;}' unless defined(&HMETHREADRUN);
	eval 'sub HME_FACTADDR_PRESENT () {0x1;}' unless defined(&HME_FACTADDR_PRESENT);
	eval 'sub HME_FACTADDR_USE () {0x2;}' unless defined(&HME_FACTADDR_USE);
	eval 'sub MAX_NAMELEN () { &KSTAT_STRLEN;}' unless defined(&MAX_NAMELEN);
	eval 'sub HMEDRAINTIME () {(400000);}' unless defined(&HMEDRAINTIME);
	eval 'sub ROUNDUP {
	    my($a, $n) = @_;
    	    eval q(((($a) + (($n) - 1)) & ~(($n) - 1)));
	}' unless defined(&ROUNDUP);
	eval 'sub ROUNDUP2 {
	    my($a, $n) = @_;
    	    eval q(( &uchar_t *)(((( &uintptr_t)($a)) + (($n) - 1)) & ~(($n) - 1)));
	}' unless defined(&ROUNDUP2);
	eval 'sub HMEBURSTSIZE () {(64);}' unless defined(&HMEBURSTSIZE);
	eval 'sub HMEBURSTMASK () {( &HMEBURSTSIZE - 1);}' unless defined(&HMEBURSTMASK);
	eval 'sub HMEALIGNBUFSIZE () {(2048);}' unless defined(&HMEALIGNBUFSIZE);
	unless(defined(&HME_RXBUF)) {
	    eval 'sub HMEBUFSIZE () {(1728);}' unless defined(&HMEBUFSIZE);
	} else {
	    eval 'sub HMEBUFSIZE () {(1728- $sizeof{\'struct hme\' } - $sizeof{ &frtn_t});}' unless defined(&HMEBUFSIZE);
	    eval 'sub HMEBUFPAD () {( &HMEBURSTSIZE - $sizeof{\'struct hme\' } - $sizeof{ &frtn_t});}' unless defined(&HMEBUFPAD);
	}
	eval 'sub HME_FSTBYTE_OFFSET () {2;}' unless defined(&HME_FSTBYTE_OFFSET);
	eval 'sub get_ether_type {
	    my($ptr) = @_;
    	    eval q(( ((( &uchar_t *)(( &eehp)$ptr)-> &ether_type)[0] << 8) | ((( &uchar_t *)(( &eehp)$ptr)-> &ether_type)[1])));
	}' unless defined(&get_ether_type);
	eval 'sub put_ether_type {
	    my($ptr, $value) = @_;
    	    eval q({ (( &uchar_t *)((( &eehp)$ptr)-> &ether_type))[0] = (( &uint_t)$value & 0xff00) >> 8; (( &uchar_t *)((( &eehp)$ptr)-> &ether_type))[1] = ($value & 0xff); });
	}' unless defined(&put_ether_type);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
