require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_RAMDAC_H)) {
    eval 'sub _SYS_RAMDAC_H () {1;}' unless defined(&_SYS_RAMDAC_H);
    require 'sys/pixrect.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub RAMDAC_READMASK () {04;}' unless defined(&RAMDAC_READMASK);
    eval 'sub RAMDAC_BLINKMASK () {05;}' unless defined(&RAMDAC_BLINKMASK);
    eval 'sub RAMDAC_COMMAND () {06;}' unless defined(&RAMDAC_COMMAND);
    eval 'sub RAMDAC_CTRLTEST () {07;}' unless defined(&RAMDAC_CTRLTEST);
    eval 'sub ASSIGN_LUT {
        my($lut, $value) = @_;
	    eval q(($lut). &packed = ($value & 0xff) | (($value & 0xff) << 8) | (($value & 0xff) << 16));
    }' unless defined(&ASSIGN_LUT);
    eval 'sub INIT_BT458 {
        my($lut) = @_;
	    eval q({  &ASSIGN_LUT(($lut)-> &addr_reg, 0);  &ASSIGN_LUT(($lut)-> &addr_reg,  &RAMDAC_CTRLTEST);  &ASSIGN_LUT(($lut)-> &command, 04);  &ASSIGN_LUT(($lut)-> &addr_reg,  &RAMDAC_COMMAND);  &ASSIGN_LUT(($lut)-> &command, 0x43);  &ASSIGN_LUT(($lut)-> &addr_reg,  &RAMDAC_READMASK);  &ASSIGN_LUT(($lut)-> &command, 0xff);  &ASSIGN_LUT(($lut)-> &addr_reg,  &RAMDAC_BLINKMASK);  &ASSIGN_LUT(($lut)-> &command, 0); });
    }' unless defined(&INIT_BT458);
    eval 'sub INIT_OCMAP {
        my($omap) = @_;
	    eval q({ ($omap)[0]. &packed = 0x; ($omap)[1]. &packed = 0xffffff; ($omap)[2]. &packed = 0xff00; ($omap)[3]. &packed = 0x; });
    }' unless defined(&INIT_OCMAP);
    eval 'sub INIT_CMAP {
        my($cmap, $size) = @_;
	    eval q({  &register \'int\'  &idx;  &for ( &idx = 0;  &idx < $size;  &idx++)  &ASSIGN_LUT(($cmap)[ &idx],  &idx); });
    }' unless defined(&INIT_CMAP);
    if(defined(&__cplusplus)) {
    }
}
1;
