require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCHEDCTL_H)) {
    eval 'sub _SYS_SCHEDCTL_H () {1;}' unless defined(&_SYS_SCHEDCTL_H);
    if(defined(&__cplusplus)) {
    }
    if(!defined( &_ASM)) {
	require 'sys/types.ph';
	require 'sys/processor.ph';
	if(defined(&_KERNEL)) {
	    require 'sys/mutex.ph';
	    require 'sys/thread.ph';
	    require 'sys/vnode.ph';
	    require 'sys/cpuvar.ph';
	    require 'sys/door.ph';
	}
	eval 'sub SC_FREE () {0x;}' unless defined(&SC_FREE);
	eval 'sub SC_SLEEP () {0x1;}' unless defined(&SC_SLEEP);
	eval 'sub SC_RUN () {0x2;}' unless defined(&SC_RUN);
	eval 'sub SC_ONPROC () {0x4;}' unless defined(&SC_ONPROC);
	eval 'sub SC_STOPPED () {0x10;}' unless defined(&SC_STOPPED);
	eval 'sub SC_IGNORE () {-2;}' unless defined(&SC_IGNORE);
	eval 'sub SC_NOPREEMPT () {-3;}' unless defined(&SC_NOPREEMPT);
	eval 'sub SC_MAX_TICKS () {2;}' unless defined(&SC_MAX_TICKS);
	eval 'sub SC_STATE () {0x1;}' unless defined(&SC_STATE);
	eval 'sub SC_BLOCK () {0x2;}' unless defined(&SC_BLOCK);
	eval 'sub SC_PRIORITY () {0x4;}' unless defined(&SC_PRIORITY);
	eval 'sub SC_PREEMPT () {0x8;}' unless defined(&SC_PREEMPT);
	eval 'sub SC_DOOR () {0x10;}' unless defined(&SC_DOOR);
	if(defined(&_KERNEL)) {
	    eval 'sub schedctl_check {
	        my($t, $flag) = @_;
    		eval q(((($t)-> &t_schedctl !=  &NULL)  && (($t)-> ($t_schedctl->{sc_flags}) & ($flag))));
	    }' unless defined(&schedctl_check);
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
