require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_ADAPTERS_ISPCMD_H)) {
    eval 'sub _SYS_SCSI_ADAPTERS_ISPCMD_H () {1;}' unless defined(&_SYS_SCSI_ADAPTERS_ISPCMD_H);
    require 'sys/scsi/scsi_types.ph';
    if(defined(&__cplusplus)) {
    }
    require 'sys/id32.ph';
    eval 'sub PKT_PRIV_LEN () {(2*$sizeof{ &void});}' unless defined(&PKT_PRIV_LEN);
    eval 'sub PKT2CMD {
        my($pkt) = @_;
	    eval q((($pkt)-> &pkt_ha_private));
    }' unless defined(&PKT2CMD);
    eval 'sub CMD2PKT {
        my($sp) = @_;
	    eval q((($sp)-> &cmd_pkt));
    }' unless defined(&CMD2PKT);
    if(defined(&_LP64)) {
	eval 'sub ISP_GET_ID {
	    my($x, $f) = @_;
    	    eval q( &id32_alloc(($x), ($f)));
	}' unless defined(&ISP_GET_ID);
	eval 'sub ISP_LOOKUP_ID {
	    my($x) = @_;
    	    eval q( &id32_lookup(( &uint32_t)($x)));
	}' unless defined(&ISP_LOOKUP_ID);
	eval 'sub ISP_FREE_ID {
	    my($x) = @_;
    	    eval q( &id32_free(($x)));
	}' unless defined(&ISP_FREE_ID);
    } else {
	eval 'sub ISP_GET_ID {
	    my($x, $f) = @_;
    	    eval q((($x)));
	}' unless defined(&ISP_GET_ID);
	eval 'sub ISP_LOOKUP_ID {
	    my($x) = @_;
    	    eval q((($x)));
	}' unless defined(&ISP_LOOKUP_ID);
	eval 'sub ISP_FREE_ID {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&ISP_FREE_ID);
    }
    eval 'sub EXTCMDS_STATUS_SIZE () {($sizeof{\'struct scsi_arq_status\'});}' unless defined(&EXTCMDS_STATUS_SIZE);
    eval 'sub EXTCMDS_SIZE () {( &EXTCMDS_STATUS_SIZE + $sizeof{\'struct isp_cmd\'} + $sizeof{\'struct scsi_pkt\'});}' unless defined(&EXTCMDS_SIZE);
    eval 'sub CFLAG_FINISHED () {0x1;}' unless defined(&CFLAG_FINISHED);
    eval 'sub CFLAG_COMPLETED () {0x2;}' unless defined(&CFLAG_COMPLETED);
    eval 'sub CFLAG_IN_TRANSPORT () {0x4;}' unless defined(&CFLAG_IN_TRANSPORT);
    eval 'sub CFLAG_TRANFLAG () {0xf;}' unless defined(&CFLAG_TRANFLAG);
    eval 'sub CFLAG_DMAVALID () {0x10;}' unless defined(&CFLAG_DMAVALID);
    eval 'sub CFLAG_DMASEND () {0x20;}' unless defined(&CFLAG_DMASEND);
    eval 'sub CFLAG_CMDIOPB () {0x40;}' unless defined(&CFLAG_CMDIOPB);
    eval 'sub CFLAG_CDBEXTERN () {0x100;}' unless defined(&CFLAG_CDBEXTERN);
    eval 'sub CFLAG_SCBEXTERN () {0x200;}' unless defined(&CFLAG_SCBEXTERN);
    eval 'sub CFLAG_FREE () {0x400;}' unless defined(&CFLAG_FREE);
    eval 'sub CFLAG_PRIVEXTERN () {0x1000;}' unless defined(&CFLAG_PRIVEXTERN);
    eval 'sub CFLAG_DMA_PARTIAL () {0x2000;}' unless defined(&CFLAG_DMA_PARTIAL);
    if(defined(&__cplusplus)) {
    }
}
1;
