require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_ADAPTERS_SFVAR_H)) {
    eval 'sub _SYS_SCSI_ADAPTERS_SFVAR_H () {1;}' unless defined(&_SYS_SCSI_ADAPTERS_SFVAR_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub SF_BASE_MINOR () {32;}' unless defined(&SF_BASE_MINOR);
    eval 'sub SF_DEVCTL_MINOR () {( &SF_BASE_MINOR + 1);}' unless defined(&SF_DEVCTL_MINOR);
    eval 'sub SF_FC_MINOR () {( &SF_BASE_MINOR + 2);}' unless defined(&SF_FC_MINOR);
    eval 'sub SF_INST_SHIFT4MINOR () {6;}' unless defined(&SF_INST_SHIFT4MINOR);
    eval 'sub SF_INST2DEVCTL_MINOR {
        my($x) = @_;
	    eval q((($x <<  &SF_INST_SHIFT4MINOR) |  &SF_DEVCTL_MINOR));
    }' unless defined(&SF_INST2DEVCTL_MINOR);
    eval 'sub SF_INST2FC_MINOR {
        my($x) = @_;
	    eval q((($x <<  &SF_INST_SHIFT4MINOR) |  &SF_FC_MINOR));
    }' unless defined(&SF_INST2FC_MINOR);
    eval 'sub SF_MINOR2INST {
        my($x) = @_;
	    eval q(($x >>  &SF_INST_SHIFT4MINOR));
    }' unless defined(&SF_MINOR2INST);
    eval 'sub SF_INIT_ITEMS () {5;}' unless defined(&SF_INIT_ITEMS);
    eval 'sub SF_MAX_TARGETS () {126;}' unless defined(&SF_MAX_TARGETS);
    eval 'sub SF_MAX_LILP_ENTRIES () {126;}' unless defined(&SF_MAX_LILP_ENTRIES);
    eval 'sub SF_NUM_HASH_QUEUES () {32;}' unless defined(&SF_NUM_HASH_QUEUES);
    eval 'sub SF_HASH {
        my($x, $y) = @_;
	    eval q((($x->[0]+$x->[1]+$x->[2]+$x->[3]+$x->[4]+$x->[5]+$x->[6]+$x->[7]) ( &SF_NUM_HASH_QUEUES-1)));
    }' unless defined(&SF_HASH);
    eval 'sub SCMD_GROUP5 () {0xa0;}' unless defined(&SCMD_GROUP5);
    eval 'sub SCMD_REPORTLUN () {0xa0;}' unless defined(&SCMD_REPORTLUN);
    eval 'sub SF_STATE_INIT () {0x1;}' unless defined(&SF_STATE_INIT);
    eval 'sub SF_STATE_OFFLINE () {0x2;}' unless defined(&SF_STATE_OFFLINE);
    eval 'sub SF_STATE_ONLINE () {0x4;}' unless defined(&SF_STATE_ONLINE);
    eval 'sub SF_STATE_ONLINING () {0x8;}' unless defined(&SF_STATE_ONLINING);
    eval 'sub SF_STATE_SUSPENDED () {0x10;}' unless defined(&SF_STATE_SUSPENDED);
    eval 'sub SF_EVENT_TAG_INSERT () {0;}' unless defined(&SF_EVENT_TAG_INSERT);
    eval 'sub SF_EVENT_TAG_REMOVE () {1;}' unless defined(&SF_EVENT_TAG_REMOVE);
    eval 'sub SF_CR_POOL_MAX () {32;}' unless defined(&SF_CR_POOL_MAX);
    eval 'sub SF_ELEMS_IN_POOL () {128;}' unless defined(&SF_ELEMS_IN_POOL);
    eval 'sub SF_LOG2_ELEMS_IN_POOL () {7;}' unless defined(&SF_LOG2_ELEMS_IN_POOL);
    eval 'sub SF_FREE_CR_EPSILON () {64;}' unless defined(&SF_FREE_CR_EPSILON);
    if(defined(&RAID_LUNS)) {
	eval 'sub SCSA_LUN {
	    my($t) = @_;
    	    eval q(( &int64_t)($t)-> &sft_raid_lun);
	}' unless defined(&SCSA_LUN);
    } else {
	eval 'sub SCSA_LUN {
	    my($t) = @_;
    	    eval q(($t)-> ($sft_lun->{l}));
	}' unless defined(&SCSA_LUN);
    }
    eval 'sub SF_TARGET_INIT_DONE () {0x1;}' unless defined(&SF_TARGET_INIT_DONE);
    eval 'sub SF_TARGET_BUSY () {0x2;}' unless defined(&SF_TARGET_BUSY);
    eval 'sub SF_TARGET_OFFLINE () {0x4;}' unless defined(&SF_TARGET_OFFLINE);
    eval 'sub SF_TARGET_MARK () {0x8;}' unless defined(&SF_TARGET_MARK);
    eval 'sub PKT2CMD {
        my($pkt) = @_;
	    eval q(( ($pkt->{pkt_ha_private})));
    }' unless defined(&PKT2CMD);
    eval 'sub CMD2PKT {
        my($cmd) = @_;
	    eval q((($cmd)-> &cmd_pkt));
    }' unless defined(&CMD2PKT);
    if(defined(&_LP64)) {
	eval 'sub PKT_PRIV_SIZE () {2;}' unless defined(&PKT_PRIV_SIZE);
	eval 'sub PKT_PRIV_LEN () {16;}' unless defined(&PKT_PRIV_LEN);
    } else {
	eval 'sub PKT_PRIV_SIZE () {1;}' unless defined(&PKT_PRIV_SIZE);
	eval 'sub PKT_PRIV_LEN () {8;}' unless defined(&PKT_PRIV_LEN);
    }
    eval 'sub SF_STATE_IDLE () {0x1;}' unless defined(&SF_STATE_IDLE);
    eval 'sub SF_STATE_ISSUED () {0x2;}' unless defined(&SF_STATE_ISSUED);
    eval 'sub SF_STATE_ABORTING () {0x4;}' unless defined(&SF_STATE_ABORTING);
    eval 'sub EXTCMDS_STATUS_SIZE () {($sizeof{\'struct scsi_arq_status\'});}' unless defined(&EXTCMDS_STATUS_SIZE);
    eval 'sub CFLAG_DMAVALID () {0x10;}' unless defined(&CFLAG_DMAVALID);
    eval 'sub CFLAG_DMASEND () {0x20;}' unless defined(&CFLAG_DMASEND);
    eval 'sub CFLAG_CMDIOPB () {0x40;}' unless defined(&CFLAG_CMDIOPB);
    eval 'sub CFLAG_CDBEXTERN () {0x100;}' unless defined(&CFLAG_CDBEXTERN);
    eval 'sub CFLAG_SCBEXTERN () {0x200;}' unless defined(&CFLAG_SCBEXTERN);
    eval 'sub CFLAG_FREE () {0x400;}' unless defined(&CFLAG_FREE);
    eval 'sub CFLAG_PRIVEXTERN () {0x1000;}' unless defined(&CFLAG_PRIVEXTERN);
    eval 'sub CFLAG_IN_QUEUE () {0x2000;}' unless defined(&CFLAG_IN_QUEUE);
    eval 'sub SF_ONLINE () {0;}' unless defined(&SF_ONLINE);
    eval 'sub SF_OFFLINE () {1;}' unless defined(&SF_OFFLINE);
    eval 'sub ADDR2SF {
        my($ap) = @_;
	    eval q((($ap)-> ($a_hba_tran->{tran_hba_private})));
    }' unless defined(&ADDR2SF);
    eval 'sub ADDR2TARGET {
        my($ap) = @_;
	    eval q((($ap)-> &a_hba_tran->  &tran_tgt_private));
    }' unless defined(&ADDR2TARGET);
    eval 'sub SF_OFFLINE_TIMEOUT () {45;}' unless defined(&SF_OFFLINE_TIMEOUT);
    eval 'sub SF_RESET_TIMEOUT () {10;}' unless defined(&SF_RESET_TIMEOUT);
    eval 'sub SF_ELS_TIMEOUT () {5;}' unless defined(&SF_ELS_TIMEOUT);
    eval 'sub SF_INVALID_TIMEOUT () {0x7fffffff;}' unless defined(&SF_INVALID_TIMEOUT);
    eval 'sub SF_FCP_TIMEOUT () {30;}' unless defined(&SF_FCP_TIMEOUT);
    eval 'sub SF_BSY_TIMEOUT () {10;}' unless defined(&SF_BSY_TIMEOUT);
    eval 'sub SF_ABORT_TIMEOUT () {10000000;}' unless defined(&SF_ABORT_TIMEOUT);
    eval 'sub SF_POLL_TIMEOUT () {60;}' unless defined(&SF_POLL_TIMEOUT);
    eval 'sub SF_TARGET_RESET_DELAY () {250000;}' unless defined(&SF_TARGET_RESET_DELAY);
    eval 'sub SF_DECR_DELTA () {5;}' unless defined(&SF_DECR_DELTA);
    eval 'sub SF_INCR_DELTA () {5;}' unless defined(&SF_INCR_DELTA);
    eval 'sub SF_LO_CMD_DELTA () {512;}' unless defined(&SF_LO_CMD_DELTA);
    eval 'sub SF_HI_CMD_DELTA () {256;}' unless defined(&SF_HI_CMD_DELTA);
    eval 'sub SF_ELS_RETRIES () {4;}' unless defined(&SF_ELS_RETRIES);
    eval 'sub SF_BSY_RETRIES () {7;}' unless defined(&SF_BSY_RETRIES);
    eval 'sub SF_INIT_WAIT_TIMEOUT () {60000000;}' unless defined(&SF_INIT_WAIT_TIMEOUT);
    eval 'sub SF_CORE_CMD_TIMEOUT () {0x1;}' unless defined(&SF_CORE_CMD_TIMEOUT);
    eval 'sub SF_CORE_BAD_ABORT () {0x2;}' unless defined(&SF_CORE_BAD_ABORT);
    eval 'sub SF_CORE_ABORT_TIMEOUT () {0x4;}' unless defined(&SF_CORE_ABORT_TIMEOUT);
    eval 'sub SF_CORE_ELS_TIMEOUT () {0x8;}' unless defined(&SF_CORE_ELS_TIMEOUT);
    eval 'sub SF_CORE_ELS_FAILED () {0x10;}' unless defined(&SF_CORE_ELS_FAILED);
    eval 'sub SF_CORE_LILP_FAILED () {0x20;}' unless defined(&SF_CORE_LILP_FAILED);
    eval 'sub SF_CORE_OFFLINE_TIMEOUT () {0x40;}' unless defined(&SF_CORE_OFFLINE_TIMEOUT);
    eval 'sub SF_CORE_LIP_FAILED () {0x80;}' unless defined(&SF_CORE_LIP_FAILED);
    eval 'sub SF_CORE_OFFLINE_TARGET () {0x100;}' unless defined(&SF_CORE_OFFLINE_TARGET);
    eval 'sub SF_CORE_INCOMPLETE_DMA () {0x200;}' unless defined(&SF_CORE_INCOMPLETE_DMA);
    eval 'sub SF_CORE_REPORTLUN_TIMEOUT () {0x400;}' unless defined(&SF_CORE_REPORTLUN_TIMEOUT);
    eval 'sub SF_CORE_INQUIRY_TIMEOUT () {0x800;}' unless defined(&SF_CORE_INQUIRY_TIMEOUT);
    eval 'sub TRUE () {1;}' unless defined(&TRUE);
    eval 'sub FALSE () {0;}' unless defined(&FALSE);
    eval 'sub UNDEFINED () {-1;}' unless defined(&UNDEFINED);
    eval 'sub REPORT_LUNS_MIN_LUNS () {2;}' unless defined(&REPORT_LUNS_MIN_LUNS);
    eval 'sub REPORT_LUNS_DEFAULT () {256;}' unless defined(&REPORT_LUNS_DEFAULT);
    eval 'sub REPORT_LUNS_SIZE () {(( &REPORT_LUNS_DEFAULT)*$sizeof{ &uint32_t} +2*$sizeof{ &uint32_t});}' unless defined(&REPORT_LUNS_SIZE);
    if(defined(&__cplusplus)) {
    }
}
1;
