require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_GENERIC_COMMANDS_H)) {
    eval 'sub _SYS_SCSI_GENERIC_COMMANDS_H () {1;}' unless defined(&_SYS_SCSI_GENERIC_COMMANDS_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub CDB_GROUPID {
        my($cmd) = @_;
	    eval q((($cmd >> 5) & 0x7));
    }' unless defined(&CDB_GROUPID);
    eval 'sub CDB_GROUPID_0 () {0;}' unless defined(&CDB_GROUPID_0);
    eval 'sub CDB_GROUPID_1 () {1;}' unless defined(&CDB_GROUPID_1);
    eval 'sub CDB_GROUPID_2 () {2;}' unless defined(&CDB_GROUPID_2);
    eval 'sub CDB_GROUPID_3 () {3;}' unless defined(&CDB_GROUPID_3);
    eval 'sub CDB_GROUPID_4 () {4;}' unless defined(&CDB_GROUPID_4);
    eval 'sub CDB_GROUPID_5 () {5;}' unless defined(&CDB_GROUPID_5);
    eval 'sub CDB_GROUPID_6 () {6;}' unless defined(&CDB_GROUPID_6);
    eval 'sub CDB_GROUPID_7 () {7;}' unless defined(&CDB_GROUPID_7);
    eval 'sub CDB_GROUP0 () {6;}' unless defined(&CDB_GROUP0);
    eval 'sub CDB_GROUP1 () {10;}' unless defined(&CDB_GROUP1);
    eval 'sub CDB_GROUP2 () {10;}' unless defined(&CDB_GROUP2);
    eval 'sub CDB_GROUP3 () {0;}' unless defined(&CDB_GROUP3);
    eval 'sub CDB_GROUP4 () {16;}' unless defined(&CDB_GROUP4);
    eval 'sub CDB_GROUP5 () {12;}' unless defined(&CDB_GROUP5);
    eval 'sub CDB_GROUP6 () {0;}' unless defined(&CDB_GROUP6);
    eval 'sub CDB_GROUP7 () {0;}' unless defined(&CDB_GROUP7);
    eval 'sub SCMD_GROUP0 () {0x;}' unless defined(&SCMD_GROUP0);
    eval 'sub SCMD_TEST_UNIT_READY () {0x;}' unless defined(&SCMD_TEST_UNIT_READY);
    eval 'sub SCMD_REQUEST_SENSE () {0x3;}' unless defined(&SCMD_REQUEST_SENSE);
    eval 'sub SCMD_INQUIRY () {0x12;}' unless defined(&SCMD_INQUIRY);
    eval 'sub SCMD_COPY () {0x18;}' unless defined(&SCMD_COPY);
    eval 'sub SCMD_GDIAG () {0x1c;}' unless defined(&SCMD_GDIAG);
    eval 'sub SCMD_SDIAG () {0x1d;}' unless defined(&SCMD_SDIAG);
    eval 'sub SCMD_REZERO_UNIT () {0x1;}' unless defined(&SCMD_REZERO_UNIT);
    eval 'sub SCMD_FORMAT () {0x4;}' unless defined(&SCMD_FORMAT);
    eval 'sub SCMD_REASSIGN_BLOCK () {0x7;}' unless defined(&SCMD_REASSIGN_BLOCK);
    eval 'sub SCMD_READ () {0x8;}' unless defined(&SCMD_READ);
    eval 'sub SCMD_WRITE () {0xa;}' unless defined(&SCMD_WRITE);
    eval 'sub SCMD_SEEK () {0xb;}' unless defined(&SCMD_SEEK);
    eval 'sub SCMD_MODE_SELECT () {0x15;}' unless defined(&SCMD_MODE_SELECT);
    eval 'sub SCMD_RESERVE () {0x16;}' unless defined(&SCMD_RESERVE);
    eval 'sub SCMD_RELEASE () {0x17;}' unless defined(&SCMD_RELEASE);
    eval 'sub SCMD_MODE_SENSE () {0x1a;}' unless defined(&SCMD_MODE_SENSE);
    eval 'sub SCMD_START_STOP () {0x1b;}' unless defined(&SCMD_START_STOP);
    eval 'sub SCMD_DOORLOCK () {0x1e;}' unless defined(&SCMD_DOORLOCK);
    eval 'sub SCMD_REWIND () {0x1;}' unless defined(&SCMD_REWIND);
    eval 'sub SCMD_READ_BLKLIM () {0x5;}' unless defined(&SCMD_READ_BLKLIM);
    eval 'sub SCMD_TRK_SEL () {0xb;}' unless defined(&SCMD_TRK_SEL);
    eval 'sub SCMD_READ_REVERSE () {0xf;}' unless defined(&SCMD_READ_REVERSE);
    eval 'sub SCMD_WRITE_FILE_MARK () {0x10;}' unless defined(&SCMD_WRITE_FILE_MARK);
    eval 'sub SCMD_SPACE () {0x11;}' unless defined(&SCMD_SPACE);
    eval 'sub SCMD_VERIFY_G0 () {0x13;}' unless defined(&SCMD_VERIFY_G0);
    eval 'sub SCMD_RECOVER_BUF () {0x14;}' unless defined(&SCMD_RECOVER_BUF);
    eval 'sub SCMD_ERASE () {0x19;}' unless defined(&SCMD_ERASE);
    eval 'sub SCMD_LOAD () {0x1b;}' unless defined(&SCMD_LOAD);
    eval 'sub SCMD_PRINT () {0xa;}' unless defined(&SCMD_PRINT);
    eval 'sub SCMD_SLEW_PRINT () {0xb;}' unless defined(&SCMD_SLEW_PRINT);
    eval 'sub SCMD_FLUSH_PRINT_BUF () {0x10;}' unless defined(&SCMD_FLUSH_PRINT_BUF);
    eval 'sub SCMD_STOP_PRINT () {0x1b;}' unless defined(&SCMD_STOP_PRINT);
    eval 'sub SCMD_RECEIVE () {0x8;}' unless defined(&SCMD_RECEIVE);
    eval 'sub SCMD_SEND () {0xa;}' unless defined(&SCMD_SEND);
    eval 'sub SCMD_GROUP1 () {0x20;}' unless defined(&SCMD_GROUP1);
    eval 'sub SCMD_COMPARE () {0x39;}' unless defined(&SCMD_COMPARE);
    eval 'sub SCMD_COPY_VERIFY () {0x3a;}' unless defined(&SCMD_COPY_VERIFY);
    eval 'sub SCMD_READ_CAPACITY () {0x25;}' unless defined(&SCMD_READ_CAPACITY);
    eval 'sub SCMD_READ_G1 () {0x28;}' unless defined(&SCMD_READ_G1);
    eval 'sub SCMD_WRITE_G1 () {0x2a;}' unless defined(&SCMD_WRITE_G1);
    eval 'sub SCMD_SEEK_G1 () {0x2b;}' unless defined(&SCMD_SEEK_G1);
    eval 'sub SCMD_WRITE_VERIFY () {0x2e;}' unless defined(&SCMD_WRITE_VERIFY);
    eval 'sub SCMD_VERIFY () {0x2f;}' unless defined(&SCMD_VERIFY);
    eval 'sub SCMD_SEARCH_HIGH () {0x30;}' unless defined(&SCMD_SEARCH_HIGH);
    eval 'sub SCMD_SEARCH_EQUAL () {0x31;}' unless defined(&SCMD_SEARCH_EQUAL);
    eval 'sub SCMD_SEARCH_LOW () {0x32;}' unless defined(&SCMD_SEARCH_LOW);
    eval 'sub SCMD_SET_LIMITS () {0x33;}' unless defined(&SCMD_SET_LIMITS);
    eval 'sub SCMD_READ_DEFECT_LIST () {0x37;}' unless defined(&SCMD_READ_DEFECT_LIST);
    eval 'sub SCMD_WRITE_BUFFER () {0x3b;}' unless defined(&SCMD_WRITE_BUFFER);
    eval 'sub SCMD_READ_BUFFER () {0x3c;}' unless defined(&SCMD_READ_BUFFER);
    eval 'sub SCMD_READ_LONG () {0x3e;}' unless defined(&SCMD_READ_LONG);
    eval 'sub SCMD_WRITE_LONG () {0x3f;}' unless defined(&SCMD_WRITE_LONG);
    eval 'sub SCMD_RESERVE_G1 () {0x56;}' unless defined(&SCMD_RESERVE_G1);
    eval 'sub SCMD_RELEASE_G1 () {0x57;}' unless defined(&SCMD_RELEASE_G1);
    eval 'sub SCMD_MODE_SELECT_G1 () {0x55;}' unless defined(&SCMD_MODE_SELECT_G1);
    eval 'sub SCMD_MODE_SENSE_G1 () {0x5a;}' unless defined(&SCMD_MODE_SENSE_G1);
    eval 'sub SCMD_GET_CONFIGURATION () {0x46;}' unless defined(&SCMD_GET_CONFIGURATION);
    eval 'sub SCMD_LOG_SENSE_G1 () {0x4d;}' unless defined(&SCMD_LOG_SENSE_G1);
    eval 'sub ATAPI_SET_CD_SPEED () {0xbb;}' unless defined(&ATAPI_SET_CD_SPEED);
    eval 'sub ATAPI_CAPABILITIES () {0x2a;}' unless defined(&ATAPI_CAPABILITIES);
    eval 'sub SCMD_GROUP5 () {0xa0;}' unless defined(&SCMD_GROUP5);
    eval 'sub SCMD_READ_G5 () {0xa8;}' unless defined(&SCMD_READ_G5);
    eval 'sub SCMD_WRITE_G5 () {0xaa;}' unless defined(&SCMD_WRITE_G5);
    if(defined(&__cplusplus)) {
    }
    require 'sys/scsi/generic/inquiry.ph';
    require 'sys/scsi/generic/sense.ph';
    require 'sys/scsi/impl/commands.ph';
}
1;
