require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_IMPL_COMMANDS_H)) {
    eval 'sub _SYS_SCSI_IMPL_COMMANDS_H () {1;}' unless defined(&_SYS_SCSI_IMPL_COMMANDS_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub CDB_SIZE () { &CDB_GROUP5;}' unless defined(&CDB_SIZE);
    eval 'sub SCSI_CDB_SIZE () { &CDB_GROUP4;}' unless defined(&SCSI_CDB_SIZE);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("One\ of\ _BIT_FIELDS_LTOH\ or\ _BIT_FIELDS_HTOL\ must\ be\ defined");
    }
    eval 'sub scc_cmd () { ($cdb_un->{cmd});}' unless defined(&scc_cmd);
    eval 'sub scc_lun () { ($cdb_un->{lun});}' unless defined(&scc_lun);
    eval 'sub g0_addr2 () { ($cdb_un->{tag});}' unless defined(&g0_addr2);
    eval 'sub g0_addr1 () { ($cdb_un->{sg}->{g0}->{addr1});}' unless defined(&g0_addr1);
    eval 'sub g0_addr0 () { ($cdb_un->{sg}->{g0}->{addr0});}' unless defined(&g0_addr0);
    eval 'sub g0_count0 () { ($cdb_un->{sg}->{g0}->{count0});}' unless defined(&g0_count0);
    eval 'sub g0_vu_1 () { ($cdb_un->{sg}->{g0}->{vu_57});}' unless defined(&g0_vu_1);
    eval 'sub g0_vu_0 () { ($cdb_un->{sg}->{g0}->{vu_56});}' unless defined(&g0_vu_0);
    eval 'sub g0_naca () { ($cdb_un->{sg}->{g0}->{naca});}' unless defined(&g0_naca);
    eval 'sub g0_flag () { ($cdb_un->{sg}->{g0}->{flag});}' unless defined(&g0_flag);
    eval 'sub g0_link () { ($cdb_un->{sg}->{g0}->{link});}' unless defined(&g0_link);
    eval 'sub t_code () { ($cdb_un->{tag});}' unless defined(&t_code);
    eval 'sub high_count () { ($cdb_un->{sg}->{g0}->{addr1});}' unless defined(&high_count);
    eval 'sub mid_count () { ($cdb_un->{sg}->{g0}->{addr0});}' unless defined(&mid_count);
    eval 'sub low_count () { ($cdb_un->{sg}->{g0}->{count0});}' unless defined(&low_count);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("One\ of\ _BIT_FIELDS_LTOH\ or\ _BIT_FIELDS_HTOL\ must\ be\ defined");
    }
    eval 'sub g1_reladdr () { ($cdb_un->{tag});}' unless defined(&g1_reladdr);
    eval 'sub g1_rsvd0 () { ($cdb_un->{sg}->{g1}->{rsvd1});}' unless defined(&g1_rsvd0);
    eval 'sub g1_addr3 () { ($cdb_un->{sg}->{g1}->{addr3});}' unless defined(&g1_addr3);
    eval 'sub g1_addr2 () { ($cdb_un->{sg}->{g1}->{addr2});}' unless defined(&g1_addr2);
    eval 'sub g1_addr1 () { ($cdb_un->{sg}->{g1}->{addr1});}' unless defined(&g1_addr1);
    eval 'sub g1_addr0 () { ($cdb_un->{sg}->{g1}->{addr0});}' unless defined(&g1_addr0);
    eval 'sub g1_count1 () { ($cdb_un->{sg}->{g1}->{count1});}' unless defined(&g1_count1);
    eval 'sub g1_count0 () { ($cdb_un->{sg}->{g1}->{count0});}' unless defined(&g1_count0);
    eval 'sub g1_vu_1 () { ($cdb_un->{sg}->{g1}->{vu_97});}' unless defined(&g1_vu_1);
    eval 'sub g1_vu_0 () { ($cdb_un->{sg}->{g1}->{vu_96});}' unless defined(&g1_vu_0);
    eval 'sub g1_naca () { ($cdb_un->{sg}->{g1}->{naca});}' unless defined(&g1_naca);
    eval 'sub g1_flag () { ($cdb_un->{sg}->{g1}->{flag});}' unless defined(&g1_flag);
    eval 'sub g1_link () { ($cdb_un->{sg}->{g1}->{link});}' unless defined(&g1_link);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("One\ of\ _BIT_FIELDS_LTOH\ or\ _BIT_FIELDS_HTOL\ must\ be\ defined");
    }
    eval 'sub g4_reladdr () { ($cdb_un->{tag});}' unless defined(&g4_reladdr);
    eval 'sub g4_addr3 () { ($cdb_un->{sg}->{g4}->{addr3});}' unless defined(&g4_addr3);
    eval 'sub g4_addr2 () { ($cdb_un->{sg}->{g4}->{addr2});}' unless defined(&g4_addr2);
    eval 'sub g4_addr1 () { ($cdb_un->{sg}->{g4}->{addr1});}' unless defined(&g4_addr1);
    eval 'sub g4_addr0 () { ($cdb_un->{sg}->{g4}->{addr0});}' unless defined(&g4_addr0);
    eval 'sub g4_addtl_cdb_data3 () { ($cdb_un->{sg}->{g4}->{addtl_cdb_data3});}' unless defined(&g4_addtl_cdb_data3);
    eval 'sub g4_addtl_cdb_data2 () { ($cdb_un->{sg}->{g4}->{addtl_cdb_data2});}' unless defined(&g4_addtl_cdb_data2);
    eval 'sub g4_addtl_cdb_data1 () { ($cdb_un->{sg}->{g4}->{addtl_cdb_data1});}' unless defined(&g4_addtl_cdb_data1);
    eval 'sub g4_addtl_cdb_data0 () { ($cdb_un->{sg}->{g4}->{addtl_cdb_data0});}' unless defined(&g4_addtl_cdb_data0);
    eval 'sub g4_count3 () { ($cdb_un->{sg}->{g4}->{count3});}' unless defined(&g4_count3);
    eval 'sub g4_count2 () { ($cdb_un->{sg}->{g4}->{count2});}' unless defined(&g4_count2);
    eval 'sub g4_count1 () { ($cdb_un->{sg}->{g4}->{count1});}' unless defined(&g4_count1);
    eval 'sub g4_count0 () { ($cdb_un->{sg}->{g4}->{count0});}' unless defined(&g4_count0);
    eval 'sub g4_rsvd0 () { ($cdb_un->{sg}->{g4}->{rsvd1});}' unless defined(&g4_rsvd0);
    eval 'sub g4_vu_1 () { ($cdb_un->{sg}->{g4}->{vu_157});}' unless defined(&g4_vu_1);
    eval 'sub g4_vu_0 () { ($cdb_un->{sg}->{g4}->{vu_156});}' unless defined(&g4_vu_0);
    eval 'sub g4_naca () { ($cdb_un->{sg}->{g4}->{naca});}' unless defined(&g4_naca);
    eval 'sub g4_flag () { ($cdb_un->{sg}->{g4}->{flag});}' unless defined(&g4_flag);
    eval 'sub g4_link () { ($cdb_un->{sg}->{g4}->{link});}' unless defined(&g4_link);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("One\ of\ _BIT_FIELDS_LTOH\ or\ _BIT_FIELDS_HTOL\ must\ be\ defined");
    }
    eval 'sub scc5_reladdr () { ($cdb_un->{tag});}' unless defined(&scc5_reladdr);
    eval 'sub scc5_addr3 () { ($cdb_un->{sg}->{g5}->{addr3});}' unless defined(&scc5_addr3);
    eval 'sub scc5_addr2 () { ($cdb_un->{sg}->{g5}->{addr2});}' unless defined(&scc5_addr2);
    eval 'sub scc5_addr1 () { ($cdb_un->{sg}->{g5}->{addr1});}' unless defined(&scc5_addr1);
    eval 'sub scc5_addr0 () { ($cdb_un->{sg}->{g5}->{addr0});}' unless defined(&scc5_addr0);
    eval 'sub scc5_count3 () { ($cdb_un->{sg}->{g5}->{count3});}' unless defined(&scc5_count3);
    eval 'sub scc5_count2 () { ($cdb_un->{sg}->{g5}->{count2});}' unless defined(&scc5_count2);
    eval 'sub scc5_count1 () { ($cdb_un->{sg}->{g5}->{count1});}' unless defined(&scc5_count1);
    eval 'sub scc5_count0 () { ($cdb_un->{sg}->{g5}->{count0});}' unless defined(&scc5_count0);
    eval 'sub scc5_rsvd0 () { ($cdb_un->{sg}->{g5}->{rsvd1});}' unless defined(&scc5_rsvd0);
    eval 'sub scc5_vu_1 () { ($cdb_un->{sg}->{g5}->{v117});}' unless defined(&scc5_vu_1);
    eval 'sub scc5_vu_0 () { ($cdb_un->{sg}->{g5}->{v116});}' unless defined(&scc5_vu_0);
    eval 'sub scc5_naca () { ($cdb_un->{sg}->{g5}->{naca});}' unless defined(&scc5_naca);
    eval 'sub scc5_flag () { ($cdb_un->{sg}->{g5}->{flag});}' unless defined(&scc5_flag);
    eval 'sub scc5_link () { ($cdb_un->{sg}->{g5}->{link});}' unless defined(&scc5_link);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("One\ of\ _BIT_FIELDS_LTOH\ or\ _BIT_FIELDS_HTOL\ must\ be\ defined");
    }
    eval 'sub GETCMD {
        my($cdb) = @_;
	    eval q((($cdb)-> &scc_cmd & 0x1f));
    }' unless defined(&GETCMD);
    eval 'sub GETGROUP {
        my($cdb) = @_;
	    eval q(( &CDB_GROUPID(($cdb)-> &scc_cmd)));
    }' unless defined(&GETGROUP);
    eval 'sub FORMG0COUNT {
        my($cdb, $cnt) = @_;
	    eval q(($cdb)-> &g0_count0 = ($cnt));
    }' unless defined(&FORMG0COUNT);
    eval 'sub FORMG0ADDR {
        my($cdb, $addr) = @_;
	    eval q(($cdb)-> &g0_addr2 = ($addr) >> 16; ($cdb)-> &g0_addr1 = (($addr) >> 8) & 0xff; ($cdb)-> &g0_addr0 = ($addr) & 0xff);
    }' unless defined(&FORMG0ADDR);
    eval 'sub GETG0ADDR {
        my($cdb) = @_;
	    eval q(((($cdb)-> &g0_addr2 & 0x1f) << 16) + (($cdb)-> &g0_addr1 << 8) + (($cdb)-> &g0_addr0));
    }' unless defined(&GETG0ADDR);
    eval 'sub GETG0TAG {
        my($cdb) = @_;
	    eval q((($cdb)-> &g0_addr2));
    }' unless defined(&GETG0TAG);
    eval 'sub FORMG0COUNT_S {
        my($cdb, $cnt) = @_;
	    eval q(($cdb)-> &high_count = ($cnt) >> 16; ($cdb)-> &mid_count = (($cnt) >> 8) & 0xff; ($cdb)-> &low_count = ($cnt) & 0xff);
    }' unless defined(&FORMG0COUNT_S);
    eval 'sub FORMG1COUNT {
        my($cdb, $cnt) = @_;
	    eval q(($cdb)-> &g1_count1 = (($cnt) >> 8); ($cdb)-> &g1_count0 = ($cnt) & 0xff);
    }' unless defined(&FORMG1COUNT);
    eval 'sub FORMG1ADDR {
        my($cdb, $addr) = @_;
	    eval q(($cdb)-> &g1_addr3 = ($addr) >> 24; ($cdb)-> &g1_addr2 = (($addr) >> 16) & 0xff; ($cdb)-> &g1_addr1 = (($addr) >> 8) & 0xff; ($cdb)-> &g1_addr0 = ($addr) & 0xff);
    }' unless defined(&FORMG1ADDR);
    eval 'sub GETG1ADDR {
        my($cdb) = @_;
	    eval q((($cdb)-> &g1_addr3 << 24) + (($cdb)-> &g1_addr2 << 16) + (($cdb)-> &g1_addr1 << 8) + (($cdb)-> &g1_addr0));
    }' unless defined(&GETG1ADDR);
    eval 'sub GETG1TAG {
        my($cdb) = @_;
	    eval q(($cdb)-> &g1_reladdr);
    }' unless defined(&GETG1TAG);
    eval 'sub FORMG4COUNT {
        my($cdb, $cnt) = @_;
	    eval q(($cdb)-> &g4_count3 = (($cnt) >> 24); ($cdb)-> &g4_count2 = (($cnt) >> 16) & 0xff; ($cdb)-> &g4_count1 = (($cnt) >> 8) & 0xff; ($cdb)-> &g4_count0 = ($cnt) & 0xff);
    }' unless defined(&FORMG4COUNT);
    eval 'sub FORMG4ADDR {
        my($cdb, $addr) = @_;
	    eval q(($cdb)-> &g4_addr3 = ($addr) >> 24; ($cdb)-> &g4_addr2 = (($addr) >> 16) & 0xff; ($cdb)-> &g4_addr1 = (($addr) >> 8) & 0xff; ($cdb)-> &g4_addr0 = ($addr) & 0xff);
    }' unless defined(&FORMG4ADDR);
    eval 'sub FORMG4ADDTL {
        my($cdb, $addtl_cdb_data) = @_;
	    eval q(($cdb)-> &g4_addtl_cdb_data3 = ($addtl_cdb_data) >> 24; ($cdb)-> &g4_addtl_cdb_data2 = (($addtl_cdb_data) >> 16) & 0xff; ($cdb)-> &g4_addtl_cdb_data1 = (($addtl_cdb_data) >> 8) & 0xff; ($cdb)-> &g4_addtl_cdb_data0 = ($addtl_cdb_data) & 0xff);
    }' unless defined(&FORMG4ADDTL);
    eval 'sub GETG4ADDR {
        my($cdb) = @_;
	    eval q((($cdb)-> &g4_addr3 << 24) + (($cdb)-> &g4_addr2 << 16) + (($cdb)-> &g4_addr1 << 8) + (($cdb)-> &g4_addr0));
    }' unless defined(&GETG4ADDR);
    eval 'sub GETG4TAG {
        my($cdb) = @_;
	    eval q(($cdb)-> &g4_reladdr);
    }' unless defined(&GETG4TAG);
    eval 'sub FORMG5COUNT {
        my($cdb, $cnt) = @_;
	    eval q(($cdb)-> &scc5_count3 = (($cnt) >> 24); ($cdb)-> &scc5_count2 = (($cnt) >> 16) & 0xff; ($cdb)-> &scc5_count1 = (($cnt) >> 8) & 0xff; ($cdb)-> &scc5_count0 = ($cnt) & 0xff);
    }' unless defined(&FORMG5COUNT);
    eval 'sub FORMG5ADDR {
        my($cdb, $addr) = @_;
	    eval q(($cdb)-> &scc5_addr3 = ($addr) >> 24; ($cdb)-> &scc5_addr2 = (($addr) >> 16) & 0xff; ($cdb)-> &scc5_addr1 = (($addr) >> 8) & 0xff; ($cdb)-> &scc5_addr0 = ($addr) & 0xff);
    }' unless defined(&FORMG5ADDR);
    eval 'sub GETG5ADDR {
        my($cdb) = @_;
	    eval q((($cdb)-> &scc5_addr3 << 24) + (($cdb)-> &scc5_addr2 << 16) + (($cdb)-> &scc5_addr1 << 8) + (($cdb)-> &scc5_addr0));
    }' unless defined(&GETG5ADDR);
    eval 'sub GETG5TAG {
        my($cdb) = @_;
	    eval q(($cdb)-> &scc5_reladdr);
    }' unless defined(&GETG5TAG);
    eval 'sub MAKECOM_COMMON {
        my($pktp, $devp, $flag, $cmd) = @_;
	    eval q(($pktp)-> &pkt_address = ($devp)-> &sd_address, ($pktp)-> &pkt_flags = ($flag), (($pktp)-> &pkt_cdbp)-> &scc_cmd = ($cmd), (($pktp)-> &pkt_cdbp)-> &scc_lun = ($pktp)-> ($pkt_address->{a_lun}));
    }' unless defined(&MAKECOM_COMMON);
    eval 'sub MAKECOM_G0 {
        my($pktp, $devp, $flag, $cmd, $addr, $cnt) = @_;
	    eval q( &MAKECOM_COMMON(($pktp), ($devp), ($flag), ($cmd)),  &FORMG0ADDR((($pktp)-> &pkt_cdbp), ($addr)),  &FORMG0COUNT((($pktp)-> &pkt_cdbp), ($cnt)));
    }' unless defined(&MAKECOM_G0);
    eval 'sub MAKECOM_G0_S {
        my($pktp, $devp, $flag, $cmd, $cnt, $fixbit) = @_;
	    eval q( &MAKECOM_COMMON(($pktp), ($devp), ($flag), ($cmd)),  &FORMG0COUNT_S((($pktp)-> &pkt_cdbp), ($cnt)), (($pktp)-> &pkt_cdbp)-> &t_code = ($fixbit));
    }' unless defined(&MAKECOM_G0_S);
    eval 'sub MAKECOM_G1 {
        my($pktp, $devp, $flag, $cmd, $addr, $cnt) = @_;
	    eval q( &MAKECOM_COMMON(($pktp), ($devp), ($flag), ($cmd)),  &FORMG1ADDR((($pktp)-> &pkt_cdbp), ($addr)),  &FORMG1COUNT((($pktp)-> &pkt_cdbp), ($cnt)));
    }' unless defined(&MAKECOM_G1);
    eval 'sub MAKECOM_G5 {
        my($pktp, $devp, $flag, $cmd, $addr, $cnt) = @_;
	    eval q( &MAKECOM_COMMON(($pktp), ($devp), ($flag), ($cmd)),  &FORMG5ADDR((($pktp)-> &pkt_cdbp), ($addr)),  &FORMG5COUNT((($pktp)-> &pkt_cdbp), ($cnt)));
    }' unless defined(&MAKECOM_G5);
    eval 'sub fmt_parm_bits () { &g0_addr2;}' unless defined(&fmt_parm_bits);
    eval 'sub fmt_interleave () { &g0_count0;}' unless defined(&fmt_interleave);
    eval 'sub defect_list_descrip () { &g1_addr3;}' unless defined(&defect_list_descrip);
    eval 'sub FPB_BFI () {0x4;}' unless defined(&FPB_BFI);
    eval 'sub FPB_CMPLT () {0x8;}' unless defined(&FPB_CMPLT);
    eval 'sub FPB_DATA () {0x10;}' unless defined(&FPB_DATA);
    eval 'sub DLD_MAN_DEF_LIST () {0x10;}' unless defined(&DLD_MAN_DEF_LIST);
    eval 'sub DLD_GROWN_DEF_LIST () {0x8;}' unless defined(&DLD_GROWN_DEF_LIST);
    eval 'sub DLD_BLOCK_FORMAT () {0x;}' unless defined(&DLD_BLOCK_FORMAT);
    eval 'sub DLD_BFI_FORMAT () {0x4;}' unless defined(&DLD_BFI_FORMAT);
    eval 'sub DLD_PS_FORMAT () {0x5;}' unless defined(&DLD_PS_FORMAT);
    eval 'sub RDEF_ALL () {0;}' unless defined(&RDEF_ALL);
    eval 'sub RDEF_MANUF () {1;}' unless defined(&RDEF_MANUF);
    eval 'sub RDEF_CKLEN () {2;}' unless defined(&RDEF_CKLEN);
    eval 'sub ST506_NDEFECT () {127;}' unless defined(&ST506_NDEFECT);
    eval 'sub ESDI_NDEFECT () { &ST506_NDEFECT;}' unless defined(&ESDI_NDEFECT);
    if(defined(&_KERNEL)) {
	if(defined(&__STDC__)) {
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
