require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_TARGETS_SGENDEF_H)) {
    eval 'sub _SYS_SCSI_TARGETS_SGENDEF_H () {1;}' unless defined(&_SYS_SCSI_TARGETS_SGENDEF_H);
    require 'sys/types.ph';
    require 'sys/kstat.ph';
    require 'sys/condvar.ph';
    require 'sys/mutex.ph';
    require 'sys/buf.ph';
    require 'sys/scsi/scsi.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub SGEN_IOC () {((ord(\'S\' << 16) | (\'G\') << 8));}' unless defined(&SGEN_IOC);
    eval 'sub SGEN_IOC_READY () {( &SGEN_IOC | 0x1);}' unless defined(&SGEN_IOC_READY);
    eval 'sub SGEN_IOC_DIAG () {( &SGEN_IOC | 0x2);}' unless defined(&SGEN_IOC_DIAG);
    if(defined( &_KERNEL)) {
	eval 'sub SGEN_DIAG1 () {((1<< 8) |  &CE_CONT);}' unless defined(&SGEN_DIAG1);
	eval 'sub SGEN_DIAG2 () {((2<< 8) |  &CE_CONT);}' unless defined(&SGEN_DIAG2);
	eval 'sub SGEN_DIAG3 () {((3<< 8) |  &CE_CONT);}' unless defined(&SGEN_DIAG3);
	eval 'sub sgen_mutex () { ($sgen_scsidev->{sd_mutex});}' unless defined(&sgen_mutex);
	eval 'sub sgen_devinfo () { ($sgen_scsidev->{sd_dev});}' unless defined(&sgen_devinfo);
	eval 'sub sgen_scsiaddr () { ($sgen_scsidev->{sd_address});}' unless defined(&sgen_scsiaddr);
	eval 'sub sgen_sense () { ($sgen_scsidev->{sd_sense});}' unless defined(&sgen_sense);
	eval 'sub SGEN_FL_OPEN () {0x1;}' unless defined(&SGEN_FL_OPEN);
	eval 'sub SGEN_FL_SUSP () {0x2;}' unless defined(&SGEN_FL_SUSP);
	eval 'sub SGEN_FL_BUSY () {0x4;}' unless defined(&SGEN_FL_BUSY);
	eval 'sub SGEN_SET_OPEN {
	    my($stp) = @_;
    	    eval q(((( &sgen_state_t *)($stp))-> &sgen_flags |=  &SGEN_FL_OPEN));
	}' unless defined(&SGEN_SET_OPEN);
	eval 'sub SGEN_CLR_OPEN {
	    my($stp) = @_;
    	    eval q(((( &sgen_state_t *)($stp))-> &sgen_flags &= ~ &SGEN_FL_OPEN));
	}' unless defined(&SGEN_CLR_OPEN);
	eval 'sub SGEN_IS_OPEN {
	    my($stp) = @_;
    	    eval q((((( &sgen_state_t *)($stp))-> &sgen_flags &  &SGEN_FL_OPEN) ==  &SGEN_FL_OPEN));
	}' unless defined(&SGEN_IS_OPEN);
	eval 'sub SGEN_SET_SUSP {
	    my($stp) = @_;
    	    eval q(((( &sgen_state_t *)($stp))-> &sgen_flags |=  &SGEN_FL_SUSP));
	}' unless defined(&SGEN_SET_SUSP);
	eval 'sub SGEN_CLR_SUSP {
	    my($stp) = @_;
    	    eval q(((( &sgen_state_t *)($stp))-> &sgen_flags &= ~ &SGEN_FL_SUSP));
	}' unless defined(&SGEN_CLR_SUSP);
	eval 'sub SGEN_IS_SUSP {
	    my($stp) = @_;
    	    eval q((((( &sgen_state_t *)($stp))-> &sgen_flags &  &SGEN_FL_SUSP) ==  &SGEN_FL_SUSP));
	}' unless defined(&SGEN_IS_SUSP);
	eval 'sub SGEN_SET_BUSY {
	    my($stp) = @_;
    	    eval q(((( &sgen_state_t *)($stp))-> &sgen_flags |=  &SGEN_FL_BUSY));
	}' unless defined(&SGEN_SET_BUSY);
	eval 'sub SGEN_CLR_BUSY {
	    my($stp) = @_;
    	    eval q(((( &sgen_state_t *)($stp))-> &sgen_flags &= ~ &SGEN_FL_BUSY));
	}' unless defined(&SGEN_CLR_BUSY);
	eval 'sub SGEN_IS_BUSY {
	    my($stp) = @_;
    	    eval q((((( &sgen_state_t *)($stp))-> &sgen_flags &  &SGEN_FL_BUSY) ==  &SGEN_FL_BUSY));
	}' unless defined(&SGEN_IS_BUSY);
	eval 'sub SGEN_ESTIMATED_NUM_DEVS () {4;}' unless defined(&SGEN_ESTIMATED_NUM_DEVS);
	eval 'sub SGEN_BSY_TIMEOUT () {( &drv_usectohz(5* 1000000));}' unless defined(&SGEN_BSY_TIMEOUT);
	eval 'sub SGEN_IO_TIME () {60;}' unless defined(&SGEN_IO_TIME);
	eval 'sub COMMAND_DONE () {0;}' unless defined(&COMMAND_DONE);
	eval 'sub COMMAND_DONE_ERROR () {1;}' unless defined(&COMMAND_DONE_ERROR);
	eval 'sub FETCH_SENSE () {2;}' unless defined(&FETCH_SENSE);
	eval 'sub SET_BP_ERROR {
	    my($bp, $err) = @_;
    	    eval q( ($bp->{b_oerror}) = $err,  &bioerror($bp, $err););
	}' unless defined(&SET_BP_ERROR);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
