require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_TARGETS_SSDDEF_H)) {
    eval 'sub _SYS_SCSI_TARGETS_SSDDEF_H () {1;}' unless defined(&_SYS_SCSI_TARGETS_SSDDEF_H);
    require 'sys/note.ph';
    require 'sys/mhd.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &_KERNEL) || defined( &_KMEMUSER)) {
	eval 'sub USCSI_DEFAULT_MAXPHYS () {0x80000;}' unless defined(&USCSI_DEFAULT_MAXPHYS);
	eval 'sub SSD_SCSI_DEVP () {( ($un->{un_sd}));}' unless defined(&SSD_SCSI_DEVP);
	eval 'sub SSD_DEVINFO () {( ($SSD_SCSI_DEVP->{sd_dev}));}' unless defined(&SSD_DEVINFO);
	eval 'sub SSD_INQUIRY () {( ($SSD_SCSI_DEVP->{sd_inq}));}' unless defined(&SSD_INQUIRY);
	eval 'sub SSD_RQSENSE () {( ($SSD_SCSI_DEVP->{sd_sense}));}' unless defined(&SSD_RQSENSE);
	eval 'sub SSD_MUTEX () {( ($SSD_SCSI_DEVP->{sd_mutex}));}' unless defined(&SSD_MUTEX);
	eval 'sub ROUTE () {( ($SSD_SCSI_DEVP->{sd_address}));}' unless defined(&ROUTE);
	eval 'sub SCBP {
	    my($pkt) = @_;
    	    eval q((($pkt)-> &pkt_scbp));
	}' unless defined(&SCBP);
	eval 'sub SCBP_C {
	    my($pkt) = @_;
    	    eval q(((*($pkt)-> &pkt_scbp) &  &STATUS_MASK));
	}' unless defined(&SCBP_C);
	eval 'sub CDBP {
	    my($pkt) = @_;
    	    eval q((($pkt)-> &pkt_cdbp));
	}' unless defined(&CDBP);
	eval 'sub NO_PKT_ALLOCATED () {(0);}' unless defined(&NO_PKT_ALLOCATED);
	eval 'sub ALLOCATING_PKT () {(-1);}' unless defined(&ALLOCATING_PKT);
	eval 'sub BP_PKT {
	    my($bp) = @_;
    	    eval q(( ($bp->{av_back})));
	}' unless defined(&BP_PKT);
	eval 'sub BP_HAS_NO_PKT {
	    my($bp) = @_;
    	    eval q(( ($bp->{av_back}) ==  &NO_PKT_ALLOCATED));
	}' unless defined(&BP_HAS_NO_PKT);
	eval 'sub STATUS_SCBP_C {
	    my($statusp) = @_;
    	    eval q((*( &uchar_t *)($statusp) &  &STATUS_MASK));
	}' unless defined(&STATUS_SCBP_C);
	eval 'sub Tgt {
	    my($devp) = @_;
    	    eval q(( ($devp->{sd_address}->{a_target})));
	}' unless defined(&Tgt);
	eval 'sub Lun {
	    my($devp) = @_;
    	    eval q(( ($devp->{sd_address}->{a_lun})));
	}' unless defined(&Lun);
	eval 'sub New_state {
	    my($un, $s) = @_;
    	    eval q(($un)-> &un_last_state = ($un)-> &un_state, ($un)-> &un_state = ($s));
	}' unless defined(&New_state);
	eval 'sub Restore_state {
	    my($un) = @_;
    	    eval q({  &uchar_t  &tmp = ($un)-> &un_last_state;  &New_state(($un),  &tmp); });
	}' unless defined(&Restore_state);
	eval 'sub SSDUNIT_SHIFT () {3;}' unless defined(&SSDUNIT_SHIFT);
	eval 'sub SSDPART_MASK () {7;}' unless defined(&SSDPART_MASK);
	eval 'sub SSDUNIT {
	    my($dev) = @_;
    	    eval q(( &getminor(($dev))>> &SSDUNIT_SHIFT));
	}' unless defined(&SSDUNIT);
	eval 'sub SSDPART {
	    my($dev) = @_;
    	    eval q(( &getminor(($dev)) &SSDPART_MASK));
	}' unless defined(&SSDPART);
	eval 'sub OCSIZE () {$sizeof{\'struct ocinfo\'};}' unless defined(&OCSIZE);
	eval 'sub lyropen () { ($rinfo->{lyr_open});}' unless defined(&lyropen);
	eval 'sub regopen () { ($rinfo->{reg_open});}' unless defined(&regopen);
	eval 'sub SSD_SCMD_PRIN () {0x5e;}' unless defined(&SSD_SCMD_PRIN);
	eval 'sub SSD_SCMD_PROUT () {0x5f;}' unless defined(&SSD_SCMD_PROUT);
	eval 'sub SSD_READ_KEYS () {0x;}' unless defined(&SSD_READ_KEYS);
	eval 'sub SSD_READ_RESV () {0x1;}' unless defined(&SSD_READ_RESV);
	eval 'sub SSD_SCSI3_REGISTER () {0x;}' unless defined(&SSD_SCSI3_REGISTER);
	eval 'sub SSD_SCSI3_RESERVE () {0x1;}' unless defined(&SSD_SCSI3_RESERVE);
	eval 'sub SSD_SCSI3_RELEASE () {0x2;}' unless defined(&SSD_SCSI3_RELEASE);
	eval 'sub SSD_SCSI3_PREEMPTANDABORT () {0x5;}' unless defined(&SSD_SCSI3_PREEMPTANDABORT);
	eval 'sub SSD_SCSI3_REGISTERANDIGNOREKEY () {0x6;}' unless defined(&SSD_SCSI3_REGISTERANDIGNOREKEY);
	eval 'sub SSD_SCSI3_RESERVATION () {0x;}' unless defined(&SSD_SCSI3_RESERVATION);
	eval 'sub SSD_SCSI2_RESERVATION () {0x1;}' unless defined(&SSD_SCSI2_RESERVATION);
	eval 'sub SSD_MAX_XFER_SIZE () {(1024* 1024);}' unless defined(&SSD_MAX_XFER_SIZE);
	eval 'sub PP_LEN () {($sizeof{\'struct ssd_pkt_private\'});}' unless defined(&PP_LEN);
	eval 'sub PKT_SET_BP {
	    my($pkt, $bp) = @_;
    	    eval q(( ($pkt->{pkt_private}))-> &ssdpp_bp = $bp);
	}' unless defined(&PKT_SET_BP);
	eval 'sub PKT_GET_BP {
	    my($pkt) = @_;
    	    eval q((( ($pkt->{pkt_private}))-> &ssdpp_bp));
	}' unless defined(&PKT_GET_BP);
	eval 'sub PKT_SET_RETRY_CNT {
	    my($pkt, $n) = @_;
    	    eval q(( ($pkt->{pkt_private}))-> &ssdpp_retry_count = $n);
	}' unless defined(&PKT_SET_RETRY_CNT);
	eval 'sub PKT_GET_RETRY_CNT {
	    my($pkt) = @_;
    	    eval q((( ($pkt->{pkt_private}))-> &ssdpp_retry_count));
	}' unless defined(&PKT_GET_RETRY_CNT);
	eval 'sub PKT_INCR_RETRY_CNT {
	    my($pkt, $n) = @_;
    	    eval q(( ($pkt->{pkt_private}))-> &ssdpp_retry_count += $n);
	}' unless defined(&PKT_INCR_RETRY_CNT);
	eval 'sub PKT_SET_VICTIM_RETRY_CNT {
	    my($pkt, $n) = @_;
    	    eval q(( ($pkt->{pkt_private}))-> &ssdpp_victim_retry_count = $n);
	}' unless defined(&PKT_SET_VICTIM_RETRY_CNT);
	eval 'sub PKT_GET_VICTIM_RETRY_CNT {
	    my($pkt) = @_;
    	    eval q((( ($pkt->{pkt_private}))-> &ssdpp_victim_retry_count));
	}' unless defined(&PKT_GET_VICTIM_RETRY_CNT);
	eval 'sub PKT_INCR_VICTIM_RETRY_CNT {
	    my($pkt, $n) = @_;
    	    eval q(( ($pkt->{pkt_private}))-> &ssdpp_victim_retry_count += $n);
	}' unless defined(&PKT_INCR_VICTIM_RETRY_CNT);
	eval 'sub SSD_VICTIM_RETRY_COUNT () {( &ssd_victim_retry_count);}' unless defined(&SSD_VICTIM_RETRY_COUNT);
	if((defined(&DEBUG) ? &DEBUG : 0) || (defined(&lint) ? &lint : 0)) {
	    eval 'sub SDDEBUG () {1;}' unless defined(&SDDEBUG);
	}
	if(defined(&SDDEBUG)) {
	    eval 'sub DEBUGGING () {( &ssddebug > 1);}' unless defined(&DEBUGGING);
	    eval 'sub SSD_DEBUG () { &if ( &ssddebug == 1)  &scsi_log;}' unless defined(&SSD_DEBUG);
	    eval 'sub SSD_DEBUG2 () { &if ( &ssddebug == 2)  &scsi_log;}' unless defined(&SSD_DEBUG2);
	    eval 'sub SSD_DEBUG3 () { &if ( &ssddebug == 3)  &scsi_log;}' unless defined(&SSD_DEBUG3);
	} else {
	    eval 'sub ssddebug () {(0);}' unless defined(&ssddebug);
	    eval 'sub DEBUGGING () {(0);}' unless defined(&DEBUGGING);
	    eval 'sub SSD_DEBUG () { &if (0)  &scsi_log;}' unless defined(&SSD_DEBUG);
	    eval 'sub SSD_DEBUG2 () { &if (0)  &scsi_log;}' unless defined(&SSD_DEBUG2);
	    eval 'sub SSD_DEBUG3 () { &if (0)  &scsi_log;}' unless defined(&SSD_DEBUG3);
	}
    }
    eval 'sub MAX_THROTTLE () {64;}' unless defined(&MAX_THROTTLE);
    eval 'sub MIN_THROTTLE () {8;}' unless defined(&MIN_THROTTLE);
    eval 'sub SSD_STATE_NORMAL () {0;}' unless defined(&SSD_STATE_NORMAL);
    eval 'sub SSD_STATE_OFFLINE () {1;}' unless defined(&SSD_STATE_OFFLINE);
    eval 'sub SSD_STATE_RWAIT () {2;}' unless defined(&SSD_STATE_RWAIT);
    eval 'sub SSD_STATE_DUMPING () {3;}' unless defined(&SSD_STATE_DUMPING);
    eval 'sub SSD_STATE_EJECTED () {4;}' unless defined(&SSD_STATE_EJECTED);
    eval 'sub SSD_STATE_SUSPENDED () {5;}' unless defined(&SSD_STATE_SUSPENDED);
    eval 'sub SSD_STATE_PM_SUSPENDED () {6;}' unless defined(&SSD_STATE_PM_SUSPENDED);
    eval 'sub SSDERR_ALL () {0;}' unless defined(&SSDERR_ALL);
    eval 'sub SSDERR_UNKNOWN () {1;}' unless defined(&SSDERR_UNKNOWN);
    eval 'sub SSDERR_INFORMATIONAL () {2;}' unless defined(&SSDERR_INFORMATIONAL);
    eval 'sub SSDERR_RECOVERED () {3;}' unless defined(&SSDERR_RECOVERED);
    eval 'sub SSDERR_RETRYABLE () {4;}' unless defined(&SSDERR_RETRYABLE);
    eval 'sub SSDERR_FATAL () {5;}' unless defined(&SSDERR_FATAL);
    eval 'sub SSD_IO_TIME () {60;}' unless defined(&SSD_IO_TIME);
    eval 'sub SSD_FMT_TIME () {120*60;}' unless defined(&SSD_FMT_TIME);
    eval 'sub SSD_BSY_TIMEOUT () {( &drv_usectohz(( &clock_t)5* 1000000));}' unless defined(&SSD_BSY_TIMEOUT);
    eval 'sub SSD_RESTART_TIMEOUT () {( &drv_usectohz(( &clock_t)100000));}' unless defined(&SSD_RESTART_TIMEOUT);
    eval 'sub SSD_RESET_THROTTLE_TIMEOUT () {60;}' unless defined(&SSD_RESET_THROTTLE_TIMEOUT);
    eval 'sub SSD_RETRY_COUNT () {3;}' unless defined(&SSD_RETRY_COUNT);
    eval 'sub SSD_MAXUNIT () {32;}' unless defined(&SSD_MAXUNIT);
    eval 'sub SSD_WAIT_CMDS_COMPLETE () {30;}' unless defined(&SSD_WAIT_CMDS_COMPLETE);
    eval 'sub SSD_RELEASE () {0x;}' unless defined(&SSD_RELEASE);
    eval 'sub SSD_RESERVE () {0x1;}' unless defined(&SSD_RESERVE);
    eval 'sub SSD_TKOWN () {0x2;}' unless defined(&SSD_TKOWN);
    eval 'sub SSD_LOST_RESERVE () {0x4;}' unless defined(&SSD_LOST_RESERVE);
    eval 'sub SSD_FAILFAST () {0x80;}' unless defined(&SSD_FAILFAST);
    eval 'sub SSD_WANT_RESERVE () {0x100;}' unless defined(&SSD_WANT_RESERVE);
    eval 'sub SSD_RESERVATION_CONFLICT () {0x200;}' unless defined(&SSD_RESERVATION_CONFLICT);
    eval 'sub SSD_PRIORITY_RESERVE () {0x400;}' unless defined(&SSD_PRIORITY_RESERVE);
    eval 'sub SSD_MAX_NODES () {16;}' unless defined(&SSD_MAX_NODES);
    eval 'sub SSD_REINSTATE_RESV_DELAY () {6000000;}' unless defined(&SSD_REINSTATE_RESV_DELAY);
    eval 'sub COMMAND_DONE () {0;}' unless defined(&COMMAND_DONE);
    eval 'sub COMMAND_DONE_ERROR () {1;}' unless defined(&COMMAND_DONE_ERROR);
    eval 'sub QUE_COMMAND () {2;}' unless defined(&QUE_COMMAND);
    eval 'sub QUE_COMMAND_NOW () {3;}' unless defined(&QUE_COMMAND_NOW);
    eval 'sub QUE_SENSE () {4;}' unless defined(&QUE_SENSE);
    eval 'sub JUST_RETURN () {5;}' unless defined(&JUST_RETURN);
    eval 'sub SSD_STOP () {(0);}' unless defined(&SSD_STOP);
    eval 'sub SSD_START () {(1);}' unless defined(&SSD_START);
    eval 'sub VIDMAX () {8;}' unless defined(&VIDMAX);
    eval 'sub PIDMAX () {16;}' unless defined(&PIDMAX);
    eval 'sub SSD_NODISC () {0x1;}' unless defined(&SSD_NODISC);
    eval 'sub SSD_NOPARITY () {0x2;}' unless defined(&SSD_NOPARITY);
    eval 'sub SSD_MULTICMD () {0x4;}' unless defined(&SSD_MULTICMD);
    eval 'sub SSD_EIOENABLE () {0x8;}' unless defined(&SSD_EIOENABLE);
    eval 'sub SSD_QUEUEING () {0x10;}' unless defined(&SSD_QUEUEING);
    eval 'sub SSD_EACCES () {1;}' unless defined(&SSD_EACCES);
    eval 'sub SCMD_SYNCHRONIZE_CACHE () {0x35;}' unless defined(&SCMD_SYNCHRONIZE_CACHE);
    eval 'sub SSA_PRIORITY_RESERVE () {0x80;}' unless defined(&SSA_PRIORITY_RESERVE);
    eval 'sub SSD_CONF_VERSION () {1;}' unless defined(&SSD_CONF_VERSION);
    eval 'sub SSD_CONF_SET_THROTTLE () {0;}' unless defined(&SSD_CONF_SET_THROTTLE);
    eval 'sub SSD_CONF_BSET_THROTTLE () {(1<<  &SSD_CONF_SET_THROTTLE);}' unless defined(&SSD_CONF_BSET_THROTTLE);
    eval 'sub SSD_CONF_SET_NOTREADY_RETRIES () {1;}' unless defined(&SSD_CONF_SET_NOTREADY_RETRIES);
    eval 'sub SSD_CONF_BSET_NRR_COUNT () {(1<<  &SSD_CONF_SET_NOTREADY_RETRIES);}' unless defined(&SSD_CONF_BSET_NRR_COUNT);
    eval 'sub SSD_CONF_SET_BUSY_RETRIES () {2;}' unless defined(&SSD_CONF_SET_BUSY_RETRIES);
    eval 'sub SSD_CONF_BSET_BSY_RETRY_COUNT () {(1<<  &SSD_CONF_SET_BUSY_RETRIES);}' unless defined(&SSD_CONF_BSET_BSY_RETRY_COUNT);
    eval 'sub SSD_CONF_SET_RST_RETRIES () {3;}' unless defined(&SSD_CONF_SET_RST_RETRIES);
    eval 'sub SSD_CONF_BSET_RST_RETRY_COUNT () {(1<<  &SSD_CONF_SET_RST_RETRIES);}' unless defined(&SSD_CONF_BSET_RST_RETRY_COUNT);
    eval 'sub SSD_CONF_SET_RSV_REL_TIME () {4;}' unless defined(&SSD_CONF_SET_RSV_REL_TIME);
    eval 'sub SSD_CONF_BSET_RSV_REL_TIME () {(1<<  &SSD_CONF_SET_RSV_REL_TIME);}' unless defined(&SSD_CONF_BSET_RSV_REL_TIME);
    eval 'sub SSD_CONF_MAX_ITEMS () {5;}' unless defined(&SSD_CONF_MAX_ITEMS);
    eval 'sub SSD_SPINDLE_OFF () {0x;}' unless defined(&SSD_SPINDLE_OFF);
    eval 'sub SSD_SPINDLE_ON () {0x1;}' unless defined(&SSD_SPINDLE_ON);
    eval 'sub SSD_PM_NOT_SUPPORTED () {0x2;}' unless defined(&SSD_PM_NOT_SUPPORTED);
    eval 'sub START_STOP_CYCLE_COUNTER_PAGE_SIZE () {0x28;}' unless defined(&START_STOP_CYCLE_COUNTER_PAGE_SIZE);
    eval 'sub START_STOP_CYCLE_PAGE () {0xe;}' unless defined(&START_STOP_CYCLE_PAGE);
    eval 'sub START_STOP_CYCLE_VU_PAGE () {0x31;}' unless defined(&START_STOP_CYCLE_VU_PAGE);
    eval 'sub SSD_BECOMING_ACTIVE () {0x1;}' unless defined(&SSD_BECOMING_ACTIVE);
    if(defined(&__cplusplus)) {
    }
}
1;
