require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SOBJECT_H)) {
    eval 'sub _SYS_SOBJECT_H () {1;}' unless defined(&_SYS_SOBJECT_H);
    require 'sys/types.ph';
    require 'sys/thread.ph';
    if(defined(&__cplusplus)) {
    }
    eval("sub SOBJ_NONE () { 0; }") unless defined(&SOBJ_NONE);
    eval("sub SOBJ_MUTEX () { 1; }") unless defined(&SOBJ_MUTEX);
    eval("sub SOBJ_RWLOCK () { 2; }") unless defined(&SOBJ_RWLOCK);
    eval("sub SOBJ_CV () { 3; }") unless defined(&SOBJ_CV);
    eval("sub SOBJ_SEMA () { 4; }") unless defined(&SOBJ_SEMA);
    eval("sub SOBJ_USER () { 5; }") unless defined(&SOBJ_USER);
    eval("sub SOBJ_USER_PI () { 6; }") unless defined(&SOBJ_USER_PI);
    eval("sub SOBJ_SHUTTLE () { 7; }") unless defined(&SOBJ_SHUTTLE);
    if(defined(&_KERNEL)) {
	eval 'sub SOBJ_TYPE {
	    my($sobj_ops) = @_;
    	    eval q( ($sobj_ops->{sobj_type}));
	}' unless defined(&SOBJ_TYPE);
	eval 'sub SOBJ_OWNER {
	    my($sobj_ops, $sobj) = @_;
    	    eval q((*( ($sobj_ops->{sobj_owner})))($sobj));
	}' unless defined(&SOBJ_OWNER);
	eval 'sub SOBJ_UNSLEEP {
	    my($sobj_ops, $t) = @_;
    	    eval q((*( ($sobj_ops->{sobj_unsleep})))($t));
	}' unless defined(&SOBJ_UNSLEEP);
	eval 'sub SOBJ_CHANGE_PRI {
	    my($sobj_ops, $t, $pri) = @_;
    	    eval q((*( ($sobj_ops->{sobj_change_pri})))($t, $pri,  ($t->{t_pri})));
	}' unless defined(&SOBJ_CHANGE_PRI);
	eval 'sub SOBJ_CHANGE_EPRI {
	    my($sobj_ops, $t, $pri) = @_;
    	    eval q((*( ($sobj_ops->{sobj_change_pri})))($t, $pri,  ($t->{t_epri})));
	}' unless defined(&SOBJ_CHANGE_EPRI);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
