require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_STACK_H)) {
    eval 'sub _SYS_STACK_H () {1;}' unless defined(&_SYS_STACK_H);
    if(!defined( &_ASM)) {
	require 'sys/types.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub WINDOWSIZE32 () {(16*4);}' unless defined(&WINDOWSIZE32);
    eval 'sub ARGPUSHSIZE32 () {(6*4);}' unless defined(&ARGPUSHSIZE32);
    eval 'sub ARGPUSH32 () {( &WINDOWSIZE32 + 4);}' unless defined(&ARGPUSH32);
    eval 'sub MINFRAME32 () {( &WINDOWSIZE32 +  &ARGPUSHSIZE32 + 4);}' unless defined(&MINFRAME32);
    eval 'sub STACK_GROWTH_DOWN () {1;}' unless defined(&STACK_GROWTH_DOWN);
    eval 'sub STACK_ALIGN32 () {8;}' unless defined(&STACK_ALIGN32);
    eval 'sub SA32 {
        my($X) = @_;
	    eval q(((($X)+( &STACK_ALIGN32-1)) & ~( &STACK_ALIGN32-1)));
    }' unless defined(&SA32);
    if(defined( &__sparcv9) || defined( &__sparcv9cpu)) {
	eval 'sub WINDOWSIZE64 () {(16*8);}' unless defined(&WINDOWSIZE64);
	eval 'sub ARGPUSHSIZE64 () {(6*8);}' unless defined(&ARGPUSHSIZE64);
	eval 'sub MINFRAME64 () {( &WINDOWSIZE64 + 48);}' unless defined(&MINFRAME64);
	eval 'sub ARGPUSH64 () {( &WINDOWSIZE64);}' unless defined(&ARGPUSH64);
	eval 'sub V9BIAS64 () {(2048-1);}' unless defined(&V9BIAS64);
	eval 'sub STACK_ALIGN64 () {16;}' unless defined(&STACK_ALIGN64);
	eval 'sub SA64 {
	    my($X) = @_;
    	    eval q(((($X)+( &STACK_ALIGN64-1)) & ~( &STACK_ALIGN64-1)));
	}' unless defined(&SA64);
	eval 'sub IS_V9STACK {
	    my($x) = @_;
    	    eval q((((( &uintptr_t)($x) +  &V9BIAS64) & ( &STACK_ALIGN64-1)) == 0));
	}' unless defined(&IS_V9STACK);
    }
    if(defined(&__sparcv9)) {
	eval 'sub WINDOWSIZE () { &WINDOWSIZE64;}' unless defined(&WINDOWSIZE);
	eval 'sub ARGPUSHSIZE () { &ARGPUSHSIZE64;}' unless defined(&ARGPUSHSIZE);
	eval 'sub ARGPUSH () { &ARGPUSH64;}' unless defined(&ARGPUSH);
	eval 'sub MINFRAME () { &MINFRAME64;}' unless defined(&MINFRAME);
	eval 'sub STACK_ALIGN () { &STACK_ALIGN64;}' unless defined(&STACK_ALIGN);
	eval 'sub STACK_BIAS () { &V9BIAS64;}' unless defined(&STACK_BIAS);
	eval 'sub SA {
	    my($x) = @_;
    	    eval q( &SA64($x));
	}' unless defined(&SA);
    } else {
	eval 'sub WINDOWSIZE () { &WINDOWSIZE32;}' unless defined(&WINDOWSIZE);
	eval 'sub ARGPUSHSIZE () { &ARGPUSHSIZE32;}' unless defined(&ARGPUSHSIZE);
	eval 'sub ARGPUSH () { &ARGPUSH32;}' unless defined(&ARGPUSH);
	eval 'sub MINFRAME () { &MINFRAME32;}' unless defined(&MINFRAME);
	eval 'sub STACK_ALIGN () { &STACK_ALIGN32;}' unless defined(&STACK_ALIGN);
	eval 'sub STACK_BIAS () {0;}' unless defined(&STACK_BIAS);
	eval 'sub SA {
	    my($x) = @_;
    	    eval q( &SA32($x));
	}' unless defined(&SA);
    }
    if(defined( &_KERNEL)  && !defined( &_ASM)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
