require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_STROPTS_H)) {
    eval 'sub _SYS_STROPTS_H () {1;}' unless defined(&_SYS_STROPTS_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    require 'sys/conf.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub SNDZERO () {0x1;}' unless defined(&SNDZERO);
    eval 'sub SNDPIPE () {0x2;}' unless defined(&SNDPIPE);
    eval 'sub RNORM () {0x;}' unless defined(&RNORM);
    eval 'sub RMSGD () {0x1;}' unless defined(&RMSGD);
    eval 'sub RMSGN () {0x2;}' unless defined(&RMSGN);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub RMODEMASK () {0x3;}' unless defined(&RMODEMASK);
    }
    eval 'sub RPROTDAT () {0x4;}' unless defined(&RPROTDAT);
    eval 'sub RPROTDIS () {0x8;}' unless defined(&RPROTDIS);
    eval 'sub RPROTNORM () {0x10;}' unless defined(&RPROTNORM);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub RPROTMASK () {0x1c;}' unless defined(&RPROTMASK);
	eval 'sub RFLUSHMASK () {0x20;}' unless defined(&RFLUSHMASK);
	eval 'sub RFLUSHPCPROT () {0x20;}' unless defined(&RFLUSHPCPROT);
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub RERRNORM () {0x1;}' unless defined(&RERRNORM);
	eval 'sub RERRNONPERSIST () {0x2;}' unless defined(&RERRNONPERSIST);
	eval 'sub RERRMASK () {( &RERRNORM| &RERRNONPERSIST);}' unless defined(&RERRMASK);
	eval 'sub WERRNORM () {0x4;}' unless defined(&WERRNORM);
	eval 'sub WERRNONPERSIST () {0x8;}' unless defined(&WERRNONPERSIST);
	eval 'sub WERRMASK () {( &WERRNORM| &WERRNONPERSIST);}' unless defined(&WERRMASK);
    }
    eval 'sub FLUSHR () {0x1;}' unless defined(&FLUSHR);
    eval 'sub FLUSHW () {0x2;}' unless defined(&FLUSHW);
    eval 'sub FLUSHRW () {0x3;}' unless defined(&FLUSHRW);
    eval 'sub FLUSHBAND () {0x4;}' unless defined(&FLUSHBAND);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub MAPINOK () {0x1;}' unless defined(&MAPINOK);
	eval 'sub NOMAPIN () {0x2;}' unless defined(&NOMAPIN);
	eval 'sub REMAPOK () {0x4;}' unless defined(&REMAPOK);
	eval 'sub NOREMAP () {0x8;}' unless defined(&NOREMAP);
    }
    eval 'sub S_INPUT () {0x1;}' unless defined(&S_INPUT);
    eval 'sub S_HIPRI () {0x2;}' unless defined(&S_HIPRI);
    eval 'sub S_OUTPUT () {0x4;}' unless defined(&S_OUTPUT);
    eval 'sub S_MSG () {0x8;}' unless defined(&S_MSG);
    eval 'sub S_ERROR () {0x10;}' unless defined(&S_ERROR);
    eval 'sub S_HANGUP () {0x20;}' unless defined(&S_HANGUP);
    eval 'sub S_RDNORM () {0x40;}' unless defined(&S_RDNORM);
    eval 'sub S_WRNORM () { &S_OUTPUT;}' unless defined(&S_WRNORM);
    eval 'sub S_RDBAND () {0x80;}' unless defined(&S_RDBAND);
    eval 'sub S_WRBAND () {0x100;}' unless defined(&S_WRBAND);
    eval 'sub S_BANDURG () {0x200;}' unless defined(&S_BANDURG);
    eval 'sub RS_HIPRI () {0x1;}' unless defined(&RS_HIPRI);
    eval 'sub STRUIO_POSTPONE () {0x8;}' unless defined(&STRUIO_POSTPONE);
    eval 'sub STRUIO_MAPIN () {0x10;}' unless defined(&STRUIO_MAPIN);
    eval 'sub MSG_HIPRI () {0x1;}' unless defined(&MSG_HIPRI);
    eval 'sub MSG_ANY () {0x2;}' unless defined(&MSG_ANY);
    eval 'sub MSG_BAND () {0x4;}' unless defined(&MSG_BAND);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub MSG_XPG4 () {0x8;}' unless defined(&MSG_XPG4);
    }
    if(defined(&_KERNEL)) {
	eval 'sub MSG_IPEEK () {0x10;}' unless defined(&MSG_IPEEK);
	eval 'sub MSG_DISCARDTAIL () {0x20;}' unless defined(&MSG_DISCARDTAIL);
	eval 'sub MSG_HOLDSIG () {0x40;}' unless defined(&MSG_HOLDSIG);
	eval 'sub MSG_IGNERROR () {0x80;}' unless defined(&MSG_IGNERROR);
	eval 'sub MSG_DELAYERROR () {0x100;}' unless defined(&MSG_DELAYERROR);
	eval 'sub MSG_IGNFLOW () {0x200;}' unless defined(&MSG_IGNFLOW);
	eval 'sub MSG_NOMARK () {0x400;}' unless defined(&MSG_NOMARK);
    }
    eval 'sub MORECTL () {1;}' unless defined(&MORECTL);
    eval 'sub MOREDATA () {2;}' unless defined(&MOREDATA);
    eval 'sub MUXID_ALL () {(-1);}' unless defined(&MUXID_ALL);
    eval 'sub ANYMARK () {0x1;}' unless defined(&ANYMARK);
    eval 'sub LASTMARK () {0x2;}' unless defined(&LASTMARK);
    eval 'sub STR () {(ord(\'S\')<<8);}' unless defined(&STR);
    eval 'sub I_NREAD () {( &STR|01);}' unless defined(&I_NREAD);
    eval 'sub I_PUSH () {( &STR|02);}' unless defined(&I_PUSH);
    eval 'sub I_POP () {( &STR|03);}' unless defined(&I_POP);
    eval 'sub I_LOOK () {( &STR|04);}' unless defined(&I_LOOK);
    eval 'sub I_FLUSH () {( &STR|05);}' unless defined(&I_FLUSH);
    eval 'sub I_SRDOPT () {( &STR|06);}' unless defined(&I_SRDOPT);
    eval 'sub I_GRDOPT () {( &STR|07);}' unless defined(&I_GRDOPT);
    eval 'sub I_STR () {( &STR|010);}' unless defined(&I_STR);
    eval 'sub I_SETSIG () {( &STR|011);}' unless defined(&I_SETSIG);
    eval 'sub I_GETSIG () {( &STR|012);}' unless defined(&I_GETSIG);
    eval 'sub I_FIND () {( &STR|013);}' unless defined(&I_FIND);
    eval 'sub I_LINK () {( &STR|014);}' unless defined(&I_LINK);
    eval 'sub I_UNLINK () {( &STR|015);}' unless defined(&I_UNLINK);
    eval 'sub I_PEEK () {( &STR|017);}' unless defined(&I_PEEK);
    eval 'sub I_FDINSERT () {( &STR|020);}' unless defined(&I_FDINSERT);
    eval 'sub I_SENDFD () {( &STR|021);}' unless defined(&I_SENDFD);
    if(defined( &_KERNEL)) {
	eval 'sub I_RECVFD () {( &STR|022);}' unless defined(&I_RECVFD);
	eval 'sub I_E_RECVFD () {( &STR|016);}' unless defined(&I_E_RECVFD);
    } else {
	eval 'sub I_RECVFD () {( &STR|016);}' unless defined(&I_RECVFD);
    }
    eval 'sub I_SWROPT () {( &STR|023);}' unless defined(&I_SWROPT);
    eval 'sub I_GWROPT () {( &STR|024);}' unless defined(&I_GWROPT);
    eval 'sub I_LIST () {( &STR|025);}' unless defined(&I_LIST);
    eval 'sub I_PLINK () {( &STR|026);}' unless defined(&I_PLINK);
    eval 'sub I_PUNLINK () {( &STR|027);}' unless defined(&I_PUNLINK);
    eval 'sub I_ANCHOR () {( &STR|030);}' unless defined(&I_ANCHOR);
    eval 'sub I_FLUSHBAND () {( &STR|034);}' unless defined(&I_FLUSHBAND);
    eval 'sub I_CKBAND () {( &STR|035);}' unless defined(&I_CKBAND);
    eval 'sub I_GETBAND () {( &STR|036);}' unless defined(&I_GETBAND);
    eval 'sub I_ATMARK () {( &STR|037);}' unless defined(&I_ATMARK);
    eval 'sub I_SETCLTIME () {( &STR|040);}' unless defined(&I_SETCLTIME);
    eval 'sub I_GETCLTIME () {( &STR|041);}' unless defined(&I_GETCLTIME);
    eval 'sub I_CANPUT () {( &STR|042);}' unless defined(&I_CANPUT);
    eval 'sub I_SERROPT () {( &STR|043);}' unless defined(&I_SERROPT);
    eval 'sub I_GERROPT () {( &STR|044);}' unless defined(&I_GERROPT);
    eval 'sub I_ESETSIG () {( &STR|045);}' unless defined(&I_ESETSIG);
    eval 'sub I_EGETSIG () {( &STR|046);}' unless defined(&I_EGETSIG);
    eval 'sub __I_PUSH_NOCTTY () {( &STR|047);}' unless defined(&__I_PUSH_NOCTTY);
    eval 'sub I_STRFT () {( &STR|050);}' unless defined(&I_STRFT);
    eval 'sub I_STRFTON () {( &STR|051);}' unless defined(&I_STRFTON);
    eval 'sub I_STRFTOFF () {( &STR|052);}' unless defined(&I_STRFTOFF);
    eval 'sub I_STRFTSTR () {( &STR|053);}' unless defined(&I_STRFTSTR);
    eval 'sub I_STRFTALL () {( &STR|054);}' unless defined(&I_STRFTALL);
    eval 'sub I_STRFTZERO () {( &STR|055);}' unless defined(&I_STRFTZERO);
    eval 'sub _I_MUXID2FD () {( &STR|056);}' unless defined(&_I_MUXID2FD);
    eval 'sub _I_INSERT () {( &STR|057);}' unless defined(&_I_INSERT);
    eval 'sub _I_REMOVE () {( &STR|060);}' unless defined(&_I_REMOVE);
    if(defined( &_SYSCALL32)) {
    }
    eval 'sub _INFTIM () {-1;}' unless defined(&_INFTIM);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub INFTIM () { &_INFTIM;}' unless defined(&INFTIM);
    }
    if(defined( &_SYSCALL32)) {
    }
    if(defined( &_SYSCALL32)) {
    }
    if(defined( &_SYSCALL32)) {
    }
    if(defined( &_KERNEL)) {
    }
    if(defined( &_XPG4_2)) {
    } else {
    }
    if(defined( &_SYSCALL32)) {
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	if(defined( &_SYSCALL32)) {
	}
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
    }
    if(defined(&_XPG4_2)) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	} else {
	    eval 'sub putmsg () { &__xpg4_putmsg;}' unless defined(&putmsg);
	    eval 'sub putpmsg () { &__xpg4_putpmsg;}' unless defined(&putpmsg);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
