require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SUNNDI_H)) {
    eval 'sub _SYS_SUNNDI_H () {1;}' unless defined(&_SYS_SUNNDI_H);
    require 'sys/esunddi.ph';
    require 'sys/sunddi.ph';
    require 'sys/obpdefs.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub NDI_SUCCESS () { &DDI_SUCCESS;}' unless defined(&NDI_SUCCESS);
	eval 'sub NDI_FAILURE () { &DDI_FAILURE;}' unless defined(&NDI_FAILURE);
	eval 'sub NDI_NOMEM () {-2;}' unless defined(&NDI_NOMEM);
	eval 'sub NDI_BADHANDLE () {-3;}' unless defined(&NDI_BADHANDLE);
	eval 'sub NDI_FAULT () {-4;}' unless defined(&NDI_FAULT);
	eval 'sub NDI_BUSY () {-5;}' unless defined(&NDI_BUSY);
	eval 'sub NDI_UNBOUND () {-6;}' unless defined(&NDI_UNBOUND);
	eval 'sub NDI_EVENT_CLAIMED () { &DDI_EVENT_CLAIMED;}' unless defined(&NDI_EVENT_CLAIMED);
	eval 'sub NDI_EVENT_UNCLAIMED () { &DDI_EVENT_UNCLAIMED;}' unless defined(&NDI_EVENT_UNCLAIMED);
	eval 'sub NDI_SLEEP () {0x;}' unless defined(&NDI_SLEEP);
	eval 'sub NDI_NOSLEEP () {0x1;}' unless defined(&NDI_NOSLEEP);
	eval 'sub NDI_EVENT_NOPASS () {0x10;}' unless defined(&NDI_EVENT_NOPASS);
	eval 'sub NDI_DEVI_REMOVE () {0x1;}' unless defined(&NDI_DEVI_REMOVE);
	eval 'sub NDI_ONLINE_ATTACH () {0x2;}' unless defined(&NDI_ONLINE_ATTACH);
	eval 'sub NDI_DEVI_FORCE () {0x4;}' unless defined(&NDI_DEVI_FORCE);
	eval 'sub NDI_CONFIG () {0x8;}' unless defined(&NDI_CONFIG);
	eval 'sub NDI_UNCONFIG () {0x10;}' unless defined(&NDI_UNCONFIG);
	eval 'sub NDI_DEVI_BIND () {0x20;}' unless defined(&NDI_DEVI_BIND);
	eval 'sub NDI_DEVI_PERSIST () {0x40;}' unless defined(&NDI_DEVI_PERSIST);
	eval 'sub NDI_EVENT_POST_TO_ALL () {0x;}' unless defined(&NDI_EVENT_POST_TO_ALL);
	eval 'sub NDI_EVENT_POST_TO_TGT () {0x1;}' unless defined(&NDI_EVENT_POST_TO_TGT);
	eval 'sub NDI_EVENT_POST_TO_ONE () {0x2;}' unless defined(&NDI_EVENT_POST_TO_ONE);
	eval 'sub NDI_EVENTS_REV0 () {0;}' unless defined(&NDI_EVENTS_REV0);
	eval 'sub NDI_RA_ALIGN_SIZE () {0x1;}' unless defined(&NDI_RA_ALIGN_SIZE);
	eval 'sub NDI_RA_ALLOC_BOUNDED () {0x2;}' unless defined(&NDI_RA_ALLOC_BOUNDED);
	eval 'sub NDI_RA_ALLOC_SPECIFIED () {0x4;}' unless defined(&NDI_RA_ALLOC_SPECIFIED);
	eval 'sub NDI_RA_ALLOC_PARTIAL_OK () {0x8;}' unless defined(&NDI_RA_ALLOC_PARTIAL_OK);
	eval 'sub NDI_RA_PARTIAL_REQ () {-7;}' unless defined(&NDI_RA_PARTIAL_REQ);
	eval 'sub NDI_RA_TYPE_MEM () {"memory";}' unless defined(&NDI_RA_TYPE_MEM);
	eval 'sub NDI_RA_TYPE_IO () {"io";}' unless defined(&NDI_RA_TYPE_IO);
	eval 'sub NDI_RA_TYPE_PCI_BUSNUM () {"pci_bus_number";}' unless defined(&NDI_RA_TYPE_PCI_BUSNUM);
	eval 'sub NDI_RA_TYPE_PCI_PREFETCH_MEM () {"pci_prefetchable_memory";}' unless defined(&NDI_RA_TYPE_PCI_PREFETCH_MEM);
	eval 'sub NDI_RA_TYPE_INTR () {"interrupt";}' unless defined(&NDI_RA_TYPE_INTR);
	eval 'sub NDI_RA_PASS () {0x1;}' unless defined(&NDI_RA_PASS);
	eval 'sub DDI_DEVI_FAULT_EVENT () {"DDI:DEVI_FAULT";}' unless defined(&DDI_DEVI_FAULT_EVENT);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
