require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SWAP_H)) {
    eval 'sub _SYS_SWAP_H () {1;}' unless defined(&_SYS_SWAP_H);
    require 'sys/isa_defs.ph';
    require 'sys/feature_tests.ph';
    require 'vm/anon.ph';
    require 'sys/fs/swapnode.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined( &_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) {
	die("Cannot use swapctl in the large files compilation environment");
    }
    eval 'sub SC_ADD () {1;}' unless defined(&SC_ADD);
    eval 'sub SC_LIST () {2;}' unless defined(&SC_LIST);
    eval 'sub SC_REMOVE () {3;}' unless defined(&SC_REMOVE);
    eval 'sub SC_GETNSWP () {4;}' unless defined(&SC_GETNSWP);
    eval 'sub SC_AINFO () {5;}' unless defined(&SC_AINFO);
    if(defined( &_SYSCALL32)) {
    }
    if(defined( &_KERNEL)) {
	if(defined( &_LP64)  && defined( &_SYSCALL32)) {
	}
    } else {
	if(defined( &__STDC__)) {
	} else {
	}
    }
    eval 'sub ST_INDEL () {0x1;}' unless defined(&ST_INDEL);
    eval 'sub ST_DOINGDEL () {0x2;}' unless defined(&ST_DOINGDEL);
    eval 'sub AN_OFFSHIFT () {( &PAGESHIFT);}' unless defined(&AN_OFFSHIFT);
    eval 'sub AN_VPSHIFT () {(32-  &AN_OFFSHIFT);}' unless defined(&AN_VPSHIFT);
    eval 'sub AN_VPSIZE () {(1<<  &AN_OFFSHIFT);}' unless defined(&AN_VPSIZE);
    eval 'sub swap_xlate {
        my($AP, $VPP, $OFFP) = @_;
	    eval q({ *($VPP) = ($AP)-> &an_vp; *($OFFP) = ($AP)-> &an_off; });
    }' unless defined(&swap_xlate);
    eval 'sub swap_xlate_nopanic () { &swap_xlate;}' unless defined(&swap_xlate_nopanic);
    eval 'sub swap_alloc {
        my($AP) = @_;
	    eval q({ ($AP)-> &an_vp =  &swapfs_getvp(( &uintptr_t)($AP) >>  &AN_VPSHIFT); ($AP)-> &an_off = ( &anoff_t)(( &uintptr_t)($AP) <<  &AN_OFFSHIFT); });
    }' unless defined(&swap_alloc);
    eval 'sub swap_free {
        my($AP) = @_;
	    eval q();
    }' unless defined(&swap_free);
    eval 'sub SA_NOT () {0x1;}' unless defined(&SA_NOT);
    eval 'sub SE_NOSWAP () {-1;}' unless defined(&SE_NOSWAP);
    eval 'sub SE_NOANON () {-2;}' unless defined(&SE_NOANON);
    if(defined(&_KERNEL)) {
    }
    if(defined(&SWAP_DEBUG)) {
	eval 'sub SW_RENAME () {0x1;}' unless defined(&SW_RENAME);
	eval 'sub SW_RESV () {0x2;}' unless defined(&SW_RESV);
	eval 'sub SW_ALLOC () {0x4;}' unless defined(&SW_ALLOC);
	eval 'sub SW_CTL () {0x8;}' unless defined(&SW_CTL);
	eval 'sub SWAP_PRINT {
	    my($f, $s, $x1, $x2, $x3, $x4, $x5) = @_;
    	    eval q( &if ( &swap_debug & $f)  &printf($s, $x1, $x2, $x3, $x4, $x5););
	}' unless defined(&SWAP_PRINT);
    } else {
	eval 'sub SWAP_PRINT {
	    my($f, $s, $x1, $x2, $x3, $x4, $x5) = @_;
    	    eval q();
	}' unless defined(&SWAP_PRINT);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
