require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SYSEVENT_IMPL_H)) {
    eval 'sub _SYS_SYSEVENT_IMPL_H () {1;}' unless defined(&_SYS_SYSEVENT_IMPL_H);
    require 'sys/nvpair.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub ATTR_DETACHED () {0;}' unless defined(&ATTR_DETACHED);
    eval 'sub ATTR_ATTACHED () {1;}' unless defined(&ATTR_ATTACHED);
    eval 'sub seh_version () { ($se_header->{se_version});}' unless defined(&seh_version);
    eval 'sub seh_class () { ($se_header->{se_class});}' unless defined(&seh_class);
    eval 'sub seh_subclass () { ($se_header->{se_subclass});}' unless defined(&seh_subclass);
    eval 'sub seh_seq () { ($se_header->{se_id}->{eid_seq});}' unless defined(&seh_seq);
    eval 'sub seh_time () { ($se_header->{se_id}->{eid_ts});}' unless defined(&seh_time);
    eval 'sub seh_subclass_off () { ($se_header->{se_subclass_off});}' unless defined(&seh_subclass_off);
    eval 'sub seh_pub_off () { ($se_header->{se_pub_off});}' unless defined(&seh_pub_off);
    eval 'sub seh_attr_off () { ($se_header->{se_attr_off});}' unless defined(&seh_attr_off);
    eval 'sub seh_payload_sz () { ($se_header->{se_payload_sz});}' unless defined(&seh_payload_sz);
    eval 'sub seh_flag () { ($se_header->{se_flag});}' unless defined(&seh_flag);
    eval 'sub SYS_EVENT_VERSION () {0;}' unless defined(&SYS_EVENT_VERSION);
    eval 'sub SE_PACKED_BUF () {1;}' unless defined(&SE_PACKED_BUF);
    eval 'sub SYSEVENT_IMPL {
        my($ev) = @_;
	    eval q((( &sysevent_impl_t *)( &void *)($ev)));
    }' unless defined(&SYSEVENT_IMPL);
    eval 'sub SE_VERSION {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_version));
    }' unless defined(&SE_VERSION);
    eval 'sub SE_CLASS {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_class));
    }' unless defined(&SE_CLASS);
    eval 'sub SE_SUBCLASS {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_subclass));
    }' unless defined(&SE_SUBCLASS);
    eval 'sub SE_SEQ {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_seq));
    }' unless defined(&SE_SEQ);
    eval 'sub SE_TIME {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_time));
    }' unless defined(&SE_TIME);
    eval 'sub SE_SUBCLASS_OFF {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_subclass_off));
    }' unless defined(&SE_SUBCLASS_OFF);
    eval 'sub SE_PUB_OFF {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_pub_off));
    }' unless defined(&SE_PUB_OFF);
    eval 'sub SE_PAYLOAD_SZ {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_payload_sz));
    }' unless defined(&SE_PAYLOAD_SZ);
    eval 'sub SE_FLAG {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_flag));
    }' unless defined(&SE_FLAG);
    eval 'sub SE_SIZE {
        my($ev) = @_;
	    eval q(($sizeof{ &sysevent_impl_t} +  &SE_PAYLOAD_SZ($ev)));
    }' unless defined(&SE_SIZE);
    eval 'sub SE_CLASS_NAME {
        my($ev) = @_;
	    eval q((( &SYSEVENT_IMPL($ev)-> &se_class_name)));
    }' unless defined(&SE_CLASS_NAME);
    eval 'sub SE_SUBCLASS_NAME {
        my($ev) = @_;
	    eval q(((($ev) +  &SE_SUBCLASS_OFF($ev))));
    }' unless defined(&SE_SUBCLASS_NAME);
    eval 'sub SE_PUB_NAME {
        my($ev) = @_;
	    eval q(((($ev) +  &SE_PUB_OFF($ev))));
    }' unless defined(&SE_PUB_NAME);
    eval 'sub SE_ALIGN {
        my($x) = @_;
	    eval q(((($x) + 7) & ~7));
    }' unless defined(&SE_ALIGN);
    eval 'sub SE_ATTR_PTR {
        my($ev) = @_;
	    eval q(( &SYSEVENT_IMPL($ev)-> &seh_attr_off));
    }' unless defined(&SE_ATTR_PTR);
    eval 'sub SE_ATTR_OFF {
        my($ev) = @_;
	    eval q( &SE_PUB_OFF($ev) +  &SE_ALIGN( &strlen( &SE_PUB_NAME($ev)) + 1));
    }' unless defined(&SE_ATTR_OFF);
    eval 'sub LOGEVENT_DOOR_UPCALL () {"/etc/sysevent/sysevent_door";}' unless defined(&LOGEVENT_DOOR_UPCALL);
    if(defined(&__cplusplus)) {
    }
}
1;
