require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_TIHDR_H)) {
    eval 'sub _SYS_TIHDR_H () {1;}' unless defined(&_SYS_TIHDR_H);
    require 'sys/types.ph';
    require 'sys/tpicommon.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub T_CONN_REQ () {0;}' unless defined(&T_CONN_REQ);
    if((defined(&_SUN_TPI_VERSION) ? &_SUN_TPI_VERSION : 0) > 1) {
	eval 'sub O_T_CONN_RES () {1;}' unless defined(&O_T_CONN_RES);
    } else {
	eval 'sub T_CONN_RES () {1;}' unless defined(&T_CONN_RES);
    }
    eval 'sub T_DISCON_REQ () {2;}' unless defined(&T_DISCON_REQ);
    eval 'sub T_DATA_REQ () {3;}' unless defined(&T_DATA_REQ);
    eval 'sub T_EXDATA_REQ () {4;}' unless defined(&T_EXDATA_REQ);
    eval 'sub T_INFO_REQ () {5;}' unless defined(&T_INFO_REQ);
    if((defined(&_SUN_TPI_VERSION) ? &_SUN_TPI_VERSION : 0) > 0) {
	eval 'sub O_T_BIND_REQ () {6;}' unless defined(&O_T_BIND_REQ);
    } else {
	eval 'sub T_BIND_REQ () {6;}' unless defined(&T_BIND_REQ);
    }
    eval 'sub T_UNBIND_REQ () {7;}' unless defined(&T_UNBIND_REQ);
    eval 'sub T_UNITDATA_REQ () {8;}' unless defined(&T_UNITDATA_REQ);
    eval 'sub T_SVR4_OPTMGMT_REQ () {9;}' unless defined(&T_SVR4_OPTMGMT_REQ);
    if((defined(&_SUN_TPI_VERSION) ? &_SUN_TPI_VERSION : 0) > 0) {
	eval 'sub O_T_OPTMGMT_REQ () { &T_SVR4_OPTMGMT_REQ;}' unless defined(&O_T_OPTMGMT_REQ);
    } else {
	eval 'sub T_OPTMGMT_REQ () { &T_SVR4_OPTMGMT_REQ;}' unless defined(&T_OPTMGMT_REQ);
    }
    eval 'sub T_ORDREL_REQ () {10;}' unless defined(&T_ORDREL_REQ);
    eval 'sub T_CONN_IND () {11;}' unless defined(&T_CONN_IND);
    eval 'sub T_CONN_CON () {12;}' unless defined(&T_CONN_CON);
    eval 'sub T_DISCON_IND () {13;}' unless defined(&T_DISCON_IND);
    eval 'sub T_DATA_IND () {14;}' unless defined(&T_DATA_IND);
    eval 'sub T_EXDATA_IND () {15;}' unless defined(&T_EXDATA_IND);
    eval 'sub T_INFO_ACK () {16;}' unless defined(&T_INFO_ACK);
    eval 'sub T_BIND_ACK () {17;}' unless defined(&T_BIND_ACK);
    eval 'sub T_ERROR_ACK () {18;}' unless defined(&T_ERROR_ACK);
    eval 'sub T_OK_ACK () {19;}' unless defined(&T_OK_ACK);
    eval 'sub T_UNITDATA_IND () {20;}' unless defined(&T_UNITDATA_IND);
    eval 'sub T_UDERROR_IND () {21;}' unless defined(&T_UDERROR_IND);
    eval 'sub T_OPTMGMT_ACK () {22;}' unless defined(&T_OPTMGMT_ACK);
    eval 'sub T_ORDREL_IND () {23;}' unless defined(&T_ORDREL_IND);
    eval 'sub T_ADDR_REQ () {24;}' unless defined(&T_ADDR_REQ);
    eval 'sub T_ADDR_ACK () {25;}' unless defined(&T_ADDR_ACK);
    if((defined(&_SUN_TPI_VERSION) ? &_SUN_TPI_VERSION : 0) > 0) {
	eval 'sub T_BIND_REQ () {26;}' unless defined(&T_BIND_REQ);
	eval 'sub T_OPTMGMT_REQ () {27;}' unless defined(&T_OPTMGMT_REQ);
    }
    if((defined(&_SUN_TPI_VERSION) ? &_SUN_TPI_VERSION : 0) > 1) {
	eval 'sub T_CONN_RES () {28;}' unless defined(&T_CONN_RES);
	eval 'sub T_CAPABILITY_REQ () {30;}' unless defined(&T_CAPABILITY_REQ);
	eval 'sub T_CAPABILITY_ACK () {31;}' unless defined(&T_CAPABILITY_ACK);
    }
    if(defined(&_KERNEL)) {
	eval 'sub T_OPTDATA_REQ () {0x1001;}' unless defined(&T_OPTDATA_REQ);
	eval 'sub T_OPTDATA_IND () {0x1002;}' unless defined(&T_OPTDATA_IND);
	eval 'sub T_EXTCONN_IND () {0x1003;}' unless defined(&T_EXTCONN_IND);
    }
    eval 'sub TE_BIND_REQ () {0;}' unless defined(&TE_BIND_REQ);
    eval 'sub TE_UNBIND_REQ () {1;}' unless defined(&TE_UNBIND_REQ);
    eval 'sub TE_OPTMGMT_REQ () {2;}' unless defined(&TE_OPTMGMT_REQ);
    eval 'sub TE_BIND_ACK () {3;}' unless defined(&TE_BIND_ACK);
    eval 'sub TE_OPTMGMT_ACK () {4;}' unless defined(&TE_OPTMGMT_ACK);
    eval 'sub TE_ERROR_ACK () {5;}' unless defined(&TE_ERROR_ACK);
    eval 'sub TE_OK_ACK1 () {6;}' unless defined(&TE_OK_ACK1);
    eval 'sub TE_OK_ACK2 () {7;}' unless defined(&TE_OK_ACK2);
    eval 'sub TE_OK_ACK3 () {8;}' unless defined(&TE_OK_ACK3);
    eval 'sub TE_OK_ACK4 () {9;}' unless defined(&TE_OK_ACK4);
    eval 'sub TE_CONN_REQ () {10;}' unless defined(&TE_CONN_REQ);
    eval 'sub TE_CONN_RES () {11;}' unless defined(&TE_CONN_RES);
    eval 'sub TE_DISCON_REQ () {12;}' unless defined(&TE_DISCON_REQ);
    eval 'sub TE_DATA_REQ () {13;}' unless defined(&TE_DATA_REQ);
    eval 'sub TE_EXDATA_REQ () {14;}' unless defined(&TE_EXDATA_REQ);
    eval 'sub TE_ORDREL_REQ () {15;}' unless defined(&TE_ORDREL_REQ);
    eval 'sub TE_CONN_IND () {16;}' unless defined(&TE_CONN_IND);
    eval 'sub TE_CONN_CON () {17;}' unless defined(&TE_CONN_CON);
    eval 'sub TE_DATA_IND () {18;}' unless defined(&TE_DATA_IND);
    eval 'sub TE_EXDATA_IND () {19;}' unless defined(&TE_EXDATA_IND);
    eval 'sub TE_ORDREL_IND () {20;}' unless defined(&TE_ORDREL_IND);
    eval 'sub TE_DISCON_IND1 () {21;}' unless defined(&TE_DISCON_IND1);
    eval 'sub TE_DISCON_IND2 () {22;}' unless defined(&TE_DISCON_IND2);
    eval 'sub TE_DISCON_IND3 () {23;}' unless defined(&TE_DISCON_IND3);
    eval 'sub TE_PASS_CONN () {24;}' unless defined(&TE_PASS_CONN);
    eval 'sub TE_UNITDATA_REQ () {25;}' unless defined(&TE_UNITDATA_REQ);
    eval 'sub TE_UNITDATA_IND () {26;}' unless defined(&TE_UNITDATA_IND);
    eval 'sub TE_UDERROR_IND () {27;}' unless defined(&TE_UDERROR_IND);
    eval 'sub TE_NOEVENTS () {28;}' unless defined(&TE_NOEVENTS);
    eval 'sub TS_UNBND () {0;}' unless defined(&TS_UNBND);
    eval 'sub TS_WACK_BREQ () {1;}' unless defined(&TS_WACK_BREQ);
    eval 'sub TS_WACK_UREQ () {2;}' unless defined(&TS_WACK_UREQ);
    eval 'sub TS_IDLE () {3;}' unless defined(&TS_IDLE);
    eval 'sub TS_WACK_OPTREQ () {4;}' unless defined(&TS_WACK_OPTREQ);
    eval 'sub TS_WACK_CREQ () {5;}' unless defined(&TS_WACK_CREQ);
    eval 'sub TS_WCON_CREQ () {6;}' unless defined(&TS_WCON_CREQ);
    eval 'sub TS_WRES_CIND () {7;}' unless defined(&TS_WRES_CIND);
    eval 'sub TS_WACK_CRES () {8;}' unless defined(&TS_WACK_CRES);
    eval 'sub TS_DATA_XFER () {9;}' unless defined(&TS_DATA_XFER);
    eval 'sub TS_WIND_ORDREL () {10;}' unless defined(&TS_WIND_ORDREL);
    eval 'sub TS_WREQ_ORDREL () {11;}' unless defined(&TS_WREQ_ORDREL);
    eval 'sub TS_WACK_DREQ6 () {12;}' unless defined(&TS_WACK_DREQ6);
    eval 'sub TS_WACK_DREQ7 () {13;}' unless defined(&TS_WACK_DREQ7);
    eval 'sub TS_WACK_DREQ9 () {14;}' unless defined(&TS_WACK_DREQ9);
    eval 'sub TS_WACK_DREQ10 () {15;}' unless defined(&TS_WACK_DREQ10);
    eval 'sub TS_WACK_DREQ11 () {16;}' unless defined(&TS_WACK_DREQ11);
    eval 'sub TS_NOSTATES () {17;}' unless defined(&TS_NOSTATES);
    if((defined(&_SUN_TPI_VERSION) ? &_SUN_TPI_VERSION : 0) > 0) {
	eval 'sub SENDZERO () {0x1;}' unless defined(&SENDZERO);
	eval 'sub OLD_SENDZERO () {0x1000;}' unless defined(&OLD_SENDZERO);
    } else {
	eval 'sub SENDZERO () {0x1000;}' unless defined(&SENDZERO);
    }
    eval 'sub EXPINLINE () {0x2;}' unless defined(&EXPINLINE);
    eval 'sub XPG4_1 () {0x4;}' unless defined(&XPG4_1);
    if((defined(&_SUN_TPI_VERSION) ? &_SUN_TPI_VERSION : 0) > 1) {
	eval 'sub TC1_INFO () {(1 << 0);}' unless defined(&TC1_INFO);
	eval 'sub TC1_ACCEPTOR_ID () {(1 << 1);}' unless defined(&TC1_ACCEPTOR_ID);
	eval 'sub TC1_CAP_BITS2 () {(1 << 31);}' unless defined(&TC1_CAP_BITS2);
    }
    if(defined(&_KERNEL)) {
    }
    if((defined(&_SUN_TPI_VERSION) ? &_SUN_TPI_VERSION : 0) > 1) {
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub __TPI_ALIGN_SIZE () {($sizeof{ &t_scalar_t});}' unless defined(&__TPI_ALIGN_SIZE);
    eval 'sub __TPI_ALIGN {
        my($x) = @_;
	    eval q(((( &uintptr_t)($x) +  &__TPI_ALIGN_SIZE - 1) & ~( &__TPI_ALIGN_SIZE - 1)));
    }' unless defined(&__TPI_ALIGN);
    eval 'sub __TPI_SIZE_ISALIGNED {
        my($x) = @_;
	    eval q(((( &uintptr_t)($x) & ( &__TPI_ALIGN_SIZE - 1)) == 0));
    }' unless defined(&__TPI_SIZE_ISALIGNED);
    eval 'sub __TPI_PRIM_ISALIGNED {
        my($x) = @_;
	    eval q( &__TPI_SIZE_ISALIGNED($x));
    }' unless defined(&__TPI_PRIM_ISALIGNED);
    eval 'sub __TPI_OPT_ISALIGNED {
        my($x) = @_;
	    eval q( &__TPI_SIZE_ISALIGNED($x));
    }' unless defined(&__TPI_OPT_ISALIGNED);
    eval 'sub _TPI_ALIGN_OPT {
        my($x) = @_;
	    eval q( &__TPI_ALIGN($x));
    }' unless defined(&_TPI_ALIGN_OPT);
    eval 'sub __TPI_TOPT_ISALIGNED {
        my($x) = @_;
	    eval q( &__TPI_SIZE_ISALIGNED($x));
    }' unless defined(&__TPI_TOPT_ISALIGNED);
    eval 'sub _TPI_ALIGN_TOPT {
        my($x) = @_;
	    eval q( &__TPI_ALIGN($x));
    }' unless defined(&_TPI_ALIGN_TOPT);
    eval 'sub _TPI_TOPT_DATA {
        my($tohp) = @_;
	    eval q(((($tohp) + $sizeof{\'struct T_opthdr\'})));
    }' unless defined(&_TPI_TOPT_DATA);
    eval 'sub _TPI_TOPT_DATALEN {
        my($tohp) = @_;
	    eval q((($tohp)-> &len - $sizeof{\'struct T_opthdr\'}));
    }' unless defined(&_TPI_TOPT_DATALEN);
    eval 'sub _TPI_TOPT_FIRSTHDR {
        my($pbuf, $buflen) = @_;
	    eval q(((( >= $sizeof{\'struct T_opthdr\'})  &&  &__TPI_TOPT_ISALIGNED($pbuf)) ? ($pbuf) : 0));
    }' unless defined(&_TPI_TOPT_FIRSTHDR);
    eval 'sub _TPI_TOPT_NEXTHDR {
        my($pbuf, $buflen, $popt) = @_;
	    eval q((( +  &_TPI_ALIGN_TOPT(-> &len)) < (($pbuf) + ($buflen)) ? (($popt) +  &_TPI_ALIGN_TOPT(($popt)-> &len)) : 0));
    }' unless defined(&_TPI_TOPT_NEXTHDR);
    eval 'sub _TPI_TOPT_VALID {
        my($tohp, $start, $end) = @_;
	    eval q(( &__TPI_TOPT_ISALIGNED($tohp)  && (( &uintptr_t)($tohp) >= ( &uintptr_t)($start))  && (( &uintptr_t)($tohp) < ( &uintptr_t)($end))  && (( &ssize_t)($tohp)-> &len >= $sizeof{\'struct T_opthdr\'})  && (( &uintptr_t)($tohp) + ($tohp)-> &len <= ( &uintptr_t)($end))  && (( &uintptr_t)($tohp) + ($tohp)-> &len >= ( &uintptr_t)($tohp) + $sizeof{\'struct T_opthdr\'})));
    }' unless defined(&_TPI_TOPT_VALID);
    if(defined(&__cplusplus)) {
    }
}
1;
