require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_TNF_COM_H)) {
    eval 'sub _SYS_TNF_COM_H () {1;}' unless defined(&_SYS_TNF_COM_H);
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub TNF_MAGIC () {0x544e4600;}' unless defined(&TNF_MAGIC);
    eval 'sub TNF_MAGIC_1 () {0x464e54;}' unless defined(&TNF_MAGIC_1);
    eval 'sub TNF_TAG_GENERATION_NUM () {0xffffffff;}' unless defined(&TNF_TAG_GENERATION_NUM);
    eval 'sub TNF_SPACE_MASK () {0x80000000;}' unless defined(&TNF_SPACE_MASK);
    eval 'sub TNF_SPACE_PERMANENT () {0x80000000;}' unless defined(&TNF_SPACE_PERMANENT);
    eval 'sub TNF_SPACE_RECLAIMABLE () {0x;}' unless defined(&TNF_SPACE_RECLAIMABLE);
    eval 'sub TNF_SPACE_SIGN_BIT () {0x40000000;}' unless defined(&TNF_SPACE_SIGN_BIT);
    eval 'sub TNF_REF32_MAKE_PERMANENT {
        my($x) = @_;
	    eval q((($x) |  &TNF_SPACE_PERMANENT));
    }' unless defined(&TNF_REF32_MAKE_PERMANENT);
    eval 'sub TNF_REF32_MAKE_RECLAIMABLE {
        my($x) = @_;
	    eval q((($x) & ~ &TNF_SPACE_MASK));
    }' unless defined(&TNF_REF32_MAKE_RECLAIMABLE);
    eval 'sub TNF_REF32_SPACE {
        my($x) = @_;
	    eval q((( &tnf_uint32_t)($x) &  &TNF_SPACE_MASK));
    }' unless defined(&TNF_REF32_SPACE);
    eval 'sub TNF_REF32_IS_PERMANENT {
        my($x) = @_;
	    eval q(( &TNF_REF32_SPACE($x) ==  &TNF_SPACE_PERMANENT));
    }' unless defined(&TNF_REF32_IS_PERMANENT);
    eval 'sub TNF_REF32_IS_RECLAIMABLE {
        my($x) = @_;
	    eval q(( &TNF_REF32_SPACE($x) ==  &TNF_SPACE_RECLAIMABLE));
    }' unless defined(&TNF_REF32_IS_RECLAIMABLE);
    eval 'sub TNF_REF32_SIGN_EXTEND {
        my($x) = @_;
	    eval q((((( &tnf_uint32_t)($x) &  &TNF_SPACE_SIGN_BIT) ==  &TNF_SPACE_SIGN_BIT) ? (( &tnf_ref32_t)(( &tnf_uint32_t)($x) |  &TNF_SPACE_MASK)) : ($x)));
    }' unless defined(&TNF_REF32_SIGN_EXTEND);
    eval 'sub TNF_REF32_TYPE_MASK () {0x3;}' unless defined(&TNF_REF32_TYPE_MASK);
    eval 'sub TNF_REF32_T_FULL () {0x;}' unless defined(&TNF_REF32_T_FULL);
    eval 'sub TNF_REF32_T_FWD () { &TNF_REF32_T_FULL;}' unless defined(&TNF_REF32_T_FWD);
    eval 'sub TNF_REF32_T_PAIR () {0x1;}' unless defined(&TNF_REF32_T_PAIR);
    eval 'sub TNF_REF32_T_TAG () {0x2;}' unless defined(&TNF_REF32_T_TAG);
    eval 'sub TNF_REF32_T_RSVD () {0x3;}' unless defined(&TNF_REF32_T_RSVD);
    eval 'sub TNF_REF32_REF16_MASK () {0xffff;}' unless defined(&TNF_REF32_REF16_MASK);
    eval 'sub TNF_REF32_TAG16_SHIFT () {16;}' unless defined(&TNF_REF32_TAG16_SHIFT);
    eval 'sub TNF_REF32_TAG16_MASK () {0xffff;}' unless defined(&TNF_REF32_TAG16_MASK);
    eval 'sub TNF_REF16_TYPE_MASK () {0x3;}' unless defined(&TNF_REF16_TYPE_MASK);
    eval 'sub TNF_TAG16_TYPE_MASK () {0x3;}' unless defined(&TNF_TAG16_TYPE_MASK);
    eval 'sub TNF_TAG16_T_ABS () { &TNF_REF32_T_PAIR;}' unless defined(&TNF_TAG16_T_ABS);
    eval 'sub TNF_TAG16_T_REL () { &TNF_REF32_T_FWD;}' unless defined(&TNF_TAG16_T_REL);
    eval 'sub TNF_NULL () {0;}' unless defined(&TNF_NULL);
    eval 'sub TNF_REF32_TYPE {
        my($x) = @_;
	    eval q((( &tnf_uint32_t)($x) &  &TNF_REF32_TYPE_MASK));
    }' unless defined(&TNF_REF32_TYPE);
    eval 'sub TNF_REF32_VALUE {
        my($x) = @_;
	    eval q((( &tnf_ref32_t)((( &tnf_uint32_t)($x) & ~ &TNF_REF32_TYPE_MASK) & ~ &TNF_SPACE_MASK)));
    }' unless defined(&TNF_REF32_VALUE);
    eval 'sub TNF_REF32_IS_FULL {
        my($x) = @_;
	    eval q(( &TNF_REF32_TYPE($x) ==  &TNF_REF32_T_FULL));
    }' unless defined(&TNF_REF32_IS_FULL);
    eval 'sub TNF_REF32_IS_FWD {
        my($x) = @_;
	    eval q(( &TNF_REF32_TYPE($x) ==  &TNF_REF32_T_FWD));
    }' unless defined(&TNF_REF32_IS_FWD);
    eval 'sub TNF_REF32_IS_PAIR {
        my($x) = @_;
	    eval q(( &TNF_REF32_TYPE($x) ==  &TNF_REF32_T_PAIR));
    }' unless defined(&TNF_REF32_IS_PAIR);
    eval 'sub TNF_REF32_IS_TAG {
        my($x) = @_;
	    eval q(( &TNF_REF32_TYPE($x) ==  &TNF_REF32_T_TAG));
    }' unless defined(&TNF_REF32_IS_TAG);
    eval 'sub TNF_REF32_IS_RSVD {
        my($x) = @_;
	    eval q(( &TNF_REF32_TYPE($x) ==  &TNF_REF32_T_RSVD));
    }' unless defined(&TNF_REF32_IS_RSVD);
    eval 'sub TNF_REF32_IS_NULL {
        my($x) = @_;
	    eval q((($x) ==  &TNF_NULL));
    }' unless defined(&TNF_REF32_IS_NULL);
    eval 'sub TNF_REF32_REF16 {
        my($x) = @_;
	    eval q((( &tnf_ref16_t)(( &tnf_uint32_t)($x) &  &TNF_REF32_REF16_MASK)));
    }' unless defined(&TNF_REF32_REF16);
    eval 'sub TNF_REF32_TAG16 {
        my($x) = @_;
	    eval q((( &tnf_ref16_t)((( &tnf_uint32_t)($x) >>  &TNF_REF32_TAG16_SHIFT) &  &TNF_REF32_TAG16_MASK)));
    }' unless defined(&TNF_REF32_TAG16);
    eval 'sub TNF_REF16_TYPE {
        my($x) = @_;
	    eval q((( &tnf_uint32_t)($x) &  &TNF_REF16_TYPE_MASK));
    }' unless defined(&TNF_REF16_TYPE);
    eval 'sub TNF_REF16_VALUE {
        my($x) = @_;
	    eval q((( &tnf_ref16_t)(( &tnf_uint32_t)($x) & ~ &TNF_REF16_TYPE_MASK)));
    }' unless defined(&TNF_REF16_VALUE);
    eval 'sub TNF_TAG16_TYPE {
        my($x) = @_;
	    eval q((( &tnf_uint32_t)($x) &  &TNF_TAG16_TYPE_MASK));
    }' unless defined(&TNF_TAG16_TYPE);
    eval 'sub TNF_TAG16_IS_REL {
        my($x) = @_;
	    eval q(( &TNF_TAG16_TYPE($x) ==  &TNF_TAG16_T_REL));
    }' unless defined(&TNF_TAG16_IS_REL);
    eval 'sub TNF_TAG16_IS_ABS {
        my($x) = @_;
	    eval q(( &TNF_TAG16_TYPE($x) ==  &TNF_TAG16_T_ABS));
    }' unless defined(&TNF_TAG16_IS_ABS);
    eval 'sub TNF_TAG16_REF16 {
        my($x) = @_;
	    eval q((( &tnf_ref16_t)(( &tnf_uint32_t)($x) & ~ &TNF_TAG16_TYPE_MASK)));
    }' unless defined(&TNF_TAG16_REF16);
    eval 'sub TNF_TAG16_ABS16 {
        my($x) = @_;
	    eval q((( &tnf_abs16_t)(( &tnf_uint32_t)($x) & ~ &TNF_TAG16_TYPE_MASK)));
    }' unless defined(&TNF_TAG16_ABS16);
    eval 'sub TNF_FILE_VERSION () {1;}' unless defined(&TNF_FILE_VERSION);
    eval 'sub TNF_N_INLINE () {"tnf_inline";}' unless defined(&TNF_N_INLINE);
    eval 'sub TNF_N_TAGGED () {"tnf_tagged";}' unless defined(&TNF_N_TAGGED);
    eval 'sub TNF_N_SCALAR () {"tnf_scalar";}' unless defined(&TNF_N_SCALAR);
    eval 'sub TNF_N_CHAR () {"tnf_char";}' unless defined(&TNF_N_CHAR);
    eval 'sub TNF_N_INT8 () {"tnf_int8";}' unless defined(&TNF_N_INT8);
    eval 'sub TNF_N_UINT8 () {"tnf_uint8";}' unless defined(&TNF_N_UINT8);
    eval 'sub TNF_N_INT16 () {"tnf_int16";}' unless defined(&TNF_N_INT16);
    eval 'sub TNF_N_UINT16 () {"tnf_uint16";}' unless defined(&TNF_N_UINT16);
    eval 'sub TNF_N_INT32 () {"tnf_int32";}' unless defined(&TNF_N_INT32);
    eval 'sub TNF_N_UINT32 () {"tnf_uint32";}' unless defined(&TNF_N_UINT32);
    eval 'sub TNF_N_INT64 () {"tnf_int64";}' unless defined(&TNF_N_INT64);
    eval 'sub TNF_N_UINT64 () {"tnf_uint64";}' unless defined(&TNF_N_UINT64);
    eval 'sub TNF_N_FLOAT32 () {"tnf_float32";}' unless defined(&TNF_N_FLOAT32);
    eval 'sub TNF_N_FLOAT64 () {"tnf_float64";}' unless defined(&TNF_N_FLOAT64);
    eval 'sub TNF_N_ARRAY () {"tnf_array";}' unless defined(&TNF_N_ARRAY);
    eval 'sub TNF_N_STRING () {"tnf_string";}' unless defined(&TNF_N_STRING);
    eval 'sub TNF_N_TYPE_ARRAY () {"tnf_type_array";}' unless defined(&TNF_N_TYPE_ARRAY);
    eval 'sub TNF_N_NAME_ARRAY () {"tnf_name_array";}' unless defined(&TNF_N_NAME_ARRAY);
    eval 'sub TNF_N_ALIGN () {"tnf_align";}' unless defined(&TNF_N_ALIGN);
    eval 'sub TNF_N_DERIVED () {"tnf_derived";}' unless defined(&TNF_N_DERIVED);
    eval 'sub TNF_N_DERIVED_BASE () {"tnf_derived_base";}' unless defined(&TNF_N_DERIVED_BASE);
    eval 'sub TNF_N_ELEMENT_TYPE () {"tnf_element_type";}' unless defined(&TNF_N_ELEMENT_TYPE);
    eval 'sub TNF_N_HEADER_SIZE () {"tnf_header_size";}' unless defined(&TNF_N_HEADER_SIZE);
    eval 'sub TNF_N_NAME () {"tnf_name";}' unless defined(&TNF_N_NAME);
    eval 'sub TNF_N_OPAQUE () {"tnf_opaque";}' unless defined(&TNF_N_OPAQUE);
    eval 'sub TNF_N_PROPERTIES () {"tnf_properties";}' unless defined(&TNF_N_PROPERTIES);
    eval 'sub TNF_N_SELF_SIZE () {"tnf_self_size";}' unless defined(&TNF_N_SELF_SIZE);
    eval 'sub TNF_N_SIZE () {"tnf_size";}' unless defined(&TNF_N_SIZE);
    eval 'sub TNF_N_SLOT_NAMES () {"tnf_slot_names";}' unless defined(&TNF_N_SLOT_NAMES);
    eval 'sub TNF_N_SLOT_TYPES () {"tnf_slot_types";}' unless defined(&TNF_N_SLOT_TYPES);
    eval 'sub TNF_N_TAG () {"tnf_tag";}' unless defined(&TNF_N_TAG);
    eval 'sub TNF_N_TAG_ARG () {"tnf_tag_arg";}' unless defined(&TNF_N_TAG_ARG);
    eval 'sub TNF_N_TYPE_SIZE () {"tnf_type_size";}' unless defined(&TNF_N_TYPE_SIZE);
    eval 'sub TNF_N_STRUCT () {"tnf_struct";}' unless defined(&TNF_N_STRUCT);
    eval 'sub TNF_N_ARRAY_TYPE () {"tnf_array_type";}' unless defined(&TNF_N_ARRAY_TYPE);
    eval 'sub TNF_N_DERIVED_TYPE () {"tnf_derived_type";}' unless defined(&TNF_N_DERIVED_TYPE);
    eval 'sub TNF_N_SCALAR_TYPE () {"tnf_scalar_type";}' unless defined(&TNF_N_SCALAR_TYPE);
    eval 'sub TNF_N_STRUCT_TYPE () {"tnf_struct_type";}' unless defined(&TNF_N_STRUCT_TYPE);
    eval 'sub TNF_N_TYPE () {"tnf_type";}' unless defined(&TNF_N_TYPE);
    eval 'sub TNF_N_FILE_HEADER () {"tnf_file_header";}' unless defined(&TNF_N_FILE_HEADER);
    eval 'sub TNF_N_FILE_VERSION () {"file_version";}' unless defined(&TNF_N_FILE_VERSION);
    eval 'sub TNF_N_FILE_HEADER_SIZE () {"file_header_size";}' unless defined(&TNF_N_FILE_HEADER_SIZE);
    eval 'sub TNF_N_FILE_LOGICAL_SIZE () {"file_logical_size";}' unless defined(&TNF_N_FILE_LOGICAL_SIZE);
    eval 'sub TNF_N_BLOCK_HEADER_SIZE () {"block_header_size";}' unless defined(&TNF_N_BLOCK_HEADER_SIZE);
    eval 'sub TNF_N_BLOCK_SIZE () {"block_size";}' unless defined(&TNF_N_BLOCK_SIZE);
    eval 'sub TNF_N_DIRECTORY_SIZE () {"directory_size";}' unless defined(&TNF_N_DIRECTORY_SIZE);
    eval 'sub TNF_N_BLOCK_COUNT () {"block_count";}' unless defined(&TNF_N_BLOCK_COUNT);
    eval 'sub TNF_N_BLOCKS_VALID () {"blocks_valid";}' unless defined(&TNF_N_BLOCKS_VALID);
    eval 'sub TNF_N_BLOCK_HEADER () {"tnf_block_header";}' unless defined(&TNF_N_BLOCK_HEADER);
    eval 'sub TNF_N_GENERATION () {"generation";}' unless defined(&TNF_N_GENERATION);
    eval 'sub TNF_N_BYTES_VALID () {"bytes_valid";}' unless defined(&TNF_N_BYTES_VALID);
    eval 'sub TNF_N_USER_SCHEDULE () {"tnf_user_schedule";}' unless defined(&TNF_N_USER_SCHEDULE);
    eval 'sub TNF_N_KERNEL_SCHEDULE () {"tnf_kernel_schedule";}' unless defined(&TNF_N_KERNEL_SCHEDULE);
    eval 'sub TNF_N_PID () {"pid";}' unless defined(&TNF_N_PID);
    eval 'sub TNF_N_LWPID () {"lwpid";}' unless defined(&TNF_N_LWPID);
    eval 'sub TNF_N_TID () {"tid";}' unless defined(&TNF_N_TID);
    eval 'sub TNF_N_TIME_BASE () {"time_base";}' unless defined(&TNF_N_TIME_BASE);
    eval 'sub TNF_N_TIME_DELTA () {"time_delta";}' unless defined(&TNF_N_TIME_DELTA);
    if(defined(&__cplusplus)) {
    }
}
1;
