require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_TPICOMMON_H)) {
    eval 'sub _SYS_TPICOMMON_H () {1;}' unless defined(&_SYS_TPICOMMON_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub TBADADDR () {1;}' unless defined(&TBADADDR);
    eval 'sub TBADOPT () {2;}' unless defined(&TBADOPT);
    eval 'sub TACCES () {3;}' unless defined(&TACCES);
    eval 'sub TBADF () {4;}' unless defined(&TBADF);
    eval 'sub TNOADDR () {5;}' unless defined(&TNOADDR);
    eval 'sub TOUTSTATE () {6;}' unless defined(&TOUTSTATE);
    eval 'sub TBADSEQ () {7;}' unless defined(&TBADSEQ);
    eval 'sub TSYSERR () {8;}' unless defined(&TSYSERR);
    eval 'sub TLOOK () {9;}' unless defined(&TLOOK);
    eval 'sub TBADDATA () {10;}' unless defined(&TBADDATA);
    eval 'sub TBUFOVFLW () {11;}' unless defined(&TBUFOVFLW);
    eval 'sub TFLOW () {12;}' unless defined(&TFLOW);
    eval 'sub TNODATA () {13;}' unless defined(&TNODATA);
    eval 'sub TNODIS () {14;}' unless defined(&TNODIS);
    eval 'sub TNOUDERR () {15;}' unless defined(&TNOUDERR);
    eval 'sub TBADFLAG () {16;}' unless defined(&TBADFLAG);
    eval 'sub TNOREL () {17;}' unless defined(&TNOREL);
    eval 'sub TNOTSUPPORT () {18;}' unless defined(&TNOTSUPPORT);
    eval 'sub TSTATECHNG () {19;}' unless defined(&TSTATECHNG);
    eval 'sub TNOSTRUCTYPE () {20;}' unless defined(&TNOSTRUCTYPE);
    eval 'sub TBADNAME () {21;}' unless defined(&TBADNAME);
    eval 'sub TBADQLEN () {22;}' unless defined(&TBADQLEN);
    eval 'sub TADDRBUSY () {23;}' unless defined(&TADDRBUSY);
    eval 'sub TINDOUT () {24;}' unless defined(&TINDOUT);
    eval 'sub TPROVMISMATCH () {25;}' unless defined(&TPROVMISMATCH);
    eval 'sub TRESQLEN () {26;}' unless defined(&TRESQLEN);
    eval 'sub TRESADDR () {27;}' unless defined(&TRESADDR);
    eval 'sub TQFULL () {28;}' unless defined(&TQFULL);
    eval 'sub TPROTO () {29;}' unless defined(&TPROTO);
    eval 'sub T_COTS () {1;}' unless defined(&T_COTS);
    eval 'sub T_COTS_ORD () {2;}' unless defined(&T_COTS_ORD);
    eval 'sub T_CLTS () {3;}' unless defined(&T_CLTS);
    eval 'sub T_NEGOTIATE () {0x4;}' unless defined(&T_NEGOTIATE);
    eval 'sub T_CHECK () {0x8;}' unless defined(&T_CHECK);
    eval 'sub T_DEFAULT () {0x10;}' unless defined(&T_DEFAULT);
    eval 'sub T_SUCCESS () {0x20;}' unless defined(&T_SUCCESS);
    eval 'sub T_FAILURE () {0x40;}' unless defined(&T_FAILURE);
    eval 'sub T_CURRENT () {0x80;}' unless defined(&T_CURRENT);
    eval 'sub T_PARTSUCCESS () {0x100;}' unless defined(&T_PARTSUCCESS);
    eval 'sub T_READONLY () {0x200;}' unless defined(&T_READONLY);
    eval 'sub T_NOTSUPPORT () {0x400;}' unless defined(&T_NOTSUPPORT);
    eval 'sub T_YES () {1;}' unless defined(&T_YES);
    eval 'sub T_NO () {0;}' unless defined(&T_NO);
    eval 'sub T_INFINITE () {-1;}' unless defined(&T_INFINITE);
    eval 'sub T_INVALID () {-2;}' unless defined(&T_INVALID);
    eval 'sub T_UNSPEC () {(~0-2);}' unless defined(&T_UNSPEC);
    eval 'sub T_ALLOPT () {0;}' unless defined(&T_ALLOPT);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub OPTLEN {
	    my($x) = @_;
    	    eval q((((($x) + $sizeof{ &t_uscalar_t} - 1) / $sizeof{ &t_uscalar_t}) * $sizeof{ &t_uscalar_t}));
	}' unless defined(&OPTLEN);
	eval 'sub OPTVAL {
	    my($opt) = @_;
    	    eval q((($opt + 1)));
	}' unless defined(&OPTVAL);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
