require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_VUID_EVENT_H)) {
    eval 'sub _SYS_VUID_EVENT_H () {1;}' unless defined(&_SYS_VUID_EVENT_H);
    require 'sys/types.ph';
    require 'sys/types32.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub VUID_SEG_SIZE () {(256);}' unless defined(&VUID_SEG_SIZE);
    eval 'sub ASCII_DEVID () {0x;}' unless defined(&ASCII_DEVID);
    eval 'sub TOP_DEVID () {0x1;}' unless defined(&TOP_DEVID);
    eval 'sub ISO_DEVID () {0x2;}' unless defined(&ISO_DEVID);
    eval 'sub LIGHTPEN_DEVID () {0x79;}' unless defined(&LIGHTPEN_DEVID);
    eval 'sub BUTTON_DEVID () {0x7a;}' unless defined(&BUTTON_DEVID);
    eval 'sub DIAL_DEVID () {0x7b;}' unless defined(&DIAL_DEVID);
    eval 'sub SUNVIEW_DEVID () {0x7c;}' unless defined(&SUNVIEW_DEVID);
    eval 'sub PANEL_DEVID () {0x7d;}' unless defined(&PANEL_DEVID);
    eval 'sub SCROLL_DEVID () {0x7e;}' unless defined(&SCROLL_DEVID);
    eval 'sub WORKSTATION_DEVID () {0x7f;}' unless defined(&WORKSTATION_DEVID);
    eval 'sub LAST_DEVID () {0xff;}' unless defined(&LAST_DEVID);
    eval("sub VUID_ASCII () { ASCII_DEVID; }") unless defined(&VUID_ASCII);
    eval("sub VUID_TOP () { TOP_DEVID; }") unless defined(&VUID_TOP);
    eval("sub VUID_ISO () { ISO_DEVID; }") unless defined(&VUID_ISO);
    eval("sub VUID_LIGHTPEN () { LIGHTPEN_DEVID; }") unless defined(&VUID_LIGHTPEN);
    eval("sub VUID_DIAL () { DIAL_DEVID; }") unless defined(&VUID_DIAL);
    eval("sub VUID_SUNVIEW () { SUNVIEW_DEVID; }") unless defined(&VUID_SUNVIEW);
    eval("sub VUID_PANEL () { PANEL_DEVID; }") unless defined(&VUID_PANEL);
    eval("sub VUID_SCROLL () { SCROLL_DEVID; }") unless defined(&VUID_SCROLL);
    eval("sub VUID_WORKSTATION () { WORKSTATION_DEVID; }") unless defined(&VUID_WORKSTATION);
    eval("sub VUID_LAST () { LAST_DEVID; }") unless defined(&VUID_LAST);
    eval 'sub vuid_first {
        my($devid) = @_;
	    eval q((($devid) << 8));
    }' unless defined(&vuid_first);
    eval 'sub vuid_last {
        my($devid) = @_;
	    eval q(((($devid) << 8)+ &VUID_SEG_SIZE-1));
    }' unless defined(&vuid_last);
    eval 'sub vuid_in_range {
        my($devid, $id) = @_;
	    eval q((($id >=  &vuid_first($devid))  && ($id <=  &vuid_last($devid))));
    }' unless defined(&vuid_in_range);
    eval 'sub EUC_FIRST () {(0);}' unless defined(&EUC_FIRST);
    eval 'sub EUC_LAST () {(255);}' unless defined(&EUC_LAST);
    eval 'sub ASCII_FIRST () {(0);}' unless defined(&ASCII_FIRST);
    eval 'sub ASCII_LAST () {(127);}' unless defined(&ASCII_LAST);
    eval 'sub META_FIRST () {(128);}' unless defined(&META_FIRST);
    eval 'sub META_LAST () {(255);}' unless defined(&META_LAST);
    eval 'sub TOP_FIRST () {(256);}' unless defined(&TOP_FIRST);
    eval 'sub TOP_LAST () {(511);}' unless defined(&TOP_LAST);
    eval 'sub ISO_FIRST () {(512);}' unless defined(&ISO_FIRST);
    eval 'sub ISO_LAST () {(767);}' unless defined(&ISO_LAST);
    eval 'sub VKEY_FIRST () { &vuid_first( &WORKSTATION_DEVID);}' unless defined(&VKEY_FIRST);
    eval 'sub VKEY_UP () {0;}' unless defined(&VKEY_UP);
    eval 'sub VKEY_DOWN () {1;}' unless defined(&VKEY_DOWN);
    eval 'sub VKEY_KBD_CODES () {(128);}' unless defined(&VKEY_KBD_CODES);
    eval 'sub VKEY_FIRSTPSEUDO () {( &VKEY_FIRST);}' unless defined(&VKEY_FIRSTPSEUDO);
    eval 'sub VKEY_LASTPSEUDO () {( &VKEY_FIRSTPSEUDO+15);}' unless defined(&VKEY_LASTPSEUDO);
    eval 'sub VKEY_FIRSTSHIFT () {( &VKEY_LASTPSEUDO+1);}' unless defined(&VKEY_FIRSTSHIFT);
    eval 'sub SHIFT_CAPSLOCK () {( &VKEY_FIRSTSHIFT+0);}' unless defined(&SHIFT_CAPSLOCK);
    eval 'sub SHIFT_LOCK () {( &VKEY_FIRSTSHIFT+1);}' unless defined(&SHIFT_LOCK);
    eval 'sub SHIFT_LEFT () {( &VKEY_FIRSTSHIFT+2);}' unless defined(&SHIFT_LEFT);
    eval 'sub SHIFT_RIGHT () {( &VKEY_FIRSTSHIFT+3);}' unless defined(&SHIFT_RIGHT);
    eval 'sub SHIFT_LEFTCTRL () {( &VKEY_FIRSTSHIFT+4);}' unless defined(&SHIFT_LEFTCTRL);
    eval 'sub SHIFT_CTRL () { &SHIFT_LEFTCTRL;}' unless defined(&SHIFT_CTRL);
    eval 'sub SHIFT_RIGHTCTRL () {( &VKEY_FIRSTSHIFT+5);}' unless defined(&SHIFT_RIGHTCTRL);
    eval 'sub SHIFT_META () {( &VKEY_FIRSTSHIFT+6);}' unless defined(&SHIFT_META);
    eval 'sub SHIFT_TOP () {( &VKEY_FIRSTSHIFT+7);}' unless defined(&SHIFT_TOP);
    eval 'sub SHIFT_CMD () {( &VKEY_FIRSTSHIFT+8);}' unless defined(&SHIFT_CMD);
    eval 'sub SHIFT_ALTG () {( &VKEY_FIRSTSHIFT+9);}' unless defined(&SHIFT_ALTG);
    eval 'sub SHIFT_ALT () {( &VKEY_FIRSTSHIFT+10);}' unless defined(&SHIFT_ALT);
    eval 'sub SHIFT_NUMLOCK () {( &VKEY_FIRSTSHIFT+11);}' unless defined(&SHIFT_NUMLOCK);
    eval 'sub VKEY_LASTSHIFT () {( &VKEY_FIRSTSHIFT+15);}' unless defined(&VKEY_LASTSHIFT);
    eval 'sub VKEY_FIRSTFUNC () {( &VKEY_LASTSHIFT+1);}' unless defined(&VKEY_FIRSTFUNC);
    eval 'sub BUT_FIRST () {( &VKEY_FIRSTFUNC);}' unless defined(&BUT_FIRST);
    eval 'sub BUT {
        my($i) = @_;
	    eval q((( &BUT_FIRST)+($i)-1));
    }' unless defined(&BUT);
    eval 'sub BUT_LAST () {( &BUT_FIRST+9);}' unless defined(&BUT_LAST);
    eval 'sub KEY_LEFTFIRST () {(( &BUT_LAST)+1);}' unless defined(&KEY_LEFTFIRST);
    eval 'sub KEY_LEFT {
        my($i) = @_;
	    eval q((( &KEY_LEFTFIRST)+($i)-1));
    }' unless defined(&KEY_LEFT);
    eval 'sub KEY_LEFTLAST () {(( &KEY_LEFTFIRST)+15);}' unless defined(&KEY_LEFTLAST);
    eval 'sub KEY_RIGHTFIRST () {(( &KEY_LEFTLAST)+1);}' unless defined(&KEY_RIGHTFIRST);
    eval 'sub KEY_RIGHT {
        my($i) = @_;
	    eval q((( &KEY_RIGHTFIRST)+($i)-1));
    }' unless defined(&KEY_RIGHT);
    eval 'sub KEY_RIGHTLAST () {(( &KEY_RIGHTFIRST)+15);}' unless defined(&KEY_RIGHTLAST);
    eval 'sub KEY_TOPFIRST () {(( &KEY_RIGHTLAST)+1);}' unless defined(&KEY_TOPFIRST);
    eval 'sub KEY_TOP {
        my($i) = @_;
	    eval q((( &KEY_TOPFIRST)+($i)-1));
    }' unless defined(&KEY_TOP);
    eval 'sub KEY_TOPLAST () {(( &KEY_TOPFIRST)+15);}' unless defined(&KEY_TOPLAST);
    eval 'sub KEY_BOTTOMLEFT () {(( &KEY_TOPLAST)+1);}' unless defined(&KEY_BOTTOMLEFT);
    eval 'sub KEY_BOTTOMRIGHT () {(( &KEY_BOTTOMLEFT)+1);}' unless defined(&KEY_BOTTOMRIGHT);
    eval 'sub KEY_BOTTOMFIRST () {(( &KEY_TOPLAST)+1);}' unless defined(&KEY_BOTTOMFIRST);
    eval 'sub KEY_BOTTOM {
        my($i) = @_;
	    eval q((( &KEY_BOTTOMFIRST)+($i)-1));
    }' unless defined(&KEY_BOTTOM);
    eval 'sub KEY_BOTTOMLAST () {(( &KEY_BOTTOMFIRST)+15);}' unless defined(&KEY_BOTTOMLAST);
    eval 'sub VKEY_LASTFUNC () {( &VKEY_FIRSTFUNC+73);}' unless defined(&VKEY_LASTFUNC);
    eval 'sub VKEY_FIRSTPAD () {( &VKEY_LASTFUNC+1);}' unless defined(&VKEY_FIRSTPAD);
    eval 'sub VKEY_PADEQUAL () {( &VKEY_FIRSTPAD+0);}' unless defined(&VKEY_PADEQUAL);
    eval 'sub VKEY_PADSLASH () {( &VKEY_FIRSTPAD+1);}' unless defined(&VKEY_PADSLASH);
    eval 'sub VKEY_PADSTAR () {( &VKEY_FIRSTPAD+2);}' unless defined(&VKEY_PADSTAR);
    eval 'sub VKEY_PADMINUS () {( &VKEY_FIRSTPAD+3);}' unless defined(&VKEY_PADMINUS);
    eval 'sub VKEY_PADSEP () {( &VKEY_FIRSTPAD+4);}' unless defined(&VKEY_PADSEP);
    eval 'sub VKEY_PAD7 () {( &VKEY_FIRSTPAD+5);}' unless defined(&VKEY_PAD7);
    eval 'sub VKEY_PAD8 () {( &VKEY_FIRSTPAD+6);}' unless defined(&VKEY_PAD8);
    eval 'sub VKEY_PAD9 () {( &VKEY_FIRSTPAD+7);}' unless defined(&VKEY_PAD9);
    eval 'sub VKEY_PADPLUS () {( &VKEY_FIRSTPAD+8);}' unless defined(&VKEY_PADPLUS);
    eval 'sub VKEY_PAD4 () {( &VKEY_FIRSTPAD+9);}' unless defined(&VKEY_PAD4);
    eval 'sub VKEY_PAD5 () {( &VKEY_FIRSTPAD+10);}' unless defined(&VKEY_PAD5);
    eval 'sub VKEY_PAD6 () {( &VKEY_FIRSTPAD+11);}' unless defined(&VKEY_PAD6);
    eval 'sub VKEY_PAD1 () {( &VKEY_FIRSTPAD+12);}' unless defined(&VKEY_PAD1);
    eval 'sub VKEY_PAD2 () {( &VKEY_FIRSTPAD+13);}' unless defined(&VKEY_PAD2);
    eval 'sub VKEY_PAD3 () {( &VKEY_FIRSTPAD+14);}' unless defined(&VKEY_PAD3);
    eval 'sub VKEY_PAD0 () {( &VKEY_FIRSTPAD+15);}' unless defined(&VKEY_PAD0);
    eval 'sub VKEY_PADDOT () {( &VKEY_FIRSTPAD+16);}' unless defined(&VKEY_PADDOT);
    eval 'sub VKEY_PADENTER () {( &VKEY_FIRSTPAD+17);}' unless defined(&VKEY_PADENTER);
    eval 'sub VKEY_LASTPAD () {( &VKEY_FIRSTPAD+17);}' unless defined(&VKEY_LASTPAD);
    eval 'sub VKEY_LAST () {( &VKEY_FIRST+ &VKEY_KBD_CODES-1);}' unless defined(&VKEY_LAST);
    eval 'sub MOUSE_DEVID () { &WORKSTATION_DEVID;}' unless defined(&MOUSE_DEVID);
    eval 'sub VLOC_FIRST () {( &VKEY_LAST+1);}' unless defined(&VLOC_FIRST);
    eval 'sub LOC_FIRST_DELTA () {( &VLOC_FIRST+0);}' unless defined(&LOC_FIRST_DELTA);
    eval 'sub LOC_X_DELTA () {( &VLOC_FIRST+0);}' unless defined(&LOC_X_DELTA);
    eval 'sub LOC_Y_DELTA () {( &VLOC_FIRST+1);}' unless defined(&LOC_Y_DELTA);
    eval 'sub LOC_LAST_DELTA () {( &VLOC_FIRST+1);}' unless defined(&LOC_LAST_DELTA);
    eval 'sub LOC_FIRST_ABSOLUTE () {( &VLOC_FIRST+2);}' unless defined(&LOC_FIRST_ABSOLUTE);
    eval 'sub LOC_X_ABSOLUTE () {( &VLOC_FIRST+2);}' unless defined(&LOC_X_ABSOLUTE);
    eval 'sub LOC_Y_ABSOLUTE () {( &VLOC_FIRST+3);}' unless defined(&LOC_Y_ABSOLUTE);
    eval 'sub LOC_LAST_ABSOLUTE () {( &VLOC_FIRST+3);}' unless defined(&LOC_LAST_ABSOLUTE);
    eval 'sub VLOC_BATCH () {( &VLOC_FIRST+4);}' unless defined(&VLOC_BATCH);
    eval 'sub VLOC_LAST () {( &VLOC_BATCH+1);}' unless defined(&VLOC_LAST);
    eval 'sub MS_LEFT () { &BUT(1);}' unless defined(&MS_LEFT);
    eval 'sub MS_MIDDLE () { &BUT(2);}' unless defined(&MS_MIDDLE);
    eval 'sub MS_RIGHT () { &BUT(3);}' unless defined(&MS_RIGHT);
    eval 'sub FE_PAIR_NONE () {0;}' unless defined(&FE_PAIR_NONE);
    eval 'sub FE_PAIR_SET () {1;}' unless defined(&FE_PAIR_SET);
    eval 'sub FE_PAIR_DELTA () {2;}' unless defined(&FE_PAIR_DELTA);
    eval 'sub FE_PAIR_ABSOLUTE () {3;}' unless defined(&FE_PAIR_ABSOLUTE);
    if(defined( &_LP64) || defined( &_I32LPx)) {
    } else {
    }
    eval 'sub FIRM_EVENT_NULL () {(( &Firm_event *)0);}' unless defined(&FIRM_EVENT_NULL);
    eval 'sub vuid_id_addr {
        my($id) = @_;
	    eval q((($id) & 0xff00));
    }' unless defined(&vuid_id_addr);
    eval 'sub vuid_id_offset {
        my($id) = @_;
	    eval q((($id) & 0xff));
    }' unless defined(&vuid_id_offset);
    eval 'sub vuid_boolean_value {
        my($value) = @_;
	    eval q(((($value) == 0) || (($value) == 1)));
    }' unless defined(&vuid_boolean_value);
    eval 'sub vuid_int_value {
        my($value) = @_;
	    eval q((!( &vuid_boolean_value(($value)))));
    }' unless defined(&vuid_int_value);
    eval 'sub VUIOC () {(ord(\'v\')<<8);}' unless defined(&VUIOC);
    if(!(defined( &i386) || defined( &__i386))) {
	eval 'sub VUIDSFORMAT () {( &VUIOC|1);}' unless defined(&VUIDSFORMAT);
	eval 'sub VUIDGFORMAT () {( &VUIOC|2);}' unless defined(&VUIDGFORMAT);
    } else {
	eval 'sub VUIDSFORMAT () {( &VUIOC|11);}' unless defined(&VUIDSFORMAT);
	eval 'sub VUIDGFORMAT () {( &VUIOC|12);}' unless defined(&VUIDGFORMAT);
    }
    eval 'sub VUID_NATIVE () {0;}' unless defined(&VUID_NATIVE);
    eval 'sub VUID_FIRM_EVENT () {1;}' unless defined(&VUID_FIRM_EVENT);
    if(!(defined( &i386) || defined( &__i386))) {
	eval 'sub VUIDSADDR () {( &VUIOC|3);}' unless defined(&VUIDSADDR);
	eval 'sub VUIDGADDR () {( &VUIOC|4);}' unless defined(&VUIDGADDR);
    } else {
	eval 'sub VUIDSADDR () {( &VUIOC|13);}' unless defined(&VUIDSADDR);
	eval 'sub VUIDGADDR () {( &VUIOC|14);}' unless defined(&VUIDGADDR);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
