require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_ZSDEV_H)) {
    eval 'sub _SYS_ZSDEV_H () {1;}' unless defined(&_SYS_ZSDEV_H);
    require 'sys/spl.ph';
    require 'sys/ksynch.ph';
    require 'sys/dditypes.ph';
    require 'sys/ser_zscc.ph';
    if(defined(&_MACHDEP)) {
	require 'sys/zsmach.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_MACHDEP)) {
	eval 'sub ZSDELAY () {
	    eval q();
	}' unless defined(&ZSDELAY);
	eval 'sub ZSFLUSH () {
	    eval q();
	}' unless defined(&ZSFLUSH);
	eval 'sub ZSNEXTPOLL {
	    my($zscurr) = @_;
    	    eval q();
	}' unless defined(&ZSNEXTPOLL);
    }
    eval 'sub OUTLINE () {(( &minor_t)1<< ( &NBITSMINOR32 - 1));}' unless defined(&OUTLINE);
    eval 'sub UNIT {
        my($x) = @_;
	    eval q(( &getminor($x) & ~ &OUTLINE));
    }' unless defined(&UNIT);
    eval 'sub ZSWR1_INIT () {( &ZSWR1_SIE| &ZSWR1_TIE| &ZSWR1_RIE);}' unless defined(&ZSWR1_INIT);
    eval 'sub ZS_REG_SIZE () {(2* $sizeof{\'struct zscc_device\'});}' unless defined(&ZS_REG_SIZE);
    eval 'sub PCLK () {(19660800/4);}' unless defined(&PCLK);
    eval 'sub SDLCFLAG () {0x7e;}' unless defined(&SDLCFLAG);
    eval 'sub ZS_ON () {( &ZSWR5_DTR| &ZSWR5_RTS);}' unless defined(&ZS_ON);
    eval 'sub ZS_OFF () {0;}' unless defined(&ZS_OFF);
    eval 'sub DMSET () {0;}' unless defined(&DMSET);
    eval 'sub DMBIS () {1;}' unless defined(&DMBIS);
    eval 'sub DMBIC () {2;}' unless defined(&DMBIC);
    eval 'sub DMGET () {3;}' unless defined(&DMGET);
    eval 'sub SCC_WRITEA {
        my($reg, $val) = @_;
	    eval q({ ( (( &uintptr_t) ($zs->{zs_addr}) |  &ZSOFF))-> &zscc_control = $reg;  &ZSDELAY(); ( (( &uintptr_t) ($zs->{zs_addr}) |  &ZSOFF))-> &zscc_control = $val;  &ZSDELAY();  ($zs->{zs_wreg[$reg]}) = $val; });
    }' unless defined(&SCC_WRITEA);
    eval 'sub SCC_WRITEB {
        my($reg, $val) = @_;
	    eval q({ ( (( &uintptr_t) ($zs->{zs_addr}) & ~ &ZSOFF))-> &zscc_control = $reg;  &ZSDELAY(); ( (( &uintptr_t) ($zs->{zs_addr}) & ~ &ZSOFF))-> &zscc_control = $val;  &ZSDELAY();  ($zs->{zs_wreg[$reg]}) = $val; });
    }' unless defined(&SCC_WRITEB);
    eval 'sub SCC_WRITE {
        my($reg, $val) = @_;
	    eval q({  ($zs->{zs_addr}->{zscc_control}) = $reg;  &ZSDELAY();  ($zs->{zs_addr}->{zscc_control}) = $val;  &ZSDELAY();  ($zs->{zs_wreg[$reg]}) = $val; });
    }' unless defined(&SCC_WRITE);
    eval 'sub SCC_READA {
        my($reg, $var) = @_;
	    eval q({ ( (( &uintptr_t) ($zs->{zs_addr}) |  &ZSOFF))-> &zscc_control = $reg;  &ZSDELAY(); $var = ( (( &uintptr_t) ($zs->{zs_addr}) |  &ZSOFF))-> &zscc_control;  &ZSDELAY(); });
    }' unless defined(&SCC_READA);
    eval 'sub SCC_READB {
        my($reg, $var) = @_;
	    eval q({ ( (( &uintptr_t) ($zs->{zs_addr}) & ~ &ZSOFF))-> &zscc_control = $reg;  &ZSDELAY(); $var = ( (( &uintptr_t) ($zs->{zs_addr}) & ~ &ZSOFF))-> &zscc_control;  &ZSDELAY(); });
    }' unless defined(&SCC_READB);
    eval 'sub SCC_READ {
        my($reg, $var) = @_;
	    eval q({  &register \'struct zscc_device\' * &tmp;  &tmp =  ($zs->{zs_addr});  ($tmp->{zscc_control}) = $reg;  &ZSDELAY(); $var =  ($tmp->{zscc_control});  &ZSDELAY(); });
    }' unless defined(&SCC_READ);
    eval 'sub SCC_BIS {
        my($reg, $val) = @_;
	    eval q({  ($zs->{zs_addr}->{zscc_control}) = $reg;  &ZSDELAY();  ($zs->{zs_addr}->{zscc_control}) =  ($zs->{zs_wreg[$reg]}) |= $val;  &ZSDELAY(); });
    }' unless defined(&SCC_BIS);
    eval 'sub SCC_BIC {
        my($reg, $val) = @_;
	    eval q({  ($zs->{zs_addr}->{zscc_control}) = $reg;  &ZSDELAY();  ($zs->{zs_addr}->{zscc_control}) =  ($zs->{zs_wreg[$reg]}) &= ~$val;  &ZSDELAY(); });
    }' unless defined(&SCC_BIC);
    eval 'sub SCC_WRITE0 {
        my($val) = @_;
	    eval q({  ($zs->{zs_addr}->{zscc_control}) = $val;  &ZSDELAY();  &ZSFLUSH(); });
    }' unless defined(&SCC_WRITE0);
    eval 'sub SCC_WRITEDATA {
        my($val) = @_;
	    eval q({  ($zs->{zs_addr}->{zscc_data}) = $val;  &ZSDELAY();  &ZSFLUSH(); });
    }' unless defined(&SCC_WRITEDATA);
    eval 'sub SCC_READ0 () {
        eval q( ($zs->{zs_addr}->{zscc_control}));
    }' unless defined(&SCC_READ0);
    eval 'sub SCC_READDATA () {
        eval q( ($zs->{zs_addr}->{zscc_data}));
    }' unless defined(&SCC_READDATA);
    eval 'sub ZS_MAX_PRIV_STR () {800;}' unless defined(&ZS_MAX_PRIV_STR);
    eval 'sub ZS_NEEDSOFT () {1;}' unless defined(&ZS_NEEDSOFT);
    if(defined(&_KERNEL)) {
	eval 'sub ZS_H_LOG_MAX () {0x8000;}' unless defined(&ZS_H_LOG_MAX);
	eval 'sub ZSSETSOFT {
	    my($zs) = @_;
    	    eval q({  ($zs->{zs_flags_need}) =  &ZS_NEEDSOFT;  &if (! &zssoftpend) {  &zssoftpend = 1;  &ddi_trigger_softintr( &zs_softintr_id); } });
	}' unless defined(&ZSSETSOFT);
    }
    eval 'sub ZS_PL () { &ipltospl( &SPL3);}' unless defined(&ZS_PL);
    eval 'sub ZS_PL_HI () { &ipltospl( &SPLTTY);}' unless defined(&ZS_PL_HI);
    eval 'sub ZSP_SYNC () {01;}' unless defined(&ZSP_SYNC);
    eval 'sub ZSP_NRZI () {02;}' unless defined(&ZSP_NRZI);
    eval 'sub ZSP_PLL () {04;}' unless defined(&ZSP_PLL);
    eval 'sub ZSP_LOOP () {010;}' unless defined(&ZSP_LOOP);
    eval 'sub ZSP_PARITY_SPECIAL () {020;}' unless defined(&ZSP_PARITY_SPECIAL);
    eval 'sub ZSP_ECHO () {040;}' unless defined(&ZSP_ECHO);
    if(defined(&__cplusplus)) {
    }
}
1;
