require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_UNISTD_H)) {
    eval 'sub _UNISTD_H () {1;}' unless defined(&_UNISTD_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    require 'sys/unistd.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub R_OK () {4;}' unless defined(&R_OK);
    eval 'sub W_OK () {2;}' unless defined(&W_OK);
    eval 'sub X_OK () {1;}' unless defined(&X_OK);
    eval 'sub F_OK () {0;}' unless defined(&F_OK);
    if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub F_ULOCK () {0;}' unless defined(&F_ULOCK);
	eval 'sub F_LOCK () {1;}' unless defined(&F_LOCK);
	eval 'sub F_TLOCK () {2;}' unless defined(&F_TLOCK);
	eval 'sub F_TEST () {3;}' unless defined(&F_TEST);
    }
    unless(defined(&SEEK_SET)) {
	eval 'sub SEEK_SET () {0;}' unless defined(&SEEK_SET);
    }
    unless(defined(&SEEK_CUR)) {
	eval 'sub SEEK_CUR () {1;}' unless defined(&SEEK_CUR);
    }
    unless(defined(&SEEK_END)) {
	eval 'sub SEEK_END () {2;}' unless defined(&SEEK_END);
    }
    if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	eval 'sub GF_PATH () {"/etc/group";}' unless defined(&GF_PATH);
	eval 'sub PF_PATH () {"/etc/passwd";}' unless defined(&PF_PATH);
    }
    eval 'sub _POSIX_ASYNC_IO () {1;}' unless defined(&_POSIX_ASYNC_IO);
    eval 'sub _POSIX_ASYNCHRONOUS_IO () {1;}' unless defined(&_POSIX_ASYNCHRONOUS_IO);
    eval 'sub _POSIX_FSYNC () {1;}' unless defined(&_POSIX_FSYNC);
    eval 'sub _POSIX_JOB_CONTROL () {1;}' unless defined(&_POSIX_JOB_CONTROL);
    eval 'sub _POSIX_MAPPED_FILES () {1;}' unless defined(&_POSIX_MAPPED_FILES);
    eval 'sub _POSIX_MEMLOCK () {1;}' unless defined(&_POSIX_MEMLOCK);
    eval 'sub _POSIX_MEMLOCK_RANGE () {1;}' unless defined(&_POSIX_MEMLOCK_RANGE);
    eval 'sub _POSIX_MEMORY_PROTECTION () {1;}' unless defined(&_POSIX_MEMORY_PROTECTION);
    eval 'sub _POSIX_MESSAGE_PASSING () {1;}' unless defined(&_POSIX_MESSAGE_PASSING);
    eval 'sub _POSIX_PRIORITY_SCHEDULING () {1;}' unless defined(&_POSIX_PRIORITY_SCHEDULING);
    eval 'sub _POSIX_REALTIME_SIGNALS () {1;}' unless defined(&_POSIX_REALTIME_SIGNALS);
    eval 'sub _POSIX_SAVED_IDS () {1;}' unless defined(&_POSIX_SAVED_IDS);
    eval 'sub _POSIX_SEMAPHORES () {1;}' unless defined(&_POSIX_SEMAPHORES);
    eval 'sub _POSIX_SHARED_MEMORY_OBJECTS () {1;}' unless defined(&_POSIX_SHARED_MEMORY_OBJECTS);
    eval 'sub _POSIX_SYNC_IO () {1;}' unless defined(&_POSIX_SYNC_IO);
    eval 'sub _POSIX_SYNCHRONIZED_IO () {1;}' unless defined(&_POSIX_SYNCHRONIZED_IO);
    eval 'sub _POSIX_TIMERS () {1;}' unless defined(&_POSIX_TIMERS);
    eval 'sub _POSIX_THREAD_SAFE_FUNCTIONS () {1;}' unless defined(&_POSIX_THREAD_SAFE_FUNCTIONS);
    eval 'sub _POSIX_THREADS () {1;}' unless defined(&_POSIX_THREADS);
    eval 'sub _POSIX_THREAD_ATTR_STACKADDR () {1;}' unless defined(&_POSIX_THREAD_ATTR_STACKADDR);
    eval 'sub _POSIX_THREAD_ATTR_STACKSIZE () {1;}' unless defined(&_POSIX_THREAD_ATTR_STACKSIZE);
    eval 'sub _POSIX_THREAD_PROCESS_SHARED () {1;}' unless defined(&_POSIX_THREAD_PROCESS_SHARED);
    eval 'sub _POSIX_THREAD_PRIORITY_SCHEDULING () {1;}' unless defined(&_POSIX_THREAD_PRIORITY_SCHEDULING);
    eval 'sub _POSIX_THREAD_PRIO_INHERIT () {1;}' unless defined(&_POSIX_THREAD_PRIO_INHERIT);
    eval 'sub _POSIX_THREAD_PRIO_PROTECT () {1;}' unless defined(&_POSIX_THREAD_PRIO_PROTECT);
    unless(defined(&_POSIX_VDISABLE)) {
	eval 'sub _POSIX_VDISABLE () {0;}' unless defined(&_POSIX_VDISABLE);
    }
    unless(defined(&NULL)) {
	if(defined( &_LP64)  && !defined( &__cplusplus)) {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	} else {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	}
    }
    eval 'sub STDIN_FILENO () {0;}' unless defined(&STDIN_FILENO);
    eval 'sub STDOUT_FILENO () {1;}' unless defined(&STDOUT_FILENO);
    eval 'sub STDERR_FILENO () {2;}' unless defined(&STDERR_FILENO);
    eval 'sub _LFS_LARGEFILE () {1;}' unless defined(&_LFS_LARGEFILE);
    eval 'sub _LFS64_LARGEFILE () {1;}' unless defined(&_LFS64_LARGEFILE);
    eval 'sub _LFS64_STDIO () {1;}' unless defined(&_LFS64_STDIO);
    eval 'sub _LFS64_ASYNCHRONOUS_IO () {1;}' unless defined(&_LFS64_ASYNCHRONOUS_IO);
    if(!defined( &_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	} else {
	    eval 'sub ftruncate () { &ftruncate64;}' unless defined(&ftruncate);
	    eval 'sub lseek () { &lseek64;}' unless defined(&lseek);
	    eval 'sub pread () { &pread64;}' unless defined(&pread);
	    eval 'sub pwrite () { &pwrite64;}' unless defined(&pwrite);
	    eval 'sub truncate () { &truncate64;}' unless defined(&truncate);
	    eval 'sub lockf () { &lockf64;}' unless defined(&lockf);
	    eval 'sub tell () { &tell64;}' unless defined(&tell);
	}
    }
    if(defined( &_LP64)  && defined( &_LARGEFILE64_SOURCE)) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	} else {
	    eval 'sub ftruncate64 () { &ftruncate;}' unless defined(&ftruncate64);
	    eval 'sub lseek64 () { &lseek;}' unless defined(&lseek64);
	    eval 'sub pread64 () { &pread;}' unless defined(&pread64);
	    eval 'sub pwrite64 () { &pwrite;}' unless defined(&pwrite64);
	    eval 'sub truncate64 () { &truncate;}' unless defined(&truncate64);
	    eval 'sub lockf64 () { &lockf;}' unless defined(&lockf64);
	    eval 'sub tell64 () { &tell;}' unless defined(&tell64);
	}
    }
    if(defined( &__STDC__)) {
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4)) || defined( &__EXTENSIONS__)) {
	}
	if(!defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE) || defined( &__EXTENSIONS__)) {
	}
	if(defined(&_REENTRANT)) {
	}
	if((defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if(!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if(!defined( &_POSIX_C_SOURCE) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if(defined( &_XPG4_2)) {
	}
 elsif(defined( &__EXTENSIONS__) || (!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE))) {
	}
	if((defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || defined( &_XPG5) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || defined( &_XPG5) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0< 4)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if(defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if(defined( &_XPG5)) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub sysconf () { &__sysconf_xpg5;}' unless defined(&sysconf);
	    }
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if(defined( &_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)  && !defined( &__PRAGMA_REDEFINE_EXTNAME))) {
	}
    } else {
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4)) || defined( &__EXTENSIONS__)) {
	}
	if(!defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE) || defined( &__EXTENSIONS__)) {
	}
	if(defined(&_REENTRANT)) {
	}
	if((defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if(!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2) || defined( &__EXTENSIONS__)) {
	}
	if(!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if(!defined( &_POSIX_C_SOURCE) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	    if((defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4)) || defined( &__EXTENSIONS__)) {
	    }
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || defined( &_XPG5) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) > 2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || defined( &_XPG5) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0< 4)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if(defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if(defined( &_XPG5)) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub sysconf () { &__sysconf_xpg5;}' unless defined(&sysconf);
	    }
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || (defined( &_LARGEFILE_SOURCE)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if(!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	}
	if(defined( &_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64)  && !defined( &__PRAGMA_REDEFINE_EXTNAME))) {
	}
    }
    if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	if(defined( &__sparc)) {
	}
    }
    if(defined( &__EXTENSIONS__) || defined( &_REENTRANT) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) - 0>= 199506) || defined( &_POSIX_PTHREAD_SEMANTICS)) {
	if(defined( &__STDC__)) {
	    if(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) - 0>= 199506) || defined( &_POSIX_PTHREAD_SEMANTICS)) {
		if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
		} else {
		}
	    } else {
	    }
	} else {
	    if(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : 0) - 0>= 199506) || defined( &_POSIX_PTHREAD_SEMANTICS)) {
		if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
		} else {
		}
	    } else {
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
