require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PSR_H)) {
    eval 'sub _SYS_PSR_H () {1;}' unless defined(&_SYS_PSR_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub PSR_CWP () {0x1f;}' unless defined(&PSR_CWP);
    eval 'sub PSR_ET () {0x20;}' unless defined(&PSR_ET);
    eval 'sub PSR_PS () {0x40;}' unless defined(&PSR_PS);
    eval 'sub PSR_S () {0x80;}' unless defined(&PSR_S);
    eval 'sub PSR_PIL () {0xf00;}' unless defined(&PSR_PIL);
    eval 'sub PSR_EF () {0x1000;}' unless defined(&PSR_EF);
    eval 'sub PSR_EC () {0x2000;}' unless defined(&PSR_EC);
    eval 'sub PSR_RSV () {0xfc000;}' unless defined(&PSR_RSV);
    eval 'sub PSR_ICC () {0xf00000;}' unless defined(&PSR_ICC);
    eval 'sub PSR_C () {0x100000;}' unless defined(&PSR_C);
    eval 'sub PSR_V () {0x200000;}' unless defined(&PSR_V);
    eval 'sub PSR_Z () {0x400000;}' unless defined(&PSR_Z);
    eval 'sub PSR_N () {0x800000;}' unless defined(&PSR_N);
    eval 'sub PSR_VER () {0xf000000;}' unless defined(&PSR_VER);
    eval 'sub PSR_IMPL () {0xf0000000;}' unless defined(&PSR_IMPL);
    eval 'sub PSL_ALLCC () { &PSR_ICC;}' unless defined(&PSL_ALLCC);
    unless(defined(&_ASM)) {
    }
    eval 'sub PSL_USER () {( &PSR_S);}' unless defined(&PSL_USER);
    eval 'sub PSL_USERMASK () {( &PSR_ICC);}' unless defined(&PSL_USERMASK);
    eval 'sub PSL_UBITS () {( &PSR_ICC| &PSR_EF);}' unless defined(&PSL_UBITS);
    unless(defined(&__sparcv9cpu)) {
	eval 'sub USERMODE {
	    my($ps) = @_;
    	    eval q(((($ps) &  &PSR_PS) == 0));
	}' unless defined(&USERMODE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
