require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_TRAPTRACE_H)) {
    eval 'sub _SYS_TRAPTRACE_H () {1;}' unless defined(&_SYS_TRAPTRACE_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub TRAP_ENT_TBR () {0x;}' unless defined(&TRAP_ENT_TBR);
    eval 'sub TRAP_ENT_PSR () {0x4;}' unless defined(&TRAP_ENT_PSR);
    eval 'sub TRAP_ENT_PC () {0x8;}' unless defined(&TRAP_ENT_PC);
    eval 'sub TRAP_ENT_SP () {0xc;}' unless defined(&TRAP_ENT_SP);
    eval 'sub TRAP_ENT_G7 () {0x10;}' unless defined(&TRAP_ENT_G7);
    eval 'sub TRAP_ENT_TR () {0x14;}' unless defined(&TRAP_ENT_TR);
    eval 'sub TRAP_ENT_F1 () {0x18;}' unless defined(&TRAP_ENT_F1);
    eval 'sub TRAP_ENT_F2 () {0x1c;}' unless defined(&TRAP_ENT_F2);
    eval 'sub TRAP_ENT_SIZE () {32;}' unless defined(&TRAP_ENT_SIZE);
    eval 'sub TRAP_TSIZE () {( &TRAP_ENT_SIZE*256);}' unless defined(&TRAP_TSIZE);
    eval 'sub TRAPTR_NEXT () {0;}' unless defined(&TRAPTR_NEXT);
    eval 'sub TRAPTR_FIRST () {4;}' unless defined(&TRAPTR_FIRST);
    eval 'sub TRAPTR_LIMIT () {8;}' unless defined(&TRAPTR_LIMIT);
    eval 'sub TRAPTR_SIZE_SHIFT () {4;}' unless defined(&TRAPTR_SIZE_SHIFT);
    if(defined(&_ASM)) {
	eval 'sub TRACE_PTR {
	    my($ptr, $scr1) = @_;
    	    eval q( &CPU_INDEX($scr1);  &sll $scr1,  &TRAPTR_SIZE_SHIFT, $scr1;  &set  &trap_trace_ctl, $ptr;  &ld [$ptr + $scr1], $ptr;  &set  &panicstr, $scr1;  &ld [$scr1], $scr1;  &tst $scr1;  &bz .+0xc;  &sethi % &hi( &trap_tr_panic), $scr1;  &or $scr1, % &lo( &trap_tr_panic), $ptr);
	}' unless defined(&TRACE_PTR);
	eval 'sub TRACE_NEXT {
	    my($ptr, $scr1, $scr2) = @_;
    	    eval q( &CPU_INDEX($scr2);  &sll $scr2,  &TRAPTR_SIZE_SHIFT, $scr2;  &set  &trap_trace_ctl, $scr1;  &add $scr2, $scr1, $scr1;  &add $ptr,  &TRAP_ENT_SIZE, $ptr;  &ld [$scr1 +  &TRAPTR_LIMIT], $scr2;  &cmp $ptr, $scr2;  &bgeu, &a .+8;  &ld [$scr1 +  &TRAPTR_FIRST], $ptr;  &set  &panicstr, $scr2;  &ld [$scr2], $scr2;  &tst $scr2;  &bz, &a .+8;  &st $ptr, [$scr1]);
	}' unless defined(&TRACE_NEXT);
	if(defined(&TRAPTRACE)) {
	    eval 'sub TRACE_UNFL {
	        my($code, $addr, $scr1, $scr2, $scr3) = @_;
    		eval q( &TRACE_PTR($scr1, $scr2);  &set $code, $scr2;  &st $scr2, [$scr1 +  &TRAP_ENT_TBR];  &mov % &psr, $scr2;  &st $scr2, [$scr1 +  &TRAP_ENT_PSR];  &st % &g0, [$scr1 +  &TRAP_ENT_PC];  &st $addr, [$scr1 +  &TRAP_ENT_SP];  &st % &g0, [$scr1 +  &TRAP_ENT_G7];  &TRACE_NEXT($scr1, $scr2, $scr3));
	    }' unless defined(&TRACE_UNFL);
	} else {
	    eval 'sub TRACE_UNFL {
	        my($code, $addr, $scr1, $scr2, $scr3) = @_;
    		eval q();
	    }' unless defined(&TRACE_UNFL);
	}
	eval 'sub TRACE_OVFL () { &TRACE_UNFL;}' unless defined(&TRACE_OVFL);
    }
    eval 'sub TT_OV_USR () {0x51;}' unless defined(&TT_OV_USR);
    eval 'sub TT_OV_SYS () {0x52;}' unless defined(&TT_OV_SYS);
    eval 'sub TT_OV_SHR () {0x53;}' unless defined(&TT_OV_SHR);
    eval 'sub TT_OV_SHRK () {0x54;}' unless defined(&TT_OV_SHRK);
    eval 'sub TT_OV_BUF () {0x55;}' unless defined(&TT_OV_BUF);
    eval 'sub TT_OV_BUFK () {0x56;}' unless defined(&TT_OV_BUFK);
    eval 'sub TT_UF_USR () {0x61;}' unless defined(&TT_UF_USR);
    eval 'sub TT_UF_SYS () {0x62;}' unless defined(&TT_UF_SYS);
    eval 'sub TT_UF_FAULT () {0x63;}' unless defined(&TT_UF_FAULT);
    eval 'sub TT_SC_RET () {0x881;}' unless defined(&TT_SC_RET);
    eval 'sub TT_SC_POST () {0x882;}' unless defined(&TT_SC_POST);
    eval 'sub TT_SC_TRAP () {0x883;}' unless defined(&TT_SC_TRAP);
    eval 'sub TT_SYS_RTT () {0x6666;}' unless defined(&TT_SYS_RTT);
    eval 'sub TT_SYS_RTTU () {0x7777;}' unless defined(&TT_SYS_RTTU);
    eval 'sub TT_INTR_ENT () {-1;}' unless defined(&TT_INTR_ENT);
    eval 'sub TT_INTR_RET () {-2;}' unless defined(&TT_INTR_RET);
    eval 'sub TT_INTR_RET2 () {-3;}' unless defined(&TT_INTR_RET2);
    eval 'sub TT_INTR_EXIT () {0x8888;}' unless defined(&TT_INTR_EXIT);
    if(defined(&__cplusplus)) {
    }
}
1;
