require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MACHTRAP_H)) {
    eval 'sub _SYS_MACHTRAP_H () {1;}' unless defined(&_SYS_MACHTRAP_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub T_POR () {0x1;}' unless defined(&T_POR);
    eval 'sub T_WDR () {0x2;}' unless defined(&T_WDR);
    eval 'sub T_XIR () {0x3;}' unless defined(&T_XIR);
    eval 'sub T_SIR () {0x4;}' unless defined(&T_SIR);
    eval 'sub T_RED_EXCEPTION () {0x5;}' unless defined(&T_RED_EXCEPTION);
    eval 'sub T_INSTR_EXCEPTION () {0x8;}' unless defined(&T_INSTR_EXCEPTION);
    eval 'sub T_INSTR_MMU_MISS () {0x9;}' unless defined(&T_INSTR_MMU_MISS);
    eval 'sub T_INSTR_ERROR () {0xa;}' unless defined(&T_INSTR_ERROR);
    eval 'sub T_UNIMP_INSTR () {0x10;}' unless defined(&T_UNIMP_INSTR);
    eval 'sub T_PRIV_INSTR () {0x11;}' unless defined(&T_PRIV_INSTR);
    eval 'sub T_FP_DISABLED () {0x20;}' unless defined(&T_FP_DISABLED);
    eval 'sub T_FP_EXCEPTION_IEEE () {0x21;}' unless defined(&T_FP_EXCEPTION_IEEE);
    eval 'sub T_FP_EXCEPTION_OTHER () {0x22;}' unless defined(&T_FP_EXCEPTION_OTHER);
    eval 'sub T_TAG_OVERFLOW () {0x23;}' unless defined(&T_TAG_OVERFLOW);
    eval 'sub T_CLEAN_WINDOW () {0x24;}' unless defined(&T_CLEAN_WINDOW);
    eval 'sub T_IDIV0 () {0x28;}' unless defined(&T_IDIV0);
    eval 'sub T_DATA_EXCEPTION () {0x30;}' unless defined(&T_DATA_EXCEPTION);
    eval 'sub T_DATA_MMU_MISS () {0x31;}' unless defined(&T_DATA_MMU_MISS);
    eval 'sub T_DATA_ERROR () {0x32;}' unless defined(&T_DATA_ERROR);
    eval 'sub T_DATA_PROT () {0x33;}' unless defined(&T_DATA_PROT);
    eval 'sub T_ALIGNMENT () {0x34;}' unless defined(&T_ALIGNMENT);
    eval 'sub T_LDDF_ALIGN () {0x35;}' unless defined(&T_LDDF_ALIGN);
    eval 'sub T_STDF_ALIGN () {0x36;}' unless defined(&T_STDF_ALIGN);
    eval 'sub T_PRIV_ACTION () {0x37;}' unless defined(&T_PRIV_ACTION);
    eval 'sub T_ASYNC_ERROR () {0x40;}' unless defined(&T_ASYNC_ERROR);
    eval 'sub T_INT_LEVEL_1 () {0x41;}' unless defined(&T_INT_LEVEL_1);
    eval 'sub T_INT_LEVEL_2 () {0x42;}' unless defined(&T_INT_LEVEL_2);
    eval 'sub T_INT_LEVEL_3 () {0x43;}' unless defined(&T_INT_LEVEL_3);
    eval 'sub T_INT_LEVEL_4 () {0x44;}' unless defined(&T_INT_LEVEL_4);
    eval 'sub T_INT_LEVEL_5 () {0x45;}' unless defined(&T_INT_LEVEL_5);
    eval 'sub T_INT_LEVEL_6 () {0x46;}' unless defined(&T_INT_LEVEL_6);
    eval 'sub T_INT_LEVEL_7 () {0x47;}' unless defined(&T_INT_LEVEL_7);
    eval 'sub T_INT_LEVEL_8 () {0x48;}' unless defined(&T_INT_LEVEL_8);
    eval 'sub T_INT_LEVEL_9 () {0x49;}' unless defined(&T_INT_LEVEL_9);
    eval 'sub T_INT_LEVEL_10 () {0x4a;}' unless defined(&T_INT_LEVEL_10);
    eval 'sub T_INT_LEVEL_11 () {0x4b;}' unless defined(&T_INT_LEVEL_11);
    eval 'sub T_INT_LEVEL_12 () {0x4c;}' unless defined(&T_INT_LEVEL_12);
    eval 'sub T_INT_LEVEL_13 () {0x4d;}' unless defined(&T_INT_LEVEL_13);
    eval 'sub T_INT_LEVEL_14 () {0x4e;}' unless defined(&T_INT_LEVEL_14);
    eval 'sub T_INT_LEVEL_15 () {0x4f;}' unless defined(&T_INT_LEVEL_15);
    eval 'sub T_PA_WATCHPOINT () {0x61;}' unless defined(&T_PA_WATCHPOINT);
    eval 'sub T_VA_WATCHPOINT () {0x62;}' unless defined(&T_VA_WATCHPOINT);
    eval 'sub T_WIN_OVERFLOW () {0x80;}' unless defined(&T_WIN_OVERFLOW);
    eval 'sub T_WIN_UNDERFLOW () {0xc0;}' unless defined(&T_WIN_UNDERFLOW);
    eval 'sub T_TL1 () {0x200;}' unless defined(&T_TL1);
    eval 'sub T_SOFTWARE_TRAP () {0x100;}' unless defined(&T_SOFTWARE_TRAP);
    eval 'sub T_ESOFTWARE_TRAP () {0x1ff;}' unless defined(&T_ESOFTWARE_TRAP);
    eval 'sub T_OSYSCALL () {( &T_SOFTWARE_TRAP +  &ST_OSYSCALL);}' unless defined(&T_OSYSCALL);
    eval 'sub T_BREAKPOINT () {( &T_SOFTWARE_TRAP +  &ST_BREAKPOINT);}' unless defined(&T_BREAKPOINT);
    eval 'sub T_DIV0 () {( &T_SOFTWARE_TRAP +  &ST_DIV0);}' unless defined(&T_DIV0);
    eval 'sub T_FLUSH_WINDOWS () {( &T_SOFTWARE_TRAP +  &ST_FLUSH_WINDOWS);}' unless defined(&T_FLUSH_WINDOWS);
    eval 'sub T_CLEAN_WINDOWS () {( &T_SOFTWARE_TRAP +  &ST_CLEAN_WINDOWS);}' unless defined(&T_CLEAN_WINDOWS);
    eval 'sub T_RANGE_CHECK () {( &T_SOFTWARE_TRAP +  &ST_RANGE_CHECK);}' unless defined(&T_RANGE_CHECK);
    eval 'sub T_FIX_ALIGN () {( &T_SOFTWARE_TRAP +  &ST_FIX_ALIGN);}' unless defined(&T_FIX_ALIGN);
    eval 'sub T_INT_OVERFLOW () {( &T_SOFTWARE_TRAP +  &ST_INT_OVERFLOW);}' unless defined(&T_INT_OVERFLOW);
    eval 'sub T_SYSCALL () {( &T_SOFTWARE_TRAP +  &ST_SYSCALL);}' unless defined(&T_SYSCALL);
    eval 'sub T_GETCC () {( &T_SOFTWARE_TRAP +  &ST_GETCC);}' unless defined(&T_GETCC);
    eval 'sub T_SETCC () {( &T_SOFTWARE_TRAP +  &ST_SETCC);}' unless defined(&T_SETCC);
    eval 'sub T_HOTPATCH_TRAP () {( &T_SOFTWARE_TRAP +  &ST_HOTPATCH_TRAP);}' unless defined(&T_HOTPATCH_TRAP);
    eval 'sub T_AST () {0x200;}' unless defined(&T_AST);
    eval 'sub T_FLUSH_PCB () {( &T_AST + 0x10);}' unless defined(&T_FLUSH_PCB);
    eval 'sub T_SYS_RTT_PAGE () {( &T_AST + 0x20);}' unless defined(&T_SYS_RTT_PAGE);
    eval 'sub T_SYS_RTT_ALIGN () {( &T_AST + 0x30);}' unless defined(&T_SYS_RTT_ALIGN);
    eval 'sub T_USER () {0x10000;}' unless defined(&T_USER);
    if(defined(&__cplusplus)) {
    }
}
1;
