require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MUTEX_IMPL_H)) {
    eval 'sub _SYS_MUTEX_IMPL_H () {1;}' unless defined(&_SYS_MUTEX_IMPL_H);
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
	require 'sys/machlock.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	unless(defined(&_LP64)) {
	}
	if(defined(&_LP64)) {
	} else {
	}
	eval 'sub m_owner () { ($m_adaptive->{_m_owner});}' unless defined(&m_owner);
	eval 'sub MUTEX_WAITERS () {0x1;}' unless defined(&MUTEX_WAITERS);
	eval 'sub MUTEX_DEAD () {0x6;}' unless defined(&MUTEX_DEAD);
	eval 'sub MUTEX_THREAD () {(-0x8);}' unless defined(&MUTEX_THREAD);
	eval 'sub MUTEX_OWNER {
	    my($lp) = @_;
    	    eval q((( &kthread_id_t)(($lp)-> &m_owner &  &MUTEX_THREAD)));
	}' unless defined(&MUTEX_OWNER);
	eval 'sub MUTEX_NO_OWNER () {(( &kthread_id_t) &NULL);}' unless defined(&MUTEX_NO_OWNER);
	eval 'sub MUTEX_SET_WAITERS {
	    my($lp) = @_;
    	    eval q({  &uintptr_t  &old;  &while (( &old = ($lp)-> &m_owner) != 0 &&  &casip(($lp)-> &m_owner,  &old,  &old |  &MUTEX_WAITERS) !=  &old)  &continue; });
	}' unless defined(&MUTEX_SET_WAITERS);
	eval 'sub MUTEX_HAS_WAITERS {
	    my($lp) = @_;
    	    eval q((($lp)-> &m_owner &  &MUTEX_WAITERS));
	}' unless defined(&MUTEX_HAS_WAITERS);
	eval 'sub MUTEX_CLEAR_LOCK_AND_WAITERS {
	    my($lp) = @_;
    	    eval q(($lp)-> &m_owner = 0);
	}' unless defined(&MUTEX_CLEAR_LOCK_AND_WAITERS);
	eval 'sub MUTEX_SET_TYPE {
	    my($lp, $type) = @_;
    	    eval q();
	}' unless defined(&MUTEX_SET_TYPE);
	eval 'sub MUTEX_TYPE_ADAPTIVE {
	    my($lp) = @_;
    	    eval q(((($lp)-> &m_owner &  &MUTEX_DEAD) == 0));
	}' unless defined(&MUTEX_TYPE_ADAPTIVE);
	eval 'sub MUTEX_TYPE_SPIN {
	    my($lp) = @_;
    	    eval q((($lp)-> ($m_spin->{m_dummylock}) ==  &LOCK_HELD_VALUE));
	}' unless defined(&MUTEX_TYPE_SPIN);
	eval 'sub MUTEX_DESTROY {
	    my($lp) = @_;
    	    eval q(($lp)-> &m_owner = (( &uintptr_t) &curthread |  &MUTEX_DEAD));
	}' unless defined(&MUTEX_DESTROY);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
