require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_TRAPTRACE_H)) {
    eval 'sub _SYS_TRAPTRACE_H () {1;}' unless defined(&_SYS_TRAPTRACE_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&__sparcv9)) {
	eval 'sub TRAP_TPGS () {(2*  &PAGESIZE);}' unless defined(&TRAP_TPGS);
    } else {
	eval 'sub TRAP_TPGS () {( &PAGESIZE);}' unless defined(&TRAP_TPGS);
    }
    unless(defined(&_ASM)) {
	eval 'sub TRAP_TSIZE () {(( &TRAP_TPGS / $sizeof{\'struct trap_trace_record\'}) * $sizeof{\'struct trap_trace_record\'});}' unless defined(&TRAP_TSIZE);
    } else {
	eval 'sub TRAP_TSIZE () {(( &TRAP_TPGS /  &TRAP_ENT_SIZE) *  &TRAP_ENT_SIZE);}' unless defined(&TRAP_TSIZE);
    }
    unless(defined(&_ASM)) {
	if(defined(&__sparcv9)) {
	} else {
	}
	if(defined(&_KERNEL)) {
	}
	eval 'sub TRAPTRACE_FREEZE () { &trap_freeze = 1;;}' unless defined(&TRAPTRACE_FREEZE);
	eval 'sub TRAPTRACE_UNFREEZE () { &trap_freeze = 0;;}' unless defined(&TRAPTRACE_UNFREEZE);
    } else {
	require 'sys/machthread.ph';
	if(defined(&__sparcv9)) {
	    eval 'sub TRAPTR_VBASE () {0;}' unless defined(&TRAPTR_VBASE);
	    eval 'sub TRAPTR_LAST_OFFSET () {16;}' unless defined(&TRAPTR_LAST_OFFSET);
	    eval 'sub TRAPTR_OFFSET () {20;}' unless defined(&TRAPTR_OFFSET);
	    eval 'sub TRAPTR_LIMIT () {24;}' unless defined(&TRAPTR_LIMIT);
	    eval 'sub TRAPTR_PBASE () {8;}' unless defined(&TRAPTR_PBASE);
	    eval 'sub TRAPTR_ASIBUF () {28;}' unless defined(&TRAPTR_ASIBUF);
	} else {
	    eval 'sub TRAPTR_VBASE () {0;}' unless defined(&TRAPTR_VBASE);
	    eval 'sub TRAPTR_LAST_OFFSET () {4;}' unless defined(&TRAPTR_LAST_OFFSET);
	    eval 'sub TRAPTR_OFFSET () {8;}' unless defined(&TRAPTR_OFFSET);
	    eval 'sub TRAPTR_LIMIT () {12;}' unless defined(&TRAPTR_LIMIT);
	    eval 'sub TRAPTR_PBASE () {16;}' unless defined(&TRAPTR_PBASE);
	    eval 'sub TRAPTR_ASIBUF () {24;}' unless defined(&TRAPTR_ASIBUF);
	}
	eval 'sub TRAPTR_SIZE_SHIFT () {6;}' unless defined(&TRAPTR_SIZE_SHIFT);
	eval 'sub TRAPTR_SIZE () {(1<< &TRAPTR_SIZE_SHIFT);}' unless defined(&TRAPTR_SIZE);
	eval 'sub TRAPTR_ASI () { &ASI_MEM;}' unless defined(&TRAPTR_ASI);
	if(defined(&TRAPTRACE_FORCE_TICK)) {
	    eval 'sub GET_TRACE_TICK {
	        my($reg) = @_;
    		eval q( &rdpr % &tick, $reg;);
	    }' unless defined(&GET_TRACE_TICK);
	} else {
	    eval 'sub GET_TRACE_TICK {
	        my($reg) = @_;
    		eval q( &sethi % &hi( &traptrace_use_stick), $reg;  &lduw [$reg + % &lo( &traptrace_use_stick)], $reg;  &brz, &a $reg, .+12;  &rdpr % &tick, $reg;  &rd % &asr24, $reg;);
	    }' unless defined(&GET_TRACE_TICK);
	}
	eval 'sub TRACE_PTR {
	    my($ptr, $scr1) = @_;
    	    eval q( &rdpr % &pstate, $scr1;  &and $scr1,  &PSTATE_IE |  &PSTATE_AM, $scr1;  &brz, &pt $scr1, .+20;  &nop;  &sethi % &hi( &trap_trace_msg), % &o0;  &call  &prom_panic;  &or % &o0, % &lo( &trap_trace_msg), % &o0;  &CPU_INDEX($scr1, $ptr);  &sll $scr1,  &TRAPTR_SIZE_SHIFT, $scr1;  &set  &trap_trace_ctl, $ptr;  &add $ptr, $scr1, $scr1;  &rd % &asi, $ptr;  &stb $ptr, [$scr1 +  &TRAPTR_ASIBUF];  &ld [$scr1 +  &TRAPTR_LIMIT], $ptr;  &brnz, &pt $ptr, .+20;  &nop;  &sethi % &hi( &trap_trace_msg), % &o0;  &call  &prom_panic;  &or % &o0, % &lo( &trap_trace_msg), % &o0;  &ldx [$scr1 +  &TRAPTR_PBASE], $ptr;  &ld [$scr1 +  &TRAPTR_OFFSET], $scr1;  &wr % &g0,  &TRAPTR_ASI, % &asi;  &add $ptr, $scr1, $ptr;);
	}' unless defined(&TRACE_PTR);
	eval 'sub TRACE_NEXT {
	    my($scr1, $scr2, $scr3) = @_;
    	    eval q( &CPU_INDEX($scr2, $scr1);  &sll $scr2,  &TRAPTR_SIZE_SHIFT, $scr2;  &set  &trap_trace_ctl, $scr1;  &add $scr1, $scr2, $scr2;  &ldub [$scr2 +  &TRAPTR_ASIBUF], $scr1;  &wr % &g0, $scr1, % &asi;  &sethi % &hi( &trap_freeze), $scr1;  &ld [$scr1 + % &lo( &trap_freeze)], $scr1;  &brnz $scr1, .+36;  &ld [$scr2 +  &TRAPTR_OFFSET], $scr1;  &ld [$scr2 +  &TRAPTR_LIMIT], $scr3;  &st $scr1, [$scr2 +  &TRAPTR_LAST_OFFSET];  &add $scr1,  &TRAP_ENT_SIZE, $scr1;  &sub $scr3,  &TRAP_ENT_SIZE, $scr3;  &cmp $scr1, $scr3;  &movge % &icc, 0, $scr1;  &st $scr1, [$scr2 +  &TRAPTR_OFFSET];);
	}' unless defined(&TRACE_NEXT);
	eval 'sub TRACE_RTT {
	    my($code, $scr1, $scr2, $scr3, $scr4) = @_;
    	    eval q( &rdpr % &pstate, $scr4;  &andn $scr4,  &PSTATE_IE |  &PSTATE_AM, $scr3;  &wrpr % &g0, $scr3, % &pstate;  &TRACE_PTR($scr1, $scr2);  &GET_TRACE_TICK($scr2);  &stxa $scr2, [$scr1 +  &TRAP_ENT_TICK]% &asi;  &rdpr % &tl, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TL]% &asi;  &set $code, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TT]% &asi;  &ldn [% &l7 +  &PC_OFF], $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_TPC]% &asi;  &ldx [% &l7 +  &TSTATE_OFF], $scr2;  &stxa $scr2, [$scr1 +  &TRAP_ENT_TSTATE]% &asi;  &stna % &sp, [$scr1 +  &TRAP_ENT_SP]% &asi;  &stna % &l6, [$scr1 +  &TRAP_ENT_TR]% &asi;  &stna % &l7, [$scr1 +  &TRAP_ENT_F1]% &asi;  &ldn [ &THREAD_REG +  &T_CPU], $scr2;  &ld [$scr2 +  &CPU_BASE_SPL], $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_F2]% &asi;  &mov  &MMU_SCONTEXT, $scr2;  &ldxa [$scr2] &ASI_DMMU, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_F3]% &asi;  &rdpr % &cwp, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_F4]% &asi;  &TRACE_NEXT($scr1, $scr2, $scr3);  &wrpr % &g0, $scr4, % &pstate);
	}' unless defined(&TRACE_RTT);
	eval 'sub TRACE_WIN_INFO {
	    my($code, $scr1, $scr2, $scr3) = @_;
    	    eval q( &TRACE_PTR($scr1, $scr2);  &GET_TRACE_TICK($scr2);  &stxa $scr2, [$scr1 +  &TRAP_ENT_TICK]% &asi;  &rdpr % &tl, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TL]% &asi;  &rdpr % &tt, $scr2;  &set $code, $scr3;  &or $scr2, $scr3, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TT]% &asi;  &rdpr % &tstate, $scr2;  &stxa $scr2, [$scr1 +  &TRAP_ENT_TSTATE]% &asi;  &stna % &sp, [$scr1 +  &TRAP_ENT_SP]% &asi;  &rdpr % &tpc, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_TPC]% &asi;  &set  &TT_FSPILL_DEBUG, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_TR]% &asi;  &rdpr % &pstate, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_F1]% &asi;  &rdpr % &cwp, $scr2;  &sll $scr2, 24, $scr2;  &rdpr % &cansave, $scr3;  &sll $scr3, 16, $scr3;  &or $scr2, $scr3, $scr2;  &rdpr % &canrestore, $scr3;  &or $scr2, $scr3, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_F2]% &asi;  &rdpr % &otherwin, $scr2;  &sll $scr2, 24, $scr2;  &rdpr % &cleanwin, $scr3;  &sll $scr3, 16, $scr3;  &or $scr2, $scr3, $scr2;  &rdpr % &wstate, $scr3;  &or $scr2, $scr3, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_F3]% &asi;  &stna % &o7, [$scr1 +  &TRAP_ENT_F4]% &asi;  &TRACE_NEXT($scr1, $scr2, $scr3));
	}' unless defined(&TRACE_WIN_INFO);
	eval 'sub TRACE_WINTRAP () { &rd % &asi, % &l3;  &TRACE_PTR(% &l1, % &l2);  &GET_TRACE_TICK(% &l2);  &stxa % &l2, [% &l1 +  &TRAP_ENT_TICK]% &asi;  &rdpr % &tl, % &l2;  &stha % &l2, [% &l1 +  &TRAP_ENT_TL]% &asi;  &rdpr % &tt, % &l2;  &stha % &l2, [% &l1 +  &TRAP_ENT_TT]% &asi;  &rdpr % &tpc, % &l2;  &stna % &l2, [% &l1 +  &TRAP_ENT_TPC]% &asi;  &rdpr % &tstate, % &l2;  &stxa % &l2, [% &l1 +  &TRAP_ENT_TSTATE]% &asi;  &stna % &sp, [% &l1 +  &TRAP_ENT_SP]% &asi;  &stna % &l3, [% &l1 +  &TRAP_ENT_TR]% &asi;  &rdpr % &cansave, % &l2;  &stba % &l2, [% &l1 +  &TRAP_ENT_F1]% &asi;  &rdpr % &canrestore, % &l2;  &stba % &l2, [% &l1 +  &TRAP_ENT_F1 + 1]% &asi;  &rdpr % &otherwin, % &l2;  &stba % &l2, [% &l1 +  &TRAP_ENT_F1 + 2]% &asi;  &rdpr % &wstate, % &l2;  &stba % &l2, [% &l1 +  &TRAP_ENT_F1 + 3]% &asi;  &stna % &l0, [% &l1 +  &TRAP_ENT_F2]% &asi;  &stna % &g0, [% &l1 +  &TRAP_ENT_F3]% &asi;  &stna % &g0, [% &l1 +  &TRAP_ENT_F4]% &asi;  &TRACE_NEXT(% &l1, % &l2, % &l3);}' unless defined(&TRACE_WINTRAP);
	if(defined(&TRAPTRACE)) {
	    eval 'sub FAULT_WINTRACE {
	        my($scr1, $scr2, $scr3, $type) = @_;
    		eval q( &TRACE_PTR($scr1, $scr2);  &GET_TRACE_TICK($scr2);  &stxa $scr2, [$scr1 +  &TRAP_ENT_TICK]% &asi;  &rdpr % &tl, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TL]% &asi;  &set $type, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TT]% &asi;  &rdpr % &tpc, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_TPC]% &asi;  &rdpr % &tstate, $scr2;  &stxa $scr2, [$scr1 +  &TRAP_ENT_TSTATE]% &asi;  &stna % &sp, [$scr1 +  &TRAP_ENT_SP]% &asi;  &stna % &g0, [$scr1 +  &TRAP_ENT_TR]% &asi;  &stna % &g0, [$scr1 +  &TRAP_ENT_F1]% &asi;  &stna % &g4, [$scr1 +  &TRAP_ENT_F2]% &asi;  &rdpr % &pil, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_F3]% &asi;  &stna % &g0, [$scr1 +  &TRAP_ENT_F4]% &asi;  &TRACE_NEXT($scr1, $scr2, $scr3));
	    }' unless defined(&FAULT_WINTRACE);
	    eval 'sub CLEAN_WINDOW_TRACE () { &sethi % &hi( &win_trace), % &l0;  &jmpl % &l0 + % &lo( &win_trace), % &l0;  &nop;}' unless defined(&CLEAN_WINDOW_TRACE);
	    eval 'sub WIN_TRACE () { &sethi % &hi( &win_trace), % &l0;  &jmpl % &l0 + % &lo( &win_trace), % &l0;  &nop;}' unless defined(&WIN_TRACE);
	    eval 'sub MMU_TRACE {
	        my($scr1, $scr2, $scr3) = @_;
    		eval q( &rd % &asi, $scr3;  &TRACE_PTR($scr1, $scr2);  &GET_TRACE_TICK($scr2);  &stxa $scr2, [$scr1 +  &TRAP_ENT_TICK]% &asi;  &rdpr % &tl, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TL]% &asi;  &rdpr % &tt, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TT]% &asi;  &rdpr % &tpc, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_TPC]% &asi;  &rdpr % &tstate, $scr2;  &stxa $scr2, [$scr1 +  &TRAP_ENT_TSTATE]% &asi;  &stna % &sp, [$scr1 +  &TRAP_ENT_SP]% &asi;  &wr % &g0, $scr3, % &asi;  &ldxa [ &MMU_TAG_ACCESS]% &asi, $scr2;  &wr % &g0,  &TRAPTR_ASI, % &asi;  &stna $scr2, [$scr1 +  &TRAP_ENT_F1]% &asi;  &stna % &g0, [$scr1 +  &TRAP_ENT_F2]% &asi;  &rdpr % &cansave, $scr2;  &stba $scr2, [$scr1 +  &TRAP_ENT_F3]% &asi;  &rdpr % &canrestore, $scr2;  &stba $scr2, [$scr1 +  &TRAP_ENT_F3 + 1]% &asi;  &rdpr % &otherwin, $scr2;  &stba $scr2, [$scr1 +  &TRAP_ENT_F3 + 2]% &asi;  &rdpr % &wstate, $scr2;  &stba $scr2, [$scr1 +  &TRAP_ENT_F3 + 3]% &asi;  &stna % &g0, [$scr1 +  &TRAP_ENT_F4]% &asi;  &TRACE_NEXT($scr1, $scr2, $scr3));
	    }' unless defined(&MMU_TRACE);
	    eval 'sub SYSTRAP_TT () {0x1300;}' unless defined(&SYSTRAP_TT);
	    eval 'sub SYSTRAP_TRACE {
	        my($scr1, $scr2, $scr3) = @_;
    		eval q( &TRACE_PTR($scr1, $scr2);  &GET_TRACE_TICK($scr2);  &stxa $scr2, [$scr1 +  &TRAP_ENT_TICK]% &asi;  &rdpr % &tl, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TL]% &asi;  &set  &SYSTRAP_TT, $scr3;  &rdpr % &tt, $scr2;  &or $scr3, $scr2, $scr2;  &stha $scr2, [$scr1 +  &TRAP_ENT_TT]% &asi;  &rdpr % &tpc, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_TPC]% &asi;  &rdpr % &tstate, $scr2;  &stxa $scr2, [$scr1 +  &TRAP_ENT_TSTATE]% &asi;  &stna % &g1, [$scr1 +  &TRAP_ENT_SP]% &asi;  &stna % &g2, [$scr1 +  &TRAP_ENT_TR]% &asi;  &stna % &g3, [$scr1 +  &TRAP_ENT_F1]% &asi;  &stna % &g4, [$scr1 +  &TRAP_ENT_F2]% &asi;  &rdpr % &pil, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_F3]% &asi;  &rdpr % &cwp, $scr2;  &stna $scr2, [$scr1 +  &TRAP_ENT_F4]% &asi;  &TRACE_NEXT($scr1, $scr2, $scr3));
	    }' unless defined(&SYSTRAP_TRACE);
	} else {
	    eval 'sub FAULT_WINTRACE {
	        my($scr1, $scr2, $scr3, $type) = @_;
    		eval q();
	    }' unless defined(&FAULT_WINTRACE);
	    eval 'sub CLEAN_WINDOW_TRACE () {1;}' unless defined(&CLEAN_WINDOW_TRACE);
	    eval 'sub WIN_TRACE () {1;}' unless defined(&WIN_TRACE);
	    eval 'sub MMU_TRACE () {1;}' unless defined(&MMU_TRACE);
	    eval 'sub SYSTRAP_TRACE {
	        my($scr1, $scr2, $scr3) = @_;
    		eval q();
	    }' unless defined(&SYSTRAP_TRACE);
	}
    }
    eval 'sub TT_F32_SN0 () {0x1084;}' unless defined(&TT_F32_SN0);
    eval 'sub TT_F64_SN0 () {0x1088;}' unless defined(&TT_F64_SN0);
    eval 'sub TT_F32_NT0 () {0x1094;}' unless defined(&TT_F32_NT0);
    eval 'sub TT_F64_NT0 () {0x1098;}' unless defined(&TT_F64_NT0);
    eval 'sub TT_F32_SO0 () {0x10a4;}' unless defined(&TT_F32_SO0);
    eval 'sub TT_F64_SO0 () {0x10a8;}' unless defined(&TT_F64_SO0);
    eval 'sub TT_F32_FN0 () {0x10c4;}' unless defined(&TT_F32_FN0);
    eval 'sub TT_F64_FN0 () {0x10c8;}' unless defined(&TT_F64_FN0);
    eval 'sub TT_F32_SN1 () {0x1284;}' unless defined(&TT_F32_SN1);
    eval 'sub TT_F64_SN1 () {0x1288;}' unless defined(&TT_F64_SN1);
    eval 'sub TT_F32_NT1 () {0x1294;}' unless defined(&TT_F32_NT1);
    eval 'sub TT_F64_NT1 () {0x1298;}' unless defined(&TT_F64_NT1);
    eval 'sub TT_F32_SO1 () {0x12a4;}' unless defined(&TT_F32_SO1);
    eval 'sub TT_F64_SO1 () {0x12a8;}' unless defined(&TT_F64_SO1);
    eval 'sub TT_F32_FN1 () {0x12c4;}' unless defined(&TT_F32_FN1);
    eval 'sub TT_F64_FN1 () {0x12c8;}' unless defined(&TT_F64_FN1);
    eval 'sub TT_SC_ENTR () {0x880;}' unless defined(&TT_SC_ENTR);
    eval 'sub TT_SC_RET () {0x881;}' unless defined(&TT_SC_RET);
    eval 'sub TT_SYS_RTT_PROM () {0x5555;}' unless defined(&TT_SYS_RTT_PROM);
    eval 'sub TT_SYS_RTT_PRIV () {0x6666;}' unless defined(&TT_SYS_RTT_PRIV);
    eval 'sub TT_SYS_RTT_USER () {0x7777;}' unless defined(&TT_SYS_RTT_USER);
    eval 'sub TT_INTR_EXIT () {0x8888;}' unless defined(&TT_INTR_EXIT);
    eval 'sub TT_FSPILL_DEBUG () {0x9999;}' unless defined(&TT_FSPILL_DEBUG);
    eval 'sub TT_SERVE_INTR () {0x6000;}' unless defined(&TT_SERVE_INTR);
    eval 'sub TT_XCALL () {0xd000;}' unless defined(&TT_XCALL);
    eval 'sub TT_XCALL_CONT () {0xdc00;}' unless defined(&TT_XCALL_CONT);
    if(defined(&__cplusplus)) {
    }
}
1;
