require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VM_ANON_H)) {
    eval 'sub _VM_ANON_H () {1;}' unless defined(&_VM_ANON_H);
    require 'sys/cred.ph';
    require 'vm/seg.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub ANON_HASH_SIZE () { &anon_hash_size;}' unless defined(&ANON_HASH_SIZE);
	eval 'sub ANON_HASHAVELEN () {4;}' unless defined(&ANON_HASHAVELEN);
	eval 'sub ANON_HASH {
	    my($VP, $OFF) = @_;
    	    eval q((((( &uintptr_t)($VP) >> 7) ^ (($OFF) >>  &PAGESHIFT)) & ( &ANON_HASH_SIZE - 1)));
	}' unless defined(&ANON_HASH);
	eval 'sub AH_LOCK_SIZE () {64;}' unless defined(&AH_LOCK_SIZE);
	eval 'sub AH_LOCK {
	    my($vp, $off) = @_;
    	    eval q(( &ANON_HASH(($vp), ($off)) & ( &AH_LOCK_SIZE -1)));
	}' unless defined(&AH_LOCK);
    }
    if(defined(&_SYSCALL32)) {
    }
    eval 'sub ANI_MAX_POOL () {8;}' unless defined(&ANI_MAX_POOL);
    eval 'sub ANI_ADD {
        my($inc) = @_;
	    eval q({  &ani_free_t * &anifp; \'int\'  &index;  &index = ( ($CPU->{cpu_id}) & ( &ANI_MAX_POOL - 1));  &anifp =  $ani_free_pool[ &index];  &mutex_enter( ($anifp->{ani_lock}));  ($anifp->{ani_count}) += $inc;  &mutex_exit( ($anifp->{ani_lock})); });
    }' unless defined(&ANI_ADD);
    if(defined(&_LP64)) {
	eval 'sub ANON_PTRSHIFT () {3;}' unless defined(&ANON_PTRSHIFT);
    } else {
	eval 'sub ANON_PTRSHIFT () {2;}' unless defined(&ANON_PTRSHIFT);
    }
    eval 'sub ANON_CHUNK_SIZE () {( &PAGESIZE >>  &ANON_PTRSHIFT);}' unless defined(&ANON_CHUNK_SIZE);
    eval 'sub ANON_CHUNK_SHIFT () {( &PAGESHIFT -  &ANON_PTRSHIFT);}' unless defined(&ANON_CHUNK_SHIFT);
    eval 'sub ANON_CHUNK_OFF () {( &ANON_CHUNK_SIZE - 1);}' unless defined(&ANON_CHUNK_OFF);
    eval 'sub ANON_SLEEP () {0x;}' unless defined(&ANON_SLEEP);
    eval 'sub ANON_NOSLEEP () {0x1;}' unless defined(&ANON_NOSLEEP);
    eval 'sub ANON_ALLOC_FORCE () {0x2;}' unless defined(&ANON_ALLOC_FORCE);
    if(defined(&_KERNEL)) {
	eval 'sub TOTAL_AVAILABLE_SWAP () {( ($k_anoninfo->{ani_max}) +  &MAX(( &spgcnt_t)( &availrmem -  &swapfs_minfree), 0));}' unless defined(&TOTAL_AVAILABLE_SWAP);
	eval 'sub CURRENT_TOTAL_AVAILABLE_SWAP () {(( ($k_anoninfo->{ani_max}) -  ($k_anoninfo->{ani_phys_resv})) +  &MAX(( &spgcnt_t)( &availrmem -  &swapfs_minfree), 0));}' unless defined(&CURRENT_TOTAL_AVAILABLE_SWAP);
	if(defined( &__STDC__) ) {
	}
	eval 'sub anon_resv {
	    my($size) = @_;
    	    eval q( &anon_resvmem(($size), 1));
	}' unless defined(&anon_resv);
	eval 'sub anon_checkspace {
	    my($size) = @_;
    	    eval q( &anon_resvmem(($size), 0));
	}' unless defined(&anon_checkspace);
	eval 'sub STEAL_PAGE () {0x1;}' unless defined(&STEAL_PAGE);
	eval 'sub LOCK_PAGE () {0x2;}' unless defined(&LOCK_PAGE);
	if(defined(&ANON_DEBUG)) {
	    eval 'sub A_ANON () {0x1;}' unless defined(&A_ANON);
	    eval 'sub A_RESV () {0x2;}' unless defined(&A_RESV);
	    eval 'sub A_MRESV () {0x4;}' unless defined(&A_MRESV);
	    eval 'sub ANON_PRINT {
	        my($f, $printf_args) = @_;
    		eval q( &if ( &anon_debug & $f)  &printf $printf_args);
	    }' unless defined(&ANON_PRINT);
	} else {
	    eval 'sub ANON_PRINT {
	        my($f, $printf_args) = @_;
    		eval q();
	    }' unless defined(&ANON_PRINT);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
