require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VM_HAT_H)) {
    eval 'sub _VM_HAT_H () {1;}' unless defined(&_VM_HAT_H);
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'vm/faultcode.ph';
    require 'sys/kstat.ph';
    require 'sys/siginfo.ph';
    if(defined(&__cplusplus)) {
    }
    require 'vm/page.ph';
    if(defined(&_KERNEL)) {
	eval("sub HAT_SHARED_PT () { 0; }") unless defined(&HAT_SHARED_PT);
	eval("sub HAT_DYNAMIC_ISM_UNMAP () { 1; }") unless defined(&HAT_DYNAMIC_ISM_UNMAP);
	eval 'sub HAT_FLAGS_RESV () {0xff000000;}' unless defined(&HAT_FLAGS_RESV);
	eval 'sub HAT_LOAD () {0x;}' unless defined(&HAT_LOAD);
	eval 'sub HAT_LOAD_LOCK () {0x1;}' unless defined(&HAT_LOAD_LOCK);
	eval 'sub HAT_LOAD_ADV () {0x4;}' unless defined(&HAT_LOAD_ADV);
	eval 'sub HAT_LOAD_CONTIG () {0x10;}' unless defined(&HAT_LOAD_CONTIG);
	eval 'sub HAT_LOAD_NOCONSIST () {0x20;}' unless defined(&HAT_LOAD_NOCONSIST);
	eval 'sub HAT_LOAD_SHARE () {0x40;}' unless defined(&HAT_LOAD_SHARE);
	eval 'sub HAT_LOAD_REMAP () {0x80;}' unless defined(&HAT_LOAD_REMAP);
	eval 'sub HAT_RELOAD_SHARE () {0x100;}' unless defined(&HAT_RELOAD_SHARE);
	eval 'sub HAT_PLAT_ATTR_MASK () {0xf00000;}' unless defined(&HAT_PLAT_ATTR_MASK);
	eval 'sub HAT_PROT_MASK () {0xf;}' unless defined(&HAT_PROT_MASK);
	eval 'sub HAT_NOFAULT () {0x10;}' unless defined(&HAT_NOFAULT);
	eval 'sub HAT_NOSYNC () {0x20;}' unless defined(&HAT_NOSYNC);
	eval 'sub HAT_STRICTORDER () {0x;}' unless defined(&HAT_STRICTORDER);
	eval 'sub HAT_UNORDERED_OK () {0x100;}' unless defined(&HAT_UNORDERED_OK);
	eval 'sub HAT_MERGING_OK () {0x200;}' unless defined(&HAT_MERGING_OK);
	eval 'sub HAT_LOADCACHING_OK () {0x300;}' unless defined(&HAT_LOADCACHING_OK);
	eval 'sub HAT_STORECACHING_OK () {0x400;}' unless defined(&HAT_STORECACHING_OK);
	eval 'sub HAT_ORDER_MASK () {0x700;}' unless defined(&HAT_ORDER_MASK);
	eval 'sub HAT_NEVERSWAP () {0x;}' unless defined(&HAT_NEVERSWAP);
	eval 'sub HAT_STRUCTURE_BE () {0x1000;}' unless defined(&HAT_STRUCTURE_BE);
	eval 'sub HAT_STRUCTURE_LE () {0x2000;}' unless defined(&HAT_STRUCTURE_LE);
	eval 'sub HAT_ENDIAN_MASK () {0x3000;}' unless defined(&HAT_ENDIAN_MASK);
	eval 'sub HAT_COW () {0x1;}' unless defined(&HAT_COW);
	eval 'sub HAT_UNLOAD () {0x;}' unless defined(&HAT_UNLOAD);
	eval 'sub HAT_UNLOAD_NOSYNC () {0x2;}' unless defined(&HAT_UNLOAD_NOSYNC);
	eval 'sub HAT_UNLOAD_UNLOCK () {0x4;}' unless defined(&HAT_UNLOAD_UNLOCK);
	eval 'sub HAT_UNLOAD_OTHER () {0x8;}' unless defined(&HAT_UNLOAD_OTHER);
	eval 'sub HAT_UNLOAD_UNMAP () {0x10;}' unless defined(&HAT_UNLOAD_UNMAP);
	eval 'sub HAT_SYNC_DONTZERO () {0x;}' unless defined(&HAT_SYNC_DONTZERO);
	eval 'sub HAT_SYNC_ZERORM () {0x1;}' unless defined(&HAT_SYNC_ZERORM);
	eval 'sub HAT_SYNC_STOPON_REF () {0x2;}' unless defined(&HAT_SYNC_STOPON_REF);
	eval 'sub HAT_SYNC_STOPON_MOD () {0x4;}' unless defined(&HAT_SYNC_STOPON_MOD);
	eval 'sub HAT_SYNC_STOPON_RM () {( &HAT_SYNC_STOPON_REF |  &HAT_SYNC_STOPON_MOD);}' unless defined(&HAT_SYNC_STOPON_RM);
	eval 'sub HAT_SYNC_STOPON_SHARED () {0x8;}' unless defined(&HAT_SYNC_STOPON_SHARED);
	eval 'sub HAT_DUP_ALL () {1;}' unless defined(&HAT_DUP_ALL);
	eval 'sub HAT_DUP_COW () {2;}' unless defined(&HAT_DUP_COW);
	eval 'sub HAT_MAP () {0x;}' unless defined(&HAT_MAP);
	eval 'sub HAT_ADV_PGUNLOAD () {0x;}' unless defined(&HAT_ADV_PGUNLOAD);
	eval 'sub HAT_FORCE_PGUNLOAD () {0x1;}' unless defined(&HAT_FORCE_PGUNLOAD);
	eval 'sub P_MOD () {0x1;}' unless defined(&P_MOD);
	eval 'sub P_REF () {0x2;}' unless defined(&P_REF);
	eval 'sub P_RO () {0x4;}' unless defined(&P_RO);
	eval 'sub hat_ismod {
	    my($pp) = @_;
    	    eval q(( &hat_page_getattr($pp,  &P_MOD)));
	}' unless defined(&hat_ismod);
	eval 'sub hat_isref {
	    my($pp) = @_;
    	    eval q(( &hat_page_getattr($pp,  &P_REF)));
	}' unless defined(&hat_isref);
	eval 'sub hat_isro {
	    my($pp) = @_;
    	    eval q(( &hat_page_getattr($pp,  &P_RO)));
	}' unless defined(&hat_isro);
	eval 'sub hat_setmod {
	    my($pp) = @_;
    	    eval q(( &hat_page_setattr($pp,  &P_MOD)));
	}' unless defined(&hat_setmod);
	eval 'sub hat_setref {
	    my($pp) = @_;
    	    eval q(( &hat_page_setattr($pp,  &P_REF)));
	}' unless defined(&hat_setref);
	eval 'sub hat_setrefmod {
	    my($pp) = @_;
    	    eval q(( &hat_page_setattr($pp,  &P_REF| &P_MOD)));
	}' unless defined(&hat_setrefmod);
	eval 'sub hat_clrmod {
	    my($pp) = @_;
    	    eval q(( &hat_page_clrattr($pp,  &P_MOD)));
	}' unless defined(&hat_clrmod);
	eval 'sub hat_clrref {
	    my($pp) = @_;
    	    eval q(( &hat_page_clrattr($pp,  &P_REF)));
	}' unless defined(&hat_clrref);
	eval 'sub hat_clrrefmod {
	    my($pp) = @_;
    	    eval q(( &hat_page_clrattr($pp,  &P_REF| &P_MOD)));
	}' unless defined(&hat_clrrefmod);
	eval 'sub hat_page_is_mapped {
	    my($pp) = @_;
    	    eval q(( &hat_page_getshare($pp)));
	}' unless defined(&hat_page_is_mapped);
	eval 'sub HAT_DONTALLOC () {0;}' unless defined(&HAT_DONTALLOC);
	eval 'sub HAT_ALLOC () {1;}' unless defined(&HAT_ALLOC);
    }
    eval 'sub HRM_SHIFT () {4;}' unless defined(&HRM_SHIFT);
    eval 'sub HRM_BYTES () {(1<<  &HRM_SHIFT);}' unless defined(&HRM_BYTES);
    eval 'sub HRM_PAGES () {(( &HRM_BYTES *  &NBBY) / 2);}' unless defined(&HRM_PAGES);
    eval 'sub HRM_PGPERBYTE () {( &NBBY/2);}' unless defined(&HRM_PGPERBYTE);
    eval 'sub HRM_PGBYTEMASK () {( &HRM_PGPERBYTE-1);}' unless defined(&HRM_PGBYTEMASK);
    eval 'sub HRM_PGOFFMASK () {(( &HRM_PGPERBYTE-1) <<  &MMU_PAGESHIFT);}' unless defined(&HRM_PGOFFMASK);
    eval 'sub HRM_BASEOFFSET () {((( &MMU_PAGESIZE *  &HRM_PAGES) - 1));}' unless defined(&HRM_BASEOFFSET);
    eval 'sub HRM_BASEMASK () {(~( &HRM_BASEOFFSET));}' unless defined(&HRM_BASEMASK);
    eval 'sub HRM_BASESHIFT () {( &MMU_PAGESHIFT + ( &HRM_SHIFT + 2));}' unless defined(&HRM_BASESHIFT);
    eval 'sub HRM_PAGEMASK () {( &MMU_PAGEMASK ^  &HRM_BASEMASK);}' unless defined(&HRM_PAGEMASK);
    eval 'sub HRM_HASHSIZE () {0x200;}' unless defined(&HRM_HASHSIZE);
    eval 'sub HRM_HASHMASK () {( &HRM_HASHSIZE - 1);}' unless defined(&HRM_HASHMASK);
    eval 'sub HRM_BLIST_INCR () {0x200;}' unless defined(&HRM_BLIST_INCR);
    eval 'sub HRM_SWSMONID () {1;}' unless defined(&HRM_SWSMONID);
    if(defined(&_KERNEL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
