require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VM_SEG_H)) {
    eval 'sub _VM_SEG_H () {1;}' unless defined(&_VM_SEG_H);
    require 'sys/vnode.ph';
    require 'vm/seg_enum.ph';
    require 'vm/faultcode.ph';
    require 'vm/hat.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub SSL_NLEVELS () {4;}' unless defined(&SSL_NLEVELS);
    eval 'sub SSL_BFACTOR () {4;}' unless defined(&SSL_BFACTOR);
    eval 'sub SSL_LOG2BF () {2;}' unless defined(&SSL_LOG2BF);
    eval 'sub SSL_UNUSED () {(-1);}' unless defined(&SSL_UNUSED);
    if(defined(&_KERNEL)) {
	eval 'sub SEGP_ASYNC_FLUSH () {0x1;}' unless defined(&SEGP_ASYNC_FLUSH);
	eval 'sub SEGP_FORCE_WIRED () {0x2;}' unless defined(&SEGP_FORCE_WIRED);
	eval 'sub SEGP_SUCCESS () {0;}' unless defined(&SEGP_SUCCESS);
	eval 'sub SEGP_FAIL () {1;}' unless defined(&SEGP_FAIL);
	eval 'sub SEGOP_DUP {
	    my($s, $n) = @_;
    	    eval q((*($s)-> ($s_ops->{dup}))(($s), ($n)));
	}' unless defined(&SEGOP_DUP);
	eval 'sub SEGOP_UNMAP {
	    my($s, $a, $l) = @_;
    	    eval q((*($s)-> ($s_ops->{unmap}))(($s), ($a), ($l)));
	}' unless defined(&SEGOP_UNMAP);
	eval 'sub SEGOP_FREE {
	    my($s) = @_;
    	    eval q((*($s)-> ($s_ops->{free}))(($s)));
	}' unless defined(&SEGOP_FREE);
	eval 'sub SEGOP_FAULT {
	    my($h, $s, $a, $l, $t, $rw) = @_;
    	    eval q((*($s)-> ($s_ops->{f$ault}))(($h), ($s), ($a), ($l), ($t), ($rw)));
	}' unless defined(&SEGOP_FAULT);
	eval 'sub SEGOP_FAULTA {
	    my($s, $a) = @_;
    	    eval q((*($s)-> ($s_ops->{f$aulta}))(($s), ($a)));
	}' unless defined(&SEGOP_FAULTA);
	eval 'sub SEGOP_SETPROT {
	    my($s, $a, $l, $p) = @_;
    	    eval q((*($s)-> ($s_ops->{setprot}))(($s), ($a), ($l), ($p)));
	}' unless defined(&SEGOP_SETPROT);
	eval 'sub SEGOP_CHECKPROT {
	    my($s, $a, $l, $p) = @_;
    	    eval q((*($s)-> ($s_ops->{checkprot}))(($s), ($a), ($l), ($p)));
	}' unless defined(&SEGOP_CHECKPROT);
	eval 'sub SEGOP_KLUSTER {
	    my($s, $a, $d) = @_;
    	    eval q((*($s)-> ($s_ops->{kluster}))(($s), ($a), ($d)));
	}' unless defined(&SEGOP_KLUSTER);
	eval 'sub SEGOP_SWAPOUT {
	    my($s) = @_;
    	    eval q((*($s)-> ($s_ops->{swapout}))(($s)));
	}' unless defined(&SEGOP_SWAPOUT);
	eval 'sub SEGOP_SYNC {
	    my($s, $a, $l, $atr, $f) = @_;
    	    eval q((*($s)-> ($s_ops->{sync}))(($s), ($a), ($l), ($atr), ($f)));
	}' unless defined(&SEGOP_SYNC);
	eval 'sub SEGOP_INCORE {
	    my($s, $a, $l, $v) = @_;
    	    eval q((*($s)-> ($s_ops->{incore}))(($s), ($a), ($l), ($v)));
	}' unless defined(&SEGOP_INCORE);
	eval 'sub SEGOP_LOCKOP {
	    my($s, $a, $l, $atr, $op, $b, $p) = @_;
    	    eval q((*($s)-> ($s_ops->{lockop}))(($s), ($a), ($l), ($atr), ($op), ($b), ($p)));
	}' unless defined(&SEGOP_LOCKOP);
	eval 'sub SEGOP_GETPROT {
	    my($s, $a, $l, $p) = @_;
    	    eval q((*($s)-> ($s_ops->{getprot}))(($s), ($a), ($l), ($p)));
	}' unless defined(&SEGOP_GETPROT);
	eval 'sub SEGOP_GETOFFSET {
	    my($s, $a) = @_;
    	    eval q((*($s)-> ($s_ops->{getoffset}))(($s), ($a)));
	}' unless defined(&SEGOP_GETOFFSET);
	eval 'sub SEGOP_GETTYPE {
	    my($s, $a) = @_;
    	    eval q((*($s)-> ($s_ops->{gettype}))(($s), ($a)));
	}' unless defined(&SEGOP_GETTYPE);
	eval 'sub SEGOP_GETVP {
	    my($s, $a, $vpp) = @_;
    	    eval q((*($s)-> ($s_ops->{getvp}))(($s), ($a), ($vpp)));
	}' unless defined(&SEGOP_GETVP);
	eval 'sub SEGOP_ADVISE {
	    my($s, $a, $l, $b) = @_;
    	    eval q((*($s)-> ($s_ops->{advise}))(($s), ($a), ($l), ($b)));
	}' unless defined(&SEGOP_ADVISE);
	eval 'sub SEGOP_DUMP {
	    my($s) = @_;
    	    eval q((*($s)-> ($s_ops->{dump}))(($s)));
	}' unless defined(&SEGOP_DUMP);
	eval 'sub SEGOP_PAGELOCK {
	    my($s, $a, $l, $p, $t, $rw) = @_;
    	    eval q((*($s)-> ($s_ops->{p$agelock}))(($s), ($a), ($l), ($p), ($t), ($rw)));
	}' unless defined(&SEGOP_PAGELOCK);
	eval 'sub SEGOP_GETMEMID {
	    my($s, $a, $mp) = @_;
    	    eval q((*($s)-> ($s_ops->{getmemid}))(($s), ($a), ($mp)));
	}' unless defined(&SEGOP_GETMEMID);
	eval 'sub seg_page {
	    my($seg, $addr) = @_;
    	    eval q(((( &uintptr_t)(($addr) - ($seg)-> &s_base)) >>  &PAGESHIFT));
	}' unless defined(&seg_page);
	eval 'sub seg_pages {
	    my($seg) = @_;
    	    eval q(((( &uintptr_t)(($seg)-> &s_size +  &PAGEOFFSET)) >>  &PAGESHIFT));
	}' unless defined(&seg_pages);
	eval 'sub IE_NOMEM () {-1;}' unless defined(&IE_NOMEM);
	eval 'sub SEGP_PREDEL_DELAY_FACTOR () {4;}' unless defined(&SEGP_PREDEL_DELAY_FACTOR);
	eval 'sub SEGP_STALL_THRESHOLD () {2;}' unless defined(&SEGP_STALL_THRESHOLD);
	if(defined(&VMDEBUG)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
