require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VM_SEG_KP_H)) {
    eval 'sub _VM_SEG_KP_H () {1;}' unless defined(&_VM_SEG_KP_H);
    require 'vm/seg.ph';
    require 'sys/vmem.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub SEGKP_VMEM {
	    my($seg) = @_;
    	    eval q(((($seg)-> &s_data)-> &kpsd_arena));
	}' unless defined(&SEGKP_VMEM);
	eval 'sub SEGKP_HASHSZ () {256;}' unless defined(&SEGKP_HASHSZ);
	eval 'sub SEGKP_HASHMASK () {( &SEGKP_HASHSZ - 1);}' unless defined(&SEGKP_HASHMASK);
	eval 'sub SEGKP_HASH {
	    my($vaddr) = @_;
    	    eval q((((( &uintptr_t)$vaddr >>  &PAGESHIFT) &  &SEGKP_HASHMASK)));
	}' unless defined(&SEGKP_HASH);
	eval 'sub KPD_ZERO () {0x1;}' unless defined(&KPD_ZERO);
	eval 'sub KPD_LOCKED () {0x2;}' unless defined(&KPD_LOCKED);
	eval 'sub KPD_NO_ANON () {0x4;}' unless defined(&KPD_NO_ANON);
	eval 'sub KPD_HASREDZONE () {0x8;}' unless defined(&KPD_HASREDZONE);
	eval 'sub KPD_NOWAIT () {0x10;}' unless defined(&KPD_NOWAIT);
	eval 'sub KPD_WRITEDIRTY () {0x20;}' unless defined(&KPD_WRITEDIRTY);
	eval 'sub KPD_HASAMP () {0x40;}' unless defined(&KPD_HASAMP);
	eval 'sub SEGKP_MAX_CACHE () {4;}' unless defined(&SEGKP_MAX_CACHE);
	if(defined(&STACK_GROWTH_DOWN)) {
	    eval 'sub KPD_REDZONE {
	        my($kpd) = @_;
    		eval q((0));
	    }' unless defined(&KPD_REDZONE);
	    eval 'sub stom {
	        my($v, $flags) = @_;
    		eval q(((($flags) &  &KPD_HASREDZONE) ? ($v) +  &PAGESIZE : ($v)));
	    }' unless defined(&stom);
	} else {
	    eval 'sub KPD_REDZONE {
	        my($kpd) = @_;
    		eval q(( &btop( ($kpd->{len})) - 1));
	    }' unless defined(&KPD_REDZONE);
	    eval 'sub stom {
	        my($v) = @_;
    		eval q(($v));
	    }' unless defined(&stom);
	}
	eval 'sub SEGKP_MAPLEN {
	    my($len, $flags) = @_;
    	    eval q(((($flags) &  &KPD_HASREDZONE) ? ($len) -  &PAGESIZE : ($len)));
	}' unless defined(&SEGKP_MAPLEN);
	eval 'sub SEG_IS_SEGKP {
	    my($SEG) = @_;
    	    eval q((($SEG) ==  &segkp));
	}' unless defined(&SEG_IS_SEGKP);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
