require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XTI_H)) {
    eval 'sub _XTI_H () {1;}' unless defined(&_XTI_H);
    require 'sys/types.ph';
    require 'sys/tpicommon.ph';
    require 'sys/xti_xtiopt.ph';
    if(!defined( &_XPG5)) {
	require 'sys/xti_osi.ph';
	require 'sys/xti_inet.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub T_LISTEN () {0x1;}' unless defined(&T_LISTEN);
    eval 'sub T_CONNECT () {0x2;}' unless defined(&T_CONNECT);
    eval 'sub T_DATA () {0x4;}' unless defined(&T_DATA);
    eval 'sub T_EXDATA () {0x8;}' unless defined(&T_EXDATA);
    eval 'sub T_DISCONNECT () {0x10;}' unless defined(&T_DISCONNECT);
    eval 'sub T_UDERR () {0x40;}' unless defined(&T_UDERR);
    eval 'sub T_ORDREL () {0x80;}' unless defined(&T_ORDREL);
    eval 'sub T_GODATA () {0x100;}' unless defined(&T_GODATA);
    eval 'sub T_GOEXDATA () {0x200;}' unless defined(&T_GOEXDATA);
    eval 'sub T_MORE () {0x1;}' unless defined(&T_MORE);
    eval 'sub T_EXPEDITED () {0x2;}' unless defined(&T_EXPEDITED);
    eval 'sub T_PUSH () {0x4;}' unless defined(&T_PUSH);
    if(defined( &_REENTRANT) || defined( &_TS_ERRNO)) {
	eval 'sub t_errno () {(*( &__t_errno()));}' unless defined(&t_errno);
    } else {
    }
    unless(defined(&T_IOV_MAX)) {
	eval 'sub T_IOV_MAX () {16;}' unless defined(&T_IOV_MAX);
    }
    unless(defined(&_SC_T_IOV_MAX)) {
	eval 'sub _SC_T_IOV_MAX () {79;}' unless defined(&_SC_T_IOV_MAX);
    }
    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	if(defined( &_XOPEN_SOURCE)  && !defined( &_XPG5)) {
	} else {
	}
	if(defined( &_XOPEN_SOURCE)  && !defined( &_XPG5)) {
	} else {
	}
    } else {
	if(defined( &_XOPEN_SOURCE)  && !defined( &_XPG5)) {
	    eval 'sub t_accept () { &_xti_accept;}' unless defined(&t_accept);
	} else {
	    eval 'sub t_accept () { &_xti_xns5_accept;}' unless defined(&t_accept);
	}
	eval 'sub t_alloc () { &_xti_alloc;}' unless defined(&t_alloc);
	eval 'sub t_bind () { &_xti_bind;}' unless defined(&t_bind);
	eval 'sub t_close () { &_xti_close;}' unless defined(&t_close);
	eval 'sub t_connect () { &_xti_connect;}' unless defined(&t_connect);
	eval 'sub t_error () { &_xti_error;}' unless defined(&t_error);
	eval 'sub t_free () { &_xti_free;}' unless defined(&t_free);
	eval 'sub t_getinfo () { &_xti_getinfo;}' unless defined(&t_getinfo);
	eval 'sub t_getstate () { &_xti_getstate;}' unless defined(&t_getstate);
	eval 'sub t_getprotaddr () { &_xti_getprotaddr;}' unless defined(&t_getprotaddr);
	eval 'sub t_listen () { &_xti_listen;}' unless defined(&t_listen);
	eval 'sub t_look () { &_xti_look;}' unless defined(&t_look);
	eval 'sub t_open () { &_xti_open;}' unless defined(&t_open);
	eval 'sub t_optmgmt () { &_xti_optmgmt;}' unless defined(&t_optmgmt);
	eval 'sub t_rcv () { &_xti_rcv;}' unless defined(&t_rcv);
	eval 'sub t_rcvconnect () { &_xti_rcvconnect;}' unless defined(&t_rcvconnect);
	eval 'sub t_rcvdis () { &_xti_rcvdis;}' unless defined(&t_rcvdis);
	eval 'sub t_rcvrel () { &_xti_rcvrel;}' unless defined(&t_rcvrel);
	eval 'sub t_rcvreldata () { &_xti_rcvreldata;}' unless defined(&t_rcvreldata);
	eval 'sub t_rcvudata () { &_xti_rcvudata;}' unless defined(&t_rcvudata);
	eval 'sub t_rcvuderr () { &_xti_rcvuderr;}' unless defined(&t_rcvuderr);
	eval 'sub t_rcvv () { &_xti_rcvv;}' unless defined(&t_rcvv);
	eval 'sub t_rcvvudata () { &_xti_rcvvudata;}' unless defined(&t_rcvvudata);
	if(defined( &_XOPEN_SOURCE)  && !defined( &_XPG5)) {
	    eval 'sub t_snd () { &_xti_snd;}' unless defined(&t_snd);
	} else {
	    eval 'sub t_snd () { &_xti_xns5_snd;}' unless defined(&t_snd);
	}
	eval 'sub t_snddis () { &_xti_snddis;}' unless defined(&t_snddis);
	eval 'sub t_sndrel () { &_xti_sndrel;}' unless defined(&t_sndrel);
	eval 'sub t_sndreldata () { &_xti_sndreldata;}' unless defined(&t_sndreldata);
	eval 'sub t_sndudata () { &_xti_sndudata;}' unless defined(&t_sndudata);
	eval 'sub t_sndv () { &_xti_sndv;}' unless defined(&t_sndv);
	eval 'sub t_sndvudata () { &_xti_sndvudata;}' unless defined(&t_sndvudata);
	eval 'sub t_strerror () { &_xti_strerror;}' unless defined(&t_strerror);
	eval 'sub t_sync () { &_xti_sync;}' unless defined(&t_sync);
	eval 'sub t_sysconf () { &_xti_sysconf;}' unless defined(&t_sysconf);
	eval 'sub t_unbind () { &_xti_unbind;}' unless defined(&t_unbind);
    }
    eval 'sub T_SENDZERO () {0x1;}' unless defined(&T_SENDZERO);
    eval 'sub T_ORDRELDATA () {0x2;}' unless defined(&T_ORDRELDATA);
    if(defined( &_XPG5)) {
    } else {
    }
    eval 'sub T_BIND () {1;}' unless defined(&T_BIND);
    eval 'sub T_OPTMGMT () {2;}' unless defined(&T_OPTMGMT);
    eval 'sub T_CALL () {3;}' unless defined(&T_CALL);
    eval 'sub T_DIS () {4;}' unless defined(&T_DIS);
    eval 'sub T_UNITDATA () {5;}' unless defined(&T_UNITDATA);
    eval 'sub T_UDERROR () {6;}' unless defined(&T_UDERROR);
    eval 'sub T_INFO () {7;}' unless defined(&T_INFO);
    eval 'sub T_ADDR () {0x1;}' unless defined(&T_ADDR);
    eval 'sub T_OPT () {0x2;}' unless defined(&T_OPT);
    eval 'sub T_UDATA () {0x4;}' unless defined(&T_UDATA);
    eval 'sub T_ALL () {0xffff;}' unless defined(&T_ALL);
    eval 'sub T_UNINIT () {0;}' unless defined(&T_UNINIT);
    eval 'sub T_UNBND () {1;}' unless defined(&T_UNBND);
    eval 'sub T_IDLE () {2;}' unless defined(&T_IDLE);
    eval 'sub T_OUTCON () {3;}' unless defined(&T_OUTCON);
    eval 'sub T_INCON () {4;}' unless defined(&T_INCON);
    eval 'sub T_DATAXFER () {5;}' unless defined(&T_DATAXFER);
    eval 'sub T_OUTREL () {6;}' unless defined(&T_OUTREL);
    eval 'sub T_INREL () {7;}' unless defined(&T_INREL);
    eval 'sub T_UNUSED () {-1;}' unless defined(&T_UNUSED);
    eval 'sub T_NULL () {0;}' unless defined(&T_NULL);
    eval 'sub T_ABSREQ () {0x8000;}' unless defined(&T_ABSREQ);
    eval 'sub _T_OPT_HALIGN_SZ () {($sizeof{ &t_scalar_t});}' unless defined(&_T_OPT_HALIGN_SZ);
    eval 'sub _T_OPT_DALIGN_SZ () {($sizeof{ &int32_t});}' unless defined(&_T_OPT_DALIGN_SZ);
    eval 'sub _T_OPTHDR_SZ () {($sizeof{\'struct t_opthdr\'});}' unless defined(&_T_OPTHDR_SZ);
    eval 'sub _T_OPT_ALIGN {
        my($x, $asize) = @_;
	    eval q(((( &uintptr_t)($x) + (($asize) - 1)) & ~(($asize) - 1)));
    }' unless defined(&_T_OPT_ALIGN);
    eval 'sub _T_OPTHDR_ALIGN {
        my($x) = @_;
	    eval q(( &_T_OPT_ALIGN(($x),  &_T_OPT_HALIGN_SZ)));
    }' unless defined(&_T_OPTHDR_ALIGN);
    eval 'sub _T_OPTDATA_ALIGN {
        my($x) = @_;
	    eval q(( &_T_OPT_ALIGN(($x),  &_T_OPT_DALIGN_SZ)));
    }' unless defined(&_T_OPTDATA_ALIGN);
    eval 'sub T_OPT_FIRSTHDR {
        my($nbp) = @_;
	    eval q((($nbp)-> &len >=  &_T_OPTHDR_SZ ? ($nbp)-> &buf : 0));
    }' unless defined(&T_OPT_FIRSTHDR);
    eval 'sub T_OPT_DATA {
        my($tohp) = @_;
	    eval q(( &_T_OPTDATA_ALIGN(($tohp) +  &_T_OPTHDR_SZ)));
    }' unless defined(&T_OPT_DATA);
    eval 'sub _T_NEXTHDR {
        my($pbuf, $buflen, $popt) = @_;
	    eval q((( &_T_OPTHDR_ALIGN( + -> &len) +  &_T_OPTHDR_SZ <= (($pbuf) + ($buflen))) ? ( &_T_OPTHDR_ALIGN(($popt) + ($popt)-> &len)) : 0));
    }' unless defined(&_T_NEXTHDR);
    eval 'sub T_OPT_NEXTHDR {
        my($nbp, $tohp) = @_;
	    eval q(( &_T_NEXTHDR(($nbp)-> &buf, ($nbp)-> &len, ($tohp))));
    }' unless defined(&T_OPT_NEXTHDR);
    if(!defined( &_XPG5)) {
	eval 'sub T_ALIGN {
	    my($p) = @_;
    	    eval q(((( &uintptr_t)($p) + ($sizeof{ &t_scalar_t} - 1)) & ~($sizeof{ &t_scalar_t} - 1)));
	}' unless defined(&T_ALIGN);
	eval 'sub OPT_NEXTHDR {
	    my($pbuf, $buflen, $popt) = @_;
    	    eval q(( &_T_NEXTHDR(($pbuf), ($buflen), ($popt))));
	}' unless defined(&OPT_NEXTHDR);
    }
    if(defined( &__STDC__)) {
	if(defined( &_XOPEN_SOURCE)  && !defined( &_XPG5)) {
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
