require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_STANDARD)) {
    eval 'sub _H_STANDARD () {1;}' unless defined(&_H_STANDARD);
    eval 'sub MAXLINE () {512;}' unless defined(&MAXLINE);
    eval 'sub BITSPRBYTE () {8;}' unless defined(&BITSPRBYTE);
    eval 'sub MAXPOS {
        my($type) = @_;
	    eval q(((($type)1<< ( &BITSPRBYTE*$sizeof{$type}-1)) - ($type)1));
    }' unless defined(&MAXPOS);
    eval 'sub UNSSHORT {
        my($n) = @_;
	    eval q((($n)));
    }' unless defined(&UNSSHORT);
    eval 'sub UNSCHAR {
        my($c) = @_;
	    eval q((($c)));
    }' unless defined(&UNSCHAR);
    eval 'sub ARRAYLEN {
        my($a) = @_;
	    eval q(($sizeof{$a}/$sizeof{$a->[0]}));
    }' unless defined(&ARRAYLEN);
    unless(defined(&NUL)) {
	eval 'sub NUL () {0;}' unless defined(&NUL);
    }
    eval 'sub TRUE () {1;}' unless defined(&TRUE);
    eval 'sub FALSE () {0;}' unless defined(&FALSE);
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    eval 'sub SOBUF () { &_sobuf;}' unless defined(&SOBUF);
    eval 'sub Reg1 () { &register;}' unless defined(&Reg1);
    eval 'sub Reg2 () { &register;}' unless defined(&Reg2);
    eval 'sub Reg3 () { &register;}' unless defined(&Reg3);
    eval 'sub Reg4 () { &register;}' unless defined(&Reg4);
    eval 'sub Reg5 () { &register;}' unless defined(&Reg5);
    eval 'sub Reg6 () { &register;}' unless defined(&Reg6);
    eval 'sub Reg7 () {1;}' unless defined(&Reg7);
    eval 'sub Reg8 () {1;}' unless defined(&Reg8);
    eval 'sub Reg9 () {1;}' unless defined(&Reg9);
    eval 'sub Reg10 () {1;}' unless defined(&Reg10);
    eval 'sub Reg11 () {1;}' unless defined(&Reg11);
    eval 'sub Reg12 () {1;}' unless defined(&Reg12);
    eval 'sub EXITOK () { &UNSCHAR(0);}' unless defined(&EXITOK);
    eval 'sub EXITWARN () { &UNSCHAR(1);}' unless defined(&EXITWARN);
    eval 'sub EXITERROR () { &UNSCHAR(040);}' unless defined(&EXITERROR);
    eval 'sub EXITFATAL () { &UNSCHAR(0100);}' unless defined(&EXITFATAL);
    eval 'sub EXITEXEC () { &UNSCHAR(255);}' unless defined(&EXITEXEC);
    eval 'sub EXITBAD () { &UNSCHAR(254);}' unless defined(&EXITBAD);
    eval 'sub EXITIO () { &UNSCHAR(253);}' unless defined(&EXITIO);
    eval 'sub EXITFILE () { &UNSCHAR(252);}' unless defined(&EXITFILE);
    eval 'sub EXITSIGNAL () { &UNSCHAR(251);}' unless defined(&EXITSIGNAL);
    eval 'sub EXITSPACE () { &UNSCHAR(250);}' unless defined(&EXITSPACE);
    eval 'sub EXITOTHER () { &UNSCHAR(128);}' unless defined(&EXITOTHER);
    eval 'sub EXIT_REASON {
        my($status) = @_;
	    eval q( &UNSCHAR($status));
    }' unless defined(&EXIT_REASON);
    eval 'sub EXIT_VALUE {
        my($status) = @_;
	    eval q( &UNSCHAR(($status)>>8));
    }' unless defined(&EXIT_VALUE);
}
1;
