require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_AIX_H)) {
    eval 'sub _AIX_H () {1;}' unless defined(&_AIX_H);
    eval 'sub AIX_GLYPHS_PER_KEY () {2;}' unless defined(&AIX_GLYPHS_PER_KEY);
    eval 'sub AIX_MIN_KEY () {0x8;}' unless defined(&AIX_MIN_KEY);
    eval 'sub AIX_MAX_KEY () {0xf7+ &AIX_MIN_KEY;}' unless defined(&AIX_MAX_KEY);
    eval 'sub XDEV_IBM_K101 () {0;}' unless defined(&XDEV_IBM_K101);
    eval 'sub XDEV_IBM_K102 () {1;}' unless defined(&XDEV_IBM_K102);
    eval 'sub XDEV_IBM_K106 () {2;}' unless defined(&XDEV_IBM_K106);
    eval 'sub XDEV_IBM_APA8 () {6153;}' unless defined(&XDEV_IBM_APA8);
    eval 'sub XDEV_IBM_APA8C () {6154;}' unless defined(&XDEV_IBM_APA8C);
    eval 'sub XDEV_IBM_APA16 () {6155;}' unless defined(&XDEV_IBM_APA16);
    eval 'sub XDEV_IBM_MPEL () {5081;}' unless defined(&XDEV_IBM_MPEL);
    eval 'sub XDEV_IBM_EGA () {5154;}' unless defined(&XDEV_IBM_EGA);
    eval 'sub XDEV_IBM_8514A () {8514;}' unless defined(&XDEV_IBM_8514A);
    eval 'sub XDEV_IBM_GSL () {4444;}' unless defined(&XDEV_IBM_GSL);
    eval 'sub XDEV_IBM_GAI () {9999;}' unless defined(&XDEV_IBM_GAI);
    eval 'sub XDEV_IBM_SKYWAY () {1111;}' unless defined(&XDEV_IBM_SKYWAY);
    eval 'sub XDEV_IBM_SABINE () {2222;}' unless defined(&XDEV_IBM_SABINE);
    eval 'sub XDEV_IBM_GEMINI () {3333;}' unless defined(&XDEV_IBM_GEMINI);
    eval 'sub XDEV_IBM_SKYMONO () {5555;}' unless defined(&XDEV_IBM_SKYMONO);
    eval 'sub XDEV_IBM_PEDER () {6666;}' unless defined(&XDEV_IBM_PEDER);
    eval 'sub XDEV_IBM_SGA () {7777;}' unless defined(&XDEV_IBM_SGA);
    eval 'sub AIXConnectionClosed () {255;}' unless defined(&AIXConnectionClosed);
    eval 'sub XAIXEXTENSIONNAME () {"XAixExtension";}' unless defined(&XAIXEXTENSIONNAME);
    eval 'sub AIXDIRECTRESOURCENAME () {"AixDirectResource";}' unless defined(&AIXDIRECTRESOURCENAME);
    eval 'sub AIXDIRECTNAME () {"aixDirectAccessExtension";}' unless defined(&AIXDIRECTNAME);
    eval 'sub DIRECTACCESSNAME () {"xDirectAccessExtension";}' unless defined(&DIRECTACCESSNAME);
    eval 'sub aixDIRECTACCESS_MAJOR_VERSION () {1;}' unless defined(&aixDIRECTACCESS_MAJOR_VERSION);
    eval 'sub aixDIRECTACCESS_MINOR_VERSION () {6;}' unless defined(&aixDIRECTACCESS_MINOR_VERSION);
    eval 'sub AIXCURSOREXTENSION () {"aixCursorExtension";}' unless defined(&AIXCURSOREXTENSION);
    eval 'sub aixCURSOR_MAJOR_VERSION () {1;}' unless defined(&aixCURSOR_MAJOR_VERSION);
    eval 'sub aixCURSOR_MINOR_VERSION () {0;}' unless defined(&aixCURSOR_MINOR_VERSION);
    eval 'sub COLORMAPEXTNAME () {"xColormapExtension";}' unless defined(&COLORMAPEXTNAME);
    eval 'sub X_DrawPolyMarker () {1;}' unless defined(&X_DrawPolyMarker);
    eval 'sub X_SetPolyMarker () {2;}' unless defined(&X_SetPolyMarker);
    eval 'sub X_DrawPolyMarkers () {3;}' unless defined(&X_DrawPolyMarkers);
    eval 'sub X_AAAA () {4;}' unless defined(&X_AAAA);
    eval 'sub X_BBBB () {5;}' unless defined(&X_BBBB);
    eval 'sub X_DrawGeoText () {6;}' unless defined(&X_DrawGeoText);
    eval 'sub X_SetGeoText () {7;}' unless defined(&X_SetGeoText);
    eval 'sub X_CCCC () {8;}' unless defined(&X_CCCC);
    eval 'sub X_DirectAdapterAccess () {1;}' unless defined(&X_DirectAdapterAccess);
    eval 'sub X_DirectWindowAccess () {2;}' unless defined(&X_DirectWindowAccess);
    eval 'sub X_DirectFontAccess () {3;}' unless defined(&X_DirectFontAccess);
    eval 'sub X_QueryDirectResourceAccess () {4;}' unless defined(&X_QueryDirectResourceAccess);
    eval 'sub X_FullScreen () {5;}' unless defined(&X_FullScreen);
    eval 'sub X_NewXFont () {6;}' unless defined(&X_NewXFont);
    eval 'sub X_ManageOverlay () {7;}' unless defined(&X_ManageOverlay);
    eval 'sub X_QueryMemoryUsage () {8;}' unless defined(&X_QueryMemoryUsage);
    if(defined(&GL_X_PERF)) {
	eval 'sub X_DirectInputAccess () {9;}' unless defined(&X_DirectInputAccess);
    }
    eval 'sub X_DirectBufferAccess () {10;}' unless defined(&X_DirectBufferAccess);
    eval 'sub X_FastResUpdate () {11;}' unless defined(&X_FastResUpdate);
    eval 'sub X_HardwareSync () {12;}' unless defined(&X_HardwareSync);
    eval 'sub X_DirectAccessQueryVersion () {13;}' unless defined(&X_DirectAccessQueryVersion);
    eval 'sub X_ChangeCoreDeviceControl () {14;}' unless defined(&X_ChangeCoreDeviceControl);
    eval 'sub X_GetCoreDeviceControl () {15;}' unless defined(&X_GetCoreDeviceControl);
    eval 'sub X_DAEQueryCapabilities () {16;}' unless defined(&X_DAEQueryCapabilities);
    eval 'sub X_DAEWriteToBothBuffers () {17;}' unless defined(&X_DAEWriteToBothBuffers);
    eval 'sub X_DAEChangeDisplayResolution () {19;}' unless defined(&X_DAEChangeDisplayResolution);
    eval 'sub FLUSHTOFRAMEBUFFER () {0;}' unless defined(&FLUSHTOFRAMEBUFFER);
    eval 'sub QUERY_ALL_ACTIVE_MEM () {0;}' unless defined(&QUERY_ALL_ACTIVE_MEM);
    eval 'sub QUERY_MEM_SINCE_LAST_QUERY () {1;}' unless defined(&QUERY_MEM_SINCE_LAST_QUERY);
    eval 'sub DAEWriteToBothBuffersOn () {1;}' unless defined(&DAEWriteToBothBuffersOn);
    eval 'sub DAEWriteToBothBuffersOff () {0;}' unless defined(&DAEWriteToBothBuffersOff);
    eval 'sub DAEWriteToBothBuffersCapability () {(1<<0);}' unless defined(&DAEWriteToBothBuffersCapability);
    eval 'sub DAEResolutionDefault () {(1<<0);}' unless defined(&DAEResolutionDefault);
    eval 'sub DAEResolution640X480 () {(1<<1);}' unless defined(&DAEResolution640X480);
    eval 'sub X_CreateCrossHair () {1;}' unless defined(&X_CreateCrossHair);
    eval 'sub X_QueryCrossHair () {2;}' unless defined(&X_QueryCrossHair);
    eval 'sub X_CreateMultiColorCur () {3;}' unless defined(&X_CreateMultiColorCur);
    eval 'sub X_RecolorMultiColorCur () {4;}' unless defined(&X_RecolorMultiColorCur);
    eval 'sub X_CursorQueryVersion () {5;}' unless defined(&X_CursorQueryVersion);
    eval 'sub X_GetCrossHairCursorInfo () {6;}' unless defined(&X_GetCrossHairCursorInfo);
    eval 'sub X_RecolorCrossHairCursor () {7;}' unless defined(&X_RecolorCrossHairCursor);
    eval 'sub X_GetMultiColorCursorInfo () {8;}' unless defined(&X_GetMultiColorCursorInfo);
    eval 'sub PSEUDO_BASED_CROSSHAIR () {4;}' unless defined(&PSEUDO_BASED_CROSSHAIR);
    eval 'sub SCREEN_BASED_CROSSHAIR () {1;}' unless defined(&SCREEN_BASED_CROSSHAIR);
    eval 'sub WINDOW_BASED_CROSSHAIR () {2;}' unless defined(&WINDOW_BASED_CROSSHAIR);
    eval 'sub NO_CROSSHAIR () {0;}' unless defined(&NO_CROSSHAIR);
    eval 'sub X_ExtBlink () {1;}' unless defined(&X_ExtBlink);
    eval 'sub X_ExtStoreAnyColors () {2;}' unless defined(&X_ExtStoreAnyColors);
    eval 'sub X_ExtRegisterGlcmap () {3;}' unless defined(&X_ExtRegisterGlcmap);
    eval 'sub NUM_SHMFASTRESUPDATE_ENTRY () {1021;}' unless defined(&NUM_SHMFASTRESUPDATE_ENTRY);
    eval 'sub Cleanup_shmFastRes {
        my($header_p, $index_p) = @_;
	    eval q({ --((( &shmFastResUpdateHeaderPtr)($header_p))-> &numEntryAllocated); (( &shmFastResUpdateHeaderPtr)($header_p))-> $disBufEntry[($index_p)] = -1; });
    }' unless defined(&Cleanup_shmFastRes);
    eval 'sub GetDisplayedBuffer {
        my($ptr) = @_;
	    eval q({ *$ptr; });
    }' unless defined(&GetDisplayedBuffer);
}
1;
