require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_aix_keysym_h)) {
    eval 'sub _aix_keysym_h () {1;}' unless defined(&_aix_keysym_h);
    eval 'sub XK_dead_degree () {0x180000b0;}' unless defined(&XK_dead_degree);
    eval 'sub XK_ZenKouho () {0x1800ff01;}' unless defined(&XK_ZenKouho);
    eval 'sub XK_KanjiBangou () {0x1800ff02;}' unless defined(&XK_KanjiBangou);
    eval 'sub XK_HenkanMenu () {0x1800ff03;}' unless defined(&XK_HenkanMenu);
    eval 'sub XK_MaeKouho () {0x1800ff04;}' unless defined(&XK_MaeKouho);
    eval 'sub XK_BunsetsuYomi () {0x1800ff05;}' unless defined(&XK_BunsetsuYomi);
    eval 'sub XK_LeftDouble () {0x1800ff06;}' unless defined(&XK_LeftDouble);
    eval 'sub XK_RightDouble () {0x1800ff07;}' unless defined(&XK_RightDouble);
    eval 'sub XK_LeftPhrase () {0x1800ff08;}' unless defined(&XK_LeftPhrase);
    eval 'sub XK_RightPhrase () {0x1800ff09;}' unless defined(&XK_RightPhrase);
    eval 'sub XK_ErInput () {0x1800ff0a;}' unless defined(&XK_ErInput);
    eval 'sub XK_Reset () {0x1800ff0b;}' unless defined(&XK_Reset);
    eval 'sub XK_dead_accentdieresis () {0x180007ae;}' unless defined(&XK_dead_accentdieresis);
    eval 'sub XK_dead_hook_above () {0x180001d2;}' unless defined(&XK_dead_hook_above);
    eval 'sub XK_dong_sign () {0x180001d3;}' unless defined(&XK_dong_sign);
    eval 'sub XK_Ydiaeresis () {0x180001d4;}' unless defined(&XK_Ydiaeresis);
    eval 'sub XK_oe () {0x180001d5;}' unless defined(&XK_oe);
    eval 'sub XK_OE () {0x180001d6;}' unless defined(&XK_OE);
    eval 'sub XK_uhorn () {0x180001d7;}' unless defined(&XK_uhorn);
    eval 'sub XK_Uhorn () {0x180001d8;}' unless defined(&XK_Uhorn);
    eval 'sub XK_ohorn () {0x180001d9;}' unless defined(&XK_ohorn);
    eval 'sub XK_Ohorn () {0x180001da;}' unless defined(&XK_Ohorn);
    eval 'sub XK_Thai_yamakkan () {0x18000200;}' unless defined(&XK_Thai_yamakkan);
    eval 'sub XK_Thai_fongman () {0x18000201;}' unless defined(&XK_Thai_fongman);
    eval 'sub XK_Thai_angkhankhu () {0x18000202;}' unless defined(&XK_Thai_angkhankhu);
    eval 'sub XK_Thai_khomut () {0x18000203;}' unless defined(&XK_Thai_khomut);
    eval 'sub XK_Ukrainian_ghe () {0x18000300;}' unless defined(&XK_Ukrainian_ghe);
    eval 'sub XK_Ukrainian_GHE () {0x18000301;}' unless defined(&XK_Ukrainian_GHE);
    eval 'sub XK_hindi_candrabindu () {0x18000901;}' unless defined(&XK_hindi_candrabindu);
    eval 'sub XK_hindi_anusvara () {0x18000902;}' unless defined(&XK_hindi_anusvara);
    eval 'sub XK_hindi_visarga () {0x18000903;}' unless defined(&XK_hindi_visarga);
    eval 'sub XK_hindi_a () {0x18000905;}' unless defined(&XK_hindi_a);
    eval 'sub XK_hindi_aa () {0x18000906;}' unless defined(&XK_hindi_aa);
    eval 'sub XK_hindi_i () {0x18000907;}' unless defined(&XK_hindi_i);
    eval 'sub XK_hindi_ii () {0x18000908;}' unless defined(&XK_hindi_ii);
    eval 'sub XK_hindi_u () {0x18000909;}' unless defined(&XK_hindi_u);
    eval 'sub XK_hindi_uu () {0x1800090a;}' unless defined(&XK_hindi_uu);
    eval 'sub XK_hindi_rvocalic () {0x1800090b;}' unless defined(&XK_hindi_rvocalic);
    eval 'sub XK_hindi_lvocalic () {0x1800090c;}' unless defined(&XK_hindi_lvocalic);
    eval 'sub XK_hindi_ecandra () {0x1800090d;}' unless defined(&XK_hindi_ecandra);
    eval 'sub XK_hindi_eshort () {0x1800090e;}' unless defined(&XK_hindi_eshort);
    eval 'sub XK_hindi_e () {0x1800090f;}' unless defined(&XK_hindi_e);
    eval 'sub XK_hindi_ai () {0x18000910;}' unless defined(&XK_hindi_ai);
    eval 'sub XK_hindi_ocandra () {0x18000911;}' unless defined(&XK_hindi_ocandra);
    eval 'sub XK_hindi_oshort () {0x18000912;}' unless defined(&XK_hindi_oshort);
    eval 'sub XK_hindi_o () {0x18000913;}' unless defined(&XK_hindi_o);
    eval 'sub XK_hindi_au () {0x18000914;}' unless defined(&XK_hindi_au);
    eval 'sub XK_hindi_ka () {0x18000915;}' unless defined(&XK_hindi_ka);
    eval 'sub XK_hindi_kha () {0x18000916;}' unless defined(&XK_hindi_kha);
    eval 'sub XK_hindi_ga () {0x18000917;}' unless defined(&XK_hindi_ga);
    eval 'sub XK_hindi_gha () {0x18000918;}' unless defined(&XK_hindi_gha);
    eval 'sub XK_hindi_nga () {0x18000919;}' unless defined(&XK_hindi_nga);
    eval 'sub XK_hindi_ca () {0x1800091a;}' unless defined(&XK_hindi_ca);
    eval 'sub XK_hindi_cha () {0x1800091b;}' unless defined(&XK_hindi_cha);
    eval 'sub XK_hindi_ja () {0x1800091c;}' unless defined(&XK_hindi_ja);
    eval 'sub XK_hindi_jha () {0x1800091d;}' unless defined(&XK_hindi_jha);
    eval 'sub XK_hindi_nya () {0x1800091e;}' unless defined(&XK_hindi_nya);
    eval 'sub XK_hindi_tta () {0x1800091f;}' unless defined(&XK_hindi_tta);
    eval 'sub XK_hindi_ttha () {0x18000920;}' unless defined(&XK_hindi_ttha);
    eval 'sub XK_hindi_dda () {0x18000921;}' unless defined(&XK_hindi_dda);
    eval 'sub XK_hindi_ddha () {0x18000922;}' unless defined(&XK_hindi_ddha);
    eval 'sub XK_hindi_nna () {0x18000923;}' unless defined(&XK_hindi_nna);
    eval 'sub XK_hindi_ta () {0x18000924;}' unless defined(&XK_hindi_ta);
    eval 'sub XK_hindi_tha () {0x18000925;}' unless defined(&XK_hindi_tha);
    eval 'sub XK_hindi_da () {0x18000926;}' unless defined(&XK_hindi_da);
    eval 'sub XK_hindi_dha () {0x18000927;}' unless defined(&XK_hindi_dha);
    eval 'sub XK_hindi_na () {0x18000928;}' unless defined(&XK_hindi_na);
    eval 'sub XK_hindi_nnna () {0x18000929;}' unless defined(&XK_hindi_nnna);
    eval 'sub XK_hindi_pa () {0x1800092a;}' unless defined(&XK_hindi_pa);
    eval 'sub XK_hindi_pha () {0x1800092b;}' unless defined(&XK_hindi_pha);
    eval 'sub XK_hindi_ba () {0x1800092c;}' unless defined(&XK_hindi_ba);
    eval 'sub XK_hindi_bha () {0x1800092d;}' unless defined(&XK_hindi_bha);
    eval 'sub XK_hindi_ma () {0x1800092e;}' unless defined(&XK_hindi_ma);
    eval 'sub XK_hindi_ya () {0x1800092f;}' unless defined(&XK_hindi_ya);
    eval 'sub XK_hindi_ra () {0x18000930;}' unless defined(&XK_hindi_ra);
    eval 'sub XK_hindi_rra () {0x18000931;}' unless defined(&XK_hindi_rra);
    eval 'sub XK_hindi_la () {0x18000932;}' unless defined(&XK_hindi_la);
    eval 'sub XK_hindi_lla () {0x18000933;}' unless defined(&XK_hindi_lla);
    eval 'sub XK_hindi_llla () {0x18000934;}' unless defined(&XK_hindi_llla);
    eval 'sub XK_hindi_va () {0x18000935;}' unless defined(&XK_hindi_va);
    eval 'sub XK_hindi_sha () {0x18000936;}' unless defined(&XK_hindi_sha);
    eval 'sub XK_hindi_ssa () {0x18000937;}' unless defined(&XK_hindi_ssa);
    eval 'sub XK_hindi_sa () {0x18000938;}' unless defined(&XK_hindi_sa);
    eval 'sub XK_hindi_ha () {0x18000939;}' unless defined(&XK_hindi_ha);
    eval 'sub XK_hindi_nukta () {0x1800093c;}' unless defined(&XK_hindi_nukta);
    eval 'sub XK_hindi_avagraha () {0x1800093d;}' unless defined(&XK_hindi_avagraha);
    eval 'sub XK_hindi_aavowelsign () {0x1800093e;}' unless defined(&XK_hindi_aavowelsign);
    eval 'sub XK_hindi_ivowelsign () {0x1800093f;}' unless defined(&XK_hindi_ivowelsign);
    eval 'sub XK_hindi_iivowelsign () {0x18000940;}' unless defined(&XK_hindi_iivowelsign);
    eval 'sub XK_hindi_uvowelsign () {0x18000941;}' unless defined(&XK_hindi_uvowelsign);
    eval 'sub XK_hindi_uuvowelsign () {0x18000942;}' unless defined(&XK_hindi_uuvowelsign);
    eval 'sub XK_hindi_rvocalicvowelsign () {0x18000943;}' unless defined(&XK_hindi_rvocalicvowelsign);
    eval 'sub XK_hindi_rrvocalicvowelsign () {0x18000944;}' unless defined(&XK_hindi_rrvocalicvowelsign);
    eval 'sub XK_hindi_ecandravowelsign () {0x18000945;}' unless defined(&XK_hindi_ecandravowelsign);
    eval 'sub XK_hindi_eshortvowelsign () {0x18000946;}' unless defined(&XK_hindi_eshortvowelsign);
    eval 'sub XK_hindi_evowelsign () {0x18000947;}' unless defined(&XK_hindi_evowelsign);
    eval 'sub XK_hindi_aivowelsign () {0x18000948;}' unless defined(&XK_hindi_aivowelsign);
    eval 'sub XK_hindi_ocandravowelsign () {0x18000949;}' unless defined(&XK_hindi_ocandravowelsign);
    eval 'sub XK_hindi_oshortvowelsign () {0x1800094a;}' unless defined(&XK_hindi_oshortvowelsign);
    eval 'sub XK_hindi_ovowelsign () {0x1800094b;}' unless defined(&XK_hindi_ovowelsign);
    eval 'sub XK_hindi_auvowelsign () {0x1800094c;}' unless defined(&XK_hindi_auvowelsign);
    eval 'sub XK_hindi_virama () {0x1800094d;}' unless defined(&XK_hindi_virama);
    eval 'sub XK_hindi_om () {0x18000950;}' unless defined(&XK_hindi_om);
    eval 'sub XK_hindi_udatta () {0x18000951;}' unless defined(&XK_hindi_udatta);
    eval 'sub XK_hindi_anudatta () {0x18000952;}' unless defined(&XK_hindi_anudatta);
    eval 'sub XK_hindi_qa () {0x18000958;}' unless defined(&XK_hindi_qa);
    eval 'sub XK_hindi_khha () {0x18000959;}' unless defined(&XK_hindi_khha);
    eval 'sub XK_hindi_ghha () {0x1800095a;}' unless defined(&XK_hindi_ghha);
    eval 'sub XK_hindi_za () {0x1800095b;}' unless defined(&XK_hindi_za);
    eval 'sub XK_hindi_dddha () {0x1800095c;}' unless defined(&XK_hindi_dddha);
    eval 'sub XK_hindi_rha () {0x1800095d;}' unless defined(&XK_hindi_rha);
    eval 'sub XK_hindi_fa () {0x1800095e;}' unless defined(&XK_hindi_fa);
    eval 'sub XK_hindi_yya () {0x1800095f;}' unless defined(&XK_hindi_yya);
    eval 'sub XK_hindi_rrvocalic () {0x18000960;}' unless defined(&XK_hindi_rrvocalic);
    eval 'sub XK_hindi_llvocalic () {0x18000961;}' unless defined(&XK_hindi_llvocalic);
    eval 'sub XK_hindi_lvocalicvowelsign () {0x18000962;}' unless defined(&XK_hindi_lvocalicvowelsign);
    eval 'sub XK_hindi_llvocalicvowelsign () {0x18000963;}' unless defined(&XK_hindi_llvocalicvowelsign);
    eval 'sub XK_hindi_danda () {0x18000964;}' unless defined(&XK_hindi_danda);
    eval 'sub XK_hindi_doubledanda () {0x18000965;}' unless defined(&XK_hindi_doubledanda);
    eval 'sub XK_hindi_zero () {0x18000966;}' unless defined(&XK_hindi_zero);
    eval 'sub XK_hindi_one () {0x18000967;}' unless defined(&XK_hindi_one);
    eval 'sub XK_hindi_two () {0x18000968;}' unless defined(&XK_hindi_two);
    eval 'sub XK_hindi_three () {0x18000969;}' unless defined(&XK_hindi_three);
    eval 'sub XK_hindi_four () {0x1800096a;}' unless defined(&XK_hindi_four);
    eval 'sub XK_hindi_five () {0x1800096b;}' unless defined(&XK_hindi_five);
    eval 'sub XK_hindi_six () {0x1800096c;}' unless defined(&XK_hindi_six);
    eval 'sub XK_hindi_seven () {0x1800096d;}' unless defined(&XK_hindi_seven);
    eval 'sub XK_hindi_eight () {0x1800096e;}' unless defined(&XK_hindi_eight);
    eval 'sub XK_hindi_nine () {0x1800096f;}' unless defined(&XK_hindi_nine);
    eval 'sub XK_hindi_abbreviation () {0x18000970;}' unless defined(&XK_hindi_abbreviation);
    eval 'sub XK_hindi_rasub () {0x18000971;}' unless defined(&XK_hindi_rasub);
    eval 'sub XK_hindi_reph () {0x18000972;}' unless defined(&XK_hindi_reph);
    eval 'sub XK_hindi_janya () {0x18000973;}' unless defined(&XK_hindi_janya);
    eval 'sub XK_hindi_tara () {0x18000974;}' unless defined(&XK_hindi_tara);
    eval 'sub XK_hindi_kassa () {0x18000975;}' unless defined(&XK_hindi_kassa);
    eval 'sub XK_hindi_shara () {0x18000976;}' unless defined(&XK_hindi_shara);
}
1;
