require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&FONT_H)) {
    eval 'sub FONT_H () {1;}' unless defined(&FONT_H);
    unless(defined(&BitmapFormatByteOrderMask)) {
	require 'fsmasks.ph';
    }
    unless(defined(&_XTYPEDEF_FONTPTR)) {
	eval 'sub _XTYPEDEF_FONTPTR () {1;}' unless defined(&_XTYPEDEF_FONTPTR);
    }
    unless(defined(&_XTYPEDEF_CHARINFOPTR)) {
	eval 'sub _XTYPEDEF_CHARINFOPTR () {1;}' unless defined(&_XTYPEDEF_CHARINFOPTR);
    }
    eval 'sub NullCharInfo () {(( &CharInfoPtr) 0);}' unless defined(&NullCharInfo);
    eval 'sub NullFont () {(( &FontPtr) 0);}' unless defined(&NullFont);
    eval 'sub NullFontInfo () {(( &FontInfoPtr) 0);}' unless defined(&NullFontInfo);
    eval 'sub LeftToRight () {0;}' unless defined(&LeftToRight);
    eval 'sub RightToLeft () {1;}' unless defined(&RightToLeft);
    eval 'sub BottomToTop () {2;}' unless defined(&BottomToTop);
    eval 'sub TopToBottom () {3;}' unless defined(&TopToBottom);
    eval 'sub NO_SUCH_CHAR () {-1;}' unless defined(&NO_SUCH_CHAR);
    eval 'sub FontAliasType () {0x1000;}' unless defined(&FontAliasType);
    eval 'sub AllocError () {80;}' unless defined(&AllocError);
    eval 'sub StillWorking () {81;}' unless defined(&StillWorking);
    eval 'sub FontNameAlias () {82;}' unless defined(&FontNameAlias);
    eval 'sub BadFontName () {83;}' unless defined(&BadFontName);
    eval 'sub Suspended () {84;}' unless defined(&Suspended);
    eval 'sub Successful () {85;}' unless defined(&Successful);
    eval 'sub BadFontPath () {86;}' unless defined(&BadFontPath);
    eval 'sub BadCharRange () {87;}' unless defined(&BadCharRange);
    eval 'sub BadFontFormat () {88;}' unless defined(&BadFontFormat);
    eval 'sub FPEResetFailed () {89;}' unless defined(&FPEResetFailed);
    eval 'sub FontLoadInfo () {0x1;}' unless defined(&FontLoadInfo);
    eval 'sub FontLoadProps () {0x2;}' unless defined(&FontLoadProps);
    eval 'sub FontLoadMetrics () {0x4;}' unless defined(&FontLoadMetrics);
    eval 'sub FontLoadBitmaps () {0x8;}' unless defined(&FontLoadBitmaps);
    eval 'sub FontLoadAll () {0xf;}' unless defined(&FontLoadAll);
    eval 'sub FontOpenSync () {0x10;}' unless defined(&FontOpenSync);
    eval 'sub FontReopen () {0x20;}' unless defined(&FontReopen);
    eval 'sub LoadAll () {0x1;}' unless defined(&LoadAll);
    eval 'sub FinishRamge () {0x2;}' unless defined(&FinishRamge);
    eval 'sub EightBitFont () {0x4;}' unless defined(&EightBitFont);
    eval 'sub SixteenBitFont () {0x8;}' unless defined(&SixteenBitFont);
    eval 'sub CACHING_OFF () {0;}' unless defined(&CACHING_OFF);
    eval 'sub CACHE_16_BIT_GLYPHS () {1;}' unless defined(&CACHE_16_BIT_GLYPHS);
    eval 'sub CACHE_ALL_GLYPHS () {2;}' unless defined(&CACHE_ALL_GLYPHS);
    eval 'sub DEFAULT_GLYPH_CACHING_MODE () { &CACHING_OFF;}' unless defined(&DEFAULT_GLYPH_CACHING_MODE);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval("sub Linear8Bit () { 0; }") unless defined(&Linear8Bit);
    eval("sub TwoD8Bit () { 1; }") unless defined(&TwoD8Bit);
    eval("sub Linear16Bit () { 2; }") unless defined(&Linear16Bit);
    eval("sub TwoD16Bit () { 3; }") unless defined(&TwoD16Bit);
}
1;
