require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&FONTSTR_H)) {
    eval 'sub FONTSTR_H () {1;}' unless defined(&FONTSTR_H);
    require 'X11/Xproto.ph';
    require 'font.ph';
    require 'X11/Xfuncproto.ph';
    eval 'sub GLYPHPADOPTIONS () {4;}' unless defined(&GLYPHPADOPTIONS);
    eval 'sub FontGetPrivate {
        my($pFont,$n) = @_;
	    eval q((($n) > ($pFont)-> &maxPrivate ? ( &pointer) 0: ($pFont)-> $devPrivates[$n]));
    }' unless defined(&FontGetPrivate);
    eval 'sub FontSetPrivate {
        my($pFont,$n,$ptr) = @_;
	    eval q((($n) > ($pFont)-> &maxPrivate ?  &_FontSetNewPrivate ($pFont, $n, $ptr) : (((($pFont)-> $devPrivates[$n] = ($ptr)) != 0) ||  &TRUE)));
    }' unless defined(&FontSetPrivate);
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedNestedPrototypes) ? &NeedNestedPrototypes : 0)) {
    }
    if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
    }
    eval 'sub GLYPHWIDTHPIXELS {
        my($pci) = @_;
	    eval q((($pci)-> ($metrics->{rightSideBearing}) - ($pci)-> ($metrics->{leftSideBearing})));
    }' unless defined(&GLYPHWIDTHPIXELS);
    eval 'sub GLYPHHEIGHTPIXELS {
        my($pci) = @_;
	    eval q((($pci)-> ($metrics->{ascent}) + ($pci)-> ($metrics->{descent})));
    }' unless defined(&GLYPHHEIGHTPIXELS);
    eval 'sub GLYPHWIDTHBYTES {
        my($pci) = @_;
	    eval q(((( &GLYPHWIDTHPIXELS($pci))+7) >> 3));
    }' unless defined(&GLYPHWIDTHBYTES);
    eval 'sub GLYPHWIDTHPADDED {
        my($bc) = @_;
	    eval q(((($bc)+7) & ~0x7));
    }' unless defined(&GLYPHWIDTHPADDED);
    eval 'sub BYTES_PER_ROW {
        my($bits, $nbytes) = @_;
	    eval q((($nbytes) == 1? ((($bits)+7)>>3) :($nbytes) == 2? (((($bits)+15)>>3)&~1) :($nbytes) == 4? (((($bits)+31)>>3)&~3) :($nbytes) == 8? (((($bits)+63)>>3)&~7) : 0));
    }' unless defined(&BYTES_PER_ROW);
    eval 'sub BYTES_FOR_GLYPH {
        my($ci,$pad) = @_;
	    eval q(( &GLYPHHEIGHTPIXELS($ci) *  &BYTES_PER_ROW( &GLYPHWIDTHPIXELS($ci),$pad)));
    }' unless defined(&BYTES_FOR_GLYPH);
    eval 'sub FONT_MAX_ASCENT {
        my($pi) = @_;
	    eval q((($pi)-> &fontAscent > ($pi)-> ($ink_maxbounds->{ascent}) ? ($pi)-> &fontAscent : ($pi)-> ($ink_maxbounds->{ascent})));
    }' unless defined(&FONT_MAX_ASCENT);
    eval 'sub FONT_MAX_DESCENT {
        my($pi) = @_;
	    eval q((($pi)-> &fontDescent > ($pi)-> ($ink_maxbounds->{descent}) ? ($pi)-> &fontDescent : ($pi)-> ($ink_maxbounds->{descent})));
    }' unless defined(&FONT_MAX_DESCENT);
    eval 'sub FONT_MAX_HEIGHT {
        my($pi) = @_;
	    eval q(( &FONT_MAX_ASCENT($pi) +  &FONT_MAX_DESCENT($pi)));
    }' unless defined(&FONT_MAX_HEIGHT);
    eval 'sub FONT_MIN_LEFT {
        my($pi) = @_;
	    eval q((($pi)-> ($ink_minbounds->{leftSideBearing}) < 0? ($pi)-> ($ink_minbounds->{leftSideBearing}) : 0));
    }' unless defined(&FONT_MIN_LEFT);
    eval 'sub FONT_MAX_RIGHT {
        my($pi) = @_;
	    eval q((($pi)-> ($ink_maxbounds->{rightSideBearing}) > ($pi)-> ($ink_maxbounds->{characterWidth}) ? ($pi)-> ($ink_maxbounds->{rightSideBearing}) : ($pi)-> ($ink_maxbounds->{characterWidth})));
    }' unless defined(&FONT_MAX_RIGHT);
    eval 'sub FONT_MAX_WIDTH {
        my($pi) = @_;
	    eval q(( &FONT_MAX_RIGHT($pi) -  &FONT_MIN_LEFT($pi)));
    }' unless defined(&FONT_MAX_WIDTH);
}
1;
