require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SITE_H)) {
    eval 'sub SITE_H () {1;}' unless defined(&SITE_H);
    unless(defined(&VENDOR_STRING)) {
	eval 'sub VENDOR_STRING () {"International Business Machines";}' unless defined(&VENDOR_STRING);
    }
    unless(defined(&VENDOR_RELEASE)) {
	eval 'sub VENDOR_RELEASE () {6100;}' unless defined(&VENDOR_RELEASE);
    }
    unless(defined(&COMPILEDDEFAULTFONTPATH)) {
	eval 'sub COMPILEDDEFAULTFONTPATH () {"/usr/lib/X11/fonts/misc/";}' unless defined(&COMPILEDDEFAULTFONTPATH);
    }
    unless(defined(&RGB_DB)) {
	eval 'sub RGB_DB () {"/usr/lib/X11/rgb";}' unless defined(&RGB_DB);
    }
    if(defined(&_AIXR6)) {
	unless(defined(&COMPILEDDEFAULTFONT)) {
	    eval 'sub COMPILEDDEFAULTFONT () {"fixed";}' unless defined(&COMPILEDDEFAULTFONT);
	}
    } else {
	eval 'sub COMPILEDDEFAULTFONT () {"fixed";}' unless defined(&COMPILEDDEFAULTFONT);
    }
    if(defined(&_AIXR6)) {
	unless(defined(&COMPILEDCURSORFONT)) {
	    eval 'sub COMPILEDCURSORFONT () {"cursor";}' unless defined(&COMPILEDCURSORFONT);
	}
    } else {
	eval 'sub COMPILEDCURSORFONT () {"cursor";}' unless defined(&COMPILEDCURSORFONT);
    }
    unless(defined(&COMPILEDDISPLAYCLASS)) {
	eval 'sub COMPILEDDISPLAYCLASS () {"MIT-unspecified";}' unless defined(&COMPILEDDISPLAYCLASS);
    }
    eval 'sub DEFAULT_TIMEOUT () {60;}' unless defined(&DEFAULT_TIMEOUT);
    eval 'sub DEFAULT_KEYBOARD_CLICK () {0;}' unless defined(&DEFAULT_KEYBOARD_CLICK);
    eval 'sub DEFAULT_BELL () {50;}' unless defined(&DEFAULT_BELL);
    eval 'sub DEFAULT_BELL_PITCH () {400;}' unless defined(&DEFAULT_BELL_PITCH);
    eval 'sub DEFAULT_BELL_DURATION () {100;}' unless defined(&DEFAULT_BELL_DURATION);
    if(defined( &XKB) || defined( &_AIXR6)) {
	eval 'sub DEFAULT_AUTOREPEAT () { &TRUE;}' unless defined(&DEFAULT_AUTOREPEAT);
    } else {
	eval 'sub DEFAULT_AUTOREPEAT () { &FALSE;}' unless defined(&DEFAULT_AUTOREPEAT);
    }
    if(defined( &hpux)) {
	eval 'sub DEFAULT_AUTOREPEATS () {{ 0x, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x};}' unless defined(&DEFAULT_AUTOREPEATS);
    }
 elsif(defined( &_AIXR6)) {
	eval 'sub DEFAULT_AUTOREPEATS () {{ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};}' unless defined(&DEFAULT_AUTOREPEATS);
    } else {
	eval 'sub DEFAULT_AUTOREPEATS () {{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};}' unless defined(&DEFAULT_AUTOREPEATS);
    }
    eval 'sub DEFAULT_LEDS () {0x;}' unless defined(&DEFAULT_LEDS);
    eval 'sub DEFAULT_LEDS_MASK () {0xffffffff;}' unless defined(&DEFAULT_LEDS_MASK);
    eval 'sub DEFAULT_INT_RESOLUTION () {1000;}' unless defined(&DEFAULT_INT_RESOLUTION);
    eval 'sub DEFAULT_INT_MIN_VALUE () {0;}' unless defined(&DEFAULT_INT_MIN_VALUE);
    eval 'sub DEFAULT_INT_MAX_VALUE () {100;}' unless defined(&DEFAULT_INT_MAX_VALUE);
    eval 'sub DEFAULT_INT_DISPLAYED () {0;}' unless defined(&DEFAULT_INT_DISPLAYED);
    eval 'sub DEFAULT_PTR_NUMERATOR () {2;}' unless defined(&DEFAULT_PTR_NUMERATOR);
    eval 'sub DEFAULT_PTR_DENOMINATOR () {1;}' unless defined(&DEFAULT_PTR_DENOMINATOR);
    eval 'sub DEFAULT_PTR_THRESHOLD () {4;}' unless defined(&DEFAULT_PTR_THRESHOLD);
    eval 'sub DEFAULT_SCREEN_SAVER_TIME () {(10* (60* 1000));}' unless defined(&DEFAULT_SCREEN_SAVER_TIME);
    eval 'sub DEFAULT_SCREEN_SAVER_INTERVAL () {(10* (60* 1000));}' unless defined(&DEFAULT_SCREEN_SAVER_INTERVAL);
    eval 'sub DEFAULT_SCREEN_SAVER_BLANKING () { &PreferBlanking;}' unless defined(&DEFAULT_SCREEN_SAVER_BLANKING);
    eval 'sub DEFAULT_SCREEN_SAVER_EXPOSURES () { &AllowExposures;}' unless defined(&DEFAULT_SCREEN_SAVER_EXPOSURES);
    unless(defined(&NOLOGOHACK)) {
	eval 'sub DEFAULT_LOGO_SCREEN_SAVER () {1;}' unless defined(&DEFAULT_LOGO_SCREEN_SAVER);
    }
    unless(defined(&DEFAULT_ACCESS_CONTROL)) {
	eval 'sub DEFAULT_ACCESS_CONTROL () { &TRUE;}' unless defined(&DEFAULT_ACCESS_CONTROL);
    }
}
1;
