require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_AHDR)) {
    eval 'sub _H_AHDR () {1;}' unless defined(&_H_AHDR);
    require 'xcoff32_64.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&__XCOFF_HYBRID__)) {
	if(defined(&__XCOFF32__)) {
	    eval 'sub _AOUTHSZ_SHORT () {((( &AOUTHDR *)0)-> &o_toc);}' unless defined(&_AOUTHSZ_SHORT);
	    eval 'sub _AOUTHSZ_EXEC () {$sizeof{ &AOUTHDR};}' unless defined(&_AOUTHSZ_EXEC);
	}
	if(defined(&__XCOFF64__)) {
	    if(defined(&__XCOFF32__)) {
		eval 'sub _AOUTHSZ_EXEC_64 () {$sizeof{ &_S_( &AOUTHDR)};}' unless defined(&_AOUTHSZ_EXEC_64);
	    } else {
		eval 'sub _AOUTHSZ_EXEC () {$sizeof{ &_S_( &AOUTHDR)};}' unless defined(&_AOUTHSZ_EXEC);
	    }
	}
	eval 'sub o_tsize () { &tsize;}' unless defined(&o_tsize);
	eval 'sub o_dsize () { &dsize;}' unless defined(&o_dsize);
	eval 'sub o_bsize () { &bsize;}' unless defined(&o_bsize);
	eval 'sub o_entry () { &entry;}' unless defined(&o_entry);
	eval 'sub o_text_start () { &text_start;}' unless defined(&o_text_start);
	eval 'sub o_data_start () { &data_start;}' unless defined(&o_data_start);
    } else {
	eval 'sub o_tsize32 () { ($_u2->{_tsize32});}' unless defined(&o_tsize32);
	eval 'sub o_debugger64 () { ($_u2->{_debugger64});}' unless defined(&o_debugger64);
	eval 'sub o_dsize32 () { ($_u1->{_s32}->{_dsize32});}' unless defined(&o_dsize32);
	eval 'sub o_bsize32 () { ($_u1->{_s32}->{_bsize32});}' unless defined(&o_bsize32);
	eval 'sub o_entry32 () { ($_u1->{_s32}->{_entry32});}' unless defined(&o_entry32);
	eval 'sub o_text_start32 () { ($_u1->{_s32}->{_text_start32});}' unless defined(&o_text_start32);
	eval 'sub o_data_start32 () { ($_u1->{_s32}->{_data_start32});}' unless defined(&o_data_start32);
	eval 'sub o_toc32 () { ($_u1->{_s32}->{_toc32});}' unless defined(&o_toc32);
	eval 'sub o_text_start64 () { ($_u1->{_s64}->{_text_start64});}' unless defined(&o_text_start64);
	eval 'sub o_data_start64 () { ($_u1->{_s64}->{_data_start64});}' unless defined(&o_data_start64);
	eval 'sub o_toc64 () { ($_u1->{_s64}->{_toc64});}' unless defined(&o_toc64);
	eval 'sub o_maxdata32 () { ($_u3->{_u4}->{_maxdata32});}' unless defined(&o_maxdata32);
	eval 'sub o_debugger32 () { ($_u3->{_u4}->{_debugger32});}' unless defined(&o_debugger32);
	eval 'sub o_tsize64 () { ($_u3->{_tsize64});}' unless defined(&o_tsize64);
	eval 'sub _AOUTHSZ_SHORT_32 () {((( &_S_( &AOUTHDR) *)0)-> &o_toc32);}' unless defined(&_AOUTHSZ_SHORT_32);
	eval 'sub _AOUTHSZ_EXEC_32 () {((( &AOUTHDR *)0)-> &o_bsize64);}' unless defined(&_AOUTHSZ_EXEC_32);
	eval 'sub _AOUTHSZ_EXEC_64 () {$sizeof{ &AOUTHDR};}' unless defined(&_AOUTHSZ_EXEC_64);
    }
    eval 'sub o_mflag () { &magic;}' unless defined(&o_mflag);
    eval 'sub o_vstamp () { &vstamp;}' unless defined(&o_vstamp);
    eval 'sub TOBJ_SAME () {0x80;}' unless defined(&TOBJ_SAME);
    eval 'sub TOBJ_COM () {0x40;}' unless defined(&TOBJ_COM);
    eval 'sub TOBJ_EMULATE () {0x20;}' unless defined(&TOBJ_EMULATE);
    eval 'sub TOBJ_COMPAT () {0x10;}' unless defined(&TOBJ_COMPAT);
    eval 'sub TCPU_INVALID () {0;}' unless defined(&TCPU_INVALID);
    eval 'sub TCPU_PPC () {1;}' unless defined(&TCPU_PPC);
    eval 'sub TCPU_PPC64 () {2;}' unless defined(&TCPU_PPC64);
    eval 'sub TCPU_COM () {3;}' unless defined(&TCPU_COM);
    eval 'sub TCPU_PWR () {4;}' unless defined(&TCPU_PWR);
    eval 'sub TCPU_ANY () {5;}' unless defined(&TCPU_ANY);
    eval 'sub TCPU_601 () {6;}' unless defined(&TCPU_601);
    eval 'sub TCPU_603 () {7;}' unless defined(&TCPU_603);
    eval 'sub TCPU_604 () {8;}' unless defined(&TCPU_604);
    eval 'sub TCPU_PWR1 () {10;}' unless defined(&TCPU_PWR1);
    eval 'sub TCPU_620 () {16;}' unless defined(&TCPU_620);
    eval 'sub TCPU_A35 () {17;}' unless defined(&TCPU_A35);
    eval 'sub TCPU_PWRX () {224;}' unless defined(&TCPU_PWRX);
    if(defined(&__cplusplus)) {
    }
}
1;
