require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ARPA_INET_H)) {
    eval 'sub _ARPA_INET_H () {1;}' unless defined(&_ARPA_INET_H);
    require 'standards.ph';
    require 'sys/inttypes.ph';
    require 'netinet/in.ph';
    if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0) == 1) {
	unless(defined(&_IP_TYPES_T)) {
	    eval 'sub _IP_TYPES_T () {1;}' unless defined(&_IP_TYPES_T);
	}
	unless(defined(&_IN_ADDR_STRUCT)) {
	    eval 'sub _IN_ADDR_STRUCT () {1;}' unless defined(&_IN_ADDR_STRUCT);
	}
	if(defined(&_NO_PROTO)) {
	    unless(defined(&htonl)) {
	    }
	} else {
	    unless(defined(&htonl)) {
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
    }
    if(defined(&_ALL_SOURCE)) {
	require 'sys/machine.ph';
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	    unless(defined(&htonl)) {
		eval 'sub htonl {
		    my($hostlong) = @_;
    		    eval q(($hostlong));
		}' unless defined(&htonl);
	    }
	    unless(defined(&htons)) {
		eval 'sub htons {
		    my($hostshort) = @_;
    		    eval q(($hostshort));
		}' unless defined(&htons);
	    }
	    unless(defined(&ntohl)) {
		eval 'sub ntohl {
		    my($netlong) = @_;
    		    eval q(($netlong));
		}' unless defined(&ntohl);
	    }
	    unless(defined(&ntohs)) {
		eval 'sub ntohs {
		    my($netshort) = @_;
    		    eval q(($netshort));
		}' unless defined(&ntohs);
	    }
	}
	unless(defined(&_IN6_ADDR_STRUCT)) {
	    if(defined(&notyet)) {
	    }
	    eval 'sub s6_addr32 () { ($u6_addr->{u6_addr32});}' unless defined(&s6_addr32);
	    if(defined(&notyet)) {
		eval 'sub s6_addr64 () { ($u6_addr->{u6_addr64});}' unless defined(&s6_addr64);
	    }
	    eval 'sub s6_addr16 () { ($u6_addr->{u6_addr16});}' unless defined(&s6_addr16);
	    eval 'sub s6_addr8 () { ($u6_addr->{u6_addr8});}' unless defined(&s6_addr8);
	    eval 'sub s6_addr () { ($u6_addr->{u6_addr8});}' unless defined(&s6_addr);
	    eval 'sub _IN6_ADDR_STRUCT () {1;}' unless defined(&_IN6_ADDR_STRUCT);
	}
	if(defined(&_NO_PROTO)) {
	} else {
	    eval 'sub _ARPA_INET_ONLY () {1;}' unless defined(&_ARPA_INET_ONLY);
	    require 'netinet/if_ether.ph';
	    undef(&_ARPA_INET_ONLY) if defined(&_ARPA_INET_ONLY);
	    require 'net/if_dl.ph';
	}
    }
}
1;
