require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__H_CDD_INTR_MACROS)) {
    eval 'sub __H_CDD_INTR_MACROS () {1;}' unless defined(&__H_CDD_INTR_MACROS);
    eval 'sub CDD_INTR_device {
        my($cp) = @_;
	    eval q((($cp)-> &p_cdd_intr_dev_attrs));
    }' unless defined(&CDD_INTR_device);
    eval 'sub CDD_INTR_svcs {
        my($cp) = @_;
	    eval q((($cp)-> &p_cdd_intr_svcs));
    }' unless defined(&CDD_INTR_svcs);
    eval 'sub CDD_INTR_ext {
        my($cp) = @_;
	    eval q((($cp)-> &p_cdd_intr_extensions));
    }' unless defined(&CDD_INTR_ext);
    eval 'sub CDD_INTR_rc {
        my($cp) = @_;
	    eval q(( ($cp)-> &intr_rc ));
    }' unless defined(&CDD_INTR_rc);
    eval 'sub CDD_INTR_version {
        my($cp) = @_;
	    eval q((($cp)-> &intr_version));
    }' unless defined(&CDD_INTR_version);
    eval 'sub CDD_INTR_ddf {
        my($cp) = @_;
	    eval q(( &CDD_INTR_device($cp)-> &ddf_intr_scratchpad));
    }' unless defined(&CDD_INTR_ddf);
    eval 'sub CDD_INTR_ddf_len {
        my($cp) = @_;
	    eval q(( &CDD_INTR_device($cp)-> &ddf_intr_len));
    }' unless defined(&CDD_INTR_ddf_len);
    eval 'sub CDD_INTR_busmem_seg {
        my($cp) = @_;
	    eval q(( &CDD_INTR_device($cp)-> &busmem_att));
    }' unless defined(&CDD_INTR_busmem_seg);
    eval 'sub CDD_INTR_slot {
        my($cp) = @_;
	    eval q(( &CDD_INTR_device($cp)-> &slot));
    }' unless defined(&CDD_INTR_slot);
    eval 'sub CDD_INTR_iocc_seg {
        my($cp) = @_;
	    eval q(( &CDD_INTR_device($cp)-> &iocc_att));
    }' unless defined(&CDD_INTR_iocc_seg);
    eval 'sub CDD_INTR_busmem_base {
        my($cp,$i) = @_;
	    eval q(( &CDD_INTR_device($cp)-> $busmem_hw_base[($i)]));
    }' unless defined(&CDD_INTR_busmem_base);
    eval 'sub CDD_INTR_busmem_len {
        my($cp,$i) = @_;
	    eval q(( &CDD_INTR_device($cp)-> $address_space_length[($i)]));
    }' unless defined(&CDD_INTR_busmem_len);
    eval 'sub CDD_INTR_iocc_base {
        my($cp) = @_;
	    eval q(( &CDD_INTR_device($cp)-> &iocc_addr_base));
    }' unless defined(&CDD_INTR_iocc_base);
    eval 'sub CDD_INTR_exception {
        my($cp) = @_;
	    eval q(( &CDD_INTR_device($cp)-> &exception_code));
    }' unless defined(&CDD_INTR_exception);
    eval 'sub CDD_INTR_lockl {
        my($cp,$lock_word) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &lockl ))(($lock_word)));
    }' unless defined(&CDD_INTR_lockl);
    eval 'sub CDD_INTR_unlockl {
        my($cp,$lock_word) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &unlockl ))(($lock_word)));
    }' unless defined(&CDD_INTR_unlockl);
    eval 'sub CDD_INTR_i_disable {
        my($cp,$new_priority) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &i_disable ))(($new_priority)));
    }' unless defined(&CDD_INTR_i_disable);
    eval 'sub CDD_INTR_i_enable {
        my($cp,$priority) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &i_enable ))(($priority)));
    }' unless defined(&CDD_INTR_i_enable);
    eval 'sub CDD_INTR_strncmp {
        my( $cp, $s1, $s2, $n ) = @_;
	    eval q();
    }' unless defined(&CDD_INTR_strncmp);
    eval 'sub CDD_INTR_busgetl {
        my($cp,$seg,$ptr,$pval) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &bus_get_l ))(($seg),($ptr),($pval)));
    }' unless defined(&CDD_INTR_busgetl);
    eval 'sub CDD_INTR_busgets {
        my($cp,$seg,$ptr,$pval) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &bus_get_s ))(($seg),($ptr),($pval)));
    }' unless defined(&CDD_INTR_busgets);
    eval 'sub CDD_INTR_busgetc {
        my($cp,$seg,$ptr,$pval) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &bus_get_c ))(($seg),($ptr),($pval)));
    }' unless defined(&CDD_INTR_busgetc);
    eval 'sub CDD_INTR_busputl {
        my($cp,$seg,$ptr,$val) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &bus_put_l ))(($seg),($ptr),($val)));
    }' unless defined(&CDD_INTR_busputl);
    eval 'sub CDD_INTR_busputs {
        my($cp,$seg,$ptr,$val) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &bus_put_s ))(($seg),($ptr),($val)));
    }' unless defined(&CDD_INTR_busputs);
    eval 'sub CDD_INTR_busputc {
        my($cp,$seg,$ptr,$val) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &bus_put_c ))(($seg),($ptr),($val)));
    }' unless defined(&CDD_INTR_busputc);
    eval 'sub CDD_INTR_buscpy {
        my($cp,$src,$dest,$len,$dir) = @_;
	    eval q((*(  &CDD_INTR_svcs($cp)-> &bus_cpy ))(($src),($dest),($len),($dir)));
    }' unless defined(&CDD_INTR_buscpy);
}
1;
