require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_CUR01)) {
    eval 'sub _H_CUR01 () {1;}' unless defined(&_H_CUR01);
    require 'stdio.ph';
    if(((defined(&IS1) ? &IS1 : 0)|(defined(&IS2) ? &IS2 : 0)|(defined(&V7) ? &V7 : 0))) {
	require 'sgtty.ph';
    } else {
	require 'termio.ph';
    }
    require 'stdlib.ph';
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {(1);}' unless defined(&TRUE);
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {(0);}' unless defined(&FALSE);
    }
    eval 'sub ERR () {(0);}' unless defined(&ERR);
    eval 'sub OK () {(1);}' unless defined(&OK);
    eval 'sub NLSCHAR () { &wchar_t;}' unless defined(&NLSCHAR);
    eval 'sub NLSBLANK () {( &NLSCHAR) ord(\' \');}' unless defined(&NLSBLANK);
    eval 'sub NLSNL () {( &NLSCHAR) ord(\'\\n\');}' unless defined(&NLSNL);
    eval 'sub ATTR () {\'unsigned short\';}' unless defined(&ATTR);
    eval 'sub WINDOW () {\'struct _win_st\';}' unless defined(&WINDOW);
    eval 'sub _SUBWIN () {01;}' unless defined(&_SUBWIN);
    eval 'sub _ENDLINE () {02;}' unless defined(&_ENDLINE);
    eval 'sub _FULLWIN () {04;}' unless defined(&_FULLWIN);
    eval 'sub _SCROLLWIN () {010;}' unless defined(&_SCROLLWIN);
    eval 'sub _FLUSH () {020;}' unless defined(&_FLUSH);
    eval 'sub _ISVIEW () {040;}' unless defined(&_ISVIEW);
    eval 'sub _HASVIEW () {0100;}' unless defined(&_HASVIEW);
    eval 'sub _STANDOUT () {0200;}' unless defined(&_STANDOUT);
    eval 'sub _NOCHANGE () {-1;}' unless defined(&_NOCHANGE);
    if(defined(&lint)) {
	eval 'sub VOID {
	    my($x) = @_;
    	    eval q(( &__void__ = ($x)));
	}' unless defined(&VOID);
    } else {
	eval 'sub VOID {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&VOID);
    }
    eval 'sub chgat {
        my($num, $mod) = @_;
	    eval q( &VOID( &wchgat( &stdscr, $num, $mod)));
    }' unless defined(&chgat);
    eval 'sub addch {
        my($ch) = @_;
	    eval q( &VOID( &waddch( &stdscr, $ch)));
    }' unless defined(&addch);
    eval 'sub getch () {
        eval q( &VOID( &wgetch( &stdscr)));
    }' unless defined(&getch);
    eval 'sub addstr {
        my($str) = @_;
	    eval q( &VOID( &waddstr( &stdscr, $str)));
    }' unless defined(&addstr);
    eval 'sub getstr {
        my($str) = @_;
	    eval q( &VOID( &wgetstr( &stdscr, $str)));
    }' unless defined(&getstr);
    eval 'sub move {
        my($y, $x) = @_;
	    eval q( &VOID( &wmove( &stdscr, $y, $x)));
    }' unless defined(&move);
    eval 'sub clear () {
        eval q( &VOID( &wclear( &stdscr)));
    }' unless defined(&clear);
    eval 'sub erase () {
        eval q( &VOID( &werase( &stdscr)));
    }' unless defined(&erase);
    eval 'sub clrtobot () {
        eval q( &VOID( &wclrtobot( &stdscr)));
    }' unless defined(&clrtobot);
    eval 'sub clrtoeol () {
        eval q( &VOID( &wclrtoeol( &stdscr)));
    }' unless defined(&clrtoeol);
    eval 'sub insertln () {
        eval q( &VOID( &winsertln( &stdscr)));
    }' unless defined(&insertln);
    eval 'sub deleteln () {
        eval q( &VOID( &wdeleteln( &stdscr)));
    }' unless defined(&deleteln);
    eval 'sub refresh () {
        eval q( &VOID( &wrefresh( &stdscr)));
    }' unless defined(&refresh);
    eval 'sub inch () {
        eval q( &VOID( &winch( &stdscr)));
    }' unless defined(&inch);
    eval 'sub insch {
        my($c) = @_;
	    eval q( &VOID( &winsch( &stdscr, $c)));
    }' unless defined(&insch);
    eval 'sub delch () {
        eval q( &VOID( &wdelch( &stdscr)));
    }' unless defined(&delch);
    eval 'sub standout () {
        eval q( &VOID( &xstandout( &stdscr, 1)));
    }' unless defined(&standout);
    eval 'sub standend () {
        eval q( &VOID( &xstandend( &stdscr)));
    }' unless defined(&standend);
    eval 'sub colorout {
        my($a) = @_;
	    eval q( &VOID( &xstandout( &stdscr, $a)));
    }' unless defined(&colorout);
    eval 'sub colorend () {
        eval q( &VOID( &xstandend( &stdscr)));
    }' unless defined(&colorend);
    eval 'sub overwrite {
        my($a,$b) = @_;
	    eval q( &VOID( &overput($a, $b,  &TRUE)));
    }' unless defined(&overwrite);
    eval 'sub overlay {
        my($a, $b) = @_;
	    eval q( &VOID( &overput($a, $b,  &FALSE)));
    }' unless defined(&overlay);
    eval 'sub wcolorout {
        my($w,$a) = @_;
	    eval q( &VOID( &xstandout($w, $a)));
    }' unless defined(&wcolorout);
    eval 'sub wstandout {
        my($win) = @_;
	    eval q( &VOID( &xstandout($win, 1)));
    }' unless defined(&wstandout);
    eval 'sub wstandend {
        my($win) = @_;
	    eval q( &VOID( &xstandend($win)));
    }' unless defined(&wstandend);
    eval 'sub wcolorend {
        my($win) = @_;
	    eval q( &VOID( &xstandend($win)));
    }' unless defined(&wcolorend);
    eval 'sub setscrreg {
        my($t,$b) = @_;
	    eval q( &VOID( &wsetscrreg( &stdscr, $t, $b)));
    }' unless defined(&setscrreg);
    eval 'sub wsetscrreg {
        my($win,$t,$b) = @_;
	    eval q( &VOID(( ($win->{_$tmarg})=($t), ($win->{_$bmarg})=($b))));
    }' unless defined(&wsetscrreg);
    eval 'sub mvwchgat {
        my($win,$y,$x,$n,$m) = @_;
	    eval q( &VOID( &wmove($win,$y,$x)== &ERR? &ERR: &wchgat($win,$n,$m)));
    }' unless defined(&mvwchgat);
    eval 'sub mvwaddch {
        my($win,$y,$x,$ch) = @_;
	    eval q( &VOID( &wmove($win,$y,$x)== &ERR? &ERR: &waddch($win,$ch)));
    }' unless defined(&mvwaddch);
    eval 'sub mvwgetch {
        my($win,$y,$x) = @_;
	    eval q( &VOID( &wmove($win,$y,$x)== &ERR? &ERR:( &wrefresh($win), &wgetch($win))));
    }' unless defined(&mvwgetch);
    eval 'sub mvwaddstr {
        my($win,$y,$x,$str) = @_;
	    eval q( &VOID( &wmove($win,$y,$x)== &ERR? &ERR: &waddstr($win,$str)));
    }' unless defined(&mvwaddstr);
    eval 'sub mvwgetstr {
        my($win,$y,$x,$s) = @_;
	    eval q( &VOID( &wmove($win,$y,$x)== &ERR? &ERR: &wgetstr($win,$s)));
    }' unless defined(&mvwgetstr);
    eval 'sub mvwinch {
        my($win,$y,$x) = @_;
	    eval q( &VOID( &wmove($win,$y,$x)== &ERR? &ERR: &winch($win)));
    }' unless defined(&mvwinch);
    eval 'sub mvwdelch {
        my($win,$y,$x) = @_;
	    eval q( &VOID( &wmove($win,$y,$x)== &ERR? &ERR: &wdelch($win)));
    }' unless defined(&mvwdelch);
    eval 'sub mvwinsch {
        my($win,$y,$x,$c) = @_;
	    eval q( &VOID( &wmove($win,$y,$x)== &ERR? &ERR: &winsch($win,$c)));
    }' unless defined(&mvwinsch);
    eval 'sub mvchgat {
        my($y,$x,$n,$m) = @_;
	    eval q( &mvwchgat( &stdscr,$y,$x,$n,$m));
    }' unless defined(&mvchgat);
    eval 'sub mvaddch {
        my($y,$x,$ch) = @_;
	    eval q( &mvwaddch( &stdscr,$y,$x,$ch));
    }' unless defined(&mvaddch);
    eval 'sub mvgetch {
        my($y,$x) = @_;
	    eval q( &mvwgetch( &stdscr,$y,$x));
    }' unless defined(&mvgetch);
    eval 'sub mvaddstr {
        my($y,$x,$str) = @_;
	    eval q( &mvwaddstr( &stdscr,$y,$x,$str));
    }' unless defined(&mvaddstr);
    eval 'sub mvgetstr {
        my($y,$x,$str) = @_;
	    eval q( &mvwgetstr( &stdscr,$y,$x,$str));
    }' unless defined(&mvgetstr);
    eval 'sub mvinch {
        my($y,$x) = @_;
	    eval q( &mvwinch( &stdscr,$y,$x));
    }' unless defined(&mvinch);
    eval 'sub mvdelch {
        my($y,$x) = @_;
	    eval q( &mvwdelch( &stdscr,$y,$x));
    }' unless defined(&mvdelch);
    eval 'sub mvinsch {
        my($y,$x,$c) = @_;
	    eval q( &mvwinsch( &stdscr,$y,$x,$c));
    }' unless defined(&mvinsch);
    eval 'sub box {
        my($w,$b,$c) = @_;
	    eval q( &superbox1($w,0,0,($w)-> &_maxy,($w)-> &_maxx,$b,$c,$c,$c,$c,$c,0));
    }' unless defined(&box);
    eval 'sub fullbox {
        my($w,$b,$c,$d,$e,$f,$g) = @_;
	    eval q( &superbox1($w,0,0,($w)-> &_maxy,($w)-> &_maxx,$b,$c,$d,$e,$f,$g,0));
    }' unless defined(&fullbox);
    eval 'sub cbox {
        my($w) = @_;
	    eval q( &superbox1($w,0,0,($w)-> &_maxy,($w)-> &_maxx, $BX[3], $BX[1], $BX[0], $BX[2], $BX[5],  $BX[4], &Bxa));
    }' unless defined(&cbox);
    eval 'sub drawbox {
        my($w,$y,$x,$l,$c) = @_;
	    eval q( &superbox1($w,($y),($x),($l),($c), $BX[3], $BX[1], $BX[0], $BX[2], $BX[5], $BX[4], &Bxa));
    }' unless defined(&drawbox);
    eval 'sub flash () {
        eval q( &bell(2));
    }' unless defined(&flash);
    eval 'sub beep () {
        eval q( &bell(1));
    }' unless defined(&beep);
    eval 'sub werase {
        my($win) = @_;
	    eval q((($win)-> &_curx = ($win)-> &_cury = 0,  &wclrtobot($win)));
    }' unless defined(&werase);
    eval 'sub wclear {
        my($win) = @_;
	    eval q((($win)-> &_curx = ($win)-> &_cury = 0,  &wclrtobot($win), ($win)-> &_clear =  &TRUE));
    }' unless defined(&wclear);
    eval 'sub clearok {
        my($win,$bf) = @_;
	    eval q((($win)-> &_clear = $bf));
    }' unless defined(&clearok);
    eval 'sub leaveok {
        my($win,$bf) = @_;
	    eval q((($win)-> &_leave = $bf));
    }' unless defined(&leaveok);
    eval 'sub scrollok {
        my($win,$bf) = @_;
	    eval q((($win)-> &_scroll = $bf));
    }' unless defined(&scrollok);
    eval 'sub flushok {
        my($win,$bf) = @_;
	    eval q(($bf ? (($win)-> &_flags |=  &_FLUSH):(($win)-> &_flags &= ~ &_FLUSH)));
    }' unless defined(&flushok);
    eval 'sub getyx {
        my($win,$y,$x) = @_;
	    eval q($y = ($win)-> &_cury, $x = ($win)-> &_curx);
    }' unless defined(&getyx);
    eval 'sub cboxalt {
        my($w) = @_;
	    eval q( &superbox1($w,0,0,($w)-> &_maxy,($w)-> &_maxx, $BY[3], $BY[1], $BY[0], $BY[2], $BY[5], $BY[4], &Bya));
    }' unless defined(&cboxalt);
    eval 'sub drawboxalt {
        my($w,$y,$x,$l,$c) = @_;
	    eval q( &superbox1($w,($y),($x),($l),($c), $BY[3], $BY[1], $BY[0], $BY[2], $BY[5], $BY[4], &Bya));
    }' unless defined(&drawboxalt);
    if(((defined(&IS1) ? &IS1 : 0)|(defined(&IS2) ? &IS2 : 0)|(defined(&V7) ? &V7 : 0))) {
	eval 'sub raw () {
	    eval q(( ($_tty->{sg_flags})|= &RAW,  &_pfast= &_rawmode= &TRUE,  &stty( &_tty_ch,& &_tty)));
	}' unless defined(&raw);
	eval 'sub noraw () {
	    eval q(( ($_tty->{sg_flags})&=~ &RAW, &_rawmode= &FALSE, &_pfast=!( ($_tty->{sg_flags})& &CRMOD),  &stty( &_tty_ch,& &_tty)));
	}' unless defined(&noraw);
	eval 'sub crmode () {
	    eval q(( ($_tty->{sg_flags}) |=  &CBREAK,  &_rawmode =  &TRUE,  &stty( &_tty_ch,& &_tty)));
	}' unless defined(&crmode);
	eval 'sub nocrmode () {
	    eval q(( ($_tty->{sg_flags}) &= ~ &CBREAK, &_rawmode= &FALSE, &stty( &_tty_ch,& &_tty)));
	}' unless defined(&nocrmode);
	eval 'sub echo () {
	    eval q(( ($_tty->{sg_flags}) |=  &ECHO,  &_echoit =  &TRUE,  &stty( &_tty_ch, & &_tty)));
	}' unless defined(&echo);
	eval 'sub noecho () {
	    eval q(( ($_tty->{sg_flags}) &= ~ &ECHO,  &_echoit =  &FALSE,  &stty( &_tty_ch, & &_tty)));
	}' unless defined(&noecho);
	eval 'sub nl () {
	    eval q(( ($_tty->{sg_flags}) |=  &CRMOD, &_pfast =  &_rawmode, &stty( &_tty_ch, & &_tty)));
	}' unless defined(&nl);
	eval 'sub nonl () {
	    eval q(( ($_tty->{sg_flags}) &= ~ &CRMOD,  &_pfast =  &TRUE,  &stty( &_tty_ch, & &_tty)));
	}' unless defined(&nonl);
	eval 'sub savetty () {
	    eval q(( &gtty( &_tty_ch, & &_tty),  &_res_flg =  ($_tty->{sg_flags})));
	}' unless defined(&savetty);
	eval 'sub resetty () {
	    eval q(( ($_tty->{sg_flags}) =  &_res_flg,  &stty( &_tty_ch, & &_tty)));
	}' unless defined(&resetty);
    } else {
	eval 'sub Stty {
	    my($chan, $data) = @_;
    	    eval q( &ioctl($chan,  &TCSETAW, $data));
	}' unless defined(&Stty);
	eval 'sub Gtty {
	    my($chan, $data) = @_;
    	    eval q( &ioctl($chan,  &TCGETA, $data));
	}' unless defined(&Gtty);
    }
}
1;
