require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_h_diag)) {
    eval 'sub _h_diag () {1;}' unless defined(&_h_diag);
    require 'diag/diag_define.ph';
    eval 'sub DIAG_EXIT_GOOD () {0;}' unless defined(&DIAG_EXIT_GOOD);
    eval 'sub DIAG_EXIT_DEVICE_ERROR () {1;}' unless defined(&DIAG_EXIT_DEVICE_ERROR);
    eval 'sub DIAG_EXIT_INTERRUPT () {2;}' unless defined(&DIAG_EXIT_INTERRUPT);
    eval 'sub DIAG_EXIT_NO_DEVICE () {3;}' unless defined(&DIAG_EXIT_NO_DEVICE);
    eval 'sub DIAG_EXIT_BUSY () {4;}' unless defined(&DIAG_EXIT_BUSY);
    eval 'sub DIAG_EXIT_LOCK_ERROR () {5;}' unless defined(&DIAG_EXIT_LOCK_ERROR);
    eval 'sub DIAG_EXIT_OBJCLASS_ERROR () {6;}' unless defined(&DIAG_EXIT_OBJCLASS_ERROR);
    eval 'sub DIAG_EXIT_USAGE () {7;}' unless defined(&DIAG_EXIT_USAGE);
    eval 'sub DIAG_EXIT_SCREEN () {8;}' unless defined(&DIAG_EXIT_SCREEN);
    eval 'sub DIAG_EXIT_NoPDiagDev () {9;}' unless defined(&DIAG_EXIT_NoPDiagDev);
    eval 'sub DIAG_EXIT_NO_DIAGSUPPORT () {10;}' unless defined(&DIAG_EXIT_NO_DIAGSUPPORT);
    eval 'sub DIAG_EXIT_NOT_MISSING () {11;}' unless defined(&DIAG_EXIT_NOT_MISSING);
    eval 'sub DIAG_EXIT_DCTRL_RELOAD () {98;}' unless defined(&DIAG_EXIT_DCTRL_RELOAD);
    eval 'sub DIAG_EXIT_RESPAWN () {201;}' unless defined(&DIAG_EXIT_RESPAWN);
    eval 'sub PTYPE () {0;}' unless defined(&PTYPE);
    eval 'sub PCLASS () {1;}' unless defined(&PCLASS);
    eval 'sub PSCLASS () {2;}' unless defined(&PSCLASS);
    eval 'sub DIAGNOSTICS () {"/usr/lpp/diagnostics";}' unless defined(&DIAGNOSTICS);
    eval 'sub DEFAULT_DADIR () {"/usr/lpp/diagnostics/da";}' unless defined(&DEFAULT_DADIR);
    eval 'sub DEFAULT_SLIHDIR () {"/usr/lpp/diagnostics/slih";}' unless defined(&DEFAULT_SLIHDIR);
    eval 'sub DEFAULT_UTILDIR () {"/usr/lpp/diagnostics/bin";}' unless defined(&DEFAULT_UTILDIR);
    eval 'sub DIAGNLPATH () {"/usr/lpp/diagnostics/catalog";}' unless defined(&DIAGNLPATH);
    eval 'sub DIAGDATA () {"/etc/lpp/diagnostics/data";}' unless defined(&DIAGDATA);
    eval 'sub DIAGSHIPDATA () {"/usr/lpp/diagnostics/data";}' unless defined(&DIAGSHIPDATA);
    eval 'sub DIAGNOSTICS_TU_LIB () {"/usr/lpp/diagnostics/lib";}' unless defined(&DIAGNOSTICS_TU_LIB);
    eval 'sub DEFAULTOBJPATH () {"/etc/objrepos";}' unless defined(&DEFAULTOBJPATH);
    eval 'sub CFGMETHODSDIR () {"/usr/lib/methods";}' unless defined(&CFGMETHODSDIR);
    eval 'sub PORT_CAT () {"dcda.cat";}' unless defined(&PORT_CAT);
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    unless(defined(&NAMESIZE)) {
	eval 'sub NAMESIZE () {16;}' unless defined(&NAMESIZE);
    }
    eval 'sub MAX_EXPECT () {16;}' unless defined(&MAX_EXPECT);
    eval 'sub DIAG_BADRC () {0xff;}' unless defined(&DIAG_BADRC);
    eval 'sub CPU_DRAWER () {"cpu1";}' unless defined(&CPU_DRAWER);
    eval 'sub ASYNC_DRAWER () {"async1";}' unless defined(&ASYNC_DRAWER);
    eval 'sub SCSI_DRAWER () {"scsi1";}' unless defined(&SCSI_DRAWER);
    eval 'sub MEDIA_DRAWER () {"media1";}' unless defined(&MEDIA_DRAWER);
    eval 'sub SYSUNIT () {"sysunit0";}' unless defined(&SYSUNIT);
    eval 'sub CLASS_SYSUNIT () {"sysunit";}' unless defined(&CLASS_SYSUNIT);
    eval 'sub CLASS_ADAPTER () {"adapter";}' unless defined(&CLASS_ADAPTER);
    eval 'sub CLASS_DRAWER () {"drawer";}' unless defined(&CLASS_DRAWER);
    eval 'sub CLASS_SYSPLANAR () {"planar";}' unless defined(&CLASS_SYSPLANAR);
    eval 'sub CLASS_IOPLANAR () {"ioplanar";}' unless defined(&CLASS_IOPLANAR);
    eval 'sub CLASS_MEMORY () {"memory";}' unless defined(&CLASS_MEMORY);
    eval 'sub CLASS_DISK () {"disk";}' unless defined(&CLASS_DISK);
    eval 'sub CLASS_PROC () {"processor";}' unless defined(&CLASS_PROC);
    eval 'sub SUBCLASS_SCSI () {"scsi";}' unless defined(&SUBCLASS_SCSI);
    eval 'sub CLASS_DEFAULT () {"";}' unless defined(&CLASS_DEFAULT);
    eval 'sub BASE_OBJ () {"sys0";}' unless defined(&BASE_OBJ);
    eval 'sub SYSTEM_CHECKOUT () {0;}' unless defined(&SYSTEM_CHECKOUT);
    eval 'sub SYSX_NO () {0x1;}' unless defined(&SYSX_NO);
    eval 'sub SYSX_ALONE () {0x2;}' unless defined(&SYSX_ALONE);
    eval 'sub SYSX_MEDIA () {0x4;}' unless defined(&SYSX_MEDIA);
    eval 'sub SYSX_INTERACTION () { &SYSX_MEDIA;}' unless defined(&SYSX_INTERACTION);
    eval 'sub SYSX_LONG () {0x8;}' unless defined(&SYSX_LONG);
    eval 'sub SUPTESTS_SHR () {0x1;}' unless defined(&SUPTESTS_SHR);
    eval 'sub SUPTESTS_SUB () {0x2;}' unless defined(&SUPTESTS_SUB);
    eval 'sub SUPTESTS_FULL () {0x4;}' unless defined(&SUPTESTS_FULL);
    eval 'sub SUPTESTS_MS1 () {0x8;}' unless defined(&SUPTESTS_MS1);
    eval 'sub SUPTESTS_MS2 () {0x10;}' unless defined(&SUPTESTS_MS2);
    eval 'sub SUPTESTS_HFT () {0x20;}' unless defined(&SUPTESTS_HFT);
    eval 'sub SUPTESTS_DIAGEX () {0x40;}' unless defined(&SUPTESTS_DIAGEX);
    eval 'sub DIAG_DTL () {1;}' unless defined(&DIAG_DTL);
    eval 'sub DIAG_NOTDLT () {2;}' unless defined(&DIAG_NOTDLT);
    eval 'sub DIAG_DS () {4;}' unless defined(&DIAG_DS);
    eval 'sub DIAG_CON () {8;}' unless defined(&DIAG_CON);
    eval 'sub DIAG_DA_SRN () {16;}' unless defined(&DIAG_DA_SRN);
    eval 'sub DIAG_SA_SELECTION () {32;}' unless defined(&DIAG_SA_SELECTION);
    eval 'sub DIAG_SA_CON_CHILD () {64;}' unless defined(&DIAG_SA_CON_CHILD);
    eval 'sub DIAG_PAR () {1;}' unless defined(&DIAG_PAR);
    eval 'sub DIAG_SIB () {2;}' unless defined(&DIAG_SIB);
    eval 'sub TSTLVL_NOTEST () {0;}' unless defined(&TSTLVL_NOTEST);
    eval 'sub TSTLVL_SHR () {1;}' unless defined(&TSTLVL_SHR);
    eval 'sub TSTLVL_SUB () {2;}' unless defined(&TSTLVL_SUB);
    eval 'sub TSTLVL_FULL () {4;}' unless defined(&TSTLVL_FULL);
    eval("sub RTMENU_DEF () { 0; }") unless defined(&RTMENU_DEF);
    eval("sub RTMENU_DDTL () { 1; }") unless defined(&RTMENU_DDTL);
    eval 'sub DIAG_NO () {0;}' unless defined(&DIAG_NO);
    eval 'sub DIAG_YES () {1;}' unless defined(&DIAG_YES);
    eval 'sub DIAG_FALSE () {0;}' unless defined(&DIAG_FALSE);
    eval 'sub DIAG_TRUE () {1;}' unless defined(&DIAG_TRUE);
    eval 'sub NOT_IN_USE () {-1;}' unless defined(&NOT_IN_USE);
    eval 'sub NEW () {0;}' unless defined(&NEW);
    eval 'sub DONTCARE () {1;}' unless defined(&DONTCARE);
    eval 'sub SAME () {2;}' unless defined(&SAME);
    eval 'sub MISSING () {3;}' unless defined(&MISSING);
    eval 'sub INSERT_DSKT_MSG () {1;}' unless defined(&INSERT_DSKT_MSG);
    eval 'sub RD_DSKT_MSG () {2;}' unless defined(&RD_DSKT_MSG);
    eval 'sub BAD_DSKT_MSG () {3;}' unless defined(&BAD_DSKT_MSG);
    eval 'sub WRONG_DSKT_MSG () {4;}' unless defined(&WRONG_DSKT_MSG);
    eval 'sub LINE_LENGTH () {74;}' unless defined(&LINE_LENGTH);
    eval 'sub DIAG_SEL_TYPE () {0;}' unless defined(&DIAG_SEL_TYPE);
    eval 'sub NTF_TYPE () {1;}' unless defined(&NTF_TYPE);
    eval 'sub NTF_LOC_COL () {15;}' unless defined(&NTF_LOC_COL);
    eval 'sub DS_LOC_COL () {13;}' unless defined(&DS_LOC_COL);
    eval 'sub READING_DSKT () {0x801040;}' unless defined(&READING_DSKT);
    eval 'sub PROB_REPORT () {0x801014;}' unless defined(&PROB_REPORT);
    eval 'sub DC_SOURCE_SOFT () {0x803;}' unless defined(&DC_SOURCE_SOFT);
    eval 'sub INIT () {1;}' unless defined(&INIT);
    eval 'sub SUBSEQ () {2;}' unless defined(&SUBSEQ);
    eval 'sub TERMI () {3;}' unless defined(&TERMI);
    eval 'sub NVRAMEL () {4;}' unless defined(&NVRAMEL);
    eval 'sub PERM () {"PERM";}' unless defined(&PERM);
    eval 'sub TEMP () {"TEMP";}' unless defined(&TEMP);
    eval 'sub PERF () {"PERF";}' unless defined(&PERF);
    eval 'sub PEND () {"PEND";}' unless defined(&PEND);
    eval 'sub UNKN () {"UNKN";}' unless defined(&UNKN);
    eval 'sub HARDWARE () {ord(\'H\');}' unless defined(&HARDWARE);
    eval 'sub SOFTWARE () {ord(\'S\');}' unless defined(&SOFTWARE);
    eval 'sub IPLSOURCE_DISK () {0;}' unless defined(&IPLSOURCE_DISK);
    eval 'sub IPLSOURCE_CDROM () {1;}' unless defined(&IPLSOURCE_CDROM);
    eval 'sub IPLSOURCE_TAPE () {2;}' unless defined(&IPLSOURCE_TAPE);
    eval 'sub IPLSOURCE_LAN () {3;}' unless defined(&IPLSOURCE_LAN);
    eval 'sub SUPTESTS_PERIODIC_MODE () {0x1;}' unless defined(&SUPTESTS_PERIODIC_MODE);
    eval 'sub DEFAULT_TESTTIME () {9999;}' unless defined(&DEFAULT_TESTTIME);
    eval 'sub DEFAULT_IOP_TESTTIME () {400;}' unless defined(&DEFAULT_IOP_TESTTIME);
    eval 'sub DEFAULT_DISK_TESTTIME () {300;}' unless defined(&DEFAULT_DISK_TESTTIME);
    eval 'sub DEFAULT_PROC_TESTTIME () {400;}' unless defined(&DEFAULT_PROC_TESTTIME);
    eval 'sub DAVARS_ERRCODE () {"Error_code";}' unless defined(&DAVARS_ERRCODE);
    eval 'sub DAVARS_ERRLOG () {"ErrorLog";}' unless defined(&DAVARS_ERRLOG);
    eval 'sub LONG_PHYLOC () {"LongPhyLoc";}' unless defined(&LONG_PHYLOC);
    eval 'sub SCHEDULE_ELA () {"schedule_ela";}' unless defined(&SCHEDULE_ELA);
    eval 'sub DIAG_REMINDER () {"diag_reminder";}' unless defined(&DIAG_REMINDER);
    eval 'sub REMIND_TIME () {"remind_time";}' unless defined(&REMIND_TIME);
    eval 'sub REMIND_FREQ () {"remind_freq";}' unless defined(&REMIND_FREQ);
    eval 'sub REMIND_DAY () {"remind_day";}' unless defined(&REMIND_DAY);
    eval 'sub DEFAULT_REMIND_TIME () {"0800";}' unless defined(&DEFAULT_REMIND_TIME);
    eval 'sub DEFAULT_REMIND_FREQ () {"weekly";}' unless defined(&DEFAULT_REMIND_FREQ);
    eval 'sub DEFAULT_REMIND_DAY () {"Tuesday";}' unless defined(&DEFAULT_REMIND_DAY);
    eval 'sub REMIND_TIME_SIZE () {4;}' unless defined(&REMIND_TIME_SIZE);
    eval 'sub REMIND_FREQ_SIZE () {7;}' unless defined(&REMIND_FREQ_SIZE);
    eval 'sub REMIND_DAY_SIZE () {9;}' unless defined(&REMIND_DAY_SIZE);
}
1;
