require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_DUMPRESTOR)) {
    eval 'sub _H_DUMPRESTOR () {1;}' unless defined(&_H_DUMPRESTOR);
    eval 'sub TP_BSIZE () {1024;}' unless defined(&TP_BSIZE);
    eval 'sub NTREC () {10;}' unless defined(&NTREC);
    eval 'sub HIGHDENSITYTREC () {32;}' unless defined(&HIGHDENSITYTREC);
    eval 'sub TP_NINDIR () {( &TP_BSIZE/2);}' unless defined(&TP_NINDIR);
    eval 'sub TS_TAPE () {1;}' unless defined(&TS_TAPE);
    eval 'sub TS_INODE () {2;}' unless defined(&TS_INODE);
    eval 'sub TS_BITS () {3;}' unless defined(&TS_BITS);
    eval 'sub TS_ADDR () {4;}' unless defined(&TS_ADDR);
    eval 'sub TS_END () {5;}' unless defined(&TS_END);
    eval 'sub TS_CLRI () {6;}' unless defined(&TS_CLRI);
    eval 'sub TS_ACL () {7;}' unless defined(&TS_ACL);
    eval 'sub TS_PCL () {8;}' unless defined(&TS_PCL);
    eval 'sub TS_INODE_LF () {9;}' unless defined(&TS_INODE_LF);
    eval 'sub TS_SEC () {10;}' unless defined(&TS_SEC);
    eval 'sub TS_J2DIR () {11;}' unless defined(&TS_J2DIR);
    eval 'sub TS_INODE_LN () {12;}' unless defined(&TS_INODE_LN);
    eval 'sub OFS_MAGIC () {60011;}' unless defined(&OFS_MAGIC);
    eval 'sub NFS_MAGIC () {60012;}' unless defined(&NFS_MAGIC);
    eval 'sub MAGIC () {60011;}' unless defined(&MAGIC);
    eval 'sub PACKED_MAGIC () {60012;}' unless defined(&PACKED_MAGIC);
    eval 'sub B1V1_MAGIC () {60013;}' unless defined(&B1V1_MAGIC);
    eval 'sub B1V1_PACKED_MAGIC () {60014;}' unless defined(&B1V1_PACKED_MAGIC);
    eval 'sub B1V2_MAGIC () {60015;}' unless defined(&B1V2_MAGIC);
    eval 'sub B1V2_PACKED_MAGIC () {60016;}' unless defined(&B1V2_PACKED_MAGIC);
    eval 'sub XIX_MAGIC () {60013;}' unless defined(&XIX_MAGIC);
    eval 'sub JFS2_MAGIC () {60017;}' unless defined(&JFS2_MAGIC);
    eval 'sub CHECKSUM () {84446;}' unless defined(&CHECKSUM);
    eval 'sub BSD_NDADDR () {12;}' unless defined(&BSD_NDADDR);
    eval 'sub BSD_NIADDR () {3;}' unless defined(&BSD_NIADDR);
    eval 'sub JFSDILENGTH () {128;}' unless defined(&JFSDILENGTH);
    eval 'sub spcl () { ($u_spcl->{s_spcl});}' unless defined(&spcl);
    eval 'sub bsd_di_ic () { ($di_un->{di_icom});}' unless defined(&bsd_di_ic);
    eval 'sub bsd_di_mode () { ($bsd_di_ic->{ic_mode});}' unless defined(&bsd_di_mode);
    eval 'sub bsd_di_nlink () { ($bsd_di_ic->{ic_nlink});}' unless defined(&bsd_di_nlink);
    eval 'sub bsd_di_uid () { ($bsd_di_ic->{ic_uid});}' unless defined(&bsd_di_uid);
    eval 'sub bsd_di_gid () { ($bsd_di_ic->{ic_gid});}' unless defined(&bsd_di_gid);
    eval 'sub bsd_di_db () { ($bsd_di_ic->{ic_db});}' unless defined(&bsd_di_db);
    eval 'sub bsd_di_ib () { ($bsd_di_ic->{ic_ib});}' unless defined(&bsd_di_ib);
    eval 'sub bsd_di_atime () { ($bsd_di_ic->{ic_atime});}' unless defined(&bsd_di_atime);
    eval 'sub bsd_di_mtime () { ($bsd_di_ic->{ic_mtime});}' unless defined(&bsd_di_mtime);
    eval 'sub bsd_di_ctime () { ($bsd_di_ic->{ic_ctime});}' unless defined(&bsd_di_ctime);
    eval 'sub bsd_di_rdev () { ($bsd_di_ic->{ic_db[0]});}' unless defined(&bsd_di_rdev);
    eval 'sub bsd_di_blocks () { ($bsd_di_ic->{ic_blocks});}' unless defined(&bsd_di_blocks);
    eval 'sub bsd_di_size () { ($bsd_di_ic->{ic_size}->{val[1]});}' unless defined(&bsd_di_size);
    eval 'sub bsd_di_size_lo () { ($bsd_di_ic->{ic_size}->{val[1]});}' unless defined(&bsd_di_size_lo);
    eval 'sub bsd_di_size_hi () { ($bsd_di_ic->{ic_size}->{val[0]});}' unless defined(&bsd_di_size_hi);
    eval 'sub DUMPOUTFMT () {"%s %c %s";}' unless defined(&DUMPOUTFMT);
    eval 'sub DUMPINFMT () {"%s %c %[^\\n]\\n";}' unless defined(&DUMPINFMT);
    eval 'sub MWORD {
        my($m,$i) = @_;
	    eval q(($m->[($i-1)/ &NBBY]));
    }' unless defined(&MWORD);
    eval 'sub MBIT {
        my($i) = @_;
	    eval q((1<<(($i-1)% &NBBY)));
    }' unless defined(&MBIT);
    eval 'sub BIS {
        my($i,$w) = @_;
	    eval q(( &MWORD($w,$i) |=  &MBIT($i)));
    }' unless defined(&BIS);
    eval 'sub BIC {
        my($i,$w) = @_;
	    eval q(( &MWORD($w,$i) &= ~ &MBIT($i)));
    }' unless defined(&BIC);
    eval 'sub BIT {
        my($i,$w) = @_;
	    eval q(( &MWORD($w,$i) &  &MBIT($i)));
    }' unless defined(&BIT);
    eval 'sub MSIZ () {(8*1024);}' unless defined(&MSIZ);
    eval 'sub RDTMAX () { &BSIZE;}' unless defined(&RDTMAX);
    eval 'sub FS_VOLUME () {0;}' unless defined(&FS_VOLUME);
    eval 'sub FS_FINDEX () {1;}' unless defined(&FS_FINDEX);
    eval 'sub FS_CLRI () {2;}' unless defined(&FS_CLRI);
    eval 'sub FS_BITS () {3;}' unless defined(&FS_BITS);
    eval 'sub FS_OINODE () {4;}' unless defined(&FS_OINODE);
    eval 'sub FS_ONAME () {5;}' unless defined(&FS_ONAME);
    eval 'sub FS_VOLEND () {6;}' unless defined(&FS_VOLEND);
    eval 'sub FS_END () {7;}' unless defined(&FS_END);
    eval 'sub FS_DINODE () {8;}' unless defined(&FS_DINODE);
    eval 'sub FS_NAME () {9;}' unless defined(&FS_NAME);
    eval 'sub FS_DS () {10;}' unless defined(&FS_DS);
    eval 'sub FS_NAME_X () {11;}' unless defined(&FS_NAME_X);
    eval 'sub FS_NAME_LF () {12;}' unless defined(&FS_NAME_LF);
    eval 'sub FXLEN () {80;}' unless defined(&FXLEN);
    eval 'sub TBEG () {0;}' unless defined(&TBEG);
    eval 'sub TEND () {1;}' unless defined(&TEND);
    eval 'sub TINS () {2;}' unless defined(&TINS);
    eval 'sub BPW () {8;}' unless defined(&BPW);
    eval 'sub LOGBPW () {3;}' unless defined(&LOGBPW);
    eval 'sub btow {
        my($x) = @_;
	    eval q(( (($x) +  &BPW - 1) >>  &LOGBPW));
    }' unless defined(&btow);
    eval 'sub wtob {
        my($x) = @_;
	    eval q(( ($x) <<  &LOGBPW ));
    }' unless defined(&wtob);
    eval 'sub swap_card8 {
        my($d) = @_;
	    eval q((((( &card8)  &swap_card4(($d) >> 32)) & 0xffffffff) | (((( &card8)  &swap_card4($d)) << 32) & 1.84467440694146e+19)));
    }' unless defined(&swap_card8);
    eval 'sub swap_card4 {
        my($d) = @_;
	    eval q((((($d) >> 24) & 0xff) | ((($d) >> 8) & 0xff00) | ((($d) << 8) & 0xff0000) | ((($d) << 24) & 0xff000000)));
    }' unless defined(&swap_card4);
    eval 'sub swap_card2 {
        my($d) = @_;
	    eval q((( &card2) (((($d) >> 8) & 0xff) | ((($d) << 8) & 0xff00))));
    }' unless defined(&swap_card2);
    if(defined(&_POWER)) {
	eval 'sub rlonglong {
	    my($a) = @_;
    	    eval q((($a) =  &swap_card8($a)));
	}' unless defined(&rlonglong);
	eval 'sub wlonglong {
	    my($a) = @_;
    	    eval q((($a) =  &swap_card8($a)));
	}' unless defined(&wlonglong);
	eval 'sub rlong {
	    my($a) = @_;
    	    eval q((($a) =  &swap_card4($a)));
	}' unless defined(&rlong);
	eval 'sub wlong {
	    my($a) = @_;
    	    eval q((($a) =  &swap_card4($a)));
	}' unless defined(&wlong);
	eval 'sub rshort {
	    my($a) = @_;
    	    eval q((($a) =  &swap_card2($a)));
	}' unless defined(&rshort);
	eval 'sub wshort {
	    my($a) = @_;
    	    eval q((($a) =  &swap_card2($a)));
	}' unless defined(&wshort);
    } else {
	eval 'sub rlonglong {
	    my($a) = @_;
    	    eval q(($a));
	}' unless defined(&rlonglong);
	eval 'sub wlonglong {
	    my($a) = @_;
    	    eval q(($a));
	}' unless defined(&wlonglong);
	eval 'sub rlong {
	    my($a) = @_;
    	    eval q(($a));
	}' unless defined(&rlong);
	eval 'sub wlong {
	    my($a) = @_;
    	    eval q(($a));
	}' unless defined(&wlong);
	eval 'sub rshort {
	    my($a) = @_;
    	    eval q(($a));
	}' unless defined(&rshort);
	eval 'sub wshort {
	    my($a) = @_;
    	    eval q(($a));
	}' unless defined(&wshort);
    }
    eval 'sub SIZHDR () { &btow($sizeof{\'struct hdr\'});}' unless defined(&SIZHDR);
    eval 'sub DUMNAME () {4;}' unless defined(&DUMNAME);
    eval 'sub DUMNAME2 () {8;}' unless defined(&DUMNAME2);
    eval 'sub SIZSTR () {16;}' unless defined(&SIZSTR);
    require 'sys/param.ph';
    eval 'sub NAMESZ () { &PATH_MAX+1;}' unless defined(&NAMESZ);
    eval 'sub min {
        my($a,$b) = @_;
	    eval q(( (($a) < ($b))? ($a): ($b) ));
    }' unless defined(&min);
    eval 'sub max {
        my($a,$b) = @_;
	    eval q(( (($a) > ($b))? ($a): ($b) ));
    }' unless defined(&max);
    eval 'sub BYNAME () {100;}' unless defined(&BYNAME);
    eval 'sub BYINODE () {101;}' unless defined(&BYINODE);
    eval 'sub BYMD () {102;}' unless defined(&BYMD);
    eval 'sub DONTCOUNT () {-1;}' unless defined(&DONTCOUNT);
    eval 'sub DEF_LEV () {ord(\'9\');}' unless defined(&DEF_LEV);
    eval 'sub A_WHILE () {150;}' unless defined(&A_WHILE);
    eval 'sub NTRACKS () {1;}' unless defined(&NTRACKS);
    eval 'sub ROOT_FILSYS () {"/dev/hd0";}' unless defined(&ROOT_FILSYS);
    eval 'sub DEF_FILSYS () { &ROOT_FILSYS;}' unless defined(&DEF_FILSYS);
    eval 'sub DEF_MEDIUM () {"/dev/rfd0";}' unless defined(&DEF_MEDIUM);
    eval 'sub DEF_DTYP () { &DD_DISK;}' unless defined(&DEF_DTYP);
    eval 'sub DEF_CLUSTER () {100;}' unless defined(&DEF_CLUSTER);
    eval 'sub DEF_TLEN () {4500;}' unless defined(&DEF_TLEN);
    eval 'sub DEF_TDEN () {700;}' unless defined(&DEF_TDEN);
    eval 'sub IRG () {1;}' unless defined(&IRG);
}
1;
