require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_ERRNO)) {
    eval 'sub _H_ERRNO () {1;}' unless defined(&_H_ERRNO);
    require 'standards.ph';
    if(defined(&_ANSI_C_SOURCE)) {
	unless(defined(&_KERNEL)) {
	    if(defined( &_THREAD_SAFE) || defined( &_THREAD_SAFE_ERRNO)) {
		eval 'sub errno () {(* &_Errno());}' unless defined(&errno);
	    } else {
	    }
	}
	if(defined(&_ALL_SOURCE)) {
	}
	eval 'sub EPERM () {1;}' unless defined(&EPERM);
	eval 'sub ENOENT () {2;}' unless defined(&ENOENT);
	eval 'sub ESRCH () {3;}' unless defined(&ESRCH);
	eval 'sub EINTR () {4;}' unless defined(&EINTR);
	eval 'sub EIO () {5;}' unless defined(&EIO);
	eval 'sub ENXIO () {6;}' unless defined(&ENXIO);
	eval 'sub E2BIG () {7;}' unless defined(&E2BIG);
	eval 'sub ENOEXEC () {8;}' unless defined(&ENOEXEC);
	eval 'sub EBADF () {9;}' unless defined(&EBADF);
	eval 'sub ECHILD () {10;}' unless defined(&ECHILD);
	eval 'sub EAGAIN () {11;}' unless defined(&EAGAIN);
	eval 'sub ENOMEM () {12;}' unless defined(&ENOMEM);
	eval 'sub EACCES () {13;}' unless defined(&EACCES);
	eval 'sub EFAULT () {14;}' unless defined(&EFAULT);
	eval 'sub ENOTBLK () {15;}' unless defined(&ENOTBLK);
	eval 'sub EBUSY () {16;}' unless defined(&EBUSY);
	eval 'sub EEXIST () {17;}' unless defined(&EEXIST);
	eval 'sub EXDEV () {18;}' unless defined(&EXDEV);
	eval 'sub ENODEV () {19;}' unless defined(&ENODEV);
	eval 'sub ENOTDIR () {20;}' unless defined(&ENOTDIR);
	eval 'sub EISDIR () {21;}' unless defined(&EISDIR);
	eval 'sub EINVAL () {22;}' unless defined(&EINVAL);
	eval 'sub ENFILE () {23;}' unless defined(&ENFILE);
	eval 'sub EMFILE () {24;}' unless defined(&EMFILE);
	eval 'sub ENOTTY () {25;}' unless defined(&ENOTTY);
	eval 'sub ETXTBSY () {26;}' unless defined(&ETXTBSY);
	eval 'sub EFBIG () {27;}' unless defined(&EFBIG);
	eval 'sub ENOSPC () {28;}' unless defined(&ENOSPC);
	eval 'sub ESPIPE () {29;}' unless defined(&ESPIPE);
	eval 'sub EROFS () {30;}' unless defined(&EROFS);
	eval 'sub EMLINK () {31;}' unless defined(&EMLINK);
	eval 'sub EPIPE () {32;}' unless defined(&EPIPE);
	eval 'sub EDOM () {33;}' unless defined(&EDOM);
	eval 'sub ERANGE () {34;}' unless defined(&ERANGE);
	eval 'sub ENOMSG () {35;}' unless defined(&ENOMSG);
	eval 'sub EIDRM () {36;}' unless defined(&EIDRM);
	eval 'sub ECHRNG () {37;}' unless defined(&ECHRNG);
	eval 'sub EL2NSYNC () {38;}' unless defined(&EL2NSYNC);
	eval 'sub EL3HLT () {39;}' unless defined(&EL3HLT);
	eval 'sub EL3RST () {40;}' unless defined(&EL3RST);
	eval 'sub ELNRNG () {41;}' unless defined(&ELNRNG);
	eval 'sub EUNATCH () {42;}' unless defined(&EUNATCH);
	eval 'sub ENOCSI () {43;}' unless defined(&ENOCSI);
	eval 'sub EL2HLT () {44;}' unless defined(&EL2HLT);
	eval 'sub EDEADLK () {45;}' unless defined(&EDEADLK);
	eval 'sub ENOTREADY () {46;}' unless defined(&ENOTREADY);
	eval 'sub EWRPROTECT () {47;}' unless defined(&EWRPROTECT);
	eval 'sub EFORMAT () {48;}' unless defined(&EFORMAT);
	eval 'sub ENOLCK () {49;}' unless defined(&ENOLCK);
	eval 'sub ENOCONNECT () {50;}' unless defined(&ENOCONNECT);
	eval 'sub ESTALE () {52;}' unless defined(&ESTALE);
	eval 'sub EDIST () {53;}' unless defined(&EDIST);
	if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0)==1) {
	    eval 'sub EWOULDBLOCK () { &EAGAIN;}' unless defined(&EWOULDBLOCK);
	} else {
	    eval 'sub EWOULDBLOCK () {54;}' unless defined(&EWOULDBLOCK);
	}
	eval 'sub EINPROGRESS () {55;}' unless defined(&EINPROGRESS);
	eval 'sub EALREADY () {56;}' unless defined(&EALREADY);
	eval 'sub ENOTSOCK () {57;}' unless defined(&ENOTSOCK);
	eval 'sub EDESTADDRREQ () {58;}' unless defined(&EDESTADDRREQ);
	eval 'sub EDESTADDREQ () { &EDESTADDRREQ;}' unless defined(&EDESTADDREQ);
	eval 'sub EMSGSIZE () {59;}' unless defined(&EMSGSIZE);
	eval 'sub EPROTOTYPE () {60;}' unless defined(&EPROTOTYPE);
	eval 'sub ENOPROTOOPT () {61;}' unless defined(&ENOPROTOOPT);
	eval 'sub EPROTONOSUPPORT () {62;}' unless defined(&EPROTONOSUPPORT);
	eval 'sub ESOCKTNOSUPPORT () {63;}' unless defined(&ESOCKTNOSUPPORT);
	eval 'sub EOPNOTSUPP () {64;}' unless defined(&EOPNOTSUPP);
	eval 'sub EPFNOSUPPORT () {65;}' unless defined(&EPFNOSUPPORT);
	eval 'sub EAFNOSUPPORT () {66;}' unless defined(&EAFNOSUPPORT);
	eval 'sub EADDRINUSE () {67;}' unless defined(&EADDRINUSE);
	eval 'sub EADDRNOTAVAIL () {68;}' unless defined(&EADDRNOTAVAIL);
	eval 'sub ENETDOWN () {69;}' unless defined(&ENETDOWN);
	eval 'sub ENETUNREACH () {70;}' unless defined(&ENETUNREACH);
	eval 'sub ENETRESET () {71;}' unless defined(&ENETRESET);
	eval 'sub ECONNABORTED () {72;}' unless defined(&ECONNABORTED);
	eval 'sub ECONNRESET () {73;}' unless defined(&ECONNRESET);
	eval 'sub ENOBUFS () {74;}' unless defined(&ENOBUFS);
	eval 'sub EISCONN () {75;}' unless defined(&EISCONN);
	eval 'sub ENOTCONN () {76;}' unless defined(&ENOTCONN);
	eval 'sub ESHUTDOWN () {77;}' unless defined(&ESHUTDOWN);
	eval 'sub ETIMEDOUT () {78;}' unless defined(&ETIMEDOUT);
	eval 'sub ECONNREFUSED () {79;}' unless defined(&ECONNREFUSED);
	eval 'sub EHOSTDOWN () {80;}' unless defined(&EHOSTDOWN);
	eval 'sub EHOSTUNREACH () {81;}' unless defined(&EHOSTUNREACH);
	eval 'sub ERESTART () {82;}' unless defined(&ERESTART);
	eval 'sub EPROCLIM () {83;}' unless defined(&EPROCLIM);
	eval 'sub EUSERS () {84;}' unless defined(&EUSERS);
	eval 'sub ELOOP () {85;}' unless defined(&ELOOP);
	eval 'sub ENAMETOOLONG () {86;}' unless defined(&ENAMETOOLONG);
	if(defined( &_ALL_SOURCE)  && !defined( &_LINUX_SOURCE_COMPAT)) {
	    eval 'sub ENOTEMPTY () { &EEXIST;}' unless defined(&ENOTEMPTY);
	} else {
	    eval 'sub ENOTEMPTY () {87;}' unless defined(&ENOTEMPTY);
	}
	eval 'sub EDQUOT () {88;}' unless defined(&EDQUOT);
	eval 'sub ECORRUPT () {89;}' unless defined(&ECORRUPT);
	eval 'sub EREMOTE () {93;}' unless defined(&EREMOTE);
	eval 'sub ENOSYS () {109;}' unless defined(&ENOSYS);
	eval 'sub EMEDIA () {110;}' unless defined(&EMEDIA);
	eval 'sub ESOFT () {111;}' unless defined(&ESOFT);
	eval 'sub ENOATTR () {112;}' unless defined(&ENOATTR);
	eval 'sub ESAD () {113;}' unless defined(&ESAD);
	eval 'sub ENOTRUST () {114;}' unless defined(&ENOTRUST);
	eval 'sub ETOOMANYREFS () {115;}' unless defined(&ETOOMANYREFS);
	eval 'sub EILSEQ () {116;}' unless defined(&EILSEQ);
	eval 'sub ECANCELED () {117;}' unless defined(&ECANCELED);
	eval 'sub ENOSR () {118;}' unless defined(&ENOSR);
	eval 'sub ETIME () {119;}' unless defined(&ETIME);
	eval 'sub EBADMSG () {120;}' unless defined(&EBADMSG);
	eval 'sub EPROTO () {121;}' unless defined(&EPROTO);
	eval 'sub ENODATA () {122;}' unless defined(&ENODATA);
	eval 'sub ENOSTR () {123;}' unless defined(&ENOSTR);
	eval 'sub ECLONEME () { &ERESTART;}' unless defined(&ECLONEME);
	eval 'sub ENOTSUP () {124;}' unless defined(&ENOTSUP);
	eval 'sub EMULTIHOP () {125;}' unless defined(&EMULTIHOP);
	eval 'sub ENOLINK () {126;}' unless defined(&ENOLINK);
	eval 'sub EOVERFLOW () {127;}' unless defined(&EOVERFLOW);
    }
}
1;
