require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&RSCAN_VIDEO_HEAD)) {
    sub RSCAN_VIDEO_HEAD () {	 &rom_scan_video_head_t;}
}
unless(defined(&RSCAN_VIDEO_HEAD_SIZE)) {
    sub RSCAN_VIDEO_HEAD_SIZE () {	( $sizeof{  &rom_scan_video_head_t} );}
}
unless(defined(&RSCAN_VIDEO_HEAD_rom_Blength)) {
    sub RSCAN_VIDEO_HEAD_rom_Blength {
	my($ptr) = @_;
	eval q((($ptr) ->  &rom_length_in_512B_blocks));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_residue)) {
    sub RSCAN_VIDEO_HEAD_residue {
	my($ptr) = @_;
	eval q((($ptr) ->  &rom_CRC_residue));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_rom_type)) {
    sub RSCAN_VIDEO_HEAD_rom_type {
	my($ptr) = @_;
	eval q((($ptr) ->  &rom_type));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_ucode_offset)) {
    sub RSCAN_VIDEO_HEAD_ucode_offset {
	my($ptr) = @_;
	eval q((($ptr) ->  &offset_to_ucode));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_ucode_len)) {
    sub RSCAN_VIDEO_HEAD_ucode_len {
	my($ptr) = @_;
	eval q((($ptr) ->  &length_of_ucode));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_odm_offset)) {
    sub RSCAN_VIDEO_HEAD_odm_offset {
	my($ptr) = @_;
	eval q((($ptr) ->  &offset_to_ODM_file));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_odm_len)) {
    sub RSCAN_VIDEO_HEAD_odm_len {
	my($ptr) = @_;
	eval q((($ptr) ->  &length_of_ODM_file));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_kmod_offset)) {
    sub RSCAN_VIDEO_HEAD_kmod_offset {
	my($ptr,$i) = @_;
	eval q((($ptr) ->  ($kmod_functions[$i]->{offset_to_kmod}) ));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_kmod_len)) {
    sub RSCAN_VIDEO_HEAD_kmod_len {
	my($ptr,$i) = @_;
	eval q((($ptr) ->  ($kmod_functions[$i]->{length_of_kmod}) ));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_ext_offset)) {
    sub RSCAN_VIDEO_HEAD_ext_offset {
	my($ptr,$i) = @_;
	eval q((($ptr) ->  ($kmod_extensions[$i]->{offset_to_kmod}) ));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_ext_len)) {
    sub RSCAN_VIDEO_HEAD_ext_len {
	my($ptr,$i) = @_;
	eval q((($ptr) ->  ($kmod_extensions[$i]->{length_of_kmod}) ));
    }
}
unless(defined(&RSCAN_VIDEO_HEAD_copyright)) {
    sub RSCAN_VIDEO_HEAD_copyright {
	my($ptr) = @_;
	eval q((($ptr) ->  &copyright_notice ));
    }
}
1;
