require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__H_FSHELP)) {
    eval 'sub __H_FSHELP () {1;}' unless defined(&__H_FSHELP);
    require 'sys/types.ph';
    eval 'sub NIL {
        my($type) = @_;
	    eval q((($type) 0));
    }' unless defined(&NIL);
    eval 'sub NILPTR {
        my($type) = @_;
	    eval q((($type *) 0));
    }' unless defined(&NILPTR);
    eval 'sub FSHRC_GOOD () {1;}' unless defined(&FSHRC_GOOD);
    eval 'sub FSHRC_BAD () {0;}' unless defined(&FSHRC_BAD);
    eval 'sub FSHRC_UGLY () {(-1);}' unless defined(&FSHRC_UGLY);
    eval 'sub FSHBUG_NONE () {0;}' unless defined(&FSHBUG_NONE);
    eval 'sub FSHBUG_INFO () {1;}' unless defined(&FSHBUG_INFO);
    eval 'sub FSHBUG_ACTION () {2;}' unless defined(&FSHBUG_ACTION);
    eval 'sub FSHBUG_LIBCALL () {3;}' unless defined(&FSHBUG_LIBCALL);
    eval 'sub FSHBUG_LIBDATA () {4;}' unless defined(&FSHBUG_LIBDATA);
    eval 'sub FSHBUG_OPCALL () {5;}' unless defined(&FSHBUG_OPCALL);
    eval 'sub FSHBUG_OPDATA () {6;}' unless defined(&FSHBUG_OPDATA);
    eval 'sub FSHBUG_BLOOP () {7;}' unless defined(&FSHBUG_BLOOP);
    eval 'sub FSHMOD_INTERACT () {0x1;}' unless defined(&FSHMOD_INTERACT);
    eval 'sub FSHMOD_INTERACT_FLAG () {ord(\'i\');}' unless defined(&FSHMOD_INTERACT_FLAG);
    eval 'sub FSHMOD_FORCE () {0x2;}' unless defined(&FSHMOD_FORCE);
    eval 'sub FSHMOD_FORCE_FLAG () {ord(\'f\');}' unless defined(&FSHMOD_FORCE_FLAG);
    eval 'sub FSHMOD_NONBLOCK () {0x4;}' unless defined(&FSHMOD_NONBLOCK);
    eval 'sub FSHMOD_NONBLOCK_FLAG () {ord(\'n\');}' unless defined(&FSHMOD_NONBLOCK_FLAG);
    eval 'sub FSHMOD_PERROR () {0x8;}' unless defined(&FSHMOD_PERROR);
    eval 'sub FSHMOD_PERROR_FLAG () {ord(\'p\');}' unless defined(&FSHMOD_PERROR_FLAG);
    eval 'sub FSHMOD_ERRDUMP () {0x10;}' unless defined(&FSHMOD_ERRDUMP);
    eval 'sub FSHMOD_ERRDUMP_FLAG () {ord(\'e\');}' unless defined(&FSHMOD_ERRDUMP_FLAG);
    eval 'sub FSHMOD_STANDALONE () {0x20;}' unless defined(&FSHMOD_STANDALONE);
    eval 'sub FSHMOD_STANDALONE_FLAG () {ord(\'s\');}' unless defined(&FSHMOD_STANDALONE_FLAG);
    eval 'sub FSHMOD_IGNDEVTYPE () {0x40;}' unless defined(&FSHMOD_IGNDEVTYPE);
    eval 'sub FSHMOD_IGNDEVTYPE_FLAG () {ord(\'I\');}' unless defined(&FSHMOD_IGNDEVTYPE_FLAG);
    eval 'sub FSHMOD_ALL () {0x7f;}' unless defined(&FSHMOD_ALL);
    unless(defined(&_I_AM_FSHELP)) {
    }
    eval 'sub FSHOP_NULL () {0;}' unless defined(&FSHOP_NULL);
    eval 'sub FSHOP_CHECK () {1;}' unless defined(&FSHOP_CHECK);
    eval 'sub FSHOP_CHGSIZ () {2;}' unless defined(&FSHOP_CHGSIZ);
    eval 'sub FSHOP_FINDATA () {3;}' unless defined(&FSHOP_FINDATA);
    eval 'sub FSHOP_FREE () {4;}' unless defined(&FSHOP_FREE);
    eval 'sub FSHOP_MAKE () {5;}' unless defined(&FSHOP_MAKE);
    eval 'sub FSHOP_REBUILD () {6;}' unless defined(&FSHOP_REBUILD);
    eval 'sub FSHOP_STATFS () {7;}' unless defined(&FSHOP_STATFS);
    eval 'sub FSHOP_STAT () {8;}' unless defined(&FSHOP_STAT);
    eval 'sub FSHOP_USAGE () {9;}' unless defined(&FSHOP_USAGE);
    eval 'sub FSHOP_NAMEI () {10;}' unless defined(&FSHOP_NAMEI);
    eval 'sub FSHOP_DEBUG () {11;}' unless defined(&FSHOP_DEBUG);
    eval 'sub LAST_FSHOP () { &FSHOP_DEBUG;}' unless defined(&LAST_FSHOP);
    eval 'sub FSHOP_NUM_OPS () {( &LAST_FSHOP + 1);}' unless defined(&FSHOP_NUM_OPS);
    eval 'sub A_NAME () {0;}' unless defined(&A_NAME);
    eval 'sub A_OP () {1;}' unless defined(&A_OP);
    eval 'sub A_FSFD () {2;}' unless defined(&A_FSFD);
    eval 'sub A_COMFD () {3;}' unless defined(&A_COMFD);
    eval 'sub A_MODE () {4;}' unless defined(&A_MODE);
    eval 'sub A_DEBG () {5;}' unless defined(&A_DEBG);
    eval 'sub A_FLGS () {6;}' unless defined(&A_FLGS);
    eval 'sub N_ARGS () {7;}' unless defined(&N_ARGS);
    eval 'sub FSHERR_GOOD () {0;}' unless defined(&FSHERR_GOOD);
    eval 'sub FSHERR_INVAL () {1;}' unless defined(&FSHERR_INVAL);
    eval 'sub FSHERR_INVALFS () {2;}' unless defined(&FSHERR_INVALFS);
    eval 'sub FSHERR_INVALFILNO () {3;}' unless defined(&FSHERR_INVALFILNO);
    eval 'sub FSHERR_INVALDBLK () {4;}' unless defined(&FSHERR_INVALDBLK);
    eval 'sub FSHERR_INVALMODE () {5;}' unless defined(&FSHERR_INVALMODE);
    eval 'sub FSHERR_INVALARG () {6;}' unless defined(&FSHERR_INVALARG);
    eval 'sub FSHERR_AXSHELPER () {7;}' unless defined(&FSHERR_AXSHELPER);
    eval 'sub FSHERR_ARGMISSING () {8;}' unless defined(&FSHERR_ARGMISSING);
    eval 'sub FSHERR_NOP () {9;}' unless defined(&FSHERR_NOP);
    eval 'sub FSHERR_SYNTAX () {10;}' unless defined(&FSHERR_SYNTAX);
    eval 'sub FSHERR_UNKVFS () {11;}' unless defined(&FSHERR_UNKVFS);
    eval 'sub FSHERR_UNKOP () {12;}' unless defined(&FSHERR_UNKOP);
    eval 'sub FSHERR_VFSMANGLED () {13;}' unless defined(&FSHERR_VFSMANGLED);
    eval 'sub FSHERR_VFSAXS () {14;}' unless defined(&FSHERR_VFSAXS);
    eval 'sub FSHERR_NOTSUP () {15;}' unless defined(&FSHERR_NOTSUP);
    eval 'sub FSHERR_WOULDBLOCK () {16;}' unless defined(&FSHERR_WOULDBLOCK);
    eval 'sub FSHERR_ACTIVE () {17;}' unless defined(&FSHERR_ACTIVE);
    eval 'sub FSHERR_CANTLOCK () {18;}' unless defined(&FSHERR_CANTLOCK);
    eval 'sub FSHERR_DEVOPEN () {19;}' unless defined(&FSHERR_DEVOPEN);
    eval 'sub FSHERR_DEVFAIL () {20;}' unless defined(&FSHERR_DEVFAIL);
    eval 'sub FSHERR_DEVFAILRD () {21;}' unless defined(&FSHERR_DEVFAILRD);
    eval 'sub FSHERR_DEVFAILWR () {22;}' unless defined(&FSHERR_DEVFAILWR);
    eval 'sub FSHERR_CORRUPT () {23;}' unless defined(&FSHERR_CORRUPT);
    eval 'sub FSHERR_NOMEM () {24;}' unless defined(&FSHERR_NOMEM);
    eval 'sub FSHERR_INTERNAL () {25;}' unless defined(&FSHERR_INTERNAL);
    eval 'sub FSHERR_LAST () { &FSHERR_INTERNAL;}' unless defined(&FSHERR_LAST);
    eval 'sub FSHERR_IMPERR () {( &FSHERR_LAST+1);}' unless defined(&FSHERR_IMPERR);
    eval 'sub FSHERR_UNKERR () {( &FSHERR_LAST+2);}' unless defined(&FSHERR_UNKERR);
    eval 'sub FSHERR_1STIMP () {100;}' unless defined(&FSHERR_1STIMP);
    eval 'sub set_fsherr {
        my($err) = @_;
	    eval q( &fshlpr_errno = $err);
    }' unless defined(&set_fsherr);
    eval 'sub clear_fsherr () {
        eval q( &set_fsherr ( &FSHERR_GOOD));
    }' unless defined(&clear_fsherr);
    eval 'sub fsherr () {
        eval q(( &fshlpr_errno));
    }' unless defined(&fsherr);
    unless(defined(&_I_AM_FSHELP)) {
    }
}
1;
