require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_GLOB)) {
    eval 'sub _H_GLOB () {1;}' unless defined(&_H_GLOB);
    unless(defined(&_H_STANDARDS)) {
	require 'standards.ph';
    }
    unless(defined(&_H_TYPES)) {
	require 'sys/types.ph';
    }
    if(defined(&_XOPEN_SOURCE)) {
	eval 'sub GLOB_APPEND () {0x1;}' unless defined(&GLOB_APPEND);
	eval 'sub GLOB_DOOFFS () {0x2;}' unless defined(&GLOB_DOOFFS);
	eval 'sub GLOB_ERR () {0x4;}' unless defined(&GLOB_ERR);
	eval 'sub GLOB_MARK () {0x8;}' unless defined(&GLOB_MARK);
	eval 'sub GLOB_NOCHECK () {0x10;}' unless defined(&GLOB_NOCHECK);
	eval 'sub GLOB_NOSORT () {0x20;}' unless defined(&GLOB_NOSORT);
	eval 'sub GLOB_NOESCAPE () {0x80;}' unless defined(&GLOB_NOESCAPE);
	eval 'sub GLOB_ABORTED () {0x1000;}' unless defined(&GLOB_ABORTED);
	eval 'sub GLOB_NOSPACE () {0x2000;}' unless defined(&GLOB_NOSPACE);
	eval 'sub GLOB_NOMATCH () {0x4000;}' unless defined(&GLOB_NOMATCH);
	eval 'sub GLOB_NOSYS () {0x8000;}' unless defined(&GLOB_NOSYS);
	if(defined(&_NO_PROTO)) {
	} else {
	}
    }
    if(defined(&_ALL_SOURCE)) {
	eval 'sub GLOB_QUOTE () {0x40;}' unless defined(&GLOB_QUOTE);
    }
}
1;
