require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&DST_H)) {
    eval 'sub DST_H () {1;}' unless defined(&DST_H);
    unless(defined(&HAS_DST_KEY)) {
    }
    eval 'sub RAW_KEY_SIZE () {8192;}' unless defined(&RAW_KEY_SIZE);
    eval 'sub SIG_MODE_INIT () {1;}' unless defined(&SIG_MODE_INIT);
    eval 'sub SIG_MODE_UPDATE () {2;}' unless defined(&SIG_MODE_UPDATE);
    eval 'sub SIG_MODE_FINAL () {4;}' unless defined(&SIG_MODE_FINAL);
    eval 'sub SIG_MODE_ALL () {( &SIG_MODE_INIT| &SIG_MODE_UPDATE| &SIG_MODE_FINAL);}' unless defined(&SIG_MODE_ALL);
    eval 'sub DST_FORCE_READ () {0x1000000;}' unless defined(&DST_FORCE_READ);
    eval 'sub DST_CAN_SIGN () {0x10f;}' unless defined(&DST_CAN_SIGN);
    eval 'sub DST_NO_AUTHEN () {0x8000;}' unless defined(&DST_NO_AUTHEN);
    eval 'sub DST_EXTEND_FLAG () {0x1000;}' unless defined(&DST_EXTEND_FLAG);
    eval 'sub DST_STANDARD () {0;}' unless defined(&DST_STANDARD);
    eval 'sub DST_PRIVATE () {0x2000000;}' unless defined(&DST_PRIVATE);
    eval 'sub DST_PUBLIC () {0x4000000;}' unless defined(&DST_PUBLIC);
    eval 'sub DST_RAND_SEMI () {1;}' unless defined(&DST_RAND_SEMI);
    eval 'sub DST_RAND_STD () {2;}' unless defined(&DST_RAND_STD);
    eval 'sub DST_RAND_KEY () {3;}' unless defined(&DST_RAND_KEY);
    eval 'sub DST_RAND_DSS () {4;}' unless defined(&DST_RAND_DSS);
    eval 'sub KEY_RSA () {1;}' unless defined(&KEY_RSA);
    eval 'sub KEY_DH () {2;}' unless defined(&KEY_DH);
    eval 'sub KEY_DSA () {3;}' unless defined(&KEY_DSA);
    eval 'sub KEY_PRIVATE () {254;}' unless defined(&KEY_PRIVATE);
    eval 'sub KEY_EXPAND () {255;}' unless defined(&KEY_EXPAND);
    eval 'sub KEY_HMAC_MD5 () {157;}' unless defined(&KEY_HMAC_MD5);
    eval 'sub KEY_HMAC_SHA1 () {158;}' unless defined(&KEY_HMAC_SHA1);
    eval 'sub UNKNOWN_KEYALG () {0;}' unless defined(&UNKNOWN_KEYALG);
    eval 'sub DST_MAX_ALGS () { &KEY_HMAC_SHA1;}' unless defined(&DST_MAX_ALGS);
    eval 'sub DST_FLAGS_SIZE () {2;}' unless defined(&DST_FLAGS_SIZE);
    eval 'sub DST_KEY_PROT () {2;}' unless defined(&DST_KEY_PROT);
    eval 'sub DST_KEY_ALG () {3;}' unless defined(&DST_KEY_ALG);
    eval 'sub DST_EXT_FLAG () {4;}' unless defined(&DST_EXT_FLAG);
    eval 'sub DST_KEY_START () {4;}' unless defined(&DST_KEY_START);
    unless(defined(&SIGN_F_NOKEY)) {
	eval 'sub SIGN_F_NOKEY () {0xc000;}' unless defined(&SIGN_F_NOKEY);
    }
    eval 'sub SIGN_INIT_FAILURE () {(-23);}' unless defined(&SIGN_INIT_FAILURE);
    eval 'sub SIGN_UPDATE_FAILURE () {(-24);}' unless defined(&SIGN_UPDATE_FAILURE);
    eval 'sub SIGN_FINAL_FAILURE () {(-25);}' unless defined(&SIGN_FINAL_FAILURE);
    eval 'sub VERIFY_INIT_FAILURE () {(-26);}' unless defined(&VERIFY_INIT_FAILURE);
    eval 'sub VERIFY_UPDATE_FAILURE () {(-27);}' unless defined(&VERIFY_UPDATE_FAILURE);
    eval 'sub VERIFY_FINAL_FAILURE () {(-28);}' unless defined(&VERIFY_FINAL_FAILURE);
    eval 'sub MISSING_KEY_OR_SIGNATURE () {(-30);}' unless defined(&MISSING_KEY_OR_SIGNATURE);
    eval 'sub UNSUPPORTED_KEYALG () {(-31);}' unless defined(&UNSUPPORTED_KEYALG);
}
1;
