require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_EVENTLIB_H)) {
    eval 'sub _EVENTLIB_H () {1;}' unless defined(&_EVENTLIB_H);
    require 'sys/types.ph';
    require 'sys/uio.ph';
    require 'sys/time.ph';
    require 'stdio.ph';
    unless(defined(&__P)) {
	eval 'sub __EVENTLIB_P_DEFINED () {1;}' unless defined(&__EVENTLIB_P_DEFINED);
	if(defined(&__STDC__)) {
	    eval 'sub __P {
	        my($x) = @_;
    		eval q($x);
	    }' unless defined(&__P);
	} else {
	    eval 'sub __P {
	        my($x) = @_;
    		eval q(());
	    }' unless defined(&__P);
	}
    }
    eval 'sub evInitID {
        my($id) = @_;
	    eval q((($id)-> &opaque =  &NULL));
    }' unless defined(&evInitID);
    eval 'sub evTestID {
        my($id) = @_;
	    eval q((($id). &opaque !=  &NULL));
    }' unless defined(&evTestID);
    eval 'sub EV_BYTEMASK_BYTE {
        my($b) = @_;
	    eval q((($b) / 8));
    }' unless defined(&EV_BYTEMASK_BYTE);
    eval 'sub EV_BYTEMASK_MASK {
        my($b) = @_;
	    eval q((1<< (($b) % 8)));
    }' unless defined(&EV_BYTEMASK_MASK);
    eval 'sub EV_BYTEMASK_SET {
        my($bm, $b) = @_;
	    eval q((($bm). $mask[ &EV_BYTEMASK_BYTE($b)] |=  &EV_BYTEMASK_MASK($b)));
    }' unless defined(&EV_BYTEMASK_SET);
    eval 'sub EV_BYTEMASK_CLR {
        my($bm, $b) = @_;
	    eval q((($bm). $mask[ &EV_BYTEMASK_BYTE($b)] &= ~ &EV_BYTEMASK_MASK($b)));
    }' unless defined(&EV_BYTEMASK_CLR);
    eval 'sub EV_BYTEMASK_TST {
        my($bm, $b) = @_;
	    eval q((($bm). $mask[ &EV_BYTEMASK_BYTE($b)] &  &EV_BYTEMASK_MASK($b)));
    }' unless defined(&EV_BYTEMASK_TST);
    eval 'sub EV_POLL () {1;}' unless defined(&EV_POLL);
    eval 'sub EV_WAIT () {2;}' unless defined(&EV_WAIT);
    eval 'sub EV_NULL () {4;}' unless defined(&EV_NULL);
    eval 'sub EV_READ () {1;}' unless defined(&EV_READ);
    eval 'sub EV_WRITE () {2;}' unless defined(&EV_WRITE);
    eval 'sub EV_EXCEPT () {4;}' unless defined(&EV_EXCEPT);
    eval 'sub evCreate () { &__evCreate;}' unless defined(&evCreate);
    eval 'sub evSetDebug () { &__evSetDebug;}' unless defined(&evSetDebug);
    eval 'sub evDestroy () { &__evDestroy;}' unless defined(&evDestroy);
    eval 'sub evGetNext () { &__evGetNext;}' unless defined(&evGetNext);
    eval 'sub evDispatch () { &__evDispatch;}' unless defined(&evDispatch);
    eval 'sub evDrop () { &__evDrop;}' unless defined(&evDrop);
    eval 'sub evMainLoop () { &__evMainLoop;}' unless defined(&evMainLoop);
    eval 'sub evHighestFD () { &__evHighestFD;}' unless defined(&evHighestFD);
    eval 'sub evListen () { &__evListen;}' unless defined(&evListen);
    eval 'sub evConnect () { &__evConnect;}' unless defined(&evConnect);
    eval 'sub evCancelConn () { &__evCancelConn;}' unless defined(&evCancelConn);
    eval 'sub evHold () { &__evHold;}' unless defined(&evHold);
    eval 'sub evUnhold () { &__evUnhold;}' unless defined(&evUnhold);
    eval 'sub evTryAccept () { &__evTryAccept;}' unless defined(&evTryAccept);
    eval 'sub evSelectFD () { &__evSelectFD;}' unless defined(&evSelectFD);
    eval 'sub evDeselectFD () { &__evDeselectFD;}' unless defined(&evDeselectFD);
    eval 'sub evConsIovec () { &__evConsIovec;}' unless defined(&evConsIovec);
    eval 'sub evWrite () { &__evWrite;}' unless defined(&evWrite);
    eval 'sub evRead () { &__evRead;}' unless defined(&evRead);
    eval 'sub evTimeRW () { &__evTimeRW;}' unless defined(&evTimeRW);
    eval 'sub evUntimeRW () { &__evUntimeRW;}' unless defined(&evUntimeRW);
    eval 'sub evCancelRW () { &__evCancelRW;}' unless defined(&evCancelRW);
    eval 'sub evConsTime () { &__evConsTime;}' unless defined(&evConsTime);
    eval 'sub evAddTime () { &__evAddTime;}' unless defined(&evAddTime);
    eval 'sub evSubTime () { &__evSubTime;}' unless defined(&evSubTime);
    eval 'sub evCmpTime () { &__evCmpTime;}' unless defined(&evCmpTime);
    eval 'sub evTimeSpec () { &__evTimeSpec;}' unless defined(&evTimeSpec);
    eval 'sub evTimeVal () { &__evTimeVal;}' unless defined(&evTimeVal);
    eval 'sub evNowTime () { &__evNowTime;}' unless defined(&evNowTime);
    eval 'sub evLastEventTime () { &__evLastEventTime;}' unless defined(&evLastEventTime);
    eval 'sub evSetTimer () { &__evSetTimer;}' unless defined(&evSetTimer);
    eval 'sub evClearTimer () { &__evClearTimer;}' unless defined(&evClearTimer);
    eval 'sub evResetTimer () { &__evResetTimer;}' unless defined(&evResetTimer);
    eval 'sub evSetIdleTimer () { &__evSetIdleTimer;}' unless defined(&evSetIdleTimer);
    eval 'sub evClearIdleTimer () { &__evClearIdleTimer;}' unless defined(&evClearIdleTimer);
    eval 'sub evResetIdleTimer () { &__evResetIdleTimer;}' unless defined(&evResetIdleTimer);
    eval 'sub evTouchIdleTimer () { &__evTouchIdleTimer;}' unless defined(&evTouchIdleTimer);
    eval 'sub evWaitFor () { &__evWaitFor;}' unless defined(&evWaitFor);
    eval 'sub evDo () { &__evDo;}' unless defined(&evDo);
    eval 'sub evUnwait () { &__evUnwait;}' unless defined(&evUnwait);
    eval 'sub evDefer () { &__evDefer;}' unless defined(&evDefer);
    if(defined(&__EVENTLIB_P_DEFINED)) {
	undef(&__P) if defined(&__P);
    }
}
1;
