require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&LOGGING_H)) {
    eval 'sub LOGGING_H () {1;}' unless defined(&LOGGING_H);
    require 'stdio.ph';
    require 'stdarg.ph';
    eval 'sub log_critical () {(-5);}' unless defined(&log_critical);
    eval 'sub log_error () {(-4);}' unless defined(&log_error);
    eval 'sub log_warning () {(-3);}' unless defined(&log_warning);
    eval 'sub log_notice () {(-2);}' unless defined(&log_notice);
    eval 'sub log_info () {(-1);}' unless defined(&log_info);
    eval 'sub log_debug {
        my($level) = @_;
	    eval q(($level));
    }' unless defined(&log_debug);
    eval("sub log_syslog () { 0; }") unless defined(&log_syslog);
    eval("sub log_file () { 1; }") unless defined(&log_file);
    eval("sub log_null () { 2; }") unless defined(&log_null);
    eval 'sub LOG_MAX_VERSIONS () {99;}' unless defined(&LOG_MAX_VERSIONS);
    eval 'sub LOG_CLOSE_STREAM () {0x1;}' unless defined(&LOG_CLOSE_STREAM);
    eval 'sub LOG_TIMESTAMP () {0x2;}' unless defined(&LOG_TIMESTAMP);
    eval 'sub LOG_TRUNCATE () {0x4;}' unless defined(&LOG_TRUNCATE);
    eval 'sub LOG_USE_CONTEXT_LEVEL () {0x8;}' unless defined(&LOG_USE_CONTEXT_LEVEL);
    eval 'sub LOG_PRINT_LEVEL () {0x10;}' unless defined(&LOG_PRINT_LEVEL);
    eval 'sub LOG_REQUIRE_DEBUG () {0x20;}' unless defined(&LOG_REQUIRE_DEBUG);
    eval 'sub LOG_CHANNEL_BROKEN () {0x40;}' unless defined(&LOG_CHANNEL_BROKEN);
    eval 'sub LOG_PRINT_CATEGORY () {0x80;}' unless defined(&LOG_PRINT_CATEGORY);
    eval 'sub LOG_CHANNEL_OFF () {0x100;}' unless defined(&LOG_CHANNEL_OFF);
    eval 'sub LOG_OPTION_DEBUG () {0x1;}' unless defined(&LOG_OPTION_DEBUG);
    eval 'sub LOG_OPTION_LEVEL () {0x2;}' unless defined(&LOG_OPTION_LEVEL);
    eval 'sub log_open_stream () { &__log_open_stream;}' unless defined(&log_open_stream);
    eval 'sub log_close_stream () { &__log_close_stream;}' unless defined(&log_close_stream);
    eval 'sub log_get_stream () { &__log_get_stream;}' unless defined(&log_get_stream);
    eval 'sub log_get_filename () { &__log_get_filename;}' unless defined(&log_get_filename);
    eval 'sub log_check_channel () { &__log_check_channel;}' unless defined(&log_check_channel);
    eval 'sub log_check () { &__log_check;}' unless defined(&log_check);
    eval 'sub log_vwrite () { &__log_vwrite;}' unless defined(&log_vwrite);
    eval 'sub log_write () { &__log_write;}' unless defined(&log_write);
    eval 'sub log_new_context () { &__log_new_context;}' unless defined(&log_new_context);
    eval 'sub log_free_context () { &__log_free_context;}' unless defined(&log_free_context);
    eval 'sub log_add_channel () { &__log_add_channel;}' unless defined(&log_add_channel);
    eval 'sub log_remove_channel () { &__log_remove_channel;}' unless defined(&log_remove_channel);
    eval 'sub log_option () { &__log_option;}' unless defined(&log_option);
    eval 'sub log_category_is_active () { &__log_category_is_active;}' unless defined(&log_category_is_active);
    eval 'sub log_new_syslog_channel () { &__log_new_syslog_channel;}' unless defined(&log_new_syslog_channel);
    eval 'sub log_new_file_channel () { &__log_new_file_channel;}' unless defined(&log_new_file_channel);
    eval 'sub log_new_null_channel () { &__log_new_null_channel;}' unless defined(&log_new_null_channel);
    eval 'sub log_inc_references () { &__log_inc_references;}' unless defined(&log_inc_references);
    eval 'sub log_dec_references () { &__log_dec_references;}' unless defined(&log_dec_references);
    eval 'sub log_get_channel_type () { &__log_get_channel_type;}' unless defined(&log_get_channel_type);
    eval 'sub log_free_channel () { &__log_free_channel;}' unless defined(&log_free_channel);
}
1;
