require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ACPKT_)) {
    eval 'sub _ACPKT_ () {1;}' unless defined(&_ACPKT_);
    unless(defined(&_AcSAP_)) {
	require 'isode/acsap.ph';
    }
    unless(defined(&_PSAP2_)) {
	require 'isode/psap2.ph';
    }
    if(defined(&ACSE)) {
	eval 'sub AC_ASN () {"acse pci version 1";}' unless defined(&AC_ASN);
	eval 'sub acsapPsig {
	    my($acb, $sd) = @_;
    	    eval q({  &if (($acb =  &findacblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &acsaplose ( &aci,  &ACS_PARAMETER,  &NULLCP, \\"invalid association descriptor\\"); }  &if (!($acb ->  &acb_flags &  &ACB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &acsaplose ( &aci,  &ACS_OPERATION,  &NULLCP, \\"assocation descriptor not connected\\"); }  &if ($acb ->  &acb_flags &  &ACB_FINN) { ( &void)  &sigiomask ( &smask);  &return  &acsaplose ( &aci,  &ACS_OPERATION,  &NULLCP, \\"association descriptor finishing\\"); }  &if ($acb ->  &acb_flags &  &ACB_RELEASE) { ( &void)  &sigiomask ( &smask);  &return  &acsaplose ( &aci,  &ACS_OPERATION,  &NULLCP, \\"release in progress\\"); } });
	}' unless defined(&acsapPsig);
	eval 'sub acsapFsig {
	    my($acb, $sd) = @_;
    	    eval q({  &if (($acb =  &findacblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &acsaplose ( &aci,  &ACS_PARAMETER,  &NULLCP, \\"invalid association descriptor\\"); }  &if (!($acb ->  &acb_flags &  &ACB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &acsaplose ( &aci,  &ACS_OPERATION,  &NULLCP, \\"assocation descriptor not connected\\"); }  &if (!($acb ->  &acb_flags &  &ACB_FINN)) { ( &void)  &sigiomask ( &smask);  &return  &acsaplose ( &aci,  &ACS_OPERATION,  &NULLCP, \\"association descriptor not finishing\\"); }  &if ($acb ->  &acb_flags &  &ACB_RELEASE) { ( &void)  &sigiomask ( &smask);  &return  &acsaplose ( &aci,  &ACS_OPERATION,  &NULLCP, \\"release in progress\\"); } });
	}' unless defined(&acsapFsig);
	eval 'sub toomuchP {
	    my($b,$n,$m,$p) = @_;
    	    eval q({  &if ($b ==  &NULL) $n = 0;  &else  &if ($n > $m)  &return  &acsaplose ( &aci,  &ACS_PARAMETER,  &NULLCP, \\"too many %s user data elements\\", $p); });
	}' unless defined(&toomuchP);
	eval 'sub missingP {
	    my($p) = @_;
    	    eval q({  &if ($p ==  &NULL)  &return  &acsaplose ( &aci,  &ACS_PARAMETER,  &NULLCP, \\"mandatory parameter \\\\\\"%s\\\\\\" missing\\", \\"p\\"); });
	}' unless defined(&missingP);
	unless(defined(&lint)) {
	    if(!defined( &_AIX) ) {
		eval 'sub copyAcSAPdata {
		    my($base,$len,$d) = @_;
    		    eval q({  &register \'int\'  &i = $len;  &if (($d -> $d  &_cc =  &min ( &i,  &sizeof $d -> $d  &_data)) > 0)  &bcopy ($base, $d -> $d  &_data, $d -> $d  &_cc); });
		}' unless defined(&copyAcSAPdata);
	    } else {
		eval 'sub copyAcSAPdata {
		    my($base,$len,$d) = @_;
    		    eval q({  &register \'int\'  &i = $len;  &if (($d -> $d &_cc =  &min ( &i,  &sizeof $d -> $d &_data)) > 0)  &bcopy ($base, $d -> $d &_data, $d -> $d &_cc); });
		}' unless defined(&copyAcSAPdata);
	    }
	} else {
	    eval 'sub copyAcSAPdata {
	        my($base,$len,$d) = @_;
    		eval q( &bcopy ($base, $d, $len));
	    }' unless defined(&copyAcSAPdata);
	}
	eval 'sub ACS_USER_BASE () { &ACS_USER_NULL;}' unless defined(&ACS_USER_BASE);
	eval 'sub ACS_PROV_BASE () { &ACS_PROV_NULL;}' unless defined(&ACS_PROV_BASE);
    }
    eval 'sub ACB_NULL () {0x;}' unless defined(&ACB_NULL);
    eval 'sub ACB_CONN () {0x1;}' unless defined(&ACB_CONN);
    eval 'sub ACB_FINN () {0x2;}' unless defined(&ACB_FINN);
    eval 'sub ACB_INIT () {0x4;}' unless defined(&ACB_INIT);
    eval 'sub ACB_ASYN () {0x8;}' unless defined(&ACB_ASYN);
    eval 'sub ACB_TURN () {0x10;}' unless defined(&ACB_TURN);
    eval 'sub ACB_TWA () {0x20;}' unless defined(&ACB_TWA);
    eval 'sub ACB_ACT () {0x40;}' unless defined(&ACB_ACT);
    eval 'sub ACB_PLEASE () {0x80;}' unless defined(&ACB_PLEASE);
    eval 'sub ACB_TIMER () {0x100;}' unless defined(&ACB_TIMER);
    eval 'sub ACB_ROS () {0x200;}' unless defined(&ACB_ROS);
    eval 'sub ACB_RTS () {0x400;}' unless defined(&ACB_RTS);
    eval 'sub ACB_ACS () {0x800;}' unless defined(&ACB_ACS);
    eval 'sub ACB_CLOSING () {0x1000;}' unless defined(&ACB_CLOSING);
    eval 'sub ACB_FINISH () {0x2000;}' unless defined(&ACB_FINISH);
    eval 'sub ACB_STICKY () {0x4000;}' unless defined(&ACB_STICKY);
    eval 'sub ACB_RELEASE () {0x8000;}' unless defined(&ACB_RELEASE);
    eval 'sub NULLACB () {( 0);}' unless defined(&NULLACB);
    eval 'sub FREEACB {
        my($acb) = @_;
	    eval q({  &if (($acb) ->  &acb_realbase)  &free (($acb) ->  &acb_realbase);  &else  &if (($acb) ->  &acb_base)  &free (($acb) ->  &acb_base); ($acb) ->  &acb_realbase = ($acb) ->  &acb_base =  &NULL, ($acb) ->  &acb_len = 0; });
    }' unless defined(&FREEACB);
    unless(defined(&ACSE)) {
	eval 'sub PCONN_DTS () {0;}' unless defined(&PCONN_DTS);
	eval 'sub PCONN_DATA () {1;}' unless defined(&PCONN_DATA);
	eval 'sub PCONN_DATA_CK () {0;}' unless defined(&PCONN_DATA_CK);
	eval 'sub PCONN_CK_DFLT () {0;}' unless defined(&PCONN_CK_DFLT);
	eval 'sub PCONN_DATA_WD () {1;}' unless defined(&PCONN_DATA_WD);
	eval 'sub PCONN_WD_DFLT () {3;}' unless defined(&PCONN_WD_DFLT);
	eval 'sub PCONN_DATA_DM () {2;}' unless defined(&PCONN_DATA_DM);
	eval 'sub PCONN_DM_MONO () {0;}' unless defined(&PCONN_DM_MONO);
	eval 'sub PCONN_DM_TWA () {1;}' unless defined(&PCONN_DM_TWA);
	eval 'sub PCONN_DM_DFLT () { &PCONN_DM_MONO;}' unless defined(&PCONN_DM_DFLT);
	eval 'sub PCONN_DATA_CN () {3;}' unless defined(&PCONN_DATA_CN);
	eval 'sub PCONN_DATA_AP () {4;}' unless defined(&PCONN_DATA_AP);
	eval 'sub PCONN_AP_DFLT () {1;}' unless defined(&PCONN_AP_DFLT);
	eval 'sub PACC_DTS () {0;}' unless defined(&PACC_DTS);
	eval 'sub PACC_DATA () {1;}' unless defined(&PACC_DATA);
	eval 'sub PACC_DATA_CK () {0;}' unless defined(&PACC_DATA_CK);
	eval 'sub PACC_CK_DFLT () {0;}' unless defined(&PACC_CK_DFLT);
	eval 'sub PACC_DATA_WD () {1;}' unless defined(&PACC_DATA_WD);
	eval 'sub PACC_WD_DFLT () {3;}' unless defined(&PACC_WD_DFLT);
	eval 'sub PACC_DATA_CN () {2;}' unless defined(&PACC_DATA_CN);
	eval 'sub PREF_REASON () {0;}' unless defined(&PREF_REASON);
	eval 'sub DTS_SYNTAX () {0;}' unless defined(&DTS_SYNTAX);
	eval 'sub SYN_X409 () {0;}' unless defined(&SYN_X409);
	eval 'sub CN_OPEN () {0;}' unless defined(&CN_OPEN);
	eval 'sub CN_RECOVER () {1;}' unless defined(&CN_RECOVER);
	eval 'sub REFUSE_BUSY () {0;}' unless defined(&REFUSE_BUSY);
	eval 'sub REFUSE_RECOVER () {1;}' unless defined(&REFUSE_RECOVER);
	eval 'sub REFUSE_VALIDATE () {2;}' unless defined(&REFUSE_VALIDATE);
	eval 'sub REFUSE_MODE () {3;}' unless defined(&REFUSE_MODE);
	eval 'sub ABORT_LSP () {0;}' unless defined(&ABORT_LSP);
	eval 'sub ABORT_INV () {1;}' unless defined(&ABORT_INV);
	eval 'sub ABORT_ACT () {2;}' unless defined(&ABORT_ACT);
	eval 'sub ABORT_TMP () {3;}' unless defined(&ABORT_TMP);
	eval 'sub ABORT_PROTO () {4;}' unless defined(&ABORT_PROTO);
	eval 'sub ABORT_PERM () {5;}' unless defined(&ABORT_PERM);
	eval 'sub ABORT_USER () {6;}' unless defined(&ABORT_USER);
	eval 'sub ABORT_TRANS () {7;}' unless defined(&ABORT_TRANS);
    }
}
1;
