require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_AcSAP_)) {
    eval 'sub _AcSAP_ () {1;}' unless defined(&_AcSAP_);
    unless(defined(&_MANIFEST_)) {
	require 'isode/manifest.ph';
    }
    unless(defined(&_GENERAL_)) {
	require 'isode/general.ph';
    }
    unless(defined(&_PSAP2_)) {
	require 'isode/psap2.ph';
    }
    eval 'sub NACDATA () {3;}' unless defined(&NACDATA);
    eval 'sub ACSFREE {
        my($acs) = @_;
	    eval q({  &register \'int\'  &ACSI;  &if (($acs) ->  &acs_context)  &oid_free (($acs) ->  &acs_context), ($acs) ->  &acs_context =  &NULLOID;  &AEIFREE (($acs) ->  &acs_callingtitle);  &AEIFREE (($acs) ->  &acs_calledtitle);  &PSFREE (($acs) ->  &acs_start);  &for ( &ACSI = ($acs) ->  &acs_ninfo - 1;  &ACSI >= 0;  &ACSI--)  &if (($acs) ->  $acs_info[ &ACSI])  &pe_free (($acs) ->  $acs_info[ &ACSI]), ($acs) ->  $acs_info[ &ACSI] =  &NULLPE; ($acs) ->  &acs_ninfo = 0; });
    }' unless defined(&ACSFREE);
    eval 'sub ACS_ACCEPT () {0;}' unless defined(&ACS_ACCEPT);
    eval 'sub ACS_REJECT () {(-1);}' unless defined(&ACS_REJECT);
    eval 'sub ACS_PERMANENT () {1;}' unless defined(&ACS_PERMANENT);
    eval 'sub ACS_TRANSIENT () {2;}' unless defined(&ACS_TRANSIENT);
    eval 'sub ACS_USER_NULL () {3;}' unless defined(&ACS_USER_NULL);
    eval 'sub ACS_USER_NOREASON () {4;}' unless defined(&ACS_USER_NOREASON);
    eval 'sub ACS_CONTEXT () {5;}' unless defined(&ACS_CONTEXT);
    eval 'sub ACS_CALLING_AP_TITLE () {6;}' unless defined(&ACS_CALLING_AP_TITLE);
    eval 'sub ACS_CALLING_AP_ID () {7;}' unless defined(&ACS_CALLING_AP_ID);
    eval 'sub ACS_CALLING_AE_QUAL () {8;}' unless defined(&ACS_CALLING_AE_QUAL);
    eval 'sub ACS_CALLING_AE_ID () {9;}' unless defined(&ACS_CALLING_AE_ID);
    eval 'sub ACS_CALLED_AP_TITLE () {10;}' unless defined(&ACS_CALLED_AP_TITLE);
    eval 'sub ACS_CALLED_AP_ID () {11;}' unless defined(&ACS_CALLED_AP_ID);
    eval 'sub ACS_CALLED_AE_QUAL () {12;}' unless defined(&ACS_CALLED_AE_QUAL);
    eval 'sub ACS_CALLED_AE_ID () {13;}' unless defined(&ACS_CALLED_AE_ID);
    eval 'sub ACS_PROV_NULL () {14;}' unless defined(&ACS_PROV_NULL);
    eval 'sub ACS_PROV_NOREASON () {15;}' unless defined(&ACS_PROV_NOREASON);
    eval 'sub ACS_VERSION () {16;}' unless defined(&ACS_VERSION);
    eval 'sub ACS_ADDRESS () {17;}' unless defined(&ACS_ADDRESS);
    eval 'sub ACS_REFUSED () {18;}' unless defined(&ACS_REFUSED);
    eval 'sub ACS_CONGEST () {19;}' unless defined(&ACS_CONGEST);
    eval 'sub ACS_PRESENTATION () {20;}' unless defined(&ACS_PRESENTATION);
    eval 'sub ACS_PROTOCOL () {21;}' unless defined(&ACS_PROTOCOL);
    eval 'sub ACS_ABORTED () {22;}' unless defined(&ACS_ABORTED);
    eval 'sub ACS_PARAMETER () {23;}' unless defined(&ACS_PARAMETER);
    eval 'sub ACS_OPERATION () {24;}' unless defined(&ACS_OPERATION);
    eval 'sub ACS_TIMER () {25;}' unless defined(&ACS_TIMER);
    eval 'sub ACS_FATAL {
        my($r) = @_;
	    eval q((($r) <  &ACS_PARAMETER));
    }' unless defined(&ACS_FATAL);
    eval 'sub ACS_OFFICIAL {
        my($r) = @_;
	    eval q((($r) <  &ACS_ADDRESS));
    }' unless defined(&ACS_OFFICIAL);
    eval 'sub ACCFREE {
        my($acc) = @_;
	    eval q({  &register \'int\'  &ACCI;  &if (($acc) ->  &acc_context)  &oid_free (($acc) ->  &acc_context), ($acc) ->  &acc_context =  &NULLOID;  &AEIFREE (($acc) ->  &acc_respondtitle);  &PCFREE (($acc) ->  &acc_connect);  &for ( &ACCI = ($acc) ->  &acc_ninfo - 1;  &ACCI >= 0;  &ACCI--)  &if (($acc) ->  $acc_info[ &ACCI])  &pe_free (($acc) ->  $acc_info[ &ACCI]), ($acc) ->  $acc_info[ &ACCI] =  &NULLPE; ($acc) ->  &acc_ninfo = 0; });
    }' unless defined(&ACCFREE);
    eval 'sub ACF_NORMAL () {0;}' unless defined(&ACF_NORMAL);
    eval 'sub ACF_URGENT () {1;}' unless defined(&ACF_URGENT);
    eval 'sub ACF_USERDEFINED () {30;}' unless defined(&ACF_USERDEFINED);
    eval 'sub ACFFREE {
        my($acf) = @_;
	    eval q({  &register \'int\'  &ACFI;  &for ( &ACFI = ($acf) ->  &acf_ninfo - 1;  &ACFI >= 0;  &ACFI--)  &if (($acf) ->  $acf_info[ &ACFI])  &pe_free (($acf) ->  $acf_info[ &ACFI]), ($acf) ->  $acf_info[ &ACFI] =  &NULLPE; ($acf) ->  &acf_ninfo = 0; });
    }' unless defined(&ACFFREE);
    eval 'sub ACR_NORMAL () {0;}' unless defined(&ACR_NORMAL);
    eval 'sub ACR_NOTFINISHED () {1;}' unless defined(&ACR_NOTFINISHED);
    eval 'sub ACR_USERDEFINED () {30;}' unless defined(&ACR_USERDEFINED);
    eval 'sub ACRFREE {
        my($acr) = @_;
	    eval q({  &register \'int\'  &ACRI;  &for ( &ACRI = ($acr) ->  &acr_ninfo - 1;  &ACRI >= 0;  &ACRI--)  &if (($acr) ->  $acr_info[ &ACRI])  &pe_free (($acr) ->  $acr_info[ &ACRI]), ($acr) ->  $acr_info[ &ACRI] =  &NULLPE; ($acr) ->  &acr_ninfo = 0; });
    }' unless defined(&ACRFREE);
    eval 'sub ACA_USER () {0;}' unless defined(&ACA_USER);
    eval 'sub ACA_PROVIDER () {1;}' unless defined(&ACA_PROVIDER);
    eval 'sub ACA_LOCAL () {2;}' unless defined(&ACA_LOCAL);
    eval 'sub ACA_SIZE () {512;}' unless defined(&ACA_SIZE);
    eval 'sub ACAFREE {
        my($aca) = @_;
	    eval q({  &register \'int\'  &ACAI;  &for ( &ACAI = ($aca) ->  &aca_ninfo - 1;  &ACAI >= 0;  &ACAI--)  &if (($aca) ->  $aca_info[ &ACAI])  &pe_free (($aca) ->  $aca_info[ &ACAI]), ($aca) ->  $aca_info[ &ACAI] =  &NULLPE; ($aca) ->  &aca_ninfo = 0; });
    }' unless defined(&ACAFREE);
    eval 'sub ACI_FINISH () {0x;}' unless defined(&ACI_FINISH);
    eval 'sub ACI_ABORT () {0x1;}' unless defined(&ACI_ABORT);
    eval 'sub aci_finish () { ($aci_un->{aci_un_finish});}' unless defined(&aci_finish);
    eval 'sub aci_abort () { ($aci_un->{aci_un_abort});}' unless defined(&aci_abort);
    eval 'sub AcAssocRequest {
        my($a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$a10,$a11,$a12,$a13,$a14,$a15,$a16,$a17) = @_;
	    eval q( &AcAsynAssocRequest ($a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$a10,$a11,$a12,$a13,$a14,$a15,$a16,$a17,0));
    }' unless defined(&AcAssocRequest);
}
1;
