require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_FTAM_)) {
    eval 'sub _FTAM_ () {1;}' unless defined(&_FTAM_);
    unless(defined(&_PSAP2_)) {
	require 'isode/psap2.ph';
    }
    require 'isode/logger.ph';
    eval 'sub FQOS_NORECOVERY () {0;}' unless defined(&FQOS_NORECOVERY);
    eval 'sub FQOS_CLASS1 () {1;}' unless defined(&FQOS_CLASS1);
    eval 'sub FQOS_CLASS2 () {2;}' unless defined(&FQOS_CLASS2);
    eval 'sub FQOS_CLASS3 () {3;}' unless defined(&FQOS_CLASS3);
    eval 'sub MY_FQOS () { &FQOS_NORECOVERY;}' unless defined(&MY_FQOS);
    eval 'sub FCLASS_UNCONS () {0x1;}' unless defined(&FCLASS_UNCONS);
    eval 'sub FCLASS_MANAGE () {0x2;}' unless defined(&FCLASS_MANAGE);
    eval 'sub FCLASS_TRANSFER () {0x4;}' unless defined(&FCLASS_TRANSFER);
    eval 'sub FCLASS_TM () {0x8;}' unless defined(&FCLASS_TM);
    eval 'sub FCLASS_ACCESS () {0x10;}' unless defined(&FCLASS_ACCESS);
    eval 'sub FUNIT_READ () {0x1;}' unless defined(&FUNIT_READ);
    eval 'sub FUNIT_WRITE () {0x2;}' unless defined(&FUNIT_WRITE);
    eval 'sub FUNIT_ACCESS () {0x4;}' unless defined(&FUNIT_ACCESS);
    eval 'sub FUNIT_LIMITED () {0x8;}' unless defined(&FUNIT_LIMITED);
    eval 'sub FUNIT_ENHANCED () {0x10;}' unless defined(&FUNIT_ENHANCED);
    eval 'sub FUNIT_GROUPING () {0x20;}' unless defined(&FUNIT_GROUPING);
    eval 'sub FUNIT_FADULOCK () {0x40;}' unless defined(&FUNIT_FADULOCK);
    eval 'sub FUNIT_RECOVERY () {0x80;}' unless defined(&FUNIT_RECOVERY);
    eval 'sub FUNIT_RESTART () {0x100;}' unless defined(&FUNIT_RESTART);
    eval 'sub MY_FUNIT () {( &FUNIT_READ |  &FUNIT_WRITE |  &FUNIT_ACCESS |  &FUNIT_LIMITED |  &FUNIT_ENHANCED |  &FUNIT_GROUPING |  &FUNIT_FADULOCK);}' unless defined(&MY_FUNIT);
    eval 'sub FATTR_STORAGE () {0x1;}' unless defined(&FATTR_STORAGE);
    eval 'sub FATTR_SECURITY () {0x2;}' unless defined(&FATTR_SECURITY);
    eval 'sub FATTR_PRIVATE () {0x4;}' unless defined(&FATTR_PRIVATE);
    eval 'sub MY_FATTR () {( &FATTR_STORAGE |  &FATTR_SECURITY);}' unless defined(&MY_FATTR);
    eval 'sub FSTATE_SUCCESS () {0;}' unless defined(&FSTATE_SUCCESS);
    eval 'sub FSTATE_FAILURE () {1;}' unless defined(&FSTATE_FAILURE);
    eval 'sub FACTION_SUCCESS () {0;}' unless defined(&FACTION_SUCCESS);
    eval 'sub FACTION_TRANS () {1;}' unless defined(&FACTION_TRANS);
    eval 'sub FACTION_PERM () {2;}' unless defined(&FACTION_PERM);
    eval 'sub NFCONT () {( &NPCTX - 2);}' unless defined(&NFCONT);
    eval 'sub DIAG_INFORM () {0;}' unless defined(&DIAG_INFORM);
    eval 'sub DIAG_TRANS () {1;}' unless defined(&DIAG_TRANS);
    eval 'sub DIAG_PERM () {2;}' unless defined(&DIAG_PERM);
    eval 'sub FS_CODE2OFF {
        my($c) = @_;
	    eval q((($c) % 1000));
    }' unless defined(&FS_CODE2OFF);
    eval 'sub FS_GEN_BASE () {0;}' unless defined(&FS_GEN_BASE);
    eval 'sub FS_GEN_NOREASON () {0;}' unless defined(&FS_GEN_NOREASON);
    eval 'sub FS_GEN_RESPONDER () {1;}' unless defined(&FS_GEN_RESPONDER);
    eval 'sub FS_GEN_SHUTDOWN () {2;}' unless defined(&FS_GEN_SHUTDOWN);
    eval 'sub FS_GEN_MGMT () {3;}' unless defined(&FS_GEN_MGMT);
    eval 'sub FS_GEN_MGMTACCT () {4;}' unless defined(&FS_GEN_MGMTACCT);
    eval 'sub FS_GEN_MGMTPASS () {5;}' unless defined(&FS_GEN_MGMTPASS);
    eval 'sub FS_GEN_DELAY () {6;}' unless defined(&FS_GEN_DELAY);
    eval 'sub FS_GEN_INITIATOR () {7;}' unless defined(&FS_GEN_INITIATOR);
    eval 'sub FS_GEN_SUBSEQ () {8;}' unless defined(&FS_GEN_SUBSEQ);
    eval 'sub FS_GEN_TEMPORAL () {9;}' unless defined(&FS_GEN_TEMPORAL);
    eval 'sub FS_GEN_VFSECURE () {10;}' unless defined(&FS_GEN_VFSECURE);
    eval 'sub FS_GEN_LSECURE () {11;}' unless defined(&FS_GEN_LSECURE);
    eval 'sub FS_GEN_WAITING () {12;}' unless defined(&FS_GEN_WAITING);
    eval 'sub FS_PRO_BASE () {1000;}' unless defined(&FS_PRO_BASE);
    eval 'sub FS_PRO_CONFLICT () {1000;}' unless defined(&FS_PRO_CONFLICT);
    eval 'sub FS_PRO_UNSUPORT () {1001;}' unless defined(&FS_PRO_UNSUPORT);
    eval 'sub FS_PRO_MANDATORY () {1002;}' unless defined(&FS_PRO_MANDATORY);
    eval 'sub FS_PRO_UNPARAM () {1003;}' unless defined(&FS_PRO_UNPARAM);
    eval 'sub FS_PRO_DUPARAM () {1004;}' unless defined(&FS_PRO_DUPARAM);
    eval 'sub FS_PRO_ILLEGAL () {1005;}' unless defined(&FS_PRO_ILLEGAL);
    eval 'sub FS_PRO_UNTYPE () {1006;}' unless defined(&FS_PRO_UNTYPE);
    eval 'sub FS_PRO_ERR () {1007;}' unless defined(&FS_PRO_ERR);
    eval 'sub FS_PRO_ERRPROC () {1008;}' unless defined(&FS_PRO_ERRPROC);
    eval 'sub FS_PRO_ERRFUNIT () {1009;}' unless defined(&FS_PRO_ERRFUNIT);
    eval 'sub FS_PRO_ERRMSG () {1010;}' unless defined(&FS_PRO_ERRMSG);
    eval 'sub FS_PRO_LOWFAIL () {1011;}' unless defined(&FS_PRO_LOWFAIL);
    eval 'sub FS_PRO_LOWADDR () {1012;}' unless defined(&FS_PRO_LOWADDR);
    eval 'sub FS_PRO_TIMEOUT () {1013;}' unless defined(&FS_PRO_TIMEOUT);
    eval 'sub FS_PRO_SHUTDOWN () {1014;}' unless defined(&FS_PRO_SHUTDOWN);
    eval 'sub FS_PRO_GROUPING () {1015;}' unless defined(&FS_PRO_GROUPING);
    eval 'sub FS_PRO_THRESH () {1016;}' unless defined(&FS_PRO_THRESH);
    eval 'sub FS_PRO_PDU () {1017;}' unless defined(&FS_PRO_PDU);
    eval 'sub FS_ACS_BASE () {2000;}' unless defined(&FS_ACS_BASE);
    eval 'sub FS_ACS_USER () {2000;}' unless defined(&FS_ACS_USER);
    eval 'sub FS_ACS_2001 () {2001;}' unless defined(&FS_ACS_2001);
    eval 'sub FS_ACS_CLASS () {2002;}' unless defined(&FS_ACS_CLASS);
    eval 'sub FS_ACS_FUNIT () {2003;}' unless defined(&FS_ACS_FUNIT);
    eval 'sub FS_ACS_GRP () {2004;}' unless defined(&FS_ACS_GRP);
    eval 'sub FS_ACS_GRPSUP () {2005;}' unless defined(&FS_ACS_GRPSUP);
    eval 'sub FS_ACS_GRPALL () {2006;}' unless defined(&FS_ACS_GRPALL);
    eval 'sub FS_ACS_ACCT () {2007;}' unless defined(&FS_ACS_ACCT);
    eval 'sub FS_ACS_MGMT () {2008;}' unless defined(&FS_ACS_MGMT);
    eval 'sub FS_ACS_MGMTADDR () {2009;}' unless defined(&FS_ACS_MGMTADDR);
    eval 'sub FS_ACS_MGMTACCT () {2010;}' unless defined(&FS_ACS_MGMTACCT);
    eval 'sub FS_ACS_CKPLARGE () {2011;}' unless defined(&FS_ACS_CKPLARGE);
    eval 'sub FS_ACS_CKPSMALL () {2012;}' unless defined(&FS_ACS_CKPSMALL);
    eval 'sub FS_ACS_CKPERR () {2013;}' unless defined(&FS_ACS_CKPERR);
    eval 'sub FS_ACS_QOS () {2014;}' unless defined(&FS_ACS_QOS);
    eval 'sub FS_ACS_IDENTITY () {2015;}' unless defined(&FS_ACS_IDENTITY);
    eval 'sub FS_ACS_CONTEXT () {2016;}' unless defined(&FS_ACS_CONTEXT);
    eval 'sub FS_ACS_ROLLBACK () {2017;}' unless defined(&FS_ACS_ROLLBACK);
    eval 'sub FS_ACS_CNTRESP () {2018;}' unless defined(&FS_ACS_CNTRESP);
    eval 'sub FS_ACS_CNTPSAP () {2019;}' unless defined(&FS_ACS_CNTPSAP);
    eval 'sub FS_ACS_PASSWORD () {2020;}' unless defined(&FS_ACS_PASSWORD);
    eval 'sub FS_ACS_SERVICES () {2021;}' unless defined(&FS_ACS_SERVICES);
    eval 'sub FS_SEL_BASE () {3000;}' unless defined(&FS_SEL_BASE);
    eval 'sub FS_SEL_FILENAME () {3000;}' unless defined(&FS_SEL_FILENAME);
    eval 'sub FS_SEL_MATCHED () {3001;}' unless defined(&FS_SEL_MATCHED);
    eval 'sub FS_SEL_INITIAL () {3002;}' unless defined(&FS_SEL_INITIAL);
    eval 'sub FS_SEL_ATTRNAME () {3003;}' unless defined(&FS_SEL_ATTRNAME);
    eval 'sub FS_SEL_NOEXIST () {3004;}' unless defined(&FS_SEL_NOEXIST);
    eval 'sub FS_SEL_EXISTS () {3005;}' unless defined(&FS_SEL_EXISTS);
    eval 'sub FS_SEL_CREATE () {3006;}' unless defined(&FS_SEL_CREATE);
    eval 'sub FS_SEL_DELETE () {3007;}' unless defined(&FS_SEL_DELETE);
    eval 'sub FS_SEL_CONAVAIL () {3008;}' unless defined(&FS_SEL_CONAVAIL);
    eval 'sub FS_SEL_CONSUPRT () {3009;}' unless defined(&FS_SEL_CONSUPRT);
    eval 'sub FS_SEL_CONPOSS () {3010;}' unless defined(&FS_SEL_CONPOSS);
    eval 'sub FS_SEL_RESTRICT () {3011;}' unless defined(&FS_SEL_RESTRICT);
    eval 'sub FS_SEL_BUSY () {3012;}' unless defined(&FS_SEL_BUSY);
    eval 'sub FS_SEL_AVAIL () {3013;}' unless defined(&FS_SEL_AVAIL);
    eval 'sub FS_SEL_ACCAVAIL () {3014;}' unless defined(&FS_SEL_ACCAVAIL);
    eval 'sub FS_SEL_ACCSUPRT () {3015;}' unless defined(&FS_SEL_ACCSUPRT);
    eval 'sub FS_SEL_ACCINCON () {3016;}' unless defined(&FS_SEL_ACCINCON);
    eval 'sub FS_SEL_TRUNC () {3017;}' unless defined(&FS_SEL_TRUNC);
    eval 'sub FS_SEL_ALTER () {3018;}' unless defined(&FS_SEL_ALTER);
    eval 'sub FS_SEL_ACCOUNT () {3019;}' unless defined(&FS_SEL_ACCOUNT);
    eval 'sub FS_SEL_CREEXIST () {3020;}' unless defined(&FS_SEL_CREEXIST);
    eval 'sub FS_SEL_CREOLD () {3021;}' unless defined(&FS_SEL_CREOLD);
    eval 'sub FS_SEL_CRENEW () {3022;}' unless defined(&FS_SEL_CRENEW);
    eval 'sub FS_SEL_CRELOSE () {3023;}' unless defined(&FS_SEL_CRELOSE);
    eval 'sub FS_SEL_AMBIG () {3024;}' unless defined(&FS_SEL_AMBIG);
    eval 'sub FS_SEL_CREPASS () {3025;}' unless defined(&FS_SEL_CREPASS);
    eval 'sub FS_SEL_DELPASS () {3026;}' unless defined(&FS_SEL_DELPASS);
    eval 'sub FS_SEL_ATRVALUE () {3027;}' unless defined(&FS_SEL_ATRVALUE);
    eval 'sub FS_SEL_VIOLATES () {3028;}' unless defined(&FS_SEL_VIOLATES);
    eval 'sub FS_SEL_NOTAVAIL () {3029;}' unless defined(&FS_SEL_NOTAVAIL);
    eval 'sub FS_SEL_CRENOSEL () {3030;}' unless defined(&FS_SEL_CRENOSEL);
    eval 'sub FS_MGT_BASE () {4000;}' unless defined(&FS_MGT_BASE);
    eval 'sub FS_MGT_EXIST () {4000;}' unless defined(&FS_MGT_EXIST);
    eval 'sub FS_MGT_READ () {4001;}' unless defined(&FS_MGT_READ);
    eval 'sub FS_MGT_CHANGE () {4002;}' unless defined(&FS_MGT_CHANGE);
    eval 'sub FS_MGT_SUPPORT () {4003;}' unless defined(&FS_MGT_SUPPORT);
    eval 'sub FS_MGT_NAME () {4004;}' unless defined(&FS_MGT_NAME);
    eval 'sub FS_MGT_VALUE () {4005;}' unless defined(&FS_MGT_VALUE);
    eval 'sub FS_MGT_PARTIAL () {4006;}' unless defined(&FS_MGT_PARTIAL);
    eval 'sub FS_MGMT_DISTINCT () {4007;}' unless defined(&FS_MGMT_DISTINCT);
    eval 'sub FS_ACC_BASE () {5000;}' unless defined(&FS_ACC_BASE);
    eval 'sub FS_ACC_FADU () {5000;}' unless defined(&FS_ACC_FADU);
    eval 'sub FS_ACC_FADUSIZE () {5001;}' unless defined(&FS_ACC_FADUSIZE);
    eval 'sub FS_ACC_FADUTYPE () {5002;}' unless defined(&FS_ACC_FADUTYPE);
    eval 'sub FS_ACC_FADUSPEC () {5003;}' unless defined(&FS_ACC_FADUSPEC);
    eval 'sub FS_ACC_FADULOC () {5004;}' unless defined(&FS_ACC_FADULOC);
    eval 'sub FS_ACC_EXIST () {5005;}' unless defined(&FS_ACC_EXIST);
    eval 'sub FS_ACC_AVL () {5006;}' unless defined(&FS_ACC_AVL);
    eval 'sub FS_ACC_AVLREAD () {5007;}' unless defined(&FS_ACC_AVLREAD);
    eval 'sub FS_ACC_AVLWRITE () {5008;}' unless defined(&FS_ACC_AVLWRITE);
    eval 'sub FS_ACC_AVLLOC () {5009;}' unless defined(&FS_ACC_AVLLOC);
    eval 'sub FS_ACC_AVLERASE () {5010;}' unless defined(&FS_ACC_AVLERASE);
    eval 'sub FS_ACC_INSERT () {5011;}' unless defined(&FS_ACC_INSERT);
    eval 'sub FS_ACC_REPLACE () {5012;}' unless defined(&FS_ACC_REPLACE);
    eval 'sub FS_ACC_LOCATE () {5013;}' unless defined(&FS_ACC_LOCATE);
    eval 'sub FS_ACC_ELEMENT () {5014;}' unless defined(&FS_ACC_ELEMENT);
    eval 'sub FS_ACC_OPAVAIL () {5015;}' unless defined(&FS_ACC_OPAVAIL);
    eval 'sub FS_ACC_OPSUPRT () {5016;}' unless defined(&FS_ACC_OPSUPRT);
    eval 'sub FS_ACC_OPCONS () {5017;}' unless defined(&FS_ACC_OPCONS);
    eval 'sub FS_ACC_CONAVAIL () {5018;}' unless defined(&FS_ACC_CONAVAIL);
    eval 'sub FS_ACC_CONSUPRT () {5019;}' unless defined(&FS_ACC_CONSUPRT);
    eval 'sub FS_ACC_CONINCON () {5020;}' unless defined(&FS_ACC_CONINCON);
    eval 'sub FS_ACC_MODAVAIL () {5021;}' unless defined(&FS_ACC_MODAVAIL);
    eval 'sub FS_ACC_MODSUPRT () {5022;}' unless defined(&FS_ACC_MODSUPRT);
    eval 'sub FS_ACC_MODINCON () {5023;}' unless defined(&FS_ACC_MODINCON);
    eval 'sub FS_ACC_CTXAVAIL () {5024;}' unless defined(&FS_ACC_CTXAVAIL);
    eval 'sub FS_ACC_CTXSUPRT () {5025;}' unless defined(&FS_ACC_CTXSUPRT);
    eval 'sub FS_ACC_WRITE () {5026;}' unless defined(&FS_ACC_WRITE);
    eval 'sub FS_ACC_READ () {5027;}' unless defined(&FS_ACC_READ);
    eval 'sub FS_ACC_LCL () {5028;}' unless defined(&FS_ACC_LCL);
    eval 'sub FS_ACC_LCLSPACE () {5029;}' unless defined(&FS_ACC_LCLSPACE);
    eval 'sub FS_ACC_LCLDATA () {5030;}' unless defined(&FS_ACC_LCLDATA);
    eval 'sub FS_ACC_LCLDEV () {5031;}' unless defined(&FS_ACC_LCLDEV);
    eval 'sub FS_ACC_FFSEXCEED () {5032;}' unless defined(&FS_ACC_FFSEXCEED);
    eval 'sub FS_ACC_FFSINCRES () {5034;}' unless defined(&FS_ACC_FFSINCRES);
    eval 'sub FS_ACC_FUNIT () {5035;}' unless defined(&FS_ACC_FUNIT);
    eval 'sub FS_ACC_TYPINCON () {5036;}' unless defined(&FS_ACC_TYPINCON);
    eval 'sub FS_ACC_TYPSIMPL () {5037;}' unless defined(&FS_ACC_TYPSIMPL);
    eval 'sub FS_ACC_DUPLICATE () {5038;}' unless defined(&FS_ACC_DUPLICATE);
    eval 'sub FS_ACC_DAMAGED () {5039;}' unless defined(&FS_ACC_DAMAGED);
    eval 'sub FS_ACC_NOLOCKS () {5040;}' unless defined(&FS_ACC_NOLOCKS);
    eval 'sub FS_ACC_LOCKED () {5041;}' unless defined(&FS_ACC_LOCKED);
    eval 'sub FS_RVY_BASE () {6000;}' unless defined(&FS_RVY_BASE);
    eval 'sub FS_RVY_CKP () {6000;}' unless defined(&FS_RVY_CKP);
    eval 'sub FS_RVY_UNIQUE () {6001;}' unless defined(&FS_RVY_UNIQUE);
    eval 'sub FS_RVY_WINDOW () {6002;}' unless defined(&FS_RVY_WINDOW);
    eval 'sub FS_RVY_EXISTS () {6003;}' unless defined(&FS_RVY_EXISTS);
    eval 'sub FS_RVY_RECOG () {6004;}' unless defined(&FS_RVY_RECOG);
    eval 'sub FS_RVY_NODOCKET () {6005;}' unless defined(&FS_RVY_NODOCKET);
    eval 'sub FS_RVY_CODOCKET () {6006;}' unless defined(&FS_RVY_CODOCKET);
    eval 'sub FS_RVY_WAITING () {6007;}' unless defined(&FS_RVY_WAITING);
    eval 'sub FS_RVY_RECOVERY () {6008;}' unless defined(&FS_RVY_RECOVERY);
    eval 'sub FS_RVY_NOPOINT () {6009;}' unless defined(&FS_RVY_NOPOINT);
    eval 'sub FS_RVY_MODAVAIL () {6010;}' unless defined(&FS_RVY_MODAVAIL);
    eval 'sub FS_RVY_MODINCON () {6011;}' unless defined(&FS_RVY_MODINCON);
    eval 'sub FS_RVY_MODREDUCE () {6012;}' unless defined(&FS_RVY_MODREDUCE);
    eval 'sub FS_RVY_ACCAVAIL () {6013;}' unless defined(&FS_RVY_ACCAVAIL);
    eval 'sub FS_RVY_ACCSUPRT () {6014;}' unless defined(&FS_RVY_ACCSUPRT);
    eval 'sub FS_RVY_ACCINCON () {6015;}' unless defined(&FS_RVY_ACCINCON);
    eval 'sub FS_RVY_TYPINCON () {6016;}' unless defined(&FS_RVY_TYPINCON);
    eval 'sub FS_RVY_TYPSIMPL () {6017;}' unless defined(&FS_RVY_TYPSIMPL);
    eval 'sub EREF_NONE () {0;}' unless defined(&EREF_NONE);
    eval 'sub EREF_IFSU () {1;}' unless defined(&EREF_IFSU);
    eval 'sub EREF_IFPM () {2;}' unless defined(&EREF_IFPM);
    eval 'sub EREF_SERV () {3;}' unless defined(&EREF_SERV);
    eval 'sub EREF_RFPM () {4;}' unless defined(&EREF_RFPM);
    eval 'sub EREF_RFSU () {5;}' unless defined(&EREF_RFSU);
    eval 'sub DIAG_NODELAY () {(-1);}' unless defined(&DIAG_NODELAY);
    eval 'sub FTD_SIZE () {512;}' unless defined(&FTD_SIZE);
    eval 'sub NFCHRG () {5;}' unless defined(&NFCHRG);
    eval 'sub FPFREE {
        my($fp) = @_;
	    eval q({  &register \'struct FTAMpasswords\' * &FP = ($fp);  &if ( &FP ->  &fp_read)  &free ( &FP ->  &fp_read),  &FP ->  &fp_read =  &NULL;  &if ( &FP ->  &fp_insert)  &free ( &FP ->  &fp_insert),  &FP ->  &fp_insert =  &NULL;  &if ( &FP ->  &fp_replace)  &free ( &FP ->  &fp_replace),  &FP ->  &fp_replace =  &NULL;  &if ( &FP ->  &fp_extend)  &free ( &FP ->  &fp_extend),  &FP ->  &fp_extend =  &NULL;  &if ( &FP ->  &fp_erase)  &free ( &FP ->  &fp_erase),  &FP ->  &fp_erase =  &NULL;  &if ( &FP ->  &fp_readattr)  &free ( &FP ->  &fp_readattr),  &FP ->  &fp_readattr =  &NULL;  &if ( &FP ->  &fp_chngattr)  &free ( &FP ->  &fp_chngattr),  &FP ->  &fp_chngattr =  &NULL;  &if ( &FP ->  &fp_delete)  &free ( &FP ->  &fp_delete),  &FP ->  &fp_delete =  &NULL; });
    }' unless defined(&FPFREE);
    eval 'sub FLOCK_SHARED () {00;}' unless defined(&FLOCK_SHARED);
    eval 'sub FLOCK_EXCLUSIVE () {01;}' unless defined(&FLOCK_EXCLUSIVE);
    eval 'sub FLOCK_NOTREQD () {02;}' unless defined(&FLOCK_NOTREQD);
    eval 'sub FLOCK_NOACCESS () {03;}' unless defined(&FLOCK_NOACCESS);
    eval 'sub FLOCK_MASK () {03;}' unless defined(&FLOCK_MASK);
    eval 'sub FLOCK_PRESENT () { &FLOCK_EXCLUSIVE;}' unless defined(&FLOCK_PRESENT);
    eval 'sub FLOCK_RESTRICT () {01;}' unless defined(&FLOCK_RESTRICT);
    eval 'sub FCINIT {
        my($fc) = @_;
	    eval q({ ($fc) ->  &fc_readlock =  &FLOCK_NOTREQD; ($fc) ->  &fc_insertlock =  &FLOCK_NOTREQD; ($fc) ->  &fc_replacelock =  &FLOCK_NOTREQD; ($fc) ->  &fc_eraselock =  &FLOCK_NOTREQD; ($fc) ->  &fc_extendlock =  &FLOCK_NOTREQD; ($fc) ->  &fc_readattrlock =  &FLOCK_NOTREQD; ($fc) ->  &fc_chngattrlock =  &FLOCK_NOTREQD; ($fc) ->  &fc_deletelock =  &FLOCK_NOTREQD; });
    }' unless defined(&FCINIT);
    eval 'sub FA_PERM_READ () {0x1;}' unless defined(&FA_PERM_READ);
    eval 'sub FA_PERM_INSERT () {0x2;}' unless defined(&FA_PERM_INSERT);
    eval 'sub FA_PERM_REPLACE () {0x4;}' unless defined(&FA_PERM_REPLACE);
    eval 'sub FA_PERM_EXTEND () {0x8;}' unless defined(&FA_PERM_EXTEND);
    eval 'sub FA_PERM_ERASE () {0x10;}' unless defined(&FA_PERM_ERASE);
    eval 'sub FA_PERM_READATTR () {0x20;}' unless defined(&FA_PERM_READATTR);
    eval 'sub FA_PERM_CHNGATTR () {0x40;}' unless defined(&FA_PERM_CHNGATTR);
    eval 'sub FA_PERM_DELETE () {0x80;}' unless defined(&FA_PERM_DELETE);
    eval 'sub FEFREE {
        my($fe) = @_;
	    eval q({  &register \'struct FTAMacelement\' * &FE, * &FN;  &for ( &FE = ;  &FE;  &FE =  &FN) {  &FN =  &FE ->  &fe_next;  &if ( &FE ->  &fe_identity)  &free ( &FE ->  &fe_identity),  &FE ->  &fe_identity =  &NULL;  &FPFREE ( &FE ->  &fe_passwords);  &if ( &FE ->  &fe_aet) {  &AEIFREE ( &FE ->  &fe_aet);  &free (  &FE ->  &fe_aet),  &FE ->  &fe_aet =  &NULL; }  &FE ->  &fe_next =  &NULL;  &free (  &FE); } });
    }' unless defined(&FEFREE);
    eval 'sub FA_NULL () {0x;}' unless defined(&FA_NULL);
    eval 'sub FA_FILENAME () {0x1;}' unless defined(&FA_FILENAME);
    eval 'sub FA_ACTIONS () {0x2;}' unless defined(&FA_ACTIONS);
    eval 'sub FA_CONTENTS () {0x4;}' unless defined(&FA_CONTENTS);
    eval 'sub FA_ACCOUNT () {0x8;}' unless defined(&FA_ACCOUNT);
    eval 'sub FA_DATE_CREATE () {0x10;}' unless defined(&FA_DATE_CREATE);
    eval 'sub FA_DATE_MODIFY () {0x20;}' unless defined(&FA_DATE_MODIFY);
    eval 'sub FA_DATE_READ () {0x40;}' unless defined(&FA_DATE_READ);
    eval 'sub FA_DATE_ATTR () {0x80;}' unless defined(&FA_DATE_ATTR);
    eval 'sub FA_ID_CREATE () {0x100;}' unless defined(&FA_ID_CREATE);
    eval 'sub FA_ID_MODIFY () {0x200;}' unless defined(&FA_ID_MODIFY);
    eval 'sub FA_ID_READ () {0x400;}' unless defined(&FA_ID_READ);
    eval 'sub FA_ID_ATTR () {0x800;}' unless defined(&FA_ID_ATTR);
    eval 'sub FA_AVAILABILITY () {0x1000;}' unless defined(&FA_AVAILABILITY);
    eval 'sub FA_FILESIZE () {0x2000;}' unless defined(&FA_FILESIZE);
    eval 'sub FA_FUTURESIZE () {0x4000;}' unless defined(&FA_FUTURESIZE);
    eval 'sub FA_CONTROL () {0x8000;}' unless defined(&FA_CONTROL);
    eval 'sub FA_LEGAL () {0x10000;}' unless defined(&FA_LEGAL);
    eval 'sub FA_PRIVATE () {0x20000;}' unless defined(&FA_PRIVATE);
    eval 'sub FA_KERNEL () {( &FA_FILENAME |  &FA_ACTIONS |  &FA_CONTENTS);}' unless defined(&FA_KERNEL);
    eval 'sub FA_STORAGE () {( &FA_ACCOUNT |  &FA_DATE_CREATE |  &FA_DATE_MODIFY |  &FA_DATE_READ |  &FA_DATE_ATTR |  &FA_ID_CREATE |  &FA_ID_MODIFY |  &FA_ID_READ |  &FA_ID_ATTR |  &FA_AVAILABILITY |  &FA_FILESIZE |  &FA_FUTURESIZE);}' unless defined(&FA_STORAGE);
    eval 'sub FA_SECURITY () {( &FA_CONTROL |  &FA_LEGAL);}' unless defined(&FA_SECURITY);
    eval 'sub NFFILE () {5;}' unless defined(&NFFILE);
    eval 'sub FA_PERM_TRAV () {0x100;}' unless defined(&FA_PERM_TRAV);
    eval 'sub FA_PERM_RVTRAV () {0x200;}' unless defined(&FA_PERM_RVTRAV);
    eval 'sub FA_PERM_RANDOM () {0x400;}' unless defined(&FA_PERM_RANDOM);
    eval 'sub FA_PERM_TRAVERSAL () {( &FA_PERM_TRAV |  &FA_PERM_RVTRAV |  &FA_PERM_RANDOM);}' unless defined(&FA_PERM_TRAVERSAL);
    eval 'sub FA_AVAIL_IMMED () {0;}' unless defined(&FA_AVAIL_IMMED);
    eval 'sub FA_AVAIL_DEFER () {1;}' unless defined(&FA_AVAIL_DEFER);
    eval 'sub FA_FIRSTLAST () {0;}' unless defined(&FA_FIRSTLAST);
    eval 'sub FA_RELATIVE () {1;}' unless defined(&FA_RELATIVE);
    eval 'sub FA_BEGINEND () {2;}' unless defined(&FA_BEGINEND);
    eval 'sub FA_SINGLE () {3;}' unless defined(&FA_SINGLE);
    eval 'sub FA_NAMELIST () {4;}' unless defined(&FA_NAMELIST);
    eval 'sub FA_FADUNUMBER () {5;}' unless defined(&FA_FADUNUMBER);
    eval 'sub FA_FIRST () {0;}' unless defined(&FA_FIRST);
    eval 'sub FA_LAST () {1;}' unless defined(&FA_LAST);
    eval 'sub FA_PREVIOUS () {0;}' unless defined(&FA_PREVIOUS);
    eval 'sub FA_CURRENT () {1;}' unless defined(&FA_CURRENT);
    eval 'sub FA_NEXT () {2;}' unless defined(&FA_NEXT);
    eval 'sub FA_BEGIN () {0;}' unless defined(&FA_BEGIN);
    eval 'sub FA_END () {1;}' unless defined(&FA_END);
    eval 'sub NANAME () {5;}' unless defined(&NANAME);
    eval 'sub fa_firstlast () { ($fa_un->{fa_un_firstlast});}' unless defined(&fa_firstlast);
    eval 'sub fa_relative () { ($fa_un->{fa_un_relative});}' unless defined(&fa_relative);
    eval 'sub fa_beginend () { ($fa_un->{fa_un_beginend});}' unless defined(&fa_beginend);
    eval 'sub fa_singlename () { ($fa_un->{fa_un_singlename});}' unless defined(&fa_singlename);
    eval 'sub fa_names () { ($fa_un->{fa_un_list}->{fa_un_names});}' unless defined(&fa_names);
    eval 'sub fa_nname () { ($fa_un->{fa_un_list}->{fa_un_nname});}' unless defined(&fa_nname);
    eval 'sub fa_fadunumber () { ($fa_un->{fa_un_fadunumber});}' unless defined(&fa_fadunumber);
    eval 'sub FUFREE {
        my($fu) = @_;
	    eval q({  &register \'int\'  &FUI;  &if (($fu) ->  &fa_singlename)  &free (($fu) ->  &fa_singlename), ($fu) ->  &fa_singlename =  &NULL;  &for ( &FUI = ($fu) ->  &fa_nname - 1;  &FUI >= 0;  &FUI--)  &if (($fu) ->  $fa_names[ &FUI])  &free (($fu) ->  $fa_names[ &FUI]), ($fu) ->  $fa_names[ &FUI] =  &NULL; });
    }' unless defined(&FUFREE);
    eval 'sub FTSFREE {
        my($fts) = @_;
	    eval q({  &register \'int\'  &FSI;  &AEIFREE (($fts) ->  &fts_callingtitle);  &AEIFREE (($fts) ->  &fts_calledtitle);  &if (($fts) ->  &fts_context)  &oid_free (($fts) ->  &fts_context), ($fts) ->  &fts_context =  &NULLOID;  &if (($fts) ->  &fts_sharedASE)  &pe_free (($fts) ->  &fts_sharedASE), ($fts) ->  &fts_sharedASE =  &NULLPE;  &for ( &FSI = ($fts) ->  ($fts_contents->{fc_ncontent}) - 1;  &FSI >= 0;  &FSI--)  &oid_free (($fts) ->  ($fts_contents->{fc_contents[&FSI]}->{fc_dtn})), ($fts) ->  ($fts_contents->{fc_contents[&FSI]}->{fc_dtn}) =  &NULLOID; ($fts) ->  ($fts_contents->{fc_ncontent}) = 0;  &if (($fts) ->  &fts_initiator)  &free (($fts) ->  &fts_initiator), ($fts) ->  &fts_initiator =  &NULL;  &if (($fts) ->  &fts_account)  &free (($fts) ->  &fts_account), ($fts) ->  &fts_account =  &NULL;  &if (($fts) ->  &fts_password)  &free (($fts) ->  &fts_password), ($fts) ->  &fts_password =  &NULL; });
    }' unless defined(&FTSFREE);
    eval 'sub NFDIAG () {5;}' unless defined(&NFDIAG);
    eval 'sub FTCFREE {
        my($ftc) = @_;
	    eval q({  &register \'int\'  &FCI;  &AEIFREE (($ftc) ->  &ftc_respondtitle);  &if (($ftc) ->  &ftc_context)  &oid_free (($ftc) ->  &ftc_context), ($ftc) ->  &ftc_context =  &NULLOID;  &if (($ftc) ->  &ftc_sharedASE)  &pe_free (($ftc) ->  &ftc_sharedASE), ($ftc) ->  &ftc_sharedASE =  &NULLPE;  &for ( &FCI = ($ftc) ->  ($ftc_contents->{fc_ncontent}) - 1;  &FCI >= 0;  &FCI--)  &oid_free (($ftc) ->  ($ftc_contents->{fc_contents[&FCI]}->{fc_dtn})), ($ftc) ->  ($ftc_contents->{fc_contents[&FCI]}->{fc_dtn}) =  &NULLOID; ($ftc) ->  ($ftc_contents->{fc_ncontent}) = 0; });
    }' unless defined(&FTCFREE);
    eval 'sub FTFFREE {
        my($ftf) = @_;
	    eval q({  &if (($ftf) ->  &ftf_sharedASE)  &pe_free (($ftf) ->  &ftf_sharedASE), ($ftf) ->  &ftf_sharedASE =  &NULLPE; });
    }' unless defined(&FTFFREE);
    eval 'sub FTRFREE {
        my($ftr) = @_;
	    eval q({  &register \'int\'  &FRI;  &register \'struct fc_charge\' * &FC;  &if (($ftr) ->  &ftr_sharedASE)  &pe_free (($ftr) ->  &ftr_sharedASE), ($ftr) ->  &ftr_sharedASE =  &NULLPE;  &for ( &FC = ($ftr) ->  ($ftr_charges->{fc_charges}),  &FRI = ($ftr) ->  ($ftr_charges->{fc_ncharge}) - 1;  &FRI >= 0;  &FC++,  &FRI--) {  &if ( &FC ->  &fc_resource)  &free ( &FC ->  &fc_resource),  &FC ->  &fc_resource =  &NULL;  &if ( &FC ->  &fc_unit)  &free ( &FC ->  &fc_unit),  &FC ->  &fc_unit =  &NULL; } ($ftr) ->  ($ftr_charges->{fc_ncharge}) = 0; });
    }' unless defined(&FTRFREE);
    eval 'sub FA_SEL_ATTRS () { &FA_FILENAME;}' unless defined(&FA_SEL_ATTRS);
    eval 'sub FA_REQ_MASK () {( &FA_PERM_READ |  &FA_PERM_INSERT |  &FA_PERM_REPLACE |  &FA_PERM_EXTEND |  &FA_PERM_ERASE |  &FA_PERM_READATTR |  &FA_PERM_CHNGATTR |  &FA_PERM_DELETE);}' unless defined(&FA_REQ_MASK);
    eval 'sub FTSEFREE {
        my($ftse) = @_;
	    eval q({  &FAFREE ((($ftse) ->  &ftse_attrs));  &FPFREE ((($ftse) ->  &ftse_pwds));  &if (($ftse) ->  &ftse_sharedASE)  &pe_free (($ftse) ->  &ftse_sharedASE), ($ftse) ->  &ftse_sharedASE =  &NULLPE;  &if (($ftse) ->  &ftse_account)  &free (($ftse) ->  &ftse_account), ($ftse) ->  &ftse_account =  &NULLCP; });
    }' unless defined(&FTSEFREE);
    eval 'sub FTDEFREE {
        my($ftde) = @_;
	    eval q({  &register \'int\'  &FDEI;  &register \'struct fc_charge\' * &FC;  &for ( &FC = ($ftde) ->  ($ftde_charges->{fc_charges}),  &FDEI = ($ftde) ->  ($ftde_charges->{fc_ncharge}) - 1;  &FDEI >= 0;  &FC++,  &FDEI--) {  &if ( &FC ->  &fc_resource)  &free ( &FC ->  &fc_resource),  &FC ->  &fc_resource =  &NULL;  &if ( &FC ->  &fc_unit)  &free ( &FC ->  &fc_unit),  &FC ->  &fc_unit =  &NULL; } ($ftde) ->  ($ftde_charges->{fc_ncharge}) = 0;  &if (($ftde) ->  &ftde_sharedASE)  &pe_free (($ftde) ->  &ftde_sharedASE), ($ftde) ->  &ftde_sharedASE =  &NULLPE; });
    }' unless defined(&FTDEFREE);
    eval 'sub FOVER_FAIL () {0;}' unless defined(&FOVER_FAIL);
    eval 'sub FOVER_SELECT () {1;}' unless defined(&FOVER_SELECT);
    eval 'sub FOVER_WRITE () {2;}' unless defined(&FOVER_WRITE);
    eval 'sub FOVER_DELETE () {3;}' unless defined(&FOVER_DELETE);
    eval 'sub FA_CRE_ATTRS () {( &FA_FILENAME |  &FA_ACTIONS |  &FA_CONTENTS |  &FA_ACCOUNT |  &FA_AVAILABILITY |  &FA_FUTURESIZE |  &FA_CONTROL |  &FA_LEGAL |  &FA_PRIVATE);}' unless defined(&FA_CRE_ATTRS);
    eval 'sub FTCEFREE {
        my($ftce) = @_;
	    eval q({  &FAFREE ((($ftce) ->  &ftce_attrs));  &if (($ftce) ->  &ftce_create)  &free (($ftce) ->  &ftce_create), ($ftce) ->  &ftce_create =  &NULLCP;  &FPFREE ((($ftce) ->  &ftce_pwds));  &if (($ftce) ->  &ftce_sharedASE)  &pe_free (($ftce) ->  &ftce_sharedASE), ($ftce) ->  &ftce_sharedASE =  &NULLPE;  &if (($ftce) ->  &ftce_account)  &free (($ftce) ->  &ftce_account), ($ftce) ->  &ftce_account =  &NULLCP; });
    }' unless defined(&FTCEFREE);
    eval 'sub FTXEFREE {
        my($ftxe) = @_;
	    eval q({  &register \'int\'  &FXEI;  &register \'struct fc_charge\' * &FC;  &if (($ftxe) ->  &ftxe_sharedASE)  &pe_free (($ftxe) ->  &ftxe_sharedASE), ($ftxe) ->  &ftxe_sharedASE =  &NULLPE;  &for ( &FC = ($ftxe) ->  ($ftxe_charges->{fc_charges}),  &FXEI = ($ftxe) ->  ($ftxe_charges->{fc_ncharge}) - 1;  &FXEI >= 0;  &FC++,  &FXEI--) {  &if ( &FC ->  &fc_resource)  &free ( &FC ->  &fc_resource),  &FC ->  &fc_resource =  &NULL;  &if ( &FC ->  &fc_unit)  &free ( &FC ->  &fc_unit),  &FC ->  &fc_unit =  &NULL; } ($ftxe) ->  ($ftxe_charges->{fc_ncharge}) = 0; });
    }' unless defined(&FTXEFREE);
    eval 'sub FTRAFREE {
        my($ftra) = @_;
	    eval q({  &FAFREE ((($ftra) ->  &ftra_attrs)); });
    }' unless defined(&FTRAFREE);
    eval 'sub FA_CHG_ATTRS () {( &FA_FILENAME |  &FA_ACCOUNT |  &FA_AVAILABILITY |  &FA_FUTURESIZE |  &FA_CONTROL |  &FA_LEGAL |  &FA_PRIVATE);}' unless defined(&FA_CHG_ATTRS);
    eval 'sub FTCAFREE {
        my($ftca) = @_;
	    eval q({  &FAFREE ((($ftca) ->  &ftca_attrs)); });
    }' unless defined(&FTCAFREE);
    eval 'sub FA_MODE_MASK () {( &FA_PERM_READ |  &FA_PERM_INSERT |  &FA_PERM_REPLACE |  &FA_PERM_EXTEND |  &FA_PERM_ERASE);}' unless defined(&FA_MODE_MASK);
    eval 'sub FTOPFREE {
        my($ftop) = @_;
	    eval q({  &if (($ftop) ->  &ftop_contents)  &oid_free (($ftop) ->  &ftop_contents), ($ftop) ->  &ftop_contents =  &NULLOID;  &if (($ftop) ->  &ftop_parameter)  &pe_free (($ftop) ->  &ftop_parameter), ($ftop) ->  &ftop_parameter =  &NULLPE;  &if (($ftop) ->  &ftop_sharedASE)  &pe_free (($ftop) ->  &ftop_sharedASE), ($ftop) ->  &ftop_sharedASE =  &NULLPE; });
    }' unless defined(&FTOPFREE);
    eval 'sub FTCLFREE {
        my($ftcl) = @_;
	    eval q({  &if (($ftcl) ->  &ftcl_sharedASE)  &pe_free (($ftcl) ->  &ftcl_sharedASE), ($ftcl) ->  &ftcl_sharedASE =  &NULLPE; });
    }' unless defined(&FTCLFREE);
    eval 'sub FTG_NULL () {0x;}' unless defined(&FTG_NULL);
    eval 'sub FTG_BEGIN () {0x1;}' unless defined(&FTG_BEGIN);
    eval 'sub FTG_SELECT () {0x2;}' unless defined(&FTG_SELECT);
    eval 'sub FTG_CREATE () {0x4;}' unless defined(&FTG_CREATE);
    eval 'sub FTG_RDATTR () {0x8;}' unless defined(&FTG_RDATTR);
    eval 'sub FTG_CHATTR () {0x10;}' unless defined(&FTG_CHATTR);
    eval 'sub FTG_OPEN () {0x20;}' unless defined(&FTG_OPEN);
    eval 'sub FTG_CLOSE () {0x40;}' unless defined(&FTG_CLOSE);
    eval 'sub FTG_DESELECT () {0x80;}' unless defined(&FTG_DESELECT);
    eval 'sub FTG_DELETE () {0x100;}' unless defined(&FTG_DELETE);
    eval 'sub FTG_END () {0x200;}' unless defined(&FTG_END);
    eval 'sub ftg_select () { ($ftg_un1->{ftg_un1_select});}' unless defined(&ftg_select);
    eval 'sub ftg_create () { ($ftg_un1->{ftg_un1_create});}' unless defined(&ftg_create);
    eval 'sub ftg_close () { ($ftg_un1->{ftg_un1_close});}' unless defined(&ftg_close);
    eval 'sub ftg_deselect () { ($ftg_un2->{ftg_un2_deselect});}' unless defined(&ftg_deselect);
    eval 'sub ftg_delete () { ($ftg_un2->{ftg_un2_delete});}' unless defined(&ftg_delete);
    eval 'sub ftg_open () { ($ftg_un2->{ftg_un2_open});}' unless defined(&ftg_open);
    eval 'sub FTGFREE {
        my($ftg) = @_;
	    eval q({  &if (($ftg) ->  &ftg_flags &  &FTG_SELECT) {  &FTSEFREE ((($ftg) ->  &ftg_select)); }  &else  &if (($ftg) ->  &ftg_flags &  &FTG_CREATE) {  &FTCEFREE ((($ftg) ->  &ftg_create)); }  &else  &if (($ftg) ->  &ftg_flags &  &FTG_CLOSE)  &FTCLFREE ((($ftg) ->  &ftg_close));  &if (($ftg) -> &ftg_flags &  &FTG_RDATTR)  &FTRAFREE ((($ftg) ->  &ftg_readattr));  &if (($ftg) -> &ftg_flags &  &FTG_CHATTR)  &FTCAFREE ((($ftg) ->  &ftg_chngattr));  &if (($ftg) ->  &ftg_flags &  &FTG_DESELECT) {  &FTDEFREE ((($ftg) ->  &ftg_deselect)); }  &else  &if (($ftg) ->  &ftg_flags &  &FTG_DELETE) {  &FTXEFREE ((($ftg) ->  &ftg_delete)); }  &else  &if (($ftg) ->  &ftg_flags &  &FTG_OPEN)  &FTOPFREE ((($ftg) ->  &ftg_open)); });
    }' unless defined(&FTGFREE);
    eval 'sub FA_OPS_LOCATE () {0;}' unless defined(&FA_OPS_LOCATE);
    eval 'sub FA_OPS_ERASE () {1;}' unless defined(&FA_OPS_ERASE);
    eval 'sub FTACFREE {
        my($ftac) = @_;
	    eval q({  &FUFREE ((($ftac) ->  &ftac_identity)); });
    }' unless defined(&FTACFREE);
    eval 'sub FA_OPS_READ () {(-1);}' unless defined(&FA_OPS_READ);
    eval 'sub FA_OPS_INSERT () {0;}' unless defined(&FA_OPS_INSERT);
    eval 'sub FA_OPS_REPLACE () {1;}' unless defined(&FA_OPS_REPLACE);
    eval 'sub FA_OPS_EXTEND () {2;}' unless defined(&FA_OPS_EXTEND);
    eval 'sub FA_ACC_HA () {0;}' unless defined(&FA_ACC_HA);
    eval 'sub FA_ACC_HN () {1;}' unless defined(&FA_ACC_HN);
    eval 'sub FA_ACC_FA () {2;}' unless defined(&FA_ACC_FA);
    eval 'sub FA_ACC_FL () {3;}' unless defined(&FA_ACC_FL);
    eval 'sub FA_ACC_FS () {4;}' unless defined(&FA_ACC_FS);
    eval 'sub FA_ACC_UA () {5;}' unless defined(&FA_ACC_UA);
    eval 'sub FA_ACC_US () {6;}' unless defined(&FA_ACC_US);
    eval 'sub FTRWFREE {
        my($ftrw) = @_;
	    eval q({  &FUFREE ((($ftrw) ->  &ftrw_identity)); });
    }' unless defined(&FTRWFREE);
    eval 'sub FTREFREE {
        my($ftre) = @_;
	    eval q({  &if (($ftre) ->  &ftre_sharedASE)  &pe_free (($ftre) ->  &ftre_sharedASE), ($ftre) ->  &ftre_sharedASE =  &NULLPE; });
    }' unless defined(&FTREFREE);
    eval 'sub FTCNFREE {
        my($ftcn) = @_;
	    eval q({  &if (($ftcn) ->  &ftcn_sharedASE)  &pe_free (($ftcn) ->  &ftcn_sharedASE), ($ftcn) ->  &ftcn_sharedASE =  &NULLPE; });
    }' unless defined(&FTCNFREE);
    eval 'sub FTI_FINISH () {0x;}' unless defined(&FTI_FINISH);
    eval 'sub FTI_ABORT () {0x1;}' unless defined(&FTI_ABORT);
    eval 'sub FTI_MANAGEMENT () {0x2;}' unless defined(&FTI_MANAGEMENT);
    eval 'sub FTI_BULKBEGIN () {0x3;}' unless defined(&FTI_BULKBEGIN);
    eval 'sub FTI_BULKEND () {0x4;}' unless defined(&FTI_BULKEND);
    eval 'sub FTI_ACCESS () {0x5;}' unless defined(&FTI_ACCESS);
    eval 'sub FTI_READWRITE () {0x6;}' unless defined(&FTI_READWRITE);
    eval 'sub FTI_DATA () {0x7;}' unless defined(&FTI_DATA);
    eval 'sub FTI_DATAEND () {0x8;}' unless defined(&FTI_DATAEND);
    eval 'sub FTI_CANCEL () {0x9;}' unless defined(&FTI_CANCEL);
    eval 'sub FTI_TRANSEND () {0x10;}' unless defined(&FTI_TRANSEND);
    eval 'sub fti_finish () { ($fti_un->{fti_un_finish});}' unless defined(&fti_finish);
    eval 'sub fti_abort () { ($fti_un->{fti_un_abort});}' unless defined(&fti_abort);
    eval 'sub fti_group () { ($fti_un->{fti_un_group});}' unless defined(&fti_group);
    eval 'sub fti_access () { ($fti_un->{fti_un_access});}' unless defined(&fti_access);
    eval 'sub fti_readwrite () { ($fti_un->{fti_un_readwrite});}' unless defined(&fti_readwrite);
    eval 'sub fti_data () { ($fti_un->{fti_un_data});}' unless defined(&fti_data);
    eval 'sub fti_dataend () { ($fti_un->{fti_un_dataend});}' unless defined(&fti_dataend);
    eval 'sub fti_cancel () { ($fti_un->{fti_un_cancel});}' unless defined(&fti_cancel);
    eval 'sub fti_transend () { ($fti_un->{fti_un_transend});}' unless defined(&fti_transend);
    eval 'sub FADU_NODESCR () {0;}' unless defined(&FADU_NODESCR);
    eval 'sub FADU_ENTERTREE () {1;}' unless defined(&FADU_ENTERTREE);
    eval 'sub FADU_EXITREE () {2;}' unless defined(&FADU_EXITREE);
}
1;
