require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_INTERNET_)) {
    eval 'sub _INTERNET_ () {1;}' unless defined(&_INTERNET_);
    unless(defined(&_MANIFEST_)) {
	require 'isode/manifest.ph';
    }
    require 'sys/socket.ph';
    unless(defined(&SOMAXCONN)) {
	eval 'sub SOMAXCONN () {5;}' unless defined(&SOMAXCONN);
    }
    if(defined( &WIN) || defined( &WINTLI)) {
	require 'sys/in.ph';
    } else {
	require 'netinet/in.ph';
    }
    if(defined(&SOCKETS)) {
	eval 'sub read_tcp_socket () { &read;}' unless defined(&read_tcp_socket);
	eval 'sub write_tcp_socket () { &write;}' unless defined(&write_tcp_socket);
	eval 'sub select_tcp_socket () { &selsocket;}' unless defined(&select_tcp_socket);
    }
    if(defined(&WINTLI)) {
	eval 'sub select_tcp_socket () { &selsocket;}' unless defined(&select_tcp_socket);
    }
    if(defined(&EXOS)) {
	if(defined(&SYS5)) {
	    eval 'sub join_tcp_client {
	        my($s,$f) = @_;
    		eval q(( &accept (($s),  ($f)) !=  &NOTOK ? ($s) :  &NOTOK));
	    }' unless defined(&join_tcp_client);
	    eval 'sub join_tcp_server {
	        my($s,$t) = @_;
    		eval q( &connect (($s),  ($t)));
	    }' unless defined(&join_tcp_server);
	    eval 'sub read_tcp_socket () { &read;}' unless defined(&read_tcp_socket);
	    eval 'sub write_tcp_socket () { &write;}' unless defined(&write_tcp_socket);
	    eval 'sub close_tcp_socket () { &close;}' unless defined(&close_tcp_socket);
	    eval 'sub select_tcp_socket () { &selsocket;}' unless defined(&select_tcp_socket);
	}
    }
    unless(defined(&_AIX)) {
    }
    if(defined(&SOCKETS)) {
	unless(defined(&_DGRAM_)) {
	    require 'isode/dgram.ph';
	}
	eval 'sub start_udp_client () { &start_udp_server;}' unless defined(&start_udp_client);
	eval 'sub join_udp_server {
	    my($fd,$sock) = @_;
    	    eval q( &join_dgram_aux (($fd),  ($sock), 0));
	}' unless defined(&join_udp_server);
	eval 'sub join_udp_client {
	    my($fd,$sock) = @_;
    	    eval q( &join_dgram_aux (($fd),  ($sock), 1));
	}' unless defined(&join_udp_client);
	eval 'sub read_udp_socket () { &read_dgram_socket;}' unless defined(&read_udp_socket);
	eval 'sub write_udp_socket () { &write_dgram_socket;}' unless defined(&write_udp_socket);
	eval 'sub close_udp_socket () { &close_dgram_socket;}' unless defined(&close_udp_socket);
	eval 'sub select_udp_socket () { &select_dgram_socket;}' unless defined(&select_udp_socket);
	eval 'sub check_udp_socket () { &check_dgram_socket;}' unless defined(&check_udp_socket);
    }
    if(defined( &SOCKETS) || defined ( &WINTLI) || defined ( &WIN)) {
	require 'netdb.ph';
    }
    if(defined( &BIND)  && !defined( &h_addr)) {
	eval 'sub h_addr () { $h_addr_list[0];}' unless defined(&h_addr);
    }
    eval 'sub inaddr_copy {
        my($hp,$sin) = @_;
	    eval q( &bcopy (($hp) ->  &h_addr,  (($sin) ->  &sin_addr), ($hp) ->  &h_length));
    }' unless defined(&inaddr_copy);
    if(defined(&EXOS)) {
    }
    unless(defined(&_AIX)) {
	unless(defined(&DG)) {
	    unless(defined(&HPUX)) {
	    } else {
	    }
	} else {
	}
    } else {
	require 'arpa/inet.ph';
    }
}
1;
