require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PEPSY_DEFINITIONS)) {
    eval 'sub PEPSY_DEFINITIONS () {1;}' unless defined(&PEPSY_DEFINITIONS);
    unless(defined(&PEPYPARM)) {
	eval 'sub PEPYPARM () {\'char\' *;}' unless defined(&PEPYPARM);
    }
    eval 'sub NULLTPE () {(( &tpe *)0);}' unless defined(&NULLTPE);
    eval 'sub NULLPTPE () {(( &ptpe *)0);}' unless defined(&NULLPTPE);
    eval 'sub GPTR {
        my($mod, $ind, $type) = @_;
	    eval q((($type )($mod)-> $md_ptrtab[$ind]));
    }' unless defined(&GPTR);
    eval 'sub IVAL {
        my($mod, $x) = @_;
	    eval q((($x)-> &pe_ucode));
    }' unless defined(&IVAL);
    eval 'sub PVAL {
        my($mod, $x) = @_;
	    eval q(( &GPTR($mod, ($x)-> &pe_tag, \'char\' *)));
    }' unless defined(&PVAL);
    eval 'sub TVAL {
        my($mod, $x) = @_;
	    eval q((($x)-> &pe_flags));
    }' unless defined(&TVAL);
    eval 'sub RVAL {
        my($mod, $x) = @_;
	    eval q((* &GPTR($mod, ($x)-> &pe_tag, \'double\' *)));
    }' unless defined(&RVAL);
    eval 'sub FN_PTR {
        my($mod, $x) = @_;
	    eval q((* &GPTR($mod, ($x)-> &pe_ucode,  &IFP )));
    }' unless defined(&FN_PTR);
    eval 'sub EXT2MOD {
        my($mod, $x) = @_;
	    eval q(( &GPTR($mod, ($x)-> &pe_ucode,  &modtyp *)));
    }' unless defined(&EXT2MOD);
    eval 'sub PE_START () {(-1);}' unless defined(&PE_START);
    eval 'sub PE_END () {0;}' unless defined(&PE_END);
    eval 'sub XOBJECT () {3;}' unless defined(&XOBJECT);
    eval 'sub UCODE () {6;}' unless defined(&UCODE);
    eval 'sub MEMALLOC () {7;}' unless defined(&MEMALLOC);
    eval 'sub SCTRL () {8;}' unless defined(&SCTRL);
    eval 'sub CH_ACT () {9;}' unless defined(&CH_ACT);
    eval 'sub OPTL () {10;}' unless defined(&OPTL);
    eval 'sub BOPTIONAL () {11;}' unless defined(&BOPTIONAL);
    eval 'sub FFN_CALL () {12;}' unless defined(&FFN_CALL);
    eval 'sub FREE_ONLY () {13;}' unless defined(&FREE_ONLY);
    eval 'sub TYPE_DATA () {20;}' unless defined(&TYPE_DATA);
    eval 'sub ANY () {( &TYPE_DATA + 0);}' unless defined(&ANY);
    eval 'sub INTEGER () {( &TYPE_DATA + 1);}' unless defined(&INTEGER);
    eval 'sub BOOLEAN () {( &TYPE_DATA + 2);}' unless defined(&BOOLEAN);
    eval 'sub OBJECT () {( &TYPE_DATA + 3);}' unless defined(&OBJECT);
    eval 'sub BITSTRING () {( &TYPE_DATA + 4);}' unless defined(&BITSTRING);
    eval 'sub OCTETSTRING () {( &TYPE_DATA + 5);}' unless defined(&OCTETSTRING);
    eval 'sub SET_START () {( &TYPE_DATA + 6);}' unless defined(&SET_START);
    eval 'sub SEQ_START () {( &TYPE_DATA + 7);}' unless defined(&SEQ_START);
    eval 'sub SEQOF_START () {( &TYPE_DATA + 8);}' unless defined(&SEQOF_START);
    eval 'sub SETOF_START () {( &TYPE_DATA + 9);}' unless defined(&SETOF_START);
    eval 'sub CHOICE_START () {( &TYPE_DATA + 10);}' unless defined(&CHOICE_START);
    eval 'sub REALTYPE () {( &TYPE_DATA + 11);}' unless defined(&REALTYPE);
    eval 'sub T_NULL () {( &TYPE_DATA + 12);}' unless defined(&T_NULL);
    eval 'sub T_OID () {( &TYPE_DATA + 13);}' unless defined(&T_OID);
    eval 'sub ETAG () {( &TYPE_DATA + 14);}' unless defined(&ETAG);
    eval 'sub IMP_OBJ () {( &TYPE_DATA + 15);}' unless defined(&IMP_OBJ);
    eval 'sub EXTOBJ () {( &TYPE_DATA + 16);}' unless defined(&EXTOBJ);
    eval 'sub EXTMOD () {( &TYPE_DATA + 17);}' unless defined(&EXTMOD);
    eval 'sub OBJID () {( &TYPE_DATA + 18);}' unless defined(&OBJID);
    eval 'sub DFLT_F () {( &TYPE_DATA + 19);}' unless defined(&DFLT_F);
    eval 'sub DFLT_B () {( &TYPE_DATA + 20);}' unless defined(&DFLT_B);
    eval 'sub T_STRING () {( &TYPE_DATA + 21);}' unless defined(&T_STRING);
    eval 'sub OCTET_PTR () {( &TYPE_DATA + 22);}' unless defined(&OCTET_PTR);
    eval 'sub OCTET_LEN () {( &TYPE_DATA + 23);}' unless defined(&OCTET_LEN);
    eval 'sub BITSTR_PTR () {( &TYPE_DATA + 24);}' unless defined(&BITSTR_PTR);
    eval 'sub BITSTR_LEN () {( &TYPE_DATA + 25);}' unless defined(&BITSTR_LEN);
    eval 'sub FN_CALL () {( &TYPE_DATA + 26);}' unless defined(&FN_CALL);
    if((defined(&PEPSY_VERSION) ? &PEPSY_VERSION : 0) >= 2) {
	eval 'sub STYPE_DATA () {( &TYPE_DATA + 50);}' unless defined(&STYPE_DATA);
    } else {
	eval 'sub STYPE_DATA () {( &TYPE_DATA + 30);}' unless defined(&STYPE_DATA);
    }
    eval 'sub SBITSTRING () {( &STYPE_DATA + 0);}' unless defined(&SBITSTRING);
    eval 'sub SOBJID () {( &STYPE_DATA + 1);}' unless defined(&SOBJID);
    eval 'sub SREALTYPE () {( &STYPE_DATA + 2);}' unless defined(&SREALTYPE);
    eval 'sub SANY () {( &STYPE_DATA + 3);}' unless defined(&SANY);
    eval 'sub SEXTOBJ () {( &STYPE_DATA + 4);}' unless defined(&SEXTOBJ);
    eval 'sub SOBJECT () {( &STYPE_DATA + 5);}' unless defined(&SOBJECT);
    eval 'sub SOCTETSTRING () {( &STYPE_DATA + 6);}' unless defined(&SOCTETSTRING);
    eval 'sub SEXTERNAL () {( &STYPE_DATA + 7);}' unless defined(&SEXTERNAL);
    eval 'sub SSEQ_START () {( &STYPE_DATA + 8);}' unless defined(&SSEQ_START);
    eval 'sub SSET_START () {( &STYPE_DATA + 9);}' unless defined(&SSET_START);
    eval 'sub SSEQOF_START () {( &STYPE_DATA + 10);}' unless defined(&SSEQOF_START);
    eval 'sub SSETOF_START () {( &STYPE_DATA + 11);}' unless defined(&SSETOF_START);
    eval 'sub SCHOICE_START () {( &STYPE_DATA + 12);}' unless defined(&SCHOICE_START);
    eval 'sub ISDTYPE {
        my($p) = @_;
	    eval q(( ($p->{pe_type}) >=  &TYPE_DATA));
    }' unless defined(&ISDTYPE);
    eval 'sub NONE () {0;}' unless defined(&NONE);
    eval 'sub T_BOOL () {1;}' unless defined(&T_BOOL);
    eval 'sub T_INTEGER () {2;}' unless defined(&T_INTEGER);
    eval 'sub T_OCTETSTRING () {4;}' unless defined(&T_OCTETSTRING);
    eval 'sub T_OBJIDENT () {6;}' unless defined(&T_OBJIDENT);
    eval 'sub T_EXTERNAL () {8;}' unless defined(&T_EXTERNAL);
    eval 'sub T_REAL () {9;}' unless defined(&T_REAL);
    eval 'sub T_ENUMERATED () {10;}' unless defined(&T_ENUMERATED);
    eval 'sub T_SEQ () {16;}' unless defined(&T_SEQ);
    eval 'sub T_SET () {17;}' unless defined(&T_SET);
    eval 'sub T_IA5 () {22;}' unless defined(&T_IA5);
    eval 'sub T_GRAPHIC () {25;}' unless defined(&T_GRAPHIC);
    eval 'sub FL_CLASS () {0xf;}' unless defined(&FL_CLASS);
    eval 'sub FL_UNIVERSAL () { &PE_CLASS_UNIV;}' unless defined(&FL_UNIVERSAL);
    eval 'sub FL_APPLICATION () { &PE_CLASS_APPL;}' unless defined(&FL_APPLICATION);
    eval 'sub FL_CONTEXT () { &PE_CLASS_CONT;}' unless defined(&FL_CONTEXT);
    eval 'sub FL_PRIVATE () { &PE_CLASS_PRIV;}' unless defined(&FL_PRIVATE);
    eval 'sub FL_IMPLICIT () {0100;}' unless defined(&FL_IMPLICIT);
    eval 'sub FL_DEFAULT () {0200;}' unless defined(&FL_DEFAULT);
    eval 'sub FL_OPTIONAL () {0400;}' unless defined(&FL_OPTIONAL);
    eval 'sub OPTIONAL {
        my($p) = @_;
	    eval q((($p)-> &pe_flags &  &FL_OPTIONAL));
    }' unless defined(&OPTIONAL);
    eval 'sub DEFAULT {
        my($p) = @_;
	    eval q((($p)-> &pe_flags &  &FL_DEFAULT));
    }' unless defined(&DEFAULT);
    eval 'sub FL_PRTAG () {01000;}' unless defined(&FL_PRTAG);
    eval 'sub PRINT_TAG {
        my($p) = @_;
	    eval q((($p)-> &pe_flags &  &FL_PRTAG));
    }' unless defined(&PRINT_TAG);
    eval 'sub FL_USELECT () {02000;}' unless defined(&FL_USELECT);
    eval 'sub IF_USELECT {
        my($p) = @_;
	    eval q((($p) ->  &pe_flags &  &FL_USELECT));
    }' unless defined(&IF_USELECT);
    eval 'sub CLASS {
        my($p) = @_;
	    eval q((( &PElementClass)(($p)-> &pe_flags &  &FL_CLASS)));
    }' unless defined(&CLASS);
    eval 'sub TAG {
        my($p) = @_;
	    eval q((( &PElementID)(($p)-> &pe_tag)));
    }' unless defined(&TAG);
    eval 'sub STAG {
        my($p) = @_;
	    eval q((($p)-> &pe_tag));
    }' unless defined(&STAG);
    eval 'sub TESTBIT {
        my($p, $bit) = @_;
	    eval q((($p) & (1<< ($bit))));
    }' unless defined(&TESTBIT);
    eval 'sub SETBIT {
        my($p, $bit) = @_;
	    eval q((($p) |= (1<< ($bit))));
    }' unless defined(&SETBIT);
    eval 'sub CLRBIT {
        my($p, $bit) = @_;
	    eval q((($p) &= ~(1<< ($bit))));
    }' unless defined(&CLRBIT);
    eval 'sub BITTEST {
        my($p, $bit) = @_;
	    eval q(((($p)[($bit)/8]) & (0x80 >> ($bit) % 8)));
    }' unless defined(&BITTEST);
    eval 'sub BITSET {
        my($p, $bit) = @_;
	    eval q(((($p)[($bit)/8]) |= (0x80 >> ($bit) % 8)));
    }' unless defined(&BITSET);
    eval 'sub BITCLR {
        my($p, $bit) = @_;
	    eval q(((($p)[($bit)/8]) &= ~(0x80 >> ($bit) % 8)));
    }' unless defined(&BITCLR);
    eval 'sub NBITS2NCHARS {
        my($x) = @_;
	    eval q(((($x) + 7)/8));
    }' unless defined(&NBITS2NCHARS);
    eval 'sub NULLMODTYP () {(( &modtyp *)0);}' unless defined(&NULLMODTYP);
    eval 'sub LOTSOFBITS () {128;}' unless defined(&LOTSOFBITS);
}
1;
