require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_module_ACS_defined_)) {
    eval 'sub _module_ACS_defined_ () {1;}' unless defined(&_module_ACS_defined_);
    unless(defined(&PEPSY_VERSION)) {
	eval 'sub PEPSY_VERSION () {2;}' unless defined(&PEPSY_VERSION);
    }
    require 'isode/psap.ph';
    require 'isode/pepsy.ph';
    require 'isode/pepsy/UNIV-types.ph';
    require 'isode/pepsy/ACS_defs.ph';
    eval 'sub type_ACS_Application__context__name () { &OIDentifier;}' unless defined(&type_ACS_Application__context__name);
    eval 'sub free_ACS_Application__context__name () { &oid_free;}' unless defined(&free_ACS_Application__context__name);
    eval 'sub type_ACS_AP__title () { &PElement;}' unless defined(&type_ACS_AP__title);
    eval 'sub free_ACS_AP__title () { &pe_free;}' unless defined(&free_ACS_AP__title);
    eval 'sub type_ACS_AE__qualifier () { &PElement;}' unless defined(&type_ACS_AE__qualifier);
    eval 'sub free_ACS_AE__qualifier () { &pe_free;}' unless defined(&free_ACS_AE__qualifier);
    eval 'sub type_ACS_Implementation__data () { &type_UNIV_GraphicString;}' unless defined(&type_ACS_Implementation__data);
    eval 'sub free_ACS_Implementation__data () { &free_UNIV_GraphicString;}' unless defined(&free_ACS_Implementation__data);
    eval 'sub type_ACS_ACSE__apdu_aarq () {1;}' unless defined(&type_ACS_ACSE__apdu_aarq);
    eval 'sub type_ACS_ACSE__apdu_aare () {2;}' unless defined(&type_ACS_ACSE__apdu_aare);
    eval 'sub type_ACS_ACSE__apdu_rlrq () {3;}' unless defined(&type_ACS_ACSE__apdu_rlrq);
    eval 'sub type_ACS_ACSE__apdu_rlre () {4;}' unless defined(&type_ACS_ACSE__apdu_rlre);
    eval 'sub type_ACS_ACSE__apdu_abrt () {5;}' unless defined(&type_ACS_ACSE__apdu_abrt);
    eval 'sub free_ACS_ACSE__apdu {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZACSE_apduACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_ACSE__apdu);
    eval 'sub bits_ACS_protocol__version () {"\\020\\01version1";}' unless defined(&bits_ACS_protocol__version);
    eval 'sub bit_ACS_protocol__version_version1 () {0;}' unless defined(&bit_ACS_protocol__version_version1);
    eval 'sub free_ACS_AARQ__apdu {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZAARQ_apduACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_AARQ__apdu);
    eval 'sub bits_ACS_protocol__version () {"\\020\\01version1";}' unless defined(&bits_ACS_protocol__version);
    eval 'sub bit_ACS_protocol__version_version1 () {0;}' unless defined(&bit_ACS_protocol__version_version1);
    eval 'sub int_ACS_result_accepted () {0;}' unless defined(&int_ACS_result_accepted);
    eval 'sub int_ACS_result_rejected__permanent () {1;}' unless defined(&int_ACS_result_rejected__permanent);
    eval 'sub int_ACS_result_rejected__transient () {2;}' unless defined(&int_ACS_result_rejected__transient);
    eval 'sub free_ACS_AARE__apdu {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZAARE_apduACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_AARE__apdu);
    eval 'sub opt_ACS_RLRQ__apdu_reason () {(000000001);}' unless defined(&opt_ACS_RLRQ__apdu_reason);
    eval 'sub int_ACS_reason_normal () {0;}' unless defined(&int_ACS_reason_normal);
    eval 'sub int_ACS_reason_urgent () {1;}' unless defined(&int_ACS_reason_urgent);
    eval 'sub int_ACS_reason_user__defined () {30;}' unless defined(&int_ACS_reason_user__defined);
    eval 'sub free_ACS_RLRQ__apdu {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZRLRQ_apduACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_RLRQ__apdu);
    eval 'sub opt_ACS_RLRE__apdu_reason () {(000000001);}' unless defined(&opt_ACS_RLRE__apdu_reason);
    eval 'sub int_ACS_reason_normal () {0;}' unless defined(&int_ACS_reason_normal);
    eval 'sub int_ACS_reason_not__finished () {1;}' unless defined(&int_ACS_reason_not__finished);
    eval 'sub int_ACS_reason_user__defined () {30;}' unless defined(&int_ACS_reason_user__defined);
    eval 'sub free_ACS_RLRE__apdu {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZRLRE_apduACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_RLRE__apdu);
    eval 'sub int_ACS_abort__source_acse__service__user () {0;}' unless defined(&int_ACS_abort__source_acse__service__user);
    eval 'sub int_ACS_abort__source_acse__service__provider () {1;}' unless defined(&int_ACS_abort__source_acse__service__provider);
    eval 'sub free_ACS_ABRT__apdu {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZABRT_apduACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_ABRT__apdu);
    eval 'sub int_ACS_ABRT__source_acse__service__user () {0;}' unless defined(&int_ACS_ABRT__source_acse__service__user);
    eval 'sub int_ACS_ABRT__source_acse__service__provider () {1;}' unless defined(&int_ACS_ABRT__source_acse__service__provider);
    eval 'sub free_ACS_ABRT__source {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZABRT_sourceACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_ABRT__source);
    eval 'sub free_ACS_AE__title {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZAE_titleACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_AE__title);
    eval 'sub free_ACS_AE__invocation__id {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZAE_invocation_idACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_AE__invocation__id);
    eval 'sub free_ACS_AP__invocation__id {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZAP_invocation_idACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_AP__invocation__id);
    eval 'sub int_ACS_Associate__result_accepted () {0;}' unless defined(&int_ACS_Associate__result_accepted);
    eval 'sub int_ACS_Associate__result_rejected__permanent () {1;}' unless defined(&int_ACS_Associate__result_rejected__permanent);
    eval 'sub int_ACS_Associate__result_rejected__transient () {2;}' unless defined(&int_ACS_Associate__result_rejected__transient);
    eval 'sub free_ACS_Associate__result {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZAssociate_resultACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_Associate__result);
    eval 'sub type_ACS_Associate__source__diagnostic_acse__service__user () {1;}' unless defined(&type_ACS_Associate__source__diagnostic_acse__service__user);
    eval 'sub type_ACS_Associate__source__diagnostic_acse__service__provider () {2;}' unless defined(&type_ACS_Associate__source__diagnostic_acse__service__provider);
    eval 'sub int_ACS_acse__service__user_null () {0;}' unless defined(&int_ACS_acse__service__user_null);
    eval 'sub int_ACS_acse__service__user_no__reason__given () {1;}' unless defined(&int_ACS_acse__service__user_no__reason__given);
    eval 'sub int_ACS_acse__service__user_application__context__name__not__supported () {2;}' unless defined(&int_ACS_acse__service__user_application__context__name__not__supported);
    eval 'sub int_ACS_acse__service__user_calling__AP__title__not__recognized () {3;}' unless defined(&int_ACS_acse__service__user_calling__AP__title__not__recognized);
    eval 'sub int_ACS_acse__service__user_calling__AP__invocation__identifier__not__recognized () {4;}' unless defined(&int_ACS_acse__service__user_calling__AP__invocation__identifier__not__recognized);
    eval 'sub int_ACS_acse__service__user_calling__AE__qualifier__not__recognized () {5;}' unless defined(&int_ACS_acse__service__user_calling__AE__qualifier__not__recognized);
    eval 'sub int_ACS_acse__service__user_calling__AE__invocation__id__not__recognized () {6;}' unless defined(&int_ACS_acse__service__user_calling__AE__invocation__id__not__recognized);
    eval 'sub int_ACS_acse__service__user_called__AP__title__not__recognized () {7;}' unless defined(&int_ACS_acse__service__user_called__AP__title__not__recognized);
    eval 'sub int_ACS_acse__service__user_called__AP__invocation__identifier__not__recognized () {8;}' unless defined(&int_ACS_acse__service__user_called__AP__invocation__identifier__not__recognized);
    eval 'sub int_ACS_acse__service__user_called__AE__qualifier__not__recognized () {9;}' unless defined(&int_ACS_acse__service__user_called__AE__qualifier__not__recognized);
    eval 'sub int_ACS_acse__service__user_called__AE__invocation__id__not__recognized () {10;}' unless defined(&int_ACS_acse__service__user_called__AE__invocation__id__not__recognized);
    eval 'sub int_ACS_acse__service__provider_null () {0;}' unless defined(&int_ACS_acse__service__provider_null);
    eval 'sub int_ACS_acse__service__provider_no__reason__given () {1;}' unless defined(&int_ACS_acse__service__provider_no__reason__given);
    eval 'sub int_ACS_acse__service__provider_no__common__acse__version () {2;}' unless defined(&int_ACS_acse__service__provider_no__common__acse__version);
    eval 'sub free_ACS_Associate__source__diagnostic {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZAssociate_source_diagnosticACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_Associate__source__diagnostic);
    eval 'sub free_ACS_Association__information {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZAssociation_informationACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_Association__information);
    eval 'sub int_ACS_Release__request__reason_normal () {0;}' unless defined(&int_ACS_Release__request__reason_normal);
    eval 'sub int_ACS_Release__request__reason_urgent () {1;}' unless defined(&int_ACS_Release__request__reason_urgent);
    eval 'sub int_ACS_Release__request__reason_user__defined () {30;}' unless defined(&int_ACS_Release__request__reason_user__defined);
    eval 'sub free_ACS_Release__request__reason {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZRelease_request_reasonACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_Release__request__reason);
    eval 'sub int_ACS_Release__response__reason_normal () {0;}' unless defined(&int_ACS_Release__response__reason_normal);
    eval 'sub int_ACS_Release__response__reason_not__finished () {1;}' unless defined(&int_ACS_Release__response__reason_not__finished);
    eval 'sub int_ACS_Release__response__reason_user__defined () {30;}' unless defined(&int_ACS_Release__response__reason_user__defined);
    eval 'sub free_ACS_Release__response__reason {
        my($parm) = @_;
	    eval q(( &void)  &fre_obj( $parm,  ($_ZACS_mod->{md_dtab[&_ZRelease_response_reasonACS]}), & &_ZACS_mod, 1));
    }' unless defined(&free_ACS_Release__response__reason);
}
1;
