require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ACS_defs_)) {
    eval 'sub _ACS_defs_ () {1;}' unless defined(&_ACS_defs_);
    require 'isode/pepsy/ACS_pre_defs.ph';
    unless(defined(&lint)) {
	eval 'sub encode_ACS_ACSE__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZACSE_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_ACSE__apdu);
	eval 'sub decode_ACS_ACSE__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZACSE_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_ACSE__apdu);
	eval 'sub print_ACS_ACSE__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZACSE_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_ACSE__apdu);
	eval 'sub print_ACS_ACSE__apdu_P () { &_ZACSE_apduACS, & &_ZACS_mod;}' unless defined(&print_ACS_ACSE__apdu_P);
	eval 'sub encode_ACS_AARQ__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAARQ_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_AARQ__apdu);
	eval 'sub decode_ACS_AARQ__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAARQ_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_AARQ__apdu);
	eval 'sub print_ACS_AARQ__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAARQ_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_AARQ__apdu);
	eval 'sub print_ACS_AARQ__apdu_P () { &_ZAARQ_apduACS, & &_ZACS_mod;}' unless defined(&print_ACS_AARQ__apdu_P);
	eval 'sub encode_ACS_AARE__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAARE_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_AARE__apdu);
	eval 'sub decode_ACS_AARE__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAARE_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_AARE__apdu);
	eval 'sub print_ACS_AARE__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAARE_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_AARE__apdu);
	eval 'sub print_ACS_AARE__apdu_P () { &_ZAARE_apduACS, & &_ZACS_mod;}' unless defined(&print_ACS_AARE__apdu_P);
	eval 'sub encode_ACS_RLRQ__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZRLRQ_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_RLRQ__apdu);
	eval 'sub decode_ACS_RLRQ__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZRLRQ_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_RLRQ__apdu);
	eval 'sub print_ACS_RLRQ__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZRLRQ_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_RLRQ__apdu);
	eval 'sub print_ACS_RLRQ__apdu_P () { &_ZRLRQ_apduACS, & &_ZACS_mod;}' unless defined(&print_ACS_RLRQ__apdu_P);
	eval 'sub encode_ACS_RLRE__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZRLRE_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_RLRE__apdu);
	eval 'sub decode_ACS_RLRE__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZRLRE_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_RLRE__apdu);
	eval 'sub print_ACS_RLRE__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZRLRE_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_RLRE__apdu);
	eval 'sub print_ACS_RLRE__apdu_P () { &_ZRLRE_apduACS, & &_ZACS_mod;}' unless defined(&print_ACS_RLRE__apdu_P);
	eval 'sub encode_ACS_ABRT__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZABRT_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_ABRT__apdu);
	eval 'sub decode_ACS_ABRT__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZABRT_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_ABRT__apdu);
	eval 'sub print_ACS_ABRT__apdu {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZABRT_apduACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_ABRT__apdu);
	eval 'sub print_ACS_ABRT__apdu_P () { &_ZABRT_apduACS, & &_ZACS_mod;}' unless defined(&print_ACS_ABRT__apdu_P);
	eval 'sub encode_ACS_ABRT__source {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZABRT_sourceACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_ABRT__source);
	eval 'sub decode_ACS_ABRT__source {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZABRT_sourceACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_ABRT__source);
	eval 'sub print_ACS_ABRT__source {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZABRT_sourceACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_ABRT__source);
	eval 'sub print_ACS_ABRT__source_P () { &_ZABRT_sourceACS, & &_ZACS_mod;}' unless defined(&print_ACS_ABRT__source_P);
	eval 'sub encode_ACS_Application__context__name {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZApplication_context_nameACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_Application__context__name);
	eval 'sub decode_ACS_Application__context__name {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZApplication_context_nameACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_Application__context__name);
	eval 'sub print_ACS_Application__context__name {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZApplication_context_nameACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_Application__context__name);
	eval 'sub print_ACS_Application__context__name_P () { &_ZApplication_context_nameACS, & &_ZACS_mod;}' unless defined(&print_ACS_Application__context__name_P);
	eval 'sub encode_ACS_AP__title {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAP_titleACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_AP__title);
	eval 'sub decode_ACS_AP__title {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAP_titleACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_AP__title);
	eval 'sub print_ACS_AP__title {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAP_titleACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_AP__title);
	eval 'sub print_ACS_AP__title_P () { &_ZAP_titleACS, & &_ZACS_mod;}' unless defined(&print_ACS_AP__title_P);
	eval 'sub encode_ACS_AE__qualifier {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAE_qualifierACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_AE__qualifier);
	eval 'sub decode_ACS_AE__qualifier {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAE_qualifierACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_AE__qualifier);
	eval 'sub print_ACS_AE__qualifier {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAE_qualifierACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_AE__qualifier);
	eval 'sub print_ACS_AE__qualifier_P () { &_ZAE_qualifierACS, & &_ZACS_mod;}' unless defined(&print_ACS_AE__qualifier_P);
	eval 'sub encode_ACS_AE__title {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAE_titleACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_AE__title);
	eval 'sub decode_ACS_AE__title {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAE_titleACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_AE__title);
	eval 'sub print_ACS_AE__title {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAE_titleACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_AE__title);
	eval 'sub print_ACS_AE__title_P () { &_ZAE_titleACS, & &_ZACS_mod;}' unless defined(&print_ACS_AE__title_P);
	eval 'sub encode_ACS_AE__invocation__id {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAE_invocation_idACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_AE__invocation__id);
	eval 'sub decode_ACS_AE__invocation__id {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAE_invocation_idACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_AE__invocation__id);
	eval 'sub print_ACS_AE__invocation__id {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAE_invocation_idACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_AE__invocation__id);
	eval 'sub print_ACS_AE__invocation__id_P () { &_ZAE_invocation_idACS, & &_ZACS_mod;}' unless defined(&print_ACS_AE__invocation__id_P);
	eval 'sub encode_ACS_AP__invocation__id {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAP_invocation_idACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_AP__invocation__id);
	eval 'sub decode_ACS_AP__invocation__id {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAP_invocation_idACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_AP__invocation__id);
	eval 'sub print_ACS_AP__invocation__id {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAP_invocation_idACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_AP__invocation__id);
	eval 'sub print_ACS_AP__invocation__id_P () { &_ZAP_invocation_idACS, & &_ZACS_mod;}' unless defined(&print_ACS_AP__invocation__id_P);
	eval 'sub encode_ACS_Associate__result {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAssociate_resultACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_Associate__result);
	eval 'sub decode_ACS_Associate__result {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAssociate_resultACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_Associate__result);
	eval 'sub print_ACS_Associate__result {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAssociate_resultACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_Associate__result);
	eval 'sub print_ACS_Associate__result_P () { &_ZAssociate_resultACS, & &_ZACS_mod;}' unless defined(&print_ACS_Associate__result_P);
	eval 'sub encode_ACS_Associate__source__diagnostic {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAssociate_source_diagnosticACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_Associate__source__diagnostic);
	eval 'sub decode_ACS_Associate__source__diagnostic {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAssociate_source_diagnosticACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_Associate__source__diagnostic);
	eval 'sub print_ACS_Associate__source__diagnostic {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAssociate_source_diagnosticACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_Associate__source__diagnostic);
	eval 'sub print_ACS_Associate__source__diagnostic_P () { &_ZAssociate_source_diagnosticACS, & &_ZACS_mod;}' unless defined(&print_ACS_Associate__source__diagnostic_P);
	eval 'sub encode_ACS_Association__information {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZAssociation_informationACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_Association__information);
	eval 'sub decode_ACS_Association__information {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZAssociation_informationACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_Association__information);
	eval 'sub print_ACS_Association__information {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZAssociation_informationACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_Association__information);
	eval 'sub print_ACS_Association__information_P () { &_ZAssociation_informationACS, & &_ZACS_mod;}' unless defined(&print_ACS_Association__information_P);
	eval 'sub encode_ACS_Implementation__data {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZImplementation_dataACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_Implementation__data);
	eval 'sub decode_ACS_Implementation__data {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZImplementation_dataACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_Implementation__data);
	eval 'sub print_ACS_Implementation__data {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZImplementation_dataACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_Implementation__data);
	eval 'sub print_ACS_Implementation__data_P () { &_ZImplementation_dataACS, & &_ZACS_mod;}' unless defined(&print_ACS_Implementation__data_P);
	eval 'sub encode_ACS_Release__request__reason {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZRelease_request_reasonACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_Release__request__reason);
	eval 'sub decode_ACS_Release__request__reason {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZRelease_request_reasonACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_Release__request__reason);
	eval 'sub print_ACS_Release__request__reason {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZRelease_request_reasonACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_Release__request__reason);
	eval 'sub print_ACS_Release__request__reason_P () { &_ZRelease_request_reasonACS, & &_ZACS_mod;}' unless defined(&print_ACS_Release__request__reason_P);
	eval 'sub encode_ACS_Release__response__reason {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZRelease_response_reasonACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_ACS_Release__response__reason);
	eval 'sub decode_ACS_Release__response__reason {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZRelease_response_reasonACS, & &_ZACS_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_ACS_Release__response__reason);
	eval 'sub print_ACS_Release__response__reason {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZRelease_response_reasonACS, & &_ZACS_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_ACS_Release__response__reason);
	eval 'sub print_ACS_Release__response__reason_P () { &_ZRelease_response_reasonACS, & &_ZACS_mod;}' unless defined(&print_ACS_Release__response__reason_P);
    }
}
1;
