require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SNMP_defs_)) {
    eval 'sub _SNMP_defs_ () {1;}' unless defined(&_SNMP_defs_);
    require 'isode/pepsy/SNMP_pre_defs.ph';
    unless(defined(&lint)) {
	eval 'sub encode_SNMP_Message {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZMessageSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_Message);
	eval 'sub decode_SNMP_Message {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZMessageSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_Message);
	eval 'sub print_SNMP_Message {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZMessageSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_Message);
	eval 'sub print_SNMP_Message_P () { &_ZMessageSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_Message_P);
	eval 'sub encode_SNMP_PDUs {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZPDUsSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_PDUs);
	eval 'sub decode_SNMP_PDUs {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZPDUsSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_PDUs);
	eval 'sub print_SNMP_PDUs {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZPDUsSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_PDUs);
	eval 'sub print_SNMP_PDUs_P () { &_ZPDUsSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_PDUs_P);
	eval 'sub encode_SNMP_GetRequest__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZGetRequest_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_GetRequest__PDU);
	eval 'sub decode_SNMP_GetRequest__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZGetRequest_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_GetRequest__PDU);
	eval 'sub print_SNMP_GetRequest__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZGetRequest_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_GetRequest__PDU);
	eval 'sub print_SNMP_GetRequest__PDU_P () { &_ZGetRequest_PDUSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_GetRequest__PDU_P);
	eval 'sub encode_SNMP_GetNextRequest__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZGetNextRequest_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_GetNextRequest__PDU);
	eval 'sub decode_SNMP_GetNextRequest__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZGetNextRequest_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_GetNextRequest__PDU);
	eval 'sub print_SNMP_GetNextRequest__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZGetNextRequest_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_GetNextRequest__PDU);
	eval 'sub print_SNMP_GetNextRequest__PDU_P () { &_ZGetNextRequest_PDUSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_GetNextRequest__PDU_P);
	eval 'sub encode_SNMP_GetResponse__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZGetResponse_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_GetResponse__PDU);
	eval 'sub decode_SNMP_GetResponse__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZGetResponse_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_GetResponse__PDU);
	eval 'sub print_SNMP_GetResponse__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZGetResponse_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_GetResponse__PDU);
	eval 'sub print_SNMP_GetResponse__PDU_P () { &_ZGetResponse_PDUSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_GetResponse__PDU_P);
	eval 'sub encode_SNMP_SetRequest__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZSetRequest_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_SetRequest__PDU);
	eval 'sub decode_SNMP_SetRequest__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZSetRequest_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_SetRequest__PDU);
	eval 'sub print_SNMP_SetRequest__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZSetRequest_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_SetRequest__PDU);
	eval 'sub print_SNMP_SetRequest__PDU_P () { &_ZSetRequest_PDUSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_SetRequest__PDU_P);
	eval 'sub encode_SNMP_PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZPDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_PDU);
	eval 'sub decode_SNMP_PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZPDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_PDU);
	eval 'sub print_SNMP_PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZPDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_PDU);
	eval 'sub print_SNMP_PDU_P () { &_ZPDUSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_PDU_P);
	eval 'sub encode_SNMP_Trap__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZTrap_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_Trap__PDU);
	eval 'sub decode_SNMP_Trap__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZTrap_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_Trap__PDU);
	eval 'sub print_SNMP_Trap__PDU {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZTrap_PDUSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_Trap__PDU);
	eval 'sub print_SNMP_Trap__PDU_P () { &_ZTrap_PDUSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_Trap__PDU_P);
	eval 'sub encode_SNMP_VarBind {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZVarBindSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_VarBind);
	eval 'sub decode_SNMP_VarBind {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZVarBindSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_VarBind);
	eval 'sub print_SNMP_VarBind {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZVarBindSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_VarBind);
	eval 'sub print_SNMP_VarBind_P () { &_ZVarBindSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_VarBind_P);
	eval 'sub encode_SNMP_VarBindList {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &enc_f( &_ZVarBindListSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&encode_SNMP_VarBindList);
	eval 'sub decode_SNMP_VarBindList {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &dec_f( &_ZVarBindListSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer, $parm));
	}' unless defined(&decode_SNMP_VarBindList);
	eval 'sub print_SNMP_VarBindList {
	    my($pe, $top, $len, $buffer, $parm) = @_;
    	    eval q( &prnt_f( &_ZVarBindListSNMP, & &_ZSNMP_mod, $pe, $top, $len, $buffer));
	}' unless defined(&print_SNMP_VarBindList);
	eval 'sub print_SNMP_VarBindList_P () { &_ZVarBindListSNMP, & &_ZSNMP_mod;}' unless defined(&print_SNMP_VarBindList_P);
    }
}
1;
