require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PPKT_)) {
    eval 'sub _PPKT_ () {1;}' unless defined(&_PPKT_);
    unless(defined(&_PSAP2_)) {
	require 'isode/psap2.ph';
    }
    require 'isode/ssap.ph';
    eval 'sub psapPsig {
        my($pb, $sd) = @_;
	    eval q({  &if (($pb =  &findpblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &psaplose ( &pi,  &PC_PARAMETER,  &NULLCP, \\"invalid presentation descriptor\\"); }  &if (!($pb ->  &pb_flags &  &PB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &psaplose ( &pi,  &PC_OPERATION,  &NULLCP, \\"presentation descriptor not connected\\"); }  &if ($pb ->  &pb_flags &  &PB_FINN) { ( &void)  &sigiomask ( &smask);  &return  &psaplose ( &pi,  &PC_OPERATION,  &NULLCP, \\"presentation descriptor finishing\\"); }  &if ($pb ->  &pb_flags &  &PB_RELEASE) { ( &void)  &sigiomask ( &smask);  &return  &psaplose ( &pi,  &PC_OPERATION,  &NULLCP, \\"release in progress\\"); } });
    }' unless defined(&psapPsig);
    eval 'sub psapFsig {
        my($pb, $sd) = @_;
	    eval q({  &if (($pb =  &findpblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &psaplose ( &pi,  &PC_PARAMETER,  &NULLCP, \\"invalid presentation descriptor\\"); }  &if (!($pb ->  &pb_flags &  &PB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &psaplose ( &pi,  &PC_OPERATION,  &NULLCP, \\"presentation descriptor not connected\\"); }  &if (!($pb ->  &pb_flags &  &PB_FINN)) { ( &void)  &sigiomask ( &smask);  &return  &psaplose ( &pi,  &PC_OPERATION,  &NULLCP, \\"presentation descriptor not finishing\\"); }  &if ($pb ->  &pb_flags &  &PB_RELEASE) { ( &void)  &sigiomask ( &smask);  &return  &psaplose ( &pi,  &PC_OPERATION,  &NULLCP, \\"release in progress\\"); } });
    }' unless defined(&psapFsig);
    eval 'sub toomuchP {
        my($b,$n,$m,$p) = @_;
	    eval q({  &if ($b ==  &NULL) $n = 0;  &else  &if ($n > $m)  &return  &psaplose ( &pi,  &PC_PARAMETER,  &NULLCP, \\"too many %s user data elements\\", $p); });
    }' unless defined(&toomuchP);
    eval 'sub missingP {
        my($p) = @_;
	    eval q({  &if ($p ==  &NULL)  &return  &psaplose ( &pi,  &PC_PARAMETER,  &NULLCP, \\"mandatory parameter \\\\\\"%s\\\\\\" missing\\", \\"p\\"); });
    }' unless defined(&missingP);
    unless(defined(&lint)) {
	if(!defined( &_AIX)) {
	    eval 'sub copyPSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d  &_cc =  &min ( &i,  &sizeof $d -> $d  &_data)) > 0)  &bcopy ($base, $d -> $d  &_data, $d -> $d  &_cc); });
	    }' unless defined(&copyPSAPdata);
	} else {
	    eval 'sub copyPSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d &_cc =  &min ( &i,  &sizeof $d -> $d &_data)) > 0)  &bcopy ($base, $d -> $d &_data, $d -> $d &_cc); });
	    }' unless defined(&copyPSAPdata);
	}
    } else {
	eval 'sub copyPSAPdata {
	    my($base,$len,$d) = @_;
    	    eval q( &bcopy ($base, $d, $len));
	}' unless defined(&copyPSAPdata);
    }
    eval 'sub pylose {
        my($p) = @_;
	    eval q( &ppktlose ( &pb,  &pi,  &PC_UNRECOGNIZED, ($p),  &NULLCP, \\"%s\\",  &PY_pepy));
    }' unless defined(&pylose);
    eval 'sub DFLT_ASN () {"iso asn.1 abstract syntax";}' unless defined(&DFLT_ASN);
    eval 'sub DFLT_ATN () { &BER;}' unless defined(&DFLT_ATN);
    eval 'sub atn_is_ok {
        my($pb,$atn) = @_;
	    eval q( &atn_is_ber (($pb), ($atn)));
    }' unless defined(&atn_is_ok);
    eval 'sub atn_is_ber {
        my($pb,$atn) = @_;
	    eval q((! &oid_cmp ($pb ->  &pb_ber, $atn)));
    }' unless defined(&atn_is_ber);
    eval 'sub PB_NULL () {0x;}' unless defined(&PB_NULL);
    eval 'sub PB_CONN () {0x1;}' unless defined(&PB_CONN);
    eval 'sub PB_FINN () {0x2;}' unless defined(&PB_FINN);
    eval 'sub PB_ASYN () {0x4;}' unless defined(&PB_ASYN);
    eval 'sub PB_DFLT () {0x10;}' unless defined(&PB_DFLT);
    eval 'sub PB_RELEASE () {0x20;}' unless defined(&PB_RELEASE);
    unless(defined(&LPP)) {
    } else {
    }
    if(defined(&LPP)) {
    }
    if(defined(&LPP)) {
    }
    eval 'sub NULLPB () {( 0);}' unless defined(&NULLPB);
    unless(defined(&LPP)) {
	eval 'sub PC_PROV_BASE () { &PC_NOTSPECIFIED;}' unless defined(&PC_PROV_BASE);
	eval 'sub PC_ABORT_BASE () {( &PC_UNRECOGNIZED -  &int_PS_Abort__reason_unrecognized__ppdu);}' unless defined(&PC_ABORT_BASE);
	eval 'sub PC_REASON_BASE () {( &PC_ABSTRACT -  &int_PS_provider__reason_abstract__syntax__not__supported);}' unless defined(&PC_REASON_BASE);
    }
    eval 'sub REASON_BASE () { &PC_NOTSPECIFIED;}' unless defined(&REASON_BASE);
    unless(defined(&LPP)) {
	eval 'sub PPDU_NONE () {(-1);}' unless defined(&PPDU_NONE);
	eval 'sub PPDU_CP () {0;}' unless defined(&PPDU_CP);
	eval 'sub PPDU_CPA () {1;}' unless defined(&PPDU_CPA);
	eval 'sub PPDU_CPR () {2;}' unless defined(&PPDU_CPR);
	eval 'sub PPDU_ARU () {3;}' unless defined(&PPDU_ARU);
	eval 'sub PPDU_ARP () {4;}' unless defined(&PPDU_ARP);
	eval 'sub PPDU_TD () {7;}' unless defined(&PPDU_TD);
	eval 'sub PPDU_RS () {12;}' unless defined(&PPDU_RS);
	eval 'sub PPDU_RSA () {13;}' unless defined(&PPDU_RSA);
    } else {
	eval 'sub PR_KERNEL () {0x;}' unless defined(&PR_KERNEL);
	eval 'sub NPCTX_PS () {2;}' unless defined(&NPCTX_PS);
	eval 'sub NPDATA_PS () {1;}' unless defined(&NPDATA_PS);
	eval 'sub PCI_ROSE () {1;}' unless defined(&PCI_ROSE);
	eval 'sub PCI_ACSE () {3;}' unless defined(&PCI_ACSE);
	eval 'sub PT_TCP () {ord(\'T\');}' unless defined(&PT_TCP);
	eval 'sub PT_UDP () {ord(\'U\');}' unless defined(&PT_UDP);
	eval 'sub NULLRF () {( 0);}' unless defined(&NULLRF);
	eval 'sub pslose {
	    my($pi,$reason) = @_;
    	    eval q(($reason !=  &PS_ERR_NONE  && $reason !=  &PS_ERR_IO ?  &psaplose (($pi),  &PC_CONGEST,  &NULLCP, \\"%s\\",  &ps_error ($reason)) :  &psaplose (($pi),  &PC_SESSION,  &NULLCP,  &NULLCP)));
	}' unless defined(&pslose);
    }
}
1;
