require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PSAP2_)) {
    eval 'sub _PSAP2_ () {1;}' unless defined(&_PSAP2_);
    unless(defined(&_PSAP_)) {
	require 'isode/psap.ph';
    }
    unless(defined(&_SSAP_)) {
	require 'isode/ssap.ph';
    }
    unless(defined(&_ISOADDRS_)) {
	require 'isode/isoaddrs.ph';
    }
    eval 'sub NPDATA () {125;}' unless defined(&NPDATA);
    eval 'sub NPCTX () {10;}' unless defined(&NPCTX);
    eval 'sub NULLPC () {( 0);}' unless defined(&NULLPC);
    eval 'sub BER () {"basic encoding of a single asn.1 type";}' unless defined(&BER);
    eval 'sub PSFREE {
        my($ps) = @_;
	    eval q({  &register \'int\'  &PSI;  &for ( &PSI = ($ps) ->  ($ps_ctxlist->{pc_nctx}) - 1;  &PSI >= 0;  &PSI--) {  &oid_free (($ps) ->  ($ps_ctxlist->{pc_ctx[&PSI]}->{pc_asn}));  &oid_free (($ps) ->  ($ps_ctxlist->{pc_ctx[&PSI]}->{pc_atn})); ($ps) ->  ($ps_ctxlist->{pc_ctx[&PSI]}->{pc_asn}) = ($ps) ->  ($ps_ctxlist->{pc_ctx[&PSI]}->{pc_atn}) =  &NULLOID; } ($ps) ->  ($ps_ctxlist->{pc_nctx}) = 0;  &if (($ps) ->  &ps_defctx)  &oid_free (($ps) ->  &ps_defctx), ($ps) ->  &ps_defctx =  &NULLOID;  &for ( &PSI = ($ps) ->  &ps_ninfo - 1;  &PSI >= 0;  &PSI--)  &if (($ps) ->  $ps_info[ &PSI])  &pe_free (($ps) ->  $ps_info[ &PSI]), ($ps) ->  $ps_info[ &PSI] =  &NULLPE; ($ps) ->  &ps_ninfo = 0; });
    }' unless defined(&PSFREE);
    eval 'sub PC_ACCEPT () {(-1);}' unless defined(&PC_ACCEPT);
    eval 'sub PC_REJECTED () {0;}' unless defined(&PC_REJECTED);
    eval 'sub PC_NOTSPECIFIED () {1;}' unless defined(&PC_NOTSPECIFIED);
    eval 'sub PC_CONGEST () {2;}' unless defined(&PC_CONGEST);
    eval 'sub PC_EXCEEDED () {3;}' unless defined(&PC_EXCEEDED);
    eval 'sub PC_ADDRESS () {4;}' unless defined(&PC_ADDRESS);
    eval 'sub PC_VERSION () {5;}' unless defined(&PC_VERSION);
    eval 'sub PC_DEFAULT () {6;}' unless defined(&PC_DEFAULT);
    eval 'sub PC_READABLE () {7;}' unless defined(&PC_READABLE);
    eval 'sub PC_AVAILABLE () {8;}' unless defined(&PC_AVAILABLE);
    eval 'sub PC_UNRECOGNIZED () {9;}' unless defined(&PC_UNRECOGNIZED);
    eval 'sub PC_UNEXPECTED () {10;}' unless defined(&PC_UNEXPECTED);
    eval 'sub PC_SSPRIMITIVE () {11;}' unless defined(&PC_SSPRIMITIVE);
    eval 'sub PC_PPPARAM1 () {12;}' unless defined(&PC_PPPARAM1);
    eval 'sub PC_PPPARAM2 () {13;}' unless defined(&PC_PPPARAM2);
    eval 'sub PC_INVALID () {14;}' unless defined(&PC_INVALID);
    eval 'sub PC_ABSTRACT () {15;}' unless defined(&PC_ABSTRACT);
    eval 'sub PC_TRANSFER () {16;}' unless defined(&PC_TRANSFER);
    eval 'sub PC_DCSLIMIT () {17;}' unless defined(&PC_DCSLIMIT);
    eval 'sub PC_REFUSED () {18;}' unless defined(&PC_REFUSED);
    eval 'sub PC_SESSION () {19;}' unless defined(&PC_SESSION);
    eval 'sub PC_PROTOCOL () {20;}' unless defined(&PC_PROTOCOL);
    eval 'sub PC_ABORTED () {21;}' unless defined(&PC_ABORTED);
    eval 'sub PC_PARAMETER () {22;}' unless defined(&PC_PARAMETER);
    eval 'sub PC_OPERATION () {23;}' unless defined(&PC_OPERATION);
    eval 'sub PC_TIMER () {24;}' unless defined(&PC_TIMER);
    eval 'sub PC_WAITING () {25;}' unless defined(&PC_WAITING);
    eval 'sub PC_FATAL {
        my($r) = @_;
	    eval q((($r) <  &PC_PARAMETER));
    }' unless defined(&PC_FATAL);
    eval 'sub PC_OFFICIAL {
        my($r) = @_;
	    eval q((($r) <  &PC_REFUSED));
    }' unless defined(&PC_OFFICIAL);
    eval 'sub PCFREE {
        my($pc) = @_;
	    eval q({  &register \'int\'  &PCI;  &for ( &PCI = ($pc) ->  ($pc_ctxlist->{pc_nctx}) - 1;  &PCI >= 0;  &PCI--) {  &oid_free (($pc) ->  ($pc_ctxlist->{pc_ctx[&PCI]}->{pc_asn}));  &oid_free (($pc) ->  ($pc_ctxlist->{pc_ctx[&PCI]}->{pc_atn})); ($pc) ->  ($pc_ctxlist->{pc_ctx[&PCI]}->{pc_asn}) = ($pc) ->  ($pc_ctxlist->{pc_ctx[&PCI]}->{pc_atn}) =  &NULLOID; } ($pc) ->  ($pc_ctxlist->{pc_nctx}) = 0;  &for ( &PCI = ($pc) ->  &pc_ninfo - 1;  &PCI >= 0;  &PCI--)  &if (($pc) ->  $pc_info[ &PCI])  &pe_free (($pc) ->  $pc_info[ &PCI]), ($pc) ->  $pc_info[ &PCI] =  &NULLPE; ($pc) ->  &pc_ninfo = 0; });
    }' unless defined(&PCFREE);
    eval 'sub PR_MANAGEMENT () {0x1;}' unless defined(&PR_MANAGEMENT);
    eval 'sub PR_RESTORATION () {0x2;}' unless defined(&PR_RESTORATION);
    eval 'sub PR_MYREQUIRE () {0x;}' unless defined(&PR_MYREQUIRE);
    eval 'sub PXFREE {
        my($px) = @_;
	    eval q({  &register \'int\'  &PXI;  &for ( &PXI = ($px) ->  &px_ninfo - 1;  &PXI >= 0;  &PXI--)  &if (($px) ->  $px_info[ &PXI])  &pe_free (($px) ->  $px_info[ &PXI]), ($px) ->  $px_info[ &PXI] =  &NULLPE; ($px) ->  &px_ninfo = 0; });
    }' unless defined(&PXFREE);
    eval 'sub PTFREE {
        my($pt) = @_;
	    eval q({  &register \'int\'  &PTI;  &for ( &PTI = ($pt) ->  &pt_ninfo - 1;  &PTI >= 0;  &PTI--)  &if (($pt) ->  $pt_info[ &PTI])  &pe_free (($pt) ->  $pt_info[ &PTI]), ($pt) ->  $pt_info[ &PTI] =  &NULLPE; ($pt) ->  &pt_ninfo = 0; });
    }' unless defined(&PTFREE);
    eval 'sub PNFREE {
        my($pn) = @_;
	    eval q({  &register \'int\'  &PNI;  &for ( &PNI = ($pn) ->  &pn_ninfo - 1;  &PNI >= 0;  &PNI--)  &if (($pn) ->  $pn_info[ &PNI])  &pe_free (($pn) ->  $pn_info[ &PNI]), ($pn) ->  $pn_info[ &PNI] =  &NULLPE; ($pn) ->  &pn_ninfo = 0; });
    }' unless defined(&PNFREE);
    eval 'sub PVFREE {
        my($pv) = @_;
	    eval q({  &register \'int\'  &PVI;  &for ( &PVI = ($pv) ->  &pv_ninfo - 1;  &PVI >= 0;  &PVI--)  &if (($pv) ->  $pv_info[ &PVI])  &pe_free (($pv) ->  $pv_info[ &PVI]), ($pv) ->  $pv_info[ &PVI] =  &NULLPE; ($pv) ->  &pv_ninfo = 0; });
    }' unless defined(&PVFREE);
    eval 'sub PPFREE {
        my($pp) = @_;
	    eval q({  &register \'int\'  &PPI;  &for ( &PPI = ($pp) ->  &pp_ninfo - 1;  &PPI >= 0;  &PPI--)  &if (($pp) ->  $pp_info[ &PPI])  &pe_free (($pp) ->  $pp_info[ &PPI]), ($pp) ->  $pp_info[ &PPI] =  &NULLPE; ($pp) ->  &pp_ninfo = 0; });
    }' unless defined(&PPFREE);
    eval 'sub PFFREE {
        my($pf) = @_;
	    eval q({  &register \'int\'  &PFI;  &for ( &PFI = ($pf) ->  &pf_ninfo - 1;  &PFI >= 0;  &PFI--)  &if (($pf) ->  $pf_info[ &PFI])  &pe_free (($pf) ->  $pf_info[ &PFI]), ($pf) ->  $pf_info[ &PFI] =  &NULLPE; ($pf) ->  &pf_ninfo = 0; });
    }' unless defined(&PFFREE);
    eval 'sub PRFREE {
        my($pr) = @_;
	    eval q({  &register \'int\'  &PRI;  &for ( &PRI = ($pr) ->  &pr_ninfo - 1;  &PRI >= 0;  &PRI--)  &if (($pr) ->  $pr_info[ &PRI])  &pe_free (($pr) ->  $pr_info[ &PRI]), ($pr) ->  $pr_info[ &PRI] =  &NULLPE; ($pr) ->  &pr_ninfo = 0; });
    }' unless defined(&PRFREE);
    eval 'sub PA_SIZE () {512;}' unless defined(&PA_SIZE);
    eval 'sub PAFREE {
        my($pa) = @_;
	    eval q({  &register \'int\'  &PAI;  &for ( &PAI = ($pa) ->  &pa_ninfo - 1;  &PAI >= 0;  &PAI--)  &if (($pa) ->  $pa_info[ &PAI])  &pe_free (($pa) ->  $pa_info[ &PAI]), ($pa) ->  $pa_info[ &PAI] =  &NULLPE; ($pa) ->  &pa_ninfo = 0; });
    }' unless defined(&PAFREE);
    eval 'sub PI_DATA () {0x;}' unless defined(&PI_DATA);
    eval 'sub PI_TOKEN () {0x1;}' unless defined(&PI_TOKEN);
    eval 'sub PI_SYNC () {0x2;}' unless defined(&PI_SYNC);
    eval 'sub PI_ACTIVITY () {0x3;}' unless defined(&PI_ACTIVITY);
    eval 'sub PI_REPORT () {0x4;}' unless defined(&PI_REPORT);
    eval 'sub PI_FINISH () {0x5;}' unless defined(&PI_FINISH);
    eval 'sub PI_ABORT () {0x6;}' unless defined(&PI_ABORT);
    eval 'sub pi_data () { ($pi_un->{pi_un_data});}' unless defined(&pi_data);
    eval 'sub pi_token () { ($pi_un->{pi_un_token});}' unless defined(&pi_token);
    eval 'sub pi_sync () { ($pi_un->{pi_un_sync});}' unless defined(&pi_sync);
    eval 'sub pi_activity () { ($pi_un->{pi_un_activity});}' unless defined(&pi_activity);
    eval 'sub pi_report () { ($pi_un->{pi_un_report});}' unless defined(&pi_report);
    eval 'sub pi_finish () { ($pi_un->{pi_un_finish});}' unless defined(&pi_finish);
    eval 'sub pi_abort () { ($pi_un->{pi_un_abort});}' unless defined(&pi_abort);
    eval 'sub PConnRequest {
        my($a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$a10,$a11,$a12,$a13,$a14) = @_;
	    eval q( &PAsynConnRequest ($a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$a10,$a11,$a12,$a13,$a14,0));
    }' unless defined(&PConnRequest);
    eval 'sub PPDU_TTD () {8;}' unless defined(&PPDU_TTD);
    eval 'sub PPDU_TE () {9;}' unless defined(&PPDU_TE);
    eval 'sub PPDU_TC () {10;}' unless defined(&PPDU_TC);
    eval 'sub PPDU_TCC () {11;}' unless defined(&PPDU_TCC);
    eval 'sub PExpdRequest {
        my($s,$d,$n,$p) = @_;
	    eval q( &PDataRequestAux (($s), ($d), ($n), ($p), \\"expedited\\",  &SExpdRequest, \\"SExpdRequest\\", \\"P-EXPEDITED-DATA user-data\\",  &PPDU_TE));
    }' unless defined(&PExpdRequest);
    eval 'sub PTypedRequest {
        my($s,$d,$n,$p) = @_;
	    eval q( &PDataRequestAux (($s), ($d), ($n), ($p), \\"typed\\",  &STypedRequest, \\"STypedRequest\\", \\"P-TYPED-DATA user-data\\",  &PPDU_TTD));
    }' unless defined(&PTypedRequest);
    eval 'sub PCapdRequest {
        my($s,$d,$n,$p) = @_;
	    eval q( &PDataRequestAux (($s), ($d), ($n), ($p), \\"capability\\",  &SCapdRequest, \\"SCapdRequest\\", \\"P-CAPABILITY-DATA user-data\\",  &PPDU_TC));
    }' unless defined(&PCapdRequest);
    eval 'sub PCapdResponse {
        my($s,$d,$n,$p) = @_;
	    eval q( &PDataRequestAux (($s), ($d), ($n), ($p), \\"capability\\",  &SCapdResponse, \\"SCapdResponse\\",\\"P-CAPABILITY-DATA user-data\\", &PPDU_TCC));
    }' unless defined(&PCapdResponse);
    eval 'sub PMajSyncRequest {
        my($s,$i,$d,$n,$p) = @_;
	    eval q( &PMajSyncRequestAux (($s), ($i), ($d), ($n), ($p), \\"majorsync\\",  &SMajSyncRequest, \\"SMajSyncRequest\\"));
    }' unless defined(&PMajSyncRequest);
    eval 'sub PActEndRequest {
        my($s,$i,$d,$n,$p) = @_;
	    eval q( &PMajSyncRequestAux (($s), ($i), ($d), ($n), ($p), \\"activity end\\",  &SActEndRequest, \\"SActEndRequest\\"));
    }' unless defined(&PActEndRequest);
    eval 'sub PMajSyncResponse {
        my($s,$d,$n,$p) = @_;
	    eval q( &PMajSyncResponseAux (($s), ($d), ($n), ($p), \\"majorsync\\",  &SMajSyncResponse, \\"SMajSyncResponse\\"));
    }' unless defined(&PMajSyncResponse);
    eval 'sub PActEndResponse {
        my($s,$d,$n,$p) = @_;
	    eval q( &PMajSyncResponseAux (($s), ($d), ($n), ($p), \\"activity end\\",  &SActEndResponse, \\"SActEndResponse\\"));
    }' unless defined(&PActEndResponse);
    eval 'sub PActIntrRequest {
        my($s,$r,$p) = @_;
	    eval q( &PActIntrRequestAux (($s), ($r), ($p),  &SActIntrRequest, \\"SActIntrRequest\\"));
    }' unless defined(&PActIntrRequest);
    eval 'sub PActDiscRequest {
        my($s,$r,$p) = @_;
	    eval q( &PActIntrRequestAux (($s), ($r), ($p),  &SActDiscRequest, \\"SActDiscRequest\\"));
    }' unless defined(&PActDiscRequest);
    eval 'sub PActIntrResponse {
        my($s,$p) = @_;
	    eval q( &PActIntrResponseAux (($s), ($p),  &SActIntrResponse, \\"SActIntrResponse\\"));
    }' unless defined(&PActIntrResponse);
    eval 'sub PActDiscResponse {
        my($s,$p) = @_;
	    eval q( &PActIntrResponseAux (($s), ($p),  &SActDiscResponse, \\"SActDiscResponse\\"));
    }' unless defined(&PActDiscResponse);
    eval 'sub PLocalHostName () { &getlocalhost;}' unless defined(&PLocalHostName);
}
1;
