require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RoSAP_)) {
    eval 'sub _RoSAP_ () {1;}' unless defined(&_RoSAP_);
    unless(defined(&_MANIFEST_)) {
	require 'isode/manifest.ph';
    }
    unless(defined(&_GENERAL_)) {
	require 'isode/general.ph';
    }
    unless(defined(&_AcSAP_)) {
	require 'isode/acsap.ph';
    }
    eval 'sub NULLRoA () {( 0);}' unless defined(&NULLRoA);
    eval 'sub ROS_MYREQUIRE () { &SR_DUPLEX;}' unless defined(&ROS_MYREQUIRE);
    eval 'sub ROSFREE {
        my($ros) = @_;
	    eval q({  &if (($ros) ->  &ros_data)  &pe_free (($ros) ->  &ros_data), ($ros) ->  &ros_data =  &NULLPE; });
    }' unless defined(&ROSFREE);
    eval 'sub ROS_ACCEPT () {(-1);}' unless defined(&ROS_ACCEPT);
    eval 'sub ROS_VALIDATE () {0;}' unless defined(&ROS_VALIDATE);
    eval 'sub ROS_BUSY () {1;}' unless defined(&ROS_BUSY);
    eval 'sub ROS_GP_UNRECOG () {2;}' unless defined(&ROS_GP_UNRECOG);
    eval 'sub ROS_GP_MISTYPED () {3;}' unless defined(&ROS_GP_MISTYPED);
    eval 'sub ROS_GP_STRUCT () {4;}' unless defined(&ROS_GP_STRUCT);
    eval 'sub ROS_IP_DUP () {5;}' unless defined(&ROS_IP_DUP);
    eval 'sub ROS_IP_UNRECOG () {6;}' unless defined(&ROS_IP_UNRECOG);
    eval 'sub ROS_IP_MISTYPED () {7;}' unless defined(&ROS_IP_MISTYPED);
    eval 'sub ROS_IP_LIMIT () {8;}' unless defined(&ROS_IP_LIMIT);
    eval 'sub ROS_IP_RELEASE () {9;}' unless defined(&ROS_IP_RELEASE);
    eval 'sub ROS_IP_UNLINKED () {10;}' unless defined(&ROS_IP_UNLINKED);
    eval 'sub ROS_IP_LINKED () {11;}' unless defined(&ROS_IP_LINKED);
    eval 'sub ROS_IP_CHILD () {12;}' unless defined(&ROS_IP_CHILD);
    eval 'sub ROS_RRP_UNRECOG () {13;}' unless defined(&ROS_RRP_UNRECOG);
    eval 'sub ROS_RRP_UNEXP () {14;}' unless defined(&ROS_RRP_UNEXP);
    eval 'sub ROS_RRP_MISTYPED () {15;}' unless defined(&ROS_RRP_MISTYPED);
    eval 'sub ROS_REP_UNRECOG () {16;}' unless defined(&ROS_REP_UNRECOG);
    eval 'sub ROS_REP_UNEXP () {17;}' unless defined(&ROS_REP_UNEXP);
    eval 'sub ROS_REP_RECERR () {18;}' unless defined(&ROS_REP_RECERR);
    eval 'sub ROS_REP_UNEXPERR () {19;}' unless defined(&ROS_REP_UNEXPERR);
    eval 'sub ROS_REP_MISTYPED () {20;}' unless defined(&ROS_REP_MISTYPED);
    eval 'sub ROS_ADDRESS () {21;}' unless defined(&ROS_ADDRESS);
    eval 'sub ROS_REFUSED () {22;}' unless defined(&ROS_REFUSED);
    eval 'sub ROS_SESSION () {23;}' unless defined(&ROS_SESSION);
    eval 'sub ROS_PROTOCOL () {24;}' unless defined(&ROS_PROTOCOL);
    eval 'sub ROS_CONGEST () {25;}' unless defined(&ROS_CONGEST);
    eval 'sub ROS_REMOTE () {26;}' unless defined(&ROS_REMOTE);
    eval 'sub ROS_DONE () {27;}' unless defined(&ROS_DONE);
    eval 'sub ROS_ABORTED () {28;}' unless defined(&ROS_ABORTED);
    eval 'sub ROS_RTS () {29;}' unless defined(&ROS_RTS);
    eval 'sub ROS_PRESENTATION () {30;}' unless defined(&ROS_PRESENTATION);
    eval 'sub ROS_ACS () {31;}' unless defined(&ROS_ACS);
    eval 'sub ROS_PARAMETER () {32;}' unless defined(&ROS_PARAMETER);
    eval 'sub ROS_OPERATION () {33;}' unless defined(&ROS_OPERATION);
    eval 'sub ROS_TIMER () {34;}' unless defined(&ROS_TIMER);
    eval 'sub ROS_WAITING () {35;}' unless defined(&ROS_WAITING);
    eval 'sub ROS_APDU () {36;}' unless defined(&ROS_APDU);
    eval 'sub ROS_INTERRUPTED () {37;}' unless defined(&ROS_INTERRUPTED);
    eval 'sub ROS_FATAL {
        my($r) = @_;
	    eval q((!( &ROS_OFFICIAL ($r))  && ($r) <  &ROS_PARAMETER));
    }' unless defined(&ROS_FATAL);
    eval 'sub ROS_OFFICIAL {
        my($r) = @_;
	    eval q((($r) <  &ROS_ADDRESS));
    }' unless defined(&ROS_OFFICIAL);
    eval 'sub ROCFREE {
        my($roc) = @_;
	    eval q({  &if (($roc) ->  &roc_data)  &pe_free (($roc) ->  &roc_data), ($roc) ->  &roc_data =  &NULLPE; });
    }' unless defined(&ROCFREE);
    eval 'sub ROS_SYNC () {0;}' unless defined(&ROS_SYNC);
    eval 'sub ROS_ASYNC () {1;}' unless defined(&ROS_ASYNC);
    eval 'sub ROS_NOPRIO () {0;}' unless defined(&ROS_NOPRIO);
    eval 'sub ROXFREE {
        my($rox) = @_;
	    eval q({  &if (($rox) ->  &rox_args)  &pe_free (($rox) ->  &rox_args), ($rox) ->  &rox_args =  &NULLPE; });
    }' unless defined(&ROXFREE);
    eval 'sub RORFREE {
        my($ror) = @_;
	    eval q({  &if (($ror) ->  &ror_result)  &pe_free (($ror) ->  &ror_result), ($ror) ->  &ror_result =  &NULLPE; });
    }' unless defined(&RORFREE);
    eval 'sub ROEFREE {
        my($roe) = @_;
	    eval q({  &if (($roe) ->  &roe_param)  &pe_free (($roe) ->  &roe_param), ($roe) ->  &roe_param =  &NULLPE; });
    }' unless defined(&ROEFREE);
    eval 'sub ROP_SIZE () {512;}' unless defined(&ROP_SIZE);
    eval 'sub ROPFREE {
        my($rop) = @_;
	    eval q({  &if (($rop) ->  &rop_apdu)  &pe_free (($rop) ->  &rop_apdu), ($rop) ->  &rop_apdu =  &NULLPE; });
    }' unless defined(&ROPFREE);
    eval 'sub ROI_INVOKE () {0x;}' unless defined(&ROI_INVOKE);
    eval 'sub ROI_RESULT () {0x1;}' unless defined(&ROI_RESULT);
    eval 'sub ROI_ERROR () {0x2;}' unless defined(&ROI_ERROR);
    eval 'sub ROI_UREJECT () {0x3;}' unless defined(&ROI_UREJECT);
    eval 'sub ROI_PREJECT () {0x4;}' unless defined(&ROI_PREJECT);
    eval 'sub ROI_END () {0x5;}' unless defined(&ROI_END);
    eval 'sub ROI_FINISH () {0x6;}' unless defined(&ROI_FINISH);
    eval 'sub roi_invoke () { ($roi_un->{roi_un_invoke});}' unless defined(&roi_invoke);
    eval 'sub roi_result () { ($roi_un->{roi_un_result});}' unless defined(&roi_result);
    eval 'sub roi_error () { ($roi_un->{roi_un_error});}' unless defined(&roi_error);
    eval 'sub roi_ureject () { ($roi_un->{roi_un_ureject});}' unless defined(&roi_ureject);
    eval 'sub roi_preject () { ($roi_un->{roi_un_preject});}' unless defined(&roi_preject);
    eval 'sub roi_end () { ($roi_un->{roi_un_end});}' unless defined(&roi_end);
    eval 'sub roi_finish () { ($roi_un->{roi_un_finish});}' unless defined(&roi_finish);
    eval 'sub RoRejectURequest () { &RoURejectRequest;}' unless defined(&RoRejectURequest);
}
1;
