require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_OBJECTS_)) {
    eval 'sub _OBJECTS_ () {1;}' unless defined(&_OBJECTS_);
    require 'isode/psap.ph';
    eval 'sub NULLOS () {(( &OS) 0);}' unless defined(&NULLOS);
    eval 'sub OT_NONE () {0x;}' unless defined(&OT_NONE);
    eval 'sub OT_RDONLY () {0x1;}' unless defined(&OT_RDONLY);
    eval 'sub OT_WRONLY () {0x2;}' unless defined(&OT_WRONLY);
    eval 'sub OT_RDWRITE () {( &OT_RDONLY |  &OT_WRONLY);}' unless defined(&OT_RDWRITE);
    eval 'sub OT_OBSOLETE () {0x;}' unless defined(&OT_OBSOLETE);
    eval 'sub OT_MANDATORY () {0x1;}' unless defined(&OT_MANDATORY);
    eval 'sub OT_OPTIONAL () {0x2;}' unless defined(&OT_OPTIONAL);
    eval 'sub OT_DEPRECATED () {0x3;}' unless defined(&OT_DEPRECATED);
    eval 'sub type_SNMP_PDUs_commit () {(-1);}' unless defined(&type_SNMP_PDUs_commit);
    eval 'sub type_SNMP_PDUs_rollback () {(-2);}' unless defined(&type_SNMP_PDUs_rollback);
    eval 'sub NULLOT () {(( &OT) 0);}' unless defined(&NULLOT);
    eval 'sub NULLOI () {(( &OI) 0);}' unless defined(&NULLOI);
    eval 'sub o_integer {
        my($oi,$v,$number) = @_;
	    eval q( &o_number (($oi), ($v), ( &integer) ($number)));
    }' unless defined(&o_integer);
    if(defined(&BSD44)) {
	eval 'sub o_clnpaddr {
	    my($oi,$v,$value) = @_;
    	    eval q( &o_specific (, , ($value)));
	}' unless defined(&o_clnpaddr);
    }
    eval 'sub ipaddr2oid {
        my($ip,$addr) = @_;
	    eval q( &mediaddr2oid (, ($addr), $sizeof{\'struct in_addr\'}, 0));
    }' unless defined(&ipaddr2oid);
    if(defined(&BSD44)) {
	eval 'sub clnpaddr2oid {
	    my($ip,$addr) = @_;
    	    eval q( &mediaddr2oid (, ->  &isoa_genaddr, ($addr) ->  &isoa_len, 1));
	}' unless defined(&clnpaddr2oid);
    }
}
1;
