require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPKT_)) {
    eval 'sub _SPKT_ () {1;}' unless defined(&_SPKT_);
    unless(defined(&_SSAP_)) {
	require 'isode/ssap.ph';
    }
    require 'isode/tsap.ph';
    eval 'sub ssapPsig {
        my($sb, $sd) = @_;
	    eval q({  &if (($sb =  &findsblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"invalid session descriptor\\"); }  &if (!($sb ->  &sb_flags &  &SB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"session descriptor not connected\\"); }  &if ($sb ->  &sb_flags &  &SB_FINN) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"session descriptor finishing\\"); }  &if ($sb ->  &sb_flags &  &SB_RELEASE) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"release in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_MAP) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"majorsync in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_RS) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"resync in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_RA) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"awaiting your resync response\\"); }  &if ($sb ->  &sb_flags &  &SB_AI) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"activity interrupt/discard in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_AIA) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"awaiting your activity interrupt/discard response\\"); }  &if ($sb ->  &sb_flags & ( &SB_ED |  &SB_EDACK |  &SB_ERACK)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"exception in progress\\"); } });
    }' unless defined(&ssapPsig);
    eval 'sub ssapXsig {
        my($sb, $sd) = @_;
	    eval q({  &if (($sb =  &findsblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"invalid session descriptor\\"); }  &if (!($sb ->  &sb_flags &  &SB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"session descriptor not connected\\"); }  &if ($sb ->  &sb_flags &  &SB_FINN) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"session descriptor finishing\\"); }  &if ($sb ->  &sb_flags &  &SB_RELEASE) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"release in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_RS) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"resync in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_RA) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"awaiting your resync response\\"); }  &if ($sb ->  &sb_flags &  &SB_AI) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"activity interrupt/discard in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_AIA) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"awaiting your activity interrupt/discard response\\"); }  &if ($sb ->  &sb_flags &  &SB_ED) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"exception in progress\\"); } });
    }' unless defined(&ssapXsig);
    eval 'sub ssapRsig {
        my($sb, $sd) = @_;
	    eval q({  &if (($sb =  &findsblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"invalid session descriptor\\"); }  &if (!($sb ->  &sb_flags &  &SB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"session descriptor not connected\\"); }  &if ($sb ->  &sb_flags &  &SB_FINN) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"session descriptor finishing\\"); }  &if ($sb ->  &sb_flags &  &SB_RELEASE) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"release in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_RS) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"resync in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_AI) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"activity interrupt/discard in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_AIA) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"awaiting your activity interrupt/discard response\\"); }  &if ($sb ->  &sb_flags &  &SB_AE) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"activity end in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_ED) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"exception in progress\\"); } });
    }' unless defined(&ssapRsig);
    eval 'sub ssapAsig {
        my($sb, $sd) = @_;
	    eval q({  &if (($sb =  &findsblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"invalid session descriptor\\"); }  &if (!($sb ->  &sb_flags &  &SB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"session descriptor not connected\\"); }  &if ($sb ->  &sb_flags &  &SB_FINN) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"session descriptor finishing\\"); }  &if ($sb ->  &sb_flags &  &SB_RELEASE) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"release in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_MAA) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"awaiting your majorsync response\\"); }  &if ($sb ->  &sb_flags &  &SB_RS) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"resync in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_AI) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"activity interrupt/discard in response\\"); }  &if ($sb ->  &sb_flags & ( &SB_ED |  &SB_EDACK |  &SB_ERACK)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"exception in progress\\"); } });
    }' unless defined(&ssapAsig);
    eval 'sub ssapFsig {
        my($sb, $sd) = @_;
	    eval q({  &if (($sb =  &findsblk ($sd)) ==  &NULL) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"invalid session descriptor\\"); }  &if (!($sb ->  &sb_flags &  &SB_CONN)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"session descriptor not connected\\"); }  &if (!($sb ->  &sb_flags &  &SB_FINN)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"session descriptor not finishing\\"); }  &if ($sb ->  &sb_flags &  &SB_RELEASE) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"release in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_MAA) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"awaiting your majorsync response\\"); }  &if ($sb ->  &sb_flags &  &SB_RS) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"resync in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_RA) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"awaiting your resync response\\"); }  &if ($sb ->  &sb_flags &  &SB_AI) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"activity interrupt/discard in progress\\"); }  &if ($sb ->  &sb_flags &  &SB_AIA) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"awaiting your activity interrupt/discard response\\"); }  &if ($sb ->  &sb_flags & ( &SB_ED |  &SB_EDACK |  &SB_ERACK)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_OPERATION,  &NULLCP, \\"exception in progress\\"); } });
    }' unless defined(&ssapFsig);
    eval 'sub missingP {
        my($p) = @_;
	    eval q({  &if ($p ==  &NULL)  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"mandatory parameter \\\\\\"%s\\\\\\" missing\\", \\"p\\"); });
    }' unless defined(&missingP);
    eval 'sub refmuchP {
        my($sr) = @_;
	    eval q({  &if (($sr) ->  &sr_ulen >  &SREF_USER_SIZE || ($sr) ->  &sr_clen >  &SREF_COMM_SIZE || ($sr) ->  &sr_alen >  &SREF_ADDT_SIZE || ($sr) ->  &sr_vlen >  &SREF_USER_SIZE)  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"bad format for reference\\"); });
    }' unless defined(&refmuchP);
    eval 'sub idmuchP {
        my($sd) = @_;
	    eval q({  &if (($sd) ->  &sd_len >  &SID_DATA_SIZE)  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"bad format for activity ID\\"); });
    }' unless defined(&idmuchP);
    eval 'sub toomuchP {
        my($sb,$b,$n,$m,$p) = @_;
	    eval q({  &if ($b ==  &NULL) $n = 0;  &else  &if ($n > ($sb ->  &sb_version <  &SB_VRSN2 ? $m :  &ENCLOSE_MAX)) { ( &void)  &sigiomask ( &smask);  &return  &ssaplose ( &si,  &SC_PARAMETER,  &NULLCP, \\"too much %s user data, %d octets\\", $p, $n); } });
    }' unless defined(&toomuchP);
    eval 'sub NULLTX () {( 0);}' unless defined(&NULLTX);
    eval 'sub NULLSD () {( 0);}' unless defined(&NULLSD);
    eval 'sub NULLSR () {( 0);}' unless defined(&NULLSR);
    unless(defined(&lint)) {
	if(!defined( &_AIX)) {
	    eval 'sub copySSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d  &_cc =  &min ( &i,  &sizeof $d -> $d  &_data)) > 0)  &bcopy ($base, $d -> $d  &_data, $d -> $d  &_cc); });
	    }' unless defined(&copySSAPdata);
	    eval 'sub copySPKTdata {
	        my($s,$d) = @_;
    		eval q({ $d -> $d  &_data = $s ->  &s_udata, $d -> $d  &_cc = $s ->  &s_ulen; $s ->  &s_udata =  &NULL; });
	    }' unless defined(&copySPKTdata);
	} else {
	    eval 'sub copySSAPdata {
	        my($base,$len,$d) = @_;
    		eval q({  &register \'int\'  &i = $len;  &if (($d -> $d &_cc =  &min ( &i,  &sizeof $d -> $d &_data)) > 0)  &bcopy ($base, $d -> $d &_data, $d -> $d &_cc); });
	    }' unless defined(&copySSAPdata);
	    eval 'sub copySPKTdata {
	        my($s, $d) = @_;
    		eval q({ $d -> $d &_data = $s ->  &s_udata, $d -> $d &_cc = $s ->  &s_ulen; $s ->  &s_udata =  &NULL; });
	    }' unless defined(&copySPKTdata);
	}
    } else {
	eval 'sub copySSAPdata {
	    my($base,$len,$d) = @_;
    	    eval q( &bcopy ($base, $d, $len));
	}' unless defined(&copySSAPdata);
	eval 'sub copySPKTdata {
	    my($s,$d) = @_;
    	    eval q( &bcopy ($s ->  &s_udata, $d, $s ->  &s_ulen));
	}' unless defined(&copySPKTdata);
    }
    eval 'sub AB_TIM () {30;}' unless defined(&AB_TIM);
    eval 'sub RF_TIM () {30;}' unless defined(&RF_TIM);
    eval 'sub SC_REFUSE () {( &SC_BASE << 1);}' unless defined(&SC_REFUSE);
    eval 'sub SB_VRSN1 () {0;}' unless defined(&SB_VRSN1);
    eval 'sub SB_VRSN2 () {1;}' unless defined(&SB_VRSN2);
    eval 'sub SB_ALLVRSNS () {((1<<  &SB_VRSN1) | (1<<  &SB_VRSN2));}' unless defined(&SB_ALLVRSNS);
    eval 'sub SB_NULL () {0x;}' unless defined(&SB_NULL);
    eval 'sub SB_CONN () {0x1;}' unless defined(&SB_CONN);
    eval 'sub SB_FINN () {0x2;}' unless defined(&SB_FINN);
    eval 'sub SB_INIT () {0x4;}' unless defined(&SB_INIT);
    eval 'sub SB_ASYN () {0x8;}' unless defined(&SB_ASYN);
    eval 'sub SB_EXPD () {0x10;}' unless defined(&SB_EXPD);
    eval 'sub SB_CD () {0x20;}' unless defined(&SB_CD);
    eval 'sub SB_CDA () {0x40;}' unless defined(&SB_CDA);
    eval 'sub SB_GTC () {0x80;}' unless defined(&SB_GTC);
    eval 'sub SB_MAP () {0x100;}' unless defined(&SB_MAP);
    eval 'sub SB_MAA () {0x200;}' unless defined(&SB_MAA);
    eval 'sub SB_AE () {0x400;}' unless defined(&SB_AE);
    eval 'sub SB_RS () {0x800;}' unless defined(&SB_RS);
    eval 'sub SB_RA () {0x1000;}' unless defined(&SB_RA);
    eval 'sub SB_AI () {0x2000;}' unless defined(&SB_AI);
    eval 'sub SB_AIA () {0x4000;}' unless defined(&SB_AIA);
    eval 'sub SB_ED () {0x8000;}' unless defined(&SB_ED);
    eval 'sub SB_EDACK () {0x10000;}' unless defined(&SB_EDACK);
    eval 'sub SB_ERACK () {0x20000;}' unless defined(&SB_ERACK);
    eval 'sub SB_Vact () {0x40000;}' unless defined(&SB_Vact);
    eval 'sub SB_Vsc () {0x80000;}' unless defined(&SB_Vsc);
    eval 'sub SB_Vnextact () {0x100000;}' unless defined(&SB_Vnextact);
    eval 'sub SB_RELEASE () {0x200000;}' unless defined(&SB_RELEASE);
    eval 'sub SYNC_INTR () {3;}' unless defined(&SYNC_INTR);
    eval 'sub SYNC_DISC () {4;}' unless defined(&SYNC_DISC);
    eval 'sub BAD_TSDU_SIZE {
        my($s) = @_;
	    eval q((($s) ? ($s) <  &DT_MINSIZE : 0));
    }' unless defined(&BAD_TSDU_SIZE);
    eval 'sub GET_TSDU_SIZE {
        my($s) = @_;
	    eval q((($s) <  &DT_MINSIZE ? 0: ($s)));
    }' unless defined(&GET_TSDU_SIZE);
    eval 'sub NULLBP () {( 0);}' unless defined(&NULLBP);
    eval 'sub SPDU_CN () {0xd;}' unless defined(&SPDU_CN);
    eval 'sub SPDU_AC () {0xe;}' unless defined(&SPDU_AC);
    eval 'sub SPDU_RF () {0xc;}' unless defined(&SPDU_RF);
    eval 'sub SPDU_FN () {0x9;}' unless defined(&SPDU_FN);
    eval 'sub SPDU_DN () {0xa;}' unless defined(&SPDU_DN);
    eval 'sub SPDU_NF () {0x8;}' unless defined(&SPDU_NF);
    eval 'sub SPDU_AB () {0x19;}' unless defined(&SPDU_AB);
    eval 'sub SPDU_AA () {0x1a;}' unless defined(&SPDU_AA);
    eval 'sub SPDU_DT () { &SPDU_GT;}' unless defined(&SPDU_DT);
    eval 'sub SPDU_EX () {0x5;}' unless defined(&SPDU_EX);
    eval 'sub SPDU_TD () {0x21;}' unless defined(&SPDU_TD);
    eval 'sub SPDU_CD () {0x3d;}' unless defined(&SPDU_CD);
    eval 'sub SPDU_CDA () {0x3e;}' unless defined(&SPDU_CDA);
    eval 'sub SPDU_GT () {0x1;}' unless defined(&SPDU_GT);
    eval 'sub SPDU_PT () {0x2;}' unless defined(&SPDU_PT);
    eval 'sub SPDU_GTC () {0x15;}' unless defined(&SPDU_GTC);
    eval 'sub SPDU_GTA () {0x16;}' unless defined(&SPDU_GTA);
    eval 'sub SPDU_MIP () {0x31;}' unless defined(&SPDU_MIP);
    eval 'sub SPDU_MIA () {0x32;}' unless defined(&SPDU_MIA);
    eval 'sub SPDU_MAP () {0x29;}' unless defined(&SPDU_MAP);
    eval 'sub SPDU_MAA () {0x2a;}' unless defined(&SPDU_MAA);
    eval 'sub SPDU_RS () {0x35;}' unless defined(&SPDU_RS);
    eval 'sub SPDU_RA () {0x22;}' unless defined(&SPDU_RA);
    eval 'sub SPDU_PR () {0x7;}' unless defined(&SPDU_PR);
    eval 'sub SPDU_ER () {0x;}' unless defined(&SPDU_ER);
    eval 'sub SPDU_ED () {0x30;}' unless defined(&SPDU_ED);
    eval 'sub SPDU_AS () {0x2d;}' unless defined(&SPDU_AS);
    eval 'sub SPDU_AR () {0x1d;}' unless defined(&SPDU_AR);
    eval 'sub SPDU_AI () { &SPDU_AB;}' unless defined(&SPDU_AI);
    eval 'sub SPDU_AIA () { &SPDU_AA;}' unless defined(&SPDU_AIA);
    eval 'sub SPDU_AD () {0x39;}' unless defined(&SPDU_AD);
    eval 'sub SPDU_ADA () {0x3a;}' unless defined(&SPDU_ADA);
    eval 'sub SPDU_AE () { &SPDU_MAP;}' unless defined(&SPDU_AE);
    eval 'sub SPDU_AEA () { &SPDU_MAA;}' unless defined(&SPDU_AEA);
    eval 'sub SPDU_MAXLEN () {65535;}' unless defined(&SPDU_MAXLEN);
    eval 'sub SSDU_MAGIC () {7;}' unless defined(&SSDU_MAGIC);
    eval 'sub SMASK_CN_REF () {0x1;}' unless defined(&SMASK_CN_REF);
    eval 'sub SMASK_CN_OPT () {0x2;}' unless defined(&SMASK_CN_OPT);
    eval 'sub CR_OPT_NULL () {0x;}' unless defined(&CR_OPT_NULL);
    eval 'sub CR_OPT_EXTD () {0x1;}' unless defined(&CR_OPT_EXTD);
    eval 'sub CR_OPT_MASK () { &CR_OPT_EXTD;}' unless defined(&CR_OPT_MASK);
    eval 'sub SMASK_CN_TSDU () {0x4;}' unless defined(&SMASK_CN_TSDU);
    eval 'sub SMASK_CN_VRSN () {0x8;}' unless defined(&SMASK_CN_VRSN);
    eval 'sub SMASK_CN_ISN () {0x10;}' unless defined(&SMASK_CN_ISN);
    eval 'sub SIZE_CN_ISN () {6;}' unless defined(&SIZE_CN_ISN);
    eval 'sub SMASK_CN_SET () {0x20;}' unless defined(&SMASK_CN_SET);
    eval 'sub SMASK_AC_TOKEN () {0x40;}' unless defined(&SMASK_AC_TOKEN);
    eval 'sub SMASK_CN_REQ () {0x80;}' unless defined(&SMASK_CN_REQ);
    eval 'sub SMASK_CN_CALLING () {0x100;}' unless defined(&SMASK_CN_CALLING);
    eval 'sub SMASK_CN_CALLED () {0x200;}' unless defined(&SMASK_CN_CALLED);
    eval 'sub CN_SIZE () {512;}' unless defined(&CN_SIZE);
    eval 'sub CONNECT_MAX () {10240;}' unless defined(&CONNECT_MAX);
    eval 'sub CN_BASE_SIZE () {56;}' unless defined(&CN_BASE_SIZE);
    eval 'sub AC_SIZE () {512;}' unless defined(&AC_SIZE);
    eval 'sub AC_BASE_SIZE () {62;}' unless defined(&AC_BASE_SIZE);
    eval 'sub SMASK_RF_REF () {0x1;}' unless defined(&SMASK_RF_REF);
    eval 'sub SMASK_RF_DISC () {0x2;}' unless defined(&SMASK_RF_DISC);
    eval 'sub RF_DISC_RELEASE () {0x1;}' unless defined(&RF_DISC_RELEASE);
    eval 'sub RF_DISC_MASK () { &RF_DISC_RELEASE;}' unless defined(&RF_DISC_MASK);
    eval 'sub SMASK_RF_REQ () {0x4;}' unless defined(&SMASK_RF_REQ);
    eval 'sub SMASK_RF_VRSN () {0x8;}' unless defined(&SMASK_RF_VRSN);
    eval 'sub RF_SIZE () {513;}' unless defined(&RF_SIZE);
    eval 'sub RF_BASE_SIZE () {13;}' unless defined(&RF_BASE_SIZE);
    eval 'sub SMASK_FN_DISC () {0x1;}' unless defined(&SMASK_FN_DISC);
    eval 'sub FN_DISC_RELEASE () {0x1;}' unless defined(&FN_DISC_RELEASE);
    eval 'sub FN_DISC_MASK () { &FN_DISC_RELEASE;}' unless defined(&FN_DISC_MASK);
    eval 'sub FN_SIZE () {512;}' unless defined(&FN_SIZE);
    eval 'sub FN_BASE_SIZE () {6;}' unless defined(&FN_BASE_SIZE);
    eval 'sub DN_SIZE () {512;}' unless defined(&DN_SIZE);
    eval 'sub DN_BASE_SIZE () {3;}' unless defined(&DN_BASE_SIZE);
    eval 'sub NF_SIZE () {512;}' unless defined(&NF_SIZE);
    eval 'sub NF_BASE_SIZE () {3;}' unless defined(&NF_BASE_SIZE);
    eval 'sub SMASK_AB_DISC () {0x1;}' unless defined(&SMASK_AB_DISC);
    eval 'sub AB_DISC_RELEASE () {0x1;}' unless defined(&AB_DISC_RELEASE);
    eval 'sub AB_DISC_USER () {0x2;}' unless defined(&AB_DISC_USER);
    eval 'sub AB_DISC_PROTO () {0x4;}' unless defined(&AB_DISC_PROTO);
    eval 'sub AB_DISC_UNKNOWN () {0x8;}' unless defined(&AB_DISC_UNKNOWN);
    eval 'sub AB_DISC_MASK () {( &AB_DISC_RELEASE |  &AB_DISC_USER |  &AB_DISC_PROTO |  &AB_DISC_UNKNOWN);}' unless defined(&AB_DISC_MASK);
    eval 'sub SMASK_AB_REFL () {0x2;}' unless defined(&SMASK_AB_REFL);
    eval 'sub AB_REFL_SIZE () {9;}' unless defined(&AB_REFL_SIZE);
    eval 'sub AB_SIZE () {9;}' unless defined(&AB_SIZE);
    eval 'sub AB_BASE_SIZE () {17;}' unless defined(&AB_BASE_SIZE);
    eval 'sub SMASK_SPDU_AB () {0x4;}' unless defined(&SMASK_SPDU_AB);
    eval 'sub AA_SIZE () {0;}' unless defined(&AA_SIZE);
    eval 'sub AA_BASE_SIZE () {0;}' unless defined(&AA_BASE_SIZE);
    eval 'sub SMASK_SPDU_AA () {0x1;}' unless defined(&SMASK_SPDU_AA);
    eval 'sub DT_SIZE () {65535;}' unless defined(&DT_SIZE);
    eval 'sub DT_MINSIZE () {64;}' unless defined(&DT_MINSIZE);
    eval 'sub DT_BASE_SIZE () {3;}' unless defined(&DT_BASE_SIZE);
    eval 'sub EX_SIZE () { &SX_EXSIZE;}' unless defined(&EX_SIZE);
    eval 'sub EX_BASE_SIZE () {0;}' unless defined(&EX_BASE_SIZE);
    eval 'sub TD_SIGHS () {65535;}' unless defined(&TD_SIGHS);
    eval 'sub TD_MINSIZE () {64;}' unless defined(&TD_MINSIZE);
    eval 'sub TD_BASE_SIZE () {3;}' unless defined(&TD_BASE_SIZE);
    eval 'sub CD_SIZE () { &SX_CDSIZE;}' unless defined(&CD_SIZE);
    eval 'sub CD_BASE_SIZE () {3;}' unless defined(&CD_BASE_SIZE);
    eval 'sub CDA_SIZE () { &SX_CDASIZE;}' unless defined(&CDA_SIZE);
    eval 'sub CDA_BASE_SIZE () {3;}' unless defined(&CDA_BASE_SIZE);
    eval 'sub SMASK_GT_TOKEN () {0x1;}' unless defined(&SMASK_GT_TOKEN);
    eval 'sub GT_SIZE () {0;}' unless defined(&GT_SIZE);
    eval 'sub GT_BASE_SIZE () {3;}' unless defined(&GT_BASE_SIZE);
    eval 'sub SMASK_SPDU_GT () {0x2;}' unless defined(&SMASK_SPDU_GT);
    eval 'sub SMASK_PT_TOKEN () {0x1;}' unless defined(&SMASK_PT_TOKEN);
    eval 'sub PT_SIZE () {512;}' unless defined(&PT_SIZE);
    eval 'sub PT_BASE_SIZE () {6;}' unless defined(&PT_BASE_SIZE);
    eval 'sub GTC_SIZE () {0;}' unless defined(&GTC_SIZE);
    eval 'sub GTC_BASE_SIZE () {0;}' unless defined(&GTC_BASE_SIZE);
    eval 'sub GTA_SIZE () {0;}' unless defined(&GTA_SIZE);
    eval 'sub GTA_BASE_SIZE () {0;}' unless defined(&GTA_BASE_SIZE);
    eval 'sub SMASK_MIP_SYNC () {0x1;}' unless defined(&SMASK_MIP_SYNC);
    eval 'sub MIP_SYNC_NOEXPL () {0x1;}' unless defined(&MIP_SYNC_NOEXPL);
    eval 'sub MIP_SYNC_MASK () { &MIP_SYNC_NOEXPL;}' unless defined(&MIP_SYNC_MASK);
    eval 'sub SMASK_MIP_SERIAL () {0x2;}' unless defined(&SMASK_MIP_SERIAL);
    eval 'sub MIP_SIZE () {512;}' unless defined(&MIP_SIZE);
    eval 'sub MIP_BASE_SIZE () {14;}' unless defined(&MIP_BASE_SIZE);
    eval 'sub SMASK_MIA_SERIAL () {0x1;}' unless defined(&SMASK_MIA_SERIAL);
    eval 'sub MIA_SIZE () {512;}' unless defined(&MIA_SIZE);
    eval 'sub MIA_BASE_SIZE () {11;}' unless defined(&MIA_BASE_SIZE);
    eval 'sub SMASK_MAP_SYNC () {0x1;}' unless defined(&SMASK_MAP_SYNC);
    eval 'sub MAP_SYNC_NOEND () {0x1;}' unless defined(&MAP_SYNC_NOEND);
    eval 'sub MAP_SYNC_MASK () { &MAP_SYNC_NOEND;}' unless defined(&MAP_SYNC_MASK);
    eval 'sub SMASK_MAP_SERIAL () {0x2;}' unless defined(&SMASK_MAP_SERIAL);
    eval 'sub MAP_SIZE () {512;}' unless defined(&MAP_SIZE);
    eval 'sub MAP_BASE_SIZE () {14;}' unless defined(&MAP_BASE_SIZE);
    eval 'sub SMASK_MAA_SERIAL () {0x1;}' unless defined(&SMASK_MAA_SERIAL);
    eval 'sub MAA_SIZE () {512;}' unless defined(&MAA_SIZE);
    eval 'sub MAA_BASE_SIZE () {11;}' unless defined(&MAA_BASE_SIZE);
    eval 'sub SMASK_RS_SET () {0x1;}' unless defined(&SMASK_RS_SET);
    eval 'sub SMASK_RS_TYPE () {0x2;}' unless defined(&SMASK_RS_TYPE);
    eval 'sub SYNC_OK {
        my($r) = @_;
	    eval q((( ($r)) <=  &SYNC_SET));
    }' unless defined(&SYNC_OK);
    eval 'sub SMASK_RS_SSN () {0x4;}' unless defined(&SMASK_RS_SSN);
    eval 'sub RS_SIZE () {512;}' unless defined(&RS_SIZE);
    eval 'sub RS_BASE_SIZE () {17;}' unless defined(&RS_BASE_SIZE);
    eval 'sub SMASK_RA_SET () {0x1;}' unless defined(&SMASK_RA_SET);
    eval 'sub SMASK_RA_SSN () {0x2;}' unless defined(&SMASK_RA_SSN);
    eval 'sub RA_SIZE () {512;}' unless defined(&RA_SIZE);
    eval 'sub RA_BASE_SIZE () {14;}' unless defined(&RA_BASE_SIZE);
    eval 'sub SMASK_PR_TYPE () {0x1;}' unless defined(&SMASK_PR_TYPE);
    eval 'sub PR_MAA () {1;}' unless defined(&PR_MAA);
    eval 'sub PR_RS () {2;}' unless defined(&PR_RS);
    eval 'sub PR_RA () {3;}' unless defined(&PR_RA);
    eval 'sub PR_AB () {4;}' unless defined(&PR_AB);
    eval 'sub PR_MAX () { &PR_AB;}' unless defined(&PR_MAX);
    eval 'sub PR_SIZE () {0;}' unless defined(&PR_SIZE);
    eval 'sub PR_BASE_SIZE () {3;}' unless defined(&PR_BASE_SIZE);
    eval 'sub ER_SIZE () {0;}' unless defined(&ER_SIZE);
    eval 'sub ER_BASE_SIZE () {0;}' unless defined(&ER_BASE_SIZE);
    eval 'sub SMASK_ED_REASON () {0x1;}' unless defined(&SMASK_ED_REASON);
    eval 'sub SP_OK {
        my($r) = @_;
	    eval q(((($r) <  &SP_PROCEDURAL  && ($r) !=  &SP_RSVD1  && ($r) !=  &SP_RSVD2) || ($r) ==  &SP_DEMAND));
    }' unless defined(&SP_OK);
    eval 'sub ED_SIZE () {512;}' unless defined(&ED_SIZE);
    eval 'sub ED_BASE_SIZE () {6;}' unless defined(&ED_BASE_SIZE);
    eval 'sub SMASK_AS_ID () {0x1;}' unless defined(&SMASK_AS_ID);
    eval 'sub AS_SIZE () {512;}' unless defined(&AS_SIZE);
    eval 'sub AS_BASE_SIZE () {11;}' unless defined(&AS_BASE_SIZE);
    eval 'sub SMASK_AR_REF () {0x1;}' unless defined(&SMASK_AR_REF);
    eval 'sub SMASK_AR_OID () {0x2;}' unless defined(&SMASK_AR_OID);
    eval 'sub SMASK_AR_SSN () {0x4;}' unless defined(&SMASK_AR_SSN);
    eval 'sub SMASK_AR_ID () {0x8;}' unless defined(&SMASK_AR_ID);
    eval 'sub AR_SIZE () {512;}' unless defined(&AR_SIZE);
    eval 'sub AR_BASE_SIZE () {29;}' unless defined(&AR_BASE_SIZE);
    eval 'sub SMASK_AI_REASON () {0x1;}' unless defined(&SMASK_AI_REASON);
    eval 'sub AI_SIZE () {0;}' unless defined(&AI_SIZE);
    eval 'sub AI_BASE_SIZE () {3;}' unless defined(&AI_BASE_SIZE);
    eval 'sub AIA_SIZE () {0;}' unless defined(&AIA_SIZE);
    eval 'sub AIA_BASE_SIZE () {0;}' unless defined(&AIA_BASE_SIZE);
    eval 'sub SMASK_AD_REASON () {0x1;}' unless defined(&SMASK_AD_REASON);
    eval 'sub AD_SIZE () {0;}' unless defined(&AD_SIZE);
    eval 'sub AD_BASE_SIZE () {3;}' unless defined(&AD_BASE_SIZE);
    eval 'sub ADA_SIZE () {0;}' unless defined(&ADA_SIZE);
    eval 'sub ADA_BASE_SIZE () {0;}' unless defined(&ADA_BASE_SIZE);
    eval 'sub AE_SIZE () {512;}' unless defined(&AE_SIZE);
    eval 'sub AE_BASE_SIZE () {8;}' unless defined(&AE_BASE_SIZE);
    eval 'sub AEA_SIZE () { &MAA_SIZE;}' unless defined(&AEA_SIZE);
    eval 'sub AEA_BASE_SIZE () { &MAA_BASE_SIZE;}' unless defined(&AEA_BASE_SIZE);
    eval 'sub s_cn_reference () { ($s_un->{un_cn}->{un_cn_reference});}' unless defined(&s_cn_reference);
    eval 'sub s_options () { ($s_un->{un_cn}->{un_cn_item}->{un_cn_options});}' unless defined(&s_options);
    eval 'sub s_tsdu_init () { ($s_un->{un_cn}->{un_cn_item}->{un_cn_tsdu_init});}' unless defined(&s_tsdu_init);
    eval 'sub s_tsdu_resp () { ($s_un->{un_cn}->{un_cn_item}->{un_cn_tsdu_resp});}' unless defined(&s_tsdu_resp);
    eval 'sub s_cn_version () { ($s_un->{un_cn}->{un_cn_item}->{un_cn_version});}' unless defined(&s_cn_version);
    eval 'sub s_isn () { ($s_un->{un_cn}->{un_cn_item}->{un_cn_isn});}' unless defined(&s_isn);
    eval 'sub s_settings () { ($s_un->{un_cn}->{un_cn_item}->{un_settings});}' unless defined(&s_settings);
    eval 'sub s_ac_token () { ($s_un->{un_cn}->{un_ac_token});}' unless defined(&s_ac_token);
    eval 'sub s_cn_require () { ($s_un->{un_cn}->{un_cn_requirements});}' unless defined(&s_cn_require);
    eval 'sub s_calling () { ($s_un->{un_cn}->{un_cn_calling});}' unless defined(&s_calling);
    eval 'sub s_callinglen () { ($s_un->{un_cn}->{un_cn_callinglen});}' unless defined(&s_callinglen);
    eval 'sub s_called () { ($s_un->{un_cn}->{un_cn_called});}' unless defined(&s_called);
    eval 'sub s_calledlen () { ($s_un->{un_cn}->{un_cn_calledlen});}' unless defined(&s_calledlen);
    eval 'sub s_rf_reference () { ($s_un->{un_rf}->{un_rf_reference});}' unless defined(&s_rf_reference);
    eval 'sub s_rf_disconnect () { ($s_un->{un_rf}->{un_rf_disconnect});}' unless defined(&s_rf_disconnect);
    eval 'sub s_rf_require () { ($s_un->{un_rf}->{un_rf_requirements});}' unless defined(&s_rf_require);
    eval 'sub s_rf_version () { ($s_un->{un_rf}->{un_rf_version});}' unless defined(&s_rf_version);
    eval 'sub s_rdata () { ($s_un->{un_rf}->{un_rf_rdata});}' unless defined(&s_rdata);
    eval 'sub s_rlen () { ($s_un->{un_rf}->{un_rf_rlen});}' unless defined(&s_rlen);
    eval 'sub s_fn_disconnect () { ($s_un->{un_fn}->{un_fn_disconnect});}' unless defined(&s_fn_disconnect);
    eval 'sub s_ab_disconnect () { ($s_un->{un_ab}->{un_ab_disconnect});}' unless defined(&s_ab_disconnect);
    eval 'sub s_reflect () { ($s_un->{un_ab}->{un_ab_reflect});}' unless defined(&s_reflect);
    eval 'sub s_gt_token () { ($s_un->{un_gt}->{un_gt_token});}' unless defined(&s_gt_token);
    eval 'sub s_pt_token () { ($s_un->{un_pt}->{un_pt_token});}' unless defined(&s_pt_token);
    eval 'sub s_mip_sync () { ($s_un->{un_mip}->{un_mip_sync});}' unless defined(&s_mip_sync);
    eval 'sub s_mip_serial () { ($s_un->{un_mip}->{un_mip_serial});}' unless defined(&s_mip_serial);
    eval 'sub s_mia_serial () { ($s_un->{un_mia}->{un_mia_serial});}' unless defined(&s_mia_serial);
    eval 'sub s_map_sync () { ($s_un->{un_map}->{un_map_sync});}' unless defined(&s_map_sync);
    eval 'sub s_map_serial () { ($s_un->{un_map}->{un_map_serial});}' unless defined(&s_map_serial);
    eval 'sub s_maa_serial () { ($s_un->{un_maa}->{un_maa_serial});}' unless defined(&s_maa_serial);
    eval 'sub s_rs_settings () { ($s_un->{un_rs}->{un_rs_settings});}' unless defined(&s_rs_settings);
    eval 'sub s_rs_type () { ($s_un->{un_rs}->{un_rs_type});}' unless defined(&s_rs_type);
    eval 'sub s_rs_serial () { ($s_un->{un_rs}->{un_rs_serial});}' unless defined(&s_rs_serial);
    eval 'sub s_ra_settings () { ($s_un->{un_ra}->{un_ra_settings});}' unless defined(&s_ra_settings);
    eval 'sub s_ra_serial () { ($s_un->{un_ra}->{un_ra_serial});}' unless defined(&s_ra_serial);
    eval 'sub s_pr_type () { ($s_un->{un_pr}->{un_pr_type});}' unless defined(&s_pr_type);
    eval 'sub s_ed_reason () { ($s_un->{un_ed}->{un_ed_reason});}' unless defined(&s_ed_reason);
    eval 'sub s_as_id () { ($s_un->{un_as}->{un_as_id});}' unless defined(&s_as_id);
    eval 'sub s_ar_reference () { ($s_un->{un_ar}->{un_ar_link}->{un_ar_reference});}' unless defined(&s_ar_reference);
    eval 'sub s_ar_oid () { ($s_un->{un_ar}->{un_ar_link}->{un_ar_oid});}' unless defined(&s_ar_oid);
    eval 'sub s_ar_serial () { ($s_un->{un_ar}->{un_ar_link}->{un_ar_serial});}' unless defined(&s_ar_serial);
    eval 'sub s_ar_id () { ($s_un->{un_ar}->{un_ar_id});}' unless defined(&s_ar_id);
    eval 'sub s_ai_reason () { ($s_un->{un_ai}->{un_ai_reason});}' unless defined(&s_ai_reason);
    eval 'sub s_ad_reason () { ($s_un->{un_ad}->{un_ad_reason});}' unless defined(&s_ad_reason);
    eval 'sub SMASK_ENCLOSE () {0x2000;}' unless defined(&SMASK_ENCLOSE);
    eval 'sub ENCL_BEGIN () {0x1;}' unless defined(&ENCL_BEGIN);
    eval 'sub ENCL_END () {0x2;}' unless defined(&ENCL_END);
    eval 'sub ENCL_MASK () {( &ENCL_BEGIN |  &ENCL_END);}' unless defined(&ENCL_MASK);
    eval 'sub ENCLOSE_MAX () {65400;}' unless defined(&ENCLOSE_MAX);
    eval 'sub SEGMENT_MAX () {65528;}' unless defined(&SEGMENT_MAX);
    eval 'sub SMASK_UDATA_PGI () {0x4000;}' unless defined(&SMASK_UDATA_PGI);
    eval 'sub SMASK_SPDU_EXPD () {0x8000;}' unless defined(&SMASK_SPDU_EXPD);
    eval 'sub NULLSPKT () {( 0);}' unless defined(&NULLSPKT);
}
1;
