require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X25_)) {
    eval 'sub _X25_ () {1;}' unless defined(&_X25_);
    unless(defined(&_INTERNET_)) {
	require 'sys/socket.ph';
    }
    if(defined(&SUN_X25)) {
	require 'sys/ioctl.ph';
	require 'sys/param.ph';
	require 'sys/mbuf.ph';
	require 'sundev/syncstat.ph';
	require 'netx25/x25_pk.ph';
	require 'netx25/x25_ctl.ph';
	require 'netx25/x25_ioctl.ph';
    }
    require 'sys/protosw.ph';
    require 'sys/domain.ph';
    require 'sys/socketvar.ph';
    require 'sys/errno.ph';
    require 'net/if.ph';
    if(defined(&CAMTEC)) {
	require 'cci.ph';
	undef(&NTPUV) if defined(&NTPUV);
	eval 'sub NTPUV () {2;}' unless defined(&NTPUV);
    }
    if(defined(&CAMTEC_CCL)) {
	require 'sys/ioctl.ph';
	require 'sys/param.ph';
	require 'sys/types.ph';
	require 'sys/uio.ph';
	require 'netccl/ccl.ph';
    }
    if(defined(&UBC_X25)) {
	require 'netccitt/x25_sockaddr.ph';
	if(defined(&BSD44)) {
	    require 'sys/ioctl.ph';
	}
	eval 'sub X25_PACKETSIZE () {128;}' unless defined(&X25_PACKETSIZE);
    }
    if(defined(&SUN_X25)) {
	eval 'sub close_x25_socket () { &close;}' unless defined(&close_x25_socket);
	eval 'sub select_x25_socket () { &selsocket;}' unless defined(&select_x25_socket);
	eval 'sub read_x25_socket () { &read;}' unless defined(&read_x25_socket);
	eval 'sub write_x25_socket () { &write;}' unless defined(&write_x25_socket);
    }
    if(defined( &UBC_X25) || defined( &CAMTEC_CCL)) {
	eval 'sub close_x25_socket () { &close;}' unless defined(&close_x25_socket);
	eval 'sub select_x25_socket () { &selsocket;}' unless defined(&select_x25_socket);
    }
    unless(defined(&SUN_X25)) {
	eval 'sub RECV_DIAG () {0;}' unless defined(&RECV_DIAG);
	eval 'sub DIAG_TYPE () {1;}' unless defined(&DIAG_TYPE);
	eval 'sub WAIT_CONFIRMATION () {2;}' unless defined(&WAIT_CONFIRMATION);
    }
    eval 'sub ADDR_LOCAL () {0;}' unless defined(&ADDR_LOCAL);
    eval 'sub ADDR_REMOTE () {1;}' unless defined(&ADDR_REMOTE);
    eval 'sub ADDR_LISTEN () {2;}' unless defined(&ADDR_LISTEN);
    eval 'sub SEPARATOR () {ord(\':\');}' unless defined(&SEPARATOR);
    eval 'sub MAXNSDU () {2048;}' unless defined(&MAXNSDU);
}
1;
