require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_J2_DTREE)) {
    eval 'sub _H_J2_DTREE () {1;}' unless defined(&_H_J2_DTREE);
    eval 'sub _H_JFS_DIR () {1;}' unless defined(&_H_JFS_DIR);
    require 'sys/dir.ph';
    require 'j2/j2_btree.ph';
    if(defined(&_J2_UNICODE)) {
    } else {
    }
    eval 'sub DTSLOTSIZE () {32;}' unless defined(&DTSLOTSIZE);
    eval 'sub L2DTSLOTSIZE () {5;}' unless defined(&L2DTSLOTSIZE);
    eval 'sub DTSLOTHDRSIZE () {2;}' unless defined(&DTSLOTHDRSIZE);
    eval 'sub DTSLOTDATASIZE () {30;}' unless defined(&DTSLOTDATASIZE);
    if(defined(&_J2_UNICODE)) {
	eval 'sub DTSLOTDATALEN () {15;}' unless defined(&DTSLOTDATALEN);
    } else {
	eval 'sub DTSLOTDATALEN () {30;}' unless defined(&DTSLOTDATALEN);
    }
    if(defined(&_J2_UNICODE)) {
    } else {
    }
    eval 'sub DTIHDRSIZE () {10;}' unless defined(&DTIHDRSIZE);
    if(defined(&_J2_UNICODE)) {
	eval 'sub DTIHDRDATALEN () {11;}' unless defined(&DTIHDRDATALEN);
    } else {
	eval 'sub DTIHDRDATALEN () {22;}' unless defined(&DTIHDRDATALEN);
    }
    if(defined(&_J2_UNICODE)) {
    } else {
    }
    eval 'sub DTLHDRSIZE () {10;}' unless defined(&DTLHDRSIZE);
    if(defined(&_J2_UNICODE)) {
	eval 'sub DTLHDRDATALEN () {11;}' unless defined(&DTLHDRDATALEN);
    } else {
	eval 'sub DTLHDRDATALEN () {22;}' unless defined(&DTLHDRDATALEN);
    }
    if(defined(&_J2_UNICODE)) {
	eval 'sub NDTSLOT {
	    my($klen) = @_;
    	    eval q((( &DTSLOTDATALEN + ($klen) + $sizeof{ &ino64_t} - 2) /  &DTSLOTDATALEN));
	}' unless defined(&NDTSLOT);
    } else {
	eval 'sub NDTSLOT {
	    my($klen) = @_;
    	    eval q((( &DTSLOTDATALEN + ($klen) + $sizeof{ &ino64_t} - 1) /  &DTSLOTDATALEN));
	}' unless defined(&NDTSLOT);
    }
    eval 'sub DTROOTMAXSLOT () {9;}' unless defined(&DTROOTMAXSLOT);
    eval 'sub dtEmpty {
        my($IP) = @_;
	    eval q(( (( &dtroot_t *)($IP)-> &i_btroot)-> ($header->{nextindex}) == 0? 0:  &EEXIST));
    }' unless defined(&dtEmpty);
    eval 'sub DTPAGEMAXSLOT () {128;}' unless defined(&DTPAGEMAXSLOT);
    eval 'sub DT8THPGNODEBYTES () {512;}' unless defined(&DT8THPGNODEBYTES);
    eval 'sub DT8THPGNODETSLOTS () {1;}' unless defined(&DT8THPGNODETSLOTS);
    eval 'sub DT8THPGNODESLOTS () {16;}' unless defined(&DT8THPGNODESLOTS);
    eval 'sub DTQTRPGNODEBYTES () {1024;}' unless defined(&DTQTRPGNODEBYTES);
    eval 'sub DTQTRPGNODETSLOTS () {1;}' unless defined(&DTQTRPGNODETSLOTS);
    eval 'sub DTQTRPGNODESLOTS () {32;}' unless defined(&DTQTRPGNODESLOTS);
    eval 'sub DTHALFPGNODEBYTES () {2048;}' unless defined(&DTHALFPGNODEBYTES);
    eval 'sub DTHALFPGNODETSLOTS () {2;}' unless defined(&DTHALFPGNODETSLOTS);
    eval 'sub DTHALFPGNODESLOTS () {64;}' unless defined(&DTHALFPGNODESLOTS);
    eval 'sub DTFULLPGNODEBYTES () {4096;}' unless defined(&DTFULLPGNODEBYTES);
    eval 'sub DTFULLPGNODETSLOTS () {4;}' unless defined(&DTFULLPGNODETSLOTS);
    eval 'sub DTFULLPGNODESLOTS () {128;}' unless defined(&DTFULLPGNODESLOTS);
    eval 'sub DTENTRYSTART () {1;}' unless defined(&DTENTRYSTART);
    eval 'sub DT_GETSTBL {
        my($p) = @_;
	    eval q(( (($p)-> ($header->{flag}) &  &BT_ROOT) ? (( &dtroot_t *)($p))-> ($header->{stbl}) : ( &int8 *)($p)-> $slot[($p)-> ($header->{stblindex})] ));
    }' unless defined(&DT_GETSTBL);
    if(defined(&_KERNEL)) {
	if(defined(&_J2_UNICODE)) {
	    eval 'sub DIRENTSIZ {
	        my($namlen) = @_;
    		eval q(( (( &ureg_t)((0)-> &d_name) + 2*(($namlen)+1) + $sizeof{ &ino_t}-1) & ~($sizeof{ &ino_t}-1) ));
	    }' unless defined(&DIRENTSIZ);
	} else {
	    eval 'sub DIRENTSIZ {
	        my($namlen) = @_;
    		eval q(( (( &ureg_t)((0)-> &d_name) + (($namlen)+1) + $sizeof{ &ino_t}-1) & ~($sizeof{ &ino_t}-1) ));
	    }' unless defined(&DIRENTSIZ);
	}
	if(defined(&_J2_DEBUG)) {
	}
    }
}
1;
