require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_J2_LOCK)) {
    eval 'sub _H_J2_LOCK () {1;}' unless defined(&_H_J2_LOCK);
    require 'sys/lock_def.ph';
    require 'sys/lock_alloc.ph';
    require 'sys/lockname.ph';
    require 'sys/sleep.ph';
    require 'proc/proc_public.ph';
    eval 'sub IOSPINLOCK_T () { &Simple_lock;}' unless defined(&IOSPINLOCK_T);
    if(defined(&_POWER_MP)) {
	eval 'sub IOSPINLOCK_ALLOC {
	    my($Lock,$Flag,$Class,$Occurrence) = @_;
    	    eval q( &lock_alloc($Lock,  &LOCK_ALLOC_PIN, $Class, $Occurrence));
	}' unless defined(&IOSPINLOCK_ALLOC);
	eval 'sub IOSPINLOCK_FREE {
	    my($Lock) = @_;
    	    eval q( &lock_free($Lock));
	}' unless defined(&IOSPINLOCK_FREE);
	eval 'sub IOSPINLOCK_INIT {
	    my($Lock) = @_;
    	    eval q( &simple_lock_init($Lock));
	}' unless defined(&IOSPINLOCK_INIT);
	eval 'sub IOSPINLOCK_DISABLE_LOCK {
	    my($Lock) = @_;
    	    eval q( &disable_lock( &INTIODONE,$Lock));
	}' unless defined(&IOSPINLOCK_DISABLE_LOCK);
	eval 'sub IO_DISABLE () {
	    eval q( &i_disable( &INTIODONE));
	}' unless defined(&IO_DISABLE);
	eval 'sub IOSPINLOCK_LOCK {
	    my($Lock) = @_;
    	    eval q( &simple_lock($Lock));
	}' unless defined(&IOSPINLOCK_LOCK);
	eval 'sub IOSPINLOCK_LOCK_TRY {
	    my($Lock) = @_;
    	    eval q( &simple_lock_try($Lock));
	}' unless defined(&IOSPINLOCK_LOCK_TRY);
	eval 'sub IOSPINLOCK_UNLOCK_ENABLE {
	    my($xipl,$Lock) = @_;
    	    eval q( &unlock_enable($xipl,$Lock));
	}' unless defined(&IOSPINLOCK_UNLOCK_ENABLE);
	eval 'sub IOSPINLOCK_UNLOCK {
	    my($Lock) = @_;
    	    eval q( &simple_unlock($Lock));
	}' unless defined(&IOSPINLOCK_UNLOCK);
	eval 'sub IOSPINLOCK_UNLOCK_MEM {
	    my($Lock) = @_;
    	    eval q( &simple_unlock_mem($Lock));
	}' unless defined(&IOSPINLOCK_UNLOCK_MEM);
	eval 'sub IO_ENABLE {
	    my($xipl) = @_;
    	    eval q( &i_enable($xipl));
	}' unless defined(&IO_ENABLE);
    } else {
	eval 'sub IOSPINLOCK_ALLOC {
	    my($Lock,$Flag,$Class,$Occurrence) = @_;
    	    eval q();
	}' unless defined(&IOSPINLOCK_ALLOC);
	eval 'sub IOSPINLOCK_FREE {
	    my($Lock) = @_;
    	    eval q();
	}' unless defined(&IOSPINLOCK_FREE);
	eval 'sub IOSPINLOCK_INIT {
	    my($Lock) = @_;
    	    eval q();
	}' unless defined(&IOSPINLOCK_INIT);
	eval 'sub IOSPINLOCK_DISABLE_LOCK {
	    my($Lock) = @_;
    	    eval q( &i_disable( &INTIODONE));
	}' unless defined(&IOSPINLOCK_DISABLE_LOCK);
	eval 'sub IO_DISABLE () {
	    eval q( &i_disable( &INTIODONE));
	}' unless defined(&IO_DISABLE);
	eval 'sub IOSPINLOCK_LOCK {
	    my($Lock) = @_;
    	    eval q();
	}' unless defined(&IOSPINLOCK_LOCK);
	eval 'sub IOSPINLOCK_LOCK_TRY {
	    my($Lock) = @_;
    	    eval q(1);
	}' unless defined(&IOSPINLOCK_LOCK_TRY);
	eval 'sub IOSPINLOCK_UNLOCK_ENABLE {
	    my($xipl,$Lock) = @_;
    	    eval q( &i_enable($xipl));
	}' unless defined(&IOSPINLOCK_UNLOCK_ENABLE);
	eval 'sub IOSPINLOCK_UNLOCK {
	    my($Lock) = @_;
    	    eval q();
	}' unless defined(&IOSPINLOCK_UNLOCK);
	eval 'sub IOSPINLOCK_UNLOCK_MEM {
	    my($Lock) = @_;
    	    eval q();
	}' unless defined(&IOSPINLOCK_UNLOCK_MEM);
	eval 'sub IO_ENABLE {
	    my($xipl) = @_;
    	    eval q( &i_enable($xipl));
	}' unless defined(&IO_ENABLE);
    }
    eval 'sub MUTEXLOCK_T () { &Simple_lock;}' unless defined(&MUTEXLOCK_T);
    eval 'sub MUTEXLOCK_ALLOC {
        my($Lock,$Flag,$Class,$Occurrence) = @_;
	    eval q( &lock_alloc($Lock,  &LOCK_ALLOC_PAGED, $Class, $Occurrence));
    }' unless defined(&MUTEXLOCK_ALLOC);
    eval 'sub MUTEXLOCK_FREE {
        my($Lock) = @_;
	    eval q( &lock_free($Lock));
    }' unless defined(&MUTEXLOCK_FREE);
    eval 'sub MUTEXLOCK_INIT {
        my($Lock) = @_;
	    eval q( &simple_lock_init($Lock));
    }' unless defined(&MUTEXLOCK_INIT);
    eval 'sub MUTEXLOCK_LOCK {
        my($Lock) = @_;
	    eval q( &simple_lock($Lock));
    }' unless defined(&MUTEXLOCK_LOCK);
    eval 'sub MUTEXLOCK_LOCK_TRY {
        my($Lock) = @_;
	    eval q( &simple_lock_try($Lock));
    }' unless defined(&MUTEXLOCK_LOCK_TRY);
    eval 'sub MUTEXLOCK_UNLOCK {
        my($Lock) = @_;
	    eval q( &simple_unlock($Lock));
    }' unless defined(&MUTEXLOCK_UNLOCK);
    eval 'sub MUTEXLOCK_UNLOCK_MEM {
        my($Lock) = @_;
	    eval q( &simple_unlock_mem($Lock));
    }' unless defined(&MUTEXLOCK_UNLOCK_MEM);
    eval 'sub RDWRLOCK_T () { &Complex_lock;}' unless defined(&RDWRLOCK_T);
    eval 'sub RDWRLOCK_ALLOC {
        my($Lock,$Flag,$Class,$Occurrence) = @_;
	    eval q( &lock_alloc($Lock,  &LOCK_ALLOC_PAGED, $Class, $Occurrence));
    }' unless defined(&RDWRLOCK_ALLOC);
    eval 'sub RDWRLOCK_FREE {
        my($Lock) = @_;
	    eval q( &lock_free($Lock));
    }' unless defined(&RDWRLOCK_FREE);
    eval 'sub RDWRLOCK_INIT {
        my($Lock) = @_;
	    eval q( &lock_init($Lock, 0));
    }' unless defined(&RDWRLOCK_INIT);
    eval 'sub READ_LOCK {
        my($Lock) = @_;
	    eval q( &lock_read($Lock));
    }' unless defined(&READ_LOCK);
    eval 'sub READ_UNLOCK {
        my($Lock) = @_;
	    eval q( &lock_done($Lock));
    }' unless defined(&READ_UNLOCK);
    eval 'sub WRITE_LOCK {
        my($Lock) = @_;
	    eval q( &lock_write($Lock));
    }' unless defined(&WRITE_LOCK);
    eval 'sub WRITE_LOCK_TRY {
        my($Lock) = @_;
	    eval q( &lock_try_write($Lock));
    }' unless defined(&WRITE_LOCK_TRY);
    eval 'sub WRITE_UNLOCK {
        my($Lock) = @_;
	    eval q( &lock_done($Lock));
    }' unless defined(&WRITE_UNLOCK);
    eval 'sub event_init {
        my($event) = @_;
	    eval q(*($event) =  &EVENT_NULL);
    }' unless defined(&event_init);
    eval 'sub T_IOSPINLOCK () { &LOCK_HANDLER;}' unless defined(&T_IOSPINLOCK);
    eval 'sub T_MUTEXLOCK () { &LOCK_SIMPLE;}' unless defined(&T_MUTEXLOCK);
    eval 'sub T_READLOCK () { &LOCK_READ;}' unless defined(&T_READLOCK);
    eval 'sub T_WRITELOCK () { &LOCK_WRITE;}' unless defined(&T_WRITELOCK);
    eval 'sub EVENT_SLEEP {
        my($Event,$Lock,$Flag) = @_;
	    eval q( &e_sleep_thread($Event,$Lock,$Flag));
    }' unless defined(&EVENT_SLEEP);
    eval 'sub EVENT_SLEEP_RC {
        my($Event,$Lock,$Flag,$rc) = @_;
	    eval q($rc =  &e_sleep_thread($Event,$Lock,$Flag));
    }' unless defined(&EVENT_SLEEP_RC);
    eval 'sub EVENT_WAKEUP {
        my($Event) = @_;
	    eval q( &e_wakeup($Event));
    }' unless defined(&EVENT_WAKEUP);
    eval 'sub EVENT_WAKEUP_RC {
        my($Event,$rc) = @_;
	    eval q( &e_wakeup_w_result($Event,$rc));
    }' unless defined(&EVENT_WAKEUP_RC);
    eval 'sub J2_LOCK () {
        eval q( &MUTEXLOCK_LOCK( &j2Lock));
    }' unless defined(&J2_LOCK);
    eval 'sub J2_UNLOCK () {
        eval q( &MUTEXLOCK_UNLOCK( &j2Lock));
    }' unless defined(&J2_UNLOCK);
    eval 'sub IREAD_LOCK {
        my($ip) = @_;
	    eval q( &READ_LOCK((($ip)-> &i_rdwrlock)));
    }' unless defined(&IREAD_LOCK);
    eval 'sub IREAD_UNLOCK {
        my($ip) = @_;
	    eval q( &READ_UNLOCK((($ip)-> &i_rdwrlock)));
    }' unless defined(&IREAD_UNLOCK);
    eval 'sub IWRITE_LOCK {
        my($ip) = @_;
	    eval q({  &WRITE_LOCK((($ip)-> &i_rdwrlock));  &if ( ($ip->{i_fsxlock}) &  &FSXLOCK) {  &do {  ($ip->{i_fsxlock}) |=  &FSXWANT;  &EVENT_SLEEP(($ip)-> &i_fsevent, ($ip)-> &i_rdwrlock,  &T_WRITELOCK); }  &while ( ($ip->{i_fsxlock}) &  &FSXLOCK); }});
    }' unless defined(&IWRITE_LOCK);
    eval 'sub IWRITE_LOCK_TRY {
        my($ip) = @_;
	    eval q( &WRITE_LOCK_TRY((($ip)-> &i_rdwrlock)));
    }' unless defined(&IWRITE_LOCK_TRY);
    eval 'sub IWRITE_UNLOCK {
        my($ip) = @_;
	    eval q( &WRITE_UNLOCK((($ip)-> &i_rdwrlock)));
    }' unless defined(&IWRITE_UNLOCK);
    eval 'sub IWRITE_LOCK_LIST () { &iWriteLockList;}' unless defined(&IWRITE_LOCK_LIST);
    eval 'sub INODE_LOCK {
        my($ip) = @_;
	    eval q( &MUTEXLOCK_LOCK((($ip)-> &i_nodelock)));
    }' unless defined(&INODE_LOCK);
    eval 'sub INODE_LOCK_TRY {
        my($ip) = @_;
	    eval q( &MUTEXLOCK_LOCK_TRY((($ip)-> &i_nodelock)));
    }' unless defined(&INODE_LOCK_TRY);
    eval 'sub INODE_UNLOCK {
        my($ip) = @_;
	    eval q( &MUTEXLOCK_UNLOCK((($ip)-> &i_nodelock)));
    }' unless defined(&INODE_UNLOCK);
    eval 'sub LOGRDWR_LOCK {
        my($log) = @_;
	    eval q( &MUTEXLOCK_LOCK((($log)-> &rdwrLock)));
    }' unless defined(&LOGRDWR_LOCK);
    eval 'sub LOGRDWR_UNLOCK {
        my($log) = @_;
	    eval q( &MUTEXLOCK_UNLOCK((($log)-> &rdwrLock)));
    }' unless defined(&LOGRDWR_UNLOCK);
    eval 'sub RENAME_LOCK {
        my($ipmnt) = @_;
	    eval q( &MUTEXLOCK_LOCK((($ipmnt)-> &i_renamelock)));
    }' unless defined(&RENAME_LOCK);
    eval 'sub RENAME_UNLOCK {
        my($ipmnt) = @_;
	    eval q( &MUTEXLOCK_UNLOCK((($ipmnt)-> &i_renamelock)));
    }' unless defined(&RENAME_UNLOCK);
}
1;
