require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_J2_LOGMGR)) {
    eval 'sub _H_J2_LOGMGR () {1;}' unless defined(&_H_J2_LOGMGR);
    require 'j2/j2_types.ph';
    require 'j2/j2_filsys.ph';
    require 'j2/j2_inode.ph';
    require 'j2/j2_bufmgr.ph';
    eval 'sub LOGNAME_PREFIX () {"log";}' unless defined(&LOGNAME_PREFIX);
    eval 'sub LOGTYPE () {"j2";}' unless defined(&LOGTYPE);
    eval 'sub MAXNLOG () {256;}' unless defined(&MAXNLOG);
    eval 'sub LOGMINOR () {8;}' unless defined(&LOGMINOR);
    eval 'sub LOGPSIZE () {4096;}' unless defined(&LOGPSIZE);
    eval 'sub L2LOGPSIZE () {12;}' unless defined(&L2LOGPSIZE);
    eval 'sub LOGSUPER_B () {1;}' unless defined(&LOGSUPER_B);
    eval 'sub LOGSTART_B () {2;}' unless defined(&LOGSTART_B);
    eval 'sub LOGMAGIC () {"J2XL";}' unless defined(&LOGMAGIC);
    eval 'sub LOGVERSION () {1;}' unless defined(&LOGVERSION);
    eval 'sub LOGMOUNT () {0;}' unless defined(&LOGMOUNT);
    eval 'sub LOGREDONE () {1;}' unless defined(&LOGREDONE);
    eval 'sub LOGWRAP () {2;}' unless defined(&LOGWRAP);
    eval 'sub LOGIOERROR () {3;}' unless defined(&LOGIOERROR);
    eval 'sub LOGREADERR () { &LOGIOERROR;}' unless defined(&LOGREADERR);
    eval 'sub LOGPHDRSIZE () {8;}' unless defined(&LOGPHDRSIZE);
    eval 'sub LOGPTLRSIZE () {8;}' unless defined(&LOGPTLRSIZE);
    eval 'sub LOG_COMMIT () {0x8000;}' unless defined(&LOG_COMMIT);
    eval 'sub LOG_SYNCPT () {0x4000;}' unless defined(&LOG_SYNCPT);
    eval 'sub LOG_MOUNT () {0x2000;}' unless defined(&LOG_MOUNT);
    eval 'sub LOG_REDOPAGE () {0x800;}' unless defined(&LOG_REDOPAGE);
    eval 'sub LOG_NOREDOPAGE () {0x80;}' unless defined(&LOG_NOREDOPAGE);
    eval 'sub LOG_NOREDOINOEXT () {0x40;}' unless defined(&LOG_NOREDOINOEXT);
    eval 'sub LOG_ALLOCINOEXT () {0x20;}' unless defined(&LOG_ALLOCINOEXT);
    eval 'sub LOG_UPDATEMAP () {0x8;}' unless defined(&LOG_UPDATEMAP);
    eval 'sub LOG_NOREDOFREE () {0x2;}' unless defined(&LOG_NOREDOFREE);
    eval 'sub LOG_NOREDOFILE () {0x1;}' unless defined(&LOG_NOREDOFILE);
    eval 'sub LOG_INODE () {0x1;}' unless defined(&LOG_INODE);
    eval 'sub LOG_XTREE () {0x2;}' unless defined(&LOG_XTREE);
    eval 'sub LOG_DTREE () {0x4;}' unless defined(&LOG_DTREE);
    eval 'sub LOG_BTROOT () {0x10;}' unless defined(&LOG_BTROOT);
    eval 'sub LOG_EA () {0x20;}' unless defined(&LOG_EA);
    eval 'sub LOG_ACL () {0x40;}' unless defined(&LOG_ACL);
    eval 'sub LOG_SYMLINK () {0x80;}' unless defined(&LOG_SYMLINK);
    eval 'sub LOG_NEW () {0x100;}' unless defined(&LOG_NEW);
    eval 'sub LOG_EXTEND () {0x200;}' unless defined(&LOG_EXTEND);
    eval 'sub LOG_RELOCATE () {0x400;}' unless defined(&LOG_RELOCATE);
    eval 'sub LOG_ALLOCXADLIST () {0x80;}' unless defined(&LOG_ALLOCXADLIST);
    eval 'sub LOG_ALLOCPXDLIST () {0x40;}' unless defined(&LOG_ALLOCPXDLIST);
    eval 'sub LOG_ALLOCXAD () {0x20;}' unless defined(&LOG_ALLOCXAD);
    eval 'sub LOG_ALLOCPXD () {0x10;}' unless defined(&LOG_ALLOCPXD);
    eval 'sub LOG_FREEXADLIST () {0x8;}' unless defined(&LOG_FREEXADLIST);
    eval 'sub LOG_FREEPXDLIST () {0x4;}' unless defined(&LOG_FREEPXDLIST);
    eval 'sub LOG_FREEXAD () {0x2;}' unless defined(&LOG_FREEXAD);
    eval 'sub LOG_FREEPXD () {0x1;}' unless defined(&LOG_FREEPXD);
    eval 'sub LOGRDSIZE () {($sizeof{\'struct lrd\'});}' unless defined(&LOGRDSIZE);
    eval 'sub LogSyncOff () {0x;}' unless defined(&LogSyncOff);
    eval 'sub LogSyncOn () {0x1;}' unless defined(&LogSyncOn);
    eval 'sub LogSyncSync () {0x2;}' unless defined(&LogSyncSync);
    eval 'sub logGC_PAGEOUT () {0x1;}' unless defined(&logGC_PAGEOUT);
    eval 'sub tblkGC_QUEUE () {0x1;}' unless defined(&tblkGC_QUEUE);
    eval 'sub tblkGC_READY () {0x2;}' unless defined(&tblkGC_READY);
    eval 'sub tblkGC_COMMIT () {0x4;}' unless defined(&tblkGC_COMMIT);
    eval 'sub tblkGC_COMMITTED () {0x8;}' unless defined(&tblkGC_COMMITTED);
    eval 'sub tblkGC_EOP () {0x10;}' unless defined(&tblkGC_EOP);
    eval 'sub tblkGC_FREE () {0x20;}' unless defined(&tblkGC_FREE);
    eval 'sub tblkGC_LEADER () {0x40;}' unless defined(&tblkGC_LEADER);
    eval 'sub tblkGC_ERROR () {0x80;}' unless defined(&tblkGC_ERROR);
    eval 'sub tblkGC_WAIT () {0x100;}' unless defined(&tblkGC_WAIT);
    eval 'sub LOG_BUFFER_HWM () {0x1;}' unless defined(&LOG_BUFFER_HWM);
    eval 'sub lb_freeList () { ($_lb_u1->{_freeList});}' unless defined(&lb_freeList);
    eval 'sub LOG_LOCK {
        my($log) = @_;
	    eval q( &MUTEXLOCK_LOCK((($log)-> &logLock)));
    }' unless defined(&LOG_LOCK);
    eval 'sub LOG_UNLOCK {
        my($log) = @_;
	    eval q( &MUTEXLOCK_UNLOCK((($log)-> &logLock)));
    }' unless defined(&LOG_UNLOCK);
    eval 'sub LOGSYNC_LOCK {
        my($logx) = @_;
	    eval q( &IOSPINLOCK_LOCK(($logx)-> &syncListLock));
    }' unless defined(&LOGSYNC_LOCK);
    eval 'sub LOGSYNC_LOCK_TRY {
        my($logx) = @_;
	    eval q( &IOSPINLOCK_LOCK_TRY(($logx)-> &syncListLock));
    }' unless defined(&LOGSYNC_LOCK_TRY);
    eval 'sub LOGSYNC_UNLOCK {
        my($logx) = @_;
	    eval q( &IOSPINLOCK_UNLOCK(($logx)-> &syncListLock));
    }' unless defined(&LOGSYNC_UNLOCK);
    eval 'sub LOGSYNC_DISABLE_LOCK {
        my($logx) = @_;
	    eval q( &IOSPINLOCK_DISABLE_LOCK(($logx)-> &syncListLock));
    }' unless defined(&LOGSYNC_DISABLE_LOCK);
    eval 'sub LOGSYNC_UNLOCK_ENABLE {
        my($xipl, $logx) = @_;
	    eval q( &IOSPINLOCK_UNLOCK_ENABLE($xipl, ($logx)-> &syncListLock));
    }' unless defined(&LOGSYNC_UNLOCK_ENABLE);
    eval 'sub logDifference {
        my($diff, $lsn, $logx) = @_;
	    eval q({ $diff = ($lsn) - ($logx)-> &syncpt;  &if ($diff < 0) $diff += ($logx)-> &size;});
    }' unless defined(&logDifference);
    if(defined(&_KERNEL)) {
    }
}
1;
