require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_J2_TXNMGR)) {
    eval 'sub _H_J2_TXNMGR () {1;}' unless defined(&_H_J2_TXNMGR);
    require 'j2/j2_xtree.ph';
    require 'j2/j2_logmgr.ph';
    require 'j2/j2_bufmgr.ph';
    eval 'sub COMMIT_BEGIN () {0xf0000000;}' unless defined(&COMMIT_BEGIN);
    eval 'sub COMMIT_RESERVED () {0x80000000;}' unless defined(&COMMIT_RESERVED);
    eval 'sub COMMIT_THRU () {0x40000000;}' unless defined(&COMMIT_THRU);
    eval 'sub COMMIT_COMMIT () {0xf000000;}' unless defined(&COMMIT_COMMIT);
    eval 'sub COMMIT_SYNC () {0x1000000;}' unless defined(&COMMIT_SYNC);
    eval 'sub COMMIT_FORCEBEFORE () {0x2000000;}' unless defined(&COMMIT_FORCEBEFORE);
    eval 'sub COMMIT_CAREFULUPDATE () { &COMMIT_FORCEBEFORE;}' unless defined(&COMMIT_CAREFULUPDATE);
    eval 'sub COMMIT_FORCEAFTER () {0x4000000;}' unless defined(&COMMIT_FORCEAFTER);
    eval 'sub COMMIT_FORCE () { &COMMIT_FORCEAFTER;}' unless defined(&COMMIT_FORCE);
    eval 'sub COMMIT_FLUSH () {0x8000000;}' unless defined(&COMMIT_FLUSH);
    eval 'sub COMMIT_FREE () {0xf00000;}' unless defined(&COMMIT_FREE);
    eval 'sub COMMIT_REMOVE () {0x100000;}' unless defined(&COMMIT_REMOVE);
    eval 'sub COMMIT_TRUNCATE () {0x200000;}' unless defined(&COMMIT_TRUNCATE);
    eval 'sub COMMIT_PAGERINPROGRESS () {0x10000;}' unless defined(&COMMIT_PAGERINPROGRESS);
    eval 'sub COMMIT_NOUSERSYNC () {0x20000;}' unless defined(&COMMIT_NOUSERSYNC);
    eval 'sub COMMIT_MAP () {0xf;}' unless defined(&COMMIT_MAP);
    eval 'sub COMMIT_PMAP () {0x1;}' unless defined(&COMMIT_PMAP);
    eval 'sub COMMIT_WMAP () {0x2;}' unless defined(&COMMIT_WMAP);
    eval 'sub COMMIT_PWMAP () {0x4;}' unless defined(&COMMIT_PWMAP);
    eval 'sub tlckPAGELOCK () {0x8000;}' unless defined(&tlckPAGELOCK);
    eval 'sub tlckINODELOCK () {0x4000;}' unless defined(&tlckINODELOCK);
    eval 'sub tlckMAPLOCK () {0x2000;}' unless defined(&tlckMAPLOCK);
    eval 'sub tlckLINELOCK () {( &tlckPAGELOCK |  &tlckINODELOCK);}' unless defined(&tlckLINELOCK);
    eval 'sub tlckLOG () {0x800;}' unless defined(&tlckLOG);
    eval 'sub tlckUPDATEMAP () {0x80;}' unless defined(&tlckUPDATEMAP);
    eval 'sub tlckFREELOCK () {0x8;}' unless defined(&tlckFREELOCK);
    eval 'sub tlckWRITEPAGE () {0x4;}' unless defined(&tlckWRITEPAGE);
    eval 'sub tlckFREEPAGE () {0x2;}' unless defined(&tlckFREEPAGE);
    eval 'sub tlckLOCAL () {0x1;}' unless defined(&tlckLOCAL);
    eval 'sub tlckTYPE () {0xf800;}' unless defined(&tlckTYPE);
    eval 'sub tlckINODE () {0x8000;}' unless defined(&tlckINODE);
    eval 'sub tlckXTREE () {0x4000;}' unless defined(&tlckXTREE);
    eval 'sub tlckDTREE () {0x2000;}' unless defined(&tlckDTREE);
    eval 'sub tlckMAP () {0x1000;}' unless defined(&tlckMAP);
    eval 'sub tlckEA () {0x800;}' unless defined(&tlckEA);
    eval 'sub tlckACL () {0x400;}' unless defined(&tlckACL);
    eval 'sub tlckSYMLINK () {0x200;}' unless defined(&tlckSYMLINK);
    eval 'sub tlckBTROOT () {0x100;}' unless defined(&tlckBTROOT);
    eval 'sub tlckOPERATION () {0xff;}' unless defined(&tlckOPERATION);
    eval 'sub tlckNEW () {0x1;}' unless defined(&tlckNEW);
    eval 'sub tlckGROW () {0x2;}' unless defined(&tlckGROW);
    eval 'sub tlckENTRY () {0x2;}' unless defined(&tlckENTRY);
    eval 'sub tlckEXTEND () {0x4;}' unless defined(&tlckEXTEND);
    eval 'sub tlckRELINK () {0x8;}' unless defined(&tlckRELINK);
    eval 'sub tlckFREE () {0x10;}' unless defined(&tlckFREE);
    eval 'sub tlckTRUNCATE () {0x20;}' unless defined(&tlckTRUNCATE);
    eval 'sub tlckFREEMAP () {0x40;}' unless defined(&tlckFREEMAP);
    eval 'sub tlckMETAPGFREE () {0x80;}' unless defined(&tlckMETAPGFREE);
    eval 'sub TLOCKSHORT () {22;}' unless defined(&TLOCKSHORT);
    eval 'sub TLOCKLONG () {34;}' unless defined(&TLOCKLONG);
    eval 'sub diLock_t () { &lineLock_t;}' unless defined(&diLock_t);
    eval 'sub dtlock_t () { &lineLock_t;}' unless defined(&dtlock_t);
    eval 'sub mlckALLOC () {0xf0;}' unless defined(&mlckALLOC);
    eval 'sub mlckALLOCXADLIST () {0x80;}' unless defined(&mlckALLOCXADLIST);
    eval 'sub mlckALLOCPXDLIST () {0x40;}' unless defined(&mlckALLOCPXDLIST);
    eval 'sub mlckALLOCXAD () {0x20;}' unless defined(&mlckALLOCXAD);
    eval 'sub mlckALLOCPXD () {0x10;}' unless defined(&mlckALLOCPXD);
    eval 'sub mlckFREE () {0xf;}' unless defined(&mlckFREE);
    eval 'sub mlckFREEXADLIST () {0x8;}' unless defined(&mlckFREEXADLIST);
    eval 'sub mlckFREEPXDLIST () {0x4;}' unless defined(&mlckFREEPXDLIST);
    eval 'sub mlckFREEXAD () {0x2;}' unless defined(&mlckFREEXAD);
    eval 'sub mlckFREEPXD () {0x1;}' unless defined(&mlckFREEPXD);
}
1;
