require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_J2_XTREE)) {
    eval 'sub _H_J2_XTREE () {1;}' unless defined(&_H_J2_XTREE);
    require 'j2/j2_btree.ph';
    eval 'sub MAXXLEN () {((1<< 24) - 1);}' unless defined(&MAXXLEN);
    eval 'sub XTSLOTSIZE () {16;}' unless defined(&XTSLOTSIZE);
    eval 'sub L2XTSLOTSIZE () {4;}' unless defined(&L2XTSLOTSIZE);
    eval 'sub XADoffset {
        my($xad, $offset64) = @_;
	    eval q({ ($xad)-> &off1 = ($offset64) >> 32; ($xad)-> &off2 = ($offset64) & 0xffffffff;});
    }' unless defined(&XADoffset);
    eval 'sub XADaddress {
        my($xad, $address64) = @_;
	    eval q({ ($xad)-> &addr1 = ($address64) >> 32; ($xad)-> &addr2 = ($address64) & 0xffffffff;});
    }' unless defined(&XADaddress);
    eval 'sub XADlength {
        my($xad, $length32) = @_;
	    eval q(($xad)-> &len = $length32);
    }' unless defined(&XADlength);
    eval 'sub offsetXAD {
        my($xad) = @_;
	    eval q(( (( &int64)(($xad)-> &off1)) << 32| ($xad)-> &off2 ));
    }' unless defined(&offsetXAD);
    eval 'sub addressXAD {
        my($xad) = @_;
	    eval q(( (( &int64)(($xad)-> &addr1)) << 32| ($xad)-> &addr2 ));
    }' unless defined(&addressXAD);
    eval 'sub lengthXAD {
        my($xad) = @_;
	    eval q(( ($xad)-> &len ));
    }' unless defined(&lengthXAD);
    eval 'sub XAD_NEW () {0x1;}' unless defined(&XAD_NEW);
    eval 'sub XAD_EXTENDED () {0x2;}' unless defined(&XAD_EXTENDED);
    eval 'sub XAD_ABNR () {0x4;}' unless defined(&XAD_ABNR);
    eval 'sub XAD_RELOC () {0x8;}' unless defined(&XAD_RELOC);
    eval 'sub XAD_COW () {0x10;}' unless defined(&XAD_COW);
    eval 'sub XAD_COMPRESSED () {0x20;}' unless defined(&XAD_COMPRESSED);
    eval 'sub XAD_EOF () {0x80;}' unless defined(&XAD_EOF);
    eval 'sub XAD_RBNA () {0x1000;}' unless defined(&XAD_RBNA);
    eval 'sub XAD_NOTALLOCATED () {0x8000;}' unless defined(&XAD_NOTALLOCATED);
    eval 'sub XAD_UPDATABLE () { &XAD_ABNR;}' unless defined(&XAD_UPDATABLE);
    eval 'sub XTROOTMAXSLOT () {18;}' unless defined(&XTROOTMAXSLOT);
    eval 'sub XTPAGEMAXSLOT () {256;}' unless defined(&XTPAGEMAXSLOT);
    eval 'sub XTENTRYSTART () {2;}' unless defined(&XTENTRYSTART);
    if(defined(&_KERNEL)) {
	if(defined(&_J2_DEBUG)) {
	}
    }
}
1;
