require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_LANGINFO)) {
    eval 'sub _H_LANGINFO () {1;}' unless defined(&_H_LANGINFO);
    unless(defined(&_H_STANDARDS)) {
	require 'standards.ph';
    }
    unless(defined(&_H_NL_TYPES)) {
	require 'nl_types.ph';
    }
    if(defined(&_XOPEN_SOURCE)) {
	eval 'sub D_T_FMT () {1;}' unless defined(&D_T_FMT);
	eval 'sub D_FMT () {2;}' unless defined(&D_FMT);
	eval 'sub T_FMT () {3;}' unless defined(&T_FMT);
	eval 'sub AM_STR () {4;}' unless defined(&AM_STR);
	eval 'sub PM_STR () {5;}' unless defined(&PM_STR);
	eval 'sub ABDAY_1 () {6;}' unless defined(&ABDAY_1);
	eval 'sub ABDAY_2 () {7;}' unless defined(&ABDAY_2);
	eval 'sub ABDAY_3 () {8;}' unless defined(&ABDAY_3);
	eval 'sub ABDAY_4 () {9;}' unless defined(&ABDAY_4);
	eval 'sub ABDAY_5 () {10;}' unless defined(&ABDAY_5);
	eval 'sub ABDAY_6 () {11;}' unless defined(&ABDAY_6);
	eval 'sub ABDAY_7 () {12;}' unless defined(&ABDAY_7);
	eval 'sub DAY_1 () {13;}' unless defined(&DAY_1);
	eval 'sub DAY_2 () {14;}' unless defined(&DAY_2);
	eval 'sub DAY_3 () {15;}' unless defined(&DAY_3);
	eval 'sub DAY_4 () {16;}' unless defined(&DAY_4);
	eval 'sub DAY_5 () {17;}' unless defined(&DAY_5);
	eval 'sub DAY_6 () {18;}' unless defined(&DAY_6);
	eval 'sub DAY_7 () {19;}' unless defined(&DAY_7);
	eval 'sub ABMON_1 () {20;}' unless defined(&ABMON_1);
	eval 'sub ABMON_2 () {21;}' unless defined(&ABMON_2);
	eval 'sub ABMON_3 () {22;}' unless defined(&ABMON_3);
	eval 'sub ABMON_4 () {23;}' unless defined(&ABMON_4);
	eval 'sub ABMON_5 () {24;}' unless defined(&ABMON_5);
	eval 'sub ABMON_6 () {25;}' unless defined(&ABMON_6);
	eval 'sub ABMON_7 () {26;}' unless defined(&ABMON_7);
	eval 'sub ABMON_8 () {27;}' unless defined(&ABMON_8);
	eval 'sub ABMON_9 () {28;}' unless defined(&ABMON_9);
	eval 'sub ABMON_10 () {29;}' unless defined(&ABMON_10);
	eval 'sub ABMON_11 () {30;}' unless defined(&ABMON_11);
	eval 'sub ABMON_12 () {31;}' unless defined(&ABMON_12);
	eval 'sub MON_1 () {32;}' unless defined(&MON_1);
	eval 'sub MON_2 () {33;}' unless defined(&MON_2);
	eval 'sub MON_3 () {34;}' unless defined(&MON_3);
	eval 'sub MON_4 () {35;}' unless defined(&MON_4);
	eval 'sub MON_5 () {36;}' unless defined(&MON_5);
	eval 'sub MON_6 () {37;}' unless defined(&MON_6);
	eval 'sub MON_7 () {38;}' unless defined(&MON_7);
	eval 'sub MON_8 () {39;}' unless defined(&MON_8);
	eval 'sub MON_9 () {40;}' unless defined(&MON_9);
	eval 'sub MON_10 () {41;}' unless defined(&MON_10);
	eval 'sub MON_11 () {42;}' unless defined(&MON_11);
	eval 'sub MON_12 () {43;}' unless defined(&MON_12);
	eval 'sub RADIXCHAR () {44;}' unless defined(&RADIXCHAR);
	eval 'sub THOUSEP () {45;}' unless defined(&THOUSEP);
	eval 'sub YESSTR () {46;}' unless defined(&YESSTR);
	eval 'sub NOSTR () {47;}' unless defined(&NOSTR);
	eval 'sub CRNCYSTR () {48;}' unless defined(&CRNCYSTR);
	eval 'sub CODESET () {49;}' unless defined(&CODESET);
	eval 'sub T_FMT_AMPM () {55;}' unless defined(&T_FMT_AMPM);
	eval 'sub ERA () {56;}' unless defined(&ERA);
	eval 'sub ERA_D_FMT () {57;}' unless defined(&ERA_D_FMT);
	eval 'sub ERA_D_T_FMT () {58;}' unless defined(&ERA_D_T_FMT);
	eval 'sub ERA_T_FMT () {59;}' unless defined(&ERA_T_FMT);
	eval 'sub ALT_DIGITS () {60;}' unless defined(&ALT_DIGITS);
	eval 'sub YESEXPR () {61;}' unless defined(&YESEXPR);
	eval 'sub NOEXPR () {62;}' unless defined(&NOEXPR);
	if(defined(&_NO_PROTO)) {
	} else {
	}
    }
    if(defined(&_ALL_SOURCE)) {
	unless(defined(&__H_LOCALEDEF)) {
	    require 'sys/localedef.ph';
	}
	eval 'sub NLLDATE () {50;}' unless defined(&NLLDATE);
	eval 'sub NLTMISC () {51;}' unless defined(&NLTMISC);
	eval 'sub NLTSTRS () {52;}' unless defined(&NLTSTRS);
	eval 'sub NLTUNITS () {53;}' unless defined(&NLTUNITS);
	eval 'sub NLYEAR () {54;}' unless defined(&NLYEAR);
	unless(defined(&_NL_NUM_ITEMS)) {
	    eval 'sub _NL_NUM_ITEMS () {63;}' unless defined(&_NL_NUM_ITEMS);
	}
    }
}
1;
