require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_LDFCN)) {
    eval 'sub _H_LDFCN () {1;}' unless defined(&_H_LDFCN);
    unless(defined(&_LONG_LONG)) {
	die("\-qlonglong\ must\ be\ used");
    }
    require 'filehdr.ph';
    require 'scnhdr.ph';
    require 'linenum.ph';
    require 'syms.ph';
    unless(defined(&LDFILE)) {
	eval 'sub AR_TYPE_BIG () {0x1;}' unless defined(&AR_TYPE_BIG);
	eval 'sub LDFILE () {\'struct ldfile\';}' unless defined(&LDFILE);
	eval 'sub IOPTR {
	    my($x) = @_;
    	    eval q( ($x->{ioptr}));
	}' unless defined(&IOPTR);
	eval 'sub OFFSET {
	    my($x) = @_;
    	    eval q( ($x->{offset}));
	}' unless defined(&OFFSET);
	eval 'sub TYPE {
	    my($x) = @_;
    	    eval q( ($x->{type}));
	}' unless defined(&TYPE);
	eval 'sub LDFLAGS {
	    my($x) = @_;
    	    eval q( ($x->{flags}));
	}' unless defined(&LDFLAGS);
	eval 'sub HEADER {
	    my($x) = @_;
    	    eval q( ($x->{header}));
	}' unless defined(&HEADER);
	eval 'sub LDFSZ () {$sizeof{ &LDFILE};}' unless defined(&LDFSZ);
	eval 'sub AR_OFF {
	    my($x) = @_;
    	    eval q( ($x->{ar_off}));
	}' unless defined(&AR_OFF);
	eval 'sub AR_END_OFF {
	    my($x) = @_;
    	    eval q( ($x->{ar_end_off}));
	}' unless defined(&AR_END_OFF);
	eval 'sub ARTYPE () {0177545;}' unless defined(&ARTYPE);
	if(defined(&_LARGE_FILES)) {
	} else {
	}
	eval 'sub ARCHDR () { &archdr;}' unless defined(&ARCHDR);
	eval 'sub ARCHSZ () {$sizeof{ &ARCHDR};}' unless defined(&ARCHSZ);
	eval 'sub SYMTBL () {0;}' unless defined(&SYMTBL);
	eval 'sub SUCCESS () {1;}' unless defined(&SUCCESS);
	eval 'sub CLOSED () {1;}' unless defined(&CLOSED);
	eval 'sub FAILURE () {0;}' unless defined(&FAILURE);
	eval 'sub NOCLOSE () {0;}' unless defined(&NOCLOSE);
	eval 'sub BADINDEX () {-1;}' unless defined(&BADINDEX);
	eval 'sub OKFSEEK () {0;}' unless defined(&OKFSEEK);
	if(defined(&_NO_PROTO)) {
	    if(defined(&_LARGE_FILES)) {
	    } else {
	    }
	} else {
	    if(defined(&_LARGE_FILES)) {
	    } else {
	    }
	}
	eval 'sub BEGINNING () {0;}' unless defined(&BEGINNING);
	eval 'sub CURRENT () {1;}' unless defined(&CURRENT);
	eval 'sub END () {2;}' unless defined(&END);
	eval 'sub GETC {
	    my($ldptr) = @_;
    	    eval q( &getc( &IOPTR($ldptr)));
	}' unless defined(&GETC);
	eval 'sub GETW {
	    my($ldptr) = @_;
    	    eval q( &getw( &IOPTR($ldptr)));
	}' unless defined(&GETW);
	eval 'sub FEOF {
	    my($ldptr) = @_;
    	    eval q( &feof( &IOPTR($ldptr)));
	}' unless defined(&FEOF);
	eval 'sub FERROR {
	    my($ldptr) = @_;
    	    eval q( &ferror( &IOPTR($ldptr)));
	}' unless defined(&FERROR);
	eval 'sub FGETC {
	    my($ldptr) = @_;
    	    eval q( &fgetc( &IOPTR($ldptr)));
	}' unless defined(&FGETC);
	eval 'sub FGETS {
	    my($s,$n,$ldptr) = @_;
    	    eval q( &fgets($s,$n, &IOPTR($ldptr)));
	}' unless defined(&FGETS);
	eval 'sub FILENO {
	    my($ldptr) = @_;
    	    eval q( &fileno( &IOPTR($ldptr)));
	}' unless defined(&FILENO);
	eval 'sub FREAD {
	    my($p,$s,$n,$ldptr) = @_;
    	    eval q( &fread($p,$s,$n, &IOPTR($ldptr)));
	}' unless defined(&FREAD);
	eval 'sub FSEEK {
	    my($ldptr,$o,$p) = @_;
    	    eval q( &fseek( &IOPTR($ldptr),($p== &BEGINNING)?( &OFFSET($ldptr)+$o):$o,$p));
	}' unless defined(&FSEEK);
	eval 'sub FTELL {
	    my($ldptr) = @_;
    	    eval q( &ftell( &IOPTR($ldptr)));
	}' unless defined(&FTELL);
	eval 'sub FWRITE {
	    my($p,$s,$n,$ldptr) = @_;
    	    eval q( &fwrite($p,$s,$n, &IOPTR($ldptr)));
	}' unless defined(&FWRITE);
	eval 'sub REWIND {
	    my($ldptr) = @_;
    	    eval q( &rewind( &IOPTR($ldptr)));
	}' unless defined(&REWIND);
	eval 'sub SETBUF {
	    my($ldptr,$b) = @_;
    	    eval q( &setbuf( &IOPTR($ldptr),$b));
	}' unless defined(&SETBUF);
	eval 'sub UNGETC {
	    my($c,$ldptr) = @_;
    	    eval q( &ungetc($c, &IOPTR($ldptr)));
	}' unless defined(&UNGETC);
	eval 'sub STROFFSET {
	    my($ldptr) = @_;
    	    eval q(( &HEADER($ldptr). &f_symptr+ &HEADER($ldptr). &f_nsyms* &SYMESZ));
	}' unless defined(&STROFFSET);
    }
}
1;
