require '_h2ph_pre.ph';

no warnings 'redefine';

require 'sys/time.ph';
require 'sys/types.ph';
require 'sys/context.ph';
unless(defined(&_LIB_LOCK_H_)) {
    eval 'sub _LIB_LOCK_H_ () {1;}' unless defined(&_LIB_LOCK_H_);
    unless(defined(&ESUCCESS)) {
	eval 'sub ESUCCESS () {0;}' unless defined(&ESUCCESS);
    }
    unless(defined(&NO_THREAD)) {
	eval 'sub NO_THREAD () {( &lib_threadid_t)0;}' unless defined(&NO_THREAD);
    }
    eval 'sub LIB_LOCK_FUNCTION {
        my($lockstruct, $operation, $arg) = @_;
	    eval q((($lockstruct).$operation ? (*($lockstruct).$operation)($arg) :  &ESUCCESS));
    }' unless defined(&LIB_LOCK_FUNCTION);
    eval 'sub LIB_LOCK_FUNCTION0 {
        my($lockstruct, $operation) = @_;
	    eval q((($lockstruct).$operation ? (*($lockstruct).$operation)() :  &ESUCCESS));
    }' unless defined(&LIB_LOCK_FUNCTION0);
    eval 'sub LIB_LOCK_FUNCTION2 {
        my($lockstruct, $operation, $arg1, $arg2) = @_;
	    eval q((($lockstruct).$operation ? (*($lockstruct).$operation)($arg1, $arg2) :  &ESUCCESS));
    }' unless defined(&LIB_LOCK_FUNCTION2);
    eval 'sub LIB_LOCK_FUNCTION3 {
        my($lockstruct, $operation, $arg1, $arg2, $arg3) = @_;
	    eval q((($lockstruct).$operation ? (*($lockstruct).$operation)($arg1, $arg2, $arg3) :  &ESUCCESS));
    }' unless defined(&LIB_LOCK_FUNCTION3);
    eval 'sub LIB_LOCK_FUNCTION4 {
        my($lockstruct, $operation, $arg1, $arg2, $arg3, $arg4) = @_;
	    eval q((($lockstruct).$operation ? (*($lockstruct).$operation)($arg1, $arg2, $arg3, $arg4) :  &ESUCCESS));
    }' unless defined(&LIB_LOCK_FUNCTION4);
    eval 'sub LIB_LOCK_FUNCTION5 {
        my($lockstruct, $operation, $arg1, $arg2, $arg3, $arg4, $arg5) = @_;
	    eval q((($lockstruct).$operation ? (*($lockstruct).$operation)($arg1, $arg2, $arg3, $arg4, $arg5) :  &ESUCCESS));
    }' unless defined(&LIB_LOCK_FUNCTION5);
    eval 'sub LIB_LOCK_FUNCTION_TRYLOCK {
        my($lockstruct, $operation, $arg) = @_;
	    eval q((($lockstruct).$operation ? (*($lockstruct).$operation)($arg) : 1));
    }' unless defined(&LIB_LOCK_FUNCTION_TRYLOCK);
    eval 'sub lib_mutex_create {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &mutex_create, $lock));
    }' unless defined(&lib_mutex_create);
    eval 'sub lib_mutex_delete {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &mutex_delete, $lock));
    }' unless defined(&lib_mutex_delete);
    eval 'sub lib_mutex_lock {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &mutex_lock, $lock));
    }' unless defined(&lib_mutex_lock);
    eval 'sub lib_mutex_unlock {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &mutex_unlock, $lock));
    }' unless defined(&lib_mutex_unlock);
    eval 'sub lib_mutex_trylock {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION_TRYLOCK($lockstruct,  &mutex_trylock, $lock));
    }' unless defined(&lib_mutex_trylock);
    eval 'sub lib_spinlock_create {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &spinlock_create, $lock));
    }' unless defined(&lib_spinlock_create);
    eval 'sub lib_spinlock_delete {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &spinlock_delete, $lock));
    }' unless defined(&lib_spinlock_delete);
    eval 'sub lib_spinlock_lock {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &spinlock_lock, $lock));
    }' unless defined(&lib_spinlock_lock);
    eval 'sub lib_spinlock_unlock {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &spinlock_unlock, $lock));
    }' unless defined(&lib_spinlock_unlock);
    eval 'sub lib_spinlock_trylock {
        my($lockstruct, $lock) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &spinlock_trylock, $lock));
    }' unless defined(&lib_spinlock_trylock);
    eval 'sub lib_thread_id {
        my($lockstruct) = @_;
	    eval q((($lockstruct). &thread_id ? (*($lockstruct). &thread_id)() : 0));
    }' unless defined(&lib_thread_id);
    eval 'sub lib_cleanup_push {
        my($lockstruct, $_function, $lock) = @_;
	    eval q( &if (($lockstruct). &cleanup_push) { (*($lockstruct). &cleanup_push)($_function, $lock); });
    }' unless defined(&lib_cleanup_push);
    eval 'sub lib_cleanup_pop {
        my($lockstruct, $_flag) = @_;
	    eval q( &if (($lockstruct). &cleanup_pop) { (*($lockstruct). &cleanup_pop)($_flag); });
    }' unless defined(&lib_cleanup_pop);
    eval 'sub lib_atfork {
        my($lockstruct, $arg1, $arg2, $arg3) = @_;
	    eval q( &LIB_LOCK_FUNCTION3($lockstruct,  &atfork, $arg1, $arg2, $arg3));
    }' unless defined(&lib_atfork);
    eval 'sub lib_atfork_np {
        my($lockstruct, $arg1, $arg2, $arg3 ,$arg4) = @_;
	    eval q( &LIB_LOCK_FUNCTION4($lockstruct,  &atfork, $arg1, $arg2, $arg3, $arg4));
    }' unless defined(&lib_atfork_np);
    eval 'sub lib_atfork_unregister_np {
        my($lockstruct, $arg1, $arg2, $arg3, $arg4, $arg5) = @_;
	    eval q( &LIB_LOCK_FUNCTION5($lockstruct,  &atfork_unregister_np, $arg1, $arg2, $arg3, $arg4, $arg5));
    }' unless defined(&lib_atfork_unregister_np);
    eval 'sub lib_thread_exit {
        my($lockstruct, $arg1) = @_;
	    eval q( &if(($lockstruct). &thread_exit) (*($lockstruct). &thread_exit)($arg1));
    }' unless defined(&lib_thread_exit);
    eval 'sub lib_getspecific {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &getspecific, $arg1));
    }' unless defined(&lib_getspecific);
    eval 'sub lib_setspecific {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &setspecific, $arg1, $arg2));
    }' unless defined(&lib_setspecific);
    eval 'sub lib_key_create {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &key_create, $arg1, $arg2));
    }' unless defined(&lib_key_create);
    eval 'sub lib_key_delete {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &key_delete, $arg1));
    }' unless defined(&lib_key_delete);
    eval 'sub lib_once {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &once, $arg1, $arg2));
    }' unless defined(&lib_once);
    eval 'sub lib_nsleep {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &nsleep, $arg1, $arg2));
    }' unless defined(&lib_nsleep);
    eval 'sub lib_pause {
        my($lockstruct) = @_;
	    eval q( &LIB_LOCK_FUNCTION0($lockstruct,  &pause));
    }' unless defined(&lib_pause);
    eval 'sub lib_raise {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &raise, $arg1));
    }' unless defined(&lib_raise);
    eval 'sub lib_sigaction {
        my($lockstruct, $arg1, $arg2, $arg3) = @_;
	    eval q( &LIB_LOCK_FUNCTION3($lockstruct,  &sigaction, $arg1, $arg2, $arg3));
    }' unless defined(&lib_sigaction);
    eval 'sub lib_sigpending {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &sigpending, $arg1));
    }' unless defined(&lib_sigpending);
    eval 'sub lib_sigsuspend {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &sigsuspend, $arg1));
    }' unless defined(&lib_sigsuspend);
    eval 'sub lib_yield {
        my($lockstruct) = @_;
	    eval q( &LIB_LOCK_FUNCTION0($lockstruct,  &yield));
    }' unless defined(&lib_yield);
    eval 'sub lib_equal {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &equal, $arg1, $arg2));
    }' unless defined(&lib_equal);
    eval 'sub lib_setcancelstate {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &setcancelstate, $arg1, $arg2));
    }' unless defined(&lib_setcancelstate);
    eval 'sub lib_create {
        my($lockstruct, $arg1, $arg2, $arg3, $arg4) = @_;
	    eval q( &LIB_LOCK_FUNCTION4($lockstruct,  &create, $arg1, $arg2, $arg3, $arg4));
    }' unless defined(&lib_create);
    eval 'sub lib_join {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &join, $arg1, $arg2));
    }' unless defined(&lib_join);
    eval 'sub lib_testcancel {
        my($lockstruct) = @_;
	    eval q((($lockstruct). &testcancel ? (*($lockstruct). &testcancel)() : ( &void)0));
    }' unless defined(&lib_testcancel);
    eval 'sub lib_setcanceltype {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &setcanceltype, $arg1, $arg2));
    }' unless defined(&lib_setcanceltype);
    eval 'sub lib_cancel {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &cancel, $arg1));
    }' unless defined(&lib_cancel);
    eval 'sub lib_detach {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &detach, $arg1));
    }' unless defined(&lib_detach);
    eval 'sub lib_mutex_init {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &mutex_init, $arg1, $arg2));
    }' unless defined(&lib_mutex_init);
    eval 'sub lib_cond_init {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &cond_init, $arg1, $arg2));
    }' unless defined(&lib_cond_init);
    eval 'sub lib_cond_destroy {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &cond_destroy, $arg1));
    }' unless defined(&lib_cond_destroy);
    eval 'sub lib_cond_wait {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &cond_wait, $arg1, $arg2));
    }' unless defined(&lib_cond_wait);
    eval 'sub lib_cond_broadcast {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &cond_broadcast, $arg1));
    }' unless defined(&lib_cond_broadcast);
    eval 'sub lib_cond_signal {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &cond_signal, $arg1));
    }' unless defined(&lib_cond_signal);
    eval 'sub lib_chkpnt {
        my($lockstruct, $arg1, $arg2, $arg3, $arg4) = @_;
	    eval q( &LIB_LOCK_FUNCTION4($lockstruct,  &chkpnt, $arg1, $arg2, $arg3, $arg4));
    }' unless defined(&lib_chkpnt);
    eval 'sub lib_chkpnt_commit {
        my($lockstruct, $arg1, $arg2, $arg3, $arg4) = @_;
	    eval q( &LIB_LOCK_FUNCTION4($lockstruct,  &chkpnt_commit, $arg1, $arg2, $arg3, $arg4));
    }' unless defined(&lib_chkpnt_commit);
    eval 'sub lib_chkpnt_fail {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &chkpnt_fail, $arg1));
    }' unless defined(&lib_chkpnt_fail);
    eval 'sub lib_chkpnt_register {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &chkpnt_register, $arg1, $arg2));
    }' unless defined(&lib_chkpnt_register);
    eval 'sub lib_attr_init {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &attr_init, $arg1));
    }' unless defined(&lib_attr_init);
    eval 'sub lib_attr_destroy {
        my($lockstruct, $arg1) = @_;
	    eval q( &LIB_LOCK_FUNCTION($lockstruct,  &attr_destroy, $arg1));
    }' unless defined(&lib_attr_destroy);
    eval 'sub lib_attr_setdetachstate {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &attr_setdetachstate, $arg1, $arg2));
    }' unless defined(&lib_attr_setdetachstate);
    eval 'sub lib_attr_setstacksize {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &attr_setstacksize, $arg1, $arg2));
    }' unless defined(&lib_attr_setstacksize);
    eval 'sub lib_attr_setinheritsched {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &attr_setinheritsched, $arg1, $arg2));
    }' unless defined(&lib_attr_setinheritsched);
    eval 'sub lib_attr_getinheritsched {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &attr_getinheritsched, $arg1, $arg2));
    }' unless defined(&lib_attr_getinheritsched);
    eval 'sub lib_attr_setschedparam {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &attr_setschedparam, $arg1, $arg2));
    }' unless defined(&lib_attr_setschedparam);
    eval 'sub lib_attr_getschedparam {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &attr_setschedparam, $arg1, $arg2));
    }' unless defined(&lib_attr_getschedparam);
    eval 'sub lib_attr_setscope {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &attr_setscope, $arg1, $arg2));
    }' unless defined(&lib_attr_setscope);
    eval 'sub lib_attr_getscope {
        my($lockstruct, $arg1, $arg2) = @_;
	    eval q( &LIB_LOCK_FUNCTION2($lockstruct,  &attr_getscope, $arg1, $arg2));
    }' unless defined(&lib_attr_getscope);
    eval 'sub lib_suspend_others {
        my($lockstruct) = @_;
	    eval q((($lockstruct). &suspend_others ? (*($lockstruct). &suspend_others)() : 0));
    }' unless defined(&lib_suspend_others);
    eval 'sub lib_continue_others {
        my($lockstruct) = @_;
	    eval q((($lockstruct). &continue_others ? (*($lockstruct). &continue_others)() : 0));
    }' unless defined(&lib_continue_others);
    eval 'sub lib_getsigcontext {
        my($lockstruct, $arg1, $arg2, $arg3, $arg4, $arg5) = @_;
	    eval q((($lockstruct). &getsigcontext ? (*($lockstruct). &getsigcontext)($arg1, $arg2, $arg3, $arg4, $arg5) : -1));
    }' unless defined(&lib_getsigcontext);
}
1;
