require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_LOADER)) {
    eval 'sub _H_LOADER () {1;}' unless defined(&_H_LOADER);
    require 'xcoff32_64.ph';
    if(defined(&__cplusplus)) {
    }
    require 'syms.ph';
    require 'reloc.ph';
    unless(defined(&__XCOFF_HYBRID__)) {
	if(defined(&__XCOFF32__)) {
	    eval 'sub _CURRENT_LDR_VERSION () {(1);}' unless defined(&_CURRENT_LDR_VERSION);
	}
	if(defined(&__XCOFF64__)) {
	    if(defined(&__XCOFF32__)) {
		eval 'sub _CURRENT_LDR_VERSION_64 () {(2);}' unless defined(&_CURRENT_LDR_VERSION_64);
	    } else {
		eval 'sub _CURRENT_LDR_VERSION () {(2);}' unless defined(&_CURRENT_LDR_VERSION);
	    }
	    if(defined(&__XCOFF32__)) {
		eval 'sub LDHDRSZ_64 () {$sizeof{ &LDHDR_64};}' unless defined(&LDHDRSZ_64);
	    }
	}
	eval 'sub LDHDRSZ () {$sizeof{ &LDHDR};}' unless defined(&LDHDRSZ);
    } else {
	eval 'sub _CURRENT_LDR_VERSION_32 () {(1);}' unless defined(&_CURRENT_LDR_VERSION_32);
	eval 'sub _CURRENT_LDR_VERSION_64 () {(2);}' unless defined(&_CURRENT_LDR_VERSION_64);
	eval 'sub l_impoff32 () { ($_u1->{_impoff32});}' unless defined(&l_impoff32);
	eval 'sub l_stlen64 () { ($_u1->{_stlen64});}' unless defined(&l_stlen64);
	eval 'sub l_stoff32 () { ($_u2->{_x}->{_stoff32});}' unless defined(&l_stoff32);
	eval 'sub l_stlen32 () { ($_u2->{_x}->{_stlen32});}' unless defined(&l_stlen32);
	eval 'sub l_impoff64 () { ($_u2->{_impoff64});}' unless defined(&l_impoff64);
	eval 'sub LDHDRSZ_32 () {(((( &LDHDR *)0)-> ($_u2->{_x}->{_stoff32}))+$sizeof{ &_ULONG32});}' unless defined(&LDHDRSZ_32);
	eval 'sub LDHDRSZ_64 () {$sizeof{ &LDHDR};}' unless defined(&LDHDRSZ_64);
    }
    unless(defined(&__XCOFF_HYBRID__)) {
	if(defined(&__XCOFF32__)) {
	    if(defined(&__64BIT__)) {
	    } else {
	    }
	    eval 'sub l_name () { ($_l->{_l_name});}' unless defined(&l_name);
	    eval 'sub l_zeroes () { ($_l->{_l_l}->{_l_zeroes});}' unless defined(&l_zeroes);
	    unless(defined(&__XCOFF64__)) {
		eval 'sub l_nptr () { ($_l->{_l_nptr[1]});}' unless defined(&l_nptr);
	    }
	}
	if(defined(&__XCOFF64__)) {
	    unless(defined(&__64BIT__)) {
	    }
	    unless(defined(&__XCOFF32__)) {
		eval 'sub l_nptr () { ($_l->{_l_nptr});}' unless defined(&l_nptr);
	    }
	    if(defined(&__XCOFF_32_64__)) {
		eval 'sub LDSYMSZ_64 () {$sizeof{ &LDSYM_64};}' unless defined(&LDSYMSZ_64);
	    }
	}
	eval 'sub l_offset () { ($_l->{_l_l}->{_l_offset});}' unless defined(&l_offset);
    } else {
	if(defined(&__64BIT__)) {
	} else {
	}
	unless(defined(&__64BIT__)) {
	}
	eval 'sub l_name32 () { ($_l->{_l_name32});}' unless defined(&l_name32);
	eval 'sub l_zeroes32 () { ($_l->{_l_l}->{_l_zeroes32});}' unless defined(&l_zeroes32);
	eval 'sub l_offset32 () { ($_l->{_l_l}->{_l_offset32});}' unless defined(&l_offset32);
	eval 'sub l_value64 () { ($_l->{_value64});}' unless defined(&l_value64);
	eval 'sub l_offset64 () { ($_u->{_offset64});}' unless defined(&l_offset64);
	eval 'sub l_value32 () { ($_u->{_value32});}' unless defined(&l_value32);
	eval 'sub LDSYMSZ_32 () {$sizeof{ &LDSYM};}' unless defined(&LDSYMSZ_32);
	eval 'sub LDSYMSZ_64 () {$sizeof{ &LDSYM};}' unless defined(&LDSYMSZ_64);
	unless(defined(&__64BIT__)) {
	    eval 'sub l_nptr32 () { ($_l->{_l_nptr[1]});}' unless defined(&l_nptr32);
	    eval 'sub l_nptr64 () { ($_u->{_l_nptr});}' unless defined(&l_nptr64);
	}
    }
    eval 'sub LDSYMSZ () {$sizeof{ &LDSYM};}' unless defined(&LDSYMSZ);
    eval 'sub L_WEAK () {0x8;}' unless defined(&L_WEAK);
    eval 'sub L_EXPORT () {0x10;}' unless defined(&L_EXPORT);
    eval 'sub L_ENTRY () {0x20;}' unless defined(&L_ENTRY);
    eval 'sub L_IMPORT () {0x40;}' unless defined(&L_IMPORT);
    eval 'sub LDR_WEAK {
        my($x) = @_;
	    eval q((($x). &l_smtype &  &L_WEAK));
    }' unless defined(&LDR_WEAK);
    eval 'sub LDR_EXPORT {
        my($x) = @_;
	    eval q((($x). &l_smtype &  &L_EXPORT));
    }' unless defined(&LDR_EXPORT);
    eval 'sub LDR_ENTRY {
        my($x) = @_;
	    eval q((($x). &l_smtype &  &L_ENTRY));
    }' unless defined(&LDR_ENTRY);
    eval 'sub LDR_IMPORT {
        my($x) = @_;
	    eval q((($x). &l_smtype &  &L_IMPORT));
    }' unless defined(&LDR_IMPORT);
    eval 'sub LDR_TYPE {
        my($x) = @_;
	    eval q((($x). &l_smtype & 0x7));
    }' unless defined(&LDR_TYPE);
    unless(defined(&__XCOFF_HYBRID__)) {
	if(defined(&__XCOFF32__)) {
	}
	if(defined(&__XCOFF64__)) {
	}
	if(defined(&__XCOFF_32_64__)) {
	    eval 'sub LDRELSZ_64 () {$sizeof{ &LDREL_64};}' unless defined(&LDRELSZ_64);
	}
	eval 'sub LDRELSZ () {$sizeof{ &LDREL};}' unless defined(&LDRELSZ);
    } else {
	eval 'sub l_vaddr32 () { ($_u->{_s}->{_vaddr32});}' unless defined(&l_vaddr32);
	eval 'sub l_symndx32 () { ($_u->{_s}->{_symndx32});}' unless defined(&l_symndx32);
	eval 'sub l_vaddr64 () { ($_u->{_vaddr64});}' unless defined(&l_vaddr64);
	eval 'sub LDRELSZ_32 () {((( &LDREL *)0)-> &l_symndx64);}' unless defined(&LDRELSZ_32);
	eval 'sub LDRELSZ_64 () {$sizeof{ &LDREL};}' unless defined(&LDRELSZ_64);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
