require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NET_NET_MALLOC)) {
    eval 'sub _NET_NET_MALLOC () {1;}' unless defined(&_NET_NET_MALLOC);
    require 'sys/lock_def.ph';
    eval 'sub KMEMSTATS () {1;}' unless defined(&KMEMSTATS);
    eval 'sub SOCKTHRESH () {85;}' unless defined(&SOCKTHRESH);
    if(defined(&__64BIT__)) {
	eval 'sub NETMAXCPU () {(128);}' unless defined(&NETMAXCPU);
    } else {
	eval 'sub NETMAXCPU () {(64);}' unless defined(&NETMAXCPU);
    }
    eval 'sub M_WAITOK () {0x;}' unless defined(&M_WAITOK);
    eval 'sub M_NOWAIT () {0x1;}' unless defined(&M_NOWAIT);
    eval 'sub M_FREE () {0;}' unless defined(&M_FREE);
    eval 'sub M_MBUF () {1;}' unless defined(&M_MBUF);
    eval 'sub M_CLUSTER () {2;}' unless defined(&M_CLUSTER);
    eval 'sub M_SOCKET () {3;}' unless defined(&M_SOCKET);
    eval 'sub M_PCB () {4;}' unless defined(&M_PCB);
    eval 'sub M_RTABLE () {5;}' unless defined(&M_RTABLE);
    eval 'sub M_FTABLE () {6;}' unless defined(&M_FTABLE);
    eval 'sub M_IFADDR () {7;}' unless defined(&M_IFADDR);
    eval 'sub M_SOOPTS () {8;}' unless defined(&M_SOOPTS);
    eval 'sub M_SONAME () {9;}' unless defined(&M_SONAME);
    eval 'sub M_MBLK () {10;}' unless defined(&M_MBLK);
    eval 'sub M_MBDATA () {11;}' unless defined(&M_MBDATA);
    eval 'sub M_STRHEAD () {12;}' unless defined(&M_STRHEAD);
    eval 'sub M_STRQUEUE () {13;}' unless defined(&M_STRQUEUE);
    eval 'sub M_STRQBAND () {14;}' unless defined(&M_STRQBAND);
    eval 'sub M_STRMODSW () {15;}' unless defined(&M_STRMODSW);
    eval 'sub M_STRSIGS () {16;}' unless defined(&M_STRSIGS);
    eval 'sub M_STRPOLLS () {17;}' unless defined(&M_STRPOLLS);
    eval 'sub M_STROSR () {18;}' unless defined(&M_STROSR);
    eval 'sub M_STRSQ () {19;}' unless defined(&M_STRSQ);
    eval 'sub M_STREAMS () {20;}' unless defined(&M_STREAMS);
    eval 'sub M_IOV () {21;}' unless defined(&M_IOV);
    eval 'sub M_FHANDLE () {22;}' unless defined(&M_FHANDLE);
    eval 'sub M_NFSREQ () {23;}' unless defined(&M_NFSREQ);
    eval 'sub M_NFSMNT () {24;}' unless defined(&M_NFSMNT);
    eval 'sub M_FILE () {25;}' unless defined(&M_FILE);
    eval 'sub M_FILEDESC () {26;}' unless defined(&M_FILEDESC);
    eval 'sub M_IOCTLOPS () {27;}' unless defined(&M_IOCTLOPS);
    eval 'sub M_SELPOLL () {28;}' unless defined(&M_SELPOLL);
    eval 'sub M_DEVBUF () {29;}' unless defined(&M_DEVBUF);
    eval 'sub M_PATHNAME () {30;}' unless defined(&M_PATHNAME);
    eval 'sub M_KTABLE () {31;}' unless defined(&M_KTABLE);
    eval 'sub M_MOUNT () {32;}' unless defined(&M_MOUNT);
    eval 'sub M_SUPERBLK () {33;}' unless defined(&M_SUPERBLK);
    eval 'sub M_UFSMNT () {34;}' unless defined(&M_UFSMNT);
    eval 'sub M_S5MNT () {35;}' unless defined(&M_S5MNT);
    eval 'sub M_S5SUPERBLK () {36;}' unless defined(&M_S5SUPERBLK);
    eval 'sub M_VSRAD () {37;}' unless defined(&M_VSRAD);
    eval 'sub M_SPECINFO () {38;}' unless defined(&M_SPECINFO);
    eval 'sub M_SPECALIAS () {39;}' unless defined(&M_SPECALIAS);
    eval 'sub M_SPECBUF () {40;}' unless defined(&M_SPECBUF);
    eval 'sub M_LOCKF () {41;}' unless defined(&M_LOCKF);
    eval 'sub M_DEVSW () {42;}' unless defined(&M_DEVSW);
    eval 'sub M_IPSEC () {43;}' unless defined(&M_IPSEC);
    eval 'sub M_KALLOC () {48;}' unless defined(&M_KALLOC);
    eval 'sub M_TEMP () {49;}' unless defined(&M_TEMP);
    eval 'sub M_IPMOPTS () {50;}' unless defined(&M_IPMOPTS);
    eval 'sub M_IPMADDR () {51;}' unless defined(&M_IPMADDR);
    eval 'sub M_IFMADDR () {52;}' unless defined(&M_IFMADDR);
    eval 'sub M_LAST () {53;}' unless defined(&M_LAST);
    eval 'sub KMEMNAMSZ () {12;}' unless defined(&KMEMNAMSZ);
    eval 'sub INITKMEMNAMES () {{ "free", "mbuf", "mcluster", "socket", "pcb", "routetbl", "fragtbl", "ifaddr", "soopts", "soname", "mblk", "mblkdata", "strhead", "strqueue", "strqband", "strmodsw", "strsigs", "strpoll", "strosr", "strsyncq", "streams", "iov", "fhandle", "NFS req", "NFS mount", "file", "file desc", "ioctlops", "select/poll", "devbuf", "pathname", "kernel table", "mount", "superblock", "UFS mount", "S5FS mount", "S5FS superbk", "vnode", "spec info", "spec alias", "spec buf", "locking", "devsw", "", "", "", "", "", "kalloc", "temp", "mcast opts", "mcast addrs", "ll mc addrs", };}' unless defined(&INITKMEMNAMES);
    if(defined(&_KERNEL)) {
	if(defined(&_AIX_FULLOSF)) {
	    require 'kern/lock.ph';
	} else {
	    require 'sys/param.ph';
	}
    }
    eval 'sub MINBUCKET () {5;}' unless defined(&MINBUCKET);
    eval 'sub MAXBUCKET () {( &MINBUCKET+15);}' unless defined(&MAXBUCKET);
    eval 'sub BUCKETSPERCPU () {( &MAXBUCKET+1);}' unless defined(&BUCKETSPERCPU);
    if(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub ku_freecnt () { ($ku_un->{freecnt});}' unless defined(&ku_freecnt);
    eval 'sub ku_pagecnt () { ($ku_un->{pagecnt});}' unless defined(&ku_pagecnt);
    if(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub KMEM_CACHE_LINE () {(128/$sizeof{\'long\'});}' unless defined(&KMEM_CACHE_LINE);
    if(defined(&_KERNEL)) {
	if(defined(&__64BIT__)) {
	    eval 'sub MAXNETKMEM () {(260);}' unless defined(&MAXNETKMEM);
	} else {
	    eval 'sub MAXNETKMEM () {(4);}' unless defined(&MAXNETKMEM);
	}
	undef(&alloc_lock) if defined(&alloc_lock);
    }
    if(defined(&_KERNEL)) {
	eval 'sub MINALLOCSIZE () {(1<<  &MINBUCKET);}' unless defined(&MINALLOCSIZE);
	if(defined(&_POWER)) {
	    if(defined(&__64BIT)) {
		if(!defined( &__cplusplus)) {
		}
		eval 'sub BUCKETINDX {
		    my($size) = @_;
    		    eval q();
		}' unless defined(&BUCKETINDX);
	    } else {
		if(!defined( &__cplusplus)) {
		}
		eval 'sub BUCKETINDX {
		    my($size) = @_;
    		    eval q(( ($size) == 256? ( &MINBUCKET + 3) : ($size) ? (  &cntlz32($size-1) > ( 32-  &MINBUCKET) ?  &MINBUCKET :  &cntlz32($size-1) < ( 32-  &MAXBUCKET) ?  &MAXBUCKET : (32-  &cntlz32($size-1)) ) :  &MINBUCKET ));
		}' unless defined(&BUCKETINDX);
	    }
	} else {
	    eval 'sub BUCKETINDX {
	        my($size) = @_;
    		eval q(( ($size) == 256? ( &MINBUCKET + 3) : ($size) == 4096? ( &MINBUCKET + 7) : ($size) <= ( &MINALLOCSIZE * 128) ? ($size) <= ( &MINALLOCSIZE * 8) ? ($size) <= ( &MINALLOCSIZE * 2) ? ($size) <= ( &MINALLOCSIZE * 1) ? ( &MINBUCKET + 0) : ( &MINBUCKET + 1) : ($size) <= ( &MINALLOCSIZE * 4) ? ( &MINBUCKET + 2) : ( &MINBUCKET + 3) : ($size) <= ( &MINALLOCSIZE* 32) ? ($size) <= ( &MINALLOCSIZE * 16) ? ( &MINBUCKET + 4) : ( &MINBUCKET + 5) : ($size) <= ( &MINALLOCSIZE * 64) ? ( &MINBUCKET + 6) : ( &MINBUCKET + 7) : ($size) <= ( &MINALLOCSIZE * 2048) ? ($size) <= ( &MINALLOCSIZE * 512) ? ($size) <= ( &MINALLOCSIZE * 256) ? ( &MINBUCKET + 8) : ( &MINBUCKET + 9) : ($size) <= ( &MINALLOCSIZE * 1024) ? ( &MINBUCKET + 10) : ( &MINBUCKET + 11) : ($size) <= ( &MINALLOCSIZE * 8192) ? ($size) <= ( &MINALLOCSIZE * 4096) ? ( &MINBUCKET + 12) : ( &MINBUCKET + 13) : ($size) <= ( &MINALLOCSIZE * 16384) ? ( &MINBUCKET + 14) :  &MAXBUCKET ));
	    }' unless defined(&BUCKETINDX);
	}
	unless(defined(&PAGE_SIZE)) {
	    eval 'sub PAGE_SIZE () {4096;}' unless defined(&PAGE_SIZE);
	}
	eval 'sub BTOSRAD {
	    my($addr) = @_;
    	    eval q(( &mynetkmem()-> $kmemusage_srad[ &SEGNUMBER($addr) -  &SEGNUMBER( &netkmembase)]));
	}' unless defined(&BTOSRAD);
	eval 'sub btokup {
	    my($addr) = @_;
    	    eval q(( &BTOSRAD(($addr))-> $kmemusage[(( &void *)($addr) -  &BTOSRAD(($addr))-> &kmembase)/ &PAGE_SIZE]));
	}' unless defined(&btokup);
	eval 'sub MALLOC {
	    my($space, $cast, $size, $type, $flags) = @_;
    	    eval q(($space) = ($cast) &net_malloc(($size), $type, $flags));
	}' unless defined(&MALLOC);
	eval 'sub MALLOC_SRAD {
	    my($space, $cast, $size, $type, $flags, $srad) = @_;
    	    eval q(($space) = ($cast) &net_malloc_srad(($size), $type, $flags,$srad));
	}' unless defined(&MALLOC_SRAD);
	eval 'sub FREE {
	    my($addr, $type) = @_;
    	    eval q( &net_free(( &void *)($addr), $type));
	}' unless defined(&FREE);
	eval 'sub NET_MALLOC {
	    my($p,$c,$s,$t,$f) = @_;
    	    eval q( &MALLOC($p,$c,$s,$t,$f));
	}' unless defined(&NET_MALLOC);
	eval 'sub NET_MALLOC_SRAD {
	    my($p,$c,$s,$t,$f,$g) = @_;
    	    eval q( &MALLOC_SRAD($p,$c,$s,$t,$f,$g));
	}' unless defined(&NET_MALLOC_SRAD);
	eval 'sub NET_FREE {
	    my($p,$t) = @_;
    	    eval q( &FREE($p,$t));
	}' unless defined(&NET_FREE);
    }
}
1;
