require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NET_NETISR_H)) {
    eval 'sub _NET_NETISR_H () {1;}' unless defined(&_NET_NETISR_H);
    eval 'sub NETISR_WILD () {0;}' unless defined(&NETISR_WILD);
    eval 'sub NETISR_OTHER () {1;}' unless defined(&NETISR_OTHER);
    eval 'sub NETISR_ARP () {2;}' unless defined(&NETISR_ARP);
    eval 'sub NETISR_IP () {3;}' unless defined(&NETISR_IP);
    eval 'sub NETISR_NS () {4;}' unless defined(&NETISR_NS);
    eval 'sub NETISR_ISO () {5;}' unless defined(&NETISR_ISO);
    eval 'sub NETISR_MB () {6;}' unless defined(&NETISR_MB);
    eval 'sub NETISR_STREAMS () {7;}' unless defined(&NETISR_STREAMS);
    eval 'sub NETISR_STRTO () {8;}' unless defined(&NETISR_STRTO);
    eval 'sub NETISR_STRWELD () {9;}' unless defined(&NETISR_STRWELD);
    eval 'sub NETISR_PFFAST () {10;}' unless defined(&NETISR_PFFAST);
    eval 'sub NETISR_PFSLOW () {11;}' unless defined(&NETISR_PFSLOW);
    eval 'sub NETISR_IFSLOW () {12;}' unless defined(&NETISR_IFSLOW);
    eval 'sub NETISR_ARPTMO () {13;}' unless defined(&NETISR_ARPTMO);
    eval 'sub NETISR_WRITE () {14;}' unless defined(&NETISR_WRITE);
    eval 'sub NETISR_MBLK () {15;}' unless defined(&NETISR_MBLK);
    eval 'sub NETISR_NDD () {16;}' unless defined(&NETISR_NDD);
    eval 'sub NETISR_STRFUNNEL () {17;}' unless defined(&NETISR_STRFUNNEL);
    eval 'sub NETISR_PFCTLINPUT () {18;}' unless defined(&NETISR_PFCTLINPUT);
    eval 'sub NETISR_SQH () {19;}' unless defined(&NETISR_SQH);
    eval 'sub NETISR_CSIGNAL () {21;}' unless defined(&NETISR_CSIGNAL);
    eval 'sub NETISR_ROUTE () {22;}' unless defined(&NETISR_ROUTE);
    eval 'sub NETISR_DGD () {23;}' unless defined(&NETISR_DGD);
    eval 'sub NETISR_DGD_RETRY () {24;}' unless defined(&NETISR_DGD_RETRY);
    eval 'sub NETISR_UDIMA () {25;}' unless defined(&NETISR_UDIMA);
    eval 'sub NETISR_UDINETMAP () {26;}' unless defined(&NETISR_UDINETMAP);
    eval 'sub NETISR_PMTU () {27;}' unless defined(&NETISR_PMTU);
    eval 'sub NNETISR () {(4096/$sizeof{\'struct netisr\'});}' unless defined(&NNETISR);
    if(defined(&_KERNEL)) {
	if(defined(&_AIX_FULLOSF)) {
	    require 'kern/queue.ph';
	    require 'kern/thread.ph';
	    require 'kern/sched_prim.ph';
	} else {
	    eval 'sub EVENT_NETISR () {0x726;}' unless defined(&EVENT_NETISR);
	}
	eval 'sub schednetisr {
	    my($num) = @_;
    	    eval q( &do { \'struct netisr\' * &netisr; \'int\'  &server = 0;  &NETISR_LOCK_DECL()  &NETISR_LOCK();  &if (( &netisr =  &which_netisr($num))  && (++ ($netisr->{pending}) +  ($netisr->{active})) == 1) {  &remque( &netisr);  &queue_init( &netisr);  &insque( &netisr,  ($netisr_active->{prev}));  &if ( &netisr_servers !=  &EVENT_NULL)  &server = 1;  &else ++ ($netisr_active->{noserver}); }  &NETISR_UNLOCK();  &if ( &server)  &e_wakeup_one( &netisr_servers); }  &while (0));
	}' unless defined(&schednetisr);
	eval 'sub which_netisr {
	    my($num) = @_;
    	    eval q((($num) <  &NNETISR ?  $netisr_table[$num] :  &netisr_lookup($num)));
	}' unless defined(&which_netisr);
	eval 'sub NETISR_LOCK_DECL () {
	    eval q(\'int\'  &_ns;);
	}' unless defined(&NETISR_LOCK_DECL);
	eval 'sub NETISR_LOCKINIT () {
	    eval q({  &lock_alloc( &netisr_slock,  &LOCK_ALLOC_PIN,  &NETISR_LOCK_FAMILY, -1);  &simple_lock_init( &netisr_slock); });
	}' unless defined(&NETISR_LOCKINIT);
	eval 'sub NETISR_LOCK () {
	    eval q( &_ns =  &disable_lock( &INTMAX,  &netisr_slock));
	}' unless defined(&NETISR_LOCK);
	eval 'sub NETISR_UNLOCK () {
	    eval q( &unlock_enable( &_ns,  &netisr_slock));
	}' unless defined(&NETISR_UNLOCK);
	if(defined(&_AIX)) {
	    eval 'sub NETISR_MAX () {($sizeof{\'unsigned long\'} *  &NBPB);}' unless defined(&NETISR_MAX);
	    eval 'sub NET_KPROC () {0;}' unless defined(&NET_KPROC);
	    eval 'sub NET_OFF_LEVEL () {1;}' unless defined(&NET_OFF_LEVEL);
	    eval 'sub NET_WILD_TYPE () {0xffff;}' unless defined(&NET_WILD_TYPE);
	    eval 'sub MAX_NITS () {32;}' unless defined(&MAX_NITS);
	}
    }
}
1;
