require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_ICMP6_H_)) {
    eval 'sub _NETINET_ICMP6_H_ () {1;}' unless defined(&_NETINET_ICMP6_H_);
    eval 'sub icmp6_data32 () { ($icmp6_dataun->{icmp6_un_data32});}' unless defined(&icmp6_data32);
    eval 'sub icmp6_data16 () { ($icmp6_dataun->{icmp6_un_data16});}' unless defined(&icmp6_data16);
    eval 'sub icmp6_data8 () { ($icmp6_dataun->{icmp6_un_data8});}' unless defined(&icmp6_data8);
    eval 'sub icmp6_pptr () { $icmp6_data32[0];}' unless defined(&icmp6_pptr);
    eval 'sub icmp6_mtu () { $icmp6_data32[0];}' unless defined(&icmp6_mtu);
    eval 'sub icmp6_id () { $icmp6_data16[0];}' unless defined(&icmp6_id);
    eval 'sub icmp6_seq () { $icmp6_data16[1];}' unless defined(&icmp6_seq);
    eval 'sub icmp6_maxdelay () { $icmp6_data16[0];}' unless defined(&icmp6_maxdelay);
    eval 'sub ICMPV6_DEST_UNREACH () {1;}' unless defined(&ICMPV6_DEST_UNREACH);
    eval 'sub ICMPV6_PACKET_TOOBIG () {2;}' unless defined(&ICMPV6_PACKET_TOOBIG);
    eval 'sub ICMPV6_TIME_EXCEEDED () {3;}' unless defined(&ICMPV6_TIME_EXCEEDED);
    eval 'sub ICMPV6_PARAMPROB () {4;}' unless defined(&ICMPV6_PARAMPROB);
    eval 'sub ICMPV6_INFOMSG_MASK () {0x80;}' unless defined(&ICMPV6_INFOMSG_MASK);
    eval 'sub ICMPV6_ECHOREQUEST () {128;}' unless defined(&ICMPV6_ECHOREQUEST);
    eval 'sub ICMPV6_ECHOREPLY () {129;}' unless defined(&ICMPV6_ECHOREPLY);
    eval 'sub ICMPV6_MGM_QUERY () {130;}' unless defined(&ICMPV6_MGM_QUERY);
    eval 'sub ICMPV6_MGM_REPORT () {131;}' unless defined(&ICMPV6_MGM_REPORT);
    eval 'sub ICMPV6_MGM_REDUCTION () {132;}' unless defined(&ICMPV6_MGM_REDUCTION);
    eval 'sub ICMPV6_DEST_UNREACH_NOROUTE () {0;}' unless defined(&ICMPV6_DEST_UNREACH_NOROUTE);
    eval 'sub ICMPV6_DEST_UNREACH_ADMIN () {1;}' unless defined(&ICMPV6_DEST_UNREACH_ADMIN);
    eval 'sub ICMPV6_DEST_UNREACH_NOTNEIGHBOR () {2;}' unless defined(&ICMPV6_DEST_UNREACH_NOTNEIGHBOR);
    eval 'sub ICMPV6_DEST_UNREACH_ADDR () {3;}' unless defined(&ICMPV6_DEST_UNREACH_ADDR);
    eval 'sub ICMPV6_DEST_UNREACH_NOPORT () {4;}' unless defined(&ICMPV6_DEST_UNREACH_NOPORT);
    eval 'sub ICMPV6_TIME_EXCEEDED_HOPS () {0;}' unless defined(&ICMPV6_TIME_EXCEEDED_HOPS);
    eval 'sub ICMPV6_TIME_EXCEEDED_REASSEMBLY () {1;}' unless defined(&ICMPV6_TIME_EXCEEDED_REASSEMBLY);
    eval 'sub ICMPV6_PARAMPROB_HEADER () {0;}' unless defined(&ICMPV6_PARAMPROB_HEADER);
    eval 'sub ICMPV6_PARAMPROB_NEXTHEADER () {1;}' unless defined(&ICMPV6_PARAMPROB_NEXTHEADER);
    eval 'sub ICMPV6_PARAMPROB_OPTION () {2;}' unless defined(&ICMPV6_PARAMPROB_OPTION);
    eval 'sub ND6_ROUTER_SOLICITATION () {133;}' unless defined(&ND6_ROUTER_SOLICITATION);
    eval 'sub ND6_ROUTER_ADVERTISEMENT () {134;}' unless defined(&ND6_ROUTER_ADVERTISEMENT);
    eval 'sub ND6_NEIGHBOR_SOLICITATION () {135;}' unless defined(&ND6_NEIGHBOR_SOLICITATION);
    eval 'sub ND6_NEIGHBOR_ADVERTISEMENT () {136;}' unless defined(&ND6_NEIGHBOR_ADVERTISEMENT);
    eval 'sub ND6_REDIRECT () {137;}' unless defined(&ND6_REDIRECT);
    eval("sub ND6_OPT_SOURCE_LINKADDR () { 1; }") unless defined(&ND6_OPT_SOURCE_LINKADDR);
    eval("sub ND6_OPT_TARGET_LINKADDR () { 2; }") unless defined(&ND6_OPT_TARGET_LINKADDR);
    eval("sub ND6_OPT_PREFIX_INFORMATION () { 3; }") unless defined(&ND6_OPT_PREFIX_INFORMATION);
    eval("sub ND6_OPT_REDIRECTED_HEADER () { 4; }") unless defined(&ND6_OPT_REDIRECTED_HEADER);
    eval("sub ND6_OPT_MTU () { 5; }") unless defined(&ND6_OPT_MTU);
    eval("sub ND6_OPT_ENDOFLIST () { 256; }") unless defined(&ND6_OPT_ENDOFLIST);
    eval 'sub rsol_type () { ($rsol_hdr->{icmp6_type});}' unless defined(&rsol_type);
    eval 'sub rsol_code () { ($rsol_hdr->{icmp6_code});}' unless defined(&rsol_code);
    eval 'sub rsol_cksum () { ($rsol_hdr->{icmp6_cksum});}' unless defined(&rsol_cksum);
    eval 'sub rsol_reserved () { ($rsol_hdr->{icmp6_data32[0]});}' unless defined(&rsol_reserved);
    eval 'sub radv_type () { ($radv_hdr->{icmp6_type});}' unless defined(&radv_type);
    eval 'sub radv_code () { ($radv_hdr->{icmp6_code});}' unless defined(&radv_code);
    eval 'sub radv_cksum () { ($radv_hdr->{icmp6_cksum});}' unless defined(&radv_cksum);
    eval 'sub radv_maxhoplimit () { ($radv_hdr->{icmp6_data8[0]});}' unless defined(&radv_maxhoplimit);
    eval 'sub radv_m_o_res () { ($radv_hdr->{icmp6_data8[1]});}' unless defined(&radv_m_o_res);
    eval 'sub ND6_RADV_M_BIT () {0x80;}' unless defined(&ND6_RADV_M_BIT);
    eval 'sub ND6_RADV_O_BIT () {0x40;}' unless defined(&ND6_RADV_O_BIT);
    eval 'sub radv_router_lifetime () { ($radv_hdr->{icmp6_data16[1]});}' unless defined(&radv_router_lifetime);
    eval 'sub nadv6_flags () { ($nadv6_hdr->{icmp6_data32[0]});}' unless defined(&nadv6_flags);
    eval 'sub ND6_NADVERFLAG_ISROUTER () {0x80000000;}' unless defined(&ND6_NADVERFLAG_ISROUTER);
    eval 'sub ND6_NADVERFLAG_SOLICITED () {0x40000000;}' unless defined(&ND6_NADVERFLAG_SOLICITED);
    eval 'sub ND6_NADVERFLAG_OVERRIDE () {0x20000000;}' unless defined(&ND6_NADVERFLAG_OVERRIDE);
    eval 'sub ND_OPT_SOURCE_LINKADDR () {1;}' unless defined(&ND_OPT_SOURCE_LINKADDR);
    eval 'sub ND_OPT_TARGET_LINKADDR () {2;}' unless defined(&ND_OPT_TARGET_LINKADDR);
    eval 'sub ND_OPT_PREFIX_INFORMATION () {3;}' unless defined(&ND_OPT_PREFIX_INFORMATION);
    eval 'sub ND_OPT_REDIRECTED_HEADER () {4;}' unless defined(&ND_OPT_REDIRECTED_HEADER);
    eval 'sub ND_OPT_MTU () {5;}' unless defined(&ND_OPT_MTU);
    eval 'sub ND6_OPT_PI_L_BIT () {0x80;}' unless defined(&ND6_OPT_PI_L_BIT);
    eval 'sub ND6_OPT_PI_A_BIT () {0x40;}' unless defined(&ND6_OPT_PI_A_BIT);
}
1;
