require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ETHER_ADDR)) {
    eval 'sub _ETHER_ADDR () {1;}' unless defined(&_ETHER_ADDR);
    require 'sys/types.ph';
}
unless(defined(&_ARPA_INET_ONLY)) {
    unless(defined(&_NETINET_IF_ETHER_H)) {
	eval 'sub _NETINET_IF_ETHER_H () {1;}' unless defined(&_NETINET_IF_ETHER_H);
	unless(defined(&_SYS_CDLI_H)) {
	    require 'sys/cdli.ph';
	}
	unless(defined(&_NET_ND_LAN_H)) {
	    require 'net/nd_lan.ph';
	}
	eval 'sub mac_dst_802_3 () { &ie3_mac_dst;}' unless defined(&mac_dst_802_3);
	eval 'sub mac_src_802_3 () { &ie3_mac_src;}' unless defined(&mac_src_802_3);
	eval 'sub mac_len_802_3 () { &ie3_mac_len;}' unless defined(&mac_len_802_3);
	eval 'sub ETHERTYPE_PUP () {0x200;}' unless defined(&ETHERTYPE_PUP);
	eval 'sub ETHERTYPE_IP () {0x800;}' unless defined(&ETHERTYPE_IP);
	eval 'sub ETHERTYPE_ARP () {0x806;}' unless defined(&ETHERTYPE_ARP);
	eval 'sub ETHERTYPE_REVARP () {0x8035;}' unless defined(&ETHERTYPE_REVARP);
	eval 'sub ETHERTYPE_NETWARE () {0x8137;}' unless defined(&ETHERTYPE_NETWARE);
	eval 'sub ETHERTYPE_NS () {0x600;}' unless defined(&ETHERTYPE_NS);
	eval 'sub _802_3_TYPE_AP () { &SNAP_TYPE_AP;}' unless defined(&_802_3_TYPE_AP);
	eval 'sub _802_3_TYPE_IP () { &SNAP_TYPE_IP;}' unless defined(&_802_3_TYPE_IP);
	eval 'sub _802_3_TYPE_ARP () { &SNAP_TYPE_ARP;}' unless defined(&_802_3_TYPE_ARP);
	eval 'sub ETHERTYPE_TRAIL () {0x1000;}' unless defined(&ETHERTYPE_TRAIL);
	eval 'sub ETHERTYPE_NTRAILER () {16;}' unless defined(&ETHERTYPE_NTRAILER);
	eval 'sub ETHER_ADDRLEN () {6;}' unless defined(&ETHER_ADDRLEN);
	eval 'sub ETH_FRAMECHARS () {12;}' unless defined(&ETH_FRAMECHARS);
	eval 'sub ETHERMTU () {1500;}' unless defined(&ETHERMTU);
	eval 'sub ETHERMIN () {(60-14);}' unless defined(&ETHERMIN);
	eval 'sub arp_hrd () { ($ea_hdr->{ar_hrd});}' unless defined(&arp_hrd);
	eval 'sub arp_pro () { ($ea_hdr->{ar_pro});}' unless defined(&arp_pro);
	eval 'sub arp_hln () { ($ea_hdr->{ar_hln});}' unless defined(&arp_hln);
	eval 'sub arp_pln () { ($ea_hdr->{ar_pln});}' unless defined(&arp_pln);
	eval 'sub arp_op () { ($ea_hdr->{ar_op});}' unless defined(&arp_op);
	if(defined(&_KERNEL)) {
	    if(defined(&IP_MULTICAST)) {
		eval 'sub ETHER_MAP_IP_MULTICAST {
		    my($ipaddr, $enaddr) = @_;
    		    eval q({ [0] = 0x1; [1] = 0x; [2] = 0x5e; [3] = [1] & 0x7f; [4] = [2]; [5] = ($ipaddr)[3]; });
		}' unless defined(&ETHER_MAP_IP_MULTICAST);
	    }
	}
    }
}
1;
