require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IN_H_)) {
    eval 'sub _NETINET_IN_H_ () {1;}' unless defined(&_NETINET_IN_H_);
    require 'standards.ph';
    require 'sys/types.ph';
    if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0) == 1) {
	unless(defined(&_IP_TYPES_T)) {
	    eval 'sub _IP_TYPES_T () {1;}' unless defined(&_IP_TYPES_T);
	}
	unless(defined(&_IN_ADDR_STRUCT)) {
	    eval 'sub _IN_ADDR_STRUCT () {1;}' unless defined(&_IN_ADDR_STRUCT);
	}
	unless(defined(&_SA_FAMILY_T)) {
	    eval 'sub _SA_FAMILY_T () {1;}' unless defined(&_SA_FAMILY_T);
	}
	eval 'sub IPPROTO_IP () {0;}' unless defined(&IPPROTO_IP);
	eval 'sub IPPROTO_HOPOPTS () {0;}' unless defined(&IPPROTO_HOPOPTS);
	eval 'sub IPPROTO_ICMP () {1;}' unless defined(&IPPROTO_ICMP);
	eval 'sub IPPROTO_IGMP () {2;}' unless defined(&IPPROTO_IGMP);
	eval 'sub IPPROTO_GGP () {3;}' unless defined(&IPPROTO_GGP);
	eval 'sub IPPROTO_IPIP () {4;}' unless defined(&IPPROTO_IPIP);
	eval 'sub IPPROTO_TCP () {6;}' unless defined(&IPPROTO_TCP);
	eval 'sub IPPROTO_EGP () {8;}' unless defined(&IPPROTO_EGP);
	eval 'sub IPPROTO_PUP () {12;}' unless defined(&IPPROTO_PUP);
	eval 'sub IPPROTO_UDP () {17;}' unless defined(&IPPROTO_UDP);
	eval 'sub IPPROTO_IDP () {22;}' unless defined(&IPPROTO_IDP);
	eval 'sub IPPROTO_TP () {29;}' unless defined(&IPPROTO_TP);
	eval 'sub IPPROTO_IPV6 () {41;}' unless defined(&IPPROTO_IPV6);
	eval 'sub IPPROTO_ROUTING () {43;}' unless defined(&IPPROTO_ROUTING);
	eval 'sub IPPROTO_FRAGMENT () {44;}' unless defined(&IPPROTO_FRAGMENT);
	eval 'sub IPPROTO_QOS () {45;}' unless defined(&IPPROTO_QOS);
	eval 'sub IPPROTO_RSVP () {46;}' unless defined(&IPPROTO_RSVP);
	eval 'sub IPPROTO_ESP () {50;}' unless defined(&IPPROTO_ESP);
	eval 'sub IPPROTO_AH () {51;}' unless defined(&IPPROTO_AH);
	eval 'sub IPPROTO_ICMPV6 () {58;}' unless defined(&IPPROTO_ICMPV6);
	eval 'sub IPPROTO_NONE () {59;}' unless defined(&IPPROTO_NONE);
	eval 'sub IPPROTO_DSTOPTS () {60;}' unless defined(&IPPROTO_DSTOPTS);
	eval 'sub IPPROTO_LOCAL () {63;}' unless defined(&IPPROTO_LOCAL);
	eval 'sub IPPROTO_EON () {80;}' unless defined(&IPPROTO_EON);
	eval 'sub IPPROTO_BIP () {0x53;}' unless defined(&IPPROTO_BIP);
	eval 'sub IPPROTO_RAW () {255;}' unless defined(&IPPROTO_RAW);
	eval 'sub IPPROTO_MAX () {256;}' unless defined(&IPPROTO_MAX);
	eval 'sub INADDR_ANY () {( &uint32_t)0x;}' unless defined(&INADDR_ANY);
	eval 'sub INADDR_BROADCAST () {( &uint32_t)0xffffffff;}' unless defined(&INADDR_BROADCAST);
	unless(defined(&_KERNEL)) {
	    eval 'sub INADDR_NONE () {0xffffffff;}' unless defined(&INADDR_NONE);
	}
	eval 'sub IPPORT_RESERVED () {1024;}' unless defined(&IPPORT_RESERVED);
	eval 'sub IPPORT_USERRESERVED () {5000;}' unless defined(&IPPORT_USERRESERVED);
	eval 'sub IPPORT_TIMESERVER () {37;}' unless defined(&IPPORT_TIMESERVER);
	eval 'sub IN_CLASSA {
	    my($i) = @_;
    	    eval q(((( &int32_t)($i) & 0x80000000) == 0));
	}' unless defined(&IN_CLASSA);
	eval 'sub IN_CLASSA_NET () {0xff000000;}' unless defined(&IN_CLASSA_NET);
	eval 'sub IN_CLASSA_NSHIFT () {24;}' unless defined(&IN_CLASSA_NSHIFT);
	eval 'sub IN_CLASSA_HOST () {0xffffff;}' unless defined(&IN_CLASSA_HOST);
	eval 'sub IN_CLASSA_MAX () {128;}' unless defined(&IN_CLASSA_MAX);
	eval 'sub IN_CLASSB {
	    my($i) = @_;
    	    eval q(((( &int32_t)($i) & 0xc0000000) == 0x80000000));
	}' unless defined(&IN_CLASSB);
	eval 'sub IN_CLASSB_NET () {0xffff0000;}' unless defined(&IN_CLASSB_NET);
	eval 'sub IN_CLASSB_NSHIFT () {16;}' unless defined(&IN_CLASSB_NSHIFT);
	eval 'sub IN_CLASSB_HOST () {0xffff;}' unless defined(&IN_CLASSB_HOST);
	eval 'sub IN_CLASSB_MAX () {65536;}' unless defined(&IN_CLASSB_MAX);
	eval 'sub IN_CLASSC {
	    my($i) = @_;
    	    eval q(((( &int32_t)($i) & 0xe0000000) == 0xc0000000));
	}' unless defined(&IN_CLASSC);
	eval 'sub IN_CLASSC_NET () {0xffffff00;}' unless defined(&IN_CLASSC_NET);
	eval 'sub IN_CLASSC_NSHIFT () {8;}' unless defined(&IN_CLASSC_NSHIFT);
	eval 'sub IN_CLASSC_HOST () {0xff;}' unless defined(&IN_CLASSC_HOST);
	eval 'sub IN_CLASSD {
	    my($i) = @_;
    	    eval q(((( &int32_t)($i) & 0xf0000000) == 0xe0000000));
	}' unless defined(&IN_CLASSD);
	eval 'sub IN_MULTICAST {
	    my($i) = @_;
    	    eval q( &IN_CLASSD($i));
	}' unless defined(&IN_MULTICAST);
	eval 'sub IN_CLASSD_NET () {0xf0000000;}' unless defined(&IN_CLASSD_NET);
	eval 'sub IN_CLASSD_NSHIFT () {28;}' unless defined(&IN_CLASSD_NSHIFT);
	eval 'sub IN_CLASSD_HOST () {0xfffffff;}' unless defined(&IN_CLASSD_HOST);
	eval 'sub INADDR_UNSPEC_GROUP () {( &uint32_t)0xe0000000;}' unless defined(&INADDR_UNSPEC_GROUP);
	eval 'sub INADDR_ALLHOSTS_GROUP () {( &uint32_t)0xe0000001;}' unless defined(&INADDR_ALLHOSTS_GROUP);
	eval 'sub INADDR_ALLRTRS_GROUP () {( &uint32_t)0xe0000002;}' unless defined(&INADDR_ALLRTRS_GROUP);
	eval 'sub INADDR_MAX_LOCAL_GROUP () {( &uint32_t)0xe00000ff;}' unless defined(&INADDR_MAX_LOCAL_GROUP);
	eval 'sub IN_EXPERIMENTAL {
	    my($i) = @_;
    	    eval q(((( &int32_t)($i) & 0xe0000000) == 0xe0000000));
	}' unless defined(&IN_EXPERIMENTAL);
	eval 'sub IN_BADCLASS {
	    my($i) = @_;
    	    eval q(((( &int32_t)($i) & 0xf0000000) == 0xf0000000));
	}' unless defined(&IN_BADCLASS);
	eval 'sub IN_LOOPBACKNET () {127;}' unless defined(&IN_LOOPBACKNET);
	eval 'sub IP_OPTIONS () {1;}' unless defined(&IP_OPTIONS);
	eval 'sub IP_HDRINCL () {2;}' unless defined(&IP_HDRINCL);
	eval 'sub IP_TOS () {3;}' unless defined(&IP_TOS);
	eval 'sub IP_TTL () {4;}' unless defined(&IP_TTL);
	eval 'sub IP_UNICAST_HOPS () { &IP_TTL;}' unless defined(&IP_UNICAST_HOPS);
	eval 'sub IP_RECVOPTS () {5;}' unless defined(&IP_RECVOPTS);
	eval 'sub IP_RECVRETOPTS () {6;}' unless defined(&IP_RECVRETOPTS);
	eval 'sub IP_RECVDSTADDR () {7;}' unless defined(&IP_RECVDSTADDR);
	eval 'sub IP_RETOPTS () {8;}' unless defined(&IP_RETOPTS);
	eval 'sub IP_MULTICAST_IF () {9;}' unless defined(&IP_MULTICAST_IF);
	eval 'sub IP_MULTICAST_TTL () {10;}' unless defined(&IP_MULTICAST_TTL);
	eval 'sub IP_MULTICAST_HOPS () { &IP_MULTICAST_TTL;}' unless defined(&IP_MULTICAST_HOPS);
	eval 'sub IP_MULTICAST_LOOP () {11;}' unless defined(&IP_MULTICAST_LOOP);
	eval 'sub IP_ADD_MEMBERSHIP () {12;}' unless defined(&IP_ADD_MEMBERSHIP);
	eval 'sub IP_DROP_MEMBERSHIP () {13;}' unless defined(&IP_DROP_MEMBERSHIP);
	eval 'sub IP_RECVMACHDR () {14;}' unless defined(&IP_RECVMACHDR);
	eval 'sub IP_RECVIFINFO () {15;}' unless defined(&IP_RECVIFINFO);
	eval 'sub IP_BROADCAST_IF () {16;}' unless defined(&IP_BROADCAST_IF);
	eval 'sub IP_DHCPMODE () {17;}' unless defined(&IP_DHCPMODE);
	eval 'sub IP_RECVIF () {20;}' unless defined(&IP_RECVIF);
	eval 'sub IP_ADDRFORM () {22;}' unless defined(&IP_ADDRFORM);
	eval 'sub IP_DONTFRAG () {25;}' unless defined(&IP_DONTFRAG);
	eval 'sub IP_FINDPMTU () {26;}' unless defined(&IP_FINDPMTU);
	eval 'sub IP_PMTUAGE () {27;}' unless defined(&IP_PMTUAGE);
	eval 'sub IP_RECVINTERFACE () {32;}' unless defined(&IP_RECVINTERFACE);
	eval 'sub IP_RECVTTL () {34;}' unless defined(&IP_RECVTTL);
	eval 'sub IP_DEFAULT_MULTICAST_TTL () {1;}' unless defined(&IP_DEFAULT_MULTICAST_TTL);
	eval 'sub IP_DEFAULT_MULTICAST_LOOP () {1;}' unless defined(&IP_DEFAULT_MULTICAST_LOOP);
	eval 'sub IP_MAX_MEMBERSHIPS () {20;}' unless defined(&IP_MAX_MEMBERSHIPS);
	if(((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) == 500)) {
	    if(defined(&_NO_PROTO)) {
		unless(defined(&htonl)) {
		}
	    } else {
		unless(defined(&htonl)) {
		}
	    }
	}
    }
    if(defined(&_ALL_SOURCE)) {
	require 'sys/machine.ph';
	if(defined(&_NO_PROTO)) {
	    unless(defined(&htonll)) {
	    }
	} else {
	    unless(defined(&htonll)) {
	    }
	}
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	    unless(defined(&htonll)) {
		eval 'sub htonll {
		    my($hostlong) = @_;
    		    eval q(($hostlong));
		}' unless defined(&htonll);
	    }
	    unless(defined(&htonl)) {
		eval 'sub htonl {
		    my($hostlong) = @_;
    		    eval q(($hostlong));
		}' unless defined(&htonl);
	    }
	    unless(defined(&htons)) {
		eval 'sub htons {
		    my($hostshort) = @_;
    		    eval q(($hostshort));
		}' unless defined(&htons);
	    }
	    unless(defined(&ntohll)) {
		eval 'sub ntohll {
		    my($netlong) = @_;
    		    eval q(($netlong));
		}' unless defined(&ntohll);
	    }
	    unless(defined(&ntohl)) {
		eval 'sub ntohl {
		    my($netlong) = @_;
    		    eval q(($netlong));
		}' unless defined(&ntohl);
	    }
	    unless(defined(&ntohs)) {
		eval 'sub ntohs {
		    my($netshort) = @_;
    		    eval q(($netshort));
		}' unless defined(&ntohs);
	    }
	}
	if(defined(&_AIX)) {
	    eval 'sub INADDR_LOOPBACK () {( &uint32_t)0x7f000001;}' unless defined(&INADDR_LOOPBACK);
	}
	eval 'sub IPV6_TOKEN_LENGTH () {64;}' unless defined(&IPV6_TOKEN_LENGTH);
	unless(defined(&_IN6_ADDR_STRUCT)) {
	    if(defined(&notyet)) {
	    }
	    eval 'sub s6_addr32 () { ($u6_addr->{u6_addr32});}' unless defined(&s6_addr32);
	    if(defined(&notyet)) {
		eval 'sub s6_addr64 () { ($u6_addr->{u6_addr64});}' unless defined(&s6_addr64);
	    }
	    eval 'sub s6_addr16 () { ($u6_addr->{u6_addr16});}' unless defined(&s6_addr16);
	    eval 'sub s6_addr8 () { ($u6_addr->{u6_addr8});}' unless defined(&s6_addr8);
	    eval 'sub s6_addr () { ($u6_addr->{u6_addr8});}' unless defined(&s6_addr);
	    eval 'sub INET6_ADDRSTRLEN () {46;}' unless defined(&INET6_ADDRSTRLEN);
	    eval 'sub IN6ADDR_ANY_INIT () {{0, 0, 0, 0};}' unless defined(&IN6ADDR_ANY_INIT);
	    eval 'sub IPV6ADDR_ANY_INIT () { &IN6ADDR_ANY_INIT;}' unless defined(&IPV6ADDR_ANY_INIT);
	    if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
		eval 'sub IN6ADDR_LOOPBACK_INIT () {{0, 0, 0, 1};}' unless defined(&IN6ADDR_LOOPBACK_INIT);
	    } else {
		eval 'sub IN6ADDR_LOOPBACK_INIT () {{0, 0, 0, 0x1000000};}' unless defined(&IN6ADDR_LOOPBACK_INIT);
	    }
	    eval 'sub IPV6ADDR_LOOPBACK_INIT () { &IN6ADDR_LOOPBACK_INIT;}' unless defined(&IPV6ADDR_LOOPBACK_INIT);
	    eval 'sub _IN6_ADDR_STRUCT () {1;}' unless defined(&_IN6_ADDR_STRUCT);
	}
	if(defined(&_AIX)) {
	    eval 'sub _SOCKADDR_LEN () {1;}' unless defined(&_SOCKADDR_LEN);
	}
	if(((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0) != 1)  && !defined( &_SOCKADDR_LEN)  && !defined( &_KERNEL)) {
	}
	eval 'sub SIN6_LEN () {1;}' unless defined(&SIN6_LEN);
	if(defined(&MFC_IMPL)) {
	}
	unless(defined(&__cplusplus)) {
	}
	unless(defined(&IFNAMSIZ)) {
	    eval 'sub IFNAMSIZ () {16;}' unless defined(&IFNAMSIZ);
	}
	eval 'sub IF_NAMESIZE () { &IFNAMSIZ;}' unless defined(&IF_NAMESIZE);
	if(defined(&_KERNEL)) {
	}
	require 'net/nh.ph';
	eval 'sub INET_ADDRSTRLEN () {16;}' unless defined(&INET_ADDRSTRLEN);
	eval 'sub IPNGVERSION () {6;}' unless defined(&IPNGVERSION);
	eval 'sub IPV6_FLOWINFO_FLOWLABEL () {0xffffff;}' unless defined(&IPV6_FLOWINFO_FLOWLABEL);
	eval 'sub IPV6_FLOWINFO_PRIORITY () {0xf000000;}' unless defined(&IPV6_FLOWINFO_PRIORITY);
	eval 'sub IPV6_FLOWINFO_PRIFLOW () {0xfffffff;}' unless defined(&IPV6_FLOWINFO_PRIFLOW);
	eval 'sub IPV6_FLOWINFO_SRFLAG () {0x10000000;}' unless defined(&IPV6_FLOWINFO_SRFLAG);
	eval 'sub IPV6_FLOWINFO_VERSION () {0xf0000000;}' unless defined(&IPV6_FLOWINFO_VERSION);
	eval 'sub IPV6_PRIORITY_UNCHARACTERIZED () {0x;}' unless defined(&IPV6_PRIORITY_UNCHARACTERIZED);
	eval 'sub IPV6_PRIORITY_FILLER () {0x1000000;}' unless defined(&IPV6_PRIORITY_FILLER);
	eval 'sub IPV6_PRIORITY_UNATTENDED () {0x2000000;}' unless defined(&IPV6_PRIORITY_UNATTENDED);
	eval 'sub IPV6_PRIORITY_RESERVED1 () {0x3000000;}' unless defined(&IPV6_PRIORITY_RESERVED1);
	eval 'sub IPV6_PRIORITY_BULK () {0x4000000;}' unless defined(&IPV6_PRIORITY_BULK);
	eval 'sub IPV6_PRIORITY_RESERVED2 () {0x5000000;}' unless defined(&IPV6_PRIORITY_RESERVED2);
	eval 'sub IPV6_PRIORITY_INTERACTIVE () {0x6000000;}' unless defined(&IPV6_PRIORITY_INTERACTIVE);
	eval 'sub IPV6_PRIORITY_CONTROL () {0x7000000;}' unless defined(&IPV6_PRIORITY_CONTROL);
	eval 'sub IPV6_PRIORITY_8 () {0x8000000;}' unless defined(&IPV6_PRIORITY_8);
	eval 'sub IPV6_PRIORITY_9 () {0x9000000;}' unless defined(&IPV6_PRIORITY_9);
	eval 'sub IPV6_PRIORITY_10 () {0xa000000;}' unless defined(&IPV6_PRIORITY_10);
	eval 'sub IPV6_PRIORITY_11 () {0xb000000;}' unless defined(&IPV6_PRIORITY_11);
	eval 'sub IPV6_PRIORITY_12 () {0xc000000;}' unless defined(&IPV6_PRIORITY_12);
	eval 'sub IPV6_PRIORITY_13 () {0xd000000;}' unless defined(&IPV6_PRIORITY_13);
	eval 'sub IPV6_PRIORITY_14 () {0xe000000;}' unless defined(&IPV6_PRIORITY_14);
	eval 'sub IPV6_PRIORITY_15 () {0xf000000;}' unless defined(&IPV6_PRIORITY_15);
	eval 'sub IPV6_SRFLAG_STRICT () {0x10000000;}' unless defined(&IPV6_SRFLAG_STRICT);
	eval 'sub IPV6_SRFLAG_LOOSE () {0x;}' unless defined(&IPV6_SRFLAG_LOOSE);
	eval 'sub IPV6_VERSION () {0x60000000;}' unless defined(&IPV6_VERSION);
	eval 'sub IPV6_GET_FLOWLABEL {
	    my($x) = @_;
    	    eval q(( &ntohl($x) & 0xffffff));
	}' unless defined(&IPV6_GET_FLOWLABEL);
	eval 'sub IPV6_GET_PRIORITY {
	    my($x) = @_;
    	    eval q((( &ntohl($x) >> 24) & 0xf));
	}' unless defined(&IPV6_GET_PRIORITY);
	eval 'sub IPV6_GET_VERSION {
	    my($x) = @_;
    	    eval q(((*(($x)) >> 4) & 0xf));
	}' unless defined(&IPV6_GET_VERSION);
	eval 'sub IPV6_SET_FLOWLABEL {
	    my($x) = @_;
    	    eval q(( &htonl($x) &  &IPV6_FLOWINFO_FLOWLABEL));
	}' unless defined(&IPV6_SET_FLOWLABEL);
	eval 'sub IPV6_SET_PRIORITY {
	    my($x) = @_;
    	    eval q(( &htonl(($x & 0xf) << 24)));
	}' unless defined(&IPV6_SET_PRIORITY);
	eval 'sub CLR_ADDR6 {
	    my($a) = @_;
    	    eval q({ ($a). $s6_addr32[0] = 0; ($a). $s6_addr32[1] = 0; ($a). $s6_addr32[2] = 0; ($a). $s6_addr32[3] = 0; });
	}' unless defined(&CLR_ADDR6);
	eval 'sub COPY_ADDR6 {
	    my($from, $to) = @_;
    	    eval q(($to) = ($from));
	}' unless defined(&COPY_ADDR6);
	eval 'sub IA6_TO_ARRAY16 {
	    my($a) = @_;
    	    eval q(($a). $s6_addr16[7], ($a). $s6_addr16[6], ($a). $s6_addr16[5], ($a). $s6_addr16[4], ($a). $s6_addr16[3], ($a). $s6_addr16[2], ($a). $s6_addr16[1], ($a). $s6_addr16[0]);
	}' unless defined(&IA6_TO_ARRAY16);
	eval 'sub SAME_SOCKADDR {
	    my($a, $b) = @_;
    	    eval q(((($a)-> ($sin6_addr->{s6_addr32[0]}) == ($b)-> ($sin6_addr->{s6_addr32[0]}))  && (($a)-> ($sin6_addr->{s6_addr32[1]}) == ($b)-> ($sin6_addr->{s6_addr32[1]}))  && (($a)-> ($sin6_addr->{s6_addr32[2]}) == ($b)-> ($sin6_addr->{s6_addr32[2]}))  && (($a)-> ($sin6_addr->{s6_addr32[3]}) == ($b)-> ($sin6_addr->{s6_addr32[3]}))));
	}' unless defined(&SAME_SOCKADDR);
	eval 'sub SAME_ADDR6 {
	    my($a, $b) = @_;
    	    eval q(((($a). $s6_addr32[0] == ($b). $s6_addr32[0])  && (($a). $s6_addr32[1] == ($b). $s6_addr32[1])  && (($a). $s6_addr32[2] == ($b). $s6_addr32[2])  && (($a). $s6_addr32[3] == ($b). $s6_addr32[3])));
	}' unless defined(&SAME_ADDR6);
	eval 'sub IS_ANYSOCKADDR {
	    my($a) = @_;
    	    eval q(((($a)-> ($sin6_addr->{s6_addr32[0]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[1]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[2]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[3]}) == 0)));
	}' unless defined(&IS_ANYSOCKADDR);
	eval 'sub IS_ANYADDR6 {
	    my($a) = @_;
    	    eval q(((($a). $s6_addr32[0] == 0)  && (($a). $s6_addr32[1] == 0)  && (($a). $s6_addr32[2] == 0)  && (($a). $s6_addr32[3] == 0)));
	}' unless defined(&IS_ANYADDR6);
	eval 'sub IS_COMPATSOCKADDR {
	    my($a) = @_;
    	    eval q(((($a)-> ($sin6_addr->{s6_addr32[0]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[1]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[2]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr8[12]}) != 0)));
	}' unless defined(&IS_COMPATSOCKADDR);
	eval 'sub IS_COMPATADDR6 {
	    my($a) = @_;
    	    eval q(((($a). $s6_addr32[0] == 0)  && (($a). $s6_addr32[1] == 0)  && (($a). $s6_addr32[2] == 0)  && (($a). $s6_addr8[12] != 0)));
	}' unless defined(&IS_COMPATADDR6);
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	    eval 'sub IS_LOOPSOCKADDR {
	        my($a) = @_;
    		eval q(((($a)-> ($sin6_addr->{s6_addr32[0]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[1]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[2]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[3]}) == 1)));
	    }' unless defined(&IS_LOOPSOCKADDR);
	    eval 'sub IS_LOOPADDR6 {
	        my($a) = @_;
    		eval q(((($a). $s6_addr32[0] == 0)  && (($a). $s6_addr32[1] == 0)  && (($a). $s6_addr32[2] == 0)  && (($a). $s6_addr32[3] == 1)));
	    }' unless defined(&IS_LOOPADDR6);
	    eval 'sub IS_IPV4SOCK_ANYADDR {
	        my($a) = @_;
    		eval q(((($a)-> ($sin6_addr->{s6_addr32[0]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[1]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[2]}) == 0xffff)  && (($a)-> ($sin6_addr->{s6_addr32[3]}) == 0)));
	    }' unless defined(&IS_IPV4SOCK_ANYADDR);
	    eval 'sub IS_IPV4SOCKADDR {
	        my($a) = @_;
    		eval q(((($a)-> ($sin6_addr->{s6_addr32[0]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[1]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[2]}) == 0xffff)  && (($a)-> ($sin6_addr->{s6_addr32[3]}) != 0)));
	    }' unless defined(&IS_IPV4SOCKADDR);
	    eval 'sub IS_IPV4ADDR6 {
	        my($a) = @_;
    		eval q(((($a). $s6_addr32[0] == 0)  && (($a). $s6_addr32[1] == 0)  && (($a). $s6_addr32[2] == 0xffff)  && (($a). $s6_addr32[3] != 0)));
	    }' unless defined(&IS_IPV4ADDR6);
	} else {
	    eval 'sub IS_LOOPSOCKADDR {
	        my($a) = @_;
    		eval q(((($a)-> ($sin6_addr->{s6_addr32[0]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[1]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[2]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[3]}) == 0x1000000)));
	    }' unless defined(&IS_LOOPSOCKADDR);
	    eval 'sub IS_LOOPADDR6 {
	        my($a) = @_;
    		eval q(((($a). $s6_addr32[0] == 0)  && (($a). $s6_addr32[1] == 0)  && (($a). $s6_addr32[2] == 0)  && (($a). $s6_addr32[3] == 0x1000000)));
	    }' unless defined(&IS_LOOPADDR6);
	    eval 'sub IS_IPV4SOCK_ANYADDR {
	        my($a) = @_;
    		eval q(((($a)-> ($sin6_addr->{s6_addr32[0]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[1]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[2]}) == 0xffff0000)  && (($a)-> ($sin6_addr->{s6_addr32[3]}) == 0)));
	    }' unless defined(&IS_IPV4SOCK_ANYADDR);
	    eval 'sub IS_IPV4SOCKADDR {
	        my($a) = @_;
    		eval q(((($a)-> ($sin6_addr->{s6_addr32[0]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[1]}) == 0)  && (($a)-> ($sin6_addr->{s6_addr32[2]}) == 0xffff0000)  && (($a)-> ($sin6_addr->{s6_addr32[3]}) != 0)));
	    }' unless defined(&IS_IPV4SOCKADDR);
	    eval 'sub IS_IPV4ADDR6 {
	        my($a) = @_;
    		eval q(((($a). $s6_addr32[0] == 0)  && (($a). $s6_addr32[1] == 0)  && (($a). $s6_addr32[2] == 0xffff0000)  && (($a). $s6_addr32[3] != 0)));
	    }' unless defined(&IS_IPV4ADDR6);
	}
	eval 'sub IS_LOCALADDR6 {
	    my($a) = @_;
    	    eval q((($a). $s6_addr8[0] == 0xfe));
	}' unless defined(&IS_LOCALADDR6);
	eval 'sub IS_LINKLADDR6 {
	    my($a) = @_;
    	    eval q(( &IS_LOCALADDR6($a)  && (($a). $s6_addr8[1] == 0x80)));
	}' unless defined(&IS_LINKLADDR6);
	eval 'sub IS_SITELADDR6 {
	    my($a) = @_;
    	    eval q(( &IS_LOCALADDR6($a)  && (($a). $s6_addr8[1] == 0xc0)));
	}' unless defined(&IS_SITELADDR6);
	eval 'sub IS_MULTIADDR6 {
	    my($a) = @_;
    	    eval q((($a). $s6_addr8[0] == 0xff));
	}' unless defined(&IS_MULTIADDR6);
	eval 'sub MADDR6_FLAGS {
	    my($a) = @_;
    	    eval q((($a). $s6_addr8[1] >> 4));
	}' unless defined(&MADDR6_FLAGS);
	eval 'sub MADDR6_FLG_WK () {0;}' unless defined(&MADDR6_FLG_WK);
	eval 'sub MADDR6_FLG_TS () {1;}' unless defined(&MADDR6_FLG_TS);
	eval 'sub MADDR6_SCOPE {
	    my($a) = @_;
    	    eval q((($a). $s6_addr8[1] & 0xf));
	}' unless defined(&MADDR6_SCOPE);
	eval 'sub MADDR6_SCP_NODE () {0x1;}' unless defined(&MADDR6_SCP_NODE);
	eval 'sub MADDR6_SCP_LINK () {0x2;}' unless defined(&MADDR6_SCP_LINK);
	eval 'sub MADDR6_SCP_SITE () {0x5;}' unless defined(&MADDR6_SCP_SITE);
	eval 'sub MADDR6_SCP_ORG () {0x8;}' unless defined(&MADDR6_SCP_ORG);
	eval 'sub MADDR6_SCP_GLO () {0xe;}' unless defined(&MADDR6_SCP_GLO);
	eval 'sub MADDR6_ALLNODES () {1;}' unless defined(&MADDR6_ALLNODES);
	eval 'sub MADDR6_ALLROUTERS () {2;}' unless defined(&MADDR6_ALLROUTERS);
	eval 'sub MADDR6_ALLHOSTS () {3;}' unless defined(&MADDR6_ALLHOSTS);
	eval 'sub IN6_IS_ADDR_UNSPECIFIED {
	    my($p) = @_;
    	    eval q( &IS_ANYADDR6(*$p));
	}' unless defined(&IN6_IS_ADDR_UNSPECIFIED);
	eval 'sub IN6_IS_ADDR_LOOPBACK {
	    my($p) = @_;
    	    eval q( &IS_LOOPADDR6(*$p));
	}' unless defined(&IN6_IS_ADDR_LOOPBACK);
	eval 'sub IN6_IS_ADDR_MULTICAST {
	    my($p) = @_;
    	    eval q( &IS_MULTIADDR6(*$p));
	}' unless defined(&IN6_IS_ADDR_MULTICAST);
	eval 'sub IN6_IS_ADDR_LINKLOCAL {
	    my($p) = @_;
    	    eval q( &IS_LINKLADDR6(*$p));
	}' unless defined(&IN6_IS_ADDR_LINKLOCAL);
	eval 'sub IN6_IS_ADDR_SITELOCAL {
	    my($p) = @_;
    	    eval q( &IS_SITELADDR6(*$p));
	}' unless defined(&IN6_IS_ADDR_SITELOCAL);
	eval 'sub IN6_IS_ADDR_V4MAPPED {
	    my($p) = @_;
    	    eval q( &IS_IPV4ADDR6(*$p));
	}' unless defined(&IN6_IS_ADDR_V4MAPPED);
	eval 'sub IN6_IS_ADDR_V4COMPAT {
	    my($p) = @_;
    	    eval q( &IS_COMPATADDR6(*$p));
	}' unless defined(&IN6_IS_ADDR_V4COMPAT);
	eval 'sub IN6_IS_ADDR_MC_NODELOCAL {
	    my($p) = @_;
    	    eval q(( &IS_MULTIADDR6(*$p)  && ( &MADDR6_SCOPE(*$p) ==  &MADDR6_SCP_NODE)));
	}' unless defined(&IN6_IS_ADDR_MC_NODELOCAL);
	eval 'sub IN6_IS_ADDR_MC_LINKLOCAL {
	    my($p) = @_;
    	    eval q(( &IS_MULTIADDR6(*$p)  && ( &MADDR6_SCOPE(*$p) ==  &MADDR6_SCP_LINK)));
	}' unless defined(&IN6_IS_ADDR_MC_LINKLOCAL);
	eval 'sub IN6_IS_ADDR_MC_SITELOCAL {
	    my($p) = @_;
    	    eval q(( &IS_MULTIADDR6(*$p)  && ( &MADDR6_SCOPE(*$p) ==  &MADDR6_SCP_SITE)));
	}' unless defined(&IN6_IS_ADDR_MC_SITELOCAL);
	eval 'sub IN6_IS_ADDR_MC_ORGLOCAL {
	    my($p) = @_;
    	    eval q(( &IS_MULTIADDR6(*$p)  && ( &MADDR6_SCOPE(*$p) ==  &MADDR6_SCP_ORG)));
	}' unless defined(&IN6_IS_ADDR_MC_ORGLOCAL);
	eval 'sub IN6_IS_ADDR_MC_GLOBAL {
	    my($p) = @_;
    	    eval q(( &IS_MULTIADDR6(*$p)  && ( &MADDR6_SCOPE(*$p) ==  &MADDR6_SCP_GLO)));
	}' unless defined(&IN6_IS_ADDR_MC_GLOBAL);
	eval 'sub IN6_ARE_ADDR_EQUAL {
	    my($pa,$pb) = @_;
    	    eval q( &SAME_ADDR6(*$pa,*$pb));
	}' unless defined(&IN6_ARE_ADDR_EQUAL);
	eval 'sub IN6_ADDR_V6_TO_V4 {
	    my($a) = @_;
    	    eval q((($a)-> $s6_addr[12]));
	}' unless defined(&IN6_ADDR_V6_TO_V4);
	unless(defined(&_KERNEL)) {
	}
	eval 'sub IPV6_UNICAST_HOPS () { &IP_TTL;}' unless defined(&IPV6_UNICAST_HOPS);
	eval 'sub IPV6_MULTICAST_IF () { &IP_MULTICAST_IF;}' unless defined(&IPV6_MULTICAST_IF);
	eval 'sub IPV6_MULTICAST_HOPS () { &IP_MULTICAST_TTL;}' unless defined(&IPV6_MULTICAST_HOPS);
	eval 'sub IPV6_MULTICAST_LOOP () { &IP_MULTICAST_LOOP;}' unless defined(&IPV6_MULTICAST_LOOP);
	eval 'sub IPV6_ADD_MEMBERSHIP () { &IP_ADD_MEMBERSHIP;}' unless defined(&IPV6_ADD_MEMBERSHIP);
	eval 'sub IPV6_JOIN_GROUP () { &IP_ADD_MEMBERSHIP;}' unless defined(&IPV6_JOIN_GROUP);
	eval 'sub IPV6_DROP_MEMBERSHIP () { &IP_DROP_MEMBERSHIP;}' unless defined(&IPV6_DROP_MEMBERSHIP);
	eval 'sub IPV6_LEAVE_GROUP () { &IP_DROP_MEMBERSHIP;}' unless defined(&IPV6_LEAVE_GROUP);
	eval 'sub IPV6_ADDRFORM () { &IP_ADDRFORM;}' unless defined(&IPV6_ADDRFORM);
	eval 'sub IPV6_NOPROBE () {28;}' unless defined(&IPV6_NOPROBE);
	eval 'sub IPV6_RECVSRCRT () {29;}' unless defined(&IPV6_RECVSRCRT);
	eval 'sub IPV6_RECVIF () {30;}' unless defined(&IPV6_RECVIF);
	eval 'sub IPV6_SENDIF () {31;}' unless defined(&IPV6_SENDIF);
	eval 'sub IPV6_PKTINFO () {33;}' unless defined(&IPV6_PKTINFO);
	eval 'sub IPV6_RECVHOPS () { &IP_RECVTTL;}' unless defined(&IPV6_RECVHOPS);
	eval 'sub IPV6_RECVPKTINFO () {35;}' unless defined(&IPV6_RECVPKTINFO);
	eval 'sub IPV6_PKTOPTIONS () {36;}' unless defined(&IPV6_PKTOPTIONS);
	eval 'sub FLOW6_RAND () {49;}' unless defined(&FLOW6_RAND);
	if(defined(&_KERNEL)) {
	    eval 'sub satosin {
	        my($sa) = @_;
    		eval q((($sa)));
	    }' unless defined(&satosin);
	    eval 'sub sintosa {
	        my($sin) = @_;
    		eval q((($sin)));
	    }' unless defined(&sintosa);
	    eval 'sub ifatoia {
	        my($ifa) = @_;
    		eval q((($ifa)));
	    }' unless defined(&ifatoia);
	    eval 'sub satosin6 {
	        my($sa) = @_;
    		eval q((($sa)));
	    }' unless defined(&satosin6);
	    eval 'sub sin6tosa {
	        my($sin6) = @_;
    		eval q((($sin6)));
	    }' unless defined(&sin6tosa);
	    eval 'sub ifatoia6 {
	        my($ifa) = @_;
    		eval q((($ifa)));
	    }' unless defined(&ifatoia6);
	}
    }
}
1;
