require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_IN_PCBHASH_H_)) {
    eval 'sub _IN_PCBHASH_H_ () {1;}' unless defined(&_IN_PCBHASH_H_);
    require 'stddef.ph';
    eval 'sub intimewaittopcb {
        my($hp) = @_;
	    eval q((($hp) -  &offsetof(\'struct inpcb\',  &inp_timewait)));
    }' unless defined(&intimewaittopcb);
    eval 'sub inpcbtotimewait {
        my($inp) = @_;
	    eval q((( ($inp->{inp_timewait}))));
    }' unless defined(&inpcbtotimewait);
    eval 'sub inhashtopcb {
        my($hp) = @_;
	    eval q((($hp) -  &offsetof(\'struct inpcb\',  &inp_hash)));
    }' unless defined(&inhashtopcb);
    eval 'sub inpcbtohash {
        my($inp) = @_;
	    eval q((( ($inp->{inp_hash}))));
    }' unless defined(&inpcbtohash);
    eval 'sub INPCB_HASHSZ () {24499;}' unless defined(&INPCB_HASHSZ);
    eval 'sub INPCB_TCPHASH {
        my($faddr, $fport, $laddr, $lport) = @_;
	    eval q((((($faddr) + ($laddr)) + ($fport) + ($lport)) %  &INPCB_HASHSZ));
    }' unless defined(&INPCB_TCPHASH);
    eval 'sub INPCB_UDPHASH {
        my($lport) = @_;
	    eval q((($lport) %  &INPCB_HASHSZ));
    }' unless defined(&INPCB_UDPHASH);
    if(defined(&DEBUG)) {
    }
    eval 'sub __NPCBBITS () {($sizeof{\'int\'} * 8);}' unless defined(&__NPCBBITS);
    eval 'sub __NPCBBITS_MASK () {( &__NPCBBITS - 1);}' unless defined(&__NPCBBITS_MASK);
    eval 'sub __NPCBINTS () {(( &INPCB_HASHSZ +  &__NPCBBITS - 1) /  &__NPCBBITS);}' unless defined(&__NPCBINTS);
    eval 'sub HASH_SET {
        my($bit, $hash) = @_;
	    eval q((( &void)  &fetch_and_or($hash $_hash_bits[($bit)/ &__NPCBBITS], (1<< (($bit) &  &__NPCBBITS_MASK)))));
    }' unless defined(&HASH_SET);
    eval 'sub HASH_CLEARWORD {
        my($wordindex, $hash) = @_;
	    eval q((( &void)  &fetch_and_and($hash $_hash_bits[($wordindex)], 0)));
    }' unless defined(&HASH_CLEARWORD);
    eval 'sub TCP_FAST_HASH_SET {
        my($bit) = @_;
	    eval q( &HASH_SET($bit,  &tcp_fast));
    }' unless defined(&TCP_FAST_HASH_SET);
    eval 'sub TCP_FAST_HASH_CLEARWORD {
        my($wordindex) = @_;
	    eval q( &HASH_CLEARWORD($wordindex,  &tcp_fast));
    }' unless defined(&TCP_FAST_HASH_CLEARWORD);
    eval 'sub TCP_SLOW_HASH_SET {
        my($bit) = @_;
	    eval q( &HASH_SET($bit,  &tcp_slow));
    }' unless defined(&TCP_SLOW_HASH_SET);
    eval 'sub TCP_SLOW_HASH_CLEARWORD {
        my($wordindex) = @_;
	    eval q( &HASH_CLEARWORD($wordindex,  &tcp_slow));
    }' unless defined(&TCP_SLOW_HASH_CLEARWORD);
    if(defined( &_KERNEL)  && (defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
    }
    eval 'sub INP_IFA () {( &inp ?  ($inp->{inp_ifa}) : 0);}' unless defined(&INP_IFA);
    if(defined( &_KERNEL)  && (defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
    }
    if(defined(&IP_MULTICAST)) {
    }
    eval 'sub inp_faddr () { ($inp_faddr_6->{in_addr_4}->{addr});}' unless defined(&inp_faddr);
    eval 'sub inp_laddr () { ($inp_laddr_6->{in_addr_4}->{addr});}' unless defined(&inp_laddr);
    eval 'sub inp_faddr6 () { ($inp_faddr_6->{addr6});}' unless defined(&inp_faddr6);
    eval 'sub inp_laddr6 () { ($inp_laddr_6->{addr6});}' unless defined(&inp_laddr6);
    eval 'sub inp_route () { ($inp_route_6->{route});}' unless defined(&inp_route);
    eval 'sub IPATYPE_UNBD () {0x;}' unless defined(&IPATYPE_UNBD);
    eval 'sub IPATYPE_IPV4 () {0x1;}' unless defined(&IPATYPE_IPV4);
    eval 'sub IPATYPE_IPV6 () {0x2;}' unless defined(&IPATYPE_IPV6);
    eval 'sub IPATYPE_DUAL () {0x3;}' unless defined(&IPATYPE_DUAL);
    eval 'sub INP_RECVOPTS () {0x1;}' unless defined(&INP_RECVOPTS);
    eval 'sub INP_RECVRETOPTS () {0x2;}' unless defined(&INP_RECVRETOPTS);
    eval 'sub INP_RECVDSTADDR () {0x4;}' unless defined(&INP_RECVDSTADDR);
    eval 'sub INP_RECVMACHDR () {0x8;}' unless defined(&INP_RECVMACHDR);
    eval 'sub INP_RECVIFINFO () {0x10;}' unless defined(&INP_RECVIFINFO);
    eval 'sub INP_BROADCAST_IF () {0x20;}' unless defined(&INP_BROADCAST_IF);
    eval 'sub INP_FINDPMTU () {0x40;}' unless defined(&INP_FINDPMTU);
    eval 'sub INP_DONTFRAG () {0x80;}' unless defined(&INP_DONTFRAG);
    eval 'sub INP_RECVINTERFACE () {0x100;}' unless defined(&INP_RECVINTERFACE);
    eval 'sub INP_RECVPKTINFO () {0x4000;}' unless defined(&INP_RECVPKTINFO);
    eval 'sub INP_RECVTTL () {0x2000;}' unless defined(&INP_RECVTTL);
    eval 'sub INP_CONTROLOPTS () {( &INP_RECVMACHDR| &INP_RECVOPTS|  &INP_RECVRETOPTS| &INP_RECVIFINFO|  &INP_BROADCAST_IF| &INP_RECVDSTADDR|  &INP_RECVINTERFACE| &INP_RECVPKTINFO|  &INP_RECVTTL);}' unless defined(&INP_CONTROLOPTS);
    eval 'sub INP_NOPROBE () {0x200;}' unless defined(&INP_NOPROBE);
    eval 'sub INP_COMPATV4 () {0x400;}' unless defined(&INP_COMPATV4);
    eval 'sub INP_COMPATV6 () {0x800;}' unless defined(&INP_COMPATV6);
    eval 'sub INP_COMPATANY () {0xc00;}' unless defined(&INP_COMPATANY);
    eval 'sub INP_HDRINCL () {0x1000;}' unless defined(&INP_HDRINCL);
    if(defined(&sotorawcb)) {
	eval 'sub RINPF_HDRINCL () {0x1;}' unless defined(&RINPF_HDRINCL);
	if(defined(&IP_MULTICAST)) {
	}
    }
    eval 'sub INPLOOKUP_WILDCARD () {1;}' unless defined(&INPLOOKUP_WILDCARD);
    eval 'sub INPLOOKUP_SETLOCAL () {2;}' unless defined(&INPLOOKUP_SETLOCAL);
    eval 'sub INPLOOKUP_USECACHE () {4;}' unless defined(&INPLOOKUP_USECACHE);
    eval 'sub INPLOOKUP_CMPV6ADDR () {8;}' unless defined(&INPLOOKUP_CMPV6ADDR);
    eval 'sub sotoinpcb {
        my($so) = @_;
	    eval q((($so)-> &so_pcb));
    }' unless defined(&sotoinpcb);
    eval 'sub sotorawinpcb {
        my($so) = @_;
	    eval q((($so)-> &so_pcb));
    }' unless defined(&sotorawinpcb);
    if(defined(&_KERNEL)) {
	if((defined(&NETSYNC_LOCK) ? &NETSYNC_LOCK : 0)) {
	    eval 'sub INPCB_LOCKINIT {
	        my($inp) = @_;
    		eval q( &simple_lock_init((($inp)-> &inp_lock)));
	    }' unless defined(&INPCB_LOCKINIT);
	    eval 'sub INPCB_LOCK {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCB_LOCK);
	    eval 'sub INPCB_UNLOCK {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCB_UNLOCK);
	    eval 'sub INPCB_ISLOCKED {
	        my($inp) = @_;
    		eval q(1);
	    }' unless defined(&INPCB_ISLOCKED);
	    eval 'sub INHEAD_LOCK_DECL () {
	        eval q();
	    }' unless defined(&INHEAD_LOCK_DECL);
	    eval 'sub INHEAD_READ_LOCK {
	        my($head) = @_;
    		eval q(($head)-> &_inhl =  &disable_lock( &PL_IMP, (($head)-> &inp_lock)));
	    }' unless defined(&INHEAD_READ_LOCK);
	    eval 'sub INHEAD_READ_UNLOCK {
	        my($head) = @_;
    		eval q( &unlock_enable(($head)-> &_inhl, (($head)-> &inp_lock)));
	    }' unless defined(&INHEAD_READ_UNLOCK);
	    eval 'sub INHEAD_WRITE_LOCK {
	        my($head) = @_;
    		eval q(($head)-> &_inhl =  &disable_lock( &PL_IMP, (($head)-> &inp_lock)));
	    }' unless defined(&INHEAD_WRITE_LOCK);
	    eval 'sub INHEAD_WRITE_UNLOCK {
	        my($head) = @_;
    		eval q( &unlock_enable(($head)-> &_inhl, (($head)-> &inp_lock)));
	    }' unless defined(&INHEAD_WRITE_UNLOCK);
	    eval 'sub INHEAD_LOCKINIT {
	        my($head) = @_;
    		eval q( &INPCB_LOCKINIT($head));
	    }' unless defined(&INHEAD_LOCKINIT);
	    eval 'sub INHEAD_ISLOCKED {
	        my($head) = @_;
    		eval q(1);
	    }' unless defined(&INHEAD_ISLOCKED);
	    eval 'sub INUDPHEAD_LOCK_DECL () {
	        eval q();
	    }' unless defined(&INUDPHEAD_LOCK_DECL);
	    eval 'sub INUDPHEAD_READ_LOCK {
	        my($head) = @_;
    		eval q(($head)-> &_inhl =  &disable_lock( &PL_IMP, (($head)-> &inp_lock)));
	    }' unless defined(&INUDPHEAD_READ_LOCK);
	    eval 'sub INUDPHEAD_READ_UNLOCK {
	        my($head) = @_;
    		eval q( &unlock_enable(($head)-> &_inhl, (($head)-> &inp_lock)));
	    }' unless defined(&INUDPHEAD_READ_UNLOCK);
	    eval 'sub INUDPHEAD_WRITE_LOCK {
	        my($head) = @_;
    		eval q(($head)-> &_inhl =  &disable_lock( &PL_IMP, (($head)-> &inp_lock)));
	    }' unless defined(&INUDPHEAD_WRITE_LOCK);
	    eval 'sub INUDPHEAD_WRITE_UNLOCK {
	        my($head) = @_;
    		eval q( &unlock_enable(($head)-> &_inhl, (($head)-> &inp_lock)));
	    }' unless defined(&INUDPHEAD_WRITE_UNLOCK);
	    eval 'sub INUDPHEAD_LOCKINIT {
	        my($head) = @_;
    		eval q( &INPCB_LOCKINIT($head));
	    }' unless defined(&INUDPHEAD_LOCKINIT);
	    eval 'sub INUDPHEAD_ISLOCKED {
	        my($head) = @_;
    		eval q(1);
	    }' unless defined(&INUDPHEAD_ISLOCKED);
	    eval 'sub INTCPHEAD_LOCK_DECL () {
	        eval q();
	    }' unless defined(&INTCPHEAD_LOCK_DECL);
	    eval 'sub INTCPHEAD_READ_LOCK {
	        my($head) = @_;
    		eval q(($head)-> &_inhl =  &disable_lock( &PL_IMP, (($head)-> &inp_lock)));
	    }' unless defined(&INTCPHEAD_READ_LOCK);
	    eval 'sub INTCPHEAD_READ_UNLOCK {
	        my($head) = @_;
    		eval q( &unlock_enable(($head)-> &_inhl, (($head)-> &inp_lock)));
	    }' unless defined(&INTCPHEAD_READ_UNLOCK);
	    eval 'sub INTCPHEAD_WRITE_LOCK {
	        my($head) = @_;
    		eval q(($head)-> &_inhl =  &disable_lock( &PL_IMP, (($head)-> &inp_lock)));
	    }' unless defined(&INTCPHEAD_WRITE_LOCK);
	    eval 'sub INTCPHEAD_WRITE_UNLOCK {
	        my($head) = @_;
    		eval q( &unlock_enable(($head)-> &_inhl, (($head)-> &inp_lock)));
	    }' unless defined(&INTCPHEAD_WRITE_UNLOCK);
	    eval 'sub INTCPHEAD_LOCKINIT {
	        my($head) = @_;
    		eval q( &INPCB_LOCKINIT($head));
	    }' unless defined(&INTCPHEAD_LOCKINIT);
	    eval 'sub INTCPHEAD_ISLOCKED {
	        my($head) = @_;
    		eval q(1);
	    }' unless defined(&INTCPHEAD_ISLOCKED);
	    eval 'sub INTCP_HASHCHNHEAD_LOCK_DECL () {
	        eval q(\'int\'  &_intcphchnhl;);
	    }' unless defined(&INTCP_HASHCHNHEAD_LOCK_DECL);
	    eval 'sub INTCP_HASHCHNHEAD_LOCK_INIT {
	        my($index) = @_;
    		eval q( &simple_lock_init( ( $tcp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INTCP_HASHCHNHEAD_LOCK_INIT);
	    eval 'sub INTCP_HASHCHNHEAD_READ_LOCK {
	        my($index) = @_;
    		eval q( &_intcphchnhl =  &disable_lock( &PL_IMP, ( $tcp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INTCP_HASHCHNHEAD_READ_LOCK);
	    eval 'sub INTCP_HASHCHNHEAD_READ_UNLOCK {
	        my($index) = @_;
    		eval q( &unlock_enable( &_intcphchnhl, ( $tcp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INTCP_HASHCHNHEAD_READ_UNLOCK);
	    eval 'sub INTCP_HASHCHNHEAD_WRITE_LOCK {
	        my($index) = @_;
    		eval q( &_intcphchnhl =  &disable_lock( &PL_IMP, ( $tcp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INTCP_HASHCHNHEAD_WRITE_LOCK);
	    eval 'sub INTCP_HASHCHNHEAD_WRITE_UNLOCK {
	        my($index) = @_;
    		eval q( &unlock_enable( &_intcphchnhl, ( $tcp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INTCP_HASHCHNHEAD_WRITE_UNLOCK);
	    eval 'sub INUDP_HASHCHNHEAD_LOCK_DECL () {
	        eval q(\'int\'  &_inudphchnhl;);
	    }' unless defined(&INUDP_HASHCHNHEAD_LOCK_DECL);
	    eval 'sub INUDP_HASHCHNHEAD_LOCK_INIT {
	        my($index) = @_;
    		eval q( &simple_lock_init( ( $udp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INUDP_HASHCHNHEAD_LOCK_INIT);
	    eval 'sub INUDP_HASHCHNHEAD_READ_LOCK {
	        my($index) = @_;
    		eval q( &_inudphchnhl =  &disable_lock( &PL_IMP, ( $udp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INUDP_HASHCHNHEAD_READ_LOCK);
	    eval 'sub INUDP_HASHCHNHEAD_READ_UNLOCK {
	        my($index) = @_;
    		eval q( &unlock_enable( &_inudphchnhl, ( $udp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INUDP_HASHCHNHEAD_READ_UNLOCK);
	    eval 'sub INUDP_HASHCHNHEAD_WRITE_LOCK {
	        my($index) = @_;
    		eval q( &_inudphchnhl =  &disable_lock( &PL_IMP, ( $udp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INUDP_HASHCHNHEAD_WRITE_LOCK);
	    eval 'sub INUDP_HASHCHNHEAD_WRITE_UNLOCK {
	        my($index) = @_;
    		eval q( &unlock_enable( &_inudphchnhl, ( $udp_pcb_hashchn_lock[$index])));
	    }' unless defined(&INUDP_HASHCHNHEAD_WRITE_UNLOCK);
	    eval 'sub INPCBRC_LOCKINIT {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCBRC_LOCKINIT);
	    eval 'sub INPCBRC_LOCK {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCBRC_LOCK);
	    eval 'sub INPCBRC_UNLOCK {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCBRC_UNLOCK);
	    eval 'sub INPCBRC_REF {
	        my($inp) = @_;
    		eval q({  &fetch_and_add((($inp)-> &inp_refcnt), 1); });
	    }' unless defined(&INPCBRC_REF);
	    eval 'sub INPCBRC_UNREF {
	        my($inp) = @_;
    		eval q({  &if ( &fetch_and_add((($inp)-> &inp_refcnt), -1) == 1) {  &in_pcbfree($inp); } });
	    }' unless defined(&INPCBRC_UNREF);
	    eval 'sub INPCBRC_UNREF_NOLOCK {
	        my($inp) = @_;
    		eval q({  &if ( &fetch_and_add((($inp)-> &inp_refcnt), -1) == 1) {  &in_pcbfree_nolock($inp); } });
	    }' unless defined(&INPCBRC_UNREF_NOLOCK);
	} else {
	    eval 'sub INPCB_LOCK {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCB_LOCK);
	    eval 'sub INPCB_UNLOCK {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCB_UNLOCK);
	    eval 'sub INPCB_LOCKINIT {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCB_LOCKINIT);
	    eval 'sub INPCB_ISLOCKED {
	        my($inp) = @_;
    		eval q(1);
	    }' unless defined(&INPCB_ISLOCKED);
	    eval 'sub INHEAD_READ_LOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INHEAD_READ_LOCK);
	    eval 'sub INHEAD_WRITE_LOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INHEAD_WRITE_LOCK);
	    eval 'sub INHEAD_READ_UNLOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INHEAD_READ_UNLOCK);
	    eval 'sub INHEAD_WRITE_UNLOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INHEAD_WRITE_UNLOCK);
	    eval 'sub INHEAD_LOCKINIT {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INHEAD_LOCKINIT);
	    eval 'sub INUDPHEAD_READ_LOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INUDPHEAD_READ_LOCK);
	    eval 'sub INUDPHEAD_WRITE_LOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INUDPHEAD_WRITE_LOCK);
	    eval 'sub INUDPHEAD_READ_UNLOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INUDPHEAD_READ_UNLOCK);
	    eval 'sub INUDPHEAD_WRITE_UNLOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INUDPHEAD_WRITE_UNLOCK);
	    eval 'sub INUDPHEAD_LOCKINIT {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INUDPHEAD_LOCKINIT);
	    eval 'sub INTCPHEAD_READ_LOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INTCPHEAD_READ_LOCK);
	    eval 'sub INTCPHEAD_WRITE_LOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INTCPHEAD_WRITE_LOCK);
	    eval 'sub INTCPHEAD_READ_UNLOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INTCPHEAD_READ_UNLOCK);
	    eval 'sub INTCPHEAD_WRITE_UNLOCK {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INTCPHEAD_WRITE_UNLOCK);
	    eval 'sub INTCPHEAD_LOCKINIT {
	        my($head) = @_;
    		eval q();
	    }' unless defined(&INTCPHEAD_LOCKINIT);
	    eval 'sub INTCP_HASHCHNHEAD_LOCK_INIT {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INTCP_HASHCHNHEAD_LOCK_INIT);
	    eval 'sub INTCP_HASHCHNHEAD_READ_LOCK {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INTCP_HASHCHNHEAD_READ_LOCK);
	    eval 'sub INTCP_HASHCHNHEAD_READ_UNLOCK {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INTCP_HASHCHNHEAD_READ_UNLOCK);
	    eval 'sub INTCP_HASHCHNHEAD_WRITE_LOCK {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INTCP_HASHCHNHEAD_WRITE_LOCK);
	    eval 'sub INTCP_HASHCHNHEAD_WRITE_UNLOCK {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INTCP_HASHCHNHEAD_WRITE_UNLOCK);
	    eval 'sub INUDP_HASHCHNHEAD_LOCK_INIT {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INUDP_HASHCHNHEAD_LOCK_INIT);
	    eval 'sub INUDP_HASHCHNHEAD_READ_LOCK {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INUDP_HASHCHNHEAD_READ_LOCK);
	    eval 'sub INUDP_HASHCHNHEAD_READ_UNLOCK {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INUDP_HASHCHNHEAD_READ_UNLOCK);
	    eval 'sub INUDP_HASHCHNHEAD_WRITE_LOCK {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INUDP_HASHCHNHEAD_WRITE_LOCK);
	    eval 'sub INUDP_HASHCHNHEAD_WRITE_UNLOCK {
	        my($index) = @_;
    		eval q();
	    }' unless defined(&INUDP_HASHCHNHEAD_WRITE_UNLOCK);
	    eval 'sub INPCBRC_LOCKINIT {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCBRC_LOCKINIT);
	    eval 'sub INPCBRC_LOCK {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCBRC_LOCK);
	    eval 'sub INPCBRC_UNLOCK {
	        my($inp) = @_;
    		eval q();
	    }' unless defined(&INPCBRC_UNLOCK);
	    eval 'sub INPCBRC_REF {
	        my($inp) = @_;
    		eval q(($inp)-> &inp_refcnt++);
	    }' unless defined(&INPCBRC_REF);
	    eval 'sub INPCBRC_UNREF {
	        my($inp) = @_;
    		eval q({ &if (--($inp)-> &inp_refcnt == 0)  &in_pcbfree($inp);});
	    }' unless defined(&INPCBRC_UNREF);
	}
	require 'netinet/in.ph';
	eval 'sub PORT_IN_USE {
	    my($head, $port) = @_;
    	    eval q((($head) ==  &tcb ?  $tcp_port_count[$port] :  $udp_port_count[$port]));
	}' unless defined(&PORT_IN_USE);
	eval 'sub PORT_INC {
	    my($head, $port) = @_;
    	    eval q((($head) ==  &tcb ?  &fetch_and_add( $tcp_port_count[$port],1) :  &fetch_and_add( $udp_port_count[$port],1)));
	}' unless defined(&PORT_INC);
	eval 'sub PORT_DEC {
	    my($head, $port) = @_;
    	    eval q((($head) ==  &tcb ?  &fetch_and_add( $tcp_port_count[$port],-1) :  &fetch_and_add( $udp_port_count[$port],-1)));
	}' unless defined(&PORT_DEC);
	if(defined(&MEMSAVE)) {
	    eval 'sub so2inpcb {
	        my($so) = @_;
    		eval q( (( ($so)) + $sizeof{\'struct socket\'}));
	    }' unless defined(&so2inpcb);
	}
    }
    eval 'sub inhdr_laddr () { ($inhdr_laddr_6->{in_addr_4}->{addr});}' unless defined(&inhdr_laddr);
    eval 'sub inhdr_faddr () { ($inhdr_faddr_6->{in_addr_4}->{addr});}' unless defined(&inhdr_faddr);
    eval 'sub inhdr_laddr6 () { ($inhdr_laddr_6->{addr6});}' unless defined(&inhdr_laddr6);
    eval 'sub inhdr_faddr6 () { ($inhdr_faddr_6->{addr6});}' unless defined(&inhdr_faddr6);
}
1;
