require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IP6_H_)) {
    eval 'sub _NETINET_IP6_H_ () {1;}' unless defined(&_NETINET_IP6_H_);
    eval 'sub IP6_MMTU () {1280;}' unless defined(&IP6_MMTU);
    eval 'sub IP6_NHDR_HOP () {0;}' unless defined(&IP6_NHDR_HOP);
    eval 'sub IP6_NHDR_RT () {43;}' unless defined(&IP6_NHDR_RT);
    eval 'sub IP6_NHDR_FRAG () {44;}' unless defined(&IP6_NHDR_FRAG);
    eval 'sub IP6_NHDR_AUTH () {51;}' unless defined(&IP6_NHDR_AUTH);
    eval 'sub IP6_NHDR_ESP () {50;}' unless defined(&IP6_NHDR_ESP);
    eval 'sub IP6_NHDR_DOPT () {60;}' unless defined(&IP6_NHDR_DOPT);
    eval 'sub IP6_NHDR_NONH () {59;}' unless defined(&IP6_NHDR_NONH);
    eval 'sub IP6_MF () {0x1;}' unless defined(&IP6_MF);
    eval 'sub IP6_OFFMASK () {0xfff8;}' unless defined(&IP6_OFFMASK);
    eval 'sub IP6_LSRRT () {0;}' unless defined(&IP6_LSRRT);
    eval 'sub IP6_OPT_PAD1 () {0;}' unless defined(&IP6_OPT_PAD1);
    eval 'sub IP6_OPT_PADN () {1;}' unless defined(&IP6_OPT_PADN);
    eval 'sub IP6FRAGTTL () {120;}' unless defined(&IP6FRAGTTL);
    if(defined(&STEVENS_API)) {
	eval 'sub ip6_vfc () { ($ip6_ctlun->{un_vfc});}' unless defined(&ip6_vfc);
	eval 'sub ip6_flow () { ($ip6_ctlun->{un_ctl6}->{ctl6_flow});}' unless defined(&ip6_flow);
	eval 'sub ip6_plen () { ($ip6_ctlun->{un_ctl6}->{ctl6_plen});}' unless defined(&ip6_plen);
	eval 'sub ip6_nxt () { ($ip6_ctlun->{un_ctl6}->{ctl6_nxt});}' unless defined(&ip6_nxt);
	eval 'sub ip6_hlim () { ($ip6_ctlun->{un_ctl6}->{ctl6_hlim});}' unless defined(&ip6_hlim);
	eval 'sub ip6_hops () { ($ip6_ctlun->{un_ctl6}->{ctl6_hops});}' unless defined(&ip6_hops);
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	    eval 'sub IP6F_OFF_MASK () {0xfff8;}' unless defined(&IP6F_OFF_MASK);
	    eval 'sub IP6F_RESERVED_MASK () {0x6;}' unless defined(&IP6F_RESERVED_MASK);
	    eval 'sub IP6F_MORE_FLAG () {0x1;}' unless defined(&IP6F_MORE_FLAG);
	} else {
	    eval 'sub IP6F_OFF_MASK () {0xf8ff;}' unless defined(&IP6F_OFF_MASK);
	    eval 'sub IP6F_RESERVED_MASK () {0x600;}' unless defined(&IP6F_RESERVED_MASK);
	    eval 'sub IP6F_MORE_FLAG () {0x100;}' unless defined(&IP6F_MORE_FLAG);
	}
    }
}
1;
