require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&_ONCPLUS)) {
    require 'oncplus/nfs/nfs_fscntl.ph';
} else {
    unless(defined(&_NFS_FSCNTL_)) {
	eval 'sub _NFS_FSCNTL_ () {1;}' unless defined(&_NFS_FSCNTL_);
	require 'rpc/types.ph';
	require 'rpc/auth.ph';
	require 'rpc/clnt.ph';
	require 'rpc/svc.ph';
	eval 'sub NFS_CNTL_SET_CHKSUM () {1;}' unless defined(&NFS_CNTL_SET_CHKSUM);
	eval 'sub NFS_CNTL_SET_SOCKS () {2;}' unless defined(&NFS_CNTL_SET_SOCKS);
	eval 'sub NFS_CNTL_SET_PORTCK () {3;}' unless defined(&NFS_CNTL_SET_PORTCK);
	eval 'sub NFS_CNTL_GET_OPTIONS () {4;}' unless defined(&NFS_CNTL_GET_OPTIONS);
	eval 'sub NFS_CNTL_GET_CLNT_STAT () {5;}' unless defined(&NFS_CNTL_GET_CLNT_STAT);
	eval 'sub NFS_CNTL_CLR_CLNT_STAT () {6;}' unless defined(&NFS_CNTL_CLR_CLNT_STAT);
	eval 'sub NFS_CNTL_GET_SERV_STAT () {7;}' unless defined(&NFS_CNTL_GET_SERV_STAT);
	eval 'sub NFS_CNTL_CLR_SERV_STAT () {8;}' unless defined(&NFS_CNTL_CLR_SERV_STAT);
	eval 'sub NFS_CNTL_GET_CLKRPC_STAT () {9;}' unless defined(&NFS_CNTL_GET_CLKRPC_STAT);
	eval 'sub NFS_CNTL_CLR_CLKRPC_STAT () {10;}' unless defined(&NFS_CNTL_CLR_CLKRPC_STAT);
	eval 'sub NFS_CNTL_GET_SVKRPC_STAT () {11;}' unless defined(&NFS_CNTL_GET_SVKRPC_STAT);
	eval 'sub NFS_CNTL_CLR_SVKRPC_STAT () {12;}' unless defined(&NFS_CNTL_CLR_SVKRPC_STAT);
	eval 'sub NFS_CNTL_GET_ALL_STAT () {13;}' unless defined(&NFS_CNTL_GET_ALL_STAT);
	eval 'sub NFS_CNTL_CLR_ALL_STAT () {14;}' unless defined(&NFS_CNTL_CLR_ALL_STAT);
	eval 'sub NFS_CNTL_SET_SETATTR () {15;}' unless defined(&NFS_CNTL_SET_SETATTR);
	eval 'sub NFS_CNTL_SET_WRGATHER () {16;}' unless defined(&NFS_CNTL_SET_WRGATHER);
	eval 'sub NFS_CNTL_SET_REPEATMSG () {17;}' unless defined(&NFS_CNTL_SET_REPEATMSG);
	eval 'sub NFS_CNTL_GET_PKTS_STAT () {18;}' unless defined(&NFS_CNTL_GET_PKTS_STAT);
	eval 'sub NFS_CNTL_CLR_PKTS_STAT () {19;}' unless defined(&NFS_CNTL_CLR_PKTS_STAT);
	eval 'sub NFS_CNTL_SET_NFSDUPCACHESZ () {20;}' unless defined(&NFS_CNTL_SET_NFSDUPCACHESZ);
	eval 'sub NFS_CNTL_GET_NFSDUPCACHESZ () {21;}' unless defined(&NFS_CNTL_GET_NFSDUPCACHESZ);
	eval 'sub NFS_CNTL_SET_NFSBASEPRIORITY () {22;}' unless defined(&NFS_CNTL_SET_NFSBASEPRIORITY);
	eval 'sub NFS_CNTL_GET_NFSBASEPRIORITY () {23;}' unless defined(&NFS_CNTL_GET_NFSBASEPRIORITY);
	eval 'sub NFS_CNTL_SET_NFSDYNAMICRETRANS () {24;}' unless defined(&NFS_CNTL_SET_NFSDYNAMICRETRANS);
	eval 'sub NFS_CNTL_GET_NFSDYNAMICRETRANS () {25;}' unless defined(&NFS_CNTL_GET_NFSDYNAMICRETRANS);
	eval 'sub NFS_CNTL_SET_NFSCLIENTIOPACE () {26;}' unless defined(&NFS_CNTL_SET_NFSCLIENTIOPACE);
	eval 'sub NFS_CNTL_GET_NFSCLIENTIOPACE () {27;}' unless defined(&NFS_CNTL_GET_NFSCLIENTIOPACE);
	eval 'sub NFS_CNTL_SET_NFSHA () {28;}' unless defined(&NFS_CNTL_SET_NFSHA);
	eval 'sub NFS_CNTL_GET_NFSHA () {29;}' unless defined(&NFS_CNTL_GET_NFSHA);
	eval 'sub NFS_CNTL_SET_NFSHADUPCACHE () {30;}' unless defined(&NFS_CNTL_SET_NFSHADUPCACHE);
	eval 'sub NFS_CNTL_GET_NFSHADUPCACHE () {31;}' unless defined(&NFS_CNTL_GET_NFSHADUPCACHE);
	eval 'sub NFS_CNTL_CHKSUM_SIZE () {$sizeof{ &nfsudpcksum};}' unless defined(&NFS_CNTL_CHKSUM_SIZE);
	eval 'sub NFS_CNTL_SOCKS_SIZE () {$sizeof{ &nfs_socketsize};}' unless defined(&NFS_CNTL_SOCKS_SIZE);
	eval 'sub NFS_CNTL_PORTCK_SIZE () {$sizeof{ &nfs_portmonitor};}' unless defined(&NFS_CNTL_PORTCK_SIZE);
	eval 'sub NFS_CNTL_OPTIONS_SIZE () {$sizeof{ &t_nfs_options};}' unless defined(&NFS_CNTL_OPTIONS_SIZE);
	eval 'sub NFS_CNTL_CLNT_SIZE () {$sizeof{ &t_clstat};}' unless defined(&NFS_CNTL_CLNT_SIZE);
	eval 'sub NFS_CNTL_SERV_SIZE () {$sizeof{ &t_svstat};}' unless defined(&NFS_CNTL_SERV_SIZE);
	eval 'sub NFS_CNTL_CLKRPC_SIZE () {$sizeof{ &t_rcstat};}' unless defined(&NFS_CNTL_CLKRPC_SIZE);
	eval 'sub NFS_CNTL_SVKRPC_SIZE () {$sizeof{ &t_rsstat};}' unless defined(&NFS_CNTL_SVKRPC_SIZE);
	eval 'sub NFS_CNTL_ALL_SIZE () {$sizeof{ &t_nfs_stats};}' unless defined(&NFS_CNTL_ALL_SIZE);
	eval 'sub NFS_CNTL_SETATTR_SIZE () {$sizeof{ &nfs_setattr_err_ignore};}' unless defined(&NFS_CNTL_SETATTR_SIZE);
	eval 'sub NFS_CNTL_WRGATHER_SIZE () {$sizeof{ &nfs_write_gather};}' unless defined(&NFS_CNTL_WRGATHER_SIZE);
	eval 'sub NFS_CNTL_REPEATMSG_SIZE () {$sizeof{ &nfs_repeat};}' unless defined(&NFS_CNTL_REPEATMSG_SIZE);
	eval 'sub NFS_CNTL_PKTS_SIZE () {$sizeof{ &t_nfs_stats_pkts};}' unless defined(&NFS_CNTL_PKTS_SIZE);
	eval 'sub NFS_CNTL_DUPCACHE_SIZE () {$sizeof{ &nfs_dupcachesize};}' unless defined(&NFS_CNTL_DUPCACHE_SIZE);
	eval 'sub NFS_CNTL_BASEPRIORITY_SIZE () {$sizeof{ &nfs_basepriority};}' unless defined(&NFS_CNTL_BASEPRIORITY_SIZE);
	eval 'sub NFS_CNTL_DYNAMICRETRANS_SIZE () {$sizeof{ &nfs_dynamicretrans};}' unless defined(&NFS_CNTL_DYNAMICRETRANS_SIZE);
	eval 'sub NFS_CNTL_CLIENTIOPACE_SIZE () {$sizeof{ &nfs_clientiopace};}' unless defined(&NFS_CNTL_CLIENTIOPACE_SIZE);
	eval 'sub NFS_CNTL_NFSHA_SIZE () {$sizeof{ &nfs_ha};}' unless defined(&NFS_CNTL_NFSHA_SIZE);
    }
}
1;
