require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&_ONCPLUS)) {
    require 'oncplus/nfs/rnode.ph';
} else {
    unless(defined(&_NFS_RNODE_H)) {
	eval 'sub _NFS_RNODE_H () {1;}' unless defined(&_NFS_RNODE_H);
	eval 'sub MAXRNODES () {200;}' unless defined(&MAXRNODES);
	eval 'sub RLOCKED () {0x1;}' unless defined(&RLOCKED);
	eval 'sub RWANT () {0x2;}' unless defined(&RWANT);
	eval 'sub RATTRVALID () {0x4;}' unless defined(&RATTRVALID);
	eval 'sub REOF () {0x8;}' unless defined(&REOF);
	eval 'sub RDIRTY () {0x10;}' unless defined(&RDIRTY);
	eval 'sub RRWVP () {0x20;}' unless defined(&RRWVP);
	eval 'sub DOING_CHECK () {0x40;}' unless defined(&DOING_CHECK);
	eval 'sub RACLINVALID () {0x80;}' unless defined(&RACLINVALID);
	eval 'sub RPCLINVALID () {0x100;}' unless defined(&RPCLINVALID);
	eval 'sub rtov {
	    my($rp) = @_;
    	    eval q((($rp)-> &r_vnode));
	}' unless defined(&rtov);
	eval 'sub vtor {
	    my($vp) = @_;
    	    eval q(((($vp)-> &v_data)));
	}' unless defined(&vtor);
	eval 'sub vtofh {
	    my($vp) = @_;
    	    eval q((( &vtor($vp)-> &r_fh)));
	}' unless defined(&vtofh);
	eval 'sub rtofh {
	    my($rp) = @_;
    	    eval q((($rp)-> &r_fh));
	}' unless defined(&rtofh);
	eval 'sub RLOCK {
	    my($rp) = @_;
    	    eval q( &rlock($rp););
	}' unless defined(&RLOCK);
	eval 'sub RUNLOCK {
	    my($rp) = @_;
    	    eval q( &runlock($rp););
	}' unless defined(&RUNLOCK);
    }
}
1;
