require '_h2ph_pre.ph';

no warnings 'redefine';

require 'rpc/types.ph';
require 'rpcsvc/nis.ph';
require 'nsl/nis_clnt.ph';
unless(defined(&CACHE_FILE)) {
    sub CACHE_FILE () {	"/var/nis/NIS_SHARED_DIRCACHE";}
}
unless(defined(&PRIVATE_CACHE_FILE)) {
    sub PRIVATE_CACHE_FILE () {	"/var/nis/.NIS_PRIVATE_DIRCACHE";}
}
unless(defined(&TMP_CACHE_FILE)) {
    sub TMP_CACHE_FILE () {	"/var/nis/.NIS_TEMPORARY_DIRCACHE";}
}
if(defined(&__cplusplus)) {
}
unless(defined(&CACHEPROG)) {
    sub CACHEPROG () {	(100301);}
}
unless(defined(&CACHE_VER_2)) {
    sub CACHE_VER_2 () {	(2);}
}
unless(defined(&NIS_CACHE_ADD_ENTRY)) {
    sub NIS_CACHE_ADD_ENTRY () {	(1);}
}
unless(defined(&NIS_CACHE_REMOVE_ENTRY)) {
    sub NIS_CACHE_REMOVE_ENTRY () {	(2);}
}
unless(defined(&NIS_CACHE_READ_COLDSTART)) {
    sub NIS_CACHE_READ_COLDSTART () {	(3);}
}
unless(defined(&NIS_CACHE_REFRESH_ENTRY)) {
    sub NIS_CACHE_REFRESH_ENTRY () {	(4);}
}
unless(defined(&NIS_CACHE_BIND_REPLICA)) {
    sub NIS_CACHE_BIND_REPLICA () {	(5);}
}
unless(defined(&NIS_CACHE_BIND_MASTER)) {
    sub NIS_CACHE_BIND_MASTER () {	(6);}
}
unless(defined(&NIS_CACHE_BIND_SERVER)) {
    sub NIS_CACHE_BIND_SERVER () {	(7);}
}
unless(defined(&NIS_CACHE_REFRESH_BINDING)) {
    sub NIS_CACHE_REFRESH_BINDING () {	(8);}
}
unless(defined(&NIS_CACHE_REFRESH_ADDRESS)) {
    sub NIS_CACHE_REFRESH_ADDRESS () {	(9);}
}
unless(defined(&NIS_CACHE_REFRESH_CALLBACK)) {
    sub NIS_CACHE_REFRESH_CALLBACK () {	(10);}
}
unless(defined(&NIS_CACHE_PING)) {
    sub NIS_CACHE_PING () {	(11);}
}
if(defined(&__cplusplus)) {
}
1;
