require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PIOSTRUCT_H)) {
    eval 'sub _PIOSTRUCT_H () {1;}' unless defined(&_PIOSTRUCT_H);
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
    }
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    eval 'sub PIOEXITGOOD () {0;}' unless defined(&PIOEXITGOOD);
    eval 'sub PIOEXITBAD () {1;}' unless defined(&PIOEXITBAD);
    eval 'sub piogetc {
        my($stream) = @_;
	    eval q( &getc($stream));
    }' unless defined(&piogetc);
    eval 'sub piogetchar () {
        eval q( &piogetc( &stdin));
    }' unless defined(&piogetchar);
    eval 'sub pioputc {
        my($x, $p) = @_;
	    eval q({  &if (! &piopgskip) {  &putc($x, $p);  &piodatasent =  &TRUE; }});
    }' unless defined(&pioputc);
    eval 'sub pioputchar {
        my($x) = @_;
	    eval q( &pioputc(($x),  &stdout));
    }' unless defined(&pioputchar);
    eval 'sub SPOOLER () { &statusfile;}' unless defined(&SPOOLER);
    eval 'sub VAR_INT () {1;}' unless defined(&VAR_INT);
    eval 'sub VAR_STR () {2;}' unless defined(&VAR_STR);
    eval 'sub PIO_DBASE_MODE () {0;}' unless defined(&PIO_DBASE_MODE);
    eval 'sub PIO_CURR_MODE () {1;}' unless defined(&PIO_CURR_MODE);
    eval 'sub PIO_SECUR_MODE () {2;}' unless defined(&PIO_SECUR_MODE);
    eval 'sub PIO_NUM_MODES () {3;}' unless defined(&PIO_NUM_MODES);
    eval 'sub PIO_CFLEVEL_ATTR () {"zL";}' unless defined(&PIO_CFLEVEL_ATTR);
    eval 'sub PIO_CFLEVEL_NEW () {2;}' unless defined(&PIO_CFLEVEL_NEW);
    eval 'sub PIO_CFLEVEL_CONV () {1;}' unless defined(&PIO_CFLEVEL_CONV);
    eval 'sub PIO_CFLEVEL_OLD () {0;}' unless defined(&PIO_CFLEVEL_OLD);
    eval 'sub PIO_CFLEVEL_DECL () { &static \'int\' * &_piocflevel;  &static \'struct attrparms\'  $piocfltbl[] = { {  &PIO_CFLEVEL_ATTR,  &VAR_INT,  &NULL, & &_piocflevel }, {  &NULL , 0,  &NULL,  &NULL } };}' unless defined(&PIO_CFLEVEL_DECL);
    eval 'sub Piocflevel () {(*( &_piocflevel +  &piomode));}' unless defined(&Piocflevel);
    eval 'sub CP () {-1;}' unless defined(&CP);
    eval 'sub RM () {-2;}' unless defined(&RM);
    eval 'sub SC () {-3;}' unless defined(&SC);
    eval 'sub PIODEFMSG () {"0782-000 Cannot access message text (index %d)\\n\\tin message catalog file %s\\n\\tUse local problem reporting procedures.\\n";}' unless defined(&PIODEFMSG);
    eval 'sub ERR_NOATTR () {1;}' unless defined(&ERR_NOATTR);
    eval 'sub PIOR_CONT () {0;}' unless defined(&PIOR_CONT);
    eval 'sub PIOR_END () {1;}' unless defined(&PIOR_END);
    eval 'sub PIOR_BAD () {2;}' unless defined(&PIOR_BAD);
    eval 'sub PIOR_FAIL () {3;}' unless defined(&PIOR_FAIL);
    eval 'sub BEGSTR () {"%%[ ";}' unless defined(&BEGSTR);
    eval 'sub ENDSTR () {" ]%%";}' unless defined(&ENDSTR);
    eval 'sub BEGLEN () {($sizeof{ &BEGSTR}-1);}' unless defined(&BEGLEN);
    eval 'sub ENDLEN () {($sizeof{ &ENDSTR}-1);}' unless defined(&ENDLEN);
    eval 'sub PIOATTRNMLEN () {2;}' unless defined(&PIOATTRNMLEN);
    eval 'sub PIOCFAPI () {"/usr/lib/lpd/pio/etc/piocfapi";}' unless defined(&PIOCFAPI);
    eval 'sub PA_AVALT () {1;}' unless defined(&PA_AVALT);
    eval 'sub PA_ADSCT () {2;}' unless defined(&PA_ADSCT);
    eval 'sub PA_ALIMT () {3;}' unless defined(&PA_ALIMT);
    if(defined(&_NO_PROTO)) {
    } else {
    }
    eval 'sub PIOMSGIPCENV () {"PIO_IPCWRITEFD";}' unless defined(&PIOMSGIPCENV);
    eval 'sub PM_CATNMMAX () {(127);}' unless defined(&PM_CATNMMAX);
    eval 'sub PM_MAXMSGARGNO () {(9);}' unless defined(&PM_MAXMSGARGNO);
    eval 'sub PDE_JOB_ABORTED_BY_SERVER () {0;}' unless defined(&PDE_JOB_ABORTED_BY_SERVER);
    eval 'sub PDE_DOCUMENT_ABORTED_BY_BACKEND () {1;}' unless defined(&PDE_DOCUMENT_ABORTED_BY_BACKEND);
    eval 'sub PDE_ERROR_PAGE_SELECT () {2;}' unless defined(&PDE_ERROR_PAGE_SELECT);
    eval 'sub PDE_ERROR_DOCUMENT_CONTENT () {3;}' unless defined(&PDE_ERROR_DOCUMENT_CONTENT);
    eval 'sub PDE_ERROR_OTHER () {4;}' unless defined(&PDE_ERROR_OTHER);
    eval 'sub PDE_WARNING_RESOURCE_NEEDS_ATTENTION () {5;}' unless defined(&PDE_WARNING_RESOURCE_NEEDS_ATTENTION);
    eval 'sub PDE_WARNING_RESOURCE_NEEDS_OPERATOR () {6;}' unless defined(&PDE_WARNING_RESOURCE_NEEDS_OPERATOR);
    eval 'sub PDE_WARNING_CRITERION_EXCEEDED () {7;}' unless defined(&PDE_WARNING_CRITERION_EXCEEDED);
    eval 'sub PDE_WARNING_OTHER () {8;}' unless defined(&PDE_WARNING_OTHER);
    eval 'sub PDE_REPORT_CHECKPOINT_TAKEN () {9;}' unless defined(&PDE_REPORT_CHECKPOINT_TAKEN);
    eval 'sub PDE_STATE_CHANGED_PRINTER () {10;}' unless defined(&PDE_STATE_CHANGED_PRINTER);
    eval 'sub PDE_PRINTER_IS_IDLE () {11;}' unless defined(&PDE_PRINTER_IS_IDLE);
    eval 'sub PDE_PRINTER_IS_PRINTING () {12;}' unless defined(&PDE_PRINTER_IS_PRINTING);
    eval 'sub PDE_PRINTER_NEEDS_ATTENTION () {13;}' unless defined(&PDE_PRINTER_NEEDS_ATTENTION);
    eval 'sub PDE_PRINTER_NEEDS_KEY_OPERATOR () {14;}' unless defined(&PDE_PRINTER_NEEDS_KEY_OPERATOR);
    eval 'sub PDE_JOB_CANCELLED_BY_OPERATOR () {15;}' unless defined(&PDE_JOB_CANCELLED_BY_OPERATOR);
    eval 'sub PDE_DOCUMENT_CANCELLED_BY_OPERATOR () {16;}' unless defined(&PDE_DOCUMENT_CANCELLED_BY_OPERATOR);
    eval 'sub PDE_ERROR_NO_RESOURCE () {17;}' unless defined(&PDE_ERROR_NO_RESOURCE);
    eval 'sub PDE_ERROR_UNRECOGNIZED_RESOURCE () {18;}' unless defined(&PDE_ERROR_UNRECOGNIZED_RESOURCE);
    eval 'sub PDE_INTERNAL_SERVER_ERROR () {19;}' unless defined(&PDE_INTERNAL_SERVER_ERROR);
    eval 'sub PDE_PRINTER_IS_TIMED_OUT () {20;}' unless defined(&PDE_PRINTER_IS_TIMED_OUT);
    eval 'sub PDE_WARNING_PRINTER_NEEDS_ADMINISTRATOR () {21;}' unless defined(&PDE_WARNING_PRINTER_NEEDS_ADMINISTRATOR);
    eval 'sub PDE_WARNING_PRINTER_FUNCTION_UNAVAILABLE () {22;}' unless defined(&PDE_WARNING_PRINTER_FUNCTION_UNAVAILABLE);
    eval 'sub PDE_DOCUMENT_CANCELLED_AT_PRINTER () {23;}' unless defined(&PDE_DOCUMENT_CANCELLED_AT_PRINTER);
    eval 'sub PDE_REPORT_DETAILED_MESSAGES () {24;}' unless defined(&PDE_REPORT_DETAILED_MESSAGES);
    eval 'sub PDE_DOCUMENT_RESUMED_BY_BACKEND () {101;}' unless defined(&PDE_DOCUMENT_RESUMED_BY_BACKEND);
    eval 'sub PDE_NO_EVENT () {255;}' unless defined(&PDE_NO_EVENT);
    eval 'sub PA_ATSTRING () {0;}' unless defined(&PA_ATSTRING);
    eval 'sub PA_ATINT () {1;}' unless defined(&PA_ATINT);
}
1;
