require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&TP_BSIZE)) {
    sub TP_BSIZE () {	1024;}
}
unless(defined(&NTREC)) {
    sub NTREC () {	10;}
}
unless(defined(&HIGHDENSITYTREC)) {
    sub HIGHDENSITYTREC () {	32;}
}
unless(defined(&TP_NINDIR)) {
    sub TP_NINDIR () {	( &TP_BSIZE/2);}
}
unless(defined(&TS_TAPE)) {
    sub TS_TAPE () {	1;}
}
unless(defined(&TS_INODE)) {
    sub TS_INODE () {	2;}
}
unless(defined(&TS_BITS)) {
    sub TS_BITS () {	3;}
}
unless(defined(&TS_ADDR)) {
    sub TS_ADDR () {	4;}
}
unless(defined(&TS_END)) {
    sub TS_END () {	5;}
}
unless(defined(&TS_CLRI)) {
    sub TS_CLRI () {	6;}
}
unless(defined(&OFS_MAGIC)) {
    sub OFS_MAGIC () {	60011;}
}
unless(defined(&NFS_MAGIC)) {
    sub NFS_MAGIC () {	60012;}
}
unless(defined(&CHECKSUM)) {
    sub CHECKSUM () {	84446;}
}
unless(defined(&spcl)) {
    sub spcl () {	 ($u_spcl->{s_spcl});}
}
unless(defined(&DUMPOUTFMT)) {
    sub DUMPOUTFMT () {	"%-16s %c %s";}
}
unless(defined(&DUMPINFMT)) {
    sub DUMPINFMT () {	"%16s %c %[^\n]\n";}
}
1;
