require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_RESOLV)) {
    eval 'sub _H_RESOLV () {1;}' unless defined(&_H_RESOLV);
    require 'sys/param.ph';
    require 'sys/types.ph';
    require 'sys/cdefs.ph';
    require 'stdio.ph';
    require 'netinet/in.ph';
    if(defined(&_POWER_PROLOG_)) {
    }
    if(defined(&_USE_IRS)) {
	eval 'sub IRS_CONST_UCHAR () { &const \'u_char\';}' unless defined(&IRS_CONST_UCHAR);
	eval 'sub IRS_CONST_CHAR () { &const \'char\';}' unless defined(&IRS_CONST_CHAR);
    } else {
	eval 'sub IRS_CONST_UCHAR () {\'char\';}' unless defined(&IRS_CONST_UCHAR);
	eval 'sub IRS_CONST_CHAR () {\'char\';}' unless defined(&IRS_CONST_CHAR);
    }
    if(defined(&_USE_IRS)) {
	eval 'sub MAXDNAME () {1025;}' unless defined(&MAXDNAME);
    } else {
	eval 'sub MAXDNAME () {256;}' unless defined(&MAXDNAME);
    }
    eval 'sub __RES () {19991006;}' unless defined(&__RES);
    unless(defined(&_PATH_RESCONF)) {
	eval 'sub _PATH_RESCONF () {"/etc/resolv.conf";}' unless defined(&_PATH_RESCONF);
    }
    eval("sub res_goahead () { 0; }") unless defined(&res_goahead);
    eval("sub res_nextns () { 1; }") unless defined(&res_nextns);
    eval("sub res_modified () { 2; }") unless defined(&res_modified);
    eval("sub res_done () { 3; }") unless defined(&res_done);
    eval("sub res_error () { 4; }") unless defined(&res_error);
    eval 'sub MAXNS () {3;}' unless defined(&MAXNS);
    eval 'sub MAXDFLSRCH () {3;}' unless defined(&MAXDFLSRCH);
    eval 'sub MAXDNSRCH () {6;}' unless defined(&MAXDNSRCH);
    eval 'sub LOCALDOMAINPARTS () {2;}' unless defined(&LOCALDOMAINPARTS);
    eval 'sub RES_TIMEOUT () {5;}' unless defined(&RES_TIMEOUT);
    eval 'sub MAXRESOLVSORT () {10;}' unless defined(&MAXRESOLVSORT);
    eval 'sub RES_MAXNDOTS () {15;}' unless defined(&RES_MAXNDOTS);
    eval 'sub RES_MAXRETRANS () {30;}' unless defined(&RES_MAXRETRANS);
    eval 'sub RES_MAXRETRY () {5;}' unless defined(&RES_MAXRETRY);
    eval 'sub RES_DFLRETRY () {2;}' unless defined(&RES_DFLRETRY);
    if(defined(&BIND_8_RESSTATE)) {
    } else {
	eval 'sub __res_state () { &state;}' unless defined(&__res_state);
    }
    eval 'sub nsaddr () { $nsaddr_list[0];}' unless defined(&nsaddr);
    eval 'sub RES_F_VC () {0x1;}' unless defined(&RES_F_VC);
    eval 'sub RES_F_CONN () {0x2;}' unless defined(&RES_F_CONN);
    eval 'sub RES_EXHAUSTIVE () {0x1;}' unless defined(&RES_EXHAUSTIVE);
    eval 'sub RES_INIT () {0x1;}' unless defined(&RES_INIT);
    eval 'sub RES_DEBUG () {0x2;}' unless defined(&RES_DEBUG);
    eval 'sub RES_AAONLY () {0x4;}' unless defined(&RES_AAONLY);
    eval 'sub RES_USEVC () {0x8;}' unless defined(&RES_USEVC);
    eval 'sub RES_PRIMARY () {0x10;}' unless defined(&RES_PRIMARY);
    eval 'sub RES_IGNTC () {0x20;}' unless defined(&RES_IGNTC);
    eval 'sub RES_RECURSE () {0x40;}' unless defined(&RES_RECURSE);
    eval 'sub RES_DEFNAMES () {0x80;}' unless defined(&RES_DEFNAMES);
    eval 'sub RES_STAYOPEN () {0x100;}' unless defined(&RES_STAYOPEN);
    eval 'sub RES_DNSRCH () {0x200;}' unless defined(&RES_DNSRCH);
    eval 'sub RES_INSECURE1 () {0x400;}' unless defined(&RES_INSECURE1);
    eval 'sub RES_INSECURE2 () {0x800;}' unless defined(&RES_INSECURE2);
    eval 'sub RES_NOALIASES () {0x1000;}' unless defined(&RES_NOALIASES);
    eval 'sub RES_MAPINET6 () {0x2000;}' unless defined(&RES_MAPINET6);
    eval 'sub RES_MAPINET4 () {0x4000;}' unless defined(&RES_MAPINET4);
    eval 'sub RES_MAPSIT () {0x8000;}' unless defined(&RES_MAPSIT);
    eval 'sub RES_NOFALL6 () {0x10000;}' unless defined(&RES_NOFALL6);
    eval 'sub RES_USE_INET6 () {0x20000;}' unless defined(&RES_USE_INET6);
    eval 'sub RES_ROTATE () {0x40000;}' unless defined(&RES_ROTATE);
    eval 'sub RES_NOCHECKNAME () {0x80000;}' unless defined(&RES_NOCHECKNAME);
    eval 'sub RES_KEEPTSIG () {0x100000;}' unless defined(&RES_KEEPTSIG);
    eval 'sub RES_DEFAULT () {( &RES_RECURSE |  &RES_DEFNAMES |  &RES_DNSRCH);}' unless defined(&RES_DEFAULT);
    eval 'sub RES_PRF_STATS () {0x1;}' unless defined(&RES_PRF_STATS);
    eval 'sub RES_PRF_UPDATE () {0x2;}' unless defined(&RES_PRF_UPDATE);
    eval 'sub RES_PRF_CLASS () {0x4;}' unless defined(&RES_PRF_CLASS);
    eval 'sub RES_PRF_CMD () {0x8;}' unless defined(&RES_PRF_CMD);
    eval 'sub RES_PRF_QUES () {0x10;}' unless defined(&RES_PRF_QUES);
    eval 'sub RES_PRF_ANS () {0x20;}' unless defined(&RES_PRF_ANS);
    eval 'sub RES_PRF_AUTH () {0x40;}' unless defined(&RES_PRF_AUTH);
    eval 'sub RES_PRF_ADD () {0x80;}' unless defined(&RES_PRF_ADD);
    eval 'sub RES_PRF_HEAD1 () {0x100;}' unless defined(&RES_PRF_HEAD1);
    eval 'sub RES_PRF_HEAD2 () {0x200;}' unless defined(&RES_PRF_HEAD2);
    eval 'sub RES_PRF_TTLID () {0x400;}' unless defined(&RES_PRF_TTLID);
    eval 'sub RES_PRF_HEADX () {0x800;}' unless defined(&RES_PRF_HEADX);
    eval 'sub RES_PRF_QUERY () {0x1000;}' unless defined(&RES_PRF_QUERY);
    eval 'sub RES_PRF_REPLY () {0x2000;}' unless defined(&RES_PRF_REPLY);
    eval 'sub RES_PRF_INIT () {0x4000;}' unless defined(&RES_PRF_INIT);
    if(defined(&BIND_8_RESSTATE)) {
	eval 'sub WHICH_RES_STATE () {
	    eval q( &__res_state());
	}' unless defined(&WHICH_RES_STATE);
    } else {
	eval 'sub WHICH_RES_STATE () {
	    eval q( &__which_res_state());
	}' unless defined(&WHICH_RES_STATE);
    }
    eval 'sub _res () {(* &WHICH_RES_STATE());}' unless defined(&_res);
    eval 'sub RES_SET_H_ERRNO {
        my($r,$x) = @_;
	    eval q( &__h_errno_set($r,$x));
    }' unless defined(&RES_SET_H_ERRNO);
    if(defined(&_USE_IRS)) {
    } else {
    }
    if(defined(&_ARPA_NAMESER_H_)) {
    }
    eval 'sub res_init () { &_res_init;}' unless defined(&res_init);
}
1;
