require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&_AIX_TIRPC)) {
    require 'tirpc/rpc/key_prot.ph';
} else {
    unless(defined(&_RPC_KEY_PROT_H)) {
	eval 'sub _RPC_KEY_PROT_H () {1;}' unless defined(&_RPC_KEY_PROT_H);
	eval 'sub KEY_PROG () {100029;}' unless defined(&KEY_PROG);
	eval 'sub KEY_VERS () {1;}' unless defined(&KEY_VERS);
	eval 'sub KEY_SET () {1;}' unless defined(&KEY_SET);
	eval 'sub KEY_ENCRYPT () {2;}' unless defined(&KEY_ENCRYPT);
	eval 'sub KEY_DECRYPT () {3;}' unless defined(&KEY_DECRYPT);
	eval 'sub KEY_GEN () {4;}' unless defined(&KEY_GEN);
	eval 'sub KEY_GETCRED () {5;}' unless defined(&KEY_GETCRED);
	eval 'sub PROOT () {3;}' unless defined(&PROOT);
	eval 'sub HEXMODULUS () {"d4a0ba0250b6fd2ec626e7efd637df76c716e22d0944b88b";}' unless defined(&HEXMODULUS);
	eval 'sub HEXKEYBYTES () {48;}' unless defined(&HEXKEYBYTES);
	eval 'sub KEYSIZE () {192;}' unless defined(&KEYSIZE);
	eval 'sub KEYBYTES () {24;}' unless defined(&KEYBYTES);
	eval 'sub KEYCHECKSUMSIZE () {16;}' unless defined(&KEYCHECKSUMSIZE);
	eval("sub KEY_SUCCESS () { 0; }") unless defined(&KEY_SUCCESS);
	eval("sub KEY_NOSECRET () { 1; }") unless defined(&KEY_NOSECRET);
	eval("sub KEY_UNKNOWN () { 2; }") unless defined(&KEY_UNKNOWN);
	eval("sub KEY_SYSTEMERR () { 3; }") unless defined(&KEY_SYSTEMERR);
	unless(defined(&_KERNEL)) {
	}
	eval 'sub MAXGIDS () {16;}' unless defined(&MAXGIDS);
    }
}
1;
