require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&_ONCPLUS)) {
    require 'oncplus/rpcsvc/mount.ph';
} else {
    unless(defined(&_H_rpcsvc_mount)) {
	eval 'sub _H_rpcsvc_mount () {1;}' unless defined(&_H_rpcsvc_mount);
	eval 'sub MOUNTPROG () {100005;}' unless defined(&MOUNTPROG);
	eval 'sub MOUNTPROC_MNT () {1;}' unless defined(&MOUNTPROC_MNT);
	eval 'sub MOUNTPROC_DUMP () {2;}' unless defined(&MOUNTPROC_DUMP);
	eval 'sub MOUNTPROC_UMNT () {3;}' unless defined(&MOUNTPROC_UMNT);
	eval 'sub MOUNTPROC_UMNTALL () {4;}' unless defined(&MOUNTPROC_UMNTALL);
	eval 'sub MOUNTPROC_EXPORT () {5;}' unless defined(&MOUNTPROC_EXPORT);
	eval 'sub MOUNTPROC_EXPORTALL () {6;}' unless defined(&MOUNTPROC_EXPORTALL);
	eval 'sub MOUNTPROC_PATHCONF () {7;}' unless defined(&MOUNTPROC_PATHCONF);
	eval 'sub MOUNTVERS () {1;}' unless defined(&MOUNTVERS);
	eval 'sub MOUNTVERS_POSIX () {2;}' unless defined(&MOUNTVERS_POSIX);
	unless(defined(&svc_getcaller)) {
	    eval 'sub svc_getcaller {
	        my($x) = @_;
    		eval q((($x)-> &xp_raddr));
	    }' unless defined(&svc_getcaller);
	}
	eval 'sub MNTOPT_ACDIRMAX () {"acdirmax";}' unless defined(&MNTOPT_ACDIRMAX);
	eval 'sub MNTOPT_ACDIRMIN () {"acdirmin";}' unless defined(&MNTOPT_ACDIRMIN);
	eval 'sub MNTOPT_ACREGMAX () {"acregmax";}' unless defined(&MNTOPT_ACREGMAX);
	eval 'sub MNTOPT_ACREGMIN () {"acregmin";}' unless defined(&MNTOPT_ACREGMIN);
	eval 'sub MNTOPT_ACTIMEO () {"actimeo";}' unless defined(&MNTOPT_ACTIMEO);
	eval 'sub MNTOPT_BG () {"bg";}' unless defined(&MNTOPT_BG);
	eval 'sub MNTOPT_FG () {"fg";}' unless defined(&MNTOPT_FG);
	eval 'sub MNTOPT_GRPID () {"grpid";}' unless defined(&MNTOPT_GRPID);
	eval 'sub MNTOPT_HARD () {"hard";}' unless defined(&MNTOPT_HARD);
	eval 'sub MNTOPT_INTR () {"intr";}' unless defined(&MNTOPT_INTR);
	eval 'sub MNTOPT_NOAC () {"noac";}' unless defined(&MNTOPT_NOAC);
	eval 'sub MNTOPT_NOACL () {"noacl";}' unless defined(&MNTOPT_NOACL);
	eval 'sub MNTOPT_ACL () {"acl";}' unless defined(&MNTOPT_ACL);
	eval 'sub MNTOPT_NOAUTO () {"noauto";}' unless defined(&MNTOPT_NOAUTO);
	eval 'sub MNTOPT_NOCTO () {"nocto";}' unless defined(&MNTOPT_NOCTO);
	eval 'sub MNTOPT_NODEV () {"nodev";}' unless defined(&MNTOPT_NODEV);
	eval 'sub MNTOPT_NOQUOTA () {"noquota";}' unless defined(&MNTOPT_NOQUOTA);
	eval 'sub MNTOPT_NOSUID () {"nosuid";}' unless defined(&MNTOPT_NOSUID);
	eval 'sub MNTOPT_BSY () {"bsy";}' unless defined(&MNTOPT_BSY);
	eval 'sub MNTOPT_PORT () {"port";}' unless defined(&MNTOPT_PORT);
	eval 'sub MNTOPT_POSIX () {"posix";}' unless defined(&MNTOPT_POSIX);
	eval 'sub MNTOPT_QUOTA () {"quota";}' unless defined(&MNTOPT_QUOTA);
	eval 'sub MNTOPT_RETRANS () {"retrans";}' unless defined(&MNTOPT_RETRANS);
	eval 'sub MNTOPT_RETRYS () {"retry";}' unless defined(&MNTOPT_RETRYS);
	eval 'sub MNTOPT_RMNT () {"remount";}' unless defined(&MNTOPT_RMNT);
	eval 'sub MNTOPT_RO () {"ro";}' unless defined(&MNTOPT_RO);
	eval 'sub MNTOPT_RSIZE () {"rsize";}' unless defined(&MNTOPT_RSIZE);
	eval 'sub MNTOPT_RW () {"rw";}' unless defined(&MNTOPT_RW);
	eval 'sub MNTOPT_SECURE () {"secure";}' unless defined(&MNTOPT_SECURE);
	eval 'sub MNTOPT_SHORTDEV () {"shortdev";}' unless defined(&MNTOPT_SHORTDEV);
	eval 'sub MNTOPT_SOFT () {"soft";}' unless defined(&MNTOPT_SOFT);
	eval 'sub MNTOPT_TIMEO () {"timeo";}' unless defined(&MNTOPT_TIMEO);
	eval 'sub MNTOPT_WSIZE () {"wsize";}' unless defined(&MNTOPT_WSIZE);
	eval 'sub NFSMNT_SOFT () {0x1;}' unless defined(&NFSMNT_SOFT);
	eval 'sub NFSMNT_WSIZE () {0x2;}' unless defined(&NFSMNT_WSIZE);
	eval 'sub NFSMNT_RSIZE () {0x4;}' unless defined(&NFSMNT_RSIZE);
	eval 'sub NFSMNT_TIMEO () {0x8;}' unless defined(&NFSMNT_TIMEO);
	eval 'sub NFSMNT_RETRANS () {0x10;}' unless defined(&NFSMNT_RETRANS);
	eval 'sub NFSMNT_HOSTNAME () {0x20;}' unless defined(&NFSMNT_HOSTNAME);
	eval 'sub NFSMNT_INT () {0x40;}' unless defined(&NFSMNT_INT);
	eval 'sub NFSMNT_NOAC () {0x80;}' unless defined(&NFSMNT_NOAC);
	eval 'sub NFSMNT_ACREGMIN () {0x100;}' unless defined(&NFSMNT_ACREGMIN);
	eval 'sub NFSMNT_ACREGMAX () {0x200;}' unless defined(&NFSMNT_ACREGMAX);
	eval 'sub NFSMNT_ACDIRMIN () {0x400;}' unless defined(&NFSMNT_ACDIRMIN);
	eval 'sub NFSMNT_ACDIRMAX () {0x800;}' unless defined(&NFSMNT_ACDIRMAX);
	eval 'sub NFSMNT_SECURE () {0x1000;}' unless defined(&NFSMNT_SECURE);
	eval 'sub NFSMNT_NOCTO () {0x2000;}' unless defined(&NFSMNT_NOCTO);
	eval 'sub NFSMNT_POSIX () {0x4000;}' unless defined(&NFSMNT_POSIX);
	eval 'sub NFSMNT_NOACL () {0x8000;}' unless defined(&NFSMNT_NOACL);
	eval 'sub NFSMNT_SHORTDEV () {0x10000;}' unless defined(&NFSMNT_SHORTDEV);
	eval 'sub NFSMNT_BIODS () {0x20000;}' unless defined(&NFSMNT_BIODS);
	eval 'sub NFSMNT_GRPID () {0x40000;}' unless defined(&NFSMNT_GRPID);
	eval 'sub NFSMNT_ACL () {0x80000;}' unless defined(&NFSMNT_ACL);
	eval 'sub DEF_BIODS () {6;}' unless defined(&DEF_BIODS);
	require 'rpc/xdr.ph';
	unless(defined(&KERNEL)) {
	    require 'sys/types.ph';
	}
    }
}
1;
