require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&YPOLDVERS)) {
    sub YPOLDVERS () {	( &YPVERS - 1);}
}
unless(defined(&YPOLDPROC_NULL)) {
    sub YPOLDPROC_NULL () {	(0);}
}
unless(defined(&YPOLDPROC_DOMAIN)) {
    sub YPOLDPROC_DOMAIN () {	(1);}
}
unless(defined(&YPOLDPROC_DOMAIN_NONACK)) {
    sub YPOLDPROC_DOMAIN_NONACK () {	(2);}
}
unless(defined(&YPOLDPROC_MATCH)) {
    sub YPOLDPROC_MATCH () {	(3);}
}
unless(defined(&YPOLDPROC_FIRST)) {
    sub YPOLDPROC_FIRST () {	(4);}
}
unless(defined(&YPOLDPROC_NEXT)) {
    sub YPOLDPROC_NEXT () {	(5);}
}
unless(defined(&YPOLDPROC_POLL)) {
    sub YPOLDPROC_POLL () {	(6);}
}
unless(defined(&YPOLDPROC_PUSH)) {
    sub YPOLDPROC_PUSH () {	(7);}
}
unless(defined(&YPOLDPROC_PULL)) {
    sub YPOLDPROC_PULL () {	(8);}
}
unless(defined(&YPOLDPROC_GET)) {
    sub YPOLDPROC_GET () {	(9);}
}
eval("sub YPREQ_KEY () { 1; }") unless defined(&YPREQ_KEY);
eval("sub YPREQ_NOKEY () { 2; }") unless defined(&YPREQ_NOKEY);
eval("sub YPREQ_MAP_PARMS () { 3; }") unless defined(&YPREQ_MAP_PARMS);
unless(defined(&YPMATCH_REQTYPE)) {
    sub YPMATCH_REQTYPE () {	 &YPREQ_KEY;}
}
unless(defined(&ypmatch_req_domain)) {
    sub ypmatch_req_domain () {	 ($yp_reqbody->{yp_req_keytype}->{domain});}
}
unless(defined(&ypmatch_req_map)) {
    sub ypmatch_req_map () {	 ($yp_reqbody->{yp_req_keytype}->{map});}
}
unless(defined(&ypmatch_req_keydat)) {
    sub ypmatch_req_keydat () {	 ($yp_reqbody->{yp_req_keytype}->{keydat});}
}
unless(defined(&ypmatch_req_keyptr)) {
    sub ypmatch_req_keyptr () {	 ($yp_reqbody->{yp_req_keytype}->{keydat}->{dptr});}
}
unless(defined(&ypmatch_req_keysize)) {
    sub ypmatch_req_keysize () {	 ($yp_reqbody->{yp_req_keytype}->{keydat}->{dsize});}
}
unless(defined(&YPFIRST_REQTYPE)) {
    sub YPFIRST_REQTYPE () {	 &YPREQ_NOKEY;}
}
unless(defined(&ypfirst_req_domain)) {
    sub ypfirst_req_domain () {	 ($yp_reqbody->{yp_req_nokeytype}->{domain});}
}
unless(defined(&ypfirst_req_map)) {
    sub ypfirst_req_map () {	 ($yp_reqbody->{yp_req_nokeytype}->{map});}
}
unless(defined(&YPNEXT_REQTYPE)) {
    sub YPNEXT_REQTYPE () {	 &YPREQ_KEY;}
}
unless(defined(&ypnext_req_domain)) {
    sub ypnext_req_domain () {	 ($yp_reqbody->{yp_req_keytype}->{domain});}
}
unless(defined(&ypnext_req_map)) {
    sub ypnext_req_map () {	 ($yp_reqbody->{yp_req_keytype}->{map});}
}
unless(defined(&ypnext_req_keydat)) {
    sub ypnext_req_keydat () {	 ($yp_reqbody->{yp_req_keytype}->{keydat});}
}
unless(defined(&ypnext_req_keyptr)) {
    sub ypnext_req_keyptr () {	 ($yp_reqbody->{yp_req_keytype}->{keydat}->{dptr});}
}
unless(defined(&ypnext_req_keysize)) {
    sub ypnext_req_keysize () {	 ($yp_reqbody->{yp_req_keytype}->{keydat}->{dsize});}
}
unless(defined(&YPPUSH_REQTYPE)) {
    sub YPPUSH_REQTYPE () {	 &YPREQ_NOKEY;}
}
unless(defined(&yppush_req_domain)) {
    sub yppush_req_domain () {	 ($yp_reqbody->{yp_req_nokeytype}->{domain});}
}
unless(defined(&yppush_req_map)) {
    sub yppush_req_map () {	 ($yp_reqbody->{yp_req_nokeytype}->{map});}
}
unless(defined(&YPPULL_REQTYPE)) {
    sub YPPULL_REQTYPE () {	 &YPREQ_NOKEY;}
}
unless(defined(&yppull_req_domain)) {
    sub yppull_req_domain () {	 ($yp_reqbody->{yp_req_nokeytype}->{domain});}
}
unless(defined(&yppull_req_map)) {
    sub yppull_req_map () {	 ($yp_reqbody->{yp_req_nokeytype}->{map});}
}
unless(defined(&YPPOLL_REQTYPE)) {
    sub YPPOLL_REQTYPE () {	 &YPREQ_NOKEY;}
}
unless(defined(&yppoll_req_domain)) {
    sub yppoll_req_domain () {	 ($yp_reqbody->{yp_req_nokeytype}->{domain});}
}
unless(defined(&yppoll_req_map)) {
    sub yppoll_req_map () {	 ($yp_reqbody->{yp_req_nokeytype}->{map});}
}
unless(defined(&YPGET_REQTYPE)) {
    sub YPGET_REQTYPE () {	 &YPREQ_MAP_PARMS;}
}
unless(defined(&ypget_req_domain)) {
    sub ypget_req_domain () {	 ($yp_reqbody->{yp_req_map_parmstype}->{domain});}
}
unless(defined(&ypget_req_map)) {
    sub ypget_req_map () {	 ($yp_reqbody->{yp_req_map_parmstype}->{map});}
}
unless(defined(&ypget_req_ordernum)) {
    sub ypget_req_ordernum () {	 ($yp_reqbody->{yp_req_map_parmstype}->{ordernum});}
}
unless(defined(&ypget_req_owner)) {
    sub ypget_req_owner () {	 ($yp_reqbody->{yp_req_map_parmstype}->{owner});}
}
eval("sub YPRESP_VAL () { 1; }") unless defined(&YPRESP_VAL);
eval("sub YPRESP_KEY_VAL () { 2; }") unless defined(&YPRESP_KEY_VAL);
eval("sub YPRESP_MAP_PARMS () { 3; }") unless defined(&YPRESP_MAP_PARMS);
unless(defined(&YPMATCH_RESPTYPE)) {
    sub YPMATCH_RESPTYPE () {	 &YPRESP_VAL;}
}
unless(defined(&ypmatch_resp_status)) {
    sub ypmatch_resp_status () {	 ($yp_respbody->{yp_resp_valtype}->{status});}
}
unless(defined(&ypmatch_resp_valdat)) {
    sub ypmatch_resp_valdat () {	 ($yp_respbody->{yp_resp_valtype}->{valdat});}
}
unless(defined(&ypmatch_resp_valptr)) {
    sub ypmatch_resp_valptr () {	 ($yp_respbody->{yp_resp_valtype}->{valdat}->{dptr});}
}
unless(defined(&ypmatch_resp_valsize)) {
    sub ypmatch_resp_valsize () {	 ($yp_respbody->{yp_resp_valtype}->{valdat}->{dsize});}
}
unless(defined(&YPFIRST_RESPTYPE)) {
    sub YPFIRST_RESPTYPE () {	 &YPRESP_KEY_VAL;}
}
unless(defined(&ypfirst_resp_status)) {
    sub ypfirst_resp_status () {	 ($yp_respbody->{yp_resp_key_valtype}->{status});}
}
unless(defined(&ypfirst_resp_keydat)) {
    sub ypfirst_resp_keydat () {	 ($yp_respbody->{yp_resp_key_valtype}->{keydat});}
}
unless(defined(&ypfirst_resp_keyptr)) {
    sub ypfirst_resp_keyptr () {	 ($yp_respbody->{yp_resp_key_valtype}->{keydat}->{dptr});}
}
unless(defined(&ypfirst_resp_keysize)) {
    sub ypfirst_resp_keysize () {	 ($yp_respbody->{yp_resp_key_valtype}->{keydat}->{dsize});}
}
unless(defined(&ypfirst_resp_valdat)) {
    sub ypfirst_resp_valdat () {	 ($yp_respbody->{yp_resp_key_valtype}->{valdat});}
}
unless(defined(&ypfirst_resp_valptr)) {
    sub ypfirst_resp_valptr () {	 ($yp_respbody->{yp_resp_key_valtype}->{valdat}->{dptr});}
}
unless(defined(&ypfirst_resp_valsize)) {
    sub ypfirst_resp_valsize () {	 ($yp_respbody->{yp_resp_key_valtype}->{valdat}->{dsize});}
}
unless(defined(&YPNEXT_RESPTYPE)) {
    sub YPNEXT_RESPTYPE () {	 &YPRESP_KEY_VAL;}
}
unless(defined(&ypnext_resp_status)) {
    sub ypnext_resp_status () {	 ($yp_respbody->{yp_resp_key_valtype}->{status});}
}
unless(defined(&ypnext_resp_keydat)) {
    sub ypnext_resp_keydat () {	 ($yp_respbody->{yp_resp_key_valtype}->{keydat});}
}
unless(defined(&ypnext_resp_keyptr)) {
    sub ypnext_resp_keyptr () {	 ($yp_respbody->{yp_resp_key_valtype}->{keydat}->{dptr});}
}
unless(defined(&ypnext_resp_keysize)) {
    sub ypnext_resp_keysize () {	 ($yp_respbody->{yp_resp_key_valtype}->{keydat}->{dsize});}
}
unless(defined(&ypnext_resp_valdat)) {
    sub ypnext_resp_valdat () {	 ($yp_respbody->{yp_resp_key_valtype}->{valdat});}
}
unless(defined(&ypnext_resp_valptr)) {
    sub ypnext_resp_valptr () {	 ($yp_respbody->{yp_resp_key_valtype}->{valdat}->{dptr});}
}
unless(defined(&ypnext_resp_valsize)) {
    sub ypnext_resp_valsize () {	 ($yp_respbody->{yp_resp_key_valtype}->{valdat}->{dsize});}
}
unless(defined(&YPPOLL_RESPTYPE)) {
    sub YPPOLL_RESPTYPE () {	 &YPRESP_MAP_PARMS;}
}
unless(defined(&yppoll_resp_domain)) {
    sub yppoll_resp_domain () {	 ($yp_respbody->{yp_resp_map_parmstype}->{domain});}
}
unless(defined(&yppoll_resp_map)) {
    sub yppoll_resp_map () {	 ($yp_respbody->{yp_resp_map_parmstype}->{map});}
}
unless(defined(&yppoll_resp_ordernum)) {
    sub yppoll_resp_ordernum () {	 ($yp_respbody->{yp_resp_map_parmstype}->{ordernum});}
}
unless(defined(&yppoll_resp_owner)) {
    sub yppoll_resp_owner () {	 ($yp_respbody->{yp_resp_map_parmstype}->{owner});}
}
unless(defined(&YPBINDOLDVERS)) {
    sub YPBINDOLDVERS () {	( &YPBINDVERS - 1);}
}
unless(defined(&ypoldsetdom_addr)) {
    sub ypoldsetdom_addr () {	 ($ypoldsetdom_binding->{ypbind_binding_addr});}
}
unless(defined(&ypoldsetdom_port)) {
    sub ypoldsetdom_port () {	 ($ypoldsetdom_binding->{ypbind_binding_port});}
}
1;
