require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_CT)) {
    eval 'sub _H_CT () {1;}' unless defined(&_H_CT);
    if(defined(&__cplusplus)) {
    }
    require 'inttypes.ph';
    eval("sub CT_UNKNOWN () { 0; }") unless defined(&CT_UNKNOWN);
    eval("sub CT_NONE () { 1; }") unless defined(&CT_NONE);
    eval("sub CT_INT32 () { 2; }") unless defined(&CT_INT32);
    eval("sub CT_UINT32 () { 3; }") unless defined(&CT_UINT32);
    eval("sub CT_INT64 () { 4; }") unless defined(&CT_INT64);
    eval("sub CT_UINT64 () { 5; }") unless defined(&CT_UINT64);
    eval("sub CT_FLOAT32 () { 6; }") unless defined(&CT_FLOAT32);
    eval("sub CT_FLOAT64 () { 7; }") unless defined(&CT_FLOAT64);
    eval("sub CT_CHAR_PTR () { 8; }") unless defined(&CT_CHAR_PTR);
    eval("sub CT_BINARY_PTR () { 9; }") unless defined(&CT_BINARY_PTR);
    eval("sub CT_RSRC_HANDLE_PTR () { 10; }") unless defined(&CT_RSRC_HANDLE_PTR);
    eval("sub CT_SD_PTR () { 11; }") unless defined(&CT_SD_PTR);
    eval("sub CT_SBS_PTR () { 12; }") unless defined(&CT_SBS_PTR);
    eval("sub CT_INT32_ARRAY () { 13; }") unless defined(&CT_INT32_ARRAY);
    eval("sub CT_UINT32_ARRAY () { 14; }") unless defined(&CT_UINT32_ARRAY);
    eval("sub CT_INT64_ARRAY () { 15; }") unless defined(&CT_INT64_ARRAY);
    eval("sub CT_UINT64_ARRAY () { 16; }") unless defined(&CT_UINT64_ARRAY);
    eval("sub CT_FLOAT32_ARRAY () { 17; }") unless defined(&CT_FLOAT32_ARRAY);
    eval("sub CT_FLOAT64_ARRAY () { 18; }") unless defined(&CT_FLOAT64_ARRAY);
    eval("sub CT_CHAR_PTR_ARRAY () { 19; }") unless defined(&CT_CHAR_PTR_ARRAY);
    eval("sub CT_BINARY_PTR_ARRAY () { 20; }") unless defined(&CT_BINARY_PTR_ARRAY);
    eval("sub CT_RSRC_HANDLE_PTR_ARRAY () { 21; }") unless defined(&CT_RSRC_HANDLE_PTR_ARRAY);
    eval("sub CT_SD_PTR_ARRAY () { 22; }") unless defined(&CT_SD_PTR_ARRAY);
    eval("sub CT_SF_INT32 () { 0; }") unless defined(&CT_SF_INT32);
    eval("sub CT_SF_FLOAT32 () { 1; }") unless defined(&CT_SF_FLOAT32);
    eval("sub CT_SF_STRING () { 2; }") unless defined(&CT_SF_STRING);
    eval("sub CT_SF_BINARY () { 3; }") unless defined(&CT_SF_BINARY);
    eval("sub CT_CONTACT_IP () { 0; }") unless defined(&CT_CONTACT_IP);
    eval("sub CT_CONTACT_ENV_VAR () { 1; }") unless defined(&CT_CONTACT_ENV_VAR);
    eval("sub CT_CONTACT_LOCAL () { 2; }") unless defined(&CT_CONTACT_LOCAL);
    if(defined(&_AIX)) {
	if(defined(&__64BIT__)) {
	    eval 'sub CT_PRI64_PREFIX () {"l";}' unless defined(&CT_PRI64_PREFIX);
	} else {
	    eval 'sub CT_PRI64_PREFIX () {"ll";}' unless defined(&CT_PRI64_PREFIX);
	}
    }
    if(defined(&__linux__)) {
	if((defined(&__WORDSIZE) ? &__WORDSIZE : 0) == 64) {
	    eval 'sub CT_PRI64_PREFIX () {"l";}' unless defined(&CT_PRI64_PREFIX);
	} else {
	    eval 'sub CT_PRI64_PREFIX () {"ll";}' unless defined(&CT_PRI64_PREFIX);
	}
    }
    unless(defined(&CT_PRI64_PREFIX)) {
	eval 'sub CT_PRI64_PREFIX () {"ll";}' unless defined(&CT_PRI64_PREFIX);
    }
    eval 'sub CT_PRId8 () {"hd";}' unless defined(&CT_PRId8);
    eval 'sub CT_PRId16 () {"hd";}' unless defined(&CT_PRId16);
    eval 'sub CT_PRId32 () {"d";}' unless defined(&CT_PRId32);
    eval 'sub CT_PRId64 () { &CT_PRI64_PREFIX "d";}' unless defined(&CT_PRId64);
    eval 'sub CT_PRIi8 () {"hi";}' unless defined(&CT_PRIi8);
    eval 'sub CT_PRIi16 () {"hi";}' unless defined(&CT_PRIi16);
    eval 'sub CT_PRIi32 () {"i";}' unless defined(&CT_PRIi32);
    eval 'sub CT_PRIi64 () { &CT_PRI64_PREFIX "i";}' unless defined(&CT_PRIi64);
    eval 'sub CT_PRIo8 () {"ho";}' unless defined(&CT_PRIo8);
    eval 'sub CT_PRIo16 () {"ho";}' unless defined(&CT_PRIo16);
    eval 'sub CT_PRIo32 () {"o";}' unless defined(&CT_PRIo32);
    eval 'sub CT_PRIo64 () { &CT_PRI64_PREFIX "o";}' unless defined(&CT_PRIo64);
    eval 'sub CT_PRIx8 () {"hx";}' unless defined(&CT_PRIx8);
    eval 'sub CT_PRIx16 () {"hx";}' unless defined(&CT_PRIx16);
    eval 'sub CT_PRIx32 () {"x";}' unless defined(&CT_PRIx32);
    eval 'sub CT_PRIx64 () { &CT_PRI64_PREFIX "x";}' unless defined(&CT_PRIx64);
    eval 'sub CT_PRIX8 () {"hX";}' unless defined(&CT_PRIX8);
    eval 'sub CT_PRIX16 () {"hX";}' unless defined(&CT_PRIX16);
    eval 'sub CT_PRIX32 () {"X";}' unless defined(&CT_PRIX32);
    eval 'sub CT_PRIX64 () { &CT_PRI64_PREFIX "X";}' unless defined(&CT_PRIX64);
    eval 'sub CT_PRIu8 () {"hu";}' unless defined(&CT_PRIu8);
    eval 'sub CT_PRIu16 () {"hu";}' unless defined(&CT_PRIu16);
    eval 'sub CT_PRIu32 () {"u";}' unless defined(&CT_PRIu32);
    eval 'sub CT_PRIu64 () { &CT_PRI64_PREFIX "u";}' unless defined(&CT_PRIu64);
    if(defined(&__cplusplus)) {
    }
}
1;
