require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_CT_CU_PROC)) {
    eval 'sub _H_CT_CU_PROC () {1;}' unless defined(&_H_CT_CU_PROC);
    require 'rsct/ct_cu.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_AIX)) {
	require 'procinfo.ph';
	require 'sys/proc.ph';
    }
    eval 'sub cu_get_proc_info () { &CU_ROUTINE_VERSION( &cu_get_proc_info,  &CU_VERSION);}' unless defined(&cu_get_proc_info);
    eval 'sub cu_get_procs () { &CU_ROUTINE_VERSION( &cu_get_procs,  &CU_VERSION);}' unless defined(&cu_get_procs);
    eval 'sub cu_get_proc_args () { &CU_ROUTINE_VERSION( &cu_get_proc_args,  &CU_VERSION);}' unless defined(&cu_get_proc_args);
    eval 'sub cu_get_keyword_info () { &CU_ROUTINE_VERSION( &cu_get_keyword_info,  &CU_VERSION);}' unless defined(&cu_get_keyword_info);
    if(defined(&_AIX)) {
	eval 'sub CU_PROC_SNOTPROC {
	    my($p) = @_;
    	    eval q((($p) ==  &SNONE));
	}' unless defined(&CU_PROC_SNOTPROC);
	eval 'sub CU_PROC_STRANS {
	    my($p) = @_;
    	    eval q((($p) ==  &SIDL));
	}' unless defined(&CU_PROC_STRANS);
	eval 'sub CU_PROC_SZOMBIE {
	    my($p) = @_;
    	    eval q((($p) ==  &SZOMB));
	}' unless defined(&CU_PROC_SZOMBIE);
	eval 'sub CU_PROC_SACTIVE {
	    my($p) = @_;
    	    eval q((($p) ==  &SACTIVE));
	}' unless defined(&CU_PROC_SACTIVE);
	eval 'sub CU_PROC_SRUNNING {
	    my($p) = @_;
    	    eval q((($p) ==  &SACTIVE));
	}' unless defined(&CU_PROC_SRUNNING);
	eval 'sub CU_PROC_SSTOP {
	    my($p) = @_;
    	    eval q((($p) ==  &SSTOP));
	}' unless defined(&CU_PROC_SSTOP);
	eval 'sub CU_PROC_SWAIT {
	    my($p) = @_;
    	    eval q((($p) ==  &SSWAP));
	}' unless defined(&CU_PROC_SWAIT);
	eval 'sub CU_PROC_FLAG_KPROC {
	    my($p) = @_;
    	    eval q((($p) &  &SKPROC));
	}' unless defined(&CU_PROC_FLAG_KPROC);
	eval 'sub CU_PROC_FLAG_EXITING {
	    my($p) = @_;
    	    eval q((($p) &  &SEXIT));
	}' unless defined(&CU_PROC_FLAG_EXITING);
	eval 'sub CU_PROC_FLAG_EXECED {
	    my($p) = @_;
    	    eval q((($p) &  &SEXECED));
	}' unless defined(&CU_PROC_FLAG_EXECED);
	eval 'sub CU_PROC_FLAG_STARTING {
	    my($p) = @_;
    	    eval q((($p) &  &SEXECING));
	}' unless defined(&CU_PROC_FLAG_STARTING);
	eval 'sub CU_PROC_FLAG_TRACED {
	    my($p) = @_;
    	    eval q((($p) &  &STRC));
	}' unless defined(&CU_PROC_FLAG_TRACED);
    } else {
	eval 'sub CU_PROC_SNOTPROC {
	    my($p) = @_;
    	    eval q((($p) == ord(\' \')));
	}' unless defined(&CU_PROC_SNOTPROC);
	eval 'sub CU_PROC_STRANS {
	    my($p) = @_;
    	    eval q((0));
	}' unless defined(&CU_PROC_STRANS);
	eval 'sub CU_PROC_SZOMBIE {
	    my($p) = @_;
    	    eval q((($p) == ord(\'Z\')));
	}' unless defined(&CU_PROC_SZOMBIE);
	eval 'sub CU_PROC_SACTIVE {
	    my($p) = @_;
    	    eval q(( (($p) == ord(\'S\') || ((p) == \'R\')) ));
	}' unless defined(&CU_PROC_SACTIVE);
	eval 'sub CU_PROC_SRUNNING {
	    my($p) = @_;
    	    eval q((($p) == ord(\'R\')));
	}' unless defined(&CU_PROC_SRUNNING);
	eval 'sub CU_PROC_SSTOP {
	    my($p) = @_;
    	    eval q((($p) == ord(\'T\')));
	}' unless defined(&CU_PROC_SSTOP);
	eval 'sub CU_PROC_SWAIT {
	    my($p) = @_;
    	    eval q((($p) == ord(\'D\')));
	}' unless defined(&CU_PROC_SWAIT);
	eval 'sub CU_PROC_FLAG_KPROC {
	    my($p) = @_;
    	    eval q((($p) & 0x));
	}' unless defined(&CU_PROC_FLAG_KPROC);
	eval 'sub CU_PROC_FLAG_STARTING {
	    my($p) = @_;
    	    eval q((($p) & 0x2));
	}' unless defined(&CU_PROC_FLAG_STARTING);
	eval 'sub CU_PROC_FLAG_EXITING {
	    my($p) = @_;
    	    eval q((($p) & 0x4));
	}' unless defined(&CU_PROC_FLAG_EXITING);
	eval 'sub CU_PROC_FLAG_TRACED {
	    my($p) = @_;
    	    eval q((($p) & 0x10));
	}' unless defined(&CU_PROC_FLAG_TRACED);
	eval 'sub CU_PROC_FLAG_EXECED {
	    my($p) = @_;
    	    eval q(((($p) & 0x40)==0));
	}' unless defined(&CU_PROC_FLAG_EXECED);
    }
    if(((defined(&CU_VERSION) ? &CU_VERSION : 0) == 1) || defined( &CU_ALL_VERSIONS)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
