require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_CT_TR)) {
    eval 'sub _H_CT_TR () {1;}' unless defined(&_H_CT_TR);
    require 'rsct/ct.ph';
    require 'rsct/ct_cu.ph';
    require 'stdarg.ph';
    unless(defined(&TR_VERSION)) {
	eval 'sub TR_VERSION () {1;}' unless defined(&TR_VERSION);
    }
    eval 'sub TR_MIN_FILE_SIZE () {0x1000;}' unless defined(&TR_MIN_FILE_SIZE);
    eval 'sub TR_MAX_DATA_BLOCK () {0x10;}' unless defined(&TR_MAX_DATA_BLOCK);
    eval 'sub TR_PLATFORM_UNKNOWN () {0;}' unless defined(&TR_PLATFORM_UNKNOWN);
    eval 'sub TR_PLATFORM_AIX_POWERPC () {1;}' unless defined(&TR_PLATFORM_AIX_POWERPC);
    eval 'sub TR_PLATFORM_LINUX_INTEL () {2;}' unless defined(&TR_PLATFORM_LINUX_INTEL);
    eval 'sub TR_PLATFORM_AIX_IA64 () {3;}' unless defined(&TR_PLATFORM_AIX_IA64);
    eval 'sub TR_PLATFORM_LINUX_S390 () {4;}' unless defined(&TR_PLATFORM_LINUX_S390);
    eval 'sub TR_PLATFORM_LINUX_POWERPC () {5;}' unless defined(&TR_PLATFORM_LINUX_POWERPC);
    eval 'sub TR_NUMBER_OF_CATEGORIES_INVALID () {1;}' unless defined(&TR_NUMBER_OF_CATEGORIES_INVALID);
    eval 'sub TR_COMPONENT_ID_MISSING () {2;}' unless defined(&TR_COMPONENT_ID_MISSING);
    eval 'sub TR_CATEGORIES_MISSING () {3;}' unless defined(&TR_CATEGORIES_MISSING);
    eval 'sub TR_DETAIL_LEVELS_MISSING () {4;}' unless defined(&TR_DETAIL_LEVELS_MISSING);
    eval 'sub TR_CATEGORY_NAME_NULL () {5;}' unless defined(&TR_CATEGORY_NAME_NULL);
    eval 'sub TR_CATEGORY_ID_TOO_BIG () {6;}' unless defined(&TR_CATEGORY_ID_TOO_BIG);
    eval 'sub TR_DEFAULT_LEVEL_TOO_BIG () {7;}' unless defined(&TR_DEFAULT_LEVEL_TOO_BIG);
    eval 'sub TR_MINIMUM_LEVEL_TOO_BIG () {8;}' unless defined(&TR_MINIMUM_LEVEL_TOO_BIG);
    eval 'sub TR_NOT_ABLE_TO_LOCK () {9;}' unless defined(&TR_NOT_ABLE_TO_LOCK);
    eval 'sub TR_TRACE_SPEC_COMPID_EXPECTED () {10;}' unless defined(&TR_TRACE_SPEC_COMPID_EXPECTED);
    eval 'sub TR_TRACE_SPEC_SEPARATOR_EXPECTED () {11;}' unless defined(&TR_TRACE_SPEC_SEPARATOR_EXPECTED);
    eval 'sub TR_TRACE_SPEC_CATEGORY_EXPECTED () {12;}' unless defined(&TR_TRACE_SPEC_CATEGORY_EXPECTED);
    eval 'sub TR_TRACE_SPEC_DETAIL_LEVEL_EXPECTED () {13;}' unless defined(&TR_TRACE_SPEC_DETAIL_LEVEL_EXPECTED);
    eval 'sub TR_MEMORY_ALLOCATION_FAILED () {14;}' unless defined(&TR_MEMORY_ALLOCATION_FAILED);
    eval 'sub TR_TRACE_SPEC_COMPID_INVALID () {15;}' unless defined(&TR_TRACE_SPEC_COMPID_INVALID);
    eval 'sub TR_TRACE_SPEC_CATEGORY_INVALID () {16;}' unless defined(&TR_TRACE_SPEC_CATEGORY_INVALID);
    eval 'sub TR_FILENAME_INVALID () {17;}' unless defined(&TR_FILENAME_INVALID);
    eval 'sub TR_FILE_ERROR () {18;}' unless defined(&TR_FILE_ERROR);
    eval 'sub TR_FILE_STAT_ERROR () {19;}' unless defined(&TR_FILE_STAT_ERROR);
    eval 'sub TR_FILE_NOT_REGULAR_FILE () {20;}' unless defined(&TR_FILE_NOT_REGULAR_FILE);
    eval 'sub TR_COULD_NOT_MAP_FILE () {21;}' unless defined(&TR_COULD_NOT_MAP_FILE);
    eval 'sub TR_FILE_TRUNCATE_ERROR () {22;}' unless defined(&TR_FILE_TRUNCATE_ERROR);
    eval 'sub TR_FILE_FCLEAR_ERROR () {23;}' unless defined(&TR_FILE_FCLEAR_ERROR);
    eval 'sub TR_FILESIZE_MODIFIED () {24;}' unless defined(&TR_FILESIZE_MODIFIED);
    eval 'sub TR_TRACE_NOT_ACTIVE () {25;}' unless defined(&TR_TRACE_NOT_ACTIVE);
    eval 'sub TR_COMPONENT_NOT_REGISTERED () {26;}' unless defined(&TR_COMPONENT_NOT_REGISTERED);
    eval 'sub TR_STRING_MISSING () {27;}' unless defined(&TR_STRING_MISSING);
    eval 'sub TR_VSPRINTF_ERROR () {28;}' unless defined(&TR_VSPRINTF_ERROR);
    eval 'sub TR_TOO_MANY_DATA_BLOCKS () {29;}' unless defined(&TR_TOO_MANY_DATA_BLOCKS);
    eval 'sub TR_INVALID_DATA_BLOCK () {30;}' unless defined(&TR_INVALID_DATA_BLOCK);
    eval 'sub TR_INVALID_DATA_LENGTH () {31;}' unless defined(&TR_INVALID_DATA_LENGTH);
    eval 'sub TR_FILE_MSYNC_ERROR () {32;}' unless defined(&TR_FILE_MSYNC_ERROR);
    eval 'sub TR_FORMAT_STRING_MISSING () {33;}' unless defined(&TR_FORMAT_STRING_MISSING);
    eval 'sub TR_NUMBER_OF_STRINGS_INVALID () {34;}' unless defined(&TR_NUMBER_OF_STRINGS_INVALID);
    eval 'sub TR_FILE_NO_SPACE () {35;}' unless defined(&TR_FILE_NO_SPACE);
    eval 'sub TR_NOT_TRACE_FILE () {36;}' unless defined(&TR_NOT_TRACE_FILE);
    eval 'sub TR_INVALID_TRACE_HANDLE () {37;}' unless defined(&TR_INVALID_TRACE_HANDLE);
    eval 'sub tr_check {
        my( $level_array, $category, $lod ) = @_;
	    eval q(( <= *((($level_array))+($category))));
    }' unless defined(&tr_check);
    eval 'sub tr_record_int32 {
        my( $comp_id, $trace_id, $int1 ) = @_;
	    eval q( &tr_record_values_32( $comp_id, $trace_id, 1, ( &ct_int32_t)($int1) ));
    }' unless defined(&tr_record_int32);
    eval 'sub tr_record_int32_2 {
        my( $comp_id, $trace_id, $int1, $int2 ) = @_;
	    eval q( &tr_record_values_32( $comp_id, $trace_id, 2, ( &ct_int32_t)($int1), ( &ct_int32_t)($int2) ));
    }' unless defined(&tr_record_int32_2);
    eval 'sub tr_record_uint32 {
        my( $comp_id, $trace_id, $int1 ) = @_;
	    eval q( &tr_record_values_32( $comp_id, $trace_id, 1, ( &ct_uint32_t)($int1) ));
    }' unless defined(&tr_record_uint32);
    eval 'sub tr_record_uint32_2 {
        my( $comp_id, $trace_id, $int1, $int2 ) = @_;
	    eval q( &tr_record_values_32( $comp_id, $trace_id, 2, ( &ct_uint32_t)($int1), ( &ct_uint32_t)($int2) ));
    }' unless defined(&tr_record_uint32_2);
    eval 'sub tr_record_int64 {
        my( $comp_id, $trace_id, $int1 ) = @_;
	    eval q( &tr_record_values_64( $comp_id, $trace_id, 1, ( &ct_int64_t)($int1) ));
    }' unless defined(&tr_record_int64);
    eval 'sub tr_record_int64_2 {
        my( $comp_id, $trace_id, $int1, $int2 ) = @_;
	    eval q( &tr_record_values_64( $comp_id, $trace_id, 2, ( &ct_int64_t)($int1), ( &ct_int64_t)($int2) ));
    }' unless defined(&tr_record_int64_2);
    eval 'sub tr_record_uint64 {
        my( $comp_id, $trace_id, $int1 ) = @_;
	    eval q( &tr_record_values_64( $comp_id, $trace_id, 1, ( &ct_uint64_t)($int1) ));
    }' unless defined(&tr_record_uint64);
    eval 'sub tr_record_uint64_2 {
        my( $comp_id, $trace_id, $int1, $int2 ) = @_;
	    eval q( &tr_record_values_64( $comp_id, $trace_id, 2, ( &ct_uint64_t)($int1), ( &ct_uint64_t)($int2) ));
    }' unless defined(&tr_record_uint64_2);
    eval 'sub tr_record_string {
        my( $comp_id, $string ) = @_;
	    eval q( &tr_record_strings( $comp_id, 0xffffffff, 1, $string ));
    }' unless defined(&tr_record_string);
    eval 'sub tr_record_vprintf {
        my( $comp_id, $format, $arg_list ) = @_;
	    eval q( &tr_record_vfmt_string( $comp_id, 0xffffffff, $format, $arg_list ));
    }' unless defined(&tr_record_vprintf);
    eval 'sub tr_chk_record_id {
        my( $category, $lod, $trace_id ) = @_;
	    eval q({  &if (  &tr_check(  &TR_DETAIL_LEVEL_ARRAY, $category, $lod ) )  &tr_record_id(  &TR_COMP_ID, $trace_id ); });
    }' unless defined(&tr_chk_record_id);
    eval 'sub tr_chk_record_string {
        my( $category, $lod, $trace_id, $string ) = @_;
	    eval q({  &if (  &tr_check(  &TR_DETAIL_LEVEL_ARRAY, $category, $lod ) )  &tr_record_strings(  &TR_COMP_ID, $trace_id, 1, ( &ct_char_t *)($string) ); });
    }' unless defined(&tr_chk_record_string);
    eval 'sub tr_chk_record_value_32 {
        my( $category, $lod, $trace_id, $value ) = @_;
	    eval q({  &if (  &tr_check(  &TR_DETAIL_LEVEL_ARRAY, $category, $lod ) )  &tr_record_values_32(  &TR_COMP_ID, $trace_id, 1, ( &ct_uint32_t)($value) ); });
    }' unless defined(&tr_chk_record_value_32);
    eval 'sub tr_chk_record_data1 {
        my( $category, $lod, $trace_id, $pData, $length ) = @_;
	    eval q({  &if (  &tr_check(  &TR_DETAIL_LEVEL_ARRAY, $category, $lod ) )  &tr_record_data(  &TR_COMP_ID, $trace_id, 1, ( &void *)($pData), ( &ct_uint32_t)($length) ); });
    }' unless defined(&tr_chk_record_data1);
    eval 'sub tr_chk_record_data2 {
        my( $category, $lod, $trace_id, $pData1, $length1, $pData2, $length2 ) = @_;
	    eval q({  &if (  &tr_check(  &TR_DETAIL_LEVEL_ARRAY, $category, $lod ) )  &tr_record_data(  &TR_COMP_ID, $trace_id, 1, ( &void *)($pData1), ( &ct_uint32_t)($length1), ( &void *)($pData2), ( &ct_uint32_t)($length2) ); });
    }' unless defined(&tr_chk_record_data2);
    eval 'sub tr_chk_record_error {
        my( $category, $lod, $trace_id, $pFuncName, $pErrorInfo ) = @_;
	    eval q({  &if (  &tr_check(  &TR_DETAIL_LEVEL_ARRAY, $category, $lod ) )  &tr_record_error(  &TR_COMP_ID, $trace_id, $pFuncName,  &__LINE__,  &__FILE__, $pErrorInfo ); });
    }' unless defined(&tr_chk_record_error);
    eval 'sub tr_register_component () { &TR_ROUTINE_VERSION( &tr_register_component,  &TR_VERSION);}' unless defined(&tr_register_component);
    eval 'sub tr_unregister_component () { &TR_ROUTINE_VERSION( &tr_unregister_component,  &TR_VERSION);}' unless defined(&tr_unregister_component);
    eval 'sub tr_set_size () { &TR_ROUTINE_VERSION( &tr_set_size,  &TR_VERSION);}' unless defined(&tr_set_size);
    eval 'sub tr_get_size () { &TR_ROUTINE_VERSION( &tr_get_size,  &TR_VERSION);}' unless defined(&tr_get_size);
    eval 'sub tr_set_filename () { &TR_ROUTINE_VERSION( &tr_set_filename,  &TR_VERSION);}' unless defined(&tr_set_filename);
    eval 'sub tr_get_filename () { &TR_ROUTINE_VERSION( &tr_get_filename,  &TR_VERSION);}' unless defined(&tr_get_filename);
    eval 'sub tr_flush () { &TR_ROUTINE_VERSION( &tr_flush,  &TR_VERSION);}' unless defined(&tr_flush);
    eval 'sub tr_set_trace_levels () { &TR_ROUTINE_VERSION( &tr_set_trace_levels,  &TR_VERSION);}' unless defined(&tr_set_trace_levels);
    eval 'sub tr_record_id () { &TR_ROUTINE_VERSION( &tr_record_id,  &TR_VERSION);}' unless defined(&tr_record_id);
    eval 'sub tr_record_strings () { &TR_ROUTINE_VERSION( &tr_record_strings,  &TR_VERSION);}' unless defined(&tr_record_strings);
    eval 'sub tr_record_strings_v () { &TR_ROUTINE_VERSION( &tr_record_strings_v,  &TR_VERSION);}' unless defined(&tr_record_strings_v);
    eval 'sub tr_record_fmt_string () { &TR_ROUTINE_VERSION( &tr_record_fmt_string,  &TR_VERSION );}' unless defined(&tr_record_fmt_string);
    eval 'sub tr_record_vfmt_string () { &TR_ROUTINE_VERSION( &tr_record_vfmt_string,  &TR_VERSION);}' unless defined(&tr_record_vfmt_string);
    eval 'sub tr_record_printf () { &TR_ROUTINE_VERSION( &tr_record_printf,  &TR_VERSION);}' unless defined(&tr_record_printf);
    eval 'sub tr_record_data () { &TR_ROUTINE_VERSION( &tr_record_data,  &TR_VERSION);}' unless defined(&tr_record_data);
    eval 'sub tr_record_data_v () { &TR_ROUTINE_VERSION( &tr_record_data_v,  &TR_VERSION);}' unless defined(&tr_record_data_v);
    eval 'sub tr_record_values_32 () { &TR_ROUTINE_VERSION( &tr_record_values_32,  &TR_VERSION);}' unless defined(&tr_record_values_32);
    eval 'sub tr_record_values_32_v () { &TR_ROUTINE_VERSION( &tr_record_values_32_v,  &TR_VERSION);}' unless defined(&tr_record_values_32_v);
    eval 'sub tr_record_values_64 () { &TR_ROUTINE_VERSION( &tr_record_values_64,  &TR_VERSION);}' unless defined(&tr_record_values_64);
    eval 'sub tr_record_values_64_v () { &TR_ROUTINE_VERSION( &tr_record_values_64_v,  &TR_VERSION);}' unless defined(&tr_record_values_64_v);
    eval 'sub tr_record_error () { &TR_ROUTINE_VERSION( &tr_record_error,  &TR_VERSION);}' unless defined(&tr_record_error);
    eval 'sub tr_open_query () { &TR_ROUTINE_VERSION( &tr_open_query,  &TR_VERSION);}' unless defined(&tr_open_query);
    eval 'sub tr_close_query () { &TR_ROUTINE_VERSION( &tr_close_query,  &TR_VERSION);}' unless defined(&tr_close_query);
    eval 'sub tr_query_pid () { &TR_ROUTINE_VERSION( &tr_query_pid,  &TR_VERSION);}' unless defined(&tr_query_pid);
    eval 'sub tr_query_prog () { &TR_ROUTINE_VERSION( &tr_query_prog,  &TR_VERSION);}' unless defined(&tr_query_prog);
    eval 'sub tr_query_platform () { &TR_ROUTINE_VERSION( &tr_query_platform,  &TR_VERSION);}' unless defined(&tr_query_platform);
    eval 'sub TR_ROUTINE_VERSION {
        my($routine, $version) = @_;
	    eval q( &TR_ROUTINE_VERSION_GLUE($routine, $version));
    }' unless defined(&TR_ROUTINE_VERSION);
    eval 'sub TR_ROUTINE_VERSION_GLUE {
        my($routine, $version) = @_;
	    eval q($routine   &_  $version);
    }' unless defined(&TR_ROUTINE_VERSION_GLUE);
    if(defined(&__cplusplus)) {
    }
    if(((defined(&TR_VERSION) ? &TR_VERSION : 0) == 1) || defined( &TR_ALL_VERSIONS)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
