require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SNMP_INTERFACES_H_)) {
    eval 'sub _SNMP_INTERFACES_H_ () {1;}' unless defined(&_SNMP_INTERFACES_H_);
    require 'sys/time.ph';
    require 'sys/signal.ph';
    eval 'sub DEFAULT_DIRECTORY () {"/etc/snmpinterfaces/";}' unless defined(&DEFAULT_DIRECTORY);
    eval 'sub SNMP_GET_DELAY () {1;}' unless defined(&SNMP_GET_DELAY);
    eval 'sub SNMP_SET_DELAY () {5;}' unless defined(&SNMP_SET_DELAY);
    eval 'sub IF_TABLE_MAX_STR_LEN () {256;}' unless defined(&IF_TABLE_MAX_STR_LEN);
    eval 'sub IF_NAME_SIZE () {16;}' unless defined(&IF_NAME_SIZE);
    eval 'sub IF_STATUS_LINK_UP () {1;}' unless defined(&IF_STATUS_LINK_UP);
    eval 'sub IF_STATUS_LINK_DOWN () {2;}' unless defined(&IF_STATUS_LINK_DOWN);
    eval 'sub DEFAULT_SNMPSUBAGENT_SIGNAL () { &SIGINT;}' unless defined(&DEFAULT_SNMPSUBAGENT_SIGNAL);
    eval 'sub DEFAULT_SIGNALINTERVAL () {2000;}' unless defined(&DEFAULT_SIGNALINTERVAL);
    eval 'sub DEFAULT_SNMPMINREQUESTS () {23;}' unless defined(&DEFAULT_SNMPMINREQUESTS);
    eval 'sub CURRENT_SYSUPTIME {
        my($table_ptr, $tv) = @_;
	    eval q(((($tv). &tv_sec - ($table_ptr)-> ($SysUpTime->{tv_sec})) * 100+ (($tv). &tv_usec - ($table_ptr)-> ($SysUpTime->{tv_usec})) / 10000));
    }' unless defined(&CURRENT_SYSUPTIME);
}
1;
