require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SYSFP)) {
    eval 'sub _H_SYSFP () {1;}' unless defined(&_H_SYSFP);
    eval 'sub MAX_FEXPON () {0xff;}' unless defined(&MAX_FEXPON);
    eval 'sub MAX_DEXPON () {0x7ff;}' unless defined(&MAX_DEXPON);
    eval 'sub FEXPBIAS () {0x7f;}' unless defined(&FEXPBIAS);
    eval 'sub DEXPBIAS () {0x3ff;}' unless defined(&DEXPBIAS);
    eval 'sub FEXPHI () { &FEXPBIAS+1;}' unless defined(&FEXPHI);
    eval 'sub DEXPHI () { &DEXPBIAS+1;}' unless defined(&DEXPHI);
    eval 'sub FEXPLO () {-( &FEXPBIAS);}' unless defined(&FEXPLO);
    eval 'sub DEXPLO () {-( &DEXPBIAS);}' unless defined(&DEXPLO);
    eval 'sub DUFBIAS () {1536;}' unless defined(&DUFBIAS);
    eval 'sub DOVBIAS () { &DUFBIAS;}' unless defined(&DOVBIAS);
    eval 'sub FUFBIAS () {192;}' unless defined(&FUFBIAS);
    eval 'sub FOVBIAS () { &FUFBIAS;}' unless defined(&FOVBIAS);
    if(defined(&_h_ltypes)) {
	eval 'sub StoQDNaN {
	    my($X) = @_;
    	    eval q( &hipart(($X)) |=  &DoubleStoQ);
	}' unless defined(&StoQDNaN);
	eval 'sub StoQFNaN {
	    my($X) = @_;
    	    eval q( &hipart(($X)) |=  &SingleStoQ);
	}' unless defined(&StoQFNaN);
    }
    unless(defined(&__ia64)) {
	eval 'sub VALH {
	    my($val) = @_;
    	    eval q(*(($val)));
	}' unless defined(&VALH);
    } else {
	eval 'sub VALH {
	    my($val) = @_;
    	    eval q(*((($val))+1));
	}' unless defined(&VALH);
    }
    unless(defined(&__ia64)) {
	eval 'sub VALL {
	    my($val) = @_;
    	    eval q(*((($val))+1));
	}' unless defined(&VALL);
    } else {
	eval 'sub VALL {
	    my($val) = @_;
    	    eval q(*(($val)));
	}' unless defined(&VALL);
    }
    eval 'sub VALSHORT {
        my($dbl) = @_;
	    eval q((($dbl)));
    }' unless defined(&VALSHORT);
    eval 'sub VAL0 {
        my($val) = @_;
	    eval q(*( &VALSHORT($val)+3));
    }' unless defined(&VAL0);
    eval 'sub VAL1 {
        my($val) = @_;
	    eval q(*( &VALSHORT($val)+2));
    }' unless defined(&VAL1);
    eval 'sub VAL2 {
        my($val) = @_;
	    eval q(*( &VALSHORT($val)+1));
    }' unless defined(&VAL2);
    eval 'sub VAL3 {
        my($val) = @_;
	    eval q(* &VALSHORT($val));
    }' unless defined(&VAL3);
    eval 'sub INTS2DBL {
        my($x,$y) = @_;
	    eval q(($x),($y));
    }' unless defined(&INTS2DBL);
    if(defined(&__LONGDOUBLE128)) {
	eval 'sub LDVAL0 {
	    my($ld_val) = @_;
    	    eval q(*(($ld_val)));
	}' unless defined(&LDVAL0);
	eval 'sub LDVAL1 {
	    my($ld_val) = @_;
    	    eval q(*((($ld_val))+1));
	}' unless defined(&LDVAL1);
	eval 'sub LDVAL2 {
	    my($ld_val) = @_;
    	    eval q(*((($ld_val))+2));
	}' unless defined(&LDVAL2);
	eval 'sub LDVAL3 {
	    my($ld_val) = @_;
    	    eval q(*((($ld_val))+3));
	}' unless defined(&LDVAL3);
    }
}
1;
