require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_NLCHAR)) {
    eval 'sub _H_NLCHAR () {1;}' unless defined(&_H_NLCHAR);
    require 'jctype.ph';
    require 'sys/types.ph';
    require 'sys/localedef.ph';
    eval 'sub NLCOLMAX () {16384;}' unless defined(&NLCOLMAX);
    eval 'sub NLCHARMAX () {256;}' unless defined(&NLCHARMAX);
    if(defined(&lint)) {
    } else {
	eval 'sub _NCtop {
	    my($nlc) = @_;
    	    eval q((($nlc) >> 8& 0xff));
	}' unless defined(&_NCtop);
	eval 'sub _NCbot {
	    my($nlc) = @_;
    	    eval q((($nlc) & 0xff));
	}' unless defined(&_NCbot);
	eval 'sub _NCis2 {
	    my($c0,$c1) = @_;
    	    eval q( &NCisshift($c0));
	}' unless defined(&_NCis2);
	eval 'sub _NCd2 {
	    my($c0,$c1) = @_;
    	    eval q(((($c0) << 8) | ($c1)));
	}' unless defined(&_NCd2);
	eval 'sub _NCe2 {
	    my($nlc, $c0, $c1) = @_;
    	    eval q(((($nlc) > 0xff) ? (($c0) =  &_NCtop($nlc), ($c1) =  &_NCbot($nlc), 2) : (($c0) = ($nlc), 1)));
	}' unless defined(&_NCe2);
	eval 'sub _NCdec2 {
	    my($c0, $c1, $nlc) = @_;
    	    eval q((( &_NCis2(($c0), ($c1))) ? (($nlc) =  &_NCd2(($c0), ($c1)), 2) : (($nlc) = ($c0), 1)));
	}' unless defined(&_NCdec2);
	eval 'sub _NCmap {
	    my($nlc) = @_;
    	    eval q(( (($nlc) <= 0xff) ? ($nlc) : ( ($nlc) < 0xdfff ? ( ($nlc) - 0x8000 ) : ( ($nlc) - 0xc000 ) )));
	}' unless defined(&_NCmap);
	eval 'sub _NCunmap {
	    my($nlc) = @_;
    	    eval q(( (($nlc) <= 0xff)? ($nlc) : ( ($nlc) < 0x2000 ? ( ($nlc) + 0x8000 ) : ( ($nlc) + 0xc000 ) )));
	}' unless defined(&_NCunmap);
	eval 'sub NCeqvmap {
	    my($ucval) = @_;
    	    eval q(( 1));
	}' unless defined(&NCeqvmap);
    }
    eval 'sub NLCSETMAX () {33;}' unless defined(&NLCSETMAX);
    if(defined(&lint)) {
    } else {
	eval 'sub _NCbufstr {
	    my($s, $d, $l) = @_;
    	    eval q((($d)[0] = 0, (($l) - 2<=  &NCdecstr(($s), ($d)[1], ($l) - 1)) ?  &_NCgetbuf(($s), ($l)) : ($d)[1]));
	}' unless defined(&_NCbufstr);
	unless(defined(&_KERNEL)) {
	    eval 'sub _NCfreebuf {
	        my($s) = @_;
    		eval q( &if (*(($s) - 1))  &free(( &void *)(($s) - 1)););
	    }' unless defined(&_NCfreebuf);
	}
    }
}
1;
