require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&H_ATMSOCK_H)) {
    eval 'sub H_ATMSOCK_H () {1;}' unless defined(&H_ATMSOCK_H);
    require 'sys/call_ie.ph';
    eval 'sub SO_ATM_CALLING () {1;}' unless defined(&SO_ATM_CALLING);
    eval 'sub SO_ATM_CALLED () {2;}' unless defined(&SO_ATM_CALLED);
    eval 'sub SO_ATM_AAL_PARM () {3;}' unless defined(&SO_ATM_AAL_PARM);
    eval 'sub SO_ATM_TRAFFIC_DES () {4;}' unless defined(&SO_ATM_TRAFFIC_DES);
    eval 'sub SO_ATM_BEARER () {5;}' unless defined(&SO_ATM_BEARER);
    eval 'sub SO_ATM_BHLI () {6;}' unless defined(&SO_ATM_BHLI);
    eval 'sub SO_ATM_BLLI () {7;}' unless defined(&SO_ATM_BLLI);
    eval 'sub SO_ATM_QOS_PARM () {8;}' unless defined(&SO_ATM_QOS_PARM);
    eval 'sub SO_ATM_TRANSIT_SEL () {9;}' unless defined(&SO_ATM_TRANSIT_SEL);
    eval 'sub SO_ATM_MAX_PEND () {10;}' unless defined(&SO_ATM_MAX_PEND);
    eval 'sub SO_ATM_PARAM () {11;}' unless defined(&SO_ATM_PARAM);
    eval 'sub SO_ATM_CAUSE () {12;}' unless defined(&SO_ATM_CAUSE);
    eval 'sub SO_ATM_ACCEPT () {13;}' unless defined(&SO_ATM_ACCEPT);
    eval 'sub SO_ATM_ADDPARTY () {14;}' unless defined(&SO_ATM_ADDPARTY);
    eval 'sub SO_ATM_DROPPARTY () {15;}' unless defined(&SO_ATM_DROPPARTY);
    eval 'sub SO_ATM_LEAF_IND () {16;}' unless defined(&SO_ATM_LEAF_IND);
    eval 'sub NDD_ATM_LEAF_NOCHANGE () {0;}' unless defined(&NDD_ATM_LEAF_NOCHANGE);
    eval 'sub NDD_ATM_LEAF_CONNECTED () {1;}' unless defined(&NDD_ATM_LEAF_CONNECTED);
    eval 'sub NDD_ATM_LEAF_DISCONNECTED () {2;}' unless defined(&NDD_ATM_LEAF_DISCONNECTED);
    eval 'sub NDD_ATM_ADDR_VALID () {0x1;}' unless defined(&NDD_ATM_ADDR_VALID);
    eval 'sub NDD_ATM_HANDLE_VALID () {0x1;}' unless defined(&NDD_ATM_HANDLE_VALID);
    eval 'sub NDD_ATM_VIDEO () {0x2;}' unless defined(&NDD_ATM_VIDEO);
    eval 'sub NDD_ATM_KILL_CALL () {0x4;}' unless defined(&NDD_ATM_KILL_CALL);
    eval 'sub NDD_ATM_DISC () {0x8;}' unless defined(&NDD_ATM_DISC);
    eval 'sub NDD_ATM_CONNECT () {0x10;}' unless defined(&NDD_ATM_CONNECT);
    eval 'sub NDD_ATM_LISTEN () {0x20;}' unless defined(&NDD_ATM_LISTEN);
    eval 'sub NDD_ATM_ACCEPT () {0x40;}' unless defined(&NDD_ATM_ACCEPT);
    eval 'sub NDD_ATM_REG () {0x80;}' unless defined(&NDD_ATM_REG);
    eval 'sub NDD_ATM_WAKEUP () {0x100;}' unless defined(&NDD_ATM_WAKEUP);
    eval 'sub NDD_ATM_PARMS_CHANGED () {0x200;}' unless defined(&NDD_ATM_PARMS_CHANGED);
    eval 'sub sotoatmpcb {
        my($so) = @_;
	    eval q((( &atm_pcb_t *)($so)-> &so_pcb));
    }' unless defined(&sotoatmpcb);
    eval 'sub OFFSETOF {
        my($a1,$a2) = @_;
	    eval q(((($a1 *)0)->$a2));
    }' unless defined(&OFFSETOF);
    eval 'sub NDD_ATM_LOCK () {
        eval q( &intpri =  &disable_lock(  &PL_IMP,  &ndd_atmsock_lock ));
    }' unless defined(&NDD_ATM_LOCK);
    eval 'sub NDD_ATM_UNLOCK () {
        eval q( &unlock_enable(  &intpri,  &ndd_atmsock_lock ));
    }' unless defined(&NDD_ATM_UNLOCK);
    eval 'sub NDD_ATM_USRREQ_LOCK () {
        eval q( &intprij =  &disable_lock(  &PL_IMP,  &ndd_atmsock_usrreq_lock ));
    }' unless defined(&NDD_ATM_USRREQ_LOCK);
    eval 'sub NDD_ATM_USRREQ_UNLOCK () {
        eval q( &unlock_enable(  &intprij,  &ndd_atmsock_usrreq_lock ));
    }' unless defined(&NDD_ATM_USRREQ_UNLOCK);
    eval 'sub NDD_ATM_ENQUEUE_ALLOC {
        my($allocp) = @_;
	    eval q({  &insque(  ($allocp->{alloc_chain}),  &atm_alloc_ancor ); });
    }' unless defined(&NDD_ATM_ENQUEUE_ALLOC);
    eval 'sub NDD_ATM_DEQUEUE_ALLOC {
        my($allocp) = @_;
	    eval q({  &remque(  ($allocp->{alloc_chain}) ); });
    }' unless defined(&NDD_ATM_DEQUEUE_ALLOC);
    eval 'sub NDD_ATM_FIND_ALLOC {
        my($addr, $allocpp) = @_;
	    eval q({  &ndd_atm_alloc_t * &alloc_work;  &qelem_t * &qwork= &atm_alloc_ancor; *$allocpp =  &NULL;  &qwork =  ($atm_alloc_ancor->{next});  &while ( &qwork !=  &atm_alloc_ancor ) {  &alloc_work = ( &ndd_atm_alloc_t *)( &qwork -  &OFFSETOF( &ndd_atm_alloc_t,  &alloc_chain));  &if (  &strcmp( ($alloc_work->{name}),  ($addr->{sndd_atm_nddname})) == 0) { *$allocpp =  &alloc_work;  &break; }  &else {  &qwork=  ($qwork->{next}); } } });
    }' unless defined(&NDD_ATM_FIND_ALLOC);
    eval 'sub NDD_ATM_ENQ_PCB {
        my($pcbq, $ancor, $chain, $offset) = @_;
	    eval q({  &TRCHKL2T( &HKWD_ATMSOCK |  &hkwd_atmsock_pcbenq, $pcbq - $offset, $chain );  &insque( $pcbq, $ancor ); });
    }' unless defined(&NDD_ATM_ENQ_PCB);
    eval 'sub NDD_ATM_DEQ_PCB {
        my($pcbq, $chain, $offset) = @_;
	    eval q({  &TRCHKL2T( &HKWD_ATMSOCK |  &hkwd_atmsock_pcbdeq, $pcbq - $offset, $chain );  &remque( $pcbq ); });
    }' unless defined(&NDD_ATM_DEQ_PCB);
    eval 'sub NDD_ATM_ENQ_LEAF {
        my($leafq, $ancor) = @_;
	    eval q({  &insque( $leafq, $ancor ); });
    }' unless defined(&NDD_ATM_ENQ_LEAF);
    eval 'sub NDD_ATM_DEQ_LEAF {
        my($leafq) = @_;
	    eval q({  &remque( $leafq ); });
    }' unless defined(&NDD_ATM_DEQ_LEAF);
    eval 'sub NDD_ATMRC_REF {
        my($atm_pcb) = @_;
	    eval q({  &fetch_and_add((($atm_pcb)-> &refcnt), 1); });
    }' unless defined(&NDD_ATMRC_REF);
    eval 'sub NDD_ATMRC_UNREF {
        my($atm_pcb) = @_;
	    eval q({  &if ( &fetch_and_add((($atm_pcb)-> &refcnt), -1) == 1) {  &if ( ($atm_pcb->{refcnt}) <= 1) {  ($atm_pcb->{so}->{so_pcb}) =  &NULL;  &sofree( ($atm_pcb->{so}));  &TRCHKL1T( &HKWD_ATMSOCK |  &hkwd_atmsock_netfree, $atm_pcb );  &NET_FREE($atm_pcb,  &M_PCB); } } });
    }' unless defined(&NDD_ATMRC_UNREF);
    eval 'sub hkwd_atmsock_attach () {1;}' unless defined(&hkwd_atmsock_attach);
    eval 'sub hkwd_atmsock_bind () {2;}' unless defined(&hkwd_atmsock_bind);
    eval 'sub hkwd_atmsock_addr () {3;}' unless defined(&hkwd_atmsock_addr);
    eval 'sub hkwd_atmsock_listen () {4;}' unless defined(&hkwd_atmsock_listen);
    eval 'sub hkwd_atmsock_connpvc () {5;}' unless defined(&hkwd_atmsock_connpvc);
    eval 'sub hkwd_atmsock_connsvc () {6;}' unless defined(&hkwd_atmsock_connsvc);
    eval 'sub hkwd_atmsock_accept () {7;}' unless defined(&hkwd_atmsock_accept);
    eval 'sub hkwd_atmsock_disc () {8;}' unless defined(&hkwd_atmsock_disc);
    eval 'sub hkwd_atmsock_detach () {9;}' unless defined(&hkwd_atmsock_detach);
    eval 'sub hkwd_atmsock_abort () {10;}' unless defined(&hkwd_atmsock_abort);
    eval 'sub hkwd_atmsock_connerr () {11;}' unless defined(&hkwd_atmsock_connerr);
    eval 'sub hkwd_atmsock_calldisc () {12;}' unless defined(&hkwd_atmsock_calldisc);
    eval 'sub hkwd_atmsock_shut () {13;}' unless defined(&hkwd_atmsock_shut);
    eval 'sub hkwd_atmsock_indentry () {14;}' unless defined(&hkwd_atmsock_indentry);
    eval 'sub hkwd_atmsock_indexit () {15;}' unless defined(&hkwd_atmsock_indexit);
    eval 'sub hkwd_atmsock_callack () {16;}' unless defined(&hkwd_atmsock_callack);
    eval 'sub hkwd_atmsock_addfill () {17;}' unless defined(&hkwd_atmsock_addfill);
    eval 'sub hkwd_atmsock_adderr () {18;}' unless defined(&hkwd_atmsock_adderr);
    eval 'sub hkwd_atmsock_delfill () {19;}' unless defined(&hkwd_atmsock_delfill);
    eval 'sub hkwd_atmsock_svcreg () {20;}' unless defined(&hkwd_atmsock_svcreg);
    eval 'sub hkwd_atmsock_svcdereg () {21;}' unless defined(&hkwd_atmsock_svcdereg);
    eval 'sub hkwd_atmsock_svcerr () {22;}' unless defined(&hkwd_atmsock_svcerr);
    eval 'sub hkwd_atmsock_netfree () {23;}' unless defined(&hkwd_atmsock_netfree);
    eval 'sub hkwd_atmsock_callacc () {24;}' unless defined(&hkwd_atmsock_callacc);
    eval 'sub hkwd_atmsock_work () {25;}' unless defined(&hkwd_atmsock_work);
    eval 'sub hkwd_atmsock_allocp () {26;}' unless defined(&hkwd_atmsock_allocp);
    eval 'sub hkwd_atmsock_allocfree () {27;}' unless defined(&hkwd_atmsock_allocfree);
    eval 'sub hkwd_atmsock_pcbenq () {28;}' unless defined(&hkwd_atmsock_pcbenq);
    eval 'sub hkwd_atmsock_pcbdeq () {29;}' unless defined(&hkwd_atmsock_pcbdeq);
    eval 'sub hkwd_atmsock_lisq () {30;}' unless defined(&hkwd_atmsock_lisq);
    eval 'sub hkwd_atmsock_regreg () {31;}' unless defined(&hkwd_atmsock_regreg);
    eval 'sub hkwd_atmsock_regdereg () {32;}' unless defined(&hkwd_atmsock_regdereg);
    eval 'sub hkwd_atmsock_regerr () {33;}' unless defined(&hkwd_atmsock_regerr);
    eval 'sub hkwd_atmsock_reglis () {34;}' unless defined(&hkwd_atmsock_reglis);
    eval 'sub hkwd_atmsock_kill () {35;}' unless defined(&hkwd_atmsock_kill);
    eval 'sub hkwd_atmsock_fvtstart () {36;}' unless defined(&hkwd_atmsock_fvtstart);
    eval 'sub hkwd_atmsock_fvtfinish () {37;}' unless defined(&hkwd_atmsock_fvtfinish);
    eval 'sub hkwd_atmsock_rcventry () {38;}' unless defined(&hkwd_atmsock_rcventry);
    eval 'sub hkwd_atmsock_rcvexit () {39;}' unless defined(&hkwd_atmsock_rcvexit);
    eval 'sub hkwd_atmsock_sndentry () {40;}' unless defined(&hkwd_atmsock_sndentry);
    eval 'sub hkwd_atmsock_sndexit () {41;}' unless defined(&hkwd_atmsock_sndexit);
    eval 'sub hkwd_atmsock_leafack () {42;}' unless defined(&hkwd_atmsock_leafack);
    eval 'sub hkwd_atmsock_leafdisc () {43;}' unless defined(&hkwd_atmsock_leafdisc);
    eval 'sub hkwd_atmsock_addp () {44;}' unless defined(&hkwd_atmsock_addp);
    eval 'sub hkwd_atmsock_drop () {45;}' unless defined(&hkwd_atmsock_drop);
    eval 'sub hkwd_atmsock_leafind () {46;}' unless defined(&hkwd_atmsock_leafind);
}
1;
