require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_AUDIT)) {
    eval 'sub _H_AUDIT () {1;}' unless defined(&_H_AUDIT);
    require 'sys/types.ph';
    require 'sys/user.ph';
    require 'sys/tcb.ph';
    eval 'sub AUDIT_OFF () {0;}' unless defined(&AUDIT_OFF);
    eval 'sub AUDIT_ON () {1;}' unless defined(&AUDIT_ON);
    eval 'sub AUDIT_QUERY () {2;}' unless defined(&AUDIT_QUERY);
    eval 'sub AUDIT_RESET () {4;}' unless defined(&AUDIT_RESET);
    eval 'sub AUDIT_NO_PANIC () {8;}' unless defined(&AUDIT_NO_PANIC);
    eval 'sub AUDIT_PANIC () {16;}' unless defined(&AUDIT_PANIC);
    eval 'sub AUDIT_EVENT_THRESHOLD () {32;}' unless defined(&AUDIT_EVENT_THRESHOLD);
    eval 'sub AUDIT_BYTE_THRESHOLD () {64;}' unless defined(&AUDIT_BYTE_THRESHOLD);
    eval 'sub AUDIT_WAIT () {0x1;}' unless defined(&AUDIT_WAIT);
    eval 'sub AUDIT_EXCL () {0x2;}' unless defined(&AUDIT_EXCL);
    eval 'sub AUDIT_QEVENTS () {1;}' unless defined(&AUDIT_QEVENTS);
    eval 'sub AUDIT_EVENTS () {2;}' unless defined(&AUDIT_EVENTS);
    eval 'sub AUDIT_QSTATUS () {3;}' unless defined(&AUDIT_QSTATUS);
    eval 'sub AUDIT_STATUS () {4;}' unless defined(&AUDIT_STATUS);
    eval 'sub AUDIT_RESUME () {0;}' unless defined(&AUDIT_RESUME);
    eval 'sub AUDIT_SUSPEND () {1;}' unless defined(&AUDIT_SUSPEND);
    eval 'sub AUDIT_KLIST_EVENTS () {5;}' unless defined(&AUDIT_KLIST_EVENTS);
    eval 'sub AUDIT_GET () {0;}' unless defined(&AUDIT_GET);
    eval 'sub AUDIT_SET () {1;}' unless defined(&AUDIT_SET);
    eval 'sub AUDIT_LOCK () {3;}' unless defined(&AUDIT_LOCK);
    eval 'sub AUDIT_MAGIC () {0xf0f0;}' unless defined(&AUDIT_MAGIC);
    eval 'sub VERSION_AUDIT_MERGED () {3;}' unless defined(&VERSION_AUDIT_MERGED);
    eval 'sub VERSION_AUDIT_64BIT () {4;}' unless defined(&VERSION_AUDIT_64BIT);
    eval 'sub VERSION_AUDIT_IS64BIT () {0200;}' unless defined(&VERSION_AUDIT_IS64BIT);
    eval 'sub AUDIT_VERSION () { &VERSION_AUDIT_64BIT;}' unless defined(&AUDIT_VERSION);
    eval 'sub AUDIT_HEAD () {0;}' unless defined(&AUDIT_HEAD);
    eval 'sub AUDIT_BIN_END () {1;}' unless defined(&AUDIT_BIN_END);
    eval 'sub AUDIT_TRAIL () {2;}' unless defined(&AUDIT_TRAIL);
    eval 'sub AUDIT_SUSPENDED () {0x1;}' unless defined(&AUDIT_SUSPENDED);
    eval 'sub AUDIT_FILE () {0x1;}' unless defined(&AUDIT_FILE);
    eval 'sub AUDIT_READ () {0;}' unless defined(&AUDIT_READ);
    eval 'sub AUDIT_WRITE () {1;}' unless defined(&AUDIT_WRITE);
    eval 'sub AUDIT_EXEC () {2;}' unless defined(&AUDIT_EXEC);
    eval 'sub AUDIT_PACK () {0;}' unless defined(&AUDIT_PACK);
    eval 'sub AUDIT_UNPACK () {1;}' unless defined(&AUDIT_UNPACK);
    eval 'sub AIO_EVENTS () {0x1;}' unless defined(&AIO_EVENTS);
    eval 'sub AUDIT_OK () {0;}' unless defined(&AUDIT_OK);
    eval 'sub AUDIT_TCB_MOD () {0x99;}' unless defined(&AUDIT_TCB_MOD);
    eval 'sub AUDIT_FAIL () {0x1;}' unless defined(&AUDIT_FAIL);
    eval 'sub AUDIT_FAIL_AUTH () {0x3;}' unless defined(&AUDIT_FAIL_AUTH);
    eval 'sub AUDIT_FAIL_PRIV () {0x5;}' unless defined(&AUDIT_FAIL_PRIV);
    eval 'sub AUDIT_FAIL_ACCESS () {0x9;}' unless defined(&AUDIT_FAIL_ACCESS);
    eval 'sub AUDIT_FAIL_DAC () {0x19;}' unless defined(&AUDIT_FAIL_DAC);
    eval 'sub AUDIT_RECORD_VERSION_MERGED () {2;}' unless defined(&AUDIT_RECORD_VERSION_MERGED);
    eval 'sub AUDIT_RECORD_VERSION_64BIT () {3;}' unless defined(&AUDIT_RECORD_VERSION_64BIT);
    eval 'sub AUDIT_RECORD_VERSION_IS64BIT () {0200;}' unless defined(&AUDIT_RECORD_VERSION_IS64BIT);
    eval 'sub AUDIT_RECORD_VERSION () { &AUDIT_RECORD_VERSION_64BIT;}' unless defined(&AUDIT_RECORD_VERSION);
    eval 'sub AUDIT_HDR0 () {0;}' unless defined(&AUDIT_HDR0);
    eval 'sub AUDIT_HDR1 () {1;}' unless defined(&AUDIT_HDR1);
    eval 'sub AUDIT_HDR2 () {( ($sizeof{\'struct aud_rec_ext\'} << 8) |  &AUDIT_RECORD_VERSION );}' unless defined(&AUDIT_HDR2);
    eval 'sub AUDIT_HDR3 () { &AUDIT_HDR2 |  &AUDIT_RECORD_VERSION_IS64BIT;}' unless defined(&AUDIT_HDR3);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub AUDIT_HDR () { &AUDIT_HDR2;}' unless defined(&AUDIT_HDR);
    } else {
	eval 'sub AUDIT_HDR () { &AUDIT_HDR3;}' unless defined(&AUDIT_HDR);
    }
    eval 'sub AUD_HDR_EXT_CPUID_LEN () {8;}' unless defined(&AUD_HDR_EXT_CPUID_LEN);
    eval 'sub ah_magic () { ($ah_base->{arb_magic});}' unless defined(&ah_magic);
    eval 'sub ah_length () { ($ah_base->{arb_length});}' unless defined(&ah_length);
    eval 'sub ah_event () { ($ah_base->{arb_event});}' unless defined(&ah_event);
    eval 'sub ah_result () { ($ah_base->{arb_result});}' unless defined(&ah_result);
    eval 'sub ah_ruid () { ($ah_base->{arb_ruid});}' unless defined(&ah_ruid);
    eval 'sub ah_luid () { ($ah_base->{arb_luid});}' unless defined(&ah_luid);
    eval 'sub ah_name () { ($ah_base->{arb_name});}' unless defined(&ah_name);
    eval 'sub ah_pid () { ($ah_base->{arb_pid});}' unless defined(&ah_pid);
    eval 'sub ah_ppid () { ($ah_base->{arb_ppid});}' unless defined(&ah_ppid);
    eval 'sub ah_tid () { ($ah_base->{arb_tid});}' unless defined(&ah_tid);
    eval 'sub ah_time () { ($ah_base->{arb_time});}' unless defined(&ah_time);
    eval 'sub ah_ntime () { ($ah_base->{arb_ntime});}' unless defined(&ah_ntime);
    eval 'sub ah_cpuid () { ($ah_ext->{are_cpuid});}' unless defined(&ah_cpuid);
    eval 'sub ah_time64 () { ($ah_ext->{are_time64});}' unless defined(&ah_time64);
    eval 'sub REC_HDR_SIZ () {($sizeof{\'struct aud_rec\'});}' unless defined(&REC_HDR_SIZ);
    eval 'sub AUDIT_CPU_ID {
        my($rec) = @_;
	    eval q((( &AUDIT_HDR_VERSION($rec) >=  &AUDIT_RECORD_VERSION_MERGED) ? ((($rec))-> &ah_cpuid) :  &NULL));
    }' unless defined(&AUDIT_CPU_ID);
    eval 'sub AUDIT_HDR_VERSION {
        my($rec) = @_;
	    eval q(((( ($rec))-> &ah_magic) & 0x7f));
    }' unless defined(&AUDIT_HDR_VERSION);
    eval 'sub AUDIT_HDR_EXT_SIZE {
        my($rec) = @_;
	    eval q((((( ($rec))-> &ah_magic) >> 8) & 0xff));
    }' unless defined(&AUDIT_HDR_EXT_SIZE);
    eval 'sub AUDIT_REC_SIZE {
        my($rec) = @_;
	    eval q(($sizeof{\'struct aud_rec_base\'} +  &AUDIT_HDR_EXT_SIZE($rec)));
    }' unless defined(&AUDIT_REC_SIZE);
    eval 'sub AUD_REC_TAIL {
        my($rec) = @_;
	    eval q(( +  &AUDIT_REC_SIZE($rec)));
    }' unless defined(&AUD_REC_TAIL);
    eval 'sub AUDIT_TIME_64 {
        my($rec) = @_;
	    eval q(( &AUDIT_HDR_VERSION($rec) >=  &AUDIT_RECORD_VERSION_64BIT  &&  &AUDIT_64BIT_TAIL($rec) ? (((( &time64_t) ($rec)-> $ah_time64[0]) << 32) | (( &time64_t)($rec)-> $ah_time64[1])) : (( &time64_t) ($rec)-> &ah_time )));
    }' unless defined(&AUDIT_TIME_64);
    eval 'sub AUDIT_64BIT_TAIL {
        my($rec) = @_;
	    eval q((((($rec))-> &ah_magic) &  &AUDIT_RECORD_VERSION_IS64BIT));
    }' unless defined(&AUDIT_64BIT_TAIL);
    eval 'sub AUDIT_BIN_IS64BIT {
        my($bh) = @_;
	    eval q((((($bh))-> &bin_version) & \\\\);
    }' unless defined(&AUDIT_BIN_IS64BIT);
    eval 'sub AUDIT_BIN_CPUID {
        my($bh) = @_;
	    eval q(( &AUDIT_BIN_IS64BIT($bh) ? ((($bh))-> &bin_cpuid) : \\\\);
    }' unless defined(&AUDIT_BIN_CPUID);
    if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
    }
}
1;
