require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_AUDITK)) {
    eval 'sub _H_AUDITK () {1;}' unless defined(&_H_AUDITK);
    require 'sys/audit.ph';
    require 'sys/sleep.ph';
    require 'sys/types.ph';
    require 'sys/lockl.ph';
    eval 'sub MAX_ANAMES () {32;}' unless defined(&MAX_ANAMES);
    eval 'sub ALL_CLASS () {31;}' unless defined(&ALL_CLASS);
    eval 'sub ALL_SIZE () {$sizeof{\'struct audit_class\'} + 5;}' unless defined(&ALL_SIZE);
    eval 'sub MAX_EVNTSIZ () {16;}' unless defined(&MAX_EVNTSIZ);
    eval 'sub MAX_EVNTNUM () {16;}' unless defined(&MAX_EVNTNUM);
    eval 'sub MAX_PATHSIZ () {256;}' unless defined(&MAX_PATHSIZ);
    eval 'sub HASHLEN () {256;}' unless defined(&HASHLEN);
    eval 'sub MAX_TABSIZ () {48*1024;}' unless defined(&MAX_TABSIZ);
    eval 'sub audit_is_on {
        my($id) = @_;
	    eval q(( ($be_symtab[&(id)]->{be_bitmap}) &  ($U->{U_procp}->{p_pvprocp}->{pv_auditmask})));
    }' unless defined(&audit_is_on);
    eval 'sub audit_svc () {
        eval q({\'struct uthread\' * &ut =  ($curthread->{t_uthreadp}); &if ( ($ut->{ut_audsvc}))  &if(( ($ut->{ut_audsvc}))-> &svcnum){  &lock_read( &audit_lock);  &if( ($U->{U_procp}->{p_pvprocp}->{pv_auditmask}) &  ($be_symtab[&(ut->{ut_audsvc)}->{svcnum]}->{be_bitmap})) {  &lock_done( &audit_lock);  &audit_svcfinis(); }  &else  &lock_done( &audit_lock);  ($ut->{ut_audsvc}->{svcnum}) = 0; } });
    }' unless defined(&audit_svc);
    eval 'sub _auditlog {
        my($event,$result,$buf,$len) = @_;
	    eval q({  &if( &audit_flag &  &AUDIT_ON) {  &static \'int\'  &_id;  &if( &_id == 0) &_id =  &audit_klookup($event);  &if(( &_id > 0)  &&  &audit_is_on( &_id))  &audit_write( &_id, $result, $buf, $len); } });
    }' unless defined(&_auditlog);
    eval 'sub _ResetBinInfo {
        my($b) = @_;
	    eval q({  ($b->{fd}) = -1;  ($b->{file}) =  &NULL;  ($b->{EventCount}) =  ($b->{ByteCount}) = 0;});
    }' unless defined(&_ResetBinInfo);
    eval 'sub TCBMOD () {1;}' unless defined(&TCBMOD);
    eval 'sub TCBLEAK () {2;}' unless defined(&TCBLEAK);
    eval 'sub PRIVFAIL () {3;}' unless defined(&PRIVFAIL);
    eval 'sub PRIVUSE () {4;}' unless defined(&PRIVUSE);
}
1;
