require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_DDTRACE)) {
    eval 'sub _H_DDTRACE () {1;}' unless defined(&_H_DDTRACE);
    require 'sys/trcmacros.ph';
    eval 'sub DDHKWD1 {
        my($hkid,$loc,$errno,$data) = @_;
	    eval q(( &TRCHKL1T( ($hkid|($loc<<8)|$errno), $data )));
    }' unless defined(&DDHKWD1);
    eval 'sub DDHKWD2 {
        my($hkid,$loc,$errno,$data1,$data2) = @_;
	    eval q(( &TRCHKL2T( ($hkid|($loc<<8)|$errno), $data1, $data2 )));
    }' unless defined(&DDHKWD2);
    eval 'sub DDHKWD3 {
        my($hkid,$loc,$errno,$data1,$data2,$data3) = @_;
	    eval q(( &TRCHKL3T( ($hkid|($loc<<8)|$errno), $data1, $data2, $data3 )));
    }' unless defined(&DDHKWD3);
    eval 'sub DDHKWD4 {
        my($hkid,$loc,$errno,$data1,$data2,$data3,$data4) = @_;
	    eval q(( &TRCHKL4T( ($hkid|($loc<<8)|$errno), $data1, $data2, $data3, $data4 )));
    }' unless defined(&DDHKWD4);
    eval 'sub DDHKWD5 {
        my($hkid,$loc,$errno,$data1,$data2,$data3,$data4,$data5) = @_;
	    eval q(( &TRCHKL5T( ($hkid|($loc<<8)|$errno), $data1,$data2,$data3,$data4,$data5 )));
    }' unless defined(&DDHKWD5);
    eval 'sub DDHKGEN {
        my($hkid,$devno,$devln,$devnm) = @_;
	    eval q(( &TRCGENT(0,$hkid,$devno,$devln,$devnm)));
    }' unless defined(&DDHKGEN);
    eval 'sub DD_ENTRY_OPEN () {0x1;}' unless defined(&DD_ENTRY_OPEN);
    eval 'sub DD_EXIT_OPEN () {0x2;}' unless defined(&DD_EXIT_OPEN);
    eval 'sub DD_ENTRY_CLOSE () {0x3;}' unless defined(&DD_ENTRY_CLOSE);
    eval 'sub DD_EXIT_CLOSE () {0x4;}' unless defined(&DD_EXIT_CLOSE);
    eval 'sub DD_ENTRY_READ () {0x5;}' unless defined(&DD_ENTRY_READ);
    eval 'sub DD_EXIT_READ () {0x6;}' unless defined(&DD_EXIT_READ);
    eval 'sub DD_ENTRY_WRITE () {0x7;}' unless defined(&DD_ENTRY_WRITE);
    eval 'sub DD_EXIT_WRITE () {0x8;}' unless defined(&DD_EXIT_WRITE);
    eval 'sub DD_ENTRY_IOCTL () {0x9;}' unless defined(&DD_ENTRY_IOCTL);
    eval 'sub DD_EXIT_IOCTL () {0xa;}' unless defined(&DD_EXIT_IOCTL);
    eval 'sub DD_ENTRY_SELECT () {0xb;}' unless defined(&DD_ENTRY_SELECT);
    eval 'sub DD_EXIT_SELECT () {0xc;}' unless defined(&DD_EXIT_SELECT);
    eval 'sub DD_ENTRY_CONFIG () {0xd;}' unless defined(&DD_ENTRY_CONFIG);
    eval 'sub DD_EXIT_CONFIG () {0xe;}' unless defined(&DD_EXIT_CONFIG);
    eval 'sub DD_ENTRY_STRATEGY () {0xf;}' unless defined(&DD_ENTRY_STRATEGY);
    eval 'sub DD_EXIT_STRATEGY () {0x10;}' unless defined(&DD_EXIT_STRATEGY);
    eval 'sub DD_ENTRY_MPX () {0x11;}' unless defined(&DD_ENTRY_MPX);
    eval 'sub DD_EXIT_MPX () {0x12;}' unless defined(&DD_EXIT_MPX);
    eval 'sub DD_ENTRY_REVOKE () {0x13;}' unless defined(&DD_ENTRY_REVOKE);
    eval 'sub DD_EXIT_REVOKE () {0x14;}' unless defined(&DD_EXIT_REVOKE);
    eval 'sub DD_ENTRY_INTR () {0x15;}' unless defined(&DD_ENTRY_INTR);
    eval 'sub DD_EXIT_INTR () {0x16;}' unless defined(&DD_EXIT_INTR);
    eval 'sub DD_ENTRY_BSTART () {0x17;}' unless defined(&DD_ENTRY_BSTART);
    eval 'sub DD_EXIT_BSTART () {0x18;}' unless defined(&DD_EXIT_BSTART);
    eval 'sub DD_ENTRY_CSTART () {0x19;}' unless defined(&DD_ENTRY_CSTART);
    eval 'sub DD_EXIT_CSTART () {0x1a;}' unless defined(&DD_EXIT_CSTART);
    eval 'sub DD_ENTRY_IODONE () {0x1b;}' unless defined(&DD_ENTRY_IODONE);
    eval 'sub DD_EXIT_IODONE () {0x1c;}' unless defined(&DD_EXIT_IODONE);
    eval 'sub DD_SC_INTR () {0x1d;}' unless defined(&DD_SC_INTR);
    eval 'sub DD_COALESCE () {0x1e;}' unless defined(&DD_COALESCE);
    eval 'sub DD_SC_IODONE () {0x1f;}' unless defined(&DD_SC_IODONE);
    eval 'sub DD_PERF_HOOK () {0x20;}' unless defined(&DD_PERF_HOOK);
    eval 'sub DD_C327_HOOK () {0x21;}' unless defined(&DD_C327_HOOK);
    eval 'sub DD_CONFIG_NAME () {0x40;}' unless defined(&DD_CONFIG_NAME);
    eval 'sub DD_ENTRY_HALT () {0x70;}' unless defined(&DD_ENTRY_HALT);
    eval 'sub DD_EXIT_HALT () {0x71;}' unless defined(&DD_EXIT_HALT);
    eval 'sub DD_ENTRY_GET_STAT () {0x72;}' unless defined(&DD_ENTRY_GET_STAT);
    eval 'sub DD_EXIT_GET_STAT () {0x73;}' unless defined(&DD_EXIT_GET_STAT);
    eval 'sub DD_EXIT_KREAD () {0x74;}' unless defined(&DD_EXIT_KREAD);
    eval 'sub DD_EXIT_KSTAT () {0x75;}' unless defined(&DD_EXIT_KSTAT);
    eval 'sub DD_EXIT_KTX_FN () {0x76;}' unless defined(&DD_EXIT_KTX_FN);
    eval 'sub DD_ENTRY_CHGPARM () {0x77;}' unless defined(&DD_ENTRY_CHGPARM);
    eval 'sub DD_EXIT_CHGPARM () {0x78;}' unless defined(&DD_EXIT_CHGPARM);
    eval 'sub DD_ENTRY_STARTAR () {0x79;}' unless defined(&DD_ENTRY_STARTAR);
    eval 'sub DD_EXIT_STARTAR () {0x7a;}' unless defined(&DD_EXIT_STARTAR);
    eval 'sub DD_ENTRY_FLUSHPORT () {0x7b;}' unless defined(&DD_ENTRY_FLUSHPORT);
    eval 'sub DD_EXIT_FLUSHPORT () {0x7c;}' unless defined(&DD_EXIT_FLUSHPORT);
    eval 'sub DD_ENTRY_ADAPT_QUERY () {0x7d;}' unless defined(&DD_ENTRY_ADAPT_QUERY);
    eval 'sub DD_EXIT_ADAPT_QUERY () {0x7e;}' unless defined(&DD_EXIT_ADAPT_QUERY);
    eval 'sub DD_ENTRY_QUERY_STAT () {0x7f;}' unless defined(&DD_ENTRY_QUERY_STAT);
    eval 'sub DD_EXIT_QUERY_STAT () {0x80;}' unless defined(&DD_EXIT_QUERY_STAT);
    eval 'sub DD_ENTRY_STOP_AR () {0x81;}' unless defined(&DD_ENTRY_STOP_AR);
    eval 'sub DD_EXIT_STOP_AR () {0x82;}' unless defined(&DD_EXIT_STOP_AR);
    eval 'sub DD_ENTRY_TRACEON () {0x83;}' unless defined(&DD_ENTRY_TRACEON);
    eval 'sub DD_EXIT_TRACEON () {0x84;}' unless defined(&DD_EXIT_TRACEON);
    eval 'sub DD_ENTRY_STOP_PORT () {0x85;}' unless defined(&DD_ENTRY_STOP_PORT);
    eval 'sub DD_EXIT_STOP_PORT () {0x86;}' unless defined(&DD_EXIT_STOP_PORT);
    eval 'sub DD_ENTRY_TRACEOFF () {0x87;}' unless defined(&DD_ENTRY_TRACEOFF);
    eval 'sub DD_EXIT_TRACEOFF () {0x88;}' unless defined(&DD_EXIT_TRACEOFF);
    eval 'sub DD_ENTRY_IOCINFO () {0x89;}' unless defined(&DD_ENTRY_IOCINFO);
    eval 'sub DD_EXIT_IOCINFO () {0x8a;}' unless defined(&DD_EXIT_IOCINFO);
    eval 'sub DD_ENTRY_START () {0x8b;}' unless defined(&DD_ENTRY_START);
    eval 'sub DD_EXIT_START () {0x8c;}' unless defined(&DD_EXIT_START);
    eval 'sub DD_ENTRY_QUERY () {0x8d;}' unless defined(&DD_ENTRY_QUERY);
    eval 'sub DD_EXIT_QUERY () {0x8e;}' unless defined(&DD_EXIT_QUERY);
    eval 'sub DD_ENTRY_REJECT_CALL () {0x8f;}' unless defined(&DD_ENTRY_REJECT_CALL);
    eval 'sub DD_EXIT_REJECT_CALL () {0x90;}' unless defined(&DD_EXIT_REJECT_CALL);
    eval 'sub DD_ENTRY_QUERY_SESSION () {0x91;}' unless defined(&DD_ENTRY_QUERY_SESSION);
    eval 'sub DD_EXIT_QUERY_SESSION () {0x92;}' unless defined(&DD_EXIT_QUERY_SESSION);
    eval 'sub DD_ENTRY_DEL_RID () {0x93;}' unless defined(&DD_ENTRY_DEL_RID);
    eval 'sub DD_EXIT_DEL_RID () {0x94;}' unless defined(&DD_EXIT_DEL_RID);
    eval 'sub DD_ENTRY_QUERY_RID () {0x95;}' unless defined(&DD_ENTRY_QUERY_RID);
    eval 'sub DD_EXIT_QUERY_RID () {0x96;}' unless defined(&DD_EXIT_QUERY_RID);
    eval 'sub DD_ENTRY_LINK_CON () {0x97;}' unless defined(&DD_ENTRY_LINK_CON);
    eval 'sub DD_EXIT_LINK_CON () {0x98;}' unless defined(&DD_EXIT_LINK_CON);
    eval 'sub DD_ENTRY_LINK_DIS () {0x99;}' unless defined(&DD_ENTRY_LINK_DIS);
    eval 'sub DD_EXIT_LINK_DIS () {0x9a;}' unless defined(&DD_EXIT_LINK_DIS);
    eval 'sub DD_ENTRY_LINK_STAT () {0x9b;}' unless defined(&DD_ENTRY_LINK_STAT);
    eval 'sub DD_EXIT_LINK_STAT () {0x9c;}' unless defined(&DD_EXIT_LINK_STAT);
    eval 'sub DD_ENTRY_LOCAL_BUSY () {0x9d;}' unless defined(&DD_ENTRY_LOCAL_BUSY);
    eval 'sub DD_EXIT_LOCAL_BUSY () {0x9e;}' unless defined(&DD_EXIT_LOCAL_BUSY);
    eval 'sub DD_ENTRY_COUNTER_GET () {0x9f;}' unless defined(&DD_ENTRY_COUNTER_GET);
    eval 'sub DD_EXIT_COUNTER_GET () {0xa0;}' unless defined(&DD_EXIT_COUNTER_GET);
    eval 'sub DD_ENTRY_COUNTER_WAIT () {0xa1;}' unless defined(&DD_ENTRY_COUNTER_WAIT);
    eval 'sub DD_EXIT_COUNTER_WAIT () {0xa2;}' unless defined(&DD_EXIT_COUNTER_WAIT);
    eval 'sub DD_ENTRY_COUNTER_READ () {0xa3;}' unless defined(&DD_ENTRY_COUNTER_READ);
    eval 'sub DD_EXIT_COUNTER_READ () {0xa4;}' unless defined(&DD_EXIT_COUNTER_READ);
    eval 'sub DD_ENTRY_COUNTER_REM () {0xa5;}' unless defined(&DD_ENTRY_COUNTER_REM);
    eval 'sub DD_EXIT_COUNTER_REM () {0xa6;}' unless defined(&DD_EXIT_COUNTER_REM);
    eval 'sub DD_ENTRY_DIAG_IO () {0xa7;}' unless defined(&DD_ENTRY_DIAG_IO);
    eval 'sub DD_EXIT_DIAG_IO () {0xa8;}' unless defined(&DD_EXIT_DIAG_IO);
    eval 'sub DD_ENTRY_DIAG_MEM () {0xa9;}' unless defined(&DD_ENTRY_DIAG_MEM);
    eval 'sub DD_EXIT_DIAG_MEM () {0xaa;}' unless defined(&DD_EXIT_DIAG_MEM);
    eval 'sub DD_EXIT_DIAG_CARD () {0xab;}' unless defined(&DD_EXIT_DIAG_CARD);
    eval 'sub DD_ENTRY_DIAG_CARD () {0xac;}' unless defined(&DD_ENTRY_DIAG_CARD);
    eval 'sub DD_ENTRY_RESET () {0xad;}' unless defined(&DD_ENTRY_RESET);
    eval 'sub DD_EXIT_RESET () {0xae;}' unless defined(&DD_EXIT_RESET);
    eval 'sub DD_ENTRY_DIAG_TASK () {0xaf;}' unless defined(&DD_ENTRY_DIAG_TASK);
    eval 'sub DD_EXIT_DIAG_TASK () {0xb0;}' unless defined(&DD_EXIT_DIAG_TASK);
    eval 'sub DD_ENTRY_UCODE_TASK () {0xb1;}' unless defined(&DD_ENTRY_UCODE_TASK);
    eval 'sub DD_EXIT_UCODE_TASK () {0xb2;}' unless defined(&DD_EXIT_UCODE_TASK);
    eval 'sub DD_ENTRY_ADD_RID () {0xb3;}' unless defined(&DD_ENTRY_ADD_RID);
    eval 'sub DD_EXIT_ADD_RID () {0xb4;}' unless defined(&DD_EXIT_ADD_RID);
    eval 'sub DD_PERF_TX_DATA_QUEUE () {0xb5;}' unless defined(&DD_PERF_TX_DATA_QUEUE);
    eval 'sub DD_PERF_TX_DATA_ASSIGN () {0xb6;}' unless defined(&DD_PERF_TX_DATA_ASSIGN);
    eval 'sub DD_PERF_TX_DATA_COMP () {0xb7;}' unless defined(&DD_PERF_TX_DATA_COMP);
    eval 'sub DD_PERF_PACKET_RECEIVE () {0xb8;}' unless defined(&DD_PERF_PACKET_RECEIVE);
    eval 'sub DD_PERF_RX_DATA_QUEUE () {0xb9;}' unless defined(&DD_PERF_RX_DATA_QUEUE);
    eval 'sub DD_PERF_RX_DATA_DELIVER () {0xba;}' unless defined(&DD_PERF_RX_DATA_DELIVER);
    eval 'sub DD_PERF_RX_DATA_KERNEL () {0xbb;}' unless defined(&DD_PERF_RX_DATA_KERNEL);
    eval 'sub DD_PERF_RX_DATA_QFULL () {0xbc;}' unless defined(&DD_PERF_RX_DATA_QFULL);
    eval 'sub DD_ENTRY_INTR_STAT () {0xbd;}' unless defined(&DD_ENTRY_INTR_STAT);
    eval 'sub DD_EXIT_INTR_STAT () {0xbe;}' unless defined(&DD_EXIT_INTR_STAT);
}
1;
