require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_DUMP)) {
    eval 'sub _H_DUMP () {1;}' unless defined(&_H_DUMP);
    require 'sys/types.ph';
    if(defined(&_KERNEL)) {
	if(defined(&__64BIT__)) {
	    eval 'sub DUMP_GEN_SEGVAL () {(( &vmhandle_t)-1);}' unless defined(&DUMP_GEN_SEGVAL);
	    eval 'sub DUMP_REAL_SEGVAL () {(( &vmhandle_t)-2);}' unless defined(&DUMP_REAL_SEGVAL);
	} else {
	    eval 'sub DUMP_GEN_SEGVAL () {(( &vmhandle_t)0);}' unless defined(&DUMP_GEN_SEGVAL);
	}
    } else {
	eval 'sub DUMP_GEN_SEGVAL64 () {(-1);}' unless defined(&DUMP_GEN_SEGVAL64);
	eval 'sub DUMP_GEN_SEGVAL32 () {(0);}' unless defined(&DUMP_GEN_SEGVAL32);
	eval 'sub DUMP_GEN_SEGVAL () { &DUMP_GEN_SEGVAL32;}' unless defined(&DUMP_GEN_SEGVAL);
	eval 'sub DUMP_REAL_SEGVAL () {(-2);}' unless defined(&DUMP_REAL_SEGVAL);
    }
    if(defined(&__64BIT__)) {
	eval 'sub ISADDRREAL {
	    my($cde) = @_;
    	    eval q((($cde)-> &d_segval ==  &DUMP_REAL_SEGVAL));
	}' unless defined(&ISADDRREAL);
	eval 'sub ADDR_VR {
	    my($cde) = @_;
    	    eval q(($cde)-> &d_ptr);
	}' unless defined(&ADDR_VR);
    } else {
	eval 'sub d_xmemdp () { &d_segval;}' unless defined(&d_xmemdp);
	eval 'sub d_segval () { ($_d->{_d_segval});}' unless defined(&d_segval);
	eval 'sub cdt_entry32 () { &cdt_entry;}' unless defined(&cdt_entry32);
	eval 'sub d_realaddr () { ($_u->{_d_realaddr});}' unless defined(&d_realaddr);
	eval 'sub d_segval_v () { ($_u->{_d}->{_d_segval});}' unless defined(&d_segval_v);
	eval 'sub d_ptr_v () { ($_u->{_d}->{_d_ptr});}' unless defined(&d_ptr_v);
	eval 'sub D_REAL () {0x1;}' unless defined(&D_REAL);
	eval 'sub ISADDRREAL {
	    my($cde) = @_;
    	    eval q((($cde)-> &d_addrflags &  &D_REAL));
	}' unless defined(&ISADDRREAL);
	eval 'sub ADDR_VR {
	    my($cde) = @_;
    	    eval q( ? -> &d_realaddr : ($cde)-> &d_ptr_v);
	}' unless defined(&ADDR_VR);
    }
    eval 'sub DMP_MAGIC_32 () {0xeeeeeeee;}' unless defined(&DMP_MAGIC_32);
    eval 'sub DMP_MAGIC_VR () {0xeeeeeeef;}' unless defined(&DMP_MAGIC_VR);
    eval 'sub DMP_MAGIC_64 () {0xeeeeeeed;}' unless defined(&DMP_MAGIC_64);
    if(defined(&__64BIT__)) {
	eval 'sub DMP_MAGIC () { &DMP_MAGIC_64;}' unless defined(&DMP_MAGIC);
    } else {
	eval 'sub DMP_MAGIC () { &DMP_MAGIC_32;}' unless defined(&DMP_MAGIC);
    }
    unless(defined(&__64BIT__)) {
    }
    eval 'sub cdt_magic () { ($_cdt_head->{_cdt_magic});}' unless defined(&cdt_magic);
    eval 'sub cdt_name () { ($_cdt_head->{_cdt_name});}' unless defined(&cdt_name);
    eval 'sub cdt_len () { ($_cdt_head->{_cdt_len});}' unless defined(&cdt_len);
    eval 'sub VALID_DMP_MAGIC_32_64 {
        my($n) = @_;
	    eval q(((($n) ==  &DMP_MAGIC_32) || (($n) ==  &DMP_MAGIC_64) || (($n) ==  &DMP_MAGIC_VR)));
    }' unless defined(&VALID_DMP_MAGIC_32_64);
    eval 'sub CDT_ENTRY_SIZE_32_64 {
        my($comp_head) = @_;
	    eval q(( (($comp_head)-> &cdt_magic== &DMP_MAGIC_64) ? $sizeof{\'struct cdt_entry64\'}: ( (( &ISDMPVR($comp_head)) ? $sizeof{\'struct cdt_entry_vr\'} : $sizeof{\'struct cdt_entry32\'})) ));
    }' unless defined(&CDT_ENTRY_SIZE_32_64);
    eval 'sub NUM_ENTRIES_32_64 {
        my($cp) = @_;
	    eval q(((($cp)-> &cdt_len - $sizeof{\'struct cdt_head\'}) /  &CDT_ENTRY_SIZE_32_64($cp) ));
    }' unless defined(&NUM_ENTRIES_32_64);
    if(defined(&__64BIT__)) {
	eval 'sub VALID_DMP_MAGIC {
	    my($n) = @_;
    	    eval q((($n) ==  &DMP_MAGIC));
	}' unless defined(&VALID_DMP_MAGIC);
    } else {
	eval 'sub VALID_DMP_MAGIC {
	    my($n) = @_;
    	    eval q(((($n) ==  &DMP_MAGIC) || (($n) ==  &DMP_MAGIC_VR)));
	}' unless defined(&VALID_DMP_MAGIC);
    }
    eval 'sub VALID_CDT_MAGIC {
        my($cp) = @_;
	    eval q( &VALID_DMP_MAGIC(($cp)-> &cdt_magic));
    }' unless defined(&VALID_CDT_MAGIC);
    eval 'sub VALID_CDT_MAGIC_32_64 {
        my($cp) = @_;
	    eval q( &VALID_DMP_MAGIC_32_64(($cp)-> &cdt_magic));
    }' unless defined(&VALID_CDT_MAGIC_32_64);
    if(defined(&__64BIT__)) {
	eval 'sub ISDMPVR {
	    my($cp) = @_;
    	    eval q(0);
	}' unless defined(&ISDMPVR);
    } else {
	eval 'sub ISDMPVR {
	    my($cp) = @_;
    	    eval q((($cp)-> &cdt_magic ==  &DMP_MAGIC_VR));
	}' unless defined(&ISDMPVR);
    }
    if(defined(&__64BIT__)) {
	eval 'sub CDT_ENTRY_SIZE {
	    my($cp) = @_;
    	    eval q($sizeof{\'struct cdt_entry\'});
	}' unless defined(&CDT_ENTRY_SIZE);
    } else {
	eval 'sub CDT_ENTRY_SIZE {
	    my($cp) = @_;
    	    eval q((( &ISDMPVR($cp)) ? $sizeof{\'struct cdt_entry_vr\'} : $sizeof{\'struct cdt_entry\'}));
	}' unless defined(&CDT_ENTRY_SIZE);
    }
    eval 'sub NUM_ENTRIES {
        my($cp) = @_;
	    eval q(((($cp)-> &cdt_len - $sizeof{\'struct cdt_head\'}) /  &CDT_ENTRY_SIZE($cp) ));
    }' unless defined(&NUM_ENTRIES);
    unless(defined(&__64BIT__)) {
	eval 'sub CDT_OLD2NEW {
	    my($oldp, $newp) = @_;
    	    eval q({ \'int\' * &iold = , * &inew = ($newp); * &inew++ = * &iold++; * &inew++ = * &iold++; * &inew++ = 0; * &inew++ = 0; * &inew++ = * &iold++; * &inew++ = 0; * &inew++ = * &iold++; * &inew = * &iold; });
	}' unless defined(&CDT_OLD2NEW);
    }
    unless(defined(&_UW7_)) {
    }
    if(defined(&__64BIT__)) {
	eval 'sub DMP_MAXSEGS () {30;}' unless defined(&DMP_MAXSEGS);
    } else {
	eval 'sub DMP_MAXSEGS () {1;}' unless defined(&DMP_MAXSEGS);
    }
    eval 'sub DMP_MAXPAGES () {((( &DMP_MAXSEGS * 256* 1024* 1024) /  &PAGESIZE));}' unless defined(&DMP_MAXPAGES);
    eval 'sub BITS_BM () {(8* $sizeof{ &bitmap_t});}' unless defined(&BITS_BM);
    eval 'sub DMP_BMBITS () {(512*  &BITS_BM);}' unless defined(&DMP_BMBITS);
    eval 'sub DMP_BMMASK () {(512*  &BITS_BM - 1);}' unless defined(&DMP_BMMASK);
    eval 'sub ISBITMAP {
        my($bm,$bit) = @_;
	    eval q(( $bm->[($bit)/ &BITS_BM] & (1<< (($bit) %  &BITS_BM)) ));
    }' unless defined(&ISBITMAP);
    eval 'sub SETBITMAP {
        my($bm,$bit) = @_;
	    eval q(( $bm->[($bit)/ &BITS_BM] |= (1<< (($bit) %  &BITS_BM)) ));
    }' unless defined(&SETBITMAP);
    if(defined(&__64BIT__)) {
	eval 'sub BTOP {
	    my($addr) = @_;
    	    eval q(((($addr) & ( &SEGSIZE-1)) /  &PAGESIZE));
	}' unless defined(&BTOP);
    } else {
	eval 'sub BTOP {
	    my($addr) = @_;
    	    eval q(((($addr) & 0xfffffff) /  &PAGESIZE));
	}' unless defined(&BTOP);
	eval 'sub BTOPR {
	    my($addr) = @_;
    	    eval q((($addr) /  &PAGESIZE));
	}' unless defined(&BTOPR);
	eval 'sub BTOP_VR {
	    my($f,$addr) = @_;
    	    eval q((($f) ?  &BTOPR($addr) :  &BTOP($addr)));
	}' unless defined(&BTOP_VR);
    }
    if(defined(&__64BIT__)) {
	eval 'sub DMPLIM {
	    my($ptr,$len) = @_;
    	    eval q((($ptr)+($len)-1));
	}' unless defined(&DMPLIM);
    } else {
	eval 'sub DMPSEG {
	    my($x) = @_;
    	    eval q((($x) & 1.84467440734411e+19));
	}' unless defined(&DMPSEG);
	eval 'sub DMPLIM {
	    my($ptr,$len) = @_;
    	    eval q((  &DMPSEG(+-1) ==  &DMPSEG ? (($ptr)+($len)-1) : 0xfffffff ));
	}' unless defined(&DMPLIM);
	eval 'sub DMPLIMR {
	    my($ptr,$len) = @_;
    	    eval q((($ptr)+($len)-1));
	}' unless defined(&DMPLIMR);
	eval 'sub DMPLIM_VR {
	    my($f,$addr,$len) = @_;
    	    eval q((($f) ?  &DMPLIMR($addr,$len) :  &DMPLIM($addr,$len)));
	}' unless defined(&DMPLIM_VR);
    }
    eval 'sub NPAGES32 {
        my($ptr,$len) = @_;
	    eval q(( ($len) == 0? 0:  &BTOP( &DMPLIM($ptr,$len)) -  &BTOP($ptr) + 1));
    }' unless defined(&NPAGES32);
    eval 'sub NPAGES_VR {
        my($f,$ptr,$len) = @_;
	    eval q(( == 0? 0: ( &BTOP_VR($f, &DMPLIM_VR($f,$ptr,$len)) -  &BTOP_VR($f,$ptr) + 1) ));
    }' unless defined(&NPAGES_VR);
    eval 'sub NPAGES_CDE32 {
        my($cep) = @_;
	    eval q( &NPAGES_VR( &ISADDRREAL($cep),  &ADDR_VR($cep), ($cep)-> &d_len));
    }' unless defined(&NPAGES_CDE32);
    eval 'sub NPAGES64 {
        my($ptr,$len) = @_;
	    eval q(( == 0? 0: (((($ptr) & ( &PAGESIZE-1)) + ($len) +  &PAGESIZE - 1) /  &PAGESIZE)));
    }' unless defined(&NPAGES64);
    eval 'sub NPAGES_CDE64 {
        my($cep) = @_;
	    eval q( &NPAGES64(($cep)-> &d_ptr, ($cep)-> &d_len));
    }' unless defined(&NPAGES_CDE64);
    if(defined(&__64BIT__)) {
	eval 'sub NPAGES {
	    my($ptr,$len) = @_;
    	    eval q( &NPAGES64($ptr,$len));
	}' unless defined(&NPAGES);
	eval 'sub NPAGES_CDE {
	    my($cep) = @_;
    	    eval q( &NPAGES_CDE64($cep));
	}' unless defined(&NPAGES_CDE);
    } else {
	eval 'sub NPAGES {
	    my($ptr,$len) = @_;
    	    eval q( &NPAGES32($ptr,$len));
	}' unless defined(&NPAGES);
	eval 'sub NPAGES_CDE {
	    my($cep) = @_;
    	    eval q( &NPAGES_CDE32($cep));
	}' unless defined(&NPAGES_CDE);
    }
    eval 'sub BITMAPSIZE64 {
        my($ptr,$len) = @_;
	    eval q(( ( &NPAGES64($ptr,$len) +  &BITS_BM - 1) /  &BITS_BM ));
    }' unless defined(&BITMAPSIZE64);
    eval 'sub BITMAPSIZE_CDE64 {
        my($cep) = @_;
	    eval q( &BITMAPSIZE64(($cep)-> &d_ptr, ($cep)-> &d_len));
    }' unless defined(&BITMAPSIZE_CDE64);
    eval 'sub BITMAPSIZE32 {
        my($ptr,$len) = @_;
	    eval q(( ( &NPAGES32($ptr,$len) +  &BITS_BM - 1) /  &BITS_BM ));
    }' unless defined(&BITMAPSIZE32);
    eval 'sub BITMAPSIZE_VR {
        my($f,$ptr,$len) = @_;
	    eval q(( ( &NPAGES_VR($f,$ptr,$len) +  &BITS_BM - 1) /  &BITS_BM ));
    }' unless defined(&BITMAPSIZE_VR);
    eval 'sub BITMAPSIZE_CDE32 {
        my($cep) = @_;
	    eval q( &BITMAPSIZE_VR( &ISADDRREAL($cep),  &ADDR_VR($cep), ($cep)-> &d_len));
    }' unless defined(&BITMAPSIZE_CDE32);
    if(defined(&__64BIT__)) {
	eval 'sub BITMAPSIZE {
	    my($ptr,$len) = @_;
    	    eval q( &BITMAPSIZE64($ptr,$len));
	}' unless defined(&BITMAPSIZE);
	eval 'sub BITMAPSIZE_CDE {
	    my($cep) = @_;
    	    eval q( &BITMAPSIZE_CDE64($cep));
	}' unless defined(&BITMAPSIZE_CDE);
    } else {
	eval 'sub BITMAPSIZE {
	    my($ptr,$len) = @_;
    	    eval q( &BITMAPSIZE32($ptr,$len));
	}' unless defined(&BITMAPSIZE);
	eval 'sub BITMAPSIZE_CDE {
	    my($cep) = @_;
    	    eval q( &BITMAPSIZE_CDE32($cep));
	}' unless defined(&BITMAPSIZE_CDE);
    }
    eval 'sub DMPD_PRIM () {1;}' unless defined(&DMPD_PRIM);
    eval 'sub DMPD_SEC () {2;}' unless defined(&DMPD_SEC);
    eval 'sub DMPD_AUTO () {3;}' unless defined(&DMPD_AUTO);
    eval 'sub DMPD_PRIM_HALT () {4;}' unless defined(&DMPD_PRIM_HALT);
    eval 'sub DMPD_SEC_HALT () {5;}' unless defined(&DMPD_SEC_HALT);
    eval 'sub DMPDO_SUCCESS () {0;}' unless defined(&DMPDO_SUCCESS);
    eval 'sub DMPDO_DISABLED () {-1;}' unless defined(&DMPDO_DISABLED);
    eval 'sub DMPDO_PART () {-2;}' unless defined(&DMPDO_PART);
    eval 'sub DMPDO_FAIL () {-3;}' unless defined(&DMPDO_FAIL);
    eval 'sub DMPDO_IOERROR () {-4;}' unless defined(&DMPDO_IOERROR);
    eval 'sub DMPFL_NEEDLOG () {0x1;}' unless defined(&DMPFL_NEEDLOG);
    eval 'sub DMPFL_NEEDCOPY () {0x2;}' unless defined(&DMPFL_NEEDCOPY);
    if(defined(&_KERNEL)) {
	eval 'sub AUTO_DUMP () {0;}' unless defined(&AUTO_DUMP);
	eval 'sub KEYSEQ_DUMP () {1;}' unless defined(&KEYSEQ_DUMP);
	eval 'sub RESET_DUMP () {2;}' unless defined(&RESET_DUMP);
	eval 'sub DUMPIO_STAT_V1 () {1;}' unless defined(&DUMPIO_STAT_V1);
	if(defined(&__64BIT_KERNEL)) {
	} else {
	}
	if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
	    if(defined(&_KERNSYS)) {
	    }
	}
    }
}
1;
