require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_FCP)) {
    eval 'sub _H_FCP () {1;}' unless defined(&_H_FCP);
    require 'sys/scsi_buf.ph';
    eval 'sub FCP_NPORTID_MASK () {0xffffff;}' unless defined(&FCP_NPORTID_MASK);
    if(defined(&__ia64)) {
	eval 'sub FCP_WRITE_DATA () {0x1000000;}' unless defined(&FCP_WRITE_DATA);
	eval 'sub FCP_READ_DATA () {0x2000000;}' unless defined(&FCP_READ_DATA);
	eval 'sub FCP_TASK_MGM_FLGS_MASK () {0xf60000;}' unless defined(&FCP_TASK_MGM_FLGS_MASK);
	eval 'sub FCP_ABORT_TASK_SET () {0x20000;}' unless defined(&FCP_ABORT_TASK_SET);
	eval 'sub FCP_CLEAR_TASK_SET () {0x40000;}' unless defined(&FCP_CLEAR_TASK_SET);
	eval 'sub FCP_LUN_RESET () {0x100000;}' unless defined(&FCP_LUN_RESET);
	eval 'sub FCP_TARGET_RESET () {0x200000;}' unless defined(&FCP_TARGET_RESET);
	eval 'sub FCP_CLEAR_ACA () {0x400000;}' unless defined(&FCP_CLEAR_ACA);
	eval 'sub FCP_TERMINATE_TASK () {0x800000;}' unless defined(&FCP_TERMINATE_TASK);
	eval 'sub FCP_TASK_ATTR_MASK () {0x700;}' unless defined(&FCP_TASK_ATTR_MASK);
	eval 'sub FCP_SIMPLE_Q () {0x;}' unless defined(&FCP_SIMPLE_Q);
	eval 'sub FCP_HEAD_OF_Q () {0x100;}' unless defined(&FCP_HEAD_OF_Q);
	eval 'sub FCP_ORDERED_Q () {0x200;}' unless defined(&FCP_ORDERED_Q);
	eval 'sub FCP_ACA_Q () {0x400;}' unless defined(&FCP_ACA_Q);
	eval 'sub FCP_UNTAGGED () {0x500;}' unless defined(&FCP_UNTAGGED);
	eval 'sub FCP_CRN_MASK () {0xff;}' unless defined(&FCP_CRN_MASK);
    } else {
	eval 'sub FCP_WRITE_DATA () {0x1;}' unless defined(&FCP_WRITE_DATA);
	eval 'sub FCP_READ_DATA () {0x2;}' unless defined(&FCP_READ_DATA);
	eval 'sub FCP_TASK_MGM_FLGS_MASK () {0xf600;}' unless defined(&FCP_TASK_MGM_FLGS_MASK);
	eval 'sub FCP_ABORT_TASK_SET () {0x200;}' unless defined(&FCP_ABORT_TASK_SET);
	eval 'sub FCP_CLEAR_TASK_SET () {0x400;}' unless defined(&FCP_CLEAR_TASK_SET);
	eval 'sub FCP_LUN_RESET () {0x1000;}' unless defined(&FCP_LUN_RESET);
	eval 'sub FCP_TARGET_RESET () {0x2000;}' unless defined(&FCP_TARGET_RESET);
	eval 'sub FCP_CLEAR_ACA () {0x4000;}' unless defined(&FCP_CLEAR_ACA);
	eval 'sub FCP_TERMINATE_TASK () {0x8000;}' unless defined(&FCP_TERMINATE_TASK);
	eval 'sub FCP_TASK_ATTR_MASK () {0x70000;}' unless defined(&FCP_TASK_ATTR_MASK);
	eval 'sub FCP_SIMPLE_Q () {0x;}' unless defined(&FCP_SIMPLE_Q);
	eval 'sub FCP_HEAD_OF_Q () {0x10000;}' unless defined(&FCP_HEAD_OF_Q);
	eval 'sub FCP_ORDERED_Q () {0x20000;}' unless defined(&FCP_ORDERED_Q);
	eval 'sub FCP_ACA_Q () {0x40000;}' unless defined(&FCP_ACA_Q);
	eval 'sub FCP_UNTAGGED () {0x50000;}' unless defined(&FCP_UNTAGGED);
	eval 'sub FCP_CRN_MASK () {0xff000000;}' unless defined(&FCP_CRN_MASK);
    }
    if(defined(&__ia64)) {
	eval 'sub FCP_SET_CRN {
	    my($fcp_cntl, $crn) = @_;
    	    eval q({ ($fcp_cntl) &= 0xffffff00; ($fcp_cntl) |= (($crn) & 0xff) });
	}' unless defined(&FCP_SET_CRN);
    } else {
	eval 'sub FCP_SET_CRN {
	    my($fcp_cntl, $crn) = @_;
    	    eval q({ ($fcp_cntl) &= 0xffffff; ($fcp_cntl) |= (($crn) & 0xff) << 24; });
	}' unless defined(&FCP_SET_CRN);
    }
    if(defined(&__ia64)) {
	eval 'sub FCP_GET_CRN {
	    my($fcp_cntl, $crn) = @_;
    	    eval q({ = (($fcp_cntl) & 0xff); });
	}' unless defined(&FCP_GET_CRN);
    } else {
	eval 'sub FCP_GET_CRN {
	    my($fcp_cntl, $crn) = @_;
    	    eval q({ = ((($fcp_cntl) & 0xff000000) >> 24) & 0xff; });
	}' unless defined(&FCP_GET_CRN);
    }
    eval 'sub MAX_FCP_INFO_LENGTH () {256;}' unless defined(&MAX_FCP_INFO_LENGTH);
    if(defined(&__ia64)) {
	eval 'sub FCP_CONF_REQ () {0x100000;}' unless defined(&FCP_CONF_REQ);
	eval 'sub FCP_RESID_UNDER () {0x80000;}' unless defined(&FCP_RESID_UNDER);
	eval 'sub FCP_RESID_OVER () {0x40000;}' unless defined(&FCP_RESID_OVER);
	eval 'sub FCP_SNS_LEN_VALID () {0x20000;}' unless defined(&FCP_SNS_LEN_VALID);
	eval 'sub FCP_RSP_LEN_VALID () {0x10000;}' unless defined(&FCP_RSP_LEN_VALID);
	eval 'sub FCP_SCSI_STATUS_MASK () {0xff000000;}' unless defined(&FCP_SCSI_STATUS_MASK);
    } else {
	eval 'sub FCP_CONF_REQ () {0x1000;}' unless defined(&FCP_CONF_REQ);
	eval 'sub FCP_RESID_UNDER () {0x800;}' unless defined(&FCP_RESID_UNDER);
	eval 'sub FCP_RESID_OVER () {0x400;}' unless defined(&FCP_RESID_OVER);
	eval 'sub FCP_SNS_LEN_VALID () {0x200;}' unless defined(&FCP_SNS_LEN_VALID);
	eval 'sub FCP_RSP_LEN_VALID () {0x100;}' unless defined(&FCP_RSP_LEN_VALID);
	eval 'sub FCP_SCSI_STATUS_MASK () {0xff;}' unless defined(&FCP_SCSI_STATUS_MASK);
    }
    eval 'sub FCP_RSP_CODE_MASK () {0xff;}' unless defined(&FCP_RSP_CODE_MASK);
    eval 'sub FCP_RSP_SUCCESSFUL () {0x;}' unless defined(&FCP_RSP_SUCCESSFUL);
    eval 'sub FCP_RSP_LENGTH_DIFF () {0x1;}' unless defined(&FCP_RSP_LENGTH_DIFF);
    eval 'sub FCP_RSP_INVALID_CMD_FIELDS () {0x2;}' unless defined(&FCP_RSP_INVALID_CMD_FIELDS);
    eval 'sub FCP_RSP_DATARO_MISMATCH () {0x3;}' unless defined(&FCP_RSP_DATARO_MISMATCH);
    eval 'sub FCP_RSP_TSKMGM_UNSUPPORED () {0x4;}' unless defined(&FCP_RSP_TSKMGM_UNSUPPORED);
    eval 'sub FCP_RSP_TSKMGM_FAILED () {0x5;}' unless defined(&FCP_RSP_TSKMGM_FAILED);
    eval 'sub FCP_SCSI () {0x8;}' unless defined(&FCP_SCSI);
    eval 'sub FCP_CREATE_IMAGE_PAIR () {0x20;}' unless defined(&FCP_CREATE_IMAGE_PAIR);
    eval 'sub FCP_SUCCESS_RESP () {0x1;}' unless defined(&FCP_SUCCESS_RESP);
    if(defined(&__ia64)) {
	eval 'sub FCP_DEV_RETRY_CMD () {0x1;}' unless defined(&FCP_DEV_RETRY_CMD);
	eval 'sub FCP_DEV_CONF_COMPLETE () {0x8000;}' unless defined(&FCP_DEV_CONF_COMPLETE);
	eval 'sub FCP_DEV_DATA_OVERLAY () {0x4000;}' unless defined(&FCP_DEV_DATA_OVERLAY);
	eval 'sub FCP_DEV_INITIATOR_FCN () {0x2000;}' unless defined(&FCP_DEV_INITIATOR_FCN);
	eval 'sub FCP_DEV_TARGET_FCN () {0x1000;}' unless defined(&FCP_DEV_TARGET_FCN);
	eval 'sub FCP_DEV_MIXED_CMD_DATA () {0x800;}' unless defined(&FCP_DEV_MIXED_CMD_DATA);
	eval 'sub FCP_DEV_MIXED_DATA_RSP () {0x400;}' unless defined(&FCP_DEV_MIXED_DATA_RSP);
	eval 'sub FCP_DEV_READ_XFER_RDY_DISABLED () {0x200;}' unless defined(&FCP_DEV_READ_XFER_RDY_DISABLED);
	eval 'sub FCP_DEV_WRITE_XFER_RDY_DISABLED () {0x100;}' unless defined(&FCP_DEV_WRITE_XFER_RDY_DISABLED);
    } else {
	eval 'sub FCP_DEV_RETRY_CMD () {0x100;}' unless defined(&FCP_DEV_RETRY_CMD);
	eval 'sub FCP_DEV_CONF_COMPLETE () {0x80;}' unless defined(&FCP_DEV_CONF_COMPLETE);
	eval 'sub FCP_DEV_DATA_OVERLAY () {0x40;}' unless defined(&FCP_DEV_DATA_OVERLAY);
	eval 'sub FCP_DEV_INITIATOR_FCN () {0x20;}' unless defined(&FCP_DEV_INITIATOR_FCN);
	eval 'sub FCP_DEV_TARGET_FCN () {0x10;}' unless defined(&FCP_DEV_TARGET_FCN);
	eval 'sub FCP_DEV_MIXED_CMD_DATA () {0x8;}' unless defined(&FCP_DEV_MIXED_CMD_DATA);
	eval 'sub FCP_DEV_MIXED_DATA_RSP () {0x4;}' unless defined(&FCP_DEV_MIXED_DATA_RSP);
	eval 'sub FCP_DEV_READ_XFER_RDY_DISABLED () {0x2;}' unless defined(&FCP_DEV_READ_XFER_RDY_DISABLED);
	eval 'sub FCP_DEV_WRITE_XFER_RDY_DISABLED () {0x1;}' unless defined(&FCP_DEV_WRITE_XFER_RDY_DISABLED);
    }
    if(defined(&__ia64)) {
	eval 'sub FCP_GET_DEV_FLAGS {
	    my($dev_flags) = @_;
    	    eval q(((((($dev_flags)) >> 8) & 0xff)));
	}' unless defined(&FCP_GET_DEV_FLAGS);
    } else {
	eval 'sub FCP_GET_DEV_FLAGS {
	    my($dev_flags) = @_;
    	    eval q(((($dev_flags) & 0xff)));
	}' unless defined(&FCP_GET_DEV_FLAGS);
    }
    eval 'sub FCP_RETRY_CMD () {0x100;}' unless defined(&FCP_RETRY_CMD);
    eval 'sub FCP_CONF_COMPLETE () {0x80;}' unless defined(&FCP_CONF_COMPLETE);
    eval 'sub FCP_DATA_OVERLAY () {0x40;}' unless defined(&FCP_DATA_OVERLAY);
    eval 'sub FCP_INITIATOR_FCN () {0x20;}' unless defined(&FCP_INITIATOR_FCN);
    eval 'sub FCP_TARGET_FCN () {0x10;}' unless defined(&FCP_TARGET_FCN);
    eval 'sub FCP_MIXED_CMD_DATA () {0x8;}' unless defined(&FCP_MIXED_CMD_DATA);
    eval 'sub FCP_MIXED_DATA_RSP () {0x4;}' unless defined(&FCP_MIXED_DATA_RSP);
    eval 'sub FCP_READ_XFER_RDY_DISABLED () {0x2;}' unless defined(&FCP_READ_XFER_RDY_DISABLED);
    eval 'sub FCP_WRITE_XFER_RDY_DISABLED () {0x1;}' unless defined(&FCP_WRITE_XFER_RDY_DISABLED);
    eval 'sub FCP_PRLI_CMD () {0x20;}' unless defined(&FCP_PRLI_CMD);
    eval 'sub FCP_PRLO_CMD () {0x21;}' unless defined(&FCP_PRLO_CMD);
}
1;
