require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_FILE)) {
    eval 'sub _H_FILE () {1;}' unless defined(&_H_FILE);
    require 'sys/types.ph';
    require 'sys/param.ph';
    require 'sys/access.ph';
    require 'sys/lock_def.ph';
    require 'sys/cred.ph';
    require 'sys/uio.ph';
    require 'fcntl.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
	} else {
	}
	eval 'sub f_data () { ($f_up->{f_uvnode});}' unless defined(&f_data);
	eval 'sub f_vnode () { ($f_up->{f_uvnode});}' unless defined(&f_vnode);
	eval 'sub f_next () { ($f_up->{f_unext});}' unless defined(&f_next);
	eval 'sub f_cred () { ($f_cp->{f_cpcred});}' unless defined(&f_cred);
	eval 'sub f_qmnext () { ($f_cp->{f_cpqmnext});}' unless defined(&f_qmnext);
	eval 'sub DTYPE_VNODE () {1;}' unless defined(&DTYPE_VNODE);
	eval 'sub DTYPE_SOCKET () {2;}' unless defined(&DTYPE_SOCKET);
	eval 'sub DTYPE_GNODE () {3;}' unless defined(&DTYPE_GNODE);
	eval 'sub DTYPE_OTHER () {-1;}' unless defined(&DTYPE_OTHER);
	eval 'sub FAIO () {0x1;}' unless defined(&FAIO);
	eval 'sub GCFMARK () {0x2;}' unless defined(&GCFMARK);
	eval 'sub GCFDEFER () {0x4;}' unless defined(&GCFDEFER);
	eval 'sub FREVOKED () {0x8;}' unless defined(&FREVOKED);
	eval 'sub FAIO_FPATH () {0x10;}' unless defined(&FAIO_FPATH);
	eval 'sub FAIO_KPROC () {0x20;}' unless defined(&FAIO_KPROC);
	eval 'sub FOBIT6 () {0x40;}' unless defined(&FOBIT6);
	eval 'sub FOBIT7 () {0x80;}' unless defined(&FOBIT7);
	eval 'sub FOBIT8 () {0x100;}' unless defined(&FOBIT8);
	eval 'sub FOBIT9 () {0x200;}' unless defined(&FOBIT9);
	eval 'sub FOBIT10 () {0x400;}' unless defined(&FOBIT10);
	eval 'sub FOBIT11 () {0x800;}' unless defined(&FOBIT11);
	eval 'sub FOBIT12 () {0x1000;}' unless defined(&FOBIT12);
	eval 'sub FOBIT13 () {0x2000;}' unless defined(&FOBIT13);
	eval 'sub FOBIT14 () {0x4000;}' unless defined(&FOBIT14);
	eval 'sub FOBIT15 () {0x8000;}' unless defined(&FOBIT15);
	if(defined(&__64BIT_KERNEL)) {
	} else {
	}
    }
    eval 'sub LOCK_SH () {1;}' unless defined(&LOCK_SH);
    eval 'sub LOCK_EX () {2;}' unless defined(&LOCK_EX);
    eval 'sub LOCK_NB () {4;}' unless defined(&LOCK_NB);
    eval 'sub LOCK_UN () {8;}' unless defined(&LOCK_UN);
    eval 'sub L_SET () {0;}' unless defined(&L_SET);
    eval 'sub L_INCR () {1;}' unless defined(&L_INCR);
    eval 'sub L_XTND () {2;}' unless defined(&L_XTND);
    if(defined(&__cplusplus)) {
    }
}
1;
