require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_FTYP)) {
    eval 'sub _H_FTYP () {1;}' unless defined(&_H_FTYP);
    require 'sys/types.ph';
    eval 'sub FsVar () {0;}' unless defined(&FsVar);
    eval 'sub Fs1b () {1;}' unless defined(&Fs1b);
    eval 'sub Fs2b () {2;}' unless defined(&Fs2b);
    eval 'sub Fs4b () {3;}' unless defined(&Fs4b);
    eval 'sub Fs8b () {4;}' unless defined(&Fs8b);
    eval 'sub Fs16b () {5;}' unless defined(&Fs16b);
    eval 'sub Fs32b () {6;}' unless defined(&Fs32b);
    eval 'sub Fs64b () {7;}' unless defined(&Fs64b);
    if(!defined( &lint)  && defined( &_FSpgen)) {
	eval 'sub LOG2 {
	    my($x) = @_;
    	    eval q(( (($x) < 2) ? 0: ( (($x) < 4) ? 1: ( (($x) < 8) ? 2: ( (($x) < 16) ? 3: ( (($x) < 32) ? 4: ( (($x) < 64) ? 5: ( (($x) < 128) ? 6: ( (($x) < 256) ? 7: ( (($x) < 512) ? 8: 9)))))))) ));
	}' unless defined(&LOG2);
	eval 'sub BSmin () { &LOG2( &UBSIZE);}' unless defined(&BSmin);
	eval 'sub ISmin () { &LOG2( &UBSIZE/$sizeof{\'struct dinode\'});}' unless defined(&ISmin);
	eval 'sub NSmin () { &LOG2( &UBSIZE/$sizeof{ &daddr_t});}' unless defined(&NSmin);
	eval 'sub FSPARM {
	    my($t,$b) = @_;
    	    eval q({ ($t), ($b), (($b)-1), ((($b)/$sizeof{ &daddr_t})-1), (($b)/$sizeof{\'struct dinode\'}), (($b)/$sizeof{ &daddr_t}), ((($b)/$sizeof{\'struct dinode\'})-1), ( &BSmin + (($t)-1)), ( &ISmin + (($t)-1)), ( &NSmin + (($t)-1)), (($b)/256) });
	}' unless defined(&FSPARM);
    } else {
    }
    if(defined(&BMASK)) {
	undef(&BMASK) if defined(&BMASK);
	undef(&NMASK) if defined(&NMASK);
	undef(&INOPB) if defined(&INOPB);
	undef(&NINDIR) if defined(&NINDIR);
	undef(&INOMASK) if defined(&INOMASK);
	undef(&BSHIFT) if defined(&BSHIFT);
	undef(&NSHIFT) if defined(&NSHIFT);
    }
    eval 'sub BLKSIZE {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_blksize}));
    }' unless defined(&BLKSIZE);
    eval 'sub BMASK {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_bmask}));
    }' unless defined(&BMASK);
    eval 'sub NMASK {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_nmask}));
    }' unless defined(&NMASK);
    eval 'sub INOPB {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_inopb}));
    }' unless defined(&INOPB);
    eval 'sub NINDIR {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_nindir}));
    }' unless defined(&NINDIR);
    eval 'sub INOMASK {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_inomask}));
    }' unless defined(&INOMASK);
    eval 'sub BSHIFT {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_bshift}));
    }' unless defined(&BSHIFT);
    eval 'sub ISHIFT {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_ishift}));
    }' unless defined(&ISHIFT);
    eval 'sub NSHIFT {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_nshift}));
    }' unless defined(&NSHIFT);
    eval 'sub CHNKSIZE {
        my($t) = @_;
	    eval q( ($_FSparms[(t)-1]->{FS_chnksize}));
    }' unless defined(&CHNKSIZE);
    if(defined(&itod)) {
	undef(&itod) if defined(&itod);
	undef(&itoo) if defined(&itoo);
    }
    eval 'sub itod {
        my($x,$t) = @_;
	    eval q(( &daddr_t)(((($x)-1)>> &ISHIFT($t))+2));
    }' unless defined(&itod);
    eval 'sub itoo {
        my($x,$t) = @_;
	    eval q(((($x)-1) &INOMASK($t)));
    }' unless defined(&itoo);
}
1;
