require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_Generic_MIBS)) {
    eval 'sub _H_Generic_MIBS () {1;}' unless defined(&_H_Generic_MIBS);
    require 'sys/machine.ph';
    eval 'sub GENERIC_CHIPSET () {1;}' unless defined(&GENERIC_CHIPSET);
    eval 'sub CHIPSETLENGTH () {64;}' unless defined(&CHIPSETLENGTH);
    if((defined(&BYTEORDER) ? &BYTEORDER : 0)==(defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	eval 'sub UNKNOWNCHIPSET () {"\\000\\000\\000\\002\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000";}' unless defined(&UNKNOWNCHIPSET);
    } else {
	eval 'sub UNKNOWNCHIPSET () {"\\002\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000\\000";}' unless defined(&UNKNOWNCHIPSET);
    }
    eval 'sub GENERIC_REVWARE () {2;}' unless defined(&GENERIC_REVWARE);
    eval 'sub GENERIC_MCAST_TX_OK () {3;}' unless defined(&GENERIC_MCAST_TX_OK);
    eval 'sub GENERIC_BCAST_TX_OK () {4;}' unless defined(&GENERIC_BCAST_TX_OK);
    eval 'sub GENERIC_MCAST_RX_OK () {5;}' unless defined(&GENERIC_MCAST_RX_OK);
    eval 'sub GENERIC_BCAST_RX_OK () {6;}' unless defined(&GENERIC_BCAST_RX_OK);
    eval 'sub GENERIC_PROMISCUOUS () {7;}' unless defined(&GENERIC_PROMISCUOUS);
    eval 'sub PROMTRUE () {1;}' unless defined(&PROMTRUE);
    eval 'sub PROMFALSE () {2;}' unless defined(&PROMFALSE);
    eval 'sub GENERIC_COMMUNITY () {10;}' unless defined(&GENERIC_COMMUNITY);
    eval 'sub GENERIC_REQUEST_ID () {11;}' unless defined(&GENERIC_REQUEST_ID);
    eval 'sub GENERIC_TYPE () {12;}' unless defined(&GENERIC_TYPE);
    eval 'sub GEN_MIB_NOTEST () {0;}' unless defined(&GEN_MIB_NOTEST);
    eval 'sub GEN_MIB_TESTFULLDUPLEXLOOPBACK () {1;}' unless defined(&GEN_MIB_TESTFULLDUPLEXLOOPBACK);
    eval 'sub GENERIC_RESULT () {13;}' unless defined(&GENERIC_RESULT);
    eval 'sub GEN_MIB_NONE () {1;}' unless defined(&GEN_MIB_NONE);
    eval 'sub GEN_MIB_SUCCESS () {2;}' unless defined(&GEN_MIB_SUCCESS);
    eval 'sub GEN_MIB_INPROGRESS () {3;}' unless defined(&GEN_MIB_INPROGRESS);
    eval 'sub GEN_MIB_NOTSUPPORTED () {4;}' unless defined(&GEN_MIB_NOTSUPPORTED);
    eval 'sub GEN_MIB_UNABLETORUN () {5;}' unless defined(&GEN_MIB_UNABLETORUN);
    eval 'sub GEN_MIB_ABORTED () {6;}' unless defined(&GEN_MIB_ABORTED);
    eval 'sub GEN_MIB_FAILED () {7;}' unless defined(&GEN_MIB_FAILED);
    eval 'sub GENERIC_CODE () {14;}' unless defined(&GENERIC_CODE);
    eval 'sub GENERIC_ADDRESS_STATUS () {15;}' unless defined(&GENERIC_ADDRESS_STATUS);
}
1;
