require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_IOACC)) {
    eval 'sub _H_IOACC () {1;}' unless defined(&_H_IOACC);
    require 'sys/types.ph';
    if(defined(&__ia64)) {
	eval 'sub INBYTE {
	    my($_b,$_p) = @_;
    	    eval q( &pal_portio_read(($_b),(1),($_p)));
	}' unless defined(&INBYTE);
	eval 'sub INHALF {
	    my($_b,$_p) = @_;
    	    eval q( &pal_portio_read(($_b),(2),($_p)));
	}' unless defined(&INHALF);
	eval 'sub INWORD {
	    my($_b,$_p) = @_;
    	    eval q( &pal_portio_read(($_b),(4),($_p)));
	}' unless defined(&INWORD);
	eval 'sub OUTBYTE {
	    my($_b,$_p,$_d) = @_;
    	    eval q( &pal_portio_write(($_b),(1),($_p),($_d)));
	}' unless defined(&OUTBYTE);
	eval 'sub OUTHALF {
	    my($_b,$_p,$_d) = @_;
    	    eval q( &pal_portio_write(($_b),(2),($_p),($_d)));
	}' unless defined(&OUTHALF);
	eval 'sub OUTWORD {
	    my($_b,$_p,$_d) = @_;
    	    eval q( &pal_portio_write(($_b),(4),($_p),($_d)));
	}' unless defined(&OUTWORD);
    }
    eval 'sub BUS_PUTL {
        my($p,$v) = @_;
	    eval q(* = ($v));
    }' unless defined(&BUS_PUTL);
    eval 'sub BUS_PUTS {
        my($p,$v) = @_;
	    eval q(* = ($v));
    }' unless defined(&BUS_PUTS);
    eval 'sub BUS_PUTC {
        my($p,$v) = @_;
	    eval q(*(\'uchar\'  &volatile *) = ($v));
    }' unless defined(&BUS_PUTC);
    eval 'sub BUS_GETL {
        my($p) = @_;
	    eval q((*(($p))));
    }' unless defined(&BUS_GETL);
    eval 'sub BUS_GETS {
        my($p) = @_;
	    eval q((*(($p))));
    }' unless defined(&BUS_GETS);
    eval 'sub BUS_GETC {
        my($p) = @_;
	    eval q((*((\'uchar\'  &volatile *)($p))));
    }' unless defined(&BUS_GETC);
    eval 'sub BUSIO_PUTL {
        my($p,$v) = @_;
	    eval q(* = ($v));
    }' unless defined(&BUSIO_PUTL);
    eval 'sub BUSIO_PUTS {
        my($p,$v) = @_;
	    eval q(* = ($v));
    }' unless defined(&BUSIO_PUTS);
    eval 'sub BUSIO_PUTC {
        my($p,$v) = @_;
	    eval q(*(\'uchar\'  &volatile *) = ($v));
    }' unless defined(&BUSIO_PUTC);
    eval 'sub BUSIO_GETL {
        my($p) = @_;
	    eval q((*(($p))));
    }' unless defined(&BUSIO_GETL);
    eval 'sub BUSIO_GETS {
        my($p) = @_;
	    eval q((*(($p))));
    }' unless defined(&BUSIO_GETS);
    eval 'sub BUSIO_GETC {
        my($p) = @_;
	    eval q((*((\'uchar\'  &volatile *)($p))));
    }' unless defined(&BUSIO_GETC);
    unless(defined(&__ia64)) {
	if(defined(&__64BIT_KERNEL)) {
	} else {
	    eval 'sub BUS_GETLR {
	        my($p) = @_;
    		eval q(( &BusGetLR($p)));
	    }' unless defined(&BUS_GETLR);
	    eval 'sub BUS_GETSR {
	        my($p) = @_;
    		eval q(( &BusGetSR($p)));
	    }' unless defined(&BUS_GETSR);
	    eval 'sub BUS_PUTLR {
	        my($p,$v) = @_;
    		eval q((( &void) &BusPutLR($p,$v)));
	    }' unless defined(&BUS_PUTLR);
	    eval 'sub BUS_PUTSR {
	        my($p,$v) = @_;
    		eval q((( &void) &BusPutSR($p,$v)));
	    }' unless defined(&BUS_PUTSR);
	    eval 'sub BUSIO_GETLR {
	        my($p) = @_;
    		eval q(( &BusGetLR($p)));
	    }' unless defined(&BUSIO_GETLR);
	    eval 'sub BUSIO_GETSR {
	        my($p) = @_;
    		eval q(( &BusGetSR($p)));
	    }' unless defined(&BUSIO_GETSR);
	    eval 'sub BUSIO_PUTLR {
	        my($p,$v) = @_;
    		eval q((( &void) &BusPutLR($p,$v)));
	    }' unless defined(&BUSIO_PUTLR);
	    eval 'sub BUSIO_PUTSR {
	        my($p,$v) = @_;
    		eval q((( &void) &BusPutSR($p,$v)));
	    }' unless defined(&BUSIO_PUTSR);
	}
    }
    eval 'sub BUS_GETSTR {
        my($d,$s,$l) = @_;
	    eval q((( &void) &BusCpy($d,$s,$l)));
    }' unless defined(&BUS_GETSTR);
    eval 'sub BUS_PUTSTR {
        my($d,$s,$l) = @_;
	    eval q((( &void) &BusCpy($d,$s,$l)));
    }' unless defined(&BUS_PUTSTR);
    eval 'sub BUSIO_GETSTR {
        my($d,$s,$l) = @_;
	    eval q((( &void) &BusCpy($d,$s,$l)));
    }' unless defined(&BUSIO_GETSTR);
    eval 'sub BUSIO_PUTSTR {
        my($d,$s,$l) = @_;
	    eval q((( &void) &BusCpy($d,$s,$l)));
    }' unless defined(&BUSIO_PUTSTR);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub BUS_PUTLX {
	    my($p,$v) = @_;
    	    eval q( &busputl($p,$v));
	}' unless defined(&BUS_PUTLX);
	eval 'sub BUS_PUTLRX {
	    my($p,$v) = @_;
    	    eval q( &busputlr($p,$v));
	}' unless defined(&BUS_PUTLRX);
	eval 'sub BUS_PUTSRX {
	    my($p,$v) = @_;
    	    eval q( &busputsr($p,$v));
	}' unless defined(&BUS_PUTSRX);
	eval 'sub BUS_PUTSX {
	    my($p,$v) = @_;
    	    eval q( &busputs($p,$v));
	}' unless defined(&BUS_PUTSX);
	eval 'sub BUS_PUTCX {
	    my($p,$v) = @_;
    	    eval q( &busputc($p,$v));
	}' unless defined(&BUS_PUTCX);
	eval 'sub BUS_GETLX {
	    my($p,$v) = @_;
    	    eval q( &busgetl($p,$v));
	}' unless defined(&BUS_GETLX);
	eval 'sub BUS_GETLRX {
	    my($p,$v) = @_;
    	    eval q( &busgetlr($p,$v));
	}' unless defined(&BUS_GETLRX);
	eval 'sub BUS_GETSRX {
	    my($p,$v) = @_;
    	    eval q( &busgetsr($p,$v));
	}' unless defined(&BUS_GETSRX);
	eval 'sub BUS_GETSX {
	    my($p,$v) = @_;
    	    eval q( &busgets($p,$v));
	}' unless defined(&BUS_GETSX);
	eval 'sub BUS_GETCX {
	    my($p,$v) = @_;
    	    eval q( &busgetc($p,$v));
	}' unless defined(&BUS_GETCX);
	eval 'sub BUS_GETSTRX {
	    my($io,$s,$l) = @_;
    	    eval q( &buscpy($io,$s,$l));
	}' unless defined(&BUS_GETSTRX);
	eval 'sub BUS_PUTSTRX {
	    my($io,$s,$l) = @_;
    	    eval q( &buscpy($s,$io,$l));
	}' unless defined(&BUS_PUTSTRX);
	unless(defined(&_NO_PROTO)) {
	}
    }
    eval 'sub BID_VAL {
        my($type, $region, $num) = @_;
	    eval q(( (($num) & 0x90000000) ? ( (($num) & 0xfff0003f ) | (($region) << 16) | (($type) << 6) ) : ( 0x90000000 | (($type) << 6) | (($region) << 16) | (($num & 0xc000 ) << 15) | (($num & 0x3c00) << 10) | (($num & 0x3c0) << 18) | ($num & 0x3f))));
    }' unless defined(&BID_VAL);
    eval 'sub BID_VERSION1 () {0x10000000;}' unless defined(&BID_VERSION1);
    eval 'sub BID_VERSION2 () {0x80000000 |  &BID_VERSION1;}' unless defined(&BID_VERSION2);
    eval 'sub BID_TYPE {
        my($bid) = @_;
	    eval q((((($bid)) >> 6) & 0x3ff));
    }' unless defined(&BID_TYPE);
    eval 'sub BID_NUM {
        my($bid) = @_;
	    eval q((((($bid) >> 15) & 0xc000) | ((($bid) >> 10) & 0x3c00 ) | ((($bid) >> 18) & 0x3c0) | (($bid) & 0x3f)));
    }' unless defined(&BID_NUM);
    eval 'sub BID_REGION {
        my($bid) = @_;
	    eval q((((($bid)) >> 16) & 0xf));
    }' unless defined(&BID_REGION);
    eval 'sub BID_BITMASK () {0x6fffffff;}' unless defined(&BID_BITMASK);
    eval 'sub BID_ALTREG {
        my($bid, $region) = @_;
	    eval q((($bid & 0xfff0ffff) | ($region << 16)));
    }' unless defined(&BID_ALTREG);
    if(defined( &_KERNEL) || defined( &_KERNSYS)) {
	eval 'sub IO_REALMEM () {0x1;}' unless defined(&IO_REALMEM);
    }
    eval 'sub IO_DIAG () {0x2;}' unless defined(&IO_DIAG);
    eval 'sub IO_PCI () {0x3;}' unless defined(&IO_PCI);
    eval 'sub IO_ISA () {0x4;}' unless defined(&IO_ISA);
    eval 'sub IO_VME () {0x5;}' unless defined(&IO_VME);
    eval 'sub IO_FT () {0x6;}' unless defined(&IO_FT);
    eval 'sub IO_MBUS () {0x7;}' unless defined(&IO_MBUS);
    if(defined(&_POWER_PC)) {
	eval 'sub IO_TCE () {0x8;}' unless defined(&IO_TCE);
    }
    eval 'sub IO_SYSTEM () {0xc;}' unless defined(&IO_SYSTEM);
    eval 'sub IO_OEM_0 () {0x8;}' unless defined(&IO_OEM_0);
    eval 'sub IO_OEM_1 () {0x9;}' unless defined(&IO_OEM_1);
    eval 'sub IO_OEM_2 () {0xa;}' unless defined(&IO_OEM_2);
    eval 'sub IO_OEM_3 () {0xb;}' unless defined(&IO_OEM_3);
    eval 'sub INVALID_BID () {0xffffffff;}' unless defined(&INVALID_BID);
    eval 'sub MAX_BID_TYPES () {0x10;}' unless defined(&MAX_BID_TYPES);
    eval 'sub MAX_BUS_NUM_PER_TYPE () {512;}' unless defined(&MAX_BUS_NUM_PER_TYPE);
    eval 'sub MAX_HASH_LIST () {4;}' unless defined(&MAX_HASH_LIST);
    eval 'sub NUM_HASH_BKTS () { &MAX_BUS_NUM_PER_TYPE/ &MAX_HASH_LIST;}' unless defined(&NUM_HASH_BKTS);
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub MAX_FIXED_PER_TYPE () {16;}' unless defined(&MAX_FIXED_PER_TYPE);
    } else {
	eval 'sub MAX_FIXED_PER_TYPE () {2;}' unless defined(&MAX_FIXED_PER_TYPE);
    }
    eval 'sub MAX_REGIONS () {16;}' unless defined(&MAX_REGIONS);
    eval 'sub PCI_IOMEM () {0;}' unless defined(&PCI_IOMEM);
    eval 'sub PCI_BUSMEM () {1;}' unless defined(&PCI_BUSMEM);
    if(defined(&_KERNSYS)) {
	eval 'sub PCI_CFGMEM () {2;}' unless defined(&PCI_CFGMEM);
	eval 'sub PCI_MEMALIAS () {3;}' unless defined(&PCI_MEMALIAS);
	eval 'sub MAX_ALIAS_ADDR () {0x1000000;}' unless defined(&MAX_ALIAS_ADDR);
    }
    eval 'sub ISA_IOMEM () {0;}' unless defined(&ISA_IOMEM);
    eval 'sub ISA_BUSMEM () {1;}' unless defined(&ISA_BUSMEM);
    if(defined( &_KERNSYS)  && !defined( &__64BIT_KERNEL)) {
    }
    if(defined( (defined(&__64BIT_KERNEL) ? &__64BIT_KERNEL : 0)) || !defined( &_KERNSYS)) {
    } else {
    }
    unless(defined(&__64BIT_KERNEL)) {
    }
    if(defined( &_KERNEL) || defined( &_KERNSYS)) {
	eval 'sub REALMEM_BID () { &BID_VAL( &IO_REALMEM, 0, 0);}' unless defined(&REALMEM_BID);
    }
    if(defined(&_KERNSYS)) {
	eval 'sub BID_TYPE_INDEX {
	    my($bid) = @_;
    	    eval q( &BID_TYPE($bid));
	}' unless defined(&BID_TYPE_INDEX);
	eval 'sub BID_NUM_INDEX {
	    my($bid) = @_;
    	    eval q( &BID_NUM($bid));
	}' unless defined(&BID_NUM_INDEX);
	eval 'sub MAX_BID_TYPE_INDEX () { &MAX_BID_TYPES;}' unless defined(&MAX_BID_TYPE_INDEX);
	eval 'sub MAX_BID_NUM_INDEX () { &MAX_FIXED_PER_TYPE;}' unless defined(&MAX_BID_NUM_INDEX);
	eval 'sub BID_2_BINFO {
	    my($_bp,$_bid) = @_;
    	    eval q({ \'long _type\'; \'long _number\';  &_type =  &BID_TYPE_INDEX($_bid);  &_number =  &BID_NUM_INDEX($_bid); ($_bp) =  &find_businfo($_bid); });
	}' unless defined(&BID_2_BINFO);
	eval 'sub REGION_W_ALIAS {
	    my($_region, $_bp, $_iop, $_bid) = @_;
    	    eval q({ $_region =  &BID_REGION;  &if ((-> &num_regions >  &PCI_MEMALIAS)  && ( &BID_TYPE ==  &IO_PCI)  && ($_region ==  &PCI_BUSMEM)  && (((-> &busaddr) + (-> &size)) <=  &MAX_ALIAS_ADDR) ) { $_region =  &PCI_MEMALIAS; } });
	}' unless defined(&REGION_W_ALIAS);
    }
    if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
    }
    eval 'sub SYSMEM_BID () { &BID_VAL( &IO_SYSTEM, 0, 0);}' unless defined(&SYSMEM_BID);
    if(defined(&_POWER_PC)) {
	eval 'sub TCEMEM_BID () { &BID_VAL( &IO_TCE, 0, 0);}' unless defined(&TCEMEM_BID);
    }
}
1;
