require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_IOCTL)) {
    eval 'sub _H_IOCTL () {1;}' unless defined(&_H_IOCTL);
    if(defined(&__cplusplus)) {
    }
    eval 'sub IOCTYPE () {0xff00;}' unless defined(&IOCTYPE);
    eval 'sub IOCINFO () {0xff01;}' unless defined(&IOCINFO);
    eval 'sub IOCCONFIG () {0xff02;}' unless defined(&IOCCONFIG);
    unless(defined(&_IOCTL_)) {
	eval 'sub _IOCTL_ () {1;}' unless defined(&_IOCTL_);
	require 'standards.ph';
	require 'sys/ttychars.ph';
	require 'sys/ttydev.ph';
	if(defined(&_ALL_SOURCE)) {
	    eval("sub TXISATTY () { ('X'<<8); }") unless defined(&TXISATTY);
	    eval("sub TXTTYNAME () { 1; }") unless defined(&TXTTYNAME);
	    eval("sub TXGETLD () { 2; }") unless defined(&TXGETLD);
	    eval("sub TXSETLD () { 3; }") unless defined(&TXSETLD);
	    eval("sub TXGETCD () { 4; }") unless defined(&TXGETCD);
	    eval("sub TXADDCD () { 5; }") unless defined(&TXADDCD);
	    eval("sub TXDELCD () { 6; }") unless defined(&TXDELCD);
	    eval("sub TXSBAUD () { 7; }") unless defined(&TXSBAUD);
	    eval("sub TXGBAUD () { 8; }") unless defined(&TXGBAUD);
	    eval("sub TXSETIHOG () { 9; }") unless defined(&TXSETIHOG);
	    eval("sub TXSETOHOG () { 10; }") unless defined(&TXSETOHOG);
	    eval("sub TXGPGRP () { 11; }") unless defined(&TXGPGRP);
	    eval("sub TXSPGRP () { 12; }") unless defined(&TXSPGRP);
	    eval("sub TXSETMASK () { 13; }") unless defined(&TXSETMASK);
	    eval 'sub TTNAMEMAX () {32;}' unless defined(&TTNAMEMAX);
	}
	eval 'sub TIOCGSIZE () { &TIOCGWINSZ;}' unless defined(&TIOCGSIZE);
	eval 'sub TIOCSSIZE () { &TIOCSWINSZ;}' unless defined(&TIOCSSIZE);
	unless(defined(&_IO)) {
	    eval 'sub IOCPARM_MASK () {0x7f;}' unless defined(&IOCPARM_MASK);
	    eval 'sub IOC_VOID () {0x20000000;}' unless defined(&IOC_VOID);
	    eval 'sub IOC_OUT () {0x40000000;}' unless defined(&IOC_OUT);
	    eval 'sub IOC_IN () {(0x40000000<<1);}' unless defined(&IOC_IN);
	    eval 'sub IOC_INOUT () {( &IOC_IN| &IOC_OUT);}' unless defined(&IOC_INOUT);
	    eval 'sub _IO {
	        my($x,$y) = @_;
    		eval q(( &IOC_VOID|($x<<8)|$y));
	    }' unless defined(&_IO);
	    eval 'sub _IOR {
	        my($x,$y,$t) = @_;
    		eval q(( &IOC_OUT|(($sizeof{$t} &IOCPARM_MASK)<<16)|($x<<8)|$y));
	    }' unless defined(&_IOR);
	    eval 'sub _IOW {
	        my($x,$y,$t) = @_;
    		eval q(( &IOC_IN|(($sizeof{$t} &IOCPARM_MASK)<<16)|($x<<8)|$y));
	    }' unless defined(&_IOW);
	    eval 'sub _IOWR {
	        my($x,$y,$t) = @_;
    		eval q(( &IOC_INOUT|(($sizeof{$t} &IOCPARM_MASK)<<16)|($x<<8)|$y));
	    }' unless defined(&_IOWR);
	}
	eval 'sub TIOCGETD () { &_IOR(ord(\'t\'), 0, \'int\');}' unless defined(&TIOCGETD);
	eval 'sub TIOCSETD () { &_IOW(ord(\'t\'), 1, \'int\');}' unless defined(&TIOCSETD);
	eval 'sub TIOCHPCL () { &_IO(ord(\'t\'), 2);}' unless defined(&TIOCHPCL);
	eval 'sub TIOCMODG () { &_IOR(ord(\'t\'), 3, \'int\');}' unless defined(&TIOCMODG);
	eval 'sub TIOCMODS () { &_IOW(ord(\'t\'), 4, \'int\');}' unless defined(&TIOCMODS);
	eval 'sub TIOCM_LE () {0001;}' unless defined(&TIOCM_LE);
	eval 'sub TIOCM_DTR () {0002;}' unless defined(&TIOCM_DTR);
	eval 'sub TIOCM_RTS () {0004;}' unless defined(&TIOCM_RTS);
	eval 'sub TIOCM_ST () {0010;}' unless defined(&TIOCM_ST);
	eval 'sub TIOCM_SR () {0020;}' unless defined(&TIOCM_SR);
	eval 'sub TIOCM_CTS () {0040;}' unless defined(&TIOCM_CTS);
	eval 'sub TIOCM_CAR () {0100;}' unless defined(&TIOCM_CAR);
	eval 'sub TIOCM_CD () { &TIOCM_CAR;}' unless defined(&TIOCM_CD);
	eval 'sub TIOCM_RNG () {0200;}' unless defined(&TIOCM_RNG);
	eval 'sub TIOCM_RI () { &TIOCM_RNG;}' unless defined(&TIOCM_RI);
	eval 'sub TIOCM_DSR () {0400;}' unless defined(&TIOCM_DSR);
	eval 'sub TIOCGETP () { &_IOR(ord(\'t\'), 8,\'struct sgttyb\');}' unless defined(&TIOCGETP);
	eval 'sub TIOCSETP () { &_IOW(ord(\'t\'), 9,\'struct sgttyb\');}' unless defined(&TIOCSETP);
	eval 'sub TIOCSETN () { &_IOW(ord(\'t\'),10,\'struct sgttyb\');}' unless defined(&TIOCSETN);
	eval 'sub TIOCEXCL () { &_IO(ord(\'t\'), 13);}' unless defined(&TIOCEXCL);
	eval 'sub TIOCNXCL () { &_IO(ord(\'t\'), 14);}' unless defined(&TIOCNXCL);
	eval 'sub TIOCFLUSH () { &_IOW(ord(\'t\'), 16, \'int\');}' unless defined(&TIOCFLUSH);
	eval 'sub TIOCSETC () { &_IOW(ord(\'t\'),17,\'struct tchars\');}' unless defined(&TIOCSETC);
	eval 'sub TIOCGETC () { &_IOR(ord(\'t\'),18,\'struct tchars\');}' unless defined(&TIOCGETC);
	eval 'sub TANDEM () {0x1;}' unless defined(&TANDEM);
	eval 'sub CBREAK () {0x2;}' unless defined(&CBREAK);
	eval 'sub LCASE () {0x4;}' unless defined(&LCASE);
	eval 'sub ECHO () {0x8;}' unless defined(&ECHO);
	eval 'sub CRMOD () {0x10;}' unless defined(&CRMOD);
	eval 'sub RAW () {0x20;}' unless defined(&RAW);
	eval 'sub ODDP () {0x40;}' unless defined(&ODDP);
	eval 'sub EVENP () {0x80;}' unless defined(&EVENP);
	eval 'sub ANYP () {0xc0;}' unless defined(&ANYP);
	eval 'sub CRDELAY () {0x300;}' unless defined(&CRDELAY);
	eval 'sub CR0 () {0x;}' unless defined(&CR0);
	eval 'sub CR1 () {0x100;}' unless defined(&CR1);
	eval 'sub CR2 () {0x200;}' unless defined(&CR2);
	eval 'sub CR3 () {0x300;}' unless defined(&CR3);
	eval 'sub TBDELAY () {0xc00;}' unless defined(&TBDELAY);
	eval 'sub TAB0 () {0x;}' unless defined(&TAB0);
	eval 'sub TAB1 () {0x400;}' unless defined(&TAB1);
	eval 'sub TAB2 () {0x800;}' unless defined(&TAB2);
	eval 'sub XTABS () {0xc00;}' unless defined(&XTABS);
	eval 'sub BSDELAY () {0x1000;}' unless defined(&BSDELAY);
	eval 'sub BS0 () {0x;}' unless defined(&BS0);
	eval 'sub BS1 () {0x1000;}' unless defined(&BS1);
	eval 'sub VTDELAY () {0x2000;}' unless defined(&VTDELAY);
	eval 'sub FF0 () {0x;}' unless defined(&FF0);
	eval 'sub FF1 () {0x2000;}' unless defined(&FF1);
	eval 'sub NLDELAY () {0xc000;}' unless defined(&NLDELAY);
	eval 'sub NL0 () {0x;}' unless defined(&NL0);
	eval 'sub NL1 () {0x4000;}' unless defined(&NL1);
	eval 'sub NL2 () {0x8000;}' unless defined(&NL2);
	eval 'sub NL3 () {0xc000;}' unless defined(&NL3);
	eval 'sub ALLDELAY () {( &NLDELAY| &TBDELAY| &CRDELAY| &VTDELAY| &BSDELAY);}' unless defined(&ALLDELAY);
	eval 'sub TOSTOP () {0x10000;}' unless defined(&TOSTOP);
	eval 'sub PRTERA () {0x20000;}' unless defined(&PRTERA);
	eval 'sub CRTERA () {0x40000;}' unless defined(&CRTERA);
	eval 'sub TILDE () {0x80000;}' unless defined(&TILDE);
	eval 'sub FLUSHO () {0x100000;}' unless defined(&FLUSHO);
	eval 'sub LITOUT () {0x200000;}' unless defined(&LITOUT);
	eval 'sub CRTBS () {0x400000;}' unless defined(&CRTBS);
	eval 'sub MDMBUF () {0x800000;}' unless defined(&MDMBUF);
	eval 'sub NOHANG () {0x1000000;}' unless defined(&NOHANG);
	eval 'sub L001000 () {0x2000000;}' unless defined(&L001000);
	eval 'sub CRTKIL () {0x4000000;}' unless defined(&CRTKIL);
	eval 'sub PASS8 () {0x8000000;}' unless defined(&PASS8);
	eval 'sub CTLECH () {0x10000000;}' unless defined(&CTLECH);
	eval 'sub PENDIN () {0x20000000;}' unless defined(&PENDIN);
	eval 'sub DECCTQ () {0x40000000;}' unless defined(&DECCTQ);
	eval 'sub NOFLUSH () {0x80000000;}' unless defined(&NOFLUSH);
	eval 'sub UNLKPT () { &_IO(ord(\'t\'),70);}' unless defined(&UNLKPT);
	eval 'sub ISPTM () { &_IO(ord(\'t\'),71);}' unless defined(&ISPTM);
	eval 'sub ISPTS () { &_IO(ord(\'t\'),73);}' unless defined(&ISPTS);
	eval 'sub GRTPT () { &_IO(ord(\'t\'),74);}' unless defined(&GRTPT);
	eval 'sub RLOGIND () { &_IO(ord(\'t\'),75);}' unless defined(&RLOGIND);
	eval 'sub TELNETDP () { &_IO(ord(\'t\'),76);}' unless defined(&TELNETDP);
	eval 'sub TIOCCONS () { &_IOW(ord(\'t\'), 98, \'int\');}' unless defined(&TIOCCONS);
	eval 'sub TIOCGSID () { &_IOR(ord(\'t\'), 72, \'int\');}' unless defined(&TIOCGSID);
	if(defined(&_BSD_INCLUDES)) {
	    eval 'sub NOFLSH () { &NOFLUSH;}' unless defined(&NOFLSH);
	}
	eval 'sub TIOCLBIS () { &_IOW(ord(\'t\'), 127, \'int\');}' unless defined(&TIOCLBIS);
	eval 'sub TIOCLBIC () { &_IOW(ord(\'t\'), 126, \'int\');}' unless defined(&TIOCLBIC);
	eval 'sub TIOCLSET () { &_IOW(ord(\'t\'), 125, \'int\');}' unless defined(&TIOCLSET);
	eval 'sub TIOCLGET () { &_IOR(ord(\'t\'), 124, \'int\');}' unless defined(&TIOCLGET);
	eval 'sub LCRTBS () {( &CRTBS>>16);}' unless defined(&LCRTBS);
	eval 'sub LPRTERA () {( &PRTERA>>16);}' unless defined(&LPRTERA);
	eval 'sub LCRTERA () {( &CRTERA>>16);}' unless defined(&LCRTERA);
	eval 'sub LTILDE () {( &TILDE>>16);}' unless defined(&LTILDE);
	eval 'sub LMDMBUF () {( &MDMBUF>>16);}' unless defined(&LMDMBUF);
	eval 'sub LLITOUT () {( &LITOUT>>16);}' unless defined(&LLITOUT);
	eval 'sub LTOSTOP () {( &TOSTOP>>16);}' unless defined(&LTOSTOP);
	eval 'sub LFLUSHO () {( &FLUSHO>>16);}' unless defined(&LFLUSHO);
	eval 'sub LNOHANG () {( &NOHANG>>16);}' unless defined(&LNOHANG);
	eval 'sub LCRTKIL () {( &CRTKIL>>16);}' unless defined(&LCRTKIL);
	eval 'sub LPASS8 () {( &PASS8>>16);}' unless defined(&LPASS8);
	eval 'sub LCTLECH () {( &CTLECH>>16);}' unless defined(&LCTLECH);
	eval 'sub LPENDIN () {( &PENDIN>>16);}' unless defined(&LPENDIN);
	eval 'sub LDECCTQ () {( &DECCTQ>>16);}' unless defined(&LDECCTQ);
	eval 'sub LNOFLSH () {( &NOFLUSH>>16);}' unless defined(&LNOFLSH);
	eval 'sub TIOCSBRK () { &_IO(ord(\'t\'), 123);}' unless defined(&TIOCSBRK);
	eval 'sub TIOCCBRK () { &_IO(ord(\'t\'), 122);}' unless defined(&TIOCCBRK);
	eval 'sub TIOCSDTR () { &_IO(ord(\'t\'), 121);}' unless defined(&TIOCSDTR);
	eval 'sub TIOCCDTR () { &_IO(ord(\'t\'), 120);}' unless defined(&TIOCCDTR);
	eval 'sub TIOCGPGRP () { &_IOR(ord(\'t\'), 119, \'int\');}' unless defined(&TIOCGPGRP);
	eval 'sub TIOCSPGRP () { &_IOW(ord(\'t\'), 118, \'int\');}' unless defined(&TIOCSPGRP);
	eval 'sub TIOCSLTC () { &_IOW(ord(\'t\'),117,\'struct ltchars\');}' unless defined(&TIOCSLTC);
	eval 'sub TIOCGLTC () { &_IOR(ord(\'t\'),116,\'struct ltchars\');}' unless defined(&TIOCGLTC);
	eval 'sub TIOCOUTQ () { &_IOR(ord(\'t\'), 115, \'int\');}' unless defined(&TIOCOUTQ);
	eval 'sub TIOCSTI () { &_IOW(ord(\'t\'), 114, \'char\');}' unless defined(&TIOCSTI);
	eval 'sub TIOCNOTTY () { &_IO(ord(\'t\'), 113);}' unless defined(&TIOCNOTTY);
	eval 'sub TIOCPKT () { &_IOW(ord(\'t\'), 112, \'int\');}' unless defined(&TIOCPKT);
	eval 'sub TIOCPKT_DATA () {0x;}' unless defined(&TIOCPKT_DATA);
	eval 'sub TIOCPKT_FLUSHREAD () {0x1;}' unless defined(&TIOCPKT_FLUSHREAD);
	eval 'sub TIOCPKT_FLUSHWRITE () {0x2;}' unless defined(&TIOCPKT_FLUSHWRITE);
	eval 'sub TIOCPKT_STOP () {0x4;}' unless defined(&TIOCPKT_STOP);
	eval 'sub TIOCPKT_START () {0x8;}' unless defined(&TIOCPKT_START);
	eval 'sub TIOCPKT_NOSTOP () {0x10;}' unless defined(&TIOCPKT_NOSTOP);
	eval 'sub TIOCPKT_DOSTOP () {0x20;}' unless defined(&TIOCPKT_DOSTOP);
	eval 'sub TIOCSTOP () { &_IO(ord(\'t\'), 111);}' unless defined(&TIOCSTOP);
	eval 'sub TIOCSTART () { &_IO(ord(\'t\'), 110);}' unless defined(&TIOCSTART);
	eval 'sub TIOCMSET () { &_IOW(ord(\'t\'), 109, \'int\');}' unless defined(&TIOCMSET);
	eval 'sub TIOCMBIS () { &_IOW(ord(\'t\'), 108, \'int\');}' unless defined(&TIOCMBIS);
	eval 'sub TIOCMBIC () { &_IOW(ord(\'t\'), 107, \'int\');}' unless defined(&TIOCMBIC);
	eval 'sub TIOCMGET () { &_IOR(ord(\'t\'), 106, \'int\');}' unless defined(&TIOCMGET);
	eval 'sub TIOCREMOTE () { &_IOW(ord(\'t\'), 105, \'int\');}' unless defined(&TIOCREMOTE);
	eval 'sub TIOCGWINSZ () { &_IOR(ord(\'t\'), 104, \'struct winsize\');}' unless defined(&TIOCGWINSZ);
	eval 'sub TIOCSWINSZ () { &_IOW(ord(\'t\'), 103, \'struct winsize\');}' unless defined(&TIOCSWINSZ);
	eval 'sub TIOCUCNTL () { &_IOW(ord(\'t\'), 102, \'int\');}' unless defined(&TIOCUCNTL);
	eval 'sub SLIOCGUNIT () { &_IOR(ord(\'t\'), 101, \'int\');}' unless defined(&SLIOCGUNIT);
	eval 'sub SLIOCSFLAGS () { &_IOW(ord(\'t\'), 89, \'int\');}' unless defined(&SLIOCSFLAGS);
	eval 'sub SLIOCGFLAGS () { &_IOR(ord(\'t\'), 90, \'int\');}' unless defined(&SLIOCGFLAGS);
	eval 'sub SLIOCSATTACH () { &_IOWR(ord(\'t\'), 91, \'int\');}' unless defined(&SLIOCSATTACH);
	eval 'sub UIOCCMD {
	    my($n) = @_;
    	    eval q( &_IO(ord(\'u\'), $n));
	}' unless defined(&UIOCCMD);
	eval 'sub OTTYDISC () {0;}' unless defined(&OTTYDISC);
	eval 'sub NETLDISC () {1;}' unless defined(&NETLDISC);
	eval 'sub NTTYDISC () {2;}' unless defined(&NTTYDISC);
	eval 'sub TABLDISC () {3;}' unless defined(&TABLDISC);
	eval 'sub SLIPDISC () {4;}' unless defined(&SLIPDISC);
	eval 'sub FIOCLEX () { &_IO(ord(\'f\'), 1);}' unless defined(&FIOCLEX);
	eval 'sub FIONCLEX () { &_IO(ord(\'f\'), 2);}' unless defined(&FIONCLEX);
	eval 'sub FIONREAD () { &_IOR(ord(\'f\'), 127, \'int\');}' unless defined(&FIONREAD);
	eval 'sub FIONBIO () { &_IOW(ord(\'f\'), 126, \'int\');}' unless defined(&FIONBIO);
	eval 'sub FIOASYNC () { &_IOW(ord(\'f\'), 125, \'int\');}' unless defined(&FIOASYNC);
	eval 'sub FIOSETOWN () { &_IOW(ord(\'f\'), 124, \'int\');}' unless defined(&FIOSETOWN);
	eval 'sub FIOGETOWN () { &_IOR(ord(\'f\'), 123, \'int\');}' unless defined(&FIOGETOWN);
	eval 'sub FIOASYNCQX () { &_IOW(ord(\'f\'), 122, \'int\');}' unless defined(&FIOASYNCQX);
	eval 'sub SIOCSHIWAT () { &_IOW(ord(\'s\'), 0, \'int\');}' unless defined(&SIOCSHIWAT);
	eval 'sub SIOCGHIWAT () { &_IOR(ord(\'s\'), 1, \'int\');}' unless defined(&SIOCGHIWAT);
	eval 'sub SIOCSLOWAT () { &_IOW(ord(\'s\'), 2, \'int\');}' unless defined(&SIOCSLOWAT);
	eval 'sub SIOCGLOWAT () { &_IOR(ord(\'s\'), 3, \'int\');}' unless defined(&SIOCGLOWAT);
	eval 'sub SIOCATMARK () { &_IOR(ord(\'s\'), 7, \'int\');}' unless defined(&SIOCATMARK);
	eval 'sub SIOCSPGRP () { &_IOW(ord(\'s\'), 8, \'int\');}' unless defined(&SIOCSPGRP);
	eval 'sub SIOCGPGRP () { &_IOR(ord(\'s\'), 9, \'int\');}' unless defined(&SIOCGPGRP);
	eval 'sub SIOCADDRT () { &_IOW(ord(\'r\'), 10, \'struct ortentry\');}' unless defined(&SIOCADDRT);
	eval 'sub SIOCDELRT () { &_IOW(ord(\'r\'), 11, \'struct ortentry\');}' unless defined(&SIOCDELRT);
	eval 'sub SIOCSIFADDR () { &_IOW(ord(\'i\'), 12, \'struct oifreq\');}' unless defined(&SIOCSIFADDR);
	eval 'sub OSIOCGIFADDR () { &_IOWR(ord(\'i\'),13, \'struct oifreq\');}' unless defined(&OSIOCGIFADDR);
	eval 'sub SIOCGIFADDR () { &_IOWR(ord(\'i\'),33, \'struct oifreq\');}' unless defined(&SIOCGIFADDR);
	eval 'sub SIOCSIFDSTADDR () { &_IOW(ord(\'i\'), 14, \'struct oifreq\');}' unless defined(&SIOCSIFDSTADDR);
	eval 'sub OSIOCGIFDSTADDR () { &_IOWR(ord(\'i\'),15, \'struct oifreq\');}' unless defined(&OSIOCGIFDSTADDR);
	eval 'sub SIOCGIFDSTADDR () { &_IOWR(ord(\'i\'),34, \'struct oifreq\');}' unless defined(&SIOCGIFDSTADDR);
	eval 'sub SIOCSIFFLAGS () { &_IOW(ord(\'i\'), 16, \'struct oifreq\');}' unless defined(&SIOCSIFFLAGS);
	eval 'sub SIOCGIFFLAGS () { &_IOWR(ord(\'i\'),17, \'struct oifreq\');}' unless defined(&SIOCGIFFLAGS);
	eval 'sub OSIOCGIFBRDADDR () { &_IOWR(ord(\'i\'),18, \'struct oifreq\');}' unless defined(&OSIOCGIFBRDADDR);
	eval 'sub SIOCGIFBRDADDR () { &_IOWR(ord(\'i\'),35, \'struct oifreq\');}' unless defined(&SIOCGIFBRDADDR);
	eval 'sub SIOCSIFBRDADDR () { &_IOW(ord(\'i\'),19, \'struct oifreq\');}' unless defined(&SIOCSIFBRDADDR);
	eval 'sub OSIOCGIFCONF () { &_IOWR(ord(\'i\'),20, \'struct ifconf\');}' unless defined(&OSIOCGIFCONF);
	eval 'sub CSIOCGIFCONF () { &_IOWR(ord(\'i\'),36, \'struct ifconf\');}' unless defined(&CSIOCGIFCONF);
	eval 'sub SIOCGIFCONF () { &_IOWR(ord(\'i\'),69, \'struct ifconf\');}' unless defined(&SIOCGIFCONF);
	eval 'sub OSIOCGIFNETMASK () { &_IOWR(ord(\'i\'),21, \'struct oifreq\');}' unless defined(&OSIOCGIFNETMASK);
	eval 'sub SIOCGIFNETMASK () { &_IOWR(ord(\'i\'),37, \'struct oifreq\');}' unless defined(&SIOCGIFNETMASK);
	eval 'sub SIOCSIFNETMASK () { &_IOW(ord(\'i\'),22, \'struct oifreq\');}' unless defined(&SIOCSIFNETMASK);
	eval 'sub SIOCGIFMETRIC () { &_IOWR(ord(\'i\'),23, \'struct oifreq\');}' unless defined(&SIOCGIFMETRIC);
	eval 'sub SIOCSIFMETRIC () { &_IOW(ord(\'i\'),24, \'struct oifreq\');}' unless defined(&SIOCSIFMETRIC);
	eval 'sub SIOCDIFADDR () { &_IOW(ord(\'i\'),25, \'struct oifreq\');}' unless defined(&SIOCDIFADDR);
	eval 'sub SIOCAIFADDR () { &_IOW(ord(\'i\'),26, \'struct ifaliasreq\');}' unless defined(&SIOCAIFADDR);
	eval 'sub SIOCSIFSUBCHAN () { &_IOW(ord(\'i\'),27, \'struct oifreq\');}' unless defined(&SIOCSIFSUBCHAN);
	eval 'sub SIOCSIFNETDUMP () { &_IOW(ord(\'i\'),28, \'struct oifreq\');}' unless defined(&SIOCSIFNETDUMP);
	eval 'sub SIOUPDROUTE () { &_IOW(ord(\'i\'),29, \'struct ifaliasreq\');}' unless defined(&SIOUPDROUTE);
	eval 'sub SIOCSARP () { &_IOW(ord(\'i\'), 30, \'struct arpreq\');}' unless defined(&SIOCSARP);
	eval 'sub OSIOCGARP () { &_IOWR(ord(\'i\'),31, \'struct arpreq\');}' unless defined(&OSIOCGARP);
	eval 'sub SIOCGARP () { &_IOWR(ord(\'i\'),38, \'struct arpreq\');}' unless defined(&SIOCGARP);
	eval 'sub SIOCDARP () { &_IOW(ord(\'i\'), 32, \'struct arpreq\');}' unless defined(&SIOCDARP);
	eval 'sub SIOCSIFOPTIONS () { &_IOW(ord(\'i\'), 41, \'struct oifreq\');}' unless defined(&SIOCSIFOPTIONS);
	eval 'sub SIOCGIFOPTIONS () { &_IOWR(ord(\'i\'),42, \'struct oifreq\');}' unless defined(&SIOCGIFOPTIONS);
	eval 'sub SIOCADDMULTI () { &_IOW(ord(\'i\'), 49, \'struct ifreq\');}' unless defined(&SIOCADDMULTI);
	eval 'sub SIOCDELMULTI () { &_IOW(ord(\'i\'), 50, \'struct ifreq\');}' unless defined(&SIOCDELMULTI);
	eval 'sub SIOCGETVIFCNT () { &_IOWR(ord(\'u\'), 51, \'struct sioc_vif_req\');}' unless defined(&SIOCGETVIFCNT);
	eval 'sub SIOCGETSGCNT () { &_IOWR(ord(\'u\'), 52, \'struct sioc_sg_req\');}' unless defined(&SIOCGETSGCNT);
	eval 'sub SIOCADDNETID () { &_IOW(ord(\'i\'),87, \'struct oifreq\');}' unless defined(&SIOCADDNETID);
	eval 'sub SIOCSIFMTU () { &_IOW(ord(\'i\'),88, \'struct oifreq\');}' unless defined(&SIOCSIFMTU);
	eval 'sub SIOCGIFMTU () { &_IOWR(ord(\'i\'),86, \'struct oifreq\');}' unless defined(&SIOCGIFMTU);
	eval 'sub SIOCSNETOPT () { &_IOW(ord(\'i\'), 90, \'struct optreq\');}' unless defined(&SIOCSNETOPT);
	eval 'sub SIOCGNETOPT () { &_IOWR(ord(\'i\'), 91, \'struct optreq\');}' unless defined(&SIOCGNETOPT);
	eval 'sub SIOCDNETOPT () { &_IOWR(ord(\'i\'), 92, \'struct optreq\');}' unless defined(&SIOCDNETOPT);
	eval 'sub SIOCSX25XLATE () { &_IOW(ord(\'i\'), 99, \'struct oifreq\');}' unless defined(&SIOCSX25XLATE);
	eval 'sub SIOCGX25XLATE () { &_IOWR(ord(\'i\'),100, \'struct oifreq\');}' unless defined(&SIOCGX25XLATE);
	eval 'sub SIOCDX25XLATE () { &_IOW(ord(\'i\'), 101, \'struct oifreq\');}' unless defined(&SIOCDX25XLATE);
	eval 'sub SIOCIFDETACH () { &_IOW(ord(\'i\'), 102, \'struct ifreq\');}' unless defined(&SIOCIFDETACH);
	eval 'sub SIOCIFATTACH () { &_IOW(ord(\'i\'), 103, \'struct ifreq\');}' unless defined(&SIOCIFATTACH);
	eval 'sub SIOCGNMTUS () { &_IO(ord(\'i\'),110);}' unless defined(&SIOCGNMTUS);
	eval 'sub SIOCGETMTUS () { &_IO(ord(\'i\'),111);}' unless defined(&SIOCGETMTUS);
	eval 'sub SIOCADDMTU () { &_IOW(ord(\'i\'),112, \'int\');}' unless defined(&SIOCADDMTU);
	eval 'sub SIOCDELMTU () { &_IOW(ord(\'i\'),113, \'int\');}' unless defined(&SIOCDELMTU);
	eval 'sub SIOCGIFGIDLIST () { &_IO(ord(\'i\'), 104);}' unless defined(&SIOCGIFGIDLIST);
	eval 'sub SIOCSIFGIDLIST () { &_IO(ord(\'i\'), 105);}' unless defined(&SIOCSIFGIDLIST);
	eval 'sub SIOCGSIZIFCONF () { &_IOR(ord(\'i\'), 106, \'int\');}' unless defined(&SIOCGSIZIFCONF);
	eval 'sub SIOCIF_ATM_UBR () { &_IOW(ord(\'i\'),120,\'struct ifreq\');}' unless defined(&SIOCIF_ATM_UBR);
	eval 'sub SIOCIF_ATM_SNMPARP () { &_IOW(ord(\'i\'),121,\'struct ifreq\');}' unless defined(&SIOCIF_ATM_SNMPARP);
	eval 'sub SIOCIF_ATM_IDLE () { &_IOW(ord(\'i\'),122,\'struct ifreq\');}' unless defined(&SIOCIF_ATM_IDLE);
	eval 'sub SIOCIF_ATM_DUMPARP () { &_IOW(ord(\'i\'),123,\'struct ifreq\');}' unless defined(&SIOCIF_ATM_DUMPARP);
	eval 'sub SIOCIF_ATM_SVC () { &_IOW(ord(\'i\'),124,\'struct ifreq\');}' unless defined(&SIOCIF_ATM_SVC);
	eval 'sub SIOCIF_ATM_DARP () { &_IOW(ord(\'i\'),125,\'struct ifreq\');}' unless defined(&SIOCIF_ATM_DARP);
	eval 'sub SIOCIF_ATM_GARP () { &_IOW(ord(\'i\'),126,\'struct ifreq\');}' unless defined(&SIOCIF_ATM_GARP);
	eval 'sub SIOCIF_ATM_SARP () { &_IOW(ord(\'i\'),127,\'struct ifreq\');}' unless defined(&SIOCIF_ATM_SARP);
	eval 'sub SIOCGISNO () { &_IOWR(ord(\'i\'),107, \'struct oifreq\');}' unless defined(&SIOCGISNO);
	eval 'sub SIOCSISNO () { &_IOW(ord(\'i\'), 108, \'struct oifreq\');}' unless defined(&SIOCSISNO);
	eval 'sub SIOCGIFBAUDRATE () { &_IOWR(ord(\'i\'), 109, \'struct oifreq\');}' unless defined(&SIOCGIFBAUDRATE);
	if(defined(&CLVM_2_3)) {
	    eval 'sub DIOCONCURRENT () { &_IO(ord(\'d\'), 8);}' unless defined(&DIOCONCURRENT);
	    eval 'sub DIOREADALL () { &_IO(ord(\'d\'), 9);}' unless defined(&DIOREADALL);
	    eval 'sub DIODEBUG () { &_IO(ord(\'d\'),10);}' unless defined(&DIODEBUG);
	    eval 'sub DIODEBUGGET () { &_IO(ord(\'d\'),11);}' unless defined(&DIODEBUGGET);
	    eval 'sub DIODEBUGPOKE () { &_IO(ord(\'d\'),12);}' unless defined(&DIODEBUGPOKE);
	    if(defined(&CLVM_SYNC)) {
		eval 'sub DIOCONCSYNC () { &_IOW(ord(\'d\'), 13, \'int\');}' unless defined(&DIOCONCSYNC);
	    }
	    if(defined(&CLVM_CONFIG)) {
		eval 'sub DIOCONCCONFIG () { &_IOW(ord(\'d\'), 14, \'int\');}' unless defined(&DIOCONCCONFIG);
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&_IA64)) {
	eval 'sub GIOMAP_IOCTL {
	    my($x) = @_;
    	    eval q(((ord(\'G\')<<24) | ($x)));
	}' unless defined(&GIOMAP_IOCTL);
	eval 'sub UDI_GIO_DATA_XFER () { &GIOMAP_IOCTL(1);}' unless defined(&UDI_GIO_DATA_XFER);
    }
}
1;
