require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_LVDD)) {
    eval 'sub _H_LVDD () {1;}' unless defined(&_H_LVDD);
    require 'sys/types.ph';
    eval 'sub LVDD_RSVD () {0xf0000000;}' unless defined(&LVDD_RSVD);
    eval 'sub WRITEV () {0x1;}' unless defined(&WRITEV);
    eval 'sub HWRELOC () {0x2;}' unless defined(&HWRELOC);
    eval 'sub UNSAFEREL () {0x4;}' unless defined(&UNSAFEREL);
    eval 'sub RORELOC () {0x8;}' unless defined(&RORELOC);
    eval 'sub NO_MWC () {0x10;}' unless defined(&NO_MWC);
    eval 'sub MWC_RCV_OP () {0x20;}' unless defined(&MWC_RCV_OP);
    eval 'sub RESYNC_OP () {0x80;}' unless defined(&RESYNC_OP);
    eval 'sub AVOID_C1 () {0x100;}' unless defined(&AVOID_C1);
    eval 'sub AVOID_C2 () {0x200;}' unless defined(&AVOID_C2);
    eval 'sub AVOID_C3 () {0x400;}' unless defined(&AVOID_C3);
    if(defined(&CLVM_2_3)) {
	eval 'sub LVM_INTR_DISK () {0x2000;}' unless defined(&LVM_INTR_DISK);
	eval 'sub LVM_TOUCH_DISK () {0x10000;}' unless defined(&LVM_TOUCH_DISK);
	eval 'sub W_RESYNC_OP () {0x20000;}' unless defined(&W_RESYNC_OP);
    }
    eval 'sub AVOID_SHFT () {8;}' unless defined(&AVOID_SHFT);
    eval 'sub AVOID_MSK () {( &AVOID_C1 |  &AVOID_C2 |  &AVOID_C3);}' unless defined(&AVOID_MSK);
    eval 'sub NUMCOPIES () {3;}' unless defined(&NUMCOPIES);
    eval 'sub LV_READ_BACKUP () {0x100000;}' unless defined(&LV_READ_BACKUP);
    eval 'sub LV_WRITE_BACKUP () { &LV_READ_BACKUP;}' unless defined(&LV_WRITE_BACKUP);
    eval 'sub LV_READ_STALE () {0x200000;}' unless defined(&LV_READ_STALE);
    eval 'sub LV_READONLY_MIRROR () {0x400000;}' unless defined(&LV_READONLY_MIRROR);
    eval 'sub LV_READ_ONLY_C1 () {( &AVOID_MSK & ~ &AVOID_C1);}' unless defined(&LV_READ_ONLY_C1);
    eval 'sub LV_READ_ONLY_C2 () {( &AVOID_MSK & ~ &AVOID_C2);}' unless defined(&LV_READ_ONLY_C2);
    eval 'sub LV_READ_ONLY_C3 () {( &AVOID_MSK & ~ &AVOID_C3);}' unless defined(&LV_READ_ONLY_C3);
    eval 'sub LV_READ_STALE_C1 () {( &LV_READ_STALE |  &LV_READ_ONLY_C1);}' unless defined(&LV_READ_STALE_C1);
    eval 'sub LV_READ_STALE_C2 () {( &LV_READ_STALE |  &LV_READ_ONLY_C2);}' unless defined(&LV_READ_STALE_C2);
    eval 'sub LV_READ_STALE_C3 () {( &LV_READ_STALE |  &LV_READ_ONLY_C3);}' unless defined(&LV_READ_STALE_C3);
    if((!defined( &__64BIT__)  && !defined( &LVMBIGTYPES)) || defined( &__KERNEL_LVM)) {
    }
    eval 'sub MWCC_NON_ACTIVE () {0;}' unless defined(&MWCC_NON_ACTIVE);
    eval 'sub MWCC_ACTIVE_MODE () {1;}' unless defined(&MWCC_ACTIVE_MODE);
    eval 'sub MWCC_PASSIVE_MODE () {2;}' unless defined(&MWCC_PASSIVE_MODE);
    eval 'sub MWCC_PASSIVE_RECOVERY () {4;}' unless defined(&MWCC_PASSIVE_RECOVERY);
    if((defined( &__64BIT__) || defined( &LVMBIGTYPES))  && !defined( &__KERNEL_LVM)) {
    } else {
    }
    if((defined( &__64BIT__) || defined( &LVMBIGTYPES))  && !defined( &__KERNEL_LVM)) {
    } else {
    }
    eval 'sub SEQUENTIAL () {1;}' unless defined(&SEQUENTIAL);
    eval 'sub PARALLEL () {2;}' unless defined(&PARALLEL);
    eval 'sub STRIPED () {5;}' unless defined(&STRIPED);
    eval 'sub READ_ONLY () {0;}' unless defined(&READ_ONLY);
    eval 'sub READ_WRITE () {1;}' unless defined(&READ_WRITE);
    eval 'sub LVIOC () {(ord(\'v\')<<8);}' unless defined(&LVIOC);
    if((defined( &__64BIT__) || defined( &LVMBIGTYPES))  && !defined( &__KERNEL_LVM)) {
	eval 'sub XLATE () {( &LVIOC|14);}' unless defined(&XLATE);
    } else {
	eval 'sub XLATE () {( &LVIOC|1);}' unless defined(&XLATE);
    }
    eval 'sub GETVGSA () {( &LVIOC|2);}' unless defined(&GETVGSA);
    eval 'sub CACLNUP () {( &LVIOC|3);}' unless defined(&CACLNUP);
    eval 'sub LP_LVIEW () {( &LVIOC|4);}' unless defined(&LP_LVIEW);
    eval 'sub PBUFCNT () {( &LVIOC|5);}' unless defined(&PBUFCNT);
    if((defined( &GSCLVMD) || defined( &CLVM_CONFIG))) {
	eval 'sub CONC_STATE () {( &LVIOC|6);}' unless defined(&CONC_STATE);
    }
    if((defined( &__64BIT__) || defined( &LVMBIGTYPES))  && !defined( &__KERNEL_LVM)) {
	eval 'sub LV_INFO () {( &LVIOC|15);}' unless defined(&LV_INFO);
    } else {
	eval 'sub LV_INFO () {( &LVIOC|7);}' unless defined(&LV_INFO);
    }
    eval 'sub LV_QRYBKPCOPY () {( &LVIOC|8);}' unless defined(&LV_QRYBKPCOPY);
    eval 'sub LV_SETBKPCOPY () {( &LVIOC|9);}' unless defined(&LV_SETBKPCOPY);
    eval 'sub LV_FSETBKPCOPY () {( &LVIOC|10);}' unless defined(&LV_FSETBKPCOPY);
    eval 'sub GETBIGVGSA () {( &LVIOC|11);}' unless defined(&GETBIGVGSA);
    eval 'sub SET_SYNC_ON_RD () {( &LVIOC|12);}' unless defined(&SET_SYNC_ON_RD);
    eval 'sub CLR_SYNC_ON_RD () {( &LVIOC|13);}' unless defined(&CLR_SYNC_ON_RD);
    eval 'sub XLATE64 () {( &LVIOC|14);}' unless defined(&XLATE64);
    eval 'sub LV_INFO64 () {( &LVIOC|15);}' unless defined(&LV_INFO64);
    if(defined(&CLVM_SYNC)) {
	eval 'sub CONC_SYNC_BEGIN () {2;}' unless defined(&CONC_SYNC_BEGIN);
	eval 'sub CONC_SYNC_END () {1;}' unless defined(&CONC_SYNC_END);
    }
}
1;
