require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_MMAN)) {
    eval 'sub _H_MMAN () {1;}' unless defined(&_H_MMAN);
    unless(defined(&_H_STANDARDS)) {
	require 'standards.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0)==1) {
	require 'sys/types.ph';
	if(defined(&_LARGE_FILES)) {
	    eval 'sub mmap () { &mmap64;}' unless defined(&mmap);
	}
	eval 'sub PROT_NONE () {0;}' unless defined(&PROT_NONE);
	eval 'sub PROT_READ () {0x1;}' unless defined(&PROT_READ);
	eval 'sub PROT_WRITE () {0x2;}' unless defined(&PROT_WRITE);
	eval 'sub PROT_EXEC () {0x4;}' unless defined(&PROT_EXEC);
	eval 'sub MAP_SHARED () {0x1;}' unless defined(&MAP_SHARED);
	eval 'sub MAP_PRIVATE () {0x2;}' unless defined(&MAP_PRIVATE);
	eval 'sub MAP_FIXED () {0x100;}' unless defined(&MAP_FIXED);
	eval 'sub MAP_VARIABLE () {0x;}' unless defined(&MAP_VARIABLE);
	eval 'sub MS_ASYNC () {0x10;}' unless defined(&MS_ASYNC);
	eval 'sub MS_SYNC () {0x20;}' unless defined(&MS_SYNC);
	eval 'sub MS_INVALIDATE () {0x40;}' unless defined(&MS_INVALIDATE);
	if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0)==500) {
	    eval 'sub MCL_CURRENT () {999;}' unless defined(&MCL_CURRENT);
	    eval 'sub MCL_FUTURE () {999;}' unless defined(&MCL_FUTURE);
	}
	if(defined( &_NO_PROTO) || defined( &_KERNEL)) {
	    if(defined(&_KERNEL)) {
	    } else {
	    }
	} else {
	    if(defined(&_LARGE_FILE_API)) {
	    }
	    if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0)==500) {
		eval 'sub MAP_FAILED () {(( &void *)-1);}' unless defined(&MAP_FAILED);
	    }
	}
    }
    if(defined(&_ALL_SOURCE)) {
	eval 'sub MAP_FILE () {0x;}' unless defined(&MAP_FILE);
	eval 'sub MAP_ANONYMOUS () {0x10;}' unless defined(&MAP_ANONYMOUS);
	eval 'sub MAP_ANON () {0x10;}' unless defined(&MAP_ANON);
	eval 'sub MAP_TYPE () {0xf0;}' unless defined(&MAP_TYPE);
	eval 'sub MADV_NORMAL () {0;}' unless defined(&MADV_NORMAL);
	eval 'sub MADV_RANDOM () {1;}' unless defined(&MADV_RANDOM);
	eval 'sub MADV_SEQUENTIAL () {2;}' unless defined(&MADV_SEQUENTIAL);
	eval 'sub MADV_WILLNEED () {3;}' unless defined(&MADV_WILLNEED);
	eval 'sub MADV_DONTNEED () {4;}' unless defined(&MADV_DONTNEED);
	eval 'sub MADV_SPACEAVAIL () {5;}' unless defined(&MADV_SPACEAVAIL);
	eval 'sub MSEM_UNLOCKED () {0;}' unless defined(&MSEM_UNLOCKED);
	eval 'sub MSEM_LOCKED () {1;}' unless defined(&MSEM_LOCKED);
	eval 'sub MSEM_IF_NOWAIT () {2;}' unless defined(&MSEM_IF_NOWAIT);
	eval 'sub MSEM_IF_WAITERS () {3;}' unless defined(&MSEM_IF_WAITERS);
	eval 'sub MSEM_REMOVED () {4;}' unless defined(&MSEM_REMOVED);
	if(!defined( &_NO_PROTO)  && !defined( &_KERNEL)) {
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
