require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_PM)) {
    eval 'sub _H_PM () {1;}' unless defined(&_H_PM);
    require 'sys/types.ph';
    require 'sys/lock_def.ph';
    require 'sys/lockname.ph';
    require 'sys/pmdev.ph';
    eval 'sub PM_SUCCESS () {0;}' unless defined(&PM_SUCCESS);
    eval 'sub PM_ERROR () {-1;}' unless defined(&PM_ERROR);
    eval 'sub PM_NONE () {0x;}' unless defined(&PM_NONE);
    eval 'sub PM_SYSTEM_FULL_ON () {0x100;}' unless defined(&PM_SYSTEM_FULL_ON);
    eval 'sub PM_SYSTEM_ENABLE () {0x200;}' unless defined(&PM_SYSTEM_ENABLE);
    eval 'sub PM_SYSTEM_STANDBY () {0x400;}' unless defined(&PM_SYSTEM_STANDBY);
    eval 'sub PM_SYSTEM_SUSPEND () {0x800;}' unless defined(&PM_SYSTEM_SUSPEND);
    eval 'sub PM_SYSTEM_HIBERNATION () {0x1000;}' unless defined(&PM_SYSTEM_HIBERNATION);
    eval 'sub PM_SYSTEM_SHUTDOWN () {0x2000;}' unless defined(&PM_SYSTEM_SHUTDOWN);
    eval 'sub PM_SYSTEM_TERMINATE () {0x4000;}' unless defined(&PM_SYSTEM_TERMINATE);
    eval 'sub PM_TERMINATE () { &PM_SYSTEM_TERMINATE;}' unless defined(&PM_TERMINATE);
    eval 'sub PM_TRANSITION_START () {0x10000;}' unless defined(&PM_TRANSITION_START);
    eval 'sub PM_TRANSITION_END () {0x20000;}' unless defined(&PM_TRANSITION_END);
    eval 'sub PM_EVENT_NONE () {0;}' unless defined(&PM_EVENT_NONE);
    eval 'sub PM_EVENT_LID_OPEN () {1;}' unless defined(&PM_EVENT_LID_OPEN);
    eval 'sub PM_EVENT_LID_CLOSE () {2;}' unless defined(&PM_EVENT_LID_CLOSE);
    eval 'sub PM_EVENT_MAIN_POWER () {3;}' unless defined(&PM_EVENT_MAIN_POWER);
    eval 'sub PM_EVENT_PD_CLICK () {4;}' unless defined(&PM_EVENT_PD_CLICK);
    eval 'sub PM_EVENT_KEYBOARD () {5;}' unless defined(&PM_EVENT_KEYBOARD);
    eval 'sub PM_EVENT_LOW_BATTERY () {6;}' unless defined(&PM_EVENT_LOW_BATTERY);
    eval 'sub PM_EVENT_CRITICAL_LOW_BATTERY () {7;}' unless defined(&PM_EVENT_CRITICAL_LOW_BATTERY);
    eval 'sub PM_EVENT_RING () {8;}' unless defined(&PM_EVENT_RING);
    eval 'sub PM_EVENT_RESUME_TIMER () {9;}' unless defined(&PM_EVENT_RESUME_TIMER);
    eval 'sub PM_EVENT_SYSTEM_IDLE_TIMER () {10;}' unless defined(&PM_EVENT_SYSTEM_IDLE_TIMER);
    eval 'sub PM_EVENT_SOFTWARE_REQUEST () {11;}' unless defined(&PM_EVENT_SOFTWARE_REQUEST);
    eval 'sub PM_EVENT_SUSPPEND_TIMER () {12;}' unless defined(&PM_EVENT_SUSPPEND_TIMER);
    eval 'sub PM_EVENT_DISPLAY_MESSAGE () {13;}' unless defined(&PM_EVENT_DISPLAY_MESSAGE);
    eval 'sub PM_EVENT_LOWBAT_W_PHASE1DD () {14;}' unless defined(&PM_EVENT_LOWBAT_W_PHASE1DD);
    eval 'sub PM_EVENT_AC () {15;}' unless defined(&PM_EVENT_AC);
    eval 'sub PM_EVENT_DC () {16;}' unless defined(&PM_EVENT_DC);
    eval 'sub PM_EVENT_RTC () {17;}' unless defined(&PM_EVENT_RTC);
    eval 'sub PM_EVENT_MOUSE () {18;}' unless defined(&PM_EVENT_MOUSE);
    eval 'sub PM_EVENT_EXTRA_INPUTDD () {19;}' unless defined(&PM_EVENT_EXTRA_INPUTDD);
    eval 'sub PM_EVENT_EXTRA_BUTTON () {20;}' unless defined(&PM_EVENT_EXTRA_BUTTON);
    eval 'sub PM_EVENT_ERROR () {21;}' unless defined(&PM_EVENT_ERROR);
    eval 'sub PM_EVENT_SPECIFIED_TIME () {22;}' unless defined(&PM_EVENT_SPECIFIED_TIME);
    eval 'sub PM_EVENT_GRAPHICAL_INPUT () {23;}' unless defined(&PM_EVENT_GRAPHICAL_INPUT);
    eval 'sub PM_EVENT_TERMINATE () {24;}' unless defined(&PM_EVENT_TERMINATE);
    eval 'sub PM_EVENT_POWER_SWITCH_ON () {25;}' unless defined(&PM_EVENT_POWER_SWITCH_ON);
    eval 'sub PM_EVENT_POWER_SWITCH_OFF () {26;}' unless defined(&PM_EVENT_POWER_SWITCH_OFF);
    eval 'sub PM_EVENT_BATTERY_STATUS_RDY () {27;}' unless defined(&PM_EVENT_BATTERY_STATUS_RDY);
    eval 'sub PM_EVENT_PHASE1_DD () {28;}' unless defined(&PM_EVENT_PHASE1_DD);
    eval 'sub PM_EVENT_REJECT_BY_DD () {29;}' unless defined(&PM_EVENT_REJECT_BY_DD);
    eval 'sub PM_EVENT_REJECT_BY_HIB_VOL () {30;}' unless defined(&PM_EVENT_REJECT_BY_HIB_VOL);
    eval 'sub PM_EVENT_NOT_SUPPORTED () {31;}' unless defined(&PM_EVENT_NOT_SUPPORTED);
    eval 'sub PM_EVENT_GENERAL_ERROR () {99;}' unless defined(&PM_EVENT_GENERAL_ERROR);
    eval 'sub PM_EVENT_P1SWRQ_STANDBY () {100;}' unless defined(&PM_EVENT_P1SWRQ_STANDBY);
    eval 'sub PM_EVENT_P1SWRQ_SHUTDOWN () {101;}' unless defined(&PM_EVENT_P1SWRQ_SHUTDOWN);
    eval 'sub PM_STOP_KOTHREADS () {1;}' unless defined(&PM_STOP_KOTHREADS);
    eval 'sub PM_STOP_KTHREADS () {2;}' unless defined(&PM_STOP_KTHREADS);
    eval 'sub PM_CTRL_SET_PARAMETERS () {19;}' unless defined(&PM_CTRL_SET_PARAMETERS);
    eval 'sub PM_CTRL_QUERY_DEVICE_NUMBER () {20;}' unless defined(&PM_CTRL_QUERY_DEVICE_NUMBER);
    eval 'sub PM_CTRL_QUERY_DEVICE_LIST () {21;}' unless defined(&PM_CTRL_QUERY_DEVICE_LIST);
    eval 'sub PM_CTRL_SET_DEVICE_INFO () {22;}' unless defined(&PM_CTRL_SET_DEVICE_INFO);
    eval 'sub PM_CTRL_SET_HIBERNATION_VOLUME () {23;}' unless defined(&PM_CTRL_SET_HIBERNATION_VOLUME);
    eval 'sub PM_CTRL_QUERY_DEVICE_INFO () {24;}' unless defined(&PM_CTRL_QUERY_DEVICE_INFO);
    eval 'sub PM_CTRL_GET_CHRP_PARAMETERS () {25;}' unless defined(&PM_CTRL_GET_CHRP_PARAMETERS);
    eval 'sub PM_OFF () {0;}' unless defined(&PM_OFF);
    eval 'sub PM_ON () {1;}' unless defined(&PM_ON);
    eval 'sub PM_DEVICE_NAME_LENGTH () {16;}' unless defined(&PM_DEVICE_NAME_LENGTH);
    eval 'sub PM_CTRL_QUERY_SYSTEM_STATE () {5;}' unless defined(&PM_CTRL_QUERY_SYSTEM_STATE);
    eval 'sub PM_CTRL_START_SYSTEM_STATE () {6;}' unless defined(&PM_CTRL_START_SYSTEM_STATE);
    eval 'sub PM_BATTERY_DISCHARGE () {1;}' unless defined(&PM_BATTERY_DISCHARGE);
    eval 'sub PM_BATTERY_QUERY () {2;}' unless defined(&PM_BATTERY_QUERY);
    eval 'sub PM_BATTERY () {0x100;}' unless defined(&PM_BATTERY);
    eval 'sub PM_BATTERY_EXIST () {0x200;}' unless defined(&PM_BATTERY_EXIST);
    eval 'sub PM_NICD () {0x400;}' unless defined(&PM_NICD);
    eval 'sub PM_CHARGE () {0x800;}' unless defined(&PM_CHARGE);
    eval 'sub PM_DISCHARGE () {0x1000;}' unless defined(&PM_DISCHARGE);
    eval 'sub PM_AC () {0x2000;}' unless defined(&PM_AC);
    eval 'sub PM_DC () {0x4000;}' unless defined(&PM_DC);
    eval 'sub PM_REFRESH_DISCHARGE_REQ () {0x8000;}' unless defined(&PM_REFRESH_DISCHARGE_REQ);
    eval 'sub PM_CONFIG () {0;}' unless defined(&PM_CONFIG);
    eval 'sub PM_UNCONFIG () {1;}' unless defined(&PM_UNCONFIG);
    eval 'sub PM_CTRL_QUERY_SYSTEM_IDLE_TIMER () {1;}' unless defined(&PM_CTRL_QUERY_SYSTEM_IDLE_TIMER);
    eval 'sub PM_CTRL_SET_SYSTEM_IDLE_TIMER () {2;}' unless defined(&PM_CTRL_SET_SYSTEM_IDLE_TIMER);
    eval 'sub PM_CTRL_QUERY_DEVICE_IDLE_TIMER () {3;}' unless defined(&PM_CTRL_QUERY_DEVICE_IDLE_TIMER);
    eval 'sub PM_CTRL_SET_DEVICE_IDLE_TIMER () {4;}' unless defined(&PM_CTRL_SET_DEVICE_IDLE_TIMER);
    eval 'sub PM_CTRL_QUERY_LID_CLOSE_ACTION () {5;}' unless defined(&PM_CTRL_QUERY_LID_CLOSE_ACTION);
    eval 'sub PM_CTRL_SET_LID_CLOSE_ACTION () {6;}' unless defined(&PM_CTRL_SET_LID_CLOSE_ACTION);
    eval 'sub PM_CTRL_QUERY_SYSTEM_IDLE_ACTION () {7;}' unless defined(&PM_CTRL_QUERY_SYSTEM_IDLE_ACTION);
    eval 'sub PM_CTRL_SET_SYSTEM_IDLE_ACTION () {8;}' unless defined(&PM_CTRL_SET_SYSTEM_IDLE_ACTION);
    eval 'sub PM_CTRL_QUERY_MAIN_SWITCH_ACTION () {9;}' unless defined(&PM_CTRL_QUERY_MAIN_SWITCH_ACTION);
    eval 'sub PM_CTRL_SET_MAIN_SWITCH_ACTION () {10;}' unless defined(&PM_CTRL_SET_MAIN_SWITCH_ACTION);
    eval 'sub PM_CTRL_QUERY_LOW_BATTERY_ACTION () {11;}' unless defined(&PM_CTRL_QUERY_LOW_BATTERY_ACTION);
    eval 'sub PM_CTRL_SET_LOW_BATTERY_ACTION () {12;}' unless defined(&PM_CTRL_SET_LOW_BATTERY_ACTION);
    eval 'sub PM_CTRL_QUERY_BEEP () {13;}' unless defined(&PM_CTRL_QUERY_BEEP);
    eval 'sub PM_CTRL_SET_BEEP () {14;}' unless defined(&PM_CTRL_SET_BEEP);
    eval 'sub PM_CTRL_QUERY_PM_DD_NUMBER () {15;}' unless defined(&PM_CTRL_QUERY_PM_DD_NUMBER);
    eval 'sub PM_CTRL_QUERY_PM_DD_LIST () {16;}' unless defined(&PM_CTRL_QUERY_PM_DD_LIST);
    eval 'sub PM_CTRL_QUERY_LID_STATE () {17;}' unless defined(&PM_CTRL_QUERY_LID_STATE);
    eval 'sub PM_DTSIZE () {$sizeof{\'struct pm_device_timer_struct\'};}' unless defined(&PM_DTSIZE);
    eval 'sub PM_BEEP_OFF () {0;}' unless defined(&PM_BEEP_OFF);
    eval 'sub PM_BEEP_ON () {1;}' unless defined(&PM_BEEP_ON);
    eval 'sub PM_LID_CLOSE () {0;}' unless defined(&PM_LID_CLOSE);
    eval 'sub PM_LID_OPEN () {1;}' unless defined(&PM_LID_OPEN);
    eval 'sub PM_CTRL_QUERY_STATE () {1;}' unless defined(&PM_CTRL_QUERY_STATE);
    eval 'sub PM_CTRL_REQUEST_STATE () {2;}' unless defined(&PM_CTRL_REQUEST_STATE);
    eval 'sub PM_CTRL_START_STATE () {3;}' unless defined(&PM_CTRL_START_STATE);
    eval 'sub PM_CTRL_QUERY_REQUEST () {4;}' unless defined(&PM_CTRL_QUERY_REQUEST);
    eval 'sub PM_MAX_REQUESTED_EVENT_NUMBER () {16;}' unless defined(&PM_MAX_REQUESTED_EVENT_NUMBER);
    eval 'sub PM_KERNEL_CMD_BLANK_LEDS () {(0x1);}' unless defined(&PM_KERNEL_CMD_BLANK_LEDS);
}
1;
