require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_PROCFS_PROCFS)) {
    eval 'sub _H_PROCFS_PROCFS () {1;}' unless defined(&_H_PROCFS_PROCFS);
    if(defined( &__cplusplus)) {
    }
    if(defined(&__64BIT__)) {
    } else {
    }
    require 'sys/types.ph';
    require 'sys/m_procfs.ph';
    eval 'sub FLTILL () {1;}' unless defined(&FLTILL);
    eval 'sub FLTPRIV () {2;}' unless defined(&FLTPRIV);
    eval 'sub FLTBPT () {3;}' unless defined(&FLTBPT);
    eval 'sub FLTTRACE () {4;}' unless defined(&FLTTRACE);
    eval 'sub FLTACCESS () {5;}' unless defined(&FLTACCESS);
    eval 'sub FLTBOUNDS () {6;}' unless defined(&FLTBOUNDS);
    eval 'sub FLTIOVF () {7;}' unless defined(&FLTIOVF);
    eval 'sub FLTIZDIV () {8;}' unless defined(&FLTIZDIV);
    eval 'sub FLTFPE () {9;}' unless defined(&FLTFPE);
    eval 'sub FLTSTACK () {10;}' unless defined(&FLTSTACK);
    eval 'sub FLTPAGE () {11;}' unless defined(&FLTPAGE);
    eval 'sub PRCLSZ () {8;}' unless defined(&PRCLSZ);
    eval 'sub PRSYSARGS () {8;}' unless defined(&PRSYSARGS);
    eval 'sub PR_STOPPED () {0x1;}' unless defined(&PR_STOPPED);
    eval 'sub PR_ISTOP () {0x2;}' unless defined(&PR_ISTOP);
    eval 'sub PR_DSTOP () {0x4;}' unless defined(&PR_DSTOP);
    eval 'sub PR_ASLEEP () {0x8;}' unless defined(&PR_ASLEEP);
    eval 'sub PR_NOREGS () {0x10;}' unless defined(&PR_NOREGS);
    eval 'sub PR_REQUESTED () {1;}' unless defined(&PR_REQUESTED);
    eval 'sub PR_SIGNALLED () {2;}' unless defined(&PR_SIGNALLED);
    eval 'sub PR_SYSENTRY () {3;}' unless defined(&PR_SYSENTRY);
    eval 'sub PR_SYSEXIT () {4;}' unless defined(&PR_SYSEXIT);
    eval 'sub PR_JOBCONTROL () {5;}' unless defined(&PR_JOBCONTROL);
    eval 'sub PR_FAULTED () {6;}' unless defined(&PR_FAULTED);
    eval 'sub PR_FORK () {0x1;}' unless defined(&PR_FORK);
    eval 'sub PR_KLC () {0x2;}' unless defined(&PR_KLC);
    eval 'sub PR_RLC () {0x4;}' unless defined(&PR_RLC);
    eval 'sub PR_ASYNC () {0x8;}' unless defined(&PR_ASYNC);
    eval 'sub PR_ISSYS () {0x10;}' unless defined(&PR_ISSYS);
    eval 'sub PR_PTRACE () {0x80000000;}' unless defined(&PR_PTRACE);
    eval 'sub PR_MODEL_ILP32 () {0;}' unless defined(&PR_MODEL_ILP32);
    eval 'sub PR_MODEL_LP64 () {1;}' unless defined(&PR_MODEL_LP64);
    eval 'sub PR_SNAME_TSIDL () {ord(\'I\');}' unless defined(&PR_SNAME_TSIDL);
    eval 'sub PR_SNAME_TSRUN () {ord(\'R\');}' unless defined(&PR_SNAME_TSRUN);
    eval 'sub PR_SNAME_TSSLEEP () {ord(\'S\');}' unless defined(&PR_SNAME_TSSLEEP);
    eval 'sub PR_SNAME_TSSWAP () {ord(\'O\');}' unless defined(&PR_SNAME_TSSWAP);
    eval 'sub PR_SNAME_TSSTOP () {ord(\'T\');}' unless defined(&PR_SNAME_TSSTOP);
    eval 'sub PR_SNAME_TSZOMB () {ord(\'Z\');}' unless defined(&PR_SNAME_TSZOMB);
    eval 'sub PRFNSZ () {16;}' unless defined(&PRFNSZ);
    eval 'sub PRARGSZ () {80;}' unless defined(&PRARGSZ);
    eval 'sub PCSTOP () {1;}' unless defined(&PCSTOP);
    eval 'sub PCDSTOP () {2;}' unless defined(&PCDSTOP);
    eval 'sub PCWSTOP () {3;}' unless defined(&PCWSTOP);
    eval 'sub PCRUN () {4;}' unless defined(&PCRUN);
    eval 'sub PCSTRACE () {5;}' unless defined(&PCSTRACE);
    eval 'sub PCSSIG () {6;}' unless defined(&PCSSIG);
    eval 'sub PCKILL () {7;}' unless defined(&PCKILL);
    eval 'sub PCUNKILL () {8;}' unless defined(&PCUNKILL);
    eval 'sub PCSHOLD () {9;}' unless defined(&PCSHOLD);
    eval 'sub PCSFAULT () {10;}' unless defined(&PCSFAULT);
    eval 'sub PCCFAULT () {11;}' unless defined(&PCCFAULT);
    eval 'sub PCSENTRY () {12;}' unless defined(&PCSENTRY);
    eval 'sub PCSEXIT () {13;}' unless defined(&PCSEXIT);
    eval 'sub PCSET () {14;}' unless defined(&PCSET);
    eval 'sub PCRESET () {15;}' unless defined(&PCRESET);
    eval 'sub PCUNSET () { &PCRESET;}' unless defined(&PCUNSET);
    eval 'sub PCSREG () {16;}' unless defined(&PCSREG);
    eval 'sub PCSFPREG () {17;}' unless defined(&PCSFPREG);
    eval 'sub PCNICE () {18;}' unless defined(&PCNICE);
    eval 'sub PR_FAMILY_START () {10000;}' unless defined(&PR_FAMILY_START);
    eval 'sub PRCSIG () {0x1;}' unless defined(&PRCSIG);
    eval 'sub PRCFAULT () {0x2;}' unless defined(&PRCFAULT);
    eval 'sub PRSTEP () {0x40;}' unless defined(&PRSTEP);
    eval 'sub PRSABORT () {0x80;}' unless defined(&PRSABORT);
    eval 'sub PRSTOP () {0x100;}' unless defined(&PRSTOP);
    eval 'sub PRBRANCH () {0x200;}' unless defined(&PRBRANCH);
    eval 'sub PRMAPSZ () {64;}' unless defined(&PRMAPSZ);
    eval 'sub MA_MAINEXEC () {0x80000000;}' unless defined(&MA_MAINEXEC);
    eval 'sub MA_KERNTEXT () {0x40000000;}' unless defined(&MA_KERNTEXT);
    eval 'sub MA_READ () {0x4;}' unless defined(&MA_READ);
    eval 'sub MA_WRITE () {0x2;}' unless defined(&MA_WRITE);
    eval 'sub MA_EXEC () {0x1;}' unless defined(&MA_EXEC);
    eval 'sub MA_SHARED () {0x8;}' unless defined(&MA_SHARED);
    eval 'sub MA_BREAK () {0x10;}' unless defined(&MA_BREAK);
    eval 'sub MA_STACK () {0x20;}' unless defined(&MA_STACK);
    eval 'sub prfillsysset {
        my($sp) = @_;
	    eval q({  &uint64_t  &_ii_ = (( &uint64_t*)($sp))[0];  &while( &_ii_) (( &uint64_t*)($sp))[-- &_ii_+1] = 1.84467440737096e+19; });
    }' unless defined(&prfillsysset);
    eval 'sub premptysysset {
        my($sp) = @_;
	    eval q({  &uint64_t  &_ii_ = (( &uint64_t*)($sp))[0];  &while( &_ii_) (( &uint64_t*)($sp))[-- &_ii_+1] = 0; });
    }' unless defined(&premptysysset);
    eval 'sub praddsysset {
        my($sp, $num) = @_;
	    eval q((((( &int64_t)($num) > 0)  && (( &uint64_t)(($num)-1) < 64*(( &uint64_t*)($sp))[0])) ? ((( &uint64_t*)($sp))[((($num)-1)/64+1)] |= (1<<((($num)-1)%64))) : 0));
    }' unless defined(&praddsysset);
    eval 'sub prdelsysset {
        my($sp, $num) = @_;
	    eval q((((( &int64_t)($num) > 0)  && (( &uint64_t)(($num)-1) < 64*(( &uint64_t*)($sp))[0])) ? ((( &uint64_t*)($sp))[((($num)-1)/64+1)] &= ~(1<<((($num)-1)%64))) : 0));
    }' unless defined(&prdelsysset);
    eval 'sub prissyssetmember {
        my($sp, $num) = @_;
	    eval q(((( &int64_t)($num) > 0)  && (( &uint64_t)(($num)-1) < (64*(( &uint64_t*)($sp))[0]))  && ((( &uint64_t*)($sp))[((($num)-1)/64+1)] & (1<<((($num)-1)%64)))));
    }' unless defined(&prissyssetmember);
    eval 'sub prfillset {
        my($sp) = @_;
	    eval q({ \'int\'  &_i_ = $sizeof{($sp)}/$sizeof{ &uint64_t};  &while( &_i_) (( &uint64_t*)($sp))[-- &_i_] = 1.84467440737096e+19; });
    }' unless defined(&prfillset);
    eval 'sub premptyset {
        my($sp) = @_;
	    eval q({ \'int\'  &_i_ = $sizeof{($sp)}/$sizeof{ &uint64_t};  &while( &_i_) (( &uint64_t*)($sp))[-- &_i_] = 0; });
    }' unless defined(&premptyset);
    eval 'sub praddset {
        my($sp, $flag) = @_;
	    eval q((((($flag)-1) < 64*$sizeof{($sp)}/$sizeof{ &uint64_t}) ? ((( &uint64_t*)($sp))[(($flag)-1)/64] |= (1<<((($flag)-1)%64))) : 0));
    }' unless defined(&praddset);
    eval 'sub prdelset {
        my($sp, $flag) = @_;
	    eval q((((($flag)-1) < 64*$sizeof{($sp)}/$sizeof{ &uint64_t}) ? ((( &uint64_t*)($sp))[(($flag)-1)/64] &= ~(1<<((($flag)-1)%64))) : 0));
    }' unless defined(&prdelset);
    eval 'sub prismember {
        my($sp, $flag) = @_;
	    eval q((((($flag)-1) < 64*$sizeof{($sp)}/$sizeof{ &uint64_t})  && ((( &uint64_t*)($sp))[(($flag)-1)/64] & (1<<((($flag)-1)%64)))));
    }' unless defined(&prismember);
    if(defined( &__cplusplus)) {
    }
}
1;
