require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_RSET)) {
    eval 'sub _H_RSET () {1;}' unless defined(&_H_RSET);
    unless(defined(&_H_TYPES)) {
	require 'sys/types.ph';
    }
    eval 'sub RAD_NAME_SIZE () {32;}' unless defined(&RAD_NAME_SIZE);
    eval 'sub RSET_NAME_SIZE () {255;}' unless defined(&RSET_NAME_SIZE);
    eval 'sub RS_MAXPROCS () {256;}' unless defined(&RS_MAXPROCS);
    eval 'sub MYSELF () {(( &pid_t) -1);}' unless defined(&MYSELF);
    eval 'sub R_CACHE_LEVEL_1 () {1;}' unless defined(&R_CACHE_LEVEL_1);
    eval 'sub R_CACHE_LEVEL_2 () {2;}' unless defined(&R_CACHE_LEVEL_2);
    eval 'sub R_CACHE_LEVEL_3 () {3;}' unless defined(&R_CACHE_LEVEL_3);
    eval 'sub R_CACHE_LEVEL_4 () {4;}' unless defined(&R_CACHE_LEVEL_4);
    eval 'sub R_AVAIL () {0x100;}' unless defined(&R_AVAIL);
    eval 'sub R_UNAVAIL () {0x200;}' unless defined(&R_UNAVAIL);
    eval 'sub R_ANY () {( &R_AVAIL |  &R_UNAVAIL);}' unless defined(&R_ANY);
    eval 'sub R_AVAIL_MASK () {0xff00;}' unless defined(&R_AVAIL_MASK);
    eval 'sub R_ONLINE () {0;}' unless defined(&R_ONLINE);
    eval 'sub R_OFFLINE () {1;}' unless defined(&R_OFFLINE);
    eval 'sub R_NOT_IN_SYSTEM () {2;}' unless defined(&R_NOT_IN_SYSTEM);
    eval 'sub RS_EMPTY () {0;}' unless defined(&RS_EMPTY);
    eval 'sub RS_SYSTEM () {1;}' unless defined(&RS_SYSTEM);
    eval("sub R_NUMPROCESSORS () { 0; }") unless defined(&R_NUMPROCESSORS);
    eval("sub R_NUMMEMPS () { 1; }") unless defined(&R_NUMMEMPS);
    eval("sub R_MEMSIZE () { 2; }") unless defined(&R_MEMSIZE);
    eval("sub R_MAXSDL () { 3; }") unless defined(&R_MAXSDL);
    eval 'sub R_PROCS () {1;}' unless defined(&R_PROCS);
    eval 'sub R_MEMPS () {2;}' unless defined(&R_MEMPS);
    eval 'sub R_DEVS () {4;}' unless defined(&R_DEVS);
    eval 'sub R_ALL_RESOURCES () {( &R_MEMPS |  &R_PROCS |  &R_DEVS);}' unless defined(&R_ALL_RESOURCES);
    eval 'sub R_TYPE_MASK () {0xff;}' unless defined(&R_TYPE_MASK);
    eval("sub R_INFO_PROC () { 0; }") unless defined(&R_INFO_PROC);
    eval("sub R_INFO_MEM () { 1; }") unless defined(&R_INFO_MEM);
    eval("sub R_INFO_DEV () { 2; }") unless defined(&R_INFO_DEV);
    eval("sub R_INFO_CACHE () { 3; }") unless defined(&R_INFO_CACHE);
    eval("sub R_INFO_RAD () { 4; }") unless defined(&R_INFO_RAD);
    eval("sub R_NADA () { 0; }") unless defined(&R_NADA);
    eval("sub R_PROCESS () { 1; }") unless defined(&R_PROCESS);
    eval("sub R_THREAD () { 2; }") unless defined(&R_THREAD);
    eval("sub R_PTHREAD () { 3; }") unless defined(&R_PTHREAD);
    eval("sub R_SHM () { 4; }") unless defined(&R_SHM);
    eval("sub R_FILDES () { 5; }") unless defined(&R_FILDES);
    eval("sub R_FILEP () { 6; }") unless defined(&R_FILEP);
    eval("sub R_PATHNAME () { 7; }") unless defined(&R_PATHNAME);
    eval("sub R_RSET () { 8; }") unless defined(&R_RSET);
    eval("sub R_SUBRANGE () { 9; }") unless defined(&R_SUBRANGE);
    eval("sub R_DETACH_ALL_LOGICAL () { 10; }") unless defined(&R_DETACH_ALL_LOGICAL);
    eval("sub R_DETACH_ALL_PHYSICAL () { 11; }") unless defined(&R_DETACH_ALL_PHYSICAL);
    eval("sub R_DETACH_ALL () { 12; }") unless defined(&R_DETACH_ALL);
    eval 'sub RS_UNION () {1;}' unless defined(&RS_UNION);
    eval 'sub RS_INTERSECTION () {2;}' unless defined(&RS_INTERSECTION);
    eval 'sub RS_EXCLUSION () {3;}' unless defined(&RS_EXCLUSION);
    eval 'sub RS_COPY () {4;}' unless defined(&RS_COPY);
    eval 'sub RS_FIRST () {5;}' unless defined(&RS_FIRST);
    eval 'sub RS_NEXT () {6;}' unless defined(&RS_NEXT);
    eval 'sub RS_NEXT_WRAP () {7;}' unless defined(&RS_NEXT_WRAP);
    eval 'sub R_FIRST_RAD () {(-1);}' unless defined(&R_FIRST_RAD);
    eval 'sub R_FIRST_CPU () {(( &cpu_t)-1);}' unless defined(&R_FIRST_CPU);
    eval 'sub RS_WRAP () {0x10000;}' unless defined(&RS_WRAP);
    eval 'sub RS_ISEMPTY () {0;}' unless defined(&RS_ISEMPTY);
    eval 'sub RS_ISAVAIL () {1;}' unless defined(&RS_ISAVAIL);
    eval 'sub RS_ISEQUAL () {2;}' unless defined(&RS_ISEQUAL);
    eval 'sub RS_ISCONTAINED () {3;}' unless defined(&RS_ISCONTAINED);
    eval 'sub RS_DEFINE () {0;}' unless defined(&RS_DEFINE);
    eval 'sub RS_REDEFINE () {1;}' unless defined(&RS_REDEFINE);
    eval 'sub RS_OWNER () {1;}' unless defined(&RS_OWNER);
    eval 'sub RS_GROUP () {2;}' unless defined(&RS_GROUP);
    eval 'sub RS_PERM () {4;}' unless defined(&RS_PERM);
    eval 'sub RS_PERMMASK () {0000666;}' unless defined(&RS_PERMMASK);
    eval 'sub RS_TYPMASK () {0003000;}' unless defined(&RS_TYPMASK);
    eval 'sub RS_APPDEF () {0000000;}' unless defined(&RS_APPDEF);
    eval 'sub RS_SYSADM () {0001000;}' unless defined(&RS_SYSADM);
    eval 'sub RS_SYSRAD () {0002000;}' unless defined(&RS_SYSRAD);
    eval 'sub RS_IRUSR () {0000400;}' unless defined(&RS_IRUSR);
    eval 'sub RS_IWUSR () {0000200;}' unless defined(&RS_IWUSR);
    eval 'sub RS_IRGRP () {0000040;}' unless defined(&RS_IRGRP);
    eval 'sub RS_IWGRP () {0000020;}' unless defined(&RS_IWGRP);
    eval 'sub RS_IROTH () {0000004;}' unless defined(&RS_IROTH);
    eval 'sub RS_IWOTH () {0000002;}' unless defined(&RS_IWOTH);
    eval 'sub AT_DEFAULT_PRIORITY () {0;}' unless defined(&AT_DEFAULT_PRIORITY);
    eval 'sub AT_PROCESSOR_PRIORITY () {1;}' unless defined(&AT_PROCESSOR_PRIORITY);
    eval 'sub AT_MEMORY_PRIORITY () {2;}' unless defined(&AT_MEMORY_PRIORITY);
    eval 'sub AT_ANY () {0;}' unless defined(&AT_ANY);
    eval 'sub AT_LOGICAL () {1;}' unless defined(&AT_LOGICAL);
    eval 'sub AT_PHYSICAL () {2;}' unless defined(&AT_PHYSICAL);
    eval 'sub RS_CURRENT () {0;}' unless defined(&RS_CURRENT);
    eval 'sub RS_ATTACHED () {1;}' unless defined(&RS_ATTACHED);
    eval 'sub RS_FILE () {0;}' unless defined(&RS_FILE);
    eval 'sub RS_FILESYSTEM () {8;}' unless defined(&RS_FILESYSTEM);
    eval 'sub AT_SOURCE () {0;}' unless defined(&AT_SOURCE);
    eval 'sub AT_TARGET () {1;}' unless defined(&AT_TARGET);
    eval 'sub P_DEFAULT () {0;}' unless defined(&P_DEFAULT);
    eval 'sub P_FIRST_TOUCH () {1;}' unless defined(&P_FIRST_TOUCH);
    eval 'sub P_BALANCED () {2;}' unless defined(&P_BALANCED);
    eval 'sub P_MOST_FREE () {4;}' unless defined(&P_MOST_FREE);
    eval 'sub P_REPLICATE () {8;}' unless defined(&P_REPLICATE);
    eval 'sub P_MIGRATE () {0x100;}' unless defined(&P_MIGRATE);
    eval 'sub RS_UNDEF () {0xfffffff;}' unless defined(&RS_UNDEF);
    if(defined(&_NO_PROTO)) {
    } else {
	if(!defined( &_KERNEL)) {
	}
    }
    if(defined( &_KERNEL)) {
	if(!defined( &_H_PROCESSOR)) {
	    require 'sys/processor.ph';
	}
	eval 'sub RS_SYSRSET () { &NULL;}' unless defined(&RS_SYSRSET);
    }
}
1;
