require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_STROPTS_)) {
    eval 'sub _STROPTS_ () {1;}' unless defined(&_STROPTS_);
    require 'standards.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_ALL_SOURCE)) {
	require 'sys/ioctl.ph';
    }
    unless(defined(&_IO)) {
	eval 'sub _IOCPARM_MASK () {0x7f;}' unless defined(&_IOCPARM_MASK);
	eval 'sub _IOC_VOID () {0x20000000;}' unless defined(&_IOC_VOID);
	eval 'sub _IOC_OUT () {0x40000000;}' unless defined(&_IOC_OUT);
	eval 'sub _IOC_IN () {0x80000000;}' unless defined(&_IOC_IN);
	eval 'sub _IOC_INOUT () {( &_IOC_IN| &_IOC_OUT);}' unless defined(&_IOC_INOUT);
	eval 'sub _IO {
	    my($x,$y) = @_;
    	    eval q(( &_IOC_VOID|($x<<8)|$y));
	}' unless defined(&_IO);
	eval 'sub _IOR {
	    my($x,$y,$t) = @_;
    	    eval q(( &_IOC_OUT|(($sizeof{$t}& &_IOCPARM_MASK)<<16)|($x<<8)|$y));
	}' unless defined(&_IOR);
	eval 'sub _IOW {
	    my($x,$y,$t) = @_;
    	    eval q(( &_IOC_IN|(($sizeof{$t}& &_IOCPARM_MASK)<<16)|($x<<8)|$y));
	}' unless defined(&_IOW);
	eval 'sub _IOWR {
	    my($x,$y,$t) = @_;
    	    eval q(( &_IOC_INOUT|(($sizeof{$t}& &_IOCPARM_MASK)<<16)|($x<<8)|$y));
	}' unless defined(&_IOWR);
	if(defined(&_ALL_SOURCE)) {
	    eval 'sub IOCPARM_MASK () { &_IOCPARM_MASK;}' unless defined(&IOCPARM_MASK);
	    eval 'sub IOC_VOID () { &_IOC_VOID;}' unless defined(&IOC_VOID);
	    eval 'sub IOC_OUT () { &_IOC_OUT;}' unless defined(&IOC_OUT);
	    eval 'sub IOC_IN () { &_IOC_IN;}' unless defined(&IOC_IN);
	    eval 'sub IOC_INOUT () { &_IOC_INOUT;}' unless defined(&IOC_INOUT);
	}
    }
    unless(defined(&_T_SCALAR_DEF)) {
	if(defined(&__64BIT__)) {
	} else {
	}
	eval 'sub _T_SCALAR_DEF () {1;}' unless defined(&_T_SCALAR_DEF);
    }
    if((defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0)==1) {
	eval 'sub I_NREAD () { &_IO(ord(\'S\'),1);}' unless defined(&I_NREAD);
	eval 'sub I_PUSH () { &_IO(ord(\'S\'),2);}' unless defined(&I_PUSH);
	eval 'sub I_POP () { &_IO(ord(\'S\'),3);}' unless defined(&I_POP);
	eval 'sub I_LOOK () { &_IO(ord(\'S\'),4);}' unless defined(&I_LOOK);
	eval 'sub I_FLUSH () { &_IO(ord(\'S\'),5);}' unless defined(&I_FLUSH);
	eval 'sub I_SRDOPT () { &_IO(ord(\'S\'),6);}' unless defined(&I_SRDOPT);
	eval 'sub I_GRDOPT () { &_IO(ord(\'S\'),7);}' unless defined(&I_GRDOPT);
	eval 'sub I_STR () { &_IO(ord(\'S\'),8);}' unless defined(&I_STR);
	eval 'sub I_SETSIG () { &_IO(ord(\'S\'),9);}' unless defined(&I_SETSIG);
	eval 'sub I_GETSIG () { &_IO(ord(\'S\'),10);}' unless defined(&I_GETSIG);
	eval 'sub I_FIND () { &_IO(ord(\'S\'),11);}' unless defined(&I_FIND);
	eval 'sub I_LINK () { &_IO(ord(\'S\'),12);}' unless defined(&I_LINK);
	eval 'sub I_UNLINK () { &_IO(ord(\'S\'),13);}' unless defined(&I_UNLINK);
	eval 'sub I_ISASTREAM () { &_IO(ord(\'S\'),14);}' unless defined(&I_ISASTREAM);
	eval 'sub I_PEEK () { &_IO(ord(\'S\'),15);}' unless defined(&I_PEEK);
	eval 'sub I_FDINSERT () { &_IO(ord(\'S\'),16);}' unless defined(&I_FDINSERT);
	eval 'sub I_SENDFD () { &_IO(ord(\'S\'),17);}' unless defined(&I_SENDFD);
	eval 'sub I_RECVFD () { &_IO(ord(\'S\'),18);}' unless defined(&I_RECVFD);
	eval 'sub I_FLUSHBAND () { &_IO(ord(\'S\'),19);}' unless defined(&I_FLUSHBAND);
	eval 'sub I_SWROPT () { &_IO(ord(\'S\'),20);}' unless defined(&I_SWROPT);
	eval 'sub I_GWROPT () { &_IO(ord(\'S\'),21);}' unless defined(&I_GWROPT);
	eval 'sub I_LIST () { &_IO(ord(\'S\'),22);}' unless defined(&I_LIST);
	eval 'sub I_ATMARK () { &_IO(ord(\'S\'),23);}' unless defined(&I_ATMARK);
	eval 'sub I_CKBAND () { &_IO(ord(\'S\'),24);}' unless defined(&I_CKBAND);
	eval 'sub I_GETBAND () { &_IO(ord(\'S\'),25);}' unless defined(&I_GETBAND);
	eval 'sub I_CANPUT () { &_IO(ord(\'S\'),26);}' unless defined(&I_CANPUT);
	eval 'sub I_SETCLTIME () { &_IO(ord(\'S\'),27);}' unless defined(&I_SETCLTIME);
	eval 'sub I_GETCLTIME () { &_IO(ord(\'S\'),28);}' unless defined(&I_GETCLTIME);
	eval 'sub I_PLINK () { &_IO(ord(\'S\'),29);}' unless defined(&I_PLINK);
	eval 'sub I_PUNLINK () { &_IO(ord(\'S\'),30);}' unless defined(&I_PUNLINK);
	eval 'sub RS_HIPRI () {0x1;}' unless defined(&RS_HIPRI);
	eval 'sub MSG_HIPRI () { &RS_HIPRI;}' unless defined(&MSG_HIPRI);
	eval 'sub MSG_BAND () {0x2;}' unless defined(&MSG_BAND);
	eval 'sub MSG_ANY () {0x4;}' unless defined(&MSG_ANY);
	eval 'sub MORECTL () {0x1;}' unless defined(&MORECTL);
	eval 'sub MOREDATA () {0x2;}' unless defined(&MOREDATA);
	unless(defined(&FMNAMESZ)) {
	    eval 'sub FMNAMESZ () {8;}' unless defined(&FMNAMESZ);
	}
	eval 'sub FLUSHR () {0x1;}' unless defined(&FLUSHR);
	eval 'sub FLUSHW () {0x2;}' unless defined(&FLUSHW);
	eval 'sub FLUSHRW () {( &FLUSHW| &FLUSHR);}' unless defined(&FLUSHRW);
	eval 'sub FLUSHBAND () {0x40;}' unless defined(&FLUSHBAND);
	eval 'sub S_INPUT () {0x1;}' unless defined(&S_INPUT);
	eval 'sub S_HIPRI () {0x2;}' unless defined(&S_HIPRI);
	eval 'sub S_OUTPUT () {0x4;}' unless defined(&S_OUTPUT);
	eval 'sub S_MSG () {0x8;}' unless defined(&S_MSG);
	eval 'sub S_RDNORM () {0x10;}' unless defined(&S_RDNORM);
	eval 'sub S_RDBAND () {0x20;}' unless defined(&S_RDBAND);
	eval 'sub S_WRNORM () {0x40;}' unless defined(&S_WRNORM);
	eval 'sub S_WRBAND () {0x80;}' unless defined(&S_WRBAND);
	eval 'sub S_ERROR () {0x100;}' unless defined(&S_ERROR);
	eval 'sub S_HANGUP () {0x200;}' unless defined(&S_HANGUP);
	eval 'sub S_BANDURG () {0x400;}' unless defined(&S_BANDURG);
	eval 'sub ANYMARK () {0x1;}' unless defined(&ANYMARK);
	eval 'sub LASTMARK () {0x2;}' unless defined(&LASTMARK);
	eval 'sub RNORM () {0x1;}' unless defined(&RNORM);
	eval 'sub RMSGD () {0x2;}' unless defined(&RMSGD);
	eval 'sub RMSGN () {0x4;}' unless defined(&RMSGN);
	eval 'sub RPROTNORM () {0x10;}' unless defined(&RPROTNORM);
	eval 'sub RPROTDIS () {0x20;}' unless defined(&RPROTDIS);
	eval 'sub RPROTDAT () {0x40;}' unless defined(&RPROTDAT);
	eval 'sub SNDZERO () {0x1;}' unless defined(&SNDZERO);
	eval 'sub MUXID_ALL () {-1;}' unless defined(&MUXID_ALL);
	if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0)==500) {
	} else {
	}
	undef(&l_name) if defined(&l_name);
	if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0)==500) {
	} else {
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
    }
    if(defined(&_ALL_SOURCE)) {
	eval 'sub RFILL () {0x8;}' unless defined(&RFILL);
	eval 'sub RPROTCOMPRESS () {0x80;}' unless defined(&RPROTCOMPRESS);
	unless(defined(&SIGPOLL)) {
	    eval 'sub SIGPOLL () { &SIGIO;}' unless defined(&SIGPOLL);
	}
	eval 'sub I_GETMSG () { &_IO(ord(\'S\'),40);}' unless defined(&I_GETMSG);
	eval 'sub I_PUTMSG () { &_IO(ord(\'S\'),41);}' unless defined(&I_PUTMSG);
	eval 'sub I_POLL () { &_IO(ord(\'S\'),42);}' unless defined(&I_POLL);
	eval 'sub I_SETDELAY () { &_IO(ord(\'S\'),43);}' unless defined(&I_SETDELAY);
	eval 'sub I_GETDELAY () { &_IO(ord(\'S\'),44);}' unless defined(&I_GETDELAY);
	eval 'sub I_RUN_QUEUES () { &_IO(ord(\'S\'),45);}' unless defined(&I_RUN_QUEUES);
	eval 'sub I_GETPMSG () { &_IO(ord(\'S\'),46);}' unless defined(&I_GETPMSG);
	eval 'sub I_PUTPMSG () { &_IO(ord(\'S\'),47);}' unless defined(&I_PUTPMSG);
	eval 'sub I_AUTOPUSH () { &_IO(ord(\'S\'),48);}' unless defined(&I_AUTOPUSH);
	eval 'sub I_PIPE () { &_IO(ord(\'S\'),49);}' unless defined(&I_PIPE);
	eval 'sub I_FIFO () { &_IO(ord(\'S\'),50);}' unless defined(&I_FIFO);
	eval 'sub I_STR_ATTR () { &_IO(ord(\'S\'),60);}' unless defined(&I_STR_ATTR);
	eval 'sub I_PEEK_ATTR () { &_IO(ord(\'S\'),61);}' unless defined(&I_PEEK_ATTR);
	eval 'sub I_FDINSERT_ATTR () { &_IO(ord(\'S\'),62);}' unless defined(&I_FDINSERT_ATTR);
	eval 'sub I_SENDFD_ATTR () { &_IO(ord(\'S\'),63);}' unless defined(&I_SENDFD_ATTR);
	eval 'sub I_RECVFD_ATTR () { &_IO(ord(\'S\'),64);}' unless defined(&I_RECVFD_ATTR);
	eval 'sub I_GETMSG_ATTR () { &_IO(ord(\'S\'),65);}' unless defined(&I_GETMSG_ATTR);
	eval 'sub I_PUTMSG_ATTR () { &_IO(ord(\'S\'),66);}' unless defined(&I_PUTMSG_ATTR);
	eval 'sub I_GETPMSG_ATTR () { &_IO(ord(\'S\'),67);}' unless defined(&I_GETPMSG_ATTR);
	eval 'sub I_PUTPMSG_ATTR () { &_IO(ord(\'S\'),68);}' unless defined(&I_PUTPMSG_ATTR);
	if(defined(&SEC_BASE)) {
	}
	eval 'sub stream_open () { &open;}' unless defined(&stream_open);
	eval 'sub stream_close () { &close;}' unless defined(&stream_close);
	eval 'sub stream_read () { &read;}' unless defined(&stream_read);
	eval 'sub stream_write () { &write;}' unless defined(&stream_write);
	eval 'sub stream_ioctl () { &ioctl;}' unless defined(&stream_ioctl);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
