require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SYSMACROS)) {
    eval 'sub _H_SYSMACROS () {1;}' unless defined(&_H_SYSMACROS);
    require 'sys/types.ph';
    require 'sys/param.ph';
    if((defined(&NCPS) ? &NCPS : 0) == 1) {
	eval 'sub ctos {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&ctos);
	eval 'sub stoc {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&stoc);
    } else {
	eval 'sub ctos {
	    my($x) = @_;
    	    eval q(((($x)+( &NCPS-1))/ &NCPS));
	}' unless defined(&ctos);
	eval 'sub stoc {
	    my($x) = @_;
    	    eval q((($x)* &NCPS));
	}' unless defined(&stoc);
    }
    if((defined(&NCPD) ? &NCPD : 0) == 1) {
	eval 'sub ctod {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&ctod);
    } else {
	eval 'sub ctod {
	    my($x) = @_;
    	    eval q(((($x)+( &NCPD-1))/ &NCPD));
	}' unless defined(&ctod);
    }
    eval 'sub bltoc {
        my($x) = @_;
	    eval q((($x)* &NCPD));
    }' unless defined(&bltoc);
    if(defined(&INOSHIFT)) {
	eval 'sub itod {
	    my($x) = @_;
    	    eval q(( &daddr_t)((($x)+(2* &INOPB-1))>> &INOSHIFT));
	}' unless defined(&itod);
    } else {
	eval 'sub itod {
	    my($x) = @_;
    	    eval q(( &daddr_t)((($x)+(2* &INOPB-1))/ &INOPB));
	}' unless defined(&itod);
    }
    if(defined(&INOSHIFT)) {
	eval 'sub itoo {
	    my($x) = @_;
    	    eval q(((($x)+(2* &INOPB-1))( &INOPB-1)));
	}' unless defined(&itoo);
    } else {
	eval 'sub itoo {
	    my($x) = @_;
    	    eval q(((($x)+(2* &INOPB-1))% &INOPB));
	}' unless defined(&itoo);
    }
    if(defined(&BPCSHIFT)) {
	eval 'sub ctob {
	    my($x) = @_;
    	    eval q((($x)<< &BPCSHIFT));
	}' unless defined(&ctob);
    } else {
	eval 'sub ctob {
	    my($x) = @_;
    	    eval q((($x)* &NBPC));
	}' unless defined(&ctob);
    }
    if(defined(&__64BIT_KERNEL)) {
	if(defined(&BPCSHIFT)) {
	    eval 'sub btoc {
	        my($x) = @_;
    		eval q(((($x)+( &NBPC-1))>> &BPCSHIFT));
	    }' unless defined(&btoc);
	    eval 'sub btoct {
	        my($x) = @_;
    		eval q((($x)>> &BPCSHIFT));
	    }' unless defined(&btoct);
	} else {
	    eval 'sub btoc {
	        my($x) = @_;
    		eval q(((($x)+( &NBPC-1))/ &NBPC));
	    }' unless defined(&btoc);
	    eval 'sub btoct {
	        my($x) = @_;
    		eval q((($x)/ &NBPC));
	    }' unless defined(&btoct);
	}
    } else {
	if(defined(&BPCSHIFT)) {
	    eval 'sub btoc {
	        my($x) = @_;
    		eval q(((($x)+( &NBPC-1))>> &BPCSHIFT));
	    }' unless defined(&btoc);
	    eval 'sub btoct {
	        my($x) = @_;
    		eval q((($x)>> &BPCSHIFT));
	    }' unless defined(&btoct);
	} else {
	    eval 'sub btoc {
	        my($x) = @_;
    		eval q(((($x)+( &NBPC-1))/ &NBPC));
	    }' unless defined(&btoc);
	    eval 'sub btoct {
	        my($x) = @_;
    		eval q((($x)/ &NBPC));
	    }' unless defined(&btoct);
	}
    }
    eval 'sub bytes2rblocks {
        my($x) = @_;
	    eval q(((($x)+(1024-1))/1024));
    }' unless defined(&bytes2rblocks);
    eval 'sub rblocks2bytes {
        my($x) = @_;
	    eval q((($x)*1024));
    }' unless defined(&rblocks2bytes);
    eval 'sub stblocks2rblocks {
        my($x) = @_;
	    eval q(((($x)* &UBSIZE+(1024-1))/1024));
    }' unless defined(&stblocks2rblocks);
    eval 'sub rblocks2stblocks {
        my($x) = @_;
	    eval q(((($x)*1024+( &UBSIZE-1))/ &UBSIZE));
    }' unless defined(&rblocks2stblocks);
    eval 'sub major {
        my($__x) = @_;
	    eval q((($__x)>>16));
    }' unless defined(&major);
    eval 'sub bmajor {
        my($x) = @_;
	    eval q((($x>>16) & 0x7fff));
    }' unless defined(&bmajor);
    eval 'sub brdev {
        my($x) = @_;
	    eval q(($x&0x7fffffff));
    }' unless defined(&brdev);
    eval 'sub minor {
        my($__x) = @_;
	    eval q((($__x)&0xffff));
    }' unless defined(&minor);
    eval 'sub makedev {
        my($__x,$__y) = @_;
	    eval q(( &dev_t)((($__x)<<16) | ($__y)));
    }' unless defined(&makedev);
    eval 'sub DEVNO64 () {9.22337203685478e+18;}' unless defined(&DEVNO64);
    eval 'sub major64 {
        my($_devno) = @_;
	    eval q((((($_devno) & 4.61168601413242e+18) >> 32)));
    }' unless defined(&major64);
    eval 'sub minor64 {
        my($_devno) = @_;
	    eval q(((($_devno) & 0xffffffff)));
    }' unless defined(&minor64);
    eval 'sub makedev64 {
        my($_major, $_minor) = @_;
	    eval q((( &dev64_t)(( << 32) | (($_minor) & 0xffffffff) |  &DEVNO64)));
    }' unless defined(&makedev64);
    if(defined(&_KERNEL)) {
	eval 'sub DEVNORSV () {4.61168601842739e+18;}' unless defined(&DEVNORSV);
	eval 'sub DEV64TO32 {
	    my($_devno) = @_;
    	    eval q((( &dev32_t)(((($_devno) & 281470681743360) >> 16) | (($_devno) & 0xffff))));
	}' unless defined(&DEV64TO32);
	eval 'sub DEV32TO64 {
	    my($_devno) = @_;
    	    eval q(( &dev64_t)(((($_devno) & 0xffff0000) << 16) | (($_devno) & 0xffff) |  &DEVNO64));
	}' unless defined(&DEV32TO64);
	eval 'sub DEV64is32 {
	    my($_devno) = @_;
    	    eval q(((((( &dev64_t)($_devno)) & 1.38347765846004e+19) ==  &DEVNO64) ? 1: 0));
	}' unless defined(&DEV64is32);
	if(defined(&_KERNSYS)) {
	    eval 'sub DEV64_valid {
	        my($_devno) = @_;
    		eval q((((((( &dev64_t)($_devno)) & ( &DEVNO64 |  &DEVNORSV)) >> 62) == 4) ? 1: 0););
	    }' unless defined(&DEV64_valid);
	}
	eval 'sub ISDEVNO64 {
	    my($_devno) = @_;
    	    eval q(((($_devno) &  &DEVNO64) ?  &TRUE :  &FALSE));
	}' unless defined(&ISDEVNO64);
	if(defined(&__64BIT_KERNEL)) {
	    eval 'sub DEV32TODEV {
	        my($_devno) = @_;
    		eval q( &DEV32TO64($_devno));
	    }' unless defined(&DEV32TODEV);
	    eval 'sub DEVTODEV32 {
	        my($_devno) = @_;
    		eval q( &DEV64TO32($_devno));
	    }' unless defined(&DEVTODEV32);
	    eval 'sub major_num {
	        my($_devno) = @_;
    		eval q( &major64($_devno));
	    }' unless defined(&major_num);
	    eval 'sub minor_num {
	        my($_devno) = @_;
    		eval q( &minor64($_devno));
	    }' unless defined(&minor_num);
	    eval 'sub makedevno {
	        my($_major, $_minor) = @_;
    		eval q( &makedev64($_major, $_minor));
	    }' unless defined(&makedevno);
	} else {
	    eval 'sub DEV32TODEV {
	        my($_devno) = @_;
    		eval q(($_devno));
	    }' unless defined(&DEV32TODEV);
	    eval 'sub DEVTODEV32 {
	        my($_devno) = @_;
    		eval q(($_devno));
	    }' unless defined(&DEVTODEV32);
	    eval 'sub major_num {
	        my($_devno) = @_;
    		eval q( &major($_devno));
	    }' unless defined(&major_num);
	    eval 'sub minor_num {
	        my($_devno) = @_;
    		eval q( &minor($_devno));
	    }' unless defined(&minor_num);
	    eval 'sub makedevno {
	        my($_major, $_minor) = @_;
    		eval q( &makedev($_major, $_minor));
	    }' unless defined(&makedevno);
	}
    }
    if(defined(&__64BIT_KERNEL)) {
	eval 'sub LONG32TOLONG64 {
	    my($_l32) = @_;
    	    eval q((($_l32)));
	}' unless defined(&LONG32TOLONG64);
	eval 'sub INTSTOLLONG {
	    my($_i1,$_i2) = @_;
    	    eval q(( << 32 | ($_i2)));
	}' unless defined(&INTSTOLLONG);
	eval 'sub INT32TOLONG64 {
	    my($_x) = @_;
    	    eval q((($_x)));
	}' unless defined(&INT32TOLONG64);
    }
}
1;
