require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SYSPEST)) {
    eval 'sub _H_SYSPEST () {1;}' unless defined(&_H_SYSPEST);
    if(defined(&__ia64)) {
    }
    if(defined(&_KERNEL)) {
	if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
	    if(defined( &__ia64)  && !defined( &__IBMC__)  && !defined( &__IBMCPP__)) {
	    } else {
	    }
	}
    }
    if(defined(&DEBUG)) {
	unless(defined(&__ia64)) {
	    if(defined(&_KERNSYS)) {
		eval 'sub assert {
		    my($p) = @_;
    		    eval q({ &__assert2( &__assert1(!!($p),0,99));});
		}' unless defined(&assert);
		eval 'sub ASSERT {
		    my($p) = @_;
    		    eval q( &assert($p));
		}' unless defined(&ASSERT);
	    } else {
		eval 'sub assert {
		    my($p) = @_;
    		    eval q({ &if(!($p)){ &printf(\\"[%s #%d]\\\\n\\", &__FILE__, &__LINE__);  &panic(\\"assert(p)\\");}});
		}' unless defined(&assert);
		eval 'sub ASSERT {
		    my($p) = @_;
    		    eval q( &assert($p));
		}' unless defined(&ASSERT);
	    }
	} else {
	    eval 'sub assert {
	        my($p) = @_;
    		eval q({ &if(!($p)){ &panic_break(); &printf(\\"[%s #%d]\\\\n\\", &__FILE__, &__LINE__);  &panic(\\"assert(p)\\");}});
	    }' unless defined(&assert);
	    eval 'sub ASSERT {
	        my($p) = @_;
    		eval q( &assert($p));
	    }' unless defined(&ASSERT);
	}
	eval 'sub BUGNFO () {0x1;}' unless defined(&BUGNFO);
	eval 'sub BUGACT () {0x2;}' unless defined(&BUGACT);
	eval 'sub BUGNTF () {0x3;}' unless defined(&BUGNTF);
	eval 'sub BUGNTA () {0x4;}' unless defined(&BUGNTA);
	eval 'sub BUGNTX () {0x5;}' unless defined(&BUGNTX);
	eval 'sub BUGGID () {0x99;}' unless defined(&BUGGID);
	eval 'sub BUGVDEF {
	    my($bugvar,$lev) = @_;
    	    eval q(\'int\' $bugvar = ($lev););
	}' unless defined(&BUGVDEF);
	eval 'sub BUGXDEF {
	    my($bugvar) = @_;
    	    eval q( &extern $bugvar;);
	}' unless defined(&BUGXDEF);
	eval 'sub BUGPR {
	    my($prspec) = @_;
    	    eval q({ &printf(\\"[%s #%d]  \\",  &__FILE__,  &__LINE__);  &printf $prspec;});
	}' unless defined(&BUGPR);
	eval 'sub BUGLPR {
	    my($bugvar,$buglev,$prspec) = @_;
    	    eval q({ &if (($buglev) <= ($bugvar)) { &printf(\\"[%s #%d]  \\",  &__FILE__,  &__LINE__);  &printf $prspec;}});
	}' unless defined(&BUGLPR);
	eval 'sub BUGC {
	    my($expr,$comnt) = @_;
    	    eval q({ &if (!($expr)) { &printf(\\"[%s #%d]  %s\\\\n\\",  &__FILE__,  &__LINE__,$comnt);}});
	}' unless defined(&BUGC);
	eval 'sub BUGLC {
	    my($bugvar,$buglev,$expr,$comnt) = @_;
    	    eval q({  &if ((!($expr))  && (($buglev) <= ($bugvar))) { &printf(\\"[%s #%d]  %s\\\\n\\",  &__FILE__,  &__LINE__,$comnt);}});
	}' unless defined(&BUGLC);
	eval 'sub BUGX {
	    my($expr,$funct) = @_;
    	    eval q({ &if (!($expr)) { &printf(\\"[%s #%d]\\\\n\\",  &__FILE__,  &__LINE__);$funct;}});
	}' unless defined(&BUGX);
	eval 'sub BUGLX {
	    my($bugvar,$buglev,$expr,$funct) = @_;
    	    eval q({  &if ((!($expr))  && (($buglev) <= ($bugvar))) { &printf(\\"[%s #%d]\\\\n\\",  &__FILE__,  &__LINE__);$funct;}});
	}' unless defined(&BUGLX);
	eval 'sub BUGCX {
	    my($expr,$comnt,$funct) = @_;
    	    eval q({  &if (!($expr)) { &printf(\\"[%s #%d]  %s\\\\n\\",  &__FILE__,  &__LINE__,$comnt);$funct;}});
	}' unless defined(&BUGCX);
	eval 'sub BUGLCX {
	    my($bugvar,$buglev,$expr,$comnt,$funct) = @_;
    	    eval q({  &if ((!($expr))  && (($buglev) <= ($bugvar))) { &printf(\\"[%s #%d]  %s\\\\n\\",  &__FILE__,  &__LINE__,$comnt);$funct;}});
	}' unless defined(&BUGLCX);
	eval 'sub BUGVT {
	    my($variable,$type) = @_;
    	    eval q({ &printf(\\"[%s #%d]  variable = %type\\\\n\\",  &__FILE__,  &__LINE__,($variable));});
	}' unless defined(&BUGVT);
	eval 'sub BUGLVT {
	    my($bugvar,$buglev,$variable,$type) = @_;
    	    eval q({  &if (($buglev) <= ($bugvar)) { &printf(\\"[%s #%d]  variable = %type\\\\n\\",  &__FILE__,  &__LINE__,($variable));}});
	}' unless defined(&BUGLVT);
	eval 'sub BUGRT {
	    my($comnt,$variable,$type) = @_;
    	    eval q({ &printf(\\"[%s #%d]  %s...variable = %type\\\\n\\",  &__FILE__,  &__LINE__,$comnt,($variable));});
	}' unless defined(&BUGRT);
	eval 'sub BUGLRT {
	    my($bugvar,$buglev,$comnt,$variable,$type) = @_;
    	    eval q({  &if (($buglev) <= ($bugvar)) { &printf(\\"[%s #%d]  %s...variable = %type\\\\n\\",  &__FILE__,  &__LINE__,$comnt,($variable));}});
	}' unless defined(&BUGLRT);
	eval 'sub BUGDM {
	    my($comnt,$dumpaddr,$dumpl) = @_;
    	    eval q({ &printf(\\"[%s #%d]  %s\\\\n\\",  &__FILE__,  &__LINE__,$comnt);  &xdump(($dumpaddr),($dumpl));});
	}' unless defined(&BUGDM);
	eval 'sub BUGLDM {
	    my($bugvar,$buglev,$comnt,$dumpaddr,$dumpl) = @_;
    	    eval q({ &if ($buglev <= $bugvar) { &printf(\\"[%s #%d]  %s\\\\n\\",  &__FILE__,  &__LINE__,$comnt);  &xdump(($dumpaddr),($dumpl));}});
	}' unless defined(&BUGLDM);
	eval 'sub BUGS1 {
	    my($bugvar,$buglev,$s1) = @_;
    	    eval q({  &if (($buglev) <= ($bugvar))  &printf(\\"[%s #%d] s1 =  %d\\\\n\\",  &__FILE__,  &__LINE__, ($s1));});
	}' unless defined(&BUGS1);
	eval 'sub BUGS2 {
	    my($bugvar,$buglev,$s1,$s2) = @_;
    	    eval q({  &if (($buglev) <= ($bugvar))  &printf(\\"[%s #%d] s1 = %x s2 = %x\\\\n\\",  &__FILE__,  &__LINE__, ($s1),($s2));});
	}' unless defined(&BUGS2);
	eval 'sub BUGFUNCT {
	    my($funct) = @_;
    	    eval q({$funct;});
	}' unless defined(&BUGFUNCT);
	eval 'sub BUGLFUNCT {
	    my($bugvar,$buglev,$expr,$funct) = @_;
    	    eval q({ &if (($buglev) <= ($bugvar)) $funct;});
	}' unless defined(&BUGLFUNCT);
    } else {
	if(defined(&_POWER)) {
	    if(defined(&__64BIT_KERNEL)) {
		eval 'sub assert {
		    my($p) = @_;
    		    eval q({ &__assert2( &__assert1(!!($p),0,99));});
		}' unless defined(&assert);
	    } else {
		eval 'sub assert {
		    my($p) = @_;
    		    eval q({ &__assert2( &__assert1(($p),0,99));});
		}' unless defined(&assert);
	    }
	} else {
	    eval 'sub assert {
	        my($p) = @_;
    		eval q({ &if(!($p)){ &panic_break(); &printf(\\"[%s #%d]\\\\n\\", &__FILE__, &__LINE__);  &panic(\\"asset(p)\\");}});
	    }' unless defined(&assert);
	}
	if(defined(&_KERNSYS)) {
	    eval 'sub ASSERT {
	        my($p) = @_;
    		eval q();
	    }' unless defined(&ASSERT);
	} else {
	    eval 'sub ASSERT {
	        my($p) = @_;
    		eval q({($p);});
	    }' unless defined(&ASSERT);
	}
	eval 'sub BUGVDEF {
	    my($bugvar,$lev) = @_;
    	    eval q();
	}' unless defined(&BUGVDEF);
	eval 'sub BUGXDEF {
	    my($bugvar) = @_;
    	    eval q();
	}' unless defined(&BUGXDEF);
	eval 'sub BUGPR {
	    my($prspec) = @_;
    	    eval q();
	}' unless defined(&BUGPR);
	eval 'sub BUGLPR {
	    my($bugvar,$buglev,$prspec) = @_;
    	    eval q();
	}' unless defined(&BUGLPR);
	eval 'sub BUGC {
	    my($expr,$comnt) = @_;
    	    eval q();
	}' unless defined(&BUGC);
	eval 'sub BUGLC {
	    my($bugvar,$buglev,$expr,$comnt) = @_;
    	    eval q();
	}' unless defined(&BUGLC);
	eval 'sub BUGX {
	    my($expr,$funct) = @_;
    	    eval q();
	}' unless defined(&BUGX);
	eval 'sub BUGLX {
	    my($bugvar,$buglev,$expr,$funct) = @_;
    	    eval q();
	}' unless defined(&BUGLX);
	eval 'sub BUGVT {
	    my($variable,$type) = @_;
    	    eval q();
	}' unless defined(&BUGVT);
	eval 'sub BUGLVT {
	    my($bugvar,$buglev,$variable,$type) = @_;
    	    eval q();
	}' unless defined(&BUGLVT);
	eval 'sub BUGRT {
	    my($comnt,$variable,$type) = @_;
    	    eval q();
	}' unless defined(&BUGRT);
	eval 'sub BUGLRT {
	    my($bugvar,$buglev,$comnt,$variable,$type) = @_;
    	    eval q();
	}' unless defined(&BUGLRT);
	eval 'sub BUGCX {
	    my($expr,$comnt,$funct) = @_;
    	    eval q();
	}' unless defined(&BUGCX);
	eval 'sub BUGLCX {
	    my($bugvar,$buglev,$expr,$comnt,$funct) = @_;
    	    eval q();
	}' unless defined(&BUGLCX);
	eval 'sub BUGDM {
	    my($comnt,$dumpaddr,$dumpl) = @_;
    	    eval q();
	}' unless defined(&BUGDM);
	eval 'sub BUGLDM {
	    my($bugvar,$buglev,$comnt,$dumpaddr,$dumpl) = @_;
    	    eval q();
	}' unless defined(&BUGLDM);
	eval 'sub BUGS1 {
	    my($bugvar,$buglev,$s1) = @_;
    	    eval q();
	}' unless defined(&BUGS1);
	eval 'sub BUGS2 {
	    my($bugvar,$buglev,$s1,$s2) = @_;
    	    eval q();
	}' unless defined(&BUGS2);
	eval 'sub BUGFUNCT {
	    my($funct) = @_;
    	    eval q();
	}' unless defined(&BUGFUNCT);
	eval 'sub BUGLFUNCT {
	    my($bugvar,$buglev,$expr,$funct) = @_;
    	    eval q();
	}' unless defined(&BUGLFUNCT);
    }
}
1;
