require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_SYSTEMCFG)) {
    eval 'sub _H_SYSTEMCFG () {1;}' unless defined(&_H_SYSTEMCFG);
    eval 'sub POWER_RS () {0x1;}' unless defined(&POWER_RS);
    eval 'sub POWER_PC () {0x2;}' unless defined(&POWER_PC);
    eval 'sub IA64 () {0x3;}' unless defined(&IA64);
    eval 'sub POWER_RS1 () {0x1;}' unless defined(&POWER_RS1);
    eval 'sub POWER_RSC () {0x2;}' unless defined(&POWER_RSC);
    eval 'sub POWER_RS2 () {0x4;}' unless defined(&POWER_RS2);
    eval 'sub POWER_601 () {0x8;}' unless defined(&POWER_601);
    eval 'sub POWER_603 () {0x20;}' unless defined(&POWER_603);
    eval 'sub POWER_604 () {0x10;}' unless defined(&POWER_604);
    eval 'sub POWER_620 () {0x40;}' unless defined(&POWER_620);
    eval 'sub POWER_630 () {0x80;}' unless defined(&POWER_630);
    eval 'sub POWER_A35 () {0x100;}' unless defined(&POWER_A35);
    eval 'sub POWER_RS64II () {0x200;}' unless defined(&POWER_RS64II);
    eval 'sub POWER_RS64III () {0x400;}' unless defined(&POWER_RS64III);
    eval 'sub POWER_4 () {0x800;}' unless defined(&POWER_4);
    eval 'sub POWER_RS64IV () { &POWER_4;}' unless defined(&POWER_RS64IV);
    eval 'sub POWER_MPC7450 () {0x1000;}' unless defined(&POWER_MPC7450);
    eval 'sub IA64_M1 () {0x1;}' unless defined(&IA64_M1);
    eval 'sub IA64_M2 () {0x2;}' unless defined(&IA64_M2);
    if(defined(&_KERNSYS)) {
	eval 'sub POWER_RESERVED_2 () {0x200;}' unless defined(&POWER_RESERVED_2);
	eval 'sub POWER_RESERVED_3 () {0x400;}' unless defined(&POWER_RESERVED_3);
	eval 'sub POWER_RESERVED_4 () {0x800;}' unless defined(&POWER_RESERVED_4);
	eval 'sub POWER_RS_ALL () {( &POWER_RS1| &POWER_RSC| &POWER_RS2);}' unless defined(&POWER_RS_ALL);
	eval 'sub POWER_PC_ALL () {( &POWER_601| &POWER_603| &POWER_604| &POWER_620| &POWER_A35| &POWER_630| &POWER_RS64II| &POWER_RS64III| &POWER_4| &POWER_MPC7450);}' unless defined(&POWER_PC_ALL);
	eval 'sub POWER_PC_DBATS () {( &POWER_603| &POWER_604| &POWER_620| &POWER_A35| &POWER_630| &POWER_RS64II| &POWER_RS64III| &POWER_MPC7450);}' unless defined(&POWER_PC_DBATS);
	eval 'sub NO_U_SPRG3 () {( &POWER_620| &POWER_A35| &POWER_630| &POWER_RS64II);}' unless defined(&NO_U_SPRG3);
	eval 'sub POWER_PC_STAB () {( &POWER_620| &POWER_A35| &POWER_630| &POWER_RS64II| &POWER_RS64III);}' unless defined(&POWER_PC_STAB);
	eval 'sub IA64_ALL () {( &IA64_M1 |  &IA64_M2);}' unless defined(&IA64_ALL);
    }
    eval 'sub PV_601 () {0x10001;}' unless defined(&PV_601);
    eval 'sub PV_601a () {0x10002;}' unless defined(&PV_601a);
    eval 'sub PV_603 () {0x60000;}' unless defined(&PV_603);
    eval 'sub PV_604 () {0x50000;}' unless defined(&PV_604);
    eval 'sub PV_620 () {0x70000;}' unless defined(&PV_620);
    eval 'sub PV_630 () {0x80000;}' unless defined(&PV_630);
    eval 'sub PV_A35 () {0x90000;}' unless defined(&PV_A35);
    eval 'sub PV_RS64II () {0xa0000;}' unless defined(&PV_RS64II);
    eval 'sub PV_RS64III () {0xb0000;}' unless defined(&PV_RS64III);
    eval 'sub PV_4 () {0xc0000;}' unless defined(&PV_4);
    eval 'sub PV_RS64IV () { &PV_4;}' unless defined(&PV_RS64IV);
    eval 'sub PV_MPC7450 () {0xd0000;}' unless defined(&PV_MPC7450);
    eval 'sub PV_4_2 () {0xe0000;}' unless defined(&PV_4_2);
    eval 'sub PV_RESERVED_2 () {0xa0000;}' unless defined(&PV_RESERVED_2);
    eval 'sub PV_RESERVED_3 () {0xb0000;}' unless defined(&PV_RESERVED_3);
    eval 'sub PV_RS2 () {0x40000;}' unless defined(&PV_RS2);
    eval 'sub PV_RS1 () {0x20000;}' unless defined(&PV_RS1);
    eval 'sub PV_RSC () {0x30000;}' unless defined(&PV_RSC);
    eval 'sub PV_M1 () {0x8000;}' unless defined(&PV_M1);
    eval 'sub PV_M2 () {0x8001;}' unless defined(&PV_M2);
    eval 'sub ITANIUM_STEP_A () {0;}' unless defined(&ITANIUM_STEP_A);
    eval 'sub ITANIUM_STEP_B0 () {1;}' unless defined(&ITANIUM_STEP_B0);
    eval 'sub ITANIUM_STEP_B1 () {2;}' unless defined(&ITANIUM_STEP_B1);
    eval 'sub ITANIUM_STEP_B2 () {3;}' unless defined(&ITANIUM_STEP_B2);
    eval 'sub RTC_POWER () {1;}' unless defined(&RTC_POWER);
    eval 'sub RTC_POWER_PC () {2;}' unless defined(&RTC_POWER_PC);
    eval 'sub RTC_IA64 () {3;}' unless defined(&RTC_IA64);
    eval 'sub __mp () {
        eval q(( ($_system_configuration->{ncpus}) > 1));
    }' unless defined(&__mp);
    eval 'sub __cpu64 () {
        eval q(( ($_system_configuration->{width}) == 64));
    }' unless defined(&__cpu64);
    eval 'sub __power_rs () {
        eval q(( ($_system_configuration->{architecture}) ==  &POWER_RS));
    }' unless defined(&__power_rs);
    eval 'sub __power_pc () {
        eval q(( ($_system_configuration->{architecture}) ==  &POWER_PC));
    }' unless defined(&__power_pc);
    eval 'sub __power_set {
        my($a) = @_;
	    eval q(( ($_system_configuration->{implementation}) & ($a)));
    }' unless defined(&__power_set);
    eval 'sub __power_mp () {
        eval q( &__mp());
    }' unless defined(&__power_mp);
    eval 'sub __power_64 () {
        eval q( &__cpu64());
    }' unless defined(&__power_64);
    eval 'sub __power_rs1 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_RS1));
    }' unless defined(&__power_rs1);
    eval 'sub __power_rsc () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_RSC));
    }' unless defined(&__power_rsc);
    eval 'sub __power_rs2 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_RS2));
    }' unless defined(&__power_rs2);
    eval 'sub __power_601 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_601));
    }' unless defined(&__power_601);
    eval 'sub __power_603 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_603));
    }' unless defined(&__power_603);
    eval 'sub __power_604 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_604));
    }' unless defined(&__power_604);
    eval 'sub __power_620 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_620));
    }' unless defined(&__power_620);
    eval 'sub __power_630 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_630));
    }' unless defined(&__power_630);
    eval 'sub __power_A35 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_A35));
    }' unless defined(&__power_A35);
    eval 'sub __power_RS64II () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_RS64II));
    }' unless defined(&__power_RS64II);
    eval 'sub __power_RS64III () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_RS64III));
    }' unless defined(&__power_RS64III);
    eval 'sub __power_4 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_4));
    }' unless defined(&__power_4);
    eval 'sub __power_RS64IV () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_4));
    }' unless defined(&__power_RS64IV);
    eval 'sub __power_mpc7450 () {
        eval q(( ($_system_configuration->{implementation}) ==  &POWER_MPC7450));
    }' unless defined(&__power_mpc7450);
    eval 'sub __isia64 () {
        eval q(( ($_system_configuration->{architecture}) ==  &IA64));
    }' unless defined(&__isia64);
    eval 'sub __ia64_set {
        my($a) = @_;
	    eval q(( ($_system_configuration->{implementation}) & ($a)));
    }' unless defined(&__ia64_set);
    eval 'sub __KRN_TYPE_MASK () {0x1;}' unless defined(&__KRN_TYPE_MASK);
    eval 'sub __LPAR_MASK () {0x2;}' unless defined(&__LPAR_MASK);
    eval 'sub __NUMA_MASK () {0x8;}' unless defined(&__NUMA_MASK);
    eval 'sub __KRN_UPMP_MASK () {0x10;}' unless defined(&__KRN_UPMP_MASK);
    eval 'sub __KERNEL_32 () {
        eval q((( ($_system_configuration->{kernel}) &  &__KRN_TYPE_MASK) == 0x));
    }' unless defined(&__KERNEL_32);
    eval 'sub __KERNEL_64 () {
        eval q((( ($_system_configuration->{kernel}) &  &__KRN_TYPE_MASK) == 0x1));
    }' unless defined(&__KERNEL_64);
    eval 'sub __LPAR () {
        eval q(( ($_system_configuration->{kernel}) &  &__LPAR_MASK));
    }' unless defined(&__LPAR);
    eval 'sub __NUMA () {
        eval q(( ($_system_configuration->{kernel}) &  &__NUMA_MASK));
    }' unless defined(&__NUMA);
    eval 'sub __KERNEL_UP () {
        eval q((( ($_system_configuration->{kernel}) &  &__KRN_UPMP_MASK) == 0x));
    }' unless defined(&__KERNEL_UP);
    eval 'sub __KERNEL_MP () {
        eval q(( ($_system_configuration->{kernel}) &  &__KRN_UPMP_MASK));
    }' unless defined(&__KERNEL_MP);
    eval 'sub __64BIT_LARGE_ABI_MASK () {0x4;}' unless defined(&__64BIT_LARGE_ABI_MASK);
    eval 'sub __64BIT_LARGE_ABI () {
        eval q(( ($_system_configuration->{kernel}) &  &__64BIT_LARGE_ABI_MASK));
    }' unless defined(&__64BIT_LARGE_ABI);
    if(defined(&_KERNSYS)) {
	eval 'sub __power_sslb () {
	    eval q(( ($_system_configuration->{slb_attr}) & 1));
	}' unless defined(&__power_sslb);
	eval 'sub MODEL_ARCH_OEM_START () {1024;}' unless defined(&MODEL_ARCH_OEM_START);
	eval 'sub MODEL_ARCH_OEM_END () {2047;}' unless defined(&MODEL_ARCH_OEM_END);
	eval 'sub MODEL_IMPL_OEM_START () {1024;}' unless defined(&MODEL_IMPL_OEM_START);
	eval 'sub MODEL_IMPL_OEM_END () {2047;}' unless defined(&MODEL_IMPL_OEM_END);
    }
    if(defined( &_KERNSYS) || defined( &_KERNEL)) {
	if(defined(&_RS6K)) {
	    eval 'sub RS6K () {1;}' unless defined(&RS6K);
	    eval 'sub __rs6k () {
	        eval q(( ($_system_configuration->{model_arch}) ==  &RS6K));
	    }' unless defined(&__rs6k);
	} else {
	    eval 'sub __rs6k () {
	        eval q(0);
	    }' unless defined(&__rs6k);
	}
	if(defined(&_RSPC)) {
	    eval 'sub RSPC () {2;}' unless defined(&RSPC);
	    eval 'sub __rspc () {
	        eval q(( ($_system_configuration->{model_arch}) ==  &RSPC));
	    }' unless defined(&__rspc);
	} else {
	    eval 'sub __rspc () {
	        eval q(0);
	    }' unless defined(&__rspc);
	}
	if(defined(&_CHRP)) {
	    eval 'sub CHRP () {3;}' unless defined(&CHRP);
	    eval 'sub __chrp () {
	        eval q(( ($_system_configuration->{model_arch}) ==  &CHRP));
	    }' unless defined(&__chrp);
	} else {
	    eval 'sub __chrp () {
	        eval q(0);
	    }' unless defined(&__chrp);
	}
	if(defined(&_IA64_SYS)) {
	    eval 'sub IA64_SYS () {4;}' unless defined(&IA64_SYS);
	    eval 'sub __ia64_sys () {
	        eval q(( ($_system_configuration->{model_arch}) ==  &IA64_SYS));
	    }' unless defined(&__ia64_sys);
	} else {
	    eval 'sub __ia64_sys () {
	        eval q(0);
	    }' unless defined(&__ia64_sys);
	}
	if(defined(&_RS6K_UP_MCA)) {
	    eval 'sub RS6K_UP_MCA () {1;}' unless defined(&RS6K_UP_MCA);
	    eval 'sub __rs6k_up_mca () {
	        eval q(( ($_system_configuration->{model_impl}) ==  &RS6K_UP_MCA));
	    }' unless defined(&__rs6k_up_mca);
	} else {
	    eval 'sub __rs6k_up_mca () {
	        eval q(0);
	    }' unless defined(&__rs6k_up_mca);
	}
	if(defined(&_RS6K_SMP_MCA)) {
	    eval 'sub RS6K_SMP_MCA () {2;}' unless defined(&RS6K_SMP_MCA);
	    eval 'sub __rs6k_smp_mca () {
	        eval q(( ($_system_configuration->{model_impl}) ==  &RS6K_SMP_MCA));
	    }' unless defined(&__rs6k_smp_mca);
	} else {
	    eval 'sub __rs6k_smp_mca () {
	        eval q(0);
	    }' unless defined(&__rs6k_smp_mca);
	}
	if(defined(&_RSPC_UP_PCI)) {
	    eval 'sub RSPC_UP_PCI () {3;}' unless defined(&RSPC_UP_PCI);
	    eval 'sub __rspc_up_pci () {
	        eval q(( ($_system_configuration->{model_impl}) ==  &RSPC_UP_PCI));
	    }' unless defined(&__rspc_up_pci);
	} else {
	    eval 'sub __rspc_up_pci () {
	        eval q(0);
	    }' unless defined(&__rspc_up_pci);
	}
	if(defined(&_RSPC_SMP_PCI)) {
	    eval 'sub RSPC_SMP_PCI () {4;}' unless defined(&RSPC_SMP_PCI);
	    eval 'sub __rspc_smp_pci () {
	        eval q(( ($_system_configuration->{model_impl}) ==  &RSPC_SMP_PCI));
	    }' unless defined(&__rspc_smp_pci);
	} else {
	    eval 'sub __rspc_smp_pci () {
	        eval q(0);
	    }' unless defined(&__rspc_smp_pci);
	}
	if(defined(&_CHRP_UP_PCI)) {
	    eval 'sub CHRP_UP_PCI () {5;}' unless defined(&CHRP_UP_PCI);
	    eval 'sub __chrp_up_pci () {
	        eval q(( ($_system_configuration->{model_impl}) ==  &CHRP_UP_PCI));
	    }' unless defined(&__chrp_up_pci);
	} else {
	    eval 'sub __chrp_up_pci () {
	        eval q(0);
	    }' unless defined(&__chrp_up_pci);
	}
	if(defined(&_CHRP_SMP_PCI)) {
	    eval 'sub CHRP_SMP_PCI () {6;}' unless defined(&CHRP_SMP_PCI);
	    eval 'sub __chrp_smp_pci () {
	        eval q(( ($_system_configuration->{model_impl}) ==  &CHRP_SMP_PCI));
	    }' unless defined(&__chrp_smp_pci);
	} else {
	    eval 'sub __chrp_smp_pci () {
	        eval q(0);
	    }' unless defined(&__chrp_smp_pci);
	}
	if(defined(&_IA64_SYS)) {
	    eval 'sub IA64_COM () {7;}' unless defined(&IA64_COM);
	    eval 'sub __ia64_com () {
	        eval q(( ($_system_configuration->{model_impl}) ==  &IA64_COM));
	    }' unless defined(&__ia64_com);
	} else {
	    eval 'sub __ia64_com () {
	        eval q(0);
	    }' unless defined(&__ia64_com);
	}
	if(defined(&_IA64_SYS)) {
	    eval 'sub IA64_SOFTSDV () {8;}' unless defined(&IA64_SOFTSDV);
	    eval 'sub __ia64_softsdv () {
	        eval q(( ($_system_configuration->{model_impl}) ==  &IA64_SOFTSDV));
	    }' unless defined(&__ia64_softsdv);
	} else {
	    eval 'sub __ia64_softsdv () {
	        eval q(0);
	    }' unless defined(&__ia64_softsdv);
	}
	eval 'sub __pal () {
	    eval q((! &__power_rs()  && ! &__rs6k()));
	}' unless defined(&__pal);
	eval 'sub __DBATS () {
	    eval q(( &__power_set( &POWER_PC_DBATS)  && ! &__LPAR()));
	}' unless defined(&__DBATS);
    }
}
1;
