require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_TAPEDD)) {
    eval 'sub _H_TAPEDD () {1;}' unless defined(&_H_TAPEDD);
    require 'sys/pm.ph';
    eval 'sub TAPE_GOOD_CMPLTN () {0x;}' unless defined(&TAPE_GOOD_CMPLTN);
    eval 'sub TAPE_CHK_CONDITION () {0x2;}' unless defined(&TAPE_CHK_CONDITION);
    eval 'sub TAPE_COND_GOOD () {0x4;}' unless defined(&TAPE_COND_GOOD);
    eval 'sub TAPE_BUSY () {0x8;}' unless defined(&TAPE_BUSY);
    eval 'sub TAPE_IMMED_GOOD () {0x10;}' unless defined(&TAPE_IMMED_GOOD);
    eval 'sub TAPE_IMMED_COND_GOOD () {0x14;}' unless defined(&TAPE_IMMED_COND_GOOD);
    eval 'sub TAPE_RES_CONFLICT () {0x18;}' unless defined(&TAPE_RES_CONFLICT);
    eval 'sub TAPE_CMD_TIMEDOUT () {0xff;}' unless defined(&TAPE_CMD_TIMEDOUT);
    eval 'sub TAPE_NO_SENSE () {0x;}' unless defined(&TAPE_NO_SENSE);
    eval 'sub TAPE_RECOVERED_ERROR () {0x1;}' unless defined(&TAPE_RECOVERED_ERROR);
    eval 'sub TAPE_NOT_READY () {0x2;}' unless defined(&TAPE_NOT_READY);
    eval 'sub TAPE_MEDIUM_ERROR () {0x3;}' unless defined(&TAPE_MEDIUM_ERROR);
    eval 'sub TAPE_HARDWARE_ERROR () {0x4;}' unless defined(&TAPE_HARDWARE_ERROR);
    eval 'sub TAPE_ILLEGAL_REQUEST () {0x5;}' unless defined(&TAPE_ILLEGAL_REQUEST);
    eval 'sub TAPE_UNIT_ATTENTION () {0x6;}' unless defined(&TAPE_UNIT_ATTENTION);
    eval 'sub TAPE_DATA_PROTECT () {0x7;}' unless defined(&TAPE_DATA_PROTECT);
    eval 'sub TAPE_BLANK_CHECK () {0x8;}' unless defined(&TAPE_BLANK_CHECK);
    eval 'sub TAPE_VENDOR_UNIQUE () {0x9;}' unless defined(&TAPE_VENDOR_UNIQUE);
    eval 'sub TAPE_COPY_ABORTED () {0xa;}' unless defined(&TAPE_COPY_ABORTED);
    eval 'sub TAPE_ABORTED_COMMAND () {0xb;}' unless defined(&TAPE_ABORTED_COMMAND);
    eval 'sub TAPE_EQUAL_CMD () {0xc;}' unless defined(&TAPE_EQUAL_CMD);
    eval 'sub TAPE_VOLUME_OVERFLOW () {0xd;}' unless defined(&TAPE_VOLUME_OVERFLOW);
    eval 'sub TAPE_MISCOMPARE () {0xe;}' unless defined(&TAPE_MISCOMPARE);
    eval 'sub TAPE_MAX_RETRY () {4;}' unless defined(&TAPE_MAX_RETRY);
    eval 'sub TAPE_MAXREQUEST () {262144;}' unless defined(&TAPE_MAXREQUEST);
    eval 'sub DEVNO_OVERLAY () {0x1fff;}' unless defined(&DEVNO_OVERLAY);
    eval 'sub TAPE_NOREW_ON_CLOSE () {0x1;}' unless defined(&TAPE_NOREW_ON_CLOSE);
    eval 'sub TAPE_RETEN_ON_OPEN () {0x2;}' unless defined(&TAPE_RETEN_ON_OPEN);
    eval 'sub TAPE_DENSITY2 () {0x4;}' unless defined(&TAPE_DENSITY2);
    eval 'sub TAPE_REVERSE () {0x1;}' unless defined(&TAPE_REVERSE);
    eval 'sub TAPE_FORWARD () {0x2;}' unless defined(&TAPE_FORWARD);
    eval 'sub TAPE_RECORD () {0x1;}' unless defined(&TAPE_RECORD);
    eval 'sub TAPE_FILEMARK () {0x2;}' unless defined(&TAPE_FILEMARK);
    eval 'sub TAPE_WAKEUP () {0x1;}' unless defined(&TAPE_WAKEUP);
    eval 'sub TAPE_NOWAKEUP () {0x2;}' unless defined(&TAPE_NOWAKEUP);
    eval 'sub TAPE_ADAPTER_ERROR () {0x1;}' unless defined(&TAPE_ADAPTER_ERROR);
    eval 'sub TAPE_SCSI_ERROR () {0x2;}' unless defined(&TAPE_SCSI_ERROR);
    eval 'sub TAPE_NOBUFF () {0x1;}' unless defined(&TAPE_NOBUFF);
    eval 'sub TAPE_BUFFERED () {0x2;}' unless defined(&TAPE_BUFFERED);
    eval 'sub TAPE_COMP_PAGE () {0xf;}' unless defined(&TAPE_COMP_PAGE);
    eval 'sub TAPE_RETEN_PAGE () {0x20;}' unless defined(&TAPE_RETEN_PAGE);
    eval 'sub TAPE_8MM () {0x1;}' unless defined(&TAPE_8MM);
    eval 'sub TAPE_9TRACK () {0x2;}' unless defined(&TAPE_9TRACK);
    eval 'sub TAPE_QUARTER () {0x3;}' unless defined(&TAPE_QUARTER);
    eval 'sub TAPE_OTHER () {0x4;}' unless defined(&TAPE_OTHER);
    eval 'sub TAPE_8MM5GB () {0x5;}' unless defined(&TAPE_8MM5GB);
    eval 'sub TAPE_QIC525 () {0x6;}' unless defined(&TAPE_QIC525);
    eval 'sub TAPE_QIC1200 () {0x7;}' unless defined(&TAPE_QIC1200);
    eval 'sub TAPE_4MM2GB () {0x8;}' unless defined(&TAPE_4MM2GB);
    eval 'sub TAPE_3490E () {0xa;}' unless defined(&TAPE_3490E);
    eval 'sub TAPE_4MM4GB () {0xb;}' unless defined(&TAPE_4MM4GB);
    eval 'sub TAPE_SCSD () {0xc;}' unless defined(&TAPE_SCSD);
    eval 'sub TAPECMD_BUSY () {0x1;}' unless defined(&TAPECMD_BUSY);
    eval 'sub TAPE_FILEMARK_ERROR () {0x1;}' unless defined(&TAPE_FILEMARK_ERROR);
    eval 'sub TAPE_ENDOFTAPE_ERROR () {0x2;}' unless defined(&TAPE_ENDOFTAPE_ERROR);
    eval 'sub TAPE_BEGOFTAPE_ERROR () {0x4;}' unless defined(&TAPE_BEGOFTAPE_ERROR);
    eval 'sub TAPE_OVERFLOW_ERROR () {0x8;}' unless defined(&TAPE_OVERFLOW_ERROR);
    eval 'sub TAPE_ILI_ERROR () {0x10;}' unless defined(&TAPE_ILI_ERROR);
    eval 'sub TAPE_ENDOFDATA_ERROR () {0x20;}' unless defined(&TAPE_ENDOFDATA_ERROR);
    eval 'sub TAPE_RESET_CMD () {0x1;}' unless defined(&TAPE_RESET_CMD);
    eval 'sub TAPE_REQSENSE_CMD () {0x2;}' unless defined(&TAPE_REQSENSE_CMD);
    eval 'sub TAPE_DIAG_CMD () {0x3;}' unless defined(&TAPE_DIAG_CMD);
    eval 'sub TAPE_OTHER_CMD () {0x4;}' unless defined(&TAPE_OTHER_CMD);
    eval 'sub TAPE_SPECIAL_CMD () {0x5;}' unless defined(&TAPE_SPECIAL_CMD);
    eval 'sub TAPE_DIAGNOSTIC () {0x1;}' unless defined(&TAPE_DIAGNOSTIC);
    eval 'sub TAPE_NORMAL () {0x2;}' unless defined(&TAPE_NORMAL);
    eval 'sub TAPE_TUR () {0x1;}' unless defined(&TAPE_TUR);
    eval 'sub TAPE_LOAD () {0x2;}' unless defined(&TAPE_LOAD);
    eval 'sub TAPE_RESERVE () {0x3;}' unless defined(&TAPE_RESERVE);
    eval 'sub TAPE_RELEASE () {0x4;}' unless defined(&TAPE_RELEASE);
    eval 'sub TAPE_SENSE () {0x5;}' unless defined(&TAPE_SENSE);
    eval 'sub TAPE_SELECT () {0x6;}' unless defined(&TAPE_SELECT);
    eval 'sub TAPE_IO () {0x7;}' unless defined(&TAPE_IO);
    eval 'sub TAPE_IOCTL () {0x8;}' unless defined(&TAPE_IOCTL);
    eval 'sub TAPE_REQ_SENSE () {0x9;}' unless defined(&TAPE_REQ_SENSE);
    eval 'sub TAPE_GENERAL () {0xa;}' unless defined(&TAPE_GENERAL);
    eval 'sub TAPE_SIGNALRCV () {0xb;}' unless defined(&TAPE_SIGNALRCV);
    eval 'sub TAPE_FLAG_OVERLAY () {0x4;}' unless defined(&TAPE_FLAG_OVERLAY);
    eval 'sub TAPE_DUMP_DEVICE () {0x1;}' unless defined(&TAPE_DUMP_DEVICE);
    eval 'sub TAPE_OPENING_DEVICE () {0x2;}' unless defined(&TAPE_OPENING_DEVICE);
    eval 'sub TAPE_READ_ONLY () {0x4;}' unless defined(&TAPE_READ_ONLY);
    eval 'sub TAPE_OFFLINE () {0x8;}' unless defined(&TAPE_OFFLINE);
    eval 'sub TAPE_FILEMARK_DETECT () {0x10;}' unless defined(&TAPE_FILEMARK_DETECT);
    eval 'sub TAPE_ENDOFTAPE_DETECT () {0x20;}' unless defined(&TAPE_ENDOFTAPE_DETECT);
    eval 'sub TAPE_REQSENSE_AVAIL () {0x40;}' unless defined(&TAPE_REQSENSE_AVAIL);
    eval 'sub TAPE_NO_DELAY () {0x80;}' unless defined(&TAPE_NO_DELAY);
    eval 'sub TAPE_LOAD_REQUIRED () {0x1;}' unless defined(&TAPE_LOAD_REQUIRED);
    eval 'sub TAPE_RESET_PARAMS () {0x2;}' unless defined(&TAPE_RESET_PARAMS);
    eval 'sub TAPE_LOADER_READY () {0x4;}' unless defined(&TAPE_LOADER_READY);
    eval 'sub TAPE_SHORTREAD_OK () {0x8;}' unless defined(&TAPE_SHORTREAD_OK);
    eval 'sub TAPE_NOSOFT_CHK () {0x10;}' unless defined(&TAPE_NOSOFT_CHK);
    eval 'sub TAPE_DISABLE_EOF () {0x20;}' unless defined(&TAPE_DISABLE_EOF);
    eval 'sub TAPE_READ_ACTIVE () {0x1;}' unless defined(&TAPE_READ_ACTIVE);
    eval 'sub TAPE_WRITE_ACTIVE () {0x2;}' unless defined(&TAPE_WRITE_ACTIVE);
    eval 'sub TAPE_SENSE_A () {0x;}' unless defined(&TAPE_SENSE_A);
    eval 'sub TAPE_SENSE_B () {0x1;}' unless defined(&TAPE_SENSE_B);
    eval 'sub TAPE_SENSE_C () {0x3;}' unless defined(&TAPE_SENSE_C);
    eval 'sub TAPE_SENSE_D () {0x4;}' unless defined(&TAPE_SENSE_D);
    if(defined(&_POWER_MP)) {
    }
    eval 'sub STIOCTOP_ORG () {0x1;}' unless defined(&STIOCTOP_ORG);
    eval 'sub STIOCTOP_LDT () {0x101;}' unless defined(&STIOCTOP_LDT);
}
1;
