require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_THREAD)) {
    eval 'sub _H_THREAD () {1;}' unless defined(&_H_THREAD);
    require 'sys/types.ph';
    require 'sys/mstsave.ph';
    require 'sys/processor.ph';
    require 'sys/lock_def.ph';
    require 'sys/var.ph';
    require 'sys/atomic_op.ph';
    require 'sys/context.ph';
    require 'sys/time.ph';
    require 'sys/resource.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_LARGE_THREADS)) {
	eval 'sub MAXTHREADS () {32767;}' unless defined(&MAXTHREADS);
    } else {
	eval 'sub MAXTHREADS () {512;}' unless defined(&MAXTHREADS);
    }
    unless(defined(&_32KERMODE)) {
	unless(defined(&__64BIT_KERNEL)) {
	} else {
	}
	eval 'sub T_CPU_MAX () {20+ &HZ;}' unless defined(&T_CPU_MAX);
	if(defined(&__64BIT_KERNEL)) {
	} else {
	}
	eval 'sub TV_VCSIZE () {128;}' unless defined(&TV_VCSIZE);
	if(defined(&__64BIT_KERNEL)) {
	    eval 'sub TV_PAD () {15;}' unless defined(&TV_PAD);
	} else {
	    eval 'sub TV_PAD () {63;}' unless defined(&TV_PAD);
	}
	if((defined(&TV_PAD) ? &TV_PAD : 0)) {
	}
    }
    eval 'sub tv_link () { &tv_prevthread;}' unless defined(&tv_link);
    eval 'sub t_uthreadp () { ($t_uaddress->{uthreadp});}' unless defined(&t_uthreadp);
    eval 'sub t_userp () { ($t_uaddress->{userp});}' unless defined(&t_userp);
    eval 'sub tv_prevthread () { ($tv_threadlist->{prevthread});}' unless defined(&tv_prevthread);
    eval 'sub tv_nextthread () { ($tv_threadlist->{nextthread});}' unless defined(&tv_nextthread);
    eval 'sub TKTHREAD () {0x1000;}' unless defined(&TKTHREAD);
    eval 'sub TCHKCALLER () {0x400;}' unless defined(&TCHKCALLER);
    eval 'sub TTERM () {0x1;}' unless defined(&TTERM);
    eval 'sub TSUSP () {0x2;}' unless defined(&TSUSP);
    eval 'sub TSIGAVAIL () {0x4;}' unless defined(&TSIGAVAIL);
    eval 'sub TINTR () {0x8;}' unless defined(&TINTR);
    eval 'sub TLOCAL () {0x10;}' unless defined(&TLOCAL);
    eval 'sub TTRCSIG () {0x40;}' unless defined(&TTRCSIG);
    eval 'sub TPROCFS () {0x80;}' unless defined(&TPROCFS);
    eval 'sub TOMASK () {0x100;}' unless defined(&TOMASK);
    eval 'sub TWAKEONSIG () {0x400;}' unless defined(&TWAKEONSIG);
    eval 'sub SWAKEONSIG () {0x800;}' unless defined(&SWAKEONSIG);
    eval 'sub TFUNNELLED () {0x2000;}' unless defined(&TFUNNELLED);
    eval 'sub TSETSTATE () {0x4000;}' unless defined(&TSETSTATE);
    eval 'sub TGETREGS () {0x8000;}' unless defined(&TGETREGS);
    eval 'sub TWAKEONCHKPT () {0x10000;}' unless defined(&TWAKEONCHKPT);
    eval 'sub TSIGWAIT () {0x20000;}' unless defined(&TSIGWAIT);
    eval 'sub TPMREQSTOP () {0x40000;}' unless defined(&TPMREQSTOP);
    eval 'sub TPMSTOP () {0x80000;}' unless defined(&TPMSTOP);
    eval 'sub TCANCEL () {0x200000;}' unless defined(&TCANCEL);
    eval 'sub TCDEFER () {0x400000;}' unless defined(&TCDEFER);
    eval 'sub TCDISABLE () {0x800000;}' unless defined(&TCDISABLE);
    eval 'sub TSYNCH () {0x1000000;}' unless defined(&TSYNCH);
    eval 'sub TUSCHED () {0x2000000;}' unless defined(&TUSCHED);
    eval 'sub TLMTSIGS () {0x4000000;}' unless defined(&TLMTSIGS);
    eval 'sub TEVTPROC () {0x8000000;}' unless defined(&TEVTPROC);
    eval 'sub TPTHSUSP () {0x10000000;}' unless defined(&TPTHSUSP);
    eval 'sub TPTHSTOPPED () {0x20000000;}' unless defined(&TPTHSTOPPED);
    eval 'sub TPTHCONT () {0x40000000;}' unless defined(&TPTHCONT);
    eval 'sub TMIGRATE () {0x80000000;}' unless defined(&TMIGRATE);
    eval 'sub TSIGSLIH () {( &TTERM| &TSUSP| &TSIGAVAIL);}' unless defined(&TSIGSLIH);
    eval 'sub TSIGINTR () {( &TSIGSLIH| &TINTR);}' unless defined(&TSIGINTR);
    eval 'sub TSLWTED () {0x20;}' unless defined(&TSLWTED);
    eval 'sub TSIGDELIVERY () {0x80;}' unless defined(&TSIGDELIVERY);
    eval 'sub TSEWTED () {0x200;}' unless defined(&TSEWTED);
    eval 'sub TSELECT () {0x8000;}' unless defined(&TSELECT);
    eval 'sub TWPDABR () {0x10000;}' unless defined(&TWPDABR);
    eval 'sub TWPSYSCALL () {0x20000;}' unless defined(&TWPSYSCALL);
    eval 'sub TSFWTED () {0x100000;}' unless defined(&TSFWTED);
    eval 'sub TCHKERROR () {0x80000000;}' unless defined(&TCHKERROR);
    eval 'sub TUEXEMPT () {0x1;}' unless defined(&TUEXEMPT);
    eval 'sub TTIMESLICE_GRANT () {0x2;}' unless defined(&TTIMESLICE_GRANT);
    eval 'sub TCHKINTR () {0x10;}' unless defined(&TCHKINTR);
    eval 'sub TCHKPNT () {0x20;}' unless defined(&TCHKPNT);
    eval 'sub TCHKPNT_BLOCK () {0x40;}' unless defined(&TCHKPNT_BLOCK);
    eval 'sub TCHKPNT_PROCESS () {0x80;}' unless defined(&TCHKPNT_PROCESS);
    eval 'sub TCHKPNT_SLEEP () {0x100;}' unless defined(&TCHKPNT_SLEEP);
    eval 'sub TCHKPTSTOP () {0x200;}' unless defined(&TCHKPTSTOP);
    eval 'sub TSNONE () {0;}' unless defined(&TSNONE);
    eval 'sub TSIDL () {1;}' unless defined(&TSIDL);
    eval 'sub TSRUN () {2;}' unless defined(&TSRUN);
    eval 'sub TSSLEEP () {3;}' unless defined(&TSSLEEP);
    eval 'sub TSSWAP () {4;}' unless defined(&TSSWAP);
    eval 'sub TSSTOP () {5;}' unless defined(&TSSTOP);
    eval 'sub TSZOMB () {6;}' unless defined(&TSZOMB);
    eval 'sub TNOWAIT () {0;}' unless defined(&TNOWAIT);
    eval 'sub TWEVENT () {1;}' unless defined(&TWEVENT);
    eval 'sub TWLOCK () {2;}' unless defined(&TWLOCK);
    eval 'sub TWTIMER () {3;}' unless defined(&TWTIMER);
    eval 'sub TWCPU () {4;}' unless defined(&TWCPU);
    eval 'sub TWPGIN () {5;}' unless defined(&TWPGIN);
    eval 'sub TWPGOUT () {6;}' unless defined(&TWPGOUT);
    eval 'sub TWPLOCK () {7;}' unless defined(&TWPLOCK);
    eval 'sub TWFREEF () {8;}' unless defined(&TWFREEF);
    eval 'sub TWMEM () {9;}' unless defined(&TWMEM);
    eval 'sub TWLOCKREAD () {10;}' unless defined(&TWLOCKREAD);
    eval 'sub TWUEXCEPT () {11;}' unless defined(&TWUEXCEPT);
    eval 'sub TWZOMB () {12;}' unless defined(&TWZOMB);
    eval 'sub TWLOCK_WX () {13;}' unless defined(&TWLOCK_WX);
    eval 'sub TWVMMWAIT () {14;}' unless defined(&TWVMMWAIT);
    eval 'sub TIDRESERVED () {5;}' unless defined(&TIDRESERVED);
    eval 'sub THREADSHIFT () {19;}' unless defined(&THREADSHIFT);
    eval 'sub TGENSHIFT () {8;}' unless defined(&TGENSHIFT);
    eval 'sub TGENMASK () {((1<< &TGENSHIFT)-1);}' unless defined(&TGENMASK);
    eval 'sub NTHREAD () {(1<< &THREADSHIFT);}' unless defined(&NTHREAD);
    eval 'sub TIDMASK () {(( &NTHREAD-1)<< &TGENSHIFT);}' unless defined(&TIDMASK);
    eval 'sub TSRADSHIFT () {5;}' unless defined(&TSRADSHIFT);
    eval 'sub TIDXSHIFT () {( &THREADSHIFT- &TSRADSHIFT);}' unless defined(&TIDXSHIFT);
    eval 'sub TSRADMASK () {((1<< &TSRADSHIFT)-1);}' unless defined(&TSRADMASK);
    eval 'sub TIDXMASK () {((1<< &TIDXSHIFT)-1);}' unless defined(&TIDXMASK);
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub THREADMASK {
	    my($tid) = @_;
    	    eval q(((($tid) &TIDMASK)>> &TGENSHIFT));
	}' unless defined(&THREADMASK);
    } else {
	eval 'sub THREADMASK {
	    my($tid) = @_;
    	    eval q(((( & ( &TSRADMASK <<  &TGENSHIFT)) << ( &TIDXSHIFT- &TGENSHIFT)) | (($tid) >> ( &TGENSHIFT+ &TSRADSHIFT))));
	}' unless defined(&THREADMASK);
    }
    unless(defined(&__64BIT_KERNEL)) {
	eval 'sub TIDGEN {
	    my($idx) = @_;
    	    eval q((($idx)<< &TGENSHIFT));
	}' unless defined(&TIDGEN);
    } else {
	eval 'sub TIDGEN {
	    my($idx) = @_;
    	    eval q(((((($idx) & ( &TIDXMASK)) << ( &TSRADSHIFT)) | ((($idx) & ( &TSRADMASK<< &TIDXSHIFT)) >>  &TIDXSHIFT)) <<  &TGENSHIFT));
	}' unless defined(&TIDGEN);
    }
    eval 'sub V_ADSP_R () {0x1;}' unless defined(&V_ADSP_R);
    eval 'sub V_ADSP_W () {0x2;}' unless defined(&V_ADSP_W);
    eval 'sub V_ADSP_CS () {0x4;}' unless defined(&V_ADSP_CS);
    eval 'sub MAYBE_TID {
        my($tid) = @_;
	    eval q(($tid & 1));
    }' unless defined(&MAYBE_TID);
    eval 'sub NULL_TID () {0;}' unless defined(&NULL_TID);
    eval 'sub SWAPPER_TID () {3;}' unless defined(&SWAPPER_TID);
    if(defined(&_KERNEL)) {
	eval 'sub PVTHREADPTR {
	    my($tid) = @_;
    	    eval q(( $pvthread[ &THREADMASK($tid)]));
	}' unless defined(&PVTHREADPTR);
	eval 'sub TID_VALIDATE {
	    my($tid) = @_;
    	    eval q((((( &THREADMASK($tid)>> &TIDXSHIFT) >=  &PM_NUMSRAD_ZONES) || ( &PVTHREADPTR($tid) >=   ($pvthread_cb->{persrad_zone})  [ &THREADMASK($tid)>> &TIDXSHIFT]-> &highwater_addr) || ( &PVTHREADPTR($tid)-> &tv_tid != ($tid))) ?  &NULL :  &PVTHREADPTR($tid)));
	}' unless defined(&TID_VALIDATE);
    }
    eval 'sub UL_FREE () {0x;}' unless defined(&UL_FREE);
    eval 'sub UL_BUSY () {0x10000000;}' unless defined(&UL_BUSY);
    eval 'sub UL_WAIT () {0x20000000;}' unless defined(&UL_WAIT);
    eval 'sub UL_WAIT_LOCAL () {0x40000000;}' unless defined(&UL_WAIT_LOCAL);
    eval 'sub UL_INTERLOCK () {0x80000000;}' unless defined(&UL_INTERLOCK);
    eval 'sub UL_MASK () {0xfffffff;}' unless defined(&UL_MASK);
    eval 'sub THREAD_TWAKEUP_ALL () {0;}' unless defined(&THREAD_TWAKEUP_ALL);
    eval 'sub THREAD_TWAKEUP_ONE () {1;}' unless defined(&THREAD_TWAKEUP_ONE);
    eval 'sub TSTATE_LOCAL () {0x1;}' unless defined(&TSTATE_LOCAL);
    eval 'sub TSTATE_CANCEL_DEFER () {0x4;}' unless defined(&TSTATE_CANCEL_DEFER);
    eval 'sub TSTATE_CANCEL_DISABLE () {0x8;}' unless defined(&TSTATE_CANCEL_DISABLE);
    eval 'sub TSTATE_CANCEL_PENDING () {0x10;}' unless defined(&TSTATE_CANCEL_PENDING);
    eval 'sub TSTATE_CANCEL_CHKPT () {0x40;}' unless defined(&TSTATE_CANCEL_CHKPT);
    eval 'sub TSTATE_INTR () {0x2;}' unless defined(&TSTATE_INTR);
    eval 'sub TSTATE_CANCEL_START () { &TSTATE_INTR;}' unless defined(&TSTATE_CANCEL_START);
    eval 'sub TSTATE_EXEMPT () {0x20;}' unless defined(&TSTATE_EXEMPT);
    eval 'sub TSTATE_SUSPEND () {0x100;}' unless defined(&TSTATE_SUSPEND);
    eval 'sub TSTATE_CONT () {0x200;}' unless defined(&TSTATE_CONT);
    eval 'sub TSTATE_RUSG_ON () {0x400;}' unless defined(&TSTATE_RUSG_ON);
    eval 'sub TSTATE_RUSG_OFF () {0x800;}' unless defined(&TSTATE_RUSG_OFF);
    eval 'sub TSTATE_ADVH () {0x1000;}' unless defined(&TSTATE_ADVH);
    eval 'sub TSTATE_SYNCH () {0x2000;}' unless defined(&TSTATE_SYNCH);
    eval 'sub TSTATE_USCHED () {0x4000;}' unless defined(&TSTATE_USCHED);
    eval 'sub TSTATE_DEFAULT_SCHED () {0x8000;}' unless defined(&TSTATE_DEFAULT_SCHED);
    eval 'sub TSTATE_CHANGE_ALL () {0xffff0000;}' unless defined(&TSTATE_CHANGE_ALL);
    eval 'sub TSTATE_CHANGE_ERRNOP () {0x4000000;}' unless defined(&TSTATE_CHANGE_ERRNOP);
    eval 'sub TSTATE_CHANGE_SIGMASK () {0x8000000;}' unless defined(&TSTATE_CHANGE_SIGMASK);
    eval 'sub TSTATE_CHANGE_PSIG () {0x10000000;}' unless defined(&TSTATE_CHANGE_PSIG);
    eval 'sub TSTATE_CHANGE_SCHED () {0x20000000;}' unless defined(&TSTATE_CHANGE_SCHED);
    eval 'sub TSTATE_CHANGE_FLAGS () {0x40000000;}' unless defined(&TSTATE_CHANGE_FLAGS);
    eval 'sub TSTATE_CHANGE_USERDATA () {0x80000000;}' unless defined(&TSTATE_CHANGE_USERDATA);
    eval 'sub THREAD_WAIT_OK () {0;}' unless defined(&THREAD_WAIT_OK);
    eval 'sub THREAD_WAIT_TIMEDOUT () {1;}' unless defined(&THREAD_WAIT_TIMEDOUT);
    eval 'sub THREAD_WAIT_ERROR () {-1;}' unless defined(&THREAD_WAIT_ERROR);
    eval 'sub MAX_POSTED_THREADS () {512;}' unless defined(&MAX_POSTED_THREADS);
    if(defined( &__64BIT__)  && !defined( &__64BIT_KERNEL) ) {
	if(defined( &_KERNEL)) {
	} else {
	}
    } else {
	if(defined(&__ia64)) {
	} else {
	    if(defined( &_KERNEL)  && defined( &__64BIT_KERNEL)) {
	    } else {
	    }
	}
	if(defined(&_KERNEL)) {
	} else {
	}
	if(defined( &_KERNEL)) {
	} else {
	}
    }
    if(defined(&_KERNSYS)) {
	if(defined( &_KERNEL)) {
	} else {
	}
    }
    unless(defined(&errno)) {
    }
    if(defined(&_NO_PROTO)) {
	if(defined(&_KERNEL)) {
	}
	if(defined(&_KERNSYS)) {
	}
    } else {
	if(defined(&_KERNEL)) {
	}
	if(defined(&_KERNEL)) {
	    if(defined(&__64BIT_KERNEL)) {
	    } else {
	    }
	} else {
	}
	if(defined(&_KERNEL)) {
	} else {
	}
	if(defined(&_KERNSYS)) {
	    if(defined(&__64BIT__)) {
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
