require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_TOKUSER)) {
    eval 'sub _H_TOKUSER () {1;}' unless defined(&_H_TOKUSER);
    require 'sys/intr.ph';
    eval 'sub TOK_PREFIX () {( &TOK_DRIVER << 16);}' unless defined(&TOK_PREFIX);
    eval 'sub TOK_MAX_ADAPTERS () {(8);}' unless defined(&TOK_MAX_ADAPTERS);
    eval 'sub TOK_MAX_OPENS () {(6);}' unless defined(&TOK_MAX_OPENS);
    eval 'sub TOK_NADR_LENGTH () {(6);}' unless defined(&TOK_NADR_LENGTH);
    eval 'sub TOK_MIN_PACKET () {(16);}' unless defined(&TOK_MIN_PACKET);
    eval 'sub TOK_16M_MAX_PACKET () {(17800);}' unless defined(&TOK_16M_MAX_PACKET);
    eval 'sub TOK_4M_MAX_PACKET () {(4472);}' unless defined(&TOK_4M_MAX_PACKET);
    eval 'sub TOK_MAX_GATHERS () {(6);}' unless defined(&TOK_MAX_GATHERS);
    eval 'sub TOK_MAX_NETIDS () {(257);}' unless defined(&TOK_MAX_NETIDS);
    eval 'sub TOK_MAC_FRAME_NETID () {( &TOK_MAX_NETIDS - 1);}' unless defined(&TOK_MAC_FRAME_NETID);
    eval 'sub TOK_READ () {(121);}' unless defined(&TOK_READ);
    eval 'sub TOK_WRITE () {(122);}' unless defined(&TOK_WRITE);
    eval 'sub TOK_4M () {(0x);}' unless defined(&TOK_4M);
    eval 'sub TOK_16M () {(0x1);}' unless defined(&TOK_16M);
    eval 'sub TOK_ADD () {(0x81);}' unless defined(&TOK_ADD);
    eval 'sub TOK_DEL () {(0x82);}' unless defined(&TOK_DEL);
    eval 'sub TOK_OPLEVEL () {( &INTOFFL2);}' unless defined(&TOK_OPLEVEL);
    eval 'sub TOK_GRP_ADDR () {( &CIO_IOCTL | 0x103);}' unless defined(&TOK_GRP_ADDR);
    eval 'sub TOK_FUNC_ADDR () {( &CIO_IOCTL | 0x104);}' unless defined(&TOK_FUNC_ADDR);
    eval 'sub TOK_QVPD () {( &CIO_IOCTL | 0x105);}' unless defined(&TOK_QVPD);
    eval 'sub TOK_ACCESS_POS () {( &CIO_IOCTL | 0x107);}' unless defined(&TOK_ACCESS_POS);
    eval 'sub TOK_SET_ADAP_IPARMS () {( &CIO_IOCTL | 0x108);}' unless defined(&TOK_SET_ADAP_IPARMS);
    eval 'sub TOK_SET_OPEN_PARMS () {( &CIO_IOCTL | 0x109);}' unless defined(&TOK_SET_OPEN_PARMS);
    eval 'sub TOK_RING_INFO () {( &CIO_IOCTL | 0x113);}' unless defined(&TOK_RING_INFO);
    eval 'sub TOK_DOWNLOAD_UCODE () {( &CIO_IOCTL | 0x114);}' unless defined(&TOK_DOWNLOAD_UCODE);
    eval 'sub TOK_VPD_VALID () {0x;}' unless defined(&TOK_VPD_VALID);
    eval 'sub TOK_VPD_NOT_READ () {0x1;}' unless defined(&TOK_VPD_NOT_READ);
    eval 'sub TOK_VPD_INVALID () {0x2;}' unless defined(&TOK_VPD_INVALID);
    eval 'sub TOK_VPD_LENGTH () {0x67;}' unless defined(&TOK_VPD_LENGTH);
    eval 'sub TOK_RING_INFO_SIZE () {(0x44);}' unless defined(&TOK_RING_INFO_SIZE);
    eval 'sub TOK_ADAP_INIT_PARMS_FAIL () {( &TOK_PREFIX | 0x8830);}' unless defined(&TOK_ADAP_INIT_PARMS_FAIL);
    eval 'sub TOK_ADAP_INIT_FAIL () {( &TOK_PREFIX | 0x8842);}' unless defined(&TOK_ADAP_INIT_FAIL);
    eval 'sub TOK_ADAP_INIT_TIMEOUT () {( &TOK_PREFIX | 0x8832);}' unless defined(&TOK_ADAP_INIT_TIMEOUT);
    eval 'sub TOK_LOBE_MEDIA_TST_FAIL () {( &TOK_PREFIX | 0x4210);}' unless defined(&TOK_LOBE_MEDIA_TST_FAIL);
    eval 'sub TOK_PHYS_INSERT () {( &TOK_PREFIX | 0x4220);}' unless defined(&TOK_PHYS_INSERT);
    eval 'sub TOK_ADDR_VERIFY_FAIL () {( &TOK_PREFIX | 0x4230);}' unless defined(&TOK_ADDR_VERIFY_FAIL);
    eval 'sub TOK_RING_POLL () {( &TOK_PREFIX | 0x4240);}' unless defined(&TOK_RING_POLL);
    eval 'sub TOK_REQ_PARMS () {( &TOK_PREFIX | 0x4250);}' unless defined(&TOK_REQ_PARMS);
    eval 'sub TOK_ADAP_CONFIG () {( &TOK_PREFIX | 0x4260);}' unless defined(&TOK_ADAP_CONFIG);
    eval 'sub TOK_NO_GROUP () {( &TOK_PREFIX | 0x210);}' unless defined(&TOK_NO_GROUP);
    eval 'sub TOK_NO_POS () {( &TOK_PREFIX | 0x220);}' unless defined(&TOK_NO_POS);
    eval 'sub TOK_NO_PARMS () {( &TOK_PREFIX | 0x550);}' unless defined(&TOK_NO_PARMS);
    eval 'sub TOK_NO_RING_INFO () {( &TOK_PREFIX | 0x660);}' unless defined(&TOK_NO_RING_INFO);
    eval 'sub TOK_NOT_DIAG_MODE () {( &TOK_PREFIX | 0xd000);}' unless defined(&TOK_NOT_DIAG_MODE);
    eval 'sub TOK_NO_DOWNLOAD () {( &TOK_PREFIX | 0xd001);}' unless defined(&TOK_NO_DOWNLOAD);
    eval 'sub TOK_BAD_UCODE_LEVEL () {( &TOK_PREFIX | 0xd003);}' unless defined(&TOK_BAD_UCODE_LEVEL);
    eval 'sub TOK_LOADER_FAIL () {( &TOK_PREFIX | 0xd004);}' unless defined(&TOK_LOADER_FAIL);
    eval 'sub TOK_UCODE_FAIL () {( &TOK_PREFIX | 0xd005);}' unless defined(&TOK_UCODE_FAIL);
    eval 'sub TOK_BAD_RANGE () {( &CIO_BAD_RANGE);}' unless defined(&TOK_BAD_RANGE);
    eval 'sub TOK_INV_CMD () {( &CIO_INV_CMD);}' unless defined(&TOK_INV_CMD);
    eval 'sub TOK_LOBE_WIRE_FAULT () {( &TOK_PREFIX | 0x800);}' unless defined(&TOK_LOBE_WIRE_FAULT);
    eval 'sub TOK_AUTO_REMOVE () {( &TOK_PREFIX | 0x400);}' unless defined(&TOK_AUTO_REMOVE);
    eval 'sub TOK_ADAP_CHECK () {( &TOK_PREFIX | 0x102);}' unless defined(&TOK_ADAP_CHECK);
    eval 'sub TOK_RING_STATUS () {( &TOK_PREFIX | 0x104);}' unless defined(&TOK_RING_STATUS);
    eval 'sub TOK_IMPL_FORCE () {( &TOK_PREFIX | 0x108);}' unless defined(&TOK_IMPL_FORCE);
    eval 'sub TOK_CMD_FAIL () {( &TOK_PREFIX | 0x110);}' unless defined(&TOK_CMD_FAIL);
    eval 'sub TOK_SIGNAL_LOSS () {( &TOK_PREFIX | 0x112);}' unless defined(&TOK_SIGNAL_LOSS);
    eval 'sub TOK_REMOVED_RECEIVED () {( &TOK_PREFIX | 0x114);}' unless defined(&TOK_REMOVED_RECEIVED);
    eval 'sub TOK_TX_ERROR () {( &TOK_PREFIX | 0x118);}' unless defined(&TOK_TX_ERROR);
    eval 'sub TOK_PIO_FAIL () {( &TOK_PREFIX | 0x200);}' unless defined(&TOK_PIO_FAIL);
    eval 'sub TOK_RCVRY_THRESH () {( &TOK_PREFIX | 0x202);}' unless defined(&TOK_RCVRY_THRESH);
    eval 'sub TOK_MC_ERROR () {( &TOK_PREFIX | 0x204);}' unless defined(&TOK_MC_ERROR);
    eval 'sub TOK_RING_BEACONING () {( &TOK_PREFIX | 0x208);}' unless defined(&TOK_RING_BEACONING);
    eval 'sub TOK_RING_RECOVERED () {( &TOK_PREFIX | 0x212);}' unless defined(&TOK_RING_RECOVERED);
    eval 'sub AC_PRIORITY () {0xe0;}' unless defined(&AC_PRIORITY);
    eval 'sub AC_TOK () {0x10;}' unless defined(&AC_TOK);
    eval 'sub AC_MONITOR () {0x80;}' unless defined(&AC_MONITOR);
    eval 'sub AC_RES () {0x7;}' unless defined(&AC_RES);
    eval 'sub FC_TYPE () {0xc0;}' unless defined(&FC_TYPE);
    eval 'sub MAC_TYPE () {0x;}' unless defined(&MAC_TYPE);
    eval 'sub LLC_TYPE () {0x40;}' unless defined(&LLC_TYPE);
    eval 'sub FC_CONTROL () {0x3f;}' unless defined(&FC_CONTROL);
    eval 'sub MAC_DAT () {0x;}' unless defined(&MAC_DAT);
    eval 'sub MAC_BCN () {0x2;}' unless defined(&MAC_BCN);
    eval 'sub MAC_CL_TK () {0x3;}' unless defined(&MAC_CL_TK);
    eval 'sub MAC_PRG () {0x4;}' unless defined(&MAC_PRG);
    eval 'sub MAC_AMP () {0x5;}' unless defined(&MAC_AMP);
    eval 'sub MAC_SMP () {0x6;}' unless defined(&MAC_SMP);
    eval 'sub PIO_86A0 () {0x86a0;}' unless defined(&PIO_86A0);
    eval 'sub PIO_96A0 () {0x96a0;}' unless defined(&PIO_96A0);
    eval 'sub PIO_A6A0 () {0xa6a0;}' unless defined(&PIO_A6A0);
    eval 'sub PIO_B6A0 () {0xb6a0;}' unless defined(&PIO_B6A0);
    eval 'sub PIO_C6A0 () {0xc6a0;}' unless defined(&PIO_C6A0);
    eval 'sub PIO_D6A0 () {0xd6a0;}' unless defined(&PIO_D6A0);
    eval 'sub PIO_E6A0 () {0xe6a0;}' unless defined(&PIO_E6A0);
    eval 'sub PIO_F6A0 () {0xf6a0;}' unless defined(&PIO_F6A0);
}
1;
