require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_TRCCTL)) {
    eval 'sub _H_TRCCTL () {1;}' unless defined(&_H_TRCCTL);
    require 'sys/systemcfg.ph';
    eval 'sub TRCIOC () {(ord(\'C\')<<8);}' unless defined(&TRCIOC);
    eval 'sub CFGMTRL () {( &TRCIOC|0x1);}' unless defined(&CFGMTRL);
    eval 'sub CFGMTRA () {( &TRCIOC|0x2);}' unless defined(&CFGMTRA);
    eval 'sub CFGMTRF () {( &TRCIOC|0x3);}' unless defined(&CFGMTRF);
    eval 'sub CFGBTR () {( &TRCIOC|0x4);}' unless defined(&CFGBTR);
    eval 'sub TRCSYNC () {( &TRCIOC|0x7);}' unless defined(&TRCSYNC);
    eval 'sub TRCON () {( &TRCIOC|0x8);}' unless defined(&TRCON);
    eval 'sub TRCOFF () {( &TRCIOC|0x9);}' unless defined(&TRCOFF);
    eval 'sub TRCSTOP () {( &TRCIOC|0xa);}' unless defined(&TRCSTOP);
    eval 'sub TRCSTAT () {( &TRCIOC|0xb);}' unless defined(&TRCSTAT);
    eval 'sub TRC_LOADER () {( &TRCIOC|0xc);}' unless defined(&TRC_LOADER);
    eval 'sub TRCIOC_CLOSE () {( &TRCIOC|0xd);}' unless defined(&TRCIOC_CLOSE);
    eval 'sub TRCIOC_LOGCFG () {( &TRCIOC|0xe);}' unless defined(&TRCIOC_LOGCFG);
    eval 'sub TRCIOC_LOGIO () {( &TRCIOC|0xf);}' unless defined(&TRCIOC_LOGIO);
    eval 'sub UTRCPRINT () {( &TRCIOC|0x10);}' unless defined(&UTRCPRINT);
    eval 'sub UTRCPANIC () {( &TRCIOC|0x11);}' unless defined(&UTRCPANIC);
    eval 'sub UTRCSNAPINFO () {( &TRCIOC|0x14);}' unless defined(&UTRCSNAPINFO);
    eval 'sub UTRCSNAPCTL () {( &TRCIOC|0x17);}' unless defined(&UTRCSNAPCTL);
    eval 'sub UTRCCALIB () {( &TRCIOC|0x18);}' unless defined(&UTRCCALIB);
    eval 'sub UTRCHDR () {( &TRCIOC|0x19);}' unless defined(&UTRCHDR);
    eval 'sub TRCIACTIVE () {( &TRCIOC|0x20);}' unless defined(&TRCIACTIVE);
    eval 'sub MDEV_SYSTRACE () {0;}' unless defined(&MDEV_SYSTRACE);
    eval 'sub MDEV_SYSTRCTL () {1;}' unless defined(&MDEV_SYSTRCTL);
    eval 'sub MDEV_SYSMEM () {2;}' unless defined(&MDEV_SYSMEM);
    eval 'sub MDEV_SYSUTIL () {3;}' unless defined(&MDEV_SYSUTIL);
    eval 'sub MDEV_SYSNULL () {4;}' unless defined(&MDEV_SYSNULL);
    eval 'sub MDEV_SYSTRACE1 () {5;}' unless defined(&MDEV_SYSTRACE1);
    eval 'sub MDEV_SYSTRACE2 () {6;}' unless defined(&MDEV_SYSTRACE2);
    eval 'sub MDEV_SYSTRACE3 () {7;}' unless defined(&MDEV_SYSTRACE3);
    eval 'sub MDEV_SYSTRCTL1 () {8;}' unless defined(&MDEV_SYSTRCTL1);
    eval 'sub MDEV_SYSTRCTL2 () {9;}' unless defined(&MDEV_SYSTRCTL2);
    eval 'sub MDEV_SYSTRCTL3 () {10;}' unless defined(&MDEV_SYSTRCTL3);
    eval 'sub MDEV_SYSTRACE4 () {11;}' unless defined(&MDEV_SYSTRACE4);
    eval 'sub MDEV_SYSTRACE5 () {12;}' unless defined(&MDEV_SYSTRACE5);
    eval 'sub MDEV_SYSTRACE6 () {13;}' unless defined(&MDEV_SYSTRACE6);
    eval 'sub MDEV_SYSTRACE7 () {14;}' unless defined(&MDEV_SYSTRACE7);
    eval 'sub MDEV_SYSTRCTL4 () {15;}' unless defined(&MDEV_SYSTRCTL4);
    eval 'sub MDEV_SYSTRCTL5 () {16;}' unless defined(&MDEV_SYSTRCTL5);
    eval 'sub MDEV_SYSTRCTL6 () {17;}' unless defined(&MDEV_SYSTRCTL6);
    eval 'sub MDEV_SYSTRCTL7 () {18;}' unless defined(&MDEV_SYSTRCTL7);
    eval 'sub __TRC_SYSCPUS () { ($_system_configuration->{ncpus});}' unless defined(&__TRC_SYSCPUS);
    eval 'sub __TRC_MAXCPUS () {1024;}' unless defined(&__TRC_MAXCPUS);
    eval 'sub __TRC_CPUBYTES () {( &__TRC_MAXCPUS/8);}' unless defined(&__TRC_CPUBYTES);
    eval 'sub __TRCBUF_MINSIZE () {8192;}' unless defined(&__TRCBUF_MINSIZE);
    eval 'sub ALLOC_HEAP () {0x1;}' unless defined(&ALLOC_HEAP);
    eval 'sub ALLOC_SEG () {0x2;}' unless defined(&ALLOC_SEG);
    eval 'sub ALLOC_MULTICPU () {0x4;}' unless defined(&ALLOC_MULTICPU);
    eval 'sub INSERT_CPUID () {0x8;}' unless defined(&INSERT_CPUID);
    unless(defined(&__ia64)) {
	eval 'sub CPUS_ID {
	    my($n) = @_;
    	    eval q((($n)/8));
	}' unless defined(&CPUS_ID);
	eval 'sub CPUS_BIT {
	    my($n) = @_;
    	    eval q((0x80 >> (($n)%8)));
	}' unless defined(&CPUS_BIT);
	eval 'sub ISCPU {
	    my($map, $n) = @_;
    	    eval q(($map->[ &CPUS_ID($n)] &  &CPUS_BIT($n)));
	}' unless defined(&ISCPU);
	eval 'sub SETCPU {
	    my($map, $n) = @_;
    	    eval q($map->[ &CPUS_ID($n)] |=  &CPUS_BIT($n));
	}' unless defined(&SETCPU);
    } else {
	eval 'sub CPUS_ID {
	    my($n) = @_;
    	    eval q((($n)/32));
	}' unless defined(&CPUS_ID);
	eval 'sub CPUS_BIT {
	    my($n) = @_;
    	    eval q((0x80000000 >> (($n)%32)));
	}' unless defined(&CPUS_BIT);
	eval 'sub ISCPU {
	    my($map, $n) = @_;
    	    eval q((($map)[ &CPUS_ID($n)] &  &CPUS_BIT($n)));
	}' unless defined(&ISCPU);
	eval 'sub SETCPU {
	    my($map, $n) = @_;
    	    eval q(($map)[ &CPUS_ID($n)] |=  &CPUS_BIT($n));
	}' unless defined(&SETCPU);
    }
    eval 'sub TRC_NLV () {100;}' unless defined(&TRC_NLV);
    eval 'sub TRC_TBUFUMAX () {(1024* 1024);}' unless defined(&TRC_TBUFUMAX);
}
1;
