require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_TRCMACROS)) {
    eval 'sub _H_TRCMACROS () {1;}' unless defined(&_H_TRCMACROS);
    require 'sys/types.ph';
    eval 'sub HKWD64_TMASK () {9.22337203685478e+18;}' unless defined(&HKWD64_TMASK);
    eval 'sub HKWD64_GMASK () {4.61168601842739e+18;}' unless defined(&HKWD64_GMASK);
    eval 'sub HKWD64_BMASK () {2.30584300921369e+18;}' unless defined(&HKWD64_BMASK);
    eval 'sub HKWD64_PMASK () {1.15292150460685e+18;}' unless defined(&HKWD64_PMASK);
    eval 'sub HKWD64_FLAGMASK () {1.84464625987328e+19;}' unless defined(&HKWD64_FLAGMASK);
    eval 'sub HKWD64_VALIDFLAGMASK () {1.72938225691027e+19;}' unless defined(&HKWD64_VALIDFLAGMASK);
    eval 'sub HKWD64_LENMASK () {281470681743360;}' unless defined(&HKWD64_LENMASK);
    eval 'sub ISTIMESTAMPED64 {
        my($hkwd) = @_;
	    eval q((($hkwd) &  &HKWD64_TMASK));
    }' unless defined(&ISTIMESTAMPED64);
    eval 'sub HKWD64_NONGEN_MAXLEN () {5*8;}' unless defined(&HKWD64_NONGEN_MAXLEN);
    eval 'sub HKWD64_HOOKMASK () {0xffff0000;}' unless defined(&HKWD64_HOOKMASK);
    eval 'sub HKWD64_SUBHKMASK () {0xffff;}' unless defined(&HKWD64_SUBHKMASK);
    eval 'sub HKWD64_HOOKSMASK () {0xffffffff;}' unless defined(&HKWD64_HOOKSMASK);
    eval 'sub HKWD64_HOOKSMASK12 () {0xfff0ffff;}' unless defined(&HKWD64_HOOKSMASK12);
    eval 'sub HKWD64_TO_HOOKID {
        my($h) = @_;
	    eval q((($h) &  &HKWD64_HOOKMASK));
    }' unless defined(&HKWD64_TO_HOOKID);
    eval 'sub HKWD64_TO_HKID {
        my($h) = @_;
	    eval q(((($h) &  &HKWD64_HOOKMASK) >> 20));
    }' unless defined(&HKWD64_TO_HKID);
    eval 'sub HKWD64_TO_LEN {
        my($h) = @_;
	    eval q(((($h) &  &HKWD64_LENMASK) >> 32));
    }' unless defined(&HKWD64_TO_LEN);
    eval 'sub HKWD64_TO_SUBHOOK {
        my($h) = @_;
	    eval q(((($h) &  &HKWD64_SUBHKMASK)));
    }' unless defined(&HKWD64_TO_SUBHOOK);
    eval 'sub HKWD64_VALIDHOOKMASK () {( &HKWD64_VALIDFLAGMASK |  &HKWD64_LENMASK |  &HKWD64_HOOKSMASK);}' unless defined(&HKWD64_VALIDHOOKMASK);
    eval 'sub HKWD64_VALIDHOOKMASK12 () {( &HKWD64_VALIDFLAGMASK |  &HKWD64_LENMASK |  &HKWD64_HOOKSMASK12);}' unless defined(&HKWD64_VALIDHOOKMASK12);
    eval 'sub HKWD64_EXPAND {
        my($h,$len) = @_;
	    eval q((( | (($len) << 32)) &  &HKWD64_VALIDHOOKMASK));
    }' unless defined(&HKWD64_EXPAND);
    eval 'sub HKWD64_EXPAND12 {
        my($h,$len) = @_;
	    eval q((( | (($len) << 32)) &  &HKWD64_VALIDHOOKMASK12));
    }' unless defined(&HKWD64_EXPAND12);
    unless(defined(&__ia64)) {
    } else {
    }
    eval 'sub HKID_MASK () {0xfff00000;}' unless defined(&HKID_MASK);
    eval 'sub HKTY_XMASK () {0xfff0ffff;}' unless defined(&HKTY_XMASK);
    eval 'sub HKTY_TMASK () {0x80000;}' unless defined(&HKTY_TMASK);
    eval 'sub HKTY_Vr () {0x;}' unless defined(&HKTY_Vr);
    eval 'sub HKTY_Sr () {0x1;}' unless defined(&HKTY_Sr);
    eval 'sub HKTY_Lr () {0x2;}' unless defined(&HKTY_Lr);
    eval 'sub HKTY_Gr () {0x6;}' unless defined(&HKTY_Gr);
    eval 'sub HKTY_VTr () {0x8;}' unless defined(&HKTY_VTr);
    eval 'sub HKTY_STr () {0x9;}' unless defined(&HKTY_STr);
    eval 'sub HKTY_LTr () {0xa;}' unless defined(&HKTY_LTr);
    eval 'sub HKTY_GTr () {0xe;}' unless defined(&HKTY_GTr);
    eval 'sub HKTY_V () {( &HKTY_Vr << 16);}' unless defined(&HKTY_V);
    eval 'sub HKTY_S () {( &HKTY_Sr << 16);}' unless defined(&HKTY_S);
    eval 'sub HKTY_L () {( &HKTY_Lr << 16);}' unless defined(&HKTY_L);
    eval 'sub HKTY_G () {( &HKTY_Gr << 16);}' unless defined(&HKTY_G);
    eval 'sub HKTY_VT () {( &HKTY_VTr << 16);}' unless defined(&HKTY_VT);
    eval 'sub HKTY_ST () {( &HKTY_STr << 16);}' unless defined(&HKTY_ST);
    eval 'sub HKTY_LT () {( &HKTY_LTr << 16);}' unless defined(&HKTY_LT);
    eval 'sub HKTY_GT () {( &HKTY_GTr << 16);}' unless defined(&HKTY_GT);
    eval 'sub HKTY_LAST () {( &HKTY_GTr << 16);}' unless defined(&HKTY_LAST);
    eval 'sub HKWDTOMAJOR {
        my($hw) = @_;
	    eval q(((($hw) >> 24) & 0xff));
    }' unless defined(&HKWDTOMAJOR);
    eval 'sub HKWDTOHKID {
        my($hw) = @_;
	    eval q(((($hw) >> 20) & 0xfff));
    }' unless defined(&HKWDTOHKID);
    eval 'sub HKWDTOTYPE {
        my($hw) = @_;
	    eval q(((($hw) >> 16) & 0xf));
    }' unless defined(&HKWDTOTYPE);
    eval 'sub HKWDTOLEN {
        my($hw) = @_;
	    eval q(((($hw) >> 16) & 0x7));
    }' unless defined(&HKWDTOLEN);
    eval 'sub HKWDTOWLEN {
        my($hw) = @_;
	    eval q((((($hw) & 0xffff) + 3) / 4));
    }' unless defined(&HKWDTOWLEN);
    eval 'sub HKWDTOBLEN {
        my($hw) = @_;
	    eval q((($hw) & 0xffff));
    }' unless defined(&HKWDTOBLEN);
    eval 'sub ISTIMESTAMPED {
        my($hw) = @_;
	    eval q((($hw) & 0x80000));
    }' unless defined(&ISTIMESTAMPED);
    eval 'sub __TRCHI64 {
        my($d) = @_;
	    eval q(($d >> 32));
    }' unless defined(&__TRCHI64);
    eval 'sub __TRCLOW64 {
        my($d) = @_;
	    eval q(($d & 0xffffffff));
    }' unless defined(&__TRCLOW64);
    eval 'sub _TRCTMASK {
        my($hw) = @_;
	    eval q((($hw) &  &HKTY_XMASK));
    }' unless defined(&_TRCTMASK);
    unless(defined(&TRC_NCHANNELS)) {
	eval 'sub TRC_NCHANNELS () {8;}' unless defined(&TRC_NCHANNELS);
    }
    eval 'sub TRC_ISON {
        my($chan) = @_;
	    eval q(( $Trconflag[($chan)]));
    }' unless defined(&TRC_ISON);
    if(defined(&_KERNEL)) {
	if(defined(&__64BIT_KERNEL)) {
	    eval 'sub __TRCHOOK () { &trchook64;}' unless defined(&__TRCHOOK);
	} else {
	    eval 'sub __TRCHOOK () { &trchook;}' unless defined(&__TRCHOOK);
	}
	if(defined( &__64BIT_KERNEL) || defined( &__FULL_PROTO)) {
	} else {
	}
	if(defined(&__64BIT_KERNEL)) {
	    eval 'sub TRCHKL0 {
	        my($hw) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,0),0,0,0,0,0) : ( &void) 0));
	    }' unless defined(&TRCHKL0);
	    eval 'sub TRCHKL0T {
	        my($hw) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,0) |  &HKWD64_TMASK ,0,0,0,0,0) : ( &void) 0));
	    }' unless defined(&TRCHKL0T);
	    eval 'sub TRCHKL1 {
	        my($hw,$a) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,8), ($a), 0,0,0,0) : ( &void) 0));
	    }' unless defined(&TRCHKL1);
	    eval 'sub TRCHKL1T {
	        my($hw,$a) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,8) |  &HKWD64_TMASK, ($a), 0,0,0,0) : ( &void) 0));
	    }' unless defined(&TRCHKL1T);
	    eval 'sub TRCHKL2 {
	        my($hw,$a,$b) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,16), , ($b), 0, 0, 0) : ( &void) 0));
	    }' unless defined(&TRCHKL2);
	    eval 'sub TRCHKL2T {
	        my($hw,$a,$b) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,16) |  &HKWD64_TMASK, , ($b), 0, 0, 0) : ( &void) 0));
	    }' unless defined(&TRCHKL2T);
	    eval 'sub TRCHKL3 {
	        my($hw,$a,$b,$c) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,24), , , ($c), 0, 0) : ( &void) 0));
	    }' unless defined(&TRCHKL3);
	    eval 'sub TRCHKL3T {
	        my($hw,$a,$b,$c) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,24) |  &HKWD64_TMASK, , , ($c), 0, 0) : ( &void) 0));
	    }' unless defined(&TRCHKL3T);
	    eval 'sub TRCHKL4 {
	        my($hw,$a,$b,$c,$d) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,32), , , , ($d), 0) : ( &void) 0));
	    }' unless defined(&TRCHKL4);
	    eval 'sub TRCHKL4T {
	        my($hw,$a,$b,$c,$d) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,32) |  &HKWD64_TMASK, , , , ($d), 0) : ( &void) 0));
	    }' unless defined(&TRCHKL4T);
	    eval 'sub TRCHKL5 {
	        my($hw,$a,$b,$c,$d,$e) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,40), , , , , ($e)) : ( &void) 0));
	    }' unless defined(&TRCHKL5);
	    eval 'sub TRCHKL5T {
	        my($hw,$a,$b,$c,$d,$e) = @_;
    		eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &HKWD64_EXPAND($hw,40) |  &HKWD64_TMASK, , , , , ($e)) : ( &void) 0));
	    }' unless defined(&TRCHKL5T);
	    eval 'sub TRCGEN {
	        my($ch,$hw,$d1,$len,$buf) = @_;
    		eval q(( &TRC_ISON($ch) ? ( &void)  &trcgenk(, , , ($len), ( &void *)($buf)) : ( &void) 0));
	    }' unless defined(&TRCGEN);
	    eval 'sub TRCGENT {
	        my($ch,$hw,$d1,$len,$buf) = @_;
    		eval q(( &TRC_ISON($ch) ? ( &void)  &trcgenkt(, , , ($len), ( &void *)($buf)) : ( &void) 0));
	    }' unless defined(&TRCGENT);
	} else {
	    if(defined(&__FULL_PROTO)) {
		eval 'sub TRCHK {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK(( &_TRCTMASK($hw)| &HKTY_S), 0,0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHK);
		eval 'sub TRCHKT {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK(( &_TRCTMASK($hw)| &HKTY_ST), 0,0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKT);
		eval 'sub TRCHKL {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK(( &_TRCTMASK| &HKTY_L), ($a), 0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKL);
		eval 'sub TRCHKLT {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK(( &_TRCTMASK| &HKTY_LT), ($a), 0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKLT);
		eval 'sub TRCHKG {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK(( &_TRCTMASK| &HKTY_G), , , , , ($e)) : ( &void) 0));
		}' unless defined(&TRCHKG);
		eval 'sub TRCHKGT {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK(( &_TRCTMASK| &HKTY_GT), , , , , ($e)) : ( &void) 0));
		}' unless defined(&TRCHKGT);
		eval 'sub TRCGEN {
		    my($ch,$hw,$d1,$len,$buf) = @_;
    		    eval q(( &TRC_ISON($ch) ? ( &void)  &trcgenk(, , , ($len), ( &void *)($buf)) : ( &void) 0));
		}' unless defined(&TRCGEN);
		eval 'sub TRCGENT {
		    my($ch,$hw,$d1,$len,$buf) = @_;
    		    eval q(( &TRC_ISON($ch) ? ( &void)  &trcgenkt(, , , ($len), ( &void *)($buf)) : ( &void) 0));
		}' unless defined(&TRCGENT);
	    } else {
		eval 'sub TRCHK {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &_TRCTMASK($hw)| &HKTY_S) : ( &void) 0));
		}' unless defined(&TRCHK);
		eval 'sub TRCHKT {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &_TRCTMASK($hw)| &HKTY_ST) : ( &void) 0));
		}' unless defined(&TRCHKT);
		eval 'sub TRCHKL {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &_TRCTMASK($hw)| &HKTY_L,$a) : ( &void) 0));
		}' unless defined(&TRCHKL);
		eval 'sub TRCHKLT {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &_TRCTMASK($hw)| &HKTY_LT,$a) : ( &void) 0));
		}' unless defined(&TRCHKLT);
		eval 'sub TRCHKG {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &_TRCTMASK($hw)| &HKTY_G,$a,$b,$c,$d,$e) : ( &void) 0));
		}' unless defined(&TRCHKG);
		eval 'sub TRCHKGT {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__TRCHOOK( &_TRCTMASK($hw)| &HKTY_GT,$a,$b,$c,$d,$e) : ( &void) 0));
		}' unless defined(&TRCHKGT);
		eval 'sub TRCGEN {
		    my($ch,$hw,$d1,$len,$buf) = @_;
    		    eval q(( &TRC_ISON($ch) ? ( &void)  &trcgenk($ch,$hw,$d1,$len,$buf) : ( &void) 0));
		}' unless defined(&TRCGEN);
		eval 'sub TRCGENT {
		    my($ch,$hw,$d1,$len,$buf) = @_;
    		    eval q(( &TRC_ISON($ch) ? ( &void)  &trcgenkt($ch,$hw,$d1,$len,$buf) : ( &void) 0));
		}' unless defined(&TRCGENT);
	    }
	}
	eval 'sub TRCGENK {
	    my($a,$b,$c,$d,$e) = @_;
    	    eval q( &TRCGEN($a,$b,$c,$d,$e));
	}' unless defined(&TRCGENK);
	eval 'sub TRCGENKT {
	    my($a,$b,$c,$d,$e) = @_;
    	    eval q( &TRCGENT($a,$b,$c,$d,$e));
	}' unless defined(&TRCGENKT);
	eval 'sub TRCHKT_SYSC {
	    my($x) = @_;
    	    eval q( &TRCHKT( &HKWD_SYSC_$x));
	}' unless defined(&TRCHKT_SYSC);
	eval 'sub TRCHKLT_SYSC {
	    my($x,$a) = @_;
    	    eval q( &TRCHKLT( &HKWD_SYSC_$x,$a));
	}' unless defined(&TRCHKLT_SYSC);
	eval 'sub TRCHKGT_SYSC {
	    my($x,$a,$b,$c,$d,$e) = @_;
    	    eval q( &TRCHKGT( &HKWD_SYSC_$x,$a,$b,$c,$d,$e));
	}' unless defined(&TRCHKGT_SYSC);
    } else {
	if(defined(&__64BIT__)) {
	    eval 'sub __UTRCHOOK () { &utrchook64;}' unless defined(&__UTRCHOOK);
	} else {
	    eval 'sub __UTRCHOOK () { &utrchook;}' unless defined(&__UTRCHOOK);
	}
	eval 'sub __TRCGENCALL () { &trcgen;}' unless defined(&__TRCGENCALL);
	eval 'sub __TRCGENTCALL () { &trcgent;}' unless defined(&__TRCGENTCALL);
	if(defined(&_NO_PROTO)) {
	} else {
	    if(defined(&__64BIT__)) {
	    } else {
	    }
	}
	if(defined(&__64BIT__)) {
	    if(defined(&_NO_PROTO)) {
		eval 'sub TRCHKL0 {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,0)) : ( &void) 0));
		}' unless defined(&TRCHKL0);
		eval 'sub TRCHKL0T {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,0) |  &HKWD64_TMASK) : ( &void) 0));
		}' unless defined(&TRCHKL0T);
		eval 'sub TRCHKL1 {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,8), $a) : ( &void) 0));
		}' unless defined(&TRCHKL1);
		eval 'sub TRCHKL1T {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,8) |  &HKWD64_TMASK, $a) : ( &void) 0));
		}' unless defined(&TRCHKL1T);
		eval 'sub TRCHKL2 {
		    my($hw,$a,$b) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,16), $a, $b) : ( &void) 0));
		}' unless defined(&TRCHKL2);
		eval 'sub TRCHKL2T {
		    my($hw,$a,$b) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,16) |  &HKWD64_TMASK, $a, $b) : ( &void) 0));
		}' unless defined(&TRCHKL2T);
		eval 'sub TRCHKL3 {
		    my($hw,$a,$b,$c) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,24), $a, $b, $c) : ( &void) 0));
		}' unless defined(&TRCHKL3);
		eval 'sub TRCHKL3T {
		    my($hw,$a,$b,$c) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,24) |  &HKWD64_TMASK, $a, $b, $c) : ( &void) 0));
		}' unless defined(&TRCHKL3T);
		eval 'sub TRCHKL4 {
		    my($hw,$a,$b,$c,$d) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,32), $a, $b, $c, $d) : ( &void) 0));
		}' unless defined(&TRCHKL4);
		eval 'sub TRCHKL4T {
		    my($hw,$a,$b,$c,$d) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,32) |  &HKWD64_TMASK, $a, $b, $c, $d) : ( &void) 0));
		}' unless defined(&TRCHKL4T);
		eval 'sub TRCHKL5 {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,40), $a, $b, $c, $d, $e) : ( &void) 0));
		}' unless defined(&TRCHKL5);
		eval 'sub TRCHKL5T {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,40) |  &HKWD64_TMASK, $a, $b, $c, $d, $e) : ( &void) 0));
		}' unless defined(&TRCHKL5T);
	    } else {
		eval 'sub TRCHKL0 {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,0),0,0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKL0);
		eval 'sub TRCHKL0T {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,0) |  &HKWD64_TMASK ,0,0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKL0T);
		eval 'sub TRCHKL1 {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,8), ($a), 0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKL1);
		eval 'sub TRCHKL1T {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,8) |  &HKWD64_TMASK, ($a), 0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKL1T);
		eval 'sub TRCHKL2 {
		    my($hw,$a,$b) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,16), , ($b), 0, 0, 0) : ( &void) 0));
		}' unless defined(&TRCHKL2);
		eval 'sub TRCHKL2T {
		    my($hw,$a,$b) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,16) |  &HKWD64_TMASK, , ($b), 0, 0, 0) : ( &void) 0));
		}' unless defined(&TRCHKL2T);
		eval 'sub TRCHKL3 {
		    my($hw,$a,$b,$c) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,24), , , ($c), 0, 0) : ( &void) 0));
		}' unless defined(&TRCHKL3);
		eval 'sub TRCHKL3T {
		    my($hw,$a,$b,$c) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,24) |  &HKWD64_TMASK, , , ($c), 0, 0) : ( &void) 0));
		}' unless defined(&TRCHKL3T);
		eval 'sub TRCHKL4 {
		    my($hw,$a,$b,$c,$d) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,32), , , , ($d), 0) : ( &void) 0));
		}' unless defined(&TRCHKL4);
		eval 'sub TRCHKL4T {
		    my($hw,$a,$b,$c,$d) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,32) |  &HKWD64_TMASK, , , , ($d), 0) : ( &void) 0));
		}' unless defined(&TRCHKL4T);
		eval 'sub TRCHKL5 {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,40), , , , , ($e)) : ( &void) 0));
		}' unless defined(&TRCHKL5);
		eval 'sub TRCHKL5T {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &HKWD64_EXPAND($hw,40) |  &HKWD64_TMASK, , , , , ($e)) : ( &void) 0));
		}' unless defined(&TRCHKL5T);
	    }
	    eval 'sub TRCGEN {
	        my($ch,$hw,$d1,$len,$buf) = @_;
    		eval q(( &TRC_ISON($ch) ? ( &void)  &__TRCGENCALL(, ($hw |  &HKWD64_GMASK), , , ($buf)) : ( &void) 0));
	    }' unless defined(&TRCGEN);
	    eval 'sub TRCGENT {
	        my($ch,$hw,$d1,$len,$buf) = @_;
    		eval q(( &TRC_ISON($ch) ? ( &void)  &__TRCGENTCALL(, ($hw |  &HKWD64_GMASK), , , ($buf)) : ( &void) 0));
	    }' unless defined(&TRCGENT);
	} else {
	    if(defined(&_NO_PROTO)) {
		eval 'sub TRCHK {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_S) : ( &void) 0));
		}' unless defined(&TRCHK);
		eval 'sub TRCHKT {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_ST) : ( &void) 0));
		}' unless defined(&TRCHKT);
		eval 'sub TRCHKL {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_L,$a) : ( &void) 0));
		}' unless defined(&TRCHKL);
		eval 'sub TRCHKLT {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_LT,$a) : ( &void) 0));
		}' unless defined(&TRCHKLT);
		eval 'sub TRCHKG {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_G,$a,$b,$c,$d,$e) : ( &void) 0));
		}' unless defined(&TRCHKG);
		eval 'sub TRCHKGT {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_GT,$a,$b,$c,$d,$e) : ( &void) 0));
		}' unless defined(&TRCHKGT);
	    } else {
		eval 'sub TRCHK {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_S,0,0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHK);
		eval 'sub TRCHKT {
		    my($hw) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void) &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_ST,0,0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKT);
		eval 'sub TRCHKL {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_L, $a, 0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKL);
		eval 'sub TRCHKLT {
		    my($hw,$a) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_LT, $a, 0,0,0,0) : ( &void) 0));
		}' unless defined(&TRCHKLT);
		eval 'sub TRCHKG {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_G, $a, $b, $c, $d, $e) : ( &void) 0));
		}' unless defined(&TRCHKG);
		eval 'sub TRCHKGT {
		    my($hw,$a,$b,$c,$d,$e) = @_;
    		    eval q(( &TRC_ISON(0) ? ( &void)  &__UTRCHOOK( &_TRCTMASK($hw)| &HKTY_GT, $a, $b, $c, $d, $e) : ( &void) 0));
		}' unless defined(&TRCHKGT);
	    }
	    eval 'sub TRCGEN {
	        my($ch,$hw,$d1,$len,$buf) = @_;
    		eval q(( &TRC_ISON($ch) ? ( &void)  &__TRCGENCALL($ch,$hw,$d1,$len,$buf) : ( &void) 0));
	    }' unless defined(&TRCGEN);
	    eval 'sub TRCGENT {
	        my($ch,$hw,$d1,$len,$buf) = @_;
    		eval q(( &TRC_ISON($ch) ? ( &void)  &__TRCGENTCALL($ch,$hw,$d1,$len,$buf) : ( &void) 0));
	    }' unless defined(&TRCGENT);
	}
    }
    unless(defined(&__64BIT__)) {
	eval 'sub TRCHKL0 {
	    my($hw) = @_;
    	    eval q( &TRCHK($hw));
	}' unless defined(&TRCHKL0);
	eval 'sub TRCHKL1 {
	    my($hw,$D1) = @_;
    	    eval q( &TRCHKL($hw,$D1));
	}' unless defined(&TRCHKL1);
	eval 'sub TRCHKL2 {
	    my($hw,$D1,$D2) = @_;
    	    eval q( &TRCHKG($hw,$D1,$D2,0,0,0));
	}' unless defined(&TRCHKL2);
	eval 'sub TRCHKL3 {
	    my($hw,$D1,$D2,$D3) = @_;
    	    eval q( &TRCHKG($hw,$D1,$D2,$D3,0,0));
	}' unless defined(&TRCHKL3);
	eval 'sub TRCHKL4 {
	    my($hw,$D1,$D2,$D3,$D4) = @_;
    	    eval q( &TRCHKG($hw,$D1,$D2,$D3,$D4,0));
	}' unless defined(&TRCHKL4);
	eval 'sub TRCHKL5 {
	    my($hw,$D1,$D2,$D3,$D4,$D5) = @_;
    	    eval q( &TRCHKG($hw,$D1,$D2,$D3,$D4,$D5));
	}' unless defined(&TRCHKL5);
	eval 'sub TRCHKL0T {
	    my($hw) = @_;
    	    eval q( &TRCHKT($hw));
	}' unless defined(&TRCHKL0T);
	eval 'sub TRCHKL1T {
	    my($hw,$D1) = @_;
    	    eval q( &TRCHKLT($hw,$D1));
	}' unless defined(&TRCHKL1T);
	eval 'sub TRCHKL2T {
	    my($hw,$D1,$D2) = @_;
    	    eval q( &TRCHKGT($hw,$D1,$D2,0,0,0));
	}' unless defined(&TRCHKL2T);
	eval 'sub TRCHKL3T {
	    my($hw,$D1,$D2,$D3) = @_;
    	    eval q( &TRCHKGT($hw,$D1,$D2,$D3,0,0));
	}' unless defined(&TRCHKL3T);
	eval 'sub TRCHKL4T {
	    my($hw,$D1,$D2,$D3,$D4) = @_;
    	    eval q( &TRCHKGT($hw,$D1,$D2,$D3,$D4,0));
	}' unless defined(&TRCHKL4T);
	eval 'sub TRCHKL5T {
	    my($hw,$D1,$D2,$D3,$D4,$D5) = @_;
    	    eval q( &TRCHKGT($hw,$D1,$D2,$D3,$D4,$D5));
	}' unless defined(&TRCHKL5T);
    } else {
	eval 'sub TRCHK {
	    my($hw) = @_;
    	    eval q( &TRCHKL0($hw));
	}' unless defined(&TRCHK);
	eval 'sub TRCHKL {
	    my($hw,$a) = @_;
    	    eval q( &TRCHKL1($hw, $a));
	}' unless defined(&TRCHKL);
	eval 'sub TRCHKG {
	    my($hw,$a,$b,$c,$d,$e) = @_;
    	    eval q( &TRCHKL5($hw, $a, $b, $c, $d, $e));
	}' unless defined(&TRCHKG);
	eval 'sub TRCHKT {
	    my($hw) = @_;
    	    eval q( &TRCHKL0T($hw));
	}' unless defined(&TRCHKT);
	eval 'sub TRCHKLT {
	    my($hw,$a) = @_;
    	    eval q( &TRCHKL1T($hw, $a));
	}' unless defined(&TRCHKLT);
	eval 'sub TRCHKGT {
	    my($hw,$a,$b,$c,$d,$e) = @_;
    	    eval q( &TRCHKL5T($hw, $a, $b, $c, $d, $e));
	}' unless defined(&TRCHKGT);
    }
    if(defined(&__64BIT__)) {
	eval 'sub TRCHK64L1 {
	    my($hw,$d1) = @_;
    	    eval q( &TRCHKL1($hw, $d1));
	}' unless defined(&TRCHK64L1);
	eval 'sub TRCHK64L2 {
	    my($hw,$d1,$d2) = @_;
    	    eval q( &TRCHKL2($hw, $d1, $d2));
	}' unless defined(&TRCHK64L2);
	eval 'sub TRCHK64L1T {
	    my($hw,$d1) = @_;
    	    eval q( &TRCHKL1T($hw, $d1));
	}' unless defined(&TRCHK64L1T);
	eval 'sub TRCHK64L2T {
	    my($hw,$d1,$d2) = @_;
    	    eval q( &TRCHKL2T($hw, $d1, $d2));
	}' unless defined(&TRCHK64L2T);
    } else {
	eval 'sub TRCHK64L1 {
	    my($hw,$d1) = @_;
    	    eval q( &TRCHKG($hw, &__TRCHI64($d1), &__TRCLOW64($d1),0,0,0));
	}' unless defined(&TRCHK64L1);
	eval 'sub TRCHK64L2 {
	    my($hw,$d1,$d2) = @_;
    	    eval q( &TRCHKG($hw, &__TRCHI64($d1), &__TRCLOW64($d1),  &__TRCHI64($d2), &__TRCLOW64($d2),0));
	}' unless defined(&TRCHK64L2);
	eval 'sub TRCHK64L1T {
	    my($hw,$d1) = @_;
    	    eval q( &TRCHKGT($hw, &__TRCHI64($d1), &__TRCLOW64($d1),0,0,0));
	}' unless defined(&TRCHK64L1T);
	eval 'sub TRCHK64L2T {
	    my($hw,$d1,$d2) = @_;
    	    eval q( &TRCHKGT($hw, &__TRCHI64($d1), &__TRCLOW64($d1),  &__TRCHI64($d2), &__TRCLOW64($d2),0));
	}' unless defined(&TRCHK64L2T);
    }
    unless(defined(&__RASLIBRTN)) {
	eval 'sub trchk {
	    my($hw) = @_;
    	    eval q( &TRCHK($hw));
	}' unless defined(&trchk);
	eval 'sub trchkt {
	    my($hw) = @_;
    	    eval q( &TRCHKT($hw));
	}' unless defined(&trchkt);
	eval 'sub trchkl {
	    my($hw,$a) = @_;
    	    eval q( &TRCHKL($hw,$a));
	}' unless defined(&trchkl);
	eval 'sub trchklt {
	    my($hw,$a) = @_;
    	    eval q( &TRCHKLT($hw,$a));
	}' unless defined(&trchklt);
	eval 'sub trchkg {
	    my($hw,$a,$b,$c,$d,$e) = @_;
    	    eval q( &TRCHKG($hw,$a,$b,$c,$d,$e));
	}' unless defined(&trchkg);
	eval 'sub trchkgt {
	    my($hw,$a,$b,$c,$d,$e) = @_;
    	    eval q( &TRCHKGT($hw,$a,$b,$c,$d,$e));
	}' unless defined(&trchkgt);
    }
}
1;
