require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RPC_CLNT_H)) {
    eval 'sub _RPC_CLNT_H () {1;}' unless defined(&_RPC_CLNT_H);
    require 'rpc/rpc_com.ph';
    require 'rpc/clnt_stat.ph';
    require 'sys/types.ph';
    require 'netconfig.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub IS_UNRECOVERABLE_RPC {
        my($s) = @_;
	    eval q(((($s) ==  &RPC_AUTHERROR) || (($s) ==  &RPC_CANTENCODEARGS) || (($s) ==  &RPC_CANTDECODERES) || (($s) ==  &RPC_VERSMISMATCH) || (($s) ==  &RPC_PROCUNAVAIL) || (($s) ==  &RPC_PROGUNAVAIL) || (($s) ==  &RPC_PROGVERSMISMATCH) || (($s) ==  &RPC_CANTDECODEARGS)));
    }' unless defined(&IS_UNRECOVERABLE_RPC);
    eval 'sub re_errno () { ($ru->{RE_err}->{RE_errno});}' unless defined(&re_errno);
    eval 'sub re_terrno () { ($ru->{RE_err}->{RE_t_errno});}' unless defined(&re_terrno);
    eval 'sub re_why () { ($ru->{RE_why});}' unless defined(&re_why);
    eval 'sub re_vers () { ($ru->{RE_vers});}' unless defined(&re_vers);
    eval 'sub re_lb () { ($ru->{RE_lb});}' unless defined(&re_lb);
    unless(defined(&__64BIT__)) {
    } else {
    }
    eval 'sub FEEDBACK_REXMIT1 () {1;}' unless defined(&FEEDBACK_REXMIT1);
    eval 'sub FEEDBACK_OK () {2;}' unless defined(&FEEDBACK_OK);
    eval 'sub CLCR_SET_LOWVERS () {3;}' unless defined(&CLCR_SET_LOWVERS);
    eval 'sub CLCR_GET_LOWVERS () {4;}' unless defined(&CLCR_GET_LOWVERS);
    eval 'sub RPCSMALLMSGSIZE () {400;}' unless defined(&RPCSMALLMSGSIZE);
    eval 'sub CLNT_CALL {
        my($rh, $proc, $xargs, $argsp, $xres, $resp, $secs) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_call}))($rh, $proc, $xargs, $argsp, $xres, $resp, $secs)));
    }' unless defined(&CLNT_CALL);
    eval 'sub clnt_call {
        my($rh, $proc, $xargs, $argsp, $xres, $resp, $secs) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_call}))($rh, $proc, $xargs, $argsp, $xres, $resp, $secs)));
    }' unless defined(&clnt_call);
    eval 'sub CLNT_ABORT {
        my($rh) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_abort}))($rh)));
    }' unless defined(&CLNT_ABORT);
    eval 'sub clnt_abort {
        my($rh) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_abort}))($rh)));
    }' unless defined(&clnt_abort);
    eval 'sub CLNT_GETERR {
        my($rh, $errp) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_geterr}))($rh, $errp)));
    }' unless defined(&CLNT_GETERR);
    eval 'sub clnt_geterr {
        my($rh, $errp) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_geterr}))($rh, $errp)));
    }' unless defined(&clnt_geterr);
    eval 'sub CLNT_FREERES {
        my($rh, $xres, $resp) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_freeres}))($rh, $xres, $resp)));
    }' unless defined(&CLNT_FREERES);
    eval 'sub clnt_freeres {
        my($rh, $xres, $resp) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_freeres}))($rh, $xres, $resp)));
    }' unless defined(&clnt_freeres);
    eval 'sub CLNT_CONTROL {
        my($cl, $rq, $in) = @_;
	    eval q(((*($cl)-> ($cl_ops->{cl_control}))($cl, $rq, $in)));
    }' unless defined(&CLNT_CONTROL);
    eval 'sub clnt_control {
        my($cl, $rq, $in) = @_;
	    eval q(((*($cl)-> ($cl_ops->{cl_control}))($cl, $rq, $in)));
    }' unless defined(&clnt_control);
    eval 'sub CLSET_TIMEOUT () {1;}' unless defined(&CLSET_TIMEOUT);
    eval 'sub CLGET_TIMEOUT () {2;}' unless defined(&CLGET_TIMEOUT);
    eval 'sub CLGET_SERVER_ADDR () {3;}' unless defined(&CLGET_SERVER_ADDR);
    eval 'sub CLGET_FD () {6;}' unless defined(&CLGET_FD);
    eval 'sub CLGET_SVC_ADDR () {7;}' unless defined(&CLGET_SVC_ADDR);
    eval 'sub CLSET_FD_CLOSE () {8;}' unless defined(&CLSET_FD_CLOSE);
    eval 'sub CLSET_FD_NCLOSE () {9;}' unless defined(&CLSET_FD_NCLOSE);
    eval 'sub CLGET_XID () {10;}' unless defined(&CLGET_XID);
    eval 'sub CLSET_XID () {11;}' unless defined(&CLSET_XID);
    eval 'sub CLGET_VERS () {12;}' unless defined(&CLGET_VERS);
    eval 'sub CLSET_VERS () {13;}' unless defined(&CLSET_VERS);
    eval 'sub CLGET_PROG () {14;}' unless defined(&CLGET_PROG);
    eval 'sub CLSET_PROG () {15;}' unless defined(&CLSET_PROG);
    eval 'sub CLSET_SVC_ADDR () {16;}' unless defined(&CLSET_SVC_ADDR);
    eval 'sub CLSET_PUSH_TIMOD () {17;}' unless defined(&CLSET_PUSH_TIMOD);
    eval 'sub CLSET_POP_TIMOD () {18;}' unless defined(&CLSET_POP_TIMOD);
    eval 'sub CLSET_RETRY_TIMEOUT () {4;}' unless defined(&CLSET_RETRY_TIMEOUT);
    eval 'sub CLGET_RETRY_TIMEOUT () {5;}' unless defined(&CLGET_RETRY_TIMEOUT);
    eval 'sub CLNT_SETTIMERS {
        my($rh, $t, $all, $min, $fdbck, $arg, $xid) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_settimers}))($rh, $t, $all, $min, $fdbck, $arg, $xid)));
    }' unless defined(&CLNT_SETTIMERS);
    eval 'sub clnt_settimers {
        my($rh, $t, $all, $min, $fdbck, $arg, $xid) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_settimers}))($rh, $t, $all, $min, $fdbck, $arg, $xid)));
    }' unless defined(&clnt_settimers);
    eval 'sub CLNT_DESTROY {
        my($rh) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_destroy}))($rh)));
    }' unless defined(&CLNT_DESTROY);
    eval 'sub clnt_destroy {
        my($rh) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_destroy}))($rh)));
    }' unless defined(&clnt_destroy);
    eval 'sub RPCTEST_PROGRAM () {(1);}' unless defined(&RPCTEST_PROGRAM);
    eval 'sub RPCTEST_VERSION () {(1);}' unless defined(&RPCTEST_VERSION);
    eval 'sub RPCTEST_NULL_PROC () {(2);}' unless defined(&RPCTEST_NULL_PROC);
    eval 'sub RPCTEST_NULL_BATCH_PROC () {(3);}' unless defined(&RPCTEST_NULL_BATCH_PROC);
    eval 'sub NULLPROC () {(0);}' unless defined(&NULLPROC);
    if(defined(&_REENTRANT)) {
	eval 'sub rpc_createerr () {(*( &__rpc_createerr()));}' unless defined(&rpc_createerr);
    } else {
    }
    if(defined(&_REENTRANT)) {
	eval 'sub rpc_callerr () {(*( &__rpc_callerr()));}' unless defined(&rpc_callerr);
    } else {
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&PORTMAP)) {
	require 'rpc/clnt_soc.ph';
    }
}
1;
