require '_h2ph_pre.ph';

no warnings 'redefine';

require 'rpc/rpc.ph';
unless(defined(&PROOT)) {
    sub PROOT () {	3;}
}
unless(defined(&HEXMODULUS)) {
    sub HEXMODULUS () {	"d4a0ba0250b6fd2ec626e7efd637df76c716e22d0944b88b";}
}
unless(defined(&HEXKEYBYTES)) {
    sub HEXKEYBYTES () {	48;}
}
unless(defined(&KEYSIZE)) {
    sub KEYSIZE () {	192;}
}
unless(defined(&KEYBYTES)) {
    sub KEYBYTES () {	24;}
}
unless(defined(&KEYCHECKSUMSIZE)) {
    sub KEYCHECKSUMSIZE () {	16;}
}
eval("sub KEY_SUCCESS () { 0; }") unless defined(&KEY_SUCCESS);
eval("sub KEY_NOSECRET () { 1; }") unless defined(&KEY_NOSECRET);
eval("sub KEY_UNKNOWN () { 2; }") unless defined(&KEY_UNKNOWN);
eval("sub KEY_SYSTEMERR () { 3; }") unless defined(&KEY_SYSTEMERR);
unless(defined(&MAXGIDS)) {
    sub MAXGIDS () {	16;}
}
unless(defined(&opaque)) {
    eval 'sub opaque () {\'char\';}' unless defined(&opaque);
}
unless(defined(&KEY_PROG)) {
    sub KEY_PROG () {	(100029);}
}
unless(defined(&KEY_VERS)) {
    sub KEY_VERS () {	(1);}
}
unless(defined(&KEY_SET)) {
    sub KEY_SET () {	(1);}
}
unless(defined(&KEY_ENCRYPT)) {
    sub KEY_ENCRYPT () {	(2);}
}
unless(defined(&KEY_DECRYPT)) {
    sub KEY_DECRYPT () {	(3);}
}
unless(defined(&KEY_GEN)) {
    sub KEY_GEN () {	(4);}
}
unless(defined(&KEY_GETCRED)) {
    sub KEY_GETCRED () {	(5);}
}
unless(defined(&KEY_VERS2)) {
    sub KEY_VERS2 () {	(2);}
}
unless(defined(&KEY_ENCRYPT_PK)) {
    sub KEY_ENCRYPT_PK () {	(6);}
}
unless(defined(&KEY_DECRYPT_PK)) {
    sub KEY_DECRYPT_PK () {	(7);}
}
unless(defined(&KEY_NET_PUT)) {
    sub KEY_NET_PUT () {	(8);}
}
unless(defined(&KEY_NET_GET)) {
    sub KEY_NET_GET () {	(9);}
}
unless(defined(&KEY_GET_CONV)) {
    sub KEY_GET_CONV () {	(10);}
}
1;
