require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_H_WCHAR)) {
    eval 'sub _H_WCHAR () {1;}' unless defined(&_H_WCHAR);
    unless(defined(&_H_STANDARDS)) {
	require 'standards.ph';
    }
    unless(defined(&_H_TYPES)) {
	require 'sys/types.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&_XOPEN_SOURCE)) {
	unless(defined(&_H_STDIO)) {
	    require 'stdio.ph';
	}
	unless(defined(&_H_TIME)) {
	    require 'time.ph';
	}
	unless(defined(&WEOF)) {
	    eval 'sub WEOF () {(-1);}' unless defined(&WEOF);
	}
	unless(defined(&NULL)) {
	    eval 'sub NULL () {(0);}' unless defined(&NULL);
	}
	if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) == 500) {
	    if(defined(&__64BIT__)) {
		eval 'sub WCHAR_MAX () { &UINT_MAX;}' unless defined(&WCHAR_MAX);
	    } else {
		eval 'sub WCHAR_MAX () {(65535);}' unless defined(&WCHAR_MAX);
	    }
	    eval 'sub WCHAR_MIN () {(0);}' unless defined(&WCHAR_MIN);
	}
	if(defined(&_NO_PROTO)) {
	    if((!(defined( &__H_CTYPE)  && defined( &_ILS_MACROS)))) {
	    }
	    if(defined(&_THREAD_SAFE)) {
	    }
	} else {
	    if((!(defined( &__H_CTYPE)  && defined( &_ILS_MACROS)))) {
	    }
	    if(((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) == 500)) {
	    } else {
	    }
	    if(((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) == 500)  && !defined( &_UNIX95)) {
	    } else {
	    }
	    if(((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) == 500)  && !defined( &_UNIX95)) {
	    } else {
	    }
	    if(defined(&_THREAD_SAFE)) {
	    }
	    if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) == 500) {
		if(defined(&_VA_LIST)) {
		} else {
		    eval 'sub _HIDDEN_VA_LIST () {1;}' unless defined(&_HIDDEN_VA_LIST);
		    require 'va_list.ph';
		}
	    }
	}
    }
    if(defined(&_ALL_SOURCE)) {
	eval 'sub getwchar () {
	    eval q( &getwc( &stdin));
	}' unless defined(&getwchar);
	if(defined(&_NO_PROTO)) {
	} else {
	    if(defined(&_VA_LIST)) {
	    } else {
		eval 'sub _HIDDEN_VA_LIST () {1;}' unless defined(&_HIDDEN_VA_LIST);
		require 'va_list.ph';
	    }
	}
	unless(defined(&__ia64)) {
	    eval 'sub wstrcat () { &NCstrcat;}' unless defined(&wstrcat);
	    eval 'sub wstrlen () { &NCstrlen;}' unless defined(&wstrlen);
	    eval 'sub wstrdup () { &NCstrdup;}' unless defined(&wstrdup);
	    eval 'sub wstrncat () { &NCstrncat;}' unless defined(&wstrncat);
	    eval 'sub wstrcmp () { &NCstrcmp;}' unless defined(&wstrcmp);
	    eval 'sub wstrncmp () { &NCstrncmp;}' unless defined(&wstrncmp);
	    eval 'sub wstrcpy () { &NCstrcpy;}' unless defined(&wstrcpy);
	    eval 'sub wstrncpy () { &NCstrncpy;}' unless defined(&wstrncpy);
	}
    }
    if((defined( &_LONG_LONG)  && defined( &_ALL_SOURCE))) {
	if(defined(&_NO_PROTO)) {
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
