require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__glxext_h_)) {
    eval 'sub __glxext_h_ () {1;}' unless defined(&__glxext_h_);
    if(defined(&__cplusplus)) {
    }
    if(defined( &_WIN32)  && !defined( &APIENTRY)  && !defined( &__CYGWIN__)) {
	eval 'sub WIN32_LEAN_AND_MEAN () {1;}' unless defined(&WIN32_LEAN_AND_MEAN);
	require 'windows.ph';
    }
    unless(defined(&APIENTRY)) {
	eval 'sub APIENTRY () {1;}' unless defined(&APIENTRY);
    }
    unless(defined(&GLAPI)) {
	eval 'sub GLAPI () { &extern;}' unless defined(&GLAPI);
    }
    eval 'sub GLX_GLXEXT_VERSION () {5;}' unless defined(&GLX_GLXEXT_VERSION);
    unless(defined(&GLX_VERSION_1_3)) {
	eval 'sub GLX_WINDOW_BIT () {0x1;}' unless defined(&GLX_WINDOW_BIT);
	eval 'sub GLX_PIXMAP_BIT () {0x2;}' unless defined(&GLX_PIXMAP_BIT);
	eval 'sub GLX_PBUFFER_BIT () {0x4;}' unless defined(&GLX_PBUFFER_BIT);
	eval 'sub GLX_RGBA_BIT () {0x1;}' unless defined(&GLX_RGBA_BIT);
	eval 'sub GLX_COLOR_INDEX_BIT () {0x2;}' unless defined(&GLX_COLOR_INDEX_BIT);
	eval 'sub GLX_PBUFFER_CLOBBER_MASK () {0x8000000;}' unless defined(&GLX_PBUFFER_CLOBBER_MASK);
	eval 'sub GLX_FRONT_LEFT_BUFFER_BIT () {0x1;}' unless defined(&GLX_FRONT_LEFT_BUFFER_BIT);
	eval 'sub GLX_FRONT_RIGHT_BUFFER_BIT () {0x2;}' unless defined(&GLX_FRONT_RIGHT_BUFFER_BIT);
	eval 'sub GLX_BACK_LEFT_BUFFER_BIT () {0x4;}' unless defined(&GLX_BACK_LEFT_BUFFER_BIT);
	eval 'sub GLX_BACK_RIGHT_BUFFER_BIT () {0x8;}' unless defined(&GLX_BACK_RIGHT_BUFFER_BIT);
	eval 'sub GLX_AUX_BUFFERS_BIT () {0x10;}' unless defined(&GLX_AUX_BUFFERS_BIT);
	eval 'sub GLX_DEPTH_BUFFER_BIT () {0x20;}' unless defined(&GLX_DEPTH_BUFFER_BIT);
	eval 'sub GLX_STENCIL_BUFFER_BIT () {0x40;}' unless defined(&GLX_STENCIL_BUFFER_BIT);
	eval 'sub GLX_ACCUM_BUFFER_BIT () {0x80;}' unless defined(&GLX_ACCUM_BUFFER_BIT);
	eval 'sub GLX_CONFIG_CAVEAT () {0x20;}' unless defined(&GLX_CONFIG_CAVEAT);
	eval 'sub GLX_X_VISUAL_TYPE () {0x22;}' unless defined(&GLX_X_VISUAL_TYPE);
	eval 'sub GLX_TRANSPARENT_TYPE () {0x23;}' unless defined(&GLX_TRANSPARENT_TYPE);
	eval 'sub GLX_TRANSPARENT_INDEX_VALUE () {0x24;}' unless defined(&GLX_TRANSPARENT_INDEX_VALUE);
	eval 'sub GLX_TRANSPARENT_RED_VALUE () {0x25;}' unless defined(&GLX_TRANSPARENT_RED_VALUE);
	eval 'sub GLX_TRANSPARENT_GREEN_VALUE () {0x26;}' unless defined(&GLX_TRANSPARENT_GREEN_VALUE);
	eval 'sub GLX_TRANSPARENT_BLUE_VALUE () {0x27;}' unless defined(&GLX_TRANSPARENT_BLUE_VALUE);
	eval 'sub GLX_TRANSPARENT_ALPHA_VALUE () {0x28;}' unless defined(&GLX_TRANSPARENT_ALPHA_VALUE);
	eval 'sub GLX_DONT_CARE () {0xffffffff;}' unless defined(&GLX_DONT_CARE);
	eval 'sub GLX_NONE () {0x8000;}' unless defined(&GLX_NONE);
	eval 'sub GLX_SLOW_CONFIG () {0x8001;}' unless defined(&GLX_SLOW_CONFIG);
	eval 'sub GLX_TRUE_COLOR () {0x8002;}' unless defined(&GLX_TRUE_COLOR);
	eval 'sub GLX_DIRECT_COLOR () {0x8003;}' unless defined(&GLX_DIRECT_COLOR);
	eval 'sub GLX_PSEUDO_COLOR () {0x8004;}' unless defined(&GLX_PSEUDO_COLOR);
	eval 'sub GLX_STATIC_COLOR () {0x8005;}' unless defined(&GLX_STATIC_COLOR);
	eval 'sub GLX_GRAY_SCALE () {0x8006;}' unless defined(&GLX_GRAY_SCALE);
	eval 'sub GLX_STATIC_GRAY () {0x8007;}' unless defined(&GLX_STATIC_GRAY);
	eval 'sub GLX_TRANSPARENT_RGB () {0x8008;}' unless defined(&GLX_TRANSPARENT_RGB);
	eval 'sub GLX_TRANSPARENT_INDEX () {0x8009;}' unless defined(&GLX_TRANSPARENT_INDEX);
	eval 'sub GLX_VISUAL_ID () {0x800b;}' unless defined(&GLX_VISUAL_ID);
	eval 'sub GLX_SCREEN () {0x800c;}' unless defined(&GLX_SCREEN);
	eval 'sub GLX_NON_CONFORMANT_CONFIG () {0x800d;}' unless defined(&GLX_NON_CONFORMANT_CONFIG);
	eval 'sub GLX_DRAWABLE_TYPE () {0x8010;}' unless defined(&GLX_DRAWABLE_TYPE);
	eval 'sub GLX_RENDER_TYPE () {0x8011;}' unless defined(&GLX_RENDER_TYPE);
	eval 'sub GLX_X_RENDERABLE () {0x8012;}' unless defined(&GLX_X_RENDERABLE);
	eval 'sub GLX_FBCONFIG_ID () {0x8013;}' unless defined(&GLX_FBCONFIG_ID);
	eval 'sub GLX_RGBA_TYPE () {0x8014;}' unless defined(&GLX_RGBA_TYPE);
	eval 'sub GLX_COLOR_INDEX_TYPE () {0x8015;}' unless defined(&GLX_COLOR_INDEX_TYPE);
	eval 'sub GLX_MAX_PBUFFER_WIDTH () {0x8016;}' unless defined(&GLX_MAX_PBUFFER_WIDTH);
	eval 'sub GLX_MAX_PBUFFER_HEIGHT () {0x8017;}' unless defined(&GLX_MAX_PBUFFER_HEIGHT);
	eval 'sub GLX_MAX_PBUFFER_PIXELS () {0x8018;}' unless defined(&GLX_MAX_PBUFFER_PIXELS);
	eval 'sub GLX_PRESERVED_CONTENTS () {0x801b;}' unless defined(&GLX_PRESERVED_CONTENTS);
	eval 'sub GLX_LARGEST_PBUFFER () {0x801c;}' unless defined(&GLX_LARGEST_PBUFFER);
	eval 'sub GLX_WIDTH () {0x801d;}' unless defined(&GLX_WIDTH);
	eval 'sub GLX_HEIGHT () {0x801e;}' unless defined(&GLX_HEIGHT);
	eval 'sub GLX_EVENT_MASK () {0x801f;}' unless defined(&GLX_EVENT_MASK);
	eval 'sub GLX_DAMAGED () {0x8020;}' unless defined(&GLX_DAMAGED);
	eval 'sub GLX_SAVED () {0x8021;}' unless defined(&GLX_SAVED);
	eval 'sub GLX_WINDOW () {0x8022;}' unless defined(&GLX_WINDOW);
	eval 'sub GLX_PBUFFER () {0x8023;}' unless defined(&GLX_PBUFFER);
	eval 'sub GLX_PBUFFER_HEIGHT () {0x8040;}' unless defined(&GLX_PBUFFER_HEIGHT);
	eval 'sub GLX_PBUFFER_WIDTH () {0x8041;}' unless defined(&GLX_PBUFFER_WIDTH);
    }
    unless(defined(&GLX_VERSION_1_4)) {
	eval 'sub GLX_SAMPLE_BUFFERS () {100000;}' unless defined(&GLX_SAMPLE_BUFFERS);
	eval 'sub GLX_SAMPLES () {100001;}' unless defined(&GLX_SAMPLES);
    }
    unless(defined(&GLX_ARB_get_proc_address)) {
    }
    unless(defined(&GLX_ARB_multisample)) {
	eval 'sub GLX_SAMPLE_BUFFERS_ARB () {100000;}' unless defined(&GLX_SAMPLE_BUFFERS_ARB);
	eval 'sub GLX_SAMPLES_ARB () {100001;}' unless defined(&GLX_SAMPLES_ARB);
    }
    unless(defined(&GLX_SGIS_multisample)) {
	eval 'sub GLX_SAMPLE_BUFFERS_SGIS () {100000;}' unless defined(&GLX_SAMPLE_BUFFERS_SGIS);
	eval 'sub GLX_SAMPLES_SGIS () {100001;}' unless defined(&GLX_SAMPLES_SGIS);
    }
    unless(defined(&GLX_EXT_visual_info)) {
	eval 'sub GLX_X_VISUAL_TYPE_EXT () {0x22;}' unless defined(&GLX_X_VISUAL_TYPE_EXT);
	eval 'sub GLX_TRANSPARENT_TYPE_EXT () {0x23;}' unless defined(&GLX_TRANSPARENT_TYPE_EXT);
	eval 'sub GLX_TRANSPARENT_INDEX_VALUE_EXT () {0x24;}' unless defined(&GLX_TRANSPARENT_INDEX_VALUE_EXT);
	eval 'sub GLX_TRANSPARENT_RED_VALUE_EXT () {0x25;}' unless defined(&GLX_TRANSPARENT_RED_VALUE_EXT);
	eval 'sub GLX_TRANSPARENT_GREEN_VALUE_EXT () {0x26;}' unless defined(&GLX_TRANSPARENT_GREEN_VALUE_EXT);
	eval 'sub GLX_TRANSPARENT_BLUE_VALUE_EXT () {0x27;}' unless defined(&GLX_TRANSPARENT_BLUE_VALUE_EXT);
	eval 'sub GLX_TRANSPARENT_ALPHA_VALUE_EXT () {0x28;}' unless defined(&GLX_TRANSPARENT_ALPHA_VALUE_EXT);
	eval 'sub GLX_NONE_EXT () {0x8000;}' unless defined(&GLX_NONE_EXT);
	eval 'sub GLX_TRUE_COLOR_EXT () {0x8002;}' unless defined(&GLX_TRUE_COLOR_EXT);
	eval 'sub GLX_DIRECT_COLOR_EXT () {0x8003;}' unless defined(&GLX_DIRECT_COLOR_EXT);
	eval 'sub GLX_PSEUDO_COLOR_EXT () {0x8004;}' unless defined(&GLX_PSEUDO_COLOR_EXT);
	eval 'sub GLX_STATIC_COLOR_EXT () {0x8005;}' unless defined(&GLX_STATIC_COLOR_EXT);
	eval 'sub GLX_GRAY_SCALE_EXT () {0x8006;}' unless defined(&GLX_GRAY_SCALE_EXT);
	eval 'sub GLX_STATIC_GRAY_EXT () {0x8007;}' unless defined(&GLX_STATIC_GRAY_EXT);
	eval 'sub GLX_TRANSPARENT_RGB_EXT () {0x8008;}' unless defined(&GLX_TRANSPARENT_RGB_EXT);
	eval 'sub GLX_TRANSPARENT_INDEX_EXT () {0x8009;}' unless defined(&GLX_TRANSPARENT_INDEX_EXT);
    }
    unless(defined(&GLX_SGI_swap_control)) {
    }
    unless(defined(&GLX_SGI_video_sync)) {
    }
    unless(defined(&GLX_SGI_make_current_read)) {
    }
    unless(defined(&GLX_SGIX_video_source)) {
    }
    unless(defined(&GLX_EXT_visual_rating)) {
	eval 'sub GLX_VISUAL_CAVEAT_EXT () {0x20;}' unless defined(&GLX_VISUAL_CAVEAT_EXT);
	eval 'sub GLX_SLOW_VISUAL_EXT () {0x8001;}' unless defined(&GLX_SLOW_VISUAL_EXT);
	eval 'sub GLX_NON_CONFORMANT_VISUAL_EXT () {0x800d;}' unless defined(&GLX_NON_CONFORMANT_VISUAL_EXT);
    }
    unless(defined(&GLX_EXT_import_context)) {
	eval 'sub GLX_SHARE_CONTEXT_EXT () {0x800a;}' unless defined(&GLX_SHARE_CONTEXT_EXT);
	eval 'sub GLX_VISUAL_ID_EXT () {0x800b;}' unless defined(&GLX_VISUAL_ID_EXT);
	eval 'sub GLX_SCREEN_EXT () {0x800c;}' unless defined(&GLX_SCREEN_EXT);
    }
    unless(defined(&GLX_SGIX_fbconfig)) {
	eval 'sub GLX_WINDOW_BIT_SGIX () {0x1;}' unless defined(&GLX_WINDOW_BIT_SGIX);
	eval 'sub GLX_PIXMAP_BIT_SGIX () {0x2;}' unless defined(&GLX_PIXMAP_BIT_SGIX);
	eval 'sub GLX_RGBA_BIT_SGIX () {0x1;}' unless defined(&GLX_RGBA_BIT_SGIX);
	eval 'sub GLX_COLOR_INDEX_BIT_SGIX () {0x2;}' unless defined(&GLX_COLOR_INDEX_BIT_SGIX);
	eval 'sub GLX_DRAWABLE_TYPE_SGIX () {0x8010;}' unless defined(&GLX_DRAWABLE_TYPE_SGIX);
	eval 'sub GLX_RENDER_TYPE_SGIX () {0x8011;}' unless defined(&GLX_RENDER_TYPE_SGIX);
	eval 'sub GLX_X_RENDERABLE_SGIX () {0x8012;}' unless defined(&GLX_X_RENDERABLE_SGIX);
	eval 'sub GLX_FBCONFIG_ID_SGIX () {0x8013;}' unless defined(&GLX_FBCONFIG_ID_SGIX);
	eval 'sub GLX_RGBA_TYPE_SGIX () {0x8014;}' unless defined(&GLX_RGBA_TYPE_SGIX);
	eval 'sub GLX_COLOR_INDEX_TYPE_SGIX () {0x8015;}' unless defined(&GLX_COLOR_INDEX_TYPE_SGIX);
    }
    unless(defined(&GLX_SGIX_pbuffer)) {
	eval 'sub GLX_PBUFFER_BIT_SGIX () {0x4;}' unless defined(&GLX_PBUFFER_BIT_SGIX);
	eval 'sub GLX_BUFFER_CLOBBER_MASK_SGIX () {0x8000000;}' unless defined(&GLX_BUFFER_CLOBBER_MASK_SGIX);
	eval 'sub GLX_FRONT_LEFT_BUFFER_BIT_SGIX () {0x1;}' unless defined(&GLX_FRONT_LEFT_BUFFER_BIT_SGIX);
	eval 'sub GLX_FRONT_RIGHT_BUFFER_BIT_SGIX () {0x2;}' unless defined(&GLX_FRONT_RIGHT_BUFFER_BIT_SGIX);
	eval 'sub GLX_BACK_LEFT_BUFFER_BIT_SGIX () {0x4;}' unless defined(&GLX_BACK_LEFT_BUFFER_BIT_SGIX);
	eval 'sub GLX_BACK_RIGHT_BUFFER_BIT_SGIX () {0x8;}' unless defined(&GLX_BACK_RIGHT_BUFFER_BIT_SGIX);
	eval 'sub GLX_AUX_BUFFERS_BIT_SGIX () {0x10;}' unless defined(&GLX_AUX_BUFFERS_BIT_SGIX);
	eval 'sub GLX_DEPTH_BUFFER_BIT_SGIX () {0x20;}' unless defined(&GLX_DEPTH_BUFFER_BIT_SGIX);
	eval 'sub GLX_STENCIL_BUFFER_BIT_SGIX () {0x40;}' unless defined(&GLX_STENCIL_BUFFER_BIT_SGIX);
	eval 'sub GLX_ACCUM_BUFFER_BIT_SGIX () {0x80;}' unless defined(&GLX_ACCUM_BUFFER_BIT_SGIX);
	eval 'sub GLX_SAMPLE_BUFFERS_BIT_SGIX () {0x100;}' unless defined(&GLX_SAMPLE_BUFFERS_BIT_SGIX);
	eval 'sub GLX_MAX_PBUFFER_WIDTH_SGIX () {0x8016;}' unless defined(&GLX_MAX_PBUFFER_WIDTH_SGIX);
	eval 'sub GLX_MAX_PBUFFER_HEIGHT_SGIX () {0x8017;}' unless defined(&GLX_MAX_PBUFFER_HEIGHT_SGIX);
	eval 'sub GLX_MAX_PBUFFER_PIXELS_SGIX () {0x8018;}' unless defined(&GLX_MAX_PBUFFER_PIXELS_SGIX);
	eval 'sub GLX_OPTIMAL_PBUFFER_WIDTH_SGIX () {0x8019;}' unless defined(&GLX_OPTIMAL_PBUFFER_WIDTH_SGIX);
	eval 'sub GLX_OPTIMAL_PBUFFER_HEIGHT_SGIX () {0x801a;}' unless defined(&GLX_OPTIMAL_PBUFFER_HEIGHT_SGIX);
	eval 'sub GLX_PRESERVED_CONTENTS_SGIX () {0x801b;}' unless defined(&GLX_PRESERVED_CONTENTS_SGIX);
	eval 'sub GLX_LARGEST_PBUFFER_SGIX () {0x801c;}' unless defined(&GLX_LARGEST_PBUFFER_SGIX);
	eval 'sub GLX_WIDTH_SGIX () {0x801d;}' unless defined(&GLX_WIDTH_SGIX);
	eval 'sub GLX_HEIGHT_SGIX () {0x801e;}' unless defined(&GLX_HEIGHT_SGIX);
	eval 'sub GLX_EVENT_MASK_SGIX () {0x801f;}' unless defined(&GLX_EVENT_MASK_SGIX);
	eval 'sub GLX_DAMAGED_SGIX () {0x8020;}' unless defined(&GLX_DAMAGED_SGIX);
	eval 'sub GLX_SAVED_SGIX () {0x8021;}' unless defined(&GLX_SAVED_SGIX);
	eval 'sub GLX_WINDOW_SGIX () {0x8022;}' unless defined(&GLX_WINDOW_SGIX);
	eval 'sub GLX_PBUFFER_SGIX () {0x8023;}' unless defined(&GLX_PBUFFER_SGIX);
    }
    unless(defined(&GLX_SGI_cushion)) {
    }
    unless(defined(&GLX_SGIX_video_resize)) {
	eval 'sub GLX_SYNC_FRAME_SGIX () {0x;}' unless defined(&GLX_SYNC_FRAME_SGIX);
	eval 'sub GLX_SYNC_SWAP_SGIX () {0x1;}' unless defined(&GLX_SYNC_SWAP_SGIX);
    }
    unless(defined(&GLX_SGIX_dmbuffer)) {
	eval 'sub GLX_DIGITAL_MEDIA_PBUFFER_SGIX () {0x8024;}' unless defined(&GLX_DIGITAL_MEDIA_PBUFFER_SGIX);
    }
    unless(defined(&GLX_SGIX_swap_group)) {
    }
    unless(defined(&GLX_SGIX_swap_barrier)) {
    }
    unless(defined(&GLX_SGIS_blended_overlay)) {
	eval 'sub GLX_BLENDED_RGBA_SGIS () {0x8025;}' unless defined(&GLX_BLENDED_RGBA_SGIS);
    }
    unless(defined(&GLX_SGIS_shared_multisample)) {
	eval 'sub GLX_MULTISAMPLE_SUB_RECT_WIDTH_SGIS () {0x8026;}' unless defined(&GLX_MULTISAMPLE_SUB_RECT_WIDTH_SGIS);
	eval 'sub GLX_MULTISAMPLE_SUB_RECT_HEIGHT_SGIS () {0x8027;}' unless defined(&GLX_MULTISAMPLE_SUB_RECT_HEIGHT_SGIS);
    }
    unless(defined(&GLX_SUN_get_transparent_index)) {
    }
    unless(defined(&GLX_3DFX_multisample)) {
	eval 'sub GLX_SAMPLE_BUFFERS_3DFX () {0x8050;}' unless defined(&GLX_SAMPLE_BUFFERS_3DFX);
	eval 'sub GLX_SAMPLES_3DFX () {0x8051;}' unless defined(&GLX_SAMPLES_3DFX);
    }
    unless(defined(&GLX_MESA_copy_sub_buffer)) {
    }
    unless(defined(&GLX_MESA_pixmap_colormap)) {
    }
    unless(defined(&GLX_MESA_release_buffers)) {
    }
    unless(defined(&GLX_MESA_agp_offset)) {
    }
    unless(defined(&GLX_MESA_set_3dfx_mode)) {
	eval 'sub GLX_3DFX_WINDOW_MODE_MESA () {0x1;}' unless defined(&GLX_3DFX_WINDOW_MODE_MESA);
	eval 'sub GLX_3DFX_FULLSCREEN_MODE_MESA () {0x2;}' unless defined(&GLX_3DFX_FULLSCREEN_MODE_MESA);
    }
    unless(defined(&GLX_SGIX_visual_select_group)) {
	eval 'sub GLX_VISUAL_SELECT_GROUP_SGIX () {0x8028;}' unless defined(&GLX_VISUAL_SELECT_GROUP_SGIX);
    }
    unless(defined(&GLX_OML_swap_method)) {
	eval 'sub GLX_SWAP_METHOD_OML () {0x8060;}' unless defined(&GLX_SWAP_METHOD_OML);
	eval 'sub GLX_SWAP_EXCHANGE_OML () {0x8061;}' unless defined(&GLX_SWAP_EXCHANGE_OML);
	eval 'sub GLX_SWAP_COPY_OML () {0x8062;}' unless defined(&GLX_SWAP_COPY_OML);
	eval 'sub GLX_SWAP_UNDEFINED_OML () {0x8063;}' unless defined(&GLX_SWAP_UNDEFINED_OML);
    }
    unless(defined(&GLX_OML_sync_control)) {
    }
    unless(defined(&GLX_ARB_get_proc_address)) {
    }
    unless(defined(&GLX_SGIX_video_source)) {
    }
    unless(defined(&GLX_SGIX_fbconfig)) {
    }
    unless(defined(&GLX_SGIX_pbuffer)) {
    }
    unless(defined(&GLX_VERSION_1_3)) {
	eval 'sub GLX_VERSION_1_3 () {1;}' unless defined(&GLX_VERSION_1_3);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_VERSION_1_4)) {
	eval 'sub GLX_VERSION_1_4 () {1;}' unless defined(&GLX_VERSION_1_4);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_ARB_get_proc_address)) {
	eval 'sub GLX_ARB_get_proc_address () {1;}' unless defined(&GLX_ARB_get_proc_address);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_ARB_multisample)) {
	eval 'sub GLX_ARB_multisample () {1;}' unless defined(&GLX_ARB_multisample);
    }
    unless(defined(&GLX_SGIS_multisample)) {
	eval 'sub GLX_SGIS_multisample () {1;}' unless defined(&GLX_SGIS_multisample);
    }
    unless(defined(&GLX_EXT_visual_info)) {
	eval 'sub GLX_EXT_visual_info () {1;}' unless defined(&GLX_EXT_visual_info);
    }
    unless(defined(&GLX_SGI_swap_control)) {
	eval 'sub GLX_SGI_swap_control () {1;}' unless defined(&GLX_SGI_swap_control);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_SGI_video_sync)) {
	eval 'sub GLX_SGI_video_sync () {1;}' unless defined(&GLX_SGI_video_sync);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_SGI_make_current_read)) {
	eval 'sub GLX_SGI_make_current_read () {1;}' unless defined(&GLX_SGI_make_current_read);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    if(defined(&_VL_H)) {
	unless(defined(&GLX_SGIX_video_source)) {
	    eval 'sub GLX_SGIX_video_source () {1;}' unless defined(&GLX_SGIX_video_source);
	    if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	    }
	}
    }
    unless(defined(&GLX_EXT_visual_rating)) {
	eval 'sub GLX_EXT_visual_rating () {1;}' unless defined(&GLX_EXT_visual_rating);
    }
    unless(defined(&GLX_EXT_import_context)) {
	eval 'sub GLX_EXT_import_context () {1;}' unless defined(&GLX_EXT_import_context);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_SGIX_fbconfig)) {
	eval 'sub GLX_SGIX_fbconfig () {1;}' unless defined(&GLX_SGIX_fbconfig);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_SGIX_pbuffer)) {
	eval 'sub GLX_SGIX_pbuffer () {1;}' unless defined(&GLX_SGIX_pbuffer);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_SGI_cushion)) {
	eval 'sub GLX_SGI_cushion () {1;}' unless defined(&GLX_SGI_cushion);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_SGIX_video_resize)) {
	eval 'sub GLX_SGIX_video_resize () {1;}' unless defined(&GLX_SGIX_video_resize);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    if(defined(&_DM_BUFFER_H_)) {
	unless(defined(&GLX_SGIX_dmbuffer)) {
	    eval 'sub GLX_SGIX_dmbuffer () {1;}' unless defined(&GLX_SGIX_dmbuffer);
	    if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	    }
	}
    }
    unless(defined(&GLX_SGIX_swap_group)) {
	eval 'sub GLX_SGIX_swap_group () {1;}' unless defined(&GLX_SGIX_swap_group);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_SGIX_swap_barrier)) {
	eval 'sub GLX_SGIX_swap_barrier () {1;}' unless defined(&GLX_SGIX_swap_barrier);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_SUN_get_transparent_index)) {
	eval 'sub GLX_SUN_get_transparent_index () {1;}' unless defined(&GLX_SUN_get_transparent_index);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_MESA_copy_sub_buffer)) {
	eval 'sub GLX_MESA_copy_sub_buffer () {1;}' unless defined(&GLX_MESA_copy_sub_buffer);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_MESA_pixmap_colormap)) {
	eval 'sub GLX_MESA_pixmap_colormap () {1;}' unless defined(&GLX_MESA_pixmap_colormap);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_MESA_release_buffers)) {
	eval 'sub GLX_MESA_release_buffers () {1;}' unless defined(&GLX_MESA_release_buffers);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_MESA_set_3dfx_mode)) {
	eval 'sub GLX_MESA_set_3dfx_mode () {1;}' unless defined(&GLX_MESA_set_3dfx_mode);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_MESA_agp_offset)) {
	eval 'sub GLX_MESA_agp_offset () {1;}' unless defined(&GLX_MESA_agp_offset);
	if(defined(&GLX_GLXEXT_PROTOTYPES)) {
	}
    }
    unless(defined(&GLX_SGIX_visual_select_group)) {
	eval 'sub GLX_SGIX_visual_select_group () {1;}' unless defined(&GLX_SGIX_visual_select_group);
    }
    unless(defined(&GLX_OML_swap_method)) {
	eval 'sub GLX_OML_swap_method () {1;}' unless defined(&GLX_OML_swap_method);
    }
    if(defined( &__STDC_VERSION__)) {
	if((defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : 0) >= 199901) {
	    require 'inttypes.ph';
	    unless(defined(&GLX_OML_sync_control)) {
		eval 'sub GLX_OML_sync_control () {1;}' unless defined(&GLX_OML_sync_control);
		if(defined(&GLX_GLXEXT_PROTOTYPES)) {
		}
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
