require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&CONVERT_PATH)) {
    eval 'sub CONVERT_PATH () {"/usr/local/bin";}' unless defined(&CONVERT_PATH);
}
unless(defined(&NETPBM_PATH)) {
    eval 'sub NETPBM_PATH () {"/usr/local/bin";}' unless defined(&NETPBM_PATH);
}
unless(defined(&CJPEG_PROG)) {
    eval 'sub CJPEG_PROG () {"/usr/local/bin/cjpeg";}' unless defined(&CJPEG_PROG);
}
unless(defined(&DJPEG_PROG)) {
    eval 'sub DJPEG_PROG () {"/usr/local/bin/djpeg";}' unless defined(&DJPEG_PROG);
}
require 'stdio.ph';
require 'unistd.ph';
require 'stdlib.ph';
require 'math.ph';
require 'ctype.ph';
require 'time.ph';
require 'netinet/in.ph';
if(defined(&HAVE_IPC_H)) {
    require 'sys/ipc.ph';
}
if(defined(&HAVE_SHM_H)) {
    require 'sys/shm.ph';
}
require 'sys/time.ph';
require 'sys/types.ph';
if(defined(&_HAVE_STRING_H)) {
    require 'string.ph';
}
 elsif((defined(&_HAVE_STRINGS_H) ? &_HAVE_STRINGS_H : 0)) {
    require 'strings.ph';
}
require 'X11/Xlib.ph';
require 'X11/Xutil.ph';
require 'X11/Xatom.ph';
require 'X11/Xos.ph';
if(defined(&HAVE_XSHM_H)) {
    require 'X11/extensions/XShm.ph';
}
require 'X11/extensions/shape.ph';
require 'X11/cursorfont.ph';
if(defined(&HAVE_LIBJPEG)) {
    require 'jpeglib.ph';
}
if(defined(&HAVE_LIBPNG)) {
    require 'png.ph';
}
if(defined(&HAVE_LIBTIFF)) {
    require 'tiffio.ph';
}
if(defined(&HAVE_LIBGIF)) {
    require 'gif_lib.ph';
}
unless(defined(&BYTE_ORD_24_RGB)) {
    sub BYTE_ORD_24_RGB () {	0;}
}
unless(defined(&BYTE_ORD_24_RBG)) {
    sub BYTE_ORD_24_RBG () {	1;}
}
unless(defined(&BYTE_ORD_24_BRG)) {
    sub BYTE_ORD_24_BRG () {	2;}
}
unless(defined(&BYTE_ORD_24_BGR)) {
    sub BYTE_ORD_24_BGR () {	3;}
}
unless(defined(&BYTE_ORD_24_GRB)) {
    sub BYTE_ORD_24_GRB () {	4;}
}
unless(defined(&BYTE_ORD_24_GBR)) {
    sub BYTE_ORD_24_GBR () {	5;}
}
if(defined(&HAVE_LIBJPEG)) {
}
if(defined(&HAVE_LIBPNG)) {
}
if(defined(&HAVE_LIBTIFF)) {
}
if(defined(&HAVE_LIBGIF)) {
}
unless(defined(&INDEX_RGB)) {
    sub INDEX_RGB {
	my($r,$g,$b) = @_;
	eval q( ($id->{fast_rgb[(r<<10)|(g<<5)|(b)]}));
    }
}
unless(defined(&COLOR_INDEX)) {
    sub COLOR_INDEX {
	my($i) = @_;
	eval q( ($id->{palette[$i]}->{p$ixel}));
    }
}
unless(defined(&COLOR_RGB)) {
    sub COLOR_RGB {
	my($r,$g,$b) = @_;
	eval q( ($id->{palette[INDEX_RGB($r,$g,$b)]}->{pixel}));
    }
}
unless(defined(&ERROR_RED)) {
    sub ERROR_RED {
	my($rr,$i) = @_;
	eval q($rr- ($id->{palette[$i]}->{r}););
    }
}
unless(defined(&ERROR_GRN)) {
    sub ERROR_GRN {
	my($gg,$i) = @_;
	eval q($gg- ($id->{palette[$i]}->{g}););
    }
}
unless(defined(&ERROR_BLU)) {
    sub ERROR_BLU {
	my($bb,$i) = @_;
	eval q($bb- ($id->{palette[$i]}->{b}););
    }
}
unless(defined(&DITHER_ERROR)) {
    sub DITHER_ERROR {
	my($Der1,$Der2,$Dex,$Der,$Deg,$Deb) = @_;
	eval q( &ter=($Der1->[$Dex]);(* &ter)+=($Der*7)>>4; &ter++;(* &ter)+=($Deg*7)>>4; &ter++;(* &ter)+=($Deb*7)>>4; &ter=($Der2->[$Dex-6]);(* &ter)+=($Der*3)>>4; &ter++;(* &ter)+=($Deg*3)>>4; &ter++;(* &ter)+=($Deb*3)>>4; &ter++;(* &ter)+=($Der*5)>>4; &ter++;(* &ter)+=($Deg*5)>>4; &ter++;(* &ter)+=($Deb*5)>>4; &ter++;(* &ter)+=$Der>>4; &ter++;(* &ter)+=$Deg>>4; &ter++;(* &ter)+=$Deb>>4;);
    }
}
1;
