require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&XMD_H)) {
    eval 'sub XMD_H () {1;}' unless defined(&XMD_H);
    if(defined(&CRAY)) {
	eval 'sub WORD64 () {1;}' unless defined(&WORD64);
    }
    if(defined( &__alpha) || defined( &__alpha__) || defined( &__ia64__) || defined( &ia64) || defined( &__sparc64__) || defined( &__s390x__) || (defined( &__hppa__)  && defined( &__LP64__)) || defined( &__x86_64__) || defined( &x86_64) || defined( &__powerpc64__) || defined( &powerpc64)) {
	eval 'sub LONG64 () {1;}' unless defined(&LONG64);
    }
    if(defined(&__sgi)) {
	if(((defined(&_MIPS_SZLONG) ? &_MIPS_SZLONG : 0) == 64)) {
	    eval 'sub LONG64 () {1;}' unless defined(&LONG64);
	}
    }
    if(defined(&WORD64)) {
	eval 'sub MUSTCOPY () {1;}' unless defined(&MUSTCOPY);
    }
    if(((defined( &__STDC__) || defined( &__cplusplus) || defined( &c_plusplus))  && !defined( &UNIXCPP)) || defined( &ANSICPP)) {
	eval 'sub _SIZEOF {
	    my($x) = @_;
    	    eval q( &sz_$x);
	}' unless defined(&_SIZEOF);
	eval 'sub SIZEOF {
	    my($x) = @_;
    	    eval q( &_SIZEOF($x));
	}' unless defined(&SIZEOF);
    } else {
	eval 'sub SIZEOF {
	    my($x) = @_;
    	    eval q( &sz_ $x);
	}' unless defined(&SIZEOF);
    }
    if(defined(&WORD64)) {
	eval 'sub B32 () {:32;}' unless defined(&B32);
	eval 'sub B16 () {:16;}' unless defined(&B16);
	if(defined(&UNSIGNEDBITFIELDS)) {
	} else {
	    if(defined(&__STDC__)) {
	    } else {
	    }
	}
    } else {
	eval 'sub B32 () {1;}' unless defined(&B32);
	eval 'sub B16 () {1;}' unless defined(&B16);
	if(defined(&LONG64)) {
	} else {
	}
    }
    if(defined( &__STDC__) || defined( &sgi) || defined( &AIXV3)) {
    } else {
    }
    if(defined(&LONG64)) {
    } else {
    }
    unless(defined(&I_NEED_OS2_H)) {
    } else {
	eval 'sub BYTE () { &CARD8;}' unless defined(&BYTE);
	eval 'sub BOOL () { &CARD8;}' unless defined(&BOOL);
    }
    if(defined( &WORD64)  && defined( &UNSIGNEDBITFIELDS)) {
	eval 'sub cvtINT8toInt {
	    my($val) = @_;
    	    eval q(((($val) & 0x80) ? (($val) | 1.84467440737096e+19) : ($val)));
	}' unless defined(&cvtINT8toInt);
	eval 'sub cvtINT16toInt {
	    my($val) = @_;
    	    eval q(((($val) & 0x8000) ? (($val) | 1.84467440737095e+19) : ($val)));
	}' unless defined(&cvtINT16toInt);
	eval 'sub cvtINT32toInt {
	    my($val) = @_;
    	    eval q(((($val) & 0x80000000) ? (($val) | 1.84467440694146e+19) : ($val)));
	}' unless defined(&cvtINT32toInt);
	eval 'sub cvtINT8toShort {
	    my($val) = @_;
    	    eval q( &cvtINT8toInt($val));
	}' unless defined(&cvtINT8toShort);
	eval 'sub cvtINT16toShort {
	    my($val) = @_;
    	    eval q( &cvtINT16toInt($val));
	}' unless defined(&cvtINT16toShort);
	eval 'sub cvtINT32toShort {
	    my($val) = @_;
    	    eval q( &cvtINT32toInt($val));
	}' unless defined(&cvtINT32toShort);
	eval 'sub cvtINT8toLong {
	    my($val) = @_;
    	    eval q( &cvtINT8toInt($val));
	}' unless defined(&cvtINT8toLong);
	eval 'sub cvtINT16toLong {
	    my($val) = @_;
    	    eval q( &cvtINT16toInt($val));
	}' unless defined(&cvtINT16toLong);
	eval 'sub cvtINT32toLong {
	    my($val) = @_;
    	    eval q( &cvtINT32toInt($val));
	}' unless defined(&cvtINT32toLong);
    } else {
	eval 'sub cvtINT8toInt {
	    my($val) = @_;
    	    eval q(($val));
	}' unless defined(&cvtINT8toInt);
	eval 'sub cvtINT16toInt {
	    my($val) = @_;
    	    eval q(($val));
	}' unless defined(&cvtINT16toInt);
	eval 'sub cvtINT32toInt {
	    my($val) = @_;
    	    eval q(($val));
	}' unless defined(&cvtINT32toInt);
	eval 'sub cvtINT8toShort {
	    my($val) = @_;
    	    eval q(($val));
	}' unless defined(&cvtINT8toShort);
	eval 'sub cvtINT16toShort {
	    my($val) = @_;
    	    eval q(($val));
	}' unless defined(&cvtINT16toShort);
	eval 'sub cvtINT32toShort {
	    my($val) = @_;
    	    eval q(($val));
	}' unless defined(&cvtINT32toShort);
	eval 'sub cvtINT8toLong {
	    my($val) = @_;
    	    eval q(($val));
	}' unless defined(&cvtINT8toLong);
	eval 'sub cvtINT16toLong {
	    my($val) = @_;
    	    eval q(($val));
	}' unless defined(&cvtINT16toLong);
	eval 'sub cvtINT32toLong {
	    my($val) = @_;
    	    eval q(($val));
	}' unless defined(&cvtINT32toLong);
    }
    if(defined(&MUSTCOPY)) {
	eval 'sub NEXTPTR {
	    my($p,$t) = @_;
    	    eval q((( $p) +  &SIZEOF($t)));
	}' unless defined(&NEXTPTR);
    } else {
	eval 'sub NEXTPTR {
	    my($p,$t) = @_;
    	    eval q(((($t *)($p)) + 1));
	}' unless defined(&NEXTPTR);
    }
}
1;
