require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XOS_H_)) {
    eval 'sub _XOS_H_ () {1;}' unless defined(&_XOS_H_);
    require 'X11/Xosdefs.ph';
    if(defined(&USG)) {
	unless(defined(&__TYPES__)) {
	    if(defined(&CRAY)) {
		eval 'sub word () { &word_t;}' unless defined(&word);
	    }
	    require 'sys/types.ph';
	    eval 'sub __TYPES__ () {1;}' unless defined(&__TYPES__);
	}
    } else {
	if(defined( &_POSIX_SOURCE)  && defined( &MOTOROLA)) {
	    undef(&_POSIX_SOURCE) if defined(&_POSIX_SOURCE);
	    require 'sys/types.ph';
	    eval 'sub _POSIX_SOURCE () {1;}' unless defined(&_POSIX_SOURCE);
	} else {
	    require 'sys/types.ph';
	}
    }
    if(defined(&_SEQUENT_)) {
	require 'netinet/in_systm.ph';
	require 'sys/select.ph';
    }
    unless(defined(&X_NOT_STDC_ENV)) {
	require 'string.ph';
	if(defined(&__STDC__)) {
	    unless(defined(&index)) {
		eval 'sub index {
		    my($s,$c) = @_;
    		    eval q(( &strchr(($s),($c))));
		}' unless defined(&index);
	    }
	    unless(defined(&rindex)) {
		eval 'sub rindex {
		    my($s,$c) = @_;
    		    eval q(( &strrchr(($s),($c))));
		}' unless defined(&rindex);
	    }
	} else {
	    unless(defined(&index)) {
		eval 'sub index () { &strchr;}' unless defined(&index);
	    }
	    unless(defined(&rindex)) {
		eval 'sub rindex () { &strrchr;}' unless defined(&rindex);
	    }
	}
    } else {
	if(defined(&SYSV)) {
	    if(defined( &clipper) || defined( &__clipper__)) {
		require 'malloc.ph';
	    }
	    require 'string.ph';
	    eval 'sub index () { &strchr;}' unless defined(&index);
	    eval 'sub rindex () { &strrchr;}' unless defined(&rindex);
	} else {
	    require 'strings.ph';
	    eval 'sub strchr () { &index;}' unless defined(&strchr);
	    eval 'sub strrchr () { &rindex;}' unless defined(&strrchr);
	}
    }
    if((defined( &X_NOT_STDC_ENV) || (defined( &sun)  && !defined( &SVR4)) || defined( &macII))  && !defined( &__GLIBC__)) {
	unless(defined(&strerror)) {
	    eval 'sub strerror {
	        my($n) = @_;
    		eval q(((($n) >= 0 && ($n) <  &sys_nerr) ?  $sys_errlist[$n] : \\"unknown error\\"));
	    }' unless defined(&strerror);
	}
    }
    if(defined( &X_NOT_POSIX)) {
	require 'fcntl.ph';
	if(defined( &USL) || defined( &CRAY) || defined( &MOTOROLA) || (defined( &i386)  && (defined( &SYSV) || defined( &SVR4))) || defined( &__sxg__)) {
	    require 'unistd.ph';
	}
	if(defined(&WIN32)) {
	    require 'X11/Xw32defs.ph';
	} else {
	    require 'sys/file.ph';
	}
    } else {
	if(!defined( &_POSIX_SOURCE)  && defined( &macII)) {
	    eval 'sub _POSIX_SOURCE () {1;}' unless defined(&_POSIX_SOURCE);
	    require 'fcntl.ph';
	    require 'unistd.ph';
	    undef(&_POSIX_SOURCE) if defined(&_POSIX_SOURCE);
	} else {
	    require 'fcntl.ph';
	    require 'unistd.ph';
	}
    }
    if(defined( &SYSV)  && !defined( &_SEQUENT_)) {
	unless(defined(&USL)) {
	    require 'sys/time.ph';
	}
	require 'time.ph';
	if(defined(&CRAY)) {
	    undef(&word) if defined(&word);
	}
	if(defined( &USG)  && !defined( &CRAY)  && !defined( &MOTOROLA)  && !defined( &uniosu)  && !defined( &__sxg__)  && !defined( &clipper)  && !defined( &__clipper__)) {
	    unless(defined(&USL_SHARELIB)) {
	    }
	}
	if(defined(&_SEQUENT_)) {
	}
    } else {
	if(defined( &_POSIX_SOURCE)  && defined( &SVR4)) {
	    undef(&_POSIX_SOURCE) if defined(&_POSIX_SOURCE);
	    require 'sys/time.ph';
	    eval 'sub _POSIX_SOURCE () {1;}' unless defined(&_POSIX_SOURCE);
	}
 elsif(defined( &WIN32)) {
	    require 'time.ph';
	    if(!defined( &_WINSOCKAPI_)  && !defined( &_WILLWINSOCK_)) {
	    }
	    require 'sys/timeb.ph';
	    eval 'sub gettimeofday {
	        my($t) = @_;
    		eval q({ \'struct _timeb\'  &_gtodtmp;  &_ftime (& &_gtodtmp); ($t)-> &tv_sec =  ($_gtodtmp->{time}); ($t)-> &tv_usec =  ($_gtodtmp->{millitm}) * 1000; });
	    }' unless defined(&gettimeofday);
	}
 elsif(defined( &_SEQUENT_) || defined( &Lynx)) {
	    require 'time.ph';
	}
 elsif(defined ( &__QNX__)) {
	    eval 'sub FD_SETSIZE () {256;}' unless defined(&FD_SETSIZE);
	    require 'sys/select.ph';
	    require 'sys/time.ph';
	    require 'time.ph';
	} else {
	    require 'sys/time.ph';
	    require 'time.ph';
	}
    }
    if(defined( &_XOPEN_XPG4) || defined( &_XOPEN_UNIX) ) {
	eval 'sub X_GETTIMEOFDAY {
	    my($t) = @_;
    	    eval q( &gettimeofday($t, 0));
	}' unless defined(&X_GETTIMEOFDAY);
    } else {
	if(defined( &SVR4) || defined( &VMS) || defined( &WIN32)) {
	    eval 'sub X_GETTIMEOFDAY {
	        my($t) = @_;
    		eval q( &gettimeofday($t));
	    }' unless defined(&X_GETTIMEOFDAY);
	} else {
	    eval 'sub X_GETTIMEOFDAY {
	        my($t) = @_;
    		eval q( &gettimeofday($t, 0));
	    }' unless defined(&X_GETTIMEOFDAY);
	}
    }
    if(defined(&__UNIXOS2__)) {
	require 'limits.ph';
	eval 'sub MAX_PATH () { &_POSIX_PATH_MAX;}' unless defined(&MAX_PATH);
    }
    if(defined(&__GNU__)) {
	eval 'sub PATH_MAX () {4096;}' unless defined(&PATH_MAX);
	eval 'sub MAXPATHLEN () {4096;}' unless defined(&MAXPATHLEN);
	eval 'sub OPEN_MAX () {256;}' unless defined(&OPEN_MAX);
    }
    if(defined( &X_NOT_POSIX)  && defined( &SYSV)  && !defined( &SIGCHLD)  && !defined( &ISC)) {
	eval 'sub SIGCHLD () { &SIGCLD;}' unless defined(&SIGCHLD);
    }
    if(defined(&ISC)) {
	require 'sys/bsdtypes.ph';
	require 'sys/limits.ph';
	eval 'sub NGROUPS () {16;}' unless defined(&NGROUPS);
    }
    if(defined( &ISC) || (defined( &linux)  && !defined( &__GLIBC__)) || (defined( &__QNX__)  && !defined( &UNIXCONN))) {
	eval 'sub X_NO_SYS_UN () {1;}' unless defined(&X_NO_SYS_UN);
    }
    require 'X11/Xarch.ph';
}
1;
