require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XLBX_H_)) {
    eval 'sub _XLBX_H_ () {1;}' unless defined(&_XLBX_H_);
    require 'X11/Xfuncproto.ph';
    eval 'sub X_LbxQueryVersion () {0;}' unless defined(&X_LbxQueryVersion);
    eval 'sub X_LbxStartProxy () {1;}' unless defined(&X_LbxStartProxy);
    eval 'sub X_LbxStopProxy () {2;}' unless defined(&X_LbxStopProxy);
    eval 'sub X_LbxSwitch () {3;}' unless defined(&X_LbxSwitch);
    eval 'sub X_LbxNewClient () {4;}' unless defined(&X_LbxNewClient);
    eval 'sub X_LbxCloseClient () {5;}' unless defined(&X_LbxCloseClient);
    eval 'sub X_LbxModifySequence () {6;}' unless defined(&X_LbxModifySequence);
    eval 'sub X_LbxAllowMotion () {7;}' unless defined(&X_LbxAllowMotion);
    eval 'sub X_LbxIncrementPixel () {8;}' unless defined(&X_LbxIncrementPixel);
    eval 'sub X_LbxDelta () {9;}' unless defined(&X_LbxDelta);
    eval 'sub X_LbxGetModifierMapping () {10;}' unless defined(&X_LbxGetModifierMapping);
    eval 'sub X_LbxInvalidateTag () {12;}' unless defined(&X_LbxInvalidateTag);
    eval 'sub X_LbxPolyPoint () {13;}' unless defined(&X_LbxPolyPoint);
    eval 'sub X_LbxPolyLine () {14;}' unless defined(&X_LbxPolyLine);
    eval 'sub X_LbxPolySegment () {15;}' unless defined(&X_LbxPolySegment);
    eval 'sub X_LbxPolyRectangle () {16;}' unless defined(&X_LbxPolyRectangle);
    eval 'sub X_LbxPolyArc () {17;}' unless defined(&X_LbxPolyArc);
    eval 'sub X_LbxFillPoly () {18;}' unless defined(&X_LbxFillPoly);
    eval 'sub X_LbxPolyFillRectangle () {19;}' unless defined(&X_LbxPolyFillRectangle);
    eval 'sub X_LbxPolyFillArc () {20;}' unless defined(&X_LbxPolyFillArc);
    eval 'sub X_LbxGetKeyboardMapping () {21;}' unless defined(&X_LbxGetKeyboardMapping);
    eval 'sub X_LbxQueryFont () {22;}' unless defined(&X_LbxQueryFont);
    eval 'sub X_LbxChangeProperty () {23;}' unless defined(&X_LbxChangeProperty);
    eval 'sub X_LbxGetProperty () {24;}' unless defined(&X_LbxGetProperty);
    eval 'sub X_LbxTagData () {25;}' unless defined(&X_LbxTagData);
    eval 'sub X_LbxCopyArea () {26;}' unless defined(&X_LbxCopyArea);
    eval 'sub X_LbxCopyPlane () {27;}' unless defined(&X_LbxCopyPlane);
    eval 'sub X_LbxPolyText8 () {28;}' unless defined(&X_LbxPolyText8);
    eval 'sub X_LbxPolyText16 () {29;}' unless defined(&X_LbxPolyText16);
    eval 'sub X_LbxImageText8 () {30;}' unless defined(&X_LbxImageText8);
    eval 'sub X_LbxImageText16 () {31;}' unless defined(&X_LbxImageText16);
    eval 'sub X_LbxQueryExtension () {32;}' unless defined(&X_LbxQueryExtension);
    eval 'sub X_LbxPutImage () {33;}' unless defined(&X_LbxPutImage);
    eval 'sub X_LbxGetImage () {34;}' unless defined(&X_LbxGetImage);
    eval 'sub X_LbxBeginLargeRequest () {35;}' unless defined(&X_LbxBeginLargeRequest);
    eval 'sub X_LbxLargeRequestData () {36;}' unless defined(&X_LbxLargeRequestData);
    eval 'sub X_LbxEndLargeRequest () {37;}' unless defined(&X_LbxEndLargeRequest);
    eval 'sub X_LbxInternAtoms () {38;}' unless defined(&X_LbxInternAtoms);
    eval 'sub X_LbxGetWinAttrAndGeom () {39;}' unless defined(&X_LbxGetWinAttrAndGeom);
    eval 'sub X_LbxGrabCmap () {40;}' unless defined(&X_LbxGrabCmap);
    eval 'sub X_LbxReleaseCmap () {41;}' unless defined(&X_LbxReleaseCmap);
    eval 'sub X_LbxAllocColor () {42;}' unless defined(&X_LbxAllocColor);
    eval 'sub X_LbxSync () {43;}' unless defined(&X_LbxSync);
    eval 'sub LbxNumberReqs () {44;}' unless defined(&LbxNumberReqs);
    eval 'sub LbxEvent () {0;}' unless defined(&LbxEvent);
    eval 'sub LbxQuickMotionDeltaEvent () {1;}' unless defined(&LbxQuickMotionDeltaEvent);
    eval 'sub LbxNumberEvents () {2;}' unless defined(&LbxNumberEvents);
    eval 'sub LbxMasterClientIndex () {0;}' unless defined(&LbxMasterClientIndex);
    eval 'sub LbxSwitchEvent () {0;}' unless defined(&LbxSwitchEvent);
    eval 'sub LbxCloseEvent () {1;}' unless defined(&LbxCloseEvent);
    eval 'sub LbxDeltaEvent () {2;}' unless defined(&LbxDeltaEvent);
    eval 'sub LbxInvalidateTagEvent () {3;}' unless defined(&LbxInvalidateTagEvent);
    eval 'sub LbxSendTagDataEvent () {4;}' unless defined(&LbxSendTagDataEvent);
    eval 'sub LbxListenToOne () {5;}' unless defined(&LbxListenToOne);
    eval 'sub LbxListenToAll () {6;}' unless defined(&LbxListenToAll);
    eval 'sub LbxMotionDeltaEvent () {7;}' unless defined(&LbxMotionDeltaEvent);
    eval 'sub LbxReleaseCmapEvent () {8;}' unless defined(&LbxReleaseCmapEvent);
    eval 'sub LbxFreeCellsEvent () {9;}' unless defined(&LbxFreeCellsEvent);
    eval 'sub LbxImageCompressNone () {0;}' unless defined(&LbxImageCompressNone);
    eval 'sub BadLbxClient () {0;}' unless defined(&BadLbxClient);
    eval 'sub LbxNumberErrors () {( &BadLbxClient + 1);}' unless defined(&LbxNumberErrors);
    eval 'sub LbxTagTypeModmap () {1;}' unless defined(&LbxTagTypeModmap);
    eval 'sub LbxTagTypeKeymap () {2;}' unless defined(&LbxTagTypeKeymap);
    eval 'sub LbxTagTypeProperty () {3;}' unless defined(&LbxTagTypeProperty);
    eval 'sub LbxTagTypeFont () {4;}' unless defined(&LbxTagTypeFont);
    eval 'sub LbxTagTypeConnInfo () {5;}' unless defined(&LbxTagTypeConnInfo);
    unless(defined(&_XLBX_SERVER_)) {
	require 'X11/Xdefs.ph';
	require 'X11/Xlib.ph';
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
	if((defined(&NeedFunctionPrototypes) ? &NeedFunctionPrototypes : 0)) {
	}
    }
}
1;
