require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&XVPROTO_H)) {
    eval 'sub XVPROTO_H () {1;}' unless defined(&XVPROTO_H);
    require 'X11/Xmd.ph';
    eval 'sub XvPortID () { &CARD32;}' unless defined(&XvPortID);
    eval 'sub XvEncodingID () { &CARD32;}' unless defined(&XvEncodingID);
    eval 'sub ShmSeg () { &CARD32;}' unless defined(&ShmSeg);
    eval 'sub VisualID () { &CARD32;}' unless defined(&VisualID);
    eval 'sub Drawable () { &CARD32;}' unless defined(&Drawable);
    eval 'sub GContext () { &CARD32;}' unless defined(&GContext);
    eval 'sub Time () { &CARD32;}' unless defined(&Time);
    eval 'sub Atom () { &CARD32;}' unless defined(&Atom);
    eval 'sub sz_xvRational () {8;}' unless defined(&sz_xvRational);
    eval 'sub sz_xvAdaptorInfo () {12;}' unless defined(&sz_xvAdaptorInfo);
    eval 'sub sz_xvEncodingInfo () {(12+  &sz_xvRational);}' unless defined(&sz_xvEncodingInfo);
    eval 'sub sz_xvFormat () {8;}' unless defined(&sz_xvFormat);
    eval 'sub sz_xvAttributeInfo () {16;}' unless defined(&sz_xvAttributeInfo);
    eval 'sub sz_xvImageFormatInfo () {128;}' unless defined(&sz_xvImageFormatInfo);
    eval 'sub xv_QueryExtension () {0;}' unless defined(&xv_QueryExtension);
    eval 'sub xv_QueryAdaptors () {1;}' unless defined(&xv_QueryAdaptors);
    eval 'sub xv_QueryEncodings () {2;}' unless defined(&xv_QueryEncodings);
    eval 'sub xv_GrabPort () {3;}' unless defined(&xv_GrabPort);
    eval 'sub xv_UngrabPort () {4;}' unless defined(&xv_UngrabPort);
    eval 'sub xv_PutVideo () {5;}' unless defined(&xv_PutVideo);
    eval 'sub xv_PutStill () {6;}' unless defined(&xv_PutStill);
    eval 'sub xv_GetVideo () {7;}' unless defined(&xv_GetVideo);
    eval 'sub xv_GetStill () {8;}' unless defined(&xv_GetStill);
    eval 'sub xv_StopVideo () {9;}' unless defined(&xv_StopVideo);
    eval 'sub xv_SelectVideoNotify () {10;}' unless defined(&xv_SelectVideoNotify);
    eval 'sub xv_SelectPortNotify () {11;}' unless defined(&xv_SelectPortNotify);
    eval 'sub xv_QueryBestSize () {12;}' unless defined(&xv_QueryBestSize);
    eval 'sub xv_SetPortAttribute () {13;}' unless defined(&xv_SetPortAttribute);
    eval 'sub xv_GetPortAttribute () {14;}' unless defined(&xv_GetPortAttribute);
    eval 'sub xv_QueryPortAttributes () {15;}' unless defined(&xv_QueryPortAttributes);
    eval 'sub xv_ListImageFormats () {16;}' unless defined(&xv_ListImageFormats);
    eval 'sub xv_QueryImageAttributes () {17;}' unless defined(&xv_QueryImageAttributes);
    eval 'sub xv_PutImage () {18;}' unless defined(&xv_PutImage);
    eval 'sub xv_ShmPutImage () {19;}' unless defined(&xv_ShmPutImage);
    eval 'sub xv_LastRequest () { &xv_ShmPutImage;}' unless defined(&xv_LastRequest);
    eval 'sub xvNumRequests () {( &xv_LastRequest + 1);}' unless defined(&xvNumRequests);
    eval 'sub sz_xvQueryExtensionReq () {4;}' unless defined(&sz_xvQueryExtensionReq);
    eval 'sub sz_xvQueryAdaptorsReq () {8;}' unless defined(&sz_xvQueryAdaptorsReq);
    eval 'sub sz_xvQueryEncodingsReq () {8;}' unless defined(&sz_xvQueryEncodingsReq);
    eval 'sub sz_xvPutVideoReq () {32;}' unless defined(&sz_xvPutVideoReq);
    eval 'sub sz_xvPutStillReq () {32;}' unless defined(&sz_xvPutStillReq);
    eval 'sub sz_xvGetVideoReq () {32;}' unless defined(&sz_xvGetVideoReq);
    eval 'sub sz_xvGetStillReq () {32;}' unless defined(&sz_xvGetStillReq);
    eval 'sub sz_xvGrabPortReq () {12;}' unless defined(&sz_xvGrabPortReq);
    eval 'sub sz_xvUngrabPortReq () {12;}' unless defined(&sz_xvUngrabPortReq);
    eval 'sub sz_xvSelectVideoNotifyReq () {12;}' unless defined(&sz_xvSelectVideoNotifyReq);
    eval 'sub sz_xvSelectPortNotifyReq () {12;}' unless defined(&sz_xvSelectPortNotifyReq);
    eval 'sub sz_xvStopVideoReq () {12;}' unless defined(&sz_xvStopVideoReq);
    eval 'sub sz_xvSetPortAttributeReq () {16;}' unless defined(&sz_xvSetPortAttributeReq);
    eval 'sub sz_xvGetPortAttributeReq () {12;}' unless defined(&sz_xvGetPortAttributeReq);
    eval 'sub sz_xvQueryBestSizeReq () {20;}' unless defined(&sz_xvQueryBestSizeReq);
    eval 'sub sz_xvQueryPortAttributesReq () {8;}' unless defined(&sz_xvQueryPortAttributesReq);
    eval 'sub sz_xvPutImageReq () {40;}' unless defined(&sz_xvPutImageReq);
    eval 'sub sz_xvShmPutImageReq () {52;}' unless defined(&sz_xvShmPutImageReq);
    eval 'sub sz_xvListImageFormatsReq () {8;}' unless defined(&sz_xvListImageFormatsReq);
    eval 'sub sz_xvQueryImageAttributesReq () {16;}' unless defined(&sz_xvQueryImageAttributesReq);
    eval 'sub sz_xvQueryExtensionReply () {32;}' unless defined(&sz_xvQueryExtensionReply);
    eval 'sub sz_xvQueryAdaptorsReply () {32;}' unless defined(&sz_xvQueryAdaptorsReply);
    eval 'sub sz_xvQueryEncodingsReply () {32;}' unless defined(&sz_xvQueryEncodingsReply);
    eval 'sub sz_xvGrabPortReply () {32;}' unless defined(&sz_xvGrabPortReply);
    eval 'sub sz_xvGetPortAttributeReply () {32;}' unless defined(&sz_xvGetPortAttributeReply);
    eval 'sub sz_xvQueryBestSizeReply () {32;}' unless defined(&sz_xvQueryBestSizeReply);
    eval 'sub sz_xvQueryPortAttributesReply () {32;}' unless defined(&sz_xvQueryPortAttributesReply);
    eval 'sub sz_xvListImageFormatsReply () {32;}' unless defined(&sz_xvListImageFormatsReply);
    eval 'sub sz_xvQueryImageAttributesReply () {32;}' unless defined(&sz_xvQueryImageAttributesReply);
    undef(&XvPortID) if defined(&XvPortID);
    undef(&XvEncodingID) if defined(&XvEncodingID);
    undef(&ShmSeg) if defined(&ShmSeg);
    undef(&VisualID) if defined(&VisualID);
    undef(&Drawable) if defined(&Drawable);
    undef(&GContext) if defined(&GContext);
    undef(&Time) if defined(&Time);
    undef(&Atom) if defined(&Atom);
}
1;
