require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LBXSTR_H_)) {
    eval 'sub _LBXSTR_H_ () {1;}' unless defined(&_LBXSTR_H_);
    require 'X11/extensions/XLbx.ph';
    eval 'sub LBXNAME () {"LBX";}' unless defined(&LBXNAME);
    eval 'sub LBX_MAJOR_VERSION () {1;}' unless defined(&LBX_MAJOR_VERSION);
    eval 'sub LBX_MINOR_VERSION () {0;}' unless defined(&LBX_MINOR_VERSION);
    eval 'sub XID () { &CARD32;}' unless defined(&XID);
    eval 'sub Atom () { &CARD32;}' unless defined(&Atom);
    eval 'sub Colormap () { &CARD32;}' unless defined(&Colormap);
    eval 'sub Drawable () { &CARD32;}' unless defined(&Drawable);
    eval 'sub VisualID () { &CARD32;}' unless defined(&VisualID);
    eval 'sub Window () { &CARD32;}' unless defined(&Window);
    eval 'sub sz_xLbxQueryVersionReq () {4;}' unless defined(&sz_xLbxQueryVersionReq);
    eval 'sub sz_xLbxQueryVersionReply () {32;}' unless defined(&sz_xLbxQueryVersionReply);
    eval 'sub sz_xLbxStartProxyReq () {4;}' unless defined(&sz_xLbxStartProxyReq);
    eval 'sub sz_xLbxStopProxyReq () {4;}' unless defined(&sz_xLbxStopProxyReq);
    eval 'sub sz_xLbxSwitchReq () {8;}' unless defined(&sz_xLbxSwitchReq);
    eval 'sub sz_xLbxNewClientReq () {8;}' unless defined(&sz_xLbxNewClientReq);
    eval 'sub sz_xLbxCloseClientReq () {8;}' unless defined(&sz_xLbxCloseClientReq);
    eval 'sub sz_xLbxModifySequenceReq () {8;}' unless defined(&sz_xLbxModifySequenceReq);
    eval 'sub sz_xLbxAllowMotionReq () {8;}' unless defined(&sz_xLbxAllowMotionReq);
    eval 'sub sz_xLbxGrabCmapReq () {8;}' unless defined(&sz_xLbxGrabCmapReq);
    eval 'sub LBX_SMART_GRAB () {0x80;}' unless defined(&LBX_SMART_GRAB);
    eval 'sub LBX_AUTO_RELEASE () {0x40;}' unless defined(&LBX_AUTO_RELEASE);
    eval 'sub LBX_3CHANNELS () {0x20;}' unless defined(&LBX_3CHANNELS);
    eval 'sub LBX_2BYTE_PIXELS () {0x10;}' unless defined(&LBX_2BYTE_PIXELS);
    eval 'sub LBX_RGB_BITS_MASK () {0xf;}' unless defined(&LBX_RGB_BITS_MASK);
    eval 'sub LBX_LIST_END () {0;}' unless defined(&LBX_LIST_END);
    eval 'sub LBX_PIXEL_PRIVATE () {1;}' unless defined(&LBX_PIXEL_PRIVATE);
    eval 'sub LBX_PIXEL_SHARED () {2;}' unless defined(&LBX_PIXEL_SHARED);
    eval 'sub LBX_PIXEL_RANGE_PRIVATE () {3;}' unless defined(&LBX_PIXEL_RANGE_PRIVATE);
    eval 'sub LBX_PIXEL_RANGE_SHARED () {4;}' unless defined(&LBX_PIXEL_RANGE_SHARED);
    eval 'sub LBX_NEXT_CHANNEL () {5;}' unless defined(&LBX_NEXT_CHANNEL);
    eval 'sub sz_xLbxGrabCmapReply () {32;}' unless defined(&sz_xLbxGrabCmapReply);
    eval 'sub sz_xLbxGrabCmapReplyHdr () {8;}' unless defined(&sz_xLbxGrabCmapReplyHdr);
    eval 'sub sz_xLbxReleaseCmapReq () {8;}' unless defined(&sz_xLbxReleaseCmapReq);
    eval 'sub sz_xLbxAllocColorReq () {20;}' unless defined(&sz_xLbxAllocColorReq);
    eval 'sub sz_xLbxIncrementPixelReq () {12;}' unless defined(&sz_xLbxIncrementPixelReq);
    eval 'sub sz_xLbxDeltaReq () {6;}' unless defined(&sz_xLbxDeltaReq);
    eval 'sub sz_xLbxGetModifierMappingReq () {4;}' unless defined(&sz_xLbxGetModifierMappingReq);
    eval 'sub sz_xLbxGetModifierMappingReply () {32;}' unless defined(&sz_xLbxGetModifierMappingReply);
    eval 'sub sz_xLbxGetKeyboardMappingReq () {8;}' unless defined(&sz_xLbxGetKeyboardMappingReq);
    eval 'sub sz_xLbxGetKeyboardMappingReply () {32;}' unless defined(&sz_xLbxGetKeyboardMappingReply);
    eval 'sub sz_xLbxQueryFontReq () {8;}' unless defined(&sz_xLbxQueryFontReq);
    eval 'sub sz_xLbxInternAtomsReq () {6;}' unless defined(&sz_xLbxInternAtomsReq);
    eval 'sub sz_xLbxInternAtomsReply () {32;}' unless defined(&sz_xLbxInternAtomsReply);
    eval 'sub sz_xLbxInternAtomsReplyHdr () {8;}' unless defined(&sz_xLbxInternAtomsReplyHdr);
    eval 'sub sz_xLbxGetWinAttrAndGeomReq () {8;}' unless defined(&sz_xLbxGetWinAttrAndGeomReq);
    if(defined( &__cplusplus) || defined( &c_plusplus)) {
    } else {
    }
    eval 'sub sz_xLbxGetWinAttrAndGeomReply () {60;}' unless defined(&sz_xLbxGetWinAttrAndGeomReply);
    eval 'sub sz_xLbxSyncReq () {4;}' unless defined(&sz_xLbxSyncReq);
    eval 'sub sz_xLbxSyncReply () {32;}' unless defined(&sz_xLbxSyncReply);
    eval 'sub LBX_WIDTH_SHIFT () {26;}' unless defined(&LBX_WIDTH_SHIFT);
    eval 'sub LBX_LEFT_SHIFT () {20;}' unless defined(&LBX_LEFT_SHIFT);
    eval 'sub LBX_RIGHT_SHIFT () {13;}' unless defined(&LBX_RIGHT_SHIFT);
    eval 'sub LBX_ASCENT_SHIFT () {7;}' unless defined(&LBX_ASCENT_SHIFT);
    eval 'sub LBX_DESCENT_SHIFT () {0;}' unless defined(&LBX_DESCENT_SHIFT);
    eval 'sub LBX_WIDTH_BITS () {6;}' unless defined(&LBX_WIDTH_BITS);
    eval 'sub LBX_LEFT_BITS () {6;}' unless defined(&LBX_LEFT_BITS);
    eval 'sub LBX_RIGHT_BITS () {7;}' unless defined(&LBX_RIGHT_BITS);
    eval 'sub LBX_ASCENT_BITS () {6;}' unless defined(&LBX_ASCENT_BITS);
    eval 'sub LBX_DESCENT_BITS () {7;}' unless defined(&LBX_DESCENT_BITS);
    eval 'sub LBX_WIDTH_MASK () {0xfc000000;}' unless defined(&LBX_WIDTH_MASK);
    eval 'sub LBX_LEFT_MASK () {0x3f00000;}' unless defined(&LBX_LEFT_MASK);
    eval 'sub LBX_RIGHT_MASK () {0xfe000;}' unless defined(&LBX_RIGHT_MASK);
    eval 'sub LBX_ASCENT_MASK () {0x1f80;}' unless defined(&LBX_ASCENT_MASK);
    eval 'sub LBX_DESCENT_MASK () {0x7f;}' unless defined(&LBX_DESCENT_MASK);
    eval 'sub LBX_MASK_BITS {
        my($val, $n) = @_;
	    eval q(( (($val) & ((1<< ($n)) - 1))));
    }' unless defined(&LBX_MASK_BITS);
    unless(defined(&WORD64)) {
    }
    unless(defined(&WORD64)) {
    }
    eval 'sub sz_xLbxQueryFontReply () {32;}' unless defined(&sz_xLbxQueryFontReply);
    eval 'sub sz_xLbxChangePropertyReq () {24;}' unless defined(&sz_xLbxChangePropertyReq);
    eval 'sub sz_xLbxChangePropertyReply () {32;}' unless defined(&sz_xLbxChangePropertyReply);
    eval 'sub sz_xLbxGetPropertyReq () {28;}' unless defined(&sz_xLbxGetPropertyReq);
    eval 'sub sz_xLbxGetPropertyReply () {32;}' unless defined(&sz_xLbxGetPropertyReply);
    eval 'sub sz_xLbxTagDataReq () {12;}' unless defined(&sz_xLbxTagDataReq);
    eval 'sub sz_xLbxInvalidateTagReq () {8;}' unless defined(&sz_xLbxInvalidateTagReq);
    eval 'sub sz_xLbxPutImageReq () {7;}' unless defined(&sz_xLbxPutImageReq);
    eval 'sub sz_xLbxGetImageReq () {24;}' unless defined(&sz_xLbxGetImageReq);
    eval 'sub sz_xLbxGetImageReply () {32;}' unless defined(&sz_xLbxGetImageReply);
    eval 'sub GFX_CACHE_SIZE () {15;}' unless defined(&GFX_CACHE_SIZE);
    eval 'sub GFXdCacheEnt {
        my($e) = @_;
	    eval q((($e) & 0xf));
    }' unless defined(&GFXdCacheEnt);
    eval 'sub GFXgCacheEnt {
        my($e) = @_;
	    eval q(((($e) >> 4) & 0xf));
    }' unless defined(&GFXgCacheEnt);
    eval 'sub GFXCacheEnts {
        my($d,$g) = @_;
	    eval q(((($d) & 0xf) | ((($g) & 0xf) << 4)));
    }' unless defined(&GFXCacheEnts);
    eval 'sub GFXCacheNone () {0xf;}' unless defined(&GFXCacheNone);
    eval 'sub sz_xLbxPolyPointReq () {6;}' unless defined(&sz_xLbxPolyPointReq);
    eval 'sub sz_xLbxPolyLineReq () { &sz_xLbxPolyPointReq;}' unless defined(&sz_xLbxPolyLineReq);
    eval 'sub sz_xLbxPolySegmentReq () { &sz_xLbxPolyPointReq;}' unless defined(&sz_xLbxPolySegmentReq);
    eval 'sub sz_xLbxPolyRectangleReq () { &sz_xLbxPolyPointReq;}' unless defined(&sz_xLbxPolyRectangleReq);
    eval 'sub sz_xLbxPolyArcReq () { &sz_xLbxPolyPointReq;}' unless defined(&sz_xLbxPolyArcReq);
    eval 'sub sz_xLbxPolyFillRectangleReq () { &sz_xLbxPolyPointReq;}' unless defined(&sz_xLbxPolyFillRectangleReq);
    eval 'sub sz_xLbxPolyFillArc () { &sz_xLbxPolyPointReq;}' unless defined(&sz_xLbxPolyFillArc);
    eval 'sub sz_xLbxFillPolyReq () {7;}' unless defined(&sz_xLbxFillPolyReq);
    eval 'sub sz_xLbxCopyAreaReq () {6;}' unless defined(&sz_xLbxCopyAreaReq);
    eval 'sub sz_xLbxCopyPlaneReq () {10;}' unless defined(&sz_xLbxCopyPlaneReq);
    eval 'sub sz_xLbxPolyTextReq () {5;}' unless defined(&sz_xLbxPolyTextReq);
    eval 'sub sz_xLbxPolyTextReq () {5;}' unless defined(&sz_xLbxPolyTextReq);
    eval 'sub sz_xLbxPolyText8Req () {5;}' unless defined(&sz_xLbxPolyText8Req);
    eval 'sub sz_xLbxPolyText16Req () {5;}' unless defined(&sz_xLbxPolyText16Req);
    eval 'sub sz_xLbxImageTextReq () {6;}' unless defined(&sz_xLbxImageTextReq);
    eval 'sub sz_xLbxImageText8Req () {6;}' unless defined(&sz_xLbxImageText8Req);
    eval 'sub sz_xLbxImageText16Req () {6;}' unless defined(&sz_xLbxImageText16Req);
    eval 'sub sz_xLbxDiffItem () {2;}' unless defined(&sz_xLbxDiffItem);
    eval 'sub sz_xLbxStartReply () {32;}' unless defined(&sz_xLbxStartReply);
    eval 'sub sz_xLbxStartReplyHdr () {8;}' unless defined(&sz_xLbxStartReplyHdr);
    eval 'sub sz_xLbxQueryExtensionReq () {8;}' unless defined(&sz_xLbxQueryExtensionReq);
    eval 'sub sz_xLbxQueryExtensionReply () {32;}' unless defined(&sz_xLbxQueryExtensionReply);
    eval 'sub sz_BeginLargeRequestReq () {8;}' unless defined(&sz_BeginLargeRequestReq);
    eval 'sub sz_LargeRequestDataReq () {4;}' unless defined(&sz_LargeRequestDataReq);
    eval 'sub sz_EndLargeRequestReq () {4;}' unless defined(&sz_EndLargeRequestReq);
    eval 'sub sz_xLbxSwitchEvent () {8;}' unless defined(&sz_xLbxSwitchEvent);
    eval 'sub sz_xLbxCloseEvent () {32;}' unless defined(&sz_xLbxCloseEvent);
    eval 'sub sz_xLbxInvalidateTagEvent () {32;}' unless defined(&sz_xLbxInvalidateTagEvent);
    eval 'sub sz_xLbxSendTagDataEvent () {32;}' unless defined(&sz_xLbxSendTagDataEvent);
    eval 'sub sz_xLbxListenToOneEvent () {32;}' unless defined(&sz_xLbxListenToOneEvent);
    eval 'sub sz_xLbxListenToOneEvent () {32;}' unless defined(&sz_xLbxListenToOneEvent);
    eval 'sub sz_xLbxReleaseCmapEvent () {32;}' unless defined(&sz_xLbxReleaseCmapEvent);
    eval 'sub sz_xLbxFreeCellsEvent () {32;}' unless defined(&sz_xLbxFreeCellsEvent);
    eval 'sub lbxsz_KeyButtonEvent () {32;}' unless defined(&lbxsz_KeyButtonEvent);
    eval 'sub lbxupsz_KeyButtonEvent () {31;}' unless defined(&lbxupsz_KeyButtonEvent);
    eval 'sub lbxsz_EnterLeaveEvent () {32;}' unless defined(&lbxsz_EnterLeaveEvent);
    eval 'sub lbxupsz_EnterLeaveEvent () {32;}' unless defined(&lbxupsz_EnterLeaveEvent);
    eval 'sub lbxsz_FocusEvent () {12;}' unless defined(&lbxsz_FocusEvent);
    eval 'sub lbxupsz_FocusEvent () {9;}' unless defined(&lbxupsz_FocusEvent);
    eval 'sub lbxsz_KeymapEvent () {32;}' unless defined(&lbxsz_KeymapEvent);
    eval 'sub lbxupsz_KeymapEvent () {32;}' unless defined(&lbxupsz_KeymapEvent);
    eval 'sub lbxsz_ExposeEvent () {20;}' unless defined(&lbxsz_ExposeEvent);
    eval 'sub lbxupsz_ExposeEvent () {18;}' unless defined(&lbxupsz_ExposeEvent);
    eval 'sub lbxsz_GfxExposeEvent () {24;}' unless defined(&lbxsz_GfxExposeEvent);
    eval 'sub lbxupsz_GfxExposeEvent () {21;}' unless defined(&lbxupsz_GfxExposeEvent);
    eval 'sub lbxsz_NoExposeEvent () {12;}' unless defined(&lbxsz_NoExposeEvent);
    eval 'sub lbxupsz_NoExposeEvent () {11;}' unless defined(&lbxupsz_NoExposeEvent);
    eval 'sub lbxsz_VisibilityEvent () {12;}' unless defined(&lbxsz_VisibilityEvent);
    eval 'sub lbxupsz_VisibilityEvent () {9;}' unless defined(&lbxupsz_VisibilityEvent);
    eval 'sub lbxsz_CreateNotifyEvent () {24;}' unless defined(&lbxsz_CreateNotifyEvent);
    eval 'sub lbxupsz_CreateNotifyEvent () {23;}' unless defined(&lbxupsz_CreateNotifyEvent);
    eval 'sub lbxsz_DestroyNotifyEvent () {12;}' unless defined(&lbxsz_DestroyNotifyEvent);
    eval 'sub lbxupsz_DestroyNotifyEvent () {12;}' unless defined(&lbxupsz_DestroyNotifyEvent);
    eval 'sub lbxsz_UnmapNotifyEvent () {16;}' unless defined(&lbxsz_UnmapNotifyEvent);
    eval 'sub lbxupsz_UnmapNotifyEvent () {13;}' unless defined(&lbxupsz_UnmapNotifyEvent);
    eval 'sub lbxsz_MapNotifyEvent () {16;}' unless defined(&lbxsz_MapNotifyEvent);
    eval 'sub lbxupsz_MapNotifyEvent () {13;}' unless defined(&lbxupsz_MapNotifyEvent);
    eval 'sub lbxsz_MapRequestEvent () {12;}' unless defined(&lbxsz_MapRequestEvent);
    eval 'sub lbxupsz_MapRequestEvent () {12;}' unless defined(&lbxupsz_MapRequestEvent);
    eval 'sub lbxsz_ReparentEvent () {24;}' unless defined(&lbxsz_ReparentEvent);
    eval 'sub lbxupsz_ReparentEvent () {21;}' unless defined(&lbxupsz_ReparentEvent);
    eval 'sub lbxsz_ConfigureNotifyEvent () {28;}' unless defined(&lbxsz_ConfigureNotifyEvent);
    eval 'sub lbxupsz_ConfigureNotifyEvent () {27;}' unless defined(&lbxupsz_ConfigureNotifyEvent);
    eval 'sub lbxsz_ConfigureRequestEvent () {28;}' unless defined(&lbxsz_ConfigureRequestEvent);
    eval 'sub lbxupsz_ConfigureRequestEvent () {28;}' unless defined(&lbxupsz_ConfigureRequestEvent);
    eval 'sub lbxsz_GravityEvent () {16;}' unless defined(&lbxsz_GravityEvent);
    eval 'sub lbxupsz_GravityEvent () {16;}' unless defined(&lbxupsz_GravityEvent);
    eval 'sub lbxsz_ResizeRequestEvent () {12;}' unless defined(&lbxsz_ResizeRequestEvent);
    eval 'sub lbxupsz_ResizeRequestEvent () {12;}' unless defined(&lbxupsz_ResizeRequestEvent);
    eval 'sub lbxsz_CirculateEvent () {20;}' unless defined(&lbxsz_CirculateEvent);
    eval 'sub lbxupsz_CirculateEvent () {17;}' unless defined(&lbxupsz_CirculateEvent);
    eval 'sub lbxsz_PropertyEvent () {20;}' unless defined(&lbxsz_PropertyEvent);
    eval 'sub lbxupsz_PropertyEvent () {17;}' unless defined(&lbxupsz_PropertyEvent);
    eval 'sub lbxsz_SelectionClearEvent () {16;}' unless defined(&lbxsz_SelectionClearEvent);
    eval 'sub lbxupsz_SelectionClearEvent () {16;}' unless defined(&lbxupsz_SelectionClearEvent);
    eval 'sub lbxsz_SelectionRequestEvent () {28;}' unless defined(&lbxsz_SelectionRequestEvent);
    eval 'sub lbxupsz_SelectionRequestEvent () {28;}' unless defined(&lbxupsz_SelectionRequestEvent);
    eval 'sub lbxsz_SelectionNotifyEvent () {24;}' unless defined(&lbxsz_SelectionNotifyEvent);
    eval 'sub lbxupsz_SelectionNotifyEvent () {24;}' unless defined(&lbxupsz_SelectionNotifyEvent);
    eval 'sub lbxsz_ColormapEvent () {16;}' unless defined(&lbxsz_ColormapEvent);
    eval 'sub lbxupsz_ColormapEvent () {14;}' unless defined(&lbxupsz_ColormapEvent);
    eval 'sub lbxsz_MappingNotifyEvent () {8;}' unless defined(&lbxsz_MappingNotifyEvent);
    eval 'sub lbxupsz_MappingNotifyEvent () {7;}' unless defined(&lbxupsz_MappingNotifyEvent);
    eval 'sub lbxsz_ClientMessageEvent () {32;}' unless defined(&lbxsz_ClientMessageEvent);
    eval 'sub lbxupsz_ClientMessageEvent () {32;}' unless defined(&lbxupsz_ClientMessageEvent);
    eval 'sub lbxsz_UnknownEvent () {32;}' unless defined(&lbxsz_UnknownEvent);
    if(defined(&DEBUG)) {
	eval 'sub DBG_SWITCH () {0x1;}' unless defined(&DBG_SWITCH);
	eval 'sub DBG_CLOSE () {0x2;}' unless defined(&DBG_CLOSE);
	eval 'sub DBG_IO () {0x4;}' unless defined(&DBG_IO);
	eval 'sub DBG_READ_REQ () {0x8;}' unless defined(&DBG_READ_REQ);
	eval 'sub DBG_LEN () {0x10;}' unless defined(&DBG_LEN);
	eval 'sub DBG_BLOCK () {0x20;}' unless defined(&DBG_BLOCK);
	eval 'sub DBG_CLIENT () {0x40;}' unless defined(&DBG_CLIENT);
	eval 'sub DBG_DELTA () {0x80;}' unless defined(&DBG_DELTA);
	eval 'sub DBG {
	    my($n,$m) = @_;
    	    eval q( &if ( &lbxDebug & ($n)) {  &fprintf $m; }  &else);
	}' unless defined(&DBG);
    } else {
	eval 'sub DBG {
	    my($n,$m) = @_;
    	    eval q();
	}' unless defined(&DBG);
    }
    undef(&XID) if defined(&XID);
    undef(&Atom) if defined(&Atom);
    undef(&Colormap) if defined(&Colormap);
    undef(&Drawable) if defined(&Drawable);
    undef(&VisualID) if defined(&VisualID);
    undef(&Window) if defined(&Window);
}
1;
