require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RENDER_H_)) {
    eval 'sub _RENDER_H_ () {1;}' unless defined(&_RENDER_H_);
    eval 'sub RENDER_NAME () {"RENDER";}' unless defined(&RENDER_NAME);
    eval 'sub RENDER_MAJOR () {0;}' unless defined(&RENDER_MAJOR);
    eval 'sub RENDER_MINOR () {8;}' unless defined(&RENDER_MINOR);
    eval 'sub X_RenderQueryVersion () {0;}' unless defined(&X_RenderQueryVersion);
    eval 'sub X_RenderQueryPictFormats () {1;}' unless defined(&X_RenderQueryPictFormats);
    eval 'sub X_RenderQueryPictIndexValues () {2;}' unless defined(&X_RenderQueryPictIndexValues);
    eval 'sub X_RenderQueryDithers () {3;}' unless defined(&X_RenderQueryDithers);
    eval 'sub X_RenderCreatePicture () {4;}' unless defined(&X_RenderCreatePicture);
    eval 'sub X_RenderChangePicture () {5;}' unless defined(&X_RenderChangePicture);
    eval 'sub X_RenderSetPictureClipRectangles () {6;}' unless defined(&X_RenderSetPictureClipRectangles);
    eval 'sub X_RenderFreePicture () {7;}' unless defined(&X_RenderFreePicture);
    eval 'sub X_RenderComposite () {8;}' unless defined(&X_RenderComposite);
    eval 'sub X_RenderScale () {9;}' unless defined(&X_RenderScale);
    eval 'sub X_RenderTrapezoids () {10;}' unless defined(&X_RenderTrapezoids);
    eval 'sub X_RenderTriangles () {11;}' unless defined(&X_RenderTriangles);
    eval 'sub X_RenderTriStrip () {12;}' unless defined(&X_RenderTriStrip);
    eval 'sub X_RenderTriFan () {13;}' unless defined(&X_RenderTriFan);
    eval 'sub X_RenderColorTrapezoids () {14;}' unless defined(&X_RenderColorTrapezoids);
    eval 'sub X_RenderColorTriangles () {15;}' unless defined(&X_RenderColorTriangles);
    eval 'sub X_RenderCreateGlyphSet () {17;}' unless defined(&X_RenderCreateGlyphSet);
    eval 'sub X_RenderReferenceGlyphSet () {18;}' unless defined(&X_RenderReferenceGlyphSet);
    eval 'sub X_RenderFreeGlyphSet () {19;}' unless defined(&X_RenderFreeGlyphSet);
    eval 'sub X_RenderAddGlyphs () {20;}' unless defined(&X_RenderAddGlyphs);
    eval 'sub X_RenderAddGlyphsFromPicture () {21;}' unless defined(&X_RenderAddGlyphsFromPicture);
    eval 'sub X_RenderFreeGlyphs () {22;}' unless defined(&X_RenderFreeGlyphs);
    eval 'sub X_RenderCompositeGlyphs8 () {23;}' unless defined(&X_RenderCompositeGlyphs8);
    eval 'sub X_RenderCompositeGlyphs16 () {24;}' unless defined(&X_RenderCompositeGlyphs16);
    eval 'sub X_RenderCompositeGlyphs32 () {25;}' unless defined(&X_RenderCompositeGlyphs32);
    eval 'sub X_RenderFillRectangles () {26;}' unless defined(&X_RenderFillRectangles);
    eval 'sub X_RenderCreateCursor () {27;}' unless defined(&X_RenderCreateCursor);
    eval 'sub X_RenderSetPictureTransform () {28;}' unless defined(&X_RenderSetPictureTransform);
    eval 'sub X_RenderQueryFilters () {29;}' unless defined(&X_RenderQueryFilters);
    eval 'sub X_RenderSetPictureFilter () {30;}' unless defined(&X_RenderSetPictureFilter);
    eval 'sub X_RenderCreateAnimCursor () {31;}' unless defined(&X_RenderCreateAnimCursor);
    eval 'sub RenderNumberRequests () {( &X_RenderCreateAnimCursor+1);}' unless defined(&RenderNumberRequests);
    eval 'sub BadPictFormat () {0;}' unless defined(&BadPictFormat);
    eval 'sub BadPicture () {1;}' unless defined(&BadPicture);
    eval 'sub BadPictOp () {2;}' unless defined(&BadPictOp);
    eval 'sub BadGlyphSet () {3;}' unless defined(&BadGlyphSet);
    eval 'sub BadGlyph () {4;}' unless defined(&BadGlyph);
    eval 'sub RenderNumberErrors () {( &BadGlyph+1);}' unless defined(&RenderNumberErrors);
    eval 'sub PictTypeIndexed () {0;}' unless defined(&PictTypeIndexed);
    eval 'sub PictTypeDirect () {1;}' unless defined(&PictTypeDirect);
    eval 'sub PictOpMinimum () {0;}' unless defined(&PictOpMinimum);
    eval 'sub PictOpClear () {0;}' unless defined(&PictOpClear);
    eval 'sub PictOpSrc () {1;}' unless defined(&PictOpSrc);
    eval 'sub PictOpDst () {2;}' unless defined(&PictOpDst);
    eval 'sub PictOpOver () {3;}' unless defined(&PictOpOver);
    eval 'sub PictOpOverReverse () {4;}' unless defined(&PictOpOverReverse);
    eval 'sub PictOpIn () {5;}' unless defined(&PictOpIn);
    eval 'sub PictOpInReverse () {6;}' unless defined(&PictOpInReverse);
    eval 'sub PictOpOut () {7;}' unless defined(&PictOpOut);
    eval 'sub PictOpOutReverse () {8;}' unless defined(&PictOpOutReverse);
    eval 'sub PictOpAtop () {9;}' unless defined(&PictOpAtop);
    eval 'sub PictOpAtopReverse () {10;}' unless defined(&PictOpAtopReverse);
    eval 'sub PictOpXor () {11;}' unless defined(&PictOpXor);
    eval 'sub PictOpAdd () {12;}' unless defined(&PictOpAdd);
    eval 'sub PictOpSaturate () {13;}' unless defined(&PictOpSaturate);
    eval 'sub PictOpMaximum () {13;}' unless defined(&PictOpMaximum);
    eval 'sub PictOpDisjointMinimum () {0x10;}' unless defined(&PictOpDisjointMinimum);
    eval 'sub PictOpDisjointClear () {0x10;}' unless defined(&PictOpDisjointClear);
    eval 'sub PictOpDisjointSrc () {0x11;}' unless defined(&PictOpDisjointSrc);
    eval 'sub PictOpDisjointDst () {0x12;}' unless defined(&PictOpDisjointDst);
    eval 'sub PictOpDisjointOver () {0x13;}' unless defined(&PictOpDisjointOver);
    eval 'sub PictOpDisjointOverReverse () {0x14;}' unless defined(&PictOpDisjointOverReverse);
    eval 'sub PictOpDisjointIn () {0x15;}' unless defined(&PictOpDisjointIn);
    eval 'sub PictOpDisjointInReverse () {0x16;}' unless defined(&PictOpDisjointInReverse);
    eval 'sub PictOpDisjointOut () {0x17;}' unless defined(&PictOpDisjointOut);
    eval 'sub PictOpDisjointOutReverse () {0x18;}' unless defined(&PictOpDisjointOutReverse);
    eval 'sub PictOpDisjointAtop () {0x19;}' unless defined(&PictOpDisjointAtop);
    eval 'sub PictOpDisjointAtopReverse () {0x1a;}' unless defined(&PictOpDisjointAtopReverse);
    eval 'sub PictOpDisjointXor () {0x1b;}' unless defined(&PictOpDisjointXor);
    eval 'sub PictOpDisjointMaximum () {0x1b;}' unless defined(&PictOpDisjointMaximum);
    eval 'sub PictOpConjointMinimum () {0x20;}' unless defined(&PictOpConjointMinimum);
    eval 'sub PictOpConjointClear () {0x20;}' unless defined(&PictOpConjointClear);
    eval 'sub PictOpConjointSrc () {0x21;}' unless defined(&PictOpConjointSrc);
    eval 'sub PictOpConjointDst () {0x22;}' unless defined(&PictOpConjointDst);
    eval 'sub PictOpConjointOver () {0x23;}' unless defined(&PictOpConjointOver);
    eval 'sub PictOpConjointOverReverse () {0x24;}' unless defined(&PictOpConjointOverReverse);
    eval 'sub PictOpConjointIn () {0x25;}' unless defined(&PictOpConjointIn);
    eval 'sub PictOpConjointInReverse () {0x26;}' unless defined(&PictOpConjointInReverse);
    eval 'sub PictOpConjointOut () {0x27;}' unless defined(&PictOpConjointOut);
    eval 'sub PictOpConjointOutReverse () {0x28;}' unless defined(&PictOpConjointOutReverse);
    eval 'sub PictOpConjointAtop () {0x29;}' unless defined(&PictOpConjointAtop);
    eval 'sub PictOpConjointAtopReverse () {0x2a;}' unless defined(&PictOpConjointAtopReverse);
    eval 'sub PictOpConjointXor () {0x2b;}' unless defined(&PictOpConjointXor);
    eval 'sub PictOpConjointMaximum () {0x2b;}' unless defined(&PictOpConjointMaximum);
    eval 'sub PolyEdgeSharp () {0;}' unless defined(&PolyEdgeSharp);
    eval 'sub PolyEdgeSmooth () {1;}' unless defined(&PolyEdgeSmooth);
    eval 'sub PolyModePrecise () {0;}' unless defined(&PolyModePrecise);
    eval 'sub PolyModeImprecise () {1;}' unless defined(&PolyModeImprecise);
    eval 'sub CPRepeat () {(1<< 0);}' unless defined(&CPRepeat);
    eval 'sub CPAlphaMap () {(1<< 1);}' unless defined(&CPAlphaMap);
    eval 'sub CPAlphaXOrigin () {(1<< 2);}' unless defined(&CPAlphaXOrigin);
    eval 'sub CPAlphaYOrigin () {(1<< 3);}' unless defined(&CPAlphaYOrigin);
    eval 'sub CPClipXOrigin () {(1<< 4);}' unless defined(&CPClipXOrigin);
    eval 'sub CPClipYOrigin () {(1<< 5);}' unless defined(&CPClipYOrigin);
    eval 'sub CPClipMask () {(1<< 6);}' unless defined(&CPClipMask);
    eval 'sub CPGraphicsExposure () {(1<< 7);}' unless defined(&CPGraphicsExposure);
    eval 'sub CPSubwindowMode () {(1<< 8);}' unless defined(&CPSubwindowMode);
    eval 'sub CPPolyEdge () {(1<< 9);}' unless defined(&CPPolyEdge);
    eval 'sub CPPolyMode () {(1<< 10);}' unless defined(&CPPolyMode);
    eval 'sub CPDither () {(1<< 11);}' unless defined(&CPDither);
    eval 'sub CPComponentAlpha () {(1<< 12);}' unless defined(&CPComponentAlpha);
    eval 'sub CPLastBit () {11;}' unless defined(&CPLastBit);
    eval 'sub FilterNearest () {"nearest";}' unless defined(&FilterNearest);
    eval 'sub FilterBilinear () {"bilinear";}' unless defined(&FilterBilinear);
    eval 'sub FilterFast () {"fast";}' unless defined(&FilterFast);
    eval 'sub FilterGood () {"good";}' unless defined(&FilterGood);
    eval 'sub FilterBest () {"best";}' unless defined(&FilterBest);
    eval 'sub FilterAliasNone () {-1;}' unless defined(&FilterAliasNone);
    eval 'sub SubPixelUnknown () {0;}' unless defined(&SubPixelUnknown);
    eval 'sub SubPixelHorizontalRGB () {1;}' unless defined(&SubPixelHorizontalRGB);
    eval 'sub SubPixelHorizontalBGR () {2;}' unless defined(&SubPixelHorizontalBGR);
    eval 'sub SubPixelVerticalRGB () {3;}' unless defined(&SubPixelVerticalRGB);
    eval 'sub SubPixelVerticalBGR () {4;}' unless defined(&SubPixelVerticalBGR);
    eval 'sub SubPixelNone () {5;}' unless defined(&SubPixelNone);
}
1;
