require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XRENDERP_H_)) {
    eval 'sub _XRENDERP_H_ () {1;}' unless defined(&_XRENDERP_H_);
    require 'X11/Xmd.ph';
    require 'X11/extensions/render.ph';
    eval 'sub Window () { &CARD32;}' unless defined(&Window);
    eval 'sub Drawable () { &CARD32;}' unless defined(&Drawable);
    eval 'sub Font () { &CARD32;}' unless defined(&Font);
    eval 'sub Pixmap () { &CARD32;}' unless defined(&Pixmap);
    eval 'sub Cursor () { &CARD32;}' unless defined(&Cursor);
    eval 'sub Colormap () { &CARD32;}' unless defined(&Colormap);
    eval 'sub GContext () { &CARD32;}' unless defined(&GContext);
    eval 'sub Atom () { &CARD32;}' unless defined(&Atom);
    eval 'sub VisualID () { &CARD32;}' unless defined(&VisualID);
    eval 'sub Time () { &CARD32;}' unless defined(&Time);
    eval 'sub KeyCode () { &CARD8;}' unless defined(&KeyCode);
    eval 'sub KeySym () { &CARD32;}' unless defined(&KeySym);
    eval 'sub Picture () { &CARD32;}' unless defined(&Picture);
    eval 'sub PictFormat () { &CARD32;}' unless defined(&PictFormat);
    eval 'sub Fixed () { &INT32;}' unless defined(&Fixed);
    eval 'sub Glyphset () { &CARD32;}' unless defined(&Glyphset);
    eval 'sub Glyph () { &CARD32;}' unless defined(&Glyph);
    eval 'sub sz_xDirectFormat () {16;}' unless defined(&sz_xDirectFormat);
    eval 'sub sz_xPictFormInfo () {28;}' unless defined(&sz_xPictFormInfo);
    eval 'sub sz_xPictVisual () {8;}' unless defined(&sz_xPictVisual);
    eval 'sub sz_xPictDepth () {8;}' unless defined(&sz_xPictDepth);
    eval 'sub sz_xPictScreen () {8;}' unless defined(&sz_xPictScreen);
    eval 'sub sz_xIndexValue () {12;}' unless defined(&sz_xIndexValue);
    eval 'sub sz_xRenderColor () {8;}' unless defined(&sz_xRenderColor);
    eval 'sub sz_xPointFixed () {8;}' unless defined(&sz_xPointFixed);
    eval 'sub sz_xLineFixed () {16;}' unless defined(&sz_xLineFixed);
    eval 'sub sz_xTriangle () {24;}' unless defined(&sz_xTriangle);
    eval 'sub sz_xTrapezoid () {40;}' unless defined(&sz_xTrapezoid);
    eval 'sub sz_xGlyphInfo () {12;}' unless defined(&sz_xGlyphInfo);
    eval 'sub sz_xGlyphElt () {8;}' unless defined(&sz_xGlyphElt);
    eval 'sub sz_xRenderQueryVersionReq () {12;}' unless defined(&sz_xRenderQueryVersionReq);
    eval 'sub sz_xRenderQueryVersionReply () {32;}' unless defined(&sz_xRenderQueryVersionReply);
    eval 'sub sz_xRenderQueryPictFormatsReq () {4;}' unless defined(&sz_xRenderQueryPictFormatsReq);
    eval 'sub sz_xRenderQueryPictFormatsReply () {32;}' unless defined(&sz_xRenderQueryPictFormatsReply);
    eval 'sub sz_xRenderQueryPictIndexValuesReq () {8;}' unless defined(&sz_xRenderQueryPictIndexValuesReq);
    eval 'sub sz_xRenderQueryPictIndexValuesReply () {32;}' unless defined(&sz_xRenderQueryPictIndexValuesReply);
    eval 'sub sz_xRenderCreatePictureReq () {20;}' unless defined(&sz_xRenderCreatePictureReq);
    eval 'sub sz_xRenderChangePictureReq () {12;}' unless defined(&sz_xRenderChangePictureReq);
    eval 'sub sz_xRenderSetPictureClipRectanglesReq () {12;}' unless defined(&sz_xRenderSetPictureClipRectanglesReq);
    eval 'sub sz_xRenderFreePictureReq () {8;}' unless defined(&sz_xRenderFreePictureReq);
    eval 'sub sz_xRenderCompositeReq () {36;}' unless defined(&sz_xRenderCompositeReq);
    eval 'sub sz_xRenderScaleReq () {32;}' unless defined(&sz_xRenderScaleReq);
    eval 'sub sz_xRenderTrapezoidsReq () {24;}' unless defined(&sz_xRenderTrapezoidsReq);
    eval 'sub sz_xRenderTrianglesReq () {24;}' unless defined(&sz_xRenderTrianglesReq);
    eval 'sub sz_xRenderTriStripReq () {24;}' unless defined(&sz_xRenderTriStripReq);
    eval 'sub sz_xRenderTriFanReq () {24;}' unless defined(&sz_xRenderTriFanReq);
    eval 'sub sz_xRenderCreateGlyphSetReq () {12;}' unless defined(&sz_xRenderCreateGlyphSetReq);
    eval 'sub sz_xRenderReferenceGlyphSetReq () {24;}' unless defined(&sz_xRenderReferenceGlyphSetReq);
    eval 'sub sz_xRenderFreeGlyphSetReq () {8;}' unless defined(&sz_xRenderFreeGlyphSetReq);
    eval 'sub sz_xRenderAddGlyphsReq () {12;}' unless defined(&sz_xRenderAddGlyphsReq);
    eval 'sub sz_xRenderFreeGlyphsReq () {8;}' unless defined(&sz_xRenderFreeGlyphsReq);
    eval 'sub sz_xRenderCompositeGlyphs8Req () {28;}' unless defined(&sz_xRenderCompositeGlyphs8Req);
    eval 'sub sz_xRenderCompositeGlyphs16Req () {28;}' unless defined(&sz_xRenderCompositeGlyphs16Req);
    eval 'sub sz_xRenderCompositeGlyphs32Req () {28;}' unless defined(&sz_xRenderCompositeGlyphs32Req);
    eval 'sub sz_xRenderFillRectanglesReq () {20;}' unless defined(&sz_xRenderFillRectanglesReq);
    eval 'sub sz_xRenderCreateCursorReq () {16;}' unless defined(&sz_xRenderCreateCursorReq);
    eval 'sub sz_xRenderTransform () {36;}' unless defined(&sz_xRenderTransform);
    eval 'sub sz_xRenderSetPictureTransformReq () {44;}' unless defined(&sz_xRenderSetPictureTransformReq);
    eval 'sub sz_xRenderQueryFiltersReq () {8;}' unless defined(&sz_xRenderQueryFiltersReq);
    eval 'sub sz_xRenderQueryFiltersReply () {32;}' unless defined(&sz_xRenderQueryFiltersReply);
    eval 'sub sz_xRenderSetPictureFilterReq () {12;}' unless defined(&sz_xRenderSetPictureFilterReq);
    eval 'sub sz_xAnimCursorElt () {8;}' unless defined(&sz_xAnimCursorElt);
    eval 'sub sz_xRenderCreateAnimCursorReq () {8;}' unless defined(&sz_xRenderCreateAnimCursorReq);
    undef(&Window) if defined(&Window);
    undef(&Drawable) if defined(&Drawable);
    undef(&Font) if defined(&Font);
    undef(&Pixmap) if defined(&Pixmap);
    undef(&Cursor) if defined(&Cursor);
    undef(&Colormap) if defined(&Colormap);
    undef(&GContext) if defined(&GContext);
    undef(&Atom) if defined(&Atom);
    undef(&VisualID) if defined(&VisualID);
    undef(&Time) if defined(&Time);
    undef(&KeyCode) if defined(&KeyCode);
    undef(&KeySym) if defined(&KeySym);
    undef(&Picture) if defined(&Picture);
    undef(&PictFormat) if defined(&PictFormat);
    undef(&Fixed) if defined(&Fixed);
    undef(&Glyphset) if defined(&Glyphset);
    undef(&Glyph) if defined(&Glyph);
}
1;
