require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__XTRAPBITS__)) {
    eval 'sub __XTRAPBITS__ () {"@(#)xtrapbits.h	1.6 - 90/09/18  ";}' unless defined(&__XTRAPBITS__);
    eval 'sub BitsInByte () {8;}' unless defined(&BitsInByte);
    eval 'sub BitInByte {
        my($bit) = @_;
	    eval q((1 << ((($bit) %  &BitsInByte))));
    }' unless defined(&BitInByte);
    eval 'sub BitInWord {
        my($bit) = @_;
	    eval q((1 << ((($bit) % ( &BitsInByte * 2)))));
    }' unless defined(&BitInWord);
    eval 'sub BitInLong {
        my($bit) = @_;
	    eval q((1 << ((($bit) % ( &BitsInByte * 4)))));
    }' unless defined(&BitInLong);
    eval 'sub ByteInArray {
        my($array,$bit) = @_;
	    eval q(((( &UByteP)($array))[($bit) /  &BitsInByte]));
    }' unless defined(&ByteInArray);
    eval 'sub BitIsTrue {
        my($array,$bit) = @_;
	    eval q(( &ByteInArray($array,$bit) &  &BitInByte($bit)));
    }' unless defined(&BitIsTrue);
    eval 'sub BitIsFalse {
        my($array,$bit) = @_;
	    eval q((!( &BitIsTrue($array,$bit))));
    }' unless defined(&BitIsFalse);
    eval 'sub BitTrue {
        my($array,$bit) = @_;
	    eval q(( &ByteInArray($array,$bit) |=  &BitInByte($bit)));
    }' unless defined(&BitTrue);
    eval 'sub BitFalse {
        my($array,$bit) = @_;
	    eval q(( &ByteInArray($array,$bit) &= ~ &BitInByte($bit)));
    }' unless defined(&BitFalse);
    eval 'sub BitToggle {
        my($array,$bit) = @_;
	    eval q(( &ByteInArray($array,$bit) ^=  &BitInByte($bit)));
    }' unless defined(&BitToggle);
    eval 'sub BitCopy {
        my($dest,$src,$bit) = @_;
	    eval q( &BitIsTrue(($src),($bit)) ?  &BitTrue(($dest),($bit)) :  &BitFalse(($dest),($bit)));
    }' unless defined(&BitCopy);
    eval 'sub BitValue {
        my($array,$bit) = @_;
	    eval q(( &BitIsTrue(($array),($bit)) ?  &True :  &False));
    }' unless defined(&BitValue);
    eval 'sub BitSet {
        my($array,$bit,$value) = @_;
	    eval q(($value) ?  &BitTrue(($array),($bit)) :  &BitFalse(($array),($bit)));
    }' unless defined(&BitSet);
}
1;
