require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__XTRAPEMACROS__)) {
    eval 'sub __XTRAPEMACROS__ () {"@(#)xtrapemacros.h	1.9 - 90/09/18  ";}' unless defined(&__XTRAPEMACROS__);
    require 'X11/extensions/xtrapbits.ph';
    require 'signal.ph';
    eval 'sub msleep {
        my($m) = @_;
	    eval q( &usleep(($m)*1000));
    }' unless defined(&msleep);
    eval 'sub XECopyTC {
        my($src,$mask,$dest) = @_;
	    eval q(($dest =  &XECreateTC((($src)-> &dpy), ($mask), ((($src)-> &values)))));
    }' unless defined(&XECopyTC);
    eval 'sub XETrapSetCfgReqCB {
        my($tcv,$x) = @_;
	    eval q((($tcv)-> &req_cb = ($x)));
    }' unless defined(&XETrapSetCfgReqCB);
    eval 'sub XETrapSetCfgEvtCB {
        my($tcv,$x) = @_;
	    eval q((($tcv)-> &evt_cb = ($x)));
    }' unless defined(&XETrapSetCfgEvtCB);
    eval 'sub XETrapSetCfgMaxPktSize {
        my($tcv,$x) = @_;
	    eval q((($tcv)-> ($v->{max_pkt_size}) = ($x)));
    }' unless defined(&XETrapSetCfgMaxPktSize);
    eval 'sub XETrapSetCfgCmdKey {
        my($tcv,$x) = @_;
	    eval q((($tcv)-> ($v->{cmd_key}) = ($x)));
    }' unless defined(&XETrapSetCfgCmdKey);
    eval 'sub XETrapSetCfgFlags {
        my($tcv,$e,$a) = @_;
	    eval q( &memcpy(($tcv)-> ($v->{flags}->{e}), ($a), $sizeof{($tcv)-> ($v->{flags}->{e})}));
    }' unless defined(&XETrapSetCfgFlags);
    eval 'sub XETrapSetCfgFlagTimestamp {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapTimestamp, ($x)));
    }' unless defined(&XETrapSetCfgFlagTimestamp);
    eval 'sub XETrapSetCfgFlagCmd {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapCmd, ($x)));
    }' unless defined(&XETrapSetCfgFlagCmd);
    eval 'sub XETrapSetCfgFlagCmdKeyMod {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapCmdKeyMod, ($x)));
    }' unless defined(&XETrapSetCfgFlagCmdKeyMod);
    eval 'sub XETrapSetCfgFlagRequest {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapRequest, ($x)));
    }' unless defined(&XETrapSetCfgFlagRequest);
    eval 'sub XETrapSetCfgFlagEvent {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapEvent, ($x)));
    }' unless defined(&XETrapSetCfgFlagEvent);
    eval 'sub XETrapSetCfgFlagMaxPacket {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapMaxPacket, ($x)));
    }' unless defined(&XETrapSetCfgFlagMaxPacket);
    eval 'sub XETrapSetCfgFlagStatistics {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapStatistics, ($x)));
    }' unless defined(&XETrapSetCfgFlagStatistics);
    eval 'sub XETrapSetCfgFlagWinXY {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapWinXY, ($x)));
    }' unless defined(&XETrapSetCfgFlagWinXY);
    eval 'sub XETrapSetCfgFlagCursor {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapCursor, ($x)));
    }' unless defined(&XETrapSetCfgFlagCursor);
    eval 'sub XETrapSetCfgFlagReq {
        my($tcv,$request,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{req}), ($request), ($x)));
    }' unless defined(&XETrapSetCfgFlagReq);
    eval 'sub XETrapSetCfgFlagXInput {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapXInput, ($x)));
    }' unless defined(&XETrapSetCfgFlagXInput);
    eval 'sub XETrapSetCfgFlagColorReplies {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapColorReplies, ($x)));
    }' unless defined(&XETrapSetCfgFlagColorReplies);
    eval 'sub XETrapSetCfgFlagGrabServer {
        my($tcv,$e,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{e}),  &XETrapGrabServer, ($x)));
    }' unless defined(&XETrapSetCfgFlagGrabServer);
    eval 'sub XETrapSetCfgFlagEvt {
        my($tcv,$evt,$x) = @_;
	    eval q( &BitSet(($tcv)-> ($v->{flags}->{event}), ($evt), ($x)));
    }' unless defined(&XETrapSetCfgFlagEvt);
    eval 'sub XETrapSetValFlagDeltaTimes {
        my($tcv,$x) = @_;
	    eval q( &BitSet(($tcv)-> &tc_flags,  &XETCDeltaTimes, ($x)));
    }' unless defined(&XETrapSetValFlagDeltaTimes);
    eval 'sub XETrapGetAvailPFIdent {
        my($avail) = @_;
	    eval q((($avail)-> &pf_ident));
    }' unless defined(&XETrapGetAvailPFIdent);
    eval 'sub XETrapGetAvailRelease {
        my($avail) = @_;
	    eval q((($avail)-> &xtrap_release));
    }' unless defined(&XETrapGetAvailRelease);
    eval 'sub XETrapGetAvailVersion {
        my($avail) = @_;
	    eval q((($avail)-> &xtrap_version));
    }' unless defined(&XETrapGetAvailVersion);
    eval 'sub XETrapGetAvailRevision {
        my($avail) = @_;
	    eval q((($avail)-> &xtrap_revision));
    }' unless defined(&XETrapGetAvailRevision);
    eval 'sub XETrapGetAvailMaxPktSize {
        my($avail) = @_;
	    eval q((($avail)-> &max_pkt_size));
    }' unless defined(&XETrapGetAvailMaxPktSize);
    eval 'sub XETrapGetAvailFlags {
        my($avail,$a) = @_;
	    eval q( &memcpy(($a), ($avail)-> &valid, $sizeof{($avail)-> &valid}));
    }' unless defined(&XETrapGetAvailFlags);
    eval 'sub XETrapGetAvailFlagTimestamp {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapTimestamp)));
    }' unless defined(&XETrapGetAvailFlagTimestamp);
    eval 'sub XETrapGetAvailFlagCmd {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapCmd)));
    }' unless defined(&XETrapGetAvailFlagCmd);
    eval 'sub XETrapGetAvailFlagCmdKeyMod {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapCmdKeyMod)));
    }' unless defined(&XETrapGetAvailFlagCmdKeyMod);
    eval 'sub XETrapGetAvailFlagRequest {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapRequest)));
    }' unless defined(&XETrapGetAvailFlagRequest);
    eval 'sub XETrapGetAvailFlagEvent {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapEvent)));
    }' unless defined(&XETrapGetAvailFlagEvent);
    eval 'sub XETrapGetAvailFlagMaxPacket {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapMaxPacket)));
    }' unless defined(&XETrapGetAvailFlagMaxPacket);
    eval 'sub XETrapGetAvailFlagStatistics {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapStatistics)));
    }' unless defined(&XETrapGetAvailFlagStatistics);
    eval 'sub XETrapGetAvailFlagWinXY {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapWinXY)));
    }' unless defined(&XETrapGetAvailFlagWinXY);
    eval 'sub XETrapGetAvailFlagCursor {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapCursor)));
    }' unless defined(&XETrapGetAvailFlagCursor);
    eval 'sub XETrapGetAvailFlagXInput {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapXInput)));
    }' unless defined(&XETrapGetAvailFlagXInput);
    eval 'sub XETrapGetAvailFlagVecEvt {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapVectorEvents)));
    }' unless defined(&XETrapGetAvailFlagVecEvt);
    eval 'sub XETrapGetAvailFlagColorReplies {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapColorReplies)));
    }' unless defined(&XETrapGetAvailFlagColorReplies);
    eval 'sub XETrapGetAvailFlagGrabServer {
        my($avail) = @_;
	    eval q(( &BitValue(($avail)-> &valid,  &XETrapGrabServer)));
    }' unless defined(&XETrapGetAvailFlagGrabServer);
    eval 'sub XETrapGetAvailOpCode {
        my($avail) = @_;
	    eval q((($avail)-> &major_opcode));
    }' unless defined(&XETrapGetAvailOpCode);
    eval 'sub XETrapGetCfgMaxPktSize {
        my($cfg) = @_;
	    eval q((($cfg)-> &max_pkt_size));
    }' unless defined(&XETrapGetCfgMaxPktSize);
    eval 'sub XETrapGetCfgCmdKey {
        my($cfg) = @_;
	    eval q((($cfg)-> &cmd_key));
    }' unless defined(&XETrapGetCfgCmdKey);
    eval 'sub XETrapGetCfgFlags {
        my($cfg,$e,$a) = @_;
	    eval q( &memcpy(($a), ($cfg)-> ($flags->{e}), $sizeof{($cfg)-> ($flags->{e})}));
    }' unless defined(&XETrapGetCfgFlags);
    eval 'sub XETrapGetCfgFlagTimestamp {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapTimestamp)));
    }' unless defined(&XETrapGetCfgFlagTimestamp);
    eval 'sub XETrapGetCfgFlagCmd {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapCmd)));
    }' unless defined(&XETrapGetCfgFlagCmd);
    eval 'sub XETrapGetCfgFlagCmdKeyMod {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapCmdKeyMod)));
    }' unless defined(&XETrapGetCfgFlagCmdKeyMod);
    eval 'sub XETrapGetCfgFlagRequest {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapRequest)));
    }' unless defined(&XETrapGetCfgFlagRequest);
    eval 'sub XETrapGetCfgFlagEvent {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapEvent)));
    }' unless defined(&XETrapGetCfgFlagEvent);
    eval 'sub XETrapGetCfgFlagMaxPacket {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapMaxPacket)));
    }' unless defined(&XETrapGetCfgFlagMaxPacket);
    eval 'sub XETrapGetCfgFlagStatistics {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapStatistics)));
    }' unless defined(&XETrapGetCfgFlagStatistics);
    eval 'sub XETrapGetCfgFlagWinXY {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapWinXY)));
    }' unless defined(&XETrapGetCfgFlagWinXY);
    eval 'sub XETrapGetCfgFlagCursor {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapCursor)));
    }' unless defined(&XETrapGetCfgFlagCursor);
    eval 'sub XETrapGetCfgFlagXInput {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapXInput)));
    }' unless defined(&XETrapGetCfgFlagXInput);
    eval 'sub XETrapGetCfgFlagColorReplies {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapColorReplies)));
    }' unless defined(&XETrapGetCfgFlagColorReplies);
    eval 'sub XETrapGetCfgFlagGrabServer {
        my($cfg,$e) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{e}),  &XETrapGrabServer)));
    }' unless defined(&XETrapGetCfgFlagGrabServer);
    eval 'sub XETrapGetCfgFlagReq {
        my($cfg,$request) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{req}), ($request))));
    }' unless defined(&XETrapGetCfgFlagReq);
    eval 'sub XETrapGetCfgFlagEvt {
        my($cfg,$evt) = @_;
	    eval q(( &BitValue(($cfg)-> ($flags->{event}), ($evt))));
    }' unless defined(&XETrapGetCfgFlagEvt);
    eval 'sub XETrapGetCurX {
        my($avail) = @_;
	    eval q((($avail)-> &cur_x));
    }' unless defined(&XETrapGetCurX);
    eval 'sub XETrapGetCurY {
        my($avail) = @_;
	    eval q((($avail)-> &cur_y));
    }' unless defined(&XETrapGetCurY);
    eval 'sub XETrapGetCurSFlags {
        my($cur,$a) = @_;
	    eval q( &memcpy(($a), ($cur)-> &state_flags, $sizeof{($cur)-> &state_flags}));
    }' unless defined(&XETrapGetCurSFlags);
    eval 'sub XETrapGetCurMaxPktSize {
        my($cur) = @_;
	    eval q(( &XETrapGetCfgMaxPktSize((($cur)-> &config))));
    }' unless defined(&XETrapGetCurMaxPktSize);
    eval 'sub XETrapGetCurCmdKey {
        my($cur) = @_;
	    eval q(( &XETrapGetCfgCmdKey((($cur)-> &config))));
    }' unless defined(&XETrapGetCurCmdKey);
    eval 'sub XETrapGetCurCFlags {
        my($cur,$e,$a) = @_;
	    eval q(( &XETrapGetCfgFlags((($cur)-> &config),$e,$a)));
    }' unless defined(&XETrapGetCurCFlags);
    eval 'sub XETrapGetCurFlagTimestamp {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagTimestamp((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagTimestamp);
    eval 'sub XETrapGetCurFlagCmd {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagCmd((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagCmd);
    eval 'sub XETrapGetCurFlagCmdKeyMod {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagCmdKeyMod((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagCmdKeyMod);
    eval 'sub XETrapGetCurFlagRequest {
        my($cur,$r) = @_;
	    eval q(( &XETrapGetCfgFlagRequest((($cur)-> &config),$r)));
    }' unless defined(&XETrapGetCurFlagRequest);
    eval 'sub XETrapGetCurFlagEvent {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagEvent((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagEvent);
    eval 'sub XETrapGetCurFlagMaxPacket {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagMaxPacket((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagMaxPacket);
    eval 'sub XETrapGetCurFlagStatistics {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagStatistics((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagStatistics);
    eval 'sub XETrapGetCurFlagWinXY {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagWinXY((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagWinXY);
    eval 'sub XETrapGetCurFlagCursor {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagCursor((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagCursor);
    eval 'sub XETrapGetCurFlagXInput {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagXInput((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagXInput);
    eval 'sub XETrapGetCurFlagColorReplies {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagColorReplies((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagColorReplies);
    eval 'sub XETrapGetCurFlagGrabServer {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagGrabServer((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagGrabServer);
    eval 'sub XETrapGetCurFlagReq {
        my($cur,$r) = @_;
	    eval q(( &XETrapGetCfgFlagReq((($cur)-> &config),$r)));
    }' unless defined(&XETrapGetCurFlagReq);
    eval 'sub XETrapGetCurFlagEvt {
        my($cur,$e) = @_;
	    eval q(( &XETrapGetCfgFlagEvt((($cur)-> &config),$e)));
    }' unless defined(&XETrapGetCurFlagEvt);
    eval 'sub XETrapGetStatsReq {
        my($stat,$e) = @_;
	    eval q((($stat)-> $requests[($e)]));
    }' unless defined(&XETrapGetStatsReq);
    eval 'sub XETrapGetStatsEvt {
        my($stat,$e) = @_;
	    eval q((($stat)-> $events[($e)]));
    }' unless defined(&XETrapGetStatsEvt);
    eval 'sub XETrapGetVersRelease {
        my($vers) = @_;
	    eval q((($vers)-> &xtrap_release));
    }' unless defined(&XETrapGetVersRelease);
    eval 'sub XETrapGetVersVersion {
        my($vers) = @_;
	    eval q((($vers)-> &xtrap_version));
    }' unless defined(&XETrapGetVersVersion);
    eval 'sub XETrapGetVersRevision {
        my($vers) = @_;
	    eval q((($vers)-> &xtrap_revision));
    }' unless defined(&XETrapGetVersRevision);
    eval 'sub XETrapGetLastInpTime {
        my($time_rep) = @_;
	    eval q((($time_rep)-> &last_time));
    }' unless defined(&XETrapGetLastInpTime);
    eval 'sub XETrapGetTCReqCB {
        my($tc) = @_;
	    eval q((($tc)-> ($values->{req_cb})));
    }' unless defined(&XETrapGetTCReqCB);
    eval 'sub XETrapGetTCEvtCB {
        my($tc) = @_;
	    eval q((($tc)-> ($values->{evt_cb})));
    }' unless defined(&XETrapGetTCEvtCB);
    eval 'sub XETrapGetTCTime {
        my($tc) = @_;
	    eval q((($tc)-> ($values->{last_time})));
    }' unless defined(&XETrapGetTCTime);
    eval 'sub XETrapGetTCLFlags {
        my($tc,$a) = @_;
	    eval q( &memcpy(($a), ($tc)-> ($v$alues->{tc_flags}), $sizeof{($tc)-> ($v$alues->{tc_flags})}));
    }' unless defined(&XETrapGetTCLFlags);
    eval 'sub XETrapGetTCFlagDeltaTimes {
        my($tc) = @_;
	    eval q(( &BitValue(($tc)-> ($values->{tc_flags}),  &XETCDeltaTimes)));
    }' unless defined(&XETrapGetTCFlagDeltaTimes);
    eval 'sub XETrapGetTCFlagTrapActive {
        my($tc) = @_;
	    eval q(( &BitValue(($tc)-> ($values->{tc_flags}),  &XETCTrapActive)));
    }' unless defined(&XETrapGetTCFlagTrapActive);
    eval 'sub XETrapGetTCMaxPktSize {
        my($tc) = @_;
	    eval q(( &XETrapGetCfgMaxPktSize((($tc)-> ($values->{v})))));
    }' unless defined(&XETrapGetTCMaxPktSize);
    eval 'sub XETrapGetTCCmdKey {
        my($tc) = @_;
	    eval q(( &XETrapGetCfgCmdKey((($tc)-> ($values->{v})))));
    }' unless defined(&XETrapGetTCCmdKey);
    eval 'sub XETrapGetTCFlags {
        my($tc,$e,$a) = @_;
	    eval q(( &XETrapGetCfgFlags((($tc)-> ($v$alues->{v})),$e,$a)));
    }' unless defined(&XETrapGetTCFlags);
    eval 'sub XETrapGetTCFlagTimestamp {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagTimestamp((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagTimestamp);
    eval 'sub XETrapGetTCFlagCmd {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagCmd((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagCmd);
    eval 'sub XETrapGetTCFlagCmdKeyMod {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagCmdKeyMod((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagCmdKeyMod);
    eval 'sub XETrapGetTCFlagRequest {
        my($tc,$r) = @_;
	    eval q(( &XETrapGetCfgFlagRequest((($tc)-> ($values->{v})),$r)));
    }' unless defined(&XETrapGetTCFlagRequest);
    eval 'sub XETrapGetTCFlagEvent {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagEvent((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagEvent);
    eval 'sub XETrapGetTCFlagMaxPacket {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagMaxPacket((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagMaxPacket);
    eval 'sub XETrapGetTCFlagStatistics {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagStatistics((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagStatistics);
    eval 'sub XETrapGetTCFlagWinXY {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagWinXY((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagWinXY);
    eval 'sub XETrapGetTCFlagCursor {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagCursor((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagCursor);
    eval 'sub XETrapGetTCFlagXInput {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagXInput((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagXInput);
    eval 'sub XETrapGetTCFlagColorReplies {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagColorReplies((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagColorReplies);
    eval 'sub XETrapGetTCFlagGrabServer {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagGrabServer((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagGrabServer);
    eval 'sub XETrapGetTCFlagReq {
        my($tc,$r) = @_;
	    eval q(( &XETrapGetCfgFlagReq((($tc)-> ($values->{v})),$r)));
    }' unless defined(&XETrapGetTCFlagReq);
    eval 'sub XETrapGetTCFlagEvt {
        my($tc,$e) = @_;
	    eval q(( &XETrapGetCfgFlagEvt((($tc)-> ($values->{v})),$e)));
    }' unless defined(&XETrapGetTCFlagEvt);
    eval 'sub XETrapGetNext {
        my($tc) = @_;
	    eval q((($tc)-> &next));
    }' unless defined(&XETrapGetNext);
    eval 'sub XETrapGetDpy {
        my($tc) = @_;
	    eval q((($tc)-> &dpy));
    }' unless defined(&XETrapGetDpy);
    eval 'sub XETrapGetEventBase {
        my($tc) = @_;
	    eval q((($tc)-> &eventBase));
    }' unless defined(&XETrapGetEventBase);
    eval 'sub XETrapGetErrorBase {
        my($tc) = @_;
	    eval q((($tc)-> &errorBase));
    }' unless defined(&XETrapGetErrorBase);
    eval 'sub XETrapGetExtOpcode {
        my($tc) = @_;
	    eval q((($tc)-> &extOpcode));
    }' unless defined(&XETrapGetExtOpcode);
    eval 'sub XETrapGetXBuff {
        my($tc) = @_;
	    eval q((($tc)-> &xbuff));
    }' unless defined(&XETrapGetXBuff);
    eval 'sub XETrapGetXMaxSize {
        my($tc) = @_;
	    eval q((($tc)-> &xmax_size));
    }' unless defined(&XETrapGetXMaxSize);
    eval 'sub XETrapGetExt {
        my($tc) = @_;
	    eval q((($tc)-> &ext_data));
    }' unless defined(&XETrapGetExt);
    eval 'sub XETrapGetDirty {
        my($tc) = @_;
	    eval q((($tc)-> &dirty));
    }' unless defined(&XETrapGetDirty);
    eval 'sub XETrapGetValues {
        my($tc) = @_;
	    eval q( &memcpy(( &x),($tc)-> &values,$sizeof{($tc)-> &values}));
    }' unless defined(&XETrapGetValues);
    eval 'sub XETrapGetEventFunc {
        my($tc) = @_;
	    eval q((($tc)-> &eventFunc));
    }' unless defined(&XETrapGetEventFunc);
    eval 'sub XETrapGetHeaderCount {
        my($phdr) = @_;
	    eval q((($phdr)-> &count));
    }' unless defined(&XETrapGetHeaderCount);
    eval 'sub XETrapGetHeaderTimestamp {
        my($phdr) = @_;
	    eval q((($phdr)-> &timestamp));
    }' unless defined(&XETrapGetHeaderTimestamp);
    eval 'sub XETrapGetHeaderType {
        my($phdr) = @_;
	    eval q((($phdr)-> &type));
    }' unless defined(&XETrapGetHeaderType);
    eval 'sub XETrapGetHeaderScreen {
        my($phdr) = @_;
	    eval q((($phdr)-> &screen));
    }' unless defined(&XETrapGetHeaderScreen);
    eval 'sub XETrapGetHeaderWindowX {
        my($phdr) = @_;
	    eval q((($phdr)-> &win_x));
    }' unless defined(&XETrapGetHeaderWindowX);
    eval 'sub XETrapGetHeaderWindowY {
        my($phdr) = @_;
	    eval q((($phdr)-> &win_y));
    }' unless defined(&XETrapGetHeaderWindowY);
    eval 'sub XETrapGetHeaderClient {
        my($phdr) = @_;
	    eval q((($phdr)-> &client));
    }' unless defined(&XETrapGetHeaderClient);
    eval 'sub XEGetRelease {
        my($tc) = @_;
	    eval q((($tc)-> &release));
    }' unless defined(&XEGetRelease);
    eval 'sub XEGetVersion {
        my($tc) = @_;
	    eval q((($tc)-> &version));
    }' unless defined(&XEGetVersion);
    eval 'sub XEGetRevision {
        my($tc) = @_;
	    eval q((($tc)-> &revision));
    }' unless defined(&XEGetRevision);
    if(!defined( &vms)  && (!defined( &_InitExceptionHandling) || !defined( &_ClearExceptionHandling))) {
	unless(defined(&_SetSIGBUSHandling)) {
	    if(defined(&SIGBUS)) {
		eval 'sub _SetSIGBUSHandling {
		    my($rtn) = @_;
    		    eval q(( &void) &signal( &SIGBUS, $rtn));
		}' unless defined(&_SetSIGBUSHandling);
	    } else {
		eval 'sub _SetSIGBUSHandling {
		    my($rtn) = @_;
    		    eval q();
		}' unless defined(&_SetSIGBUSHandling);
	    }
	}
	unless(defined(&_SetSIGSEGVHandling)) {
	    if(defined(&SIGSEGV)) {
		eval 'sub _SetSIGSEGVHandling {
		    my($rtn) = @_;
    		    eval q(( &void) &signal( &SIGSEGV, $rtn));
		}' unless defined(&_SetSIGSEGVHandling);
	    } else {
		eval 'sub _SetSIGSEGVHandling {
		    my($rtn) = @_;
    		    eval q();
		}' unless defined(&_SetSIGSEGVHandling);
	    }
	}
	unless(defined(&_SetSIGFPEHandling)) {
	    if(defined(&SIGFPE)) {
		eval 'sub _SetSIGFPEHandling {
		    my($rtn) = @_;
    		    eval q(( &void) &signal( &SIGFPE, $rtn));
		}' unless defined(&_SetSIGFPEHandling);
	    } else {
		eval 'sub _SetSIGFPEHandling {
		    my($rtn) = @_;
    		    eval q();
		}' unless defined(&_SetSIGFPEHandling);
	    }
	}
	unless(defined(&_SetSIGILLHandling)) {
	    if(defined(&SIGILL)) {
		eval 'sub _SetSIGILLHandling {
		    my($rtn) = @_;
    		    eval q(( &void) &signal( &SIGILL, $rtn));
		}' unless defined(&_SetSIGILLHandling);
	    } else {
		eval 'sub _SetSIGILLHandling {
		    my($rtn) = @_;
    		    eval q();
		}' unless defined(&_SetSIGILLHandling);
	    }
	}
	unless(defined(&_SetSIGSYSHandling)) {
	    if(defined(&SIGSYS)) {
		eval 'sub _SetSIGSYSHandling {
		    my($rtn) = @_;
    		    eval q(( &void) &signal( &SIGSYS, $rtn));
		}' unless defined(&_SetSIGSYSHandling);
	    } else {
		eval 'sub _SetSIGSYSHandling {
		    my($rtn) = @_;
    		    eval q();
		}' unless defined(&_SetSIGSYSHandling);
	    }
	}
	unless(defined(&_SetSIGHUPHandling)) {
	    if(defined(&SIGHUP)) {
		eval 'sub _SetSIGHUPHandling {
		    my($rtn) = @_;
    		    eval q(( &void) &signal( &SIGHUP, $rtn));
		}' unless defined(&_SetSIGHUPHandling);
	    } else {
		eval 'sub _SetSIGHUPHandling {
		    my($rtn) = @_;
    		    eval q();
		}' unless defined(&_SetSIGHUPHandling);
	    }
	}
	unless(defined(&_SetSIGPIPEHandling)) {
	    if(defined(&SIGPIPE)) {
		eval 'sub _SetSIGPIPEHandling {
		    my($rtn) = @_;
    		    eval q(( &void) &signal( &SIGPIPE, $rtn));
		}' unless defined(&_SetSIGPIPEHandling);
	    } else {
		eval 'sub _SetSIGPIPEHandling {
		    my($rtn) = @_;
    		    eval q();
		}' unless defined(&_SetSIGPIPEHandling);
	    }
	}
	unless(defined(&_SetSIGTERMHandling)) {
	    if(defined(&SIGTERM)) {
		eval 'sub _SetSIGTERMHandling {
		    my($rtn) = @_;
    		    eval q(( &void) &signal( &SIGTERM, $rtn));
		}' unless defined(&_SetSIGTERMHandling);
	    } else {
		eval 'sub _SetSIGTERMHandling {
		    my($rtn) = @_;
    		    eval q();
		}' unless defined(&_SetSIGTERMHandling);
	    }
	}
    }
    unless(defined(&_InitExceptionHandling)) {
	if(defined(&vms)) {
	    eval 'sub _InitExceptionHandling {
	        my($rtn) = @_;
    		eval q( &VAXC$ &ESTABLISH($rtn));
	    }' unless defined(&_InitExceptionHandling);
	} else {
	    eval 'sub _InitExceptionHandling {
	        my($rtn) = @_;
    		eval q( &_SetSIGBUSHandling($rtn);  &_SetSIGSEGVHandling($rtn);  &_SetSIGFPEHandling($rtn);  &_SetSIGILLHandling($rtn);  &_SetSIGSYSHandling($rtn);  &_SetSIGHUPHandling($rtn);  &_SetSIGPIPEHandling($rtn);  &_SetSIGTERMHandling($rtn));
	    }' unless defined(&_InitExceptionHandling);
	}
    }
    unless(defined(&_ClearExceptionHandling)) {
	if(defined(&vms)) {
	    eval 'sub _ClearExceptionHandling () {
	        eval q( &LIB$ &REVERT());
	    }' unless defined(&_ClearExceptionHandling);
	} else {
	    eval 'sub _ClearExceptionHandling () {
	        eval q( &_SetSIGBUSHandling( &SIG_DFL);  &_SetSIGSEGVHandling( &SIG_DFL);  &_SetSIGFPEHandling( &SIG_DFL);  &_SetSIGILLHandling( &SIG_DFL);  &_SetSIGSYSHandling( &SIG_DFL);  &_SetSIGHUPHandling( &SIG_DFL);  &_SetSIGPIPEHandling( &SIG_DFL);  &_SetSIGTERMHandling( &SIG_DFL));
	    }' unless defined(&_ClearExceptionHandling);
	}
    }
}
1;
