require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_FSLIB_H_)) {
    eval 'sub _FSLIB_H_ () {1;}' unless defined(&_FSLIB_H_);
    require 'X11/Xfuncproto.ph';
    require 'X11/fonts/FS.ph';
    require 'X11/fonts/FSproto.ph';
    eval 'sub Bool () {\'int\';}' unless defined(&Bool);
    eval 'sub Status () {\'int\';}' unless defined(&Status);
    eval 'sub True () {1;}' unless defined(&True);
    eval 'sub False () {0;}' unless defined(&False);
    eval 'sub QueuedAlready () {0;}' unless defined(&QueuedAlready);
    eval 'sub QueuedAfterReading () {1;}' unless defined(&QueuedAfterReading);
    eval 'sub QueuedAfterFlush () {2;}' unless defined(&QueuedAfterFlush);
    eval 'sub FSServerString {
        my($svr) = @_;
	    eval q((($svr)-> &server_name));
    }' unless defined(&FSServerString);
    eval 'sub FSVendorRelease {
        my($svr) = @_;
	    eval q((($svr)-> &release));
    }' unless defined(&FSVendorRelease);
    eval 'sub FSProtocolVersion {
        my($svr) = @_;
	    eval q((($svr)-> &proto_version));
    }' unless defined(&FSProtocolVersion);
    eval 'sub FSServerVendor {
        my($svr) = @_;
	    eval q((($svr)-> &vendor));
    }' unless defined(&FSServerVendor);
    eval 'sub FSAuthorizationData {
        my($svr) = @_;
	    eval q((($svr)-> &auth_data));
    }' unless defined(&FSAuthorizationData);
    eval 'sub FSAlternateServers {
        my($svr) = @_;
	    eval q((($svr)-> &alternate_servers));
    }' unless defined(&FSAlternateServers);
    eval 'sub FSNumAlternateServers {
        my($svr) = @_;
	    eval q((($svr)-> &num_alternates));
    }' unless defined(&FSNumAlternateServers);
    eval 'sub FSQLength {
        my($svr) = @_;
	    eval q((($svr)-> &qlen));
    }' unless defined(&FSQLength);
    eval 'sub FSNextRequest {
        my($svr) = @_;
	    eval q((($svr)-> &request + 1));
    }' unless defined(&FSNextRequest);
    eval 'sub FSLastKnownRequestProcessed {
        my($svr) = @_;
	    eval q((($svr)-> &last_request_read));
    }' unless defined(&FSLastKnownRequestProcessed);
    eval 'sub FSAllocID {
        my($svr) = @_;
	    eval q(((*($svr)-> &resource_alloc)(($svr))));
    }' unless defined(&FSAllocID);
}
1;
