require '_h2ph_pre.ph';

no warnings 'redefine';

if((!defined( &__CODECONV_H))) {
    eval 'sub __CODECONV_H () {1;}' unless defined(&__CODECONV_H);
    eval 'sub _CCMAJOR () {1;}' unless defined(&_CCMAJOR);
    eval 'sub _CCMINOR () {0;}' unless defined(&_CCMINOR);
    eval 'sub MOD_TYPE_CODECONV () {"CCCV/Character Code ConVerter v1.0";}' unless defined(&MOD_TYPE_CODECONV);
    eval 'sub DECLARE_SUBREQ {
        my($cconvSubReq) = @_;
	    eval q( &static  &XF86ModReqInfo $cconvSubReq = {  &_XTT_V_MAJOR,  &_XTT_V_MINOR,  &_XTT_V_REVISION,  &ABI_CLASS_ANSIC,  &ABI_VERS_UNSPEC,  &MOD_CLASS_FONT };);
    }' unless defined(&DECLARE_SUBREQ);
    eval 'sub CCONVVERSION {
        my($name) = @_;
	    eval q( &PREDEFCCONVVERSION($name));
    }' unless defined(&CCONVVERSION);
    eval 'sub PREDEFCCONVVERSION {
        my($name) = @_;
	    eval q( &static  &XF86ModuleVersionInfo $name   &VersRec = { $name,  &_XTT_VENDOR_NAME,  &MODINFOSTRING1,  &MODINFOSTRING2,  &XF86_VERSION_CURRENT,  &_XTT_V_MAJOR,  &_XTT_V_MINOR,  &_XTT_V_REVISION,  &ABI_CLASS_FONT,  &ABI_FONT_VERSION,  &MOD_CLASS_FONT, {0,0,0,0} };);
    }' unless defined(&PREDEFCCONVVERSION);
    eval 'sub CCONVINIT {
        my($name) = @_;
	    eval q( &PREDEFCCONVINIT($name));
    }' unless defined(&CCONVINIT);
    eval 'sub PREDEFCCONVINIT {
        my($name) = @_;
	    eval q( &XF86ModuleData $name   &ModuleData = { & $name   &VersRec, $name   &Setup,  &NULL, };);
    }' unless defined(&PREDEFCCONVINIT);
    eval 'sub CCONVSETUP {
        my($name) = @_;
	    eval q( &PREDEFCCONVSETUP($name));
    }' unless defined(&CCONVSETUP);
    if(defined(&CCONV_USE_SYMBOLIC_ENTRY_POINT)) {
	eval 'sub PREDEFCCONVSETUP {
	    my($name) = @_;
    	    eval q(\'char\'* $name   &_entrypointName = {$name\\"_entrypoint\\"}; &static  &pointer $name   &Setup( &pointer  &module,  &pointer  &opts, \'int\' * &errmaj, \'int\' * &errmin) {  &ModuleSetupArg * &moduleArg = ( &ModuleSetupArg*) &opts;  &return ( &pointer) $name   &_entrypoint (  ($moduleArg->{charSetHints}),  ($moduleArg->{refCodeConverterInfo}),  ($moduleArg->{refMapID})); });
	}' unless defined(&PREDEFCCONVSETUP);
    } else {
	eval 'sub PREDEFCCONVSETUP {
	    my($name) = @_;
    	    eval q( &static  &pointer $name   &Setup( &pointer  &module,  &pointer  &opts, \'int\' * &errmaj, \'int\' * &errmin) {  &ModuleSetupArg * &moduleArg = ( &ModuleSetupArg*) &opts;  &return ( &pointer) $name   &_entrypoint (  ($moduleArg->{charSetHints}),  ($moduleArg->{refCodeConverterInfo}),  ($moduleArg->{refMapID})); });
	}' unless defined(&PREDEFCCONVSETUP);
    }
    eval 'sub CCONV_MODULE_SETUP () { &CCONVVERSION( &MODNAME)  &CCONVSETUP( &MODNAME)  &CCONVINIT( &MODNAME);}' unless defined(&CCONV_MODULE_SETUP);
}
1;
