require '_h2ph_pre.ph';

no warnings 'redefine';

require 'linux/apm_bios.ph';
require 'sys/types.ph';
unless(defined(&APM_PROC)) {
    sub APM_PROC () {	"/proc/apm";}
}
unless(defined(&APM_DEVICE)) {
    sub APM_DEVICE () {	"/dev/apm_bios";}
}
unless(defined(&APM_DEV)) {
    sub APM_DEV () {	"/proc/devices";}
}
unless(defined(&APM_NAME)) {
    sub APM_NAME () {	"apm_bios";}
}
unless(defined(&APM_32_BIT_SUPPORT)) {
    eval 'sub APM_32_BIT_SUPPORT () {0x2;}' unless defined(&APM_32_BIT_SUPPORT);
}
unless(defined(&SUSPEND)) {
    sub SUSPEND () {	0;}
}
unless(defined(&STANDBY)) {
    sub STANDBY () {	1;}
}
unless(defined(&IGNORE)) {
    sub IGNORE () {	2;}
}
unless(defined(&NOIGNORE)) {
    sub NOIGNORE () {	3;}
}
if(defined(&APM_IOC_REJECT)) {
    eval 'sub APM_REJECT_ENABLED () {1;}' unless defined(&APM_REJECT_ENABLED);
}
1;
