require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_GLIBCPP_GCC_GTHR_POSIX_H)) {
    eval 'sub _GLIBCPP_GCC_GTHR_POSIX_H () {1;}' unless defined(&_GLIBCPP_GCC_GTHR_POSIX_H);
    eval 'sub __GTHREADS () {1;}' unless defined(&__GTHREADS);
    require 'pthread.ph';
    eval 'sub __GTHREAD_MUTEX_INIT () { &PTHREAD_MUTEX_INITIALIZER;}' unless defined(&__GTHREAD_MUTEX_INIT);
    eval 'sub __GTHREAD_ONCE_INIT () { &PTHREAD_ONCE_INIT;}' unless defined(&__GTHREAD_ONCE_INIT);
    if((defined(&_GLIBCPP_SUPPORTS_WEAK) ? &_GLIBCPP_SUPPORTS_WEAK : 0)  && (defined(&_GLIBCPP_GTHREAD_USE_WEAK) ? &_GLIBCPP_GTHREAD_USE_WEAK : 0)) {
	if(defined(&_LIBOBJC)) {
	}
	eval 'sub __gthread_active_p {
	    my($void) = @_;
    	    eval q({ $void * &const  &__gthread_active_ptr = ($void *)  &pthread_create;  &__gthread_active_ptr != 0; });
	}' unless defined(&__gthread_active_p);
    } else {
	eval 'sub __gthread_active_p {
	    my($void) = @_;
    	    eval q({ 1; });
	}' unless defined(&__gthread_active_p);
    }
    if(defined(&_LIBOBJC)) {
	require 'config.ph';
	if(defined(&HAVE_SCHED_H)) {
	    require 'sched.ph';
	}
    } else {
	eval 'sub __gthread_once {
	    eval q(( &__gthread_once_t * &once,  &void (* &func) ( &void)) {  &if ( &__gthread_active_p ())  &pthread_once ( &once,  &func);  &else -1; });
	}' unless defined(&__gthread_once);
	eval 'sub __gthread_key_create {
	    eval q(( &__gthread_key_t * &key,  &void (* &dtor) ( &void *)) {  &pthread_key_create ( &key,  &dtor); });
	}' unless defined(&__gthread_key_create);
	eval 'sub __gthread_key_dtor {
	    my($key,$ptr) = @_;
    	    eval q({  &if ($ptr)  &pthread_setspecific ($key, 0);  &else 0; });
	}' unless defined(&__gthread_key_dtor);
	eval 'sub __gthread_key_delete {
	    my($key) = @_;
    	    eval q({  &pthread_key_delete ($key); });
	}' unless defined(&__gthread_key_delete);
	eval 'sub __gthread_getspecific {
	    my($key) = @_;
    	    eval q({  &pthread_getspecific ($key); });
	}' unless defined(&__gthread_getspecific);
	eval 'sub __gthread_setspecific {
	    my($key,$ptr) = @_;
    	    eval q({  &pthread_setspecific ($key, $ptr); });
	}' unless defined(&__gthread_setspecific);
	eval 'sub __gthread_mutex_lock {
	    my($mutex) = @_;
    	    eval q({  &if ( &__gthread_active_p ())  &pthread_mutex_lock ($mutex);  &else 0; });
	}' unless defined(&__gthread_mutex_lock);
	eval 'sub __gthread_mutex_trylock {
	    my($mutex) = @_;
    	    eval q({  &if ( &__gthread_active_p ())  &pthread_mutex_trylock ($mutex);  &else 0; });
	}' unless defined(&__gthread_mutex_trylock);
	eval 'sub __gthread_mutex_unlock {
	    my($mutex) = @_;
    	    eval q({  &if ( &__gthread_active_p ())  &pthread_mutex_unlock ($mutex);  &else 0; });
	}' unless defined(&__gthread_mutex_unlock);
    }
}
1;
