require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ECPG_ERROR_H)) {
    eval 'sub _ECPG_ERROR_H () {1;}' unless defined(&_ECPG_ERROR_H);
    require 'errno.ph';
    eval 'sub ECPG_NO_ERROR () {0;}' unless defined(&ECPG_NO_ERROR);
    eval 'sub ECPG_NOT_FOUND () {100;}' unless defined(&ECPG_NOT_FOUND);
    eval 'sub ECPG_OUT_OF_MEMORY () {- &ENOMEM;}' unless defined(&ECPG_OUT_OF_MEMORY);
    eval 'sub ECPG_UNSUPPORTED () {-200;}' unless defined(&ECPG_UNSUPPORTED);
    eval 'sub ECPG_TOO_MANY_ARGUMENTS () {-201;}' unless defined(&ECPG_TOO_MANY_ARGUMENTS);
    eval 'sub ECPG_TOO_FEW_ARGUMENTS () {-202;}' unless defined(&ECPG_TOO_FEW_ARGUMENTS);
    eval 'sub ECPG_TOO_MANY_MATCHES () {-203;}' unless defined(&ECPG_TOO_MANY_MATCHES);
    eval 'sub ECPG_INT_FORMAT () {-204;}' unless defined(&ECPG_INT_FORMAT);
    eval 'sub ECPG_UINT_FORMAT () {-205;}' unless defined(&ECPG_UINT_FORMAT);
    eval 'sub ECPG_FLOAT_FORMAT () {-206;}' unless defined(&ECPG_FLOAT_FORMAT);
    eval 'sub ECPG_CONVERT_BOOL () {-207;}' unless defined(&ECPG_CONVERT_BOOL);
    eval 'sub ECPG_EMPTY () {-208;}' unless defined(&ECPG_EMPTY);
    eval 'sub ECPG_MISSING_INDICATOR () {-209;}' unless defined(&ECPG_MISSING_INDICATOR);
    eval 'sub ECPG_NO_ARRAY () {-210;}' unless defined(&ECPG_NO_ARRAY);
    eval 'sub ECPG_DATA_NOT_ARRAY () {-211;}' unless defined(&ECPG_DATA_NOT_ARRAY);
    eval 'sub ECPG_ARRAY_INSERT () {-212;}' unless defined(&ECPG_ARRAY_INSERT);
    eval 'sub ECPG_NO_CONN () {-220;}' unless defined(&ECPG_NO_CONN);
    eval 'sub ECPG_NOT_CONN () {-221;}' unless defined(&ECPG_NOT_CONN);
    eval 'sub ECPG_INVALID_STMT () {-230;}' unless defined(&ECPG_INVALID_STMT);
    eval 'sub ECPG_UNKNOWN_DESCRIPTOR () {-240;}' unless defined(&ECPG_UNKNOWN_DESCRIPTOR);
    eval 'sub ECPG_INVALID_DESCRIPTOR_INDEX () {-241;}' unless defined(&ECPG_INVALID_DESCRIPTOR_INDEX);
    eval 'sub ECPG_UNKNOWN_DESCRIPTOR_ITEM () {-242;}' unless defined(&ECPG_UNKNOWN_DESCRIPTOR_ITEM);
    eval 'sub ECPG_VAR_NOT_NUMERIC () {-243;}' unless defined(&ECPG_VAR_NOT_NUMERIC);
    eval 'sub ECPG_VAR_NOT_CHAR () {-244;}' unless defined(&ECPG_VAR_NOT_CHAR);
    eval 'sub ECPG_PGSQL () {-400;}' unless defined(&ECPG_PGSQL);
    eval 'sub ECPG_TRANS () {-401;}' unless defined(&ECPG_TRANS);
    eval 'sub ECPG_CONNECT () {-402;}' unless defined(&ECPG_CONNECT);
    eval 'sub ECPG_WARNING_UNRECOGNIZED () {-600;}' unless defined(&ECPG_WARNING_UNRECOGNIZED);
    eval 'sub ECPG_WARNING_QUERY_IGNORED () {-601;}' unless defined(&ECPG_WARNING_QUERY_IGNORED);
    eval 'sub ECPG_WARNING_UNKNOWN_PORTAL () {-602;}' unless defined(&ECPG_WARNING_UNKNOWN_PORTAL);
    eval 'sub ECPG_WARNING_IN_TRANSACTION () {-603;}' unless defined(&ECPG_WARNING_IN_TRANSACTION);
    eval 'sub ECPG_WARNING_NO_TRANSACTION () {-604;}' unless defined(&ECPG_WARNING_NO_TRANSACTION);
    eval 'sub ECPG_WARNING_PORTAL_EXISTS () {-605;}' unless defined(&ECPG_WARNING_PORTAL_EXISTS);
}
1;
