require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ESD_H)) {
    eval 'sub ESD_H () {1;}' unless defined(&ESD_H);
    require 'audiofile.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub ESD_UNIX_SOCKET_DIR () { &esd_get_socket_dirname();}' unless defined(&ESD_UNIX_SOCKET_DIR);
    eval 'sub ESD_UNIX_SOCKET_NAME () { &esd_get_socket_name();}' unless defined(&ESD_UNIX_SOCKET_NAME);
    eval 'sub ESD_BUF_SIZE () {(4* 1024);}' unless defined(&ESD_BUF_SIZE);
    eval 'sub ESD_KEY_LEN () {(16);}' unless defined(&ESD_KEY_LEN);
    eval 'sub ESD_DEFAULT_PORT () {(16001);}' unless defined(&ESD_DEFAULT_PORT);
    eval 'sub ESD_DEFAULT_RATE () {(44100);}' unless defined(&ESD_DEFAULT_RATE);
    eval 'sub ESD_NAME_MAX () {(128);}' unless defined(&ESD_NAME_MAX);
    eval 'sub ESD_ENDIAN_KEY () {( ( (ord(\'E\' << 24) + (\'N\' << 16) + (\'D\' << 8) + (\'N\')) ) );}' unless defined(&ESD_ENDIAN_KEY);
    eval 'sub ESD_VOLUME_BASE () {(256);}' unless defined(&ESD_VOLUME_BASE);
    eval("sub ESD_PROTO_CONNECT () { 0; }") unless defined(&ESD_PROTO_CONNECT);
    eval("sub ESD_PROTO_LOCK () { 1; }") unless defined(&ESD_PROTO_LOCK);
    eval("sub ESD_PROTO_UNLOCK () { 2; }") unless defined(&ESD_PROTO_UNLOCK);
    eval("sub ESD_PROTO_STREAM_PLAY () { 3; }") unless defined(&ESD_PROTO_STREAM_PLAY);
    eval("sub ESD_PROTO_STREAM_REC () { 4; }") unless defined(&ESD_PROTO_STREAM_REC);
    eval("sub ESD_PROTO_STREAM_MON () { 5; }") unless defined(&ESD_PROTO_STREAM_MON);
    eval("sub ESD_PROTO_SAMPLE_CACHE () { 6; }") unless defined(&ESD_PROTO_SAMPLE_CACHE);
    eval("sub ESD_PROTO_SAMPLE_FREE () { 7; }") unless defined(&ESD_PROTO_SAMPLE_FREE);
    eval("sub ESD_PROTO_SAMPLE_PLAY () { 8; }") unless defined(&ESD_PROTO_SAMPLE_PLAY);
    eval("sub ESD_PROTO_SAMPLE_LOOP () { 9; }") unless defined(&ESD_PROTO_SAMPLE_LOOP);
    eval("sub ESD_PROTO_SAMPLE_STOP () { 10; }") unless defined(&ESD_PROTO_SAMPLE_STOP);
    eval("sub ESD_PROTO_SAMPLE_KILL () { 11; }") unless defined(&ESD_PROTO_SAMPLE_KILL);
    eval("sub ESD_PROTO_STANDBY () { 12; }") unless defined(&ESD_PROTO_STANDBY);
    eval("sub ESD_PROTO_RESUME () { 13; }") unless defined(&ESD_PROTO_RESUME);
    eval("sub ESD_PROTO_SAMPLE_GETID () { 14; }") unless defined(&ESD_PROTO_SAMPLE_GETID);
    eval("sub ESD_PROTO_STREAM_FILT () { 15; }") unless defined(&ESD_PROTO_STREAM_FILT);
    eval("sub ESD_PROTO_SERVER_INFO () { 16; }") unless defined(&ESD_PROTO_SERVER_INFO);
    eval("sub ESD_PROTO_ALL_INFO () { 17; }") unless defined(&ESD_PROTO_ALL_INFO);
    eval("sub ESD_PROTO_SUBSCRIBE () { 18; }") unless defined(&ESD_PROTO_SUBSCRIBE);
    eval("sub ESD_PROTO_UNSUBSCRIBE () { 19; }") unless defined(&ESD_PROTO_UNSUBSCRIBE);
    eval("sub ESD_PROTO_STREAM_PAN () { 20; }") unless defined(&ESD_PROTO_STREAM_PAN);
    eval("sub ESD_PROTO_SAMPLE_PAN () { 21; }") unless defined(&ESD_PROTO_SAMPLE_PAN);
    eval("sub ESD_PROTO_STANDBY_MODE () { 22; }") unless defined(&ESD_PROTO_STANDBY_MODE);
    eval("sub ESD_PROTO_LATENCY () { 23; }") unless defined(&ESD_PROTO_LATENCY);
    eval("sub ESD_PROTO_MAX () { 24; }") unless defined(&ESD_PROTO_MAX);
    eval 'sub ESD_MASK_BITS () {( 0xf );}' unless defined(&ESD_MASK_BITS);
    eval 'sub ESD_BITS8 () {( 0x );}' unless defined(&ESD_BITS8);
    eval 'sub ESD_BITS16 () {( 0x1 );}' unless defined(&ESD_BITS16);
    eval 'sub ESD_MASK_CHAN () {( 0xf0 );}' unless defined(&ESD_MASK_CHAN);
    eval 'sub ESD_MONO () {( 0x10 );}' unless defined(&ESD_MONO);
    eval 'sub ESD_STEREO () {( 0x20 );}' unless defined(&ESD_STEREO);
    eval 'sub ESD_MASK_MODE () {( 0xf00 );}' unless defined(&ESD_MASK_MODE);
    eval 'sub ESD_STREAM () {( 0x );}' unless defined(&ESD_STREAM);
    eval 'sub ESD_SAMPLE () {( 0x100 );}' unless defined(&ESD_SAMPLE);
    eval 'sub ESD_ADPCM () {( 0x200 );}' unless defined(&ESD_ADPCM);
    eval 'sub ESD_MASK_FUNC () {( 0xf000 );}' unless defined(&ESD_MASK_FUNC);
    eval 'sub ESD_PLAY () {( 0x1000 );}' unless defined(&ESD_PLAY);
    eval 'sub ESD_MONITOR () {( 0x );}' unless defined(&ESD_MONITOR);
    eval 'sub ESD_RECORD () {( 0x2000 );}' unless defined(&ESD_RECORD);
    eval 'sub ESD_STOP () {( 0x );}' unless defined(&ESD_STOP);
    eval 'sub ESD_LOOP () {( 0x2000 );}' unless defined(&ESD_LOOP);
    eval("sub ESM_ERROR () { 0; }") unless defined(&ESM_ERROR);
    eval("sub ESM_ON_STANDBY () { 1; }") unless defined(&ESM_ON_STANDBY);
    eval("sub ESM_ON_AUTOSTANDBY () { 2; }") unless defined(&ESM_ON_AUTOSTANDBY);
    eval("sub ESM_RUNNING () { 3; }") unless defined(&ESM_RUNNING);
    if(defined(&__cplusplus)) {
    }
}
1;
