require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__FREETYPE_H__)) {
    eval 'sub __FREETYPE_H__ () {1;}' unless defined(&__FREETYPE_H__);
    eval 'sub FREETYPE_MAJOR () {2;}' unless defined(&FREETYPE_MAJOR);
    eval 'sub FREETYPE_MINOR () {1;}' unless defined(&FREETYPE_MINOR);
    eval 'sub FREETYPE_PATCH () {4;}' unless defined(&FREETYPE_PATCH);
    require 'ft2build.ph';
    unless(defined(&FT_ENC_TAG)) {
	eval 'sub FT_ENC_TAG {
	    my( $value, $a, $b, $c, $d ) = @_;
    	    eval q($value = ( ( ( &FT_UInt32)($a) << 24) | ( ( &FT_UInt32)($b) << 16) | ( ( &FT_UInt32)($c) << 8) | ( &FT_UInt32)( &d) ));
	}' unless defined(&FT_ENC_TAG);
    }
    eval 'sub ft_encoding_none () { &FT_ENCODING_NONE;}' unless defined(&ft_encoding_none);
    eval 'sub ft_encoding_unicode () { &FT_ENCODING_UNICODE;}' unless defined(&ft_encoding_unicode);
    eval 'sub ft_encoding_symbol () { &FT_ENCODING_MS_SYMBOL;}' unless defined(&ft_encoding_symbol);
    eval 'sub ft_encoding_latin_1 () { &FT_ENCODING_ADOBE_LATIN_1;}' unless defined(&ft_encoding_latin_1);
    eval 'sub ft_encoding_latin_2 () { &FT_ENCODING_OLD_LATIN_2;}' unless defined(&ft_encoding_latin_2);
    eval 'sub ft_encoding_sjis () { &FT_ENCODING_MS_SJIS;}' unless defined(&ft_encoding_sjis);
    eval 'sub ft_encoding_gb2312 () { &FT_ENCODING_MS_GB2312;}' unless defined(&ft_encoding_gb2312);
    eval 'sub ft_encoding_big5 () { &FT_ENCODING_MS_BIG5;}' unless defined(&ft_encoding_big5);
    eval 'sub ft_encoding_wansung () { &FT_ENCODING_MS_WANSUNG;}' unless defined(&ft_encoding_wansung);
    eval 'sub ft_encoding_johab () { &FT_ENCODING_MS_JOHAB;}' unless defined(&ft_encoding_johab);
    eval 'sub ft_encoding_adobe_standard () { &FT_ENCODING_ADOBE_STANDARD;}' unless defined(&ft_encoding_adobe_standard);
    eval 'sub ft_encoding_adobe_expert () { &FT_ENCODING_ADOBE_EXPERT;}' unless defined(&ft_encoding_adobe_expert);
    eval 'sub ft_encoding_adobe_custom () { &FT_ENCODING_ADOBE_CUSTOM;}' unless defined(&ft_encoding_adobe_custom);
    eval 'sub ft_encoding_apple_roman () { &FT_ENCODING_APPLE_ROMAN;}' unless defined(&ft_encoding_apple_roman);
    eval 'sub FT_FACE_FLAG_SCALABLE () {( 1 << 0);}' unless defined(&FT_FACE_FLAG_SCALABLE);
    eval 'sub FT_FACE_FLAG_FIXED_SIZES () {( 1 << 1);}' unless defined(&FT_FACE_FLAG_FIXED_SIZES);
    eval 'sub FT_FACE_FLAG_FIXED_WIDTH () {( 1 << 2);}' unless defined(&FT_FACE_FLAG_FIXED_WIDTH);
    eval 'sub FT_FACE_FLAG_SFNT () {( 1 << 3);}' unless defined(&FT_FACE_FLAG_SFNT);
    eval 'sub FT_FACE_FLAG_HORIZONTAL () {( 1 << 4);}' unless defined(&FT_FACE_FLAG_HORIZONTAL);
    eval 'sub FT_FACE_FLAG_VERTICAL () {( 1 << 5);}' unless defined(&FT_FACE_FLAG_VERTICAL);
    eval 'sub FT_FACE_FLAG_KERNING () {( 1 << 6);}' unless defined(&FT_FACE_FLAG_KERNING);
    eval 'sub FT_FACE_FLAG_FAST_GLYPHS () {( 1 << 7);}' unless defined(&FT_FACE_FLAG_FAST_GLYPHS);
    eval 'sub FT_FACE_FLAG_MULTIPLE_MASTERS () {( 1 << 8);}' unless defined(&FT_FACE_FLAG_MULTIPLE_MASTERS);
    eval 'sub FT_FACE_FLAG_GLYPH_NAMES () {( 1 << 9);}' unless defined(&FT_FACE_FLAG_GLYPH_NAMES);
    eval 'sub FT_FACE_FLAG_EXTERNAL_STREAM () {( 1 << 10);}' unless defined(&FT_FACE_FLAG_EXTERNAL_STREAM);
    eval 'sub FT_HAS_HORIZONTAL {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_HORIZONTAL ));
    }' unless defined(&FT_HAS_HORIZONTAL);
    eval 'sub FT_HAS_VERTICAL {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_VERTICAL ));
    }' unless defined(&FT_HAS_VERTICAL);
    eval 'sub FT_HAS_KERNING {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_KERNING ));
    }' unless defined(&FT_HAS_KERNING);
    eval 'sub FT_IS_SCALABLE {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_SCALABLE ));
    }' unless defined(&FT_IS_SCALABLE);
    eval 'sub FT_IS_SFNT {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_SFNT ));
    }' unless defined(&FT_IS_SFNT);
    eval 'sub FT_IS_FIXED_WIDTH {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_FIXED_WIDTH ));
    }' unless defined(&FT_IS_FIXED_WIDTH);
    eval 'sub FT_HAS_FIXED_SIZES {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_FIXED_SIZES ));
    }' unless defined(&FT_HAS_FIXED_SIZES);
    eval 'sub FT_HAS_FAST_GLYPHS {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_FAST_GLYPHS ));
    }' unless defined(&FT_HAS_FAST_GLYPHS);
    eval 'sub FT_HAS_GLYPH_NAMES {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_GLYPH_NAMES ));
    }' unless defined(&FT_HAS_GLYPH_NAMES);
    eval 'sub FT_HAS_MULTIPLE_MASTERS {
        my( $face ) = @_;
	    eval q((  ($face->{face_flags}) &  &FT_FACE_FLAG_MULTIPLE_MASTERS ));
    }' unless defined(&FT_HAS_MULTIPLE_MASTERS);
    eval 'sub FT_STYLE_FLAG_ITALIC () {( 1<< 0);}' unless defined(&FT_STYLE_FLAG_ITALIC);
    eval 'sub FT_STYLE_FLAG_BOLD () {( 1<< 1);}' unless defined(&FT_STYLE_FLAG_BOLD);
    eval("sub FT_OPEN_MEMORY () { 1; }") unless defined(&FT_OPEN_MEMORY);
    eval("sub FT_OPEN_STREAM () { 2; }") unless defined(&FT_OPEN_STREAM);
    eval("sub FT_OPEN_PATHNAME () { 4; }") unless defined(&FT_OPEN_PATHNAME);
    eval("sub FT_OPEN_DRIVER () { 8; }") unless defined(&FT_OPEN_DRIVER);
    eval("sub FT_OPEN_PARAMS () { 16; }") unless defined(&FT_OPEN_PARAMS);
    eval 'sub ft_open_memory () { &FT_OPEN_MEMORY;}' unless defined(&ft_open_memory);
    eval 'sub ft_open_stream () { &FT_OPEN_STREAM;}' unless defined(&ft_open_stream);
    eval 'sub ft_open_pathname () { &FT_OPEN_PATHNAME;}' unless defined(&ft_open_pathname);
    eval 'sub ft_open_driver () { &FT_OPEN_DRIVER;}' unless defined(&ft_open_driver);
    eval 'sub ft_open_params () { &FT_OPEN_PARAMS;}' unless defined(&ft_open_params);
    eval 'sub FT_LOAD_NO_SCALE () {0x1;}' unless defined(&FT_LOAD_NO_SCALE);
    eval 'sub FT_LOAD_NO_HINTING () {0x2;}' unless defined(&FT_LOAD_NO_HINTING);
    eval 'sub FT_LOAD_RENDER () {0x4;}' unless defined(&FT_LOAD_RENDER);
    eval 'sub FT_LOAD_NO_BITMAP () {0x8;}' unless defined(&FT_LOAD_NO_BITMAP);
    eval 'sub FT_LOAD_VERTICAL_LAYOUT () {0x10;}' unless defined(&FT_LOAD_VERTICAL_LAYOUT);
    eval 'sub FT_LOAD_FORCE_AUTOHINT () {0x20;}' unless defined(&FT_LOAD_FORCE_AUTOHINT);
    eval 'sub FT_LOAD_CROP_BITMAP () {0x40;}' unless defined(&FT_LOAD_CROP_BITMAP);
    eval 'sub FT_LOAD_PEDANTIC () {0x80;}' unless defined(&FT_LOAD_PEDANTIC);
    eval 'sub FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH () {0x200;}' unless defined(&FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
    eval 'sub FT_LOAD_NO_RECURSE () {0x400;}' unless defined(&FT_LOAD_NO_RECURSE);
    eval 'sub FT_LOAD_IGNORE_TRANSFORM () {0x800;}' unless defined(&FT_LOAD_IGNORE_TRANSFORM);
    eval 'sub FT_LOAD_MONOCHROME () {0x1000;}' unless defined(&FT_LOAD_MONOCHROME);
    eval 'sub FT_LOAD_LINEAR_DESIGN () {0x2000;}' unless defined(&FT_LOAD_LINEAR_DESIGN);
    eval 'sub FT_LOAD_SBITS_ONLY () {0x4000;}' unless defined(&FT_LOAD_SBITS_ONLY);
    eval 'sub FT_LOAD_NO_AUTOHINT () {0x8000;}' unless defined(&FT_LOAD_NO_AUTOHINT);
    eval 'sub FT_LOAD_TARGET_ {
        my( $x ) = @_;
	    eval q(( ( &FT_Int32)( ( &x) & 15) << 16));
    }' unless defined(&FT_LOAD_TARGET_);
    eval 'sub FT_LOAD_TARGET_MODE {
        my( $x ) = @_;
	    eval q(( ( &FT_Render_Mode)( ( ( &x) >> 16) & 15) ));
    }' unless defined(&FT_LOAD_TARGET_MODE);
    eval 'sub FT_LOAD_TARGET_NORMAL () { &FT_LOAD_TARGET_(  &FT_RENDER_MODE_NORMAL );}' unless defined(&FT_LOAD_TARGET_NORMAL);
    eval 'sub FT_LOAD_TARGET_LIGHT () { &FT_LOAD_TARGET_(  &FT_RENDER_MODE_LIGHT );}' unless defined(&FT_LOAD_TARGET_LIGHT);
    eval 'sub FT_LOAD_TARGET_MONO () { &FT_LOAD_TARGET_(  &FT_RENDER_MODE_MONO );}' unless defined(&FT_LOAD_TARGET_MONO);
    eval 'sub FT_LOAD_TARGET_LCD () { &FT_LOAD_TARGET_(  &FT_RENDER_MODE_LCD );}' unless defined(&FT_LOAD_TARGET_LCD);
    eval 'sub FT_LOAD_TARGET_LCD_V () { &FT_LOAD_TARGET_(  &FT_RENDER_MODE_LCD_V );}' unless defined(&FT_LOAD_TARGET_LCD_V);
    eval 'sub FT_LOAD_DEFAULT () {0x;}' unless defined(&FT_LOAD_DEFAULT);
    eval("sub FT_RENDER_MODE_NORMAL () { 0; }") unless defined(&FT_RENDER_MODE_NORMAL);
    eval("sub FT_RENDER_MODE_LIGHT () { 1; }") unless defined(&FT_RENDER_MODE_LIGHT);
    eval("sub FT_RENDER_MODE_MONO () { 2; }") unless defined(&FT_RENDER_MODE_MONO);
    eval("sub FT_RENDER_MODE_LCD () { 3; }") unless defined(&FT_RENDER_MODE_LCD);
    eval("sub FT_RENDER_MODE_LCD_V () { 4; }") unless defined(&FT_RENDER_MODE_LCD_V);
    eval("sub FT_RENDER_MODE_MAX () { 5; }") unless defined(&FT_RENDER_MODE_MAX);
    eval 'sub ft_render_mode_normal () { &FT_RENDER_MODE_NORMAL;}' unless defined(&ft_render_mode_normal);
    eval 'sub ft_render_mode_mono () { &FT_RENDER_MODE_MONO;}' unless defined(&ft_render_mode_mono);
    eval("sub FT_KERNING_DEFAULT () { 0; }") unless defined(&FT_KERNING_DEFAULT);
    eval("sub FT_KERNING_UNFITTED () { 1; }") unless defined(&FT_KERNING_UNFITTED);
    eval("sub FT_KERNING_UNSCALED () { 2; }") unless defined(&FT_KERNING_UNSCALED);
    eval 'sub ft_kerning_default () { &FT_KERNING_DEFAULT;}' unless defined(&ft_kerning_default);
    eval 'sub ft_kerning_unfitted () { &FT_KERNING_UNFITTED;}' unless defined(&ft_kerning_unfitted);
    eval 'sub ft_kerning_unscaled () { &FT_KERNING_UNSCALED;}' unless defined(&ft_kerning_unscaled);
}
1;
