require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__FTIMAGE_H__)) {
    eval 'sub __FTIMAGE_H__ () {1;}' unless defined(&__FTIMAGE_H__);
    unless(defined(&_STANDALONE_)) {
	require 'ft2build.ph';
    }
    eval("sub FT_PIXEL_MODE_NONE () { 0; }") unless defined(&FT_PIXEL_MODE_NONE);
    eval("sub FT_PIXEL_MODE_MONO () { 1; }") unless defined(&FT_PIXEL_MODE_MONO);
    eval("sub FT_PIXEL_MODE_GRAY () { 2; }") unless defined(&FT_PIXEL_MODE_GRAY);
    eval("sub FT_PIXEL_MODE_GRAY2 () { 3; }") unless defined(&FT_PIXEL_MODE_GRAY2);
    eval("sub FT_PIXEL_MODE_GRAY4 () { 4; }") unless defined(&FT_PIXEL_MODE_GRAY4);
    eval("sub FT_PIXEL_MODE_LCD () { 5; }") unless defined(&FT_PIXEL_MODE_LCD);
    eval("sub FT_PIXEL_MODE_LCD_V () { 6; }") unless defined(&FT_PIXEL_MODE_LCD_V);
    eval("sub FT_PIXEL_MODE_MAX () { 7; }") unless defined(&FT_PIXEL_MODE_MAX);
    eval 'sub ft_pixel_mode_none () { &FT_PIXEL_MODE_NONE;}' unless defined(&ft_pixel_mode_none);
    eval 'sub ft_pixel_mode_mono () { &FT_PIXEL_MODE_MONO;}' unless defined(&ft_pixel_mode_mono);
    eval 'sub ft_pixel_mode_grays () { &FT_PIXEL_MODE_GRAY;}' unless defined(&ft_pixel_mode_grays);
    eval 'sub ft_pixel_mode_pal2 () { &FT_PIXEL_MODE_GRAY2;}' unless defined(&ft_pixel_mode_pal2);
    eval 'sub ft_pixel_mode_pal4 () { &FT_PIXEL_MODE_GRAY4;}' unless defined(&ft_pixel_mode_pal4);
    if(0) {
	eval("sub ft_palette_mode_rgb () { 0; }") unless defined(&ft_palette_mode_rgb);
	eval("sub ft_palette_mode_rgba () { 1; }") unless defined(&ft_palette_mode_rgba);
	eval("sub ft_palettte_mode_max () { 2; }") unless defined(&ft_palettte_mode_max);
    }
    eval("sub FT_OUTLINE_NONE () { 0; }") unless defined(&FT_OUTLINE_NONE);
    eval("sub FT_OUTLINE_OWNER () { 1; }") unless defined(&FT_OUTLINE_OWNER);
    eval("sub FT_OUTLINE_EVEN_ODD_FILL () { 2; }") unless defined(&FT_OUTLINE_EVEN_ODD_FILL);
    eval("sub FT_OUTLINE_REVERSE_FILL () { 4; }") unless defined(&FT_OUTLINE_REVERSE_FILL);
    eval("sub FT_OUTLINE_IGNORE_DROPOUTS () { 8; }") unless defined(&FT_OUTLINE_IGNORE_DROPOUTS);
    eval("sub FT_OUTLINE_HIGH_PRECISION () { 256; }") unless defined(&FT_OUTLINE_HIGH_PRECISION);
    eval("sub FT_OUTLINE_SINGLE_PASS () { 512; }") unless defined(&FT_OUTLINE_SINGLE_PASS);
    eval 'sub ft_outline_none () { &FT_OUTLINE_NONE;}' unless defined(&ft_outline_none);
    eval 'sub ft_outline_owner () { &FT_OUTLINE_OWNER;}' unless defined(&ft_outline_owner);
    eval 'sub ft_outline_even_odd_fill () { &FT_OUTLINE_EVEN_ODD_FILL;}' unless defined(&ft_outline_even_odd_fill);
    eval 'sub ft_outline_reverse_fill () { &FT_OUTLINE_REVERSE_FILL;}' unless defined(&ft_outline_reverse_fill);
    eval 'sub ft_outline_ignore_dropouts () { &FT_OUTLINE_IGNORE_DROPOUTS;}' unless defined(&ft_outline_ignore_dropouts);
    eval 'sub ft_outline_high_precision () { &FT_OUTLINE_HIGH_PRECISION;}' unless defined(&ft_outline_high_precision);
    eval 'sub ft_outline_single_pass () { &FT_OUTLINE_SINGLE_PASS;}' unless defined(&ft_outline_single_pass);
    eval 'sub FT_CURVE_TAG {
        my( $flag ) = @_;
	    eval q(( $flag & 3));
    }' unless defined(&FT_CURVE_TAG);
    eval 'sub FT_CURVE_TAG_ON () {1;}' unless defined(&FT_CURVE_TAG_ON);
    eval 'sub FT_CURVE_TAG_CONIC () {0;}' unless defined(&FT_CURVE_TAG_CONIC);
    eval 'sub FT_CURVE_TAG_CUBIC () {2;}' unless defined(&FT_CURVE_TAG_CUBIC);
    eval 'sub FT_CURVE_TAG_TOUCH_X () {8;}' unless defined(&FT_CURVE_TAG_TOUCH_X);
    eval 'sub FT_CURVE_TAG_TOUCH_Y () {16;}' unless defined(&FT_CURVE_TAG_TOUCH_Y);
    eval 'sub FT_CURVE_TAG_TOUCH_BOTH () {(  &FT_CURVE_TAG_TOUCH_X |  &FT_CURVE_TAG_TOUCH_Y );}' unless defined(&FT_CURVE_TAG_TOUCH_BOTH);
    eval 'sub FT_Curve_Tag_On () { &FT_CURVE_TAG_ON;}' unless defined(&FT_Curve_Tag_On);
    eval 'sub FT_Curve_Tag_Conic () { &FT_CURVE_TAG_CONIC;}' unless defined(&FT_Curve_Tag_Conic);
    eval 'sub FT_Curve_Tag_Cubic () { &FT_CURVE_TAG_CUBIC;}' unless defined(&FT_Curve_Tag_Cubic);
    eval 'sub FT_Curve_Tag_Touch_X () { &FT_CURVE_TAG_TOUCH_X;}' unless defined(&FT_Curve_Tag_Touch_X);
    eval 'sub FT_Curve_Tag_Touch_Y () { &FT_CURVE_TAG_TOUCH_Y;}' unless defined(&FT_Curve_Tag_Touch_Y);
    eval 'sub FT_Outline_MoveTo_Func () { &FT_Outline_MoveToFunc;}' unless defined(&FT_Outline_MoveTo_Func);
    eval 'sub FT_Outline_LineTo_Func () { &FT_Outline_LineToFunc;}' unless defined(&FT_Outline_LineTo_Func);
    eval 'sub FT_Outline_ConicTo_Func () { &FT_Outline_ConicToFunc;}' unless defined(&FT_Outline_ConicTo_Func);
    eval 'sub FT_Outline_CubicTo_Func () { &FT_Outline_CubicToFunc;}' unless defined(&FT_Outline_CubicTo_Func);
    unless(defined(&FT_IMAGE_TAG)) {
	eval 'sub FT_IMAGE_TAG {
	    my( $value, $_x1, $_x2, $_x3, $_x4 ) = @_;
    	    eval q($value = ( ( $_x1 << 24) | ( $_x2 << 16) | ( $_x3 << 8) | $_x4 ));
	}' unless defined(&FT_IMAGE_TAG);
    }
    eval 'sub ft_glyph_format_none () { &FT_GLYPH_FORMAT_NONE;}' unless defined(&ft_glyph_format_none);
    eval 'sub ft_glyph_format_composite () { &FT_GLYPH_FORMAT_COMPOSITE;}' unless defined(&ft_glyph_format_composite);
    eval 'sub ft_glyph_format_bitmap () { &FT_GLYPH_FORMAT_BITMAP;}' unless defined(&ft_glyph_format_bitmap);
    eval 'sub ft_glyph_format_outline () { &FT_GLYPH_FORMAT_OUTLINE;}' unless defined(&ft_glyph_format_outline);
    eval 'sub ft_glyph_format_plotter () { &FT_GLYPH_FORMAT_PLOTTER;}' unless defined(&ft_glyph_format_plotter);
    eval 'sub FT_Raster_Span_Func () { &FT_SpanFunc;}' unless defined(&FT_Raster_Span_Func);
    eval("sub FT_RASTER_FLAG_DEFAULT () { 0; }") unless defined(&FT_RASTER_FLAG_DEFAULT);
    eval("sub FT_RASTER_FLAG_AA () { 1; }") unless defined(&FT_RASTER_FLAG_AA);
    eval("sub FT_RASTER_FLAG_DIRECT () { 2; }") unless defined(&FT_RASTER_FLAG_DIRECT);
    eval("sub FT_RASTER_FLAG_CLIP () { 4; }") unless defined(&FT_RASTER_FLAG_CLIP);
    eval 'sub ft_raster_flag_default () { &FT_RASTER_FLAG_DEFAULT;}' unless defined(&ft_raster_flag_default);
    eval 'sub ft_raster_flag_aa () { &FT_RASTER_FLAG_AA;}' unless defined(&ft_raster_flag_aa);
    eval 'sub ft_raster_flag_direct () { &FT_RASTER_FLAG_DIRECT;}' unless defined(&ft_raster_flag_direct);
    eval 'sub ft_raster_flag_clip () { &FT_RASTER_FLAG_CLIP;}' unless defined(&ft_raster_flag_clip);
    eval 'sub FT_Raster_New_Func () { &FT_Raster_NewFunc;}' unless defined(&FT_Raster_New_Func);
    eval 'sub FT_Raster_Done_Func () { &FT_Raster_DoneFunc;}' unless defined(&FT_Raster_Done_Func);
    eval 'sub FT_Raster_Reset_Func () { &FT_Raster_ResetFunc;}' unless defined(&FT_Raster_Reset_Func);
    eval 'sub FT_Raster_Set_Mode_Func () { &FT_Raster_SetModeFunc;}' unless defined(&FT_Raster_Set_Mode_Func);
    eval 'sub FT_Raster_Render_Func () { &FT_Raster_RenderFunc;}' unless defined(&FT_Raster_Render_Func);
}
1;
