require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__FTMEMORY_H__)) {
    eval 'sub __FTMEMORY_H__ () {1;}' unless defined(&__FTMEMORY_H__);
    require 'ft2build.ph';
    undef(&FT_SET_ERROR) if defined(&FT_SET_ERROR);
    eval 'sub FT_SET_ERROR {
        my( $expression ) = @_;
	    eval q(( (  &error = ($expression) ) != 0));
    }' unless defined(&FT_SET_ERROR);
    if(defined(&FT_DEBUG_MEMORY)) {
    }
    eval 'sub FT_MEM_SET {
        my( $dest, $byte, $count ) = @_;
	    eval q( &ft_memset( $dest, $byte, $count ));
    }' unless defined(&FT_MEM_SET);
    eval 'sub FT_MEM_COPY {
        my( $dest, $source, $count ) = @_;
	    eval q( &ft_memcpy( $dest, $source, $count ));
    }' unless defined(&FT_MEM_COPY);
    eval 'sub FT_MEM_MOVE {
        my( $dest, $source, $count ) = @_;
	    eval q( &ft_memmove( $dest, $source, $count ));
    }' unless defined(&FT_MEM_MOVE);
    eval 'sub FT_MEM_ZERO {
        my( $dest, $count ) = @_;
	    eval q( &FT_MEM_SET( $dest, 0, $count ));
    }' unless defined(&FT_MEM_ZERO);
    eval 'sub FT_ZERO {
        my( $p ) = @_;
	    eval q( &FT_MEM_ZERO(  &p, $sizeof{ ( &p) } ));
    }' unless defined(&FT_ZERO);
    eval 'sub _FT_OVERFLOWS {
        my($x) = @_;
	    eval q(( != ( &FT_Int) ($x)));
    }' unless defined(&_FT_OVERFLOWS);
    eval 'sub _FT_CHECK_OVERFLOW {
        my($_size_, $_action_if_true_, $_action_if_false_) = @_;
	    eval q(( &_FT_OVERFLOWS ($_size_) ? ($_action_if_true_),  &FT_Err_Array_Too_Large : ($_action_if_false_)));
    }' unless defined(&_FT_CHECK_OVERFLOW);
    if(defined(&FT_DEBUG_MEMORY)) {
	eval 'sub FT_MEM_ALLOC {
	    my( $_pointer_, $_size_ ) = @_;
    	    eval q( &_FT_CHECK_OVERFLOW ($_size_, ($_pointer_) =  &NULL,  &FT_Alloc_Debug(  &memory, $_size_, ( &void**)($_pointer_),  &__FILE__,  &__LINE__ )));
	}' unless defined(&FT_MEM_ALLOC);
	eval 'sub FT_MEM_REALLOC {
	    my( $_pointer_, $_current_, $_size_ ) = @_;
    	    eval q( &_FT_CHECK_OVERFLOW ($_current_,  &FT_Free ( &memory, ( &void**)($_pointer_)),  &_FT_CHECK_OVERFLOW ($_size_,  &FT_Free ( &memory, ( &void**)($_pointer_)),  &FT_Realloc_Debug( &memory, $_current_, $_size_, ( &void**)($_pointer_),  &__FILE__,  &__LINE__ ))));
	}' unless defined(&FT_MEM_REALLOC);
	eval 'sub FT_MEM_FREE {
	    my( $_pointer_ ) = @_;
    	    eval q( &FT_Free_Debug(  &memory, ( &void**)($_pointer_),  &__FILE__,  &__LINE__ ));
	}' unless defined(&FT_MEM_FREE);
    } else {
	eval 'sub FT_MEM_ALLOC {
	    my( $_pointer_, $_size_ ) = @_;
    	    eval q( &_FT_CHECK_OVERFLOW ($_size_, ($_pointer_) =  &NULL,  &FT_Alloc(  &memory, $_size_, ( &void**)($_pointer_))));
	}' unless defined(&FT_MEM_ALLOC);
	eval 'sub FT_MEM_FREE {
	    my( $_pointer_ ) = @_;
    	    eval q( &FT_Free(  &memory, ( &void**)($_pointer_) ));
	}' unless defined(&FT_MEM_FREE);
	eval 'sub FT_MEM_REALLOC {
	    my( $_pointer_, $_current_, $_size_ ) = @_;
    	    eval q( &_FT_CHECK_OVERFLOW ($_current_,  &FT_Free ( &memory, ( &void**)($_pointer_)),  &_FT_CHECK_OVERFLOW ($_size_,  &FT_Free ( &memory, ( &void**)($_pointer_)),  &FT_Realloc(  &memory, $_current_, $_size_, ( &void**)($_pointer_) ))));
	}' unless defined(&FT_MEM_REALLOC);
    }
    eval 'sub FT_MEM_NEW {
        my( $_pointer_ ) = @_;
	    eval q( &FT_MEM_ALLOC( $_pointer_, $sizeof{ ($_pointer_) } ));
    }' unless defined(&FT_MEM_NEW);
    eval 'sub FT_MEM_NEW_ARRAY {
        my( $_pointer_, $_count_ ) = @_;
	    eval q( &FT_MEM_ALLOC( $_pointer_, ($_count_) * $sizeof{ ($_pointer_) } ));
    }' unless defined(&FT_MEM_NEW_ARRAY);
    eval 'sub FT_MEM_RENEW_ARRAY {
        my( $_pointer_, $_old_, $_new_ ) = @_;
	    eval q( &FT_MEM_REALLOC( $_pointer_, ($_old_) * $sizeof{ ($_pointer_) }, ($_new_) * $sizeof{ ($_pointer_) } ));
    }' unless defined(&FT_MEM_RENEW_ARRAY);
    eval 'sub FT_MEM_ALLOC_ARRAY {
        my( $_pointer_, $_count_, $_type_ ) = @_;
	    eval q( &FT_MEM_ALLOC( $_pointer_, ($_count_) * $sizeof{ $_type_ } ));
    }' unless defined(&FT_MEM_ALLOC_ARRAY);
    eval 'sub FT_MEM_REALLOC_ARRAY {
        my( $_pointer_, $_old_, $_new_, $_type_ ) = @_;
	    eval q( &FT_MEM_REALLOC( $_pointer_, ($_old_) * $sizeof{  &_type }, ($_new_) * $sizeof{ $_type_ } ));
    }' unless defined(&FT_MEM_REALLOC_ARRAY);
    eval 'sub FT_ALLOC {
        my( $_pointer_, $_size_ ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_MEM_ALLOC( $_pointer_, $_size_ ) ));
    }' unless defined(&FT_ALLOC);
    eval 'sub FT_REALLOC {
        my( $_pointer_, $_current_, $_size_ ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_MEM_REALLOC( $_pointer_, $_current_, $_size_ ) ));
    }' unless defined(&FT_REALLOC);
    eval 'sub FT_FREE {
        my( $_pointer_ ) = @_;
	    eval q( &FT_MEM_FREE( $_pointer_ ));
    }' unless defined(&FT_FREE);
    eval 'sub FT_NEW {
        my( $_pointer_ ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_MEM_NEW( $_pointer_ ) ));
    }' unless defined(&FT_NEW);
    eval 'sub FT_NEW_ARRAY {
        my( $_pointer_, $_count_ ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_MEM_NEW_ARRAY( $_pointer_, $_count_ ) ));
    }' unless defined(&FT_NEW_ARRAY);
    eval 'sub FT_RENEW_ARRAY {
        my( $_pointer_, $_old_, $_new_ ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_MEM_RENEW_ARRAY( $_pointer_, $_old_, $_new_ ) ));
    }' unless defined(&FT_RENEW_ARRAY);
    eval 'sub FT_ALLOC_ARRAY {
        my( $_pointer_, $_count_, $_type_ ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_MEM_ALLOC( $_pointer_, ($_count_) * $sizeof{ $_type_ } ) ));
    }' unless defined(&FT_ALLOC_ARRAY);
    eval 'sub FT_REALLOC_ARRAY {
        my( $_pointer_, $_old_, $_new_, $_type_ ) = @_;
	    eval q( &FT_SET_ERROR(  &FT_MEM_REALLOC( $_pointer_, ($_old_) * $sizeof{ $_type_ }, ($_new_) * $sizeof{ $_type_ } ) ));
    }' unless defined(&FT_REALLOC_ARRAY);
}
1;
