require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_GAIM_GTKIMHTML_H_)) {
    eval 'sub _GAIM_GTKIMHTML_H_ () {1;}' unless defined(&_GAIM_GTKIMHTML_H_);
    require 'gdk/gdk.ph';
    require 'gtk/gtktextview.ph';
    require 'gtk/gtktooltips.ph';
    require 'gtk/gtkimage.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub GTK_TYPE_IMHTML () {( &gtk_imhtml_get_type ());}' unless defined(&GTK_TYPE_IMHTML);
    eval 'sub GTK_IMHTML {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_CAST (($obj),  &GTK_TYPE_IMHTML,  &GtkIMHtml)));
    }' unless defined(&GTK_IMHTML);
    eval 'sub GTK_IMHTML_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_CAST (($klass),  &GTK_TYPE_IMHTML,  &GtkIMHtmlClass)));
    }' unless defined(&GTK_IMHTML_CLASS);
    eval 'sub GTK_IS_IMHTML {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_TYPE (($obj),  &GTK_TYPE_IMHTML)));
    }' unless defined(&GTK_IS_IMHTML);
    eval 'sub GTK_IS_IMHTML_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_TYPE (($klass),  &GTK_TYPE_IMHTML)));
    }' unless defined(&GTK_IS_IMHTML_CLASS);
    eval 'sub GTK_IMHTML_SCALABLE {
        my($obj) = @_;
	    eval q((( &GtkIMHtmlScalable *)$obj));
    }' unless defined(&GTK_IMHTML_SCALABLE);
    eval("sub GTK_IMHTML_BOLD () { 1<<0; }") unless defined(&GTK_IMHTML_BOLD);
    eval("sub GTK_IMHTML_ITALIC () { 1<<1; }") unless defined(&GTK_IMHTML_ITALIC);
    eval("sub GTK_IMHTML_UNDERLINE () { 1<<2; }") unless defined(&GTK_IMHTML_UNDERLINE);
    eval("sub GTK_IMHTML_GROW () { 1<<3; }") unless defined(&GTK_IMHTML_GROW);
    eval("sub GTK_IMHTML_SHRINK () { 1<<4; }") unless defined(&GTK_IMHTML_SHRINK);
    eval("sub GTK_IMHTML_FACE () { 1<<5; }") unless defined(&GTK_IMHTML_FACE);
    eval("sub GTK_IMHTML_FORECOLOR () { 1<<6; }") unless defined(&GTK_IMHTML_FORECOLOR);
    eval("sub GTK_IMHTML_BACKCOLOR () { 1<<7; }") unless defined(&GTK_IMHTML_BACKCOLOR);
    eval("sub GTK_IMHTML_LINK () { 1<<8; }") unless defined(&GTK_IMHTML_LINK);
    eval("sub GTK_IMHTML_IMAGE () { 1<<9; }") unless defined(&GTK_IMHTML_IMAGE);
    eval("sub GTK_IMHTML_SMILEY () { 1<<10; }") unless defined(&GTK_IMHTML_SMILEY);
    eval("sub GTK_IMHTML_LINKDESC () { 1<<11; }") unless defined(&GTK_IMHTML_LINKDESC);
    eval("sub GTK_IMHTML_STRIKE () { 1<<12; }") unless defined(&GTK_IMHTML_STRIKE);
    eval("sub GTK_IMHTML_ALL () { -1; }") unless defined(&GTK_IMHTML_ALL);
    eval("sub GTK_IMHTML_NO_COLOURS () { 1<<0; }") unless defined(&GTK_IMHTML_NO_COLOURS);
    eval("sub GTK_IMHTML_NO_FONTS () { 1<<1; }") unless defined(&GTK_IMHTML_NO_FONTS);
    eval("sub GTK_IMHTML_NO_COMMENTS () { 1<<2; }") unless defined(&GTK_IMHTML_NO_COMMENTS);
    eval("sub GTK_IMHTML_NO_TITLE () { 1<<3; }") unless defined(&GTK_IMHTML_NO_TITLE);
    eval("sub GTK_IMHTML_NO_NEWLINE () { 1<<4; }") unless defined(&GTK_IMHTML_NO_NEWLINE);
    eval("sub GTK_IMHTML_NO_SIZES () { 1<<5; }") unless defined(&GTK_IMHTML_NO_SIZES);
    eval("sub GTK_IMHTML_NO_SCROLL () { 1<<6; }") unless defined(&GTK_IMHTML_NO_SCROLL);
    eval("sub GTK_IMHTML_RETURN_LOG () { 1<<7; }") unless defined(&GTK_IMHTML_RETURN_LOG);
    eval("sub GTK_IMHTML_USE_POINTSIZE () { 1<<8; }") unless defined(&GTK_IMHTML_USE_POINTSIZE);
    eval("sub GTK_IMHTML_DRAG_URL () { 0; }") unless defined(&GTK_IMHTML_DRAG_URL);
    eval("sub GTK_IMHTML_DRAG_HTML () { 1; }") unless defined(&GTK_IMHTML_DRAG_HTML);
    eval("sub GTK_IMHTML_DRAG_UTF8_STRING () { 2; }") unless defined(&GTK_IMHTML_DRAG_UTF8_STRING);
    eval("sub GTK_IMHTML_DRAG_COMPOUND_TEXT () { 3; }") unless defined(&GTK_IMHTML_DRAG_COMPOUND_TEXT);
    eval("sub GTK_IMHTML_DRAG_STRING () { 4; }") unless defined(&GTK_IMHTML_DRAG_STRING);
    eval("sub GTK_IMHTML_DRAG_TEXT () { 5; }") unless defined(&GTK_IMHTML_DRAG_TEXT);
    eval("sub GTK_IMHTML_DRAG_NUM () { 6; }") unless defined(&GTK_IMHTML_DRAG_NUM);
    eval 'sub GTK_IMHTML_DND_TARGETS () {{ "text/uri-list", 0,  &GTK_IMHTML_DRAG_URL }, { "_NETSCAPE_URL", 0,  &GTK_IMHTML_DRAG_URL }, { "text/html", 0,  &GTK_IMHTML_DRAG_HTML }, { "x-url/ftp", 0,  &GTK_IMHTML_DRAG_URL }, { "x-url/http", 0,  &GTK_IMHTML_DRAG_URL }, { "UTF8_STRING", 0,  &GTK_IMHTML_DRAG_UTF8_STRING }, { "COMPOUND_TEXT", 0,  &GTK_IMHTML_DRAG_COMPOUND_TEXT }, { "STRING", 0,  &GTK_IMHTML_DRAG_STRING }, { "text/plain", 0,  &GTK_IMHTML_DRAG_TEXT }, { "TEXT", 0,  &GTK_IMHTML_DRAG_TEXT };}' unless defined(&GTK_IMHTML_DND_TARGETS);
    eval 'sub gtk_imhtml_append_text {
        my($imhtml, $text, $options) = @_;
	    eval q( &gtk_imhtml_append_text_with_images($imhtml, $text, $options,  &NULL));
    }' unless defined(&gtk_imhtml_append_text);
    if(defined(&__cplusplus)) {
    }
}
1;
