require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_GAIM_INTERNAL_H_)) {
    eval 'sub _GAIM_INTERNAL_H_ () {1;}' unless defined(&_GAIM_INTERNAL_H_);
    if(defined(&HAVE_CONFIG_H)) {
	require 'config.ph';
    }
    if(defined(&ENABLE_NLS)) {
	require 'locale.ph';
	require 'libintl.ph';
	eval 'sub _ {
	    my($x) = @_;
    	    eval q( &gettext($x));
	}' unless defined(&_);
	if(defined(&gettext_noop)) {
	    eval 'sub N_ {
	        my($String) = @_;
    		eval q( &gettext_noop ($String));
	    }' unless defined(&N_);
	} else {
	    eval 'sub N_ {
	        my($String) = @_;
    		eval q(($String));
	    }' unless defined(&N_);
	}
    } else {
	require 'locale.ph';
	eval 'sub N_ {
	    my($String) = @_;
    	    eval q(($String));
	}' unless defined(&N_);
	eval 'sub _ {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&_);
	eval 'sub ngettext {
	    my($Singular, $Plural, $Number) = @_;
    	    eval q((($Number == 1) ? ($Singular) : ($Plural)));
	}' unless defined(&ngettext);
    }
    if(defined(&HAVE_ENDIAN_H)) {
	require 'endian.ph';
    }
    eval 'sub MSG_LEN () {2048;}' unless defined(&MSG_LEN);
    eval 'sub BUF_LEN () { &MSG_LEN;}' unless defined(&BUF_LEN);
    eval 'sub BUF_LONG () { &BUF_LEN * 2;}' unless defined(&BUF_LONG);
    require 'sys/stat.ph';
    require 'sys/time.ph';
    require 'sys/types.ph';
    unless(defined(&_WIN32)) {
	require 'sys/wait.ph';
    }
    require 'ctype.ph';
    require 'errno.ph';
    require 'fcntl.ph';
    require 'math.ph';
    require 'stdio.ph';
    require 'stdlib.ph';
    require 'string.ph';
    require 'time.ph';
    if(defined(&HAVE_ICONV)) {
	require 'iconv.ph';
    }
    if(defined(&HAVE_LANGINFO_CODESET)) {
	require 'langinfo.ph';
    }
    if(defined(&GAIM_PLUGINS)) {
	require 'gmodule.ph';
	unless(defined(&_WIN32)) {
	    require 'dlfcn.ph';
	}
    }
    unless(defined(&_WIN32)) {
	require 'netinet/in.ph';
	require 'sys/socket.ph';
	require 'arpa/inet.ph';
	require 'sys/un.ph';
	require 'sys/utsname.ph';
	require 'netdb.ph';
	require 'signal.ph';
	require 'unistd.ph';
    }
    unless(defined(&MAXPATHLEN)) {
	eval 'sub MAXPATHLEN () {1024;}' unless defined(&MAXPATHLEN);
    }
    unless(defined(&HOST_NAME_MAX)) {
	eval 'sub HOST_NAME_MAX () {255;}' unless defined(&HOST_NAME_MAX);
    }
    eval 'sub PATHSIZE () {1024;}' unless defined(&PATHSIZE);
    require 'glib.ph';
    if( &GLIB_CHECK_VERSION(2,6,0)) {
	require 'glib/gstdio.ph';
    }
    unless(defined(&G_MAXSIZE)) {
	if((defined(&GLIB_SIZEOF_LONG) ? &GLIB_SIZEOF_LONG : 0) == 8) {
	    eval 'sub G_MAXSIZE () {(( &gsize) 1.84467440737096e+19);}' unless defined(&G_MAXSIZE);
	} else {
	    eval 'sub G_MAXSIZE () {(( &gsize) 0xffffffff);}' unless defined(&G_MAXSIZE);
	}
    }
    if(defined(&_WIN32)) {
	require 'win32dep.ph';
    }
    if(! &GLIB_CHECK_VERSION(2,6,0)) {
	eval 'sub g_freopen () { &freopen;}' unless defined(&g_freopen);
	eval 'sub g_fopen () { &fopen;}' unless defined(&g_fopen);
	eval 'sub g_rmdir () { &rmdir;}' unless defined(&g_rmdir);
	eval 'sub g_remove () { &remove;}' unless defined(&g_remove);
	eval 'sub g_unlink () { &unlink;}' unless defined(&g_unlink);
	eval 'sub g_lstat () { &lstat;}' unless defined(&g_lstat);
	eval 'sub g_stat () { &stat;}' unless defined(&g_stat);
	eval 'sub g_mkdir () { &mkdir;}' unless defined(&g_mkdir);
	eval 'sub g_rename () { &rename;}' unless defined(&g_rename);
	eval 'sub g_open () { &open;}' unless defined(&g_open);
    }
    unless(defined(&G_GINT64_MODIFIER)) {
	if((defined(&GLIB_SIZEOF_LONG) ? &GLIB_SIZEOF_LONG : 0) == 8) {
	    eval 'sub G_GINT64_MODIFIER () {"l";}' unless defined(&G_GINT64_MODIFIER);
	} else {
	    eval 'sub G_GINT64_MODIFIER () {"ll";}' unless defined(&G_GINT64_MODIFIER);
	}
    }
    unless(defined(&G_GSIZE_FORMAT)) {
	if((defined(&GLIB_SIZEOF_LONG) ? &GLIB_SIZEOF_LONG : 0) == 8) {
	    eval 'sub G_GSIZE_FORMAT () {"lu";}' unless defined(&G_GSIZE_FORMAT);
	} else {
	    eval 'sub G_GSIZE_FORMAT () {"u";}' unless defined(&G_GSIZE_FORMAT);
	}
    }
    eval 'sub GAIM_WEBSITE () {"http://gaim.sourceforge.net/";}' unless defined(&GAIM_WEBSITE);
    unless(defined(&_WIN32)) {
	require 'prefix.ph';
    }
}
1;
