require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_GAIM_PLUGIN_H_)) {
    eval 'sub _GAIM_PLUGIN_H_ () {1;}' unless defined(&_GAIM_PLUGIN_H_);
    require 'glib/glist.ph';
    require 'gmodule.ph';
    require 'signals.ph';
    require 'value.ph';
    require 'pluginpref.ph';
    eval("sub GAIM_PLUGIN_UNKNOWN () { -1; }") unless defined(&GAIM_PLUGIN_UNKNOWN);
    eval("sub GAIM_PLUGIN_STANDARD () { 0; }") unless defined(&GAIM_PLUGIN_STANDARD);
    eval("sub GAIM_PLUGIN_LOADER () { 1; }") unless defined(&GAIM_PLUGIN_LOADER);
    eval("sub GAIM_PLUGIN_PROTOCOL () { 2; }") unless defined(&GAIM_PLUGIN_PROTOCOL);
    eval 'sub GAIM_PRIORITY_DEFAULT () {0;}' unless defined(&GAIM_PRIORITY_DEFAULT);
    eval 'sub GAIM_PRIORITY_HIGHEST () {9999;}' unless defined(&GAIM_PRIORITY_HIGHEST);
    eval 'sub GAIM_PRIORITY_LOWEST () {-9999;}' unless defined(&GAIM_PRIORITY_LOWEST);
    eval 'sub GAIM_PLUGIN_FLAG_INVISIBLE () {0x1;}' unless defined(&GAIM_PLUGIN_FLAG_INVISIBLE);
    eval 'sub GAIM_PLUGIN_MAGIC () {5;}' unless defined(&GAIM_PLUGIN_MAGIC);
    eval 'sub GAIM_PLUGIN_LOADER_INFO {
        my($plugin) = @_;
	    eval q((( &GaimPluginLoaderInfo *)($plugin)-> ($info->{extra_info})));
    }' unless defined(&GAIM_PLUGIN_LOADER_INFO);
    eval 'sub GAIM_PLUGIN_HAS_PREF_FRAME {
        my($plugin) = @_;
	    eval q((($plugin)-> &info !=  &NULL  && ($plugin)-> ($info->{prefs_info}) !=  &NULL));
    }' unless defined(&GAIM_PLUGIN_HAS_PREF_FRAME);
    eval 'sub GAIM_PLUGIN_UI_INFO {
        my($plugin) = @_;
	    eval q((( &GaimPluginUiInfo*)($plugin)-> ($info->{prefs_info})));
    }' unless defined(&GAIM_PLUGIN_UI_INFO);
    eval 'sub GAIM_PLUGIN_HAS_ACTIONS {
        my($plugin) = @_;
	    eval q((($plugin)-> &info !=  &NULL  && ($plugin)-> ($info->{actions}) !=  &NULL));
    }' unless defined(&GAIM_PLUGIN_HAS_ACTIONS);
    eval 'sub GAIM_PLUGIN_ACTIONS {
        my($plugin, $context) = @_;
	    eval q(( &GAIM_PLUGIN_HAS_ACTIONS($plugin)? ($plugin)-> ($info->{actions})($plugin, $context):  &NULL));
    }' unless defined(&GAIM_PLUGIN_ACTIONS);
    if(!defined( &GAIM_PLUGINS) || defined( &GAIM_STATIC_PRPL)) {
	eval 'sub GAIM_INIT_PLUGIN {
	    my($pluginname, $initfunc, $plugininfo) = @_;
    	    eval q( &gboolean  &gaim_init_$pluginname &_plugin( &void) {  &GaimPlugin * &plugin =  &gaim_plugin_new( &TRUE,  &NULL);  ($plugin->{info}) = ($plugininfo); $initfunc(( &plugin));  &return  &gaim_plugin_register( &plugin); });
	}' unless defined(&GAIM_INIT_PLUGIN);
    } else {
	eval 'sub GAIM_INIT_PLUGIN {
	    my($pluginname, $initfunc, $plugininfo) = @_;
    	    eval q( &G_MODULE_EXPORT  &gboolean  &gaim_init_plugin( &GaimPlugin * &plugin) {  ($plugin->{info}) = ($plugininfo); $initfunc(( &plugin));  &return  &gaim_plugin_register( &plugin); });
	}' unless defined(&GAIM_INIT_PLUGIN);
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
