require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PREFIX_H_)) {
    eval 'sub _PREFIX_H_ () {1;}' unless defined(&_PREFIX_H_);
    if(defined(&__cplusplus)) {
    }
    undef(&BR_NAMESPACE) if defined(&BR_NAMESPACE);
    eval 'sub BR_NAMESPACE {
        my($funcName) = @_;
	    eval q( &gaim_  $funcName);
    }' unless defined(&BR_NAMESPACE);
    if(defined(&ENABLE_BINRELOC)) {
	eval 'sub br_thread_local_store () { &BR_NAMESPACE( &br_thread_local_store);}' unless defined(&br_thread_local_store);
	eval 'sub br_locate () { &BR_NAMESPACE( &br_locate);}' unless defined(&br_locate);
	eval 'sub br_locate_prefix () { &BR_NAMESPACE( &br_locate_prefix);}' unless defined(&br_locate_prefix);
	eval 'sub br_prepend_prefix () { &BR_NAMESPACE( &br_prepend_prefix);}' unless defined(&br_prepend_prefix);
	unless(defined(&BR_NO_MACROS)) {
	    undef(&SELFPATH) if defined(&SELFPATH);
	    undef(&PREFIX) if defined(&PREFIX);
	    undef(&PREFIXDIR) if defined(&PREFIXDIR);
	    undef(&BINDIR) if defined(&BINDIR);
	    undef(&SBINDIR) if defined(&SBINDIR);
	    undef(&DATADIR) if defined(&DATADIR);
	    undef(&LIBDIR) if defined(&LIBDIR);
	    undef(&LIBEXECDIR) if defined(&LIBEXECDIR);
	    undef(&ETCDIR) if defined(&ETCDIR);
	    undef(&SYSCONFDIR) if defined(&SYSCONFDIR);
	    undef(&CONFDIR) if defined(&CONFDIR);
	    undef(&LOCALEDIR) if defined(&LOCALEDIR);
	    eval 'sub SELFPATH () {( &br_thread_local_store ( &br_locate (( &void *) "")));}' unless defined(&SELFPATH);
	    eval 'sub PREFIX () {( &br_thread_local_store ( &br_locate_prefix (( &void *) "")));}' unless defined(&PREFIX);
	    eval 'sub PREFIXDIR () {( &br_thread_local_store ( &br_locate_prefix (( &void *) "")));}' unless defined(&PREFIXDIR);
	    eval 'sub BINDIR () {( &br_thread_local_store ( &br_prepend_prefix (( &void *) "", "/bin")));}' unless defined(&BINDIR);
	    eval 'sub SBINDIR () {( &br_thread_local_store ( &br_prepend_prefix (( &void *) "", "/sbin")));}' unless defined(&SBINDIR);
	    eval 'sub DATADIR () {( &br_thread_local_store ( &br_prepend_prefix (( &void *) "", "/share")));}' unless defined(&DATADIR);
	    eval 'sub LIBDIR () {( &br_thread_local_store ( &br_prepend_prefix (( &void *) "", "/lib/gaim")));}' unless defined(&LIBDIR);
	    eval 'sub LIBEXECDIR () {( &br_thread_local_store ( &br_prepend_prefix (( &void *) "", "/libexec")));}' unless defined(&LIBEXECDIR);
	    eval 'sub ETCDIR () {( &br_thread_local_store ( &br_prepend_prefix (( &void *) "", "/etc")));}' unless defined(&ETCDIR);
	    eval 'sub SYSCONFDIR () {( &br_thread_local_store ( &br_prepend_prefix (( &void *) "", "/etc")));}' unless defined(&SYSCONFDIR);
	    eval 'sub CONFDIR () {( &br_thread_local_store ( &br_prepend_prefix (( &void *) "", "/etc")));}' unless defined(&CONFDIR);
	    eval 'sub LOCALEDIR () {( &br_thread_local_store ( &br_prepend_prefix (( &void *) "", "/share/locale")));}' unless defined(&LOCALEDIR);
	}
    }
    eval 'sub br_strcat () { &BR_NAMESPACE( &br_strcat);}' unless defined(&br_strcat);
    eval 'sub br_extract_dir () { &BR_NAMESPACE( &br_extract_dir);}' unless defined(&br_extract_dir);
    eval 'sub br_extract_prefix () { &BR_NAMESPACE( &br_extract_prefix);}' unless defined(&br_extract_prefix);
    eval 'sub br_set_locate_fallback_func () { &BR_NAMESPACE( &br_set_locate_fallback_func);}' unless defined(&br_set_locate_fallback_func);
    unless(defined(&BR_NO_MACROS)) {
	eval 'sub BR_SELFPATH {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &SELFPATH, $suffix))));
	}' unless defined(&BR_SELFPATH);
	eval 'sub BR_PREFIX {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &PREFIX, $suffix))));
	}' unless defined(&BR_PREFIX);
	eval 'sub BR_PREFIXDIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &BR_PREFIX, $suffix))));
	}' unless defined(&BR_PREFIXDIR);
	eval 'sub BR_BINDIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &BINDIR, $suffix))));
	}' unless defined(&BR_BINDIR);
	eval 'sub BR_SBINDIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &SBINDIR, $suffix))));
	}' unless defined(&BR_SBINDIR);
	eval 'sub BR_DATADIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &DATADIR, $suffix))));
	}' unless defined(&BR_DATADIR);
	eval 'sub BR_LIBDIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &LIBDIR, $suffix))));
	}' unless defined(&BR_LIBDIR);
	eval 'sub BR_LIBEXECDIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &LIBEXECDIR, $suffix))));
	}' unless defined(&BR_LIBEXECDIR);
	eval 'sub BR_ETCDIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &ETCDIR, $suffix))));
	}' unless defined(&BR_ETCDIR);
	eval 'sub BR_SYSCONFDIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &SYSCONFDIR, $suffix))));
	}' unless defined(&BR_SYSCONFDIR);
	eval 'sub BR_CONFDIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &CONFDIR, $suffix))));
	}' unless defined(&BR_CONFDIR);
	eval 'sub BR_LOCALEDIR {
	    my($suffix) = @_;
    	    eval q(( &br_thread_local_store ( &br_strcat ( &LOCALEDIR, $suffix))));
	}' unless defined(&BR_LOCALEDIR);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
