require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_GIF_LIB_H)) {
    eval 'sub _GIF_LIB_H () {1;}' unless defined(&_GIF_LIB_H);
    eval 'sub GIF_LIB_VERSION () {" Version 4.0, ";}' unless defined(&GIF_LIB_VERSION);
    eval 'sub GIF_ERROR () {0;}' unless defined(&GIF_ERROR);
    eval 'sub GIF_OK () {1;}' unless defined(&GIF_OK);
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
    }
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    eval 'sub GIF_STAMP () {"GIFVER";}' unless defined(&GIF_STAMP);
    eval 'sub GIF_STAMP_LEN () {$sizeof{ &GIF_STAMP} - 1;}' unless defined(&GIF_STAMP_LEN);
    eval 'sub GIF_VERSION_POS () {3;}' unless defined(&GIF_VERSION_POS);
    eval 'sub GIF87_STAMP () {"GIF87a";}' unless defined(&GIF87_STAMP);
    eval 'sub GIF89_STAMP () {"GIF89a";}' unless defined(&GIF89_STAMP);
    eval 'sub GIF_FILE_BUFFER_SIZE () {16384;}' unless defined(&GIF_FILE_BUFFER_SIZE);
    eval 'sub GIF_MESSAGE {
        my($Msg) = @_;
	    eval q( &fprintf( &stderr, \\"\\\\n%s: %s\\\\n\\",  &PROGRAM_NAME, $Msg));
    }' unless defined(&GIF_MESSAGE);
    eval 'sub GIF_EXIT {
        my($Msg) = @_;
	    eval q({  &GIF_MESSAGE($Msg);  &exit(-3); });
    }' unless defined(&GIF_EXIT);
    if(defined(&SYSV)) {
	eval 'sub VoidPtr () {\'char\' *;}' unless defined(&VoidPtr);
    } else {
	eval 'sub VoidPtr () { &void *;}' unless defined(&VoidPtr);
    }
    eval("sub UNDEFINED_RECORD_TYPE () { 0; }") unless defined(&UNDEFINED_RECORD_TYPE);
    eval("sub SCREEN_DESC_RECORD_TYPE () { 1; }") unless defined(&SCREEN_DESC_RECORD_TYPE);
    eval("sub IMAGE_DESC_RECORD_TYPE () { 2; }") unless defined(&IMAGE_DESC_RECORD_TYPE);
    eval("sub EXTENSION_RECORD_TYPE () { 3; }") unless defined(&EXTENSION_RECORD_TYPE);
    eval("sub TERMINATE_RECORD_TYPE () { 4; }") unless defined(&TERMINATE_RECORD_TYPE);
    eval("sub GIF_DUMP_SGI_WINDOW () { 1000; }") unless defined(&GIF_DUMP_SGI_WINDOW);
    eval("sub GIF_DUMP_X_WINDOW () { 1001; }") unless defined(&GIF_DUMP_X_WINDOW);
    eval 'sub COMMENT_EXT_FUNC_CODE () {0xfe;}' unless defined(&COMMENT_EXT_FUNC_CODE);
    eval 'sub GRAPHICS_EXT_FUNC_CODE () {0xf9;}' unless defined(&GRAPHICS_EXT_FUNC_CODE);
    eval 'sub PLAINTEXT_EXT_FUNC_CODE () {0x1;}' unless defined(&PLAINTEXT_EXT_FUNC_CODE);
    eval 'sub APPLICATION_EXT_FUNC_CODE () {0xff;}' unless defined(&APPLICATION_EXT_FUNC_CODE);
    eval 'sub E_GIF_ERR_OPEN_FAILED () {1;}' unless defined(&E_GIF_ERR_OPEN_FAILED);
    eval 'sub E_GIF_ERR_WRITE_FAILED () {2;}' unless defined(&E_GIF_ERR_WRITE_FAILED);
    eval 'sub E_GIF_ERR_HAS_SCRN_DSCR () {3;}' unless defined(&E_GIF_ERR_HAS_SCRN_DSCR);
    eval 'sub E_GIF_ERR_HAS_IMAG_DSCR () {4;}' unless defined(&E_GIF_ERR_HAS_IMAG_DSCR);
    eval 'sub E_GIF_ERR_NO_COLOR_MAP () {5;}' unless defined(&E_GIF_ERR_NO_COLOR_MAP);
    eval 'sub E_GIF_ERR_DATA_TOO_BIG () {6;}' unless defined(&E_GIF_ERR_DATA_TOO_BIG);
    eval 'sub E_GIF_ERR_NOT_ENOUGH_MEM () {7;}' unless defined(&E_GIF_ERR_NOT_ENOUGH_MEM);
    eval 'sub E_GIF_ERR_DISK_IS_FULL () {8;}' unless defined(&E_GIF_ERR_DISK_IS_FULL);
    eval 'sub E_GIF_ERR_CLOSE_FAILED () {9;}' unless defined(&E_GIF_ERR_CLOSE_FAILED);
    eval 'sub E_GIF_ERR_NOT_WRITEABLE () {10;}' unless defined(&E_GIF_ERR_NOT_WRITEABLE);
    eval 'sub D_GIF_ERR_OPEN_FAILED () {101;}' unless defined(&D_GIF_ERR_OPEN_FAILED);
    eval 'sub D_GIF_ERR_READ_FAILED () {102;}' unless defined(&D_GIF_ERR_READ_FAILED);
    eval 'sub D_GIF_ERR_NOT_GIF_FILE () {103;}' unless defined(&D_GIF_ERR_NOT_GIF_FILE);
    eval 'sub D_GIF_ERR_NO_SCRN_DSCR () {104;}' unless defined(&D_GIF_ERR_NO_SCRN_DSCR);
    eval 'sub D_GIF_ERR_NO_IMAG_DSCR () {105;}' unless defined(&D_GIF_ERR_NO_IMAG_DSCR);
    eval 'sub D_GIF_ERR_NO_COLOR_MAP () {106;}' unless defined(&D_GIF_ERR_NO_COLOR_MAP);
    eval 'sub D_GIF_ERR_WRONG_RECORD () {107;}' unless defined(&D_GIF_ERR_WRONG_RECORD);
    eval 'sub D_GIF_ERR_DATA_TOO_BIG () {108;}' unless defined(&D_GIF_ERR_DATA_TOO_BIG);
    eval 'sub D_GIF_ERR_NOT_ENOUGH_MEM () {109;}' unless defined(&D_GIF_ERR_NOT_ENOUGH_MEM);
    eval 'sub D_GIF_ERR_CLOSE_FAILED () {110;}' unless defined(&D_GIF_ERR_CLOSE_FAILED);
    eval 'sub D_GIF_ERR_NOT_READABLE () {111;}' unless defined(&D_GIF_ERR_NOT_READABLE);
    eval 'sub D_GIF_ERR_IMAGE_DEFECT () {112;}' unless defined(&D_GIF_ERR_IMAGE_DEFECT);
    eval 'sub D_GIF_ERR_EOF_TOO_SOON () {113;}' unless defined(&D_GIF_ERR_EOF_TOO_SOON);
    if(defined(&HAVE_VARARGS_H)) {
    } else {
    }
    eval 'sub GIF_FONT_WIDTH () {8;}' unless defined(&GIF_FONT_WIDTH);
    eval 'sub GIF_FONT_HEIGHT () {8;}' unless defined(&GIF_FONT_HEIGHT);
}
1;
