require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XmHTMLI_h_)) {
    eval 'sub _XmHTMLI_h_ () {1;}' unless defined(&_XmHTMLI_h_);
    unless(defined(&XmHTML_ERROR_FUNCS)) {
	eval 'sub Abs {
	    my($x) = @_;
    	    eval q((($x) < 0? -($x) : ($x)));
	}' unless defined(&Abs);
	eval 'sub Max {
	    my($x,$y) = @_;
    	    eval q(((($x) > ($y)) ? ($x) : ($y)));
	}' unless defined(&Max);
	eval 'sub Min {
	    my($x,$y) = @_;
    	    eval q(((($x) < ($y)) ? ($x) : ($y)));
	}' unless defined(&Min);
	eval 'sub FONTHEIGHT {
	    my($f) = @_;
    	    eval q((($f)-> ($max_bounds->{ascent}) + ($f)-> ($max_bounds->{descent})));
	}' unless defined(&FONTHEIGHT);
	eval 'sub FnHeight {
	    my($f) = @_;
    	    eval q((($f)-> &ascent + ($f)-> &descent));
	}' unless defined(&FnHeight);
	eval 'sub RANGE {
	    my($a,$b,$c) = @_;
    	    eval q({  &if ($a < $b) $a = $b;  &if ($a > $c) $a = $c; });
	}' unless defined(&RANGE);
	eval 'sub OPTIONAL_CLOSURE {
	    my($id) = @_;
    	    eval q((($id) ==  &HT_DD || ($id) ==  &HT_DT || ($id) ==  &HT_LI || ($id) ==  &HT_P || ($id) ==  &HT_OPTION || ($id) ==  &HT_TD || ($id) ==  &HT_TH || ($id) ==  &HT_TR));
	}' unless defined(&OPTIONAL_CLOSURE);
	eval 'sub IS_MARKUP {
	    my($id) = @_;
    	    eval q((($id) ==  &HT_TT || ($id) ==  &HT_I || ($id) ==  &HT_B || ($id) ==  &HT_U || ($id) ==  &HT_STRIKE || ($id) ==  &HT_BIG || ($id) ==  &HT_SMALL || ($id) ==  &HT_SUB || ($id) ==  &HT_SUP || ($id) ==  &HT_EM || ($id) ==  &HT_STRONG || ($id) ==  &HT_DFN || ($id) ==  &HT_CODE || ($id) ==  &HT_SAMP || ($id) ==  &HT_KBD || ($id) ==  &HT_VAR || ($id) ==  &HT_CITE || ($id) ==  &HT_FONT));
	}' unless defined(&IS_MARKUP);
	eval 'sub IS_CONTAINER {
	    my($id) = @_;
    	    eval q((($id) ==  &HT_BODY || ($id) ==  &HT_DIV || ($id) ==  &HT_CENTER || ($id) ==  &HT_BLOCKQUOTE || ($id) ==  &HT_FORM || ($id) ==  &HT_TH || ($id) ==  &HT_TD || ($id) ==  &HT_DD || ($id) ==  &HT_LI || ($id) ==  &HT_NOFRAMES));
	}' unless defined(&IS_CONTAINER);
	eval 'sub NESTED_ELEMENT {
	    my($id) = @_;
    	    eval q(( &IS_MARKUP($id) || ($id) ==  &HT_APPLET || ($id) ==  &HT_BLOCKQUOTE || ($id) ==  &HT_DIV || ($id) ==  &HT_CENTER || ($id) ==  &HT_FRAMESET));
	}' unless defined(&NESTED_ELEMENT);
	eval 'sub IS_MISC {
	    my($id) = @_;
    	    eval q((($id) ==  &HT_P || ($id) ==  &HT_H1 || ($id) ==  &HT_H2 || ($id) ==  &HT_H3 || ($id) ==  &HT_H4 || ($id) ==  &HT_H5 || ($id) ==  &HT_H6 || ($id) ==  &HT_PRE || ($id) ==  &HT_ADDRESS || ($id) ==  &HT_APPLET || ($id) ==  &HT_CAPTION || ($id) ==  &HT_A || ($id) ==  &HT_DT));
	}' unless defined(&IS_MISC);
	eval 'sub _FastLower {
	    my($x) = @_;
    	    eval q(( $__my_translation_table[$x]));
	}' unless defined(&_FastLower);
	if(defined(&NEED_STRERROR)) {
	    eval 'sub strerror {
	        my($ERRNUM) = @_;
    		eval q( $sys_errlist[$ERRNUM]);
	    }' unless defined(&strerror);
	}
	if(defined(&NEED_STRCASECMP)) {
	    require 'sys/types.ph';
	    eval 'sub strcasecmp {
	        my($S1,$S2) = @_;
    		eval q( &my_strcasecmp($S1,$S2));
	    }' unless defined(&strcasecmp);
	    eval 'sub strncasecmp {
	        my($S1,$S2,$N) = @_;
    		eval q( &my_strncasecmp($S1,$S2,$N));
	    }' unless defined(&strncasecmp);
	}
	eval 'sub FreePixmap {
	    my($DPY,$PIX) = @_;
    	    eval q( &if(($PIX)!=  &None)  &Toolkit_Free_Pixmap(($DPY),($PIX)));
	}' unless defined(&FreePixmap);
	eval 'sub BodyImageLoaded {
	    my($IMAGE) = @_;
    	    eval q((($IMAGE) ? (! &ImageInfoDelayed(($IMAGE))  && ! &ImageInfoProgressive(($IMAGE))) :  &True));
	}' unless defined(&BodyImageLoaded);
	eval 'sub ImageIsBackground {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_ISBACKGROUND));
	}' unless defined(&ImageIsBackground);
	eval 'sub ImageIsInternal {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_ISINTERNAL));
	}' unless defined(&ImageIsInternal);
	eval 'sub ImageIsCopy {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_ISCOPY));
	}' unless defined(&ImageIsCopy);
	eval 'sub ImageIsAnim {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_ISANIM));
	}' unless defined(&ImageIsAnim);
	eval 'sub ImageFrameRefresh {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_FRAMEREFRESH));
	}' unless defined(&ImageFrameRefresh);
	eval 'sub ImageHasDimensions {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_HASDIMENSIONS));
	}' unless defined(&ImageHasDimensions);
	eval 'sub ImageHasState {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_HASSTATE));
	}' unless defined(&ImageHasState);
	eval 'sub ImageInfoFreed {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_INFOFREED));
	}' unless defined(&ImageInfoFreed);
	eval 'sub ImageDelayedCreation {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_DELAYED_CREATION));
	}' unless defined(&ImageDelayedCreation);
	eval 'sub ImageIsOrphaned {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_ORPHANED));
	}' unless defined(&ImageIsOrphaned);
	eval 'sub ImageIsProgressive {
	    my($IMG) = @_;
    	    eval q((($IMG)-> &options &  &IMG_PROGRESSIVE));
	}' unless defined(&ImageIsProgressive);
	eval 'sub ImageInfoDelayed {
	    my($INFO) = @_;
    	    eval q((($INFO)-> &options &  &XmIMAGE_DELAYED));
	}' unless defined(&ImageInfoDelayed);
	eval 'sub ImageInfoFreeLater {
	    my($INFO) = @_;
    	    eval q((($INFO)-> &options &  &XmIMAGE_DEFERRED_FREE));
	}' unless defined(&ImageInfoFreeLater);
	eval 'sub ImageInfoFreeNow {
	    my($INFO) = @_;
    	    eval q((($INFO)-> &options &  &XmIMAGE_IMMEDIATE_FREE));
	}' unless defined(&ImageInfoFreeNow);
	eval 'sub ImageInfoScale {
	    my($INFO) = @_;
    	    eval q((($INFO)-> &options &  &XmIMAGE_ALLOW_SCALE));
	}' unless defined(&ImageInfoScale);
	eval 'sub ImageInfoRGBSingle {
	    my($INFO) = @_;
    	    eval q((($INFO)-> &options &  &XmIMAGE_RGB_SINGLE));
	}' unless defined(&ImageInfoRGBSingle);
	eval 'sub ImageInfoShared {
	    my($INFO) = @_;
    	    eval q((($INFO)-> &options &  &XmIMAGE_SHARED_DATA));
	}' unless defined(&ImageInfoShared);
	eval 'sub ImageInfoClipmask {
	    my($INFO) = @_;
    	    eval q((($INFO)-> &options &  &XmIMAGE_CLIPMASK));
	}' unless defined(&ImageInfoClipmask);
	eval 'sub ImageInfoDelayedCreation {
	    my($INFO) = @_;
    	    eval q((($INFO)-> &options &  &XmIMAGE_DELAYED_CREATION));
	}' unless defined(&ImageInfoDelayedCreation);
	eval 'sub ImageInfoProgressive {
	    my($INFO) = @_;
    	    eval q((($INFO)-> &options &  &XmIMAGE_PROGRESSIVE));
	}' unless defined(&ImageInfoProgressive);
	eval 'sub RewindImageBuffer {
	    my($IB) = @_;
    	    eval q( &do{ -> &next = 0; ($IB)-> &curr_pos = ($IB)-> &buffer; } &while(0));
	}' unless defined(&RewindImageBuffer);
	eval 'sub FreeImageBuffer {
	    my($IB) = @_;
    	    eval q({  &if(($IB)-> &may_free) {  &free(($IB)-> &file);  &free(($IB)-> &buffer);  &free(($IB)); ($IB) =  &NULL; } });
	}' unless defined(&FreeImageBuffer);
	eval 'sub AllocRawImage {
	    my($IMG, $W, $H) = @_;
    	    eval q( &do { $IMG = ( &XmHTMLRawImageData*) &malloc($sizeof{ &XmHTMLRawImageData});  &memset($IMG, 0, $sizeof{ &XmHTMLRawImageData});  ($IMG->{cmapsize}) = 0;  ($IMG->{bg}) = -1;  ($IMG->{width}) = $W;  ($IMG->{height}) = $H;  ($IMG->{data}) = ( &Byte*) &calloc($W*$H, $sizeof{ &Byte});  ($IMG->{delayed_creation}) =  &False;  ($IMG->{color_class}) =  &XmIMAGE_COLORSPACE_INDEXED; } &while(0));
	}' unless defined(&AllocRawImage);
	if(defined(&WITH_MOTIF)) {
	    eval 'sub AllocRawImageCmap {
	        my($IMG,$SIZE) = @_;
    		eval q( &do { \'int\'  &i;  ($IMG->{cmap}) = ( &XColor*) &calloc($SIZE, $sizeof{ &XColor});  &for( &i = 0;  &i < $SIZE;  &i++) {  ($IMG->{cmap[&i]}->{pixel}) =  &i;  ($IMG->{cmap[&i]}->{flags}) =  &DoRed| &DoGreen| &DoBlue; }  ($IMG->{cmapsize}) = $SIZE; } &while(0));
	    }' unless defined(&AllocRawImageCmap);
	} else {
	    eval 'sub AllocRawImageCmap {
	        my($IMG,$SIZE) = @_;
    		eval q( &do { \'int\'  &i;  ($IMG->{cmap}) = ( &GdkColor*) &calloc($SIZE, $sizeof{ &GdkColor});  &for( &i = 0;  &i < $SIZE;  &i++) {  ($IMG->{cmap[&i]}->{pixel}) =  &i; }  ($IMG->{cmapsize}) = $SIZE; } &while(0));
	    }' unless defined(&AllocRawImageCmap);
	}
	eval 'sub AllocRawImageWithCmap {
	    my($IMG, $W, $H, $SIZE) = @_;
    	    eval q( &do { $IMG = ( &XmHTMLRawImageData*) &malloc($sizeof{ &XmHTMLRawImageData});  &memset($IMG, 0, $sizeof{ &XmHTMLRawImageData});  &AllocRawImageCmap($IMG,$SIZE);  ($IMG->{bg}) = -1;  ($IMG->{width}) = $W;  ($IMG->{height}) = $H;  ($IMG->{data}) = ( &Byte*) &calloc($W*$H, $sizeof{ &Byte});  ($IMG->{delayed_creation}) =  &False; } &while(0));
	}' unless defined(&AllocRawImageWithCmap);
	eval 'sub FreeRawImage {
	    my($IMG) = @_;
    	    eval q( &do{  &if($IMG !=  &NULL) {  &if( ($IMG->{data}))  &free( ($IMG->{data}));  &if( ($IMG->{cmap}))  &free( ($IMG->{cmap}));  &free($IMG); $IMG =  &NULL; }} &while(0));
	}' unless defined(&FreeRawImage);
	eval 'sub ResetRawImage {
	    my($IMG) = @_;
    	    eval q( &do {  &memset($IMG, 0, $sizeof{ &XmHTMLRawImageData});  &if( ($IMG->{cmap}))  &free( ($IMG->{cmap}));  ($IMG->{cmap}) = ( &TColor*) &NULL;  ($IMG->{cmapsize}) = 0;  ($IMG->{bg}) = -1;  ($IMG->{width}) = 0;  ($IMG->{height}) = 0;  ($IMG->{data}) = ( &Byte*) &NULL;  ($IMG->{delayed_creation}) =  &False; } &while(0));
	}' unless defined(&ResetRawImage);
	if(defined(&WITH_MOTIF)) {
	} else {
	}
    }
    if(defined(&DEBUG)) {
	eval 'sub __WFUNC__ {
	    my($WIDGET_ID, $FUNC) = @_;
    	    eval q(( &TWidget)$WIDGET_ID,  &__FILE__,  &__LINE__, $FUNC);
	}' unless defined(&__WFUNC__);
	eval 'sub _XmHTMLBadParent {
	    my($W,$FUNC) = @_;
    	    eval q( &__XmHTMLBadParent($W, &__FILE__, &__LINE__,$FUNC));
	}' unless defined(&_XmHTMLBadParent);
    } else {
	eval 'sub __WFUNC__ {
	    my($WIDGET_ID, $FUNC) = @_;
    	    eval q(( &TWidget)$WIDGET_ID);
	}' unless defined(&__WFUNC__);
	eval 'sub _XmHTMLBadParent {
	    my($W,$FUNC) = @_;
    	    eval q( &__XmHTMLBadParent($W,$FUNC));
	}' unless defined(&_XmHTMLBadParent);
    }
    eval 'sub _XmHTMLWarning () { &__XmHTMLWarning;}' unless defined(&_XmHTMLWarning);
    eval 'sub _XmHTMLError () { &__XmHTMLError;}' unless defined(&_XmHTMLError);
    require 'gtk-xmhtml.ph';
    require 'gtk-xmhtml-p.ph';
}
1;
