require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&GNOME_EXCLUDE_DEPRECATED)) {
    unless(defined(&__GTK_XMHTML_H__)) {
	eval 'sub __GTK_XMHTML_H__ () {1;}' unless defined(&__GTK_XMHTML_H__);
	require 'gdk/gdk.ph';
	require 'gtk/gtkobject.ph';
	unless(defined(&GTK_XMHTML_LIBRARY)) {
	    unless(defined(&WITH_GTK)) {
		eval 'sub WITH_GTK () {1;}' unless defined(&WITH_GTK);
	    }
	    require 'gtk-xmhtml/toolkit.ph';
	    require 'gtk-xmhtml/XmHTML.ph';
	}
	if(defined(&__cplusplus)) {
	}
	eval 'sub GTK_XMHTML {
	    my($obj) = @_;
    	    eval q( &GTK_CHECK_CAST ($obj,  &gtk_xmhtml_get_type (),  &GtkXmHTML));
	}' unless defined(&GTK_XMHTML);
	eval 'sub GTK_XMHTML_CLASS {
	    my($klass) = @_;
    	    eval q( &GTK_CHECK_CLASS_CAST ($klass,  &gtk_xmhtml_get_type (),  &GtkXmHTMLClass));
	}' unless defined(&GTK_XMHTML_CLASS);
	eval 'sub GTK_IS_XMHTML {
	    my($obj) = @_;
    	    eval q( &GTK_CHECK_TYPE ($obj,  &gtk_xmhtml_get_type ()));
	}' unless defined(&GTK_IS_XMHTML);
	eval 'sub XmIsHTML {
	    my($obj) = @_;
    	    eval q( &GTK_IS_XMHTML($obj));
	}' unless defined(&XmIsHTML);
	eval 'sub XmHTML {
	    my($obj) = @_;
    	    eval q( &GTK_XMHTML($obj));
	}' unless defined(&XmHTML);
	unless(defined(&GTK_XMHTML_LIBRARY)) {
	    require 'gtk-xmhtml/XmHTMLP.ph';
	}
	eval("sub GTK_ANCHOR_NOLINE () { 0; }") unless defined(&GTK_ANCHOR_NOLINE);
	eval("sub GTK_ANCHOR_SINGLE_LINE () { 1; }") unless defined(&GTK_ANCHOR_SINGLE_LINE);
	eval("sub GTK_ANCHOR_DOUBLE_LINE () { 2; }") unless defined(&GTK_ANCHOR_DOUBLE_LINE);
	eval("sub GTK_ANCHOR_DASHED_LINE () { 3; }") unless defined(&GTK_ANCHOR_DASHED_LINE);
	eval("sub GTK_ANCHOR_DOUBLE_DASHED_LINE () { 4; }") unless defined(&GTK_ANCHOR_DOUBLE_DASHED_LINE);
	if(defined(&__cplusplus)) {
	}
    }
}
1;
