require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ART_MISC_H__)) {
    eval 'sub __ART_MISC_H__ () {1;}' unless defined(&__ART_MISC_H__);
    require 'stdlib.ph';
    if(defined(&LIBART_COMPILATION)) {
	require 'art_config.ph';
    } else {
	require 'libart_lgpl/art_config.ph';
    }
    eval 'sub art_alloc () { &malloc;}' unless defined(&art_alloc);
    eval 'sub art_free () { &free;}' unless defined(&art_free);
    eval 'sub art_realloc () { &realloc;}' unless defined(&art_realloc);
    eval 'sub art_new {
        my($type, $n) = @_;
	    eval q((($type *) &art_alloc (($n) * $sizeof{$type})));
    }' unless defined(&art_new);
    eval 'sub art_renew {
        my($p, $type, $n) = @_;
	    eval q((($type *) &art_realloc ($p, ($n) * $sizeof{$type})));
    }' unless defined(&art_renew);
    eval 'sub art_expand {
        my($p, $type, $max) = @_;
	    eval q($p =  &art_renew ($p, $type, $max <<= 1));
    }' unless defined(&art_expand);
    eval 'sub ART_FALSE () {0;}' unless defined(&ART_FALSE);
    eval 'sub ART_TRUE () {1;}' unless defined(&ART_TRUE);
    unless(defined(&M_PI)) {
	eval 'sub M_PI () {3.14159265358979323846;}' unless defined(&M_PI);
    }
    unless(defined(&M_SQRT2)) {
	eval 'sub M_SQRT2 () {1.41421356237309504880;}' unless defined(&M_SQRT2);
    }
    if(defined( &__GNUC__)  && ((defined(&__GNUC__) ? &__GNUC__ : 0) > 2|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) > 4))) {
	eval 'sub ART_GNUC_PRINTF {
	    my( $format_idx, $arg_idx ) = @_;
    	    eval q( &__attribute__(( &format ( &printf, $format_idx, $arg_idx))));
	}' unless defined(&ART_GNUC_PRINTF);
    } else {
	eval 'sub ART_GNUC_PRINTF {
	    my( $format_idx, $arg_idx ) = @_;
    	    eval q();
	}' unless defined(&ART_GNUC_PRINTF);
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
