require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&GNOME_CANVAS_H)) {
    eval 'sub GNOME_CANVAS_H () {1;}' unless defined(&GNOME_CANVAS_H);
    require 'libgnome/gnome-defs.ph';
    require 'gtk/gtklayout.ph';
    require 'stdarg.ph';
    require 'libart_lgpl/art_misc.ph';
    require 'libart_lgpl/art_rect.ph';
    require 'libart_lgpl/art_svp.ph';
    require 'libart_lgpl/art_uta.ph';
    require 'libart_lgpl/art_affine.ph';
    eval 'sub GNOME_CANVAS_EPSILON () {1 &e-10;}' unless defined(&GNOME_CANVAS_EPSILON);
    eval 'sub GNOME_CANVAS_COLOR {
        my($r, $g, $b) = @_;
	    eval q(((( & 0xff) << 24) | (( & 0xff) << 16) | (( ($b) & 0xff) << 8) | 0xff));
    }' unless defined(&GNOME_CANVAS_COLOR);
    eval 'sub GNOME_CANVAS_COLOR_A {
        my($r, $g, $b, $a) = @_;
	    eval q(((( & 0xff) << 24) | (( & 0xff) << 16) | (( & 0xff) << 8) | ( ($a) & 0xff)));
    }' unless defined(&GNOME_CANVAS_COLOR_A);
    eval("sub GNOME_CANVAS_ITEM_REALIZED () { 1<<4; }") unless defined(&GNOME_CANVAS_ITEM_REALIZED);
    eval("sub GNOME_CANVAS_ITEM_MAPPED () { 1<<5; }") unless defined(&GNOME_CANVAS_ITEM_MAPPED);
    eval("sub GNOME_CANVAS_ITEM_ALWAYS_REDRAW () { 1<<6; }") unless defined(&GNOME_CANVAS_ITEM_ALWAYS_REDRAW);
    eval("sub GNOME_CANVAS_ITEM_VISIBLE () { 1<<7; }") unless defined(&GNOME_CANVAS_ITEM_VISIBLE);
    eval("sub GNOME_CANVAS_ITEM_NEED_UPDATE () { 1<<8; }") unless defined(&GNOME_CANVAS_ITEM_NEED_UPDATE);
    eval("sub GNOME_CANVAS_ITEM_NEED_AFFINE () { 1<<9; }") unless defined(&GNOME_CANVAS_ITEM_NEED_AFFINE);
    eval("sub GNOME_CANVAS_ITEM_NEED_CLIP () { 1<<10; }") unless defined(&GNOME_CANVAS_ITEM_NEED_CLIP);
    eval("sub GNOME_CANVAS_ITEM_NEED_VIS () { 1<<11; }") unless defined(&GNOME_CANVAS_ITEM_NEED_VIS);
    eval("sub GNOME_CANVAS_ITEM_AFFINE_FULL () { 1<<12; }") unless defined(&GNOME_CANVAS_ITEM_AFFINE_FULL);
    eval("sub GNOME_CANVAS_UPDATE_REQUESTED () { 1<<0; }") unless defined(&GNOME_CANVAS_UPDATE_REQUESTED);
    eval("sub GNOME_CANVAS_UPDATE_AFFINE () { 1<<1; }") unless defined(&GNOME_CANVAS_UPDATE_AFFINE);
    eval("sub GNOME_CANVAS_UPDATE_CLIP () { 1<<2; }") unless defined(&GNOME_CANVAS_UPDATE_CLIP);
    eval("sub GNOME_CANVAS_UPDATE_VISIBILITY () { 1<<3; }") unless defined(&GNOME_CANVAS_UPDATE_VISIBILITY);
    eval("sub GNOME_CANVAS_UPDATE_IS_VISIBLE () { 1<<4; }") unless defined(&GNOME_CANVAS_UPDATE_IS_VISIBLE);
    eval 'sub GNOME_TYPE_CANVAS_ITEM () {( &gnome_canvas_item_get_type ());}' unless defined(&GNOME_TYPE_CANVAS_ITEM);
    eval 'sub GNOME_CANVAS_ITEM {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_CAST (($obj),  &GNOME_TYPE_CANVAS_ITEM,  &GnomeCanvasItem)));
    }' unless defined(&GNOME_CANVAS_ITEM);
    eval 'sub GNOME_CANVAS_ITEM_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_CAST (($klass),  &GNOME_TYPE_CANVAS_ITEM,  &GnomeCanvasItemClass)));
    }' unless defined(&GNOME_CANVAS_ITEM_CLASS);
    eval 'sub GNOME_IS_CANVAS_ITEM {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_TYPE (($obj),  &GNOME_TYPE_CANVAS_ITEM)));
    }' unless defined(&GNOME_IS_CANVAS_ITEM);
    eval 'sub GNOME_IS_CANVAS_ITEM_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_TYPE (($klass),  &GNOME_TYPE_CANVAS_ITEM)));
    }' unless defined(&GNOME_IS_CANVAS_ITEM_CLASS);
    eval 'sub GNOME_TYPE_CANVAS_GROUP () {( &gnome_canvas_group_get_type ());}' unless defined(&GNOME_TYPE_CANVAS_GROUP);
    eval 'sub GNOME_CANVAS_GROUP {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_CAST (($obj),  &GNOME_TYPE_CANVAS_GROUP,  &GnomeCanvasGroup)));
    }' unless defined(&GNOME_CANVAS_GROUP);
    eval 'sub GNOME_CANVAS_GROUP_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_CAST (($klass),  &GNOME_TYPE_CANVAS_GROUP,  &GnomeCanvasGroupClass)));
    }' unless defined(&GNOME_CANVAS_GROUP_CLASS);
    eval 'sub GNOME_IS_CANVAS_GROUP {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_TYPE (($obj),  &GNOME_TYPE_CANVAS_GROUP)));
    }' unless defined(&GNOME_IS_CANVAS_GROUP);
    eval 'sub GNOME_IS_CANVAS_GROUP_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_TYPE (($klass),  &GNOME_TYPE_CANVAS_GROUP)));
    }' unless defined(&GNOME_IS_CANVAS_GROUP_CLASS);
    if(defined(&OLD_XFORM)) {
    }
    eval 'sub GNOME_TYPE_CANVAS () {( &gnome_canvas_get_type ());}' unless defined(&GNOME_TYPE_CANVAS);
    eval 'sub GNOME_CANVAS {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_CAST (($obj),  &GNOME_TYPE_CANVAS,  &GnomeCanvas)));
    }' unless defined(&GNOME_CANVAS);
    eval 'sub GNOME_CANVAS_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_CAST (($klass),  &GNOME_TYPE_CANVAS,  &GnomeCanvasClass)));
    }' unless defined(&GNOME_CANVAS_CLASS);
    eval 'sub GNOME_IS_CANVAS {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_TYPE (($obj),  &GNOME_TYPE_CANVAS)));
    }' unless defined(&GNOME_IS_CANVAS);
    eval 'sub GNOME_IS_CANVAS_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_TYPE (($klass),  &GNOME_TYPE_CANVAS)));
    }' unless defined(&GNOME_IS_CANVAS_CLASS);
    unless(defined(&GNOME_EXCLUDE_EXPERIMENTAL)) {
    }
}
1;
