require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_DEBUG_MEMORY_ALLOC_)) {
    eval 'sub _DEBUG_MEMORY_ALLOC_ () {1;}' unless defined(&_DEBUG_MEMORY_ALLOC_);
    eval 'sub NO_DEBUG_MEMORY () {1;}' unless defined(&NO_DEBUG_MEMORY);
    if(defined(&NO_DEBUG_MEMORY)) {
	if(defined(&HAVE_MALLOC_H)) {
	    require 'malloc.ph';
	}
	eval 'sub xmlFree {
	    my($x) = @_;
    	    eval q( &free(($x)));
	}' unless defined(&xmlFree);
	eval 'sub xmlMalloc {
	    my($x) = @_;
    	    eval q( &malloc($x));
	}' unless defined(&xmlMalloc);
	eval 'sub xmlRealloc {
	    my($p, $x) = @_;
    	    eval q( &realloc(($p), ($x)));
	}' unless defined(&xmlRealloc);
	eval 'sub xmlMemStrdup {
	    my($x) = @_;
    	    eval q( &strdup(($x)));
	}' unless defined(&xmlMemStrdup);
	eval 'sub xmlInitMemory () {
	    eval q();
	}' unless defined(&xmlInitMemory);
	eval 'sub xmlMemUsed () {
	    eval q();
	}' unless defined(&xmlMemUsed);
	eval 'sub xmlInitMemory () {
	    eval q();
	}' unless defined(&xmlInitMemory);
	eval 'sub xmlMemoryDump () {
	    eval q();
	}' unless defined(&xmlMemoryDump);
	eval 'sub xmlMemDisplay {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&xmlMemDisplay);
	eval 'sub xmlMemShow {
	    my($x, $d) = @_;
    	    eval q();
	}' unless defined(&xmlMemShow);
    } else {
	require 'stdio.ph';
	eval 'sub DEBUG_MEMORY_LOCATION () {1;}' unless defined(&DEBUG_MEMORY_LOCATION);
	if(defined(&DEBUG)) {
	    unless(defined(&DEBUG_MEMORY)) {
		eval 'sub DEBUG_MEMORY () {1;}' unless defined(&DEBUG_MEMORY);
	    }
	}
	eval 'sub MEM_LIST () {1;}' unless defined(&MEM_LIST);
	if(defined(&__cplusplus)) {
	}
	if(defined(&DEBUG_MEMORY_LOCATION)) {
	    eval 'sub xmlMalloc {
	        my($x) = @_;
    		eval q( &xmlMallocLoc(($x),  &__FILE__,  &__LINE__));
	    }' unless defined(&xmlMalloc);
	    eval 'sub xmlRealloc {
	        my($p, $x) = @_;
    		eval q( &xmlReallocLoc(($p), ($x),  &__FILE__,  &__LINE__));
	    }' unless defined(&xmlRealloc);
	    eval 'sub xmlMemStrdup {
	        my($x) = @_;
    		eval q( &xmlMemStrdupLoc(($x),  &__FILE__,  &__LINE__));
	    }' unless defined(&xmlMemStrdup);
	    if(defined(&__cplusplus)) {
	    }
	}
    }
}
1;
