require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__cplusplus)) {
}
unless(defined(&ATT_GRAPHPVT_H)) {
    eval 'sub ATT_GRAPHPVT_H () {1;}' unless defined(&ATT_GRAPHPVT_H);
    unless(defined(&EXTERN)) {
	eval 'sub EXTERN () { &extern;}' unless defined(&EXTERN);
    }
    if(defined(&HAVE_CONFIG_H)) {
	require 'config.ph';
    }
    require 'agraph.ph';
    if(defined(&HAVE_AST)) {
	require 'ast.ph';
	require 'vmalloc.ph';
    } else {
	if(defined(&HAVE_VMALLOC)) {
	    require 'vmalloc.ph';
	}
	require 'sys/types.ph';
	require 'stdlib.ph';
	if(defined(&HAVE_STRINGS_H)) {
	    require 'strings.ph';
	}
	if(defined(&HAVE_STRING_H)) {
	    require 'string.ph';
	}
	if(defined(&HAVE_UNISTD_H)) {
	    require 'unistd.ph';
	}
    }
    if(defined(&DEBUG)) {
	require 'assert.ph';
    } else {
	eval 'sub assert {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&assert);
    }
    unless(defined(&streq)) {
	eval 'sub streq {
	    my($s,$t) = @_;
    	    eval q(((*$s == *$t)  && ! &strcmp(($s),($t))));
	}' unless defined(&streq);
    }
    if(defined(&offsetof)) {
	undef(&offsetof) if defined(&offsetof);
    }
    eval 'sub offsetof {
        my($typ,$fld) = @_;
	    eval q(((((($typ*)0)->$fld))));
    }' unless defined(&offsetof);
    eval 'sub NOTUSED {
        my($var) = @_;
	    eval q(( &void) $var);
    }' unless defined(&NOTUSED);
    eval 'sub NILgraph () { &NIL( &Agraph_t*);}' unless defined(&NILgraph);
    eval 'sub NILnode () { &NIL( &Agnode_t*);}' unless defined(&NILnode);
    eval 'sub NILedge () { &NIL( &Agedge_t*);}' unless defined(&NILedge);
    eval 'sub NILsym () { &NIL( &Agsym_t*);}' unless defined(&NILsym);
    eval 'sub NILstr () { &NIL;}' unless defined(&NILstr);
    eval 'sub MAX_OUTPUTLINE () {80;}' unless defined(&MAX_OUTPUTLINE);
    eval 'sub SUCCESS () {0;}' unless defined(&SUCCESS);
    eval 'sub FAILURE () {-1;}' unless defined(&FAILURE);
    eval 'sub LOCALNAMEPREFIX () {ord(\'%\');}' unless defined(&LOCALNAMEPREFIX);
    eval 'sub AGDISC {
        my($g,$d) = @_;
	    eval q((($g)-> ($clos->{disc}->{d})));
    }' unless defined(&AGDISC);
    eval 'sub AGCLOS {
        my($g,$d) = @_;
	    eval q((($g)-> ($clos->{state}->{d})));
    }' unless defined(&AGCLOS);
    eval 'sub AGNEW {
        my($g,$t) = @_;
	    eval q((($t*)( &agalloc($g,$sizeof{$t}))));
    }' unless defined(&AGNEW);
    eval 'sub TAIL_ID () {"tailport";}' unless defined(&TAIL_ID);
    eval 'sub HEAD_ID () {"headport";}' unless defined(&HEAD_ID);
    eval 'sub ISALNUM {
        my($c) = @_;
	    eval q((( &isalnum($c)) || (($c) == ord(\'_\')) || (! &isascii($c))));
    }' unless defined(&ISALNUM);
    eval 'sub CB_INITIALIZE () {100;}' unless defined(&CB_INITIALIZE);
    eval 'sub CB_UPDATE () {101;}' unless defined(&CB_UPDATE);
    eval 'sub CB_DELETION () {102;}' unless defined(&CB_DELETION);
}
if(defined(&__cplusplus)) {
}
1;
