require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_CDT_H)) {
    eval 'sub _CDT_H () {1;}' unless defined(&_CDT_H);
    eval 'sub CDT_VERSION () {19991101;}' unless defined(&CDT_VERSION);
    if((defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
	require 'ast_std.ph';
    } else {
	require 'ast_common.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub DT_SET () {0000001;}' unless defined(&DT_SET);
    eval 'sub DT_BAG () {0000002;}' unless defined(&DT_BAG);
    eval 'sub DT_OSET () {0000004;}' unless defined(&DT_OSET);
    eval 'sub DT_OBAG () {0000010;}' unless defined(&DT_OBAG);
    eval 'sub DT_LIST () {0000020;}' unless defined(&DT_LIST);
    eval 'sub DT_STACK () {0000040;}' unless defined(&DT_STACK);
    eval 'sub DT_QUEUE () {0000100;}' unless defined(&DT_QUEUE);
    eval 'sub DT_METHODS () {0000177;}' unless defined(&DT_METHODS);
    eval 'sub DT_SAMECMP () {0000001;}' unless defined(&DT_SAMECMP);
    eval 'sub DT_SAMEHASH () {0000002;}' unless defined(&DT_SAMEHASH);
    eval 'sub DT_INSERT () {0000001;}' unless defined(&DT_INSERT);
    eval 'sub DT_DELETE () {0000002;}' unless defined(&DT_DELETE);
    eval 'sub DT_SEARCH () {0000004;}' unless defined(&DT_SEARCH);
    eval 'sub DT_NEXT () {0000010;}' unless defined(&DT_NEXT);
    eval 'sub DT_PREV () {0000020;}' unless defined(&DT_PREV);
    eval 'sub DT_RENEW () {0000040;}' unless defined(&DT_RENEW);
    eval 'sub DT_CLEAR () {0000100;}' unless defined(&DT_CLEAR);
    eval 'sub DT_FIRST () {0000200;}' unless defined(&DT_FIRST);
    eval 'sub DT_LAST () {0000400;}' unless defined(&DT_LAST);
    eval 'sub DT_MATCH () {0001000;}' unless defined(&DT_MATCH);
    eval 'sub DT_VSEARCH () {0002000;}' unless defined(&DT_VSEARCH);
    eval 'sub DT_ATTACH () {0004000;}' unless defined(&DT_ATTACH);
    eval 'sub DT_DETACH () {0010000;}' unless defined(&DT_DETACH);
    eval 'sub DT_OPEN () {1;}' unless defined(&DT_OPEN);
    eval 'sub DT_CLOSE () {2;}' unless defined(&DT_CLOSE);
    eval 'sub DT_DISC () {3;}' unless defined(&DT_DISC);
    eval 'sub DT_METH () {4;}' unless defined(&DT_METH);
    if((defined(&_BLD_cdt) ? &_BLD_cdt : 0)  && defined( &__EXPORT__)) {
	eval 'sub extern () { &__EXPORT__;}' unless defined(&extern);
    }
    if(!(defined(&_BLD_cdt) ? &_BLD_cdt : 0)  && defined( &__IMPORT__)) {
	eval 'sub extern () { &__IMPORT__;}' unless defined(&extern);
    }
    unless(defined(&KPVDEL)) {
    }
    undef(&extern) if defined(&extern);
    if((defined(&_BLD_cdt) ? &_BLD_cdt : 0)  && defined( &__EXPORT__)) {
	eval 'sub extern () { &__EXPORT__;}' unless defined(&extern);
    }
    if(!(defined(&_BLD_cdt) ? &_BLD_cdt : 0)  && defined( &__IMPORT__)  && defined( &__EXPORT__)) {
	eval 'sub extern () { &__IMPORT__;}' unless defined(&extern);
    }
    undef(&extern) if defined(&extern);
    eval 'sub _DT_ {
        my($d) = @_;
	    eval q((( &Dt_t*)($d)));
    }' unless defined(&_DT_);
    eval 'sub dtvnext {
        my($d) = @_;
	    eval q(( &_DT_($d)-> &view));
    }' unless defined(&dtvnext);
    eval 'sub dtvcount {
        my($d) = @_;
	    eval q(( &_DT_($d)-> &nview));
    }' unless defined(&dtvcount);
    eval 'sub dtvhere {
        my($d) = @_;
	    eval q(( &_DT_($d)-> &walk));
    }' unless defined(&dtvhere);
    eval 'sub dtlink {
        my($d,$e) = @_;
	    eval q(((( &Dtlink_t*)($e))-> &right));
    }' unless defined(&dtlink);
    eval 'sub dtobj {
        my($d,$e) = @_;
	    eval q((( &_DT_($d)-> ($disc->{link}) < 0) ? ((( &Dthold_t*)($e))-> &obj) : ( &Void_t*)(($e) -  &_DT_($d)-> ($disc->{link})) ));
    }' unless defined(&dtobj);
    eval 'sub dtfinger {
        my($d) = @_;
	    eval q(( &_DT_($d)-> ($data->{here}) ?  &dtobj(($d), &_DT_($d)-> ($data->{here})) : ( &Void_t*)(0) ));
    }' unless defined(&dtfinger);
    eval 'sub dtfirst {
        my($d) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)(0), &DT_FIRST));
    }' unless defined(&dtfirst);
    eval 'sub dtnext {
        my($d,$o) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)($o), &DT_NEXT));
    }' unless defined(&dtnext);
    eval 'sub dtlast {
        my($d) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)(0), &DT_LAST));
    }' unless defined(&dtlast);
    eval 'sub dtprev {
        my($d,$o) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)($o), &DT_PREV));
    }' unless defined(&dtprev);
    eval 'sub dtsearch {
        my($d,$o) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)($o), &DT_SEARCH));
    }' unless defined(&dtsearch);
    eval 'sub dtmatch {
        my($d,$o) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)($o), &DT_MATCH));
    }' unless defined(&dtmatch);
    eval 'sub dtinsert {
        my($d,$o) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)($o), &DT_INSERT));
    }' unless defined(&dtinsert);
    eval 'sub dtdelete {
        my($d,$o) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)($o), &DT_DELETE));
    }' unless defined(&dtdelete);
    eval 'sub dtattach {
        my($d,$o) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)($o), &DT_ATTACH));
    }' unless defined(&dtattach);
    eval 'sub dtdetach {
        my($d,$o) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)($o), &DT_DETACH));
    }' unless defined(&dtdetach);
    eval 'sub dtclear {
        my($d) = @_;
	    eval q((*( &_DT_($d)-> &searchf))(($d),( &Void_t*)(0), &DT_CLEAR));
    }' unless defined(&dtclear);
    eval 'sub dtcharhash {
        my($h,$c) = @_;
	    eval q(((()<<4) + () + (($c)) + 97531));
    }' unless defined(&dtcharhash);
    if(defined(&__cplusplus)) {
    }
}
1;
