require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__cplusplus)) {
}
unless(defined(&_EXPR_H)) {
    eval 'sub _EXPR_H () {1;}' unless defined(&_EXPR_H);
    require 'ast.ph';
    undef(&RS) if defined(&RS);
    unless(defined(&__CYGWIN__)) {
	if((defined(&_BLD_expr) ? &_BLD_expr : 0)  && defined( &__EXPORT__)) {
	    eval 'sub extern () { &__EXPORT__;}' unless defined(&extern);
	}
	if(!(defined(&_BLD_expr) ? &_BLD_expr : 0)  && defined( &__IMPORT__)) {
	    eval 'sub extern () { &extern  &__IMPORT__;}' unless defined(&extern);
	}
    }
    require 'exparse.ph';
    undef(&extern) if defined(&extern);
    require 'cdt.ph';
    require 'vmalloc.ph';
    eval 'sub EX_VERSION () {20000101;}' unless defined(&EX_VERSION);
    eval 'sub EX_CHARSTRING () {(1<<0);}' unless defined(&EX_CHARSTRING);
    eval 'sub EX_CONSTANT () {(1<<1);}' unless defined(&EX_CONSTANT);
    eval 'sub EX_FATAL () {(1<<2);}' unless defined(&EX_FATAL);
    eval 'sub EX_INTERACTIVE () {(1<<3);}' unless defined(&EX_INTERACTIVE);
    eval 'sub EX_PURE () {(1<<4);}' unless defined(&EX_PURE);
    eval 'sub EX_QUALIFY () {(1<<5);}' unless defined(&EX_QUALIFY);
    eval 'sub EX_RETAIN () {(1<<6);}' unless defined(&EX_RETAIN);
    eval 'sub EX_SIZED () {(1<<7);}' unless defined(&EX_SIZED);
    eval 'sub EX_STRICT () {(1<<8);}' unless defined(&EX_STRICT);
    eval 'sub EX_UNDECLARED () {(1<<9);}' unless defined(&EX_UNDECLARED);
    eval 'sub EX_ARRAY () {(-3);}' unless defined(&EX_ARRAY);
    eval 'sub EX_CALL () {(-2);}' unless defined(&EX_CALL);
    eval 'sub EX_SCALAR () {(-1);}' unless defined(&EX_SCALAR);
    eval 'sub EX_NAMELEN () {32;}' unless defined(&EX_NAMELEN);
    eval 'sub EX_INTARRAY () {1;}' unless defined(&EX_INTARRAY);
    eval 'sub EX_ID {
        my($n,$l,$i,$t,$f) = @_;
	    eval q({{0},($l),($i),($t),0,($f),0,{0},$n});
    }' unless defined(&EX_ID);
    eval 'sub DELETE () { &BREAK;}' unless defined(&DELETE);
    eval 'sub INTEGRAL {
        my($t) = @_;
	    eval q((($t)>= &INT &&($t)<= &CHAR));
    }' unless defined(&INTEGRAL);
    eval 'sub BUILTIN {
        my($t) = @_;
	    eval q((($t) >  &MINTOKEN));
    }' unless defined(&BUILTIN);
    eval 'sub F () {01;}' unless defined(&F);
    eval 'sub I () {02;}' unless defined(&I);
    eval 'sub S () {03;}' unless defined(&S);
    eval 'sub TBITS () {4;}' unless defined(&TBITS);
    eval 'sub TMASK () {((1<< &TBITS)-1);}' unless defined(&TMASK);
    eval 'sub A {
        my($n,$t) = @_;
	    eval q((($t)<<(($n)* &TBITS)));
    }' unless defined(&A);
    eval 'sub N {
        my($t) = @_;
	    eval q((($t)>>= &TBITS));
    }' unless defined(&N);
    eval 'sub exalloc {
        my($p,$n) = @_;
	    eval q( &exnewof($p,0,\'char\',$n,0));
    }' unless defined(&exalloc);
    eval 'sub exnewof {
        my($p,$o,$t,$n,$x) = @_;
	    eval q( &vmnewof(($p)-> &vm,$o,$t,$n,$x));
    }' unless defined(&exnewof);
    eval 'sub exfree {
        my($p,$x) = @_;
	    eval q( &vmfree(($p)-> &vm,$x));
    }' unless defined(&exfree);
    eval 'sub exstrdup {
        my($p,$s) = @_;
	    eval q( &vmstrdup(($p)-> &vm,$s));
    }' unless defined(&exstrdup);
    if((defined(&LONG_MAX) ? &LONG_MAX : 0) > (defined(&INT_MAX) ? &INT_MAX : 0)) {
    } else {
    }
    if(defined(&_EX_DATA_PRIVATE_)) {
    }
    if(defined(&_EX_NODE_PRIVATE_)) {
    }
    if(defined(&_EX_PROG_PRIVATE_)) {
    }
    if(defined(&_EX_CC_PRIVATE_)) {
    }
    unless(defined(&__CYGWIN__)) {
	if((defined(&_BLD_expr) ? &_BLD_expr : 0)  && defined( &__EXPORT__)) {
	    eval 'sub extern () { &__EXPORT__;}' unless defined(&extern);
	}
    }
    undef(&extern) if defined(&extern);
}
if(defined(&__cplusplus)) {
}
1;
