require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_GRAPH_H)) {
    eval 'sub _GRAPH_H () {1;}' unless defined(&_GRAPH_H);
    if((defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
	require 'ast.ph';
    } else {
	require 'sys/types.ph';
	require 'stdlib.ph';
    }
    require 'stdio.ph';
    require 'cdt.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub TAIL_ID () {"tailport";}' unless defined(&TAIL_ID);
    eval 'sub HEAD_ID () {"headport";}' unless defined(&HEAD_ID);
    eval 'sub AGFLAG_DIRECTED () {(1<<0);}' unless defined(&AGFLAG_DIRECTED);
    eval 'sub AGFLAG_STRICT () {(1<<1);}' unless defined(&AGFLAG_STRICT);
    eval 'sub AGFLAG_METAGRAPH () {(1<<2);}' unless defined(&AGFLAG_METAGRAPH);
    eval 'sub AGRAPH () {0;}' unless defined(&AGRAPH);
    eval 'sub AGRAPHSTRICT () {( &AGRAPH |  &AGFLAG_STRICT);}' unless defined(&AGRAPHSTRICT);
    eval 'sub AGDIGRAPH () { &AGFLAG_DIRECTED;}' unless defined(&AGDIGRAPH);
    eval 'sub AGDIGRAPHSTRICT () {( &AGDIGRAPH |  &AGFLAG_STRICT);}' unless defined(&AGDIGRAPHSTRICT);
    eval 'sub AGMETAGRAPH () {( &AGFLAG_DIRECTED |  &AGFLAG_STRICT |  &AGFLAG_METAGRAPH);}' unless defined(&AGMETAGRAPH);
    eval 'sub AG_IS_DIRECTED {
        my($g) = @_;
	    eval q((($g)-> &kind &  &AGFLAG_DIRECTED));
    }' unless defined(&AG_IS_DIRECTED);
    eval 'sub AG_IS_STRICT {
        my($g) = @_;
	    eval q((($g)-> &kind &  &AGFLAG_STRICT));
    }' unless defined(&AG_IS_STRICT);
    eval 'sub AG_IS_METAGRAPH {
        my($g) = @_;
	    eval q((($g)-> &kind &  &AGFLAG_METAGRAPH));
    }' unless defined(&AG_IS_METAGRAPH);
    eval 'sub aginit () {
        eval q( &aginitlib($sizeof{ &Agraph_t},$sizeof{ &Agnode_t},$sizeof{ &Agedge_t}));
    }' unless defined(&aginit);
    if((defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
	if((defined(&_BLD_graph) ? &_BLD_graph : 0)  && defined( &__EXPORT__)) {
	    eval 'sub extern () { &__EXPORT__;}' unless defined(&extern);
	}
	if(!(defined(&_BLD_graph) ? &_BLD_graph : 0)  && defined( &__IMPORT__)  && 0) {
	    eval 'sub extern () { &__IMPORT__;}' unless defined(&extern);
	}
    }
    eval("sub AGWARN () { 0; }") unless defined(&AGWARN);
    eval("sub AGERR () { 1; }") unless defined(&AGERR);
    eval("sub AGMAX () { 2; }") unless defined(&AGMAX);
    eval("sub AGPREV () { 3; }") unless defined(&AGPREV);
    eval("sub AGNODE () { 1; }") unless defined(&AGNODE);
    eval("sub AGEDGE () { 2; }") unless defined(&AGEDGE);
    eval("sub AGGRAPH () { 3; }") unless defined(&AGGRAPH);
    eval 'sub agobjkind {
        my($p) = @_;
	    eval q((( &agobjkind_t)((( &Agraph_t*)($p))-> &tag)));
    }' unless defined(&agobjkind);
    eval 'sub agmetanode {
        my($g) = @_;
	    eval q((($g)-> &meta_node));
    }' unless defined(&agmetanode);
    undef(&extern) if defined(&extern);
    if((defined(&_PACKAGE_ast) ? &_PACKAGE_ast : 0)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
