require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GDK_I18N_H__)) {
    eval 'sub __GDK_I18N_H__ () {1;}' unless defined(&__GDK_I18N_H__);
    require 'glib.ph';
    require 'stdlib.ph';
    if(!defined( &G_HAVE_BROKEN_WCTYPE)  && (defined( &G_HAVE_WCTYPE_H) || defined( &G_HAVE_WCHAR_H))  && !defined( &X_LOCALE)) {
	if(defined(&G_HAVE_WCTYPE_H)) {
	    require 'wctype.ph';
	} else {
	    if(defined(&G_HAVE_WCHAR_H)) {
		require 'wchar.ph';
	    }
	}
	eval 'sub gdk_iswalnum {
	    my($c) = @_;
    	    eval q( &iswalnum($c));
	}' unless defined(&gdk_iswalnum);
	eval 'sub gdk_iswspace {
	    my($c) = @_;
    	    eval q( &iswspace($c));
	}' unless defined(&gdk_iswspace);
    } else {
	require 'ctype.ph';
	eval 'sub gdk_iswalnum {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) <= 0xff  &&  &isalnum($c)));
	}' unless defined(&gdk_iswalnum);
	eval 'sub gdk_iswspace {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) <= 0xff  &&  &isspace($c)));
	}' unless defined(&gdk_iswspace);
    }
    if(!defined( &G_HAVE_BROKEN_WCTYPE)  && (defined( &G_HAVE_WCTYPE_H) || defined( &G_HAVE_WCHAR_H))  && !defined( &X_LOCALE)) {
	eval 'sub gdk_iswalpha {
	    my($c) = @_;
    	    eval q( &iswalpha($c));
	}' unless defined(&gdk_iswalpha);
	eval 'sub gdk_iswcntrl {
	    my($c) = @_;
    	    eval q( &iswcntrl($c));
	}' unless defined(&gdk_iswcntrl);
	eval 'sub gdk_iswdigit {
	    my($c) = @_;
    	    eval q( &iswdigit($c));
	}' unless defined(&gdk_iswdigit);
	eval 'sub gdk_iswlower {
	    my($c) = @_;
    	    eval q( &iswlower($c));
	}' unless defined(&gdk_iswlower);
	eval 'sub gdk_iswgraph {
	    my($c) = @_;
    	    eval q( &iswgraph($c));
	}' unless defined(&gdk_iswgraph);
	eval 'sub gdk_iswprint {
	    my($c) = @_;
    	    eval q( &iswprint($c));
	}' unless defined(&gdk_iswprint);
	eval 'sub gdk_iswpunct {
	    my($c) = @_;
    	    eval q( &iswpunct($c));
	}' unless defined(&gdk_iswpunct);
	eval 'sub gdk_iswupper {
	    my($c) = @_;
    	    eval q( &iswupper($c));
	}' unless defined(&gdk_iswupper);
	eval 'sub gdk_iswxdigit {
	    my($c) = @_;
    	    eval q( &iswxdigit($c));
	}' unless defined(&gdk_iswxdigit);
    } else {
	eval 'sub gdk_iswalpha {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) <= 0xff  &&  &isalpha($c)));
	}' unless defined(&gdk_iswalpha);
	eval 'sub gdk_iswcntrl {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) <= 0xff  &&  &iscntrl($c)));
	}' unless defined(&gdk_iswcntrl);
	eval 'sub gdk_iswdigit {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) <= 0xff  &&  &isdigit($c)));
	}' unless defined(&gdk_iswdigit);
	eval 'sub gdk_iswlower {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) <= 0xff  &&  &islower($c)));
	}' unless defined(&gdk_iswlower);
	eval 'sub gdk_iswgraph {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) > 0xff ||  &isgraph($c)));
	}' unless defined(&gdk_iswgraph);
	eval 'sub gdk_iswprint {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) > 0xff ||  &isprint($c)));
	}' unless defined(&gdk_iswprint);
	eval 'sub gdk_iswpunct {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) <= 0xff  &&  &ispunct($c)));
	}' unless defined(&gdk_iswpunct);
	eval 'sub gdk_iswupper {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) <= 0xff  &&  &isupper($c)));
	}' unless defined(&gdk_iswupper);
	eval 'sub gdk_iswxdigit {
	    my($c) = @_;
    	    eval q((( &wchar_t)($c) <= 0xff  &&  &isxdigit($c)));
	}' unless defined(&gdk_iswxdigit);
    }
}
1;
