require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&GDK_VoidSymbol)) {
    sub GDK_VoidSymbol () {	0xffffff;}
}
unless(defined(&GDK_BackSpace)) {
    sub GDK_BackSpace () {	0xff08;}
}
unless(defined(&GDK_Tab)) {
    sub GDK_Tab () {	0xff09;}
}
unless(defined(&GDK_Linefeed)) {
    sub GDK_Linefeed () {	0xff0a;}
}
unless(defined(&GDK_Clear)) {
    sub GDK_Clear () {	0xff0b;}
}
unless(defined(&GDK_Return)) {
    sub GDK_Return () {	0xff0d;}
}
unless(defined(&GDK_Pause)) {
    sub GDK_Pause () {	0xff13;}
}
unless(defined(&GDK_Scroll_Lock)) {
    sub GDK_Scroll_Lock () {	0xff14;}
}
unless(defined(&GDK_Sys_Req)) {
    sub GDK_Sys_Req () {	0xff15;}
}
unless(defined(&GDK_Escape)) {
    sub GDK_Escape () {	0xff1b;}
}
unless(defined(&GDK_Delete)) {
    sub GDK_Delete () {	0xffff;}
}
unless(defined(&GDK_Multi_key)) {
    sub GDK_Multi_key () {	0xff20;}
}
unless(defined(&GDK_SingleCandidate)) {
    sub GDK_SingleCandidate () {	0xff3c;}
}
unless(defined(&GDK_MultipleCandidate)) {
    sub GDK_MultipleCandidate () {	0xff3d;}
}
unless(defined(&GDK_PreviousCandidate)) {
    sub GDK_PreviousCandidate () {	0xff3e;}
}
unless(defined(&GDK_Kanji)) {
    sub GDK_Kanji () {	0xff21;}
}
unless(defined(&GDK_Muhenkan)) {
    sub GDK_Muhenkan () {	0xff22;}
}
unless(defined(&GDK_Henkan_Mode)) {
    sub GDK_Henkan_Mode () {	0xff23;}
}
unless(defined(&GDK_Henkan)) {
    sub GDK_Henkan () {	0xff23;}
}
unless(defined(&GDK_Romaji)) {
    sub GDK_Romaji () {	0xff24;}
}
unless(defined(&GDK_Hiragana)) {
    sub GDK_Hiragana () {	0xff25;}
}
unless(defined(&GDK_Katakana)) {
    sub GDK_Katakana () {	0xff26;}
}
unless(defined(&GDK_Hiragana_Katakana)) {
    sub GDK_Hiragana_Katakana () {	0xff27;}
}
unless(defined(&GDK_Zenkaku)) {
    sub GDK_Zenkaku () {	0xff28;}
}
unless(defined(&GDK_Hankaku)) {
    sub GDK_Hankaku () {	0xff29;}
}
unless(defined(&GDK_Zenkaku_Hankaku)) {
    sub GDK_Zenkaku_Hankaku () {	0xff2a;}
}
unless(defined(&GDK_Touroku)) {
    sub GDK_Touroku () {	0xff2b;}
}
unless(defined(&GDK_Massyo)) {
    sub GDK_Massyo () {	0xff2c;}
}
unless(defined(&GDK_Kana_Lock)) {
    sub GDK_Kana_Lock () {	0xff2d;}
}
unless(defined(&GDK_Kana_Shift)) {
    sub GDK_Kana_Shift () {	0xff2e;}
}
unless(defined(&GDK_Eisu_Shift)) {
    sub GDK_Eisu_Shift () {	0xff2f;}
}
unless(defined(&GDK_Eisu_toggle)) {
    sub GDK_Eisu_toggle () {	0xff30;}
}
unless(defined(&GDK_Zen_Koho)) {
    sub GDK_Zen_Koho () {	0xff3d;}
}
unless(defined(&GDK_Mae_Koho)) {
    sub GDK_Mae_Koho () {	0xff3e;}
}
unless(defined(&GDK_Home)) {
    sub GDK_Home () {	0xff50;}
}
unless(defined(&GDK_Left)) {
    sub GDK_Left () {	0xff51;}
}
unless(defined(&GDK_Up)) {
    sub GDK_Up () {	0xff52;}
}
unless(defined(&GDK_Right)) {
    sub GDK_Right () {	0xff53;}
}
unless(defined(&GDK_Down)) {
    sub GDK_Down () {	0xff54;}
}
unless(defined(&GDK_Prior)) {
    sub GDK_Prior () {	0xff55;}
}
unless(defined(&GDK_Page_Up)) {
    sub GDK_Page_Up () {	0xff55;}
}
unless(defined(&GDK_Next)) {
    sub GDK_Next () {	0xff56;}
}
unless(defined(&GDK_Page_Down)) {
    sub GDK_Page_Down () {	0xff56;}
}
unless(defined(&GDK_End)) {
    sub GDK_End () {	0xff57;}
}
unless(defined(&GDK_Begin)) {
    sub GDK_Begin () {	0xff58;}
}
unless(defined(&GDK_Select)) {
    sub GDK_Select () {	0xff60;}
}
unless(defined(&GDK_Print)) {
    sub GDK_Print () {	0xff61;}
}
unless(defined(&GDK_Execute)) {
    sub GDK_Execute () {	0xff62;}
}
unless(defined(&GDK_Insert)) {
    sub GDK_Insert () {	0xff63;}
}
unless(defined(&GDK_Undo)) {
    sub GDK_Undo () {	0xff65;}
}
unless(defined(&GDK_Redo)) {
    sub GDK_Redo () {	0xff66;}
}
unless(defined(&GDK_Menu)) {
    sub GDK_Menu () {	0xff67;}
}
unless(defined(&GDK_Find)) {
    sub GDK_Find () {	0xff68;}
}
unless(defined(&GDK_Cancel)) {
    sub GDK_Cancel () {	0xff69;}
}
unless(defined(&GDK_Help)) {
    sub GDK_Help () {	0xff6a;}
}
unless(defined(&GDK_Break)) {
    sub GDK_Break () {	0xff6b;}
}
unless(defined(&GDK_Mode_switch)) {
    sub GDK_Mode_switch () {	0xff7e;}
}
unless(defined(&GDK_script_switch)) {
    sub GDK_script_switch () {	0xff7e;}
}
unless(defined(&GDK_Num_Lock)) {
    sub GDK_Num_Lock () {	0xff7f;}
}
unless(defined(&GDK_KP_Space)) {
    sub GDK_KP_Space () {	0xff80;}
}
unless(defined(&GDK_KP_Tab)) {
    sub GDK_KP_Tab () {	0xff89;}
}
unless(defined(&GDK_KP_Enter)) {
    sub GDK_KP_Enter () {	0xff8d;}
}
unless(defined(&GDK_KP_F1)) {
    sub GDK_KP_F1 () {	0xff91;}
}
unless(defined(&GDK_KP_F2)) {
    sub GDK_KP_F2 () {	0xff92;}
}
unless(defined(&GDK_KP_F3)) {
    sub GDK_KP_F3 () {	0xff93;}
}
unless(defined(&GDK_KP_F4)) {
    sub GDK_KP_F4 () {	0xff94;}
}
unless(defined(&GDK_KP_Home)) {
    sub GDK_KP_Home () {	0xff95;}
}
unless(defined(&GDK_KP_Left)) {
    sub GDK_KP_Left () {	0xff96;}
}
unless(defined(&GDK_KP_Up)) {
    sub GDK_KP_Up () {	0xff97;}
}
unless(defined(&GDK_KP_Right)) {
    sub GDK_KP_Right () {	0xff98;}
}
unless(defined(&GDK_KP_Down)) {
    sub GDK_KP_Down () {	0xff99;}
}
unless(defined(&GDK_KP_Prior)) {
    sub GDK_KP_Prior () {	0xff9a;}
}
unless(defined(&GDK_KP_Page_Up)) {
    sub GDK_KP_Page_Up () {	0xff9a;}
}
unless(defined(&GDK_KP_Next)) {
    sub GDK_KP_Next () {	0xff9b;}
}
unless(defined(&GDK_KP_Page_Down)) {
    sub GDK_KP_Page_Down () {	0xff9b;}
}
unless(defined(&GDK_KP_End)) {
    sub GDK_KP_End () {	0xff9c;}
}
unless(defined(&GDK_KP_Begin)) {
    sub GDK_KP_Begin () {	0xff9d;}
}
unless(defined(&GDK_KP_Insert)) {
    sub GDK_KP_Insert () {	0xff9e;}
}
unless(defined(&GDK_KP_Delete)) {
    sub GDK_KP_Delete () {	0xff9f;}
}
unless(defined(&GDK_KP_Equal)) {
    sub GDK_KP_Equal () {	0xffbd;}
}
unless(defined(&GDK_KP_Multiply)) {
    sub GDK_KP_Multiply () {	0xffaa;}
}
unless(defined(&GDK_KP_Add)) {
    sub GDK_KP_Add () {	0xffab;}
}
unless(defined(&GDK_KP_Separator)) {
    sub GDK_KP_Separator () {	0xffac;}
}
unless(defined(&GDK_KP_Subtract)) {
    sub GDK_KP_Subtract () {	0xffad;}
}
unless(defined(&GDK_KP_Decimal)) {
    sub GDK_KP_Decimal () {	0xffae;}
}
unless(defined(&GDK_KP_Divide)) {
    sub GDK_KP_Divide () {	0xffaf;}
}
unless(defined(&GDK_KP_0)) {
    sub GDK_KP_0 () {	0xffb0;}
}
unless(defined(&GDK_KP_1)) {
    sub GDK_KP_1 () {	0xffb1;}
}
unless(defined(&GDK_KP_2)) {
    sub GDK_KP_2 () {	0xffb2;}
}
unless(defined(&GDK_KP_3)) {
    sub GDK_KP_3 () {	0xffb3;}
}
unless(defined(&GDK_KP_4)) {
    sub GDK_KP_4 () {	0xffb4;}
}
unless(defined(&GDK_KP_5)) {
    sub GDK_KP_5 () {	0xffb5;}
}
unless(defined(&GDK_KP_6)) {
    sub GDK_KP_6 () {	0xffb6;}
}
unless(defined(&GDK_KP_7)) {
    sub GDK_KP_7 () {	0xffb7;}
}
unless(defined(&GDK_KP_8)) {
    sub GDK_KP_8 () {	0xffb8;}
}
unless(defined(&GDK_KP_9)) {
    sub GDK_KP_9 () {	0xffb9;}
}
unless(defined(&GDK_F1)) {
    sub GDK_F1 () {	0xffbe;}
}
unless(defined(&GDK_F2)) {
    sub GDK_F2 () {	0xffbf;}
}
unless(defined(&GDK_F3)) {
    sub GDK_F3 () {	0xffc0;}
}
unless(defined(&GDK_F4)) {
    sub GDK_F4 () {	0xffc1;}
}
unless(defined(&GDK_F5)) {
    sub GDK_F5 () {	0xffc2;}
}
unless(defined(&GDK_F6)) {
    sub GDK_F6 () {	0xffc3;}
}
unless(defined(&GDK_F7)) {
    sub GDK_F7 () {	0xffc4;}
}
unless(defined(&GDK_F8)) {
    sub GDK_F8 () {	0xffc5;}
}
unless(defined(&GDK_F9)) {
    sub GDK_F9 () {	0xffc6;}
}
unless(defined(&GDK_F10)) {
    sub GDK_F10 () {	0xffc7;}
}
unless(defined(&GDK_F11)) {
    sub GDK_F11 () {	0xffc8;}
}
unless(defined(&GDK_L1)) {
    sub GDK_L1 () {	0xffc8;}
}
unless(defined(&GDK_F12)) {
    sub GDK_F12 () {	0xffc9;}
}
unless(defined(&GDK_L2)) {
    sub GDK_L2 () {	0xffc9;}
}
unless(defined(&GDK_F13)) {
    sub GDK_F13 () {	0xffca;}
}
unless(defined(&GDK_L3)) {
    sub GDK_L3 () {	0xffca;}
}
unless(defined(&GDK_F14)) {
    sub GDK_F14 () {	0xffcb;}
}
unless(defined(&GDK_L4)) {
    sub GDK_L4 () {	0xffcb;}
}
unless(defined(&GDK_F15)) {
    sub GDK_F15 () {	0xffcc;}
}
unless(defined(&GDK_L5)) {
    sub GDK_L5 () {	0xffcc;}
}
unless(defined(&GDK_F16)) {
    sub GDK_F16 () {	0xffcd;}
}
unless(defined(&GDK_L6)) {
    sub GDK_L6 () {	0xffcd;}
}
unless(defined(&GDK_F17)) {
    sub GDK_F17 () {	0xffce;}
}
unless(defined(&GDK_L7)) {
    sub GDK_L7 () {	0xffce;}
}
unless(defined(&GDK_F18)) {
    sub GDK_F18 () {	0xffcf;}
}
unless(defined(&GDK_L8)) {
    sub GDK_L8 () {	0xffcf;}
}
unless(defined(&GDK_F19)) {
    sub GDK_F19 () {	0xffd0;}
}
unless(defined(&GDK_L9)) {
    sub GDK_L9 () {	0xffd0;}
}
unless(defined(&GDK_F20)) {
    sub GDK_F20 () {	0xffd1;}
}
unless(defined(&GDK_L10)) {
    sub GDK_L10 () {	0xffd1;}
}
unless(defined(&GDK_F21)) {
    sub GDK_F21 () {	0xffd2;}
}
unless(defined(&GDK_R1)) {
    sub GDK_R1 () {	0xffd2;}
}
unless(defined(&GDK_F22)) {
    sub GDK_F22 () {	0xffd3;}
}
unless(defined(&GDK_R2)) {
    sub GDK_R2 () {	0xffd3;}
}
unless(defined(&GDK_F23)) {
    sub GDK_F23 () {	0xffd4;}
}
unless(defined(&GDK_R3)) {
    sub GDK_R3 () {	0xffd4;}
}
unless(defined(&GDK_F24)) {
    sub GDK_F24 () {	0xffd5;}
}
unless(defined(&GDK_R4)) {
    sub GDK_R4 () {	0xffd5;}
}
unless(defined(&GDK_F25)) {
    sub GDK_F25 () {	0xffd6;}
}
unless(defined(&GDK_R5)) {
    sub GDK_R5 () {	0xffd6;}
}
unless(defined(&GDK_F26)) {
    sub GDK_F26 () {	0xffd7;}
}
unless(defined(&GDK_R6)) {
    sub GDK_R6 () {	0xffd7;}
}
unless(defined(&GDK_F27)) {
    sub GDK_F27 () {	0xffd8;}
}
unless(defined(&GDK_R7)) {
    sub GDK_R7 () {	0xffd8;}
}
unless(defined(&GDK_F28)) {
    sub GDK_F28 () {	0xffd9;}
}
unless(defined(&GDK_R8)) {
    sub GDK_R8 () {	0xffd9;}
}
unless(defined(&GDK_F29)) {
    sub GDK_F29 () {	0xffda;}
}
unless(defined(&GDK_R9)) {
    sub GDK_R9 () {	0xffda;}
}
unless(defined(&GDK_F30)) {
    sub GDK_F30 () {	0xffdb;}
}
unless(defined(&GDK_R10)) {
    sub GDK_R10 () {	0xffdb;}
}
unless(defined(&GDK_F31)) {
    sub GDK_F31 () {	0xffdc;}
}
unless(defined(&GDK_R11)) {
    sub GDK_R11 () {	0xffdc;}
}
unless(defined(&GDK_F32)) {
    sub GDK_F32 () {	0xffdd;}
}
unless(defined(&GDK_R12)) {
    sub GDK_R12 () {	0xffdd;}
}
unless(defined(&GDK_F33)) {
    sub GDK_F33 () {	0xffde;}
}
unless(defined(&GDK_R13)) {
    sub GDK_R13 () {	0xffde;}
}
unless(defined(&GDK_F34)) {
    sub GDK_F34 () {	0xffdf;}
}
unless(defined(&GDK_R14)) {
    sub GDK_R14 () {	0xffdf;}
}
unless(defined(&GDK_F35)) {
    sub GDK_F35 () {	0xffe0;}
}
unless(defined(&GDK_R15)) {
    sub GDK_R15 () {	0xffe0;}
}
unless(defined(&GDK_Shift_L)) {
    sub GDK_Shift_L () {	0xffe1;}
}
unless(defined(&GDK_Shift_R)) {
    sub GDK_Shift_R () {	0xffe2;}
}
unless(defined(&GDK_Control_L)) {
    sub GDK_Control_L () {	0xffe3;}
}
unless(defined(&GDK_Control_R)) {
    sub GDK_Control_R () {	0xffe4;}
}
unless(defined(&GDK_Caps_Lock)) {
    sub GDK_Caps_Lock () {	0xffe5;}
}
unless(defined(&GDK_Shift_Lock)) {
    sub GDK_Shift_Lock () {	0xffe6;}
}
unless(defined(&GDK_Meta_L)) {
    sub GDK_Meta_L () {	0xffe7;}
}
unless(defined(&GDK_Meta_R)) {
    sub GDK_Meta_R () {	0xffe8;}
}
unless(defined(&GDK_Alt_L)) {
    sub GDK_Alt_L () {	0xffe9;}
}
unless(defined(&GDK_Alt_R)) {
    sub GDK_Alt_R () {	0xffea;}
}
unless(defined(&GDK_Super_L)) {
    sub GDK_Super_L () {	0xffeb;}
}
unless(defined(&GDK_Super_R)) {
    sub GDK_Super_R () {	0xffec;}
}
unless(defined(&GDK_Hyper_L)) {
    sub GDK_Hyper_L () {	0xffed;}
}
unless(defined(&GDK_Hyper_R)) {
    sub GDK_Hyper_R () {	0xffee;}
}
unless(defined(&GDK_ISO_Lock)) {
    sub GDK_ISO_Lock () {	0xfe01;}
}
unless(defined(&GDK_ISO_Level2_Latch)) {
    sub GDK_ISO_Level2_Latch () {	0xfe02;}
}
unless(defined(&GDK_ISO_Level3_Shift)) {
    sub GDK_ISO_Level3_Shift () {	0xfe03;}
}
unless(defined(&GDK_ISO_Level3_Latch)) {
    sub GDK_ISO_Level3_Latch () {	0xfe04;}
}
unless(defined(&GDK_ISO_Level3_Lock)) {
    sub GDK_ISO_Level3_Lock () {	0xfe05;}
}
unless(defined(&GDK_ISO_Group_Shift)) {
    sub GDK_ISO_Group_Shift () {	0xff7e;}
}
unless(defined(&GDK_ISO_Group_Latch)) {
    sub GDK_ISO_Group_Latch () {	0xfe06;}
}
unless(defined(&GDK_ISO_Group_Lock)) {
    sub GDK_ISO_Group_Lock () {	0xfe07;}
}
unless(defined(&GDK_ISO_Next_Group)) {
    sub GDK_ISO_Next_Group () {	0xfe08;}
}
unless(defined(&GDK_ISO_Next_Group_Lock)) {
    sub GDK_ISO_Next_Group_Lock () {	0xfe09;}
}
unless(defined(&GDK_ISO_Prev_Group)) {
    sub GDK_ISO_Prev_Group () {	0xfe0a;}
}
unless(defined(&GDK_ISO_Prev_Group_Lock)) {
    sub GDK_ISO_Prev_Group_Lock () {	0xfe0b;}
}
unless(defined(&GDK_ISO_First_Group)) {
    sub GDK_ISO_First_Group () {	0xfe0c;}
}
unless(defined(&GDK_ISO_First_Group_Lock)) {
    sub GDK_ISO_First_Group_Lock () {	0xfe0d;}
}
unless(defined(&GDK_ISO_Last_Group)) {
    sub GDK_ISO_Last_Group () {	0xfe0e;}
}
unless(defined(&GDK_ISO_Last_Group_Lock)) {
    sub GDK_ISO_Last_Group_Lock () {	0xfe0f;}
}
unless(defined(&GDK_ISO_Left_Tab)) {
    sub GDK_ISO_Left_Tab () {	0xfe20;}
}
unless(defined(&GDK_ISO_Move_Line_Up)) {
    sub GDK_ISO_Move_Line_Up () {	0xfe21;}
}
unless(defined(&GDK_ISO_Move_Line_Down)) {
    sub GDK_ISO_Move_Line_Down () {	0xfe22;}
}
unless(defined(&GDK_ISO_Partial_Line_Up)) {
    sub GDK_ISO_Partial_Line_Up () {	0xfe23;}
}
unless(defined(&GDK_ISO_Partial_Line_Down)) {
    sub GDK_ISO_Partial_Line_Down () {	0xfe24;}
}
unless(defined(&GDK_ISO_Partial_Space_Left)) {
    sub GDK_ISO_Partial_Space_Left () {	0xfe25;}
}
unless(defined(&GDK_ISO_Partial_Space_Right)) {
    sub GDK_ISO_Partial_Space_Right () {	0xfe26;}
}
unless(defined(&GDK_ISO_Set_Margin_Left)) {
    sub GDK_ISO_Set_Margin_Left () {	0xfe27;}
}
unless(defined(&GDK_ISO_Set_Margin_Right)) {
    sub GDK_ISO_Set_Margin_Right () {	0xfe28;}
}
unless(defined(&GDK_ISO_Release_Margin_Left)) {
    sub GDK_ISO_Release_Margin_Left () {	0xfe29;}
}
unless(defined(&GDK_ISO_Release_Margin_Right)) {
    sub GDK_ISO_Release_Margin_Right () {	0xfe2a;}
}
unless(defined(&GDK_ISO_Release_Both_Margins)) {
    sub GDK_ISO_Release_Both_Margins () {	0xfe2b;}
}
unless(defined(&GDK_ISO_Fast_Cursor_Left)) {
    sub GDK_ISO_Fast_Cursor_Left () {	0xfe2c;}
}
unless(defined(&GDK_ISO_Fast_Cursor_Right)) {
    sub GDK_ISO_Fast_Cursor_Right () {	0xfe2d;}
}
unless(defined(&GDK_ISO_Fast_Cursor_Up)) {
    sub GDK_ISO_Fast_Cursor_Up () {	0xfe2e;}
}
unless(defined(&GDK_ISO_Fast_Cursor_Down)) {
    sub GDK_ISO_Fast_Cursor_Down () {	0xfe2f;}
}
unless(defined(&GDK_ISO_Continuous_Underline)) {
    sub GDK_ISO_Continuous_Underline () {	0xfe30;}
}
unless(defined(&GDK_ISO_Discontinuous_Underline)) {
    sub GDK_ISO_Discontinuous_Underline () {	0xfe31;}
}
unless(defined(&GDK_ISO_Emphasize)) {
    sub GDK_ISO_Emphasize () {	0xfe32;}
}
unless(defined(&GDK_ISO_Center_Object)) {
    sub GDK_ISO_Center_Object () {	0xfe33;}
}
unless(defined(&GDK_ISO_Enter)) {
    sub GDK_ISO_Enter () {	0xfe34;}
}
unless(defined(&GDK_dead_grave)) {
    sub GDK_dead_grave () {	0xfe50;}
}
unless(defined(&GDK_dead_acute)) {
    sub GDK_dead_acute () {	0xfe51;}
}
unless(defined(&GDK_dead_circumflex)) {
    sub GDK_dead_circumflex () {	0xfe52;}
}
unless(defined(&GDK_dead_tilde)) {
    sub GDK_dead_tilde () {	0xfe53;}
}
unless(defined(&GDK_dead_macron)) {
    sub GDK_dead_macron () {	0xfe54;}
}
unless(defined(&GDK_dead_breve)) {
    sub GDK_dead_breve () {	0xfe55;}
}
unless(defined(&GDK_dead_abovedot)) {
    sub GDK_dead_abovedot () {	0xfe56;}
}
unless(defined(&GDK_dead_diaeresis)) {
    sub GDK_dead_diaeresis () {	0xfe57;}
}
unless(defined(&GDK_dead_abovering)) {
    sub GDK_dead_abovering () {	0xfe58;}
}
unless(defined(&GDK_dead_doubleacute)) {
    sub GDK_dead_doubleacute () {	0xfe59;}
}
unless(defined(&GDK_dead_caron)) {
    sub GDK_dead_caron () {	0xfe5a;}
}
unless(defined(&GDK_dead_cedilla)) {
    sub GDK_dead_cedilla () {	0xfe5b;}
}
unless(defined(&GDK_dead_ogonek)) {
    sub GDK_dead_ogonek () {	0xfe5c;}
}
unless(defined(&GDK_dead_iota)) {
    sub GDK_dead_iota () {	0xfe5d;}
}
unless(defined(&GDK_dead_voiced_sound)) {
    sub GDK_dead_voiced_sound () {	0xfe5e;}
}
unless(defined(&GDK_dead_semivoiced_sound)) {
    sub GDK_dead_semivoiced_sound () {	0xfe5f;}
}
unless(defined(&GDK_dead_belowdot)) {
    sub GDK_dead_belowdot () {	0xfe60;}
}
unless(defined(&GDK_First_Virtual_Screen)) {
    sub GDK_First_Virtual_Screen () {	0xfed0;}
}
unless(defined(&GDK_Prev_Virtual_Screen)) {
    sub GDK_Prev_Virtual_Screen () {	0xfed1;}
}
unless(defined(&GDK_Next_Virtual_Screen)) {
    sub GDK_Next_Virtual_Screen () {	0xfed2;}
}
unless(defined(&GDK_Last_Virtual_Screen)) {
    sub GDK_Last_Virtual_Screen () {	0xfed4;}
}
unless(defined(&GDK_Terminate_Server)) {
    sub GDK_Terminate_Server () {	0xfed5;}
}
unless(defined(&GDK_AccessX_Enable)) {
    sub GDK_AccessX_Enable () {	0xfe70;}
}
unless(defined(&GDK_AccessX_Feedback_Enable)) {
    sub GDK_AccessX_Feedback_Enable () {	0xfe71;}
}
unless(defined(&GDK_RepeatKeys_Enable)) {
    sub GDK_RepeatKeys_Enable () {	0xfe72;}
}
unless(defined(&GDK_SlowKeys_Enable)) {
    sub GDK_SlowKeys_Enable () {	0xfe73;}
}
unless(defined(&GDK_BounceKeys_Enable)) {
    sub GDK_BounceKeys_Enable () {	0xfe74;}
}
unless(defined(&GDK_StickyKeys_Enable)) {
    sub GDK_StickyKeys_Enable () {	0xfe75;}
}
unless(defined(&GDK_MouseKeys_Enable)) {
    sub GDK_MouseKeys_Enable () {	0xfe76;}
}
unless(defined(&GDK_MouseKeys_Accel_Enable)) {
    sub GDK_MouseKeys_Accel_Enable () {	0xfe77;}
}
unless(defined(&GDK_Overlay1_Enable)) {
    sub GDK_Overlay1_Enable () {	0xfe78;}
}
unless(defined(&GDK_Overlay2_Enable)) {
    sub GDK_Overlay2_Enable () {	0xfe79;}
}
unless(defined(&GDK_AudibleBell_Enable)) {
    sub GDK_AudibleBell_Enable () {	0xfe7a;}
}
unless(defined(&GDK_Pointer_Left)) {
    sub GDK_Pointer_Left () {	0xfee0;}
}
unless(defined(&GDK_Pointer_Right)) {
    sub GDK_Pointer_Right () {	0xfee1;}
}
unless(defined(&GDK_Pointer_Up)) {
    sub GDK_Pointer_Up () {	0xfee2;}
}
unless(defined(&GDK_Pointer_Down)) {
    sub GDK_Pointer_Down () {	0xfee3;}
}
unless(defined(&GDK_Pointer_UpLeft)) {
    sub GDK_Pointer_UpLeft () {	0xfee4;}
}
unless(defined(&GDK_Pointer_UpRight)) {
    sub GDK_Pointer_UpRight () {	0xfee5;}
}
unless(defined(&GDK_Pointer_DownLeft)) {
    sub GDK_Pointer_DownLeft () {	0xfee6;}
}
unless(defined(&GDK_Pointer_DownRight)) {
    sub GDK_Pointer_DownRight () {	0xfee7;}
}
unless(defined(&GDK_Pointer_Button_Dflt)) {
    sub GDK_Pointer_Button_Dflt () {	0xfee8;}
}
unless(defined(&GDK_Pointer_Button1)) {
    sub GDK_Pointer_Button1 () {	0xfee9;}
}
unless(defined(&GDK_Pointer_Button2)) {
    sub GDK_Pointer_Button2 () {	0xfeea;}
}
unless(defined(&GDK_Pointer_Button3)) {
    sub GDK_Pointer_Button3 () {	0xfeeb;}
}
unless(defined(&GDK_Pointer_Button4)) {
    sub GDK_Pointer_Button4 () {	0xfeec;}
}
unless(defined(&GDK_Pointer_Button5)) {
    sub GDK_Pointer_Button5 () {	0xfeed;}
}
unless(defined(&GDK_Pointer_DblClick_Dflt)) {
    sub GDK_Pointer_DblClick_Dflt () {	0xfeee;}
}
unless(defined(&GDK_Pointer_DblClick1)) {
    sub GDK_Pointer_DblClick1 () {	0xfeef;}
}
unless(defined(&GDK_Pointer_DblClick2)) {
    sub GDK_Pointer_DblClick2 () {	0xfef0;}
}
unless(defined(&GDK_Pointer_DblClick3)) {
    sub GDK_Pointer_DblClick3 () {	0xfef1;}
}
unless(defined(&GDK_Pointer_DblClick4)) {
    sub GDK_Pointer_DblClick4 () {	0xfef2;}
}
unless(defined(&GDK_Pointer_DblClick5)) {
    sub GDK_Pointer_DblClick5 () {	0xfef3;}
}
unless(defined(&GDK_Pointer_Drag_Dflt)) {
    sub GDK_Pointer_Drag_Dflt () {	0xfef4;}
}
unless(defined(&GDK_Pointer_Drag1)) {
    sub GDK_Pointer_Drag1 () {	0xfef5;}
}
unless(defined(&GDK_Pointer_Drag2)) {
    sub GDK_Pointer_Drag2 () {	0xfef6;}
}
unless(defined(&GDK_Pointer_Drag3)) {
    sub GDK_Pointer_Drag3 () {	0xfef7;}
}
unless(defined(&GDK_Pointer_Drag4)) {
    sub GDK_Pointer_Drag4 () {	0xfef8;}
}
unless(defined(&GDK_Pointer_Drag5)) {
    sub GDK_Pointer_Drag5 () {	0xfefd;}
}
unless(defined(&GDK_Pointer_EnableKeys)) {
    sub GDK_Pointer_EnableKeys () {	0xfef9;}
}
unless(defined(&GDK_Pointer_Accelerate)) {
    sub GDK_Pointer_Accelerate () {	0xfefa;}
}
unless(defined(&GDK_Pointer_DfltBtnNext)) {
    sub GDK_Pointer_DfltBtnNext () {	0xfefb;}
}
unless(defined(&GDK_Pointer_DfltBtnPrev)) {
    sub GDK_Pointer_DfltBtnPrev () {	0xfefc;}
}
unless(defined(&GDK_3270_Duplicate)) {
    sub GDK_3270_Duplicate () {	0xfd01;}
}
unless(defined(&GDK_3270_FieldMark)) {
    sub GDK_3270_FieldMark () {	0xfd02;}
}
unless(defined(&GDK_3270_Right2)) {
    sub GDK_3270_Right2 () {	0xfd03;}
}
unless(defined(&GDK_3270_Left2)) {
    sub GDK_3270_Left2 () {	0xfd04;}
}
unless(defined(&GDK_3270_BackTab)) {
    sub GDK_3270_BackTab () {	0xfd05;}
}
unless(defined(&GDK_3270_EraseEOF)) {
    sub GDK_3270_EraseEOF () {	0xfd06;}
}
unless(defined(&GDK_3270_EraseInput)) {
    sub GDK_3270_EraseInput () {	0xfd07;}
}
unless(defined(&GDK_3270_Reset)) {
    sub GDK_3270_Reset () {	0xfd08;}
}
unless(defined(&GDK_3270_Quit)) {
    sub GDK_3270_Quit () {	0xfd09;}
}
unless(defined(&GDK_3270_PA1)) {
    sub GDK_3270_PA1 () {	0xfd0a;}
}
unless(defined(&GDK_3270_PA2)) {
    sub GDK_3270_PA2 () {	0xfd0b;}
}
unless(defined(&GDK_3270_PA3)) {
    sub GDK_3270_PA3 () {	0xfd0c;}
}
unless(defined(&GDK_3270_Test)) {
    sub GDK_3270_Test () {	0xfd0d;}
}
unless(defined(&GDK_3270_Attn)) {
    sub GDK_3270_Attn () {	0xfd0e;}
}
unless(defined(&GDK_3270_CursorBlink)) {
    sub GDK_3270_CursorBlink () {	0xfd0f;}
}
unless(defined(&GDK_3270_AltCursor)) {
    sub GDK_3270_AltCursor () {	0xfd10;}
}
unless(defined(&GDK_3270_KeyClick)) {
    sub GDK_3270_KeyClick () {	0xfd11;}
}
unless(defined(&GDK_3270_Jump)) {
    sub GDK_3270_Jump () {	0xfd12;}
}
unless(defined(&GDK_3270_Ident)) {
    sub GDK_3270_Ident () {	0xfd13;}
}
unless(defined(&GDK_3270_Rule)) {
    sub GDK_3270_Rule () {	0xfd14;}
}
unless(defined(&GDK_3270_Copy)) {
    sub GDK_3270_Copy () {	0xfd15;}
}
unless(defined(&GDK_3270_Play)) {
    sub GDK_3270_Play () {	0xfd16;}
}
unless(defined(&GDK_3270_Setup)) {
    sub GDK_3270_Setup () {	0xfd17;}
}
unless(defined(&GDK_3270_Record)) {
    sub GDK_3270_Record () {	0xfd18;}
}
unless(defined(&GDK_3270_ChangeScreen)) {
    sub GDK_3270_ChangeScreen () {	0xfd19;}
}
unless(defined(&GDK_3270_DeleteWord)) {
    sub GDK_3270_DeleteWord () {	0xfd1a;}
}
unless(defined(&GDK_3270_ExSelect)) {
    sub GDK_3270_ExSelect () {	0xfd1b;}
}
unless(defined(&GDK_3270_CursorSelect)) {
    sub GDK_3270_CursorSelect () {	0xfd1c;}
}
unless(defined(&GDK_3270_PrintScreen)) {
    sub GDK_3270_PrintScreen () {	0xfd1d;}
}
unless(defined(&GDK_3270_Enter)) {
    sub GDK_3270_Enter () {	0xfd1e;}
}
unless(defined(&GDK_space)) {
    sub GDK_space () {	0x20;}
}
unless(defined(&GDK_exclam)) {
    sub GDK_exclam () {	0x21;}
}
unless(defined(&GDK_quotedbl)) {
    sub GDK_quotedbl () {	0x22;}
}
unless(defined(&GDK_numbersign)) {
    sub GDK_numbersign () {	0x23;}
}
unless(defined(&GDK_dollar)) {
    sub GDK_dollar () {	0x24;}
}
unless(defined(&GDK_percent)) {
    sub GDK_percent () {	0x25;}
}
unless(defined(&GDK_ampersand)) {
    sub GDK_ampersand () {	0x26;}
}
unless(defined(&GDK_apostrophe)) {
    sub GDK_apostrophe () {	0x27;}
}
unless(defined(&GDK_quoteright)) {
    sub GDK_quoteright () {	0x27;}
}
unless(defined(&GDK_parenleft)) {
    sub GDK_parenleft () {	0x28;}
}
unless(defined(&GDK_parenright)) {
    sub GDK_parenright () {	0x29;}
}
unless(defined(&GDK_asterisk)) {
    sub GDK_asterisk () {	0x2a;}
}
unless(defined(&GDK_plus)) {
    sub GDK_plus () {	0x2b;}
}
unless(defined(&GDK_comma)) {
    sub GDK_comma () {	0x2c;}
}
unless(defined(&GDK_minus)) {
    sub GDK_minus () {	0x2d;}
}
unless(defined(&GDK_period)) {
    sub GDK_period () {	0x2e;}
}
unless(defined(&GDK_slash)) {
    sub GDK_slash () {	0x2f;}
}
unless(defined(&GDK_0)) {
    sub GDK_0 () {	0x30;}
}
unless(defined(&GDK_1)) {
    sub GDK_1 () {	0x31;}
}
unless(defined(&GDK_2)) {
    sub GDK_2 () {	0x32;}
}
unless(defined(&GDK_3)) {
    sub GDK_3 () {	0x33;}
}
unless(defined(&GDK_4)) {
    sub GDK_4 () {	0x34;}
}
unless(defined(&GDK_5)) {
    sub GDK_5 () {	0x35;}
}
unless(defined(&GDK_6)) {
    sub GDK_6 () {	0x36;}
}
unless(defined(&GDK_7)) {
    sub GDK_7 () {	0x37;}
}
unless(defined(&GDK_8)) {
    sub GDK_8 () {	0x38;}
}
unless(defined(&GDK_9)) {
    sub GDK_9 () {	0x39;}
}
unless(defined(&GDK_colon)) {
    sub GDK_colon () {	0x3a;}
}
unless(defined(&GDK_semicolon)) {
    sub GDK_semicolon () {	0x3b;}
}
unless(defined(&GDK_less)) {
    sub GDK_less () {	0x3c;}
}
unless(defined(&GDK_equal)) {
    sub GDK_equal () {	0x3d;}
}
unless(defined(&GDK_greater)) {
    sub GDK_greater () {	0x3e;}
}
unless(defined(&GDK_question)) {
    sub GDK_question () {	0x3f;}
}
unless(defined(&GDK_at)) {
    sub GDK_at () {	0x40;}
}
unless(defined(&GDK_A)) {
    sub GDK_A () {	0x41;}
}
unless(defined(&GDK_B)) {
    sub GDK_B () {	0x42;}
}
unless(defined(&GDK_C)) {
    sub GDK_C () {	0x43;}
}
unless(defined(&GDK_D)) {
    sub GDK_D () {	0x44;}
}
unless(defined(&GDK_E)) {
    sub GDK_E () {	0x45;}
}
unless(defined(&GDK_F)) {
    sub GDK_F () {	0x46;}
}
unless(defined(&GDK_G)) {
    sub GDK_G () {	0x47;}
}
unless(defined(&GDK_H)) {
    sub GDK_H () {	0x48;}
}
unless(defined(&GDK_I)) {
    sub GDK_I () {	0x49;}
}
unless(defined(&GDK_J)) {
    sub GDK_J () {	0x4a;}
}
unless(defined(&GDK_K)) {
    sub GDK_K () {	0x4b;}
}
unless(defined(&GDK_L)) {
    sub GDK_L () {	0x4c;}
}
unless(defined(&GDK_M)) {
    sub GDK_M () {	0x4d;}
}
unless(defined(&GDK_N)) {
    sub GDK_N () {	0x4e;}
}
unless(defined(&GDK_O)) {
    sub GDK_O () {	0x4f;}
}
unless(defined(&GDK_P)) {
    sub GDK_P () {	0x50;}
}
unless(defined(&GDK_Q)) {
    sub GDK_Q () {	0x51;}
}
unless(defined(&GDK_R)) {
    sub GDK_R () {	0x52;}
}
unless(defined(&GDK_S)) {
    sub GDK_S () {	0x53;}
}
unless(defined(&GDK_T)) {
    sub GDK_T () {	0x54;}
}
unless(defined(&GDK_U)) {
    sub GDK_U () {	0x55;}
}
unless(defined(&GDK_V)) {
    sub GDK_V () {	0x56;}
}
unless(defined(&GDK_W)) {
    sub GDK_W () {	0x57;}
}
unless(defined(&GDK_X)) {
    sub GDK_X () {	0x58;}
}
unless(defined(&GDK_Y)) {
    sub GDK_Y () {	0x59;}
}
unless(defined(&GDK_Z)) {
    sub GDK_Z () {	0x5a;}
}
unless(defined(&GDK_bracketleft)) {
    sub GDK_bracketleft () {	0x5b;}
}
unless(defined(&GDK_backslash)) {
    sub GDK_backslash () {	0x5c;}
}
unless(defined(&GDK_bracketright)) {
    sub GDK_bracketright () {	0x5d;}
}
unless(defined(&GDK_asciicircum)) {
    sub GDK_asciicircum () {	0x5e;}
}
unless(defined(&GDK_underscore)) {
    sub GDK_underscore () {	0x5f;}
}
unless(defined(&GDK_grave)) {
    sub GDK_grave () {	0x60;}
}
unless(defined(&GDK_quoteleft)) {
    sub GDK_quoteleft () {	0x60;}
}
unless(defined(&GDK_a)) {
    sub GDK_a () {	0x61;}
}
unless(defined(&GDK_b)) {
    sub GDK_b () {	0x62;}
}
unless(defined(&GDK_c)) {
    sub GDK_c () {	0x63;}
}
unless(defined(&GDK_d)) {
    sub GDK_d () {	0x64;}
}
unless(defined(&GDK_e)) {
    sub GDK_e () {	0x65;}
}
unless(defined(&GDK_f)) {
    sub GDK_f () {	0x66;}
}
unless(defined(&GDK_g)) {
    sub GDK_g () {	0x67;}
}
unless(defined(&GDK_h)) {
    sub GDK_h () {	0x68;}
}
unless(defined(&GDK_i)) {
    sub GDK_i () {	0x69;}
}
unless(defined(&GDK_j)) {
    sub GDK_j () {	0x6a;}
}
unless(defined(&GDK_k)) {
    sub GDK_k () {	0x6b;}
}
unless(defined(&GDK_l)) {
    sub GDK_l () {	0x6c;}
}
unless(defined(&GDK_m)) {
    sub GDK_m () {	0x6d;}
}
unless(defined(&GDK_n)) {
    sub GDK_n () {	0x6e;}
}
unless(defined(&GDK_o)) {
    sub GDK_o () {	0x6f;}
}
unless(defined(&GDK_p)) {
    sub GDK_p () {	0x70;}
}
unless(defined(&GDK_q)) {
    sub GDK_q () {	0x71;}
}
unless(defined(&GDK_r)) {
    sub GDK_r () {	0x72;}
}
unless(defined(&GDK_s)) {
    sub GDK_s () {	0x73;}
}
unless(defined(&GDK_t)) {
    sub GDK_t () {	0x74;}
}
unless(defined(&GDK_u)) {
    sub GDK_u () {	0x75;}
}
unless(defined(&GDK_v)) {
    sub GDK_v () {	0x76;}
}
unless(defined(&GDK_w)) {
    sub GDK_w () {	0x77;}
}
unless(defined(&GDK_x)) {
    sub GDK_x () {	0x78;}
}
unless(defined(&GDK_y)) {
    sub GDK_y () {	0x79;}
}
unless(defined(&GDK_z)) {
    sub GDK_z () {	0x7a;}
}
unless(defined(&GDK_braceleft)) {
    sub GDK_braceleft () {	0x7b;}
}
unless(defined(&GDK_bar)) {
    sub GDK_bar () {	0x7c;}
}
unless(defined(&GDK_braceright)) {
    sub GDK_braceright () {	0x7d;}
}
unless(defined(&GDK_asciitilde)) {
    sub GDK_asciitilde () {	0x7e;}
}
unless(defined(&GDK_nobreakspace)) {
    sub GDK_nobreakspace () {	0xa0;}
}
unless(defined(&GDK_exclamdown)) {
    sub GDK_exclamdown () {	0xa1;}
}
unless(defined(&GDK_cent)) {
    sub GDK_cent () {	0xa2;}
}
unless(defined(&GDK_sterling)) {
    sub GDK_sterling () {	0xa3;}
}
unless(defined(&GDK_currency)) {
    sub GDK_currency () {	0xa4;}
}
unless(defined(&GDK_yen)) {
    sub GDK_yen () {	0xa5;}
}
unless(defined(&GDK_brokenbar)) {
    sub GDK_brokenbar () {	0xa6;}
}
unless(defined(&GDK_section)) {
    sub GDK_section () {	0xa7;}
}
unless(defined(&GDK_diaeresis)) {
    sub GDK_diaeresis () {	0xa8;}
}
unless(defined(&GDK_copyright)) {
    sub GDK_copyright () {	0xa9;}
}
unless(defined(&GDK_ordfeminine)) {
    sub GDK_ordfeminine () {	0xaa;}
}
unless(defined(&GDK_guillemotleft)) {
    sub GDK_guillemotleft () {	0xab;}
}
unless(defined(&GDK_notsign)) {
    sub GDK_notsign () {	0xac;}
}
unless(defined(&GDK_hyphen)) {
    sub GDK_hyphen () {	0xad;}
}
unless(defined(&GDK_registered)) {
    sub GDK_registered () {	0xae;}
}
unless(defined(&GDK_macron)) {
    sub GDK_macron () {	0xaf;}
}
unless(defined(&GDK_degree)) {
    sub GDK_degree () {	0xb0;}
}
unless(defined(&GDK_plusminus)) {
    sub GDK_plusminus () {	0xb1;}
}
unless(defined(&GDK_twosuperior)) {
    sub GDK_twosuperior () {	0xb2;}
}
unless(defined(&GDK_threesuperior)) {
    sub GDK_threesuperior () {	0xb3;}
}
unless(defined(&GDK_acute)) {
    sub GDK_acute () {	0xb4;}
}
unless(defined(&GDK_mu)) {
    sub GDK_mu () {	0xb5;}
}
unless(defined(&GDK_paragraph)) {
    sub GDK_paragraph () {	0xb6;}
}
unless(defined(&GDK_periodcentered)) {
    sub GDK_periodcentered () {	0xb7;}
}
unless(defined(&GDK_cedilla)) {
    sub GDK_cedilla () {	0xb8;}
}
unless(defined(&GDK_onesuperior)) {
    sub GDK_onesuperior () {	0xb9;}
}
unless(defined(&GDK_masculine)) {
    sub GDK_masculine () {	0xba;}
}
unless(defined(&GDK_guillemotright)) {
    sub GDK_guillemotright () {	0xbb;}
}
unless(defined(&GDK_onequarter)) {
    sub GDK_onequarter () {	0xbc;}
}
unless(defined(&GDK_onehalf)) {
    sub GDK_onehalf () {	0xbd;}
}
unless(defined(&GDK_threequarters)) {
    sub GDK_threequarters () {	0xbe;}
}
unless(defined(&GDK_questiondown)) {
    sub GDK_questiondown () {	0xbf;}
}
unless(defined(&GDK_Agrave)) {
    sub GDK_Agrave () {	0xc0;}
}
unless(defined(&GDK_Aacute)) {
    sub GDK_Aacute () {	0xc1;}
}
unless(defined(&GDK_Acircumflex)) {
    sub GDK_Acircumflex () {	0xc2;}
}
unless(defined(&GDK_Atilde)) {
    sub GDK_Atilde () {	0xc3;}
}
unless(defined(&GDK_Adiaeresis)) {
    sub GDK_Adiaeresis () {	0xc4;}
}
unless(defined(&GDK_Aring)) {
    sub GDK_Aring () {	0xc5;}
}
unless(defined(&GDK_AE)) {
    sub GDK_AE () {	0xc6;}
}
unless(defined(&GDK_Ccedilla)) {
    sub GDK_Ccedilla () {	0xc7;}
}
unless(defined(&GDK_Egrave)) {
    sub GDK_Egrave () {	0xc8;}
}
unless(defined(&GDK_Eacute)) {
    sub GDK_Eacute () {	0xc9;}
}
unless(defined(&GDK_Ecircumflex)) {
    sub GDK_Ecircumflex () {	0xca;}
}
unless(defined(&GDK_Ediaeresis)) {
    sub GDK_Ediaeresis () {	0xcb;}
}
unless(defined(&GDK_Igrave)) {
    sub GDK_Igrave () {	0xcc;}
}
unless(defined(&GDK_Iacute)) {
    sub GDK_Iacute () {	0xcd;}
}
unless(defined(&GDK_Icircumflex)) {
    sub GDK_Icircumflex () {	0xce;}
}
unless(defined(&GDK_Idiaeresis)) {
    sub GDK_Idiaeresis () {	0xcf;}
}
unless(defined(&GDK_ETH)) {
    sub GDK_ETH () {	0xd0;}
}
unless(defined(&GDK_Eth)) {
    sub GDK_Eth () {	0xd0;}
}
unless(defined(&GDK_Ntilde)) {
    sub GDK_Ntilde () {	0xd1;}
}
unless(defined(&GDK_Ograve)) {
    sub GDK_Ograve () {	0xd2;}
}
unless(defined(&GDK_Oacute)) {
    sub GDK_Oacute () {	0xd3;}
}
unless(defined(&GDK_Ocircumflex)) {
    sub GDK_Ocircumflex () {	0xd4;}
}
unless(defined(&GDK_Otilde)) {
    sub GDK_Otilde () {	0xd5;}
}
unless(defined(&GDK_Odiaeresis)) {
    sub GDK_Odiaeresis () {	0xd6;}
}
unless(defined(&GDK_multiply)) {
    sub GDK_multiply () {	0xd7;}
}
unless(defined(&GDK_Ooblique)) {
    sub GDK_Ooblique () {	0xd8;}
}
unless(defined(&GDK_Ugrave)) {
    sub GDK_Ugrave () {	0xd9;}
}
unless(defined(&GDK_Uacute)) {
    sub GDK_Uacute () {	0xda;}
}
unless(defined(&GDK_Ucircumflex)) {
    sub GDK_Ucircumflex () {	0xdb;}
}
unless(defined(&GDK_Udiaeresis)) {
    sub GDK_Udiaeresis () {	0xdc;}
}
unless(defined(&GDK_Yacute)) {
    sub GDK_Yacute () {	0xdd;}
}
unless(defined(&GDK_THORN)) {
    sub GDK_THORN () {	0xde;}
}
unless(defined(&GDK_Thorn)) {
    sub GDK_Thorn () {	0xde;}
}
unless(defined(&GDK_ssharp)) {
    sub GDK_ssharp () {	0xdf;}
}
unless(defined(&GDK_agrave)) {
    sub GDK_agrave () {	0xe0;}
}
unless(defined(&GDK_aacute)) {
    sub GDK_aacute () {	0xe1;}
}
unless(defined(&GDK_acircumflex)) {
    sub GDK_acircumflex () {	0xe2;}
}
unless(defined(&GDK_atilde)) {
    sub GDK_atilde () {	0xe3;}
}
unless(defined(&GDK_adiaeresis)) {
    sub GDK_adiaeresis () {	0xe4;}
}
unless(defined(&GDK_aring)) {
    sub GDK_aring () {	0xe5;}
}
unless(defined(&GDK_ae)) {
    sub GDK_ae () {	0xe6;}
}
unless(defined(&GDK_ccedilla)) {
    sub GDK_ccedilla () {	0xe7;}
}
unless(defined(&GDK_egrave)) {
    sub GDK_egrave () {	0xe8;}
}
unless(defined(&GDK_eacute)) {
    sub GDK_eacute () {	0xe9;}
}
unless(defined(&GDK_ecircumflex)) {
    sub GDK_ecircumflex () {	0xea;}
}
unless(defined(&GDK_ediaeresis)) {
    sub GDK_ediaeresis () {	0xeb;}
}
unless(defined(&GDK_igrave)) {
    sub GDK_igrave () {	0xec;}
}
unless(defined(&GDK_iacute)) {
    sub GDK_iacute () {	0xed;}
}
unless(defined(&GDK_icircumflex)) {
    sub GDK_icircumflex () {	0xee;}
}
unless(defined(&GDK_idiaeresis)) {
    sub GDK_idiaeresis () {	0xef;}
}
unless(defined(&GDK_eth)) {
    sub GDK_eth () {	0xf0;}
}
unless(defined(&GDK_ntilde)) {
    sub GDK_ntilde () {	0xf1;}
}
unless(defined(&GDK_ograve)) {
    sub GDK_ograve () {	0xf2;}
}
unless(defined(&GDK_oacute)) {
    sub GDK_oacute () {	0xf3;}
}
unless(defined(&GDK_ocircumflex)) {
    sub GDK_ocircumflex () {	0xf4;}
}
unless(defined(&GDK_otilde)) {
    sub GDK_otilde () {	0xf5;}
}
unless(defined(&GDK_odiaeresis)) {
    sub GDK_odiaeresis () {	0xf6;}
}
unless(defined(&GDK_division)) {
    sub GDK_division () {	0xf7;}
}
unless(defined(&GDK_oslash)) {
    sub GDK_oslash () {	0xf8;}
}
unless(defined(&GDK_ugrave)) {
    sub GDK_ugrave () {	0xf9;}
}
unless(defined(&GDK_uacute)) {
    sub GDK_uacute () {	0xfa;}
}
unless(defined(&GDK_ucircumflex)) {
    sub GDK_ucircumflex () {	0xfb;}
}
unless(defined(&GDK_udiaeresis)) {
    sub GDK_udiaeresis () {	0xfc;}
}
unless(defined(&GDK_yacute)) {
    sub GDK_yacute () {	0xfd;}
}
unless(defined(&GDK_thorn)) {
    sub GDK_thorn () {	0xfe;}
}
unless(defined(&GDK_ydiaeresis)) {
    sub GDK_ydiaeresis () {	0xff;}
}
unless(defined(&GDK_Aogonek)) {
    sub GDK_Aogonek () {	0x1a1;}
}
unless(defined(&GDK_breve)) {
    sub GDK_breve () {	0x1a2;}
}
unless(defined(&GDK_Lstroke)) {
    sub GDK_Lstroke () {	0x1a3;}
}
unless(defined(&GDK_Lcaron)) {
    sub GDK_Lcaron () {	0x1a5;}
}
unless(defined(&GDK_Sacute)) {
    sub GDK_Sacute () {	0x1a6;}
}
unless(defined(&GDK_Scaron)) {
    sub GDK_Scaron () {	0x1a9;}
}
unless(defined(&GDK_Scedilla)) {
    sub GDK_Scedilla () {	0x1aa;}
}
unless(defined(&GDK_Tcaron)) {
    sub GDK_Tcaron () {	0x1ab;}
}
unless(defined(&GDK_Zacute)) {
    sub GDK_Zacute () {	0x1ac;}
}
unless(defined(&GDK_Zcaron)) {
    sub GDK_Zcaron () {	0x1ae;}
}
unless(defined(&GDK_Zabovedot)) {
    sub GDK_Zabovedot () {	0x1af;}
}
unless(defined(&GDK_aogonek)) {
    sub GDK_aogonek () {	0x1b1;}
}
unless(defined(&GDK_ogonek)) {
    sub GDK_ogonek () {	0x1b2;}
}
unless(defined(&GDK_lstroke)) {
    sub GDK_lstroke () {	0x1b3;}
}
unless(defined(&GDK_lcaron)) {
    sub GDK_lcaron () {	0x1b5;}
}
unless(defined(&GDK_sacute)) {
    sub GDK_sacute () {	0x1b6;}
}
unless(defined(&GDK_caron)) {
    sub GDK_caron () {	0x1b7;}
}
unless(defined(&GDK_scaron)) {
    sub GDK_scaron () {	0x1b9;}
}
unless(defined(&GDK_scedilla)) {
    sub GDK_scedilla () {	0x1ba;}
}
unless(defined(&GDK_tcaron)) {
    sub GDK_tcaron () {	0x1bb;}
}
unless(defined(&GDK_zacute)) {
    sub GDK_zacute () {	0x1bc;}
}
unless(defined(&GDK_doubleacute)) {
    sub GDK_doubleacute () {	0x1bd;}
}
unless(defined(&GDK_zcaron)) {
    sub GDK_zcaron () {	0x1be;}
}
unless(defined(&GDK_zabovedot)) {
    sub GDK_zabovedot () {	0x1bf;}
}
unless(defined(&GDK_Racute)) {
    sub GDK_Racute () {	0x1c0;}
}
unless(defined(&GDK_Abreve)) {
    sub GDK_Abreve () {	0x1c3;}
}
unless(defined(&GDK_Lacute)) {
    sub GDK_Lacute () {	0x1c5;}
}
unless(defined(&GDK_Cacute)) {
    sub GDK_Cacute () {	0x1c6;}
}
unless(defined(&GDK_Ccaron)) {
    sub GDK_Ccaron () {	0x1c8;}
}
unless(defined(&GDK_Eogonek)) {
    sub GDK_Eogonek () {	0x1ca;}
}
unless(defined(&GDK_Ecaron)) {
    sub GDK_Ecaron () {	0x1cc;}
}
unless(defined(&GDK_Dcaron)) {
    sub GDK_Dcaron () {	0x1cf;}
}
unless(defined(&GDK_Dstroke)) {
    sub GDK_Dstroke () {	0x1d0;}
}
unless(defined(&GDK_Nacute)) {
    sub GDK_Nacute () {	0x1d1;}
}
unless(defined(&GDK_Ncaron)) {
    sub GDK_Ncaron () {	0x1d2;}
}
unless(defined(&GDK_Odoubleacute)) {
    sub GDK_Odoubleacute () {	0x1d5;}
}
unless(defined(&GDK_Rcaron)) {
    sub GDK_Rcaron () {	0x1d8;}
}
unless(defined(&GDK_Uring)) {
    sub GDK_Uring () {	0x1d9;}
}
unless(defined(&GDK_Udoubleacute)) {
    sub GDK_Udoubleacute () {	0x1db;}
}
unless(defined(&GDK_Tcedilla)) {
    sub GDK_Tcedilla () {	0x1de;}
}
unless(defined(&GDK_racute)) {
    sub GDK_racute () {	0x1e0;}
}
unless(defined(&GDK_abreve)) {
    sub GDK_abreve () {	0x1e3;}
}
unless(defined(&GDK_lacute)) {
    sub GDK_lacute () {	0x1e5;}
}
unless(defined(&GDK_cacute)) {
    sub GDK_cacute () {	0x1e6;}
}
unless(defined(&GDK_ccaron)) {
    sub GDK_ccaron () {	0x1e8;}
}
unless(defined(&GDK_eogonek)) {
    sub GDK_eogonek () {	0x1ea;}
}
unless(defined(&GDK_ecaron)) {
    sub GDK_ecaron () {	0x1ec;}
}
unless(defined(&GDK_dcaron)) {
    sub GDK_dcaron () {	0x1ef;}
}
unless(defined(&GDK_dstroke)) {
    sub GDK_dstroke () {	0x1f0;}
}
unless(defined(&GDK_nacute)) {
    sub GDK_nacute () {	0x1f1;}
}
unless(defined(&GDK_ncaron)) {
    sub GDK_ncaron () {	0x1f2;}
}
unless(defined(&GDK_odoubleacute)) {
    sub GDK_odoubleacute () {	0x1f5;}
}
unless(defined(&GDK_udoubleacute)) {
    sub GDK_udoubleacute () {	0x1fb;}
}
unless(defined(&GDK_rcaron)) {
    sub GDK_rcaron () {	0x1f8;}
}
unless(defined(&GDK_uring)) {
    sub GDK_uring () {	0x1f9;}
}
unless(defined(&GDK_tcedilla)) {
    sub GDK_tcedilla () {	0x1fe;}
}
unless(defined(&GDK_abovedot)) {
    sub GDK_abovedot () {	0x1ff;}
}
unless(defined(&GDK_Hstroke)) {
    sub GDK_Hstroke () {	0x2a1;}
}
unless(defined(&GDK_Hcircumflex)) {
    sub GDK_Hcircumflex () {	0x2a6;}
}
unless(defined(&GDK_Iabovedot)) {
    sub GDK_Iabovedot () {	0x2a9;}
}
unless(defined(&GDK_Gbreve)) {
    sub GDK_Gbreve () {	0x2ab;}
}
unless(defined(&GDK_Jcircumflex)) {
    sub GDK_Jcircumflex () {	0x2ac;}
}
unless(defined(&GDK_hstroke)) {
    sub GDK_hstroke () {	0x2b1;}
}
unless(defined(&GDK_hcircumflex)) {
    sub GDK_hcircumflex () {	0x2b6;}
}
unless(defined(&GDK_idotless)) {
    sub GDK_idotless () {	0x2b9;}
}
unless(defined(&GDK_gbreve)) {
    sub GDK_gbreve () {	0x2bb;}
}
unless(defined(&GDK_jcircumflex)) {
    sub GDK_jcircumflex () {	0x2bc;}
}
unless(defined(&GDK_Cabovedot)) {
    sub GDK_Cabovedot () {	0x2c5;}
}
unless(defined(&GDK_Ccircumflex)) {
    sub GDK_Ccircumflex () {	0x2c6;}
}
unless(defined(&GDK_Gabovedot)) {
    sub GDK_Gabovedot () {	0x2d5;}
}
unless(defined(&GDK_Gcircumflex)) {
    sub GDK_Gcircumflex () {	0x2d8;}
}
unless(defined(&GDK_Ubreve)) {
    sub GDK_Ubreve () {	0x2dd;}
}
unless(defined(&GDK_Scircumflex)) {
    sub GDK_Scircumflex () {	0x2de;}
}
unless(defined(&GDK_cabovedot)) {
    sub GDK_cabovedot () {	0x2e5;}
}
unless(defined(&GDK_ccircumflex)) {
    sub GDK_ccircumflex () {	0x2e6;}
}
unless(defined(&GDK_gabovedot)) {
    sub GDK_gabovedot () {	0x2f5;}
}
unless(defined(&GDK_gcircumflex)) {
    sub GDK_gcircumflex () {	0x2f8;}
}
unless(defined(&GDK_ubreve)) {
    sub GDK_ubreve () {	0x2fd;}
}
unless(defined(&GDK_scircumflex)) {
    sub GDK_scircumflex () {	0x2fe;}
}
unless(defined(&GDK_kra)) {
    sub GDK_kra () {	0x3a2;}
}
unless(defined(&GDK_kappa)) {
    sub GDK_kappa () {	0x3a2;}
}
unless(defined(&GDK_Rcedilla)) {
    sub GDK_Rcedilla () {	0x3a3;}
}
unless(defined(&GDK_Itilde)) {
    sub GDK_Itilde () {	0x3a5;}
}
unless(defined(&GDK_Lcedilla)) {
    sub GDK_Lcedilla () {	0x3a6;}
}
unless(defined(&GDK_Emacron)) {
    sub GDK_Emacron () {	0x3aa;}
}
unless(defined(&GDK_Gcedilla)) {
    sub GDK_Gcedilla () {	0x3ab;}
}
unless(defined(&GDK_Tslash)) {
    sub GDK_Tslash () {	0x3ac;}
}
unless(defined(&GDK_rcedilla)) {
    sub GDK_rcedilla () {	0x3b3;}
}
unless(defined(&GDK_itilde)) {
    sub GDK_itilde () {	0x3b5;}
}
unless(defined(&GDK_lcedilla)) {
    sub GDK_lcedilla () {	0x3b6;}
}
unless(defined(&GDK_emacron)) {
    sub GDK_emacron () {	0x3ba;}
}
unless(defined(&GDK_gcedilla)) {
    sub GDK_gcedilla () {	0x3bb;}
}
unless(defined(&GDK_tslash)) {
    sub GDK_tslash () {	0x3bc;}
}
unless(defined(&GDK_ENG)) {
    sub GDK_ENG () {	0x3bd;}
}
unless(defined(&GDK_eng)) {
    sub GDK_eng () {	0x3bf;}
}
unless(defined(&GDK_Amacron)) {
    sub GDK_Amacron () {	0x3c0;}
}
unless(defined(&GDK_Iogonek)) {
    sub GDK_Iogonek () {	0x3c7;}
}
unless(defined(&GDK_Eabovedot)) {
    sub GDK_Eabovedot () {	0x3cc;}
}
unless(defined(&GDK_Imacron)) {
    sub GDK_Imacron () {	0x3cf;}
}
unless(defined(&GDK_Ncedilla)) {
    sub GDK_Ncedilla () {	0x3d1;}
}
unless(defined(&GDK_Omacron)) {
    sub GDK_Omacron () {	0x3d2;}
}
unless(defined(&GDK_Kcedilla)) {
    sub GDK_Kcedilla () {	0x3d3;}
}
unless(defined(&GDK_Uogonek)) {
    sub GDK_Uogonek () {	0x3d9;}
}
unless(defined(&GDK_Utilde)) {
    sub GDK_Utilde () {	0x3dd;}
}
unless(defined(&GDK_Umacron)) {
    sub GDK_Umacron () {	0x3de;}
}
unless(defined(&GDK_amacron)) {
    sub GDK_amacron () {	0x3e0;}
}
unless(defined(&GDK_iogonek)) {
    sub GDK_iogonek () {	0x3e7;}
}
unless(defined(&GDK_eabovedot)) {
    sub GDK_eabovedot () {	0x3ec;}
}
unless(defined(&GDK_imacron)) {
    sub GDK_imacron () {	0x3ef;}
}
unless(defined(&GDK_ncedilla)) {
    sub GDK_ncedilla () {	0x3f1;}
}
unless(defined(&GDK_omacron)) {
    sub GDK_omacron () {	0x3f2;}
}
unless(defined(&GDK_kcedilla)) {
    sub GDK_kcedilla () {	0x3f3;}
}
unless(defined(&GDK_uogonek)) {
    sub GDK_uogonek () {	0x3f9;}
}
unless(defined(&GDK_utilde)) {
    sub GDK_utilde () {	0x3fd;}
}
unless(defined(&GDK_umacron)) {
    sub GDK_umacron () {	0x3fe;}
}
unless(defined(&GDK_overline)) {
    sub GDK_overline () {	0x47e;}
}
unless(defined(&GDK_kana_fullstop)) {
    sub GDK_kana_fullstop () {	0x4a1;}
}
unless(defined(&GDK_kana_openingbracket)) {
    sub GDK_kana_openingbracket () {	0x4a2;}
}
unless(defined(&GDK_kana_closingbracket)) {
    sub GDK_kana_closingbracket () {	0x4a3;}
}
unless(defined(&GDK_kana_comma)) {
    sub GDK_kana_comma () {	0x4a4;}
}
unless(defined(&GDK_kana_conjunctive)) {
    sub GDK_kana_conjunctive () {	0x4a5;}
}
unless(defined(&GDK_kana_middledot)) {
    sub GDK_kana_middledot () {	0x4a5;}
}
unless(defined(&GDK_kana_WO)) {
    sub GDK_kana_WO () {	0x4a6;}
}
unless(defined(&GDK_kana_a)) {
    sub GDK_kana_a () {	0x4a7;}
}
unless(defined(&GDK_kana_i)) {
    sub GDK_kana_i () {	0x4a8;}
}
unless(defined(&GDK_kana_u)) {
    sub GDK_kana_u () {	0x4a9;}
}
unless(defined(&GDK_kana_e)) {
    sub GDK_kana_e () {	0x4aa;}
}
unless(defined(&GDK_kana_o)) {
    sub GDK_kana_o () {	0x4ab;}
}
unless(defined(&GDK_kana_ya)) {
    sub GDK_kana_ya () {	0x4ac;}
}
unless(defined(&GDK_kana_yu)) {
    sub GDK_kana_yu () {	0x4ad;}
}
unless(defined(&GDK_kana_yo)) {
    sub GDK_kana_yo () {	0x4ae;}
}
unless(defined(&GDK_kana_tsu)) {
    sub GDK_kana_tsu () {	0x4af;}
}
unless(defined(&GDK_kana_tu)) {
    sub GDK_kana_tu () {	0x4af;}
}
unless(defined(&GDK_prolongedsound)) {
    sub GDK_prolongedsound () {	0x4b0;}
}
unless(defined(&GDK_kana_A)) {
    sub GDK_kana_A () {	0x4b1;}
}
unless(defined(&GDK_kana_I)) {
    sub GDK_kana_I () {	0x4b2;}
}
unless(defined(&GDK_kana_U)) {
    sub GDK_kana_U () {	0x4b3;}
}
unless(defined(&GDK_kana_E)) {
    sub GDK_kana_E () {	0x4b4;}
}
unless(defined(&GDK_kana_O)) {
    sub GDK_kana_O () {	0x4b5;}
}
unless(defined(&GDK_kana_KA)) {
    sub GDK_kana_KA () {	0x4b6;}
}
unless(defined(&GDK_kana_KI)) {
    sub GDK_kana_KI () {	0x4b7;}
}
unless(defined(&GDK_kana_KU)) {
    sub GDK_kana_KU () {	0x4b8;}
}
unless(defined(&GDK_kana_KE)) {
    sub GDK_kana_KE () {	0x4b9;}
}
unless(defined(&GDK_kana_KO)) {
    sub GDK_kana_KO () {	0x4ba;}
}
unless(defined(&GDK_kana_SA)) {
    sub GDK_kana_SA () {	0x4bb;}
}
unless(defined(&GDK_kana_SHI)) {
    sub GDK_kana_SHI () {	0x4bc;}
}
unless(defined(&GDK_kana_SU)) {
    sub GDK_kana_SU () {	0x4bd;}
}
unless(defined(&GDK_kana_SE)) {
    sub GDK_kana_SE () {	0x4be;}
}
unless(defined(&GDK_kana_SO)) {
    sub GDK_kana_SO () {	0x4bf;}
}
unless(defined(&GDK_kana_TA)) {
    sub GDK_kana_TA () {	0x4c0;}
}
unless(defined(&GDK_kana_CHI)) {
    sub GDK_kana_CHI () {	0x4c1;}
}
unless(defined(&GDK_kana_TI)) {
    sub GDK_kana_TI () {	0x4c1;}
}
unless(defined(&GDK_kana_TSU)) {
    sub GDK_kana_TSU () {	0x4c2;}
}
unless(defined(&GDK_kana_TU)) {
    sub GDK_kana_TU () {	0x4c2;}
}
unless(defined(&GDK_kana_TE)) {
    sub GDK_kana_TE () {	0x4c3;}
}
unless(defined(&GDK_kana_TO)) {
    sub GDK_kana_TO () {	0x4c4;}
}
unless(defined(&GDK_kana_NA)) {
    sub GDK_kana_NA () {	0x4c5;}
}
unless(defined(&GDK_kana_NI)) {
    sub GDK_kana_NI () {	0x4c6;}
}
unless(defined(&GDK_kana_NU)) {
    sub GDK_kana_NU () {	0x4c7;}
}
unless(defined(&GDK_kana_NE)) {
    sub GDK_kana_NE () {	0x4c8;}
}
unless(defined(&GDK_kana_NO)) {
    sub GDK_kana_NO () {	0x4c9;}
}
unless(defined(&GDK_kana_HA)) {
    sub GDK_kana_HA () {	0x4ca;}
}
unless(defined(&GDK_kana_HI)) {
    sub GDK_kana_HI () {	0x4cb;}
}
unless(defined(&GDK_kana_FU)) {
    sub GDK_kana_FU () {	0x4cc;}
}
unless(defined(&GDK_kana_HU)) {
    sub GDK_kana_HU () {	0x4cc;}
}
unless(defined(&GDK_kana_HE)) {
    sub GDK_kana_HE () {	0x4cd;}
}
unless(defined(&GDK_kana_HO)) {
    sub GDK_kana_HO () {	0x4ce;}
}
unless(defined(&GDK_kana_MA)) {
    sub GDK_kana_MA () {	0x4cf;}
}
unless(defined(&GDK_kana_MI)) {
    sub GDK_kana_MI () {	0x4d0;}
}
unless(defined(&GDK_kana_MU)) {
    sub GDK_kana_MU () {	0x4d1;}
}
unless(defined(&GDK_kana_ME)) {
    sub GDK_kana_ME () {	0x4d2;}
}
unless(defined(&GDK_kana_MO)) {
    sub GDK_kana_MO () {	0x4d3;}
}
unless(defined(&GDK_kana_YA)) {
    sub GDK_kana_YA () {	0x4d4;}
}
unless(defined(&GDK_kana_YU)) {
    sub GDK_kana_YU () {	0x4d5;}
}
unless(defined(&GDK_kana_YO)) {
    sub GDK_kana_YO () {	0x4d6;}
}
unless(defined(&GDK_kana_RA)) {
    sub GDK_kana_RA () {	0x4d7;}
}
unless(defined(&GDK_kana_RI)) {
    sub GDK_kana_RI () {	0x4d8;}
}
unless(defined(&GDK_kana_RU)) {
    sub GDK_kana_RU () {	0x4d9;}
}
unless(defined(&GDK_kana_RE)) {
    sub GDK_kana_RE () {	0x4da;}
}
unless(defined(&GDK_kana_RO)) {
    sub GDK_kana_RO () {	0x4db;}
}
unless(defined(&GDK_kana_WA)) {
    sub GDK_kana_WA () {	0x4dc;}
}
unless(defined(&GDK_kana_N)) {
    sub GDK_kana_N () {	0x4dd;}
}
unless(defined(&GDK_voicedsound)) {
    sub GDK_voicedsound () {	0x4de;}
}
unless(defined(&GDK_semivoicedsound)) {
    sub GDK_semivoicedsound () {	0x4df;}
}
unless(defined(&GDK_kana_switch)) {
    sub GDK_kana_switch () {	0xff7e;}
}
unless(defined(&GDK_Arabic_comma)) {
    sub GDK_Arabic_comma () {	0x5ac;}
}
unless(defined(&GDK_Arabic_semicolon)) {
    sub GDK_Arabic_semicolon () {	0x5bb;}
}
unless(defined(&GDK_Arabic_question_mark)) {
    sub GDK_Arabic_question_mark () {	0x5bf;}
}
unless(defined(&GDK_Arabic_hamza)) {
    sub GDK_Arabic_hamza () {	0x5c1;}
}
unless(defined(&GDK_Arabic_maddaonalef)) {
    sub GDK_Arabic_maddaonalef () {	0x5c2;}
}
unless(defined(&GDK_Arabic_hamzaonalef)) {
    sub GDK_Arabic_hamzaonalef () {	0x5c3;}
}
unless(defined(&GDK_Arabic_hamzaonwaw)) {
    sub GDK_Arabic_hamzaonwaw () {	0x5c4;}
}
unless(defined(&GDK_Arabic_hamzaunderalef)) {
    sub GDK_Arabic_hamzaunderalef () {	0x5c5;}
}
unless(defined(&GDK_Arabic_hamzaonyeh)) {
    sub GDK_Arabic_hamzaonyeh () {	0x5c6;}
}
unless(defined(&GDK_Arabic_alef)) {
    sub GDK_Arabic_alef () {	0x5c7;}
}
unless(defined(&GDK_Arabic_beh)) {
    sub GDK_Arabic_beh () {	0x5c8;}
}
unless(defined(&GDK_Arabic_tehmarbuta)) {
    sub GDK_Arabic_tehmarbuta () {	0x5c9;}
}
unless(defined(&GDK_Arabic_teh)) {
    sub GDK_Arabic_teh () {	0x5ca;}
}
unless(defined(&GDK_Arabic_theh)) {
    sub GDK_Arabic_theh () {	0x5cb;}
}
unless(defined(&GDK_Arabic_jeem)) {
    sub GDK_Arabic_jeem () {	0x5cc;}
}
unless(defined(&GDK_Arabic_hah)) {
    sub GDK_Arabic_hah () {	0x5cd;}
}
unless(defined(&GDK_Arabic_khah)) {
    sub GDK_Arabic_khah () {	0x5ce;}
}
unless(defined(&GDK_Arabic_dal)) {
    sub GDK_Arabic_dal () {	0x5cf;}
}
unless(defined(&GDK_Arabic_thal)) {
    sub GDK_Arabic_thal () {	0x5d0;}
}
unless(defined(&GDK_Arabic_ra)) {
    sub GDK_Arabic_ra () {	0x5d1;}
}
unless(defined(&GDK_Arabic_zain)) {
    sub GDK_Arabic_zain () {	0x5d2;}
}
unless(defined(&GDK_Arabic_seen)) {
    sub GDK_Arabic_seen () {	0x5d3;}
}
unless(defined(&GDK_Arabic_sheen)) {
    sub GDK_Arabic_sheen () {	0x5d4;}
}
unless(defined(&GDK_Arabic_sad)) {
    sub GDK_Arabic_sad () {	0x5d5;}
}
unless(defined(&GDK_Arabic_dad)) {
    sub GDK_Arabic_dad () {	0x5d6;}
}
unless(defined(&GDK_Arabic_tah)) {
    sub GDK_Arabic_tah () {	0x5d7;}
}
unless(defined(&GDK_Arabic_zah)) {
    sub GDK_Arabic_zah () {	0x5d8;}
}
unless(defined(&GDK_Arabic_ain)) {
    sub GDK_Arabic_ain () {	0x5d9;}
}
unless(defined(&GDK_Arabic_ghain)) {
    sub GDK_Arabic_ghain () {	0x5da;}
}
unless(defined(&GDK_Arabic_tatweel)) {
    sub GDK_Arabic_tatweel () {	0x5e0;}
}
unless(defined(&GDK_Arabic_feh)) {
    sub GDK_Arabic_feh () {	0x5e1;}
}
unless(defined(&GDK_Arabic_qaf)) {
    sub GDK_Arabic_qaf () {	0x5e2;}
}
unless(defined(&GDK_Arabic_kaf)) {
    sub GDK_Arabic_kaf () {	0x5e3;}
}
unless(defined(&GDK_Arabic_lam)) {
    sub GDK_Arabic_lam () {	0x5e4;}
}
unless(defined(&GDK_Arabic_meem)) {
    sub GDK_Arabic_meem () {	0x5e5;}
}
unless(defined(&GDK_Arabic_noon)) {
    sub GDK_Arabic_noon () {	0x5e6;}
}
unless(defined(&GDK_Arabic_ha)) {
    sub GDK_Arabic_ha () {	0x5e7;}
}
unless(defined(&GDK_Arabic_heh)) {
    sub GDK_Arabic_heh () {	0x5e7;}
}
unless(defined(&GDK_Arabic_waw)) {
    sub GDK_Arabic_waw () {	0x5e8;}
}
unless(defined(&GDK_Arabic_alefmaksura)) {
    sub GDK_Arabic_alefmaksura () {	0x5e9;}
}
unless(defined(&GDK_Arabic_yeh)) {
    sub GDK_Arabic_yeh () {	0x5ea;}
}
unless(defined(&GDK_Arabic_fathatan)) {
    sub GDK_Arabic_fathatan () {	0x5eb;}
}
unless(defined(&GDK_Arabic_dammatan)) {
    sub GDK_Arabic_dammatan () {	0x5ec;}
}
unless(defined(&GDK_Arabic_kasratan)) {
    sub GDK_Arabic_kasratan () {	0x5ed;}
}
unless(defined(&GDK_Arabic_fatha)) {
    sub GDK_Arabic_fatha () {	0x5ee;}
}
unless(defined(&GDK_Arabic_damma)) {
    sub GDK_Arabic_damma () {	0x5ef;}
}
unless(defined(&GDK_Arabic_kasra)) {
    sub GDK_Arabic_kasra () {	0x5f0;}
}
unless(defined(&GDK_Arabic_shadda)) {
    sub GDK_Arabic_shadda () {	0x5f1;}
}
unless(defined(&GDK_Arabic_sukun)) {
    sub GDK_Arabic_sukun () {	0x5f2;}
}
unless(defined(&GDK_Arabic_switch)) {
    sub GDK_Arabic_switch () {	0xff7e;}
}
unless(defined(&GDK_Serbian_dje)) {
    sub GDK_Serbian_dje () {	0x6a1;}
}
unless(defined(&GDK_Macedonia_gje)) {
    sub GDK_Macedonia_gje () {	0x6a2;}
}
unless(defined(&GDK_Cyrillic_io)) {
    sub GDK_Cyrillic_io () {	0x6a3;}
}
unless(defined(&GDK_Ukrainian_ie)) {
    sub GDK_Ukrainian_ie () {	0x6a4;}
}
unless(defined(&GDK_Ukranian_je)) {
    sub GDK_Ukranian_je () {	0x6a4;}
}
unless(defined(&GDK_Macedonia_dse)) {
    sub GDK_Macedonia_dse () {	0x6a5;}
}
unless(defined(&GDK_Ukrainian_i)) {
    sub GDK_Ukrainian_i () {	0x6a6;}
}
unless(defined(&GDK_Ukranian_i)) {
    sub GDK_Ukranian_i () {	0x6a6;}
}
unless(defined(&GDK_Ukrainian_yi)) {
    sub GDK_Ukrainian_yi () {	0x6a7;}
}
unless(defined(&GDK_Ukranian_yi)) {
    sub GDK_Ukranian_yi () {	0x6a7;}
}
unless(defined(&GDK_Cyrillic_je)) {
    sub GDK_Cyrillic_je () {	0x6a8;}
}
unless(defined(&GDK_Serbian_je)) {
    sub GDK_Serbian_je () {	0x6a8;}
}
unless(defined(&GDK_Cyrillic_lje)) {
    sub GDK_Cyrillic_lje () {	0x6a9;}
}
unless(defined(&GDK_Serbian_lje)) {
    sub GDK_Serbian_lje () {	0x6a9;}
}
unless(defined(&GDK_Cyrillic_nje)) {
    sub GDK_Cyrillic_nje () {	0x6aa;}
}
unless(defined(&GDK_Serbian_nje)) {
    sub GDK_Serbian_nje () {	0x6aa;}
}
unless(defined(&GDK_Serbian_tshe)) {
    sub GDK_Serbian_tshe () {	0x6ab;}
}
unless(defined(&GDK_Macedonia_kje)) {
    sub GDK_Macedonia_kje () {	0x6ac;}
}
unless(defined(&GDK_Byelorussian_shortu)) {
    sub GDK_Byelorussian_shortu () {	0x6ae;}
}
unless(defined(&GDK_Cyrillic_dzhe)) {
    sub GDK_Cyrillic_dzhe () {	0x6af;}
}
unless(defined(&GDK_Serbian_dze)) {
    sub GDK_Serbian_dze () {	0x6af;}
}
unless(defined(&GDK_numerosign)) {
    sub GDK_numerosign () {	0x6b0;}
}
unless(defined(&GDK_Serbian_DJE)) {
    sub GDK_Serbian_DJE () {	0x6b1;}
}
unless(defined(&GDK_Macedonia_GJE)) {
    sub GDK_Macedonia_GJE () {	0x6b2;}
}
unless(defined(&GDK_Cyrillic_IO)) {
    sub GDK_Cyrillic_IO () {	0x6b3;}
}
unless(defined(&GDK_Ukrainian_IE)) {
    sub GDK_Ukrainian_IE () {	0x6b4;}
}
unless(defined(&GDK_Ukranian_JE)) {
    sub GDK_Ukranian_JE () {	0x6b4;}
}
unless(defined(&GDK_Macedonia_DSE)) {
    sub GDK_Macedonia_DSE () {	0x6b5;}
}
unless(defined(&GDK_Ukrainian_I)) {
    sub GDK_Ukrainian_I () {	0x6b6;}
}
unless(defined(&GDK_Ukranian_I)) {
    sub GDK_Ukranian_I () {	0x6b6;}
}
unless(defined(&GDK_Ukrainian_YI)) {
    sub GDK_Ukrainian_YI () {	0x6b7;}
}
unless(defined(&GDK_Ukranian_YI)) {
    sub GDK_Ukranian_YI () {	0x6b7;}
}
unless(defined(&GDK_Cyrillic_JE)) {
    sub GDK_Cyrillic_JE () {	0x6b8;}
}
unless(defined(&GDK_Serbian_JE)) {
    sub GDK_Serbian_JE () {	0x6b8;}
}
unless(defined(&GDK_Cyrillic_LJE)) {
    sub GDK_Cyrillic_LJE () {	0x6b9;}
}
unless(defined(&GDK_Serbian_LJE)) {
    sub GDK_Serbian_LJE () {	0x6b9;}
}
unless(defined(&GDK_Cyrillic_NJE)) {
    sub GDK_Cyrillic_NJE () {	0x6ba;}
}
unless(defined(&GDK_Serbian_NJE)) {
    sub GDK_Serbian_NJE () {	0x6ba;}
}
unless(defined(&GDK_Serbian_TSHE)) {
    sub GDK_Serbian_TSHE () {	0x6bb;}
}
unless(defined(&GDK_Macedonia_KJE)) {
    sub GDK_Macedonia_KJE () {	0x6bc;}
}
unless(defined(&GDK_Byelorussian_SHORTU)) {
    sub GDK_Byelorussian_SHORTU () {	0x6be;}
}
unless(defined(&GDK_Cyrillic_DZHE)) {
    sub GDK_Cyrillic_DZHE () {	0x6bf;}
}
unless(defined(&GDK_Serbian_DZE)) {
    sub GDK_Serbian_DZE () {	0x6bf;}
}
unless(defined(&GDK_Cyrillic_yu)) {
    sub GDK_Cyrillic_yu () {	0x6c0;}
}
unless(defined(&GDK_Cyrillic_a)) {
    sub GDK_Cyrillic_a () {	0x6c1;}
}
unless(defined(&GDK_Cyrillic_be)) {
    sub GDK_Cyrillic_be () {	0x6c2;}
}
unless(defined(&GDK_Cyrillic_tse)) {
    sub GDK_Cyrillic_tse () {	0x6c3;}
}
unless(defined(&GDK_Cyrillic_de)) {
    sub GDK_Cyrillic_de () {	0x6c4;}
}
unless(defined(&GDK_Cyrillic_ie)) {
    sub GDK_Cyrillic_ie () {	0x6c5;}
}
unless(defined(&GDK_Cyrillic_ef)) {
    sub GDK_Cyrillic_ef () {	0x6c6;}
}
unless(defined(&GDK_Cyrillic_ghe)) {
    sub GDK_Cyrillic_ghe () {	0x6c7;}
}
unless(defined(&GDK_Cyrillic_ha)) {
    sub GDK_Cyrillic_ha () {	0x6c8;}
}
unless(defined(&GDK_Cyrillic_i)) {
    sub GDK_Cyrillic_i () {	0x6c9;}
}
unless(defined(&GDK_Cyrillic_shorti)) {
    sub GDK_Cyrillic_shorti () {	0x6ca;}
}
unless(defined(&GDK_Cyrillic_ka)) {
    sub GDK_Cyrillic_ka () {	0x6cb;}
}
unless(defined(&GDK_Cyrillic_el)) {
    sub GDK_Cyrillic_el () {	0x6cc;}
}
unless(defined(&GDK_Cyrillic_em)) {
    sub GDK_Cyrillic_em () {	0x6cd;}
}
unless(defined(&GDK_Cyrillic_en)) {
    sub GDK_Cyrillic_en () {	0x6ce;}
}
unless(defined(&GDK_Cyrillic_o)) {
    sub GDK_Cyrillic_o () {	0x6cf;}
}
unless(defined(&GDK_Cyrillic_pe)) {
    sub GDK_Cyrillic_pe () {	0x6d0;}
}
unless(defined(&GDK_Cyrillic_ya)) {
    sub GDK_Cyrillic_ya () {	0x6d1;}
}
unless(defined(&GDK_Cyrillic_er)) {
    sub GDK_Cyrillic_er () {	0x6d2;}
}
unless(defined(&GDK_Cyrillic_es)) {
    sub GDK_Cyrillic_es () {	0x6d3;}
}
unless(defined(&GDK_Cyrillic_te)) {
    sub GDK_Cyrillic_te () {	0x6d4;}
}
unless(defined(&GDK_Cyrillic_u)) {
    sub GDK_Cyrillic_u () {	0x6d5;}
}
unless(defined(&GDK_Cyrillic_zhe)) {
    sub GDK_Cyrillic_zhe () {	0x6d6;}
}
unless(defined(&GDK_Cyrillic_ve)) {
    sub GDK_Cyrillic_ve () {	0x6d7;}
}
unless(defined(&GDK_Cyrillic_softsign)) {
    sub GDK_Cyrillic_softsign () {	0x6d8;}
}
unless(defined(&GDK_Cyrillic_yeru)) {
    sub GDK_Cyrillic_yeru () {	0x6d9;}
}
unless(defined(&GDK_Cyrillic_ze)) {
    sub GDK_Cyrillic_ze () {	0x6da;}
}
unless(defined(&GDK_Cyrillic_sha)) {
    sub GDK_Cyrillic_sha () {	0x6db;}
}
unless(defined(&GDK_Cyrillic_e)) {
    sub GDK_Cyrillic_e () {	0x6dc;}
}
unless(defined(&GDK_Cyrillic_shcha)) {
    sub GDK_Cyrillic_shcha () {	0x6dd;}
}
unless(defined(&GDK_Cyrillic_che)) {
    sub GDK_Cyrillic_che () {	0x6de;}
}
unless(defined(&GDK_Cyrillic_hardsign)) {
    sub GDK_Cyrillic_hardsign () {	0x6df;}
}
unless(defined(&GDK_Cyrillic_YU)) {
    sub GDK_Cyrillic_YU () {	0x6e0;}
}
unless(defined(&GDK_Cyrillic_A)) {
    sub GDK_Cyrillic_A () {	0x6e1;}
}
unless(defined(&GDK_Cyrillic_BE)) {
    sub GDK_Cyrillic_BE () {	0x6e2;}
}
unless(defined(&GDK_Cyrillic_TSE)) {
    sub GDK_Cyrillic_TSE () {	0x6e3;}
}
unless(defined(&GDK_Cyrillic_DE)) {
    sub GDK_Cyrillic_DE () {	0x6e4;}
}
unless(defined(&GDK_Cyrillic_IE)) {
    sub GDK_Cyrillic_IE () {	0x6e5;}
}
unless(defined(&GDK_Cyrillic_EF)) {
    sub GDK_Cyrillic_EF () {	0x6e6;}
}
unless(defined(&GDK_Cyrillic_GHE)) {
    sub GDK_Cyrillic_GHE () {	0x6e7;}
}
unless(defined(&GDK_Cyrillic_HA)) {
    sub GDK_Cyrillic_HA () {	0x6e8;}
}
unless(defined(&GDK_Cyrillic_I)) {
    sub GDK_Cyrillic_I () {	0x6e9;}
}
unless(defined(&GDK_Cyrillic_SHORTI)) {
    sub GDK_Cyrillic_SHORTI () {	0x6ea;}
}
unless(defined(&GDK_Cyrillic_KA)) {
    sub GDK_Cyrillic_KA () {	0x6eb;}
}
unless(defined(&GDK_Cyrillic_EL)) {
    sub GDK_Cyrillic_EL () {	0x6ec;}
}
unless(defined(&GDK_Cyrillic_EM)) {
    sub GDK_Cyrillic_EM () {	0x6ed;}
}
unless(defined(&GDK_Cyrillic_EN)) {
    sub GDK_Cyrillic_EN () {	0x6ee;}
}
unless(defined(&GDK_Cyrillic_O)) {
    sub GDK_Cyrillic_O () {	0x6ef;}
}
unless(defined(&GDK_Cyrillic_PE)) {
    sub GDK_Cyrillic_PE () {	0x6f0;}
}
unless(defined(&GDK_Cyrillic_YA)) {
    sub GDK_Cyrillic_YA () {	0x6f1;}
}
unless(defined(&GDK_Cyrillic_ER)) {
    sub GDK_Cyrillic_ER () {	0x6f2;}
}
unless(defined(&GDK_Cyrillic_ES)) {
    sub GDK_Cyrillic_ES () {	0x6f3;}
}
unless(defined(&GDK_Cyrillic_TE)) {
    sub GDK_Cyrillic_TE () {	0x6f4;}
}
unless(defined(&GDK_Cyrillic_U)) {
    sub GDK_Cyrillic_U () {	0x6f5;}
}
unless(defined(&GDK_Cyrillic_ZHE)) {
    sub GDK_Cyrillic_ZHE () {	0x6f6;}
}
unless(defined(&GDK_Cyrillic_VE)) {
    sub GDK_Cyrillic_VE () {	0x6f7;}
}
unless(defined(&GDK_Cyrillic_SOFTSIGN)) {
    sub GDK_Cyrillic_SOFTSIGN () {	0x6f8;}
}
unless(defined(&GDK_Cyrillic_YERU)) {
    sub GDK_Cyrillic_YERU () {	0x6f9;}
}
unless(defined(&GDK_Cyrillic_ZE)) {
    sub GDK_Cyrillic_ZE () {	0x6fa;}
}
unless(defined(&GDK_Cyrillic_SHA)) {
    sub GDK_Cyrillic_SHA () {	0x6fb;}
}
unless(defined(&GDK_Cyrillic_E)) {
    sub GDK_Cyrillic_E () {	0x6fc;}
}
unless(defined(&GDK_Cyrillic_SHCHA)) {
    sub GDK_Cyrillic_SHCHA () {	0x6fd;}
}
unless(defined(&GDK_Cyrillic_CHE)) {
    sub GDK_Cyrillic_CHE () {	0x6fe;}
}
unless(defined(&GDK_Cyrillic_HARDSIGN)) {
    sub GDK_Cyrillic_HARDSIGN () {	0x6ff;}
}
unless(defined(&GDK_Greek_ALPHAaccent)) {
    sub GDK_Greek_ALPHAaccent () {	0x7a1;}
}
unless(defined(&GDK_Greek_EPSILONaccent)) {
    sub GDK_Greek_EPSILONaccent () {	0x7a2;}
}
unless(defined(&GDK_Greek_ETAaccent)) {
    sub GDK_Greek_ETAaccent () {	0x7a3;}
}
unless(defined(&GDK_Greek_IOTAaccent)) {
    sub GDK_Greek_IOTAaccent () {	0x7a4;}
}
unless(defined(&GDK_Greek_IOTAdiaeresis)) {
    sub GDK_Greek_IOTAdiaeresis () {	0x7a5;}
}
unless(defined(&GDK_Greek_OMICRONaccent)) {
    sub GDK_Greek_OMICRONaccent () {	0x7a7;}
}
unless(defined(&GDK_Greek_UPSILONaccent)) {
    sub GDK_Greek_UPSILONaccent () {	0x7a8;}
}
unless(defined(&GDK_Greek_UPSILONdieresis)) {
    sub GDK_Greek_UPSILONdieresis () {	0x7a9;}
}
unless(defined(&GDK_Greek_OMEGAaccent)) {
    sub GDK_Greek_OMEGAaccent () {	0x7ab;}
}
unless(defined(&GDK_Greek_accentdieresis)) {
    sub GDK_Greek_accentdieresis () {	0x7ae;}
}
unless(defined(&GDK_Greek_horizbar)) {
    sub GDK_Greek_horizbar () {	0x7af;}
}
unless(defined(&GDK_Greek_alphaaccent)) {
    sub GDK_Greek_alphaaccent () {	0x7b1;}
}
unless(defined(&GDK_Greek_epsilonaccent)) {
    sub GDK_Greek_epsilonaccent () {	0x7b2;}
}
unless(defined(&GDK_Greek_etaaccent)) {
    sub GDK_Greek_etaaccent () {	0x7b3;}
}
unless(defined(&GDK_Greek_iotaaccent)) {
    sub GDK_Greek_iotaaccent () {	0x7b4;}
}
unless(defined(&GDK_Greek_iotadieresis)) {
    sub GDK_Greek_iotadieresis () {	0x7b5;}
}
unless(defined(&GDK_Greek_iotaaccentdieresis)) {
    sub GDK_Greek_iotaaccentdieresis () {	0x7b6;}
}
unless(defined(&GDK_Greek_omicronaccent)) {
    sub GDK_Greek_omicronaccent () {	0x7b7;}
}
unless(defined(&GDK_Greek_upsilonaccent)) {
    sub GDK_Greek_upsilonaccent () {	0x7b8;}
}
unless(defined(&GDK_Greek_upsilondieresis)) {
    sub GDK_Greek_upsilondieresis () {	0x7b9;}
}
unless(defined(&GDK_Greek_upsilonaccentdieresis)) {
    sub GDK_Greek_upsilonaccentdieresis () {	0x7ba;}
}
unless(defined(&GDK_Greek_omegaaccent)) {
    sub GDK_Greek_omegaaccent () {	0x7bb;}
}
unless(defined(&GDK_Greek_ALPHA)) {
    sub GDK_Greek_ALPHA () {	0x7c1;}
}
unless(defined(&GDK_Greek_BETA)) {
    sub GDK_Greek_BETA () {	0x7c2;}
}
unless(defined(&GDK_Greek_GAMMA)) {
    sub GDK_Greek_GAMMA () {	0x7c3;}
}
unless(defined(&GDK_Greek_DELTA)) {
    sub GDK_Greek_DELTA () {	0x7c4;}
}
unless(defined(&GDK_Greek_EPSILON)) {
    sub GDK_Greek_EPSILON () {	0x7c5;}
}
unless(defined(&GDK_Greek_ZETA)) {
    sub GDK_Greek_ZETA () {	0x7c6;}
}
unless(defined(&GDK_Greek_ETA)) {
    sub GDK_Greek_ETA () {	0x7c7;}
}
unless(defined(&GDK_Greek_THETA)) {
    sub GDK_Greek_THETA () {	0x7c8;}
}
unless(defined(&GDK_Greek_IOTA)) {
    sub GDK_Greek_IOTA () {	0x7c9;}
}
unless(defined(&GDK_Greek_KAPPA)) {
    sub GDK_Greek_KAPPA () {	0x7ca;}
}
unless(defined(&GDK_Greek_LAMDA)) {
    sub GDK_Greek_LAMDA () {	0x7cb;}
}
unless(defined(&GDK_Greek_LAMBDA)) {
    sub GDK_Greek_LAMBDA () {	0x7cb;}
}
unless(defined(&GDK_Greek_MU)) {
    sub GDK_Greek_MU () {	0x7cc;}
}
unless(defined(&GDK_Greek_NU)) {
    sub GDK_Greek_NU () {	0x7cd;}
}
unless(defined(&GDK_Greek_XI)) {
    sub GDK_Greek_XI () {	0x7ce;}
}
unless(defined(&GDK_Greek_OMICRON)) {
    sub GDK_Greek_OMICRON () {	0x7cf;}
}
unless(defined(&GDK_Greek_PI)) {
    sub GDK_Greek_PI () {	0x7d0;}
}
unless(defined(&GDK_Greek_RHO)) {
    sub GDK_Greek_RHO () {	0x7d1;}
}
unless(defined(&GDK_Greek_SIGMA)) {
    sub GDK_Greek_SIGMA () {	0x7d2;}
}
unless(defined(&GDK_Greek_TAU)) {
    sub GDK_Greek_TAU () {	0x7d4;}
}
unless(defined(&GDK_Greek_UPSILON)) {
    sub GDK_Greek_UPSILON () {	0x7d5;}
}
unless(defined(&GDK_Greek_PHI)) {
    sub GDK_Greek_PHI () {	0x7d6;}
}
unless(defined(&GDK_Greek_CHI)) {
    sub GDK_Greek_CHI () {	0x7d7;}
}
unless(defined(&GDK_Greek_PSI)) {
    sub GDK_Greek_PSI () {	0x7d8;}
}
unless(defined(&GDK_Greek_OMEGA)) {
    sub GDK_Greek_OMEGA () {	0x7d9;}
}
unless(defined(&GDK_Greek_alpha)) {
    sub GDK_Greek_alpha () {	0x7e1;}
}
unless(defined(&GDK_Greek_beta)) {
    sub GDK_Greek_beta () {	0x7e2;}
}
unless(defined(&GDK_Greek_gamma)) {
    sub GDK_Greek_gamma () {	0x7e3;}
}
unless(defined(&GDK_Greek_delta)) {
    sub GDK_Greek_delta () {	0x7e4;}
}
unless(defined(&GDK_Greek_epsilon)) {
    sub GDK_Greek_epsilon () {	0x7e5;}
}
unless(defined(&GDK_Greek_zeta)) {
    sub GDK_Greek_zeta () {	0x7e6;}
}
unless(defined(&GDK_Greek_eta)) {
    sub GDK_Greek_eta () {	0x7e7;}
}
unless(defined(&GDK_Greek_theta)) {
    sub GDK_Greek_theta () {	0x7e8;}
}
unless(defined(&GDK_Greek_iota)) {
    sub GDK_Greek_iota () {	0x7e9;}
}
unless(defined(&GDK_Greek_kappa)) {
    sub GDK_Greek_kappa () {	0x7ea;}
}
unless(defined(&GDK_Greek_lamda)) {
    sub GDK_Greek_lamda () {	0x7eb;}
}
unless(defined(&GDK_Greek_lambda)) {
    sub GDK_Greek_lambda () {	0x7eb;}
}
unless(defined(&GDK_Greek_mu)) {
    sub GDK_Greek_mu () {	0x7ec;}
}
unless(defined(&GDK_Greek_nu)) {
    sub GDK_Greek_nu () {	0x7ed;}
}
unless(defined(&GDK_Greek_xi)) {
    sub GDK_Greek_xi () {	0x7ee;}
}
unless(defined(&GDK_Greek_omicron)) {
    sub GDK_Greek_omicron () {	0x7ef;}
}
unless(defined(&GDK_Greek_pi)) {
    sub GDK_Greek_pi () {	0x7f0;}
}
unless(defined(&GDK_Greek_rho)) {
    sub GDK_Greek_rho () {	0x7f1;}
}
unless(defined(&GDK_Greek_sigma)) {
    sub GDK_Greek_sigma () {	0x7f2;}
}
unless(defined(&GDK_Greek_finalsmallsigma)) {
    sub GDK_Greek_finalsmallsigma () {	0x7f3;}
}
unless(defined(&GDK_Greek_tau)) {
    sub GDK_Greek_tau () {	0x7f4;}
}
unless(defined(&GDK_Greek_upsilon)) {
    sub GDK_Greek_upsilon () {	0x7f5;}
}
unless(defined(&GDK_Greek_phi)) {
    sub GDK_Greek_phi () {	0x7f6;}
}
unless(defined(&GDK_Greek_chi)) {
    sub GDK_Greek_chi () {	0x7f7;}
}
unless(defined(&GDK_Greek_psi)) {
    sub GDK_Greek_psi () {	0x7f8;}
}
unless(defined(&GDK_Greek_omega)) {
    sub GDK_Greek_omega () {	0x7f9;}
}
unless(defined(&GDK_Greek_switch)) {
    sub GDK_Greek_switch () {	0xff7e;}
}
unless(defined(&GDK_leftradical)) {
    sub GDK_leftradical () {	0x8a1;}
}
unless(defined(&GDK_topleftradical)) {
    sub GDK_topleftradical () {	0x8a2;}
}
unless(defined(&GDK_horizconnector)) {
    sub GDK_horizconnector () {	0x8a3;}
}
unless(defined(&GDK_topintegral)) {
    sub GDK_topintegral () {	0x8a4;}
}
unless(defined(&GDK_botintegral)) {
    sub GDK_botintegral () {	0x8a5;}
}
unless(defined(&GDK_vertconnector)) {
    sub GDK_vertconnector () {	0x8a6;}
}
unless(defined(&GDK_topleftsqbracket)) {
    sub GDK_topleftsqbracket () {	0x8a7;}
}
unless(defined(&GDK_botleftsqbracket)) {
    sub GDK_botleftsqbracket () {	0x8a8;}
}
unless(defined(&GDK_toprightsqbracket)) {
    sub GDK_toprightsqbracket () {	0x8a9;}
}
unless(defined(&GDK_botrightsqbracket)) {
    sub GDK_botrightsqbracket () {	0x8aa;}
}
unless(defined(&GDK_topleftparens)) {
    sub GDK_topleftparens () {	0x8ab;}
}
unless(defined(&GDK_botleftparens)) {
    sub GDK_botleftparens () {	0x8ac;}
}
unless(defined(&GDK_toprightparens)) {
    sub GDK_toprightparens () {	0x8ad;}
}
unless(defined(&GDK_botrightparens)) {
    sub GDK_botrightparens () {	0x8ae;}
}
unless(defined(&GDK_leftmiddlecurlybrace)) {
    sub GDK_leftmiddlecurlybrace () {	0x8af;}
}
unless(defined(&GDK_rightmiddlecurlybrace)) {
    sub GDK_rightmiddlecurlybrace () {	0x8b0;}
}
unless(defined(&GDK_topleftsummation)) {
    sub GDK_topleftsummation () {	0x8b1;}
}
unless(defined(&GDK_botleftsummation)) {
    sub GDK_botleftsummation () {	0x8b2;}
}
unless(defined(&GDK_topvertsummationconnector)) {
    sub GDK_topvertsummationconnector () {	0x8b3;}
}
unless(defined(&GDK_botvertsummationconnector)) {
    sub GDK_botvertsummationconnector () {	0x8b4;}
}
unless(defined(&GDK_toprightsummation)) {
    sub GDK_toprightsummation () {	0x8b5;}
}
unless(defined(&GDK_botrightsummation)) {
    sub GDK_botrightsummation () {	0x8b6;}
}
unless(defined(&GDK_rightmiddlesummation)) {
    sub GDK_rightmiddlesummation () {	0x8b7;}
}
unless(defined(&GDK_lessthanequal)) {
    sub GDK_lessthanequal () {	0x8bc;}
}
unless(defined(&GDK_notequal)) {
    sub GDK_notequal () {	0x8bd;}
}
unless(defined(&GDK_greaterthanequal)) {
    sub GDK_greaterthanequal () {	0x8be;}
}
unless(defined(&GDK_integral)) {
    sub GDK_integral () {	0x8bf;}
}
unless(defined(&GDK_therefore)) {
    sub GDK_therefore () {	0x8c0;}
}
unless(defined(&GDK_variation)) {
    sub GDK_variation () {	0x8c1;}
}
unless(defined(&GDK_infinity)) {
    sub GDK_infinity () {	0x8c2;}
}
unless(defined(&GDK_nabla)) {
    sub GDK_nabla () {	0x8c5;}
}
unless(defined(&GDK_approximate)) {
    sub GDK_approximate () {	0x8c8;}
}
unless(defined(&GDK_similarequal)) {
    sub GDK_similarequal () {	0x8c9;}
}
unless(defined(&GDK_ifonlyif)) {
    sub GDK_ifonlyif () {	0x8cd;}
}
unless(defined(&GDK_implies)) {
    sub GDK_implies () {	0x8ce;}
}
unless(defined(&GDK_identical)) {
    sub GDK_identical () {	0x8cf;}
}
unless(defined(&GDK_radical)) {
    sub GDK_radical () {	0x8d6;}
}
unless(defined(&GDK_includedin)) {
    sub GDK_includedin () {	0x8da;}
}
unless(defined(&GDK_includes)) {
    sub GDK_includes () {	0x8db;}
}
unless(defined(&GDK_intersection)) {
    sub GDK_intersection () {	0x8dc;}
}
unless(defined(&GDK_union)) {
    sub GDK_union () {	0x8dd;}
}
unless(defined(&GDK_logicaland)) {
    sub GDK_logicaland () {	0x8de;}
}
unless(defined(&GDK_logicalor)) {
    sub GDK_logicalor () {	0x8df;}
}
unless(defined(&GDK_partialderivative)) {
    sub GDK_partialderivative () {	0x8ef;}
}
unless(defined(&GDK_function)) {
    sub GDK_function () {	0x8f6;}
}
unless(defined(&GDK_leftarrow)) {
    sub GDK_leftarrow () {	0x8fb;}
}
unless(defined(&GDK_uparrow)) {
    sub GDK_uparrow () {	0x8fc;}
}
unless(defined(&GDK_rightarrow)) {
    sub GDK_rightarrow () {	0x8fd;}
}
unless(defined(&GDK_downarrow)) {
    sub GDK_downarrow () {	0x8fe;}
}
unless(defined(&GDK_blank)) {
    sub GDK_blank () {	0x9df;}
}
unless(defined(&GDK_soliddiamond)) {
    sub GDK_soliddiamond () {	0x9e0;}
}
unless(defined(&GDK_checkerboard)) {
    sub GDK_checkerboard () {	0x9e1;}
}
unless(defined(&GDK_ht)) {
    sub GDK_ht () {	0x9e2;}
}
unless(defined(&GDK_ff)) {
    sub GDK_ff () {	0x9e3;}
}
unless(defined(&GDK_cr)) {
    sub GDK_cr () {	0x9e4;}
}
unless(defined(&GDK_lf)) {
    sub GDK_lf () {	0x9e5;}
}
unless(defined(&GDK_nl)) {
    sub GDK_nl () {	0x9e8;}
}
unless(defined(&GDK_vt)) {
    sub GDK_vt () {	0x9e9;}
}
unless(defined(&GDK_lowrightcorner)) {
    sub GDK_lowrightcorner () {	0x9ea;}
}
unless(defined(&GDK_uprightcorner)) {
    sub GDK_uprightcorner () {	0x9eb;}
}
unless(defined(&GDK_upleftcorner)) {
    sub GDK_upleftcorner () {	0x9ec;}
}
unless(defined(&GDK_lowleftcorner)) {
    sub GDK_lowleftcorner () {	0x9ed;}
}
unless(defined(&GDK_crossinglines)) {
    sub GDK_crossinglines () {	0x9ee;}
}
unless(defined(&GDK_horizlinescan1)) {
    sub GDK_horizlinescan1 () {	0x9ef;}
}
unless(defined(&GDK_horizlinescan3)) {
    sub GDK_horizlinescan3 () {	0x9f0;}
}
unless(defined(&GDK_horizlinescan5)) {
    sub GDK_horizlinescan5 () {	0x9f1;}
}
unless(defined(&GDK_horizlinescan7)) {
    sub GDK_horizlinescan7 () {	0x9f2;}
}
unless(defined(&GDK_horizlinescan9)) {
    sub GDK_horizlinescan9 () {	0x9f3;}
}
unless(defined(&GDK_leftt)) {
    sub GDK_leftt () {	0x9f4;}
}
unless(defined(&GDK_rightt)) {
    sub GDK_rightt () {	0x9f5;}
}
unless(defined(&GDK_bott)) {
    sub GDK_bott () {	0x9f6;}
}
unless(defined(&GDK_topt)) {
    sub GDK_topt () {	0x9f7;}
}
unless(defined(&GDK_vertbar)) {
    sub GDK_vertbar () {	0x9f8;}
}
unless(defined(&GDK_emspace)) {
    sub GDK_emspace () {	0xaa1;}
}
unless(defined(&GDK_enspace)) {
    sub GDK_enspace () {	0xaa2;}
}
unless(defined(&GDK_em3space)) {
    sub GDK_em3space () {	0xaa3;}
}
unless(defined(&GDK_em4space)) {
    sub GDK_em4space () {	0xaa4;}
}
unless(defined(&GDK_digitspace)) {
    sub GDK_digitspace () {	0xaa5;}
}
unless(defined(&GDK_punctspace)) {
    sub GDK_punctspace () {	0xaa6;}
}
unless(defined(&GDK_thinspace)) {
    sub GDK_thinspace () {	0xaa7;}
}
unless(defined(&GDK_hairspace)) {
    sub GDK_hairspace () {	0xaa8;}
}
unless(defined(&GDK_emdash)) {
    sub GDK_emdash () {	0xaa9;}
}
unless(defined(&GDK_endash)) {
    sub GDK_endash () {	0xaaa;}
}
unless(defined(&GDK_signifblank)) {
    sub GDK_signifblank () {	0xaac;}
}
unless(defined(&GDK_ellipsis)) {
    sub GDK_ellipsis () {	0xaae;}
}
unless(defined(&GDK_doubbaselinedot)) {
    sub GDK_doubbaselinedot () {	0xaaf;}
}
unless(defined(&GDK_onethird)) {
    sub GDK_onethird () {	0xab0;}
}
unless(defined(&GDK_twothirds)) {
    sub GDK_twothirds () {	0xab1;}
}
unless(defined(&GDK_onefifth)) {
    sub GDK_onefifth () {	0xab2;}
}
unless(defined(&GDK_twofifths)) {
    sub GDK_twofifths () {	0xab3;}
}
unless(defined(&GDK_threefifths)) {
    sub GDK_threefifths () {	0xab4;}
}
unless(defined(&GDK_fourfifths)) {
    sub GDK_fourfifths () {	0xab5;}
}
unless(defined(&GDK_onesixth)) {
    sub GDK_onesixth () {	0xab6;}
}
unless(defined(&GDK_fivesixths)) {
    sub GDK_fivesixths () {	0xab7;}
}
unless(defined(&GDK_careof)) {
    sub GDK_careof () {	0xab8;}
}
unless(defined(&GDK_figdash)) {
    sub GDK_figdash () {	0xabb;}
}
unless(defined(&GDK_leftanglebracket)) {
    sub GDK_leftanglebracket () {	0xabc;}
}
unless(defined(&GDK_decimalpoint)) {
    sub GDK_decimalpoint () {	0xabd;}
}
unless(defined(&GDK_rightanglebracket)) {
    sub GDK_rightanglebracket () {	0xabe;}
}
unless(defined(&GDK_marker)) {
    sub GDK_marker () {	0xabf;}
}
unless(defined(&GDK_oneeighth)) {
    sub GDK_oneeighth () {	0xac3;}
}
unless(defined(&GDK_threeeighths)) {
    sub GDK_threeeighths () {	0xac4;}
}
unless(defined(&GDK_fiveeighths)) {
    sub GDK_fiveeighths () {	0xac5;}
}
unless(defined(&GDK_seveneighths)) {
    sub GDK_seveneighths () {	0xac6;}
}
unless(defined(&GDK_trademark)) {
    sub GDK_trademark () {	0xac9;}
}
unless(defined(&GDK_signaturemark)) {
    sub GDK_signaturemark () {	0xaca;}
}
unless(defined(&GDK_trademarkincircle)) {
    sub GDK_trademarkincircle () {	0xacb;}
}
unless(defined(&GDK_leftopentriangle)) {
    sub GDK_leftopentriangle () {	0xacc;}
}
unless(defined(&GDK_rightopentriangle)) {
    sub GDK_rightopentriangle () {	0xacd;}
}
unless(defined(&GDK_emopencircle)) {
    sub GDK_emopencircle () {	0xace;}
}
unless(defined(&GDK_emopenrectangle)) {
    sub GDK_emopenrectangle () {	0xacf;}
}
unless(defined(&GDK_leftsinglequotemark)) {
    sub GDK_leftsinglequotemark () {	0xad0;}
}
unless(defined(&GDK_rightsinglequotemark)) {
    sub GDK_rightsinglequotemark () {	0xad1;}
}
unless(defined(&GDK_leftdoublequotemark)) {
    sub GDK_leftdoublequotemark () {	0xad2;}
}
unless(defined(&GDK_rightdoublequotemark)) {
    sub GDK_rightdoublequotemark () {	0xad3;}
}
unless(defined(&GDK_prescription)) {
    sub GDK_prescription () {	0xad4;}
}
unless(defined(&GDK_minutes)) {
    sub GDK_minutes () {	0xad6;}
}
unless(defined(&GDK_seconds)) {
    sub GDK_seconds () {	0xad7;}
}
unless(defined(&GDK_latincross)) {
    sub GDK_latincross () {	0xad9;}
}
unless(defined(&GDK_hexagram)) {
    sub GDK_hexagram () {	0xada;}
}
unless(defined(&GDK_filledrectbullet)) {
    sub GDK_filledrectbullet () {	0xadb;}
}
unless(defined(&GDK_filledlefttribullet)) {
    sub GDK_filledlefttribullet () {	0xadc;}
}
unless(defined(&GDK_filledrighttribullet)) {
    sub GDK_filledrighttribullet () {	0xadd;}
}
unless(defined(&GDK_emfilledcircle)) {
    sub GDK_emfilledcircle () {	0xade;}
}
unless(defined(&GDK_emfilledrect)) {
    sub GDK_emfilledrect () {	0xadf;}
}
unless(defined(&GDK_enopencircbullet)) {
    sub GDK_enopencircbullet () {	0xae0;}
}
unless(defined(&GDK_enopensquarebullet)) {
    sub GDK_enopensquarebullet () {	0xae1;}
}
unless(defined(&GDK_openrectbullet)) {
    sub GDK_openrectbullet () {	0xae2;}
}
unless(defined(&GDK_opentribulletup)) {
    sub GDK_opentribulletup () {	0xae3;}
}
unless(defined(&GDK_opentribulletdown)) {
    sub GDK_opentribulletdown () {	0xae4;}
}
unless(defined(&GDK_openstar)) {
    sub GDK_openstar () {	0xae5;}
}
unless(defined(&GDK_enfilledcircbullet)) {
    sub GDK_enfilledcircbullet () {	0xae6;}
}
unless(defined(&GDK_enfilledsqbullet)) {
    sub GDK_enfilledsqbullet () {	0xae7;}
}
unless(defined(&GDK_filledtribulletup)) {
    sub GDK_filledtribulletup () {	0xae8;}
}
unless(defined(&GDK_filledtribulletdown)) {
    sub GDK_filledtribulletdown () {	0xae9;}
}
unless(defined(&GDK_leftpointer)) {
    sub GDK_leftpointer () {	0xaea;}
}
unless(defined(&GDK_rightpointer)) {
    sub GDK_rightpointer () {	0xaeb;}
}
unless(defined(&GDK_club)) {
    sub GDK_club () {	0xaec;}
}
unless(defined(&GDK_diamond)) {
    sub GDK_diamond () {	0xaed;}
}
unless(defined(&GDK_heart)) {
    sub GDK_heart () {	0xaee;}
}
unless(defined(&GDK_maltesecross)) {
    sub GDK_maltesecross () {	0xaf0;}
}
unless(defined(&GDK_dagger)) {
    sub GDK_dagger () {	0xaf1;}
}
unless(defined(&GDK_doubledagger)) {
    sub GDK_doubledagger () {	0xaf2;}
}
unless(defined(&GDK_checkmark)) {
    sub GDK_checkmark () {	0xaf3;}
}
unless(defined(&GDK_ballotcross)) {
    sub GDK_ballotcross () {	0xaf4;}
}
unless(defined(&GDK_musicalsharp)) {
    sub GDK_musicalsharp () {	0xaf5;}
}
unless(defined(&GDK_musicalflat)) {
    sub GDK_musicalflat () {	0xaf6;}
}
unless(defined(&GDK_malesymbol)) {
    sub GDK_malesymbol () {	0xaf7;}
}
unless(defined(&GDK_femalesymbol)) {
    sub GDK_femalesymbol () {	0xaf8;}
}
unless(defined(&GDK_telephone)) {
    sub GDK_telephone () {	0xaf9;}
}
unless(defined(&GDK_telephonerecorder)) {
    sub GDK_telephonerecorder () {	0xafa;}
}
unless(defined(&GDK_phonographcopyright)) {
    sub GDK_phonographcopyright () {	0xafb;}
}
unless(defined(&GDK_caret)) {
    sub GDK_caret () {	0xafc;}
}
unless(defined(&GDK_singlelowquotemark)) {
    sub GDK_singlelowquotemark () {	0xafd;}
}
unless(defined(&GDK_doublelowquotemark)) {
    sub GDK_doublelowquotemark () {	0xafe;}
}
unless(defined(&GDK_cursor)) {
    sub GDK_cursor () {	0xaff;}
}
unless(defined(&GDK_leftcaret)) {
    sub GDK_leftcaret () {	0xba3;}
}
unless(defined(&GDK_rightcaret)) {
    sub GDK_rightcaret () {	0xba6;}
}
unless(defined(&GDK_downcaret)) {
    sub GDK_downcaret () {	0xba8;}
}
unless(defined(&GDK_upcaret)) {
    sub GDK_upcaret () {	0xba9;}
}
unless(defined(&GDK_overbar)) {
    sub GDK_overbar () {	0xbc0;}
}
unless(defined(&GDK_downtack)) {
    sub GDK_downtack () {	0xbc2;}
}
unless(defined(&GDK_upshoe)) {
    sub GDK_upshoe () {	0xbc3;}
}
unless(defined(&GDK_downstile)) {
    sub GDK_downstile () {	0xbc4;}
}
unless(defined(&GDK_underbar)) {
    sub GDK_underbar () {	0xbc6;}
}
unless(defined(&GDK_jot)) {
    sub GDK_jot () {	0xbca;}
}
unless(defined(&GDK_quad)) {
    sub GDK_quad () {	0xbcc;}
}
unless(defined(&GDK_uptack)) {
    sub GDK_uptack () {	0xbce;}
}
unless(defined(&GDK_circle)) {
    sub GDK_circle () {	0xbcf;}
}
unless(defined(&GDK_upstile)) {
    sub GDK_upstile () {	0xbd3;}
}
unless(defined(&GDK_downshoe)) {
    sub GDK_downshoe () {	0xbd6;}
}
unless(defined(&GDK_rightshoe)) {
    sub GDK_rightshoe () {	0xbd8;}
}
unless(defined(&GDK_leftshoe)) {
    sub GDK_leftshoe () {	0xbda;}
}
unless(defined(&GDK_lefttack)) {
    sub GDK_lefttack () {	0xbdc;}
}
unless(defined(&GDK_righttack)) {
    sub GDK_righttack () {	0xbfc;}
}
unless(defined(&GDK_hebrew_doublelowline)) {
    sub GDK_hebrew_doublelowline () {	0xcdf;}
}
unless(defined(&GDK_hebrew_aleph)) {
    sub GDK_hebrew_aleph () {	0xce0;}
}
unless(defined(&GDK_hebrew_bet)) {
    sub GDK_hebrew_bet () {	0xce1;}
}
unless(defined(&GDK_hebrew_beth)) {
    sub GDK_hebrew_beth () {	0xce1;}
}
unless(defined(&GDK_hebrew_gimel)) {
    sub GDK_hebrew_gimel () {	0xce2;}
}
unless(defined(&GDK_hebrew_gimmel)) {
    sub GDK_hebrew_gimmel () {	0xce2;}
}
unless(defined(&GDK_hebrew_dalet)) {
    sub GDK_hebrew_dalet () {	0xce3;}
}
unless(defined(&GDK_hebrew_daleth)) {
    sub GDK_hebrew_daleth () {	0xce3;}
}
unless(defined(&GDK_hebrew_he)) {
    sub GDK_hebrew_he () {	0xce4;}
}
unless(defined(&GDK_hebrew_waw)) {
    sub GDK_hebrew_waw () {	0xce5;}
}
unless(defined(&GDK_hebrew_zain)) {
    sub GDK_hebrew_zain () {	0xce6;}
}
unless(defined(&GDK_hebrew_zayin)) {
    sub GDK_hebrew_zayin () {	0xce6;}
}
unless(defined(&GDK_hebrew_chet)) {
    sub GDK_hebrew_chet () {	0xce7;}
}
unless(defined(&GDK_hebrew_het)) {
    sub GDK_hebrew_het () {	0xce7;}
}
unless(defined(&GDK_hebrew_tet)) {
    sub GDK_hebrew_tet () {	0xce8;}
}
unless(defined(&GDK_hebrew_teth)) {
    sub GDK_hebrew_teth () {	0xce8;}
}
unless(defined(&GDK_hebrew_yod)) {
    sub GDK_hebrew_yod () {	0xce9;}
}
unless(defined(&GDK_hebrew_finalkaph)) {
    sub GDK_hebrew_finalkaph () {	0xcea;}
}
unless(defined(&GDK_hebrew_kaph)) {
    sub GDK_hebrew_kaph () {	0xceb;}
}
unless(defined(&GDK_hebrew_lamed)) {
    sub GDK_hebrew_lamed () {	0xcec;}
}
unless(defined(&GDK_hebrew_finalmem)) {
    sub GDK_hebrew_finalmem () {	0xced;}
}
unless(defined(&GDK_hebrew_mem)) {
    sub GDK_hebrew_mem () {	0xcee;}
}
unless(defined(&GDK_hebrew_finalnun)) {
    sub GDK_hebrew_finalnun () {	0xcef;}
}
unless(defined(&GDK_hebrew_nun)) {
    sub GDK_hebrew_nun () {	0xcf0;}
}
unless(defined(&GDK_hebrew_samech)) {
    sub GDK_hebrew_samech () {	0xcf1;}
}
unless(defined(&GDK_hebrew_samekh)) {
    sub GDK_hebrew_samekh () {	0xcf1;}
}
unless(defined(&GDK_hebrew_ayin)) {
    sub GDK_hebrew_ayin () {	0xcf2;}
}
unless(defined(&GDK_hebrew_finalpe)) {
    sub GDK_hebrew_finalpe () {	0xcf3;}
}
unless(defined(&GDK_hebrew_pe)) {
    sub GDK_hebrew_pe () {	0xcf4;}
}
unless(defined(&GDK_hebrew_finalzade)) {
    sub GDK_hebrew_finalzade () {	0xcf5;}
}
unless(defined(&GDK_hebrew_finalzadi)) {
    sub GDK_hebrew_finalzadi () {	0xcf5;}
}
unless(defined(&GDK_hebrew_zade)) {
    sub GDK_hebrew_zade () {	0xcf6;}
}
unless(defined(&GDK_hebrew_zadi)) {
    sub GDK_hebrew_zadi () {	0xcf6;}
}
unless(defined(&GDK_hebrew_qoph)) {
    sub GDK_hebrew_qoph () {	0xcf7;}
}
unless(defined(&GDK_hebrew_kuf)) {
    sub GDK_hebrew_kuf () {	0xcf7;}
}
unless(defined(&GDK_hebrew_resh)) {
    sub GDK_hebrew_resh () {	0xcf8;}
}
unless(defined(&GDK_hebrew_shin)) {
    sub GDK_hebrew_shin () {	0xcf9;}
}
unless(defined(&GDK_hebrew_taw)) {
    sub GDK_hebrew_taw () {	0xcfa;}
}
unless(defined(&GDK_hebrew_taf)) {
    sub GDK_hebrew_taf () {	0xcfa;}
}
unless(defined(&GDK_Hebrew_switch)) {
    sub GDK_Hebrew_switch () {	0xff7e;}
}
unless(defined(&GDK_Thai_kokai)) {
    sub GDK_Thai_kokai () {	0xda1;}
}
unless(defined(&GDK_Thai_khokhai)) {
    sub GDK_Thai_khokhai () {	0xda2;}
}
unless(defined(&GDK_Thai_khokhuat)) {
    sub GDK_Thai_khokhuat () {	0xda3;}
}
unless(defined(&GDK_Thai_khokhwai)) {
    sub GDK_Thai_khokhwai () {	0xda4;}
}
unless(defined(&GDK_Thai_khokhon)) {
    sub GDK_Thai_khokhon () {	0xda5;}
}
unless(defined(&GDK_Thai_khorakhang)) {
    sub GDK_Thai_khorakhang () {	0xda6;}
}
unless(defined(&GDK_Thai_ngongu)) {
    sub GDK_Thai_ngongu () {	0xda7;}
}
unless(defined(&GDK_Thai_chochan)) {
    sub GDK_Thai_chochan () {	0xda8;}
}
unless(defined(&GDK_Thai_choching)) {
    sub GDK_Thai_choching () {	0xda9;}
}
unless(defined(&GDK_Thai_chochang)) {
    sub GDK_Thai_chochang () {	0xdaa;}
}
unless(defined(&GDK_Thai_soso)) {
    sub GDK_Thai_soso () {	0xdab;}
}
unless(defined(&GDK_Thai_chochoe)) {
    sub GDK_Thai_chochoe () {	0xdac;}
}
unless(defined(&GDK_Thai_yoying)) {
    sub GDK_Thai_yoying () {	0xdad;}
}
unless(defined(&GDK_Thai_dochada)) {
    sub GDK_Thai_dochada () {	0xdae;}
}
unless(defined(&GDK_Thai_topatak)) {
    sub GDK_Thai_topatak () {	0xdaf;}
}
unless(defined(&GDK_Thai_thothan)) {
    sub GDK_Thai_thothan () {	0xdb0;}
}
unless(defined(&GDK_Thai_thonangmontho)) {
    sub GDK_Thai_thonangmontho () {	0xdb1;}
}
unless(defined(&GDK_Thai_thophuthao)) {
    sub GDK_Thai_thophuthao () {	0xdb2;}
}
unless(defined(&GDK_Thai_nonen)) {
    sub GDK_Thai_nonen () {	0xdb3;}
}
unless(defined(&GDK_Thai_dodek)) {
    sub GDK_Thai_dodek () {	0xdb4;}
}
unless(defined(&GDK_Thai_totao)) {
    sub GDK_Thai_totao () {	0xdb5;}
}
unless(defined(&GDK_Thai_thothung)) {
    sub GDK_Thai_thothung () {	0xdb6;}
}
unless(defined(&GDK_Thai_thothahan)) {
    sub GDK_Thai_thothahan () {	0xdb7;}
}
unless(defined(&GDK_Thai_thothong)) {
    sub GDK_Thai_thothong () {	0xdb8;}
}
unless(defined(&GDK_Thai_nonu)) {
    sub GDK_Thai_nonu () {	0xdb9;}
}
unless(defined(&GDK_Thai_bobaimai)) {
    sub GDK_Thai_bobaimai () {	0xdba;}
}
unless(defined(&GDK_Thai_popla)) {
    sub GDK_Thai_popla () {	0xdbb;}
}
unless(defined(&GDK_Thai_phophung)) {
    sub GDK_Thai_phophung () {	0xdbc;}
}
unless(defined(&GDK_Thai_fofa)) {
    sub GDK_Thai_fofa () {	0xdbd;}
}
unless(defined(&GDK_Thai_phophan)) {
    sub GDK_Thai_phophan () {	0xdbe;}
}
unless(defined(&GDK_Thai_fofan)) {
    sub GDK_Thai_fofan () {	0xdbf;}
}
unless(defined(&GDK_Thai_phosamphao)) {
    sub GDK_Thai_phosamphao () {	0xdc0;}
}
unless(defined(&GDK_Thai_moma)) {
    sub GDK_Thai_moma () {	0xdc1;}
}
unless(defined(&GDK_Thai_yoyak)) {
    sub GDK_Thai_yoyak () {	0xdc2;}
}
unless(defined(&GDK_Thai_rorua)) {
    sub GDK_Thai_rorua () {	0xdc3;}
}
unless(defined(&GDK_Thai_ru)) {
    sub GDK_Thai_ru () {	0xdc4;}
}
unless(defined(&GDK_Thai_loling)) {
    sub GDK_Thai_loling () {	0xdc5;}
}
unless(defined(&GDK_Thai_lu)) {
    sub GDK_Thai_lu () {	0xdc6;}
}
unless(defined(&GDK_Thai_wowaen)) {
    sub GDK_Thai_wowaen () {	0xdc7;}
}
unless(defined(&GDK_Thai_sosala)) {
    sub GDK_Thai_sosala () {	0xdc8;}
}
unless(defined(&GDK_Thai_sorusi)) {
    sub GDK_Thai_sorusi () {	0xdc9;}
}
unless(defined(&GDK_Thai_sosua)) {
    sub GDK_Thai_sosua () {	0xdca;}
}
unless(defined(&GDK_Thai_hohip)) {
    sub GDK_Thai_hohip () {	0xdcb;}
}
unless(defined(&GDK_Thai_lochula)) {
    sub GDK_Thai_lochula () {	0xdcc;}
}
unless(defined(&GDK_Thai_oang)) {
    sub GDK_Thai_oang () {	0xdcd;}
}
unless(defined(&GDK_Thai_honokhuk)) {
    sub GDK_Thai_honokhuk () {	0xdce;}
}
unless(defined(&GDK_Thai_paiyannoi)) {
    sub GDK_Thai_paiyannoi () {	0xdcf;}
}
unless(defined(&GDK_Thai_saraa)) {
    sub GDK_Thai_saraa () {	0xdd0;}
}
unless(defined(&GDK_Thai_maihanakat)) {
    sub GDK_Thai_maihanakat () {	0xdd1;}
}
unless(defined(&GDK_Thai_saraaa)) {
    sub GDK_Thai_saraaa () {	0xdd2;}
}
unless(defined(&GDK_Thai_saraam)) {
    sub GDK_Thai_saraam () {	0xdd3;}
}
unless(defined(&GDK_Thai_sarai)) {
    sub GDK_Thai_sarai () {	0xdd4;}
}
unless(defined(&GDK_Thai_saraii)) {
    sub GDK_Thai_saraii () {	0xdd5;}
}
unless(defined(&GDK_Thai_saraue)) {
    sub GDK_Thai_saraue () {	0xdd6;}
}
unless(defined(&GDK_Thai_sarauee)) {
    sub GDK_Thai_sarauee () {	0xdd7;}
}
unless(defined(&GDK_Thai_sarau)) {
    sub GDK_Thai_sarau () {	0xdd8;}
}
unless(defined(&GDK_Thai_sarauu)) {
    sub GDK_Thai_sarauu () {	0xdd9;}
}
unless(defined(&GDK_Thai_phinthu)) {
    sub GDK_Thai_phinthu () {	0xdda;}
}
unless(defined(&GDK_Thai_maihanakat_maitho)) {
    sub GDK_Thai_maihanakat_maitho () {	0xdde;}
}
unless(defined(&GDK_Thai_baht)) {
    sub GDK_Thai_baht () {	0xddf;}
}
unless(defined(&GDK_Thai_sarae)) {
    sub GDK_Thai_sarae () {	0xde0;}
}
unless(defined(&GDK_Thai_saraae)) {
    sub GDK_Thai_saraae () {	0xde1;}
}
unless(defined(&GDK_Thai_sarao)) {
    sub GDK_Thai_sarao () {	0xde2;}
}
unless(defined(&GDK_Thai_saraaimaimuan)) {
    sub GDK_Thai_saraaimaimuan () {	0xde3;}
}
unless(defined(&GDK_Thai_saraaimaimalai)) {
    sub GDK_Thai_saraaimaimalai () {	0xde4;}
}
unless(defined(&GDK_Thai_lakkhangyao)) {
    sub GDK_Thai_lakkhangyao () {	0xde5;}
}
unless(defined(&GDK_Thai_maiyamok)) {
    sub GDK_Thai_maiyamok () {	0xde6;}
}
unless(defined(&GDK_Thai_maitaikhu)) {
    sub GDK_Thai_maitaikhu () {	0xde7;}
}
unless(defined(&GDK_Thai_maiek)) {
    sub GDK_Thai_maiek () {	0xde8;}
}
unless(defined(&GDK_Thai_maitho)) {
    sub GDK_Thai_maitho () {	0xde9;}
}
unless(defined(&GDK_Thai_maitri)) {
    sub GDK_Thai_maitri () {	0xdea;}
}
unless(defined(&GDK_Thai_maichattawa)) {
    sub GDK_Thai_maichattawa () {	0xdeb;}
}
unless(defined(&GDK_Thai_thanthakhat)) {
    sub GDK_Thai_thanthakhat () {	0xdec;}
}
unless(defined(&GDK_Thai_nikhahit)) {
    sub GDK_Thai_nikhahit () {	0xded;}
}
unless(defined(&GDK_Thai_leksun)) {
    sub GDK_Thai_leksun () {	0xdf0;}
}
unless(defined(&GDK_Thai_leknung)) {
    sub GDK_Thai_leknung () {	0xdf1;}
}
unless(defined(&GDK_Thai_leksong)) {
    sub GDK_Thai_leksong () {	0xdf2;}
}
unless(defined(&GDK_Thai_leksam)) {
    sub GDK_Thai_leksam () {	0xdf3;}
}
unless(defined(&GDK_Thai_leksi)) {
    sub GDK_Thai_leksi () {	0xdf4;}
}
unless(defined(&GDK_Thai_lekha)) {
    sub GDK_Thai_lekha () {	0xdf5;}
}
unless(defined(&GDK_Thai_lekhok)) {
    sub GDK_Thai_lekhok () {	0xdf6;}
}
unless(defined(&GDK_Thai_lekchet)) {
    sub GDK_Thai_lekchet () {	0xdf7;}
}
unless(defined(&GDK_Thai_lekpaet)) {
    sub GDK_Thai_lekpaet () {	0xdf8;}
}
unless(defined(&GDK_Thai_lekkao)) {
    sub GDK_Thai_lekkao () {	0xdf9;}
}
unless(defined(&GDK_Hangul)) {
    sub GDK_Hangul () {	0xff31;}
}
unless(defined(&GDK_Hangul_Start)) {
    sub GDK_Hangul_Start () {	0xff32;}
}
unless(defined(&GDK_Hangul_End)) {
    sub GDK_Hangul_End () {	0xff33;}
}
unless(defined(&GDK_Hangul_Hanja)) {
    sub GDK_Hangul_Hanja () {	0xff34;}
}
unless(defined(&GDK_Hangul_Jamo)) {
    sub GDK_Hangul_Jamo () {	0xff35;}
}
unless(defined(&GDK_Hangul_Romaja)) {
    sub GDK_Hangul_Romaja () {	0xff36;}
}
unless(defined(&GDK_Hangul_Codeinput)) {
    sub GDK_Hangul_Codeinput () {	0xff37;}
}
unless(defined(&GDK_Hangul_Jeonja)) {
    sub GDK_Hangul_Jeonja () {	0xff38;}
}
unless(defined(&GDK_Hangul_Banja)) {
    sub GDK_Hangul_Banja () {	0xff39;}
}
unless(defined(&GDK_Hangul_PreHanja)) {
    sub GDK_Hangul_PreHanja () {	0xff3a;}
}
unless(defined(&GDK_Hangul_PostHanja)) {
    sub GDK_Hangul_PostHanja () {	0xff3b;}
}
unless(defined(&GDK_Hangul_SingleCandidate)) {
    sub GDK_Hangul_SingleCandidate () {	0xff3c;}
}
unless(defined(&GDK_Hangul_MultipleCandidate)) {
    sub GDK_Hangul_MultipleCandidate () {	0xff3d;}
}
unless(defined(&GDK_Hangul_PreviousCandidate)) {
    sub GDK_Hangul_PreviousCandidate () {	0xff3e;}
}
unless(defined(&GDK_Hangul_Special)) {
    sub GDK_Hangul_Special () {	0xff3f;}
}
unless(defined(&GDK_Hangul_switch)) {
    sub GDK_Hangul_switch () {	0xff7e;}
}
unless(defined(&GDK_Hangul_Kiyeog)) {
    sub GDK_Hangul_Kiyeog () {	0xea1;}
}
unless(defined(&GDK_Hangul_SsangKiyeog)) {
    sub GDK_Hangul_SsangKiyeog () {	0xea2;}
}
unless(defined(&GDK_Hangul_KiyeogSios)) {
    sub GDK_Hangul_KiyeogSios () {	0xea3;}
}
unless(defined(&GDK_Hangul_Nieun)) {
    sub GDK_Hangul_Nieun () {	0xea4;}
}
unless(defined(&GDK_Hangul_NieunJieuj)) {
    sub GDK_Hangul_NieunJieuj () {	0xea5;}
}
unless(defined(&GDK_Hangul_NieunHieuh)) {
    sub GDK_Hangul_NieunHieuh () {	0xea6;}
}
unless(defined(&GDK_Hangul_Dikeud)) {
    sub GDK_Hangul_Dikeud () {	0xea7;}
}
unless(defined(&GDK_Hangul_SsangDikeud)) {
    sub GDK_Hangul_SsangDikeud () {	0xea8;}
}
unless(defined(&GDK_Hangul_Rieul)) {
    sub GDK_Hangul_Rieul () {	0xea9;}
}
unless(defined(&GDK_Hangul_RieulKiyeog)) {
    sub GDK_Hangul_RieulKiyeog () {	0xeaa;}
}
unless(defined(&GDK_Hangul_RieulMieum)) {
    sub GDK_Hangul_RieulMieum () {	0xeab;}
}
unless(defined(&GDK_Hangul_RieulPieub)) {
    sub GDK_Hangul_RieulPieub () {	0xeac;}
}
unless(defined(&GDK_Hangul_RieulSios)) {
    sub GDK_Hangul_RieulSios () {	0xead;}
}
unless(defined(&GDK_Hangul_RieulTieut)) {
    sub GDK_Hangul_RieulTieut () {	0xeae;}
}
unless(defined(&GDK_Hangul_RieulPhieuf)) {
    sub GDK_Hangul_RieulPhieuf () {	0xeaf;}
}
unless(defined(&GDK_Hangul_RieulHieuh)) {
    sub GDK_Hangul_RieulHieuh () {	0xeb0;}
}
unless(defined(&GDK_Hangul_Mieum)) {
    sub GDK_Hangul_Mieum () {	0xeb1;}
}
unless(defined(&GDK_Hangul_Pieub)) {
    sub GDK_Hangul_Pieub () {	0xeb2;}
}
unless(defined(&GDK_Hangul_SsangPieub)) {
    sub GDK_Hangul_SsangPieub () {	0xeb3;}
}
unless(defined(&GDK_Hangul_PieubSios)) {
    sub GDK_Hangul_PieubSios () {	0xeb4;}
}
unless(defined(&GDK_Hangul_Sios)) {
    sub GDK_Hangul_Sios () {	0xeb5;}
}
unless(defined(&GDK_Hangul_SsangSios)) {
    sub GDK_Hangul_SsangSios () {	0xeb6;}
}
unless(defined(&GDK_Hangul_Ieung)) {
    sub GDK_Hangul_Ieung () {	0xeb7;}
}
unless(defined(&GDK_Hangul_Jieuj)) {
    sub GDK_Hangul_Jieuj () {	0xeb8;}
}
unless(defined(&GDK_Hangul_SsangJieuj)) {
    sub GDK_Hangul_SsangJieuj () {	0xeb9;}
}
unless(defined(&GDK_Hangul_Cieuc)) {
    sub GDK_Hangul_Cieuc () {	0xeba;}
}
unless(defined(&GDK_Hangul_Khieuq)) {
    sub GDK_Hangul_Khieuq () {	0xebb;}
}
unless(defined(&GDK_Hangul_Tieut)) {
    sub GDK_Hangul_Tieut () {	0xebc;}
}
unless(defined(&GDK_Hangul_Phieuf)) {
    sub GDK_Hangul_Phieuf () {	0xebd;}
}
unless(defined(&GDK_Hangul_Hieuh)) {
    sub GDK_Hangul_Hieuh () {	0xebe;}
}
unless(defined(&GDK_Hangul_A)) {
    sub GDK_Hangul_A () {	0xebf;}
}
unless(defined(&GDK_Hangul_AE)) {
    sub GDK_Hangul_AE () {	0xec0;}
}
unless(defined(&GDK_Hangul_YA)) {
    sub GDK_Hangul_YA () {	0xec1;}
}
unless(defined(&GDK_Hangul_YAE)) {
    sub GDK_Hangul_YAE () {	0xec2;}
}
unless(defined(&GDK_Hangul_EO)) {
    sub GDK_Hangul_EO () {	0xec3;}
}
unless(defined(&GDK_Hangul_E)) {
    sub GDK_Hangul_E () {	0xec4;}
}
unless(defined(&GDK_Hangul_YEO)) {
    sub GDK_Hangul_YEO () {	0xec5;}
}
unless(defined(&GDK_Hangul_YE)) {
    sub GDK_Hangul_YE () {	0xec6;}
}
unless(defined(&GDK_Hangul_O)) {
    sub GDK_Hangul_O () {	0xec7;}
}
unless(defined(&GDK_Hangul_WA)) {
    sub GDK_Hangul_WA () {	0xec8;}
}
unless(defined(&GDK_Hangul_WAE)) {
    sub GDK_Hangul_WAE () {	0xec9;}
}
unless(defined(&GDK_Hangul_OE)) {
    sub GDK_Hangul_OE () {	0xeca;}
}
unless(defined(&GDK_Hangul_YO)) {
    sub GDK_Hangul_YO () {	0xecb;}
}
unless(defined(&GDK_Hangul_U)) {
    sub GDK_Hangul_U () {	0xecc;}
}
unless(defined(&GDK_Hangul_WEO)) {
    sub GDK_Hangul_WEO () {	0xecd;}
}
unless(defined(&GDK_Hangul_WE)) {
    sub GDK_Hangul_WE () {	0xece;}
}
unless(defined(&GDK_Hangul_WI)) {
    sub GDK_Hangul_WI () {	0xecf;}
}
unless(defined(&GDK_Hangul_YU)) {
    sub GDK_Hangul_YU () {	0xed0;}
}
unless(defined(&GDK_Hangul_EU)) {
    sub GDK_Hangul_EU () {	0xed1;}
}
unless(defined(&GDK_Hangul_YI)) {
    sub GDK_Hangul_YI () {	0xed2;}
}
unless(defined(&GDK_Hangul_I)) {
    sub GDK_Hangul_I () {	0xed3;}
}
unless(defined(&GDK_Hangul_J_Kiyeog)) {
    sub GDK_Hangul_J_Kiyeog () {	0xed4;}
}
unless(defined(&GDK_Hangul_J_SsangKiyeog)) {
    sub GDK_Hangul_J_SsangKiyeog () {	0xed5;}
}
unless(defined(&GDK_Hangul_J_KiyeogSios)) {
    sub GDK_Hangul_J_KiyeogSios () {	0xed6;}
}
unless(defined(&GDK_Hangul_J_Nieun)) {
    sub GDK_Hangul_J_Nieun () {	0xed7;}
}
unless(defined(&GDK_Hangul_J_NieunJieuj)) {
    sub GDK_Hangul_J_NieunJieuj () {	0xed8;}
}
unless(defined(&GDK_Hangul_J_NieunHieuh)) {
    sub GDK_Hangul_J_NieunHieuh () {	0xed9;}
}
unless(defined(&GDK_Hangul_J_Dikeud)) {
    sub GDK_Hangul_J_Dikeud () {	0xeda;}
}
unless(defined(&GDK_Hangul_J_Rieul)) {
    sub GDK_Hangul_J_Rieul () {	0xedb;}
}
unless(defined(&GDK_Hangul_J_RieulKiyeog)) {
    sub GDK_Hangul_J_RieulKiyeog () {	0xedc;}
}
unless(defined(&GDK_Hangul_J_RieulMieum)) {
    sub GDK_Hangul_J_RieulMieum () {	0xedd;}
}
unless(defined(&GDK_Hangul_J_RieulPieub)) {
    sub GDK_Hangul_J_RieulPieub () {	0xede;}
}
unless(defined(&GDK_Hangul_J_RieulSios)) {
    sub GDK_Hangul_J_RieulSios () {	0xedf;}
}
unless(defined(&GDK_Hangul_J_RieulTieut)) {
    sub GDK_Hangul_J_RieulTieut () {	0xee0;}
}
unless(defined(&GDK_Hangul_J_RieulPhieuf)) {
    sub GDK_Hangul_J_RieulPhieuf () {	0xee1;}
}
unless(defined(&GDK_Hangul_J_RieulHieuh)) {
    sub GDK_Hangul_J_RieulHieuh () {	0xee2;}
}
unless(defined(&GDK_Hangul_J_Mieum)) {
    sub GDK_Hangul_J_Mieum () {	0xee3;}
}
unless(defined(&GDK_Hangul_J_Pieub)) {
    sub GDK_Hangul_J_Pieub () {	0xee4;}
}
unless(defined(&GDK_Hangul_J_PieubSios)) {
    sub GDK_Hangul_J_PieubSios () {	0xee5;}
}
unless(defined(&GDK_Hangul_J_Sios)) {
    sub GDK_Hangul_J_Sios () {	0xee6;}
}
unless(defined(&GDK_Hangul_J_SsangSios)) {
    sub GDK_Hangul_J_SsangSios () {	0xee7;}
}
unless(defined(&GDK_Hangul_J_Ieung)) {
    sub GDK_Hangul_J_Ieung () {	0xee8;}
}
unless(defined(&GDK_Hangul_J_Jieuj)) {
    sub GDK_Hangul_J_Jieuj () {	0xee9;}
}
unless(defined(&GDK_Hangul_J_Cieuc)) {
    sub GDK_Hangul_J_Cieuc () {	0xeea;}
}
unless(defined(&GDK_Hangul_J_Khieuq)) {
    sub GDK_Hangul_J_Khieuq () {	0xeeb;}
}
unless(defined(&GDK_Hangul_J_Tieut)) {
    sub GDK_Hangul_J_Tieut () {	0xeec;}
}
unless(defined(&GDK_Hangul_J_Phieuf)) {
    sub GDK_Hangul_J_Phieuf () {	0xeed;}
}
unless(defined(&GDK_Hangul_J_Hieuh)) {
    sub GDK_Hangul_J_Hieuh () {	0xeee;}
}
unless(defined(&GDK_Hangul_RieulYeorinHieuh)) {
    sub GDK_Hangul_RieulYeorinHieuh () {	0xeef;}
}
unless(defined(&GDK_Hangul_SunkyeongeumMieum)) {
    sub GDK_Hangul_SunkyeongeumMieum () {	0xef0;}
}
unless(defined(&GDK_Hangul_SunkyeongeumPieub)) {
    sub GDK_Hangul_SunkyeongeumPieub () {	0xef1;}
}
unless(defined(&GDK_Hangul_PanSios)) {
    sub GDK_Hangul_PanSios () {	0xef2;}
}
unless(defined(&GDK_Hangul_KkogjiDalrinIeung)) {
    sub GDK_Hangul_KkogjiDalrinIeung () {	0xef3;}
}
unless(defined(&GDK_Hangul_SunkyeongeumPhieuf)) {
    sub GDK_Hangul_SunkyeongeumPhieuf () {	0xef4;}
}
unless(defined(&GDK_Hangul_YeorinHieuh)) {
    sub GDK_Hangul_YeorinHieuh () {	0xef5;}
}
unless(defined(&GDK_Hangul_AraeA)) {
    sub GDK_Hangul_AraeA () {	0xef6;}
}
unless(defined(&GDK_Hangul_AraeAE)) {
    sub GDK_Hangul_AraeAE () {	0xef7;}
}
unless(defined(&GDK_Hangul_J_PanSios)) {
    sub GDK_Hangul_J_PanSios () {	0xef8;}
}
unless(defined(&GDK_Hangul_J_KkogjiDalrinIeung)) {
    sub GDK_Hangul_J_KkogjiDalrinIeung () {	0xef9;}
}
unless(defined(&GDK_Hangul_J_YeorinHieuh)) {
    sub GDK_Hangul_J_YeorinHieuh () {	0xefa;}
}
unless(defined(&GDK_Korean_Won)) {
    sub GDK_Korean_Won () {	0xeff;}
}
1;
