require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GDK_TYPES_H__)) {
    eval 'sub __GDK_TYPES_H__ () {1;}' unless defined(&__GDK_TYPES_H__);
    require 'glib.ph';
    eval 'sub GDK_NONE () {0;}' unless defined(&GDK_NONE);
    eval 'sub GDK_CURRENT_TIME () {0;}' unless defined(&GDK_CURRENT_TIME);
    eval 'sub GDK_PARENT_RELATIVE () {1;}' unless defined(&GDK_PARENT_RELATIVE);
    eval 'sub GDK_CORE_POINTER () {0xfedc;}' unless defined(&GDK_CORE_POINTER);
    if(defined(&__cplusplus)) {
    }
    eval("sub GDK_WINDOW_ROOT () { 0; }") unless defined(&GDK_WINDOW_ROOT);
    eval("sub GDK_WINDOW_TOPLEVEL () { 1; }") unless defined(&GDK_WINDOW_TOPLEVEL);
    eval("sub GDK_WINDOW_CHILD () { 2; }") unless defined(&GDK_WINDOW_CHILD);
    eval("sub GDK_WINDOW_DIALOG () { 3; }") unless defined(&GDK_WINDOW_DIALOG);
    eval("sub GDK_WINDOW_TEMP () { 4; }") unless defined(&GDK_WINDOW_TEMP);
    eval("sub GDK_WINDOW_PIXMAP () { 5; }") unless defined(&GDK_WINDOW_PIXMAP);
    eval("sub GDK_WINDOW_FOREIGN () { 6; }") unless defined(&GDK_WINDOW_FOREIGN);
    eval("sub GDK_INPUT_OUTPUT () { 0; }") unless defined(&GDK_INPUT_OUTPUT);
    eval("sub GDK_INPUT_ONLY () { 1; }") unless defined(&GDK_INPUT_ONLY);
    eval("sub GDK_IMAGE_NORMAL () { 0; }") unless defined(&GDK_IMAGE_NORMAL);
    eval("sub GDK_IMAGE_SHARED () { 1; }") unless defined(&GDK_IMAGE_SHARED);
    eval("sub GDK_IMAGE_FASTEST () { 2; }") unless defined(&GDK_IMAGE_FASTEST);
    eval("sub GDK_VISUAL_STATIC_GRAY () { 0; }") unless defined(&GDK_VISUAL_STATIC_GRAY);
    eval("sub GDK_VISUAL_GRAYSCALE () { 1; }") unless defined(&GDK_VISUAL_GRAYSCALE);
    eval("sub GDK_VISUAL_STATIC_COLOR () { 2; }") unless defined(&GDK_VISUAL_STATIC_COLOR);
    eval("sub GDK_VISUAL_PSEUDO_COLOR () { 3; }") unless defined(&GDK_VISUAL_PSEUDO_COLOR);
    eval("sub GDK_VISUAL_TRUE_COLOR () { 4; }") unless defined(&GDK_VISUAL_TRUE_COLOR);
    eval("sub GDK_VISUAL_DIRECT_COLOR () { 5; }") unless defined(&GDK_VISUAL_DIRECT_COLOR);
    eval("sub GDK_FONT_FONT () { 0; }") unless defined(&GDK_FONT_FONT);
    eval("sub GDK_FONT_FONTSET () { 1; }") unless defined(&GDK_FONT_FONTSET);
    eval("sub GDK_WA_TITLE () { 1<<1; }") unless defined(&GDK_WA_TITLE);
    eval("sub GDK_WA_X () { 1<<2; }") unless defined(&GDK_WA_X);
    eval("sub GDK_WA_Y () { 1<<3; }") unless defined(&GDK_WA_Y);
    eval("sub GDK_WA_CURSOR () { 1<<4; }") unless defined(&GDK_WA_CURSOR);
    eval("sub GDK_WA_COLORMAP () { 1<<5; }") unless defined(&GDK_WA_COLORMAP);
    eval("sub GDK_WA_VISUAL () { 1<<6; }") unless defined(&GDK_WA_VISUAL);
    eval("sub GDK_WA_WMCLASS () { 1<<7; }") unless defined(&GDK_WA_WMCLASS);
    eval("sub GDK_WA_NOREDIR () { 1<<8; }") unless defined(&GDK_WA_NOREDIR);
    eval("sub GDK_HINT_POS () { 1<<0; }") unless defined(&GDK_HINT_POS);
    eval("sub GDK_HINT_MIN_SIZE () { 1<<1; }") unless defined(&GDK_HINT_MIN_SIZE);
    eval("sub GDK_HINT_MAX_SIZE () { 1<<2; }") unless defined(&GDK_HINT_MAX_SIZE);
    eval("sub GDK_HINT_BASE_SIZE () { 1<<3; }") unless defined(&GDK_HINT_BASE_SIZE);
    eval("sub GDK_HINT_ASPECT () { 1<<4; }") unless defined(&GDK_HINT_ASPECT);
    eval("sub GDK_HINT_RESIZE_INC () { 1<<5; }") unless defined(&GDK_HINT_RESIZE_INC);
    eval("sub GDK_COPY () { 0; }") unless defined(&GDK_COPY);
    eval("sub GDK_INVERT () { 1; }") unless defined(&GDK_INVERT);
    eval("sub GDK_XOR () { 2; }") unless defined(&GDK_XOR);
    eval("sub GDK_CLEAR () { 3; }") unless defined(&GDK_CLEAR);
    eval("sub GDK_AND () { 4; }") unless defined(&GDK_AND);
    eval("sub GDK_AND_REVERSE () { 5; }") unless defined(&GDK_AND_REVERSE);
    eval("sub GDK_AND_INVERT () { 6; }") unless defined(&GDK_AND_INVERT);
    eval("sub GDK_NOOP () { 7; }") unless defined(&GDK_NOOP);
    eval("sub GDK_OR () { 8; }") unless defined(&GDK_OR);
    eval("sub GDK_EQUIV () { 9; }") unless defined(&GDK_EQUIV);
    eval("sub GDK_OR_REVERSE () { 10; }") unless defined(&GDK_OR_REVERSE);
    eval("sub GDK_COPY_INVERT () { 11; }") unless defined(&GDK_COPY_INVERT);
    eval("sub GDK_OR_INVERT () { 12; }") unless defined(&GDK_OR_INVERT);
    eval("sub GDK_NAND () { 13; }") unless defined(&GDK_NAND);
    eval("sub GDK_SET () { 14; }") unless defined(&GDK_SET);
    eval("sub GDK_SOLID () { 0; }") unless defined(&GDK_SOLID);
    eval("sub GDK_TILED () { 1; }") unless defined(&GDK_TILED);
    eval("sub GDK_STIPPLED () { 2; }") unless defined(&GDK_STIPPLED);
    eval("sub GDK_OPAQUE_STIPPLED () { 3; }") unless defined(&GDK_OPAQUE_STIPPLED);
    eval("sub GDK_EVEN_ODD_RULE () { 0; }") unless defined(&GDK_EVEN_ODD_RULE);
    eval("sub GDK_WINDING_RULE () { 1; }") unless defined(&GDK_WINDING_RULE);
    eval("sub GDK_LINE_SOLID () { 0; }") unless defined(&GDK_LINE_SOLID);
    eval("sub GDK_LINE_ON_OFF_DASH () { 1; }") unless defined(&GDK_LINE_ON_OFF_DASH);
    eval("sub GDK_LINE_DOUBLE_DASH () { 2; }") unless defined(&GDK_LINE_DOUBLE_DASH);
    eval("sub GDK_CAP_NOT_LAST () { 0; }") unless defined(&GDK_CAP_NOT_LAST);
    eval("sub GDK_CAP_BUTT () { 1; }") unless defined(&GDK_CAP_BUTT);
    eval("sub GDK_CAP_ROUND () { 2; }") unless defined(&GDK_CAP_ROUND);
    eval("sub GDK_CAP_PROJECTING () { 3; }") unless defined(&GDK_CAP_PROJECTING);
    eval("sub GDK_JOIN_MITER () { 0; }") unless defined(&GDK_JOIN_MITER);
    eval("sub GDK_JOIN_ROUND () { 1; }") unless defined(&GDK_JOIN_ROUND);
    eval("sub GDK_JOIN_BEVEL () { 2; }") unless defined(&GDK_JOIN_BEVEL);
    eval("sub GDK_CURSOR_IS_PIXMAP () { -1; }") unless defined(&GDK_CURSOR_IS_PIXMAP);
    eval("sub GDK_FILTER_CONTINUE () { 0; }") unless defined(&GDK_FILTER_CONTINUE);
    eval("sub GDK_FILTER_TRANSLATE () { 1; }") unless defined(&GDK_FILTER_TRANSLATE);
    eval("sub GDK_FILTER_REMOVE () { 2; }") unless defined(&GDK_FILTER_REMOVE);
    eval("sub GDK_VISIBILITY_UNOBSCURED () { 0; }") unless defined(&GDK_VISIBILITY_UNOBSCURED);
    eval("sub GDK_VISIBILITY_PARTIAL () { 1; }") unless defined(&GDK_VISIBILITY_PARTIAL);
    eval("sub GDK_VISIBILITY_FULLY_OBSCURED () { 2; }") unless defined(&GDK_VISIBILITY_FULLY_OBSCURED);
    eval("sub GDK_NOTHING () { -1; }") unless defined(&GDK_NOTHING);
    eval("sub GDK_DELETE () { 0; }") unless defined(&GDK_DELETE);
    eval("sub GDK_DESTROY () { 1; }") unless defined(&GDK_DESTROY);
    eval("sub GDK_EXPOSE () { 2; }") unless defined(&GDK_EXPOSE);
    eval("sub GDK_MOTION_NOTIFY () { 3; }") unless defined(&GDK_MOTION_NOTIFY);
    eval("sub GDK_BUTTON_PRESS () { 4; }") unless defined(&GDK_BUTTON_PRESS);
    eval("sub GDK_2BUTTON_PRESS () { 5; }") unless defined(&GDK_2BUTTON_PRESS);
    eval("sub GDK_3BUTTON_PRESS () { 6; }") unless defined(&GDK_3BUTTON_PRESS);
    eval("sub GDK_BUTTON_RELEASE () { 7; }") unless defined(&GDK_BUTTON_RELEASE);
    eval("sub GDK_KEY_PRESS () { 8; }") unless defined(&GDK_KEY_PRESS);
    eval("sub GDK_KEY_RELEASE () { 9; }") unless defined(&GDK_KEY_RELEASE);
    eval("sub GDK_ENTER_NOTIFY () { 10; }") unless defined(&GDK_ENTER_NOTIFY);
    eval("sub GDK_LEAVE_NOTIFY () { 11; }") unless defined(&GDK_LEAVE_NOTIFY);
    eval("sub GDK_FOCUS_CHANGE () { 12; }") unless defined(&GDK_FOCUS_CHANGE);
    eval("sub GDK_CONFIGURE () { 13; }") unless defined(&GDK_CONFIGURE);
    eval("sub GDK_MAP () { 14; }") unless defined(&GDK_MAP);
    eval("sub GDK_UNMAP () { 15; }") unless defined(&GDK_UNMAP);
    eval("sub GDK_PROPERTY_NOTIFY () { 16; }") unless defined(&GDK_PROPERTY_NOTIFY);
    eval("sub GDK_SELECTION_CLEAR () { 17; }") unless defined(&GDK_SELECTION_CLEAR);
    eval("sub GDK_SELECTION_REQUEST () { 18; }") unless defined(&GDK_SELECTION_REQUEST);
    eval("sub GDK_SELECTION_NOTIFY () { 19; }") unless defined(&GDK_SELECTION_NOTIFY);
    eval("sub GDK_PROXIMITY_IN () { 20; }") unless defined(&GDK_PROXIMITY_IN);
    eval("sub GDK_PROXIMITY_OUT () { 21; }") unless defined(&GDK_PROXIMITY_OUT);
    eval("sub GDK_DRAG_ENTER () { 22; }") unless defined(&GDK_DRAG_ENTER);
    eval("sub GDK_DRAG_LEAVE () { 23; }") unless defined(&GDK_DRAG_LEAVE);
    eval("sub GDK_DRAG_MOTION () { 24; }") unless defined(&GDK_DRAG_MOTION);
    eval("sub GDK_DRAG_STATUS () { 25; }") unless defined(&GDK_DRAG_STATUS);
    eval("sub GDK_DROP_START () { 26; }") unless defined(&GDK_DROP_START);
    eval("sub GDK_DROP_FINISHED () { 27; }") unless defined(&GDK_DROP_FINISHED);
    eval("sub GDK_CLIENT_EVENT () { 28; }") unless defined(&GDK_CLIENT_EVENT);
    eval("sub GDK_VISIBILITY_NOTIFY () { 29; }") unless defined(&GDK_VISIBILITY_NOTIFY);
    eval("sub GDK_NO_EXPOSE () { 30; }") unless defined(&GDK_NO_EXPOSE);
    eval("sub GDK_EXPOSURE_MASK () { 1<<1; }") unless defined(&GDK_EXPOSURE_MASK);
    eval("sub GDK_POINTER_MOTION_MASK () { 1<<2; }") unless defined(&GDK_POINTER_MOTION_MASK);
    eval("sub GDK_POINTER_MOTION_HINT_MASK () { 1<<3; }") unless defined(&GDK_POINTER_MOTION_HINT_MASK);
    eval("sub GDK_BUTTON_MOTION_MASK () { 1<<4; }") unless defined(&GDK_BUTTON_MOTION_MASK);
    eval("sub GDK_BUTTON1_MOTION_MASK () { 1<<5; }") unless defined(&GDK_BUTTON1_MOTION_MASK);
    eval("sub GDK_BUTTON2_MOTION_MASK () { 1<<6; }") unless defined(&GDK_BUTTON2_MOTION_MASK);
    eval("sub GDK_BUTTON3_MOTION_MASK () { 1<<7; }") unless defined(&GDK_BUTTON3_MOTION_MASK);
    eval("sub GDK_BUTTON_PRESS_MASK () { 1<<8; }") unless defined(&GDK_BUTTON_PRESS_MASK);
    eval("sub GDK_BUTTON_RELEASE_MASK () { 1<<9; }") unless defined(&GDK_BUTTON_RELEASE_MASK);
    eval("sub GDK_KEY_PRESS_MASK () { 1<<10; }") unless defined(&GDK_KEY_PRESS_MASK);
    eval("sub GDK_KEY_RELEASE_MASK () { 1<<11; }") unless defined(&GDK_KEY_RELEASE_MASK);
    eval("sub GDK_ENTER_NOTIFY_MASK () { 1<<12; }") unless defined(&GDK_ENTER_NOTIFY_MASK);
    eval("sub GDK_LEAVE_NOTIFY_MASK () { 1<<13; }") unless defined(&GDK_LEAVE_NOTIFY_MASK);
    eval("sub GDK_FOCUS_CHANGE_MASK () { 1<<14; }") unless defined(&GDK_FOCUS_CHANGE_MASK);
    eval("sub GDK_STRUCTURE_MASK () { 1<<15; }") unless defined(&GDK_STRUCTURE_MASK);
    eval("sub GDK_PROPERTY_CHANGE_MASK () { 1<<16; }") unless defined(&GDK_PROPERTY_CHANGE_MASK);
    eval("sub GDK_VISIBILITY_NOTIFY_MASK () { 1<<17; }") unless defined(&GDK_VISIBILITY_NOTIFY_MASK);
    eval("sub GDK_PROXIMITY_IN_MASK () { 1<<18; }") unless defined(&GDK_PROXIMITY_IN_MASK);
    eval("sub GDK_PROXIMITY_OUT_MASK () { 1<<19; }") unless defined(&GDK_PROXIMITY_OUT_MASK);
    eval("sub GDK_SUBSTRUCTURE_MASK () { 1<<20; }") unless defined(&GDK_SUBSTRUCTURE_MASK);
    eval("sub GDK_ALL_EVENTS_MASK () { 0x0FFFFF; }") unless defined(&GDK_ALL_EVENTS_MASK);
    eval("sub GDK_NOTIFY_ANCESTOR () { 0; }") unless defined(&GDK_NOTIFY_ANCESTOR);
    eval("sub GDK_NOTIFY_VIRTUAL () { 1; }") unless defined(&GDK_NOTIFY_VIRTUAL);
    eval("sub GDK_NOTIFY_INFERIOR () { 2; }") unless defined(&GDK_NOTIFY_INFERIOR);
    eval("sub GDK_NOTIFY_NONLINEAR () { 3; }") unless defined(&GDK_NOTIFY_NONLINEAR);
    eval("sub GDK_NOTIFY_NONLINEAR_VIRTUAL () { 4; }") unless defined(&GDK_NOTIFY_NONLINEAR_VIRTUAL);
    eval("sub GDK_NOTIFY_UNKNOWN () { 5; }") unless defined(&GDK_NOTIFY_UNKNOWN);
    eval("sub GDK_CROSSING_NORMAL () { 0; }") unless defined(&GDK_CROSSING_NORMAL);
    eval("sub GDK_CROSSING_GRAB () { 1; }") unless defined(&GDK_CROSSING_GRAB);
    eval("sub GDK_CROSSING_UNGRAB () { 2; }") unless defined(&GDK_CROSSING_UNGRAB);
    eval("sub GDK_SHIFT_MASK () { 1<<0; }") unless defined(&GDK_SHIFT_MASK);
    eval("sub GDK_LOCK_MASK () { 1<<1; }") unless defined(&GDK_LOCK_MASK);
    eval("sub GDK_CONTROL_MASK () { 1<<2; }") unless defined(&GDK_CONTROL_MASK);
    eval("sub GDK_MOD1_MASK () { 1<<3; }") unless defined(&GDK_MOD1_MASK);
    eval("sub GDK_MOD2_MASK () { 1<<4; }") unless defined(&GDK_MOD2_MASK);
    eval("sub GDK_MOD3_MASK () { 1<<5; }") unless defined(&GDK_MOD3_MASK);
    eval("sub GDK_MOD4_MASK () { 1<<6; }") unless defined(&GDK_MOD4_MASK);
    eval("sub GDK_MOD5_MASK () { 1<<7; }") unless defined(&GDK_MOD5_MASK);
    eval("sub GDK_BUTTON1_MASK () { 1<<8; }") unless defined(&GDK_BUTTON1_MASK);
    eval("sub GDK_BUTTON2_MASK () { 1<<9; }") unless defined(&GDK_BUTTON2_MASK);
    eval("sub GDK_BUTTON3_MASK () { 1<<10; }") unless defined(&GDK_BUTTON3_MASK);
    eval("sub GDK_BUTTON4_MASK () { 1<<11; }") unless defined(&GDK_BUTTON4_MASK);
    eval("sub GDK_BUTTON5_MASK () { 1<<12; }") unless defined(&GDK_BUTTON5_MASK);
    eval("sub GDK_RELEASE_MASK () { 1<<13; }") unless defined(&GDK_RELEASE_MASK);
    eval("sub GDK_MODIFIER_MASK () { 0x3fff; }") unless defined(&GDK_MODIFIER_MASK);
    eval("sub GDK_CLIP_BY_CHILDREN () { 0; }") unless defined(&GDK_CLIP_BY_CHILDREN);
    eval("sub GDK_INCLUDE_INFERIORS () { 1; }") unless defined(&GDK_INCLUDE_INFERIORS);
    eval("sub GDK_INPUT_READ () { 1<<0; }") unless defined(&GDK_INPUT_READ);
    eval("sub GDK_INPUT_WRITE () { 1<<1; }") unless defined(&GDK_INPUT_WRITE);
    eval("sub GDK_INPUT_EXCEPTION () { 1<<2; }") unless defined(&GDK_INPUT_EXCEPTION);
    eval("sub GDK_OK () { 0; }") unless defined(&GDK_OK);
    eval("sub GDK_ERROR () { -1; }") unless defined(&GDK_ERROR);
    eval("sub GDK_ERROR_PARAM () { -2; }") unless defined(&GDK_ERROR_PARAM);
    eval("sub GDK_ERROR_FILE () { -3; }") unless defined(&GDK_ERROR_FILE);
    eval("sub GDK_ERROR_MEM () { -4; }") unless defined(&GDK_ERROR_MEM);
    eval("sub GDK_LSB_FIRST () { 0; }") unless defined(&GDK_LSB_FIRST);
    eval("sub GDK_MSB_FIRST () { 1; }") unless defined(&GDK_MSB_FIRST);
    eval("sub GDK_GC_FOREGROUND () { 1<<0; }") unless defined(&GDK_GC_FOREGROUND);
    eval("sub GDK_GC_BACKGROUND () { 1<<1; }") unless defined(&GDK_GC_BACKGROUND);
    eval("sub GDK_GC_FONT () { 1<<2; }") unless defined(&GDK_GC_FONT);
    eval("sub GDK_GC_FUNCTION () { 1<<3; }") unless defined(&GDK_GC_FUNCTION);
    eval("sub GDK_GC_FILL () { 1<<4; }") unless defined(&GDK_GC_FILL);
    eval("sub GDK_GC_TILE () { 1<<5; }") unless defined(&GDK_GC_TILE);
    eval("sub GDK_GC_STIPPLE () { 1<<6; }") unless defined(&GDK_GC_STIPPLE);
    eval("sub GDK_GC_CLIP_MASK () { 1<<7; }") unless defined(&GDK_GC_CLIP_MASK);
    eval("sub GDK_GC_SUBWINDOW () { 1<<8; }") unless defined(&GDK_GC_SUBWINDOW);
    eval("sub GDK_GC_TS_X_ORIGIN () { 1<<9; }") unless defined(&GDK_GC_TS_X_ORIGIN);
    eval("sub GDK_GC_TS_Y_ORIGIN () { 1<<10; }") unless defined(&GDK_GC_TS_Y_ORIGIN);
    eval("sub GDK_GC_CLIP_X_ORIGIN () { 1<<11; }") unless defined(&GDK_GC_CLIP_X_ORIGIN);
    eval("sub GDK_GC_CLIP_Y_ORIGIN () { 1<<12; }") unless defined(&GDK_GC_CLIP_Y_ORIGIN);
    eval("sub GDK_GC_EXPOSURES () { 1<<13; }") unless defined(&GDK_GC_EXPOSURES);
    eval("sub GDK_GC_LINE_WIDTH () { 1<<14; }") unless defined(&GDK_GC_LINE_WIDTH);
    eval("sub GDK_GC_LINE_STYLE () { 1<<15; }") unless defined(&GDK_GC_LINE_STYLE);
    eval("sub GDK_GC_CAP_STYLE () { 1<<16; }") unless defined(&GDK_GC_CAP_STYLE);
    eval("sub GDK_GC_JOIN_STYLE () { 1<<17; }") unless defined(&GDK_GC_JOIN_STYLE);
    eval("sub GDK_SELECTION_PRIMARY () { 1; }") unless defined(&GDK_SELECTION_PRIMARY);
    eval("sub GDK_SELECTION_SECONDARY () { 2; }") unless defined(&GDK_SELECTION_SECONDARY);
    eval("sub GDK_PROPERTY_NEW_VALUE () { 0; }") unless defined(&GDK_PROPERTY_NEW_VALUE);
    eval("sub GDK_PROPERTY_DELETE () { 1; }") unless defined(&GDK_PROPERTY_DELETE);
    eval("sub GDK_PROP_MODE_REPLACE () { 0; }") unless defined(&GDK_PROP_MODE_REPLACE);
    eval("sub GDK_PROP_MODE_PREPEND () { 1; }") unless defined(&GDK_PROP_MODE_PREPEND);
    eval("sub GDK_PROP_MODE_APPEND () { 2; }") unless defined(&GDK_PROP_MODE_APPEND);
    eval("sub GDK_SOURCE_MOUSE () { 0; }") unless defined(&GDK_SOURCE_MOUSE);
    eval("sub GDK_SOURCE_PEN () { 1; }") unless defined(&GDK_SOURCE_PEN);
    eval("sub GDK_SOURCE_ERASER () { 2; }") unless defined(&GDK_SOURCE_ERASER);
    eval("sub GDK_SOURCE_CURSOR () { 3; }") unless defined(&GDK_SOURCE_CURSOR);
    eval("sub GDK_MODE_DISABLED () { 0; }") unless defined(&GDK_MODE_DISABLED);
    eval("sub GDK_MODE_SCREEN () { 1; }") unless defined(&GDK_MODE_SCREEN);
    eval("sub GDK_MODE_WINDOW () { 2; }") unless defined(&GDK_MODE_WINDOW);
    eval("sub GDK_AXIS_IGNORE () { 0; }") unless defined(&GDK_AXIS_IGNORE);
    eval("sub GDK_AXIS_X () { 1; }") unless defined(&GDK_AXIS_X);
    eval("sub GDK_AXIS_Y () { 2; }") unless defined(&GDK_AXIS_Y);
    eval("sub GDK_AXIS_PRESSURE () { 3; }") unless defined(&GDK_AXIS_PRESSURE);
    eval("sub GDK_AXIS_XTILT () { 4; }") unless defined(&GDK_AXIS_XTILT);
    eval("sub GDK_AXIS_YTILT () { 5; }") unless defined(&GDK_AXIS_YTILT);
    eval("sub GDK_AXIS_LAST () { 6; }") unless defined(&GDK_AXIS_LAST);
    eval("sub GDK_TARGET_BITMAP () { 5; }") unless defined(&GDK_TARGET_BITMAP);
    eval("sub GDK_TARGET_COLORMAP () { 7; }") unless defined(&GDK_TARGET_COLORMAP);
    eval("sub GDK_TARGET_DRAWABLE () { 17; }") unless defined(&GDK_TARGET_DRAWABLE);
    eval("sub GDK_TARGET_PIXMAP () { 20; }") unless defined(&GDK_TARGET_PIXMAP);
    eval("sub GDK_TARGET_STRING () { 31; }") unless defined(&GDK_TARGET_STRING);
    eval("sub GDK_SELECTION_TYPE_ATOM () { 4; }") unless defined(&GDK_SELECTION_TYPE_ATOM);
    eval("sub GDK_SELECTION_TYPE_BITMAP () { 5; }") unless defined(&GDK_SELECTION_TYPE_BITMAP);
    eval("sub GDK_SELECTION_TYPE_COLORMAP () { 7; }") unless defined(&GDK_SELECTION_TYPE_COLORMAP);
    eval("sub GDK_SELECTION_TYPE_DRAWABLE () { 17; }") unless defined(&GDK_SELECTION_TYPE_DRAWABLE);
    eval("sub GDK_SELECTION_TYPE_INTEGER () { 19; }") unless defined(&GDK_SELECTION_TYPE_INTEGER);
    eval("sub GDK_SELECTION_TYPE_PIXMAP () { 20; }") unless defined(&GDK_SELECTION_TYPE_PIXMAP);
    eval("sub GDK_SELECTION_TYPE_WINDOW () { 33; }") unless defined(&GDK_SELECTION_TYPE_WINDOW);
    eval("sub GDK_SELECTION_TYPE_STRING () { 31; }") unless defined(&GDK_SELECTION_TYPE_STRING);
    eval("sub GDK_EXTENSION_EVENTS_NONE () { 0; }") unless defined(&GDK_EXTENSION_EVENTS_NONE);
    eval("sub GDK_EXTENSION_EVENTS_ALL () { 1; }") unless defined(&GDK_EXTENSION_EVENTS_ALL);
    eval("sub GDK_EXTENSION_EVENTS_CURSOR () { 2; }") unless defined(&GDK_EXTENSION_EVENTS_CURSOR);
    eval("sub GDK_IM_PREEDIT_AREA () { 0x0001; }") unless defined(&GDK_IM_PREEDIT_AREA);
    eval("sub GDK_IM_PREEDIT_CALLBACKS () { 0x0002; }") unless defined(&GDK_IM_PREEDIT_CALLBACKS);
    eval("sub GDK_IM_PREEDIT_POSITION () { 0x0004; }") unless defined(&GDK_IM_PREEDIT_POSITION);
    eval("sub GDK_IM_PREEDIT_NOTHING () { 0x0008; }") unless defined(&GDK_IM_PREEDIT_NOTHING);
    eval("sub GDK_IM_PREEDIT_NONE () { 0x0010; }") unless defined(&GDK_IM_PREEDIT_NONE);
    eval("sub GDK_IM_PREEDIT_MASK () { 0x001f; }") unless defined(&GDK_IM_PREEDIT_MASK);
    eval("sub GDK_IM_STATUS_AREA () { 0x0100; }") unless defined(&GDK_IM_STATUS_AREA);
    eval("sub GDK_IM_STATUS_CALLBACKS () { 0x0200; }") unless defined(&GDK_IM_STATUS_CALLBACKS);
    eval("sub GDK_IM_STATUS_NOTHING () { 0x0400; }") unless defined(&GDK_IM_STATUS_NOTHING);
    eval("sub GDK_IM_STATUS_NONE () { 0x0800; }") unless defined(&GDK_IM_STATUS_NONE);
    eval("sub GDK_IM_STATUS_MASK () { 0x0f00; }") unless defined(&GDK_IM_STATUS_MASK);
    eval("sub GDK_IC_STYLE () { 1<<0; }") unless defined(&GDK_IC_STYLE);
    eval("sub GDK_IC_CLIENT_WINDOW () { 1<<1; }") unless defined(&GDK_IC_CLIENT_WINDOW);
    eval("sub GDK_IC_FOCUS_WINDOW () { 1<<2; }") unless defined(&GDK_IC_FOCUS_WINDOW);
    eval("sub GDK_IC_FILTER_EVENTS () { 1<<3; }") unless defined(&GDK_IC_FILTER_EVENTS);
    eval("sub GDK_IC_SPOT_LOCATION () { 1<<4; }") unless defined(&GDK_IC_SPOT_LOCATION);
    eval("sub GDK_IC_LINE_SPACING () { 1<<5; }") unless defined(&GDK_IC_LINE_SPACING);
    eval("sub GDK_IC_CURSOR () { 1<<6; }") unless defined(&GDK_IC_CURSOR);
    eval("sub GDK_IC_PREEDIT_FONTSET () { 1<<10; }") unless defined(&GDK_IC_PREEDIT_FONTSET);
    eval("sub GDK_IC_PREEDIT_AREA () { 1<<11; }") unless defined(&GDK_IC_PREEDIT_AREA);
    eval("sub GDK_IC_PREEDIT_AREA_NEEDED () { 1<<12; }") unless defined(&GDK_IC_PREEDIT_AREA_NEEDED);
    eval("sub GDK_IC_PREEDIT_FOREGROUND () { 1<<13; }") unless defined(&GDK_IC_PREEDIT_FOREGROUND);
    eval("sub GDK_IC_PREEDIT_BACKGROUND () { 1<<14; }") unless defined(&GDK_IC_PREEDIT_BACKGROUND);
    eval("sub GDK_IC_PREEDIT_PIXMAP () { 1<<15; }") unless defined(&GDK_IC_PREEDIT_PIXMAP);
    eval("sub GDK_IC_PREEDIT_COLORMAP () { 1<<16; }") unless defined(&GDK_IC_PREEDIT_COLORMAP);
    eval("sub GDK_IC_STATUS_FONTSET () { 1<<21; }") unless defined(&GDK_IC_STATUS_FONTSET);
    eval("sub GDK_IC_STATUS_AREA () { 1<<22; }") unless defined(&GDK_IC_STATUS_AREA);
    eval("sub GDK_IC_STATUS_AREA_NEEDED () { 1<<23; }") unless defined(&GDK_IC_STATUS_AREA_NEEDED);
    eval("sub GDK_IC_STATUS_FOREGROUND () { 1<<24; }") unless defined(&GDK_IC_STATUS_FOREGROUND);
    eval("sub GDK_IC_STATUS_BACKGROUND () { 1<<25; }") unless defined(&GDK_IC_STATUS_BACKGROUND);
    eval("sub GDK_IC_STATUS_PIXMAP () { 1<<26; }") unless defined(&GDK_IC_STATUS_PIXMAP);
    eval("sub GDK_IC_STATUS_COLORMAP () { 1<<27; }") unless defined(&GDK_IC_STATUS_COLORMAP);
    eval("sub GDK_IC_ALL_REQ () { GDK_IC_STYLE|GDK_IC_CLIENT_WINDOW; }") unless defined(&GDK_IC_ALL_REQ);
    eval("sub GDK_IC_PREEDIT_AREA_REQ () { GDK_IC_PREEDIT_AREA|GDK_IC_PREEDIT_FONTSET; }") unless defined(&GDK_IC_PREEDIT_AREA_REQ);
    eval("sub GDK_IC_PREEDIT_POSITION_REQ () { GDK_IC_PREEDIT_AREA|GDK_IC_SPOT_LOCATION|GDK_IC_PREEDIT_FONTSET; }") unless defined(&GDK_IC_PREEDIT_POSITION_REQ);
    eval("sub GDK_IC_STATUS_AREA_REQ () { GDK_IC_STATUS_AREA|GDK_IC_STATUS_FONTSET; }") unless defined(&GDK_IC_STATUS_AREA_REQ);
    eval("sub GDK_DECOR_ALL () { 1<<0; }") unless defined(&GDK_DECOR_ALL);
    eval("sub GDK_DECOR_BORDER () { 1<<1; }") unless defined(&GDK_DECOR_BORDER);
    eval("sub GDK_DECOR_RESIZEH () { 1<<2; }") unless defined(&GDK_DECOR_RESIZEH);
    eval("sub GDK_DECOR_TITLE () { 1<<3; }") unless defined(&GDK_DECOR_TITLE);
    eval("sub GDK_DECOR_MENU () { 1<<4; }") unless defined(&GDK_DECOR_MENU);
    eval("sub GDK_DECOR_MINIMIZE () { 1<<5; }") unless defined(&GDK_DECOR_MINIMIZE);
    eval("sub GDK_DECOR_MAXIMIZE () { 1<<6; }") unless defined(&GDK_DECOR_MAXIMIZE);
    eval("sub GDK_FUNC_ALL () { 1<<0; }") unless defined(&GDK_FUNC_ALL);
    eval("sub GDK_FUNC_RESIZE () { 1<<1; }") unless defined(&GDK_FUNC_RESIZE);
    eval("sub GDK_FUNC_MOVE () { 1<<2; }") unless defined(&GDK_FUNC_MOVE);
    eval("sub GDK_FUNC_MINIMIZE () { 1<<3; }") unless defined(&GDK_FUNC_MINIMIZE);
    eval("sub GDK_FUNC_MAXIMIZE () { 1<<4; }") unless defined(&GDK_FUNC_MAXIMIZE);
    eval("sub GDK_FUNC_CLOSE () { 1<<5; }") unless defined(&GDK_FUNC_CLOSE);
    eval("sub GDK_CC_MODE_UNDEFINED () { 0; }") unless defined(&GDK_CC_MODE_UNDEFINED);
    eval("sub GDK_CC_MODE_BW () { 1; }") unless defined(&GDK_CC_MODE_BW);
    eval("sub GDK_CC_MODE_STD_CMAP () { 2; }") unless defined(&GDK_CC_MODE_STD_CMAP);
    eval("sub GDK_CC_MODE_TRUE () { 3; }") unless defined(&GDK_CC_MODE_TRUE);
    eval("sub GDK_CC_MODE_MY_GRAY () { 4; }") unless defined(&GDK_CC_MODE_MY_GRAY);
    eval("sub GDK_CC_MODE_PALETTE () { 5; }") unless defined(&GDK_CC_MODE_PALETTE);
    eval("sub GDK_OVERLAP_RECTANGLE_IN () { 0; }") unless defined(&GDK_OVERLAP_RECTANGLE_IN);
    eval("sub GDK_OVERLAP_RECTANGLE_OUT () { 1; }") unless defined(&GDK_OVERLAP_RECTANGLE_OUT);
    eval("sub GDK_OVERLAP_RECTANGLE_PART () { 2; }") unless defined(&GDK_OVERLAP_RECTANGLE_PART);
    eval("sub GDK_ACTION_DEFAULT () { 1<<0; }") unless defined(&GDK_ACTION_DEFAULT);
    eval("sub GDK_ACTION_COPY () { 1<<1; }") unless defined(&GDK_ACTION_COPY);
    eval("sub GDK_ACTION_MOVE () { 1<<2; }") unless defined(&GDK_ACTION_MOVE);
    eval("sub GDK_ACTION_LINK () { 1<<3; }") unless defined(&GDK_ACTION_LINK);
    eval("sub GDK_ACTION_PRIVATE () { 1<<4; }") unless defined(&GDK_ACTION_PRIVATE);
    eval("sub GDK_ACTION_ASK () { 1<<5; }") unless defined(&GDK_ACTION_ASK);
    eval("sub GDK_DRAG_PROTO_MOTIF () { 0; }") unless defined(&GDK_DRAG_PROTO_MOTIF);
    eval("sub GDK_DRAG_PROTO_XDND () { 1; }") unless defined(&GDK_DRAG_PROTO_XDND);
    eval("sub GDK_DRAG_PROTO_ROOTWIN () { 2; }") unless defined(&GDK_DRAG_PROTO_ROOTWIN);
    eval("sub GDK_DRAG_PROTO_NONE () { 3; }") unless defined(&GDK_DRAG_PROTO_NONE);
    if(defined(&__cplusplus)) {
    }
}
1;
