require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GTK_CLIST_H__)) {
    eval 'sub __GTK_CLIST_H__ () {1;}' unless defined(&__GTK_CLIST_H__);
    require 'gdk/gdk.ph';
    require 'gtk/gtksignal.ph';
    require 'gtk/gtkalignment.ph';
    require 'gtk/gtklabel.ph';
    require 'gtk/gtkbutton.ph';
    require 'gtk/gtkhscrollbar.ph';
    require 'gtk/gtkvscrollbar.ph';
    require 'gtk/gtkenums.ph';
    if(defined(&__cplusplus)) {
    }
    eval("sub GTK_CLIST_IN_DRAG () { 1<<0; }") unless defined(&GTK_CLIST_IN_DRAG);
    eval("sub GTK_CLIST_ROW_HEIGHT_SET () { 1<<1; }") unless defined(&GTK_CLIST_ROW_HEIGHT_SET);
    eval("sub GTK_CLIST_SHOW_TITLES () { 1<<2; }") unless defined(&GTK_CLIST_SHOW_TITLES);
    eval("sub GTK_CLIST_CHILD_HAS_FOCUS () { 1<<3; }") unless defined(&GTK_CLIST_CHILD_HAS_FOCUS);
    eval("sub GTK_CLIST_ADD_MODE () { 1<<4; }") unless defined(&GTK_CLIST_ADD_MODE);
    eval("sub GTK_CLIST_AUTO_SORT () { 1<<5; }") unless defined(&GTK_CLIST_AUTO_SORT);
    eval("sub GTK_CLIST_AUTO_RESIZE_BLOCKED () { 1<<6; }") unless defined(&GTK_CLIST_AUTO_RESIZE_BLOCKED);
    eval("sub GTK_CLIST_REORDERABLE () { 1<<7; }") unless defined(&GTK_CLIST_REORDERABLE);
    eval("sub GTK_CLIST_USE_DRAG_ICONS () { 1<<8; }") unless defined(&GTK_CLIST_USE_DRAG_ICONS);
    eval("sub GTK_CLIST_DRAW_DRAG_LINE () { 1<<9; }") unless defined(&GTK_CLIST_DRAW_DRAG_LINE);
    eval("sub GTK_CLIST_DRAW_DRAG_RECT () { 1<<10; }") unless defined(&GTK_CLIST_DRAW_DRAG_RECT);
    eval("sub GTK_CELL_EMPTY () { 0; }") unless defined(&GTK_CELL_EMPTY);
    eval("sub GTK_CELL_TEXT () { 1; }") unless defined(&GTK_CELL_TEXT);
    eval("sub GTK_CELL_PIXMAP () { 2; }") unless defined(&GTK_CELL_PIXMAP);
    eval("sub GTK_CELL_PIXTEXT () { 3; }") unless defined(&GTK_CELL_PIXTEXT);
    eval("sub GTK_CELL_WIDGET () { 4; }") unless defined(&GTK_CELL_WIDGET);
    eval("sub GTK_CLIST_DRAG_NONE () { 0; }") unless defined(&GTK_CLIST_DRAG_NONE);
    eval("sub GTK_CLIST_DRAG_BEFORE () { 1; }") unless defined(&GTK_CLIST_DRAG_BEFORE);
    eval("sub GTK_CLIST_DRAG_INTO () { 2; }") unless defined(&GTK_CLIST_DRAG_INTO);
    eval("sub GTK_CLIST_DRAG_AFTER () { 3; }") unless defined(&GTK_CLIST_DRAG_AFTER);
    eval("sub GTK_BUTTON_IGNORED () { 0; }") unless defined(&GTK_BUTTON_IGNORED);
    eval("sub GTK_BUTTON_SELECTS () { 1<<0; }") unless defined(&GTK_BUTTON_SELECTS);
    eval("sub GTK_BUTTON_DRAGS () { 1<<1; }") unless defined(&GTK_BUTTON_DRAGS);
    eval("sub GTK_BUTTON_EXPANDS () { 1<<2; }") unless defined(&GTK_BUTTON_EXPANDS);
    eval 'sub GTK_TYPE_CLIST () {( &gtk_clist_get_type ());}' unless defined(&GTK_TYPE_CLIST);
    eval 'sub GTK_CLIST {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_CAST (($obj),  &GTK_TYPE_CLIST,  &GtkCList)));
    }' unless defined(&GTK_CLIST);
    eval 'sub GTK_CLIST_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_CAST (($klass),  &GTK_TYPE_CLIST,  &GtkCListClass)));
    }' unless defined(&GTK_CLIST_CLASS);
    eval 'sub GTK_IS_CLIST {
        my($obj) = @_;
	    eval q(( &GTK_CHECK_TYPE (($obj),  &GTK_TYPE_CLIST)));
    }' unless defined(&GTK_IS_CLIST);
    eval 'sub GTK_IS_CLIST_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_TYPE (($klass),  &GTK_TYPE_CLIST)));
    }' unless defined(&GTK_IS_CLIST_CLASS);
    eval 'sub GTK_CLIST_FLAGS {
        my($clist) = @_;
	    eval q(( &GTK_CLIST ($clist)-> &flags));
    }' unless defined(&GTK_CLIST_FLAGS);
    eval 'sub GTK_CLIST_SET_FLAG {
        my($clist,$flag) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) |= ( &GTK_  $flag)));
    }' unless defined(&GTK_CLIST_SET_FLAG);
    eval 'sub GTK_CLIST_UNSET_FLAG {
        my($clist,$flag) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &= ~( &GTK_  $flag)));
    }' unless defined(&GTK_CLIST_UNSET_FLAG);
    eval 'sub GTK_CLIST_IN_DRAG {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_IN_DRAG));
    }' unless defined(&GTK_CLIST_IN_DRAG);
    eval 'sub GTK_CLIST_ROW_HEIGHT_SET {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_ROW_HEIGHT_SET));
    }' unless defined(&GTK_CLIST_ROW_HEIGHT_SET);
    eval 'sub GTK_CLIST_SHOW_TITLES {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_SHOW_TITLES));
    }' unless defined(&GTK_CLIST_SHOW_TITLES);
    eval 'sub GTK_CLIST_CHILD_HAS_FOCUS {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_CHILD_HAS_FOCUS));
    }' unless defined(&GTK_CLIST_CHILD_HAS_FOCUS);
    eval 'sub GTK_CLIST_ADD_MODE {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_ADD_MODE));
    }' unless defined(&GTK_CLIST_ADD_MODE);
    eval 'sub GTK_CLIST_AUTO_SORT {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_AUTO_SORT));
    }' unless defined(&GTK_CLIST_AUTO_SORT);
    eval 'sub GTK_CLIST_AUTO_RESIZE_BLOCKED {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_AUTO_RESIZE_BLOCKED));
    }' unless defined(&GTK_CLIST_AUTO_RESIZE_BLOCKED);
    eval 'sub GTK_CLIST_REORDERABLE {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_REORDERABLE));
    }' unless defined(&GTK_CLIST_REORDERABLE);
    eval 'sub GTK_CLIST_USE_DRAG_ICONS {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_USE_DRAG_ICONS));
    }' unless defined(&GTK_CLIST_USE_DRAG_ICONS);
    eval 'sub GTK_CLIST_DRAW_DRAG_LINE {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_DRAW_DRAG_LINE));
    }' unless defined(&GTK_CLIST_DRAW_DRAG_LINE);
    eval 'sub GTK_CLIST_DRAW_DRAG_RECT {
        my($clist) = @_;
	    eval q(( &GTK_CLIST_FLAGS ($clist) &  &GTK_CLIST_DRAW_DRAG_RECT));
    }' unless defined(&GTK_CLIST_DRAW_DRAG_RECT);
    eval 'sub GTK_CLIST_ROW {
        my($_glist_) = @_;
	    eval q((( &GtkCListRow *)(($_glist_)-> &data)));
    }' unless defined(&GTK_CLIST_ROW);
    eval 'sub GTK_CELL_TEXT {
        my($cell) = @_;
	    eval q(((( &GtkCellText *) ($cell))));
    }' unless defined(&GTK_CELL_TEXT);
    eval 'sub GTK_CELL_PIXMAP {
        my($cell) = @_;
	    eval q(((( &GtkCellPixmap *) ($cell))));
    }' unless defined(&GTK_CELL_PIXMAP);
    eval 'sub GTK_CELL_PIXTEXT {
        my($cell) = @_;
	    eval q(((( &GtkCellPixText *) ($cell))));
    }' unless defined(&GTK_CELL_PIXTEXT);
    eval 'sub GTK_CELL_WIDGET {
        my($cell) = @_;
	    eval q(((( &GtkCellWidget *) ($cell))));
    }' unless defined(&GTK_CELL_WIDGET);
    if(defined(&__cplusplus)) {
    }
}
1;
