require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GTK_OBJECT_H__)) {
    eval 'sub __GTK_OBJECT_H__ () {1;}' unless defined(&__GTK_OBJECT_H__);
    require 'gtk/gtkarg.ph';
    require 'gtk/gtkenums.ph';
    require 'gtk/gtktypeutils.ph';
    require 'gtk/gtkdebug.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub GTK_OBJECT {
        my($object) = @_;
	    eval q((  &GTK_IS_OBJECT ($object) ? ( &GtkObject*) ($object) : ( &GtkObject*)  &gtk_type_check_object_cast (( &GtkTypeObject*) ($object),  &GTK_TYPE_OBJECT) ));
    }' unless defined(&GTK_OBJECT);
    eval 'sub GTK_OBJECT_CLASS {
        my($klass) = @_;
	    eval q((  &GTK_IS_OBJECT_CLASS ($klass) ? ( &GtkObjectClass*) ($klass) : ( &GtkObjectClass*)  &gtk_type_check_class_cast (( &GtkTypeClass*) ($klass),  &GTK_TYPE_OBJECT) ));
    }' unless defined(&GTK_OBJECT_CLASS);
    eval 'sub GTK_IS_OBJECT {
        my($object) = @_;
	    eval q(( ($object) !=  &NULL  &&  &GTK_IS_OBJECT_CLASS ((( &GtkObject*) ($object))-> &klass) ));
    }' unless defined(&GTK_IS_OBJECT);
    eval 'sub GTK_IS_OBJECT_CLASS {
        my($klass) = @_;
	    eval q(( ($klass) !=  &NULL  &&  &GTK_FUNDAMENTAL_TYPE ((( &GtkObjectClass*) ($klass))-> &type) ==  &GTK_TYPE_OBJECT ));
    }' unless defined(&GTK_IS_OBJECT_CLASS);
    eval 'sub GTK_OBJECT_TYPE {
        my($obj) = @_;
	    eval q(( &GTK_OBJECT ($obj)-> ($klass->{type})));
    }' unless defined(&GTK_OBJECT_TYPE);
    eval 'sub GTK_OBJECT_SIGNALS {
        my($obj) = @_;
	    eval q(( &GTK_OBJECT ($obj)-> ($klass->{signals})));
    }' unless defined(&GTK_OBJECT_SIGNALS);
    eval 'sub GTK_OBJECT_NSIGNALS {
        my($obj) = @_;
	    eval q(( &GTK_OBJECT ($obj)-> ($klass->{nsignals})));
    }' unless defined(&GTK_OBJECT_NSIGNALS);
    eval("sub GTK_DESTROYED () { 1<<0; }") unless defined(&GTK_DESTROYED);
    eval("sub GTK_FLOATING () { 1<<1; }") unless defined(&GTK_FLOATING);
    eval("sub GTK_CONNECTED () { 1<<2; }") unless defined(&GTK_CONNECTED);
    eval("sub GTK_CONSTRUCTED () { 1<<3; }") unless defined(&GTK_CONSTRUCTED);
    eval 'sub GTK_OBJECT_FLAGS {
        my($obj) = @_;
	    eval q(( &GTK_OBJECT ($obj)-> &flags));
    }' unless defined(&GTK_OBJECT_FLAGS);
    eval 'sub GTK_OBJECT_DESTROYED {
        my($obj) = @_;
	    eval q((( &GTK_OBJECT_FLAGS ($obj) &  &GTK_DESTROYED) != 0));
    }' unless defined(&GTK_OBJECT_DESTROYED);
    eval 'sub GTK_OBJECT_FLOATING {
        my($obj) = @_;
	    eval q((( &GTK_OBJECT_FLAGS ($obj) &  &GTK_FLOATING) != 0));
    }' unless defined(&GTK_OBJECT_FLOATING);
    eval 'sub GTK_OBJECT_CONNECTED {
        my($obj) = @_;
	    eval q((( &GTK_OBJECT_FLAGS ($obj) &  &GTK_CONNECTED) != 0));
    }' unless defined(&GTK_OBJECT_CONNECTED);
    eval 'sub GTK_OBJECT_CONSTRUCTED {
        my($obj) = @_;
	    eval q((( &GTK_OBJECT_FLAGS ($obj) &  &GTK_CONSTRUCTED) != 0));
    }' unless defined(&GTK_OBJECT_CONSTRUCTED);
    eval 'sub GTK_OBJECT_SET_FLAGS {
        my($obj,$flag) = @_;
	    eval q( &G_STMT_START{ ( &GTK_OBJECT_FLAGS ($obj) |= ($flag)); } &G_STMT_END);
    }' unless defined(&GTK_OBJECT_SET_FLAGS);
    eval 'sub GTK_OBJECT_UNSET_FLAGS {
        my($obj,$flag) = @_;
	    eval q( &G_STMT_START{ ( &GTK_OBJECT_FLAGS ($obj) &= ~($flag)); } &G_STMT_END);
    }' unless defined(&GTK_OBJECT_UNSET_FLAGS);
    eval("sub GTK_ARG_READABLE () { 1<<0; }") unless defined(&GTK_ARG_READABLE);
    eval("sub GTK_ARG_WRITABLE () { 1<<1; }") unless defined(&GTK_ARG_WRITABLE);
    eval("sub GTK_ARG_CONSTRUCT () { 1<<2; }") unless defined(&GTK_ARG_CONSTRUCT);
    eval("sub GTK_ARG_CONSTRUCT_ONLY () { 1<<3; }") unless defined(&GTK_ARG_CONSTRUCT_ONLY);
    eval("sub GTK_ARG_CHILD_ARG () { 1<<4; }") unless defined(&GTK_ARG_CHILD_ARG);
    eval("sub GTK_ARG_MASK () { 0x1f; }") unless defined(&GTK_ARG_MASK);
    eval("sub GTK_ARG_READWRITE () { GTK_ARG_READABLE|GTK_ARG_WRITABLE; }") unless defined(&GTK_ARG_READWRITE);
    eval 'sub gtk_object_data_try_key () { &g_quark_try_string;}' unless defined(&gtk_object_data_try_key);
    eval 'sub gtk_object_data_force_id () { &g_quark_from_string;}' unless defined(&gtk_object_data_force_id);
    if(defined(&G_ENABLE_DEBUG)) {
	eval 'sub gtk_object_ref {
	    my($o) = @_;
    	    eval q( &G_STMT_START{ &gtk_trace_referencing(($o), &G_GNUC_PRETTY_FUNCTION,0, &__LINE__,1);} &G_STMT_END);
	}' unless defined(&gtk_object_ref);
	eval 'sub gtk_object_unref {
	    my($o) = @_;
    	    eval q( &G_STMT_START{ &gtk_trace_referencing(($o), &G_GNUC_PRETTY_FUNCTION,0, &__LINE__,0);} &G_STMT_END);
	}' unless defined(&gtk_object_unref);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
