require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GTK_WIDGET_H__)) {
    eval 'sub __GTK_WIDGET_H__ () {1;}' unless defined(&__GTK_WIDGET_H__);
    require 'gdk/gdk.ph';
    require 'gtk/gtkaccelgroup.ph';
    require 'gtk/gtkobject.ph';
    require 'gtk/gtkadjustment.ph';
    require 'gtk/gtkstyle.ph';
    if(defined(&__cplusplus)) {
    }
    eval("sub GTK_TOPLEVEL () { 1<<4; }") unless defined(&GTK_TOPLEVEL);
    eval("sub GTK_NO_WINDOW () { 1<<5; }") unless defined(&GTK_NO_WINDOW);
    eval("sub GTK_REALIZED () { 1<<6; }") unless defined(&GTK_REALIZED);
    eval("sub GTK_MAPPED () { 1<<7; }") unless defined(&GTK_MAPPED);
    eval("sub GTK_VISIBLE () { 1<<8; }") unless defined(&GTK_VISIBLE);
    eval("sub GTK_SENSITIVE () { 1<<9; }") unless defined(&GTK_SENSITIVE);
    eval("sub GTK_PARENT_SENSITIVE () { 1<<10; }") unless defined(&GTK_PARENT_SENSITIVE);
    eval("sub GTK_CAN_FOCUS () { 1<<11; }") unless defined(&GTK_CAN_FOCUS);
    eval("sub GTK_HAS_FOCUS () { 1<<12; }") unless defined(&GTK_HAS_FOCUS);
    eval("sub GTK_CAN_DEFAULT () { 1<<13; }") unless defined(&GTK_CAN_DEFAULT);
    eval("sub GTK_HAS_DEFAULT () { 1<<14; }") unless defined(&GTK_HAS_DEFAULT);
    eval("sub GTK_HAS_GRAB () { 1<<15; }") unless defined(&GTK_HAS_GRAB);
    eval("sub GTK_RC_STYLE () { 1<<16; }") unless defined(&GTK_RC_STYLE);
    eval("sub GTK_COMPOSITE_CHILD () { 1<<17; }") unless defined(&GTK_COMPOSITE_CHILD);
    eval("sub GTK_NO_REPARENT () { 1<<18; }") unless defined(&GTK_NO_REPARENT);
    eval("sub GTK_APP_PAINTABLE () { 1<<19; }") unless defined(&GTK_APP_PAINTABLE);
    eval("sub GTK_RECEIVES_DEFAULT () { 1<<20; }") unless defined(&GTK_RECEIVES_DEFAULT);
    eval 'sub GTK_TYPE_WIDGET () {( &gtk_widget_get_type ());}' unless defined(&GTK_TYPE_WIDGET);
    eval 'sub GTK_WIDGET {
        my($widget) = @_;
	    eval q(( &GTK_CHECK_CAST (($widget),  &GTK_TYPE_WIDGET,  &GtkWidget)));
    }' unless defined(&GTK_WIDGET);
    eval 'sub GTK_WIDGET_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_CAST (($klass),  &GTK_TYPE_WIDGET,  &GtkWidgetClass)));
    }' unless defined(&GTK_WIDGET_CLASS);
    eval 'sub GTK_IS_WIDGET {
        my($widget) = @_;
	    eval q(( &GTK_CHECK_TYPE (($widget),  &GTK_TYPE_WIDGET)));
    }' unless defined(&GTK_IS_WIDGET);
    eval 'sub GTK_IS_WIDGET_CLASS {
        my($klass) = @_;
	    eval q(( &GTK_CHECK_CLASS_TYPE (($klass),  &GTK_TYPE_WIDGET)));
    }' unless defined(&GTK_IS_WIDGET_CLASS);
    eval 'sub GTK_WIDGET_TYPE {
        my($wid) = @_;
	    eval q(( &GTK_OBJECT_TYPE ($wid)));
    }' unless defined(&GTK_WIDGET_TYPE);
    eval 'sub GTK_WIDGET_STATE {
        my($wid) = @_;
	    eval q(( &GTK_WIDGET ($wid)-> &state));
    }' unless defined(&GTK_WIDGET_STATE);
    eval 'sub GTK_WIDGET_SAVED_STATE {
        my($wid) = @_;
	    eval q(( &GTK_WIDGET ($wid)-> &saved_state));
    }' unless defined(&GTK_WIDGET_SAVED_STATE);
    eval 'sub GTK_WIDGET_FLAGS {
        my($wid) = @_;
	    eval q(( &GTK_OBJECT_FLAGS ($wid)));
    }' unless defined(&GTK_WIDGET_FLAGS);
    eval 'sub GTK_WIDGET_TOPLEVEL {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_TOPLEVEL) != 0));
    }' unless defined(&GTK_WIDGET_TOPLEVEL);
    eval 'sub GTK_WIDGET_NO_WINDOW {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_NO_WINDOW) != 0));
    }' unless defined(&GTK_WIDGET_NO_WINDOW);
    eval 'sub GTK_WIDGET_REALIZED {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_REALIZED) != 0));
    }' unless defined(&GTK_WIDGET_REALIZED);
    eval 'sub GTK_WIDGET_MAPPED {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_MAPPED) != 0));
    }' unless defined(&GTK_WIDGET_MAPPED);
    eval 'sub GTK_WIDGET_VISIBLE {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_VISIBLE) != 0));
    }' unless defined(&GTK_WIDGET_VISIBLE);
    eval 'sub GTK_WIDGET_DRAWABLE {
        my($wid) = @_;
	    eval q(( &GTK_WIDGET_VISIBLE ($wid)  &&  &GTK_WIDGET_MAPPED ($wid)));
    }' unless defined(&GTK_WIDGET_DRAWABLE);
    eval 'sub GTK_WIDGET_SENSITIVE {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_SENSITIVE) != 0));
    }' unless defined(&GTK_WIDGET_SENSITIVE);
    eval 'sub GTK_WIDGET_PARENT_SENSITIVE {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_PARENT_SENSITIVE) != 0));
    }' unless defined(&GTK_WIDGET_PARENT_SENSITIVE);
    eval 'sub GTK_WIDGET_IS_SENSITIVE {
        my($wid) = @_;
	    eval q(( &GTK_WIDGET_SENSITIVE ($wid)  &&  &GTK_WIDGET_PARENT_SENSITIVE ($wid)));
    }' unless defined(&GTK_WIDGET_IS_SENSITIVE);
    eval 'sub GTK_WIDGET_CAN_FOCUS {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_CAN_FOCUS) != 0));
    }' unless defined(&GTK_WIDGET_CAN_FOCUS);
    eval 'sub GTK_WIDGET_HAS_FOCUS {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_HAS_FOCUS) != 0));
    }' unless defined(&GTK_WIDGET_HAS_FOCUS);
    eval 'sub GTK_WIDGET_CAN_DEFAULT {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_CAN_DEFAULT) != 0));
    }' unless defined(&GTK_WIDGET_CAN_DEFAULT);
    eval 'sub GTK_WIDGET_HAS_DEFAULT {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_HAS_DEFAULT) != 0));
    }' unless defined(&GTK_WIDGET_HAS_DEFAULT);
    eval 'sub GTK_WIDGET_HAS_GRAB {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_HAS_GRAB) != 0));
    }' unless defined(&GTK_WIDGET_HAS_GRAB);
    eval 'sub GTK_WIDGET_RC_STYLE {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_RC_STYLE) != 0));
    }' unless defined(&GTK_WIDGET_RC_STYLE);
    eval 'sub GTK_WIDGET_COMPOSITE_CHILD {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_COMPOSITE_CHILD) != 0));
    }' unless defined(&GTK_WIDGET_COMPOSITE_CHILD);
    eval 'sub GTK_WIDGET_APP_PAINTABLE {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_APP_PAINTABLE) != 0));
    }' unless defined(&GTK_WIDGET_APP_PAINTABLE);
    eval 'sub GTK_WIDGET_RECEIVES_DEFAULT {
        my($wid) = @_;
	    eval q((( &GTK_WIDGET_FLAGS ($wid) &  &GTK_RECEIVES_DEFAULT) != 0));
    }' unless defined(&GTK_WIDGET_RECEIVES_DEFAULT);
    eval 'sub GTK_WIDGET_SET_FLAGS {
        my($wid,$flag) = @_;
	    eval q( &G_STMT_START{ ( &GTK_WIDGET_FLAGS ($wid) |= ($flag)); } &G_STMT_END);
    }' unless defined(&GTK_WIDGET_SET_FLAGS);
    eval 'sub GTK_WIDGET_UNSET_FLAGS {
        my($wid,$flag) = @_;
	    eval q( &G_STMT_START{ ( &GTK_WIDGET_FLAGS ($wid) &= ~($flag)); } &G_STMT_END);
    }' unless defined(&GTK_WIDGET_UNSET_FLAGS);
    if(defined ( &GTK_TRACE_OBJECTS)  && defined ( &__GNUC__)) {
	eval 'sub gtk_widget_ref () { &gtk_object_ref;}' unless defined(&gtk_widget_ref);
	eval 'sub gtk_widget_unref () { &gtk_object_unref;}' unless defined(&gtk_widget_unref);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
