require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LDAP_H)) {
    eval 'sub _LDAP_H () {1;}' unless defined(&_LDAP_H);
    require 'lber.ph';
    eval 'sub LDAP_VERSION1 () {1;}' unless defined(&LDAP_VERSION1);
    eval 'sub LDAP_VERSION2 () {2;}' unless defined(&LDAP_VERSION2);
    eval 'sub LDAP_VERSION3 () {3;}' unless defined(&LDAP_VERSION3);
    eval 'sub LDAP_VERSION_MIN () { &LDAP_VERSION2;}' unless defined(&LDAP_VERSION_MIN);
    eval 'sub LDAP_VERSION () { &LDAP_VERSION2;}' unless defined(&LDAP_VERSION);
    eval 'sub LDAP_VERSION_MAX () { &LDAP_VERSION3;}' unless defined(&LDAP_VERSION_MAX);
    eval 'sub LDAP_API_VERSION () {2004;}' unless defined(&LDAP_API_VERSION);
    eval 'sub LDAP_VENDOR_NAME () {"OpenLDAP";}' unless defined(&LDAP_VENDOR_NAME);
    eval 'sub LDAP_VENDOR_VERSION () {20026;}' unless defined(&LDAP_VENDOR_VERSION);
    eval 'sub LDAP_API_FEATURE_X_OPENLDAP () { &LDAP_VENDOR_VERSION;}' unless defined(&LDAP_API_FEATURE_X_OPENLDAP);
    require 'ldap_features.ph';
    if(defined( (defined(&LDAP_API_FEATURE_X_OPENLDAP_REENTRANT) ? &LDAP_API_FEATURE_X_OPENLDAP_REENTRANT : 0) ) || ( defined( (defined(&LDAP_THREAD_SAFE) ? &LDAP_THREAD_SAFE : 0) )  && defined( (defined(&LDAP_API_FEATURE_X_OPENLDAP_THREAD_SAFE) ? &LDAP_API_FEATURE_X_OPENLDAP_THREAD_SAFE : 0) ) )) {
	eval 'sub LDAP_API_FEATURE_THREAD_SAFE () {1;}' unless defined(&LDAP_API_FEATURE_THREAD_SAFE);
    }
    if(defined( (defined(&LDAP_THREAD_SAFE) ? &LDAP_THREAD_SAFE : 0) )  && defined( (defined(&LDAP_API_FEATURE_X_OPENLDAP_THREAD_SAFE) ? &LDAP_API_FEATURE_X_OPENLDAP_THREAD_SAFE : 0) )) {
    }
    eval 'sub LDAP_PORT () {389;}' unless defined(&LDAP_PORT);
    eval 'sub LDAPS_PORT () {636;}' unless defined(&LDAPS_PORT);
    eval 'sub LDAP_ROOT_DSE () {"";}' unless defined(&LDAP_ROOT_DSE);
    eval 'sub LDAP_NO_ATTRS () {"1.1";}' unless defined(&LDAP_NO_ATTRS);
    eval 'sub LDAP_ALL_USER_ATTRIBUTES () {"*";}' unless defined(&LDAP_ALL_USER_ATTRIBUTES);
    eval 'sub LDAP_ALL_OPERATIONAL_ATTRIBUTES () {"+";}' unless defined(&LDAP_ALL_OPERATIONAL_ATTRIBUTES);
    eval 'sub LDAP_OPT_API_INFO () {0x;}' unless defined(&LDAP_OPT_API_INFO);
    eval 'sub LDAP_OPT_DESC () {0x1;}' unless defined(&LDAP_OPT_DESC);
    eval 'sub LDAP_OPT_DEREF () {0x2;}' unless defined(&LDAP_OPT_DEREF);
    eval 'sub LDAP_OPT_SIZELIMIT () {0x3;}' unless defined(&LDAP_OPT_SIZELIMIT);
    eval 'sub LDAP_OPT_TIMELIMIT () {0x4;}' unless defined(&LDAP_OPT_TIMELIMIT);
    eval 'sub LDAP_OPT_REFERRALS () {0x8;}' unless defined(&LDAP_OPT_REFERRALS);
    eval 'sub LDAP_OPT_RESTART () {0x9;}' unless defined(&LDAP_OPT_RESTART);
    eval 'sub LDAP_OPT_PROTOCOL_VERSION () {0x11;}' unless defined(&LDAP_OPT_PROTOCOL_VERSION);
    eval 'sub LDAP_OPT_SERVER_CONTROLS () {0x12;}' unless defined(&LDAP_OPT_SERVER_CONTROLS);
    eval 'sub LDAP_OPT_CLIENT_CONTROLS () {0x13;}' unless defined(&LDAP_OPT_CLIENT_CONTROLS);
    eval 'sub LDAP_OPT_API_FEATURE_INFO () {0x15;}' unless defined(&LDAP_OPT_API_FEATURE_INFO);
    eval 'sub LDAP_OPT_HOST_NAME () {0x30;}' unless defined(&LDAP_OPT_HOST_NAME);
    eval 'sub LDAP_OPT_ERROR_NUMBER () {0x31;}' unless defined(&LDAP_OPT_ERROR_NUMBER);
    eval 'sub LDAP_OPT_ERROR_STRING () {0x32;}' unless defined(&LDAP_OPT_ERROR_STRING);
    eval 'sub LDAP_OPT_MATCHED_DN () {0x33;}' unless defined(&LDAP_OPT_MATCHED_DN);
    eval 'sub LDAP_OPT_PRIVATE_EXTENSION_BASE () {0x4000;}' unless defined(&LDAP_OPT_PRIVATE_EXTENSION_BASE);
    eval 'sub LDAP_OPT_DEBUG_LEVEL () {0x5001;}' unless defined(&LDAP_OPT_DEBUG_LEVEL);
    eval 'sub LDAP_OPT_TIMEOUT () {0x5002;}' unless defined(&LDAP_OPT_TIMEOUT);
    eval 'sub LDAP_OPT_REFHOPLIMIT () {0x5003;}' unless defined(&LDAP_OPT_REFHOPLIMIT);
    eval 'sub LDAP_OPT_NETWORK_TIMEOUT () {0x5005;}' unless defined(&LDAP_OPT_NETWORK_TIMEOUT);
    eval 'sub LDAP_OPT_URI () {0x5006;}' unless defined(&LDAP_OPT_URI);
    eval 'sub LDAP_OPT_X_TLS () {0x6000;}' unless defined(&LDAP_OPT_X_TLS);
    eval 'sub LDAP_OPT_X_TLS_CTX () {0x6001;}' unless defined(&LDAP_OPT_X_TLS_CTX);
    eval 'sub LDAP_OPT_X_TLS_CACERTFILE () {0x6002;}' unless defined(&LDAP_OPT_X_TLS_CACERTFILE);
    eval 'sub LDAP_OPT_X_TLS_CACERTDIR () {0x6003;}' unless defined(&LDAP_OPT_X_TLS_CACERTDIR);
    eval 'sub LDAP_OPT_X_TLS_CERTFILE () {0x6004;}' unless defined(&LDAP_OPT_X_TLS_CERTFILE);
    eval 'sub LDAP_OPT_X_TLS_KEYFILE () {0x6005;}' unless defined(&LDAP_OPT_X_TLS_KEYFILE);
    eval 'sub LDAP_OPT_X_TLS_REQUIRE_CERT () {0x6006;}' unless defined(&LDAP_OPT_X_TLS_REQUIRE_CERT);
    eval 'sub LDAP_OPT_X_TLS_CIPHER_SUITE () {0x6008;}' unless defined(&LDAP_OPT_X_TLS_CIPHER_SUITE);
    eval 'sub LDAP_OPT_X_TLS_RANDOM_FILE () {0x6009;}' unless defined(&LDAP_OPT_X_TLS_RANDOM_FILE);
    eval 'sub LDAP_OPT_X_TLS_NEVER () {0;}' unless defined(&LDAP_OPT_X_TLS_NEVER);
    eval 'sub LDAP_OPT_X_TLS_HARD () {1;}' unless defined(&LDAP_OPT_X_TLS_HARD);
    eval 'sub LDAP_OPT_X_TLS_DEMAND () {2;}' unless defined(&LDAP_OPT_X_TLS_DEMAND);
    eval 'sub LDAP_OPT_X_TLS_ALLOW () {3;}' unless defined(&LDAP_OPT_X_TLS_ALLOW);
    eval 'sub LDAP_OPT_X_TLS_TRY () {4;}' unless defined(&LDAP_OPT_X_TLS_TRY);
    eval 'sub LDAP_OPT_X_SASL_MECH () {0x6100;}' unless defined(&LDAP_OPT_X_SASL_MECH);
    eval 'sub LDAP_OPT_X_SASL_REALM () {0x6101;}' unless defined(&LDAP_OPT_X_SASL_REALM);
    eval 'sub LDAP_OPT_X_SASL_AUTHCID () {0x6102;}' unless defined(&LDAP_OPT_X_SASL_AUTHCID);
    eval 'sub LDAP_OPT_X_SASL_AUTHZID () {0x6103;}' unless defined(&LDAP_OPT_X_SASL_AUTHZID);
    eval 'sub LDAP_OPT_X_SASL_SSF () {0x6104;}' unless defined(&LDAP_OPT_X_SASL_SSF);
    eval 'sub LDAP_OPT_X_SASL_SSF_EXTERNAL () {0x6105;}' unless defined(&LDAP_OPT_X_SASL_SSF_EXTERNAL);
    eval 'sub LDAP_OPT_X_SASL_SECPROPS () {0x6106;}' unless defined(&LDAP_OPT_X_SASL_SECPROPS);
    eval 'sub LDAP_OPT_X_SASL_SSF_MIN () {0x6107;}' unless defined(&LDAP_OPT_X_SASL_SSF_MIN);
    eval 'sub LDAP_OPT_X_SASL_SSF_MAX () {0x6108;}' unless defined(&LDAP_OPT_X_SASL_SSF_MAX);
    eval 'sub LDAP_OPT_X_SASL_MAXBUFSIZE () {0x6109;}' unless defined(&LDAP_OPT_X_SASL_MAXBUFSIZE);
    eval 'sub LDAP_OPT_ON () {(( &void *) 1);}' unless defined(&LDAP_OPT_ON);
    eval 'sub LDAP_OPT_OFF () {(( &void *) 0);}' unless defined(&LDAP_OPT_OFF);
    eval 'sub LDAP_OPT_SUCCESS () {0;}' unless defined(&LDAP_OPT_SUCCESS);
    eval 'sub LDAP_OPT_ERROR () {(-1);}' unless defined(&LDAP_OPT_ERROR);
    eval 'sub LDAP_API_INFO_VERSION () {(1);}' unless defined(&LDAP_API_INFO_VERSION);
    eval 'sub LDAP_FEATURE_INFO_VERSION () {(1);}' unless defined(&LDAP_FEATURE_INFO_VERSION);
    if(defined(&undef)) {
	eval 'sub LDAP_CONTROL_REFERRALS () {"1.2.840.113666.1.4.616";}' unless defined(&LDAP_CONTROL_REFERRALS);
	eval 'sub LDAP_CHASE_SUBORDINATE_REFERRALS () {0x20;}' unless defined(&LDAP_CHASE_SUBORDINATE_REFERRALS);
	eval 'sub LDAP_CHASE_EXTERNAL_REFERRALS () {0x40;}' unless defined(&LDAP_CHASE_EXTERNAL_REFERRALS);
    }
    eval 'sub LDAP_CONTROL_MANAGEDSAIT () {"2.16.840.1.113730.3.4.2";}' unless defined(&LDAP_CONTROL_MANAGEDSAIT);
    eval 'sub LDAP_CONTROL_SORTREQUEST () {"1.2.840.113556.1.4.473";}' unless defined(&LDAP_CONTROL_SORTREQUEST);
    eval 'sub LDAP_CONTROL_SORTRESPONSE () {"1.2.840.113556.1.4.474";}' unless defined(&LDAP_CONTROL_SORTRESPONSE);
    eval 'sub LDAP_CONTROL_VLVREQUEST () {"2.16.840.1.113730.3.4.9";}' unless defined(&LDAP_CONTROL_VLVREQUEST);
    eval 'sub LDAP_CONTROL_VLVRESPONSE () {"2.16.840.1.113730.3.4.10";}' unless defined(&LDAP_CONTROL_VLVRESPONSE);
    eval 'sub LDAP_NOTICE_OF_DISCONNECTION () {"1.3.6.1.4.1.1466.20036";}' unless defined(&LDAP_NOTICE_OF_DISCONNECTION);
    eval 'sub LDAP_NOTICE_DISCONNECT () { &LDAP_NOTICE_OF_DISCONNECTION;}' unless defined(&LDAP_NOTICE_DISCONNECT);
    eval 'sub LDAP_EXOP_START_TLS () {"1.3.6.1.4.1.1466.20037";}' unless defined(&LDAP_EXOP_START_TLS);
    eval 'sub LDAP_EXOP_X_MODIFY_PASSWD () {"1.3.6.1.4.1.4203.1.11.1";}' unless defined(&LDAP_EXOP_X_MODIFY_PASSWD);
    eval 'sub LDAP_TAG_EXOP_X_MODIFY_PASSWD_ID () {(( &ber_tag_t) 0x80);}' unless defined(&LDAP_TAG_EXOP_X_MODIFY_PASSWD_ID);
    eval 'sub LDAP_TAG_EXOP_X_MODIFY_PASSWD_OLD () {(( &ber_tag_t) 0x81);}' unless defined(&LDAP_TAG_EXOP_X_MODIFY_PASSWD_OLD);
    eval 'sub LDAP_TAG_EXOP_X_MODIFY_PASSWD_NEW () {(( &ber_tag_t) 0x82);}' unless defined(&LDAP_TAG_EXOP_X_MODIFY_PASSWD_NEW);
    eval 'sub LDAP_TAG_EXOP_X_MODIFY_PASSWD_GEN () {(( &ber_tag_t) 0x80);}' unless defined(&LDAP_TAG_EXOP_X_MODIFY_PASSWD_GEN);
    eval 'sub LDAP_TAG_MESSAGE () {(( &ber_tag_t) 0x30);}' unless defined(&LDAP_TAG_MESSAGE);
    eval 'sub LDAP_TAG_MSGID () {(( &ber_tag_t) 0x2);}' unless defined(&LDAP_TAG_MSGID);
    eval 'sub LDAP_TAG_LDAPDN () {(( &ber_tag_t) 0x4);}' unless defined(&LDAP_TAG_LDAPDN);
    eval 'sub LDAP_TAG_LDAPCRED () {(( &ber_tag_t) 0x4);}' unless defined(&LDAP_TAG_LDAPCRED);
    eval 'sub LDAP_TAG_CONTROLS () {(( &ber_tag_t) 0xa0);}' unless defined(&LDAP_TAG_CONTROLS);
    eval 'sub LDAP_TAG_REFERRAL () {(( &ber_tag_t) 0xa3);}' unless defined(&LDAP_TAG_REFERRAL);
    eval 'sub LDAP_TAG_NEWSUPERIOR () {(( &ber_tag_t) 0x80);}' unless defined(&LDAP_TAG_NEWSUPERIOR);
    eval 'sub LDAP_TAG_EXOP_REQ_OID () {(( &ber_tag_t) 0x80);}' unless defined(&LDAP_TAG_EXOP_REQ_OID);
    eval 'sub LDAP_TAG_EXOP_REQ_VALUE () {(( &ber_tag_t) 0x81);}' unless defined(&LDAP_TAG_EXOP_REQ_VALUE);
    eval 'sub LDAP_TAG_EXOP_RES_OID () {(( &ber_tag_t) 0x8a);}' unless defined(&LDAP_TAG_EXOP_RES_OID);
    eval 'sub LDAP_TAG_EXOP_RES_VALUE () {(( &ber_tag_t) 0x8b);}' unless defined(&LDAP_TAG_EXOP_RES_VALUE);
    eval 'sub LDAP_TAG_SASL_RES_CREDS () {(( &ber_tag_t) 0x87);}' unless defined(&LDAP_TAG_SASL_RES_CREDS);
    eval 'sub LDAP_REQ_BIND () {(( &ber_tag_t) 0x60);}' unless defined(&LDAP_REQ_BIND);
    eval 'sub LDAP_REQ_UNBIND () {(( &ber_tag_t) 0x42);}' unless defined(&LDAP_REQ_UNBIND);
    eval 'sub LDAP_REQ_SEARCH () {(( &ber_tag_t) 0x63);}' unless defined(&LDAP_REQ_SEARCH);
    eval 'sub LDAP_REQ_MODIFY () {(( &ber_tag_t) 0x66);}' unless defined(&LDAP_REQ_MODIFY);
    eval 'sub LDAP_REQ_ADD () {(( &ber_tag_t) 0x68);}' unless defined(&LDAP_REQ_ADD);
    eval 'sub LDAP_REQ_DELETE () {(( &ber_tag_t) 0x4a);}' unless defined(&LDAP_REQ_DELETE);
    eval 'sub LDAP_REQ_MODDN () {(( &ber_tag_t) 0x6c);}' unless defined(&LDAP_REQ_MODDN);
    eval 'sub LDAP_REQ_MODRDN () { &LDAP_REQ_MODDN;}' unless defined(&LDAP_REQ_MODRDN);
    eval 'sub LDAP_REQ_RENAME () { &LDAP_REQ_MODDN;}' unless defined(&LDAP_REQ_RENAME);
    eval 'sub LDAP_REQ_COMPARE () {(( &ber_tag_t) 0x6e);}' unless defined(&LDAP_REQ_COMPARE);
    eval 'sub LDAP_REQ_ABANDON () {(( &ber_tag_t) 0x50);}' unless defined(&LDAP_REQ_ABANDON);
    eval 'sub LDAP_REQ_EXTENDED () {(( &ber_tag_t) 0x77);}' unless defined(&LDAP_REQ_EXTENDED);
    eval 'sub LDAP_RES_BIND () {(( &ber_tag_t) 0x61);}' unless defined(&LDAP_RES_BIND);
    eval 'sub LDAP_RES_SEARCH_ENTRY () {(( &ber_tag_t) 0x64);}' unless defined(&LDAP_RES_SEARCH_ENTRY);
    eval 'sub LDAP_RES_SEARCH_REFERENCE () {(( &ber_tag_t) 0x73);}' unless defined(&LDAP_RES_SEARCH_REFERENCE);
    eval 'sub LDAP_RES_SEARCH_RESULT () {(( &ber_tag_t) 0x65);}' unless defined(&LDAP_RES_SEARCH_RESULT);
    eval 'sub LDAP_RES_MODIFY () {(( &ber_tag_t) 0x67);}' unless defined(&LDAP_RES_MODIFY);
    eval 'sub LDAP_RES_ADD () {(( &ber_tag_t) 0x69);}' unless defined(&LDAP_RES_ADD);
    eval 'sub LDAP_RES_DELETE () {(( &ber_tag_t) 0x6b);}' unless defined(&LDAP_RES_DELETE);
    eval 'sub LDAP_RES_MODDN () {(( &ber_tag_t) 0x6d);}' unless defined(&LDAP_RES_MODDN);
    eval 'sub LDAP_RES_MODRDN () { &LDAP_RES_MODDN;}' unless defined(&LDAP_RES_MODRDN);
    eval 'sub LDAP_RES_RENAME () { &LDAP_RES_MODDN;}' unless defined(&LDAP_RES_RENAME);
    eval 'sub LDAP_RES_COMPARE () {(( &ber_tag_t) 0x6f);}' unless defined(&LDAP_RES_COMPARE);
    eval 'sub LDAP_RES_EXTENDED () {(( &ber_tag_t) 0x78);}' unless defined(&LDAP_RES_EXTENDED);
    eval 'sub LDAP_RES_EXTENDED_PARTIAL () {(( &ber_tag_t) 0x79);}' unless defined(&LDAP_RES_EXTENDED_PARTIAL);
    eval 'sub LDAP_RES_ANY () {(-1);}' unless defined(&LDAP_RES_ANY);
    eval 'sub LDAP_RES_UNSOLICITED () {(0);}' unless defined(&LDAP_RES_UNSOLICITED);
    eval 'sub LDAP_SASL_SIMPLE () {(0);}' unless defined(&LDAP_SASL_SIMPLE);
    eval 'sub LDAP_SASL_NULL () {("");}' unless defined(&LDAP_SASL_NULL);
    eval 'sub LDAP_AUTH_NONE () {(( &ber_tag_t) 0x);}' unless defined(&LDAP_AUTH_NONE);
    eval 'sub LDAP_AUTH_SIMPLE () {(( &ber_tag_t) 0x80);}' unless defined(&LDAP_AUTH_SIMPLE);
    eval 'sub LDAP_AUTH_SASL () {(( &ber_tag_t) 0xa3);}' unless defined(&LDAP_AUTH_SASL);
    eval 'sub LDAP_AUTH_KRBV4 () {(( &ber_tag_t) 0xff);}' unless defined(&LDAP_AUTH_KRBV4);
    eval 'sub LDAP_AUTH_KRBV41 () {(( &ber_tag_t) 0x81);}' unless defined(&LDAP_AUTH_KRBV41);
    eval 'sub LDAP_AUTH_KRBV42 () {(( &ber_tag_t) 0x82);}' unless defined(&LDAP_AUTH_KRBV42);
    eval 'sub LDAP_FILTER_AND () {(( &ber_tag_t) 0xa0);}' unless defined(&LDAP_FILTER_AND);
    eval 'sub LDAP_FILTER_OR () {(( &ber_tag_t) 0xa1);}' unless defined(&LDAP_FILTER_OR);
    eval 'sub LDAP_FILTER_NOT () {(( &ber_tag_t) 0xa2);}' unless defined(&LDAP_FILTER_NOT);
    eval 'sub LDAP_FILTER_EQUALITY () {(( &ber_tag_t) 0xa3);}' unless defined(&LDAP_FILTER_EQUALITY);
    eval 'sub LDAP_FILTER_SUBSTRINGS () {(( &ber_tag_t) 0xa4);}' unless defined(&LDAP_FILTER_SUBSTRINGS);
    eval 'sub LDAP_FILTER_GE () {(( &ber_tag_t) 0xa5);}' unless defined(&LDAP_FILTER_GE);
    eval 'sub LDAP_FILTER_LE () {(( &ber_tag_t) 0xa6);}' unless defined(&LDAP_FILTER_LE);
    eval 'sub LDAP_FILTER_PRESENT () {(( &ber_tag_t) 0x87);}' unless defined(&LDAP_FILTER_PRESENT);
    eval 'sub LDAP_FILTER_APPROX () {(( &ber_tag_t) 0xa8);}' unless defined(&LDAP_FILTER_APPROX);
    eval 'sub LDAP_FILTER_EXT () {(( &ber_tag_t) 0xa9);}' unless defined(&LDAP_FILTER_EXT);
    eval 'sub LDAP_FILTER_EXT_OID () {(( &ber_tag_t) 0x81);}' unless defined(&LDAP_FILTER_EXT_OID);
    eval 'sub LDAP_FILTER_EXT_TYPE () {(( &ber_tag_t) 0x82);}' unless defined(&LDAP_FILTER_EXT_TYPE);
    eval 'sub LDAP_FILTER_EXT_VALUE () {(( &ber_tag_t) 0x83);}' unless defined(&LDAP_FILTER_EXT_VALUE);
    eval 'sub LDAP_FILTER_EXT_DNATTRS () {(( &ber_tag_t) 0x84);}' unless defined(&LDAP_FILTER_EXT_DNATTRS);
    eval 'sub LDAP_SUBSTRING_INITIAL () {(( &ber_tag_t) 0x80);}' unless defined(&LDAP_SUBSTRING_INITIAL);
    eval 'sub LDAP_SUBSTRING_ANY () {(( &ber_tag_t) 0x81);}' unless defined(&LDAP_SUBSTRING_ANY);
    eval 'sub LDAP_SUBSTRING_FINAL () {(( &ber_tag_t) 0x82);}' unless defined(&LDAP_SUBSTRING_FINAL);
    eval 'sub LDAP_SCOPE_DEFAULT () {(( &ber_int_t) -1);}' unless defined(&LDAP_SCOPE_DEFAULT);
    eval 'sub LDAP_SCOPE_BASE () {(( &ber_int_t) 0x);}' unless defined(&LDAP_SCOPE_BASE);
    eval 'sub LDAP_SCOPE_ONELEVEL () {(( &ber_int_t) 0x1);}' unless defined(&LDAP_SCOPE_ONELEVEL);
    eval 'sub LDAP_SCOPE_SUBTREE () {(( &ber_int_t) 0x2);}' unless defined(&LDAP_SCOPE_SUBTREE);
    eval 'sub LDAP_SUBSTRING_INITIAL () {(( &ber_tag_t) 0x80);}' unless defined(&LDAP_SUBSTRING_INITIAL);
    eval 'sub LDAP_SUBSTRING_ANY () {(( &ber_tag_t) 0x81);}' unless defined(&LDAP_SUBSTRING_ANY);
    eval 'sub LDAP_SUBSTRING_FINAL () {(( &ber_tag_t) 0x82);}' unless defined(&LDAP_SUBSTRING_FINAL);
    eval 'sub LDAP_RANGE {
        my($n,$x,$y) = @_;
	    eval q(((($x) <= ($n))  && (($n) <= ($y))));
    }' unless defined(&LDAP_RANGE);
    eval 'sub LDAP_SUCCESS () {0x;}' unless defined(&LDAP_SUCCESS);
    eval 'sub LDAP_OPERATIONS_ERROR () {0x1;}' unless defined(&LDAP_OPERATIONS_ERROR);
    eval 'sub LDAP_PROTOCOL_ERROR () {0x2;}' unless defined(&LDAP_PROTOCOL_ERROR);
    eval 'sub LDAP_TIMELIMIT_EXCEEDED () {0x3;}' unless defined(&LDAP_TIMELIMIT_EXCEEDED);
    eval 'sub LDAP_SIZELIMIT_EXCEEDED () {0x4;}' unless defined(&LDAP_SIZELIMIT_EXCEEDED);
    eval 'sub LDAP_COMPARE_FALSE () {0x5;}' unless defined(&LDAP_COMPARE_FALSE);
    eval 'sub LDAP_COMPARE_TRUE () {0x6;}' unless defined(&LDAP_COMPARE_TRUE);
    eval 'sub LDAP_AUTH_METHOD_NOT_SUPPORTED () {0x7;}' unless defined(&LDAP_AUTH_METHOD_NOT_SUPPORTED);
    eval 'sub LDAP_STRONG_AUTH_NOT_SUPPORTED () { &LDAP_AUTH_METHOD_NOT_SUPPORTED;}' unless defined(&LDAP_STRONG_AUTH_NOT_SUPPORTED);
    eval 'sub LDAP_STRONG_AUTH_REQUIRED () {0x8;}' unless defined(&LDAP_STRONG_AUTH_REQUIRED);
    eval 'sub LDAP_PARTIAL_RESULTS () {0x9;}' unless defined(&LDAP_PARTIAL_RESULTS);
    eval 'sub LDAP_REFERRAL () {0xa;}' unless defined(&LDAP_REFERRAL);
    eval 'sub LDAP_ADMINLIMIT_EXCEEDED () {0xb;}' unless defined(&LDAP_ADMINLIMIT_EXCEEDED);
    eval 'sub LDAP_UNAVAILABLE_CRITICAL_EXTENSION () {0xc;}' unless defined(&LDAP_UNAVAILABLE_CRITICAL_EXTENSION);
    eval 'sub LDAP_CONFIDENTIALITY_REQUIRED () {0xd;}' unless defined(&LDAP_CONFIDENTIALITY_REQUIRED);
    eval 'sub LDAP_SASL_BIND_IN_PROGRESS () {0xe;}' unless defined(&LDAP_SASL_BIND_IN_PROGRESS);
    eval 'sub LDAP_ATTR_ERROR {
        my($n) = @_;
	    eval q( &LDAP_RANGE(($n),0x10,0x15));
    }' unless defined(&LDAP_ATTR_ERROR);
    eval 'sub LDAP_NO_SUCH_ATTRIBUTE () {0x10;}' unless defined(&LDAP_NO_SUCH_ATTRIBUTE);
    eval 'sub LDAP_UNDEFINED_TYPE () {0x11;}' unless defined(&LDAP_UNDEFINED_TYPE);
    eval 'sub LDAP_INAPPROPRIATE_MATCHING () {0x12;}' unless defined(&LDAP_INAPPROPRIATE_MATCHING);
    eval 'sub LDAP_CONSTRAINT_VIOLATION () {0x13;}' unless defined(&LDAP_CONSTRAINT_VIOLATION);
    eval 'sub LDAP_TYPE_OR_VALUE_EXISTS () {0x14;}' unless defined(&LDAP_TYPE_OR_VALUE_EXISTS);
    eval 'sub LDAP_INVALID_SYNTAX () {0x15;}' unless defined(&LDAP_INVALID_SYNTAX);
    eval 'sub LDAP_NAME_ERROR {
        my($n) = @_;
	    eval q( &LDAP_RANGE(($n),0x20,0x24));
    }' unless defined(&LDAP_NAME_ERROR);
    eval 'sub LDAP_NO_SUCH_OBJECT () {0x20;}' unless defined(&LDAP_NO_SUCH_OBJECT);
    eval 'sub LDAP_ALIAS_PROBLEM () {0x21;}' unless defined(&LDAP_ALIAS_PROBLEM);
    eval 'sub LDAP_INVALID_DN_SYNTAX () {0x22;}' unless defined(&LDAP_INVALID_DN_SYNTAX);
    eval 'sub LDAP_IS_LEAF () {0x23;}' unless defined(&LDAP_IS_LEAF);
    eval 'sub LDAP_ALIAS_DEREF_PROBLEM () {0x24;}' unless defined(&LDAP_ALIAS_DEREF_PROBLEM);
    eval 'sub LDAP_SECURITY_ERROR {
        my($n) = @_;
	    eval q( &LDAP_RANGE(($n),0x30,0x32));
    }' unless defined(&LDAP_SECURITY_ERROR);
    eval 'sub LDAP_INAPPROPRIATE_AUTH () {0x30;}' unless defined(&LDAP_INAPPROPRIATE_AUTH);
    eval 'sub LDAP_INVALID_CREDENTIALS () {0x31;}' unless defined(&LDAP_INVALID_CREDENTIALS);
    eval 'sub LDAP_INSUFFICIENT_ACCESS () {0x32;}' unless defined(&LDAP_INSUFFICIENT_ACCESS);
    eval 'sub LDAP_SERVICE_ERROR {
        my($n) = @_;
	    eval q( &LDAP_RANGE(($n),0x33,0x36));
    }' unless defined(&LDAP_SERVICE_ERROR);
    eval 'sub LDAP_BUSY () {0x33;}' unless defined(&LDAP_BUSY);
    eval 'sub LDAP_UNAVAILABLE () {0x34;}' unless defined(&LDAP_UNAVAILABLE);
    eval 'sub LDAP_UNWILLING_TO_PERFORM () {0x35;}' unless defined(&LDAP_UNWILLING_TO_PERFORM);
    eval 'sub LDAP_LOOP_DETECT () {0x36;}' unless defined(&LDAP_LOOP_DETECT);
    eval 'sub LDAP_UPDATE_ERROR {
        my($n) = @_;
	    eval q( &LDAP_RANGE(($n),0x40,0x47));
    }' unless defined(&LDAP_UPDATE_ERROR);
    eval 'sub LDAP_NAMING_VIOLATION () {0x40;}' unless defined(&LDAP_NAMING_VIOLATION);
    eval 'sub LDAP_OBJECT_CLASS_VIOLATION () {0x41;}' unless defined(&LDAP_OBJECT_CLASS_VIOLATION);
    eval 'sub LDAP_NOT_ALLOWED_ON_NONLEAF () {0x42;}' unless defined(&LDAP_NOT_ALLOWED_ON_NONLEAF);
    eval 'sub LDAP_NOT_ALLOWED_ON_RDN () {0x43;}' unless defined(&LDAP_NOT_ALLOWED_ON_RDN);
    eval 'sub LDAP_ALREADY_EXISTS () {0x44;}' unless defined(&LDAP_ALREADY_EXISTS);
    eval 'sub LDAP_NO_OBJECT_CLASS_MODS () {0x45;}' unless defined(&LDAP_NO_OBJECT_CLASS_MODS);
    eval 'sub LDAP_RESULTS_TOO_LARGE () {0x46;}' unless defined(&LDAP_RESULTS_TOO_LARGE);
    eval 'sub LDAP_AFFECTS_MULTIPLE_DSAS () {0x47;}' unless defined(&LDAP_AFFECTS_MULTIPLE_DSAS);
    eval 'sub LDAP_OTHER () {0x50;}' unless defined(&LDAP_OTHER);
    eval 'sub LDAP_API_ERROR {
        my($n) = @_;
	    eval q( &LDAP_RANGE(($n),0x51,0x61));
    }' unless defined(&LDAP_API_ERROR);
    eval 'sub LDAP_API_RESULT {
        my($n) = @_;
	    eval q(((($n) ==  &LDAP_SUCCESS) ||  &LDAP_RANGE(($n),0x51,0x61)));
    }' unless defined(&LDAP_API_RESULT);
    eval 'sub LDAP_SERVER_DOWN () {0x51;}' unless defined(&LDAP_SERVER_DOWN);
    eval 'sub LDAP_LOCAL_ERROR () {0x52;}' unless defined(&LDAP_LOCAL_ERROR);
    eval 'sub LDAP_ENCODING_ERROR () {0x53;}' unless defined(&LDAP_ENCODING_ERROR);
    eval 'sub LDAP_DECODING_ERROR () {0x54;}' unless defined(&LDAP_DECODING_ERROR);
    eval 'sub LDAP_TIMEOUT () {0x55;}' unless defined(&LDAP_TIMEOUT);
    eval 'sub LDAP_AUTH_UNKNOWN () {0x56;}' unless defined(&LDAP_AUTH_UNKNOWN);
    eval 'sub LDAP_FILTER_ERROR () {0x57;}' unless defined(&LDAP_FILTER_ERROR);
    eval 'sub LDAP_USER_CANCELLED () {0x58;}' unless defined(&LDAP_USER_CANCELLED);
    eval 'sub LDAP_PARAM_ERROR () {0x59;}' unless defined(&LDAP_PARAM_ERROR);
    eval 'sub LDAP_NO_MEMORY () {0x5a;}' unless defined(&LDAP_NO_MEMORY);
    eval 'sub LDAP_CONNECT_ERROR () {0x5b;}' unless defined(&LDAP_CONNECT_ERROR);
    eval 'sub LDAP_NOT_SUPPORTED () {0x5c;}' unless defined(&LDAP_NOT_SUPPORTED);
    eval 'sub LDAP_CONTROL_NOT_FOUND () {0x5d;}' unless defined(&LDAP_CONTROL_NOT_FOUND);
    eval 'sub LDAP_NO_RESULTS_RETURNED () {0x5e;}' unless defined(&LDAP_NO_RESULTS_RETURNED);
    eval 'sub LDAP_MORE_RESULTS_TO_RETURN () {0x5f;}' unless defined(&LDAP_MORE_RESULTS_TO_RETURN);
    eval 'sub LDAP_CLIENT_LOOP () {0x60;}' unless defined(&LDAP_CLIENT_LOOP);
    eval 'sub LDAP_REFERRAL_LIMIT_EXCEEDED () {0x61;}' unless defined(&LDAP_REFERRAL_LIMIT_EXCEEDED);
    eval 'sub LDAP_MOD_ADD () {(( &ber_int_t) 0x);}' unless defined(&LDAP_MOD_ADD);
    eval 'sub LDAP_MOD_DELETE () {(( &ber_int_t) 0x1);}' unless defined(&LDAP_MOD_DELETE);
    eval 'sub LDAP_MOD_REPLACE () {(( &ber_int_t) 0x2);}' unless defined(&LDAP_MOD_REPLACE);
    eval 'sub LDAP_MOD_BVALUES () {(( &ber_int_t) 0x80);}' unless defined(&LDAP_MOD_BVALUES);
    eval 'sub mod_values () { ($mod_vals->{modv_strvals});}' unless defined(&mod_values);
    eval 'sub mod_bvalues () { ($mod_vals->{modv_bvals});}' unless defined(&mod_bvalues);
    eval 'sub LDAP_FILT_MAXSIZ () {1024;}' unless defined(&LDAP_FILT_MAXSIZ);
    eval 'sub LDAP_DEREF_NEVER () {0x;}' unless defined(&LDAP_DEREF_NEVER);
    eval 'sub LDAP_DEREF_SEARCHING () {0x1;}' unless defined(&LDAP_DEREF_SEARCHING);
    eval 'sub LDAP_DEREF_FINDING () {0x2;}' unless defined(&LDAP_DEREF_FINDING);
    eval 'sub LDAP_DEREF_ALWAYS () {0x3;}' unless defined(&LDAP_DEREF_ALWAYS);
    eval 'sub LDAP_NO_LIMIT () {0;}' unless defined(&LDAP_NO_LIMIT);
    eval 'sub LDAP_MSG_ONE () {0x;}' unless defined(&LDAP_MSG_ONE);
    eval 'sub LDAP_MSG_ALL () {0x1;}' unless defined(&LDAP_MSG_ALL);
    eval 'sub LDAP_MSG_RECEIVED () {0x2;}' unless defined(&LDAP_MSG_RECEIVED);
    eval 'sub LDAP_URL_SUCCESS () {0x;}' unless defined(&LDAP_URL_SUCCESS);
    eval 'sub LDAP_URL_ERR_MEM () {0x1;}' unless defined(&LDAP_URL_ERR_MEM);
    eval 'sub LDAP_URL_ERR_PARAM () {0x2;}' unless defined(&LDAP_URL_ERR_PARAM);
    eval 'sub LDAP_URL_ERR_BADSCHEME () {0x3;}' unless defined(&LDAP_URL_ERR_BADSCHEME);
    eval 'sub LDAP_URL_ERR_BADENCLOSURE () {0x4;}' unless defined(&LDAP_URL_ERR_BADENCLOSURE);
    eval 'sub LDAP_URL_ERR_BADURL () {0x5;}' unless defined(&LDAP_URL_ERR_BADURL);
    eval 'sub LDAP_URL_ERR_BADHOST () {0x6;}' unless defined(&LDAP_URL_ERR_BADHOST);
    eval 'sub LDAP_URL_ERR_BADATTRS () {0x7;}' unless defined(&LDAP_URL_ERR_BADATTRS);
    eval 'sub LDAP_URL_ERR_BADSCOPE () {0x8;}' unless defined(&LDAP_URL_ERR_BADSCOPE);
    eval 'sub LDAP_URL_ERR_BADFILTER () {0x9;}' unless defined(&LDAP_URL_ERR_BADFILTER);
    eval 'sub LDAP_URL_ERR_BADEXTS () {0xa;}' unless defined(&LDAP_URL_ERR_BADEXTS);
    eval 'sub LDAP_SASL_AUTOMATIC () {0;}' unless defined(&LDAP_SASL_AUTOMATIC);
    eval 'sub LDAP_SASL_INTERACTIVE () {1;}' unless defined(&LDAP_SASL_INTERACTIVE);
    eval 'sub LDAP_SASL_QUIET () {2;}' unless defined(&LDAP_SASL_QUIET);
}
1;
