require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LIBAIO_H)) {
    eval 'sub __LIBAIO_H () {1;}' unless defined(&__LIBAIO_H);
    if(defined(&__cplusplus)) {
    }
    require 'asm/types.ph';
    require 'string.ph';
    eval("sub IO_CMD_PREAD () { 0; }") unless defined(&IO_CMD_PREAD);
    eval("sub IO_CMD_PWRITE () { 1; }") unless defined(&IO_CMD_PWRITE);
    eval("sub IO_CMD_FSYNC () { 2; }") unless defined(&IO_CMD_FSYNC);
    eval("sub IO_CMD_FDSYNC () { 3; }") unless defined(&IO_CMD_FDSYNC);
    eval("sub IO_CMD_POLL () { 5; }") unless defined(&IO_CMD_POLL);
    eval("sub IO_CMD_NOOP () { 6; }") unless defined(&IO_CMD_NOOP);
    if(defined( &__i386__) ) {
	eval 'sub PADDED {
	    my($x, $y) = @_;
    	    eval q($x; \'unsigned y\');
	}' unless defined(&PADDED);
	eval 'sub PADDEDptr {
	    my($x, $y) = @_;
    	    eval q($x; \'unsigned y\');
	}' unless defined(&PADDEDptr);
	eval 'sub PADDEDul {
	    my($x, $y) = @_;
    	    eval q(\'unsigned long x\'; \'unsigned y\');
	}' unless defined(&PADDEDul);
    }
 elsif(defined( &__ia64__) || defined( &__x86_64__)) {
	eval 'sub PADDED {
	    my($x, $y) = @_;
    	    eval q($x, $y);
	}' unless defined(&PADDED);
	eval 'sub PADDEDptr {
	    my($x, $y) = @_;
    	    eval q($x);
	}' unless defined(&PADDEDptr);
	eval 'sub PADDEDul {
	    my($x, $y) = @_;
    	    eval q(\'unsigned long x\');
	}' unless defined(&PADDEDul);
    }
 elsif(defined( &__powerpc64__) ) {
	eval 'sub PADDED {
	    my($x, $y) = @_;
    	    eval q(\'unsigned y\'; $x);
	}' unless defined(&PADDED);
	eval 'sub PADDEDptr {
	    my($x,$y) = @_;
    	    eval q($x);
	}' unless defined(&PADDEDptr);
	eval 'sub PADDEDul {
	    my($x, $y) = @_;
    	    eval q(\'unsigned long x\');
	}' unless defined(&PADDEDul);
    }
 elsif(defined( &__PPC__) ) {
	eval 'sub PADDED {
	    my($x, $y) = @_;
    	    eval q(\'unsigned y\'; $x);
	}' unless defined(&PADDED);
	eval 'sub PADDEDptr {
	    my($x, $y) = @_;
    	    eval q(\'unsigned y\'; $x);
	}' unless defined(&PADDEDptr);
	eval 'sub PADDEDul {
	    my($x, $y) = @_;
    	    eval q(\'unsigned y\'; \'unsigned long x\');
	}' unless defined(&PADDEDul);
    }
 elsif(defined( &__s390x__) ) {
	eval 'sub PADDED {
	    my($x, $y) = @_;
    	    eval q(\'unsigned y\'; $x);
	}' unless defined(&PADDED);
	eval 'sub PADDEDptr {
	    my($x,$y) = @_;
    	    eval q($x);
	}' unless defined(&PADDEDptr);
	eval 'sub PADDEDul {
	    my($x, $y) = @_;
    	    eval q(\'unsigned long x\');
	}' unless defined(&PADDEDul);
    }
 elsif(defined( &__s390__) ) {
	eval 'sub PADDED {
	    my($x, $y) = @_;
    	    eval q(\'unsigned y\'; $x);
	}' unless defined(&PADDED);
	eval 'sub PADDEDptr {
	    my($x, $y) = @_;
    	    eval q(\'unsigned y\'; $x);
	}' unless defined(&PADDEDptr);
	eval 'sub PADDEDul {
	    my($x, $y) = @_;
    	    eval q(\'unsigned y\'; \'unsigned long x\');
	}' unless defined(&PADDEDul);
    } else {
	die("endian\?");
    }
    undef(&PADDED) if defined(&PADDED);
    undef(&PADDEDptr) if defined(&PADDEDptr);
    undef(&PADDEDul) if defined(&PADDEDul);
    eval 'sub io_set_callback {
        my($iocb,$cb) = @_;
	    eval q({  ($iocb->{data}) = ( &void *)$cb; });
    }' unless defined(&io_set_callback);
    eval 'sub io_prep_pread {
        my($iocb,$fd,$buf,$count,$offset) = @_;
	    eval q({  &memset($iocb, 0, $sizeof{$iocb});  ($iocb->{aio_fildes}) = $fd;  ($iocb->{aio_lio_opcode}) =  &IO_CMD_PREAD;  ($iocb->{aio_reqprio}) = 0;  ($iocb->{u}->{c}->{buf}) = $buf;  ($iocb->{u}->{c}->{nbytes}) = $count;  ($iocb->{u}->{c}->{offset}) = $offset; });
    }' unless defined(&io_prep_pread);
    eval 'sub io_prep_pwrite {
        my($iocb,$fd,$buf,$count,$offset) = @_;
	    eval q({  &memset($iocb, 0, $sizeof{$iocb});  ($iocb->{aio_fildes}) = $fd;  ($iocb->{aio_lio_opcode}) =  &IO_CMD_PWRITE;  ($iocb->{aio_reqprio}) = 0;  ($iocb->{u}->{c}->{buf}) = $buf;  ($iocb->{u}->{c}->{nbytes}) = $count;  ($iocb->{u}->{c}->{offset}) = $offset; });
    }' unless defined(&io_prep_pwrite);
    eval 'sub io_prep_poll {
        my($iocb,$fd,$events) = @_;
	    eval q({  &memset($iocb, 0, $sizeof{$iocb});  ($iocb->{aio_fildes}) = $fd;  ($iocb->{aio_lio_opcode}) =  &IO_CMD_POLL;  ($iocb->{aio_reqprio}) = 0;  ($iocb->{u}->{poll}->{events}) = $events; });
    }' unless defined(&io_prep_poll);
    eval 'sub io_poll {
        my($ctx,$iocb,$cb,$fd,$events) = @_;
	    eval q({  &io_prep_poll($iocb, $fd, $events);  &io_set_callback($iocb, $cb);  &io_submit($ctx, 1, $iocb); });
    }' unless defined(&io_poll);
    eval 'sub io_prep_fsync {
        my($iocb,$fd) = @_;
	    eval q({  &memset($iocb, 0, $sizeof{$iocb});  ($iocb->{aio_fildes}) = $fd;  ($iocb->{aio_lio_opcode}) =  &IO_CMD_FSYNC;  ($iocb->{aio_reqprio}) = 0; });
    }' unless defined(&io_prep_fsync);
    eval 'sub io_fsync {
        my($ctx,$iocb,$cb,$fd) = @_;
	    eval q({  &io_prep_fsync($iocb, $fd);  &io_set_callback($iocb, $cb);  &io_submit($ctx, 1, $iocb); });
    }' unless defined(&io_fsync);
    eval 'sub io_prep_fdsync {
        my($iocb,$fd) = @_;
	    eval q({  &memset($iocb, 0, $sizeof{$iocb});  ($iocb->{aio_fildes}) = $fd;  ($iocb->{aio_lio_opcode}) =  &IO_CMD_FDSYNC;  ($iocb->{aio_reqprio}) = 0; });
    }' unless defined(&io_prep_fdsync);
    eval 'sub io_fdsync {
        my($ctx,$iocb,$cb,$fd) = @_;
	    eval q({  &io_prep_fdsync($iocb, $fd);  &io_set_callback($iocb, $cb);  &io_submit($ctx, 1, $iocb); });
    }' unless defined(&io_fdsync);
    if(defined(&__cplusplus)) {
    }
}
1;
