require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__XML_PARSER_INTERNALS_H__)) {
    eval 'sub __XML_PARSER_INTERNALS_H__ () {1;}' unless defined(&__XML_PARSER_INTERNALS_H__);
    require 'libxml/parser.ph';
    require 'libxml/HTMLparser.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub XML_MAX_NAMELEN () {100;}' unless defined(&XML_MAX_NAMELEN);
    eval 'sub INPUT_CHUNK () {250;}' unless defined(&INPUT_CHUNK);
    eval 'sub IS_CHAR {
        my($c) = @_;
	    eval q((((($c) >= 0x20)  && (($c) <= 0xd7ff)) || (($c) == 0x9) || (($c) == 0xa) || (($c) == 0xd) || ((($c) >= 0xe000)  && (($c) <= 0xfffd)) || ((($c) >= 0x10000)  && (($c) <= 0x10ffff))));
    }' unless defined(&IS_CHAR);
    eval 'sub IS_BLANK {
        my($c) = @_;
	    eval q(((($c) == 0x20) || (($c) == 0x9) || (($c) == 0xa) || (($c) == 0xd)));
    }' unless defined(&IS_BLANK);
    eval 'sub IS_BASECHAR {
        my($c) = @_;
	    eval q( &xmlIsBaseChar($c));
    }' unless defined(&IS_BASECHAR);
    eval 'sub IS_DIGIT {
        my($c) = @_;
	    eval q( &xmlIsDigit($c));
    }' unless defined(&IS_DIGIT);
    eval 'sub IS_COMBINING {
        my($c) = @_;
	    eval q( &xmlIsCombining($c));
    }' unless defined(&IS_COMBINING);
    eval 'sub IS_EXTENDER {
        my($c) = @_;
	    eval q( &xmlIsExtender($c));
    }' unless defined(&IS_EXTENDER);
    eval 'sub IS_IDEOGRAPHIC {
        my($c) = @_;
	    eval q( &xmlIsIdeographic($c));
    }' unless defined(&IS_IDEOGRAPHIC);
    eval 'sub IS_LETTER {
        my($c) = @_;
	    eval q(( &IS_BASECHAR($c) ||  &IS_IDEOGRAPHIC($c)));
    }' unless defined(&IS_LETTER);
    eval 'sub IS_PUBIDCHAR {
        my($c) = @_;
	    eval q( &xmlIsPubidChar($c));
    }' unless defined(&IS_PUBIDCHAR);
    eval 'sub SKIP_EOL {
        my($p) = @_;
	    eval q( &if (*($p) == 0x13) { $p++ ;  &if (*($p) == 0x10) $p++; }  &if (*($p) == 0x10) { $p++ ;  &if (*($p) == 0x13) $p++; });
    }' unless defined(&SKIP_EOL);
    eval 'sub MOVETO_ENDTAG {
        my($p) = @_;
	    eval q( &while ((*$p)  && (*($p) != ord(\'>\'))) ($p)++);
    }' unless defined(&MOVETO_ENDTAG);
    eval 'sub MOVETO_STARTTAG {
        my($p) = @_;
	    eval q( &while ((*$p)  && (*($p) != ord(\'<\'))) ($p)++);
    }' unless defined(&MOVETO_STARTTAG);
    eval 'sub XML_SUBSTITUTE_NONE () {0;}' unless defined(&XML_SUBSTITUTE_NONE);
    eval 'sub XML_SUBSTITUTE_REF () {1;}' unless defined(&XML_SUBSTITUTE_REF);
    eval 'sub XML_SUBSTITUTE_PEREF () {2;}' unless defined(&XML_SUBSTITUTE_PEREF);
    eval 'sub XML_SUBSTITUTE_BOTH () {3;}' unless defined(&XML_SUBSTITUTE_BOTH);
    if(defined(&LIBXML_HTML_ENABLED)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
