require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_mysql_com_h)) {
    eval 'sub _mysql_com_h () {1;}' unless defined(&_mysql_com_h);
    eval 'sub NAME_LEN () {64;}' unless defined(&NAME_LEN);
    eval 'sub HOSTNAME_LENGTH () {60;}' unless defined(&HOSTNAME_LENGTH);
    eval 'sub USERNAME_LENGTH () {16;}' unless defined(&USERNAME_LENGTH);
    eval 'sub SERVER_VERSION_LENGTH () {60;}' unless defined(&SERVER_VERSION_LENGTH);
    eval 'sub LOCAL_HOST () {"localhost";}' unless defined(&LOCAL_HOST);
    eval 'sub LOCAL_HOST_NAMEDPIPE () {".";}' unless defined(&LOCAL_HOST_NAMEDPIPE);
    if(defined( &__WIN__)  && !defined( (defined(&_CUSTOMCONFIG_) ? &_CUSTOMCONFIG_ : 0))) {
	eval 'sub MYSQL_NAMEDPIPE () {"MySQL";}' unless defined(&MYSQL_NAMEDPIPE);
	eval 'sub MYSQL_SERVICENAME () {"MySql";}' unless defined(&MYSQL_SERVICENAME);
    }
    eval("sub COM_SLEEP () { 0; }") unless defined(&COM_SLEEP);
    eval("sub COM_QUIT () { 1; }") unless defined(&COM_QUIT);
    eval("sub COM_INIT_DB () { 2; }") unless defined(&COM_INIT_DB);
    eval("sub COM_QUERY () { 3; }") unless defined(&COM_QUERY);
    eval("sub COM_FIELD_LIST () { 4; }") unless defined(&COM_FIELD_LIST);
    eval("sub COM_CREATE_DB () { 5; }") unless defined(&COM_CREATE_DB);
    eval("sub COM_DROP_DB () { 6; }") unless defined(&COM_DROP_DB);
    eval("sub COM_REFRESH () { 7; }") unless defined(&COM_REFRESH);
    eval("sub COM_SHUTDOWN () { 8; }") unless defined(&COM_SHUTDOWN);
    eval("sub COM_STATISTICS () { 9; }") unless defined(&COM_STATISTICS);
    eval("sub COM_PROCESS_INFO () { 10; }") unless defined(&COM_PROCESS_INFO);
    eval("sub COM_CONNECT () { 11; }") unless defined(&COM_CONNECT);
    eval("sub COM_PROCESS_KILL () { 12; }") unless defined(&COM_PROCESS_KILL);
    eval("sub COM_DEBUG () { 13; }") unless defined(&COM_DEBUG);
    eval("sub COM_PING () { 14; }") unless defined(&COM_PING);
    eval("sub COM_TIME () { 15; }") unless defined(&COM_TIME);
    eval("sub COM_DELAYED_INSERT () { 16; }") unless defined(&COM_DELAYED_INSERT);
    eval("sub COM_CHANGE_USER () { 17; }") unless defined(&COM_CHANGE_USER);
    eval("sub COM_BINLOG_DUMP () { 18; }") unless defined(&COM_BINLOG_DUMP);
    eval("sub COM_TABLE_DUMP () { 19; }") unless defined(&COM_TABLE_DUMP);
    eval("sub COM_CONNECT_OUT () { 20; }") unless defined(&COM_CONNECT_OUT);
    eval 'sub NOT_NULL_FLAG () {1;}' unless defined(&NOT_NULL_FLAG);
    eval 'sub PRI_KEY_FLAG () {2;}' unless defined(&PRI_KEY_FLAG);
    eval 'sub UNIQUE_KEY_FLAG () {4;}' unless defined(&UNIQUE_KEY_FLAG);
    eval 'sub MULTIPLE_KEY_FLAG () {8;}' unless defined(&MULTIPLE_KEY_FLAG);
    eval 'sub BLOB_FLAG () {16;}' unless defined(&BLOB_FLAG);
    eval 'sub UNSIGNED_FLAG () {32;}' unless defined(&UNSIGNED_FLAG);
    eval 'sub ZEROFILL_FLAG () {64;}' unless defined(&ZEROFILL_FLAG);
    eval 'sub BINARY_FLAG () {128;}' unless defined(&BINARY_FLAG);
    eval 'sub ENUM_FLAG () {256;}' unless defined(&ENUM_FLAG);
    eval 'sub AUTO_INCREMENT_FLAG () {512;}' unless defined(&AUTO_INCREMENT_FLAG);
    eval 'sub TIMESTAMP_FLAG () {1024;}' unless defined(&TIMESTAMP_FLAG);
    eval 'sub SET_FLAG () {2048;}' unless defined(&SET_FLAG);
    eval 'sub NUM_FLAG () {32768;}' unless defined(&NUM_FLAG);
    eval 'sub PART_KEY_FLAG () {16384;}' unless defined(&PART_KEY_FLAG);
    eval 'sub GROUP_FLAG () {32768;}' unless defined(&GROUP_FLAG);
    eval 'sub UNIQUE_FLAG () {65536;}' unless defined(&UNIQUE_FLAG);
    eval 'sub REFRESH_GRANT () {1;}' unless defined(&REFRESH_GRANT);
    eval 'sub REFRESH_LOG () {2;}' unless defined(&REFRESH_LOG);
    eval 'sub REFRESH_TABLES () {4;}' unless defined(&REFRESH_TABLES);
    eval 'sub REFRESH_HOSTS () {8;}' unless defined(&REFRESH_HOSTS);
    eval 'sub REFRESH_STATUS () {16;}' unless defined(&REFRESH_STATUS);
    eval 'sub REFRESH_THREADS () {32;}' unless defined(&REFRESH_THREADS);
    eval 'sub REFRESH_SLAVE () {64;}' unless defined(&REFRESH_SLAVE);
    eval 'sub REFRESH_MASTER () {128;}' unless defined(&REFRESH_MASTER);
    eval 'sub REFRESH_READ_LOCK () {16384;}' unless defined(&REFRESH_READ_LOCK);
    eval 'sub REFRESH_FAST () {32768;}' unless defined(&REFRESH_FAST);
    eval 'sub CLIENT_LONG_PASSWORD () {1;}' unless defined(&CLIENT_LONG_PASSWORD);
    eval 'sub CLIENT_FOUND_ROWS () {2;}' unless defined(&CLIENT_FOUND_ROWS);
    eval 'sub CLIENT_LONG_FLAG () {4;}' unless defined(&CLIENT_LONG_FLAG);
    eval 'sub CLIENT_CONNECT_WITH_DB () {8;}' unless defined(&CLIENT_CONNECT_WITH_DB);
    eval 'sub CLIENT_NO_SCHEMA () {16;}' unless defined(&CLIENT_NO_SCHEMA);
    eval 'sub CLIENT_COMPRESS () {32;}' unless defined(&CLIENT_COMPRESS);
    eval 'sub CLIENT_ODBC () {64;}' unless defined(&CLIENT_ODBC);
    eval 'sub CLIENT_LOCAL_FILES () {128;}' unless defined(&CLIENT_LOCAL_FILES);
    eval 'sub CLIENT_IGNORE_SPACE () {256;}' unless defined(&CLIENT_IGNORE_SPACE);
    eval 'sub CLIENT_INTERACTIVE () {1024;}' unless defined(&CLIENT_INTERACTIVE);
    eval 'sub CLIENT_SSL () {2048;}' unless defined(&CLIENT_SSL);
    eval 'sub CLIENT_IGNORE_SIGPIPE () {4096;}' unless defined(&CLIENT_IGNORE_SIGPIPE);
    eval 'sub CLIENT_TRANSACTIONS () {8192;}' unless defined(&CLIENT_TRANSACTIONS);
    eval 'sub SERVER_STATUS_IN_TRANS () {1;}' unless defined(&SERVER_STATUS_IN_TRANS);
    eval 'sub SERVER_STATUS_AUTOCOMMIT () {2;}' unless defined(&SERVER_STATUS_AUTOCOMMIT);
    eval 'sub MYSQL_ERRMSG_SIZE () {200;}' unless defined(&MYSQL_ERRMSG_SIZE);
    eval 'sub NET_READ_TIMEOUT () {30;}' unless defined(&NET_READ_TIMEOUT);
    eval 'sub NET_WRITE_TIMEOUT () {60;}' unless defined(&NET_WRITE_TIMEOUT);
    eval 'sub NET_WAIT_TIMEOUT () {8*60*60;}' unless defined(&NET_WAIT_TIMEOUT);
    unless(defined(&Vio_defined)) {
	eval 'sub Vio_defined () {1;}' unless defined(&Vio_defined);
	if(defined(&HAVE_VIO)) {
	} else {
	}
    }
    eval 'sub MAX_CHAR_WIDTH () {255;}' unless defined(&MAX_CHAR_WIDTH);
    eval 'sub MAX_BLOB_WIDTH () {8192;}' unless defined(&MAX_BLOB_WIDTH);
    eval 'sub packet_error () {( -1);}' unless defined(&packet_error);
    eval("sub FIELD_TYPE_DECIMAL () { 0; }") unless defined(&FIELD_TYPE_DECIMAL);
    eval("sub FIELD_TYPE_TINY () { 1; }") unless defined(&FIELD_TYPE_TINY);
    eval("sub FIELD_TYPE_SHORT () { 2; }") unless defined(&FIELD_TYPE_SHORT);
    eval("sub FIELD_TYPE_LONG () { 3; }") unless defined(&FIELD_TYPE_LONG);
    eval("sub FIELD_TYPE_FLOAT () { 4; }") unless defined(&FIELD_TYPE_FLOAT);
    eval("sub FIELD_TYPE_DOUBLE () { 5; }") unless defined(&FIELD_TYPE_DOUBLE);
    eval("sub FIELD_TYPE_NULL () { 6; }") unless defined(&FIELD_TYPE_NULL);
    eval("sub FIELD_TYPE_TIMESTAMP () { 7; }") unless defined(&FIELD_TYPE_TIMESTAMP);
    eval("sub FIELD_TYPE_LONGLONG () { 8; }") unless defined(&FIELD_TYPE_LONGLONG);
    eval("sub FIELD_TYPE_INT24 () { 9; }") unless defined(&FIELD_TYPE_INT24);
    eval("sub FIELD_TYPE_DATE () { 10; }") unless defined(&FIELD_TYPE_DATE);
    eval("sub FIELD_TYPE_TIME () { 11; }") unless defined(&FIELD_TYPE_TIME);
    eval("sub FIELD_TYPE_DATETIME () { 12; }") unless defined(&FIELD_TYPE_DATETIME);
    eval("sub FIELD_TYPE_YEAR () { 13; }") unless defined(&FIELD_TYPE_YEAR);
    eval("sub FIELD_TYPE_NEWDATE () { 14; }") unless defined(&FIELD_TYPE_NEWDATE);
    eval("sub FIELD_TYPE_ENUM () { 247; }") unless defined(&FIELD_TYPE_ENUM);
    eval("sub FIELD_TYPE_SET () { 248; }") unless defined(&FIELD_TYPE_SET);
    eval("sub FIELD_TYPE_TINY_BLOB () { 249; }") unless defined(&FIELD_TYPE_TINY_BLOB);
    eval("sub FIELD_TYPE_MEDIUM_BLOB () { 250; }") unless defined(&FIELD_TYPE_MEDIUM_BLOB);
    eval("sub FIELD_TYPE_LONG_BLOB () { 251; }") unless defined(&FIELD_TYPE_LONG_BLOB);
    eval("sub FIELD_TYPE_BLOB () { 252; }") unless defined(&FIELD_TYPE_BLOB);
    eval("sub FIELD_TYPE_VAR_STRING () { 253; }") unless defined(&FIELD_TYPE_VAR_STRING);
    eval("sub FIELD_TYPE_STRING () { 254; }") unless defined(&FIELD_TYPE_STRING);
    eval 'sub FIELD_TYPE_CHAR () { &FIELD_TYPE_TINY;}' unless defined(&FIELD_TYPE_CHAR);
    eval 'sub FIELD_TYPE_INTERVAL () { &FIELD_TYPE_ENUM;}' unless defined(&FIELD_TYPE_INTERVAL);
    eval 'sub net_new_transaction {
        my($net) = @_;
	    eval q((($net)-> &pkt_nr=0));
    }' unless defined(&net_new_transaction);
    eval("sub STRING_RESULT () { 0; }") unless defined(&STRING_RESULT);
    eval("sub REAL_RESULT () { 1; }") unless defined(&REAL_RESULT);
    eval("sub INT_RESULT () { 2; }") unless defined(&INT_RESULT);
    eval 'sub NET_HEADER_SIZE () {4;}' unless defined(&NET_HEADER_SIZE);
    eval 'sub COMP_HEADER_SIZE () {3;}' unless defined(&COMP_HEADER_SIZE);
    if(defined(&__cplusplus)) {
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub NULL_LENGTH () {( ~0);}' unless defined(&NULL_LENGTH);
}
1;
