require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&AGENT_REGISTRY_H)) {
    eval 'sub AGENT_REGISTRY_H () {1;}' unless defined(&AGENT_REGISTRY_H);
    require 'net-snmp/agent/snmp_agent.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub MIB_REGISTERED_OK () {0;}' unless defined(&MIB_REGISTERED_OK);
    eval 'sub MIB_DUPLICATE_REGISTRATION () {-1;}' unless defined(&MIB_DUPLICATE_REGISTRATION);
    eval 'sub MIB_REGISTRATION_FAILED () {-2;}' unless defined(&MIB_REGISTRATION_FAILED);
    eval 'sub MIB_UNREGISTERED_OK () {0;}' unless defined(&MIB_UNREGISTERED_OK);
    eval 'sub MIB_NO_SUCH_REGISTRATION () {-1;}' unless defined(&MIB_NO_SUCH_REGISTRATION);
    eval 'sub MIB_UNREGISTRATION_FAILED () {-2;}' unless defined(&MIB_UNREGISTRATION_FAILED);
    eval 'sub DEFAULT_MIB_PRIORITY () {127;}' unless defined(&DEFAULT_MIB_PRIORITY);
    eval 'sub REGISTER_MIB {
        my($descr, $var, $vartype, $theoid) = @_;
	    eval q( &if ( &register_mib($descr,  $var, $sizeof{\'struct vartype\'}, $sizeof{$var}/$sizeof{\'struct vartype\'}, $theoid, $sizeof{$theoid}/$sizeof{ &oid}) !=  &MIB_REGISTERED_OK )  &DEBUGMSGTL((\\"register_mib\\", \\"%s registration failed\\\\n\\", $descr)););
    }' unless defined(&REGISTER_MIB);
    eval 'sub NUM_EXTERNAL_FDS () {32;}' unless defined(&NUM_EXTERNAL_FDS);
    eval 'sub FD_REGISTERED_OK () {0;}' unless defined(&FD_REGISTERED_OK);
    eval 'sub FD_REGISTRATION_FAILED () {-2;}' unless defined(&FD_REGISTRATION_FAILED);
    eval 'sub FD_UNREGISTERED_OK () {0;}' unless defined(&FD_UNREGISTERED_OK);
    eval 'sub FD_NO_SUCH_REGISTRATION () {-1;}' unless defined(&FD_NO_SUCH_REGISTRATION);
    eval 'sub NUM_EXTERNAL_SIGS () {32;}' unless defined(&NUM_EXTERNAL_SIGS);
    eval 'sub SIG_REGISTERED_OK () {0;}' unless defined(&SIG_REGISTERED_OK);
    eval 'sub SIG_REGISTRATION_FAILED () {-2;}' unless defined(&SIG_REGISTRATION_FAILED);
    eval 'sub SIG_UNREGISTERED_OK () {0;}' unless defined(&SIG_UNREGISTERED_OK);
    if(defined(&__cplusplus)) {
    }
}
1;
