require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_OS_TYPES_H)) {
    eval 'sub _OS_TYPES_H () {1;}' unless defined(&_OS_TYPES_H);
    eval 'sub _ogg_malloc () { &malloc;}' unless defined(&_ogg_malloc);
    eval 'sub _ogg_calloc () { &calloc;}' unless defined(&_ogg_calloc);
    eval 'sub _ogg_realloc () { &realloc;}' unless defined(&_ogg_realloc);
    eval 'sub _ogg_free () { &free;}' unless defined(&_ogg_free);
    if(defined(&_WIN32)) {
	unless(defined(&__GNUC__)) {
	} else {
	    require '_G_config.ph';
	}
    }
 elsif(defined( &__MACOS__)) {
	require 'sys/types.ph';
    }
 elsif(defined( &__MACOSX__) ) {
	require 'sys/types.ph';
    }
 elsif(defined( &__BEOS__)) {
	require 'inttypes.ph';
    }
 elsif(defined ( &__EMX__)) {
    } else {
	require 'sys/types.ph';
	require 'ogg/config_types.ph';
    }
}
1;
