require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ENCODERS_H)) {
    eval 'sub ENCODERS_H () {1;}' unless defined(&ENCODERS_H);
    eval 'sub ENCODER_DEC {
        my($typename) = @_;
	    eval q( &void  &giop_encoder_$typename( &GIOPSendBuffer * &send_buffer,  &const $typename * &mem));
    }' unless defined(&ENCODER_DEC);
    eval 'sub ENCODER_CALL {
        my($typename, $mem) = @_;
	    eval q( &giop_encoder_$typename( &send_buffer, $mem));
    }' unless defined(&ENCODER_CALL);
    eval 'sub AP {
        my($m, $l) = @_;
	    eval q( &giop_message_buffer_append_mem( &GIOP_MESSAGE_BUFFER( &send_buffer), $m, $l));
    }' unless defined(&AP);
    eval 'sub APA {
        my($m, $l) = @_;
	    eval q( &giop_message_buffer_append_mem_a( &GIOP_MESSAGE_BUFFER( &send_buffer), $m, $l));
    }' unless defined(&APA);
    eval 'sub API {
        my($m, $l) = @_;
	    eval q( &giop_send_buffer_append_mem_indirect( &send_buffer, $m, $l));
    }' unless defined(&API);
    eval 'sub APIA {
        my($m, $l) = @_;
	    eval q( &giop_send_buffer_append_mem_indirect_a( &send_buffer, $m, $l));
    }' unless defined(&APIA);
    eval 'sub giop_encoder_CORBA_Principal {
        my($rb, $mem) = @_;
	    eval q( &giop_encoder_CORBA_sequence_octet($rb, $mem));
    }' unless defined(&giop_encoder_CORBA_Principal);
}
1;
