require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&IIOP_ENDIAN_H)) {
    eval 'sub IIOP_ENDIAN_H () {1;}' unless defined(&IIOP_ENDIAN_H);
    require 'glib.ph';
    if((defined(&G_BYTE_ORDER) ? &G_BYTE_ORDER : 0) == (defined(&G_BIG_ENDIAN) ? &G_BIG_ENDIAN : 0)) {
	eval 'sub FLAG_ENDIANNESS () { &FLAG_BIG_ENDIAN;}' unless defined(&FLAG_ENDIANNESS);
	eval 'sub conversion_needed {
	    my($to_endianness) = @_;
    	    eval q((($to_endianness)!= &FLAG_BIG_ENDIAN));
	}' unless defined(&conversion_needed);
    }
 elsif((defined(&G_BYTE_ORDER) ? &G_BYTE_ORDER : 0) == (defined(&G_LITTLE_ENDIAN) ? &G_LITTLE_ENDIAN : 0)) {
	eval 'sub FLAG_ENDIANNESS () { &FLAG_LITTLE_ENDIAN;}' unless defined(&FLAG_ENDIANNESS);
	eval 'sub conversion_needed {
	    my($to_endianness) = @_;
    	    eval q((($to_endianness)!= &FLAG_LITTLE_ENDIAN));
	}' unless defined(&conversion_needed);
    } else {
	die("Unsupported endianness on this system.");
    }
    eval 'sub FLAG_BIG_ENDIAN () {0;}' unless defined(&FLAG_BIG_ENDIAN);
    eval 'sub FLAG_LITTLE_ENDIAN () {1;}' unless defined(&FLAG_LITTLE_ENDIAN);
    if(!defined( &G_CAN_INLINE) || defined( &IIOP_DO_NOT_INLINE_IIOP_BYTESWAP)) {
    } else {
    }
}
1;
