require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PCI_VENDOR_ID)) {
    sub PCI_VENDOR_ID () {	0x;}
}
unless(defined(&PCI_DEVICE_ID)) {
    sub PCI_DEVICE_ID () {	0x2;}
}
unless(defined(&PCI_COMMAND)) {
    sub PCI_COMMAND () {	0x4;}
}
unless(defined(&PCI_COMMAND_IO)) {
    sub PCI_COMMAND_IO () {	0x1;}
}
unless(defined(&PCI_COMMAND_MEMORY)) {
    sub PCI_COMMAND_MEMORY () {	0x2;}
}
unless(defined(&PCI_COMMAND_MASTER)) {
    sub PCI_COMMAND_MASTER () {	0x4;}
}
unless(defined(&PCI_COMMAND_SPECIAL)) {
    sub PCI_COMMAND_SPECIAL () {	0x8;}
}
unless(defined(&PCI_COMMAND_INVALIDATE)) {
    sub PCI_COMMAND_INVALIDATE () {	0x10;}
}
unless(defined(&PCI_COMMAND_VGA_PALETTE)) {
    sub PCI_COMMAND_VGA_PALETTE () {	0x20;}
}
unless(defined(&PCI_COMMAND_PARITY)) {
    sub PCI_COMMAND_PARITY () {	0x40;}
}
unless(defined(&PCI_COMMAND_WAIT)) {
    sub PCI_COMMAND_WAIT () {	0x80;}
}
unless(defined(&PCI_COMMAND_SERR)) {
    sub PCI_COMMAND_SERR () {	0x100;}
}
unless(defined(&PCI_COMMAND_FAST_BACK)) {
    sub PCI_COMMAND_FAST_BACK () {	0x200;}
}
unless(defined(&PCI_STATUS)) {
    sub PCI_STATUS () {	0x6;}
}
unless(defined(&PCI_STATUS_CAP_LIST)) {
    sub PCI_STATUS_CAP_LIST () {	0x10;}
}
unless(defined(&PCI_STATUS_66MHZ)) {
    sub PCI_STATUS_66MHZ () {	0x20;}
}
unless(defined(&PCI_STATUS_UDF)) {
    sub PCI_STATUS_UDF () {	0x40;}
}
unless(defined(&PCI_STATUS_FAST_BACK)) {
    sub PCI_STATUS_FAST_BACK () {	0x80;}
}
unless(defined(&PCI_STATUS_PARITY)) {
    sub PCI_STATUS_PARITY () {	0x100;}
}
unless(defined(&PCI_STATUS_DEVSEL_MASK)) {
    sub PCI_STATUS_DEVSEL_MASK () {	0x600;}
}
unless(defined(&PCI_STATUS_DEVSEL_FAST)) {
    sub PCI_STATUS_DEVSEL_FAST () {	0x;}
}
unless(defined(&PCI_STATUS_DEVSEL_MEDIUM)) {
    sub PCI_STATUS_DEVSEL_MEDIUM () {	0x200;}
}
unless(defined(&PCI_STATUS_DEVSEL_SLOW)) {
    sub PCI_STATUS_DEVSEL_SLOW () {	0x400;}
}
unless(defined(&PCI_STATUS_SIG_TARGET_ABORT)) {
    sub PCI_STATUS_SIG_TARGET_ABORT () {	0x800;}
}
unless(defined(&PCI_STATUS_REC_TARGET_ABORT)) {
    sub PCI_STATUS_REC_TARGET_ABORT () {	0x1000;}
}
unless(defined(&PCI_STATUS_REC_MASTER_ABORT)) {
    sub PCI_STATUS_REC_MASTER_ABORT () {	0x2000;}
}
unless(defined(&PCI_STATUS_SIG_SYSTEM_ERROR)) {
    sub PCI_STATUS_SIG_SYSTEM_ERROR () {	0x4000;}
}
unless(defined(&PCI_STATUS_DETECTED_PARITY)) {
    sub PCI_STATUS_DETECTED_PARITY () {	0x8000;}
}
unless(defined(&PCI_CLASS_REVISION)) {
    sub PCI_CLASS_REVISION () {	0x8;}
}
unless(defined(&PCI_REVISION_ID)) {
    sub PCI_REVISION_ID () {	0x8;}
}
unless(defined(&PCI_CLASS_PROG)) {
    sub PCI_CLASS_PROG () {	0x9;}
}
unless(defined(&PCI_CLASS_DEVICE)) {
    sub PCI_CLASS_DEVICE () {	0xa;}
}
unless(defined(&PCI_CACHE_LINE_SIZE)) {
    sub PCI_CACHE_LINE_SIZE () {	0xc;}
}
unless(defined(&PCI_LATENCY_TIMER)) {
    sub PCI_LATENCY_TIMER () {	0xd;}
}
unless(defined(&PCI_HEADER_TYPE)) {
    sub PCI_HEADER_TYPE () {	0xe;}
}
unless(defined(&PCI_HEADER_TYPE_NORMAL)) {
    sub PCI_HEADER_TYPE_NORMAL () {	0;}
}
unless(defined(&PCI_HEADER_TYPE_BRIDGE)) {
    sub PCI_HEADER_TYPE_BRIDGE () {	1;}
}
unless(defined(&PCI_HEADER_TYPE_CARDBUS)) {
    sub PCI_HEADER_TYPE_CARDBUS () {	2;}
}
unless(defined(&PCI_BIST)) {
    sub PCI_BIST () {	0xf;}
}
unless(defined(&PCI_BIST_CODE_MASK)) {
    sub PCI_BIST_CODE_MASK () {	0xf;}
}
unless(defined(&PCI_BIST_START)) {
    sub PCI_BIST_START () {	0x40;}
}
unless(defined(&PCI_BIST_CAPABLE)) {
    sub PCI_BIST_CAPABLE () {	0x80;}
}
unless(defined(&PCI_BASE_ADDRESS_0)) {
    sub PCI_BASE_ADDRESS_0 () {	0x10;}
}
unless(defined(&PCI_BASE_ADDRESS_1)) {
    sub PCI_BASE_ADDRESS_1 () {	0x14;}
}
unless(defined(&PCI_BASE_ADDRESS_2)) {
    sub PCI_BASE_ADDRESS_2 () {	0x18;}
}
unless(defined(&PCI_BASE_ADDRESS_3)) {
    sub PCI_BASE_ADDRESS_3 () {	0x1c;}
}
unless(defined(&PCI_BASE_ADDRESS_4)) {
    sub PCI_BASE_ADDRESS_4 () {	0x20;}
}
unless(defined(&PCI_BASE_ADDRESS_5)) {
    sub PCI_BASE_ADDRESS_5 () {	0x24;}
}
unless(defined(&PCI_BASE_ADDRESS_SPACE)) {
    sub PCI_BASE_ADDRESS_SPACE () {	0x1;}
}
unless(defined(&PCI_BASE_ADDRESS_SPACE_IO)) {
    sub PCI_BASE_ADDRESS_SPACE_IO () {	0x1;}
}
unless(defined(&PCI_BASE_ADDRESS_SPACE_MEMORY)) {
    sub PCI_BASE_ADDRESS_SPACE_MEMORY () {	0x;}
}
unless(defined(&PCI_BASE_ADDRESS_MEM_TYPE_MASK)) {
    sub PCI_BASE_ADDRESS_MEM_TYPE_MASK () {	0x6;}
}
unless(defined(&PCI_BASE_ADDRESS_MEM_TYPE_32)) {
    sub PCI_BASE_ADDRESS_MEM_TYPE_32 () {	0x;}
}
unless(defined(&PCI_BASE_ADDRESS_MEM_TYPE_1M)) {
    sub PCI_BASE_ADDRESS_MEM_TYPE_1M () {	0x2;}
}
unless(defined(&PCI_BASE_ADDRESS_MEM_TYPE_64)) {
    sub PCI_BASE_ADDRESS_MEM_TYPE_64 () {	0x4;}
}
unless(defined(&PCI_BASE_ADDRESS_MEM_PREFETCH)) {
    sub PCI_BASE_ADDRESS_MEM_PREFETCH () {	0x8;}
}
unless(defined(&PCI_BASE_ADDRESS_MEM_MASK)) {
    sub PCI_BASE_ADDRESS_MEM_MASK () {	(~0xf);}
}
unless(defined(&PCI_BASE_ADDRESS_IO_MASK)) {
    sub PCI_BASE_ADDRESS_IO_MASK () {	(~0x3);}
}
unless(defined(&PCI_CARDBUS_CIS)) {
    sub PCI_CARDBUS_CIS () {	0x28;}
}
unless(defined(&PCI_SUBSYSTEM_VENDOR_ID)) {
    sub PCI_SUBSYSTEM_VENDOR_ID () {	0x2c;}
}
unless(defined(&PCI_SUBSYSTEM_ID)) {
    sub PCI_SUBSYSTEM_ID () {	0x2e;}
}
unless(defined(&PCI_ROM_ADDRESS)) {
    sub PCI_ROM_ADDRESS () {	0x30;}
}
unless(defined(&PCI_ROM_ADDRESS_ENABLE)) {
    sub PCI_ROM_ADDRESS_ENABLE () {	0x1;}
}
unless(defined(&PCI_ROM_ADDRESS_MASK)) {
    sub PCI_ROM_ADDRESS_MASK () {	(~0x7ff);}
}
unless(defined(&PCI_CAPABILITY_LIST)) {
    sub PCI_CAPABILITY_LIST () {	0x34;}
}
unless(defined(&PCI_INTERRUPT_LINE)) {
    sub PCI_INTERRUPT_LINE () {	0x3c;}
}
unless(defined(&PCI_INTERRUPT_PIN)) {
    sub PCI_INTERRUPT_PIN () {	0x3d;}
}
unless(defined(&PCI_MIN_GNT)) {
    sub PCI_MIN_GNT () {	0x3e;}
}
unless(defined(&PCI_MAX_LAT)) {
    sub PCI_MAX_LAT () {	0x3f;}
}
unless(defined(&PCI_PRIMARY_BUS)) {
    sub PCI_PRIMARY_BUS () {	0x18;}
}
unless(defined(&PCI_SECONDARY_BUS)) {
    sub PCI_SECONDARY_BUS () {	0x19;}
}
unless(defined(&PCI_SUBORDINATE_BUS)) {
    sub PCI_SUBORDINATE_BUS () {	0x1a;}
}
unless(defined(&PCI_SEC_LATENCY_TIMER)) {
    sub PCI_SEC_LATENCY_TIMER () {	0x1b;}
}
unless(defined(&PCI_IO_BASE)) {
    sub PCI_IO_BASE () {	0x1c;}
}
unless(defined(&PCI_IO_LIMIT)) {
    sub PCI_IO_LIMIT () {	0x1d;}
}
unless(defined(&PCI_IO_RANGE_TYPE_MASK)) {
    sub PCI_IO_RANGE_TYPE_MASK () {	0xf;}
}
unless(defined(&PCI_IO_RANGE_TYPE_16)) {
    sub PCI_IO_RANGE_TYPE_16 () {	0x;}
}
unless(defined(&PCI_IO_RANGE_TYPE_32)) {
    sub PCI_IO_RANGE_TYPE_32 () {	0x1;}
}
unless(defined(&PCI_IO_RANGE_MASK)) {
    sub PCI_IO_RANGE_MASK () {	~0xf;}
}
unless(defined(&PCI_SEC_STATUS)) {
    sub PCI_SEC_STATUS () {	0x1e;}
}
unless(defined(&PCI_MEMORY_BASE)) {
    sub PCI_MEMORY_BASE () {	0x20;}
}
unless(defined(&PCI_MEMORY_LIMIT)) {
    sub PCI_MEMORY_LIMIT () {	0x22;}
}
unless(defined(&PCI_MEMORY_RANGE_TYPE_MASK)) {
    sub PCI_MEMORY_RANGE_TYPE_MASK () {	0xf;}
}
unless(defined(&PCI_MEMORY_RANGE_MASK)) {
    sub PCI_MEMORY_RANGE_MASK () {	~0xf;}
}
unless(defined(&PCI_PREF_MEMORY_BASE)) {
    sub PCI_PREF_MEMORY_BASE () {	0x24;}
}
unless(defined(&PCI_PREF_MEMORY_LIMIT)) {
    sub PCI_PREF_MEMORY_LIMIT () {	0x26;}
}
unless(defined(&PCI_PREF_RANGE_TYPE_MASK)) {
    sub PCI_PREF_RANGE_TYPE_MASK () {	0xf;}
}
unless(defined(&PCI_PREF_RANGE_TYPE_32)) {
    sub PCI_PREF_RANGE_TYPE_32 () {	0x;}
}
unless(defined(&PCI_PREF_RANGE_TYPE_64)) {
    sub PCI_PREF_RANGE_TYPE_64 () {	0x1;}
}
unless(defined(&PCI_PREF_RANGE_MASK)) {
    sub PCI_PREF_RANGE_MASK () {	~0xf;}
}
unless(defined(&PCI_PREF_BASE_UPPER32)) {
    sub PCI_PREF_BASE_UPPER32 () {	0x28;}
}
unless(defined(&PCI_PREF_LIMIT_UPPER32)) {
    sub PCI_PREF_LIMIT_UPPER32 () {	0x2c;}
}
unless(defined(&PCI_IO_BASE_UPPER16)) {
    sub PCI_IO_BASE_UPPER16 () {	0x30;}
}
unless(defined(&PCI_IO_LIMIT_UPPER16)) {
    sub PCI_IO_LIMIT_UPPER16 () {	0x32;}
}
unless(defined(&PCI_ROM_ADDRESS1)) {
    sub PCI_ROM_ADDRESS1 () {	0x38;}
}
unless(defined(&PCI_BRIDGE_CONTROL)) {
    sub PCI_BRIDGE_CONTROL () {	0x3e;}
}
unless(defined(&PCI_BRIDGE_CTL_PARITY)) {
    sub PCI_BRIDGE_CTL_PARITY () {	0x1;}
}
unless(defined(&PCI_BRIDGE_CTL_SERR)) {
    sub PCI_BRIDGE_CTL_SERR () {	0x2;}
}
unless(defined(&PCI_BRIDGE_CTL_NO_ISA)) {
    sub PCI_BRIDGE_CTL_NO_ISA () {	0x4;}
}
unless(defined(&PCI_BRIDGE_CTL_VGA)) {
    sub PCI_BRIDGE_CTL_VGA () {	0x8;}
}
unless(defined(&PCI_BRIDGE_CTL_MASTER_ABORT)) {
    sub PCI_BRIDGE_CTL_MASTER_ABORT () {	0x20;}
}
unless(defined(&PCI_BRIDGE_CTL_BUS_RESET)) {
    sub PCI_BRIDGE_CTL_BUS_RESET () {	0x40;}
}
unless(defined(&PCI_BRIDGE_CTL_FAST_BACK)) {
    sub PCI_BRIDGE_CTL_FAST_BACK () {	0x80;}
}
unless(defined(&PCI_CB_SEC_STATUS)) {
    sub PCI_CB_SEC_STATUS () {	0x16;}
}
unless(defined(&PCI_CB_PRIMARY_BUS)) {
    sub PCI_CB_PRIMARY_BUS () {	0x18;}
}
unless(defined(&PCI_CB_CARD_BUS)) {
    sub PCI_CB_CARD_BUS () {	0x19;}
}
unless(defined(&PCI_CB_SUBORDINATE_BUS)) {
    sub PCI_CB_SUBORDINATE_BUS () {	0x1a;}
}
unless(defined(&PCI_CB_LATENCY_TIMER)) {
    sub PCI_CB_LATENCY_TIMER () {	0x1b;}
}
unless(defined(&PCI_CB_MEMORY_BASE_0)) {
    sub PCI_CB_MEMORY_BASE_0 () {	0x1c;}
}
unless(defined(&PCI_CB_MEMORY_LIMIT_0)) {
    sub PCI_CB_MEMORY_LIMIT_0 () {	0x20;}
}
unless(defined(&PCI_CB_MEMORY_BASE_1)) {
    sub PCI_CB_MEMORY_BASE_1 () {	0x24;}
}
unless(defined(&PCI_CB_MEMORY_LIMIT_1)) {
    sub PCI_CB_MEMORY_LIMIT_1 () {	0x28;}
}
unless(defined(&PCI_CB_IO_BASE_0)) {
    sub PCI_CB_IO_BASE_0 () {	0x2c;}
}
unless(defined(&PCI_CB_IO_BASE_0_HI)) {
    sub PCI_CB_IO_BASE_0_HI () {	0x2e;}
}
unless(defined(&PCI_CB_IO_LIMIT_0)) {
    sub PCI_CB_IO_LIMIT_0 () {	0x30;}
}
unless(defined(&PCI_CB_IO_LIMIT_0_HI)) {
    sub PCI_CB_IO_LIMIT_0_HI () {	0x32;}
}
unless(defined(&PCI_CB_IO_BASE_1)) {
    sub PCI_CB_IO_BASE_1 () {	0x34;}
}
unless(defined(&PCI_CB_IO_BASE_1_HI)) {
    sub PCI_CB_IO_BASE_1_HI () {	0x36;}
}
unless(defined(&PCI_CB_IO_LIMIT_1)) {
    sub PCI_CB_IO_LIMIT_1 () {	0x38;}
}
unless(defined(&PCI_CB_IO_LIMIT_1_HI)) {
    sub PCI_CB_IO_LIMIT_1_HI () {	0x3a;}
}
unless(defined(&PCI_CB_IO_RANGE_MASK)) {
    sub PCI_CB_IO_RANGE_MASK () {	~0x3;}
}
unless(defined(&PCI_CB_BRIDGE_CONTROL)) {
    sub PCI_CB_BRIDGE_CONTROL () {	0x3e;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_PARITY)) {
    sub PCI_CB_BRIDGE_CTL_PARITY () {	0x1;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_SERR)) {
    sub PCI_CB_BRIDGE_CTL_SERR () {	0x2;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_ISA)) {
    sub PCI_CB_BRIDGE_CTL_ISA () {	0x4;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_VGA)) {
    sub PCI_CB_BRIDGE_CTL_VGA () {	0x8;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_MASTER_ABORT)) {
    sub PCI_CB_BRIDGE_CTL_MASTER_ABORT () {	0x20;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_CB_RESET)) {
    sub PCI_CB_BRIDGE_CTL_CB_RESET () {	0x40;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_16BIT_INT)) {
    sub PCI_CB_BRIDGE_CTL_16BIT_INT () {	0x80;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_PREFETCH_MEM0)) {
    sub PCI_CB_BRIDGE_CTL_PREFETCH_MEM0 () {	0x100;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_PREFETCH_MEM1)) {
    sub PCI_CB_BRIDGE_CTL_PREFETCH_MEM1 () {	0x200;}
}
unless(defined(&PCI_CB_BRIDGE_CTL_POST_WRITES)) {
    sub PCI_CB_BRIDGE_CTL_POST_WRITES () {	0x400;}
}
unless(defined(&PCI_CB_SUBSYSTEM_VENDOR_ID)) {
    sub PCI_CB_SUBSYSTEM_VENDOR_ID () {	0x40;}
}
unless(defined(&PCI_CB_SUBSYSTEM_ID)) {
    sub PCI_CB_SUBSYSTEM_ID () {	0x42;}
}
unless(defined(&PCI_CB_LEGACY_MODE_BASE)) {
    sub PCI_CB_LEGACY_MODE_BASE () {	0x44;}
}
unless(defined(&PCI_CAP_LIST_ID)) {
    sub PCI_CAP_LIST_ID () {	0;}
}
unless(defined(&PCI_CAP_ID_PM)) {
    sub PCI_CAP_ID_PM () {	0x1;}
}
unless(defined(&PCI_CAP_ID_AGP)) {
    sub PCI_CAP_ID_AGP () {	0x2;}
}
unless(defined(&PCI_CAP_ID_VPD)) {
    sub PCI_CAP_ID_VPD () {	0x3;}
}
unless(defined(&PCI_CAP_ID_SLOTID)) {
    sub PCI_CAP_ID_SLOTID () {	0x4;}
}
unless(defined(&PCI_CAP_ID_MSI)) {
    sub PCI_CAP_ID_MSI () {	0x5;}
}
unless(defined(&PCI_CAP_ID_CHSWP)) {
    sub PCI_CAP_ID_CHSWP () {	0x6;}
}
unless(defined(&PCI_CAP_ID_PCIX)) {
    sub PCI_CAP_ID_PCIX () {	0x7;}
}
unless(defined(&PCI_CAP_LIST_NEXT)) {
    sub PCI_CAP_LIST_NEXT () {	1;}
}
unless(defined(&PCI_CAP_FLAGS)) {
    sub PCI_CAP_FLAGS () {	2;}
}
unless(defined(&PCI_CAP_SIZEOF)) {
    sub PCI_CAP_SIZEOF () {	4;}
}
unless(defined(&PCI_PM_CAP_VER_MASK)) {
    sub PCI_PM_CAP_VER_MASK () {	0x7;}
}
unless(defined(&PCI_PM_CAP_PME_CLOCK)) {
    sub PCI_PM_CAP_PME_CLOCK () {	0x8;}
}
unless(defined(&PCI_PM_CAP_DSI)) {
    sub PCI_PM_CAP_DSI () {	0x20;}
}
unless(defined(&PCI_PM_CAP_AUX_C_MASK)) {
    sub PCI_PM_CAP_AUX_C_MASK () {	0x1c0;}
}
unless(defined(&PCI_PM_CAP_D1)) {
    sub PCI_PM_CAP_D1 () {	0x200;}
}
unless(defined(&PCI_PM_CAP_D2)) {
    sub PCI_PM_CAP_D2 () {	0x400;}
}
unless(defined(&PCI_PM_CAP_PME_D0)) {
    sub PCI_PM_CAP_PME_D0 () {	0x800;}
}
unless(defined(&PCI_PM_CAP_PME_D1)) {
    sub PCI_PM_CAP_PME_D1 () {	0x1000;}
}
unless(defined(&PCI_PM_CAP_PME_D2)) {
    sub PCI_PM_CAP_PME_D2 () {	0x2000;}
}
unless(defined(&PCI_PM_CAP_PME_D3_HOT)) {
    sub PCI_PM_CAP_PME_D3_HOT () {	0x4000;}
}
unless(defined(&PCI_PM_CAP_PME_D3_COLD)) {
    sub PCI_PM_CAP_PME_D3_COLD () {	0x8000;}
}
unless(defined(&PCI_PM_CTRL)) {
    sub PCI_PM_CTRL () {	4;}
}
unless(defined(&PCI_PM_CTRL_STATE_MASK)) {
    sub PCI_PM_CTRL_STATE_MASK () {	0x3;}
}
unless(defined(&PCI_PM_CTRL_PME_ENABLE)) {
    sub PCI_PM_CTRL_PME_ENABLE () {	0x100;}
}
unless(defined(&PCI_PM_CTRL_DATA_SEL_MASK)) {
    sub PCI_PM_CTRL_DATA_SEL_MASK () {	0x1e00;}
}
unless(defined(&PCI_PM_CTRL_DATA_SCALE_MASK)) {
    sub PCI_PM_CTRL_DATA_SCALE_MASK () {	0x6000;}
}
unless(defined(&PCI_PM_CTRL_PME_STATUS)) {
    sub PCI_PM_CTRL_PME_STATUS () {	0x8000;}
}
unless(defined(&PCI_PM_PPB_EXTENSIONS)) {
    sub PCI_PM_PPB_EXTENSIONS () {	6;}
}
unless(defined(&PCI_PM_PPB_B2_B3)) {
    sub PCI_PM_PPB_B2_B3 () {	0x40;}
}
unless(defined(&PCI_PM_BPCC_ENABLE)) {
    sub PCI_PM_BPCC_ENABLE () {	0x80;}
}
unless(defined(&PCI_PM_DATA_REGISTER)) {
    sub PCI_PM_DATA_REGISTER () {	7;}
}
unless(defined(&PCI_PM_SIZEOF)) {
    sub PCI_PM_SIZEOF () {	8;}
}
unless(defined(&PCI_AGP_VERSION)) {
    sub PCI_AGP_VERSION () {	2;}
}
unless(defined(&PCI_AGP_RFU)) {
    sub PCI_AGP_RFU () {	3;}
}
unless(defined(&PCI_AGP_STATUS)) {
    sub PCI_AGP_STATUS () {	4;}
}
unless(defined(&PCI_AGP_STATUS_RQ_MASK)) {
    sub PCI_AGP_STATUS_RQ_MASK () {	0xff000000;}
}
unless(defined(&PCI_AGP_STATUS_SBA)) {
    sub PCI_AGP_STATUS_SBA () {	0x200;}
}
unless(defined(&PCI_AGP_STATUS_64BIT)) {
    sub PCI_AGP_STATUS_64BIT () {	0x20;}
}
unless(defined(&PCI_AGP_STATUS_FW)) {
    sub PCI_AGP_STATUS_FW () {	0x10;}
}
unless(defined(&PCI_AGP_STATUS_RATE4)) {
    sub PCI_AGP_STATUS_RATE4 () {	0x4;}
}
unless(defined(&PCI_AGP_STATUS_RATE2)) {
    sub PCI_AGP_STATUS_RATE2 () {	0x2;}
}
unless(defined(&PCI_AGP_STATUS_RATE1)) {
    sub PCI_AGP_STATUS_RATE1 () {	0x1;}
}
unless(defined(&PCI_AGP_COMMAND)) {
    sub PCI_AGP_COMMAND () {	8;}
}
unless(defined(&PCI_AGP_COMMAND_RQ_MASK)) {
    sub PCI_AGP_COMMAND_RQ_MASK () {	0xff000000;}
}
unless(defined(&PCI_AGP_COMMAND_SBA)) {
    sub PCI_AGP_COMMAND_SBA () {	0x200;}
}
unless(defined(&PCI_AGP_COMMAND_AGP)) {
    sub PCI_AGP_COMMAND_AGP () {	0x100;}
}
unless(defined(&PCI_AGP_COMMAND_64BIT)) {
    sub PCI_AGP_COMMAND_64BIT () {	0x20;}
}
unless(defined(&PCI_AGP_COMMAND_FW)) {
    sub PCI_AGP_COMMAND_FW () {	0x10;}
}
unless(defined(&PCI_AGP_COMMAND_RATE4)) {
    sub PCI_AGP_COMMAND_RATE4 () {	0x4;}
}
unless(defined(&PCI_AGP_COMMAND_RATE2)) {
    sub PCI_AGP_COMMAND_RATE2 () {	0x2;}
}
unless(defined(&PCI_AGP_COMMAND_RATE1)) {
    sub PCI_AGP_COMMAND_RATE1 () {	0x1;}
}
unless(defined(&PCI_AGP_SIZEOF)) {
    sub PCI_AGP_SIZEOF () {	12;}
}
unless(defined(&PCI_SID_ESR)) {
    sub PCI_SID_ESR () {	2;}
}
unless(defined(&PCI_SID_ESR_NSLOTS)) {
    sub PCI_SID_ESR_NSLOTS () {	0x1f;}
}
unless(defined(&PCI_SID_ESR_FIC)) {
    sub PCI_SID_ESR_FIC () {	0x20;}
}
unless(defined(&PCI_SID_CHASSIS_NR)) {
    sub PCI_SID_CHASSIS_NR () {	3;}
}
unless(defined(&PCI_MSI_FLAGS)) {
    sub PCI_MSI_FLAGS () {	2;}
}
unless(defined(&PCI_MSI_FLAGS_64BIT)) {
    sub PCI_MSI_FLAGS_64BIT () {	0x80;}
}
unless(defined(&PCI_MSI_FLAGS_QSIZE)) {
    sub PCI_MSI_FLAGS_QSIZE () {	0x70;}
}
unless(defined(&PCI_MSI_FLAGS_QMASK)) {
    sub PCI_MSI_FLAGS_QMASK () {	0xe;}
}
unless(defined(&PCI_MSI_FLAGS_ENABLE)) {
    sub PCI_MSI_FLAGS_ENABLE () {	0x1;}
}
unless(defined(&PCI_MSI_RFU)) {
    sub PCI_MSI_RFU () {	3;}
}
unless(defined(&PCI_MSI_ADDRESS_LO)) {
    sub PCI_MSI_ADDRESS_LO () {	4;}
}
unless(defined(&PCI_MSI_ADDRESS_HI)) {
    sub PCI_MSI_ADDRESS_HI () {	8;}
}
unless(defined(&PCI_MSI_DATA_32)) {
    sub PCI_MSI_DATA_32 () {	8;}
}
unless(defined(&PCI_MSI_DATA_64)) {
    sub PCI_MSI_DATA_64 () {	12;}
}
unless(defined(&PCI_PCIX_COMMAND)) {
    sub PCI_PCIX_COMMAND () {	2;}
}
unless(defined(&PCI_PCIX_COMMAND_DPERE)) {
    sub PCI_PCIX_COMMAND_DPERE () {	0x1;}
}
unless(defined(&PCI_PCIX_COMMAND_ERO)) {
    sub PCI_PCIX_COMMAND_ERO () {	0x2;}
}
unless(defined(&PCI_PCIX_COMMAND_MAX_MEM_READ_BYTE_COUNT)) {
    sub PCI_PCIX_COMMAND_MAX_MEM_READ_BYTE_COUNT () {	0xc;}
}
unless(defined(&PCI_PCIX_COMMAND_MAX_OUTSTANDING_SPLIT_TRANS)) {
    sub PCI_PCIX_COMMAND_MAX_OUTSTANDING_SPLIT_TRANS () {	0x70;}
}
unless(defined(&PCI_PCIX_COMMAND_RESERVED)) {
    sub PCI_PCIX_COMMAND_RESERVED () {	0xf80;}
}
unless(defined(&PCI_PCIX_STATUS)) {
    sub PCI_PCIX_STATUS () {	4;}
}
unless(defined(&PCI_PCIX_STATUS_FUNCTION)) {
    sub PCI_PCIX_STATUS_FUNCTION () {	0x7;}
}
unless(defined(&PCI_PCIX_STATUS_DEVICE)) {
    sub PCI_PCIX_STATUS_DEVICE () {	0xf8;}
}
unless(defined(&PCI_PCIX_STATUS_BUS)) {
    sub PCI_PCIX_STATUS_BUS () {	0xff00;}
}
unless(defined(&PCI_PCIX_STATUS_64BIT)) {
    sub PCI_PCIX_STATUS_64BIT () {	0x10000;}
}
unless(defined(&PCI_PCIX_STATUS_133MHZ)) {
    sub PCI_PCIX_STATUS_133MHZ () {	0x20000;}
}
unless(defined(&PCI_PCIX_STATUS_SC_DISCARDED)) {
    sub PCI_PCIX_STATUS_SC_DISCARDED () {	0x40000;}
}
unless(defined(&PCI_PCIX_STATUS_UNEXPECTED_SC)) {
    sub PCI_PCIX_STATUS_UNEXPECTED_SC () {	0x80000;}
}
unless(defined(&PCI_PCIX_STATUS_DEVICE_COMPLEXITY)) {
    sub PCI_PCIX_STATUS_DEVICE_COMPLEXITY () {	0x100000;}
}
unless(defined(&PCI_PCIX_STATUS_DESIGNED_MAX_MEM_READ_BYTE_COUNT)) {
    sub PCI_PCIX_STATUS_DESIGNED_MAX_MEM_READ_BYTE_COUNT () {	0x600000;}
}
unless(defined(&PCI_PCIX_STATUS_DESIGNED_MAX_OUTSTANDING_SPLIT_TRANS)) {
    sub PCI_PCIX_STATUS_DESIGNED_MAX_OUTSTANDING_SPLIT_TRANS () {	0x3800000;}
}
unless(defined(&PCI_PCIX_STATUS_DESIGNED_MAX_CUMULATIVE_READ_SIZE)) {
    sub PCI_PCIX_STATUS_DESIGNED_MAX_CUMULATIVE_READ_SIZE () {	0x1c000000;}
}
unless(defined(&PCI_PCIX_STATUS_RCVD_SC_ERR_MESS)) {
    sub PCI_PCIX_STATUS_RCVD_SC_ERR_MESS () {	0x20000000;}
}
unless(defined(&PCI_PCIX_STATUS_RESERVED)) {
    sub PCI_PCIX_STATUS_RESERVED () {	0xc0000000;}
}
unless(defined(&PCI_PCIX_SIZEOF)) {
    sub PCI_PCIX_SIZEOF () {	4;}
}
unless(defined(&PCI_PCIX_BRIDGE_SEC_STATUS)) {
    sub PCI_PCIX_BRIDGE_SEC_STATUS () {	2;}
}
unless(defined(&PCI_PCIX_BRIDGE_SEC_STATUS_64BIT)) {
    sub PCI_PCIX_BRIDGE_SEC_STATUS_64BIT () {	0x1;}
}
unless(defined(&PCI_PCIX_BRIDGE_SEC_STATUS_133MHZ)) {
    sub PCI_PCIX_BRIDGE_SEC_STATUS_133MHZ () {	0x2;}
}
unless(defined(&PCI_PCIX_BRIDGE_SEC_STATUS_SC_DISCARDED)) {
    sub PCI_PCIX_BRIDGE_SEC_STATUS_SC_DISCARDED () {	0x4;}
}
unless(defined(&PCI_PCIX_BRIDGE_SEC_STATUS_UNEXPECTED_SC)) {
    sub PCI_PCIX_BRIDGE_SEC_STATUS_UNEXPECTED_SC () {	0x8;}
}
unless(defined(&PCI_PCIX_BRIDGE_SEC_STATUS_SC_OVERRUN)) {
    sub PCI_PCIX_BRIDGE_SEC_STATUS_SC_OVERRUN () {	0x10;}
}
unless(defined(&PCI_PCIX_BRIDGE_SEC_STATUS_SPLIT_REQUEST_DELAYED)) {
    sub PCI_PCIX_BRIDGE_SEC_STATUS_SPLIT_REQUEST_DELAYED () {	0x20;}
}
unless(defined(&PCI_PCIX_BRIDGE_SEC_STATUS_CLOCK_FREQ)) {
    sub PCI_PCIX_BRIDGE_SEC_STATUS_CLOCK_FREQ () {	0x1c0;}
}
unless(defined(&PCI_PCIX_BRIDGE_SEC_STATUS_RESERVED)) {
    sub PCI_PCIX_BRIDGE_SEC_STATUS_RESERVED () {	0xfe00;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS)) {
    sub PCI_PCIX_BRIDGE_STATUS () {	4;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_FUNCTION)) {
    sub PCI_PCIX_BRIDGE_STATUS_FUNCTION () {	0x7;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_DEVICE)) {
    sub PCI_PCIX_BRIDGE_STATUS_DEVICE () {	0xf8;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_BUS)) {
    sub PCI_PCIX_BRIDGE_STATUS_BUS () {	0xff00;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_64BIT)) {
    sub PCI_PCIX_BRIDGE_STATUS_64BIT () {	0x10000;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_133MHZ)) {
    sub PCI_PCIX_BRIDGE_STATUS_133MHZ () {	0x20000;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_SC_DISCARDED)) {
    sub PCI_PCIX_BRIDGE_STATUS_SC_DISCARDED () {	0x40000;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_UNEXPECTED_SC)) {
    sub PCI_PCIX_BRIDGE_STATUS_UNEXPECTED_SC () {	0x80000;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_SC_OVERRUN)) {
    sub PCI_PCIX_BRIDGE_STATUS_SC_OVERRUN () {	0x100000;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_SPLIT_REQUEST_DELAYED)) {
    sub PCI_PCIX_BRIDGE_STATUS_SPLIT_REQUEST_DELAYED () {	0x200000;}
}
unless(defined(&PCI_PCIX_BRIDGE_STATUS_RESERVED)) {
    sub PCI_PCIX_BRIDGE_STATUS_RESERVED () {	0xffc00000;}
}
unless(defined(&PCI_PCIX_BRIDGE_UPSTREAM_SPLIT_TRANS_CTRL)) {
    sub PCI_PCIX_BRIDGE_UPSTREAM_SPLIT_TRANS_CTRL () {	8;}
}
unless(defined(&PCI_PCIX_BRIDGE_DOWNSTREAM_SPLIT_TRANS_CTRL)) {
    sub PCI_PCIX_BRIDGE_DOWNSTREAM_SPLIT_TRANS_CTRL () {	12;}
}
unless(defined(&PCI_PCIX_BRIDGE_STR_CAPACITY)) {
    sub PCI_PCIX_BRIDGE_STR_CAPACITY () {	0xffff;}
}
unless(defined(&PCI_PCIX_BRIDGE_STR_COMMITMENT_LIMIT)) {
    sub PCI_PCIX_BRIDGE_STR_COMMITMENT_LIMIT () {	0xffff0000;}
}
unless(defined(&PCI_PCIX_BRIDGE_SIZEOF)) {
    sub PCI_PCIX_BRIDGE_SIZEOF () {	12;}
}
unless(defined(&PCI_DEVFN)) {
    sub PCI_DEVFN {
	my($slot,$func) = @_;
	eval q((((($slot) & 0x1f) << 3) | (($func) & 0x7)));
    }
}
unless(defined(&PCI_SLOT)) {
    sub PCI_SLOT {
	my($devfn) = @_;
	eval q(((($devfn) >> 3) & 0x1f));
    }
}
unless(defined(&PCI_FUNC)) {
    sub PCI_FUNC {
	my($devfn) = @_;
	eval q((($devfn) & 0x7));
    }
}
unless(defined(&PCI_CLASS_NOT_DEFINED)) {
    sub PCI_CLASS_NOT_DEFINED () {	0x;}
}
unless(defined(&PCI_CLASS_NOT_DEFINED_VGA)) {
    sub PCI_CLASS_NOT_DEFINED_VGA () {	0x1;}
}
unless(defined(&PCI_BASE_CLASS_STORAGE)) {
    sub PCI_BASE_CLASS_STORAGE () {	0x1;}
}
unless(defined(&PCI_CLASS_STORAGE_SCSI)) {
    sub PCI_CLASS_STORAGE_SCSI () {	0x100;}
}
unless(defined(&PCI_CLASS_STORAGE_IDE)) {
    sub PCI_CLASS_STORAGE_IDE () {	0x101;}
}
unless(defined(&PCI_CLASS_STORAGE_FLOPPY)) {
    sub PCI_CLASS_STORAGE_FLOPPY () {	0x102;}
}
unless(defined(&PCI_CLASS_STORAGE_IPI)) {
    sub PCI_CLASS_STORAGE_IPI () {	0x103;}
}
unless(defined(&PCI_CLASS_STORAGE_RAID)) {
    sub PCI_CLASS_STORAGE_RAID () {	0x104;}
}
unless(defined(&PCI_CLASS_STORAGE_OTHER)) {
    sub PCI_CLASS_STORAGE_OTHER () {	0x180;}
}
unless(defined(&PCI_BASE_CLASS_NETWORK)) {
    sub PCI_BASE_CLASS_NETWORK () {	0x2;}
}
unless(defined(&PCI_CLASS_NETWORK_ETHERNET)) {
    sub PCI_CLASS_NETWORK_ETHERNET () {	0x200;}
}
unless(defined(&PCI_CLASS_NETWORK_TOKEN_RING)) {
    sub PCI_CLASS_NETWORK_TOKEN_RING () {	0x201;}
}
unless(defined(&PCI_CLASS_NETWORK_FDDI)) {
    sub PCI_CLASS_NETWORK_FDDI () {	0x202;}
}
unless(defined(&PCI_CLASS_NETWORK_ATM)) {
    sub PCI_CLASS_NETWORK_ATM () {	0x203;}
}
unless(defined(&PCI_CLASS_NETWORK_OTHER)) {
    sub PCI_CLASS_NETWORK_OTHER () {	0x280;}
}
unless(defined(&PCI_BASE_CLASS_DISPLAY)) {
    sub PCI_BASE_CLASS_DISPLAY () {	0x3;}
}
unless(defined(&PCI_CLASS_DISPLAY_VGA)) {
    sub PCI_CLASS_DISPLAY_VGA () {	0x300;}
}
unless(defined(&PCI_CLASS_DISPLAY_XGA)) {
    sub PCI_CLASS_DISPLAY_XGA () {	0x301;}
}
unless(defined(&PCI_CLASS_DISPLAY_OTHER)) {
    sub PCI_CLASS_DISPLAY_OTHER () {	0x380;}
}
unless(defined(&PCI_BASE_CLASS_MULTIMEDIA)) {
    sub PCI_BASE_CLASS_MULTIMEDIA () {	0x4;}
}
unless(defined(&PCI_CLASS_MULTIMEDIA_VIDEO)) {
    sub PCI_CLASS_MULTIMEDIA_VIDEO () {	0x400;}
}
unless(defined(&PCI_CLASS_MULTIMEDIA_AUDIO)) {
    sub PCI_CLASS_MULTIMEDIA_AUDIO () {	0x401;}
}
unless(defined(&PCI_CLASS_MULTIMEDIA_OTHER)) {
    sub PCI_CLASS_MULTIMEDIA_OTHER () {	0x480;}
}
unless(defined(&PCI_BASE_CLASS_MEMORY)) {
    sub PCI_BASE_CLASS_MEMORY () {	0x5;}
}
unless(defined(&PCI_CLASS_MEMORY_RAM)) {
    sub PCI_CLASS_MEMORY_RAM () {	0x500;}
}
unless(defined(&PCI_CLASS_MEMORY_FLASH)) {
    sub PCI_CLASS_MEMORY_FLASH () {	0x501;}
}
unless(defined(&PCI_CLASS_MEMORY_OTHER)) {
    sub PCI_CLASS_MEMORY_OTHER () {	0x580;}
}
unless(defined(&PCI_BASE_CLASS_BRIDGE)) {
    sub PCI_BASE_CLASS_BRIDGE () {	0x6;}
}
unless(defined(&PCI_CLASS_BRIDGE_HOST)) {
    sub PCI_CLASS_BRIDGE_HOST () {	0x600;}
}
unless(defined(&PCI_CLASS_BRIDGE_ISA)) {
    sub PCI_CLASS_BRIDGE_ISA () {	0x601;}
}
unless(defined(&PCI_CLASS_BRIDGE_EISA)) {
    sub PCI_CLASS_BRIDGE_EISA () {	0x602;}
}
unless(defined(&PCI_CLASS_BRIDGE_MC)) {
    sub PCI_CLASS_BRIDGE_MC () {	0x603;}
}
unless(defined(&PCI_CLASS_BRIDGE_PCI)) {
    sub PCI_CLASS_BRIDGE_PCI () {	0x604;}
}
unless(defined(&PCI_CLASS_BRIDGE_PCMCIA)) {
    sub PCI_CLASS_BRIDGE_PCMCIA () {	0x605;}
}
unless(defined(&PCI_CLASS_BRIDGE_NUBUS)) {
    sub PCI_CLASS_BRIDGE_NUBUS () {	0x606;}
}
unless(defined(&PCI_CLASS_BRIDGE_CARDBUS)) {
    sub PCI_CLASS_BRIDGE_CARDBUS () {	0x607;}
}
unless(defined(&PCI_CLASS_BRIDGE_OTHER)) {
    sub PCI_CLASS_BRIDGE_OTHER () {	0x680;}
}
unless(defined(&PCI_BASE_CLASS_COMMUNICATION)) {
    sub PCI_BASE_CLASS_COMMUNICATION () {	0x7;}
}
unless(defined(&PCI_CLASS_COMMUNICATION_SERIAL)) {
    sub PCI_CLASS_COMMUNICATION_SERIAL () {	0x700;}
}
unless(defined(&PCI_CLASS_COMMUNICATION_PARALLEL)) {
    sub PCI_CLASS_COMMUNICATION_PARALLEL () {	0x701;}
}
unless(defined(&PCI_CLASS_COMMUNICATION_OTHER)) {
    sub PCI_CLASS_COMMUNICATION_OTHER () {	0x780;}
}
unless(defined(&PCI_BASE_CLASS_SYSTEM)) {
    sub PCI_BASE_CLASS_SYSTEM () {	0x8;}
}
unless(defined(&PCI_CLASS_SYSTEM_PIC)) {
    sub PCI_CLASS_SYSTEM_PIC () {	0x800;}
}
unless(defined(&PCI_CLASS_SYSTEM_DMA)) {
    sub PCI_CLASS_SYSTEM_DMA () {	0x801;}
}
unless(defined(&PCI_CLASS_SYSTEM_TIMER)) {
    sub PCI_CLASS_SYSTEM_TIMER () {	0x802;}
}
unless(defined(&PCI_CLASS_SYSTEM_RTC)) {
    sub PCI_CLASS_SYSTEM_RTC () {	0x803;}
}
unless(defined(&PCI_CLASS_SYSTEM_OTHER)) {
    sub PCI_CLASS_SYSTEM_OTHER () {	0x880;}
}
unless(defined(&PCI_BASE_CLASS_INPUT)) {
    sub PCI_BASE_CLASS_INPUT () {	0x9;}
}
unless(defined(&PCI_CLASS_INPUT_KEYBOARD)) {
    sub PCI_CLASS_INPUT_KEYBOARD () {	0x900;}
}
unless(defined(&PCI_CLASS_INPUT_PEN)) {
    sub PCI_CLASS_INPUT_PEN () {	0x901;}
}
unless(defined(&PCI_CLASS_INPUT_MOUSE)) {
    sub PCI_CLASS_INPUT_MOUSE () {	0x902;}
}
unless(defined(&PCI_CLASS_INPUT_OTHER)) {
    sub PCI_CLASS_INPUT_OTHER () {	0x980;}
}
unless(defined(&PCI_BASE_CLASS_DOCKING)) {
    sub PCI_BASE_CLASS_DOCKING () {	0xa;}
}
unless(defined(&PCI_CLASS_DOCKING_GENERIC)) {
    sub PCI_CLASS_DOCKING_GENERIC () {	0xa00;}
}
unless(defined(&PCI_CLASS_DOCKING_OTHER)) {
    sub PCI_CLASS_DOCKING_OTHER () {	0xa01;}
}
unless(defined(&PCI_BASE_CLASS_PROCESSOR)) {
    sub PCI_BASE_CLASS_PROCESSOR () {	0xb;}
}
unless(defined(&PCI_CLASS_PROCESSOR_386)) {
    sub PCI_CLASS_PROCESSOR_386 () {	0xb00;}
}
unless(defined(&PCI_CLASS_PROCESSOR_486)) {
    sub PCI_CLASS_PROCESSOR_486 () {	0xb01;}
}
unless(defined(&PCI_CLASS_PROCESSOR_PENTIUM)) {
    sub PCI_CLASS_PROCESSOR_PENTIUM () {	0xb02;}
}
unless(defined(&PCI_CLASS_PROCESSOR_ALPHA)) {
    sub PCI_CLASS_PROCESSOR_ALPHA () {	0xb10;}
}
unless(defined(&PCI_CLASS_PROCESSOR_POWERPC)) {
    sub PCI_CLASS_PROCESSOR_POWERPC () {	0xb20;}
}
unless(defined(&PCI_CLASS_PROCESSOR_CO)) {
    sub PCI_CLASS_PROCESSOR_CO () {	0xb40;}
}
unless(defined(&PCI_BASE_CLASS_SERIAL)) {
    sub PCI_BASE_CLASS_SERIAL () {	0xc;}
}
unless(defined(&PCI_CLASS_SERIAL_FIREWIRE)) {
    sub PCI_CLASS_SERIAL_FIREWIRE () {	0xc00;}
}
unless(defined(&PCI_CLASS_SERIAL_ACCESS)) {
    sub PCI_CLASS_SERIAL_ACCESS () {	0xc01;}
}
unless(defined(&PCI_CLASS_SERIAL_SSA)) {
    sub PCI_CLASS_SERIAL_SSA () {	0xc02;}
}
unless(defined(&PCI_CLASS_SERIAL_USB)) {
    sub PCI_CLASS_SERIAL_USB () {	0xc03;}
}
unless(defined(&PCI_CLASS_SERIAL_FIBER)) {
    sub PCI_CLASS_SERIAL_FIBER () {	0xc04;}
}
unless(defined(&PCI_CLASS_OTHERS)) {
    sub PCI_CLASS_OTHERS () {	0xff;}
}
unless(defined(&PCI_VENDOR_ID_INTEL)) {
    sub PCI_VENDOR_ID_INTEL () {	0x8086;}
}
unless(defined(&PCI_VENDOR_ID_COMPAQ)) {
    sub PCI_VENDOR_ID_COMPAQ () {	0xe11;}
}
1;
