require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PCI_LIB_H)) {
    eval 'sub _PCI_LIB_H () {1;}' unless defined(&_PCI_LIB_H);
    require 'config.ph';
    if(defined(&HAVE_OWN_HEADER_H)) {
	require 'header.ph';
    } else {
	require 'linux/pci.ph';
    }
    if(defined(&OS_LINUX)) {
	require 'linux/types.ph';
    }
    if(defined(&OS_FREEBSD)) {
	require 'sys/types.ph';
    }
    if(defined(&OS_AIX)) {
	require 'sys/param.ph';
    }
    if(defined(&HAVE_LONG_ADDRESS)) {
    } else {
    }
    eval 'sub PCI_ACCESS_AUTO () {0;}' unless defined(&PCI_ACCESS_AUTO);
    eval 'sub PCI_ACCESS_PROC_BUS_PCI () {1;}' unless defined(&PCI_ACCESS_PROC_BUS_PCI);
    eval 'sub PCI_ACCESS_SYSCALLS () {2;}' unless defined(&PCI_ACCESS_SYSCALLS);
    eval 'sub PCI_ACCESS_I386_TYPE1 () {3;}' unless defined(&PCI_ACCESS_I386_TYPE1);
    eval 'sub PCI_ACCESS_I386_TYPE2 () {4;}' unless defined(&PCI_ACCESS_I386_TYPE2);
    eval 'sub PCI_ACCESS_FBSD_DEVICE () {5;}' unless defined(&PCI_ACCESS_FBSD_DEVICE);
    eval 'sub PCI_ACCESS_AIX_DEVICE () {6;}' unless defined(&PCI_ACCESS_AIX_DEVICE);
    eval 'sub PCI_ACCESS_DUMP () {7;}' unless defined(&PCI_ACCESS_DUMP);
    eval 'sub PCI_ACCESS_MAX () {8;}' unless defined(&PCI_ACCESS_MAX);
    eval 'sub PCI_ADDR_IO_MASK () {(~( &pciaddr_t) 0x3);}' unless defined(&PCI_ADDR_IO_MASK);
    eval 'sub PCI_ADDR_MEM_MASK () {(~( &pciaddr_t) 0xf);}' unless defined(&PCI_ADDR_MEM_MASK);
    eval 'sub PCI_FILL_IDENT () {1;}' unless defined(&PCI_FILL_IDENT);
    eval 'sub PCI_FILL_IRQ () {2;}' unless defined(&PCI_FILL_IRQ);
    eval 'sub PCI_FILL_BASES () {4;}' unless defined(&PCI_FILL_BASES);
    eval 'sub PCI_FILL_ROM_BASE () {8;}' unless defined(&PCI_FILL_ROM_BASE);
    eval 'sub PCI_FILL_SIZES () {16;}' unless defined(&PCI_FILL_SIZES);
    eval 'sub PCI_FILL_RESCAN () {0x10000;}' unless defined(&PCI_FILL_RESCAN);
    eval 'sub PCI_LOOKUP_VENDOR () {1;}' unless defined(&PCI_LOOKUP_VENDOR);
    eval 'sub PCI_LOOKUP_DEVICE () {2;}' unless defined(&PCI_LOOKUP_DEVICE);
    eval 'sub PCI_LOOKUP_CLASS () {4;}' unless defined(&PCI_LOOKUP_CLASS);
    eval 'sub PCI_LOOKUP_SUBSYSTEM () {8;}' unless defined(&PCI_LOOKUP_SUBSYSTEM);
    eval 'sub PCI_LOOKUP_PROGIF () {16;}' unless defined(&PCI_LOOKUP_PROGIF);
    eval 'sub PCI_LOOKUP_NUMERIC () {0x10000;}' unless defined(&PCI_LOOKUP_NUMERIC);
}
1;
