require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ATTNUM_H)) {
    eval 'sub ATTNUM_H () {1;}' unless defined(&ATTNUM_H);
    eval 'sub InvalidAttrNumber () {0;}' unless defined(&InvalidAttrNumber);
    eval 'sub AttributeNumberIsValid {
        my($attributeNumber) = @_;
	    eval q((( &bool) (($attributeNumber) !=  &InvalidAttrNumber)));
    }' unless defined(&AttributeNumberIsValid);
    eval 'sub AttrNumberIsForUserDefinedAttr {
        my($attributeNumber) = @_;
	    eval q((( &bool) (($attributeNumber) > 0)));
    }' unless defined(&AttrNumberIsForUserDefinedAttr);
    eval 'sub AttrNumberGetAttrOffset {
        my($attNum) = @_;
	    eval q((  &AssertMacro( &AttrNumberIsForUserDefinedAttr($attNum)), (($attNum) - 1) ));
    }' unless defined(&AttrNumberGetAttrOffset);
    eval 'sub AttrOffsetGetAttrNumber {
        my($attributeOffset) = @_;
	    eval q((( &AttrNumber) (1+ $attributeOffset)));
    }' unless defined(&AttrOffsetGetAttrNumber);
}
1;
