require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&HASH_H)) {
    eval 'sub HASH_H () {1;}' unless defined(&HASH_H);
    require 'access/itup.ph';
    require 'access/relscan.ph';
    require 'access/sdir.ph';
    require 'access/xlog.ph';
    require 'fmgr.ph';
    eval 'sub InvalidOvflAddress () {0;}' unless defined(&InvalidOvflAddress);
    eval 'sub SPLITSHIFT () {11;}' unless defined(&SPLITSHIFT);
    eval 'sub SPLITMASK () {0x7ff;}' unless defined(&SPLITMASK);
    eval 'sub SPLITNUM {
        my($N) = @_;
	    eval q((( &SplitNumber)((( &uint32)($N)) >>  &SPLITSHIFT)));
    }' unless defined(&SPLITNUM);
    eval 'sub OPAGENUM {
        my($N) = @_;
	    eval q((( &PageOffset)(($N) &  &SPLITMASK)));
    }' unless defined(&OPAGENUM);
    eval 'sub OADDR_OF {
        my($S,$O) = @_;
	    eval q((( &OverflowPageAddress)(( &uint32)(( &uint32)($S) <<  &SPLITSHIFT) + ($O))));
    }' unless defined(&OADDR_OF);
    eval 'sub BUCKET_TO_BLKNO {
        my($B) = @_;
	    eval q((( &Bucket) (($B) + (($B) ?  ($metap->{hashm_spares[_hash_log2((B)+1)}-1]) : 0)) + 1));
    }' unless defined(&BUCKET_TO_BLKNO);
    eval 'sub OADDR_TO_BLKNO {
        my($B) = @_;
	    eval q((( &BlockNumber) ( &BUCKET_TO_BLKNO ( (1<<  &SPLITNUM(($B))) -1) +  &OPAGENUM(($B)))););
    }' unless defined(&OADDR_TO_BLKNO);
    eval 'sub LH_UNUSED_PAGE () {(0);}' unless defined(&LH_UNUSED_PAGE);
    eval 'sub LH_OVERFLOW_PAGE () {(1<< 0);}' unless defined(&LH_OVERFLOW_PAGE);
    eval 'sub LH_BUCKET_PAGE () {(1<< 1);}' unless defined(&LH_BUCKET_PAGE);
    eval 'sub LH_BITMAP_PAGE () {(1<< 2);}' unless defined(&LH_BITMAP_PAGE);
    eval 'sub LH_META_PAGE () {(1<< 3);}' unless defined(&LH_META_PAGE);
    eval 'sub HASH_METAPAGE () {0;}' unless defined(&HASH_METAPAGE);
    eval 'sub HASH_MAGIC () {0x6440640;}' unless defined(&HASH_MAGIC);
    eval 'sub HASH_VERSION () {0;}' unless defined(&HASH_VERSION);
    eval 'sub NCACHED () {32;}' unless defined(&NCACHED);
    eval 'sub DEFAULT_FFACTOR () {300;}' unless defined(&DEFAULT_FFACTOR);
    eval 'sub SPLITMAX () {8;}' unless defined(&SPLITMAX);
    eval 'sub BYTE_TO_BIT () {3;}' unless defined(&BYTE_TO_BIT);
    eval 'sub INT_TO_BYTE () {2;}' unless defined(&INT_TO_BYTE);
    eval 'sub INT_TO_BIT () {5;}' unless defined(&INT_TO_BIT);
    eval 'sub ALL_SET () {(( &uint32) ~0);}' unless defined(&ALL_SET);
    eval 'sub BMPGSZ_BYTE {
        my($metap) = @_;
	    eval q((($metap)-> &hashm_bmsize));
    }' unless defined(&BMPGSZ_BYTE);
    eval 'sub BMPGSZ_BIT {
        my($metap) = @_;
	    eval q((($metap)-> &hashm_bmsize <<  &BYTE_TO_BIT));
    }' unless defined(&BMPGSZ_BIT);
    eval 'sub HashPageGetBitmap {
        my($pg) = @_;
	    eval q((( &uint32 *) (( ($pg)) +  &MAXALIGN($sizeof{ &PageHeaderData}))));
    }' unless defined(&HashPageGetBitmap);
    eval 'sub BITS_PER_MAP () {32;}' unless defined(&BITS_PER_MAP);
    eval 'sub CLRBIT {
        my($A, $N) = @_;
	    eval q((($A)[($N)/ &BITS_PER_MAP] &= ~(1<<(($N)% &BITS_PER_MAP))));
    }' unless defined(&CLRBIT);
    eval 'sub SETBIT {
        my($A, $N) = @_;
	    eval q((($A)[($N)/ &BITS_PER_MAP] |= (1<<(($N)% &BITS_PER_MAP))));
    }' unless defined(&SETBIT);
    eval 'sub ISSET {
        my($A, $N) = @_;
	    eval q((($A)[($N)/ &BITS_PER_MAP] & (1<<(($N)% &BITS_PER_MAP))));
    }' unless defined(&ISSET);
    eval 'sub HASH_READ () {0;}' unless defined(&HASH_READ);
    eval 'sub HASH_WRITE () {1;}' unless defined(&HASH_WRITE);
    eval 'sub P_NONE () {0;}' unless defined(&P_NONE);
    eval 'sub HTEqualStrategyNumber () {1;}' unless defined(&HTEqualStrategyNumber);
    eval 'sub HTMaxStrategyNumber () {1;}' unless defined(&HTMaxStrategyNumber);
    eval 'sub HASHPROC () {1;}' unless defined(&HASHPROC);
}
1;
