require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&HEAPAM_H)) {
    eval 'sub HEAPAM_H () {1;}' unless defined(&HEAPAM_H);
    require 'access/htup.ph';
    require 'access/relscan.ph';
    require 'access/sdir.ph';
    require 'access/tupmacs.ph';
    require 'access/xlogutils.ph';
    require 'nodes/primnodes.ph';
    require 'storage/block.ph';
    require 'storage/lmgr.ph';
    require 'utils/rel.ph';
    require 'utils/tqual.ph';
    eval 'sub IncrHeapAccessStat {
        my($x) = @_;
	    eval q((( &void) 0));
    }' unless defined(&IncrHeapAccessStat);
    if(!defined( &DISABLE_COMPLEX_MACRO)) {
	eval 'sub fastgetattr {
	    my($tup, $attnum, $tupleDesc, $isnull) = @_;
    	    eval q((  &AssertMacro(($attnum) > 0), (($isnull) ? (*($isnull) =  &false) : ( &dummyret) &NULL),  &HeapTupleNoNulls ? ( -> ($attrs[-1]->{attcacheoff}) >= 0? (  &fetchatt(-> $attrs[-1], ($tup)-> &t_data + ($tup)-> ($t_data->{t_hoff}) + ($tupleDesc)-> ($attrs[(attnum)-1]->{attcacheoff})) ) :  &nocachegetattr(($tup), ($attnum), ($tupleDesc), ($isnull)) ) : (  &att_isnull(($attnum)-1, ($tup)-> ($t_data->{t_bits})) ? ( (($isnull) ? (*($isnull) =  &true) : ( &dummyret) &NULL), ( &Datum) &NULL ) : (  &nocachegetattr(($tup), ($attnum), ($tupleDesc), ($isnull)) ) ) ));
	}' unless defined(&fastgetattr);
    } else {
    }
    eval 'sub heap_getattr {
        my($tup, $attnum, $tupleDesc, $isnull) = @_;
	    eval q((  &AssertMacro( !=  &NULL), ( ( > 0) ? ( ( > ($tup)-> ($t_data->{t_natts})) ? ( (($isnull) ? (*($isnull) =  &true) : ( &dummyret) &NULL), ( &Datum) &NULL ) :  &fastgetattr(($tup), ($attnum), ($tupleDesc), ($isnull)) ) :  &heap_getsysattr(($tup), ($attnum), ($isnull)) ) ));
    }' unless defined(&heap_getattr);
    eval 'sub heap_close {
        my($r,$l) = @_;
	    eval q( &relation_close($r,$l));
    }' unless defined(&heap_close);
}
1;
