require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SDIR_H)) {
    eval 'sub SDIR_H () {1;}' unless defined(&SDIR_H);
    eval("sub BackwardScanDirection () { -1; }") unless defined(&BackwardScanDirection);
    eval("sub NoMovementScanDirection () { 0; }") unless defined(&NoMovementScanDirection);
    eval("sub ForwardScanDirection () { 1; }") unless defined(&ForwardScanDirection);
    eval 'sub ScanDirectionIsValid {
        my($direction) = @_;
	    eval q((( &bool) ( &BackwardScanDirection <= ($direction)  && ($direction) <=  &ForwardScanDirection)));
    }' unless defined(&ScanDirectionIsValid);
    eval 'sub ScanDirectionIsBackward {
        my($direction) = @_;
	    eval q((( &bool) (($direction) ==  &BackwardScanDirection)));
    }' unless defined(&ScanDirectionIsBackward);
    eval 'sub ScanDirectionIsNoMovement {
        my($direction) = @_;
	    eval q((( &bool) (($direction) ==  &NoMovementScanDirection)));
    }' unless defined(&ScanDirectionIsNoMovement);
    eval 'sub ScanDirectionIsForward {
        my($direction) = @_;
	    eval q((( &bool) (($direction) ==  &ForwardScanDirection)));
    }' unless defined(&ScanDirectionIsForward);
}
1;
