require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&XACT_H)) {
    eval 'sub XACT_H () {1;}' unless defined(&XACT_H);
    require 'access/transam.ph';
    require 'access/xlog.ph';
    require 'utils/nabstime.ph';
    require 'utils/timestamp.ph';
    eval 'sub XACT_DIRTY_READ () {0;}' unless defined(&XACT_DIRTY_READ);
    eval 'sub XACT_READ_COMMITTED () {1;}' unless defined(&XACT_READ_COMMITTED);
    eval 'sub XACT_REPEATABLE_READ () {2;}' unless defined(&XACT_REPEATABLE_READ);
    eval 'sub XACT_SERIALIZABLE () {3;}' unless defined(&XACT_SERIALIZABLE);
    eval 'sub TRANS_DEFAULT () {0;}' unless defined(&TRANS_DEFAULT);
    eval 'sub TRANS_START () {1;}' unless defined(&TRANS_START);
    eval 'sub TRANS_INPROGRESS () {2;}' unless defined(&TRANS_INPROGRESS);
    eval 'sub TRANS_COMMIT () {3;}' unless defined(&TRANS_COMMIT);
    eval 'sub TRANS_ABORT () {4;}' unless defined(&TRANS_ABORT);
    eval 'sub TBLOCK_DEFAULT () {0;}' unless defined(&TBLOCK_DEFAULT);
    eval 'sub TBLOCK_BEGIN () {1;}' unless defined(&TBLOCK_BEGIN);
    eval 'sub TBLOCK_INPROGRESS () {2;}' unless defined(&TBLOCK_INPROGRESS);
    eval 'sub TBLOCK_END () {3;}' unless defined(&TBLOCK_END);
    eval 'sub TBLOCK_ABORT () {4;}' unless defined(&TBLOCK_ABORT);
    eval 'sub TBLOCK_ENDABORT () {5;}' unless defined(&TBLOCK_ENDABORT);
    eval 'sub XLOG_XACT_COMMIT () {0x;}' unless defined(&XLOG_XACT_COMMIT);
    eval 'sub XLOG_XACT_ABORT () {0x20;}' unless defined(&XLOG_XACT_ABORT);
    eval 'sub SizeOfXactCommit () {(( &offsetof( &xl_xact_commit,  &xtime) + $sizeof{ &time_t}));}' unless defined(&SizeOfXactCommit);
    eval 'sub SizeOfXactAbort () {(( &offsetof( &xl_xact_abort,  &xtime) + $sizeof{ &time_t}));}' unless defined(&SizeOfXactAbort);
}
1;
