require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&EXECDEBUG_H)) {
    eval 'sub EXECDEBUG_H () {1;}' unless defined(&EXECDEBUG_H);
    require 'executor/executor.ph';
    require 'nodes/print.ph';
    eval 'sub T_OR_F {
        my($b) = @_;
	    eval q((($b) ? \\"true\\" : \\"false\\"));
    }' unless defined(&T_OR_F);
    eval 'sub NULL_OR_TUPLE {
        my($slot) = @_;
	    eval q(( &TupIsNull($slot) ? \\"null\\" : \\"a tuple\\"));
    }' unless defined(&NULL_OR_TUPLE);
    if(defined(&EXEC_TUPLECOUNT)) {
	eval 'sub IncrRetrieved () {
	    eval q( &NTupleRetrieved++);
	}' unless defined(&IncrRetrieved);
	eval 'sub IncrAppended () {
	    eval q( &NTupleAppended++);
	}' unless defined(&IncrAppended);
	eval 'sub IncrDeleted () {
	    eval q( &NTupleDeleted++);
	}' unless defined(&IncrDeleted);
	eval 'sub IncrReplaced () {
	    eval q( &NTupleReplaced++);
	}' unless defined(&IncrReplaced);
	eval 'sub IncrInserted () {
	    eval q( &NTupleInserted++);
	}' unless defined(&IncrInserted);
	eval 'sub IncrProcessed () {
	    eval q( &NTupleProcessed++);
	}' unless defined(&IncrProcessed);
	eval 'sub IncrIndexProcessed () {
	    eval q( &NIndexTupleProcessed++);
	}' unless defined(&IncrIndexProcessed);
	eval 'sub IncrIndexInserted () {
	    eval q( &NIndexTupleInserted++);
	}' unless defined(&IncrIndexInserted);
    } else {
	eval 'sub IncrRetrieved () {
	    eval q(( &void)(0));
	}' unless defined(&IncrRetrieved);
	eval 'sub IncrAppended () {
	    eval q(( &void)(0));
	}' unless defined(&IncrAppended);
	eval 'sub IncrDeleted () {
	    eval q(( &void)(0));
	}' unless defined(&IncrDeleted);
	eval 'sub IncrReplaced () {
	    eval q(( &void)(0));
	}' unless defined(&IncrReplaced);
	eval 'sub IncrInserted () {
	    eval q(( &void)(0));
	}' unless defined(&IncrInserted);
	eval 'sub IncrProcessed () {
	    eval q(( &void)(0));
	}' unless defined(&IncrProcessed);
	eval 'sub IncrIndexProcessed () {
	    eval q(( &void)(0));
	}' unless defined(&IncrIndexProcessed);
	eval 'sub IncrIndexInserted () {
	    eval q(( &void)(0));
	}' unless defined(&IncrIndexInserted);
    }
    if(defined(&EXEC_CONTEXTDEBUG)) {
	eval 'sub CXT_printf {
	    my($s) = @_;
    	    eval q( &printf($s));
	}' unless defined(&CXT_printf);
	eval 'sub CXT1_printf {
	    my($s, $a) = @_;
    	    eval q( &printf($s, $a));
	}' unless defined(&CXT1_printf);
    } else {
	eval 'sub CXT_printf {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&CXT_printf);
	eval 'sub CXT1_printf {
	    my($s, $a) = @_;
    	    eval q();
	}' unless defined(&CXT1_printf);
    }
    if(defined(&EXEC_UTILSDEBUG)) {
	eval 'sub EU_nodeDisplay {
	    my($l) = @_;
    	    eval q( &nodeDisplay($l));
	}' unless defined(&EU_nodeDisplay);
	eval 'sub EU_printf {
	    my($s) = @_;
    	    eval q( &printf($s));
	}' unless defined(&EU_printf);
	eval 'sub EU1_printf {
	    my($s, $a) = @_;
    	    eval q( &printf($s, $a));
	}' unless defined(&EU1_printf);
	eval 'sub EU2_printf {
	    my($s, $a, $b) = @_;
    	    eval q( &printf($s, $a, $b));
	}' unless defined(&EU2_printf);
	eval 'sub EU3_printf {
	    my($s, $a, $b, $c) = @_;
    	    eval q( &printf($s, $a, $b, $c));
	}' unless defined(&EU3_printf);
	eval 'sub EU4_printf {
	    my($s, $a, $b, $c, $d) = @_;
    	    eval q( &printf($s, $a, $b, $c, $d));
	}' unless defined(&EU4_printf);
    } else {
	eval 'sub EU_nodeDisplay {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&EU_nodeDisplay);
	eval 'sub EU_printf {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&EU_printf);
	eval 'sub EU1_printf {
	    my($s, $a) = @_;
    	    eval q();
	}' unless defined(&EU1_printf);
	eval 'sub EU2_printf {
	    my($s, $a, $b) = @_;
    	    eval q();
	}' unless defined(&EU2_printf);
	eval 'sub EU3_printf {
	    my($s, $a, $b, $c) = @_;
    	    eval q();
	}' unless defined(&EU3_printf);
	eval 'sub EU4_printf {
	    my($s, $a, $b, $c, $d) = @_;
    	    eval q();
	}' unless defined(&EU4_printf);
    }
    if(defined(&EXEC_NESTLOOPDEBUG)) {
	eval 'sub NL_nodeDisplay {
	    my($l) = @_;
    	    eval q( &nodeDisplay($l));
	}' unless defined(&NL_nodeDisplay);
	eval 'sub NL_printf {
	    my($s) = @_;
    	    eval q( &printf($s));
	}' unless defined(&NL_printf);
	eval 'sub NL1_printf {
	    my($s, $a) = @_;
    	    eval q( &printf($s, $a));
	}' unless defined(&NL1_printf);
	eval 'sub NL4_printf {
	    my($s, $a, $b, $c, $d) = @_;
    	    eval q( &printf($s, $a, $b, $c, $d));
	}' unless defined(&NL4_printf);
	eval 'sub ENL1_printf {
	    my($message) = @_;
    	    eval q( &printf(\\"ExecNestLoop: %s\\\\n\\", $message));
	}' unless defined(&ENL1_printf);
    } else {
	eval 'sub NL_nodeDisplay {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&NL_nodeDisplay);
	eval 'sub NL_printf {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&NL_printf);
	eval 'sub NL1_printf {
	    my($s, $a) = @_;
    	    eval q();
	}' unless defined(&NL1_printf);
	eval 'sub NL4_printf {
	    my($s, $a, $b, $c, $d) = @_;
    	    eval q();
	}' unless defined(&NL4_printf);
	eval 'sub ENL1_printf {
	    my($message) = @_;
    	    eval q();
	}' unless defined(&ENL1_printf);
    }
    if(defined(&EXEC_PROCDEBUG)) {
	eval 'sub PN_printf {
	    my($s) = @_;
    	    eval q( &printf($s));
	}' unless defined(&PN_printf);
	eval 'sub PN1_printf {
	    my($s, $p) = @_;
    	    eval q( &printf($s, $p));
	}' unless defined(&PN1_printf);
    } else {
	eval 'sub PN_printf {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&PN_printf);
	eval 'sub PN1_printf {
	    my($s, $p) = @_;
    	    eval q();
	}' unless defined(&PN1_printf);
    }
    if(defined(&EXEC_EVALDEBUG)) {
	eval 'sub EV_nodeDisplay {
	    my($l) = @_;
    	    eval q( &nodeDisplay($l));
	}' unless defined(&EV_nodeDisplay);
	eval 'sub EV_printf {
	    my($s) = @_;
    	    eval q( &printf($s));
	}' unless defined(&EV_printf);
	eval 'sub EV1_printf {
	    my($s, $a) = @_;
    	    eval q( &printf($s, $a));
	}' unless defined(&EV1_printf);
	eval 'sub EV5_printf {
	    my($s, $a, $b, $c, $d, $e) = @_;
    	    eval q( &printf($s, $a, $b, $c, $d, $e));
	}' unless defined(&EV5_printf);
    } else {
	eval 'sub EV_nodeDisplay {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&EV_nodeDisplay);
	eval 'sub EV_printf {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&EV_printf);
	eval 'sub EV1_printf {
	    my($s, $a) = @_;
    	    eval q();
	}' unless defined(&EV1_printf);
	eval 'sub EV5_printf {
	    my($s, $a, $b, $c, $d, $e) = @_;
    	    eval q();
	}' unless defined(&EV5_printf);
    }
    if(defined(&EXEC_SCANDEBUG)) {
	eval 'sub S_nodeDisplay {
	    my($l) = @_;
    	    eval q( &nodeDisplay($l));
	}' unless defined(&S_nodeDisplay);
	eval 'sub S_printf {
	    my($s) = @_;
    	    eval q( &printf($s));
	}' unless defined(&S_printf);
	eval 'sub S1_printf {
	    my($s, $p) = @_;
    	    eval q( &printf($s, $p));
	}' unless defined(&S1_printf);
    } else {
	eval 'sub S_nodeDisplay {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&S_nodeDisplay);
	eval 'sub S_printf {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&S_printf);
	eval 'sub S1_printf {
	    my($s, $p) = @_;
    	    eval q();
	}' unless defined(&S1_printf);
    }
    if(defined(&EXEC_SORTDEBUG)) {
	eval 'sub SO_nodeDisplay {
	    my($l) = @_;
    	    eval q( &nodeDisplay($l));
	}' unless defined(&SO_nodeDisplay);
	eval 'sub SO_printf {
	    my($s) = @_;
    	    eval q( &printf($s));
	}' unless defined(&SO_printf);
	eval 'sub SO1_printf {
	    my($s, $p) = @_;
    	    eval q( &printf($s, $p));
	}' unless defined(&SO1_printf);
    } else {
	eval 'sub SO_nodeDisplay {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&SO_nodeDisplay);
	eval 'sub SO_printf {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&SO_printf);
	eval 'sub SO1_printf {
	    my($s, $p) = @_;
    	    eval q();
	}' unless defined(&SO1_printf);
    }
    if(defined(&EXEC_MERGEJOINDEBUG)) {
	eval 'sub MJ_nodeDisplay {
	    my($l) = @_;
    	    eval q( &nodeDisplay($l));
	}' unless defined(&MJ_nodeDisplay);
	eval 'sub MJ_printf {
	    my($s) = @_;
    	    eval q( &printf($s));
	}' unless defined(&MJ_printf);
	eval 'sub MJ1_printf {
	    my($s, $p) = @_;
    	    eval q( &printf($s, $p));
	}' unless defined(&MJ1_printf);
	eval 'sub MJ2_printf {
	    my($s, $p1, $p2) = @_;
    	    eval q( &printf($s, $p1, $p2));
	}' unless defined(&MJ2_printf);
	eval 'sub MJ_debugtup {
	    my($tuple, $type) = @_;
    	    eval q( &debugtup($tuple, $type,  &NULL));
	}' unless defined(&MJ_debugtup);
	eval 'sub MJ_dump {
	    my($state) = @_;
    	    eval q( &ExecMergeTupleDump($state));
	}' unless defined(&MJ_dump);
	eval 'sub MJ_DEBUG_QUAL {
	    my($clause, $res) = @_;
    	    eval q( &MJ2_printf(\\"  ExecQual(%s, econtext) returns %s\\\\n\\",  &CppAsString($clause),  &T_OR_F($res)););
	}' unless defined(&MJ_DEBUG_QUAL);
	eval 'sub MJ_DEBUG_MERGE_COMPARE {
	    my($qual, $res) = @_;
    	    eval q( &MJ2_printf(\\"  MergeCompare(mergeclauses, %s, ...) returns %s\\\\n\\",  &CppAsString($qual),  &T_OR_F($res)););
	}' unless defined(&MJ_DEBUG_MERGE_COMPARE);
	eval 'sub MJ_DEBUG_PROC_NODE {
	    my($slot) = @_;
    	    eval q( &MJ2_printf(\\"  %s = ExecProcNode(...) returns %s\\\\n\\",  &CppAsString($slot),  &NULL_OR_TUPLE($slot)););
	}' unless defined(&MJ_DEBUG_PROC_NODE);
    } else {
	eval 'sub MJ_nodeDisplay {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&MJ_nodeDisplay);
	eval 'sub MJ_printf {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&MJ_printf);
	eval 'sub MJ1_printf {
	    my($s, $p) = @_;
    	    eval q();
	}' unless defined(&MJ1_printf);
	eval 'sub MJ2_printf {
	    my($s, $p1, $p2) = @_;
    	    eval q();
	}' unless defined(&MJ2_printf);
	eval 'sub MJ_debugtup {
	    my($tuple, $type) = @_;
    	    eval q();
	}' unless defined(&MJ_debugtup);
	eval 'sub MJ_dump {
	    my($state) = @_;
    	    eval q();
	}' unless defined(&MJ_dump);
	eval 'sub MJ_DEBUG_QUAL {
	    my($clause, $res) = @_;
    	    eval q();
	}' unless defined(&MJ_DEBUG_QUAL);
	eval 'sub MJ_DEBUG_MERGE_COMPARE {
	    my($qual, $res) = @_;
    	    eval q();
	}' unless defined(&MJ_DEBUG_MERGE_COMPARE);
	eval 'sub MJ_DEBUG_PROC_NODE {
	    my($slot) = @_;
    	    eval q();
	}' unless defined(&MJ_DEBUG_PROC_NODE);
    }
    undef(&NOTYET) if defined(&NOTYET);
}
1;
