require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&EXECUTOR_H)) {
    eval 'sub EXECUTOR_H () {1;}' unless defined(&EXECUTOR_H);
    require 'executor/execdesc.ph';
    eval 'sub TupIsNull {
        my($slot) = @_;
	    eval q((($slot) ==  &NULL || ($slot)-> &val ==  &NULL));
    }' unless defined(&TupIsNull);
    eval 'sub do_text_output_oneline {
        my($tstate, $text_to_emit) = @_;
	    eval q( &do { \'char\' * $values_[1];  $values_[0] = ($text_to_emit);  &do_tup_output($tstate,  &values_); }  &while (0));
    }' unless defined(&do_text_output_oneline);
    eval 'sub ResetExprContext {
        my($econtext) = @_;
	    eval q( &MemoryContextReset(($econtext)-> &ecxt_per_tuple_memory));
    }' unless defined(&ResetExprContext);
    eval 'sub GetPerTupleExprContext {
        my($estate) = @_;
	    eval q((($estate)-> &es_per_tuple_exprcontext ? ($estate)-> &es_per_tuple_exprcontext :  &MakePerTupleExprContext($estate)));
    }' unless defined(&GetPerTupleExprContext);
    eval 'sub GetPerTupleMemoryContext {
        my($estate) = @_;
	    eval q(( &GetPerTupleExprContext($estate)-> &ecxt_per_tuple_memory));
    }' unless defined(&GetPerTupleMemoryContext);
    eval 'sub ResetPerTupleExprContext {
        my($estate) = @_;
	    eval q( &do {  &if (($estate)-> &es_per_tuple_exprcontext)  &ResetExprContext(($estate)-> &es_per_tuple_exprcontext); }  &while (0));
    }' unless defined(&ResetPerTupleExprContext);
}
1;
