require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&FMGR_H)) {
    eval 'sub FMGR_H () {1;}' unless defined(&FMGR_H);
    eval 'sub FunctionCallInvoke {
        my($fcinfo) = @_;
	    eval q(((* ($fcinfo)-> ($flinfo->{fn_addr})) ($fcinfo)));
    }' unless defined(&FunctionCallInvoke);
    eval 'sub PG_FUNCTION_ARGS () { &FunctionCallInfo  &fcinfo;}' unless defined(&PG_FUNCTION_ARGS);
    eval 'sub PG_NARGS () {
        eval q(( ($fcinfo->{nargs})));
    }' unless defined(&PG_NARGS);
    eval 'sub PG_ARGISNULL {
        my($n) = @_;
	    eval q(( ($fcinfo->{argnull[$n]})));
    }' unless defined(&PG_ARGISNULL);
    eval 'sub PG_DETOAST_DATUM {
        my($datum) = @_;
	    eval q( &pg_detoast_datum(  &DatumGetPointer($datum)));
    }' unless defined(&PG_DETOAST_DATUM);
    eval 'sub PG_DETOAST_DATUM_COPY {
        my($datum) = @_;
	    eval q( &pg_detoast_datum_copy(  &DatumGetPointer($datum)));
    }' unless defined(&PG_DETOAST_DATUM_COPY);
    eval 'sub PG_DETOAST_DATUM_SLICE {
        my($datum,$f,$c) = @_;
	    eval q( &pg_detoast_datum_slice(  &DatumGetPointer($datum), ( &int32) $f, ( &int32) $c));
    }' unless defined(&PG_DETOAST_DATUM_SLICE);
    eval 'sub PG_FREE_IF_COPY {
        my($ptr,$n) = @_;
	    eval q( &do {  &if (( &Pointer) ($ptr) !=  &PG_GETARG_POINTER($n))  &pfree($ptr); }  &while (0));
    }' unless defined(&PG_FREE_IF_COPY);
    eval 'sub PG_GETARG_DATUM {
        my($n) = @_;
	    eval q(( ($fcinfo->{arg[$n]})));
    }' unless defined(&PG_GETARG_DATUM);
    eval 'sub PG_GETARG_INT32 {
        my($n) = @_;
	    eval q( &DatumGetInt32( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_INT32);
    eval 'sub PG_GETARG_UINT32 {
        my($n) = @_;
	    eval q( &DatumGetUInt32( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_UINT32);
    eval 'sub PG_GETARG_INT16 {
        my($n) = @_;
	    eval q( &DatumGetInt16( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_INT16);
    eval 'sub PG_GETARG_UINT16 {
        my($n) = @_;
	    eval q( &DatumGetUInt16( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_UINT16);
    eval 'sub PG_GETARG_CHAR {
        my($n) = @_;
	    eval q( &DatumGetChar( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_CHAR);
    eval 'sub PG_GETARG_BOOL {
        my($n) = @_;
	    eval q( &DatumGetBool( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_BOOL);
    eval 'sub PG_GETARG_OID {
        my($n) = @_;
	    eval q( &DatumGetObjectId( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_OID);
    eval 'sub PG_GETARG_POINTER {
        my($n) = @_;
	    eval q( &DatumGetPointer( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_POINTER);
    eval 'sub PG_GETARG_CSTRING {
        my($n) = @_;
	    eval q( &DatumGetCString( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_CSTRING);
    eval 'sub PG_GETARG_NAME {
        my($n) = @_;
	    eval q( &DatumGetName( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_NAME);
    eval 'sub PG_GETARG_FLOAT4 {
        my($n) = @_;
	    eval q( &DatumGetFloat4( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_FLOAT4);
    eval 'sub PG_GETARG_FLOAT8 {
        my($n) = @_;
	    eval q( &DatumGetFloat8( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_FLOAT8);
    eval 'sub PG_GETARG_INT64 {
        my($n) = @_;
	    eval q( &DatumGetInt64( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_INT64);
    eval 'sub PG_GETARG_RAW_VARLENA_P {
        my($n) = @_;
	    eval q((  &PG_GETARG_POINTER($n)));
    }' unless defined(&PG_GETARG_RAW_VARLENA_P);
    eval 'sub PG_GETARG_VARLENA_P {
        my($n) = @_;
	    eval q( &PG_DETOAST_DATUM( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_VARLENA_P);
    eval 'sub DatumGetByteaP {
        my($X) = @_;
	    eval q((( &bytea *)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetByteaP);
    eval 'sub DatumGetTextP {
        my($X) = @_;
	    eval q((( &text *)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetTextP);
    eval 'sub DatumGetBpCharP {
        my($X) = @_;
	    eval q((( &BpChar *)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetBpCharP);
    eval 'sub DatumGetVarCharP {
        my($X) = @_;
	    eval q((( &VarChar *)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetVarCharP);
    eval 'sub DatumGetByteaPCopy {
        my($X) = @_;
	    eval q((( &bytea *)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetByteaPCopy);
    eval 'sub DatumGetTextPCopy {
        my($X) = @_;
	    eval q((( &text *)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetTextPCopy);
    eval 'sub DatumGetBpCharPCopy {
        my($X) = @_;
	    eval q((( &BpChar *)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetBpCharPCopy);
    eval 'sub DatumGetVarCharPCopy {
        my($X) = @_;
	    eval q((( &VarChar *)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetVarCharPCopy);
    eval 'sub DatumGetByteaPSlice {
        my($X,$m,$n) = @_;
	    eval q((( &bytea *)  &PG_DETOAST_DATUM_SLICE($X,$m,$n)));
    }' unless defined(&DatumGetByteaPSlice);
    eval 'sub DatumGetTextPSlice {
        my($X,$m,$n) = @_;
	    eval q((( &text *)  &PG_DETOAST_DATUM_SLICE($X,$m,$n)));
    }' unless defined(&DatumGetTextPSlice);
    eval 'sub DatumGetBpCharPSlice {
        my($X,$m,$n) = @_;
	    eval q((( &BpChar *)  &PG_DETOAST_DATUM_SLICE($X,$m,$n)));
    }' unless defined(&DatumGetBpCharPSlice);
    eval 'sub DatumGetVarCharPSlice {
        my($X,$m,$n) = @_;
	    eval q((( &VarChar *)  &PG_DETOAST_DATUM_SLICE($X,$m,$n)));
    }' unless defined(&DatumGetVarCharPSlice);
    eval 'sub PG_GETARG_BYTEA_P {
        my($n) = @_;
	    eval q( &DatumGetByteaP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_BYTEA_P);
    eval 'sub PG_GETARG_TEXT_P {
        my($n) = @_;
	    eval q( &DatumGetTextP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_TEXT_P);
    eval 'sub PG_GETARG_BPCHAR_P {
        my($n) = @_;
	    eval q( &DatumGetBpCharP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_BPCHAR_P);
    eval 'sub PG_GETARG_VARCHAR_P {
        my($n) = @_;
	    eval q( &DatumGetVarCharP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_VARCHAR_P);
    eval 'sub PG_GETARG_BYTEA_P_COPY {
        my($n) = @_;
	    eval q( &DatumGetByteaPCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_BYTEA_P_COPY);
    eval 'sub PG_GETARG_TEXT_P_COPY {
        my($n) = @_;
	    eval q( &DatumGetTextPCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_TEXT_P_COPY);
    eval 'sub PG_GETARG_BPCHAR_P_COPY {
        my($n) = @_;
	    eval q( &DatumGetBpCharPCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_BPCHAR_P_COPY);
    eval 'sub PG_GETARG_VARCHAR_P_COPY {
        my($n) = @_;
	    eval q( &DatumGetVarCharPCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_VARCHAR_P_COPY);
    eval 'sub PG_GETARG_BYTEA_P_SLICE {
        my($n,$a,$b) = @_;
	    eval q( &DatumGetByteaPSlice( &PG_GETARG_DATUM($n),$a,$b));
    }' unless defined(&PG_GETARG_BYTEA_P_SLICE);
    eval 'sub PG_GETARG_TEXT_P_SLICE {
        my($n,$a,$b) = @_;
	    eval q( &DatumGetTextPSlice( &PG_GETARG_DATUM($n),$a,$b));
    }' unless defined(&PG_GETARG_TEXT_P_SLICE);
    eval 'sub PG_GETARG_BPCHAR_P_SLICE {
        my($n,$a,$b) = @_;
	    eval q( &DatumGetBpCharPSlice( &PG_GETARG_DATUM($n),$a,$b));
    }' unless defined(&PG_GETARG_BPCHAR_P_SLICE);
    eval 'sub PG_GETARG_VARCHAR_P_SLICE {
        my($n,$a,$b) = @_;
	    eval q( &DatumGetVarCharPSlice( &PG_GETARG_DATUM($n),$a,$b));
    }' unless defined(&PG_GETARG_VARCHAR_P_SLICE);
    eval 'sub PG_RETURN_NULL () {
        eval q( &do {  ($fcinfo->{isnull}) =  &true;  &return ( &Datum) 0; }  &while (0));
    }' unless defined(&PG_RETURN_NULL);
    eval 'sub PG_RETURN_VOID () {
        eval q( &return ( &Datum) 0);
    }' unless defined(&PG_RETURN_VOID);
    eval 'sub PG_RETURN_DATUM {
        my($x) = @_;
	    eval q( &return ($x));
    }' unless defined(&PG_RETURN_DATUM);
    eval 'sub PG_RETURN_INT32 {
        my($x) = @_;
	    eval q( &return  &Int32GetDatum($x));
    }' unless defined(&PG_RETURN_INT32);
    eval 'sub PG_RETURN_UINT32 {
        my($x) = @_;
	    eval q( &return  &UInt32GetDatum($x));
    }' unless defined(&PG_RETURN_UINT32);
    eval 'sub PG_RETURN_INT16 {
        my($x) = @_;
	    eval q( &return  &Int16GetDatum($x));
    }' unless defined(&PG_RETURN_INT16);
    eval 'sub PG_RETURN_CHAR {
        my($x) = @_;
	    eval q( &return  &CharGetDatum($x));
    }' unless defined(&PG_RETURN_CHAR);
    eval 'sub PG_RETURN_BOOL {
        my($x) = @_;
	    eval q( &return  &BoolGetDatum($x));
    }' unless defined(&PG_RETURN_BOOL);
    eval 'sub PG_RETURN_OID {
        my($x) = @_;
	    eval q( &return  &ObjectIdGetDatum($x));
    }' unless defined(&PG_RETURN_OID);
    eval 'sub PG_RETURN_POINTER {
        my($x) = @_;
	    eval q( &return  &PointerGetDatum($x));
    }' unless defined(&PG_RETURN_POINTER);
    eval 'sub PG_RETURN_CSTRING {
        my($x) = @_;
	    eval q( &return  &CStringGetDatum($x));
    }' unless defined(&PG_RETURN_CSTRING);
    eval 'sub PG_RETURN_NAME {
        my($x) = @_;
	    eval q( &return  &NameGetDatum($x));
    }' unless defined(&PG_RETURN_NAME);
    eval 'sub PG_RETURN_FLOAT4 {
        my($x) = @_;
	    eval q( &return  &Float4GetDatum($x));
    }' unless defined(&PG_RETURN_FLOAT4);
    eval 'sub PG_RETURN_FLOAT8 {
        my($x) = @_;
	    eval q( &return  &Float8GetDatum($x));
    }' unless defined(&PG_RETURN_FLOAT8);
    eval 'sub PG_RETURN_INT64 {
        my($x) = @_;
	    eval q( &return  &Int64GetDatum($x));
    }' unless defined(&PG_RETURN_INT64);
    eval 'sub PG_RETURN_BYTEA_P {
        my($x) = @_;
	    eval q( &PG_RETURN_POINTER($x));
    }' unless defined(&PG_RETURN_BYTEA_P);
    eval 'sub PG_RETURN_TEXT_P {
        my($x) = @_;
	    eval q( &PG_RETURN_POINTER($x));
    }' unless defined(&PG_RETURN_TEXT_P);
    eval 'sub PG_RETURN_BPCHAR_P {
        my($x) = @_;
	    eval q( &PG_RETURN_POINTER($x));
    }' unless defined(&PG_RETURN_BPCHAR_P);
    eval 'sub PG_RETURN_VARCHAR_P {
        my($x) = @_;
	    eval q( &PG_RETURN_POINTER($x));
    }' unless defined(&PG_RETURN_VARCHAR_P);
    eval 'sub PG_FUNCTION_INFO_V1 {
        my($funcname) = @_;
	    eval q( &extern  &Pg_finfo_record *  &CppConcat( &pg_finfo_,$funcname) ( &void);  &Pg_finfo_record *  &CppConcat( &pg_finfo_,$funcname) ( &void) {  &static  &Pg_finfo_record  &my_finfo = { 1};  &return  &my_finfo; }  &extern \'int\'  &no_such_variable);
    }' unless defined(&PG_FUNCTION_INFO_V1);
}
1;
