require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PQCOMM_H)) {
    eval 'sub PQCOMM_H () {1;}' unless defined(&PQCOMM_H);
    require 'sys/types.ph';
    if(defined(&WIN32)) {
	require 'winsock.ph';
	if(defined(&ELOG_H)) {
	    undef(&ERROR) if defined(&ERROR);
	    eval 'sub ERROR () {(-1);}' unless defined(&ERROR);
	}
    } else {
	require 'sys/socket.ph';
	if(defined(&HAVE_SYS_UN_H)) {
	    require 'sys/un.ph';
	}
	require 'netinet/in.ph';
    }
    unless(defined(&HAVE_STRUCT_SOCKADDR_UN)) {
    }
    eval 'sub UNIXSOCK_PATH {
        my($sun,$port,$defpath) = @_;
	    eval q( &snprintf(($sun). &sun_path, $sizeof{($sun). &sun_path}, \\"%s/.s.PGSQL.%d\\", (($defpath)  && *($defpath) != ord(\'\\\\0\')) ? ($defpath) :  &DEFAULT_PGSOCKET_DIR, ($port)));
    }' unless defined(&UNIXSOCK_PATH);
    if(defined( &SUN_LEN)) {
	eval 'sub UNIXSOCK_LEN {
	    my($sun) = @_;
    	    eval q(( &SUN_LEN(($sun))));
	}' unless defined(&UNIXSOCK_LEN);
    } else {
	eval 'sub UNIXSOCK_LEN {
	    my($sun) = @_;
    	    eval q(( &strlen(($sun). &sun_path) +  &offsetof(\'struct sockaddr_un\',  &sun_path)));
	}' unless defined(&UNIXSOCK_LEN);
    }
    eval 'sub PG_PROTOCOL_MAJOR {
        my($v) = @_;
	    eval q((($v) >> 16));
    }' unless defined(&PG_PROTOCOL_MAJOR);
    eval 'sub PG_PROTOCOL_MINOR {
        my($v) = @_;
	    eval q((($v) & 0xffff));
    }' unless defined(&PG_PROTOCOL_MINOR);
    eval 'sub PG_PROTOCOL {
        my($m,$n) = @_;
	    eval q(((($m) << 16) | ($n)));
    }' unless defined(&PG_PROTOCOL);
    eval 'sub PG_PROTOCOL_EARLIEST () { &PG_PROTOCOL(1,0);}' unless defined(&PG_PROTOCOL_EARLIEST);
    eval 'sub PG_PROTOCOL_LATEST () { &PG_PROTOCOL(2,0);}' unless defined(&PG_PROTOCOL_LATEST);
    eval 'sub SM_DATABASE () {64;}' unless defined(&SM_DATABASE);
    eval 'sub SM_USER () {32;}' unless defined(&SM_USER);
    eval 'sub SM_DATABASE_USER () {( &SM_DATABASE+ &SM_USER+1);}' unless defined(&SM_DATABASE_USER);
    eval 'sub SM_OPTIONS () {64;}' unless defined(&SM_OPTIONS);
    eval 'sub SM_UNUSED () {64;}' unless defined(&SM_UNUSED);
    eval 'sub SM_TTY () {64;}' unless defined(&SM_TTY);
    eval 'sub AUTH_REQ_OK () {0;}' unless defined(&AUTH_REQ_OK);
    eval 'sub AUTH_REQ_KRB4 () {1;}' unless defined(&AUTH_REQ_KRB4);
    eval 'sub AUTH_REQ_KRB5 () {2;}' unless defined(&AUTH_REQ_KRB5);
    eval 'sub AUTH_REQ_PASSWORD () {3;}' unless defined(&AUTH_REQ_PASSWORD);
    eval 'sub AUTH_REQ_CRYPT () {4;}' unless defined(&AUTH_REQ_CRYPT);
    eval 'sub AUTH_REQ_MD5 () {5;}' unless defined(&AUTH_REQ_MD5);
    eval 'sub AUTH_REQ_SCM_CREDS () {6;}' unless defined(&AUTH_REQ_SCM_CREDS);
    eval 'sub CANCEL_REQUEST_CODE () { &PG_PROTOCOL(1234,5678);}' unless defined(&CANCEL_REQUEST_CODE);
    eval 'sub NEGOTIATE_SSL_CODE () { &PG_PROTOCOL(1234,5679);}' unless defined(&NEGOTIATE_SSL_CODE);
}
1;
