require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PG_WCHAR_H)) {
    eval 'sub PG_WCHAR_H () {1;}' unless defined(&PG_WCHAR_H);
    require 'sys/types.ph';
    if(defined(&FRONTEND)) {
	undef(&palloc) if defined(&palloc);
	eval 'sub palloc () { &malloc;}' unless defined(&palloc);
	undef(&pfree) if defined(&pfree);
	eval 'sub pfree () { &free;}' unless defined(&pfree);
    }
    eval 'sub SS2 () {0x8e;}' unless defined(&SS2);
    eval 'sub SS3 () {0x8f;}' unless defined(&SS3);
    eval 'sub IS_LC1 {
        my($c) = @_;
	    eval q(( >= 0x81  && ($c) <= 0x8d));
    }' unless defined(&IS_LC1);
    eval 'sub IS_LCPRV1 {
        my($c) = @_;
	    eval q(( == 0x9a || ($c) == 0x9b));
    }' unless defined(&IS_LCPRV1);
    eval 'sub IS_LC2 {
        my($c) = @_;
	    eval q(( >= 0x90  && ($c) <= 0x99));
    }' unless defined(&IS_LC2);
    eval 'sub IS_LCPRV2 {
        my($c) = @_;
	    eval q(( == 0x9c || ($c) == 0x9d));
    }' unless defined(&IS_LCPRV2);
    eval 'sub LC_ISO8859_1 () {0x81;}' unless defined(&LC_ISO8859_1);
    eval 'sub LC_ISO8859_2 () {0x82;}' unless defined(&LC_ISO8859_2);
    eval 'sub LC_ISO8859_3 () {0x83;}' unless defined(&LC_ISO8859_3);
    eval 'sub LC_ISO8859_4 () {0x84;}' unless defined(&LC_ISO8859_4);
    eval 'sub LC_TIS620 () {0x85;}' unless defined(&LC_TIS620);
    eval 'sub LC_ISO8859_7 () {0x86;}' unless defined(&LC_ISO8859_7);
    eval 'sub LC_ISO8859_6 () {0x87;}' unless defined(&LC_ISO8859_6);
    eval 'sub LC_ISO8859_8 () {0x88;}' unless defined(&LC_ISO8859_8);
    eval 'sub LC_JISX0201K () {0x89;}' unless defined(&LC_JISX0201K);
    eval 'sub LC_JISX0201R () {0x8a;}' unless defined(&LC_JISX0201R);
    eval 'sub LC_KOI8_R () {0x8b;}' unless defined(&LC_KOI8_R);
    eval 'sub LC_KOI8_U () {0x8b;}' unless defined(&LC_KOI8_U);
    eval 'sub LC_ISO8859_5 () {0x8c;}' unless defined(&LC_ISO8859_5);
    eval 'sub LC_ISO8859_9 () {0x8d;}' unless defined(&LC_ISO8859_9);
    eval 'sub CONTROL_1 () {0x8f;}' unless defined(&CONTROL_1);
    eval 'sub LC_JISX0208_1978 () {0x90;}' unless defined(&LC_JISX0208_1978);
    eval 'sub LC_GB2312_80 () {0x91;}' unless defined(&LC_GB2312_80);
    eval 'sub LC_JISX0208 () {0x92;}' unless defined(&LC_JISX0208);
    eval 'sub LC_KS5601 () {0x93;}' unless defined(&LC_KS5601);
    eval 'sub LC_JISX0212 () {0x94;}' unless defined(&LC_JISX0212);
    eval 'sub LC_CNS11643_1 () {0x95;}' unless defined(&LC_CNS11643_1);
    eval 'sub LC_CNS11643_2 () {0x96;}' unless defined(&LC_CNS11643_2);
    eval 'sub LC_BIG5_1 () {0x98;}' unless defined(&LC_BIG5_1);
    eval 'sub LC_BIG5_2 () {0x99;}' unless defined(&LC_BIG5_2);
    eval 'sub LC_SISHENG () {0xa0;}' unless defined(&LC_SISHENG);
    eval 'sub LC_IPA () {0xa1;}' unless defined(&LC_IPA);
    eval 'sub LC_VISCII_LOWER () {0xa2;}' unless defined(&LC_VISCII_LOWER);
    eval 'sub LC_VISCII_UPPER () {0xa3;}' unless defined(&LC_VISCII_UPPER);
    eval 'sub LC_ARABIC_DIGIT () {0xa4;}' unless defined(&LC_ARABIC_DIGIT);
    eval 'sub LC_ARABIC_1_COLUMN () {0xa5;}' unless defined(&LC_ARABIC_1_COLUMN);
    eval 'sub LC_ASCII_RIGHT_TO_LEFT () {0xa6;}' unless defined(&LC_ASCII_RIGHT_TO_LEFT);
    eval 'sub LC_LAO () {0xa7;}' unless defined(&LC_LAO);
    eval 'sub LC_ARABIC_2_COLUMN () {0xa8;}' unless defined(&LC_ARABIC_2_COLUMN);
    eval 'sub LC_INDIAN_1_COLUMN () {0xf0;}' unless defined(&LC_INDIAN_1_COLUMN);
    eval 'sub LC_TIBETAN_1_COLUMN () {0xf1;}' unless defined(&LC_TIBETAN_1_COLUMN);
    eval 'sub LC_ETHIOPIC () {0xf5;}' unless defined(&LC_ETHIOPIC);
    eval 'sub LC_CNS11643_3 () {0xf6;}' unless defined(&LC_CNS11643_3);
    eval 'sub LC_CNS11643_4 () {0xf7;}' unless defined(&LC_CNS11643_4);
    eval 'sub LC_CNS11643_5 () {0xf8;}' unless defined(&LC_CNS11643_5);
    eval 'sub LC_CNS11643_6 () {0xf9;}' unless defined(&LC_CNS11643_6);
    eval 'sub LC_CNS11643_7 () {0xfa;}' unless defined(&LC_CNS11643_7);
    eval 'sub LC_INDIAN_2_COLUMN () {0xfb;}' unless defined(&LC_INDIAN_2_COLUMN);
    eval 'sub LC_TIBETAN () {0xfc;}' unless defined(&LC_TIBETAN);
    eval("sub PG_SQL_ASCII () { 0; }") unless defined(&PG_SQL_ASCII);
    eval("sub PG_EUC_JP () { 1; }") unless defined(&PG_EUC_JP);
    eval("sub PG_EUC_CN () { 2; }") unless defined(&PG_EUC_CN);
    eval("sub PG_EUC_KR () { 3; }") unless defined(&PG_EUC_KR);
    eval("sub PG_EUC_TW () { 4; }") unless defined(&PG_EUC_TW);
    eval("sub PG_JOHAB () { 5; }") unless defined(&PG_JOHAB);
    eval("sub PG_UTF8 () { 6; }") unless defined(&PG_UTF8);
    eval("sub PG_MULE_INTERNAL () { 7; }") unless defined(&PG_MULE_INTERNAL);
    eval("sub PG_LATIN1 () { 8; }") unless defined(&PG_LATIN1);
    eval("sub PG_LATIN2 () { 9; }") unless defined(&PG_LATIN2);
    eval("sub PG_LATIN3 () { 10; }") unless defined(&PG_LATIN3);
    eval("sub PG_LATIN4 () { 11; }") unless defined(&PG_LATIN4);
    eval("sub PG_LATIN5 () { 12; }") unless defined(&PG_LATIN5);
    eval("sub PG_LATIN6 () { 13; }") unless defined(&PG_LATIN6);
    eval("sub PG_LATIN7 () { 14; }") unless defined(&PG_LATIN7);
    eval("sub PG_LATIN8 () { 15; }") unless defined(&PG_LATIN8);
    eval("sub PG_LATIN9 () { 16; }") unless defined(&PG_LATIN9);
    eval("sub PG_LATIN10 () { 17; }") unless defined(&PG_LATIN10);
    eval("sub PG_WIN1256 () { 18; }") unless defined(&PG_WIN1256);
    eval("sub PG_TCVN () { 19; }") unless defined(&PG_TCVN);
    eval("sub PG_WIN874 () { 20; }") unless defined(&PG_WIN874);
    eval("sub PG_KOI8R () { 21; }") unless defined(&PG_KOI8R);
    eval("sub PG_WIN1251 () { 22; }") unless defined(&PG_WIN1251);
    eval("sub PG_ALT () { 23; }") unless defined(&PG_ALT);
    eval("sub PG_ISO_8859_5 () { 24; }") unless defined(&PG_ISO_8859_5);
    eval("sub PG_ISO_8859_6 () { 25; }") unless defined(&PG_ISO_8859_6);
    eval("sub PG_ISO_8859_7 () { 26; }") unless defined(&PG_ISO_8859_7);
    eval("sub PG_ISO_8859_8 () { 27; }") unless defined(&PG_ISO_8859_8);
    eval("sub PG_SJIS () { 28; }") unless defined(&PG_SJIS);
    eval("sub PG_BIG5 () { 29; }") unless defined(&PG_BIG5);
    eval("sub PG_GBK () { 30; }") unless defined(&PG_GBK);
    eval("sub PG_UHC () { 31; }") unless defined(&PG_UHC);
    eval("sub PG_WIN1250 () { 32; }") unless defined(&PG_WIN1250);
    eval("sub PG_GB18030 () { 33; }") unless defined(&PG_GB18030);
    eval("sub _PG_LAST_ENCODING_ () { 34; }") unless defined(&_PG_LAST_ENCODING_);
    eval 'sub PG_ENCODING_BE_LAST () { &PG_ISO_8859_8;}' unless defined(&PG_ENCODING_BE_LAST);
    eval 'sub PG_ENCODING_FE_LAST () { &PG_WIN1256;}' unless defined(&PG_ENCODING_FE_LAST);
    eval 'sub PG_VALID_BE_ENCODING {
        my($_enc) = @_;
	    eval q((($_enc) >= 0 && ($_enc) <=  &PG_ENCODING_BE_LAST));
    }' unless defined(&PG_VALID_BE_ENCODING);
    eval 'sub PG_ENCODING_IS_CLIEN_ONLY {
        my($_enc) = @_;
	    eval q(((($_enc) >  &PG_ENCODING_BE_LAST  && ($_enc) <=  &PG_ENCODING_FE_LAST));
    }' unless defined(&PG_ENCODING_IS_CLIEN_ONLY);
    eval 'sub PG_VALID_ENCODING {
        my($_enc) = @_;
	    eval q((($_enc) >= 0 && ($_enc) <  &_PG_LAST_ENCODING_));
    }' unless defined(&PG_VALID_ENCODING);
    eval 'sub PG_VALID_FE_ENCODING {
        my($_enc) = @_;
	    eval q( &PG_VALID_ENCODING($_enc));
    }' unless defined(&PG_VALID_FE_ENCODING);
}
1;
