require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&MISCADMIN_H)) {
    eval 'sub MISCADMIN_H () {1;}' unless defined(&MISCADMIN_H);
    eval 'sub CHECK_FOR_INTERRUPTS () {
        eval q( &do {  &if ( &InterruptPending)  &ProcessInterrupts(); }  &while(0));
    }' unless defined(&CHECK_FOR_INTERRUPTS);
    eval 'sub HOLD_INTERRUPTS () {
        eval q(( &InterruptHoldoffCount++));
    }' unless defined(&HOLD_INTERRUPTS);
    eval 'sub RESUME_INTERRUPTS () {
        eval q( &do {  &Assert( &InterruptHoldoffCount > 0);  &InterruptHoldoffCount--; }  &while(0));
    }' unless defined(&RESUME_INTERRUPTS);
    eval 'sub START_CRIT_SECTION () {
        eval q(( &CritSectionCount++));
    }' unless defined(&START_CRIT_SECTION);
    eval 'sub END_CRIT_SECTION () {
        eval q( &do {  &Assert( &CritSectionCount > 0);  &CritSectionCount--; }  &while(0));
    }' unless defined(&END_CRIT_SECTION);
    eval 'sub MAXTZLEN () {10;}' unless defined(&MAXTZLEN);
    eval 'sub USE_POSTGRES_DATES () {0;}' unless defined(&USE_POSTGRES_DATES);
    eval 'sub USE_ISO_DATES () {1;}' unless defined(&USE_ISO_DATES);
    eval 'sub USE_SQL_DATES () {2;}' unless defined(&USE_SQL_DATES);
    eval 'sub USE_GERMAN_DATES () {3;}' unless defined(&USE_GERMAN_DATES);
    if(defined(&CYR_RECODE)) {
    }
    eval("sub BootstrapProcessing () { 0; }") unless defined(&BootstrapProcessing);
    eval("sub InitProcessing () { 1; }") unless defined(&InitProcessing);
    eval("sub NormalProcessing () { 2; }") unless defined(&NormalProcessing);
    eval 'sub IsBootstrapProcessingMode () {
        eval q((( &bool)( &Mode ==  &BootstrapProcessing)));
    }' unless defined(&IsBootstrapProcessingMode);
    eval 'sub IsInitProcessingMode () {
        eval q((( &bool)( &Mode ==  &InitProcessing)));
    }' unless defined(&IsInitProcessingMode);
    eval 'sub IsNormalProcessingMode () {
        eval q((( &bool)( &Mode ==  &NormalProcessing)));
    }' unless defined(&IsNormalProcessingMode);
    eval 'sub SetProcessingMode {
        my($mode) = @_;
	    eval q( &do {  &AssertArg(($mode) ==  &BootstrapProcessing || ($mode) ==  &InitProcessing || ($mode) ==  &NormalProcessing);  &Mode = ($mode); }  &while(0));
    }' unless defined(&SetProcessingMode);
    eval 'sub GetProcessingMode () {
        eval q( &Mode);
    }' unless defined(&GetProcessingMode);
}
1;
