require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PARSENODES_H)) {
    eval 'sub PARSENODES_H () {1;}' unless defined(&PARSENODES_H);
    require 'nodes/primnodes.ph';
    eval("sub QSRC_ORIGINAL () { 0; }") unless defined(&QSRC_ORIGINAL);
    eval("sub QSRC_PARSER () { 1; }") unless defined(&QSRC_PARSER);
    eval("sub QSRC_INSTEAD_RULE () { 2; }") unless defined(&QSRC_INSTEAD_RULE);
    eval("sub QSRC_QUAL_INSTEAD_RULE () { 3; }") unless defined(&QSRC_QUAL_INSTEAD_RULE);
    eval("sub QSRC_NON_INSTEAD_RULE () { 4; }") unless defined(&QSRC_NON_INSTEAD_RULE);
    eval("sub IS_NULL () { 0; }") unless defined(&IS_NULL);
    eval("sub IS_NOT_NULL () { 1; }") unless defined(&IS_NOT_NULL);
    eval("sub IS_TRUE () { 0; }") unless defined(&IS_TRUE);
    eval("sub IS_NOT_TRUE () { 1; }") unless defined(&IS_NOT_TRUE);
    eval("sub IS_FALSE () { 2; }") unless defined(&IS_FALSE);
    eval("sub IS_NOT_FALSE () { 3; }") unless defined(&IS_NOT_FALSE);
    eval("sub IS_UNKNOWN () { 4; }") unless defined(&IS_UNKNOWN);
    eval("sub IS_NOT_UNKNOWN () { 5; }") unless defined(&IS_NOT_UNKNOWN);
    eval("sub CONSTR_TEST_NOTNULL () { 0; }") unless defined(&CONSTR_TEST_NOTNULL);
    eval("sub CONSTR_TEST_CHECK () { 1; }") unless defined(&CONSTR_TEST_CHECK);
    eval("sub RTE_RELATION () { 0; }") unless defined(&RTE_RELATION);
    eval("sub RTE_SUBQUERY () { 1; }") unless defined(&RTE_SUBQUERY);
    eval("sub RTE_JOIN () { 2; }") unless defined(&RTE_JOIN);
    eval("sub RTE_SPECIAL () { 3; }") unless defined(&RTE_SPECIAL);
    eval("sub RTE_FUNCTION () { 4; }") unless defined(&RTE_FUNCTION);
    eval("sub SETOP_NONE () { 0; }") unless defined(&SETOP_NONE);
    eval("sub SETOP_UNION () { 1; }") unless defined(&SETOP_UNION);
    eval("sub SETOP_INTERSECT () { 2; }") unless defined(&SETOP_INTERSECT);
    eval("sub SETOP_EXCEPT () { 3; }") unless defined(&SETOP_EXCEPT);
    eval("sub DROP_RESTRICT () { 0; }") unless defined(&DROP_RESTRICT);
    eval("sub DROP_CASCADE () { 1; }") unless defined(&DROP_CASCADE);
    eval("sub ACL_OBJECT_RELATION () { 0; }") unless defined(&ACL_OBJECT_RELATION);
    eval("sub ACL_OBJECT_DATABASE () { 1; }") unless defined(&ACL_OBJECT_DATABASE);
    eval("sub ACL_OBJECT_FUNCTION () { 2; }") unless defined(&ACL_OBJECT_FUNCTION);
    eval("sub ACL_OBJECT_LANGUAGE () { 3; }") unless defined(&ACL_OBJECT_LANGUAGE);
    eval("sub ACL_OBJECT_NAMESPACE () { 4; }") unless defined(&ACL_OBJECT_NAMESPACE);
    eval 'sub ACL_INSERT () {(1<<0);}' unless defined(&ACL_INSERT);
    eval 'sub ACL_SELECT () {(1<<1);}' unless defined(&ACL_SELECT);
    eval 'sub ACL_UPDATE () {(1<<2);}' unless defined(&ACL_UPDATE);
    eval 'sub ACL_DELETE () {(1<<3);}' unless defined(&ACL_DELETE);
    eval 'sub ACL_RULE () {(1<<4);}' unless defined(&ACL_RULE);
    eval 'sub ACL_REFERENCES () {(1<<5);}' unless defined(&ACL_REFERENCES);
    eval 'sub ACL_TRIGGER () {(1<<6);}' unless defined(&ACL_TRIGGER);
    eval 'sub ACL_EXECUTE () {(1<<7);}' unless defined(&ACL_EXECUTE);
    eval 'sub ACL_USAGE () {(1<<8);}' unless defined(&ACL_USAGE);
    eval 'sub ACL_CREATE () {(1<<9);}' unless defined(&ACL_CREATE);
    eval 'sub ACL_CREATE_TEMP () {(1<<10);}' unless defined(&ACL_CREATE_TEMP);
    eval 'sub N_ACL_RIGHTS () {11;}' unless defined(&N_ACL_RIGHTS);
    eval 'sub ACL_ALL_RIGHTS () {(-1);}' unless defined(&ACL_ALL_RIGHTS);
    eval 'sub ACL_NO_RIGHTS () {0;}' unless defined(&ACL_NO_RIGHTS);
    eval("sub CONSTR_NULL () { 0; }") unless defined(&CONSTR_NULL);
    eval("sub CONSTR_NOTNULL () { 1; }") unless defined(&CONSTR_NOTNULL);
    eval("sub CONSTR_DEFAULT () { 2; }") unless defined(&CONSTR_DEFAULT);
    eval("sub CONSTR_CHECK () { 3; }") unless defined(&CONSTR_CHECK);
    eval("sub CONSTR_PRIMARY () { 4; }") unless defined(&CONSTR_PRIMARY);
    eval("sub CONSTR_UNIQUE () { 5; }") unless defined(&CONSTR_UNIQUE);
    eval("sub CONSTR_ATTR_DEFERRABLE () { 6; }") unless defined(&CONSTR_ATTR_DEFERRABLE);
    eval("sub CONSTR_ATTR_NOT_DEFERRABLE () { 7; }") unless defined(&CONSTR_ATTR_NOT_DEFERRABLE);
    eval("sub CONSTR_ATTR_DEFERRED () { 8; }") unless defined(&CONSTR_ATTR_DEFERRED);
    eval("sub CONSTR_ATTR_IMMEDIATE () { 9; }") unless defined(&CONSTR_ATTR_IMMEDIATE);
    eval 'sub FKCONSTR_ACTION_NOACTION () {ord(\'a\');}' unless defined(&FKCONSTR_ACTION_NOACTION);
    eval 'sub FKCONSTR_ACTION_RESTRICT () {ord(\'r\');}' unless defined(&FKCONSTR_ACTION_RESTRICT);
    eval 'sub FKCONSTR_ACTION_CASCADE () {ord(\'c\');}' unless defined(&FKCONSTR_ACTION_CASCADE);
    eval 'sub FKCONSTR_ACTION_SETNULL () {ord(\'n\');}' unless defined(&FKCONSTR_ACTION_SETNULL);
    eval 'sub FKCONSTR_ACTION_SETDEFAULT () {ord(\'d\');}' unless defined(&FKCONSTR_ACTION_SETDEFAULT);
    eval 'sub FKCONSTR_MATCH_FULL () {ord(\'f\');}' unless defined(&FKCONSTR_MATCH_FULL);
    eval 'sub FKCONSTR_MATCH_PARTIAL () {ord(\'p\');}' unless defined(&FKCONSTR_MATCH_PARTIAL);
    eval 'sub FKCONSTR_MATCH_UNSPECIFIED () {ord(\'u\');}' unless defined(&FKCONSTR_MATCH_UNSPECIFIED);
    eval 'sub OPCLASS_ITEM_OPERATOR () {1;}' unless defined(&OPCLASS_ITEM_OPERATOR);
    eval 'sub OPCLASS_ITEM_FUNCTION () {2;}' unless defined(&OPCLASS_ITEM_FUNCTION);
    eval 'sub OPCLASS_ITEM_STORAGETYPE () {3;}' unless defined(&OPCLASS_ITEM_STORAGETYPE);
    eval 'sub DROP_TABLE () {1;}' unless defined(&DROP_TABLE);
    eval 'sub DROP_SEQUENCE () {2;}' unless defined(&DROP_SEQUENCE);
    eval 'sub DROP_VIEW () {3;}' unless defined(&DROP_VIEW);
    eval 'sub DROP_INDEX () {4;}' unless defined(&DROP_INDEX);
    eval 'sub DROP_TYPE () {5;}' unless defined(&DROP_TYPE);
    eval 'sub DROP_DOMAIN () {6;}' unless defined(&DROP_DOMAIN);
    eval 'sub DROP_CONVERSION () {7;}' unless defined(&DROP_CONVERSION);
    eval 'sub DROP_SCHEMA () {8;}' unless defined(&DROP_SCHEMA);
    eval 'sub DROP_RULE () {100;}' unless defined(&DROP_RULE);
    eval 'sub DROP_TRIGGER () {101;}' unless defined(&DROP_TRIGGER);
    eval 'sub COMMENT_ON_AGGREGATE () {100;}' unless defined(&COMMENT_ON_AGGREGATE);
    eval 'sub COMMENT_ON_COLUMN () {101;}' unless defined(&COMMENT_ON_COLUMN);
    eval 'sub COMMENT_ON_CONSTRAINT () {102;}' unless defined(&COMMENT_ON_CONSTRAINT);
    eval 'sub COMMENT_ON_DATABASE () {103;}' unless defined(&COMMENT_ON_DATABASE);
    eval 'sub COMMENT_ON_FUNCTION () {104;}' unless defined(&COMMENT_ON_FUNCTION);
    eval 'sub COMMENT_ON_INDEX () {105;}' unless defined(&COMMENT_ON_INDEX);
    eval 'sub COMMENT_ON_OPERATOR () {106;}' unless defined(&COMMENT_ON_OPERATOR);
    eval 'sub COMMENT_ON_RULE () {107;}' unless defined(&COMMENT_ON_RULE);
    eval 'sub COMMENT_ON_SCHEMA () {108;}' unless defined(&COMMENT_ON_SCHEMA);
    eval 'sub COMMENT_ON_SEQUENCE () {109;}' unless defined(&COMMENT_ON_SEQUENCE);
    eval 'sub COMMENT_ON_TABLE () {110;}' unless defined(&COMMENT_ON_TABLE);
    eval 'sub COMMENT_ON_TRIGGER () {111;}' unless defined(&COMMENT_ON_TRIGGER);
    eval 'sub COMMENT_ON_TYPE () {112;}' unless defined(&COMMENT_ON_TYPE);
    eval 'sub COMMENT_ON_VIEW () {113;}' unless defined(&COMMENT_ON_VIEW);
    eval 'sub RENAME_TABLE () {110;}' unless defined(&RENAME_TABLE);
    eval 'sub RENAME_COLUMN () {111;}' unless defined(&RENAME_COLUMN);
    eval 'sub RENAME_TRIGGER () {112;}' unless defined(&RENAME_TRIGGER);
    eval 'sub RENAME_RULE () {113;}' unless defined(&RENAME_RULE);
}
1;
