require '_h2ph_pre.ph';

no warnings 'redefine';

require 'sys/types.ph';
require 'arpa/nameser.ph';
require 'process.ph';
require 'ioctl.ph';
require 'unix.ph';
require 'sys/select.ph';
unless(defined(&HAS_TEST_AND_SET)) {
    sub HAS_TEST_AND_SET () {	1;}
}
undef(&HAVE_GETRUSAGE) if defined(&HAVE_GETRUSAGE);
unless(defined(&strncasecmp)) {
    sub strncasecmp () {	 &strnicmp;}
}
unless(defined(&NAN)) {
    unless(defined(&__nan_bytes)) {
	eval 'sub __nan_bytes () {{ 0, 0, 0, 0, 0, 0, 0xf8, 0x7f };}' unless defined(&__nan_bytes);
    }
    eval 'sub NAN () {(*( &const \'double\' *)  &__nan);}' unless defined(&NAN);
}
1;
