require '_h2ph_pre.ph';

no warnings 'redefine';

require 'limits.ph';
unless(defined(&MAGIC1)) {
    sub MAGIC1 () {	(((ord('r'^0200)<<8) | 'e'));}
}
unless(defined(&OPRMASK)) {
    sub OPRMASK () {	(( &sop) 0xf8000000);}
}
unless(defined(&OPDMASK)) {
    sub OPDMASK () {	(( &sop) 0x7ffffff);}
}
unless(defined(&OPSHIFT)) {
    sub OPSHIFT () {	(27);}
}
unless(defined(&OP)) {
    sub OP {
	my($n) = @_;
	eval q((($n) &OPRMASK));
    }
}
unless(defined(&OPND)) {
    sub OPND {
	my($n) = @_;
	eval q((($n) &OPDMASK));
    }
}
unless(defined(&SOP)) {
    sub SOP {
	my($op, $opnd) = @_;
	eval q((($op)|($opnd)));
    }
}
unless(defined(&OEND)) {
    sub OEND () {	(1<< &OPSHIFT);}
}
unless(defined(&OCHAR)) {
    sub OCHAR () {	(2<< &OPSHIFT);}
}
unless(defined(&OBOL)) {
    sub OBOL () {	(3<< &OPSHIFT);}
}
unless(defined(&OEOL)) {
    sub OEOL () {	(4<< &OPSHIFT);}
}
unless(defined(&OANY)) {
    sub OANY () {	(5<< &OPSHIFT);}
}
unless(defined(&OANYOF)) {
    sub OANYOF () {	(6<< &OPSHIFT);}
}
unless(defined(&OBACK_)) {
    sub OBACK_ () {	(7<< &OPSHIFT);}
}
unless(defined(&O_BACK)) {
    sub O_BACK () {	(8<< &OPSHIFT);}
}
unless(defined(&OPLUS_)) {
    sub OPLUS_ () {	(9<< &OPSHIFT);}
}
unless(defined(&O_PLUS)) {
    sub O_PLUS () {	(10<< &OPSHIFT);}
}
unless(defined(&OQUEST_)) {
    sub OQUEST_ () {	(11<< &OPSHIFT);}
}
unless(defined(&O_QUEST)) {
    sub O_QUEST () {	(12<< &OPSHIFT);}
}
unless(defined(&OLPAREN)) {
    sub OLPAREN () {	(13<< &OPSHIFT);}
}
unless(defined(&ORPAREN)) {
    sub ORPAREN () {	(14<< &OPSHIFT);}
}
unless(defined(&OCH_)) {
    sub OCH_ () {	(15<< &OPSHIFT);}
}
unless(defined(&OOR1)) {
    sub OOR1 () {	(16<< &OPSHIFT);}
}
unless(defined(&OOR2)) {
    sub OOR2 () {	(17<< &OPSHIFT);}
}
unless(defined(&O_CH)) {
    sub O_CH () {	(18<< &OPSHIFT);}
}
unless(defined(&OBOW)) {
    sub OBOW () {	(19<< &OPSHIFT);}
}
unless(defined(&OEOW)) {
    sub OEOW () {	(20<< &OPSHIFT);}
}
unless(defined(&CHlc)) {
    sub CHlc {
	my($c) = @_;
	eval q(((($c)&0xff0000)>>16));
    }
}
unless(defined(&CHadd)) {
    sub CHadd {
	my($cs, $c) = @_;
	eval q((-> $ptr[&0xffff] |= -> &mask, -> &hash += ($c)&0xffff, ($cs)-> &lc =  &CHlc($c)));
    }
}
unless(defined(&CHsub)) {
    sub CHsub {
	my($cs, $c) = @_;
	eval q((-> $ptr[&0xffff] &= ~-> &mask, -> &hash -= ($c)&0xffff));
    }
}
unless(defined(&CHIN)) {
    sub CHIN {
	my($cs, $c) = @_;
	eval q((-> $ptr[($c)&0xffff] & ($cs)-> &mask  && (($cs)-> &lc ==  &CHlc($c))));
    }
}
unless(defined(&MCadd)) {
    sub MCadd {
	my($p, $cs, $cp) = @_;
	eval q( &mcadd($p, $cs, $cp));
    }
}
unless(defined(&MCsub)) {
    sub MCsub {
	my($p, $cs, $cp) = @_;
	eval q( &mcsub($p, $cs, $cp));
    }
}
unless(defined(&MCin)) {
    sub MCin {
	my($p, $cs, $cp) = @_;
	eval q( &mcin($p, $cs, $cp));
    }
}
unless(defined(&MAGIC2)) {
    sub MAGIC2 () {	(((ord('R'^0200)<<8)|'E'));}
}
unless(defined(&USEBOL)) {
    sub USEBOL () {	01;}
}
unless(defined(&USEEOL)) {
    sub USEEOL () {	02;}
}
unless(defined(&BAD)) {
    sub BAD () {	04;}
}
unless(defined(&OUT)) {
    sub OUT () {	(16777216+1);}
}
unless(defined(&ISWORD)) {
    sub ISWORD {
	my($c) = @_;
	eval q((( >= 0 && <=  &UCHAR_MAX)  && ( &isalnum( ($c)) || ($c) == ord('_'))));
    }
}
1;
