require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&BLOCK_H)) {
    eval 'sub BLOCK_H () {1;}' unless defined(&BLOCK_H);
    eval 'sub InvalidBlockNumber () {(( &BlockNumber) 0xffffffff);}' unless defined(&InvalidBlockNumber);
    eval 'sub MaxBlockNumber () {(( &BlockNumber) 0xfffffffe);}' unless defined(&MaxBlockNumber);
    eval 'sub BlockNumberIsValid {
        my($blockNumber) = @_;
	    eval q((( &bool) (( &BlockNumber) ($blockNumber) !=  &InvalidBlockNumber)));
    }' unless defined(&BlockNumberIsValid);
    eval 'sub BlockIdIsValid {
        my($blockId) = @_;
	    eval q((( &bool)  &PointerIsValid($blockId)));
    }' unless defined(&BlockIdIsValid);
    eval 'sub BlockIdSet {
        my($blockId, $blockNumber) = @_;
	    eval q((  &AssertMacro( &PointerIsValid($blockId)), ($blockId)-> &bi_hi = ($blockNumber) >> 16, ($blockId)-> &bi_lo = ($blockNumber) & 0xffff ));
    }' unless defined(&BlockIdSet);
    eval 'sub BlockIdCopy {
        my($toBlockId, $fromBlockId) = @_;
	    eval q((  &AssertMacro( &PointerIsValid($toBlockId)),  &AssertMacro( &PointerIsValid($fromBlockId)), ($toBlockId)-> &bi_hi = ($fromBlockId)-> &bi_hi, ($toBlockId)-> &bi_lo = ($fromBlockId)-> &bi_lo ));
    }' unless defined(&BlockIdCopy);
    eval 'sub BlockIdEquals {
        my($blockId1, $blockId2) = @_;
	    eval q((($blockId1)-> &bi_hi == ($blockId2)-> &bi_hi  && ($blockId1)-> &bi_lo == ($blockId2)-> &bi_lo));
    }' unless defined(&BlockIdEquals);
    eval 'sub BlockIdGetBlockNumber {
        my($blockId) = @_;
	    eval q((  &AssertMacro( &BlockIdIsValid($blockId)), ( &BlockNumber) ((($blockId)-> &bi_hi << 16) | (( &uint16) ($blockId)-> &bi_lo)) ));
    }' unless defined(&BlockIdGetBlockNumber);
}
1;
