require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&SPIN_H)) {
    eval 'sub SPIN_H () {1;}' unless defined(&SPIN_H);
    require 'storage/s_lock.ph';
    require 'miscadmin.ph';
    eval 'sub SpinLockInit {
        my($lock) = @_;
	    eval q( &S_INIT_LOCK($lock));
    }' unless defined(&SpinLockInit);
    eval 'sub SpinLockAcquire {
        my($lock) = @_;
	    eval q( &do {  &HOLD_INTERRUPTS();  &S_LOCK($lock); }  &while (0));
    }' unless defined(&SpinLockAcquire);
    eval 'sub SpinLockAcquire_NoHoldoff {
        my($lock) = @_;
	    eval q( &S_LOCK($lock));
    }' unless defined(&SpinLockAcquire_NoHoldoff);
    eval 'sub SpinLockRelease {
        my($lock) = @_;
	    eval q( &do {  &S_UNLOCK($lock);  &RESUME_INTERRUPTS(); }  &while (0));
    }' unless defined(&SpinLockRelease);
    eval 'sub SpinLockRelease_NoHoldoff {
        my($lock) = @_;
	    eval q( &S_UNLOCK($lock));
    }' unless defined(&SpinLockRelease_NoHoldoff);
    eval 'sub SpinLockFree {
        my($lock) = @_;
	    eval q( &S_LOCK_FREE($lock));
    }' unless defined(&SpinLockFree);
}
1;
