require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ARRAY_H)) {
    eval 'sub ARRAY_H () {1;}' unless defined(&ARRAY_H);
    require 'fmgr.ph';
    eval 'sub DatumGetArrayTypeP {
        my($X) = @_;
	    eval q((( &ArrayType *)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetArrayTypeP);
    eval 'sub DatumGetArrayTypePCopy {
        my($X) = @_;
	    eval q((( &ArrayType *)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetArrayTypePCopy);
    eval 'sub PG_GETARG_ARRAYTYPE_P {
        my($n) = @_;
	    eval q( &DatumGetArrayTypeP( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_ARRAYTYPE_P);
    eval 'sub PG_GETARG_ARRAYTYPE_P_COPY {
        my($n) = @_;
	    eval q( &DatumGetArrayTypePCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_ARRAYTYPE_P_COPY);
    eval 'sub PG_RETURN_ARRAYTYPE_P {
        my($x) = @_;
	    eval q( &PG_RETURN_POINTER($x));
    }' unless defined(&PG_RETURN_ARRAYTYPE_P);
    eval 'sub ARR_SIZE {
        my($a) = @_;
	    eval q(((( &ArrayType *) ($a))-> &size));
    }' unless defined(&ARR_SIZE);
    eval 'sub ARR_NDIM {
        my($a) = @_;
	    eval q(((( &ArrayType *) ($a))-> &ndim));
    }' unless defined(&ARR_NDIM);
    eval 'sub ARR_ELEMTYPE {
        my($a) = @_;
	    eval q(((( &ArrayType *) ($a))-> &elemtype));
    }' unless defined(&ARR_ELEMTYPE);
    eval 'sub ARR_DIMS {
        my($a) = @_;
	    eval q(( (( ($a)) + $sizeof{ &ArrayType})));
    }' unless defined(&ARR_DIMS);
    eval 'sub ARR_LBOUND {
        my($a) = @_;
	    eval q(( (( ($a)) + $sizeof{ &ArrayType} + ($sizeof{\'int\'} *  &ARR_NDIM($a)))));
    }' unless defined(&ARR_LBOUND);
    eval 'sub ARR_OVERHEAD {
        my($n) = @_;
	    eval q(( &MAXALIGN($sizeof{ &ArrayType} + 2* $sizeof{\'int\'} * ($n))));
    }' unless defined(&ARR_OVERHEAD);
    eval 'sub ARR_DATA_PTR {
        my($a) = @_;
	    eval q((( ($a)) +  &ARR_OVERHEAD( &ARR_NDIM($a))));
    }' unless defined(&ARR_DATA_PTR);
}
1;
