require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&NABSTIME_H)) {
    eval 'sub NABSTIME_H () {1;}' unless defined(&NABSTIME_H);
    require 'limits.ph';
    require 'time.ph';
    require 'fmgr.ph';
    require 'utils/timestamp.ph';
    require 'utils/datetime.ph';
    eval 'sub DatumGetAbsoluteTime {
        my($X) = @_;
	    eval q((( &AbsoluteTime)  &DatumGetInt32($X)));
    }' unless defined(&DatumGetAbsoluteTime);
    eval 'sub DatumGetRelativeTime {
        my($X) = @_;
	    eval q((( &RelativeTime)  &DatumGetInt32($X)));
    }' unless defined(&DatumGetRelativeTime);
    eval 'sub DatumGetTimeInterval {
        my($X) = @_;
	    eval q((( &TimeInterval)  &DatumGetPointer($X)));
    }' unless defined(&DatumGetTimeInterval);
    eval 'sub AbsoluteTimeGetDatum {
        my($X) = @_;
	    eval q( &Int32GetDatum($X));
    }' unless defined(&AbsoluteTimeGetDatum);
    eval 'sub RelativeTimeGetDatum {
        my($X) = @_;
	    eval q( &Int32GetDatum($X));
    }' unless defined(&RelativeTimeGetDatum);
    eval 'sub TimeIntervalGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&TimeIntervalGetDatum);
    eval 'sub PG_GETARG_ABSOLUTETIME {
        my($n) = @_;
	    eval q( &DatumGetAbsoluteTime( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_ABSOLUTETIME);
    eval 'sub PG_GETARG_RELATIVETIME {
        my($n) = @_;
	    eval q( &DatumGetRelativeTime( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_RELATIVETIME);
    eval 'sub PG_GETARG_TIMEINTERVAL {
        my($n) = @_;
	    eval q( &DatumGetTimeInterval( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_TIMEINTERVAL);
    eval 'sub PG_RETURN_ABSOLUTETIME {
        my($x) = @_;
	    eval q( &return  &AbsoluteTimeGetDatum($x));
    }' unless defined(&PG_RETURN_ABSOLUTETIME);
    eval 'sub PG_RETURN_RELATIVETIME {
        my($x) = @_;
	    eval q( &return  &RelativeTimeGetDatum($x));
    }' unless defined(&PG_RETURN_RELATIVETIME);
    eval 'sub PG_RETURN_TIMEINTERVAL {
        my($x) = @_;
	    eval q( &return  &TimeIntervalGetDatum($x));
    }' unless defined(&PG_RETURN_TIMEINTERVAL);
    eval 'sub INVALID_ABSTIME () {(( &AbsoluteTime) 0x7ffffffe);}' unless defined(&INVALID_ABSTIME);
    eval 'sub NOEND_ABSTIME () {(( &AbsoluteTime) 0x7ffffffc);}' unless defined(&NOEND_ABSTIME);
    eval 'sub NOSTART_ABSTIME () {(( &AbsoluteTime)  &INT_MIN);}' unless defined(&NOSTART_ABSTIME);
    eval 'sub INVALID_RELTIME () {(( &RelativeTime) 0x7ffffffe);}' unless defined(&INVALID_RELTIME);
    eval 'sub AbsoluteTimeIsValid {
        my($time) = @_;
	    eval q((( &bool) (($time) !=  &INVALID_ABSTIME)));
    }' unless defined(&AbsoluteTimeIsValid);
    eval 'sub AbsoluteTimeIsReal {
        my($time) = @_;
	    eval q((( &bool) ((( &AbsoluteTime) ($time)) <  &NOEND_ABSTIME  && (( &AbsoluteTime) ($time)) !=  &NOSTART_ABSTIME)));
    }' unless defined(&AbsoluteTimeIsReal);
    eval 'sub RelativeTimeIsValid {
        my($time) = @_;
	    eval q((( &bool) ((( &RelativeTime) ($time)) !=  &INVALID_RELTIME)));
    }' unless defined(&RelativeTimeIsValid);
}
1;
