require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PG_NUMERIC_H_)) {
    eval 'sub _PG_NUMERIC_H_ () {1;}' unless defined(&_PG_NUMERIC_H_);
    eval 'sub NUMERIC_MAX_PRECISION () {1000;}' unless defined(&NUMERIC_MAX_PRECISION);
    eval 'sub NUMERIC_MAX_DISPLAY_SCALE () { &NUMERIC_MAX_PRECISION;}' unless defined(&NUMERIC_MAX_DISPLAY_SCALE);
    eval 'sub NUMERIC_MIN_DISPLAY_SCALE () {0;}' unless defined(&NUMERIC_MIN_DISPLAY_SCALE);
    eval 'sub NUMERIC_MAX_RESULT_SCALE () {( &NUMERIC_MAX_PRECISION * 2);}' unless defined(&NUMERIC_MAX_RESULT_SCALE);
    eval 'sub NUMERIC_MIN_SIG_DIGITS () {16;}' unless defined(&NUMERIC_MIN_SIG_DIGITS);
    eval 'sub NUMERIC_EXTRA_DIGITS () {4;}' unless defined(&NUMERIC_EXTRA_DIGITS);
    eval 'sub NUMERIC_SIGN_MASK () {0xc000;}' unless defined(&NUMERIC_SIGN_MASK);
    eval 'sub NUMERIC_POS () {0x;}' unless defined(&NUMERIC_POS);
    eval 'sub NUMERIC_NEG () {0x4000;}' unless defined(&NUMERIC_NEG);
    eval 'sub NUMERIC_NAN () {0xc000;}' unless defined(&NUMERIC_NAN);
    eval 'sub NUMERIC_DSCALE_MASK () {0x3fff;}' unless defined(&NUMERIC_DSCALE_MASK);
    eval 'sub NUMERIC_SIGN {
        my($n) = @_;
	    eval q((($n)-> &n_sign_dscale &  &NUMERIC_SIGN_MASK));
    }' unless defined(&NUMERIC_SIGN);
    eval 'sub NUMERIC_DSCALE {
        my($n) = @_;
	    eval q((($n)-> &n_sign_dscale &  &NUMERIC_DSCALE_MASK));
    }' unless defined(&NUMERIC_DSCALE);
    eval 'sub NUMERIC_IS_NAN {
        my($n) = @_;
	    eval q(( &NUMERIC_SIGN($n) !=  &NUMERIC_POS  &&  &NUMERIC_SIGN($n) !=  &NUMERIC_NEG));
    }' unless defined(&NUMERIC_IS_NAN);
    eval 'sub NUMERIC_HDRSZ () {($sizeof{ &int32} + $sizeof{ &uint16} * 3);}' unless defined(&NUMERIC_HDRSZ);
    eval 'sub DatumGetNumeric {
        my($X) = @_;
	    eval q((( &Numeric)  &PG_DETOAST_DATUM($X)));
    }' unless defined(&DatumGetNumeric);
    eval 'sub DatumGetNumericCopy {
        my($X) = @_;
	    eval q((( &Numeric)  &PG_DETOAST_DATUM_COPY($X)));
    }' unless defined(&DatumGetNumericCopy);
    eval 'sub NumericGetDatum {
        my($X) = @_;
	    eval q( &PointerGetDatum($X));
    }' unless defined(&NumericGetDatum);
    eval 'sub PG_GETARG_NUMERIC {
        my($n) = @_;
	    eval q( &DatumGetNumeric( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_NUMERIC);
    eval 'sub PG_GETARG_NUMERIC_COPY {
        my($n) = @_;
	    eval q( &DatumGetNumericCopy( &PG_GETARG_DATUM($n)));
    }' unless defined(&PG_GETARG_NUMERIC_COPY);
    eval 'sub PG_RETURN_NUMERIC {
        my($x) = @_;
	    eval q( &return  &NumericGetDatum($x));
    }' unless defined(&PG_RETURN_NUMERIC);
}
1;
