require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_PYTHON_H)) {
    eval 'sub Py_PYTHON_H () {1;}' unless defined(&Py_PYTHON_H);
    unless(defined(&_GNU_SOURCE)) {
	eval 'sub _GNU_SOURCE () {1;}' unless defined(&_GNU_SOURCE);
    }
    if(0) {
	unless(defined(&_XOPEN_SOURCE)) {
	    eval 'sub _XOPEN_SOURCE () {500;}' unless defined(&_XOPEN_SOURCE);
	}
    }
    require 'patchlevel.ph';
    require 'pyconfig.ph';
    if(defined(&HAVE_LIMITS_H)) {
	require 'limits.ph';
    }
    unless(defined(&DL_IMPORT)) {
	eval 'sub DL_IMPORT {
	    my($RTYPE) = @_;
    	    eval q($RTYPE);
	}' unless defined(&DL_IMPORT);
    }
    unless(defined(&DL_EXPORT)) {
	eval 'sub DL_EXPORT {
	    my($RTYPE) = @_;
    	    eval q($RTYPE);
	}' unless defined(&DL_EXPORT);
    }
    if(defined( &__sgi)  && defined( &WITH_THREAD)  && !defined( &_SGI_MP_SOURCE)) {
	eval 'sub _SGI_MP_SOURCE () {1;}' unless defined(&_SGI_MP_SOURCE);
    }
    require 'stdio.ph';
    unless(defined(&NULL)) {
	die("Python.h requires that stdio.h define NULL.");
    }
    require 'string.ph';
    require 'errno.ph';
    if(defined(&HAVE_STDLIB_H)) {
	require 'stdlib.ph';
    }
    if(defined(&HAVE_UNISTD_H)) {
	require 'unistd.ph';
    }
    require 'assert.ph';
    require 'pyport.ph';
    require 'pymem.ph';
    require 'object.ph';
    require 'objimpl.ph';
    require 'pydebug.ph';
    require 'unicodeobject.ph';
    require 'intobject.ph';
    require 'longobject.ph';
    require 'floatobject.ph';
    unless(defined(&WITHOUT_COMPLEX)) {
	require 'complexobject.ph';
    }
    require 'rangeobject.ph';
    require 'stringobject.ph';
    require 'bufferobject.ph';
    require 'tupleobject.ph';
    require 'listobject.ph';
    require 'dictobject.ph';
    require 'methodobject.ph';
    require 'moduleobject.ph';
    require 'funcobject.ph';
    require 'classobject.ph';
    require 'fileobject.ph';
    require 'cobject.ph';
    require 'traceback.ph';
    require 'sliceobject.ph';
    require 'cellobject.ph';
    require 'iterobject.ph';
    require 'descrobject.ph';
    require 'weakrefobject.ph';
    require 'codecs.ph';
    require 'pyerrors.ph';
    require 'pystate.ph';
    require 'modsupport.ph';
    require 'pythonrun.ph';
    require 'ceval.ph';
    require 'sysmodule.ph';
    require 'intrcheck.ph';
    require 'import.ph';
    require 'abstract.ph';
    eval 'sub PyArg_GetInt {
        my($v, $a) = @_;
	    eval q( &PyArg_Parse(($v), \\"i\\", ($a)));
    }' unless defined(&PyArg_GetInt);
    eval 'sub PyArg_NoArgs {
        my($v) = @_;
	    eval q( &PyArg_Parse($v, \\"\\"));
    }' unless defined(&PyArg_NoArgs);
    if(defined(&__CHAR_UNSIGNED__)) {
	eval 'sub Py_CHARMASK {
	    my($c) = @_;
    	    eval q(($c));
	}' unless defined(&Py_CHARMASK);
    } else {
	eval 'sub Py_CHARMASK {
	    my($c) = @_;
    	    eval q((($c) & 0xff));
	}' unless defined(&Py_CHARMASK);
    }
    require 'pyfpe.ph';
    eval 'sub Py_single_input () {256;}' unless defined(&Py_single_input);
    eval 'sub Py_file_input () {257;}' unless defined(&Py_file_input);
    eval 'sub Py_eval_input () {258;}' unless defined(&Py_eval_input);
    if(defined(&HAVE_PTH)) {
	require 'pth.ph';
    }
}
1;
