require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_ABSTRACTOBJECT_H)) {
    eval 'sub Py_ABSTRACTOBJECT_H () {1;}' unless defined(&Py_ABSTRACTOBJECT_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub PyObject_DelAttrString {
        my($O,$A) = @_;
	    eval q( &PyObject_SetAttrString(($O),($A), &NULL));
    }' unless defined(&PyObject_DelAttrString);
    eval 'sub PyObject_DelAttr {
        my($O,$A) = @_;
	    eval q( &PyObject_SetAttr(($O),($A), &NULL));
    }' unless defined(&PyObject_DelAttr);
    undef(&PyObject_Length) if defined(&PyObject_Length);
    eval 'sub PyObject_Length () { &PyObject_Size;}' unless defined(&PyObject_Length);
    eval 'sub PyIter_Check {
        my($obj) = @_;
	    eval q(( &PyType_HasFeature(($obj)-> &ob_type,  &Py_TPFLAGS_HAVE_ITER)  && ($obj)-> ($ob_type->{tp_iternext}) !=  &NULL));
    }' unless defined(&PyIter_Check);
    undef(&PySequence_Length) if defined(&PySequence_Length);
    eval 'sub PySequence_Length () { &PySequence_Size;}' unless defined(&PySequence_Length);
    eval 'sub PySequence_Fast_GET_SIZE {
        my($o) = @_;
	    eval q(( &PyList_Check($o) ?  &PyList_GET_SIZE($o) :  &PyTuple_GET_SIZE($o)));
    }' unless defined(&PySequence_Fast_GET_SIZE);
    eval 'sub PySequence_Fast_GET_ITEM {
        my($o, $i) = @_;
	    eval q(( &PyList_Check($o) ?  &PyList_GET_ITEM($o, $i) :  &PyTuple_GET_ITEM($o, $i)));
    }' unless defined(&PySequence_Fast_GET_ITEM);
    eval 'sub PY_ITERSEARCH_COUNT () {1;}' unless defined(&PY_ITERSEARCH_COUNT);
    eval 'sub PY_ITERSEARCH_INDEX () {2;}' unless defined(&PY_ITERSEARCH_INDEX);
    eval 'sub PY_ITERSEARCH_CONTAINS () {3;}' unless defined(&PY_ITERSEARCH_CONTAINS);
    undef(&PySequence_In) if defined(&PySequence_In);
    eval 'sub PySequence_In () { &PySequence_Contains;}' unless defined(&PySequence_In);
    undef(&PyMapping_Length) if defined(&PyMapping_Length);
    eval 'sub PyMapping_Length () { &PyMapping_Size;}' unless defined(&PyMapping_Length);
    eval 'sub PyMapping_DelItemString {
        my($O,$K) = @_;
	    eval q( &PyObject_DelItemString(($O),($K)));
    }' unless defined(&PyMapping_DelItemString);
    eval 'sub PyMapping_DelItem {
        my($O,$K) = @_;
	    eval q( &PyObject_DelItem(($O),($K)));
    }' unless defined(&PyMapping_DelItem);
    eval 'sub PyMapping_Keys {
        my($O) = @_;
	    eval q( &PyObject_CallMethod($O,\\"keys\\", &NULL));
    }' unless defined(&PyMapping_Keys);
    eval 'sub PyMapping_Values {
        my($O) = @_;
	    eval q( &PyObject_CallMethod($O,\\"values\\", &NULL));
    }' unless defined(&PyMapping_Values);
    eval 'sub PyMapping_Items {
        my($O) = @_;
	    eval q( &PyObject_CallMethod($O,\\"items\\", &NULL));
    }' unless defined(&PyMapping_Items);
    if(defined(&__cplusplus)) {
    }
}
1;
