require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_OBJECT_H)) {
    eval 'sub Py_OBJECT_H () {1;}' unless defined(&Py_OBJECT_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&Py_DEBUG)) {
	eval 'sub Py_TRACE_REFS () {1;}' unless defined(&Py_TRACE_REFS);
	eval 'sub Py_REF_DEBUG () {1;}' unless defined(&Py_REF_DEBUG);
    }
    if(defined(&Py_TRACE_REFS)) {
	eval 'sub PyObject_HEAD () {\'struct _object\' * &_ob_next, * &_ob_prev; \'int\'  &ob_refcnt; \'struct _typeobject\' * &ob_type;;}' unless defined(&PyObject_HEAD);
	eval 'sub PyObject_HEAD_INIT {
	    my($type) = @_;
    	    eval q(0, 0, 1, $type,);
	}' unless defined(&PyObject_HEAD_INIT);
    } else {
	eval 'sub PyObject_HEAD () {\'int\'  &ob_refcnt; \'struct _typeobject\' * &ob_type;;}' unless defined(&PyObject_HEAD);
	eval 'sub PyObject_HEAD_INIT {
	    my($type) = @_;
    	    eval q(1, $type,);
	}' unless defined(&PyObject_HEAD_INIT);
    }
    eval 'sub PyObject_VAR_HEAD () { &PyObject_HEAD \'int\'  &ob_size;;}' unless defined(&PyObject_VAR_HEAD);
    if(defined(&COUNT_ALLOCS)) {
    }
    eval 'sub PyObject_TypeCheck {
        my($ob, $tp) = @_;
	    eval q((($ob)-> &ob_type == ($tp) ||  &PyType_IsSubtype(($ob)-> &ob_type, ($tp))));
    }' unless defined(&PyObject_TypeCheck);
    eval 'sub PyType_Check {
        my($op) = @_;
	    eval q( &PyObject_TypeCheck($op,  &PyType_Type));
    }' unless defined(&PyType_Check);
    eval 'sub PyType_CheckExact {
        my($op) = @_;
	    eval q((($op)-> &ob_type ==  &PyType_Type));
    }' unless defined(&PyType_CheckExact);
    if(defined(&Py_USING_UNICODE)) {
    }
    eval 'sub PyObject_REPR {
        my($obj) = @_;
	    eval q( &PyString_AS_STRING( &PyObject_Repr($obj)));
    }' unless defined(&PyObject_REPR);
    eval 'sub Py_PRINT_RAW () {1;}' unless defined(&Py_PRINT_RAW);
    eval 'sub Py_TPFLAGS_HAVE_GETCHARBUFFER () {(1<<0);}' unless defined(&Py_TPFLAGS_HAVE_GETCHARBUFFER);
    eval 'sub Py_TPFLAGS_HAVE_SEQUENCE_IN () {(1<<1);}' unless defined(&Py_TPFLAGS_HAVE_SEQUENCE_IN);
    eval 'sub Py_TPFLAGS_GC () {0;}' unless defined(&Py_TPFLAGS_GC);
    eval 'sub Py_TPFLAGS_HAVE_INPLACEOPS () {(1<<3);}' unless defined(&Py_TPFLAGS_HAVE_INPLACEOPS);
    eval 'sub Py_TPFLAGS_CHECKTYPES () {(1<<4);}' unless defined(&Py_TPFLAGS_CHECKTYPES);
    eval 'sub Py_TPFLAGS_HAVE_RICHCOMPARE () {(1<<5);}' unless defined(&Py_TPFLAGS_HAVE_RICHCOMPARE);
    eval 'sub Py_TPFLAGS_HAVE_WEAKREFS () {(1<<6);}' unless defined(&Py_TPFLAGS_HAVE_WEAKREFS);
    eval 'sub Py_TPFLAGS_HAVE_ITER () {(1<<7);}' unless defined(&Py_TPFLAGS_HAVE_ITER);
    eval 'sub Py_TPFLAGS_HAVE_CLASS () {(1<<8);}' unless defined(&Py_TPFLAGS_HAVE_CLASS);
    eval 'sub Py_TPFLAGS_HEAPTYPE () {(1<<9);}' unless defined(&Py_TPFLAGS_HEAPTYPE);
    eval 'sub Py_TPFLAGS_BASETYPE () {(1<<10);}' unless defined(&Py_TPFLAGS_BASETYPE);
    eval 'sub Py_TPFLAGS_READY () {(1<<12);}' unless defined(&Py_TPFLAGS_READY);
    eval 'sub Py_TPFLAGS_READYING () {(1<<13);}' unless defined(&Py_TPFLAGS_READYING);
    if(defined(&WITH_CYCLE_GC)) {
	eval 'sub Py_TPFLAGS_HAVE_GC () {(1<<14);}' unless defined(&Py_TPFLAGS_HAVE_GC);
    } else {
	eval 'sub Py_TPFLAGS_HAVE_GC () {0;}' unless defined(&Py_TPFLAGS_HAVE_GC);
    }
    eval 'sub Py_TPFLAGS_DEFAULT () {(  &Py_TPFLAGS_HAVE_GETCHARBUFFER |  &Py_TPFLAGS_HAVE_SEQUENCE_IN |  &Py_TPFLAGS_HAVE_INPLACEOPS |  &Py_TPFLAGS_HAVE_RICHCOMPARE |  &Py_TPFLAGS_HAVE_WEAKREFS |  &Py_TPFLAGS_HAVE_ITER |  &Py_TPFLAGS_HAVE_CLASS | 0);}' unless defined(&Py_TPFLAGS_DEFAULT);
    eval 'sub PyType_HasFeature {
        my($t,$f) = @_;
	    eval q(((($t)-> &tp_flags & ($f)) != 0));
    }' unless defined(&PyType_HasFeature);
    if(defined(&Py_TRACE_REFS)) {
	unless(defined(&Py_REF_DEBUG)) {
	    eval 'sub Py_REF_DEBUG () {1;}' unless defined(&Py_REF_DEBUG);
	}
    }
    if(defined(&Py_TRACE_REFS)) {
    }
    unless(defined(&Py_TRACE_REFS)) {
	if(defined(&COUNT_ALLOCS)) {
	    eval 'sub _Py_Dealloc {
	        my($op) = @_;
    		eval q((($op)-> ($ob_type->{tp_frees})++, (*($op)-> ($ob_type->{tp_dealloc}))(( &PyObject *)($op))));
	    }' unless defined(&_Py_Dealloc);
	    eval 'sub _Py_ForgetReference {
	        my($op) = @_;
    		eval q((($op)-> ($ob_type->{tp_frees})++));
	    }' unless defined(&_Py_ForgetReference);
	} else {
	    eval 'sub _Py_Dealloc {
	        my($op) = @_;
    		eval q((*($op)-> ($ob_type->{tp_dealloc}))(( &PyObject *)($op)));
	    }' unless defined(&_Py_Dealloc);
	    eval 'sub _Py_ForgetReference {
	        my($op) = @_;
    		eval q();
	    }' unless defined(&_Py_ForgetReference);
	}
    }
    if(defined(&COUNT_ALLOCS)) {
    }
    if(defined(&Py_REF_DEBUG)) {
	unless(defined(&Py_TRACE_REFS)) {
	    if(defined(&COUNT_ALLOCS)) {
		eval 'sub _Py_NewReference {
		    my($op) = @_;
    		    eval q(( &inc_count(($op)-> &ob_type),  &_Py_RefTotal++, ($op)-> &ob_refcnt = 1));
		}' unless defined(&_Py_NewReference);
	    } else {
		eval 'sub _Py_NewReference {
		    my($op) = @_;
    		    eval q(( &_Py_RefTotal++, ($op)-> &ob_refcnt = 1));
		}' unless defined(&_Py_NewReference);
	    }
	}
	eval 'sub Py_INCREF {
	    my($op) = @_;
    	    eval q(( &_Py_RefTotal++, ($op)-> &ob_refcnt++));
	}' unless defined(&Py_INCREF);
	eval 'sub Py_DECREF {
	    my($op) = @_;
    	    eval q( &if (-- &_Py_RefTotal, 0< (--(($op)-> &ob_refcnt))) ;  &else  &if (0== ($op)-> &ob_refcnt)  &_Py_Dealloc( ( &PyObject*)($op));  &else ( &void) &fprintf(  &stderr, \\"%s:%i negative ref count %i\\\\n\\",  &__FILE__,  &__LINE__, ($op)-> &ob_refcnt));
	}' unless defined(&Py_DECREF);
    } else {
	if(defined(&COUNT_ALLOCS)) {
	    eval 'sub _Py_NewReference {
	        my($op) = @_;
    		eval q(( &inc_count(($op)-> &ob_type), ($op)-> &ob_refcnt = 1));
	    }' unless defined(&_Py_NewReference);
	} else {
	    eval 'sub _Py_NewReference {
	        my($op) = @_;
    		eval q((($op)-> &ob_refcnt = 1));
	    }' unless defined(&_Py_NewReference);
	}
	eval 'sub Py_INCREF {
	    my($op) = @_;
    	    eval q((($op)-> &ob_refcnt++));
	}' unless defined(&Py_INCREF);
	eval 'sub Py_DECREF {
	    my($op) = @_;
    	    eval q( &if (--($op)-> &ob_refcnt != 0) ;  &else  &_Py_Dealloc(( &PyObject *)($op)));
	}' unless defined(&Py_DECREF);
    }
    eval 'sub Py_XINCREF {
        my($op) = @_;
	    eval q( &if (($op) ==  &NULL) ;  &else  &Py_INCREF($op));
    }' unless defined(&Py_XINCREF);
    eval 'sub Py_XDECREF {
        my($op) = @_;
	    eval q( &if (($op) ==  &NULL) ;  &else  &Py_DECREF($op));
    }' unless defined(&Py_XDECREF);
    eval 'sub Py_None () {(& &_Py_NoneStruct);}' unless defined(&Py_None);
    eval 'sub Py_NotImplemented () {(& &_Py_NotImplementedStruct);}' unless defined(&Py_NotImplemented);
    eval 'sub Py_LT () {0;}' unless defined(&Py_LT);
    eval 'sub Py_LE () {1;}' unless defined(&Py_LE);
    eval 'sub Py_EQ () {2;}' unless defined(&Py_EQ);
    eval 'sub Py_NE () {3;}' unless defined(&Py_NE);
    eval 'sub Py_GT () {4;}' unless defined(&Py_GT);
    eval 'sub Py_GE () {5;}' unless defined(&Py_GE);
    if(defined(&BAD_STATIC_FORWARD)) {
	eval 'sub staticforward () { &extern;}' unless defined(&staticforward);
	eval 'sub statichere () { &static;}' unless defined(&statichere);
    } else {
	eval 'sub staticforward () { &static;}' unless defined(&staticforward);
	eval 'sub statichere () { &static;}' unless defined(&statichere);
    }
    eval 'sub PyTrash_UNWIND_LEVEL () {50;}' unless defined(&PyTrash_UNWIND_LEVEL);
    eval 'sub Py_TRASHCAN_SAFE_BEGIN {
        my($op) = @_;
	    eval q({ ++ &_PyTrash_delete_nesting;  &if ( &_PyTrash_delete_nesting <  &PyTrash_UNWIND_LEVEL) {);
    }' unless defined(&Py_TRASHCAN_SAFE_BEGIN);
    eval 'sub Py_TRASHCAN_SAFE_END {
        my($op) = @_;
	    eval q(;}  &else  &_PyTrash_deposit_object(( &PyObject*)$op); -- &_PyTrash_delete_nesting;  &if ( &_PyTrash_delete_later  &&  &_PyTrash_delete_nesting <= 0)  &_PyTrash_destroy_chain(); });
    }' unless defined(&Py_TRASHCAN_SAFE_END);
    eval 'sub xxPy_TRASHCAN_SAFE_BEGIN {
        my($op) = @_;
	    eval q();
    }' unless defined(&xxPy_TRASHCAN_SAFE_BEGIN);
    eval 'sub xxPy_TRASHCAN_SAFE_END {
        my($op) = @_;
	    eval q(;);
    }' unless defined(&xxPy_TRASHCAN_SAFE_END);
    if(defined(&__cplusplus)) {
    }
}
1;
