require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ALL_SOURCE)) {
}
unless(defined(&__CHAR_UNSIGNED__)) {
}
unless(defined(&HAVE_ST_BLKSIZE)) {
    sub HAVE_ST_BLKSIZE () {	1;}
}
unless(defined(&HAVE_ST_BLOCKS)) {
    sub HAVE_ST_BLOCKS () {	1;}
}
unless(defined(&HAVE_ST_RDEV)) {
    sub HAVE_ST_RDEV () {	1;}
}
unless(defined(&HAVE_TM_ZONE)) {
    sub HAVE_TM_ZONE () {	1;}
}
unless(defined(&RETSIGTYPE)) {
    sub RETSIGTYPE () {	 &void;}
}
unless(defined(&STDC_HEADERS)) {
    sub STDC_HEADERS () {	1;}
}
unless(defined(&TIME_WITH_SYS_TIME)) {
    sub TIME_WITH_SYS_TIME () {	1;}
}
unless(defined(&_FILE_OFFSET_BITS)) {
    sub _FILE_OFFSET_BITS () {	64;}
}
unless(defined(&ENABLE_IPV6)) {
    sub ENABLE_IPV6 () {	1;}
}
unless(defined(&HAVE_ADDRINFO)) {
    sub HAVE_ADDRINFO () {	1;}
}
unless(defined(&HAVE_GETADDRINFO)) {
    sub HAVE_GETADDRINFO () {	1;}
}
unless(defined(&HAVE_SOCKADDR_STORAGE)) {
    sub HAVE_SOCKADDR_STORAGE () {	1;}
}
unless(defined(&HAVE_DYNAMIC_LOADING)) {
    sub HAVE_DYNAMIC_LOADING () {	1;}
}
unless(defined(&HAVE_GETC_UNLOCKED)) {
    sub HAVE_GETC_UNLOCKED () {	1;}
}
unless(defined(&HAVE_GETHOSTBYNAME_R)) {
    sub HAVE_GETHOSTBYNAME_R () {	1;}
}
unless(defined(&HAVE_GETHOSTBYNAME_R_6_ARG)) {
    sub HAVE_GETHOSTBYNAME_R_6_ARG () {	1;}
}
unless(defined(&HAVE_LARGEFILE_SUPPORT)) {
    sub HAVE_LARGEFILE_SUPPORT () {	1;}
}
unless(defined(&HAVE_LONG_LONG)) {
    sub HAVE_LONG_LONG () {	1;}
}
unless(defined(&HAVE_PROTOTYPES)) {
    sub HAVE_PROTOTYPES () {	1;}
}
unless(defined(&HAVE_RL_COMPLETION_APPEND_CHARACTER)) {
    sub HAVE_RL_COMPLETION_APPEND_CHARACTER () {	1;}
}
unless(defined(&HAVE_RL_PRE_INPUT_HOOK)) {
    sub HAVE_RL_PRE_INPUT_HOOK () {	1;}
}
unless(defined(&HAVE_RL_COMPLETION_MATCHES)) {
    sub HAVE_RL_COMPLETION_MATCHES () {	1;}
}
unless(defined(&HAVE_STDARG_PROTOTYPES)) {
    sub HAVE_STDARG_PROTOTYPES () {	1;}
}
unless(defined(&HAVE_USABLE_WCHAR_T)) {
    sub HAVE_USABLE_WCHAR_T () {	1;}
}
unless(defined(&HAVE_WCHAR_H)) {
    sub HAVE_WCHAR_H () {	1;}
}
unless(defined(&_LARGEFILE_SOURCE)) {
    sub _LARGEFILE_SOURCE () {	1;}
}
unless(defined(&Py_USING_UNICODE)) {
    sub Py_USING_UNICODE () {	1;}
}
unless(defined(&PY_UNICODE_TYPE)) {
    sub PY_UNICODE_TYPE () {	 &wchar_t;}
}
unless(defined(&Py_UNICODE_SIZE)) {
    sub Py_UNICODE_SIZE () {	4;}
}
unless(defined(&MALLOC_ZERO_RETURNS_NULL)) {
    sub MALLOC_ZERO_RETURNS_NULL () {	1;}
}
unless(defined(&_REENTRANT)) {
    sub _REENTRANT () {	1;}
}
unless(defined(&SIZEOF_OFF_T)) {
    sub SIZEOF_OFF_T () {	8;}
}
unless(defined(&SIZEOF_TIME_T)) {
    sub SIZEOF_TIME_T () {	4;}
}
unless(defined(&SIZEOF_PTHREAD_T)) {
    sub SIZEOF_PTHREAD_T () {	4;}
}
unless(defined(&PTHREAD_SYSTEM_SCHED_SUPPORTED)) {
    sub PTHREAD_SYSTEM_SCHED_SUPPORTED () {	1;}
}
unless(defined(&SYS_SELECT_WITH_SYS_TIME)) {
    sub SYS_SELECT_WITH_SYS_TIME () {	1;}
}
unless(defined(&WITH_CYCLE_GC)) {
    sub WITH_CYCLE_GC () {	1;}
}
unless(defined(&WITH_THREAD)) {
    sub WITH_THREAD () {	1;}
}
unless(defined(&MVWDELCH_IS_EXPRESSION)) {
    sub MVWDELCH_IS_EXPRESSION () {	1;}
}
unless(defined(&WINDOW_HAS_FLAGS)) {
    sub WINDOW_HAS_FLAGS () {	1;}
}
unless(defined(&SIZEOF_CHAR)) {
    sub SIZEOF_CHAR () {	1;}
}
unless(defined(&SIZEOF_DOUBLE)) {
    sub SIZEOF_DOUBLE () {	8;}
}
unless(defined(&SIZEOF_FLOAT)) {
    sub SIZEOF_FLOAT () {	4;}
}
unless(defined(&SIZEOF_FPOS_T)) {
    sub SIZEOF_FPOS_T () {	16;}
}
unless(defined(&SIZEOF_INT)) {
    sub SIZEOF_INT () {	4;}
}
unless(defined(&SIZEOF_LONG)) {
    sub SIZEOF_LONG () {	4;}
}
unless(defined(&SIZEOF_LONG_LONG)) {
    sub SIZEOF_LONG_LONG () {	8;}
}
unless(defined(&SIZEOF_SHORT)) {
    sub SIZEOF_SHORT () {	2;}
}
unless(defined(&SIZEOF_VOID_P)) {
    sub SIZEOF_VOID_P () {	4;}
}
unless(defined(&SIZEOF_WCHAR_T)) {
    sub SIZEOF_WCHAR_T () {	4;}
}
unless(defined(&HAVE_ALARM)) {
    sub HAVE_ALARM () {	1;}
}
unless(defined(&HAVE_CHOWN)) {
    sub HAVE_CHOWN () {	1;}
}
unless(defined(&HAVE_CHROOT)) {
    sub HAVE_CHROOT () {	1;}
}
unless(defined(&HAVE_CLOCK)) {
    sub HAVE_CLOCK () {	1;}
}
unless(defined(&HAVE_CONFSTR)) {
    sub HAVE_CONFSTR () {	1;}
}
unless(defined(&HAVE_CTERMID)) {
    sub HAVE_CTERMID () {	1;}
}
unless(defined(&HAVE_DLOPEN)) {
    sub HAVE_DLOPEN () {	1;}
}
unless(defined(&HAVE_DUP2)) {
    sub HAVE_DUP2 () {	1;}
}
unless(defined(&HAVE_EXECV)) {
    sub HAVE_EXECV () {	1;}
}
unless(defined(&HAVE_FDATASYNC)) {
    sub HAVE_FDATASYNC () {	1;}
}
unless(defined(&HAVE_FLOCK)) {
    sub HAVE_FLOCK () {	1;}
}
unless(defined(&HAVE_FORK)) {
    sub HAVE_FORK () {	1;}
}
unless(defined(&HAVE_FORKPTY)) {
    sub HAVE_FORKPTY () {	1;}
}
unless(defined(&HAVE_FPATHCONF)) {
    sub HAVE_FPATHCONF () {	1;}
}
unless(defined(&HAVE_FSEEKO)) {
    sub HAVE_FSEEKO () {	1;}
}
unless(defined(&HAVE_FSTATVFS)) {
    sub HAVE_FSTATVFS () {	1;}
}
unless(defined(&HAVE_FSYNC)) {
    sub HAVE_FSYNC () {	1;}
}
unless(defined(&HAVE_FTELLO)) {
    sub HAVE_FTELLO () {	1;}
}
unless(defined(&HAVE_FTIME)) {
    sub HAVE_FTIME () {	1;}
}
unless(defined(&HAVE_FTRUNCATE)) {
    sub HAVE_FTRUNCATE () {	1;}
}
unless(defined(&HAVE_GAI_STRERROR)) {
    sub HAVE_GAI_STRERROR () {	1;}
}
unless(defined(&HAVE_GETCWD)) {
    sub HAVE_GETCWD () {	1;}
}
unless(defined(&HAVE_GETGROUPS)) {
    sub HAVE_GETGROUPS () {	1;}
}
unless(defined(&HAVE_GETLOGIN)) {
    sub HAVE_GETLOGIN () {	1;}
}
unless(defined(&HAVE_GETNAMEINFO)) {
    sub HAVE_GETNAMEINFO () {	1;}
}
unless(defined(&HAVE_GETPEERNAME)) {
    sub HAVE_GETPEERNAME () {	1;}
}
unless(defined(&HAVE_GETPGRP)) {
    sub HAVE_GETPGRP () {	1;}
}
unless(defined(&HAVE_GETPID)) {
    sub HAVE_GETPID () {	1;}
}
unless(defined(&HAVE_GETPRIORITY)) {
    sub HAVE_GETPRIORITY () {	1;}
}
unless(defined(&HAVE_GETPWENT)) {
    sub HAVE_GETPWENT () {	1;}
}
unless(defined(&HAVE_GETTIMEOFDAY)) {
    sub HAVE_GETTIMEOFDAY () {	1;}
}
unless(defined(&HAVE_GETWD)) {
    sub HAVE_GETWD () {	1;}
}
unless(defined(&HAVE_HSTRERROR)) {
    sub HAVE_HSTRERROR () {	1;}
}
unless(defined(&HAVE_HYPOT)) {
    sub HAVE_HYPOT () {	1;}
}
unless(defined(&HAVE_INET_PTON)) {
    sub HAVE_INET_PTON () {	1;}
}
unless(defined(&HAVE_KILL)) {
    sub HAVE_KILL () {	1;}
}
unless(defined(&HAVE_LINK)) {
    sub HAVE_LINK () {	1;}
}
unless(defined(&HAVE_LSTAT)) {
    sub HAVE_LSTAT () {	1;}
}
unless(defined(&HAVE_MEMMOVE)) {
    sub HAVE_MEMMOVE () {	1;}
}
unless(defined(&HAVE_MKFIFO)) {
    sub HAVE_MKFIFO () {	1;}
}
unless(defined(&HAVE_MKTIME)) {
    sub HAVE_MKTIME () {	1;}
}
unless(defined(&HAVE_MREMAP)) {
    sub HAVE_MREMAP () {	1;}
}
unless(defined(&HAVE_NICE)) {
    sub HAVE_NICE () {	1;}
}
unless(defined(&HAVE_OPENPTY)) {
    sub HAVE_OPENPTY () {	1;}
}
unless(defined(&HAVE_PATHCONF)) {
    sub HAVE_PATHCONF () {	1;}
}
unless(defined(&HAVE_PAUSE)) {
    sub HAVE_PAUSE () {	1;}
}
unless(defined(&HAVE_POLL)) {
    sub HAVE_POLL () {	1;}
}
unless(defined(&HAVE_PTHREAD_SIGMASK)) {
    sub HAVE_PTHREAD_SIGMASK () {	1;}
}
unless(defined(&HAVE_PUTENV)) {
    sub HAVE_PUTENV () {	1;}
}
unless(defined(&HAVE_READLINK)) {
    sub HAVE_READLINK () {	1;}
}
unless(defined(&HAVE_SELECT)) {
    sub HAVE_SELECT () {	1;}
}
unless(defined(&HAVE_SETEGID)) {
    sub HAVE_SETEGID () {	1;}
}
unless(defined(&HAVE_SETEUID)) {
    sub HAVE_SETEUID () {	1;}
}
unless(defined(&HAVE_SETGID)) {
    sub HAVE_SETGID () {	1;}
}
unless(defined(&HAVE_SETGROUPS)) {
    sub HAVE_SETGROUPS () {	1;}
}
unless(defined(&HAVE_SETLOCALE)) {
    sub HAVE_SETLOCALE () {	1;}
}
unless(defined(&HAVE_SETPGID)) {
    sub HAVE_SETPGID () {	1;}
}
unless(defined(&HAVE_SETPGRP)) {
    sub HAVE_SETPGRP () {	1;}
}
unless(defined(&HAVE_SETREGID)) {
    sub HAVE_SETREGID () {	1;}
}
unless(defined(&HAVE_SETREUID)) {
    sub HAVE_SETREUID () {	1;}
}
unless(defined(&HAVE_SETSID)) {
    sub HAVE_SETSID () {	1;}
}
unless(defined(&HAVE_SETUID)) {
    sub HAVE_SETUID () {	1;}
}
unless(defined(&HAVE_SETVBUF)) {
    sub HAVE_SETVBUF () {	1;}
}
unless(defined(&HAVE_SIGACTION)) {
    sub HAVE_SIGACTION () {	1;}
}
unless(defined(&HAVE_SIGINTERRUPT)) {
    sub HAVE_SIGINTERRUPT () {	1;}
}
unless(defined(&HAVE_SIGRELSE)) {
    sub HAVE_SIGRELSE () {	1;}
}
unless(defined(&HAVE_SNPRINTF)) {
    sub HAVE_SNPRINTF () {	1;}
}
unless(defined(&HAVE_STATVFS)) {
    sub HAVE_STATVFS () {	1;}
}
unless(defined(&HAVE_STRDUP)) {
    sub HAVE_STRDUP () {	1;}
}
unless(defined(&HAVE_STRERROR)) {
    sub HAVE_STRERROR () {	1;}
}
unless(defined(&HAVE_STRFTIME)) {
    sub HAVE_STRFTIME () {	1;}
}
unless(defined(&HAVE_STRPTIME)) {
    sub HAVE_STRPTIME () {	1;}
}
unless(defined(&HAVE_SYMLINK)) {
    sub HAVE_SYMLINK () {	1;}
}
unless(defined(&HAVE_SYSCONF)) {
    sub HAVE_SYSCONF () {	1;}
}
unless(defined(&HAVE_TCGETPGRP)) {
    sub HAVE_TCGETPGRP () {	1;}
}
unless(defined(&HAVE_TCSETPGRP)) {
    sub HAVE_TCSETPGRP () {	1;}
}
unless(defined(&HAVE_TEMPNAM)) {
    sub HAVE_TEMPNAM () {	1;}
}
unless(defined(&HAVE_TIMEGM)) {
    sub HAVE_TIMEGM () {	1;}
}
unless(defined(&HAVE_TIMES)) {
    sub HAVE_TIMES () {	1;}
}
unless(defined(&HAVE_TMPFILE)) {
    sub HAVE_TMPFILE () {	1;}
}
unless(defined(&HAVE_TMPNAM)) {
    sub HAVE_TMPNAM () {	1;}
}
unless(defined(&HAVE_TMPNAM_R)) {
    sub HAVE_TMPNAM_R () {	1;}
}
unless(defined(&HAVE_TRUNCATE)) {
    sub HAVE_TRUNCATE () {	1;}
}
unless(defined(&HAVE_UNAME)) {
    sub HAVE_UNAME () {	1;}
}
unless(defined(&HAVE_UNSETENV)) {
    sub HAVE_UNSETENV () {	1;}
}
unless(defined(&HAVE_WAITPID)) {
    sub HAVE_WAITPID () {	1;}
}
unless(defined(&HAVE_DB_H)) {
    sub HAVE_DB_H () {	1;}
}
unless(defined(&HAVE_DB_185_H)) {
    sub HAVE_DB_185_H () {	1;}
}
unless(defined(&HAVE_DIRENT_H)) {
    sub HAVE_DIRENT_H () {	1;}
}
unless(defined(&HAVE_DLFCN_H)) {
    sub HAVE_DLFCN_H () {	1;}
}
unless(defined(&HAVE_FCNTL_H)) {
    sub HAVE_FCNTL_H () {	1;}
}
unless(defined(&HAVE_GDBM_NDBM_H)) {
    sub HAVE_GDBM_NDBM_H () {	1;}
}
unless(defined(&HAVE_GRP_H)) {
    sub HAVE_GRP_H () {	1;}
}
unless(defined(&HAVE_LANGINFO_H)) {
    sub HAVE_LANGINFO_H () {	1;}
}
unless(defined(&HAVE_LIMITS_H)) {
    sub HAVE_LIMITS_H () {	1;}
}
unless(defined(&HAVE_LOCALE_H)) {
    sub HAVE_LOCALE_H () {	1;}
}
unless(defined(&HAVE_NCURSES_H)) {
    sub HAVE_NCURSES_H () {	1;}
}
unless(defined(&HAVE_NETPACKET_PACKET_H)) {
    sub HAVE_NETPACKET_PACKET_H () {	1;}
}
unless(defined(&HAVE_POLL_H)) {
    sub HAVE_POLL_H () {	1;}
}
unless(defined(&HAVE_PTHREAD_H)) {
    sub HAVE_PTHREAD_H () {	1;}
}
unless(defined(&HAVE_PTY_H)) {
    sub HAVE_PTY_H () {	1;}
}
unless(defined(&HAVE_SIGNAL_H)) {
    sub HAVE_SIGNAL_H () {	1;}
}
unless(defined(&HAVE_STDARG_H)) {
    sub HAVE_STDARG_H () {	1;}
}
unless(defined(&HAVE_STDDEF_H)) {
    sub HAVE_STDDEF_H () {	1;}
}
unless(defined(&HAVE_STDLIB_H)) {
    sub HAVE_STDLIB_H () {	1;}
}
unless(defined(&HAVE_SYS_FILE_H)) {
    sub HAVE_SYS_FILE_H () {	1;}
}
unless(defined(&HAVE_SYS_PARAM_H)) {
    sub HAVE_SYS_PARAM_H () {	1;}
}
unless(defined(&HAVE_SYS_POLL_H)) {
    sub HAVE_SYS_POLL_H () {	1;}
}
unless(defined(&HAVE_SYS_RESOURCE_H)) {
    sub HAVE_SYS_RESOURCE_H () {	1;}
}
unless(defined(&HAVE_SYS_SELECT_H)) {
    sub HAVE_SYS_SELECT_H () {	1;}
}
unless(defined(&HAVE_SYS_SOCKET_H)) {
    sub HAVE_SYS_SOCKET_H () {	1;}
}
unless(defined(&HAVE_SYS_TIME_H)) {
    sub HAVE_SYS_TIME_H () {	1;}
}
unless(defined(&HAVE_SYS_TIMES_H)) {
    sub HAVE_SYS_TIMES_H () {	1;}
}
unless(defined(&HAVE_SYS_UN_H)) {
    sub HAVE_SYS_UN_H () {	1;}
}
unless(defined(&HAVE_SYS_UTSNAME_H)) {
    sub HAVE_SYS_UTSNAME_H () {	1;}
}
unless(defined(&HAVE_SYS_WAIT_H)) {
    sub HAVE_SYS_WAIT_H () {	1;}
}
unless(defined(&HAVE_TERM_H)) {
    sub HAVE_TERM_H () {	1;}
}
unless(defined(&HAVE_TERMIOS_H)) {
    sub HAVE_TERMIOS_H () {	1;}
}
unless(defined(&HAVE_UNISTD_H)) {
    sub HAVE_UNISTD_H () {	1;}
}
unless(defined(&HAVE_UTIME_H)) {
    sub HAVE_UTIME_H () {	1;}
}
unless(defined(&HAVE_LIBDL)) {
    sub HAVE_LIBDL () {	1;}
}
if(defined(&__CYGWIN__)) {
    if(defined(&USE_DL_IMPORT)) {
	eval 'sub DL_IMPORT {
	    my($RTYPE) = @_;
    	    eval q( &__declspec( &dllimport) $RTYPE);
	}' unless defined(&DL_IMPORT);
	eval 'sub DL_EXPORT {
	    my($RTYPE) = @_;
    	    eval q( &__declspec( &dllexport) $RTYPE);
	}' unless defined(&DL_EXPORT);
    } else {
	eval 'sub DL_IMPORT {
	    my($RTYPE) = @_;
    	    eval q( &__declspec( &dllexport) $RTYPE);
	}' unless defined(&DL_IMPORT);
	eval 'sub DL_EXPORT {
	    my($RTYPE) = @_;
    	    eval q( &__declspec( &dllexport) $RTYPE);
	}' unless defined(&DL_EXPORT);
    }
}
if(defined( &__USLC__)  && defined( &__SCO_VERSION__)) {
    eval 'sub STRICT_SYSV_CURSES () {1;}' unless defined(&STRICT_SYSV_CURSES);
}
1;
