require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_STRUCTMEMBER_H)) {
    eval 'sub Py_STRUCTMEMBER_H () {1;}' unless defined(&Py_STRUCTMEMBER_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&HAVE_STDDEF_H)) {
	require 'stddef.ph';
    }
    unless(defined(&offsetof)) {
	eval 'sub offsetof {
	    my($type, $member) = @_;
    	    eval q((  & (($type*)0) -> $member ));
	}' unless defined(&offsetof);
    }
    eval 'sub T_SHORT () {0;}' unless defined(&T_SHORT);
    eval 'sub T_INT () {1;}' unless defined(&T_INT);
    eval 'sub T_LONG () {2;}' unless defined(&T_LONG);
    eval 'sub T_FLOAT () {3;}' unless defined(&T_FLOAT);
    eval 'sub T_DOUBLE () {4;}' unless defined(&T_DOUBLE);
    eval 'sub T_STRING () {5;}' unless defined(&T_STRING);
    eval 'sub T_OBJECT () {6;}' unless defined(&T_OBJECT);
    eval 'sub T_CHAR () {7;}' unless defined(&T_CHAR);
    eval 'sub T_BYTE () {8;}' unless defined(&T_BYTE);
    eval 'sub T_UBYTE () {9;}' unless defined(&T_UBYTE);
    eval 'sub T_USHORT () {10;}' unless defined(&T_USHORT);
    eval 'sub T_UINT () {11;}' unless defined(&T_UINT);
    eval 'sub T_ULONG () {12;}' unless defined(&T_ULONG);
    eval 'sub T_STRING_INPLACE () {13;}' unless defined(&T_STRING_INPLACE);
    if(defined(&macintosh)) {
	eval 'sub T_PSTRING () {14;}' unless defined(&T_PSTRING);
	eval 'sub T_PSTRING_INPLACE () {15;}' unless defined(&T_PSTRING_INPLACE);
    }
    eval 'sub T_OBJECT_EX () {16;}' unless defined(&T_OBJECT_EX);
    eval 'sub READONLY () {1;}' unless defined(&READONLY);
    eval 'sub RO () { &READONLY;}' unless defined(&RO);
    eval 'sub READ_RESTRICTED () {2;}' unless defined(&READ_RESTRICTED);
    eval 'sub WRITE_RESTRICTED () {4;}' unless defined(&WRITE_RESTRICTED);
    eval 'sub RESTRICTED () {( &READ_RESTRICTED |  &WRITE_RESTRICTED);}' unless defined(&RESTRICTED);
    if(defined(&__cplusplus)) {
    }
}
1;
