require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Py_UNICODEOBJECT_H)) {
    eval 'sub Py_UNICODEOBJECT_H () {1;}' unless defined(&Py_UNICODEOBJECT_H);
    require 'ctype.ph';
    unless(defined(&Py_USING_UNICODE)) {
	eval 'sub PyUnicode_Check {
	    my($op) = @_;
    	    eval q(0);
	}' unless defined(&PyUnicode_Check);
	eval 'sub PyUnicode_CheckExact {
	    my($op) = @_;
    	    eval q(0);
	}' unless defined(&PyUnicode_CheckExact);
    } else {
	unless(defined(&Py_UNICODE_SIZE)) {
	    die("Must\ define\ Py_UNICODE_SIZE");
	}
	if((defined(&Py_UNICODE_SIZE) ? &Py_UNICODE_SIZE : 0) >= 4) {
	    eval 'sub Py_UNICODE_WIDE () {1;}' unless defined(&Py_UNICODE_WIDE);
	}
	unless(defined(&PY_UNICODE_TYPE)) {
	    if(defined( &MS_WIN32)  && (defined(&Py_UNICODE_SIZE) ? &Py_UNICODE_SIZE : 0) == 2) {
		eval 'sub HAVE_USABLE_WCHAR_T () {1;}' unless defined(&HAVE_USABLE_WCHAR_T);
		eval 'sub PY_UNICODE_TYPE () { &wchar_t;}' unless defined(&PY_UNICODE_TYPE);
	    }
	    if(defined( &Py_UNICODE_WIDE)) {
		eval 'sub PY_UNICODE_TYPE () { &Py_UCS4;}' unless defined(&PY_UNICODE_TYPE);
	    }
	}
	if(defined(&HAVE_USABLE_WCHAR_T)) {
	    unless(defined(&HAVE_WCHAR_H)) {
		eval 'sub HAVE_WCHAR_H () {1;}' unless defined(&HAVE_WCHAR_H);
	    }
	}
	if(defined(&HAVE_WCHAR_H)) {
	    if(defined(&_HAVE_BSDI)) {
		require 'time.ph';
	    }
	    require 'wchar.ph';
	}
	if((defined(&SIZEOF_INT) ? &SIZEOF_INT : 0) >= 4) {
	}
 elsif((defined(&SIZEOF_LONG) ? &SIZEOF_LONG : 0) >= 4) {
	}
	unless(defined(&Py_UNICODE_WIDE)) {
	    eval 'sub PyUnicode_AsASCIIString () { &PyUnicodeUCS2_AsASCIIString;}' unless defined(&PyUnicode_AsASCIIString);
	    eval 'sub PyUnicode_AsCharmapString () { &PyUnicodeUCS2_AsCharmapString;}' unless defined(&PyUnicode_AsCharmapString);
	    eval 'sub PyUnicode_AsEncodedString () { &PyUnicodeUCS2_AsEncodedString;}' unless defined(&PyUnicode_AsEncodedString);
	    eval 'sub PyUnicode_AsLatin1String () { &PyUnicodeUCS2_AsLatin1String;}' unless defined(&PyUnicode_AsLatin1String);
	    eval 'sub PyUnicode_AsRawUnicodeEscapeString () { &PyUnicodeUCS2_AsRawUnicodeEscapeString;}' unless defined(&PyUnicode_AsRawUnicodeEscapeString);
	    eval 'sub PyUnicode_AsUTF16String () { &PyUnicodeUCS2_AsUTF16String;}' unless defined(&PyUnicode_AsUTF16String);
	    eval 'sub PyUnicode_AsUTF8String () { &PyUnicodeUCS2_AsUTF8String;}' unless defined(&PyUnicode_AsUTF8String);
	    eval 'sub PyUnicode_AsUnicode () { &PyUnicodeUCS2_AsUnicode;}' unless defined(&PyUnicode_AsUnicode);
	    eval 'sub PyUnicode_AsUnicodeEscapeString () { &PyUnicodeUCS2_AsUnicodeEscapeString;}' unless defined(&PyUnicode_AsUnicodeEscapeString);
	    eval 'sub PyUnicode_AsWideChar () { &PyUnicodeUCS2_AsWideChar;}' unless defined(&PyUnicode_AsWideChar);
	    eval 'sub PyUnicode_Compare () { &PyUnicodeUCS2_Compare;}' unless defined(&PyUnicode_Compare);
	    eval 'sub PyUnicode_Concat () { &PyUnicodeUCS2_Concat;}' unless defined(&PyUnicode_Concat);
	    eval 'sub PyUnicode_Contains () { &PyUnicodeUCS2_Contains;}' unless defined(&PyUnicode_Contains);
	    eval 'sub PyUnicode_Count () { &PyUnicodeUCS2_Count;}' unless defined(&PyUnicode_Count);
	    eval 'sub PyUnicode_Decode () { &PyUnicodeUCS2_Decode;}' unless defined(&PyUnicode_Decode);
	    eval 'sub PyUnicode_DecodeASCII () { &PyUnicodeUCS2_DecodeASCII;}' unless defined(&PyUnicode_DecodeASCII);
	    eval 'sub PyUnicode_DecodeCharmap () { &PyUnicodeUCS2_DecodeCharmap;}' unless defined(&PyUnicode_DecodeCharmap);
	    eval 'sub PyUnicode_DecodeLatin1 () { &PyUnicodeUCS2_DecodeLatin1;}' unless defined(&PyUnicode_DecodeLatin1);
	    eval 'sub PyUnicode_DecodeRawUnicodeEscape () { &PyUnicodeUCS2_DecodeRawUnicodeEscape;}' unless defined(&PyUnicode_DecodeRawUnicodeEscape);
	    eval 'sub PyUnicode_DecodeUTF16 () { &PyUnicodeUCS2_DecodeUTF16;}' unless defined(&PyUnicode_DecodeUTF16);
	    eval 'sub PyUnicode_DecodeUTF8 () { &PyUnicodeUCS2_DecodeUTF8;}' unless defined(&PyUnicode_DecodeUTF8);
	    eval 'sub PyUnicode_DecodeUnicodeEscape () { &PyUnicodeUCS2_DecodeUnicodeEscape;}' unless defined(&PyUnicode_DecodeUnicodeEscape);
	    eval 'sub PyUnicode_Encode () { &PyUnicodeUCS2_Encode;}' unless defined(&PyUnicode_Encode);
	    eval 'sub PyUnicode_EncodeASCII () { &PyUnicodeUCS2_EncodeASCII;}' unless defined(&PyUnicode_EncodeASCII);
	    eval 'sub PyUnicode_EncodeCharmap () { &PyUnicodeUCS2_EncodeCharmap;}' unless defined(&PyUnicode_EncodeCharmap);
	    eval 'sub PyUnicode_EncodeDecimal () { &PyUnicodeUCS2_EncodeDecimal;}' unless defined(&PyUnicode_EncodeDecimal);
	    eval 'sub PyUnicode_EncodeLatin1 () { &PyUnicodeUCS2_EncodeLatin1;}' unless defined(&PyUnicode_EncodeLatin1);
	    eval 'sub PyUnicode_EncodeRawUnicodeEscape () { &PyUnicodeUCS2_EncodeRawUnicodeEscape;}' unless defined(&PyUnicode_EncodeRawUnicodeEscape);
	    eval 'sub PyUnicode_EncodeUTF16 () { &PyUnicodeUCS2_EncodeUTF16;}' unless defined(&PyUnicode_EncodeUTF16);
	    eval 'sub PyUnicode_EncodeUTF8 () { &PyUnicodeUCS2_EncodeUTF8;}' unless defined(&PyUnicode_EncodeUTF8);
	    eval 'sub PyUnicode_EncodeUnicodeEscape () { &PyUnicodeUCS2_EncodeUnicodeEscape;}' unless defined(&PyUnicode_EncodeUnicodeEscape);
	    eval 'sub PyUnicode_Find () { &PyUnicodeUCS2_Find;}' unless defined(&PyUnicode_Find);
	    eval 'sub PyUnicode_Format () { &PyUnicodeUCS2_Format;}' unless defined(&PyUnicode_Format);
	    eval 'sub PyUnicode_FromEncodedObject () { &PyUnicodeUCS2_FromEncodedObject;}' unless defined(&PyUnicode_FromEncodedObject);
	    eval 'sub PyUnicode_FromObject () { &PyUnicodeUCS2_FromObject;}' unless defined(&PyUnicode_FromObject);
	    eval 'sub PyUnicode_FromUnicode () { &PyUnicodeUCS2_FromUnicode;}' unless defined(&PyUnicode_FromUnicode);
	    eval 'sub PyUnicode_FromWideChar () { &PyUnicodeUCS2_FromWideChar;}' unless defined(&PyUnicode_FromWideChar);
	    eval 'sub PyUnicode_GetDefaultEncoding () { &PyUnicodeUCS2_GetDefaultEncoding;}' unless defined(&PyUnicode_GetDefaultEncoding);
	    eval 'sub PyUnicode_GetMax () { &PyUnicodeUCS2_GetMax;}' unless defined(&PyUnicode_GetMax);
	    eval 'sub PyUnicode_GetSize () { &PyUnicodeUCS2_GetSize;}' unless defined(&PyUnicode_GetSize);
	    eval 'sub PyUnicode_Join () { &PyUnicodeUCS2_Join;}' unless defined(&PyUnicode_Join);
	    eval 'sub PyUnicode_Replace () { &PyUnicodeUCS2_Replace;}' unless defined(&PyUnicode_Replace);
	    eval 'sub PyUnicode_Resize () { &PyUnicodeUCS2_Resize;}' unless defined(&PyUnicode_Resize);
	    eval 'sub PyUnicode_SetDefaultEncoding () { &PyUnicodeUCS2_SetDefaultEncoding;}' unless defined(&PyUnicode_SetDefaultEncoding);
	    eval 'sub PyUnicode_Split () { &PyUnicodeUCS2_Split;}' unless defined(&PyUnicode_Split);
	    eval 'sub PyUnicode_Splitlines () { &PyUnicodeUCS2_Splitlines;}' unless defined(&PyUnicode_Splitlines);
	    eval 'sub PyUnicode_Tailmatch () { &PyUnicodeUCS2_Tailmatch;}' unless defined(&PyUnicode_Tailmatch);
	    eval 'sub PyUnicode_Translate () { &PyUnicodeUCS2_Translate;}' unless defined(&PyUnicode_Translate);
	    eval 'sub PyUnicode_TranslateCharmap () { &PyUnicodeUCS2_TranslateCharmap;}' unless defined(&PyUnicode_TranslateCharmap);
	    eval 'sub _PyUnicode_AsDefaultEncodedString () { &_PyUnicodeUCS2_AsDefaultEncodedString;}' unless defined(&_PyUnicode_AsDefaultEncodedString);
	    eval 'sub _PyUnicode_Fini () { &_PyUnicodeUCS2_Fini;}' unless defined(&_PyUnicode_Fini);
	    eval 'sub _PyUnicode_Init () { &_PyUnicodeUCS2_Init;}' unless defined(&_PyUnicode_Init);
	    eval 'sub _PyUnicode_IsAlpha () { &_PyUnicodeUCS2_IsAlpha;}' unless defined(&_PyUnicode_IsAlpha);
	    eval 'sub _PyUnicode_IsDecimalDigit () { &_PyUnicodeUCS2_IsDecimalDigit;}' unless defined(&_PyUnicode_IsDecimalDigit);
	    eval 'sub _PyUnicode_IsDigit () { &_PyUnicodeUCS2_IsDigit;}' unless defined(&_PyUnicode_IsDigit);
	    eval 'sub _PyUnicode_IsLinebreak () { &_PyUnicodeUCS2_IsLinebreak;}' unless defined(&_PyUnicode_IsLinebreak);
	    eval 'sub _PyUnicode_IsLowercase () { &_PyUnicodeUCS2_IsLowercase;}' unless defined(&_PyUnicode_IsLowercase);
	    eval 'sub _PyUnicode_IsNumeric () { &_PyUnicodeUCS2_IsNumeric;}' unless defined(&_PyUnicode_IsNumeric);
	    eval 'sub _PyUnicode_IsTitlecase () { &_PyUnicodeUCS2_IsTitlecase;}' unless defined(&_PyUnicode_IsTitlecase);
	    eval 'sub _PyUnicode_IsUppercase () { &_PyUnicodeUCS2_IsUppercase;}' unless defined(&_PyUnicode_IsUppercase);
	    eval 'sub _PyUnicode_IsWhitespace () { &_PyUnicodeUCS2_IsWhitespace;}' unless defined(&_PyUnicode_IsWhitespace);
	    eval 'sub _PyUnicode_ToDecimalDigit () { &_PyUnicodeUCS2_ToDecimalDigit;}' unless defined(&_PyUnicode_ToDecimalDigit);
	    eval 'sub _PyUnicode_ToDigit () { &_PyUnicodeUCS2_ToDigit;}' unless defined(&_PyUnicode_ToDigit);
	    eval 'sub _PyUnicode_ToLowercase () { &_PyUnicodeUCS2_ToLowercase;}' unless defined(&_PyUnicode_ToLowercase);
	    eval 'sub _PyUnicode_ToNumeric () { &_PyUnicodeUCS2_ToNumeric;}' unless defined(&_PyUnicode_ToNumeric);
	    eval 'sub _PyUnicode_ToTitlecase () { &_PyUnicodeUCS2_ToTitlecase;}' unless defined(&_PyUnicode_ToTitlecase);
	    eval 'sub _PyUnicode_ToUppercase () { &_PyUnicodeUCS2_ToUppercase;}' unless defined(&_PyUnicode_ToUppercase);
	} else {
	    eval 'sub PyUnicode_AsASCIIString () { &PyUnicodeUCS4_AsASCIIString;}' unless defined(&PyUnicode_AsASCIIString);
	    eval 'sub PyUnicode_AsCharmapString () { &PyUnicodeUCS4_AsCharmapString;}' unless defined(&PyUnicode_AsCharmapString);
	    eval 'sub PyUnicode_AsEncodedString () { &PyUnicodeUCS4_AsEncodedString;}' unless defined(&PyUnicode_AsEncodedString);
	    eval 'sub PyUnicode_AsLatin1String () { &PyUnicodeUCS4_AsLatin1String;}' unless defined(&PyUnicode_AsLatin1String);
	    eval 'sub PyUnicode_AsRawUnicodeEscapeString () { &PyUnicodeUCS4_AsRawUnicodeEscapeString;}' unless defined(&PyUnicode_AsRawUnicodeEscapeString);
	    eval 'sub PyUnicode_AsUTF16String () { &PyUnicodeUCS4_AsUTF16String;}' unless defined(&PyUnicode_AsUTF16String);
	    eval 'sub PyUnicode_AsUTF8String () { &PyUnicodeUCS4_AsUTF8String;}' unless defined(&PyUnicode_AsUTF8String);
	    eval 'sub PyUnicode_AsUnicode () { &PyUnicodeUCS4_AsUnicode;}' unless defined(&PyUnicode_AsUnicode);
	    eval 'sub PyUnicode_AsUnicodeEscapeString () { &PyUnicodeUCS4_AsUnicodeEscapeString;}' unless defined(&PyUnicode_AsUnicodeEscapeString);
	    eval 'sub PyUnicode_AsWideChar () { &PyUnicodeUCS4_AsWideChar;}' unless defined(&PyUnicode_AsWideChar);
	    eval 'sub PyUnicode_Compare () { &PyUnicodeUCS4_Compare;}' unless defined(&PyUnicode_Compare);
	    eval 'sub PyUnicode_Concat () { &PyUnicodeUCS4_Concat;}' unless defined(&PyUnicode_Concat);
	    eval 'sub PyUnicode_Contains () { &PyUnicodeUCS4_Contains;}' unless defined(&PyUnicode_Contains);
	    eval 'sub PyUnicode_Count () { &PyUnicodeUCS4_Count;}' unless defined(&PyUnicode_Count);
	    eval 'sub PyUnicode_Decode () { &PyUnicodeUCS4_Decode;}' unless defined(&PyUnicode_Decode);
	    eval 'sub PyUnicode_DecodeASCII () { &PyUnicodeUCS4_DecodeASCII;}' unless defined(&PyUnicode_DecodeASCII);
	    eval 'sub PyUnicode_DecodeCharmap () { &PyUnicodeUCS4_DecodeCharmap;}' unless defined(&PyUnicode_DecodeCharmap);
	    eval 'sub PyUnicode_DecodeLatin1 () { &PyUnicodeUCS4_DecodeLatin1;}' unless defined(&PyUnicode_DecodeLatin1);
	    eval 'sub PyUnicode_DecodeRawUnicodeEscape () { &PyUnicodeUCS4_DecodeRawUnicodeEscape;}' unless defined(&PyUnicode_DecodeRawUnicodeEscape);
	    eval 'sub PyUnicode_DecodeUTF16 () { &PyUnicodeUCS4_DecodeUTF16;}' unless defined(&PyUnicode_DecodeUTF16);
	    eval 'sub PyUnicode_DecodeUTF8 () { &PyUnicodeUCS4_DecodeUTF8;}' unless defined(&PyUnicode_DecodeUTF8);
	    eval 'sub PyUnicode_DecodeUnicodeEscape () { &PyUnicodeUCS4_DecodeUnicodeEscape;}' unless defined(&PyUnicode_DecodeUnicodeEscape);
	    eval 'sub PyUnicode_Encode () { &PyUnicodeUCS4_Encode;}' unless defined(&PyUnicode_Encode);
	    eval 'sub PyUnicode_EncodeASCII () { &PyUnicodeUCS4_EncodeASCII;}' unless defined(&PyUnicode_EncodeASCII);
	    eval 'sub PyUnicode_EncodeCharmap () { &PyUnicodeUCS4_EncodeCharmap;}' unless defined(&PyUnicode_EncodeCharmap);
	    eval 'sub PyUnicode_EncodeDecimal () { &PyUnicodeUCS4_EncodeDecimal;}' unless defined(&PyUnicode_EncodeDecimal);
	    eval 'sub PyUnicode_EncodeLatin1 () { &PyUnicodeUCS4_EncodeLatin1;}' unless defined(&PyUnicode_EncodeLatin1);
	    eval 'sub PyUnicode_EncodeRawUnicodeEscape () { &PyUnicodeUCS4_EncodeRawUnicodeEscape;}' unless defined(&PyUnicode_EncodeRawUnicodeEscape);
	    eval 'sub PyUnicode_EncodeUTF16 () { &PyUnicodeUCS4_EncodeUTF16;}' unless defined(&PyUnicode_EncodeUTF16);
	    eval 'sub PyUnicode_EncodeUTF8 () { &PyUnicodeUCS4_EncodeUTF8;}' unless defined(&PyUnicode_EncodeUTF8);
	    eval 'sub PyUnicode_EncodeUnicodeEscape () { &PyUnicodeUCS4_EncodeUnicodeEscape;}' unless defined(&PyUnicode_EncodeUnicodeEscape);
	    eval 'sub PyUnicode_Find () { &PyUnicodeUCS4_Find;}' unless defined(&PyUnicode_Find);
	    eval 'sub PyUnicode_Format () { &PyUnicodeUCS4_Format;}' unless defined(&PyUnicode_Format);
	    eval 'sub PyUnicode_FromEncodedObject () { &PyUnicodeUCS4_FromEncodedObject;}' unless defined(&PyUnicode_FromEncodedObject);
	    eval 'sub PyUnicode_FromObject () { &PyUnicodeUCS4_FromObject;}' unless defined(&PyUnicode_FromObject);
	    eval 'sub PyUnicode_FromUnicode () { &PyUnicodeUCS4_FromUnicode;}' unless defined(&PyUnicode_FromUnicode);
	    eval 'sub PyUnicode_FromWideChar () { &PyUnicodeUCS4_FromWideChar;}' unless defined(&PyUnicode_FromWideChar);
	    eval 'sub PyUnicode_GetDefaultEncoding () { &PyUnicodeUCS4_GetDefaultEncoding;}' unless defined(&PyUnicode_GetDefaultEncoding);
	    eval 'sub PyUnicode_GetMax () { &PyUnicodeUCS4_GetMax;}' unless defined(&PyUnicode_GetMax);
	    eval 'sub PyUnicode_GetSize () { &PyUnicodeUCS4_GetSize;}' unless defined(&PyUnicode_GetSize);
	    eval 'sub PyUnicode_Join () { &PyUnicodeUCS4_Join;}' unless defined(&PyUnicode_Join);
	    eval 'sub PyUnicode_Replace () { &PyUnicodeUCS4_Replace;}' unless defined(&PyUnicode_Replace);
	    eval 'sub PyUnicode_Resize () { &PyUnicodeUCS4_Resize;}' unless defined(&PyUnicode_Resize);
	    eval 'sub PyUnicode_SetDefaultEncoding () { &PyUnicodeUCS4_SetDefaultEncoding;}' unless defined(&PyUnicode_SetDefaultEncoding);
	    eval 'sub PyUnicode_Split () { &PyUnicodeUCS4_Split;}' unless defined(&PyUnicode_Split);
	    eval 'sub PyUnicode_Splitlines () { &PyUnicodeUCS4_Splitlines;}' unless defined(&PyUnicode_Splitlines);
	    eval 'sub PyUnicode_Tailmatch () { &PyUnicodeUCS4_Tailmatch;}' unless defined(&PyUnicode_Tailmatch);
	    eval 'sub PyUnicode_Translate () { &PyUnicodeUCS4_Translate;}' unless defined(&PyUnicode_Translate);
	    eval 'sub PyUnicode_TranslateCharmap () { &PyUnicodeUCS4_TranslateCharmap;}' unless defined(&PyUnicode_TranslateCharmap);
	    eval 'sub _PyUnicode_AsDefaultEncodedString () { &_PyUnicodeUCS4_AsDefaultEncodedString;}' unless defined(&_PyUnicode_AsDefaultEncodedString);
	    eval 'sub _PyUnicode_Fini () { &_PyUnicodeUCS4_Fini;}' unless defined(&_PyUnicode_Fini);
	    eval 'sub _PyUnicode_Init () { &_PyUnicodeUCS4_Init;}' unless defined(&_PyUnicode_Init);
	    eval 'sub _PyUnicode_IsAlpha () { &_PyUnicodeUCS4_IsAlpha;}' unless defined(&_PyUnicode_IsAlpha);
	    eval 'sub _PyUnicode_IsDecimalDigit () { &_PyUnicodeUCS4_IsDecimalDigit;}' unless defined(&_PyUnicode_IsDecimalDigit);
	    eval 'sub _PyUnicode_IsDigit () { &_PyUnicodeUCS4_IsDigit;}' unless defined(&_PyUnicode_IsDigit);
	    eval 'sub _PyUnicode_IsLinebreak () { &_PyUnicodeUCS4_IsLinebreak;}' unless defined(&_PyUnicode_IsLinebreak);
	    eval 'sub _PyUnicode_IsLowercase () { &_PyUnicodeUCS4_IsLowercase;}' unless defined(&_PyUnicode_IsLowercase);
	    eval 'sub _PyUnicode_IsNumeric () { &_PyUnicodeUCS4_IsNumeric;}' unless defined(&_PyUnicode_IsNumeric);
	    eval 'sub _PyUnicode_IsTitlecase () { &_PyUnicodeUCS4_IsTitlecase;}' unless defined(&_PyUnicode_IsTitlecase);
	    eval 'sub _PyUnicode_IsUppercase () { &_PyUnicodeUCS4_IsUppercase;}' unless defined(&_PyUnicode_IsUppercase);
	    eval 'sub _PyUnicode_IsWhitespace () { &_PyUnicodeUCS4_IsWhitespace;}' unless defined(&_PyUnicode_IsWhitespace);
	    eval 'sub _PyUnicode_ToDecimalDigit () { &_PyUnicodeUCS4_ToDecimalDigit;}' unless defined(&_PyUnicode_ToDecimalDigit);
	    eval 'sub _PyUnicode_ToDigit () { &_PyUnicodeUCS4_ToDigit;}' unless defined(&_PyUnicode_ToDigit);
	    eval 'sub _PyUnicode_ToLowercase () { &_PyUnicodeUCS4_ToLowercase;}' unless defined(&_PyUnicode_ToLowercase);
	    eval 'sub _PyUnicode_ToNumeric () { &_PyUnicodeUCS4_ToNumeric;}' unless defined(&_PyUnicode_ToNumeric);
	    eval 'sub _PyUnicode_ToTitlecase () { &_PyUnicodeUCS4_ToTitlecase;}' unless defined(&_PyUnicode_ToTitlecase);
	    eval 'sub _PyUnicode_ToUppercase () { &_PyUnicodeUCS4_ToUppercase;}' unless defined(&_PyUnicode_ToUppercase);
	}
	if(defined( &HAVE_USABLE_WCHAR_T)  && defined( &WANT_WCTYPE_FUNCTIONS)) {
	    require 'wctype.ph';
	    eval 'sub Py_UNICODE_ISSPACE {
	        my($ch) = @_;
    		eval q( &iswspace($ch));
	    }' unless defined(&Py_UNICODE_ISSPACE);
	    eval 'sub Py_UNICODE_ISLOWER {
	        my($ch) = @_;
    		eval q( &iswlower($ch));
	    }' unless defined(&Py_UNICODE_ISLOWER);
	    eval 'sub Py_UNICODE_ISUPPER {
	        my($ch) = @_;
    		eval q( &iswupper($ch));
	    }' unless defined(&Py_UNICODE_ISUPPER);
	    eval 'sub Py_UNICODE_ISTITLE {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsTitlecase($ch));
	    }' unless defined(&Py_UNICODE_ISTITLE);
	    eval 'sub Py_UNICODE_ISLINEBREAK {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsLinebreak($ch));
	    }' unless defined(&Py_UNICODE_ISLINEBREAK);
	    eval 'sub Py_UNICODE_TOLOWER {
	        my($ch) = @_;
    		eval q( &towlower($ch));
	    }' unless defined(&Py_UNICODE_TOLOWER);
	    eval 'sub Py_UNICODE_TOUPPER {
	        my($ch) = @_;
    		eval q( &towupper($ch));
	    }' unless defined(&Py_UNICODE_TOUPPER);
	    eval 'sub Py_UNICODE_TOTITLE {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToTitlecase($ch));
	    }' unless defined(&Py_UNICODE_TOTITLE);
	    eval 'sub Py_UNICODE_ISDECIMAL {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsDecimalDigit($ch));
	    }' unless defined(&Py_UNICODE_ISDECIMAL);
	    eval 'sub Py_UNICODE_ISDIGIT {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsDigit($ch));
	    }' unless defined(&Py_UNICODE_ISDIGIT);
	    eval 'sub Py_UNICODE_ISNUMERIC {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsNumeric($ch));
	    }' unless defined(&Py_UNICODE_ISNUMERIC);
	    eval 'sub Py_UNICODE_TODECIMAL {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToDecimalDigit($ch));
	    }' unless defined(&Py_UNICODE_TODECIMAL);
	    eval 'sub Py_UNICODE_TODIGIT {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToDigit($ch));
	    }' unless defined(&Py_UNICODE_TODIGIT);
	    eval 'sub Py_UNICODE_TONUMERIC {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToNumeric($ch));
	    }' unless defined(&Py_UNICODE_TONUMERIC);
	    eval 'sub Py_UNICODE_ISALPHA {
	        my($ch) = @_;
    		eval q( &iswalpha($ch));
	    }' unless defined(&Py_UNICODE_ISALPHA);
	} else {
	    eval 'sub Py_UNICODE_ISSPACE {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsWhitespace($ch));
	    }' unless defined(&Py_UNICODE_ISSPACE);
	    eval 'sub Py_UNICODE_ISLOWER {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsLowercase($ch));
	    }' unless defined(&Py_UNICODE_ISLOWER);
	    eval 'sub Py_UNICODE_ISUPPER {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsUppercase($ch));
	    }' unless defined(&Py_UNICODE_ISUPPER);
	    eval 'sub Py_UNICODE_ISTITLE {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsTitlecase($ch));
	    }' unless defined(&Py_UNICODE_ISTITLE);
	    eval 'sub Py_UNICODE_ISLINEBREAK {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsLinebreak($ch));
	    }' unless defined(&Py_UNICODE_ISLINEBREAK);
	    eval 'sub Py_UNICODE_TOLOWER {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToLowercase($ch));
	    }' unless defined(&Py_UNICODE_TOLOWER);
	    eval 'sub Py_UNICODE_TOUPPER {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToUppercase($ch));
	    }' unless defined(&Py_UNICODE_TOUPPER);
	    eval 'sub Py_UNICODE_TOTITLE {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToTitlecase($ch));
	    }' unless defined(&Py_UNICODE_TOTITLE);
	    eval 'sub Py_UNICODE_ISDECIMAL {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsDecimalDigit($ch));
	    }' unless defined(&Py_UNICODE_ISDECIMAL);
	    eval 'sub Py_UNICODE_ISDIGIT {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsDigit($ch));
	    }' unless defined(&Py_UNICODE_ISDIGIT);
	    eval 'sub Py_UNICODE_ISNUMERIC {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsNumeric($ch));
	    }' unless defined(&Py_UNICODE_ISNUMERIC);
	    eval 'sub Py_UNICODE_TODECIMAL {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToDecimalDigit($ch));
	    }' unless defined(&Py_UNICODE_TODECIMAL);
	    eval 'sub Py_UNICODE_TODIGIT {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToDigit($ch));
	    }' unless defined(&Py_UNICODE_TODIGIT);
	    eval 'sub Py_UNICODE_TONUMERIC {
	        my($ch) = @_;
    		eval q( &_PyUnicode_ToNumeric($ch));
	    }' unless defined(&Py_UNICODE_TONUMERIC);
	    eval 'sub Py_UNICODE_ISALPHA {
	        my($ch) = @_;
    		eval q( &_PyUnicode_IsAlpha($ch));
	    }' unless defined(&Py_UNICODE_ISALPHA);
	}
	eval 'sub Py_UNICODE_ISALNUM {
	    my($ch) = @_;
    	    eval q(( &Py_UNICODE_ISALPHA($ch) ||  &Py_UNICODE_ISDECIMAL($ch) ||  &Py_UNICODE_ISDIGIT($ch) ||  &Py_UNICODE_ISNUMERIC($ch)));
	}' unless defined(&Py_UNICODE_ISALNUM);
	eval 'sub Py_UNICODE_COPY {
	    my($target, $source, $length) = @_;
    	    eval q(( &memcpy(($target), ($source), ($length)*$sizeof{ &Py_UNICODE})));
	}' unless defined(&Py_UNICODE_COPY);
	eval 'sub Py_UNICODE_FILL {
	    my($target, $value, $length) = @_;
    	    eval q( &do {\'int\'  &i;  &for ( &i = 0;  &i < ($length);  &i++) ($target)[ &i] = ($value);}  &while (0));
	}' unless defined(&Py_UNICODE_FILL);
	eval 'sub Py_UNICODE_MATCH {
	    my($string, $offset, $substring) = @_;
    	    eval q(((*(($string)-> &str + ($offset)) == *(($substring)-> &str))  && ! &memcmp(($string)-> &str + ($offset), ($substring)-> &str, ($substring)-> &length*$sizeof{ &Py_UNICODE})));
	}' unless defined(&Py_UNICODE_MATCH);
	if(defined(&__cplusplus)) {
	}
	eval 'sub PyUnicode_Check {
	    my($op) = @_;
    	    eval q( &PyObject_TypeCheck($op,  &PyUnicode_Type));
	}' unless defined(&PyUnicode_Check);
	eval 'sub PyUnicode_CheckExact {
	    my($op) = @_;
    	    eval q((($op)-> &ob_type ==  &PyUnicode_Type));
	}' unless defined(&PyUnicode_CheckExact);
	eval 'sub PyUnicode_GET_SIZE {
	    my($op) = @_;
    	    eval q(((( &PyUnicodeObject *)($op))-> &length));
	}' unless defined(&PyUnicode_GET_SIZE);
	eval 'sub PyUnicode_GET_DATA_SIZE {
	    my($op) = @_;
    	    eval q(((( &PyUnicodeObject *)($op))-> &length * $sizeof{ &Py_UNICODE}));
	}' unless defined(&PyUnicode_GET_DATA_SIZE);
	eval 'sub PyUnicode_AS_UNICODE {
	    my($op) = @_;
    	    eval q(((( &PyUnicodeObject *)($op))-> &str));
	}' unless defined(&PyUnicode_AS_UNICODE);
	eval 'sub PyUnicode_AS_DATA {
	    my($op) = @_;
    	    eval q((( &const \'char\' *)(( &PyUnicodeObject *)($op))-> &str));
	}' unless defined(&PyUnicode_AS_DATA);
	eval 'sub Py_UNICODE_REPLACEMENT_CHARACTER () {(( &Py_UNICODE) 0xfffd);}' unless defined(&Py_UNICODE_REPLACEMENT_CHARACTER);
	if(defined(&HAVE_WCHAR_H)) {
	}
	if(defined(&MS_WIN32)) {
	}
	if(defined(&__cplusplus)) {
	}
    }
}
1;
