require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&DAVIS_SLANG_H_)) {
    eval 'sub DAVIS_SLANG_H_ () {1;}' unless defined(&DAVIS_SLANG_H_);
    eval 'sub SLANG_VERSION () {10405;}' unless defined(&SLANG_VERSION);
    eval 'sub SLANG_VERSION_STRING () {"1.4.5";}' unless defined(&SLANG_VERSION_STRING);
    if(defined( &__WATCOMC__)  && defined( &DOS)) {
	unless(defined(&__MSDOS__)) {
	    eval 'sub __MSDOS__ () {1;}' unless defined(&__MSDOS__);
	}
	unless(defined(&DOS386)) {
	    eval 'sub DOS386 () {1;}' unless defined(&DOS386);
	}
	unless(defined(&IBMPC_SYSTEM)) {
	    eval 'sub IBMPC_SYSTEM () {1;}' unless defined(&IBMPC_SYSTEM);
	}
    }
    if(defined( &unix) || defined( &__unix)) {
	unless(defined(&__unix__)) {
	    eval 'sub __unix__ () {1;}' unless defined(&__unix__);
	}
    }
    if(!defined( &__GO32__)) {
	if(defined(&__unix__)) {
	    eval 'sub REAL_UNIX_SYSTEM () {1;}' unless defined(&REAL_UNIX_SYSTEM);
	}
    }
    if(defined(&__GO32__)) {
	unless(defined(&__DJGPP__)) {
	    eval 'sub __DJGPP__ () {1;}' unless defined(&__DJGPP__);
	}
	unless(defined(&IBMPC_SYSTEM)) {
	    eval 'sub IBMPC_SYSTEM () {1;}' unless defined(&IBMPC_SYSTEM);
	}
    }
    if(defined(&__BORLANDC__)) {
	unless(defined(&IBMPC_SYSTEM)) {
	    eval 'sub IBMPC_SYSTEM () {1;}' unless defined(&IBMPC_SYSTEM);
	}
    }
    if(defined(&__MSDOS__)) {
	unless(defined(&IBMPC_SYSTEM)) {
	    eval 'sub IBMPC_SYSTEM () {1;}' unless defined(&IBMPC_SYSTEM);
	}
    }
    if(defined( &OS2) || defined( &__os2__)) {
	unless(defined(&IBMPC_SYSTEM)) {
	    eval 'sub IBMPC_SYSTEM () {1;}' unless defined(&IBMPC_SYSTEM);
	}
	unless(defined(&__os2__)) {
	    eval 'sub __os2__ () {1;}' unless defined(&__os2__);
	}
    }
    if(defined( &__NT__) || defined( &__MINGW32__) ) {
	unless(defined(&IBMPC_SYSTEM)) {
	    eval 'sub IBMPC_SYSTEM () {1;}' unless defined(&IBMPC_SYSTEM);
	}
    }
    if(defined( &IBMPC_SYSTEM) || defined( &VMS)) {
	if(defined(&REAL_UNIX_SYSTEM)) {
	    undef(&REAL_UNIX_SYSTEM) if defined(&REAL_UNIX_SYSTEM);
	}
    }
    if(defined(&__cplusplus)) {
    }
    if(0) {
    }
    require 'stdio.ph';
    require 'stdarg.ph';
    if(defined( &__STDC__) || defined( &__BORLANDC__) || defined( &__cplusplus)) {
	require 'stddef.ph';
    }
    if(defined( &__SC__)  && !defined( &DOS386)) {
	require 'dos.ph';
    }
    if(defined( &__BORLANDC__)) {
	require 'alloc.ph';
    }
    if(defined ( &__cplusplus) || defined( &__STDC__) || defined( &IBMPC_SYSTEM)) {
    } else {
    }
    if(defined( &__MSDOS__)  && defined( &__BORLANDC__)) {
	eval 'sub SLFREE {
	    my($buf) = @_;
    	    eval q( &farfree(( &void  &far *)($buf)));
	}' unless defined(&SLFREE);
	eval 'sub SLMALLOC {
	    my($x) = @_;
    	    eval q( &farmalloc( ($x)));
	}' unless defined(&SLMALLOC);
	eval 'sub SLREALLOC {
	    my($buf, $n) = @_;
    	    eval q( &farrealloc(( &void  &far *) , ($n)));
	}' unless defined(&SLREALLOC);
	eval 'sub SLCALLOC {
	    my($n, $m) = @_;
    	    eval q( &farcalloc( , ($m)));
	}' unless defined(&SLCALLOC);
    } else {
	if(defined( &VMS)  && !defined( &__DECC)) {
	    eval 'sub SLFREE () { &VAXC$ &FREE_OPT;}' unless defined(&SLFREE);
	    eval 'sub SLMALLOC () { &VAXC$ &MALLOC_OPT;}' unless defined(&SLMALLOC);
	    eval 'sub SLREALLOC () { &VAXC$ &REALLOC_OPT;}' unless defined(&SLREALLOC);
	    eval 'sub SLCALLOC () { &VAXC$ &CALLOC_OPT;}' unless defined(&SLCALLOC);
	} else {
	    eval 'sub SLFREE {
	        my($x) = @_;
    		eval q( &free(($x)));
	    }' unless defined(&SLFREE);
	    eval 'sub SLMALLOC () { &malloc;}' unless defined(&SLMALLOC);
	    eval 'sub SLREALLOC () { &realloc;}' unless defined(&SLREALLOC);
	    eval 'sub SLCALLOC () { &calloc;}' unless defined(&SLCALLOC);
	}
    }
    eval 'sub SLANG_LVARIABLE () {0x1;}' unless defined(&SLANG_LVARIABLE);
    eval 'sub SLANG_GVARIABLE () {0x2;}' unless defined(&SLANG_GVARIABLE);
    eval 'sub SLANG_IVARIABLE () {0x3;}' unless defined(&SLANG_IVARIABLE);
    eval 'sub SLANG_RVARIABLE () {0x4;}' unless defined(&SLANG_RVARIABLE);
    eval 'sub SLANG_INTRINSIC () {0x5;}' unless defined(&SLANG_INTRINSIC);
    eval 'sub SLANG_FUNCTION () {0x6;}' unless defined(&SLANG_FUNCTION);
    eval 'sub SLANG_MATH_UNARY () {0x7;}' unless defined(&SLANG_MATH_UNARY);
    eval 'sub SLANG_APP_UNARY () {0x8;}' unless defined(&SLANG_APP_UNARY);
    eval 'sub SLANG_ICONSTANT () {0x9;}' unless defined(&SLANG_ICONSTANT);
    eval 'sub SLANG_DCONSTANT () {0xa;}' unless defined(&SLANG_DCONSTANT);
    eval 'sub SLANG_PVARIABLE () {0xb;}' unless defined(&SLANG_PVARIABLE);
    eval 'sub SLANG_PFUNCTION () {0xc;}' unless defined(&SLANG_PFUNCTION);
    eval 'sub SLANG_MAX_INTRIN_ARGS () {7;}' unless defined(&SLANG_MAX_INTRIN_ARGS);
    if(defined( &ultrix)  && !defined( &__GNUC__)) {
	unless(defined(&NO_PROTOTYPES)) {
	    eval 'sub NO_PROTOTYPES () {1;}' unless defined(&NO_PROTOTYPES);
	}
    }
    unless(defined(&NO_PROTOTYPES)) {
	eval 'sub _PROTO {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&_PROTO);
    } else {
	eval 'sub _PROTO {
	    my($x) = @_;
    	    eval q(());
	}' unless defined(&_PROTO);
    }
    if(0) {
	if(defined( &SL_APP_WANTS_FOREACH)) {
	} else {
	}
    }
    eval 'sub SLANG_CLASS_TYPE_MMT () {0;}' unless defined(&SLANG_CLASS_TYPE_MMT);
    eval 'sub SLANG_CLASS_TYPE_SCALAR () {1;}' unless defined(&SLANG_CLASS_TYPE_SCALAR);
    eval 'sub SLANG_CLASS_TYPE_VECTOR () {2;}' unless defined(&SLANG_CLASS_TYPE_VECTOR);
    eval 'sub SLANG_CLASS_TYPE_PTR () {3;}' unless defined(&SLANG_CLASS_TYPE_PTR);
    eval 'sub SLMATH_SIN () {1;}' unless defined(&SLMATH_SIN);
    eval 'sub SLMATH_COS () {2;}' unless defined(&SLMATH_COS);
    eval 'sub SLMATH_TAN () {3;}' unless defined(&SLMATH_TAN);
    eval 'sub SLMATH_ATAN () {4;}' unless defined(&SLMATH_ATAN);
    eval 'sub SLMATH_ASIN () {5;}' unless defined(&SLMATH_ASIN);
    eval 'sub SLMATH_ACOS () {6;}' unless defined(&SLMATH_ACOS);
    eval 'sub SLMATH_EXP () {7;}' unless defined(&SLMATH_EXP);
    eval 'sub SLMATH_LOG () {8;}' unless defined(&SLMATH_LOG);
    eval 'sub SLMATH_SQRT () {9;}' unless defined(&SLMATH_SQRT);
    eval 'sub SLMATH_LOG10 () {10;}' unless defined(&SLMATH_LOG10);
    eval 'sub SLMATH_REAL () {11;}' unless defined(&SLMATH_REAL);
    eval 'sub SLMATH_IMAG () {12;}' unless defined(&SLMATH_IMAG);
    eval 'sub SLMATH_SINH () {13;}' unless defined(&SLMATH_SINH);
    eval 'sub SLMATH_COSH () {14;}' unless defined(&SLMATH_COSH);
    eval 'sub SLMATH_TANH () {15;}' unless defined(&SLMATH_TANH);
    eval 'sub SLMATH_ATANH () {16;}' unless defined(&SLMATH_ATANH);
    eval 'sub SLMATH_ASINH () {17;}' unless defined(&SLMATH_ASINH);
    eval 'sub SLMATH_ACOSH () {18;}' unless defined(&SLMATH_ACOSH);
    eval 'sub SLMATH_TODOUBLE () {19;}' unless defined(&SLMATH_TODOUBLE);
    eval 'sub SLMATH_CONJ () {20;}' unless defined(&SLMATH_CONJ);
    if(defined(&_SLANG_SOURCE_)) {
    } else {
    }
    eval 'sub SLARRAY_MAX_DIMS () {7;}' unless defined(&SLARRAY_MAX_DIMS);
    eval 'sub SLARR_DATA_VALUE_IS_READ_ONLY () {1;}' unless defined(&SLARR_DATA_VALUE_IS_READ_ONLY);
    eval 'sub SLARR_DATA_VALUE_IS_POINTER () {2;}' unless defined(&SLARR_DATA_VALUE_IS_POINTER);
    eval 'sub SLARR_DATA_VALUE_IS_RANGE () {4;}' unless defined(&SLARR_DATA_VALUE_IS_RANGE);
    eval 'sub SLARR_DATA_VALUE_IS_INTRINSIC () {8;}' unless defined(&SLARR_DATA_VALUE_IS_INTRINSIC);
    eval 'sub SL_APPLICATION_ERROR () {-2;}' unless defined(&SL_APPLICATION_ERROR);
    eval 'sub SL_VARIABLE_UNINITIALIZED () {-3;}' unless defined(&SL_VARIABLE_UNINITIALIZED);
    eval 'sub SL_INTERNAL_ERROR () {-5;}' unless defined(&SL_INTERNAL_ERROR);
    eval 'sub SL_STACK_OVERFLOW () {-6;}' unless defined(&SL_STACK_OVERFLOW);
    eval 'sub SL_STACK_UNDERFLOW () {-7;}' unless defined(&SL_STACK_UNDERFLOW);
    eval 'sub SL_UNDEFINED_NAME () {-8;}' unless defined(&SL_UNDEFINED_NAME);
    eval 'sub SL_SYNTAX_ERROR () {-9;}' unless defined(&SL_SYNTAX_ERROR);
    eval 'sub SL_DUPLICATE_DEFINITION () {-10;}' unless defined(&SL_DUPLICATE_DEFINITION);
    eval 'sub SL_TYPE_MISMATCH () {-11;}' unless defined(&SL_TYPE_MISMATCH);
    eval 'sub SL_OBJ_UNKNOWN () {-13;}' unless defined(&SL_OBJ_UNKNOWN);
    eval 'sub SL_UNKNOWN_ERROR () {-14;}' unless defined(&SL_UNKNOWN_ERROR);
    eval 'sub SL_TYPE_UNDEFINED_OP_ERROR () {-16;}' unless defined(&SL_TYPE_UNDEFINED_OP_ERROR);
    eval 'sub SL_INTRINSIC_ERROR () {1;}' unless defined(&SL_INTRINSIC_ERROR);
    eval 'sub SL_USER_BREAK () {2;}' unless defined(&SL_USER_BREAK);
    eval 'sub SL_DIVIDE_ERROR () {3;}' unless defined(&SL_DIVIDE_ERROR);
    eval 'sub SL_OBJ_NOPEN () {4;}' unless defined(&SL_OBJ_NOPEN);
    eval 'sub SL_USER_ERROR () {5;}' unless defined(&SL_USER_ERROR);
    eval 'sub SL_USAGE_ERROR () {6;}' unless defined(&SL_USAGE_ERROR);
    eval 'sub SL_READONLY_ERROR () {7;}' unless defined(&SL_READONLY_ERROR);
    eval 'sub SL_INVALID_PARM () {8;}' unless defined(&SL_INVALID_PARM);
    eval 'sub SL_NOT_IMPLEMENTED () {9;}' unless defined(&SL_NOT_IMPLEMENTED);
    eval 'sub SL_MALLOC_ERROR () {10;}' unless defined(&SL_MALLOC_ERROR);
    eval 'sub SL_OVERFLOW () {11;}' unless defined(&SL_OVERFLOW);
    eval 'sub SL_FLOATING_EXCEPTION () {12;}' unless defined(&SL_FLOATING_EXCEPTION);
    eval 'sub USER_BREAK () { &SL_USER_BREAK;}' unless defined(&USER_BREAK);
    eval 'sub INTRINSIC_ERROR () { &SL_INTRINSIC_ERROR;}' unless defined(&INTRINSIC_ERROR);
    if(defined(&_SLANG_SOURCE_)) {
    } else {
    }
    if(defined(&REAL_UNIX_SYSTEM)) {
    }
    if(defined(&REAL_UNIX_SYSTEM)) {
    }
    eval 'sub SLANG_GETKEY_ERROR () {0xffff;}' unless defined(&SLANG_GETKEY_ERROR);
    if(defined(&IBMPC_SYSTEM)) {
    }
    if(defined(&VMS)) {
    }
    eval 'sub SLANG_MAX_KEYMAP_KEY_SEQ () {14;}' unless defined(&SLANG_MAX_KEYMAP_KEY_SEQ);
    eval 'sub SLKEY_F_INTERPRET () {0x1;}' unless defined(&SLKEY_F_INTERPRET);
    eval 'sub SLKEY_F_INTRINSIC () {0x2;}' unless defined(&SLKEY_F_INTRINSIC);
    eval 'sub SLKEY_F_KEYSYM () {0x3;}' unless defined(&SLKEY_F_KEYSYM);
    eval 'sub SLANG_MAX_KEYMAPS () {30;}' unless defined(&SLANG_MAX_KEYMAPS);
    eval 'sub SLRL_DISPLAY_BUFFER_SIZE () {256;}' unless defined(&SLRL_DISPLAY_BUFFER_SIZE);
    eval 'sub SL_RLINE_NO_ECHO () {1;}' unless defined(&SL_RLINE_NO_ECHO);
    eval 'sub SL_RLINE_USE_ANSI () {2;}' unless defined(&SL_RLINE_USE_ANSI);
    eval 'sub SL_RLINE_BLINK_MATCH () {4;}' unless defined(&SL_RLINE_BLINK_MATCH);
    eval 'sub SLTT_BOLD_MASK () {0x1000000;}' unless defined(&SLTT_BOLD_MASK);
    eval 'sub SLTT_BLINK_MASK () {0x2000000;}' unless defined(&SLTT_BLINK_MASK);
    eval 'sub SLTT_ULINE_MASK () {0x4000000;}' unless defined(&SLTT_ULINE_MASK);
    eval 'sub SLTT_REV_MASK () {0x8000000;}' unless defined(&SLTT_REV_MASK);
    eval 'sub SLTT_ALTC_MASK () {0x10000000;}' unless defined(&SLTT_ALTC_MASK);
    if(defined( &REAL_UNIX_SYSTEM)) {
    }
    unless(defined(&IBMPC_SYSTEM)) {
    }
    unless(defined(&__GO32__)) {
	if(defined( &VMS) || defined( &REAL_UNIX_SYSTEM)) {
	    unless(defined(&VMS)) {
	    }
	}
    }
    if(defined( &IBMPC_SYSTEM)) {
    }
    eval 'sub UTF8 () {1;}' unless defined(&UTF8);
    if(defined(&UTF8)) {
	eval 'sub acs_map () { &SLcurses_Acs_Map;}' unless defined(&acs_map);
	eval 'sub SLSMG_EXTRACT_CHAR {
	    my($x) = @_;
    	    eval q((($x) & 0xffffff));
	}' unless defined(&SLSMG_EXTRACT_CHAR);
	eval 'sub SLSMG_EXTRACT_COLOR {
	    my($x) = @_;
    	    eval q(((($x)>>24)&0xff));
	}' unless defined(&SLSMG_EXTRACT_COLOR);
	eval 'sub SLSMG_BUILD_CHAR {
	    my($ch,$color) = @_;
    	    eval q(((( &SLsmg_Char_Type)( &wchar_t)($ch))|(($color)<<24)));
	}' unless defined(&SLSMG_BUILD_CHAR);
	eval 'sub SLSMG_NOCHAR () {1;}' unless defined(&SLSMG_NOCHAR);
    } else {
	eval 'sub SLSMG_EXTRACT_CHAR {
	    my($x) = @_;
    	    eval q((($x) & 0xff));
	}' unless defined(&SLSMG_EXTRACT_CHAR);
	eval 'sub SLSMG_EXTRACT_COLOR {
	    my($x) = @_;
    	    eval q(((($x)>>8)&0xff));
	}' unless defined(&SLSMG_EXTRACT_COLOR);
	eval 'sub SLSMG_BUILD_CHAR {
	    my($ch,$color) = @_;
    	    eval q(((( &SLsmg_Char_Type)($ch))|(($color)<<8)));
	}' unless defined(&SLSMG_BUILD_CHAR);
    }
    if(defined( &VMS) || defined( &REAL_UNIX_SYSTEM)) {
	if(defined(&REAL_UNIX_SYSTEM)) {
	}
    }
    eval 'sub SLPREP_BLANK_LINES_OK () {1;}' unless defined(&SLPREP_BLANK_LINES_OK);
    eval 'sub SLPREP_COMMENT_LINES_OK () {2;}' unless defined(&SLPREP_COMMENT_LINES_OK);
    if(defined(&UTF8)) {
    } else {
    }
    unless(defined(&IBMPC_SYSTEM)) {
    }
    if(defined(&UTF8)) {
    } else {
    }
    if(defined(&UTF8)) {
    } else {
    }
    eval 'sub SLSMG_NEWLINE_IGNORED () {0;}' unless defined(&SLSMG_NEWLINE_IGNORED);
    eval 'sub SLSMG_NEWLINE_MOVES () {1;}' unless defined(&SLSMG_NEWLINE_MOVES);
    eval 'sub SLSMG_NEWLINE_SCROLLS () {2;}' unless defined(&SLSMG_NEWLINE_SCROLLS);
    eval 'sub SLSMG_NEWLINE_PRINTABLE () {3;}' unless defined(&SLSMG_NEWLINE_PRINTABLE);
    if(defined(&IBMPC_SYSTEM)) {
	eval 'sub SLSMG_HLINE_CHAR () {0xc4;}' unless defined(&SLSMG_HLINE_CHAR);
	eval 'sub SLSMG_VLINE_CHAR () {0xb3;}' unless defined(&SLSMG_VLINE_CHAR);
	eval 'sub SLSMG_ULCORN_CHAR () {0xda;}' unless defined(&SLSMG_ULCORN_CHAR);
	eval 'sub SLSMG_URCORN_CHAR () {0xbf;}' unless defined(&SLSMG_URCORN_CHAR);
	eval 'sub SLSMG_LLCORN_CHAR () {0xc0;}' unless defined(&SLSMG_LLCORN_CHAR);
	eval 'sub SLSMG_LRCORN_CHAR () {0xd9;}' unless defined(&SLSMG_LRCORN_CHAR);
	eval 'sub SLSMG_RTEE_CHAR () {0xb4;}' unless defined(&SLSMG_RTEE_CHAR);
	eval 'sub SLSMG_LTEE_CHAR () {0xc3;}' unless defined(&SLSMG_LTEE_CHAR);
	eval 'sub SLSMG_UTEE_CHAR () {0xc2;}' unless defined(&SLSMG_UTEE_CHAR);
	eval 'sub SLSMG_DTEE_CHAR () {0xc1;}' unless defined(&SLSMG_DTEE_CHAR);
	eval 'sub SLSMG_PLUS_CHAR () {0xc5;}' unless defined(&SLSMG_PLUS_CHAR);
	eval 'sub SLSMG_CKBRD_CHAR () {0xb0;}' unless defined(&SLSMG_CKBRD_CHAR);
	eval 'sub SLSMG_DIAMOND_CHAR () {0x4;}' unless defined(&SLSMG_DIAMOND_CHAR);
	eval 'sub SLSMG_DEGREE_CHAR () {0xf8;}' unless defined(&SLSMG_DEGREE_CHAR);
	eval 'sub SLSMG_PLMINUS_CHAR () {0xf1;}' unless defined(&SLSMG_PLMINUS_CHAR);
	eval 'sub SLSMG_BULLET_CHAR () {0xf9;}' unless defined(&SLSMG_BULLET_CHAR);
	eval 'sub SLSMG_LARROW_CHAR () {0x1b;}' unless defined(&SLSMG_LARROW_CHAR);
	eval 'sub SLSMG_RARROW_CHAR () {0x1a;}' unless defined(&SLSMG_RARROW_CHAR);
	eval 'sub SLSMG_DARROW_CHAR () {0x19;}' unless defined(&SLSMG_DARROW_CHAR);
	eval 'sub SLSMG_UARROW_CHAR () {0x18;}' unless defined(&SLSMG_UARROW_CHAR);
	eval 'sub SLSMG_BOARD_CHAR () {0xb2;}' unless defined(&SLSMG_BOARD_CHAR);
	eval 'sub SLSMG_BLOCK_CHAR () {0xdb;}' unless defined(&SLSMG_BLOCK_CHAR);
    } else {
	if(defined( &AMIGA)) {
	    eval 'sub SLSMG_HLINE_CHAR () {ord(\'-\');}' unless defined(&SLSMG_HLINE_CHAR);
	    eval 'sub SLSMG_VLINE_CHAR () {ord(\'|\');}' unless defined(&SLSMG_VLINE_CHAR);
	    eval 'sub SLSMG_ULCORN_CHAR () {ord(\'+\');}' unless defined(&SLSMG_ULCORN_CHAR);
	    eval 'sub SLSMG_URCORN_CHAR () {ord(\'+\');}' unless defined(&SLSMG_URCORN_CHAR);
	    eval 'sub SLSMG_LLCORN_CHAR () {ord(\'+\');}' unless defined(&SLSMG_LLCORN_CHAR);
	    eval 'sub SLSMG_LRCORN_CHAR () {ord(\'+\');}' unless defined(&SLSMG_LRCORN_CHAR);
	    eval 'sub SLSMG_CKBRD_CHAR () {ord(\'#\');}' unless defined(&SLSMG_CKBRD_CHAR);
	    eval 'sub SLSMG_RTEE_CHAR () {ord(\'+\');}' unless defined(&SLSMG_RTEE_CHAR);
	    eval 'sub SLSMG_LTEE_CHAR () {ord(\'+\');}' unless defined(&SLSMG_LTEE_CHAR);
	    eval 'sub SLSMG_UTEE_CHAR () {ord(\'+\');}' unless defined(&SLSMG_UTEE_CHAR);
	    eval 'sub SLSMG_DTEE_CHAR () {ord(\'+\');}' unless defined(&SLSMG_DTEE_CHAR);
	    eval 'sub SLSMG_PLUS_CHAR () {ord(\'+\');}' unless defined(&SLSMG_PLUS_CHAR);
	    eval 'sub SLSMG_DIAMOND_CHAR () {ord(\'+\');}' unless defined(&SLSMG_DIAMOND_CHAR);
	    eval 'sub SLSMG_DEGREE_CHAR () {ord(\'\\\\\');}' unless defined(&SLSMG_DEGREE_CHAR);
	    eval 'sub SLSMG_PLMINUS_CHAR () {ord(\'#\');}' unless defined(&SLSMG_PLMINUS_CHAR);
	    eval 'sub SLSMG_BULLET_CHAR () {ord(\'o\');}' unless defined(&SLSMG_BULLET_CHAR);
	    eval 'sub SLSMG_LARROW_CHAR () {ord(\'<\');}' unless defined(&SLSMG_LARROW_CHAR);
	    eval 'sub SLSMG_RARROW_CHAR () {ord(\'>\');}' unless defined(&SLSMG_RARROW_CHAR);
	    eval 'sub SLSMG_DARROW_CHAR () {ord(\'v\');}' unless defined(&SLSMG_DARROW_CHAR);
	    eval 'sub SLSMG_UARROW_CHAR () {ord(\'^\');}' unless defined(&SLSMG_UARROW_CHAR);
	    eval 'sub SLSMG_BOARD_CHAR () {ord(\'#\');}' unless defined(&SLSMG_BOARD_CHAR);
	    eval 'sub SLSMG_BLOCK_CHAR () {ord(\'#\');}' unless defined(&SLSMG_BLOCK_CHAR);
	} else {
	    eval 'sub SLSMG_HLINE_CHAR () {( $acs_map[ord(\'q\')]);}' unless defined(&SLSMG_HLINE_CHAR);
	    eval 'sub SLSMG_VLINE_CHAR () {( $acs_map[ord(\'x\')]);}' unless defined(&SLSMG_VLINE_CHAR);
	    eval 'sub SLSMG_ULCORN_CHAR () {( $acs_map[ord(\'l\')]);}' unless defined(&SLSMG_ULCORN_CHAR);
	    eval 'sub SLSMG_URCORN_CHAR () {( $acs_map[ord(\'k\')]);}' unless defined(&SLSMG_URCORN_CHAR);
	    eval 'sub SLSMG_LLCORN_CHAR () {( $acs_map[ord(\'m\')]);}' unless defined(&SLSMG_LLCORN_CHAR);
	    eval 'sub SLSMG_LRCORN_CHAR () {( $acs_map[ord(\'j\')]);}' unless defined(&SLSMG_LRCORN_CHAR);
	    eval 'sub SLSMG_CKBRD_CHAR () {( $acs_map[ord(\'a\')]);}' unless defined(&SLSMG_CKBRD_CHAR);
	    eval 'sub SLSMG_RTEE_CHAR () {( $acs_map[ord(\'u\')]);}' unless defined(&SLSMG_RTEE_CHAR);
	    eval 'sub SLSMG_LTEE_CHAR () {( $acs_map[ord(\'t\')]);}' unless defined(&SLSMG_LTEE_CHAR);
	    eval 'sub SLSMG_UTEE_CHAR () {( $acs_map[ord(\'v\')]);}' unless defined(&SLSMG_UTEE_CHAR);
	    eval 'sub SLSMG_DTEE_CHAR () {( $acs_map[ord(\'w\')]);}' unless defined(&SLSMG_DTEE_CHAR);
	    eval 'sub SLSMG_PLUS_CHAR () {( $acs_map[ord(\'n\')]);}' unless defined(&SLSMG_PLUS_CHAR);
	    eval 'sub SLSMG_DIAMOND_CHAR () {( $acs_map[ord(\'`\')]);}' unless defined(&SLSMG_DIAMOND_CHAR);
	    eval 'sub SLSMG_DEGREE_CHAR () {( $acs_map[ord(\'f\')]);}' unless defined(&SLSMG_DEGREE_CHAR);
	    eval 'sub SLSMG_PLMINUS_CHAR () {( $acs_map[ord(\'g\')]);}' unless defined(&SLSMG_PLMINUS_CHAR);
	    eval 'sub SLSMG_BULLET_CHAR () {( $acs_map[ord(\'~\')]);}' unless defined(&SLSMG_BULLET_CHAR);
	    eval 'sub SLSMG_LARROW_CHAR () {( $acs_map[ord(\',\')]);}' unless defined(&SLSMG_LARROW_CHAR);
	    eval 'sub SLSMG_RARROW_CHAR () {( $acs_map[ord(\'+\')]);}' unless defined(&SLSMG_RARROW_CHAR);
	    eval 'sub SLSMG_DARROW_CHAR () {( $acs_map[ord(\'.\')]);}' unless defined(&SLSMG_DARROW_CHAR);
	    eval 'sub SLSMG_UARROW_CHAR () {( $acs_map[ord(\'-\')]);}' unless defined(&SLSMG_UARROW_CHAR);
	    eval 'sub SLSMG_BOARD_CHAR () {( $acs_map[ord(\'h\')]);}' unless defined(&SLSMG_BOARD_CHAR);
	    eval 'sub SLSMG_BLOCK_CHAR () {( $acs_map[ord(\'0\')]);}' unless defined(&SLSMG_BLOCK_CHAR);
	    eval 'sub SLSMG_HLINE_CHAR_TERM () {ord(\'q\');}' unless defined(&SLSMG_HLINE_CHAR_TERM);
	    eval 'sub SLSMG_VLINE_CHAR_TERM () {ord(\'x\');}' unless defined(&SLSMG_VLINE_CHAR_TERM);
	    eval 'sub SLSMG_ULCORN_CHAR_TERM () {ord(\'l\');}' unless defined(&SLSMG_ULCORN_CHAR_TERM);
	    eval 'sub SLSMG_URCORN_CHAR_TERM () {ord(\'k\');}' unless defined(&SLSMG_URCORN_CHAR_TERM);
	    eval 'sub SLSMG_LLCORN_CHAR_TERM () {ord(\'m\');}' unless defined(&SLSMG_LLCORN_CHAR_TERM);
	    eval 'sub SLSMG_LRCORN_CHAR_TERM () {ord(\'j\');}' unless defined(&SLSMG_LRCORN_CHAR_TERM);
	    eval 'sub SLSMG_CKBRD_CHAR_TERM () {ord(\'a\');}' unless defined(&SLSMG_CKBRD_CHAR_TERM);
	    eval 'sub SLSMG_RTEE_CHAR_TERM () {ord(\'u\');}' unless defined(&SLSMG_RTEE_CHAR_TERM);
	    eval 'sub SLSMG_LTEE_CHAR_TERM () {ord(\'t\');}' unless defined(&SLSMG_LTEE_CHAR_TERM);
	    eval 'sub SLSMG_UTEE_CHAR_TERM () {ord(\'v\');}' unless defined(&SLSMG_UTEE_CHAR_TERM);
	    eval 'sub SLSMG_DTEE_CHAR_TERM () {ord(\'w\');}' unless defined(&SLSMG_DTEE_CHAR_TERM);
	    eval 'sub SLSMG_PLUS_CHAR_TERM () {ord(\'n\');}' unless defined(&SLSMG_PLUS_CHAR_TERM);
	    eval 'sub SLSMG_DIAMOND_CHAR_TERM () {ord(\'`\');}' unless defined(&SLSMG_DIAMOND_CHAR_TERM);
	    eval 'sub SLSMG_DEGREE_CHAR_TERM () {ord(\'f\');}' unless defined(&SLSMG_DEGREE_CHAR_TERM);
	    eval 'sub SLSMG_PLMINUS_CHAR_TERM () {ord(\'g\');}' unless defined(&SLSMG_PLMINUS_CHAR_TERM);
	    eval 'sub SLSMG_BULLET_CHAR_TERM () {ord(\'~\');}' unless defined(&SLSMG_BULLET_CHAR_TERM);
	    eval 'sub SLSMG_LARROW_CHAR_TERM () {ord(\',\');}' unless defined(&SLSMG_LARROW_CHAR_TERM);
	    eval 'sub SLSMG_RARROW_CHAR_TERM () {ord(\'+\');}' unless defined(&SLSMG_RARROW_CHAR_TERM);
	    eval 'sub SLSMG_DARROW_CHAR_TERM () {ord(\'.\');}' unless defined(&SLSMG_DARROW_CHAR_TERM);
	    eval 'sub SLSMG_UARROW_CHAR_TERM () {ord(\'-\');}' unless defined(&SLSMG_UARROW_CHAR_TERM);
	    eval 'sub SLSMG_BOARD_CHAR_TERM () {ord(\'h\');}' unless defined(&SLSMG_BOARD_CHAR_TERM);
	    eval 'sub SLSMG_BLOCK_CHAR_TERM () {ord(\'0\');}' unless defined(&SLSMG_BLOCK_CHAR_TERM);
	}
    }
    if(defined(&UTF8)) {
	eval 'sub SLSMG_HLINE_CHAR_UNICODE () {0x2500;}' unless defined(&SLSMG_HLINE_CHAR_UNICODE);
	eval 'sub SLSMG_VLINE_CHAR_UNICODE () {0x2502;}' unless defined(&SLSMG_VLINE_CHAR_UNICODE);
	eval 'sub SLSMG_ULCORN_CHAR_UNICODE () {0x250c;}' unless defined(&SLSMG_ULCORN_CHAR_UNICODE);
	eval 'sub SLSMG_URCORN_CHAR_UNICODE () {0x2510;}' unless defined(&SLSMG_URCORN_CHAR_UNICODE);
	eval 'sub SLSMG_LLCORN_CHAR_UNICODE () {0x2514;}' unless defined(&SLSMG_LLCORN_CHAR_UNICODE);
	eval 'sub SLSMG_LRCORN_CHAR_UNICODE () {0x2518;}' unless defined(&SLSMG_LRCORN_CHAR_UNICODE);
	eval 'sub SLSMG_RTEE_CHAR_UNICODE () {0x2524;}' unless defined(&SLSMG_RTEE_CHAR_UNICODE);
	eval 'sub SLSMG_LTEE_CHAR_UNICODE () {0x251c;}' unless defined(&SLSMG_LTEE_CHAR_UNICODE);
	eval 'sub SLSMG_UTEE_CHAR_UNICODE () {0x2534;}' unless defined(&SLSMG_UTEE_CHAR_UNICODE);
	eval 'sub SLSMG_DTEE_CHAR_UNICODE () {0x252c;}' unless defined(&SLSMG_DTEE_CHAR_UNICODE);
	eval 'sub SLSMG_PLUS_CHAR_UNICODE () {0x253c;}' unless defined(&SLSMG_PLUS_CHAR_UNICODE);
	eval 'sub SLSMG_CKBRD_CHAR_UNICODE () {0x2592;}' unless defined(&SLSMG_CKBRD_CHAR_UNICODE);
	eval 'sub SLSMG_DIAMOND_CHAR_UNICODE () {0x25c6;}' unless defined(&SLSMG_DIAMOND_CHAR_UNICODE);
	eval 'sub SLSMG_DEGREE_CHAR_UNICODE () {0xb0;}' unless defined(&SLSMG_DEGREE_CHAR_UNICODE);
	eval 'sub SLSMG_PLMINUS_CHAR_UNICODE () {0xb1;}' unless defined(&SLSMG_PLMINUS_CHAR_UNICODE);
	eval 'sub SLSMG_BULLET_CHAR_UNICODE () {0xb7;}' unless defined(&SLSMG_BULLET_CHAR_UNICODE);
	eval 'sub SLSMG_LARROW_CHAR_UNICODE () {0x2190;}' unless defined(&SLSMG_LARROW_CHAR_UNICODE);
	eval 'sub SLSMG_RARROW_CHAR_UNICODE () {0x2192;}' unless defined(&SLSMG_RARROW_CHAR_UNICODE);
	eval 'sub SLSMG_DARROW_CHAR_UNICODE () {0x2193;}' unless defined(&SLSMG_DARROW_CHAR_UNICODE);
	eval 'sub SLSMG_UARROW_CHAR_UNICODE () {0x2191;}' unless defined(&SLSMG_UARROW_CHAR_UNICODE);
	eval 'sub SLSMG_BOARD_CHAR_UNICODE () {0x2592;}' unless defined(&SLSMG_BOARD_CHAR_UNICODE);
	eval 'sub SLSMG_BLOCK_CHAR_UNICODE () {0x25ae;}' unless defined(&SLSMG_BLOCK_CHAR_UNICODE);
    }
    unless(defined(&IBMPC_SYSTEM)) {
	eval 'sub SLSMG_COLOR_BLACK () {0x;}' unless defined(&SLSMG_COLOR_BLACK);
	eval 'sub SLSMG_COLOR_RED () {0x1;}' unless defined(&SLSMG_COLOR_RED);
	eval 'sub SLSMG_COLOR_GREEN () {0x2;}' unless defined(&SLSMG_COLOR_GREEN);
	eval 'sub SLSMG_COLOR_BROWN () {0x3;}' unless defined(&SLSMG_COLOR_BROWN);
	eval 'sub SLSMG_COLOR_BLUE () {0x4;}' unless defined(&SLSMG_COLOR_BLUE);
	eval 'sub SLSMG_COLOR_MAGENTA () {0x5;}' unless defined(&SLSMG_COLOR_MAGENTA);
	eval 'sub SLSMG_COLOR_CYAN () {0x6;}' unless defined(&SLSMG_COLOR_CYAN);
	eval 'sub SLSMG_COLOR_LGRAY () {0x7;}' unless defined(&SLSMG_COLOR_LGRAY);
	eval 'sub SLSMG_COLOR_GRAY () {0x8;}' unless defined(&SLSMG_COLOR_GRAY);
	eval 'sub SLSMG_COLOR_BRIGHT_RED () {0x9;}' unless defined(&SLSMG_COLOR_BRIGHT_RED);
	eval 'sub SLSMG_COLOR_BRIGHT_GREEN () {0xa;}' unless defined(&SLSMG_COLOR_BRIGHT_GREEN);
	eval 'sub SLSMG_COLOR_BRIGHT_BROWN () {0xb;}' unless defined(&SLSMG_COLOR_BRIGHT_BROWN);
	eval 'sub SLSMG_COLOR_BRIGHT_BLUE () {0xc;}' unless defined(&SLSMG_COLOR_BRIGHT_BLUE);
	eval 'sub SLSMG_COLOR_BRIGHT_CYAN () {0xd;}' unless defined(&SLSMG_COLOR_BRIGHT_CYAN);
	eval 'sub SLSMG_COLOR_BRIGHT_MAGENTA () {0xe;}' unless defined(&SLSMG_COLOR_BRIGHT_MAGENTA);
	eval 'sub SLSMG_COLOR_BRIGHT_WHITE () {0xf;}' unless defined(&SLSMG_COLOR_BRIGHT_WHITE);
    }
    eval 'sub SL_KEY_ERR () {0xffff;}' unless defined(&SL_KEY_ERR);
    eval 'sub SL_KEY_UP () {0x101;}' unless defined(&SL_KEY_UP);
    eval 'sub SL_KEY_DOWN () {0x102;}' unless defined(&SL_KEY_DOWN);
    eval 'sub SL_KEY_LEFT () {0x103;}' unless defined(&SL_KEY_LEFT);
    eval 'sub SL_KEY_RIGHT () {0x104;}' unless defined(&SL_KEY_RIGHT);
    eval 'sub SL_KEY_PPAGE () {0x105;}' unless defined(&SL_KEY_PPAGE);
    eval 'sub SL_KEY_NPAGE () {0x106;}' unless defined(&SL_KEY_NPAGE);
    eval 'sub SL_KEY_HOME () {0x107;}' unless defined(&SL_KEY_HOME);
    eval 'sub SL_KEY_END () {0x108;}' unless defined(&SL_KEY_END);
    eval 'sub SL_KEY_A1 () {0x109;}' unless defined(&SL_KEY_A1);
    eval 'sub SL_KEY_A3 () {0x10a;}' unless defined(&SL_KEY_A3);
    eval 'sub SL_KEY_B2 () {0x10b;}' unless defined(&SL_KEY_B2);
    eval 'sub SL_KEY_C1 () {0x10c;}' unless defined(&SL_KEY_C1);
    eval 'sub SL_KEY_C3 () {0x10d;}' unless defined(&SL_KEY_C3);
    eval 'sub SL_KEY_REDO () {0x10e;}' unless defined(&SL_KEY_REDO);
    eval 'sub SL_KEY_UNDO () {0x10f;}' unless defined(&SL_KEY_UNDO);
    eval 'sub SL_KEY_BACKSPACE () {0x110;}' unless defined(&SL_KEY_BACKSPACE);
    eval 'sub SL_KEY_ENTER () {0x111;}' unless defined(&SL_KEY_ENTER);
    eval 'sub SL_KEY_IC () {0x112;}' unless defined(&SL_KEY_IC);
    eval 'sub SL_KEY_DELETE () {0x113;}' unless defined(&SL_KEY_DELETE);
    eval 'sub SL_KEY_F0 () {0x200;}' unless defined(&SL_KEY_F0);
    eval 'sub SL_KEY_F {
        my($X) = @_;
	    eval q(( &SL_KEY_F0 + $X));
    }' unless defined(&SL_KEY_F);
    eval 'sub SLANG_UNDEFINED_TYPE () {0x;}' unless defined(&SLANG_UNDEFINED_TYPE);
    eval 'sub SLANG_VOID_TYPE () {0x1;}' unless defined(&SLANG_VOID_TYPE);
    eval 'sub SLANG_INT_TYPE () {0x2;}' unless defined(&SLANG_INT_TYPE);
    eval 'sub SLANG_DOUBLE_TYPE () {0x3;}' unless defined(&SLANG_DOUBLE_TYPE);
    eval 'sub SLANG_CHAR_TYPE () {0x4;}' unless defined(&SLANG_CHAR_TYPE);
    eval 'sub SLANG_INTP_TYPE () {0x5;}' unless defined(&SLANG_INTP_TYPE);
    eval 'sub SLANG_REF_TYPE () {0x6;}' unless defined(&SLANG_REF_TYPE);
    eval 'sub SLANG_COMPLEX_TYPE () {0x7;}' unless defined(&SLANG_COMPLEX_TYPE);
    eval 'sub SLANG_NULL_TYPE () {0x8;}' unless defined(&SLANG_NULL_TYPE);
    eval 'sub SLANG_UCHAR_TYPE () {0x9;}' unless defined(&SLANG_UCHAR_TYPE);
    eval 'sub SLANG_SHORT_TYPE () {0xa;}' unless defined(&SLANG_SHORT_TYPE);
    eval 'sub SLANG_USHORT_TYPE () {0xb;}' unless defined(&SLANG_USHORT_TYPE);
    eval 'sub SLANG_UINT_TYPE () {0xc;}' unless defined(&SLANG_UINT_TYPE);
    eval 'sub SLANG_LONG_TYPE () {0xd;}' unless defined(&SLANG_LONG_TYPE);
    eval 'sub SLANG_ULONG_TYPE () {0xe;}' unless defined(&SLANG_ULONG_TYPE);
    eval 'sub SLANG_STRING_TYPE () {0xf;}' unless defined(&SLANG_STRING_TYPE);
    eval 'sub SLANG_FLOAT_TYPE () {0x10;}' unless defined(&SLANG_FLOAT_TYPE);
    eval 'sub SLANG_STRUCT_TYPE () {0x11;}' unless defined(&SLANG_STRUCT_TYPE);
    eval 'sub SLANG_ISTRUCT_TYPE () {0x12;}' unless defined(&SLANG_ISTRUCT_TYPE);
    eval 'sub SLANG_ARRAY_TYPE () {0x20;}' unless defined(&SLANG_ARRAY_TYPE);
    eval 'sub SLANG_DATATYPE_TYPE () {0x21;}' unless defined(&SLANG_DATATYPE_TYPE);
    eval 'sub SLANG_FILE_PTR_TYPE () {0x22;}' unless defined(&SLANG_FILE_PTR_TYPE);
    eval 'sub SLANG_ASSOC_TYPE () {0x23;}' unless defined(&SLANG_ASSOC_TYPE);
    eval 'sub SLANG_ANY_TYPE () {0x24;}' unless defined(&SLANG_ANY_TYPE);
    eval 'sub SLANG_BSTRING_TYPE () {0x25;}' unless defined(&SLANG_BSTRING_TYPE);
    eval 'sub SLANG_FILE_FD_TYPE () {0x26;}' unless defined(&SLANG_FILE_FD_TYPE);
    if(defined(&FLOAT_TYPE)) {
	undef(&FLOAT_TYPE) if defined(&FLOAT_TYPE);
    }
    eval 'sub VOID_TYPE () { &SLANG_VOID_TYPE;}' unless defined(&VOID_TYPE);
    eval 'sub INT_TYPE () { &SLANG_INT_TYPE;}' unless defined(&INT_TYPE);
    eval 'sub INTP_TYPE () { &SLANG_INTP_TYPE;}' unless defined(&INTP_TYPE);
    eval 'sub FLOAT_TYPE () { &SLANG_DOUBLE_TYPE;}' unless defined(&FLOAT_TYPE);
    eval 'sub ARRAY_TYPE () { &SLANG_ARRAY_TYPE;}' unless defined(&ARRAY_TYPE);
    eval 'sub CHAR_TYPE () { &SLANG_CHAR_TYPE;}' unless defined(&CHAR_TYPE);
    eval 'sub STRING_TYPE () { &SLANG_STRING_TYPE;}' unless defined(&STRING_TYPE);
    eval 'sub SLANG_PLUS () {0x1;}' unless defined(&SLANG_PLUS);
    eval 'sub SLANG_MINUS () {0x2;}' unless defined(&SLANG_MINUS);
    eval 'sub SLANG_TIMES () {0x3;}' unless defined(&SLANG_TIMES);
    eval 'sub SLANG_DIVIDE () {0x4;}' unless defined(&SLANG_DIVIDE);
    eval 'sub SLANG_EQ () {0x5;}' unless defined(&SLANG_EQ);
    eval 'sub SLANG_NE () {0x6;}' unless defined(&SLANG_NE);
    eval 'sub SLANG_GT () {0x7;}' unless defined(&SLANG_GT);
    eval 'sub SLANG_GE () {0x8;}' unless defined(&SLANG_GE);
    eval 'sub SLANG_LT () {0x9;}' unless defined(&SLANG_LT);
    eval 'sub SLANG_LE () {0xa;}' unless defined(&SLANG_LE);
    eval 'sub SLANG_POW () {0xb;}' unless defined(&SLANG_POW);
    eval 'sub SLANG_OR () {0xc;}' unless defined(&SLANG_OR);
    eval 'sub SLANG_AND () {0xd;}' unless defined(&SLANG_AND);
    eval 'sub SLANG_BAND () {0xe;}' unless defined(&SLANG_BAND);
    eval 'sub SLANG_BOR () {0xf;}' unless defined(&SLANG_BOR);
    eval 'sub SLANG_BXOR () {0x10;}' unless defined(&SLANG_BXOR);
    eval 'sub SLANG_SHL () {0x11;}' unless defined(&SLANG_SHL);
    eval 'sub SLANG_SHR () {0x12;}' unless defined(&SLANG_SHR);
    eval 'sub SLANG_MOD () {0x13;}' unless defined(&SLANG_MOD);
    eval 'sub SLANG_PLUSPLUS () {0x20;}' unless defined(&SLANG_PLUSPLUS);
    eval 'sub SLANG_MINUSMINUS () {0x21;}' unless defined(&SLANG_MINUSMINUS);
    eval 'sub SLANG_ABS () {0x22;}' unless defined(&SLANG_ABS);
    eval 'sub SLANG_SIGN () {0x23;}' unless defined(&SLANG_SIGN);
    eval 'sub SLANG_SQR () {0x24;}' unless defined(&SLANG_SQR);
    eval 'sub SLANG_MUL2 () {0x25;}' unless defined(&SLANG_MUL2);
    eval 'sub SLANG_CHS () {0x26;}' unless defined(&SLANG_CHS);
    eval 'sub SLANG_NOT () {0x27;}' unless defined(&SLANG_NOT);
    eval 'sub SLANG_BNOT () {0x28;}' unless defined(&SLANG_BNOT);
    eval 'sub MAKE_INTRINSIC_N {
        my($n,$f,$out,$in,$a1,$a2,$a3,$a4,$a5,$a6,$a7) = @_;
	    eval q({($n),  &NULL,  &SLANG_INTRINSIC, ( &FVOID_STAR) ($f), {$a1,$a2,$a3,$a4,$a5,$a6,$a7}, ($in), ($out)});
    }' unless defined(&MAKE_INTRINSIC_N);
    eval 'sub MAKE_INTRINSIC_7 {
        my($n,$f,$out,$a1,$a2,$a3,$a4,$a5,$a6,$a7) = @_;
	    eval q( &MAKE_INTRINSIC_N($n,$f,$out,7,$a1,$a2,$a3,$a4,$a5,$a6,$a7));
    }' unless defined(&MAKE_INTRINSIC_7);
    eval 'sub MAKE_INTRINSIC_6 {
        my($n,$f,$out,$a1,$a2,$a3,$a4,$a5,$a6) = @_;
	    eval q( &MAKE_INTRINSIC_N($n,$f,$out,6,$a1,$a2,$a3,$a4,$a5,$a6,0));
    }' unless defined(&MAKE_INTRINSIC_6);
    eval 'sub MAKE_INTRINSIC_5 {
        my($n,$f,$out,$a1,$a2,$a3,$a4,$a5) = @_;
	    eval q( &MAKE_INTRINSIC_N($n,$f,$out,5,$a1,$a2,$a3,$a4,$a5,0,0));
    }' unless defined(&MAKE_INTRINSIC_5);
    eval 'sub MAKE_INTRINSIC_4 {
        my($n,$f,$out,$a1,$a2,$a3,$a4) = @_;
	    eval q( &MAKE_INTRINSIC_N($n,$f,$out,4,$a1,$a2,$a3,$a4,0,0,0));
    }' unless defined(&MAKE_INTRINSIC_4);
    eval 'sub MAKE_INTRINSIC_3 {
        my($n,$f,$out,$a1,$a2,$a3) = @_;
	    eval q( &MAKE_INTRINSIC_N($n,$f,$out,3,$a1,$a2,$a3,0,0,0,0));
    }' unless defined(&MAKE_INTRINSIC_3);
    eval 'sub MAKE_INTRINSIC_2 {
        my($n,$f,$out,$a1,$a2) = @_;
	    eval q( &MAKE_INTRINSIC_N($n,$f,$out,2,$a1,$a2,0,0,0,0,0));
    }' unless defined(&MAKE_INTRINSIC_2);
    eval 'sub MAKE_INTRINSIC_1 {
        my($n,$f,$out,$a1) = @_;
	    eval q( &MAKE_INTRINSIC_N($n,$f,$out,1,$a1,0,0,0,0,0,0));
    }' unless defined(&MAKE_INTRINSIC_1);
    eval 'sub MAKE_INTRINSIC_0 {
        my($n,$f,$out) = @_;
	    eval q( &MAKE_INTRINSIC_N($n,$f,$out,0,0,0,0,0,0,0,0));
    }' unless defined(&MAKE_INTRINSIC_0);
    eval 'sub MAKE_INTRINSIC_S {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_1($n,$f,$r, &SLANG_STRING_TYPE));
    }' unless defined(&MAKE_INTRINSIC_S);
    eval 'sub MAKE_INTRINSIC_I {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_1($n,$f,$r, &SLANG_INT_TYPE));
    }' unless defined(&MAKE_INTRINSIC_I);
    eval 'sub MAKE_INTRINSIC_SS {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_2($n,$f,$r, &SLANG_STRING_TYPE, &SLANG_STRING_TYPE));
    }' unless defined(&MAKE_INTRINSIC_SS);
    eval 'sub MAKE_INTRINSIC_SI {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_2($n,$f,$r, &SLANG_STRING_TYPE, &SLANG_INT_TYPE));
    }' unless defined(&MAKE_INTRINSIC_SI);
    eval 'sub MAKE_INTRINSIC_IS {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_2($n,$f,$r, &SLANG_INT_TYPE, &SLANG_STRING_TYPE));
    }' unless defined(&MAKE_INTRINSIC_IS);
    eval 'sub MAKE_INTRINSIC_II {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_2($n,$f,$r, &SLANG_INT_TYPE, &SLANG_INT_TYPE));
    }' unless defined(&MAKE_INTRINSIC_II);
    eval 'sub MAKE_INTRINSIC_SSS {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_3($n,$f,$r, &SLANG_STRING_TYPE, &SLANG_STRING_TYPE, &SLANG_STRING_TYPE));
    }' unless defined(&MAKE_INTRINSIC_SSS);
    eval 'sub MAKE_INTRINSIC_SSI {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_3($n,$f,$r, &SLANG_STRING_TYPE, &SLANG_STRING_TYPE, &SLANG_INT_TYPE));
    }' unless defined(&MAKE_INTRINSIC_SSI);
    eval 'sub MAKE_INTRINSIC_SIS {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_3($n,$f,$r, &SLANG_STRING_TYPE, &SLANG_INT_TYPE, &SLANG_STRING_TYPE));
    }' unless defined(&MAKE_INTRINSIC_SIS);
    eval 'sub MAKE_INTRINSIC_SII {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_3($n,$f,$r, &SLANG_STRING_TYPE, &SLANG_INT_TYPE, &SLANG_INT_TYPE));
    }' unless defined(&MAKE_INTRINSIC_SII);
    eval 'sub MAKE_INTRINSIC_ISS {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_3($n,$f,$r, &SLANG_INT_TYPE, &SLANG_STRING_TYPE, &SLANG_STRING_TYPE));
    }' unless defined(&MAKE_INTRINSIC_ISS);
    eval 'sub MAKE_INTRINSIC_ISI {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_3($n,$f,$r, &SLANG_INT_TYPE, &SLANG_STRING_TYPE, &SLANG_INT_TYPE));
    }' unless defined(&MAKE_INTRINSIC_ISI);
    eval 'sub MAKE_INTRINSIC_IIS {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_3($n,$f,$r, &SLANG_INT_TYPE, &SLANG_INT_TYPE, &SLANG_STRING_TYPE));
    }' unless defined(&MAKE_INTRINSIC_IIS);
    eval 'sub MAKE_INTRINSIC_III {
        my($n,$f,$r) = @_;
	    eval q( &MAKE_INTRINSIC_3($n,$f,$r, &SLANG_INT_TYPE, &SLANG_INT_TYPE, &SLANG_INT_TYPE));
    }' unless defined(&MAKE_INTRINSIC_III);
    eval 'sub MAKE_INTRINSIC {
        my($n, $f, $out, $in) = @_;
	    eval q( &MAKE_INTRINSIC_N($n,$f,$out,$in,0,0,0,0,0,0,0));
    }' unless defined(&MAKE_INTRINSIC);
    eval 'sub MAKE_VARIABLE {
        my($n, $v, $t, $r) = @_;
	    eval q({$n,  &NULL,  &SLANG_IVARIABLE + ($r), ( &VOID_STAR)($v), ($t)});
    }' unless defined(&MAKE_VARIABLE);
    eval 'sub MAKE_APP_UNARY {
        my($n,$op) = @_;
	    eval q({($n),  &NULL,  &SLANG_APP_UNARY, ($op)});
    }' unless defined(&MAKE_APP_UNARY);
    eval 'sub MAKE_MATH_UNARY {
        my($n,$op) = @_;
	    eval q({($n),  &NULL,  &SLANG_MATH_UNARY, ($op)});
    }' unless defined(&MAKE_MATH_UNARY);
    eval 'sub MAKE_ICONSTANT {
        my($n,$val) = @_;
	    eval q({($n), &NULL,  &SLANG_ICONSTANT, ($val)});
    }' unless defined(&MAKE_ICONSTANT);
    eval 'sub MAKE_DCONSTANT {
        my($n,$val) = @_;
	    eval q({($n), &NULL,  &SLANG_DCONSTANT, ($val)});
    }' unless defined(&MAKE_DCONSTANT);
    unless(defined(&offsetof)) {
	eval 'sub offsetof {
	    my($T,$F) = @_;
    	    eval q((((($T *)0)->$F - 0)));
	}' unless defined(&offsetof);
    }
    eval 'sub MAKE_ISTRUCT_FIELD {
        my($s,$f,$n,$t,$r) = @_;
	    eval q({($n),  &offsetof($s,$f), ($t), ($r)});
    }' unless defined(&MAKE_ISTRUCT_FIELD);
    eval 'sub SLANG_END_TABLE () {{ &NULL};}' unless defined(&SLANG_END_TABLE);
    eval 'sub SLANG_END_INTRIN_FUN_TABLE () { &MAKE_INTRINSIC_0( &NULL, &NULL,0);}' unless defined(&SLANG_END_INTRIN_FUN_TABLE);
    eval 'sub SLANG_END_DCONST_TABLE () { &MAKE_DCONSTANT( &NULL,0);}' unless defined(&SLANG_END_DCONST_TABLE);
    eval 'sub SLANG_END_MATH_UNARY_TABLE () { &MAKE_MATH_UNARY( &NULL,0);}' unless defined(&SLANG_END_MATH_UNARY_TABLE);
    eval 'sub SLANG_END_INTRIN_VAR_TABLE () { &MAKE_VARIABLE( &NULL, &NULL,0,0);}' unless defined(&SLANG_END_INTRIN_VAR_TABLE);
    eval 'sub SLANG_END_ICONST_TABLE () { &MAKE_ICONSTANT( &NULL,0);}' unless defined(&SLANG_END_ICONST_TABLE);
    eval 'sub SLANG_END_ISTRUCT_TABLE () {{ &NULL, 0, 0, 0};}' unless defined(&SLANG_END_ISTRUCT_TABLE);
    eval 'sub UPPER_CASE {
        my($x) = @_;
	    eval q(( $_SLChg_UCase_Lut[ ($x)]));
    }' unless defined(&UPPER_CASE);
    eval 'sub LOWER_CASE {
        my($x) = @_;
	    eval q(( $_SLChg_LCase_Lut[ ($x)]));
    }' unless defined(&LOWER_CASE);
    eval 'sub CHANGE_CASE {
        my($x) = @_;
	    eval q((( ==  $_SLChg_LCase_Lut[ ]) ?  $_SLChg_UCase_Lut[ ] :  $_SLChg_LCase_Lut[ ($x)]));
    }' unless defined(&CHANGE_CASE);
    eval 'sub SLANG_MODULE {
        my($name) = @_;
	    eval q( &extern \'int\'  &init_$name &_module_ns ;  &extern  &void  &deinit_$name &_module ( &void));
    }' unless defined(&SLANG_MODULE);
    if(0) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
