require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&rtti_INCLUDED)) {
    eval 'sub rtti_INCLUDED () {1;}' unless defined(&rtti_INCLUDED);
    if(defined(&SP_HAVE_RTTI)) {
	eval 'sub DYNAMIC_CAST_PTR {
	    my($T, $p) = @_;
    	    eval q( &dynamic_cast<$T *>($p));
	}' unless defined(&DYNAMIC_CAST_PTR);
	eval 'sub DYNAMIC_CAST_CONST_PTR {
	    my($T, $p) = @_;
    	    eval q( &dynamic_cast< &const $T *>($p));
	}' unless defined(&DYNAMIC_CAST_CONST_PTR);
	eval 'sub RTTI_CLASS () {1;}' unless defined(&RTTI_CLASS);
	eval 'sub RTTI_DEF0 {
	    my($T) = @_;
    	    eval q();
	}' unless defined(&RTTI_DEF0);
	eval 'sub RTTI_DEF1 {
	    my($T, $B1) = @_;
    	    eval q();
	}' unless defined(&RTTI_DEF1);
	eval 'sub RTTI_DEF2 {
	    my($T, $B1, $B2) = @_;
    	    eval q();
	}' unless defined(&RTTI_DEF2);
	eval 'sub RTTI_DEF3 {
	    my($T, $B1, $B2, $B3) = @_;
    	    eval q();
	}' unless defined(&RTTI_DEF3);
    } else {
	require 'TypeId.ph';
	eval 'sub RTTI_CLASS () { &public:  &virtual  &TypeId  &dynamicType()  &const;  &static  &inline  &TypeId  &staticType() {  &return  &TypeId( &RTTI_bases_); }  &protected:  &static  &const  &void * $RTTI_bases_[];  &private:;}' unless defined(&RTTI_CLASS);
	eval 'sub RTTI_DEF0 {
	    my($T) = @_;
    	    eval q( &const  &void *$T:: $RTTI_bases_[] = { 0};  &TypeId $T:: &dynamicType()  &const {  &return  &staticType(); });
	}' unless defined(&RTTI_DEF0);
	eval 'sub RTTI_DEF1 {
	    my($T, $B1) = @_;
    	    eval q( &const  &void *$T:: $RTTI_bases_[] = { $B1:: &RTTI_bases_, 0};  &TypeId $T:: &dynamicType()  &const {  &return  &staticType(); });
	}' unless defined(&RTTI_DEF1);
	eval 'sub RTTI_DEF2 {
	    my($T, $B1, $B2) = @_;
    	    eval q( &const  &void *$T:: $RTTI_bases_[] = { $B1:: &RTTI_bases_, $B2:: &RTTI_bases_, 0};  &TypeId $T:: &dynamicType()  &const {  &return  &staticType(); });
	}' unless defined(&RTTI_DEF2);
	eval 'sub RTTI_DEF3 {
	    my($T, $B1, $B2, $B3) = @_;
    	    eval q( &const  &void *$T:: $RTTI_bases_[] = { $B1:: &RTTI_bases_, $B2:: &RTTI_bases_, $B3:: &RTTI_bases_, 0};  &TypeId $T:: &dynamicType()  &const {  &return  &staticType(); });
	}' unless defined(&RTTI_DEF3);
	eval 'sub DYNAMIC_CAST_PTR {
	    my($T, $p) = @_;
    	    eval q((($p)  && ($p)-> &dynamicType(). &canCast($T:: &staticType(), ($p)-> &staticType()) ? ($T *)($p) : 0));
	}' unless defined(&DYNAMIC_CAST_PTR);
	eval 'sub DYNAMIC_CAST_CONST_PTR {
	    my($T, $p) = @_;
    	    eval q((($p)  && ($p)-> &dynamicType(). &canCast($T:: &staticType(), ($p)-> &staticType()) ? ( &const $T *)$p : 0));
	}' unless defined(&DYNAMIC_CAST_CONST_PTR);
    }
}
1;
