require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&UCD_COMPATIBLE)) {
    require 'net-snmp/library/default_store.ph';
    eval 'sub DS_MAX_IDS () { &NETSNMP_DS_MAX_IDS;}' unless defined(&DS_MAX_IDS);
    eval 'sub DS_MAX_SUBIDS () { &NETSNMP_DS_MAX_SUBIDS;}' unless defined(&DS_MAX_SUBIDS);
    eval 'sub DS_LIBRARY_ID () { &NETSNMP_DS_LIBRARY_ID;}' unless defined(&DS_LIBRARY_ID);
    eval 'sub DS_APPLICATION_ID () { &NETSNMP_DS_APPLICATION_ID;}' unless defined(&DS_APPLICATION_ID);
    eval 'sub DS_TOKEN_ID () { &NETSNMP_DS_TOKEN_ID;}' unless defined(&DS_TOKEN_ID);
    eval 'sub DS_LIB_MIB_ERRORS () { &NETSNMP_DS_LIB_MIB_ERRORS;}' unless defined(&DS_LIB_MIB_ERRORS);
    eval 'sub DS_LIB_SAVE_MIB_DESCRS () { &NETSNMP_DS_LIB_SAVE_MIB_DESCRS;}' unless defined(&DS_LIB_SAVE_MIB_DESCRS);
    eval 'sub DS_LIB_MIB_COMMENT_TERM () { &NETSNMP_DS_LIB_MIB_COMMENT_TERM;}' unless defined(&DS_LIB_MIB_COMMENT_TERM);
    eval 'sub DS_LIB_MIB_PARSE_LABEL () { &NETSNMP_DS_LIB_MIB_PARSE_LABEL;}' unless defined(&DS_LIB_MIB_PARSE_LABEL);
    eval 'sub DS_LIB_DUMP_PACKET () { &NETSNMP_DS_LIB_DUMP_PACKET;}' unless defined(&DS_LIB_DUMP_PACKET);
    eval 'sub DS_LIB_LOG_TIMESTAMP () { &NETSNMP_DS_LIB_LOG_TIMESTAMP;}' unless defined(&DS_LIB_LOG_TIMESTAMP);
    eval 'sub DS_LIB_DONT_READ_CONFIGS () { &NETSNMP_DS_LIB_DONT_READ_CONFIGS;}' unless defined(&DS_LIB_DONT_READ_CONFIGS);
    eval 'sub DS_LIB_MIB_REPLACE () { &NETSNMP_DS_LIB_MIB_REPLACE;}' unless defined(&DS_LIB_MIB_REPLACE);
    eval 'sub DS_LIB_PRINT_NUMERIC_ENUM () { &NETSNMP_DS_LIB_PRINT_NUMERIC_ENUM;}' unless defined(&DS_LIB_PRINT_NUMERIC_ENUM);
    eval 'sub DS_LIB_PRINT_NUMERIC_OIDS () { &NETSNMP_DS_LIB_PRINT_NUMERIC_OIDS;}' unless defined(&DS_LIB_PRINT_NUMERIC_OIDS);
    eval 'sub DS_LIB_DONT_BREAKDOWN_OIDS () { &NETSNMP_DS_LIB_DONT_BREAKDOWN_OIDS;}' unless defined(&DS_LIB_DONT_BREAKDOWN_OIDS);
    eval 'sub DS_LIB_ALARM_DONT_USE_SIG () { &NETSNMP_DS_LIB_ALARM_DONT_USE_SIG;}' unless defined(&DS_LIB_ALARM_DONT_USE_SIG);
    eval 'sub DS_LIB_PRINT_FULL_OID () { &NETSNMP_DS_LIB_PRINT_FULL_OID;}' unless defined(&DS_LIB_PRINT_FULL_OID);
    eval 'sub DS_LIB_QUICK_PRINT () { &NETSNMP_DS_LIB_QUICK_PRINT;}' unless defined(&DS_LIB_QUICK_PRINT);
    eval 'sub DS_LIB_RANDOM_ACCESS () { &NETSNMP_DS_LIB_RANDOM_ACCESS;}' unless defined(&DS_LIB_RANDOM_ACCESS);
    eval 'sub DS_LIB_REGEX_ACCESS () { &NETSNMP_DS_LIB_REGEX_ACCESS;}' unless defined(&DS_LIB_REGEX_ACCESS);
    eval 'sub DS_LIB_DONT_CHECK_RANGE () { &NETSNMP_DS_LIB_DONT_CHECK_RANGE;}' unless defined(&DS_LIB_DONT_CHECK_RANGE);
    eval 'sub DS_LIB_NO_TOKEN_WARNINGS () { &NETSNMP_DS_LIB_NO_TOKEN_WARNINGS;}' unless defined(&DS_LIB_NO_TOKEN_WARNINGS);
    eval 'sub DS_LIB_NUMERIC_TIMETICKS () { &NETSNMP_DS_LIB_NUMERIC_TIMETICKS;}' unless defined(&DS_LIB_NUMERIC_TIMETICKS);
    eval 'sub DS_LIB_ESCAPE_QUOTES () { &NETSNMP_DS_LIB_ESCAPE_QUOTES;}' unless defined(&DS_LIB_ESCAPE_QUOTES);
    eval 'sub DS_LIB_REVERSE_ENCODE () { &NETSNMP_DS_LIB_REVERSE_ENCODE;}' unless defined(&DS_LIB_REVERSE_ENCODE);
    eval 'sub DS_LIB_PRINT_BARE_VALUE () { &NETSNMP_DS_LIB_PRINT_BARE_VALUE;}' unless defined(&DS_LIB_PRINT_BARE_VALUE);
    eval 'sub DS_LIB_EXTENDED_INDEX () { &NETSNMP_DS_LIB_EXTENDED_INDEX;}' unless defined(&DS_LIB_EXTENDED_INDEX);
    eval 'sub DS_LIB_PRINT_HEX_TEXT () { &NETSNMP_DS_LIB_PRINT_HEX_TEXT;}' unless defined(&DS_LIB_PRINT_HEX_TEXT);
    eval 'sub DS_LIB_MIB_WARNINGS () { &NETSNMP_DS_LIB_MIB_WARNINGS;}' unless defined(&DS_LIB_MIB_WARNINGS);
    eval 'sub DS_LIB_SECLEVEL () { &NETSNMP_DS_LIB_SECLEVEL;}' unless defined(&DS_LIB_SECLEVEL);
    eval 'sub DS_LIB_SNMPVERSION () { &NETSNMP_DS_LIB_SNMPVERSION;}' unless defined(&DS_LIB_SNMPVERSION);
    eval 'sub DS_LIB_DEFAULT_PORT () { &NETSNMP_DS_LIB_DEFAULT_PORT;}' unless defined(&DS_LIB_DEFAULT_PORT);
    eval 'sub DS_LIB_PRINT_SUFFIX_ONLY () { &NETSNMP_DS_LIB_PRINT_SUFFIX_ONLY;}' unless defined(&DS_LIB_PRINT_SUFFIX_ONLY);
    eval 'sub DS_LIB_SECNAME () { &NETSNMP_DS_LIB_SECNAME;}' unless defined(&DS_LIB_SECNAME);
    eval 'sub DS_LIB_CONTEXT () { &NETSNMP_DS_LIB_CONTEXT;}' unless defined(&DS_LIB_CONTEXT);
    eval 'sub DS_LIB_PASSPHRASE () { &NETSNMP_DS_LIB_PASSPHRASE;}' unless defined(&DS_LIB_PASSPHRASE);
    eval 'sub DS_LIB_AUTHPASSPHRASE () { &NETSNMP_DS_LIB_AUTHPASSPHRASE;}' unless defined(&DS_LIB_AUTHPASSPHRASE);
    eval 'sub DS_LIB_PRIVPASSPHRASE () { &NETSNMP_DS_LIB_PRIVPASSPHRASE;}' unless defined(&DS_LIB_PRIVPASSPHRASE);
    eval 'sub DS_LIB_OPTIONALCONFIG () { &NETSNMP_DS_LIB_OPTIONALCONFIG;}' unless defined(&DS_LIB_OPTIONALCONFIG);
    eval 'sub DS_LIB_APPTYPE () { &NETSNMP_DS_LIB_APPTYPE;}' unless defined(&DS_LIB_APPTYPE);
    eval 'sub DS_LIB_COMMUNITY () { &NETSNMP_DS_LIB_COMMUNITY;}' unless defined(&DS_LIB_COMMUNITY);
    eval 'sub DS_LIB_PERSISTENT_DIR () { &NETSNMP_DS_LIB_PERSISTENT_DIR;}' unless defined(&DS_LIB_PERSISTENT_DIR);
    eval 'sub DS_LIB_CONFIGURATION_DIR () { &NETSNMP_DS_LIB_CONFIGURATION_DIR;}' unless defined(&DS_LIB_CONFIGURATION_DIR);
    if(defined(&__cplusplus)) {
    }
    if(defined(&__cplusplus)) {
    }
} else {
    die("Please update your headers or configure using --enable-ucd-snmp-compatibility");
}
1;
