require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&Mrm_H)) {
    eval 'sub Mrm_H () {1;}' unless defined(&Mrm_H);
    eval 'sub urm_h () {1;}' unless defined(&urm_h);
    require 'X11/Xfuncs.ph';
    require 'Mrm/MrmPublic.ph';
    require 'Xm/Xm.ph';
    require 'Xm/XmosP.ph';
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    my($x,$y) = @_;
    	    eval q((($x) < ($y) ? ($x) : ($y)));
	}' unless defined(&MIN);
    }
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    my($x,$y) = @_;
    	    eval q((($x) > ($y) ? ($x) : ($y)));
	}' unless defined(&MAX);
    }
    unless(defined(&XmConst)) {
	if(defined( &__STDC__) || !defined( (defined(&NO_CONST) ? &NO_CONST : 0) )) {
	    eval 'sub XmConst () { &const;}' unless defined(&XmConst);
	} else {
	    eval 'sub XmConst () {1;}' unless defined(&XmConst);
	}
    }
    eval 'sub _sl () {$sizeof{\'long\'};}' unless defined(&_sl);
    eval 'sub _slm () {($sizeof{\'long\'} - 1);}' unless defined(&_slm);
    eval 'sub _FULLWORD {
        my($exp) = @_;
	    eval q(( &_sl * ((($exp) +  &_slm) /  &_sl)));
    }' unless defined(&_FULLWORD);
    if(defined(&_LP64)) {
	eval 'sub swap8bytes {
	    my($l) = @_;
    	    eval q({ \'long t\' = $l; \'char\'  &n, * &tp =   &t;  &n =  $tp[0];  $tp[0] =  $tp[7];  $tp[7] =  &n;  &n =  $tp[1];  $tp[1] =  $tp[6];  $tp[6] =  &n;  &n =  $tp[2];  $tp[2] =  $tp[5];  $tp[5] =  &n;  &n =  $tp[3];  $tp[3] =  $tp[4];  $tp[4] =  &n; $l =  &t;});
	}' unless defined(&swap8bytes);
    }
    eval 'sub swap4bytes {
        my($l) = @_;
	    eval q({  &CARD32  &t = ( &CARD32) $l; \'char\'  &n, * &tp =   &t;  &tp += $sizeof{ &CARD32} - 4;  &n =  $tp[0];  $tp[0] =  $tp[3];  $tp[3] =  &n;  &n =  $tp[1];  $tp[1] =  $tp[2];  $tp[2] =  &n; $l =  &t;});
    }' unless defined(&swap4bytes);
    eval 'sub swap2bytes {
        my($s) = @_;
	    eval q({  &CARD16  &t = ( &CARD16) $s; \'char\'  &n, * &tp =   &t;  &tp += $sizeof{ &CARD16} - 2;  &n =  $tp[0];  $tp[0] =  $tp[1];  $tp[1] =  &n; $s =  &t;});
    }' unless defined(&swap2bytes);
    unless(defined(&_LP64)) {
	eval 'sub swapbytes {
	    my($v) = @_;
    	    eval q({  &if ($sizeof{$v} == 2)  &swap2bytes($v)  &else  &if ($sizeof{$v} >= 4)  &swap4bytes($v); });
	}' unless defined(&swapbytes);
    } else {
	eval 'sub swapbytes {
	    my($v) = @_;
    	    eval q({  &if ($sizeof{$v} == 2)  &swap2bytes($v)  &else  &if ($sizeof{$v} == 4)  &swap4bytes($v)  &else  &if ($sizeof{$v} == 8)  &swap8bytes($v); });
	}' unless defined(&swapbytes);
    }
    eval 'sub swapdouble {
        my($d) = @_;
	    eval q({ \'double\'  &dt = $d; \'unsigned m\', * &dp =   &dt;  &swap4bytes(  $dp[0] );  &swap4bytes(  $dp[1] );  &m =  $dp[0];  $dp[0] =  $dp[1];  $dp[1] =  &m; $d =  &dt;});
    }' unless defined(&swapdouble);
    eval 'sub MrmResourceUnswapped () {128;}' unless defined(&MrmResourceUnswapped);
    eval 'sub URMversion () {"URM 1.2";}' unless defined(&URMversion);
    eval 'sub URM1_1version () {"URM 1.1";}' unless defined(&URM1_1version);
    eval 'sub UilMrmClassTableIndex () {">ClassTable";}' unless defined(&UilMrmClassTableIndex);
    eval 'sub UilMrmResourceTableIndex () {">ResourceTable";}' unless defined(&UilMrmResourceTableIndex);
    eval 'sub URMgNul () {0;}' unless defined(&URMgNul);
    eval 'sub URMgWidget () {1;}' unless defined(&URMgWidget);
    eval 'sub URMgLiteral () {2;}' unless defined(&URMgLiteral);
    eval 'sub URMgResourceSet () {3;}' unless defined(&URMgResourceSet);
    eval 'sub URMgMessage () {5;}' unless defined(&URMgMessage);
    eval 'sub URMgMin () {1;}' unless defined(&URMgMin);
    eval 'sub URMgMax () {5;}' unless defined(&URMgMax);
    eval 'sub URMgVecSize () { &URMgMax+1;}' unless defined(&URMgVecSize);
    eval 'sub URMtNul () {0;}' unless defined(&URMtNul);
    eval 'sub URMaPublic () {1;}' unless defined(&URMaPublic);
    eval 'sub URMaPrivate () {2;}' unless defined(&URMaPrivate);
    eval 'sub URMrIndex () {1;}' unless defined(&URMrIndex);
    eval 'sub URMrRID () {2;}' unless defined(&URMrRID);
    eval 'sub URMrImmediate () {3;}' unless defined(&URMrImmediate);
    eval 'sub URMMaxIndexLen () {31;}' unless defined(&URMMaxIndexLen);
    eval 'sub URMMaxIndexLen1 () {( &URMMaxIndexLen + 1);}' unless defined(&URMMaxIndexLen1);
    eval 'sub URMReadAccess () {1;}' unless defined(&URMReadAccess);
    eval 'sub URMWriteAccess () {2;}' unless defined(&URMWriteAccess);
    eval 'sub URMhsDate () {29;}' unless defined(&URMhsDate);
    eval 'sub URMrsInterfaceModule () {1;}' unless defined(&URMrsInterfaceModule);
    eval("sub MrmManageUnmanage () { 0; }") unless defined(&MrmManageUnmanage);
    eval("sub MrmManageManage () { 1; }") unless defined(&MrmManageManage);
    eval("sub MrmManageDefault () { 2; }") unless defined(&MrmManageDefault);
    eval 'sub RGMListSizeMax () {1000;}' unless defined(&RGMListSizeMax);
    eval 'sub UrmPlistPtrList {
        my($list) = @_;
	    eval q((($list)-> &ptr_vec));
    }' unless defined(&UrmPlistPtrList);
    eval 'sub UrmPlistNum {
        my($list) = @_;
	    eval q((($list)-> &num_ptrs));
    }' unless defined(&UrmPlistNum);
    eval 'sub UrmPlistPtrN {
        my($list,$ndx) = @_;
	    eval q((($list)-> $ptr_vec[$ndx]));
    }' unless defined(&UrmPlistPtrN);
    eval 'sub URMResourceContextValid () {232570204;}' unless defined(&URMResourceContextValid);
    eval 'sub UrmRCValid {
        my($context) = @_;
	    eval q((($context)-> &validation== &URMResourceContextValid));
    }' unless defined(&UrmRCValid);
    eval 'sub UrmRCBuffer {
        my($context) = @_;
	    eval q((($context)-> &data_buffer));
    }' unless defined(&UrmRCBuffer);
    eval 'sub UrmRCBufSize {
        my($context) = @_;
	    eval q((($context)-> &buffer_size));
    }' unless defined(&UrmRCBufSize);
    eval 'sub UrmRCSize {
        my($context) = @_;
	    eval q((($context)-> &resource_size));
    }' unless defined(&UrmRCSize);
    eval 'sub UrmRCGroup {
        my($context) = @_;
	    eval q((($context)-> &group));
    }' unless defined(&UrmRCGroup);
    eval 'sub UrmRCType {
        my($context) = @_;
	    eval q((($context)-> &type));
    }' unless defined(&UrmRCType);
    eval 'sub UrmRCAccess {
        my($context) = @_;
	    eval q((($context)-> &access));
    }' unless defined(&UrmRCAccess);
    eval 'sub UrmRCLock {
        my($context) = @_;
	    eval q((($context)-> &lock));
    }' unless defined(&UrmRCLock);
    eval 'sub UrmRCByteSwap {
        my($context) = @_;
	    eval q((($context)-> &byte_swapped));
    }' unless defined(&UrmRCByteSwap);
    eval 'sub UrmRCSetBuffer {
        my($context,$bufadr) = @_;
	    eval q({($context)-> &data_buffer=($bufadr);});
    }' unless defined(&UrmRCSetBuffer);
    eval 'sub UrmRCSetSize {
        my($context,$sizval) = @_;
	    eval q({($context)-> &resource_size=($sizval);});
    }' unless defined(&UrmRCSetSize);
    eval 'sub UrmRCSetGroup {
        my($context,$grpval) = @_;
	    eval q({($context)-> &group=($grpval);});
    }' unless defined(&UrmRCSetGroup);
    eval 'sub UrmRCSetType {
        my($context,$typval) = @_;
	    eval q({($context)-> &type=($typval);});
    }' unless defined(&UrmRCSetType);
    eval 'sub UrmRCSetAccess {
        my($context,$accval) = @_;
	    eval q({($context)-> &access=($accval);});
    }' unless defined(&UrmRCSetAccess);
    eval 'sub UrmRCSetLock {
        my($context,$lckval) = @_;
	    eval q({($context)-> &lock=($lckval);});
    }' unless defined(&UrmRCSetLock);
    eval 'sub UrmRCSetByteSwap {
        my($context,$swapval) = @_;
	    eval q({($context)-> &byte_swapped=($swapval);});
    }' unless defined(&UrmRCSetByteSwap);
    eval 'sub URMRCErrorDefault () {1;}' unless defined(&URMRCErrorDefault);
    eval 'sub URMRCErrorSave () {2;}' unless defined(&URMRCErrorSave);
    eval 'sub URMErrOutMemory () {1;}' unless defined(&URMErrOutMemory);
    eval 'sub URMErrOutStdout () {2;}' unless defined(&URMErrOutStdout);
    eval 'sub IDBrtMin () {1;}' unless defined(&IDBrtMin);
    eval 'sub IDBrtHeader () {1;}' unless defined(&IDBrtHeader);
    eval 'sub IDBrtIndexLeaf () {2;}' unless defined(&IDBrtIndexLeaf);
    eval 'sub IDBrtIndexNode () {3;}' unless defined(&IDBrtIndexNode);
    eval 'sub IDBrtRIDMap () {4;}' unless defined(&IDBrtRIDMap);
    eval 'sub IDBrtData () {5;}' unless defined(&IDBrtData);
    eval 'sub IDBrtMax () {5;}' unless defined(&IDBrtMax);
    eval 'sub IDBrtVecSize () {6;}' unless defined(&IDBrtVecSize);
    eval 'sub IDBhsVersion () {9;}' unless defined(&IDBhsVersion);
    eval 'sub IDBhsVersion1 () {( &IDBhsVersion + 1);}' unless defined(&IDBhsVersion1);
    eval 'sub IDBhsCreator () {29;}' unless defined(&IDBhsCreator);
    eval 'sub IDBhsCreator1 () {( &IDBhsCreator + 1);}' unless defined(&IDBhsCreator1);
    eval 'sub IDBhsDate () { &URMhsDate;}' unless defined(&IDBhsDate);
    eval 'sub IDBhsDate1 () {( &IDBhsDate + 1);}' unless defined(&IDBhsDate1);
    eval 'sub IDBhsModule () {29;}' unless defined(&IDBhsModule);
    eval 'sub IDBhsModule1 () {( &IDBhsModule + 1);}' unless defined(&IDBhsModule1);
    eval 'sub URMWCIClassDescValid () {39963371;}' unless defined(&URMWCIClassDescValid);
    eval 'sub UrmWCIClassDescValid {
        my($classdesc) = @_;
	    eval q((($classdesc)-> &validation== &URMWCIClassDescValid));
    }' unless defined(&UrmWCIClassDescValid);
    eval 'sub UidCompressionTableValid () {317938336;}' unless defined(&UidCompressionTableValid);
    eval 'sub UilMrmUnknownCode () {1;}' unless defined(&UilMrmUnknownCode);
    eval 'sub UilMrmMinValidCode () {2;}' unless defined(&UilMrmMinValidCode);
    eval 'sub UilMrmReservedCodeCount () {2;}' unless defined(&UilMrmReservedCodeCount);
    unless(defined(&_LP64)) {
    } else {
    }
    eval 'sub k_hash_table_size () {(127);}' unless defined(&k_hash_table_size);
    eval 'sub IDBOpenFileValid () {421642674;}' unless defined(&IDBOpenFileValid);
    if(defined(&_LP64)) {
    }
    eval 'sub MrmHIERARCHY_VALID () {102214835;}' unless defined(&MrmHIERARCHY_VALID);
    eval 'sub MrmHierarchyValid {
        my($hierarchy) = @_;
	    eval q((($hierarchy)-> &validation== &MrmHIERARCHY_VALID));
    }' unless defined(&MrmHierarchyValid);
    eval 'sub URMWidgetRecordValid () {373946338;}' unless defined(&URMWidgetRecordValid);
    eval 'sub UilMrmWidgetVariety () {0;}' unless defined(&UilMrmWidgetVariety);
    eval 'sub UilMrmAutoChildVariety () {1;}' unless defined(&UilMrmAutoChildVariety);
    eval 'sub RGMWidgetRecordHdrSize () {$sizeof{ &RGMWidgetRecord};}' unless defined(&RGMWidgetRecordHdrSize);
    eval 'sub UrmWRWidgetRec {
        my($context) = @_;
	    eval q((( &RGMWidgetRecordPtr)  &UrmRCBuffer($context)));
    }' unless defined(&UrmWRWidgetRec);
    eval 'sub UrmWRValid {
        my($widgetrec) = @_;
	    eval q((($widgetrec)-> &validation== &URMWidgetRecordValid));
    }' unless defined(&UrmWRValid);
    eval 'sub UrmWRPSize {
        my($context) = @_;
	    eval q(( &UrmWRWidgetRec($context)-> &size));
    }' unless defined(&UrmWRPSize);
    eval 'sub UrmWRPAccess {
        my($context) = @_;
	    eval q(( &UrmWRWidgetRec($context)-> &access));
    }' unless defined(&UrmWRPAccess);
    eval 'sub UrmWRPLock {
        my($context) = @_;
	    eval q(( &UrmWRWidgetRec($context)-> &lock));
    }' unless defined(&UrmWRPLock);
    eval 'sub UrmWRPType {
        my($context) = @_;
	    eval q(( &UrmWRWidgetRec($context)-> &type));
    }' unless defined(&UrmWRPType);
    unless(defined(&_LP64)) {
    } else {
    }
    eval 'sub URMTextVectorValid () {34966592;}' unless defined(&URMTextVectorValid);
    unless(defined(&_LP64)) {
    } else {
    }
    eval 'sub URMIntegerVectorValid () {34966593;}' unless defined(&URMIntegerVectorValid);
    unless(defined(&_LP64)) {
    } else {
    }
    eval 'sub URMCallbackDescriptorValid () {107397480;}' unless defined(&URMCallbackDescriptorValid);
    unless(defined(&_LP64)) {
    } else {
    }
    eval 'sub URMFontListValid () {74149235;}' unless defined(&URMFontListValid);
    if(defined(&_LP64)) {
    } else {
    }
    eval 'sub RGMwrTypeReference () {233;}' unless defined(&RGMwrTypeReference);
    eval 'sub RGMwrTypeSubTree () {234;}' unless defined(&RGMwrTypeSubTree);
    eval 'sub URMInterfaceModuleValid () {408427447;}' unless defined(&URMInterfaceModuleValid);
    eval 'sub UrmInterfaceModuleValid {
        my($module) = @_;
	    eval q((($module)-> &validation== &URMInterfaceModuleValid));
    }' unless defined(&UrmInterfaceModuleValid);
    eval 'sub URMColorMonochromeUnspecified () {1;}' unless defined(&URMColorMonochromeUnspecified);
    eval 'sub URMColorMonochromeForeground () {2;}' unless defined(&URMColorMonochromeForeground);
    eval 'sub URMColorMonochromeBackground () {3;}' unless defined(&URMColorMonochromeBackground);
    eval 'sub URMColorDescTypeName () {1;}' unless defined(&URMColorDescTypeName);
    eval 'sub URMColorDescTypeRGB () {2;}' unless defined(&URMColorDescTypeRGB);
    eval 'sub RGMColorDescNameMinSize () {($sizeof{ &RGMColorDesc} - $sizeof{ &RGBColor} + $sizeof{\'char\'});}' unless defined(&RGMColorDescNameMinSize);
    eval 'sub URMColorTableValid () {9424574;}' unless defined(&URMColorTableValid);
    unless(defined(&_LP64)) {
    } else {
    }
    eval 'sub URMColorTableBG () {0;}' unless defined(&URMColorTableBG);
    eval 'sub URMColorTableFG () {1;}' unless defined(&URMColorTableFG);
    eval 'sub URMColorTableUserMin () {2;}' unless defined(&URMColorTableUserMin);
    eval 'sub URMIconImageValid () {160003640;}' unless defined(&URMIconImageValid);
    unless(defined(&_LP64)) {
	eval 'sub GET_ICON_IMAGE {
	    my($val) = @_;
    	    eval q((( &RGMIconImagePtr)($val)));
	}' unless defined(&GET_ICON_IMAGE);
    } else {
	eval 'sub GET_ICON_IMAGE {
	    my($val) = @_;
    	    eval q(( &RGMIconImagePtr)((( &RGMIconImageRedirectPtr)($val))-> &iconptr64));
	}' unless defined(&GET_ICON_IMAGE);
    }
    eval 'sub URMPixelSize1Bit () {1;}' unless defined(&URMPixelSize1Bit);
    eval 'sub URMPixelSize2Bit () {2;}' unless defined(&URMPixelSize2Bit);
    eval 'sub URMPixelSize4Bit () {3;}' unless defined(&URMPixelSize4Bit);
    eval 'sub URMPixelSize8Bit () {4;}' unless defined(&URMPixelSize8Bit);
    eval 'sub URMsvWidgetRef () {1;}' unless defined(&URMsvWidgetRef);
    eval 'sub URMsvIconImage () {2;}' unless defined(&URMsvIconImage);
    eval 'sub URMsvCallBackList () {3;}' unless defined(&URMsvCallBackList);
    eval 'sub UrmWRefHeaderBytes {
        my($ref_id) = @_;
	    eval q(($sizeof{ &URMWRefStruct}+(($ref_id)-> &num_refs-1)*$sizeof{ &URMWRef}));
    }' unless defined(&UrmWRefHeaderBytes);
    eval 'sub UrmWRefBytesUsed {
        my($ref_id) = @_;
	    eval q(( &UrmWRefHeaderBytes(($ref_id))+($ref_id)-> &heap_size));
    }' unless defined(&UrmWRefBytesUsed);
    eval 'sub UrmWRefIdN {
        my($ref_id,$ndx) = @_;
	    eval q((($ref_id)-> ($refs[&(ndx)]->{w_id})));
    }' unless defined(&UrmWRefIdN);
    eval 'sub UrmWRefNameN {
        my($ref_id,$ndx) = @_;
	    eval q((( &String)(( &String)($ref_id)+($ref_id)-> ($refs[&(ndx)]->{w_name_offs}))));
    }' unless defined(&UrmWRefNameN);
    unless(defined(&_ARGUMENTS)) {
	eval 'sub _ARGUMENTS {
	    my($arglist) = @_;
    	    eval q($arglist);
	}' unless defined(&_ARGUMENTS);
    }
    require 'IDB.ph';
    if(defined(&UNALIGNED)) {
	eval 'sub UrmBCopy {
	    my($src, $dst, $size) = @_;
    	    eval q( &if ($size ==  &sizeof) * = *;  &else  &if ($size ==  &sizeof) * = *;  &else  &if ($size ==  &sizeof) * = *;  &else  &if ($size ==  &sizeof) * = *;  &else  &memmove( , , ($size)););
	}' unless defined(&UrmBCopy);
    } else {
	eval 'sub UrmBCopy {
	    my($src, $dst, $size) = @_;
    	    eval q( &memmove( , , ($size)););
	}' unless defined(&UrmBCopy);
    }
    if(defined(&XTHREADS)) {
	eval 'sub _MrmWidgetToAppContext {
	    my($w) = @_;
    	    eval q( &XtAppContext  &app =  &XtWidgetToApplicationContext($w));
	}' unless defined(&_MrmWidgetToAppContext);
	eval 'sub _MrmDisplayToAppContext {
	    my($d) = @_;
    	    eval q( &XtAppContext  &app =  &XtDisplayToApplicationContext($d));
	}' unless defined(&_MrmDisplayToAppContext);
	eval 'sub _MrmAppLock {
	    my($app) = @_;
    	    eval q( &XtAppLock($app));
	}' unless defined(&_MrmAppLock);
	eval 'sub _MrmAppUnlock {
	    my($app) = @_;
    	    eval q( &XtAppUnlock($app));
	}' unless defined(&_MrmAppUnlock);
	eval 'sub _MrmProcessLock () {
	    eval q( &XtProcessLock());
	}' unless defined(&_MrmProcessLock);
	eval 'sub _MrmProcessUnlock () {
	    eval q( &XtProcessUnlock());
	}' unless defined(&_MrmProcessUnlock);
    } else {
	eval 'sub _MrmWidgetToAppContext {
	    my($w) = @_;
    	    eval q();
	}' unless defined(&_MrmWidgetToAppContext);
	eval 'sub _MrmDisplayToAppContext {
	    my($d) = @_;
    	    eval q();
	}' unless defined(&_MrmDisplayToAppContext);
	eval 'sub _MrmAppLock {
	    my($app) = @_;
    	    eval q();
	}' unless defined(&_MrmAppLock);
	eval 'sub _MrmAppUnlock {
	    my($app) = @_;
    	    eval q();
	}' unless defined(&_MrmAppUnlock);
	eval 'sub _MrmProcessLock () {
	    eval q();
	}' unless defined(&_MrmProcessLock);
	eval 'sub _MrmProcessUnlock () {
	    eval q();
	}' unless defined(&_MrmProcessUnlock);
    }
}
1;
