require '_h2ph_pre.ph';

no warnings 'redefine';

require 'record.ph';
unless(defined(&RECORD_NAME)) {
    sub RECORD_NAME () {	"RECORD";}
}
unless(defined(&RECORD_MAJOR_VERSION)) {
    sub RECORD_MAJOR_VERSION () {	1;}
}
unless(defined(&RECORD_MINOR_VERSION)) {
    sub RECORD_MINOR_VERSION () {	13;}
}
unless(defined(&RECORD_LOWEST_MAJOR_VERSION)) {
    sub RECORD_LOWEST_MAJOR_VERSION () {	1;}
}
unless(defined(&RECORD_LOWEST_MINOR_VERSION)) {
    sub RECORD_LOWEST_MINOR_VERSION () {	12;}
}
unless(defined(&X_RecordQueryVersion)) {
    sub X_RecordQueryVersion () {	0;}
}
unless(defined(&X_RecordCreateContext)) {
    sub X_RecordCreateContext () {	1;}
}
unless(defined(&X_RecordRegisterClients)) {
    sub X_RecordRegisterClients () {	2;}
}
unless(defined(&X_RecordUnregisterClients)) {
    sub X_RecordUnregisterClients () {	3;}
}
unless(defined(&X_RecordGetContext)) {
    sub X_RecordGetContext () {	4;}
}
unless(defined(&X_RecordEnableContext)) {
    sub X_RecordEnableContext () {	5;}
}
unless(defined(&X_RecordDisableContext)) {
    sub X_RecordDisableContext () {	6;}
}
unless(defined(&X_RecordFreeContext)) {
    sub X_RecordFreeContext () {	7;}
}
unless(defined(&RecordNumErrors)) {
    sub RecordNumErrors () {	( &XRecordBadContext + 1);}
}
unless(defined(&RecordNumEvents)) {
    sub RecordNumEvents () {	0;}
}
unless(defined(&sz_XRecordRange)) {
    sub sz_XRecordRange () {	32;}
}
unless(defined(&sz_XRecordClientInfo)) {
    sub sz_XRecordClientInfo () {	12;}
}
unless(defined(&sz_XRecordState)) {
    sub sz_XRecordState () {	16;}
}
unless(defined(&sz_XRecordDatum)) {
    sub sz_XRecordDatum () {	32;}
}
unless(defined(&XRecordGlobaldef)) {
    sub XRecordGlobaldef () {	1;}
}
unless(defined(&XRecordGlobalref)) {
    sub XRecordGlobalref () {	 &extern;}
}
unless(defined(&RecordMaxEvent)) {
    sub RecordMaxEvent () {	(128-1);}
}
unless(defined(&RecordMinDeviceEvent)) {
    sub RecordMinDeviceEvent () {	(2);}
}
unless(defined(&RecordMaxDeviceEvent)) {
    sub RecordMaxDeviceEvent () {	(6);}
}
unless(defined(&RecordMaxError)) {
    sub RecordMaxError () {	(256-1);}
}
unless(defined(&RecordMaxCoreRequest)) {
    sub RecordMaxCoreRequest () {	(128-1);}
}
unless(defined(&RecordMaxExtRequest)) {
    sub RecordMaxExtRequest () {	(256-1);}
}
unless(defined(&RecordMinExtRequest)) {
    sub RecordMinExtRequest () {	(129-1);}
}
unless(defined(&RECORD_RC)) {
    sub RECORD_RC () {	 &CARD32;}
}
unless(defined(&RECORD_XIDBASE)) {
    sub RECORD_XIDBASE () {	 &CARD32;}
}
unless(defined(&RECORD_CLIENTSPEC)) {
    sub RECORD_CLIENTSPEC () {	 &CARD32;}
}
unless(defined(&RECORD_ELEMENT_HEADER)) {
    sub RECORD_ELEMENT_HEADER () {	 &CARD8;}
}
unless(defined(&sz_RECORDRANGE)) {
    sub sz_RECORDRANGE () {	24;}
}
unless(defined(&sz_xRecordRange)) {
    sub sz_xRecordRange () {	24;}
}
unless(defined(&sz_xRecordQueryVersionReq)) {
    sub sz_xRecordQueryVersionReq () {	8;}
}
unless(defined(&sz_xRecordQueryVersionReply)) {
    sub sz_xRecordQueryVersionReply () {	32;}
}
unless(defined(&sz_xRecordCreateContextReq)) {
    sub sz_xRecordCreateContextReq () {	20;}
}
unless(defined(&sz_xRecordRegisterClientsReq)) {
    sub sz_xRecordRegisterClientsReq () {	20;}
}
unless(defined(&sz_xRecordUnregisterClientsReq)) {
    sub sz_xRecordUnregisterClientsReq () {	12;}
}
unless(defined(&sz_xRecordGetContextReq)) {
    sub sz_xRecordGetContextReq () {	8;}
}
unless(defined(&sz_xRecordGetContextReply)) {
    sub sz_xRecordGetContextReply () {	32;}
}
unless(defined(&sz_xRecordEnableContextReq)) {
    sub sz_xRecordEnableContextReq () {	8;}
}
unless(defined(&sz_xRecordEnableContextReply)) {
    sub sz_xRecordEnableContextReply () {	32;}
}
unless(defined(&sz_xRecordDisableContextReq)) {
    sub sz_xRecordDisableContextReq () {	8;}
}
unless(defined(&sz_xRecordFreeContextReq)) {
    sub sz_xRecordFreeContextReq () {	8;}
}
undef(&RECORD_RC) if defined(&RECORD_RC);
undef(&RECORD_XIDBASE) if defined(&RECORD_XIDBASE);
undef(&RECORD_ELEMENT_HEADER) if defined(&RECORD_ELEMENT_HEADER);
undef(&RECORD_CLIENTSPEC) if defined(&RECORD_CLIENTSPEC);
1;
