require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SECURITY_H)) {
    eval 'sub _SECURITY_H () {1;}' unless defined(&_SECURITY_H);
    eval 'sub _XAUTH_STRUCT_ONLY () {1;}' unless defined(&_XAUTH_STRUCT_ONLY);
    require 'X11/Xauth.ph';
    eval 'sub XSecurityNumberEvents () {1;}' unless defined(&XSecurityNumberEvents);
    eval 'sub XSecurityNumberErrors () {2;}' unless defined(&XSecurityNumberErrors);
    eval 'sub XSecurityBadAuthorization () {0;}' unless defined(&XSecurityBadAuthorization);
    eval 'sub XSecurityBadAuthorizationProtocol () {1;}' unless defined(&XSecurityBadAuthorizationProtocol);
    eval 'sub XSecurityClientTrusted () {0;}' unless defined(&XSecurityClientTrusted);
    eval 'sub XSecurityClientUntrusted () {1;}' unless defined(&XSecurityClientUntrusted);
    eval 'sub XSecurityTimeout () {(1<<0);}' unless defined(&XSecurityTimeout);
    eval 'sub XSecurityTrustLevel () {(1<<1);}' unless defined(&XSecurityTrustLevel);
    eval 'sub XSecurityGroup () {(1<<2);}' unless defined(&XSecurityGroup);
    eval 'sub XSecurityEventMask () {(1<<3);}' unless defined(&XSecurityEventMask);
    eval 'sub XSecurityAllAuthorizationAttributes () {( &XSecurityTimeout |  &XSecurityTrustLevel |  &XSecurityGroup |  &XSecurityEventMask);}' unless defined(&XSecurityAllAuthorizationAttributes);
    eval 'sub XSecurityAuthorizationRevokedMask () {(1<<0);}' unless defined(&XSecurityAuthorizationRevokedMask);
    eval 'sub XSecurityAllEventMasks () { &XSecurityAuthorizationRevokedMask;}' unless defined(&XSecurityAllEventMasks);
    eval 'sub XSecurityAuthorizationRevoked () {0;}' unless defined(&XSecurityAuthorizationRevoked);
    eval 'sub XSecurityAuthorizationName () {"XC-QUERY-SECURITY-1";}' unless defined(&XSecurityAuthorizationName);
    eval 'sub XSecurityAuthorizationNameLen () {19;}' unless defined(&XSecurityAuthorizationNameLen);
    unless(defined(&_SECURITY_SERVER)) {
    } else {
	require 'input.ph';
	require 'property.ph';
	eval 'sub SECURITY_AUDIT_LEVEL () {4;}' unless defined(&SECURITY_AUDIT_LEVEL);
	eval 'sub SecurityAllowOperation () {0;}' unless defined(&SecurityAllowOperation);
	eval 'sub SecurityIgnoreOperation () {1;}' unless defined(&SecurityIgnoreOperation);
	eval 'sub SecurityErrorOperation () {2;}' unless defined(&SecurityErrorOperation);
	eval 'sub SECURITY_POLICY_FILE_VERSION () {"version-1";}' unless defined(&SECURITY_POLICY_FILE_VERSION);
    }
}
1;
