require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XmRowColumnP_h)) {
    eval 'sub _XmRowColumnP_h () {1;}' unless defined(&_XmRowColumnP_h);
    unless(defined(&MOTIF12_HEADERS)) {
	require 'Xm/RowColumn.ph';
	require 'Xm/ManagerP.ph';
	if(defined(&__cplusplus)) {
	}
	eval 'sub XmRC_ARMED_BIT () {(1<< 0);}' unless defined(&XmRC_ARMED_BIT);
	eval 'sub XmRC_BEING_ARMED_BIT () {(1<< 1);}' unless defined(&XmRC_BEING_ARMED_BIT);
	eval 'sub XmRC_EXPOSE_BIT () {(1<< 2);}' unless defined(&XmRC_EXPOSE_BIT);
	eval 'sub XmRC_WINDOW_MOVED_BIT () {(1<< 3);}' unless defined(&XmRC_WINDOW_MOVED_BIT);
	eval 'sub XmRC_WIDGET_MOVED_BIT () {(1<< 4);}' unless defined(&XmRC_WIDGET_MOVED_BIT);
	eval 'sub XmRC_POPPING_DOWN_BIT () {(1<< 5);}' unless defined(&XmRC_POPPING_DOWN_BIT);
	eval 'sub XmRC_FROM_RESIZE_BIT () {(1<< 6);}' unless defined(&XmRC_FROM_RESIZE_BIT);
	eval 'sub RC_IsArmed {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_ARMED_BIT));
	}' unless defined(&RC_IsArmed);
	eval 'sub RC_BeingArmed {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_BEING_ARMED_BIT));
	}' unless defined(&RC_BeingArmed);
	eval 'sub RC_DoExpose {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_EXPOSE_BIT));
	}' unless defined(&RC_DoExpose);
	eval 'sub RC_WidgetHasMoved {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_WIDGET_MOVED_BIT));
	}' unless defined(&RC_WidgetHasMoved);
	eval 'sub RC_WindowHasMoved {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_WINDOW_MOVED_BIT));
	}' unless defined(&RC_WindowHasMoved);
	eval 'sub RC_PoppingDown {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_POPPING_DOWN_BIT));
	}' unless defined(&RC_PoppingDown);
	eval 'sub RC_FromResize {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_FROM_RESIZE_BIT));
	}' unless defined(&RC_FromResize);
	eval 'sub RC_SetBit {
	    my($byte,$bit,$v) = @_;
    	    eval q($byte = ($byte & (~$bit)) | ($v ? $bit : 0));
	}' unless defined(&RC_SetBit);
	eval 'sub RC_SetArmed {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit ((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_ARMED_BIT, $v));
	}' unless defined(&RC_SetArmed);
	eval 'sub RC_SetBeingArmed {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit ((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_BEING_ARMED_BIT, $v));
	}' unless defined(&RC_SetBeingArmed);
	eval 'sub RC_SetExpose {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit ((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_EXPOSE_BIT, $v));
	}' unless defined(&RC_SetExpose);
	eval 'sub RC_SetWidgetMoved {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_WIDGET_MOVED_BIT,$v));
	}' unless defined(&RC_SetWidgetMoved);
	eval 'sub RC_SetWindowMoved {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_WINDOW_MOVED_BIT,$v));
	}' unless defined(&RC_SetWindowMoved);
	eval 'sub RC_SetPoppingDown {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_POPPING_DOWN_BIT,$v));
	}' unless defined(&RC_SetPoppingDown);
	eval 'sub RC_SetFromResize {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_FROM_RESIZE_BIT,$v));
	}' unless defined(&RC_SetFromResize);
	eval 'sub RC_MarginW {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{margin_width})));
	}' unless defined(&RC_MarginW);
	eval 'sub RC_MarginH {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{margin_height})));
	}' unless defined(&RC_MarginH);
	eval 'sub RC_Entry_cb {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_callback})));
	}' unless defined(&RC_Entry_cb);
	eval 'sub RC_Map_cb {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{map_callback})));
	}' unless defined(&RC_Map_cb);
	eval 'sub RC_Unmap_cb {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{unmap_callback})));
	}' unless defined(&RC_Unmap_cb);
	eval 'sub RC_Orientation {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{orientation})));
	}' unless defined(&RC_Orientation);
	eval 'sub RC_Spacing {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{spacing})));
	}' unless defined(&RC_Spacing);
	eval 'sub RC_EntryBorder {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_border})));
	}' unless defined(&RC_EntryBorder);
	eval 'sub RC_HelpPb {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{help_pushbutton})));
	}' unless defined(&RC_HelpPb);
	eval 'sub RC_DoMarginAdjust {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{adjust_margin})));
	}' unless defined(&RC_DoMarginAdjust);
	eval 'sub RC_EntryAlignment {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_alignment})));
	}' unless defined(&RC_EntryAlignment);
	eval 'sub RC_EntryVerticalAlignment {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_vertical_alignment})));
	}' unless defined(&RC_EntryVerticalAlignment);
	eval 'sub RC_Packing {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{packing})));
	}' unless defined(&RC_Packing);
	eval 'sub RC_NCol {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{num_columns})));
	}' unless defined(&RC_NCol);
	eval 'sub RC_AdjLast {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{adjust_last})));
	}' unless defined(&RC_AdjLast);
	eval 'sub RC_AdjMargin {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{adjust_margin})));
	}' unless defined(&RC_AdjMargin);
	eval 'sub RC_MemWidget {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{memory_subwidget})));
	}' unless defined(&RC_MemWidget);
	eval 'sub RC_CascadeBtn {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{cascadeBtn})));
	}' unless defined(&RC_CascadeBtn);
	eval 'sub RC_OptionLabel {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{option_label})));
	}' unless defined(&RC_OptionLabel);
	eval 'sub RC_OptionSubMenu {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{option_submenu})));
	}' unless defined(&RC_OptionSubMenu);
	eval 'sub RC_RadioBehavior {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{radio})));
	}' unless defined(&RC_RadioBehavior);
	eval 'sub RC_RadioAlwaysOne {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{radio_one})));
	}' unless defined(&RC_RadioAlwaysOne);
	eval 'sub RC_PopupPosted {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{popupPosted})));
	}' unless defined(&RC_PopupPosted);
	eval 'sub RC_ResizeHeight {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{resize_height})));
	}' unless defined(&RC_ResizeHeight);
	eval 'sub RC_ResizeWidth {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{resize_width})));
	}' unless defined(&RC_ResizeWidth);
	eval 'sub RC_Type {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{type})));
	}' unless defined(&RC_Type);
	eval 'sub RC_EntryClass {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_class})));
	}' unless defined(&RC_EntryClass);
	eval 'sub RC_IsHomogeneous {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{homogeneous})));
	}' unless defined(&RC_IsHomogeneous);
	eval 'sub RC_Boxes {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{boxes})));
	}' unless defined(&RC_Boxes);
	eval 'sub RC_PopupEnabled {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{popup_enabled})));
	}' unless defined(&RC_PopupEnabled);
	eval 'sub RC_MenuAccelerator {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{menu_accelerator})));
	}' unless defined(&RC_MenuAccelerator);
	eval 'sub RC_Mnemonic {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{mnemonic})));
	}' unless defined(&RC_Mnemonic);
	eval 'sub RC_MnemonicCharSet {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{mnemonicCharSet})));
	}' unless defined(&RC_MnemonicCharSet);
	eval 'sub RC_MenuPost {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{menuPost})));
	}' unless defined(&RC_MenuPost);
	eval 'sub RC_PostButton {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{postButton})));
	}' unless defined(&RC_PostButton);
	eval 'sub RC_PostModifiers {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{postModifiers})));
	}' unless defined(&RC_PostModifiers);
	eval 'sub RC_PostEventType {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{postEventType})));
	}' unless defined(&RC_PostEventType);
	eval 'sub RC_OldFocusPolicy {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{oldFocusPolicy})));
	}' unless defined(&RC_OldFocusPolicy);
	eval 'sub RC_ParentShell {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{ParentShell})));
	}' unless defined(&RC_ParentShell);
	eval 'sub RC_TearOffControl {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{tear_off_control})));
	}' unless defined(&RC_TearOffControl);
	eval 'sub RC_TearOffModel {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{TearOffModel})));
	}' unless defined(&RC_TearOffModel);
	eval 'sub RC_popupMenuClick {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{popup_menu_click})));
	}' unless defined(&RC_popupMenuClick);
	eval 'sub RC_TearOffTitle {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{tear_off_title})));
	}' unless defined(&RC_TearOffTitle);
	eval 'sub XmTO_TORN_OFF_BIT () {(1<< 0);}' unless defined(&XmTO_TORN_OFF_BIT);
	eval 'sub XmTO_FROM_INIT_BIT () {(1<< 1);}' unless defined(&XmTO_FROM_INIT_BIT);
	eval 'sub XmTO_VISUAL_DIRTY_BIT () {(1<< 2);}' unless defined(&XmTO_VISUAL_DIRTY_BIT);
	eval 'sub XmTO_ACTIVE_BIT () {(1<< 3);}' unless defined(&XmTO_ACTIVE_BIT);
	eval 'sub RC_SetTornOff {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}),  &XmTO_TORN_OFF_BIT,$v));
	}' unless defined(&RC_SetTornOff);
	eval 'sub RC_TornOff {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}) &  &XmTO_TORN_OFF_BIT));
	}' unless defined(&RC_TornOff);
	eval 'sub RC_SetFromInit {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}),  &XmTO_FROM_INIT_BIT,$v));
	}' unless defined(&RC_SetFromInit);
	eval 'sub RC_FromInit {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}) &  &XmTO_FROM_INIT_BIT));
	}' unless defined(&RC_FromInit);
	eval 'sub RC_SetTearOffDirty {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}),  &XmTO_VISUAL_DIRTY_BIT,$v));
	}' unless defined(&RC_SetTearOffDirty);
	eval 'sub RC_TearOffDirty {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}) &  &XmTO_VISUAL_DIRTY_BIT));
	}' unless defined(&RC_TearOffDirty);
	eval 'sub RC_TearOffActive {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}) &  &XmTO_ACTIVE_BIT));
	}' unless defined(&RC_TearOffActive);
	eval 'sub RC_SetTearOffActive {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}),  &XmTO_ACTIVE_BIT,$v));
	}' unless defined(&RC_SetTearOffActive);
	eval 'sub initial_value () {0;}' unless defined(&initial_value);
	eval 'sub XmADD () {0;}' unless defined(&XmADD);
	eval 'sub XmDELETE () {1;}' unless defined(&XmDELETE);
	eval 'sub XmREPLACE () {2;}' unless defined(&XmREPLACE);
	eval 'sub XmWEAK_CHECK () {1;}' unless defined(&XmWEAK_CHECK);
	eval 'sub XmMEDIUM_CHECK () {2;}' unless defined(&XmMEDIUM_CHECK);
	eval 'sub XmSTRONG_CHECK () {3;}' unless defined(&XmSTRONG_CHECK);
	eval 'sub XmMENU_BEGIN () {0;}' unless defined(&XmMENU_BEGIN);
	eval 'sub XmMENU_MIDDLE () {1;}' unless defined(&XmMENU_MIDDLE);
	eval 'sub XmMENU_END () {2;}' unless defined(&XmMENU_END);
	eval 'sub ANY_CHILD () {0;}' unless defined(&ANY_CHILD);
	eval 'sub FIRST_BUTTON () {1;}' unless defined(&FIRST_BUTTON);
	eval 'sub XmInheritMenuProceduresProc () {(( &XmMenuProc)  &_XtInherit);}' unless defined(&XmInheritMenuProceduresProc);
	eval 'sub XmInheritArmAndActivateProc () {(( &XtActionProc)  &_XtInherit);}' unless defined(&XmInheritArmAndActivateProc);
	eval 'sub XmInheritMenuTraversalProc () {(( &XmMenuTraversalProc)  &_XtInherit);}' unless defined(&XmInheritMenuTraversalProc);
	if(defined(&__cplusplus)) {
	}
    } else {
	require 'Xm/RowColumn.ph';
	require 'Xm/ManagerP.ph';
	if(defined(&__cplusplus)) {
	}
	unless(defined(&WAIT_FOR_BETTER_GRAB_SOLUTION)) {
	}
	eval 'sub XmRC_ARMED_BIT () {(1<< 0);}' unless defined(&XmRC_ARMED_BIT);
	eval 'sub XmRC_BEING_ARMED_BIT () {(1<< 1);}' unless defined(&XmRC_BEING_ARMED_BIT);
	eval 'sub XmRC_EXPOSE_BIT () {(1<< 2);}' unless defined(&XmRC_EXPOSE_BIT);
	eval 'sub XmRC_WINDOW_MOVED_BIT () {(1<< 3);}' unless defined(&XmRC_WINDOW_MOVED_BIT);
	eval 'sub XmRC_WIDGET_MOVED_BIT () {(1<< 4);}' unless defined(&XmRC_WIDGET_MOVED_BIT);
	eval 'sub XmRC_POPPING_DOWN_BIT () {(1<< 5);}' unless defined(&XmRC_POPPING_DOWN_BIT);
	eval 'sub XmRC_FROM_RESIZE_BIT () {(1<< 6);}' unless defined(&XmRC_FROM_RESIZE_BIT);
	eval 'sub RC_IsArmed {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_ARMED_BIT));
	}' unless defined(&RC_IsArmed);
	eval 'sub RC_BeingArmed {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_BEING_ARMED_BIT));
	}' unless defined(&RC_BeingArmed);
	eval 'sub RC_DoExpose {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_EXPOSE_BIT));
	}' unless defined(&RC_DoExpose);
	eval 'sub RC_WidgetHasMoved {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_WIDGET_MOVED_BIT));
	}' unless defined(&RC_WidgetHasMoved);
	eval 'sub RC_WindowHasMoved {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_WINDOW_MOVED_BIT));
	}' unless defined(&RC_WindowHasMoved);
	eval 'sub RC_PoppingDown {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_POPPING_DOWN_BIT));
	}' unless defined(&RC_PoppingDown);
	eval 'sub RC_FromResize {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{armed}) &  &XmRC_FROM_RESIZE_BIT));
	}' unless defined(&RC_FromResize);
	eval 'sub RC_SetBit {
	    my($byte,$bit,$v) = @_;
    	    eval q($byte = ($byte & (~$bit)) | ($v ? $bit : 0));
	}' unless defined(&RC_SetBit);
	eval 'sub RC_SetArmed {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit ((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_ARMED_BIT, $v));
	}' unless defined(&RC_SetArmed);
	eval 'sub RC_SetBeingArmed {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit ((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_BEING_ARMED_BIT, $v));
	}' unless defined(&RC_SetBeingArmed);
	eval 'sub RC_SetExpose {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit ((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_EXPOSE_BIT, $v));
	}' unless defined(&RC_SetExpose);
	eval 'sub RC_SetWidgetMoved {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_WIDGET_MOVED_BIT,$v));
	}' unless defined(&RC_SetWidgetMoved);
	eval 'sub RC_SetWindowMoved {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_WINDOW_MOVED_BIT,$v));
	}' unless defined(&RC_SetWindowMoved);
	eval 'sub RC_SetPoppingDown {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_POPPING_DOWN_BIT,$v));
	}' unless defined(&RC_SetPoppingDown);
	eval 'sub RC_SetFromResize {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{armed}),  &XmRC_FROM_RESIZE_BIT,$v));
	}' unless defined(&RC_SetFromResize);
	eval 'sub RC_MarginW {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{margin_width})));
	}' unless defined(&RC_MarginW);
	eval 'sub RC_MarginH {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{margin_height})));
	}' unless defined(&RC_MarginH);
	eval 'sub RC_Entry_cb {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_callback})));
	}' unless defined(&RC_Entry_cb);
	eval 'sub RC_Map_cb {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{map_callback})));
	}' unless defined(&RC_Map_cb);
	eval 'sub RC_Unmap_cb {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{unmap_callback})));
	}' unless defined(&RC_Unmap_cb);
	eval 'sub RC_Orientation {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{orientation})));
	}' unless defined(&RC_Orientation);
	eval 'sub RC_Spacing {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{spacing})));
	}' unless defined(&RC_Spacing);
	eval 'sub RC_EntryBorder {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_border})));
	}' unless defined(&RC_EntryBorder);
	eval 'sub RC_HelpPb {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{help_pushbutton})));
	}' unless defined(&RC_HelpPb);
	eval 'sub RC_DoMarginAdjust {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{adjust_margin})));
	}' unless defined(&RC_DoMarginAdjust);
	eval 'sub RC_EntryAlignment {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_alignment})));
	}' unless defined(&RC_EntryAlignment);
	eval 'sub RC_EntryVerticalAlignment {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_vertical_alignment})));
	}' unless defined(&RC_EntryVerticalAlignment);
	eval 'sub RC_Packing {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{packing})));
	}' unless defined(&RC_Packing);
	eval 'sub RC_NCol {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{num_columns})));
	}' unless defined(&RC_NCol);
	eval 'sub RC_AdjLast {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{adjust_last})));
	}' unless defined(&RC_AdjLast);
	eval 'sub RC_AdjMargin {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{adjust_margin})));
	}' unless defined(&RC_AdjMargin);
	eval 'sub RC_MemWidget {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{memory_subwidget})));
	}' unless defined(&RC_MemWidget);
	eval 'sub RC_CascadeBtn {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{cascadeBtn})));
	}' unless defined(&RC_CascadeBtn);
	eval 'sub RC_OptionLabel {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{option_label})));
	}' unless defined(&RC_OptionLabel);
	eval 'sub RC_OptionSubMenu {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{option_submenu})));
	}' unless defined(&RC_OptionSubMenu);
	eval 'sub RC_RadioBehavior {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{radio})));
	}' unless defined(&RC_RadioBehavior);
	eval 'sub RC_RadioAlwaysOne {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{radio_one})));
	}' unless defined(&RC_RadioAlwaysOne);
	eval 'sub RC_PopupPosted {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{popupPosted})));
	}' unless defined(&RC_PopupPosted);
	eval 'sub RC_ResizeHeight {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{resize_height})));
	}' unless defined(&RC_ResizeHeight);
	eval 'sub RC_ResizeWidth {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{resize_width})));
	}' unless defined(&RC_ResizeWidth);
	eval 'sub RC_Type {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{type})));
	}' unless defined(&RC_Type);
	eval 'sub RC_EntryClass {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{entry_class})));
	}' unless defined(&RC_EntryClass);
	eval 'sub RC_IsHomogeneous {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{homogeneous})));
	}' unless defined(&RC_IsHomogeneous);
	eval 'sub RC_Boxes {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{boxes})));
	}' unless defined(&RC_Boxes);
	eval 'sub RC_PopupEnabled {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{popup_enabled})));
	}' unless defined(&RC_PopupEnabled);
	eval 'sub RC_MenuAccelerator {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{menu_accelerator})));
	}' unless defined(&RC_MenuAccelerator);
	eval 'sub RC_Mnemonic {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{mnemonic})));
	}' unless defined(&RC_Mnemonic);
	eval 'sub RC_MnemonicCharSet {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{mnemonicCharSet})));
	}' unless defined(&RC_MnemonicCharSet);
	eval 'sub RC_MenuPost {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{menuPost})));
	}' unless defined(&RC_MenuPost);
	eval 'sub RC_PostButton {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{postButton})));
	}' unless defined(&RC_PostButton);
	eval 'sub RC_PostModifiers {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{postModifiers})));
	}' unless defined(&RC_PostModifiers);
	eval 'sub RC_PostEventType {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{postEventType})));
	}' unless defined(&RC_PostEventType);
	eval 'sub RC_OldFocusPolicy {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{oldFocusPolicy})));
	}' unless defined(&RC_OldFocusPolicy);
	eval 'sub RC_ParentShell {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{ParentShell})));
	}' unless defined(&RC_ParentShell);
	eval 'sub RC_TearOffControl {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{tear_off_control})));
	}' unless defined(&RC_TearOffControl);
	eval 'sub RC_TearOffModel {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget) $m)-> ($row_column->{TearOffModel})));
	}' unless defined(&RC_TearOffModel);
	eval 'sub RC_popupMenuClick {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{popup_menu_click})));
	}' unless defined(&RC_popupMenuClick);
	eval 'sub XmTO_TORN_OFF_BIT () {(1<< 0);}' unless defined(&XmTO_TORN_OFF_BIT);
	eval 'sub XmTO_FROM_INIT_BIT () {(1<< 1);}' unless defined(&XmTO_FROM_INIT_BIT);
	eval 'sub XmTO_VISUAL_DIRTY_BIT () {(1<< 2);}' unless defined(&XmTO_VISUAL_DIRTY_BIT);
	eval 'sub XmTO_ACTIVE_BIT () {(1<< 3);}' unless defined(&XmTO_ACTIVE_BIT);
	eval 'sub RC_SetTornOff {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}),  &XmTO_TORN_OFF_BIT,$v));
	}' unless defined(&RC_SetTornOff);
	eval 'sub RC_TornOff {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}) &  &XmTO_TORN_OFF_BIT));
	}' unless defined(&RC_TornOff);
	eval 'sub RC_SetFromInit {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}),  &XmTO_FROM_INIT_BIT,$v));
	}' unless defined(&RC_SetFromInit);
	eval 'sub RC_FromInit {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}) &  &XmTO_FROM_INIT_BIT));
	}' unless defined(&RC_FromInit);
	eval 'sub RC_SetTearOffDirty {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}),  &XmTO_VISUAL_DIRTY_BIT,$v));
	}' unless defined(&RC_SetTearOffDirty);
	eval 'sub RC_TearOffDirty {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}) &  &XmTO_VISUAL_DIRTY_BIT));
	}' unless defined(&RC_TearOffDirty);
	eval 'sub RC_TearOffActive {
	    my($m) = @_;
    	    eval q(((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}) &  &XmTO_ACTIVE_BIT));
	}' unless defined(&RC_TearOffActive);
	eval 'sub RC_SetTearOffActive {
	    my($m,$v) = @_;
    	    eval q( &RC_SetBit((( &XmRowColumnWidget)($m))-> ($row_column->{to_state}),  &XmTO_ACTIVE_BIT,$v));
	}' unless defined(&RC_SetTearOffActive);
	eval 'sub initial_value () {0;}' unless defined(&initial_value);
	eval 'sub XmADD () {0;}' unless defined(&XmADD);
	eval 'sub XmDELETE () {1;}' unless defined(&XmDELETE);
	eval 'sub XmREPLACE () {2;}' unless defined(&XmREPLACE);
	eval 'sub XmWEAK_CHECK () {1;}' unless defined(&XmWEAK_CHECK);
	eval 'sub XmMEDIUM_CHECK () {2;}' unless defined(&XmMEDIUM_CHECK);
	eval 'sub XmSTRONG_CHECK () {3;}' unless defined(&XmSTRONG_CHECK);
	eval 'sub XmMENU_BEGIN () {0;}' unless defined(&XmMENU_BEGIN);
	eval 'sub XmMENU_MIDDLE () {1;}' unless defined(&XmMENU_MIDDLE);
	eval 'sub XmMENU_END () {2;}' unless defined(&XmMENU_END);
	eval 'sub ANY_CHILD () {0;}' unless defined(&ANY_CHILD);
	eval 'sub FIRST_BUTTON () {1;}' unless defined(&FIRST_BUTTON);
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&__cplusplus)) {
	}
    }
}
1;
