require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XmP_h)) {
    eval 'sub _XmP_h () {1;}' unless defined(&_XmP_h);
    unless(defined(&MOTIF12_HEADERS)) {
	require 'Xm/Xm.ph';
	require 'X11/IntrinsicP.ph';
	require 'X11/ObjectP.ph';
	require 'Xm/ColorP.ph';
	require 'Xm/AccColorT.ph';
	if(defined(&__cplusplus)) {
	}
	unless(defined(&NO_XM_1_2_XTMACROS)) {
	    eval 'sub XM_1_2_XTMACROS () {1;}' unless defined(&XM_1_2_XTMACROS);
	}
	if(defined(&XM_1_2_XTMACROS)) {
	    if(defined(&XtClass)) {
		undef(&XtClass) if defined(&XtClass);
	    }
	    eval 'sub XtClass {
	        my($widget) = @_;
    		eval q(((( &Object)($widget))-> ($object->{widget_class})));
	    }' unless defined(&XtClass);
	    if(defined(&XtParent)) {
		undef(&XtParent) if defined(&XtParent);
	    }
	    eval 'sub XtParent {
	        my($widget) = @_;
    		eval q(((( &Object)($widget))-> ($object->{parent})));
	    }' unless defined(&XtParent);
	    if(defined(&XtDisplay)) {
		undef(&XtDisplay) if defined(&XtDisplay);
	    }
	    eval 'sub XtDisplay {
	        my($widget) = @_;
    		eval q( &XtDisplayOfObject(( &Widget) $widget));
	    }' unless defined(&XtDisplay);
	    if(defined(&XtScreen)) {
		undef(&XtScreen) if defined(&XtScreen);
	    }
	    eval 'sub XtScreen {
	        my($widget) = @_;
    		eval q( &XtScreenOfObject(( &Widget) $widget));
	    }' unless defined(&XtScreen);
	    if(defined(&XtWindow)) {
		undef(&XtWindow) if defined(&XtWindow);
	    }
	    eval 'sub XtWindow {
	        my($widget) = @_;
    		eval q( &XtWindowOfObject(( &Widget) $widget));
	    }' unless defined(&XtWindow);
	    eval 'sub XtX {
	        my($w) = @_;
    		eval q((($w)-> ($core->{x})));
	    }' unless defined(&XtX);
	    eval 'sub XtY {
	        my($w) = @_;
    		eval q((($w)-> ($core->{y})));
	    }' unless defined(&XtY);
	    eval 'sub XtWidth {
	        my($w) = @_;
    		eval q((($w)-> ($core->{width})));
	    }' unless defined(&XtWidth);
	    eval 'sub XtHeight {
	        my($w) = @_;
    		eval q((($w)-> ($core->{height})));
	    }' unless defined(&XtHeight);
	    eval 'sub XtBorderWidth {
	        my($w) = @_;
    		eval q((($w)-> ($core->{border_width})));
	    }' unless defined(&XtBorderWidth);
	    eval 'sub XtBackground {
	        my($w) = @_;
    		eval q((($w)-> ($core->{background_pixel})));
	    }' unless defined(&XtBackground);
	    eval 'sub XtCoreProc {
	        my($w,$proc) = @_;
    		eval q((($w)-> ($core->{widget_class}->{core_class}->{proc})));
	    }' unless defined(&XtCoreProc);
	}
	eval 'sub XmNdotCache () {".cache";}' unless defined(&XmNdotCache);
	eval 'sub XmCDotCache () {".Cache";}' unless defined(&XmCDotCache);
	eval 'sub XmDELAYED_PIXMAP () {( &XmUNSPECIFIED_PIXMAP - 1);}' unless defined(&XmDELAYED_PIXMAP);
	eval 'sub XmUNSPECIFIED () {(~0);}' unless defined(&XmUNSPECIFIED);
	eval 'sub XmUNSPECIFIED_COUNT () {(~0);}' unless defined(&XmUNSPECIFIED_COUNT);
	eval 'sub _XM_CONVERTER_DONE {
	    my( $to_rtn, $type, $value, $failure ) = @_;
    	    eval q({  &static $type  &buf ;  &if ( ($to_rtn->{addr})) {  &if ( ($to_rtn->{size}) < $sizeof{$type}) { $failure  ($to_rtn->{size}) = $sizeof{$type};  &return  &FALSE; }  &else { *(($type *) ( ($to_rtn->{addr}))) = $value; } }  &else {  &buf = $value;  ($to_rtn->{addr}) = ( &XPointer)  &buf; }  ($to_rtn->{size}) = $sizeof{$type};  &return  &TRUE; });
	}' unless defined(&_XM_CONVERTER_DONE);
	eval 'sub Xm3D_ENHANCE_PIXEL () {2;}' unless defined(&Xm3D_ENHANCE_PIXEL);
	eval 'sub XmINDICATOR_SHADOW_THICKNESS () {2;}' unless defined(&XmINDICATOR_SHADOW_THICKNESS);
	eval 'sub XmINVALID_DIMENSION () {0xffff;}' unless defined(&XmINVALID_DIMENSION);
	unless(defined(&XmConst)) {
	    if(defined( &__STDC__) || !defined( (defined(&NO_CONST) ? &NO_CONST : 0) )) {
		eval 'sub XmConst () { &const;}' unless defined(&XmConst);
	    } else {
		eval 'sub XmConst () {1;}' unless defined(&XmConst);
	    }
	}
	eval("sub XmMENU_POPDOWN () { 0; }") unless defined(&XmMENU_POPDOWN);
	eval("sub XmMENU_PROCESS_TREE () { 1; }") unless defined(&XmMENU_PROCESS_TREE);
	eval("sub XmMENU_TRAVERSAL () { 2; }") unless defined(&XmMENU_TRAVERSAL);
	eval("sub XmMENU_SHELL_POPDOWN () { 3; }") unless defined(&XmMENU_SHELL_POPDOWN);
	eval("sub XmMENU_CALLBACK () { 4; }") unless defined(&XmMENU_CALLBACK);
	eval("sub XmMENU_BUTTON () { 5; }") unless defined(&XmMENU_BUTTON);
	eval("sub XmMENU_CASCADING () { 6; }") unless defined(&XmMENU_CASCADING);
	eval("sub XmMENU_SUBMENU () { 7; }") unless defined(&XmMENU_SUBMENU);
	eval("sub XmMENU_ARM () { 8; }") unless defined(&XmMENU_ARM);
	eval("sub XmMENU_DISARM () { 9; }") unless defined(&XmMENU_DISARM);
	eval("sub XmMENU_BAR_CLEANUP () { 10; }") unless defined(&XmMENU_BAR_CLEANUP);
	eval("sub XmMENU_STATUS () { 11; }") unless defined(&XmMENU_STATUS);
	eval("sub XmMENU_MEMWIDGET_UPDATE () { 12; }") unless defined(&XmMENU_MEMWIDGET_UPDATE);
	eval("sub XmMENU_BUTTON_POPDOWN () { 13; }") unless defined(&XmMENU_BUTTON_POPDOWN);
	eval("sub XmMENU_RESTORE_EXCLUDED_TEAROFF_TO_TOPLEVEL_SHELL () { 14; }") unless defined(&XmMENU_RESTORE_EXCLUDED_TEAROFF_TO_TOPLEVEL_SHELL);
	eval("sub XmMENU_RESTORE_TEAROFF_TO_TOPLEVEL_SHELL () { 15; }") unless defined(&XmMENU_RESTORE_TEAROFF_TO_TOPLEVEL_SHELL);
	eval("sub XmMENU_RESTORE_TEAROFF_TO_MENUSHELL () { 16; }") unless defined(&XmMENU_RESTORE_TEAROFF_TO_MENUSHELL);
	eval("sub XmMENU_GET_LAST_SELECT_TOPLEVEL () { 17; }") unless defined(&XmMENU_GET_LAST_SELECT_TOPLEVEL);
	eval("sub XmMENU_TEAR_OFF_ARM () { 18; }") unless defined(&XmMENU_TEAR_OFF_ARM);
	eval 'sub XmMENU_TORN_BIT () {(1<< 0);}' unless defined(&XmMENU_TORN_BIT);
	eval 'sub XmMENU_TEAR_OFF_SHELL_DESCENDANT_BIT () {(1<< 1);}' unless defined(&XmMENU_TEAR_OFF_SHELL_DESCENDANT_BIT);
	eval 'sub XmMENU_POPUP_POSTED_BIT () {(1<< 2);}' unless defined(&XmMENU_POPUP_POSTED_BIT);
	eval 'sub XmMENU_IN_DRAG_MODE_BIT () {(1<< 3);}' unless defined(&XmMENU_IN_DRAG_MODE_BIT);
	eval 'sub XmIsTorn {
	    my($mask) = @_;
    	    eval q(($mask &  &XmMENU_TORN_BIT));
	}' unless defined(&XmIsTorn);
	eval 'sub XmIsTearOffShellDescendant {
	    my($mask) = @_;
    	    eval q(($mask &  &XmMENU_TEAR_OFF_SHELL_DESCENDANT_BIT));
	}' unless defined(&XmIsTearOffShellDescendant);
	eval 'sub XmPopupPosted {
	    my($mask) = @_;
    	    eval q(($mask &  &XmMENU_POPUP_POSTED_BIT));
	}' unless defined(&XmPopupPosted);
	eval 'sub XmIsInDragMode {
	    my($mask) = @_;
    	    eval q(($mask &  &XmMENU_IN_DRAG_MODE_BIT));
	}' unless defined(&XmIsInDragMode);
	eval 'sub XmIGNORE_EVENTTYPE () {-1;}' unless defined(&XmIGNORE_EVENTTYPE);
	eval 'sub XmDEFAULT_INDICATOR_DIM () {9;}' unless defined(&XmDEFAULT_INDICATOR_DIM);
	eval("sub XmSYNTHETIC_NONE () { 0; }") unless defined(&XmSYNTHETIC_NONE);
	eval("sub XmSYNTHETIC_LOAD () { 1; }") unless defined(&XmSYNTHETIC_LOAD);
	eval("sub XmPARENT_PROCESS_ANY () { 0; }") unless defined(&XmPARENT_PROCESS_ANY);
	eval("sub XmINPUT_ACTION () { 1; }") unless defined(&XmINPUT_ACTION);
	eval("sub XmPARENT_ACTIVATE () { 0; }") unless defined(&XmPARENT_ACTIVATE);
	eval("sub XmPARENT_CANCEL () { 1; }") unless defined(&XmPARENT_CANCEL);
	eval 'sub XmRETURN () { &XmPARENT_ACTIVATE;}' unless defined(&XmRETURN);
	eval 'sub XmCANCEL () { &XmPARENT_CANCEL;}' unless defined(&XmCANCEL);
	eval("sub XmBASELINE_GET () { 0; }") unless defined(&XmBASELINE_GET);
	eval("sub XmBASELINE_SET () { 1; }") unless defined(&XmBASELINE_SET);
	eval("sub XmFOCUS_IN () { 0; }") unless defined(&XmFOCUS_IN);
	eval("sub XmFOCUS_OUT () { 1; }") unless defined(&XmFOCUS_OUT);
	eval("sub XmENTER () { 2; }") unless defined(&XmENTER);
	eval("sub XmLEAVE () { 3; }") unless defined(&XmLEAVE);
	eval("sub XmNOT_NAVIGABLE () { 0; }") unless defined(&XmNOT_NAVIGABLE);
	eval("sub XmCONTROL_NAVIGABLE () { 1; }") unless defined(&XmCONTROL_NAVIGABLE);
	eval("sub XmTAB_NAVIGABLE () { 2; }") unless defined(&XmTAB_NAVIGABLE);
	eval("sub XmDESCENDANTS_NAVIGABLE () { 3; }") unless defined(&XmDESCENDANTS_NAVIGABLE);
	eval("sub XmDESCENDANTS_TAB_NAVIGABLE () { 4; }") unless defined(&XmDESCENDANTS_TAB_NAVIGABLE);
	eval 'sub XmVoidProc () { &XtProc;}' unless defined(&XmVoidProc);
	if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	} else {
	}
	eval("sub XmsdLeft () { 0; }") unless defined(&XmsdLeft);
	eval("sub XmsdRight () { 1; }") unless defined(&XmsdRight);
	if(defined(&SUN_CTL)) {
	    eval("sub XmcdLTR () { 0; }") unless defined(&XmcdLTR);
	    eval("sub XmcdRTL () { 1; }") unless defined(&XmcdRTL);
	    eval("sub XmCURSOR_DIRECTION_B_L () { 0; }") unless defined(&XmCURSOR_DIRECTION_B_L);
	    eval("sub XmCURSOR_DIRECTION_B_R () { 1; }") unless defined(&XmCURSOR_DIRECTION_B_R);
	    eval("sub XmCURSOR_DIRECTION_L_L () { 2; }") unless defined(&XmCURSOR_DIRECTION_L_L);
	    eval("sub XmCURSOR_DIRECTION_L_R () { 3; }") unless defined(&XmCURSOR_DIRECTION_L_R);
	    eval("sub XmCURSOR_DIRECTION_L_E () { 4; }") unless defined(&XmCURSOR_DIRECTION_L_E);
	    eval("sub XmCURSOR_DIRECTION_R_R () { 5; }") unless defined(&XmCURSOR_DIRECTION_R_R);
	    eval("sub XmCURSOR_DIRECTION_R_L () { 6; }") unless defined(&XmCURSOR_DIRECTION_R_L);
	    eval("sub XmCURSOR_DIRECTION_R_E () { 7; }") unless defined(&XmCURSOR_DIRECTION_R_E);
	    eval("sub XmEDGE_NEAREST () { 0; }") unless defined(&XmEDGE_NEAREST);
	    eval("sub XmEDGE_LEFT () { 1; }") unless defined(&XmEDGE_LEFT);
	    eval("sub XmEDGE_RIGHT () { 2; }") unless defined(&XmEDGE_RIGHT);
	    eval("sub XmEDGE_BEG () { 3; }") unless defined(&XmEDGE_BEG);
	    eval("sub XmEDGE_END () { 4; }") unless defined(&XmEDGE_END);
	}
	eval("sub XmCHAR_OK () { 0; }") unless defined(&XmCHAR_OK);
	eval("sub XmCHAR_EILSEQ () { 1; }") unless defined(&XmCHAR_EILSEQ);
	if(defined(&SUN_CTL)) {
	}
	eval("sub XmDEST_SELECT () { 0; }") unless defined(&XmDEST_SELECT);
	eval("sub XmPRIM_SELECT () { 1; }") unless defined(&XmPRIM_SELECT);
	eval("sub _XM_IS_DEST_CTX () { 0; }") unless defined(&_XM_IS_DEST_CTX);
	eval("sub _XM_IS_GC_DATA_CTX () { 1; }") unless defined(&_XM_IS_GC_DATA_CTX);
	eval("sub _XM_IS_PIXMAP_CTX () { 2; }") unless defined(&_XM_IS_PIXMAP_CTX);
	eval 'sub XmTEXT_DRAG_ICON_WIDTH () {64;}' unless defined(&XmTEXT_DRAG_ICON_WIDTH);
	eval 'sub XmTEXT_DRAG_ICON_HEIGHT () {64;}' unless defined(&XmTEXT_DRAG_ICON_HEIGHT);
	eval 'sub XmTEXT_DRAG_ICON_X_HOT () {10;}' unless defined(&XmTEXT_DRAG_ICON_X_HOT);
	eval 'sub XmTEXT_DRAG_ICON_Y_HOT () {4;}' unless defined(&XmTEXT_DRAG_ICON_Y_HOT);
	eval("sub XmGET_ACTUAL_SIZE () { 1; }") unless defined(&XmGET_ACTUAL_SIZE);
	eval("sub XmGET_PREFERRED_SIZE () { 2; }") unless defined(&XmGET_PREFERRED_SIZE);
	eval("sub XmGEO_PRE_SET () { 3; }") unless defined(&XmGEO_PRE_SET);
	eval("sub XmGEO_POST_SET () { 4; }") unless defined(&XmGEO_POST_SET);
	eval("sub XmGEO_EXPAND () { 0; }") unless defined(&XmGEO_EXPAND);
	eval("sub XmGEO_CENTER () { 1; }") unless defined(&XmGEO_CENTER);
	eval("sub XmGEO_PACK () { 2; }") unless defined(&XmGEO_PACK);
	eval("sub XmGEO_PROPORTIONAL () { 0; }") unless defined(&XmGEO_PROPORTIONAL);
	eval("sub XmGEO_AVERAGING () { 1; }") unless defined(&XmGEO_AVERAGING);
	eval("sub XmGEO_WRAP () { 2; }") unless defined(&XmGEO_WRAP);
	eval("sub XmGEO_ROW_MAJOR () { 0; }") unless defined(&XmGEO_ROW_MAJOR);
	eval("sub XmGEO_COLUMN_MAJOR () { 1; }") unless defined(&XmGEO_COLUMN_MAJOR);
	if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	} else {
	}
	eval 'sub XmInheritCallbackProc () {(( &XtCallbackProc)  &_XtInherit);}' unless defined(&XmInheritCallbackProc);
	eval 'sub XmInheritTraversalProc () {(( &XmTraversalProc)  &_XtInherit);}' unless defined(&XmInheritTraversalProc);
	eval 'sub XmInheritParentProcess () {(( &XmParentProcessProc)  &_XtInherit);}' unless defined(&XmInheritParentProcess);
	eval 'sub XmInheritWidgetProc () {(( &XtWidgetProc)  &_XtInherit);}' unless defined(&XmInheritWidgetProc);
	eval 'sub XmInheritMenuProc () {(( &XmMenuProc)  &_XtInherit);}' unless defined(&XmInheritMenuProc);
	eval 'sub XmInheritTranslations () { &XtInheritTranslations;}' unless defined(&XmInheritTranslations);
	eval 'sub XmInheritCachePart () {(( &XmCacheClassPartPtr)  &_XtInherit);}' unless defined(&XmInheritCachePart);
	eval 'sub XmInheritBaselineProc () {(( &XmWidgetBaselineProc)  &_XtInherit);}' unless defined(&XmInheritBaselineProc);
	eval 'sub XmInheritDisplayRectProc () {(( &XmWidgetDisplayRectProc)  &_XtInherit);}' unless defined(&XmInheritDisplayRectProc);
	eval 'sub XmInheritMarginsProc () {(( &XmWidgetMarginsProc)  &_XtInherit);}' unless defined(&XmInheritMarginsProc);
	eval 'sub XmInheritGeoMatrixCreate () {(( &XmGeoCreateProc)  &_XtInherit);}' unless defined(&XmInheritGeoMatrixCreate);
	eval 'sub XmInheritFocusMovedProc () {(( &XmFocusMovedProc)  &_XtInherit);}' unless defined(&XmInheritFocusMovedProc);
	eval 'sub XmInheritClass () {(( &WidgetClass) & &_XmInheritClass);}' unless defined(&XmInheritClass);
	eval 'sub XmInheritInitializePrehook () {(( &XtInitProc)  &_XtInherit);}' unless defined(&XmInheritInitializePrehook);
	eval 'sub XmInheritSetValuesPrehook () {(( &XtSetValuesFunc)  &_XtInherit);}' unless defined(&XmInheritSetValuesPrehook);
	eval 'sub XmInheritGetValuesPrehook () {(( &XtArgsProc)  &_XtInherit);}' unless defined(&XmInheritGetValuesPrehook);
	eval 'sub XmInheritInitializePosthook () {(( &XtInitProc)  &_XtInherit);}' unless defined(&XmInheritInitializePosthook);
	eval 'sub XmInheritSetValuesPosthook () {(( &XtSetValuesFunc)  &_XtInherit);}' unless defined(&XmInheritSetValuesPosthook);
	eval 'sub XmInheritGetValuesPosthook () {(( &XtArgsProc)  &_XtInherit);}' unless defined(&XmInheritGetValuesPosthook);
	eval 'sub XmInheritSecObjectCreate () {(( &XtInitProc)  &_XtInherit);}' unless defined(&XmInheritSecObjectCreate);
	eval 'sub XmInheritGetSecResData () {(( &XmGetSecResDataFunc)  &_XtInherit);}' unless defined(&XmInheritGetSecResData);
	eval 'sub XmInheritInputDispatch () {(( &XmWidgetDispatchProc)  &_XtInherit);}' unless defined(&XmInheritInputDispatch);
	eval 'sub XmInheritVisualChange () {(( &XmVisualChangeProc)  &_XtInherit);}' unless defined(&XmInheritVisualChange);
	eval 'sub XmInheritArmAndActivate () {(( &XtActionProc)  &_XtInherit);}' unless defined(&XmInheritArmAndActivate);
	eval 'sub XmInheritActionProc () {(( &XtActionProc)  &_XtInherit);}' unless defined(&XmInheritActionProc);
	eval 'sub XmInheritFocusChange () {(( &XmFocusChangeProc)  &_XtInherit);}' unless defined(&XmInheritFocusChange);
	eval 'sub XmInheritWidgetNavigable () {(( &XmWidgetNavigableProc)  &_XtInherit);}' unless defined(&XmInheritWidgetNavigable);
	eval 'sub XmInheritClassPartInitPrehook () {(( &XtWidgetClassProc)  &_XtInherit);}' unless defined(&XmInheritClassPartInitPrehook);
	eval 'sub XmInheritClassPartInitPosthook () {(( &XtWidgetClassProc)  &_XtInherit);}' unless defined(&XmInheritClassPartInitPosthook);
	eval 'sub XmInheritBorderHighlight () {(( &XtWidgetProc)  &_XtInherit);}' unless defined(&XmInheritBorderHighlight);
	eval 'sub XmInheritBorderUnhighlight () {(( &XtWidgetProc)  &_XtInherit);}' unless defined(&XmInheritBorderUnhighlight);
	eval 'sub XmFIRST_APPLICATION_SUBCLASS_BIT () {192;}' unless defined(&XmFIRST_APPLICATION_SUBCLASS_BIT);
	eval("sub XmCASCADE_BUTTON_BIT () { 1; }") unless defined(&XmCASCADE_BUTTON_BIT);
	eval("sub XmCASCADE_BUTTON_GADGET_BIT () { 2; }") unless defined(&XmCASCADE_BUTTON_GADGET_BIT);
	eval("sub XmCOMMAND_BOX_BIT () { 3; }") unless defined(&XmCOMMAND_BOX_BIT);
	eval("sub XmDIALOG_SHELL_BIT () { 4; }") unless defined(&XmDIALOG_SHELL_BIT);
	eval("sub XmLIST_BIT () { 5; }") unless defined(&XmLIST_BIT);
	eval("sub XmFORM_BIT () { 6; }") unless defined(&XmFORM_BIT);
	eval("sub XmTEXT_FIELD_BIT () { 7; }") unless defined(&XmTEXT_FIELD_BIT);
	eval("sub XmGADGET_BIT () { 8; }") unless defined(&XmGADGET_BIT);
	eval("sub XmLABEL_BIT () { 9; }") unless defined(&XmLABEL_BIT);
	eval("sub XmLABEL_GADGET_BIT () { 10; }") unless defined(&XmLABEL_GADGET_BIT);
	eval("sub XmMAIN_WINDOW_BIT () { 11; }") unless defined(&XmMAIN_WINDOW_BIT);
	eval("sub XmMANAGER_BIT () { 12; }") unless defined(&XmMANAGER_BIT);
	eval("sub XmMENU_SHELL_BIT () { 13; }") unless defined(&XmMENU_SHELL_BIT);
	eval("sub XmDRAWN_BUTTON_BIT () { 14; }") unless defined(&XmDRAWN_BUTTON_BIT);
	eval("sub XmPRIMITIVE_BIT () { 15; }") unless defined(&XmPRIMITIVE_BIT);
	eval("sub XmPUSH_BUTTON_BIT () { 16; }") unless defined(&XmPUSH_BUTTON_BIT);
	eval("sub XmPUSH_BUTTON_GADGET_BIT () { 17; }") unless defined(&XmPUSH_BUTTON_GADGET_BIT);
	eval("sub XmROW_COLUMN_BIT () { 18; }") unless defined(&XmROW_COLUMN_BIT);
	eval("sub XmSCROLL_BAR_BIT () { 19; }") unless defined(&XmSCROLL_BAR_BIT);
	eval("sub XmSCROLLED_WINDOW_BIT () { 20; }") unless defined(&XmSCROLLED_WINDOW_BIT);
	eval("sub XmSELECTION_BOX_BIT () { 21; }") unless defined(&XmSELECTION_BOX_BIT);
	eval("sub XmSEPARATOR_BIT () { 22; }") unless defined(&XmSEPARATOR_BIT);
	eval("sub XmSEPARATOR_GADGET_BIT () { 23; }") unless defined(&XmSEPARATOR_GADGET_BIT);
	eval("sub XmTEXT_BIT () { 24; }") unless defined(&XmTEXT_BIT);
	eval("sub XmTOGGLE_BUTTON_BIT () { 25; }") unless defined(&XmTOGGLE_BUTTON_BIT);
	eval("sub XmTOGGLE_BUTTON_GADGET_BIT () { 26; }") unless defined(&XmTOGGLE_BUTTON_GADGET_BIT);
	eval("sub XmDROP_TRANSFER_BIT () { 27; }") unless defined(&XmDROP_TRANSFER_BIT);
	eval("sub XmDROP_SITE_MANAGER_BIT () { 28; }") unless defined(&XmDROP_SITE_MANAGER_BIT);
	eval("sub XmDISPLAY_BIT () { 29; }") unless defined(&XmDISPLAY_BIT);
	eval("sub XmSCREEN_BIT () { 30; }") unless defined(&XmSCREEN_BIT);
	eval("sub XmARROW_BUTTON_BIT () { 31; }") unless defined(&XmARROW_BUTTON_BIT);
	eval("sub XmARROW_BUTTON_GADGET_BIT () { 32; }") unless defined(&XmARROW_BUTTON_GADGET_BIT);
	eval("sub XmBULLETIN_BOARD_BIT () { 33; }") unless defined(&XmBULLETIN_BOARD_BIT);
	eval("sub XmDRAWING_AREA_BIT () { 34; }") unless defined(&XmDRAWING_AREA_BIT);
	eval("sub XmFILE_SELECTION_BOX_BIT () { 35; }") unless defined(&XmFILE_SELECTION_BOX_BIT);
	eval("sub XmFRAME_BIT () { 36; }") unless defined(&XmFRAME_BIT);
	eval("sub XmMESSAGE_BOX_BIT () { 37; }") unless defined(&XmMESSAGE_BOX_BIT);
	eval("sub XmSASH_BIT () { 38; }") unless defined(&XmSASH_BIT);
	eval("sub XmSCALE_BIT () { 39; }") unless defined(&XmSCALE_BIT);
	eval("sub XmPANED_WINDOW_BIT () { 40; }") unless defined(&XmPANED_WINDOW_BIT);
	eval("sub XmVENDOR_SHELL_BIT () { 41; }") unless defined(&XmVENDOR_SHELL_BIT);
	eval("sub XmCLIP_WINDOW_BIT () { 42; }") unless defined(&XmCLIP_WINDOW_BIT);
	eval("sub XmDRAG_ICON_BIT () { 43; }") unless defined(&XmDRAG_ICON_BIT);
	eval("sub XmTEAROFF_BUTTON_BIT () { 44; }") unless defined(&XmTEAROFF_BUTTON_BIT);
	eval("sub XmDRAG_OVER_SHELL_BIT () { 45; }") unless defined(&XmDRAG_OVER_SHELL_BIT);
	eval("sub XmDRAG_CONTEXT_BIT () { 46; }") unless defined(&XmDRAG_CONTEXT_BIT);
	eval("sub XmCONTAINER_BIT () { 47; }") unless defined(&XmCONTAINER_BIT);
	eval("sub XmICONGADGET_BIT () { 48; }") unless defined(&XmICONGADGET_BIT);
	eval("sub XmNOTEBOOK_BIT () { 49; }") unless defined(&XmNOTEBOOK_BIT);
	eval("sub XmCSTEXT_BIT () { 50; }") unless defined(&XmCSTEXT_BIT);
	eval("sub XmGRAB_SHELL_BIT () { 51; }") unless defined(&XmGRAB_SHELL_BIT);
	eval("sub XmCOMBO_BOX_BIT () { 52; }") unless defined(&XmCOMBO_BOX_BIT);
	eval("sub XmSPINBOX_BIT () { 53; }") unless defined(&XmSPINBOX_BIT);
	eval("sub XmICONHEADER_BIT () { 54; }") unless defined(&XmICONHEADER_BIT);
	eval("sub XmFAST_SUBCLASS_TAIL_BIT () { 55; }") unless defined(&XmFAST_SUBCLASS_TAIL_BIT);
	eval 'sub XmLAST_FAST_SUBCLASS_BIT () {( &XmFAST_SUBCLASS_TAIL_BIT - 1);}' unless defined(&XmLAST_FAST_SUBCLASS_BIT);
	undef(&XmIsCascadeButton) if defined(&XmIsCascadeButton);
	eval 'sub XmIsCascadeButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCASCADE_BUTTON_BIT)));
	}' unless defined(&XmIsCascadeButton);
	undef(&XmIsCascadeButtonGadget) if defined(&XmIsCascadeButtonGadget);
	eval 'sub XmIsCascadeButtonGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCASCADE_BUTTON_GADGET_BIT)));
	}' unless defined(&XmIsCascadeButtonGadget);
	undef(&XmIsClipWindow) if defined(&XmIsClipWindow);
	eval 'sub XmIsClipWindow {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCLIP_WINDOW_BIT)));
	}' unless defined(&XmIsClipWindow);
	undef(&XmIsComboBox) if defined(&XmIsComboBox);
	eval 'sub XmIsComboBox {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCOMBO_BOX_BIT)));
	}' unless defined(&XmIsComboBox);
	undef(&XmIsCommandBox) if defined(&XmIsCommandBox);
	eval 'sub XmIsCommandBox {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCOMMAND_BOX_BIT)));
	}' unless defined(&XmIsCommandBox);
	undef(&XmIsContainer) if defined(&XmIsContainer);
	eval 'sub XmIsContainer {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCONTAINER_BIT)));
	}' unless defined(&XmIsContainer);
	undef(&XmIsDialogShell) if defined(&XmIsDialogShell);
	eval 'sub XmIsDialogShell {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDIALOG_SHELL_BIT)));
	}' unless defined(&XmIsDialogShell);
	undef(&XmIsDisplay) if defined(&XmIsDisplay);
	eval 'sub XmIsDisplay {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDISPLAY_BIT)));
	}' unless defined(&XmIsDisplay);
	undef(&XmIsGrabShell) if defined(&XmIsGrabShell);
	eval 'sub XmIsGrabShell {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmGRAB_SHELL_BIT)));
	}' unless defined(&XmIsGrabShell);
	undef(&XmIsIconGadget) if defined(&XmIsIconGadget);
	eval 'sub XmIsIconGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmICONGADGET_BIT)));
	}' unless defined(&XmIsIconGadget);
	undef(&XmIsList) if defined(&XmIsList);
	eval 'sub XmIsList {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmLIST_BIT)));
	}' unless defined(&XmIsList);
	undef(&XmIsForm) if defined(&XmIsForm);
	eval 'sub XmIsForm {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmFORM_BIT)));
	}' unless defined(&XmIsForm);
	undef(&XmIsTextField) if defined(&XmIsTextField);
	eval 'sub XmIsTextField {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTEXT_FIELD_BIT)));
	}' unless defined(&XmIsTextField);
	undef(&XmIsGadget) if defined(&XmIsGadget);
	eval 'sub XmIsGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmGADGET_BIT)));
	}' unless defined(&XmIsGadget);
	undef(&XmIsLabel) if defined(&XmIsLabel);
	eval 'sub XmIsLabel {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmLABEL_BIT)));
	}' unless defined(&XmIsLabel);
	undef(&XmIsLabelGadget) if defined(&XmIsLabelGadget);
	eval 'sub XmIsLabelGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmLABEL_GADGET_BIT)));
	}' unless defined(&XmIsLabelGadget);
	undef(&XmIsMainWindow) if defined(&XmIsMainWindow);
	eval 'sub XmIsMainWindow {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmMAIN_WINDOW_BIT)));
	}' unless defined(&XmIsMainWindow);
	undef(&XmIsManager) if defined(&XmIsManager);
	eval 'sub XmIsManager {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmMANAGER_BIT)));
	}' unless defined(&XmIsManager);
	undef(&XmIsMenuShell) if defined(&XmIsMenuShell);
	eval 'sub XmIsMenuShell {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmMENU_SHELL_BIT)));
	}' unless defined(&XmIsMenuShell);
	undef(&XmIsNotebook) if defined(&XmIsNotebook);
	eval 'sub XmIsNotebook {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmNOTEBOOK_BIT)));
	}' unless defined(&XmIsNotebook);
	undef(&XmIsDragIcon) if defined(&XmIsDragIcon);
	eval 'sub XmIsDragIcon {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAG_ICON_BIT)));
	}' unless defined(&XmIsDragIcon);
	undef(&XmIsDropSiteManager) if defined(&XmIsDropSiteManager);
	eval 'sub XmIsDropSiteManager {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDROP_SITE_MANAGER_BIT)));
	}' unless defined(&XmIsDropSiteManager);
	undef(&XmIsDropTransfer) if defined(&XmIsDropTransfer);
	eval 'sub XmIsDropTransfer {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDROP_TRANSFER_BIT)));
	}' unless defined(&XmIsDropTransfer);
	undef(&XmIsDragOverShell) if defined(&XmIsDragOverShell);
	eval 'sub XmIsDragOverShell {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAG_OVER_SHELL_BIT)));
	}' unless defined(&XmIsDragOverShell);
	undef(&XmIsDragContext) if defined(&XmIsDragContext);
	eval 'sub XmIsDragContext {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAG_CONTEXT_BIT)));
	}' unless defined(&XmIsDragContext);
	undef(&XmIsDrawnButton) if defined(&XmIsDrawnButton);
	eval 'sub XmIsDrawnButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAWN_BUTTON_BIT)));
	}' unless defined(&XmIsDrawnButton);
	undef(&XmIsPrimitive) if defined(&XmIsPrimitive);
	eval 'sub XmIsPrimitive {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmPRIMITIVE_BIT)));
	}' unless defined(&XmIsPrimitive);
	undef(&XmIsPushButton) if defined(&XmIsPushButton);
	eval 'sub XmIsPushButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmPUSH_BUTTON_BIT)));
	}' unless defined(&XmIsPushButton);
	undef(&XmIsPushButtonGadget) if defined(&XmIsPushButtonGadget);
	eval 'sub XmIsPushButtonGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmPUSH_BUTTON_GADGET_BIT)));
	}' unless defined(&XmIsPushButtonGadget);
	undef(&XmIsRowColumn) if defined(&XmIsRowColumn);
	eval 'sub XmIsRowColumn {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmROW_COLUMN_BIT)));
	}' unless defined(&XmIsRowColumn);
	undef(&XmIsScreen) if defined(&XmIsScreen);
	eval 'sub XmIsScreen {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSCREEN_BIT)));
	}' unless defined(&XmIsScreen);
	undef(&XmIsScrollBar) if defined(&XmIsScrollBar);
	eval 'sub XmIsScrollBar {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSCROLL_BAR_BIT)));
	}' unless defined(&XmIsScrollBar);
	undef(&XmIsScrolledWindow) if defined(&XmIsScrolledWindow);
	eval 'sub XmIsScrolledWindow {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSCROLLED_WINDOW_BIT)));
	}' unless defined(&XmIsScrolledWindow);
	undef(&XmIsSelectionBox) if defined(&XmIsSelectionBox);
	eval 'sub XmIsSelectionBox {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSELECTION_BOX_BIT)));
	}' unless defined(&XmIsSelectionBox);
	undef(&XmIsSeparator) if defined(&XmIsSeparator);
	eval 'sub XmIsSeparator {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSEPARATOR_BIT)));
	}' unless defined(&XmIsSeparator);
	undef(&XmIsSeparatorGadget) if defined(&XmIsSeparatorGadget);
	eval 'sub XmIsSeparatorGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSEPARATOR_GADGET_BIT)));
	}' unless defined(&XmIsSeparatorGadget);
	undef(&XmIsSpinButton) if defined(&XmIsSpinButton);
	eval 'sub XmIsSpinButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSPINBUTTON_BIT)));
	}' unless defined(&XmIsSpinButton);
	undef(&XmIsText) if defined(&XmIsText);
	eval 'sub XmIsText {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTEXT_BIT)));
	}' unless defined(&XmIsText);
	undef(&XmIsTearOffButton) if defined(&XmIsTearOffButton);
	eval 'sub XmIsTearOffButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTEAROFF_BUTTON_BIT)));
	}' unless defined(&XmIsTearOffButton);
	undef(&XmIsToggleButton) if defined(&XmIsToggleButton);
	eval 'sub XmIsToggleButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTOGGLE_BUTTON_BIT)));
	}' unless defined(&XmIsToggleButton);
	undef(&XmIsToggleButtonGadget) if defined(&XmIsToggleButtonGadget);
	eval 'sub XmIsToggleButtonGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTOGGLE_BUTTON_GADGET_BIT)));
	}' unless defined(&XmIsToggleButtonGadget);
	undef(&XmIsPrintShell) if defined(&XmIsPrintShell);
	eval 'sub XmIsPrintShell {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmPRINT_SHELL_BIT)));
	}' unless defined(&XmIsPrintShell);
	undef(&XmIsArrowButton) if defined(&XmIsArrowButton);
	eval 'sub XmIsArrowButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmARROW_BUTTON_BIT)));
	}' unless defined(&XmIsArrowButton);
	undef(&XmIsArrowButtonGadget) if defined(&XmIsArrowButtonGadget);
	eval 'sub XmIsArrowButtonGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmARROW_BUTTON_GADGET_BIT)));
	}' unless defined(&XmIsArrowButtonGadget);
	undef(&XmIsBulletinBoard) if defined(&XmIsBulletinBoard);
	eval 'sub XmIsBulletinBoard {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmBULLETIN_BOARD_BIT)));
	}' unless defined(&XmIsBulletinBoard);
	undef(&XmIsDrawingArea) if defined(&XmIsDrawingArea);
	eval 'sub XmIsDrawingArea {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAWING_AREA_BIT)));
	}' unless defined(&XmIsDrawingArea);
	undef(&XmIsFileSelectionBox) if defined(&XmIsFileSelectionBox);
	eval 'sub XmIsFileSelectionBox {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmFILE_SELECTION_BOX_BIT)));
	}' unless defined(&XmIsFileSelectionBox);
	undef(&XmIsFrame) if defined(&XmIsFrame);
	eval 'sub XmIsFrame {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmFRAME_BIT)));
	}' unless defined(&XmIsFrame);
	undef(&XmIsMessageBox) if defined(&XmIsMessageBox);
	eval 'sub XmIsMessageBox {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmMESSAGE_BOX_BIT)));
	}' unless defined(&XmIsMessageBox);
	undef(&XmIsSash) if defined(&XmIsSash);
	eval 'sub XmIsSash {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSASH_BIT)));
	}' unless defined(&XmIsSash);
	undef(&XmIsScale) if defined(&XmIsScale);
	eval 'sub XmIsScale {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSCALE_BIT)));
	}' unless defined(&XmIsScale);
	undef(&XmIsPanedWindow) if defined(&XmIsPanedWindow);
	eval 'sub XmIsPanedWindow {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmPANED_WINDOW_BIT)));
	}' unless defined(&XmIsPanedWindow);
	undef(&XmIsCSText) if defined(&XmIsCSText);
	eval 'sub XmIsCSText {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCSTEXT_BIT)));
	}' unless defined(&XmIsCSText);
	eval 'sub XmObjectIndex () {0;}' unless defined(&XmObjectIndex);
	eval 'sub ObjectIndex () { &XmObjectIndex;}' unless defined(&ObjectIndex);
	eval 'sub XmRectObjIndex () {( &XmObjectIndex + 1);}' unless defined(&XmRectObjIndex);
	eval 'sub RectObjIndex () { &XmRectObjIndex;}' unless defined(&RectObjIndex);
	eval 'sub XmWindowObjIndex () {( &XmRectObjIndex + 1);}' unless defined(&XmWindowObjIndex);
	eval 'sub WindowObjIndex () { &XmWindowObjIndex;}' unless defined(&WindowObjIndex);
	eval 'sub XmCoreIndex () {0;}' unless defined(&XmCoreIndex);
	eval 'sub CoreIndex () { &XmCoreIndex;}' unless defined(&CoreIndex);
	eval 'sub XmCompositeIndex () {( &XmWindowObjIndex + 2);}' unless defined(&XmCompositeIndex);
	eval 'sub CompositeIndex () { &XmCompositeIndex;}' unless defined(&CompositeIndex);
	eval 'sub XmConstraintIndex () {( &XmCompositeIndex + 1);}' unless defined(&XmConstraintIndex);
	eval 'sub ConstraintIndex () { &XmConstraintIndex;}' unless defined(&ConstraintIndex);
	eval 'sub XmGadgetIndex () {( &XmRectObjIndex + 1);}' unless defined(&XmGadgetIndex);
	eval 'sub XmPrimitiveIndex () {( &XmWindowObjIndex + 2);}' unless defined(&XmPrimitiveIndex);
	eval 'sub XmManagerIndex () {( &XmConstraintIndex + 1);}' unless defined(&XmManagerIndex);
	eval 'sub XmArrowBIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmArrowBIndex);
	eval 'sub XmArrowButtonIndex () { &XmArrowBIndex;}' unless defined(&XmArrowButtonIndex);
	eval 'sub XmLabelIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmLabelIndex);
	eval 'sub XmListIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmListIndex);
	eval 'sub XmScrollBarIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmScrollBarIndex);
	eval 'sub XmSeparatorIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmSeparatorIndex);
	eval 'sub XmTextIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmTextIndex);
	eval 'sub XmTextFieldIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmTextFieldIndex);
	eval 'sub XmCSTextIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmCSTextIndex);
	eval 'sub XmCascadeBIndex () {( &XmLabelIndex + 1);}' unless defined(&XmCascadeBIndex);
	eval 'sub XmCascadeButtonIndex () { &XmCascadeBIndex;}' unless defined(&XmCascadeButtonIndex);
	eval 'sub XmDrawnBIndex () {( &XmLabelIndex + 1);}' unless defined(&XmDrawnBIndex);
	eval 'sub XmDrawnButtonIndex () { &XmDrawnBIndex;}' unless defined(&XmDrawnButtonIndex);
	eval 'sub XmPushBIndex () {( &XmLabelIndex + 1);}' unless defined(&XmPushBIndex);
	eval 'sub XmPushButtonIndex () { &XmPushBIndex;}' unless defined(&XmPushButtonIndex);
	eval 'sub XmToggleBIndex () {( &XmLabelIndex + 1);}' unless defined(&XmToggleBIndex);
	eval 'sub XmToggleButtonIndex () { &XmToggleBIndex;}' unless defined(&XmToggleButtonIndex);
	eval 'sub XmTearOffButtonIndex () {( &XmPushBIndex + 1);}' unless defined(&XmTearOffButtonIndex);
	eval 'sub XmArrowBGIndex () {( &XmGadgetIndex + 1);}' unless defined(&XmArrowBGIndex);
	eval 'sub XmArrowButtonGadgetIndex () { &XmArrowBGIndex;}' unless defined(&XmArrowButtonGadgetIndex);
	eval 'sub XmLabelGIndex () {( &XmGadgetIndex + 1);}' unless defined(&XmLabelGIndex);
	eval 'sub XmLabelGadgetIndex () { &XmLabelGIndex;}' unless defined(&XmLabelGadgetIndex);
	eval 'sub XmSeparatoGIndex () {( &XmGadgetIndex + 1);}' unless defined(&XmSeparatoGIndex);
	eval 'sub XmSeparatorGadgetIndex () { &XmSeparatoGIndex;}' unless defined(&XmSeparatorGadgetIndex);
	eval 'sub XmCascadeBGIndex () {( &XmLabelGIndex + 1);}' unless defined(&XmCascadeBGIndex);
	eval 'sub XmCascadeButtonGadgetIndex () { &XmCascadeBGIndex;}' unless defined(&XmCascadeButtonGadgetIndex);
	eval 'sub XmPushBGIndex () {( &XmLabelGIndex + 1);}' unless defined(&XmPushBGIndex);
	eval 'sub XmPushButtonGadgetIndex () { &XmPushBGIndex;}' unless defined(&XmPushButtonGadgetIndex);
	eval 'sub XmToggleBGIndex () {( &XmLabelGIndex + 1);}' unless defined(&XmToggleBGIndex);
	eval 'sub XmToggleButtonGadgetIndex () { &XmToggleBGIndex;}' unless defined(&XmToggleButtonGadgetIndex);
	eval 'sub XmIconGadgetIndex () {( &XmGadgetIndex + 1);}' unless defined(&XmIconGadgetIndex);
	eval 'sub XmBulletinBIndex () {( &XmManagerIndex + 1);}' unless defined(&XmBulletinBIndex);
	eval 'sub XmBulletinBoardIndex () { &XmBulletinBIndex;}' unless defined(&XmBulletinBoardIndex);
	eval 'sub XmDrawingAIndex () {( &XmManagerIndex + 1);}' unless defined(&XmDrawingAIndex);
	eval 'sub XmDrawingAreaIndex () { &XmDrawingAIndex;}' unless defined(&XmDrawingAreaIndex);
	eval 'sub XmClipWindowIndex () {( &XmDrawingAIndex + 1);}' unless defined(&XmClipWindowIndex);
	eval 'sub XmFrameIndex () {( &XmManagerIndex + 1);}' unless defined(&XmFrameIndex);
	eval 'sub XmPanedWIndex () {( &XmManagerIndex + 1);}' unless defined(&XmPanedWIndex);
	eval 'sub XmPanedWindowIndex () { &XmPanedWIndex;}' unless defined(&XmPanedWindowIndex);
	eval 'sub XmSashIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmSashIndex);
	eval 'sub XmRowColumnIndex () {( &XmManagerIndex + 1);}' unless defined(&XmRowColumnIndex);
	eval 'sub XmScaleIndex () {( &XmManagerIndex + 1);}' unless defined(&XmScaleIndex);
	eval 'sub XmScrolledWIndex () {( &XmManagerIndex + 1);}' unless defined(&XmScrolledWIndex);
	eval 'sub XmScrolledWindowIndex () { &XmScrolledWIndex;}' unless defined(&XmScrolledWindowIndex);
	eval 'sub XmFormIndex () {( &XmBulletinBIndex + 1);}' unless defined(&XmFormIndex);
	eval 'sub XmMessageBIndex () {( &XmBulletinBIndex + 1);}' unless defined(&XmMessageBIndex);
	eval 'sub XmMessageBoxIndex () { &XmMessageBIndex;}' unless defined(&XmMessageBoxIndex);
	eval 'sub XmSelectioBIndex () {( &XmBulletinBIndex + 1);}' unless defined(&XmSelectioBIndex);
	eval 'sub XmSelectionBoxIndex () { &XmSelectioBIndex;}' unless defined(&XmSelectionBoxIndex);
	eval 'sub XmMainWIndex () {( &XmScrolledWIndex + 1);}' unless defined(&XmMainWIndex);
	eval 'sub XmMainWindowIndex () { &XmMainWIndex;}' unless defined(&XmMainWindowIndex);
	eval 'sub XmCommandIndex () {( &XmSelectioBIndex + 1);}' unless defined(&XmCommandIndex);
	eval 'sub XmFileSBIndex () {( &XmSelectioBIndex + 1);}' unless defined(&XmFileSBIndex);
	eval 'sub XmFileSelectionBoxIndex () { &XmFileSBIndex;}' unless defined(&XmFileSelectionBoxIndex);
	eval 'sub XmShellIndex () {( &XmCompositeIndex + 1);}' unless defined(&XmShellIndex);
	eval 'sub ShellIndex () { &XmShellIndex;}' unless defined(&ShellIndex);
	eval 'sub XmOverrideShellIndex () {( &XmShellIndex + 1);}' unless defined(&XmOverrideShellIndex);
	eval 'sub OverrideShellIndex () { &XmOverrideShellIndex;}' unless defined(&OverrideShellIndex);
	eval 'sub XmWMShellIndex () {( &XmShellIndex + 1);}' unless defined(&XmWMShellIndex);
	eval 'sub WMShellIndex () { &XmWMShellIndex;}' unless defined(&WMShellIndex);
	eval 'sub XmVendorShellIndex () {( &XmWMShellIndex + 1);}' unless defined(&XmVendorShellIndex);
	eval 'sub VendorShellIndex () { &XmVendorShellIndex;}' unless defined(&VendorShellIndex);
	eval 'sub XmTransientShellIndex () {( &XmVendorShellIndex + 1);}' unless defined(&XmTransientShellIndex);
	eval 'sub TransientShellIndex () { &XmTransientShellIndex;}' unless defined(&TransientShellIndex);
	eval 'sub XmTopLevelShellIndex () {( &XmVendorShellIndex + 1);}' unless defined(&XmTopLevelShellIndex);
	eval 'sub TopLevelShellIndex () { &XmTopLevelShellIndex;}' unless defined(&TopLevelShellIndex);
	eval 'sub XmApplicationShellIndex () {( &XmTopLevelShellIndex + 1);}' unless defined(&XmApplicationShellIndex);
	eval 'sub ApplicationShellIndex () { &XmApplicationShellIndex;}' unless defined(&ApplicationShellIndex);
	eval 'sub XmGrabShellIndex () {( &XmVendorShellIndex + 1);}' unless defined(&XmGrabShellIndex);
	eval 'sub XmDisplayIndex () {( &XmApplicationShellIndex + 1);}' unless defined(&XmDisplayIndex);
	eval 'sub XmDialogSIndex () {( &XmTransientShellIndex + 1);}' unless defined(&XmDialogSIndex);
	eval 'sub XmDialogShellIndex () { &XmDialogSIndex;}' unless defined(&XmDialogShellIndex);
	eval 'sub XmMenuShellIndex () {( &XmOverrideShellIndex + 1);}' unless defined(&XmMenuShellIndex);
	eval 'sub XmContainerIndex () {( &XmManagerIndex + 1);}' unless defined(&XmContainerIndex);
	eval 'sub XmNotebookIndex () {( &XmManagerIndex + 1);}' unless defined(&XmNotebookIndex);
	eval 'sub XmSpinButtonIndex () {( &XmManagerIndex + 1);}' unless defined(&XmSpinButtonIndex);
	eval 'sub XmComboBoxIndex () {( &XmManagerIndex + 1);}' unless defined(&XmComboBoxIndex);
	eval 'sub XmDragIconIndex () {( &XmRectObjIndex + 1);}' unless defined(&XmDragIconIndex);
	eval 'sub XmDropSiteManagerIndex () {( &XmObjectIndex + 1);}' unless defined(&XmDropSiteManagerIndex);
	eval 'sub XmDropTransferIndex () {( &XmObjectIndex + 1);}' unless defined(&XmDropTransferIndex);
	eval 'sub XmDragOverShellIndex () {( &XmVendorShellIndex + 1);}' unless defined(&XmDragOverShellIndex);
	eval 'sub XmDragContextIndex () {( &XmCoreIndex + 1);}' unless defined(&XmDragContextIndex);
	eval 'sub XmOFFSETBITS () {($sizeof{ &Cardinal}*8/2);}' unless defined(&XmOFFSETBITS);
	eval 'sub XmOFFSETMASK () {((1<< &XmOFFSETBITS)-1);}' unless defined(&XmOFFSETMASK);
	if((defined( &__STDC__)  && !defined( &UNIXCPP)) || defined( &__cplusplus) || defined( &ANSICPP)) {
	    eval 'sub XmPartOffset {
	        my($part, $variable) = @_;
    		eval q((($part &Index) <<  &XmOFFSETBITS) +  &XtOffsetOf( $part &Part, $variable));
	    }' unless defined(&XmPartOffset);
	    eval 'sub XmConstraintPartOffset {
	        my($part, $variable) = @_;
    		eval q((($part &Index) <<  &XmOFFSETBITS) +  &XtOffsetOf( $part &ConstraintPart, $variable));
	    }' unless defined(&XmConstraintPartOffset);
	    eval 'sub XmGetPartOffset {
	        my($r, $offset) = @_;
    		eval q((($r)-> &resource_offset &  &XmOFFSETMASK) + (*($offset))[($r)-> &resource_offset >>  &XmOFFSETBITS];);
	    }' unless defined(&XmGetPartOffset);
	    eval 'sub XmField {
	        my($widget, $offsetrecord, $part, $variable, $type) = @_;
    		eval q((*($type *)(( ($widget)) + $offsetrecord->[$part &Index] +  &XtOffsetOf( $part &Part, $variable))));
	    }' unless defined(&XmField);
	    eval 'sub XmConstraintField {
	        my($widget, $offsetrecord, $part, $variable, $type) = @_;
    		eval q((*($type *)(( ($widget)-> ($core->{constraints})) + $offsetrecord->[$part &Index] +  &XtOffsetOf( $part &ConstraintPart, $variable))));
	    }' unless defined(&XmConstraintField);
	} else {
	    eval 'sub XmPartOffset {
	        my($part, $variable) = @_;
    		eval q((($part  &Index) <<  &XmOFFSETBITS) +  &XtOffsetOf( $part  &Part, $variable));
	    }' unless defined(&XmPartOffset);
	    eval 'sub XmConstraintPartOffset {
	        my($part, $variable) = @_;
    		eval q((($part  &Index) <<  &XmOFFSETBITS) +  &XtOffsetOf( $part  &ConstraintPart, $variable));
	    }' unless defined(&XmConstraintPartOffset);
	    eval 'sub XmGetPartOffset {
	        my($r, $offset) = @_;
    		eval q((($r)-> &resource_offset &  &XmOFFSETMASK) + (*($offset))[($r)-> &resource_offset >>  &XmOFFSETBITS];);
	    }' unless defined(&XmGetPartOffset);
	    eval 'sub XmField {
	        my($widget, $offsetrecord, $part, $variable, $type) = @_;
    		eval q((*($type *)(( ($widget)) + $offsetrecord->[$part  &Index] +  &XtOffsetOf( $part  &Part, $variable))));
	    }' unless defined(&XmField);
	    eval 'sub XmConstraintField {
	        my($widget, $offsetrecord, $part, $variable, $type) = @_;
    		eval q((*($type *)(( ($widget)-> ($core->{constraints})) + $offsetrecord->[$part  &Index] +  &XtOffsetOf( $part  &ConstraintPart, $variable))));
	    }' unless defined(&XmConstraintField);
	}
	eval("sub XmLABEL_FONTLIST () { 1; }") unless defined(&XmLABEL_FONTLIST);
	eval("sub XmBUTTON_FONTLIST () { 2; }") unless defined(&XmBUTTON_FONTLIST);
	eval("sub XmTEXT_FONTLIST () { 3; }") unless defined(&XmTEXT_FONTLIST);
	eval("sub XmLABEL_RENDER_TABLE () { 1; }") unless defined(&XmLABEL_RENDER_TABLE);
	eval("sub XmBUTTON_RENDER_TABLE () { 2; }") unless defined(&XmBUTTON_RENDER_TABLE);
	eval("sub XmTEXT_RENDER_TABLE () { 3; }") unless defined(&XmTEXT_RENDER_TABLE);
	eval 'sub XmSTRING_TAG_STRLEN () {-1;}' unless defined(&XmSTRING_TAG_STRLEN);
	eval("sub XmTAB_NEXT () { 0; }") unless defined(&XmTAB_NEXT);
	eval("sub XmTAB_NEWLINE () { 1; }") unless defined(&XmTAB_NEWLINE);
	eval("sub XmTAB_EOS () { 2; }") unless defined(&XmTAB_EOS);
	eval 'sub XmTAB_ANY () {(( &XmNavigationType) 255);}' unless defined(&XmTAB_ANY);
	eval 'sub XmNONE_OR_BC () {(( &XmNavigationType) 254);}' unless defined(&XmNONE_OR_BC);
	eval("sub XmPARSE_ERROR () { 0; }") unless defined(&XmPARSE_ERROR);
	eval("sub XmPARSE_NO_UNITS () { 1; }") unless defined(&XmPARSE_NO_UNITS);
	eval("sub XmPARSE_UNITS_OK () { 2; }") unless defined(&XmPARSE_UNITS_OK);
	if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	} else {
	}
	if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	} else {
	}
	if(defined(&__cplusplus)) {
	}
	require 'Xm/BaseClassP.ph';
	unless(defined(&NO_XM_1_2_BC)) {
	    eval 'sub _XmClearBorder () { &XmeClearBorder;}' unless defined(&_XmClearBorder);
	    eval 'sub _XmConfigureObject () { &XmeConfigureObject;}' unless defined(&_XmConfigureObject);
	    eval 'sub _XmDrawArrow () { &XmeDrawArrow;}' unless defined(&_XmDrawArrow);
	    eval 'sub _XmDrawDiamond () { &XmeDrawDiamond;}' unless defined(&_XmDrawDiamond);
	    eval 'sub _XmDrawSeparator () { &XmeDrawSeparator;}' unless defined(&_XmDrawSeparator);
	    eval 'sub _XmDrawShadows () { &XmeDrawShadows;}' unless defined(&_XmDrawShadows);
	    eval 'sub _XmDrawSimpleHighlight () { &XmeDrawHighlight;}' unless defined(&_XmDrawSimpleHighlight);
	    eval 'sub _XmFontListGetDefaultFont () { &XmeRenderTableGetDefaultFont;}' unless defined(&_XmFontListGetDefaultFont);
	    eval 'sub _XmFromHorizontalPixels () { &XmeFromHorizontalPixels;}' unless defined(&_XmFromHorizontalPixels);
	    eval 'sub _XmFromVerticalPixels () { &XmeFromVerticalPixels;}' unless defined(&_XmFromVerticalPixels);
	    eval 'sub _XmGMReplyToQueryGeometry () { &XmeReplyToQueryGeometry;}' unless defined(&_XmGMReplyToQueryGeometry);
	    eval 'sub _XmGetDefaultFontList () { &XmeGetDefaultRenderTable;}' unless defined(&_XmGetDefaultFontList);
	    eval 'sub _XmGetMaxCursorSize () { &XmeQueryBestCursorSize;}' unless defined(&_XmGetMaxCursorSize);
	    eval 'sub _XmGetNullCursor () { &XmeGetNullCursor;}' unless defined(&_XmGetNullCursor);
	    eval 'sub _XmGetTextualDragIcon () { &XmeGetTextualDragIcon;}' unless defined(&_XmGetTextualDragIcon);
	    eval 'sub _XmInputInGadget () { &XmObjectAtPoint;}' unless defined(&_XmInputInGadget);
	    eval 'sub _XmMicroSleep () { &XmeMicroSleep;}' unless defined(&_XmMicroSleep);
	    eval 'sub _XmNavigChangeManaged () { &XmeNavigChangeManaged;}' unless defined(&_XmNavigChangeManaged);
	    eval 'sub _XmOSGetHomeDirName () { &XmeGetHomeDirName;}' unless defined(&_XmOSGetHomeDirName);
	    eval 'sub _XmOSGetLocalizedString () { &XmeGetLocalizedString;}' unless defined(&_XmOSGetLocalizedString);
	    eval 'sub _XmRedisplayGadgets () { &XmeRedisplayGadgets;}' unless defined(&_XmRedisplayGadgets);
	    eval 'sub _XmStringIsXmString () { &XmeStringIsValid;}' unless defined(&_XmStringIsXmString);
	    eval 'sub _XmStringUpdateWMShellTitle () { &XmeSetWMShellTitle;}' unless defined(&_XmStringUpdateWMShellTitle);
	    eval 'sub _XmStringsAreEqual () { &XmeStringsAreEqual;}' unless defined(&_XmStringsAreEqual);
	    eval 'sub _XmToHorizontalPixels () { &XmeToHorizontalPixels;}' unless defined(&_XmToHorizontalPixels);
	    eval 'sub _XmToVerticalPixels () { &XmeToVerticalPixels;}' unless defined(&_XmToVerticalPixels);
	    eval 'sub _XmWarning () { &XmeWarning;}' unless defined(&_XmWarning);
	    if(defined(&__cplusplus)) {
	    }
	    if(defined(&__cplusplus)) {
	    }
	    eval 'sub _XmCreateImage {
	        my($IMAGE, $DISPLAY, $DATA, $WIDTH, $HEIGHT, $BYTE_ORDER) = @_;
    		eval q({ $IMAGE =  &XCreateImage($DISPLAY,  &DefaultVisual($DISPLAY,  &DefaultScreen($DISPLAY)), 1,  &XYBitmap, 0, $DATA, $WIDTH, $HEIGHT, 8, ($WIDTH+7) >> 3);  ($IMAGE->{byte_order}) = $BYTE_ORDER;  ($IMAGE->{bitmap_unit}) = 8;  ($IMAGE->{bitmap_bit_order}) =  &LSBFirst;});
	    }' unless defined(&_XmCreateImage);
	}
	if(defined( &__lint)  && defined( &_LP64)) {
	} else {
	    eval 'sub TextPosToUInt {
	        my($tp) = @_;
    		eval q(($tp));
	    }' unless defined(&TextPosToUInt);
	}
	if(defined(&SUN_CTL)) {
	    eval 'sub CTL_MAX_BUF_SIZE () {2048;}' unless defined(&CTL_MAX_BUF_SIZE);
	    eval 'sub TAB_CHAR () {ord(\'\\t\');}' unless defined(&TAB_CHAR);
	    eval 'sub NEWLINE_CHAR () {ord(\'\\n\');}' unless defined(&NEWLINE_CHAR);
	    eval 'sub W_TAB_CHAR () {(( &wchar_t)  &Lord(\'\\t\'));}' unless defined(&W_TAB_CHAR);
	    eval 'sub W_NEWLINE_CHAR () {(( &wchar_t)  &Lord(\'\\n\'));}' unless defined(&W_NEWLINE_CHAR);
	    eval 'sub WCHAR_CMP {
	        my($c1_ptr, $c2_ptr) = @_;
    		eval q((*( &wchar_t*)($c1_ptr) == *( &wchar_t*)($c2_ptr)));
	    }' unless defined(&WCHAR_CMP);
	    eval 'sub NCHAR_CMP {
	        my($c1_ptr, $c2_ptr) = @_;
    		eval q((* == *($c2_ptr)));
	    }' unless defined(&NCHAR_CMP);
	    eval 'sub CHAR_CMP {
	        my($c1_ptr, $c2_ptr, $is_wchar) = @_;
    		eval q(($is_wchar?  &WCHAR_CMP($c1_ptr, $c2_ptr) : &NCHAR_CMP($c1_ptr, $c2_ptr)));
	    }' unless defined(&CHAR_CMP);
	    eval 'sub IS_TAB {
	        my($c_ptr, $is_wchar) = @_;
    		eval q(($is_wchar ? *( &wchar_t*) ==  &W_TAB_CHAR : * ($c_ptr) ==  &TAB_CHAR));
	    }' unless defined(&IS_TAB);
	    eval 'sub IS_NEWLINE {
	        my($c_ptr, $is_wchar) = @_;
    		eval q(($is_wchar ? *( &wchar_t*) ==  &W_NEWLINE_CHAR : * ($c_ptr) ==  &NEWLINE_CHAR));
	    }' unless defined(&IS_NEWLINE);
	    eval 'sub STR_IPTR {
	        my($str, $i, $is_wchar) = @_;
    		eval q(($is_wchar ? ((( &wchar_t*)$str) + $i) : ($str + $i)));
	    }' unless defined(&STR_IPTR);
	    eval 'sub STR_ICHAR {
	        my($str, $i, $is_wchar) = @_;
    		eval q(($is_wchar ? (( &wchar_t*)$str)[$i] : ($str)[$i]));
	    }' unless defined(&STR_ICHAR);
	    eval 'sub CHAR_CPY {
	        my($dest_ptr, $src_ptr, $is_wchar) = @_;
    		eval q(($is_wchar ? (*( &wchar_t*)$dest_ptr = *( &wchar_t*)$src_ptr) : (*$dest_ptr = *$src_ptr)));
	    }' unless defined(&CHAR_CPY);
	    eval 'sub STR_IINC {
	        my($str, $i, $is_wchar) = @_;
    		eval q($str =  &STR_IPTR($str, $i));
	    }' unless defined(&STR_IINC);
	}
    } else {
	require 'Xm/Xm.ph';
	require 'X11/IntrinsicP.ph';
	require 'X11/ObjectP.ph';
	if(defined(&__cplusplus)) {
	}
	if(defined(&XtName)) {
	    undef(&XtName) if defined(&XtName);
	}
	eval 'sub XtName {
	    my($widget) = @_;
    	    eval q( &XrmQuarkToString ((( &Object)($widget))-> ($object->{xrm_name})));
	}' unless defined(&XtName);
	if(defined(&XtDisplay)) {
	    undef(&XtDisplay) if defined(&XtDisplay);
	}
	eval 'sub XtDisplay {
	    my($widget) = @_;
    	    eval q(( &XtIsWidget($widget) ? (( &Widget)($widget))-> ($core->{screen}->{display}) : (( &Object)($widget))-> ($object->{parent}->{core}->{screen}->{display})));
	}' unless defined(&XtDisplay);
	if(defined(&XtScreen)) {
	    undef(&XtScreen) if defined(&XtScreen);
	}
	eval 'sub XtScreen {
	    my($widget) = @_;
    	    eval q(( &XtIsWidget($widget) ? (( &Widget)($widget))-> ($core->{screen})  : (( &Object)($widget))-> ($object->{parent}->{core}->{screen})));
	}' unless defined(&XtScreen);
	if(defined(&XtWindow)) {
	    undef(&XtWindow) if defined(&XtWindow);
	}
	eval 'sub XtWindow {
	    my($widget) = @_;
    	    eval q(( &XtIsWidget($widget) ? (( &Widget)($widget))-> ($core->{window})  : (( &Object)($widget))-> ($object->{parent}->{core}->{window})));
	}' unless defined(&XtWindow);
	if(defined(&XtClass)) {
	    undef(&XtClass) if defined(&XtClass);
	}
	eval 'sub XtClass {
	    my($widget) = @_;
    	    eval q(((( &Object)($widget))-> ($object->{widget_class})));
	}' unless defined(&XtClass);
	if(defined(&XtSuperclass)) {
	    undef(&XtSuperclass) if defined(&XtSuperclass);
	}
	eval 'sub XtSuperclass {
	    my($widget) = @_;
    	    eval q(( &XtClass($widget)-> ($core_class->{superclass})));
	}' unless defined(&XtSuperclass);
	if(defined(&XtIsRealized)) {
	    undef(&XtIsRealized) if defined(&XtIsRealized);
	}
	eval 'sub XtIsRealized {
	    my($widget) = @_;
    	    eval q(( &XtWindow(( &Widget)$widget) !=  &None));
	}' unless defined(&XtIsRealized);
	if(defined(&XtIsManaged)) {
	    undef(&XtIsManaged) if defined(&XtIsManaged);
	}
	eval 'sub XtIsManaged {
	    my($widget) = @_;
    	    eval q(( &XtIsRectObj($widget) ? ((( &RectObj)($widget))-> ($rectangle->{managed})) :  &False));
	}' unless defined(&XtIsManaged);
	if(defined(&XtIsSensitive)) {
	    undef(&XtIsSensitive) if defined(&XtIsSensitive);
	}
	eval 'sub XtIsSensitive {
	    my($widget) = @_;
    	    eval q(((! &XtIsRectObj($widget)) ?  &False : ((( &RectObj)($widget))-> ($rectangle->{sensitive})  && (( &RectObj)($widget))-> ($rectangle->{ancestor_sensitive}))));
	}' unless defined(&XtIsSensitive);
	if(defined(&XtParent)) {
	    undef(&XtParent) if defined(&XtParent);
	}
	eval 'sub XtParent {
	    my($widget) = @_;
    	    eval q(((( &Object)($widget))-> ($object->{parent})));
	}' unless defined(&XtParent);
	eval 'sub XtX {
	    my($w) = @_;
    	    eval q((($w)-> ($core->{x})));
	}' unless defined(&XtX);
	eval 'sub XtY {
	    my($w) = @_;
    	    eval q((($w)-> ($core->{y})));
	}' unless defined(&XtY);
	eval 'sub XtWidth {
	    my($w) = @_;
    	    eval q((($w)-> ($core->{width})));
	}' unless defined(&XtWidth);
	eval 'sub XtHeight {
	    my($w) = @_;
    	    eval q((($w)-> ($core->{height})));
	}' unless defined(&XtHeight);
	eval 'sub XtBorderWidth {
	    my($w) = @_;
    	    eval q((($w)-> ($core->{border_width})));
	}' unless defined(&XtBorderWidth);
	eval 'sub XtBackground {
	    my($w) = @_;
    	    eval q((($w)-> ($core->{background_pixel})));
	}' unless defined(&XtBackground);
	eval 'sub XtSensitive {
	    my($w) = @_;
    	    eval q((($w)-> ($core->{sensitive})  && ($w)-> ($core->{ancestor_sensitive})));
	}' unless defined(&XtSensitive);
	eval 'sub XtCoreProc {
	    my($w,$proc) = @_;
    	    eval q((($w)-> ($core->{widget_class}->{core_class}->{proc})));
	}' unless defined(&XtCoreProc);
	unless(defined(&XmConst)) {
	    if(((defined( &__STDC__)  && (defined(&__STDC__) ? &__STDC__ : 0)) || ((defined(&FUNCPROTO) ? &FUNCPROTO : 0)&4)) || !defined( (defined(&NO_CONST) ? &NO_CONST : 0) )|| defined( &SUN_MOTIF)) {
		eval 'sub XmConst () { &const;}' unless defined(&XmConst);
	    } else {
		eval 'sub XmConst () {1;}' unless defined(&XmConst);
	    }
	}
	eval("sub XmMENU_POPDOWN () { 0; }") unless defined(&XmMENU_POPDOWN);
	eval("sub XmMENU_PROCESS_TREE () { 1; }") unless defined(&XmMENU_PROCESS_TREE);
	eval("sub XmMENU_TRAVERSAL () { 2; }") unless defined(&XmMENU_TRAVERSAL);
	eval("sub XmMENU_SHELL_POPDOWN () { 3; }") unless defined(&XmMENU_SHELL_POPDOWN);
	eval("sub XmMENU_CALLBACK () { 4; }") unless defined(&XmMENU_CALLBACK);
	eval("sub XmMENU_BUTTON () { 5; }") unless defined(&XmMENU_BUTTON);
	eval("sub XmMENU_CASCADING () { 6; }") unless defined(&XmMENU_CASCADING);
	eval("sub XmMENU_SUBMENU () { 7; }") unless defined(&XmMENU_SUBMENU);
	eval("sub XmMENU_ARM () { 8; }") unless defined(&XmMENU_ARM);
	eval("sub XmMENU_DISARM () { 9; }") unless defined(&XmMENU_DISARM);
	eval("sub XmMENU_BAR_CLEANUP () { 10; }") unless defined(&XmMENU_BAR_CLEANUP);
	eval("sub XmMENU_STATUS () { 11; }") unless defined(&XmMENU_STATUS);
	eval("sub XmMENU_MEMWIDGET_UPDATE () { 12; }") unless defined(&XmMENU_MEMWIDGET_UPDATE);
	eval("sub XmMENU_BUTTON_POPDOWN () { 13; }") unless defined(&XmMENU_BUTTON_POPDOWN);
	eval("sub XmMENU_RESTORE_EXCLUDED_TEAROFF_TO_TOPLEVEL_SHELL () { 14; }") unless defined(&XmMENU_RESTORE_EXCLUDED_TEAROFF_TO_TOPLEVEL_SHELL);
	eval("sub XmMENU_RESTORE_TEAROFF_TO_TOPLEVEL_SHELL () { 15; }") unless defined(&XmMENU_RESTORE_TEAROFF_TO_TOPLEVEL_SHELL);
	eval("sub XmMENU_RESTORE_TEAROFF_TO_MENUSHELL () { 16; }") unless defined(&XmMENU_RESTORE_TEAROFF_TO_MENUSHELL);
	eval("sub XmMENU_GET_LAST_SELECT_TOPLEVEL () { 17; }") unless defined(&XmMENU_GET_LAST_SELECT_TOPLEVEL);
	eval("sub XmMENU_TEAR_OFF_ARM () { 18; }") unless defined(&XmMENU_TEAR_OFF_ARM);
	eval 'sub XmMENU_TORN_BIT () {(1<< 0);}' unless defined(&XmMENU_TORN_BIT);
	eval 'sub XmMENU_TEAR_OFF_SHELL_DESCENDANT_BIT () {(1<< 1);}' unless defined(&XmMENU_TEAR_OFF_SHELL_DESCENDANT_BIT);
	eval 'sub XmMENU_POPUP_POSTED_BIT () {(1<< 2);}' unless defined(&XmMENU_POPUP_POSTED_BIT);
	eval 'sub XmIsTorn {
	    my($mask) = @_;
    	    eval q(($mask &  &XmMENU_TORN_BIT));
	}' unless defined(&XmIsTorn);
	eval 'sub XmIsTearOffShellDescendant {
	    my($mask) = @_;
    	    eval q(($mask &  &XmMENU_TEAR_OFF_SHELL_DESCENDANT_BIT));
	}' unless defined(&XmIsTearOffShellDescendant);
	eval 'sub XmPopupPosted {
	    my($mask) = @_;
    	    eval q(($mask &  &XmMENU_POPUP_POSTED_BIT));
	}' unless defined(&XmPopupPosted);
	if(defined(&_NO_PROTO)) {
	} else {
	}
	eval 'sub XmIGNORE_EVENTTYPE () {-1;}' unless defined(&XmIGNORE_EVENTTYPE);
	eval 'sub XmDEFAULT_INDICATOR_DIM () {9;}' unless defined(&XmDEFAULT_INDICATOR_DIM);
	eval 'sub Xm3D_ENHANCE_PIXEL () {2;}' unless defined(&Xm3D_ENHANCE_PIXEL);
	eval 'sub XmDEFAULT_TOP_MARGIN () {0;}' unless defined(&XmDEFAULT_TOP_MARGIN);
	eval 'sub XmDEFAULT_BOTTOM_MARGIN () {0;}' unless defined(&XmDEFAULT_BOTTOM_MARGIN);
	eval("sub XmSYNTHETIC_NONE () { 0; }") unless defined(&XmSYNTHETIC_NONE);
	eval("sub XmSYNTHETIC_LOAD () { 1; }") unless defined(&XmSYNTHETIC_LOAD);
	if(defined(&_NO_PROTO)) {
	} else {
	}
	eval("sub XmPARENT_PROCESS_ANY () { 0; }") unless defined(&XmPARENT_PROCESS_ANY);
	eval("sub XmINPUT_ACTION () { 1; }") unless defined(&XmINPUT_ACTION);
	eval("sub XmPARENT_ACTIVATE () { 0; }") unless defined(&XmPARENT_ACTIVATE);
	eval("sub XmPARENT_CANCEL () { 1; }") unless defined(&XmPARENT_CANCEL);
	eval 'sub XmRETURN () { &XmPARENT_ACTIVATE;}' unless defined(&XmRETURN);
	eval 'sub XmCANCEL () { &XmPARENT_CANCEL;}' unless defined(&XmCANCEL);
	eval 'sub XmINVALID_DIMENSION () {(0xffff);}' unless defined(&XmINVALID_DIMENSION);
	eval("sub XmBASELINE_GET () { 0; }") unless defined(&XmBASELINE_GET);
	eval("sub XmBASELINE_SET () { 1; }") unless defined(&XmBASELINE_SET);
	eval("sub XmFOCUS_IN () { 0; }") unless defined(&XmFOCUS_IN);
	eval("sub XmFOCUS_OUT () { 1; }") unless defined(&XmFOCUS_OUT);
	eval("sub XmENTER () { 2; }") unless defined(&XmENTER);
	eval("sub XmLEAVE () { 3; }") unless defined(&XmLEAVE);
	eval("sub XmNOT_NAVIGABLE () { 0; }") unless defined(&XmNOT_NAVIGABLE);
	eval("sub XmCONTROL_NAVIGABLE () { 1; }") unless defined(&XmCONTROL_NAVIGABLE);
	eval("sub XmTAB_NAVIGABLE () { 2; }") unless defined(&XmTAB_NAVIGABLE);
	eval("sub XmDESCENDANTS_NAVIGABLE () { 3; }") unless defined(&XmDESCENDANTS_NAVIGABLE);
	eval("sub XmDESCENDANTS_TAB_NAVIGABLE () { 4; }") unless defined(&XmDESCENDANTS_TAB_NAVIGABLE);
	eval 'sub XmVoidProc () { &XtProc;}' unless defined(&XmVoidProc);
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	eval("sub XmDEST_SELECT () { 0; }") unless defined(&XmDEST_SELECT);
	eval("sub XmPRIM_SELECT () { 1; }") unless defined(&XmPRIM_SELECT);
	eval("sub _XM_IS_DEST_CTX () { 0; }") unless defined(&_XM_IS_DEST_CTX);
	eval("sub _XM_IS_GC_DATA_CTX () { 1; }") unless defined(&_XM_IS_GC_DATA_CTX);
	eval("sub _XM_IS_PIXMAP_CTX () { 2; }") unless defined(&_XM_IS_PIXMAP_CTX);
	eval 'sub XmTEXT_DRAG_ICON_WIDTH () {64;}' unless defined(&XmTEXT_DRAG_ICON_WIDTH);
	eval 'sub XmTEXT_DRAG_ICON_HEIGHT () {64;}' unless defined(&XmTEXT_DRAG_ICON_HEIGHT);
	eval 'sub XmTEXT_DRAG_ICON_X_HOT () {10;}' unless defined(&XmTEXT_DRAG_ICON_X_HOT);
	eval 'sub XmTEXT_DRAG_ICON_Y_HOT () {4;}' unless defined(&XmTEXT_DRAG_ICON_Y_HOT);
	eval("sub XmGET_ACTUAL_SIZE () { 1; }") unless defined(&XmGET_ACTUAL_SIZE);
	eval("sub XmGET_PREFERRED_SIZE () { 2; }") unless defined(&XmGET_PREFERRED_SIZE);
	eval("sub XmGEO_PRE_SET () { 3; }") unless defined(&XmGEO_PRE_SET);
	eval("sub XmGEO_POST_SET () { 4; }") unless defined(&XmGEO_POST_SET);
	eval("sub XmGEO_EXPAND () { 0; }") unless defined(&XmGEO_EXPAND);
	eval("sub XmGEO_CENTER () { 1; }") unless defined(&XmGEO_CENTER);
	eval("sub XmGEO_PACK () { 2; }") unless defined(&XmGEO_PACK);
	eval("sub XmGEO_PROPORTIONAL () { 0; }") unless defined(&XmGEO_PROPORTIONAL);
	eval("sub XmGEO_AVERAGING () { 1; }") unless defined(&XmGEO_AVERAGING);
	eval("sub XmGEO_WRAP () { 2; }") unless defined(&XmGEO_WRAP);
	eval("sub XmGEO_ROW_MAJOR () { 0; }") unless defined(&XmGEO_ROW_MAJOR);
	eval("sub XmGEO_COLUMN_MAJOR () { 1; }") unless defined(&XmGEO_COLUMN_MAJOR);
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	eval 'sub XmInheritCallbackProc () {(( &XtCallbackProc)  &_XtInherit);}' unless defined(&XmInheritCallbackProc);
	eval 'sub XmInheritTraversalProc () {(( &XmTraversalProc)  &_XtInherit);}' unless defined(&XmInheritTraversalProc);
	eval 'sub XmInheritParentProcess () {(( &XmParentProcessProc)  &_XtInherit);}' unless defined(&XmInheritParentProcess);
	eval 'sub XmInheritWidgetProc () {(( &XtWidgetProc)  &_XtInherit);}' unless defined(&XmInheritWidgetProc);
	eval 'sub XmInheritMenuProc () {(( &XmMenuProc)  &_XtInherit);}' unless defined(&XmInheritMenuProc);
	eval 'sub XmInheritTranslations () { &XtInheritTranslations;}' unless defined(&XmInheritTranslations);
	eval 'sub XmInheritCachePart () {(( &XmCacheClassPartPtr)  &_XtInherit);}' unless defined(&XmInheritCachePart);
	eval 'sub XmInheritBaselineProc () {(( &XmWidgetBaselineProc)  &_XtInherit);}' unless defined(&XmInheritBaselineProc);
	eval 'sub XmInheritDisplayRectProc () {(( &XmWidgetDisplayRectProc)  &_XtInherit);}' unless defined(&XmInheritDisplayRectProc);
	eval 'sub XmInheritMarginsProc () {(( &XmWidgetMarginsProc)  &_XtInherit);}' unless defined(&XmInheritMarginsProc);
	eval 'sub XmInheritGeoMatrixCreate () {(( &XmGeoCreateProc)  &_XtInherit);}' unless defined(&XmInheritGeoMatrixCreate);
	eval 'sub XmInheritFocusMovedProc () {(( &XmFocusMovedProc)  &_XtInherit);}' unless defined(&XmInheritFocusMovedProc);
	eval 'sub XmInheritClass () {(( &WidgetClass) & &_XmInheritClass);}' unless defined(&XmInheritClass);
	eval 'sub XmInheritInitializePrehook () {(( &XtInitProc)  &_XtInherit);}' unless defined(&XmInheritInitializePrehook);
	eval 'sub XmInheritSetValuesPrehook () {(( &XtSetValuesFunc)  &_XtInherit);}' unless defined(&XmInheritSetValuesPrehook);
	eval 'sub XmInheritGetValuesPrehook () {(( &XtArgsProc)  &_XtInherit);}' unless defined(&XmInheritGetValuesPrehook);
	eval 'sub XmInheritInitializePosthook () {(( &XtInitProc)  &_XtInherit);}' unless defined(&XmInheritInitializePosthook);
	eval 'sub XmInheritSetValuesPosthook () {(( &XtSetValuesFunc)  &_XtInherit);}' unless defined(&XmInheritSetValuesPosthook);
	eval 'sub XmInheritGetValuesPosthook () {(( &XtArgsProc)  &_XtInherit);}' unless defined(&XmInheritGetValuesPosthook);
	eval 'sub XmInheritSecObjectCreate () {(( &XtInitProc)  &_XtInherit);}' unless defined(&XmInheritSecObjectCreate);
	eval 'sub XmInheritGetSecResData () {(( &XmGetSecResDataFunc)  &_XtInherit);}' unless defined(&XmInheritGetSecResData);
	eval 'sub XmInheritInputDispatch () {(( &XmWidgetDispatchProc)  &_XtInherit);}' unless defined(&XmInheritInputDispatch);
	eval 'sub XmInheritVisualChange () {(( &XmVisualChangeProc)  &_XtInherit);}' unless defined(&XmInheritVisualChange);
	eval 'sub XmInheritArmAndActivate () {(( &XtActionProc)  &_XtInherit);}' unless defined(&XmInheritArmAndActivate);
	eval 'sub XmInheritActionProc () {(( &XtActionProc)  &_XtInherit);}' unless defined(&XmInheritActionProc);
	eval 'sub XmInheritFocusChange () {(( &XmFocusChangeProc)  &_XtInherit);}' unless defined(&XmInheritFocusChange);
	eval 'sub XmInheritWidgetNavigable () {(( &XmWidgetNavigableProc)  &_XtInherit);}' unless defined(&XmInheritWidgetNavigable);
	eval 'sub XmInheritClassPartInitPrehook () {(( &XtWidgetClassProc)  &_XtInherit);}' unless defined(&XmInheritClassPartInitPrehook);
	eval 'sub XmInheritClassPartInitPosthook () {(( &XtWidgetClassProc)  &_XtInherit);}' unless defined(&XmInheritClassPartInitPosthook);
	eval 'sub XmInheritBorderHighlight () {(( &XtWidgetProc)  &_XtInherit);}' unless defined(&XmInheritBorderHighlight);
	eval 'sub XmInheritBorderUnhighlight () {(( &XtWidgetProc)  &_XtInherit);}' unless defined(&XmInheritBorderUnhighlight);
	eval 'sub XtInheritFocusMovedProc () { &XmInheritFocusMovedProc;}' unless defined(&XtInheritFocusMovedProc);
	eval 'sub XmFIRST_APPLICATION_SUBCLASS_BIT () {192;}' unless defined(&XmFIRST_APPLICATION_SUBCLASS_BIT);
	eval("sub XmCASCADE_BUTTON_BIT () { 1; }") unless defined(&XmCASCADE_BUTTON_BIT);
	eval("sub XmCASCADE_BUTTON_GADGET_BIT () { 2; }") unless defined(&XmCASCADE_BUTTON_GADGET_BIT);
	eval("sub XmCOMMAND_BOX_BIT () { 3; }") unless defined(&XmCOMMAND_BOX_BIT);
	eval("sub XmDIALOG_SHELL_BIT () { 4; }") unless defined(&XmDIALOG_SHELL_BIT);
	eval("sub XmLIST_BIT () { 5; }") unless defined(&XmLIST_BIT);
	eval("sub XmFORM_BIT () { 6; }") unless defined(&XmFORM_BIT);
	eval("sub XmTEXT_FIELD_BIT () { 7; }") unless defined(&XmTEXT_FIELD_BIT);
	eval("sub XmGADGET_BIT () { 8; }") unless defined(&XmGADGET_BIT);
	eval("sub XmLABEL_BIT () { 9; }") unless defined(&XmLABEL_BIT);
	eval("sub XmLABEL_GADGET_BIT () { 10; }") unless defined(&XmLABEL_GADGET_BIT);
	eval("sub XmMAIN_WINDOW_BIT () { 11; }") unless defined(&XmMAIN_WINDOW_BIT);
	eval("sub XmMANAGER_BIT () { 12; }") unless defined(&XmMANAGER_BIT);
	eval("sub XmMENU_SHELL_BIT () { 13; }") unless defined(&XmMENU_SHELL_BIT);
	eval("sub XmDRAWN_BUTTON_BIT () { 14; }") unless defined(&XmDRAWN_BUTTON_BIT);
	eval("sub XmPRIMITIVE_BIT () { 15; }") unless defined(&XmPRIMITIVE_BIT);
	eval("sub XmPUSH_BUTTON_BIT () { 16; }") unless defined(&XmPUSH_BUTTON_BIT);
	eval("sub XmPUSH_BUTTON_GADGET_BIT () { 17; }") unless defined(&XmPUSH_BUTTON_GADGET_BIT);
	eval("sub XmROW_COLUMN_BIT () { 18; }") unless defined(&XmROW_COLUMN_BIT);
	eval("sub XmSCROLL_BAR_BIT () { 19; }") unless defined(&XmSCROLL_BAR_BIT);
	eval("sub XmSCROLLED_WINDOW_BIT () { 20; }") unless defined(&XmSCROLLED_WINDOW_BIT);
	eval("sub XmSELECTION_BOX_BIT () { 21; }") unless defined(&XmSELECTION_BOX_BIT);
	eval("sub XmSEPARATOR_BIT () { 22; }") unless defined(&XmSEPARATOR_BIT);
	eval("sub XmSEPARATOR_GADGET_BIT () { 23; }") unless defined(&XmSEPARATOR_GADGET_BIT);
	eval("sub XmTEXT_BIT () { 24; }") unless defined(&XmTEXT_BIT);
	eval("sub XmTOGGLE_BUTTON_BIT () { 25; }") unless defined(&XmTOGGLE_BUTTON_BIT);
	eval("sub XmTOGGLE_BUTTON_GADGET_BIT () { 26; }") unless defined(&XmTOGGLE_BUTTON_GADGET_BIT);
	eval("sub XmDROP_TRANSFER_BIT () { 27; }") unless defined(&XmDROP_TRANSFER_BIT);
	eval("sub XmDROP_SITE_MANAGER_BIT () { 28; }") unless defined(&XmDROP_SITE_MANAGER_BIT);
	eval("sub XmDISPLAY_BIT () { 29; }") unless defined(&XmDISPLAY_BIT);
	eval("sub XmSCREEN_BIT () { 30; }") unless defined(&XmSCREEN_BIT);
	eval("sub XmARROW_BUTTON_BIT () { 32; }") unless defined(&XmARROW_BUTTON_BIT);
	eval("sub XmARROW_BUTTON_GADGET_BIT () { 33; }") unless defined(&XmARROW_BUTTON_GADGET_BIT);
	eval("sub XmBULLETIN_BOARD_BIT () { 34; }") unless defined(&XmBULLETIN_BOARD_BIT);
	eval("sub XmDRAWING_AREA_BIT () { 35; }") unless defined(&XmDRAWING_AREA_BIT);
	eval("sub XmFILE_SELECTION_BOX_BIT () { 36; }") unless defined(&XmFILE_SELECTION_BOX_BIT);
	eval("sub XmFRAME_BIT () { 37; }") unless defined(&XmFRAME_BIT);
	eval("sub XmMESSAGE_BOX_BIT () { 38; }") unless defined(&XmMESSAGE_BOX_BIT);
	eval("sub XmSASH_BIT () { 39; }") unless defined(&XmSASH_BIT);
	eval("sub XmSCALE_BIT () { 40; }") unless defined(&XmSCALE_BIT);
	eval("sub XmPANED_WINDOW_BIT () { 41; }") unless defined(&XmPANED_WINDOW_BIT);
	eval("sub XmVENDOR_SHELL_BIT () { 42; }") unless defined(&XmVENDOR_SHELL_BIT);
	eval("sub XmCLIP_WINDOW_BIT () { 43; }") unless defined(&XmCLIP_WINDOW_BIT);
	eval("sub XmDRAG_ICON_BIT () { 44; }") unless defined(&XmDRAG_ICON_BIT);
	eval("sub XmTEAROFF_BUTTON_BIT () { 45; }") unless defined(&XmTEAROFF_BUTTON_BIT);
	eval("sub XmDRAG_OVER_SHELL_BIT () { 46; }") unless defined(&XmDRAG_OVER_SHELL_BIT);
	eval("sub XmDRAG_CONTEXT_BIT () { 47; }") unless defined(&XmDRAG_CONTEXT_BIT);
	eval("sub XmFAST_SUBCLASS_TAIL_BIT () { 48; }") unless defined(&XmFAST_SUBCLASS_TAIL_BIT);
	eval 'sub XmLAST_FAST_SUBCLASS_BIT () {( &XmFAST_SUBCLASS_TAIL_BIT - 1);}' unless defined(&XmLAST_FAST_SUBCLASS_BIT);
	undef(&XmIsCascadeButton) if defined(&XmIsCascadeButton);
	eval 'sub XmIsCascadeButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCASCADE_BUTTON_BIT)));
	}' unless defined(&XmIsCascadeButton);
	undef(&XmIsCascadeButtonGadget) if defined(&XmIsCascadeButtonGadget);
	eval 'sub XmIsCascadeButtonGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCASCADE_BUTTON_GADGET_BIT)));
	}' unless defined(&XmIsCascadeButtonGadget);
	undef(&XmIsCommandBox) if defined(&XmIsCommandBox);
	eval 'sub XmIsCommandBox {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmCOMMAND_BOX_BIT)));
	}' unless defined(&XmIsCommandBox);
	undef(&XmIsDialogShell) if defined(&XmIsDialogShell);
	eval 'sub XmIsDialogShell {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDIALOG_SHELL_BIT)));
	}' unless defined(&XmIsDialogShell);
	undef(&XmIsDisplay) if defined(&XmIsDisplay);
	eval 'sub XmIsDisplay {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDISPLAY_BIT)));
	}' unless defined(&XmIsDisplay);
	undef(&XmIsList) if defined(&XmIsList);
	eval 'sub XmIsList {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmLIST_BIT)));
	}' unless defined(&XmIsList);
	undef(&XmIsForm) if defined(&XmIsForm);
	eval 'sub XmIsForm {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmFORM_BIT)));
	}' unless defined(&XmIsForm);
	undef(&XmIsTextField) if defined(&XmIsTextField);
	eval 'sub XmIsTextField {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTEXT_FIELD_BIT)));
	}' unless defined(&XmIsTextField);
	undef(&XmIsGadget) if defined(&XmIsGadget);
	eval 'sub XmIsGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmGADGET_BIT)));
	}' unless defined(&XmIsGadget);
	undef(&XmIsLabel) if defined(&XmIsLabel);
	eval 'sub XmIsLabel {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmLABEL_BIT)));
	}' unless defined(&XmIsLabel);
	undef(&XmIsLabelGadget) if defined(&XmIsLabelGadget);
	eval 'sub XmIsLabelGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmLABEL_GADGET_BIT)));
	}' unless defined(&XmIsLabelGadget);
	undef(&XmIsMainWindow) if defined(&XmIsMainWindow);
	eval 'sub XmIsMainWindow {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmMAIN_WINDOW_BIT)));
	}' unless defined(&XmIsMainWindow);
	undef(&XmIsManager) if defined(&XmIsManager);
	eval 'sub XmIsManager {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmMANAGER_BIT)));
	}' unless defined(&XmIsManager);
	undef(&XmIsMenuShell) if defined(&XmIsMenuShell);
	eval 'sub XmIsMenuShell {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmMENU_SHELL_BIT)));
	}' unless defined(&XmIsMenuShell);
	undef(&XmIsDragIcon) if defined(&XmIsDragIcon);
	eval 'sub XmIsDragIcon {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAG_ICON_BIT)));
	}' unless defined(&XmIsDragIcon);
	undef(&XmIsDropSiteManager) if defined(&XmIsDropSiteManager);
	eval 'sub XmIsDropSiteManager {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDROP_SITE_MANAGER_BIT)));
	}' unless defined(&XmIsDropSiteManager);
	undef(&XmIsDropTransfer) if defined(&XmIsDropTransfer);
	eval 'sub XmIsDropTransfer {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDROP_TRANSFER_BIT)));
	}' unless defined(&XmIsDropTransfer);
	undef(&XmIsDragOverShell) if defined(&XmIsDragOverShell);
	eval 'sub XmIsDragOverShell {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAG_OVER_SHELL_BIT)));
	}' unless defined(&XmIsDragOverShell);
	undef(&XmIsDragContext) if defined(&XmIsDragContext);
	eval 'sub XmIsDragContext {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAG_CONTEXT_BIT)));
	}' unless defined(&XmIsDragContext);
	undef(&XmIsDrawnButton) if defined(&XmIsDrawnButton);
	eval 'sub XmIsDrawnButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAWN_BUTTON_BIT)));
	}' unless defined(&XmIsDrawnButton);
	undef(&XmIsPrimitive) if defined(&XmIsPrimitive);
	eval 'sub XmIsPrimitive {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmPRIMITIVE_BIT)));
	}' unless defined(&XmIsPrimitive);
	undef(&XmIsPushButton) if defined(&XmIsPushButton);
	eval 'sub XmIsPushButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmPUSH_BUTTON_BIT)));
	}' unless defined(&XmIsPushButton);
	undef(&XmIsPushButtonGadget) if defined(&XmIsPushButtonGadget);
	eval 'sub XmIsPushButtonGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmPUSH_BUTTON_GADGET_BIT)));
	}' unless defined(&XmIsPushButtonGadget);
	undef(&XmIsRowColumn) if defined(&XmIsRowColumn);
	eval 'sub XmIsRowColumn {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmROW_COLUMN_BIT)));
	}' unless defined(&XmIsRowColumn);
	undef(&XmIsScreen) if defined(&XmIsScreen);
	eval 'sub XmIsScreen {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSCREEN_BIT)));
	}' unless defined(&XmIsScreen);
	undef(&XmIsScrollBar) if defined(&XmIsScrollBar);
	eval 'sub XmIsScrollBar {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSCROLL_BAR_BIT)));
	}' unless defined(&XmIsScrollBar);
	undef(&XmIsScrolledWindow) if defined(&XmIsScrolledWindow);
	eval 'sub XmIsScrolledWindow {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSCROLLED_WINDOW_BIT)));
	}' unless defined(&XmIsScrolledWindow);
	undef(&XmIsSelectionBox) if defined(&XmIsSelectionBox);
	eval 'sub XmIsSelectionBox {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSELECTION_BOX_BIT)));
	}' unless defined(&XmIsSelectionBox);
	undef(&XmIsSeparator) if defined(&XmIsSeparator);
	eval 'sub XmIsSeparator {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSEPARATOR_BIT)));
	}' unless defined(&XmIsSeparator);
	undef(&XmIsSeparatorGadget) if defined(&XmIsSeparatorGadget);
	eval 'sub XmIsSeparatorGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSEPARATOR_GADGET_BIT)));
	}' unless defined(&XmIsSeparatorGadget);
	undef(&XmIsText) if defined(&XmIsText);
	eval 'sub XmIsText {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTEXT_BIT)));
	}' unless defined(&XmIsText);
	undef(&XmIsTearOffButton) if defined(&XmIsTearOffButton);
	eval 'sub XmIsTearOffButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTEAROFF_BUTTON_BIT)));
	}' unless defined(&XmIsTearOffButton);
	undef(&XmIsToggleButton) if defined(&XmIsToggleButton);
	eval 'sub XmIsToggleButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTOGGLE_BUTTON_BIT)));
	}' unless defined(&XmIsToggleButton);
	undef(&XmIsToggleButtonGadget) if defined(&XmIsToggleButtonGadget);
	eval 'sub XmIsToggleButtonGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmTOGGLE_BUTTON_GADGET_BIT)));
	}' unless defined(&XmIsToggleButtonGadget);
	undef(&XmIsArrowButton) if defined(&XmIsArrowButton);
	eval 'sub XmIsArrowButton {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmARROW_BUTTON_BIT)));
	}' unless defined(&XmIsArrowButton);
	undef(&XmIsArrowButtonGadget) if defined(&XmIsArrowButtonGadget);
	eval 'sub XmIsArrowButtonGadget {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmARROW_BUTTON_GADGET_BIT)));
	}' unless defined(&XmIsArrowButtonGadget);
	undef(&XmIsBulletinBoard) if defined(&XmIsBulletinBoard);
	eval 'sub XmIsBulletinBoard {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmBULLETIN_BOARD_BIT)));
	}' unless defined(&XmIsBulletinBoard);
	undef(&XmIsDrawingArea) if defined(&XmIsDrawingArea);
	eval 'sub XmIsDrawingArea {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmDRAWING_AREA_BIT)));
	}' unless defined(&XmIsDrawingArea);
	undef(&XmIsFileSelectionBox) if defined(&XmIsFileSelectionBox);
	eval 'sub XmIsFileSelectionBox {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmFILE_SELECTION_BOX_BIT)));
	}' unless defined(&XmIsFileSelectionBox);
	undef(&XmIsFrame) if defined(&XmIsFrame);
	eval 'sub XmIsFrame {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmFRAME_BIT)));
	}' unless defined(&XmIsFrame);
	undef(&XmIsMessageBox) if defined(&XmIsMessageBox);
	eval 'sub XmIsMessageBox {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmMESSAGE_BOX_BIT)));
	}' unless defined(&XmIsMessageBox);
	undef(&XmIsSash) if defined(&XmIsSash);
	eval 'sub XmIsSash {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSASH_BIT)));
	}' unless defined(&XmIsSash);
	undef(&XmIsScale) if defined(&XmIsScale);
	eval 'sub XmIsScale {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmSCALE_BIT)));
	}' unless defined(&XmIsScale);
	undef(&XmIsPanedWindow) if defined(&XmIsPanedWindow);
	eval 'sub XmIsPanedWindow {
	    my($w) = @_;
    	    eval q(( &_XmIsFastSubclass( &XtClass($w),  &XmPANED_WINDOW_BIT)));
	}' unless defined(&XmIsPanedWindow);
	eval 'sub XmObjectIndex () {0;}' unless defined(&XmObjectIndex);
	eval 'sub ObjectIndex () { &XmObjectIndex;}' unless defined(&ObjectIndex);
	eval 'sub XmRectObjIndex () {( &XmObjectIndex + 1);}' unless defined(&XmRectObjIndex);
	eval 'sub RectObjIndex () { &XmRectObjIndex;}' unless defined(&RectObjIndex);
	eval 'sub XmWindowObjIndex () {( &XmRectObjIndex + 1);}' unless defined(&XmWindowObjIndex);
	eval 'sub WindowObjIndex () { &XmWindowObjIndex;}' unless defined(&WindowObjIndex);
	eval 'sub XmCoreIndex () {0;}' unless defined(&XmCoreIndex);
	eval 'sub CoreIndex () { &XmCoreIndex;}' unless defined(&CoreIndex);
	eval 'sub XmCompositeIndex () {( &XmWindowObjIndex + 2);}' unless defined(&XmCompositeIndex);
	eval 'sub CompositeIndex () { &XmCompositeIndex;}' unless defined(&CompositeIndex);
	eval 'sub XmConstraintIndex () {( &XmCompositeIndex + 1);}' unless defined(&XmConstraintIndex);
	eval 'sub ConstraintIndex () { &XmConstraintIndex;}' unless defined(&ConstraintIndex);
	eval 'sub XmGadgetIndex () {( &XmRectObjIndex + 1);}' unless defined(&XmGadgetIndex);
	eval 'sub XmPrimitiveIndex () {( &XmWindowObjIndex + 2);}' unless defined(&XmPrimitiveIndex);
	eval 'sub XmManagerIndex () {( &XmConstraintIndex + 1);}' unless defined(&XmManagerIndex);
	eval 'sub XmArrowBIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmArrowBIndex);
	eval 'sub XmArrowButtonIndex () { &XmArrowBIndex;}' unless defined(&XmArrowButtonIndex);
	eval 'sub XmLabelIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmLabelIndex);
	eval 'sub XmListIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmListIndex);
	eval 'sub XmScrollBarIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmScrollBarIndex);
	eval 'sub XmSeparatorIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmSeparatorIndex);
	eval 'sub XmTextIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmTextIndex);
	eval 'sub XmCascadeBIndex () {( &XmLabelIndex + 1);}' unless defined(&XmCascadeBIndex);
	eval 'sub XmCascadeButtonIndex () { &XmCascadeBIndex;}' unless defined(&XmCascadeButtonIndex);
	eval 'sub XmDrawnBIndex () {( &XmLabelIndex + 1);}' unless defined(&XmDrawnBIndex);
	eval 'sub XmDrawnButtonIndex () { &XmDrawnBIndex;}' unless defined(&XmDrawnButtonIndex);
	eval 'sub XmPushBIndex () {( &XmLabelIndex + 1);}' unless defined(&XmPushBIndex);
	eval 'sub XmPushButtonIndex () { &XmPushBIndex;}' unless defined(&XmPushButtonIndex);
	eval 'sub XmToggleBIndex () {( &XmLabelIndex + 1);}' unless defined(&XmToggleBIndex);
	eval 'sub XmToggleButtonIndex () { &XmToggleBIndex;}' unless defined(&XmToggleButtonIndex);
	eval 'sub XmTearOffButtonIndex () {( &XmPushBIndex + 1);}' unless defined(&XmTearOffButtonIndex);
	eval 'sub XmArrowBGIndex () {( &XmGadgetIndex + 1);}' unless defined(&XmArrowBGIndex);
	eval 'sub XmArrowButtonGadgetIndex () { &XmArrowBGIndex;}' unless defined(&XmArrowButtonGadgetIndex);
	eval 'sub XmLabelGIndex () {( &XmGadgetIndex + 1);}' unless defined(&XmLabelGIndex);
	eval 'sub XmLabelGadgetIndex () { &XmLabelGIndex;}' unless defined(&XmLabelGadgetIndex);
	eval 'sub XmSeparatoGIndex () {( &XmGadgetIndex + 1);}' unless defined(&XmSeparatoGIndex);
	eval 'sub XmSeparatorGadgetIndex () { &XmSeparatoGIndex;}' unless defined(&XmSeparatorGadgetIndex);
	eval 'sub XmCascadeBGIndex () {( &XmLabelGIndex + 1);}' unless defined(&XmCascadeBGIndex);
	eval 'sub XmCascadeButtonGadgetIndex () { &XmCascadeBGIndex;}' unless defined(&XmCascadeButtonGadgetIndex);
	eval 'sub XmPushBGIndex () {( &XmLabelGIndex + 1);}' unless defined(&XmPushBGIndex);
	eval 'sub XmPushButtonGadgetIndex () { &XmPushBGIndex;}' unless defined(&XmPushButtonGadgetIndex);
	eval 'sub XmToggleBGIndex () {( &XmLabelGIndex + 1);}' unless defined(&XmToggleBGIndex);
	eval 'sub XmToggleButtonGadgetIndex () { &XmToggleBGIndex;}' unless defined(&XmToggleButtonGadgetIndex);
	eval 'sub XmBulletinBIndex () {( &XmManagerIndex + 1);}' unless defined(&XmBulletinBIndex);
	eval 'sub XmBulletinBoardIndex () { &XmBulletinBIndex;}' unless defined(&XmBulletinBoardIndex);
	eval 'sub XmDrawingAIndex () {( &XmManagerIndex + 1);}' unless defined(&XmDrawingAIndex);
	eval 'sub XmDrawingAreaIndex () { &XmDrawingAIndex;}' unless defined(&XmDrawingAreaIndex);
	eval 'sub XmFrameIndex () {( &XmManagerIndex + 1);}' unless defined(&XmFrameIndex);
	eval 'sub XmPanedWIndex () {( &XmManagerIndex + 1);}' unless defined(&XmPanedWIndex);
	eval 'sub XmPanedWindowIndex () { &XmPanedWIndex;}' unless defined(&XmPanedWindowIndex);
	eval 'sub XmSashIndex () {( &XmPrimitiveIndex + 1);}' unless defined(&XmSashIndex);
	eval 'sub XmRowColumnIndex () {( &XmManagerIndex + 1);}' unless defined(&XmRowColumnIndex);
	eval 'sub XmScaleIndex () {( &XmManagerIndex + 1);}' unless defined(&XmScaleIndex);
	eval 'sub XmScrolledWIndex () {( &XmManagerIndex + 1);}' unless defined(&XmScrolledWIndex);
	eval 'sub XmScrolledWindowIndex () { &XmScrolledWIndex;}' unless defined(&XmScrolledWindowIndex);
	eval 'sub XmFormIndex () {( &XmBulletinBIndex + 1);}' unless defined(&XmFormIndex);
	eval 'sub XmMessageBIndex () {( &XmBulletinBIndex + 1);}' unless defined(&XmMessageBIndex);
	eval 'sub XmMessageBoxIndex () { &XmMessageBIndex;}' unless defined(&XmMessageBoxIndex);
	eval 'sub XmSelectioBIndex () {( &XmBulletinBIndex + 1);}' unless defined(&XmSelectioBIndex);
	eval 'sub XmSelectionBoxIndex () { &XmSelectioBIndex;}' unless defined(&XmSelectionBoxIndex);
	eval 'sub XmMainWIndex () {( &XmScrolledWIndex + 1);}' unless defined(&XmMainWIndex);
	eval 'sub XmMainWindowIndex () { &XmMainWIndex;}' unless defined(&XmMainWindowIndex);
	eval 'sub XmCommandIndex () {( &XmSelectioBIndex + 1);}' unless defined(&XmCommandIndex);
	eval 'sub XmFileSBIndex () {( &XmSelectioBIndex + 1);}' unless defined(&XmFileSBIndex);
	eval 'sub XmFileSelectionBoxIndex () { &XmFileSBIndex;}' unless defined(&XmFileSelectionBoxIndex);
	eval 'sub XmShellIndex () {( &XmCompositeIndex + 1);}' unless defined(&XmShellIndex);
	eval 'sub ShellIndex () { &XmShellIndex;}' unless defined(&ShellIndex);
	eval 'sub XmOverrideShellIndex () {( &XmShellIndex + 1);}' unless defined(&XmOverrideShellIndex);
	eval 'sub OverrideShellIndex () { &XmOverrideShellIndex;}' unless defined(&OverrideShellIndex);
	eval 'sub XmWMShellIndex () {( &XmShellIndex + 1);}' unless defined(&XmWMShellIndex);
	eval 'sub WMShellIndex () { &XmWMShellIndex;}' unless defined(&WMShellIndex);
	eval 'sub XmVendorShellIndex () {( &XmWMShellIndex + 1);}' unless defined(&XmVendorShellIndex);
	eval 'sub VendorShellIndex () { &XmVendorShellIndex;}' unless defined(&VendorShellIndex);
	eval 'sub XmTransientShellIndex () {( &XmVendorShellIndex + 1);}' unless defined(&XmTransientShellIndex);
	eval 'sub TransientShellIndex () { &XmTransientShellIndex;}' unless defined(&TransientShellIndex);
	eval 'sub XmTopLevelShellIndex () {( &XmVendorShellIndex + 1);}' unless defined(&XmTopLevelShellIndex);
	eval 'sub TopLevelShellIndex () { &XmTopLevelShellIndex;}' unless defined(&TopLevelShellIndex);
	eval 'sub XmApplicationShellIndex () {( &XmTopLevelShellIndex + 1);}' unless defined(&XmApplicationShellIndex);
	eval 'sub ApplicationShellIndex () { &XmApplicationShellIndex;}' unless defined(&ApplicationShellIndex);
	eval 'sub XmDisplayIndex () {( &XmApplicationShellIndex + 1);}' unless defined(&XmDisplayIndex);
	eval 'sub XmDialogSIndex () {( &XmTransientShellIndex + 1);}' unless defined(&XmDialogSIndex);
	eval 'sub XmDialogShellIndex () { &XmDialogSIndex;}' unless defined(&XmDialogShellIndex);
	eval 'sub XmMenuShellIndex () {( &XmOverrideShellIndex + 1);}' unless defined(&XmMenuShellIndex);
	eval 'sub XmDragIconIndex () {( &XmRectObjIndex + 1);}' unless defined(&XmDragIconIndex);
	eval 'sub XmDropSiteManagerIndex () {( &XmObjectIndex + 1);}' unless defined(&XmDropSiteManagerIndex);
	eval 'sub XmDropTransferIndex () {( &XmObjectIndex + 1);}' unless defined(&XmDropTransferIndex);
	eval 'sub XmDragOverShellIndex () {( &XmVendorShellIndex + 1);}' unless defined(&XmDragOverShellIndex);
	eval 'sub XmDragContextIndex () {( &XmCoreIndex + 1);}' unless defined(&XmDragContextIndex);
	eval 'sub XmOFFSETBITS () {($sizeof{ &Cardinal}*8/2);}' unless defined(&XmOFFSETBITS);
	eval 'sub XmOFFSETMASK () {((1<< &XmOFFSETBITS)-1);}' unless defined(&XmOFFSETMASK);
	if(defined( &FUNCPROTO) || defined( &__STDC__)  && !defined( &UNIXCPP) || defined( &__cplusplus)) {
	    eval 'sub XmPartOffset {
	        my($part, $variable) = @_;
    		eval q((($part &Index) <<  &XmOFFSETBITS) +  &XtOffsetOf( $part &Part, $variable));
	    }' unless defined(&XmPartOffset);
	    eval 'sub XmConstraintPartOffset {
	        my($part, $variable) = @_;
    		eval q((($part &Index) <<  &XmOFFSETBITS) +  &XtOffsetOf( $part &ConstraintPart, $variable));
	    }' unless defined(&XmConstraintPartOffset);
	    eval 'sub XmGetPartOffset {
	        my($r, $offset) = @_;
    		eval q((($r)-> &resource_offset &  &XmOFFSETMASK) + (*($offset))[($r)-> &resource_offset >>  &XmOFFSETBITS];);
	    }' unless defined(&XmGetPartOffset);
	    eval 'sub XmField {
	        my($widget, $offsetrecord, $part, $variable, $type) = @_;
    		eval q((*($type *)(( ($widget)) + $offsetrecord->[$part &Index] +  &XtOffsetOf( $part &Part, $variable))));
	    }' unless defined(&XmField);
	    eval 'sub XmConstraintField {
	        my($widget, $offsetrecord, $part, $variable, $type) = @_;
    		eval q((*($type *)(( ($widget)-> ($core->{constraints})) + $offsetrecord->[$part &Index] +  &XtOffsetOf( $part &ConstraintPart, $variable))));
	    }' unless defined(&XmConstraintField);
	} else {
	    eval 'sub XmPartOffset {
	        my($part, $variable) = @_;
    		eval q((($part  &Index) <<  &XmOFFSETBITS) +  &XtOffsetOf( $part  &Part, $variable));
	    }' unless defined(&XmPartOffset);
	    eval 'sub XmConstraintPartOffset {
	        my($part, $variable) = @_;
    		eval q((($part  &Index) <<  &XmOFFSETBITS) +  &XtOffsetOf( $part  &ConstraintPart, $variable));
	    }' unless defined(&XmConstraintPartOffset);
	    eval 'sub XmGetPartOffset {
	        my($r, $offset) = @_;
    		eval q((($r)-> &resource_offset &  &XmOFFSETMASK) + (*($offset))[($r)-> &resource_offset >>  &XmOFFSETBITS];);
	    }' unless defined(&XmGetPartOffset);
	    eval 'sub XmField {
	        my($widget, $offsetrecord, $part, $variable, $type) = @_;
    		eval q((*($type *)(( ($widget)) + $offsetrecord->[$part  &Index] +  &XtOffsetOf( $part  &Part, $variable))));
	    }' unless defined(&XmField);
	    eval 'sub XmConstraintField {
	        my($widget, $offsetrecord, $part, $variable, $type) = @_;
    		eval q((*($type *)(( ($widget)-> ($core->{constraints})) + $offsetrecord->[$part  &Index] +  &XtOffsetOf( $part  &ConstraintPart, $variable))));
	    }' unless defined(&XmConstraintField);
	}
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	eval 'sub _XmCreateImage {
	    my($IMAGE, $DISPLAY, $DATA, $WIDTH, $HEIGHT, $BYTE_ORDER) = @_;
    	    eval q({ $IMAGE =  &XCreateImage($DISPLAY,  &DefaultVisual($DISPLAY,  &DefaultScreen($DISPLAY)), 1,  &XYBitmap, 0, $DATA, $WIDTH, $HEIGHT, 8, ($WIDTH+7) >> 3);  ($IMAGE->{byte_order}) = $BYTE_ORDER;  ($IMAGE->{bitmap_unit}) = 8;  ($IMAGE->{bitmap_bit_order}) =  &LSBFirst;});
	}' unless defined(&_XmCreateImage);
	if(defined(&_NO_PROTO)) {
	} else {
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	eval("sub XmLABEL_FONTLIST () { 1; }") unless defined(&XmLABEL_FONTLIST);
	eval("sub XmBUTTON_FONTLIST () { 2; }") unless defined(&XmBUTTON_FONTLIST);
	eval("sub XmTEXT_FONTLIST () { 3; }") unless defined(&XmTEXT_FONTLIST);
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	eval 'sub XmLOOK_AT_SCREEN () {(1<<0);}' unless defined(&XmLOOK_AT_SCREEN);
	eval 'sub XmLOOK_AT_CMAP () {(1<<1);}' unless defined(&XmLOOK_AT_CMAP);
	eval 'sub XmLOOK_AT_BACKGROUND () {(1<<2);}' unless defined(&XmLOOK_AT_BACKGROUND);
	eval 'sub XmLOOK_AT_FOREGROUND () {(1<<3);}' unless defined(&XmLOOK_AT_FOREGROUND);
	eval 'sub XmLOOK_AT_TOP_SHADOW () {(1<<4);}' unless defined(&XmLOOK_AT_TOP_SHADOW);
	eval 'sub XmLOOK_AT_BOTTOM_SHADOW () {(1<<5);}' unless defined(&XmLOOK_AT_BOTTOM_SHADOW);
	eval 'sub XmLOOK_AT_SELECT () {(1<<6);}' unless defined(&XmLOOK_AT_SELECT);
	eval 'sub XmBACKGROUND () {( (1<<0));}' unless defined(&XmBACKGROUND);
	eval 'sub XmFOREGROUND () {( (1<<1));}' unless defined(&XmFOREGROUND);
	eval 'sub XmTOP_SHADOW () {( (1<<2));}' unless defined(&XmTOP_SHADOW);
	eval 'sub XmBOTTOM_SHADOW () {( (1<<3));}' unless defined(&XmBOTTOM_SHADOW);
	eval 'sub XmSELECT () {( (1<<4));}' unless defined(&XmSELECT);
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&_XmDEBUG_XMSTRING)) {
	    if(defined(&_NO_PROTO)) {
	    } else {
	    }
	}
	eval 'sub XmTAB_ANY () {(( &XmNavigationType) 255);}' unless defined(&XmTAB_ANY);
	eval 'sub XmNONE_OR_BC () {(( &XmNavigationType) 254);}' unless defined(&XmNONE_OR_BC);
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&_NO_PROTO)) {
	} else {
	}
	if(defined(&__cplusplus)) {
	}
	if(defined(&XM_1_1_BC)) {
	    eval 'sub XmVPANED_BIT () { &XmPANED_WINDOW_BIT;}' unless defined(&XmVPANED_BIT);
	    eval 'sub LOOK_AT_SCREEN () {(1<<0);}' unless defined(&LOOK_AT_SCREEN);
	    eval 'sub LOOK_AT_CMAP () {(1<<1);}' unless defined(&LOOK_AT_CMAP);
	    eval 'sub LOOK_AT_BACKGROUND () {(1<<2);}' unless defined(&LOOK_AT_BACKGROUND);
	    eval 'sub LOOK_AT_FOREGROUND () {(1<<3);}' unless defined(&LOOK_AT_FOREGROUND);
	    eval 'sub LOOK_AT_TOP_SHADOW () {(1<<4);}' unless defined(&LOOK_AT_TOP_SHADOW);
	    eval 'sub LOOK_AT_BOTTOM_SHADOW () {(1<<5);}' unless defined(&LOOK_AT_BOTTOM_SHADOW);
	    eval 'sub LOOK_AT_SELECT () {(1<<6);}' unless defined(&LOOK_AT_SELECT);
	    eval 'sub XmStrlen {
	        my($s) = @_;
    		eval q((($s) ?  &strlen($s) : 0));
	    }' unless defined(&XmStrlen);
	    eval 'sub DEFAULT_INDICATOR_DIM () {9;}' unless defined(&DEFAULT_INDICATOR_DIM);
	    unless(defined(&MAX)) {
		eval 'sub MAX {
		    my($x,$y) = @_;
    		    eval q((($x) > ($y) ? ($x) : ($y)));
		}' unless defined(&MAX);
	    }
	    eval 'sub RX {
	        my($r) = @_;
    		eval q(((( &RectObj) $r)-> ($rectangle->{x})));
	    }' unless defined(&RX);
	    eval 'sub RY {
	        my($r) = @_;
    		eval q(((( &RectObj) $r)-> ($rectangle->{y})));
	    }' unless defined(&RY);
	    eval 'sub RWidth {
	        my($r) = @_;
    		eval q(((( &RectObj) $r)-> ($rectangle->{width})));
	    }' unless defined(&RWidth);
	    eval 'sub RHeight {
	        my($r) = @_;
    		eval q(((( &RectObj) $r)-> ($rectangle->{height})));
	    }' unless defined(&RHeight);
	    eval 'sub RBorder {
	        my($r) = @_;
    		eval q(((( &RectObj) $r)-> ($rectangle->{border_width})));
	    }' unless defined(&RBorder);
	    eval 'sub GMode {
	        my($g) = @_;
    		eval q((($g)-> &request_mode));
	    }' unless defined(&GMode);
	    eval 'sub IsX {
	        my($g) = @_;
    		eval q(( &GMode ($g) &  &CWX));
	    }' unless defined(&IsX);
	    eval 'sub IsY {
	        my($g) = @_;
    		eval q(( &GMode ($g) &  &CWY));
	    }' unless defined(&IsY);
	    eval 'sub IsWidth {
	        my($g) = @_;
    		eval q(( &GMode ($g) &  &CWWidth));
	    }' unless defined(&IsWidth);
	    eval 'sub IsHeight {
	        my($g) = @_;
    		eval q(( &GMode ($g) &  &CWHeight));
	    }' unless defined(&IsHeight);
	    eval 'sub IsBorder {
	        my($g) = @_;
    		eval q(( &GMode ($g) &  &CWBorderWidth));
	    }' unless defined(&IsBorder);
	    eval 'sub IsWidthHeight {
	        my($g) = @_;
    		eval q((( &GMode ($g) &  &CWWidth) || ( &GMode ($g) &  &CWHeight)));
	    }' unless defined(&IsWidthHeight);
	    eval 'sub IsQueryOnly {
	        my($g) = @_;
    		eval q(( &GMode ($g) &  &XtCWQueryOnly));
	    }' unless defined(&IsQueryOnly);
	    eval 'sub MAXDIMENSION () {((1<< 31)-1);}' unless defined(&MAXDIMENSION);
	    eval 'sub Max {
	        my($x, $y) = @_;
    		eval q(((($x) > ($y)) ? ($x) : ($y)));
	    }' unless defined(&Max);
	    eval 'sub Min {
	        my($x, $y) = @_;
    		eval q(((($x) < ($y)) ? ($x) : ($y)));
	    }' unless defined(&Min);
	    eval 'sub AssignMax {
	        my($x, $y) = @_;
    		eval q( &if (($y) > ($x)) $x = ($y));
	    }' unless defined(&AssignMax);
	    eval 'sub AssignMin {
	        my($x, $y) = @_;
    		eval q( &if (($y) < ($x)) $x = ($y));
	    }' unless defined(&AssignMin);
	    eval 'sub DIALOG_SUFFIX () {"_popup";}' unless defined(&DIALOG_SUFFIX);
	    eval 'sub DIALOG_SUFFIX_SIZE () {6;}' unless defined(&DIALOG_SUFFIX_SIZE);
	    eval 'sub XM_3D_ENHANCE_PIXEL () {2;}' unless defined(&XM_3D_ENHANCE_PIXEL);
	    eval 'sub XM_DEFAULT_TOP_MARGIN () {0;}' unless defined(&XM_DEFAULT_TOP_MARGIN);
	    eval 'sub XM_DEFAULT_BOTTOM_MARGIN () {0;}' unless defined(&XM_DEFAULT_BOTTOM_MARGIN);
	    unless(defined(&_XmNO_BC_INCL)) {
		require 'Xm/VendorSP.ph';
		require 'Xm/ManagerP.ph';
		require 'Xm/PrimitiveP.ph';
		require 'Xm/GadgetP.ph';
	    }
	}
	require 'Xm/BaseClassP.ph';
    }
}
1;
