require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XmosP_h)) {
    eval 'sub _XmosP_h () {1;}' unless defined(&_XmosP_h);
    unless(defined(&MOTIF12_HEADERS)) {
	require 'X11/Xfuncs.ph';
	unless(defined(&USER_VAR)) {
	    if(defined( &SYSV) || defined( &SVR4)) {
		eval 'sub USER_VAR () {"LOGNAME";}' unless defined(&USER_VAR);
	    } else {
		eval 'sub USER_VAR () {"USER";}' unless defined(&USER_VAR);
	    }
	}
	if(defined(&NO_MEMMOVE)) {
	    if(defined(&bcopy)) {
		undef(&bcopy) if defined(&bcopy);
	    }
	    eval 'sub memmove {
	        my( $p1, $p2, $p3 ) = @_;
    		eval q( &bcopy( $p2, $p1, $p3 ));
	    }' unless defined(&memmove);
	}
	unless(defined(&X_NOT_STDC_ENV)) {
	    require 'stdlib.ph';
	}
	if(defined( &sun)) {
	    undef(&mblen) if defined(&mblen);
	    eval 'sub mblen {
	        my($ptr, $size) = @_;
    		eval q((($ptr  && *($ptr) == ord(\'\\\\0\')) ? 0:  &mbtowc(( &wchar_t *)0, ($ptr), ($size))));
	    }' unless defined(&mblen);
	}
	require 'limits.ph';
	unless(defined(&INT_MAX)) {
	    eval 'sub INT_MAX () {2147483647;}' unless defined(&INT_MAX);
	}
	unless(defined(&LONG_MAX)) {
	    eval 'sub LONG_MAX () {2147483647;}' unless defined(&LONG_MAX);
	}
	if(defined(&BOGUS_MB_MAX)) {
	    undef(&MB_LEN_MAX) if defined(&MB_LEN_MAX);
	    eval 'sub MB_LEN_MAX () {1;}' unless defined(&MB_LEN_MAX);
	    undef(&MB_CUR_MAX) if defined(&MB_CUR_MAX);
	    eval 'sub MB_CUR_MAX () {1;}' unless defined(&MB_CUR_MAX);
	}
	if(defined(&INCLUDE_ALLOCA_H)) {
	    require 'alloca.ph';
	}
	if(defined(&CRAY)) {
	    eval 'sub WORD64 () {1;}' unless defined(&WORD64);
	}
	unless(defined(&NO_ALLOCA)) {
	    if(defined( &__HIGHC__)) {
		if((defined(&HCVERSION) ? &HCVERSION : 0) < 21003) {
		    eval 'sub ALLOCATE_LOCAL {
		        my($size) = @_;
    			eval q( &alloca($size));
		    }' unless defined(&ALLOCATE_LOCAL);
		} else {
		    eval 'sub ALLOCATE_LOCAL {
		        my($size) = @_;
    			eval q( &_Alloca($size));
		    }' unless defined(&ALLOCATE_LOCAL);
		}
		eval 'sub DEALLOCATE_LOCAL {
		    my($ptr) = @_;
    		    eval q();
		}' unless defined(&DEALLOCATE_LOCAL);
	    }
	    if(defined(&__GNUC__)) {
		unless(defined(&alloca)) {
		    eval 'sub alloca () { &__builtin_alloca;}' unless defined(&alloca);
		}
		eval 'sub ALLOCATE_LOCAL {
		    my($size) = @_;
    		    eval q( &alloca($size));
		}' unless defined(&ALLOCATE_LOCAL);
		eval 'sub DEALLOCATE_LOCAL {
		    my($ptr) = @_;
    		    eval q();
		}' unless defined(&DEALLOCATE_LOCAL);
	    } else {
		if(defined( &vax) || defined( &sun) || defined( &apollo) || defined( &stellar)) {
		    eval 'sub ALLOCATE_LOCAL {
		        my($size) = @_;
    			eval q( &alloca($size));
		    }' unless defined(&ALLOCATE_LOCAL);
		    eval 'sub DEALLOCATE_LOCAL {
		        my($ptr) = @_;
    			eval q();
		    }' unless defined(&DEALLOCATE_LOCAL);
		}
	    }
	}
	unless(defined(&ALLOCATE_LOCAL)) {
	    eval 'sub ALLOCATE_LOCAL {
	        my($size) = @_;
    		eval q( &XtMalloc($size));
	    }' unless defined(&ALLOCATE_LOCAL);
	    eval 'sub DEALLOCATE_LOCAL {
	        my($ptr) = @_;
    		eval q( &XtFree($ptr));
	    }' unless defined(&DEALLOCATE_LOCAL);
	}
	require 'Xm/XmP.ph';
	if(!defined( &CRAY)  && !defined( &__alpha)) {
	    eval 'sub MrmShortPtr () {1;}' unless defined(&MrmShortPtr);
	}
	if(defined(&__cplusplus)) {
	}
	eval 'sub MATCH_CHAR () {ord(\'P\');}' unless defined(&MATCH_CHAR);
	eval 'sub XMBINDDIR () {"XMBINDDIR";}' unless defined(&XMBINDDIR);
	unless(defined(&XMBINDDIR_FALLBACK)) {
	    eval 'sub XMBINDDIR_FALLBACK () {"/usr/lib/Xm/bindings";}' unless defined(&XMBINDDIR_FALLBACK);
	}
	eval 'sub XMBINDFILE () {"xmbind.alias";}' unless defined(&XMBINDFILE);
	eval 'sub MOTIFBIND () {".motifbind";}' unless defined(&MOTIFBIND);
	eval("sub XmOS_METHOD_NULL () { 0; }") unless defined(&XmOS_METHOD_NULL);
	eval("sub XmOS_METHOD_DEFAULTED () { 1; }") unless defined(&XmOS_METHOD_DEFAULTED);
	eval("sub XmOS_METHOD_REPLACED () { 2; }") unless defined(&XmOS_METHOD_REPLACED);
	if(defined(&__cplusplus)) {
	}
    } else {
	if(defined(&NO_MEMMOVE)) {
	    eval 'sub memmove {
	        my( $p1, $p2, $p3 ) = @_;
    		eval q( &bcopy( $p2, $p1, $p3 ));
	    }' unless defined(&memmove);
	}
	unless(defined(&X_NOT_STDC_ENV)) {
	    require 'stdlib.ph';
	}
	require 'limits.ph';
	if(defined(&BOGUS_MB_MAX)) {
	    undef(&MB_LEN_MAX) if defined(&MB_LEN_MAX);
	    eval 'sub MB_LEN_MAX () {1;}' unless defined(&MB_LEN_MAX);
	    undef(&MB_CUR_MAX) if defined(&MB_CUR_MAX);
	    eval 'sub MB_CUR_MAX () {1;}' unless defined(&MB_CUR_MAX);
	}
	if(defined(&INCLUDE_ALLOCA_H)) {
	    require 'alloca.ph';
	}
	if(defined(&CRAY)) {
	    eval 'sub WORD64 () {1;}' unless defined(&WORD64);
	}
	unless(defined(&NO_ALLOCA)) {
	    if(defined( &__HIGHC__)) {
		if((defined(&HCVERSION) ? &HCVERSION : 0) < 21003) {
		    eval 'sub ALLOCATE_LOCAL {
		        my($size) = @_;
    			eval q( &alloca($size));
		    }' unless defined(&ALLOCATE_LOCAL);
		} else {
		    eval 'sub ALLOCATE_LOCAL {
		        my($size) = @_;
    			eval q( &_Alloca($size));
		    }' unless defined(&ALLOCATE_LOCAL);
		}
		eval 'sub DEALLOCATE_LOCAL {
		    my($ptr) = @_;
    		    eval q();
		}' unless defined(&DEALLOCATE_LOCAL);
	    }
	    if(defined(&__GNUC__)) {
		unless(defined(&alloca)) {
		    eval 'sub alloca () { &__builtin_alloca;}' unless defined(&alloca);
		}
		eval 'sub ALLOCATE_LOCAL {
		    my($size) = @_;
    		    eval q( &alloca($size));
		}' unless defined(&ALLOCATE_LOCAL);
		eval 'sub DEALLOCATE_LOCAL {
		    my($ptr) = @_;
    		    eval q();
		}' unless defined(&DEALLOCATE_LOCAL);
	    } else {
		if(defined( &vax) || defined( &sun) || defined( &apollo) || defined( &stellar)) {
		    eval 'sub ALLOCATE_LOCAL {
		        my($size) = @_;
    			eval q( &alloca($size));
		    }' unless defined(&ALLOCATE_LOCAL);
		    eval 'sub DEALLOCATE_LOCAL {
		        my($ptr) = @_;
    			eval q();
		    }' unless defined(&DEALLOCATE_LOCAL);
		}
	    }
	}
	unless(defined(&ALLOCATE_LOCAL)) {
	    eval 'sub ALLOCATE_LOCAL {
	        my($size) = @_;
    		eval q( &XtMalloc($size));
	    }' unless defined(&ALLOCATE_LOCAL);
	    eval 'sub DEALLOCATE_LOCAL {
	        my($ptr) = @_;
    		eval q( &XtFree($ptr));
	    }' unless defined(&DEALLOCATE_LOCAL);
	}
	require 'Xm/XmP.ph';
	if(defined(&__cplusplus)) {
	}
	eval 'sub MATCH_CHAR () {ord(\'P\');}' unless defined(&MATCH_CHAR);
	eval 'sub XMBINDDIR () {"XMBINDDIR";}' unless defined(&XMBINDDIR);
	unless(defined(&XMBINDDIR_FALLBACK)) {
	    eval 'sub XMBINDDIR_FALLBACK () {"/usr/lib/Xm/bindings";}' unless defined(&XMBINDDIR_FALLBACK);
	}
	eval 'sub XMBINDFILE () {"xmbind.alias";}' unless defined(&XMBINDFILE);
	eval 'sub MOTIFBIND () {".motifbind";}' unless defined(&MOTIFBIND);
	eval 'sub _XmOSProcessUnmappedCharsetAndText {
	    my($tag, $ctext, $sep, $outc, $outl, $prev) = @_;
    	    eval q( &processCharsetAndText( &XmFONTLIST_DEFAULT_TAG, $ctext, $sep, $outc, $outl, $prev));
	}' unless defined(&_XmOSProcessUnmappedCharsetAndText);
	if(defined(&_NO_PROTO)) {
	} else {
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	    if((defined(&NeedWidePrototypes) ? &NeedWidePrototypes : 0)) {
	    } else {
	    }
	}
	if(defined(&__cplusplus)) {
	}
    }
}
1;
