require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_BSM_AUDIT_H)) {
    eval 'sub _BSM_AUDIT_H () {1;}' unless defined(&_BSM_AUDIT_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/shm.ph';
    require 'sys/sem.ph';
    require 'sys/msg.ph';
    eval 'sub AUC_UNSET () {0;}' unless defined(&AUC_UNSET);
    eval 'sub AUC_AUDITING () {1;}' unless defined(&AUC_AUDITING);
    eval 'sub AUC_NOAUDIT () {2;}' unless defined(&AUC_NOAUDIT);
    eval 'sub AUC_DISABLED () {-1;}' unless defined(&AUC_DISABLED);
    eval 'sub AU_NOAUDITID () {-2;}' unless defined(&AU_NOAUDITID);
    eval 'sub AU_NULL () {0x;}' unless defined(&AU_NULL);
    eval 'sub AU_FREAD () {0x1;}' unless defined(&AU_FREAD);
    eval 'sub AU_FWRITE () {0x2;}' unless defined(&AU_FWRITE);
    eval 'sub AU_FACCESS () {0x4;}' unless defined(&AU_FACCESS);
    eval 'sub AU_FMODIFY () {0x8;}' unless defined(&AU_FMODIFY);
    eval 'sub AU_FCREATE () {0x10;}' unless defined(&AU_FCREATE);
    eval 'sub AU_FDELETE () {0x20;}' unless defined(&AU_FDELETE);
    eval 'sub AU_CLOSE () {0x40;}' unless defined(&AU_CLOSE);
    eval 'sub AU_PROCESS () {0x80;}' unless defined(&AU_PROCESS);
    eval 'sub AU_NET () {0x100;}' unless defined(&AU_NET);
    eval 'sub AU_IPC () {0x200;}' unless defined(&AU_IPC);
    eval 'sub AU_NONAT () {0x400;}' unless defined(&AU_NONAT);
    eval 'sub AU_ADMIN () {0x800;}' unless defined(&AU_ADMIN);
    eval 'sub AU_LOGIN () {0x1000;}' unless defined(&AU_LOGIN);
    eval 'sub AU_TFM () {0x2000;}' unless defined(&AU_TFM);
    eval 'sub AU_APPL () {0x4000;}' unless defined(&AU_APPL);
    eval 'sub AU_SETL () {0x8000;}' unless defined(&AU_SETL);
    eval 'sub AU_IFLOAT () {0x10000;}' unless defined(&AU_IFLOAT);
    eval 'sub AU_PRIV () {0x20000;}' unless defined(&AU_PRIV);
    eval 'sub AU_MAC_RW () {0x40000;}' unless defined(&AU_MAC_RW);
    eval 'sub AU_XCONN () {0x80000;}' unless defined(&AU_XCONN);
    eval 'sub AU_XCREATE () {0x100000;}' unless defined(&AU_XCREATE);
    eval 'sub AU_XDELETE () {0x200000;}' unless defined(&AU_XDELETE);
    eval 'sub AU_XIFLOAT () {0x400000;}' unless defined(&AU_XIFLOAT);
    eval 'sub AU_XPRIVS () {0x800000;}' unless defined(&AU_XPRIVS);
    eval 'sub AU_XPRIVF () {0x1000000;}' unless defined(&AU_XPRIVF);
    eval 'sub AU_XMOVE () {0x2000000;}' unless defined(&AU_XMOVE);
    eval 'sub AU_XDACF () {0x4000000;}' unless defined(&AU_XDACF);
    eval 'sub AU_XMACF () {0x8000000;}' unless defined(&AU_XMACF);
    eval 'sub AU_XSECATTR () {0x10000000;}' unless defined(&AU_XSECATTR);
    eval 'sub AU_IOCTL () {0x20000000;}' unless defined(&AU_IOCTL);
    eval 'sub AU_EXEC () {0x40000000;}' unless defined(&AU_EXEC);
    eval 'sub AU_OTHER () {0x80000000;}' unless defined(&AU_OTHER);
    eval 'sub AU_ALL () {0xffffffff;}' unless defined(&AU_ALL);
    eval 'sub PAD_MACUSE () {0x1;}' unless defined(&PAD_MACUSE);
    eval 'sub PAD_MACREAD () {0x2;}' unless defined(&PAD_MACREAD);
    eval 'sub PAD_MACWRITE () {0x4;}' unless defined(&PAD_MACWRITE);
    eval 'sub PAD_MACSEARCH () {0x8;}' unless defined(&PAD_MACSEARCH);
    eval 'sub PAD_MACKILL () {0x10;}' unless defined(&PAD_MACKILL);
    eval 'sub PAD_MACTRACE () {0x20;}' unless defined(&PAD_MACTRACE);
    eval 'sub PAD_MACIOCTL () {0x40;}' unless defined(&PAD_MACIOCTL);
    eval 'sub PAD_MACMASK () {0x7e;}' unless defined(&PAD_MACMASK);
    eval 'sub PAD_SPRIVUSE () {0x80;}' unless defined(&PAD_SPRIVUSE);
    eval 'sub PAD_FPRIVUSE () {0x100;}' unless defined(&PAD_FPRIVUSE);
    eval 'sub PAD_NONATTR () {0x4000;}' unless defined(&PAD_NONATTR);
    eval 'sub PAD_FAILURE () {0x8000;}' unless defined(&PAD_FAILURE);
    eval 'sub as_success () { &am_success;}' unless defined(&as_success);
    eval 'sub as_failure () { &am_failure;}' unless defined(&as_failure);
    if(defined( &_SYSCALL32)) {
    }
    if(defined( &_SYSCALL32)) {
    }
    eval 'sub AU_IPv4 () {4;}' unless defined(&AU_IPv4);
    eval 'sub AU_IPv6 () {16;}' unless defined(&AU_IPv6);
    eval 'sub ai_state () { &ai_mask;;}' unless defined(&ai_state);
    eval 'sub BSM_GETAUID () {19;}' unless defined(&BSM_GETAUID);
    eval 'sub BSM_SETAUID () {20;}' unless defined(&BSM_SETAUID);
    eval 'sub BSM_GETAUDIT () {21;}' unless defined(&BSM_GETAUDIT);
    eval 'sub BSM_SETAUDIT () {22;}' unless defined(&BSM_SETAUDIT);
    eval 'sub BSM_GETUSERAUDIT () {23;}' unless defined(&BSM_GETUSERAUDIT);
    eval 'sub BSM_SETUSERAUDIT () {24;}' unless defined(&BSM_SETUSERAUDIT);
    eval 'sub BSM_AUDIT () {25;}' unless defined(&BSM_AUDIT);
    eval 'sub BSM_AUDITUSER () {26;}' unless defined(&BSM_AUDITUSER);
    eval 'sub BSM_AUDITSVC () {27;}' unless defined(&BSM_AUDITSVC);
    eval 'sub BSM_AUDITON () {28;}' unless defined(&BSM_AUDITON);
    eval 'sub BSM_AUDITCTL () {29;}' unless defined(&BSM_AUDITCTL);
    eval 'sub BSM_GETKERNSTATE () {30;}' unless defined(&BSM_GETKERNSTATE);
    eval 'sub BSM_SETKERNSTATE () {31;}' unless defined(&BSM_SETKERNSTATE);
    eval 'sub BSM_GETPORTAUDIT () {32;}' unless defined(&BSM_GETPORTAUDIT);
    eval 'sub BSM_REVOKE () {33;}' unless defined(&BSM_REVOKE);
    eval 'sub BSM_AUDITSTAT () {34;}' unless defined(&BSM_AUDITSTAT);
    eval 'sub BSM_GETAUDIT_ADDR () {35;}' unless defined(&BSM_GETAUDIT_ADDR);
    eval 'sub BSM_SETAUDIT_ADDR () {36;}' unless defined(&BSM_SETAUDIT_ADDR);
    eval 'sub A_GETPOLICY () {2;}' unless defined(&A_GETPOLICY);
    eval 'sub A_SETPOLICY () {3;}' unless defined(&A_SETPOLICY);
    eval 'sub A_GETKMASK () {4;}' unless defined(&A_GETKMASK);
    eval 'sub A_SETKMASK () {5;}' unless defined(&A_SETKMASK);
    eval 'sub A_GETQCTRL () {6;}' unless defined(&A_GETQCTRL);
    eval 'sub A_SETQCTRL () {7;}' unless defined(&A_SETQCTRL);
    eval 'sub A_GETCWD () {8;}' unless defined(&A_GETCWD);
    eval 'sub A_GETCAR () {9;}' unless defined(&A_GETCAR);
    eval 'sub A_GETSTAT () {12;}' unless defined(&A_GETSTAT);
    eval 'sub A_SETSTAT () {13;}' unless defined(&A_SETSTAT);
    eval 'sub A_SETUMASK () {14;}' unless defined(&A_SETUMASK);
    eval 'sub A_SETSMASK () {15;}' unless defined(&A_SETSMASK);
    eval 'sub A_GETCOND () {20;}' unless defined(&A_GETCOND);
    eval 'sub A_SETCOND () {21;}' unless defined(&A_SETCOND);
    eval 'sub A_GETCLASS () {22;}' unless defined(&A_GETCLASS);
    eval 'sub A_SETCLASS () {23;}' unless defined(&A_SETCLASS);
    eval 'sub A_GETPINFO () {24;}' unless defined(&A_GETPINFO);
    eval 'sub A_SETPMASK () {25;}' unless defined(&A_SETPMASK);
    eval 'sub A_SETFSIZE () {26;}' unless defined(&A_SETFSIZE);
    eval 'sub A_GETFSIZE () {27;}' unless defined(&A_GETFSIZE);
    eval 'sub A_GETPINFO_ADDR () {28;}' unless defined(&A_GETPINFO_ADDR);
    eval 'sub A_GETKAUDIT () {29;}' unless defined(&A_GETKAUDIT);
    eval 'sub A_SETKAUDIT () {30;}' unless defined(&A_SETKAUDIT);
    eval 'sub AUDIT_CNT () {0x1;}' unless defined(&AUDIT_CNT);
    eval 'sub AUDIT_AHLT () {0x2;}' unless defined(&AUDIT_AHLT);
    eval 'sub AUDIT_ARGV () {0x4;}' unless defined(&AUDIT_ARGV);
    eval 'sub AUDIT_ARGE () {0x8;}' unless defined(&AUDIT_ARGE);
    eval 'sub AUDIT_PASSWD () {0x10;}' unless defined(&AUDIT_PASSWD);
    eval 'sub AUDIT_SEQ () {0x20;}' unless defined(&AUDIT_SEQ);
    eval 'sub AUDIT_WINDATA () {0x40;}' unless defined(&AUDIT_WINDATA);
    eval 'sub AUDIT_USER () {0x80;}' unless defined(&AUDIT_USER);
    eval 'sub AUDIT_GROUP () {0x100;}' unless defined(&AUDIT_GROUP);
    eval 'sub AUDIT_TRAIL () {0x200;}' unless defined(&AUDIT_TRAIL);
    eval 'sub AUDIT_PATH () {0x400;}' unless defined(&AUDIT_PATH);
    if(defined( &_SYSCALL32)) {
    }
    eval 'sub AQ_HIWATER () {100;}' unless defined(&AQ_HIWATER);
    eval 'sub AQ_MAXHIGH () {10000;}' unless defined(&AQ_MAXHIGH);
    eval 'sub AQ_LOWATER () {10;}' unless defined(&AQ_LOWATER);
    eval 'sub AQ_BUFSZ () {1024;}' unless defined(&AQ_BUFSZ);
    eval 'sub AQ_MAXBUFSZ () {1048576;}' unless defined(&AQ_MAXBUFSZ);
    eval 'sub AQ_DELAY () {20;}' unless defined(&AQ_DELAY);
    eval 'sub AQ_MAXDELAY () {20000;}' unless defined(&AQ_MAXDELAY);
    if(defined( &_SYSCALL32)) {
    }
    if(defined( &_SYSCALL32)) {
    }
    if(defined( &_SYSCALL32)) {
    }
    if(defined( &_SYSCALL32)) {
    }
    eval 'sub AS_INC {
        my($a, $b) = @_;
	    eval q({ &mutex_enter( &au_stat_lock);  &audit_statistics. $a += $b;  &mutex_exit( &au_stat_lock); });
    }' unless defined(&AS_INC);
    eval 'sub AS_DEC {
        my($a, $b) = @_;
	    eval q({ &mutex_enter( &au_stat_lock);  &audit_statistics. $a -= $b;  &mutex_exit( &au_stat_lock); });
    }' unless defined(&AS_DEC);
    eval 'sub AT_IPC_MSG () {(1);}' unless defined(&AT_IPC_MSG);
    eval 'sub AT_IPC_SEM () {(2);}' unless defined(&AT_IPC_SEM);
    eval 'sub AT_IPC_SHM () {(3);}' unless defined(&AT_IPC_SHM);
    if(defined( &_KERNEL)) {
	if(defined(&__cplusplus)) {
	}
	require 'sys/types.ph';
	require 'sys/model.ph';
	require 'sys/proc.ph';
	require 'sys/stream.ph';
	require 'sys/stropts.ph';
	require 'sys/file.ph';
	require 'sys/pathname.ph';
	require 'sys/vnode.ph';
	require 'sys/systm.ph';
	require 'netinet/in.ph';
	require 'c2/audit_kernel.ph';
	if(defined(&__cplusplus)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
