require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_BSM_AUDIT_KERNEL_H)) {
    eval 'sub _BSM_AUDIT_KERNEL_H () {1;}' unless defined(&_BSM_AUDIT_KERNEL_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub S2E_SP () {0x1;}' unless defined(&S2E_SP);
    eval 'sub S2E_MLD () {0x2;}' unless defined(&S2E_MLD);
    eval 'sub S2E_NPT () {0x4;}' unless defined(&S2E_NPT);
    eval 'sub PAD_SAVPATH () {0x1;}' unless defined(&PAD_SAVPATH);
    eval 'sub PAD_MLD () {0x2;}' unless defined(&PAD_MLD);
    eval 'sub PAD_NOPATH () {0x4;}' unless defined(&PAD_NOPATH);
    eval 'sub PAD_ABSPATH () {0x8;}' unless defined(&PAD_ABSPATH);
    eval 'sub PAD_NOATTRB () {0x10;}' unless defined(&PAD_NOATTRB);
    eval 'sub PAD_SUSEROK () {0x20;}' unless defined(&PAD_SUSEROK);
    eval 'sub PAD_SUSERNO () {0x40;}' unless defined(&PAD_SUSERNO);
    eval 'sub PAD_LFLOAT () {0x80;}' unless defined(&PAD_LFLOAT);
    eval 'sub PAD_NOAUDIT () {0x100;}' unless defined(&PAD_NOAUDIT);
    eval 'sub PAD_PATHFND () {0x200;}' unless defined(&PAD_PATHFND);
    eval 'sub PAD_SPRIV () {0x400;}' unless defined(&PAD_SPRIV);
    eval 'sub PAD_FPRIV () {0x800;}' unless defined(&PAD_FPRIV);
    eval 'sub PAD_SMAC () {0x1000;}' unless defined(&PAD_SMAC);
    eval 'sub PAD_FMAC () {0x2000;}' unless defined(&PAD_FMAC);
    eval 'sub PAD_AUDITME () {0x4000;}' unless defined(&PAD_AUDITME);
    eval 'sub PAD_IFLOAT () {0x8000;}' unless defined(&PAD_IFLOAT);
    eval 'sub PAD_TRUE_CREATE () {0x10000;}' unless defined(&PAD_TRUE_CREATE);
    eval 'sub PAD_CORE () {0x20000;}' unless defined(&PAD_CORE);
    eval 'sub FAD_READ () {0x1;}' unless defined(&FAD_READ);
    eval 'sub FAD_WRITE () {0x2;}' unless defined(&FAD_WRITE);
    eval 'sub P2A {
        my($p) = @_;
	    eval q(( ($p->{p_audit_data})));
    }' unless defined(&P2A);
    eval 'sub T2A {
        my($t) = @_;
	    eval q(( ($t->{t_audit_data})));
    }' unless defined(&T2A);
    eval 'sub U2A {
        my($u) = @_;
	    eval q(( ($c$urthread->{t_audit_data})));
    }' unless defined(&U2A);
    eval 'sub F2A {
        my($f) = @_;
	    eval q(( ($f->{f_audit_data})));
    }' unless defined(&F2A);
    eval 'sub u_ad () {(( &U2A( &u))-> &tad_ad);}' unless defined(&u_ad);
    eval 'sub ad_ctrl () {(( &U2A( &u))-> &tad_ctrl);}' unless defined(&ad_ctrl);
    eval 'sub ad_flag () {(( &U2A( &u))-> &tad_flag);}' unless defined(&ad_flag);
    eval 'sub AU_BUFSIZE () {128;}' unless defined(&AU_BUFSIZE);
    eval 'sub AU_PAGE () {32*  &AU_BUFSIZE;}' unless defined(&AU_PAGE);
    eval 'sub ONPAGE () {32;}' unless defined(&ONPAGE);
    eval 'sub AU_MAXMEM () {(2048* 1024);}' unless defined(&AU_MAXMEM);
    eval 'sub AU_CNTL () {32* $sizeof{ &au_buff_t};}' unless defined(&AU_CNTL);
    eval 'sub THREAD_HIT () { ($au_tlist_stat->{called})++;  ($au_tlist_stat->{hit})++;  ($au_tlist_stat->{size})--;;}' unless defined(&THREAD_HIT);
    eval 'sub THREAD_MISS () { ($au_tlist_stat->{called})++;  ($au_tlist_stat->{miss})++;;}' unless defined(&THREAD_MISS);
    eval 'sub THREAD_FREE () { ($au_tlist_stat->{free})++;;}' unless defined(&THREAD_FREE);
    eval 'sub PROC_HIT () { ($au_plist_stat->{called})++;  ($au_plist_stat->{hit})++;  ($au_plist_stat->{size})--;;}' unless defined(&PROC_HIT);
    eval 'sub PROC_MISS () { ($au_plist_stat->{called})++;  ($au_plist_stat->{miss})++;;}' unless defined(&PROC_MISS);
    eval 'sub PROC_FREE () { ($au_plist_stat->{free})++;;}' unless defined(&PROC_FREE);
    eval 'sub FILE_HIT () { ($au_flist_stat->{called})++;  ($au_flist_stat->{hit})++;  ($au_flist_stat->{size})--;;}' unless defined(&FILE_HIT);
    eval 'sub FILE_MISS () { ($au_flist_stat->{called})++;  ($au_flist_stat->{miss})++;;}' unless defined(&FILE_MISS);
    eval 'sub FILE_FREE () { ($au_flist_stat->{free})++;;}' unless defined(&FILE_FREE);
    eval 'sub QUEUE_HIT () { ($au_mem_stat->{called})++;  ($au_mem_stat->{hit})++;  ($au_mem_stat->{size})--;;}' unless defined(&QUEUE_HIT);
    eval 'sub QUEUE_MISS () { ($au_mem_stat->{called})++;  ($au_mem_stat->{miss})++;;}' unless defined(&QUEUE_MISS);
    eval 'sub QUEUE_FREE () { ($au_mem_stat->{size})++;  ($au_mem_stat->{free})++;;}' unless defined(&QUEUE_FREE);
    eval 'sub TLIST_SIZE () {30;;}' unless defined(&TLIST_SIZE);
    eval 'sub FLIST_SIZE () {30;;}' unless defined(&FLIST_SIZE);
    eval 'sub PLIST_SIZE () {30;;}' unless defined(&PLIST_SIZE);
    if(defined( &C2_DEBUG) || defined( &lint)) {
	eval 'sub dprintf {
	    my($a, $f) = @_;
    	    eval q({ &if ( &audit_debug & $a)  &printf $f; });
	}' unless defined(&dprintf);
	eval 'sub call_debug {
	    my($a) = @_;
    	    eval q({ &if ( &c2_debug & $a)  &debug_enter( &NULL); });
	}' unless defined(&call_debug);
	eval 'sub ADDTRACE {
	    my($a, $b, $c, $d, $e, $f, $g) = @_;
    	    eval q( &addtrace($a, $b, $c, $d, $e, $f, $g));
	}' unless defined(&ADDTRACE);
    } else {
	eval 'sub dprintf {
	    my($a, $f) = @_;
    	    eval q();
	}' unless defined(&dprintf);
	eval 'sub call_debug {
	    my($a) = @_;
    	    eval q();
	}' unless defined(&call_debug);
	eval 'sub ADDTRACE {
	    my($a, $b, $c, $d, $e, $f, $g) = @_;
    	    eval q();
	}' unless defined(&ADDTRACE);
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub memtod {
        my($x, $t) = @_;
	    eval q((($t) ($x->{buf})));
    }' unless defined(&memtod);
    eval 'sub MT_FREE () {0;}' unless defined(&MT_FREE);
    eval 'sub MT_DATA () {1;}' unless defined(&MT_DATA);
    eval 'sub DONTWAIT () {0;}' unless defined(&DONTWAIT);
    eval 'sub WAIT () {1;}' unless defined(&WAIT);
    if(defined(&__cplusplus)) {
    }
}
1;
