require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_BSM_AUDIT_RECORD_H)) {
    eval 'sub _BSM_AUDIT_RECORD_H () {1;}' unless defined(&_BSM_AUDIT_RECORD_H);
    require 'sys/socket.ph';
    require 'sys/acl.ph';
    if(defined( &TSOL)  && defined( &_KERNEL)) {
	require 'sys/tsol/label.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&TSOL)) {
	eval 'sub TOKEN_VERSION () {4;}' unless defined(&TOKEN_VERSION);
    } else {
	eval 'sub TOKEN_VERSION () {2;}' unless defined(&TOKEN_VERSION);
    }
    eval 'sub AUT_INVALID () {(0x);}' unless defined(&AUT_INVALID);
    eval 'sub AUT_OTHER_FILE () {(0x11);}' unless defined(&AUT_OTHER_FILE);
    eval 'sub AUT_OTHER_FILE32 () { &AUT_OTHER_FILE;}' unless defined(&AUT_OTHER_FILE32);
    eval 'sub AUT_OHEADER () {(0x12);}' unless defined(&AUT_OHEADER);
    eval 'sub AUT_TRAILER () {(0x13);}' unless defined(&AUT_TRAILER);
    eval 'sub AUT_HEADER () {(0x14);}' unless defined(&AUT_HEADER);
    eval 'sub AUT_HEADER32 () { &AUT_HEADER;}' unless defined(&AUT_HEADER32);
    eval 'sub AUT_HEADER32_EX () {(0x15);}' unless defined(&AUT_HEADER32_EX);
    eval 'sub AUT_TRAILER_MAGIC () {(0xb105);}' unless defined(&AUT_TRAILER_MAGIC);
    eval 'sub AUT_DATA () {(0x21);}' unless defined(&AUT_DATA);
    eval 'sub AUT_IPC () {(0x22);}' unless defined(&AUT_IPC);
    eval 'sub AUT_PATH () {(0x23);}' unless defined(&AUT_PATH);
    eval 'sub AUT_SUBJECT () {(0x24);}' unless defined(&AUT_SUBJECT);
    eval 'sub AUT_SUBJECT32 () { &AUT_SUBJECT;}' unless defined(&AUT_SUBJECT32);
    eval 'sub AUT_SERVER () {(0x25);}' unless defined(&AUT_SERVER);
    eval 'sub AUT_SERVER32 () { &AUT_SERVER;}' unless defined(&AUT_SERVER32);
    eval 'sub AUT_PROCESS () {(0x26);}' unless defined(&AUT_PROCESS);
    eval 'sub AUT_PROCESS32 () { &AUT_PROCESS;}' unless defined(&AUT_PROCESS32);
    eval 'sub AUT_RETURN () {(0x27);}' unless defined(&AUT_RETURN);
    eval 'sub AUT_RETURN32 () { &AUT_RETURN;}' unless defined(&AUT_RETURN32);
    eval 'sub AUT_TEXT () {(0x28);}' unless defined(&AUT_TEXT);
    eval 'sub AUT_OPAQUE () {(0x29);}' unless defined(&AUT_OPAQUE);
    eval 'sub AUT_IN_ADDR () {(0x2a);}' unless defined(&AUT_IN_ADDR);
    eval 'sub AUT_IP () {(0x2b);}' unless defined(&AUT_IP);
    eval 'sub AUT_IPORT () {(0x2c);}' unless defined(&AUT_IPORT);
    eval 'sub AUT_ARG () {(0x2d);}' unless defined(&AUT_ARG);
    eval 'sub AUT_ARG32 () { &AUT_ARG;}' unless defined(&AUT_ARG32);
    eval 'sub AUT_SOCKET () {(0x2e);}' unless defined(&AUT_SOCKET);
    eval 'sub AUT_SEQ () {(0x2f);}' unless defined(&AUT_SEQ);
    eval 'sub AUT_ACL () {(0x30);}' unless defined(&AUT_ACL);
    eval 'sub AUT_ATTR () {(0x31);}' unless defined(&AUT_ATTR);
    eval 'sub AUT_IPC_PERM () {(0x32);}' unless defined(&AUT_IPC_PERM);
    eval 'sub AUT_LABEL () {(0x33);}' unless defined(&AUT_LABEL);
    eval 'sub AUT_GROUPS () {(0x34);}' unless defined(&AUT_GROUPS);
    eval 'sub AUT_ILABEL () {(0x35);}' unless defined(&AUT_ILABEL);
    eval 'sub AUT_SLABEL () {(0x36);}' unless defined(&AUT_SLABEL);
    eval 'sub AUT_CLEAR () {(0x37);}' unless defined(&AUT_CLEAR);
    eval 'sub AUT_PRIV () {(0x38);}' unless defined(&AUT_PRIV);
    eval 'sub AUT_UPRIV () {(0x39);}' unless defined(&AUT_UPRIV);
    eval 'sub AUT_LIAISON () {(0x3a);}' unless defined(&AUT_LIAISON);
    eval 'sub AUT_NEWGROUPS () {(0x3b);}' unless defined(&AUT_NEWGROUPS);
    eval 'sub AUT_EXEC_ARGS () {(0x3c);}' unless defined(&AUT_EXEC_ARGS);
    eval 'sub AUT_EXEC_ENV () {(0x3d);}' unless defined(&AUT_EXEC_ENV);
    eval 'sub AUT_ATTR32 () {(0x3e);}' unless defined(&AUT_ATTR32);
    eval 'sub AUT_XATOM () {(0x40);}' unless defined(&AUT_XATOM);
    eval 'sub AUT_XOBJ () {(0x41);}' unless defined(&AUT_XOBJ);
    eval 'sub AUT_XPROTO () {(0x42);}' unless defined(&AUT_XPROTO);
    eval 'sub AUT_XSELECT () {(0x43);}' unless defined(&AUT_XSELECT);
    if((defined(&TOKEN_VERSION) ? &TOKEN_VERSION : 0) != 3) {
	eval 'sub AUT_XCOLORMAP () {(0x44);}' unless defined(&AUT_XCOLORMAP);
	eval 'sub AUT_XCURSOR () {(0x45);}' unless defined(&AUT_XCURSOR);
	eval 'sub AUT_XFONT () {(0x46);}' unless defined(&AUT_XFONT);
	eval 'sub AUT_XGC () {(0x47);}' unless defined(&AUT_XGC);
	eval 'sub AUT_XPIXMAP () {(0x48);}' unless defined(&AUT_XPIXMAP);
	eval 'sub AUT_XPROPERTY () {(0x49);}' unless defined(&AUT_XPROPERTY);
	eval 'sub AUT_XWINDOW () {(0x4a);}' unless defined(&AUT_XWINDOW);
	eval 'sub AUT_XCLIENT () {(0x4b);}' unless defined(&AUT_XCLIENT);
    } else {
	eval 'sub AUT_XCOLORMAP () {(0x74);}' unless defined(&AUT_XCOLORMAP);
	eval 'sub AUT_XCURSOR () {(0x75);}' unless defined(&AUT_XCURSOR);
	eval 'sub AUT_XFONT () {(0x76);}' unless defined(&AUT_XFONT);
	eval 'sub AUT_XGC () {(0x77);}' unless defined(&AUT_XGC);
	eval 'sub AUT_XPIXMAP () {(0x78);}' unless defined(&AUT_XPIXMAP);
	eval 'sub AUT_XPROPERTY () {(0x79);}' unless defined(&AUT_XPROPERTY);
	eval 'sub AUT_XWINDOW () {(0x7a);}' unless defined(&AUT_XWINDOW);
	eval 'sub AUT_XCLIENT () {(0x7b);}' unless defined(&AUT_XCLIENT);
    }
    eval 'sub AUT_CMD () {(0x51);}' unless defined(&AUT_CMD);
    eval 'sub AUT_EXIT () {(0x52);}' unless defined(&AUT_EXIT);
    eval 'sub AUT_HOST () {(0x70);}' unless defined(&AUT_HOST);
    eval 'sub AUT_ARG64 () {(0x71);}' unless defined(&AUT_ARG64);
    eval 'sub AUT_RETURN64 () {(0x72);}' unless defined(&AUT_RETURN64);
    eval 'sub AUT_ATTR64 () {(0x73);}' unless defined(&AUT_ATTR64);
    eval 'sub AUT_HEADER64 () {(0x74);}' unless defined(&AUT_HEADER64);
    eval 'sub AUT_SUBJECT64 () {(0x75);}' unless defined(&AUT_SUBJECT64);
    eval 'sub AUT_SERVER64 () {(0x76);}' unless defined(&AUT_SERVER64);
    eval 'sub AUT_PROCESS64 () {(0x77);}' unless defined(&AUT_PROCESS64);
    eval 'sub AUT_OTHER_FILE64 () {(0x78);}' unless defined(&AUT_OTHER_FILE64);
    eval 'sub AUT_HEADER64_EX () {(0x79);}' unless defined(&AUT_HEADER64_EX);
    eval 'sub AUT_SUBJECT32_EX () {(0x7a);}' unless defined(&AUT_SUBJECT32_EX);
    eval 'sub AUT_PROCESS32_EX () {(0x7b);}' unless defined(&AUT_PROCESS32_EX);
    eval 'sub AUT_SUBJECT64_EX () {(0x7c);}' unless defined(&AUT_SUBJECT64_EX);
    eval 'sub AUT_PROCESS64_EX () {(0x7d);}' unless defined(&AUT_PROCESS64_EX);
    eval 'sub AUT_IN_ADDR_EX () {(0x7e);}' unless defined(&AUT_IN_ADDR_EX);
    eval 'sub AUT_SOCKET_EX () {(0x7f);}' unless defined(&AUT_SOCKET_EX);
    eval 'sub AUP_BINARY () {(0);}' unless defined(&AUP_BINARY);
    eval 'sub AUP_OCTAL () {(1);}' unless defined(&AUP_OCTAL);
    eval 'sub AUP_DECIMAL () {(2);}' unless defined(&AUP_DECIMAL);
    eval 'sub AUP_HEX () {(3);}' unless defined(&AUP_HEX);
    eval 'sub AUP_STRING () {(4);}' unless defined(&AUP_STRING);
    eval 'sub AUR_BYTE () {(0);}' unless defined(&AUR_BYTE);
    eval 'sub AUR_CHAR () {(0);}' unless defined(&AUR_CHAR);
    eval 'sub AUR_SHORT () {(1);}' unless defined(&AUR_SHORT);
    eval 'sub AUR_INT () {(2);}' unless defined(&AUR_INT);
    eval 'sub AUR_INT32 () {(2);}' unless defined(&AUR_INT32);
    eval 'sub AUR_INT64 () {(3);}' unless defined(&AUR_INT64);
    if(defined(&_KERNEL)) {
	require 'sys/param.ph';
	require 'sys/systm.ph';
	require 'sys/time.ph';
	require 'sys/types.ph';
	require 'sys/vnode.ph';
	require 'sys/mode.ph';
	require 'sys/user.ph';
	require 'sys/session.ph';
	require 'sys/ipc.ph';
	require 'netinet/in_systm.ph';
	require 'netinet/in.ph';
	require 'netinet/ip.ph';
	require 'sys/socket.ph';
	require 'net/route.ph';
	require 'netinet/in_pcb.ph';
	if(defined(&TSOL)) {
	}
    } else {
	require 'limits.ph';
	require 'sys/types.ph';
	require 'netinet/in_systm.ph';
	require 'netinet/in.ph';
	require 'netinet/ip.ph';
	require 'sys/ipc.ph';
	if(defined(&__STDC__)) {
	} else {
	}
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
