require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_FLOAT_H)) {
    eval 'sub _FLOAT_H () {1;}' unless defined(&_FLOAT_H);
    if(defined(&__cplusplus)) {
    }
    if(defined( &__sparc) || defined( &__ia64)) {
	if(defined( &__STDC__)) {
	} else {
	}
	eval 'sub FLT_ROUNDS () { &__flt_rounds();}' unless defined(&FLT_ROUNDS);
    } else {
	eval 'sub FLT_ROUNDS () { &__flt_rounds;}' unless defined(&FLT_ROUNDS);
	if(defined( &__STDC__)) {
	} else {
	}
    }
    eval 'sub FLT_RADIX () {2;}' unless defined(&FLT_RADIX);
    eval 'sub FLT_MANT_DIG () {24;}' unless defined(&FLT_MANT_DIG);
    eval 'sub FLT_EPSILON () {1.192092896E-07;}' unless defined(&FLT_EPSILON);
    eval 'sub FLT_DIG () {6;}' unless defined(&FLT_DIG);
    eval 'sub FLT_MIN_EXP () {(-125);}' unless defined(&FLT_MIN_EXP);
    eval 'sub FLT_MIN () {1.175494351E-38;}' unless defined(&FLT_MIN);
    eval 'sub FLT_MIN_10_EXP () {(-37);}' unless defined(&FLT_MIN_10_EXP);
    eval 'sub FLT_MAX_EXP () {(+128);}' unless defined(&FLT_MAX_EXP);
    eval 'sub FLT_MAX () {3.402823466E+38;}' unless defined(&FLT_MAX);
    eval 'sub FLT_MAX_10_EXP () {(+38);}' unless defined(&FLT_MAX_10_EXP);
    eval 'sub DBL_MANT_DIG () {53;}' unless defined(&DBL_MANT_DIG);
    eval 'sub DBL_EPSILON () {2.2204460492503131E-16;}' unless defined(&DBL_EPSILON);
    eval 'sub DBL_DIG () {15;}' unless defined(&DBL_DIG);
    eval 'sub DBL_MIN_EXP () {(-1021);}' unless defined(&DBL_MIN_EXP);
    eval 'sub DBL_MIN () {2.2250738585072014E-308;}' unless defined(&DBL_MIN);
    eval 'sub DBL_MIN_10_EXP () {(-307);}' unless defined(&DBL_MIN_10_EXP);
    eval 'sub DBL_MAX_EXP () {(+1024);}' unless defined(&DBL_MAX_EXP);
    eval 'sub DBL_MAX () {1.7976931348623157E+308;}' unless defined(&DBL_MAX);
    eval 'sub DBL_MAX_10_EXP () {(+308);}' unless defined(&DBL_MAX_10_EXP);
    if(defined( &__i386) || defined( &__ia64)) {
	eval 'sub LDBL_MANT_DIG () {64;}' unless defined(&LDBL_MANT_DIG);
	eval 'sub LDBL_EPSILON () {1.0842021724855044340075E-19;}' unless defined(&LDBL_EPSILON);
	eval 'sub LDBL_DIG () {18;}' unless defined(&LDBL_DIG);
	eval 'sub LDBL_MIN_EXP () {(-16381);}' unless defined(&LDBL_MIN_EXP);
	eval 'sub LDBL_MIN () {3.3621031431120935062627E-4932;}' unless defined(&LDBL_MIN);
	eval 'sub LDBL_MIN_10_EXP () {(-4931);}' unless defined(&LDBL_MIN_10_EXP);
	eval 'sub LDBL_MAX_EXP () {(+16384);}' unless defined(&LDBL_MAX_EXP);
	eval 'sub LDBL_MAX () {1.1897314953572317650213E+4932;}' unless defined(&LDBL_MAX);
	eval 'sub LDBL_MAX_10_EXP () {(+4932);}' unless defined(&LDBL_MAX_10_EXP);
    }
 elsif(defined( &__sparc)) {
	eval 'sub LDBL_MANT_DIG () {113;}' unless defined(&LDBL_MANT_DIG);
	eval 'sub LDBL_EPSILON () {1.925929944387235853055977942584927319E-34;}' unless defined(&LDBL_EPSILON);
	eval 'sub LDBL_DIG () {33;}' unless defined(&LDBL_DIG);
	eval 'sub LDBL_MIN_EXP () {(-16381);}' unless defined(&LDBL_MIN_EXP);
	eval 'sub LDBL_MIN () {3.362103143112093506262677817321752603E-4932;}' unless defined(&LDBL_MIN);
	eval 'sub LDBL_MIN_10_EXP () {(-4931);}' unless defined(&LDBL_MIN_10_EXP);
	eval 'sub LDBL_MAX_EXP () {(+16384);}' unless defined(&LDBL_MAX_EXP);
	eval 'sub LDBL_MAX () {1.189731495357231765085759326628007016E+4932;}' unless defined(&LDBL_MAX);
	eval 'sub LDBL_MAX_10_EXP () {(+4932);}' unless defined(&LDBL_MAX_10_EXP);
    } else {
	die("Unknown architecture!");
    }
    if(defined(&__cplusplus)) {
    }
}
1;
