require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_INET_IP_IRE_H)) {
    eval 'sub _INET_IP_IRE_H () {1;}' unless defined(&_INET_IP_IRE_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub IPV6_LL_PREFIXLEN () {10;}' unless defined(&IPV6_LL_PREFIXLEN);
    eval 'sub IP_FTABLE_HASH_SIZE () {32;}' unless defined(&IP_FTABLE_HASH_SIZE);
    eval 'sub IP_CACHE_TABLE_SIZE () {256;}' unless defined(&IP_CACHE_TABLE_SIZE);
    eval 'sub IP_MRTUN_TABLE_SIZE () {256;}' unless defined(&IP_MRTUN_TABLE_SIZE);
    eval 'sub IP_SRCIF_TABLE_SIZE () {256;}' unless defined(&IP_SRCIF_TABLE_SIZE);
    eval 'sub IP_MASK_TABLE_SIZE () {( &IP_ABITS + 1);}' unless defined(&IP_MASK_TABLE_SIZE);
    eval 'sub IP6_FTABLE_HASH_SIZE () {32;}' unless defined(&IP6_FTABLE_HASH_SIZE);
    eval 'sub IP6_CACHE_TABLE_SIZE () {256;}' unless defined(&IP6_CACHE_TABLE_SIZE);
    eval 'sub IP6_MASK_TABLE_SIZE () {( &IPV6_ABITS + 1);}' unless defined(&IP6_MASK_TABLE_SIZE);
    eval 'sub IRE_ADDR_HASH {
        my($addr, $table_size) = @_;
	    eval q(((($addr) ^ (($addr) >> 8) ^ (($addr) >> 16) ^ (($addr) >> 24)) & (($table_size) - 1)));
    }' unless defined(&IRE_ADDR_HASH);
    eval 'sub IRE_ADDR_HASH_V6 {
        my($addr, $table_size) = @_;
	    eval q(((($addr). $s6_addr32[3] ^ ((($addr). $s6_addr32[3] ^ ($addr). $s6_addr32[2]) >> 12)) & (($table_size) - 1)));
    }' unless defined(&IRE_ADDR_HASH_V6);
    eval 'sub IRE_ADDR_MASK_HASH_V6 {
        my($addr, $mask, $table_size) = @_;
	    eval q((((($addr). $s6_addr8[8] & ($mask). $s6_addr8[8]) ^ (($addr). $s6_addr8[9] & ($mask). $s6_addr8[9]) ^ (($addr). $s6_addr8[10] & ($mask). $s6_addr8[10]) ^ (($addr). $s6_addr8[13] & ($mask). $s6_addr8[13]) ^ (($addr). $s6_addr8[14] & ($mask). $s6_addr8[14]) ^ (($addr). $s6_addr8[15] & ($mask). $s6_addr8[15])) & (($table_size) - 1)));
    }' unless defined(&IRE_ADDR_MASK_HASH_V6);
    eval 'sub MATCH_IRE_DSTONLY () {0x;}' unless defined(&MATCH_IRE_DSTONLY);
    eval 'sub MATCH_IRE_TYPE () {0x1;}' unless defined(&MATCH_IRE_TYPE);
    eval 'sub MATCH_IRE_SRC () {0x2;}' unless defined(&MATCH_IRE_SRC);
    eval 'sub MATCH_IRE_MASK () {0x4;}' unless defined(&MATCH_IRE_MASK);
    eval 'sub MATCH_IRE_WQ () {0x8;}' unless defined(&MATCH_IRE_WQ);
    eval 'sub MATCH_IRE_GW () {0x10;}' unless defined(&MATCH_IRE_GW);
    eval 'sub MATCH_IRE_IPIF () {0x20;}' unless defined(&MATCH_IRE_IPIF);
    eval 'sub MATCH_IRE_RECURSIVE () {0x40;}' unless defined(&MATCH_IRE_RECURSIVE);
    eval 'sub MATCH_IRE_DEFAULT () {0x80;}' unless defined(&MATCH_IRE_DEFAULT);
    eval 'sub MATCH_IRE_RJ_BHOLE () {0x100;}' unless defined(&MATCH_IRE_RJ_BHOLE);
    eval 'sub MATCH_IRE_IHANDLE () {0x200;}' unless defined(&MATCH_IRE_IHANDLE);
    eval 'sub MATCH_IRE_MARK_HIDDEN () {0x400;}' unless defined(&MATCH_IRE_MARK_HIDDEN);
    eval 'sub MATCH_IRE_ILL_GROUP () {0x800;}' unless defined(&MATCH_IRE_ILL_GROUP);
    eval 'sub MATCH_IRE_ILL () {0x1000;}' unless defined(&MATCH_IRE_ILL);
    eval 'sub BUMP_IRE_STATS {
        my($ire_stats, $x) = @_;
	    eval q( &atomic_add_64(($ire_stats).$x, 1));
    }' unless defined(&BUMP_IRE_STATS);
    if(defined(&_KERNEL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
