require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_INET_MIB2_H)) {
    eval 'sub _INET_MIB2_H () {1;}' unless defined(&_INET_MIB2_H);
    require 'netinet/in.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&IPPROTO_MAX)) {
	eval 'sub IPPROTO_MAX () {256;}' unless defined(&IPPROTO_MAX);
    }
    eval 'sub MIB2_SYSTEM () {( &IPPROTO_MAX+1);}' unless defined(&MIB2_SYSTEM);
    eval 'sub MIB2_INTERFACES () {( &IPPROTO_MAX+2);}' unless defined(&MIB2_INTERFACES);
    eval 'sub MIB2_AT () {( &IPPROTO_MAX+3);}' unless defined(&MIB2_AT);
    eval 'sub MIB2_IP () {( &IPPROTO_MAX+4);}' unless defined(&MIB2_IP);
    eval 'sub MIB2_ICMP () {( &IPPROTO_MAX+5);}' unless defined(&MIB2_ICMP);
    eval 'sub MIB2_TCP () {( &IPPROTO_MAX+6);}' unless defined(&MIB2_TCP);
    eval 'sub MIB2_UDP () {( &IPPROTO_MAX+7);}' unless defined(&MIB2_UDP);
    eval 'sub MIB2_EGP () {( &IPPROTO_MAX+8);}' unless defined(&MIB2_EGP);
    eval 'sub MIB2_CMOT () {( &IPPROTO_MAX+9);}' unless defined(&MIB2_CMOT);
    eval 'sub MIB2_TRANSMISSION () {( &IPPROTO_MAX+10);}' unless defined(&MIB2_TRANSMISSION);
    eval 'sub MIB2_SNMP () {( &IPPROTO_MAX+11);}' unless defined(&MIB2_SNMP);
    eval 'sub MIB2_IP6 () {( &IPPROTO_MAX+12);}' unless defined(&MIB2_IP6);
    eval 'sub MIB2_ICMP6 () {( &IPPROTO_MAX+13);}' unless defined(&MIB2_ICMP6);
    eval 'sub MIB2_TCP6 () {( &IPPROTO_MAX+14);}' unless defined(&MIB2_TCP6);
    eval 'sub MIB2_UDP6 () {( &IPPROTO_MAX+15);}' unless defined(&MIB2_UDP6);
    eval 'sub MIB2_RANGE_START () {( &IPPROTO_MAX+1);}' unless defined(&MIB2_RANGE_START);
    eval 'sub MIB2_RANGE_END () {( &IPPROTO_MAX+15);}' unless defined(&MIB2_RANGE_END);
    eval 'sub EXPER () {1024;}' unless defined(&EXPER);
    eval 'sub EXPER_IGMP () {( &EXPER+1);}' unless defined(&EXPER_IGMP);
    eval 'sub EXPER_DVMRP () {( &EXPER+2);}' unless defined(&EXPER_DVMRP);
    eval 'sub EXPER_RAWIP () {( &EXPER+3);}' unless defined(&EXPER_RAWIP);
    eval 'sub EXPER_RANGE_START () {( &EXPER+1);}' unless defined(&EXPER_RANGE_START);
    eval 'sub EXPER_RANGE_END () {( &EXPER+3);}' unless defined(&EXPER_RANGE_END);
    eval 'sub BUMP_MIB {
        my($x) = @_;
	    eval q(($x)++);
    }' unless defined(&BUMP_MIB);
    eval 'sub SET_MIB {
        my($x, $y) = @_;
	    eval q($x = $y);
    }' unless defined(&SET_MIB);
    eval 'sub UPDATE_MIB {
        my($x, $y) = @_;
	    eval q($x += $y);
    }' unless defined(&UPDATE_MIB);
    eval 'sub BUMP_LOCAL {
        my($x) = @_;
	    eval q(($x)++);
    }' unless defined(&BUMP_LOCAL);
    eval 'sub OCTET_LENGTH () {32;}' unless defined(&OCTET_LENGTH);
    eval 'sub MIB2_IP_ADDR () {20;}' unless defined(&MIB2_IP_ADDR);
    eval 'sub MIB2_IP_ROUTE () {21;}' unless defined(&MIB2_IP_ROUTE);
    eval 'sub MIB2_IP_MEDIA () {22;}' unless defined(&MIB2_IP_MEDIA);
    eval 'sub MIB2_IP6_ROUTE () {23;}' unless defined(&MIB2_IP6_ROUTE);
    eval 'sub MIB2_IP6_MEDIA () {24;}' unless defined(&MIB2_IP6_MEDIA);
    eval 'sub MIB2_IP6_ADDR () {25;}' unless defined(&MIB2_IP6_ADDR);
    eval 'sub EXPER_IP_GROUP_MEMBERSHIP () {100;}' unless defined(&EXPER_IP_GROUP_MEMBERSHIP);
    eval 'sub EXPER_IP6_GROUP_MEMBERSHIP () {101;}' unless defined(&EXPER_IP6_GROUP_MEMBERSHIP);
    eval 'sub MIB2_IP_20 () { &MIB2_IP_ADDR;}' unless defined(&MIB2_IP_20);
    eval 'sub MIB2_IP_21 () { &MIB2_IP_ROUTE;}' unless defined(&MIB2_IP_21);
    eval 'sub MIB2_IP_22 () { &MIB2_IP_MEDIA;}' unless defined(&MIB2_IP_22);
    eval 'sub MIB2_TCP_CONN () {13;}' unless defined(&MIB2_TCP_CONN);
    eval 'sub MIB2_TCP6_CONN () {14;}' unless defined(&MIB2_TCP6_CONN);
    eval 'sub MIB2_TCP_13 () { &MIB2_TCP_CONN;}' unless defined(&MIB2_TCP_13);
    eval 'sub MIB2_TCP_closed () {1;}' unless defined(&MIB2_TCP_closed);
    eval 'sub MIB2_TCP_listen () {2;}' unless defined(&MIB2_TCP_listen);
    eval 'sub MIB2_TCP_synSent () {3;}' unless defined(&MIB2_TCP_synSent);
    eval 'sub MIB2_TCP_synReceived () {4;}' unless defined(&MIB2_TCP_synReceived);
    eval 'sub MIB2_TCP_established () {5;}' unless defined(&MIB2_TCP_established);
    eval 'sub MIB2_TCP_finWait1 () {6;}' unless defined(&MIB2_TCP_finWait1);
    eval 'sub MIB2_TCP_finWait2 () {7;}' unless defined(&MIB2_TCP_finWait2);
    eval 'sub MIB2_TCP_closeWait () {8;}' unless defined(&MIB2_TCP_closeWait);
    eval 'sub MIB2_TCP_lastAck () {9;}' unless defined(&MIB2_TCP_lastAck);
    eval 'sub MIB2_TCP_closing () {10;}' unless defined(&MIB2_TCP_closing);
    eval 'sub MIB2_TCP_timeWait () {11;}' unless defined(&MIB2_TCP_timeWait);
    eval 'sub MIB2_TCP_deleteTCB () {12;}' unless defined(&MIB2_TCP_deleteTCB);
    eval 'sub MIB2_UDP_ENTRY () {5;}' unless defined(&MIB2_UDP_ENTRY);
    eval 'sub MIB2_UDP6_ENTRY () {6;}' unless defined(&MIB2_UDP6_ENTRY);
    eval 'sub MIB2_UDP_5 () { &MIB2_UDP_ENTRY;}' unless defined(&MIB2_UDP_5);
    eval 'sub MIB2_UDP_unbound () {1;}' unless defined(&MIB2_UDP_unbound);
    eval 'sub MIB2_UDP_idle () {2;}' unless defined(&MIB2_UDP_idle);
    eval 'sub MIB2_UDP_connected () {3;}' unless defined(&MIB2_UDP_connected);
    eval 'sub MIB2_UDP_unknown () {4;}' unless defined(&MIB2_UDP_unknown);
    eval 'sub EXPER_DVMRP_VIF () {1;}' unless defined(&EXPER_DVMRP_VIF);
    eval 'sub EXPER_DVMRP_MRT () {2;}' unless defined(&EXPER_DVMRP_MRT);
    if(defined(&__cplusplus)) {
    }
}
1;
