require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ISO_CTYPE_ISO_H)) {
    eval 'sub _ISO_CTYPE_ISO_H () {1;}' unless defined(&_ISO_CTYPE_ISO_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub _U () {0x1;}' unless defined(&_U);
    eval 'sub _L () {0x2;}' unless defined(&_L);
    eval 'sub _N () {0x4;}' unless defined(&_N);
    eval 'sub _S () {0x8;}' unless defined(&_S);
    eval 'sub _P () {0x10;}' unless defined(&_P);
    eval 'sub _C () {0x20;}' unless defined(&_C);
    eval 'sub _B () {0x40;}' unless defined(&_B);
    eval 'sub _X () {0x80;}' unless defined(&_X);
    eval 'sub _ISUPPER () { &_U;}' unless defined(&_ISUPPER);
    eval 'sub _ISLOWER () { &_L;}' unless defined(&_ISLOWER);
    eval 'sub _ISDIGIT () { &_N;}' unless defined(&_ISDIGIT);
    eval 'sub _ISSPACE () { &_S;}' unless defined(&_ISSPACE);
    eval 'sub _ISPUNCT () { &_P;}' unless defined(&_ISPUNCT);
    eval 'sub _ISCNTRL () { &_C;}' unless defined(&_ISCNTRL);
    eval 'sub _ISBLANK () { &_B;}' unless defined(&_ISBLANK);
    eval 'sub _ISXDIGIT () { &_X;}' unless defined(&_ISXDIGIT);
    eval 'sub _ISGRAPH () {0x2000;}' unless defined(&_ISGRAPH);
    eval 'sub _ISALPHA () {0x4000;}' unless defined(&_ISALPHA);
    eval 'sub _ISPRINT () {0x8000;}' unless defined(&_ISPRINT);
    eval 'sub _ISALNUM () {( &_ISALPHA |  &_ISDIGIT);}' unless defined(&_ISALNUM);
    if(defined( &__STDC__)) {
	if((defined(&__cplusplus) ? &__cplusplus : 0) < 199711 ) {
	}
	if((defined(&__cplusplus) ? &__cplusplus : 0) >= 199711) {
	}
	if((defined(&__cplusplus) ? &__cplusplus : 0) >= 199711) {
	}
	if(!defined( &__lint)) {
	    if((defined(&__cplusplus) ? &__cplusplus : 0) >= 199711) {
		if(defined( &__XPG4_CHAR_CLASS__) || defined( &_XPG4_2) || (defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4))) {
		} else {
		}
	    } else {
		if(defined( &__XPG4_CHAR_CLASS__) || defined( &_XPG4_2) || (defined( &_XOPEN_SOURCE)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : 0) - 0>= 4))) {
		    eval 'sub isalpha {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISALPHA));
		    }' unless defined(&isalpha);
		    eval 'sub isupper {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISUPPER));
		    }' unless defined(&isupper);
		    eval 'sub islower {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISLOWER));
		    }' unless defined(&islower);
		    eval 'sub isdigit {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISDIGIT));
		    }' unless defined(&isdigit);
		    eval 'sub isxdigit {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISXDIGIT));
		    }' unless defined(&isxdigit);
		    eval 'sub isalnum {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISALNUM));
		    }' unless defined(&isalnum);
		    eval 'sub isspace {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISSPACE));
		    }' unless defined(&isspace);
		    eval 'sub ispunct {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISPUNCT));
		    }' unless defined(&ispunct);
		    eval 'sub isprint {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISPRINT));
		    }' unless defined(&isprint);
		    eval 'sub isgraph {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISGRAPH));
		    }' unless defined(&isgraph);
		    eval 'sub iscntrl {
		        my($c) = @_;
    			eval q(( $__ctype_mask[$c] &  &_ISCNTRL));
		    }' unless defined(&iscntrl);
		} else {
		    eval 'sub isalpha {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] & ( &_U |  &_L)));
		    }' unless defined(&isalpha);
		    eval 'sub isupper {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] &  &_U));
		    }' unless defined(&isupper);
		    eval 'sub islower {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] &  &_L));
		    }' unless defined(&islower);
		    eval 'sub isdigit {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] &  &_N));
		    }' unless defined(&isdigit);
		    eval 'sub isxdigit {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] &  &_X));
		    }' unless defined(&isxdigit);
		    eval 'sub isalnum {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] & ( &_U |  &_L |  &_N)));
		    }' unless defined(&isalnum);
		    eval 'sub isspace {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] &  &_S));
		    }' unless defined(&isspace);
		    eval 'sub ispunct {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] &  &_P));
		    }' unless defined(&ispunct);
		    eval 'sub isprint {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] & ( &_P |  &_U |  &_L |  &_N |  &_B)));
		    }' unless defined(&isprint);
		    eval 'sub isgraph {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] & ( &_P |  &_U |  &_L |  &_N)));
		    }' unless defined(&isgraph);
		    eval 'sub iscntrl {
		        my($c) = @_;
    			eval q((( &__ctype + 1)[$c] &  &_C));
		    }' unless defined(&iscntrl);
		}
	    }
	}
    } else {
	if(!defined( &__lint)) {
	    eval 'sub isalpha {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] & ( &_U |  &_L)));
	    }' unless defined(&isalpha);
	    eval 'sub isupper {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] &  &_U));
	    }' unless defined(&isupper);
	    eval 'sub islower {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] &  &_L));
	    }' unless defined(&islower);
	    eval 'sub isdigit {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] &  &_N));
	    }' unless defined(&isdigit);
	    eval 'sub isxdigit {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] &  &_X));
	    }' unless defined(&isxdigit);
	    eval 'sub isalnum {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] & ( &_U |  &_L |  &_N)));
	    }' unless defined(&isalnum);
	    eval 'sub isspace {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] &  &_S));
	    }' unless defined(&isspace);
	    eval 'sub ispunct {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] &  &_P));
	    }' unless defined(&ispunct);
	    eval 'sub isprint {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] & ( &_P |  &_U |  &_L |  &_N |  &_B)));
	    }' unless defined(&isprint);
	    eval 'sub isgraph {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] & ( &_P |  &_U |  &_L |  &_N)));
	    }' unless defined(&isgraph);
	    eval 'sub iscntrl {
	        my($c) = @_;
    		eval q((( &_ctype + 1)[$c] &  &_C));
	    }' unless defined(&iscntrl);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
