require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__Kcs__)) {
    eval 'sub __Kcs__ () {1;}' unless defined(&__Kcs__);
    if(defined(&__cplusplus)) {
    }
    if(defined( &applec) || defined( &THINK_C)) {
	eval 'sub KCS_ON_MAC () {1;}' unless defined(&KCS_ON_MAC);
    }
    if(defined(&_Windows)) {
	eval 'sub KCS_ON_WINDOWS () {1;}' unless defined(&KCS_ON_WINDOWS);
    }
    if(defined ( &__sun) || defined( &sun) ) {
	undef(&KCS_ON_SOLARIS) if defined(&KCS_ON_SOLARIS);
	eval 'sub KCS_ON_SOLARIS () {1;}' unless defined(&KCS_ON_SOLARIS);
    }
    if(defined ( &__unix)) {
	eval 'sub KCS_ON_UNIX () {1;}' unless defined(&KCS_ON_UNIX);
    }
    if(defined(&KCS_ON_WINDOWS)) {
	eval 'sub KCS_PTR () { &_far*;}' unless defined(&KCS_PTR);
	eval 'sub KCS_PASC {
	    my($X) = @_;
    	    eval q($X  &_far  &_pascal);
	}' unless defined(&KCS_PASC);
	eval 'sub KCS_CALLBK {
	    my($X) = @_;
    	    eval q($X  &_far  &_pascal);
	}' unless defined(&KCS_CALLBK);
	eval 'sub KCS_INLINE_ASM {
	    my( $selector, $argsize ) = @_;
    	    eval q();
	}' unless defined(&KCS_INLINE_ASM);
    }
    if(defined(&KCS_ON_SOLARIS)) {
	require 'sys/isa_defs.ph';
	eval 'sub KCS_PTR () {*;}' unless defined(&KCS_PTR);
	eval 'sub KCS_PASC {
	    my($X) = @_;
    	    eval q($X);
	}' unless defined(&KCS_PASC);
	eval 'sub KCS_CALLBK {
	    my($X) = @_;
    	    eval q($X);
	}' unless defined(&KCS_CALLBK);
	eval 'sub KCS_INLINE_ASM {
	    my( $selector, $argsize ) = @_;
    	    eval q();
	}' unless defined(&KCS_INLINE_ASM);
	eval 'sub KCS_pascal () {1;}' unless defined(&KCS_pascal);
    }
    if(defined(&KCS_ON_MAC)) {
	eval 'sub KCS_PTR () {*;}' unless defined(&KCS_PTR);
	eval 'sub KCS_CALLBK {
	    my($X) = @_;
    	    eval q($X);
	}' unless defined(&KCS_CALLBK);
	eval 'sub KCS_gestaltKcs () {ord(\'Kcs \');}' unless defined(&KCS_gestaltKcs);
	unless(defined(&KCS_LINKABLE_INTERFACE)) {
	    eval 'sub KCS_INLINE_ASM {
	        my( $selector, $argsize ) = @_;
    		eval q(= { 0x2f00, 0x203c, 0x4b63, 0x7320, 0xa1ad, 0x4a40, 0x670e, 0x201f, 0xdefc, $argsize, 0x2ebc, 0x, 0x4054, 0x6016, 0x201f, 0x42a7, 0x2f3c, $argsize, $selector, 0x4e90, 0x205f, 0xb0fc, 0x, 0x67e0, 0x4e90, 0x4e71 });
	    }' unless defined(&KCS_INLINE_ASM);
	    eval 'sub pKcsSelectorStart () {0x;}' unless defined(&pKcsSelectorStart);
	    eval 'sub pKcsLoadProfile () {0x;}' unless defined(&pKcsLoadProfile);
	    eval 'sub pKcsSaveProfile () {0x1;}' unless defined(&pKcsSaveProfile);
	    eval 'sub pKcsFreeProfile () {0x2;}' unless defined(&pKcsFreeProfile);
	    eval 'sub pKcsReserved0003 () {0x3;}' unless defined(&pKcsReserved0003);
	    eval 'sub pKcsReserved0004 () {0x4;}' unless defined(&pKcsReserved0004);
	    eval 'sub pKcsGetAttribute () {0x5;}' unless defined(&pKcsGetAttribute);
	    eval 'sub pKcsSetAttribute () {0x6;}' unless defined(&pKcsSetAttribute);
	    eval 'sub pKcsReserved0007 () {0x7;}' unless defined(&pKcsReserved0007);
	    eval 'sub pKcsReserved0008 () {0x8;}' unless defined(&pKcsReserved0008);
	    eval 'sub pKcsConnectProfiles () {0x9;}' unless defined(&pKcsConnectProfiles);
	    eval 'sub pKcsOptimizeProfile () {0xa;}' unless defined(&pKcsOptimizeProfile);
	    eval 'sub pKcsEvaluate () {0xb;}' unless defined(&pKcsEvaluate);
	    eval 'sub pKcsReserved000C () {0xc;}' unless defined(&pKcsReserved000C);
	    eval 'sub pKcsReserved000D () {0xd;}' unless defined(&pKcsReserved000D);
	    eval 'sub pKcsReserved000E () {0xe;}' unless defined(&pKcsReserved000E);
	    eval 'sub pKcsModifyLoadHints () {0xf;}' unless defined(&pKcsModifyLoadHints);
	    eval 'sub pKcsSetCallback () {0x10;}' unless defined(&pKcsSetCallback);
	    eval 'sub pKcsCreateProfile () {0x11;}' unless defined(&pKcsCreateProfile);
	    eval 'sub pKcsUpdateProfile () {0x12;}' unless defined(&pKcsUpdateProfile);
	    eval 'sub pKcsGetSimpleAttribute () {0x13;}' unless defined(&pKcsGetSimpleAttribute);
	    eval 'sub pKcsSetSimpleAttribute () {0x14;}' unless defined(&pKcsSetSimpleAttribute);
	    eval 'sub pKcsAvailable () {0x15;}' unless defined(&pKcsAvailable);
	    eval 'sub pKcsGetLastError () {0x16;}' unless defined(&pKcsGetLastError);
	    eval 'sub pKcsLastSelector () {0x17;}' unless defined(&pKcsLastSelector);
	    eval 'sub KCS_PASC {
	        my($X) = @_;
    		eval q( &pascal $X);
	    }' unless defined(&KCS_PASC);
	} else {
	    eval 'sub KCS_INLINE_ASM {
	        my( $selector, $argsize ) = @_;
    		eval q();
	    }' unless defined(&KCS_INLINE_ASM);
	    eval 'sub KCS_PASC {
	        my($X) = @_;
    		eval q($X);
	    }' unless defined(&KCS_PASC);
	}
    }
    require 'kcstypes.ph';
    if(defined(&__cplusplus)) {
    }
}
1;
