require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_KCS_STATUS_H)) {
    eval 'sub _KCS_STATUS_H () {1;}' unless defined(&_KCS_STATUS_H);
    eval("sub KCS_SUCCESS () { 0x0000; }") unless defined(&KCS_SUCCESS);
    eval("sub KCS_WARNINGS_START () { 0x1000; }") unless defined(&KCS_WARNINGS_START);
    eval("sub KCS_OPERATION_CANCELLED () { 0x1001; }") unless defined(&KCS_OPERATION_CANCELLED);
    eval("sub KCS_TRUNCATED () { 0x1002; }") unless defined(&KCS_TRUNCATED);
    eval("sub KCS_SPEC_CMM_NOT_FOUND () { 0x1003; }") unless defined(&KCS_SPEC_CMM_NOT_FOUND);
    eval("sub KCS_CANNOT_OPTIMIZE () { 0x1004; }") unless defined(&KCS_CANNOT_OPTIMIZE);
    eval("sub KCS_CANNOT_DEOPTIMIZE () { 0x1005; }") unless defined(&KCS_CANNOT_DEOPTIMIZE);
    eval("sub KCS_ATTR_LARGE_CT_SUPPLIED () { 0x1006; }") unless defined(&KCS_ATTR_LARGE_CT_SUPPLIED);
    eval("sub KCS_WARNINGS_END () { 1; }") unless defined(&KCS_WARNINGS_END);
    eval("sub KCS_ERRORS_START () { 0x4000; }") unless defined(&KCS_ERRORS_START);
    eval("sub KCS_MEM_ALLOC_ERR () { 0x4006; }") unless defined(&KCS_MEM_ALLOC_ERR);
    eval("sub KCS_MEM_ADDRESS_ERR () { 0x4007; }") unless defined(&KCS_MEM_ADDRESS_ERR);
    eval("sub KCS_OS_ERR () { 0x4008; }") unless defined(&KCS_OS_ERR);
    eval("sub KCS_IO_READ_ERR () { 0X4010; }") unless defined(&KCS_IO_READ_ERR);
    eval("sub KCS_IO_WRITE_ERR () { 0X4011; }") unless defined(&KCS_IO_WRITE_ERR);
    eval("sub KCS_IO_SEEK_ERR () { 0X4012; }") unless defined(&KCS_IO_SEEK_ERR);
    eval("sub KCS_IO_UNKNOWN_TYPE_ERR () { 0X4013; }") unless defined(&KCS_IO_UNKNOWN_TYPE_ERR);
    eval("sub KCS_PROF_ID_BAD () { 0x4020; }") unless defined(&KCS_PROF_ID_BAD);
    eval("sub KCS_PROF_FORMAT_BAD () { 0x4021; }") unless defined(&KCS_PROF_FORMAT_BAD);
    eval("sub KCS_PROF_CT_EXCEEDS_PROF_LIST () { 0x4022; }") unless defined(&KCS_PROF_CT_EXCEEDS_PROF_LIST);
    eval("sub KCS_PROF_INCOMPLETE () { 0x4023; }") unless defined(&KCS_PROF_INCOMPLETE);
    eval("sub KCS_PROF_NO_DATA_SUPPORT_4_REQUEST () { 0x4024; }") unless defined(&KCS_PROF_NO_DATA_SUPPORT_4_REQUEST);
    eval("sub KCS_PROF_REQ_ATTRS_INCOMPLETE () { 0x4025; }") unless defined(&KCS_PROF_REQ_ATTRS_INCOMPLETE);
    eval("sub KCS_ATTR_NAME_OUT_OF_RANGE () { 0x4030; }") unless defined(&KCS_ATTR_NAME_OUT_OF_RANGE);
    eval("sub KCS_ATTR_TYPE_UNKNOWN () { 0x4031; }") unless defined(&KCS_ATTR_TYPE_UNKNOWN);
    eval("sub KCS_ATTR_LOAD_FORMAT_INCORRECT () { 0x4032; }") unless defined(&KCS_ATTR_LOAD_FORMAT_INCORRECT);
    eval("sub KCS_ATTR_LOAD_FLOAT_ERR () { 0x4033; }") unless defined(&KCS_ATTR_LOAD_FLOAT_ERR);
    eval("sub KCS_ATTR_LOAD_INT_ERR () { 0x4034; }") unless defined(&KCS_ATTR_LOAD_INT_ERR);
    eval("sub KCS_ATTR_DATE_TIME_FORMAT () { 0x4035; }") unless defined(&KCS_ATTR_DATE_TIME_FORMAT);
    eval("sub KCS_ATTR_CT_ZERO_OR_NEG () { 0x4036; }") unless defined(&KCS_ATTR_CT_ZERO_OR_NEG);
    eval("sub KCS_ATTR_READ_ONLY () { 0x4037; }") unless defined(&KCS_ATTR_READ_ONLY);
    eval("sub KCS_ATTR_TYPE_NOT_SIMPLE () { 0x4038; }") unless defined(&KCS_ATTR_TYPE_NOT_SIMPLE);
    eval("sub KCS_CONNECT_FAILED () { 0x4040; }") unless defined(&KCS_CONNECT_FAILED);
    eval("sub KCS_CONNECT_PRECISION_UNACCEPTABLE () { 0x4041; }") unless defined(&KCS_CONNECT_PRECISION_UNACCEPTABLE);
    eval("sub KCS_CONNECT_OPT_FORCED_DATA_LOSS () { 0x4042; }") unless defined(&KCS_CONNECT_OPT_FORCED_DATA_LOSS);
    eval("sub KCS_CONNECT_PROFILES_CT_ERR () { 0x4043; }") unless defined(&KCS_CONNECT_PROFILES_CT_ERR);
    eval("sub KCS_CONNECT_QUANT_MISMATCH () { 0x4044; }") unless defined(&KCS_CONNECT_QUANT_MISMATCH);
    eval("sub KCS_CONNECT_UNIMP_OP () { 0x4045; }") unless defined(&KCS_CONNECT_UNIMP_OP);
    eval("sub KCS_NOT_AVAILABLE () { 0x4054; }") unless defined(&KCS_NOT_AVAILABLE);
    eval("sub KCS_MISMATCHED_WHITEPOINTS () { 0x4060; }") unless defined(&KCS_MISMATCHED_WHITEPOINTS);
    eval("sub KCS_MISMATCHED_BLACKPOINTS () { 0x4061; }") unless defined(&KCS_MISMATCHED_BLACKPOINTS);
    eval("sub KCS_MISMATCHED_COLORSPACES () { 0x4062; }") unless defined(&KCS_MISMATCHED_COLORSPACES);
    eval("sub KCS_MISMATCHED_DIMENSIONS () { 0x4063; }") unless defined(&KCS_MISMATCHED_DIMENSIONS);
    eval("sub KCS_MISMATCHED_VERSIONS () { 0x4064; }") unless defined(&KCS_MISMATCHED_VERSIONS);
    eval("sub KCS_LAYOUT_INVALID () { 0x4070; }") unless defined(&KCS_LAYOUT_INVALID);
    eval("sub KCS_LAYOUT_UNSUPPORTED () { 0x4071; }") unless defined(&KCS_LAYOUT_UNSUPPORTED);
    eval("sub KCS_LAYOUT_MISMATCH () { 0x4072; }") unless defined(&KCS_LAYOUT_MISMATCH);
    eval("sub KCS_EVAL_TOO_MANY_CHANNELS () { 0x4080; }") unless defined(&KCS_EVAL_TOO_MANY_CHANNELS);
    eval("sub KCS_EVAL_BUFFER_OVERFLOW () { 0x4081; }") unless defined(&KCS_EVAL_BUFFER_OVERFLOW);
    eval("sub KCS_EVAL_ONLY_ONE_OP_ALLOWED () { 0x4082; }") unless defined(&KCS_EVAL_ONLY_ONE_OP_ALLOWED);
    eval("sub KCS_CC_UPDATE_NEEDS_MORE_DATA () { 0x4090; }") unless defined(&KCS_CC_UPDATE_NEEDS_MORE_DATA);
    eval("sub KCS_CC_UPDATE_INVALID_DATA () { 0x4091; }") unless defined(&KCS_CC_UPDATE_INVALID_DATA);
    eval("sub KCS_CC_INCORRECT_COLOR_SPACE () { 0x4092; }") unless defined(&KCS_CC_INCORRECT_COLOR_SPACE);
    eval("sub KCS_CC_NUM_COMPS_OUT_OF_RANGE () { 0x4093; }") unless defined(&KCS_CC_NUM_COMPS_OUT_OF_RANGE);
    eval("sub KCS_CC_TOO_FEW_MEASUREMENTS () { 0x4094; }") unless defined(&KCS_CC_TOO_FEW_MEASUREMENTS);
    eval("sub KCS_CC_TABLE_DATA_BAD () { 0x4095; }") unless defined(&KCS_CC_TABLE_DATA_BAD);
    eval("sub KCS_CC_INCORRECT_DEV_TYPE () { 0x4096; }") unless defined(&KCS_CC_INCORRECT_DEV_TYPE);
    eval("sub KCS_CC_INCORRECT_ATTR_CLASS () { 0x4097; }") unless defined(&KCS_CC_INCORRECT_ATTR_CLASS);
    eval("sub KCS_CC_CANNOT_CAL_DEV_TYPE () { 0x4098; }") unless defined(&KCS_CC_CANNOT_CAL_DEV_TYPE);
    eval("sub KCS_CC_CANNOT_CHAR_DEV_TYPE () { 0x4099; }") unless defined(&KCS_CC_CANNOT_CHAR_DEV_TYPE);
    eval("sub KCS_CC_INPUT_NOT_RAMP () { 0x409A; }") unless defined(&KCS_CC_INPUT_NOT_RAMP);
    eval("sub KCS_CMM_UNKNOWN_TECHNOLOGY () { 0x4100; }") unless defined(&KCS_CMM_UNKNOWN_TECHNOLOGY);
    eval("sub KCS_COMP_MGR_FAILURE () { 0x4101; }") unless defined(&KCS_COMP_MGR_FAILURE);
    eval("sub KCS_CMM_UNKNOWN_RUNTIME_TYPE () { 0X4102; }") unless defined(&KCS_CMM_UNKNOWN_RUNTIME_TYPE);
    eval("sub KCS_CMM_UNSUPPORTED_OP () { 0X4103; }") unless defined(&KCS_CMM_UNSUPPORTED_OP);
    eval("sub KCS_CMM_RTLOAD_FAILED () { 0x4104; }") unless defined(&KCS_CMM_RTLOAD_FAILED);
    eval("sub KCS_CMM_MAJOR_VERSION_MISMATCH () { 0x4105; }") unless defined(&KCS_CMM_MAJOR_VERSION_MISMATCH);
    eval("sub KCS_CMM_MINOR_VERSION_MISMATCH () { 0x4106; }") unless defined(&KCS_CMM_MINOR_VERSION_MISMATCH);
    eval("sub KCS_UNIMP_NESTED_CONNECTIONS () { 0x4110; }") unless defined(&KCS_UNIMP_NESTED_CONNECTIONS);
    eval("sub KCS_UNIMP_TOO_MANY_PROFILES () { 0x4111; }") unless defined(&KCS_UNIMP_TOO_MANY_PROFILES);
    eval("sub KCS_UNIMP_ILLEGAL_TECHNOLOGY () { 0x4112; }") unless defined(&KCS_UNIMP_ILLEGAL_TECHNOLOGY);
    eval("sub KCS_INTERNAL_CLASS_CORRUPTED () { 0x4120; }") unless defined(&KCS_INTERNAL_CLASS_CORRUPTED);
    eval("sub KCS_INTERNAL_DATA_CORRUPTED () { 0x4121; }") unless defined(&KCS_INTERNAL_DATA_CORRUPTED);
    eval("sub KCS_PUBLIC_ERRORS_END () { 0x6FFF; }") unless defined(&KCS_PUBLIC_ERRORS_END);
    eval("sub KCS_KODAK_PRIVATE_ERRORS_END () { 0x7FFE; }") unless defined(&KCS_KODAK_PRIVATE_ERRORS_END);
    eval("sub KCS_ERRORS_END () { 1; }") unless defined(&KCS_ERRORS_END);
    eval("sub KCS_USER_STATUS () { 0xA000; }") unless defined(&KCS_USER_STATUS);
    eval("sub KCS_USER_STATUS_END () { 0xFF00; }") unless defined(&KCS_USER_STATUS_END);
    eval("sub KCS_STATUS_END () { KcsForceAlign; }") unless defined(&KCS_STATUS_END);
}
1;
