require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LIBELF_H)) {
    eval 'sub _LIBELF_H () {1;}' unless defined(&_LIBELF_H);
    require 'sys/types.ph';
    require 'sys/elf.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &_ILP32)  && ((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) != 32)) {
	die("large files are not supported by libelf");
    }
    undef(&_) if defined(&_);
    if(defined(&__STDC__)) {
	eval 'sub _ {
	    my($a) = @_;
    	    eval q($a);
	}' unless defined(&_);
    } else {
	eval 'sub _ {
	    my($a) = @_;
    	    eval q(());
	}' unless defined(&_);
	undef(&const) if defined(&const);
	eval 'sub const () {1;}' unless defined(&const);
    }
    eval("sub ELF_C_NULL () { 0; }") unless defined(&ELF_C_NULL);
    eval("sub ELF_C_READ () { 1; }") unless defined(&ELF_C_READ);
    eval("sub ELF_C_WRITE () { 2; }") unless defined(&ELF_C_WRITE);
    eval("sub ELF_C_CLR () { 3; }") unless defined(&ELF_C_CLR);
    eval("sub ELF_C_SET () { 4; }") unless defined(&ELF_C_SET);
    eval("sub ELF_C_FDDONE () { 5; }") unless defined(&ELF_C_FDDONE);
    eval("sub ELF_C_FDREAD () { 6; }") unless defined(&ELF_C_FDREAD);
    eval("sub ELF_C_RDWR () { 7; }") unless defined(&ELF_C_RDWR);
    eval("sub ELF_C_WRIMAGE () { 8; }") unless defined(&ELF_C_WRIMAGE);
    eval("sub ELF_C_IMAGE () { 9; }") unless defined(&ELF_C_IMAGE);
    eval("sub ELF_C_NUM () { 10; }") unless defined(&ELF_C_NUM);
    eval 'sub ELF_F_DIRTY () {0x1;}' unless defined(&ELF_F_DIRTY);
    eval 'sub ELF_F_LAYOUT () {0x4;}' unless defined(&ELF_F_LAYOUT);
    eval("sub ELF_K_NONE () { 0; }") unless defined(&ELF_K_NONE);
    eval("sub ELF_K_AR () { 1; }") unless defined(&ELF_K_AR);
    eval("sub ELF_K_COFF () { 2; }") unless defined(&ELF_K_COFF);
    eval("sub ELF_K_ELF () { 3; }") unless defined(&ELF_K_ELF);
    eval("sub ELF_K_NUM () { 4; }") unless defined(&ELF_K_NUM);
    eval("sub ELF_T_BYTE () { 0; }") unless defined(&ELF_T_BYTE);
    eval("sub ELF_T_ADDR () { 1; }") unless defined(&ELF_T_ADDR);
    eval("sub ELF_T_DYN () { 2; }") unless defined(&ELF_T_DYN);
    eval("sub ELF_T_EHDR () { 3; }") unless defined(&ELF_T_EHDR);
    eval("sub ELF_T_HALF () { 4; }") unless defined(&ELF_T_HALF);
    eval("sub ELF_T_OFF () { 5; }") unless defined(&ELF_T_OFF);
    eval("sub ELF_T_PHDR () { 6; }") unless defined(&ELF_T_PHDR);
    eval("sub ELF_T_RELA () { 7; }") unless defined(&ELF_T_RELA);
    eval("sub ELF_T_REL () { 8; }") unless defined(&ELF_T_REL);
    eval("sub ELF_T_SHDR () { 9; }") unless defined(&ELF_T_SHDR);
    eval("sub ELF_T_SWORD () { 10; }") unless defined(&ELF_T_SWORD);
    eval("sub ELF_T_SYM () { 11; }") unless defined(&ELF_T_SYM);
    eval("sub ELF_T_WORD () { 12; }") unless defined(&ELF_T_WORD);
    eval("sub ELF_T_VDEF () { 13; }") unless defined(&ELF_T_VDEF);
    eval("sub ELF_T_VNEED () { 14; }") unless defined(&ELF_T_VNEED);
    eval("sub ELF_T_SXWORD () { 15; }") unless defined(&ELF_T_SXWORD);
    eval("sub ELF_T_XWORD () { 16; }") unless defined(&ELF_T_XWORD);
    eval("sub ELF_T_SYMINFO () { 17; }") unless defined(&ELF_T_SYMINFO);
    eval("sub ELF_T_NOTE () { 18; }") unless defined(&ELF_T_NOTE);
    eval("sub ELF_T_MOVE () { 19; }") unless defined(&ELF_T_MOVE);
    eval("sub ELF_T_MOVEP () { 20; }") unless defined(&ELF_T_MOVEP);
    eval("sub ELF_T_NUM () { 21; }") unless defined(&ELF_T_NUM);
    if((defined( &_LP64) || (((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0)  && (!defined( &_NO_LONGLONG))))) {
    }
    undef(&_) if defined(&_);
    if(defined(&__cplusplus)) {
    }
}
1;
