require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LIBRCM_H)) {
    eval 'sub _LIBRCM_H () {1;}' unless defined(&_LIBRCM_H);
    require 'libnvpair.ph';
    require 'sys/types.ph';
    require 'sys/processor.ph';
    require 'sys/pset.ph';
    require 'sys/time_impl.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub RCM_INCLUDE_SUBTREE () {0x1;}' unless defined(&RCM_INCLUDE_SUBTREE);
    eval 'sub RCM_INCLUDE_DEPENDENT () {0x2;}' unless defined(&RCM_INCLUDE_DEPENDENT);
    eval 'sub RCM_QUERY () {0x4;}' unless defined(&RCM_QUERY);
    eval 'sub RCM_FORCE () {0x8;}' unless defined(&RCM_FORCE);
    eval 'sub RCM_FILESYS () {0x10;}' unless defined(&RCM_FILESYS);
    eval 'sub RCM_NOPID () {0x20;}' unless defined(&RCM_NOPID);
    eval 'sub RCM_DR_OPERATION () {0x40;}' unless defined(&RCM_DR_OPERATION);
    eval 'sub RCM_MOD_INFO () {0x80;}' unless defined(&RCM_MOD_INFO);
    eval 'sub RCM_CAPACITY_ADD () {0x100;}' unless defined(&RCM_CAPACITY_ADD);
    eval 'sub RCM_CAPACITY_DELETE () {0x200;}' unless defined(&RCM_CAPACITY_DELETE);
    eval 'sub RCM_QUERY_CANCEL () {0x400;}' unless defined(&RCM_QUERY_CANCEL);
    eval 'sub RCM_SCOPE () {0x800;}' unless defined(&RCM_SCOPE);
    eval 'sub RCM_REGISTER_DR () {0x1000;}' unless defined(&RCM_REGISTER_DR);
    eval 'sub RCM_REGISTER_EVENT () {0x2000;}' unless defined(&RCM_REGISTER_EVENT);
    eval 'sub RCM_REGISTER_CAPACITY () {0x4000;}' unless defined(&RCM_REGISTER_CAPACITY);
    eval 'sub RCM_SUSPENDED () {0x8000;}' unless defined(&RCM_SUSPENDED);
    eval 'sub RCM_SUCCESS () {0;}' unless defined(&RCM_SUCCESS);
    eval 'sub RCM_FAILURE () {-1;}' unless defined(&RCM_FAILURE);
    eval 'sub RCM_CONFLICT () {-2;}' unless defined(&RCM_CONFLICT);
    eval 'sub RCM_STATE_UNKNOWN () {0;}' unless defined(&RCM_STATE_UNKNOWN);
    eval 'sub RCM_STATE_ONLINE () {1;}' unless defined(&RCM_STATE_ONLINE);
    eval 'sub RCM_STATE_ONLINING () {2;}' unless defined(&RCM_STATE_ONLINING);
    eval 'sub RCM_STATE_OFFLINE_FAIL () {3;}' unless defined(&RCM_STATE_OFFLINE_FAIL);
    eval 'sub RCM_STATE_OFFLINING () {4;}' unless defined(&RCM_STATE_OFFLINING);
    eval 'sub RCM_STATE_OFFLINE () {5;}' unless defined(&RCM_STATE_OFFLINE);
    eval 'sub RCM_STATE_REMOVING () {6;}' unless defined(&RCM_STATE_REMOVING);
    eval 'sub RCM_STATE_RESUMING () {10;}' unless defined(&RCM_STATE_RESUMING);
    eval 'sub RCM_STATE_SUSPEND_FAIL () {11;}' unless defined(&RCM_STATE_SUSPEND_FAIL);
    eval 'sub RCM_STATE_SUSPENDING () {12;}' unless defined(&RCM_STATE_SUSPENDING);
    eval 'sub RCM_STATE_SUSPEND () {13;}' unless defined(&RCM_STATE_SUSPEND);
    eval 'sub RCM_STATE_REMOVE () {14;}' unless defined(&RCM_STATE_REMOVE);
    eval 'sub RCM_STATE_OFFLINE_QUERYING () {15;}' unless defined(&RCM_STATE_OFFLINE_QUERYING);
    eval 'sub RCM_STATE_OFFLINE_QUERY_FAIL () {16;}' unless defined(&RCM_STATE_OFFLINE_QUERY_FAIL);
    eval 'sub RCM_STATE_OFFLINE_QUERY () {17;}' unless defined(&RCM_STATE_OFFLINE_QUERY);
    eval 'sub RCM_STATE_SUSPEND_QUERYING () {18;}' unless defined(&RCM_STATE_SUSPEND_QUERYING);
    eval 'sub RCM_STATE_SUSPEND_QUERY_FAIL () {19;}' unless defined(&RCM_STATE_SUSPEND_QUERY_FAIL);
    eval 'sub RCM_STATE_SUSPEND_QUERY () {20;}' unless defined(&RCM_STATE_SUSPEND_QUERY);
    eval 'sub RCM_RSRCNAME () {"rcm.rsrcname";}' unless defined(&RCM_RSRCNAME);
    eval 'sub RCM_CLIENT_NAME () {"rcm.client_name";}' unless defined(&RCM_CLIENT_NAME);
    eval 'sub RCM_CLIENT_EXPORTS () {"rcm.client_exports";}' unless defined(&RCM_CLIENT_EXPORTS);
    eval 'sub RCM_RESOURCE_NETWORK_NEW () {"SUNW_event/resource/new/network";}' unless defined(&RCM_RESOURCE_NETWORK_NEW);
    eval 'sub RCM_NV_DRIVER_NAME () {"driver_name";}' unless defined(&RCM_NV_DRIVER_NAME);
    eval 'sub RCM_NV_INSTANCE () {"instance";}' unless defined(&RCM_NV_INSTANCE);
    eval 'sub RCM_NV_NODE_NAME () {"node_name";}' unless defined(&RCM_NV_NODE_NAME);
    eval 'sub RCM_NV_DEVFS_PATH () {"devfs_path";}' unless defined(&RCM_NV_DEVFS_PATH);
    eval 'sub RCM_NV_MINOR_DATA () {"minor_data";}' unless defined(&RCM_NV_MINOR_DATA);
    eval 'sub RCM_NV_MINOR_TYPE () {"minor_type";}' unless defined(&RCM_NV_MINOR_TYPE);
    eval 'sub RCM_NV_MINOR_NAME () {"minor_name";}' unless defined(&RCM_NV_MINOR_NAME);
    eval 'sub RCM_NV_MINOR_NODE_TYPE () {"minor_node_type";}' unless defined(&RCM_NV_MINOR_NODE_TYPE);
    if(defined(&__cplusplus)) {
    }
}
1;
