require '_h2ph_pre.ph';

no warnings 'redefine';

# "@(#)cics_macro.h 1.6 93/05/19 SMI"
unless(defined(&_MLE_CICS_MACRO_H)) {
    eval 'sub _MLE_CICS_MACRO_H () {1;}' unless defined(&_MLE_CICS_MACRO_H);
    eval 'sub CS_NOP () {0x;}' unless defined(&CS_NOP);
    eval 'sub CS_CHAR_EVENT () { &CS_NOP;}' unless defined(&CS_CHAR_EVENT);
    eval 'sub CS_STR_EVENT () {0x1;}' unless defined(&CS_STR_EVENT);
    eval 'sub CS_IM_SWITCH () {0x100;}' unless defined(&CS_IM_SWITCH);
    eval 'sub CS_IM_KANJI () {0x101;}' unless defined(&CS_IM_KANJI);
    eval 'sub CS_IM_HANKAKU () {0x102;}' unless defined(&CS_IM_HANKAKU);
    eval 'sub CS_IM_CODE () {0x103;}' unless defined(&CS_IM_CODE);
    eval 'sub CS_CM_SWITCH () {0x200;}' unless defined(&CS_CM_SWITCH);
    eval 'sub CS_CM_IKKATSU () {0x201;}' unless defined(&CS_CM_IKKATSU);
    eval 'sub CS_CM_SAKIYOMI () {0x202;}' unless defined(&CS_CM_SAKIYOMI);
    eval 'sub CS_CM_CHIKUJI () {0x203;}' unless defined(&CS_CM_CHIKUJI);
    eval 'sub CS_CM_TANBUN () {0x204;}' unless defined(&CS_CM_TANBUN);
    eval 'sub CS_CM_TANKAN () {0x205;}' unless defined(&CS_CM_TANKAN);
    eval 'sub CS_CIM_SWITCH () {0x300;}' unless defined(&CS_CIM_SWITCH);
    eval 'sub CS_CIM_ROMAJI () {0x301;}' unless defined(&CS_CIM_ROMAJI);
    eval 'sub CS_CIM_KANA () {0x302;}' unless defined(&CS_CIM_KANA);
    eval 'sub CS_XIM_SWITCH () {0x400;}' unless defined(&CS_XIM_SWITCH);
    eval 'sub CS_XIM_HIRA () {0x401;}' unless defined(&CS_XIM_HIRA);
    eval 'sub CS_XIM_ZENKANA () {0x402;}' unless defined(&CS_XIM_ZENKANA);
    eval 'sub CS_XIM_HANKANA () {0x403;}' unless defined(&CS_XIM_HANKANA);
    eval 'sub CS_XIM_ZENALPHA () {0x404;}' unless defined(&CS_XIM_ZENALPHA);
    eval 'sub CS_XIM_HANALPHA () {0x405;}' unless defined(&CS_XIM_HANALPHA);
    eval 'sub CS_XIM_EXIT () {0x406;}' unless defined(&CS_XIM_EXIT);
    eval 'sub CS_CODE_SWITCH () {0x500;}' unless defined(&CS_CODE_SWITCH);
    eval 'sub CS_CODE_JIS () {0x501;}' unless defined(&CS_CODE_JIS);
    eval 'sub CS_CODE_KUTEN () {0x502;}' unless defined(&CS_CODE_KUTEN);
    eval 'sub CS_CODE_EUC () {0x503;}' unless defined(&CS_CODE_EUC);
    eval 'sub CS_CODE_SJIS () {0x504;}' unless defined(&CS_CODE_SJIS);
    eval 'sub CS_CNV_SWITCH () {0x1000;}' unless defined(&CS_CNV_SWITCH);
    eval 'sub CS_CNV_OFF () {0x1002;}' unless defined(&CS_CNV_OFF);
    eval 'sub CS_CNV_ON () {0x1003;}' unless defined(&CS_CNV_ON);
    eval 'sub CS_CNV_CONVERT () {0x1004;}' unless defined(&CS_CNV_CONVERT);
    eval 'sub CS_CNV_HENKAN () { &CS_CNV_CONVERT;}' unless defined(&CS_CNV_HENKAN);
    eval 'sub CS_CONVERT () { &CS_CNV_CONVERT;}' unless defined(&CS_CONVERT);
    eval 'sub CS_HENKAN () { &CS_CONVERT;}' unless defined(&CS_HENKAN);
    eval 'sub CS_CNV_NEXT () {0x1005;}' unless defined(&CS_CNV_NEXT);
    eval 'sub CS_CNV_PREV () {0x1006;}' unless defined(&CS_CNV_PREV);
    eval 'sub CS_TO_HIRAGANA () {0x1007;}' unless defined(&CS_TO_HIRAGANA);
    eval 'sub CS_TO_ZENKANA () {0x1008;}' unless defined(&CS_TO_ZENKANA);
    eval 'sub CS_TO_ZENALPHA () {0x1009;}' unless defined(&CS_TO_ZENALPHA);
    eval 'sub CS_TO_HANKANA () {0x100a;}' unless defined(&CS_TO_HANKANA);
    eval 'sub CS_TO_HANALPHA () {0x100b;}' unless defined(&CS_TO_HANALPHA);
    eval 'sub CS_TO_ZENKAKU () {0x100c;}' unless defined(&CS_TO_ZENKAKU);
    eval 'sub CS_TO_HANKAKU () {0x100d;}' unless defined(&CS_TO_HANKAKU);
    eval 'sub CS_FOCUS_HEAD () {0x1010;}' unless defined(&CS_FOCUS_HEAD);
    eval 'sub CS_FOCUS_TAIL () {0x1011;}' unless defined(&CS_FOCUS_TAIL);
    eval 'sub CS_FOCUS_NEXT () {0x1012;}' unless defined(&CS_FOCUS_NEXT);
    eval 'sub CS_FOCUS_PREV () {0x1013;}' unless defined(&CS_FOCUS_PREV);
    eval 'sub CS_FOCUS_LONG () {0x1020;}' unless defined(&CS_FOCUS_LONG);
    eval 'sub CS_FOCUS_SHORT () {0x1021;}' unless defined(&CS_FOCUS_SHORT);
    eval 'sub CS_FOCUS_NLONG () {0x1022;}' unless defined(&CS_FOCUS_NLONG);
    eval 'sub CS_FOCUS_NSHORT () {0x1023;}' unless defined(&CS_FOCUS_NSHORT);
    eval 'sub CS_COMMIT_PART () {0x1030;}' unless defined(&CS_COMMIT_PART);
    eval 'sub CS_KAKUTEI_BUBUN () { &CS_COMMIT_PART;}' unless defined(&CS_KAKUTEI_BUBUN);
    eval 'sub CS_COMMIT_ALL () {0x1040;}' unless defined(&CS_COMMIT_ALL);
    eval 'sub CS_KAKUTEI_ALL () { &CS_COMMIT_ALL;}' unless defined(&CS_KAKUTEI_ALL);
    eval 'sub CS_COMMIT () { &CS_COMMIT_ALL;}' unless defined(&CS_COMMIT);
    eval 'sub CS_KAKUTEI () { &CS_COMMIT;}' unless defined(&CS_KAKUTEI);
    eval 'sub CS_SELECT () {0x1100;}' unless defined(&CS_SELECT);
    eval 'sub CS_SENTAKU () { &CS_SELECT;}' unless defined(&CS_SENTAKU);
    eval 'sub CS_CNV_CANCEL () {0x1200;}' unless defined(&CS_CNV_CANCEL);
    eval 'sub CS_HENKAN_CANCEL () { &CS_CNV_CANCEL;}' unless defined(&CS_HENKAN_CANCEL);
    eval 'sub CS_CURSOR_HEAD () {0x1201;}' unless defined(&CS_CURSOR_HEAD);
    eval 'sub CS_CURSOR_TAIL () {0x1202;}' unless defined(&CS_CURSOR_TAIL);
    eval 'sub CS_CURSOR_RIGHT () {0x1203;}' unless defined(&CS_CURSOR_RIGHT);
    eval 'sub CS_CURSOR_LEFT () {0x1204;}' unless defined(&CS_CURSOR_LEFT);
    eval 'sub CS_ERASE_LCHAR () {0x1205;}' unless defined(&CS_ERASE_LCHAR);
    eval 'sub CS_ERASE_CHAR () {0x1206;}' unless defined(&CS_ERASE_CHAR);
    eval 'sub CS_ERASE_EOL () {0x1207;}' unless defined(&CS_ERASE_EOL);
    eval 'sub CS_ERASE_ALL () {0x1208;}' unless defined(&CS_ERASE_ALL);
    eval 'sub CS_MENU_IM () {0x1301;}' unless defined(&CS_MENU_IM);
    eval 'sub CS_MENU_CM () {0x1302;}' unless defined(&CS_MENU_CM);
    eval 'sub CS_MENU_CIM () {0x1303;}' unless defined(&CS_MENU_CIM);
    eval 'sub CS_MENU_XIM () {0x1304;}' unless defined(&CS_MENU_XIM);
    eval 'sub CS_MENU_CODE () {0x1305;}' unless defined(&CS_MENU_CODE);
    eval 'sub CS_MENU_DICT () {0x1306;}' unless defined(&CS_MENU_DICT);
    eval 'sub CS_MENU_CS () {0x1307;}' unless defined(&CS_MENU_CS);
    eval 'sub CS_SELECT_NEXT () {0x1310;}' unless defined(&CS_SELECT_NEXT);
    eval 'sub CS_SELECT_PREV () {0x1311;}' unless defined(&CS_SELECT_PREV);
    eval 'sub CS_SELECT_NUMBER () {0x1320;}' unless defined(&CS_SELECT_NUMBER);
    eval 'sub CS_SELECT_HEAD () {0x1330;}' unless defined(&CS_SELECT_HEAD);
    eval 'sub CS_SELECT_TAIL () {0x1331;}' unless defined(&CS_SELECT_TAIL);
    eval 'sub CS_SELECT_RIGHT () {0x1332;}' unless defined(&CS_SELECT_RIGHT);
    eval 'sub CS_SELECT_LEFT () {0x1333;}' unless defined(&CS_SELECT_LEFT);
    eval 'sub CS_SELECT_UP () {0x1334;}' unless defined(&CS_SELECT_UP);
    eval 'sub CS_SELECT_DOWN () {0x1335;}' unless defined(&CS_SELECT_DOWN);
    eval 'sub CS_SELECT_DONE () {0x1340;}' unless defined(&CS_SELECT_DONE);
    eval 'sub CS_SELECT_UNDO () {0x1341;}' unless defined(&CS_SELECT_UNDO);
    eval 'sub CS_CS_SWITCH () {0x1400;}' unless defined(&CS_CS_SWITCH);
    eval 'sub CS_RESET_CS () {0x7f00;}' unless defined(&CS_RESET_CS);
    eval 'sub CS_ONLINE_HELP () {0x7f01;}' unless defined(&CS_ONLINE_HELP);
    eval 'sub CS_UPDATE_DICT () {0x7f02;}' unless defined(&CS_UPDATE_DICT);
    eval 'sub CS_MISC_FIELD_TOP () {0x7f10;}' unless defined(&CS_MISC_FIELD_TOP);
    eval 'sub CS_MISC_FIELD_LAST () {0x7f11;}' unless defined(&CS_MISC_FIELD_LAST);
    eval 'sub CS_MISC_FIELD_NEXT () {0x7f12;}' unless defined(&CS_MISC_FIELD_NEXT);
    eval 'sub CS_MISC_FIELD_PREV () {0x7f13;}' unless defined(&CS_MISC_FIELD_PREV);
}
1;
