require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PPP_DEFS_H_)) {
    eval 'sub _PPP_DEFS_H_ () {1;}' unless defined(&_PPP_DEFS_H_);
    if(defined(&__cplusplus)) {
    }
    eval 'sub PPP_HDRLEN () {4;}' unless defined(&PPP_HDRLEN);
    eval 'sub PPP_FCSLEN () {2;}' unless defined(&PPP_FCSLEN);
    eval 'sub PPP_FCS32LEN () {4;}' unless defined(&PPP_FCS32LEN);
    eval 'sub PPP_MAX_MUX_LEN () {127;}' unless defined(&PPP_MAX_MUX_LEN);
    eval 'sub PFF () {0x80;}' unless defined(&PFF);
    eval 'sub PPP_MTU () {1500;}' unless defined(&PPP_MTU);
    eval 'sub PPP_MAXMTU () {65535- ( &PPP_HDRLEN +  &PPP_FCSLEN);}' unless defined(&PPP_MAXMTU);
    eval 'sub PPP_MINMTU () {64;}' unless defined(&PPP_MINMTU);
    eval 'sub PPP_MRU () {1500;}' unless defined(&PPP_MRU);
    eval 'sub PPP_MAXMRU () {65000;}' unless defined(&PPP_MAXMRU);
    eval 'sub PPP_MINMRU () {128;}' unless defined(&PPP_MINMRU);
    eval 'sub PPP_ADDRESS {
        my($p) = @_;
	    eval q(((( &uchar_t *)($p))[0]));
    }' unless defined(&PPP_ADDRESS);
    eval 'sub PPP_CONTROL {
        my($p) = @_;
	    eval q(((( &uchar_t *)($p))[1]));
    }' unless defined(&PPP_CONTROL);
    eval 'sub PPP_PROTOCOL {
        my($p) = @_;
	    eval q((((( &uchar_t *)($p))[2] << 8) + (( &uchar_t *)($p))[3]));
    }' unless defined(&PPP_PROTOCOL);
    eval 'sub PPP_ALLSTATIONS () {0xff;}' unless defined(&PPP_ALLSTATIONS);
    eval 'sub PPP_UI () {0x3;}' unless defined(&PPP_UI);
    eval 'sub PPP_FLAG () {0x7e;}' unless defined(&PPP_FLAG);
    eval 'sub PPP_ESCAPE () {0x7d;}' unless defined(&PPP_ESCAPE);
    eval 'sub PPP_TRANS () {0x20;}' unless defined(&PPP_TRANS);
    eval 'sub PPP_IP () {0x21;}' unless defined(&PPP_IP);
    eval 'sub PPP_OSI () {0x23;}' unless defined(&PPP_OSI);
    eval 'sub PPP_AT () {0x29;}' unless defined(&PPP_AT);
    eval 'sub PPP_IPX () {0x2b;}' unless defined(&PPP_IPX);
    eval 'sub PPP_VJC_COMP () {0x2d;}' unless defined(&PPP_VJC_COMP);
    eval 'sub PPP_VJC_UNCOMP () {0x2f;}' unless defined(&PPP_VJC_UNCOMP);
    eval 'sub PPP_BRIDGE () {0x31;}' unless defined(&PPP_BRIDGE);
    eval 'sub PPP_MP () {0x3d;}' unless defined(&PPP_MP);
    eval 'sub PPP_ENCRYPT () {0x53;}' unless defined(&PPP_ENCRYPT);
    eval 'sub PPP_ENCRYPTFRAG () {0x55;}' unless defined(&PPP_ENCRYPTFRAG);
    eval 'sub PPP_IPV6 () {0x57;}' unless defined(&PPP_IPV6);
    eval 'sub PPP_MUX () {0x59;}' unless defined(&PPP_MUX);
    eval 'sub PPP_FULLHDR () {0x61;}' unless defined(&PPP_FULLHDR);
    eval 'sub PPP_COMPTCP () {0x63;}' unless defined(&PPP_COMPTCP);
    eval 'sub PPP_COMPNONTCP () {0x65;}' unless defined(&PPP_COMPNONTCP);
    eval 'sub PPP_COMPUDP8 () {0x67;}' unless defined(&PPP_COMPUDP8);
    eval 'sub PPP_COMPRTP8 () {0x69;}' unless defined(&PPP_COMPRTP8);
    eval 'sub PPP_COMPFRAG () {0xfb;}' unless defined(&PPP_COMPFRAG);
    eval 'sub PPP_COMP () {0xfd;}' unless defined(&PPP_COMP);
    eval 'sub PPP_802HELLO () {0x201;}' unless defined(&PPP_802HELLO);
    eval 'sub PPP_MPLS () {0x281;}' unless defined(&PPP_MPLS);
    eval 'sub PPP_MPLSMC () {0x283;}' unless defined(&PPP_MPLSMC);
    eval 'sub PPP_COMPTCPND () {0x2063;}' unless defined(&PPP_COMPTCPND);
    eval 'sub PPP_COMPSTATE () {0x2065;}' unless defined(&PPP_COMPSTATE);
    eval 'sub PPP_COMPUDP16 () {0x2067;}' unless defined(&PPP_COMPUDP16);
    eval 'sub PPP_COMPRTP16 () {0x2069;}' unless defined(&PPP_COMPRTP16);
    eval 'sub PPP_IPCP () {0x8021;}' unless defined(&PPP_IPCP);
    eval 'sub PPP_OSINLCP () {0x8023;}' unless defined(&PPP_OSINLCP);
    eval 'sub PPP_ATCP () {0x8029;}' unless defined(&PPP_ATCP);
    eval 'sub PPP_IPXCP () {0x802b;}' unless defined(&PPP_IPXCP);
    eval 'sub PPP_BCP () {0x8031;}' unless defined(&PPP_BCP);
    eval 'sub PPP_ECP () {0x8053;}' unless defined(&PPP_ECP);
    eval 'sub PPP_ECPFRAG () {0x8055;}' unless defined(&PPP_ECPFRAG);
    eval 'sub PPP_IPV6CP () {0x8057;}' unless defined(&PPP_IPV6CP);
    eval 'sub PPP_MUXCP () {0x8059;}' unless defined(&PPP_MUXCP);
    eval 'sub PPP_CCPFRAG () {0x80fb;}' unless defined(&PPP_CCPFRAG);
    eval 'sub PPP_CCP () {0x80fd;}' unless defined(&PPP_CCP);
    eval 'sub PPP_MPLSCP () {0x8281;}' unless defined(&PPP_MPLSCP);
    eval 'sub PPP_LCP () {0xc021;}' unless defined(&PPP_LCP);
    eval 'sub PPP_PAP () {0xc023;}' unless defined(&PPP_PAP);
    eval 'sub PPP_LQR () {0xc025;}' unless defined(&PPP_LQR);
    eval 'sub PPP_BACP () {0xc02b;}' unless defined(&PPP_BACP);
    eval 'sub PPP_BAP () {0xc02d;}' unless defined(&PPP_BAP);
    eval 'sub PPP_CBCP () {0xc029;}' unless defined(&PPP_CBCP);
    eval 'sub PPP_CHAP () {0xc223;}' unless defined(&PPP_CHAP);
    eval 'sub PPP_EAP () {0xc227;}' unless defined(&PPP_EAP);
    eval 'sub PPP_INITFCS () {0xffff;}' unless defined(&PPP_INITFCS);
    eval 'sub PPP_GOODFCS () {0xf0b8;}' unless defined(&PPP_GOODFCS);
    eval 'sub PPP_FCS {
        my($fcs, $c) = @_;
	    eval q(((($fcs) >> 8) ^  $fcstab[(($fcs) ^ ($c)) & 0xff]));
    }' unless defined(&PPP_FCS);
    eval 'sub PPPINITFCS16 () { &PPP_INITFCS;}' unless defined(&PPPINITFCS16);
    eval 'sub PPPGOODFCS16 () { &PPP_GOODFCS;}' unless defined(&PPPGOODFCS16);
    eval 'sub PPPFCS16 {
        my($fcs, $c) = @_;
	    eval q( &PPP_FCS(($fcs), ($c)));
    }' unless defined(&PPPFCS16);
    eval 'sub PPPINITFCS32 () {0xffffffff;}' unless defined(&PPPINITFCS32);
    eval 'sub PPPGOODFCS32 () {0xdebb20e3;}' unless defined(&PPPGOODFCS32);
    eval 'sub PPPFCS32 {
        my($fcs, $c) = @_;
	    eval q(((($fcs) >> 8) ^  $fcstab_32[(($fcs) ^ ($c)) & 0xff]));
    }' unless defined(&PPPFCS32);
    eval 'sub RECMARK_STARTSEND () {1;}' unless defined(&RECMARK_STARTSEND);
    eval 'sub RECMARK_STARTRECV () {2;}' unless defined(&RECMARK_STARTRECV);
    eval 'sub RECMARK_ENDSEND () {3;}' unless defined(&RECMARK_ENDSEND);
    eval 'sub RECMARK_ENDRECV () {4;}' unless defined(&RECMARK_ENDRECV);
    eval 'sub RECMARK_TIMEDELTA32 () {5;}' unless defined(&RECMARK_TIMEDELTA32);
    eval 'sub RECMARK_TIMEDELTA8 () {6;}' unless defined(&RECMARK_TIMEDELTA8);
    eval 'sub RECMARK_TIMESTART () {7;}' unless defined(&RECMARK_TIMESTART);
    if(!defined( &__BIT_TYPES_DEFINED__)  && !defined( &_BITYPES)  && !defined( &__FreeBSD__)  && ((defined(&NS_TARGET) ? &NS_TARGET : 0) < 40)) {
	if(defined(&UINT32_T)) {
	} else {
	}
    }
    if(defined( &sun)  && !defined( &_SYS_INT_TYPES_H)  && !defined( &_UINT32_T)) {
	eval 'sub _UINT32_T () {1;}' unless defined(&_UINT32_T);
    }
    eval("sub NPMODE_PASS () { 0; }") unless defined(&NPMODE_PASS);
    eval("sub NPMODE_DROP () { 1; }") unless defined(&NPMODE_DROP);
    eval("sub NPMODE_ERROR () { 2; }") unless defined(&NPMODE_ERROR);
    eval("sub NPMODE_QUEUE () { 3; }") unless defined(&NPMODE_QUEUE);
    eval("sub PPP_LINKSTAT_HANGUP () { 0xabcd; }") unless defined(&PPP_LINKSTAT_HANGUP);
    eval("sub PPP_LINKSTAT_NEEDUP () { 1; }") unless defined(&PPP_LINKSTAT_NEEDUP);
    eval("sub PPP_LINKSTAT_IPV4_UNBOUND () { 2; }") unless defined(&PPP_LINKSTAT_IPV4_UNBOUND);
    eval("sub PPP_LINKSTAT_IPV6_UNBOUND () { 3; }") unless defined(&PPP_LINKSTAT_IPV6_UNBOUND);
    eval("sub PPP_LINKSTAT_IPV4_BOUND () { 4; }") unless defined(&PPP_LINKSTAT_IPV4_BOUND);
    eval("sub PPP_LINKSTAT_IPV6_BOUND () { 5; }") unless defined(&PPP_LINKSTAT_IPV6_BOUND);
    eval("sub PPP_LINKSTAT_UP () { 6; }") unless defined(&PPP_LINKSTAT_UP);
    eval 'sub PPPLSMAGIC () {0x53505050;}' unless defined(&PPPLSMAGIC);
    unless(defined(&__P)) {
	if(defined(&__STDC__)) {
	    eval 'sub __P {
	        my($x) = @_;
    		eval q($x);
	    }' unless defined(&__P);
	} else {
	    eval 'sub __P {
	        my($x) = @_;
    		eval q(());
	    }' unless defined(&__P);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
