require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_DHCP_H)) {
    eval 'sub _DHCP_H () {1;}' unless defined(&_DHCP_H);
    if(defined(&__cplusplus)) {
    }
    if(defined( &_KERNEL)  && defined( &DHCP_CLIENT)) {
	require 'sys/dhcpboot.ph';
    }
    if(defined(&_REENTRANT)) {
	require 'thread.ph';
    }
    eval 'sub CD_PAD () {0;}' unless defined(&CD_PAD);
    eval 'sub CD_END () {255;}' unless defined(&CD_END);
    eval 'sub CD_SUBNETMASK () {1;}' unless defined(&CD_SUBNETMASK);
    eval 'sub CD_TIMEOFFSET () {2;}' unless defined(&CD_TIMEOFFSET);
    eval 'sub CD_ROUTER () {3;}' unless defined(&CD_ROUTER);
    eval 'sub CD_TIMESERV () {4;}' unless defined(&CD_TIMESERV);
    eval 'sub CD_IEN116_NAME_SERV () {5;}' unless defined(&CD_IEN116_NAME_SERV);
    eval 'sub CD_DNSSERV () {6;}' unless defined(&CD_DNSSERV);
    eval 'sub CD_LOG_SERV () {7;}' unless defined(&CD_LOG_SERV);
    eval 'sub CD_COOKIE_SERV () {8;}' unless defined(&CD_COOKIE_SERV);
    eval 'sub CD_LPR_SERV () {9;}' unless defined(&CD_LPR_SERV);
    eval 'sub CD_IMPRESS_SERV () {10;}' unless defined(&CD_IMPRESS_SERV);
    eval 'sub CD_RESOURCE_SERV () {11;}' unless defined(&CD_RESOURCE_SERV);
    eval 'sub CD_HOSTNAME () {12;}' unless defined(&CD_HOSTNAME);
    eval 'sub CD_BOOT_SIZE () {13;}' unless defined(&CD_BOOT_SIZE);
    eval 'sub CD_DUMP_FILE () {14;}' unless defined(&CD_DUMP_FILE);
    eval 'sub CD_DNSDOMAIN () {15;}' unless defined(&CD_DNSDOMAIN);
    eval 'sub CD_SWAP_SERV () {16;}' unless defined(&CD_SWAP_SERV);
    eval 'sub CD_ROOT_PATH () {17;}' unless defined(&CD_ROOT_PATH);
    eval 'sub CD_EXTEND_PATH () {18;}' unless defined(&CD_EXTEND_PATH);
    eval 'sub CD_IP_FORWARDING_ON () {19;}' unless defined(&CD_IP_FORWARDING_ON);
    eval 'sub CD_NON_LCL_ROUTE_ON () {20;}' unless defined(&CD_NON_LCL_ROUTE_ON);
    eval 'sub CD_POLICY_FILTER () {21;}' unless defined(&CD_POLICY_FILTER);
    eval 'sub CD_MAXIPSIZE () {22;}' unless defined(&CD_MAXIPSIZE);
    eval 'sub CD_IPTTL () {23;}' unless defined(&CD_IPTTL);
    eval 'sub CD_PATH_MTU_TIMEOUT () {24;}' unless defined(&CD_PATH_MTU_TIMEOUT);
    eval 'sub CD_PATH_MTU_TABLE_SZ () {25;}' unless defined(&CD_PATH_MTU_TABLE_SZ);
    eval 'sub CD_MTU () {26;}' unless defined(&CD_MTU);
    eval 'sub CD_ALL_SUBNETS_LCL_ON () {27;}' unless defined(&CD_ALL_SUBNETS_LCL_ON);
    eval 'sub CD_BROADCASTADDR () {28;}' unless defined(&CD_BROADCASTADDR);
    eval 'sub CD_MASK_DISCVRY_ON () {29;}' unless defined(&CD_MASK_DISCVRY_ON);
    eval 'sub CD_MASK_SUPPLIER_ON () {30;}' unless defined(&CD_MASK_SUPPLIER_ON);
    eval 'sub CD_ROUTER_DISCVRY_ON () {31;}' unless defined(&CD_ROUTER_DISCVRY_ON);
    eval 'sub CD_ROUTER_SOLICIT_SERV () {32;}' unless defined(&CD_ROUTER_SOLICIT_SERV);
    eval 'sub CD_STATIC_ROUTE () {33;}' unless defined(&CD_STATIC_ROUTE);
    eval 'sub CD_TRAILER_ENCAPS_ON () {34;}' unless defined(&CD_TRAILER_ENCAPS_ON);
    eval 'sub CD_ARP_TIMEOUT () {35;}' unless defined(&CD_ARP_TIMEOUT);
    eval 'sub CD_ETHERNET_ENCAPS_ON () {36;}' unless defined(&CD_ETHERNET_ENCAPS_ON);
    eval 'sub CD_TCP_TTL () {37;}' unless defined(&CD_TCP_TTL);
    eval 'sub CD_TCP_KALIVE_INTVL () {38;}' unless defined(&CD_TCP_KALIVE_INTVL);
    eval 'sub CD_TCP_KALIVE_GRBG_ON () {39;}' unless defined(&CD_TCP_KALIVE_GRBG_ON);
    eval 'sub CD_NIS_DOMAIN () {40;}' unless defined(&CD_NIS_DOMAIN);
    eval 'sub CD_NIS_SERV () {41;}' unless defined(&CD_NIS_SERV);
    eval 'sub CD_NTP_SERV () {42;}' unless defined(&CD_NTP_SERV);
    eval 'sub CD_VENDOR_SPEC () {43;}' unless defined(&CD_VENDOR_SPEC);
    eval 'sub CD_NETBIOS_NAME_SERV () {44;}' unless defined(&CD_NETBIOS_NAME_SERV);
    eval 'sub CD_NETBIOS_DIST_SERV () {45;}' unless defined(&CD_NETBIOS_DIST_SERV);
    eval 'sub CD_NETBIOS_NODE_TYPE () {46;}' unless defined(&CD_NETBIOS_NODE_TYPE);
    eval 'sub CD_NETBIOS_SCOPE () {47;}' unless defined(&CD_NETBIOS_SCOPE);
    eval 'sub CD_XWIN_FONT_SERV () {48;}' unless defined(&CD_XWIN_FONT_SERV);
    eval 'sub CD_XWIN_DISP_SERV () {49;}' unless defined(&CD_XWIN_DISP_SERV);
    eval 'sub CD_REQUESTED_IP_ADDR () {50;}' unless defined(&CD_REQUESTED_IP_ADDR);
    eval 'sub CD_LEASE_TIME () {51;}' unless defined(&CD_LEASE_TIME);
    eval 'sub CD_OPTION_OVERLOAD () {52;}' unless defined(&CD_OPTION_OVERLOAD);
    eval 'sub CD_DHCP_TYPE () {53;}' unless defined(&CD_DHCP_TYPE);
    eval 'sub CD_SERVER_ID () {54;}' unless defined(&CD_SERVER_ID);
    eval 'sub CD_REQUEST_LIST () {55;}' unless defined(&CD_REQUEST_LIST);
    eval 'sub CD_MESSAGE () {56;}' unless defined(&CD_MESSAGE);
    eval 'sub CD_MAX_DHCP_SIZE () {57;}' unless defined(&CD_MAX_DHCP_SIZE);
    eval 'sub CD_T1_TIME () {58;}' unless defined(&CD_T1_TIME);
    eval 'sub CD_T2_TIME () {59;}' unless defined(&CD_T2_TIME);
    eval 'sub CD_CLASS_ID () {60;}' unless defined(&CD_CLASS_ID);
    eval 'sub CD_CLIENT_ID () {61;}' unless defined(&CD_CLIENT_ID);
    eval 'sub CD_NW_IP_DOMAIN () {62;}' unless defined(&CD_NW_IP_DOMAIN);
    eval 'sub CD_NW_IP_OPTIONS () {63;}' unless defined(&CD_NW_IP_OPTIONS);
    eval 'sub CD_NISPLUS_DMAIN () {64;}' unless defined(&CD_NISPLUS_DMAIN);
    eval 'sub CD_NISPLUS_SERVS () {65;}' unless defined(&CD_NISPLUS_SERVS);
    eval 'sub CD_TFTP_SERV_NAME () {66;}' unless defined(&CD_TFTP_SERV_NAME);
    eval 'sub CD_OPT_BOOTFILE_NAME () {67;}' unless defined(&CD_OPT_BOOTFILE_NAME);
    eval 'sub CD_MOBILE_IP_AGENT () {68;}' unless defined(&CD_MOBILE_IP_AGENT);
    eval 'sub CD_SMTP_SERVS () {69;}' unless defined(&CD_SMTP_SERVS);
    eval 'sub CD_POP3_SERVS () {70;}' unless defined(&CD_POP3_SERVS);
    eval 'sub CD_NNTP_SERVS () {71;}' unless defined(&CD_NNTP_SERVS);
    eval 'sub CD_WWW_SERVS () {72;}' unless defined(&CD_WWW_SERVS);
    eval 'sub CD_FINGER_SERVS () {73;}' unless defined(&CD_FINGER_SERVS);
    eval 'sub CD_IRC_SERVS () {74;}' unless defined(&CD_IRC_SERVS);
    eval 'sub CD_STREETTALK_SERVS () {75;}' unless defined(&CD_STREETTALK_SERVS);
    eval 'sub CD_STREETTALK_DA_SERVS () {76;}' unless defined(&CD_STREETTALK_DA_SERVS);
    eval 'sub CD_USER_CLASS_ID () {77;}' unless defined(&CD_USER_CLASS_ID);
    eval 'sub CD_SLPDA () {78;}' unless defined(&CD_SLPDA);
    eval 'sub CD_SLPSS () {79;}' unless defined(&CD_SLPSS);
    eval 'sub CD_AGENTOPT () {82;}' unless defined(&CD_AGENTOPT);
    eval 'sub CD_FQDN () {89;}' unless defined(&CD_FQDN);
    eval 'sub CD_PXEARCHi () {93;}' unless defined(&CD_PXEARCHi);
    eval 'sub CD_PXENIIi () {94;}' unless defined(&CD_PXENIIi);
    eval 'sub CD_PXECID () {95;}' unless defined(&CD_PXECID);
    eval 'sub CD_MULTICST () {107;}' unless defined(&CD_MULTICST);
    eval 'sub DHCP_FIRST_OPT () { &CD_SUBNETMASK;}' unless defined(&DHCP_FIRST_OPT);
    eval 'sub DHCP_LAST_STD () { &CD_MULTICST;}' unless defined(&DHCP_LAST_STD);
    eval 'sub DHCP_SITE_OPT () {128;}' unless defined(&DHCP_SITE_OPT);
    eval 'sub DHCP_END_SITE () {254;}' unless defined(&DHCP_END_SITE);
    eval 'sub DHCP_LAST_OPT () { &DHCP_END_SITE;}' unless defined(&DHCP_LAST_OPT);
    eval 'sub DHCP_MAX_OPT_SIZE () {255;}' unless defined(&DHCP_MAX_OPT_SIZE);
    eval 'sub DHCP_DEF_MAX_SIZE () {576;}' unless defined(&DHCP_DEF_MAX_SIZE);
    eval 'sub PKT_BUFFER () {1486;}' unless defined(&PKT_BUFFER);
    eval 'sub BASE_PKT_SIZE () {240;}' unless defined(&BASE_PKT_SIZE);
    eval 'sub DISCOVER () {(( &uint8_t)1);}' unless defined(&DISCOVER);
    eval 'sub OFFER () {(( &uint8_t)2);}' unless defined(&OFFER);
    eval 'sub REQUEST () {(( &uint8_t)3);}' unless defined(&REQUEST);
    eval 'sub DECLINE () {(( &uint8_t)4);}' unless defined(&DECLINE);
    eval 'sub ACK () {(( &uint8_t)5);}' unless defined(&ACK);
    eval 'sub NAK () {(( &uint8_t)6);}' unless defined(&NAK);
    eval 'sub RELEASE () {(( &uint8_t)7);}' unless defined(&RELEASE);
    eval 'sub INFORM () {(( &uint8_t)8);}' unless defined(&INFORM);
    eval 'sub DHCP_PERM () {(( &lease_t)0xffffffff);}' unless defined(&DHCP_PERM);
    eval 'sub BOOTREQUEST () {(1);}' unless defined(&BOOTREQUEST);
    eval 'sub BOOTREPLY () {(2);}' unless defined(&BOOTREPLY);
    eval 'sub BOOTMAGIC () {{ 99, 130, 83, 99};}' unless defined(&BOOTMAGIC);
    if(defined(&__cplusplus)) {
    }
}
1;
