require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IN_H)) {
    eval 'sub _NETINET_IN_H () {1;}' unless defined(&_NETINET_IN_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	require 'sys/stream.ph';
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__) || defined( &_XPG5)) {
	require 'sys/byteorder.ph';
    }
    unless(defined(&_IN_PORT_T)) {
	eval 'sub _IN_PORT_T () {1;}' unless defined(&_IN_PORT_T);
    }
    unless(defined(&_IN_ADDR_T)) {
	eval 'sub _IN_ADDR_T () {1;}' unless defined(&_IN_ADDR_T);
    }
    unless(defined(&_IPADDR_T)) {
	eval 'sub _IPADDR_T () {1;}' unless defined(&_IPADDR_T);
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	if(defined(&_KERNEL)) {
	} else {
	}
	eval 'sub s6_addr () { ($_S6_un->{_S6_u8});}' unless defined(&s6_addr);
	if(defined(&_KERNEL)) {
	    eval 'sub s6_addr8 () { ($_S6_un->{_S6_u8});}' unless defined(&s6_addr8);
	    eval 'sub s6_addr32 () { ($_S6_un->{_S6_u32});}' unless defined(&s6_addr32);
	}
    }
    unless(defined(&_SA_FAMILY_T)) {
	eval 'sub _SA_FAMILY_T () {1;}' unless defined(&_SA_FAMILY_T);
    }
    eval 'sub IPPROTO_IP () {0;}' unless defined(&IPPROTO_IP);
    eval 'sub IPPROTO_HOPOPTS () {0;}' unless defined(&IPPROTO_HOPOPTS);
    eval 'sub IPPROTO_ICMP () {1;}' unless defined(&IPPROTO_ICMP);
    eval 'sub IPPROTO_IGMP () {2;}' unless defined(&IPPROTO_IGMP);
    eval 'sub IPPROTO_GGP () {3;}' unless defined(&IPPROTO_GGP);
    eval 'sub IPPROTO_ENCAP () {4;}' unless defined(&IPPROTO_ENCAP);
    eval 'sub IPPROTO_TCP () {6;}' unless defined(&IPPROTO_TCP);
    eval 'sub IPPROTO_EGP () {8;}' unless defined(&IPPROTO_EGP);
    eval 'sub IPPROTO_PUP () {12;}' unless defined(&IPPROTO_PUP);
    eval 'sub IPPROTO_UDP () {17;}' unless defined(&IPPROTO_UDP);
    eval 'sub IPPROTO_IDP () {22;}' unless defined(&IPPROTO_IDP);
    eval 'sub IPPROTO_IPV6 () {41;}' unless defined(&IPPROTO_IPV6);
    eval 'sub IPPROTO_ROUTING () {43;}' unless defined(&IPPROTO_ROUTING);
    eval 'sub IPPROTO_FRAGMENT () {44;}' unless defined(&IPPROTO_FRAGMENT);
    eval 'sub IPPROTO_RSVP () {46;}' unless defined(&IPPROTO_RSVP);
    eval 'sub IPPROTO_ESP () {50;}' unless defined(&IPPROTO_ESP);
    eval 'sub IPPROTO_AH () {51;}' unless defined(&IPPROTO_AH);
    eval 'sub IPPROTO_ICMPV6 () {58;}' unless defined(&IPPROTO_ICMPV6);
    eval 'sub IPPROTO_NONE () {59;}' unless defined(&IPPROTO_NONE);
    eval 'sub IPPROTO_DSTOPTS () {60;}' unless defined(&IPPROTO_DSTOPTS);
    eval 'sub IPPROTO_HELLO () {63;}' unless defined(&IPPROTO_HELLO);
    eval 'sub IPPROTO_ND () {77;}' unless defined(&IPPROTO_ND);
    eval 'sub IPPROTO_EON () {80;}' unless defined(&IPPROTO_EON);
    eval 'sub IPPROTO_PIM () {103;}' unless defined(&IPPROTO_PIM);
    eval 'sub IPPROTO_RAW () {255;}' unless defined(&IPPROTO_RAW);
    eval 'sub IPPROTO_MAX () {256;}' unless defined(&IPPROTO_MAX);
    eval 'sub IPPORT_ECHO () {7;}' unless defined(&IPPORT_ECHO);
    eval 'sub IPPORT_DISCARD () {9;}' unless defined(&IPPORT_DISCARD);
    eval 'sub IPPORT_SYSTAT () {11;}' unless defined(&IPPORT_SYSTAT);
    eval 'sub IPPORT_DAYTIME () {13;}' unless defined(&IPPORT_DAYTIME);
    eval 'sub IPPORT_NETSTAT () {15;}' unless defined(&IPPORT_NETSTAT);
    eval 'sub IPPORT_FTP () {21;}' unless defined(&IPPORT_FTP);
    eval 'sub IPPORT_TELNET () {23;}' unless defined(&IPPORT_TELNET);
    eval 'sub IPPORT_SMTP () {25;}' unless defined(&IPPORT_SMTP);
    eval 'sub IPPORT_TIMESERVER () {37;}' unless defined(&IPPORT_TIMESERVER);
    eval 'sub IPPORT_NAMESERVER () {42;}' unless defined(&IPPORT_NAMESERVER);
    eval 'sub IPPORT_WHOIS () {43;}' unless defined(&IPPORT_WHOIS);
    eval 'sub IPPORT_MTP () {57;}' unless defined(&IPPORT_MTP);
    eval 'sub IPPORT_BOOTPS () {67;}' unless defined(&IPPORT_BOOTPS);
    eval 'sub IPPORT_BOOTPC () {68;}' unless defined(&IPPORT_BOOTPC);
    eval 'sub IPPORT_TFTP () {69;}' unless defined(&IPPORT_TFTP);
    eval 'sub IPPORT_RJE () {77;}' unless defined(&IPPORT_RJE);
    eval 'sub IPPORT_FINGER () {79;}' unless defined(&IPPORT_FINGER);
    eval 'sub IPPORT_TTYLINK () {87;}' unless defined(&IPPORT_TTYLINK);
    eval 'sub IPPORT_SUPDUP () {95;}' unless defined(&IPPORT_SUPDUP);
    eval 'sub IPPORT_EXECSERVER () {512;}' unless defined(&IPPORT_EXECSERVER);
    eval 'sub IPPORT_LOGINSERVER () {513;}' unless defined(&IPPORT_LOGINSERVER);
    eval 'sub IPPORT_CMDSERVER () {514;}' unless defined(&IPPORT_CMDSERVER);
    eval 'sub IPPORT_EFSSERVER () {520;}' unless defined(&IPPORT_EFSSERVER);
    eval 'sub IPPORT_BIFFUDP () {512;}' unless defined(&IPPORT_BIFFUDP);
    eval 'sub IPPORT_WHOSERVER () {513;}' unless defined(&IPPORT_WHOSERVER);
    eval 'sub IPPORT_ROUTESERVER () {520;}' unless defined(&IPPORT_ROUTESERVER);
    eval 'sub IPPORT_RESERVED () {1024;}' unless defined(&IPPORT_RESERVED);
    eval 'sub IPPORT_USERRESERVED () {5000;}' unless defined(&IPPORT_USERRESERVED);
    eval 'sub IMPLINK_IP () {155;}' unless defined(&IMPLINK_IP);
    eval 'sub IMPLINK_LOWEXPER () {156;}' unless defined(&IMPLINK_LOWEXPER);
    eval 'sub IMPLINK_HIGHEXPER () {158;}' unless defined(&IMPLINK_HIGHEXPER);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub _S_un_b () { &S_un_b;}' unless defined(&_S_un_b);
	eval 'sub _S_un_w () { &S_un_w;}' unless defined(&_S_un_w);
	eval 'sub _S_addr () { &S_addr;}' unless defined(&_S_addr);
	eval 'sub _S_un () { &S_un;}' unless defined(&_S_un);
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
    } else {
    }
    eval 'sub s_addr () { ($_S_un->{_S_addr});}' unless defined(&s_addr);
    eval 'sub s_host () { ($_S_un->{_S_un_b}->{s_b2});}' unless defined(&s_host);
    eval 'sub s_net () { ($_S_un->{_S_un_b}->{s_b1});}' unless defined(&s_net);
    eval 'sub s_imp () { ($_S_un->{_S_un_w}->{s_w2});}' unless defined(&s_imp);
    eval 'sub s_impno () { ($_S_un->{_S_un_b}->{s_b4});}' unless defined(&s_impno);
    eval 'sub s_lh () { ($_S_un->{_S_un_b}->{s_b3});}' unless defined(&s_lh);
    eval 'sub IN_CLASSA {
        my($i) = @_;
	    eval q(((($i) & 0x80000000) == 0));
    }' unless defined(&IN_CLASSA);
    eval 'sub IN_CLASSA_NET () {0xff000000;}' unless defined(&IN_CLASSA_NET);
    eval 'sub IN_CLASSA_NSHIFT () {24;}' unless defined(&IN_CLASSA_NSHIFT);
    eval 'sub IN_CLASSA_HOST () {0xffffff;}' unless defined(&IN_CLASSA_HOST);
    eval 'sub IN_CLASSA_MAX () {128;}' unless defined(&IN_CLASSA_MAX);
    eval 'sub IN_CLASSB {
        my($i) = @_;
	    eval q(((($i) & 0xc0000000) == 0x80000000));
    }' unless defined(&IN_CLASSB);
    eval 'sub IN_CLASSB_NET () {0xffff0000;}' unless defined(&IN_CLASSB_NET);
    eval 'sub IN_CLASSB_NSHIFT () {16;}' unless defined(&IN_CLASSB_NSHIFT);
    eval 'sub IN_CLASSB_HOST () {0xffff;}' unless defined(&IN_CLASSB_HOST);
    eval 'sub IN_CLASSB_MAX () {65536;}' unless defined(&IN_CLASSB_MAX);
    eval 'sub IN_CLASSC {
        my($i) = @_;
	    eval q(((($i) & 0xe0000000) == 0xc0000000));
    }' unless defined(&IN_CLASSC);
    eval 'sub IN_CLASSC_NET () {0xffffff00;}' unless defined(&IN_CLASSC_NET);
    eval 'sub IN_CLASSC_NSHIFT () {8;}' unless defined(&IN_CLASSC_NSHIFT);
    eval 'sub IN_CLASSC_HOST () {0xff;}' unless defined(&IN_CLASSC_HOST);
    eval 'sub IN_CLASSD {
        my($i) = @_;
	    eval q(((($i) & 0xf0000000) == 0xe0000000));
    }' unless defined(&IN_CLASSD);
    eval 'sub IN_CLASSD_NET () {0xf0000000;}' unless defined(&IN_CLASSD_NET);
    eval 'sub IN_CLASSD_NSHIFT () {28;}' unless defined(&IN_CLASSD_NSHIFT);
    eval 'sub IN_CLASSD_HOST () {0xfffffff;}' unless defined(&IN_CLASSD_HOST);
    eval 'sub IN_MULTICAST {
        my($i) = @_;
	    eval q( &IN_CLASSD($i));
    }' unless defined(&IN_MULTICAST);
    eval 'sub IN_EXPERIMENTAL {
        my($i) = @_;
	    eval q(((($i) & 0xe0000000) == 0xe0000000));
    }' unless defined(&IN_EXPERIMENTAL);
    eval 'sub IN_BADCLASS {
        my($i) = @_;
	    eval q(((($i) & 0xf0000000) == 0xf0000000));
    }' unless defined(&IN_BADCLASS);
    eval 'sub INADDR_ANY () {0x;}' unless defined(&INADDR_ANY);
    eval 'sub INADDR_LOOPBACK () {0x7f000001;}' unless defined(&INADDR_LOOPBACK);
    eval 'sub INADDR_BROADCAST () {0xffffffff;}' unless defined(&INADDR_BROADCAST);
    eval 'sub INADDR_UNSPEC_GROUP () {0xe0000000;}' unless defined(&INADDR_UNSPEC_GROUP);
    eval 'sub INADDR_ALLHOSTS_GROUP () {0xe0000001;}' unless defined(&INADDR_ALLHOSTS_GROUP);
    eval 'sub INADDR_ALLRTRS_GROUP () {0xe0000002;}' unless defined(&INADDR_ALLRTRS_GROUP);
    eval 'sub INADDR_MAX_LOCAL_GROUP () {0xe00000ff;}' unless defined(&INADDR_MAX_LOCAL_GROUP);
    eval 'sub IN_LOOPBACKNET () {127;}' unless defined(&IN_LOOPBACKNET);
    if(!defined( &_XPG4_2) || !defined( &__EXTENSIONS__)) {
	eval 'sub IN_SET_LOOPBACK_ADDR {
	    my($a) = @_;
    	    eval q({ ($a)-> ($sin_addr->{s_addr})  =  &htonl( &INADDR_LOOPBACK); ($a)-> &sin_family =  &AF_INET; });
	}' unless defined(&IN_SET_LOOPBACK_ADDR);
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
    } else {
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IPV6_FLOWINFO_FLOWLABEL () {0xfffff;}' unless defined(&IPV6_FLOWINFO_FLOWLABEL);
	    eval 'sub IPV6_FLOWINFO_TCLASS () {0xff00000;}' unless defined(&IPV6_FLOWINFO_TCLASS);
	} else {
	    eval 'sub IPV6_FLOWINFO_FLOWLABEL () {0xffff0f00;}' unless defined(&IPV6_FLOWINFO_FLOWLABEL);
	    eval 'sub IPV6_FLOWINFO_TCLASS () {0xf00f;}' unless defined(&IPV6_FLOWINFO_TCLASS);
	}
	if(defined(&_KERNEL)) {
	    eval 'sub IN6ADDR_ANY_INIT () {{ 0, 0, 0, 0};}' unless defined(&IN6ADDR_ANY_INIT);
	    if(defined(&_BIG_ENDIAN)) {
		eval 'sub IN6ADDR_LOOPBACK_INIT () {{ 0, 0, 0, 0x1 };}' unless defined(&IN6ADDR_LOOPBACK_INIT);
	    } else {
		eval 'sub IN6ADDR_LOOPBACK_INIT () {{ 0, 0, 0, 0x1000000 };}' unless defined(&IN6ADDR_LOOPBACK_INIT);
	    }
	} else {
	    eval 'sub IN6ADDR_ANY_INIT () {{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};}' unless defined(&IN6ADDR_ANY_INIT);
	    eval 'sub IN6ADDR_LOOPBACK_INIT () {{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x1 };}' unless defined(&IN6ADDR_LOOPBACK_INIT);
	}
	eval 'sub IN6_IS_ADDR_UNSPECIFIED {
	    my($addr) = @_;
    	    eval q(((($addr)-> ($_S6_un->{_S6_u32[3]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[2]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[1]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[0]}) == 0)));
	}' unless defined(&IN6_IS_ADDR_UNSPECIFIED);
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_LOOPBACK {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[3]}) == 0x1)  && (($addr)-> ($_S6_un->{_S6_u32[2]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[1]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[0]}) == 0)));
	    }' unless defined(&IN6_IS_ADDR_LOOPBACK);
	} else {
	    eval 'sub IN6_IS_ADDR_LOOPBACK {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[3]}) == 0x1000000)  && (($addr)-> ($_S6_un->{_S6_u32[2]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[1]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[0]}) == 0)));
	    }' unless defined(&IN6_IS_ADDR_LOOPBACK);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_MULTICAST {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xff000000) == 0xff000000));
	    }' unless defined(&IN6_IS_ADDR_MULTICAST);
	} else {
	    eval 'sub IN6_IS_ADDR_MULTICAST {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xff) == 0xff));
	    }' unless defined(&IN6_IS_ADDR_MULTICAST);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_LINKLOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xffc00000) == 0xfe800000));
	    }' unless defined(&IN6_IS_ADDR_LINKLOCAL);
	} else {
	    eval 'sub IN6_IS_ADDR_LINKLOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xc0ff) == 0x80fe));
	    }' unless defined(&IN6_IS_ADDR_LINKLOCAL);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_SITELOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xffc00000) == 0xfec00000));
	    }' unless defined(&IN6_IS_ADDR_SITELOCAL);
	} else {
	    eval 'sub IN6_IS_ADDR_SITELOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xc0ff) == 0xc0fe));
	    }' unless defined(&IN6_IS_ADDR_SITELOCAL);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_V4MAPPED {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[2]}) == 0xffff)  && (($addr)-> ($_S6_un->{_S6_u32[1]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[0]}) == 0)));
	    }' unless defined(&IN6_IS_ADDR_V4MAPPED);
	} else {
	    eval 'sub IN6_IS_ADDR_V4MAPPED {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[2]}) == 0xffff0000)  && (($addr)-> ($_S6_un->{_S6_u32[1]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[0]}) == 0)));
	    }' unless defined(&IN6_IS_ADDR_V4MAPPED);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_V4MAPPED_ANY {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[3]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[2]}) == 0xffff)  && (($addr)-> ($_S6_un->{_S6_u32[1]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[0]}) == 0)));
	    }' unless defined(&IN6_IS_ADDR_V4MAPPED_ANY);
	} else {
	    eval 'sub IN6_IS_ADDR_V4MAPPED_ANY {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[3]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[2]}) == 0xffff0000)  && (($addr)-> ($_S6_un->{_S6_u32[1]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[0]}) == 0)));
	    }' unless defined(&IN6_IS_ADDR_V4MAPPED_ANY);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_V4COMPAT {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[2]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[1]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[0]}) == 0)  && !(($addr)-> ($_S6_un->{_S6_u32[3]}) == 0)  && !(($addr)-> ($_S6_un->{_S6_u32[3]}) == 0x1)));
	    }' unless defined(&IN6_IS_ADDR_V4COMPAT);
	} else {
	    eval 'sub IN6_IS_ADDR_V4COMPAT {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[2]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[1]}) == 0)  && (($addr)-> ($_S6_un->{_S6_u32[0]}) == 0)  && !(($addr)-> ($_S6_un->{_S6_u32[3]}) == 0)  && !(($addr)-> ($_S6_un->{_S6_u32[3]}) == 0x1000000)));
	    }' unless defined(&IN6_IS_ADDR_V4COMPAT);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_MC_RESERVED {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xff0f0000) == 0xff000000));
	    }' unless defined(&IN6_IS_ADDR_MC_RESERVED);
	} else {
	    eval 'sub IN6_IS_ADDR_MC_RESERVED {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xfff) == 0xff));
	    }' unless defined(&IN6_IS_ADDR_MC_RESERVED);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_MC_NODELOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xff0f0000) == 0xff010000));
	    }' unless defined(&IN6_IS_ADDR_MC_NODELOCAL);
	} else {
	    eval 'sub IN6_IS_ADDR_MC_NODELOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xfff) == 0x1ff));
	    }' unless defined(&IN6_IS_ADDR_MC_NODELOCAL);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_MC_LINKLOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xff0f0000) == 0xff020000));
	    }' unless defined(&IN6_IS_ADDR_MC_LINKLOCAL);
	} else {
	    eval 'sub IN6_IS_ADDR_MC_LINKLOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xfff) == 0x2ff));
	    }' unless defined(&IN6_IS_ADDR_MC_LINKLOCAL);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_MC_SITELOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xff0f0000) == 0xff050000));
	    }' unless defined(&IN6_IS_ADDR_MC_SITELOCAL);
	} else {
	    eval 'sub IN6_IS_ADDR_MC_SITELOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xfff) == 0x5ff));
	    }' unless defined(&IN6_IS_ADDR_MC_SITELOCAL);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_MC_ORGLOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xff0f0000) == 0xff080000));
	    }' unless defined(&IN6_IS_ADDR_MC_ORGLOCAL);
	} else {
	    eval 'sub IN6_IS_ADDR_MC_ORGLOCAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xfff) == 0x8ff));
	    }' unless defined(&IN6_IS_ADDR_MC_ORGLOCAL);
	}
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_IS_ADDR_MC_GLOBAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xff0f0000) == 0xff0e0000));
	    }' unless defined(&IN6_IS_ADDR_MC_GLOBAL);
	} else {
	    eval 'sub IN6_IS_ADDR_MC_GLOBAL {
	        my($addr) = @_;
    		eval q(((($addr)-> ($_S6_un->{_S6_u32[0]}) & 0xfff) == 0xeff));
	    }' unless defined(&IN6_IS_ADDR_MC_GLOBAL);
	}
	eval 'sub IN6_V4MAPPED_TO_INADDR {
	    my($v6, $v4) = @_;
    	    eval q((($v4)-> &s_addr = ($v6)-> ($_S6_un->{_S6_u32[3]})));
	}' unless defined(&IN6_V4MAPPED_TO_INADDR);
	eval 'sub IN6_V4MAPPED_TO_IPADDR {
	    my($v6, $v4) = @_;
    	    eval q((($v4) = ($v6)-> ($_S6_un->{_S6_u32[3]})));
	}' unless defined(&IN6_V4MAPPED_TO_IPADDR);
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub IN6_INADDR_TO_V4MAPPED {
	        my($v4, $v6) = @_;
    		eval q((($v6)-> ($_S6_un->{_S6_u32[3]}) = ($v4)-> &s_addr, ($v6)-> ($_S6_un->{_S6_u32[2]}) = 0xffff, ($v6)-> ($_S6_un->{_S6_u32[1]}) = 0, ($v6)-> ($_S6_un->{_S6_u32[0]}) = 0));
	    }' unless defined(&IN6_INADDR_TO_V4MAPPED);
	    eval 'sub IN6_IPADDR_TO_V4MAPPED {
	        my($v4, $v6) = @_;
    		eval q((($v6)-> ($_S6_un->{_S6_u32[3]}) = ($v4), ($v6)-> ($_S6_un->{_S6_u32[2]}) = 0xffff, ($v6)-> ($_S6_un->{_S6_u32[1]}) = 0, ($v6)-> ($_S6_un->{_S6_u32[0]}) = 0));
	    }' unless defined(&IN6_IPADDR_TO_V4MAPPED);
	} else {
	    eval 'sub IN6_INADDR_TO_V4MAPPED {
	        my($v4, $v6) = @_;
    		eval q((($v6)-> ($_S6_un->{_S6_u32[3]}) = ($v4)-> &s_addr, ($v6)-> ($_S6_un->{_S6_u32[2]}) = 0xffff0000, ($v6)-> ($_S6_un->{_S6_u32[1]}) = 0, ($v6)-> ($_S6_un->{_S6_u32[0]}) = 0));
	    }' unless defined(&IN6_INADDR_TO_V4MAPPED);
	    eval 'sub IN6_IPADDR_TO_V4MAPPED {
	        my($v4, $v6) = @_;
    		eval q((($v6)-> ($_S6_un->{_S6_u32[3]}) = ($v4), ($v6)-> ($_S6_un->{_S6_u32[2]}) = 0xffff0000, ($v6)-> ($_S6_un->{_S6_u32[1]}) = 0, ($v6)-> ($_S6_un->{_S6_u32[0]}) = 0));
	    }' unless defined(&IN6_IPADDR_TO_V4MAPPED);
	}
	eval 'sub IN6_ARE_ADDR_EQUAL {
	    my($addr1, $addr2) = @_;
    	    eval q(((($addr1)-> ($_S6_un->{_S6_u32[3]}) == ($addr2)-> ($_S6_un->{_S6_u32[3]}))  && (($addr1)-> ($_S6_un->{_S6_u32[2]}) == ($addr2)-> ($_S6_un->{_S6_u32[2]}))  && (($addr1)-> ($_S6_un->{_S6_u32[1]}) == ($addr2)-> ($_S6_un->{_S6_u32[1]}))  && (($addr1)-> ($_S6_un->{_S6_u32[0]}) == ($addr2)-> ($_S6_un->{_S6_u32[0]}))));
	}' unless defined(&IN6_ARE_ADDR_EQUAL);
    }
    unless(defined(&IP_OPTIONS)) {
	eval 'sub IP_OPTIONS () {1;}' unless defined(&IP_OPTIONS);
    }
    eval 'sub IP_HDRINCL () {2;}' unless defined(&IP_HDRINCL);
    unless(defined(&IP_TOS)) {
	eval 'sub IP_TOS () {3;}' unless defined(&IP_TOS);
    }
    unless(defined(&IP_TTL)) {
	eval 'sub IP_TTL () {4;}' unless defined(&IP_TTL);
    }
    eval 'sub IP_RECVOPTS () {0x5;}' unless defined(&IP_RECVOPTS);
    eval 'sub IP_RECVRETOPTS () {0x6;}' unless defined(&IP_RECVRETOPTS);
    eval 'sub IP_RECVDSTADDR () {0x7;}' unless defined(&IP_RECVDSTADDR);
    eval 'sub IP_RETOPTS () {0x8;}' unless defined(&IP_RETOPTS);
    eval 'sub IP_RECVIF () {0x9;}' unless defined(&IP_RECVIF);
    eval 'sub IP_RECVSLLA () {0xa;}' unless defined(&IP_RECVSLLA);
    eval 'sub IP_RECVTTL () {0xb;}' unless defined(&IP_RECVTTL);
    eval 'sub IP_MULTICAST_IF () {0x10;}' unless defined(&IP_MULTICAST_IF);
    eval 'sub IP_MULTICAST_TTL () {0x11;}' unless defined(&IP_MULTICAST_TTL);
    eval 'sub IP_MULTICAST_LOOP () {0x12;}' unless defined(&IP_MULTICAST_LOOP);
    eval 'sub IP_ADD_MEMBERSHIP () {0x13;}' unless defined(&IP_ADD_MEMBERSHIP);
    eval 'sub IP_DROP_MEMBERSHIP () {0x14;}' unless defined(&IP_DROP_MEMBERSHIP);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub IP_SEC_OPT () {0x22;}' unless defined(&IP_SEC_OPT);
	eval 'sub IPSEC_PREF_NEVER () {0x1;}' unless defined(&IPSEC_PREF_NEVER);
	eval 'sub IPSEC_PREF_REQUIRED () {0x2;}' unless defined(&IPSEC_PREF_REQUIRED);
	eval 'sub IPSEC_PREF_UNIQUE () {0x4;}' unless defined(&IPSEC_PREF_UNIQUE);
    }
    eval 'sub IP_ADD_PROXY_ADDR () {0x40;}' unless defined(&IP_ADD_PROXY_ADDR);
    eval 'sub IP_BOUND_IF () {0x41;}' unless defined(&IP_BOUND_IF);
    eval 'sub IP_UNSPEC_SRC () {0x42;}' unless defined(&IP_UNSPEC_SRC);
    eval 'sub IP_UNICAST_IF () {0x43;}' unless defined(&IP_UNICAST_IF);
    unless(defined(&IP_REUSEADDR)) {
	eval 'sub IP_REUSEADDR () {0x104;}' unless defined(&IP_REUSEADDR);
    }
    unless(defined(&IP_DONTROUTE)) {
	eval 'sub IP_DONTROUTE () {0x105;}' unless defined(&IP_DONTROUTE);
    }
    unless(defined(&IP_BROADCAST)) {
	eval 'sub IP_BROADCAST () {0x106;}' unless defined(&IP_BROADCAST);
    }
    eval 'sub IP_DEFAULT_MULTICAST_TTL () {1;}' unless defined(&IP_DEFAULT_MULTICAST_TTL);
    eval 'sub IP_DEFAULT_MULTICAST_LOOP () {1;}' unless defined(&IP_DEFAULT_MULTICAST_LOOP);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub IPV6_RTHDR_TYPE_0 () {0;}' unless defined(&IPV6_RTHDR_TYPE_0);
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub IPV6_UNICAST_HOPS () {0x5;}' unless defined(&IPV6_UNICAST_HOPS);
	eval 'sub IPV6_MULTICAST_IF () {0x6;}' unless defined(&IPV6_MULTICAST_IF);
	eval 'sub IPV6_MULTICAST_HOPS () {0x7;}' unless defined(&IPV6_MULTICAST_HOPS);
	eval 'sub IPV6_MULTICAST_LOOP () {0x8;}' unless defined(&IPV6_MULTICAST_LOOP);
	eval 'sub IPV6_JOIN_GROUP () {0x9;}' unless defined(&IPV6_JOIN_GROUP);
	eval 'sub IPV6_LEAVE_GROUP () {0xa;}' unless defined(&IPV6_LEAVE_GROUP);
	eval 'sub IPV6_ADD_MEMBERSHIP () {0x9;}' unless defined(&IPV6_ADD_MEMBERSHIP);
	eval 'sub IPV6_DROP_MEMBERSHIP () {0xa;}' unless defined(&IPV6_DROP_MEMBERSHIP);
	eval 'sub IPV6_PKTINFO () {0xb;}' unless defined(&IPV6_PKTINFO);
	eval 'sub IPV6_HOPLIMIT () {0xc;}' unless defined(&IPV6_HOPLIMIT);
	eval 'sub IPV6_NEXTHOP () {0xd;}' unless defined(&IPV6_NEXTHOP);
	eval 'sub IPV6_HOPOPTS () {0xe;}' unless defined(&IPV6_HOPOPTS);
	eval 'sub IPV6_DSTOPTS () {0xf;}' unless defined(&IPV6_DSTOPTS);
	eval 'sub IPV6_RTHDR () {0x10;}' unless defined(&IPV6_RTHDR);
	eval 'sub IPV6_RTHDRDSTOPTS () {0x11;}' unless defined(&IPV6_RTHDRDSTOPTS);
	eval 'sub IPV6_RECVPKTINFO () {0x12;}' unless defined(&IPV6_RECVPKTINFO);
	eval 'sub IPV6_RECVHOPLIMIT () {0x13;}' unless defined(&IPV6_RECVHOPLIMIT);
	eval 'sub IPV6_RECVHOPOPTS () {0x14;}' unless defined(&IPV6_RECVHOPOPTS);
	eval 'sub IPV6_RECVDSTOPTS () {0x15;}' unless defined(&IPV6_RECVDSTOPTS);
	eval 'sub IPV6_RECVRTHDR () {0x16;}' unless defined(&IPV6_RECVRTHDR);
	eval 'sub IPV6_RECVRTHDRDSTOPTS () {0x17;}' unless defined(&IPV6_RECVRTHDRDSTOPTS);
	eval 'sub IPV6_CHECKSUM () {0x18;}' unless defined(&IPV6_CHECKSUM);
	eval 'sub IPV6_BOUND_IF () {0x41;}' unless defined(&IPV6_BOUND_IF);
	eval 'sub IPV6_UNSPEC_SRC () {0x42;}' unless defined(&IPV6_UNSPEC_SRC);
	eval 'sub IPV6_BOUND_PIF () {0x43;}' unless defined(&IPV6_BOUND_PIF);
	eval 'sub INET_ADDRSTRLEN () {16;}' unless defined(&INET_ADDRSTRLEN);
	eval 'sub INET6_ADDRSTRLEN () {46;}' unless defined(&INET6_ADDRSTRLEN);
	eval 'sub IPV6_PAD1_OPT () {0;}' unless defined(&IPV6_PAD1_OPT);
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	unless(defined(&_KERNEL)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
