require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NFS_EXPORT_H)) {
    eval 'sub _NFS_EXPORT_H () {1;}' unless defined(&_NFS_EXPORT_H);
    require 'nfs/nfs_sec.ph';
    require 'rpcsvc/nfsauth_prot.ph';
    require 'sys/vnode.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_SYSCALL32)) {
    }
    eval 'sub SEC_QUERY () {0x1;}' unless defined(&SEC_QUERY);
    eval 'sub M_RO () {0x1;}' unless defined(&M_RO);
    eval 'sub M_ROL () {0x2;}' unless defined(&M_ROL);
    eval 'sub M_RW () {0x4;}' unless defined(&M_RW);
    eval 'sub M_RWL () {0x8;}' unless defined(&M_RWL);
    eval 'sub M_ROOT () {0x10;}' unless defined(&M_ROOT);
    eval 'sub EX_CURRENT_VERSION () {2;}' unless defined(&EX_CURRENT_VERSION);
    if(defined(&_SYSCALL32)) {
    }
    eval 'sub EX_NOSUID () {0x1;}' unless defined(&EX_NOSUID);
    eval 'sub EX_ACLOK () {0x2;}' unless defined(&EX_ACLOK);
    eval 'sub EX_PUBLIC () {0x4;}' unless defined(&EX_PUBLIC);
    eval 'sub EX_NOSUB () {0x8;}' unless defined(&EX_NOSUB);
    eval 'sub EX_INDEX () {0x10;}' unless defined(&EX_INDEX);
    eval 'sub EX_LOG () {0x20;}' unless defined(&EX_LOG);
    eval 'sub EX_LOG_ALLOPS () {0x40;}' unless defined(&EX_LOG_ALLOPS);
    if(defined(&_KERNEL)) {
	eval 'sub AUTH_TABLESIZE () {32;}' unless defined(&AUTH_TABLESIZE);
	eval 'sub L_WAITING () {0x1;}' unless defined(&L_WAITING);
	eval 'sub L_PRINTED () {0x2;}' unless defined(&L_PRINTED);
	eval 'sub L_ERROR () {0x4;}' unless defined(&L_ERROR);
	eval 'sub LOG_BUFFER_HOLD {
	    my($lbp) = @_;
    	    eval q({  &mutex_enter(($lbp)-> &lb_lock); ($lbp)-> &lb_refcnt++;  &mutex_exit(($lbp)-> &lb_lock); });
	}' unless defined(&LOG_BUFFER_HOLD);
	eval 'sub LOG_BUFFER_RELE {
	    my($lbp) = @_;
    	    eval q({  &log_buffer_rele($lbp); });
	}' unless defined(&LOG_BUFFER_RELE);
	eval 'sub EXPTABLESIZE () {16;}' unless defined(&EXPTABLESIZE);
	eval 'sub EQFSID {
	    my($fsidp1, $fsidp2) = @_;
    	    eval q(((($fsidp1)-> $val[0] == ($fsidp2)-> $val[0])  && (($fsidp1)-> $val[1] == ($fsidp2)-> $val[1])));
	}' unless defined(&EQFSID);
	eval 'sub EQFID {
	    my($fidp1, $fidp2) = @_;
    	    eval q((-> &fid_len == -> &fid_len  &&  &nfs_fhbcmp(-> &fid_data, ($fidp2)-> &fid_data, ( &uint_t)($fidp1)-> &fid_len) == 0));
	}' unless defined(&EQFID);
	eval 'sub exportmatch {
	    my($exi, $fsid, $fid) = @_;
    	    eval q(( &EQFSID(($exi)-> &exi_fsid, ($fsid))  &&  &EQFID(($exi)-> &exi_fid, ($fid))));
	}' unless defined(&exportmatch);
	eval 'sub rdonly {
	    my($exi, $req) = @_;
    	    eval q(( &nfsauth_access($exi, $req) &  &NFSAUTH_RO));
	}' unless defined(&rdonly);
	eval 'sub PUBLIC_FH2 {
	    my($fh) = @_;
    	    eval q((($fh)-> ($fh_fsid->{val[1]}) == 0 &&  &bcmp(($fh),  &nullfh2, $sizeof{ &fhandle_t}) == 0));
	}' unless defined(&PUBLIC_FH2);
	eval 'sub PUBLIC_FH3 {
	    my($fh) = @_;
    	    eval q((($fh)-> &fh3_length == 0));
	}' unless defined(&PUBLIC_FH3);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
