require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RPC_CLNT_H)) {
    eval 'sub _RPC_CLNT_H () {1;}' unless defined(&_RPC_CLNT_H);
    require 'rpc/rpc_com.ph';
    require 'rpc/clnt_stat.ph';
    require 'sys/types.ph';
    require 'sys/netconfig.ph';
    if(defined(&_KERNEL)) {
	require 'sys/t_kuser.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub RPCB_MULTICAST_ADDR () {"FF02::202";}' unless defined(&RPCB_MULTICAST_ADDR);
    eval 'sub IS_UNRECOVERABLE_RPC {
        my($s) = @_;
	    eval q(((($s) ==  &RPC_AUTHERROR) || (($s) ==  &RPC_CANTENCODEARGS) || (($s) ==  &RPC_CANTDECODERES) || (($s) ==  &RPC_VERSMISMATCH) || (($s) ==  &RPC_PROCUNAVAIL) || (($s) ==  &RPC_PROGUNAVAIL) || (($s) ==  &RPC_PROGVERSMISMATCH) || (($s) ==  &RPC_CANTDECODEARGS)));
    }' unless defined(&IS_UNRECOVERABLE_RPC);
    eval 'sub re_errno () { ($ru->{RE_err}->{RE_errno});}' unless defined(&re_errno);
    eval 'sub re_terrno () { ($ru->{RE_err}->{RE_t_errno});}' unless defined(&re_terrno);
    eval 'sub re_why () { ($ru->{RE_why});}' unless defined(&re_why);
    eval 'sub re_vers () { ($ru->{RE_vers});}' unless defined(&re_vers);
    eval 'sub re_lb () { ($ru->{RE_lb});}' unless defined(&re_lb);
    if(defined(&__STDC__)) {
	unless(defined(&_KERNEL)) {
	}
    } else {
	unless(defined(&_KERNEL)) {
	}
    }
    unless(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub FEEDBACK_REXMIT1 () {1;}' unless defined(&FEEDBACK_REXMIT1);
    eval 'sub FEEDBACK_OK () {2;}' unless defined(&FEEDBACK_OK);
    eval 'sub CLCR_SET_LOWVERS () {3;}' unless defined(&CLCR_SET_LOWVERS);
    eval 'sub CLCR_GET_LOWVERS () {4;}' unless defined(&CLCR_GET_LOWVERS);
    eval 'sub RPCSMALLMSGSIZE () {400;}' unless defined(&RPCSMALLMSGSIZE);
    eval 'sub KNC_STRSIZE () {128;}' unless defined(&KNC_STRSIZE);
    if(defined(&_SYSCALL32)) {
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub CLNT_CALL {
        my($rh, $proc, $xargs, $argsp, $xres, $resp, $secs) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_call}))($rh, $proc, $xargs, $argsp, $xres, $resp, $secs)));
    }' unless defined(&CLNT_CALL);
    eval 'sub clnt_call {
        my($rh, $proc, $xargs, $argsp, $xres, $resp, $secs) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_call}))($rh, $proc, $xargs, $argsp, $xres, $resp, $secs)));
    }' unless defined(&clnt_call);
    unless(defined(&_KERNEL)) {
	eval 'sub CLNT_SEND {
	    my($rh, $proc, $xargs, $argsp) = @_;
    	    eval q(((*($rh)-> ($cl_ops->{cl_send}))($rh, $proc, $xargs, $argsp)));
	}' unless defined(&CLNT_SEND);
	eval 'sub clnt_send {
	    my($rh, $proc, $xargs, $argsp) = @_;
    	    eval q(((*($rh)-> ($cl_ops->{cl_send}))($rh, $proc, $xargs, $argsp)));
	}' unless defined(&clnt_send);
    }
    eval 'sub CLNT_ABORT {
        my($rh) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_abort}))($rh)));
    }' unless defined(&CLNT_ABORT);
    eval 'sub clnt_abort {
        my($rh) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_abort}))($rh)));
    }' unless defined(&clnt_abort);
    eval 'sub CLNT_GETERR {
        my($rh, $errp) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_geterr}))($rh, $errp)));
    }' unless defined(&CLNT_GETERR);
    eval 'sub clnt_geterr {
        my($rh, $errp) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_geterr}))($rh, $errp)));
    }' unless defined(&clnt_geterr);
    eval 'sub CLNT_FREERES {
        my($rh, $xres, $resp) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_freeres}))($rh, $xres, $resp)));
    }' unless defined(&CLNT_FREERES);
    eval 'sub clnt_freeres {
        my($rh, $xres, $resp) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_freeres}))($rh, $xres, $resp)));
    }' unless defined(&clnt_freeres);
    eval 'sub CLNT_CONTROL {
        my($cl, $rq, $in) = @_;
	    eval q(((*($cl)-> ($cl_ops->{cl_control}))($cl, $rq, $in)));
    }' unless defined(&CLNT_CONTROL);
    eval 'sub clnt_control {
        my($cl, $rq, $in) = @_;
	    eval q(((*($cl)-> ($cl_ops->{cl_control}))($cl, $rq, $in)));
    }' unless defined(&clnt_control);
    eval 'sub CLSET_TIMEOUT () {1;}' unless defined(&CLSET_TIMEOUT);
    eval 'sub CLGET_TIMEOUT () {2;}' unless defined(&CLGET_TIMEOUT);
    eval 'sub CLGET_SERVER_ADDR () {3;}' unless defined(&CLGET_SERVER_ADDR);
    eval 'sub CLGET_FD () {6;}' unless defined(&CLGET_FD);
    eval 'sub CLGET_SVC_ADDR () {7;}' unless defined(&CLGET_SVC_ADDR);
    eval 'sub CLSET_FD_CLOSE () {8;}' unless defined(&CLSET_FD_CLOSE);
    eval 'sub CLSET_FD_NCLOSE () {9;}' unless defined(&CLSET_FD_NCLOSE);
    eval 'sub CLGET_XID () {10;}' unless defined(&CLGET_XID);
    eval 'sub CLSET_XID () {11;}' unless defined(&CLSET_XID);
    eval 'sub CLGET_VERS () {12;}' unless defined(&CLGET_VERS);
    eval 'sub CLSET_VERS () {13;}' unless defined(&CLSET_VERS);
    eval 'sub CLGET_PROG () {14;}' unless defined(&CLGET_PROG);
    eval 'sub CLSET_PROG () {15;}' unless defined(&CLSET_PROG);
    eval 'sub CLSET_SVC_ADDR () {16;}' unless defined(&CLSET_SVC_ADDR);
    eval 'sub CLSET_PUSH_TIMOD () {17;}' unless defined(&CLSET_PUSH_TIMOD);
    eval 'sub CLSET_POP_TIMOD () {18;}' unless defined(&CLSET_POP_TIMOD);
    unless(defined(&_KERNEL)) {
	eval 'sub CLSET_IO_MODE () {19;}' unless defined(&CLSET_IO_MODE);
	eval 'sub CLGET_IO_MODE () {20;}' unless defined(&CLGET_IO_MODE);
	eval 'sub CLSET_FLUSH_MODE () {21;}' unless defined(&CLSET_FLUSH_MODE);
	eval 'sub CLGET_FLUSH_MODE () {22;}' unless defined(&CLGET_FLUSH_MODE);
	eval 'sub CLFLUSH () {23;}' unless defined(&CLFLUSH);
	eval 'sub CLSET_CONNMAXREC_SIZE () {24;}' unless defined(&CLSET_CONNMAXREC_SIZE);
	eval 'sub CLGET_CONNMAXREC_SIZE () {25;}' unless defined(&CLGET_CONNMAXREC_SIZE);
	eval 'sub CLGET_CURRENT_REC_SIZE () {26;}' unless defined(&CLGET_CURRENT_REC_SIZE);
	eval("sub RPC_CL_BESTEFFORT_FLUSH () { 100; }") unless defined(&RPC_CL_BESTEFFORT_FLUSH);
	eval("sub RPC_CL_BLOCKING_FLUSH () { 101; }") unless defined(&RPC_CL_BLOCKING_FLUSH);
	eval("sub RPC_CL_DEFAULT_FLUSH () { 102; }") unless defined(&RPC_CL_DEFAULT_FLUSH);
	eval("sub RPC_CL_BLOCKING () { 10; }") unless defined(&RPC_CL_BLOCKING);
	eval("sub RPC_CL_NONBLOCKING () { 11; }") unless defined(&RPC_CL_NONBLOCKING);
    }
    eval 'sub CLSET_RETRY_TIMEOUT () {4;}' unless defined(&CLSET_RETRY_TIMEOUT);
    eval 'sub CLGET_RETRY_TIMEOUT () {5;}' unless defined(&CLGET_RETRY_TIMEOUT);
    if(defined(&_KERNEL)) {
	eval 'sub CLSET_PROGRESS () {10000;}' unless defined(&CLSET_PROGRESS);
	eval 'sub CLSET_BCAST () {10001;}' unless defined(&CLSET_BCAST);
	eval 'sub CLGET_BCAST () {10002;}' unless defined(&CLGET_BCAST);
    }
    eval 'sub CLNT_SETTIMERS {
        my($rh, $t, $all, $min, $fdbck, $arg, $xid) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_settimers}))($rh, $t, $all, $min, $fdbck, $arg, $xid)));
    }' unless defined(&CLNT_SETTIMERS);
    eval 'sub clnt_settimers {
        my($rh, $t, $all, $min, $fdbck, $arg, $xid) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_settimers}))($rh, $t, $all, $min, $fdbck, $arg, $xid)));
    }' unless defined(&clnt_settimers);
    eval 'sub CLNT_DESTROY {
        my($rh) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_destroy}))($rh)));
    }' unless defined(&CLNT_DESTROY);
    eval 'sub clnt_destroy {
        my($rh) = @_;
	    eval q(((*($rh)-> ($cl_ops->{cl_destroy}))($rh)));
    }' unless defined(&clnt_destroy);
    eval 'sub RPCTEST_PROGRAM () {(( &rpcprog_t)1);}' unless defined(&RPCTEST_PROGRAM);
    eval 'sub RPCTEST_VERSION () {(( &rpcvers_t)1);}' unless defined(&RPCTEST_VERSION);
    eval 'sub RPCTEST_NULL_PROC () {(( &rpcproc_t)2);}' unless defined(&RPCTEST_NULL_PROC);
    eval 'sub RPCTEST_NULL_BATCH_PROC () {(( &rpcproc_t)3);}' unless defined(&RPCTEST_NULL_BATCH_PROC);
    eval 'sub NULLPROC () {(( &rpcproc_t)0);}' unless defined(&NULLPROC);
    unless(defined(&_KERNEL)) {
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&_REENTRANT)) {
	    eval 'sub rpc_createerr () {(*( &__rpc_createerr()));}' unless defined(&rpc_createerr);
	} else {
	}
	if(defined(&__STDC__)) {
	} else {
	}
	if(defined(&_REENTRANT)) {
	    eval 'sub rpc_callerr () {(*( &__rpc_callerr()));}' unless defined(&rpc_callerr);
	} else {
	}
	if(defined(&__STDC__)) {
	}
	if(defined(&__STDC__)) {
	} else {
	}
    }
    if(defined(&__STDC__)) {
    } else {
    }
    if(defined(&__STDC__)) {
    } else {
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&PORTMAP)) {
	require 'rpc/clnt_soc.ph';
    }
}
1;
