require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_RPC_SVC_MT_H)) {
    eval 'sub _RPC_SVC_MT_H () {1;}' unless defined(&_RPC_SVC_MT_H);
    require 'synch.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub SVC_VERSQUIET () {0x1;}' unless defined(&SVC_VERSQUIET);
    eval 'sub SVC_DEFUNCT () {0x2;}' unless defined(&SVC_DEFUNCT);
    eval 'sub SVC_DGRAM () {0x4;}' unless defined(&SVC_DGRAM);
    eval 'sub SVC_RENDEZVOUS () {0x8;}' unless defined(&SVC_RENDEZVOUS);
    eval 'sub SVC_CONNECTION () {0xc;}' unless defined(&SVC_CONNECTION);
    eval 'sub SVC_DOOR () {0x10;}' unless defined(&SVC_DOOR);
    eval 'sub SVC_TYPE_MASK () {0x1c;}' unless defined(&SVC_TYPE_MASK);
    eval 'sub SVC_FAILED () {0x20;}' unless defined(&SVC_FAILED);
    eval 'sub SVC_ARGS_CHECK () {0x40;}' unless defined(&SVC_ARGS_CHECK);
    eval 'sub svc_flags {
        my($xprt) = @_;
	    eval q(( &SVCEXT($xprt)-> &flags));
    }' unless defined(&svc_flags);
    eval 'sub version_keepquiet {
        my($xprt) = @_;
	    eval q(( &svc_flags($xprt) &  &SVC_VERSQUIET));
    }' unless defined(&version_keepquiet);
    eval 'sub svc_defunct {
        my($xprt) = @_;
	    eval q((( &svc_flags($xprt) &  &SVC_DEFUNCT) ?  &TRUE :  &FALSE));
    }' unless defined(&svc_defunct);
    eval 'sub svc_failed {
        my($xprt) = @_;
	    eval q((( &svc_flags($xprt) &  &SVC_FAILED) ?  &TRUE :  &FALSE));
    }' unless defined(&svc_failed);
    eval 'sub svc_type {
        my($xprt) = @_;
	    eval q(( &svc_flags($xprt) &  &SVC_TYPE_MASK));
    }' unless defined(&svc_type);
    eval 'sub svc_send_mutex {
        my($xprt) = @_;
	    eval q(( &SVCEXT($xprt)-> &send_mutex));
    }' unless defined(&svc_send_mutex);
    eval 'sub SVCEXT {
        my($xprt) = @_;
	    eval q((( &SVCXPRT_EXT *)(($xprt)-> &xp_p3)));
    }' unless defined(&SVCEXT);
    eval 'sub SVC_XP_AUTH {
        my($xprt) = @_;
	    eval q(( &SVCEXT($xprt)-> &xp_auth));
    }' unless defined(&SVC_XP_AUTH);
    eval 'sub SVCAUTH_WRAP {
        my($auth, $xdrs, $xfunc, $xwhere) = @_;
	    eval q(((*(($auth)-> ($svc_ah_ops->{svc_ah_wrap})))($auth, $xdrs, $xfunc, $xwhere)));
    }' unless defined(&SVCAUTH_WRAP);
    eval 'sub SVCAUTH_UNWRAP {
        my($auth, $xdrs, $xfunc, $xwhere) = @_;
	    eval q(((*(($auth)-> ($svc_ah_ops->{svc_ah_unwrap})))($auth, $xdrs, $xfunc, $xwhere)));
    }' unless defined(&SVCAUTH_UNWRAP);
    eval 'sub rpc_door_create () {(* ($rpcdrc->{door_create}));}' unless defined(&rpc_door_create);
    eval 'sub rpc_door_revoke () {(* ($rpcdrc->{door_revoke}));}' unless defined(&rpc_door_revoke);
    eval 'sub rpc_door_info () {(* ($rpcdrc->{door_info}));}' unless defined(&rpc_door_info);
    eval 'sub rpc_door_cred () {(* ($rpcdrc->{door_cred}));}' unless defined(&rpc_door_cred);
    eval 'sub rpc_door_call () {(* ($rpcdrc->{door_call}));}' unless defined(&rpc_door_call);
    eval 'sub rpc_door_return () {(* ($rpcdrc->{door_return}));}' unless defined(&rpc_door_return);
    eval 'sub RPC_DOOR_DIR () {"/var/run/rpc_door";}' unless defined(&RPC_DOOR_DIR);
    eval 'sub RPC_DOOR_RENDEZVOUS () {"/var/run/rpc_door/rpc_%d.%d";}' unless defined(&RPC_DOOR_RENDEZVOUS);
    if(defined(&__cplusplus)) {
    }
}
1;
