require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYMS_H)) {
    eval 'sub _SYMS_H () {1;}' unless defined(&_SYMS_H);
    require 'storclass.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub SYMNMLEN () {8;}' unless defined(&SYMNMLEN);
    eval 'sub FILNMLEN () {14;}' unless defined(&FILNMLEN);
    eval 'sub DIMNUM () {4;}' unless defined(&DIMNUM);
    eval 'sub n_name () { ($_n->{_n_name});}' unless defined(&n_name);
    eval 'sub n_nptr () { ($_n->{_n_nptr[1]});}' unless defined(&n_nptr);
    eval 'sub n_zeroes () { ($_n->{_n_n}->{_n_zeroes});}' unless defined(&n_zeroes);
    eval 'sub n_offset () { ($_n->{_n_n}->{_n_offset});}' unless defined(&n_offset);
    eval 'sub N_UNDEF () {0;}' unless defined(&N_UNDEF);
    eval 'sub N_ABS () {-1;}' unless defined(&N_ABS);
    eval 'sub N_DEBUG () {-2;}' unless defined(&N_DEBUG);
    eval 'sub N_TV () {-3;}' unless defined(&N_TV);
    eval 'sub P_TV () {-4;}' unless defined(&P_TV);
    eval 'sub _EF () {".ef";}' unless defined(&_EF);
    eval 'sub T_NULL () {0;}' unless defined(&T_NULL);
    eval 'sub T_ARG () {1;}' unless defined(&T_ARG);
    eval 'sub T_CHAR () {2;}' unless defined(&T_CHAR);
    eval 'sub T_SHORT () {3;}' unless defined(&T_SHORT);
    eval 'sub T_INT () {4;}' unless defined(&T_INT);
    eval 'sub T_LONG () {5;}' unless defined(&T_LONG);
    eval 'sub T_FLOAT () {6;}' unless defined(&T_FLOAT);
    eval 'sub T_DOUBLE () {7;}' unless defined(&T_DOUBLE);
    eval 'sub T_STRUCT () {8;}' unless defined(&T_STRUCT);
    eval 'sub T_UNION () {9;}' unless defined(&T_UNION);
    eval 'sub T_ENUM () {10;}' unless defined(&T_ENUM);
    eval 'sub T_MOE () {11;}' unless defined(&T_MOE);
    eval 'sub T_UCHAR () {12;}' unless defined(&T_UCHAR);
    eval 'sub T_USHORT () {13;}' unless defined(&T_USHORT);
    eval 'sub T_UINT () {14;}' unless defined(&T_UINT);
    eval 'sub T_ULONG () {15;}' unless defined(&T_ULONG);
    eval 'sub DT_NON () {0;}' unless defined(&DT_NON);
    eval 'sub DT_PTR () {1;}' unless defined(&DT_PTR);
    eval 'sub DT_FCN () {2;}' unless defined(&DT_FCN);
    eval 'sub DT_ARY () {3;}' unless defined(&DT_ARY);
    eval 'sub N_BTMASK () {017;}' unless defined(&N_BTMASK);
    eval 'sub N_TMASK () {060;}' unless defined(&N_TMASK);
    eval 'sub N_TMASK1 () {0300;}' unless defined(&N_TMASK1);
    eval 'sub N_TMASK2 () {0360;}' unless defined(&N_TMASK2);
    eval 'sub N_BTSHFT () {4;}' unless defined(&N_BTSHFT);
    eval 'sub N_TSHIFT () {2;}' unless defined(&N_TSHIFT);
    eval 'sub BTYPE {
        my($x) = @_;
	    eval q((($x) &  &N_BTMASK));
    }' unless defined(&BTYPE);
    eval 'sub ISPTR {
        my($x) = @_;
	    eval q(((($x) &  &N_TMASK) == ( &DT_PTR <<  &N_BTSHFT)));
    }' unless defined(&ISPTR);
    eval 'sub ISFCN {
        my($x) = @_;
	    eval q(((($x) &  &N_TMASK) == ( &DT_FCN <<  &N_BTSHFT)));
    }' unless defined(&ISFCN);
    eval 'sub ISARY {
        my($x) = @_;
	    eval q(((($x) &  &N_TMASK) == ( &DT_ARY <<  &N_BTSHFT)));
    }' unless defined(&ISARY);
    eval 'sub ISTAG {
        my($x) = @_;
	    eval q((($x) ==  &C_STRTAG || ($x) ==  &C_UNTAG || ($x) ==  &C_ENTAG));
    }' unless defined(&ISTAG);
    eval 'sub INCREF {
        my($x) = @_;
	    eval q((((($x)&~ &N_BTMASK)<< &N_TSHIFT)|( &DT_PTR<< &N_BTSHFT)|($x &N_BTMASK)));
    }' unless defined(&INCREF);
    eval 'sub DECREF {
        my($x) = @_;
	    eval q((((($x)>> &N_TSHIFT)&~ &N_BTMASK)|(($x) &N_BTMASK)));
    }' unless defined(&DECREF);
    eval 'sub SYMENT () {\'struct syment\';}' unless defined(&SYMENT);
    eval 'sub SYMESZ () {18;}' unless defined(&SYMESZ);
    eval 'sub AUXENT () {\'union auxent\';}' unless defined(&AUXENT);
    eval 'sub AUXESZ () {18;}' unless defined(&AUXESZ);
    eval 'sub _ETEXT () {"etext";}' unless defined(&_ETEXT);
    eval 'sub _EDATA () {"edata";}' unless defined(&_EDATA);
    eval 'sub _END () {"end";}' unless defined(&_END);
    eval 'sub _START () {"_start";}' unless defined(&_START);
    if(defined(&__cplusplus)) {
    }
}
1;
