require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_AIO_IMPL_H)) {
    eval 'sub _SYS_AIO_IMPL_H () {1;}' unless defined(&_SYS_AIO_IMPL_H);
    require 'sys/aio_req.ph';
    require 'sys/aio.ph';
    require 'sys/aiocb.ph';
    require 'sys/uio.ph';
    require 'sys/dditypes.ph';
    require 'sys/siginfo.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub AIO_HASHSZ () {8192;}' unless defined(&AIO_HASHSZ);
	eval 'sub AIO_HASH {
	    my($cookie) = @_;
    	    eval q(((( &uintptr_t)($cookie) >> 3) & ( &AIO_HASHSZ-1)));
	}' unless defined(&AIO_HASH);
	eval 'sub DUPLICATE () {1;}' unless defined(&DUPLICATE);
	eval 'sub AIO_CLEANUP () {0x1;}' unless defined(&AIO_CLEANUP);
	eval 'sub AIO_POLL () {0x1;}' unless defined(&AIO_POLL);
	eval 'sub AIO_PENDING () {0x2;}' unless defined(&AIO_PENDING);
	eval 'sub AIO_PHYSIODONE () {0x4;}' unless defined(&AIO_PHYSIODONE);
	eval 'sub AIO_COPYOUTDONE () {0x8;}' unless defined(&AIO_COPYOUTDONE);
	eval 'sub AIO_NOTIFYQ () {0x10;}' unless defined(&AIO_NOTIFYQ);
	eval 'sub AIO_CLEANUPQ () {0x20;}' unless defined(&AIO_CLEANUPQ);
	eval 'sub AIO_POLLQ () {0x40;}' unless defined(&AIO_POLLQ);
	eval 'sub AIO_DONEQ () {0x80;}' unless defined(&AIO_DONEQ);
	eval 'sub AIO_ZEROLEN () {0x100;}' unless defined(&AIO_ZEROLEN);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
