require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_AUDIO_TRACE_H)) {
    eval 'sub _SYS_AUDIO_TRACE_H () {1;}' unless defined(&_SYS_AUDIO_TRACE_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub AUDIO_TRACE_BUFFER_SIZE () {(1024);}' unless defined(&AUDIO_TRACE_BUFFER_SIZE);
	if(defined(&DEBUG)) {
	    unless(defined(&__lock_lint)) {
		eval 'sub ATRACE {
		    my($M, $D) = @_;
    		    eval q({  &mutex_enter( &audio_tb_lock);  ($audio_trace_buffer[&audio_tb_pos]->{atb_seq}) =  &audio_tb_seq++;  ($audio_trace_buffer[&audio_tb_pos]->{atb_comment}) = ($M);  ($audio_trace_buffer[&audio_tb_pos++]->{atb_data}) = ( &void *)($D);  &if ( &audio_tb_pos >=  &audio_tb_siz)  &audio_tb_pos = 0;  &mutex_exit( &audio_tb_lock); });
		}' unless defined(&ATRACE);
		eval 'sub ATRACE_64 {
		    my($M, $D) = @_;
    		    eval q( &ATRACE($M, $D));
		}' unless defined(&ATRACE_64);
		eval 'sub ATRACE_32 {
		    my($M, $D) = @_;
    		    eval q({  &mutex_enter( &audio_tb_lock);  ($audio_trace_buffer[&audio_tb_pos]->{atb_seq}) =  &audio_tb_seq++;  ($audio_trace_buffer[&audio_tb_pos]->{atb_comment}) = ($M);  ($audio_trace_buffer[&audio_tb_pos++]->{atb_data}) = ( &void *)(($D) & 0xffffffff);  &if ( &audio_tb_pos >=  &audio_tb_siz)  &audio_tb_pos = 0;  &mutex_exit( &audio_tb_lock); });
		}' unless defined(&ATRACE_32);
		eval 'sub ATRACE_16 {
		    my($M, $D) = @_;
    		    eval q({  &mutex_enter( &audio_tb_lock);  ($audio_trace_buffer[&audio_tb_pos]->{atb_seq}) =  &audio_tb_seq++;  ($audio_trace_buffer[&audio_tb_pos]->{atb_comment}) = ($M);  ($audio_trace_buffer[&audio_tb_pos++]->{atb_data}) = ( &void *)(($D) & 0xffff);  &if ( &audio_tb_pos >=  &audio_tb_siz)  &audio_tb_pos = 0;  &mutex_exit( &audio_tb_lock); });
		}' unless defined(&ATRACE_16);
		eval 'sub ATRACE_8 {
		    my($M, $D) = @_;
    		    eval q({  &mutex_enter( &audio_tb_lock);  ($audio_trace_buffer[&audio_tb_pos]->{atb_seq}) =  &audio_tb_seq++;  ($audio_trace_buffer[&audio_tb_pos]->{atb_comment}) = ($M);  ($audio_trace_buffer[&audio_tb_pos++]->{atb_data}) = ( &void *)(($D) & 0xff);  &if ( &audio_tb_pos >=  &audio_tb_siz)  &audio_tb_pos = 0;  &mutex_exit( &audio_tb_lock); });
		}' unless defined(&ATRACE_8);
	    } else {
		eval 'sub ATRACE {
		    my($M, $D) = @_;
    		    eval q();
		}' unless defined(&ATRACE);
		eval 'sub ATRACE_32 {
		    my($M, $D) = @_;
    		    eval q();
		}' unless defined(&ATRACE_32);
		eval 'sub ATRACE_16 {
		    my($M, $D) = @_;
    		    eval q();
		}' unless defined(&ATRACE_16);
		eval 'sub ATRACE_8 {
		    my($M, $D) = @_;
    		    eval q();
		}' unless defined(&ATRACE_8);
	    }
	} else {
	    eval 'sub ATRACE {
	        my($M, $D) = @_;
    		eval q();
	    }' unless defined(&ATRACE);
	    eval 'sub ATRACE_32 {
	        my($M, $D) = @_;
    		eval q();
	    }' unless defined(&ATRACE_32);
	    eval 'sub ATRACE_16 {
	        my($M, $D) = @_;
    		eval q();
	    }' unless defined(&ATRACE_16);
	    eval 'sub ATRACE_8 {
	        my($M, $D) = @_;
    		eval q();
	    }' unless defined(&ATRACE_8);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
