require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_AUDIOIO_H)) {
    eval 'sub _SYS_AUDIOIO_H () {1;}' unless defined(&_SYS_AUDIOIO_H);
    require 'sys/types.ph';
    require 'sys/types32.ph';
    require 'sys/time.ph';
    require 'sys/ioccom.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub AUDIO_ENCODING_NONE () {(0);}' unless defined(&AUDIO_ENCODING_NONE);
    eval 'sub AUDIO_ENCODING_ULAW () {(1);}' unless defined(&AUDIO_ENCODING_ULAW);
    eval 'sub AUDIO_ENCODING_ALAW () {(2);}' unless defined(&AUDIO_ENCODING_ALAW);
    eval 'sub AUDIO_ENCODING_LINEAR () {(3);}' unless defined(&AUDIO_ENCODING_LINEAR);
    eval 'sub AUDIO_ENCODING_DVI () {(104);}' unless defined(&AUDIO_ENCODING_DVI);
    eval 'sub AUDIO_ENCODING_LINEAR8 () {(105);}' unless defined(&AUDIO_ENCODING_LINEAR8);
    eval 'sub AUDIO_MIN_GAIN () {(0);}' unless defined(&AUDIO_MIN_GAIN);
    eval 'sub AUDIO_MAX_GAIN () {(255);}' unless defined(&AUDIO_MAX_GAIN);
    eval 'sub AUDIO_MID_GAIN () {( &AUDIO_MAX_GAIN / 2);}' unless defined(&AUDIO_MID_GAIN);
    eval 'sub AUDIO_LEFT_BALANCE () {(0);}' unless defined(&AUDIO_LEFT_BALANCE);
    eval 'sub AUDIO_MID_BALANCE () {(32);}' unless defined(&AUDIO_MID_BALANCE);
    eval 'sub AUDIO_RIGHT_BALANCE () {(64);}' unless defined(&AUDIO_RIGHT_BALANCE);
    eval 'sub AUDIO_BALANCE_SHIFT () {(3);}' unless defined(&AUDIO_BALANCE_SHIFT);
    eval 'sub AUDIO_CHANNELS_MONO () {(1);}' unless defined(&AUDIO_CHANNELS_MONO);
    eval 'sub AUDIO_CHANNELS_STEREO () {(2);}' unless defined(&AUDIO_CHANNELS_STEREO);
    eval 'sub AUDIO_MIN_PLAY_CHANNELS () {( &AUDIO_CHANNELS_MONO);}' unless defined(&AUDIO_MIN_PLAY_CHANNELS);
    eval 'sub AUDIO_MAX_PLAY_CHANNELS () {( &AUDIO_CHANNELS_STEREO);}' unless defined(&AUDIO_MAX_PLAY_CHANNELS);
    eval 'sub AUDIO_MIN_REC_CHANNELS () {( &AUDIO_CHANNELS_MONO);}' unless defined(&AUDIO_MIN_REC_CHANNELS);
    eval 'sub AUDIO_MAX_REC_CHANNELS () {( &AUDIO_CHANNELS_STEREO);}' unless defined(&AUDIO_MAX_REC_CHANNELS);
    eval 'sub AUDIO_PRECISION_8 () {(8);}' unless defined(&AUDIO_PRECISION_8);
    eval 'sub AUDIO_PRECISION_16 () {(16);}' unless defined(&AUDIO_PRECISION_16);
    eval 'sub AUDIO_MIN_PLAY_PRECISION () {(8);}' unless defined(&AUDIO_MIN_PLAY_PRECISION);
    eval 'sub AUDIO_MAX_PLAY_PRECISION () {(32);}' unless defined(&AUDIO_MAX_PLAY_PRECISION);
    eval 'sub AUDIO_MIN_REC_PRECISION () {(8);}' unless defined(&AUDIO_MIN_REC_PRECISION);
    eval 'sub AUDIO_MAX_REC_PRECISION () {(32);}' unless defined(&AUDIO_MAX_REC_PRECISION);
    eval 'sub AUDIO_NONE () {0x;}' unless defined(&AUDIO_NONE);
    eval 'sub AUDIO_SPEAKER () {0x1;}' unless defined(&AUDIO_SPEAKER);
    eval 'sub AUDIO_HEADPHONE () {0x2;}' unless defined(&AUDIO_HEADPHONE);
    eval 'sub AUDIO_LINE_OUT () {0x4;}' unless defined(&AUDIO_LINE_OUT);
    eval 'sub AUDIO_SPDIF_OUT () {0x8;}' unless defined(&AUDIO_SPDIF_OUT);
    eval 'sub AUDIO_AUX1_OUT () {0x10;}' unless defined(&AUDIO_AUX1_OUT);
    eval 'sub AUDIO_AUX2_OUT () {0x20;}' unless defined(&AUDIO_AUX2_OUT);
    eval 'sub AUDIO_MICROPHONE () {0x1;}' unless defined(&AUDIO_MICROPHONE);
    eval 'sub AUDIO_LINE_IN () {0x2;}' unless defined(&AUDIO_LINE_IN);
    eval 'sub AUDIO_CD () {0x4;}' unless defined(&AUDIO_CD);
    eval 'sub AUDIO_INTERNAL_CD_IN () { &AUDIO_CD;}' unless defined(&AUDIO_INTERNAL_CD_IN);
    eval 'sub AUDIO_SPDIF_IN () {0x8;}' unless defined(&AUDIO_SPDIF_IN);
    eval 'sub AUDIO_AUX1_IN () {0x10;}' unless defined(&AUDIO_AUX1_IN);
    eval 'sub AUDIO_AUX2_IN () {0x20;}' unless defined(&AUDIO_AUX2_IN);
    eval 'sub AUDIO_CODEC_LOOPB_IN () {0x40;}' unless defined(&AUDIO_CODEC_LOOPB_IN);
    eval 'sub AUDIO_SUNVTS () {0x80;}' unless defined(&AUDIO_SUNVTS);
    eval 'sub AUDIO_HWFEATURE_DUPLEX () {0x1;}' unless defined(&AUDIO_HWFEATURE_DUPLEX);
    eval 'sub AUDIO_HWFEATURE_MSCODEC () {0x2;}' unless defined(&AUDIO_HWFEATURE_MSCODEC);
    eval 'sub AUDIO_HWFEATURE_IN2OUT () {0x4;}' unless defined(&AUDIO_HWFEATURE_IN2OUT);
    eval 'sub AUDIO_HWFEATURE_PLAY () {0x8;}' unless defined(&AUDIO_HWFEATURE_PLAY);
    eval 'sub AUDIO_HWFEATURE_RECORD () {0x10;}' unless defined(&AUDIO_HWFEATURE_RECORD);
    eval 'sub AUDIO_SWFEATURE_MIXER () {0x1;}' unless defined(&AUDIO_SWFEATURE_MIXER);
    eval 'sub AUDIO_INITINFO {
        my($i) = @_;
	    eval q({  &uint_t * &__x__;  &for ( &__x__ = ( &uint_t *);  &__x__ < ((($i)) + $sizeof{ &audio_info_t}); * &__x__++ = ~0); });
    }' unless defined(&AUDIO_INITINFO);
    eval 'sub MAX_AUDIO_DEV_LEN () {(16);}' unless defined(&MAX_AUDIO_DEV_LEN);
    eval 'sub AUDIO_GETINFO () { &_IOR(ord(\'A\'), 1,  &audio_info_t);}' unless defined(&AUDIO_GETINFO);
    eval 'sub AUDIO_SETINFO () { &_IOWR(ord(\'A\'), 2,  &audio_info_t);}' unless defined(&AUDIO_SETINFO);
    eval 'sub AUDIO_DRAIN () { &_IO(ord(\'A\'), 3);}' unless defined(&AUDIO_DRAIN);
    eval 'sub AUDIO_GETDEV () { &_IOR(ord(\'A\'), 4,  &audio_device_t);}' unless defined(&AUDIO_GETDEV);
    eval 'sub AUDIO_DIAG_LOOPBACK () { &_IOW(ord(\'A\'), 101, \'int\');}' unless defined(&AUDIO_DIAG_LOOPBACK);
    if(defined( &_LP64) || defined( &_I32LPx)) {
    } else {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
