require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_AUDIOVAR_H)) {
    eval 'sub _SYS_AUDIOVAR_H () {1;}' unless defined(&_SYS_AUDIOVAR_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub AUD_INITVALUE () {(~0);}' unless defined(&AUD_INITVALUE);
    eval 'sub Modify {
        my($X) = @_;
	    eval q((( &uint_t)($X) !=  &AUD_INITVALUE));
    }' unless defined(&Modify);
    eval 'sub Modifys {
        my($X) = @_;
	    eval q((($X) != ( &ushort_t) &AUD_INITVALUE));
    }' unless defined(&Modifys);
    eval 'sub Modifyc {
        my($X) = @_;
	    eval q((($X) != ( &uchar_t) &AUD_INITVALUE));
    }' unless defined(&Modifyc);
    eval("sub AUDRETURN_CHANGE () { 0; }") unless defined(&AUDRETURN_CHANGE);
    eval("sub AUDRETURN_NOCHANGE () { 1; }") unless defined(&AUDRETURN_NOCHANGE);
    eval("sub AUDRETURN_DELAYED () { 2; }") unless defined(&AUDRETURN_DELAYED);
    eval("sub AUD_ACTIVE () { 0; }") unless defined(&AUD_ACTIVE);
    eval("sub AUD_ERRORRESET () { 1; }") unless defined(&AUD_ERRORRESET);
    eval("sub AUDTYPE_NONE () { 00; }") unless defined(&AUDTYPE_NONE);
    eval("sub AUDTYPE_DATA () { 01; }") unless defined(&AUDTYPE_DATA);
    eval("sub AUDTYPE_CONTROL () { 02; }") unless defined(&AUDTYPE_CONTROL);
    eval("sub AUDTYPE_BOTH () { 03; }") unless defined(&AUDTYPE_BOTH);
    eval 'sub ISPLAYSTREAM {
        my($as) = @_;
	    eval q(( &ISDATASTREAM($as)  && ( ($as->{openflag}) &  &FWRITE)));
    }' unless defined(&ISPLAYSTREAM);
    eval 'sub ISRECORDSTREAM {
        my($as) = @_;
	    eval q(( &ISDATASTREAM($as)  && ( ($as->{openflag}) &  &FREAD)));
    }' unless defined(&ISRECORDSTREAM);
    eval 'sub ISDATASTREAM {
        my($as) = @_;
	    eval q(((( ($as->{type})) & ( &AUDTYPE_DATA)) != 0));
    }' unless defined(&ISDATASTREAM);
    eval 'sub ISCONTROLSTREAM {
        my($as) = @_;
	    eval q(((( ($as->{type})) & ( &AUDTYPE_CONTROL)) != 0));
    }' unless defined(&ISCONTROLSTREAM);
    eval("sub AUDMODE_NONE () { 00; }") unless defined(&AUDMODE_NONE);
    eval("sub AUDMODE_AUDIO () { 01; }") unless defined(&AUDMODE_AUDIO);
    eval("sub AUDMODE_HDLC () { 02; }") unless defined(&AUDMODE_HDLC);
    eval 'sub LOCK_AS {
        my($as) = @_;
	    eval q( &mutex_enter(($as)-> &lock));
    }' unless defined(&LOCK_AS);
    eval 'sub UNLOCK_AS {
        my($as) = @_;
	    eval q( &mutex_exit(($as)-> &lock));
    }' unless defined(&UNLOCK_AS);
    eval 'sub ASSERT_ASLOCKED {
        my($as) = @_;
	    eval q( &ASSERT( &MUTEX_HELD(($as)-> &lock)));
    }' unless defined(&ASSERT_ASLOCKED);
    eval 'sub AUDIOCACTION_INIT () {(0);}' unless defined(&AUDIOCACTION_INIT);
    eval 'sub AUDIOCACTION_WAIT () {(1);}' unless defined(&AUDIOCACTION_WAIT);
    eval 'sub AUDIOCACTION_WAITING () {(2);}' unless defined(&AUDIOCACTION_WAITING);
    eval("sub AUDIO_SENDSIG_NONE () { 0; }") unless defined(&AUDIO_SENDSIG_NONE);
    eval("sub AUDIO_SENDSIG_EXPLICIT () { 1; }") unless defined(&AUDIO_SENDSIG_EXPLICIT);
    eval("sub AUDIO_SENDSIG_ALL () { 2; }") unless defined(&AUDIO_SENDSIG_ALL);
    if(defined(&__STDC__)) {
    } else {
    }
    eval 'sub AUD_CLOSE {
        my($A) = @_;
	    eval q((*($A)-> ($distate->{ops}->{close}))($A));
    }' unless defined(&AUD_CLOSE);
    eval 'sub AUD_IOCTL {
        my($A, $Q, $M) = @_;
	    eval q((*($A)-> ($distate->{ops}->{ioctl}))($A, $Q, $M));
    }' unless defined(&AUD_IOCTL);
    eval 'sub AUD_MPROTO {
        my($A, $M) = @_;
	    eval q((*($A)-> ($distate->{ops}->{mproto}))($A, $M));
    }' unless defined(&AUD_MPROTO);
    eval 'sub AUD_START {
        my($A) = @_;
	    eval q((*($A)-> ($distate->{ops}->{start}))($A));
    }' unless defined(&AUD_START);
    eval 'sub AUD_STOP {
        my($A) = @_;
	    eval q((*($A)-> ($distate->{ops}->{stop}))($A));
    }' unless defined(&AUD_STOP);
    eval 'sub AUD_SETFLAG {
        my($A, $F, $X) = @_;
	    eval q((*($A)-> ($distate->{ops}->{setflag}))($A, $F, $X));
    }' unless defined(&AUD_SETFLAG);
    eval 'sub AUD_GETFLAG {
        my($A, $F) = @_;
	    eval q((*($A)-> ($distate->{ops}->{setflag}))($A, $F,  &AUD_INITVALUE));
    }' unless defined(&AUD_GETFLAG);
    eval 'sub AUD_SETINFO {
        my($A, $M, $E) = @_;
	    eval q((*($A)-> ($distate->{ops}->{setinfo}))($A, $M, $E));
    }' unless defined(&AUD_SETINFO);
    eval 'sub AUD_GETINFO {
        my($A) = @_;
	    eval q((*($A)-> ($distate->{ops}->{setinfo}))($A,  &NULL,  &NULL));
    }' unless defined(&AUD_GETINFO);
    eval 'sub AUD_QUEUECMD {
        my($A, $C) = @_;
	    eval q((*($A)-> ($distate->{ops}->{queuecmd}))($A, $C));
    }' unless defined(&AUD_QUEUECMD);
    eval 'sub AUD_FLUSHCMD {
        my($A) = @_;
	    eval q((*($A)-> ($distate->{ops}->{flushcmd}))($A));
    }' unless defined(&AUD_FLUSHCMD);
    if(defined(&__STDC__)) {
    } else {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
