require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_AUTOCONF_H)) {
    eval 'sub _SYS_AUTOCONF_H () {1;}' unless defined(&_SYS_AUTOCONF_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/dditypes.ph';
    require 'sys/devops.ph';
    require 'sys/mutex.ph';
    require 'sys/thread.ph';
    eval 'sub DN_CONF_PARSED () {0x1;}' unless defined(&DN_CONF_PARSED);
    eval 'sub DN_DEVI_MADE () {0x2;}' unless defined(&DN_DEVI_MADE);
    eval 'sub DN_WALKED_TREE () {0x4;}' unless defined(&DN_WALKED_TREE);
    eval 'sub DN_DEVS_ATTACHED () {0x8;}' unless defined(&DN_DEVS_ATTACHED);
    eval 'sub DN_BUSY_LOADING () {0x10;}' unless defined(&DN_BUSY_LOADING);
    eval 'sub DN_BUSY_UNLOADING () {0x20;}' unless defined(&DN_BUSY_UNLOADING);
    eval 'sub DN_TAKEN_GETUDEV () {0x40;}' unless defined(&DN_TAKEN_GETUDEV);
    eval 'sub DN_DRIVER_REMOVED () {0x80;}' unless defined(&DN_DRIVER_REMOVED);
    eval 'sub DN_BUSY_CHANGING_BITS () {0x30;}' unless defined(&DN_BUSY_CHANGING_BITS);
    eval 'sub DN_BUSY_CHANGING {
        my($flg) = @_;
	    eval q(((($flg) &  &DN_BUSY_CHANGING_BITS) != 0));
    }' unless defined(&DN_BUSY_CHANGING);
    if(defined(&_KERNEL)) {
	eval 'sub LOCK_DEV_OPS {
	    my($lp) = @_;
    	    eval q( &mutex_enter(($lp)));
	}' unless defined(&LOCK_DEV_OPS);
	eval 'sub UNLOCK_DEV_OPS {
	    my($lp) = @_;
    	    eval q( &mutex_exit(($lp)));
	}' unless defined(&UNLOCK_DEV_OPS);
	eval 'sub INCR_DEV_OPS_REF {
	    my($opsp) = @_;
    	    eval q(($opsp)-> &devo_refcnt++);
	}' unless defined(&INCR_DEV_OPS_REF);
	eval 'sub DECR_DEV_OPS_REF {
	    my($opsp) = @_;
    	    eval q(($opsp)-> &devo_refcnt--);
	}' unless defined(&DECR_DEV_OPS_REF);
	eval 'sub CB_DRV_INSTALLED {
	    my($opsp) = @_;
    	    eval q((($opsp) !=  &nodev_ops  && ($opsp) !=  &mod_nodev_ops));
	}' unless defined(&CB_DRV_INSTALLED);
	eval 'sub DRV_UNLOADABLE {
	    my($opsp) = @_;
    	    eval q((($opsp)-> &devo_refcnt == 0));
	}' unless defined(&DRV_UNLOADABLE);
	eval 'sub DEV_OPS_HELD {
	    my($opsp) = @_;
    	    eval q((($opsp)-> &devo_refcnt > 0));
	}' unless defined(&DEV_OPS_HELD);
	eval 'sub NEXUS_DRV {
	    my($opsp) = @_;
    	    eval q((($opsp)-> &devo_bus_ops !=  &NULL));
	}' unless defined(&NEXUS_DRV);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
