require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_BPP_IO_H)) {
    eval 'sub _SYS_BPP_IO_H () {1;}' unless defined(&_SYS_BPP_IO_H);
    require 'sys/ioccom.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub BPP_UNIT {
        my($dev) = @_;
	    eval q( &getminor(*$dev));
    }' unless defined(&BPP_UNIT);
    eval 'sub BPPIOC_SETPARMS () { &_IOW(ord(\'b\'), 1, \'struct bpp_transfer_parms\');}' unless defined(&BPPIOC_SETPARMS);
    eval 'sub BPPIOC_GETPARMS () { &_IOR(ord(\'b\'), 2, \'struct bpp_transfer_parms\');}' unless defined(&BPPIOC_GETPARMS);
    eval 'sub BPPIOC_SETOUTPINS () { &_IOW(ord(\'b\'), 3, \'struct bpp_pins\');}' unless defined(&BPPIOC_SETOUTPINS);
    eval 'sub BPPIOC_GETOUTPINS () { &_IOR(ord(\'b\'), 4, \'struct bpp_pins\');}' unless defined(&BPPIOC_GETOUTPINS);
    eval 'sub BPPIOC_GETERR () { &_IOR(ord(\'b\'), 5, \'struct bpp_error_status\');}' unless defined(&BPPIOC_GETERR);
    eval 'sub BPPIOC_TESTIO () { &_IO(ord(\'b\'), 6);}' unless defined(&BPPIOC_TESTIO);
    eval 'sub MAX_TIMEOUT () {1800000;}' unless defined(&MAX_TIMEOUT);
    eval("sub BPP_NO_HS () { 1; }") unless defined(&BPP_NO_HS);
    eval("sub BPP_ACK_HS () { 2; }") unless defined(&BPP_ACK_HS);
    eval("sub BPP_BUSY_HS () { 3; }") unless defined(&BPP_BUSY_HS);
    eval("sub BPP_ACK_BUSY_HS () { 4; }") unless defined(&BPP_ACK_BUSY_HS);
    eval("sub BPP_XSCAN_HS () { 5; }") unless defined(&BPP_XSCAN_HS);
    eval("sub BPP_HSCAN_HS () { 6; }") unless defined(&BPP_HSCAN_HS);
    eval("sub BPP_CLEAR_MEM () { 7; }") unless defined(&BPP_CLEAR_MEM);
    eval("sub BPP_SET_MEM () { 8; }") unless defined(&BPP_SET_MEM);
    eval("sub BPP_VPRINT_HS () { 9; }") unless defined(&BPP_VPRINT_HS);
    eval("sub BPP_VPLOT_HS () { 10; }") unless defined(&BPP_VPLOT_HS);
    eval 'sub BPP_SLCTIN_PIN () {0x1;}' unless defined(&BPP_SLCTIN_PIN);
    eval 'sub BPP_AFX_PIN () {0x2;}' unless defined(&BPP_AFX_PIN);
    eval 'sub BPP_INIT_PIN () {0x4;}' unless defined(&BPP_INIT_PIN);
    eval 'sub BPP_V1_PIN () {0x8;}' unless defined(&BPP_V1_PIN);
    eval 'sub BPP_V2_PIN () {0x10;}' unless defined(&BPP_V2_PIN);
    eval 'sub BPP_V3_PIN () {0x20;}' unless defined(&BPP_V3_PIN);
    eval 'sub BPP_ALL_OUT_PINS () {( &BPP_SLCTIN_PIN |  &BPP_AFX_PIN |  &BPP_INIT_PIN |  &BPP_V1_PIN |  &BPP_V2_PIN |  &BPP_V3_PIN);}' unless defined(&BPP_ALL_OUT_PINS);
    eval 'sub BPP_ERR_PIN () {0x1;}' unless defined(&BPP_ERR_PIN);
    eval 'sub BPP_SLCT_PIN () {0x2;}' unless defined(&BPP_SLCT_PIN);
    eval 'sub BPP_PE_PIN () {0x4;}' unless defined(&BPP_PE_PIN);
    eval 'sub BPP_ALL_IN_PINS () {( &BPP_ERR_PIN |  &BPP_SLCT_PIN |  &BPP_PE_PIN);}' unless defined(&BPP_ALL_IN_PINS);
    eval 'sub BPP_ERR_ERR () {0x1;}' unless defined(&BPP_ERR_ERR);
    eval 'sub BPP_SLCT_ERR () {0x2;}' unless defined(&BPP_SLCT_ERR);
    eval 'sub BPP_PE_ERR () {0x4;}' unless defined(&BPP_PE_ERR);
    eval 'sub BPP_SLCTIN_ERR () {0x10;}' unless defined(&BPP_SLCTIN_ERR);
    eval 'sub BPP_BUSY_ERR () {0x40;}' unless defined(&BPP_BUSY_ERR);
    if(defined(&__cplusplus)) {
    }
}
1;
