require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CDIO_H)) {
    eval 'sub _SYS_CDIO_H () {1;}' unless defined(&_SYS_CDIO_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub CDROM_LBA () {0x1;}' unless defined(&CDROM_LBA);
    eval 'sub CDROM_MSF () {0x2;}' unless defined(&CDROM_MSF);
    eval 'sub CDROM_DATA_TRACK () {0x4;}' unless defined(&CDROM_DATA_TRACK);
    eval 'sub CDROM_LEADOUT () {0xaa;}' unless defined(&CDROM_LEADOUT);
    eval 'sub CDROM_AUDIO_INVALID () {0x;}' unless defined(&CDROM_AUDIO_INVALID);
    eval 'sub CDROM_AUDIO_PLAY () {0x11;}' unless defined(&CDROM_AUDIO_PLAY);
    eval 'sub CDROM_AUDIO_PAUSED () {0x12;}' unless defined(&CDROM_AUDIO_PAUSED);
    eval 'sub CDROM_AUDIO_COMPLETED () {0x13;}' unless defined(&CDROM_AUDIO_COMPLETED);
    eval 'sub CDROM_AUDIO_ERROR () {0x14;}' unless defined(&CDROM_AUDIO_ERROR);
    eval 'sub CDROM_AUDIO_NO_STATUS () {0x15;}' unless defined(&CDROM_AUDIO_NO_STATUS);
    if(defined( &_SYSCALL32)) {
	eval 'sub cdrom_read32tocdrom_read {
	    my($cdrd32, $cdrd) = @_;
    	    eval q( ($cdrd->{cdread_lba})	=  ($cdrd32->{cdread_lba});  ($cdrd->{cdread_bufaddr})	=  ($cdrd32->{cdread_bufaddr});  ($cdrd->{cdread_buflen})	=  ($cdrd32->{cdread_buflen}));
	}' unless defined(&cdrom_read32tocdrom_read);
	eval 'sub cdrom_readtocdrom_read32 {
	    my($cdrd, $cdrd32) = @_;
    	    eval q( ($cdrd32->{cdread_lba})	=  ($cdrd->{cdread_lba});  ($cdrd32->{cdread_bufaddr})	= ( &caddr32_t) ($cdrd->{cdread_bufaddr});  ($cdrd32->{cdread_buflen})	=  ($cdrd->{cdread_buflen}));
	}' unless defined(&cdrom_readtocdrom_read32);
    }
    if(defined( &_SYSCALL32)) {
	eval 'sub cdrom_cdda32tocdrom_cdda {
	    my($cdda32, $cdda) = @_;
    	    eval q( ($cdda->{cdda_addr})	 =  ($cdda32->{cdda_addr});  ($cdda->{cdda_length})	=  ($cdda32->{cdda_length});  ($cdda->{cdda_data})	 =  ($cdda32->{cdda_data});  ($cdda->{cdda_subcode})	=  ($cdda32->{cdda_subcode}));
	}' unless defined(&cdrom_cdda32tocdrom_cdda);
	eval 'sub cdrom_cddatocdrom_cdda32 {
	    my($cdda, $cdda32) = @_;
    	    eval q( ($cdda32->{cdda_addr})	=  ($cdda->{cdda_addr});  ($cdda32->{cdda_length})	=  ($cdda->{cdda_length});  ($cdda32->{cdda_data})	= ( &caddr32_t) ($cdda->{cdda_data});  ($cdda32->{cdda_subcode})	=  ($cdda->{cdda_subcode}));
	}' unless defined(&cdrom_cddatocdrom_cdda32);
    }
    eval 'sub CDROM_DA_NO_SUBCODE () {0x;}' unless defined(&CDROM_DA_NO_SUBCODE);
    eval 'sub CDROM_DA_SUBQ () {0x1;}' unless defined(&CDROM_DA_SUBQ);
    eval 'sub CDROM_DA_ALL_SUBCODE () {0x2;}' unless defined(&CDROM_DA_ALL_SUBCODE);
    eval 'sub CDROM_DA_SUBCODE_ONLY () {0x3;}' unless defined(&CDROM_DA_SUBCODE_ONLY);
    if(defined( &_SYSCALL32)) {
	eval 'sub cdrom_cdxa32tocdrom_cdxa {
	    my($cdxa32, $cdxa) = @_;
    	    eval q( ($cdxa->{cdxa_addr})	 =  ($cdxa32->{cdxa_addr});  ($cdxa->{cdxa_length})	=  ($cdxa32->{cdxa_length});  ($cdxa->{cdxa_data})	 =  ($cdxa32->{cdxa_data});  ($cdxa->{cdxa_format})	=  ($cdxa32->{cdxa_format}));
	}' unless defined(&cdrom_cdxa32tocdrom_cdxa);
	eval 'sub cdrom_cdxatocdrom_cdxa32 {
	    my($cdxa, $cdxa32) = @_;
    	    eval q( ($cdxa32->{cdxa_addr})	=  ($cdxa->{cdxa_addr});  ($cdxa32->{cdxa_length})	=  ($cdxa->{cdxa_length});  ($cdxa32->{cdxa_data})	= ( &caddr32_t) ($cdxa->{cdxa_data});  ($cdxa32->{cdxa_format})	=  ($cdxa->{cdxa_format}));
	}' unless defined(&cdrom_cdxatocdrom_cdxa32);
    }
    eval 'sub CDROM_XA_DATA () {0x;}' unless defined(&CDROM_XA_DATA);
    eval 'sub CDROM_XA_SECTOR_DATA () {0x1;}' unless defined(&CDROM_XA_SECTOR_DATA);
    eval 'sub CDROM_XA_DATA_W_ERROR () {0x2;}' unless defined(&CDROM_XA_DATA_W_ERROR);
    if(defined( &_SYSCALL32)) {
	eval 'sub cdrom_subcode32tocdrom_subcode {
	    my($cdsc32, $cdsc) = @_;
    	    eval q( ($cdsc->{cdsc_length})	=  ($cdsc32->{cdsc_length});  ($cdsc->{cdsc_addr})	 =  ($cdsc32->{cdsc_addr}));
	}' unless defined(&cdrom_subcode32tocdrom_subcode);
	eval 'sub cdrom_subcodetocdrom_subcode32 {
	    my($cdsc, $cdsc32) = @_;
    	    eval q( ($cdsc32->{cdsc_length})	=  ($cdsc->{cdsc_length});  ($cdsc32->{cdsc_addr})	= ( &caddr32_t) ($cdsc->{cdsc_addr}));
	}' unless defined(&cdrom_subcodetocdrom_subcode32);
    }
    eval 'sub CDROM_BLK_512 () {512;}' unless defined(&CDROM_BLK_512);
    eval 'sub CDROM_BLK_1024 () {1024;}' unless defined(&CDROM_BLK_1024);
    eval 'sub CDROM_BLK_2048 () {2048;}' unless defined(&CDROM_BLK_2048);
    eval 'sub CDROM_BLK_2056 () {2056;}' unless defined(&CDROM_BLK_2056);
    eval 'sub CDROM_BLK_2324 () {2324;}' unless defined(&CDROM_BLK_2324);
    eval 'sub CDROM_BLK_2336 () {2336;}' unless defined(&CDROM_BLK_2336);
    eval 'sub CDROM_BLK_2340 () {2340;}' unless defined(&CDROM_BLK_2340);
    eval 'sub CDROM_BLK_2352 () {2352;}' unless defined(&CDROM_BLK_2352);
    eval 'sub CDROM_BLK_2368 () {2368;}' unless defined(&CDROM_BLK_2368);
    eval 'sub CDROM_BLK_2448 () {2448;}' unless defined(&CDROM_BLK_2448);
    eval 'sub CDROM_BLK_2646 () {2646;}' unless defined(&CDROM_BLK_2646);
    eval 'sub CDROM_BLK_2647 () {2647;}' unless defined(&CDROM_BLK_2647);
    eval 'sub CDROM_BLK_SUBCODE () {96;}' unless defined(&CDROM_BLK_SUBCODE);
    eval 'sub CDROM_NORMAL_SPEED () {0x;}' unless defined(&CDROM_NORMAL_SPEED);
    eval 'sub CDROM_DOUBLE_SPEED () {0x1;}' unless defined(&CDROM_DOUBLE_SPEED);
    eval 'sub CDROM_QUAD_SPEED () {0x3;}' unless defined(&CDROM_QUAD_SPEED);
    eval 'sub CDROM_TWELVE_SPEED () {0xc;}' unless defined(&CDROM_TWELVE_SPEED);
    eval 'sub CDROM_MAXIMUM_SPEED () {0xff;}' unless defined(&CDROM_MAXIMUM_SPEED);
    eval 'sub CDIOC () {(0x4 << 8);}' unless defined(&CDIOC);
    eval 'sub CDROMPAUSE () {( &CDIOC|151);}' unless defined(&CDROMPAUSE);
    eval 'sub CDROMRESUME () {( &CDIOC|152);}' unless defined(&CDROMRESUME);
    eval 'sub CDROMPLAYMSF () {( &CDIOC|153);}' unless defined(&CDROMPLAYMSF);
    eval 'sub CDROMPLAYTRKIND () {( &CDIOC|154);}' unless defined(&CDROMPLAYTRKIND);
    eval 'sub CDROMREADTOCHDR () {( &CDIOC|155);}' unless defined(&CDROMREADTOCHDR);
    eval 'sub CDROMREADTOCENTRY () {( &CDIOC|156);}' unless defined(&CDROMREADTOCENTRY);
    eval 'sub CDROMSTOP () {( &CDIOC|157);}' unless defined(&CDROMSTOP);
    eval 'sub CDROMSTART () {( &CDIOC|158);}' unless defined(&CDROMSTART);
    eval 'sub CDROMEJECT () {( &CDIOC|159);}' unless defined(&CDROMEJECT);
    eval 'sub CDROMVOLCTRL () {( &CDIOC|160);}' unless defined(&CDROMVOLCTRL);
    eval 'sub CDROMSUBCHNL () {( &CDIOC|161);}' unless defined(&CDROMSUBCHNL);
    eval 'sub CDROMREADMODE2 () {( &CDIOC|162);}' unless defined(&CDROMREADMODE2);
    eval 'sub CDROMREADMODE1 () {( &CDIOC|163);}' unless defined(&CDROMREADMODE1);
    eval 'sub CDROMREADOFFSET () {( &CDIOC|164);}' unless defined(&CDROMREADOFFSET);
    eval 'sub CDROMGBLKMODE () {( &CDIOC|165);}' unless defined(&CDROMGBLKMODE);
    eval 'sub CDROMSBLKMODE () {( &CDIOC|166);}' unless defined(&CDROMSBLKMODE);
    eval 'sub CDROMCDDA () {( &CDIOC|167);}' unless defined(&CDROMCDDA);
    eval 'sub CDROMCDXA () {( &CDIOC|168);}' unless defined(&CDROMCDXA);
    eval 'sub CDROMSUBCODE () {( &CDIOC|169);}' unless defined(&CDROMSUBCODE);
    eval 'sub CDROMGDRVSPEED () {( &CDIOC|170);}' unless defined(&CDROMGDRVSPEED);
    eval 'sub CDROMSDRVSPEED () {( &CDIOC|171);}' unless defined(&CDROMSDRVSPEED);
    eval 'sub SCMD_READ_TOC () {0x43;}' unless defined(&SCMD_READ_TOC);
    eval 'sub SCMD_PLAYAUDIO_MSF () {0x47;}' unless defined(&SCMD_PLAYAUDIO_MSF);
    eval 'sub SCMD_PLAYAUDIO_TI () {0x48;}' unless defined(&SCMD_PLAYAUDIO_TI);
    eval 'sub SCMD_PAUSE_RESUME () {0x4b;}' unless defined(&SCMD_PAUSE_RESUME);
    eval 'sub SCMD_READ_SUBCHANNEL () {0x42;}' unless defined(&SCMD_READ_SUBCHANNEL);
    eval 'sub SCMD_PLAYAUDIO10 () {0x45;}' unless defined(&SCMD_PLAYAUDIO10);
    eval 'sub SCMD_PLAYTRACK_REL10 () {0x49;}' unless defined(&SCMD_PLAYTRACK_REL10);
    eval 'sub SCMD_READ_HEADER () {0x44;}' unless defined(&SCMD_READ_HEADER);
    eval 'sub SCMD_PLAYAUDIO12 () {0xa5;}' unless defined(&SCMD_PLAYAUDIO12);
    eval 'sub SCMD_PLAYTRACK_REL12 () {0xa9;}' unless defined(&SCMD_PLAYTRACK_REL12);
    eval 'sub SCMD_READ_CD () {0xbe;}' unless defined(&SCMD_READ_CD);
    eval 'sub READ_CD_EST_ALLTYPE () {0x;}' unless defined(&READ_CD_EST_ALLTYPE);
    eval 'sub READ_CD_EST_CDDA () {0x1;}' unless defined(&READ_CD_EST_CDDA);
    eval 'sub READ_CD_EST_MODE1 () {0x2;}' unless defined(&READ_CD_EST_MODE1);
    eval 'sub READ_CD_EST_MODE2 () {0x3;}' unless defined(&READ_CD_EST_MODE2);
    eval 'sub READ_CD_EST_MODE2FORM1 () {0x4;}' unless defined(&READ_CD_EST_MODE2FORM1);
    eval 'sub READ_CD_EST_MODE2FORM2 () {0x5;}' unless defined(&READ_CD_EST_MODE2FORM2);
    eval 'sub READ_CD_EST_RSVD1 () {0x6;}' unless defined(&READ_CD_EST_RSVD1);
    eval 'sub READ_CD_EST_RSVD2 () {0x7;}' unless defined(&READ_CD_EST_RSVD2);
    eval 'sub SCMD_CD_PLAYBACK_CONTROL () {0xc9;}' unless defined(&SCMD_CD_PLAYBACK_CONTROL);
    eval 'sub SCMD_CD_PLAYBACK_STATUS () {0xc4;}' unless defined(&SCMD_CD_PLAYBACK_STATUS);
    eval 'sub SCMD_READ_CDDA () {0xd8;}' unless defined(&SCMD_READ_CDDA);
    eval 'sub SCMD_READ_CDXA () {0xdb;}' unless defined(&SCMD_READ_CDXA);
    eval 'sub SCMD_READ_ALL_SUBCODES () {0xdf;}' unless defined(&SCMD_READ_ALL_SUBCODES);
    eval 'sub CDROM_MODE2_SIZE () {2336;}' unless defined(&CDROM_MODE2_SIZE);
    if(defined(&__cplusplus)) {
    }
}
1;
