require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_CIS_HANDLERS_H)) {
    eval 'sub _CIS_HANDLERS_H () {1;}' unless defined(&_CIS_HANDLERS_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub HANDTPL_NOERROR () {0x;}' unless defined(&HANDTPL_NOERROR);
    eval 'sub HANDTPL_SET_FLAGS () {0x1;}' unless defined(&HANDTPL_SET_FLAGS);
    eval 'sub HANDTPL_COPY_DONE () {0x2;}' unless defined(&HANDTPL_COPY_DONE);
    eval 'sub HANDTPL_PARSE_LTUPLE () {0x4;}' unless defined(&HANDTPL_PARSE_LTUPLE);
    eval 'sub HANDTPL_RETURN_NAME () {0x8;}' unless defined(&HANDTPL_RETURN_NAME);
    eval 'sub HANDTPL_ERROR () {0x1000000;}' unless defined(&HANDTPL_ERROR);
    eval 'sub CISTPL_EXT_BIT () {0x80;}' unless defined(&CISTPL_EXT_BIT);
    eval 'sub CISTPL_DEVSPEED_TABLE () {0x1;}' unless defined(&CISTPL_DEVSPEED_TABLE);
    eval 'sub CISTPL_DEVSPEED_EXT () {0x2;}' unless defined(&CISTPL_DEVSPEED_EXT);
    eval 'sub CISTPL_DEVSPEED_MAX_TBL () {8;}' unless defined(&CISTPL_DEVSPEED_MAX_TBL);
    eval 'sub CISTPL_DEVSPEED_MAX_EXP () {8;}' unless defined(&CISTPL_DEVSPEED_MAX_EXP);
    eval 'sub CISTPL_DEVSPEED_MAX_MAN () {16;}' unless defined(&CISTPL_DEVSPEED_MAX_MAN);
    eval 'sub CISTPL_DEVSPEED_TBL {
        my($t) = @_;
	    eval q( ($cistpl_devspeed_struct->{table[(t) &							(CISTPL_DEVSPEED_MAX_TBL }- 1)]));
    }' unless defined(&CISTPL_DEVSPEED_TBL);
    eval 'sub CISTPL_DEVSPEED_MAN {
        my($m) = @_;
	    eval q( ($cistpl_devspeed_struct->{mantissa[(m) &							(CISTPL_DEVSPEED_MAX_MAN }- 1)]));
    }' unless defined(&CISTPL_DEVSPEED_MAN);
    eval 'sub CISTPL_DEVSPEED_EXP {
        my($e) = @_;
	    eval q( ($cistpl_devspeed_struct->{exponent[(e) &							(CISTPL_DEVSPEED_MAX_EXP }- 1)]));
    }' unless defined(&CISTPL_DEVSPEED_EXP);
    eval 'sub CISTPL_DEVICE_DTYPE_NULL () {0x;}' unless defined(&CISTPL_DEVICE_DTYPE_NULL);
    eval 'sub CISTPL_DEVICE_DTYPE_ROM () {0x1;}' unless defined(&CISTPL_DEVICE_DTYPE_ROM);
    eval 'sub CISTPL_DEVICE_DTYPE_OTPROM () {0x2;}' unless defined(&CISTPL_DEVICE_DTYPE_OTPROM);
    eval 'sub CISTPL_DEVICE_DTYPE_EPROM () {0x3;}' unless defined(&CISTPL_DEVICE_DTYPE_EPROM);
    eval 'sub CISTPL_DEVICE_DTYPE_EEPROM () {0x4;}' unless defined(&CISTPL_DEVICE_DTYPE_EEPROM);
    eval 'sub CISTPL_DEVICE_DTYPE_FLASH () {0x5;}' unless defined(&CISTPL_DEVICE_DTYPE_FLASH);
    eval 'sub CISTPL_DEVICE_DTYPE_SRAM () {0x6;}' unless defined(&CISTPL_DEVICE_DTYPE_SRAM);
    eval 'sub CISTPL_DEVICE_DTYPE_DRAM () {0x7;}' unless defined(&CISTPL_DEVICE_DTYPE_DRAM);
    eval 'sub CISTPL_DEVICE_DTYPE_RSVD_8 () {0x8;}' unless defined(&CISTPL_DEVICE_DTYPE_RSVD_8);
    eval 'sub CISTPL_DEVICE_DTYPE_RSVD_9 () {0x9;}' unless defined(&CISTPL_DEVICE_DTYPE_RSVD_9);
    eval 'sub CISTPL_DEVICE_DTYPE_RSVD_a () {0xa;}' unless defined(&CISTPL_DEVICE_DTYPE_RSVD_a);
    eval 'sub CISTPL_DEVICE_DTYPE_RSVD_b () {0xb;}' unless defined(&CISTPL_DEVICE_DTYPE_RSVD_b);
    eval 'sub CISTPL_DEVICE_DTYPE_RSVD_c () {0xc;}' unless defined(&CISTPL_DEVICE_DTYPE_RSVD_c);
    eval 'sub CISTPL_DEVICE_DTYPE_FUNCSPEC () {0xd;}' unless defined(&CISTPL_DEVICE_DTYPE_FUNCSPEC);
    eval 'sub CISTPL_DEVICE_DTYPE_EXTEND () {0xe;}' unless defined(&CISTPL_DEVICE_DTYPE_EXTEND);
    eval 'sub CISTPL_DEVICE_DTYPE_RSVD_f () {0xf;}' unless defined(&CISTPL_DEVICE_DTYPE_RSVD_f);
    eval 'sub CISTPL_DEVICE_WPS () {0x1;}' unless defined(&CISTPL_DEVICE_WPS);
    eval 'sub CISTPL_DEVICE_OC_MWAIT () {0x10000;}' unless defined(&CISTPL_DEVICE_OC_MWAIT);
    eval 'sub CISTPL_DEVICE_OC_Vcc_MASK () {0x60000;}' unless defined(&CISTPL_DEVICE_OC_Vcc_MASK);
    eval 'sub CISTPL_DEVICE_OC_Vcc5 () {0x;}' unless defined(&CISTPL_DEVICE_OC_Vcc5);
    eval 'sub CISTPL_DEVICE_OC_Vcc33 () {0x20000;}' unless defined(&CISTPL_DEVICE_OC_Vcc33);
    eval 'sub CISTPL_DEVICE_OC_VccXX () {0x40000;}' unless defined(&CISTPL_DEVICE_OC_VccXX);
    eval 'sub CISTPL_DEVICE_OC_VccYY () {0x60000;}' unless defined(&CISTPL_DEVICE_OC_VccYY);
    eval 'sub CISTPL_DEVICE_MAX_DEVICES () {10;}' unless defined(&CISTPL_DEVICE_MAX_DEVICES);
    eval 'sub CISTPL_DEVICE_SPEED_SIZE_IGNORE () {0xff;}' unless defined(&CISTPL_DEVICE_SPEED_SIZE_IGNORE);
    eval 'sub MAKE_CONFIG_REG_ADDR {
        my($base, $reg) = @_;
	    eval q(($base + ($reg * 2)));
    }' unless defined(&MAKE_CONFIG_REG_ADDR);
    eval 'sub CISTPL_CONFIG_MAX_CONFIG_REGS () {128;}' unless defined(&CISTPL_CONFIG_MAX_CONFIG_REGS);
    eval 'sub CISTPL_VERS_1_MAX_PROD_STRINGS () {4;}' unless defined(&CISTPL_VERS_1_MAX_PROD_STRINGS);
    eval 'sub CISTPL_JEDEC_MAX_IDENTIFIERS () {4;}' unless defined(&CISTPL_JEDEC_MAX_IDENTIFIERS);
    eval 'sub TPLFMTTYPE_DISK () {0x;}' unless defined(&TPLFMTTYPE_DISK);
    eval 'sub TPLFMTTYPE_MEM () {0x1;}' unless defined(&TPLFMTTYPE_MEM);
    eval 'sub TPLFMTTYPE_VS () {0x80;}' unless defined(&TPLFMTTYPE_VS);
    eval 'sub TPLFMTEDC_NONE () {0x;}' unless defined(&TPLFMTEDC_NONE);
    eval 'sub TPLFMTEDC_CKSUM () {0x1;}' unless defined(&TPLFMTEDC_CKSUM);
    eval 'sub TPLFMTEDC_CRC () {0x2;}' unless defined(&TPLFMTEDC_CRC);
    eval 'sub TPLFMTEDC_PCC () {0x3;}' unless defined(&TPLFMTEDC_PCC);
    eval 'sub TPLFMTEDC_VS () {0x80;}' unless defined(&TPLFMTEDC_VS);
    eval 'sub EDC_LENGTH_MASK () {0x7;}' unless defined(&EDC_LENGTH_MASK);
    eval 'sub EDC_TYPE_MASK () {0xf;}' unless defined(&EDC_TYPE_MASK);
    eval 'sub EDC_TYPE_SHIFT () {3;}' unless defined(&EDC_TYPE_SHIFT);
    eval 'sub TPLFMTFLAGS_ADDR () {0x1;}' unless defined(&TPLFMTFLAGS_ADDR);
    eval 'sub TPLFMTFLAGS_AUTO () {0x2;}' unless defined(&TPLFMTFLAGS_AUTO);
    eval 'sub TPLBYTEORD_LOW () {0x;}' unless defined(&TPLBYTEORD_LOW);
    eval 'sub TPLBYTEORD_HIGH () {0x1;}' unless defined(&TPLBYTEORD_HIGH);
    eval 'sub TPLBYTEORD_VS () {0x80;}' unless defined(&TPLBYTEORD_VS);
    eval 'sub TPLBYTEMAP_LOW () {0x;}' unless defined(&TPLBYTEMAP_LOW);
    eval 'sub TPLBYTEMAP_HIGH () {0x1;}' unless defined(&TPLBYTEMAP_HIGH);
    eval 'sub TPLBYTEMAP_VS () {0x80;}' unless defined(&TPLBYTEMAP_VS);
    eval 'sub TPLFUNC_MULTI () {0x;}' unless defined(&TPLFUNC_MULTI);
    eval 'sub TPLFUNC_MEMORY () {0x1;}' unless defined(&TPLFUNC_MEMORY);
    eval 'sub TPLFUNC_SERIAL () {0x2;}' unless defined(&TPLFUNC_SERIAL);
    eval 'sub TPLFUNC_PARALLEL () {0x3;}' unless defined(&TPLFUNC_PARALLEL);
    eval 'sub TPLFUNC_FIXED () {0x4;}' unless defined(&TPLFUNC_FIXED);
    eval 'sub TPLFUNC_VIDEO () {0x5;}' unless defined(&TPLFUNC_VIDEO);
    eval 'sub TPLFUNC_LAN () {0x6;}' unless defined(&TPLFUNC_LAN);
    eval 'sub TPLFUNC_AIMS () {0x7;}' unless defined(&TPLFUNC_AIMS);
    eval 'sub TPLFUNC_SCSI () {0x8;}' unless defined(&TPLFUNC_SCSI);
    eval 'sub TPLFUNC_SECURITY () {0x9;}' unless defined(&TPLFUNC_SECURITY);
    eval 'sub TPLFUNC_VENDOR_SPECIFIC () {0xfe;}' unless defined(&TPLFUNC_VENDOR_SPECIFIC);
    eval 'sub TPLFUNC_UNKNOWN () {0xff;}' unless defined(&TPLFUNC_UNKNOWN);
    eval 'sub TPLINIT_POST () {0x1;}' unless defined(&TPLINIT_POST);
    eval 'sub TPLINIT_ROM () {0x2;}' unless defined(&TPLINIT_ROM);
    eval 'sub TPLFE_SUB_SERIAL () {0;}' unless defined(&TPLFE_SUB_SERIAL);
    eval 'sub TPLFE_SUB_MODEM_COMMON () {1;}' unless defined(&TPLFE_SUB_MODEM_COMMON);
    eval 'sub TPLFE_SUB_MODEM_DATA () {2;}' unless defined(&TPLFE_SUB_MODEM_DATA);
    eval 'sub TPLFE_SUB_MODEM_FAX () {3;}' unless defined(&TPLFE_SUB_MODEM_FAX);
    eval 'sub TPLFE_SUB_VOICE () {4;}' unless defined(&TPLFE_SUB_VOICE);
    eval 'sub TPLFE_CAP_MODEM_DATA () {5;}' unless defined(&TPLFE_CAP_MODEM_DATA);
    eval 'sub TPLFE_CAP_MODEM_FAX () {6;}' unless defined(&TPLFE_CAP_MODEM_FAX);
    eval 'sub TPLFE_CAP_MODEM_VOICE () {7;}' unless defined(&TPLFE_CAP_MODEM_VOICE);
    eval 'sub TPLFE_CAP_SERIAL_DATA () {8;}' unless defined(&TPLFE_CAP_SERIAL_DATA);
    eval 'sub TPLFE_CAP_SERIAL_FAX () {9;}' unless defined(&TPLFE_CAP_SERIAL_FAX);
    eval 'sub TPLFE_CAP_SERIAL_VOICE () {10;}' unless defined(&TPLFE_CAP_SERIAL_VOICE);
    eval 'sub TPLFE_UA_8250 () {0;}' unless defined(&TPLFE_UA_8250);
    eval 'sub TPLFE_UA_16450 () {1;}' unless defined(&TPLFE_UA_16450);
    eval 'sub TPLFE_UA_16550 () {2;}' unless defined(&TPLFE_UA_16550);
    eval 'sub TPLFE_UC_PARITY_SPACE () {0x1;}' unless defined(&TPLFE_UC_PARITY_SPACE);
    eval 'sub TPLFE_UC_PARITY_MARK () {0x2;}' unless defined(&TPLFE_UC_PARITY_MARK);
    eval 'sub TPLFE_UC_PARITY_ODD () {0x4;}' unless defined(&TPLFE_UC_PARITY_ODD);
    eval 'sub TPLFE_UC_PARITY_EVEN () {0x8;}' unless defined(&TPLFE_UC_PARITY_EVEN);
    eval 'sub TPLFE_UC_CS5 () {0x100;}' unless defined(&TPLFE_UC_CS5);
    eval 'sub TPLFE_UC_CS6 () {0x200;}' unless defined(&TPLFE_UC_CS6);
    eval 'sub TPLFE_UC_CS7 () {0x400;}' unless defined(&TPLFE_UC_CS7);
    eval 'sub TPLFE_UC_CS8 () {0x800;}' unless defined(&TPLFE_UC_CS8);
    eval 'sub TPLFE_UC_STOP_1 () {0x1000;}' unless defined(&TPLFE_UC_STOP_1);
    eval 'sub TPLFE_UC_STOP_15 () {0x2000;}' unless defined(&TPLFE_UC_STOP_15);
    eval 'sub TPLFE_UC_STOP_2 () {0x4000;}' unless defined(&TPLFE_UC_STOP_2);
    eval 'sub TPLFE_FC_TX_XONOFF () {0x1;}' unless defined(&TPLFE_FC_TX_XONOFF);
    eval 'sub TPLFE_FC_RX_XONOFF () {0x2;}' unless defined(&TPLFE_FC_RX_XONOFF);
    eval 'sub TPLFE_FC_TX_HW () {0x4;}' unless defined(&TPLFE_FC_TX_HW);
    eval 'sub TPLFE_FC_RX_HW () {0x8;}' unless defined(&TPLFE_FC_RX_HW);
    eval 'sub TPLFE_FC_TRANS () {0x10;}' unless defined(&TPLFE_FC_TRANS);
    eval 'sub TPLFE_MS_BELL103 () {0x1;}' unless defined(&TPLFE_MS_BELL103);
    eval 'sub TPLFE_MS_V21 () {0x2;}' unless defined(&TPLFE_MS_V21);
    eval 'sub TPLFE_MS_V23 () {0x4;}' unless defined(&TPLFE_MS_V23);
    eval 'sub TPLFE_MS_V22AB () {0x8;}' unless defined(&TPLFE_MS_V22AB);
    eval 'sub TPLFE_MS_BELL212 () {0x10;}' unless defined(&TPLFE_MS_BELL212);
    eval 'sub TPLFE_MS_V22BIS () {0x20;}' unless defined(&TPLFE_MS_V22BIS);
    eval 'sub TPLFE_MS_V26 () {0x40;}' unless defined(&TPLFE_MS_V26);
    eval 'sub TPLFE_MS_V26BIS () {0x80;}' unless defined(&TPLFE_MS_V26BIS);
    eval 'sub TPLFE_MS_V27BIS () {0x100;}' unless defined(&TPLFE_MS_V27BIS);
    eval 'sub TPLFE_MS_V29 () {0x200;}' unless defined(&TPLFE_MS_V29);
    eval 'sub TPLFE_MS_V32 () {0x400;}' unless defined(&TPLFE_MS_V32);
    eval 'sub TPLFE_MS_V32BIS () {0x800;}' unless defined(&TPLFE_MS_V32BIS);
    eval 'sub TPLFE_MS_VFAST () {0x1000;}' unless defined(&TPLFE_MS_VFAST);
    eval 'sub TPLFE_EM_MNP () {0x1;}' unless defined(&TPLFE_EM_MNP);
    eval 'sub TPLFE_EM_V42 () {0x2;}' unless defined(&TPLFE_EM_V42);
    eval 'sub TPLFE_DC_V42BIS () {0x1;}' unless defined(&TPLFE_DC_V42BIS);
    eval 'sub TPLFE_DC_MNP5 () {0x2;}' unless defined(&TPLFE_DC_MNP5);
    eval 'sub TPLFE_CM_AT1 () {0x1;}' unless defined(&TPLFE_CM_AT1);
    eval 'sub TPLFE_CM_AT2 () {0x2;}' unless defined(&TPLFE_CM_AT2);
    eval 'sub TPLFE_CM_AT3 () {0x4;}' unless defined(&TPLFE_CM_AT3);
    eval 'sub TPLFE_CM_MNP_AT () {0x8;}' unless defined(&TPLFE_CM_MNP_AT);
    eval 'sub TPLFE_CM_V25BIS () {0x10;}' unless defined(&TPLFE_CM_V25BIS);
    eval 'sub TPLFE_CM_V25A () {0x20;}' unless defined(&TPLFE_CM_V25A);
    eval 'sub TPLFE_CM_DMCL () {0x40;}' unless defined(&TPLFE_CM_DMCL);
    eval 'sub TPLFE_EX_BREAK () {0x1;}' unless defined(&TPLFE_EX_BREAK);
    eval 'sub TPLFE_EX_PLUS () {0x2;}' unless defined(&TPLFE_EX_PLUS);
    eval 'sub TPLFE_EX_UD () {0x4;}' unless defined(&TPLFE_EX_UD);
    eval 'sub TPLFE_EF_CALLERID () {0x1;}' unless defined(&TPLFE_EF_CALLERID);
    eval 'sub TPLFE_FM_V21C2 () {0x1;}' unless defined(&TPLFE_FM_V21C2);
    eval 'sub TPLFE_FM_V27TER () {0x2;}' unless defined(&TPLFE_FM_V27TER);
    eval 'sub TPLFE_FM_V29 () {0x4;}' unless defined(&TPLFE_FM_V29);
    eval 'sub TPLFE_FM_V17 () {0x8;}' unless defined(&TPLFE_FM_V17);
    eval 'sub TPLFE_FM_V33 () {0x10;}' unless defined(&TPLFE_FM_V33);
    eval 'sub TPLFE_FS_T3 () {0x1;}' unless defined(&TPLFE_FS_T3);
    eval 'sub TPLFE_FS_T4 () {0x2;}' unless defined(&TPLFE_FS_T4);
    eval 'sub TPLFE_FS_T6 () {0x4;}' unless defined(&TPLFE_FS_T6);
    eval 'sub TPLFE_FS_ECM () {0x8;}' unless defined(&TPLFE_FS_ECM);
    eval 'sub TPLFE_FS_VOICEREQ () {0x10;}' unless defined(&TPLFE_FS_VOICEREQ);
    eval 'sub TPLFE_FS_POLLING () {0x20;}' unless defined(&TPLFE_FS_POLLING);
    eval 'sub TPLFE_FS_FTP () {0x40;}' unless defined(&TPLFE_FS_FTP);
    eval 'sub TPLFE_FS_PASSWORD () {0x80;}' unless defined(&TPLFE_FS_PASSWORD);
    eval 'sub TPLFE_NETWORK_INFO () {0x;}' unless defined(&TPLFE_NETWORK_INFO);
    eval 'sub TPLFE_LAN_TECH_ARCNET () {1;}' unless defined(&TPLFE_LAN_TECH_ARCNET);
    eval 'sub TPLFE_LAN_TECH_ETHERNET () {2;}' unless defined(&TPLFE_LAN_TECH_ETHERNET);
    eval 'sub TPLFE_LAN_TECH_TOKENRING () {3;}' unless defined(&TPLFE_LAN_TECH_TOKENRING);
    eval 'sub TPLFE_LAN_TECH_LOCALTALK () {4;}' unless defined(&TPLFE_LAN_TECH_LOCALTALK);
    eval 'sub TPLFE_LAN_TECH_FDDI () {5;}' unless defined(&TPLFE_LAN_TECH_FDDI);
    eval 'sub TPLFE_LAN_TECH_ATM () {6;}' unless defined(&TPLFE_LAN_TECH_ATM);
    eval 'sub TPLFE_LAN_TECH_WIRELESS () {7;}' unless defined(&TPLFE_LAN_TECH_WIRELESS);
    eval 'sub TPLFE_LAN_MEDIA_INHERENT () {0;}' unless defined(&TPLFE_LAN_MEDIA_INHERENT);
    eval 'sub TPLFE_LAN_MEDIA_UTP () {1;}' unless defined(&TPLFE_LAN_MEDIA_UTP);
    eval 'sub TPLFE_LAN_MEDIA_STP () {2;}' unless defined(&TPLFE_LAN_MEDIA_STP);
    eval 'sub TPLFE_LAN_MEDIA_THIN_COAX () {3;}' unless defined(&TPLFE_LAN_MEDIA_THIN_COAX);
    eval 'sub TPLFE_LAN_MEDIA_THICK_COAX () {4;}' unless defined(&TPLFE_LAN_MEDIA_THICK_COAX);
    eval 'sub TPLFE_LAN_MEDIA_FIBER () {5;}' unless defined(&TPLFE_LAN_MEDIA_FIBER);
    eval 'sub TPLFE_LAN_MEDIA_SSR_902 () {6;}' unless defined(&TPLFE_LAN_MEDIA_SSR_902);
    eval 'sub TPLFE_LAN_MEDIA_SSR_2_4 () {7;}' unless defined(&TPLFE_LAN_MEDIA_SSR_2_4);
    eval 'sub TPLFE_LAN_MEDIA_SSR_5_4 () {8;}' unless defined(&TPLFE_LAN_MEDIA_SSR_5_4);
    eval 'sub TPLFE_LAN_MEDIA_DIFFUSE_IR () {9;}' unless defined(&TPLFE_LAN_MEDIA_DIFFUSE_IR);
    eval 'sub TPLFE_LAN_MEDIA_PTP_IR () {10;}' unless defined(&TPLFE_LAN_MEDIA_PTP_IR);
    eval 'sub CISTPL_CFTABLE_TPCE_CFGENTRYM () {0x3f;}' unless defined(&CISTPL_CFTABLE_TPCE_CFGENTRYM);
    eval 'sub CISTPL_CFTABLE_TPCE_DEFAULTM () {0x40;}' unless defined(&CISTPL_CFTABLE_TPCE_DEFAULTM);
    eval 'sub CISTPL_CFTABLE_TPCE_IFM () {0x80;}' unless defined(&CISTPL_CFTABLE_TPCE_IFM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_PWRM () {0x3;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_PWRM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_PWR_VPP2M () {0x3;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_PWR_VPP2M);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_PWR_VPP1M () {0x2;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_PWR_VPP1M);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_PWR_VCCM () {0x1;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_PWR_VCCM);
    eval 'sub CISTPL_CFTABLE_PD_NC_SLEEPM () {0x7d;}' unless defined(&CISTPL_CFTABLE_PD_NC_SLEEPM);
    eval 'sub CISTPL_CFTABLE_PD_ZEROM () {0x7e;}' unless defined(&CISTPL_CFTABLE_PD_ZEROM);
    eval 'sub CISTPL_CFTABLE_PD_NCM () {0x7f;}' unless defined(&CISTPL_CFTABLE_PD_NCM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_TDM () {0x4;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_TDM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_TD_WAITM () {0x3;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_TD_WAITM);
    eval 'sub GET_TPCE_FS_TD_WAITS {
        my($sf) = @_;
	    eval q((($sf)&  &CISTPL_CFTABLE_TPCE_FS_TD_WAITM));
    }' unless defined(&GET_TPCE_FS_TD_WAITS);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_TD_RDYM () {0x1c;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_TD_RDYM);
    eval 'sub GET_TPCE_FS_TD_RDYS {
        my($sf) = @_;
	    eval q(((($sf)>>2)&  &CISTPL_CFTABLE_TPCE_FS_TD_RDYM));
    }' unless defined(&GET_TPCE_FS_TD_RDYS);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_TD_RSVDM () {0xe0;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_TD_RSVDM);
    eval 'sub GET_TPCE_FS_TD_RSVDS {
        my($sf) = @_;
	    eval q(((($sf)>>5)&  &CISTPL_CFTABLE_TPCE_FS_TD_RSVDM));
    }' unless defined(&GET_TPCE_FS_TD_RSVDS);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IOM () {0x8;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IOM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IO_ALM () {0x1f;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IO_ALM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IO_RANGEM () {0x80;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IO_RANGEM);
    eval 'sub CISTPL_CFTABLE_ENTRY_MAX_IO_RANGES () {16;}' unless defined(&CISTPL_CFTABLE_ENTRY_MAX_IO_RANGES);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IRQM () {0x10;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IRQM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IRQ_MASKM () {0x10;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IRQ_MASKM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEMM () {0x60;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEMM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM3M () {0x60;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM3M);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM2M () {0x40;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM2M);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM1M () {0x20;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM1M);
    eval 'sub CISTPL_CFTABLE_ENTRY_MAX_MEM_WINDOWS () {8;}' unless defined(&CISTPL_CFTABLE_ENTRY_MAX_MEM_WINDOWS);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM_PGSIZE () {256;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM_PGSIZE);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM_HOSTM () {0x80;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM_HOSTM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MISCM () {0x80;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MISCM);
    eval 'sub CISTPL_PD_MAN {
        my($m) = @_;
	    eval q( ($cistpl_pd_struct->{mantissa[$m&15]}));
    }' unless defined(&CISTPL_PD_MAN);
    eval 'sub CISTPL_PD_EXP {
        my($e) = @_;
	    eval q( ($cistpl_pd_struct->{exponent[$e&7]}));
    }' unless defined(&CISTPL_PD_EXP);
    eval 'sub CISTPL_CFTABLE_TPCE_DEFAULT () {0x100;}' unless defined(&CISTPL_CFTABLE_TPCE_DEFAULT);
    eval 'sub CISTPL_CFTABLE_TPCE_IF () {0x200;}' unless defined(&CISTPL_CFTABLE_TPCE_IF);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_MEMORY () {0x;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_MEMORY);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_IO_MEM () {0x1;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_IO_MEM);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_2 () {0x2;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_2);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_3 () {0x3;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_3);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_CUSTOM_0 () {0x4;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_CUSTOM_0);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_CUSTOM_1 () {0x5;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_CUSTOM_1);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_CUSTOM_2 () {0x6;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_CUSTOM_2);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_CUSTOM_3 () {0x7;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_CUSTOM_3);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_8 () {0x8;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_8);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_9 () {0x9;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_9);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_a () {0xa;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_a);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_b () {0xb;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_b);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_c () {0xc;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_c);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_d () {0xd;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_d);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_e () {0xe;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_e);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RSVD_f () {0xf;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RSVD_f);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_MASK () {0xf;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_MASK);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_BVD () {0x10;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_BVD);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_WP () {0x20;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_WP);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_RDY () {0x40;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_RDY);
    eval 'sub CISTPL_CFTABLE_TPCE_IF_MWAIT () {0x80;}' unless defined(&CISTPL_CFTABLE_TPCE_IF_MWAIT);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_PWR () {0x1000;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_PWR);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_TD () {0x10000;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_TD);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IO () {0x100000;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IO);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IRQ () {0x200000;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IRQ);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM () {0x1000000;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MISC () {0x2000000;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MISC);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_STCE_EV () {0x4000000;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_STCE_EV);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_STCE_PD () {0x8000000;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_STCE_PD);
    eval 'sub CISTPL_CFTABLE_PD_NOMV () {0x1;}' unless defined(&CISTPL_CFTABLE_PD_NOMV);
    eval 'sub CISTPL_CFTABLE_PD_MINV () {0x2;}' unless defined(&CISTPL_CFTABLE_PD_MINV);
    eval 'sub CISTPL_CFTABLE_PD_MAXV () {0x4;}' unless defined(&CISTPL_CFTABLE_PD_MAXV);
    eval 'sub CISTPL_CFTABLE_PD_STATICI () {0x8;}' unless defined(&CISTPL_CFTABLE_PD_STATICI);
    eval 'sub CISTPL_CFTABLE_PD_AVGI () {0x10;}' unless defined(&CISTPL_CFTABLE_PD_AVGI);
    eval 'sub CISTPL_CFTABLE_PD_PEAKI () {0x20;}' unless defined(&CISTPL_CFTABLE_PD_PEAKI);
    eval 'sub CISTPL_CFTABLE_PD_PDOWNI () {0x40;}' unless defined(&CISTPL_CFTABLE_PD_PDOWNI);
    eval 'sub CISTPL_CFTABLE_PD_RFU () {0x80;}' unless defined(&CISTPL_CFTABLE_PD_RFU);
    eval 'sub CISTPL_CFTABLE_PD_EXISTS () {0x100;}' unless defined(&CISTPL_CFTABLE_PD_EXISTS);
    eval 'sub CISTPL_CFTABLE_PD_MUL10 () {0x200;}' unless defined(&CISTPL_CFTABLE_PD_MUL10);
    eval 'sub CISTPL_CFTABLE_PD_NC_SLEEP () {0x1000;}' unless defined(&CISTPL_CFTABLE_PD_NC_SLEEP);
    eval 'sub CISTPL_CFTABLE_PD_ZERO () {0x2000;}' unless defined(&CISTPL_CFTABLE_PD_ZERO);
    eval 'sub CISTPL_CFTABLE_PD_NC () {0x4000;}' unless defined(&CISTPL_CFTABLE_PD_NC);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_PWR_VCC () {0x1;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_PWR_VCC);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_PWR_VPP1 () {0x2;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_PWR_VPP1);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_PWR_VPP2 () {0x4;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_PWR_VPP2);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_TD_WAIT () {0x1;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_TD_WAIT);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_TD_RDY () {0x2;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_TD_RDY);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_TD_RSVD () {0x4;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_TD_RSVD);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IO_BUS () {0x60;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IO_BUS);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IO_BUS8 () {0x20;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IO_BUS8);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IO_BUS16 () {0x40;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IO_BUS16);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_IO_RANGE () {0x80;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_IO_RANGE);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM3 () {0x1;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM3);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM2 () {0x2;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM2);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM1 () {0x4;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM1);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MEM_HOST () {0x8;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MEM_HOST);
    eval 'sub CISTPL_CFTABLE_TPCE_FS_MISC_MAX () {2;}' unless defined(&CISTPL_CFTABLE_TPCE_FS_MISC_MAX);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_MTC_MASK () {0x7;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_MTC_MASK);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_AUDIO () {0x8;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_AUDIO);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_READONLY () {0x10;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_READONLY);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_PWRDOWN () {0x20;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_PWRDOWN);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_DRQ_MASK () {0xc00;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_DRQ_MASK);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_DRQ_SPK () {0x400;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_DRQ_SPK);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_DRQ_IOIS () {0x800;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_DRQ_IOIS);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_DRQ_INP () {0xc00;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_DRQ_INP);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_DMA_8 () {0x;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_DMA_8);
    eval 'sub CISTPL_CFTABLE_TPCE_MI_DMA_16 () {0x1000;}' unless defined(&CISTPL_CFTABLE_TPCE_MI_DMA_16);
    eval 'sub STCE_EV () {0xc0;}' unless defined(&STCE_EV);
    eval 'sub STCE_PD () {0xc1;}' unless defined(&STCE_PD);
    eval 'sub MIN_LINKTARGET_LENGTH () {3;}' unless defined(&MIN_LINKTARGET_LENGTH);
    eval 'sub CISTPL_LINKTARGET_MAGIC () {"CIS";}' unless defined(&CISTPL_LINKTARGET_MAGIC);
    eval 'sub LINKTARGET_AC_HEADER_LENGTH () {2;}' unless defined(&LINKTARGET_AC_HEADER_LENGTH);
    eval 'sub MIN_LONGLINK_AC_LENGTH () {4;}' unless defined(&MIN_LONGLINK_AC_LENGTH);
    eval 'sub CISTPL_LONGLINK_AC_AM () {0x1;}' unless defined(&CISTPL_LONGLINK_AC_AM);
    eval 'sub CISTPL_LONGLINK_AC_CM () {0x2;}' unless defined(&CISTPL_LONGLINK_AC_CM);
    eval 'sub MIN_LONGLINK_MFC_LENGTH () {6;}' unless defined(&MIN_LONGLINK_MFC_LENGTH);
    eval 'sub MIN_LONGLINK_MFC_NREGS () {1;}' unless defined(&MIN_LONGLINK_MFC_NREGS);
    eval 'sub CISTPL_LONGLINK_MFC_TAS_AM () {0x;}' unless defined(&CISTPL_LONGLINK_MFC_TAS_AM);
    eval 'sub CISTPL_LONGLINK_MFC_TAS_CM () {0x1;}' unless defined(&CISTPL_LONGLINK_MFC_TAS_CM);
    eval 'sub CISTPL_LONGLINK_CB_CFG () {0x1;}' unless defined(&CISTPL_LONGLINK_CB_CFG);
    eval 'sub CISTPL_LONGLINK_CB_MEM () {0x2;}' unless defined(&CISTPL_LONGLINK_CB_MEM);
    eval 'sub CISTPL_LONGLINK_CB_ROM () {0x4;}' unless defined(&CISTPL_LONGLINK_CB_ROM);
    eval 'sub CISTPL_SPCL_SEQ_END () {0x80;}' unless defined(&CISTPL_SPCL_SEQ_END);
    eval 'sub CISTPL_BAR_ASI_MASK () {0x7;}' unless defined(&CISTPL_BAR_ASI_MASK);
    eval 'sub CISTPL_BAR_ASI_BAR_1 () {0x1;}' unless defined(&CISTPL_BAR_ASI_BAR_1);
    eval 'sub CISTPL_BAR_ASI_BAR_2 () {0x2;}' unless defined(&CISTPL_BAR_ASI_BAR_2);
    eval 'sub CISTPL_BAR_ASI_BAR_3 () {0x3;}' unless defined(&CISTPL_BAR_ASI_BAR_3);
    eval 'sub CISTPL_BAR_ASI_BAR_4 () {0x4;}' unless defined(&CISTPL_BAR_ASI_BAR_4);
    eval 'sub CISTPL_BAR_ASI_BAR_5 () {0x5;}' unless defined(&CISTPL_BAR_ASI_BAR_5);
    eval 'sub CISTPL_BAR_ASI_BAR_6 () {0x6;}' unless defined(&CISTPL_BAR_ASI_BAR_6);
    eval 'sub CISTPL_BAR_ASI_BAR_7 () {0x7;}' unless defined(&CISTPL_BAR_ASI_BAR_7);
    eval 'sub CISTPL_BAR_ASI_EXP_ROM () {0x7;}' unless defined(&CISTPL_BAR_ASI_EXP_ROM);
    eval 'sub CISTPL_BAR_AS_MEM () {0x;}' unless defined(&CISTPL_BAR_AS_MEM);
    eval 'sub CISTPL_BAR_AS_IO () {0x8;}' unless defined(&CISTPL_BAR_AS_IO);
    eval 'sub CISTPL_BAR_PREFETCH_CACHE_MASK () {0x60;}' unless defined(&CISTPL_BAR_PREFETCH_CACHE_MASK);
    eval 'sub CISTPL_BAR_PREFETCH () {0x20;}' unless defined(&CISTPL_BAR_PREFETCH);
    eval 'sub CISTPL_BAR_PREFETCH_CACHE () {0x40;}' unless defined(&CISTPL_BAR_PREFETCH_CACHE);
    eval 'sub CISTPL_BAR_BELOW_1MB () {0x80;}' unless defined(&CISTPL_BAR_BELOW_1MB);
    eval 'sub CISTPL_DEVICEGEO_MAX_PARTITIONS () {42;}' unless defined(&CISTPL_DEVICEGEO_MAX_PARTITIONS);
    if(defined(&__cplusplus)) {
    }
}
1;
