require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CONF_H)) {
    eval 'sub _SYS_CONF_H () {1;}' unless defined(&_SYS_CONF_H);
    require 'sys/feature_tests.ph';
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	require 'sys/t_lock.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub FMNAMESZ () {8;}' unless defined(&FMNAMESZ);
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	if(defined(&_KERNEL)) {
	    require 'sys/systm.ph';
	    require 'sys/devops.ph';
	    require 'sys/model.ph';
	    require 'sys/types.ph';
	    require 'sys/buf.ph';
	    require 'sys/cred.ph';
	    require 'sys/uio.ph';
	    require 'sys/poll.ph';
	    require 'vm/as.ph';
	    eval 'sub STREAMSTAB {
	        my($maj) = @_;
    		eval q(( $devopsp[($maj)] ==  &NULL ?  &NULL : ( ($devopsp[&(maj)]->{devo_cb_ops}) ==  &NULL ?  &NULL :  ($devopsp[&(maj)]->{devo_cb_ops}->{cb_str}))));
	    }' unless defined(&STREAMSTAB);
	}
	eval 'sub D_NEW () {0x;}' unless defined(&D_NEW);
	eval 'sub _D_OLD () {0x1;}' unless defined(&_D_OLD);
	eval 'sub D_TAPE () {0x8;}' unless defined(&D_TAPE);
	eval 'sub D_MTSAFE () {0x20;}' unless defined(&D_MTSAFE);
	eval 'sub _D_QNEXTLESS () {0x40;}' unless defined(&_D_QNEXTLESS);
	eval 'sub _D_MTOCSHARED () {0x80;}' unless defined(&_D_MTOCSHARED);
	eval 'sub D_MTOCEXCL () {0x800;}' unless defined(&D_MTOCEXCL);
	eval 'sub D_MTPUTSHARED () {0x1000;}' unless defined(&D_MTPUTSHARED);
	eval 'sub D_MTPERQ () {0x2000;}' unless defined(&D_MTPERQ);
	eval 'sub D_MTQPAIR () {0x4000;}' unless defined(&D_MTQPAIR);
	eval 'sub D_MTPERMOD () {0x6000;}' unless defined(&D_MTPERMOD);
	eval 'sub D_MTOUTPERIM () {0x8000;}' unless defined(&D_MTOUTPERIM);
	eval 'sub _D_MTCBSHARED () {0x10000;}' unless defined(&_D_MTCBSHARED);
	eval 'sub D_MTINNER_MASK () {( &D_MP| &D_MTPERQ| &D_MTQPAIR| &D_MTPERMOD);}' unless defined(&D_MTINNER_MASK);
	eval 'sub D_MTINNER_MOD () {( &D_MTPUTSHARED| &_D_MTOCSHARED| &_D_MTCBSHARED);}' unless defined(&D_MTINNER_MOD);
	eval 'sub D_MTOUTER_MOD () {( &D_MTOCEXCL);}' unless defined(&D_MTOUTER_MOD);
	eval 'sub D_MTSAFETY_MASK () {( &D_MTINNER_MASK| &D_MTOUTPERIM| &D_MTPUTSHARED|  &D_MTINNER_MOD| &D_MTOUTER_MOD);}' unless defined(&D_MTSAFETY_MASK);
	eval 'sub D_MP () { &D_MTSAFE;}' unless defined(&D_MP);
	eval 'sub D_64BIT () {0x200;}' unless defined(&D_64BIT);
	eval 'sub D_SYNCSTR () {0x400;}' unless defined(&D_SYNCSTR);
	eval 'sub D_DEVMAP () {0x100;}' unless defined(&D_DEVMAP);
	eval 'sub D_HOTPLUG () {0x4;}' unless defined(&D_HOTPLUG);
	if(defined(&_KERNEL)) {
	    eval 'sub STATIC_STREAM () {( &kmutex_t *)0xffffffff;}' unless defined(&STATIC_STREAM);
	    eval 'sub LOADABLE_STREAM {
	        my($s) = @_;
    		eval q((($s)-> &f_lock !=  &STATIC_STREAM));
	    }' unless defined(&LOADABLE_STREAM);
	    eval 'sub ALLOCATED_STREAM {
	        my($s) = @_;
    		eval q((($s)-> &f_lock !=  &NULL));
	    }' unless defined(&ALLOCATED_STREAM);
	    eval 'sub STREAM_INSTALLED {
	        my($s) = @_;
    		eval q((($s)-> &f_str !=  &NULL));
	    }' unless defined(&STREAM_INSTALLED);
	}
	if(defined(&_KERNEL)) {
	}
	if(defined(&_KERNEL)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
