require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_COPYOPS_H)) {
    eval 'sub _SYS_COPYOPS_H () {1;}' unless defined(&_SYS_COPYOPS_H);
    require 'sys/types.ph';
    require 'sys/thread.ph';
    require 'sys/buf.ph';
    require 'sys/aio_req.ph';
    require 'sys/uio.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub CP_COPYIN {
	    my($uaddr, $kaddr, $count) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_copyin}))($uaddr, $kaddr, $count)));
	}' unless defined(&CP_COPYIN);
	eval 'sub CP_XCOPYIN {
	    my($uaddr, $kaddr, $count) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_xcopyin}))($uaddr, $kaddr, $count)));
	}' unless defined(&CP_XCOPYIN);
	eval 'sub CP_COPYOUT {
	    my($kaddr, $uaddr, $count) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_copyout}))($kaddr, $uaddr, $count)));
	}' unless defined(&CP_COPYOUT);
	eval 'sub CP_XCOPYOUT {
	    my($kaddr, $uaddr, $count) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_xcopyout}))($kaddr, $uaddr, $count)));
	}' unless defined(&CP_XCOPYOUT);
	eval 'sub CP_COPYINSTR {
	    my($uaddr, $kaddr, $max, $lencopied) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_copyinstr}))($uaddr, $kaddr, $max, $lencopied)));
	}' unless defined(&CP_COPYINSTR);
	eval 'sub CP_COPYOUTSTR {
	    my($kaddr, $uaddr, $max, $lencopied) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_copyoutstr}))($kaddr, $uaddr, $max, $lencopied)));
	}' unless defined(&CP_COPYOUTSTR);
	eval 'sub CP_FUWORD8 {
	    my($addr, $valuep) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_fuword8}))($addr, $valuep)));
	}' unless defined(&CP_FUWORD8);
	eval 'sub CP_FUIWORD8 {
	    my($addr, $valuep) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_fuiword8}))($addr, $valuep)));
	}' unless defined(&CP_FUIWORD8);
	eval 'sub CP_FUWORD16 {
	    my($addr, $valuep) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_fuword16}))($addr, $valuep)));
	}' unless defined(&CP_FUWORD16);
	eval 'sub CP_FUWORD32 {
	    my($addr, $valuep) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_fuword32}))($addr, $valuep)));
	}' unless defined(&CP_FUWORD32);
	eval 'sub CP_FUIWORD32 {
	    my($addr, $valuep) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_fuiword32}))($addr, $valuep)));
	}' unless defined(&CP_FUIWORD32);
	eval 'sub CP_FUWORD64 {
	    my($addr, $valuep) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_fuword64}))($addr, $valuep)));
	}' unless defined(&CP_FUWORD64);
	eval 'sub CP_SUWORD8 {
	    my($addr, $value) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_suword8}))($addr, $value)));
	}' unless defined(&CP_SUWORD8);
	eval 'sub CP_SUIWORD8 {
	    my($addr, $value) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_suiword8}))($addr, $value)));
	}' unless defined(&CP_SUIWORD8);
	eval 'sub CP_SUWORD16 {
	    my($addr, $value) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_suword16}))($addr, $value)));
	}' unless defined(&CP_SUWORD16);
	eval 'sub CP_SUWORD32 {
	    my($addr, $value) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_suword32}))($addr, $value)));
	}' unless defined(&CP_SUWORD32);
	eval 'sub CP_SUIWORD32 {
	    my($addr, $value) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_suiword32}))($addr, $value)));
	}' unless defined(&CP_SUIWORD32);
	eval 'sub CP_SUWORD64 {
	    my($addr, $value) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_suword64}))($addr, $value)));
	}' unless defined(&CP_SUWORD64);
	eval 'sub CP_PHYSIO {
	    my($strat, $bp, $dev, $rw, $mincnt, $uio) = @_;
    	    eval q(((* ($curthread->{t_copyops}->{cp_physio}))($strat, $bp, $dev, $rw, $mincnt, $uio)));
	}' unless defined(&CP_PHYSIO);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
