require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CPC_EVENT_H)) {
    eval 'sub _SYS_CPC_EVENT_H () {1;}' unless defined(&_SYS_CPC_EVENT_H);
    require 'sys/inttypes.ph';
    require 'sys/time.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &__sparc)) {
	eval 'sub CPC_TICKREG_NAME () {"%tick";}' unless defined(&CPC_TICKREG_NAME);
	eval 'sub CPC_TICKREG {
	    my($ev) = @_;
    	    eval q((($ev)-> &ce_tick));
	}' unless defined(&CPC_TICKREG);
	eval 'sub CPC_ULTRA_PCR_USR () {2;}' unless defined(&CPC_ULTRA_PCR_USR);
	eval 'sub CPC_ULTRA_PCR_SYS () {1;}' unless defined(&CPC_ULTRA_PCR_SYS);
	eval 'sub CPC_ULTRA_PCR_PRIVPIC () {0;}' unless defined(&CPC_ULTRA_PCR_PRIVPIC);
	eval 'sub CPC_ULTRA_PCR_PIC0_SHIFT () {4;}' unless defined(&CPC_ULTRA_PCR_PIC0_SHIFT);
	eval 'sub CPC_ULTRA2_PCR_PIC0_MASK () { &UINT64_C(0xf);}' unless defined(&CPC_ULTRA2_PCR_PIC0_MASK);
	eval 'sub CPC_ULTRA3_PCR_PIC0_MASK () { &UINT64_C(0x3f);}' unless defined(&CPC_ULTRA3_PCR_PIC0_MASK);
	eval 'sub CPC_ULTRA_PCR_PIC1_SHIFT () {11;}' unless defined(&CPC_ULTRA_PCR_PIC1_SHIFT);
	eval 'sub CPC_ULTRA2_PCR_PIC1_MASK () { &UINT64_C(0xf);}' unless defined(&CPC_ULTRA2_PCR_PIC1_MASK);
	eval 'sub CPC_ULTRA3_PCR_PIC1_MASK () { &UINT64_C(0x3f);}' unless defined(&CPC_ULTRA3_PCR_PIC1_MASK);
    }
 elsif(defined( &__i386)) {
	eval 'sub ce_cesr () { $ce_pes[0];}' unless defined(&ce_cesr);
	eval 'sub CPC_TICKREG_NAME () {"tsc";}' unless defined(&CPC_TICKREG_NAME);
	eval 'sub CPC_TICKREG {
	    my($ev) = @_;
    	    eval q((($ev)-> &ce_tsc));
	}' unless defined(&CPC_TICKREG);
	eval 'sub CPC_P5_CESR_ES0_SHIFT () {0;}' unless defined(&CPC_P5_CESR_ES0_SHIFT);
	eval 'sub CPC_P5_CESR_ES0_MASK () {0x3f;}' unless defined(&CPC_P5_CESR_ES0_MASK);
	eval 'sub CPC_P5_CESR_ES1_SHIFT () {16;}' unless defined(&CPC_P5_CESR_ES1_SHIFT);
	eval 'sub CPC_P5_CESR_ES1_MASK () {0x3f;}' unless defined(&CPC_P5_CESR_ES1_MASK);
	eval 'sub CPC_P5_CESR_OS0 () {6;}' unless defined(&CPC_P5_CESR_OS0);
	eval 'sub CPC_P5_CESR_USR0 () {7;}' unless defined(&CPC_P5_CESR_USR0);
	eval 'sub CPC_P5_CESR_CLK0 () {8;}' unless defined(&CPC_P5_CESR_CLK0);
	eval 'sub CPC_P5_CESR_PC0 () {9;}' unless defined(&CPC_P5_CESR_PC0);
	eval 'sub CPC_P5_CESR_OS1 () {( &CPC_P5_CESR_OS0 + 16);}' unless defined(&CPC_P5_CESR_OS1);
	eval 'sub CPC_P5_CESR_USR1 () {( &CPC_P5_CESR_USR0 + 16);}' unless defined(&CPC_P5_CESR_USR1);
	eval 'sub CPC_P5_CESR_CLK1 () {( &CPC_P5_CESR_CLK0 + 16);}' unless defined(&CPC_P5_CESR_CLK1);
	eval 'sub CPC_P5_CESR_PC1 () {( &CPC_P5_CESR_PC0 + 16);}' unless defined(&CPC_P5_CESR_PC1);
	eval 'sub CPC_P6_PES_INV () {23;}' unless defined(&CPC_P6_PES_INV);
	eval 'sub CPC_P6_PES_EN () {22;}' unless defined(&CPC_P6_PES_EN);
	eval 'sub CPC_P6_PES_INT () {20;}' unless defined(&CPC_P6_PES_INT);
	eval 'sub CPC_P6_PES_PC () {19;}' unless defined(&CPC_P6_PES_PC);
	eval 'sub CPC_P6_PES_E () {18;}' unless defined(&CPC_P6_PES_E);
	eval 'sub CPC_P6_PES_OS () {17;}' unless defined(&CPC_P6_PES_OS);
	eval 'sub CPC_P6_PES_USR () {16;}' unless defined(&CPC_P6_PES_USR);
	eval 'sub CPC_P6_PES_UMASK_SHIFT () {8;}' unless defined(&CPC_P6_PES_UMASK_SHIFT);
	eval 'sub CPC_P6_PES_UMASK_MASK () {(0xff);}' unless defined(&CPC_P6_PES_UMASK_MASK);
	eval 'sub CPC_P6_PES_CMASK_SHIFT () {24;}' unless defined(&CPC_P6_PES_CMASK_SHIFT);
	eval 'sub CPC_P6_PES_CMASK_MASK () {(0xff);}' unless defined(&CPC_P6_PES_CMASK_MASK);
	eval 'sub CPC_P6_PES_PIC0_MASK () {(0xff);}' unless defined(&CPC_P6_PES_PIC0_MASK);
	eval 'sub CPC_P6_PES_PIC1_MASK () {(0xff);}' unless defined(&CPC_P6_PES_PIC1_MASK);
    } else {
	die("performance counters not available on this architecture");
    }
    eval 'sub CPC_BIND_LWP_INHERIT () {(0x1);}' unless defined(&CPC_BIND_LWP_INHERIT);
    eval 'sub CPC_BIND_EMT_OVF () {(0x2);}' unless defined(&CPC_BIND_EMT_OVF);
    eval 'sub CPC_ULTRA1 () {1000;}' unless defined(&CPC_ULTRA1);
    eval 'sub CPC_ULTRA2 () {1001;}' unless defined(&CPC_ULTRA2);
    eval 'sub CPC_ULTRA3 () {1002;}' unless defined(&CPC_ULTRA3);
    eval 'sub CPC_ULTRA3_PLUS () {1003;}' unless defined(&CPC_ULTRA3_PLUS);
    eval 'sub CPC_PENTIUM () {2000;}' unless defined(&CPC_PENTIUM);
    eval 'sub CPC_PENTIUM_MMX () {2001;}' unless defined(&CPC_PENTIUM_MMX);
    eval 'sub CPC_PENTIUM_PRO () {2002;}' unless defined(&CPC_PENTIUM_PRO);
    eval 'sub CPC_PENTIUM_PRO_MMX () {2003;}' unless defined(&CPC_PENTIUM_PRO_MMX);
    if(defined(&__cplusplus)) {
    }
}
1;
