require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_CPUPART_H)) {
    eval 'sub _SYS_CPUPART_H () {1;}' unless defined(&_SYS_CPUPART_H);
    require 'sys/types.ph';
    require 'sys/processor.ph';
    require 'sys/cpuvar.ph';
    require 'sys/disp.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub CP_CREATE () {1;}' unless defined(&CP_CREATE);
	eval 'sub CP_DESTROY () {2;}' unless defined(&CP_DESTROY);
	eval 'sub CP_ATTACH () {3;}' unless defined(&CP_ATTACH);
	eval 'sub CP_SET () {4;}' unless defined(&CP_SET);
	eval 'sub CP_GET () {5;}' unless defined(&CP_GET);
	eval 'sub CP_CPUS () {6;}' unless defined(&CP_CPUS);
	eval 'sub CP_NONE () {-1;}' unless defined(&CP_NONE);
	eval 'sub CP_DEFAULT () {0;}' unless defined(&CP_DEFAULT);
	eval 'sub CP_SYSTEM () {1;}' unless defined(&CP_SYSTEM);
	eval 'sub CP_PRIVATE () {2;}' unless defined(&CP_PRIVATE);
	eval 'sub CP_PUBLIC {
	    my($cp) = @_;
    	    eval q((($cp)-> &cp_level ==  &CP_SYSTEM || ($cp)-> &cp_level ==  &CP_DEFAULT));
	}' unless defined(&CP_PUBLIC);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
