require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_CS_PRIV_H)) {
    eval 'sub _CS_PRIV_H () {1;}' unless defined(&_CS_PRIV_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub CS_MAGIC () { &PCCS_MAGIC;}' unless defined(&CS_MAGIC);
    eval 'sub SocketServices () {(* &cs_socket_services);}' unless defined(&SocketServices);
    eval 'sub CIS_PARSER () {(* &cis_parser);}' unless defined(&CIS_PARSER);
    eval 'sub CIS_DEFAULT_SPEED () {250;}' unless defined(&CIS_DEFAULT_SPEED);
    eval 'sub IO_WIN_SPEED () {250;}' unless defined(&IO_WIN_SPEED);
    eval 'sub CS_GET_FIRST_FLAG () {0x1;}' unless defined(&CS_GET_FIRST_FLAG);
    eval 'sub CS_GET_NEXT_FLAG () {0x2;}' unless defined(&CS_GET_NEXT_FLAG);
    eval 'sub CS_BIT_WORDSIZE () {($sizeof{ &uint32_t});}' unless defined(&CS_BIT_WORDSIZE);
    eval 'sub CS_BIT_GET {
        my($val, $bit) = @_;
	    eval q((( &uint32_t)($val) & ( &uint32_t)(1<<( &uint32_t)($bit))));
    }' unless defined(&CS_BIT_GET);
    eval 'sub CS_BIT_CLEAR {
        my($val, $bit) = @_;
	    eval q((($val) &= ( &uint32_t)~(1<<( &uint32_t)($bit))));
    }' unless defined(&CS_BIT_CLEAR);
    eval 'sub CS_BIT_SET {
        my($val, $bit) = @_;
	    eval q((( &uint32_t)($val) |= ( &uint32_t)(1<<( &uint32_t)($bit))));
    }' unless defined(&CS_BIT_SET);
    eval 'sub RESET_TIMEOUT_TIME () {180;}' unless defined(&RESET_TIMEOUT_TIME);
    eval 'sub READY_TIMEOUT_TIME () {( &drv_usectohz(20000000));}' unless defined(&READY_TIMEOUT_TIME);
    eval 'sub SOFTINT_TIMEOUT_TIME () {( &drv_usectohz(2000000));}' unless defined(&SOFTINT_TIMEOUT_TIME);
    eval 'sub CS_RC1_DELAY () {20;}' unless defined(&CS_RC1_DELAY);
    eval 'sub CS_RC2_DELAY () {300;}' unless defined(&CS_RC2_DELAY);
    eval 'sub CS_RQ_DELAY () {100;}' unless defined(&CS_RQ_DELAY);
    eval 'sub UNTIMEOUT {
        my($id) = @_;
	    eval q( &if (($id)) { ( &void)  &untimeout(($id)); ($id) = 0; });
    }' unless defined(&UNTIMEOUT);
    eval 'sub EVENT_THREAD_MUTEX_ENTER {
        my($acq, $sp) = @_;
	    eval q($acq = ! &MUTEX_HELD( ($sp->{client_lock}));  &if ($acq)  &mutex_enter( ($sp->{client_lock})););
    }' unless defined(&EVENT_THREAD_MUTEX_ENTER);
    eval 'sub EVENT_THREAD_MUTEX_EXIT {
        my($acq, $sp) = @_;
	    eval q( &if ($acq)  &mutex_exit( ($sp->{client_lock})););
    }' unless defined(&EVENT_THREAD_MUTEX_EXIT);
    eval 'sub CIS_MAGIC () {0x20434953;}' unless defined(&CIS_MAGIC);
    eval 'sub CIS_VERSION () { &_VERSION(0, 1);}' unless defined(&CIS_VERSION);
    eval 'sub CS_MAX_CIS () {( &CIS_MAX_FUNCTIONS + 1);}' unless defined(&CS_MAX_CIS);
    eval 'sub CS_GLOBAL_CIS () { &CIS_MAX_FUNCTIONS;}' unless defined(&CS_GLOBAL_CIS);
    eval 'sub CS_SS_CLIENT_HANDLE () {0x;}' unless defined(&CS_SS_CLIENT_HANDLE);
    eval 'sub CLIENT_HANDLE_IS_SS {
        my($ch) = @_;
	    eval q((! &GET_CLIENT_MINOR(($ch))));
    }' unless defined(&CLIENT_HANDLE_IS_SS);
    eval 'sub CS_MAX_SOCKETS_MASK () {( &PCMCIA_MAX_SOCKETS - 1);}' unless defined(&CS_MAX_SOCKETS_MASK);
    eval 'sub CS_MAX_FUNCTIONS_MASK () {( &CIS_MAX_FUNCTIONS - 1);}' unless defined(&CS_MAX_FUNCTIONS_MASK);
    eval 'sub CS_MAX_CLIENTS_MASK () {0xffff;}' unless defined(&CS_MAX_CLIENTS_MASK);
    eval 'sub CS_MAX_CLIENTS () {( &CS_MAX_CLIENTS_MASK - 2);}' unless defined(&CS_MAX_CLIENTS);
    eval 'sub MAKE_CLIENT_HANDLE {
        my($s, $f, $c) = @_;
	    eval q((((($f) &CS_MAX_FUNCTIONS_MASK)<<24) | ((($s) &CS_MAX_SOCKETS_MASK)<<16) | (($c) &CS_MAX_CLIENTS_MASK)));
    }' unless defined(&MAKE_CLIENT_HANDLE);
    eval 'sub GET_CLIENT_SOCKET {
        my($ch) = @_;
	    eval q(((($ch)>>16) &CS_MAX_SOCKETS_MASK));
    }' unless defined(&GET_CLIENT_SOCKET);
    eval 'sub GET_CLIENT_FUNCTION {
        my($ch) = @_;
	    eval q(((($ch)>>24) &CS_MAX_FUNCTIONS_MASK));
    }' unless defined(&GET_CLIENT_FUNCTION);
    eval 'sub GET_CLIENT_MINOR {
        my($ch) = @_;
	    eval q((($ch) &CS_MAX_CLIENTS_MASK));
    }' unless defined(&GET_CLIENT_MINOR);
    eval 'sub CS_GET_SOCKET_NUMBER {
        my($s) = @_;
	    eval q((($s) &CS_MAX_SOCKETS_MASK));
    }' unless defined(&CS_GET_SOCKET_NUMBER);
    eval 'sub CS_GET_FUNCTION_NUMBER {
        my($s) = @_;
	    eval q(((($s)>>16)( &CS_MAX_FUNCTIONS_MASK |  &CIS_MAX_FUNCTIONS)));
    }' unless defined(&CS_GET_FUNCTION_NUMBER);
    eval 'sub CS_SET_SOCKET_NUMBER {
        my($s) = @_;
	    eval q((($s) &CS_MAX_SOCKETS_MASK));
    }' unless defined(&CS_SET_SOCKET_NUMBER);
    eval 'sub CS_SET_FUNCTION_NUMBER {
        my($f) = @_;
	    eval q(((($f)( &CS_MAX_FUNCTIONS_MASK |  &CIS_MAX_FUNCTIONS))<<16));
    }' unless defined(&CS_SET_FUNCTION_NUMBER);
    eval 'sub CS_MAKE_SOCKET_NUMBER {
        my($s, $f) = @_;
	    eval q(( &CS_SET_SOCKET_NUMBER($s) |  &CS_SET_FUNCTION_NUMBER($f)));
    }' unless defined(&CS_MAKE_SOCKET_NUMBER);
    eval 'sub DIP2SOCKET_NUM {
        my($dip) = @_;
	    eval q( &ddi_getprop( &DDI_DEV_T_NONE, $dip, ( &DDI_PROP_CANSLEEP |  &DDI_PROP_NOTPROM),  &PCM_DEV_SOCKET,  ($cs_globals->{max_socket_num})));
    }' unless defined(&DIP2SOCKET_NUM);
    eval 'sub CHECK_SOCKET_NUM {
        my($sn, $ms) = @_;
	    eval q(((($sn) >= ($ms))?0:1));
    }' unless defined(&CHECK_SOCKET_NUM);
    eval 'sub WINDOW_FOR_SOCKET {
        my($wsm, $sn) = @_;
	    eval q((($wsm)[$sn/ &PR_WORDSIZE] & (1<< (($sn) &  &PR_MASK))));
    }' unless defined(&WINDOW_FOR_SOCKET);
    eval 'sub WINDOW_AVAILABLE_FOR_MEM {
        my($cwp) = @_;
	    eval q((!( ($cwp->{state}) &  &CW_WIN_IN_USE)));
    }' unless defined(&WINDOW_AVAILABLE_FOR_MEM);
    eval 'sub WINDOW_AVAILABLE_FOR_IO {
        my($cwp) = @_;
	    eval q((!( ($cwp->{state}) & ( &CW_CIS |  &CW_MEM |  &CW_ALLOCATED))));
    }' unless defined(&WINDOW_AVAILABLE_FOR_IO);
    eval 'sub IOADDR_FROBNITZ {
        my($Base, $IOAddrLines) = @_;
	    eval q(($Base((1<<$IOAddrLines)-1)));
    }' unless defined(&IOADDR_FROBNITZ);
    eval 'sub IONUMPORTS_FROBNITZ {
        my($np) = @_;
	    eval q(((($np)&1)?(($np)+1):($np)));
    }' unless defined(&IONUMPORTS_FROBNITZ);
    eval 'sub CLIENT_EVENT_CALLBACK {
        my($cp, $event, $pri) = @_;
	    eval q(($cp)-> &event_callback_handler($event, $pri, ($cp)-> &event_callback_args));
    }' unless defined(&CLIENT_EVENT_CALLBACK);
    eval 'sub PRR_EVENT {
        my($prrx, $pe, $ps, $ce, $re) = @_;
	    eval q( &if ($prrx & $pe) {  &if ($prrx & $ps) ($re) |= $ce; $prrx &= ~$pe; $prrx |= $ps; });
    }' unless defined(&PRR_EVENT);
    eval 'sub REQ_CONFIGURATION_DONE () {0x1000;}' unless defined(&REQ_CONFIGURATION_DONE);
    eval 'sub REQ_SOCKET_MASK_DONE () {0x2000;}' unless defined(&REQ_SOCKET_MASK_DONE);
    eval 'sub REQ_IO_DONE () {0x4000;}' unless defined(&REQ_IO_DONE);
    eval 'sub REQ_IRQ_DONE () {0x8000;}' unless defined(&REQ_IRQ_DONE);
    eval 'sub CLIENT_SUPER_CLIENT () {0x10000;}' unless defined(&CLIENT_SUPER_CLIENT);
    eval 'sub CLIENT_CSI_CLIENT () {0x20000;}' unless defined(&CLIENT_CSI_CLIENT);
    eval 'sub CLIENT_CARD_INSERTED () {0x100000;}' unless defined(&CLIENT_CARD_INSERTED);
    eval 'sub CLIENT_SENT_INSERTION () {0x200000;}' unless defined(&CLIENT_SENT_INSERTION);
    eval 'sub CLIENT_MTD_IN_PROGRESS () {0x1000000;}' unless defined(&CLIENT_MTD_IN_PROGRESS);
    eval 'sub CLIENT_IO_ALLOCATED () {0x2000000;}' unless defined(&CLIENT_IO_ALLOCATED);
    eval 'sub CLIENT_IRQ_ALLOCATED () {0x4000000;}' unless defined(&CLIENT_IRQ_ALLOCATED);
    eval 'sub CLIENT_WIN_ALLOCATED () {0x8000000;}' unless defined(&CLIENT_WIN_ALLOCATED);
    if(defined(&USE_IOMMAP_WINDOW)) {
    }
    if(defined(&USE_IOMMAP_WINDOW)) {
    }
    eval 'sub SOCKET_CARD_INSERTED () {0x1;}' unless defined(&SOCKET_CARD_INSERTED);
    eval 'sub SOCKET_IS_IO () {0x2;}' unless defined(&SOCKET_IS_IO);
    eval 'sub SOCKET_UNLOAD_MODULE () {0x4;}' unless defined(&SOCKET_UNLOAD_MODULE);
    eval 'sub SOCKET_NEEDS_THREAD () {0x8;}' unless defined(&SOCKET_NEEDS_THREAD);
    eval 'sub SOCKET_IS_VALID () {0x20;}' unless defined(&SOCKET_IS_VALID);
    eval 'sub SOCKET_THREAD_EXIT () {0x1;}' unless defined(&SOCKET_THREAD_EXIT);
    eval 'sub SOCKET_WAIT_FOR_READY () {0x1000;}' unless defined(&SOCKET_WAIT_FOR_READY);
    eval 'sub SOCKET_RESET_TIMER () {0x2000;}' unless defined(&SOCKET_RESET_TIMER);
    eval 'sub SOCKET_WAIT_SYNC () {0x4000;}' unless defined(&SOCKET_WAIT_SYNC);
    eval 'sub SOCKET_THREAD_CSCISInit () {0x100000;}' unless defined(&SOCKET_THREAD_CSCISInit);
    eval 'sub CW_VALID_CIS () {0x1;}' unless defined(&CW_VALID_CIS);
    eval 'sub CW_MULTI_FUNCTION_CIS () {0x2;}' unless defined(&CW_MULTI_FUNCTION_CIS);
    eval 'sub CW_LONGLINK_A_FOUND () {0x4;}' unless defined(&CW_LONGLINK_A_FOUND);
    eval 'sub CW_LONGLINK_C_FOUND () {0x8;}' unless defined(&CW_LONGLINK_C_FOUND);
    eval 'sub CW_LONGLINK_MFC_FOUND () {0x10;}' unless defined(&CW_LONGLINK_MFC_FOUND);
    eval 'sub CW_CHECK_LINKTARGET () {0x20;}' unless defined(&CW_CHECK_LINKTARGET);
    eval 'sub CW_RET_ON_LINKTARGET_ERROR () {0x40;}' unless defined(&CW_RET_ON_LINKTARGET_ERROR);
    eval 'sub CW_CHECK_PRIMARY_CHAIN () {0x80;}' unless defined(&CW_CHECK_PRIMARY_CHAIN);
    eval 'sub CW_LONGLINK_FOUND () {( &CW_LONGLINK_A_FOUND |  &CW_LONGLINK_C_FOUND |  &CW_LONGLINK_MFC_FOUND);}' unless defined(&CW_LONGLINK_FOUND);
    eval 'sub SOCKET_HAS_CIS_WINDOW {
        my($sp) = @_;
	    eval q(( ($sp->{cis_win_num}) !=  &PCMCIA_MAX_WINDOWS));
    }' unless defined(&SOCKET_HAS_CIS_WINDOW);
    eval 'sub SOCKET_INIT_STATE_MUTEX () {0x1;}' unless defined(&SOCKET_INIT_STATE_MUTEX);
    eval 'sub SOCKET_INIT_STATE_CV () {0x2;}' unless defined(&SOCKET_INIT_STATE_CV);
    eval 'sub SOCKET_INIT_STATE_THREAD () {0x4;}' unless defined(&SOCKET_INIT_STATE_THREAD);
    eval 'sub SOCKET_INIT_STATE_READY () {0x8;}' unless defined(&SOCKET_INIT_STATE_READY);
    eval 'sub SOCKET_INIT_STATE_SS_THREAD () {0x10;}' unless defined(&SOCKET_INIT_STATE_SS_THREAD);
    eval 'sub SOCKET_INIT_STATE_SOFTINTR () {0x20;}' unless defined(&SOCKET_INIT_STATE_SOFTINTR);
    eval 'sub CS_THREAD_PRIORITY () {( ($v->{v_maxsyspri}) - 4);}' unless defined(&CS_THREAD_PRIORITY);
    eval 'sub CREATE_SOCKET_EVENT_THREAD {
        my($eh, $csp) = @_;
	    eval q( &thread_create( &NULL, 0, $eh, $csp, 0,  &p0,  &TS_RUN,  &CS_THREAD_PRIORITY));
    }' unless defined(&CREATE_SOCKET_EVENT_THREAD);
    eval 'sub CW_ALLOCATED () {0x1;}' unless defined(&CW_ALLOCATED);
    eval 'sub CW_CIS () {0x2;}' unless defined(&CW_CIS);
    eval 'sub CW_MEM () {0x4;}' unless defined(&CW_MEM);
    eval 'sub CW_IO () {0x8;}' unless defined(&CW_IO);
    eval 'sub CW_WIN_IN_USE () {0xffff;}' unless defined(&CW_WIN_IN_USE);
    eval 'sub CW_WINDOW_VALID () {0x10000;}' unless defined(&CW_WINDOW_VALID);
    eval 'sub WINDOW_HANDLE_MAGIC () {0x574d0000;}' unless defined(&WINDOW_HANDLE_MAGIC);
    eval 'sub WINDOW_HANDLE_MASK () {0xffff;}' unless defined(&WINDOW_HANDLE_MASK);
    eval 'sub GET_WINDOW_NUMBER {
        my($wh) = @_;
	    eval q((($wh) &  &WINDOW_HANDLE_MASK));
    }' unless defined(&GET_WINDOW_NUMBER);
    eval 'sub GET_WINDOW_MAGIC {
        my($wh) = @_;
	    eval q((($wh) & ~ &WINDOW_HANDLE_MASK));
    }' unless defined(&GET_WINDOW_MAGIC);
    eval 'sub CLIENT_EVENTS_LIFO () {0x1;}' unless defined(&CLIENT_EVENTS_LIFO);
    eval 'sub CLIENT_EVENTS_FIFO () {0x2;}' unless defined(&CLIENT_EVENTS_FIFO);
    eval 'sub GLOBAL_INIT_STATE_SOFTINTR () {0x10000;}' unless defined(&GLOBAL_INIT_STATE_SOFTINTR);
    eval 'sub GLOBAL_INIT_STATE_MUTEX () {0x20000;}' unless defined(&GLOBAL_INIT_STATE_MUTEX);
    eval 'sub GLOBAL_INIT_STATE_NO_CLIENTS () {0x40000;}' unless defined(&GLOBAL_INIT_STATE_NO_CLIENTS);
    eval 'sub GLOBAL_INIT_STATE_UNLOADING () {0x80000;}' unless defined(&GLOBAL_INIT_STATE_UNLOADING);
    eval 'sub GLOBAL_INIT_STATE_SS_READY () {0x100000;}' unless defined(&GLOBAL_INIT_STATE_SS_READY);
    eval 'sub GLOBAL_SUPER_CLIENT_REGISTERED () {0x1;}' unless defined(&GLOBAL_SUPER_CLIENT_REGISTERED);
    eval 'sub GLOBAL_IN_SOFTINTR () {0x2;}' unless defined(&GLOBAL_IN_SOFTINTR);
    eval 'sub CS_RES_IGNORE_NO_CARD () {0x1;}' unless defined(&CS_RES_IGNORE_NO_CARD);
    eval 'sub CSFUN2TEXT_FUNCTION () {0x1;}' unless defined(&CSFUN2TEXT_FUNCTION);
    eval 'sub CSFUN2TEXT_RETURN () {0x2;}' unless defined(&CSFUN2TEXT_RETURN);
    eval 'sub GET_NEXT_TUPLE {
        my($tp, $f) = @_;
	    eval q( &CIS_PARSER( &CISP_CIS_GET_LTUPLE, $tp,  &NULL,  &GET_NEXT_LTUPLEF | ($f & ~ &CIS_GET_LTUPLE_OPMASK)));
    }' unless defined(&GET_NEXT_TUPLE);
    eval 'sub GET_PREV_TUPLE {
        my($tp, $f) = @_;
	    eval q( &CIS_PARSER( &CISP_CIS_GET_LTUPLE, $tp,  &NULL,  &GET_PREV_LTUPLEF | ($f & ~ &CIS_GET_LTUPLE_OPMASK)));
    }' unless defined(&GET_PREV_TUPLE);
    eval 'sub GET_FIRST_LTUPLE {
        my($tp, $f) = @_;
	    eval q( &CIS_PARSER( &CISP_CIS_GET_LTUPLE, $tp,  &NULL,  &GET_FIRST_LTUPLEF | ($f & ~ &CIS_GET_LTUPLE_OPMASK)));
    }' unless defined(&GET_FIRST_LTUPLE);
    eval 'sub GET_LAST_LTUPLE {
        my($tp, $f) = @_;
	    eval q( &CIS_PARSER( &CISP_CIS_GET_LTUPLE, $tp,  &NULL,  &GET_LAST_LTUPLEF | ($f & ~ &CIS_GET_LTUPLE_OPMASK)));
    }' unless defined(&GET_LAST_LTUPLE);
    eval 'sub FIND_LTUPLE_FWD {
        my($tp, $tu, $f) = @_;
	    eval q( &CIS_PARSER( &CISP_CIS_GET_LTUPLE, $tp, $tu,  &FIND_LTUPLE_FWDF | ($f & ~ &CIS_GET_LTUPLE_OPMASK)));
    }' unless defined(&FIND_LTUPLE_FWD);
    eval 'sub FIND_LTUPLE_BACK {
        my($tp, $tu, $f) = @_;
	    eval q( &CIS_PARSER( &CISP_CIS_GET_LTUPLE, $tp, $tu,  &FIND_LTUPLE_BACKF | ($f & ~ &CIS_GET_LTUPLE_OPMASK)));
    }' unless defined(&FIND_LTUPLE_BACK);
    eval 'sub FIND_NEXT_LTUPLE {
        my($tp, $tu, $f) = @_;
	    eval q( &CIS_PARSER( &CISP_CIS_GET_LTUPLE, $tp, $tu,  &FIND_NEXT_LTUPLEF | ($f & ~ &CIS_GET_LTUPLE_OPMASK)));
    }' unless defined(&FIND_NEXT_LTUPLE);
    eval 'sub FIND_PREV_LTUPLE {
        my($tp, $tu, $f) = @_;
	    eval q( &CIS_PARSER( &CISP_CIS_GET_LTUPLE, $tp, $tu,  &FIND_PREV_LTUPLEF | ($f & ~ &CIS_GET_LTUPLE_OPMASK)));
    }' unless defined(&FIND_PREV_LTUPLE);
    eval 'sub FIND_FIRST_LTUPLE {
        my($tp, $tu, $f) = @_;
	    eval q( &FIND_LTUPLE_FWD( &GET_FIRST_LTUPLE($tp, $f), $tu, $f));
    }' unless defined(&FIND_FIRST_LTUPLE);
    if(defined(&__cplusplus)) {
    }
}
1;
