require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DBRIVAR_H)) {
    eval 'sub _SYS_DBRIVAR_H () {1;}' unless defined(&_SYS_DBRIVAR_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	if(!defined( &DBRI_NOSETPORT)) {
	    eval 'sub DBRI_NOSETPORT () {1;}' unless defined(&DBRI_NOSETPORT);
	}
	eval 'sub DBRI_IDNUM () {(0x6175);}' unless defined(&DBRI_IDNUM);
	eval 'sub DBRI_NAME () {"dbri";}' unless defined(&DBRI_NAME);
	eval 'sub DBRI_MINPSZ () {(0);}' unless defined(&DBRI_MINPSZ);
	eval 'sub DBRI_MAXPSZ () {(8188);}' unless defined(&DBRI_MAXPSZ);
	eval 'sub DBRI_HIWAT () {(57000);}' unless defined(&DBRI_HIWAT);
	eval 'sub DBRI_LOWAT () {(32000);}' unless defined(&DBRI_LOWAT);
	eval 'sub DBRI_DEFAULT_GAIN () {(128);}' unless defined(&DBRI_DEFAULT_GAIN);
	eval 'sub DBRI_NUM_INTQS () {(6);}' unless defined(&DBRI_NUM_INTQS);
	eval 'sub DBRI_MAX_BSIZE () {(8176);}' unless defined(&DBRI_MAX_BSIZE);
	eval 'sub DBRI_DEFAULT_BSIZE () {(1024);}' unless defined(&DBRI_DEFAULT_BSIZE);
	eval 'sub DBRI_BSIZE_MODULO () {(16);}' unless defined(&DBRI_BSIZE_MODULO);
	eval("sub DBRI_MINOR_NODEV () { 0; }") unless defined(&DBRI_MINOR_NODEV);
	eval("sub DBRI_MINOR_AUDIO_RW () { 1; }") unless defined(&DBRI_MINOR_AUDIO_RW);
	eval("sub DBRI_MINOR_AUDIO_RO () { 2; }") unless defined(&DBRI_MINOR_AUDIO_RO);
	eval("sub DBRI_MINOR_AUDIOCTL () { 3; }") unless defined(&DBRI_MINOR_AUDIOCTL);
	eval("sub DBRI_MINOR_TE_B1_RW () { 4; }") unless defined(&DBRI_MINOR_TE_B1_RW);
	eval("sub DBRI_MINOR_TE_B1_RO () { 5; }") unless defined(&DBRI_MINOR_TE_B1_RO);
	eval("sub DBRI_MINOR_TE_B2_RW () { 6; }") unless defined(&DBRI_MINOR_TE_B2_RW);
	eval("sub DBRI_MINOR_TE_B2_RO () { 7; }") unless defined(&DBRI_MINOR_TE_B2_RO);
	eval("sub DBRI_MINOR_TE_D () { 8; }") unless defined(&DBRI_MINOR_TE_D);
	eval("sub DBRI_MINOR_TEMGT () { 9; }") unless defined(&DBRI_MINOR_TEMGT);
	eval("sub DBRI_MINOR_NT_B1_RW () { 10; }") unless defined(&DBRI_MINOR_NT_B1_RW);
	eval("sub DBRI_MINOR_NT_B1_RO () { 11; }") unless defined(&DBRI_MINOR_NT_B1_RO);
	eval("sub DBRI_MINOR_NT_B2_RW () { 12; }") unless defined(&DBRI_MINOR_NT_B2_RW);
	eval("sub DBRI_MINOR_NT_B2_RO () { 13; }") unless defined(&DBRI_MINOR_NT_B2_RO);
	eval("sub DBRI_MINOR_NT_D () { 14; }") unless defined(&DBRI_MINOR_NT_D);
	eval("sub DBRI_MINOR_NTMGT () { 15; }") unless defined(&DBRI_MINOR_NTMGT);
	eval("sub DBRI_MINOR_DBRIMGT () { 16; }") unless defined(&DBRI_MINOR_DBRIMGT);
	eval("sub DBRI_MINOR_TE_D_TRACE () { 37; }") unless defined(&DBRI_MINOR_TE_D_TRACE);
	eval("sub DBRI_MINOR_NT_D_TRACE () { 38; }") unless defined(&DBRI_MINOR_NT_D_TRACE);
	eval 'sub NCHANBITS () {(8);}' unless defined(&NCHANBITS);
	eval 'sub NUNITBITS () {(4);}' unless defined(&NUNITBITS);
	eval 'sub NCLONEBITS () {(1);}' unless defined(&NCLONEBITS);
	eval 'sub CHANOFFSET () {(0);}' unless defined(&CHANOFFSET);
	eval 'sub UNITOFFSET () {( &NCHANBITS);}' unless defined(&UNITOFFSET);
	eval 'sub CLONEOFFSET () {( &UNITOFFSET +  &NUNITBITS);}' unless defined(&CLONEOFFSET);
	eval 'sub CHANMASK () {(((1<<  &NCHANBITS) - 1) <<  &CHANOFFSET);}' unless defined(&CHANMASK);
	eval 'sub CLONEMASK () {(((1<<  &NCLONEBITS) - 1) <<  &CLONEOFFSET);}' unless defined(&CLONEMASK);
	eval 'sub UNITMASK () {(((1<<  &NUNITBITS) - 1) <<  &UNITOFFSET);}' unless defined(&UNITMASK);
	eval 'sub MAKECHAN {
	    my($x) = @_;
    	    eval q(((($x) <<  &CHANOFFSET) &  &CHANMASK));
	}' unless defined(&MAKECHAN);
	eval 'sub MAKECLONE {
	    my($x) = @_;
    	    eval q(((($x) <<  &CLONEOFFSET) &  &CLONEMASK));
	}' unless defined(&MAKECLONE);
	eval 'sub MAKEUNIT {
	    my($x) = @_;
    	    eval q(((($x) <<  &UNITOFFSET) &  &UNITMASK));
	}' unless defined(&MAKEUNIT);
	eval 'sub GETCHAN {
	    my($x) = @_;
    	    eval q(((($x) &  &CHANMASK) >>  &CHANOFFSET));
	}' unless defined(&GETCHAN);
	eval 'sub GETCLONE {
	    my($x) = @_;
    	    eval q(((($x) &  &CLONEMASK) >>  &CLONEOFFSET));
	}' unless defined(&GETCLONE);
	eval 'sub GETUNIT {
	    my($x) = @_;
    	    eval q(((($x) &  &UNITMASK) >>  &UNITOFFSET));
	}' unless defined(&GETUNIT);
	eval 'sub MINORDEV {
	    my($dev) = @_;
    	    eval q( &GETCHAN( &getminor($dev)));
	}' unless defined(&MINORDEV);
	eval 'sub MINORUNIT {
	    my($dev) = @_;
    	    eval q( &GETUNIT( &getminor($dev)));
	}' unless defined(&MINORUNIT);
	eval 'sub dbrimakeminor {
	    my($unit, $min) = @_;
    	    eval q(( &minor_t)( &MAKEUNIT($unit) |  &MAKECHAN($min)));
	}' unless defined(&dbrimakeminor);
	eval 'sub dbrimakedev {
	    my($maj, $unit, $min) = @_;
    	    eval q( &makedevice(($maj),  &dbrimakeminor($unit, $min)));
	}' unless defined(&dbrimakedev);
	eval 'sub dbrimakeclonedev {
	    my($maj, $unit, $min) = @_;
    	    eval q( &makedevice(($maj),  &dbrimakeminor($unit, $min) |  &MAKECLONE(1)));
	}' unless defined(&dbrimakeclonedev);
	eval("sub DBRI_CHAN_INDIRECT () { -4; }") unless defined(&DBRI_CHAN_INDIRECT);
	eval("sub DBRI_CHAN_FIXED () { -3; }") unless defined(&DBRI_CHAN_FIXED);
	eval("sub DBRI_CHAN_NONE () { -2; }") unless defined(&DBRI_CHAN_NONE);
	eval("sub DBRI_CHAN_HOST () { -1; }") unless defined(&DBRI_CHAN_HOST);
	eval("sub DBRI_TE_D_OUT () { 0; }") unless defined(&DBRI_TE_D_OUT);
	eval("sub DBRI_TE_D_IN () { 1; }") unless defined(&DBRI_TE_D_IN);
	eval("sub DBRI_TE_B1_OUT () { 2; }") unless defined(&DBRI_TE_B1_OUT);
	eval("sub DBRI_TE_B1_IN () { 3; }") unless defined(&DBRI_TE_B1_IN);
	eval("sub DBRI_TE_B2_OUT () { 4; }") unless defined(&DBRI_TE_B2_OUT);
	eval("sub DBRI_TE_B2_IN () { 5; }") unless defined(&DBRI_TE_B2_IN);
	eval("sub DBRI_NT_D_OUT () { 6; }") unless defined(&DBRI_NT_D_OUT);
	eval("sub DBRI_NT_D_IN () { 7; }") unless defined(&DBRI_NT_D_IN);
	eval("sub DBRI_NT_B1_OUT () { 8; }") unless defined(&DBRI_NT_B1_OUT);
	eval("sub DBRI_NT_B1_IN () { 9; }") unless defined(&DBRI_NT_B1_IN);
	eval("sub DBRI_NT_B2_OUT () { 10; }") unless defined(&DBRI_NT_B2_OUT);
	eval("sub DBRI_NT_B2_IN () { 11; }") unless defined(&DBRI_NT_B2_IN);
	eval("sub DBRI_AUDIO_OUT () { 12; }") unless defined(&DBRI_AUDIO_OUT);
	eval("sub DBRI_AUDIO_IN () { 13; }") unless defined(&DBRI_AUDIO_IN);
	eval("sub DBRI_AUDIOCTL () { 14; }") unless defined(&DBRI_AUDIOCTL);
	eval("sub DBRI_TEMGT () { 15; }") unless defined(&DBRI_TEMGT);
	eval("sub DBRI_NTMGT () { 16; }") unless defined(&DBRI_NTMGT);
	eval("sub DBRI_DBRIMGT () { 17; }") unless defined(&DBRI_DBRIMGT);
	eval("sub DBRI_TE_D_TRACE () { 18; }") unless defined(&DBRI_TE_D_TRACE);
	eval("sub DBRI_NT_D_TRACE () { 19; }") unless defined(&DBRI_NT_D_TRACE);
	eval("sub DBRI_LAST_CHAN () { 20; }") unless defined(&DBRI_LAST_CHAN);
	eval 'sub DBRI_CHAN_MEMORY () {( &DBRI_CHAN_HOST);}' unless defined(&DBRI_CHAN_MEMORY);
	eval 'sub DBRI_NSTREAM () {( &DBRI_LAST_CHAN);}' unless defined(&DBRI_NSTREAM);
	eval("sub DBRI_MODE_UNKNOWN () { -1; }") unless defined(&DBRI_MODE_UNKNOWN);
	eval("sub DBRI_MODE_TRANSPARENT () { DBRI_SDP_TRANSPARENT; }") unless defined(&DBRI_MODE_TRANSPARENT);
	eval("sub DBRI_MODE_HDLC () { DBRI_SDP_HDLC; }") unless defined(&DBRI_MODE_HDLC);
	eval("sub DBRI_MODE_HDLC_D () { DBRI_SDP_TE_DCHAN; }") unless defined(&DBRI_MODE_HDLC_D);
	eval("sub DBRI_MODE_SERIAL () { DBRI_SDP_SERIAL; }") unless defined(&DBRI_MODE_SERIAL);
	eval("sub DBRI_MODE_FIXED () { DBRI_SDP_FIXED; }") unless defined(&DBRI_MODE_FIXED);
	eval("sub DBRI_CLOCK_NONE () { 0; }") unless defined(&DBRI_CLOCK_NONE);
	eval("sub DBRI_CLOCK_DBRI () { 1; }") unless defined(&DBRI_CLOCK_DBRI);
	eval("sub DBRI_CLOCK_EXT () { 2; }") unless defined(&DBRI_CLOCK_EXT);
	if(0) {
	}
	eval 'sub DBRI_MAX_CMDS () {(512);}' unless defined(&DBRI_MAX_CMDS);
	eval 'sub DBRI_MAX_CMDSIZE () {(3);}' unless defined(&DBRI_MAX_CMDSIZE);
	eval 'sub DBRI_END_CMDLIST () {( &DBRI_MAX_CMDS -  &DBRI_MAX_CMDSIZE - 2- 1);}' unless defined(&DBRI_END_CMDLIST);
	eval 'sub DBRI_SYNC_CMDQ {
	    my($UNITP, $LEN, $DIR) = @_;
    	    eval q( &ddi_dma_sync(($UNITP)-> &dma_handle, ( &off_t)($UNITP)-> &cmdqp - ( &off_t)($UNITP)-> &iopbkbase + ( &off_t)(($UNITP)-> ($cmdqp->{cmdhp}) * $sizeof{ &uint_t}), ($LEN) * $sizeof{ &uint_t}, ($DIR)));
	}' unless defined(&DBRI_SYNC_CMDQ);
	eval("sub CHI_NO_STATE () { 0; }") unless defined(&CHI_NO_STATE);
	eval("sub CHI_NO_DEVICES () { 1; }") unless defined(&CHI_NO_DEVICES);
	eval("sub CHI_IN_DATA_MODE () { 2; }") unless defined(&CHI_IN_DATA_MODE);
	eval("sub CHI_IN_CTRL_MODE () { 3; }") unless defined(&CHI_IN_CTRL_MODE);
	eval("sub CHI_WAIT_DCB_LOW () { 4; }") unless defined(&CHI_WAIT_DCB_LOW);
	eval("sub CHI_WAIT_DCB_HIGH () { 5; }") unless defined(&CHI_WAIT_DCB_HIGH);
	eval("sub CHI_GOING_TO_DATA_MODE () { 6; }") unless defined(&CHI_GOING_TO_DATA_MODE);
	eval("sub CHI_CODEC_CALIBRATION () { 7; }") unless defined(&CHI_CODEC_CALIBRATION);
	eval("sub CHI_GOING_TO_CTRL_MODE () { 8; }") unless defined(&CHI_GOING_TO_CTRL_MODE);
	eval("sub CHI_POWERED_DOWN () { 9; }") unless defined(&CHI_POWERED_DOWN);
	eval 'sub DBRI_CHI_STATUS_P {
	    my($unitp) = @_;
    	    eval q((($unitp)-> ($ser_sts->{chi})));
	}' unless defined(&DBRI_CHI_STATUS_P);
	eval 'sub DBRI_TE_STATUS_P {
	    my($unitp) = @_;
    	    eval q((($unitp)-> ($ser_sts->{te})));
	}' unless defined(&DBRI_TE_STATUS_P);
	eval 'sub DBRI_NT_STATUS_P {
	    my($unitp) = @_;
    	    eval q((($unitp)-> ($ser_sts->{nt})));
	}' unless defined(&DBRI_NT_STATUS_P);
	eval 'sub CHI_DATA_MODE_LEN () {128;}' unless defined(&CHI_DATA_MODE_LEN);
	eval 'sub CHI_CTRL_MODE_LEN () {256;}' unless defined(&CHI_CTRL_MODE_LEN);
	eval 'sub PIPENO {
	    my($pipep) = @_;
    	    eval q(( ($pipep->{pipeno})));
	}' unless defined(&PIPENO);
	eval 'sub DBRI_PIPE_TE_D_IN () {(0);}' unless defined(&DBRI_PIPE_TE_D_IN);
	eval 'sub DBRI_PIPE_TE_D_OUT () {(1);}' unless defined(&DBRI_PIPE_TE_D_OUT);
	eval 'sub DBRI_PIPE_NT_D_OUT () {(2);}' unless defined(&DBRI_PIPE_NT_D_OUT);
	eval 'sub DBRI_PIPE_NT_D_IN () {(3);}' unless defined(&DBRI_PIPE_NT_D_IN);
	eval 'sub DBRI_PIPE_LONGFREE () {(4);}' unless defined(&DBRI_PIPE_LONGFREE);
	eval 'sub DBRI_PIPE_CHI () {(16);}' unless defined(&DBRI_PIPE_CHI);
	eval 'sub DBRI_PIPE_DM_T_5_8 () {(17);}' unless defined(&DBRI_PIPE_DM_T_5_8);
	eval 'sub DBRI_PIPE_DM_R_5_6 () {(18);}' unless defined(&DBRI_PIPE_DM_R_5_6);
	eval 'sub DBRI_PIPE_DM_R_7_8 () {(19);}' unless defined(&DBRI_PIPE_DM_R_7_8);
	eval 'sub DBRI_PIPE_CM_T_1_4 () {(20);}' unless defined(&DBRI_PIPE_CM_T_1_4);
	eval 'sub DBRI_PIPE_CM_R_1_2 () {(21);}' unless defined(&DBRI_PIPE_CM_R_1_2);
	eval 'sub DBRI_PIPE_CM_R_3_4 () {(22);}' unless defined(&DBRI_PIPE_CM_R_3_4);
	eval 'sub DBRI_PIPE_SB_PAL_T () {(23);}' unless defined(&DBRI_PIPE_SB_PAL_T);
	eval 'sub DBRI_PIPE_SB_PAL_R () {(24);}' unless defined(&DBRI_PIPE_SB_PAL_R);
	eval 'sub DBRI_PIPE_CM_R_7 () {(25);}' unless defined(&DBRI_PIPE_CM_R_7);
	eval 'sub DBRI_PIPE_DUMMYDATA () {(26);}' unless defined(&DBRI_PIPE_DUMMYDATA);
	eval 'sub DBRI_PIPE_SHORTFREE () {(27);}' unless defined(&DBRI_PIPE_SHORTFREE);
	eval 'sub DBRI_MAX_PIPES () {(32);}' unless defined(&DBRI_MAX_PIPES);
	eval 'sub DBRI_BAD_PIPE () { &DBRI_MAX_PIPES;}' unless defined(&DBRI_BAD_PIPE);
	eval 'sub DBRI_LONGPIPE () {(0);}' unless defined(&DBRI_LONGPIPE);
	eval 'sub DBRI_SHORTPIPE () {(1);}' unless defined(&DBRI_SHORTPIPE);
	eval 'sub ISPIPEINUSE {
	    my($a) = @_;
    	    eval q((($a)-> &refcnt != 0));
	}' unless defined(&ISPIPEINUSE);
	eval 'sub ISHWCONNECTED {
	    my($as) = @_;
    	    eval q(( &ISDATASTREAM($as)  && ( &AsToDs($as)-> &pipep !=  &NULL)));
	}' unless defined(&ISHWCONNECTED);
	eval 'sub ISTEDCHANNEL {
	    my($as) = @_;
    	    eval q((( &PIPENO( &AsToDs($as)-> &pipep) ==  &DBRI_PIPE_TE_D_IN) || ( &PIPENO( &AsToDs($as)-> &pipep) ==  &DBRI_PIPE_TE_D_OUT)));
	}' unless defined(&ISTEDCHANNEL);
	eval 'sub ISNTDCHANNEL {
	    my($as) = @_;
    	    eval q((( &PIPENO( &AsToDs($as)-> &pipep) ==  &DBRI_PIPE_NT_D_IN) || ( &PIPENO( &AsToDs($as)-> &pipep) ==  &DBRI_PIPE_NT_D_OUT)));
	}' unless defined(&ISNTDCHANNEL);
	eval 'sub ISXMITDIRECTION {
	    my($as) = @_;
    	    eval q(( &AsToDs($as)-> ($pipep->{sdp}) &  &DBRI_SDP_D));
	}' unless defined(&ISXMITDIRECTION);
	eval 'sub DBRI_DIRECTION_NONE () {(0x);}' unless defined(&DBRI_DIRECTION_NONE);
	eval 'sub DBRI_DIRECTION_IN () {(0x1);}' unless defined(&DBRI_DIRECTION_IN);
	eval 'sub DBRI_DIRECTION_OUT () {(0x2);}' unless defined(&DBRI_DIRECTION_OUT);
	eval 'sub DBRI_MD_ALIGN () {(16);}' unless defined(&DBRI_MD_ALIGN);
	eval 'sub DBRI_SYNC_MD {
	    my($UNITP, $MDP, $DIR) = @_;
    	    eval q( &ddi_dma_sync(($UNITP)-> &dma_handle, ( &off_t)($MDP) - ( &off_t)($UNITP)-> &iopbkbase, $sizeof{ &dbri_md_t}, ($DIR)));
	}' unless defined(&DBRI_SYNC_MD);
	eval 'sub txmd () { ($md->{_md}->{tx});}' unless defined(&txmd);
	eval 'sub rxmd () { ($md->{_md}->{rx});}' unless defined(&rxmd);
	eval 'sub words () { ($md->{_md}->{_words});}' unless defined(&words);
	eval 'sub txmd2 () { ($md2->{_md}->{tx});}' unless defined(&txmd2);
	eval 'sub rxmd2 () { ($md2->{_md}->{rx});}' unless defined(&rxmd2);
	eval 'sub words2 () { ($md2->{_md}->{_words});}' unless defined(&words2);
	eval 'sub DBRI_SYNC_BUF {
	    my($DCP, $SIZE, $DIR) = @_;
    	    eval q( &ddi_dma_sync(($DCP)-> &buf_dma_handle, 0, ($SIZE), ($DIR)));
	}' unless defined(&DBRI_SYNC_BUF);
	eval 'sub AsToDs {
	    my($as) = @_;
    	    eval q((( &dbri_stream_t *)($as)));
	}' unless defined(&AsToDs);
	eval 'sub DsToAs {
	    my($ds) = @_;
    	    eval q((($ds)-> &as));
	}' unless defined(&DsToAs);
	eval 'sub DChanToDs {
	    my($unitp, $dchan) = @_;
    	    eval q((($unitp)-> $ioc[$dchan]));
	}' unless defined(&DChanToDs);
	eval 'sub DChanToAs {
	    my($unitp, $dchan) = @_;
    	    eval q((($unitp)-> ($ioc[$dchan]->{as})));
	}' unless defined(&DChanToAs);
	eval 'sub DsToUnitp {
	    my($ds) = @_;
    	    eval q((( &dbri_unit_t *)($ds)-> ($as->{distate}->{d$dstate})));
	}' unless defined(&DsToUnitp);
	eval 'sub AsToUnitp {
	    my($ds) = @_;
    	    eval q((( &dbri_unit_t *)( &as)-> ($distate->{d$dstate})));
	}' unless defined(&AsToUnitp);
	eval 'sub DsDisabled {
	    my($ds) = @_;
    	    eval q((($ds)-> &ctep ==  &NULL ?  &B_TRUE :  &B_FALSE));
	}' unless defined(&DsDisabled);
	eval 'sub DBRI_SYNC_CURINTQ {
	    my($UNITP) = @_;
    	    eval q( &ddi_dma_sync(($UNITP)-> &dma_handle, ( &off_t)($UNITP)-> ($intq->{curqp}) - ( &off_t)($UNITP)-> &iopbkbase + ( &off_t)(($UNITP)-> ($intq->{off}) * $sizeof{ &uint32_t}), $sizeof{ &uint32_t},  &DDI_DMA_SYNC_FORCPU));
	}' unless defined(&DBRI_SYNC_CURINTQ);
	eval 'sub DBRI_IOPBIOADDR {
	    my($unitp, $a) = @_;
    	    eval q((($unitp)-> &iopbiobase + (( &uintptr_t)($a) - ( &uintptr_t)($unitp)-> &iopbkbase)));
	}' unless defined(&DBRI_IOPBIOADDR);
	eval 'sub DBRI_IOPBKADDR {
	    my($unitp, $a) = @_;
    	    eval q((($unitp)-> &iopbkbase + (( &uintptr_t)($a) - ( &uintptr_t)($unitp)-> &iopbiobase)));
	}' unless defined(&DBRI_IOPBKADDR);
	eval 'sub LOCK_UNIT {
	    my($unitp) = @_;
    	    eval q( &mutex_enter(($unitp)-> &lock));
	}' unless defined(&LOCK_UNIT);
	eval 'sub UNLOCK_UNIT {
	    my($unitp) = @_;
    	    eval q( &mutex_exit(($unitp)-> &lock));
	}' unless defined(&UNLOCK_UNIT);
	eval 'sub ASSERT_UNITLOCKED {
	    my($unitp) = @_;
    	    eval q( &ASSERT( &MUTEX_HELD(($unitp)-> &lock)));
	}' unless defined(&ASSERT_UNITLOCKED);
	eval 'sub TICKS {
	    my($x) = @_;
    	    eval q( &drv_usectohz(($x) > 0? (($x) * 1000) : 1));
	}' unless defined(&TICKS);
	eval 'sub DBRI_DEV_NAME () {"SUNW,dbri";}' unless defined(&DBRI_DEV_NAME);
	eval 'sub DBRI_DEV_SPKRBOX () {"speakerbox";}' unless defined(&DBRI_DEV_SPKRBOX);
	eval 'sub DBRI_DEV_ONBRD1 () {"onboard1";}' unless defined(&DBRI_DEV_ONBRD1);
	eval 'sub DBRI_DEV_ISDN_B () {"isdn_b";}' unless defined(&DBRI_DEV_ISDN_B);
	eval("sub DBRI_DTS_NONE () { 0; }") unless defined(&DBRI_DTS_NONE);
	eval("sub DBRI_DTS_INSERT () { 1; }") unless defined(&DBRI_DTS_INSERT);
	eval("sub DBRI_DTS_MODIFY () { 2; }") unless defined(&DBRI_DTS_MODIFY);
	eval("sub DBRI_DTS_DELETE () { 3; }") unless defined(&DBRI_DTS_DELETE);
	eval 'sub DBRIEV_SBI_CONFIG () {(1);}' unless defined(&DBRIEV_SBI_CONFIG);
	if(defined(&__STDC__)) {
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
