require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DKLABEL_H)) {
    eval 'sub _SYS_DKLABEL_H () {1;}' unless defined(&_SYS_DKLABEL_H);
    require 'sys/isa_defs.ph';
    require 'sys/types32.ph';
    require 'sys/isa_defs.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub DKL_MAGIC () {0xdabe;}' unless defined(&DKL_MAGIC);
    eval 'sub FKL_MAGIC () {0xff;}' unless defined(&FKL_MAGIC);
    if(defined( &_SUNOS_VTOC_16)) {
	eval 'sub NDKMAP () {16;}' unless defined(&NDKMAP);
	eval 'sub DK_LABEL_LOC () {1;}' unless defined(&DK_LABEL_LOC);
    }
 elsif(defined( &_SUNOS_VTOC_8)) {
	eval 'sub NDKMAP () {8;}' unless defined(&NDKMAP);
	eval 'sub DK_LABEL_LOC () {0;}' unless defined(&DK_LABEL_LOC);
    } else {
	die("No VTOC format defined.");
    }
    eval 'sub LEN_DKL_ASCII () {128;}' unless defined(&LEN_DKL_ASCII);
    eval 'sub LEN_DKL_VVOL () {8;}' unless defined(&LEN_DKL_VVOL);
    eval 'sub DK_LABEL_SIZE () {512;}' unless defined(&DK_LABEL_SIZE);
    eval 'sub DK_ACYL () {2;}' unless defined(&DK_ACYL);
    if(defined( &_SUNOS_VTOC_16)) {
    }
 elsif(defined( &_SUNOS_VTOC_8)) {
    } else {
	die("No VTOC format defined.");
    }
    if(defined( &_SUNOS_VTOC_16)) {
	eval 'sub LEN_DKL_PAD () {( &DK_LABEL_SIZE - (($sizeof{\'struct dk_vtoc\'} + (4* $sizeof{ &uint32_t}) + (12* $sizeof{ &uint16_t}) + (2* ($sizeof{ &uint16_t})))));}' unless defined(&LEN_DKL_PAD);
    }
 elsif(defined( &_SUNOS_VTOC_8)) {
	eval 'sub LEN_DKL_PAD () {( &DK_LABEL_SIZE - (( &LEN_DKL_ASCII) + ($sizeof{\'struct dk_vtoc\'}) + ($sizeof{\'struct dk_map32\'} *  &NDKMAP) + (14* ($sizeof{ &uint16_t})) + (2* ($sizeof{ &uint16_t}))));}' unless defined(&LEN_DKL_PAD);
    } else {
	die("No VTOC format defined.");
    }
    if(defined( &_SUNOS_VTOC_16)) {
    }
 elsif(defined( &_SUNOS_VTOC_8)) {
	if(defined( &_SYSCALL32)) {
	} else {
	}
    } else {
	die("No VTOC format defined.");
    }
    if(defined( &_SUNOS_VTOC_16)) {
	eval 'sub dkl_asciilabel () { ($dkl_vtoc->{v_asciilabel});}' unless defined(&dkl_asciilabel);
	eval 'sub v_timestamp () { &timestamp;}' unless defined(&v_timestamp);
    }
 elsif(defined( &_SUNOS_VTOC_8)) {
	eval 'sub dkl_gap1 () { &dkl_obs1;}' unless defined(&dkl_gap1);
	eval 'sub dkl_gap2 () { &dkl_obs2;}' unless defined(&dkl_gap2);
	eval 'sub dkl_bhead () { &dkl_obs3;}' unless defined(&dkl_bhead);
	eval 'sub dkl_ppart () { &dkl_obs4;}' unless defined(&dkl_ppart);
    } else {
	die("No VTOC format defined.");
    }
    eval 'sub DK_DEVID_BLKSIZE () {(512);}' unless defined(&DK_DEVID_BLKSIZE);
    eval 'sub DK_DEVID_SIZE () {( &DK_DEVID_BLKSIZE - (($sizeof{ &uchar_t} * 7)));}' unless defined(&DK_DEVID_SIZE);
    eval 'sub DK_DEVID_REV_MSB () {(0);}' unless defined(&DK_DEVID_REV_MSB);
    eval 'sub DK_DEVID_REV_LSB () {(1);}' unless defined(&DK_DEVID_REV_LSB);
    eval 'sub DKD_GETCHKSUM {
        my($dkd) = @_;
	    eval q((($dkd)-> &dkd_checksum3 << 24) + (($dkd)-> &dkd_checksum2 << 16) + (($dkd)-> &dkd_checksum1 << 8) + (($dkd)-> &dkd_checksum0));
    }' unless defined(&DKD_GETCHKSUM);
    eval 'sub DKD_FORMCHKSUM {
        my($c, $dkd) = @_;
	    eval q(($dkd)-> &dkd_checksum3 =  &hibyte( &hiword(($c))); ($dkd)-> &dkd_checksum2 =  &lobyte( &hiword(($c))); ($dkd)-> &dkd_checksum1 =  &hibyte( &loword(($c))); ($dkd)-> &dkd_checksum0 =  &lobyte( &loword(($c))););
    }' unless defined(&DKD_FORMCHKSUM);
    if(defined(&__cplusplus)) {
    }
}
1;
