require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_DMFE_IMPL_H)) {
    eval 'sub _SYS_DMFE_IMPL_H () {1;}' unless defined(&_SYS_DMFE_IMPL_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'sys/stream.ph';
    require 'sys/strsun.ph';
    require 'sys/stat.ph';
    require 'sys/pci.ph';
    require 'sys/note.ph';
    require 'sys/modctl.ph';
    require 'sys/kstat.ph';
    require 'sys/ethernet.ph';
    require 'sys/dlpi.ph';
    require 'sys/devops.ph';
    require 'sys/debug.ph';
    require 'sys/conf.ph';
    require 'inet/common.ph';
    require 'inet/nd.ph';
    require 'inet/mi.ph';
    require 'sys/dditypes.ph';
    require 'sys/ddi.ph';
    require 'sys/sunddi.ph';
    require 'sys/gld.ph';
    require 'sys/mii.ph';
    require 'sys/dmfe.ph';
    eval 'sub CHIP_STATE_READY () {0;}' unless defined(&CHIP_STATE_READY);
    eval 'sub CHIP_STATE_RESET () {1;}' unless defined(&CHIP_STATE_RESET);
    eval 'sub CHIP_STATE_PHYRESET () {2;}' unless defined(&CHIP_STATE_PHYRESET);
    eval 'sub CHIP_STATE_LINKCHG () {4;}' unless defined(&CHIP_STATE_LINKCHG);
    eval 'sub CHIP_STATE_RUNT_PENDING () {8;}' unless defined(&CHIP_STATE_RUNT_PENDING);
    eval 'sub ENINT_DEFAULT () {0;}' unless defined(&ENINT_DEFAULT);
    eval 'sub ENINT_TX_DONE () {1;}' unless defined(&ENINT_TX_DONE);
    eval 'sub ENINT_RUNT_TIMER () {2;}' unless defined(&ENINT_RUNT_TIMER);
    eval 'sub ENINT_REPROGRAM () {3;}' unless defined(&ENINT_REPROGRAM);
    eval 'sub DMFE_TX_DESC () {32;}' unless defined(&DMFE_TX_DESC);
    eval 'sub DMFE_RX_DESC () {32;}' unless defined(&DMFE_RX_DESC);
    eval 'sub ethaddr_copy {
        my($src, $dst) = @_;
	    eval q( &bcopy(($src), ($dst),  &ETHERADDRL));
    }' unless defined(&ethaddr_copy);
    eval 'sub NEXT_TX_INDEX {
        my($index) = @_;
	    eval q((($index)+1<  ($dmfep->{tx}->{n_desc}) ? ($index)+1: 0));
    }' unless defined(&NEXT_TX_INDEX);
    eval 'sub NEXT_RX_INDEX {
        my($index) = @_;
	    eval q((($index)+1<  ($dmfep->{rx}->{n_desc}) ? ($index)+1: 0));
    }' unless defined(&NEXT_RX_INDEX);
    eval 'sub param_linkup () {( ($dmfep->{param_arr[0]}->{param_val}));}' unless defined(&param_linkup);
    eval 'sub param_speed () {( ($dmfep->{param_arr[1]}->{param_val}));}' unless defined(&param_speed);
    eval 'sub param_mode () {( ($dmfep->{param_arr[2]}->{param_val}));}' unless defined(&param_mode);
    eval 'sub param_autoneg () {( ($dmfep->{param_arr[3]}->{param_val}));}' unless defined(&param_autoneg);
    eval 'sub param_anar_100fdx () {( ($dmfep->{param_arr[4]}->{param_val}));}' unless defined(&param_anar_100fdx);
    eval 'sub param_anar_100hdx () {( ($dmfep->{param_arr[5]}->{param_val}));}' unless defined(&param_anar_100hdx);
    eval 'sub param_anar_10fdx () {( ($dmfep->{param_arr[6]}->{param_val}));}' unless defined(&param_anar_10fdx);
    eval 'sub param_anar_10hdx () {( ($dmfep->{param_arr[7]}->{param_val}));}' unless defined(&param_anar_10hdx);
    if(defined(&DEBUG)) {
	eval 'sub DMFEDEBUG () {1;}' unless defined(&DMFEDEBUG);
    } else {
	eval 'sub DMFEDEBUG () {0;}' unless defined(&DMFEDEBUG);
    }
    eval 'sub DMFETRACE () {0x1;}' unless defined(&DMFETRACE);
    eval 'sub DMFEERRS () {0x2;}' unless defined(&DMFEERRS);
    eval 'sub DMFERECV () {0x4;}' unless defined(&DMFERECV);
    eval 'sub DMFEDDI () {0x8;}' unless defined(&DMFEDDI);
    eval 'sub DMFESEND () {0x10;}' unless defined(&DMFESEND);
    eval 'sub DMFEINT () {0x20;}' unless defined(&DMFEINT);
    eval 'sub DMFEOPN () {0x40;}' unless defined(&DMFEOPN);
    eval 'sub DMFESENSE () {0x80;}' unless defined(&DMFESENSE);
    eval 'sub DMFESTAT () {0x100;}' unless defined(&DMFESTAT);
    eval 'sub DMFEXMIT () {0x200;}' unless defined(&DMFEXMIT);
    eval 'sub DMFENDD () {0x400;}' unless defined(&DMFENDD);
    eval 'sub DMFEMII () {0x800;}' unless defined(&DMFEMII);
    eval 'sub DMFELOOP () {0x1000;}' unless defined(&DMFELOOP);
    eval 'sub DMFEPROMISC () {0x2000;}' unless defined(&DMFEPROMISC);
    eval 'sub DMFESROM () {0x4000;}' unless defined(&DMFESROM);
    eval 'sub DMFEINIT () {0x8000;}' unless defined(&DMFEINIT);
    if((defined(&DMFEDEBUG) ? &DMFEDEBUG : 0)) {
	eval 'sub DMFE_DEBUG {
	    my($args) = @_;
    	    eval q( &do {  &if ( ($dmfep->{debug}) & ( &DMFE_DBG))  &cmn_err $args;  &_NOTE( &CONSTANTCONDITION) }  &while (0));
	}' unless defined(&DMFE_DEBUG);
	eval 'sub DMFE_TRACE {
	    my($args) = @_;
    	    eval q( &do {  &if ( ($dmfep->{debug}) & ( &DMFETRACE))  &cmn_err $args;  &_NOTE( &CONSTANTCONDITION) }  &while (0));
	}' unless defined(&DMFE_TRACE);
	eval 'sub DMFE_GDEBUG {
	    my($args) = @_;
    	    eval q( &do {  &if ( &dmfe_debug & ( &DMFE_DBG))  &cmn_err $args;  &_NOTE( &CONSTANTCONDITION) }  &while (0));
	}' unless defined(&DMFE_GDEBUG);
	eval 'sub DMFE_GTRACE {
	    my($args) = @_;
    	    eval q( &do {  &if ( &dmfe_debug & ( &DMFETRACE))  &cmn_err $args;  &_NOTE( &CONSTANTCONDITION) }  &while (0));
	}' unless defined(&DMFE_GTRACE);
    } else {
	eval 'sub DMFE_DEBUG {
	    my($args) = @_;
    	    eval q( &do ;  &_NOTE( &CONSTANTCONDITION)  &while (0));
	}' unless defined(&DMFE_DEBUG);
	eval 'sub DMFE_TRACE {
	    my($args) = @_;
    	    eval q( &do ;  &_NOTE( &CONSTANTCONDITION)  &while (0));
	}' unless defined(&DMFE_TRACE);
	eval 'sub DMFE_GDEBUG {
	    my($args) = @_;
    	    eval q( &do ;  &_NOTE( &CONSTANTCONDITION)  &while (0));
	}' unless defined(&DMFE_GDEBUG);
	eval 'sub DMFE_GTRACE {
	    my($args) = @_;
    	    eval q( &do ;  &_NOTE( &CONSTANTCONDITION)  &while (0));
	}' unless defined(&DMFE_GTRACE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
