require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FBIO_H)) {
    eval 'sub _SYS_FBIO_H () {1;}' unless defined(&_SYS_FBIO_H);
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&ASM)) {
	eval 'sub FIOC () {(ord(\'F\')<<8);}' unless defined(&FIOC);
	eval 'sub FBIOGTYPE () {( &FIOC|0);}' unless defined(&FBIOGTYPE);
	if(defined(&_KERNEL)) {
	    eval 'sub FBIOGPIXRECT () {( &FIOC|1);}' unless defined(&FBIOGPIXRECT);
	}
	eval 'sub FBIOGINFO () {( &FIOC|2);}' unless defined(&FBIOGINFO);
	if(defined(&_SYSCALL32)) {
	}
	eval 'sub FBIOPUTCMAP () {( &FIOC|3);}' unless defined(&FBIOPUTCMAP);
	eval 'sub FBIOGETCMAP () {( &FIOC|4);}' unless defined(&FBIOGETCMAP);
	eval 'sub FB_ATTR_NDEVSPECIFIC () {8;}' unless defined(&FB_ATTR_NDEVSPECIFIC);
	eval 'sub FB_ATTR_NEMUTYPES () {4;}' unless defined(&FB_ATTR_NEMUTYPES);
	eval 'sub FB_ATTR_AUTOINIT () {1;}' unless defined(&FB_ATTR_AUTOINIT);
	eval 'sub FB_ATTR_DEVSPECIFIC () {2;}' unless defined(&FB_ATTR_DEVSPECIFIC);
	eval 'sub FBIOSATTR () {( &FIOC|5);}' unless defined(&FBIOSATTR);
	eval 'sub FBIOGATTR () {( &FIOC|6);}' unless defined(&FBIOGATTR);
	eval 'sub FBVIDEO_OFF () {0;}' unless defined(&FBVIDEO_OFF);
	eval 'sub FBVIDEO_ON () {1;}' unless defined(&FBVIDEO_ON);
	eval 'sub FBIOSVIDEO () {( &FIOC|7);}' unless defined(&FBIOSVIDEO);
	eval 'sub FBIOGVIDEO () {( &FIOC|8);}' unless defined(&FBIOGVIDEO);
	eval 'sub FBIOVERTICAL () {( &FIOC|9);}' unless defined(&FBIOVERTICAL);
	eval 'sub GRABPAGEALLOC () {( &FIOC|10);}' unless defined(&GRABPAGEALLOC);
	eval 'sub GRABPAGEFREE () {( &FIOC|11);}' unless defined(&GRABPAGEFREE);
	eval 'sub GRABATTACH () {( &FIOC|12);}' unless defined(&GRABATTACH);
	eval 'sub FBIOGPLNGRP () {( &FIOC|13);}' unless defined(&FBIOGPLNGRP);
	eval 'sub FBIOGCMSIZE () {( &FIOC|14);}' unless defined(&FBIOGCMSIZE);
	eval 'sub FBIOSCMSIZE () {( &FIOC|15);}' unless defined(&FBIOSCMSIZE);
	eval 'sub FBIOSCMS () {( &FIOC|16);}' unless defined(&FBIOSCMS);
	eval 'sub FBIOAVAILPLNGRP () {( &FIOC|17);}' unless defined(&FBIOAVAILPLNGRP);
	eval 'sub FBDBL_AVAIL () {0x80000000;}' unless defined(&FBDBL_AVAIL);
	eval 'sub FBDBL_DONT_BLOCK () {0x40000000;}' unless defined(&FBDBL_DONT_BLOCK);
	eval 'sub FBDBL_AVAIL_PG () {0x20000000;}' unless defined(&FBDBL_AVAIL_PG);
	eval 'sub FBDBL_A () {0x1;}' unless defined(&FBDBL_A);
	eval 'sub FBDBL_B () {0x2;}' unless defined(&FBDBL_B);
	eval 'sub FBDBL_BOTH () {( &FBDBL_A |  &FBDBL_B);}' unless defined(&FBDBL_BOTH);
	eval 'sub FBDBL_NONE () {0x4;}' unless defined(&FBDBL_NONE);
	eval 'sub FBIODBLGINFO () {( &FIOC|18);}' unless defined(&FBIODBLGINFO);
	eval 'sub FBIODBLSINFO () {( &FIOC|19);}' unless defined(&FBIODBLSINFO);
	eval 'sub FBIOSWINFD () {( &FIOC|20);}' unless defined(&FBIOSWINFD);
	eval 'sub FBIOSAVWINFD () {( &FIOC|21);}' unless defined(&FBIOSAVWINFD);
	eval 'sub FBIORESWINFD () {( &FIOC|22);}' unless defined(&FBIORESWINFD);
	eval 'sub FBIOSRWINFD () {( &FIOC|23);}' unless defined(&FBIOSRWINFD);
	eval 'sub FB_CUR_SETCUR () {0x1;}' unless defined(&FB_CUR_SETCUR);
	eval 'sub FB_CUR_SETPOS () {0x2;}' unless defined(&FB_CUR_SETPOS);
	eval 'sub FB_CUR_SETHOT () {0x4;}' unless defined(&FB_CUR_SETHOT);
	eval 'sub FB_CUR_SETCMAP () {0x8;}' unless defined(&FB_CUR_SETCMAP);
	eval 'sub FB_CUR_SETSHAPE () {0x10;}' unless defined(&FB_CUR_SETSHAPE);
	eval 'sub FB_CUR_SETALL () {0x1f;}' unless defined(&FB_CUR_SETALL);
	if(defined(&_SYSCALL32)) {
	}
	eval 'sub FBIOSCURSOR () {( &FIOC|24);}' unless defined(&FBIOSCURSOR);
	eval 'sub FBIOGCURSOR () {( &FIOC|25);}' unless defined(&FBIOGCURSOR);
	eval 'sub FBIOSCURPOS () {( &FIOC|26);}' unless defined(&FBIOSCURPOS);
	eval 'sub FBIOGCURPOS () {( &FIOC|27);}' unless defined(&FBIOGCURPOS);
	eval 'sub FBIOGCURMAX () {( &FIOC|28);}' unless defined(&FBIOGCURMAX);
	eval 'sub GRABLOCKINFO () {( &FIOC|29);}' unless defined(&GRABLOCKINFO);
	eval 'sub FB_WID_SHARED_8 () {0;}' unless defined(&FB_WID_SHARED_8);
	eval 'sub FB_WID_SHARED_24 () {1;}' unless defined(&FB_WID_SHARED_24);
	eval 'sub FB_WID_DBL_8 () {2;}' unless defined(&FB_WID_DBL_8);
	eval 'sub FB_WID_DBL_24 () {3;}' unless defined(&FB_WID_DBL_24);
	if(defined(&_SYSCALL32)) {
	}
	eval 'sub FBIO_WID_ALLOC () {( &FIOC|30);}' unless defined(&FBIO_WID_ALLOC);
	eval 'sub FBIO_WID_FREE () {( &FIOC|31);}' unless defined(&FBIO_WID_FREE);
	eval 'sub FBIO_WID_PUT () {( &FIOC|32);}' unless defined(&FBIO_WID_PUT);
	eval 'sub FBIO_WID_GET () {( &FIOC|33);}' unless defined(&FBIO_WID_GET);
	eval 'sub FBIO_DEVID () {( &FIOC|34);}' unless defined(&FBIO_DEVID);
	eval 'sub FBIO_U_RST () {( &FIOC|35);}' unless defined(&FBIO_U_RST);
	eval 'sub FBIO_FULLSCREEN_ELIMINATION_GROUPS () {( &FIOC|36);}' unless defined(&FBIO_FULLSCREEN_ELIMINATION_GROUPS);
	eval 'sub FBIO_WID_DBL_SET () {( &FIOC|37);}' unless defined(&FBIO_WID_DBL_SET);
	eval 'sub FBIOVRTOFFSET () {( &FIOC|38);}' unless defined(&FBIOVRTOFFSET);
	eval 'sub MON_TYPE_STEREO () {0x8;}' unless defined(&MON_TYPE_STEREO);
	eval 'sub MON_TYPE_0_OFFSET () {0x4;}' unless defined(&MON_TYPE_0_OFFSET);
	eval 'sub MON_TYPE_OVERSCAN () {0x2;}' unless defined(&MON_TYPE_OVERSCAN);
	eval 'sub MON_TYPE_GRAY () {0x1;}' unless defined(&MON_TYPE_GRAY);
	eval 'sub FBIOGXINFO () {( &FIOC|39);}' unless defined(&FBIOGXINFO);
	eval 'sub FBIOMONINFO () {( &FIOC|40);}' unless defined(&FBIOMONINFO);
	if(defined(&_SYSCALL32)) {
	}
	eval 'sub FB_CMAP_BLOCK () {0x1;}' unless defined(&FB_CMAP_BLOCK);
	eval 'sub FB_CMAP_KERNEL () {0x2;}' unless defined(&FB_CMAP_KERNEL);
	eval 'sub FBIOPUTCMAPI () {( &FIOC|41);}' unless defined(&FBIOPUTCMAPI);
	eval 'sub FBIOGETCMAPI () {( &FIOC|42);}' unless defined(&FBIOGETCMAPI);
	eval 'sub FBIO_ASSIGNWID () {( &FIOC|43);}' unless defined(&FBIO_ASSIGNWID);
	eval 'sub FBIO_STEREO () {( &FIOC|44);}' unless defined(&FBIO_STEREO);
	eval 'sub FB_WIN_STEREO () {0x2;}' unless defined(&FB_WIN_STEREO);
    }
    eval 'sub FBTYPE_NOTYPE () {(-1);}' unless defined(&FBTYPE_NOTYPE);
    eval 'sub FBTYPE_SUN1BW () {0;}' unless defined(&FBTYPE_SUN1BW);
    eval 'sub FBTYPE_SUN1COLOR () {1;}' unless defined(&FBTYPE_SUN1COLOR);
    eval 'sub FBTYPE_SUN2BW () {2;}' unless defined(&FBTYPE_SUN2BW);
    eval 'sub FBTYPE_SUN2COLOR () {3;}' unless defined(&FBTYPE_SUN2COLOR);
    eval 'sub FBTYPE_SUN2GP () {4;}' unless defined(&FBTYPE_SUN2GP);
    eval 'sub FBTYPE_SUN5COLOR () {5;}' unless defined(&FBTYPE_SUN5COLOR);
    eval 'sub FBTYPE_SUN3COLOR () {6;}' unless defined(&FBTYPE_SUN3COLOR);
    eval 'sub FBTYPE_MEMCOLOR () {7;}' unless defined(&FBTYPE_MEMCOLOR);
    eval 'sub FBTYPE_SUN4COLOR () {8;}' unless defined(&FBTYPE_SUN4COLOR);
    eval 'sub FBTYPE_NOTSUN1 () {9;}' unless defined(&FBTYPE_NOTSUN1);
    eval 'sub FBTYPE_NOTSUN2 () {10;}' unless defined(&FBTYPE_NOTSUN2);
    eval 'sub FBTYPE_NOTSUN3 () {11;}' unless defined(&FBTYPE_NOTSUN3);
    eval 'sub FBTYPE_SUNFAST_COLOR () {12;}' unless defined(&FBTYPE_SUNFAST_COLOR);
    eval 'sub FBTYPE_SUNROP_COLOR () {13;}' unless defined(&FBTYPE_SUNROP_COLOR);
    eval 'sub FBTYPE_SUNFB_VIDEO () {14;}' unless defined(&FBTYPE_SUNFB_VIDEO);
    eval 'sub FBTYPE_SUNGIFB () {15;}' unless defined(&FBTYPE_SUNGIFB);
    eval 'sub FBTYPE_SUNGPLAS () {16;}' unless defined(&FBTYPE_SUNGPLAS);
    eval 'sub FBTYPE_SUNGP3 () {17;}' unless defined(&FBTYPE_SUNGP3);
    eval 'sub FBTYPE_SUNGT () {18;}' unless defined(&FBTYPE_SUNGT);
    eval 'sub FBTYPE_SUNLEO () {19;}' unless defined(&FBTYPE_SUNLEO);
    eval 'sub FBTYPE_MDICOLOR () {20;}' unless defined(&FBTYPE_MDICOLOR);
    eval 'sub FBTYPE_LASTPLUSONE () {21;}' unless defined(&FBTYPE_LASTPLUSONE);
    if(defined(&__cplusplus)) {
    }
}
1;
