require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FC4_FC_H)) {
    eval 'sub _SYS_FC4_FC_H () {1;}' unless defined(&_SYS_FC4_FC_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub FC_PH_VERSION () {0x6;}' unless defined(&FC_PH_VERSION);
    eval 'sub MAX_FRAME_SIZE () {2112;}' unless defined(&MAX_FRAME_SIZE);
    eval 'sub WE_ARE_ORIGINATOR {
        my($fh) = @_;
	    eval q(( ($fh->{f_ctl}) &  &F_CTL_XCHG_CONTEXT));
    }' unless defined(&WE_ARE_ORIGINATOR);
    eval 'sub UNSOLICITED_FRAME {
        my($fh) = @_;
	    eval q(( ($fh->{rx_id}) == 0xffff));
    }' unless defined(&UNSOLICITED_FRAME);
    eval 'sub FIRST_SEQUENCE {
        my($fh) = @_;
	    eval q(( ($fh->{f_ctl}) &  &F_CTL_FIRST_SEQ));
    }' unless defined(&FIRST_SEQUENCE);
    eval 'sub LAST_FRAME_OF_SEQUENCE {
        my($fh) = @_;
	    eval q(( ($fh->{f_ctl}) &  &F_CTL_END_SEQ));
    }' unless defined(&LAST_FRAME_OF_SEQUENCE);
    eval 'sub LAST_SEQUENCE_OF_EXCHANGE {
        my($fh) = @_;
	    eval q(( ($fh->{f_ctl}) &  &F_CTL_LAST_SEQ));
    }' unless defined(&LAST_SEQUENCE_OF_EXCHANGE);
    eval 'sub TRANSFER_INITIATIVE {
        my($fh) = @_;
	    eval q(( ($fh->{f_ctl}) &  &F_CTL_SEQ_INITIATIVE));
    }' unless defined(&TRANSFER_INITIATIVE);
    eval 'sub R_CTL_ROUTING () {0xf0;}' unless defined(&R_CTL_ROUTING);
    eval 'sub R_CTL_INFO () {0xf;}' unless defined(&R_CTL_INFO);
    eval 'sub R_CTL_DEVICE_DATA () {0x;}' unless defined(&R_CTL_DEVICE_DATA);
    eval 'sub R_CTL_EXTENDED_SVC () {0x20;}' unless defined(&R_CTL_EXTENDED_SVC);
    eval 'sub R_CTL_FC4_SVC () {0x30;}' unless defined(&R_CTL_FC4_SVC);
    eval 'sub R_CTL_VIDEO_BUFF () {0x40;}' unless defined(&R_CTL_VIDEO_BUFF);
    eval 'sub R_CTL_BASIC_SVC () {0x80;}' unless defined(&R_CTL_BASIC_SVC);
    eval 'sub R_CTL_LINK_CTL () {0xc0;}' unless defined(&R_CTL_LINK_CTL);
    eval 'sub R_CTL_UNCATEGORIZED () {0x;}' unless defined(&R_CTL_UNCATEGORIZED);
    eval 'sub R_CTL_SOLICITED_DATA () {0x1;}' unless defined(&R_CTL_SOLICITED_DATA);
    eval 'sub R_CTL_UNSOL_CONTROL () {0x2;}' unless defined(&R_CTL_UNSOL_CONTROL);
    eval 'sub R_CTL_SOLICITED_CONTROL () {0x3;}' unless defined(&R_CTL_SOLICITED_CONTROL);
    eval 'sub R_CTL_UNSOL_DATA () {0x4;}' unless defined(&R_CTL_UNSOL_DATA);
    eval 'sub R_CTL_XFER_RDY () {0x5;}' unless defined(&R_CTL_XFER_RDY);
    eval 'sub R_CTL_COMMAND () {0x6;}' unless defined(&R_CTL_COMMAND);
    eval 'sub R_CTL_STATUS () {0x7;}' unless defined(&R_CTL_STATUS);
    eval 'sub R_CTL_LS_NOP () {0x80;}' unless defined(&R_CTL_LS_NOP);
    eval 'sub R_CTL_LS_ABTS () {0x81;}' unless defined(&R_CTL_LS_ABTS);
    eval 'sub R_CTL_LS_RMC () {0x82;}' unless defined(&R_CTL_LS_RMC);
    eval 'sub R_CTL_LS_BA_ACC () {0x84;}' unless defined(&R_CTL_LS_BA_ACC);
    eval 'sub R_CTL_LS_BA_RJT () {0x85;}' unless defined(&R_CTL_LS_BA_RJT);
    eval 'sub R_CTL_ELS_REQ () {0x22;}' unless defined(&R_CTL_ELS_REQ);
    eval 'sub R_CTL_ELS_RSP () {0x23;}' unless defined(&R_CTL_ELS_RSP);
    eval 'sub LS_RJT () {0x1000000;}' unless defined(&LS_RJT);
    eval 'sub LS_ACC () {0x2000000;}' unless defined(&LS_ACC);
    eval 'sub LS_PLOGI () {0x3000000;}' unless defined(&LS_PLOGI);
    eval 'sub LS_FLOGI () {0x4000000;}' unless defined(&LS_FLOGI);
    eval 'sub LS_LOGO () {0x5000000;}' unless defined(&LS_LOGO);
    eval 'sub LS_ABTX () {0x6000000;}' unless defined(&LS_ABTX);
    eval 'sub LS_RCS () {0x7000000;}' unless defined(&LS_RCS);
    eval 'sub LS_RES () {0x8000000;}' unless defined(&LS_RES);
    eval 'sub LS_RSS () {0x9000000;}' unless defined(&LS_RSS);
    eval 'sub LS_RSI () {0xa000000;}' unless defined(&LS_RSI);
    eval 'sub LS_ESTS () {0xb000000;}' unless defined(&LS_ESTS);
    eval 'sub LS_ESTC () {0xc000000;}' unless defined(&LS_ESTC);
    eval 'sub LS_ADVC () {0xd000000;}' unless defined(&LS_ADVC);
    eval 'sub LS_RTV () {0xe000000;}' unless defined(&LS_RTV);
    eval 'sub LS_RLS () {0xf000000;}' unless defined(&LS_RLS);
    eval 'sub LS_ECHO () {0x10000000;}' unless defined(&LS_ECHO);
    eval 'sub LS_TEST () {0x11000000;}' unless defined(&LS_TEST);
    eval 'sub LS_RRQ () {0x12000000;}' unless defined(&LS_RRQ);
    eval 'sub LS_IDENT () {0x20000000;}' unless defined(&LS_IDENT);
    eval 'sub LS_DISPLAY () {0x21000000;}' unless defined(&LS_DISPLAY);
    eval 'sub R_CTL_ACK_1 () {0xc0;}' unless defined(&R_CTL_ACK_1);
    eval 'sub R_CTL_ACK_N () {0xc1;}' unless defined(&R_CTL_ACK_N);
    eval 'sub R_CTL_P_RJT () {0xc2;}' unless defined(&R_CTL_P_RJT);
    eval 'sub R_CTL_F_RJT () {0xc3;}' unless defined(&R_CTL_F_RJT);
    eval 'sub R_CTL_P_BSY () {0xc4;}' unless defined(&R_CTL_P_BSY);
    eval 'sub R_CTL_F_BSY_DF () {0xc5;}' unless defined(&R_CTL_F_BSY_DF);
    eval 'sub R_CTL_F_BSY_LC () {0xc6;}' unless defined(&R_CTL_F_BSY_LC);
    eval 'sub R_CTL_LCR () {0xc7;}' unless defined(&R_CTL_LCR);
    eval 'sub TYPE_BASIC_LS () {0x;}' unless defined(&TYPE_BASIC_LS);
    eval 'sub TYPE_EXTENDED_LS () {0x1;}' unless defined(&TYPE_EXTENDED_LS);
    eval 'sub TYPE_IS8802 () {0x4;}' unless defined(&TYPE_IS8802);
    eval 'sub TYPE_IS8802_SNAP () {0x5;}' unless defined(&TYPE_IS8802_SNAP);
    eval 'sub TYPE_SCSI_FCP () {0x8;}' unless defined(&TYPE_SCSI_FCP);
    eval 'sub TYPE_SCSI_GPP () {0x9;}' unless defined(&TYPE_SCSI_GPP);
    eval 'sub TYPE_HIPP_FP () {0xa;}' unless defined(&TYPE_HIPP_FP);
    eval 'sub TYPE_IPI3_MASTER () {0x11;}' unless defined(&TYPE_IPI3_MASTER);
    eval 'sub TYPE_IPI3_SLAVE () {0x12;}' unless defined(&TYPE_IPI3_SLAVE);
    eval 'sub TYPE_IPI3_PEER () {0x13;}' unless defined(&TYPE_IPI3_PEER);
    eval 'sub F_CTL_XCHG_CONTEXT () {0x800000;}' unless defined(&F_CTL_XCHG_CONTEXT);
    eval 'sub F_CTL_SEQ_CONTEXT () {0x400000;}' unless defined(&F_CTL_SEQ_CONTEXT);
    eval 'sub F_CTL_FIRST_SEQ () {0x200000;}' unless defined(&F_CTL_FIRST_SEQ);
    eval 'sub F_CTL_LAST_SEQ () {0x100000;}' unless defined(&F_CTL_LAST_SEQ);
    eval 'sub F_CTL_END_SEQ () {0x80000;}' unless defined(&F_CTL_END_SEQ);
    eval 'sub F_CTL_END_CONNECT () {0x40000;}' unless defined(&F_CTL_END_CONNECT);
    eval 'sub F_CTL_CHAINED_SEQ () {0x20000;}' unless defined(&F_CTL_CHAINED_SEQ);
    eval 'sub F_CTL_SEQ_INITIATIVE () {0x10000;}' unless defined(&F_CTL_SEQ_INITIATIVE);
    eval 'sub F_CTL_XID_REASSIGNED () {0x8000;}' unless defined(&F_CTL_XID_REASSIGNED);
    eval 'sub F_CTL_INVALIDATE_XID () {0x4000;}' unless defined(&F_CTL_INVALIDATE_XID);
    eval 'sub F_CTL_CONTINUE_SEQ () {0xc0;}' unless defined(&F_CTL_CONTINUE_SEQ);
    eval 'sub F_CTL_ABORT_SEQ () {0x30;}' unless defined(&F_CTL_ABORT_SEQ);
    eval 'sub F_CTL_RO_PRESENT () {0x8;}' unless defined(&F_CTL_RO_PRESENT);
    eval 'sub F_CTL_XCHG_REASSEMBLE () {0x4;}' unless defined(&F_CTL_XCHG_REASSEMBLE);
    eval 'sub F_CTL_FILL_BYTES () {0x3;}' unless defined(&F_CTL_FILL_BYTES);
    eval 'sub F_CTL_RESERVED () {0x3f00;}' unless defined(&F_CTL_RESERVED);
    eval 'sub F_CTL_ALWAYS_ZERO () {( &F_CTL_RESERVED |  &F_CTL_XCHG_REASSEMBLE |  &F_CTL_ABORT_SEQ |  &F_CTL_CONTINUE_SEQ|  &F_CTL_INVALIDATE_XID |  &F_CTL_XID_REASSIGNED |  &F_CTL_CHAINED_SEQ |  &F_CTL_END_CONNECT);}' unless defined(&F_CTL_ALWAYS_ZERO);
    eval 'sub FS_GENERAL_MULTICAST () {0xfffff7;}' unless defined(&FS_GENERAL_MULTICAST);
    eval 'sub FS_WELL_KNOWN_MULTICAST () {0xfffff8;}' unless defined(&FS_WELL_KNOWN_MULTICAST);
    eval 'sub FS_HUNT_GROUP () {0xfffff9;}' unless defined(&FS_HUNT_GROUP);
    eval 'sub FS_MANAGEMENT_SERVER () {0xfffffa;}' unless defined(&FS_MANAGEMENT_SERVER);
    eval 'sub FS_TIME_SERVER () {0xfffffb;}' unless defined(&FS_TIME_SERVER);
    eval 'sub FS_NAME_SERVER () {0xfffffc;}' unless defined(&FS_NAME_SERVER);
    eval 'sub FS_FABRIC_CONTROLLER () {0xfffffd;}' unless defined(&FS_FABRIC_CONTROLLER);
    eval 'sub FS_FABRIC_F_PORT () {0xfffffe;}' unless defined(&FS_FABRIC_F_PORT);
    eval 'sub FS_BROADCAST () {0xffffff;}' unless defined(&FS_BROADCAST);
    eval 'sub FABRIC_BUSY () {0x1;}' unless defined(&FABRIC_BUSY);
    eval 'sub NPORT_BUSY () {0x3;}' unless defined(&NPORT_BUSY);
    eval 'sub PHYSICAL_BUSY () {0x1;}' unless defined(&PHYSICAL_BUSY);
    eval 'sub RESOURSE_BUSY () {0x3;}' unless defined(&RESOURSE_BUSY);
    eval 'sub INVALID_D_ID () {0x1;}' unless defined(&INVALID_D_ID);
    eval 'sub INVALID_S_ID () {0x2;}' unless defined(&INVALID_S_ID);
    eval 'sub NPORT_NOT_AVAIL_TEMP () {0x3;}' unless defined(&NPORT_NOT_AVAIL_TEMP);
    eval 'sub NPORT_NOT_AVAIL_PERM () {0x4;}' unless defined(&NPORT_NOT_AVAIL_PERM);
    eval 'sub CLASS_NOT_SUPPORTED () {0x5;}' unless defined(&CLASS_NOT_SUPPORTED);
    eval 'sub DELIMITER_ERROR () {0x6;}' unless defined(&DELIMITER_ERROR);
    eval 'sub TYPE_NOT_SUPPORTED () {0x7;}' unless defined(&TYPE_NOT_SUPPORTED);
    eval 'sub INVALID_LINK_CONTROL () {0x8;}' unless defined(&INVALID_LINK_CONTROL);
    eval 'sub INVALID_R_CTL () {0x9;}' unless defined(&INVALID_R_CTL);
    eval 'sub INVALID_F_CTL () {0xa;}' unless defined(&INVALID_F_CTL);
    eval 'sub INVALID_OX_ID () {0xb;}' unless defined(&INVALID_OX_ID);
    eval 'sub INVALID_RX_ID () {0xc;}' unless defined(&INVALID_RX_ID);
    eval 'sub INVALID_SEQ_ID () {0xd;}' unless defined(&INVALID_SEQ_ID);
    eval 'sub INVALID_DF_CTL () {0xe;}' unless defined(&INVALID_DF_CTL);
    eval 'sub INVALID_SEQ_CNT () {0xf;}' unless defined(&INVALID_SEQ_CNT);
    eval 'sub INVALID_PARAMETER () {0x10;}' unless defined(&INVALID_PARAMETER);
    eval 'sub EXCHANGE_ERROR () {0x11;}' unless defined(&EXCHANGE_ERROR);
    eval 'sub PROTOCOL_ERROR () {0x12;}' unless defined(&PROTOCOL_ERROR);
    eval 'sub INCORRECT_LENGTH () {0x13;}' unless defined(&INCORRECT_LENGTH);
    eval 'sub UNEXPECTED_ACK () {0x14;}' unless defined(&UNEXPECTED_ACK);
    eval 'sub UNEXPECTED_LINK_RESP () {0x15;}' unless defined(&UNEXPECTED_LINK_RESP);
    eval 'sub LOGIN_REQUIRED () {0x16;}' unless defined(&LOGIN_REQUIRED);
    eval 'sub EXCESSIVE_SEQUENCES () {0x17;}' unless defined(&EXCESSIVE_SEQUENCES);
    eval 'sub CANT_ESTABLISH_EXCHANGE () {0x18;}' unless defined(&CANT_ESTABLISH_EXCHANGE);
    eval 'sub SECURITY_NOT_SUPPORTED () {0x19;}' unless defined(&SECURITY_NOT_SUPPORTED);
    eval 'sub RJT_INVALID_CMD_CODE () {0x1;}' unless defined(&RJT_INVALID_CMD_CODE);
    eval 'sub RJT_LOGICAL_ERROR () {0x3;}' unless defined(&RJT_LOGICAL_ERROR);
    eval 'sub RJT_LOGICAL_BUSY () {0x5;}' unless defined(&RJT_LOGICAL_BUSY);
    eval 'sub RJT_PROTOCOL_ERR () {0x7;}' unless defined(&RJT_PROTOCOL_ERR);
    eval 'sub RJT_CANT_PERFORM_RQST () {0x9;}' unless defined(&RJT_CANT_PERFORM_RQST);
    eval 'sub RJT_CMD_NOT_SUPPORTED () {0xb;}' unless defined(&RJT_CMD_NOT_SUPPORTED);
    eval 'sub SP_F_PORT_LOGIN () {0x10;}' unless defined(&SP_F_PORT_LOGIN);
    eval 'sub FC_MAX_ELS () {(60-4);}' unless defined(&FC_MAX_ELS);
    if(defined(&__cplusplus)) {
    }
}
1;
