require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FEATURE_TESTS_H)) {
    eval 'sub _SYS_FEATURE_TESTS_H () {1;}' unless defined(&_SYS_FEATURE_TESTS_H);
    require 'sys/isa_defs.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &_POSIX_SOURCE)  && !defined( &_POSIX_C_SOURCE)) {
	eval 'sub _POSIX_C_SOURCE () {1;}' unless defined(&_POSIX_C_SOURCE);
    }
    if((((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0)  && !defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_KERNEL) || defined( &_KMEMUSER) || defined( &__EXTENSIONS__)) {
	undef(&_LARGEFILE64_SOURCE) if defined(&_LARGEFILE64_SOURCE);
	eval 'sub _LARGEFILE64_SOURCE () {1;}' unless defined(&_LARGEFILE64_SOURCE);
    }
    if((defined(&_LARGEFILE64_SOURCE) ? &_LARGEFILE64_SOURCE : 0) - 0== 1) {
	undef(&_LARGEFILE_SOURCE) if defined(&_LARGEFILE_SOURCE);
	eval 'sub _LARGEFILE_SOURCE () {1;}' unless defined(&_LARGEFILE_SOURCE);
    }
    if(defined( &_LP64)) {
	unless(defined(&_FILE_OFFSET_BITS)) {
	    eval 'sub _FILE_OFFSET_BITS () {64;}' unless defined(&_FILE_OFFSET_BITS);
	}
	if((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) - 0!= 64) {
	    die("invalid _FILE_OFFSET_BITS value specified");
	}
    } else {
	unless(defined(&_FILE_OFFSET_BITS)) {
	    eval 'sub _FILE_OFFSET_BITS () {32;}' unless defined(&_FILE_OFFSET_BITS);
	}
	if((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) - 0!= 32 && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) - 0!= 64) {
	    die("invalid _FILE_OFFSET_BITS value specified");
	}
    }
    if((defined( &_XOPEN_SOURCE)  && (defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : 0) - 0== 1)) {
	eval 'sub _XPG4_2 () {1;}' unless defined(&_XPG4_2);
    }
    if(((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : 0) - 0== 500)) {
	eval 'sub _XPG5 () {1;}' unless defined(&_XPG5);
	eval 'sub _XPG4_2 () {1;}' unless defined(&_XPG4_2);
	undef(&_POSIX_C_SOURCE) if defined(&_POSIX_C_SOURCE);
	eval 'sub _POSIX_C_SOURCE () {199506;}' unless defined(&_POSIX_C_SOURCE);
	eval 'sub _POSIX_PTHREAD_SEMANTICS () {1;}' unless defined(&_POSIX_PTHREAD_SEMANTICS);
    }
    unless(defined(&_XOPEN_VERSION)) {
	if(defined(&_XPG5)) {
	    eval 'sub _XOPEN_VERSION () {500;}' unless defined(&_XOPEN_VERSION);
	} else {
	    if(defined(&_XPG4_2)) {
		eval 'sub _XOPEN_VERSION () {4;}' unless defined(&_XOPEN_VERSION);
	    } else {
		eval 'sub _XOPEN_VERSION () {3;}' unless defined(&_XOPEN_VERSION);
	    }
	}
    }
    eval 'sub _ISO_CPP_14882_1998 () {1;}' unless defined(&_ISO_CPP_14882_1998);
    if(defined(&__cplusplus)) {
    }
}
1;
