require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FIBRE_CHANNEL_FCA_USOCREG_H)) {
    eval 'sub _SYS_FIBRE_CHANNEL_FCA_USOCREG_H () {1;}' unless defined(&_SYS_FIBRE_CHANNEL_FCA_USOCREG_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub N_USOC_NPORTS () {2;}' unless defined(&N_USOC_NPORTS);
    eval 'sub USOC_CR_SBUS_BURST_SIZE_MASK () {0x7;}' unless defined(&USOC_CR_SBUS_BURST_SIZE_MASK);
    eval 'sub USOC_CR_SBUS_BURST_SIZE_64BIT_MASK () {0x700;}' unless defined(&USOC_CR_SBUS_BURST_SIZE_64BIT_MASK);
    eval 'sub USOC_CR_SBUS_BURST_SIZE_64BIT {
        my($a) = @_;
	    eval q(((($a) &  &USOC_CR_SBUS_BURST_SIZE_64BIT_MASK) >> 8));
    }' unless defined(&USOC_CR_SBUS_BURST_SIZE_64BIT);
    eval 'sub USOC_CR_BURST_4 () {0x;}' unless defined(&USOC_CR_BURST_4);
    eval 'sub USOC_CR_BURST_8 () {0x3;}' unless defined(&USOC_CR_BURST_8);
    eval 'sub USOC_CR_BURST_16 () {0x4;}' unless defined(&USOC_CR_BURST_16);
    eval 'sub USOC_CR_BURST_32 () {0x5;}' unless defined(&USOC_CR_BURST_32);
    eval 'sub USOC_CR_BURST_64 () {0x6;}' unless defined(&USOC_CR_BURST_64);
    eval 'sub USOC_CR_BURST_128 () {0x7;}' unless defined(&USOC_CR_BURST_128);
    eval 'sub USOC_CR_SBUS_ENHANCED () {0x8;}' unless defined(&USOC_CR_SBUS_ENHANCED);
    eval 'sub USOC_CR_SBUS_PARITY_CHK () {0x10;}' unless defined(&USOC_CR_SBUS_PARITY_CHK);
    eval 'sub USOC_CR_SBUS_PARITY_TEST () {0x20;}' unless defined(&USOC_CR_SBUS_PARITY_TEST);
    eval 'sub USOC_CR_EEPROM_BANK_MASK () {0x30000;}' unless defined(&USOC_CR_EEPROM_BANK_MASK);
    eval 'sub USOC_CR_EEPROM_BANK {
        my($a) = @_;
	    eval q(((($a) &  &USOC_CR_EEPROM_BANK_MASK) >> 16));
    }' unless defined(&USOC_CR_EEPROM_BANK);
    eval 'sub USOC_CR_EXTERNAL_RAM_BANK_MASK () {0x7000000;}' unless defined(&USOC_CR_EXTERNAL_RAM_BANK_MASK);
    eval 'sub USOC_CR_EXTERNAL_RAM_BANK {
        my($a) = @_;
	    eval q(((($a) &  &USOC_CR_EXTERNAL_RAM_BANK_MASK) >> 24));
    }' unless defined(&USOC_CR_EXTERNAL_RAM_BANK);
    eval 'sub USOC_SAE_PARITY_ERROR () {0x1;}' unless defined(&USOC_SAE_PARITY_ERROR);
    eval 'sub USOC_SAE_UNSUPPORTED_TRANSFER () {0x2;}' unless defined(&USOC_SAE_UNSUPPORTED_TRANSFER);
    eval 'sub USOC_SAE_ALIGNMENT_ERROR () {0x4;}' unless defined(&USOC_SAE_ALIGNMENT_ERROR);
    eval 'sub USOC_CSR_ZEROS () {0x70;}' unless defined(&USOC_CSR_ZEROS);
    eval 'sub USOC_CSR_USOC_TO_HOST () {0xf0000;}' unless defined(&USOC_CSR_USOC_TO_HOST);
    eval 'sub USOC_CSR_HOST_TO_USOC () {0xf00;}' unless defined(&USOC_CSR_HOST_TO_USOC);
    eval 'sub USOC_CSR_SLV_ACC_ERR () {0x80;}' unless defined(&USOC_CSR_SLV_ACC_ERR);
    eval 'sub USOC_CSR_INT_PENDING () {0x8;}' unless defined(&USOC_CSR_INT_PENDING);
    eval 'sub USOC_CSR_NON_Q_CMD () {0x4;}' unless defined(&USOC_CSR_NON_Q_CMD);
    eval 'sub USOC_CSR_IDLE () {0x2;}' unless defined(&USOC_CSR_IDLE);
    eval 'sub USOC_CSR_SOFT_RESET () {0x1;}' unless defined(&USOC_CSR_SOFT_RESET);
    eval 'sub USOC_CSR_1ST_S_TO_H () {0x10000;}' unless defined(&USOC_CSR_1ST_S_TO_H);
    eval 'sub USOC_CSR_1ST_H_TO_S () {0x100;}' unless defined(&USOC_CSR_1ST_H_TO_S);
    eval 'sub USOC_CSR_RSP_QUE_0 () { &USOC_CSR_1ST_S_TO_H;}' unless defined(&USOC_CSR_RSP_QUE_0);
    eval 'sub USOC_CSR_RSP_QUE_1 () {0x20000;}' unless defined(&USOC_CSR_RSP_QUE_1);
    eval 'sub USOC_CSR_RSP_QUE_2 () {0x40000;}' unless defined(&USOC_CSR_RSP_QUE_2);
    eval 'sub USOC_CSR_RSP_QUE_3 () {0x80000;}' unless defined(&USOC_CSR_RSP_QUE_3);
    eval 'sub USOC_CSR_REQ_QUE_0 () { &USOC_CSR_1ST_H_TO_S;}' unless defined(&USOC_CSR_REQ_QUE_0);
    eval 'sub USOC_CSR_REQ_QUE_1 () {0x200;}' unless defined(&USOC_CSR_REQ_QUE_1);
    eval 'sub USOC_CSR_REQ_QUE_2 () {0x400;}' unless defined(&USOC_CSR_REQ_QUE_2);
    eval 'sub USOC_CSR_REQ_QUE_3 () {0x800;}' unless defined(&USOC_CSR_REQ_QUE_3);
    eval 'sub USOC_IMR_NON_QUEUED_STATE () {0x4;}' unless defined(&USOC_IMR_NON_QUEUED_STATE);
    eval 'sub USOC_IMR_SLAVE_ACCESS_ERROR () {0x80;}' unless defined(&USOC_IMR_SLAVE_ACCESS_ERROR);
    eval 'sub USOC_IMR_REQUEST_QUEUE_0 () {0x100;}' unless defined(&USOC_IMR_REQUEST_QUEUE_0);
    eval 'sub USOC_IMR_REQUEST_QUEUE_1 () {0x200;}' unless defined(&USOC_IMR_REQUEST_QUEUE_1);
    eval 'sub USOC_IMR_REQUEST_QUEUE_2 () {0x400;}' unless defined(&USOC_IMR_REQUEST_QUEUE_2);
    eval 'sub USOC_IMR_REQUEST_QUEUE_3 () {0x800;}' unless defined(&USOC_IMR_REQUEST_QUEUE_3);
    eval 'sub USOC_IMR_RESPONSE_QUEUE_0 () {0x10000;}' unless defined(&USOC_IMR_RESPONSE_QUEUE_0);
    eval 'sub USOC_IMR_RESPONSE_QUEUE_1 () {0x20000;}' unless defined(&USOC_IMR_RESPONSE_QUEUE_1);
    eval 'sub USOC_IMR_RESPONSE_QUEUE_2 () {0x40000;}' unless defined(&USOC_IMR_RESPONSE_QUEUE_2);
    eval 'sub USOC_IMR_RESPONSE_QUEUE_3 () {0x80000;}' unless defined(&USOC_IMR_RESPONSE_QUEUE_3);
    eval 'sub USOC_REQUESTQ0_MASK () {0xff000000;}' unless defined(&USOC_REQUESTQ0_MASK);
    eval 'sub USOC_REQUESTQ1_MASK () {0xff0000;}' unless defined(&USOC_REQUESTQ1_MASK);
    eval 'sub USOC_REQUESTQ2_MASK () {0xff00;}' unless defined(&USOC_REQUESTQ2_MASK);
    eval 'sub USOC_REQUESTQ3_MASK () {0xff;}' unless defined(&USOC_REQUESTQ3_MASK);
    eval 'sub USOC_REQUESTQ0_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &USOC_REQUESTQ0_MASK) >> 24));
    }' unless defined(&USOC_REQUESTQ0_INDEX);
    eval 'sub USOC_REQUESTQ1_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &USOC_REQUESTQ1_MASK) >> 16));
    }' unless defined(&USOC_REQUESTQ1_INDEX);
    eval 'sub USOC_REQUESTQ2_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &USOC_REQUESTQ2_MASK) >> 8));
    }' unless defined(&USOC_REQUESTQ2_INDEX);
    eval 'sub USOC_REQUESTQ3_INDEX {
        my($a) = @_;
	    eval q((($a) &  &USOC_REQUESTQ3_MASK));
    }' unless defined(&USOC_REQUESTQ3_INDEX);
    eval 'sub USOC_REQUESTQ_INDEX {
        my($a, $b) = @_;
	    eval q((($b)>>((3-($a))<<3) & 0xff));
    }' unless defined(&USOC_REQUESTQ_INDEX);
    eval 'sub USOC_RESPONSEQ0_MASK () {0xff000000;}' unless defined(&USOC_RESPONSEQ0_MASK);
    eval 'sub USOC_RESPONSEQ1_MASK () {0xff0000;}' unless defined(&USOC_RESPONSEQ1_MASK);
    eval 'sub USOC_RESPONSEQ2_MASK () {0xff00;}' unless defined(&USOC_RESPONSEQ2_MASK);
    eval 'sub USOC_RESPONSEQ3_MASK () {0xff;}' unless defined(&USOC_RESPONSEQ3_MASK);
    eval 'sub USOC_RESPONSEQ0_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &USOC_RESPONSEQ0_MASK) >> 24));
    }' unless defined(&USOC_RESPONSEQ0_INDEX);
    eval 'sub USOC_RESPONSEQ1_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &USOC_RESPONSEQ1_MASK) >> 16));
    }' unless defined(&USOC_RESPONSEQ1_INDEX);
    eval 'sub USOC_RESPONSEQ2_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &USOC_RESPONSEQ2_MASK) >> 8));
    }' unless defined(&USOC_RESPONSEQ2_INDEX);
    eval 'sub USOC_RESPONSEQ3_INDEX {
        my($a) = @_;
	    eval q((($a) &  &USOC_RESPONSEQ3_MASK));
    }' unless defined(&USOC_RESPONSEQ3_INDEX);
    eval 'sub USOC_RESPONSEQ_INDEX {
        my($a, $b) = @_;
	    eval q((($b)>>((3-($a))<<3) & 0xff));
    }' unless defined(&USOC_RESPONSEQ_INDEX);
    eval 'sub USOC_XRAM_OFFSET () {0x10000;}' unless defined(&USOC_XRAM_OFFSET);
    eval 'sub USOC_XRAM_SIZE () {0x10000;}' unless defined(&USOC_XRAM_SIZE);
    eval 'sub USOC_MAX_XCHG () {1024;}' unless defined(&USOC_MAX_XCHG);
    eval 'sub USOC_REG_OFFSET () {( &USOC_XRAM_OFFSET +  &USOC_XRAM_SIZE);}' unless defined(&USOC_REG_OFFSET);
    eval 'sub USOC_CQ_REQUEST_OFFSET () {( &USOC_XRAM_OFFSET + 0x200);}' unless defined(&USOC_CQ_REQUEST_OFFSET);
    eval 'sub USOC_CQ_RESPONSE_OFFSET () {( &USOC_XRAM_OFFSET + 0x220);}' unless defined(&USOC_CQ_RESPONSE_OFFSET);
    eval 'sub USOC_INTR_CAUSE {
        my($usocp, $csr) = @_;
	    eval q(((($csr) &  &USOC_CSR_USOC_TO_HOST) | ((~$csr) & ( &USOC_CSR_HOST_TO_USOC))) &  ($usocp->{usoc_k_imr}));
    }' unless defined(&USOC_INTR_CAUSE);
    unless(defined(&BURSTSIZE)) {
	eval 'sub BURSTSIZE () {1;}' unless defined(&BURSTSIZE);
	eval 'sub BURST1 () {0x1;}' unless defined(&BURST1);
	eval 'sub BURST2 () {0x2;}' unless defined(&BURST2);
	eval 'sub BURST4 () {0x4;}' unless defined(&BURST4);
	eval 'sub BURST8 () {0x8;}' unless defined(&BURST8);
	eval 'sub BURST16 () {0x10;}' unless defined(&BURST16);
	eval 'sub BURST32 () {0x20;}' unless defined(&BURST32);
	eval 'sub BURST64 () {0x40;}' unless defined(&BURST64);
	eval 'sub BURST128 () {0x80;}' unless defined(&BURST128);
	eval 'sub BURSTSIZE_MASK () {0xff;}' unless defined(&BURSTSIZE_MASK);
	eval 'sub DEFAULT_BURSTSIZE () { &BURST16| &BURST8| &BURST4| &BURST2| &BURST1;}' unless defined(&DEFAULT_BURSTSIZE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
