require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FIBRE_CHANNEL_IMPL_FC_ERROR_H)) {
    eval 'sub _SYS_FIBRE_CHANNEL_IMPL_FC_ERROR_H () {1;}' unless defined(&_SYS_FIBRE_CHANNEL_IMPL_FC_ERROR_H);
    require 'sys/note.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub FC_FAILURE () {-1;}' unless defined(&FC_FAILURE);
    eval 'sub FC_FAILURE_SILENT () {-2;}' unless defined(&FC_FAILURE_SILENT);
    eval 'sub FC_SUCCESS () {0x;}' unless defined(&FC_SUCCESS);
    eval 'sub FC_CAP_ERROR () {0x1;}' unless defined(&FC_CAP_ERROR);
    eval 'sub FC_CAP_FOUND () {0x2;}' unless defined(&FC_CAP_FOUND);
    eval 'sub FC_CAP_SETTABLE () {0x3;}' unless defined(&FC_CAP_SETTABLE);
    eval 'sub FC_UNBOUND () {0x4;}' unless defined(&FC_UNBOUND);
    eval 'sub FC_NOMEM () {0x5;}' unless defined(&FC_NOMEM);
    eval 'sub FC_BADPACKET () {0x6;}' unless defined(&FC_BADPACKET);
    eval 'sub FC_OFFLINE () {0x7;}' unless defined(&FC_OFFLINE);
    eval 'sub FC_OLDPORT () {0x8;}' unless defined(&FC_OLDPORT);
    eval 'sub FC_NO_MAP () {0x9;}' unless defined(&FC_NO_MAP);
    eval 'sub FC_TRANSPORT_ERROR () {0xa;}' unless defined(&FC_TRANSPORT_ERROR);
    eval 'sub FC_ELS_FREJECT () {0xb;}' unless defined(&FC_ELS_FREJECT);
    eval 'sub FC_ELS_PREJECT () {0xc;}' unless defined(&FC_ELS_PREJECT);
    eval 'sub FC_ELS_BAD () {0xd;}' unless defined(&FC_ELS_BAD);
    eval 'sub FC_ELS_MALFORMED () {0xe;}' unless defined(&FC_ELS_MALFORMED);
    eval 'sub FC_TOOMANY () {0xf;}' unless defined(&FC_TOOMANY);
    eval 'sub FC_UB_BADTOKEN () {0x10;}' unless defined(&FC_UB_BADTOKEN);
    eval 'sub FC_UB_ERROR () {0x11;}' unless defined(&FC_UB_ERROR);
    eval 'sub FC_UB_BUSY () {0x12;}' unless defined(&FC_UB_BUSY);
    eval 'sub FC_BADULP () {0x15;}' unless defined(&FC_BADULP);
    eval 'sub FC_BADTYPE () {0x16;}' unless defined(&FC_BADTYPE);
    eval 'sub FC_UNCLAIMED () {0x17;}' unless defined(&FC_UNCLAIMED);
    eval 'sub FC_ULP_SAMEMODULE () {0x18;}' unless defined(&FC_ULP_SAMEMODULE);
    eval 'sub FC_ULP_SAMETYPE () {0x19;}' unless defined(&FC_ULP_SAMETYPE);
    eval 'sub FC_ABORTED () {0x20;}' unless defined(&FC_ABORTED);
    eval 'sub FC_ABORT_FAILED () {0x21;}' unless defined(&FC_ABORT_FAILED);
    eval 'sub FC_BADEXCHANGE () {0x22;}' unless defined(&FC_BADEXCHANGE);
    eval 'sub FC_BADWWN () {0x23;}' unless defined(&FC_BADWWN);
    eval 'sub FC_BADDEV () {0x24;}' unless defined(&FC_BADDEV);
    eval 'sub FC_BADCMD () {0x25;}' unless defined(&FC_BADCMD);
    eval 'sub FC_BADOBJECT () {0x26;}' unless defined(&FC_BADOBJECT);
    eval 'sub FC_BADPORT () {0x27;}' unless defined(&FC_BADPORT);
    eval 'sub FC_NOTTHISPORT () {0x30;}' unless defined(&FC_NOTTHISPORT);
    eval 'sub FC_PREJECT () {0x31;}' unless defined(&FC_PREJECT);
    eval 'sub FC_FREJECT () {0x32;}' unless defined(&FC_FREJECT);
    eval 'sub FC_PBUSY () {0x33;}' unless defined(&FC_PBUSY);
    eval 'sub FC_FBUSY () {0x34;}' unless defined(&FC_FBUSY);
    eval 'sub FC_ALREADY () {0x35;}' unless defined(&FC_ALREADY);
    eval 'sub FC_LOGINREQ () {0x36;}' unless defined(&FC_LOGINREQ);
    eval 'sub FC_RESETFAIL () {0x37;}' unless defined(&FC_RESETFAIL);
    eval 'sub FC_INVALID_REQUEST () {0x38;}' unless defined(&FC_INVALID_REQUEST);
    eval 'sub FC_OUTOFBOUNDS () {0x39;}' unless defined(&FC_OUTOFBOUNDS);
    eval 'sub FC_TRAN_BUSY () {0x40;}' unless defined(&FC_TRAN_BUSY);
    eval 'sub FC_STATEC_BUSY () {0x41;}' unless defined(&FC_STATEC_BUSY);
    eval 'sub FC_DEVICE_BUSY () {0x42;}' unless defined(&FC_DEVICE_BUSY);
    eval 'sub FC_PKT_SUCCESS () {0x1;}' unless defined(&FC_PKT_SUCCESS);
    eval 'sub FC_PKT_REMOTE_STOP () {0x2;}' unless defined(&FC_PKT_REMOTE_STOP);
    eval 'sub FC_PKT_LOCAL_RJT () {0x3;}' unless defined(&FC_PKT_LOCAL_RJT);
    eval 'sub FC_PKT_NPORT_RJT () {0x4;}' unless defined(&FC_PKT_NPORT_RJT);
    eval 'sub FC_PKT_FABRIC_RJT () {0x5;}' unless defined(&FC_PKT_FABRIC_RJT);
    eval 'sub FC_PKT_LOCAL_BSY () {0x6;}' unless defined(&FC_PKT_LOCAL_BSY);
    eval 'sub FC_PKT_TRAN_BSY () {0x7;}' unless defined(&FC_PKT_TRAN_BSY);
    eval 'sub FC_PKT_NPORT_BSY () {0x8;}' unless defined(&FC_PKT_NPORT_BSY);
    eval 'sub FC_PKT_FABRIC_BSY () {0x9;}' unless defined(&FC_PKT_FABRIC_BSY);
    eval 'sub FC_PKT_LS_RJT () {0xa;}' unless defined(&FC_PKT_LS_RJT);
    eval 'sub FC_PKT_BA_RJT () {0xb;}' unless defined(&FC_PKT_BA_RJT);
    eval 'sub FC_PKT_TIMEOUT () {0xc;}' unless defined(&FC_PKT_TIMEOUT);
    eval 'sub FC_PKT_FS_RJT () {0xd;}' unless defined(&FC_PKT_FS_RJT);
    eval 'sub FC_PKT_TRAN_ERROR () {0xe;}' unless defined(&FC_PKT_TRAN_ERROR);
    eval 'sub FC_PKT_FAILURE () {0xf;}' unless defined(&FC_PKT_FAILURE);
    eval 'sub FC_PKT_PORT_OFFLINE () {0x10;}' unless defined(&FC_PKT_PORT_OFFLINE);
    eval 'sub FC_PKT_ELS_IN_PROGRESS () {0x11;}' unless defined(&FC_PKT_ELS_IN_PROGRESS);
    eval 'sub FC_REASON_ABTS () {0x;}' unless defined(&FC_REASON_ABTS);
    eval 'sub FC_REASON_ABTX () {0x1;}' unless defined(&FC_REASON_ABTX);
    eval 'sub FC_REASON_HW_ERROR () {0x1;}' unless defined(&FC_REASON_HW_ERROR);
    eval 'sub FC_REASON_SEQ_TIMEOUT () {0x2;}' unless defined(&FC_REASON_SEQ_TIMEOUT);
    eval 'sub FC_REASON_ABORTED () {0x3;}' unless defined(&FC_REASON_ABORTED);
    eval 'sub FC_REASON_ABORT_FAILED () {0x4;}' unless defined(&FC_REASON_ABORT_FAILED);
    eval 'sub FC_REASON_NO_CONNECTION () {0x5;}' unless defined(&FC_REASON_NO_CONNECTION);
    eval 'sub FC_REASON_XCHG_DROPPED () {0x6;}' unless defined(&FC_REASON_XCHG_DROPPED);
    eval 'sub FC_REASON_ILLEGAL_FRAME () {0x7;}' unless defined(&FC_REASON_ILLEGAL_FRAME);
    eval 'sub FC_REASON_ILLEGAL_LENGTH () {0x8;}' unless defined(&FC_REASON_ILLEGAL_LENGTH);
    eval 'sub FC_REASON_UNSUPPORTED () {0x9;}' unless defined(&FC_REASON_UNSUPPORTED);
    eval 'sub FC_REASON_RX_BUF_TIMEOUT () {0xa;}' unless defined(&FC_REASON_RX_BUF_TIMEOUT);
    eval 'sub FC_REASON_FCAL_OPN_FAIL () {0xb;}' unless defined(&FC_REASON_FCAL_OPN_FAIL);
    eval 'sub FC_REASON_OVERRUN () {0xc;}' unless defined(&FC_REASON_OVERRUN);
    eval 'sub FC_REASON_QFULL () {0xd;}' unless defined(&FC_REASON_QFULL);
    eval 'sub FC_REASON_ILLEGAL_REQ () {0xe;}' unless defined(&FC_REASON_ILLEGAL_REQ);
    eval 'sub FC_REASON_PKT_BUSY () {0xf;}' unless defined(&FC_REASON_PKT_BUSY);
    eval 'sub FC_REASON_OFFLINE () {0x11;}' unless defined(&FC_REASON_OFFLINE);
    eval 'sub FC_REASON_BAD_XID () {0x12;}' unless defined(&FC_REASON_BAD_XID);
    eval 'sub FC_REASON_XCHG_BSY () {0x13;}' unless defined(&FC_REASON_XCHG_BSY);
    eval 'sub FC_REASON_NOMEM () {0x14;}' unless defined(&FC_REASON_NOMEM);
    eval 'sub FC_REASON_BAD_SID () {0x15;}' unless defined(&FC_REASON_BAD_SID);
    eval 'sub FC_REASON_NO_SEQ_INIT () {0x16;}' unless defined(&FC_REASON_NO_SEQ_INIT);
    eval 'sub FC_REASON_DIAG_BUSY () {0x17;}' unless defined(&FC_REASON_DIAG_BUSY);
    eval 'sub FC_REASON_DMA_ERROR () {0x18;}' unless defined(&FC_REASON_DMA_ERROR);
    eval 'sub FC_REASON_CRC_ERROR () {0x19;}' unless defined(&FC_REASON_CRC_ERROR);
    eval 'sub FC_REASON_ABORT_TIMEOUT () {0x1a;}' unless defined(&FC_REASON_ABORT_TIMEOUT);
    eval 'sub FC_REASON_UNDERRUN () {0x1b;}' unless defined(&FC_REASON_UNDERRUN);
    eval 'sub FC_REASON_FCA_UNIQUE () {0x7e;}' unless defined(&FC_REASON_FCA_UNIQUE);
    eval 'sub FC_REASON_INVALID_D_ID () {0x1;}' unless defined(&FC_REASON_INVALID_D_ID);
    eval 'sub FC_REASON_INVALID_S_ID () {0x2;}' unless defined(&FC_REASON_INVALID_S_ID);
    eval 'sub FC_REASON_TEMP_UNAVAILABLE () {0x3;}' unless defined(&FC_REASON_TEMP_UNAVAILABLE);
    eval 'sub FC_REASON_PERM_UNAVAILABLE () {0x4;}' unless defined(&FC_REASON_PERM_UNAVAILABLE);
    eval 'sub FC_REASON_CLASS_NOT_SUPP () {0x5;}' unless defined(&FC_REASON_CLASS_NOT_SUPP);
    eval 'sub FC_REASON_DELIMTER_USAGE_ERROR () {0x6;}' unless defined(&FC_REASON_DELIMTER_USAGE_ERROR);
    eval 'sub FC_REASON_TYPE_NOT_SUPP () {0x7;}' unless defined(&FC_REASON_TYPE_NOT_SUPP);
    eval 'sub FC_REASON_INVALID_LINK_CTRL () {0x8;}' unless defined(&FC_REASON_INVALID_LINK_CTRL);
    eval 'sub FC_REASON_INVALID_R_CTL () {0x9;}' unless defined(&FC_REASON_INVALID_R_CTL);
    eval 'sub FC_REASON_INVALID_F_CTL () {0xa;}' unless defined(&FC_REASON_INVALID_F_CTL);
    eval 'sub FC_REASON_INVALID_OX_ID () {0xb;}' unless defined(&FC_REASON_INVALID_OX_ID);
    eval 'sub FC_REASON_INVALID_RX_ID () {0xc;}' unless defined(&FC_REASON_INVALID_RX_ID);
    eval 'sub FC_REASON_INVALID_SEQ_ID () {0xd;}' unless defined(&FC_REASON_INVALID_SEQ_ID);
    eval 'sub FC_REASON_INVALID_DF_CTL () {0xe;}' unless defined(&FC_REASON_INVALID_DF_CTL);
    eval 'sub FC_REASON_INVALID_SEQ_CNT () {0xf;}' unless defined(&FC_REASON_INVALID_SEQ_CNT);
    eval 'sub FC_REASON_INVALID_PARAM () {0x10;}' unless defined(&FC_REASON_INVALID_PARAM);
    eval 'sub FC_REASON_EXCH_ERROR () {0x11;}' unless defined(&FC_REASON_EXCH_ERROR);
    eval 'sub FC_REASON_PROTOCOL_ERROR () {0x12;}' unless defined(&FC_REASON_PROTOCOL_ERROR);
    eval 'sub FC_REASON_INCORRECT_LENGTH () {0x13;}' unless defined(&FC_REASON_INCORRECT_LENGTH);
    eval 'sub FC_REASON_UNEXPECTED_ACK () {0x14;}' unless defined(&FC_REASON_UNEXPECTED_ACK);
    eval 'sub FC_REASON_UNEXPECTED_LR () {0x15;}' unless defined(&FC_REASON_UNEXPECTED_LR);
    eval 'sub FC_REASON_LOGIN_REQUIRED () {0x16;}' unless defined(&FC_REASON_LOGIN_REQUIRED);
    eval 'sub FC_REASON_EXCESSIVE_SEQS () {0x17;}' unless defined(&FC_REASON_EXCESSIVE_SEQS);
    eval 'sub FC_REASON_EXCH_UNABLE () {0x18;}' unless defined(&FC_REASON_EXCH_UNABLE);
    eval 'sub FC_REASON_ESH_NOT_SUPP () {0x19;}' unless defined(&FC_REASON_ESH_NOT_SUPP);
    eval 'sub FC_REASON_NO_FABRIC_PATH () {0x1a;}' unless defined(&FC_REASON_NO_FABRIC_PATH);
    eval 'sub FC_REASON_VENDOR_UNIQUE () {0xff;}' unless defined(&FC_REASON_VENDOR_UNIQUE);
    eval 'sub FC_REASON_PHYSICAL_BUSY () {0x1;}' unless defined(&FC_REASON_PHYSICAL_BUSY);
    eval 'sub FC_REASON_N_PORT_RESOURCE_BSY () {0x3;}' unless defined(&FC_REASON_N_PORT_RESOURCE_BSY);
    eval 'sub FC_REASON_N_PORT_VENDOR_UNIQUE () {0xff;}' unless defined(&FC_REASON_N_PORT_VENDOR_UNIQUE);
    eval 'sub FC_REASON_FABRIC_BSY () {0x1;}' unless defined(&FC_REASON_FABRIC_BSY);
    eval 'sub FC_REASON_N_PORT_BSY () {0x3;}' unless defined(&FC_REASON_N_PORT_BSY);
    eval 'sub FC_REASON_INVALID_LA_CODE () {0x1;}' unless defined(&FC_REASON_INVALID_LA_CODE);
    eval 'sub FC_REASON_LOGICAL_ERROR () {0x3;}' unless defined(&FC_REASON_LOGICAL_ERROR);
    eval 'sub FC_REASON_LOGICAL_BSY () {0x5;}' unless defined(&FC_REASON_LOGICAL_BSY);
    eval 'sub FC_REASON_PROTOCOL_ERROR_RJT () {0x7;}' unless defined(&FC_REASON_PROTOCOL_ERROR_RJT);
    eval 'sub FC_REASON_CMD_UNABLE () {0x9;}' unless defined(&FC_REASON_CMD_UNABLE);
    eval 'sub FC_REASON_CMD_UNSUPPORTED () {0xb;}' unless defined(&FC_REASON_CMD_UNSUPPORTED);
    eval 'sub FC_REASON_VU_RJT () {0xff;}' unless defined(&FC_REASON_VU_RJT);
    eval 'sub FC_REASON_FS_INVALID_CMD () {0x1;}' unless defined(&FC_REASON_FS_INVALID_CMD);
    eval 'sub FC_REASON_FS_INVALID_VER () {0x2;}' unless defined(&FC_REASON_FS_INVALID_VER);
    eval 'sub FC_REASON_FS_LOGICAL_ERR () {0x3;}' unless defined(&FC_REASON_FS_LOGICAL_ERR);
    eval 'sub FC_REASON_FS_INVALID_IUSIZE () {0x4;}' unless defined(&FC_REASON_FS_INVALID_IUSIZE);
    eval 'sub FC_REASON_FS_LOGICAL_BUSY () {0x5;}' unless defined(&FC_REASON_FS_LOGICAL_BUSY);
    eval 'sub FC_REASON_FS_PROTOCOL_ERR () {0x7;}' unless defined(&FC_REASON_FS_PROTOCOL_ERR);
    eval 'sub FC_REASON_FS_CMD_UNABLE () {0x9;}' unless defined(&FC_REASON_FS_CMD_UNABLE);
    eval 'sub FC_REASON_FS_CMD_UNSUPPORTED () {0xb;}' unless defined(&FC_REASON_FS_CMD_UNSUPPORTED);
    eval 'sub FC_REASON_FS_VENDOR_UNIQUE () {0xff;}' unless defined(&FC_REASON_FS_VENDOR_UNIQUE);
    eval 'sub FC_ACTION_SEQ_TERM_RETRY () {0x1;}' unless defined(&FC_ACTION_SEQ_TERM_RETRY);
    eval 'sub FC_ACTION_SEQ_ACTIVE_RETRY () {0x2;}' unless defined(&FC_ACTION_SEQ_ACTIVE_RETRY);
    eval 'sub FC_ACTION_RETRYABLE () {0x1;}' unless defined(&FC_ACTION_RETRYABLE);
    eval 'sub FC_ACTION_NON_RETRYABLE () {0x2;}' unless defined(&FC_ACTION_NON_RETRYABLE);
    eval 'sub FC_ACTION_FREE_PACKET () {0x1;}' unless defined(&FC_ACTION_FREE_PACKET);
    eval 'sub FC_ACTION_DONT_FREE_PACKET () {0x2;}' unless defined(&FC_ACTION_DONT_FREE_PACKET);
    eval 'sub FC_EXPLN_NONE () {0x;}' unless defined(&FC_EXPLN_NONE);
    eval 'sub FC_EXPLN_INVALID_OX_RX_ID () {0x3;}' unless defined(&FC_EXPLN_INVALID_OX_RX_ID);
    eval 'sub FC_EXPLN_SEQ_ABORTED () {0x5;}' unless defined(&FC_EXPLN_SEQ_ABORTED);
    if(defined(&__cplusplus)) {
    }
}
1;
