require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FIBRE_CHANNEL_IMPL_FCTL_H)) {
    eval 'sub _SYS_FIBRE_CHANNEL_IMPL_FCTL_H () {1;}' unless defined(&_SYS_FIBRE_CHANNEL_IMPL_FCTL_H);
    require 'sys/note.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub FC_STATE_OFFLINE () {0x;}' unless defined(&FC_STATE_OFFLINE);
    eval 'sub FC_STATE_ONLINE () {0x1;}' unless defined(&FC_STATE_ONLINE);
    eval 'sub FC_STATE_LOOP () {0x2;}' unless defined(&FC_STATE_LOOP);
    eval 'sub FC_STATE_NAMESERVICE () {0x3;}' unless defined(&FC_STATE_NAMESERVICE);
    eval 'sub FC_STATE_RESET () {0x4;}' unless defined(&FC_STATE_RESET);
    eval 'sub FC_STATE_RESET_REQUESTED () {0x5;}' unless defined(&FC_STATE_RESET_REQUESTED);
    eval 'sub FC_STATE_LIP () {0x6;}' unless defined(&FC_STATE_LIP);
    eval 'sub FC_STATE_LIP_LBIT_SET () {0x7;}' unless defined(&FC_STATE_LIP_LBIT_SET);
    eval 'sub FC_STATE_DEVICE_CHANGE () {0x8;}' unless defined(&FC_STATE_DEVICE_CHANGE);
    eval 'sub FC_STATE_TARGET_PORT_RESET () {0x9;}' unless defined(&FC_STATE_TARGET_PORT_RESET);
    eval 'sub FC_STATE_FULL_SPEED () {0x100;}' unless defined(&FC_STATE_FULL_SPEED);
    eval 'sub FC_STATE_HALF_SPEED () {0x200;}' unless defined(&FC_STATE_HALF_SPEED);
    eval 'sub FC_STATE_QUARTER_SPEED () {0x300;}' unless defined(&FC_STATE_QUARTER_SPEED);
    eval 'sub FC_STATE_DOUBLE_SPEED () {0x400;}' unless defined(&FC_STATE_DOUBLE_SPEED);
    eval 'sub FC_PORT_SPEED_MASK {
        my($state) = @_;
	    eval q((($state) & 0xff00));
    }' unless defined(&FC_PORT_SPEED_MASK);
    eval 'sub FC_PORT_STATE_MASK {
        my($state) = @_;
	    eval q((($state) & 0xff));
    }' unless defined(&FC_PORT_STATE_MASK);
    eval 'sub FC_NOTIFY_RECOVERY_DONE () {0x1;}' unless defined(&FC_NOTIFY_RECOVERY_DONE);
    eval 'sub FC_NOTIFY_TARGET_MODE () {0x2;}' unless defined(&FC_NOTIFY_TARGET_MODE);
    eval 'sub FC_NOTIFY_NO_TARGET_MODE () {0x3;}' unless defined(&FC_NOTIFY_NO_TARGET_MODE);
    eval 'sub FC_NOTIFY_RECOVERY_CLEANUP () {0x4;}' unless defined(&FC_NOTIFY_RECOVERY_CLEANUP);
    eval 'sub FC_NOTIFY_FLAG_MASK {
        my($cmd) = @_;
	    eval q((($cmd) & 0xff));
    }' unless defined(&FC_NOTIFY_FLAG_MASK);
    eval 'sub FC_NOTIFY_VALUE_MASK {
        my($cmd) = @_;
	    eval q((($cmd) & 0xffffff00));
    }' unless defined(&FC_NOTIFY_VALUE_MASK);
    eval 'sub FC_NOTIFY_GET_FLAG {
        my($cmd) = @_;
	    eval q( &FC_NOTIFY_FLAG_MASK($cmd));
    }' unless defined(&FC_NOTIFY_GET_FLAG);
    eval 'sub FC_NOTIFY_GET_VALUE {
        my($cmd) = @_;
	    eval q(( &FC_NOTIFY_VALUE_MASK($cmd) >> 8));
    }' unless defined(&FC_NOTIFY_GET_VALUE);
    eval 'sub FC_DEVICE_INVALID () {0;}' unless defined(&FC_DEVICE_INVALID);
    eval 'sub FC_DEVICE_VALID () {1;}' unless defined(&FC_DEVICE_VALID);
    eval 'sub FC_STACK_DEPTH () {14;}' unless defined(&FC_STACK_DEPTH);
    eval 'sub PORT_DEVICE_NOCHANGE () {0x;}' unless defined(&PORT_DEVICE_NOCHANGE);
    eval 'sub PORT_DEVICE_NEW () {0x1;}' unless defined(&PORT_DEVICE_NEW);
    eval 'sub PORT_DEVICE_OLD () {0x2;}' unless defined(&PORT_DEVICE_OLD);
    eval 'sub PORT_DEVICE_CHANGED () {0x3;}' unless defined(&PORT_DEVICE_CHANGED);
    eval 'sub PORT_DEVICE_DELETE () {0x4;}' unless defined(&PORT_DEVICE_DELETE);
    eval 'sub PORT_DEVICE_USER_LOGIN () {0x5;}' unless defined(&PORT_DEVICE_USER_LOGIN);
    eval 'sub PORT_DEVICE_USER_LOGOUT () {0x6;}' unless defined(&PORT_DEVICE_USER_LOGOUT);
    eval 'sub PORT_DEVICE_USER_CREATE () {0x7;}' unless defined(&PORT_DEVICE_USER_CREATE);
    eval 'sub PORT_DEVICE_USER_DELETE () {0x8;}' unless defined(&PORT_DEVICE_USER_DELETE);
    eval 'sub PD_IDLE () {0x;}' unless defined(&PD_IDLE);
    eval 'sub PD_ELS_IN_PROGRESS () {0x1;}' unless defined(&PD_ELS_IN_PROGRESS);
    eval 'sub PD_ELS_MARK () {0x2;}' unless defined(&PD_ELS_MARK);
    eval 'sub PD_IN_DID_QUEUE () {0x4;}' unless defined(&PD_IN_DID_QUEUE);
    eval 'sub PD_PLOGI_INITIATOR () {0;}' unless defined(&PD_PLOGI_INITIATOR);
    eval 'sub PD_PLOGI_RECEPIENT () {1;}' unless defined(&PD_PLOGI_RECEPIENT);
    eval 'sub FC_TRAN_CLASS {
        my($flag) = @_;
	    eval q((($flag) & 0xf0));
    }' unless defined(&FC_TRAN_CLASS);
    eval 'sub FC_TRAN_INTR () {0x1;}' unless defined(&FC_TRAN_INTR);
    eval 'sub FC_TRAN_NO_INTR () {0x2;}' unless defined(&FC_TRAN_NO_INTR);
    eval 'sub FC_TRAN_HI_PRIORITY () {0x4;}' unless defined(&FC_TRAN_HI_PRIORITY);
    eval 'sub FC_TRAN_DUMPING () {0x8;}' unless defined(&FC_TRAN_DUMPING);
    eval 'sub FC_TRAN_CLASS1 () {0x10;}' unless defined(&FC_TRAN_CLASS1);
    eval 'sub FC_TRAN_CLASS2 () {0x20;}' unless defined(&FC_TRAN_CLASS2);
    eval 'sub FC_TRAN_CLASS3 () {0x30;}' unless defined(&FC_TRAN_CLASS3);
    eval 'sub FC_TRAN_CLASS_INVALID () {0xf0;}' unless defined(&FC_TRAN_CLASS_INVALID);
    eval 'sub FC_PKT_NOP () {0;}' unless defined(&FC_PKT_NOP);
    eval 'sub FC_PKT_INBOUND () {1;}' unless defined(&FC_PKT_INBOUND);
    eval 'sub FC_PKT_OUTBOUND () {2;}' unless defined(&FC_PKT_OUTBOUND);
    eval 'sub FC_PKT_EXCHANGE () {3;}' unless defined(&FC_PKT_EXCHANGE);
    eval 'sub FC_PKT_FCP_READ () {4;}' unless defined(&FC_PKT_FCP_READ);
    eval 'sub FC_PKT_FCP_WRITE () {5;}' unless defined(&FC_PKT_FCP_WRITE);
    eval 'sub FC_PKT_IP_WRITE () {6;}' unless defined(&FC_PKT_IP_WRITE);
    eval 'sub FC_PKT_BROADCAST () {7;}' unless defined(&FC_PKT_BROADCAST);
    if(!defined( &lint)) {
    }
    if(!defined( &lint)) {
    }
    if(!defined( &lint)) {
    }
    if(!defined( &lint)) {
    }
    if(defined(&DEBUG)) {
    }
    if(!defined( &lint)) {
    }
    if(!defined( &lint)) {
    }
    if(!defined( &lint)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
