require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_CACHEFS_FS_H)) {
    eval 'sub _SYS_FS_CACHEFS_FS_H () {1;}' unless defined(&_SYS_FS_CACHEFS_FS_H);
    require 'sys/vnode.ph';
    require 'sys/vfs.ph';
    require 'sys/types.ph';
    require 'sys/types32.ph';
    require 'sys/t_lock.ph';
    require 'sys/thread.ph';
    require 'sys/kmem.ph';
    require 'sys/inttypes.ph';
    require 'sys/time_impl.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&CFSDEBUG)) {
	eval 'sub CFSDEBUG_ALL () {0xffffffff;}' unless defined(&CFSDEBUG_ALL);
	eval 'sub CFSDEBUG_NONE () {0x;}' unless defined(&CFSDEBUG_NONE);
	eval 'sub CFSDEBUG_GENERAL () {0x1;}' unless defined(&CFSDEBUG_GENERAL);
	eval 'sub CFSDEBUG_SUBR () {0x2;}' unless defined(&CFSDEBUG_SUBR);
	eval 'sub CFSDEBUG_CNODE () {0x4;}' unless defined(&CFSDEBUG_CNODE);
	eval 'sub CFSDEBUG_DIR () {0x8;}' unless defined(&CFSDEBUG_DIR);
	eval 'sub CFSDEBUG_STRICT () {0x10;}' unless defined(&CFSDEBUG_STRICT);
	eval 'sub CFSDEBUG_VOPS () {0x20;}' unless defined(&CFSDEBUG_VOPS);
	eval 'sub CFSDEBUG_VFSOP () {0x40;}' unless defined(&CFSDEBUG_VFSOP);
	eval 'sub CFSDEBUG_RESOURCE () {0x80;}' unless defined(&CFSDEBUG_RESOURCE);
	eval 'sub CFSDEBUG_CHEAT () {0x100;}' unless defined(&CFSDEBUG_CHEAT);
	eval 'sub CFSDEBUG_INVALIDATE () {0x200;}' unless defined(&CFSDEBUG_INVALIDATE);
	eval 'sub CFSDEBUG_DLOG () {0x400;}' unless defined(&CFSDEBUG_DLOG);
	eval 'sub CFSDEBUG_FILEGRP () {0x800;}' unless defined(&CFSDEBUG_FILEGRP);
	eval 'sub CFSDEBUG_IOCTL () {0x1000;}' unless defined(&CFSDEBUG_IOCTL);
	eval 'sub CFSDEBUG_FRONT () {0x2000;}' unless defined(&CFSDEBUG_FRONT);
	eval 'sub CFSDEBUG_BACK () {0x4000;}' unless defined(&CFSDEBUG_BACK);
	eval 'sub CFSDEBUG_ALLOCMAP () {0x8000;}' unless defined(&CFSDEBUG_ALLOCMAP);
	eval 'sub CFSDEBUG_ASYNCPOP () {0x10000;}' unless defined(&CFSDEBUG_ASYNCPOP);
	eval 'sub CFSCLEANFLAG () {1;}' unless defined(&CFSCLEANFLAG);
	eval 'sub CFS_DEBUG {
	    my($N) = @_;
    	    eval q( &if ( &cachefsdebug & ($N)));
	}' unless defined(&CFS_DEBUG);
    }
    if(0) {
	if(defined(&CFSDEBUG)) {
	    eval 'sub CFS_CD_DEBUG () {1;}' unless defined(&CFS_CD_DEBUG);
	    eval 'sub T_CD_HELD () {0x1000;}' unless defined(&T_CD_HELD);
	}
    }
    if(0) {
	eval 'sub CFSRLDEBUG () {1;}' unless defined(&CFSRLDEBUG);
    }
    if(defined(&CFSRLDEBUG)) {
	eval 'sub CFSVERSION () {109;}' unless defined(&CFSVERSION);
	eval 'sub CFSVERSION64 () {110;}' unless defined(&CFSVERSION64);
    } else {
	eval 'sub CFSVERSION () {6;}' unless defined(&CFSVERSION);
	eval 'sub CFSVERSION64 () {7;}' unless defined(&CFSVERSION64);
    }
    eval 'sub DEF_FILEGRP_SIZE () {256;}' unless defined(&DEF_FILEGRP_SIZE);
    eval 'sub DEF_POP_SIZE () {0x10000;}' unless defined(&DEF_POP_SIZE);
    eval 'sub CACHELABEL_NAME () {".cfs_label";}' unless defined(&CACHELABEL_NAME);
    eval 'sub RESOURCE_NAME () {".cfs_resource";}' unless defined(&RESOURCE_NAME);
    eval 'sub CACHEFS_FSINFO () {".cfs_fsinfo";}' unless defined(&CACHEFS_FSINFO);
    eval 'sub ATTRCACHE_NAME () {".cfs_attrcache";}' unless defined(&ATTRCACHE_NAME);
    eval 'sub CACHEFS_LOSTFOUND_NAME () {"lost+found";}' unless defined(&CACHEFS_LOSTFOUND_NAME);
    eval 'sub BACKMNT_NAME () {".cfs_mnt_points";}' unless defined(&BACKMNT_NAME);
    eval 'sub CACHEFS_LOCK_FILE () {".cfs_lock";}' unless defined(&CACHEFS_LOCK_FILE);
    eval 'sub CACHEFS_DLOG_FILE () {".cfs_dlog";}' unless defined(&CACHEFS_DLOG_FILE);
    eval 'sub CACHEFS_DMAP_FILE () {".cfs_dmap";}' unless defined(&CACHEFS_DMAP_FILE);
    eval 'sub CACHEFS_MNT_FILE () {".cfs_mnt";}' unless defined(&CACHEFS_MNT_FILE);
    eval 'sub CACHEFS_UNMNT_FILE () {".cfs_unmnt";}' unless defined(&CACHEFS_UNMNT_FILE);
    eval 'sub LOG_STATUS_NAME () {".cfs_logging";}' unless defined(&LOG_STATUS_NAME);
    eval 'sub NOBACKUP_NAME () {".nsr";}' unless defined(&NOBACKUP_NAME);
    eval 'sub CACHEFS_PREFIX () {".cfs_";}' unless defined(&CACHEFS_PREFIX);
    eval 'sub CACHEFS_PREFIX_LEN () {5;}' unless defined(&CACHEFS_PREFIX_LEN);
    eval 'sub ROOTLINK_NAME () {"root";}' unless defined(&ROOTLINK_NAME);
    eval 'sub CFS_FRONTFILE_NAME_SIZE () {18;}' unless defined(&CFS_FRONTFILE_NAME_SIZE);
    eval 'sub CACHEFS_BASETYPE () {"cachefs";}' unless defined(&CACHEFS_BASETYPE);
    eval 'sub CFS_MAXFREECNODES () {20;}' unless defined(&CFS_MAXFREECNODES);
    eval 'sub CACHEFSTAB () {"/etc/cachefstab";}' unless defined(&CACHEFSTAB);
    eval 'sub CFS_CID_LOCAL () {1;}' unless defined(&CFS_CID_LOCAL);
    if((defined( &_SYSCALL32)  && defined( &_LP64))) {
	eval 'sub cfs_timespec () { &timespec32;}' unless defined(&cfs_timespec);
	eval 'sub cfs_vattr () { &vattr32;}' unless defined(&cfs_vattr);
	eval 'sub cfs_fid () { &fid32;}' unless defined(&cfs_fid);
	eval 'sub CACHEFS_DEV_TO_DEV32_COPY {
	    my($in_dev, $out_dev, $error) = @_;
    	    eval q( &if ( &cmpldev(( &dev32_t *)($out_dev), $in_dev) == 0) $error =  &EOVERFLOW;);
	}' unless defined(&CACHEFS_DEV_TO_DEV32_COPY);
	eval 'sub CACHEFS_DEV32_TO_DEV_COPY {
	    my($in_dev, $out_dev) = @_;
    	    eval q($out_dev = ( &dev_t) &expldev($in_dev););
	}' unless defined(&CACHEFS_DEV32_TO_DEV_COPY);
	eval 'sub TIME_OVERFLOW {
	    my($tval) = @_;
    	    eval q((($tval) <  &TIME32_MIN || ($tval) >  &TIME32_MAX));
	}' unless defined(&TIME_OVERFLOW);
	eval 'sub CACHEFS_TIME_TO_TIME32_COPY {
	    my($in_tval, $out_tval, $error) = @_;
    	    eval q($out_tval = ($in_tval);  &if ( &TIME_OVERFLOW($in_tval)) $error =  &EOVERFLOW;);
	}' unless defined(&CACHEFS_TIME_TO_TIME32_COPY);
	eval 'sub CACHEFS_TIME32_TO_TIME_COPY {
	    my($in_tval, $out_tval) = @_;
    	    eval q($out_tval = ($in_tval););
	}' unless defined(&CACHEFS_TIME32_TO_TIME_COPY);
	eval 'sub CACHEFS_TS_TO_TS32_COPY {
	    my($in_tsp, $out_tsp, $error) = @_;
    	    eval q(($out_tsp)-> &tv_nsec = ($in_tsp)-> &tv_nsec;  &CACHEFS_TIME_TO_TIME32_COPY(($in_tsp)-> &tv_sec, ($out_tsp)-> &tv_sec, $error));
	}' unless defined(&CACHEFS_TS_TO_TS32_COPY);
	eval 'sub CACHEFS_TS32_TO_TS_COPY {
	    my($in_tsp, $out_tsp) = @_;
    	    eval q(($out_tsp)-> &tv_nsec = ($in_tsp)-> &tv_nsec;  &CACHEFS_TIME32_TO_TIME_COPY(($in_tsp)-> &tv_sec, ($out_tsp)-> &tv_sec));
	}' unless defined(&CACHEFS_TS32_TO_TS_COPY);
	eval 'sub CACHEFS_FID_COPY {
	    my($in_fidp, $out_fidp) = @_;
    	    eval q(($out_fidp)-> &fid_len = ($in_fidp)-> &fid_len;  &bcopy(($in_fidp)-> &fid_data, ($out_fidp)-> &fid_data, ($in_fidp)-> &fid_len));
	}' unless defined(&CACHEFS_FID_COPY);
	eval 'sub CACHEFS_VATTR_TO_VATTR32_COPY {
	    my($in_vattrp, $out_vattrp, $error) = @_;
    	    eval q(($out_vattrp)-> &va_mask = ($in_vattrp)-> &va_mask; ($out_vattrp)-> &va_type = ($in_vattrp)-> &va_type; ($out_vattrp)-> &va_mode = ($in_vattrp)-> &va_mode; ($out_vattrp)-> &va_uid = ($in_vattrp)-> &va_uid; ($out_vattrp)-> &va_gid = ($in_vattrp)-> &va_gid;  &CACHEFS_DEV_TO_DEV32_COPY(($in_vattrp)-> &va_fsid, ($out_vattrp)-> &va_fsid, $error); ($out_vattrp)-> &va_nodeid = ($in_vattrp)-> &va_nodeid; ($out_vattrp)-> &va_nlink = ($in_vattrp)-> &va_nlink; ($out_vattrp)-> &va_size = ($in_vattrp)-> &va_size;  &CACHEFS_TS_TO_TS32_COPY(($in_vattrp)-> &va_atime, ($out_vattrp)-> &va_atime, $error);  &CACHEFS_TS_TO_TS32_COPY(($in_vattrp)-> &va_mtime, ($out_vattrp)-> &va_mtime, $error);  &CACHEFS_TS_TO_TS32_COPY(($in_vattrp)-> &va_ctime, ($out_vattrp)-> &va_ctime, $error);  &CACHEFS_DEV_TO_DEV32_COPY(($in_vattrp)-> &va_rdev, ($out_vattrp)-> &va_rdev, $error); ($out_vattrp)-> &va_blksize = ($in_vattrp)-> &va_blksize; ($out_vattrp)-> &va_nblocks = ($in_vattrp)-> &va_nblocks; ($out_vattrp)-> &va_vcode = ($in_vattrp)-> &va_vcode);
	}' unless defined(&CACHEFS_VATTR_TO_VATTR32_COPY);
	eval 'sub CACHEFS_VATTR32_TO_VATTR_COPY {
	    my($in_vattrp, $out_vattrp) = @_;
    	    eval q(($out_vattrp)-> &va_mask = ($in_vattrp)-> &va_mask; ($out_vattrp)-> &va_type = ($in_vattrp)-> &va_type; ($out_vattrp)-> &va_mode = ($in_vattrp)-> &va_mode; ($out_vattrp)-> &va_uid = ($in_vattrp)-> &va_uid; ($out_vattrp)-> &va_gid = ($in_vattrp)-> &va_gid;  &CACHEFS_DEV32_TO_DEV_COPY(($in_vattrp)-> &va_fsid, ($out_vattrp)-> &va_fsid); ($out_vattrp)-> &va_nodeid = ($in_vattrp)-> &va_nodeid; ($out_vattrp)-> &va_nlink = ($in_vattrp)-> &va_nlink; ($out_vattrp)-> &va_size = ($in_vattrp)-> &va_size;  &CACHEFS_TS32_TO_TS_COPY(($in_vattrp)-> &va_atime, ($out_vattrp)-> &va_atime);  &CACHEFS_TS32_TO_TS_COPY(($in_vattrp)-> &va_mtime, ($out_vattrp)-> &va_mtime);  &CACHEFS_TS32_TO_TS_COPY(($in_vattrp)-> &va_ctime, ($out_vattrp)-> &va_ctime);  &CACHEFS_DEV32_TO_DEV_COPY(($in_vattrp)-> &va_rdev, ($out_vattrp)-> &va_rdev); ($out_vattrp)-> &va_blksize = ($in_vattrp)-> &va_blksize; ($out_vattrp)-> &va_nblocks = ($in_vattrp)-> &va_nblocks; ($out_vattrp)-> &va_vcode = ($in_vattrp)-> &va_vcode);
	}' unless defined(&CACHEFS_VATTR32_TO_VATTR_COPY);
    } else {
	eval 'sub cfs_timespec () { &timespec;}' unless defined(&cfs_timespec);
	eval 'sub cfs_vattr () { &vattr;}' unless defined(&cfs_vattr);
	eval 'sub cfs_fid () { &fid;}' unless defined(&cfs_fid);
	eval 'sub TIME_OVERFLOW {
	    my($tval) = @_;
    	    eval q( &FALSE);
	}' unless defined(&TIME_OVERFLOW);
	eval 'sub CACHEFS_DEV_TO_DEV32_COPY {
	    my($in_dev, $out_dev, $error) = @_;
    	    eval q($out_dev = ($in_dev));
	}' unless defined(&CACHEFS_DEV_TO_DEV32_COPY);
	eval 'sub CACHEFS_DEV32_TO_DEV_COPY {
	    my($in_dev, $out_dev) = @_;
    	    eval q($out_dev = ($in_dev));
	}' unless defined(&CACHEFS_DEV32_TO_DEV_COPY);
	eval 'sub CACHEFS_TIME_TO_TIME32_COPY {
	    my($in_tval, $out_tval, $error) = @_;
    	    eval q($out_tval = ($in_tval));
	}' unless defined(&CACHEFS_TIME_TO_TIME32_COPY);
	eval 'sub CACHEFS_TIME32_TO_TIME_COPY {
	    my($in_tval, $out_tval) = @_;
    	    eval q($out_tval = ($in_tval));
	}' unless defined(&CACHEFS_TIME32_TO_TIME_COPY);
	eval 'sub CACHEFS_TS_TO_TS32_COPY {
	    my($in_tsp, $out_tsp, $error) = @_;
    	    eval q(*($out_tsp) = *($in_tsp));
	}' unless defined(&CACHEFS_TS_TO_TS32_COPY);
	eval 'sub CACHEFS_TS32_TO_TS_COPY {
	    my($in_tsp, $out_tsp) = @_;
    	    eval q(*($out_tsp) = *($in_tsp));
	}' unless defined(&CACHEFS_TS32_TO_TS_COPY);
	eval 'sub CACHEFS_FID_COPY {
	    my($in_fidp, $out_fidp) = @_;
    	    eval q(*($out_fidp) = *($in_fidp));
	}' unless defined(&CACHEFS_FID_COPY);
	eval 'sub CACHEFS_VATTR_TO_VATTR32_COPY {
	    my($in_vattrp, $out_vattrp, $error) = @_;
    	    eval q(*($out_vattrp) = *($in_vattrp));
	}' unless defined(&CACHEFS_VATTR_TO_VATTR32_COPY);
	eval 'sub CACHEFS_VATTR32_TO_VATTR_COPY {
	    my($in_vattrp, $out_vattrp) = @_;
    	    eval q(*($out_vattrp) = *($in_vattrp));
	}' unless defined(&CACHEFS_VATTR32_TO_VATTR_COPY);
    }
    eval 'sub CACHEFS_DEV_TO_CFS_DEV_COPY {
        my($in_dev, $out_dev, $error) = @_;
	    eval q( &CACHEFS_DEV_TO_DEV32_COPY($in_dev, $out_dev, $error));
    }' unless defined(&CACHEFS_DEV_TO_CFS_DEV_COPY);
    eval 'sub CACHEFS_CFS_DEV_TO_DEV_COPY {
        my($in_dev, $out_dev) = @_;
	    eval q( &CACHEFS_DEV32_TO_DEV_COPY($in_dev, $out_dev));
    }' unless defined(&CACHEFS_CFS_DEV_TO_DEV_COPY);
    eval 'sub CACHEFS_TIME_TO_CFS_TIME_COPY {
        my($in_tval, $out_tval, $error) = @_;
	    eval q( &CACHEFS_TIME_TO_TIME32_COPY($in_tval, $out_tval, $error));
    }' unless defined(&CACHEFS_TIME_TO_CFS_TIME_COPY);
    eval 'sub CACHEFS_CFS_TIME_TO_TIME_COPY {
        my($in_tval, $out_tval) = @_;
	    eval q( &CACHEFS_TIME32_TO_TIME_COPY($in_tval, $out_tval));
    }' unless defined(&CACHEFS_CFS_TIME_TO_TIME_COPY);
    eval 'sub CACHEFS_TS_TO_CFS_TS_COPY {
        my($in_tsp, $out_tsp, $error) = @_;
	    eval q( &CACHEFS_TS_TO_TS32_COPY($in_tsp, $out_tsp, $error));
    }' unless defined(&CACHEFS_TS_TO_CFS_TS_COPY);
    eval 'sub CACHEFS_CFS_TS_TO_TS_COPY {
        my($in_tsp, $out_tsp) = @_;
	    eval q( &CACHEFS_TS32_TO_TS_COPY($in_tsp, $out_tsp));
    }' unless defined(&CACHEFS_CFS_TS_TO_TS_COPY);
    eval 'sub CACHEFS_VATTR_TO_CFS_VATTR_COPY {
        my($in_vattrp, $out_vattrp, $error) = @_;
	    eval q( &CACHEFS_VATTR_TO_VATTR32_COPY($in_vattrp, $out_vattrp, $error));
    }' unless defined(&CACHEFS_VATTR_TO_CFS_VATTR_COPY);
    eval 'sub CACHEFS_CFS_VATTR_TO_VATTR_COPY {
        my($in_vattrp, $out_vattrp) = @_;
	    eval q( &CACHEFS_VATTR32_TO_VATTR_COPY($in_vattrp, $out_vattrp));
    }' unless defined(&CACHEFS_CFS_VATTR_TO_VATTR_COPY);
    require 'sys/fs/cachefs_fscache.ph';
    require 'sys/fs/cachefs_filegrp.ph';
    eval 'sub CUSAGE_ACTIVE () {1;}' unless defined(&CUSAGE_ACTIVE);
    eval 'sub CUSAGE_NEED_ADJUST () {2;}' unless defined(&CUSAGE_NEED_ADJUST);
    eval("sub CACHEFS_RL_NONE () { 0x101; }") unless defined(&CACHEFS_RL_NONE);
    eval("sub CACHEFS_RL_FREE () { 1; }") unless defined(&CACHEFS_RL_FREE);
    eval("sub CACHEFS_RL_GC () { 2; }") unless defined(&CACHEFS_RL_GC);
    eval("sub CACHEFS_RL_ACTIVE () { 3; }") unless defined(&CACHEFS_RL_ACTIVE);
    eval("sub CACHEFS_RL_ATTRFILE () { 4; }") unless defined(&CACHEFS_RL_ATTRFILE);
    eval("sub CACHEFS_RL_MODIFIED () { 5; }") unless defined(&CACHEFS_RL_MODIFIED);
    eval("sub CACHEFS_RL_PACKED () { 6; }") unless defined(&CACHEFS_RL_PACKED);
    eval("sub CACHEFS_RL_PACKED_PENDING () { 7; }") unless defined(&CACHEFS_RL_PACKED_PENDING);
    eval("sub CACHEFS_RL_MF () { 8; }") unless defined(&CACHEFS_RL_MF);
    eval 'sub CACHEFS_RL_START () { &CACHEFS_RL_NONE;}' unless defined(&CACHEFS_RL_START);
    eval 'sub CACHEFS_RL_END () { &CACHEFS_RL_MF;}' unless defined(&CACHEFS_RL_END);
    eval 'sub CACHEFS_RL_CNT () {( &CACHEFS_RL_END -  &CACHEFS_RL_START + 1);}' unless defined(&CACHEFS_RL_CNT);
    eval 'sub CACHEFS_RL_INDEX {
        my($X) = @_;
	    eval q(($X -  &CACHEFS_RL_START));
    }' unless defined(&CACHEFS_RL_INDEX);
    if(defined(&CFSRLDEBUG)) {
	eval 'sub CACHEFS_RLDB_STACKSIZE () {16;}' unless defined(&CACHEFS_RLDB_STACKSIZE);
	eval 'sub CACHEFS_RLDB_DEF_MAXCOUNT () {5;}' unless defined(&CACHEFS_RLDB_DEF_MAXCOUNT);
    }
    if(defined(&CFSRLDEBUG)) {
    }
    eval 'sub CACHEFS_RLPMBS () {( &MAXBSIZE / ( &uint_t)$sizeof{ &rl_entry_t});}' unless defined(&CACHEFS_RLPMBS);
    eval 'sub CACHEFS_MAX_APOP_INQUEUE () {50;}' unless defined(&CACHEFS_MAX_APOP_INQUEUE);
    eval 'sub CACHE_NOCACHE () {0x1;}' unless defined(&CACHE_NOCACHE);
    eval 'sub CACHE_ALLOC_PENDING () {0x4;}' unless defined(&CACHE_ALLOC_PENDING);
    eval 'sub CACHE_NOFILL () {0x8;}' unless defined(&CACHE_NOFILL);
    eval 'sub CACHE_GARBAGE_COLLECT () {0x10;}' unless defined(&CACHE_GARBAGE_COLLECT);
    eval 'sub CACHE_CACHEW_THREADRUN () {0x20;}' unless defined(&CACHE_CACHEW_THREADRUN);
    eval 'sub CACHE_CACHEW_THREADEXIT () {0x40;}' unless defined(&CACHE_CACHEW_THREADEXIT);
    eval 'sub CACHE_DIRTY () {0x80;}' unless defined(&CACHE_DIRTY);
    eval 'sub CACHE_PACKED_PENDING () {0x100;}' unless defined(&CACHE_PACKED_PENDING);
    eval 'sub CACHE_CHECK_RLTYPE () {0x200;}' unless defined(&CACHE_CHECK_RLTYPE);
    eval 'sub CFS_WRITE_AROUND () {0x1;}' unless defined(&CFS_WRITE_AROUND);
    eval 'sub CFS_NONSHARED () {0x2;}' unless defined(&CFS_NONSHARED);
    eval 'sub CFS_NOCONST_MODE () {0x8;}' unless defined(&CFS_NOCONST_MODE);
    eval 'sub CFS_ACCESS_BACKFS () {0x10;}' unless defined(&CFS_ACCESS_BACKFS);
    eval 'sub CFS_CODCONST_MODE () {0x80;}' unless defined(&CFS_CODCONST_MODE);
    eval 'sub CFS_DISCONNECTABLE () {0x100;}' unless defined(&CFS_DISCONNECTABLE);
    eval 'sub CFS_SOFT () {0x200;}' unless defined(&CFS_SOFT);
    eval 'sub CFS_NOACL () {0x400;}' unless defined(&CFS_NOACL);
    eval 'sub CFS_LLOCK () {0x800;}' unless defined(&CFS_LLOCK);
    eval 'sub CFS_SLIDE () {0x1000;}' unless defined(&CFS_SLIDE);
    eval 'sub CFS_NOFILL () {0x2000;}' unless defined(&CFS_NOFILL);
    eval 'sub MAXCOOKIE_SIZE () {36;}' unless defined(&MAXCOOKIE_SIZE);
    eval 'sub C_BACK_CHECK () {0x2;}' unless defined(&C_BACK_CHECK);
    eval 'sub CFS_TIMEOUT {
        my($FSCP, $ERROR) = @_;
	    eval q(($ERROR  &&  &CFS_ISFS_SNR($FSCP)  && ((($ERROR) ==  &ETIMEDOUT) || (($ERROR) ==  &EIO))));
    }' unless defined(&CFS_TIMEOUT);
    eval 'sub C_MAX_ALLOCINFO_SLOTS () {32;}' unless defined(&C_MAX_ALLOCINFO_SLOTS);
    eval 'sub C_FSL_SIZE () {($sizeof{\'struct cachefs_allocmap\'} *  &C_MAX_ALLOCINFO_SLOTS);}' unless defined(&C_FSL_SIZE);
    if((defined( &_SYSCALL32)  && defined( &_LP64))) {
    } else {
	eval 'sub cfs_cachefs_metadata () { &cachefs_metadata;}' unless defined(&cfs_cachefs_metadata);
    }
    eval 'sub MD_CREATEDONE () {0x1;}' unless defined(&MD_CREATEDONE);
    eval 'sub MD_POPULATED () {0x2;}' unless defined(&MD_POPULATED);
    eval 'sub MD_FILE () {0x4;}' unless defined(&MD_FILE);
    eval 'sub MD_FASTSYMLNK () {0x8;}' unless defined(&MD_FASTSYMLNK);
    eval 'sub MD_PACKED () {0x10;}' unless defined(&MD_PACKED);
    eval 'sub MD_INVALREADDIR () {0x40;}' unless defined(&MD_INVALREADDIR);
    eval 'sub MD_PUTPAGE () {0x200;}' unless defined(&MD_PUTPAGE);
    eval 'sub MD_FREE () {0x400;}' unless defined(&MD_FREE);
    eval 'sub MD_PUSHDONE () {0x800;}' unless defined(&MD_PUSHDONE);
    eval 'sub MD_MAPPING () {0x1000;}' unless defined(&MD_MAPPING);
    eval 'sub MD_ACL () {0x2000;}' unless defined(&MD_ACL);
    eval 'sub MD_ACLDIR () {0x4000;}' unless defined(&MD_ACLDIR);
    eval 'sub MD_LOCALMTIME () {0x8000;}' unless defined(&MD_LOCALMTIME);
    eval 'sub MD_LOCALCTIME () {0x10000;}' unless defined(&MD_LOCALCTIME);
    eval 'sub MD_LOCALFILENO () {0x20000;}' unless defined(&MD_LOCALFILENO);
    eval 'sub MD_NEEDATTRS () {0x40000;}' unless defined(&MD_NEEDATTRS);
    eval 'sub C_MAX_MOUNT_FSCDIRNAME () {128;}' unless defined(&C_MAX_MOUNT_FSCDIRNAME);
    if(defined(&_SYSCALL32)) {
    }
    eval 'sub c_attr () { ($c_metadata->{md_vattr});}' unless defined(&c_attr);
    eval 'sub c_cookie () { ($c_metadata->{md_cookie});}' unless defined(&c_cookie);
    eval 'sub c_fileno () { ($c_id->{cid_fileno});}' unless defined(&c_fileno);
    eval 'sub CFS_DIRCACHE_COST () {3;}' unless defined(&CFS_DIRCACHE_COST);
    eval 'sub CFS_DIRCACHE_INVAL () {3;}' unless defined(&CFS_DIRCACHE_INVAL);
    eval 'sub CFS_DIRCACHE_ENABLE () {( &CFS_DIRCACHE_INVAL *  &CFS_DIRCACHE_COST);}' unless defined(&CFS_DIRCACHE_ENABLE);
    eval 'sub VTOC {
        my($VP) = @_;
	    eval q(((( &void *)(($VP)-> &v_data))));
    }' unless defined(&VTOC);
    eval 'sub CTOV {
        my($CP) = @_;
	    eval q((( &vnode_t *)(( &void *)((($CP)-> &c_vnode)))));
    }' unless defined(&CTOV);
    eval 'sub VFS_TO_FSCACHE {
        my($VFSP) = @_;
	    eval q(((( &void *)(($VFSP)-> &vfs_data))));
    }' unless defined(&VFS_TO_FSCACHE);
    eval 'sub C_TO_FSCACHE {
        my($CP) = @_;
	    eval q(( &VFS_TO_FSCACHE( &CTOV($CP)-> &v_vfsp)));
    }' unless defined(&C_TO_FSCACHE);
    eval 'sub CN_NOCACHE () {0x1;}' unless defined(&CN_NOCACHE);
    eval 'sub CN_DESTROY () {0x2;}' unless defined(&CN_DESTROY);
    eval 'sub CN_ROOT () {0x4;}' unless defined(&CN_ROOT);
    eval 'sub CN_IDLE () {0x8;}' unless defined(&CN_IDLE);
    eval 'sub CN_NEEDOPEN () {0x10;}' unless defined(&CN_NEEDOPEN);
    eval 'sub CN_UPDATED () {0x40;}' unless defined(&CN_UPDATED);
    eval 'sub CDIRTY () {0x80;}' unless defined(&CDIRTY);
    eval 'sub CN_NEED_FRONT_SYNC () {0x100;}' unless defined(&CN_NEED_FRONT_SYNC);
    eval 'sub CN_ALLOC_PENDING () {0x200;}' unless defined(&CN_ALLOC_PENDING);
    eval 'sub CN_STALE () {0x400;}' unless defined(&CN_STALE);
    eval 'sub CN_MODIFIED () {0x800;}' unless defined(&CN_MODIFIED);
    eval 'sub CN_POPULATION_PENDING () {0x1000;}' unless defined(&CN_POPULATION_PENDING);
    eval 'sub CN_ASYNC_POPULATE () {0x2000;}' unless defined(&CN_ASYNC_POPULATE);
    eval 'sub CN_ASYNC_POP_WORKING () {0x4000;}' unless defined(&CN_ASYNC_POP_WORKING);
    eval 'sub CN_PENDRM () {0x8000;}' unless defined(&CN_PENDRM);
    eval 'sub CN_MAPWRITE () {0x100000;}' unless defined(&CN_MAPWRITE);
    eval 'sub CN_CMODINPROG () {0x200000;}' unless defined(&CN_CMODINPROG);
    eval 'sub CIO_PUTPAGES () {0x1;}' unless defined(&CIO_PUTPAGES);
    eval 'sub CFS_MAX_THREADS () {5;}' unless defined(&CFS_MAX_THREADS);
    eval 'sub CFS_ASYNC_TIMEOUT () {(60*  &hz);}' unless defined(&CFS_ASYNC_TIMEOUT);
    eval("sub CFS_INVALID () { 0; }") unless defined(&CFS_INVALID);
    eval("sub CFS_CACHE_SYNC () { 1; }") unless defined(&CFS_CACHE_SYNC);
    eval("sub CFS_PUTPAGE () { 2; }") unless defined(&CFS_PUTPAGE);
    eval("sub CFS_IDLE () { 3; }") unless defined(&CFS_IDLE);
    eval("sub CFS_POPULATE () { 4; }") unless defined(&CFS_POPULATE);
    eval("sub CFS_NOOP () { 5; }") unless defined(&CFS_NOOP);
    eval 'sub CFS_FID_SIZE () {($sizeof{\'struct cachefs_fid\'} - $sizeof{ &ushort_t});}' unless defined(&CFS_FID_SIZE);
    eval 'sub CFS_CM_FRONT () {1;}' unless defined(&CFS_CM_FRONT);
    eval 'sub CFS_CM_BACK () {2;}' unless defined(&CFS_CM_BACK);
    eval 'sub CFS_BOI_ROOTFS () {1;}' unless defined(&CFS_BOI_ROOTFS);
    eval 'sub CFS_BOI_FRONTFS () {2;}' unless defined(&CFS_BOI_FRONTFS);
    eval 'sub CFS_BOI_BACKFS () {3;}' unless defined(&CFS_BOI_BACKFS);
    if(defined(&_SYSCALL32)) {
    }
    eval 'sub CACHEFS_DEBUG_DEPTH () {(16);}' unless defined(&CACHEFS_DEBUG_DEPTH);
    if(defined( &_KERNEL)  && defined( &__STDC__)) {
	if(defined(&CFSRLDEBUG)) {
	}
    }
    eval 'sub C_RL_MAXENTS () {0x4000;}' unless defined(&C_RL_MAXENTS);
    eval 'sub CFS_ISVDEV {
        my($t) = @_;
	    eval q((($t ==  &VBLK) || ($t ==  &VCHR) || ($t ==  &VFIFO)));
    }' unless defined(&CFS_ISVDEV);
    require 'sys/ioccom.ph';
    eval 'sub _FIOCOD () { &_IO(ord(\'f\'), 78);}' unless defined(&_FIOCOD);
    eval 'sub _FIOBOINFO () { &_IO(ord(\'f\'), 79);}' unless defined(&_FIOBOINFO);
    eval 'sub _FIOCNVTMNT () { &_IO(ord(\'f\'), 80);}' unless defined(&_FIOCNVTMNT);
    eval 'sub _FIOSTOPCACHE () { &_IO(ord(\'f\'), 86);}' unless defined(&_FIOSTOPCACHE);
    eval 'sub CACHEFSIO_PACK () { &_IO(ord(\'f\'), 81);}' unless defined(&CACHEFSIO_PACK);
    eval 'sub CACHEFSIO_UNPACK () { &_IO(ord(\'f\'), 82);}' unless defined(&CACHEFSIO_UNPACK);
    eval 'sub CACHEFSIO_UNPACKALL () { &_IO(ord(\'f\'), 83);}' unless defined(&CACHEFSIO_UNPACKALL);
    eval 'sub CACHEFSIO_PACKINFO () { &_IO(ord(\'f\'), 84);}' unless defined(&CACHEFSIO_PACKINFO);
    eval 'sub CACHEFSIO_DCMD () { &_IO(ord(\'f\'), 85);}' unless defined(&CACHEFSIO_DCMD);
    if(defined(&__cplusplus)) {
    }
}
1;
