require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_HSFS_ISOSPEC_H)) {
    eval 'sub _SYS_FS_HSFS_ISOSPEC_H () {1;}' unless defined(&_SYS_FS_HSFS_ISOSPEC_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub ZERO {
        my($x) = @_;
	    eval q(( &uint_t)((( &uchar_t *)($x))[0]));
    }' unless defined(&ZERO);
    eval 'sub ONE {
        my($x) = @_;
	    eval q(( &uint_t)((( &uchar_t *)($x))[1]));
    }' unless defined(&ONE);
    eval 'sub TWO {
        my($x) = @_;
	    eval q(( &uint_t)((( &uchar_t *)($x))[2]));
    }' unless defined(&TWO);
    eval 'sub THREE {
        my($x) = @_;
	    eval q(( &uint_t)((( &uchar_t *)($x))[3]));
    }' unless defined(&THREE);
    eval 'sub MSB_INT {
        my($x) = @_;
	    eval q((((((( &ZERO($x) << 8) |  &ONE($x)) << 8) |  &TWO($x)) << 8) |  &THREE($x)));
    }' unless defined(&MSB_INT);
    eval 'sub LSB_INT {
        my($x) = @_;
	    eval q((((((( &THREE($x) << 8) |  &TWO($x)) << 8) |  &ONE($x)) << 8) |  &ZERO($x)));
    }' unless defined(&LSB_INT);
    eval 'sub MSB_SHORT {
        my($x) = @_;
	    eval q((( &ZERO($x) << 8) |  &ONE($x)));
    }' unless defined(&MSB_SHORT);
    eval 'sub LSB_SHORT {
        my($x) = @_;
	    eval q((( &ONE($x) << 8) |  &ZERO($x)));
    }' unless defined(&LSB_SHORT);
    if(defined( &i386) || defined( &__i386)) {
	eval 'sub BOTH_SHORT {
	    my($x) = @_;
    	    eval q(*($x));
	}' unless defined(&BOTH_SHORT);
	eval 'sub BOTH_INT {
	    my($x) = @_;
    	    eval q(*($x));
	}' unless defined(&BOTH_INT);
    }
 elsif(defined( &sparc) || defined( &__sparc)) {
	eval 'sub BOTH_SHORT {
	    my($x) = @_;
    	    eval q( &LSB_SHORT($x));
	}' unless defined(&BOTH_SHORT);
	eval 'sub BOTH_INT {
	    my($x) = @_;
    	    eval q( &LSB_INT($x));
	}' unless defined(&BOTH_INT);
    }
    eval 'sub ISO_SECTOR_SIZE () {2048;}' unless defined(&ISO_SECTOR_SIZE);
    eval 'sub ISO_SECTOR_SHIFT () {11;}' unless defined(&ISO_SECTOR_SHIFT);
    eval 'sub ISO_SEC_PER_PAGE () {( &PAGESIZE/ &HS_SECTOR_SIZE);}' unless defined(&ISO_SEC_PER_PAGE);
    eval 'sub ISO_SYSAREA_SEC () {0;}' unless defined(&ISO_SYSAREA_SEC);
    eval 'sub ISO_VOLDESC_SEC () {16;}' unless defined(&ISO_VOLDESC_SEC);
    eval 'sub MAXISOOFFSET () {( &ISO_SECTOR_SIZE - 1);}' unless defined(&MAXISOOFFSET);
    eval 'sub MAXISOMASK () {(~ &MAXISOOFFSET);}' unless defined(&MAXISOMASK);
    eval("sub ISO_VD_BOOT () { 0; }") unless defined(&ISO_VD_BOOT);
    eval("sub ISO_VD_PVD () { 1; }") unless defined(&ISO_VD_PVD);
    eval("sub ISO_VD_SVD () { 2; }") unless defined(&ISO_VD_SVD);
    eval("sub ISO_VD_VPD () { 3; }") unless defined(&ISO_VD_VPD);
    eval("sub ISO_VD_EOV () { 255; }") unless defined(&ISO_VD_EOV);
    eval 'sub ISO_ID_STRING () {"CD001";}' unless defined(&ISO_ID_STRING);
    eval 'sub ISO_ID_STRLEN () {5;}' unless defined(&ISO_ID_STRLEN);
    eval 'sub ISO_ID_VER () {1;}' unless defined(&ISO_ID_VER);
    eval 'sub ISO_FILE_STRUCT_ID_VER () {1;}' unless defined(&ISO_FILE_STRUCT_ID_VER);
    eval 'sub ISO_SYS_ID_STRLEN () {32;}' unless defined(&ISO_SYS_ID_STRLEN);
    eval 'sub ISO_VOL_ID_STRLEN () {32;}' unless defined(&ISO_VOL_ID_STRLEN);
    eval 'sub ISO_VOL_SET_ID_STRLEN () {128;}' unless defined(&ISO_VOL_SET_ID_STRLEN);
    eval 'sub ISO_PUB_ID_STRLEN () {128;}' unless defined(&ISO_PUB_ID_STRLEN);
    eval 'sub ISO_PREP_ID_STRLEN () {128;}' unless defined(&ISO_PREP_ID_STRLEN);
    eval 'sub ISO_APPL_ID_STRLEN () {128;}' unless defined(&ISO_APPL_ID_STRLEN);
    eval 'sub ISO_COPYR_ID_STRLEN () {37;}' unless defined(&ISO_COPYR_ID_STRLEN);
    eval 'sub ISO_ABSTR_ID_STRLEN () {37;}' unless defined(&ISO_ABSTR_ID_STRLEN);
    eval 'sub ISO_SHORT_DATE_LEN () {7;}' unless defined(&ISO_SHORT_DATE_LEN);
    eval 'sub ISO_DATE_LEN () {17;}' unless defined(&ISO_DATE_LEN);
    eval 'sub ISO_desc_type {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0]));
    }' unless defined(&ISO_desc_type);
    eval 'sub ISO_std_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[1]));
    }' unless defined(&ISO_std_id);
    eval 'sub ISO_std_ver {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[6]));
    }' unless defined(&ISO_std_ver);
    eval 'sub ISO_sys_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[8]));
    }' unless defined(&ISO_sys_id);
    eval 'sub ISO_vol_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[40]));
    }' unless defined(&ISO_vol_id);
    eval 'sub ISO_vol_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[80]));
    }' unless defined(&ISO_vol_size);
    eval 'sub ISO_set_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[120]));
    }' unless defined(&ISO_set_size);
    eval 'sub ISO_set_seq {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[124]));
    }' unless defined(&ISO_set_seq);
    eval 'sub ISO_blk_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[128]));
    }' unless defined(&ISO_blk_size);
    eval 'sub ISO_ptbl_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[132]));
    }' unless defined(&ISO_ptbl_size);
    eval 'sub ISO_ptbl_man_ls {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[140]));
    }' unless defined(&ISO_ptbl_man_ls);
    eval 'sub ISO_ptbl_opt_ls1 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[144]));
    }' unless defined(&ISO_ptbl_opt_ls1);
    eval 'sub ISO_ptbl_man_ms {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[148]));
    }' unless defined(&ISO_ptbl_man_ms);
    eval 'sub ISO_ptbl_opt_ms1 {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[152]));
    }' unless defined(&ISO_ptbl_opt_ms1);
    eval 'sub ISO_root_dir {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[156]));
    }' unless defined(&ISO_root_dir);
    eval 'sub ISO_vol_set_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[190]));
    }' unless defined(&ISO_vol_set_id);
    eval 'sub ISO_pub_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[318]));
    }' unless defined(&ISO_pub_id);
    eval 'sub ISO_prep_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[446]));
    }' unless defined(&ISO_prep_id);
    eval 'sub ISO_appl_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[574]));
    }' unless defined(&ISO_appl_id);
    eval 'sub ISO_copyr_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[702]));
    }' unless defined(&ISO_copyr_id);
    eval 'sub ISO_abstr_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[739]));
    }' unless defined(&ISO_abstr_id);
    eval 'sub ISO_bibli_id {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[776]));
    }' unless defined(&ISO_bibli_id);
    eval 'sub ISO_cre_date {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[813]));
    }' unless defined(&ISO_cre_date);
    eval 'sub ISO_mod_date {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[830]));
    }' unless defined(&ISO_mod_date);
    eval 'sub ISO_exp_date {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[847]));
    }' unless defined(&ISO_exp_date);
    eval 'sub ISO_eff_date {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[864]));
    }' unless defined(&ISO_eff_date);
    eval 'sub ISO_file_struct_ver {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[881]));
    }' unless defined(&ISO_file_struct_ver);
    eval 'sub ISO_DESC_TYPE {
        my($x) = @_;
	    eval q((( &enum  &hs_voldesc_type)*( &ISO_desc_type($x))));
    }' unless defined(&ISO_DESC_TYPE);
    eval 'sub ISO_STD_ID {
        my($x) = @_;
	    eval q( &ISO_std_id($x));
    }' unless defined(&ISO_STD_ID);
    eval 'sub ISO_STD_VER {
        my($x) = @_;
	    eval q(*( &ISO_std_ver($x)));
    }' unless defined(&ISO_STD_VER);
    eval 'sub ISO_SYS_ID {
        my($x) = @_;
	    eval q( &ISO_sys_id($x));
    }' unless defined(&ISO_SYS_ID);
    eval 'sub ISO_VOL_ID {
        my($x) = @_;
	    eval q( &ISO_vol_id($x));
    }' unless defined(&ISO_VOL_ID);
    eval 'sub ISO_VOL_SIZE {
        my($x) = @_;
	    eval q( &BOTH_INT( &ISO_vol_size($x)));
    }' unless defined(&ISO_VOL_SIZE);
    eval 'sub ISO_SET_SIZE {
        my($x) = @_;
	    eval q( &BOTH_SHORT( &ISO_set_size($x)));
    }' unless defined(&ISO_SET_SIZE);
    eval 'sub ISO_SET_SEQ {
        my($x) = @_;
	    eval q( &BOTH_SHORT( &ISO_set_seq($x)));
    }' unless defined(&ISO_SET_SEQ);
    eval 'sub ISO_BLK_SIZE {
        my($x) = @_;
	    eval q( &BOTH_SHORT( &ISO_blk_size($x)));
    }' unless defined(&ISO_BLK_SIZE);
    eval 'sub ISO_PTBL_SIZE {
        my($x) = @_;
	    eval q( &BOTH_INT( &ISO_ptbl_size($x)));
    }' unless defined(&ISO_PTBL_SIZE);
    eval 'sub ISO_PTBL_MAN_LS {
        my($x) = @_;
	    eval q( &LSB_INT( &ISO_ptbl_man_ls($x)));
    }' unless defined(&ISO_PTBL_MAN_LS);
    eval 'sub ISO_PTBL_OPT_LS1 {
        my($x) = @_;
	    eval q( &LSB_INT( &ISO_ptbl_opt_ls1($x)));
    }' unless defined(&ISO_PTBL_OPT_LS1);
    eval 'sub ISO_PTBL_MAN_MS {
        my($x) = @_;
	    eval q( &MSB_INT( &ISO_ptbl_man_ms($x)));
    }' unless defined(&ISO_PTBL_MAN_MS);
    eval 'sub ISO_PTBL_OPT_MS1 {
        my($x) = @_;
	    eval q( &MSB_INT( &ISO_ptbl_opt_ms1($x)));
    }' unless defined(&ISO_PTBL_OPT_MS1);
    eval 'sub ISO_ROOT_DIR {
        my($x) = @_;
	    eval q( &ISO_root_dir($x));
    }' unless defined(&ISO_ROOT_DIR);
    eval 'sub ISO_VOL_SET_ID {
        my($x) = @_;
	    eval q( &ISO_vol_set_id($x));
    }' unless defined(&ISO_VOL_SET_ID);
    eval 'sub ISO_PUB_ID {
        my($x) = @_;
	    eval q( &ISO_pub_id($x));
    }' unless defined(&ISO_PUB_ID);
    eval 'sub ISO_PREP_ID {
        my($x) = @_;
	    eval q( &ISO_prep_id($x));
    }' unless defined(&ISO_PREP_ID);
    eval 'sub ISO_APPL_ID {
        my($x) = @_;
	    eval q( &ISO_appl_id($x));
    }' unless defined(&ISO_APPL_ID);
    eval 'sub ISO_COPYR_ID {
        my($x) = @_;
	    eval q( &ISO_copyr_id($x));
    }' unless defined(&ISO_COPYR_ID);
    eval 'sub ISO_ABSTR_ID {
        my($x) = @_;
	    eval q( &ISO_abstr_id($x));
    }' unless defined(&ISO_ABSTR_ID);
    eval 'sub ISO_BIBLI_ID {
        my($x) = @_;
	    eval q( &ISO_bibli_id($x));
    }' unless defined(&ISO_BIBLI_ID);
    eval 'sub ISO_CRE_DATE {
        my($x) = @_;
	    eval q( &HSV_cre_date($x));
    }' unless defined(&ISO_CRE_DATE);
    eval 'sub ISO_MOD_DATE {
        my($x) = @_;
	    eval q( &HSV_mod_date($x));
    }' unless defined(&ISO_MOD_DATE);
    eval 'sub ISO_EXP_DATE {
        my($x) = @_;
	    eval q( &HSV_exp_date($x));
    }' unless defined(&ISO_EXP_DATE);
    eval 'sub ISO_EFF_DATE {
        my($x) = @_;
	    eval q( &HSV_eff_date($x));
    }' unless defined(&ISO_EFF_DATE);
    eval 'sub ISO_FILE_STRUCT_VER {
        my($x) = @_;
	    eval q(*( &ISO_file_struct_ver($x)));
    }' unless defined(&ISO_FILE_STRUCT_VER);
    eval 'sub ISO_DATE_2DIG {
        my($x) = @_;
	    eval q((((($x)[0] - ord(\'0\') * 10) +							((x)[1] - \'0\'))));
    }' unless defined(&ISO_DATE_2DIG);
    eval 'sub ISO_DATE_4DIG {
        my($x) = @_;
	    eval q((((($x)[0] - ord(\'0\') * 1000) +							(((x)[1] - \'0\') * 100) +						(((x)[2] - \'0\') * 10) +							((x)[3] - \'0\'))));
    }' unless defined(&ISO_DATE_4DIG);
    eval 'sub ISO_DATE_YEAR {
        my($x) = @_;
	    eval q( &ISO_DATE_4DIG((( &uchar_t *)$x)[0]));
    }' unless defined(&ISO_DATE_YEAR);
    eval 'sub ISO_DATE_MONTH {
        my($x) = @_;
	    eval q( &ISO_DATE_2DIG((( &uchar_t *)$x)[4]));
    }' unless defined(&ISO_DATE_MONTH);
    eval 'sub ISO_DATE_DAY {
        my($x) = @_;
	    eval q( &ISO_DATE_2DIG((( &uchar_t *)$x)[6]));
    }' unless defined(&ISO_DATE_DAY);
    eval 'sub ISO_DATE_HOUR {
        my($x) = @_;
	    eval q( &ISO_DATE_2DIG((( &uchar_t *)$x)[8]));
    }' unless defined(&ISO_DATE_HOUR);
    eval 'sub ISO_DATE_MIN {
        my($x) = @_;
	    eval q( &ISO_DATE_2DIG((( &uchar_t *)$x)[10]));
    }' unless defined(&ISO_DATE_MIN);
    eval 'sub ISO_DATE_SEC {
        my($x) = @_;
	    eval q( &ISO_DATE_2DIG((( &uchar_t *)$x)[12]));
    }' unless defined(&ISO_DATE_SEC);
    eval 'sub ISO_DATE_HSEC {
        my($x) = @_;
	    eval q( &ISO_DATE_2DIG((( &uchar_t *)$x)[14]));
    }' unless defined(&ISO_DATE_HSEC);
    eval 'sub ISO_DATE_GMTOFF {
        my($x) = @_;
	    eval q((($x)[16]));
    }' unless defined(&ISO_DATE_GMTOFF);
    eval 'sub IDE_ROOT_DIR_REC_SIZE () {34;}' unless defined(&IDE_ROOT_DIR_REC_SIZE);
    eval 'sub IDE_FDESIZE () {33;}' unless defined(&IDE_FDESIZE);
    eval 'sub IDE_MAX_NAME_LEN () {(255-  &IDE_FDESIZE);}' unless defined(&IDE_MAX_NAME_LEN);
    eval 'sub IDE_dir_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0]));
    }' unless defined(&IDE_dir_len);
    eval 'sub IDE_xar_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[1]));
    }' unless defined(&IDE_xar_len);
    eval 'sub IDE_ext_lbn {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[2]));
    }' unless defined(&IDE_ext_lbn);
    eval 'sub IDE_ext_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[10]));
    }' unless defined(&IDE_ext_size);
    eval 'sub IDE_cdate {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[18]));
    }' unless defined(&IDE_cdate);
    eval 'sub IDE_flags {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[25]));
    }' unless defined(&IDE_flags);
    eval 'sub IDE_intrlv_size {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[26]));
    }' unless defined(&IDE_intrlv_size);
    eval 'sub IDE_intrlv_skip {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[27]));
    }' unless defined(&IDE_intrlv_skip);
    eval 'sub IDE_vol_set {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[28]));
    }' unless defined(&IDE_vol_set);
    eval 'sub IDE_name_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[32]));
    }' unless defined(&IDE_name_len);
    eval 'sub IDE_name {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[33]));
    }' unless defined(&IDE_name);
    eval 'sub IDE_sys_use_area {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[ &IDE_NAME_LEN($x) +  &IDE_PAD_LEN($x)] +  &IDE_FDESIZE));
    }' unless defined(&IDE_sys_use_area);
    eval 'sub IDE_DIR_LEN {
        my($x) = @_;
	    eval q(*( &IDE_dir_len($x)));
    }' unless defined(&IDE_DIR_LEN);
    eval 'sub IDE_XAR_LEN {
        my($x) = @_;
	    eval q(*( &IDE_xar_len($x)));
    }' unless defined(&IDE_XAR_LEN);
    eval 'sub IDE_EXT_LBN {
        my($x) = @_;
	    eval q( &BOTH_INT( &IDE_ext_lbn($x)));
    }' unless defined(&IDE_EXT_LBN);
    eval 'sub IDE_EXT_SIZE {
        my($x) = @_;
	    eval q( &BOTH_INT( &IDE_ext_size($x)));
    }' unless defined(&IDE_EXT_SIZE);
    eval 'sub IDE_CDATE {
        my($x) = @_;
	    eval q( &IDE_cdate($x));
    }' unless defined(&IDE_CDATE);
    eval 'sub IDE_FLAGS {
        my($x) = @_;
	    eval q(*( &IDE_flags($x)));
    }' unless defined(&IDE_FLAGS);
    eval 'sub IDE_INTRLV_SIZE {
        my($x) = @_;
	    eval q(*( &IDE_intrlv_size($x)));
    }' unless defined(&IDE_INTRLV_SIZE);
    eval 'sub IDE_INTRLV_SKIP {
        my($x) = @_;
	    eval q(*( &IDE_intrlv_skip($x)));
    }' unless defined(&IDE_INTRLV_SKIP);
    eval 'sub IDE_VOL_SET {
        my($x) = @_;
	    eval q( &BOTH_SHORT( &IDE_vol_set($x)));
    }' unless defined(&IDE_VOL_SET);
    eval 'sub IDE_NAME_LEN {
        my($x) = @_;
	    eval q(*( &IDE_name_len($x)));
    }' unless defined(&IDE_NAME_LEN);
    eval 'sub IDE_NAME {
        my($x) = @_;
	    eval q( &IDE_name($x));
    }' unless defined(&IDE_NAME);
    eval 'sub IDE_PAD_LEN {
        my($x) = @_;
	    eval q((( &IDE_NAME_LEN($x) % 2) ? 0: 1));
    }' unless defined(&IDE_PAD_LEN);
    eval 'sub IDE_SUA_LEN {
        my($x) = @_;
	    eval q(( &IDE_DIR_LEN($x) -  &IDE_FDESIZE -  &IDE_NAME_LEN($x) -  &IDE_PAD_LEN($x)));
    }' unless defined(&IDE_SUA_LEN);
    eval 'sub IDE_EXISTENCE () {0x1;}' unless defined(&IDE_EXISTENCE);
    eval 'sub IDE_DIRECTORY () {0x2;}' unless defined(&IDE_DIRECTORY);
    eval 'sub IDE_ASSOCIATED () {0x4;}' unless defined(&IDE_ASSOCIATED);
    eval 'sub IDE_RECORD () {0x8;}' unless defined(&IDE_RECORD);
    eval 'sub IDE_PROTECTION () {0x10;}' unless defined(&IDE_PROTECTION);
    eval 'sub IDE_UNUSED_FLAGS () {0x60;}' unless defined(&IDE_UNUSED_FLAGS);
    eval 'sub IDE_LAST_EXTENT () {0x80;}' unless defined(&IDE_LAST_EXTENT);
    eval 'sub IDE_PROHIBITED () {( &IDE_DIRECTORY |  &IDE_RECORD |  &IDE_LAST_EXTENT |  &IDE_UNUSED_FLAGS);}' unless defined(&IDE_PROHIBITED);
    eval 'sub IDE_DATE_YEAR {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0] + 1900));
    }' unless defined(&IDE_DATE_YEAR);
    eval 'sub IDE_DATE_MONTH {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[1]));
    }' unless defined(&IDE_DATE_MONTH);
    eval 'sub IDE_DATE_DAY {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[2]));
    }' unless defined(&IDE_DATE_DAY);
    eval 'sub IDE_DATE_HOUR {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[3]));
    }' unless defined(&IDE_DATE_HOUR);
    eval 'sub IDE_DATE_MIN {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&IDE_DATE_MIN);
    eval 'sub IDE_DATE_SEC {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[5]));
    }' unless defined(&IDE_DATE_SEC);
    eval 'sub IDE_DATE_GMTOFF {
        my($x) = @_;
	    eval q((($x)[6]));
    }' unless defined(&IDE_DATE_GMTOFF);
    eval 'sub IDE_REGULAR_FILE {
        my($x) = @_;
	    eval q(((($x) &  &IDE_PROHIBITED) == 0));
    }' unless defined(&IDE_REGULAR_FILE);
    eval 'sub IDE_REGULAR_DIR {
        my($x) = @_;
	    eval q(((($x) &  &IDE_PROHIBITED) ==  &IDE_DIRECTORY));
    }' unless defined(&IDE_REGULAR_DIR);
    eval 'sub ISO_DIR_NAMELEN () {31;}' unless defined(&ISO_DIR_NAMELEN);
    eval 'sub ISO_FILE_NAMELEN () {31;}' unless defined(&ISO_FILE_NAMELEN);
    eval 'sub IPE_FPESIZE () {8;}' unless defined(&IPE_FPESIZE);
    eval 'sub IPE_name_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0]));
    }' unless defined(&IPE_name_len);
    eval 'sub IPE_xar_len {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[1]));
    }' unless defined(&IPE_xar_len);
    eval 'sub IPE_ext_lbn {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[2]));
    }' unless defined(&IPE_ext_lbn);
    eval 'sub IPE_parent_no {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[6]));
    }' unless defined(&IPE_parent_no);
    eval 'sub IPE_name {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[8]));
    }' unless defined(&IPE_name);
    eval 'sub IPE_EXT_LBN {
        my($x) = @_;
	    eval q(( &MSB_INT( &IPE_ext_lbn($x))));
    }' unless defined(&IPE_EXT_LBN);
    eval 'sub IPE_XAR_LEN {
        my($x) = @_;
	    eval q(*( &IPE_xar_len($x)));
    }' unless defined(&IPE_XAR_LEN);
    eval 'sub IPE_NAME_LEN {
        my($x) = @_;
	    eval q(*( &IPE_name_len($x)));
    }' unless defined(&IPE_NAME_LEN);
    eval 'sub IPE_PARENT_NO {
        my($x) = @_;
	    eval q(*( &IPE_parent_no($x)));
    }' unless defined(&IPE_PARENT_NO);
    eval 'sub IPE_NAME {
        my($x) = @_;
	    eval q( &IPE_name($x));
    }' unless defined(&IPE_NAME);
    if(defined(&__cplusplus)) {
    }
}
1;
