require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_HSFS_NODE_H)) {
    eval 'sub _SYS_FS_HSFS_NODE_H () {1;}' unless defined(&_SYS_FS_HSFS_NODE_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub HREF () {1;}' unless defined(&HREF);
    eval 'sub HS_HASHSIZE () {32;}' unless defined(&HS_HASHSIZE);
    eval 'sub HS_HSNODESPACE () {16384;}' unless defined(&HS_HSNODESPACE);
    eval("sub HS_VOL_TYPE_HS () { 0; }") unless defined(&HS_VOL_TYPE_HS);
    eval("sub HS_VOL_TYPE_ISO () { 1; }") unless defined(&HS_VOL_TYPE_ISO);
    eval 'sub HSFS_MAGIC () {0x3095500;}' unless defined(&HSFS_MAGIC);
    eval 'sub HSFS_ERR_TRAILING_JUNK () {0;}' unless defined(&HSFS_ERR_TRAILING_JUNK);
    eval 'sub HSFS_ERR_LOWER_CASE_NM () {1;}' unless defined(&HSFS_ERR_LOWER_CASE_NM);
    eval 'sub HSFS_ERR_BAD_ROOT_DIR () {2;}' unless defined(&HSFS_ERR_BAD_ROOT_DIR);
    eval 'sub HSFS_ERR_UNSUP_TYPE () {3;}' unless defined(&HSFS_ERR_UNSUP_TYPE);
    eval 'sub HSFS_ERR_BAD_FILE_LEN () {4;}' unless defined(&HSFS_ERR_BAD_FILE_LEN);
    eval 'sub HSFS_HAVE_LOWER_CASE {
        my($fsp) = @_;
	    eval q((($fsp)-> &hsfs_err_flags & (1<<  &HSFS_ERR_LOWER_CASE_NM)));
    }' unless defined(&HSFS_HAVE_LOWER_CASE);
    eval 'sub hs_blksize {
        my($HSFS, $HSP, $OFF) = @_;
	    eval q((($HSP)-> ($hs_vn->{v_flag}) &  &VROOT ? (($OFF) >= (($HSFS)-> &hsfs_rdirsec & ~(($HSFS)-> &hsfs_spcl - 1))* &HS_SECSIZE ? (($HSFS)-> &hsfs_rdirsec & (($HSFS)-> &hsfs_spcl - 1))* &HS_SECSIZE : ($HSFS)-> &hsfs_clsize): ($HSFS)-> &hsfs_clsize));
    }' unless defined(&hs_blksize);
    eval 'sub hs_blkoff {
        my($OFF) = @_;
	    eval q((($OFF) & ( &HS_SECSIZE - 1)));
    }' unless defined(&hs_blkoff);
    eval 'sub VFS_TO_HSFS {
        my($VFSP) = @_;
	    eval q((($VFSP)-> &vfs_data));
    }' unless defined(&VFS_TO_HSFS);
    eval 'sub HSFS_TO_VFS {
        my($FSP) = @_;
	    eval q((($FSP)-> &hsfs_vfs));
    }' unless defined(&HSFS_TO_VFS);
    eval 'sub VTOH {
        my($VP) = @_;
	    eval q((($VP)-> &v_data));
    }' unless defined(&VTOH);
    eval 'sub HTOV {
        my($HP) = @_;
	    eval q(((($HP)-> &hs_vnode)));
    }' unless defined(&HTOV);
    eval 'sub LBN_TO_SEC {
        my($lbn, $vfsp) = @_;
	    eval q((($lbn)>>((($vfsp)-> &vfs_data))->  ($hsfs_vol->{lbn_secshift})));
    }' unless defined(&LBN_TO_SEC);
    eval 'sub SEC_TO_LBN {
        my($sec, $vfsp) = @_;
	    eval q((($sec)<<((($vfsp)-> &vfs_data))->  ($hsfs_vol->{lbn_secshift})));
    }' unless defined(&SEC_TO_LBN);
    eval 'sub LBN_TO_BYTE {
        my($lbn, $vfsp) = @_;
	    eval q((($lbn)<<((($vfsp)-> &vfs_data))->  ($hsfs_vol->{lbn_shift})));
    }' unless defined(&LBN_TO_BYTE);
    eval 'sub BYTE_TO_LBN {
        my($boff, $vfsp) = @_;
	    eval q((($boff)>>((($vfsp)-> &vfs_data))->  ($hsfs_vol->{lbn_shift})));
    }' unless defined(&BYTE_TO_LBN);
    eval 'sub HSFS_MIN_DL_SHFT () {5;}' unless defined(&HSFS_MIN_DL_SHFT);
    eval 'sub MAKE_NODEID {
        my($lbn, $off, $vfsp) = @_;
	    eval q((( &LBN_TO_BYTE(($lbn), ($vfsp)) + ($off)) >>  &HSFS_MIN_DL_SHFT));
    }' unless defined(&MAKE_NODEID);
    if(defined(&__cplusplus)) {
    }
}
1;
