require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_HSFS_RRIP_H)) {
    eval 'sub _SYS_FS_HSFS_RRIP_H () {1;}' unless defined(&_SYS_FS_HSFS_RRIP_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub HSFSMNT_NORRIP () {0x1;}' unless defined(&HSFSMNT_NORRIP);
    eval 'sub HSFSMNT_NOTRAILDOT () {0x2;}' unless defined(&HSFSMNT_NOTRAILDOT);
    eval 'sub HSFSMNT_NOMAPLCASE () {0x4;}' unless defined(&HSFSMNT_NOMAPLCASE);
    eval 'sub MS_NO_RRIP () {0x800000;}' unless defined(&MS_NO_RRIP);
    eval 'sub MIN {
        my($a, $b) = @_;
	    eval q((($a) < ($b) ? ($a) : ($b)));
    }' unless defined(&MIN);
    eval 'sub RRIP_VERSION () {1;}' unless defined(&RRIP_VERSION);
    eval 'sub RRIP_SUF_VERSION () {1;}' unless defined(&RRIP_SUF_VERSION);
    eval 'sub RRIP_EXT_VERSION () {1;}' unless defined(&RRIP_EXT_VERSION);
    eval 'sub RRIP_BIT () {1;}' unless defined(&RRIP_BIT);
    eval 'sub IS_RRIP_IMPLEMENTED {
        my($fsp) = @_;
	    eval q(( &IS_IMPL_BIT_SET($fsp,  &RRIP_BIT) ? 1: 0));
    }' unless defined(&IS_RRIP_IMPLEMENTED);
    eval 'sub RRIP_CL () {"CL";}' unless defined(&RRIP_CL);
    eval 'sub RRIP_NM () {"NM";}' unless defined(&RRIP_NM);
    eval 'sub RRIP_PL () {"PL";}' unless defined(&RRIP_PL);
    eval 'sub RRIP_PN () {"PN";}' unless defined(&RRIP_PN);
    eval 'sub RRIP_PX () {"PX";}' unless defined(&RRIP_PX);
    eval 'sub RRIP_RE () {"RE";}' unless defined(&RRIP_RE);
    eval 'sub RRIP_RR () {"RR";}' unless defined(&RRIP_RR);
    eval 'sub RRIP_SL () {"SL";}' unless defined(&RRIP_SL);
    eval 'sub RRIP_TF () {"TF";}' unless defined(&RRIP_TF);
    eval 'sub RRIP_ER_EXT_ID () {"RRIP_1991A";}' unless defined(&RRIP_ER_EXT_ID);
    eval 'sub RRIP_ER_EXT_DES () {"THE ROCK RIDGE INTERCHANGE PROTOCOL PROVIDES SUPPORT FOR POSIX FILE SYSTEM SEMANTICS.";}' unless defined(&RRIP_ER_EXT_DES);
    eval 'sub RRIP_ER_EXT_SRC () {"PLEASE CONTACT DISC PUBLISHER FOR SPECIFICATION SOURCE.  SEE PUBLISHER IDENTIFIER IN PRIMARY VOLUME DESCRIPTOR FOR CONTACT INFORMATION.";}' unless defined(&RRIP_ER_EXT_SRC);
    eval 'sub RRIP_TF_FLAGS {
        my($x) = @_;
	    eval q(*( &RRIP_tf_flags($x)));
    }' unless defined(&RRIP_TF_FLAGS);
    eval 'sub RRIP_tf_flags {
        my($x) = @_;
	    eval q(((( &uchar_t *)($x))[4]));
    }' unless defined(&RRIP_tf_flags);
    eval 'sub RRIP_TIME_START_BP () {5;}' unless defined(&RRIP_TIME_START_BP);
    eval 'sub RRIP_TF_TIME_LENGTH {
        my($x) = @_;
	    eval q(( &IS_TIME_BIT_SET( &RRIP_TF_FLAGS($x),  &RRIP_TF_LONG_BIT) ?  &ISO_DATE_LEN :  &ISO_SHORT_DATE_LEN));
    }' unless defined(&RRIP_TF_TIME_LENGTH);
    eval 'sub RRIP_TF_CREATION_BIT () {0x1;}' unless defined(&RRIP_TF_CREATION_BIT);
    eval 'sub RRIP_TF_MODIFY_BIT () {0x2;}' unless defined(&RRIP_TF_MODIFY_BIT);
    eval 'sub RRIP_TF_ACCESS_BIT () {0x4;}' unless defined(&RRIP_TF_ACCESS_BIT);
    eval 'sub RRIP_TF_ATTRIBUTES_BIT () {0x8;}' unless defined(&RRIP_TF_ATTRIBUTES_BIT);
    eval 'sub RRIP_TF_BACKUP_BIT () {0x10;}' unless defined(&RRIP_TF_BACKUP_BIT);
    eval 'sub RRIP_TF_EXPIRATION_BIT () {0x20;}' unless defined(&RRIP_TF_EXPIRATION_BIT);
    eval 'sub RRIP_TF_EFFECTIVE_BIT () {0x40;}' unless defined(&RRIP_TF_EFFECTIVE_BIT);
    eval 'sub RRIP_TF_LONG_BIT () {0x80;}' unless defined(&RRIP_TF_LONG_BIT);
    eval 'sub RRIP_tf_creation {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[ &RRIP_TIME_START_BP]));
    }' unless defined(&RRIP_tf_creation);
    eval 'sub RRIP_tf_modify {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[ &RRIP_TIME_START_BP + ( &RRIP_TF_TIME_LENGTH($x) * ( &IS_TIME_BIT_SET( &RRIP_TF_FLAGS($x),  &RRIP_TF_CREATION_BIT)))]));
    }' unless defined(&RRIP_tf_modify);
    eval 'sub RRIP_tf_access {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[ &RRIP_TIME_START_BP + ( &RRIP_TF_TIME_LENGTH($x) * ( &IS_TIME_BIT_SET( &RRIP_TF_FLAGS($x),  &RRIP_TF_CREATION_BIT) +  &IS_TIME_BIT_SET( &RRIP_TF_FLAGS($x),  &RRIP_TF_MODIFY_BIT)))]));
    }' unless defined(&RRIP_tf_access);
    eval 'sub RRIP_tf_attributes {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[ &RRIP_TIME_START_BP + ( &RRIP_TF_TIME_LENGTH($x) * ( &IS_TIME_BIT_SET( &RRIP_TF_FLAGS($x),  &RRIP_TF_CREATION_BIT) +  &IS_TIME_BIT_SET( &RRIP_TF_FLAGS($x),  &RRIP_TF_MODIFY_BIT) +  &IS_TIME_BIT_SET( &RRIP_TF_FLAGS($x),  &RRIP_TF_ACCESS_BIT)))]));
    }' unless defined(&RRIP_tf_attributes);
    eval 'sub IS_TIME_BIT_SET {
        my($x, $y) = @_;
	    eval q(((($x) & ($y)) ? 1: 0));
    }' unless defined(&IS_TIME_BIT_SET);
    eval 'sub SET_TIME_BIT {
        my($x, $y) = @_;
	    eval q((($x) |= ($y)));
    }' unless defined(&SET_TIME_BIT);
    eval 'sub RRIP_mode {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&RRIP_mode);
    eval 'sub RRIP_MODE {
        my($x) = @_;
	    eval q(( &mode_t) &BOTH_INT( &RRIP_mode($x)));
    }' unless defined(&RRIP_MODE);
    eval 'sub RRIP_nlink {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[12]));
    }' unless defined(&RRIP_nlink);
    eval 'sub RRIP_NLINK {
        my($x) = @_;
	    eval q( &BOTH_INT( &RRIP_nlink($x)));
    }' unless defined(&RRIP_NLINK);
    eval 'sub RRIP_uid {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[20]));
    }' unless defined(&RRIP_uid);
    eval 'sub RRIP_UID {
        my($x) = @_;
	    eval q(( &uid_t) &BOTH_INT( &RRIP_uid($x)));
    }' unless defined(&RRIP_UID);
    eval 'sub RRIP_gid {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[28]));
    }' unless defined(&RRIP_gid);
    eval 'sub RRIP_GID {
        my($x) = @_;
	    eval q(( &gid_t) &BOTH_INT( &RRIP_gid($x)));
    }' unless defined(&RRIP_GID);
    eval 'sub RRIP_major {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&RRIP_major);
    eval 'sub RRIP_MAJOR {
        my($x) = @_;
	    eval q( &BOTH_INT( &RRIP_major($x)));
    }' unless defined(&RRIP_MAJOR);
    eval 'sub RRIP_minor {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[12]));
    }' unless defined(&RRIP_minor);
    eval 'sub RRIP_MINOR {
        my($x) = @_;
	    eval q( &BOTH_INT( &RRIP_minor($x)));
    }' unless defined(&RRIP_MINOR);
    eval 'sub RESTORE_NM {
        my($tmp, $orig) = @_;
	    eval q( &if ( &is_rrip  && *($tmp) != ord(\'\\\\0\')) ( &void)  &strcpy(($orig), ($tmp)));
    }' unless defined(&RESTORE_NM);
    eval 'sub SYM_LINK_LEN {
        my($x) = @_;
	    eval q(( &strlen($x) + 1));
    }' unless defined(&SYM_LINK_LEN);
    eval 'sub RRIP_NAME_LEN_BASE () {5;}' unless defined(&RRIP_NAME_LEN_BASE);
    eval 'sub RRIP_NAME_LEN {
        my($x) = @_;
	    eval q(( &SUF_LEN($x) -  &RRIP_NAME_LEN_BASE));
    }' unless defined(&RRIP_NAME_LEN);
    eval 'sub RRIP_NAME_FLAGS {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&RRIP_NAME_FLAGS);
    eval 'sub RRIP_NAME_CONTINUE () {0x1;}' unless defined(&RRIP_NAME_CONTINUE);
    eval 'sub RRIP_NAME_CURRENT () {0x2;}' unless defined(&RRIP_NAME_CURRENT);
    eval 'sub RRIP_NAME_PARENT () {0x4;}' unless defined(&RRIP_NAME_PARENT);
    eval 'sub RRIP_NAME_ROOT () {0x8;}' unless defined(&RRIP_NAME_ROOT);
    eval 'sub RRIP_NAME_VOLROOT () {0x10;}' unless defined(&RRIP_NAME_VOLROOT);
    eval 'sub RRIP_NAME_HOST () {0x20;}' unless defined(&RRIP_NAME_HOST);
    eval 'sub RRIP_NAME_CHANGE () {0x40;}' unless defined(&RRIP_NAME_CHANGE);
    eval 'sub RRIP_SYM_LINK_COMPLETE () {0x80;}' unless defined(&RRIP_SYM_LINK_COMPLETE);
    eval 'sub SET_NAME_BIT {
        my($x, $y) = @_;
	    eval q((($x) |= ($y)));
    }' unless defined(&SET_NAME_BIT);
    eval 'sub UNSET_NAME_BIT {
        my($x, $y) = @_;
	    eval q((($x) &= ~($y)));
    }' unless defined(&UNSET_NAME_BIT);
    eval 'sub IS_NAME_BIT_SET {
        my($x, $y) = @_;
	    eval q((($x) & ($y)));
    }' unless defined(&IS_NAME_BIT_SET);
    eval 'sub NAME_HAS_CHANGED {
        my($flag) = @_;
	    eval q(( &IS_NAME_BIT_SET($flag,  &RRIP_NAME_CHANGE) ? 1: 0));
    }' unless defined(&NAME_HAS_CHANGED);
    eval 'sub RRIP_name {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[5]));
    }' unless defined(&RRIP_name);
    eval 'sub RRIP_NAME {
        my($x) = @_;
	    eval q( &RRIP_name($x));
    }' unless defined(&RRIP_NAME);
    eval 'sub RRIP_FILE_NAMELEN () {255;}' unless defined(&RRIP_FILE_NAMELEN);
    eval 'sub RRIP_sl_comp {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[5]));
    }' unless defined(&RRIP_sl_comp);
    eval 'sub RRIP_SL_COMP {
        my($x) = @_;
	    eval q( &RRIP_sl_comp($x));
    }' unless defined(&RRIP_SL_COMP);
    eval 'sub RRIP_SL_FLAGS {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&RRIP_SL_FLAGS);
    eval 'sub RRIP_comp {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[2]));
    }' unless defined(&RRIP_comp);
    eval 'sub RRIP_COMP {
        my($x) = @_;
	    eval q( &RRIP_comp($x));
    }' unless defined(&RRIP_COMP);
    eval 'sub RRIP_COMP_FLAGS {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[0]));
    }' unless defined(&RRIP_COMP_FLAGS);
    eval 'sub RRIP_COMP_LEN {
        my($x) = @_;
	    eval q(( &RRIP_COMP_NAME_LEN($x) + 2));
    }' unless defined(&RRIP_COMP_LEN);
    eval 'sub RRIP_COMP_NAME_LEN {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[1]));
    }' unless defined(&RRIP_COMP_NAME_LEN);
    eval 'sub IS_RELOC_BIT_SET {
        my($x, $y) = @_;
	    eval q(((($x) & ($y)) ? 1: 0));
    }' unless defined(&IS_RELOC_BIT_SET);
    eval 'sub SET_RELOC_BIT {
        my($x, $y) = @_;
	    eval q((($x) |= ($y)));
    }' unless defined(&SET_RELOC_BIT);
    eval 'sub CHILD_LINK () {0x1;}' unless defined(&CHILD_LINK);
    eval 'sub PARENT_LINK () {0x2;}' unless defined(&PARENT_LINK);
    eval 'sub RELOCATED_DIR () {0x4;}' unless defined(&RELOCATED_DIR);
    eval 'sub RRIP_child_lbn {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&RRIP_child_lbn);
    eval 'sub RRIP_CHILD_LBN {
        my($x) = @_;
	    eval q(( &uint_t) &BOTH_INT( &RRIP_child_lbn($x)));
    }' unless defined(&RRIP_CHILD_LBN);
    eval 'sub RRIP_parent_lbn {
        my($x) = @_;
	    eval q(((( &uchar_t *)$x)[4]));
    }' unless defined(&RRIP_parent_lbn);
    eval 'sub RRIP_PARENT_LBN {
        my($x) = @_;
	    eval q(( &uint_t) &BOTH_INT( &RRIP_parent_lbn($x)));
    }' unless defined(&RRIP_PARENT_LBN);
    if(defined(&_KERNEL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
