require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_PC_LABEL_H)) {
    eval 'sub _SYS_FS_PC_LABEL_H () {1;}' unless defined(&_SYS_FS_PC_LABEL_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/isa_defs.ph';
    eval 'sub PCB_BPSEC () {11;}' unless defined(&PCB_BPSEC);
    eval 'sub PCB_SPC () {13;}' unless defined(&PCB_SPC);
    eval 'sub PCB_RESSEC () {14;}' unless defined(&PCB_RESSEC);
    eval 'sub PCB_NFAT () {16;}' unless defined(&PCB_NFAT);
    eval 'sub PCB_NROOTENT () {17;}' unless defined(&PCB_NROOTENT);
    eval 'sub PCB_NSEC () {19;}' unless defined(&PCB_NSEC);
    eval 'sub PCB_MEDIA () {21;}' unless defined(&PCB_MEDIA);
    eval 'sub PCB_SPF () {22;}' unless defined(&PCB_SPF);
    eval 'sub PCB_SPT () {24;}' unless defined(&PCB_SPT);
    eval 'sub PCB_NHEAD () {26;}' unless defined(&PCB_NHEAD);
    eval 'sub PCB_HIDSEC () {28;}' unless defined(&PCB_HIDSEC);
    eval 'sub PCFS_PART () {0x1be;}' unless defined(&PCFS_PART);
    eval 'sub PCFS_NUMPART () {4;}' unless defined(&PCFS_NUMPART);
    eval 'sub PCFS_TYPESTRING_OFFSET16 () {0x36;}' unless defined(&PCFS_TYPESTRING_OFFSET16);
    eval 'sub PCFS_TYPESTRING_OFFSET32 () {0x52;}' unless defined(&PCFS_TYPESTRING_OFFSET32);
    eval 'sub PCFS_BPB () {0xb;}' unless defined(&PCFS_BPB);
    eval 'sub PCFS_SIGN () {0x1fe;}' unless defined(&PCFS_SIGN);
    eval 'sub DOS_SYSFAT12 () {1;}' unless defined(&DOS_SYSFAT12);
    eval 'sub DOS_SYSFAT16 () {4;}' unless defined(&DOS_SYSFAT16);
    eval 'sub DOS_SYSHUGE () {6;}' unless defined(&DOS_SYSHUGE);
    eval 'sub DOS_FAT32 () {0xb;}' unless defined(&DOS_FAT32);
    eval 'sub DOS_FAT32_LBA () {0xc;}' unless defined(&DOS_FAT32_LBA);
    eval 'sub DOS_FAT16P_LBA () {0xe;}' unless defined(&DOS_FAT16P_LBA);
    eval 'sub DOS_FAT16_LBA () {0xf;}' unless defined(&DOS_FAT16_LBA);
    eval 'sub DOS_F12MAXS () {20740;}' unless defined(&DOS_F12MAXS);
    eval 'sub DOS_F12MAXC () {4086;}' unless defined(&DOS_F12MAXC);
    eval 'sub DOS_ID1 () {0xe9;}' unless defined(&DOS_ID1);
    eval 'sub DOS_ID2a () {0xeb;}' unless defined(&DOS_ID2a);
    eval 'sub DOS_ID2b () {0x90;}' unless defined(&DOS_ID2b);
    eval 'sub DOS_SIGN () {0xaa55;}' unless defined(&DOS_SIGN);
    eval 'sub PC_FATBLOCK () {1;}' unless defined(&PC_FATBLOCK);
    eval 'sub MD_FIXED () {0xf8;}' unless defined(&MD_FIXED);
    eval 'sub SS8SPT () {0xfe;}' unless defined(&SS8SPT);
    eval 'sub DS8SPT () {0xff;}' unless defined(&DS8SPT);
    eval 'sub SS9SPT () {0xfc;}' unless defined(&SS9SPT);
    eval 'sub DS9SPT () {0xfd;}' unless defined(&DS9SPT);
    eval 'sub DS18SPT () {0xf0;}' unless defined(&DS18SPT);
    eval 'sub DS9_15SPT () {0xf9;}' unless defined(&DS9_15SPT);
    eval 'sub PC_SECSIZE () {512;}' unless defined(&PC_SECSIZE);
    if(defined( &i386)) {
	eval 'sub ltohs {
	    my($S) = @_;
    	    eval q((*(( &ushort_t *)(($S)))));
	}' unless defined(&ltohs);
	eval 'sub ltohi {
	    my($I) = @_;
    	    eval q((*(( &uint_t *)(($I)))));
	}' unless defined(&ltohi);
	eval 'sub htols {
	    my($S) = @_;
    	    eval q((*(( &ushort_t *)(($S)))));
	}' unless defined(&htols);
	eval 'sub htoli {
	    my($I) = @_;
    	    eval q((*(( &uint_t *)(($I)))));
	}' unless defined(&htoli);
    } else {
	eval 'sub getbyte {
	    my($A, $N) = @_;
    	    eval q((((($A)))[$N]));
	}' unless defined(&getbyte);
	eval 'sub ltohs {
	    my($S) = @_;
    	    eval q((( &getbyte($S, 1) << 8) |  &getbyte($S, 0)));
	}' unless defined(&ltohs);
	eval 'sub ltohi {
	    my($I) = @_;
    	    eval q((( &getbyte($I, 3) << 24) | ( &getbyte($I, 2) << 16) | ( &getbyte($I, 1) << 8) |  &getbyte($I, 0)));
	}' unless defined(&ltohi);
	eval 'sub htols {
	    my($S) = @_;
    	    eval q((( &getbyte($S, 1) << 8) |  &getbyte($S, 0)));
	}' unless defined(&htols);
	eval 'sub htoli {
	    my($I) = @_;
    	    eval q((( &getbyte($I, 3) << 24) | ( &getbyte($I, 2) << 16) | ( &getbyte($I, 1) << 8) |  &getbyte($I, 0)));
	}' unless defined(&htoli);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
