require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_UFS_INODE_H)) {
    eval 'sub _SYS_FS_UFS_INODE_H () {1;}' unless defined(&_SYS_FS_UFS_INODE_H);
    require 'sys/isa_defs.ph';
    require 'sys/fbuf.ph';
    require 'sys/fdbuffer.ph';
    require 'sys/fcntl.ph';
    require 'sys/uio.ph';
    require 'sys/t_lock.ph';
    require 'sys/thread.ph';
    require 'sys/cred.ph';
    require 'sys/time.ph';
    require 'sys/types32.ph';
    require 'sys/fs/ufs_fs.ph';
    require 'sys/fs/ufs_lockfs.ph';
    require 'sys/fs/ufs_trans.ph';
    require 'sys/kstat.ph';
    require 'sys/fs/ufs_acl.ph';
    require 'sys/fs/ufs_panic.ph';
    require 'sys/dnlc.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub UID_LONG () {( &o_uid_t)65535;}' unless defined(&UID_LONG);
    eval 'sub GID_LONG () {( &o_uid_t)65535;}' unless defined(&GID_LONG);
    eval 'sub NDADDR () {12;}' unless defined(&NDADDR);
    eval 'sub NIADDR () {3;}' unless defined(&NIADDR);
    eval 'sub FSL_SIZE () {( &NDADDR +  &NIADDR - 1) * $sizeof{ &daddr32_t};}' unless defined(&FSL_SIZE);
    eval 'sub i_fs () { ($i_ufsvfs->{vfs_bufp}->{b_un}->{b_fs});}' unless defined(&i_fs);
    eval 'sub i_vfs () { ($i_vnode->{v_vfsp});}' unless defined(&i_vfs);
    if(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub i_mode () { ($i_ic->{ic_smode});}' unless defined(&i_mode);
    eval 'sub i_nlink () { ($i_ic->{ic_nlink});}' unless defined(&i_nlink);
    eval 'sub i_uid () { ($i_ic->{ic_uid});}' unless defined(&i_uid);
    eval 'sub i_gid () { ($i_ic->{ic_gid});}' unless defined(&i_gid);
    eval 'sub i_smode () { ($i_ic->{ic_smode});}' unless defined(&i_smode);
    eval 'sub i_suid () { ($i_ic->{ic_suid});}' unless defined(&i_suid);
    eval 'sub i_sgid () { ($i_ic->{ic_sgid});}' unless defined(&i_sgid);
    eval 'sub i_size () { ($i_ic->{ic_lsize});}' unless defined(&i_size);
    eval 'sub i_db () { ($i_ic->{ic_db});}' unless defined(&i_db);
    eval 'sub i_ib () { ($i_ic->{ic_ib});}' unless defined(&i_ib);
    eval 'sub i_atime () { ($i_ic->{ic_atime});}' unless defined(&i_atime);
    eval 'sub i_mtime () { ($i_ic->{ic_mtime});}' unless defined(&i_mtime);
    eval 'sub i_ctime () { ($i_ic->{ic_ctime});}' unless defined(&i_ctime);
    eval 'sub i_shadow () { ($i_ic->{ic_shadow});}' unless defined(&i_shadow);
    eval 'sub i_blocks () { ($i_ic->{ic_blocks});}' unless defined(&i_blocks);
    if(defined(&_LITTLE_ENDIAN)) {
	eval 'sub i_ordev () { ($i_ic->{ic_db[1]});}' unless defined(&i_ordev);
    } else {
	eval 'sub i_ordev () { ($i_ic->{ic_db[0]});}' unless defined(&i_ordev);
    }
    eval 'sub i_gen () { ($i_ic->{ic_gen});}' unless defined(&i_gen);
    eval 'sub i_forw () { $i_chain[0];}' unless defined(&i_forw);
    eval 'sub i_back () { $i_chain[1];}' unless defined(&i_back);
    eval 'sub oEFT_MAGIC () {0x90909090;}' unless defined(&oEFT_MAGIC);
    eval 'sub di_oeftflag () { ($di_ic->{ic_oeftflag});}' unless defined(&di_oeftflag);
    eval 'sub di_ic () { ($di_un->{di_icom});}' unless defined(&di_ic);
    eval 'sub di_mode () { ($di_ic->{ic_smode});}' unless defined(&di_mode);
    eval 'sub di_nlink () { ($di_ic->{ic_nlink});}' unless defined(&di_nlink);
    eval 'sub di_uid () { ($di_ic->{ic_uid});}' unless defined(&di_uid);
    eval 'sub di_gid () { ($di_ic->{ic_gid});}' unless defined(&di_gid);
    eval 'sub di_smode () { ($di_ic->{ic_smode});}' unless defined(&di_smode);
    eval 'sub di_suid () { ($di_ic->{ic_suid});}' unless defined(&di_suid);
    eval 'sub di_sgid () { ($di_ic->{ic_sgid});}' unless defined(&di_sgid);
    eval 'sub di_size () { ($di_ic->{ic_lsize});}' unless defined(&di_size);
    eval 'sub di_db () { ($di_ic->{ic_db});}' unless defined(&di_db);
    eval 'sub di_ib () { ($di_ic->{ic_ib});}' unless defined(&di_ib);
    eval 'sub di_atime () { ($di_ic->{ic_atime});}' unless defined(&di_atime);
    eval 'sub di_mtime () { ($di_ic->{ic_mtime});}' unless defined(&di_mtime);
    eval 'sub di_ctime () { ($di_ic->{ic_ctime});}' unless defined(&di_ctime);
    if(defined(&_LITTLE_ENDIAN)) {
	eval 'sub di_ordev () { ($di_ic->{ic_db[1]});}' unless defined(&di_ordev);
    } else {
	eval 'sub di_ordev () { ($di_ic->{ic_db[0]});}' unless defined(&di_ordev);
    }
    eval 'sub di_shadow () { ($di_ic->{ic_shadow});}' unless defined(&di_shadow);
    eval 'sub di_blocks () { ($di_ic->{ic_blocks});}' unless defined(&di_blocks);
    eval 'sub di_gen () { ($di_ic->{ic_gen});}' unless defined(&di_gen);
    eval 'sub IUPD () {0x1;}' unless defined(&IUPD);
    eval 'sub IACC () {0x2;}' unless defined(&IACC);
    eval 'sub IMOD () {0x4;}' unless defined(&IMOD);
    eval 'sub ICHG () {0x8;}' unless defined(&ICHG);
    eval 'sub INOACC () {0x10;}' unless defined(&INOACC);
    eval 'sub IMODTIME () {0x20;}' unless defined(&IMODTIME);
    eval 'sub IREF () {0x40;}' unless defined(&IREF);
    eval 'sub ISYNC () {0x80;}' unless defined(&ISYNC);
    eval 'sub IFASTSYMLNK () {0x100;}' unless defined(&IFASTSYMLNK);
    eval 'sub IMODACC () {0x200;}' unless defined(&IMODACC);
    eval 'sub IATTCHG () {0x400;}' unless defined(&IATTCHG);
    eval 'sub IBDWRITE () {0x800;}' unless defined(&IBDWRITE);
    eval 'sub ISTALE () {0x1000;}' unless defined(&ISTALE);
    eval 'sub IDEL () {0x2000;}' unless defined(&IDEL);
    eval 'sub IDIRECTIO () {0x4000;}' unless defined(&IDIRECTIO);
    eval 'sub ITRUNC () {0x8000;}' unless defined(&ITRUNC);
    eval 'sub IFMT () {0170000;}' unless defined(&IFMT);
    eval 'sub IFIFO () {0010000;}' unless defined(&IFIFO);
    eval 'sub IFCHR () {0020000;}' unless defined(&IFCHR);
    eval 'sub IFDIR () {0040000;}' unless defined(&IFDIR);
    eval 'sub IFBLK () {0060000;}' unless defined(&IFBLK);
    eval 'sub IFREG () {0100000;}' unless defined(&IFREG);
    eval 'sub IFLNK () {0120000;}' unless defined(&IFLNK);
    eval 'sub IFSHAD () {0130000;}' unless defined(&IFSHAD);
    eval 'sub IFSOCK () {0140000;}' unless defined(&IFSOCK);
    eval 'sub ISUID () {04000;}' unless defined(&ISUID);
    eval 'sub ISGID () {02000;}' unless defined(&ISGID);
    eval 'sub ISVTX () {01000;}' unless defined(&ISVTX);
    eval 'sub IREAD () {0400;}' unless defined(&IREAD);
    eval 'sub IWRITE () {0200;}' unless defined(&IWRITE);
    eval 'sub IEXEC () {0100;}' unless defined(&IEXEC);
    eval 'sub I_SYNC () {1;}' unless defined(&I_SYNC);
    eval 'sub I_DSYNC () {2;}' unless defined(&I_DSYNC);
    eval 'sub I_ASYNC () {0;}' unless defined(&I_ASYNC);
    eval 'sub I_FREE () {0x1;}' unless defined(&I_FREE);
    eval 'sub I_DIR () {0x2;}' unless defined(&I_DIR);
    eval 'sub I_IBLK () {0x4;}' unless defined(&I_IBLK);
    eval 'sub I_CHEAP () {0x8;}' unless defined(&I_CHEAP);
    eval 'sub I_SHAD () {0x10;}' unless defined(&I_SHAD);
    eval 'sub I_QUOTA () {0x20;}' unless defined(&I_QUOTA);
    if(defined(&_KERNEL)) {
	eval 'sub VTOI {
	    my($VP) = @_;
    	    eval q((($VP)-> &v_data));
	}' unless defined(&VTOI);
	eval 'sub ITOV {
	    my($IP) = @_;
    	    eval q((($IP)-> &i_vnode));
	}' unless defined(&ITOV);
	eval 'sub ITOF {
	    my($IP) = @_;
    	    eval q((($IP)-> &i_fs));
	}' unless defined(&ITOF);
	if(defined(&notneeded)) {
	}
	eval 'sub ITIMES_NOLOCK {
	    my($ip) = @_;
    	    eval q( &ufs_itimes_nolock($ip));
	}' unless defined(&ITIMES_NOLOCK);
	eval 'sub ITIMES {
	    my($ip) = @_;
    	    eval q({  &mutex_enter(($ip)-> &i_tlock);  &ITIMES_NOLOCK($ip);  &mutex_exit(($ip)-> &i_tlock); });
	}' unless defined(&ITIMES);
	if(defined(&_LP64)) {
	    eval 'sub UFS_GET_ISIZE {
	        my($resultp, $ip) = @_;
    		eval q(*($resultp) = ($ip)-> &i_size);
	    }' unless defined(&UFS_GET_ISIZE);
	    eval 'sub UFS_SET_ISIZE {
	        my($value, $ip) = @_;
    		eval q(($ip)-> &i_size = ($value));
	    }' unless defined(&UFS_SET_ISIZE);
	} else {
	    if(defined(&sparc)) {
		eval 'sub UFS_GET_ISIZE {
		    my($resultp, $ip) = @_;
    		    eval q(*($resultp) =  &load_double(($ip)-> &i_size));
		}' unless defined(&UFS_GET_ISIZE);
		eval 'sub UFS_SET_ISIZE {
		    my($value, $ip) = @_;
    		    eval q( &store_double($value, ($ip)-> &i_size));
		}' unless defined(&UFS_SET_ISIZE);
	    } else {
		eval 'sub UFS_GET_ISIZE {
		    my($resultp, $ip) = @_;
    		    eval q({  &rw_enter(($ip)-> &i_contents,  &RW_READER); *($resultp) = ($ip)-> &i_size;  &rw_exit(($ip)-> &i_contents); });
		}' unless defined(&UFS_GET_ISIZE);
		eval 'sub UFS_SET_ISIZE {
		    my($value, $ip) = @_;
    		    eval q({  &ASSERT( &RW_WRITE_HELD(($ip)-> &i_contents)); ($ip)-> &i_size = ($value); });
		}' unless defined(&UFS_SET_ISIZE);
	    }
	}
	eval 'sub BMAPALLOC {
	    my($ip, $off, $size, $cr) = @_;
    	    eval q( &bmap_write(($ip), ( &u_offset_t)($off), ($size), 0, $cr));
	}' unless defined(&BMAPALLOC);
	eval 'sub ESAME () {(-1);}' unless defined(&ESAME);
	eval 'sub OWNER {
	    my($CR, $IP) = @_;
    	    eval q(((($CR)-> &cr_uid == ($IP)-> &i_uid)? 0: ( &suser($CR)? 0:  &EPERM)));
	}' unless defined(&OWNER);
	eval 'sub UFS_HOLE () {( &daddr32_t)-1;}' unless defined(&UFS_HOLE);
	eval("sub DE_CREATE () { 0; }") unless defined(&DE_CREATE);
	eval("sub DE_MKDIR () { 1; }") unless defined(&DE_MKDIR);
	eval("sub DE_LINK () { 2; }") unless defined(&DE_LINK);
	eval("sub DE_RENAME () { 3; }") unless defined(&DE_RENAME);
	eval("sub DE_SYMLINK () { 4; }") unless defined(&DE_SYMLINK);
	eval("sub DR_REMOVE () { 0; }") unless defined(&DR_REMOVE);
	eval("sub DR_RMDIR () { 1; }") unless defined(&DR_RMDIR);
	eval("sub DR_RENAME () { 2; }") unless defined(&DR_RENAME);
	eval 'sub uq_head () { ($_uq_head->{_uq_generic});}' unless defined(&uq_head);
	eval 'sub uq_ihead () { ($_uq_head->{_uq_i});}' unless defined(&uq_ihead);
	eval 'sub uq_ufhead () { ($_uq_head->{_uq_uf});}' unless defined(&uq_ufhead);
	eval 'sub UQ_EXIT () {(0x1);}' unless defined(&UQ_EXIT);
	eval 'sub UQ_WAIT () {(0x2);}' unless defined(&UQ_WAIT);
	eval 'sub UQ_SUSPEND () {(0x4);}' unless defined(&UQ_SUSPEND);
	eval 'sub UQ_SUSPENDED () {(0x8);}' unless defined(&UQ_SUSPENDED);
	eval 'sub UQ_EXISTS () {(0x10);}' unless defined(&UQ_EXISTS);
	eval 'sub UFS_LARGEFILES () {(( &ushort_t)0x1);}' unless defined(&UFS_LARGEFILES);
	eval 'sub UFS_DFRATIME () {0x1;}' unless defined(&UFS_DFRATIME);
	eval 'sub vfs_fs () { ($vfs_bufp->{b_un}->{b_fs});}' unless defined(&vfs_fs);
	eval 'sub INOHASH {
	    my($dev, $ino) = @_;
    	    eval q(( &hash2ints($dev, $ino) & ( &inohsz - 1)));
	}' unless defined(&INOHASH);
    }
    if(defined( &_KERNEL)) {
	eval 'sub DIRECTIO_FAILURE () {(0);}' unless defined(&DIRECTIO_FAILURE);
	eval 'sub DIRECTIO_SUCCESS () {(1);}' unless defined(&DIRECTIO_SUCCESS);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
