require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_UFS_LOCKFS_H)) {
    eval 'sub _SYS_FS_UFS_LOCKFS_H () {1;}' unless defined(&_SYS_FS_UFS_LOCKFS_H);
    require 'sys/lockfs.ph';
    if(defined(&__cplusplus)) {
    }
    require 'sys/fs/ufs_trans.ph';
    require 'sys/thread.ph';
    eval 'sub ULOCKFS_BUSY () {0x1;}' unless defined(&ULOCKFS_BUSY);
    eval 'sub ULOCKFS_NOIACC () {0x4;}' unless defined(&ULOCKFS_NOIACC);
    eval 'sub ULOCKFS_NOIDEL () {0x8;}' unless defined(&ULOCKFS_NOIDEL);
    eval 'sub ULOCKFS_IS_BUSY {
        my($LF) = @_;
	    eval q((($LF)-> &ul_flag &  &ULOCKFS_BUSY));
    }' unless defined(&ULOCKFS_IS_BUSY);
    eval 'sub ULOCKFS_IS_NOIACC {
        my($LF) = @_;
	    eval q((($LF)-> &ul_flag &  &ULOCKFS_NOIACC));
    }' unless defined(&ULOCKFS_IS_NOIACC);
    eval 'sub ULOCKFS_IS_NOIDEL {
        my($LF) = @_;
	    eval q((($LF)-> &ul_flag &  &ULOCKFS_NOIDEL));
    }' unless defined(&ULOCKFS_IS_NOIDEL);
    eval 'sub ULOCKFS_CLR_BUSY {
        my($LF) = @_;
	    eval q((($LF)-> &ul_flag &= ~ &ULOCKFS_BUSY));
    }' unless defined(&ULOCKFS_CLR_BUSY);
    eval 'sub ULOCKFS_SET_BUSY {
        my($LF) = @_;
	    eval q((($LF)-> &ul_flag |=  &ULOCKFS_BUSY));
    }' unless defined(&ULOCKFS_SET_BUSY);
    eval 'sub ULOCKFS_SET_MOD {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_mod = 1));
    }' unless defined(&ULOCKFS_SET_MOD);
    eval 'sub ULOCKFS_CLR_MOD {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_mod = 0));
    }' unless defined(&ULOCKFS_CLR_MOD);
    eval 'sub ULOCKFS_IS_MOD {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_mod));
    }' unless defined(&ULOCKFS_IS_MOD);
    eval 'sub ULOCKFS_ULOCK () {((1<<  &LOCKFS_ULOCK));}' unless defined(&ULOCKFS_ULOCK);
    eval 'sub ULOCKFS_WLOCK () {((1<<  &LOCKFS_WLOCK));}' unless defined(&ULOCKFS_WLOCK);
    eval 'sub ULOCKFS_NLOCK () {((1<<  &LOCKFS_NLOCK));}' unless defined(&ULOCKFS_NLOCK);
    eval 'sub ULOCKFS_DLOCK () {((1<<  &LOCKFS_DLOCK));}' unless defined(&ULOCKFS_DLOCK);
    eval 'sub ULOCKFS_HLOCK () {((1<<  &LOCKFS_HLOCK));}' unless defined(&ULOCKFS_HLOCK);
    eval 'sub ULOCKFS_ELOCK () {((1<<  &LOCKFS_ELOCK));}' unless defined(&ULOCKFS_ELOCK);
    eval 'sub ULOCKFS_ROELOCK () {((1<<  &LOCKFS_ROELOCK));}' unless defined(&ULOCKFS_ROELOCK);
    eval 'sub ULOCKFS_SLOCK () {0x80000000;}' unless defined(&ULOCKFS_SLOCK);
    eval 'sub ULOCKFS_IS_WLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock &  &ULOCKFS_WLOCK));
    }' unless defined(&ULOCKFS_IS_WLOCK);
    eval 'sub ULOCKFS_IS_HLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock &  &ULOCKFS_HLOCK));
    }' unless defined(&ULOCKFS_IS_HLOCK);
    eval 'sub ULOCKFS_IS_ELOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock &  &ULOCKFS_ELOCK));
    }' unless defined(&ULOCKFS_IS_ELOCK);
    eval 'sub ULOCKFS_IS_ROELOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock &  &ULOCKFS_ROELOCK));
    }' unless defined(&ULOCKFS_IS_ROELOCK);
    eval 'sub ULOCKFS_IS_ULOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock &  &ULOCKFS_ULOCK));
    }' unless defined(&ULOCKFS_IS_ULOCK);
    eval 'sub ULOCKFS_IS_NLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock &  &ULOCKFS_NLOCK));
    }' unless defined(&ULOCKFS_IS_NLOCK);
    eval 'sub ULOCKFS_IS_DLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock &  &ULOCKFS_DLOCK));
    }' unless defined(&ULOCKFS_IS_DLOCK);
    eval 'sub ULOCKFS_IS_SLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock &  &ULOCKFS_SLOCK));
    }' unless defined(&ULOCKFS_IS_SLOCK);
    eval 'sub ULOCKFS_IS_JUSTULOCK {
        my($LF) = @_;
	    eval q(((($LF)-> &ul_fs_lock & ( &ULOCKFS_SLOCK |  &ULOCKFS_ULOCK)) ==  &ULOCKFS_ULOCK));
    }' unless defined(&ULOCKFS_IS_JUSTULOCK);
    eval 'sub ULOCKFS_SET_SLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock |=  &ULOCKFS_SLOCK));
    }' unless defined(&ULOCKFS_SET_SLOCK);
    eval 'sub ULOCKFS_CLR_SLOCK {
        my($LF) = @_;
	    eval q((($LF)-> &ul_fs_lock &= ~ &ULOCKFS_SLOCK));
    }' unless defined(&ULOCKFS_CLR_SLOCK);
    eval 'sub ULOCKFS_READ_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_READ_MASK);
    eval 'sub ULOCKFS_WRITE_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_WRITE_MASK);
    eval 'sub ULOCKFS_GETATTR_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_GETATTR_MASK);
    eval 'sub ULOCKFS_SETATTR_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_SETATTR_MASK);
    eval 'sub ULOCKFS_ACCESS_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_ACCESS_MASK);
    eval 'sub ULOCKFS_LOOKUP_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_LOOKUP_MASK);
    eval 'sub ULOCKFS_CREATE_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_CREATE_MASK);
    eval 'sub ULOCKFS_REMOVE_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK |  &ULOCKFS_NLOCK |  &ULOCKFS_DLOCK);}' unless defined(&ULOCKFS_REMOVE_MASK);
    eval 'sub ULOCKFS_LINK_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_LINK_MASK);
    eval 'sub ULOCKFS_RENAME_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_NLOCK);}' unless defined(&ULOCKFS_RENAME_MASK);
    eval 'sub ULOCKFS_MKDIR_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_MKDIR_MASK);
    eval 'sub ULOCKFS_RMDIR_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK |  &ULOCKFS_NLOCK |  &ULOCKFS_DLOCK);}' unless defined(&ULOCKFS_RMDIR_MASK);
    eval 'sub ULOCKFS_READDIR_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_READDIR_MASK);
    eval 'sub ULOCKFS_SYMLINK_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_SYMLINK_MASK);
    eval 'sub ULOCKFS_READLINK_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_READLINK_MASK);
    eval 'sub ULOCKFS_FSYNC_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_FSYNC_MASK);
    eval 'sub ULOCKFS_FID_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_FID_MASK);
    eval 'sub ULOCKFS_RWLOCK_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_RWLOCK_MASK);
    eval 'sub ULOCKFS_RWUNLOCK_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_RWUNLOCK_MASK);
    eval 'sub ULOCKFS_SEEK_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_SEEK_MASK);
    eval 'sub ULOCKFS_FRLOCK_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_FRLOCK_MASK);
    eval 'sub ULOCKFS_SPACE_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_SPACE_MASK);
    eval 'sub ULOCKFS_QUOTA_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_QUOTA_MASK);
    eval 'sub ULOCKFS_GETREAD_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_GETREAD_MASK);
    eval 'sub ULOCKFS_GETWRITE_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_GETWRITE_MASK);
    eval 'sub ULOCKFS_MAP_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_MAP_MASK);
    eval 'sub ULOCKFS_FIODUTIMES_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_FIODUTIMES_MASK);
    eval 'sub ULOCKFS_FIODIO_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_FIODIO_MASK);
    eval 'sub ULOCKFS_FIODIOS_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_FIODIOS_MASK);
    eval 'sub ULOCKFS_PATHCONF_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_PATHCONF_MASK);
    eval 'sub ULOCKFS_VGET_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_SLOCK);}' unless defined(&ULOCKFS_VGET_MASK);
    eval 'sub ULOCKFS_DELETE_MASK () {( &ULOCKFS_HLOCK |  &ULOCKFS_ELOCK |  &ULOCKFS_ROELOCK |  &ULOCKFS_SLOCK |  &ULOCKFS_WLOCK);}' unless defined(&ULOCKFS_DELETE_MASK);
    eval 'sub VTOUL {
        my($VP) = @_;
	    eval q(( ((($VP)-> ($v_vfsp->{vfs_data})))-> &vfs_ulockfs));
    }' unless defined(&VTOUL);
    eval 'sub ITOUL {
        my($IP) = @_;
	    eval q(((($IP)-> ($i_ufsvfs->{vfs_ulockfs}))));
    }' unless defined(&ITOUL);
    if(defined(&__cplusplus)) {
    }
}
1;
