require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_UFS_PANIC_H)) {
    eval 'sub _SYS_FS_UFS_PANIC_H () {1;}' unless defined(&_SYS_FS_UFS_PANIC_H);
    require 'sys/types.ph';
    require 'sys/vfs.ph';
    require 'sys/fs/ufs_inode.ph';
    require 'sys/fs/ufs_fs.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &_KERNEL)) {
	eval("sub UF_UNDEF () { 0x0000; }") unless defined(&UF_UNDEF);
	eval("sub UF_INIT () { 0x0001; }") unless defined(&UF_INIT);
	eval("sub UF_QUEUE () { 0x0002; }") unless defined(&UF_QUEUE);
	eval("sub UF_TRYLCK () { 0x0010; }") unless defined(&UF_TRYLCK);
	eval("sub UF_LOCKED () { 0x0020; }") unless defined(&UF_LOCKED);
	eval("sub UF_UMOUNT () { 0x0040; }") unless defined(&UF_UMOUNT);
	eval("sub UF_FIXING () { 0x0080; }") unless defined(&UF_FIXING);
	eval("sub UF_FIXED () { 0x0100; }") unless defined(&UF_FIXED);
	eval("sub UF_NOTFIX () { 0x0200; }") unless defined(&UF_NOTFIX);
	eval("sub UF_REPLICA () { 0x0400; }") unless defined(&UF_REPLICA);
	eval("sub UF_PANIC () { 0x0800; }") unless defined(&UF_PANIC);
	eval("sub UF_ILLEGAL () { 0xffff; }") unless defined(&UF_ILLEGAL);
	eval("sub UF_ALLSTATES () { 0x0ff3; }") unless defined(&UF_ALLSTATES);
	eval 'sub uf_next () { $uf_chain[0];}' unless defined(&uf_next);
	eval 'sub uf_prev () { $uf_chain[1];}' unless defined(&uf_prev);
	eval 'sub uf_fs () { ($uf_bp->{b_un}->{b_fs});}' unless defined(&uf_fs);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
