require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_UFS_QUOTA_H)) {
    eval 'sub _SYS_FS_UFS_QUOTA_H () {1;}' unless defined(&_SYS_FS_UFS_QUOTA_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub DQ_FTIMELIMIT () {(7* 24*60*60);}' unless defined(&DQ_FTIMELIMIT);
    eval 'sub DQ_BTIMELIMIT () {(7* 24*60*60);}' unless defined(&DQ_BTIMELIMIT);
    eval 'sub dqoff {
        my($UID) = @_;
	    eval q(((( &offset_t)($UID) * $sizeof{\'struct dqblk\'})));
    }' unless defined(&dqoff);
    eval 'sub DQ_ERROR () {0x1;}' unless defined(&DQ_ERROR);
    eval 'sub DQ_MOD () {0x4;}' unless defined(&DQ_MOD);
    eval 'sub DQ_BLKS () {0x10;}' unless defined(&DQ_BLKS);
    eval 'sub DQ_FILES () {0x20;}' unless defined(&DQ_FILES);
    eval 'sub DQ_TRANS () {0x40;}' unless defined(&DQ_TRANS);
    if(defined(&_KERNEL)) {
    }
    eval 'sub dq_bhardlimit () { ($dq_dqb->{dqb_bhardlimit});}' unless defined(&dq_bhardlimit);
    eval 'sub dq_bsoftlimit () { ($dq_dqb->{dqb_bsoftlimit});}' unless defined(&dq_bsoftlimit);
    eval 'sub dq_curblocks () { ($dq_dqb->{dqb_curblocks});}' unless defined(&dq_curblocks);
    eval 'sub dq_fhardlimit () { ($dq_dqb->{dqb_fhardlimit});}' unless defined(&dq_fhardlimit);
    eval 'sub dq_fsoftlimit () { ($dq_dqb->{dqb_fsoftlimit});}' unless defined(&dq_fsoftlimit);
    eval 'sub dq_curfiles () { ($dq_dqb->{dqb_curfiles});}' unless defined(&dq_curfiles);
    eval 'sub dq_btimelimit () { ($dq_dqb->{dqb_btimelimit});}' unless defined(&dq_btimelimit);
    eval 'sub dq_ftimelimit () { ($dq_dqb->{dqb_ftimelimit});}' unless defined(&dq_ftimelimit);
    eval 'sub MQ_ENABLED () {0x1;}' unless defined(&MQ_ENABLED);
    if(defined( &_KERNEL)) {
	eval 'sub NDQHASH () {64;}' unless defined(&NDQHASH);
	eval 'sub DQHASH {
	    my($uid, $mp) = @_;
    	    eval q(((( &uintptr_t) + ($uid)) & ( &NDQHASH-1)));
	}' unless defined(&DQHASH);
    }
    eval 'sub Q_QUOTAON () {1;}' unless defined(&Q_QUOTAON);
    eval 'sub Q_QUOTAOFF () {2;}' unless defined(&Q_QUOTAOFF);
    eval 'sub Q_SETQUOTA () {3;}' unless defined(&Q_SETQUOTA);
    eval 'sub Q_GETQUOTA () {4;}' unless defined(&Q_GETQUOTA);
    eval 'sub Q_SETQLIM () {5;}' unless defined(&Q_SETQLIM);
    eval 'sub Q_SYNC () {6;}' unless defined(&Q_SYNC);
    eval 'sub Q_ALLSYNC () {7;}' unless defined(&Q_ALLSYNC);
    if(defined(&_SYSCALL32)) {
    }
    eval 'sub Q_QUOTACTL () {0x30189;}' unless defined(&Q_QUOTACTL);
    if(defined(&__cplusplus)) {
    }
}
1;
