require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FS_UFS_TRANS_H)) {
    eval 'sub _SYS_FS_UFS_TRANS_H () {1;}' unless defined(&_SYS_FS_UFS_TRANS_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'sys/cred.ph';
    require 'sys/fs/ufs_fs.ph';
    eval 'sub UT_UNMOUNTED () {(0);}' unless defined(&UT_UNMOUNTED);
    eval 'sub UT_MOUNTED () {(1);}' unless defined(&UT_MOUNTED);
    eval 'sub UT_HLOCKING () {(2);}' unless defined(&UT_HLOCKING);
    eval("sub DT_NONE () { 0; }") unless defined(&DT_NONE);
    eval("sub DT_SB () { 1; }") unless defined(&DT_SB);
    eval("sub DT_CG () { 2; }") unless defined(&DT_CG);
    eval("sub DT_SI () { 3; }") unless defined(&DT_SI);
    eval("sub DT_AB () { 4; }") unless defined(&DT_AB);
    eval("sub DT_ABZERO () { 5; }") unless defined(&DT_ABZERO);
    eval("sub DT_DIR () { 6; }") unless defined(&DT_DIR);
    eval("sub DT_INODE () { 7; }") unless defined(&DT_INODE);
    eval("sub DT_FBI () { 8; }") unless defined(&DT_FBI);
    eval("sub DT_QR () { 9; }") unless defined(&DT_QR);
    eval("sub DT_COMMIT () { 10; }") unless defined(&DT_COMMIT);
    eval("sub DT_CANCEL () { 11; }") unless defined(&DT_CANCEL);
    eval("sub DT_BOT () { 12; }") unless defined(&DT_BOT);
    eval("sub DT_EOT () { 13; }") unless defined(&DT_EOT);
    eval("sub DT_UD () { 14; }") unless defined(&DT_UD);
    eval("sub DT_SUD () { 15; }") unless defined(&DT_SUD);
    eval("sub DT_SHAD () { 16; }") unless defined(&DT_SHAD);
    eval("sub DT_MAX () { 17; }") unless defined(&DT_MAX);
    eval("sub TOP_READ_SYNC () { 0; }") unless defined(&TOP_READ_SYNC);
    eval("sub TOP_WRITE () { 1; }") unless defined(&TOP_WRITE);
    eval("sub TOP_WRITE_SYNC () { 2; }") unless defined(&TOP_WRITE_SYNC);
    eval("sub TOP_SETATTR () { 3; }") unless defined(&TOP_SETATTR);
    eval("sub TOP_CREATE () { 4; }") unless defined(&TOP_CREATE);
    eval("sub TOP_REMOVE () { 5; }") unless defined(&TOP_REMOVE);
    eval("sub TOP_LINK () { 6; }") unless defined(&TOP_LINK);
    eval("sub TOP_RENAME () { 7; }") unless defined(&TOP_RENAME);
    eval("sub TOP_MKDIR () { 8; }") unless defined(&TOP_MKDIR);
    eval("sub TOP_RMDIR () { 9; }") unless defined(&TOP_RMDIR);
    eval("sub TOP_SYMLINK () { 10; }") unless defined(&TOP_SYMLINK);
    eval("sub TOP_FSYNC () { 11; }") unless defined(&TOP_FSYNC);
    eval("sub TOP_GETPAGE () { 12; }") unless defined(&TOP_GETPAGE);
    eval("sub TOP_PUTPAGE () { 13; }") unless defined(&TOP_PUTPAGE);
    eval("sub TOP_SBUPDATE_FLUSH () { 14; }") unless defined(&TOP_SBUPDATE_FLUSH);
    eval("sub TOP_SBUPDATE_UPDATE () { 15; }") unless defined(&TOP_SBUPDATE_UPDATE);
    eval("sub TOP_SBUPDATE_UNMOUNT () { 16; }") unless defined(&TOP_SBUPDATE_UNMOUNT);
    eval("sub TOP_SYNCIP_CLOSEDQ () { 17; }") unless defined(&TOP_SYNCIP_CLOSEDQ);
    eval("sub TOP_SYNCIP_FLUSHI () { 18; }") unless defined(&TOP_SYNCIP_FLUSHI);
    eval("sub TOP_SYNCIP_HLOCK () { 19; }") unless defined(&TOP_SYNCIP_HLOCK);
    eval("sub TOP_SYNCIP_SYNC () { 20; }") unless defined(&TOP_SYNCIP_SYNC);
    eval("sub TOP_SYNCIP_FREE () { 21; }") unless defined(&TOP_SYNCIP_FREE);
    eval("sub TOP_SBWRITE_RECLAIM () { 22; }") unless defined(&TOP_SBWRITE_RECLAIM);
    eval("sub TOP_SBWRITE_STABLE () { 23; }") unless defined(&TOP_SBWRITE_STABLE);
    eval("sub TOP_IFREE () { 24; }") unless defined(&TOP_IFREE);
    eval("sub TOP_IUPDAT () { 25; }") unless defined(&TOP_IUPDAT);
    eval("sub TOP_MOUNT () { 26; }") unless defined(&TOP_MOUNT);
    eval("sub TOP_COMMIT_ASYNC () { 27; }") unless defined(&TOP_COMMIT_ASYNC);
    eval("sub TOP_COMMIT_FLUSH () { 28; }") unless defined(&TOP_COMMIT_FLUSH);
    eval("sub TOP_COMMIT_UPDATE () { 29; }") unless defined(&TOP_COMMIT_UPDATE);
    eval("sub TOP_COMMIT_UNMOUNT () { 30; }") unless defined(&TOP_COMMIT_UNMOUNT);
    eval("sub TOP_SETSECATTR () { 31; }") unless defined(&TOP_SETSECATTR);
    eval("sub TOP_QUOTA () { 32; }") unless defined(&TOP_QUOTA);
    eval("sub TOP_ITRUNC () { 33; }") unless defined(&TOP_ITRUNC);
    eval("sub TOP_MAX () { 34; }") unless defined(&TOP_MAX);
    eval 'sub TRANS_ISTRANS {
        my($ufsvfsp) = @_;
	    eval q(( ($ufsvfsp->{vfs_trans})));
    }' unless defined(&TRANS_ISTRANS);
    eval 'sub TRANS_BEGIN_SYNC {
        my($ufsvfsp, $vid, $vsize) = @_;
	    eval q({  &if ( &TRANS_ISTRANS($ufsvfsp)) (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_begin_sync})) ( ($ufsvfsp->{vfs_trans}), $vid, $vsize); });
    }' unless defined(&TRANS_BEGIN_SYNC);
    eval 'sub TRANS_BEGIN_ASYNC {
        my($ufsvfsp, $vid, $vsize) = @_;
	    eval q({  &if ( &TRANS_ISTRANS($ufsvfsp)) ( &void) (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_begin_async})) ( ($ufsvfsp->{vfs_trans}), $vid, $vsize, 0); });
    }' unless defined(&TRANS_BEGIN_ASYNC);
    eval 'sub TRANS_TRY_BEGIN_ASYNC {
        my($ufsvfsp, $vid, $vsize, $err) = @_;
	    eval q({  &if ( &TRANS_ISTRANS($ufsvfsp)) $err = (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_begin_async})) ( ($ufsvfsp->{vfs_trans}), $vid, $vsize, 1);  &else $err = 0; });
    }' unless defined(&TRANS_TRY_BEGIN_ASYNC);
    eval 'sub TRANS_BEGIN_CSYNC {
        my($ufsvfsp, $issync, $vid, $vsize) = @_;
	    eval q({  &if ( &TRANS_ISTRANS($ufsvfsp)) {  &if ( ($ufsvfsp->{vfs_syncdir}) ||  ($curthread->{t_flag}) &  &T_DONTPEND) { (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_begin_sync})) ( ($ufsvfsp->{vfs_trans}), $vid, $vsize); $issync = 1; }  &else { (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_begin_async})) ( ($ufsvfsp->{vfs_trans}), $vid, $vsize, 0); $issync = 0; } }});
    }' unless defined(&TRANS_BEGIN_CSYNC);
    eval 'sub TRANS_TRY_BEGIN_CSYNC {
        my($ufsvfsp, $issync, $vid, $vsize, $error) = @_;
	    eval q({  &if ( &TRANS_ISTRANS($ufsvfsp)) {  &if ( ($ufsvfsp->{vfs_syncdir}) ||  ($curthread->{t_flag}) &  &T_DONTPEND) { (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_begin_sync})) ( ($ufsvfsp->{vfs_trans}), $vid, $vsize); $issync = 1; $error = 0; }  &else { $error = (* ($ufsvfsp->{vfs_trans}->{ut_ops})->  &trans_begin_async) ( ($ufsvfsp->{vfs_trans}), $vid, $vsize, 1); $issync = 0; } }});
    }' unless defined(&TRANS_TRY_BEGIN_CSYNC);
    eval 'sub TRANS_END_ASYNC {
        my($ufsvfsp, $vid, $vsize) = @_;
	    eval q({  &if ( &TRANS_ISTRANS($ufsvfsp)) (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_end_async})) ( ($ufsvfsp->{vfs_trans}), $vid, $vsize); });
    }' unless defined(&TRANS_END_ASYNC);
    eval 'sub TRANS_END_SYNC {
        my($ufsvfsp, $error, $vid, $vsize) = @_;
	    eval q({  &if ( &TRANS_ISTRANS($ufsvfsp)) (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_end_sync})) ( ($ufsvfsp->{vfs_trans}), $error, $vid, $vsize); });
    }' unless defined(&TRANS_END_SYNC);
    eval 'sub TRANS_END_CSYNC {
        my($ufsvfsp, $error, $issync, $vid, $vsize) = @_;
	    eval q({  &if ( &TRANS_ISTRANS($ufsvfsp))  &if ($issync) (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_end_sync})) ( ($ufsvfsp->{vfs_trans}), $error, $vid, $vsize);  &else (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_end_async})) ( ($ufsvfsp->{vfs_trans}), $vid, $vsize); });
    }' unless defined(&TRANS_END_CSYNC);
    eval 'sub TRANS_DELTA {
        my($ufsvfsp, $mof, $nb, $dtyp, $func, $arg) = @_;
	    eval q( &if ( &TRANS_ISTRANS($ufsvfsp)) (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_delta})) ( ($ufsvfsp->{vfs_trans}), ( &offset_t)($mof), $nb, $dtyp, $func, $arg));
    }' unless defined(&TRANS_DELTA);
    eval 'sub TRANS_UD_DELTA {
        my($ufsvfsp, $mof, $nb, $dtyp, $func, $arg) = @_;
	    eval q((( &TRANS_ISTRANS($ufsvfsp)) ? (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_ud_delta})) ( ($ufsvfsp->{vfs_trans}), ( &offset_t)($mof), $nb, $dtyp, $func, $arg) : 0));
    }' unless defined(&TRANS_UD_DELTA);
    eval 'sub TRANS_CANCEL {
        my($ufsvfsp, $mof, $nb) = @_;
	    eval q( &if ( &TRANS_ISTRANS($ufsvfsp)) (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_cancel})) ( ($ufsvfsp->{vfs_trans}), ( &offset_t)($mof), $nb));
    }' unless defined(&TRANS_CANCEL);
    eval 'sub TRANS_LOG {
        my($ufsvfsp, $va, $mof, $nb) = @_;
	    eval q( &if ( &TRANS_ISTRANS($ufsvfsp)) (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_log})) ( ($ufsvfsp->{vfs_trans}), $va, ( &offset_t)($mof), $nb));
    }' unless defined(&TRANS_LOG);
    eval 'sub TRANS_ISCANCEL {
        my($ufsvfsp, $mof, $nb) = @_;
	    eval q((( &TRANS_ISTRANS($ufsvfsp)) ? (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_iscancel})) ( ($ufsvfsp->{vfs_trans}), ( &offset_t)($mof), $nb) : 0));
    }' unless defined(&TRANS_ISCANCEL);
    eval 'sub TRANS_SETERROR {
        my($ufsvfsp) = @_;
	    eval q( &if ( &TRANS_ISTRANS($ufsvfsp)) (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_seterror})) ( ($ufsvfsp->{vfs_trans})));
    }' unless defined(&TRANS_SETERROR);
    eval 'sub TRANS_ISERROR {
        my($ufsvfsp) = @_;
	    eval q((( &TRANS_ISTRANS($ufsvfsp)) ? (* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_iserror})) ( ($ufsvfsp->{vfs_trans})) : 0));
    }' unless defined(&TRANS_ISERROR);
    eval 'sub TRANS_BUF {
        my($ufsvfsp, $vof, $nb, $bp, $type) = @_;
	    eval q( &TRANS_DELTA($ufsvfsp,  &ldbtob( ($bp->{b_blkno})) + ( &offset_t)($vof), $nb, $type,  &ufs_trans_push_buf,  ($bp->{b_blkno})));
    }' unless defined(&TRANS_BUF);
    eval 'sub TRANS_BUF_ITEM {
        my($ufsvfsp, $item, $base, $bp, $type) = @_;
	    eval q( &TRANS_BUF($ufsvfsp, & - ($base), $sizeof{$item}, $bp, $type));
    }' unless defined(&TRANS_BUF_ITEM);
    eval 'sub TRANS_BUF_ITEM_128 {
        my($ufsvfsp, $item, $base, $bp, $type) = @_;
	    eval q( &TRANS_BUF($ufsvfsp, ((( &uintptr_t)($item)) & ~(128- 1)) - ( &uintptr_t)($base), 128, $bp, $type));
    }' unless defined(&TRANS_BUF_ITEM_128);
    eval 'sub TRANS_UD_BUF {
        my($ufsvfsp, $islogged, $vof, $nb, $bp, $type) = @_;
	    eval q({ $islogged =  &TRANS_UD_DELTA($ufsvfsp,  &ldbtob( ($bp->{b_blkno})) + ( &offset_t)($vof), $nb, $type,  &ufs_trans_push_buf,  ($bp->{b_blkno})); });
    }' unless defined(&TRANS_UD_BUF);
    eval 'sub TRANS_INODE {
        my($ufsvfsp, $ip) = @_;
	    eval q( &TRANS_DELTA($ufsvfsp,  ($ip->{i_doff}), $sizeof{\'struct dinode\'},  &DT_INODE,  &ufs_trans_push_inode,  ($ip->{i_number})));
    }' unless defined(&TRANS_INODE);
    eval 'sub TRANS_INODE_DELTA {
        my($ufsvfsp, $vof, $nb, $ip) = @_;
	    eval q( &TRANS_DELTA($ufsvfsp, ( ($ip->{i_doff}) + ( &offset_t)($vof)), $nb,  &DT_INODE,  &ufs_trans_push_inode,  ($ip->{i_number})));
    }' unless defined(&TRANS_INODE_DELTA);
    eval 'sub TRANS_INODE_FIELD {
        my($ufsvfsp, $field, $ip) = @_;
	    eval q( &TRANS_INODE_DELTA($ufsvfsp, ($field) -  ($ip->{i_ic}), $sizeof{$field}, $ip));
    }' unless defined(&TRANS_INODE_FIELD);
    eval 'sub TRANS_SI {
        my($ufsvfsp, $fs, $cg) = @_;
	    eval q( &TRANS_DELTA($ufsvfsp,  &ldbtob( &fsbtodb($fs,  ($fs->{fs_csaddr}))) + ( ($fs->{fs_cs})($fs, $cg) -  ($fs->{fs_u}->{fs_csp})), $sizeof{\'struct csum\'},  &DT_SI,  &ufs_trans_push_si, $cg));
    }' unless defined(&TRANS_SI);
    eval 'sub TRANS_DIR {
        my($ip, $offset) = @_;
	    eval q(( &TRANS_ISTRANS( ($ip->{i_ufsvfs})) ?  &ufs_trans_dir($ip, $offset) : 0));
    }' unless defined(&TRANS_DIR);
    eval 'sub TRANS_QUOTA {
        my($dqp) = @_;
	    eval q( &if ( &TRANS_ISTRANS( ($dqp->{dq_ufsvfsp})))  &ufs_trans_quota($dqp););
    }' unless defined(&TRANS_QUOTA);
    eval 'sub TRANS_DQRELE {
        my($ufsvfsp, $dqp) = @_;
	    eval q( &if ( &TRANS_ISTRANS($ufsvfsp)  && (( ($curthread->{t_flag}) &  &T_DONTBLOCK) == 0)) {  &ufs_trans_dqrele($dqp); }  &else {  &rw_enter( ($ufsvfsp->{vfs_dqrwlock}),  &RW_READER);  &dqrele($dqp);  &rw_exit( ($ufsvfsp->{vfs_dqrwlock})); });
    }' unless defined(&TRANS_DQRELE);
    eval 'sub TRANS_ITRUNC {
        my($ip, $length, $flags, $cr) = @_;
	    eval q( &ufs_trans_itrunc($ip, $length, $flags, $cr););
    }' unless defined(&TRANS_ITRUNC);
    eval 'sub TRANS_WRITE_RESV {
        my($ip, $uiop, $ulp, $resvp, $residp) = @_;
	    eval q( &if (( &TRANS_ISTRANS( ($ip->{i_ufsvfs})) !=  &NULL)  && ($ulp !=  &NULL))  &ufs_trans_write_resv($ip, $uiop, $resvp, $residp););
    }' unless defined(&TRANS_WRITE_RESV);
    eval 'sub TRANS_WRITE {
        my($ip, $uiop, $ioflag, $err, $ulp, $cr, $resv, $resid) = @_;
	    eval q( &if (( &TRANS_ISTRANS( ($ip->{i_ufsvfs})) !=  &NULL)  && ($ulp !=  &NULL)) $err =  &ufs_trans_write($ip, $uiop, $ioflag, $cr, $resv, $resid);  &else $err =  &wrip($ip, $uiop, $ioflag, $cr););
    }' unless defined(&TRANS_WRITE);
    eval 'sub TRANS_SBUPDATE {
        my($ufsvfsp, $vfsp, $topid) = @_;
	    eval q( &ufs_trans_sbupdate($ufsvfsp, $vfsp, $topid));
    }' unless defined(&TRANS_SBUPDATE);
    eval 'sub TRANS_SYNCIP {
        my($ip, $bflags, $iflag, $topid) = @_;
	    eval q( &ufs_trans_syncip($ip, $bflags, $iflag, $topid));
    }' unless defined(&TRANS_SYNCIP);
    eval 'sub TRANS_SBWRITE {
        my($ufsvfsp, $topid) = @_;
	    eval q( &ufs_trans_sbwrite($ufsvfsp, $topid));
    }' unless defined(&TRANS_SBWRITE);
    eval 'sub TRANS_IUPDAT {
        my($ip, $waitfor) = @_;
	    eval q( &ufs_trans_iupdat($ip, $waitfor));
    }' unless defined(&TRANS_IUPDAT);
    eval 'sub TRANS_DOMATAMAP {
        my($ufsvfsp) = @_;
	    eval q( ($ufsvfsp->{vfs_domatamap}) = ( &TRANS_ISTRANS($ufsvfsp)  &&  ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_mataadd})));
    }' unless defined(&TRANS_DOMATAMAP);
    eval 'sub TRANS_MATA_IGET {
        my($ufsvfsp, $ip) = @_;
	    eval q( &if ( ($ufsvfsp->{vfs_domatamap}))  &ufs_trans_mata_iget($ip));
    }' unless defined(&TRANS_MATA_IGET);
    eval 'sub TRANS_MATA_FREE {
        my($ufsvfsp, $mof, $nb) = @_;
	    eval q( &if ( ($ufsvfsp->{vfs_domatamap}))  &ufs_trans_mata_free($ufsvfsp, ( &offset_t)($mof), $nb));
    }' unless defined(&TRANS_MATA_FREE);
    eval 'sub TRANS_MATA_ALLOC {
        my($ufsvfsp, $ip, $bno, $size, $zero) = @_;
	    eval q( &if ( ($ufsvfsp->{vfs_domatamap}))  &ufs_trans_mata_alloc($ufsvfsp, $ip, $bno, $size, $zero));
    }' unless defined(&TRANS_MATA_ALLOC);
    eval 'sub TRANS_MATA_MOUNT {
        my($ufsvfsp) = @_;
	    eval q( &if ( ($ufsvfsp->{vfs_domatamap}))  &ufs_trans_mata_mount($ufsvfsp));
    }' unless defined(&TRANS_MATA_MOUNT);
    eval 'sub TRANS_MATA_UMOUNT {
        my($ufsvfsp) = @_;
	    eval q( &if ( ($ufsvfsp->{vfs_domatamap}))  &ufs_trans_mata_umount($ufsvfsp));
    }' unless defined(&TRANS_MATA_UMOUNT);
    eval 'sub TRANS_MATA_SI {
        my($ufsvfsp, $fs) = @_;
	    eval q( &if ( ($u$fsvfsp->{v$fs_domatamap}))  &ufs_trans_mata_si($ufsvfsp, $fs));
    }' unless defined(&TRANS_MATA_SI);
    eval 'sub TRANS_MATAADD {
        my($ufsvfsp, $mof, $nb) = @_;
	    eval q((* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_mataadd})) ( ($ufsvfsp->{vfs_trans}), ( &offset_t)($mof), $nb));
    }' unless defined(&TRANS_MATAADD);
    eval 'sub TRANS_MATADEL {
        my($ufsvfsp, $mof, $nb) = @_;
	    eval q((* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_matadel})) ( ($ufsvfsp->{vfs_trans}), ( &offset_t)($mof), $nb));
    }' unless defined(&TRANS_MATADEL);
    eval 'sub TRANS_MATACLR {
        my($ufsvfsp) = @_;
	    eval q((* ($ufsvfsp->{vfs_trans}->{ut_ops}->{trans_mataclr}))( ($ufsvfsp->{vfs_trans})));
    }' unless defined(&TRANS_MATACLR);
    require 'sys/fs/ufs_quota.ph';
    require 'sys/fs/ufs_lockfs.ph';
    eval 'sub TOP_SYNC () {(0x1);}' unless defined(&TOP_SYNC);
    eval 'sub TOP_ASYNC () {(0x2);}' unless defined(&TOP_ASYNC);
    eval 'sub HEADERSIZE () {(128);}' unless defined(&HEADERSIZE);
    eval 'sub ALLOCSIZE () {(160);}' unless defined(&ALLOCSIZE);
    eval 'sub INODESIZE () {($sizeof{\'struct dinode\'} +  &HEADERSIZE);}' unless defined(&INODESIZE);
    eval 'sub SIZESB () {(($sizeof{\'struct fs\'}) +  &HEADERSIZE);}' unless defined(&SIZESB);
    eval 'sub SIZEDIR () {( &DIRBLKSIZ +  &HEADERSIZE);}' unless defined(&SIZEDIR);
    eval 'sub SIZECG {
        my($IP) = @_;
	    eval q((($IP)-> ($i_fs->{fs_cgsize}) +  &HEADERSIZE));
    }' unless defined(&SIZECG);
    eval 'sub FRAGSIZE {
        my($IP) = @_;
	    eval q((($IP)-> ($i_fs->{fs_fsize}) +  &HEADERSIZE));
    }' unless defined(&FRAGSIZE);
    eval 'sub ACLSIZE {
        my($IP) = @_;
	    eval q(((($IP)-> ($i_ufsvfs->{vfs_maxacl}) +  &HEADERSIZE) +  &INODESIZE));
    }' unless defined(&ACLSIZE);
    eval 'sub MAXACLSIZE () {(( &MAX_ACL_ENTRIES << 1) * $sizeof{ &aclent_t});}' unless defined(&MAXACLSIZE);
    eval 'sub DIRSIZE {
        my($IP) = @_;
	    eval q(( &INODESIZE + (4*  &ALLOCSIZE) + ($IP)-> ($i_fs->{fs_fsize}) +  &HEADERSIZE));
    }' unless defined(&DIRSIZE);
    eval 'sub QUOTASIZE () {$sizeof{\'struct dquot\'} +  &HEADERSIZE;}' unless defined(&QUOTASIZE);
    eval 'sub TOP_CREATE_SIZE {
        my($IP) = @_;
	    eval q(( &ACLSIZE($IP) +  &SIZECG($IP) +  &DIRSIZE($IP) +  &INODESIZE));
    }' unless defined(&TOP_CREATE_SIZE);
    eval 'sub TOP_REMOVE_SIZE {
        my($IP) = @_;
	    eval q( &DIRSIZE($IP) +  &SIZECG($IP) +  &INODESIZE +  &SIZESB);
    }' unless defined(&TOP_REMOVE_SIZE);
    eval 'sub TOP_LINK_SIZE {
        my($IP) = @_;
	    eval q( &DIRSIZE($IP) +  &INODESIZE);
    }' unless defined(&TOP_LINK_SIZE);
    eval 'sub TOP_RENAME_SIZE {
        my($IP) = @_;
	    eval q( &DIRSIZE($IP) +  &DIRSIZE($IP) +  &SIZECG($IP));
    }' unless defined(&TOP_RENAME_SIZE);
    eval 'sub TOP_MKDIR_SIZE {
        my($IP) = @_;
	    eval q( &DIRSIZE($IP) +  &INODESIZE +  &DIRSIZE($IP) +  &INODESIZE +  &FRAGSIZE($IP) +  &SIZECG($IP) +  &ACLSIZE($IP));
    }' unless defined(&TOP_MKDIR_SIZE);
    eval 'sub TOP_SYMLINK_SIZE {
        my($IP) = @_;
	    eval q( &DIRSIZE(($IP)) +  &INODESIZE +  &INODESIZE +  &SIZECG($IP));
    }' unless defined(&TOP_SYMLINK_SIZE);
    eval 'sub TOP_GETPAGE_SIZE {
        my($IP) = @_;
	    eval q( &ALLOCSIZE +  &ALLOCSIZE +  &ALLOCSIZE +  &INODESIZE +  &SIZECG($IP));
    }' unless defined(&TOP_GETPAGE_SIZE);
    eval 'sub TOP_SYNCIP_SIZE () { &INODESIZE;}' unless defined(&TOP_SYNCIP_SIZE);
    eval 'sub TOP_FSYNC_SIZE () { &INODESIZE;}' unless defined(&TOP_FSYNC_SIZE);
    eval 'sub TOP_READ_SIZE () { &INODESIZE;}' unless defined(&TOP_READ_SIZE);
    eval 'sub TOP_RMDIR_SIZE () {( &SIZESB + ( &INODESIZE * 2) +  &SIZEDIR);}' unless defined(&TOP_RMDIR_SIZE);
    eval 'sub TOP_SETQUOTA_SIZE {
        my($FS) = @_;
	    eval q((($FS)-> &fs_bsize << 2));
    }' unless defined(&TOP_SETQUOTA_SIZE);
    eval 'sub TOP_QUOTA_SIZE () {( &QUOTASIZE);}' unless defined(&TOP_QUOTA_SIZE);
    eval 'sub TOP_SETSECATTR_SIZE {
        my($IP) = @_;
	    eval q(( &MAXACLSIZE));
    }' unless defined(&TOP_SETSECATTR_SIZE);
    eval 'sub TOP_IUPDAT_SIZE {
        my($IP) = @_;
	    eval q( &INODESIZE +  &SIZECG($IP));
    }' unless defined(&TOP_IUPDAT_SIZE);
    eval 'sub TOP_SBUPDATE_SIZE () {( &SIZESB);}' unless defined(&TOP_SBUPDATE_SIZE);
    eval 'sub TOP_SBWRITE_SIZE () {( &SIZESB);}' unless defined(&TOP_SBWRITE_SIZE);
    eval 'sub TOP_PUTPAGE_SIZE {
        my($IP) = @_;
	    eval q(( &INODESIZE +  &SIZECG($IP)));
    }' unless defined(&TOP_PUTPAGE_SIZE);
    eval 'sub TOP_SETATTR_SIZE {
        my($IP) = @_;
	    eval q(( &SIZECG($IP) +  &INODESIZE +  &QUOTASIZE +  &ACLSIZE($IP)));
    }' unless defined(&TOP_SETATTR_SIZE);
    eval 'sub TOP_IFREE_SIZE {
        my($IP) = @_;
	    eval q(( &SIZECG($IP) +  &INODESIZE +  &QUOTASIZE));
    }' unless defined(&TOP_IFREE_SIZE);
    eval 'sub TOP_MOUNT_SIZE () {( &SIZESB);}' unless defined(&TOP_MOUNT_SIZE);
    eval 'sub TOP_COMMIT_SIZE () {(0);}' unless defined(&TOP_COMMIT_SIZE);
    eval 'sub TOP_MAX_RESV () {(512* 1024);}' unless defined(&TOP_MAX_RESV);
    if(defined( &_KERNEL)  && defined( &__STDC__)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
