require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_HOTPLUG_HPCTRL_H)) {
    eval 'sub _SYS_HOTPLUG_HPCTRL_H () {1;}' unless defined(&_SYS_HOTPLUG_HPCTRL_H);
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub HPC_SLOT_OPS_VERSION () {0;}' unless defined(&HPC_SLOT_OPS_VERSION);
    eval 'sub HPC_SLOT_INFO_VERSION () {0;}' unless defined(&HPC_SLOT_INFO_VERSION);
    eval 'sub PCI_SLOT_NAME_LEN () {256;}' unless defined(&PCI_SLOT_NAME_LEN);
    eval 'sub pci_dev_num () { ($slot->{pci}->{device_number});}' unless defined(&pci_dev_num);
    eval 'sub pci_slot_name () { ($slot->{pci}->{slot_logical_name});}' unless defined(&pci_slot_name);
    eval 'sub pci_slot_capabilities () { ($slot->{pci}->{slot_capabilities});}' unless defined(&pci_slot_capabilities);
    eval 'sub sbd_slot_num () { ($slot->{sbd}->{slot_num});}' unless defined(&sbd_slot_num);
    eval 'sub HPC_SLOT_TYPE_PCI () {0x1;}' unless defined(&HPC_SLOT_TYPE_PCI);
    eval 'sub HPC_SLOT_TYPE_CPCI () {0x2;}' unless defined(&HPC_SLOT_TYPE_CPCI);
    eval 'sub HPC_SLOT_TYPE_SBD () {0x3;}' unless defined(&HPC_SLOT_TYPE_SBD);
    eval 'sub HPC_SLOT_64BITS () {0x1;}' unless defined(&HPC_SLOT_64BITS);
    eval 'sub HPC_SLOT_TEST () {0x2;}' unless defined(&HPC_SLOT_TEST);
    eval 'sub HPC_CTRL_GET_LED_STATE () {0x1;}' unless defined(&HPC_CTRL_GET_LED_STATE);
    eval 'sub HPC_CTRL_SET_LED_STATE () {0x2;}' unless defined(&HPC_CTRL_SET_LED_STATE);
    eval 'sub HPC_CTRL_GET_SLOT_STATE () {0x3;}' unless defined(&HPC_CTRL_GET_SLOT_STATE);
    eval 'sub HPC_CTRL_DEV_CONFIGURED () {0x4;}' unless defined(&HPC_CTRL_DEV_CONFIGURED);
    eval 'sub HPC_CTRL_DEV_UNCONFIGURED () {0x5;}' unless defined(&HPC_CTRL_DEV_UNCONFIGURED);
    eval 'sub HPC_CTRL_GET_BOARD_TYPE () {0x6;}' unless defined(&HPC_CTRL_GET_BOARD_TYPE);
    eval 'sub HPC_CTRL_DISABLE_AUTOCFG () {0x7;}' unless defined(&HPC_CTRL_DISABLE_AUTOCFG);
    eval 'sub HPC_CTRL_ENABLE_AUTOCFG () {0x8;}' unless defined(&HPC_CTRL_ENABLE_AUTOCFG);
    eval 'sub HPC_CTRL_DISABLE_SLOT () {0x9;}' unless defined(&HPC_CTRL_DISABLE_SLOT);
    eval 'sub HPC_CTRL_ENABLE_SLOT () {0xa;}' unless defined(&HPC_CTRL_ENABLE_SLOT);
    eval 'sub HPC_CTRL_DISABLE_ENUM () {0xb;}' unless defined(&HPC_CTRL_DISABLE_ENUM);
    eval 'sub HPC_CTRL_ENABLE_ENUM () {0xc;}' unless defined(&HPC_CTRL_ENABLE_ENUM);
    eval 'sub HPC_CTRL_DEV_CONFIG_FAILURE () {0xd;}' unless defined(&HPC_CTRL_DEV_CONFIG_FAILURE);
    eval 'sub HPC_CTRL_DEV_UNCONFIG_FAILURE () {0xe;}' unless defined(&HPC_CTRL_DEV_UNCONFIG_FAILURE);
    eval 'sub HPC_CTRL_DEV_CONFIG_START () {0xf;}' unless defined(&HPC_CTRL_DEV_CONFIG_START);
    eval 'sub HPC_CTRL_DEV_UNCONFIG_START () {0x10;}' unless defined(&HPC_CTRL_DEV_UNCONFIG_START);
    eval("sub HPC_FAULT_LED () { 0; }") unless defined(&HPC_FAULT_LED);
    eval("sub HPC_POWER_LED () { 1; }") unless defined(&HPC_POWER_LED);
    eval("sub HPC_ATTN_LED () { 2; }") unless defined(&HPC_ATTN_LED);
    eval("sub HPC_ACTIVE_LED () { 3; }") unless defined(&HPC_ACTIVE_LED);
    eval("sub HPC_LED_OFF () { 0; }") unless defined(&HPC_LED_OFF);
    eval("sub HPC_LED_ON () { 1; }") unless defined(&HPC_LED_ON);
    eval("sub HPC_LED_BLINK () { 2; }") unless defined(&HPC_LED_BLINK);
    eval("sub HPC_SLOT_EMPTY () { 0; }") unless defined(&HPC_SLOT_EMPTY);
    eval("sub HPC_SLOT_DISCONNECTED () { 1; }") unless defined(&HPC_SLOT_DISCONNECTED);
    eval("sub HPC_SLOT_CONNECTED () { 2; }") unless defined(&HPC_SLOT_CONNECTED);
    eval("sub HPC_SLOT_UNKNOWN () { 3; }") unless defined(&HPC_SLOT_UNKNOWN);
    eval("sub HPC_BOARD_UNKNOWN () { 0; }") unless defined(&HPC_BOARD_UNKNOWN);
    eval("sub HPC_BOARD_PCI_HOTPLUG () { 1; }") unless defined(&HPC_BOARD_PCI_HOTPLUG);
    eval("sub HPC_BOARD_CPCI_NON_HS () { 2; }") unless defined(&HPC_BOARD_CPCI_NON_HS);
    eval("sub HPC_BOARD_CPCI_BASIC_HS () { 3; }") unless defined(&HPC_BOARD_CPCI_BASIC_HS);
    eval("sub HPC_BOARD_CPCI_FULL_HS () { 4; }") unless defined(&HPC_BOARD_CPCI_FULL_HS);
    eval("sub HPC_BOARD_CPCI_HS () { 5; }") unless defined(&HPC_BOARD_CPCI_HS);
    eval 'sub HPC_EVENT_SLOT_INSERTION () {0x1;}' unless defined(&HPC_EVENT_SLOT_INSERTION);
    eval 'sub HPC_EVENT_SLOT_REMOVAL () {0x2;}' unless defined(&HPC_EVENT_SLOT_REMOVAL);
    eval 'sub HPC_EVENT_SLOT_POWER_ON () {0x4;}' unless defined(&HPC_EVENT_SLOT_POWER_ON);
    eval 'sub HPC_EVENT_SLOT_POWER_OFF () {0x8;}' unless defined(&HPC_EVENT_SLOT_POWER_OFF);
    eval 'sub HPC_EVENT_SLOT_LATCH_OPEN () {0x10;}' unless defined(&HPC_EVENT_SLOT_LATCH_OPEN);
    eval 'sub HPC_EVENT_SLOT_LATCH_SHUT () {0x20;}' unless defined(&HPC_EVENT_SLOT_LATCH_SHUT);
    eval 'sub HPC_EVENT_SLOT_ENUM () {0x40;}' unless defined(&HPC_EVENT_SLOT_ENUM);
    eval 'sub HPC_EVENT_SLOT_NOT_HEALTHY () {0x80;}' unless defined(&HPC_EVENT_SLOT_NOT_HEALTHY);
    eval 'sub HPC_EVENT_SLOT_HEALTHY_OK () {0x100;}' unless defined(&HPC_EVENT_SLOT_HEALTHY_OK);
    eval 'sub HPC_EVENT_SLOT_CONFIGURE () {0x200;}' unless defined(&HPC_EVENT_SLOT_CONFIGURE);
    eval 'sub HPC_EVENT_SLOT_UNCONFIGURE () {0x400;}' unless defined(&HPC_EVENT_SLOT_UNCONFIGURE);
    eval 'sub HPC_EVENT_SLOT_BLUE_LED_ON () {0x800;}' unless defined(&HPC_EVENT_SLOT_BLUE_LED_ON);
    eval 'sub HPC_EVENT_SLOT_BLUE_LED_OFF () {0x1000;}' unless defined(&HPC_EVENT_SLOT_BLUE_LED_OFF);
    eval 'sub HPC_EVENT_CLEAR_ENUM () {0x2000;}' unless defined(&HPC_EVENT_CLEAR_ENUM);
    eval 'sub HPC_EVENT_PROCESS_ENUM () {0x4000;}' unless defined(&HPC_EVENT_PROCESS_ENUM);
    eval 'sub HPC_EVENT_ENABLE_ENUM () {0x8000;}' unless defined(&HPC_EVENT_ENABLE_ENUM);
    eval 'sub HPC_EVENT_DISABLE_ENUM () {0x10000;}' unless defined(&HPC_EVENT_DISABLE_ENUM);
    eval 'sub HPC_EVENT_BUS_ENUM () { &HPC_EVENT_SLOT_ENUM;}' unless defined(&HPC_EVENT_BUS_ENUM);
    eval 'sub HPC_SUCCESS () {0x;}' unless defined(&HPC_SUCCESS);
    eval 'sub HPC_ERR_INVALID () {0x1;}' unless defined(&HPC_ERR_INVALID);
    eval 'sub HPC_ERR_SLOT_NOTREGISTERED () {0x2;}' unless defined(&HPC_ERR_SLOT_NOTREGISTERED);
    eval 'sub HPC_ERR_SLOT_DUPLICATE () {0x3;}' unless defined(&HPC_ERR_SLOT_DUPLICATE);
    eval 'sub HPC_ERR_BUS_NOTREGISTERED () {0x4;}' unless defined(&HPC_ERR_BUS_NOTREGISTERED);
    eval 'sub HPC_ERR_BUS_DUPLICATE () {0x5;}' unless defined(&HPC_ERR_BUS_DUPLICATE);
    eval 'sub HPC_ERR_NOTSUPPORTED () {0x6;}' unless defined(&HPC_ERR_NOTSUPPORTED);
    eval 'sub HPC_ERR_FAILED () {0x7;}' unless defined(&HPC_ERR_FAILED);
    eval 'sub HPC_EVENT_CLAIMED () {0x10;}' unless defined(&HPC_EVENT_CLAIMED);
    eval 'sub HPC_EVENT_UNCLAIMED () {-1;}' unless defined(&HPC_EVENT_UNCLAIMED);
    eval 'sub HPC_SLOT_ONLINE () {1;}' unless defined(&HPC_SLOT_ONLINE);
    eval 'sub HPC_SLOT_OFFLINE () {2;}' unless defined(&HPC_SLOT_OFFLINE);
    if(defined(&__STDC__)) {
    } else {
    }
    eval 'sub HPC_CTRL_GET_SLOT_INFO () {0x100;}' unless defined(&HPC_CTRL_GET_SLOT_INFO);
    eval 'sub HPC_CTRL_GET_CARD_INFO () {0x101;}' unless defined(&HPC_CTRL_GET_CARD_INFO);
    eval 'sub HPC_CTRL_GET_SLOT_OCCUPANTS () {0x102;}' unless defined(&HPC_CTRL_GET_SLOT_OCCUPANTS);
    eval 'sub HPC_MAX_OCCUPANTS () {128;}' unless defined(&HPC_MAX_OCCUPANTS);
    if(defined(&__cplusplus)) {
    }
}
1;
