require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_INT_LIMITS_H)) {
    eval 'sub _SYS_INT_LIMITS_H () {1;}' unless defined(&_SYS_INT_LIMITS_H);
    require 'sys/isa_defs.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &_CHAR_IS_SIGNED) || defined( &__STDC__)) {
	eval 'sub INT8_MAX () {(127);}' unless defined(&INT8_MAX);
    }
    eval 'sub INT16_MAX () {(32767);}' unless defined(&INT16_MAX);
    eval 'sub INT32_MAX () {(2147483647);}' unless defined(&INT32_MAX);
    if(defined( &_LP64) || ((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_NO_LONGLONG))) {
	eval 'sub INT64_MAX () {(9223372036854775807);}' unless defined(&INT64_MAX);
    }
    eval 'sub UINT8_MAX () {(255);}' unless defined(&UINT8_MAX);
    eval 'sub UINT16_MAX () {(65535);}' unless defined(&UINT16_MAX);
    eval 'sub UINT32_MAX () {(4294967295);}' unless defined(&UINT32_MAX);
    if(defined( &_LP64) || ((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_NO_LONGLONG))) {
	eval 'sub UINT64_MAX () {(18446744073709551615);}' unless defined(&UINT64_MAX);
    }
    if(defined(&INT64_MAX)) {
	eval 'sub INTMAX_MAX () { &INT64_MAX;}' unless defined(&INTMAX_MAX);
    } else {
	eval 'sub INTMAX_MAX () { &INT32_MAX;}' unless defined(&INTMAX_MAX);
    }
    if(defined(&UINT64_MAX)) {
	eval 'sub UINTMAX_MAX () { &UINT64_MAX;}' unless defined(&UINTMAX_MAX);
    } else {
	eval 'sub UINTMAX_MAX () { &UINT32_MAX;}' unless defined(&UINTMAX_MAX);
    }
    if(defined( &_CHAR_IS_SIGNED) || defined( &__STDC__)) {
	eval 'sub INT_LEAST8_MAX () { &INT8_MAX;}' unless defined(&INT_LEAST8_MAX);
    }
    eval 'sub INT_LEAST16_MAX () { &INT16_MAX;}' unless defined(&INT_LEAST16_MAX);
    eval 'sub INT_LEAST32_MAX () { &INT32_MAX;}' unless defined(&INT_LEAST32_MAX);
    if(defined(&INT64_MAX)) {
	eval 'sub INT_LEAST64_MAX () { &INT64_MAX;}' unless defined(&INT_LEAST64_MAX);
    }
    eval 'sub UINT_LEAST8_MAX () { &UINT8_MAX;}' unless defined(&UINT_LEAST8_MAX);
    eval 'sub UINT_LEAST16_MAX () { &UINT16_MAX;}' unless defined(&UINT_LEAST16_MAX);
    eval 'sub UINT_LEAST32_MAX () { &UINT32_MAX;}' unless defined(&UINT_LEAST32_MAX);
    if(defined(&UINT64_MAX)) {
	eval 'sub UINT_LEAST64_MAX () { &UINT64_MAX;}' unless defined(&UINT_LEAST64_MAX);
    }
    eval 'sub INTPTR_MAX () {1;}' unless defined(&INTPTR_MAX);
    eval 'sub UINTPTR_MAX () {1;}' unless defined(&UINTPTR_MAX);
    if(defined( &__EXTENSIONS__) || (!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE))) {
	if(defined( &_CHAR_IS_SIGNED) || defined( &__STDC__)) {
	    eval 'sub INT8_MIN () {(-128);}' unless defined(&INT8_MIN);
	}
	eval 'sub INT16_MIN () {(-32767-1);}' unless defined(&INT16_MIN);
	eval 'sub INT32_MIN () {(-2147483647-1);}' unless defined(&INT32_MIN);
	if(defined( &_LP64) || ((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_NO_LONGLONG))) {
	    eval 'sub INT64_MIN () {(-9223372036854775807-1);}' unless defined(&INT64_MIN);
	}
	if(defined(&INT64_MIN)) {
	    eval 'sub INTMAX_MIN () { &INT64_MIN;}' unless defined(&INTMAX_MIN);
	} else {
	    eval 'sub INTMAX_MIN () { &INT32_MIN;}' unless defined(&INTMAX_MIN);
	}
	if(defined( &_CHAR_IS_SIGNED) || defined( &__STDC__)) {
	    eval 'sub INT_LEAST8_MIN () { &INT8_MIN;}' unless defined(&INT_LEAST8_MIN);
	}
	eval 'sub INT_LEAST16_MIN () { &INT16_MIN;}' unless defined(&INT_LEAST16_MIN);
	eval 'sub INT_LEAST32_MIN () { &INT32_MIN;}' unless defined(&INT_LEAST32_MIN);
	if(defined(&INT64_MIN)) {
	    eval 'sub INT_LEAST64_MIN () { &INT64_MIN;}' unless defined(&INT_LEAST64_MIN);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
