require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_KBD_H)) {
    eval 'sub _SYS_KBD_H () {1;}' unless defined(&_SYS_KBD_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub KB_KLUNK () {0x;}' unless defined(&KB_KLUNK);
    eval 'sub KB_VT100 () {0x1;}' unless defined(&KB_VT100);
    eval 'sub KB_SUN2 () {0x2;}' unless defined(&KB_SUN2);
    eval 'sub KB_VT220 () {0x81;}' unless defined(&KB_VT220);
    eval 'sub KB_VT220I () {0x82;}' unless defined(&KB_VT220I);
    eval 'sub NOTPRESENT () {0xff;}' unless defined(&NOTPRESENT);
    eval 'sub KBD_CMD_LED1 () {0x4;}' unless defined(&KBD_CMD_LED1);
    eval 'sub KBD_CMD_NOLED1 () {0x5;}' unless defined(&KBD_CMD_NOLED1);
    eval 'sub KBD_CMD_LED2 () {0x6;}' unless defined(&KBD_CMD_LED2);
    eval 'sub KBD_CMD_NOLED2 () {0x7;}' unless defined(&KBD_CMD_NOLED2);
    eval 'sub CTLSMASK () {0x100;}' unless defined(&CTLSMASK);
    eval 'sub NOSCROLL () {0x303;}' unless defined(&NOSCROLL);
    eval 'sub CTRLS () {0x304;}' unless defined(&CTRLS);
    eval 'sub CTRLQ () {0x305;}' unless defined(&CTRLQ);
    eval 'sub KB_SUN3 () {3;}' unless defined(&KB_SUN3);
    eval 'sub KB_SUN4 () {4;}' unless defined(&KB_SUN4);
    eval 'sub KB_USB () {6;}' unless defined(&KB_USB);
    eval 'sub KB_PC () {101;}' unless defined(&KB_PC);
    eval 'sub KB_ASCII () {0xf;}' unless defined(&KB_ASCII);
    eval 'sub IDLEKEY () {0x7f;}' unless defined(&IDLEKEY);
    eval 'sub ERRORKEY () {0x7e;}' unless defined(&ERRORKEY);
    eval 'sub RESETKEY () {0xff;}' unless defined(&RESETKEY);
    eval 'sub LAYOUTKEY () {0xfe;}' unless defined(&LAYOUTKEY);
    eval 'sub PRESSED () {0x;}' unless defined(&PRESSED);
    eval 'sub RELEASED () {0x80;}' unless defined(&RELEASED);
    eval 'sub KBD_CMD_RESET () {0x1;}' unless defined(&KBD_CMD_RESET);
    eval 'sub KBD_CMD_BELL () {0x2;}' unless defined(&KBD_CMD_BELL);
    eval 'sub KBD_CMD_NOBELL () {0x3;}' unless defined(&KBD_CMD_NOBELL);
    eval 'sub KBD_CMD_CLICK () {0xa;}' unless defined(&KBD_CMD_CLICK);
    eval 'sub KBD_CMD_NOCLICK () {0xb;}' unless defined(&KBD_CMD_NOCLICK);
    eval 'sub KBD_CMD_AUTOTEST () {0xc;}' unless defined(&KBD_CMD_AUTOTEST);
    eval 'sub KBD_CMD_SETLED () {0xe;}' unless defined(&KBD_CMD_SETLED);
    eval 'sub KBD_CMD_GETLAYOUT () {0xf;}' unless defined(&KBD_CMD_GETLAYOUT);
    eval 'sub LED_NUM_LOCK () {0x1;}' unless defined(&LED_NUM_LOCK);
    eval 'sub LED_COMPOSE () {0x2;}' unless defined(&LED_COMPOSE);
    eval 'sub LED_SCROLL_LOCK () {0x4;}' unless defined(&LED_SCROLL_LOCK);
    eval 'sub LED_CAPS_LOCK () {0x8;}' unless defined(&LED_CAPS_LOCK);
    eval 'sub LED_KANA () {0x10;}' unless defined(&LED_KANA);
    eval 'sub NORMAL () {0;}' unless defined(&NORMAL);
    eval 'sub ABORT1 () {1;}' unless defined(&ABORT1);
    eval 'sub COMPOSE1 () {2;}' unless defined(&COMPOSE1);
    eval 'sub COMPOSE2 () {3;}' unless defined(&COMPOSE2);
    eval 'sub FLTACCENT () {4;}' unless defined(&FLTACCENT);
    eval 'sub ASCII_SET_SIZE () {128;}' unless defined(&ASCII_SET_SIZE);
    eval 'sub TR_NONE () {0;}' unless defined(&TR_NONE);
    eval 'sub TR_ASCII () {1;}' unless defined(&TR_ASCII);
    eval 'sub TR_EVENT () {2;}' unless defined(&TR_EVENT);
    eval 'sub TR_UNTRANS_EVENT () {3;}' unless defined(&TR_UNTRANS_EVENT);
    eval 'sub BUILDKEY {
        my($key, $state) = @_;
	    eval q(($key | $state));
    }' unless defined(&BUILDKEY);
    eval 'sub STATEOF {
        my($key) = @_;
	    eval q((($key) &  &RELEASED));
    }' unless defined(&STATEOF);
    eval 'sub KEYOF {
        my($key) = @_;
	    eval q((($key) & ~ &RELEASED));
    }' unless defined(&KEYOF);
    eval 'sub NOKEY () {(-1);}' unless defined(&NOKEY);
    eval 'sub METABIT () {0;}' unless defined(&METABIT);
    eval 'sub METAMASK () {0x80;}' unless defined(&METAMASK);
    eval 'sub SYSTEMBIT () {1;}' unless defined(&SYSTEMBIT);
    eval 'sub SYSTEMMASK () {0x100;}' unless defined(&SYSTEMMASK);
    eval 'sub CAPSLOCK () {0;}' unless defined(&CAPSLOCK);
    eval 'sub CAPSMASK () {0x1;}' unless defined(&CAPSMASK);
    eval 'sub SHIFTLOCK () {1;}' unless defined(&SHIFTLOCK);
    eval 'sub LEFTSHIFT () {2;}' unless defined(&LEFTSHIFT);
    eval 'sub RIGHTSHIFT () {3;}' unless defined(&RIGHTSHIFT);
    eval 'sub SHIFTMASK () {0xe;}' unless defined(&SHIFTMASK);
    eval 'sub LEFTCTRL () {4;}' unless defined(&LEFTCTRL);
    eval 'sub RIGHTCTRL () {5;}' unless defined(&RIGHTCTRL);
    eval 'sub CTRLMASK () {0x30;}' unless defined(&CTRLMASK);
    eval 'sub ALTGRAPH () {9;}' unless defined(&ALTGRAPH);
    eval 'sub ALTGRAPHMASK () {0x200;}' unless defined(&ALTGRAPHMASK);
    eval 'sub ALT () {10;}' unless defined(&ALT);
    eval 'sub LEFTALT () {10;}' unless defined(&LEFTALT);
    eval 'sub ALTMASK () {0x1400;}' unless defined(&ALTMASK);
    eval 'sub NUMLOCK () {11;}' unless defined(&NUMLOCK);
    eval 'sub NUMLOCKMASK () {0x800;}' unless defined(&NUMLOCKMASK);
    eval 'sub RIGHTALT () {12;}' unless defined(&RIGHTALT);
    eval 'sub UPMASK () {0x80;}' unless defined(&UPMASK);
    if(defined(&KEYMAP_SIZE_VARIABLE)) {
    } else {
	eval 'sub KEYMAP_SIZE () {128;}' unless defined(&KEYMAP_SIZE);
    }
    if(defined(&KEYMAP_SIZE_VARIABLE)) {
    } else {
    }
    eval 'sub SHIFTKEYS () {0x100;}' unless defined(&SHIFTKEYS);
    eval 'sub BUCKYBITS () {0x200;}' unless defined(&BUCKYBITS);
    eval 'sub FUNNY () {0x300;}' unless defined(&FUNNY);
    eval 'sub NOP () {0x300;}' unless defined(&NOP);
    eval 'sub OOPS () {0x301;}' unless defined(&OOPS);
    eval 'sub HOLE () {0x302;}' unless defined(&HOLE);
    eval 'sub RESET () {0x306;}' unless defined(&RESET);
    eval 'sub ERROR () {0x307;}' unless defined(&ERROR);
    eval 'sub IDLE () {0x308;}' unless defined(&IDLE);
    eval 'sub COMPOSE () {0x309;}' unless defined(&COMPOSE);
    eval 'sub NONL () {0x30a;}' unless defined(&NONL);
    eval 'sub FA_CLASS () {0x400;}' unless defined(&FA_CLASS);
    eval 'sub FA_UMLAUT () {0x400;}' unless defined(&FA_UMLAUT);
    eval 'sub FA_CFLEX () {0x401;}' unless defined(&FA_CFLEX);
    eval 'sub FA_TILDE () {0x402;}' unless defined(&FA_TILDE);
    eval 'sub FA_CEDILLA () {0x403;}' unless defined(&FA_CEDILLA);
    eval 'sub FA_ACUTE () {0x404;}' unless defined(&FA_ACUTE);
    eval 'sub FA_GRAVE () {0x405;}' unless defined(&FA_GRAVE);
    eval 'sub STRING () {0x500;}' unless defined(&STRING);
    eval 'sub KTAB_STRLEN () {10;}' unless defined(&KTAB_STRLEN);
    eval 'sub HOMEARROW () {0x;}' unless defined(&HOMEARROW);
    eval 'sub UPARROW () {0x1;}' unless defined(&UPARROW);
    eval 'sub DOWNARROW () {0x2;}' unless defined(&DOWNARROW);
    eval 'sub LEFTARROW () {0x3;}' unless defined(&LEFTARROW);
    eval 'sub RIGHTARROW () {0x4;}' unless defined(&RIGHTARROW);
    eval 'sub FUNCKEYS () {0x600;}' unless defined(&FUNCKEYS);
    eval 'sub LEFTFUNC () {0x600;}' unless defined(&LEFTFUNC);
    eval 'sub RIGHTFUNC () {0x610;}' unless defined(&RIGHTFUNC);
    eval 'sub TOPFUNC () {0x620;}' unless defined(&TOPFUNC);
    eval 'sub BOTTOMFUNC () {0x630;}' unless defined(&BOTTOMFUNC);
    eval 'sub LF {
        my($n) = @_;
	    eval q(( &LEFTFUNC+($n)-1));
    }' unless defined(&LF);
    eval 'sub RF {
        my($n) = @_;
	    eval q(( &RIGHTFUNC+($n)-1));
    }' unless defined(&RF);
    eval 'sub TF {
        my($n) = @_;
	    eval q(( &TOPFUNC+($n)-1));
    }' unless defined(&TF);
    eval 'sub BF {
        my($n) = @_;
	    eval q(( &BOTTOMFUNC+($n)-1));
    }' unless defined(&BF);
    eval 'sub PADKEYS () {0x700;}' unless defined(&PADKEYS);
    eval 'sub PADEQUAL () {0x700;}' unless defined(&PADEQUAL);
    eval 'sub PADSLASH () {0x701;}' unless defined(&PADSLASH);
    eval 'sub PADSTAR () {0x702;}' unless defined(&PADSTAR);
    eval 'sub PADMINUS () {0x703;}' unless defined(&PADMINUS);
    eval 'sub PADSEP () {0x704;}' unless defined(&PADSEP);
    eval 'sub PAD7 () {0x705;}' unless defined(&PAD7);
    eval 'sub PAD8 () {0x706;}' unless defined(&PAD8);
    eval 'sub PAD9 () {0x707;}' unless defined(&PAD9);
    eval 'sub PADPLUS () {0x708;}' unless defined(&PADPLUS);
    eval 'sub PAD4 () {0x709;}' unless defined(&PAD4);
    eval 'sub PAD5 () {0x70a;}' unless defined(&PAD5);
    eval 'sub PAD6 () {0x70b;}' unless defined(&PAD6);
    eval 'sub PAD1 () {0x70c;}' unless defined(&PAD1);
    eval 'sub PAD2 () {0x70d;}' unless defined(&PAD2);
    eval 'sub PAD3 () {0x70e;}' unless defined(&PAD3);
    eval 'sub PAD0 () {0x70f;}' unless defined(&PAD0);
    eval 'sub PADDOT () {0x710;}' unless defined(&PADDOT);
    eval 'sub PADENTER () {0x711;}' unless defined(&PADENTER);
    if(defined(&__cplusplus)) {
    }
}
1;
