require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_KOBJ_H)) {
    eval 'sub _SYS_KOBJ_H () {1;}' unless defined(&_SYS_KOBJ_H);
    require 'sys/modctl.ph';
    require 'sys/elf.ph';
    require 'sys/machelf.ph';
    require 'sys/vmem.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined( &__ia64)) {
    } else {
    }
    eval 'sub kobj_filename {
        my($p) = @_;
	    eval q((($p)-> &_name));
    }' unless defined(&kobj_filename);
    eval 'sub kobj_linenum {
        my($p) = @_;
	    eval q((($p)-> &_ln));
    }' unless defined(&kobj_linenum);
    eval 'sub kobj_newline {
        my($p) = @_;
	    eval q((($p)-> &_ln++));
    }' unless defined(&kobj_newline);
    eval 'sub kobj_getc {
        my($p) = @_;
	    eval q((--($p)-> &_cnt >= 0? (*($p)-> &_ptr++): &kobj_filbuf($p)));
    }' unless defined(&kobj_getc);
    eval 'sub kobj_ungetc {
        my($p) = @_;
	    eval q((++($p)-> &_cnt > ($p)-> &_size ? -1: (*(--($p)-> &_ptr))));
    }' unless defined(&kobj_ungetc);
    eval 'sub B_OFFSET {
        my($f_offset) = @_;
	    eval q(($f_offset & ( &MAXBSIZE-1)));
    }' unless defined(&B_OFFSET);
    eval 'sub F_PAGE {
        my($f_offset) = @_;
	    eval q(($f_offset & ~( &MAXBSIZE-1)));
    }' unless defined(&F_PAGE);
    if(defined( &_KERNEL)) {
	if(defined( &i386) || ((defined(&__sparc) ? &__sparc : 0))) {
	}
 elsif(defined( &__ia64)) {
	} else {
	    die("ISA not supported");
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
