require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_LDTERM_H)) {
    eval 'sub _SYS_LDTERM_H () {1;}' unless defined(&_SYS_LDTERM_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub IBSIZE () {16;}' unless defined(&IBSIZE);
    eval 'sub OBSIZE () {64;}' unless defined(&OBSIZE);
    eval 'sub EBSIZE () {16;}' unless defined(&EBSIZE);
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    my($a, $b) = @_;
    	    eval q(((($a) < ($b)) ? ($a) : ($b)));
	}' unless defined(&MIN);
    }
    eval 'sub V_MIN () { ($tp->{t_modes}->{c_cc[&VMIN]});}' unless defined(&V_MIN);
    eval 'sub V_TIME () { ($tp->{t_modes}->{c_cc[&VTIME]});}' unless defined(&V_TIME);
    eval 'sub RAW_MODE () {!( ($tp->{t_modes}->{c_lflag}) &  &ICANON);}' unless defined(&RAW_MODE);
    eval 'sub CANON_MODE () {( ($tp->{t_modes}->{c_lflag}) &  &ICANON);}' unless defined(&CANON_MODE);
    eval 'sub TTXOLO () {132;}' unless defined(&TTXOLO);
    eval 'sub TTXOHI () {180;}' unless defined(&TTXOHI);
    eval 'sub HIWAT () {1024;}' unless defined(&HIWAT);
    eval 'sub LOWAT () {200;}' unless defined(&LOWAT);
    eval 'sub LDCHUNK () {512;}' unless defined(&LDCHUNK);
    eval 'sub EUCSIZE () {$sizeof{\'struct eucioc\'};}' unless defined(&EUCSIZE);
    eval 'sub EUCIN () {0;}' unless defined(&EUCIN);
    eval 'sub EUCOUT () {1;}' unless defined(&EUCOUT);
    eval 'sub EUC_TWIDTH () {255;}' unless defined(&EUC_TWIDTH);
    eval 'sub EUC_BSWIDTH () {254;}' unless defined(&EUC_BSWIDTH);
    eval 'sub EUC_NLWIDTH () {253;}' unless defined(&EUC_NLWIDTH);
    eval 'sub EUC_CRWIDTH () {252;}' unless defined(&EUC_CRWIDTH);
    eval 'sub UNKNOWN_WIDTH () {251;}' unless defined(&UNKNOWN_WIDTH);
    eval 'sub EUC_MAXW () {4;}' unless defined(&EUC_MAXW);
    eval 'sub EUC_WARNCNT () {20;}' unless defined(&EUC_WARNCNT);
    eval 'sub LDTERM_DATA_VERSION () {1;}' unless defined(&LDTERM_DATA_VERSION);
    eval 'sub LDTERM_CS_TYPE_MIN () {1;}' unless defined(&LDTERM_CS_TYPE_MIN);
    eval 'sub LDTERM_CS_TYPE_EUC () {1;}' unless defined(&LDTERM_CS_TYPE_EUC);
    eval 'sub LDTERM_CS_TYPE_PCCS () {2;}' unless defined(&LDTERM_CS_TYPE_PCCS);
    eval 'sub LDTERM_CS_TYPE_UTF8 () {3;}' unless defined(&LDTERM_CS_TYPE_UTF8);
    eval 'sub LDTERM_CS_TYPE_MAX () {3;}' unless defined(&LDTERM_CS_TYPE_MAX);
    eval 'sub LDTERM_CS_MAX_BYTE_LENGTH () {8;}' unless defined(&LDTERM_CS_MAX_BYTE_LENGTH);
    eval 'sub LDTERM_CS_MAX_CODESETS () {10;}' unless defined(&LDTERM_CS_MAX_CODESETS);
    eval 'sub LDTERM_CS_TYPE_EUC_MIN_SUBCS () {0;}' unless defined(&LDTERM_CS_TYPE_EUC_MIN_SUBCS);
    eval 'sub LDTERM_CS_TYPE_EUC_MAX_SUBCS () {3;}' unless defined(&LDTERM_CS_TYPE_EUC_MAX_SUBCS);
    eval 'sub LDTERM_CS_TYPE_PCCS_MIN_SUBCS () {1;}' unless defined(&LDTERM_CS_TYPE_PCCS_MIN_SUBCS);
    eval 'sub LDTERM_CS_TYPE_PCCS_MAX_SUBCS () { &LDTERM_CS_MAX_CODESETS;}' unless defined(&LDTERM_CS_TYPE_PCCS_MAX_SUBCS);
    eval 'sub LDTERM_CS_TYPE_UTF8_MIN_BYTE () {0x80;}' unless defined(&LDTERM_CS_TYPE_UTF8_MIN_BYTE);
    eval 'sub LDTERM_CS_TYPE_UTF8_MAX_BYTE () {0xbf;}' unless defined(&LDTERM_CS_TYPE_UTF8_MAX_BYTE);
    eval 'sub LDTERM_CS_TYPE_UTF8_MIN_P14 () {0xe0000;}' unless defined(&LDTERM_CS_TYPE_UTF8_MIN_P14);
    eval 'sub LDTERM_CS_TYPE_UTF8_MAX_P14 () {0xe007f;}' unless defined(&LDTERM_CS_TYPE_UTF8_MAX_P14);
    eval 'sub LDTERM_CS_TYPE_UTF8_SHIFT_BITS () {6;}' unless defined(&LDTERM_CS_TYPE_UTF8_SHIFT_BITS);
    eval 'sub LDTERM_CS_TYPE_UTF8_BIT_MASK () {0x3f;}' unless defined(&LDTERM_CS_TYPE_UTF8_BIT_MASK);
    eval 'sub TS_XCLUDE () {0x1;}' unless defined(&TS_XCLUDE);
    eval 'sub TS_TTSTOP () {0x2;}' unless defined(&TS_TTSTOP);
    eval 'sub TS_TBLOCK () {0x4;}' unless defined(&TS_TBLOCK);
    eval 'sub TS_QUOT () {0x8;}' unless defined(&TS_QUOT);
    eval 'sub TS_ERASE () {0x10;}' unless defined(&TS_ERASE);
    eval 'sub TS_SLNCH () {0x20;}' unless defined(&TS_SLNCH);
    eval 'sub TS_PLNCH () {0x40;}' unless defined(&TS_PLNCH);
    eval 'sub TS_TTCR () {0x80;}' unless defined(&TS_TTCR);
    eval 'sub TS_NOCANON () {0x100;}' unless defined(&TS_NOCANON);
    eval 'sub TS_RESCAN () {0x400;}' unless defined(&TS_RESCAN);
    eval 'sub TS_MREAD () {0x800;}' unless defined(&TS_MREAD);
    eval 'sub TS_FLUSHWAIT () {0x1000;}' unless defined(&TS_FLUSHWAIT);
    eval 'sub TS_MEUC () {0x10000;}' unless defined(&TS_MEUC);
    eval 'sub TS_WARNED () {0x20000;}' unless defined(&TS_WARNED);
    eval 'sub TS_CLOSE () {0x40000;}' unless defined(&TS_CLOSE);
    eval 'sub TS_IOCWAIT () {0x80000;}' unless defined(&TS_IOCWAIT);
    eval 'sub TS_IFBLOCK () {0x100000;}' unless defined(&TS_IFBLOCK);
    eval 'sub TS_OFBLOCK () {0x200000;}' unless defined(&TS_OFBLOCK);
    eval 'sub TS_ISPTSTTY () {0x400000;}' unless defined(&TS_ISPTSTTY);
    eval 'sub ORDINARY () {0;}' unless defined(&ORDINARY);
    eval 'sub CONTROL () {1;}' unless defined(&CONTROL);
    eval 'sub BACKSPACE () {2;}' unless defined(&BACKSPACE);
    eval 'sub NEWLINE () {3;}' unless defined(&NEWLINE);
    eval 'sub TAB () {4;}' unless defined(&TAB);
    eval 'sub VTAB () {5;}' unless defined(&VTAB);
    eval 'sub RETURN () {6;}' unless defined(&RETURN);
    eval 'sub T_SS2 () {7;}' unless defined(&T_SS2);
    eval 'sub T_SS3 () {8;}' unless defined(&T_SS3);
    if(defined(&__cplusplus)) {
    }
}
1;
