require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_LLC2_H)) {
    eval 'sub _SYS_LLC2_H () {1;}' unless defined(&_SYS_LLC2_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub ETHER_ADDR_SIZE () {8;}' unless defined(&ETHER_ADDR_SIZE);
    eval 'sub IEEE_ADDR_SIZE () {7;}' unless defined(&IEEE_ADDR_SIZE);
    eval 'sub TOKEN_ADDR_SIZE () {7;}' unless defined(&TOKEN_ADDR_SIZE);
    eval 'sub DL_MAXSTATE () { &DL_SUBS_BIND_PND;}' unless defined(&DL_MAXSTATE);
    eval 'sub LLC2_MAX_SAPS () {128;}' unless defined(&LLC2_MAX_SAPS);
    eval 'sub LLC2_MAX_CONS () {256;}' unless defined(&LLC2_MAX_CONS);
    eval 'sub T_ACK_ON () {0x80;}' unless defined(&T_ACK_ON);
    eval 'sub T_P_ON () {0x40;}' unless defined(&T_P_ON);
    eval 'sub T_REJ_ON () {0x20;}' unless defined(&T_REJ_ON);
    eval 'sub T_REM_BUSY_ON () {0x10;}' unless defined(&T_REM_BUSY_ON);
    eval 'sub T_INACT_ON () {0x8;}' unless defined(&T_INACT_ON);
    eval 'sub T_SEND_ACK_ON () {0x4;}' unless defined(&T_SEND_ACK_ON);
    eval 'sub MAC_INST () {0x1;}' unless defined(&MAC_INST);
    eval 'sub MAC_INIT () {0x4;}' unless defined(&MAC_INIT);
    eval 'sub ILD_INIT () {0x1;}' unless defined(&ILD_INIT);
    eval 'sub ILD_UNINIT () {0x2;}' unless defined(&ILD_UNINIT);
    eval 'sub ILD_MAC () {0x3;}' unless defined(&ILD_MAC);
    eval 'sub ILD_TCAPSTART () {0x7;}' unless defined(&ILD_TCAPSTART);
    eval 'sub ILD_TCAPSTOP () {0x8;}' unless defined(&ILD_TCAPSTOP);
    eval 'sub ILD_GCONFIG () {0xa;}' unless defined(&ILD_GCONFIG);
    eval 'sub ILD_PPA_INFO () {0xd;}' unless defined(&ILD_PPA_INFO);
    eval 'sub ILD_PPA_CONFIG () {0xf;}' unless defined(&ILD_PPA_CONFIG);
    eval 'sub ILD_LLC2 () {((ord(\'I\')<<24)|8);}' unless defined(&ILD_LLC2);
    eval 'sub NOVELL_LENGTH () {0x4;}' unless defined(&NOVELL_LENGTH);
    eval 'sub NOVELL_TYPE () {0x3;}' unless defined(&NOVELL_TYPE);
    eval 'sub LLC2_INIT () {((ord(\'L\')<<24)|1);}' unless defined(&LLC2_INIT);
    eval 'sub LLC2_UNINIT () {((ord(\'L\')<<24)|2);}' unless defined(&LLC2_UNINIT);
    eval 'sub LLC2_GET_STA_STATS () {((ord(\'L\')<<24)|3);}' unless defined(&LLC2_GET_STA_STATS);
    eval 'sub LLC2_GET_SAP_STATS () {((ord(\'L\')<<24)|4);}' unless defined(&LLC2_GET_SAP_STATS);
    eval 'sub LLC2_GET_CON_STATS () {((ord(\'L\')<<24)|5);}' unless defined(&LLC2_GET_CON_STATS);
    eval 'sub LLC_GET_CON_PARMS_REQ () {((ord(\'L\')<<24)|8);}' unless defined(&LLC_GET_CON_PARMS_REQ);
    eval 'sub LLC_SET_CON_PARMS_REQ () {((ord(\'L\')<<24)|9);}' unless defined(&LLC_SET_CON_PARMS_REQ);
    eval 'sub LLC_GETPPA () {((ord(\'L\')<<24)|10);}' unless defined(&LLC_GETPPA);
    eval 'sub LLC_SETPPA () {((ord(\'L\')<<24)|11);}' unless defined(&LLC_SETPPA);
    eval 'sub ConfigMCast () {0x1;}' unless defined(&ConfigMCast);
    eval 'sub ReconfigMCast () {0x2;}' unless defined(&ReconfigMCast);
    eval 'sub CFGMULTICAST () {4;}' unless defined(&CFGMULTICAST);
    eval 'sub SetFunctionalAddr () {0x3;}' unless defined(&SetFunctionalAddr);
    eval 'sub ClearFunctionalAddr () {0x4;}' unless defined(&ClearFunctionalAddr);
    eval 'sub SetGroupAddr () {0x5;}' unless defined(&SetGroupAddr);
    eval 'sub ClearGroupAddr () {0x6;}' unless defined(&ClearGroupAddr);
    eval 'sub MCErr_Already () {0xf1;}' unless defined(&MCErr_Already);
    eval 'sub MCErr_Invalid () {0xf2;}' unless defined(&MCErr_Invalid);
    eval 'sub MCErr_Overflow () {0xf3;}' unless defined(&MCErr_Overflow);
    eval 'sub MCErr_None () {0xf4;}' unless defined(&MCErr_None);
    eval 'sub MCErr_Command () {0xf5;}' unless defined(&MCErr_Command);
    eval 'sub RVAL_CMD_UNKNOWN () {-2;}' unless defined(&RVAL_CMD_UNKNOWN);
    eval 'sub RVAL_PARM_INVALID () {-3;}' unless defined(&RVAL_PARM_INVALID);
    eval 'sub RVAL_SYS_ERR () {-4;}' unless defined(&RVAL_SYS_ERR);
    eval 'sub RVAL_STA_INVALID () {-5;}' unless defined(&RVAL_STA_INVALID);
    eval 'sub RVAL_STA_OUTSTATE () {-6;}' unless defined(&RVAL_STA_OUTSTATE);
    eval 'sub RVAL_SAP_INVALID () {-7;}' unless defined(&RVAL_SAP_INVALID);
    eval 'sub RVAL_CON_INVALID () {-8;}' unless defined(&RVAL_CON_INVALID);
    eval 'sub RVAL_MAC_INVALID () {-9;}' unless defined(&RVAL_MAC_INVALID);
    eval 'sub LLC_RESIDENT () {1;}' unless defined(&LLC_RESIDENT);
    eval 'sub ADAPTER_RESIDENT () {1;}' unless defined(&ADAPTER_RESIDENT);
    eval 'sub DOWNLOAD_REQUIRED () {2;}' unless defined(&DOWNLOAD_REQUIRED);
    eval 'sub SRB_SUPPORTED () {4;}' unless defined(&SRB_SUPPORTED);
    eval 'sub HOST_LLC_IN_USE () {8;}' unless defined(&HOST_LLC_IN_USE);
    eval 'sub ILDTCAPSIZE () {64;}' unless defined(&ILDTCAPSIZE);
    eval 'sub ILDTRCTABSIZ () {512;}' unless defined(&ILDTRCTABSIZ);
    if(defined(&__cplusplus)) {
    }
}
1;
