require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MACHELF_H)) {
    eval 'sub _SYS_MACHELF_H () {1;}' unless defined(&_SYS_MACHELF_H);
    require 'sys/elf_SPARC.ph';
    unless(defined(&_ASM)) {
	require 'sys/elf.ph';
	require 'sys/link.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined( &_ELF64)  && !defined( &_ELF32_COMPAT)) {
	unless(defined(&_ASM)) {
	}
	if(defined( &_KERNEL)) {
	    eval 'sub ELF_R_TYPE () { &ELF64_R_TYPE;}' unless defined(&ELF_R_TYPE);
	    eval 'sub ELF_R_SYM () { &ELF64_R_SYM;}' unless defined(&ELF_R_SYM);
	    eval 'sub ELF_R_TYPE_DATA () { &ELF64_R_TYPE_DATA;}' unless defined(&ELF_R_TYPE_DATA);
	    eval 'sub ELF_R_INFO () { &ELF64_R_INFO;}' unless defined(&ELF_R_INFO);
	    eval 'sub ELF_ST_BIND () { &ELF64_ST_BIND;}' unless defined(&ELF_ST_BIND);
	    eval 'sub ELF_ST_TYPE () { &ELF64_ST_TYPE;}' unless defined(&ELF_ST_TYPE);
	    eval 'sub ELF_M_SYM () { &ELF64_M_SYM;}' unless defined(&ELF_M_SYM);
	    eval 'sub ELF_M_SIZE () { &ELF64_M_SIZE;}' unless defined(&ELF_M_SIZE);
	}
	unless(defined(&_ASM)) {
	}
    } else {
	unless(defined(&_ASM)) {
	}
	if(defined( &_KERNEL)) {
	    eval 'sub ELF_R_TYPE () { &ELF32_R_TYPE;}' unless defined(&ELF_R_TYPE);
	    eval 'sub ELF_R_SYM () { &ELF32_R_SYM;}' unless defined(&ELF_R_SYM);
	    eval 'sub ELF_R_INFO () { &ELF32_R_INFO;}' unless defined(&ELF_R_INFO);
	    eval 'sub ELF_R_TYPE_DATA {
	        my($x) = @_;
    		eval q((0));
	    }' unless defined(&ELF_R_TYPE_DATA);
	    eval 'sub ELF_ST_BIND () { &ELF32_ST_BIND;}' unless defined(&ELF_ST_BIND);
	    eval 'sub ELF_ST_TYPE () { &ELF32_ST_TYPE;}' unless defined(&ELF_ST_TYPE);
	    eval 'sub ELF_M_SYM () { &ELF32_M_SYM;}' unless defined(&ELF_M_SYM);
	    eval 'sub ELF_M_SIZE () { &ELF32_M_SIZE;}' unless defined(&ELF_M_SIZE);
	}
	unless(defined(&_ASM)) {
	}
    }
    unless(defined(&__lint)) {
	eval 'sub EC_ADDR {
	    my($a) = @_;
    	    eval q((( &Elf64_Addr)($a)));
	}' unless defined(&EC_ADDR);
	eval 'sub EC_OFF {
	    my($a) = @_;
    	    eval q((( &Elf64_Off)($a)));
	}' unless defined(&EC_OFF);
	eval 'sub EC_HALF {
	    my($a) = @_;
    	    eval q((( &Elf64_Half)($a)));
	}' unless defined(&EC_HALF);
	eval 'sub EC_WORD {
	    my($a) = @_;
    	    eval q((( &Elf64_Word)($a)));
	}' unless defined(&EC_WORD);
	eval 'sub EC_SWORD {
	    my($a) = @_;
    	    eval q((( &Elf64_Sword)($a)));
	}' unless defined(&EC_SWORD);
	eval 'sub EC_XWORD {
	    my($a) = @_;
    	    eval q((( &Elf64_Xword)($a)));
	}' unless defined(&EC_XWORD);
	eval 'sub EC_SXWORD {
	    my($a) = @_;
    	    eval q((( &Elf64_Sxword)($a)));
	}' unless defined(&EC_SXWORD);
	eval 'sub EC_LWORD {
	    my($a) = @_;
    	    eval q((( &Elf64_Lword)($a)));
	}' unless defined(&EC_LWORD);
    } else {
	eval 'sub EC_ADDR {
	    my($a) = @_;
    	    eval q((($a)));
	}' unless defined(&EC_ADDR);
	eval 'sub EC_OFF {
	    my($a) = @_;
    	    eval q((($a)));
	}' unless defined(&EC_OFF);
	eval 'sub EC_HALF {
	    my($a) = @_;
    	    eval q((( &Elf64_Half)($a)));
	}' unless defined(&EC_HALF);
	eval 'sub EC_WORD {
	    my($a) = @_;
    	    eval q((( &Elf64_Word)($a)));
	}' unless defined(&EC_WORD);
	eval 'sub EC_SWORD {
	    my($a) = @_;
    	    eval q((( &Elf64_Sword)($a)));
	}' unless defined(&EC_SWORD);
	eval 'sub EC_XWORD {
	    my($a) = @_;
    	    eval q((($a)));
	}' unless defined(&EC_XWORD);
	eval 'sub EC_SXWORD {
	    my($a) = @_;
    	    eval q((($a)));
	}' unless defined(&EC_SXWORD);
	eval 'sub EC_LWORD {
	    my($a) = @_;
    	    eval q((($a)));
	}' unless defined(&EC_LWORD);
    }
    unless(defined(&_ASM)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
