require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MIIREGS_H)) {
    eval 'sub _MIIREGS_H () {1;}' unless defined(&_MIIREGS_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub MII_CONTROL () {0;}' unless defined(&MII_CONTROL);
    eval 'sub MII_STATUS () {1;}' unless defined(&MII_STATUS);
    eval 'sub MII_PHYIDH () {2;}' unless defined(&MII_PHYIDH);
    eval 'sub MII_PHYIDL () {3;}' unless defined(&MII_PHYIDL);
    eval 'sub MII_AN_ADVERT () {4;}' unless defined(&MII_AN_ADVERT);
    eval 'sub MII_AN_LPABLE () {5;}' unless defined(&MII_AN_LPABLE);
    eval 'sub MII_AN_EXPANSION () {6;}' unless defined(&MII_AN_EXPANSION);
    eval 'sub MII_AN_NXTPGXMIT () {7;}' unless defined(&MII_AN_NXTPGXMIT);
    eval 'sub MII_RESERVED () {8;}' unless defined(&MII_RESERVED);
    eval 'sub MII_VENDOR {
        my($x) = @_;
	    eval q((16+($x)));
    }' unless defined(&MII_VENDOR);
    eval 'sub MII_CONTROL_RESET () {(1<<15);}' unless defined(&MII_CONTROL_RESET);
    eval 'sub MII_CONTROL_LOOPBACK () {(1<<14);}' unless defined(&MII_CONTROL_LOOPBACK);
    eval 'sub MII_CONTROL_100MB () {(1<<13);}' unless defined(&MII_CONTROL_100MB);
    eval 'sub MII_CONTROL_ANE () {(1<<12);}' unless defined(&MII_CONTROL_ANE);
    eval 'sub MII_CONTROL_PWRDN () {(1<<11);}' unless defined(&MII_CONTROL_PWRDN);
    eval 'sub MII_CONTROL_ISOLATE () {(1<<10);}' unless defined(&MII_CONTROL_ISOLATE);
    eval 'sub MII_CONTROL_RSAN () {(1<<9);}' unless defined(&MII_CONTROL_RSAN);
    eval 'sub MII_CONTROL_FDUPLEX () {(1<<8);}' unless defined(&MII_CONTROL_FDUPLEX);
    eval 'sub MII_CONTROL_COLTST () {(1<<7);}' unless defined(&MII_CONTROL_COLTST);
    eval 'sub MII_CONTROL_RESERVED () {0x7f;}' unless defined(&MII_CONTROL_RESERVED);
    eval 'sub MII_STATUS_100_BASE_T4 () {(1<<15);}' unless defined(&MII_STATUS_100_BASE_T4);
    eval 'sub MII_STATUS_100_BASEX_FD () {(1<<14);}' unless defined(&MII_STATUS_100_BASEX_FD);
    eval 'sub MII_STATUS_100_BASEX () {(1<<13);}' unless defined(&MII_STATUS_100_BASEX);
    eval 'sub MII_STATUS_10_FD () {(1<<12);}' unless defined(&MII_STATUS_10_FD);
    eval 'sub MII_STATUS_10 () {(1<<11);}' unless defined(&MII_STATUS_10);
    eval 'sub MII_STATUS_RESERVED () {(0xf<<7);}' unless defined(&MII_STATUS_RESERVED);
    eval 'sub MII_STATUS_MFPRMBLSUPR () {(1<<6);}' unless defined(&MII_STATUS_MFPRMBLSUPR);
    eval 'sub MII_STATUS_ANDONE () {(1<<5);}' unless defined(&MII_STATUS_ANDONE);
    eval 'sub MII_STATUS_REMFAULT () {(1<<4);}' unless defined(&MII_STATUS_REMFAULT);
    eval 'sub MII_STATUS_CANAUTONEG () {(1<<3);}' unless defined(&MII_STATUS_CANAUTONEG);
    eval 'sub MII_STATUS_LINKUP () {(1<<2);}' unless defined(&MII_STATUS_LINKUP);
    eval 'sub MII_STATUS_JABBERING () {(1<<1);}' unless defined(&MII_STATUS_JABBERING);
    eval 'sub MII_STATUS_EXTENDED () {(1<<0);}' unless defined(&MII_STATUS_EXTENDED);
    eval 'sub MII_AN_ADVERT_NP () {(1<<15);}' unless defined(&MII_AN_ADVERT_NP);
    eval 'sub MII_AN_ADVERT_ACK () {(1<<14);}' unless defined(&MII_AN_ADVERT_ACK);
    eval 'sub MII_AN_ADVERT_REMFAULT () {(1<<13);}' unless defined(&MII_AN_ADVERT_REMFAULT);
    eval 'sub MII_AN_ADVERT_RESERVED () {(3<<11);}' unless defined(&MII_AN_ADVERT_RESERVED);
    eval 'sub MII_AN_ADVERT_FCS () {(1<<10);}' unless defined(&MII_AN_ADVERT_FCS);
    eval 'sub MII_AN_ADVERT_TECHABLE () {(0xff<<5);}' unless defined(&MII_AN_ADVERT_TECHABLE);
    eval 'sub MII_AN_ADVERT_SELECTOR () {(0x1f);}' unless defined(&MII_AN_ADVERT_SELECTOR);
    eval 'sub MII_ABILITY_10BASE_T () {(1<<5);}' unless defined(&MII_ABILITY_10BASE_T);
    eval 'sub MII_ABILITY_10BASE_T_FD () {(1<<6);}' unless defined(&MII_ABILITY_10BASE_T_FD);
    eval 'sub MII_ABILITY_100BASE_TX () {(1<<7);}' unless defined(&MII_ABILITY_100BASE_TX);
    eval 'sub MII_ABILITY_100BASE_TX_FD () {(1<<8);}' unless defined(&MII_ABILITY_100BASE_TX_FD);
    eval 'sub MII_ABILITY_100BASE_T4 () {(1<<9);}' unless defined(&MII_ABILITY_100BASE_T4);
    eval 'sub MII_AN_EXP_PARFAULT () {(1<<4);}' unless defined(&MII_AN_EXP_PARFAULT);
    eval 'sub MII_AN_EXP_LPCANNXTP () {(1<<3);}' unless defined(&MII_AN_EXP_LPCANNXTP);
    eval 'sub MII_AN_EXP_CANNXTPP () {(1<<2);}' unless defined(&MII_AN_EXP_CANNXTPP);
    eval 'sub MII_AN_EXP_PAGERCVD () {(1<<1);}' unless defined(&MII_AN_EXP_PAGERCVD);
    eval 'sub MII_AN_EXP_LPCANAN () {(1<<0);}' unless defined(&MII_AN_EXP_LPCANAN);
    eval 'sub PHY_MANUFACTURER {
        my($x) = @_;
	    eval q(((($x) >> 10) & 0x3fffff));
    }' unless defined(&PHY_MANUFACTURER);
    eval 'sub PHY_MODEL {
        my($x) = @_;
	    eval q(((($x) >> 4) & 0x3f));
    }' unless defined(&PHY_MODEL);
    eval 'sub PHY_REVISION {
        my($x) = @_;
	    eval q((($x) & 0xf));
    }' unless defined(&PHY_REVISION);
    eval 'sub OUI_NATIONAL_SEMICONDUCTOR () {0x80017;}' unless defined(&OUI_NATIONAL_SEMICONDUCTOR);
    eval 'sub NS_DP83840 () {0x;}' unless defined(&NS_DP83840);
    eval 'sub MII_83840_ADDR () {25;}' unless defined(&MII_83840_ADDR);
    eval 'sub NS83840_ADDR_SPEED10 () {(1<<6);}' unless defined(&NS83840_ADDR_SPEED10);
    eval 'sub NS83840_ADDR_CONSTAT () {(1<<5);}' unless defined(&NS83840_ADDR_CONSTAT);
    eval 'sub NS83840_ADDR_ADDR () {(0x1f<<0);}' unless defined(&NS83840_ADDR_ADDR);
    eval 'sub OUI_INTEL () {0xaa00;}' unless defined(&OUI_INTEL);
    eval 'sub INTEL_82553_CSTEP () {0x35;}' unless defined(&INTEL_82553_CSTEP);
    eval 'sub MII_82553_EX0 () {16;}' unless defined(&MII_82553_EX0);
    eval 'sub I82553_EX0_FDUPLEX () {(1<<0);}' unless defined(&I82553_EX0_FDUPLEX);
    eval 'sub I82553_EX0_100MB () {(1<<1);}' unless defined(&I82553_EX0_100MB);
    eval 'sub I82553_EX0_WAKE () {(1<<2);}' unless defined(&I82553_EX0_WAKE);
    eval 'sub I82553_EX0_SQUELCH () {(3<<3);}' unless defined(&I82553_EX0_SQUELCH);
    eval 'sub I82553_EX0_REVCNTR () {(7<<5);}' unless defined(&I82553_EX0_REVCNTR);
    eval 'sub I82553_EX0_FRCFAIL () {(1<<8);}' unless defined(&I82553_EX0_FRCFAIL);
    eval 'sub I82553_EX0_TEST () {(0x1f<<9);}' unless defined(&I82553_EX0_TEST);
    eval 'sub I82553_EX0_LINKDIS () {(1<<14);}' unless defined(&I82553_EX0_LINKDIS);
    eval 'sub I82553_EX0_JABDIS () {(1<<15);}' unless defined(&I82553_EX0_JABDIS);
    eval 'sub MII_82553_EX1 () {1;}' unless defined(&MII_82553_EX1);
    eval 'sub I82553_EX1_RESERVE () {(0x1ff<<0);}' unless defined(&I82553_EX1_RESERVE);
    eval 'sub I82553_EX1_CH2EOF () {(1<<9);}' unless defined(&I82553_EX1_CH2EOF);
    eval 'sub I82553_EX1_MNCHSTR () {(1<<10);}' unless defined(&I82553_EX1_MNCHSTR);
    eval 'sub I82553_EX1_EOP () {(1<<11);}' unless defined(&I82553_EX1_EOP);
    eval 'sub I82553_EX1_BADCODE () {(1<<12);}' unless defined(&I82553_EX1_BADCODE);
    eval 'sub I82553_EX1_INVALCODE () {(1<<13);}' unless defined(&I82553_EX1_INVALCODE);
    eval 'sub I82553_EX1_DCBALANCE () {(1<<14);}' unless defined(&I82553_EX1_DCBALANCE);
    eval 'sub I82553_EX1_PAIRSKEW () {(1<<15);}' unless defined(&I82553_EX1_PAIRSKEW);
    eval 'sub INTEL_82555 () {0x15;}' unless defined(&INTEL_82555);
    eval 'sub OUI_ICS () {0x57d;}' unless defined(&OUI_ICS);
    eval 'sub ICS_1890 () {2;}' unless defined(&ICS_1890);
    eval 'sub ICS_1889 () {1;}' unless defined(&ICS_1889);
    eval 'sub ICS_EXCTRL () {16;}' unless defined(&ICS_EXCTRL);
    eval 'sub ICS_EXCTRL_CMDOVRD () {(1<<15);}' unless defined(&ICS_EXCTRL_CMDOVRD);
    eval 'sub ICS_EXCTRL_PHYADDR () {(0x1f<<6);}' unless defined(&ICS_EXCTRL_PHYADDR);
    eval 'sub ICS_EXCTRL_SCSTEST () {(1<<5);}' unless defined(&ICS_EXCTRL_SCSTEST);
    eval 'sub ICS_EXCTRL_INVECTEST () {(1<<2);}' unless defined(&ICS_EXCTRL_INVECTEST);
    eval 'sub ICS_EXCTRL_SCDISABLE () {(1<<0);}' unless defined(&ICS_EXCTRL_SCDISABLE);
    eval 'sub ICS_QUICKPOLL () {17;}' unless defined(&ICS_QUICKPOLL);
    eval 'sub ICS_QUICKPOLL_100MB () {(1<<15);}' unless defined(&ICS_QUICKPOLL_100MB);
    eval 'sub ICS_QUICKPOLL_FDUPLEX () {(1<<14);}' unless defined(&ICS_QUICKPOLL_FDUPLEX);
    eval 'sub ICS_QUICKPOLL_ANPROG () {(7<<11);}' unless defined(&ICS_QUICKPOLL_ANPROG);
    eval 'sub ICS_QUICKPOLL_RSE () {(1<<10);}' unless defined(&ICS_QUICKPOLL_RSE);
    eval 'sub ICS_QUICKPOLL_PLLLOCK () {(1<<9);}' unless defined(&ICS_QUICKPOLL_PLLLOCK);
    eval 'sub ICS_QUICKPOLL_FALSECD () {(1<<8);}' unless defined(&ICS_QUICKPOLL_FALSECD);
    eval 'sub ICS_QUICKPOLL_SYMINVAL () {(1<<7);}' unless defined(&ICS_QUICKPOLL_SYMINVAL);
    eval 'sub ICS_QUICKPOLL_SYMHALT () {(1<<6);}' unless defined(&ICS_QUICKPOLL_SYMHALT);
    eval 'sub ICS_QUICKPOLL_PREMEND () {(1<<5);}' unless defined(&ICS_QUICKPOLL_PREMEND);
    eval 'sub ICS_QUICKPOLL_ANDONE () {(1<<4);}' unless defined(&ICS_QUICKPOLL_ANDONE);
    eval 'sub ICS_QUICKPOLL_RESERVED () {(1<<3);}' unless defined(&ICS_QUICKPOLL_RESERVED);
    eval 'sub ICS_QUICKPOLL_JABBER () {(1<<2);}' unless defined(&ICS_QUICKPOLL_JABBER);
    eval 'sub ICS_QUICKPOLL_REMFAULT () {(1<<1);}' unless defined(&ICS_QUICKPOLL_REMFAULT);
    eval 'sub ICS_QUICKPOLL_LINKSTAT () {(1<<0);}' unless defined(&ICS_QUICKPOLL_LINKSTAT);
    eval 'sub ICS_10BASET () {18;}' unless defined(&ICS_10BASET);
    eval 'sub ICS_10BASET_REMJABBER () {(1<<15);}' unless defined(&ICS_10BASET_REMJABBER);
    eval 'sub ICS_10BASET_REVPOLARITY () {(1<<14);}' unless defined(&ICS_10BASET_REVPOLARITY);
    eval 'sub ICS_10BASET_RESERVED () {(0xff<<6);}' unless defined(&ICS_10BASET_RESERVED);
    eval 'sub ICS_10BASET_NOJABBER () {(1<<5);}' unless defined(&ICS_10BASET_NOJABBER);
    eval 'sub ICS_10BASET_NORMLOOP () {(1<<4);}' unless defined(&ICS_10BASET_NORMLOOP);
    eval 'sub ICS_10BASET_NOAUTOPOLL () {(1<<3);}' unless defined(&ICS_10BASET_NOAUTOPOLL);
    eval 'sub ICS_10BASET_NOSQE () {(1<<2);}' unless defined(&ICS_10BASET_NOSQE);
    eval 'sub ICS_10BASET_NOLINKLOSS () {(1<<1);}' unless defined(&ICS_10BASET_NOLINKLOSS);
    eval 'sub ICS_10BASET_NOSQUELCH () {(1<<0);}' unless defined(&ICS_10BASET_NOSQUELCH);
    eval 'sub ICS_EXCTRL2 () {19;}' unless defined(&ICS_EXCTRL2);
    eval 'sub ICS_EXCTRL2_ISREPEATER () {(1<<15);}' unless defined(&ICS_EXCTRL2_ISREPEATER);
    eval 'sub ICS_EXCTRL2_SOFTPRI () {(1<<14);}' unless defined(&ICS_EXCTRL2_SOFTPRI);
    eval 'sub ICS_EXCTRL2_LPCANREMF () {(1<<13);}' unless defined(&ICS_EXCTRL2_LPCANREMF);
    eval 'sub ICS_EXCTRL2_RMFSXMITED () {(1<<10);}' unless defined(&ICS_EXCTRL2_RMFSXMITED);
    eval 'sub ICS_EXCTRL2_ANPWRREMF () {(1<<4);}' unless defined(&ICS_EXCTRL2_ANPWRREMF);
    eval 'sub ICS_EXCTRL2_10BASETQUAL () {(1<<2);}' unless defined(&ICS_EXCTRL2_10BASETQUAL);
    eval 'sub ICS_EXCTRL2_AUTOPWRDN () {(1<<0);}' unless defined(&ICS_EXCTRL2_AUTOPWRDN);
    eval 'sub OUI_DAVICOM () {0x606e;}' unless defined(&OUI_DAVICOM);
    eval 'sub DM_SCR () {16;}' unless defined(&DM_SCR);
    eval 'sub DM_SCR_F_TX () {(1<<10);}' unless defined(&DM_SCR_F_TX);
    eval 'sub DM_SCR_UTP () {(1<<9);}' unless defined(&DM_SCR_UTP);
    eval 'sub DM_SCR_F_LINK_100 () {(1<<7);}' unless defined(&DM_SCR_F_LINK_100);
    eval 'sub DM_SCR_LED_CTL () {(1<<5);}' unless defined(&DM_SCR_LED_CTL);
    eval 'sub DM_SCR_SMRST () {(1<<3);}' unless defined(&DM_SCR_SMRST);
    eval 'sub DM_SCR_MFPSC () {(1<<2);}' unless defined(&DM_SCR_MFPSC);
    eval 'sub DM_SCR_SLEEP () {(1<<1);}' unless defined(&DM_SCR_SLEEP);
    eval 'sub DM_SCR_RLOUT () {(1<<0);}' unless defined(&DM_SCR_RLOUT);
    eval 'sub DM_SCSR () {17;}' unless defined(&DM_SCSR);
    eval 'sub DM_SCSR_100FDX () {(1<<15);}' unless defined(&DM_SCSR_100FDX);
    eval 'sub DM_SCSR_100HDX () {(1<<14);}' unless defined(&DM_SCSR_100HDX);
    eval 'sub DM_SCSR_10FDX () {(1<<13);}' unless defined(&DM_SCSR_10FDX);
    eval 'sub DM_SCSR_10HDX () {(1<<12);}' unless defined(&DM_SCSR_10HDX);
    eval 'sub DM_SCSR_PHYAD () {(0x1f<<4);}' unless defined(&DM_SCSR_PHYAD);
    eval 'sub DM_SCSR_ANMB () {(0xf);}' unless defined(&DM_SCSR_ANMB);
    eval 'sub DM_10BT () {18;}' unless defined(&DM_10BT);
    eval 'sub DM_10BT_LB_EN () {(1<<14);}' unless defined(&DM_10BT_LB_EN);
    eval 'sub DM_10BT_HBE () {(1<<13);}' unless defined(&DM_10BT_HBE);
    eval 'sub DM_10BT_JABEN () {(1<<11);}' unless defined(&DM_10BT_JABEN);
    if(defined(&__cplusplus)) {
    }
}
1;
