require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MKDEV_H)) {
    eval 'sub _SYS_MKDEV_H () {1;}' unless defined(&_SYS_MKDEV_H);
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub ONBITSMAJOR () {7;}' unless defined(&ONBITSMAJOR);
    eval 'sub ONBITSMINOR () {8;}' unless defined(&ONBITSMINOR);
    eval 'sub OMAXMAJ () {0x7f;}' unless defined(&OMAXMAJ);
    eval 'sub OMAXMIN () {0xff;}' unless defined(&OMAXMIN);
    eval 'sub NBITSMAJOR32 () {14;}' unless defined(&NBITSMAJOR32);
    eval 'sub NBITSMINOR32 () {18;}' unless defined(&NBITSMINOR32);
    eval 'sub MAXMAJ32 () {0x3fff;}' unless defined(&MAXMAJ32);
    eval 'sub MAXMIN32 () {0x3ffff;}' unless defined(&MAXMIN32);
    if(defined(&_LP64)) {
	eval 'sub NBITSMAJOR64 () {32;}' unless defined(&NBITSMAJOR64);
	eval 'sub NBITSMINOR64 () {32;}' unless defined(&NBITSMINOR64);
	eval 'sub MAXMAJ64 () {0xffffffff;}' unless defined(&MAXMAJ64);
	eval 'sub MAXMIN64 () {0xffffffff;}' unless defined(&MAXMIN64);
	eval 'sub NBITSMAJOR () { &NBITSMAJOR64;}' unless defined(&NBITSMAJOR);
	eval 'sub NBITSMINOR () { &NBITSMINOR64;}' unless defined(&NBITSMINOR);
	eval 'sub MAXMAJ () { &MAXMAJ64;}' unless defined(&MAXMAJ);
	eval 'sub MAXMIN () { &MAXMIN64;}' unless defined(&MAXMIN);
    } else {
	eval 'sub NBITSMAJOR () { &NBITSMAJOR32;}' unless defined(&NBITSMAJOR);
	eval 'sub NBITSMINOR () { &NBITSMINOR32;}' unless defined(&NBITSMINOR);
	eval 'sub MAXMAJ () { &MAXMAJ32;}' unless defined(&MAXMAJ);
	eval 'sub MAXMIN () { &MAXMIN32;}' unless defined(&MAXMIN);
    }
    if(!defined( &_KERNEL)) {
	undef(&makedev) if defined(&makedev);
	undef(&major) if defined(&major);
	undef(&minor) if defined(&minor);
	if(defined( &__STDC__)) {
	} else {
	}
	eval 'sub OLDDEV () {0;}' unless defined(&OLDDEV);
	eval 'sub NEWDEV () {1;}' unless defined(&NEWDEV);
	eval 'sub makedev {
	    my($maj, $min) = @_;
    	    eval q(( &__makedev( &NEWDEV, $maj, $min)));
	}' unless defined(&makedev);
	eval 'sub major {
	    my($dev) = @_;
    	    eval q(( &__major( &NEWDEV, $dev)));
	}' unless defined(&major);
	eval 'sub minor {
	    my($dev) = @_;
    	    eval q(( &__minor( &NEWDEV, $dev)));
	}' unless defined(&minor);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
