require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_OLD_PROCFS_H)) {
    eval 'sub _SYS_OLD_PROCFS_H () {1;}' unless defined(&_SYS_OLD_PROCFS_H);
    require 'sys/types.ph';
    require 'sys/time_impl.ph';
    require 'sys/signal.ph';
    require 'sys/siginfo.ph';
    require 'sys/fault.ph';
    require 'sys/syscall.ph';
    require 'sys/procfs_isa.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined( &_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) {
	die("Cannot use procfs in the large file compilation environment");
    }
    eval 'sub PIOC () {(ord(\'q\')<<8);}' unless defined(&PIOC);
    eval 'sub PIOCSTATUS () {( &PIOC|1);}' unless defined(&PIOCSTATUS);
    eval 'sub PIOCSTOP () {( &PIOC|2);}' unless defined(&PIOCSTOP);
    eval 'sub PIOCWSTOP () {( &PIOC|3);}' unless defined(&PIOCWSTOP);
    eval 'sub PIOCRUN () {( &PIOC|4);}' unless defined(&PIOCRUN);
    eval 'sub PIOCGTRACE () {( &PIOC|5);}' unless defined(&PIOCGTRACE);
    eval 'sub PIOCSTRACE () {( &PIOC|6);}' unless defined(&PIOCSTRACE);
    eval 'sub PIOCSSIG () {( &PIOC|7);}' unless defined(&PIOCSSIG);
    eval 'sub PIOCKILL () {( &PIOC|8);}' unless defined(&PIOCKILL);
    eval 'sub PIOCUNKILL () {( &PIOC|9);}' unless defined(&PIOCUNKILL);
    eval 'sub PIOCGHOLD () {( &PIOC|10);}' unless defined(&PIOCGHOLD);
    eval 'sub PIOCSHOLD () {( &PIOC|11);}' unless defined(&PIOCSHOLD);
    eval 'sub PIOCMAXSIG () {( &PIOC|12);}' unless defined(&PIOCMAXSIG);
    eval 'sub PIOCACTION () {( &PIOC|13);}' unless defined(&PIOCACTION);
    eval 'sub PIOCGFAULT () {( &PIOC|14);}' unless defined(&PIOCGFAULT);
    eval 'sub PIOCSFAULT () {( &PIOC|15);}' unless defined(&PIOCSFAULT);
    eval 'sub PIOCCFAULT () {( &PIOC|16);}' unless defined(&PIOCCFAULT);
    eval 'sub PIOCGENTRY () {( &PIOC|17);}' unless defined(&PIOCGENTRY);
    eval 'sub PIOCSENTRY () {( &PIOC|18);}' unless defined(&PIOCSENTRY);
    eval 'sub PIOCGEXIT () {( &PIOC|19);}' unless defined(&PIOCGEXIT);
    eval 'sub PIOCSEXIT () {( &PIOC|20);}' unless defined(&PIOCSEXIT);
    eval 'sub PIOCSFORK () {( &PIOC|21);}' unless defined(&PIOCSFORK);
    eval 'sub PIOCRFORK () {( &PIOC|22);}' unless defined(&PIOCRFORK);
    eval 'sub PIOCSRLC () {( &PIOC|23);}' unless defined(&PIOCSRLC);
    eval 'sub PIOCRRLC () {( &PIOC|24);}' unless defined(&PIOCRRLC);
    eval 'sub PIOCGREG () {( &PIOC|25);}' unless defined(&PIOCGREG);
    eval 'sub PIOCSREG () {( &PIOC|26);}' unless defined(&PIOCSREG);
    eval 'sub PIOCGFPREG () {( &PIOC|27);}' unless defined(&PIOCGFPREG);
    eval 'sub PIOCSFPREG () {( &PIOC|28);}' unless defined(&PIOCSFPREG);
    eval 'sub PIOCNICE () {( &PIOC|29);}' unless defined(&PIOCNICE);
    eval 'sub PIOCPSINFO () {( &PIOC|30);}' unless defined(&PIOCPSINFO);
    eval 'sub PIOCNMAP () {( &PIOC|31);}' unless defined(&PIOCNMAP);
    eval 'sub PIOCMAP () {( &PIOC|32);}' unless defined(&PIOCMAP);
    eval 'sub PIOCOPENM () {( &PIOC|33);}' unless defined(&PIOCOPENM);
    eval 'sub PIOCCRED () {( &PIOC|34);}' unless defined(&PIOCCRED);
    eval 'sub PIOCGROUPS () {( &PIOC|35);}' unless defined(&PIOCGROUPS);
    eval 'sub PIOCGETPR () {( &PIOC|36);}' unless defined(&PIOCGETPR);
    eval 'sub PIOCGETU () {( &PIOC|37);}' unless defined(&PIOCGETU);
    eval 'sub PIOCSET () {( &PIOC|38);}' unless defined(&PIOCSET);
    eval 'sub PIOCRESET () {( &PIOC|39);}' unless defined(&PIOCRESET);
    eval 'sub PIOCUSAGE () {( &PIOC|43);}' unless defined(&PIOCUSAGE);
    eval 'sub PIOCOPENPD () {( &PIOC|44);}' unless defined(&PIOCOPENPD);
    eval 'sub PIOCLWPIDS () {( &PIOC|45);}' unless defined(&PIOCLWPIDS);
    eval 'sub PIOCOPENLWP () {( &PIOC|46);}' unless defined(&PIOCOPENLWP);
    eval 'sub PIOCLSTATUS () {( &PIOC|47);}' unless defined(&PIOCLSTATUS);
    eval 'sub PIOCLUSAGE () {( &PIOC|48);}' unless defined(&PIOCLUSAGE);
    eval 'sub PIOCNAUXV () {( &PIOC|49);}' unless defined(&PIOCNAUXV);
    eval 'sub PIOCAUXV () {( &PIOC|50);}' unless defined(&PIOCAUXV);
    eval 'sub PIOCGXREGSIZE () {( &PIOC|51);}' unless defined(&PIOCGXREGSIZE);
    eval 'sub PIOCGXREG () {( &PIOC|52);}' unless defined(&PIOCGXREG);
    eval 'sub PIOCSXREG () {( &PIOC|53);}' unless defined(&PIOCSXREG);
    eval 'sub PIOCGWIN () {( &PIOC|101);}' unless defined(&PIOCGWIN);
    eval 'sub PRCLSZ () {8;}' unless defined(&PRCLSZ);
    eval 'sub PRSYSARGS () {8;}' unless defined(&PRSYSARGS);
    eval 'sub PR_STOPPED () {0x1;}' unless defined(&PR_STOPPED);
    eval 'sub PR_ISTOP () {0x2;}' unless defined(&PR_ISTOP);
    eval 'sub PR_DSTOP () {0x4;}' unless defined(&PR_DSTOP);
    eval 'sub PR_ASLEEP () {0x8;}' unless defined(&PR_ASLEEP);
    eval 'sub PR_FORK () {0x10;}' unless defined(&PR_FORK);
    eval 'sub PR_RLC () {0x20;}' unless defined(&PR_RLC);
    eval 'sub PR_PTRACE () {0x40;}' unless defined(&PR_PTRACE);
    eval 'sub PR_PCINVAL () {0x80;}' unless defined(&PR_PCINVAL);
    eval 'sub PR_ISSYS () {0x100;}' unless defined(&PR_ISSYS);
    eval 'sub PR_STEP () {0x200;}' unless defined(&PR_STEP);
    eval 'sub PR_KLC () {0x400;}' unless defined(&PR_KLC);
    eval 'sub PR_ASYNC () {0x800;}' unless defined(&PR_ASYNC);
    eval 'sub PR_PCOMPAT () {0x1000;}' unless defined(&PR_PCOMPAT);
    eval 'sub PR_MSACCT () {0x2000;}' unless defined(&PR_MSACCT);
    eval 'sub PR_BPTADJ () {0x4000;}' unless defined(&PR_BPTADJ);
    eval 'sub PR_ASLWP () {0x8000;}' unless defined(&PR_ASLWP);
    eval 'sub PR_REQUESTED () {1;}' unless defined(&PR_REQUESTED);
    eval 'sub PR_SIGNALLED () {2;}' unless defined(&PR_SIGNALLED);
    eval 'sub PR_SYSENTRY () {3;}' unless defined(&PR_SYSENTRY);
    eval 'sub PR_SYSEXIT () {4;}' unless defined(&PR_SYSEXIT);
    eval 'sub PR_JOBCONTROL () {5;}' unless defined(&PR_JOBCONTROL);
    eval 'sub PR_FAULTED () {6;}' unless defined(&PR_FAULTED);
    eval 'sub PR_SUSPENDED () {7;}' unless defined(&PR_SUSPENDED);
    eval 'sub PR_CHECKPOINT () {8;}' unless defined(&PR_CHECKPOINT);
    eval 'sub PRFNSZ () {16;}' unless defined(&PRFNSZ);
    eval 'sub PRARGSZ () {80;}' unless defined(&PRARGSZ);
    if(!defined( &_STYPES)) {
	eval 'sub pr_ttydev () { &pr_lttydev;}' unless defined(&pr_ttydev);
    } else {
	eval 'sub pr_ttydev () { &pr_ottydev;}' unless defined(&pr_ttydev);
    }
    eval 'sub PRNODEV () {( &dev_t)(-1);}' unless defined(&PRNODEV);
    eval 'sub PRCSIG () {0x1;}' unless defined(&PRCSIG);
    eval 'sub PRCFAULT () {0x2;}' unless defined(&PRCFAULT);
    eval 'sub PRSTRACE () {0x4;}' unless defined(&PRSTRACE);
    eval 'sub PRSHOLD () {0x8;}' unless defined(&PRSHOLD);
    eval 'sub PRSFAULT () {0x10;}' unless defined(&PRSFAULT);
    eval 'sub PRSVADDR () {0x20;}' unless defined(&PRSVADDR);
    eval 'sub PRSTEP () {0x40;}' unless defined(&PRSTEP);
    eval 'sub PRSABORT () {0x80;}' unless defined(&PRSABORT);
    eval 'sub PRSTOP () {0x100;}' unless defined(&PRSTOP);
    eval 'sub MA_READ () {0x4;}' unless defined(&MA_READ);
    eval 'sub MA_WRITE () {0x2;}' unless defined(&MA_WRITE);
    eval 'sub MA_EXEC () {0x1;}' unless defined(&MA_EXEC);
    eval 'sub MA_SHARED () {0x8;}' unless defined(&MA_SHARED);
    eval 'sub MA_BREAK () {0x10;}' unless defined(&MA_BREAK);
    eval 'sub MA_STACK () {0x20;}' unless defined(&MA_STACK);
    eval 'sub PG_REFERENCED () {0x2;}' unless defined(&PG_REFERENCED);
    eval 'sub PG_MODIFIED () {0x1;}' unless defined(&PG_MODIFIED);
    eval 'sub PG_HWMAPPED () {0x4;}' unless defined(&PG_HWMAPPED);
    eval 'sub prfillset {
        my($sp) = @_;
	    eval q({  &register \'int\'  &_i_ = $sizeof{($sp)}/$sizeof{ &uint32_t};  &while ( &_i_) (( &uint32_t *)($sp))[-- &_i_] = ( &uint32_t)0xffffffff; });
    }' unless defined(&prfillset);
    eval 'sub premptyset {
        my($sp) = @_;
	    eval q({  &register \'int\'  &_i_ = $sizeof{($sp)}/$sizeof{ &uint32_t};  &while ( &_i_) (( &uint32_t *)($sp))[-- &_i_] = ( &uint32_t)0; });
    }' unless defined(&premptyset);
    eval 'sub praddset {
        my($sp, $flag) = @_;
	    eval q((( &void)(((($flag)-1) < 32*$sizeof{($sp)}/$sizeof{ &uint32_t}) ? ((( &uint32_t *)($sp))[(($flag)-1)/32] |= (1<<((($flag)-1)%32))) : 0)));
    }' unless defined(&praddset);
    eval 'sub prdelset {
        my($sp, $flag) = @_;
	    eval q((( &void)(((($flag)-1) < 32*$sizeof{($sp)}/$sizeof{ &uint32_t}) ? ((( &uint32_t *)($sp))[(($flag)-1)/32] &= ~(1<<((($flag)-1)%32))) : 0)));
    }' unless defined(&prdelset);
    eval 'sub prismember {
        my($sp, $flag) = @_;
	    eval q((((($flag)-1) < 32*$sizeof{($sp)}/$sizeof{ &uint32_t})  && ((( &uint32_t *)($sp))[(($flag)-1)/32] & (1<<((($flag)-1)%32)))));
    }' unless defined(&prismember);
    if(defined(&_SYSCALL32)) {
	eval 'sub PRNODEV32 () {( &dev32_t)(-1);}' unless defined(&PRNODEV32);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
