require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_GLD_H)) {
    eval 'sub _SYS_GLD_H () {1;}' unless defined(&_SYS_GLD_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub GLD_MAX_MULTICAST () {16;}' unless defined(&GLD_MAX_MULTICAST);
    eval 'sub GLD_INTR_READY () {0x1;}' unless defined(&GLD_INTR_READY);
    eval 'sub GLD_INTR_HI () {0x2;}' unless defined(&GLD_INTR_HI);
    eval 'sub GLD_DEV_PRESENT () {0x4;}' unless defined(&GLD_DEV_PRESENT);
    eval 'sub GLD_INTR_SOFT () {0x8;}' unless defined(&GLD_INTR_SOFT);
    eval 'sub GLD_PROMISC () {0x10;}' unless defined(&GLD_PROMISC);
    eval 'sub GLD_IN_INTR () {0x20;}' unless defined(&GLD_IN_INTR);
    eval 'sub GLD_PPA_MASK () {0x3f;}' unless defined(&GLD_PPA_MASK);
    eval 'sub GLD_PPA_INIT () {0x40;}' unless defined(&GLD_PPA_INIT);
    eval 'sub GLD_USE_STYLE2 () {0;}' unless defined(&GLD_USE_STYLE2);
    eval 'sub GLDOPT_PCMCIA () {0x1;}' unless defined(&GLDOPT_PCMCIA);
    eval 'sub GLDOPT_DRIVER_PPA () {0x2;}' unless defined(&GLDOPT_DRIVER_PPA);
    eval 'sub GLD_RAW () {0x1;}' unless defined(&GLD_RAW);
    eval 'sub GLD_FAST () {0x2;}' unless defined(&GLD_FAST);
    eval 'sub GLD_PROM_PHYS () {0x4;}' unless defined(&GLD_PROM_PHYS);
    eval 'sub GLD_PROM_SAP () {0x8;}' unless defined(&GLD_PROM_SAP);
    eval 'sub GLD_PROM_MULT () {0x10;}' unless defined(&GLD_PROM_MULT);
    eval 'sub GLD_XWAIT () {0x20;}' unless defined(&GLD_XWAIT);
    eval 'sub GLD_LOCKED () {0x40;}' unless defined(&GLD_LOCKED);
    eval 'sub GLD_802_SAP () {1500;}' unless defined(&GLD_802_SAP);
    eval 'sub GLDMAXETHERSAP () {0xffff;}' unless defined(&GLDMAXETHERSAP);
    eval 'sub GLD_MAX_802_SAP () {0xff;}' unless defined(&GLD_MAX_802_SAP);
    eval 'sub GLDM_UNKNOWN () {0;}' unless defined(&GLDM_UNKNOWN);
    eval 'sub GLDM_AUI () {1;}' unless defined(&GLDM_AUI);
    eval 'sub GLDM_BNC () {2;}' unless defined(&GLDM_BNC);
    eval 'sub GLDM_TP () {3;}' unless defined(&GLDM_TP);
    eval 'sub GLDM_FIBER () {4;}' unless defined(&GLDM_FIBER);
    eval 'sub GLD_ATTACHED () {0x1;}' unless defined(&GLD_ATTACHED);
    if(defined(&DEBUG)) {
	eval 'sub GLD_DEBUG () {1;}' unless defined(&GLD_DEBUG);
    }
    eval 'sub GLDTRACE () {0x1;}' unless defined(&GLDTRACE);
    eval 'sub GLDERRS () {0x2;}' unless defined(&GLDERRS);
    eval 'sub GLDRECV () {0x4;}' unless defined(&GLDRECV);
    eval 'sub GLDSEND () {0x8;}' unless defined(&GLDSEND);
    eval 'sub GLDPROT () {0x10;}' unless defined(&GLDPROT);
    eval 'sub GLDE_OK () {-1;}' unless defined(&GLDE_OK);
    eval 'sub GLDE_NOBUFFER () {0x1001;}' unless defined(&GLDE_NOBUFFER);
    eval 'sub GLDE_RETRY () {0x1002;}' unless defined(&GLDE_RETRY);
    eval 'sub GLDIDNUM () {0x8020;}' unless defined(&GLDIDNUM);
    eval 'sub ismulticast {
        my($cp) = @_;
	    eval q(((*($cp)) & 0x1));
    }' unless defined(&ismulticast);
    eval 'sub DLSAP {
        my($p, $offset) = @_;
	    eval q(((($p)+$offset)));
    }' unless defined(&DLSAP);
    eval 'sub GLDSTAT_INSERT () {1;}' unless defined(&GLDSTAT_INSERT);
    eval 'sub GLDSTAT_REMOVE () {2;}' unless defined(&GLDSTAT_REMOVE);
    eval 'sub DEPENDS_ON_GLD () {\'char\'  $_depends_on[] = "misc/gld";}' unless defined(&DEPENDS_ON_GLD);
    eval 'sub llcp_int () { &gldm_irq;}' unless defined(&llcp_int);
    eval 'sub LLC_ADDR_LEN () { &ETHERADDRL;}' unless defined(&LLC_ADDR_LEN);
    eval 'sub GLD_EHDR_SIZE () {$sizeof{\'struct ether_header\'};}' unless defined(&GLD_EHDR_SIZE);
    eval 'sub LOW {
        my($x) = @_;
	    eval q((($x)&0xff));
    }' unless defined(&LOW);
    eval 'sub HIGH {
        my($x) = @_;
	    eval q(((($x)>>8)&0xff));
    }' unless defined(&HIGH);
    if(defined( &_KERNEL)) {
    }
    eval 'sub gldnvm {
        my($ptr) = @_;
	    eval q((( &NVM_SLOTINFO *)$ptr));
    }' unless defined(&gldnvm);
    eval 'sub gld_boardid {
        my($nvm) = @_;
	    eval q((*( &ushort_t *)( &gldnvm($nvm)-> &boardid)));
    }' unless defined(&gld_boardid);
    eval 'sub gld_check_boardid {
        my($nvm, $id) = @_;
	    eval q(( &gld_boardid($nvm) == $id));
    }' unless defined(&gld_check_boardid);
    if(defined(&__cplusplus)) {
    }
}
1;
