require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PCSER_MANUSPEC_H)) {
    eval 'sub _PCSER_MANUSPEC_H () {1;}' unless defined(&_PCSER_MANUSPEC_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub PCSER_MODIFY_MANSPEC_PARAMS () {"pcser_modify_manspec_params";}' unless defined(&PCSER_MODIFY_MANSPEC_PARAMS);
    eval 'sub PCSPP_DEBUG_PARSE_LINE () {0x1;}' unless defined(&PCSPP_DEBUG_PARSE_LINE);
    eval 'sub PCSPP_DEBUG_SET_MSP () {0x2;}' unless defined(&PCSPP_DEBUG_SET_MSP);
    eval 'sub PCSPP_DSPMATCH () {0x4;}' unless defined(&PCSPP_DSPMATCH);
    eval 'sub PCSPP_DISPLAY () {0x10000000;}' unless defined(&PCSPP_DISPLAY);
    eval 'sub PCSPP_COMMENT () {0x20000000;}' unless defined(&PCSPP_COMMENT);
    eval 'sub PCSER_PARSE_QUOTE () {ord(\'\\\'\');}' unless defined(&PCSER_PARSE_QUOTE);
    eval 'sub PCSER_PARSE_COMMENT () {ord(\'#\');}' unless defined(&PCSER_PARSE_COMMENT);
    eval 'sub PCSER_PARSE_ESCAPE () {ord(\'\\\\\');}' unless defined(&PCSER_PARSE_ESCAPE);
    eval 'sub PCSER_PARSE_UNDERSCORE () {ord(\'_\');}' unless defined(&PCSER_PARSE_UNDERSCORE);
    eval 'sub PT_STATE_UNKNOWN () {0;}' unless defined(&PT_STATE_UNKNOWN);
    eval 'sub PT_STATE_TOKEN () {1;}' unless defined(&PT_STATE_TOKEN);
    eval 'sub PT_STATE_STRING_VAR () {2;}' unless defined(&PT_STATE_STRING_VAR);
    eval 'sub PT_STATE_HEX_VAR () {3;}' unless defined(&PT_STATE_HEX_VAR);
    eval 'sub PT_STATE_DEC_VAR () {4;}' unless defined(&PT_STATE_DEC_VAR);
    eval 'sub PT_STATE_ESCAPE () {5;}' unless defined(&PT_STATE_ESCAPE);
    eval 'sub PCSER_MATCH_MANUFACTURER () {0x1;}' unless defined(&PCSER_MATCH_MANUFACTURER);
    eval 'sub PCSER_MATCH_CARD () {0x2;}' unless defined(&PCSER_MATCH_CARD);
    eval 'sub PCSER_MATCH_VERS_1 () {0x4;}' unless defined(&PCSER_MATCH_VERS_1);
    eval 'sub PCSER_MATCH_MASK () {0xfff;}' unless defined(&PCSER_MATCH_MASK);
    eval 'sub PCSER_MANSPEC_TXBUFSIZE () {0x1000;}' unless defined(&PCSER_MANSPEC_TXBUFSIZE);
    eval 'sub PCSER_MANSPEC_RXBUFSIZE () {0x2000;}' unless defined(&PCSER_MANSPEC_RXBUFSIZE);
    eval 'sub PCSER_MANSPEC_FIFO_ENABLE () {0x4000;}' unless defined(&PCSER_MANSPEC_FIFO_ENABLE);
    eval 'sub PCSER_MANSPEC_FIFO_DISABLE () {0x8000;}' unless defined(&PCSER_MANSPEC_FIFO_DISABLE);
    eval 'sub PCSER_MANSPEC_AUTO_RTS () {0x10000;}' unless defined(&PCSER_MANSPEC_AUTO_RTS);
    eval 'sub PCSER_MANSPEC_AUTO_CTS () {0x20000;}' unless defined(&PCSER_MANSPEC_AUTO_CTS);
    eval 'sub PCSER_MANSPEC_READY_DELAY_1 () {0x40000;}' unless defined(&PCSER_MANSPEC_READY_DELAY_1);
    eval 'sub PCSER_MANSPEC_READY_DELAY_2 () {0x80000;}' unless defined(&PCSER_MANSPEC_READY_DELAY_2);
    eval 'sub PCSER_MANSPEC_CONFIG_INDEX () {0x100000;}' unless defined(&PCSER_MANSPEC_CONFIG_INDEX);
    eval 'sub PCSER_MANSPEC_CONFIG_ADDR () {0x200000;}' unless defined(&PCSER_MANSPEC_CONFIG_ADDR);
    eval 'sub PCSER_MANSPEC_CONFIG_PRESENT () {0x400000;}' unless defined(&PCSER_MANSPEC_CONFIG_PRESENT);
    eval 'sub PCSER_MANSPEC_NUM_IO_LINES () {0x800000;}' unless defined(&PCSER_MANSPEC_NUM_IO_LINES);
    eval 'sub PCSER_MANSPEC_NUM_IO_PORTS () {0x1000000;}' unless defined(&PCSER_MANSPEC_NUM_IO_PORTS);
    eval 'sub PCSER_MANSPEC_IO_ADDR () {0x2000000;}' unless defined(&PCSER_MANSPEC_IO_ADDR);
    eval 'sub PCSER_MANSPEC_CD_TIME () {0x4000000;}' unless defined(&PCSER_MANSPEC_CD_TIME);
    eval 'sub PCSER_MANSPEC_IGN_CD_ON_OPEN () {0x8000000;}' unless defined(&PCSER_MANSPEC_IGN_CD_ON_OPEN);
    eval 'sub PT_VAR_OFFSET {
        my($v) = @_;
	    eval q((( &void *)((( &pcser_manuspec_t *)0)->$v)));
    }' unless defined(&PT_VAR_OFFSET);
    eval 'sub PT_VAR_HEX () {0x1;}' unless defined(&PT_VAR_HEX);
    eval 'sub PT_VAR_DEC () {0x2;}' unless defined(&PT_VAR_DEC);
    eval 'sub PT_VAR_STRING () {0x3;}' unless defined(&PT_VAR_STRING);
    eval 'sub PT_VAR_BOOL () {0x4;}' unless defined(&PT_VAR_BOOL);
    eval 'sub PT_VAR_HEX_CTL () {0x5;}' unless defined(&PT_VAR_HEX_CTL);
    eval 'sub PT_VAR_BOOL_NONE () {0x;}' unless defined(&PT_VAR_BOOL_NONE);
    eval 'sub PT_VAR_BOOL_DISPLAY_ON () {0x1;}' unless defined(&PT_VAR_BOOL_DISPLAY_ON);
    eval 'sub PT_VAR_BOOL_DISPLAY_OFF () {0x2;}' unless defined(&PT_VAR_BOOL_DISPLAY_OFF);
    eval 'sub PT_VAR_HEX_CTL_DEBUG () {0x3;}' unless defined(&PT_VAR_HEX_CTL_DEBUG);
    eval 'sub PT_VAR_BOOL_DEBUG_STAT () {0x4;}' unless defined(&PT_VAR_BOOL_DEBUG_STAT);
    eval 'sub PT_VAR_BOOL_COMMENT_ON () {0x5;}' unless defined(&PT_VAR_BOOL_COMMENT_ON);
    eval 'sub PT_VAR_BOOL_COMMENT_OFF () {0x6;}' unless defined(&PT_VAR_BOOL_COMMENT_OFF);
    eval 'sub PT_VAR_HEX_CTL_PCSER_DEBUG () {0x7;}' unless defined(&PT_VAR_HEX_CTL_PCSER_DEBUG);
    eval 'sub PT_VAR_BOOL_DSPMATCH_ON () {0x8;}' unless defined(&PT_VAR_BOOL_DSPMATCH_ON);
    eval 'sub PT_VAR_BOOL_DSPMATCH_OFF () {0x9;}' unless defined(&PT_VAR_BOOL_DSPMATCH_OFF);
    eval 'sub PT_VAR_BOOL_CD_IGN () {0xa;}' unless defined(&PT_VAR_BOOL_CD_IGN);
    if(defined(&__cplusplus)) {
    }
}
1;
