require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PEM_H)) {
    eval 'sub _PEM_H () {1;}' unless defined(&_PEM_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub PEM_MAX_EVENTS () {64;}' unless defined(&PEM_MAX_EVENTS);
    eval 'sub PEM_IDNUM () {0x454d;}' unless defined(&PEM_IDNUM);
    eval 'sub PEM_NAME () {"pem";}' unless defined(&PEM_NAME);
    eval 'sub PEM_MIN () {0;}' unless defined(&PEM_MIN);
    eval 'sub PEM_MAX () {1024;}' unless defined(&PEM_MAX);
    eval 'sub PEM_HIWATER () {4096;}' unless defined(&PEM_HIWATER);
    eval 'sub PEM_LOWATER () {1024;}' unless defined(&PEM_LOWATER);
    eval 'sub EM_INIT_REQ () {0;}' unless defined(&EM_INIT_REQ);
    eval 'sub EM_INFO_REQ () {1;}' unless defined(&EM_INFO_REQ);
    eval 'sub EM_MODIFY_EVENT_MASK_REQ () {2;}' unless defined(&EM_MODIFY_EVENT_MASK_REQ);
    eval 'sub EM_GET_FIRST_TUPLE_REQ () {3;}' unless defined(&EM_GET_FIRST_TUPLE_REQ);
    eval 'sub EM_GET_NEXT_TUPLE_REQ () {4;}' unless defined(&EM_GET_NEXT_TUPLE_REQ);
    eval 'sub EM_INIT_ACK () {5;}' unless defined(&EM_INIT_ACK);
    eval 'sub EM_INFO_ACK () {6;}' unless defined(&EM_INFO_ACK);
    eval 'sub EM_EVENT_IND () {7;}' unless defined(&EM_EVENT_IND);
    eval 'sub EM_ADAPTER_INFO_REQ () {8;}' unless defined(&EM_ADAPTER_INFO_REQ);
    eval 'sub EM_ADAPTER_INFO_ACK () {9;}' unless defined(&EM_ADAPTER_INFO_ACK);
    eval 'sub EM_SOCKET_INFO_REQ () {10;}' unless defined(&EM_SOCKET_INFO_REQ);
    eval 'sub EM_SOCKET_INFO_ACK () {11;}' unless defined(&EM_SOCKET_INFO_ACK);
    eval 'sub EM_GET_SOCKET_REQ () {12;}' unless defined(&EM_GET_SOCKET_REQ);
    eval 'sub EM_GET_SOCKET_ACK () {13;}' unless defined(&EM_GET_SOCKET_ACK);
    eval 'sub EM_IDENT_SOCKET_REQ () {14;}' unless defined(&EM_IDENT_SOCKET_REQ);
    eval 'sub EM_GET_FIRST_TUPLE_ACK () {15;}' unless defined(&EM_GET_FIRST_TUPLE_ACK);
    eval 'sub EM_BADPRIM () {1;}' unless defined(&EM_BADPRIM);
    eval 'sub ___VERSION {
        my($a, $b) = @_;
	    eval q(((($a)<<8)|($b)));
    }' unless defined(&___VERSION);
    eval 'sub EM_VERSION () { &___VERSION(0, 1);}' unless defined(&EM_VERSION);
    eval 'sub EM_CURRENT_VERSION () { &EM_VERSION;}' unless defined(&EM_CURRENT_VERSION);
    eval 'sub EM_CLASS_SIZE () {32;}' unless defined(&EM_CLASS_SIZE);
    eval 'sub EM_EVENT_MASK_SIZE () {32;}' unless defined(&EM_EVENT_MASK_SIZE);
    if(defined( &_KERNEL)) {
	eval 'sub EM_EVENT_SIZE () {4;}' unless defined(&EM_EVENT_SIZE);
	eval 'sub EM_INIT () {1;}' unless defined(&EM_INIT);
	eval 'sub PEMF_EVENTS () {0x1;}' unless defined(&PEMF_EVENTS);
	eval 'sub PEMF_CLASSES () {0x2;}' unless defined(&PEMF_CLASSES);
	eval 'sub PEMF_INIT () {0x4;}' unless defined(&PEMF_INIT);
	eval 'sub PEMMAXINFO () {(16+ $sizeof{\'struct pcm_make_dev\'});}' unless defined(&PEMMAXINFO);
	eval 'sub PE_OWN_FREE () {0;}' unless defined(&PE_OWN_FREE);
	eval 'sub PE_OWN_CLAIMED () {1;}' unless defined(&PE_OWN_CLAIMED);
	eval 'sub PE_OWN_HANDLER () {2;}' unless defined(&PE_OWN_HANDLER);
	eval 'sub PEME_OK () {0;}' unless defined(&PEME_OK);
	eval 'sub PEME_NO_INFO () {1;}' unless defined(&PEME_NO_INFO);
	eval 'sub PEME_UNAVAILABLE () {2;}' unless defined(&PEME_UNAVAILABLE);
	eval 'sub PEME_NO_CIS () {3;}' unless defined(&PEME_NO_CIS);
	eval 'sub PEME_NO_TUPLE () {4;}' unless defined(&PEME_NO_TUPLE);
	eval 'sub PEMTRACE () {0x1;}' unless defined(&PEMTRACE);
	eval 'sub PEMERRS () {0x2;}' unless defined(&PEMERRS);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
