require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_QEC_H)) {
    eval 'sub _SYS_QEC_H () {1;}' unless defined(&_SYS_QEC_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub QECG_CONTROL_MODE () {(0xf0000000);}' unless defined(&QECG_CONTROL_MODE);
    eval 'sub QECG_CONTROL_MACE () {(0x40000000);}' unless defined(&QECG_CONTROL_MACE);
    eval 'sub QECG_CONTROL_BMAC () {(0x10000000);}' unless defined(&QECG_CONTROL_BMAC);
    eval 'sub QECG_CONTROL_PARITY () {(0x20);}' unless defined(&QECG_CONTROL_PARITY);
    eval 'sub QECG_CONTROL_ARB () {(0x18);}' unless defined(&QECG_CONTROL_ARB);
    eval 'sub QECG_CONTROL_BURST64 () {(0x4);}' unless defined(&QECG_CONTROL_BURST64);
    eval 'sub QECG_CONTROL_BURST32 () {(0x2);}' unless defined(&QECG_CONTROL_BURST32);
    eval 'sub QECG_CONTROL_BURST16 () {(0x);}' unless defined(&QECG_CONTROL_BURST16);
    eval 'sub QECG_CONTROL_RST () {(0x1);}' unless defined(&QECG_CONTROL_RST);
    eval 'sub QECG_STATUS_TINT () {(0x8);}' unless defined(&QECG_STATUS_TINT);
    eval 'sub QECG_STATUS_RINT () {(0x4);}' unless defined(&QECG_STATUS_RINT);
    eval 'sub QECG_STATUS_BMINT () {(0x2);}' unless defined(&QECG_STATUS_BMINT);
    eval 'sub QECG_STATUS_QECERR () {(0x1);}' unless defined(&QECG_STATUS_QECERR);
    eval 'sub QECG_PKTSIZE_2K () {(0x);}' unless defined(&QECG_PKTSIZE_2K);
    eval 'sub QECG_PKTSIZE_4K () {(0x1);}' unless defined(&QECG_PKTSIZE_4K);
    eval 'sub QECG_PKTSIZE_6K () {(0x10);}' unless defined(&QECG_PKTSIZE_6K);
    eval 'sub QECG_PKTSIZE_8K () {(0x11);}' unless defined(&QECG_PKTSIZE_8K);
    eval 'sub QECCHANBITS {
        my($v, $i) = @_;
	    eval q((($v >> ($i << 2)) & 0xf));
    }' unless defined(&QECCHANBITS);
    eval 'sub QECM_CONTROL_DRCV () {(0x4);}' unless defined(&QECM_CONTROL_DRCV);
    eval 'sub QECM_CONTROL_RST () {(0x2);}' unless defined(&QECM_CONTROL_RST);
    eval 'sub QECM_CONTROL_TDMD () {(0x1);}' unless defined(&QECM_CONTROL_TDMD);
    eval 'sub QECM_STATUS_EXDER () {(0x10000000);}' unless defined(&QECM_STATUS_EXDER);
    eval 'sub QECM_STATUS_LCAR () {(0x8000000);}' unless defined(&QECM_STATUS_LCAR);
    eval 'sub QECM_STATUS_RTRY () {(0x4000000);}' unless defined(&QECM_STATUS_RTRY);
    eval 'sub QECM_STATUS_LCOL () {(0x2000000);}' unless defined(&QECM_STATUS_LCOL);
    eval 'sub QECM_STATUS_UFLO () {(0x1000000);}' unless defined(&QECM_STATUS_UFLO);
    eval 'sub QECM_STATUS_JAB () {(0x800000);}' unless defined(&QECM_STATUS_JAB);
    eval 'sub QECM_STATUS_BABL () {(0x400000);}' unless defined(&QECM_STATUS_BABL);
    eval 'sub QECM_STATUS_TINT () {(0x200000);}' unless defined(&QECM_STATUS_TINT);
    eval 'sub QECM_STATUS_COLCO () {(0x100000);}' unless defined(&QECM_STATUS_COLCO);
    eval 'sub QECM_STATUS_TMDER () {(0x80000);}' unless defined(&QECM_STATUS_TMDER);
    eval 'sub QECM_STATUS_TXLATERR () {(0x40000);}' unless defined(&QECM_STATUS_TXLATERR);
    eval 'sub QECM_STATUS_TXPARERR () {(0x20000);}' unless defined(&QECM_STATUS_TXPARERR);
    eval 'sub QECM_STATUS_TXERRACK () {(0x10000);}' unless defined(&QECM_STATUS_TXERRACK);
    eval 'sub QECM_STATUS_RVCCO () {(0x1000);}' unless defined(&QECM_STATUS_RVCCO);
    eval 'sub QECM_STATUS_RPCO () {(0x800);}' unless defined(&QECM_STATUS_RPCO);
    eval 'sub QECM_STATUS_MPCO () {(0x400);}' unless defined(&QECM_STATUS_MPCO);
    eval 'sub QECM_STATUS_OFLO () {(0x200);}' unless defined(&QECM_STATUS_OFLO);
    eval 'sub QECM_STATUS_CLSN () {(0x100);}' unless defined(&QECM_STATUS_CLSN);
    eval 'sub QECM_STATUS_FMC () {(0x80);}' unless defined(&QECM_STATUS_FMC);
    eval 'sub QECM_STATUS_CRC () {(0x40);}' unless defined(&QECM_STATUS_CRC);
    eval 'sub QECM_STATUS_RINT () {(0x20);}' unless defined(&QECM_STATUS_RINT);
    eval 'sub QECM_STATUS_DROP () {(0x10);}' unless defined(&QECM_STATUS_DROP);
    eval 'sub QECM_STATUS_BUFF () {(0x8);}' unless defined(&QECM_STATUS_BUFF);
    eval 'sub QECM_STATUS_RXLATERR () {(0x4);}' unless defined(&QECM_STATUS_RXLATERR);
    eval 'sub QECM_STATUS_RXPARERR () {(0x2);}' unless defined(&QECM_STATUS_RXPARERR);
    eval 'sub QECM_STATUS_RXERRACK () {(0x1);}' unless defined(&QECM_STATUS_RXERRACK);
    eval 'sub QECM_STATUS_OTHER () {(0x1fdf3fdf);}' unless defined(&QECM_STATUS_OTHER);
    eval 'sub QECM_QECERRM_COLLM () {(0x100000);}' unless defined(&QECM_QECERRM_COLLM);
    eval 'sub QECM_QECERRM_TMDERM () {(0x80000);}' unless defined(&QECM_QECERRM_TMDERM);
    eval 'sub QECM_QECERRM_TXLATERRM () {(0x40000);}' unless defined(&QECM_QECERRM_TXLATERRM);
    eval 'sub QECM_QECERRM_TXPARERRM () {(0x20000);}' unless defined(&QECM_QECERRM_TXPARERRM);
    eval 'sub QECM_QECERRM_TXERRACKM () {(0x10000);}' unless defined(&QECM_QECERRM_TXERRACKM);
    eval 'sub QECM_QECERRM_DROPM () {(0x10);}' unless defined(&QECM_QECERRM_DROPM);
    eval 'sub QECM_QECERRM_BUFFM () {(0x8);}' unless defined(&QECM_QECERRM_BUFFM);
    eval 'sub QECM_QECERRM_RXLATERRM () {(0x4);}' unless defined(&QECM_QECERRM_RXLATERRM);
    eval 'sub QECM_QECERRM_RXPARERRM () {(0x2);}' unless defined(&QECM_QECERRM_RXPARERRM);
    eval 'sub QECM_QECERRM_RXERRACKM () {(0x1);}' unless defined(&QECM_QECERRM_RXERRACKM);
    eval 'sub QECM_MACERRM_EXDERM () {(0x10000000);}' unless defined(&QECM_MACERRM_EXDERM);
    eval 'sub QECM_MACERRM_LCARM () {(0x8000000);}' unless defined(&QECM_MACERRM_LCARM);
    eval 'sub QECM_MACERRM_RTRYM () {(0x4000000);}' unless defined(&QECM_MACERRM_RTRYM);
    eval 'sub QECM_MACERRM_LCOLM () {(0x2000000);}' unless defined(&QECM_MACERRM_LCOLM);
    eval 'sub QECM_MACERRM_UFLOM () {(0x1000000);}' unless defined(&QECM_MACERRM_UFLOM);
    eval 'sub QECM_MACERRM_JABM () {(0x800000);}' unless defined(&QECM_MACERRM_JABM);
    eval 'sub QECM_MACERRM_BABLM () {(0x400000);}' unless defined(&QECM_MACERRM_BABLM);
    eval 'sub QECM_MACERRM_OFLOM () {(0x800);}' unless defined(&QECM_MACERRM_OFLOM);
    eval 'sub QECM_MACERRM_RVCCOM () {(0x400);}' unless defined(&QECM_MACERRM_RVCCOM);
    eval 'sub QECM_MACERRM_RPCOM () {(0x200);}' unless defined(&QECM_MACERRM_RPCOM);
    eval 'sub QECM_MACERRM_MPCOM () {(0x100);}' unless defined(&QECM_MACERRM_MPCOM);
    eval 'sub QECM_PIFS_ENABLE () {(0x20);}' unless defined(&QECM_PIFS_ENABLE);
    eval 'sub QECM_PIFS_MANUAL () {(0x10);}' unless defined(&QECM_PIFS_MANUAL);
    eval 'sub QECM_PIFS_1920 () {(0xf);}' unless defined(&QECM_PIFS_1920);
    eval 'sub QECM_PIFS_1792 () {(0xe);}' unless defined(&QECM_PIFS_1792);
    eval 'sub QECM_PIFS_1664 () {(0xd);}' unless defined(&QECM_PIFS_1664);
    eval 'sub QECM_PIFS_1536 () {(0xc);}' unless defined(&QECM_PIFS_1536);
    eval 'sub QECM_PIFS_1408 () {(0xb);}' unless defined(&QECM_PIFS_1408);
    eval 'sub QECM_PIFS_1280 () {(0xa);}' unless defined(&QECM_PIFS_1280);
    eval 'sub QECM_PIFS_1152 () {(0x9);}' unless defined(&QECM_PIFS_1152);
    eval 'sub QECM_PIFS_1024 () {(0x8);}' unless defined(&QECM_PIFS_1024);
    eval 'sub QECM_PIFS_896 () {(0x7);}' unless defined(&QECM_PIFS_896);
    eval 'sub QECM_PIFS_768 () {(0x6);}' unless defined(&QECM_PIFS_768);
    eval 'sub QECM_PIFS_640 () {(0x5);}' unless defined(&QECM_PIFS_640);
    eval 'sub QECM_PIFS_512 () {(0x4);}' unless defined(&QECM_PIFS_512);
    eval 'sub QECM_PIFS_384 () {(0x3);}' unless defined(&QECM_PIFS_384);
    eval 'sub QECM_PIFS_256 () {(0x2);}' unless defined(&QECM_PIFS_256);
    eval 'sub QECM_PIFS_128 () {(0x1);}' unless defined(&QECM_PIFS_128);
    eval 'sub QECM_PIFS_2048 () {(0x);}' unless defined(&QECM_PIFS_2048);
    eval 'sub QECB_CONTROL_TDMD () {(0x1);}' unless defined(&QECB_CONTROL_TDMD);
    eval 'sub QECB_STATUS_MACE () {(0x80000000);}' unless defined(&QECB_STATUS_MACE);
    eval 'sub QECB_STATUS_TINT () {(0x200000);}' unless defined(&QECB_STATUS_TINT);
    eval 'sub QECB_STATUS_TMDER () {(0x80000);}' unless defined(&QECB_STATUS_TMDER);
    eval 'sub QECB_STATUS_TXLATERR () {(0x40000);}' unless defined(&QECB_STATUS_TXLATERR);
    eval 'sub QECB_STATUS_TXPARERR () {(0x20000);}' unless defined(&QECB_STATUS_TXPARERR);
    eval 'sub QECB_STATUS_TXERRACK () {(0x10000);}' unless defined(&QECB_STATUS_TXERRACK);
    eval 'sub QECB_STATUS_RINT () {(0x20);}' unless defined(&QECB_STATUS_RINT);
    eval 'sub QECB_STATUS_DROP () {(0x10);}' unless defined(&QECB_STATUS_DROP);
    eval 'sub QECB_STATUS_BUFF () {(0x8);}' unless defined(&QECB_STATUS_BUFF);
    eval 'sub QECB_STATUS_RXLATERR () {(0x4);}' unless defined(&QECB_STATUS_RXLATERR);
    eval 'sub QECB_STATUS_RXPARERR () {(0x2);}' unless defined(&QECB_STATUS_RXPARERR);
    eval 'sub QECB_STATUS_RXERRACK () {(0x1);}' unless defined(&QECB_STATUS_RXERRACK);
    eval 'sub QECB_STATUS_ERR () {(0x800f001f);}' unless defined(&QECB_STATUS_ERR);
    eval 'sub QECB_STATUS_INTR () {(0x802f003f);}' unless defined(&QECB_STATUS_INTR);
    eval 'sub QECB_STATUS_QEC () {(0xf001f);}' unless defined(&QECB_STATUS_QEC);
    eval 'sub QECB_QECERRM_TMDERM () {(0x80000);}' unless defined(&QECB_QECERRM_TMDERM);
    eval 'sub QECB_QECERRM_TXLATERRM () {(0x40000);}' unless defined(&QECB_QECERRM_TXLATERRM);
    eval 'sub QECB_QECERRM_TXPARERRM () {(0x20000);}' unless defined(&QECB_QECERRM_TXPARERRM);
    eval 'sub QECB_QECERRM_TXERRACKM () {(0x10000);}' unless defined(&QECB_QECERRM_TXERRACKM);
    eval 'sub QECB_QECERRM_DROPM () {(0x10);}' unless defined(&QECB_QECERRM_DROPM);
    eval 'sub QECB_QECERRM_BUFFM () {(0x8);}' unless defined(&QECB_QECERRM_BUFFM);
    eval 'sub QECB_QECERRM_RXLATERRM () {(0x4);}' unless defined(&QECB_QECERRM_RXLATERRM);
    eval 'sub QECB_QECERRM_RXPARERRM () {(0x2);}' unless defined(&QECB_QECERRM_RXPARERRM);
    eval 'sub QECB_QECERRM_RXERRACKM () {(0x1);}' unless defined(&QECB_QECERRM_RXERRACKM);
    eval 'sub QECB_BMACERRM_EXDERM () {(0x1);}' unless defined(&QECB_BMACERRM_EXDERM);
    eval 'sub QMD_OWN () {(0x80000000);}' unless defined(&QMD_OWN);
    eval 'sub QMD_SOP () {(0x40000000);}' unless defined(&QMD_SOP);
    eval 'sub QMD_EOP () {(0x20000000);}' unless defined(&QMD_EOP);
    eval 'sub QMD_INUSE () {(0x10000000);}' unless defined(&QMD_INUSE);
    eval 'sub QMD_MACE_BUFLEN () {(0x7ff);;}' unless defined(&QMD_MACE_BUFLEN);
    eval 'sub QMD_BMAC_BUFLEN () {(0x1fff);;}' unless defined(&QMD_BMAC_BUFLEN);
    eval 'sub QEC_QMDMAX () {(256);}' unless defined(&QEC_QMDMAX);
    eval 'sub QEC_QMDALIGN () {(2048);}' unless defined(&QEC_QMDALIGN);
    if(defined(&MPSAS)) {
	eval 'sub QECMAXRSTDELAY () {(1000000);}' unless defined(&QECMAXRSTDELAY);
    } else {
	eval 'sub QECMAXRSTDELAY () {(100);}' unless defined(&QECMAXRSTDELAY);
    }
    eval 'sub QECPERIOD () {10;}' unless defined(&QECPERIOD);
    eval 'sub QECWAITPERIOD () { &QECPERIOD;}' unless defined(&QECWAITPERIOD);
    eval 'sub QECDELAY {
        my($c, $n) = @_;
	    eval q({  &register \'int\'  &N = $n /  &QECWAITPERIOD;  &while (-- &N > 0) {  &if ($c)  &break;  &drv_usecwait( &QECWAITPERIOD); } });
    }' unless defined(&QECDELAY);
    if(defined(&__cplusplus)) {
    }
}
1;
