require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_RCE_H)) {
    eval 'sub _SYS_RCE_H () {1;}' unless defined(&_SYS_RCE_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    require 'sys/systm.ph';
    require 'sys/cred.ph';
    require 'sys/vfs.ph';
    require 'sys/priocntl.ph';
    require 'sys/proc.ph';
    eval 'sub SRM_IF_MAJOR () {6;}' unless defined(&SRM_IF_MAJOR);
    eval 'sub SRM_IF_MINOR () {0;}' unless defined(&SRM_IF_MINOR);
    eval 'sub SRM_STRINGIT {
        my($s) = @_;
	    eval q($s);
    }' unless defined(&SRM_STRINGIT);
    eval 'sub SRM_MK_VERSION {
        my($m, $n) = @_;
	    eval q( &SRM_STRINGIT($m) \\".\\"  &SRM_STRINGIT($n));
    }' unless defined(&SRM_MK_VERSION);
    eval 'sub _SRM_INTERFACE_VERSION () { &SRM_MK_VERSION( &SRM_IF_MAJOR,  &SRM_IF_MINOR);}' unless defined(&_SRM_INTERFACE_VERSION);
    eval 'sub SRM_ON () { &rce_ops;}' unless defined(&SRM_ON);
    eval 'sub SRM_ACTIVE () {( &rce_ops !=  &NULL);}' unless defined(&SRM_ACTIVE);
    eval 'sub SRM_START {
        my($c, $p) = @_;
	    eval q(( &SRM_ON ?  ($r$ce_ops->{r$ce_start})(($c), ($p)) : 0));
    }' unless defined(&SRM_START);
    eval 'sub SRM_LIMITMEMORY {
        my($n, $a, $l) = @_;
	    eval q(( &SRM_ON ?  ($rce_ops->{rce_limitmemory})(($n), ($a), ($l)) : 0));
    }' unless defined(&SRM_LIMITMEMORY);
    eval 'sub SRM_EXIT {
        my($p) = @_;
	    eval q(( &SRM_ON ?  ($rce_ops->{rce_exit})(($p)) : ( &void)0));
    }' unless defined(&SRM_EXIT);
    eval 'sub SRM_FLUSH {
        my($a) = @_;
	    eval q(( &SRM_ON ?  ($rce_ops->{rce_flush})(($a)) : ( &void)0));
    }' unless defined(&SRM_FLUSH);
    eval 'sub SRM_PROCCREATE {
        my($p) = @_;
	    eval q(( &SRM_ON ?  ($rce_ops->{rce_proccreate})(($p)) : 0));
    }' unless defined(&SRM_PROCCREATE);
    eval 'sub SRM_PROCDESTROY {
        my($p) = @_;
	    eval q(( &SRM_ON ?  ($rce_ops->{rce_procdestroy})(($p)) : ( &void)0));
    }' unless defined(&SRM_PROCDESTROY);
    eval 'sub SRM_SETUID {
        my($e, $c) = @_;
	    eval q(( &SRM_ON ?  ($r$ce_ops->{r$ce_setuid})(($e), ($c)) : ( &void)0));
    }' unless defined(&SRM_SETUID);
    eval 'sub SRM_LWPFAIL {
        my($p, $t) = @_;
	    eval q(( &SRM_ON ?  ($rce_ops->{rce_lwpfail})(($p), ($t)) : ( &void)0));
    }' unless defined(&SRM_LWPFAIL);
    eval 'sub SRM_LWPEXIT {
        my($p, $t) = @_;
	    eval q(( &SRM_ON ?  ($rce_ops->{rce_lwpexit})(($p), ($t)) : ( &void)0));
    }' unless defined(&SRM_LWPEXIT);
    eval 'sub SRM_LWPNEW {
        my($p) = @_;
	    eval q(( &SRM_ON ?  ($rce_ops->{rce_lwpnew})(($p)) : 0));
    }' unless defined(&SRM_LWPNEW);
    eval 'sub SRM_LIMID {
        my($p) = @_;
	    eval q(( &SRM_ON ?  ($rce_ops->{rce_limid})(($p)) : 0));
    }' unless defined(&SRM_LIMID);
    eval 'sub LI_ENFORCE () {(0x1);}' unless defined(&LI_ENFORCE);
    eval 'sub LI_UPDATE () {(0x2);}' unless defined(&LI_UPDATE);
    eval 'sub LI_ALLOC () {(0x4);}' unless defined(&LI_ALLOC);
    eval 'sub LI_FREE () {(0x8);}' unless defined(&LI_FREE);
    eval 'sub LI_DUP () {(0x10);}' unless defined(&LI_DUP);
    eval 'sub SH_NOW () {(0);}' unless defined(&SH_NOW);
    eval 'sub SH_CPR () {(-1);}' unless defined(&SH_CPR);
    eval 'sub SH_SUSPEND () { &SH_CPR;}' unless defined(&SH_SUSPEND);
    eval 'sub SH_RESUME () { &SH_CPR;}' unless defined(&SH_RESUME);
    eval 'sub SH_RUID () {0;}' unless defined(&SH_RUID);
    eval 'sub SH_EUID () {1;}' unless defined(&SH_EUID);
    if(defined(&__cplusplus)) {
    }
}
1;
