require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_RSM_RSM_H)) {
    eval 'sub _SYS_RSM_RSM_H () {1;}' unless defined(&_SYS_RSM_RSM_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/rsm/rsm_common.ph';
    require 'sys/rsm/rsmapi_common.ph';
    eval 'sub RSM_IOCTL_CONTROLLER () {0x;}' unless defined(&RSM_IOCTL_CONTROLLER);
    eval 'sub RSM_IOCTL_EXPORT_SEG () {0x10;}' unless defined(&RSM_IOCTL_EXPORT_SEG);
    eval 'sub RSM_IOCTL_IMPORT_SEG () {0x20;}' unless defined(&RSM_IOCTL_IMPORT_SEG);
    eval 'sub RSM_IOCTL_QUEUE () {0x30;}' unless defined(&RSM_IOCTL_QUEUE);
    eval 'sub RSM_IOCTL_TOPOLOGY () {0x40;}' unless defined(&RSM_IOCTL_TOPOLOGY);
    eval 'sub RSM_IOCTL_BAR () {0x50;}' unless defined(&RSM_IOCTL_BAR);
    eval 'sub RSM_IOCTL_ERRCNT () {0x60;}' unless defined(&RSM_IOCTL_ERRCNT);
    eval 'sub RSM_IOCTL_BELL () {0x70;}' unless defined(&RSM_IOCTL_BELL);
    eval 'sub RSM_IOCTL_IOVEC () {0x80;}' unless defined(&RSM_IOCTL_IOVEC);
    eval 'sub RSM_IOCTL_MAP_ADDR () {0x90;}' unless defined(&RSM_IOCTL_MAP_ADDR);
    eval 'sub RSM_IOCTL_ATTR () { &RSM_IOCTL_CONTROLLER + 0x;}' unless defined(&RSM_IOCTL_ATTR);
    eval 'sub RSM_IOCTL_BAR_INFO () { &RSM_IOCTL_CONTROLLER + 0x1;}' unless defined(&RSM_IOCTL_BAR_INFO);
    eval 'sub RSM_IOCTL_CREATE () { &RSM_IOCTL_EXPORT_SEG + 0x1;}' unless defined(&RSM_IOCTL_CREATE);
    eval 'sub RSM_IOCTL_BIND () { &RSM_IOCTL_EXPORT_SEG + 0x3;}' unless defined(&RSM_IOCTL_BIND);
    eval 'sub RSM_IOCTL_REBIND () { &RSM_IOCTL_EXPORT_SEG + 0x4;}' unless defined(&RSM_IOCTL_REBIND);
    eval 'sub RSM_IOCTL_UNBIND () { &RSM_IOCTL_EXPORT_SEG + 0x5;}' unless defined(&RSM_IOCTL_UNBIND);
    eval 'sub RSM_IOCTL_PUBLISH () { &RSM_IOCTL_EXPORT_SEG + 0x6;}' unless defined(&RSM_IOCTL_PUBLISH);
    eval 'sub RSM_IOCTL_REPUBLISH () { &RSM_IOCTL_EXPORT_SEG + 0x7;}' unless defined(&RSM_IOCTL_REPUBLISH);
    eval 'sub RSM_IOCTL_UNPUBLISH () { &RSM_IOCTL_EXPORT_SEG + 0x8;}' unless defined(&RSM_IOCTL_UNPUBLISH);
    eval 'sub RSM_IOCTL_CONNECT () { &RSM_IOCTL_IMPORT_SEG + 0x;}' unless defined(&RSM_IOCTL_CONNECT);
    eval 'sub RSM_IOCTL_DISCONNECT () { &RSM_IOCTL_IMPORT_SEG + 0x1;}' unless defined(&RSM_IOCTL_DISCONNECT);
    eval 'sub RSM_IOCTL_TOPOLOGY_SIZE () { &RSM_IOCTL_TOPOLOGY + 0x1;}' unless defined(&RSM_IOCTL_TOPOLOGY_SIZE);
    eval 'sub RSM_IOCTL_TOPOLOGY_DATA () { &RSM_IOCTL_TOPOLOGY + 0x2;}' unless defined(&RSM_IOCTL_TOPOLOGY_DATA);
    eval 'sub RSM_IOCTL_GETV () { &RSM_IOCTL_IOVEC + 0x1;}' unless defined(&RSM_IOCTL_GETV);
    eval 'sub RSM_IOCTL_PUTV () { &RSM_IOCTL_IOVEC + 0x2;}' unless defined(&RSM_IOCTL_PUTV);
    eval 'sub RSM_IOCTL_BAR_OPEN () { &RSM_IOCTL_BAR + 0x1;}' unless defined(&RSM_IOCTL_BAR_OPEN);
    eval 'sub RSM_IOCTL_BAR_ORDER () { &RSM_IOCTL_BAR + 0x2;}' unless defined(&RSM_IOCTL_BAR_ORDER);
    eval 'sub RSM_IOCTL_BAR_CLOSE () { &RSM_IOCTL_BAR + 0x3;}' unless defined(&RSM_IOCTL_BAR_CLOSE);
    eval 'sub RSM_IOCTL_BAR_CHECK () { &RSM_IOCTL_BAR + 0x4;}' unless defined(&RSM_IOCTL_BAR_CHECK);
    eval 'sub RSM_IOCTL_RING_BELL () { &RSM_IOCTL_BELL + 0x1;}' unless defined(&RSM_IOCTL_RING_BELL);
    eval 'sub RSM_IOCTL_MAP_TO_ADDR () { &RSM_IOCTL_MAP_ADDR + 0x1;}' unless defined(&RSM_IOCTL_MAP_TO_ADDR);
    eval 'sub RSM_IOCTL_MAP_TO_NODEID () { &RSM_IOCTL_MAP_ADDR + 0x2;}' unless defined(&RSM_IOCTL_MAP_TO_NODEID);
    eval 'sub RSM_IOCTL_CMDGRP {
        my($cmd) = @_;
	    eval q((($cmd) & 0xfffffff0));
    }' unless defined(&RSM_IOCTL_CMDGRP);
    eval 'sub BETWEEN {
        my($x, $lo, $hi) = @_;
	    eval q(((($x) >= ($lo))  && (($x) <= ($hi))));
    }' unless defined(&BETWEEN);
    eval 'sub RSM_MAX_IOVLEN () {4;}' unless defined(&RSM_MAX_IOVLEN);
    eval 'sub RSM_KERNEL_AGENT () {0x1000;}' unless defined(&RSM_KERNEL_AGENT);
    eval 'sub RSM_LIBRARY () {0x2000;}' unless defined(&RSM_LIBRARY);
    eval 'sub RSM_OPS () {0x4000;}' unless defined(&RSM_OPS);
    eval 'sub RSM_PATH_MANAGER () {0x8000;}' unless defined(&RSM_PATH_MANAGER);
    eval 'sub RSM_MODULE_ALL () {0xf000;}' unless defined(&RSM_MODULE_ALL);
    eval 'sub RSM_IMPORT () {0x100;}' unless defined(&RSM_IMPORT);
    eval 'sub RSM_EXPORT () {0x200;}' unless defined(&RSM_EXPORT);
    eval 'sub RSM_LOOPBACK () {0x400;}' unless defined(&RSM_LOOPBACK);
    eval 'sub RSM_FUNC_ALL () {0xf00;}' unless defined(&RSM_FUNC_ALL);
    eval 'sub RSM_DDI () {0x10;}' unless defined(&RSM_DDI);
    eval 'sub RSM_IO_ROUTINES () {0x20;}' unless defined(&RSM_IO_ROUTINES);
    eval 'sub RSM_IOCTL () {0x40;}' unless defined(&RSM_IOCTL);
    eval 'sub RSM_INTR_CALLBACK () {0x80;}' unless defined(&RSM_INTR_CALLBACK);
    eval 'sub RSM_OPER_ALL () {0xf0;}' unless defined(&RSM_OPER_ALL);
    eval 'sub RSM_FLOWCONTROL () {0x1;}' unless defined(&RSM_FLOWCONTROL);
    eval 'sub RSM_KERNEL_ALL () {( &RSM_KERNEL_AGENT |  &RSM_PATH_MANAGER | 0xfff);}' unless defined(&RSM_KERNEL_ALL);
    eval 'sub RSM_ALL () {0xffff;}' unless defined(&RSM_ALL);
    eval 'sub RSM_DEBUG_VERBOSE () {6;}' unless defined(&RSM_DEBUG_VERBOSE);
    eval 'sub RSM_DEBUG_LVL2 () {5;}' unless defined(&RSM_DEBUG_LVL2);
    eval 'sub RSM_DEBUG_LVL1 () {4;}' unless defined(&RSM_DEBUG_LVL1);
    eval 'sub RSM_DEBUG () {3;}' unless defined(&RSM_DEBUG);
    eval 'sub RSM_NOTICE () {2;}' unless defined(&RSM_NOTICE);
    eval 'sub RSM_WARNING () {1;}' unless defined(&RSM_WARNING);
    eval 'sub RSM_ERR () {0;}' unless defined(&RSM_ERR);
    if(defined(&DEBUG)) {
	eval 'sub DBG_DEFINE {
	    my($var, $value) = @_;
    	    eval q(\'int\' $var = ($value));
	}' unless defined(&DBG_DEFINE);
	eval 'sub DBG_DEFINE_STR {
	    my($var, $value) = @_;
    	    eval q(\'char\' *$var = ($value));
	}' unless defined(&DBG_DEFINE_STR);
	eval 'sub DBG_ADDCATEGORY {
	    my($var, $category) = @_;
    	    eval q(($var |= ($category)));
	}' unless defined(&DBG_ADDCATEGORY);
	eval 'sub DBG_PRINTF {
	    my($message) = @_;
    	    eval q( &dbg_printf $message);
	}' unless defined(&DBG_PRINTF);
    } else {
	eval 'sub DBG_DEFINE {
	    my($var, $value) = @_;
    	    eval q();
	}' unless defined(&DBG_DEFINE);
	eval 'sub DBG_DEFINE_STR {
	    my($var, $value) = @_;
    	    eval q();
	}' unless defined(&DBG_DEFINE_STR);
	eval 'sub DBG_ADDCATEGORY {
	    my($var, $category) = @_;
    	    eval q();
	}' unless defined(&DBG_ADDCATEGORY);
	eval 'sub DBG_PRINTF {
	    my($message) = @_;
    	    eval q();
	}' unless defined(&DBG_PRINTF);
    }
    if(defined(&_SYSCALL32)) {
    }
    if(defined(&_SYSCALL32)) {
    }
    if(defined(&_SYSCALL32)) {
    }
    if(defined(&_SYSCALL32)) {
    }
    eval 'sub RSMIPC_MSG_SEGCONNECT () {0;}' unless defined(&RSMIPC_MSG_SEGCONNECT);
    eval 'sub RSMIPC_MSG_DISCONNECT () {1;}' unless defined(&RSMIPC_MSG_DISCONNECT);
    eval 'sub RSMIPC_MSG_IMPORTING () {2;}' unless defined(&RSMIPC_MSG_IMPORTING);
    eval 'sub RSMIPC_MSG_NOTIMPORTING () {3;}' unless defined(&RSMIPC_MSG_NOTIMPORTING);
    eval 'sub RSMIPC_MSG_REPLY () {4;}' unless defined(&RSMIPC_MSG_REPLY);
    eval 'sub RSMIPC_MSG_BELL () {5;}' unless defined(&RSMIPC_MSG_BELL);
    eval 'sub RSMIPC_MSG_REPUBLISH () {6;}' unless defined(&RSMIPC_MSG_REPUBLISH);
    eval 'sub RSMIPC_MSG_SUSPEND () {7;}' unless defined(&RSMIPC_MSG_SUSPEND);
    eval 'sub RSMIPC_MSG_SUSPEND_DONE () {8;}' unless defined(&RSMIPC_MSG_SUSPEND_DONE);
    eval 'sub RSMIPC_MSG_RESUME () {9;}' unless defined(&RSMIPC_MSG_RESUME);
    eval 'sub RSMIPC_MSG_SQREADY () {10;}' unless defined(&RSMIPC_MSG_SQREADY);
    eval 'sub RSMIPC_MSG_SQREADY_ACK () {11;}' unless defined(&RSMIPC_MSG_SQREADY_ACK);
    eval 'sub RSMIPC_MSG_CREDIT () {12;}' unless defined(&RSMIPC_MSG_CREDIT);
    eval 'sub RSM_NO_REPLY () {0;}' unless defined(&RSM_NO_REPLY);
    if(defined(&__cplusplus)) {
    }
}
1;
