require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_RSM_RSMPI_H)) {
    eval 'sub _SYS_RSM_RSMPI_H () {1;}' unless defined(&_SYS_RSM_RSMPI_H);
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_KERNEL)) {
    }
    require 'sys/sunddi.ph';
    require 'sys/rsm/rsm_common.ph';
    eval 'sub RSM_RESOURCE_SLEEP () {( &rsm_resource_callback_t)0;}' unless defined(&RSM_RESOURCE_SLEEP);
    eval 'sub RSM_RESOURCE_DONTWAIT () {( &rsm_resource_callback_t)-1;}' unless defined(&RSM_RESOURCE_DONTWAIT);
    eval 'sub RSM_ALLOW_UNBIND_REBIND () {0x1;}' unless defined(&RSM_ALLOW_UNBIND_REBIND);
    eval 'sub RSM_INTR_T_DRV_BASE () {0;}' unless defined(&RSM_INTR_T_DRV_BASE);
    eval 'sub RSM_INTR_T_DRV_END () {0x3f;}' unless defined(&RSM_INTR_T_DRV_END);
    eval 'sub RSM_INTR_T_FRM_BASE () {0x40;}' unless defined(&RSM_INTR_T_FRM_BASE);
    eval 'sub RSM_INTR_T_FRM_END () {0x4f;}' unless defined(&RSM_INTR_T_FRM_END);
    eval 'sub RSM_INTR_T_RESERVED_BASE () {0x50;}' unless defined(&RSM_INTR_T_RESERVED_BASE);
    eval 'sub RSM_INTR_T_RESERVED_END () {0x5f;}' unless defined(&RSM_INTR_T_RESERVED_END);
    eval 'sub RSM_INTR_T_SUN_BASE () {0x60;}' unless defined(&RSM_INTR_T_SUN_BASE);
    eval 'sub RSM_INTR_T_SUN_END () {0xdf;}' unless defined(&RSM_INTR_T_SUN_END);
    eval 'sub RSM_INTR_T_USR_BASE () {0xe0;}' unless defined(&RSM_INTR_T_USR_BASE);
    eval 'sub RSM_INTR_T_USR_END () {0xff;}' unless defined(&RSM_INTR_T_USR_END);
    eval 'sub RSM_INTR_T_NSVC () {0x100;}' unless defined(&RSM_INTR_T_NSVC);
    eval 'sub RSM_KS_NAME () {"rsmpi_stat";}' unless defined(&RSM_KS_NAME);
    eval 'sub RSM_KS_CTLR_STATE () {"ctlr_state";}' unless defined(&RSM_KS_CTLR_STATE);
    eval 'sub RSM_KS_ADDR () {"addr";}' unless defined(&RSM_KS_ADDR);
    eval 'sub RSM_KS_EX_MEMSEGS () {"ex_memsegs";}' unless defined(&RSM_KS_EX_MEMSEGS);
    eval 'sub RSM_KS_EX_MEMSEGS_PUB () {"ex_memsegs_pub";}' unless defined(&RSM_KS_EX_MEMSEGS_PUB);
    eval 'sub RSM_KS_EX_MEMSEGS_CON () {"ex_memsegs_con";}' unless defined(&RSM_KS_EX_MEMSEGS_CON);
    eval 'sub RSM_KS_BYTES_BOUND () {"bytes_bound";}' unless defined(&RSM_KS_BYTES_BOUND);
    eval 'sub RSM_KS_IM_MEMSEGS_CON () {"im_memsegs_con";}' unless defined(&RSM_KS_IM_MEMSEGS_CON);
    eval 'sub RSM_KS_SENDQS () {"sendqs";}' unless defined(&RSM_KS_SENDQS);
    eval 'sub RSM_KS_HANDLERS () {"handlers";}' unless defined(&RSM_KS_HANDLERS);
    eval 'sub RSM_AE_CTLR_DOWN () {"rsm_down";}' unless defined(&RSM_AE_CTLR_DOWN);
    eval 'sub RSM_AE_CTLR_UP () {"rsm_up";}' unless defined(&RSM_AE_CTLR_UP);
    eval 'sub RSM_INTR_SEND_Q_NO_FENCE () {0x1;}' unless defined(&RSM_INTR_SEND_Q_NO_FENCE);
    eval 'sub RSM_INTR_SEND_Q_FULL_FAIL () {0x2;}' unless defined(&RSM_INTR_SEND_Q_FULL_FAIL);
    eval 'sub RSM_INTR_SEND_Q_UNRELIABLE () {0x4;}' unless defined(&RSM_INTR_SEND_Q_UNRELIABLE);
    eval 'sub RSM_INTR_SEND_QUEUE () {0x1;}' unless defined(&RSM_INTR_SEND_QUEUE);
    eval 'sub RSM_INTR_SEND_DELIVER () {0x2;}' unless defined(&RSM_INTR_SEND_DELIVER);
    eval 'sub RSM_INTR_SEND_POLL () {0x4;}' unless defined(&RSM_INTR_SEND_POLL);
    eval 'sub RSM_INTR_SEND_SLEEP () {0x8;}' unless defined(&RSM_INTR_SEND_SLEEP);
    eval 'sub RSM_INTR_SEND_LOWER_FENCE () {0x10;}' unless defined(&RSM_INTR_SEND_LOWER_FENCE);
    eval("sub RSM_INTR_HAND_UNCLAIMED () { 0; }") unless defined(&RSM_INTR_HAND_UNCLAIMED);
    eval("sub RSM_INTR_HAND_CLAIMED () { 1; }") unless defined(&RSM_INTR_HAND_CLAIMED);
    eval("sub RSM_INTR_HAND_CLAIMED_EXCLUSIVE () { 2; }") unless defined(&RSM_INTR_HAND_CLAIMED_EXCLUSIVE);
    eval("sub RSM_INTR_Q_OP_CREATE () { 0; }") unless defined(&RSM_INTR_Q_OP_CREATE);
    eval("sub RSM_INTR_Q_OP_CONFIGURE () { 1; }") unless defined(&RSM_INTR_Q_OP_CONFIGURE);
    eval("sub RSM_INTR_Q_OP_DESTROY () { 2; }") unless defined(&RSM_INTR_Q_OP_DESTROY);
    eval("sub RSM_INTR_Q_OP_RECEIVE () { 3; }") unless defined(&RSM_INTR_Q_OP_RECEIVE);
    eval("sub RSM_INTR_Q_OP_DROP () { 4; }") unless defined(&RSM_INTR_Q_OP_DROP);
    eval 'sub RSM_ACCESS_PUBLIC () {0xffff;}' unless defined(&RSM_ACCESS_PUBLIC);
    eval("sub RSM_MEM_VADDR () { 0; }") unless defined(&RSM_MEM_VADDR);
    eval("sub RSM_MEM_BUF () { 1; }") unless defined(&RSM_MEM_BUF);
    eval("sub RSM_MEM_HANDLE () { 2; }") unless defined(&RSM_MEM_HANDLE);
    eval("sub RSM_MEM_INVALID () { 3; }") unless defined(&RSM_MEM_INVALID);
    eval 'sub ms_bp () { ($ms_memory->{bp});}' unless defined(&ms_bp);
    eval 'sub ms_vaddr () { ($ms_memory->{vr}->{vaddr});}' unless defined(&ms_vaddr);
    eval 'sub ms_length () { ($ms_memory->{vr}->{length});}' unless defined(&ms_length);
    eval 'sub ms_as () { ($ms_memory->{vr}->{as});}' unless defined(&ms_as);
    eval 'sub RSM_ERR_NOCHANGE () {0;}' unless defined(&RSM_ERR_NOCHANGE);
    eval 'sub RSM_ERR_ZEROES () {0x1;}' unless defined(&RSM_ERR_ZEROES);
    eval 'sub RSM_ERR_RANDOM () {0x2;}' unless defined(&RSM_ERR_RANDOM);
    eval 'sub RSM_SEG_CREATE {
        my($controller, $memseg, $size, $flags, $memory, $callback, 	$callback_arg) = @_;
	    eval q((*(($controller). ($ops->{rsm_seg_create}))) (($controller). &handle, ($memseg), ($size), ($flags), ($memory), ($callback), ($callback_arg)));
    }' unless defined(&RSM_SEG_CREATE);
    eval 'sub RSM_SEG_DESTROY {
        my($controller, $memseg) = @_;
	    eval q((*(($controller). ($ops->{rsm_seg_destroy}))) (($memseg)));
    }' unless defined(&RSM_SEG_DESTROY);
    eval 'sub RSM_BIND {
        my($controller, $memseg, $offset, $memory, $callback, 	$callback_arg) = @_;
	    eval q((*(($controller). ($ops->{rsm_bind}))) (($memseg), $offset, ($memory), ($callback), ($callback_arg)));
    }' unless defined(&RSM_BIND);
    eval 'sub RSM_UNBIND {
        my($controller, $memseg, $offset, $length) = @_;
	    eval q((*(($controller). ($ops->{rsm_unbind}))) (($memseg), ($offset), ($length)));
    }' unless defined(&RSM_UNBIND);
    eval 'sub RSM_REBIND {
        my($controller, $memseg, $offset, $memory, $callback, 	$callback_arg) = @_;
	    eval q((*(($controller). ($ops->{rsm_rebind}))) (($memseg), $offset, ($memory), ($callback), ($callback_arg)));
    }' unless defined(&RSM_REBIND);
    eval 'sub RSM_PUBLISH {
        my($controller, $memseg, $access_list, $access_list_length, 	$segment_id, $callback, $callback_arg) = @_;
	    eval q((*(($controller). ($ops->{rsm_publish}))) (($memseg), $access_list, $access_list_length, $segment_id, ($callback), ($callback_arg)));
    }' unless defined(&RSM_PUBLISH);
    eval 'sub RSM_UNPUBLISH {
        my($controller, $memseg) = @_;
	    eval q((*(($controller). ($ops->{rsm_unpublish}))) (($memseg)));
    }' unless defined(&RSM_UNPUBLISH);
    eval 'sub RSM_REPUBLISH {
        my($controller, $memseg,  $access_list, $access_list_length, 	$callback, $callback_arg) = @_;
	    eval q((*(($controller). ($ops->{rsm_republish}))) (($memseg), ($access_list), ($access_list_length), ($callback), ($callback_arg)));
    }' unless defined(&RSM_REPUBLISH);
    eval 'sub RSM_CONNECT {
        my($controller, $addr, $segment_id, $im_memseg) = @_;
	    eval q((*(($controller). ($ops->{rsm_connect}))) (($controller). &handle, ($addr), ($segment_id), ($im_memseg)));
    }' unless defined(&RSM_CONNECT);
    eval 'sub RSM_DISCONNECT {
        my($controller, $im_memseg) = @_;
	    eval q((*(($controller). ($ops->{rsm_disconnect}))) (($im_memseg)));
    }' unless defined(&RSM_DISCONNECT);
    eval 'sub RSM_GET8 {
        my($controller, $im_memseg, $offset, $datap, $rep_cnt, $byte_swap) = @_;
	    eval q((*(($controller). ($ops->{rsm_get8}))) (($im_memseg), ($offset), ($datap), ($rep_cnt), ($byte_swap)));
    }' unless defined(&RSM_GET8);
    eval 'sub RSM_GET16 {
        my($controller, $im_memseg, $offset, $datap, $rep_cnt, $byte_swap) = @_;
	    eval q((*(($controller). ($ops->{rsm_get16}))) (($im_memseg), ($offset), ($datap), ($rep_cnt), ($byte_swap)));
    }' unless defined(&RSM_GET16);
    eval 'sub RSM_GET32 {
        my($controller, $im_memseg, $offset, $datap, $rep_cnt, $byte_swap) = @_;
	    eval q((*(($controller). ($ops->{rsm_get32}))) (($im_memseg), ($offset), ($datap), ($rep_cnt), ($byte_swap)));
    }' unless defined(&RSM_GET32);
    eval 'sub RSM_GET64 {
        my($controller, $im_memseg, $offset, $datap, $rep_cnt, $byte_swap) = @_;
	    eval q((*(($controller). ($ops->{rsm_get64}))) (($im_memseg), ($offset), ($datap), ($rep_cnt), ($byte_swap)));
    }' unless defined(&RSM_GET64);
    eval 'sub RSM_GET {
        my($controller, $im_memseg, $offset, $dst_addr, $length) = @_;
	    eval q((*(($controller). ($ops->{rsm_get}))) (($im_memseg), ($offset), ($dst_addr), ($length)));
    }' unless defined(&RSM_GET);
    eval 'sub RSM_PUT8 {
        my($controller, $im_memseg, $offset, $datap, $rep_cnt, $byte_swap) = @_;
	    eval q((*(($controller). ($ops->{rsm_put8}))) (($im_memseg), ($offset), ($datap), ($rep_cnt), ($byte_swap)));
    }' unless defined(&RSM_PUT8);
    eval 'sub RSM_PUT16 {
        my($controller, $im_memseg, $offset, $datap, $rep_cnt, $byte_swap) = @_;
	    eval q((*(($controller). ($ops->{rsm_put16}))) (($im_memseg), ($offset), ($datap), ($rep_cnt), ($byte_swap)));
    }' unless defined(&RSM_PUT16);
    eval 'sub RSM_PUT32 {
        my($controller, $im_memseg, $offset, $datap, $rep_cnt, $byte_swap) = @_;
	    eval q((*(($controller). ($ops->{rsm_put32}))) (($im_memseg), ($offset), ($datap), ($rep_cnt), ($byte_swap)));
    }' unless defined(&RSM_PUT32);
    eval 'sub RSM_PUT64 {
        my($controller, $im_memseg, $offset, $datap, $rep_cnt, $byte_swap) = @_;
	    eval q((*(($controller). ($ops->{rsm_put64}))) (($im_memseg), ($offset), ($datap), ($rep_cnt), ($byte_swap)));
    }' unless defined(&RSM_PUT64);
    eval 'sub RSM_PUT {
        my($controller, $im_memseg, $offset, $datap, $length) = @_;
	    eval q((*(($controller). ($ops->{rsm_put}))) (($im_memseg), ($offset), ($datap), ($length)));
    }' unless defined(&RSM_PUT);
    eval 'sub RSM_MAP {
        my($controller, $im_memseg, $offset, $length, $maplen, $dipp, 	$dev_register, $dev_offset, $callback, $arg) = @_;
	    eval q((*(($controller). ($ops->{rsm_map}))) (($im_memseg), ($offset), ($length), ($maplen), ($dipp), ($dev_register), ($dev_offset), ($callback), ($arg)));
    }' unless defined(&RSM_MAP);
    eval 'sub RSM_UNMAP {
        my($controller, $im_memseg) = @_;
	    eval q((*(($controller). ($ops->{rsm_unmap}))) (($im_memseg)));
    }' unless defined(&RSM_UNMAP);
    eval 'sub RSM_OPEN_BARRIER_REGION {
        my($controller, $region, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_open_barrier_region}))) (($region), ($barrier)));
    }' unless defined(&RSM_OPEN_BARRIER_REGION);
    eval 'sub RSM_OPEN_BARRIER_REGIONS {
        my($controller, $regions, $num_regions, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_open_barrier_regions}))) (($regions), ($num_regions), ($barrier)));
    }' unless defined(&RSM_OPEN_BARRIER_REGIONS);
    eval 'sub RSM_OPEN_BARRIER_NODE {
        my($controller, $addr, $barrier) = @_;
	    eval q((*(($controller). &ops->  &rsm_open_barrier_node)) (($controller). &handle, ($addr), ($barrier)));
    }' unless defined(&RSM_OPEN_BARRIER_NODE);
    eval 'sub RSM_OPEN_BARRIER_CTRL {
        my($controller, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_open_barrier_ctrl}))) (($controller). &handle, ($barrier)));
    }' unless defined(&RSM_OPEN_BARRIER_CTRL);
    eval 'sub RSM_OPEN_BARRIER_REGION_THR {
        my($controller, $region, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_open_barrier_region_thr}))) (($region), ($barrier)));
    }' unless defined(&RSM_OPEN_BARRIER_REGION_THR);
    eval 'sub RSM_OPEN_BARRIER_REGIONS_THR {
        my($controller, $regions, $num_regions, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_open_barrier_regions_thr}))) (($regions), ($num_regions), ($barrier)));
    }' unless defined(&RSM_OPEN_BARRIER_REGIONS_THR);
    eval 'sub RSM_OPEN_BARRIER_NODE_THR {
        my($controller, $addr, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_open_barrier_node_thr}))) (($controller). &handle, ($addr), ($barrier)));
    }' unless defined(&RSM_OPEN_BARRIER_NODE_THR);
    eval 'sub RSM_OPEN_BARRIER_CTRL_THR {
        my($controller, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_open_barrier_ctrl_thr}))) (($controller). &handle, ($barrier)););
    }' unless defined(&RSM_OPEN_BARRIER_CTRL_THR);
    eval 'sub RSM_CLOSE_BARRIER {
        my($controller, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_close_barrier}))) (($barrier)));
    }' unless defined(&RSM_CLOSE_BARRIER);
    eval 'sub RSM_REOPEN_BARRIER {
        my($controller, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_reopen_barrier}))) (($barrier)););
    }' unless defined(&RSM_REOPEN_BARRIER);
    eval 'sub RSM_ORDER_BARRIER {
        my($controller, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_order_barrier}))) (($barrier)));
    }' unless defined(&RSM_ORDER_BARRIER);
    eval 'sub RSM_THREAD_INIT {
        my($controller) = @_;
	    eval q((*(($controller). ($ops->{rsm_thread_init}))) (($controller). &handle));
    }' unless defined(&RSM_THREAD_INIT);
    eval 'sub RSM_THREAD_FINI {
        my($controller) = @_;
	    eval q((*(($controller). ($ops->{rsm_thread_fini}))) (($controller). &handle));
    }' unless defined(&RSM_THREAD_FINI);
    eval 'sub RSM_GET_BARRIER_MODE {
        my($controller, $im_memseg, $mode) = @_;
	    eval q((*(($controller). ($ops->{rsm_get_barrier_mode}))) (($im_memseg), ($mode)));
    }' unless defined(&RSM_GET_BARRIER_MODE);
    eval 'sub RSM_SET_BARRIER_MODE {
        my($controller, $im_memseg, $mode) = @_;
	    eval q((*(($controller). ($ops->{rsm_set_barrier_mode}))) (($im_memseg), ($mode)));
    }' unless defined(&RSM_SET_BARRIER_MODE);
    eval 'sub RSM_SENDQ_CREATE {
        my($controller, $addr, $service, $pri, $qdepth, $flags, 	$callback, $arg, $iqp) = @_;
	    eval q((*(($controller). ($ops->{rsm_sendq_create}))) (($controller). &handle, ($addr), ($service), ($pri), ($qdepth), ($flags), ($callback), ($arg), ($iqp)));
    }' unless defined(&RSM_SENDQ_CREATE);
    eval 'sub RSM_SENDQ_CONFIG {
        my($controller, $iq, $pri, $qdepth, $flags, $callback, $arg) = @_;
	    eval q((*(($controller). ($ops->{rsm_sendq_config}))) (($iq), ($pri), ($qdepth), ($flags), ($callback), ($arg)));
    }' unless defined(&RSM_SENDQ_CONFIG);
    eval 'sub RSM_SENDQ_DESTROY {
        my($controller, $iq) = @_;
	    eval q((*(($controller). ($ops->{rsm_sendq_destroy}))) (($iq)));
    }' unless defined(&RSM_SENDQ_DESTROY);
    eval 'sub RSM_SEND {
        my($controller, $iq, $is, $barrier) = @_;
	    eval q((*(($controller). ($ops->{rsm_send}))) (($iq), ($is), ($barrier)));
    }' unless defined(&RSM_SEND);
    eval 'sub RSM_REGISTER_HANDLER {
        my($controller, $type, $handler, $handler_arg, 	$senders_list, $senders_list_length) = @_;
	    eval q((*(($controller). ($ops->{rsm_register_handler}))) (($controller). &handle, ($controller), ($type), ($handler), ($handler_arg), ($senders_list), ($senders_list_length)));
    }' unless defined(&RSM_REGISTER_HANDLER);
    eval 'sub RSM_UNREGISTER_HANDLER {
        my($controller, $type, $handler, $handler_arg) = @_;
	    eval q((*(($controller). ($ops->{rsm_unregister_handler}))) (($controller). &handle, ($type), ($handler), ($handler_arg)));
    }' unless defined(&RSM_UNREGISTER_HANDLER);
    eval 'sub RSM_GETV {
        my($controller, $sg_io) = @_;
	    eval q((*(($controller). ($ops->{rsm_memseg_import_getv}))) (($controller). &handle, ($sg_io)));
    }' unless defined(&RSM_GETV);
    eval 'sub RSM_PUTV {
        my($controller, $sg_io) = @_;
	    eval q((*(($controller). ($ops->{rsm_memseg_import_putv}))) (($controller). &handle, ($sg_io)));
    }' unless defined(&RSM_PUTV);
    eval 'sub RSM_GET_PEERS {
        my($controller, $addr_list, $count, $num_addrs) = @_;
	    eval q((*(($controller). ($ops->{rsm_get_peers}))) (($controller). &handle, ($addr_list), ($count), ($num_addrs)));
    }' unless defined(&RSM_GET_PEERS);
    eval 'sub RSM_EXTENSION {
        my($controller, $extname, $extobj) = @_;
	    eval q((*(($controller). ($ops->{rsm_extension}))) (($controller). &handle, ($extname), ($extobj)));
    }' unless defined(&RSM_EXTENSION);
    if(defined(&__cplusplus)) {
    }
}
1;
