require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_ADAPTERS_ESPVAR_H)) {
    eval 'sub _SYS_SCSI_ADAPTERS_ESPVAR_H () {1;}' unless defined(&_SYS_SCSI_ADAPTERS_ESPVAR_H);
    require 'sys/note.ph';
    require 'sys/scsi/scsi.ph';
    require 'sys/scsi/adapters/espreg.ph';
    require 'sys/scsi/adapters/espcmd.ph';
    if(defined(&__cplusplus)) {
    }
    if((defined(&DEBUG) ? &DEBUG : 0)) {
	eval 'sub ESPDEBUG () {1;}' unless defined(&ESPDEBUG);
	eval 'sub ESPTEST () {1;}' unless defined(&ESPTEST);
	if(defined(&ESPTEST)) {
	    eval 'sub ESP_TEST_PARITY () {1;}' unless defined(&ESP_TEST_PARITY);
	    eval 'sub ESP_TEST_ABORT () {1;}' unless defined(&ESP_TEST_ABORT);
	    eval 'sub ESP_TEST_RESET () {1;}' unless defined(&ESP_TEST_RESET);
	    eval 'sub ESP_TEST_TIMEOUT () {1;}' unless defined(&ESP_TEST_TIMEOUT);
	    eval 'sub ESP_TEST_BUS_RESET () {1;}' unless defined(&ESP_TEST_BUS_RESET);
	    eval 'sub ESP_TEST_RQSENSE () {1;}' unless defined(&ESP_TEST_RQSENSE);
	    eval 'sub ESP_NEW_HW_DEBUG () {1;}' unless defined(&ESP_NEW_HW_DEBUG);
	    eval 'sub ESP_TEST_UNTAGGED () {1;}' unless defined(&ESP_TEST_UNTAGGED);
	}
    }
    eval 'sub POLL_TIMEOUT () {(2*  &SCSI_POLL_TIMEOUT * 1000000);}' unless defined(&POLL_TIMEOUT);
    eval 'sub SHORT_POLL_TIMEOUT () {(1000000);}' unless defined(&SHORT_POLL_TIMEOUT);
    eval 'sub ESP_MUTEX () {( ($esp->{e_mutex}));}' unless defined(&ESP_MUTEX);
    eval 'sub ESP_INIT_SOFT_STATE () {5;}' unless defined(&ESP_INIT_SOFT_STATE);
    eval 'sub N_SLOTS () {( &NTARGETS* &NLUNS_PER_TARGET);}' unless defined(&N_SLOTS);
    eval 'sub SDEV2TRAN {
        my($sd) = @_;
	    eval q((($sd)-> ($sd_address->{a_hba_tran})));
    }' unless defined(&SDEV2TRAN);
    eval 'sub SDEV2ADDR {
        my($sd) = @_;
	    eval q(((($sd)-> &sd_address)));
    }' unless defined(&SDEV2ADDR);
    eval 'sub PKT2TRAN {
        my($pkt) = @_;
	    eval q((($pkt)-> ($pkt_address->{a_hba_tran})));
    }' unless defined(&PKT2TRAN);
    eval 'sub ADDR2TRAN {
        my($ap) = @_;
	    eval q((($ap)-> &a_hba_tran));
    }' unless defined(&ADDR2TRAN);
    eval 'sub TRAN2ESP {
        my($tran) = @_;
	    eval q((($tran)-> &tran_hba_private));
    }' unless defined(&TRAN2ESP);
    eval 'sub SDEV2ESP {
        my($sd) = @_;
	    eval q(( &TRAN2ESP( &SDEV2TRAN($sd))));
    }' unless defined(&SDEV2ESP);
    eval 'sub PKT2ESP {
        my($pkt) = @_;
	    eval q(( &TRAN2ESP( &PKT2TRAN($pkt))));
    }' unless defined(&PKT2ESP);
    eval 'sub ADDR2ESP {
        my($ap) = @_;
	    eval q(( &TRAN2ESP( &ADDR2TRAN($ap))));
    }' unless defined(&ADDR2ESP);
    eval 'sub OMSGSIZE () {12;}' unless defined(&OMSGSIZE);
    eval 'sub IMSGSIZE () {8;}' unless defined(&IMSGSIZE);
    if(defined(&ESP_KSTATS)) {
    }
    eval 'sub NPHASE () {16;}' unless defined(&NPHASE);
    if(defined(&ESPDEBUG)) {
    }
    eval 'sub DEFAULT_REQ_ACK_DELAY_101 () {0x50;}' unless defined(&DEFAULT_REQ_ACK_DELAY_101);
    eval 'sub DEFAULT_REQ_ACK_DELAY_236 () {0x10;}' unless defined(&DEFAULT_REQ_ACK_DELAY_236);
    eval 'sub ESP_OPT_SBUS_RERUNS () {0x1;}' unless defined(&ESP_OPT_SBUS_RERUNS);
    eval 'sub ESP_OPT_FAS () {0x2;}' unless defined(&ESP_OPT_FAS);
    eval 'sub ESP_OPT_DMA_OUT_TAG () {0x4;}' unless defined(&ESP_OPT_DMA_OUT_TAG);
    eval 'sub ESP_OPT_MASK_OFF_STAT () {0x8;}' unless defined(&ESP_OPT_MASK_OFF_STAT);
    eval 'sub ESP_OPT_DIFFERENTIAL () {0x10;}' unless defined(&ESP_OPT_DIFFERENTIAL);
    eval 'sub ESP_OPT_STACKED_CMDS () {0x20;}' unless defined(&ESP_OPT_STACKED_CMDS);
    eval 'sub ESP_OPT_ACCEPT_STEP567 () {0x40;}' unless defined(&ESP_OPT_ACCEPT_STEP567);
    eval 'sub ESP_OPT_SLOW_FIFO_FLUSH () {0x80;}' unless defined(&ESP_OPT_SLOW_FIFO_FLUSH);
    eval 'sub ESP_FLG_NOTIMEOUTS () {0x1;}' unless defined(&ESP_FLG_NOTIMEOUTS);
    eval 'sub ESP_CAN_SCHED () {(( ($esp->{e_flags}) &  &ESP_FLG_NOTIMEOUTS) == 0);}' unless defined(&ESP_CAN_SCHED);
    if(defined(&ESPDEBUG)) {
	eval 'sub LOG_STATE {
	    my($esp, $arg0, $arg1, $arg2, $arg3) = @_;
    	    eval q({  ($esp->{e_phase[$esp}->{e_phase_index]}->{e_save_state}) = $arg0;  ($esp->{e_phase[$esp}->{e_phase_index]}->{e_save_stat}) = $arg1;  ($esp->{e_phase[$esp}->{e_phase_index]}->{e_val1}) = $arg2;  ($esp->{e_phase[$esp}->{e_phase_index]}->{e_val2}) = $arg3;  ($esp->{e_phase[$esp}->{e_phase_index]}->{e_reserved}) = 0xbadfeed;  ($esp->{e_phase_index}) = (++ ($esp->{e_phase_index})) & ( &NPHASE-1); };);
	}' unless defined(&LOG_STATE);
    } else {
	eval 'sub LOG_STATE {
	    my($esp, $arg0, $arg1, $arg2, $arg3) = @_;
    	    eval q({};);
	}' unless defined(&LOG_STATE);
    }
    eval 'sub STATE_FREE () {0x;}' unless defined(&STATE_FREE);
    eval 'sub STATE_SELECT_NORMAL () {0x100;}' unless defined(&STATE_SELECT_NORMAL);
    eval 'sub STATE_SELECT_N_STOP () {0x200;}' unless defined(&STATE_SELECT_N_STOP);
    eval 'sub STATE_SELECT_N_SENDMSG () {0x400;}' unless defined(&STATE_SELECT_N_SENDMSG);
    eval 'sub STATE_SYNC_ASKING () {0x800;}' unless defined(&STATE_SYNC_ASKING);
    eval 'sub STATE_SELECT_N_TAG () {0x1000;}' unless defined(&STATE_SELECT_N_TAG);
    eval 'sub STATE_SELECTING () {0xff00;}' unless defined(&STATE_SELECTING);
    eval 'sub STATE_ITPHASES () {0xff;}' unless defined(&STATE_ITPHASES);
    eval 'sub ACTS_CMD_START () {0x1;}' unless defined(&ACTS_CMD_START);
    eval 'sub ACTS_CMD_DONE () {0x2;}' unless defined(&ACTS_CMD_DONE);
    eval 'sub ACTS_MSG_OUT () {0x3;}' unless defined(&ACTS_MSG_OUT);
    eval 'sub ACTS_MSG_OUT_DONE () {0x4;}' unless defined(&ACTS_MSG_OUT_DONE);
    eval 'sub ACTS_MSG_IN () {0x5;}' unless defined(&ACTS_MSG_IN);
    eval 'sub ACTS_MSG_IN_MORE () {0x6;}' unless defined(&ACTS_MSG_IN_MORE);
    eval 'sub ACTS_MSG_IN_DONE () {0x7;}' unless defined(&ACTS_MSG_IN_DONE);
    eval 'sub ACTS_CLEARING () {0x8;}' unless defined(&ACTS_CLEARING);
    eval 'sub ACTS_DATA () {0x9;}' unless defined(&ACTS_DATA);
    eval 'sub ACTS_DATA_DONE () {0xa;}' unless defined(&ACTS_DATA_DONE);
    eval 'sub ACTS_C_CMPLT () {0xb;}' unless defined(&ACTS_C_CMPLT);
    eval 'sub ACTS_RESEL () {0xc;}' unless defined(&ACTS_RESEL);
    eval 'sub ACTS_ENDVEC () {0xc;}' unless defined(&ACTS_ENDVEC);
    eval 'sub ACTS_UNKNOWN () {0x1a;}' unless defined(&ACTS_UNKNOWN);
    eval 'sub ACTS_RESET () {0x1c;}' unless defined(&ACTS_RESET);
    eval 'sub ACTS_ABORTING () {0x1d;}' unless defined(&ACTS_ABORTING);
    eval 'sub ACTS_SPANNING () {0x1e;}' unless defined(&ACTS_SPANNING);
    eval 'sub ACTS_FROZEN () {0x1f;}' unless defined(&ACTS_FROZEN);
    eval 'sub ACTS_PREEMPTED () {0x21;}' unless defined(&ACTS_PREEMPTED);
    eval 'sub ACTS_PROXY () {0x22;}' unless defined(&ACTS_PROXY);
    eval 'sub ACTS_SYNCHOUT () {0x23;}' unless defined(&ACTS_SYNCHOUT);
    eval 'sub ACTS_CMD_LOST () {0x24;}' unless defined(&ACTS_CMD_LOST);
    eval 'sub ACTS_DATAOUT () {0x25;}' unless defined(&ACTS_DATAOUT);
    eval 'sub ACTS_DATAIN () {0x26;}' unless defined(&ACTS_DATAIN);
    eval 'sub ACTS_STATUS () {0x27;}' unless defined(&ACTS_STATUS);
    eval 'sub ACTS_DISCONNECT () {0x28;}' unless defined(&ACTS_DISCONNECT);
    eval 'sub ACTS_NOP () {0x29;}' unless defined(&ACTS_NOP);
    eval 'sub ACTS_REJECT () {0x2a;}' unless defined(&ACTS_REJECT);
    eval 'sub ACTS_RESTOREDP () {0x2b;}' unless defined(&ACTS_RESTOREDP);
    eval 'sub ACTS_SAVEDP () {0x2c;}' unless defined(&ACTS_SAVEDP);
    eval 'sub ACTS_BAD_RESEL () {0x2d;}' unless defined(&ACTS_BAD_RESEL);
    eval 'sub ACTS_LOG () {0xf;}' unless defined(&ACTS_LOG);
    eval 'sub ACTS_SELECT () {0x2e;}' unless defined(&ACTS_SELECT);
    eval 'sub ACTS_TAG () {0x2f;}' unless defined(&ACTS_TAG);
    eval 'sub ACTS_CMD () {0x30;}' unless defined(&ACTS_CMD);
    eval 'sub ACTS_NEW_STATE () {0x40;}' unless defined(&ACTS_NEW_STATE);
    eval 'sub ACTS_ESP_CMD () {0x41;}' unless defined(&ACTS_ESP_CMD);
    eval 'sub ACTION_RETURN () {-1;}' unless defined(&ACTION_RETURN);
    eval 'sub ACTION_FINSEL () {0;}' unless defined(&ACTION_FINSEL);
    eval 'sub ACTION_RESEL () {1;}' unless defined(&ACTION_RESEL);
    eval 'sub ACTION_PHASEMANAGE () {2;}' unless defined(&ACTION_PHASEMANAGE);
    eval 'sub ACTION_FINISH () {3;}' unless defined(&ACTION_FINISH);
    eval 'sub ACTION_FINRST () {4;}' unless defined(&ACTION_FINRST);
    eval 'sub ACTION_SEARCH () {5;}' unless defined(&ACTION_SEARCH);
    eval 'sub ACTION_ABORT_CURCMD () {6;}' unless defined(&ACTION_ABORT_CURCMD);
    eval 'sub ACTION_ABORT_ALLCMDS () {7;}' unless defined(&ACTION_ABORT_ALLCMDS);
    eval 'sub ACTION_RESET () {8;}' unless defined(&ACTION_RESET);
    eval 'sub ACTION_SELECT () {9;}' unless defined(&ACTION_SELECT);
    eval 'sub ESP_PROXY_TYPE () { &CDB_GROUP0;}' unless defined(&ESP_PROXY_TYPE);
    eval 'sub ESP_PROXY_RESULT () { &ESP_PROXY_TYPE+1;}' unless defined(&ESP_PROXY_RESULT);
    eval 'sub ESP_PROXY_DATA () { &ESP_PROXY_RESULT+1;}' unless defined(&ESP_PROXY_DATA);
    eval 'sub ESP_PROXY_SNDMSG () {1;}' unless defined(&ESP_PROXY_SNDMSG);
    eval 'sub ESP_RESET_ESP () {0x1;}' unless defined(&ESP_RESET_ESP);
    eval 'sub ESP_RESET_DMA () {0x2;}' unless defined(&ESP_RESET_DMA);
    eval 'sub ESP_RESET_BRESET () {0x4;}' unless defined(&ESP_RESET_BRESET);
    eval 'sub ESP_RESET_SCSIBUS () {( &ESP_RESET_BRESET);}' unless defined(&ESP_RESET_SCSIBUS);
    eval 'sub ESP_RESET_SOFTC () {0x10;}' unless defined(&ESP_RESET_SOFTC);
    eval 'sub ESP_RESET_HW () {( &ESP_RESET_ESP| &ESP_RESET_DMA| &ESP_RESET_SCSIBUS);}' unless defined(&ESP_RESET_HW);
    eval 'sub ESP_RESET_ALL () {( &ESP_RESET_HW| &ESP_RESET_SOFTC);}' unless defined(&ESP_RESET_ALL);
    eval 'sub ESP_RESET_MSG () {0x20;}' unless defined(&ESP_RESET_MSG);
    if(defined(&ESPDEBUG)) {
	eval 'sub INFORMATIVE () {( &espdebug);}' unless defined(&INFORMATIVE);
	eval 'sub DEBUGGING () {( &espdebug > 1);}' unless defined(&DEBUGGING);
	eval 'sub EPRINTF {
	    my($str) = @_;
    	    eval q( &if ( &espdebug > 1)  &eprintf( &esp, $str));
	}' unless defined(&EPRINTF);
	eval 'sub EPRINTF1 {
	    my($str, $a) = @_;
    	    eval q( &if ( &espdebug > 1)  &eprintf( &esp, $str, $a));
	}' unless defined(&EPRINTF1);
	eval 'sub EPRINTF2 {
	    my($str, $a, $b) = @_;
    	    eval q( &if ( &espdebug > 1)  &eprintf( &esp, $str, $a, $b));
	}' unless defined(&EPRINTF2);
	eval 'sub EPRINTF3 {
	    my($str, $a, $b, $c) = @_;
    	    eval q( &if ( &espdebug > 1)  &eprintf( &esp, $str, $a, $b, $c));
	}' unless defined(&EPRINTF3);
	eval 'sub EPRINTF4 {
	    my($str, $a, $b, $c, $d) = @_;
    	    eval q( &if ( &espdebug > 1)  &eprintf( &esp, $str, $a, $b, $c, $d));
	}' unless defined(&EPRINTF4);
	eval 'sub EPRINTF5 {
	    my($str, $a, $b, $c, $d, $e) = @_;
    	    eval q( &if ( &espdebug > 1)  &eprintf( &esp, $str, $a, $b, $c, $d, $e));
	}' unless defined(&EPRINTF5);
	eval 'sub EPRINTF6 {
	    my($str, $a, $b, $c, $d, $e, $f) = @_;
    	    eval q( &if ( &espdebug > 1)  &eprintf( &esp, $str, $a, $b, $c, $d, $e, $f));
	}' unless defined(&EPRINTF6);
	eval 'sub IPRINTF {
	    my($str) = @_;
    	    eval q( &if ( &espdebug)  &eprintf( &esp, $str));
	}' unless defined(&IPRINTF);
	eval 'sub IPRINTF1 {
	    my($str, $a) = @_;
    	    eval q( &if ( &espdebug)  &eprintf( &esp, $str, $a));
	}' unless defined(&IPRINTF1);
	eval 'sub IPRINTF2 {
	    my($str, $a, $b) = @_;
    	    eval q( &if ( &espdebug)  &eprintf( &esp, $str, $a, $b));
	}' unless defined(&IPRINTF2);
	eval 'sub IPRINTF3 {
	    my($str, $a, $b, $c) = @_;
    	    eval q( &if ( &espdebug)  &eprintf( &esp, $str, $a, $b, $c));
	}' unless defined(&IPRINTF3);
	eval 'sub IPRINTF4 {
	    my($str, $a, $b, $c, $d) = @_;
    	    eval q( &if ( &espdebug)  &eprintf( &esp, $str, $a, $b, $c, $d));
	}' unless defined(&IPRINTF4);
	eval 'sub IPRINTF5 {
	    my($str, $a, $b, $c, $d, $e) = @_;
    	    eval q( &if ( &espdebug)  &eprintf( &esp, $str, $a, $b, $c, $d, $e));
	}' unless defined(&IPRINTF5);
	eval 'sub IPRINTF6 {
	    my($str, $a, $b, $c, $d, $e, $f) = @_;
    	    eval q( &if ( &espdebug)  &eprintf( &esp, $str, $a, $b, $c, $d, $e, $f));
	}' unless defined(&IPRINTF6);
    } else {
	eval 'sub EPRINTF {
	    my($str) = @_;
    	    eval q();
	}' unless defined(&EPRINTF);
	eval 'sub EPRINTF1 {
	    my($str, $a) = @_;
    	    eval q();
	}' unless defined(&EPRINTF1);
	eval 'sub EPRINTF2 {
	    my($str, $a, $b) = @_;
    	    eval q();
	}' unless defined(&EPRINTF2);
	eval 'sub EPRINTF3 {
	    my($str, $a, $b, $c) = @_;
    	    eval q();
	}' unless defined(&EPRINTF3);
	eval 'sub EPRINTF4 {
	    my($str, $a, $b, $c, $d) = @_;
    	    eval q();
	}' unless defined(&EPRINTF4);
	eval 'sub EPRINTF5 {
	    my($str, $a, $b, $c, $d, $e) = @_;
    	    eval q();
	}' unless defined(&EPRINTF5);
	eval 'sub EPRINTF6 {
	    my($str, $a, $b, $c, $d, $e, $f) = @_;
    	    eval q();
	}' unless defined(&EPRINTF6);
	eval 'sub IPRINTF {
	    my($str) = @_;
    	    eval q();
	}' unless defined(&IPRINTF);
	eval 'sub IPRINTF1 {
	    my($str, $a) = @_;
    	    eval q();
	}' unless defined(&IPRINTF1);
	eval 'sub IPRINTF2 {
	    my($str, $a, $b) = @_;
    	    eval q();
	}' unless defined(&IPRINTF2);
	eval 'sub IPRINTF3 {
	    my($str, $a, $b, $c) = @_;
    	    eval q();
	}' unless defined(&IPRINTF3);
	eval 'sub IPRINTF4 {
	    my($str, $a, $b, $c, $d) = @_;
    	    eval q();
	}' unless defined(&IPRINTF4);
	eval 'sub IPRINTF5 {
	    my($str, $a, $b, $c, $d, $e) = @_;
    	    eval q();
	}' unless defined(&IPRINTF5);
	eval 'sub IPRINTF6 {
	    my($str, $a, $b, $c, $d, $e, $f) = @_;
    	    eval q();
	}' unless defined(&IPRINTF6);
    }
    eval 'sub SAME_CMD () {0;}' unless defined(&SAME_CMD);
    eval 'sub INT_CMD () {1;}' unless defined(&INT_CMD);
    eval 'sub NEW_CMD () {2;}' unless defined(&NEW_CMD);
    eval 'sub CLEAR_THROTTLE () {512;}' unless defined(&CLEAR_THROTTLE);
    eval 'sub HOLD_THROTTLE () {0;}' unless defined(&HOLD_THROTTLE);
    eval 'sub DRAIN_THROTTLE () {-1;}' unless defined(&DRAIN_THROTTLE);
    eval 'sub QFULL_THROTTLE () {-2;}' unless defined(&QFULL_THROTTLE);
    eval 'sub PAD_LIMIT () {1025;}' unless defined(&PAD_LIMIT);
    eval 'sub NODISC {
        my($tgt) = @_;
	    eval q(( ($esp->{e_nodisc}) & (1<<($tgt))));
    }' unless defined(&NODISC);
    eval 'sub NOTAG {
        my($tgt) = @_;
	    eval q(( ($esp->{e_notag}) & (1<<($tgt))));
    }' unless defined(&NOTAG);
    eval 'sub TAGGED {
        my($tgt) = @_;
	    eval q((( ($esp->{e_notag}) & (1<<($tgt))) == 0));
    }' unless defined(&TAGGED);
    eval 'sub SYNC_KNOWN {
        my($tgt) = @_;
	    eval q(( ($esp->{e_sync_known}) & (1<<($tgt))));
    }' unless defined(&SYNC_KNOWN);
    eval 'sub CURRENT_CMD {
        my($esp) = @_;
	    eval q((($esp)-> $e_slots[($esp)-> &e_cur_slot]));
    }' unless defined(&CURRENT_CMD);
    eval 'sub SLOT {
        my($sp) = @_;
	    eval q((( &Tgt(($sp)) *  &NLUNS_PER_TARGET| ( &Lun(($sp))))));
    }' unless defined(&SLOT);
    eval 'sub NEXTSLOT {
        my($slot, $d) = @_;
	    eval q((($slot)+($d)) & (( &N_SLOTS)-1));
    }' unless defined(&NEXTSLOT);
    eval 'sub FIFO_CNT {
        my($ep) = @_;
	    eval q((($ep)-> &esp_fifo_flag & 0x1f));
    }' unless defined(&FIFO_CNT);
    eval 'sub MY_ID {
        my($esp) = @_;
	    eval q((($esp)-> &e_espconf &  &ESP_CONF_BUSID));
    }' unless defined(&MY_ID);
    eval 'sub INTPENDING {
        my($esp) = @_;
	    eval q((($esp)-> ($e_dma->{dmaga_csr})& &DMAGA_INT_MASK));
    }' unless defined(&INTPENDING);
    eval 'sub Tgt {
        my($sp) = @_;
	    eval q((($sp)-> ($cmd_pkt->{pkt_address}->{a_target})));
    }' unless defined(&Tgt);
    eval 'sub Lun {
        my($sp) = @_;
	    eval q((($sp)-> ($cmd_pkt->{pkt_address}->{a_lun})));
    }' unless defined(&Lun);
    if(defined(&ESP_KSTATS)) {
	eval 'sub IOSP {
	    my($slot) = @_;
    	    eval q(( &KSTAT_IO_PTR( ($esp->{e_slot_stats[$slot]}))));
	}' unless defined(&IOSP);
	eval 'sub IOSP_SCSI_BUS () {( &KSTAT_IO_PTR( ($esp->{e_scsi_bus_stats})));}' unless defined(&IOSP_SCSI_BUS);
	eval 'sub ESP_KSTAT_SCSI_BUS {
	    my($esp) = @_;
    	    eval q( &if ( &esp_do_bus_kstats) {  &if ( ($esp->{e_laststate}) ==  &STATE_FREE  &&  ($esp->{e_state}) !=  &STATE_FREE) {  &if ( ($esp->{e_scsi_bus_stats})) {  &kstat_runq_enter( &IOSP_SCSI_BUS); } }  &else  &if ( ($esp->{e_laststate}) !=  &STATE_FREE  &&  ($esp->{e_state}) ==  &STATE_FREE) {  &if ( ($esp->{e_scsi_bus_stats})) {  &kstat_runq_exit( &IOSP_SCSI_BUS); } } });
	}' unless defined(&ESP_KSTAT_SCSI_BUS);
	eval 'sub New_state {
	    my($esp, $state) = @_;
    	    eval q(($esp)-> &e_laststate = ($esp)-> &e_state, ($esp)-> &e_state = ($state);  &ESP_KSTAT_SCSI_BUS($esp));
	}' unless defined(&New_state);
    } else {
	eval 'sub New_state {
	    my($esp, $state) = @_;
    	    eval q(($esp)-> &e_laststate = ($esp)-> &e_state, ($esp)-> &e_state = ($state));
	}' unless defined(&New_state);
    }
    eval 'sub ESP_KSTAT_INTR {
        my($esp) = @_;
	    eval q( &KSTAT_INTR_PTR( ($esp->{e_intr_kstat}))->  $intrs[ &KSTAT_INTR_HARD]++);
    }' unless defined(&ESP_KSTAT_INTR);
    eval 'sub Esp_cmd {
        my($esp, $cmd) = @_;
	    eval q(($esp)-> ($e_reg->{esp_cmd}) = ($cmd), ($esp)-> &e_last_cmd = ($cmd));
    }' unless defined(&Esp_cmd);
    eval 'sub ESP_PREEMPT {
        my($esp) = @_;
	    eval q( &New_state(($esp),  &STATE_FREE); ($esp)-> &e_last_slot = ($esp)-> &e_cur_slot, ($esp)-> &e_cur_slot =  &UNDEFINED);
    }' unless defined(&ESP_PREEMPT);
    eval 'sub CNUM () {( &ddi_get_instance( ($esp->{e_dev})));}' unless defined(&CNUM);
    eval 'sub TRUE () {1;}' unless defined(&TRUE);
    eval 'sub FALSE () {0;}' unless defined(&FALSE);
    eval 'sub UNDEFINED () {-1;}' unless defined(&UNDEFINED);
    eval 'sub INVALID_MSG () {0x7f;}' unless defined(&INVALID_MSG);
    eval 'sub ESP_DMAGA_REV {
        my($esp) = @_;
	    eval q(($esp)-> &e_dma_rev);
    }' unless defined(&ESP_DMAGA_REV);
    eval 'sub MEG () {(1000* 1000);}' unless defined(&MEG);
    eval 'sub FIVE_MEG () {(5*  &MEG);}' unless defined(&FIVE_MEG);
    eval 'sub TEN_MEG () {(10*  &MEG);}' unless defined(&TEN_MEG);
    eval 'sub TWENTY_MEG () {(20*  &MEG);}' unless defined(&TWENTY_MEG);
    eval 'sub TWENTYFIVE_MEG () {(25*  &MEG);}' unless defined(&TWENTYFIVE_MEG);
    eval 'sub FORTY_MEG () {(40*  &MEG);}' unless defined(&FORTY_MEG);
    eval 'sub ESP_FREQ_SLOP () {(25000);}' unless defined(&ESP_FREQ_SLOP);
    eval 'sub ESP_DMA_WRITE {
        my($esp, $count, $base) = @_;
	    eval q({  &register  &volatile \'struct espreg\' * &ep =  ($esp->{e_reg});  &register  &volatile \'struct dmaga\' * &dmar =  ($esp->{e_dma});  &SET_ESP_COUNT( &ep, $count);  ($esp->{e_dmaga_csr}) |=  &DMAGA_WRITE |  &DMAGA_ENDVMA;  ($dmar->{dmaga_csr}) =  ($esp->{e_dmaga_csr});  &if ( &ESP_DMAGA_REV($esp) ==  &ESC1_REV1) {  &SET_DMAESC_COUNT( &dmar, $count); }  ($dmar->{dmaga_addr}) =  ($esp->{e_lastdma}) = $base; });
    }' unless defined(&ESP_DMA_WRITE);
    eval 'sub ESP_DMA_READ {
        my($esp, $count, $base) = @_;
	    eval q({  &register  &volatile \'struct espreg\' * &ep =  ($esp->{e_reg});  &register  &volatile \'struct dmaga\' * &dmar =  ($esp->{e_dma});  &SET_ESP_COUNT( &ep, $count);  ($esp->{e_dmaga_csr}) |= ( ($esp->{e_dmaga_csr}) & ~ &DMAGA_WRITE) |  &DMAGA_ENDVMA;  ($dmar->{dmaga_csr}) =  ($esp->{e_dmaga_csr});  ($dmar->{dmaga_addr}) =  ($esp->{e_lastdma}) = $base; });
    }' unless defined(&ESP_DMA_READ);
    eval 'sub ESP_SET_ESC_READ_COUNT {
        my($esp, $count, $base) = @_;
	    eval q({  &if (( ($esp->{e_options}) &  &ESP_OPT_SBUS_RERUNS)  && ((($base + $count) & ( &MMU_PAGESIZE-1)) != 0)) {  &register  &uint_t  &addr1 = ( &uint_t)$base;  &register  &uint_t  &addr2 = ( &uint_t) ($base + $count +  &MMU_PAGESIZE) & (~( &MMU_PAGESIZE-1));  &register  &uint_t  &spec_count = ( &uint_t)( &addr2 -  &addr1);  &SET_DMAESC_COUNT( ($esp->{e_dma}),  &spec_count); }  &else  &SET_DMAESC_COUNT( ($esp->{e_dma}), $count); });
    }' unless defined(&ESP_SET_ESC_READ_COUNT);
    eval 'sub DMA_DRAIN_TIMEOUT () {(200*100);}' unless defined(&DMA_DRAIN_TIMEOUT);
    eval 'sub ESP_FLUSH_DMA {
        my($esp) = @_;
	    eval q( &if ( ($esp->{e_dmaga_csr}) &  &DMAGA_REQPEND) {  &while ( ($esp->{e_dma}->{dmaga_csr}) &  &DMAGA_REQPEND); }  ($esp->{e_dmaga_csr}) |=  &DMAGA_FLUSH;  ($esp->{e_dmaga_csr}) &= ~( &DMAGA_ENDVMA |  &DMAGA_WRITE |  &DMAGA_ENATC);  ($esp->{e_dma}->{dmaga_csr}) =  ($esp->{e_dmaga_csr});  ($esp->{e_dmaga_csr}) &= ~ &DMAGA_FLUSH;);
    }' unless defined(&ESP_FLUSH_DMA);
    eval 'sub ESP_DRAIN_DMA {
        my($esp) = @_;
	    eval q({ \'int\'  &i = 0;  &register  &volatile \'struct dmaga\' * &dmap =  ($esp->{e_dma});  &if ( &DMAGA_NPACKED( &dmap)) {  &if (( &ESP_DMAGA_REV($esp) !=  &ESC1_REV1)  && ( &ESP_DMAGA_REV($esp) !=  &DMA_REV3)) {  ($esp->{e_dmaga_csr}) |=  &DMAGA_DRAIN;  ($dmap->{dmaga_csr}) =  ($esp->{e_dmaga_csr});  ($esp->{e_dmaga_csr}) &= ~ &DMAGA_DRAIN; }  &EPRINTF(\\"draining dma\\\\n\\");  &for ( &i = 0;  &i <  &DMA_DRAIN_TIMEOUT;  &i++) {  &drv_usecwait(1);  &if ( &DMAGA_NPACKED( &dmap) == 0)  &break; } }  &if (( &i >=  &DMA_DRAIN_TIMEOUT)  && ( &DMAGA_NPACKED( &dmap))) {  &esplog($esp,  &CE_WARN, \\"dma did not drain\\\\n\\");  &return ( &ACTION_RESET); }  &ESP_FLUSH_DMA($esp); });
    }' unless defined(&ESP_DRAIN_DMA);
    eval 'sub esp_chip_disconnect {
        my($esp, $sp) = @_;
	    eval q({  &if ( ($e$sp->{e_ndisc}))  &Esp_cmd($esp,  &CMD_EN_RESEL);  &if ( ($e$sp->{e_cur_slot}) !=  &UNDEFINED  && $sp) {  &if (( ($sp->{cmd_pkt}->{pkt_flags}) &  &FLAG_NOPARITY)  && ( ($e$sp->{e_target_scsi_options[Tgt($sp)]}) &  &SCSI_OPTIONS_PARITY)) {  ($e$sp->{e_reg}->{e$sp_conf}) =  ($e$sp->{e_espconf}); } }  ($e$sp->{e_sdtr}) = 0; });
    }' unless defined(&esp_chip_disconnect);
    eval 'sub ESP_WAKEUP_CALLBACK_THREAD {
        my($esp) = @_;
	    eval q({  &register \'struct callback_info\' * &cb_info =  ($esp->{e_callback_info});  &if ( ($esp->{e_callback_signal_needed})) {  ($esp->{e_callback_signal_needed}) = 0;  &esp_wakeup_callback_thread( &cb_info); } });
    }' unless defined(&ESP_WAKEUP_CALLBACK_THREAD);
    eval 'sub ESP_CHECK_STARTQ_AND_ESP_MUTEX_EXIT {
        my($esp) = @_;
	    eval q( &mutex_enter( ($esp->{e_startQ_mutex}));  &if ( ($esp->{e_startf})) {  &esp_empty_startQ($esp); }  &mutex_exit( &ESP_MUTEX);  &mutex_exit( ($esp->{e_startQ_mutex})););
    }' unless defined(&ESP_CHECK_STARTQ_AND_ESP_MUTEX_EXIT);
    eval 'sub NO_TRAN_BUSY () {0;}' unless defined(&NO_TRAN_BUSY);
    eval 'sub TRAN_BUSY_OK () {1;}' unless defined(&TRAN_BUSY_OK);
    eval 'sub ESP_WATCH_RESET_DELAY_TICK () {50;}' unless defined(&ESP_WATCH_RESET_DELAY_TICK);
    eval 'sub RECONNECT_TAG_RCV_TIMEOUT () {2000;}' unless defined(&RECONNECT_TAG_RCV_TIMEOUT);
    eval 'sub QFULL_RETRIES () {10;}' unless defined(&QFULL_RETRIES);
    eval 'sub QFULL_RETRY_INTERVAL () {100;}' unless defined(&QFULL_RETRY_INTERVAL);
    eval 'sub RQ_MAKECOM_COMMON {
        my($pktp, $flag, $cmd) = @_;
	    eval q(($pktp)-> &pkt_flags = ($flag), (($pktp)-> &pkt_cdbp)-> &scc_cmd = ($cmd), (($pktp)-> &pkt_cdbp)-> &scc_lun = ($pktp)-> ($pkt_address->{a_lun}));
    }' unless defined(&RQ_MAKECOM_COMMON);
    eval 'sub RQ_MAKECOM_G0 {
        my($pktp, $flag, $cmd, $addr, $cnt) = @_;
	    eval q( &RQ_MAKECOM_COMMON(($pktp), ($flag), ($cmd)),  &FORMG0ADDR((($pktp)-> &pkt_cdbp), ($addr)),  &FORMG0COUNT((($pktp)-> &pkt_cdbp), ($cnt)));
    }' unless defined(&RQ_MAKECOM_G0);
    eval 'sub MARK_PKT {
        my($sp, $reason, $stat) = @_;
	    eval q( &if ( ($sp->{cmd_pkt}->{pkt_reason}) ==  &CMD_CMPLT) {  ($sp->{cmd_pkt}->{pkt_reason}) = $reason; }  ($sp->{cmd_pkt}->{pkt_statistics}) |= $stat;);
    }' unless defined(&MARK_PKT);
    eval 'sub COMPLETE_PKT {
        my($sp, $reason, $stat) = @_;
	    eval q( &MARK_PKT($sp, $reason, $stat);  &esp_call_pkt_comp( &esp, $sp));
    }' unless defined(&COMPLETE_PKT);
    eval 'sub NEW_TIMEOUT () {1;}' unless defined(&NEW_TIMEOUT);
    if(defined(&__cplusplus)) {
    }
}
1;
