require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_ADAPTERS_FASDMA_H)) {
    eval 'sub _SYS_SCSI_ADAPTERS_FASDMA_H () {1;}' unless defined(&_SYS_SCSI_ADAPTERS_FASDMA_H);
    require 'sys/note.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub DMA_INTPEND () {0x1;}' unless defined(&DMA_INTPEND);
    eval 'sub DMA_ERRPEND () {0x2;}' unless defined(&DMA_ERRPEND);
    eval 'sub DMA_DRAINING () {0x4;}' unless defined(&DMA_DRAINING);
    eval 'sub DMA_INTEN () {0x10;}' unless defined(&DMA_INTEN);
    eval 'sub DMA_RESET () {0x80;}' unless defined(&DMA_RESET);
    eval 'sub DMA_WRITE () {0x100;}' unless defined(&DMA_WRITE);
    eval 'sub DMA_ENDVMA () {0x200;}' unless defined(&DMA_ENDVMA);
    eval 'sub DMA_REQPEND () {0x400;}' unless defined(&DMA_REQPEND);
    eval 'sub DMA_DMAREV () {0x7800;}' unless defined(&DMA_DMAREV);
    eval 'sub DMA_WIDE_EN () {0x8000;}' unless defined(&DMA_WIDE_EN);
    eval 'sub DMA_DSBL_DRAIN () {0x20000;}' unless defined(&DMA_DSBL_DRAIN);
    eval 'sub DMA_BURSTS () {0xc0000;}' unless defined(&DMA_BURSTS);
    eval 'sub DMA_TWO_CYCLE () {0x200000;}' unless defined(&DMA_TWO_CYCLE);
    eval 'sub DMA_DSBL_PARITY () {0x2000000;}' unless defined(&DMA_DSBL_PARITY);
    eval 'sub DMA_PAUSE_FAS () {0x4000000;}' unless defined(&DMA_PAUSE_FAS);
    eval 'sub DMA_RESET_FAS () {0x8000000;}' unless defined(&DMA_RESET_FAS);
    eval 'sub DMA_DEV_ID () {0xf0000000;}' unless defined(&DMA_DEV_ID);
    eval 'sub DMA_INT_MASK () {( &DMA_INTPEND |  &DMA_ERRPEND);}' unless defined(&DMA_INT_MASK);
    eval 'sub DMA_BITS () {"\\20\\34RST\\33PSE\\31DSBLPAR\\26TWOCYC\\24BRST1\\23BST0\\22DSBLEDRN\\20WIDE\\13REQPEND\\12ENBLE\\11WR\\10RST\\05INTEN\\03DRNING\\02ERRPEND\\01INTPND";}' unless defined(&DMA_BITS);
    eval 'sub DMAREV {
        my($dmap) = @_;
	    eval q(((( ($dmap->{dma_csr})) &  &DMA_DMAREV) >> 11));
    }' unless defined(&DMAREV);
    eval 'sub DMA_BURST16 () {0x;}' unless defined(&DMA_BURST16);
    eval 'sub DMA_BURST32 () {0x40000;}' unless defined(&DMA_BURST32);
    eval 'sub DMA_BURST64 () {0xc0000;}' unless defined(&DMA_BURST64);
    eval 'sub DMA_CE_ID () {0xb0000000;}' unless defined(&DMA_CE_ID);
    eval 'sub BURST1 () {0x1;}' unless defined(&BURST1);
    eval 'sub BURST2 () {0x2;}' unless defined(&BURST2);
    eval 'sub BURST4 () {0x4;}' unless defined(&BURST4);
    eval 'sub BURST8 () {0x8;}' unless defined(&BURST8);
    eval 'sub BURST16 () {0x10;}' unless defined(&BURST16);
    eval 'sub BURST32 () {0x20;}' unless defined(&BURST32);
    eval 'sub BURST64 () {0x40;}' unless defined(&BURST64);
    eval 'sub BURSTSIZE_MASK () {0x7f;}' unless defined(&BURSTSIZE_MASK);
    eval 'sub DEFAULT_BURSTSIZE () { &BURST64| &BURST32| &BURST16| &BURST8| &BURST4| &BURST2| &BURST1;}' unless defined(&DEFAULT_BURSTSIZE);
    if(defined(&__cplusplus)) {
    }
}
1;
