require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_CONF_AUTOCONF_H)) {
    eval 'sub _SYS_SCSI_CONF_AUTOCONF_H () {1;}' unless defined(&_SYS_SCSI_CONF_AUTOCONF_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub SCSI_DEBUG_TGT () {0x1;}' unless defined(&SCSI_DEBUG_TGT);
    eval 'sub SCSI_DEBUG_LIB () {0x2;}' unless defined(&SCSI_DEBUG_LIB);
    eval 'sub SCSI_DEBUG_HA () {0x4;}' unless defined(&SCSI_DEBUG_HA);
    eval 'sub SCSI_OPTIONS_LINK () {0x10;}' unless defined(&SCSI_OPTIONS_LINK);
    eval 'sub SCSI_OPTIONS_TAG () {0x80;}' unless defined(&SCSI_OPTIONS_TAG);
    eval 'sub SCSI_OPTIONS_DR () {0x8;}' unless defined(&SCSI_OPTIONS_DR);
    eval 'sub SCSI_OPTIONS_SYNC () {0x20;}' unless defined(&SCSI_OPTIONS_SYNC);
    eval 'sub SCSI_OPTIONS_PARITY () {0x40;}' unless defined(&SCSI_OPTIONS_PARITY);
    eval 'sub SCSI_OPTIONS_FAST () {0x100;}' unless defined(&SCSI_OPTIONS_FAST);
    eval 'sub SCSI_OPTIONS_WIDE () {0x200;}' unless defined(&SCSI_OPTIONS_WIDE);
    eval 'sub SCSI_OPTIONS_FAST20 () {0x400;}' unless defined(&SCSI_OPTIONS_FAST20);
    eval 'sub SCSI_OPTIONS_FAST40 () {0x800;}' unless defined(&SCSI_OPTIONS_FAST40);
    eval 'sub SCSI_OPTIONS_FAST80 () {0x1000;}' unless defined(&SCSI_OPTIONS_FAST80);
    eval 'sub SCSI_OPTIONS_NLUNS_MASK () {(0x70000);}' unless defined(&SCSI_OPTIONS_NLUNS_MASK);
    eval 'sub SCSI_OPTIONS_NLUNS_DEFAULT () {0x;}' unless defined(&SCSI_OPTIONS_NLUNS_DEFAULT);
    eval 'sub SCSI_OPTIONS_NLUNS_1 () {0x10000;}' unless defined(&SCSI_OPTIONS_NLUNS_1);
    eval 'sub SCSI_OPTIONS_NLUNS_8 () {0x20000;}' unless defined(&SCSI_OPTIONS_NLUNS_8);
    eval 'sub SCSI_OPTIONS_NLUNS_16 () {0x30000;}' unless defined(&SCSI_OPTIONS_NLUNS_16);
    eval 'sub SCSI_OPTIONS_NLUNS_32 () {0x40000;}' unless defined(&SCSI_OPTIONS_NLUNS_32);
    eval 'sub SCSI_OPTIONS_NLUNS {
        my($n) = @_;
	    eval q((($n) &  &SCSI_OPTIONS_NLUNS_MASK));
    }' unless defined(&SCSI_OPTIONS_NLUNS);
    eval 'sub SCSIPROBE_EXISTS () {0;}' unless defined(&SCSIPROBE_EXISTS);
    eval 'sub SCSIPROBE_NONCCS () {1;}' unless defined(&SCSIPROBE_NONCCS);
    eval 'sub SCSIPROBE_NORESP () {2;}' unless defined(&SCSIPROBE_NORESP);
    eval 'sub SCSIPROBE_NOMEM () {3;}' unless defined(&SCSIPROBE_NOMEM);
    eval 'sub SCSIPROBE_FAILURE () {4;}' unless defined(&SCSIPROBE_FAILURE);
    eval 'sub SCSIPROBE_BUSY () {5;}' unless defined(&SCSIPROBE_BUSY);
    eval 'sub SCSIPROBE_NOMEM_CB () {6;}' unless defined(&SCSIPROBE_NOMEM_CB);
    eval 'sub SCSI_DEFAULT_RESET_DELAY () {3000;}' unless defined(&SCSI_DEFAULT_RESET_DELAY);
    eval 'sub SCSI_DEFAULT_SELECTION_TIMEOUT () {250;}' unless defined(&SCSI_DEFAULT_SELECTION_TIMEOUT);
    if(defined(&_KERNEL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
