require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_GENERIC_MODE_H)) {
    eval 'sub _SYS_SCSI_GENERIC_MODE_H () {1;}' unless defined(&_SYS_SCSI_GENERIC_MODE_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub MODE_HEADER_LENGTH () {($sizeof{\'struct mode_header\'});}' unless defined(&MODE_HEADER_LENGTH);
    eval 'sub MODE_BLK_DESC_LENGTH () {($sizeof{\'struct block_descriptor\'});}' unless defined(&MODE_BLK_DESC_LENGTH);
    eval 'sub MODE_PARAM_LENGTH () {( &MODE_HEADER_LENGTH +  &MODE_BLK_DESC_LENGTH);}' unless defined(&MODE_PARAM_LENGTH);
    eval 'sub BLOCK_DESCRIPTOR_ADDR {
        my($mhdr, $bdnum) = @_;
	    eval q((-> &bdesc_length  && (($bdnum)) < (($mhdr)-> &bdesc_length/($sizeof{\'struct block_descriptor\'}))) ? (((($mhdr))+ &MODE_HEADER_LENGTH+ (($bdnum) * $sizeof{\'struct block_descriptor\'}))) : (0));
    }' unless defined(&BLOCK_DESCRIPTOR_ADDR);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("One\ of\ _BIT_FIELDS_LTOH\ or\ _BIT_FIELDS_HTOL\ must\ be\ defined");
    }
    eval 'sub MODE_PAGE_ADDR {
        my($mhdr, $type) = @_;
	    eval q((($type *)((($mhdr))+ &MODE_HEADER_LENGTH+($mhdr)-> &bdesc_length)));
    }' unless defined(&MODE_PAGE_ADDR);
    eval 'sub MODEPAGE_DISCO_RECO () {0x2;}' unless defined(&MODEPAGE_DISCO_RECO);
    eval 'sub MODEPAGE_CACHING () {0x8;}' unless defined(&MODEPAGE_CACHING);
    eval 'sub MODEPAGE_PDEVICE () {0x9;}' unless defined(&MODEPAGE_PDEVICE);
    eval 'sub MODEPAGE_CTRL_MODE () {0xa;}' unless defined(&MODEPAGE_CTRL_MODE);
    eval 'sub MODEPAGE_POWER_COND () {0x1a;}' unless defined(&MODEPAGE_POWER_COND);
    eval 'sub MODEPAGE_INFO_EXCPT () {0x1c;}' unless defined(&MODEPAGE_INFO_EXCPT);
    eval 'sub MODEPAGE_ALLPAGES () {0x3f;}' unless defined(&MODEPAGE_ALLPAGES);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("One\ of\ _BIT_FIELDS_LTOH\ or\ _BIT_FIELDS_HTOL\ must\ be\ defined");
    }
    eval 'sub DTDC_DATADONE () {0x1;}' unless defined(&DTDC_DATADONE);
    eval 'sub DTDC_CMDDONE () {0x3;}' unless defined(&DTDC_CMDDONE);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("One\ of\ _BIT_FIELDS_LTOH\ or\ _BIT_FIELDS_HTOL\ must\ be\ defined");
    }
    eval 'sub PDEV_SCSI () {0x;}' unless defined(&PDEV_SCSI);
    eval 'sub PDEV_SMD () {0x1;}' unless defined(&PDEV_SMD);
    eval 'sub PDEV_ESDI () {0x2;}' unless defined(&PDEV_ESDI);
    eval 'sub PDEV_IPI2 () {0x3;}' unless defined(&PDEV_IPI2);
    eval 'sub PDEV_IPI3 () {0x4;}' unless defined(&PDEV_IPI3);
    eval 'sub PAGELENGTH_MODE_CONTROL_SCSI3 () {0xa;}' unless defined(&PAGELENGTH_MODE_CONTROL_SCSI3);
    if(defined( &_BIT_FIELDS_LTOH)) {
    }
 elsif(defined( &_BIT_FIELDS_HTOL)) {
    } else {
	die("One\ of\ _BIT_FIELDS_LTOH\ or\ _BIT_FIELDS_HTOL\ must\ be\ defined");
    }
    eval 'sub CTRL_QMOD_RESTRICT () {0x;}' unless defined(&CTRL_QMOD_RESTRICT);
    eval 'sub CTRL_QMOD_UNRESTRICT () {0x1;}' unless defined(&CTRL_QMOD_UNRESTRICT);
    if(defined(&__cplusplus)) {
    }
    require 'sys/scsi/generic/dad_mode.ph';
    require 'sys/scsi/impl/mode.ph';
}
1;
