require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_SCSI_PKT_H)) {
    eval 'sub _SYS_SCSI_SCSI_PKT_H () {1;}' unless defined(&_SYS_SCSI_SCSI_PKT_H);
    require 'sys/scsi/scsi_types.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub FLAG_STAG () {0x4000;}' unless defined(&FLAG_STAG);
    eval 'sub FLAG_OTAG () {0x2000;}' unless defined(&FLAG_OTAG);
    eval 'sub FLAG_HTAG () {0x1000;}' unless defined(&FLAG_HTAG);
    eval 'sub FLAG_TAGMASK () {( &FLAG_HTAG| &FLAG_OTAG| &FLAG_STAG);}' unless defined(&FLAG_TAGMASK);
    eval 'sub FLAG_ACA () {0x100;}' unless defined(&FLAG_ACA);
    eval 'sub FLAG_HEAD () {0x8000;}' unless defined(&FLAG_HEAD);
    eval 'sub FLAG_SENSING () {0x400;}' unless defined(&FLAG_SENSING);
    eval 'sub FLAG_NOINTR () {0x1;}' unless defined(&FLAG_NOINTR);
    eval 'sub FLAG_NODISCON () {0x2;}' unless defined(&FLAG_NODISCON);
    eval 'sub FLAG_NOPARITY () {0x8;}' unless defined(&FLAG_NOPARITY);
    eval 'sub FLAG_RENEGOTIATE_WIDE_SYNC () {0x1000000;}' unless defined(&FLAG_RENEGOTIATE_WIDE_SYNC);
    eval 'sub FLAG_SUBLUN () {0x4;}' unless defined(&FLAG_SUBLUN);
    eval 'sub FLAG_QUEHOLD () {0x200;}' unless defined(&FLAG_QUEHOLD);
    eval 'sub FLAG_IMMEDIATE_CB () {0x800;}' unless defined(&FLAG_IMMEDIATE_CB);
    eval 'sub FLAG_SILENT () {0x10000;}' unless defined(&FLAG_SILENT);
    eval 'sub FLAG_DIAGNOSE () {0x20000;}' unless defined(&FLAG_DIAGNOSE);
    eval 'sub FLAG_ISOLATE () {0x40000;}' unless defined(&FLAG_ISOLATE);
    eval 'sub CMD_CMPLT () {0;}' unless defined(&CMD_CMPLT);
    eval 'sub CMD_INCOMPLETE () {1;}' unless defined(&CMD_INCOMPLETE);
    eval 'sub CMD_DMA_DERR () {2;}' unless defined(&CMD_DMA_DERR);
    eval 'sub CMD_TRAN_ERR () {3;}' unless defined(&CMD_TRAN_ERR);
    eval 'sub CMD_RESET () {4;}' unless defined(&CMD_RESET);
    eval 'sub CMD_ABORTED () {5;}' unless defined(&CMD_ABORTED);
    eval 'sub CMD_TERMINATED () {22;}' unless defined(&CMD_TERMINATED);
    eval 'sub CMD_TIMEOUT () {6;}' unless defined(&CMD_TIMEOUT);
    eval 'sub CMD_DATA_OVR () {7;}' unless defined(&CMD_DATA_OVR);
    eval 'sub CMD_CMD_OVR () {8;}' unless defined(&CMD_CMD_OVR);
    eval 'sub CMD_STS_OVR () {9;}' unless defined(&CMD_STS_OVR);
    eval 'sub CMD_BADMSG () {10;}' unless defined(&CMD_BADMSG);
    eval 'sub CMD_NOMSGOUT () {11;}' unless defined(&CMD_NOMSGOUT);
    eval 'sub CMD_XID_FAIL () {12;}' unless defined(&CMD_XID_FAIL);
    eval 'sub CMD_IDE_FAIL () {13;}' unless defined(&CMD_IDE_FAIL);
    eval 'sub CMD_ABORT_FAIL () {14;}' unless defined(&CMD_ABORT_FAIL);
    eval 'sub CMD_REJECT_FAIL () {15;}' unless defined(&CMD_REJECT_FAIL);
    eval 'sub CMD_NOP_FAIL () {16;}' unless defined(&CMD_NOP_FAIL);
    eval 'sub CMD_PER_FAIL () {17;}' unless defined(&CMD_PER_FAIL);
    eval 'sub CMD_BDR_FAIL () {18;}' unless defined(&CMD_BDR_FAIL);
    eval 'sub CMD_ID_FAIL () {19;}' unless defined(&CMD_ID_FAIL);
    eval 'sub CMD_UNX_BUS_FREE () {20;}' unless defined(&CMD_UNX_BUS_FREE);
    eval 'sub CMD_TAG_REJECT () {21;}' unless defined(&CMD_TAG_REJECT);
    eval 'sub STATE_GOT_BUS () {0x1;}' unless defined(&STATE_GOT_BUS);
    eval 'sub STATE_GOT_TARGET () {0x2;}' unless defined(&STATE_GOT_TARGET);
    eval 'sub STATE_SENT_CMD () {0x4;}' unless defined(&STATE_SENT_CMD);
    eval 'sub STATE_XFERRED_DATA () {0x8;}' unless defined(&STATE_XFERRED_DATA);
    eval 'sub STATE_GOT_STATUS () {0x10;}' unless defined(&STATE_GOT_STATUS);
    eval 'sub STATE_ARQ_DONE () {0x20;}' unless defined(&STATE_ARQ_DONE);
    eval 'sub STAT_BUS_RESET () {0x8;}' unless defined(&STAT_BUS_RESET);
    eval 'sub STAT_DEV_RESET () {0x10;}' unless defined(&STAT_DEV_RESET);
    eval 'sub STAT_ABORTED () {0x20;}' unless defined(&STAT_ABORTED);
    eval 'sub STAT_TERMINATED () {0x80;}' unless defined(&STAT_TERMINATED);
    eval 'sub STAT_TIMEOUT () {0x40;}' unless defined(&STAT_TIMEOUT);
    eval 'sub STAT_DISCON () {0x1;}' unless defined(&STAT_DISCON);
    eval 'sub STAT_SYNC () {0x2;}' unless defined(&STAT_SYNC);
    eval 'sub STAT_PERR () {0x4;}' unless defined(&STAT_PERR);
    eval 'sub TRAN_ACCEPT () {1;}' unless defined(&TRAN_ACCEPT);
    eval 'sub TRAN_BUSY () {0;}' unless defined(&TRAN_BUSY);
    eval 'sub TRAN_BADPKT () {-1;}' unless defined(&TRAN_BADPKT);
    eval 'sub TRAN_FATAL_ERROR () {-2;}' unless defined(&TRAN_FATAL_ERROR);
    if(defined(&_KERNEL)) {
	eval 'sub pkt_transport () { &scsi_transport;}' unless defined(&pkt_transport);
	if(defined(&__STDC__)) {
	} else {
	}
	eval 'sub SCSI_POLL_TIMEOUT () {60;}' unless defined(&SCSI_POLL_TIMEOUT);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
