require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_TARGETS_PLN_CTLR_H)) {
    eval 'sub _SYS_SCSI_TARGETS_PLN_CTLR_H () {1;}' unless defined(&_SYS_SCSI_TARGETS_PLN_CTLR_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&DEBUG)) {
	eval 'sub PLN_CTLR_DEBUG () {1;}' unless defined(&PLN_CTLR_DEBUG);
    }
    if(defined( &_KERNEL) || defined( &_KMEMUSER)) {
	eval 'sub NEW_STATE {
	    my($state) = @_;
    	    eval q( ($pctlr->{pln_last_state}) =  ($pctlr->{pln_state});  ($pctlr->{pln_state}) = ($state));
	}' unless defined(&NEW_STATE);
	eval 'sub PLN_CTLR_SCSI_DEVP () {( ($pctlr->{pln_scsi_devicep}));}' unless defined(&PLN_CTLR_SCSI_DEVP);
	eval 'sub PLN_CTLR_MUTEX () {(( &PLN_CTLR_SCSI_DEVP)-> &sd_mutex);}' unless defined(&PLN_CTLR_MUTEX);
	eval 'sub ROUTE () {(( &PLN_CTLR_SCSI_DEVP)-> &sd_address);}' unless defined(&ROUTE);
	eval 'sub SCBP {
	    my($pkt) = @_;
    	    eval q((($pkt)-> &pkt_scbp));
	}' unless defined(&SCBP);
	eval 'sub SCBP_C {
	    my($pkt) = @_;
    	    eval q(((*($pkt)-> &pkt_scbp) &  &STATUS_MASK));
	}' unless defined(&SCBP_C);
	eval 'sub CDBP {
	    my($pkt) = @_;
    	    eval q((($pkt)-> &pkt_cdbp));
	}' unless defined(&CDBP);
	eval 'sub BP_PKT {
	    my($bp) = @_;
    	    eval q(( ($bp->{av_back})));
	}' unless defined(&BP_PKT);
	eval 'sub PLN_CTLR_MINOR {
	    my($i, $p) = @_;
    	    eval q(((($i) << 2) | ($p)));
	}' unless defined(&PLN_CTLR_MINOR);
	eval 'sub PLN_CTLR_INST {
	    my($d) = @_;
    	    eval q(( &getminor(($d)) >> 2));
	}' unless defined(&PLN_CTLR_INST);
	eval 'sub PLN_CTLR_NODE {
	    my($d) = @_;
    	    eval q(( &getminor(($d)) & 3));
	}' unless defined(&PLN_CTLR_NODE);
	eval 'sub PLN_CTLR_NODE_CTLR () {0;}' unless defined(&PLN_CTLR_NODE_CTLR);
	eval 'sub PLN_CTLR_NODE_DEVCTL () {1;}' unless defined(&PLN_CTLR_NODE_DEVCTL);
	eval 'sub PLN_CTLR_NODE_SCSI () {2;}' unless defined(&PLN_CTLR_NODE_SCSI);
	if(defined(&PLN_CTLR_DEBUG)) {
	    eval 'sub PLN_CTLR_CE_DEBUG () {((1<< 8) |  &CE_CONT);}' unless defined(&PLN_CTLR_CE_DEBUG);
	    eval 'sub PLN_CTLR_CE_DEBUG1 () {((2<< 8) |  &CE_CONT);}' unless defined(&PLN_CTLR_CE_DEBUG1);
	    eval 'sub PLN_CTLR_CE_DEBUG2 () {((3<< 8) |  &CE_CONT);}' unless defined(&PLN_CTLR_CE_DEBUG2);
	    eval 'sub PLN_CTLR_CE_DEBUG3 () {((4<< 8) |  &CE_CONT);}' unless defined(&PLN_CTLR_CE_DEBUG3);
	    eval 'sub PLN_CTLR_LOG () { &if ( &pln_ctlr_debug)  &pln_ctlr_log;}' unless defined(&PLN_CTLR_LOG);
	    eval 'sub PLN_CTLR_DEBUG_ENTER () { &if ( &pln_ctlr_debug)  &debug_enter;}' unless defined(&PLN_CTLR_DEBUG_ENTER);
	} else {
	    eval 'sub PLN_CTLR_CE_DEBUG () {0;}' unless defined(&PLN_CTLR_CE_DEBUG);
	    eval 'sub PLN_CTLR_CE_DEBUG1 () {0;}' unless defined(&PLN_CTLR_CE_DEBUG1);
	    eval 'sub PLN_CTLR_CE_DEBUG2 () {0;}' unless defined(&PLN_CTLR_CE_DEBUG2);
	    eval 'sub PLN_CTLR_CE_DEBUG3 () {0;}' unless defined(&PLN_CTLR_CE_DEBUG3);
	    eval 'sub PLN_CTLR_LOG () { &if (0)  &pln_ctlr_log;}' unless defined(&PLN_CTLR_LOG);
	    eval 'sub PLN_CTLR_DEBUG_ENTER () { &if (0) ( &void)  &debug_enter;}' unless defined(&PLN_CTLR_DEBUG_ENTER);
	}
    }
    eval 'sub PLN_CTLR_STATE_ATTACHED () {0;}' unless defined(&PLN_CTLR_STATE_ATTACHED);
    eval 'sub PLN_CTLR_STATE_CLOSED () {1;}' unless defined(&PLN_CTLR_STATE_CLOSED);
    eval 'sub PLN_CTLR_STATE_OPENING () {2;}' unless defined(&PLN_CTLR_STATE_OPENING);
    eval 'sub PLN_CTLR_STATE_OPEN () {3;}' unless defined(&PLN_CTLR_STATE_OPEN);
    eval 'sub PLN_CTLR_STATE_SENSING () {4;}' unless defined(&PLN_CTLR_STATE_SENSING);
    eval 'sub PLN_CTLR_STATE_RWAIT () {5;}' unless defined(&PLN_CTLR_STATE_RWAIT);
    eval 'sub PLN_CTLR_STATE_DETACHING () {6;}' unless defined(&PLN_CTLR_STATE_DETACHING);
    eval 'sub PLN_CTLR_IO_TIME () {35;}' unless defined(&PLN_CTLR_IO_TIME);
    eval 'sub PLN_CTLR_BSY_TIMEOUT () {( &drv_usectohz(5* 1000000));}' unless defined(&PLN_CTLR_BSY_TIMEOUT);
    eval 'sub PLN_CTLR_RETRY_COUNT () {4;}' unless defined(&PLN_CTLR_RETRY_COUNT);
    eval 'sub COMMAND_DONE () {0;}' unless defined(&COMMAND_DONE);
    eval 'sub COMMAND_DONE_ERROR () {1;}' unless defined(&COMMAND_DONE_ERROR);
    eval 'sub QUE_COMMAND () {2;}' unless defined(&QUE_COMMAND);
    eval 'sub QUE_SENSE () {3;}' unless defined(&QUE_SENSE);
    eval 'sub JUST_RETURN () {4;}' unless defined(&JUST_RETURN);
    if(defined(&__cplusplus)) {
    }
}
1;
