require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SCSI_TARGETS_SES_H)) {
    eval 'sub _SYS_SCSI_TARGETS_SES_H () {1;}' unless defined(&_SYS_SCSI_TARGETS_SES_H);
    require 'sys/note.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub EOK () {0;}' unless defined(&EOK);
    eval 'sub BP_PKT {
        my($bp) = @_;
	    eval q((($bp)-> &av_back));
    }' unless defined(&BP_PKT);
    eval 'sub SET_BP_PKT {
        my($bp, $s) = @_;
	    eval q(($bp)-> &av_back = ($s));
    }' unless defined(&SET_BP_PKT);
    eval 'sub SCBP {
        my($pkt) = @_;
	    eval q((($pkt)-> &pkt_scbp));
    }' unless defined(&SCBP);
    eval 'sub SCBP_C {
        my($pkt) = @_;
	    eval q(((*($pkt)-> &pkt_scbp) &  &STATUS_MASK));
    }' unless defined(&SCBP_C);
    eval 'sub Scsidevp () {\'struct scsi_device\' *;}' unless defined(&Scsidevp);
    eval 'sub Scsipktp () {\'struct scsi_pkt\' *;}' unless defined(&Scsipktp);
    eval 'sub Uscmd () {\'struct uscsi_cmd\';}' unless defined(&Uscmd);
    eval 'sub SES_SCSI_DEVP () {( ($un->{ses_scsi_devp}));}' unless defined(&SES_SCSI_DEVP);
    eval 'sub SES_DEVP {
        my($softc) = @_;
	    eval q((($softc)-> &ses_devp));
    }' unless defined(&SES_DEVP);
    eval 'sub SES_DEVINFO {
        my($softc) = @_;
	    eval q(( &SES_DEVP($softc)-> &sd_dev));
    }' unless defined(&SES_DEVINFO);
    eval 'sub SES_RQSENSE {
        my($softc) = @_;
	    eval q(( &SES_DEVP($softc)-> &sd_sense));
    }' unless defined(&SES_RQSENSE);
    eval 'sub SES_ROUTE {
        my($softc) = @_;
	    eval q(( &SES_DEVP($softc)-> &sd_address));
    }' unless defined(&SES_ROUTE);
    eval 'sub SES_MUTEX () {( ($ssc->{ses_devp}->{sd_mutex}));}' unless defined(&SES_MUTEX);
    eval 'sub ISOPEN {
        my($softc) = @_;
	    eval q((($softc)-> &ses_lyropen || ($softc)-> &ses_oflag));
    }' unless defined(&ISOPEN);
    eval 'sub UNUSED_PARAMETER {
        my($x) = @_;
	    eval q($x = $x);
    }' unless defined(&UNUSED_PARAMETER);
    eval 'sub SAFTE_RD_RDCFG () {0x;}' unless defined(&SAFTE_RD_RDCFG);
    eval 'sub SAFTE_RD_RDESTS () {0x1;}' unless defined(&SAFTE_RD_RDESTS);
    eval 'sub SAFTE_RD_RDDSTS () {0x4;}' unless defined(&SAFTE_RD_RDDSTS);
    eval 'sub SAFTE_WT_DSTAT () {0x10;}' unless defined(&SAFTE_WT_DSTAT);
    eval 'sub SAFTE_WT_SLTOP () {0x12;}' unless defined(&SAFTE_WT_SLTOP);
    eval 'sub SAFTE_WT_FANSPD () {0x13;}' unless defined(&SAFTE_WT_FANSPD);
    eval 'sub SAFTE_WT_ACTPWS () {0x14;}' unless defined(&SAFTE_WT_ACTPWS);
    eval 'sub SAFTE_WT_GLOBAL () {0x15;}' unless defined(&SAFTE_WT_GLOBAL);
    require 'sys/scsi/targets/sesio.ph';
    eval("sub SES_TYPE () { 0; }") unless defined(&SES_TYPE);
    eval("sub SAFT_TYPE () { 1; }") unless defined(&SAFT_TYPE);
    eval("sub SEN_TYPE () { 2; }") unless defined(&SEN_TYPE);
    unless(defined(&lint)) {
	if(defined(&_KERNEL)) {
	}
    }
    eval 'sub ENCI_SVALID () {0x80;}' unless defined(&ENCI_SVALID);
    unless(defined(&lint)) {
	if(defined(&_KERNEL)) {
	}
    }
    if(defined(&DEBUG)) {
	eval 'sub SES_DEBUG () {1;}' unless defined(&SES_DEBUG);
    }
    if(defined( &_KERNEL) || defined( &_KMEMUSER)) {
	eval 'sub SES_CE_DEBUG () {((1<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG);
	eval 'sub SES_CE_DEBUG1 () {((2<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG1);
	eval 'sub SES_CE_DEBUG2 () {((3<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG2);
	eval 'sub SES_CE_DEBUG3 () {((4<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG3);
	eval 'sub SES_CE_DEBUG4 () {((5<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG4);
	eval 'sub SES_CE_DEBUG5 () {((6<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG5);
	eval 'sub SES_CE_DEBUG6 () {((7<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG6);
	eval 'sub SES_CE_DEBUG7 () {((8<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG7);
	eval 'sub SES_CE_DEBUG8 () {((9<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG8);
	eval 'sub SES_CE_DEBUG9 () {((10<< 8) |  &CE_CONT);}' unless defined(&SES_CE_DEBUG9);
	unless(defined(&SES_DEBUG)) {
	    eval 'sub ses_debug () {0;}' unless defined(&ses_debug);
	}
	eval 'sub SES_LOG () { &if ( &ses_debug)  &ses_log;}' unless defined(&SES_LOG);
	eval 'sub SES_DEBUG_ENTER () { &if ( &ses_debug)  &debug_enter;}' unless defined(&SES_DEBUG_ENTER);
	eval 'sub SES_IO_TIME () {60;}' unless defined(&SES_IO_TIME);
	eval 'sub SES_RESTART_TIME () {100;}' unless defined(&SES_RESTART_TIME);
	eval 'sub SES_BUSY_TIME () {5000;}' unless defined(&SES_BUSY_TIME);
	eval 'sub SES_ENABLE_RESTART {
	    my($ms_time, $pkt) = @_;
    	    eval q({  ($ssc->{ses_restart_id}) =  &timeout( &ses_restart, ( &void *) $pkt, ($ms_time)? ($ms_time *  &drv_usectohz(1000)):  &drv_usectohz(1000)); });
	}' unless defined(&SES_ENABLE_RESTART);
	eval 'sub SES_RETRY_COUNT () {4;}' unless defined(&SES_RETRY_COUNT);
	eval 'sub SES_RETRY_MULTIPLIER () {8;}' unless defined(&SES_RETRY_MULTIPLIER);
	eval 'sub SES_CMD_RETRY () { &SES_RETRY_MULTIPLIER;}' unless defined(&SES_CMD_RETRY);
	eval 'sub SES_NO_RETRY () {0;}' unless defined(&SES_NO_RETRY);
	eval 'sub SES_SENSE_RETRY () {1;}' unless defined(&SES_SENSE_RETRY);
	eval 'sub SES_BUSY_RETRY () {2;}' unless defined(&SES_BUSY_RETRY);
	eval 'sub SES_CMD_RETRY1 {
	    my($retry) = @_;
    	    eval q($retry += ($retry > 0)? ( &SES_RETRY_MULTIPLIER -1) : 0;);
	}' unless defined(&SES_CMD_RETRY1);
	eval 'sub SES_CMD_RETRY2 {
	    my($retry) = @_;
    	    eval q($retry += ($retry > 0)? ( &SES_RETRY_MULTIPLIER -2) : 0;);
	}' unless defined(&SES_CMD_RETRY2);
	eval 'sub SES_CMD_RETRY4 {
	    my($retry) = @_;
    	    eval q($retry += ($retry > 0)? ( &SES_RETRY_MULTIPLIER -4) : 0;);
	}' unless defined(&SES_CMD_RETRY4);
	eval 'sub SES_CLOSED () {0;}' unless defined(&SES_CLOSED);
	eval 'sub SES_OPENING () {1;}' unless defined(&SES_OPENING);
	eval 'sub SES_OPEN () {2;}' unless defined(&SES_OPEN);
	eval 'sub COMMAND_DONE () {0;}' unless defined(&COMMAND_DONE);
	eval 'sub COMMAND_DONE_ERROR () {1;}' unless defined(&COMMAND_DONE_ERROR);
	eval 'sub QUE_COMMAND_NOW () {3;}' unless defined(&QUE_COMMAND_NOW);
	eval 'sub QUE_COMMAND () {4;}' unless defined(&QUE_COMMAND);
	eval 'sub QUE_SENSE () {5;}' unless defined(&QUE_SENSE);
	eval 'sub SCSI_ESI_PF () {0x10;}' unless defined(&SCSI_ESI_PF);
	eval 'sub SEN_ID () {"UNISYS	   SUN_SEN";}' unless defined(&SEN_ID);
	eval 'sub SEN_ID_LEN () {24;}' unless defined(&SEN_ID_LEN);
	eval 'sub SET_BP_ERROR {
	    my($bp, $err) = @_;
    	    eval q( ($bp->{b_oerror}) = $err,  &bioerror($bp, $err););
	}' unless defined(&SET_BP_ERROR);
	unless(defined(&DTYPE_ESI)) {
	    eval 'sub DTYPE_ESI () {0x13;}' unless defined(&DTYPE_ESI);
	}
	if(defined( &_KERNEL)) {
	    if(defined(&DEBUG)) {
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
