require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SER_SYNC_H)) {
    eval 'sub _SYS_SER_SYNC_H () {1;}' unless defined(&_SYS_SER_SYNC_H);
    require 'sys/stream.ph';
    require 'sys/time_impl.ph';
    require 'sys/ioccom.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub zIOC () {(ord(\'z\') << 8);}' unless defined(&zIOC);
    eval 'sub S_IOCGETMODE () {( &zIOC|01);}' unless defined(&S_IOCGETMODE);
    eval 'sub S_IOCSETMODE () {( &zIOC|02);}' unless defined(&S_IOCSETMODE);
    eval 'sub S_IOCGETSTATS () {( &zIOC|03);}' unless defined(&S_IOCGETSTATS);
    eval 'sub S_IOCCLRSTATS () {( &zIOC|04);}' unless defined(&S_IOCCLRSTATS);
    eval 'sub S_IOCGETSPEED () {( &zIOC|05);}' unless defined(&S_IOCGETSPEED);
    eval 'sub S_IOCGETMRU () {( &zIOC|06);}' unless defined(&S_IOCGETMRU);
    eval 'sub S_IOCSETMRU () {( &zIOC|07);}' unless defined(&S_IOCSETMRU);
    eval 'sub S_IOCGETMTU () {( &zIOC|010);}' unless defined(&S_IOCGETMTU);
    eval 'sub S_IOCSETMTU () {( &zIOC|011);}' unless defined(&S_IOCSETMTU);
    eval 'sub S_IOCGETMCTL () {( &zIOC|012);}' unless defined(&S_IOCGETMCTL);
    eval 'sub S_IOCSETDTR () {( &zIOC|013);}' unless defined(&S_IOCSETDTR);
    eval 'sub SMERR_TXC () {0x1;}' unless defined(&SMERR_TXC);
    eval 'sub SMERR_RXC () {0x2;}' unless defined(&SMERR_RXC);
    eval 'sub SMERR_IFLAGS () {0x4;}' unless defined(&SMERR_IFLAGS);
    eval 'sub SMERR_HDX () {0x8;}' unless defined(&SMERR_HDX);
    eval 'sub SMERR_MPT () {0x10;}' unless defined(&SMERR_MPT);
    eval 'sub SMERR_LPBKS () {0x20;}' unless defined(&SMERR_LPBKS);
    eval 'sub SMERR_BAUDRATE () {0x40;}' unless defined(&SMERR_BAUDRATE);
    eval 'sub SMERR_PLL () {0x80;}' unless defined(&SMERR_PLL);
    eval 'sub TXC_IS_TXC () {0;}' unless defined(&TXC_IS_TXC);
    eval 'sub TXC_IS_RXC () {1;}' unless defined(&TXC_IS_RXC);
    eval 'sub TXC_IS_BAUD () {2;}' unless defined(&TXC_IS_BAUD);
    eval 'sub TXC_IS_PLL () {3;}' unless defined(&TXC_IS_PLL);
    eval 'sub RXC_IS_RXC () {0;}' unless defined(&RXC_IS_RXC);
    eval 'sub RXC_IS_TXC () {1;}' unless defined(&RXC_IS_TXC);
    eval 'sub RXC_IS_BAUD () {2;}' unless defined(&RXC_IS_BAUD);
    eval 'sub RXC_IS_PLL () {3;}' unless defined(&RXC_IS_PLL);
    eval 'sub TXC_IS_SYSCLK () {4;}' unless defined(&TXC_IS_SYSCLK);
    eval 'sub RXC_IS_SYSCLK () {4;}' unless defined(&RXC_IS_SYSCLK);
    eval 'sub TXC_IS_INVERT () {5;}' unless defined(&TXC_IS_INVERT);
    eval 'sub RXC_IS_INVERT () {5;}' unless defined(&RXC_IS_INVERT);
    eval 'sub TRXD_NO_INVERT () {0;}' unless defined(&TRXD_NO_INVERT);
    eval 'sub RXD_IS_INVERT () {1;}' unless defined(&RXD_IS_INVERT);
    eval 'sub TXD_IS_INVERT () {2;}' unless defined(&TXD_IS_INVERT);
    eval 'sub TRXD_IS_INVERT () {3;}' unless defined(&TRXD_IS_INVERT);
    eval 'sub CONN_HDX () {0x1;}' unless defined(&CONN_HDX);
    eval 'sub CONN_MPT () {0x2;}' unless defined(&CONN_MPT);
    eval 'sub CONN_IBM () {0x4;}' unless defined(&CONN_IBM);
    eval 'sub CONN_SIGNAL () {0x8;}' unless defined(&CONN_SIGNAL);
    eval 'sub CONN_NRZI () {0x10;}' unless defined(&CONN_NRZI);
    eval 'sub CONN_LPBK () {0x20;}' unless defined(&CONN_LPBK);
    eval 'sub CONN_ECHO () {0x40;}' unless defined(&CONN_ECHO);
    if(defined( &_SYSCALL32)) {
    }
    eval 'sub SLS_MDMSTAT () {0x1;}' unless defined(&SLS_MDMSTAT);
    eval 'sub SLS_LINKERR () {0x2;}' unless defined(&SLS_LINKERR);
    eval 'sub CS_DCD_DOWN () {0x8;}' unless defined(&CS_DCD_DOWN);
    eval 'sub CS_DCD_UP () {0xc;}' unless defined(&CS_DCD_UP);
    eval 'sub CS_DCD_DROP () {0x10;}' unless defined(&CS_DCD_DROP);
    eval 'sub CS_CTS_DOWN () {0x20;}' unless defined(&CS_CTS_DOWN);
    eval 'sub CS_CTS_UP () {0x30;}' unless defined(&CS_CTS_UP);
    eval 'sub CS_CTS_DROP () {0x40;}' unless defined(&CS_CTS_DROP);
    eval 'sub CS_CTS_TO () {0x80;}' unless defined(&CS_CTS_TO);
    eval 'sub CS_DCD () { &CS_DCD_DOWN;}' unless defined(&CS_DCD);
    eval 'sub CS_CTS () { &CS_CTS_DOWN;}' unless defined(&CS_CTS);
    eval 'sub ZSH_MAX_RSTANDBY () {6;}' unless defined(&ZSH_MAX_RSTANDBY);
    eval 'sub ZSH_RDONE_MAX () {20;}' unless defined(&ZSH_RDONE_MAX);
    eval 'sub TX_OFF () {0x;}' unless defined(&TX_OFF);
    eval 'sub TX_IDLE () {0x1;}' unless defined(&TX_IDLE);
    eval 'sub TX_RTS () {0x2;}' unless defined(&TX_RTS);
    eval 'sub TX_ACTIVE () {0x4;}' unless defined(&TX_ACTIVE);
    eval 'sub TX_CRC () {0x8;}' unless defined(&TX_CRC);
    eval 'sub TX_FLAG () {0x10;}' unless defined(&TX_FLAG);
    eval 'sub TX_LAST () {0x20;}' unless defined(&TX_LAST);
    eval 'sub TX_ABORTED () {0x40;}' unless defined(&TX_ABORTED);
    eval 'sub SF_FDXPTP () {0x1;}' unless defined(&SF_FDXPTP);
    eval 'sub SF_XMT_INPROG () {0x2;}' unless defined(&SF_XMT_INPROG);
    eval 'sub SF_LINKERR () {0x4;}' unless defined(&SF_LINKERR);
    eval 'sub SF_FLUSH_WQ () {0x8;}' unless defined(&SF_FLUSH_WQ);
    eval 'sub SF_INITIALIZED () {0x10;}' unless defined(&SF_INITIALIZED);
    eval 'sub SF_PHONY () {0x20;}' unless defined(&SF_PHONY);
    eval 'sub SF_ZSH_START () {0x40;}' unless defined(&SF_ZSH_START);
    eval 'sub STR_CLONE () {1;}' unless defined(&STR_CLONE);
    eval 'sub SIO_WATCHDOG_TICK () {(2*  &hz);}' unless defined(&SIO_WATCHDOG_TICK);
    eval 'sub SIO_WATCHDOG_ON () {( ($zss->{sl_wd_id}) > 0);}' unless defined(&SIO_WATCHDOG_ON);
    if(defined(&__cplusplus)) {
    }
}
1;
