require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SOCALREG_H)) {
    eval 'sub _SYS_SOCALREG_H () {1;}' unless defined(&_SYS_SOCALREG_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub N_SOCAL_NPORTS () {2;}' unless defined(&N_SOCAL_NPORTS);
    eval 'sub SOCAL_CR_SBUS_BURST_SIZE_MASK () {0x7;}' unless defined(&SOCAL_CR_SBUS_BURST_SIZE_MASK);
    eval 'sub SOCAL_CR_SBUS_BURST_SIZE_64BIT_MASK () {0x700;}' unless defined(&SOCAL_CR_SBUS_BURST_SIZE_64BIT_MASK);
    eval 'sub SOCAL_CR_SBUS_BURST_SIZE_64BIT {
        my($a) = @_;
	    eval q(((($a) &  &SOCAL_CR_SBUS_BURST_SIZE_64BIT_MASK) >> 8));
    }' unless defined(&SOCAL_CR_SBUS_BURST_SIZE_64BIT);
    eval 'sub SOCAL_CR_BURST_4 () {0x;}' unless defined(&SOCAL_CR_BURST_4);
    eval 'sub SOCAL_CR_BURST_8 () {0x3;}' unless defined(&SOCAL_CR_BURST_8);
    eval 'sub SOCAL_CR_BURST_16 () {0x4;}' unless defined(&SOCAL_CR_BURST_16);
    eval 'sub SOCAL_CR_BURST_32 () {0x5;}' unless defined(&SOCAL_CR_BURST_32);
    eval 'sub SOCAL_CR_BURST_64 () {0x6;}' unless defined(&SOCAL_CR_BURST_64);
    eval 'sub SOCAL_CR_BURST_128 () {0x7;}' unless defined(&SOCAL_CR_BURST_128);
    eval 'sub SOCAL_CR_SBUS_ENHANCED () {0x8;}' unless defined(&SOCAL_CR_SBUS_ENHANCED);
    eval 'sub SOCAL_CR_SBUS_PARITY_CHK () {0x10;}' unless defined(&SOCAL_CR_SBUS_PARITY_CHK);
    eval 'sub SOCAL_CR_SBUS_PARITY_TEST () {0x20;}' unless defined(&SOCAL_CR_SBUS_PARITY_TEST);
    eval 'sub SOCAL_CR_EEPROM_BANK_MASK () {0x30000;}' unless defined(&SOCAL_CR_EEPROM_BANK_MASK);
    eval 'sub SOCAL_CR_EEPROM_BANK {
        my($a) = @_;
	    eval q(((($a) &  &SOCAL_CR_EEPROM_BANK_MASK) >> 16));
    }' unless defined(&SOCAL_CR_EEPROM_BANK);
    eval 'sub SOCAL_CR_EXTERNAL_RAM_BANK_MASK () {0x7000000;}' unless defined(&SOCAL_CR_EXTERNAL_RAM_BANK_MASK);
    eval 'sub SOCAL_CR_EXTERNAL_RAM_BANK {
        my($a) = @_;
	    eval q(((($a) &  &SOCAL_CR_EXTERNAL_RAM_BANK_MASK) >> 24));
    }' unless defined(&SOCAL_CR_EXTERNAL_RAM_BANK);
    eval 'sub SOCAL_SAE_PARITY_ERROR () {0x1;}' unless defined(&SOCAL_SAE_PARITY_ERROR);
    eval 'sub SOCAL_SAE_UNSUPPORTED_TRANSFER () {0x2;}' unless defined(&SOCAL_SAE_UNSUPPORTED_TRANSFER);
    eval 'sub SOCAL_SAE_ALIGNMENT_ERROR () {0x4;}' unless defined(&SOCAL_SAE_ALIGNMENT_ERROR);
    eval 'sub SOCAL_CSR_ZEROS () {0x70;}' unless defined(&SOCAL_CSR_ZEROS);
    eval 'sub SOCAL_CSR_SOCAL_TO_HOST () {0xf0000;}' unless defined(&SOCAL_CSR_SOCAL_TO_HOST);
    eval 'sub SOCAL_CSR_HOST_TO_SOCAL () {0xf00;}' unless defined(&SOCAL_CSR_HOST_TO_SOCAL);
    eval 'sub SOCAL_CSR_SLV_ACC_ERR () {0x80;}' unless defined(&SOCAL_CSR_SLV_ACC_ERR);
    eval 'sub SOCAL_CSR_INT_PENDING () {0x8;}' unless defined(&SOCAL_CSR_INT_PENDING);
    eval 'sub SOCAL_CSR_NON_Q_CMD () {0x4;}' unless defined(&SOCAL_CSR_NON_Q_CMD);
    eval 'sub SOCAL_CSR_IDLE () {0x2;}' unless defined(&SOCAL_CSR_IDLE);
    eval 'sub SOCAL_CSR_SOFT_RESET () {0x1;}' unless defined(&SOCAL_CSR_SOFT_RESET);
    eval 'sub SOCAL_CSR_1ST_S_TO_H () {0x10000;}' unless defined(&SOCAL_CSR_1ST_S_TO_H);
    eval 'sub SOCAL_CSR_1ST_H_TO_S () {0x100;}' unless defined(&SOCAL_CSR_1ST_H_TO_S);
    eval 'sub SOCAL_CSR_RSP_QUE_0 () { &SOCAL_CSR_1ST_S_TO_H;}' unless defined(&SOCAL_CSR_RSP_QUE_0);
    eval 'sub SOCAL_CSR_RSP_QUE_1 () {0x20000;}' unless defined(&SOCAL_CSR_RSP_QUE_1);
    eval 'sub SOCAL_CSR_RSP_QUE_2 () {0x40000;}' unless defined(&SOCAL_CSR_RSP_QUE_2);
    eval 'sub SOCAL_CSR_RSP_QUE_3 () {0x80000;}' unless defined(&SOCAL_CSR_RSP_QUE_3);
    eval 'sub SOCAL_CSR_REQ_QUE_0 () { &SOCAL_CSR_1ST_H_TO_S;}' unless defined(&SOCAL_CSR_REQ_QUE_0);
    eval 'sub SOCAL_CSR_REQ_QUE_1 () {0x200;}' unless defined(&SOCAL_CSR_REQ_QUE_1);
    eval 'sub SOCAL_CSR_REQ_QUE_2 () {0x400;}' unless defined(&SOCAL_CSR_REQ_QUE_2);
    eval 'sub SOCAL_CSR_REQ_QUE_3 () {0x800;}' unless defined(&SOCAL_CSR_REQ_QUE_3);
    eval 'sub SOCAL_IMR_NON_QUEUED_STATE () {0x4;}' unless defined(&SOCAL_IMR_NON_QUEUED_STATE);
    eval 'sub SOCAL_IMR_SLAVE_ACCESS_ERROR () {0x80;}' unless defined(&SOCAL_IMR_SLAVE_ACCESS_ERROR);
    eval 'sub SOCAL_IMR_REQUEST_QUEUE_0 () {0x100;}' unless defined(&SOCAL_IMR_REQUEST_QUEUE_0);
    eval 'sub SOCAL_IMR_REQUEST_QUEUE_1 () {0x200;}' unless defined(&SOCAL_IMR_REQUEST_QUEUE_1);
    eval 'sub SOCAL_IMR_REQUEST_QUEUE_2 () {0x400;}' unless defined(&SOCAL_IMR_REQUEST_QUEUE_2);
    eval 'sub SOCAL_IMR_REQUEST_QUEUE_3 () {0x800;}' unless defined(&SOCAL_IMR_REQUEST_QUEUE_3);
    eval 'sub SOCAL_IMR_RESPONSE_QUEUE_0 () {0x10000;}' unless defined(&SOCAL_IMR_RESPONSE_QUEUE_0);
    eval 'sub SOCAL_IMR_RESPONSE_QUEUE_1 () {0x20000;}' unless defined(&SOCAL_IMR_RESPONSE_QUEUE_1);
    eval 'sub SOCAL_IMR_RESPONSE_QUEUE_2 () {0x40000;}' unless defined(&SOCAL_IMR_RESPONSE_QUEUE_2);
    eval 'sub SOCAL_IMR_RESPONSE_QUEUE_3 () {0x80000;}' unless defined(&SOCAL_IMR_RESPONSE_QUEUE_3);
    eval 'sub SOCAL_REQUESTQ0_MASK () {0xff000000;}' unless defined(&SOCAL_REQUESTQ0_MASK);
    eval 'sub SOCAL_REQUESTQ1_MASK () {0xff0000;}' unless defined(&SOCAL_REQUESTQ1_MASK);
    eval 'sub SOCAL_REQUESTQ2_MASK () {0xff00;}' unless defined(&SOCAL_REQUESTQ2_MASK);
    eval 'sub SOCAL_REQUESTQ3_MASK () {0xff;}' unless defined(&SOCAL_REQUESTQ3_MASK);
    eval 'sub SOCAL_REQUESTQ0_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &SOCAL_REQUESTQ0_MASK) >> 24));
    }' unless defined(&SOCAL_REQUESTQ0_INDEX);
    eval 'sub SOCAL_REQUESTQ1_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &SOCAL_REQUESTQ1_MASK) >> 16));
    }' unless defined(&SOCAL_REQUESTQ1_INDEX);
    eval 'sub SOCAL_REQUESTQ2_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &SOCAL_REQUESTQ2_MASK) >> 8));
    }' unless defined(&SOCAL_REQUESTQ2_INDEX);
    eval 'sub SOCAL_REQUESTQ3_INDEX {
        my($a) = @_;
	    eval q((($a) &  &SOCAL_REQUESTQ3_MASK));
    }' unless defined(&SOCAL_REQUESTQ3_INDEX);
    eval 'sub SOCAL_REQUESTQ_INDEX {
        my($a, $b) = @_;
	    eval q((($b)>>((3-($a))<<3) & 0xff));
    }' unless defined(&SOCAL_REQUESTQ_INDEX);
    eval 'sub SOCAL_RESPONSEQ0_MASK () {0xff000000;}' unless defined(&SOCAL_RESPONSEQ0_MASK);
    eval 'sub SOCAL_RESPONSEQ1_MASK () {0xff0000;}' unless defined(&SOCAL_RESPONSEQ1_MASK);
    eval 'sub SOCAL_RESPONSEQ2_MASK () {0xff00;}' unless defined(&SOCAL_RESPONSEQ2_MASK);
    eval 'sub SOCAL_RESPONSEQ3_MASK () {0xff;}' unless defined(&SOCAL_RESPONSEQ3_MASK);
    eval 'sub SOCAL_RESPONSEQ0_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &SOCAL_RESPONSEQ0_MASK) >> 24));
    }' unless defined(&SOCAL_RESPONSEQ0_INDEX);
    eval 'sub SOCAL_RESPONSEQ1_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &SOCAL_RESPONSEQ1_MASK) >> 16));
    }' unless defined(&SOCAL_RESPONSEQ1_INDEX);
    eval 'sub SOCAL_RESPONSEQ2_INDEX {
        my($a) = @_;
	    eval q(((($a) &  &SOCAL_RESPONSEQ2_MASK) >> 8));
    }' unless defined(&SOCAL_RESPONSEQ2_INDEX);
    eval 'sub SOCAL_RESPONSEQ3_INDEX {
        my($a) = @_;
	    eval q((($a) &  &SOCAL_RESPONSEQ3_MASK));
    }' unless defined(&SOCAL_RESPONSEQ3_INDEX);
    eval 'sub SOCAL_RESPONSEQ_INDEX {
        my($a, $b) = @_;
	    eval q((($b)>>((3-($a))<<3) & 0xff));
    }' unless defined(&SOCAL_RESPONSEQ_INDEX);
    eval 'sub SOCAL_XRAM_OFFSET () {0x10000;}' unless defined(&SOCAL_XRAM_OFFSET);
    eval 'sub SOCAL_XRAM_SIZE () {0x10000;}' unless defined(&SOCAL_XRAM_SIZE);
    eval 'sub SOCAL_MAX_XCHG () {1024;}' unless defined(&SOCAL_MAX_XCHG);
    eval 'sub SOCAL_REG_OFFSET () {( &SOCAL_XRAM_OFFSET +  &SOCAL_XRAM_SIZE);}' unless defined(&SOCAL_REG_OFFSET);
    eval 'sub SOCAL_CQ_REQUEST_OFFSET () {( &SOCAL_XRAM_OFFSET + 0x200);}' unless defined(&SOCAL_CQ_REQUEST_OFFSET);
    eval 'sub SOCAL_CQ_RESPONSE_OFFSET () {( &SOCAL_XRAM_OFFSET + 0x220);}' unless defined(&SOCAL_CQ_RESPONSE_OFFSET);
    eval 'sub SOCAL_INTR_CAUSE {
        my($socalp, $csr) = @_;
	    eval q(((($csr) &  &SOCAL_CSR_SOCAL_TO_HOST) | ((~$csr) & ( &SOCAL_CSR_HOST_TO_SOCAL))) &  ($socalp->{socal_k_imr}));
    }' unless defined(&SOCAL_INTR_CAUSE);
    unless(defined(&BURSTSIZE)) {
	eval 'sub BURSTSIZE () {1;}' unless defined(&BURSTSIZE);
	eval 'sub BURST1 () {0x1;}' unless defined(&BURST1);
	eval 'sub BURST2 () {0x2;}' unless defined(&BURST2);
	eval 'sub BURST4 () {0x4;}' unless defined(&BURST4);
	eval 'sub BURST8 () {0x8;}' unless defined(&BURST8);
	eval 'sub BURST16 () {0x10;}' unless defined(&BURST16);
	eval 'sub BURST32 () {0x20;}' unless defined(&BURST32);
	eval 'sub BURST64 () {0x40;}' unless defined(&BURST64);
	eval 'sub BURST128 () {0x80;}' unless defined(&BURST128);
	eval 'sub BURSTSIZE_MASK () {0xff;}' unless defined(&BURSTSIZE_MASK);
	eval 'sub DEFAULT_BURSTSIZE () { &BURST16| &BURST8| &BURST4| &BURST2| &BURST1;}' unless defined(&DEFAULT_BURSTSIZE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
