require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SOCALVAR_H)) {
    eval 'sub _SYS_SOCALVAR_H () {1;}' unless defined(&_SYS_SOCALVAR_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/id32.ph';
    eval 'sub SOCAL_PORTA_NAME () {"0";}' unless defined(&SOCAL_PORTA_NAME);
    eval 'sub SOCAL_PORTB_NAME () {"1";}' unless defined(&SOCAL_PORTB_NAME);
    eval 'sub SOCAL_NT_PORT () { &NULL;}' unless defined(&SOCAL_NT_PORT);
    eval 'sub SOCAL_INIT_ITEMS () {5;}' unless defined(&SOCAL_INIT_ITEMS);
    eval 'sub SOCAL_MAX_CQ_ENTRIES () {256;}' unless defined(&SOCAL_MAX_CQ_ENTRIES);
    eval 'sub SOCAL_CQ_SIZE () {($sizeof{ &cqe_t} *  &SOC_MAX_CQ_ENTRIES);}' unless defined(&SOCAL_CQ_SIZE);
    eval 'sub SOCAL_SMALL_CQ_ENTRIES () {8;}' unless defined(&SOCAL_SMALL_CQ_ENTRIES);
    eval 'sub SOCAL_N_CQS () {4;}' unless defined(&SOCAL_N_CQS);
    eval 'sub SOCAL_HW_N_CQS () {4;}' unless defined(&SOCAL_HW_N_CQS);
    eval 'sub SOCAL_CQ_ALIGN () {64;}' unless defined(&SOCAL_CQ_ALIGN);
    eval 'sub SOCAL_TAKE_CORE () {0x1;}' unless defined(&SOCAL_TAKE_CORE);
    eval 'sub SOCAL_FAILED_LIP () {0x2;}' unless defined(&SOCAL_FAILED_LIP);
    eval 'sub SOCAL_POOL_SIZE () {2112;}' unless defined(&SOCAL_POOL_SIZE);
    eval 'sub SOCAL_SVC_LENGTH () {80;}' unless defined(&SOCAL_SVC_LENGTH);
    eval 'sub FABRIC_FLAG () {1;}' unless defined(&FABRIC_FLAG);
    eval 'sub NPORT_FLAG () {2;}' unless defined(&NPORT_FLAG);
    eval 'sub FCIO_DIAG_LBTFQ () {( &FIOC|203);}' unless defined(&FCIO_DIAG_LBTFQ);
    eval 'sub SOC_DIAG_LBTFQ () {0xa;}' unless defined(&SOC_DIAG_LBTFQ);
    eval 'sub PORT_LBF_PENDING () {0x100000;}' unless defined(&PORT_LBF_PENDING);
    eval 'sub SOCAL_LBF_TIMEOUT () {15000000;}' unless defined(&SOCAL_LBF_TIMEOUT);
    if(defined(&_LP64)) {
	eval 'sub SOCAL_ID_GET {
	    my($x, $w) = @_;
    	    eval q( &id32_alloc(($x), ($w)));
	}' unless defined(&SOCAL_ID_GET);
	eval 'sub SOCAL_ID_LOOKUP {
	    my($x) = @_;
    	    eval q( &id32_lookup(($x)));
	}' unless defined(&SOCAL_ID_LOOKUP);
	eval 'sub SOCAL_ID_FREE {
	    my($x) = @_;
    	    eval q( &id32_free(($x)));
	}' unless defined(&SOCAL_ID_FREE);
    } else {
	eval 'sub SOCAL_ID_GET {
	    my($x, $w) = @_;
    	    eval q((( &uint32_t)($x)));
	}' unless defined(&SOCAL_ID_GET);
	eval 'sub SOCAL_ID_LOOKUP {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&SOCAL_ID_LOOKUP);
	eval 'sub SOCAL_ID_FREE {
	    my($x) = @_;
    	    eval q(($x) = 0);
	}' unless defined(&SOCAL_ID_FREE);
    }
    eval 'sub SOCAL_SKC_FULL () {1;}' unless defined(&SOCAL_SKC_FULL);
    eval 'sub SOCAL_SKC_SLEEP () {2;}' unless defined(&SOCAL_SKC_SLEEP);
    eval 'sub PORT_FABRIC_PRESENT () {0x1;}' unless defined(&PORT_FABRIC_PRESENT);
    eval 'sub PORT_OFFLINE () {0x2;}' unless defined(&PORT_OFFLINE);
    eval 'sub NPORT_LOGIN_SUCCESS () {0x4;}' unless defined(&NPORT_LOGIN_SUCCESS);
    eval 'sub PORT_LOGIN_ACTIVE () {0x8;}' unless defined(&PORT_LOGIN_ACTIVE);
    eval 'sub PORT_LOGIN_RECOVERY () {0x10;}' unless defined(&PORT_LOGIN_RECOVERY);
    eval 'sub PORT_ONLINE_LOOP () {0x20;}' unless defined(&PORT_ONLINE_LOOP);
    eval 'sub PORT_ONLINE () {0x40;}' unless defined(&PORT_ONLINE);
    eval 'sub PORT_STATUS_FLAG () {0x80;}' unless defined(&PORT_STATUS_FLAG);
    eval 'sub PORT_STATUS_MASK () {0xff;}' unless defined(&PORT_STATUS_MASK);
    eval 'sub PORT_OPEN () {0x100;}' unless defined(&PORT_OPEN);
    eval 'sub PORT_CHILD_INIT () {0x200;}' unless defined(&PORT_CHILD_INIT);
    eval 'sub PORT_TARGET_MODE () {0x400;}' unless defined(&PORT_TARGET_MODE);
    eval 'sub PORT_LILP_PENDING () {0x1000;}' unless defined(&PORT_LILP_PENDING);
    eval 'sub PORT_LIP_PENDING () {0x2000;}' unless defined(&PORT_LIP_PENDING);
    eval 'sub PORT_ABORT_PENDING () {0x4000;}' unless defined(&PORT_ABORT_PENDING);
    eval 'sub PORT_ELS_PENDING () {0x8000;}' unless defined(&PORT_ELS_PENDING);
    eval 'sub PORT_BYPASS_PENDING () {0x10000;}' unless defined(&PORT_BYPASS_PENDING);
    eval 'sub PORT_OFFLINE_PENDING () {0x20000;}' unless defined(&PORT_OFFLINE_PENDING);
    eval 'sub PORT_ADISC_PENDING () {0x40000;}' unless defined(&PORT_ADISC_PENDING);
    eval 'sub PORT_RLS_PENDING () {0x80000;}' unless defined(&PORT_RLS_PENDING);
    eval 'sub PORT_DISABLED () {0x100000;}' unless defined(&PORT_DISABLED);
    eval 'sub SOC_TIMEOUT_DELAY {
        my($secs, $delay) = @_;
	    eval q(($secs * (1000000/ $delay)));
    }' unless defined(&SOC_TIMEOUT_DELAY);
    eval 'sub SOCAL_NOINTR_POLL_DELAY_TIME () {1000;}' unless defined(&SOCAL_NOINTR_POLL_DELAY_TIME);
    eval 'sub SOCAL_LILP_TIMEOUT () {10000000;}' unless defined(&SOCAL_LILP_TIMEOUT);
    eval 'sub SOCAL_LIP_TIMEOUT () {30000000;}' unless defined(&SOCAL_LIP_TIMEOUT);
    eval 'sub SOCAL_ABORT_TIMEOUT () {10000000;}' unless defined(&SOCAL_ABORT_TIMEOUT);
    eval 'sub SOCAL_BYPASS_TIMEOUT () {5000000;}' unless defined(&SOCAL_BYPASS_TIMEOUT);
    eval 'sub SOCAL_OFFLINE_TIMEOUT () {5000000;}' unless defined(&SOCAL_OFFLINE_TIMEOUT);
    eval 'sub SOCAL_ADISC_TIMEOUT () {15000000;}' unless defined(&SOCAL_ADISC_TIMEOUT);
    eval 'sub SOCAL_RLS_TIMEOUT () {15000000;}' unless defined(&SOCAL_RLS_TIMEOUT);
    eval 'sub SOCAL_DIAG_TIMEOUT () {15000000;}' unless defined(&SOCAL_DIAG_TIMEOUT);
    eval 'sub SOC_INITIAL_ONLINE () {30;}' unless defined(&SOC_INITIAL_ONLINE);
    if(defined(&__cplusplus)) {
    }
}
1;
