require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SOCREG_H)) {
    eval 'sub _SYS_SOCREG_H () {1;}' unless defined(&_SYS_SOCREG_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub N_SOC_NPORTS () {2;}' unless defined(&N_SOC_NPORTS);
    eval 'sub SOC_CR_SBUS_BURST_SIZE_MASK () {0x7;}' unless defined(&SOC_CR_SBUS_BURST_SIZE_MASK);
    eval 'sub SOC_CR_SBUS_BURST_SIZE_64BIT_MASK () {0x700;}' unless defined(&SOC_CR_SBUS_BURST_SIZE_64BIT_MASK);
    eval 'sub SOC_CR_SBUS_BURST_SIZE_64BIT {
        my($a) = @_;
	    eval q(((($a) &  &SOC_CR_SBUS_BURST_SIZE_64BIT_MASK) >> 8));
    }' unless defined(&SOC_CR_SBUS_BURST_SIZE_64BIT);
    eval 'sub SOC_CR_BURST_4 () {0x;}' unless defined(&SOC_CR_BURST_4);
    eval 'sub SOC_CR_BURST_16 () {0x4;}' unless defined(&SOC_CR_BURST_16);
    eval 'sub SOC_CR_BURST_32 () {0x5;}' unless defined(&SOC_CR_BURST_32);
    eval 'sub SOC_CR_BURST_64 () {0x6;}' unless defined(&SOC_CR_BURST_64);
    eval 'sub SOC_CR_SBUS_ENHANCED () {0x8;}' unless defined(&SOC_CR_SBUS_ENHANCED);
    eval 'sub SOC_CR_SBUS_PARITY_CHK () {0x10;}' unless defined(&SOC_CR_SBUS_PARITY_CHK);
    eval 'sub SOC_CR_SBUS_PARITY_TEST () {0x20;}' unless defined(&SOC_CR_SBUS_PARITY_TEST);
    eval 'sub SOC_CR_EEPROM_BANK_MASK () {0x30000;}' unless defined(&SOC_CR_EEPROM_BANK_MASK);
    eval 'sub SOC_CR_EEPROM_BANK {
        my($a) = @_;
	    eval q(((($a) &  &SOC_CR_EEPROM_BANK_MASK) >> 16));
    }' unless defined(&SOC_CR_EEPROM_BANK);
    eval 'sub SOC_CR_EXTERNAL_RAM_BANK_MASK () {0x7000000;}' unless defined(&SOC_CR_EXTERNAL_RAM_BANK_MASK);
    eval 'sub SOC_CR_EXTERNAL_RAM_BANK {
        my($a) = @_;
	    eval q(((($a) &  &SOC_CR_EXTERNAL_RAM_BANK_MASK) >> 24));
    }' unless defined(&SOC_CR_EXTERNAL_RAM_BANK);
    eval 'sub SOC_SAE_PARITY_ERROR () {0x1;}' unless defined(&SOC_SAE_PARITY_ERROR);
    eval 'sub SOC_SAE_UNSUPPORTED_TRANSFER () {0x2;}' unless defined(&SOC_SAE_UNSUPPORTED_TRANSFER);
    eval 'sub SOC_SAE_ALIGNMENT_ERROR () {0x4;}' unless defined(&SOC_SAE_ALIGNMENT_ERROR);
    eval 'sub SOC_CSR_ZEROS () {0x70;}' unless defined(&SOC_CSR_ZEROS);
    eval 'sub SOC_CSR_SOC_TO_HOST () {0xf0000;}' unless defined(&SOC_CSR_SOC_TO_HOST);
    eval 'sub SOC_CSR_HOST_TO_SOC () {0xf00;}' unless defined(&SOC_CSR_HOST_TO_SOC);
    eval 'sub SOC_CSR_SLV_ACC_ERR () {0x80;}' unless defined(&SOC_CSR_SLV_ACC_ERR);
    eval 'sub SOC_CSR_INT_PENDING () {0x8;}' unless defined(&SOC_CSR_INT_PENDING);
    eval 'sub SOC_CSR_NON_Q_CMD () {0x4;}' unless defined(&SOC_CSR_NON_Q_CMD);
    eval 'sub SOC_CSR_IDLE () {0x2;}' unless defined(&SOC_CSR_IDLE);
    eval 'sub SOC_CSR_SOFT_RESET () {0x1;}' unless defined(&SOC_CSR_SOFT_RESET);
    eval 'sub SOC_CSR_1ST_S_TO_H () {0x10000;}' unless defined(&SOC_CSR_1ST_S_TO_H);
    eval 'sub SOC_CSR_1ST_H_TO_S () {0x100;}' unless defined(&SOC_CSR_1ST_H_TO_S);
    eval 'sub SOC_CSR_RSP_QUE_0 () { &SOC_CSR_1ST_S_TO_H;}' unless defined(&SOC_CSR_RSP_QUE_0);
    eval 'sub SOC_CSR_RSP_QUE_1 () {0x20000;}' unless defined(&SOC_CSR_RSP_QUE_1);
    eval 'sub SOC_CSR_REQ_QUE_0 () { &SOC_CSR_1ST_H_TO_S;}' unless defined(&SOC_CSR_REQ_QUE_0);
    eval 'sub SOC_CSR_REQ_QUE_1 () {0x200;}' unless defined(&SOC_CSR_REQ_QUE_1);
    eval 'sub SOC_CSR_REQ_QUE_2 () {0x400;}' unless defined(&SOC_CSR_REQ_QUE_2);
    eval 'sub SOC_CSR_REQ_QUE_3 () {0x800;}' unless defined(&SOC_CSR_REQ_QUE_3);
    eval 'sub SOC_IMR_NON_QUEUED_STATE () {0x4;}' unless defined(&SOC_IMR_NON_QUEUED_STATE);
    eval 'sub SOC_IMR_SLAVE_ACCESS_ERROR () {0x80;}' unless defined(&SOC_IMR_SLAVE_ACCESS_ERROR);
    eval 'sub SOC_IMR_REQUEST_QUEUE_0 () {0x100;}' unless defined(&SOC_IMR_REQUEST_QUEUE_0);
    eval 'sub SOC_IMR_REQUEST_QUEUE_1 () {0x200;}' unless defined(&SOC_IMR_REQUEST_QUEUE_1);
    eval 'sub SOC_IMR_REQUEST_QUEUE_2 () {0x400;}' unless defined(&SOC_IMR_REQUEST_QUEUE_2);
    eval 'sub SOC_IMR_REQUEST_QUEUE_3 () {0x800;}' unless defined(&SOC_IMR_REQUEST_QUEUE_3);
    eval 'sub SOC_IMR_RESPONSE_QUEUE_0 () {0x10000;}' unless defined(&SOC_IMR_RESPONSE_QUEUE_0);
    eval 'sub SOC_IMR_RESPONSE_QUEUE_1 () {0x20000;}' unless defined(&SOC_IMR_RESPONSE_QUEUE_1);
    eval 'sub SOC_IMR_RESPONSE_QUEUE_2 () {0x40000;}' unless defined(&SOC_IMR_RESPONSE_QUEUE_2);
    eval 'sub SOC_IMR_RESPONSE_QUEUE_3 () {0x80000;}' unless defined(&SOC_IMR_RESPONSE_QUEUE_3);
    eval 'sub SOC_XRAM_OFFSET () {0x10000;}' unless defined(&SOC_XRAM_OFFSET);
    eval 'sub SOC_XRAM_SIZE () {0x10000;}' unless defined(&SOC_XRAM_SIZE);
    eval 'sub SOC_REG_OFFSET () {( &SOC_XRAM_OFFSET +  &SOC_XRAM_SIZE);}' unless defined(&SOC_REG_OFFSET);
    eval 'sub SOC_CQ_REQUEST_OFFSET () {( &SOC_XRAM_OFFSET + 0x200);}' unless defined(&SOC_CQ_REQUEST_OFFSET);
    eval 'sub SOC_CQ_RESPONSE_OFFSET () {( &SOC_XRAM_OFFSET + 0x220);}' unless defined(&SOC_CQ_RESPONSE_OFFSET);
    eval 'sub SOC_INTR_CAUSE {
        my($socp, $csr) = @_;
	    eval q(((($csr) &  &SOC_CSR_SOC_TO_HOST) | ((~$csr) & ( &SOC_CSR_HOST_TO_SOC))) &  ($socp->{k_soc_imr}));
    }' unless defined(&SOC_INTR_CAUSE);
    if(defined(&__cplusplus)) {
    }
}
1;
