require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_STCIO_H)) {
    eval 'sub _SYS_STCIO_H () {1;}' unless defined(&_SYS_STCIO_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub STC_DEADMAN () {1;}' unless defined(&STC_DEADMAN);
    eval 'sub sIOC () {(ord(\'s\')<<8);}' unless defined(&sIOC);
    eval 'sub STC_SREGS () {( &sIOC|251);}' unless defined(&STC_SREGS);
    eval 'sub STC_GREGS () {( &sIOC|252);}' unless defined(&STC_GREGS);
    eval 'sub STC_SPPC () {( &sIOC|253);}' unless defined(&STC_SPPC);
    eval 'sub STC_GPPC () {( &sIOC|254);}' unless defined(&STC_GPPC);
    eval 'sub STC_GSTATS () {( &sIOC|255);}' unless defined(&STC_GSTATS);
    eval 'sub STC_SILOSIZE () {1024;}' unless defined(&STC_SILOSIZE);
    eval 'sub FUNKY {
        my($v, $min, $max) = @_;
	    eval q((($v < $min) || ($v > $max)));
    }' unless defined(&FUNKY);
    eval 'sub DTR_ASSERT () {0x1;}' unless defined(&DTR_ASSERT);
    eval 'sub SOFT_CARR () {0x2;}' unless defined(&SOFT_CARR);
    eval 'sub STC_DTRCLOSE () {0x4;}' unless defined(&STC_DTRCLOSE);
    eval 'sub STC_CFLOWFLUSH () {0x8;}' unless defined(&STC_CFLOWFLUSH);
    eval 'sub STC_CFLOWMSG () {0x10;}' unless defined(&STC_CFLOWMSG);
    eval 'sub STC_INSTANTFLOW () {0x20;}' unless defined(&STC_INSTANTFLOW);
    eval 'sub STC_DTRFORCE () {0x40;}' unless defined(&STC_DTRFORCE);
    eval 'sub MIN_DRAIN_SIZE () {4;}' unless defined(&MIN_DRAIN_SIZE);
    eval 'sub MAX_DRAIN_SIZE () {1024;}' unless defined(&MAX_DRAIN_SIZE);
    eval 'sub MIN_HIWATER () {2;}' unless defined(&MIN_HIWATER);
    eval 'sub MAX_HIWATER () {( &STC_SILOSIZE-2);}' unless defined(&MAX_HIWATER);
    eval 'sub MIN_LOWWATER () {2;}' unless defined(&MIN_LOWWATER);
    eval 'sub MAX_LOWWATER () {(( ($stc_defaults->{stc_hiwater}))-2);}' unless defined(&MAX_LOWWATER);
    eval 'sub MIN_RTPR () {1;}' unless defined(&MIN_RTPR);
    eval 'sub MAX_RTPR () {255;}' unless defined(&MAX_RTPR);
    eval 'sub MIN_RX_FIFO () {1;}' unless defined(&MIN_RX_FIFO);
    eval 'sub MAX_RX_FIFO () {8;}' unless defined(&MAX_RX_FIFO);
    eval 'sub PP_SHIFT () {8;}' unless defined(&PP_SHIFT);
    eval 'sub PP_PAPER_OUT () {0x1;}' unless defined(&PP_PAPER_OUT);
    eval 'sub PP_ERROR () {0x2;}' unless defined(&PP_ERROR);
    eval 'sub PP_BUSY () {0x4;}' unless defined(&PP_BUSY);
    eval 'sub PP_SELECT () {0x8;}' unless defined(&PP_SELECT);
    eval 'sub PP_MSG () {0x20000;}' unless defined(&PP_MSG);
    eval 'sub PP_SIGNAL () {0x10000;}' unless defined(&PP_SIGNAL);
    eval 'sub PP_SIGTYPE () { &SIGURG;}' unless defined(&PP_SIGTYPE);
    eval 'sub MIN_STBWIDTH () {1;}' unless defined(&MIN_STBWIDTH);
    eval 'sub MAX_STBWIDTH () {30;}' unless defined(&MAX_STBWIDTH);
    eval 'sub MIN_DATASETUP () {0;}' unless defined(&MIN_DATASETUP);
    eval 'sub MAX_DATASETUP () {30;}' unless defined(&MAX_DATASETUP);
    eval 'sub MIN_ACKTIMEOUT () {5;}' unless defined(&MIN_ACKTIMEOUT);
    eval 'sub MAX_ACKTIMEOUT () {7200;}' unless defined(&MAX_ACKTIMEOUT);
    eval 'sub MIN_ERRTIMEOUT () {1;}' unless defined(&MIN_ERRTIMEOUT);
    eval 'sub MAX_ERRTIMEOUT () {480;}' unless defined(&MAX_ERRTIMEOUT);
    eval 'sub NO_BUSYTIMEOUT () {0;}' unless defined(&NO_BUSYTIMEOUT);
    eval 'sub MIN_BUSYTIMEOUT () {0;}' unless defined(&MIN_BUSYTIMEOUT);
    eval 'sub MAX_BUSYTIMEOUT () {7200;}' unless defined(&MAX_BUSYTIMEOUT);
    eval 'sub STC_SERIAL () {0x1;}' unless defined(&STC_SERIAL);
    eval 'sub STC_PARALLEL () {0x2;}' unless defined(&STC_PARALLEL);
    eval 'sub STC_CNTRL () {0x4;}' unless defined(&STC_CNTRL);
    eval 'sub STC_IOREG () {0x1;}' unless defined(&STC_IOREG);
    eval 'sub STC_PPCREG () {0x;}' unless defined(&STC_PPCREG);
    eval 'sub STC_CDEFSET () {0x1;}' unless defined(&STC_CDEFSET);
    eval 'sub STC_CDEFGET () {0x2;}' unless defined(&STC_CDEFGET);
    eval 'sub STC_SPARAM_SET () {0x4;}' unless defined(&STC_SPARAM_SET);
    eval 'sub STC_SPARAM_GET () {0x8;}' unless defined(&STC_SPARAM_GET);
    eval 'sub STC_REGIOR () {0x100;}' unless defined(&STC_REGIOR);
    eval 'sub STC_REGIOW () {0x200;}' unless defined(&STC_REGIOW);
    eval 'sub STC_PPCREGR () {0x400;}' unless defined(&STC_PPCREGR);
    eval 'sub STC_PPCREGW () {0x800;}' unless defined(&STC_PPCREGW);
    eval 'sub STC_CFLUSH () {0x8000;}' unless defined(&STC_CFLUSH);
    eval 'sub STC_SETCAR () {0x10000000;}' unless defined(&STC_SETCAR);
    eval 'sub STC_LP_SETLINE {
        my($line) = @_;
	    eval q(((($line) & 0x3f) | 64));
    }' unless defined(&STC_LP_SETLINE);
    eval 'sub STC_NOTOPEN_ERR () { &ESRCH;}' unless defined(&STC_NOTOPEN_ERR);
    eval 'sub STAT_SET () {0x2;}' unless defined(&STAT_SET);
    eval 'sub STAT_CLEAR () {0x1;}' unless defined(&STAT_CLEAR);
    eval 'sub STAT_GET () {0x;}' unless defined(&STAT_GET);
    if(defined(&__cplusplus)) {
    }
}
1;
