require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SUNDDI_H)) {
    eval 'sub _SYS_SUNDDI_H () {1;}' unless defined(&_SYS_SUNDDI_H);
    require 'sys/isa_defs.ph';
    require 'sys/dditypes.ph';
    require 'sys/ddipropdefs.ph';
    require 'sys/devops.ph';
    require 'sys/time.ph';
    require 'sys/cmn_err.ph';
    require 'sys/ddidevmap.ph';
    require 'sys/ddi_implfuncs.ph';
    require 'sys/ddi_isa.ph';
    require 'sys/model.ph';
    require 'sys/devctl.ph';
    if(defined( &i386) || defined( &__i386)) {
	require 'sys/dma_engine.ph';
    }
    require 'sys/sunpm.ph';
    require 'sys/nvpair.ph';
    require 'sys/sysevent.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub DDI_SUCCESS () {(0);}' unless defined(&DDI_SUCCESS);
    eval 'sub DDI_FAILURE () {(-1);}' unless defined(&DDI_FAILURE);
    eval 'sub DDI_NOT_WELL_FORMED () {(-2);}' unless defined(&DDI_NOT_WELL_FORMED);
    eval 'sub DDI_ENOMEM () {1;}' unless defined(&DDI_ENOMEM);
    eval 'sub DDI_EBUSY () {2;}' unless defined(&DDI_EBUSY);
    eval 'sub DDI_ETRANSPORT () {3;}' unless defined(&DDI_ETRANSPORT);
    eval 'sub DDI_ECONTEXT () {4;}' unless defined(&DDI_ECONTEXT);
    eval 'sub DDI_SLEEP () {0;}' unless defined(&DDI_SLEEP);
    eval 'sub DDI_NOSLEEP () {1;}' unless defined(&DDI_NOSLEEP);
    eval 'sub DEVI_PSEUDO_NODEID () {(-1);}' unless defined(&DEVI_PSEUDO_NODEID);
    eval 'sub DEVI_SID_NODEID () {(-2);}' unless defined(&DEVI_SID_NODEID);
    eval 'sub DEVI_PSEUDO_NEXNAME () {"pseudo";}' unless defined(&DEVI_PSEUDO_NEXNAME);
    eval 'sub DEVI_ISA_NEXNAME () {"isa";}' unless defined(&DEVI_ISA_NEXNAME);
    eval 'sub DEVI_EISA_NEXNAME () {"eisa";}' unless defined(&DEVI_EISA_NEXNAME);
    eval 'sub CLONE_DEV () {1;}' unless defined(&CLONE_DEV);
    eval 'sub GLOBAL_DEV () {0x2;}' unless defined(&GLOBAL_DEV);
    eval 'sub NODEBOUND_DEV () {0x4;}' unless defined(&NODEBOUND_DEV);
    eval 'sub NODESPECIFIC_DEV () {0x6;}' unless defined(&NODESPECIFIC_DEV);
    eval 'sub ENUMERATED_DEV () {0x8;}' unless defined(&ENUMERATED_DEV);
    eval 'sub DEVCLASS_MASK () {0xe;}' unless defined(&DEVCLASS_MASK);
    eval 'sub CLASS_DEV {
        my($flag) = @_;
	    eval q((($flag) &  &DEVCLASS_MASK));
    }' unless defined(&CLASS_DEV);
    eval 'sub DDI_NT_SERIAL () {"ddi_serial";}' unless defined(&DDI_NT_SERIAL);
    eval 'sub DDI_NT_SERIAL_MB () {"ddi_serial:mb";}' unless defined(&DDI_NT_SERIAL_MB);
    eval 'sub DDI_NT_SERIAL_DO () {"ddi_serial:dialout";}' unless defined(&DDI_NT_SERIAL_DO);
    eval 'sub DDI_NT_SERIAL_MB_DO () {"ddi_serial:dialout,mb";}' unless defined(&DDI_NT_SERIAL_MB_DO);
    eval 'sub DDI_NT_SERIAL_LOMCON () {"ddi_serial:lomcon";}' unless defined(&DDI_NT_SERIAL_LOMCON);
    eval 'sub DDI_NT_BLOCK () {"ddi_block";}' unless defined(&DDI_NT_BLOCK);
    eval 'sub DDI_NT_BLOCK_CHAN () {"ddi_block:channel";}' unless defined(&DDI_NT_BLOCK_CHAN);
    eval 'sub DDI_NT_BLOCK_WWN () {"ddi_block:wwn";}' unless defined(&DDI_NT_BLOCK_WWN);
    eval 'sub DDI_NT_CD () {"ddi_block:cdrom";}' unless defined(&DDI_NT_CD);
    eval 'sub DDI_NT_CD_CHAN () {"ddi_block:cdrom:channel";}' unless defined(&DDI_NT_CD_CHAN);
    eval 'sub DDI_NT_FD () {"ddi_block:diskette";}' unless defined(&DDI_NT_FD);
    eval 'sub DDI_NT_TAPE () {"ddi_byte:tape";}' unless defined(&DDI_NT_TAPE);
    eval 'sub DDI_NT_NET () {"ddi_network";}' unless defined(&DDI_NT_NET);
    eval 'sub DDI_NT_DISPLAY () {"ddi_display";}' unless defined(&DDI_NT_DISPLAY);
    eval 'sub DDI_PSEUDO () {"ddi_pseudo";}' unless defined(&DDI_PSEUDO);
    eval 'sub DDI_NT_AUDIO () {"ddi_audio";}' unless defined(&DDI_NT_AUDIO);
    eval 'sub DDI_NT_MOUSE () {"ddi_mouse";}' unless defined(&DDI_NT_MOUSE);
    eval 'sub DDI_NT_KEYBOARD () {"ddi_keyboard";}' unless defined(&DDI_NT_KEYBOARD);
    eval 'sub DDI_NT_PARALLEL () {"ddi_parallel";}' unless defined(&DDI_NT_PARALLEL);
    eval 'sub DDI_NT_PRINTER () {"ddi_printer";}' unless defined(&DDI_NT_PRINTER);
    eval 'sub DDI_NT_NEXUS () {"ddi_ctl:devctl";}' unless defined(&DDI_NT_NEXUS);
    eval 'sub DDI_NT_SCSI_NEXUS () {"ddi_ctl:devctl:scsi";}' unless defined(&DDI_NT_SCSI_NEXUS);
    eval 'sub DDI_NT_SBD_ATTACHMENT_POINT () {"ddi_ctl:attachment_point:sbd";}' unless defined(&DDI_NT_SBD_ATTACHMENT_POINT);
    eval 'sub DDI_NT_FC_ATTACHMENT_POINT () {"ddi_ctl:attachment_point:fc";}' unless defined(&DDI_NT_FC_ATTACHMENT_POINT);
    eval 'sub DDI_NT_ATTACHMENT_POINT () {"ddi_ctl:attachment_point";}' unless defined(&DDI_NT_ATTACHMENT_POINT);
    eval 'sub DDI_NT_SCSI_ATTACHMENT_POINT () {"ddi_ctl:attachment_point:scsi";}' unless defined(&DDI_NT_SCSI_ATTACHMENT_POINT);
    eval 'sub DDI_NT_PCI_ATTACHMENT_POINT () {"ddi_ctl:attachment_point:pci";}' unless defined(&DDI_NT_PCI_ATTACHMENT_POINT);
    eval 'sub DDI_NT_BLOCK_FABRIC () {"ddi_block:fabric";}' unless defined(&DDI_NT_BLOCK_FABRIC);
    eval 'sub DDI_NT_SMARTCARD_READER () {"ddi_smartcard_reader";}' unless defined(&DDI_NT_SMARTCARD_READER);
    eval 'sub EC_DEVFS () {"EC_devfs";}' unless defined(&EC_DEVFS);
    eval 'sub ESC_DEVFS_MINOR_CREATE () {"ESC_devfs_minor_create";}' unless defined(&ESC_DEVFS_MINOR_CREATE);
    eval 'sub ESC_DEVFS_MINOR_REMOVE () {"ESC_devfs_minor_remove";}' unless defined(&ESC_DEVFS_MINOR_REMOVE);
    eval 'sub ESC_DEVFS_DEVI_ADD () {"ESC_devfs_devi_add";}' unless defined(&ESC_DEVFS_DEVI_ADD);
    eval 'sub ESC_DEVFS_DEVI_REMOVE () {"ESC_devfs_devi_remove";}' unless defined(&ESC_DEVFS_DEVI_REMOVE);
    eval 'sub ESC_DEVFS_INSTANCE_MOD () {"ESC_devfs_instance_mod";}' unless defined(&ESC_DEVFS_INSTANCE_MOD);
    eval 'sub EP_DDI () { &SUNW_KERN_PUB"ddi";}' unless defined(&EP_DDI);
    eval 'sub DEVFS_DRIVER_NAME () {"di.driver";}' unless defined(&DEVFS_DRIVER_NAME);
    eval 'sub DEVFS_PATHNAME () {"di.path";}' unless defined(&DEVFS_PATHNAME);
    eval 'sub DEVFS_MINOR_NAME () {"mi.name";}' unless defined(&DEVFS_MINOR_NAME);
    eval 'sub DEVFS_MINOR_NODETYPE () {"mi.nodetype";}' unless defined(&DEVFS_MINOR_NODETYPE);
    eval 'sub DEVFS_MINOR_ISCLONE () {"mi.isclone";}' unless defined(&DEVFS_MINOR_ISCLONE);
    eval 'sub DEVFS_MINOR_MAJNUM () {"mi.majorno";}' unless defined(&DEVFS_MINOR_MAJNUM);
    eval 'sub DEVFS_MINOR_MINORNUM () {"mi.minorno";}' unless defined(&DEVFS_MINOR_MINORNUM);
    eval("sub DDI_SERVICE_LOST () { -32; }") unless defined(&DDI_SERVICE_LOST);
    eval("sub DDI_SERVICE_DEGRADED () { -16; }") unless defined(&DDI_SERVICE_DEGRADED);
    eval("sub DDI_SERVICE_UNAFFECTED () { 0; }") unless defined(&DDI_SERVICE_UNAFFECTED);
    eval("sub DDI_SERVICE_RESTORED () { 16; }") unless defined(&DDI_SERVICE_RESTORED);
    eval("sub DDI_DATAPATH_FAULT () { -32; }") unless defined(&DDI_DATAPATH_FAULT);
    eval("sub DDI_DEVICE_FAULT () { -16; }") unless defined(&DDI_DEVICE_FAULT);
    eval("sub DDI_EXTERNAL_FAULT () { 0; }") unless defined(&DDI_EXTERNAL_FAULT);
    eval("sub DDI_DEVSTATE_OFFLINE () { -32; }") unless defined(&DDI_DEVSTATE_OFFLINE);
    eval("sub DDI_DEVSTATE_DOWN () { -16; }") unless defined(&DDI_DEVSTATE_DOWN);
    eval("sub DDI_DEVSTATE_QUIESCED () { 0; }") unless defined(&DDI_DEVSTATE_QUIESCED);
    eval("sub DDI_DEVSTATE_DEGRADED () { 16; }") unless defined(&DDI_DEVSTATE_DEGRADED);
    eval("sub DDI_DEVSTATE_UP () { 32; }") unless defined(&DDI_DEVSTATE_UP);
    if(defined(&_KERNEL)) {
	eval 'sub DDI_INTR_NOTFOUND () {1;}' unless defined(&DDI_INTR_NOTFOUND);
	eval 'sub DDI_SOFTINT_FIXED () {0;}' unless defined(&DDI_SOFTINT_FIXED);
	eval 'sub DDI_SOFTINT_LOW () {8;}' unless defined(&DDI_SOFTINT_LOW);
	eval 'sub DDI_SOFTINT_MED () {128;}' unless defined(&DDI_SOFTINT_MED);
	eval 'sub DDI_SOFTINT_HIGH () {256;}' unless defined(&DDI_SOFTINT_HIGH);
	eval 'sub DDI_INTR_CLAIMED () {1;}' unless defined(&DDI_INTR_CLAIMED);
	eval 'sub DDI_INTR_UNCLAIMED () {0;}' unless defined(&DDI_INTR_UNCLAIMED);
	eval 'sub DDI_WALK_CONTINUE () {0;}' unless defined(&DDI_WALK_CONTINUE);
	eval 'sub DDI_WALK_PRUNECHILD () {-1;}' unless defined(&DDI_WALK_PRUNECHILD);
	eval 'sub DDI_WALK_PRUNESIB () {-2;}' unless defined(&DDI_WALK_PRUNESIB);
	eval 'sub DDI_WALK_TERMINATE () {-3;}' unless defined(&DDI_WALK_TERMINATE);
	eval 'sub DDI_KERNEL_IOCTL () {"ddi-kernel-ioctl";}' unless defined(&DDI_KERNEL_IOCTL);
	eval 'sub DDI_MODEL_MASK () { &DATAMODEL_MASK;}' unless defined(&DDI_MODEL_MASK);
	eval 'sub DDI_MODEL_ILP32 () { &DATAMODEL_ILP32;}' unless defined(&DDI_MODEL_ILP32);
	eval 'sub DDI_MODEL_LP64 () { &DATAMODEL_LP64;}' unless defined(&DDI_MODEL_LP64);
	eval 'sub DDI_MODEL_NATIVE () { &DATAMODEL_NATIVE;}' unless defined(&DDI_MODEL_NATIVE);
	eval 'sub DDI_MODEL_NONE () { &DATAMODEL_NONE;}' unless defined(&DDI_MODEL_NONE);
	if(defined(&__STDC__)) {
	    if(defined(&_LP64)) {
	    } else {
		eval 'sub ddi_peek8 () { &ddi_peekc;}' unless defined(&ddi_peek8);
		eval 'sub ddi_peek16 () { &ddi_peeks;}' unless defined(&ddi_peek16);
		eval 'sub ddi_peek32 () { &ddi_peekl;}' unless defined(&ddi_peek32);
		eval 'sub ddi_peek64 () { &ddi_peekd;}' unless defined(&ddi_peek64);
		eval 'sub ddi_poke8 () { &ddi_pokec;}' unless defined(&ddi_poke8);
		eval 'sub ddi_poke16 () { &ddi_pokes;}' unless defined(&ddi_poke16);
		eval 'sub ddi_poke32 () { &ddi_pokel;}' unless defined(&ddi_poke32);
		eval 'sub ddi_poke64 () { &ddi_poked;}' unless defined(&ddi_poke64);
	    }
	    if(defined( &sparc) || defined( &__sparc)) {
	    }
	} else {
	}
	eval 'sub uiophysio () { &physio;}' unless defined(&uiophysio);
	eval 'sub DDI_REGS_ACC_CONFLICT () {(-10);}' unless defined(&DDI_REGS_ACC_CONFLICT);
	eval 'sub DDI_DEV_NO_AUTOINCR () {0x;}' unless defined(&DDI_DEV_NO_AUTOINCR);
	eval 'sub DDI_DEV_AUTOINCR () {0x1;}' unless defined(&DDI_DEV_AUTOINCR);
	if(defined(&__STDC__)) {
	    if(defined(&_LP64)) {
	    } else {
		eval 'sub ddi_get8 () { &ddi_getb;}' unless defined(&ddi_get8);
		eval 'sub ddi_get16 () { &ddi_getw;}' unless defined(&ddi_get16);
		eval 'sub ddi_get32 () { &ddi_getl;}' unless defined(&ddi_get32);
		eval 'sub ddi_get64 () { &ddi_getll;}' unless defined(&ddi_get64);
		eval 'sub ddi_rep_get8 () { &ddi_rep_getb;}' unless defined(&ddi_rep_get8);
		eval 'sub ddi_rep_get16 () { &ddi_rep_getw;}' unless defined(&ddi_rep_get16);
		eval 'sub ddi_rep_get32 () { &ddi_rep_getl;}' unless defined(&ddi_rep_get32);
		eval 'sub ddi_rep_get64 () { &ddi_rep_getll;}' unless defined(&ddi_rep_get64);
		eval 'sub ddi_put8 () { &ddi_putb;}' unless defined(&ddi_put8);
		eval 'sub ddi_put16 () { &ddi_putw;}' unless defined(&ddi_put16);
		eval 'sub ddi_put32 () { &ddi_putl;}' unless defined(&ddi_put32);
		eval 'sub ddi_put64 () { &ddi_putll;}' unless defined(&ddi_put64);
		eval 'sub ddi_rep_put8 () { &ddi_rep_putb;}' unless defined(&ddi_rep_put8);
		eval 'sub ddi_rep_put16 () { &ddi_rep_putw;}' unless defined(&ddi_rep_put16);
		eval 'sub ddi_rep_put32 () { &ddi_rep_putl;}' unless defined(&ddi_rep_put32);
		eval 'sub ddi_rep_put64 () { &ddi_rep_putll;}' unless defined(&ddi_rep_put64);
	    }
	    eval 'sub PCI_PM_IDLESPEED () {0x1;}' unless defined(&PCI_PM_IDLESPEED);
	    eval 'sub PCI_PM_IDLESPEED_ANY () {( &void *)-1;}' unless defined(&PCI_PM_IDLESPEED_ANY);
	    eval 'sub PCI_PM_IDLESPEED_NONE () {( &void *)-2;}' unless defined(&PCI_PM_IDLESPEED_NONE);
	    if(defined(&_LP64)) {
	    } else {
		eval 'sub pci_config_get8 () { &pci_config_getb;}' unless defined(&pci_config_get8);
		eval 'sub pci_config_get16 () { &pci_config_getw;}' unless defined(&pci_config_get16);
		eval 'sub pci_config_get32 () { &pci_config_getl;}' unless defined(&pci_config_get32);
		eval 'sub pci_config_get64 () { &pci_config_getll;}' unless defined(&pci_config_get64);
		eval 'sub pci_config_put8 () { &pci_config_putb;}' unless defined(&pci_config_put8);
		eval 'sub pci_config_put16 () { &pci_config_putw;}' unless defined(&pci_config_put16);
		eval 'sub pci_config_put32 () { &pci_config_putl;}' unless defined(&pci_config_put32);
		eval 'sub pci_config_put64 () { &pci_config_putll;}' unless defined(&pci_config_put64);
	    }
	    eval 'sub DDI_EVENT_CLAIMED () {0;}' unless defined(&DDI_EVENT_CLAIMED);
	    eval 'sub DDI_EVENT_UNCLAIMED () {1;}' unless defined(&DDI_EVENT_UNCLAIMED);
	    eval 'sub DDI_EVENT_CLAIMED_UNREGISTER () {2;}' unless defined(&DDI_EVENT_CLAIMED_UNREGISTER);
	    eval 'sub DDI_DEVI_REMOVE_EVENT () {"DDI:DEVI_REMOVE";}' unless defined(&DDI_DEVI_REMOVE_EVENT);
	    eval 'sub DDI_DEVI_INSERT_EVENT () {"DDI:DEVI_INSERT";}' unless defined(&DDI_DEVI_INSERT_EVENT);
	    eval 'sub DDI_DEVI_BUS_RESET_EVENT () {"DDI:DEVI_BUS_RESET";}' unless defined(&DDI_DEVI_BUS_RESET_EVENT);
	    eval 'sub DDI_DEVI_DEVICE_RESET_EVENT () {"DDI:DEVI_DEVICE_RESET";}' unless defined(&DDI_DEVI_DEVICE_RESET_EVENT);
	    eval 'sub DDI_VENDOR_SUNW () {"SUNW";}' unless defined(&DDI_VENDOR_SUNW);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
