require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SYSMACROS_H)) {
    eval 'sub _SYS_SYSMACROS_H () {1;}' unless defined(&_SYS_SYSMACROS_H);
    require 'sys/param.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub dtob {
        my($DD) = @_;
	    eval q((($DD) <<  &DEV_BSHIFT));
    }' unless defined(&dtob);
    eval 'sub btod {
        my($BB) = @_;
	    eval q(((($BB) +  &DEV_BSIZE - 1) >>  &DEV_BSHIFT));
    }' unless defined(&btod);
    eval 'sub btodt {
        my($BB) = @_;
	    eval q((($BB) >>  &DEV_BSHIFT));
    }' unless defined(&btodt);
    eval 'sub lbtod {
        my($BB) = @_;
	    eval q(((( &offset_t)($BB) +  &DEV_BSIZE - 1) >>  &DEV_BSHIFT));
    }' unless defined(&lbtod);
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    my($a, $b) = @_;
    	    eval q((($a) < ($b) ? ($a) : ($b)));
	}' unless defined(&MIN);
    }
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    my($a, $b) = @_;
    	    eval q((($a) < ($b) ? ($b) : ($a)));
	}' unless defined(&MAX);
    }
    unless(defined(&ABS)) {
	eval 'sub ABS {
	    my($a) = @_;
    	    eval q((($a) < 0? -($a) : ($a)));
	}' unless defined(&ABS);
    }
    if(defined(&_KERNEL)) {
	eval 'sub BYTE_TO_BCD {
	    my($x) = @_;
    	    eval q( $byte_to_bcd[($x) & 0xff]);
	}' unless defined(&BYTE_TO_BCD);
	eval 'sub BCD_TO_BYTE {
	    my($x) = @_;
    	    eval q( $bcd_to_byte[($x) & 0xff]);
	}' unless defined(&BCD_TO_BYTE);
    }
    eval 'sub O_BITSMAJOR () {7;}' unless defined(&O_BITSMAJOR);
    eval 'sub O_BITSMINOR () {8;}' unless defined(&O_BITSMINOR);
    eval 'sub O_MAXMAJ () {0x7f;}' unless defined(&O_MAXMAJ);
    eval 'sub O_MAXMIN () {0xff;}' unless defined(&O_MAXMIN);
    eval 'sub L_BITSMAJOR32 () {14;}' unless defined(&L_BITSMAJOR32);
    eval 'sub L_BITSMINOR32 () {18;}' unless defined(&L_BITSMINOR32);
    eval 'sub L_MAXMAJ32 () {0x3fff;}' unless defined(&L_MAXMAJ32);
    eval 'sub L_MAXMIN32 () {0x3ffff;}' unless defined(&L_MAXMIN32);
    if(defined(&_LP64)) {
	eval 'sub L_BITSMAJOR () {32;}' unless defined(&L_BITSMAJOR);
	eval 'sub L_BITSMINOR () {32;}' unless defined(&L_BITSMINOR);
	eval 'sub L_MAXMAJ () {0xffffffff;}' unless defined(&L_MAXMAJ);
	eval 'sub L_MAXMIN () {0xffffffff;}' unless defined(&L_MAXMIN);
    } else {
	eval 'sub L_BITSMAJOR () { &L_BITSMAJOR32;}' unless defined(&L_BITSMAJOR);
	eval 'sub L_BITSMINOR () { &L_BITSMINOR32;}' unless defined(&L_BITSMINOR);
	eval 'sub L_MAXMAJ () { &L_MAXMAJ32;}' unless defined(&L_MAXMAJ);
	eval 'sub L_MAXMIN () { &L_MAXMIN32;}' unless defined(&L_MAXMIN);
    }
    if(defined(&_KERNEL)) {
	eval 'sub major {
	    my($x) = @_;
    	    eval q(( &major_t)(((($x)) >>  &O_BITSMINOR) &  &O_MAXMAJ));
	}' unless defined(&major);
	eval 'sub bmajor {
	    my($x) = @_;
    	    eval q(( &major_t)(((($x)) >>  &O_BITSMINOR) &  &O_MAXMAJ));
	}' unless defined(&bmajor);
	eval 'sub getmajor {
	    my($x) = @_;
    	    eval q(( &major_t)(((( &dev_t)($x)) >>  &L_BITSMINOR) &  &L_MAXMAJ));
	}' unless defined(&getmajor);
	eval 'sub minor {
	    my($x) = @_;
    	    eval q(( &minor_t)(($x) &  &O_MAXMIN));
	}' unless defined(&minor);
	eval 'sub getminor {
	    my($x) = @_;
    	    eval q(( &minor_t)(($x) &  &L_MAXMIN));
	}' unless defined(&getminor);
    } else {
	eval 'sub major {
	    my($x) = @_;
    	    eval q(( &major_t)(((($x)) >>  &O_BITSMINOR) &  &O_MAXMAJ));
	}' unless defined(&major);
	eval 'sub minor {
	    my($x) = @_;
    	    eval q(( &minor_t)(($x) &  &O_MAXMIN));
	}' unless defined(&minor);
    }
    eval 'sub makedev {
        my($x, $y) = @_;
	    eval q(((($x) <<  &O_BITSMINOR) | (($y) &  &O_MAXMIN)));
    }' unless defined(&makedev);
    eval 'sub makedevice {
        my($x, $y) = @_;
	    eval q(( &dev_t)((( &dev_t)($x) <<  &L_BITSMINOR) | (($y) &  &L_MAXMIN)));
    }' unless defined(&makedevice);
    eval 'sub emajor {
        my($x) = @_;
	    eval q(( &major_t)(( >>  &O_BITSMINOR) >  &O_MAXMAJ) ?  &NODEV : ((($x) >>  &O_BITSMINOR) &  &O_MAXMAJ));
    }' unless defined(&emajor);
    eval 'sub eminor {
        my($x) = @_;
	    eval q(( &minor_t)(($x) &  &O_MAXMIN));
    }' unless defined(&eminor);
    eval 'sub getemajor {
        my($x) = @_;
	    eval q(( &major_t)(((( &dev_t)($x) >>  &L_BITSMINOR) >  &L_MAXMAJ) ?  &NODEV : ((( &dev_t)($x) >>  &L_BITSMINOR) &  &L_MAXMAJ)));
    }' unless defined(&getemajor);
    eval 'sub geteminor {
        my($x) = @_;
	    eval q(( &minor_t)(($x) &  &L_MAXMIN));
    }' unless defined(&geteminor);
    if(((defined(&L_BITSMAJOR32) ? &L_BITSMAJOR32 : 0) == (defined(&L_BITSMAJOR) ? &L_BITSMAJOR : 0))  && ((defined(&L_BITSMINOR32) ? &L_BITSMINOR32 : 0) == (defined(&L_BITSMINOR) ? &L_BITSMINOR : 0))) {
	eval 'sub DEVCMPL {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&DEVCMPL);
	eval 'sub DEVEXPL {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&DEVEXPL);
    } else {
	eval 'sub DEVCMPL {
	    my($x) = @_;
    	    eval q(( &dev32_t)(((($x) >>  &L_BITSMINOR) >  &L_MAXMAJ32 || (($x) &  &L_MAXMIN) >  &L_MAXMIN32) ?  &NODEV32 : (((($x) >>  &L_BITSMINOR) <<  &L_BITSMINOR32) | (($x) &  &L_MAXMIN32))));
	}' unless defined(&DEVCMPL);
	eval 'sub DEVEXPL {
	    my($x) = @_;
    	    eval q(((($x) ==  &NODEV32) ?  &NODEV :  &makedevice((($x) >>  &L_BITSMINOR32) &  &L_MAXMAJ32, ($x) &  &L_MAXMIN32)));
	}' unless defined(&DEVEXPL);
    }
    eval 'sub cmpdev {
        my($x) = @_;
	    eval q(( &o_dev_t)(((($x) >>  &L_BITSMINOR) >  &O_MAXMAJ || (($x) &  &L_MAXMIN) >  &O_MAXMIN) ?  &NODEV : (((($x) >>  &L_BITSMINOR) <<  &O_BITSMINOR) | (($x) &  &O_MAXMIN))));
    }' unless defined(&cmpdev);
    eval 'sub expdev {
        my($x) = @_;
	    eval q(( &dev_t)((( &dev_t)((($x) >>  &O_BITSMINOR) &  &O_MAXMAJ) <<  &L_BITSMINOR) | (($x) &  &O_MAXMIN)));
    }' unless defined(&expdev);
    eval 'sub SALIGN {
        my($p) = @_;
	    eval q(((( &intptr_t)$p + ($sizeof{\'short\'} - 1)) & ~($sizeof{\'short\'} - 1)));
    }' unless defined(&SALIGN);
    eval 'sub IALIGN {
        my($p) = @_;
	    eval q(((( &intptr_t)$p + ($sizeof{\'int\'} - 1)) & ~($sizeof{\'int\'} - 1)));
    }' unless defined(&IALIGN);
    eval 'sub LALIGN {
        my($p) = @_;
	    eval q(((( &intptr_t)$p + ($sizeof{\'long\'} - 1)) & ~($sizeof{\'long\'} - 1)));
    }' unless defined(&LALIGN);
    eval 'sub SNEXT {
        my($p) = @_;
	    eval q(($p + 1));
    }' unless defined(&SNEXT);
    eval 'sub INEXT {
        my($p) = @_;
	    eval q(($p + 1));
    }' unless defined(&INEXT);
    eval 'sub LNEXT {
        my($p) = @_;
	    eval q(($p + 1));
    }' unless defined(&LNEXT);
    eval 'sub IS_P2ALIGNED {
        my($v, $a) = @_;
	    eval q((((( &uintptr_t)($v)) & (( &uintptr_t)($a) - 1)) == 0));
    }' unless defined(&IS_P2ALIGNED);
    eval 'sub howmany {
        my($x, $y) = @_;
	    eval q(((($x)+(($y)-1))/($y)));
    }' unless defined(&howmany);
    eval 'sub roundup {
        my($x, $y) = @_;
	    eval q((((($x)+(($y)-1))/($y))*($y)));
    }' unless defined(&roundup);
    eval 'sub P2ALIGN {
        my($x, $align) = @_;
	    eval q((($x) & -($align)));
    }' unless defined(&P2ALIGN);
    eval 'sub P2PHASE {
        my($x, $align) = @_;
	    eval q((($x) & (($align) - 1)));
    }' unless defined(&P2PHASE);
    eval 'sub P2NPHASE {
        my($x, $align) = @_;
	    eval q((-($x) & (($align) - 1)));
    }' unless defined(&P2NPHASE);
    eval 'sub P2ROUNDUP {
        my($x, $align) = @_;
	    eval q((-(-($x) & -($align))));
    }' unless defined(&P2ROUNDUP);
    eval 'sub P2END {
        my($x, $align) = @_;
	    eval q((-(~($x) & -($align))));
    }' unless defined(&P2END);
    eval 'sub P2PHASEUP {
        my($x, $align, $phase) = @_;
	    eval q((($phase) - ((($phase) - ($x)) & -($align))));
    }' unless defined(&P2PHASEUP);
    eval 'sub P2CROSS {
        my($x, $y, $align) = @_;
	    eval q(((($x) ^ ($y)) > ($align) - 1));
    }' unless defined(&P2CROSS);
    eval 'sub INCR_COUNT {
        my($var, $mutex) = @_;
	    eval q( &mutex_enter($mutex), (*($var))++,  &mutex_exit($mutex));
    }' unless defined(&INCR_COUNT);
    eval 'sub DECR_COUNT {
        my($var, $mutex) = @_;
	    eval q( &mutex_enter($mutex), (*($var))--,  &mutex_exit($mutex));
    }' unless defined(&DECR_COUNT);
    if(defined( &_KERNEL)  && !defined( &_KMEMUSER)  && !defined( &offsetof)) {
	eval 'sub offsetof {
	    my($s, $m) = @_;
    	    eval q(((((($s *)0)->$m))));
	}' unless defined(&offsetof);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
