require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SYSTM_H)) {
    eval 'sub _SYS_SYSTM_H () {1;}' unless defined(&_SYS_SYSTM_H);
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/proc.ph';
    require 'sys/dditypes.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	require 'sys/varargs.ph';
	if(defined( &__ia64)) {
	}
	if(defined(&C2_AUDIT)) {
	}
	eval("sub TOD_REVERSED () { 0; }") unless defined(&TOD_REVERSED);
	eval("sub TOD_STALLED () { 1; }") unless defined(&TOD_STALLED);
	eval("sub TOD_JUMPED () { 2; }") unless defined(&TOD_JUMPED);
	eval("sub TOD_RATECHANGED () { 3; }") unless defined(&TOD_RATECHANGED);
	eval("sub TOD_NOFAULT () { 4; }") unless defined(&TOD_NOFAULT);
	unless(defined(&_LP64)) {
	}
	eval 'sub insque {
	    my($q, $p) = @_;
    	    eval q( &_insque($q, $p));
	}' unless defined(&insque);
	eval 'sub remque {
	    my($q) = @_;
    	    eval q( &_remque($q));
	}' unless defined(&remque);
    }
    if(defined(&_LP64)) {
    } else {
    }
    if(defined(&_SYSCALL32_IMPL)) {
    }
    eval 'sub NSYSCALL () {256;}' unless defined(&NSYSCALL);
    eval 'sub LOADABLE_SYSCALL {
        my($s) = @_;
	    eval q(( ($s->{sy_flags}) &  &SE_LOADABLE));
    }' unless defined(&LOADABLE_SYSCALL);
    eval 'sub LOADED_SYSCALL {
        my($s) = @_;
	    eval q(( ($s->{sy_flags}) &  &SE_LOADED));
    }' unless defined(&LOADED_SYSCALL);
    eval 'sub SE_32RVAL1 () {0x;}' unless defined(&SE_32RVAL1);
    eval 'sub SE_32RVAL2 () {0x1;}' unless defined(&SE_32RVAL2);
    eval 'sub SE_64RVAL () {0x2;}' unless defined(&SE_64RVAL);
    eval 'sub SE_RVAL_MASK () {0x3;}' unless defined(&SE_RVAL_MASK);
    eval 'sub SE_LOADABLE () {0x8;}' unless defined(&SE_LOADABLE);
    eval 'sub SE_LOADED () {0x10;}' unless defined(&SE_LOADED);
    eval 'sub SE_NOUNLOAD () {0x20;}' unless defined(&SE_NOUNLOAD);
    eval 'sub SE_ARGC () {0x40;}' unless defined(&SE_ARGC);
    eval 'sub r_val1 () { ($r_v->{r_v1});}' unless defined(&r_val1);
    eval 'sub r_val2 () { ($r_v->{r_v2});}' unless defined(&r_val2);
    if(defined(&_KERNEL)) {
	if(defined(&_SYSCALL32_IMPL)) {
	}
	if(defined(&lint)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
