require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_TNF_PROBE_H)) {
    eval 'sub _SYS_TNF_PROBE_H () {1;}' unless defined(&_SYS_TNF_PROBE_H);
    require 'sys/tnf_writer.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub TNF_STRINGIFY {
        my($x) = @_;
	    eval q($x);
    }' unless defined(&TNF_STRINGIFY);
    eval 'sub TNF_STRINGVALUE {
        my($x) = @_;
	    eval q( &TNF_STRINGIFY($x));
    }' unless defined(&TNF_STRINGVALUE);
    eval 'sub TNF_REF32_ALIGN () { &TNF_OFFSETOF(\'struct _tnf_ref32_align\',  &t);}' unless defined(&TNF_REF32_ALIGN);
    if(defined(&_KERNEL)) {
	eval 'sub TNF_NEXT_INIT () {0;}' unless defined(&TNF_NEXT_INIT);
    } else {
	eval 'sub TNF_NEXT_INIT () {-1;}' unless defined(&TNF_NEXT_INIT);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_DECLARE_RECORD {
	    my($ctype, $record) = @_;
    	    eval q( &typedef  &tnf_reference_t $record &_t);
	}' unless defined(&TNF_DECLARE_RECORD);
    } else {
	eval 'sub TNF_DECLARE_RECORD {
	    my($ctype, $record) = @_;
    	    eval q( &typedef  &tnf_reference_t $record &_t;  &extern  &tnf_tag_data_t *$record &_tag_data;  &extern $record &_t $record( &tnf_ops_t *, $ctype *,  &tnf_record_p));
	}' unless defined(&TNF_DECLARE_RECORD);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_DEFINE_RECORD_1 {
	    my($ctype, $ctype_record, $t1, $n1) = @_;
    	    eval q();
	}' unless defined(&TNF_DEFINE_RECORD_1);
    } else {
	eval 'sub TNF_DEFINE_RECORD_1 {
	    my($ctype, $ctype_record, $t1, $n1) = @_;
    	    eval q( &typedef \'struct struct\' {  &tnf_tag_t  &tag; $t1 &_t  &data_1; } $ctype_record &_prototype_t;  &static  &tnf_tag_data_t **$ctype_record $_type_slots[] = {  &tnf_tag_tag_data, $t1 &_tag_data, 0};  &static \'char\' *$ctype_record $_slot_names[] = { \\"tnf_tag\\", \\"\\"$n1, 0};  &static  &tnf_tag_data_t $ctype_record &_tag_data_rec = {  &TNF_TAG_VERSION,  &tnf_struct_tag_1, 0, $ctype_record,  &tnf_user_struct_properties, $sizeof{$ctype_record &_prototype_t},  &TNF_REF32_ALIGN, $sizeof{$ctype_record &_t},  &TNF_STRUCT, 0, $ctype_record &_type_slots, $ctype_record &_slot_names };  &tnf_tag_data_t *$ctype_record &_tag_data = $ctype_record &_tag_data_rec; $ctype_record &_t $ctype_record( &tnf_ops_t * &ops, $ctype *  &the_ctype,  &tnf_record_p  &reference) {  &tnf_tag_data_t * &metatag_data;  &tnf_record_p  &metatag_index; $ctype_record &_prototype_t * &buffer;  &if ( &the_ctype ==  &NULL)  &return (0);  &buffer = ($ctype_record &_prototype_t *)  &tnf_allocate( &ops, $sizeof{$ctype_record &_prototype_t});  &if ( &buffer ==  &NULL)  &return (0);  &metatag_data = $ctype_record &_tag_data;  &metatag_index =  ($metatag_data->{tag_index}) ?  ($metatag_data->{tag_index}):  ($metatag_data->{tag_desc})( &ops,  &metatag_data);  ($buffer->{tag}) =  &tnf_tag( &ops,  &metatag_index, ( &tnf_record_p)  ($buffer->{tag}));  ($buffer->{data_1}) = $t1( &ops,  ($the_ctype->{n1}), ( &tnf_record_p) ( ($buffer->{data_1})));  &return ( &tnf_ref32( &ops, ( &tnf_record_p)  &buffer,  &reference)); });
	}' unless defined(&TNF_DEFINE_RECORD_1);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_DEFINE_RECORD_2 {
	    my($ctype, $ctype_record, $t1, $n1, $t2, $n2) = @_;
    	    eval q();
	}' unless defined(&TNF_DEFINE_RECORD_2);
    } else {
	eval 'sub TNF_DEFINE_RECORD_2 {
	    my($ctype, $ctype_record, $t1, $n1, $t2, $n2) = @_;
    	    eval q( &typedef \'struct struct\' {  &tnf_tag_t  &tag; $t1 &_t  &data_1; $t2 &_t  &data_2; } $ctype_record &_prototype_t;  &static  &tnf_tag_data_t **$ctype_record $_type_slots[] = {  &tnf_tag_tag_data, $t1 &_tag_data, $t2 &_tag_data, 0};  &static \'char\' *$ctype_record $_slot_names[] = { \\"tnf_tag\\", \\"\\"$n1, \\"\\"$n2, 0};  &static  &tnf_tag_data_t $ctype_record &_tag_data_rec = {  &TNF_TAG_VERSION,  &tnf_struct_tag_1, 0, $ctype_record,  &tnf_user_struct_properties, $sizeof{$ctype_record &_prototype_t},  &TNF_REF32_ALIGN, $sizeof{$ctype_record &_t},  &TNF_STRUCT, 0, $ctype_record &_type_slots, $ctype_record &_slot_names };  &tnf_tag_data_t *$ctype_record &_tag_data = $ctype_record &_tag_data_rec; $ctype_record &_t $ctype_record( &tnf_ops_t * &ops, $ctype *  &the_ctype,  &tnf_record_p  &reference) {  &tnf_tag_data_t * &metatag_data;  &tnf_record_p  &metatag_index; $ctype_record &_prototype_t * &buffer;  &if ( &the_ctype ==  &NULL)  &return (0);  &buffer = ($ctype_record &_prototype_t *)  &tnf_allocate( &ops, $sizeof{$ctype_record &_prototype_t});  &if ( &buffer ==  &NULL)  &return (0);  &metatag_data = $ctype_record &_tag_data;  &metatag_index =  ($metatag_data->{tag_index}) ?  ($metatag_data->{tag_index}):  ($metatag_data->{tag_desc})( &ops,  &metatag_data);  ($buffer->{tag}) =  &tnf_tag( &ops,  &metatag_index, ( &tnf_record_p)  ($buffer->{tag}));  ($buffer->{data_1}) = $t1( &ops,  ($the_ctype->{n1}), ( &tnf_record_p) ( ($buffer->{data_1})));  ($buffer->{data_2}) = $t2( &ops,  ($the_ctype->{n2}), ( &tnf_record_p) ( ($buffer->{data_2})));  &return ( &tnf_ref32( &ops, ( &tnf_record_p)  &buffer,  &reference)); });
	}' unless defined(&TNF_DEFINE_RECORD_2);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_DEFINE_RECORD_3 {
	    my($ctype, $ctype_record, $t1, $n1, $t2, $n2, $t3, $n3) = @_;
    	    eval q();
	}' unless defined(&TNF_DEFINE_RECORD_3);
    } else {
	eval 'sub TNF_DEFINE_RECORD_3 {
	    my($ctype, $ctype_record, $t1, $n1, $t2, $n2, $t3, $n3) = @_;
    	    eval q( &typedef \'struct struct\' {  &tnf_tag_t  &tag; $t1 &_t  &data_1; $t2 &_t  &data_2; $t3 &_t  &data_3; } $ctype_record &_prototype_t;  &static  &tnf_tag_data_t **$ctype_record $_type_slots[] = {  &tnf_tag_tag_data, $t1 &_tag_data, $t2 &_tag_data, $t3 &_tag_data, 0};  &static \'char\' *$ctype_record $_slot_names[] = { \\"tnf_tag\\", \\"\\"$n1, \\"\\"$n2, \\"\\"$n3, 0};  &static  &tnf_tag_data_t $ctype_record &_tag_data_rec = {  &TNF_TAG_VERSION,  &tnf_struct_tag_1, 0, $ctype_record,  &tnf_user_struct_properties, $sizeof{$ctype_record &_prototype_t},  &TNF_REF32_ALIGN, $sizeof{$ctype_record &_t},  &TNF_STRUCT, 0, $ctype_record &_type_slots, $ctype_record &_slot_names };  &tnf_tag_data_t *$ctype_record &_tag_data = $ctype_record &_tag_data_rec; $ctype_record &_t $ctype_record( &tnf_ops_t * &ops, $ctype *  &the_ctype,  &tnf_record_p  &reference) {  &tnf_tag_data_t * &metatag_data;  &tnf_record_p  &metatag_index; $ctype_record &_prototype_t * &buffer;  &if ( &the_ctype ==  &NULL)  &return (0);  &buffer = ($ctype_record &_prototype_t *)  &tnf_allocate( &ops, $sizeof{$ctype_record &_prototype_t});  &if ( &buffer ==  &NULL)  &return (0);  &metatag_data = $ctype_record &_tag_data;  &metatag_index =  ($metatag_data->{tag_index}) ?  ($metatag_data->{tag_index}):  ($metatag_data->{tag_desc})( &ops,  &metatag_data);  ($buffer->{tag}) =  &tnf_tag( &ops,  &metatag_index, ( &tnf_record_p)  ($buffer->{tag}));  ($buffer->{data_1}) = $t1( &ops,  ($the_ctype->{n1}), ( &tnf_record_p) ( ($buffer->{data_1})));  ($buffer->{data_2}) = $t2( &ops,  ($the_ctype->{n2}), ( &tnf_record_p) ( ($buffer->{data_2})));  ($buffer->{data_3}) = $t3( &ops,  ($the_ctype->{n3}), ( &tnf_record_p) ( ($buffer->{data_3})));  &return ( &tnf_ref32( &ops, ( &tnf_record_p)  &buffer,  &reference)); });
	}' unless defined(&TNF_DEFINE_RECORD_3);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_DEFINE_RECORD_4 {
	    my($ctype, $ctype_record, $t1, $n1, $t2, $n2, $t3, $n3, $t4, $n4) = @_;
    	    eval q();
	}' unless defined(&TNF_DEFINE_RECORD_4);
    } else {
	eval 'sub TNF_DEFINE_RECORD_4 {
	    my($ctype, $ctype_record, $t1, $n1, $t2, $n2, $t3, $n3, $t4, $n4) = @_;
    	    eval q( &typedef \'struct struct\' {  &tnf_tag_t  &tag; $t1 &_t  &data_1; $t2 &_t  &data_2; $t3 &_t  &data_3; $t4 &_t  &data_4; } $ctype_record &_prototype_t;  &static  &tnf_tag_data_t **$ctype_record $_type_slots[] = {  &tnf_tag_tag_data, $t1 &_tag_data, $t2 &_tag_data, $t3 &_tag_data, $t4 &_tag_data, 0};  &static \'char\' *$ctype_record $_slot_names[] = { \\"tnf_tag\\", \\"\\"$n1, \\"\\"$n2, \\"\\"$n3, \\"\\"$n4, 0};  &static  &tnf_tag_data_t $ctype_record &_tag_data_rec = {  &TNF_TAG_VERSION,  &tnf_struct_tag_1, 0, $ctype_record,  &tnf_user_struct_properties, $sizeof{$ctype_record &_prototype_t},  &TNF_REF32_ALIGN, $sizeof{$ctype_record &_t},  &TNF_STRUCT, 0, $ctype_record &_type_slots, $ctype_record &_slot_names };  &tnf_tag_data_t *$ctype_record &_tag_data = $ctype_record &_tag_data_rec; $ctype_record &_t $ctype_record( &tnf_ops_t * &ops, $ctype *  &the_ctype,  &tnf_record_p  &reference) {  &tnf_tag_data_t * &metatag_data;  &tnf_record_p  &metatag_index; $ctype_record &_prototype_t * &buffer;  &if ( &the_ctype ==  &NULL)  &return (0);  &buffer = ($ctype_record &_prototype_t *)  &tnf_allocate( &ops, $sizeof{$ctype_record &_prototype_t});  &if ( &buffer ==  &NULL)  &return (0);  &metatag_data = $ctype_record &_tag_data;  &metatag_index =  ($metatag_data->{tag_index}) ?  ($metatag_data->{tag_index}):  ($metatag_data->{tag_desc})( &ops,  &metatag_data);  ($buffer->{tag}) =  &tnf_tag( &ops,  &metatag_index, ( &tnf_record_p)  ($buffer->{tag}));  ($buffer->{data_1}) = $t1( &ops,  ($the_ctype->{n1}), ( &tnf_record_p) ( ($buffer->{data_1})));  ($buffer->{data_2}) = $t2( &ops,  ($the_ctype->{n2}), ( &tnf_record_p) ( ($buffer->{data_2})));  ($buffer->{data_3}) = $t3( &ops,  ($the_ctype->{n3}), ( &tnf_record_p) ( ($buffer->{data_3})));  ($buffer->{data_4}) = $t4( &ops,  ($the_ctype->{n4}), ( &tnf_record_p) ( ($buffer->{data_4})));  &return ( &tnf_ref32( &ops, ( &tnf_record_p)  &buffer,  &reference)); });
	}' unless defined(&TNF_DEFINE_RECORD_4);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_DEFINE_RECORD_5 {
	    my($ctype, $ctype_record, $t1, $n1, $t2, $n2, $t3, $n3, $t4, $n4, $t5, $n5) = @_;
    	    eval q();
	}' unless defined(&TNF_DEFINE_RECORD_5);
    } else {
	eval 'sub TNF_DEFINE_RECORD_5 {
	    my($ctype, $ctype_record, $t1, $n1, $t2, $n2, $t3, $n3, $t4, $n4, $t5, $n5) = @_;
    	    eval q( &typedef \'struct struct\' {  &tnf_tag_t  &tag; $t1 &_t  &data_1; $t2 &_t  &data_2; $t3 &_t  &data_3; $t4 &_t  &data_4; $t5 &_t  &data_5; } $ctype_record &_prototype_t;  &static  &tnf_tag_data_t **$ctype_record $_type_slots[] = {  &tnf_tag_tag_data, $t1 &_tag_data, $t2 &_tag_data, $t3 &_tag_data, $t4 &_tag_data, $t5 &_tag_data, 0};  &static \'char\' *$ctype_record $_slot_names[] = { \\"tnf_tag\\", \\"\\"$n1, \\"\\"$n2, \\"\\"$n3, \\"\\"$n4, \\"\\"$n5, 0};  &static  &tnf_tag_data_t $ctype_record &_tag_data_rec = {  &TNF_TAG_VERSION,  &tnf_struct_tag_1, 0, $ctype_record,  &tnf_user_struct_properties, $sizeof{$ctype_record &_prototype_t},  &TNF_REF32_ALIGN, $sizeof{$ctype_record &_t},  &TNF_STRUCT, 0, $ctype_record &_type_slots, $ctype_record &_slot_names };  &tnf_tag_data_t *$ctype_record &_tag_data = $ctype_record &_tag_data_rec; $ctype_record &_t $ctype_record( &tnf_ops_t * &ops, $ctype *  &the_ctype,  &tnf_record_p  &reference) {  &tnf_tag_data_t * &metatag_data;  &tnf_record_p  &metatag_index; $ctype_record &_prototype_t * &buffer;  &if ( &the_ctype ==  &NULL)  &return (0);  &buffer = ($ctype_record &_prototype_t *)  &tnf_allocate( &ops, $sizeof{$ctype_record &_prototype_t});  &if ( &buffer ==  &NULL)  &return (0);  &metatag_data = $ctype_record &_tag_data;  &metatag_index =  ($metatag_data->{tag_index}) ?  ($metatag_data->{tag_index}):  ($metatag_data->{tag_desc})( &ops,  &metatag_data);  ($buffer->{tag}) =  &tnf_tag( &ops,  &metatag_index, ( &tnf_record_p)  ($buffer->{tag}));  ($buffer->{data_1}) = $t1( &ops,  ($the_ctype->{n1}), ( &tnf_record_p) ( ($buffer->{data_1})));  ($buffer->{data_2}) = $t2( &ops,  ($the_ctype->{n2}), ( &tnf_record_p) ( ($buffer->{data_2})));  ($buffer->{data_3}) = $t3( &ops,  ($the_ctype->{n3}), ( &tnf_record_p) ( ($buffer->{data_3})));  ($buffer->{data_4}) = $t4( &ops,  ($the_ctype->{n4}), ( &tnf_record_p) ( ($buffer->{data_4})));  ($buffer->{data_5}) = $t5( &ops,  ($the_ctype->{n5}), ( &tnf_record_p) ( ($buffer->{data_5})));  &return ( &tnf_ref32( &ops, ( &tnf_record_p)  &buffer,  &reference)); });
	}' unless defined(&TNF_DEFINE_RECORD_5);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_PROBE_0 {
	    my($namearg, $keysarg, $detail) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_0);
    } else {
	eval 'sub TNF_PROBE_0 {
	    my($namearg, $keysarg, $detail) = @_;
    	    eval q({ \'struct tnf_v_buf_0\' {  &tnf_probe_event_t  &probe_event;  &tnf_time_delta_t  &time_delta; };  &static  &tnf_tag_data_t **  &tnf_v_$namearg $_info[] = {  &tnf_probe_event_tag_data,  &tnf_time_delta_tag_data, 0};  &static \'struct tnf_probe_control\'  &tnf_v_$namearg &_probe = { & &__tnf_probe_version_1, ( &tnf_probe_control_t *)  &TNF_NEXT_INIT, ( &tnf_probe_test_func_t) 0, ( &tnf_probe_alloc_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_uint32_t) 0, \\"name \\"  &TNF_STRINGVALUE($namearg) \\";\\" \\"slots \\" \\";\\" \\"keys \\" $keysarg \\";\\" \\"file \\"  &__FILE__ \\";\\" \\"line \\"  &TNF_STRINGVALUE( &__LINE__) \\";\\" $detail,  &tnf_v_$namearg &_info, $sizeof{\'struct tnf_v_buf_0\'} };  &tnf_probe_control_t * &tnf_v_probe_p =  &tnf_v_$namearg &_probe;  &tnf_probe_test_func_t  &tnf_v_probe_test =  ($tnf_v_probe_p->{test_func});  &tnf_probe_setup_t  &tnf_v_set_p; \'struct tnf_v_buf_0\' * &tnf_v_probe_buffer;  &if ( &tnf_v_probe_test) {  &tnf_v_probe_buffer =   &tnf_v_probe_test(0,  &tnf_v_probe_p,  &tnf_v_set_p);  &if ( &tnf_v_probe_buffer) { ( ($tnf_v_probe_p->{probe_func}))( &tnf_v_set_p); } } });
	}' unless defined(&TNF_PROBE_0);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_PROBE_1 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_1);
    } else {
	eval 'sub TNF_PROBE_1 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1) = @_;
    	    eval q({ \'struct tnf_v_buf_1\' {  &tnf_probe_event_t  &probe_event;  &tnf_time_delta_t  &time_delta; $type_1 &_t  &data_1; };  &static  &tnf_tag_data_t **  &tnf_v_$namearg $_info[] = {  &tnf_probe_event_tag_data,  &tnf_time_delta_tag_data, $type_1 &_tag_data, 0};  &static \'struct tnf_probe_control\'  &tnf_v_$namearg &_probe = { & &__tnf_probe_version_1, ( &tnf_probe_control_t *)  &TNF_NEXT_INIT, ( &tnf_probe_test_func_t) 0, ( &tnf_probe_alloc_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_uint32_t) 0, \\"name \\"  &TNF_STRINGVALUE($namearg) \\";\\" \\"slots \\" \\"\\"$namearg_1\\" \\" \\";\\" \\"keys \\" $keysarg \\";\\" \\"file \\"  &__FILE__ \\";\\" \\"line \\"  &TNF_STRINGVALUE( &__LINE__) \\";\\" $detail,  &tnf_v_$namearg &_info, $sizeof{\'struct tnf_v_buf_1\'} };  &tnf_probe_control_t * &tnf_v_probe_p =  &tnf_v_$namearg &_probe;  &tnf_probe_test_func_t  &tnf_v_probe_test =  ($tnf_v_probe_p->{test_func});  &tnf_probe_setup_t  &tnf_v_set_p; \'struct tnf_v_buf_1\' * &tnf_v_probe_buffer;  &if ( &tnf_v_probe_test) {  &tnf_v_probe_buffer =   &tnf_v_probe_test(0,  &tnf_v_probe_p,  &tnf_v_set_p);  &if ( &tnf_v_probe_buffer) {  ($tnf_v_probe_buffer->{data_1}) = $type_1(  ($tnf_v_set_p->{tpd_p}), $valarg_1, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_1}))); ( ($tnf_v_probe_p->{probe_func}))( &tnf_v_set_p); } } });
	}' unless defined(&TNF_PROBE_1);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_PROBE_2 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_2);
    } else {
	eval 'sub TNF_PROBE_2 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2) = @_;
    	    eval q({ \'struct tnf_v_buf_2\' {  &tnf_probe_event_t  &probe_event;  &tnf_time_delta_t  &time_delta; $type_1 &_t  &data_1; $type_2 &_t  &data_2; };  &static  &tnf_tag_data_t **  &tnf_v_$namearg $_info[] = {  &tnf_probe_event_tag_data,  &tnf_time_delta_tag_data, $type_1 &_tag_data, $type_2 &_tag_data, 0};  &static \'struct tnf_probe_control\'  &tnf_v_$namearg &_probe = { & &__tnf_probe_version_1, ( &tnf_probe_control_t *)  &TNF_NEXT_INIT, ( &tnf_probe_test_func_t) 0, ( &tnf_probe_alloc_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_uint32_t) 0, \\"name \\"  &TNF_STRINGVALUE($namearg) \\";\\" \\"slots \\" \\"\\"$namearg_1\\" \\" \\"\\"$namearg_2\\" \\" \\";\\" \\"keys \\" $keysarg \\";\\" \\"file \\"  &__FILE__ \\";\\" \\"line \\"  &TNF_STRINGVALUE( &__LINE__) \\";\\" $detail,  &tnf_v_$namearg &_info, $sizeof{\'struct tnf_v_buf_2\'} };  &tnf_probe_control_t * &tnf_v_probe_p =  &tnf_v_$namearg &_probe;  &tnf_probe_test_func_t  &tnf_v_probe_test =  ($tnf_v_probe_p->{test_func});  &tnf_probe_setup_t  &tnf_v_set_p; \'struct tnf_v_buf_2\' * &tnf_v_probe_buffer;  &if ( &tnf_v_probe_test) {  &tnf_v_probe_buffer =   &tnf_v_probe_test(0,  &tnf_v_probe_p,  &tnf_v_set_p);  &if ( &tnf_v_probe_buffer) {  ($tnf_v_probe_buffer->{data_1}) = $type_1(  ($tnf_v_set_p->{tpd_p}), $valarg_1, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_1})));  ($tnf_v_probe_buffer->{data_2}) = $type_2(  ($tnf_v_set_p->{tpd_p}), $valarg_2, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_2}))); ( ($tnf_v_probe_p->{probe_func}))( &tnf_v_set_p); } } });
	}' unless defined(&TNF_PROBE_2);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_PROBE_3 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_3);
    } else {
	eval 'sub TNF_PROBE_3 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3) = @_;
    	    eval q({ \'struct tnf_v_buf_3\' {  &tnf_probe_event_t  &probe_event;  &tnf_time_delta_t  &time_delta; $type_1 &_t  &data_1; $type_2 &_t  &data_2; $type_3 &_t  &data_3; };  &static  &tnf_tag_data_t **  &tnf_v_$namearg $_info[] = {  &tnf_probe_event_tag_data,  &tnf_time_delta_tag_data, $type_1 &_tag_data, $type_2 &_tag_data, $type_3 &_tag_data, 0};  &static \'struct tnf_probe_control\'  &tnf_v_$namearg &_probe = { & &__tnf_probe_version_1, ( &tnf_probe_control_t *)  &TNF_NEXT_INIT, ( &tnf_probe_test_func_t) 0, ( &tnf_probe_alloc_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_uint32_t) 0, \\"name \\"  &TNF_STRINGVALUE($namearg) \\";\\" \\"slots \\" \\"\\"$namearg_1\\" \\" \\"\\"$namearg_2\\" \\" \\"\\"$namearg_3\\" \\" \\";\\" \\"keys \\" $keysarg \\";\\" \\"file \\"  &__FILE__ \\";\\" \\"line \\"  &TNF_STRINGVALUE( &__LINE__) \\";\\" $detail,  &tnf_v_$namearg &_info, $sizeof{\'struct tnf_v_buf_3\'} };  &tnf_probe_control_t * &tnf_v_probe_p =  &tnf_v_$namearg &_probe;  &tnf_probe_test_func_t  &tnf_v_probe_test =  ($tnf_v_probe_p->{test_func});  &tnf_probe_setup_t  &tnf_v_set_p; \'struct tnf_v_buf_3\' * &tnf_v_probe_buffer;  &if ( &tnf_v_probe_test) {  &tnf_v_probe_buffer =   &tnf_v_probe_test(0,  &tnf_v_probe_p,  &tnf_v_set_p);  &if ( &tnf_v_probe_buffer) {  ($tnf_v_probe_buffer->{data_1}) = $type_1(  ($tnf_v_set_p->{tpd_p}), $valarg_1, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_1})));  ($tnf_v_probe_buffer->{data_2}) = $type_2(  ($tnf_v_set_p->{tpd_p}), $valarg_2, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_2})));  ($tnf_v_probe_buffer->{data_3}) = $type_3(  ($tnf_v_set_p->{tpd_p}), $valarg_3, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_3}))); ( ($tnf_v_probe_p->{probe_func}))( &tnf_v_set_p); } } });
	}' unless defined(&TNF_PROBE_3);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_PROBE_4 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_4);
    } else {
	eval 'sub TNF_PROBE_4 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4) = @_;
    	    eval q({ \'struct tnf_v_buf_4\' {  &tnf_probe_event_t  &probe_event;  &tnf_time_delta_t  &time_delta; $type_1 &_t  &data_1; $type_2 &_t  &data_2; $type_3 &_t  &data_3; $type_4 &_t  &data_4; };  &static  &tnf_tag_data_t **  &tnf_v_$namearg $_info[] = {  &tnf_probe_event_tag_data,  &tnf_time_delta_tag_data, $type_1 &_tag_data, $type_2 &_tag_data, $type_3 &_tag_data, $type_4 &_tag_data, 0};  &static \'struct tnf_probe_control\'  &tnf_v_$namearg &_probe = { & &__tnf_probe_version_1, ( &tnf_probe_control_t *)  &TNF_NEXT_INIT, ( &tnf_probe_test_func_t) 0, ( &tnf_probe_alloc_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_uint32_t) 0, \\"name \\"  &TNF_STRINGVALUE($namearg) \\";\\" \\"slots \\" \\"\\"$namearg_1\\" \\" \\"\\"$namearg_2\\" \\" \\"\\"$namearg_3\\" \\" \\"\\"$namearg_4\\" \\" \\";\\" \\"keys \\" $keysarg \\";\\" \\"file \\"  &__FILE__ \\";\\" \\"line \\"  &TNF_STRINGVALUE( &__LINE__) \\";\\" $detail,  &tnf_v_$namearg &_info, $sizeof{\'struct tnf_v_buf_4\'} };  &tnf_probe_control_t * &tnf_v_probe_p =  &tnf_v_$namearg &_probe;  &tnf_probe_test_func_t  &tnf_v_probe_test =  ($tnf_v_probe_p->{test_func});  &tnf_probe_setup_t  &tnf_v_set_p; \'struct tnf_v_buf_4\' * &tnf_v_probe_buffer;  &if ( &tnf_v_probe_test) {  &tnf_v_probe_buffer =   &tnf_v_probe_test(0,  &tnf_v_probe_p,  &tnf_v_set_p);  &if ( &tnf_v_probe_buffer) {  ($tnf_v_probe_buffer->{data_1}) = $type_1(  ($tnf_v_set_p->{tpd_p}), $valarg_1, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_1})));  ($tnf_v_probe_buffer->{data_2}) = $type_2(  ($tnf_v_set_p->{tpd_p}), $valarg_2, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_2})));  ($tnf_v_probe_buffer->{data_3}) = $type_3(  ($tnf_v_set_p->{tpd_p}), $valarg_3, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_3})));  ($tnf_v_probe_buffer->{data_4}) = $type_4(  ($tnf_v_set_p->{tpd_p}), $valarg_4, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_4}))); ( ($tnf_v_probe_p->{probe_func}))( &tnf_v_set_p); } } });
	}' unless defined(&TNF_PROBE_4);
    }
    if(defined(&NPROBE)) {
	eval 'sub TNF_PROBE_5 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4, $type_5, $namearg_5, $valarg_5) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_5);
    } else {
	eval 'sub TNF_PROBE_5 {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4, $type_5, $namearg_5, $valarg_5) = @_;
    	    eval q({ \'struct tnf_v_buf_5\' {  &tnf_probe_event_t  &probe_event;  &tnf_time_delta_t  &time_delta; $type_1 &_t  &data_1; $type_2 &_t  &data_2; $type_3 &_t  &data_3; $type_4 &_t  &data_4; $type_5 &_t  &data_5; };  &static  &tnf_tag_data_t **  &tnf_v_$namearg $_info[] = {  &tnf_probe_event_tag_data,  &tnf_time_delta_tag_data, $type_1 &_tag_data, $type_2 &_tag_data, $type_3 &_tag_data, $type_4 &_tag_data, $type_5 &_tag_data, 0};  &static \'struct tnf_probe_control\'  &tnf_v_$namearg &_probe = { & &__tnf_probe_version_1, ( &tnf_probe_control_t *)  &TNF_NEXT_INIT, ( &tnf_probe_test_func_t) 0, ( &tnf_probe_alloc_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_probe_func_t) 0, ( &tnf_uint32_t) 0, \\"name \\"  &TNF_STRINGVALUE($namearg) \\";\\" \\"slots \\" \\"\\"$namearg_1\\" \\" \\"\\"$namearg_2\\" \\" \\"\\"$namearg_3\\" \\" \\"\\"$namearg_4\\" \\" \\"\\"$namearg_5\\" \\" \\";\\" \\"keys \\" $keysarg \\";\\" \\"file \\"  &__FILE__ \\";\\" \\"line \\"  &TNF_STRINGVALUE( &__LINE__) \\";\\" $detail,  &tnf_v_$namearg &_info, $sizeof{\'struct tnf_v_buf_5\'} };  &tnf_probe_control_t * &tnf_v_probe_p =  &tnf_v_$namearg &_probe;  &tnf_probe_test_func_t  &tnf_v_probe_test =  ($tnf_v_probe_p->{test_func});  &tnf_probe_setup_t  &tnf_v_set_p; \'struct tnf_v_buf_5\' * &tnf_v_probe_buffer;  &if ( &tnf_v_probe_test) {  &tnf_v_probe_buffer =   &tnf_v_probe_test(0,  &tnf_v_probe_p,  &tnf_v_set_p);  &if ( &tnf_v_probe_buffer) {  ($tnf_v_probe_buffer->{data_1}) = $type_1(  ($tnf_v_set_p->{tpd_p}), $valarg_1, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_1})));  ($tnf_v_probe_buffer->{data_2}) = $type_2(  ($tnf_v_set_p->{tpd_p}), $valarg_2, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_2})));  ($tnf_v_probe_buffer->{data_3}) = $type_3(  ($tnf_v_set_p->{tpd_p}), $valarg_3, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_3})));  ($tnf_v_probe_buffer->{data_4}) = $type_4(  ($tnf_v_set_p->{tpd_p}), $valarg_4, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_4})));  ($tnf_v_probe_buffer->{data_5}) = $type_5(  ($tnf_v_set_p->{tpd_p}), $valarg_5, ( &tnf_record_p) ( ($tnf_v_probe_buffer->{data_5}))); ( ($tnf_v_probe_p->{probe_func}))( &tnf_v_set_p); } } });
	}' unless defined(&TNF_PROBE_5);
    }
    if(defined( &TNF_DEBUG)) {
	eval 'sub TNF_PROBE_0_DEBUG {
	    my($namearg, $keysarg, $detail) = @_;
    	    eval q( &TNF_PROBE_0($namearg, $keysarg, \\"debug;\\" $detail));
	}' unless defined(&TNF_PROBE_0_DEBUG);
    } else {
	eval 'sub TNF_PROBE_0_DEBUG {
	    my($namearg, $keysarg, $detail) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_0_DEBUG);
    }
    if(defined( &TNF_DEBUG)) {
	eval 'sub TNF_PROBE_1_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1) = @_;
    	    eval q( &TNF_PROBE_1($namearg, $keysarg, \\"debug;\\" $detail, $type_1, $namearg_1, $valarg_1));
	}' unless defined(&TNF_PROBE_1_DEBUG);
    } else {
	eval 'sub TNF_PROBE_1_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_1_DEBUG);
    }
    if(defined( &TNF_DEBUG)) {
	eval 'sub TNF_PROBE_2_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2) = @_;
    	    eval q( &TNF_PROBE_2($namearg, $keysarg, \\"debug;\\" $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2));
	}' unless defined(&TNF_PROBE_2_DEBUG);
    } else {
	eval 'sub TNF_PROBE_2_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_2_DEBUG);
    }
    if(defined( &TNF_DEBUG)) {
	eval 'sub TNF_PROBE_3_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3) = @_;
    	    eval q( &TNF_PROBE_3($namearg, $keysarg, \\"debug;\\" $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3));
	}' unless defined(&TNF_PROBE_3_DEBUG);
    } else {
	eval 'sub TNF_PROBE_3_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_3_DEBUG);
    }
    if(defined( &TNF_DEBUG)) {
	eval 'sub TNF_PROBE_4_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4) = @_;
    	    eval q( &TNF_PROBE_4($namearg, $keysarg, \\"debug;\\" $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4));
	}' unless defined(&TNF_PROBE_4_DEBUG);
    } else {
	eval 'sub TNF_PROBE_4_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_4_DEBUG);
    }
    if(defined( &TNF_DEBUG)) {
	eval 'sub TNF_PROBE_5_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4, $type_5, $namearg_5, $valarg_5) = @_;
    	    eval q( &TNF_PROBE_5($namearg, $keysarg, \\"debug;\\" $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4, $type_5, $namearg_5, $valarg_5));
	}' unless defined(&TNF_PROBE_5_DEBUG);
    } else {
	eval 'sub TNF_PROBE_5_DEBUG {
	    my($namearg, $keysarg, $detail, $type_1, $namearg_1, $valarg_1, $type_2, $namearg_2, $valarg_2, $type_3, $namearg_3, $valarg_3, $type_4, $namearg_4, $valarg_4, $type_5, $namearg_5, $valarg_5) = @_;
    	    eval q((( &void)0));
	}' unless defined(&TNF_PROBE_5_DEBUG);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
