require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_TYPES_H)) {
    eval 'sub _SYS_TYPES_H () {1;}' unless defined(&_SYS_TYPES_H);
    require 'sys/isa_defs.ph';
    require 'sys/feature_tests.ph';
    require 'sys/machtypes.ph';
    if(defined(&_KERNEL)) {
	require 'sys/inttypes.ph';
    } else {
	require 'sys/int_types.ph';
    }
    if(defined( &_KERNEL) || defined( &_SYSCALL32)) {
	require 'sys/types32.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_NO_LONGLONG)) {
    } else {
    }
    if(defined( &_LP64) || defined( &_I32LPx)) {
    } else {
    }
    if(defined( &_ILP32) ) {
    }
 elsif(defined( &__ia64) ) {
    }
    unless(defined(&_PTRDIFF_T)) {
	eval 'sub _PTRDIFF_T () {1;}' unless defined(&_PTRDIFF_T);
	if(defined( &_LP64) || defined( &_I32LPx)) {
	} else {
	}
    }
    unless(defined(&_OFF_T)) {
	eval 'sub _OFF_T () {1;}' unless defined(&_OFF_T);
	if(defined( &_LP64) || (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 32) {
	}
 elsif((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) {
	}
	if(defined( &_LARGEFILE64_SOURCE)) {
	    if(defined(&_LP64)) {
	    } else {
	    }
	}
    }
    if(defined( &_LP64) || (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 32) {
    }
 elsif((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : 0) == 64) {
    }
    if(defined( &_LARGEFILE64_SOURCE)) {
	if(defined(&_LP64)) {
	} else {
	}
    }
    if(defined(&_LP64)) {
    } else {
    }
    if(defined( &_POSIX_C_SOURCE) || defined( &_XOPEN_SOURCE)) {
	eval("sub _B_FALSE () { 0; }") unless defined(&_B_FALSE);
	eval("sub _B_TRUE () { 1; }") unless defined(&_B_TRUE);
    } else {
	eval("sub B_FALSE () { 0; }") unless defined(&B_FALSE);
	eval("sub B_TRUE () { 1; }") unless defined(&B_TRUE);
    }
    if((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0 && !defined( &_NO_LONGLONG)) {
    } else {
    }
    if(defined(&_LONG_LONG_LTOH)) {
    }
    if(defined(&_LONG_LONG_HTOL)) {
    }
    if(defined(&_LONG_LONG_LTOH)) {
    }
    if(defined(&_LONG_LONG_HTOL)) {
    }
    if(defined( &_LP64) || defined( &_I32LPx)) {
    } else {
    }
    unless(defined(&_SUSECONDS_T)) {
	eval 'sub _SUSECONDS_T () {1;}' unless defined(&_SUSECONDS_T);
    }
    if(defined( &_LP64) || defined( &_I32LPx)) {
    } else {
    }
    if(defined( &_LP64) || defined( &_I32LPx)) {
    } else {
    }
    unless(defined(&_UID_T)) {
	eval 'sub _UID_T () {1;}' unless defined(&_UID_T);
	if(defined( &_LP64) || defined( &_I32LPx)) {
	} else {
	}
    }
    if(defined( &_LP64) || defined( &_I32LPx)) {
    } else {
    }
    unless(defined(&_SIZE_T)) {
	eval 'sub _SIZE_T () {1;}' unless defined(&_SIZE_T);
	if(defined( &_LP64) || defined( &_I32LPx)) {
	} else {
	}
    }
    unless(defined(&_SSIZE_T)) {
	eval 'sub _SSIZE_T () {1;}' unless defined(&_SSIZE_T);
	if(defined( &_LP64) || defined( &_I32LPx)) {
	} else {
	}
    }
    unless(defined(&_TIME_T)) {
	eval 'sub _TIME_T () {1;}' unless defined(&_TIME_T);
    }
    unless(defined(&_CLOCK_T)) {
	eval 'sub _CLOCK_T () {1;}' unless defined(&_CLOCK_T);
    }
    unless(defined(&_CLOCKID_T)) {
	eval 'sub _CLOCKID_T () {1;}' unless defined(&_CLOCKID_T);
    }
    unless(defined(&_TIMER_T)) {
	eval 'sub _TIMER_T () {1;}' unless defined(&_TIMER_T);
    }
    if(defined( &__EXTENSIONS__) || (!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE))) {
	if(defined( &_KERNEL)) {
	    eval 'sub SHRT_MIN () {(-32768);}' unless defined(&SHRT_MIN);
	    eval 'sub SHRT_MAX () {32767;}' unless defined(&SHRT_MAX);
	    eval 'sub USHRT_MAX () {65535;}' unless defined(&USHRT_MAX);
	    eval 'sub INT_MIN () {(-2147483647-1);}' unless defined(&INT_MIN);
	    eval 'sub INT_MAX () {2147483647;}' unless defined(&INT_MAX);
	    eval 'sub UINT_MAX () {4294967295;}' unless defined(&UINT_MAX);
	    if(defined( &_LP64)) {
		eval 'sub LONG_MIN () {(-9223372036854775807-1);}' unless defined(&LONG_MIN);
		eval 'sub LONG_MAX () {9223372036854775807;}' unless defined(&LONG_MAX);
		eval 'sub ULONG_MAX () {18446744073709551615;}' unless defined(&ULONG_MAX);
	    } else {
		eval 'sub LONG_MIN () {(-2147483647-1);}' unless defined(&LONG_MIN);
		eval 'sub LONG_MAX () {2147483647;}' unless defined(&LONG_MAX);
		eval 'sub ULONG_MAX () {4294967295;}' unless defined(&ULONG_MAX);
	    }
	}
	eval 'sub P_MYPID () {(( &pid_t)0);}' unless defined(&P_MYPID);
	eval 'sub P_MYID () {(-1);}' unless defined(&P_MYID);
	eval 'sub NOPID () {( &pid_t)(-1);}' unless defined(&NOPID);
	unless(defined(&NODEV)) {
	    eval 'sub NODEV () {( &dev_t)(-1);}' unless defined(&NODEV);
	    if(defined(&_SYSCALL32)) {
		eval 'sub NODEV32 () {( &dev32_t)(-1);}' unless defined(&NODEV32);
	    }
	}
	eval 'sub PFN_INVALID () {(( &pfn_t)-1);}' unless defined(&PFN_INVALID);
	require 'sys/select.ph';
    }
    eval 'sub _VOID () { &void;}' unless defined(&_VOID);
    if(defined(&__cplusplus)) {
    }
}
1;
