require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_USER_H)) {
    eval 'sub _SYS_USER_H () {1;}' unless defined(&_SYS_USER_H);
    require 'sys/types.ph';
    require 'sys/signal.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&__cplusplus)) {
    }
    if(defined( &_KERNEL) || defined( &_KMEMUSER)) {
	require 'sys/param.ph';
	require 'sys/pcb.ph';
	require 'sys/siginfo.ph';
	require 'sys/resource.ph';
	require 'sys/time.ph';
	require 'sys/auxv.ph';
	require 'sys/errno.ph';
	require 'sys/t_lock.ph';
	if(defined(&__cplusplus)) {
	}
	eval 'sub UF_ENTER {
	    my($ufp, $fip, $fd) = @_;
    	    eval q( &for (;;) {  &uf_entry_t * &_flist = ($fip)-> &fi_list; $ufp = & $_flist[$fd];  &ASSERT(($fd) < ($fip)-> &fi_nfiles);  &mutex_enter( ($ufp->{uf_lock}));  &if ( &_flist == ($fip)-> &fi_list)  &break;  &mutex_exit( ($ufp->{uf_lock})); });
	}' unless defined(&UF_ENTER);
	eval 'sub UF_EXIT {
	    my($ufp) = @_;
    	    eval q( &mutex_exit( ($ufp->{uf_lock})));
	}' unless defined(&UF_EXIT);
	eval 'sub PSARGSZ () {80;}' unless defined(&PSARGSZ);
	eval 'sub PSCOMSIZ () {14;}' unless defined(&PSCOMSIZ);
	eval 'sub MAXCOMLEN () {16;}' unless defined(&MAXCOMLEN);
	if(defined( &sparc) || defined( &__sparc)) {
	    eval 'sub __KERN_NAUXV_IMPL () {19;}' unless defined(&__KERN_NAUXV_IMPL);
	}
 elsif(defined( &i386) || defined( &__i386)) {
	    eval 'sub __KERN_NAUXV_IMPL () {21;}' unless defined(&__KERN_NAUXV_IMPL);
	}
 elsif(defined( &__ia64)) {
	    eval 'sub __KERN_NAUXV_IMPL () {21;}' unless defined(&__KERN_NAUXV_IMPL);
	}
	if(defined( &_LP64)) {
	} else {
	}
	if(defined( &i386) || defined( &__i386) || defined( &__ia64)) {
	}
	require 'sys/proc.ph';
	if(defined(&_KERNEL)) {
	    if(defined(&sun)) {
		eval 'sub u () {( ($curproc->{p_user}));}' unless defined(&u);
	    }
	    eval 'sub P_FINFO {
	        my($p) = @_;
    		eval q((($p)-> ($p_user->{u_finfo})));
	    }' unless defined(&P_FINFO);
	    eval 'sub UNLIMITED_CUR {
	        my($p, $type) = @_;
    		eval q(( &PTOU($p)-> ($u_rlimit[&(type)]->{rlim_cur}) ==  &RLIM64_INFINITY));
	    }' unless defined(&UNLIMITED_CUR);
	    if(defined( &_SYSCALL32_IMPL) || defined( &__lint)) {
		eval 'sub P_CURLIMIT {
		    my($p, $type) = @_;
    		    eval q( &p_curlimit(($p), ($type), ($p)-> &p_model));
		}' unless defined(&P_CURLIMIT);
		eval 'sub P_CURLIMIT32 {
		    my($p, $type) = @_;
    		    eval q( &p_curlimit(($p), ($type),  &DATAMODEL_ILP32));
		}' unless defined(&P_CURLIMIT32);
	    } else {
		eval 'sub P_CURLIMIT {
		    my($p, $type) = @_;
    		    eval q(( &UNLIMITED_CUR($p, $type) ?  $rlim_infinity_map[($type)] :  &PTOU($p)-> ($u_rlimit[&(type)]->{rlim_cur})));
		}' unless defined(&P_CURLIMIT);
		eval 'sub P_CURLIMIT32 {
		    my($p, $type) = @_;
    		    eval q( &P_CURLIMIT($p, $type));
		}' unless defined(&P_CURLIMIT32);
	    }
	}
	if(defined(&__cplusplus)) {
	}
    } else {
	require 'sys/regset.ph';
	if(defined(&__cplusplus)) {
	}
	eval 'sub PSARGSZ () {80;}' unless defined(&PSARGSZ);
	if(defined(&__cplusplus)) {
	}
    }
}
1;
