require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_VLAN_IMPL_H)) {
    eval 'sub _SYS_VLAN_IMPL_H () {1;}' unless defined(&_SYS_VLAN_IMPL_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub DB_BASE {
        my($mp) = @_;
	    eval q((($mp)-> ($b_datap->{db_base})));
    }' unless defined(&DB_BASE);
    eval 'sub DB_LIM {
        my($mp) = @_;
	    eval q((($mp)-> ($b_datap->{db_lim})));
    }' unless defined(&DB_LIM);
    eval 'sub DB_REF {
        my($mp) = @_;
	    eval q((($mp)-> ($b_datap->{db_ref})));
    }' unless defined(&DB_REF);
    eval 'sub DB_TYPE {
        my($mp) = @_;
	    eval q((($mp)-> ($b_datap->{db_type})));
    }' unless defined(&DB_TYPE);
    eval 'sub MBLKL {
        my($mp) = @_;
	    eval q((($mp)-> &b_wptr - ($mp)-> &b_rptr));
    }' unless defined(&MBLKL);
    eval 'sub MBLKSIZE {
        my($mp) = @_;
	    eval q((($mp)-> ($b_datap->{db_lim}) - ($mp)-> ($b_datap->{db_base})));
    }' unless defined(&MBLKSIZE);
    eval 'sub MBLKHEAD {
        my($mp) = @_;
	    eval q((($mp)-> &b_rptr - ($mp)-> ($b_datap->{db_base})));
    }' unless defined(&MBLKHEAD);
    eval 'sub MBLKTAIL {
        my($mp) = @_;
	    eval q(($mp)-> ($b_datap->{db_lim}) - ($mp)-> &b_wptr));
    }' unless defined(&MBLKTAIL);
    eval 'sub MBLKIN {
        my($mp, $off, $len) = @_;
	    eval q((($off <=  &MBLKL($mp))  && ((($mp)-> &b_rptr + $off + $len) <= ($mp)-> &b_wptr)));
    }' unless defined(&MBLKIN);
    eval 'sub OFFSET {
        my($base, $p) = @_;
	    eval q(( - ($base)));
    }' unless defined(&OFFSET);
    eval 'sub ether_bcopy {
        my($a, $b) = @_;
	    eval q(( &bcopy($a, $b, 6)));
    }' unless defined(&ether_bcopy);
    eval 'sub get_ether_type {
        my($ptr) = @_;
	    eval q(( ((( &uchar_t *)(( &eehp)$ptr)-> &ether_type)[0] << 8) | ((( &uchar_t *)(( &eehp)$ptr)-> &ether_type)[1])));
    }' unless defined(&get_ether_type);
    eval 'sub put_ether_type {
        my($ptr, $value) = @_;
	    eval q({ (( &uchar_t *)((( &eehp)$ptr)-> &ether_type))[0] = (( &uint_t)$value & 0xff00) >> 8; (( &uchar_t *)((( &eehp)$ptr)-> &ether_type))[1] = ($value & 0xff);});
    }' unless defined(&put_ether_type);
    eval 'sub vget_ether_type {
        my($ptr) = @_;
	    eval q(( ((( &uchar_t *)(( &veehp)$ptr)-> &ether_type)[0] << 8) | ((( &uchar_t *)(( &veehp)$ptr)-> &ether_type)[1])));
    }' unless defined(&vget_ether_type);
    eval 'sub vput_ether_type {
        my($ptr, $value) = @_;
	    eval q({ (( &uchar_t *)((( &veehp)$ptr)-> &ether_type))[0] = (( &uint_t)$value & 0xff00) >> 8; (( &uchar_t *)((( &veehp)$ptr)-> &ether_type))[1] = ($value & 0xff); });
    }' unless defined(&vput_ether_type);
    eval 'sub GET_VID_LIST {
        my($p) = @_;
	    eval q((( &vlan_vid_list_t *)(*(( &cptr)$p))));
    }' unless defined(&GET_VID_LIST);
    eval 'sub GET_VINFO_LIST {
        my($p) = @_;
	    eval q((( &vlan_info_handle_impl_t *)(*(( &cptr)$p))));
    }' unless defined(&GET_VINFO_LIST);
    eval 'sub PUT_VLAN_PTR1 {
        my($p, $value) = @_;
	    eval q(((*(( &cptr)$p)) = $value));
    }' unless defined(&PUT_VLAN_PTR1);
    eval 'sub PUT_VLAN_PTR {
        my($p, $value) = @_;
	    eval q(((*(( &cptr)$p)) = $value));
    }' unless defined(&PUT_VLAN_PTR);
    eval 'sub IS_VLAN_DEVICE {
        my($ptr) = @_;
	    eval q({  &vlan_stream_handle_impl_t * &vqptr;  &vqptr = ( &vlan_stream_handle_impl_t *)*$ptr;  &return ( ($vqptr->{vidlist}) !=  &NULL) });
    }' unless defined(&IS_VLAN_DEVICE);
    eval 'sub VID_IDLE () {0x;}' unless defined(&VID_IDLE);
    eval 'sub VID_INITIALIZED () {0x1;}' unless defined(&VID_INITIALIZED);
    eval 'sub VID_PENDING () {0x2;}' unless defined(&VID_PENDING);
    eval 'sub VID_GVRP_OK () {0x4;}' unless defined(&VID_GVRP_OK);
    eval 'sub VID_QOS_SET () {0x8;}' unless defined(&VID_QOS_SET);
    eval 'sub VID_SET_RAW () {0x10;}' unless defined(&VID_SET_RAW);
    eval 'sub VID_SET_ALLVIDS () {0x100;}' unless defined(&VID_SET_ALLVIDS);
    if(defined(&_LITTLE_ENDIAN)) {
	eval 'sub SET_ETHER_TYPE {
	    my($X) = @_;
    	    eval q(((($X >> 8) & 0xff) | ($X << 8)));
	}' unless defined(&SET_ETHER_TYPE);
    } else {
	eval 'sub SET_ETHER_TYPE {
	    my($X) = @_;
    	    eval q($X);
	}' unless defined(&SET_ETHER_TYPE);
    }
    if(defined(&HARDWARE)) {
    }
    if(defined(&HARDWARE)) {
    }
    eval 'sub DLSAPLEN () {(($sizeof{ &uint16_t} +  &ETHERADDRL));}' unless defined(&DLSAPLEN);
    eval 'sub DL_QOS_CL_SEL1_SIZE () {$sizeof{ &dl_qos_cl_sel1_t};}' unless defined(&DL_QOS_CL_SEL1_SIZE);
    eval 'sub DL_QOS_CL_RANG1_SIZE () {$sizeof{ &dl_qos_cl_range1_t};}' unless defined(&DL_QOS_CL_RANG1_SIZE);
    eval 'sub QOS_CL_SEL1_OFFSET () {( &DL_INFO_ACK_SIZE +  &DLSAPLEN +  &ETHERADDRL);}' unless defined(&QOS_CL_SEL1_OFFSET);
    eval 'sub OS_CL_RANG1_OFFSET () {( &DL_INFO_ACK_SIZE +  &DLSAPLEN +  &ETHERADDRL +  &DL_QOS_CL_SEL1_SIZE);}' unless defined(&OS_CL_RANG1_OFFSET);
    eval 'sub DL_PRIORITY_MAX () {100;}' unless defined(&DL_PRIORITY_MAX);
    eval 'sub DL_PRIORITY_MIN () {0;}' unless defined(&DL_PRIORITY_MIN);
    eval 'sub VLAN_PRIORITY_QUEUE_MAX () {4;}' unless defined(&VLAN_PRIORITY_QUEUE_MAX);
    eval 'sub VLAN_PRIORITY_QUEUE_HIGHEST () {0;}' unless defined(&VLAN_PRIORITY_QUEUE_HIGHEST);
    eval 'sub VLAN_PRIORITY_QUEUE_DEFAULT () {2;}' unless defined(&VLAN_PRIORITY_QUEUE_DEFAULT);
    eval 'sub VLAN_PRIORITY_QUEUE_LOWEST () {3;}' unless defined(&VLAN_PRIORITY_QUEUE_LOWEST);
    eval 'sub VLAN_VERSION_1 () {1;}' unless defined(&VLAN_VERSION_1);
    eval 'sub VLAN_VERSION () { &VLAN_VERSION_1;}' unless defined(&VLAN_VERSION);
    eval 'sub VLAN_VERSION_STRING () {"v1";}' unless defined(&VLAN_VERSION_STRING);
    eval 'sub VLAN_MAX_VIDS () {1024;}' unless defined(&VLAN_MAX_VIDS);
    eval 'sub VLAN_DEFAULT_VIDS () { &VLAN_MAX_VIDS;}' unless defined(&VLAN_DEFAULT_VIDS);
    eval 'sub VLAN_HASH_TABLE_SIZE () {1024;}' unless defined(&VLAN_HASH_TABLE_SIZE);
    eval 'sub VLAN_HASH_VLAN_SIZE () {16;}' unless defined(&VLAN_HASH_VLAN_SIZE);
    eval 'sub VLAN_VID_LIST_SIZE () {($sizeof{ &vlan_vid_list_t});}' unless defined(&VLAN_VID_LIST_SIZE);
    eval 'sub VLAN_LIST_HASH_TABLE_SIZE () {( &VLAN_HASH_VLAN_SIZE *  &VLAN_VID_LIST_SIZE);}' unless defined(&VLAN_LIST_HASH_TABLE_SIZE);
    eval 'sub VLAN_GET_HASH {
        my($vid) = @_;
	    eval q(((($vid >> 10) ^ ($vid & 0x3ff)) %  &VLAN_HASH_TABLE_SIZE));
    }' unless defined(&VLAN_GET_HASH);
    eval 'sub VLAN_GET_ETHER_TYPE {
        my($ptr) = @_;
	    eval q((($ptr +  &VLAN_TAG_SIZE))-> &ether_type);
    }' unless defined(&VLAN_GET_ETHER_TYPE);
    eval 'sub VLAN_GET_SUBS_SAP {
        my($ptr) = @_;
	    eval q(( &vlan_stream_handle_impl_t *) ($ptr->{subs_sap}););
    }' unless defined(&VLAN_GET_SUBS_SAP);
    eval 'sub IS_VLAN_ENABLED {
        my($ptr) = @_;
	    eval q({  &vlan_stream_handle_impl_t * &vqptr;  &vqptr = ( &vlan_stream_handle_impl_t *)*$ptr;  &if ( &vqptr ==  &NULL)  &return ( &FALSE);  &return ((( &vlan_stream_handle_impl_t *) ($vqptr->{vidlist}) !=  &NULL)); });
    }' unless defined(&IS_VLAN_ENABLED);
    eval("sub VLAN_NO_MSG () { 0; }") unless defined(&VLAN_NO_MSG);
    eval("sub VLAN_CON_MSG () { 1; }") unless defined(&VLAN_CON_MSG);
    eval("sub VLAN_BUF_MSG () { 2; }") unless defined(&VLAN_BUF_MSG);
    eval("sub VLAN_VERB_MSG () { 3; }") unless defined(&VLAN_VERB_MSG);
    eval("sub VLAN_LOG_MSG () { 4; }") unless defined(&VLAN_LOG_MSG);
    if(defined(&DEBUG)) {
	eval("sub NO_MSG () { 0; }") unless defined(&NO_MSG);
	eval("sub ALLOC_MSG () { 1; }") unless defined(&ALLOC_MSG);
	eval("sub REG_MSG () { 2; }") unless defined(&REG_MSG);
	eval("sub STREAMS_MSG () { 3; }") unless defined(&STREAMS_MSG);
	eval("sub IOCTL_MSG () { 4; }") unless defined(&IOCTL_MSG);
	eval("sub TX_MSG () { 5; }") unless defined(&TX_MSG);
	eval("sub RX_MSG () { 6; }") unless defined(&RX_MSG);
	eval("sub INFO_MSG () { 7; }") unless defined(&INFO_MSG);
	eval("sub KSTAT_MSG () { 8; }") unless defined(&KSTAT_MSG);
	eval("sub SUBS_MSG () { 9; }") unless defined(&SUBS_MSG);
	eval("sub SAP_REG_MSG () { 10; }") unless defined(&SAP_REG_MSG);
	eval 'sub VLAN_DEBUG_MSG1 {
	    my($t, $f, $a) = @_;
    	    eval q( &vlan_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a)););
	}' unless defined(&VLAN_DEBUG_MSG1);
	eval 'sub VLAN_DEBUG_MSG2 {
	    my($t, $f, $a, $b) = @_;
    	    eval q( &vlan_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b)););
	}' unless defined(&VLAN_DEBUG_MSG2);
	eval 'sub VLAN_DEBUG_MSG3 {
	    my($t, $f, $a, $b, $c) = @_;
    	    eval q( &vlan_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b), ($c)););
	}' unless defined(&VLAN_DEBUG_MSG3);
	eval 'sub VLAN_DEBUG_MSG4 {
	    my($t, $f, $a, $b, $c, $d) = @_;
    	    eval q( &vlan_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b), ($c), ($d)););
	}' unless defined(&VLAN_DEBUG_MSG4);
	eval 'sub VLAN_DEBUG_MSG5 {
	    my($t, $f, $a, $b, $c, $d, $e) = @_;
    	    eval q( &vlan_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b), ($c), ($d), ($e)););
	}' unless defined(&VLAN_DEBUG_MSG5);
	eval 'sub VLAN_DEBUG_MSG6 {
	    my($t, $f, $a, $b, $c, $d, $e, $g) = @_;
    	    eval q( &vlan_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b), ($c), ($d), ($e), ($g)););
	}' unless defined(&VLAN_DEBUG_MSG6);
	eval 'sub VLAN_DEBUG_MSG7 {
	    my($t, $f, $a, $b, $c, $d, $e, $g, $h) = @_;
    	    eval q( &vlan_debug_msg( &__FILE__,  &__LINE__, ($t), ($f), ($a), ($b), ($c), ($d), ($e), ($g), ($h)););
	}' unless defined(&VLAN_DEBUG_MSG7);
    } else {
	eval 'sub VLAN_DEBUG_MSG1 {
	    my($t, $f, $a) = @_;
    	    eval q();
	}' unless defined(&VLAN_DEBUG_MSG1);
	eval 'sub VLAN_DEBUG_MSG2 {
	    my($t, $f, $a, $b) = @_;
    	    eval q();
	}' unless defined(&VLAN_DEBUG_MSG2);
	eval 'sub VLAN_DEBUG_MSG3 {
	    my($t, $f, $a, $b, $c) = @_;
    	    eval q();
	}' unless defined(&VLAN_DEBUG_MSG3);
	eval 'sub VLAN_DEBUG_MSG4 {
	    my($t, $f, $a, $b, $c, $d) = @_;
    	    eval q();
	}' unless defined(&VLAN_DEBUG_MSG4);
	eval 'sub VLAN_DEBUG_MSG5 {
	    my($t, $f, $a, $b, $c, $d, $e) = @_;
    	    eval q();
	}' unless defined(&VLAN_DEBUG_MSG5);
	eval 'sub VLAN_DEBUG_MSG6 {
	    my($t, $f, $a, $b, $c, $d, $e, $g) = @_;
    	    eval q();
	}' unless defined(&VLAN_DEBUG_MSG6);
	eval 'sub VLAN_DEBUG_MSG7 {
	    my($t, $f, $a, $b, $c, $d, $e, $g, $h) = @_;
    	    eval q();
	}' unless defined(&VLAN_DEBUG_MSG7);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
