require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_VMEM_IMPL_H)) {
    eval 'sub _SYS_VMEM_IMPL_H () {1;}' unless defined(&_SYS_VMEM_IMPL_H);
    require 'sys/vmem.ph';
    require 'sys/kstat.ph';
    require 'sys/mutex.ph';
    require 'sys/condvar.ph';
    require 'sys/thread.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub VMEM_STACK_DEPTH () {20;}' unless defined(&VMEM_STACK_DEPTH);
    eval 'sub VS_SIZE {
        my($vsp) = @_;
	    eval q((($vsp)-> &vs_end - ($vsp)-> &vs_start));
    }' unless defined(&VS_SIZE);
    eval 'sub VMEM_HASH_INDEX {
        my($a, $s, $q, $m) = @_;
	    eval q((((($a) + (($a) >> ($s)) + (($a) >> (($s) << 1))) >> ($q)) & ($m)));
    }' unless defined(&VMEM_HASH_INDEX);
    eval 'sub VMEM_HASH {
        my($vmp, $addr) = @_;
	    eval q((($vmp)-> $vm_hash_table[ &VMEM_HASH_INDEX($addr, ($vmp)-> &vm_hash_shift, ($vmp)-> &vm_qshift, ($vmp)-> &vm_hash_mask)]));
    }' unless defined(&VMEM_HASH);
    eval 'sub VMEM_NAMELEN () {32;}' unless defined(&VMEM_NAMELEN);
    eval 'sub VMEM_HASH_INITIAL () {64;}' unless defined(&VMEM_HASH_INITIAL);
    eval 'sub VMEM_NQCACHE_MAX () {16;}' unless defined(&VMEM_NQCACHE_MAX);
    eval 'sub VMEM_FREELISTS () {($sizeof{ &void } * 8);}' unless defined(&VMEM_FREELISTS);
    if(defined(&__cplusplus)) {
    }
}
1;
