require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_VTRACE_H)) {
    eval 'sub _SYS_VTRACE_H () {1;}' unless defined(&_SYS_VTRACE_H);
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
	require 'sys/time.ph';
	if(defined(&_KERNEL)) {
	    require 'sys/cpuvar.ph';
	}
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub TR_FAC_TRACE () {0;}' unless defined(&TR_FAC_TRACE);
    eval 'sub TR_FAC_TEST () {1;}' unless defined(&TR_FAC_TEST);
    eval 'sub TR_FAC_TRAP () {2;}' unless defined(&TR_FAC_TRAP);
    eval 'sub TR_FAC_INTR () {3;}' unless defined(&TR_FAC_INTR);
    eval 'sub TR_FAC_SYSCALL () {4;}' unless defined(&TR_FAC_SYSCALL);
    eval 'sub TR_FAC_DISP () {5;}' unless defined(&TR_FAC_DISP);
    eval 'sub TR_FAC_VM () {6;}' unless defined(&TR_FAC_VM);
    eval 'sub TR_FAC_PROC () {7;}' unless defined(&TR_FAC_PROC);
    eval 'sub TR_FAC_LOCK () {8;}' unless defined(&TR_FAC_LOCK);
    eval 'sub TR_FAC_BCOPY () {9;}' unless defined(&TR_FAC_BCOPY);
    eval 'sub TR_FAC_KMEM () {10;}' unless defined(&TR_FAC_KMEM);
    eval 'sub TR_FAC_STREAMS_FR () {11;}' unless defined(&TR_FAC_STREAMS_FR);
    eval 'sub TR_FAC_STREAMS_MOD () {12;}' unless defined(&TR_FAC_STREAMS_MOD);
    eval 'sub TR_FAC_SOCKMOD () {13;}' unless defined(&TR_FAC_SOCKMOD);
    eval 'sub TR_FAC_TCP () {14;}' unless defined(&TR_FAC_TCP);
    eval 'sub TR_FAC_UDP () {15;}' unless defined(&TR_FAC_UDP);
    eval 'sub TR_FAC_IP () {16;}' unless defined(&TR_FAC_IP);
    eval 'sub TR_FAC_ARP () {17;}' unless defined(&TR_FAC_ARP);
    eval 'sub TR_FAC_LE () {18;}' unless defined(&TR_FAC_LE);
    eval 'sub TR_FAC_IPI () {19;}' unless defined(&TR_FAC_IPI);
    eval 'sub TR_FAC_SCSI () {21;}' unless defined(&TR_FAC_SCSI);
    eval 'sub TR_FAC_LWP () {22;}' unless defined(&TR_FAC_LWP);
    eval 'sub TR_FAC_SYS_LWP () {23;}' unless defined(&TR_FAC_SYS_LWP);
    eval 'sub TR_FAC_CALLOUT () {24;}' unless defined(&TR_FAC_CALLOUT);
    eval 'sub TR_FAC_SPECFS () {29;}' unless defined(&TR_FAC_SPECFS);
    eval 'sub TR_FAC_SWAPFS () {30;}' unless defined(&TR_FAC_SWAPFS);
    eval 'sub TR_FAC_TMPFS () {31;}' unless defined(&TR_FAC_TMPFS);
    eval 'sub TR_FAC_UFS () {32;}' unless defined(&TR_FAC_UFS);
    eval 'sub TR_FAC_NFS () {33;}' unless defined(&TR_FAC_NFS);
    eval 'sub TR_FAC_DDI () {35;}' unless defined(&TR_FAC_DDI);
    eval 'sub TR_FAC_KRPC () {36;}' unless defined(&TR_FAC_KRPC);
    eval 'sub TR_FAC_SCHED () {37;}' unless defined(&TR_FAC_SCHED);
    eval 'sub TR_FAC_SCSI_RES () {38;}' unless defined(&TR_FAC_SCSI_RES);
    eval 'sub TR_FAC_SCSI_ISP () {39;}' unless defined(&TR_FAC_SCSI_ISP);
    eval 'sub TR_FAC_IA () {40;}' unless defined(&TR_FAC_IA);
    eval 'sub TR_FAC_S5 () {41;}' unless defined(&TR_FAC_S5);
    eval 'sub TR_FAC_QE () {42;}' unless defined(&TR_FAC_QE);
    eval 'sub TR_FAC_BE () {43;}' unless defined(&TR_FAC_BE);
    eval 'sub TR_FAC_FIFO () {44;}' unless defined(&TR_FAC_FIFO);
    eval 'sub TR_FAC_RLOGINP () {45;}' unless defined(&TR_FAC_RLOGINP);
    eval 'sub TR_FAC_AE () {46;}' unless defined(&TR_FAC_AE);
    eval 'sub TR_FAC_PHYSIO () {47;}' unless defined(&TR_FAC_PHYSIO);
    eval 'sub TR_FAC_META () {48;}' unless defined(&TR_FAC_META);
    eval 'sub TR_FAC_SCSI_FAS () {49;}' unless defined(&TR_FAC_SCSI_FAS);
    eval 'sub TR_FAC_SOCKFS () {50;}' unless defined(&TR_FAC_SOCKFS);
    eval 'sub TR_FAC_DEVMAP () {51;}' unless defined(&TR_FAC_DEVMAP);
    eval 'sub TR_FAC_DADA () {52;}' unless defined(&TR_FAC_DADA);
    eval 'sub TR_END () {0;}' unless defined(&TR_END);
    eval 'sub TR_VERSION () {1;}' unless defined(&TR_VERSION);
    eval 'sub TR_TITLE () {2;}' unless defined(&TR_TITLE);
    eval 'sub TR_PAD () {3;}' unless defined(&TR_PAD);
    eval 'sub TR_LABEL () {4;}' unless defined(&TR_LABEL);
    eval 'sub TR_PAGESIZE () {5;}' unless defined(&TR_PAGESIZE);
    eval 'sub TR_NUM_CPUS () {6;}' unless defined(&TR_NUM_CPUS);
    eval 'sub TR_CPU () {7;}' unless defined(&TR_CPU);
    eval 'sub TR_DATA_4 () {8;}' unless defined(&TR_DATA_4);
    eval 'sub TR_DATA_8 () {9;}' unless defined(&TR_DATA_8);
    eval 'sub TR_DATA_16 () {10;}' unless defined(&TR_DATA_16);
    eval 'sub TR_DATA_32 () {11;}' unless defined(&TR_DATA_32);
    eval 'sub TR_DATA_64 () {12;}' unless defined(&TR_DATA_64);
    eval 'sub TR_ABS_TIME () {13;}' unless defined(&TR_ABS_TIME);
    eval 'sub TR_START_TIME () {14;}' unless defined(&TR_START_TIME);
    eval 'sub TR_ELAPSED_TIME () {15;}' unless defined(&TR_ELAPSED_TIME);
    eval 'sub TR_TOTAL_TIME () {16;}' unless defined(&TR_TOTAL_TIME);
    eval 'sub TR_KTHREAD_ID () {17;}' unless defined(&TR_KTHREAD_ID);
    eval 'sub TR_UTHREAD_ID () {18;}' unless defined(&TR_UTHREAD_ID);
    eval 'sub TR_CLOCK_FREQUENCY () {19;}' unless defined(&TR_CLOCK_FREQUENCY);
    eval 'sub TR_RAW_KTHREAD_ID () {64;}' unless defined(&TR_RAW_KTHREAD_ID);
    eval 'sub TR_RAW_UTHREAD_ID () {65;}' unless defined(&TR_RAW_UTHREAD_ID);
    eval 'sub TR_KTHREAD_LABEL () {66;}' unless defined(&TR_KTHREAD_LABEL);
    eval 'sub TR_UTHREAD_LABEL () {67;}' unless defined(&TR_UTHREAD_LABEL);
    eval 'sub TR_PROCESS_NAME () {68;}' unless defined(&TR_PROCESS_NAME);
    eval 'sub TR_PROCESS_FORK () {69;}' unless defined(&TR_PROCESS_FORK);
    eval 'sub TR_SPEED_0 () {0;}' unless defined(&TR_SPEED_0);
    eval 'sub TR_SPEED_1 () {1;}' unless defined(&TR_SPEED_1);
    eval 'sub TR_SPEED_1_STRING () {2;}' unless defined(&TR_SPEED_1_STRING);
    eval 'sub TR_SPEED_2 () {3;}' unless defined(&TR_SPEED_2);
    eval 'sub TR_SPEED_2_STRING () {4;}' unless defined(&TR_SPEED_2_STRING);
    eval 'sub TR_SPEED_3 () {5;}' unless defined(&TR_SPEED_3);
    eval 'sub TR_SPEED_3_STRING () {6;}' unless defined(&TR_SPEED_3_STRING);
    eval 'sub TR_SPEED_4 () {7;}' unless defined(&TR_SPEED_4);
    eval 'sub TR_SPEED_4_STRING () {8;}' unless defined(&TR_SPEED_4_STRING);
    eval 'sub TR_SPEED_5 () {9;}' unless defined(&TR_SPEED_5);
    eval 'sub TR_SPEED_5_STRING () {10;}' unless defined(&TR_SPEED_5_STRING);
    eval 'sub TR_TRACE_FLUSH_START () {11;}' unless defined(&TR_TRACE_FLUSH_START);
    eval 'sub TR_TRACE_FLUSH_END () {12;}' unless defined(&TR_TRACE_FLUSH_END);
    eval 'sub TR_TRACE_VN_WRITE_START () {13;}' unless defined(&TR_TRACE_VN_WRITE_START);
    eval 'sub TR_TRACE_VN_WRITE_END () {14;}' unless defined(&TR_TRACE_VN_WRITE_END);
    eval 'sub TR_TRAP_START () {0;}' unless defined(&TR_TRAP_START);
    eval 'sub TR_TRAP_END () {1;}' unless defined(&TR_TRAP_END);
    eval 'sub TR_KERNEL_WINDOW_OVERFLOW () {2;}' unless defined(&TR_KERNEL_WINDOW_OVERFLOW);
    eval 'sub TR_KERNEL_WINDOW_UNDERFLOW () {3;}' unless defined(&TR_KERNEL_WINDOW_UNDERFLOW);
    eval 'sub TR_USER_WINDOW_OVERFLOW () {4;}' unless defined(&TR_USER_WINDOW_OVERFLOW);
    eval 'sub TR_USER_WINDOW_UNDERFLOW () {5;}' unless defined(&TR_USER_WINDOW_UNDERFLOW);
    eval 'sub TR_C_TRAP_HANDLER_ENTER () {6;}' unless defined(&TR_C_TRAP_HANDLER_ENTER);
    eval 'sub TR_C_TRAP_HANDLER_EXIT () {7;}' unless defined(&TR_C_TRAP_HANDLER_EXIT);
    eval 'sub TR_INTR_START () {0;}' unless defined(&TR_INTR_START);
    eval 'sub TR_INTR_END () {1;}' unless defined(&TR_INTR_END);
    eval 'sub TR_INTR_EXIT () {2;}' unless defined(&TR_INTR_EXIT);
    eval 'sub TR_INTR_PASSIVATE () {3;}' unless defined(&TR_INTR_PASSIVATE);
    eval 'sub TR_SYSCALL_START () {0;}' unless defined(&TR_SYSCALL_START);
    eval 'sub TR_SYSCALL_END () {1;}' unless defined(&TR_SYSCALL_END);
    eval 'sub TR_DISP_START () {0;}' unless defined(&TR_DISP_START);
    eval 'sub TR_DISP_END () {1;}' unless defined(&TR_DISP_END);
    eval 'sub TR_SWTCH_START () {2;}' unless defined(&TR_SWTCH_START);
    eval 'sub TR_SWTCH_END () {3;}' unless defined(&TR_SWTCH_END);
    eval 'sub TR_PREEMPT_START () {4;}' unless defined(&TR_PREEMPT_START);
    eval 'sub TR_PREEMPT_END () {5;}' unless defined(&TR_PREEMPT_END);
    eval 'sub TR_RESUME_START () {6;}' unless defined(&TR_RESUME_START);
    eval 'sub TR_RESUME_END () {7;}' unless defined(&TR_RESUME_END);
    eval 'sub TR_FRONTQ () {8;}' unless defined(&TR_FRONTQ);
    eval 'sub TR_BACKQ () {9;}' unless defined(&TR_BACKQ);
    eval 'sub TR_CPU_RESCHED () {10;}' unless defined(&TR_CPU_RESCHED);
    eval 'sub TR_SLEEP () {11;}' unless defined(&TR_SLEEP);
    eval 'sub TR_TRAPRET () {12;}' unless defined(&TR_TRAPRET);
    eval 'sub TR_TICK () {13;}' unless defined(&TR_TICK);
    eval 'sub TR_UPDATE () {14;}' unless defined(&TR_UPDATE);
    eval 'sub TR_CPU_CHOOSE () {15;}' unless defined(&TR_CPU_CHOOSE);
    eval 'sub TR_CPU_SURRENDER () {16;}' unless defined(&TR_CPU_SURRENDER);
    eval 'sub TR_PREEMPT () {17;}' unless defined(&TR_PREEMPT);
    eval 'sub TR_PAGE_INIT () {0;}' unless defined(&TR_PAGE_INIT);
    eval 'sub TR_PAGE_WS_IN () {1;}' unless defined(&TR_PAGE_WS_IN);
    eval 'sub TR_PAGE_WS_OUT () {2;}' unless defined(&TR_PAGE_WS_OUT);
    eval 'sub TR_PAGE_WS_FREE () {3;}' unless defined(&TR_PAGE_WS_FREE);
    eval 'sub TR_PAGE_WS_RECLAIM () {4;}' unless defined(&TR_PAGE_WS_RECLAIM);
    eval 'sub TR_PAGEOUT_START () {5;}' unless defined(&TR_PAGEOUT_START);
    eval 'sub TR_PAGEOUT_END () {6;}' unless defined(&TR_PAGEOUT_END);
    eval 'sub TR_PAGEOUT_HAND_WRAP () {7;}' unless defined(&TR_PAGEOUT_HAND_WRAP);
    eval 'sub TR_PAGEOUT_MAXPGIO () {8;}' unless defined(&TR_PAGEOUT_MAXPGIO);
    eval 'sub TR_PAGEOUT_ISREF () {9;}' unless defined(&TR_PAGEOUT_ISREF);
    eval 'sub TR_PAGEOUT_FREE () {10;}' unless defined(&TR_PAGEOUT_FREE);
    eval 'sub TR_PAGEOUT_CV_SIGNAL () {11;}' unless defined(&TR_PAGEOUT_CV_SIGNAL);
    eval 'sub TR_HAT_SETMOD () {12;}' unless defined(&TR_HAT_SETMOD);
    eval 'sub TR_HAT_SETREF () {13;}' unless defined(&TR_HAT_SETREF);
    eval 'sub TR_HAT_SETREFMOD () {14;}' unless defined(&TR_HAT_SETREFMOD);
    eval 'sub TR_HAT_CLRMOD () {15;}' unless defined(&TR_HAT_CLRMOD);
    eval 'sub TR_HAT_CLRREF () {16;}' unless defined(&TR_HAT_CLRREF);
    eval 'sub TR_HAT_CLRREFMOD () {17;}' unless defined(&TR_HAT_CLRREFMOD);
    eval 'sub TR_HME_ADD () {18;}' unless defined(&TR_HME_ADD);
    eval 'sub TR_HME_SUB () {19;}' unless defined(&TR_HME_SUB);
    eval 'sub TR_SEGMAP_FAULT () {20;}' unless defined(&TR_SEGMAP_FAULT);
    eval 'sub TR_SEGMAP_GETMAP () {21;}' unless defined(&TR_SEGMAP_GETMAP);
    eval 'sub TR_SEGMAP_RELMAP () {22;}' unless defined(&TR_SEGMAP_RELMAP);
    eval 'sub TR_SEGMAP_PAGECREATE () {23;}' unless defined(&TR_SEGMAP_PAGECREATE);
    eval 'sub TR_SEGMAP_GETPAGE () {24;}' unless defined(&TR_SEGMAP_GETPAGE);
    eval 'sub TR_SEGVN_FAULT () {25;}' unless defined(&TR_SEGVN_FAULT);
    eval 'sub TR_SEGVN_GETPAGE () {26;}' unless defined(&TR_SEGVN_GETPAGE);
    eval 'sub TR_ANON_GETPAGE () {27;}' unless defined(&TR_ANON_GETPAGE);
    eval 'sub TR_ANON_PRIVATE () {28;}' unless defined(&TR_ANON_PRIVATE);
    eval 'sub TR_SEGKMEM_ALLOC () {29;}' unless defined(&TR_SEGKMEM_ALLOC);
    eval 'sub TR_SWAP_ALLOC () {30;}' unless defined(&TR_SWAP_ALLOC);
    eval 'sub TR_PVN_READ_KLUSTER () {31;}' unless defined(&TR_PVN_READ_KLUSTER);
    eval 'sub TR_PVN_GETDIRTY () {32;}' unless defined(&TR_PVN_GETDIRTY);
    eval 'sub TR_PAGE_CREATE_START () {33;}' unless defined(&TR_PAGE_CREATE_START);
    eval 'sub TR_PAGE_CREATE_TOOBIG () {34;}' unless defined(&TR_PAGE_CREATE_TOOBIG);
    eval 'sub TR_PAGE_CREATE_NOMEM () {35;}' unless defined(&TR_PAGE_CREATE_NOMEM);
    eval 'sub TR_PAGE_CREATE_SUCCESS () {36;}' unless defined(&TR_PAGE_CREATE_SUCCESS);
    eval 'sub TR_PAGE_CREATE_SLEEP_START () {37;}' unless defined(&TR_PAGE_CREATE_SLEEP_START);
    eval 'sub TR_PAGE_CREATE_SLEEP_END () {38;}' unless defined(&TR_PAGE_CREATE_SLEEP_END);
    eval 'sub TR_PAGE_CREATE_ALLOC () {39;}' unless defined(&TR_PAGE_CREATE_ALLOC);
    eval 'sub TR_PAGE_FREE_FREE () {40;}' unless defined(&TR_PAGE_FREE_FREE);
    eval 'sub TR_PAGE_FREE_CACHE_HEAD () {41;}' unless defined(&TR_PAGE_FREE_CACHE_HEAD);
    eval 'sub TR_PAGE_FREE_CACHE_TAIL () {42;}' unless defined(&TR_PAGE_FREE_CACHE_TAIL);
    eval 'sub TR_PAGE_UNFREE_FREE () {43;}' unless defined(&TR_PAGE_UNFREE_FREE);
    eval 'sub TR_PAGE_UNFREE_CACHE () {44;}' unless defined(&TR_PAGE_UNFREE_CACHE);
    eval 'sub TR_PAGE_DESTROY () {45;}' unless defined(&TR_PAGE_DESTROY);
    eval 'sub TR_PAGE_HASHIN () {46;}' unless defined(&TR_PAGE_HASHIN);
    eval 'sub TR_PAGE_HASHOUT () {47;}' unless defined(&TR_PAGE_HASHOUT);
    eval 'sub TR_ANON_PROC () {48;}' unless defined(&TR_ANON_PROC);
    eval 'sub TR_ANON_SHM () {49;}' unless defined(&TR_ANON_SHM);
    eval 'sub TR_ANON_TMPFS () {50;}' unless defined(&TR_ANON_TMPFS);
    eval 'sub TR_ANON_SWAP () {51;}' unless defined(&TR_ANON_SWAP);
    eval 'sub TR_ANON_EXEC () {52;}' unless defined(&TR_ANON_EXEC);
    eval 'sub TR_ANON_SEGKP () {53;}' unless defined(&TR_ANON_SEGKP);
    eval 'sub TR_SAMPLE_REF () {54;}' unless defined(&TR_SAMPLE_REF);
    eval 'sub TR_SAMPLE_MOD () {55;}' unless defined(&TR_SAMPLE_MOD);
    eval 'sub TR_SAMPLE_WS_START () {56;}' unless defined(&TR_SAMPLE_WS_START);
    eval 'sub TR_SAMPLE_WS_END () {57;}' unless defined(&TR_SAMPLE_WS_END);
    eval 'sub TR_KAS_INFO () {58;}' unless defined(&TR_KAS_INFO);
    eval 'sub TR_AS_INFO () {59;}' unless defined(&TR_AS_INFO);
    eval 'sub TR_SEG_INFO () {60;}' unless defined(&TR_SEG_INFO);
    eval 'sub TR_PAGE_RENAME () {61;}' unless defined(&TR_PAGE_RENAME);
    eval 'sub TR_SWAP_RENAME () {62;}' unless defined(&TR_SWAP_RENAME);
    eval 'sub TR_PROC_EXEC () {0;}' unless defined(&TR_PROC_EXEC);
    eval 'sub TR_PROC_EXIT () {1;}' unless defined(&TR_PROC_EXIT);
    eval 'sub TR_PROC_FORK () {2;}' unless defined(&TR_PROC_FORK);
    eval 'sub TR_EXECMAP_PREREAD () {3;}' unless defined(&TR_EXECMAP_PREREAD);
    eval 'sub TR_EXECMAP_NO_PREREAD () {4;}' unless defined(&TR_EXECMAP_NO_PREREAD);
    eval 'sub TR_SWAPIN () {0;}' unless defined(&TR_SWAPIN);
    eval 'sub TR_SWAPOUT () {1;}' unless defined(&TR_SWAPOUT);
    eval 'sub TR_RUNIN () {2;}' unless defined(&TR_RUNIN);
    eval 'sub TR_RUNOUT () {3;}' unless defined(&TR_RUNOUT);
    eval 'sub TR_CHOOSE_SWAPOUT () {4;}' unless defined(&TR_CHOOSE_SWAPOUT);
    eval 'sub TR_CHOOSE_SWAPIN () {5;}' unless defined(&TR_CHOOSE_SWAPIN);
    eval 'sub TR_SOFTSWAP () {6;}' unless defined(&TR_SOFTSWAP);
    eval 'sub TR_HARDSWAP () {7;}' unless defined(&TR_HARDSWAP);
    eval 'sub TR_DESPERATE () {8;}' unless defined(&TR_DESPERATE);
    eval 'sub TR_HIGH_DEFICIT () {9;}' unless defined(&TR_HIGH_DEFICIT);
    eval 'sub TR_SWAPIN_VALUES () {10;}' unless defined(&TR_SWAPIN_VALUES);
    eval 'sub TR_UNLOAD () {11;}' unless defined(&TR_UNLOAD);
    eval 'sub TR_SWAPOUT_LWP () {12;}' unless defined(&TR_SWAPOUT_LWP);
    eval 'sub TR_SWAPQ_LWP () {13;}' unless defined(&TR_SWAPQ_LWP);
    eval 'sub TR_SWAPQ_PROC () {14;}' unless defined(&TR_SWAPQ_PROC);
    eval 'sub TR_RW_ENTER_RD_START () {0;}' unless defined(&TR_RW_ENTER_RD_START);
    eval 'sub TR_RW_ENTER_RD_END () {1;}' unless defined(&TR_RW_ENTER_RD_END);
    eval 'sub TR_RW_ENTER_WR_START () {2;}' unless defined(&TR_RW_ENTER_WR_START);
    eval 'sub TR_RW_ENTER_WR_END () {3;}' unless defined(&TR_RW_ENTER_WR_END);
    eval 'sub TR_RW_EXIT_START () {4;}' unless defined(&TR_RW_EXIT_START);
    eval 'sub TR_RW_EXIT_END () {5;}' unless defined(&TR_RW_EXIT_END);
    eval 'sub TR_BCOPY_START () {0;}' unless defined(&TR_BCOPY_START);
    eval 'sub TR_KCOPY_START () {1;}' unless defined(&TR_KCOPY_START);
    eval 'sub TR_PGCOPY_START () {2;}' unless defined(&TR_PGCOPY_START);
    eval 'sub TR_COPYOUT_START () {3;}' unless defined(&TR_COPYOUT_START);
    eval 'sub TR_COPYIN_START () {4;}' unless defined(&TR_COPYIN_START);
    eval 'sub TR_COPY_END () {5;}' unless defined(&TR_COPY_END);
    eval 'sub TR_COPY_FAULT () {6;}' unless defined(&TR_COPY_FAULT);
    eval 'sub TR_COPYOUT_FAULT () {7;}' unless defined(&TR_COPYOUT_FAULT);
    eval 'sub TR_COPYIN_FAULT () {8;}' unless defined(&TR_COPYIN_FAULT);
    eval 'sub TR_COPYIN_NOERR_START () {9;}' unless defined(&TR_COPYIN_NOERR_START);
    eval 'sub TR_COPYOUT_NOERR_START () {10;}' unless defined(&TR_COPYOUT_NOERR_START);
    eval 'sub TR_KMEM_ALLOC_START () {0;}' unless defined(&TR_KMEM_ALLOC_START);
    eval 'sub TR_KMEM_ALLOC_END () {1;}' unless defined(&TR_KMEM_ALLOC_END);
    eval 'sub TR_KMEM_ZALLOC_START () {2;}' unless defined(&TR_KMEM_ZALLOC_START);
    eval 'sub TR_KMEM_ZALLOC_END () {3;}' unless defined(&TR_KMEM_ZALLOC_END);
    eval 'sub TR_KMEM_FREE_START () {4;}' unless defined(&TR_KMEM_FREE_START);
    eval 'sub TR_KMEM_FREE_END () {5;}' unless defined(&TR_KMEM_FREE_END);
    eval 'sub TR_KMEM_CACHE_ALLOC_START () {12;}' unless defined(&TR_KMEM_CACHE_ALLOC_START);
    eval 'sub TR_KMEM_CACHE_ALLOC_END () {13;}' unless defined(&TR_KMEM_CACHE_ALLOC_END);
    eval 'sub TR_KMEM_CACHE_FREE_START () {14;}' unless defined(&TR_KMEM_CACHE_FREE_START);
    eval 'sub TR_KMEM_CACHE_FREE_END () {15;}' unless defined(&TR_KMEM_CACHE_FREE_END);
    eval 'sub TR_KMEM_SLAB_CREATE_START () {16;}' unless defined(&TR_KMEM_SLAB_CREATE_START);
    eval 'sub TR_KMEM_SLAB_CREATE_END () {17;}' unless defined(&TR_KMEM_SLAB_CREATE_END);
    eval 'sub TR_KMEM_SLAB_DESTROY_START () {18;}' unless defined(&TR_KMEM_SLAB_DESTROY_START);
    eval 'sub TR_KMEM_SLAB_DESTROY_END () {19;}' unless defined(&TR_KMEM_SLAB_DESTROY_END);
    eval 'sub TR_KMEM_GETPAGES_START () {20;}' unless defined(&TR_KMEM_GETPAGES_START);
    eval 'sub TR_KMEM_GETPAGES_END () {21;}' unless defined(&TR_KMEM_GETPAGES_END);
    eval 'sub TR_KMEM_FREEPAGES_START () {22;}' unless defined(&TR_KMEM_FREEPAGES_START);
    eval 'sub TR_KMEM_FREEPAGES_END () {23;}' unless defined(&TR_KMEM_FREEPAGES_END);
    eval 'sub TR_KMEM_ASYNC_DISPATCH_START () {24;}' unless defined(&TR_KMEM_ASYNC_DISPATCH_START);
    eval 'sub TR_KMEM_ASYNC_DISPATCH_END () {25;}' unless defined(&TR_KMEM_ASYNC_DISPATCH_END);
    eval 'sub TR_KMEM_ASYNC_SERVICE_START () {26;}' unless defined(&TR_KMEM_ASYNC_SERVICE_START);
    eval 'sub TR_KMEM_ASYNC_SERVICE_END () {27;}' unless defined(&TR_KMEM_ASYNC_SERVICE_END);
    eval 'sub TR_KMEM_HASH_RESCALE_START () {28;}' unless defined(&TR_KMEM_HASH_RESCALE_START);
    eval 'sub TR_KMEM_HASH_RESCALE_END () {29;}' unless defined(&TR_KMEM_HASH_RESCALE_END);
    eval 'sub TR_STROPEN () {0;}' unless defined(&TR_STROPEN);
    eval 'sub TR_STRCLOSE () {1;}' unless defined(&TR_STRCLOSE);
    eval 'sub TR_STRCLEAN () {2;}' unless defined(&TR_STRCLEAN);
    eval 'sub TR_STRREAD_ENTER () {3;}' unless defined(&TR_STRREAD_ENTER);
    eval 'sub TR_STRREAD_WAIT () {4;}' unless defined(&TR_STRREAD_WAIT);
    eval 'sub TR_STRREAD_DONE () {5;}' unless defined(&TR_STRREAD_DONE);
    eval 'sub TR_STRREAD_AWAKE () {6;}' unless defined(&TR_STRREAD_AWAKE);
    eval 'sub TR_STRRPUT_ENTER () {7;}' unless defined(&TR_STRRPUT_ENTER);
    eval 'sub TR_STRRPUT_PROTERR () {8;}' unless defined(&TR_STRRPUT_PROTERR);
    eval 'sub TR_STRRPUT_WAKE () {9;}' unless defined(&TR_STRRPUT_WAKE);
    eval 'sub TR_STRRPUT_WAKE2 () {10;}' unless defined(&TR_STRRPUT_WAKE2);
    eval 'sub TR_STRWSRV () {11;}' unless defined(&TR_STRWSRV);
    eval 'sub TR_IOCTL_ENTER () {12;}' unless defined(&TR_IOCTL_ENTER);
    eval 'sub TR_I_CANT_FIND () {13;}' unless defined(&TR_I_CANT_FIND);
    eval 'sub TR_I_PUSH () {14;}' unless defined(&TR_I_PUSH);
    eval 'sub TR_I_POP () {15;}' unless defined(&TR_I_POP);
    eval 'sub TR_I_LINK () {16;}' unless defined(&TR_I_LINK);
    eval 'sub TR_STPDOWN () {17;}' unless defined(&TR_STPDOWN);
    eval 'sub TR_I_UNLINK () {18;}' unless defined(&TR_I_UNLINK);
    eval 'sub TR_STRDOIOCTL () {19;}' unless defined(&TR_STRDOIOCTL);
    eval 'sub TR_STRDOIOCTL_WAIT () {20;}' unless defined(&TR_STRDOIOCTL_WAIT);
    eval 'sub TR_STRDOIOCTL_PUT () {21;}' unless defined(&TR_STRDOIOCTL_PUT);
    eval 'sub TR_STRDOIOCTL_WAIT2 () {22;}' unless defined(&TR_STRDOIOCTL_WAIT2);
    eval 'sub TR_STRDOIOCTL_ACK () {23;}' unless defined(&TR_STRDOIOCTL_ACK);
    eval 'sub TR_STRSENDSIG () {24;}' unless defined(&TR_STRSENDSIG);
    eval 'sub TR_QATTACH_FLAGS () {25;}' unless defined(&TR_QATTACH_FLAGS);
    eval 'sub TR_STRTIME () {26;}' unless defined(&TR_STRTIME);
    eval 'sub TR_STR2TIME () {27;}' unless defined(&TR_STR2TIME);
    eval 'sub TR_STR3TIME () {28;}' unless defined(&TR_STR3TIME);
    eval 'sub TR_STRWAITQ_TIME () {31;}' unless defined(&TR_STRWAITQ_TIME);
    eval 'sub TR_STRWAITQ_WAIT2 () {32;}' unless defined(&TR_STRWAITQ_WAIT2);
    eval 'sub TR_STRWAITQ_INTR2 () {33;}' unless defined(&TR_STRWAITQ_INTR2);
    eval 'sub TR_STRWAITQ_WAKE2 () {34;}' unless defined(&TR_STRWAITQ_WAKE2);
    eval 'sub TR_QRUN_START () {35;}' unless defined(&TR_QRUN_START);
    eval 'sub TR_QRUN_DONE () {36;}' unless defined(&TR_QRUN_DONE);
    eval 'sub TR_DQ_SERVICE () {37;}' unless defined(&TR_DQ_SERVICE);
    eval 'sub TR_RMV_QP () {38;}' unless defined(&TR_RMV_QP);
    eval 'sub TR_QRUNSERVICE_START () {39;}' unless defined(&TR_QRUNSERVICE_START);
    eval 'sub TR_BACKGROUND_DQ () {40;}' unless defined(&TR_BACKGROUND_DQ);
    eval 'sub TR_BACKGROUND_DONE () {41;}' unless defined(&TR_BACKGROUND_DONE);
    eval 'sub TR_SENDSIG () {42;}' unless defined(&TR_SENDSIG);
    eval 'sub TR_INSERTQ () {43;}' unless defined(&TR_INSERTQ);
    eval 'sub TR_REMOVEQ () {44;}' unless defined(&TR_REMOVEQ);
    eval 'sub TR_DRAIN_SYNCQ_PUT () {45;}' unless defined(&TR_DRAIN_SYNCQ_PUT);
    eval 'sub TR_FILL_SYNCQ () {46;}' unless defined(&TR_FILL_SYNCQ);
    eval 'sub TR_CANPUT_IN () {47;}' unless defined(&TR_CANPUT_IN);
    eval 'sub TR_CANPUT_OUT () {48;}' unless defined(&TR_CANPUT_OUT);
    eval 'sub TR_BCANPUT_IN () {49;}' unless defined(&TR_BCANPUT_IN);
    eval 'sub TR_BCANPUT_OUT () {50;}' unless defined(&TR_BCANPUT_OUT);
    eval 'sub TR_STRWRITE_IN () {51;}' unless defined(&TR_STRWRITE_IN);
    eval 'sub TR_STRWRITE_OUT () {52;}' unless defined(&TR_STRWRITE_OUT);
    eval 'sub TR_STRWRITE_WAIT () {53;}' unless defined(&TR_STRWRITE_WAIT);
    eval 'sub TR_STRWRITE_WAKE () {54;}' unless defined(&TR_STRWRITE_WAKE);
    eval 'sub TR_STRWRITE_PUT () {55;}' unless defined(&TR_STRWRITE_PUT);
    eval 'sub TR_STRWRITE_RESID () {56;}' unless defined(&TR_STRWRITE_RESID);
    eval 'sub TR_STRPUTMSG_IN () {57;}' unless defined(&TR_STRPUTMSG_IN);
    eval 'sub TR_STRPUTMSG_WAIT () {58;}' unless defined(&TR_STRPUTMSG_WAIT);
    eval 'sub TR_STRPUTMSG_WAKE () {59;}' unless defined(&TR_STRPUTMSG_WAKE);
    eval 'sub TR_STRPUTMSG_OUT () {60;}' unless defined(&TR_STRPUTMSG_OUT);
    eval 'sub TR_QENABLE () {61;}' unless defined(&TR_QENABLE);
    eval 'sub TR_QRUNFLAG () {62;}' unless defined(&TR_QRUNFLAG);
    eval 'sub TR_RUNQUEUES () {63;}' unless defined(&TR_RUNQUEUES);
    eval 'sub TR_QRUN_DQ () {64;}' unless defined(&TR_QRUN_DQ);
    eval 'sub TR_QRUNSERVICE_END () {65;}' unless defined(&TR_QRUNSERVICE_END);
    eval 'sub TR_BACKGROUND_AWAKE () {66;}' unless defined(&TR_BACKGROUND_AWAKE);
    eval 'sub TR_QRUN_LEAVES () {67;}' unless defined(&TR_QRUN_LEAVES);
    eval 'sub TR_PUT_START () {68;}' unless defined(&TR_PUT_START);
    eval 'sub TR_PUT_END () {69;}' unless defined(&TR_PUT_END);
    eval 'sub TR_PUTNEXT_START () {70;}' unless defined(&TR_PUTNEXT_START);
    eval 'sub TR_PUTNEXT_END () {71;}' unless defined(&TR_PUTNEXT_END);
    eval 'sub TR_DRAIN_SYNCQ_START () {72;}' unless defined(&TR_DRAIN_SYNCQ_START);
    eval 'sub TR_DRAIN_SYNCQ_END () {73;}' unless defined(&TR_DRAIN_SYNCQ_END);
    eval 'sub TR_STRGETMSG_ENTER () {74;}' unless defined(&TR_STRGETMSG_ENTER);
    eval 'sub TR_STRGETMSG_WAIT () {75;}' unless defined(&TR_STRGETMSG_WAIT);
    eval 'sub TR_STRGETMSG_DONE () {76;}' unless defined(&TR_STRGETMSG_DONE);
    eval 'sub TR_STRGETMSG_AWAKE () {77;}' unless defined(&TR_STRGETMSG_AWAKE);
    eval 'sub TR_KSTRGETMSG_ENTER () {78;}' unless defined(&TR_KSTRGETMSG_ENTER);
    eval 'sub TR_KSTRGETMSG_WAIT () {79;}' unless defined(&TR_KSTRGETMSG_WAIT);
    eval 'sub TR_KSTRGETMSG_DONE () {80;}' unless defined(&TR_KSTRGETMSG_DONE);
    eval 'sub TR_KSTRGETMSG_AWAKE () {81;}' unless defined(&TR_KSTRGETMSG_AWAKE);
    eval 'sub TR_KSTRPUTMSG_IN () {82;}' unless defined(&TR_KSTRPUTMSG_IN);
    eval 'sub TR_KSTRPUTMSG_WAIT () {83;}' unless defined(&TR_KSTRPUTMSG_WAIT);
    eval 'sub TR_KSTRPUTMSG_WAKE () {84;}' unless defined(&TR_KSTRPUTMSG_WAKE);
    eval 'sub TR_KSTRPUTMSG_OUT () {85;}' unless defined(&TR_KSTRPUTMSG_OUT);
    eval 'sub TR_CANPUTNEXT_IN () {86;}' unless defined(&TR_CANPUTNEXT_IN);
    eval 'sub TR_CANPUTNEXT_OUT () {87;}' unless defined(&TR_CANPUTNEXT_OUT);
    eval 'sub TR_MI_TIMER_RSRV_IN () {0;}' unless defined(&TR_MI_TIMER_RSRV_IN);
    eval 'sub TR_MI_TIMER_RSRV_OUT () {1;}' unless defined(&TR_MI_TIMER_RSRV_OUT);
    eval 'sub TR_MI_TIMER_FIRE () {2;}' unless defined(&TR_MI_TIMER_FIRE);
    eval 'sub TR_MCOPYMSG () {3;}' unless defined(&TR_MCOPYMSG);
    eval 'sub TR_SOCKMOD_RPUT_IN () {0;}' unless defined(&TR_SOCKMOD_RPUT_IN);
    eval 'sub TR_SOCKMOD_RPUT_OUT () {1;}' unless defined(&TR_SOCKMOD_RPUT_OUT);
    eval 'sub TR_SOCKMOD_WPUT_IN () {2;}' unless defined(&TR_SOCKMOD_WPUT_IN);
    eval 'sub TR_SOCKMOD_WPUT_OUT () {3;}' unless defined(&TR_SOCKMOD_WPUT_OUT);
    eval 'sub TR_SOCKMOD_RSRV_IN () {4;}' unless defined(&TR_SOCKMOD_RSRV_IN);
    eval 'sub TR_SOCKMOD_RSRV_OUT () {5;}' unless defined(&TR_SOCKMOD_RSRV_OUT);
    eval 'sub TR_SOCKMOD_WSRV_IN () {6;}' unless defined(&TR_SOCKMOD_WSRV_IN);
    eval 'sub TR_SOCKMOD_WSRV_OUT () {7;}' unless defined(&TR_SOCKMOD_WSRV_OUT);
    eval 'sub TR_TCP_OPEN () {0;}' unless defined(&TR_TCP_OPEN);
    eval 'sub TR_TCP_CLOSE () {1;}' unless defined(&TR_TCP_CLOSE);
    eval 'sub TR_TCP_RPUT_IN () {2;}' unless defined(&TR_TCP_RPUT_IN);
    eval 'sub TR_TCP_RPUT_OUT () {3;}' unless defined(&TR_TCP_RPUT_OUT);
    eval 'sub TR_TCP_WPUT_IN () {4;}' unless defined(&TR_TCP_WPUT_IN);
    eval 'sub TR_TCP_WPUT_OUT () {5;}' unless defined(&TR_TCP_WPUT_OUT);
    eval 'sub TR_TCP_RSRV_IN () {6;}' unless defined(&TR_TCP_RSRV_IN);
    eval 'sub TR_TCP_RSRV_OUT () {7;}' unless defined(&TR_TCP_RSRV_OUT);
    eval 'sub TR_TCP_WSRV_IN () {8;}' unless defined(&TR_TCP_WSRV_IN);
    eval 'sub TR_TCP_WSRV_OUT () {9;}' unless defined(&TR_TCP_WSRV_OUT);
    eval 'sub TR_TCP_WPUT_SLOW_IN () {10;}' unless defined(&TR_TCP_WPUT_SLOW_IN);
    eval 'sub TR_TCP_WPUT_SLOW_OUT () {11;}' unless defined(&TR_TCP_WPUT_SLOW_OUT);
    eval 'sub TR_TCP_RPUT_SLOW_IN () {12;}' unless defined(&TR_TCP_RPUT_SLOW_IN);
    eval 'sub TR_TCP_RPUT_SLOW_OUT () {13;}' unless defined(&TR_TCP_RPUT_SLOW_OUT);
    eval 'sub TR_UDP_OPEN () {0;}' unless defined(&TR_UDP_OPEN);
    eval 'sub TR_UDP_CLOSE () {1;}' unless defined(&TR_UDP_CLOSE);
    eval 'sub TR_UDP_RPUT_START () {2;}' unless defined(&TR_UDP_RPUT_START);
    eval 'sub TR_UDP_RPUT_END () {3;}' unless defined(&TR_UDP_RPUT_END);
    eval 'sub TR_UDP_WPUT_START () {4;}' unless defined(&TR_UDP_WPUT_START);
    eval 'sub TR_UDP_WPUT_END () {5;}' unless defined(&TR_UDP_WPUT_END);
    eval 'sub TR_UDP_WPUT_OTHER_START () {6;}' unless defined(&TR_UDP_WPUT_OTHER_START);
    eval 'sub TR_UDP_WPUT_OTHER_END () {7;}' unless defined(&TR_UDP_WPUT_OTHER_END);
    eval 'sub TR_IP_OPEN () {0;}' unless defined(&TR_IP_OPEN);
    eval 'sub TR_IP_CLOSE () {1;}' unless defined(&TR_IP_CLOSE);
    eval 'sub TR_IP_RPUT_START () {2;}' unless defined(&TR_IP_RPUT_START);
    eval 'sub TR_IP_RPUT_END () {3;}' unless defined(&TR_IP_RPUT_END);
    eval 'sub TR_IP_WPUT_START () {4;}' unless defined(&TR_IP_WPUT_START);
    eval 'sub TR_IP_WPUT_END () {5;}' unless defined(&TR_IP_WPUT_END);
    eval 'sub TR_IP_WSRV_START () {6;}' unless defined(&TR_IP_WSRV_START);
    eval 'sub TR_IP_WSRV_END () {7;}' unless defined(&TR_IP_WSRV_END);
    eval 'sub TR_IP_LRPUT_START () {8;}' unless defined(&TR_IP_LRPUT_START);
    eval 'sub TR_IP_LRPUT_END () {9;}' unless defined(&TR_IP_LRPUT_END);
    eval 'sub TR_IP_LWPUT_START () {10;}' unless defined(&TR_IP_LWPUT_START);
    eval 'sub TR_IP_LWPUT_END () {11;}' unless defined(&TR_IP_LWPUT_END);
    eval 'sub TR_IP_RPUT_LOCL_START () {12;}' unless defined(&TR_IP_RPUT_LOCL_START);
    eval 'sub TR_IP_RPUT_LOCL_END () {13;}' unless defined(&TR_IP_RPUT_LOCL_END);
    eval 'sub TR_IP_RPUT_LOCL_ERR () {14;}' unless defined(&TR_IP_RPUT_LOCL_ERR);
    eval 'sub TR_IP_RSRV_START () {15;}' unless defined(&TR_IP_RSRV_START);
    eval 'sub TR_IP_RSRV_END () {16;}' unless defined(&TR_IP_RSRV_END);
    eval 'sub TR_IP_CKSUM_START () {17;}' unless defined(&TR_IP_CKSUM_START);
    eval 'sub TR_IP_CKSUM_END () {18;}' unless defined(&TR_IP_CKSUM_END);
    eval 'sub TR_IP_CKSUM_COPY_START () {19;}' unless defined(&TR_IP_CKSUM_COPY_START);
    eval 'sub TR_IP_CKSUM_COPY_END () {20;}' unless defined(&TR_IP_CKSUM_COPY_END);
    eval 'sub TR_IP_WPUT_IRE_START () {21;}' unless defined(&TR_IP_WPUT_IRE_START);
    eval 'sub TR_IP_WPUT_IRE_END () {22;}' unless defined(&TR_IP_WPUT_IRE_END);
    eval 'sub TR_IP_WPUT_FRAG_START () {23;}' unless defined(&TR_IP_WPUT_FRAG_START);
    eval 'sub TR_IP_WPUT_FRAG_END () {24;}' unless defined(&TR_IP_WPUT_FRAG_END);
    eval 'sub TR_IP_WPUT_LOCAL_START () {25;}' unless defined(&TR_IP_WPUT_LOCAL_START);
    eval 'sub TR_IP_WPUT_LOCAL_END () {26;}' unless defined(&TR_IP_WPUT_LOCAL_END);
    eval 'sub TR_ARP_OPEN () {0;}' unless defined(&TR_ARP_OPEN);
    eval 'sub TR_ARP_CLOSE () {1;}' unless defined(&TR_ARP_CLOSE);
    eval 'sub TR_ARP_RPUT_START () {2;}' unless defined(&TR_ARP_RPUT_START);
    eval 'sub TR_ARP_RPUT_END () {3;}' unless defined(&TR_ARP_RPUT_END);
    eval 'sub TR_ARP_WPUT_START () {4;}' unless defined(&TR_ARP_WPUT_START);
    eval 'sub TR_ARP_WPUT_END () {5;}' unless defined(&TR_ARP_WPUT_END);
    eval 'sub TR_ARP_WSRV_START () {6;}' unless defined(&TR_ARP_WSRV_START);
    eval 'sub TR_ARP_WSRV_END () {7;}' unless defined(&TR_ARP_WSRV_END);
    eval 'sub TR_LE_OPEN () {0;}' unless defined(&TR_LE_OPEN);
    eval 'sub TR_LE_CLOSE () {1;}' unless defined(&TR_LE_CLOSE);
    eval 'sub TR_LE_WPUT_START () {2;}' unless defined(&TR_LE_WPUT_START);
    eval 'sub TR_LE_WPUT_END () {3;}' unless defined(&TR_LE_WPUT_END);
    eval 'sub TR_LE_WSRV_START () {4;}' unless defined(&TR_LE_WSRV_START);
    eval 'sub TR_LE_WSRV_END () {5;}' unless defined(&TR_LE_WSRV_END);
    eval 'sub TR_LE_START_START () {6;}' unless defined(&TR_LE_START_START);
    eval 'sub TR_LE_START_END () {7;}' unless defined(&TR_LE_START_END);
    eval 'sub TR_LE_INTR_START () {8;}' unless defined(&TR_LE_INTR_START);
    eval 'sub TR_LE_INTR_END () {9;}' unless defined(&TR_LE_INTR_END);
    eval 'sub TR_LE_READ_START () {10;}' unless defined(&TR_LE_READ_START);
    eval 'sub TR_LE_READ_END () {11;}' unless defined(&TR_LE_READ_END);
    eval 'sub TR_LE_SENDUP_START () {12;}' unless defined(&TR_LE_SENDUP_START);
    eval 'sub TR_LE_SENDUP_END () {13;}' unless defined(&TR_LE_SENDUP_END);
    eval 'sub TR_LE_ADDUDIND_START () {14;}' unless defined(&TR_LE_ADDUDIND_START);
    eval 'sub TR_LE_ADDUDIND_END () {15;}' unless defined(&TR_LE_ADDUDIND_END);
    eval 'sub TR_LE_GETBUF_START () {16;}' unless defined(&TR_LE_GETBUF_START);
    eval 'sub TR_LE_GETBUF_END () {17;}' unless defined(&TR_LE_GETBUF_END);
    eval 'sub TR_LE_FREEBUF_START () {18;}' unless defined(&TR_LE_FREEBUF_START);
    eval 'sub TR_LE_FREEBUF_END () {19;}' unless defined(&TR_LE_FREEBUF_END);
    eval 'sub TR_LE_PROTO_START () {20;}' unless defined(&TR_LE_PROTO_START);
    eval 'sub TR_LE_PROTO_END () {21;}' unless defined(&TR_LE_PROTO_END);
    eval 'sub TR_LE_INIT_START () {22;}' unless defined(&TR_LE_INIT_START);
    eval 'sub TR_LE_INIT_END () {23;}' unless defined(&TR_LE_INIT_END);
    eval 'sub TR_LE_PROTO_IN () {24;}' unless defined(&TR_LE_PROTO_IN);
    eval 'sub TR_LE_PROTO_OUT () {25;}' unless defined(&TR_LE_PROTO_OUT);
    eval 'sub TR_QE_OPEN () {0;}' unless defined(&TR_QE_OPEN);
    eval 'sub TR_QE_CLOSE () {1;}' unless defined(&TR_QE_CLOSE);
    eval 'sub TR_QE_WPUT_START () {2;}' unless defined(&TR_QE_WPUT_START);
    eval 'sub TR_QE_WPUT_END () {3;}' unless defined(&TR_QE_WPUT_END);
    eval 'sub TR_QE_WSRV_START () {4;}' unless defined(&TR_QE_WSRV_START);
    eval 'sub TR_QE_WSRV_END () {5;}' unless defined(&TR_QE_WSRV_END);
    eval 'sub TR_QE_START_START () {6;}' unless defined(&TR_QE_START_START);
    eval 'sub TR_QE_START_END () {7;}' unless defined(&TR_QE_START_END);
    eval 'sub TR_QE_INTR_START () {8;}' unless defined(&TR_QE_INTR_START);
    eval 'sub TR_QE_INTR_END () {9;}' unless defined(&TR_QE_INTR_END);
    eval 'sub TR_QE_READ_START () {10;}' unless defined(&TR_QE_READ_START);
    eval 'sub TR_QE_READ_END () {11;}' unless defined(&TR_QE_READ_END);
    eval 'sub TR_QE_SENDUP_START () {12;}' unless defined(&TR_QE_SENDUP_START);
    eval 'sub TR_QE_SENDUP_END () {13;}' unless defined(&TR_QE_SENDUP_END);
    eval 'sub TR_QE_ADDUDIND_START () {14;}' unless defined(&TR_QE_ADDUDIND_START);
    eval 'sub TR_QE_ADDUDIND_END () {15;}' unless defined(&TR_QE_ADDUDIND_END);
    eval 'sub TR_QE_GETBUF_START () {16;}' unless defined(&TR_QE_GETBUF_START);
    eval 'sub TR_QE_GETBUF_END () {17;}' unless defined(&TR_QE_GETBUF_END);
    eval 'sub TR_QE_FREEBUF_START () {18;}' unless defined(&TR_QE_FREEBUF_START);
    eval 'sub TR_QE_FREEBUF_END () {19;}' unless defined(&TR_QE_FREEBUF_END);
    eval 'sub TR_QE_PROTO_START () {20;}' unless defined(&TR_QE_PROTO_START);
    eval 'sub TR_QE_PROTO_END () {21;}' unless defined(&TR_QE_PROTO_END);
    eval 'sub TR_QE_INIT_START () {22;}' unless defined(&TR_QE_INIT_START);
    eval 'sub TR_QE_INIT_END () {23;}' unless defined(&TR_QE_INIT_END);
    eval 'sub TR_QE_PROTO_IN () {24;}' unless defined(&TR_QE_PROTO_IN);
    eval 'sub TR_QE_PROTO_OUT () {25;}' unless defined(&TR_QE_PROTO_OUT);
    eval 'sub TR_BE_OPEN () {0;}' unless defined(&TR_BE_OPEN);
    eval 'sub TR_BE_CLOSE () {1;}' unless defined(&TR_BE_CLOSE);
    eval 'sub TR_BE_WPUT_START () {2;}' unless defined(&TR_BE_WPUT_START);
    eval 'sub TR_BE_WPUT_END () {3;}' unless defined(&TR_BE_WPUT_END);
    eval 'sub TR_BE_WSRV_START () {4;}' unless defined(&TR_BE_WSRV_START);
    eval 'sub TR_BE_WSRV_END () {5;}' unless defined(&TR_BE_WSRV_END);
    eval 'sub TR_BE_START_START () {6;}' unless defined(&TR_BE_START_START);
    eval 'sub TR_BE_START_END () {7;}' unless defined(&TR_BE_START_END);
    eval 'sub TR_BE_INTR_START () {8;}' unless defined(&TR_BE_INTR_START);
    eval 'sub TR_BE_INTR_END () {9;}' unless defined(&TR_BE_INTR_END);
    eval 'sub TR_BE_READ_START () {10;}' unless defined(&TR_BE_READ_START);
    eval 'sub TR_BE_READ_END () {11;}' unless defined(&TR_BE_READ_END);
    eval 'sub TR_BE_SENDUP_START () {12;}' unless defined(&TR_BE_SENDUP_START);
    eval 'sub TR_BE_SENDUP_END () {13;}' unless defined(&TR_BE_SENDUP_END);
    eval 'sub TR_BE_ADDUDIND_START () {14;}' unless defined(&TR_BE_ADDUDIND_START);
    eval 'sub TR_BE_ADDUDIND_END () {15;}' unless defined(&TR_BE_ADDUDIND_END);
    eval 'sub TR_BE_GETBUF_START () {16;}' unless defined(&TR_BE_GETBUF_START);
    eval 'sub TR_BE_GETBUF_END () {17;}' unless defined(&TR_BE_GETBUF_END);
    eval 'sub TR_BE_FREEBUF_START () {18;}' unless defined(&TR_BE_FREEBUF_START);
    eval 'sub TR_BE_FREEBUF_END () {19;}' unless defined(&TR_BE_FREEBUF_END);
    eval 'sub TR_BE_PROTO_START () {20;}' unless defined(&TR_BE_PROTO_START);
    eval 'sub TR_BE_PROTO_END () {21;}' unless defined(&TR_BE_PROTO_END);
    eval 'sub TR_BE_INIT_START () {22;}' unless defined(&TR_BE_INIT_START);
    eval 'sub TR_BE_INIT_END () {23;}' unless defined(&TR_BE_INIT_END);
    eval 'sub TR_BE_PROTO_IN () {24;}' unless defined(&TR_BE_PROTO_IN);
    eval 'sub TR_BE_PROTO_OUT () {25;}' unless defined(&TR_BE_PROTO_OUT);
    eval 'sub TR_AE_OPEN () {0;}' unless defined(&TR_AE_OPEN);
    eval 'sub TR_AE_CLOSE () {1;}' unless defined(&TR_AE_CLOSE);
    eval 'sub TR_AE_WPUT_START () {2;}' unless defined(&TR_AE_WPUT_START);
    eval 'sub TR_AE_WPUT_END () {3;}' unless defined(&TR_AE_WPUT_END);
    eval 'sub TR_AE_WSRV_START () {4;}' unless defined(&TR_AE_WSRV_START);
    eval 'sub TR_AE_WSRV_END () {5;}' unless defined(&TR_AE_WSRV_END);
    eval 'sub TR_AE_START_START () {6;}' unless defined(&TR_AE_START_START);
    eval 'sub TR_AE_START_END () {7;}' unless defined(&TR_AE_START_END);
    eval 'sub TR_AE_INTR_START () {8;}' unless defined(&TR_AE_INTR_START);
    eval 'sub TR_AE_INTR_END () {9;}' unless defined(&TR_AE_INTR_END);
    eval 'sub TR_AE_READ_START () {10;}' unless defined(&TR_AE_READ_START);
    eval 'sub TR_AE_READ_END () {11;}' unless defined(&TR_AE_READ_END);
    eval 'sub TR_AE_SENDUP_START () {12;}' unless defined(&TR_AE_SENDUP_START);
    eval 'sub TR_AE_SENDUP_END () {13;}' unless defined(&TR_AE_SENDUP_END);
    eval 'sub TR_AE_ADDUDIND_START () {14;}' unless defined(&TR_AE_ADDUDIND_START);
    eval 'sub TR_AE_ADDUDIND_END () {15;}' unless defined(&TR_AE_ADDUDIND_END);
    eval 'sub TR_AE_GETBUF_START () {16;}' unless defined(&TR_AE_GETBUF_START);
    eval 'sub TR_AE_GETBUF_END () {17;}' unless defined(&TR_AE_GETBUF_END);
    eval 'sub TR_AE_FREEBUF_START () {18;}' unless defined(&TR_AE_FREEBUF_START);
    eval 'sub TR_AE_FREEBUF_END () {19;}' unless defined(&TR_AE_FREEBUF_END);
    eval 'sub TR_AE_PROTO_START () {20;}' unless defined(&TR_AE_PROTO_START);
    eval 'sub TR_AE_PROTO_END () {21;}' unless defined(&TR_AE_PROTO_END);
    eval 'sub TR_AE_INIT_START () {22;}' unless defined(&TR_AE_INIT_START);
    eval 'sub TR_AE_INIT_END () {23;}' unless defined(&TR_AE_INIT_END);
    eval 'sub TR_AE_PROTO_IN () {24;}' unless defined(&TR_AE_PROTO_IN);
    eval 'sub TR_AE_PROTO_OUT () {25;}' unless defined(&TR_AE_PROTO_OUT);
    eval 'sub TR_PHYSIO_START () {0;}' unless defined(&TR_PHYSIO_START);
    eval 'sub TR_PHYSIO_LOCK_START () {1;}' unless defined(&TR_PHYSIO_LOCK_START);
    eval 'sub TR_PHYSIO_LOCK_END () {2;}' unless defined(&TR_PHYSIO_LOCK_END);
    eval 'sub TR_PHYSIO_UNLOCK_START () {3;}' unless defined(&TR_PHYSIO_UNLOCK_START);
    eval 'sub TR_PHYSIO_UNLOCK_END () {4;}' unless defined(&TR_PHYSIO_UNLOCK_END);
    eval 'sub TR_PHYSIO_GETBUF_START () {5;}' unless defined(&TR_PHYSIO_GETBUF_START);
    eval 'sub TR_PHYSIO_GETBUF_END () {6;}' unless defined(&TR_PHYSIO_GETBUF_END);
    eval 'sub TR_PHYSIO_END () {7;}' unless defined(&TR_PHYSIO_END);
    eval 'sub TR_PHYSIO_AS_LOCK_START () {8;}' unless defined(&TR_PHYSIO_AS_LOCK_START);
    eval 'sub TR_PHYSIO_SEG_LOCK_START () {9;}' unless defined(&TR_PHYSIO_SEG_LOCK_START);
    eval 'sub TR_PHYSIO_SEG_LOCK_END () {10;}' unless defined(&TR_PHYSIO_SEG_LOCK_END);
    eval 'sub TR_PHYSIO_AS_FAULT_START () {11;}' unless defined(&TR_PHYSIO_AS_FAULT_START);
    eval 'sub TR_PHYSIO_AS_LOCK_END () {12;}' unless defined(&TR_PHYSIO_AS_LOCK_END);
    eval 'sub TR_PHYSIO_AS_UNLOCK_START () {13;}' unless defined(&TR_PHYSIO_AS_UNLOCK_START);
    eval 'sub TR_PHYSIO_SEG_UNLOCK_START () {14;}' unless defined(&TR_PHYSIO_SEG_UNLOCK_START);
    eval 'sub TR_PHYSIO_AS_UNLOCK_END () {15;}' unless defined(&TR_PHYSIO_AS_UNLOCK_END);
    eval 'sub TR_PHYSIO_SEGVN_START () {16;}' unless defined(&TR_PHYSIO_SEGVN_START);
    eval 'sub TR_PHYSIO_SEGVN_UNLOCK_END () {17;}' unless defined(&TR_PHYSIO_SEGVN_UNLOCK_END);
    eval 'sub TR_PHYSIO_SEGVN_HIT_END () {18;}' unless defined(&TR_PHYSIO_SEGVN_HIT_END);
    eval 'sub TR_PHYSIO_SEGVN_FILL_END () {19;}' unless defined(&TR_PHYSIO_SEGVN_FILL_END);
    eval 'sub TR_PHYSIO_SEGVN_MISS_END () {20;}' unless defined(&TR_PHYSIO_SEGVN_MISS_END);
    eval 'sub TR_META_WRITE_START () {0;}' unless defined(&TR_META_WRITE_START);
    eval 'sub TR_META_WRITE_END () {1;}' unless defined(&TR_META_WRITE_END);
    eval 'sub TR_META_READ_START () {2;}' unless defined(&TR_META_READ_START);
    eval 'sub TR_META_READ_END () {3;}' unless defined(&TR_META_READ_END);
    eval 'sub TR_META_STRATEGY_START () {4;}' unless defined(&TR_META_STRATEGY_START);
    eval 'sub TR_META_STRATEGY_END () {5;}' unless defined(&TR_META_STRATEGY_END);
    eval 'sub TR_STRIPE_STRATEGY_START () {7;}' unless defined(&TR_STRIPE_STRATEGY_START);
    eval 'sub TR_STRIPE_STRATEGY_END () {8;}' unless defined(&TR_STRIPE_STRATEGY_END);
    eval 'sub TR_STRIPE_STRATEGY_CHKBUF_START () {9;}' unless defined(&TR_STRIPE_STRATEGY_CHKBUF_START);
    eval 'sub TR_STRIPE_STRATEGY_CHKBUF_END () {10;}' unless defined(&TR_STRIPE_STRATEGY_CHKBUF_END);
    eval 'sub TR_STRIPE_STRATEGY_BPMAPIN_START () {11;}' unless defined(&TR_STRIPE_STRATEGY_BPMAPIN_START);
    eval 'sub TR_STRIPE_STRATEGY_BPMAPIN_END () {12;}' unless defined(&TR_STRIPE_STRATEGY_BPMAPIN_END);
    eval 'sub TR_STRIPE_STRATEGY_ALLOC_START () {13;}' unless defined(&TR_STRIPE_STRATEGY_ALLOC_START);
    eval 'sub TR_STRIPE_STRATEGY_ALLOC_END () {14;}' unless defined(&TR_STRIPE_STRATEGY_ALLOC_END);
    eval 'sub TR_STRIPE_STRATEGY_MAPBUF_START () {15;}' unless defined(&TR_STRIPE_STRATEGY_MAPBUF_START);
    eval 'sub TR_STRIPE_STRATEGY_MAPBUF_END () {16;}' unless defined(&TR_STRIPE_STRATEGY_MAPBUF_END);
    eval 'sub TR_STRIPE_STRATEGY_STRIPE_START () {17;}' unless defined(&TR_STRIPE_STRATEGY_STRIPE_START);
    eval 'sub TR_STRIPE_STRATEGY_STRIPE_END () {18;}' unless defined(&TR_STRIPE_STRATEGY_STRIPE_END);
    eval 'sub TR_STRIPE_STRATEGY_CALLDRV_START () {19;}' unless defined(&TR_STRIPE_STRATEGY_CALLDRV_START);
    eval 'sub TR_STRIPE_STRATEGY_CALLDRV_END () {20;}' unless defined(&TR_STRIPE_STRATEGY_CALLDRV_END);
    eval 'sub TR_IPI_START () {0;}' unless defined(&TR_IPI_START);
    eval 'sub TR_IPI_RESET_SLAVE () {1;}' unless defined(&TR_IPI_RESET_SLAVE);
    eval 'sub TR_IPI_RESET_CHAN () {2;}' unless defined(&TR_IPI_RESET_CHAN);
    eval 'sub TR_IPI_RESET_BOARD () {3;}' unless defined(&TR_IPI_RESET_BOARD);
    eval 'sub TR_IPI_TEST_BOARD () {4;}' unless defined(&TR_IPI_TEST_BOARD);
    eval 'sub TR_IPI_GET_XFER_MODE () {5;}' unless defined(&TR_IPI_GET_XFER_MODE);
    eval 'sub TR_IPI_SET_XFER_MODE () {6;}' unless defined(&TR_IPI_SET_XFER_MODE);
    eval 'sub TR_IPI_INTR_1 () {7;}' unless defined(&TR_IPI_INTR_1);
    eval 'sub TR_IPI_INTR_2 () {8;}' unless defined(&TR_IPI_INTR_2);
    eval 'sub TR_IPI_POLL_1 () {9;}' unless defined(&TR_IPI_POLL_1);
    eval 'sub TR_IPI_POLL_2 () {10;}' unless defined(&TR_IPI_POLL_2);
    eval 'sub TR_IPI_RETRY () {11;}' unless defined(&TR_IPI_RETRY);
    eval 'sub TR_IPI_IS_CMD () {12;}' unless defined(&TR_IPI_IS_CMD);
    eval 'sub TR_IPI_INTR_OK () {13;}' unless defined(&TR_IPI_INTR_OK);
    eval 'sub TR_IPI_INTR_RESP () {14;}' unless defined(&TR_IPI_INTR_RESP);
    eval 'sub TR_IPI_INTR_ERR () {15;}' unless defined(&TR_IPI_INTR_ERR);
    eval 'sub TR_PID_ON () {0;}' unless defined(&TR_PID_ON);
    eval 'sub TR_PID_OFF () {1;}' unless defined(&TR_PID_OFF);
    eval 'sub TR_GROUP_ON () {2;}' unless defined(&TR_GROUP_ON);
    eval 'sub TR_GROUP_OFF () {3;}' unless defined(&TR_GROUP_OFF);
    eval 'sub TR_CONTROL_TTY () {4;}' unless defined(&TR_CONTROL_TTY);
    eval 'sub TR_ACTIVE_CHAIN () {5;}' unless defined(&TR_ACTIVE_CHAIN);
    eval 'sub TR_S5_SYNCIP_START () {0;}' unless defined(&TR_S5_SYNCIP_START);
    eval 'sub TR_S5_SYNCIP_END () {1;}' unless defined(&TR_S5_SYNCIP_END);
    eval 'sub TR_S5_OPEN () {2;}' unless defined(&TR_S5_OPEN);
    eval 'sub TR_S5_CLOSE () {3;}' unless defined(&TR_S5_CLOSE);
    eval 'sub TR_S5_READ_START () {4;}' unless defined(&TR_S5_READ_START);
    eval 'sub TR_S5_READ_END () {5;}' unless defined(&TR_S5_READ_END);
    eval 'sub TR_S5_WRITE_START () {6;}' unless defined(&TR_S5_WRITE_START);
    eval 'sub TR_S5_WRITE_END () {7;}' unless defined(&TR_S5_WRITE_END);
    eval 'sub TR_S5_RWIP_START () {8;}' unless defined(&TR_S5_RWIP_START);
    eval 'sub TR_S5_RWIP_END () {9;}' unless defined(&TR_S5_RWIP_END);
    eval 'sub TR_S5_GETATTR_START () {10;}' unless defined(&TR_S5_GETATTR_START);
    eval 'sub TR_S5_GETATTR_END () {11;}' unless defined(&TR_S5_GETATTR_END);
    eval 'sub TR_S5_SETATTR_START () {12;}' unless defined(&TR_S5_SETATTR_START);
    eval 'sub TR_S5_SETATTR_END () {13;}' unless defined(&TR_S5_SETATTR_END);
    eval 'sub TR_S5_ACCESS_START () {14;}' unless defined(&TR_S5_ACCESS_START);
    eval 'sub TR_S5_ACCESS_END () {15;}' unless defined(&TR_S5_ACCESS_END);
    eval 'sub TR_S5_READLINK_START () {16;}' unless defined(&TR_S5_READLINK_START);
    eval 'sub TR_S5_READLINK_END () {17;}' unless defined(&TR_S5_READLINK_END);
    eval 'sub TR_S5_FSYNC_START () {18;}' unless defined(&TR_S5_FSYNC_START);
    eval 'sub TR_S5_FSYNC_END () {19;}' unless defined(&TR_S5_FSYNC_END);
    eval 'sub TR_S5_LOOKUP_START () {20;}' unless defined(&TR_S5_LOOKUP_START);
    eval 'sub TR_S5_LOOKUP_END () {21;}' unless defined(&TR_S5_LOOKUP_END);
    eval 'sub TR_S5_CREATE_START () {22;}' unless defined(&TR_S5_CREATE_START);
    eval 'sub TR_S5_CREATE_END () {23;}' unless defined(&TR_S5_CREATE_END);
    eval 'sub TR_S5_REMOVE_START () {24;}' unless defined(&TR_S5_REMOVE_START);
    eval 'sub TR_S5_REMOVE_END () {25;}' unless defined(&TR_S5_REMOVE_END);
    eval 'sub TR_S5_LINK_START () {26;}' unless defined(&TR_S5_LINK_START);
    eval 'sub TR_S5_LINK_END () {27;}' unless defined(&TR_S5_LINK_END);
    eval 'sub TR_S5_RENAME_START () {28;}' unless defined(&TR_S5_RENAME_START);
    eval 'sub TR_S5_RENAME_END () {29;}' unless defined(&TR_S5_RENAME_END);
    eval 'sub TR_S5_MKDIR_START () {30;}' unless defined(&TR_S5_MKDIR_START);
    eval 'sub TR_S5_MKDIR_END () {31;}' unless defined(&TR_S5_MKDIR_END);
    eval 'sub TR_S5_RMDIR_START () {32;}' unless defined(&TR_S5_RMDIR_START);
    eval 'sub TR_S5_RMDIR_END () {33;}' unless defined(&TR_S5_RMDIR_END);
    eval 'sub TR_S5_READDIR_START () {34;}' unless defined(&TR_S5_READDIR_START);
    eval 'sub TR_S5_READDIR_END () {35;}' unless defined(&TR_S5_READDIR_END);
    eval 'sub TR_S5_SYMLINK_START () {36;}' unless defined(&TR_S5_SYMLINK_START);
    eval 'sub TR_S5_SYMLINK_END () {37;}' unless defined(&TR_S5_SYMLINK_END);
    eval 'sub TR_S5_GETPAGE_START () {38;}' unless defined(&TR_S5_GETPAGE_START);
    eval 'sub TR_S5_GETPAGE_END () {39;}' unless defined(&TR_S5_GETPAGE_END);
    eval 'sub TR_S5_PUTPAGE_START () {40;}' unless defined(&TR_S5_PUTPAGE_START);
    eval 'sub TR_S5_PUTPAGE_END () {41;}' unless defined(&TR_S5_PUTPAGE_END);
    eval 'sub TR_S5_PUTAPAGE_START () {42;}' unless defined(&TR_S5_PUTAPAGE_START);
    eval 'sub TR_S5_PUTAPAGE_END () {43;}' unless defined(&TR_S5_PUTAPAGE_END);
    eval 'sub TR_S5_STARTIO_START () {44;}' unless defined(&TR_S5_STARTIO_START);
    eval 'sub TR_S5_STARTIO_END () {45;}' unless defined(&TR_S5_STARTIO_END);
    eval 'sub TR_S5_MAP_START () {46;}' unless defined(&TR_S5_MAP_START);
    eval 'sub TR_S5_MAP_END () {47;}' unless defined(&TR_S5_MAP_END);
    eval 'sub TR_ESPSVC_ACTION_CALL () {0;}' unless defined(&TR_ESPSVC_ACTION_CALL);
    eval 'sub TR_ESPSVC_START () {1;}' unless defined(&TR_ESPSVC_START);
    eval 'sub TR_ESPSVC_END () {2;}' unless defined(&TR_ESPSVC_END);
    eval 'sub TR_ESP_CALLBACK_START () {3;}' unless defined(&TR_ESP_CALLBACK_START);
    eval 'sub TR_ESP_CALLBACK_END () {4;}' unless defined(&TR_ESP_CALLBACK_END);
    eval 'sub TR_ESP_DOPOLL_START () {5;}' unless defined(&TR_ESP_DOPOLL_START);
    eval 'sub TR_ESP_DOPOLL_END () {6;}' unless defined(&TR_ESP_DOPOLL_END);
    eval 'sub TR_ESP_FINISH_START () {7;}' unless defined(&TR_ESP_FINISH_START);
    eval 'sub TR_ESP_FINISH_END () {8;}' unless defined(&TR_ESP_FINISH_END);
    eval 'sub TR_ESP_FINISH_SELECT_START () {9;}' unless defined(&TR_ESP_FINISH_SELECT_START);
    eval 'sub TR_ESP_FINISH_SELECT_RESET1_END () {10;}' unless defined(&TR_ESP_FINISH_SELECT_RESET1_END);
    eval 'sub TR_ESP_FINISH_SELECT_RETURN1_END () {11;}' unless defined(&TR_ESP_FINISH_SELECT_RETURN1_END);
    eval 'sub TR_ESP_FINISH_SELECT_RETURN2_END () {12;}' unless defined(&TR_ESP_FINISH_SELECT_RETURN2_END);
    eval 'sub TR_ESP_FINISH_SELECT_FINISH_END () {13;}' unless defined(&TR_ESP_FINISH_SELECT_FINISH_END);
    eval 'sub TR_ESP_FINISH_SELECT_ACTION1_END () {14;}' unless defined(&TR_ESP_FINISH_SELECT_ACTION1_END);
    eval 'sub TR_ESP_FINISH_SELECT_ACTION2_END () {15;}' unless defined(&TR_ESP_FINISH_SELECT_ACTION2_END);
    eval 'sub TR_ESP_FINISH_SELECT_RESET2_END () {16;}' unless defined(&TR_ESP_FINISH_SELECT_RESET2_END);
    eval 'sub TR_ESP_FINISH_SELECT_RESET3_END () {17;}' unless defined(&TR_ESP_FINISH_SELECT_RESET3_END);
    eval 'sub TR_ESP_FINISH_SELECT_ACTION3_END () {18;}' unless defined(&TR_ESP_FINISH_SELECT_ACTION3_END);
    eval 'sub TR_ESP_HANDLE_CLEARING_START () {19;}' unless defined(&TR_ESP_HANDLE_CLEARING_START);
    eval 'sub TR_ESP_HANDLE_CLEARING_END () {20;}' unless defined(&TR_ESP_HANDLE_CLEARING_END);
    eval 'sub TR_ESP_HANDLE_CLEARING_FINRST_END () {21;}' unless defined(&TR_ESP_HANDLE_CLEARING_FINRST_END);
    eval 'sub TR_ESP_HANDLE_CLEARING_RETURN1_END () {22;}' unless defined(&TR_ESP_HANDLE_CLEARING_RETURN1_END);
    eval 'sub TR_ESP_HANDLE_CLEARING_ABORT_END () {23;}' unless defined(&TR_ESP_HANDLE_CLEARING_ABORT_END);
    eval 'sub TR_ESP_HANDLE_CLEARING_LINKED_CMD_END () {24;}' unless defined(&TR_ESP_HANDLE_CLEARING_LINKED_CMD_END);
    eval 'sub TR_ESP_HANDLE_CLEARING_RETURN2_END () {25;}' unless defined(&TR_ESP_HANDLE_CLEARING_RETURN2_END);
    eval 'sub TR_ESP_HANDLE_CLEARING_RETURN3_END () {26;}' unless defined(&TR_ESP_HANDLE_CLEARING_RETURN3_END);
    eval 'sub TR_ESP_HANDLE_CMD_START_START () {27;}' unless defined(&TR_ESP_HANDLE_CMD_START_START);
    eval 'sub TR_ESP_HANDLE_CMD_START_END () {28;}' unless defined(&TR_ESP_HANDLE_CMD_START_END);
    eval 'sub TR_ESP_HANDLE_CMD_START_ABORT_CMD_END () {29;}' unless defined(&TR_ESP_HANDLE_CMD_START_ABORT_CMD_END);
    eval 'sub TR_ESP_HANDLE_CMD_DONE_START () {30;}' unless defined(&TR_ESP_HANDLE_CMD_DONE_START);
    eval 'sub TR_ESP_HANDLE_CMD_DONE_END () {31;}' unless defined(&TR_ESP_HANDLE_CMD_DONE_END);
    eval 'sub TR_ESP_HANDLE_CMD_DONE_ABORT1_END () {32;}' unless defined(&TR_ESP_HANDLE_CMD_DONE_ABORT1_END);
    eval 'sub TR_ESP_HANDLE_CMD_DONE_ABORT2_END () {33;}' unless defined(&TR_ESP_HANDLE_CMD_DONE_ABORT2_END);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_START () {34;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_START);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_FINRST_END () {35;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_FINRST_END);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_RETURN1_END () {36;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_RETURN1_END);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_ACTION1_END () {37;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_ACTION1_END);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_ACTION2_END () {38;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_ACTION2_END);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_ACTION3_END () {39;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_ACTION3_END);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_ACTION4_END () {40;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_ACTION4_END);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_RETURN2_END () {41;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_RETURN2_END);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_ACTION5_END () {42;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_ACTION5_END);
    eval 'sub TR_ESP_HANDLE_C_CMPLT_PHASEMANAGE_END () {43;}' unless defined(&TR_ESP_HANDLE_C_CMPLT_PHASEMANAGE_END);
    eval 'sub TR_ESP_HANDLE_DATA_START () {44;}' unless defined(&TR_ESP_HANDLE_DATA_START);
    eval 'sub TR_ESP_HANDLE_DATA_END () {45;}' unless defined(&TR_ESP_HANDLE_DATA_END);
    eval 'sub TR_ESP_HANDLE_DATA_ABORT1_END () {46;}' unless defined(&TR_ESP_HANDLE_DATA_ABORT1_END);
    eval 'sub TR_ESP_HANDLE_DATA_ABORT2_END () {47;}' unless defined(&TR_ESP_HANDLE_DATA_ABORT2_END);
    eval 'sub TR_ESP_HANDLE_DATA_ABORT3_END () {48;}' unless defined(&TR_ESP_HANDLE_DATA_ABORT3_END);
    eval 'sub TR_ESP_HANDLE_DATA_DONE_START () {49;}' unless defined(&TR_ESP_HANDLE_DATA_DONE_START);
    eval 'sub TR_ESP_HANDLE_DATA_DONE_END () {50;}' unless defined(&TR_ESP_HANDLE_DATA_DONE_END);
    eval 'sub TR_ESP_HANDLE_DATA_DONE_RESET_END () {51;}' unless defined(&TR_ESP_HANDLE_DATA_DONE_RESET_END);
    eval 'sub TR_ESP_HANDLE_DATA_DONE_PHASEMANAGE_END () {52;}' unless defined(&TR_ESP_HANDLE_DATA_DONE_PHASEMANAGE_END);
    eval 'sub TR_ESP_HANDLE_DATA_DONE_ACTION1_END () {53;}' unless defined(&TR_ESP_HANDLE_DATA_DONE_ACTION1_END);
    eval 'sub TR_ESP_HANDLE_DATA_DONE_ACTION2_END () {54;}' unless defined(&TR_ESP_HANDLE_DATA_DONE_ACTION2_END);
    eval 'sub TR_ESP_HANDLE_MORE_MSGIN_START () {55;}' unless defined(&TR_ESP_HANDLE_MORE_MSGIN_START);
    eval 'sub TR_ESP_HANDLE_MORE_MSGIN_RETURN1_END () {56;}' unless defined(&TR_ESP_HANDLE_MORE_MSGIN_RETURN1_END);
    eval 'sub TR_ESP_HANDLE_MORE_MSGIN_RETURN2_END () {57;}' unless defined(&TR_ESP_HANDLE_MORE_MSGIN_RETURN2_END);
    eval 'sub TR_ESP_HANDLE_MSG_IN_START () {58;}' unless defined(&TR_ESP_HANDLE_MSG_IN_START);
    eval 'sub TR_ESP_HANDLE_MSG_IN_END () {59;}' unless defined(&TR_ESP_HANDLE_MSG_IN_END);
    eval 'sub TR_ESP_HANDLE_MSG_IN_DONE_START () {60;}' unless defined(&TR_ESP_HANDLE_MSG_IN_DONE_START);
    eval 'sub TR_ESP_HANDLE_MSG_IN_DONE_FINRST_END () {61;}' unless defined(&TR_ESP_HANDLE_MSG_IN_DONE_FINRST_END);
    eval 'sub TR_ESP_HANDLE_MSG_IN_DONE_RETURN1_END () {62;}' unless defined(&TR_ESP_HANDLE_MSG_IN_DONE_RETURN1_END);
    eval 'sub TR_ESP_HANDLE_MSG_IN_DONE_PHASEMANAGE_END () {63;}' unless defined(&TR_ESP_HANDLE_MSG_IN_DONE_PHASEMANAGE_END);
    eval 'sub TR_ESP_HANDLE_MSG_IN_DONE_SNDMSG_END () {64;}' unless defined(&TR_ESP_HANDLE_MSG_IN_DONE_SNDMSG_END);
    eval 'sub TR_ESP_HANDLE_MSG_IN_DONE_ACTION_END () {65;}' unless defined(&TR_ESP_HANDLE_MSG_IN_DONE_ACTION_END);
    eval 'sub TR_ESP_HANDLE_MSG_IN_DONE_RETURN2_END () {66;}' unless defined(&TR_ESP_HANDLE_MSG_IN_DONE_RETURN2_END);
    eval 'sub TR_ESP_HANDLE_MSG_OUT_START () {67;}' unless defined(&TR_ESP_HANDLE_MSG_OUT_START);
    eval 'sub TR_ESP_HANDLE_MSG_OUT_END () {68;}' unless defined(&TR_ESP_HANDLE_MSG_OUT_END);
    eval 'sub TR_ESP_HANDLE_MSG_OUT_PHASEMANAGE_END () {69;}' unless defined(&TR_ESP_HANDLE_MSG_OUT_PHASEMANAGE_END);
    eval 'sub TR_ESP_HANDLE_MSG_OUT_DONE_START () {70;}' unless defined(&TR_ESP_HANDLE_MSG_OUT_DONE_START);
    eval 'sub TR_ESP_HANDLE_MSG_OUT_DONE_END () {71;}' unless defined(&TR_ESP_HANDLE_MSG_OUT_DONE_END);
    eval 'sub TR_ESP_HANDLE_MSG_OUT_DONE_FINISH_END () {72;}' unless defined(&TR_ESP_HANDLE_MSG_OUT_DONE_FINISH_END);
    eval 'sub TR_ESP_HANDLE_MSG_OUT_DONE_PHASEMANAGE_END () {73;}' unless defined(&TR_ESP_HANDLE_MSG_OUT_DONE_PHASEMANAGE_END);
    eval 'sub TR_ESP_HANDLE_SELECTION_START () {74;}' unless defined(&TR_ESP_HANDLE_SELECTION_START);
    eval 'sub TR_ESP_HANDLE_SELECTION_END () {75;}' unless defined(&TR_ESP_HANDLE_SELECTION_END);
    eval 'sub TR_ESP_HANDLE_UNKNOWN_START () {76;}' unless defined(&TR_ESP_HANDLE_UNKNOWN_START);
    eval 'sub TR_ESP_HANDLE_UNKNOWN_END () {77;}' unless defined(&TR_ESP_HANDLE_UNKNOWN_END);
    eval 'sub TR_ESP_HANDLE_UNKNOWN_INT_DISCON_END () {78;}' unless defined(&TR_ESP_HANDLE_UNKNOWN_INT_DISCON_END);
    eval 'sub TR_ESP_HANDLE_UNKNOWN_PHASE_DATA_END () {79;}' unless defined(&TR_ESP_HANDLE_UNKNOWN_PHASE_DATA_END);
    eval 'sub TR_ESP_HANDLE_UNKNOWN_PHASE_MSG_OUT_END () {80;}' unless defined(&TR_ESP_HANDLE_UNKNOWN_PHASE_MSG_OUT_END);
    eval 'sub TR_ESP_HANDLE_UNKNOWN_PHASE_MSG_IN_END () {81;}' unless defined(&TR_ESP_HANDLE_UNKNOWN_PHASE_MSG_IN_END);
    eval 'sub TR_ESP_HANDLE_UNKNOWN_PHASE_STATUS_END () {82;}' unless defined(&TR_ESP_HANDLE_UNKNOWN_PHASE_STATUS_END);
    eval 'sub TR_ESP_HANDLE_UNKNOWN_PHASE_CMD_END () {83;}' unless defined(&TR_ESP_HANDLE_UNKNOWN_PHASE_CMD_END);
    eval 'sub TR_ESP_HANDLE_UNKNOWN_RESET_END () {84;}' unless defined(&TR_ESP_HANDLE_UNKNOWN_RESET_END);
    eval 'sub TR_ESP_HDATAD_START () {85;}' unless defined(&TR_ESP_HDATAD_START);
    eval 'sub TR_ESP_HDATAD_END () {86;}' unless defined(&TR_ESP_HDATAD_END);
    eval 'sub TR_ESP_HDATA_START () {87;}' unless defined(&TR_ESP_HDATA_START);
    eval 'sub TR_ESP_HDATA_END () {88;}' unless defined(&TR_ESP_HDATA_END);
    eval 'sub TR_ESP_ISTART_START () {89;}' unless defined(&TR_ESP_ISTART_START);
    eval 'sub TR_ESP_ISTART_END () {90;}' unless defined(&TR_ESP_ISTART_END);
    eval 'sub TR_ESP_PHASEMANAGE_CALL () {91;}' unless defined(&TR_ESP_PHASEMANAGE_CALL);
    eval 'sub TR_ESP_PHASEMANAGE_START () {92;}' unless defined(&TR_ESP_PHASEMANAGE_START);
    eval 'sub TR_ESP_PHASEMANAGE_END () {93;}' unless defined(&TR_ESP_PHASEMANAGE_END);
    eval 'sub TR_ESP_POLL_START () {94;}' unless defined(&TR_ESP_POLL_START);
    eval 'sub TR_ESP_POLL_END () {95;}' unless defined(&TR_ESP_POLL_END);
    eval 'sub TR_ESP_RECONNECT_START () {96;}' unless defined(&TR_ESP_RECONNECT_START);
    eval 'sub TR_ESP_RECONNECT_F1_END () {97;}' unless defined(&TR_ESP_RECONNECT_F1_END);
    eval 'sub TR_ESP_RECONNECT_RETURN1_END () {98;}' unless defined(&TR_ESP_RECONNECT_RETURN1_END);
    eval 'sub TR_ESP_RECONNECT_F2_END () {99;}' unless defined(&TR_ESP_RECONNECT_F2_END);
    eval 'sub TR_ESP_RECONNECT_PHASEMANAGE_END () {100;}' unless defined(&TR_ESP_RECONNECT_PHASEMANAGE_END);
    eval 'sub TR_ESP_RECONNECT_F3_END () {101;}' unless defined(&TR_ESP_RECONNECT_F3_END);
    eval 'sub TR_ESP_RECONNECT_RESET1_END () {102;}' unless defined(&TR_ESP_RECONNECT_RESET1_END);
    eval 'sub TR_ESP_RECONNECT_RESET2_END () {103;}' unless defined(&TR_ESP_RECONNECT_RESET2_END);
    eval 'sub TR_ESP_RECONNECT_RESET3_END () {104;}' unless defined(&TR_ESP_RECONNECT_RESET3_END);
    eval 'sub TR_ESP_RECONNECT_SEARCH_END () {105;}' unless defined(&TR_ESP_RECONNECT_SEARCH_END);
    eval 'sub TR_ESP_RECONNECT_RESET4_END () {106;}' unless defined(&TR_ESP_RECONNECT_RESET4_END);
    eval 'sub TR_ESP_RECONNECT_RETURN2_END () {107;}' unless defined(&TR_ESP_RECONNECT_RETURN2_END);
    eval 'sub TR_ESP_RECONNECT_RESET5_END () {108;}' unless defined(&TR_ESP_RECONNECT_RESET5_END);
    eval 'sub TR_ESP_RUNPOLL_START () {109;}' unless defined(&TR_ESP_RUNPOLL_START);
    eval 'sub TR_ESP_RUNPOLL_END () {110;}' unless defined(&TR_ESP_RUNPOLL_END);
    eval 'sub TR_ESP_SCSI_IMPL_PKTALLOC_START () {111;}' unless defined(&TR_ESP_SCSI_IMPL_PKTALLOC_START);
    eval 'sub TR_ESP_SCSI_IMPL_PKTALLOC_END () {112;}' unless defined(&TR_ESP_SCSI_IMPL_PKTALLOC_END);
    eval 'sub TR_ESP_SCSI_IMPL_PKTFREE_START () {113;}' unless defined(&TR_ESP_SCSI_IMPL_PKTFREE_START);
    eval 'sub TR_ESP_SCSI_IMPL_PKTFREE_END () {114;}' unless defined(&TR_ESP_SCSI_IMPL_PKTFREE_END);
    eval 'sub TR_ESP_STARTCMD_START () {115;}' unless defined(&TR_ESP_STARTCMD_START);
    eval 'sub TR_ESP_STARTCMD_END () {116;}' unless defined(&TR_ESP_STARTCMD_END);
    eval 'sub TR_ESP_STARTCMD_RE_SELECTION_END () {117;}' unless defined(&TR_ESP_STARTCMD_RE_SELECTION_END);
    eval 'sub TR_ESP_STARTCMD_ALLOC_TAG1_END () {118;}' unless defined(&TR_ESP_STARTCMD_ALLOC_TAG1_END);
    eval 'sub TR_ESP_STARTCMD_ALLOC_TAG2_END () {119;}' unless defined(&TR_ESP_STARTCMD_ALLOC_TAG2_END);
    eval 'sub TR_ESP_STARTCMD_PREEMPT_CALL () {120;}' unless defined(&TR_ESP_STARTCMD_PREEMPT_CALL);
    eval 'sub TR_ESP_START_START () {121;}' unless defined(&TR_ESP_START_START);
    eval 'sub TR_ESP_START_END () {122;}' unless defined(&TR_ESP_START_END);
    eval 'sub TR_ESP_START_PREPARE_PKT_END () {123;}' unless defined(&TR_ESP_START_PREPARE_PKT_END);
    eval 'sub TR_ESP_WATCH_START () {124;}' unless defined(&TR_ESP_WATCH_START);
    eval 'sub TR_ESP_WATCH_END () {125;}' unless defined(&TR_ESP_WATCH_END);
    eval 'sub TR_MAKE_SD_CMD_START () {126;}' unless defined(&TR_MAKE_SD_CMD_START);
    eval 'sub TR_MAKE_SD_CMD_END () {127;}' unless defined(&TR_MAKE_SD_CMD_END);
    eval 'sub TR_MAKE_SD_CMD_NO_PKT_ALLOCATED1_END () {128;}' unless defined(&TR_MAKE_SD_CMD_NO_PKT_ALLOCATED1_END);
    eval 'sub TR_MAKE_SD_CMD_NO_PKT_ALLOCATED2_END () {129;}' unless defined(&TR_MAKE_SD_CMD_NO_PKT_ALLOCATED2_END);
    eval 'sub TR_MAKE_SD_CMD_G0_START () {130;}' unless defined(&TR_MAKE_SD_CMD_G0_START);
    eval 'sub TR_MAKE_SD_CMD_G0_END () {131;}' unless defined(&TR_MAKE_SD_CMD_G0_END);
    eval 'sub TR_MAKE_SD_CMD_G0_SBUF_START () {132;}' unless defined(&TR_MAKE_SD_CMD_G0_SBUF_START);
    eval 'sub TR_MAKE_SD_CMD_G0_SBUF_END () {133;}' unless defined(&TR_MAKE_SD_CMD_G0_SBUF_END);
    eval 'sub TR_MAKE_SD_CMD_G1_START () {134;}' unless defined(&TR_MAKE_SD_CMD_G1_START);
    eval 'sub TR_MAKE_SD_CMD_G1_END () {135;}' unless defined(&TR_MAKE_SD_CMD_G1_END);
    eval 'sub TR_MAKE_SD_CMD_INIT_PKT_START () {136;}' unless defined(&TR_MAKE_SD_CMD_INIT_PKT_START);
    eval 'sub TR_MAKE_SD_CMD_INIT_PKT_END () {137;}' unless defined(&TR_MAKE_SD_CMD_INIT_PKT_END);
    eval 'sub TR_MAKE_SD_CMD_INIT_PKT_SBUF_START () {138;}' unless defined(&TR_MAKE_SD_CMD_INIT_PKT_SBUF_START);
    eval 'sub TR_MAKE_SD_CMD_INIT_PKT_SBUF_END () {139;}' unless defined(&TR_MAKE_SD_CMD_INIT_PKT_SBUF_END);
    eval 'sub TR_MAKE_SD_CMD_RA_START () {140;}' unless defined(&TR_MAKE_SD_CMD_RA_START);
    eval 'sub TR_MAKE_SD_CMD_RA_END () {141;}' unless defined(&TR_MAKE_SD_CMD_RA_END);
    eval 'sub TR_SDDONE_BIODONE_CALL () {142;}' unless defined(&TR_SDDONE_BIODONE_CALL);
    eval 'sub TR_SDDONE_START () {143;}' unless defined(&TR_SDDONE_START);
    eval 'sub TR_SDDONE_END () {144;}' unless defined(&TR_SDDONE_END);
    eval 'sub TR_SDINTR_START () {145;}' unless defined(&TR_SDINTR_START);
    eval 'sub TR_SDINTR_END () {146;}' unless defined(&TR_SDINTR_END);
    eval 'sub TR_SDINTR_COMMAND_DONE_END () {147;}' unless defined(&TR_SDINTR_COMMAND_DONE_END);
    eval 'sub TR_SDINTR_QUE_COMMAND_END () {148;}' unless defined(&TR_SDINTR_QUE_COMMAND_END);
    eval 'sub TR_SDINTR_QUE_FAILED_END () {149;}' unless defined(&TR_SDINTR_QUE_FAILED_END);
    eval 'sub TR_SDRUNOUT_START () {150;}' unless defined(&TR_SDRUNOUT_START);
    eval 'sub TR_SDRUNOUT_END () {151;}' unless defined(&TR_SDRUNOUT_END);
    eval 'sub TR_SDSTART_START () {152;}' unless defined(&TR_SDSTART_START);
    eval 'sub TR_SDSTART_END () {153;}' unless defined(&TR_SDSTART_END);
    eval 'sub TR_SDSTART_NO_WORK_END () {154;}' unless defined(&TR_SDSTART_NO_WORK_END);
    eval 'sub TR_SDSTART_NO_RESOURCES_END () {155;}' unless defined(&TR_SDSTART_NO_RESOURCES_END);
    eval 'sub TR_SDSTRATEGY_START () {156;}' unless defined(&TR_SDSTRATEGY_START);
    eval 'sub TR_SDSTRATEGY_END () {157;}' unless defined(&TR_SDSTRATEGY_END);
    eval 'sub TR_SDSTRATEGY_DISKSORT_START () {158;}' unless defined(&TR_SDSTRATEGY_DISKSORT_START);
    eval 'sub TR_SDSTRATEGY_DISKSORT_END () {159;}' unless defined(&TR_SDSTRATEGY_DISKSORT_END);
    eval 'sub TR_SDSTRATEGY_SDSTART_START () {160;}' unless defined(&TR_SDSTRATEGY_SDSTART_START);
    eval 'sub TR_SDSTRATEGY_SDSTART_END () {161;}' unless defined(&TR_SDSTRATEGY_SDSTART_END);
    eval 'sub TR_SD_CHECK_ERROR_START () {162;}' unless defined(&TR_SD_CHECK_ERROR_START);
    eval 'sub TR_SD_CHECK_ERROR_QUE_COMMAND_END () {163;}' unless defined(&TR_SD_CHECK_ERROR_QUE_COMMAND_END);
    eval 'sub TR_SD_CHECK_ERROR_END () {164;}' unless defined(&TR_SD_CHECK_ERROR_END);
    eval 'sub TR__ESP_START_START () {165;}' unless defined(&TR__ESP_START_START);
    eval 'sub TR__ESP_START_END () {166;}' unless defined(&TR__ESP_START_END);
    eval 'sub TR_ESP_INIT_CMD_START () {167;}' unless defined(&TR_ESP_INIT_CMD_START);
    eval 'sub TR_ESP_INIT_CMD_END () {168;}' unless defined(&TR_ESP_INIT_CMD_END);
    eval 'sub TR_ESP_EMPTY_STARTQ_START () {169;}' unless defined(&TR_ESP_EMPTY_STARTQ_START);
    eval 'sub TR_ESP_EMPTY_STARTQ_END () {170;}' unless defined(&TR_ESP_EMPTY_STARTQ_END);
    eval 'sub TR_SDSTRATEGY_SMALL_WINDOW_START () {171;}' unless defined(&TR_SDSTRATEGY_SMALL_WINDOW_START);
    eval 'sub TR_SDSTRATEGY_SMALL_WINDOW_END () {172;}' unless defined(&TR_SDSTRATEGY_SMALL_WINDOW_END);
    eval 'sub TR_SDSTART_SMALL_WINDOW_START () {173;}' unless defined(&TR_SDSTART_SMALL_WINDOW_START);
    eval 'sub TR_SDSTART_SMALL_WINDOW_END () {174;}' unless defined(&TR_SDSTART_SMALL_WINDOW_END);
    eval 'sub TR_ESP_USTART_START () {175;}' unless defined(&TR_ESP_USTART_START);
    eval 'sub TR_ESP_USTART_END () {176;}' unless defined(&TR_ESP_USTART_END);
    eval 'sub TR_ESP_USTART_NOT_FOUND_END () {177;}' unless defined(&TR_ESP_USTART_NOT_FOUND_END);
    eval 'sub TR_ESP_USTART_DEFAULT_END () {178;}' unless defined(&TR_ESP_USTART_DEFAULT_END);
    eval 'sub TR_ESP_PREPARE_PKT_START () {179;}' unless defined(&TR_ESP_PREPARE_PKT_START);
    eval 'sub TR_ESP_PREPARE_PKT_TRAN_BADPKT_END () {180;}' unless defined(&TR_ESP_PREPARE_PKT_TRAN_BADPKT_END);
    eval 'sub TR_ESP_PREPARE_PKT_TRAN_ACCEPT_END () {181;}' unless defined(&TR_ESP_PREPARE_PKT_TRAN_ACCEPT_END);
    eval 'sub TR_ESP_ALLOC_TAG_START () {182;}' unless defined(&TR_ESP_ALLOC_TAG_START);
    eval 'sub TR_ESP_ALLOC_TAG_END () {183;}' unless defined(&TR_ESP_ALLOC_TAG_END);
    eval 'sub TR_ESP_CALL_PKT_COMP_START () {184;}' unless defined(&TR_ESP_CALL_PKT_COMP_START);
    eval 'sub TR_ESP_CALL_PKT_COMP_END () {185;}' unless defined(&TR_ESP_CALL_PKT_COMP_END);
    eval 'sub TR_ESP_CALL_PKT_COMP_RETURN1_END () {186;}' unless defined(&TR_ESP_CALL_PKT_COMP_RETURN1_END);
    eval 'sub TR_ESP_CALL_PKT_COMP_RETURN2_END () {187;}' unless defined(&TR_ESP_CALL_PKT_COMP_RETURN2_END);
    eval 'sub TR_ESP_POLL_LOOP_START () {188;}' unless defined(&TR_ESP_POLL_LOOP_START);
    eval 'sub TR_ESP_POLL_LOOP_END () {189;}' unless defined(&TR_ESP_POLL_LOOP_END);
    eval 'sub TR_ESP_POLL_SUN4D_START () {190;}' unless defined(&TR_ESP_POLL_SUN4D_START);
    eval 'sub TR_ESP_POLL_SUN4D_END () {191;}' unless defined(&TR_ESP_POLL_SUN4D_END);
    eval 'sub TR_ESP_SCSI_IMPL_DMAFREE_START () {192;}' unless defined(&TR_ESP_SCSI_IMPL_DMAFREE_START);
    eval 'sub TR_ESP_SCSI_IMPL_DMAFREE_END () {193;}' unless defined(&TR_ESP_SCSI_IMPL_DMAFREE_END);
    eval 'sub TR_SDWRITE_START () {194;}' unless defined(&TR_SDWRITE_START);
    eval 'sub TR_SDWRITE_END () {195;}' unless defined(&TR_SDWRITE_END);
    eval 'sub TR_SDREAD_START () {196;}' unless defined(&TR_SDREAD_START);
    eval 'sub TR_SDREAD_END () {197;}' unless defined(&TR_SDREAD_END);
    eval 'sub TR_ISP_SCSI_GETCAP_START () {1;}' unless defined(&TR_ISP_SCSI_GETCAP_START);
    eval 'sub TR_ISP_SCSI_GETCAP_END () {2;}' unless defined(&TR_ISP_SCSI_GETCAP_END);
    eval 'sub TR_ISP_SCSI_SETCAP_START () {3;}' unless defined(&TR_ISP_SCSI_SETCAP_START);
    eval 'sub TR_ISP_SCSI_SETCAP_END () {4;}' unless defined(&TR_ISP_SCSI_SETCAP_END);
    eval 'sub TR_ISP_SCAN_TIMEOUT_START () {5;}' unless defined(&TR_ISP_SCAN_TIMEOUT_START);
    eval 'sub TR_ISP_SCAN_TIMEOUT_END () {6;}' unless defined(&TR_ISP_SCAN_TIMEOUT_END);
    eval 'sub TR_ISP_SCSI_START_START () {7;}' unless defined(&TR_ISP_SCSI_START_START);
    eval 'sub TR_ISP_SCSI_START_DMA_START () {8;}' unless defined(&TR_ISP_SCSI_START_DMA_START);
    eval 'sub TR_ISP_SCSI_START_DMA_END () {9;}' unless defined(&TR_ISP_SCSI_START_DMA_END);
    eval 'sub TR_ISP_SCSI_START_END () {10;}' unless defined(&TR_ISP_SCSI_START_END);
    eval 'sub TR_ISP_I_START_CMD_START () {11;}' unless defined(&TR_ISP_I_START_CMD_START);
    eval 'sub TR_ISP_I_START_CMD_Q_FULL_END () {12;}' unless defined(&TR_ISP_I_START_CMD_Q_FULL_END);
    eval 'sub TR_ISP_I_START_CMD_SLOT_ALLOC_START () {13;}' unless defined(&TR_ISP_I_START_CMD_SLOT_ALLOC_START);
    eval 'sub TR_ISP_I_START_CMD_SLOT_ALLOC_END () {14;}' unless defined(&TR_ISP_I_START_CMD_SLOT_ALLOC_END);
    eval 'sub TR_ISP_I_START_CMD_END () {15;}' unless defined(&TR_ISP_I_START_CMD_END);
    eval 'sub TR_ISP_I_RUN_POLLED_CMD_START () {16;}' unless defined(&TR_ISP_I_RUN_POLLED_CMD_START);
    eval 'sub TR_ISP_I_RUN_POLLED_CMD_END () {17;}' unless defined(&TR_ISP_I_RUN_POLLED_CMD_END);
    eval 'sub TR_ISP_INTR_START () {18;}' unless defined(&TR_ISP_INTR_START);
    eval 'sub TR_ISP_INTR_NO_INTR_END () {19;}' unless defined(&TR_ISP_INTR_NO_INTR_END);
    eval 'sub TR_ISP_INTR_EVENT_END () {20;}' unless defined(&TR_ISP_INTR_EVENT_END);
    eval 'sub TR_ISP_INTR_Q_START () {21;}' unless defined(&TR_ISP_INTR_Q_START);
    eval 'sub TR_ISP_INTR_INVALID_END () {22;}' unless defined(&TR_ISP_INTR_INVALID_END);
    eval 'sub TR_ISP_INTR_PKT_START () {23;}' unless defined(&TR_ISP_INTR_PKT_START);
    eval 'sub TR_ISP_INTR_PKT_END () {24;}' unless defined(&TR_ISP_INTR_PKT_END);
    eval 'sub TR_ISP_INTR_Q_END () {25;}' unless defined(&TR_ISP_INTR_Q_END);
    eval 'sub TR_ISP_INTR_END () {26;}' unless defined(&TR_ISP_INTR_END);
    eval 'sub TR_ISP_I_FLAG_EVENT_START () {27;}' unless defined(&TR_ISP_I_FLAG_EVENT_START);
    eval 'sub TR_ISP_I_FLAG_EVENT_IGNORE_END () {28;}' unless defined(&TR_ISP_I_FLAG_EVENT_IGNORE_END);
    eval 'sub TR_ISP_I_FLAG_EVENT_END () {29;}' unless defined(&TR_ISP_I_FLAG_EVENT_END);
    eval 'sub TR_ISP_I_EVENT_START () {30;}' unless defined(&TR_ISP_I_EVENT_START);
    eval 'sub TR_ISP_I_EVENT_RETURN_END () {31;}' unless defined(&TR_ISP_I_EVENT_RETURN_END);
    eval 'sub TR_ISP_I_EVENT_END () {32;}' unless defined(&TR_ISP_I_EVENT_END);
    eval 'sub TR_ISP_I_ASYNCH_EVENT_START () {33;}' unless defined(&TR_ISP_I_ASYNCH_EVENT_START);
    eval 'sub TR_ISP_I_ASYNCH_EVENT_END () {34;}' unless defined(&TR_ISP_I_ASYNCH_EVENT_END);
    eval 'sub TR_ISP_I_CMD_EVENT_START () {35;}' unless defined(&TR_ISP_I_CMD_EVENT_START);
    eval 'sub TR_ISP_I_CMD_EVENT_END () {36;}' unless defined(&TR_ISP_I_CMD_EVENT_END);
    eval 'sub TR_ISP_I_RESPONSE_ERROR_START () {37;}' unless defined(&TR_ISP_I_RESPONSE_ERROR_START);
    eval 'sub TR_ISP_I_RESPONSE_ERROR_END () {38;}' unless defined(&TR_ISP_I_RESPONSE_ERROR_END);
    eval 'sub TR_ISP_I_SEND_CMD_START () {39;}' unless defined(&TR_ISP_I_SEND_CMD_START);
    eval 'sub TR_ISP_I_SEND_CMD_END () {40;}' unless defined(&TR_ISP_I_SEND_CMD_END);
    eval 'sub TR_ISP_I_CALLBACK_START () {41;}' unless defined(&TR_ISP_I_CALLBACK_START);
    eval 'sub TR_ISP_I_CALLBACK_END () {42;}' unless defined(&TR_ISP_I_CALLBACK_END);
    eval 'sub TR_ISP_I_WATCH_START () {43;}' unless defined(&TR_ISP_I_WATCH_START);
    eval 'sub TR_ISP_I_WATCH_END () {44;}' unless defined(&TR_ISP_I_WATCH_END);
    eval 'sub TR_ISP_I_TIMEOUT_START () {45;}' unless defined(&TR_ISP_I_TIMEOUT_START);
    eval 'sub TR_ISP_I_TIMEOUT_END () {46;}' unless defined(&TR_ISP_I_TIMEOUT_END);
    eval 'sub TR_ISP_I_QFLUSH_START () {47;}' unless defined(&TR_ISP_I_QFLUSH_START);
    eval 'sub TR_ISP_I_QFLUSH_END () {48;}' unless defined(&TR_ISP_I_QFLUSH_END);
    eval 'sub TR_ISP_I_SET_MARKER_START () {49;}' unless defined(&TR_ISP_I_SET_MARKER_START);
    eval 'sub TR_ISP_I_SET_MARKER_END () {50;}' unless defined(&TR_ISP_I_SET_MARKER_END);
    eval 'sub TR_ISP_SCSI_ABORT_START () {51;}' unless defined(&TR_ISP_SCSI_ABORT_START);
    eval 'sub TR_ISP_SCSI_ABORT_FALSE_END () {52;}' unless defined(&TR_ISP_SCSI_ABORT_FALSE_END);
    eval 'sub TR_ISP_SCSI_ABORT_END () {53;}' unless defined(&TR_ISP_SCSI_ABORT_END);
    eval 'sub TR_ISP_SCSI_RESET_START () {54;}' unless defined(&TR_ISP_SCSI_RESET_START);
    eval 'sub TR_ISP_SCSI_RESET_FALSE_END () {55;}' unless defined(&TR_ISP_SCSI_RESET_FALSE_END);
    eval 'sub TR_ISP_SCSI_RESET_END () {56;}' unless defined(&TR_ISP_SCSI_RESET_END);
    eval 'sub TR_ISP_I_RESET_INTERFACE_START () {57;}' unless defined(&TR_ISP_I_RESET_INTERFACE_START);
    eval 'sub TR_ISP_I_RESET_INTERFACE_END () {58;}' unless defined(&TR_ISP_I_RESET_INTERFACE_END);
    eval 'sub TR_ISP_I_CALL_PKT_COMP_START () {59;}' unless defined(&TR_ISP_I_CALL_PKT_COMP_START);
    eval 'sub TR_ISP_I_CALL_PKT_COMP_END () {60;}' unless defined(&TR_ISP_I_CALL_PKT_COMP_END);
    eval 'sub TR_ISP_I_EMPTY_WAITQ_START () {61;}' unless defined(&TR_ISP_I_EMPTY_WAITQ_START);
    eval 'sub TR_ISP_I_EMPTY_WAITQ_END () {62;}' unless defined(&TR_ISP_I_EMPTY_WAITQ_END);
    eval 'sub TR_ISP_I_INIT_CMD_START () {63;}' unless defined(&TR_ISP_I_INIT_CMD_START);
    eval 'sub TR_ISP_SCSI_START_BIG_CDB () {64;}' unless defined(&TR_ISP_SCSI_START_BIG_CDB);
    eval 'sub TR_ISP_I_INIT_CMD_END () {65;}' unless defined(&TR_ISP_I_INIT_CMD_END);
    eval 'sub TR_ISP_I_START_CMD_AFTER_SYNC () {66;}' unless defined(&TR_ISP_I_START_CMD_AFTER_SYNC);
    eval 'sub TR_ISP_INTR_LOOP_START () {67;}' unless defined(&TR_ISP_INTR_LOOP_START);
    eval 'sub TR_ISP_INTR_LOOP_END () {68;}' unless defined(&TR_ISP_INTR_LOOP_END);
    eval 'sub TR_ISP_INTR_ASYNC_END () {69;}' unless defined(&TR_ISP_INTR_ASYNC_END);
    eval 'sub TR_ISP_INTR_MBOX_END () {70;}' unless defined(&TR_ISP_INTR_MBOX_END);
    eval 'sub TR_ISP_INTR_NO_RESP_END () {71;}' unless defined(&TR_ISP_INTR_NO_RESP_END);
    eval 'sub TR_ISP_INTR_AGAIN () {72;}' unless defined(&TR_ISP_INTR_AGAIN);
    eval 'sub TR_ISP_I_MBOX_CMD_COMPLETE_START () {74;}' unless defined(&TR_ISP_I_MBOX_CMD_COMPLETE_START);
    eval 'sub TR_ISP_I_MBOX_CMD_COMPLETE_END () {75;}' unless defined(&TR_ISP_I_MBOX_CMD_COMPLETE_END);
    eval 'sub TR_ISP_I_MBOX_CMD_START_START () {76;}' unless defined(&TR_ISP_I_MBOX_CMD_START_START);
    eval 'sub TR_ISP_I_MBOX_CMD_START_END () {77;}' unless defined(&TR_ISP_I_MBOX_CMD_START_END);
    eval 'sub TR_ISP_SCSI_PKTALLOC_START () {78;}' unless defined(&TR_ISP_SCSI_PKTALLOC_START);
    eval 'sub TR_ISP_SCSI_PKTALLOC_END () {79;}' unless defined(&TR_ISP_SCSI_PKTALLOC_END);
    eval 'sub TR_ISP_SCSI_PKTFREE_START () {80;}' unless defined(&TR_ISP_SCSI_PKTFREE_START);
    eval 'sub TR_ISP_SCSI_PKTFREE_DONE () {81;}' unless defined(&TR_ISP_SCSI_PKTFREE_DONE);
    eval 'sub TR_ISP_SCSI_PKTFREE_END () {82;}' unless defined(&TR_ISP_SCSI_PKTFREE_END);
    eval 'sub TR_ISP_SCSI_DMAGET_START () {83;}' unless defined(&TR_ISP_SCSI_DMAGET_START);
    eval 'sub TR_ISP_SCSI_DMAGET_ERROR_END () {84;}' unless defined(&TR_ISP_SCSI_DMAGET_ERROR_END);
    eval 'sub TR_ISP_SCSI_DMAGET_END () {85;}' unless defined(&TR_ISP_SCSI_DMAGET_END);
    eval 'sub TR_ISP_SCSI_DMAFREE_START () {86;}' unless defined(&TR_ISP_SCSI_DMAFREE_START);
    eval 'sub TR_ISP_SCSI_DMAFREE_END () {87;}' unless defined(&TR_ISP_SCSI_DMAFREE_END);
    eval 'sub TR_ISP_I_RESET_INIT_CHIP_START () {88;}' unless defined(&TR_ISP_I_RESET_INIT_CHIP_START);
    eval 'sub TR_ISP_I_RESET_INIT_CHIP_END () {89;}' unless defined(&TR_ISP_I_RESET_INIT_CHIP_END);
    eval 'sub TR_FASSVC_ACTION_CALL () {1;}' unless defined(&TR_FASSVC_ACTION_CALL);
    eval 'sub TR_FASSVC_END () {2;}' unless defined(&TR_FASSVC_END);
    eval 'sub TR_FASSVC_START () {3;}' unless defined(&TR_FASSVC_START);
    eval 'sub TR_FAS_ALLOC_TAG_END () {4;}' unless defined(&TR_FAS_ALLOC_TAG_END);
    eval 'sub TR_FAS_ALLOC_TAG_START () {5;}' unless defined(&TR_FAS_ALLOC_TAG_START);
    eval 'sub TR_FAS_DOPOLL_END () {6;}' unless defined(&TR_FAS_DOPOLL_END);
    eval 'sub TR_FAS_DOPOLL_START () {7;}' unless defined(&TR_FAS_DOPOLL_START);
    eval 'sub TR_FAS_EMPTY_WAITQ_END () {8;}' unless defined(&TR_FAS_EMPTY_WAITQ_END);
    eval 'sub TR_FAS_EMPTY_WAITQ_START () {9;}' unless defined(&TR_FAS_EMPTY_WAITQ_START);
    eval 'sub TR_FAS_FINISH_END () {10;}' unless defined(&TR_FAS_FINISH_END);
    eval 'sub TR_FAS_FINISH_SELECT_ACTION3_END () {11;}' unless defined(&TR_FAS_FINISH_SELECT_ACTION3_END);
    eval 'sub TR_FAS_FINISH_SELECT_FINISH_END () {12;}' unless defined(&TR_FAS_FINISH_SELECT_FINISH_END);
    eval 'sub TR_FAS_FINISH_SELECT_RESET1_END () {13;}' unless defined(&TR_FAS_FINISH_SELECT_RESET1_END);
    eval 'sub TR_FAS_FINISH_SELECT_RESET2_END () {14;}' unless defined(&TR_FAS_FINISH_SELECT_RESET2_END);
    eval 'sub TR_FAS_FINISH_SELECT_RESET3_END () {15;}' unless defined(&TR_FAS_FINISH_SELECT_RESET3_END);
    eval 'sub TR_FAS_FINISH_SELECT_START () {16;}' unless defined(&TR_FAS_FINISH_SELECT_START);
    eval 'sub TR_FAS_FINISH_START () {17;}' unless defined(&TR_FAS_FINISH_START);
    eval 'sub TR_FAS_HANDLE_CLEARING_ABORT_END () {18;}' unless defined(&TR_FAS_HANDLE_CLEARING_ABORT_END);
    eval 'sub TR_FAS_HANDLE_CLEARING_END () {19;}' unless defined(&TR_FAS_HANDLE_CLEARING_END);
    eval 'sub TR_FAS_HANDLE_CLEARING_RETURN1_END () {20;}' unless defined(&TR_FAS_HANDLE_CLEARING_RETURN1_END);
    eval 'sub TR_FAS_HANDLE_CLEARING_RETURN3_END () {21;}' unless defined(&TR_FAS_HANDLE_CLEARING_RETURN3_END);
    eval 'sub TR_FAS_HANDLE_CLEARING_START () {22;}' unless defined(&TR_FAS_HANDLE_CLEARING_START);
    eval 'sub TR_FAS_HANDLE_CMD_DONE_ABORT1_END () {23;}' unless defined(&TR_FAS_HANDLE_CMD_DONE_ABORT1_END);
    eval 'sub TR_FAS_HANDLE_CMD_DONE_END () {24;}' unless defined(&TR_FAS_HANDLE_CMD_DONE_END);
    eval 'sub TR_FAS_HANDLE_CMD_DONE_START () {25;}' unless defined(&TR_FAS_HANDLE_CMD_DONE_START);
    eval 'sub TR_FAS_HANDLE_CMD_START_END () {26;}' unless defined(&TR_FAS_HANDLE_CMD_START_END);
    eval 'sub TR_FAS_HANDLE_CMD_START_START () {27;}' unless defined(&TR_FAS_HANDLE_CMD_START_START);
    eval 'sub TR_FAS_HANDLE_C_CMPLT_ACTION1_END () {28;}' unless defined(&TR_FAS_HANDLE_C_CMPLT_ACTION1_END);
    eval 'sub TR_FAS_HANDLE_C_CMPLT_ACTION2_END () {29;}' unless defined(&TR_FAS_HANDLE_C_CMPLT_ACTION2_END);
    eval 'sub TR_FAS_HANDLE_C_CMPLT_ACTION3_END () {30;}' unless defined(&TR_FAS_HANDLE_C_CMPLT_ACTION3_END);
    eval 'sub TR_FAS_HANDLE_C_CMPLT_ACTION4_END () {31;}' unless defined(&TR_FAS_HANDLE_C_CMPLT_ACTION4_END);
    eval 'sub TR_FAS_HANDLE_C_CMPLT_ACTION5_END () {32;}' unless defined(&TR_FAS_HANDLE_C_CMPLT_ACTION5_END);
    eval 'sub TR_FAS_HANDLE_C_CMPLT_RETURN1_END () {33;}' unless defined(&TR_FAS_HANDLE_C_CMPLT_RETURN1_END);
    eval 'sub TR_FAS_HANDLE_C_CMPLT_START () {34;}' unless defined(&TR_FAS_HANDLE_C_CMPLT_START);
    eval 'sub TR_FAS_HANDLE_DATA_ABORT1_END () {35;}' unless defined(&TR_FAS_HANDLE_DATA_ABORT1_END);
    eval 'sub TR_FAS_HANDLE_DATA_ABORT2_END () {36;}' unless defined(&TR_FAS_HANDLE_DATA_ABORT2_END);
    eval 'sub TR_FAS_HANDLE_DATA_DONE_ACTION2_END () {37;}' unless defined(&TR_FAS_HANDLE_DATA_DONE_ACTION2_END);
    eval 'sub TR_FAS_HANDLE_DATA_DONE_PHASEMANAGE_END () {38;}' unless defined(&TR_FAS_HANDLE_DATA_DONE_PHASEMANAGE_END);
    eval 'sub TR_FAS_HANDLE_DATA_DONE_RESET_END () {39;}' unless defined(&TR_FAS_HANDLE_DATA_DONE_RESET_END);
    eval 'sub TR_FAS_HANDLE_DATA_DONE_START () {40;}' unless defined(&TR_FAS_HANDLE_DATA_DONE_START);
    eval 'sub TR_FAS_HANDLE_DATA_END () {41;}' unless defined(&TR_FAS_HANDLE_DATA_END);
    eval 'sub TR_FAS_HANDLE_DATA_START () {42;}' unless defined(&TR_FAS_HANDLE_DATA_START);
    eval 'sub TR_FAS_HANDLE_MORE_MSGIN_RETURN2_END () {43;}' unless defined(&TR_FAS_HANDLE_MORE_MSGIN_RETURN2_END);
    eval 'sub TR_FAS_HANDLE_MORE_MSGIN_START () {44;}' unless defined(&TR_FAS_HANDLE_MORE_MSGIN_START);
    eval 'sub TR_FAS_HANDLE_MSG_IN_DONE_ACTION_END () {45;}' unless defined(&TR_FAS_HANDLE_MSG_IN_DONE_ACTION_END);
    eval 'sub TR_FAS_HANDLE_MSG_IN_DONE_RETURN2_END () {46;}' unless defined(&TR_FAS_HANDLE_MSG_IN_DONE_RETURN2_END);
    eval 'sub TR_FAS_HANDLE_MSG_IN_DONE_SNDMSG_END () {47;}' unless defined(&TR_FAS_HANDLE_MSG_IN_DONE_SNDMSG_END);
    eval 'sub TR_FAS_HANDLE_MSG_IN_DONE_START () {48;}' unless defined(&TR_FAS_HANDLE_MSG_IN_DONE_START);
    eval 'sub TR_FAS_HANDLE_MSG_IN_END () {49;}' unless defined(&TR_FAS_HANDLE_MSG_IN_END);
    eval 'sub TR_FAS_HANDLE_MSG_IN_START () {50;}' unless defined(&TR_FAS_HANDLE_MSG_IN_START);
    eval 'sub TR_FAS_HANDLE_MSG_OUT_DONE_END () {51;}' unless defined(&TR_FAS_HANDLE_MSG_OUT_DONE_END);
    eval 'sub TR_FAS_HANDLE_MSG_OUT_DONE_PHASEMANAGE_END () {52;}' unless defined(&TR_FAS_HANDLE_MSG_OUT_DONE_PHASEMANAGE_END);
    eval 'sub TR_FAS_HANDLE_MSG_OUT_DONE_START () {53;}' unless defined(&TR_FAS_HANDLE_MSG_OUT_DONE_START);
    eval 'sub TR_FAS_HANDLE_MSG_OUT_END () {54;}' unless defined(&TR_FAS_HANDLE_MSG_OUT_END);
    eval 'sub TR_FAS_HANDLE_MSG_OUT_PHASEMANAGE_END () {55;}' unless defined(&TR_FAS_HANDLE_MSG_OUT_PHASEMANAGE_END);
    eval 'sub TR_FAS_HANDLE_MSG_OUT_START () {56;}' unless defined(&TR_FAS_HANDLE_MSG_OUT_START);
    eval 'sub TR_FAS_HANDLE_UNKNOWN_INT_DISCON_END () {57;}' unless defined(&TR_FAS_HANDLE_UNKNOWN_INT_DISCON_END);
    eval 'sub TR_FAS_HANDLE_UNKNOWN_RESET_END () {58;}' unless defined(&TR_FAS_HANDLE_UNKNOWN_RESET_END);
    eval 'sub TR_FAS_HANDLE_UNKNOWN_START () {59;}' unless defined(&TR_FAS_HANDLE_UNKNOWN_START);
    eval 'sub TR_FAS_ISTART_END () {60;}' unless defined(&TR_FAS_ISTART_END);
    eval 'sub TR_FAS_ISTART_START () {61;}' unless defined(&TR_FAS_ISTART_START);
    eval 'sub TR_FAS_PHASEMANAGE_CALL () {62;}' unless defined(&TR_FAS_PHASEMANAGE_CALL);
    eval 'sub TR_FAS_PHASEMANAGE_END () {63;}' unless defined(&TR_FAS_PHASEMANAGE_END);
    eval 'sub TR_FAS_PHASEMANAGE_START () {64;}' unless defined(&TR_FAS_PHASEMANAGE_START);
    eval 'sub TR_FAS_POLL_END () {65;}' unless defined(&TR_FAS_POLL_END);
    eval 'sub TR_FAS_POLL_START () {66;}' unless defined(&TR_FAS_POLL_START);
    eval 'sub TR_FAS_PREPARE_PKT_TRAN_ACCEPT_END () {67;}' unless defined(&TR_FAS_PREPARE_PKT_TRAN_ACCEPT_END);
    eval 'sub TR_FAS_PREPARE_PKT_TRAN_BADPKT_END () {68;}' unless defined(&TR_FAS_PREPARE_PKT_TRAN_BADPKT_END);
    eval 'sub TR_FAS_RECONNECT_F2_END () {69;}' unless defined(&TR_FAS_RECONNECT_F2_END);
    eval 'sub TR_FAS_RECONNECT_RESET5_END () {70;}' unless defined(&TR_FAS_RECONNECT_RESET5_END);
    eval 'sub TR_FAS_RECONNECT_RETURN2_END () {71;}' unless defined(&TR_FAS_RECONNECT_RETURN2_END);
    eval 'sub TR_FAS_RECONNECT_START () {72;}' unless defined(&TR_FAS_RECONNECT_START);
    eval 'sub TR_FAS_RUNPOLL_END () {73;}' unless defined(&TR_FAS_RUNPOLL_END);
    eval 'sub TR_FAS_RUNPOLL_START () {74;}' unless defined(&TR_FAS_RUNPOLL_START);
    eval 'sub TR_FAS_SCSI_IMPL_DMAFREE_END () {75;}' unless defined(&TR_FAS_SCSI_IMPL_DMAFREE_END);
    eval 'sub TR_FAS_SCSI_IMPL_DMAFREE_START () {76;}' unless defined(&TR_FAS_SCSI_IMPL_DMAFREE_START);
    eval 'sub TR_FAS_SCSI_IMPL_PKTALLOC_END () {77;}' unless defined(&TR_FAS_SCSI_IMPL_PKTALLOC_END);
    eval 'sub TR_FAS_SCSI_IMPL_PKTALLOC_START () {78;}' unless defined(&TR_FAS_SCSI_IMPL_PKTALLOC_START);
    eval 'sub TR_FAS_SCSI_IMPL_PKTFREE_END () {79;}' unless defined(&TR_FAS_SCSI_IMPL_PKTFREE_END);
    eval 'sub TR_FAS_SCSI_IMPL_PKTFREE_START () {80;}' unless defined(&TR_FAS_SCSI_IMPL_PKTFREE_START);
    eval 'sub TR_FAS_STARTCMD_END () {81;}' unless defined(&TR_FAS_STARTCMD_END);
    eval 'sub TR_FAS_STARTCMD_START () {82;}' unless defined(&TR_FAS_STARTCMD_START);
    eval 'sub TR_FAS_START_END () {83;}' unless defined(&TR_FAS_START_END);
    eval 'sub TR_FAS_START_PREPARE_PKT_END () {84;}' unless defined(&TR_FAS_START_PREPARE_PKT_END);
    eval 'sub TR_FAS_START_START () {85;}' unless defined(&TR_FAS_START_START);
    eval 'sub TR_FAS_USTART_END () {86;}' unless defined(&TR_FAS_USTART_END);
    eval 'sub TR_FAS_USTART_NOT_FOUND_END () {87;}' unless defined(&TR_FAS_USTART_NOT_FOUND_END);
    eval 'sub TR_FAS_USTART_START () {88;}' unless defined(&TR_FAS_USTART_START);
    eval 'sub TR_FAS_WATCH_END () {89;}' unless defined(&TR_FAS_WATCH_END);
    eval 'sub TR_FAS_SCSI_IMPL_DMAGET_END () {90;}' unless defined(&TR_FAS_SCSI_IMPL_DMAGET_END);
    eval 'sub TR_FAS_SCSI_IMPL_DMAGET_START () {91;}' unless defined(&TR_FAS_SCSI_IMPL_DMAGET_START);
    eval 'sub TR__FAS_START_END () {92;}' unless defined(&TR__FAS_START_END);
    eval 'sub TR__FAS_START_START () {93;}' unless defined(&TR__FAS_START_START);
    eval 'sub TR_FAS_RECONNECT_RETURN1_END () {94;}' unless defined(&TR_FAS_RECONNECT_RETURN1_END);
    eval 'sub TR_FAS_RECONNECT_PHASEMANAGE_END () {95;}' unless defined(&TR_FAS_RECONNECT_PHASEMANAGE_END);
    eval 'sub TR_FAS_RECONNECT_F3_END () {96;}' unless defined(&TR_FAS_RECONNECT_F3_END);
    eval 'sub TR_FAS_HANDLE_UNKNOWN_PHASE_DATA_END () {97;}' unless defined(&TR_FAS_HANDLE_UNKNOWN_PHASE_DATA_END);
    eval 'sub TR_FAS_HANDLE_UNKNOWN_PHASE_MSG_OUT_END () {98;}' unless defined(&TR_FAS_HANDLE_UNKNOWN_PHASE_MSG_OUT_END);
    eval 'sub TR_FAS_HANDLE_UNKNOWN_PHASE_MSG_IN_END () {99;}' unless defined(&TR_FAS_HANDLE_UNKNOWN_PHASE_MSG_IN_END);
    eval 'sub TR_FAS_HANDLE_UNKNOWN_PHASE_STATUS_END () {100;}' unless defined(&TR_FAS_HANDLE_UNKNOWN_PHASE_STATUS_END);
    eval 'sub TR_FAS_HANDLE_UNKNOWN_PHASE_CMD_END () {101;}' unless defined(&TR_FAS_HANDLE_UNKNOWN_PHASE_CMD_END);
    eval 'sub TR_FAS_HANDLE_CLEARING_FINRST_END () {102;}' unless defined(&TR_FAS_HANDLE_CLEARING_FINRST_END);
    eval 'sub TR_FAS_HANDLE_CLEARING_RETURN2_END () {103;}' unless defined(&TR_FAS_HANDLE_CLEARING_RETURN2_END);
    eval 'sub TR_FAS_HANDLE_DATA_DONE_ACTION1_END () {104;}' unless defined(&TR_FAS_HANDLE_DATA_DONE_ACTION1_END);
    eval 'sub TR_FAS_HANDLE_C_CMPLT_FINRST_END () {105;}' unless defined(&TR_FAS_HANDLE_C_CMPLT_FINRST_END);
    eval 'sub TR_FAS_HANDLE_MORE_MSGIN_RETURN1_END () {106;}' unless defined(&TR_FAS_HANDLE_MORE_MSGIN_RETURN1_END);
    eval 'sub TR_FAS_HANDLE_MSG_IN_DONE_FINRST_END () {107;}' unless defined(&TR_FAS_HANDLE_MSG_IN_DONE_FINRST_END);
    eval 'sub TR_FAS_HANDLE_MSG_IN_DONE_RETURN1_END () {108;}' unless defined(&TR_FAS_HANDLE_MSG_IN_DONE_RETURN1_END);
    eval 'sub TR_FAS_HANDLE_MSG_IN_DONE_PHASEMANAGE_END () {109;}' unless defined(&TR_FAS_HANDLE_MSG_IN_DONE_PHASEMANAGE_END);
    eval 'sub TR_FAS_HANDLE_MSG_OUT_DONE_FINISH_END () {110;}' unless defined(&TR_FAS_HANDLE_MSG_OUT_DONE_FINISH_END);
    eval 'sub TR_FAS_EMPTY_CALLBACKQ_START () {111;}' unless defined(&TR_FAS_EMPTY_CALLBACKQ_START);
    eval 'sub TR_FAS_EMPTY_CALLBACKQ_END () {112;}' unless defined(&TR_FAS_EMPTY_CALLBACKQ_END);
    eval 'sub TR_FAS_CALL_PKT_COMP_START () {113;}' unless defined(&TR_FAS_CALL_PKT_COMP_START);
    eval 'sub TR_FAS_CALL_PKT_COMP_END () {114;}' unless defined(&TR_FAS_CALL_PKT_COMP_END);
    eval 'sub TR_LWP_CREATE_START () {0;}' unless defined(&TR_LWP_CREATE_START);
    eval 'sub TR_LWP_CREATE_END () {1;}' unless defined(&TR_LWP_CREATE_END);
    eval 'sub TR_LWP_EXIT_START () {2;}' unless defined(&TR_LWP_EXIT_START);
    eval 'sub TR_LWP_EXIT_END () {3;}' unless defined(&TR_LWP_EXIT_END);
    eval 'sub TR_LWP_SUSPEND_START () {4;}' unless defined(&TR_LWP_SUSPEND_START);
    eval 'sub TR_LWP_SUSPEND_END () {5;}' unless defined(&TR_LWP_SUSPEND_END);
    eval 'sub TR_LWP_CONTINUE_START () {6;}' unless defined(&TR_LWP_CONTINUE_START);
    eval 'sub TR_LWP_CONTINUE_END () {7;}' unless defined(&TR_LWP_CONTINUE_END);
    eval 'sub TR_LWP_CREATE_ASEGKP () {8;}' unless defined(&TR_LWP_CREATE_ASEGKP);
    eval 'sub TR_LWP_CREATE_ATHRC () {9;}' unless defined(&TR_LWP_CREATE_ATHRC);
    eval 'sub TR_LWP_CREATE_ABZ () {10;}' unless defined(&TR_LWP_CREATE_ABZ);
    eval 'sub TR_LWP_CONT_ASR () {11;}' unless defined(&TR_LWP_CONT_ASR);
    eval 'sub TR_LWP_EXIT_OFFQ () {12;}' unless defined(&TR_LWP_EXIT_OFFQ);
    eval 'sub TR_SYS_LWP_CREATE_START () {0;}' unless defined(&TR_SYS_LWP_CREATE_START);
    eval 'sub TR_SYS_LWP_CREATE_END1 () {1;}' unless defined(&TR_SYS_LWP_CREATE_END1);
    eval 'sub TR_SYS_LWP_CREATE_END2 () {2;}' unless defined(&TR_SYS_LWP_CREATE_END2);
    eval 'sub TR_SYS_LWP_EXIT_START () {3;}' unless defined(&TR_SYS_LWP_EXIT_START);
    eval 'sub TR_SYS_LWP_EXIT_END () {4;}' unless defined(&TR_SYS_LWP_EXIT_END);
    eval 'sub TR_SYS_LWP_WAIT () {5;}' unless defined(&TR_SYS_LWP_WAIT);
    eval 'sub TR_SYS_LWP_SELF () {6;}' unless defined(&TR_SYS_LWP_SELF);
    eval 'sub TR_SYS_LWP_SUSPEND_START () {7;}' unless defined(&TR_SYS_LWP_SUSPEND_START);
    eval 'sub TR_SYS_LWP_SUSPEND_END () {8;}' unless defined(&TR_SYS_LWP_SUSPEND_END);
    eval 'sub TR_SYS_LWP_CONTINUE_START () {9;}' unless defined(&TR_SYS_LWP_CONTINUE_START);
    eval 'sub TR_SYS_LWP_CONTINUE_END () {10;}' unless defined(&TR_SYS_LWP_CONTINUE_END);
    eval 'sub TR_SYS_LWP_MUTEX_LOCK () {11;}' unless defined(&TR_SYS_LWP_MUTEX_LOCK);
    eval 'sub TR_SYS_LWP_MUTEX_UNLOCK () {12;}' unless defined(&TR_SYS_LWP_MUTEX_UNLOCK);
    eval 'sub TR_SYS_LWP_COND_WAIT_START () {13;}' unless defined(&TR_SYS_LWP_COND_WAIT_START);
    eval 'sub TR_SYS_LWP_COND_WAIT_END () {14;}' unless defined(&TR_SYS_LWP_COND_WAIT_END);
    eval 'sub TR_SYS_LWP_COND_SIGNAL_START () {15;}' unless defined(&TR_SYS_LWP_COND_SIGNAL_START);
    eval 'sub TR_SYS_LWP_COND_SIGNAL_END () {16;}' unless defined(&TR_SYS_LWP_COND_SIGNAL_END);
    eval 'sub TR_SYS_LWP_COND_BROADCAST () {17;}' unless defined(&TR_SYS_LWP_COND_BROADCAST);
    eval 'sub TR_SYS_LWP_KILL_START () {18;}' unless defined(&TR_SYS_LWP_KILL_START);
    eval 'sub TR_SYS_LWP_KILL_END () {19;}' unless defined(&TR_SYS_LWP_KILL_END);
    eval 'sub TR_SYS_LWP_SETPRIVATE () {20;}' unless defined(&TR_SYS_LWP_SETPRIVATE);
    eval 'sub TR_SYS_LWP_GETPRIVATE () {21;}' unless defined(&TR_SYS_LWP_GETPRIVATE);
    eval 'sub TR_SYS_LWP_ACOPYIN () {22;}' unless defined(&TR_SYS_LWP_ACOPYIN);
    eval 'sub TR_SYS_LWP_ABCP () {23;}' unless defined(&TR_SYS_LWP_ABCP);
    eval 'sub TR_SYS_LWP_ALWPTOT () {24;}' unless defined(&TR_SYS_LWP_ALWPTOT);
    eval 'sub TR_SYS_LWP_CONTINUE_AIDTOT () {25;}' unless defined(&TR_SYS_LWP_CONTINUE_AIDTOT);
    eval 'sub TR_SYS_LWP_CR_WAIT () {26;}' unless defined(&TR_SYS_LWP_CR_WAIT);
    eval 'sub TR_TIMEOUT () {0;}' unless defined(&TR_TIMEOUT);
    eval 'sub TR_UNTIMEOUT () {1;}' unless defined(&TR_UNTIMEOUT);
    eval 'sub TR_UNTIMEOUT_BOGUS_ID () {2;}' unless defined(&TR_UNTIMEOUT_BOGUS_ID);
    eval 'sub TR_UNTIMEOUT_EXECUTING () {3;}' unless defined(&TR_UNTIMEOUT_EXECUTING);
    eval 'sub TR_UNTIMEOUT_SELF () {4;}' unless defined(&TR_UNTIMEOUT_SELF);
    eval 'sub TR_CALLOUT_START () {5;}' unless defined(&TR_CALLOUT_START);
    eval 'sub TR_CALLOUT_END () {6;}' unless defined(&TR_CALLOUT_END);
    eval 'sub TR_SPECFS_GETPAGE () {0;}' unless defined(&TR_SPECFS_GETPAGE);
    eval 'sub TR_SPECFS_GETAPAGE () {1;}' unless defined(&TR_SPECFS_GETAPAGE);
    eval 'sub TR_SPECFS_PUTPAGE () {2;}' unless defined(&TR_SPECFS_PUTPAGE);
    eval 'sub TR_SPECFS_PUTAPAGE () {3;}' unless defined(&TR_SPECFS_PUTAPAGE);
    eval 'sub TR_SPECFS_SEGMAP () {4;}' unless defined(&TR_SPECFS_SEGMAP);
    eval 'sub TR_SPECFS_OPEN () {5;}' unless defined(&TR_SPECFS_OPEN);
    eval 'sub TR_SPECFS_READ_START () {6;}' unless defined(&TR_SPECFS_READ_START);
    eval 'sub TR_SPECFS_READ_END () {7;}' unless defined(&TR_SPECFS_READ_END);
    eval 'sub TR_SPECFS_CDEV () {8;}' unless defined(&TR_SPECFS_CDEV);
    eval 'sub TR_SPECFS_WRITE_START () {9;}' unless defined(&TR_SPECFS_WRITE_START);
    eval 'sub TR_SPECFS_WRITE_END () {10;}' unless defined(&TR_SPECFS_WRITE_END);
    eval 'sub TR_TMPFS_LOOKUP () {0;}' unless defined(&TR_TMPFS_LOOKUP);
    eval 'sub TR_TMPFS_CREATE () {1;}' unless defined(&TR_TMPFS_CREATE);
    eval 'sub TR_TMPFS_REMOVE () {2;}' unless defined(&TR_TMPFS_REMOVE);
    eval 'sub TR_TMPFS_RENAME () {3;}' unless defined(&TR_TMPFS_RENAME);
    eval 'sub TR_TMPFS_RWTMP_START () {4;}' unless defined(&TR_TMPFS_RWTMP_START);
    eval 'sub TR_TMPFS_RWTMP_END () {5;}' unless defined(&TR_TMPFS_RWTMP_END);
    eval 'sub TR_SWAPFS_OPEN () {0;}' unless defined(&TR_SWAPFS_OPEN);
    eval 'sub TR_SWAPFS_CLOSE () {1;}' unless defined(&TR_SWAPFS_CLOSE);
    eval 'sub TR_SWAPFS_GETPAGE () {2;}' unless defined(&TR_SWAPFS_GETPAGE);
    eval 'sub TR_SWAPFS_GETAPAGE () {3;}' unless defined(&TR_SWAPFS_GETAPAGE);
    eval 'sub TR_SWAPFS_PUTPAGE () {4;}' unless defined(&TR_SWAPFS_PUTPAGE);
    eval 'sub TR_SWAPFS_PUTAPAGE () {5;}' unless defined(&TR_SWAPFS_PUTAPAGE);
    eval 'sub TR_UFS_SYNCIP_START () {0;}' unless defined(&TR_UFS_SYNCIP_START);
    eval 'sub TR_UFS_SYNCIP_END () {1;}' unless defined(&TR_UFS_SYNCIP_END);
    eval 'sub TR_UFS_OPEN () {2;}' unless defined(&TR_UFS_OPEN);
    eval 'sub TR_UFS_CLOSE () {4;}' unless defined(&TR_UFS_CLOSE);
    eval 'sub TR_UFS_READ_START () {6;}' unless defined(&TR_UFS_READ_START);
    eval 'sub TR_UFS_READ_END () {7;}' unless defined(&TR_UFS_READ_END);
    eval 'sub TR_UFS_WRITE_START () {8;}' unless defined(&TR_UFS_WRITE_START);
    eval 'sub TR_UFS_WRITE_END () {9;}' unless defined(&TR_UFS_WRITE_END);
    eval 'sub TR_UFS_RWIP_START () {10;}' unless defined(&TR_UFS_RWIP_START);
    eval 'sub TR_UFS_RWIP_END () {11;}' unless defined(&TR_UFS_RWIP_END);
    eval 'sub TR_UFS_GETATTR_START () {12;}' unless defined(&TR_UFS_GETATTR_START);
    eval 'sub TR_UFS_GETATTR_END () {13;}' unless defined(&TR_UFS_GETATTR_END);
    eval 'sub TR_UFS_SETATTR_START () {14;}' unless defined(&TR_UFS_SETATTR_START);
    eval 'sub TR_UFS_SETATTR_END () {15;}' unless defined(&TR_UFS_SETATTR_END);
    eval 'sub TR_UFS_ACCESS_START () {16;}' unless defined(&TR_UFS_ACCESS_START);
    eval 'sub TR_UFS_ACCESS_END () {17;}' unless defined(&TR_UFS_ACCESS_END);
    eval 'sub TR_UFS_READLINK_START () {18;}' unless defined(&TR_UFS_READLINK_START);
    eval 'sub TR_UFS_READLINK_END () {19;}' unless defined(&TR_UFS_READLINK_END);
    eval 'sub TR_UFS_FSYNC_START () {20;}' unless defined(&TR_UFS_FSYNC_START);
    eval 'sub TR_UFS_FSYNC_END () {21;}' unless defined(&TR_UFS_FSYNC_END);
    eval 'sub TR_UFS_LOOKUP_START () {22;}' unless defined(&TR_UFS_LOOKUP_START);
    eval 'sub TR_UFS_LOOKUP_END () {23;}' unless defined(&TR_UFS_LOOKUP_END);
    eval 'sub TR_UFS_CREATE_START () {24;}' unless defined(&TR_UFS_CREATE_START);
    eval 'sub TR_UFS_CREATE_END () {25;}' unless defined(&TR_UFS_CREATE_END);
    eval 'sub TR_UFS_REMOVE_START () {26;}' unless defined(&TR_UFS_REMOVE_START);
    eval 'sub TR_UFS_REMOVE_END () {27;}' unless defined(&TR_UFS_REMOVE_END);
    eval 'sub TR_UFS_LINK_START () {28;}' unless defined(&TR_UFS_LINK_START);
    eval 'sub TR_UFS_LINK_END () {29;}' unless defined(&TR_UFS_LINK_END);
    eval 'sub TR_UFS_RENAME_START () {30;}' unless defined(&TR_UFS_RENAME_START);
    eval 'sub TR_UFS_RENAME_END () {31;}' unless defined(&TR_UFS_RENAME_END);
    eval 'sub TR_UFS_MKDIR_START () {32;}' unless defined(&TR_UFS_MKDIR_START);
    eval 'sub TR_UFS_MKDIR_END () {33;}' unless defined(&TR_UFS_MKDIR_END);
    eval 'sub TR_UFS_RMDIR_START () {34;}' unless defined(&TR_UFS_RMDIR_START);
    eval 'sub TR_UFS_RMDIR_END () {35;}' unless defined(&TR_UFS_RMDIR_END);
    eval 'sub TR_UFS_READDIR_START () {36;}' unless defined(&TR_UFS_READDIR_START);
    eval 'sub TR_UFS_READDIR_END () {37;}' unless defined(&TR_UFS_READDIR_END);
    eval 'sub TR_UFS_SYMLINK_START () {38;}' unless defined(&TR_UFS_SYMLINK_START);
    eval 'sub TR_UFS_SYMLINK_END () {39;}' unless defined(&TR_UFS_SYMLINK_END);
    eval 'sub TR_UFS_GETPAGE_START () {40;}' unless defined(&TR_UFS_GETPAGE_START);
    eval 'sub TR_UFS_GETPAGE_END () {41;}' unless defined(&TR_UFS_GETPAGE_END);
    eval 'sub TR_UFS_GETAPAGE_START () {42;}' unless defined(&TR_UFS_GETAPAGE_START);
    eval 'sub TR_UFS_GETAPAGE_END () {43;}' unless defined(&TR_UFS_GETAPAGE_END);
    eval 'sub TR_UFS_PUTPAGE_START () {44;}' unless defined(&TR_UFS_PUTPAGE_START);
    eval 'sub TR_UFS_PUTPAGE_END () {45;}' unless defined(&TR_UFS_PUTPAGE_END);
    eval 'sub TR_UFS_PUTAPAGE_START () {46;}' unless defined(&TR_UFS_PUTAPAGE_START);
    eval 'sub TR_UFS_PUTAPAGE_END () {47;}' unless defined(&TR_UFS_PUTAPAGE_END);
    eval 'sub TR_UFS_MAP_START () {48;}' unless defined(&TR_UFS_MAP_START);
    eval 'sub TR_UFS_MAP_END () {49;}' unless defined(&TR_UFS_MAP_END);
    eval 'sub TR_UFS_GETSECATTR_START () {50;}' unless defined(&TR_UFS_GETSECATTR_START);
    eval 'sub TR_UFS_GETSECATTR_END () {51;}' unless defined(&TR_UFS_GETSECATTR_END);
    eval 'sub TR_UFS_SETSECATTR_START () {52;}' unless defined(&TR_UFS_SETSECATTR_START);
    eval 'sub TR_UFS_SETSECATTR_END () {53;}' unless defined(&TR_UFS_SETSECATTR_END);
    eval 'sub TR_RFSCALL_START () {0;}' unless defined(&TR_RFSCALL_START);
    eval 'sub TR_RFSCALL_END () {1;}' unless defined(&TR_RFSCALL_END);
    eval 'sub TR_FHTOVP_START () {2;}' unless defined(&TR_FHTOVP_START);
    eval 'sub TR_FHTOVP_END () {3;}' unless defined(&TR_FHTOVP_END);
    eval 'sub TR_VOP_GETATTR_START () {100;}' unless defined(&TR_VOP_GETATTR_START);
    eval 'sub TR_VOP_GETATTR_END () {101;}' unless defined(&TR_VOP_GETATTR_END);
    eval 'sub TR_VOP_SETATTR_START () {102;}' unless defined(&TR_VOP_SETATTR_START);
    eval 'sub TR_VOP_SETATTR_END () {103;}' unless defined(&TR_VOP_SETATTR_END);
    eval 'sub TR_VOP_LOOKUP_START () {104;}' unless defined(&TR_VOP_LOOKUP_START);
    eval 'sub TR_VOP_LOOKUP_END () {105;}' unless defined(&TR_VOP_LOOKUP_END);
    eval 'sub TR_VOP_READLINK_START () {106;}' unless defined(&TR_VOP_READLINK_START);
    eval 'sub TR_VOP_READLINK_END () {107;}' unless defined(&TR_VOP_READLINK_END);
    eval 'sub TR_VOP_RWLOCK_START () {108;}' unless defined(&TR_VOP_RWLOCK_START);
    eval 'sub TR_VOP_RWLOCK_END () {109;}' unless defined(&TR_VOP_RWLOCK_END);
    eval 'sub TR_VOP_ACCESS_START () {110;}' unless defined(&TR_VOP_ACCESS_START);
    eval 'sub TR_VOP_ACCESS_END () {111;}' unless defined(&TR_VOP_ACCESS_END);
    eval 'sub TR_VOP_OPEN_START () {112;}' unless defined(&TR_VOP_OPEN_START);
    eval 'sub TR_VOP_OPEN_END () {113;}' unless defined(&TR_VOP_OPEN_END);
    eval 'sub TR_VOP_READ_START () {114;}' unless defined(&TR_VOP_READ_START);
    eval 'sub TR_VOP_READ_END () {115;}' unless defined(&TR_VOP_READ_END);
    eval 'sub TR_VOP_CLOSE_START () {116;}' unless defined(&TR_VOP_CLOSE_START);
    eval 'sub TR_VOP_CLOSE_END () {117;}' unless defined(&TR_VOP_CLOSE_END);
    eval 'sub TR_VOP_RWUNLOCK_START () {118;}' unless defined(&TR_VOP_RWUNLOCK_START);
    eval 'sub TR_VOP_RWUNLOCK_END () {119;}' unless defined(&TR_VOP_RWUNLOCK_END);
    eval 'sub TR_VOP_WRITE_START () {120;}' unless defined(&TR_VOP_WRITE_START);
    eval 'sub TR_VOP_WRITE_END () {121;}' unless defined(&TR_VOP_WRITE_END);
    eval 'sub TR_VOP_CREATE_START () {122;}' unless defined(&TR_VOP_CREATE_START);
    eval 'sub TR_VOP_CREATE_END () {123;}' unless defined(&TR_VOP_CREATE_END);
    eval 'sub TR_VOP_REMOVE_START () {124;}' unless defined(&TR_VOP_REMOVE_START);
    eval 'sub TR_VOP_REMOVE_END () {125;}' unless defined(&TR_VOP_REMOVE_END);
    eval 'sub TR_VOP_RENAME_START () {126;}' unless defined(&TR_VOP_RENAME_START);
    eval 'sub TR_VOP_RENAME_END () {127;}' unless defined(&TR_VOP_RENAME_END);
    eval 'sub TR_VOP_LINK_START () {128;}' unless defined(&TR_VOP_LINK_START);
    eval 'sub TR_VOP_LINK_END () {129;}' unless defined(&TR_VOP_LINK_END);
    eval 'sub TR_VOP_SYMLINK_START () {130;}' unless defined(&TR_VOP_SYMLINK_START);
    eval 'sub TR_VOP_SYMLINK_END () {131;}' unless defined(&TR_VOP_SYMLINK_END);
    eval 'sub TR_VOP_MKDIR_START () {132;}' unless defined(&TR_VOP_MKDIR_START);
    eval 'sub TR_VOP_MKDIR_END () {133;}' unless defined(&TR_VOP_MKDIR_END);
    eval 'sub TR_VOP_RMDIR_START () {134;}' unless defined(&TR_VOP_RMDIR_START);
    eval 'sub TR_VOP_RMDIR_END () {135;}' unless defined(&TR_VOP_RMDIR_END);
    eval 'sub TR_VOP_READDIR_START () {136;}' unless defined(&TR_VOP_READDIR_START);
    eval 'sub TR_VOP_READDIR_END () {137;}' unless defined(&TR_VOP_READDIR_END);
    eval 'sub TR_SEGMAP_GETMAP_START () {138;}' unless defined(&TR_SEGMAP_GETMAP_START);
    eval 'sub TR_SEGMAP_GETMAP_END () {139;}' unless defined(&TR_SEGMAP_GETMAP_END);
    eval 'sub TR_AS_FAULT_START () {140;}' unless defined(&TR_AS_FAULT_START);
    eval 'sub TR_AS_FAULT_END () {141;}' unless defined(&TR_AS_FAULT_END);
    eval 'sub TR_RFS_GETATTR_START () {142;}' unless defined(&TR_RFS_GETATTR_START);
    eval 'sub TR_RFS_GETATTR_END () {143;}' unless defined(&TR_RFS_GETATTR_END);
    eval 'sub TR_RFS_SETATTR_START () {144;}' unless defined(&TR_RFS_SETATTR_START);
    eval 'sub TR_RFS_SETATTR_END () {145;}' unless defined(&TR_RFS_SETATTR_END);
    eval 'sub TR_RFS_LOOKUP_START () {146;}' unless defined(&TR_RFS_LOOKUP_START);
    eval 'sub TR_RFS_LOOKUP_END () {147;}' unless defined(&TR_RFS_LOOKUP_END);
    eval 'sub TR_RFS_READLINK_START () {148;}' unless defined(&TR_RFS_READLINK_START);
    eval 'sub TR_RFS_READLINK_END () {149;}' unless defined(&TR_RFS_READLINK_END);
    eval 'sub TR_RFS_READ_START () {150;}' unless defined(&TR_RFS_READ_START);
    eval 'sub TR_RFS_READ_END () {151;}' unless defined(&TR_RFS_READ_END);
    eval 'sub TR_RFS_WRITE_START () {152;}' unless defined(&TR_RFS_WRITE_START);
    eval 'sub TR_RFS_WRITE_END () {153;}' unless defined(&TR_RFS_WRITE_END);
    eval 'sub TR_RFS_CREATE_START () {154;}' unless defined(&TR_RFS_CREATE_START);
    eval 'sub TR_RFS_CREATE_END () {155;}' unless defined(&TR_RFS_CREATE_END);
    eval 'sub TR_RFS_REMOVE_START () {156;}' unless defined(&TR_RFS_REMOVE_START);
    eval 'sub TR_RFS_REMOVE_END () {157;}' unless defined(&TR_RFS_REMOVE_END);
    eval 'sub TR_RFS_RENAME_START () {158;}' unless defined(&TR_RFS_RENAME_START);
    eval 'sub TR_RFS_RENAME_END () {159;}' unless defined(&TR_RFS_RENAME_END);
    eval 'sub TR_RFS_LINK_START () {160;}' unless defined(&TR_RFS_LINK_START);
    eval 'sub TR_RFS_LINK_END () {161;}' unless defined(&TR_RFS_LINK_END);
    eval 'sub TR_RFS_SYMLINK_START () {162;}' unless defined(&TR_RFS_SYMLINK_START);
    eval 'sub TR_RFS_SYMLINK_END () {163;}' unless defined(&TR_RFS_SYMLINK_END);
    eval 'sub TR_RFS_MKDIR_START () {164;}' unless defined(&TR_RFS_MKDIR_START);
    eval 'sub TR_RFS_MKDIR_END () {165;}' unless defined(&TR_RFS_MKDIR_END);
    eval 'sub TR_RFS_RMDIR_START () {166;}' unless defined(&TR_RFS_RMDIR_START);
    eval 'sub TR_RFS_RMDIR_END () {167;}' unless defined(&TR_RFS_RMDIR_END);
    eval 'sub TR_RFS_READDIR_START () {168;}' unless defined(&TR_RFS_READDIR_START);
    eval 'sub TR_RFS_READDIR_END () {169;}' unless defined(&TR_RFS_READDIR_END);
    eval 'sub TR_RFS_STATFS_START () {170;}' unless defined(&TR_RFS_STATFS_START);
    eval 'sub TR_RFS_STATFS_END () {171;}' unless defined(&TR_RFS_STATFS_END);
    eval 'sub TR_SVC_SENDREPLY_START () {178;}' unless defined(&TR_SVC_SENDREPLY_START);
    eval 'sub TR_SVC_SENDREPLY_END () {179;}' unless defined(&TR_SVC_SENDREPLY_END);
    eval 'sub TR_VOP_FSYNC_START () {180;}' unless defined(&TR_VOP_FSYNC_START);
    eval 'sub TR_VOP_FSYNC_END () {181;}' unless defined(&TR_VOP_FSYNC_END);
    eval 'sub TR_VOP_PUTPAGE_START () {182;}' unless defined(&TR_VOP_PUTPAGE_START);
    eval 'sub TR_VOP_PUTPAGE_END () {183;}' unless defined(&TR_VOP_PUTPAGE_END);
    eval 'sub TR_SEGMAP_RELEASE_START () {184;}' unless defined(&TR_SEGMAP_RELEASE_START);
    eval 'sub TR_SEGMAP_RELEASE_END () {185;}' unless defined(&TR_SEGMAP_RELEASE_END);
    eval 'sub TR_SVC_GETARGS_START () {186;}' unless defined(&TR_SVC_GETARGS_START);
    eval 'sub TR_SVC_GETARGS_END () {187;}' unless defined(&TR_SVC_GETARGS_END);
    eval 'sub TR_FINDEXPORT_START () {188;}' unless defined(&TR_FINDEXPORT_START);
    eval 'sub TR_FINDEXPORT_END () {189;}' unless defined(&TR_FINDEXPORT_END);
    eval 'sub TR_SVC_FREEARGS_START () {192;}' unless defined(&TR_SVC_FREEARGS_START);
    eval 'sub TR_SVC_FREEARGS_END () {193;}' unless defined(&TR_SVC_FREEARGS_END);
    eval 'sub TR_RFS_RESFREE_START () {194;}' unless defined(&TR_RFS_RESFREE_START);
    eval 'sub TR_RFS_RESFREE_END () {195;}' unless defined(&TR_RFS_RESFREE_END);
    eval 'sub TR_RFS_CRFREE_START () {196;}' unless defined(&TR_RFS_CRFREE_START);
    eval 'sub TR_RFS_CRFREE_END () {197;}' unless defined(&TR_RFS_CRFREE_END);
    eval 'sub TR_SVC_DUPFOUND () {198;}' unless defined(&TR_SVC_DUPFOUND);
    eval 'sub TR_NFSFP_QUE_REQ_START () {199;}' unless defined(&TR_NFSFP_QUE_REQ_START);
    eval 'sub TR_NFSFP_QUE_REQ_END () {200;}' unless defined(&TR_NFSFP_QUE_REQ_END);
    eval 'sub TR_NFSFP_PROC_REQ_END () {201;}' unless defined(&TR_NFSFP_PROC_REQ_END);
    eval 'sub TR_NFSFP_XDR_ARG_START () {202;}' unless defined(&TR_NFSFP_XDR_ARG_START);
    eval 'sub TR_NFSFP_XDR_ARG_END () {203;}' unless defined(&TR_NFSFP_XDR_ARG_END);
    eval 'sub TR_NFSFP_XDR_RES_START () {204;}' unless defined(&TR_NFSFP_XDR_RES_START);
    eval 'sub TR_NFSFP_XDR_RES_END () {205;}' unless defined(&TR_NFSFP_XDR_RES_END);
    eval 'sub TR_NFSFP_DUP_CHECK_START () {206;}' unless defined(&TR_NFSFP_DUP_CHECK_START);
    eval 'sub TR_NFSFP_DUP_CHECK_END () {207;}' unless defined(&TR_NFSFP_DUP_CHECK_END);
    eval 'sub TR_NFSFP_UDP_SEND_START () {208;}' unless defined(&TR_NFSFP_UDP_SEND_START);
    eval 'sub TR_NFSFP_UDP_SEND_END () {209;}' unless defined(&TR_NFSFP_UDP_SEND_END);
    eval 'sub TR_NFSFP_SEND_REPLY_START () {210;}' unless defined(&TR_NFSFP_SEND_REPLY_START);
    eval 'sub TR_NFSFP_SEND_REPLY_END () {211;}' unless defined(&TR_NFSFP_SEND_REPLY_END);
    eval 'sub TR_NFSFP_QUE_REQ_ENQ () {212;}' unless defined(&TR_NFSFP_QUE_REQ_ENQ);
    eval 'sub TR_NFSFP_QUE_REQ_DEQ () {213;}' unless defined(&TR_NFSFP_QUE_REQ_DEQ);
    eval 'sub TR_NFSFP_RFS_READLINK_START () {214;}' unless defined(&TR_NFSFP_RFS_READLINK_START);
    eval 'sub TR_NFSFP_RFS_READLINK_END () {215;}' unless defined(&TR_NFSFP_RFS_READLINK_END);
    eval 'sub TR_NFSFP_SVCAUTH_UNIX_START () {216;}' unless defined(&TR_NFSFP_SVCAUTH_UNIX_START);
    eval 'sub TR_NFSFP_SVCAUTH_UNIX_END () {217;}' unless defined(&TR_NFSFP_SVCAUTH_UNIX_END);
    eval 'sub TR_SVC_FREERES_START () {222;}' unless defined(&TR_SVC_FREERES_START);
    eval 'sub TR_SVC_FREERES_END () {223;}' unless defined(&TR_SVC_FREERES_END);
    eval 'sub TR_DNLC_ENTER_START () {218;}' unless defined(&TR_DNLC_ENTER_START);
    eval 'sub TR_DNLC_ENTER_END () {219;}' unless defined(&TR_DNLC_ENTER_END);
    eval 'sub TR_DNLC_LOOKUP_START () {220;}' unless defined(&TR_DNLC_LOOKUP_START);
    eval 'sub TR_DNLC_LOOKUP_END () {221;}' unless defined(&TR_DNLC_LOOKUP_END);
    eval 'sub TR_CMN_DISPATCH_START () {224;}' unless defined(&TR_CMN_DISPATCH_START);
    eval 'sub TR_CMN_PROC_START () {225;}' unless defined(&TR_CMN_PROC_START);
    eval 'sub TR_CMN_PROC_END () {226;}' unless defined(&TR_CMN_PROC_END);
    eval 'sub TR_CMN_DISPATCH_END () {227;}' unless defined(&TR_CMN_DISPATCH_END);
    eval 'sub TR_VOP_SPACE_START () {228;}' unless defined(&TR_VOP_SPACE_START);
    eval 'sub TR_VOP_SPACE_END () {229;}' unless defined(&TR_VOP_SPACE_END);
    eval 'sub TR_DDI_DMA_BUF_SETUP_START () {0;}' unless defined(&TR_DDI_DMA_BUF_SETUP_START);
    eval 'sub TR_DDI_DMA_BUF_SETUP_END () {1;}' unless defined(&TR_DDI_DMA_BUF_SETUP_END);
    eval 'sub TR_IOMMUNEX_DMA_MAP_START () {2;}' unless defined(&TR_IOMMUNEX_DMA_MAP_START);
    eval 'sub TR_IOMMUNEX_DMA_MAP_END () {3;}' unless defined(&TR_IOMMUNEX_DMA_MAP_END);
    eval 'sub TR_IOMMUNEX_DMA_MAP_GETDVMAPAGES_START () {4;}' unless defined(&TR_IOMMUNEX_DMA_MAP_GETDVMAPAGES_START);
    eval 'sub TR_IOMMUNEX_DMA_MAP_GETDVMAPAGES_END () {5;}' unless defined(&TR_IOMMUNEX_DMA_MAP_GETDVMAPAGES_END);
    eval 'sub TR_SVC_GETREQ_START () {0;}' unless defined(&TR_SVC_GETREQ_START);
    eval 'sub TR_SVC_GETREQ_END () {1;}' unless defined(&TR_SVC_GETREQ_END);
    eval 'sub TR_SVC_GETREQ_LOOP_START () {2;}' unless defined(&TR_SVC_GETREQ_LOOP_START);
    eval 'sub TR_SVC_GETREQ_LOOP_END () {3;}' unless defined(&TR_SVC_GETREQ_LOOP_END);
    eval 'sub TR_SVC_RUN () {4;}' unless defined(&TR_SVC_RUN);
    eval 'sub TR_SVC_CLTS_KRECV_START () {5;}' unless defined(&TR_SVC_CLTS_KRECV_START);
    eval 'sub TR_SVC_CLTS_KRECV_END () {6;}' unless defined(&TR_SVC_CLTS_KRECV_END);
    eval 'sub TR_XDR_CALLMSG_START () {7;}' unless defined(&TR_XDR_CALLMSG_START);
    eval 'sub TR_XDR_CALLMSG_END () {8;}' unless defined(&TR_XDR_CALLMSG_END);
    eval 'sub TR_SVC_CLTS_KSEND_START () {9;}' unless defined(&TR_SVC_CLTS_KSEND_START);
    eval 'sub TR_SVC_CLTS_KSEND_END () {10;}' unless defined(&TR_SVC_CLTS_KSEND_END);
    eval 'sub TR_XDR_REPLYMSG_START () {11;}' unless defined(&TR_XDR_REPLYMSG_START);
    eval 'sub TR_XDR_REPLYMSG_END () {12;}' unless defined(&TR_XDR_REPLYMSG_END);
    eval 'sub TR_RPCMODOPEN_START () {13;}' unless defined(&TR_RPCMODOPEN_START);
    eval 'sub TR_RPCMODOPEN_END () {14;}' unless defined(&TR_RPCMODOPEN_END);
    eval 'sub TR_RPCMODRPUT_START () {15;}' unless defined(&TR_RPCMODRPUT_START);
    eval 'sub TR_RPCMODRPUT_END () {16;}' unless defined(&TR_RPCMODRPUT_END);
    eval 'sub TR_RPCMODWPUT_START () {17;}' unless defined(&TR_RPCMODWPUT_START);
    eval 'sub TR_RPCMODWPUT_END () {18;}' unless defined(&TR_RPCMODWPUT_END);
    eval 'sub TR_RPCMODRSRV_START () {19;}' unless defined(&TR_RPCMODRSRV_START);
    eval 'sub TR_RPCMODRSRV_END () {20;}' unless defined(&TR_RPCMODRSRV_END);
    eval 'sub TR_RPCMODWSRV_START () {21;}' unless defined(&TR_RPCMODWSRV_START);
    eval 'sub TR_RPCMODWSRV_END () {22;}' unless defined(&TR_RPCMODWSRV_END);
    eval 'sub TR_SVC_QUEUEREQ_START () {23;}' unless defined(&TR_SVC_QUEUEREQ_START);
    eval 'sub TR_SVC_QUEUEREQ_END () {24;}' unless defined(&TR_SVC_QUEUEREQ_END);
    eval 'sub TR_SVC_GETREQ_AUTH_START () {25;}' unless defined(&TR_SVC_GETREQ_AUTH_START);
    eval 'sub TR_SVC_GETREQ_AUTH_END () {26;}' unless defined(&TR_SVC_GETREQ_AUTH_END);
    eval 'sub TR_SVC_DUPDONE () {27;}' unless defined(&TR_SVC_DUPDONE);
    eval 'sub TR_SVC_CLTS_KDUP_START () {28;}' unless defined(&TR_SVC_CLTS_KDUP_START);
    eval 'sub TR_SVC_CLTS_KDUP_END () {29;}' unless defined(&TR_SVC_CLTS_KDUP_END);
    eval 'sub TR_RPC_QUE_REQ_START () {30;}' unless defined(&TR_RPC_QUE_REQ_START);
    eval 'sub TR_RPC_QUE_REQ_END () {31;}' unless defined(&TR_RPC_QUE_REQ_END);
    eval 'sub TR_SVC_COTS_KRECV_START () {32;}' unless defined(&TR_SVC_COTS_KRECV_START);
    eval 'sub TR_SVC_COTS_KRECV_END () {33;}' unless defined(&TR_SVC_COTS_KRECV_END);
    eval 'sub TR_SVC_COTS_KDUP_DONE () {34;}' unless defined(&TR_SVC_COTS_KDUP_DONE);
    eval 'sub TR_SVC_COTS_KDUP_INPROGRESS () {35;}' unless defined(&TR_SVC_COTS_KDUP_INPROGRESS);
    eval 'sub TR_SVC_COTS_KSEND_START () {36;}' unless defined(&TR_SVC_COTS_KSEND_START);
    eval 'sub TR_SVC_COTS_KSEND_END () {37;}' unless defined(&TR_SVC_COTS_KSEND_END);
    eval 'sub TR_SCSI_INIT_PKT_START () {0;}' unless defined(&TR_SCSI_INIT_PKT_START);
    eval 'sub TR_SCSI_INIT_PKT_RETURN1_END () {1;}' unless defined(&TR_SCSI_INIT_PKT_RETURN1_END);
    eval 'sub TR_SCSI_INIT_PKT_RETURN2_END () {2;}' unless defined(&TR_SCSI_INIT_PKT_RETURN2_END);
    eval 'sub TR_SCSI_INIT_PKT_END () {3;}' unless defined(&TR_SCSI_INIT_PKT_END);
    eval 'sub TR_SCSI_INIT_PKT_PKTALLOC_START () {4;}' unless defined(&TR_SCSI_INIT_PKT_PKTALLOC_START);
    eval 'sub TR_SCSI_INIT_PKT_PKTALLOC_END () {5;}' unless defined(&TR_SCSI_INIT_PKT_PKTALLOC_END);
    eval 'sub TR_SCSI_INIT_PKT_PKTALLOC_FAILED () {6;}' unless defined(&TR_SCSI_INIT_PKT_PKTALLOC_FAILED);
    eval 'sub TR_SCSI_INIT_PKT_DMAGET_START () {7;}' unless defined(&TR_SCSI_INIT_PKT_DMAGET_START);
    eval 'sub TR_SCSI_INIT_PKT_DMAGET_FAILED () {8;}' unless defined(&TR_SCSI_INIT_PKT_DMAGET_FAILED);
    eval 'sub TR_SCSI_INIT_PKT_FREE_START () {9;}' unless defined(&TR_SCSI_INIT_PKT_FREE_START);
    eval 'sub TR_SCSI_ALLOC_CONSISTENT_BUF_START () {10;}' unless defined(&TR_SCSI_ALLOC_CONSISTENT_BUF_START);
    eval 'sub TR_SCSI_ALLOC_CONSISTENT_BUF_RETURN1_END () {11;}' unless defined(&TR_SCSI_ALLOC_CONSISTENT_BUF_RETURN1_END);
    eval 'sub TR_SCSI_ALLOC_CONSISTENT_BUF_RETURN2_END () {12;}' unless defined(&TR_SCSI_ALLOC_CONSISTENT_BUF_RETURN2_END);
    eval 'sub TR_SCSI_ALLOC_CONSISTENT_BUF_RETURN3_END () {13;}' unless defined(&TR_SCSI_ALLOC_CONSISTENT_BUF_RETURN3_END);
    eval 'sub TR_SCSI_ALLOC_CONSISTENT_BUF_END () {14;}' unless defined(&TR_SCSI_ALLOC_CONSISTENT_BUF_END);
    eval 'sub TR_SCSI_FREE_CONSISTENT_BUF_START () {15;}' unless defined(&TR_SCSI_FREE_CONSISTENT_BUF_START);
    eval 'sub TR_SCSI_FREE_CONSISTENT_BUF_END () {16;}' unless defined(&TR_SCSI_FREE_CONSISTENT_BUF_END);
    eval 'sub TR_SCSI_IMPL_PKTALLOC_START () {17;}' unless defined(&TR_SCSI_IMPL_PKTALLOC_START);
    eval 'sub TR_SCSI_IMPL_PKTALLOC_END () {18;}' unless defined(&TR_SCSI_IMPL_PKTALLOC_END);
    eval 'sub TR_SCSI_IMPL_PKTALLOC_CALLBACK_START () {19;}' unless defined(&TR_SCSI_IMPL_PKTALLOC_CALLBACK_START);
    eval 'sub TR_SCSI_IMPL_PKTALLOC_CALLBACK_END () {20;}' unless defined(&TR_SCSI_IMPL_PKTALLOC_CALLBACK_END);
    eval 'sub TR_SCSI_IMPL_PKTFREE_START () {21;}' unless defined(&TR_SCSI_IMPL_PKTFREE_START);
    eval 'sub TR_SCSI_IMPL_PKTFREE_END () {22;}' unless defined(&TR_SCSI_IMPL_PKTFREE_END);
    eval 'sub TR_SCSI_IMPL_PKTFREE_RUN_CALLBACK () {23;}' unless defined(&TR_SCSI_IMPL_PKTFREE_RUN_CALLBACK);
    eval 'sub TR_SCSI_IMPL_DMAGET_START () {24;}' unless defined(&TR_SCSI_IMPL_DMAGET_START);
    eval 'sub TR_SCSI_IMPL_DMAGET_END () {25;}' unless defined(&TR_SCSI_IMPL_DMAGET_END);
    eval 'sub TR_SCSI_IMPL_DMAGET_BUFSETUP_START () {26;}' unless defined(&TR_SCSI_IMPL_DMAGET_BUFSETUP_START);
    eval 'sub TR_SCSI_IMPL_DMAGET_BUFSETUP_FAILED () {27;}' unless defined(&TR_SCSI_IMPL_DMAGET_BUFSETUP_FAILED);
    eval 'sub TR_SCSI_DESTROY_PKT_START () {28;}' unless defined(&TR_SCSI_DESTROY_PKT_START);
    eval 'sub TR_SCSI_DESTROY_PKT_END () {29;}' unless defined(&TR_SCSI_DESTROY_PKT_END);
    eval 'sub TR_FIFOREAD_IN () {1;}' unless defined(&TR_FIFOREAD_IN);
    eval 'sub TR_FIFOREAD_OUT () {2;}' unless defined(&TR_FIFOREAD_OUT);
    eval 'sub TR_FIFOREAD_WAIT () {3;}' unless defined(&TR_FIFOREAD_WAIT);
    eval 'sub TR_FIFOREAD_WAKE () {4;}' unless defined(&TR_FIFOREAD_WAKE);
    eval 'sub TR_FIFOREAD_STREAM () {5;}' unless defined(&TR_FIFOREAD_STREAM);
    eval 'sub TR_FIFOWRITE_IN () {6;}' unless defined(&TR_FIFOWRITE_IN);
    eval 'sub TR_FIFOWRITE_OUT () {7;}' unless defined(&TR_FIFOWRITE_OUT);
    eval 'sub TR_FIFOWRITE_WAIT () {9;}' unless defined(&TR_FIFOWRITE_WAIT);
    eval 'sub TR_FIFOWRITE_WAKE () {10;}' unless defined(&TR_FIFOWRITE_WAKE);
    eval 'sub TR_FIFOWRITE_STREAM () {11;}' unless defined(&TR_FIFOWRITE_STREAM);
    eval 'sub TR_RLOGINP_RPUT_IN () {0;}' unless defined(&TR_RLOGINP_RPUT_IN);
    eval 'sub TR_RLOGINP_RPUT_OUT () {1;}' unless defined(&TR_RLOGINP_RPUT_OUT);
    eval 'sub TR_RLOGINP_RSRV_IN () {2;}' unless defined(&TR_RLOGINP_RSRV_IN);
    eval 'sub TR_RLOGINP_RSRV_OUT () {3;}' unless defined(&TR_RLOGINP_RSRV_OUT);
    eval 'sub TR_RLOGINP_WSRV_IN () {4;}' unless defined(&TR_RLOGINP_WSRV_IN);
    eval 'sub TR_RLOGINP_WSRV_OUT () {5;}' unless defined(&TR_RLOGINP_WSRV_OUT);
    eval 'sub TR_RLOGINP_WPUT_IN () {6;}' unless defined(&TR_RLOGINP_WPUT_IN);
    eval 'sub TR_RLOGINP_WPUT_OUT () {7;}' unless defined(&TR_RLOGINP_WPUT_OUT);
    eval 'sub TR_RLOGINP_WINCTL_IN () {8;}' unless defined(&TR_RLOGINP_WINCTL_IN);
    eval 'sub TR_RLOGINP_WINCTL_OUT () {9;}' unless defined(&TR_RLOGINP_WINCTL_OUT);
    eval 'sub TR_SOCKFS_OPEN () {0;}' unless defined(&TR_SOCKFS_OPEN);
    eval 'sub TR_SOCKFS_CLOSE () {1;}' unless defined(&TR_SOCKFS_CLOSE);
    eval 'sub TR_DEVMAP_DUP () {0;}' unless defined(&TR_DEVMAP_DUP);
    eval 'sub TR_DEVMAP_UNMAP () {1;}' unless defined(&TR_DEVMAP_UNMAP);
    eval 'sub TR_DEVMAP_FREE () {2;}' unless defined(&TR_DEVMAP_FREE);
    eval 'sub TR_DEVMAP_FAULT () {3;}' unless defined(&TR_DEVMAP_FAULT);
    eval 'sub TR_DEVMAP_FAULTA () {4;}' unless defined(&TR_DEVMAP_FAULTA);
    eval 'sub TR_DEVMAP_SETPROT () {5;}' unless defined(&TR_DEVMAP_SETPROT);
    eval 'sub TR_DEVMAP_CHECKPROT () {6;}' unless defined(&TR_DEVMAP_CHECKPROT);
    eval 'sub TR_DEVMAP_SEGDEV_BADOP () {7;}' unless defined(&TR_DEVMAP_SEGDEV_BADOP);
    eval 'sub TR_DEVMAP_SYNC () {8;}' unless defined(&TR_DEVMAP_SYNC);
    eval 'sub TR_DEVMAP_INCORE () {9;}' unless defined(&TR_DEVMAP_INCORE);
    eval 'sub TR_DEVMAP_LOCKOP () {10;}' unless defined(&TR_DEVMAP_LOCKOP);
    eval 'sub TR_DEVMAP_GETPROT () {11;}' unless defined(&TR_DEVMAP_GETPROT);
    eval 'sub TR_DEVMAP_GETOFFSET () {12;}' unless defined(&TR_DEVMAP_GETOFFSET);
    eval 'sub TR_DEVMAP_GETTYPE () {13;}' unless defined(&TR_DEVMAP_GETTYPE);
    eval 'sub TR_DEVMAP_GETVP () {14;}' unless defined(&TR_DEVMAP_GETVP);
    eval 'sub TR_DEVMAP_ADVISE () {15;}' unless defined(&TR_DEVMAP_ADVISE);
    eval 'sub TR_DEVMAP_DUMP () {16;}' unless defined(&TR_DEVMAP_DUMP);
    eval 'sub TR_DEVMAP_PAGELOCK () {17;}' unless defined(&TR_DEVMAP_PAGELOCK);
    eval 'sub TR_DEVMAP_GETMEMID () {18;}' unless defined(&TR_DEVMAP_GETMEMID);
    eval 'sub TR_DEVMAP_SOFTUNLOCK () {19;}' unless defined(&TR_DEVMAP_SOFTUNLOCK);
    eval 'sub TR_DEVMAP_FAULTPAGE () {20;}' unless defined(&TR_DEVMAP_FAULTPAGE);
    eval 'sub TR_DEVMAP_FAULTPAGES () {21;}' unless defined(&TR_DEVMAP_FAULTPAGES);
    eval 'sub TR_DEVMAP_SEGMAP_SETUP () {22;}' unless defined(&TR_DEVMAP_SEGMAP_SETUP);
    eval 'sub TR_DEVMAP_DEVICE () {23;}' unless defined(&TR_DEVMAP_DEVICE);
    eval 'sub TR_DEVMAP_DO_CTXMGT () {24;}' unless defined(&TR_DEVMAP_DO_CTXMGT);
    eval 'sub TR_DEVMAP_ROUNDUP () {25;}' unless defined(&TR_DEVMAP_ROUNDUP);
    eval 'sub TR_DEVMAP_FIND_HANDLE () {26;}' unless defined(&TR_DEVMAP_FIND_HANDLE);
    eval 'sub TR_DEVMAP_UNLOAD () {27;}' unless defined(&TR_DEVMAP_UNLOAD);
    eval 'sub TR_DEVMAP_GET_LARGE_PGSIZE () {28;}' unless defined(&TR_DEVMAP_GET_LARGE_PGSIZE);
    eval 'sub TR_DEVMAP_SOFTLOCK_INIT () {29;}' unless defined(&TR_DEVMAP_SOFTLOCK_INIT);
    eval 'sub TR_DEVMAP_SOFTLOCK_RELE () {30;}' unless defined(&TR_DEVMAP_SOFTLOCK_RELE);
    eval 'sub TR_DEVMAP_CTX_RELE () {31;}' unless defined(&TR_DEVMAP_CTX_RELE);
    eval 'sub TR_DEVMAP_LOAD () {32;}' unless defined(&TR_DEVMAP_LOAD);
    eval 'sub TR_DEVMAP_SETUP () {33;}' unless defined(&TR_DEVMAP_SETUP);
    eval 'sub TR_DEVMAP_SEGMAP () {34;}' unless defined(&TR_DEVMAP_SEGMAP);
    eval 'sub TR_DEVMAP_DEVMEM_SETUP () {35;}' unless defined(&TR_DEVMAP_DEVMEM_SETUP);
    eval 'sub TR_DEVMAP_DEVMEM_REMAP () {36;}' unless defined(&TR_DEVMAP_DEVMEM_REMAP);
    eval 'sub TR_DEVMAP_UMEM_SETUP () {37;}' unless defined(&TR_DEVMAP_UMEM_SETUP);
    eval 'sub TR_DEVMAP_UMEM_REMAP () {38;}' unless defined(&TR_DEVMAP_UMEM_REMAP);
    eval 'sub TR_DEVMAP_SET_CTX_TIMEOUT () {39;}' unless defined(&TR_DEVMAP_SET_CTX_TIMEOUT);
    eval 'sub TR_DEVMAP_DEFAULT_ACCESS () {40;}' unless defined(&TR_DEVMAP_DEFAULT_ACCESS);
    eval 'sub TR_DEVMAP_UMEM_ALLOC () {41;}' unless defined(&TR_DEVMAP_UMEM_ALLOC);
    eval 'sub TR_DEVMAP_UMEM_FREE () {42;}' unless defined(&TR_DEVMAP_UMEM_FREE);
    eval 'sub TR_DEVMAP_CTXTO () {43;}' unless defined(&TR_DEVMAP_CTXTO);
    eval 'sub TR_DEVMAP_DUP_CK1 () {44;}' unless defined(&TR_DEVMAP_DUP_CK1);
    eval 'sub TR_DEVMAP_UNMAP_CK1 () {45;}' unless defined(&TR_DEVMAP_UNMAP_CK1);
    eval 'sub TR_DEVMAP_UNMAP_CK2 () {46;}' unless defined(&TR_DEVMAP_UNMAP_CK2);
    eval 'sub TR_DEVMAP_UNMAP_CK3 () {47;}' unless defined(&TR_DEVMAP_UNMAP_CK3);
    eval 'sub TR_DEVMAP_FAULT_CK1 () {48;}' unless defined(&TR_DEVMAP_FAULT_CK1);
    eval 'sub TR_DEVMAP_SETPROT_CK1 () {49;}' unless defined(&TR_DEVMAP_SETPROT_CK1);
    eval 'sub TR_DEVMAP_FAULTPAGE_CK1 () {50;}' unless defined(&TR_DEVMAP_FAULTPAGE_CK1);
    eval 'sub TR_DEVMAP_DO_CTXMGT_CK1 () {51;}' unless defined(&TR_DEVMAP_DO_CTXMGT_CK1);
    eval 'sub TR_DEVMAP_DO_CTXMGT_CK2 () {52;}' unless defined(&TR_DEVMAP_DO_CTXMGT_CK2);
    eval 'sub TR_DEVMAP_DO_CTXMGT_CK3 () {53;}' unless defined(&TR_DEVMAP_DO_CTXMGT_CK3);
    eval 'sub TR_DEVMAP_DO_CTXMGT_CK4 () {54;}' unless defined(&TR_DEVMAP_DO_CTXMGT_CK4);
    eval 'sub TR_DEVMAP_ROUNDUP_CK1 () {55;}' unless defined(&TR_DEVMAP_ROUNDUP_CK1);
    eval 'sub TR_DEVMAP_ROUNDUP_CK2 () {56;}' unless defined(&TR_DEVMAP_ROUNDUP_CK2);
    eval 'sub TR_DEVMAP_CTX_RELE_CK1 () {57;}' unless defined(&TR_DEVMAP_CTX_RELE_CK1);
    eval 'sub TR_DCDSTRATEGY_START () {1;}' unless defined(&TR_DCDSTRATEGY_START);
    eval 'sub TR_DCDSTRATEGY_DISKSORT_START () {2;}' unless defined(&TR_DCDSTRATEGY_DISKSORT_START);
    eval 'sub TR_DCDSTRATEGY_DISKSORT_END () {3;}' unless defined(&TR_DCDSTRATEGY_DISKSORT_END);
    eval 'sub TR_DCDSTRATEGY_SMALL_WINDOW_START () {4;}' unless defined(&TR_DCDSTRATEGY_SMALL_WINDOW_START);
    eval 'sub TR_DCDSTRATEGY_SMALL_WINDOW_END () {5;}' unless defined(&TR_DCDSTRATEGY_SMALL_WINDOW_END);
    eval 'sub TR_DCDSTRATEGY_END () {6;}' unless defined(&TR_DCDSTRATEGY_END);
    eval 'sub TR_DCDSTART_START () {7;}' unless defined(&TR_DCDSTART_START);
    eval 'sub TR_DCDSTART_NO_WORK_END () {8;}' unless defined(&TR_DCDSTART_NO_WORK_END);
    eval 'sub TR_DCDSTART_NO_RESOURCES_END () {9;}' unless defined(&TR_DCDSTART_NO_RESOURCES_END);
    eval 'sub TR_DCASTART_SMALL_WINDOW_START () {10;}' unless defined(&TR_DCASTART_SMALL_WINDOW_START);
    eval 'sub TR_DCDSTART_SMALL_WINDOW_END () {11;}' unless defined(&TR_DCDSTART_SMALL_WINDOW_END);
    eval 'sub TR_DCDSTART_END () {12;}' unless defined(&TR_DCDSTART_END);
    eval 'sub TR_MAKE_DCD_CMD_START () {13;}' unless defined(&TR_MAKE_DCD_CMD_START);
    eval 'sub TR_MAKE_DCD_CMD_INIT_PKT_START () {14;}' unless defined(&TR_MAKE_DCD_CMD_INIT_PKT_START);
    eval 'sub TR_MAKE_DCD_CMD_INIT_PKT_END () {15;}' unless defined(&TR_MAKE_DCD_CMD_INIT_PKT_END);
    eval 'sub TR_MAKE_DCD_CMD_NO_PKT_ALLOCATED1_END () {16;}' unless defined(&TR_MAKE_DCD_CMD_NO_PKT_ALLOCATED1_END);
    eval 'sub TR_MAKE_DCD_CMD_END () {17;}' unless defined(&TR_MAKE_DCD_CMD_END);
    eval 'sub TR_DCDINTR_START () {18;}' unless defined(&TR_DCDINTR_START);
    eval 'sub TR_DCDINTR_COMMAND_DONE_END () {19;}' unless defined(&TR_DCDINTR_COMMAND_DONE_END);
    eval 'sub TR_DCDINTR_END () {20;}' unless defined(&TR_DCDINTR_END);
    eval 'sub TR_DCDONE_START () {21;}' unless defined(&TR_DCDONE_START);
    eval 'sub TR_DCDDONE_BIODONE_CALL () {22;}' unless defined(&TR_DCDDONE_BIODONE_CALL);
    eval 'sub TR_DCDDONE_END () {23;}' unless defined(&TR_DCDDONE_END);
    eval 'sub TR_DCD_CHECK_ERROR_START () {24;}' unless defined(&TR_DCD_CHECK_ERROR_START);
    eval 'sub TR_DCD_CHECK_ERROR_END () {25;}' unless defined(&TR_DCD_CHECK_ERROR_END);
    eval 'sub TR_DCDRUNOUT_START () {26;}' unless defined(&TR_DCDRUNOUT_START);
    eval 'sub TR_DCDRUNOUT_END () {27;}' unless defined(&TR_DCDRUNOUT_END);
    eval 'sub VT_VERSION_MAJOR () {3;}' unless defined(&VT_VERSION_MAJOR);
    eval 'sub VT_VERSION_MINOR () {0;}' unless defined(&VT_VERSION_MINOR);
    eval 'sub VT_VERSION_MICRO () {0;}' unless defined(&VT_VERSION_MICRO);
    eval 'sub VT_VERSION_NAME () {"92/02/18";}' unless defined(&VT_VERSION_NAME);
    eval 'sub VT_FAC_SHIFT () {24;}' unless defined(&VT_FAC_SHIFT);
    eval 'sub VT_FAC_MASK () {0xff;}' unless defined(&VT_FAC_MASK);
    eval 'sub VT_TAG_SHIFT () {16;}' unless defined(&VT_TAG_SHIFT);
    eval 'sub VT_TAG_MASK () {0xff;}' unless defined(&VT_TAG_MASK);
    eval 'sub VT_EVENT_SHIFT () {16;}' unless defined(&VT_EVENT_SHIFT);
    eval 'sub VT_EVENT_MASK () {0xffff;}' unless defined(&VT_EVENT_MASK);
    eval 'sub VT_TIME_SHIFT () {0;}' unless defined(&VT_TIME_SHIFT);
    eval 'sub VT_TIME_MASK () {0xffff;}' unless defined(&VT_TIME_MASK);
    eval 'sub VT_MAX_FAC () { &VT_FAC_MASK;}' unless defined(&VT_MAX_FAC);
    eval 'sub VT_MAX_TAG () { &VT_TAG_MASK;}' unless defined(&VT_MAX_TAG);
    eval 'sub VT_MAX_EVENT () { &VT_EVENT_MASK;}' unless defined(&VT_MAX_EVENT);
    eval 'sub VT_MAX_WORDS () {64;}' unless defined(&VT_MAX_WORDS);
    eval 'sub VT_MAX_BYTES () {256;}' unless defined(&VT_MAX_BYTES);
    eval 'sub TR_DATA_MIN () { &TR_DATA_4;}' unless defined(&TR_DATA_MIN);
    eval 'sub TR_DATA_MAX () { &TR_DATA_64;}' unless defined(&TR_DATA_MAX);
    eval 'sub IS_DATA_REC {
        my($x) = @_;
	    eval q(((($x) >=  &TR_DATA_MIN)  && (($x) <=  &TR_DATA_MAX)));
    }' unless defined(&IS_DATA_REC);
    eval 'sub VT_FAC {
        my($vt) = @_;
	    eval q(((($vt) >>  &VT_FAC_SHIFT) &  &VT_FAC_MASK));
    }' unless defined(&VT_FAC);
    eval 'sub VT_TAG {
        my($vt) = @_;
	    eval q(((($vt) >>  &VT_TAG_SHIFT) &  &VT_TAG_MASK));
    }' unless defined(&VT_TAG);
    eval 'sub VT_EVENT {
        my($vt) = @_;
	    eval q(((($vt) >>  &VT_EVENT_SHIFT) &  &VT_EVENT_MASK));
    }' unless defined(&VT_EVENT);
    eval 'sub VT_TIME {
        my($vt) = @_;
	    eval q(((($vt) >>  &VT_TIME_SHIFT) &  &VT_TIME_MASK));
    }' unless defined(&VT_TIME);
    eval 'sub VT_SET_FAC {
        my($vt, $fac) = @_;
	    eval q($vt |= ($fac) <<  &VT_FAC_SHIFT);
    }' unless defined(&VT_SET_FAC);
    eval 'sub VT_SET_TAG {
        my($vt, $tag) = @_;
	    eval q($vt |= ($tag) <<  &VT_TAG_SHIFT);
    }' unless defined(&VT_SET_TAG);
    eval 'sub VT_SET_EVENT {
        my($vt, $event) = @_;
	    eval q($vt |= ($event) <<  &VT_EVENT_SHIFT);
    }' unless defined(&VT_SET_EVENT);
    eval 'sub VT_SET_TIME {
        my($vt, $time) = @_;
	    eval q($vt |= ($time) <<  &VT_TIME_SHIFT);
    }' unless defined(&VT_SET_TIME);
    eval 'sub FTT2HEAD {
        my($fac, $tag, $time) = @_;
	    eval q(((($fac) <<  &VT_FAC_SHIFT) | (($tag) <<  &VT_TAG_SHIFT) | ($time)));
    }' unless defined(&FTT2HEAD);
    eval 'sub ET2HEAD {
        my($event, $time) = @_;
	    eval q(((($event) <<  &VT_EVENT_SHIFT) | ($time)));
    }' unless defined(&ET2HEAD);
    eval 'sub FT2EVENT {
        my($fac, $tag) = @_;
	    eval q(((($fac) << 8) | ($tag)));
    }' unless defined(&FT2EVENT);
    eval 'sub VT_ENABLED () {0x80;}' unless defined(&VT_ENABLED);
    eval 'sub VT_USED () {0x40;}' unless defined(&VT_USED);
    eval 'sub VT_STRING_5 () {0x10;}' unless defined(&VT_STRING_5);
    eval 'sub VT_STRING_4 () {0x8;}' unless defined(&VT_STRING_4);
    eval 'sub VT_STRING_3 () {0x4;}' unless defined(&VT_STRING_3);
    eval 'sub VT_STRING_2 () {0x2;}' unless defined(&VT_STRING_2);
    eval 'sub VT_STRING_1 () {0x1;}' unless defined(&VT_STRING_1);
    eval 'sub VT_STRING_MASK () {0x1f;}' unless defined(&VT_STRING_MASK);
    eval 'sub VT_MAPSIZE () {65536;}' unless defined(&VT_MAPSIZE);
    eval 'sub VT_TEST {
        my($map, $event, $mask) = @_;
	    eval q(($map->[$event] & ($mask)));
    }' unless defined(&VT_TEST);
    eval 'sub VT_SET {
        my($map, $event, $mask) = @_;
	    eval q($map->[$event] |= ($mask));
    }' unless defined(&VT_SET);
    eval 'sub VT_UNSET {
        my($map, $event, $mask) = @_;
	    eval q($map->[$event] &= ~($mask));
    }' unless defined(&VT_UNSET);
    eval 'sub VT_TEST_FT {
        my($map, $fac, $tag, $mask) = @_;
	    eval q( &VT_TEST($map,  &FT2EVENT($fac, $tag), $mask));
    }' unless defined(&VT_TEST_FT);
    eval 'sub VT_SET_FT {
        my($map, $fac, $tag, $mask) = @_;
	    eval q( &VT_SET($map,  &FT2EVENT($fac, $tag), $mask));
    }' unless defined(&VT_SET_FT);
    eval 'sub VT_UNSET_FT {
        my($map, $fac, $tag, $mask) = @_;
	    eval q( &VT_UNSET($map,  &FT2EVENT($fac, $tag), $mask));
    }' unless defined(&VT_UNSET_FT);
    eval 'sub VT_FAC_ENABLE {
        my($map, $fac) = @_;
	    eval q({ \'ulong_t xvt_i\';  &for ( &xvt_i =  &FT2EVENT(, 0);  &xvt_i <  &FT2EVENT(($fac) + 1, 0);  &xvt_i++) $map->[ &xvt_i] =  &VT_ENABLED; });
    }' unless defined(&VT_FAC_ENABLE);
    unless(defined(&_ASM)) {
    }
    eval 'sub VTR_INIT () {0;}' unless defined(&VTR_INIT);
    eval 'sub VTR_FILE () {1;}' unless defined(&VTR_FILE);
    eval 'sub VTR_EVENTMAP () {2;}' unless defined(&VTR_EVENTMAP);
    eval 'sub VTR_EVENT () {3;}' unless defined(&VTR_EVENT);
    eval 'sub VTR_START () {4;}' unless defined(&VTR_START);
    eval 'sub VTR_PAUSE () {5;}' unless defined(&VTR_PAUSE);
    eval 'sub VTR_RESUME () {6;}' unless defined(&VTR_RESUME);
    eval 'sub VTR_INFO () {7;}' unless defined(&VTR_INFO);
    eval 'sub VTR_FLUSH () {8;}' unless defined(&VTR_FLUSH);
    eval 'sub VTR_RESET () {9;}' unless defined(&VTR_RESET);
    eval 'sub VTR_TEST () {10;}' unless defined(&VTR_TEST);
    eval 'sub VTR_PROCESS () {11;}' unless defined(&VTR_PROCESS);
    eval 'sub VTR_GET_STRING () {12;}' unless defined(&VTR_GET_STRING);
    eval 'sub VTR_INFO_GLOBAL () {0;}' unless defined(&VTR_INFO_GLOBAL);
    eval 'sub VTR_INFO_PERCPU () {1;}' unless defined(&VTR_INFO_PERCPU);
    eval 'sub VTR_NOFORCE () {0;}' unless defined(&VTR_NOFORCE);
    eval 'sub VTR_FORCE () {1;}' unless defined(&VTR_FORCE);
    eval 'sub VTR_STATE_NULL () {0x1;}' unless defined(&VTR_STATE_NULL);
    eval 'sub VTR_STATE_READY () {0x2;}' unless defined(&VTR_STATE_READY);
    eval 'sub VTR_STATE_PAUSE () {0x4;}' unless defined(&VTR_STATE_PAUSE);
    eval 'sub VTR_STATE_ACTIVE () {0x8;}' unless defined(&VTR_STATE_ACTIVE);
    eval 'sub VTR_STATE_PERPROC () {0x10;}' unless defined(&VTR_STATE_PERPROC);
    eval 'sub VTR_STATE_HALTED () {0x20;}' unless defined(&VTR_STATE_HALTED);
    eval 'sub VTR_PROCESS_NULL () {0x1;}' unless defined(&VTR_PROCESS_NULL);
    eval 'sub VTR_PROCESS_TRACE () {0x2;}' unless defined(&VTR_PROCESS_TRACE);
    eval 'sub VTR_PROCESS_NOTRACE () {0x4;}' unless defined(&VTR_PROCESS_NOTRACE);
    eval 'sub MAX_TRACE_NPROCS () {64;}' unless defined(&MAX_TRACE_NPROCS);
    if(defined(&_KERNEL)) {
	if(defined(&TRACE)) {
	    unless(defined(&_ASM)) {
	    }
	    eval 'sub TRACE_N {
	        my($fac, $tag, $name, $len, $func) = @_;
    		eval q({  &uchar_t  &xvt_info =  ($CPU->{cpu_trace}->{event_map[FT2EVENT($fac, tag)]});  &if ( &xvt_info &  &VT_ENABLED) {  &if (!( &xvt_info &  &VT_USED))  &xvt_info =  &trace_label($fac, $tag, $len, $name, -1); $func; } });
	    }' unless defined(&TRACE_N);
	} else {
	    eval 'sub TRACE_N {
	        my($fac, $tag, $name, $len, $func) = @_;
    		eval q();
	    }' unless defined(&TRACE_N);
	}
    }
    eval 'sub TRACE_0 {
        my($fac, $tag, $name) = @_;
	    eval q( &TRACE_N($fac, $tag, $name, 4,  &trace_0( &FTT2HEAD($fac, $tag,  &xvt_info))));
    }' unless defined(&TRACE_0);
    eval 'sub TRACE_1 {
        my($fac, $tag, $name, $d1) = @_;
	    eval q( &TRACE_N($fac, $tag, $name, 8,  &trace_1( &FTT2HEAD($fac, $tag,  &xvt_info), ($d1))));
    }' unless defined(&TRACE_1);
    eval 'sub TRACE_2 {
        my($fac, $tag, $name, $d1, $d2) = @_;
	    eval q( &TRACE_N($fac, $tag, $name, 12,  &trace_2( &FTT2HEAD($fac, $tag,  &xvt_info), , ($d2))));
    }' unless defined(&TRACE_2);
    eval 'sub TRACE_3 {
        my($fac, $tag, $name, $d1, $d2, $d3) = @_;
	    eval q( &TRACE_N($fac, $tag, $name, 16,  &trace_3( &FTT2HEAD($fac, $tag,  &xvt_info), , , ($d3))));
    }' unless defined(&TRACE_3);
    eval 'sub TRACE_4 {
        my($fac, $tag, $name, $d1, $d2, $d3, $d4) = @_;
	    eval q( &TRACE_N($fac, $tag, $name, 20,  &trace_4( &FTT2HEAD($fac, $tag,  &xvt_info), , , , ($d4))));
    }' unless defined(&TRACE_4);
    eval 'sub TRACE_5 {
        my($fac, $tag, $name, $d1, $d2, $d3, $d4, $d5) = @_;
	    eval q( &TRACE_N($fac, $tag, $name, 24,  &trace_5( &FTT2HEAD($fac, $tag,  &xvt_info), , , , , ($d5))));
    }' unless defined(&TRACE_5);
    if(defined(&__cplusplus)) {
    }
}
1;
