require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MUTEX_IMPL_H)) {
    eval 'sub _SYS_MUTEX_IMPL_H () {1;}' unless defined(&_SYS_MUTEX_IMPL_H);
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
	require 'sys/machlock.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	eval 'sub m_owner () { ($m_adaptive->{_m_owner});}' unless defined(&m_owner);
	eval 'sub m_waiters () { ($m_adaptive->{_m_waiters});}' unless defined(&m_waiters);
	eval 'sub m_type () { ($m_adaptive->{_m_type});}' unless defined(&m_type);
	eval 'sub MUTEX_OWNER {
	    my($lp) = @_;
    	    eval q((( &kthread_id_t)(($lp)-> &m_owner <<  &PTR24_LSB)));
	}' unless defined(&MUTEX_OWNER);
	eval 'sub MUTEX_NO_OWNER () {(( &kthread_id_t) &PTR24_BASE);}' unless defined(&MUTEX_NO_OWNER);
	eval 'sub MUTEX_SET_WAITERS {
	    my($lp) = @_;
    	    eval q((($lp)-> &m_waiters = 1));
	}' unless defined(&MUTEX_SET_WAITERS);
	eval 'sub MUTEX_HAS_WAITERS {
	    my($lp) = @_;
    	    eval q((($lp)-> &m_waiters != 0));
	}' unless defined(&MUTEX_HAS_WAITERS);
	eval 'sub MUTEX_CLEAR_LOCK_AND_WAITERS {
	    my($lp) = @_;
    	    eval q(($lp)-> &m_waiters = 0, ($lp)-> &m_owner = 0);
	}' unless defined(&MUTEX_CLEAR_LOCK_AND_WAITERS);
	eval 'sub MUTEX_SET_TYPE {
	    my($lp, $type) = @_;
    	    eval q(($lp)-> &m_type = ($type));
	}' unless defined(&MUTEX_SET_TYPE);
	eval 'sub MUTEX_TYPE_ADAPTIVE {
	    my($lp) = @_;
    	    eval q((($lp)-> &m_type ==  &MUTEX_ADAPTIVE));
	}' unless defined(&MUTEX_TYPE_ADAPTIVE);
	eval 'sub MUTEX_TYPE_SPIN {
	    my($lp) = @_;
    	    eval q((($lp)-> &m_type ==  &MUTEX_SPIN));
	}' unless defined(&MUTEX_TYPE_SPIN);
	eval 'sub MUTEX_DESTROY {
	    my($lp) = @_;
    	    eval q(($lp)-> &m_type = 0xdd,  &LOCK_INIT_HELD( ($lp->{m_spin}->{m_dummylock})));
	}' unless defined(&MUTEX_DESTROY);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
