require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PSR_COMPAT_H)) {
    eval 'sub _SYS_PSR_COMPAT_H () {1;}' unless defined(&_SYS_PSR_COMPAT_H);
    if(defined(&__cplusplus)) {
    }
    require 'v7/sys/psr.ph';
    eval 'sub PSR_ICC_SHIFT () {20;}' unless defined(&PSR_ICC_SHIFT);
    eval 'sub PSR_IMPLVER_SHIFT () {24;}' unless defined(&PSR_IMPLVER_SHIFT);
    eval 'sub PSR_TSTATE_CC_SHIFT () {12;}' unless defined(&PSR_TSTATE_CC_SHIFT);
    eval 'sub PSR_PSTATE_EF_SHIFT () {8;}' unless defined(&PSR_PSTATE_EF_SHIFT);
    eval 'sub PSR_FPRS_FEF_SHIFT () {10;}' unless defined(&PSR_FPRS_FEF_SHIFT);
    if(defined(&_ASM)) {
	eval 'sub V9_IMPLVER () {0xfe;}' unless defined(&V9_IMPLVER);
    } else {
	eval 'sub V9_IMPLVER () {0xfe;}' unless defined(&V9_IMPLVER);
    }
    eval 'sub V9_PSR_IMPLVER () {( &V9_IMPLVER <<  &PSR_IMPLVER_SHIFT);}' unless defined(&V9_PSR_IMPLVER);
    if(defined(&__cplusplus)) {
    }
}
1;
