require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_VIS_SIMULATOR_H)) {
    eval 'sub _SYS_VIS_SIMULATOR_H () {1;}' unless defined(&_SYS_VIS_SIMULATOR_H);
    if(defined(&__cplusplus)) {
    }
    eval("sub edge8 () { 0x0; }") unless defined(&edge8);
    eval("sub edge8l () { 0x2; }") unless defined(&edge8l);
    eval("sub edge16 () { 0x4; }") unless defined(&edge16);
    eval("sub edge16l () { 0x6; }") unless defined(&edge16l);
    eval("sub edge32 () { 0x8; }") unless defined(&edge32);
    eval("sub edge32l () { 0xa; }") unless defined(&edge32l);
    eval("sub array8 () { 0x10; }") unless defined(&array8);
    eval("sub array16 () { 0x12; }") unless defined(&array16);
    eval("sub array32 () { 0x14; }") unless defined(&array32);
    eval("sub alignaddr () { 0x18; }") unless defined(&alignaddr);
    eval("sub bmask () { 0x19; }") unless defined(&bmask);
    eval("sub alignaddrl () { 0x1a; }") unless defined(&alignaddrl);
    eval("sub fcmple16 () { 0x20; }") unless defined(&fcmple16);
    eval("sub fcmpne16 () { 0x22; }") unless defined(&fcmpne16);
    eval("sub fcmple32 () { 0x24; }") unless defined(&fcmple32);
    eval("sub fcmpne32 () { 0x26; }") unless defined(&fcmpne32);
    eval("sub fcmpgt16 () { 0x28; }") unless defined(&fcmpgt16);
    eval("sub fcmpeq16 () { 0x2a; }") unless defined(&fcmpeq16);
    eval("sub fcmpgt32 () { 0x2c; }") unless defined(&fcmpgt32);
    eval("sub fcmpeq32 () { 0x2e; }") unless defined(&fcmpeq32);
    eval("sub fmul8x16 () { 0x31; }") unless defined(&fmul8x16);
    eval("sub fmul8x16au () { 0x33; }") unless defined(&fmul8x16au);
    eval("sub fmul8x16al () { 0x35; }") unless defined(&fmul8x16al);
    eval("sub fmul8sux16 () { 0x36; }") unless defined(&fmul8sux16);
    eval("sub fmul8ulx16 () { 0x37; }") unless defined(&fmul8ulx16);
    eval("sub fmuld8sux16 () { 0x38; }") unless defined(&fmuld8sux16);
    eval("sub fmuld8ulx16 () { 0x39; }") unless defined(&fmuld8ulx16);
    eval("sub fpack32 () { 0x3a; }") unless defined(&fpack32);
    eval("sub fpack16 () { 0x3b; }") unless defined(&fpack16);
    eval("sub fpackfix () { 0x3d; }") unless defined(&fpackfix);
    eval("sub pdist () { 0x3e; }") unless defined(&pdist);
    eval("sub faligndata () { 0x48; }") unless defined(&faligndata);
    eval("sub fpmerge () { 0x4b; }") unless defined(&fpmerge);
    eval("sub bshuffle () { 0x4c; }") unless defined(&bshuffle);
    eval("sub fexpand () { 0x4d; }") unless defined(&fexpand);
    eval("sub fpadd16 () { 0x50; }") unless defined(&fpadd16);
    eval("sub fpadd16s () { 0x51; }") unless defined(&fpadd16s);
    eval("sub fpadd32 () { 0x52; }") unless defined(&fpadd32);
    eval("sub fpadd32s () { 0x53; }") unless defined(&fpadd32s);
    eval("sub fpsub16 () { 0x54; }") unless defined(&fpsub16);
    eval("sub fpsub16s () { 0x55; }") unless defined(&fpsub16s);
    eval("sub fpsub32 () { 0x56; }") unless defined(&fpsub32);
    eval("sub fpsub32s () { 0x57; }") unless defined(&fpsub32s);
    eval("sub fzero () { 0x60; }") unless defined(&fzero);
    eval("sub fzeros () { 0x61; }") unless defined(&fzeros);
    eval("sub fnor () { 0x62; }") unless defined(&fnor);
    eval("sub fnors () { 0x63; }") unless defined(&fnors);
    eval("sub fandnot2 () { 0x64; }") unless defined(&fandnot2);
    eval("sub fandnot2s () { 0x65; }") unless defined(&fandnot2s);
    eval("sub fnot2 () { 0x66; }") unless defined(&fnot2);
    eval("sub fnot2s () { 0x67; }") unless defined(&fnot2s);
    eval("sub fandnot1 () { 0x68; }") unless defined(&fandnot1);
    eval("sub fandnot1s () { 0x69; }") unless defined(&fandnot1s);
    eval("sub fnot1 () { 0x6a; }") unless defined(&fnot1);
    eval("sub fnot1s () { 0x6b; }") unless defined(&fnot1s);
    eval("sub fxor () { 0x6c; }") unless defined(&fxor);
    eval("sub fxors () { 0x6d; }") unless defined(&fxors);
    eval("sub fnand () { 0x6e; }") unless defined(&fnand);
    eval("sub fnands () { 0x6f; }") unless defined(&fnands);
    eval("sub fand () { 0x70; }") unless defined(&fand);
    eval("sub fands () { 0x71; }") unless defined(&fands);
    eval("sub fxnor () { 0x72; }") unless defined(&fxnor);
    eval("sub fxnors () { 0x73; }") unless defined(&fxnors);
    eval("sub fsrc1 () { 0x74; }") unless defined(&fsrc1);
    eval("sub fsrc1s () { 0x75; }") unless defined(&fsrc1s);
    eval("sub fornot2 () { 0x76; }") unless defined(&fornot2);
    eval("sub fornot2s () { 0x77; }") unless defined(&fornot2s);
    eval("sub fsrc2 () { 0x78; }") unless defined(&fsrc2);
    eval("sub fsrc2s () { 0x79; }") unless defined(&fsrc2s);
    eval("sub fornot1 () { 0x7a; }") unless defined(&fornot1);
    eval("sub fornot1s () { 0x7b; }") unless defined(&fornot1s);
    eval("sub for_op () { 0x7c; }") unless defined(&for_op);
    eval("sub fors_op () { 0x7d; }") unless defined(&fors_op);
    eval("sub fone () { 0x7e; }") unless defined(&fone);
    eval("sub fones () { 0x7f; }") unless defined(&fones);
    eval("sub siam () { 0x81; }") unless defined(&siam);
    eval 'sub GSR_ALIGN_MASK () { &UINT64_C(0x7);}' unless defined(&GSR_ALIGN_MASK);
    eval 'sub GSR_ALIGN_SHIFT () {0;}' unless defined(&GSR_ALIGN_SHIFT);
    eval 'sub GSR_SCALE_MASK () { &UINT64_C(0xf8);}' unless defined(&GSR_SCALE_MASK);
    eval 'sub GSR_SCALE_SHIFT () {3;}' unless defined(&GSR_SCALE_SHIFT);
    eval 'sub GSR_IRND_MASK () { &UINT64_C(0x6000000);}' unless defined(&GSR_IRND_MASK);
    eval 'sub GSR_IRND_SHIFT () {25;}' unless defined(&GSR_IRND_SHIFT);
    eval 'sub GSR_IM_MASK () { &UINT64_C(0x8000000);}' unless defined(&GSR_IM_MASK);
    eval 'sub GSR_IM_SHIFT () {27;}' unless defined(&GSR_IM_SHIFT);
    eval 'sub GSR_MASK_MASK () { &UINT64_C(1.84467440694146e+19);}' unless defined(&GSR_MASK_MASK);
    eval 'sub GSR_MASK_SHIFT () {32;}' unless defined(&GSR_MASK_SHIFT);
    eval 'sub GSR_IM_IRND_MASK () {( &GSR_IM_MASK |  &GSR_IRND_MASK);}' unless defined(&GSR_IM_IRND_MASK);
    eval 'sub GSR_ALIGN {
        my($gsr) = @_;
	    eval q((($gsr &  &GSR_ALIGN_MASK) >>  &GSR_ALIGN_SHIFT));
    }' unless defined(&GSR_ALIGN);
    eval 'sub GSR_SCALE {
        my($gsr) = @_;
	    eval q((($gsr &  &GSR_SCALE_MASK) >>  &GSR_SCALE_SHIFT));
    }' unless defined(&GSR_SCALE);
    eval 'sub GSR_IRND {
        my($gsr) = @_;
	    eval q((($gsr &  &GSR_IRND_MASK) >>  &GSR_IRND_SHIFT));
    }' unless defined(&GSR_IRND);
    eval 'sub GSR_IM {
        my($gsr) = @_;
	    eval q((($gsr &  &GSR_IM_MASK) >>  &GSR_IM_SHIFT));
    }' unless defined(&GSR_IM);
    eval 'sub GSR_MASK {
        my($gsr) = @_;
	    eval q((($gsr &  &GSR_MASK_MASK) >>  &GSR_MASK_SHIFT));
    }' unless defined(&GSR_MASK);
    if(defined(&__cplusplus)) {
    }
}
1;
