require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VARARGS_H)) {
    eval 'sub _VARARGS_H () {1;}' unless defined(&_VARARGS_H);
    require 'sys/va_list.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_VA_LIST)) {
	eval 'sub _VA_LIST () {1;}' unless defined(&_VA_LIST);
    }
    if((defined( &__BUILTIN_VA_ARG_INCR) || defined( &__sparc) || defined( &__i386))) {
	eval 'sub va_alist () { &__builtin_va_alist;}' unless defined(&va_alist);
    }
    if(defined( &__sparcv9)) {
	eval 'sub va_dcl () {\'long va_alist\';;}' unless defined(&va_dcl);
    } else {
	eval 'sub va_dcl () {\'int\'  &va_alist;;}' unless defined(&va_dcl);
    }
    if((defined( &__BUILTIN_VA_ARG_INCR) || defined( &__sparc) || defined( &__i386))  && !defined( &__lint)) {
	eval 'sub va_start {
	    my($list) = @_;
    	    eval q($list =   &va_alist);
	}' unless defined(&va_start);
	eval 'sub va_arg {
	    my($list, $mode) = @_;
    	    eval q((($mode *) &__builtin_va_arg_incr(($mode *)$list))[0]);
	}' unless defined(&va_arg);
    } else {
	eval 'sub va_start {
	    my($list) = @_;
    	    eval q($list =   &va_alist);
	}' unless defined(&va_start);
	eval 'sub va_arg {
	    my($list, $mode) = @_;
    	    eval q((($mode *)($list = ( &void *)($list + $sizeof{$mode})))[-1]);
	}' unless defined(&va_arg);
    }
    eval 'sub va_end {
        my($list) = @_;
	    eval q();
    }' unless defined(&va_end);
    if(defined( &__EXTENSIONS__) || (((defined(&__STDC__) ? &__STDC__ : 0) - 0== 0)  && !defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE))) {
	eval 'sub va_copy {
	    my($to, $from) = @_;
    	    eval q((($to) = ($from)));
	}' unless defined(&va_copy);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
