require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_XCTYPE_H)) {
    eval 'sub _XCTYPE_H () {1;}' unless defined(&_XCTYPE_H);
    eval 'sub iscalpha {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E3));
    }' unless defined(&iscalpha);
    eval 'sub iscblank {
        my($C) = @_;
	    eval q( &iscspace($C));
    }' unless defined(&iscblank);
    eval 'sub iscdigit {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_N));
    }' unless defined(&iscdigit);
    eval 'sub iscgb {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E7));
    }' unless defined(&iscgb);
    eval 'sub iscgbk {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E9));
    }' unless defined(&iscgbk);
    eval 'sub iscgen {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E19));
    }' unless defined(&iscgen);
    eval 'sub iscgreek {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E13));
    }' unless defined(&iscgreek);
    eval 'sub ischanzi {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E2));
    }' unless defined(&ischanzi);
    eval 'sub ischira {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E11));
    }' unless defined(&ischira);
    eval 'sub isckata {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E12));
    }' unless defined(&isckata);
    eval 'sub iscline {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E16));
    }' unless defined(&iscline);
    eval 'sub isclower {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_L));
    }' unless defined(&isclower);
    eval 'sub iscnumber {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E4));
    }' unless defined(&iscnumber);
    eval 'sub iscparen {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E10));
    }' unless defined(&iscparen);
    eval 'sub iscaccent {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E14));
    }' unless defined(&iscaccent);
    eval 'sub iscphonetic {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E21));
    }' unless defined(&iscphonetic);
    eval 'sub iscpinyin {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E20));
    }' unless defined(&iscpinyin);
    eval 'sub iscpunct {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_P));
    }' unless defined(&iscpunct);
    eval 'sub iscrussian {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E15));
    }' unless defined(&iscrussian);
    eval 'sub iscsci {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E18));
    }' unless defined(&iscsci);
    eval 'sub iscspace {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_S));
    }' unless defined(&iscspace);
    eval 'sub iscspecial {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E6));
    }' unless defined(&iscspecial);
    eval 'sub iscunit {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_E17));
    }' unless defined(&iscunit);
    eval 'sub iscupper {
        my($C) = @_;
	    eval q( &_iswctype(($C),  &_U));
    }' unless defined(&iscupper);
    eval 'sub isceuc {
        my($C) = @_;
	    eval q(((($C)&0xff00 > 0xa000)  && (($C)&0xff > 0xa0)  && (($C)&0xff00 < 0xff00)  && (($C)&0xff < 0xff)));
    }' unless defined(&isceuc);
    eval 'sub tocupper {
        my($C) = @_;
	    eval q(((($C)>127)?(( &_iswctype($C, &_L)? &_trwctype($C, &_L):$C)):$C));
    }' unless defined(&tocupper);
    eval 'sub toclower {
        my($C) = @_;
	    eval q(((($C)>127)?(( &_iswctype($C, &_U)? &_trwctype($C, &_U):$C)):$C));
    }' unless defined(&toclower);
    eval 'sub atocgb {
        my($c) = @_;
	    eval q( &isalpha($c)?($c|0x30005180):($c));
    }' unless defined(&atocgb);
    eval 'sub cgbtoa {
        my($c) = @_;
	    eval q( &iscalpha($c)?($c&0x7f):$c);
    }' unless defined(&cgbtoa);
    eval 'sub _cgbtouc {
        my($c) = @_;
	    eval q( &iscgb($c)?($c|0x8080):0);
    }' unless defined(&_cgbtouc);
    eval 'sub _uctocgb {
        my($C) = @_;
	    eval q(( &isceuc($C))? ($C&0x7f7f):0);
    }' unless defined(&_uctocgb);
}
1;
